// ==============================================================================================
// PLEASE DONOT CHANGES THIS FILE
// THIS FILE IS AUTO_GENERATED
// Source: import/address/src/rtl/gen_one/al_channel_bank_hash.sv
// ===============================================================================================
// AMD Confidential
// Creation Data: 12 Sep 2016
// RTL Author   : Prahallada Ponnathota
// Description  : Hashes the bank channel bits in the address

module al_channel_bank_hash_gc(/*AUTOARG*/
   // Outputs
   address_out,
   // Inputs
   hash_enable, hash_channel_bits, hash_bank_bits,
   hash_channel_xor_count, hash_bank_xor_count, address_in
   );

parameter LPARAM_MEM_ADDR_WIDTH = 48;;

input                               hash_enable;               
input  [2:0]                        hash_channel_bits;         // number of channel bits in the address (1,2,4,8,16 channels)
input  [2:0]                        hash_bank_bits;            // number of banks bits in the address (1,2,4,8,16 banks)
input  [2:0]                        hash_channel_xor_count;    // number of XORs into channel bits
input  [2:0]                        hash_bank_xor_count;       // number of XORs into bank bits
input  [LPARAM_MEM_ADDR_WIDTH-1: 0] address_in;
output [LPARAM_MEM_ADDR_WIDTH-1: 0] address_out;

// Channel Hash and Bank Hash
logic [LPARAM_MEM_ADDR_WIDTH-1:0]   result_hash, result;

integer i, j, m, n;

wire [2:0] ChannelBits = (hash_channel_bits > 3'h4) ? 3'h4 : hash_channel_bits;   // Restrict the ChannelBits to 0~4
wire [2:0] BankBits    = (hash_bank_bits    > 3'h4) ? 3'h4 : hash_bank_bits;      // Restrict the BankBits to 0~4
wire [2:0] ChannelXorCount = hash_channel_xor_count;
wire [2:0] BankXorCount    = hash_bank_xor_count;

assign result = address_in; //ust to keep the previous code same names

`ifdef PALLADIUM
always @(*)
  begin
    result_hash = result;
// Channel Hash
    begin  
      if ((ChannelBits != 3'h0) && (ChannelXorCount != 3'h0))     // ChannelBits == 0 or ChannelXORCount == 0 would be no hashing on channel
      begin
        case (ChannelBits[2:0])
          3'b001: begin
      for (i=8; i < (8 + 3'h1); i=i+1)
           result_hash[i] =    result[i]
                            ^  result[i+3'h1*3'h1]
                            ^ ((3'h2 <= ChannelXorCount) ? result[i+3'h1*3'h2] : 1'b0)
                            ^ ((3'h3 <= ChannelXorCount) ? result[i+3'h1*3'h3] : 1'b0)
                            ^ ((3'h4 <= ChannelXorCount) ? result[i+3'h1*3'h4] : 1'b0)
                            ^ ((3'h5 <= ChannelXorCount) ? result[i+3'h1*3'h5] : 1'b0)
                            ^ ((3'h6 <= ChannelXorCount) ? result[i+3'h1*3'h6] : 1'b0)
                            ^ ((3'h7 <= ChannelXorCount) ? result[i+3'h1*3'h7] : 1'b0);
                  end

          3'b010: begin
      for (i=8; i < (8 + 3'h2); i=i+1)
           result_hash[i] =    result[i]
                            ^  result[i+3'h2*3'h1]
                            ^ ((3'h2 <= ChannelXorCount) ? result[i+3'h2*3'h2] : 1'b0)
                            ^ ((3'h3 <= ChannelXorCount) ? result[i+3'h2*3'h3] : 1'b0)
                            ^ ((3'h4 <= ChannelXorCount) ? result[i+3'h2*3'h4] : 1'b0)
                            ^ ((3'h5 <= ChannelXorCount) ? result[i+3'h2*3'h5] : 1'b0)
                            ^ ((3'h6 <= ChannelXorCount) ? result[i+3'h2*3'h6] : 1'b0)
                            ^ ((3'h7 <= ChannelXorCount) ? result[i+3'h2*3'h7] : 1'b0);
                  end

          3'b011: begin
      for (i=8; i < (8 + 3'h3); i=i+1)
           result_hash[i] =    result[i]
                            ^  result[i+3'h3*3'h1]
                            ^ ((3'h2 <= ChannelXorCount) ? result[i+3'h3*3'h2] : 1'b0)
                            ^ ((3'h3 <= ChannelXorCount) ? result[i+3'h3*3'h3] : 1'b0)
                            ^ ((3'h4 <= ChannelXorCount) ? result[i+3'h3*3'h4] : 1'b0)
                            ^ ((3'h5 <= ChannelXorCount) ? result[i+3'h3*3'h5] : 1'b0)
                            ^ ((3'h6 <= ChannelXorCount) ? result[i+3'h3*3'h6] : 1'b0)
                            ^ ((3'h7 <= ChannelXorCount) ? result[i+3'h3*3'h7] : 1'b0);
                  end

          3'b100: begin
      for (i=8; i < (8 + 3'h4); i=i+1)
           result_hash[i] =    result[i]
                            ^  result[i+3'h4*3'h1]
                            ^ ((3'h2 <= ChannelXorCount) ? result[i+3'h4*3'h2] : 1'b0)
                            ^ ((3'h3 <= ChannelXorCount) ? result[i+3'h4*3'h3] : 1'b0)
                            ^ ((3'h4 <= ChannelXorCount) ? result[i+3'h4*3'h4] : 1'b0)
                            ^ ((3'h5 <= ChannelXorCount) ? result[i+3'h4*3'h5] : 1'b0)
                            ^ ((3'h6 <= ChannelXorCount) ? result[i+3'h4*3'h6] : 1'b0)
                            ^ ((3'h7 <= ChannelXorCount) ? result[i+3'h4*3'h7] : 1'b0);
                  end

        default: begin
      for (i=8; i < (8 + 3'h0); i=i+1)
           result_hash[i] =    result[i]
                            ^  result[i+3'h0*3'h1]
                            ^ ((3'h2 <= ChannelXorCount) ? result[i+3'h0*3'h2] : 1'b0)
                            ^ ((3'h3 <= ChannelXorCount) ? result[i+3'h0*3'h3] : 1'b0)
                            ^ ((3'h4 <= ChannelXorCount) ? result[i+3'h0*3'h4] : 1'b0)
                            ^ ((3'h5 <= ChannelXorCount) ? result[i+3'h0*3'h5] : 1'b0)
                            ^ ((3'h6 <= ChannelXorCount) ? result[i+3'h0*3'h6] : 1'b0)
                            ^ ((3'h7 <= ChannelXorCount) ? result[i+3'h0*3'h7] : 1'b0);
                  end
        endcase

      end
    end  // End of Channel Hash

// Bank Hash
    case (ChannelBits[2:0])
      3'b000: begin
                if ((BankBits != 3'h0) && (BankXorCount != 3'h0))   // either BankBits == 0 or BankXORCount == 0 is no hashing on banks
                begin
                  case (BankBits[2:0])
                    3'h1: begin
                for (i=(8+3'b000); i<(8+3'b000+3'h1); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h1*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h1*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h1*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h1*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h1*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h1*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h1*3'h7] : 1'b0);
                          end
                    3'h2: begin
                for (i=(8+3'b000); i<(8+3'b000+3'h2); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h2*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h2*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h2*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h2*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h2*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h2*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h2*3'h7] : 1'b0);
                          end

                    3'h3: begin
                for (i=(8+3'b000); i<(8+3'b000+3'h3); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h3*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h3*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h3*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h3*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h3*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h3*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h3*3'h7] : 1'b0);
                          end

                    3'h4: begin
                for (i=(8+3'b000); i<(8+3'b000+3'h4); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h4*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h4*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h4*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h4*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h4*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h4*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h4*3'h7] : 1'b0);
                          end

                    default: begin
                for (i=(8+3'b000); i<(8+3'b000+3'h0); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h0*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h0*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h0*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h0*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h0*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h0*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h0*3'h7] : 1'b0);
                          end

                  endcase
                end
              end

      3'b001: begin
                if ((BankBits != 3'h0) && (BankXorCount != 3'h0))   // either BankBits == 0 or BankXORCount == 0 is no hashing on banks
                begin
                  case (BankBits[2:0])
                    3'h1: begin
                for (i=(8+3'b001); i<(8+3'b001+3'h1); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h1*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h1*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h1*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h1*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h1*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h1*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h1*3'h7] : 1'b0);
                          end
                    3'h2: begin
                for (i=(8+3'b001); i<(8+3'b001+3'h2); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h2*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h2*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h2*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h2*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h2*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h2*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h2*3'h7] : 1'b0);
                          end

                    3'h3: begin
                for (i=(8+3'b001); i<(8+3'b001+3'h3); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h3*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h3*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h3*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h3*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h3*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h3*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h3*3'h7] : 1'b0);
                          end

                    3'h4: begin
                for (i=(8+3'b001); i<(8+3'b001+3'h4); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h4*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h4*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h4*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h4*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h4*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h4*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h4*3'h7] : 1'b0);
                          end

                    default: begin
                for (i=(8+3'b001); i<(8+3'b001+3'h0); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h0*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h0*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h0*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h0*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h0*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h0*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h0*3'h7] : 1'b0);
                          end

                  endcase
                end
              end

      3'b010: begin
                if ((BankBits != 3'h0) && (BankXorCount != 3'h0))   // either BankBits == 0 or BankXORCount == 0 is no hashing on banks
                begin
                  case (BankBits[2:0])
                    3'h1: begin
                for (i=(8+3'b010); i<(8+3'b010+3'h1); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h1*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h1*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h1*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h1*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h1*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h1*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h1*3'h7] : 1'b0);
                          end
                    3'h2: begin
                for (i=(8+3'b010); i<(8+3'b010+3'h2); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h2*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h2*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h2*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h2*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h2*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h2*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h2*3'h7] : 1'b0);
                          end

                    3'h3: begin
                for (i=(8+3'b010); i<(8+3'b010+3'h3); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h3*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h3*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h3*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h3*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h3*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h3*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h3*3'h7] : 1'b0);
                          end

                    3'h4: begin
                for (i=(8+3'b010); i<(8+3'b010+3'h4); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h4*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h4*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h4*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h4*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h4*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h4*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h4*3'h7] : 1'b0);
                          end

                    default: begin
                for (i=(8+3'b010); i<(8+3'b010+3'h0); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h0*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h0*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h0*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h0*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h0*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h0*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h0*3'h7] : 1'b0);
                          end

                  endcase
                end
              end

      3'b011: begin
                if ((BankBits != 3'h0) && (BankXorCount != 3'h0))   // either BankBits == 0 or BankXORCount == 0 is no hashing on banks
                begin
                  case (BankBits[2:0])
                    3'h1: begin
                for (i=(8+3'b011); i<(8+3'b011+3'h1); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h1*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h1*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h1*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h1*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h1*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h1*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h1*3'h7] : 1'b0);
                          end
                    3'h2: begin
                for (i=(8+3'b011); i<(8+3'b011+3'h2); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h2*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h2*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h2*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h2*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h2*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h2*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h2*3'h7] : 1'b0);
                          end

                    3'h3: begin
                for (i=(8+3'b011); i<(8+3'b011+3'h3); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h3*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h3*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h3*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h3*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h3*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h3*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h3*3'h7] : 1'b0);
                          end

                    3'h4: begin
                for (i=(8+3'b011); i<(8+3'b011+3'h4); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h4*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h4*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h4*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h4*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h4*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h4*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h4*3'h7] : 1'b0);
                          end

                    default: begin
                for (i=(8+3'b011); i<(8+3'b011+3'h0); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h0*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h0*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h0*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h0*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h0*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h0*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h0*3'h7] : 1'b0);
                          end

                  endcase
                end
              end

      3'b100: begin
                if ((BankBits != 3'h0) && (BankXorCount != 3'h0))   // either BankBits == 0 or BankXORCount == 0 is no hashing on banks
                begin
                  case (BankBits[2:0])
                    3'h1: begin
                for (i=(8+3'b100); i<(8+3'b100+3'h1); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h1*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h1*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h1*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h1*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h1*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h1*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h1*3'h7] : 1'b0);
                          end
                    3'h2: begin
                for (i=(8+3'b100); i<(8+3'b100+3'h2); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h2*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h2*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h2*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h2*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h2*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h2*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h2*3'h7] : 1'b0);
                          end

                    3'h3: begin
                for (i=(8+3'b100); i<(8+3'b100+3'h3); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h3*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h3*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h3*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h3*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h3*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h3*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h3*3'h7] : 1'b0);
                          end

                    3'h4: begin
                for (i=(8+3'b100); i<(8+3'b100+3'h4); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h4*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h4*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h4*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h4*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h4*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h4*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h4*3'h7] : 1'b0);
                          end

                    default: begin
                for (i=(8+3'b100); i<(8+3'b100+3'h0); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h0*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h0*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h0*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h0*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h0*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h0*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h0*3'h7] : 1'b0);
                          end

                  endcase
                end
              end

      default: begin
                if ((BankBits != 3'h0) && (BankXorCount != 3'h0))   // either BankBits == 0 or BankXORCount == 0 is no hashing on banks
                begin
                  case (BankBits[2:0])
                    3'h1: begin
                for (i=(8+3'b000); i<(8+3'b000+3'h1); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h1*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h1*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h1*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h1*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h1*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h1*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h1*3'h7] : 1'b0);
                          end
                    3'h2: begin
                for (i=(8+3'b000); i<(8+3'b000+3'h2); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h2*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h2*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h2*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h2*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h2*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h2*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h2*3'h7] : 1'b0);
                          end

                    3'h3: begin
                for (i=(8+3'b000); i<(8+3'b000+3'h3); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h3*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h3*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h3*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h3*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h3*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h3*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h3*3'h7] : 1'b0);
                          end

                    3'h4: begin
                for (i=(8+3'b000); i<(8+3'b000+3'h4); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h4*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h4*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h4*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h4*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h4*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h4*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h4*3'h7] : 1'b0);
                          end

                    default: begin
                for (i=(8+3'b000); i<(8+3'b000+3'h0); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+3'h0*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+3'h0*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+3'h0*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+3'h0*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+3'h0*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+3'h0*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+3'h0*3'h7] : 1'b0);
                          end

                  endcase
                end
              end


    endcase  // End of Bank Hash

  end


`else

always @(*)
  begin
    result_hash = result;
// Channel Hash
    begin  
      if ((ChannelBits != 3'h0) && (ChannelXorCount != 3'h0))     // ChannelBits == 0 or ChannelXORCount == 0 would be no hashing on channel
      begin
      for (i=8; i < (8 + ChannelBits); i=i+1)
           result_hash[i] =    result[i]
                            ^  result[i+ChannelBits*3'h1]
                            ^ ((3'h2 <= ChannelXorCount) ? result[i+ChannelBits*3'h2] : 1'b0)
                            ^ ((3'h3 <= ChannelXorCount) ? result[i+ChannelBits*3'h3] : 1'b0)
                            ^ ((3'h4 <= ChannelXorCount) ? result[i+ChannelBits*3'h4] : 1'b0)
                            ^ ((3'h5 <= ChannelXorCount) ? result[i+ChannelBits*3'h5] : 1'b0)
                            ^ ((3'h6 <= ChannelXorCount) ? result[i+ChannelBits*3'h6] : 1'b0)
                            ^ ((3'h7 <= ChannelXorCount) ? result[i+ChannelBits*3'h7] : 1'b0);

      end
    end  // End of Channel Hash

// Bank Hash
    case (ChannelBits[2:0])
      3'b000: begin
                if ((BankBits != 3'h0) && (BankXorCount != 3'h0))   // either BankBits == 0 or BankXORCount == 0 is no hashing on banks
                for (i=(8+3'b000); i<(8+3'b000+BankBits); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+BankBits*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+BankBits*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+BankBits*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+BankBits*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+BankBits*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+BankBits*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+BankBits*3'h7] : 1'b0);
              end

      3'b001: begin
                if ((BankBits != 3'h0) && (BankXorCount != 3'h0))
                for (i=(8+3'b001); i<(8+3'b001+BankBits); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+BankBits*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+BankBits*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+BankBits*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+BankBits*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+BankBits*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+BankBits*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+BankBits*3'h7] : 1'b0);
              end

      3'b010: begin
                if ((BankBits != 3'h0) && (BankXorCount != 3'h0))
                for (i=(8+3'b010); i<(8+3'b010+BankBits); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+BankBits*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+BankBits*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+BankBits*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+BankBits*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+BankBits*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+BankBits*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+BankBits*3'h7] : 1'b0);
              end

      3'b011: begin
                if ((BankBits != 3'h0) && (BankXorCount != 3'h0))
                for (i=(8+3'b011); i<(8+3'b011+BankBits); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+BankBits*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+BankBits*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+BankBits*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+BankBits*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+BankBits*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+BankBits*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+BankBits*3'h7] : 1'b0);
              end

      3'b100: begin
                if ((BankBits != 3'h0) && (BankXorCount != 3'h0))
                for (i=(8+3'b100); i<(8+3'b100+BankBits); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+BankBits*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+BankBits*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+BankBits*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+BankBits*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+BankBits*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+BankBits*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+BankBits*3'h7] : 1'b0);
              end

    default:begin
                if ((BankBits != 3'h0) && (BankXorCount != 3'h0))
                for (i=(8+3'b000); i<(8+3'b000+BankBits); i=i+1)
                     result_hash[i] =    result[i]
                                      ^  result[i+BankBits*3'h1]
                                      ^ ((3'h2 <= BankXorCount) ? result[i+BankBits*3'h2] : 1'b0)
                                      ^ ((3'h3 <= BankXorCount) ? result[i+BankBits*3'h3] : 1'b0)
                                      ^ ((3'h4 <= BankXorCount) ? result[i+BankBits*3'h4] : 1'b0)
                                      ^ ((3'h5 <= BankXorCount) ? result[i+BankBits*3'h5] : 1'b0)
                                      ^ ((3'h6 <= BankXorCount) ? result[i+BankBits*3'h6] : 1'b0)
                                      ^ ((3'h7 <= BankXorCount) ? result[i+BankBits*3'h7] : 1'b0);
            end
    endcase  // End of Bank Hash

  end

`endif

wire [LPARAM_MEM_ADDR_WIDTH-1:0] address_out = hash_enable ? result_hash : result;

endmodule

