`include "rtllib_features.vh"
module ati_clock_gate(
   // Outputs
   clk_out,
   // Inputs
   clk_src,
   clk_en,
   TE
   );
   input clk_src;
   output clk_out;
   input  clk_en;
   input  TE;
`ifdef RTLLIB_HACK_FOR_QUICK_SIM   
    reg hack_en;
    // always @(clk_src or clk_en or TE) begin
    //     if (!clk_src)
    //         hack_en <= clk_en|TE;
    // end

    // assign clk_out = clk_src & hack_en;
    
    always @(negedge clk_src) begin
        hack_en <= clk_en|TE;
    end

    assign  clk_out = clk_src & hack_en; 

`elsif CDC_VERIFICATION
// For CDC check only
    reg clk_en_latch;
    always @ (clk_src or clk_en or TE) begin
    if (!clk_src)
    clk_en_latch = (clk_en | TE);
    end
    assign clk_out = clk_src & clk_en_latch;

`else    
// Using drive strength 6 instead of 8
  HDBLVT08_CKGTPLT_V7Y2_4 d0nt_clk_gate_cell (.CLK(clk_src),
                               .TE(TE),
                               .E(clk_en),
                               .Z(clk_out));
`endif                       

`ifdef CLOCK_GATE_DEBUG
`ifdef SIMULATION
initial begin
  $display("%m : Clock Gater Instantiated.");
end
`endif
`endif
endmodule
