`include "msgio_defines.vh"

module ati_rtr_staller(/*AUTOARG*/
   // Outputs
   stall,
   // Inputs
   clk, reset, valid
   );
// VCS coverage off
   parameter name = "ati_rtr_staller";             // no longer used
   parameter hold_nonstall_when_invalid = 0;
   input     clk;
   input     reset;
   input     valid;
   output    stall;
   
   reg 	     stalled,enable;
   
   integer   i0a,i0b,i0c,i0d,i0e;
   integer   cnt,cnt1,i,i0,j,n;
   integer   local_seed;
   integer   mtrand_handle;

   reg [800-1:0] seedname;
   
   initial begin
      #1;
      enable = 0;
      $swrite(seedname, "%m");
      if($test$plusargs("ati_rtr_stallers"))
	i0 = $value$plusargs("ati_rtr_stallers=%d",enable);
      if($test$plusargs(name))
	i0 = $value$plusargs({name,"=%d"},enable);
      if($test$plusargs(seedname))
	i0 = $value$plusargs({seedname,"=%d"},enable);

      n = 0;
      if($test$plusargs("seed"))
	i0 = $value$plusargs("seed=%d",n);

      local_seed = simple_hash(seedname, n);
      mtrand_handle = $ati_new_mtrand(local_seed);

      if (enable)
        `MSGIO_DISPLAY("MODACTIVE: (%0s) stall %m enabled, using seed 32'h%0x (mtrand_handle=%0d)", seedname, local_seed, mtrand_handle);

      for(i=0;i<(n%256);i=i+1)
        j = $ati_mtrand_int32(mtrand_handle);
      
      cnt = 0;
   end
   
   always @(posedge clk) begin
      cnt1 = cnt % 1024;
      if(cnt==0)
        i0b = ($ati_mtrand_int32(mtrand_handle) & 255);
      if(cnt1==0) begin
         i0a = i0b;
         i0b = ($ati_mtrand_int32(mtrand_handle) & 255);
      end
      
      i0c = (i0a * (1024-cnt1) + i0b * cnt1)/1024;
      i0d = (3 * i0c * i0c)/256 - (2 * i0c * i0c * i0c)/65536;
      i0e = $ati_mtrand_int32(mtrand_handle)&255;
      
      stalled <=  (i0e > i0d) && enable && !reset;
      
      cnt = cnt + 1;
   end
   reg  rtr_without_rts;
   always @(posedge clk) begin
      if (valid)
        rtr_without_rts <= 0;
      else if (!stalled)
        rtr_without_rts <= 1;
      if (reset)
        rtr_without_rts <= 1;
   end
   assign stall = hold_nonstall_when_invalid ? (stalled && !rtr_without_rts) : stalled;
   

  function [31:0] simple_hash;
  input [100*8-1:0] str;
  input [31:0] seed;
  integer i;
  reg [7:0] step;
  begin
    simple_hash = 32'hdeadbeef + seed;
    for(i=0;i<800;i=i+8) begin
      step = (str >> i) & 8'hff;
      simple_hash = ((simple_hash << 1) + step) % 32'd20101;
    end
  end
  endfunction

// VCS coverage on
endmodule // ati_rtr_staller

