
`include "gc_features.vh"
`include "mem_features.vh"
`include "bpm_defs.vh"

module bpm_assert
       (
`ifdef GC__GFX_PIPELINE_CLOCK_GATING__1
        input         BPM_gfx3d,
        input         RLC_TARG_gfx3Den,
        input         RLC_TARG_gfx3Den_ff,
        input         cg3d_override,
`endif
        input         disable_mgls,
        input         disable_mgcg,
        input         rm_valid,
        input [5:0]   iCUSTOM_MEM_RM,
        input [5:0]   oCUSTOM_MEM_RM,
        input         iCUSTOM_MEM_RME,
        input         oCUSTOM_MEM_RME,
        input         RLC_TARG_gfxen_ff,
        input         stop_clock,
        input         cg_gfx_sclk,
        input         cgcg_override,
        input         Cpl_GFXCLK,
        input         hard_resetb,
        input         TEST_CLK_EN,
        input         pg_P1_strap,
        input         pg_P2_strap,
        input         RLC_TARG_gfxen,
		input		  TARG_BPM_cgcgls_override,
		input[12:0] 	  BPM_blk_addr,
		input		  RSMU_GFX_cold_resetb,
        input         RSMU_GFX_hard_resetb,
        input         xRBM_blk_soft_0_resetb,
        input         xRBM_blk_soft_1_resetb,
        input         xRBM_blk_soft_2_resetb,
        input         xRBM_blk_soft_3_resetb,
		input[35:0]   dbg_mux_SelLane,

`ifdef GC__GFX_ISLAND_POWER_GATING__1
        input         TTOP_P1_mother_sleep,
        input         TTOP_P1_daughter_sleep,
        input         TTOP_P1_iso_clampn,
`endif
`ifdef GC__STATIC_PERCU_POWER_GATING__1
        input         TTOP_P2_mother_sleep,
        input         TTOP_P2_daughter_sleep,
        input         TTOP_P2_iso_clampn,
`endif

        input         TTOP_P1_combined_resetb_0,
        input         TTOP_P1_combined_resetb_1,
        input         TTOP_P1_combined_resetb_2,
        input         TTOP_P1_combined_resetb_3,
        input         TTOP_P2_hard_resetb,
        input         TTOP_P2_combined_resetb_0,
        input         TTOP_P2_combined_resetb_1,
        input         TTOP_P2_combined_resetb_2,
        input         TTOP_P2_combined_resetb_3,
        input         TTOP_P1_hard_resetb,
        input         TTOP_MGCG_override,
        input         TTOP_FGCG_override,
        input         TTOP_MGLS_override,
        input [3:0]   TTOP_MGLS_current_freq_code,
        input [31:0]  dbg_mux_Data,
        input [`MEM__MEM_POWER_CTRL-1:0]   mem_power_ctrl,
        input [`MEM__MEM_POWER_CTRL-1:0]   TTOP_P1_mem_power_ctrl,
        input [`MEM__MEM_POWER_CTRL-1:0]   TTOP_P2_mem_power_ctrl,
        input [`MEM__MEM_POWER_CTRL-1:0]   PGFSM_P1_pwr_ctrl_out,
        input [`MEM__MEM_POWER_CTRL-1:0]   PGFSM_P2_pwr_ctrl_out,
        input         RLC_BPM_cmd,
        input         BPM_select,
        input         SERDES_new_cmd,
        input [23:0]  SERDES_cmd,
        input         RLC_BPM_status,

        input         cgcg_en
       );
// vrq translate_off

reg bpm_assert_enable;

initial begin
  if($test$plusargs("bpm_assert_disable"))
    bpm_assert_enable = 1'b0;
  else
    bpm_assert_enable= 1'b1;
end


//1. Unknown check
//AUTOCODE START
property unkn_p1;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(TEST_CLK_EN);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_1: assert property(unkn_p1) else $error("%m fails! TEST_CLK_EN is unknown");
`else
unknown_chk_1: assert property(unkn_p1) else $warning("%m fails! TEST_CLK_EN is unknown");
`endif
property unkn_p3;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(pg_P1_strap);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_3: assert property(unkn_p3) else $error("%m fails! pg_P1_strap is unknown");
`else
unknown_chk_3: assert property(unkn_p3) else $warning("%m fails! pg_P1_strap is unknown");
`endif
property unkn_p4;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(pg_P2_strap);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_4: assert property(unkn_p4) else $error("%m fails! pg_P2_strap is unknown");
`else
unknown_chk_4: assert property(unkn_p4) else $warning("%m fails! pg_P2_strap is unknown");
`endif
property unkn_p5;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(RLC_TARG_gfxen);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_5: assert property(unkn_p5) else $error("%m fails! RLC_TARG_gfxen is unknown");
`else
unknown_chk_5: assert property(unkn_p5) else $warning("%m fails! RLC_TARG_gfxen is unknown");
`endif
property unkn_p6;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(RSMU_GFX_hard_resetb);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_6: assert property(unkn_p6) else $error("%m fails! RSMU_GFX_hard_resetb is unknown");
`else
unknown_chk_6: assert property(unkn_p6) else $warning("%m fails! RSMU_GFX_hard_resetb is unknown");
`endif
property unkn_p7;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(xRBM_blk_soft_0_resetb);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_7: assert property(unkn_p7) else $error("%m fails! xRBM_blk_soft_0_resetb is unknown");
`else
unknown_chk_7: assert property(unkn_p7) else $warning("%m fails! xRBM_blk_soft_0_resetb is unknown");
`endif
property unkn_p8;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(xRBM_blk_soft_1_resetb);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_8: assert property(unkn_p8) else $error("%m fails! xRBM_blk_soft_1_resetb is unknown");
`else
unknown_chk_8: assert property(unkn_p8) else $warning("%m fails! xRBM_blk_soft_1_resetb is unknown");
`endif
property unkn_p9;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(xRBM_blk_soft_2_resetb);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_9: assert property(unkn_p9) else $error("%m fails! xRBM_blk_soft_2_resetb is unknown");
`else
unknown_chk_9: assert property(unkn_p9) else $warning("%m fails! xRBM_blk_soft_2_resetb is unknown");
`endif
property unkn_p10;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(xRBM_blk_soft_3_resetb);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_10: assert property(unkn_p10) else $error("%m fails! xRBM_blk_soft_3_resetb is unknown");
`else
unknown_chk_10: assert property(unkn_p10) else $warning("%m fails! xRBM_blk_soft_3_resetb is unknown");
`endif
property unkn_p11;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(RSMU_GFX_cold_resetb);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_11: assert property(unkn_p11) else $error("%m fails! RSMU_GFX_cold_resetb is unknown");
`else
unknown_chk_11: assert property(unkn_p11) else $warning("%m fails! RSMU_GFX_cold_resetb is unknown");
`endif
property unkn_p12;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(BPM_blk_addr);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_12: assert property(unkn_p12) else $error("%m fails! BPM_blk_addr is unknown");
`else
unknown_chk_12: assert property(unkn_p12) else $warning("%m fails! BPM_blk_addr is unknown");
`endif
//comment out as bpm hard resetb released earlier than debug bus reset
//property unkn_p13;
//  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(dbg_mux_SelLane);
//endproperty
//`ifdef GFX_CG_W2E
//unknown_chk_13: assert property(unkn_p13) else $error("%m fails! dbg_mux_SelLane is unknown");
//`else
//unknown_chk_13: assert property(unkn_p13) else $warning("%m fails! dbg_mux_SelLane is unknown");
//`endif
property unkn_p14;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(RLC_BPM_cmd);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_14: assert property(unkn_p14) else $error("%m fails! RLC_BPM_cmd is unknown");
`else
unknown_chk_14: assert property(unkn_p14) else $warning("%m fails! RLC_BPM_cmd is unknown");
`endif
property unkn_p15;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(TARG_BPM_cgcgls_override);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_15: assert property(unkn_p15) else $error("%m fails! TARG_BPM_cgcgls_override is unknown");
`else
unknown_chk_15: assert property(unkn_p15) else $warning("%m fails! TARG_BPM_cgcgls_override is unknown");
`endif
property unkn_p16;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(mem_power_ctrl);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_16: assert property(unkn_p16) else $error("%m fails! mem_power_ctrl is unknown");
`else
unknown_chk_16: assert property(unkn_p16) else $warning("%m fails! mem_power_ctrl is unknown");
`endif




property unkn_p20;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(TTOP_P1_hard_resetb);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_20: assert property(unkn_p20) else $error("%m fails! TTOP_P1_hard_resetb is unknown");
`else
unknown_chk_20: assert property(unkn_p20) else $warning("%m fails! TTOP_P1_hard_resetb is unknown");
`endif
property unkn_p21;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(TTOP_P1_combined_resetb_0);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_21: assert property(unkn_p21) else $error("%m fails! TTOP_P1_combined_resetb_0 is unknown");
`else
unknown_chk_21: assert property(unkn_p21) else $warning("%m fails! TTOP_P1_combined_resetb_0 is unknown");
`endif
property unkn_p22;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(TTOP_P1_combined_resetb_1);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_22: assert property(unkn_p22) else $error("%m fails! TTOP_P1_combined_resetb_1 is unknown");
`else
unknown_chk_22: assert property(unkn_p22) else $warning("%m fails! TTOP_P1_combined_resetb_1 is unknown");
`endif
property unkn_p23;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(TTOP_P1_combined_resetb_2);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_23: assert property(unkn_p23) else $error("%m fails! TTOP_P1_combined_resetb_2 is unknown");
`else
unknown_chk_23: assert property(unkn_p23) else $warning("%m fails! TTOP_P1_combined_resetb_2 is unknown");
`endif
property unkn_p24;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(TTOP_P1_combined_resetb_3);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_24: assert property(unkn_p24) else $error("%m fails! TTOP_P1_combined_resetb_3 is unknown");
`else
unknown_chk_24: assert property(unkn_p24) else $warning("%m fails! TTOP_P1_combined_resetb_3 is unknown");
`endif
property unkn_p25;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(TTOP_P2_hard_resetb);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_25: assert property(unkn_p25) else $error("%m fails! TTOP_P2_hard_resetb is unknown");
`else
unknown_chk_25: assert property(unkn_p25) else $warning("%m fails! TTOP_P2_hard_resetb is unknown");
`endif
property unkn_p26;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(TTOP_P2_combined_resetb_0);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_26: assert property(unkn_p26) else $error("%m fails! TTOP_P2_combined_resetb_0 is unknown");
`else
unknown_chk_26: assert property(unkn_p26) else $warning("%m fails! TTOP_P2_combined_resetb_0 is unknown");
`endif
property unkn_p27;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(TTOP_P2_combined_resetb_1);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_27: assert property(unkn_p27) else $error("%m fails! TTOP_P2_combined_resetb_1 is unknown");
`else
unknown_chk_27: assert property(unkn_p27) else $warning("%m fails! TTOP_P2_combined_resetb_1 is unknown");
`endif
property unkn_p28;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(TTOP_P2_combined_resetb_2);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_28: assert property(unkn_p28) else $error("%m fails! TTOP_P2_combined_resetb_2 is unknown");
`else
unknown_chk_28: assert property(unkn_p28) else $warning("%m fails! TTOP_P2_combined_resetb_2 is unknown");
`endif
property unkn_p29;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(TTOP_P2_combined_resetb_3);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_29: assert property(unkn_p29) else $error("%m fails! TTOP_P2_combined_resetb_3 is unknown");
`else
unknown_chk_29: assert property(unkn_p29) else $warning("%m fails! TTOP_P2_combined_resetb_3 is unknown");
`endif

`ifdef GC__GFX_PIPELINE_CLOCK_GATING__1
property unkn_p30;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(BPM_gfx3d);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_30: assert property(unkn_p30) else $error("%m fails! BPM_gfx3d is unknown");
`else
unknown_chk_30: assert property(unkn_p30) else $warning("%m fails! BPM_gfx3d is unknown");
`endif
property unkn_p31;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(RLC_TARG_gfx3Den);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_31: assert property(unkn_p31) else $error("%m fails! RLC_TARG_gfx3Den is unknown");
`else
unknown_chk_31: assert property(unkn_p31) else $warning("%m fails! RLC_TARG_gfx3Den is unknown");
`endif
`endif

property unkn_p40;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(RLC_BPM_status);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_40: assert property(unkn_p40) else $error("%m fails! RLC_BPM_status is unknown");
`else
unknown_chk_40: assert property(unkn_p40) else $warning("%m fails! RLC_BPM_status is unknown");
`endif

property unkn_p41;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(cgcg_en);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_41: assert property(unkn_p41) else $error("%m fails! cgcg_en is unknown");
`else
unknown_chk_41: assert property(unkn_p41) else $warning("%m fails! cgcg_en is unknown");
`endif


property unkn_p42;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(TTOP_MGCG_override);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_42: assert property(unkn_p42) else $error("%m fails! TTOP_MGCG_override is unknown");
`else
unknown_chk_42: assert property(unkn_p42) else $warning("%m fails! TTOP_MGCG_override is unknown");
`endif


property unkn_p43;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(TTOP_FGCG_override);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_43: assert property(unkn_p43) else $error("%m fails! TTOP_FGCG_override is unknown");
`else
unknown_chk_43: assert property(unkn_p43) else $warning("%m fails! TTOP_FGCG_override is unknown");
`endif


property unkn_p44;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(TTOP_MGLS_override);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_44: assert property(unkn_p44) else $error("%m fails! TTOP_MGLS_override is unknown");
`else
unknown_chk_44: assert property(unkn_p44) else $warning("%m fails! TTOP_MGLS_override is unknown");
`endif


property unkn_p45;
  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(TTOP_MGLS_current_freq_code);
endproperty
`ifdef GFX_CG_W2E
unknown_chk_45: assert property(unkn_p45) else $error("%m fails! TTOP_MGLS_current_freq_code is unknown");
`else
unknown_chk_45: assert property(unkn_p45) else $warning("%m fails! TTOP_MGLS_current_freq_code is unknown");
`endif


//property unkn_p46;
//  @(posedge Cpl_GFXCLK) hard_resetb |-> not $isunknown(dbg_mux_Data);
//endproperty
//`ifdef GFX_CG_W2E
//unknown_chk_46: assert property(unkn_p46) else $error("%m fails! dbg_mux_Data is unknown");
//`else
//unknown_chk_46: assert property(unkn_p46) else $warning("%m fails! dbg_mux_Data is unknown");
//`endif

//AUTOCODE FINISH



wire read_cmd_come;
reg  read_in_proc;

assign read_cmd_come = BPM_select & ~SERDES_cmd[1] & (pg_P1_strap | pg_P2_strap);
always @(posedge Cpl_GFXCLK ) begin
  if (~hard_resetb)
    read_in_proc <= 1'b0;
  else if (RLC_BPM_status)
    read_in_proc <= 1'b0;
  else if (read_cmd_come)
    read_in_proc <= 1'b1;
end
property p_read0;
  @(posedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) read_cmd_come |-> ~read_in_proc;
endproperty

`ifdef CG_C2E
//read_no_overlay_chk:   assert property(p_read0) else $error("%m fails! Read command is come when previous read command is in process!");
`else
//read_no_overlay_chk:   assert property(p_read0) else $warning("%m fails! Read command is come when previous read command is in process!");
`endif


// 7. Check for memory power control
property p71;
  @(posedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (~pg_P1_strap & mem_power_ctrl[`MEM__MEM_POWER_CTRL_LS]) |-> TTOP_P1_mem_power_ctrl[`MEM__MEM_POWER_CTRL_LS];
endproperty
property p72;
  @(posedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (pg_P1_strap & PGFSM_P1_pwr_ctrl_out[`MEM__MEM_POWER_CTRL_LS]) |-> TTOP_P1_mem_power_ctrl[`MEM__MEM_POWER_CTRL_LS];
endproperty
property p73;
  @(posedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (~pg_P2_strap & ~pg_P1_strap & mem_power_ctrl[`MEM__MEM_POWER_CTRL_LS]) |-> TTOP_P2_mem_power_ctrl[`MEM__MEM_POWER_CTRL_LS];
endproperty
property p74;
  @(posedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) ((~pg_P1_strap & pg_P1_strap & PGFSM_P1_pwr_ctrl_out[`MEM__MEM_POWER_CTRL_LS]) || (pg_P2_strap & PGFSM_P2_pwr_ctrl_out[`MEM__MEM_POWER_CTRL_LS])) |-> TTOP_P2_mem_power_ctrl[`MEM__MEM_POWER_CTRL_LS];
endproperty

`ifdef GFX_CG_W2E
mem_pwr_ls_chk1: assert property(p71) else $error("%m fails! cgtt for P1 mem ls is fail!");
mem_pwr_ls_chk2: assert property(p72) else $error("%m fails! pgfsm for P1 mem ls is fail!");
mem_pwr_ls_chk3: assert property(p73) else $error("%m fails! cgtt for P2 mem ls is fail!");
mem_pwr_ls_chk4: assert property(p74) else $error("%m fails! pgfsm for P2 mem ls is fail!");
`else
mem_pwr_ls_chk1: assert property(p71) else $warning("%m fails! cgtt for P1 mem ls is fail!");
mem_pwr_ls_chk2: assert property(p72) else $warning("%m fails! pgfsm for P1 mem ls is fail!");
mem_pwr_ls_chk3: assert property(p73) else $warning("%m fails! cgtt for P2 mem ls is fail!");
mem_pwr_ls_chk4: assert property(p74) else $warning("%m fails! pgfsm for P2 mem ls is fail!");
`endif

// Check  non-rm bits
property p75;
  @(posedge Cpl_GFXCLK) (hard_resetb & ~pg_P1_strap) |-> ({TTOP_P1_mem_power_ctrl[`MEM__MEM_POWER_CTRL-1:`GPU__MEM__MEM_POWER_CTRL_RM_END+1], TTOP_P1_mem_power_ctrl[`MEM__MEM_POWER_CTRL_TDR_SD:`MEM__MEM_POWER_CTRL_DS]} == {mem_power_ctrl[`MEM__MEM_POWER_CTRL-1:`GPU__MEM__MEM_POWER_CTRL_RM_END+1], mem_power_ctrl[`MEM__MEM_POWER_CTRL_TDR_SD:`MEM__MEM_POWER_CTRL_DS]});
endproperty

// Check non-rm bits
property p76;
  @(posedge Cpl_GFXCLK) (hard_resetb & pg_P1_strap) |-> ({TTOP_P1_mem_power_ctrl[`MEM__MEM_POWER_CTRL-1:`GPU__MEM__MEM_POWER_CTRL_RM_END+1], TTOP_P1_mem_power_ctrl[`MEM__MEM_POWER_CTRL_TDR_SD:`MEM__MEM_POWER_CTRL_DS]} == {PGFSM_P1_pwr_ctrl_out[`MEM__MEM_POWER_CTRL-1:`GPU__MEM__MEM_POWER_CTRL_RM_END+1], PGFSM_P1_pwr_ctrl_out[`MEM__MEM_POWER_CTRL_TDR_SD:`MEM__MEM_POWER_CTRL_DS]});
endproperty

// Check non-rm bits
property p77;
  @(posedge Cpl_GFXCLK) (hard_resetb & ~pg_P2_strap & ~pg_P1_strap) |-> ({TTOP_P2_mem_power_ctrl[`MEM__MEM_POWER_CTRL-1:`GPU__MEM__MEM_POWER_CTRL_RM_END+1], TTOP_P2_mem_power_ctrl[`MEM__MEM_POWER_CTRL_TDR_SD:`MEM__MEM_POWER_CTRL_DS]} == {mem_power_ctrl[`MEM__MEM_POWER_CTRL-1:`GPU__MEM__MEM_POWER_CTRL_RM_END+1], mem_power_ctrl[`MEM__MEM_POWER_CTRL_TDR_SD:`MEM__MEM_POWER_CTRL_DS]});
endproperty

// Check non-rm bits
property p78;
  @(posedge Cpl_GFXCLK) (hard_resetb & ~pg_P2_strap & pg_P1_strap) |-> ({TTOP_P2_mem_power_ctrl[`MEM__MEM_POWER_CTRL-1:`GPU__MEM__MEM_POWER_CTRL_RM_END+1], TTOP_P2_mem_power_ctrl[`MEM__MEM_POWER_CTRL_TDR_SD:`MEM__MEM_POWER_CTRL_DS]} == {PGFSM_P1_pwr_ctrl_out[`MEM__MEM_POWER_CTRL-1:`GPU__MEM__MEM_POWER_CTRL_RM_END+1], PGFSM_P1_pwr_ctrl_out[`MEM__MEM_POWER_CTRL_TDR_SD:`MEM__MEM_POWER_CTRL_DS]});
endproperty

// Check non-rm bits
property p79;
  @(posedge Cpl_GFXCLK) (hard_resetb & pg_P2_strap) |-> ({TTOP_P2_mem_power_ctrl[`MEM__MEM_POWER_CTRL-1:`GPU__MEM__MEM_POWER_CTRL_RM_END+1], TTOP_P2_mem_power_ctrl[`MEM__MEM_POWER_CTRL_TDR_SD:`MEM__MEM_POWER_CTRL_DS]} == {PGFSM_P2_pwr_ctrl_out[`MEM__MEM_POWER_CTRL-1:`GPU__MEM__MEM_POWER_CTRL_RM_END+1], PGFSM_P2_pwr_ctrl_out[`MEM__MEM_POWER_CTRL_TDR_SD:`MEM__MEM_POWER_CTRL_DS]});
endproperty

`ifdef GFX_CG_W2E
mem_pwr_ds_chk0: assert property(p75) else $error("%m fails! cgtt for P1 mem ds is fail!");
mem_pwr_ds_chk1: assert property(p76) else $error("%m fails! pgfsm for P1 mem ds is fail!");
mem_pwr_ds_chk2: assert property(p77) else $error("%m fails! cgtt for P1 mem ds is fail!");
mem_pwr_ds_chk3: assert property(p78) else $error("%m fails! pgfsm1 for P1 mem ds is fail!");
mem_pwr_ds_chk4: assert property(p79) else $error("%m fails! pgfsm2 for P1 mem ds is fail!");
`else
mem_pwr_ds_chk0: assert property(p75) else $warning("%m fails! cgtt for P1 mem ds is fail!");
mem_pwr_ds_chk1: assert property(p76) else $warning("%m fails! pgfsm for P1 mem ds is fail!");
mem_pwr_ds_chk2: assert property(p77) else $warning("%m fails! cgtt for P1 mem ds is fail!");
mem_pwr_ds_chk3: assert property(p78) else $warning("%m fails! pgfsm1 for P1 mem ds is fail!");
mem_pwr_ds_chk4: assert property(p79) else $warning("%m fails! pgfsm2 for P1 mem ds is fail!");
`endif

`ifdef GC__GFX_ISLAND_POWER_GATING__1
`ifdef GC__STATIC_PERCU_POWER_GATING__1
// 10. When p1 is power down, P2 should be already power down if p2 is not close

property pa0;
  @(posedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & ~TTOP_P1_iso_clampn) |-> (~TTOP_P2_iso_clampn | ~pg_P2_strap); // Low is active
endproperty
property pa1;
  @(posedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & TTOP_P1_mother_sleep) |-> (TTOP_P2_mother_sleep | ~pg_P2_strap);
endproperty
property pa2;
  @(posedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & TTOP_P1_daughter_sleep) |-> (TTOP_P2_daughter_sleep | ~pg_P2_strap);
endproperty

`ifdef CG_C2W
p1_pwr_dn_chk0: assert property(pa0) else $error("%m fails! P2 should be down when P1 request to power down0");
p1_pwr_dn_chk1: assert property(pa1) else $error("%m fails! P2 should be down when P1 request to power down1");
p1_pwr_dn_chk2: assert property(pa2) else $error("%m fails! P2 should be down when P1 request to power down2");
`else
p1_pwr_dn_chk0: assert property(pa0) else $warning("%m fails! P2 should be down when P1 request to power down0");
p1_pwr_dn_chk1: assert property(pa1) else $warning("%m fails! P2 should be down when P1 request to power down1");
p1_pwr_dn_chk2: assert property(pa2) else $warning("%m fails! P2 should be down when P1 request to power down2");
`endif

// 11. When p2 request power up, p1 should be already up
property pb0;
  @(posedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (pg_P2_strap & hard_resetb & TTOP_P2_iso_clampn) |-> TTOP_P1_iso_clampn;
endproperty
property pb1;
  @(posedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (pg_P2_strap & hard_resetb & ~TTOP_P2_mother_sleep) |-> ~TTOP_P1_mother_sleep;
endproperty
property pb2;
  @(posedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (pg_P2_strap & hard_resetb & ~TTOP_P2_daughter_sleep) |-> ~TTOP_P1_daughter_sleep;
endproperty

`ifdef GFX_CG_W2E
p1_pwr_up_chk0: assert property(pb0) else $error("%m fails! P2 should be down when P1 request to power down0");
p1_pwr_up_chk1: assert property(pb1) else $error("%m fails! P2 should be down when P1 request to power down1");
p1_pwr_up_chk2: assert property(pb2) else $error("%m fails! P2 should be down when P1 request to power down2");
`else
p1_pwr_up_chk0: assert property(pb0) else $warning("%m fails! P2 should be down when P1 request to power down0");
p1_pwr_up_chk1: assert property(pb1) else $warning("%m fails! P2 should be down when P1 request to power down1");
p1_pwr_up_chk2: assert property(pb2) else $warning("%m fails! P2 should be down when P1 request to power down2");
`endif

`endif  // `ifdef GC__STATIC_PERCU_POWER_GATING__1
`endif  // `ifdef GC__GFX_ISLAND_POWER_GATING__1


// 12. GFX 3D PIPELINE CLOCK GATING
`ifdef GC__GFX_PIPELINE_CLOCK_GATING__1
`ifndef GC__CGCG_MGCG_MERGE__1   // if feature CGCG/MGCG merge is enabled, no need to check the output clock
// Output 3DCG clock
property gfx3dcg_pb0;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & BPM_gfx3d & ~cg3d_override & ~cgcg_override & RLC_TARG_gfx3Den_ff & (~stop_clock)) |=> cg_gfx_sclk;
endproperty
// Output CGCG clock
property gfx3dcg_pb1;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & BPM_gfx3d & cg3d_override & ~cgcg_override & RLC_TARG_gfxen_ff & (~stop_clock)) |=> cg_gfx_sclk;
endproperty
property gfx3dcg_pb2;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & ~BPM_gfx3d & ~cgcg_override & RLC_TARG_gfxen_ff & (~stop_clock)) |=> cg_gfx_sclk;
endproperty
// Output Non-CGCGed clock
property gfx3dcg_pb3;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & cgcg_override) |=> cg_gfx_sclk;
endproperty
// No output clock, 3D BPM
property gfx3dcg_pb4;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & BPM_gfx3d & ~cg3d_override & ~cgcg_override & ~RLC_TARG_gfx3Den_ff & ~TARG_BPM_cgcgls_override) |=> ~cg_gfx_sclk;
endproperty
// Make sure all 3DCG clock output is disabled when CGCG happen, Non-3D BPM
property gfx3dcg_pb5;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & ~BPM_gfx3d & ~cgcg_override & ~RLC_TARG_gfxen_ff & ~TARG_BPM_cgcgls_override) |=> ~cg_gfx_sclk;
endproperty

`ifdef GFX_CG_W2E
// Output 3DCG clock
gfx3dcg_chk0: assert property(gfx3dcg_pb0) else $error("%m fails! 3D BPMs, 3DCG and CGCG not overrided, gfx3Den enable, GFX 3D clock should be enabled");
// Output CGCG clock
gfx3dcg_chk1: assert property(gfx3dcg_pb1) else $error("%m fails! 3D BPMs, 3DCG overrided CGCG not overrided, gfxen enable, cg_gfx_sclk should output CGCG clock");
gfx3dcg_chk2: assert property(gfx3dcg_pb2) else $error("%m fails! Non-3D BPMs, CGCG not overrided, cg_gfx_sclk should output CGCG clock");
// Output Non-CGCGed clock
gfx3dcg_chk3: assert property(gfx3dcg_pb3) else $error("%m fails! All BPMs, CGCG overrided, cg_gfx_sclk should output non-CGCGed clock");
// No output clock
gfx3dcg_chk4: assert property(gfx3dcg_pb4) else $error("%m fails! 3D BPMs, 3DCG and CGCG not overrided, gfx3Den not enable, cg_gfx_sclk should not output clock");
gfx3dcg_chk5: assert property(gfx3dcg_pb5) else $error("%m fails! Non-3D BPMs, CGCG not overrided, gfxen not enable, cg_gfx_sclk should not output clock");
`else
// Output 3DCG clock
gfx3dcg_chk0: assert property(gfx3dcg_pb0) else $error("%m fails! 3D BPMs, 3DCG and CGCG not overrided, gfx3Den enable, GFX 3D clock should be enabled");
// Output CGCG clock
gfx3dcg_chk1: assert property(gfx3dcg_pb1) else $warning("%m fails! 3D BPMs, 3DCG overrided CGCG not overrided, gfxen enable, cg_gfx_sclk should output CGCG clock");
gfx3dcg_chk2: assert property(gfx3dcg_pb2) else $warning("%m fails! Non-3D BPMs, CGCG not overrided, cg_gfx_sclk should output CGCG clock");
// Output Non-CGCGed clock
gfx3dcg_chk3: assert property(gfx3dcg_pb3) else $warning("%m fails! All BPMs, CGCG overrided, cg_gfx_sclk should output non-CGCGed clock");
// No output clock
gfx3dcg_chk4: assert property(gfx3dcg_pb4) else $warning("%m fails! 3D BPMs, 3DCG and CGCG not overrided, gfx3Den not enable, cg_gfx_sclk should not output clock");
gfx3dcg_chk5: assert property(gfx3dcg_pb5) else $warning("%m fails! Non-3D BPMs, CGCG not overrided, gfxen not enable, cg_gfx_sclk should not output clock");
`endif

property cgcgcgls_pb0;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & cg_gfx_sclk) |-> ~TTOP_P1_mem_power_ctrl[`MEM__MEM_POWER_CTRL_LS];
endproperty
property cgcgcgls_pb1;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & cg_gfx_sclk) |-> ~TTOP_P2_mem_power_ctrl[`MEM__MEM_POWER_CTRL_LS];
endproperty

`ifdef GFX_CG_W2E
cgcgcgls_chk0: assert property(cgcgcgls_pb0) else $error("%m fails! cg_gfx_sclk output vaild, P1 LS should not be asserted");
cgcgcgls_chk1: assert property(cgcgcgls_pb1) else $error("%m fails! cg_gfx_sclk output vaild, P2 LS should not be asserted");
`else
cgcgcgls_chk0: assert property(cgcgcgls_pb0) else $warning("%m fails! cg_gfx_sclk output vaild, P1 LS should not be asserted");
cgcgcgls_chk1: assert property(cgcgcgls_pb1) else $warning("%m fails! cg_gfx_sclk output vaild, P2 LS should not be asserted");
`endif

`else  // `ifndef GC__CGCG_MGCG_MERGE__1
// Output 3DCG clock
property cmm_gfx3dcg_pb0;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & BPM_gfx3d & ~cg3d_override & ~cgcg_override & RLC_TARG_gfx3Den_ff & (~stop_clock)) |-> ##1 cgcg_en;
endproperty
// Output CGCG clock
property cmm_gfx3dcg_pb1;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & BPM_gfx3d & cg3d_override & ~cgcg_override & RLC_TARG_gfxen_ff & (~stop_clock)) |-> ##1 cgcg_en;
endproperty
property cmm_gfx3dcg_pb2;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & ~BPM_gfx3d & ~cgcg_override & RLC_TARG_gfxen_ff & (~stop_clock)) |-> ##1 cgcg_en;
endproperty
// Output Non-CGCGed clock
property cmm_gfx3dcg_pb3;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & cgcg_override) |-> ##1 cgcg_en;
endproperty
// No output clock, 3D BPM
property cmm_gfx3dcg_pb4;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & BPM_gfx3d & ~cg3d_override & ~cgcg_override & ~RLC_TARG_gfx3Den_ff & ~TARG_BPM_cgcgls_override) |-> ##1 ~cgcg_en;
endproperty
// Make sure all 3DCG clock output is disabled when CGCG happen, Non-3D BPM
property cmm_gfx3dcg_pb5;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & ~BPM_gfx3d & ~cgcg_override & ~RLC_TARG_gfxen_ff & ~TARG_BPM_cgcgls_override) |-> ##1 ~cgcg_en;
endproperty

`ifdef GFX_CG_W2E
// Output 3DCG clock
cmm_gfx3dcg_chk0: assert property(cmm_gfx3dcg_pb0) else $error("%m fails! 3D BPMs, 3DCG and CGCG not overrided, gfx3Den enable, GFX 3D clock should be enabled");
// Output CGCG clock
cmm_gfx3dcg_chk1: assert property(cmm_gfx3dcg_pb1) else $error("%m fails! 3D BPMs, 3DCG overrided CGCG not overrided, gfxen enable, cg_gfx_sclk should output CGCG clock");
cmm_gfx3dcg_chk2: assert property(cmm_gfx3dcg_pb2) else $error("%m fails! Non-3D BPMs, CGCG not overrided, cg_gfx_sclk should output CGCG clock");
// Output Non-CGCGed clock
cmm_gfx3dcg_chk3: assert property(cmm_gfx3dcg_pb3) else $error("%m fails! All BPMs, CGCG overrided, cg_gfx_sclk should output non-CGCGed clock");
// No output clock
cmm_gfx3dcg_chk4: assert property(cmm_gfx3dcg_pb4) else $error("%m fails! 3D BPMs, 3DCG and CGCG not overrided, gfx3Den not enable, cg_gfx_sclk should not output clock");
cmm_gfx3dcg_chk5: assert property(cmm_gfx3dcg_pb5) else $error("%m fails! Non-3D BPMs, CGCG not overrided, gfxen not enable, cg_gfx_sclk should not output clock");
`else
// Output 3DCG clock
cmm_gfx3dcg_chk0: assert property(cmm_gfx3dcg_pb0) else $error("%m fails! 3D BPMs, 3DCG and CGCG not overrided, gfx3Den enable, GFX 3D clock should be enabled");
// Output CGCG clock
cmm_gfx3dcg_chk1: assert property(cmm_gfx3dcg_pb1) else $warning("%m fails! 3D BPMs, 3DCG overrided CGCG not overrided, gfxen enable, cg_gfx_sclk should output CGCG clock");
cmm_gfx3dcg_chk2: assert property(cmm_gfx3dcg_pb2) else $warning("%m fails! Non-3D BPMs, CGCG not overrided, cg_gfx_sclk should output CGCG clock");
// Output Non-CGCGed clock
cmm_gfx3dcg_chk3: assert property(cmm_gfx3dcg_pb3) else $warning("%m fails! All BPMs, CGCG overrided, cg_gfx_sclk should output non-CGCGed clock");
// No output clock
cmm_gfx3dcg_chk4: assert property(cmm_gfx3dcg_pb4) else $warning("%m fails! 3D BPMs, 3DCG and CGCG not overrided, gfx3Den not enable, cg_gfx_sclk should not output clock");
cmm_gfx3dcg_chk5: assert property(cmm_gfx3dcg_pb5) else $warning("%m fails! Non-3D BPMs, CGCG not overrided, gfxen not enable, cg_gfx_sclk should not output clock");
`endif

property cmm_cgcgcgls_pb0;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & cgcg_en & ~TARG_BPM_cgcgls_override) |-> ~TTOP_P1_mem_power_ctrl[`MEM__MEM_POWER_CTRL_LS];
endproperty
property cmm_cgcgcgls_pb1;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & cgcg_en & ~TARG_BPM_cgcgls_override) |-> ~TTOP_P2_mem_power_ctrl[`MEM__MEM_POWER_CTRL_LS];
endproperty

`ifdef GFX_CG_W2E
cmm_cgcgcgls_chk0: assert property(cmm_cgcgcgls_pb0) else $error("%m fails! cgcg_en output vaild, P1 LS should not be asserted");
cmm_cgcgcgls_chk1: assert property(cmm_cgcgcgls_pb1) else $error("%m fails! cgcg_en output vaild, P2 LS should not be asserted");
`else
cmm_cgcgcgls_chk0: assert property(cmm_cgcgcgls_pb0) else $warning("%m fails! cgcg_en output vaild, P1 LS should not be asserted");
cmm_cgcgcgls_chk1: assert property(cmm_cgcgcgls_pb1) else $warning("%m fails! cgcg_en output vaild, P2 LS should not be asserted");
`endif

`endif  // `ifndef GC__CGCG_MGCG_MERGE__1

`else // `ifdef GC__GFX_PIPELINE_CLOCK_GATING__1

property gfxcgls_pb0;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & cg_gfx_sclk) |-> ~TTOP_P1_mem_power_ctrl[`MEM__MEM_POWER_CTRL_LS];
endproperty
property gfxcgls_pb1;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & cg_gfx_sclk) |-> ~TTOP_P2_mem_power_ctrl[`MEM__MEM_POWER_CTRL_LS];
endproperty

`ifdef GFX_CG_W2E
gfxcgls_chk0: assert property(gfxcgls_pb0) else $error("%m fails! cg_gfx_sclk output vaild, P1 LS should not be asserted");
gfxcgls_chk1: assert property(gfxcgls_pb1) else $error("%m fails! cg_gfx_sclk output vaild, P2 LS should not be asserted");
`else
gfxcgls_chk0: assert property(gfxcgls_pb0) else $warning("%m fails! cg_gfx_sclk output vaild, P1 LS should not be asserted");
gfxcgls_chk1: assert property(gfxcgls_pb1) else $warning("%m fails! cg_gfx_sclk output vaild, P2 LS should not be asserted");
`endif

`endif // `ifdef GC__GFX_PIPELINE_CLOCK_GATING__1

// dyn_rm
property dyn_rm_pb0;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & disable_mgcg) |-> TTOP_MGCG_override;
endproperty
property dyn_rm_pb1;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & rm_valid) |-> ##4 (oCUSTOM_MEM_RM == iCUSTOM_MEM_RM);
endproperty
property dyn_rm_pb2;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & rm_valid) |-> ##4 (oCUSTOM_MEM_RME == iCUSTOM_MEM_RME);
endproperty
property dyn_rm_pb3;
  @(negedge Cpl_GFXCLK) disable iff(~bpm_assert_enable) (hard_resetb & disable_mgls) |-> TTOP_MGLS_override;
endproperty

`ifdef GFX_CG_W2E
//dyn_rm_chk0: assert property(dyn_rm_pb0) else $error("%m fails! dyn_rm changing, CGLS should not happen");
dyn_rm_chk0: assert property(dyn_rm_pb0) else $error("%m fails! dyn_rm changing, MGCG should not happen");
dyn_rm_chk1: assert property(dyn_rm_pb1) else $error("%m fails! custom memory rm bits not sampled to output");
dyn_rm_chk2: assert property(dyn_rm_pb2) else $error("%m fails! custom memory rme bit not sampled to output");
dyn_rm_chk3: assert property(dyn_rm_pb3) else $error("%m fails! dyn_rm chaning, MGLS should not happen");
`else
//dyn_rm_chk0: assert property(dyn_rm_pb0) else $warning("%m fails! dyn_rm changing, CGLS should not happen");
dyn_rm_chk0: assert property(dyn_rm_pb0) else $warning("%m fails! dyn_rm changing, MGCG should not happen");
dyn_rm_chk1: assert property(dyn_rm_pb1) else $warning("%m fails! custom memory rm bits not sampled to output");
dyn_rm_chk2: assert property(dyn_rm_pb2) else $warning("%m fails! custom memory rme bit not sampled to output");
dyn_rm_chk3: assert property(dyn_rm_pb3) else $warning("%m fails! dyn_rm chaning, MGLS should not happen");
`endif


// vrq translate_on

endmodule // bpm_assert
