`include "msgio_defines.vh"
`include "gfx_pgfsm_defines.h"
module bpm_cov
  (
   cg_gbl_sclk, cg_Cpl_GFXCLK,
`ifdef GC__GFX_PIPELINE_CLOCK_GATING__1
   BPM_gfx3d,
   cg3d_blk_cntl_override,
   cg3d_rep_cntl_override,
   RLC_TARG_gfx3Den,
   cg3d_Cpl_GFXCLK,
`endif
`ifdef GC__DLDO_POWER_GATING__1
   bpm_bpm_resetb,
`endif
    stop_clock,
   // Decoded Override Signals
   cgcg_en, cgls_en, cgls_on, cgcg_override, TTOP_MGCG_override,TTOP_FGCG_override,
   cgcgclk_en_rep,
   cg3dclk_en_rep,
   BPM_blk_addr,
   // Addition
   BPM_select, SERDES_cmd, SERDES_wdata, pg_P1_strap, pg_P2_strap, RSMU_GFX_hard_resetb, RLC_TARG_gfxen, TARG_BPM_cgcgls_override,
   //AVFS signal
   bpm_avfs_mm_wdata_l,bpm_avfs_mm_wdata_h,bpm_avfs_mm_rdata_l,bpm_avfs_mm_rdata_h,
   // Reset signals
   TTOP_P1_hard_resetb, TTOP_P1_combined_resetb_0, TTOP_P1_combined_resetb_1, TTOP_P1_combined_resetb_2, TTOP_P1_combined_resetb_3

   );

// vrq translate_off

parameter enable_dd = 0;
parameter enable_avfs = 0;
parameter enable_psm_didt_dd = 0;
parameter enable_psm_edc_dd = 0;

//////////////////////////
input    cg_gbl_sclk;
input	 cg_Cpl_GFXCLK;
input    RLC_TARG_gfxen;
`ifdef GC__GFX_PIPELINE_CLOCK_GATING__1
input    BPM_gfx3d;
input    cg3d_blk_cntl_override;
input    cg3d_rep_cntl_override;
input    RLC_TARG_gfx3Den;
input    cg3d_Cpl_GFXCLK;
`endif
`ifdef GC__DLDO_POWER_GATING__1
input    bpm_bpm_resetb;
`endif
input	   TARG_BPM_cgcgls_override;
input   stop_clock;
input	   cgcg_en;
input    cgls_en;
input    cgls_on;
input    cgcg_override;
input    TTOP_MGCG_override;
input    TTOP_FGCG_override;
input    TTOP_P1_hard_resetb;
input    TTOP_P1_combined_resetb_0;
input    TTOP_P1_combined_resetb_1;
input    TTOP_P1_combined_resetb_2;
input    TTOP_P1_combined_resetb_3;
input    cgcgclk_en_rep;
input    cg3dclk_en_rep;

input    [12:0] BPM_blk_addr;


input    BPM_select;
input    [23:0] SERDES_cmd;
input    [31:0] SERDES_wdata;
input    pg_P1_strap;
input    pg_P2_strap;
input    RSMU_GFX_hard_resetb;

input    [31:0]  bpm_avfs_mm_wdata_l;
input    [31:0]  bpm_avfs_mm_wdata_h;
input    [31:0]  bpm_avfs_mm_rdata_l;
input    [31:0]  bpm_avfs_mm_rdata_h;

//////////////////////////

//VCS coverage exclude_module
`ifdef VCS
//VCS coverage off

reg BPM_Coverage_enable;

initial begin
  if($test$plusargs("BPM_Coverage_assert_enable"))
    BPM_Coverage_enable = 1'b1;
  else
    BPM_Coverage_enable = 1'b0;
end

reg BPM_All_Coverage_enable;

initial begin
  if($test$plusargs("BPM_All_Coverage_assert_enable"))
    BPM_All_Coverage_enable = 1'b1;
  else
    BPM_All_Coverage_enable = 1'b0;
end

reg BPM_3D_Coverage_enable;

initial begin
  if($test$plusargs("BPM_3D_Coverage_assert_enable"))
    BPM_3D_Coverage_enable = 1'b1;
  else
    BPM_3D_Coverage_enable = 1'b0;
end

reg BPM_non3D_Coverage_enable;

initial begin
  if($test$plusargs("BPM_non3D_Coverage_assert_enable"))
    BPM_non3D_Coverage_enable = 1'b1;
  else
    BPM_non3D_Coverage_enable = 1'b0;
end

reg BPM_AWGP_Coverage_enable;

initial begin
  if($test$plusargs("BPM_AWGP_Coverage_assert_enable"))
    BPM_AWGP_Coverage_enable = 1'b1;
  else
    BPM_AWGP_Coverage_enable = 1'b0;
end

reg BPM_SA0_Coverage_enable;

initial begin
  if($test$plusargs("BPM_SA0_Coverage_assert_enable"))
    BPM_SA0_Coverage_enable = 1'b1;
  else
    BPM_SA0_Coverage_enable = 1'b0;
end

reg BPM_SA1_Coverage_enable;

initial begin
  if($test$plusargs("BPM_SA1_Coverage_assert_enable"))
    BPM_SA1_Coverage_enable = 1'b1;
  else
    BPM_SA1_Coverage_enable = 1'b0;
end

reg BPM_AGL2_Coverage_enable;

initial begin
  if($test$plusargs("BPM_AGL2_Coverage_assert_enable"))
    BPM_AGL2_Coverage_enable = 1'b1;
  else
    BPM_AGL2_Coverage_enable = 1'b0;
end

reg BPM_ARB_Coverage_enable;

initial begin
  if($test$plusargs("BPM_ARB_Coverage_assert_enable"))
    BPM_ARB_Coverage_enable = 1'b1;
  else
    BPM_ARB_Coverage_enable = 1'b0;
end

reg BPM_Coverage_avfs_enable;

initial begin
  if($test$plusargs("BPM_avfs_Coverage_assert_enable"))
    BPM_Coverage_avfs_enable = enable_avfs;
  else
    BPM_Coverage_avfs_enable = 1'b0;
end


reg BPM_Coverage_dd_enable;

initial begin
  if($test$plusargs("BPM_dd_Coverage_assert_enable"))
    BPM_Coverage_dd_enable = enable_dd;
  else
    BPM_Coverage_dd_enable = 1'b0;
end

reg BPM_Coverage_psm_didt_enable;

initial begin
  if($test$plusargs("BPM_psm_didt_Coverage_assert_enable"))
    BPM_Coverage_psm_didt_enable = enable_psm_didt_dd;
  else
    BPM_Coverage_psm_didt_enable = 1'b0;
end

reg BPM_Coverage_psm_edc_enable;

initial begin
  if($test$plusargs("BPM_psm_edc_Coverage_assert_enable"))
    BPM_Coverage_psm_edc_enable = enable_psm_edc_dd;
  else
    BPM_Coverage_psm_edc_enable = 1'b0;
end


reg enable;

initial begin
  if($test$plusargs("cgt_assert_disable"))
    enable = 1'b0;
  else
    enable = 1'b1;
end

reg cgt_en_assert_enable;

initial begin
  if($test$plusargs("cgt_en_assert_disable"))
    cgt_en_assert_enable = 1'b0;
  else
    cgt_en_assert_enable = 1'b1;
end

reg [9:0] 	BPM_Coverage;

always @(posedge cg_gbl_sclk) 
begin
  if (~RSMU_GFX_hard_resetb) 
  begin
    BPM_Coverage			<= 10'b0;
  end 
  else begin
    if ((BPM_select & SERDES_cmd[`BPM_WRITE]) && BPM_Coverage_enable) 
	begin
      case (SERDES_cmd[`BPM_REG_ADDR])
	8'b11111111:	
		BPM_Coverage		<= SERDES_wdata[9:0];
     default:
       begin
		BPM_Coverage		<= BPM_Coverage;
       end
      endcase
	end
  end
end

 `ifdef GFX_CG_W2E
final if((BPM_Coverage == 10'b0) && BPM_Coverage_enable && BPM_All_Coverage_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE BPM coverage test");
 `else
final if((BPM_Coverage == 10'b0) && BPM_Coverage_enable && BPM_All_Coverage_enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE BPM coverage test");
 `endif

 `ifdef GFX_CG_W2E
final if((BPM_Coverage == 10'b0) && BPM_Coverage_enable && BPM_3D_Coverage_enable && (SERDES_cmd&'hfff8>>3)=='h1fc0 && BPM_gfx3d) `MSGIO_DISPLAY("%m ERROR: CLKGATE 3D BPM coverage test");
 `else
final if((BPM_Coverage == 10'b0) && BPM_Coverage_enable && BPM_3D_Coverage_enable && (SERDES_cmd&'hfff8>>3)=='h1fc0 && BPM_gfx3d) `MSGIO_DISPLAY("%m WARNING: CLKGATE 3D BPM coverage test");
 `endif

 `ifdef GFX_CG_W2E
final if((BPM_Coverage == 10'b0) && BPM_Coverage_enable && BPM_non3D_Coverage_enable && (SERDES_cmd&'hfff8>>3)=='h1fc8 && !BPM_gfx3d) `MSGIO_DISPLAY("%m ERROR: CLKGATE non 3D BPM coverage test");
 `else
final if((BPM_Coverage == 10'b0) && BPM_Coverage_enable && BPM_non3D_Coverage_enable && (SERDES_cmd&'hfff8>>3)=='h1fc8 && !BPM_gfx3d) `MSGIO_DISPLAY("%m WARNING: CLKGATE non 3D BPM coverage test");
 `endif

 `ifdef GFX_CG_W2E
final if((BPM_Coverage == 10'b0) && BPM_Coverage_enable && BPM_AWGP_Coverage_enable && (SERDES_cmd&'hfff8>>3)=='h1fc1 && (BPM_blk_addr&'h1800>>11)=='h2) `MSGIO_DISPLAY("%m ERROR: CLKGATE All WGP BPM coverage test");
 `else
final if((BPM_Coverage == 10'b0) && BPM_Coverage_enable && BPM_AWGP_Coverage_enable && (SERDES_cmd&'hfff8>>3)=='h1fc1 && (BPM_blk_addr&'h1800>>11)=='h2) `MSGIO_DISPLAY("%m WARNING: CLKGATE All WGP BPM coverage test");
 `endif

 `ifdef GFX_CG_W2E
final if((BPM_Coverage == 10'b0) && BPM_Coverage_enable && BPM_SA0_Coverage_enable && (SERDES_cmd&'hfff8>>3)=='h1fc4 && !(BPM_blk_addr&'h400>>10)) `MSGIO_DISPLAY("%m ERROR: CLKGATE SA0 BPM coverage test");
 `else
final if((BPM_Coverage == 10'b0) && BPM_Coverage_enable && BPM_SA0_Coverage_enable && (SERDES_cmd&'hfff8>>3)=='h1fc4 && !(BPM_blk_addr&'h400>>10)) `MSGIO_DISPLAY("%m WARNING: CLKGATE SA0 BPM coverage test");
 `endif

 `ifdef GFX_CG_W2E
final if((BPM_Coverage == 10'b0) && BPM_Coverage_enable && BPM_SA1_Coverage_enable && (SERDES_cmd&'hfff8>>3)=='h1fc5 && (BPM_blk_addr&'h400>>10)) `MSGIO_DISPLAY("%m ERROR: CLKGATE SA1 BPM coverage test");
 `else
final if((BPM_Coverage == 10'b0) && BPM_Coverage_enable && BPM_SA1_Coverage_enable && (SERDES_cmd&'hfff8>>3)=='h1fc5 && (BPM_blk_addr&'h400>>10)) `MSGIO_DISPLAY("%m WARNING: CLKGATE SA1 BPM coverage test");
 `endif

 `ifdef GFX_CG_W2E
final if((BPM_Coverage == 10'b0) && BPM_Coverage_enable && BPM_AGL2_Coverage_enable && (SERDES_cmd&'hfff8>>3)=='h1fc6 && (BPM_blk_addr&'h1800>>11)=='h0 && (BPM_blk_addr&'h3c0>>6)=='h2) `MSGIO_DISPLAY("%m ERROR: CLKGATE GL2 BPM coverage test");
 `else
final if((BPM_Coverage == 10'b0) && BPM_Coverage_enable && BPM_AGL2_Coverage_enable && (SERDES_cmd&'hfff8>>3)=='h1fc6 && (BPM_blk_addr&'h1800>>11)=='h0 && (BPM_blk_addr&'h3c0>>6)=='h2) `MSGIO_DISPLAY("%m WARNING: CLKGATE GL2 BPM coverage test");
 `endif

 `ifdef GFX_CG_W2E
final if((BPM_Coverage == 10'b0) && BPM_Coverage_enable && BPM_ARB_Coverage_enable && (SERDES_cmd&'hfff8>>3)=='h1fc7 && (BPM_blk_addr&'h1800>>11)=='h1 && (BPM_blk_addr&'h380>>7)=='h1) `MSGIO_DISPLAY("%m ERROR: CLKGATE RB BPM coverage test");
 `else
final if((BPM_Coverage == 10'b0) && BPM_Coverage_enable && BPM_ARB_Coverage_enable && (SERDES_cmd&'hfff8>>3)=='h1fc7 && (BPM_blk_addr&'h1800>>11)=='h1 && (BPM_blk_addr&'h380>>7)=='h1) `MSGIO_DISPLAY("%m WARNING: CLKGATE RB BPM coverage test");
 `endif


//add for avfs broadcast write check
reg [31:0] 	BPM_avfs_Coverage;

always @(posedge cg_gbl_sclk) 
begin
  if (~RSMU_GFX_hard_resetb) 
  begin
    BPM_avfs_Coverage			<= 0;
  end 
  else begin
    if ((BPM_select & SERDES_cmd[`BPM_WRITE]) && BPM_Coverage_avfs_enable) 
	begin
      case (SERDES_cmd[`BPM_REG_ADDR])
	8'h13:	
		BPM_avfs_Coverage		<= SERDES_wdata;
     default:
       begin
		BPM_avfs_Coverage		<= BPM_avfs_Coverage;
       end
      endcase
	end
  end
end

 `ifdef GFX_CG_W2E
final if((BPM_avfs_Coverage == 32'h0) && BPM_Coverage_avfs_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE BPM AVFS coverage test");
 `else
final if((BPM_avfs_Coverage == 32'h0) && BPM_Coverage_avfs_enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE BPM AVFS coverage test");
 `endif


//add for dd broadcast write check
reg [31:0] 	BPM_dd_Coverage;

always @(posedge cg_gbl_sclk) 
begin
  if (~RSMU_GFX_hard_resetb) 
  begin
    BPM_dd_Coverage			<= 0;
  end 
  else begin
    if ((BPM_select & SERDES_cmd[`BPM_WRITE]) && BPM_Coverage_dd_enable) 
	begin
      case (SERDES_cmd[`BPM_REG_ADDR])
	8'h21:	
		BPM_dd_Coverage		<= SERDES_wdata;
     default:
       begin
		BPM_dd_Coverage		<= BPM_dd_Coverage;
       end
      endcase
	end
  end
end

 `ifdef GFX_CG_W2E
final if((BPM_dd_Coverage == 32'h0) && BPM_Coverage_dd_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE BPM DD coverage test");
 `else
final if((BPM_dd_Coverage == 32'h0) && BPM_Coverage_dd_enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE BPM DD coverage test");
 `endif

//add for psm_didt broadcast write check
reg [31:0] 	BPM_psm_didt_Coverage;

always @(posedge cg_gbl_sclk) 
begin
  if (~RSMU_GFX_hard_resetb) 
  begin
    BPM_psm_didt_Coverage			<= 0;
  end 
  else begin
    if ((BPM_select & SERDES_cmd[`BPM_WRITE]) && BPM_Coverage_psm_didt_enable) 
	begin
      case (SERDES_cmd[`BPM_REG_ADDR])
	8'h30:	
		BPM_psm_didt_Coverage		<= SERDES_wdata;
     default:
       begin
		BPM_psm_didt_Coverage		<= BPM_psm_didt_Coverage;
       end
      endcase
	end
  end
end

 `ifdef GFX_CG_W2E
final if((BPM_psm_didt_Coverage == 32'h0) && BPM_Coverage_psm_didt_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE BPM psm_didt coverage test");
 `else
final if((BPM_psm_didt_Coverage == 32'h0) && BPM_Coverage_psm_didt_enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE BPM psm_didt coverage test");
 `endif

//add for psm_edc broadcast write check
reg [31:0] 	BPM_psm_edc_Coverage;

always @(posedge cg_gbl_sclk) 
begin
  if (~RSMU_GFX_hard_resetb) 
  begin
    BPM_psm_edc_Coverage			<= 0;
  end 
  else begin
    if ((BPM_select & SERDES_cmd[`BPM_WRITE]) && BPM_Coverage_psm_edc_enable) 
	begin
      case (SERDES_cmd[`BPM_REG_ADDR])
	8'h40:	
		BPM_psm_edc_Coverage		<= SERDES_wdata;
     default:
       begin
		BPM_psm_edc_Coverage		<= BPM_psm_edc_Coverage;
       end
      endcase
	end
  end
end

 `ifdef GFX_CG_W2E
final if((BPM_psm_edc_Coverage == 32'h0) && BPM_Coverage_psm_edc_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE BPM psm_edc coverage test");
 `else
final if((BPM_psm_edc_Coverage == 32'h0) && BPM_Coverage_psm_edc_enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE BPM psm_edc coverage test");
 `endif

//
wire BPM_AS_DISABLE = (~TTOP_P1_hard_resetb) || (TTOP_P1_hard_resetb === 1'bx) ;


`ifdef GC__CGCG_MGCG_MERGE__1

`ifdef GC__GFX_PIPELINE_CLOCK_GATING__1
wire seq = ~(BPM_gfx3d ? (RLC_TARG_gfx3Den | cg3d_blk_cntl_override) : RLC_TARG_gfxen) & ~cgcg_override & ~TARG_BPM_cgcgls_override;
`else
wire seq = ~RLC_TARG_gfxen & ~cgcg_override & ~TARG_BPM_cgcgls_override & ~diable_cgcg;
`endif

cgcg_en_active						: assert property (@(negedge cg_gbl_sclk) disable iff(BPM_AS_DISABLE) (seq |-> ##1 (cgcg_en!==1'b1)));
cgcg_override_cgcg_en_inactive		: assert property (@(negedge cg_gbl_sclk) disable iff(BPM_AS_DISABLE) (cgcg_override |-> ##1 cgcg_en));
TARG_BPM_cgcgls_override_cgcg_en_inactive			: assert property (@(negedge cg_gbl_sclk) disable iff(BPM_AS_DISABLE) (TARG_BPM_cgcgls_override |-> ##1 cgcg_en));

`ifdef GC__GFX_PIPELINE_CLOCK_GATING__1
cgcg_active_rep_clk_inactive		: assert property (@(negedge cg_gbl_sclk) disable iff(BPM_AS_DISABLE) ((~BPM_gfx3d & cgcgclk_en_rep) ##1 (~BPM_gfx3d & cgcgclk_en_rep) |-> ##1 cg_Cpl_GFXCLK));
RLC_TARG_gfx3Den_active_3drep_clk_inactive : assert property (@(negedge cg_gbl_sclk) disable iff(BPM_AS_DISABLE) ((BPM_gfx3d & RLC_TARG_gfx3Den & ~cg3d_rep_cntl_override) ##1 (BPM_gfx3d & RLC_TARG_gfx3Den & ~cg3d_rep_cntl_override) |=> ##1 cg3d_Cpl_GFXCLK));

cgcg_inactive_rep_clk_active	: assert property (@(negedge cg_gbl_sclk) disable iff(BPM_AS_DISABLE) ((~BPM_gfx3d & ~cgcgclk_en_rep) ##1 (~BPM_gfx3d & ~cgcgclk_en_rep) |-> ##1 (cg_Cpl_GFXCLK!==1'b1)));
cgcg_inactive_3drep_clk_active  : assert property (@(negedge cg_gbl_sclk) disable iff(BPM_AS_DISABLE) ((BPM_gfx3d & ~cg3dclk_en_rep & ~cg3d_rep_cntl_override) ##1 (BPM_gfx3d & ~cg3dclk_en_rep & ~cg3d_rep_cntl_override) |-> ##1 (cg3d_Cpl_GFXCLK!==1'b1)));

RLC_TARG_gfxen_cgcg_en_inactive		: assert property (@(negedge cg_gbl_sclk) disable iff(BPM_AS_DISABLE) ((~BPM_gfx3d & RLC_TARG_gfxen & (~stop_clock)) |-> ##1 cgcg_en));
RLC_TARG_gfx3Den_cgcg_en_inactive	: assert property (@(negedge cg_gbl_sclk) disable iff(BPM_AS_DISABLE) ((BPM_gfx3d & RLC_TARG_gfx3Den & RLC_TARG_gfxen & (~stop_clock)) |-> ##1 cgcg_en));

stop_clock_cgcg_en_inactive : assert property (@(negedge cg_gbl_sclk) disable iff(BPM_AS_DISABLE) (stop_clock && ~cgcg_override && ~TARG_BPM_cgcgls_override) |-> ##1 ~cgcg_en);
`else
cgcg_active_rep_clk_inactive	: assert property (@(negedge cg_gbl_sclk) disable iff(BPM_AS_DISABLE) (cgcg_en ##1 cgcg_en) |-> cg_Cpl_GFXCLK));
cgcg_inactive_rep_clk_active	: assert property (@(negedge cg_gbl_sclk) disable iff(BPM_AS_DISABLE) (~cgcg_en ##1 ~cgcg_en) |-> (cg_Cpl_GFXCLK!==1'b1)));

RLC_TARG_gfxen_cgcg_en_inactive		: assert property (@(negedge cg_gbl_sclk) disable iff(BPM_AS_DISABLE) (RLC_TARG_gfxen |-> ##1 cgcg_en));
`endif

`endif


reg cgls_en_enabled;
initial cgls_en_enabled = 1'b0;
always @(posedge cg_gbl_sclk) if(cgls_en == 1'b1) cgls_en_enabled <= 1'b1;
 `ifdef GFX_CG_W2E
final if((cgls_en_enabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE cgls_en never activated");
 `else
final if((cgls_en_enabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE cgls_en never activated");
 `endif

reg cgls_on_enabled;
initial cgls_on_enabled = 1'b0;
always @(posedge cg_gbl_sclk) if(cgls_on == 1'b1) cgls_on_enabled <= 1'b1;
 `ifdef GFX_CG_W2E
final if((cgls_on_enabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE cgls never happened");
 `else
final if((cgls_on_enabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE cgls never happened");
 `endif

reg cgcg_disabled;
initial cgcg_disabled = 1'b0;
always @(posedge cg_gbl_sclk) if(RLC_TARG_gfxen == 1'b0) cgcg_disabled <= 1'b1;
 `ifdef GFX_CG_W2E
final if((cgcg_disabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE cgcg never happened");
 `else
final if((cgcg_disabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE cgcg never happened");
 `endif

 
reg cgcg_override_disabled;
initial cgcg_override_disabled = 1'b0;
always @(posedge cg_gbl_sclk) if(cgcg_override == 1'b0) cgcg_override_disabled <= 1'b1;
 `ifdef GFX_CG_W2E
final if((cgcg_override_disabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE cgcg_override never deactivated");
 `else
final if((cgcg_override_disabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE cgcg_override never deactivated");
 `endif



reg TTOP_MGCG_override_disabled;
initial TTOP_MGCG_override_disabled = 1'b0;
always @(posedge cg_gbl_sclk) if(TTOP_MGCG_override == 1'b0) TTOP_MGCG_override_disabled <= 1'b1;
 `ifdef GFX_CG_W2E
final if((TTOP_MGCG_override_disabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE TTOP_MGCG_override never deactivated");
 `else
final if((TTOP_MGCG_override_disabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE TTOP_MGCG_override never deactivated");
 `endif

reg TTOP_P1_hard_resetb_disabled;
initial TTOP_P1_hard_resetb_disabled = 1'b0;
always @(posedge cg_gbl_sclk) if(TTOP_P1_hard_resetb == 1'b1) TTOP_P1_hard_resetb_disabled <= 1'b1;
 `ifdef GFX_CG_W2E
final if((TTOP_P1_hard_resetb_disabled == 1'b0) && enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE TTOP_P1_hard_resetb never deactivated");
 `else
final if((TTOP_P1_hard_resetb_disabled == 1'b0) && enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE TTOP_P1_hard_resetb never deactivated");
 `endif

reg TTOP_P1_combined_resetb_0_disabled;
initial TTOP_P1_combined_resetb_0_disabled = 1'b0;
always @(posedge cg_gbl_sclk) if(TTOP_P1_combined_resetb_0 == 1'b1) TTOP_P1_combined_resetb_0_disabled <= 1'b1;
 `ifdef GFX_CG_W2E
final if((TTOP_P1_combined_resetb_0_disabled == 1'b0) && enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE TTOP_P1_combined_resetb_0 never deactivated");
 `else
final if((TTOP_P1_combined_resetb_0_disabled == 1'b0) && enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE TTOP_P1_combined_resetb_0 never deactivated");
 `endif

reg TTOP_P1_combined_resetb_1_disabled;
initial TTOP_P1_combined_resetb_1_disabled = 1'b0;
always @(posedge cg_gbl_sclk) if(TTOP_P1_combined_resetb_1 == 1'b1) TTOP_P1_combined_resetb_1_disabled <= 1'b1;
 `ifdef GFX_CG_W2E
final if((TTOP_P1_combined_resetb_1_disabled == 1'b0) && enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE TTOP_P1_combined_resetb_1 never deactivated");
 `else
final if((TTOP_P1_combined_resetb_1_disabled == 1'b0) && enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE TTOP_P1_combined_resetb_1 never deactivated");
 `endif

reg TTOP_P1_combined_resetb_2_disabled;
initial TTOP_P1_combined_resetb_2_disabled = 1'b0;
always @(posedge cg_gbl_sclk) if(TTOP_P1_combined_resetb_2 == 1'b1) TTOP_P1_combined_resetb_2_disabled <= 1'b1;
 `ifdef GFX_CG_W2E
final if((TTOP_P1_combined_resetb_2_disabled == 1'b0) && enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE TTOP_P1_combined_resetb_2 never deactivated");
 `else
final if((TTOP_P1_combined_resetb_2_disabled == 1'b0) && enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE TTOP_P1_combined_resetb_2 never deactivated");
 `endif

reg TTOP_P1_combined_resetb_3_disabled;
initial TTOP_P1_combined_resetb_3_disabled = 1'b0;
always @(posedge cg_gbl_sclk) if(TTOP_P1_combined_resetb_3 == 1'b1) TTOP_P1_combined_resetb_3_disabled <= 1'b1;
 `ifdef GFX_CG_W2E
final if((TTOP_P1_combined_resetb_3_disabled == 1'b0) && enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE TTOP_P1_combined_resetb_3 never deactivated");
 `else
final if((TTOP_P1_combined_resetb_3_disabled == 1'b0) && enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE TTOP_P1_combined_resetb_3 never deactivated");
 `endif

`ifndef GC__DLDO_POWER_GATING__1
always @ (posedge TTOP_P1_hard_resetb)
begin
  if (enable)
  begin
    repeat(3) @(posedge cg_gbl_sclk);
`ifdef GFX_CG_W2E
    if (cgls_en == 1)
      `MSGIO_DISPLAY("%m ERROR: CLKGATE CGLS Master Override should be set after reset");
	if (cgls_on == 1)
      `MSGIO_DISPLAY("%m ERROR: CLKGATE CGLS ON should be set after reset");
    if (cgcg_override == 0)
      `MSGIO_DISPLAY("%m ERROR: CLKGATE CGCG Master Override should be set after reset");
    if (TTOP_MGCG_override == 0)
      `MSGIO_DISPLAY("%m ERROR: CLKGATE MGCG Master Override should be set after reset");
`ifdef GC__GFX_PIPELINE_CLOCK_GATING__1
    if (cg3d_blk_cntl_override == 1)
      `MSGIO_DISPLAY("%m ERROR: GFX3D CLKGATE Override should be set after reset");
`endif // `ifdef GC__GFX_PIPELINE_CLOCK_GATING__1

`else
    if (cgls_en == 1)
      `MSGIO_DISPLAY("%m WARNING: CLKGATE CGLS Master Override should be set after reset");
	if (cgls_on == 1)
      `MSGIO_DISPLAY("%m WARNING: CLKGATE CGLS ON should be set after reset");	  
    if (cgcg_override == 0)
      `MSGIO_DISPLAY("%m WARNING: CLKGATE CGCG Master Override should be set after reset");
    if (TTOP_MGCG_override == 0)
      `MSGIO_DISPLAY("%m WARNING: CLKGATE MGCG Master Override should be set after reset");
`ifdef GC__GFX_PIPELINE_CLOCK_GATING__1
    if (cg3d_blk_cntl_override == 1)
      `MSGIO_DISPLAY("%m ERROR: GFX3D CLKGATE Override should be set after reset");
`endif // `ifdef GC__GFX_PIPELINE_CLOCK_GATING__1
`endif
  end
end
`endif

reg hier_acv_enable;
string Hier_acv;

initial begin
    hier_acv_enable = 1'b0;
    $sformat(Hier_acv, "%m");

    for(integer i=0;i<Hier_acv.len();i++) 
        begin 
            if( (Hier_acv.substr(i,i+4)==".acv.") || (Hier_acv.substr(i,i+4)=="_acv_") ||  (Hier_acv.substr(i,i+5)=="_acvi_") || (Hier_acv.substr(i,i+11)=="bpm_acv_chiw") )
            begin 
                hier_acv_enable=1'b1; 
                `MSGIO_DISPLAY("%m: WARNING: enable check disable acv cgcg_en in acv cgtt/cgts/bpm");
                break; 
            end
        end
end

//added dis acv assertion
`ifdef GFX_CG_W2E
reg dis_acv_chk_en;
initial begin
    if($test$plusargs("dis_acv_check_enable"))
        dis_acv_chk_en = 1'b1;
    else
        dis_acv_chk_en = 1'b0;
end

reg   cgcg_en_r =0;
always @(posedge cg_gbl_sclk) begin
    cgcg_en_r <= cgcg_en;
end

reg dis_acv_time=0;
always @(posedge cg_gbl_sclk)
begin
    if(~RSMU_GFX_hard_resetb)
        dis_acv_time <= 1'b0;
    else if(cgcg_en_r & (~cgcg_en) & hier_acv_enable) 
        dis_acv_time <= 1'b1;
end

wire DIS_ACV_DISABLE = (~RSMU_GFX_hard_resetb | (~(dis_acv_chk_en & hier_acv_enable & dis_acv_time)) || (RSMU_GFX_hard_resetb === 1'bx)) ;

acv_cgcg_en_inactive	: assert property (@(negedge cg_gbl_sclk) disable iff(DIS_ACV_DISABLE) (cgcg_en !== 1'b1));
`endif


`ifdef GC__GFX_PIPELINE_CLOCK_GATING__1
override_inactive_gfxen_inactive :  assert property (@(negedge cg_gbl_sclk) disable iff(~BPM_Coverage_enable || hier_acv_enable) ((BPM_Coverage=='h3ff) |=> (~cgcg_override && ~RLC_TARG_gfxen && ~cg3d_blk_cntl_override && ~RLC_TARG_gfx3Den))); 
override_inactive_gfxen_active :    assert property (@(negedge cg_gbl_sclk) disable iff(~BPM_Coverage_enable || hier_acv_enable) ((BPM_Coverage=='h3fe) |=> (cgcg_override && RLC_TARG_gfxen && cg3d_blk_cntl_override && RLC_TARG_gfx3Den))); 
override_active_gfxen_inactive :    assert property (@(negedge cg_gbl_sclk) disable iff(~BPM_Coverage_enable || hier_acv_enable) ((BPM_Coverage=='h3fd) |=> (cgcg_override && ~RLC_TARG_gfxen && cg3d_blk_cntl_override && ~RLC_TARG_gfx3Den))); 
`else
override_inactive_gfxen_inactive :  assert property (@(negedge cg_gbl_sclk) disable iff(~BPM_Coverage_enable || hier_acv_enable) ((BPM_Coverage=='h3ff) |=> (~cgcg_override && ~RLC_TARG_gfxen))); 
override_inactive_gfxen_active :    assert property (@(negedge cg_gbl_sclk) disable iff(~BPM_Coverage_enable || hier_acv_enable) ((BPM_Coverage=='h3fe) |=> (cgcg_override && RLC_TARG_gfxen))); 
override_active_gfxen_inactive :    assert property (@(negedge cg_gbl_sclk) disable iff(~BPM_Coverage_enable || hier_acv_enable) ((BPM_Coverage=='h3fd) |=> (cgcg_override && ~RLC_TARG_gfxen)));
`endif

`ifdef GFX_CG_SIGNALS_DUMP_EN
initial 
begin
  #1;
    `ifdef GC__SOC_ENV__1 
       `ifdef GC__FLAVOR__APU 
	  if(BPM_Coverage_enable) 
            $fmonitor(sys.cg_file_handle, "CG BPM_COVERAGE:(%t) %m %d BPM_blk_addr:%d BPM_gfx3d:%d",$time,BPM_Coverage,(BPM_blk_addr & 13'h1FFF),BPM_gfx3d);
          else if(BPM_Coverage_dd_enable)
            $fmonitor(sys.cg_file_handle, "CG BPM_COVERAGE:(%t) %m %d BPM_blk_addr:%d BPM_gfx3d:%d",$time,BPM_dd_Coverage,(BPM_blk_addr & 13'h1FFF),BPM_gfx3d);
          else if(BPM_Coverage_avfs_enable)
            $fmonitor(sys.cg_file_handle, "CG BPM_COVERAGE:(%t) %m %d BPM_blk_addr:%d BPM_gfx3d:%d",$time,BPM_avfs_Coverage,(BPM_blk_addr & 13'h1FFF),BPM_gfx3d);
          else if(BPM_Coverage_psm_didt_enable)
            $fmonitor(sys.cg_file_handle, "CG BPM_COVERAGE:(%t) %m %d BPM_blk_addr:%d BPM_gfx3d:%d",$time,BPM_psm_didt_Coverage,(BPM_blk_addr & 13'h1FFF),BPM_gfx3d);
          else if(BPM_Coverage_psm_edc_enable)
            $fmonitor(sys.cg_file_handle, "CG BPM_COVERAGE:(%t) %m %d BPM_blk_addr:%d BPM_gfx3d:%d",$time,BPM_psm_edc_Coverage,(BPM_blk_addr & 13'h1FFF),BPM_gfx3d);
       `else
	  if(BPM_Coverage_enable) 
            $fmonitor(tb.cg_file_handle, "CG BPM_COVERAGE:(%t) %m %d BPM_blk_addr:%d BPM_gfx3d:%d",$time,BPM_Coverage,(BPM_blk_addr & 13'h1FFF),BPM_gfx3d);
          else if(BPM_Coverage_dd_enable)
            $fmonitor(tb.cg_file_handle, "CG BPM_COVERAGE:(%t) %m %d BPM_blk_addr:%d BPM_gfx3d:%d",$time,BPM_dd_Coverage,(BPM_blk_addr & 13'h1FFF),BPM_gfx3d);
          else if(BPM_Coverage_avfs_enable)
            $fmonitor(tb.cg_file_handle, "CG BPM_COVERAGE:(%t) %m %d BPM_blk_addr:%d BPM_gfx3d:%d",$time,BPM_avfs_Coverage,(BPM_blk_addr & 13'h1FFF),BPM_gfx3d);
          else if(BPM_Coverage_psm_didt_enable)
            $fmonitor(tb.cg_file_handle, "CG BPM_COVERAGE:(%t) %m %d BPM_blk_addr:%d BPM_gfx3d:%d",$time,BPM_psm_didt_Coverage,(BPM_blk_addr & 13'h1FFF),BPM_gfx3d);
          else if(BPM_Coverage_psm_edc_enable)
            $fmonitor(tb.cg_file_handle, "CG BPM_COVERAGE:(%t) %m %d BPM_blk_addr:%d BPM_gfx3d:%d",$time,BPM_psm_edc_Coverage,(BPM_blk_addr & 13'h1FFF),BPM_gfx3d);
        `endif
    `else
	if(BPM_Coverage_enable) 
          $fmonitor(tb.cg_file_handle, "CG BPM_COVERAGE:(%t) %m %d BPM_blk_addr:%d BPM_gfx3d:%d",$time,BPM_Coverage,(BPM_blk_addr & 13'h1FFF),BPM_gfx3d);
        else if(BPM_Coverage_dd_enable)
          $fmonitor(tb.cg_file_handle, "CG BPM_COVERAGE:(%t) %m %d BPM_blk_addr:%d BPM_gfx3d:%d",$time,BPM_dd_Coverage,(BPM_blk_addr & 13'h1FFF),BPM_gfx3d);
        else if(BPM_Coverage_avfs_enable)
          $fmonitor(tb.cg_file_handle, "CG BPM_COVERAGE:(%t) %m %d BPM_blk_addr:%d BPM_gfx3d:%d",$time,BPM_avfs_Coverage,(BPM_blk_addr & 13'h1FFF),BPM_gfx3d);
        else if(BPM_Coverage_psm_didt_enable)
          $fmonitor(tb.cg_file_handle, "CG BPM_COVERAGE:(%t) %m %d BPM_blk_addr:%d BPM_gfx3d:%d",$time,BPM_psm_didt_Coverage,(BPM_blk_addr & 13'h1FFF),BPM_gfx3d);
        else if(BPM_Coverage_psm_edc_enable)
          $fmonitor(tb.cg_file_handle, "CG BPM_COVERAGE:(%t) %m %d BPM_blk_addr:%d BPM_gfx3d:%d",$time,BPM_psm_edc_Coverage,(BPM_blk_addr & 13'h1FFF),BPM_gfx3d);
    `endif
end
`endif

//added for detect DD uniqueness
//enable args
reg dd_check_en;
reg dd_active;//0:inactive; 1:active; 
initial begin
    if($test$plusargs("bpm_IP_connect_assert_enable"))
        dd_check_en = enable_dd;//1'b1;
    else
        dd_check_en = 1'b0;  
    dd_active = 0;
end

`ifdef GFX_CG_W2E
final if((dd_check_en == 1'b1)&(dd_active != 1)) `MSGIO_DISPLAY("%m ERROR: DD is not active");
`else
final if((dd_check_en == 1'b1)&(dd_active != 1)) `MSGIO_DISPLAY("%m WARNING: DD is not active");
`endif

reg fgcg_check_en;
reg fgcg_activated;
reg fgcg_1d;
initial begin
    if($test$plusargs("sram_fgcg_assert_enable"))
        fgcg_check_en = 1'b1;
    else
        fgcg_check_en = 1'b0;
    fgcg_activated = 0;
    fgcg_1d = 0;
end

always @(posedge cg_gbl_sclk)   if (~RSMU_GFX_hard_resetb) fgcg_1d<=0; else fgcg_1d <= TTOP_FGCG_override;
always @(posedge cg_gbl_sclk)   if (~RSMU_GFX_hard_resetb) fgcg_activated<=0; else fgcg_activated <= (fgcg_activated | (TTOP_FGCG_override & (~fgcg_1d)));
final if((fgcg_activated == 0) && fgcg_check_en) `MSGIO_DISPLAY("%m ERROR: FGCG_override never change from 0 to 1");
final if(TTOP_FGCG_override && fgcg_check_en) `MSGIO_DISPLAY("%m ERROR: FGCG_override  was activated in the final");

`else // !`ifdef VCS

initial begin
  $display("%m at %0t: /bpm/bpm_cov.sv: SVA not yet supported in NCSIM in wekiva scripts", $realtime);
end

//VCS coverage on

`endif // VCS

// vrq translate_on

endmodule // bpm_cov


