// **********************************************************************************
//                              -*- Mode: Verilog -*-
// Filename        : bpmh.v
// Description     : Block Power Manager Hub - Distributes signaling to bpm
// Created by      : John McCardle
// Created On      : 03/22/2011
// **********************************************************************************
module bpmh
  ( /*autoarg*/
  // Outputs
  RLC_BPM_0_cmd, RLC_BPM_1_cmd, RLC_BPM_2_cmd, RLC_BPM_3_cmd, RLC_BPM_4_cmd,
  RLC_BPM_5_cmd, RLC_BPM_6_cmd, RLC_BPM_7_cmd, RLC_BPM_8_cmd, RLC_BPM_9_cmd,
  RLC_BPM_10_cmd, RLC_BPM_11_cmd, RLC_BPM_12_cmd, RLC_BPM_13_cmd, RLC_BPM_14_cmd,
  RLC_BPM_15_cmd, RLC_BPM_16_cmd, RLC_BPM_17_cmd, RLC_BPM_18_cmd, RLC_BPM_19_cmd,
  RLC_BPM_20_cmd, RLC_BPM_21_cmd, RLC_BPM_22_cmd, RLC_BPM_23_cmd, RLC_BPM_24_cmd,
  RLC_BPM_25_cmd, RLC_BPM_26_cmd, RLC_BPM_27_cmd, RLC_BPM_28_cmd, RLC_BPM_29_cmd,
  RLC_BPM_30_cmd, RLC_BPM_31_cmd, RLC_BPM_status,
  // Inputs
  Cpl_GFXCLK, RLC_BPM_cmd, RLC_BPM_0_status, RLC_BPM_1_status, RLC_BPM_2_status,
  RLC_BPM_3_status, RLC_BPM_4_status, RLC_BPM_5_status, RLC_BPM_6_status, RLC_BPM_7_status,
  RLC_BPM_8_status, RLC_BPM_9_status, RLC_BPM_10_status, RLC_BPM_11_status, RLC_BPM_12_status,
  RLC_BPM_13_status, RLC_BPM_14_status, RLC_BPM_15_status, RLC_BPM_16_status, RLC_BPM_17_status,
  RLC_BPM_18_status, RLC_BPM_19_status, RLC_BPM_20_status, RLC_BPM_21_status, RLC_BPM_22_status,
  RLC_BPM_23_status, RLC_BPM_24_status, RLC_BPM_25_status, RLC_BPM_26_status, RLC_BPM_27_status,
  RLC_BPM_28_status, RLC_BPM_29_status, RLC_BPM_30_status, RLC_BPM_31_status,
  dft_shift_clk, Dft_Clk_Gater_Aon, Dft_Clk_Gater_En
  );

input Cpl_GFXCLK;

input RLC_BPM_cmd;

output wire RLC_BPM_0_cmd;
output wire RLC_BPM_1_cmd;
output wire RLC_BPM_2_cmd;
output wire RLC_BPM_3_cmd;
output wire RLC_BPM_4_cmd;
output wire RLC_BPM_5_cmd;
output wire RLC_BPM_6_cmd;
output wire RLC_BPM_7_cmd;
output wire RLC_BPM_8_cmd;
output wire RLC_BPM_9_cmd;
output wire RLC_BPM_10_cmd;
output wire RLC_BPM_11_cmd;
output wire RLC_BPM_12_cmd;
output wire RLC_BPM_13_cmd;
output wire RLC_BPM_14_cmd;
output wire RLC_BPM_15_cmd;
output wire RLC_BPM_16_cmd;
output wire RLC_BPM_17_cmd;
output wire RLC_BPM_18_cmd;
output wire RLC_BPM_19_cmd;
output wire RLC_BPM_20_cmd;
output wire RLC_BPM_21_cmd;
output wire RLC_BPM_22_cmd;
output wire RLC_BPM_23_cmd;
output wire RLC_BPM_24_cmd;
output wire RLC_BPM_25_cmd;
output wire RLC_BPM_26_cmd;
output wire RLC_BPM_27_cmd;
output wire RLC_BPM_28_cmd;
output wire RLC_BPM_29_cmd;
output wire RLC_BPM_30_cmd;
output wire RLC_BPM_31_cmd;

input RLC_BPM_0_status;
input RLC_BPM_1_status;
input RLC_BPM_2_status;
input RLC_BPM_3_status;
input RLC_BPM_4_status;
input RLC_BPM_5_status;
input RLC_BPM_6_status;
input RLC_BPM_7_status;
input RLC_BPM_8_status;
input RLC_BPM_9_status;
input RLC_BPM_10_status;
input RLC_BPM_11_status;
input RLC_BPM_12_status;
input RLC_BPM_13_status;
input RLC_BPM_14_status;
input RLC_BPM_15_status;
input RLC_BPM_16_status;
input RLC_BPM_17_status;
input RLC_BPM_18_status;
input RLC_BPM_19_status;
input RLC_BPM_20_status;
input RLC_BPM_21_status;
input RLC_BPM_22_status;
input RLC_BPM_23_status;
input RLC_BPM_24_status;
input RLC_BPM_25_status;
input RLC_BPM_26_status;
input RLC_BPM_27_status;
input RLC_BPM_28_status;
input RLC_BPM_29_status;
input RLC_BPM_30_status;
input RLC_BPM_31_status;

input Dft_Clk_Gater_Aon;
input Dft_Clk_Gater_En;
input dft_shift_clk;

output wire RLC_BPM_status;

parameter CHAIN_NUM = 16;

  wire     status_0_q;
  wire     status_1_q;
  wire     status_2_q;
  wire     status_3_q;
  wire     status_4_q;
  wire     status_5_q;
  wire     status_6_q;
  wire     status_7_q;
  wire     status_8_q;
  wire     status_9_q;
  wire     status_10_q;
  wire     status_11_q;
  wire     status_12_q;
  wire     status_13_q;
  wire     status_14_q;
  wire     status_15_q;
  wire     status_16_q;
  wire     status_17_q;
  wire     status_18_q;
  wire     status_19_q;
  wire     status_20_q;
  wire     status_21_q;
  wire     status_22_q;
  wire     status_23_q;
  wire     status_24_q;
  wire     status_25_q;
  wire     status_26_q;
  wire     status_27_q;
  wire     status_28_q;
  wire     status_29_q;
  wire     status_30_q;
  wire     status_31_q;

generate
  if(CHAIN_NUM == 16) begin
  assign RLC_BPM_16_cmd = 1'b0;
  assign RLC_BPM_17_cmd = 1'b0;
  assign RLC_BPM_18_cmd = 1'b0;
  assign RLC_BPM_19_cmd = 1'b0;
  assign RLC_BPM_20_cmd = 1'b0;
  assign RLC_BPM_21_cmd = 1'b0;
  assign RLC_BPM_22_cmd = 1'b0;
  assign RLC_BPM_23_cmd = 1'b0;
  assign RLC_BPM_24_cmd = 1'b0;
  assign RLC_BPM_25_cmd = 1'b0;
  assign RLC_BPM_26_cmd = 1'b0;
  assign RLC_BPM_27_cmd = 1'b0;
  assign RLC_BPM_28_cmd = 1'b0;
  assign RLC_BPM_29_cmd = 1'b0;
  assign RLC_BPM_30_cmd = 1'b0;
  assign RLC_BPM_31_cmd = 1'b0;
  end
endgenerate

  wire     or_status;

gfx_cgtt_local #(.enable_dftcgmg_gate_merge(1), .enable_dcg(0), .enable_rcg(0)) ucgtt_local (
  // Outputs
   .static_oclk    (aon_Cpl_GFXCLK)
  ,.dyn_oclk       ()
  ,.reg_oclk       ()
  ,.dyn_oclk_vld   ()
  ,.reg_oclk_vld   ()
  ,.p1_mem_power_ctrl0  ()
  // Inputs
  ,.Cpl_GFXCLK                  (Cpl_GFXCLK)
  ,.dft_clk_gate_ctrl           ({Dft_Clk_Gater_En, Dft_Clk_Gater_Aon})
  ,.dft_shift_clk               (dft_shift_clk)

  ,.resetb                      (1'b0)
  ,.iclk                        (1'b0)
  ,.cgcg_en                     (1'b1)  // tied to 1 to override CGCG feature
  ,.cg_override                 (1'b0)
  ,.core_busy                   (1'b0)
  ,.reg_busy                    (1'b0)
  ,.mgls_override               (1'b0)
  ,.mgls_current_frequency_code (4'b0)
  ,.TTOP_P1_mem_power_ctrl      (42'd0)
  ,.CGTT_BLK_CTRL_REG           (32'd0)
  ,.stall                       (1'b0)
);


ati_dff_out #(1) cmd_reg0  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_0_cmd));
ati_dff_out #(1) cmd_reg1  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_1_cmd));
ati_dff_out #(1) cmd_reg2  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_2_cmd));
ati_dff_out #(1) cmd_reg3  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_3_cmd));
ati_dff_out #(1) cmd_reg4  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_4_cmd));
ati_dff_out #(1) cmd_reg5  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_5_cmd));
ati_dff_out #(1) cmd_reg6  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_6_cmd));
ati_dff_out #(1) cmd_reg7  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_7_cmd));
ati_dff_out #(1) cmd_reg8  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_8_cmd));
ati_dff_out #(1) cmd_reg9  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_9_cmd));
ati_dff_out #(1) cmd_reg10 (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_10_cmd));
ati_dff_out #(1) cmd_reg11 (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_11_cmd));
ati_dff_out #(1) cmd_reg12 (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_12_cmd));
ati_dff_out #(1) cmd_reg13 (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_13_cmd));
ati_dff_out #(1) cmd_reg14 (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_14_cmd));
ati_dff_out #(1) cmd_reg15 (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_15_cmd));

generate
  if(CHAIN_NUM == 32) begin
ati_dff_out #(1) cmd_reg16  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_16_cmd));
ati_dff_out #(1) cmd_reg17  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_17_cmd));
ati_dff_out #(1) cmd_reg18  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_18_cmd));
ati_dff_out #(1) cmd_reg19  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_19_cmd));
ati_dff_out #(1) cmd_reg20  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_20_cmd));
ati_dff_out #(1) cmd_reg21  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_21_cmd));
ati_dff_out #(1) cmd_reg22  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_22_cmd));
ati_dff_out #(1) cmd_reg23  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_23_cmd));
ati_dff_out #(1) cmd_reg24  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_24_cmd));
ati_dff_out #(1) cmd_reg25  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_25_cmd));
ati_dff_out #(1) cmd_reg26  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_26_cmd));
ati_dff_out #(1) cmd_reg27  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_27_cmd));
ati_dff_out #(1) cmd_reg28  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_28_cmd));
ati_dff_out #(1) cmd_reg29  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_29_cmd));
ati_dff_out #(1) cmd_reg30  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_30_cmd));
ati_dff_out #(1) cmd_reg31  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_cmd), .q(RLC_BPM_31_cmd));
  end
endgenerate

ati_dff_in #(1) RLC_BPM__reg0  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_0_status),  .q(status_0_q));
ati_dff_in #(1) RLC_BPM__reg1  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_1_status),  .q(status_1_q));
ati_dff_in #(1) RLC_BPM__reg2  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_2_status),  .q(status_2_q));
ati_dff_in #(1) RLC_BPM__reg3  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_3_status),  .q(status_3_q));
ati_dff_in #(1) RLC_BPM__reg4  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_4_status),  .q(status_4_q));
ati_dff_in #(1) RLC_BPM__reg5  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_5_status),  .q(status_5_q));
ati_dff_in #(1) RLC_BPM__reg6  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_6_status),  .q(status_6_q));
ati_dff_in #(1) RLC_BPM__reg7  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_7_status),  .q(status_7_q));
ati_dff_in #(1) RLC_BPM__reg8  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_8_status),  .q(status_8_q));
ati_dff_in #(1) RLC_BPM__reg9  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_9_status),  .q(status_9_q));
ati_dff_in #(1) RLC_BPM__reg10 (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_10_status), .q(status_10_q));
ati_dff_in #(1) RLC_BPM__reg11 (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_11_status), .q(status_11_q));
ati_dff_in #(1) RLC_BPM__reg12 (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_12_status), .q(status_12_q));
ati_dff_in #(1) RLC_BPM__reg13 (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_13_status), .q(status_13_q));
ati_dff_in #(1) RLC_BPM__reg14 (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_14_status), .q(status_14_q));
ati_dff_in #(1) RLC_BPM__reg15 (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_15_status), .q(status_15_q));

generate
  if(CHAIN_NUM == 32) begin
ati_dff_in #(1) RLC_BPM__reg16  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_16_status),  .q(status_16_q));
ati_dff_in #(1) RLC_BPM__reg17  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_17_status),  .q(status_17_q));
ati_dff_in #(1) RLC_BPM__reg18  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_18_status),  .q(status_18_q));
ati_dff_in #(1) RLC_BPM__reg19  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_19_status),  .q(status_19_q));
ati_dff_in #(1) RLC_BPM__reg20  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_20_status),  .q(status_20_q));
ati_dff_in #(1) RLC_BPM__reg21  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_21_status),  .q(status_21_q));
ati_dff_in #(1) RLC_BPM__reg22  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_22_status),  .q(status_22_q));
ati_dff_in #(1) RLC_BPM__reg23  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_23_status),  .q(status_23_q));
ati_dff_in #(1) RLC_BPM__reg24  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_24_status),  .q(status_24_q));
ati_dff_in #(1) RLC_BPM__reg25  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_25_status),  .q(status_25_q));
ati_dff_in #(1) RLC_BPM__reg26  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_26_status),  .q(status_26_q));
ati_dff_in #(1) RLC_BPM__reg27  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_27_status),  .q(status_27_q));
ati_dff_in #(1) RLC_BPM__reg28  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_28_status),  .q(status_28_q));
ati_dff_in #(1) RLC_BPM__reg29  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_29_status),  .q(status_29_q));
ati_dff_in #(1) RLC_BPM__reg30  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_30_status),  .q(status_30_q));
ati_dff_in #(1) RLC_BPM__reg31  (.clk(aon_Cpl_GFXCLK), .d(RLC_BPM_31_status),  .q(status_31_q));
  end
endgenerate

generate
  if(CHAIN_NUM == 32) begin
assign or_status = status_0_q  | status_1_q  | status_2_q  | status_3_q  | status_4_q  | status_5_q  | 
                   status_6_q  | status_7_q  | status_8_q  | status_9_q  | status_10_q | status_11_q |
                   status_12_q | status_13_q | status_14_q | status_15_q | status_16_q | status_17_q |
                   status_18_q | status_19_q | status_20_q | status_21_q | status_22_q | status_23_q |
                   status_24_q | status_25_q | status_26_q | status_27_q | status_28_q | status_29_q |
                   status_30_q | status_31_q;
  end
  else begin
assign or_status = status_0_q  | status_1_q  | status_2_q  | status_3_q  |
                   status_4_q  | status_5_q  | status_6_q  | status_7_q  |
                   status_8_q  | status_9_q  | status_10_q | status_11_q |
                   status_12_q | status_13_q | status_14_q | status_15_q ;
  end
endgenerate

ati_dff_out #(1) status__reg (.clk(aon_Cpl_GFXCLK), .d(or_status), .q(RLC_BPM_status));

endmodule // bpmh
