module cac_sync_pulse (
   input SRC_CLK,
   input SRC_RESET,
   input SRC_PULSE,
   input DST_CLK,
   output wire DST_PULSE
);

reg  sync_in;
wire sync_out;
wire dst_reset;
reg  sync_out_d;

always @(posedge SRC_CLK) sync_in <= SRC_RESET ? 1'b0 : SRC_PULSE ^ sync_in;

techind_sync_icd #(.depth (3)) sync_data   (.CKdst(DST_CLK), .Dsrc(sync_in), .Qdst(sync_out),
                              .SB(1'b1), .RB(1'b1), .FLUSH(1'b0), .CKsrc(1'b0), .EN(1'b1), .Qsrc(),
                              .SC1(1'b0), .SC2(1'b0), .SE(1'b0), .SI(1'b0), .SO()
`ifdef ABV
                              ,.InputChkDis(1'b0)
`endif
);
techind_sync_icd #(.depth (3)) sync_reset  (.CKdst(DST_CLK), .Dsrc(SRC_RESET), .Qdst(dst_reset),
                              .SB(1'b1), .RB(1'b1), .FLUSH(1'b0), .CKsrc(1'b0), .EN(1'b1), .Qsrc(),
                              .SC1(1'b0), .SC2(1'b0), .SE(1'b0), .SI(1'b0), .SO()
`ifdef ABV
                              ,.InputChkDis(1'b0)
`endif
);

always @(posedge DST_CLK) sync_out_d <= sync_out;

assign DST_PULSE = ~dst_reset & (sync_out_d ^ sync_out);

endmodule

