// ==============================================================================================
// PLEASE DONOT CHANGES THIS FILE
// THIS FILE IS AUTO_GENERATED
// Source: import/address/src/rtl/gen_one/cb_cmask_addr_calc.v
// ===============================================================================================
// Filename              : now cb_cmask_10xx_addr_calc.v
// Perforce changelist   : $Change$
//
// Copyright             : Trade secret of AMD, Inc.
//                         Copyright 2008, AMD, Inc., (unpublished)
//                         All rights reserved.  This notice is intended as a precaution against
//                         inadvertent publication and does not imply publication or any waiver
//                         of confidentiality.  The year included in the foregoing notice is the
//                         year of creation of the work.
//
// RTL author: kevin.gu
//
// Description: address calc for cmask
// according to si memory addressing spec

`include "addrlib_defines_gc.vh"
module  cb_cmask_addr_calc_gc(/*AUTOARG*/
   // Outputs
   cmask_address,
   busy, 
   // Inputs
   tx, ty, z, baseAddr256B, cmask_block_max, pitch_tile_max,
   pipe_interleave_size, pipe_config, linear, 
   sclk,
   iRTS,
oRTR,
oRTS,
iRTR,
pass_thru_data_in,
pass_thru_data_out,
srst
,input_en
,output_en
   );

parameter PASSTHRU_WIDTH 		= 1;	// Bus Width of the pass through data
parameter COLLAPSABLE_PIPE_STAGE = 1;   // COLLAPSABLE/NONCOLLAPSABLE, 1/0
parameter RI=1;
parameter RO=1;

localparam CALC_STAGES = `BC_CMASK_CALC_OLD_STAGES; //number of "core" stages to calculate "outputs"
parameter PAD_STAGES = (`META_FULL_STAGES - CALC_STAGES);

//--------------------------------------------------------------------
// IO ports definitions
//--------------------------------------------------------------------   
input [10:0]                tx;//in tiles
input [10:0]                ty;//in tiles
input [10:0]                z;//slice number

input [31:0]                baseAddr256B;//base addr, 256B aligned
input [11+11-8-1:0]         cmask_block_max;// (pitch_tiles * height_tiles)/cl_size -1, where cl_size is 256 
input [10:0]                pitch_tile_max;//surface_pitch - 1, in tiles

input [ 2:0]                pipe_interleave_size;
input [ 4:0]                pipe_config;
input                       linear;

input                       sclk;
input                       srst;

output [40:0]               cmask_address;//nibble address
output                      busy;
input                       input_en;
output                      output_en;

// =-=-=-=-=- RTR/RTS interface support
input 						iRTS;
output  					oRTR;
input  [PASSTHRU_WIDTH-1:0]	pass_thru_data_in; //pass through data bus, pipelined PIPE_STAGES and enabled by (<pipe_stage_enable> & ~stall)

output 						oRTS;
input  						iRTR;
output [PASSTHRU_WIDTH-1:0]	pass_thru_data_out;

localparam TOTAL_PAD_STAGES = RO+PAD_STAGES;
localparam PIPE_STAGES = RI + CALC_STAGES + TOTAL_PAD_STAGES;

logic [10:0]        tx_in,                   tx_reg;
logic [10:0]        ty_in,                   ty_reg;
logic [10:0]        z_in,                    z_reg;
logic [31:0]        baseAddr256B_in,         baseAddr256B_reg;   
logic [11+11-8-1:0] cmask_block_max_in,      cmask_block_max_reg;
logic [10:0]        pitch_tile_max_in,       pitch_tile_max_reg; 
logic [ 2:0]        pipe_interleave_size_in, pipe_interleave_size_reg;
logic [ 4:0]        pipe_config_in,          pipe_config_reg;
logic               linear_in,               linear_reg;

wire [PIPE_STAGES-1:0] en_stage;

always @(posedge sclk)
begin
    if(en_stage[0])
     begin
        tx_reg                   <= tx;
        ty_reg                   <= ty;
        z_reg                    <= z;
        baseAddr256B_reg         <= baseAddr256B;
        cmask_block_max_reg      <= cmask_block_max;
        pitch_tile_max_reg       <= pitch_tile_max;
        pipe_interleave_size_reg <= pipe_interleave_size;
        pipe_config_reg          <= pipe_config;
        linear_reg               <= linear;
     end
end

assign tx_in                    = (RI)? tx_reg                   : tx;
assign ty_in                    = (RI)? ty_reg                   : ty;
assign z_in                     = (RI)? z_reg                    : z;
assign baseAddr256B_in          = (RI)? baseAddr256B_reg         : baseAddr256B;
assign cmask_block_max_in       = (RI)? cmask_block_max_reg      : cmask_block_max;
assign pitch_tile_max_in        = (RI)? pitch_tile_max_reg       : pitch_tile_max;
assign pipe_interleave_size_in  = (RI)? pipe_interleave_size_reg : pipe_interleave_size;
assign pipe_config_in           = (RI)? pipe_config_reg          : pipe_config;
assign linear_in                = (RI)? linear_reg               : linear;
       

addrlib_px_stage_gc #(.COLLAPSIBLE(COLLAPSABLE_PIPE_STAGE), .WIDTH(PASSTHRU_WIDTH), .DEPTH(PIPE_STAGES))
    px_stage(
			  // Outputs
			  .oRTR			(oRTR),
			  .oRTS			(oRTS),
			  .oDATA		(pass_thru_data_out[PASSTHRU_WIDTH-1:0]),
			  .pipe_stage_en (en_stage[PIPE_STAGES-1:0]),
			  .busy 		(busy),
			  // Inputs
			  .iCLK			(sclk),
			  .iRESET		(srst),
			  .iRTS			(iRTS),
			  .iDATA		(pass_thru_data_in[PASSTHRU_WIDTH-1:0]),
			  .iRTR			(iRTR)
              ,.i_en        (input_en)
              ,.o_en        (output_en)
        );
// =-=-=-=-=- End if RTR/RTS interface support

   wire   [40:0] cmask_address;

// register all inputs
   reg [10:0] tx_h1;//in tiles
   reg [10:0] ty_h1;//in tiles
   reg [10:0] z_h1;//slice number

   reg [31:0] baseAddr256B_h1;//base addr, 256B aligned
   reg [11+11-8-1:0] cmask_block_max_h1;// (pitch_tiles * height_tiles)/cl_size -1, where cl_size is 256 
   reg [10:0] pitch_tile_max_h1;//surface_pitch - 1, in tiles

   reg [ 2:0] 	 pipe_interleave_size_h1;
   reg 	  [ 4:0] pipe_config_h1;

// pipe config decode before first flop stage to break up timing path
   reg    [ 2 :0]   log2pipes;
   reg    [ 2 :0]   log2pipes_h1;
   
   always@(*) begin
     case(pipe_config_in[4:0])   // 16-pipes
     5'b00000: log2pipes = 3'b001; //2 pipes
     5'b00100: log2pipes = 3'b010; //4 pipes
     5'b00101: log2pipes = 3'b010; //4 pipes
     5'b00110: log2pipes = 3'b010; //4 pipes
     5'b00111: log2pipes = 3'b010; //4 pipes
     5'b01000: log2pipes = 3'b011; //8 pipes
     5'b01001: log2pipes = 3'b011; //8 pipes
     5'b01010: log2pipes = 3'b011; //8 pipes
     5'b01011: log2pipes = 3'b011; //8 pipes
     5'b01100: log2pipes = 3'b011; //8 pipes
     5'b01101: log2pipes = 3'b011; //8 pipes
     5'b01110: log2pipes = 3'b011; //8 pipes
  	 5'b10010: log2pipes = 3'b100; //16 pipes
     //VCS coverage off
     default:  log2pipes = 3'b011; //default to be 8 pipes
     //VCS coverage on
     endcase
   end

   reg    [1:0]   macro_shift;

   always@(*) begin
     case(log2pipes)  // 16-pipes
     3'b001:   macro_shift = 2'd3;
     3'b010:   macro_shift = 2'd2;
     3'b011:   macro_shift = 2'd1;     
     3'b100:   macro_shift = 2'd0;     
     //VCS coverage off
     default: macro_shift = 2'd1; //default to be 8 pipes
     //VCS coverage on
     endcase
   end

//cl_x = linear? 0: tx/cl_width
//cl_y = linear? 0: ty/cl_height
   wire  [10-5:0]  cl_x_tiled = (log2pipes == 3'b001)? tx_in[10:5]:              //tx/32
                                (log2pipes == 3'b010)? tx_in[10:5]:              //tx/32
                                (log2pipes == 3'b011)? tx_in[10:6]: tx_in[10:6]; //tx/64, or 16-pipes: tx/64
   wire  [10-4:0]  cl_y_tiled = (log2pipes == 3'b001)? ty_in[10:4]:              //ty/16
                                (log2pipes == 3'b010)? ty_in[10:5]:              //ty/32
                                (log2pipes == 3'b011)? ty_in[10:5]: ty_in[10:6]; //ty/32 or 16-pipes: ty/64
   wire  [10-5:0]  cl_x = linear_in? 0: cl_x_tiled;
   wire  [10-4:0]  cl_y = linear_in? 0: cl_y_tiled; 


//cl_size is 256 tiles per cacheline for cmask

//surf_pitch_cl = linear? surface_pitch/4 : surface_pitch/cl_width
//surf_height_cl = linear? 4*surface_height/(cl_size*pipes) : surface_height/cl_height

//*******kgu: do pitch align   //comment out   wire  [11:0]    surface_pitch = pitch_tile_max + 1; 
//*******new picth code for align ********//
//*******tile mode  align ********//
   wire  [2:0]  pitch_shift_size  = (log2pipes == 3'b001)? 3'd5 : 
                                    (log2pipes == 3'b010)? 3'd5 :
                                    (log2pipes == 3'b011)? 3'd6 : 3'd6;// 16-pipes: /64
                                     
   wire  [6:0]      pitch_tile_max_shifted = (pitch_tile_max_in >> pitch_shift_size) + 1;   
   wire  [11:0]     pitch_tile_max_aligned = pitch_tile_max_shifted << pitch_shift_size;

//********linear mode align ********//
   wire  [1:0]     pitch_shift_size_linear = (pipe_config_in[4:0] == 5'b01110 ||
                                              pipe_config_in[4:0] == 5'b01101 ||
                                              pipe_config_in[4:0] == 5'b01100 ||
                                              pipe_config_in[4:0] == 5'b01010 ||
                                              pipe_config_in[4:0] == 5'b10010 ||
                                              pipe_config_in[4:0] == 5'b00111) ? 2'd3 : 2'd2;  
   wire  [9:0]     pitch_tile_max_shifted_linear = (pitch_tile_max_in >> pitch_shift_size_linear) + 1; 
   wire  [11:0]    pitch_tile_max_aligned_linear = pitch_tile_max_shifted_linear << pitch_shift_size_linear;


//********get aligned pitch tile max *******//
   wire  [11:0]    surface_pitch = linear_in? pitch_tile_max_aligned_linear : pitch_tile_max_aligned;
   
   
   wire  [11-2:0]  surf_pitch_cl_linear = surface_pitch[11:2];
   wire  [11-5:0]  surf_pitch_cl_tiled = (log2pipes == 3'b001)? surface_pitch[11:5]:
                                         (log2pipes == 3'b010)? surface_pitch[11:5]:
                                         (log2pipes == 3'b011)? surface_pitch[11:6]:surface_pitch[11:6]; //16-pipes
   wire  [11-2:0]  surf_pitch_cl = linear_in? surf_pitch_cl_linear : surf_pitch_cl_tiled; 
 
//cl_offset = (cl_x + surf_pitch_cl *(cl_y + surf_height_cl * slice)) * cl_size 
//          = (cl_x + surf_pitch_cl * cl_y + surf_pitch_cl * surf_height_cl * slice)*cl_size
//          = (cl_x + surf_pitch_cl * cl_y)*cl_size + surf_pitch_cl * surf_height_cl * slice*cl_size  

//surf_pitch_cl * surf_height_cl = linear? surface_pitch * surface_height/(cl_size*pipes): surface_pitch * surface_height/(cl_width*cl_height) 
//for linear:
//cl_offset = (cl_x + surf_pitch_cl * cl_y)*cl_size + (surf_size_cl/pipes) * slice *cl_size
//for tiled:
//cl_offset = (cl_x + surf_pitch_cl * cl_y)*cl_size + (surf_size_cl/pipes) * slice *cl_size
//here, cl_size = 256 



   wire  [21+1-8:0]  surf_size_cl = cmask_block_max_in + 1;//it is the easiest way to implement algrithm 
//here we know linear is not a must if cmask is already padded as required


// surf_size_cl_bypipes shows up in timing paths

  wire   [13:0]  surf_size_cl_bypipes = (log2pipes == 3'b001)? surf_size_cl[14:1]:
                                        (log2pipes == 3'b010)? surf_size_cl[14:2]:
                                        (log2pipes == 3'b011)? surf_size_cl[14:3]:surf_size_cl[14:4]; // 16-pipes

   wire  [17+3:0]  cl_offset_in_cacheline = surf_pitch_cl * cl_y  + cl_x;//17+6 
   wire  [24:0]  surf_offset_in_cl = surf_size_cl_bypipes * z_in;
   wire  [25:0]  cl_offset_in_cl = cl_offset_in_cacheline + surf_offset_in_cl;
   wire  [25+8:0]   cl_offset_in_tiles = {cl_offset_in_cl, 8'h0};
 
//macro_x = (linear?tile_x: tile_x % cl_width )/4
//macro_y = (linear?tile_y: tile_y % cl_height) /4
//macro_pitch = (linear? surface_pitch : cl_width)/4
//macro_offset = (macro_x + macro_y * macro_pitch) << macro_shift
//macro_offset[tile_offset_bits -1 :0] = tile_offset
   wire  [10-2:0]  macro_x_linear = tx_in[10:2];
   wire  [5-2:0]   macro_x_tiled = (log2pipes == 3'b001)? tx_in[4:2]:
                                   (log2pipes == 3'b010)? tx_in[4:2]:
                                   (log2pipes == 3'b011)? tx_in[5:2]: tx_in[5:2]; // 16-pipes

   wire  [10-2:0]  macro_x = linear_in ? macro_x_linear : macro_x_tiled;
   wire  [10-2:0]  macro_y_linear = ty_in[10:2];
   wire  [5-2:0]   macro_y_tiled = (log2pipes == 3'b001)? ty_in[3:2]:
                                   (log2pipes == 3'b010)? ty_in[4:2]:                          
                                   (log2pipes == 3'b011)? ty_in[4:2]: ty_in[5:2];  // 16-pipes
   wire  [10-2:0]  macro_y = linear_in ? macro_y_linear : macro_y_tiled;
   wire  [11:0]    macro_pitch_linear = surface_pitch[11:2];
   wire  [5:0]     macro_pitch_tiled = (log2pipes == 3'b001)? 5'd8:
                                       (log2pipes == 3'b010)? 5'd8:
                                       (log2pipes == 3'b011)? 5'd16: 6'd16;  // 16-pipes
   wire  [11:0]    macro_pitch = linear_in ? macro_pitch_linear : macro_pitch_tiled;
   wire  [24:0]    macro_offset_t = (macro_y * macro_pitch + macro_x) << macro_shift;//22 + 3  


   reg   [24:0]    macro_offset;

   wire [2:0]      toffset;
   coordtotileoffset_gc coordtotileoffset( 
	   .sx({tx_in[1:0], 3'b000}), 
	   .sy({ty_in[1:0], 3'b000}), 
	   .pipe_config(pipe_config_in[4:0]),
       .tile_offset_0(toffset), 
	   .tile_offset_bits_0(), 
	   .macro_shift_0() 
       );

   reg [2:0]  toffset_h1;
   reg [24:0] macro_offset_t_h1;
   reg [25+8:0] cl_offset_in_tiles_h1;
   
// cut logic here on into stage between _h1 and _h1 
// 
// ----------------------- logic between h1 and h2 stages: ---------------------------------------
// -----------------------------------------------------------------------------------------------

   always@(*) begin
     case(pipe_config_h1[4:0])  // 16-pipes
     5'b00000: macro_offset = {macro_offset_t_h1[24:3],toffset_h1[2:0]};//2'd3; //2 pipes
     5'b00100: macro_offset = {macro_offset_t_h1[24:2],toffset_h1[1:0]};//2'd2; //4 pipes
     5'b00101: macro_offset = {macro_offset_t_h1[24:2],toffset_h1[1:0]};//2'd2; //4 pipes
     5'b00110: macro_offset = {macro_offset_t_h1[24:2],toffset_h1[1:0]};//2'd2; //4 pipes
     5'b00111: macro_offset = {macro_offset_t_h1[24:3],toffset_h1[2:0]};//2'd3; //4 pipes
     5'b01000: macro_offset = {macro_offset_t_h1[24:1],toffset_h1[0]};//2'd1; //8 pipes
     5'b01001: macro_offset = {macro_offset_t_h1[24:1],toffset_h1[0]};//2'd1; //8 pipes
     5'b01010: macro_offset = {macro_offset_t_h1[24:2],toffset_h1[1:0]};//2'd2; //8 pipes
     5'b01011: macro_offset = {macro_offset_t_h1[24:1],toffset_h1[0]};//2'd1; //8 pipes
     5'b01100: macro_offset = {macro_offset_t_h1[24:2],toffset_h1[1:0]};//2'd2; //8 pipes
     5'b01101: macro_offset = {macro_offset_t_h1[24:2],toffset_h1[1:0]};//2'd2; //8 pipes
     5'b01110: macro_offset = {macro_offset_t_h1[24:3],toffset_h1[2:0]};//2'd3; //8 pipes
     5'b10010: macro_offset = {macro_offset_t_h1[24:2],toffset_h1[1:0]}; //16 pipess
     //VCS coverage off
     default:  macro_offset = {macro_offset_t_h1[24:3],toffset_h1[2:0]}; //default to be 8 pipes
     //VCS coverage on
     endcase
   end

  reg  [31:0]   baseAddr256B_extract;
  always@(*) begin
    case({pipe_interleave_size_h1[0], log2pipes_h1})  // 16-pipes
      4'b0001: baseAddr256B_extract = {baseAddr256B_h1[31:1]}; //256, 2-pipe
      4'b0010: baseAddr256B_extract = {baseAddr256B_h1[31:2]}; //256, 4-pipe
      4'b0011: baseAddr256B_extract = {baseAddr256B_h1[31:3]}; //256, 8-pipe
      4'b0100: baseAddr256B_extract = {baseAddr256B_h1[31:4]}; //256, 16-pipe
      4'b1001: baseAddr256B_extract = {baseAddr256B_h1[31:2], baseAddr256B_h1[0]}; //512, 2-pipe
      4'b1010: baseAddr256B_extract = {baseAddr256B_h1[31:3], baseAddr256B_h1[0]}; //512, 4-pipe
      4'b1011: baseAddr256B_extract = {baseAddr256B_h1[31:4], baseAddr256B_h1[0]}; //512, 8-pipe
      4'b1100: baseAddr256B_extract = {baseAddr256B_h1[31:5], baseAddr256B_h1[0]}; //512, 16-pipe
      default:baseAddr256B_extract = {baseAddr256B_h1[31:4], baseAddr256B_h1[0]}; //512, 8-pipe
  endcase
  end

  wire  [34:0]  tile_number = cl_offset_in_tiles_h1 + macro_offset;
//  reg 	[0:0]	tile_number_h1;
   
  wire  [39:0]  device_addr = {baseAddr256B_extract, 8'h0} + (tile_number>>1) ;

  //assemble addr
  reg   [ 3: 0]  pipe_number_0;

// For this new setting (ADDR_SURF_P16), the pipe select P is calculated in the addrlib as.
// P[0] = x[3] ^ y[3] ^ x[4] ->   tx_in[0] ^ ty_in[0] ^ tx_in[1]
// P[1] = x[4] ^ y[4]			  tx_in[1] ^ ty_in[1]
// P[2] = x[5] ^ y[5]			  tx_in[2] ^ ty_in[2]
// P[3] = x[6] ^ y[5]			  tx_in[3] ^ ty_in[2]
// If GFX_BACK_COMPAT.ENABLE == 1, then PIPE_CONFIG==18 will revert to P8_32x32_16x16.
    always@(*) begin
      case(pipe_config_h1[4:0])  // 16-pipes
      5'b00000: pipe_number_0 = {3'h0, tx_h1[0]^ty_h1[0]};
      5'b00100: pipe_number_0 = {2'h0, tx_h1[0]^ty_h1[1], tx_h1[1]^ty_h1[0]};
      5'b00101: pipe_number_0 = {2'h0, tx_h1[1]^ty_h1[1], tx_h1[0]^ty_h1[0]^tx_h1[1]};
      5'b00110: pipe_number_0 = {2'h0, tx_h1[1]^ty_h1[2], tx_h1[0]^ty_h1[0]^tx_h1[1]};
      5'b00111: pipe_number_0 = {2'h0, tx_h1[2]^ty_h1[2], tx_h1[0]^ty_h1[0]^tx_h1[2]};
      5'b01000: pipe_number_0 = {1'h0, tx_h1[1]^ty_h1[1], tx_h1[0]^ty_h1[2], tx_h1[1]^ty_h1[0]^tx_h1[2]};
      5'b01001: pipe_number_0 = {1'h0, tx_h1[1]^ty_h1[2], tx_h1[0]^ty_h1[1], tx_h1[1]^ty_h1[0]^tx_h1[2]};
      5'b01010: pipe_number_0 = {1'h0, tx_h1[2]^ty_h1[2], tx_h1[0]^ty_h1[1], tx_h1[1]^ty_h1[0]^tx_h1[2]};
      5'b01011: pipe_number_0 = {1'h0, tx_h1[1]^ty_h1[2], tx_h1[2]^ty_h1[1], tx_h1[0]^ty_h1[0]^tx_h1[1]};
      5'b01100: pipe_number_0 = {1'h0, tx_h1[2]^ty_h1[2], tx_h1[1]^ty_h1[1], tx_h1[0]^ty_h1[0]^tx_h1[1]};
      5'b01101: pipe_number_0 = {1'h0, tx_h1[2]^ty_h1[2], tx_h1[1]^ty_h1[3], tx_h1[0]^ty_h1[0]^tx_h1[1]};
      5'b01110: pipe_number_0 = {1'h0, tx_h1[2]^ty_h1[3], tx_h1[3]^ty_h1[2], tx_h1[0]^ty_h1[0]^tx_h1[2]};
      5'b10010: pipe_number_0 = {tx_h1[3]^ty_h1[2], tx_h1[2]^ty_h1[2], tx_h1[1]^ty_h1[1], tx_h1[0]^ty_h1[0]^tx_h1[1]};
      //VCS coverage off
      default:  pipe_number_0 = 0;
      //VCS coverage on
      endcase
    end
   
  reg   [39:0]   final_byte_addr;
  always@(*)begin
  case({pipe_interleave_size_h1[0], log2pipes_h1})  // 16-pipes
    4'b0001: final_byte_addr = {device_addr[38:8], pipe_number_0[0],   device_addr[7:0]}; //256, 2-pipe
    4'b0010: final_byte_addr = {device_addr[37:8], pipe_number_0[1:0], device_addr[7:0]}; //256, 4-pipe
    4'b0011: final_byte_addr = {device_addr[36:8], pipe_number_0[2:0], device_addr[7:0]}; //256, 8-pipe
    4'b0100: final_byte_addr = {device_addr[35:8], pipe_number_0[3:0], device_addr[7:0]}; //256, 8-pipe

    4'b1001: final_byte_addr = {device_addr[38:9], pipe_number_0[0],   device_addr[8:0]}; //512, 2-pipe
    4'b1010: final_byte_addr = {device_addr[37:9], pipe_number_0[1:0], device_addr[8:0]}; //512, 4-pipe
    4'b1011: final_byte_addr = {device_addr[36:9], pipe_number_0[2:0], device_addr[8:0]}; //512, 8-pipe
    4'b1100: final_byte_addr = {device_addr[35:9], pipe_number_0[3:0], device_addr[8:0]}; //512, 8-pipe

    default: final_byte_addr = {device_addr[36:9], pipe_number_0[2:0], device_addr[8:0]}; //512, 8-pipe
  endcase
  end

  wire [40:0] finalAddress = {final_byte_addr, tile_number[0]};
   
  /************pipe stage 1 ***************/
    always @(posedge sclk)
    begin
        if(en_stage[RI]) begin
           // register inputs
	       tx_h1 <= tx_in;
           ty_h1 <= ty_in;
           z_h1 <= z_in;

           baseAddr256B_h1 <= baseAddr256B_in;
           cmask_block_max_h1 <= cmask_block_max_in;
           pitch_tile_max_h1 <= pitch_tile_max_in;

           pipe_interleave_size_h1[0] <= pipe_interleave_size_in[0]; // used bit 0 only, remove extra bits
           pipe_config_h1 <= pipe_config_in;
	   
           // others some work done to create these before the h1 stage cb_cm drives with flops so this should have
	   // plenty of input delay slack
           log2pipes_h1 <= log2pipes; 
           toffset_h1 <= toffset;
           macro_offset_t_h1 <= macro_offset_t;
	   cl_offset_in_tiles_h1 <= cl_offset_in_tiles;
        end
    end



// =-=-=-=-=-=-= O U T P U T   calculation =-=-=-=-=-=-=-=-
logic [40:0]  address_out_stages[TOTAL_PAD_STAGES:0];
int i;
always @(posedge sclk)
begin 
      for(i=0;i<TOTAL_PAD_STAGES;i=i+1) begin
        if(en_stage[RI+CALC_STAGES+i]) 
            if(i==0) address_out_stages[i+1] <= finalAddress;
            else     address_out_stages[i+1] <= address_out_stages[i];
      end
end
localparam INSERT_PAD_STAGES = (TOTAL_PAD_STAGES > 'd0);
assign cmask_address = (INSERT_PAD_STAGES)? address_out_stages[TOTAL_PAD_STAGES] : finalAddress;

`ifdef ADDRESS__ADDRLIB_REPLAY_DEBUG__1
    cb_cmask_addr_calc_replay_gc repaly(.*);
`endif

endmodule
