`include "msgio_defines.vh"
module cgts_local_cntl_cov
	(
	 // Inputs to cgts_local_cntl
	 simdbusy_soft_override, ls_soft_override, cg_soft_override, busy_override, iclk,resetb
	 );
//////////////////////////
input           simdbusy_soft_override;
input           ls_soft_override;
input           cg_soft_override;
input [1:0]     busy_override;
input           iclk;
input resetb;
//////////////////////////
//VCS coverage exclude_module
`ifdef VCS
reg enable;
initial begin
  if($test$plusargs("cgt_assert_disable"))
    enable = 1'b0;
  else
    enable = 1'b1;
end
reg cgt_en_assert_enable;
initial begin
  if($test$plusargs("cgt_en_assert_disable"))
    cgt_en_assert_enable = 1'b0;
  else
    cgt_en_assert_enable = 1'b1;
end
reg simdbusy_soft_override_disabled;
initial simdbusy_soft_override_disabled = 1'b0;
always @(posedge iclk) if(simdbusy_soft_override == 1'b0) simdbusy_soft_override_disabled <= 1'b1;
 `ifdef CG_W2E
final if((simdbusy_soft_override_disabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE Simdbusy_soft_override never deactivated");
 `else
final if((simdbusy_soft_override_disabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE Simdbusy_soft_override never deactivated");
 `endif
reg ls_soft_override_disabled;
initial ls_soft_override_disabled = 1'b0;
always @(posedge iclk) if(ls_soft_override == 1'b0) ls_soft_override_disabled <= 1'b1;
 `ifdef CG_W2E
final if((ls_soft_override_disabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE Ls_soft_override never deactivated");
 `else
final if((ls_soft_override_disabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE Ls_soft_override never deactivated");
 `endif
reg cg_soft_override_disabled;
initial cg_soft_override_disabled = 1'b0;
always @(posedge iclk) if(cg_soft_override == 1'b0) cg_soft_override_disabled <= 1'b1;
 `ifdef CG_W2E
final if((cg_soft_override_disabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE Cg_soft_override never deactivated");
 `else
final if((cg_soft_override_disabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE Cg_soft_override never deactivated");
 `endif
reg busy0_override_disabled;
initial busy0_override_disabled = 1'b0;
always @(posedge iclk) if(busy_override[0] == 1'b0) busy0_override_disabled <= 1'b1;
 `ifdef CG_W2E
final if((busy0_override_disabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE Busy_override[0] never deactivated");
 `else
final if((busy0_override_disabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE Busy_override[0] never deactivated");
 `endif
reg busy1_override_disabled;
initial busy1_override_disabled = 1'b0;
always @(posedge iclk) if(busy_override[1] == 1'b0) busy1_override_disabled <= 1'b1;
 `ifdef CG_W2E
final if((busy1_override_disabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE Busy_override[1] never deactivated");
 `else
final if((busy1_override_disabled == 1'b0) && enable && cgt_en_assert_enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE Busy_override[1] never deactivated");
 `endif
`ifdef CG_SIGNALS_DUMP_EN
initial 
begin
	#1;
	$fmonitor(tb.cg_file_handle, "CG CGTS_SIMDBUSY_OV:(%t) %m %b",$time,simdbusy_soft_override);
	$fmonitor(tb.cg_file_handle, "CG CGTS_LS_OV:(%t) %m %b",$time,ls_soft_override);
	$fmonitor(tb.cg_file_handle, "CG CGTS_CG_OV:(%t) %m %b",$time,cg_soft_override);
	$fmonitor(tb.cg_file_handle, "CG CGTS_BUSY_OV:(%t) %m %b",$time,busy_override);
	$fmonitor(tb.cg_file_handle, "CG CGTS_RST:(%t) %m %b",$time,resetb);
end
`endif
`else // !`ifdef VCS
initial begin
  $display("%m at %0t: ld/src/misc/cgts_local_cntl_cov.sv: SVA not yet supported in NCSIM in wekiva scripts", $realtime);
end
`endif // VCS
endmodule // cgts_local_cntl_cov
