//////////////////////////////////////////////////////////////////////////////////////////////////////////
//Description: Local clock gater register clock on generation.  The logic in this module is largely identical
//             to cgtt_local_rcg module, without the clock gate. 
//////////////////////////////////////////////////////////////////////////////////////////////////////////
module cgtt_local_rclkon(
   // Outputs
   reg_oclk_vld, 
   // Inputs
   resetb, reg_busy, soft_override, static_oclk
   );
//////////////////////////
//in/outs
//////////////////////////
 input 	     resetb;
 input       reg_busy;
 input       soft_override;
 input       static_oclk;
 output      reg_oclk_vld;
//////////////////////////
reg  reg_busy_d1;
reg  reg_busy_d2;
reg  reg_busy_d3;
reg  oclk_vld_dly;
reg        SOFT_REG_OVERRIDE;
//
//leaf (always on) clock domain logic
//
always @(posedge static_oclk) 
begin
	if(~resetb) begin
		SOFT_REG_OVERRIDE  <= 1'b1;
		reg_busy_d1  <= 1'b1;
		reg_busy_d2  <= 1'b1;
		reg_busy_d3  <= 1'b1;
	end else begin
		SOFT_REG_OVERRIDE  <= soft_override;
		reg_busy_d1  <= reg_busy || SOFT_REG_OVERRIDE;
		reg_busy_d2  <= reg_busy_d1;
		reg_busy_d3  <= reg_busy_d2;
	end
end
//
//clock gates
//
wire oclk_vld  = reg_busy_d3 && reg_busy_d2; 
`ifdef SIMULATION
//always @(oclk_vld)
//begin
//	oclk_vld_dly = #2 oclk_vld;
//end
assign #2 reg_oclk_vld = oclk_vld;
`else
assign reg_oclk_vld = oclk_vld;
`endif
endmodule
//////////////////////////////////////////////////////////////////////////////////////////////////////////
