
//----------------------------------------------------------------------------
//
// Author :		 Nehal Patel, N1-504 (Sunnyvale - Yan Dong), 44290 

//
// Notes  :		 DO NOT HAND EDIT THIS FILE!!!!!!
//	   		 This file was automatically derived from /local_vol1_nobackup/user/nepatel/dfxip4_0_tree2/dftmisc/src/meta/tools/scripts/odt2tdr_rtl.pl
//----------------------------------------------------------------------------
	  


module clk_cntl_tdr_gc10 ( 


//Broadcast to All TDRs
input Tdr_Tck,
input Tdr_Trstb,
input Tdr_Tdi,
input Tdr_Shift,
input Tdr_Capture,
input Tdr_Update



//TDR --> CLK_CNTL
 ,output wire [1-1:0] clk_stop
 ,output wire [1-1:0] ext_clk_stop_en
 ,output wire [3-1:0] mode_sel
 ,input Tdr_clk_cntl_En
 ,output Tdr_clk_cntl_Tdo
); // End of Port Declaration

///// START TDR_INST - CLK_CNTL /////

   localparam CLK_CNTL__WIDTH = 5;
   wire [CLK_CNTL__WIDTH-1:0]	CLK_CNTL;
   wire [CLK_CNTL__WIDTH-1:0]	CLK_CNTL__DEFAULT;  

	//CLK_CNTL - 0:0

   localparam  CLK_CNTL_CLK_STOP__WIDTH  = 1;
   localparam [CLK_CNTL_CLK_STOP__WIDTH-1:0] CLK_CNTL_CLK_STOP__DEFAULT  = 1'h0;
   

   localparam  CLK_CNTL_CLK_STOP__MSB  = 0;
   localparam  CLK_CNTL_CLK_STOP__LSB  = 0;
   

   assign CLK_CNTL__DEFAULT
                 [CLK_CNTL_CLK_STOP__MSB : 
                  CLK_CNTL_CLK_STOP__LSB] =  
		  CLK_CNTL_CLK_STOP__DEFAULT;
   

  ati_buffer1 mrk_clk_cntl_clk_stop[CLK_CNTL_CLK_STOP__WIDTH-1:0] 
  (
    .A(CLK_CNTL
      [CLK_CNTL_CLK_STOP__MSB :
       CLK_CNTL_CLK_STOP__LSB
      ]),    
    .Y(clk_stop[CLK_CNTL_CLK_STOP__WIDTH-1:0])
  );


	//CLK_CNTL - 4:4

   localparam  CLK_CNTL_EXT_CLK_STOP_EN__WIDTH  = 1;
   localparam [CLK_CNTL_EXT_CLK_STOP_EN__WIDTH-1:0] CLK_CNTL_EXT_CLK_STOP_EN__DEFAULT  = 1'h0;
   

   localparam  CLK_CNTL_EXT_CLK_STOP_EN__MSB  = 4;
   localparam  CLK_CNTL_EXT_CLK_STOP_EN__LSB  = 4;
   

   assign CLK_CNTL__DEFAULT
                 [CLK_CNTL_EXT_CLK_STOP_EN__MSB : 
                  CLK_CNTL_EXT_CLK_STOP_EN__LSB] =  
		  CLK_CNTL_EXT_CLK_STOP_EN__DEFAULT;
   

  ati_buffer1 mrk_clk_cntl_ext_clk_stop_en[CLK_CNTL_EXT_CLK_STOP_EN__WIDTH-1:0] 
  (
    .A(CLK_CNTL
      [CLK_CNTL_EXT_CLK_STOP_EN__MSB :
       CLK_CNTL_EXT_CLK_STOP_EN__LSB
      ]),    
    .Y(ext_clk_stop_en[CLK_CNTL_EXT_CLK_STOP_EN__WIDTH-1:0])
  );


	//CLK_CNTL - 3:1

   localparam  CLK_CNTL_MODE_SEL__WIDTH  = 3;
   localparam [CLK_CNTL_MODE_SEL__WIDTH-1:0] CLK_CNTL_MODE_SEL__DEFAULT  = 3'h0;
   

   localparam  CLK_CNTL_MODE_SEL__MSB  = 3;
   localparam  CLK_CNTL_MODE_SEL__LSB  = 1;
   

   assign CLK_CNTL__DEFAULT
                 [CLK_CNTL_MODE_SEL__MSB : 
                  CLK_CNTL_MODE_SEL__LSB] =  
		  CLK_CNTL_MODE_SEL__DEFAULT;
   

  ati_buffer1 mrk_clk_cntl_mode_sel[CLK_CNTL_MODE_SEL__WIDTH-1:0] 
  (
    .A(CLK_CNTL
      [CLK_CNTL_MODE_SEL__MSB :
       CLK_CNTL_MODE_SEL__LSB
      ]),    
    .Y(mode_sel[CLK_CNTL_MODE_SEL__WIDTH-1:0])
  );





   test_reg_async_rst_gc10
     #(CLK_CNTL__WIDTH)
   reg_CLK_CNTL (
                           .clk(Tdr_Tck),
                           .rstb(Tdr_Trstb),
                           .en(Tdr_clk_cntl_En),
                           .shift(Tdr_Shift & Tdr_clk_cntl_En),
                           .capture(Tdr_Capture & Tdr_clk_cntl_En),
                           .update(Tdr_Update & Tdr_clk_cntl_En),
                           .d_rst(CLK_CNTL__DEFAULT),
                           .q(CLK_CNTL),
                           .d(CLK_CNTL),
                           .si(Tdr_Tdi),
                           .so(Tdr_clk_cntl_Tdo),
                           .q_sr(),
                           .q_sr_posedge()
                           );









///// END TDR_INST - CLK_CNTL /////
endmodule
