module clkds_pdmux( lag, lead, test_clk_fb, test_clk_ref, VDD, VSS, clk_fb0,
    clk_fb1, clk_ref, sel );

    output lag;
    output lead;
    output test_clk_fb;
    output test_clk_ref;
    input VDD;
    input VSS;
    input clk_fb0;
    input clk_fb1;
    input clk_ref;
    input sel;

    wire  fbclk;
    wire  net24;
    wire  net25;
    wire  refclk;
    wire  tiehi;

    clkds_phase_detector  xpd( .VDD0P9(VDD), .VSS(VSS), .clk_fb(fbclk),
        .clk_ref(refclk), .lag(lag), .lead(lead) );

    dly_hdmux2xss1ul  imxref( .D0(tiehi), .D1(clk_ref), .S(tiehi), .VDD(VDD),
        .VSS(VSS), .Z(refclk) );
    dly_hdmux2xss1ul  imxfb( .D0(clk_fb0), .D1(clk_fb1), .S(sel), .VDD(VDD),
        .VSS(VSS), .Z(fbclk) );

    dly_hdtiehixss2ul  itiehi( .VDD(VDD), .VSS(VSS), .Z(tiehi) );

    dly_hdinxss2ul  invref1( .A(net24), .VDD(VDD), .VSS(VSS), .Z(test_clk_ref) );
    dly_hdinxss2ul  invfb1( .A(net25), .VDD(VDD), .VSS(VSS), .Z(test_clk_fb) );

    dly_hdinxss0_5ul  invref0( .A(refclk), .VDD(VDD), .VSS(VSS), .Z(net24) );
    dly_hdinxss0_5ul  invfb0( .A(fbclk), .VDD(VDD), .VSS(VSS), .Z(net25) );
endmodule



