//Verilog HDL for "gf28a_clkds", "clkds_pllpwrsniff" "verilog_leaf"


module clkds_pllpwrsniff ( iso_dis_pwrok, ldo_off, VDD, VSS, VDDPLL,
ldo_en, USE_CORE_PWR, ldo_on );

  input USE_CORE_PWR;
  input iso_dis_pwrok;
  input ldo_en;
  input VDD;
  input VDDPLL;
  input VSS;
  output ldo_off;
  output ldo_on;

reg corepwr_en;

always @(*)
  case ({ldo_en,USE_CORE_PWR})
    2'b00 : corepwr_en = 1'b1;
    2'b01 : corepwr_en = 1'b1;
    2'b11 : corepwr_en = 1'b1;
    2'b10 : corepwr_en = 1'b0;
  endcase

wire VDDPLL_ready_onVDD = (VDD&~VSS) ? (VDDPLL===1'b1) & corepwr_en : 1'bx;

assign ldo_off = (VDD&~VSS) ? VDDPLL_ready_onVDD & iso_dis_pwrok : 1'bx;

assign ldo_on  = (VDD&~VSS) ? ~corepwr_en : 1'bx;

endmodule
