//--------------------------------------
//std cell definitons for cells used in custom design (clkpicker, cs_top, ldo, delaychain,pdmux, etc.):w
// 12/12/2014  by yuchao
//---------------------------------------------------------------
//------------------------------------------------------------------------------------
//replace std cell with rtl model, changing its cell name also, prefixing with dly_
//-----------------------------------------------------------------------------------
`timescale 1ps/1ps
`define SEQ_DELAY #20
`define COMB_DELAY #1

module dly_hdinxss2ul ( A, VDD,VSS, Z );

  input  A ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

 assign `COMB_DELAY  Z =  ~A;

endmodule   // dly_hdinxss2ul

module dly_hdinxss8ul ( A, VDD, VSS, Z );

  input  A ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign `COMB_DELAY Z =  ~A;



endmodule   // dly_hdinxss8ul

module dly_hdoai211xss2ul ( A, B, C1, C2, VDD, VSS, Z );

  input  A ;
  input  B ;
  input  C1 ;
  input  C2 ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

 assign `COMB_DELAY  Z =  ~(A & B & (C1|C2));
  

endmodule   // dly_hdoai211xss2ul

module dly_hdinxss1ur ( A, VDD, VSS, Z );

  input  A ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign `COMB_DELAY Z =  ~A;
 

endmodule   // dly_hdinxss1ur

module dly_hdinxss6ul ( A, VDD, VSS, Z );

  input  A ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign `COMB_DELAY Z =  ~A;

  
endmodule   // dly_hdinxss6ul

module dly_hdnr2xss2ul ( A, B, VDD, VSS, Z );

  input  A ;
  input  B ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign `COMB_DELAY Z =  ~(A|B);
  

endmodule   // dly_hdnr2xss2ul

module dly_hdnr2xss3ul ( A, B, VDD, VSS, Z );

  input  A ;
  input  B ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign `COMB_DELAY Z =  ~(A|B);
  

endmodule   // dly_hdnr2xss3ul

module dly_hdnr2xss4ul ( A, B, VDD, VSS, Z );

  input  A ;
  input  B ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign `COMB_DELAY Z =  ~(A|B);
  

endmodule   // dly_hdnr2xss4ul

module dly_hdinxss8ur ( A, VDD, VSS, Z );

  input  A ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

 assign `COMB_DELAY  Z =  ~A;

endmodule   // dly_hdinxss8ur

module dly_hdinxss1ul ( A, VDD, VSS, Z );

  input  A ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign `COMB_DELAY Z =  ~A;

endmodule   // dly_hdinxss1ul

module dly_hdinxss12ul ( A, VDD, VSS, Z );

  input  A ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign `COMB_DELAY Z =  ~A;

endmodule   // dly_hdinxss12ul

module dly_hdnr2xss1ul ( A, B, VDD, VSS, Z );

  input  A ;
  input  B ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;


  assign `COMB_DELAY Z =  ~(A|B);


endmodule   // dly_hdnr2xss1ul

module dly_hdinxss4ul ( A, VDD, VSS, Z );

  input  A ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

 assign `COMB_DELAY Z =  ~A;


endmodule   // dly_hdinxss4ul

module dly_hdnd3xss1ul ( A, B, C, VDD, VSS, Z );

  input  A ;
  input  B ;
  input  C ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

 assign `COMB_DELAY  Z =  ~(A&B&C);

endmodule   // dly_hdnd3xss1ul

module dly_hdnd3xss2ul ( A, B, C, VDD, VSS, Z );

  input  A ;
  input  B ;
  input  C ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

 assign `COMB_DELAY  Z =  ~(A&B&C);

endmodule   // dly_hdnd3xss2ul


module dly_hdbfxss2ul ( A, VDD, VSS, Z );

  input  A ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;


 assign `COMB_DELAY  Z =  A;
endmodule   // dly_hdbfxss2ul

module dly_hdbfxss2ur ( A, VDD, VSS, Z );

  input  A ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;


 assign `COMB_DELAY  Z =  A;
endmodule   // dly_hdbfxss2ur

module dly_hddlydxss1ur ( A, VDD, VSS, Z ); // 

  input  A ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;


 assign   #15 Z = A;   // ubts581551

endmodule   // dly_hddlydxss1ur

module dly_hdinxss0_5ul ( A, VDD, VSS, Z );

  input  A ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;


 assign `COMB_DELAY Z =  ~A;

endmodule   // dly_hdinxss0_5ul

module dly_hdinxss2ur ( A, VDD, VSS, Z );

  input  A ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;


 assign `COMB_DELAY Z =  ~A;

endmodule   // dly_hdinxss2ur

module dly_hdnd2xss1ul ( A, B, VDD, VSS, Z );

  input  A ;
  input  B ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

 assign `COMB_DELAY Z =  ~(A&B);

endmodule   // dly_hdnd2xss1ul

module dly_hdnd2xss3ul ( A, B, VDD, VSS, Z );

  input  A ;
  input  B ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

 assign `COMB_DELAY Z =  ~(A&B);

endmodule   // dly_hdnd2xss3ul

module dly_hdan2xss2ul ( A, B, VDD, VSS, Z );

  input  A ;
  input  B ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

 assign `COMB_DELAY Z =  (A&B);

endmodule   // dly_hdan2xss2ul

module dly_hdmsfqbnsxss2ur ( CLK, D, VDD, VSS,QB  );

  input  CLK ;
  input  D ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"

  output QB ;
  reg   QB;

  always @ (posedge CLK) QB <= `SEQ_DELAY ~D;

endmodule   // dly_hdmsfqbnsxss2ur

module dly_hdmsfqbnsxss4ul ( CLK, D, VDD, VSS,QB  );

  input  CLK ;
  input  D ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"

  output QB ;
  reg   QB;

  always @ (posedge CLK) QB <= `SEQ_DELAY ~D;

endmodule   // dly_hdmsfqbnsxss4ul

module dly_hdmux4xss2ul ( D0, D1, D2, D3, S0, S1, VDD, VSS, Z );

  input  D0 ;
  input  D1 ;
  input  D2 ;
  input  D3 ;
  input  S0 ;
  input  S1 ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

 assign `COMB_DELAY  Z =  S1 ? (S0?D3:D2) : (S0?D1:D0);

endmodule   // dly_hdmux4xss2ul

module dly_hdmsfqbnsxss1ul ( CLK, D, QB, VDD, VSS );

  input  CLK ;
  input  D ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output QB ;
  reg    QB;

  always @ (posedge CLK) QB <= `SEQ_DELAY ~D;

endmodule   // dly_hdmsfqbnsxss1ul

module dly_hdan2xss1ur ( A, B, VDD, VSS, Z );

  input  A ;
  input  B ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

 assign `COMB_DELAY Z =  (A&B);

endmodule   // dly_hdan2xss1ur

module dly_hdmux2xss1ul ( D0, D1, S, VDD, VSS, Z );

  input  D0 ;
  input  D1 ;
  input  S ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

 assign `COMB_DELAY Z =  S ? D1:D0;

endmodule   // dly_hdmux2xss1ul

module dly_hdmux2xss4ul ( D0, D1, S, VDD, VSS, Z );

  input  D0 ;
  input  D1 ;
  input  S ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

 assign `COMB_DELAY Z =  S ? D1:D0;

endmodule   // dly_hdmux2xss4ul

module dly_hdmsfqbnsxss1ur ( CLK, D, QB, VDD, VSS );

  input  CLK ;
  input  D ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output QB ;
  reg    QB;

  always @ (posedge CLK) QB <= `SEQ_DELAY ~D;

endmodule   // dly_hdmsfqbnsxss1ur

module dly_hdlaqnsxss1ul ( CLK, D, Q, VDD, VSS );

  input  CLK ;
  input  D ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Q ;
  reg    Q;

  always @* if (CLK) Q <= `SEQ_DELAY D;

endmodule   // dly_hdlaqnsxss1ul

//-----Dec 2, 2014
module dly_hdtieloxss2ul ( VDD, VSS, Z );

  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign Z= 1'b0;

endmodule   // dly_hdtieloxss2ul

module dly_hdckbfxss4ul ( CLK, VDD, VSS, Z );

  input  CLK ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign `COMB_DELAY Z = CLK;

endmodule   // dly_hdckbfxss4ul

module dly_hdckbfxss3ul ( CLK, VDD, VSS, Z );

  input  CLK ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign `COMB_DELAY Z = CLK;

endmodule   // dly_hdckbfxss3ul

module dly_hdcklbqnsxss1ul ( CLK, D, Q, VDD, VSS );

  input  CLK ;
  input  D ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Q ;
  reg    Q;

  always @* if (~CLK)  Q <= `SEQ_DELAY D;

endmodule   // dly_hdcklbqnsxss1ul


module dly_hdckbfxss1ul ( CLK, VDD, VSS, Z );

  input  CLK ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign `COMB_DELAY Z = CLK;

endmodule   // dly_hdckbfxss1ul

module dly_hdckan2xss1ul ( CLK, EN, VDD, VSS, Z );

  input  CLK ;
  input  EN ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign `COMB_DELAY Z = CLK&EN;

endmodule   // dly_hdckan2xss1ul

module dly_hdckan2xss2ul ( CLK, EN, VDD, VSS, Z );

  input  CLK ;
  input  EN ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign `COMB_DELAY Z = CLK&EN;

endmodule   // dly_hdckan2xss2ul

module dly_hdckinxss8ul ( CLK, VDD, VSS, Z );

  input  CLK ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign `COMB_DELAY Z = ~CLK;

endmodule   // dly_hdckinxss8ul

module dly_hddlybxss1ur ( A, VDD, VSS, Z );

  input  A ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign #8 Z = A;     // per Thomas' suggestion 12/12/2014. For future tuning if needed.



endmodule   // dly_hddlybxss1ur


module dly_hdrsmsfqnsxss1ul ( CLK, D, Q, RESET, SET, VDD, VSS );

  input  CLK ;
  input  D ;
  input  RESET ;
  input  SET ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Q ;
  reg    Q;

always @ (posedge CLK or negedge RESET or negedge SET) begin
    
    if (~RESET)     Q <=  `SEQ_DELAY 1'b0;
    else if (~SET)  Q <=  `SEQ_DELAY 1'b1;
    else            Q <=  `SEQ_DELAY D;

end

endmodule   // dly_hdrsmsfqnsxss1ul

module dly_hdnr3xss1ur ( A, B, C, VDD, VSS, Z );

  input  A ;
  input  B ;
  input  C ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

 assign `COMB_DELAY Z = ~(A | B | C);

endmodule   // dly_hdnr3xss1ur

module dly_hdinxss3ul ( A, VDD, VSS, Z );

  input  A ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;


 assign `COMB_DELAY Z =  ~A;

endmodule

module dly_hdmux3xss1ul ( D00, D01, D1X, S0, S1, VDD, VSS, Z );

  input  D00 ;
  input  D01 ;
  input  D1X ;
  input  S0 ;
  input  S1 ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign `COMB_DELAY Z = S1 ? D1X : (S0?D01:D00);

endmodule   // dly_hdmux3xss1ul

module dly_hdmux3xss2ul ( D00, D01, D1X, S0, S1, VDD, VSS, Z );

  input  D00 ;
  input  D01 ;
  input  D1X ;
  input  S0 ;
  input  S1 ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign `COMB_DELAY Z = S1 ? D1X : (S0?D01:D00);

endmodule   // dly_hdmux3xss2ul


module dly_hdtiehixss2ul ( VDD, VSS, Z );

  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

  assign Z = 1'b1;

endmodule   // dly_hdtiehixss2ul


module dly_hdrmsfqnsxss1ul ( CLK, D, Q, RESET, VDD, VSS );

  input  CLK ;
  input  D ;
  input  RESET ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Q ;
  reg    Q;

  always @ (posedge CLK or negedge RESET) Q <= `SEQ_DELAY (~RESET) ? 1'b0 : D ;


endmodule   // dly_hdrmsfqnsxss1ul

module dly_hdrmsfqnsxss2ul ( CLK, D, Q, RESET, VDD, VSS );

  input  CLK ;
  input  D ;
  input  RESET ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Q ;
  reg    Q;

  always @ (posedge CLK or negedge RESET) Q <= `SEQ_DELAY (~RESET) ? 1'b0 : D ;


endmodule   // dly_hdrmsfqnsxss2ul


module dly_hdan3xss2ur ( A,B, C, VDD, VSS, Z );

  input  A ;
  input  B;
  input  C;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;


 assign `COMB_DELAY Z =  A&B&C;

endmodule

module dly_hdan2xss2ur ( A, B, VDD, VSS, Z );

  input  A ;
  input  B ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

 assign `COMB_DELAY Z =  A&B;

endmodule   // dly_hdan2xss2ur

module dly_hdxn2xss2ur ( A, B, VDD, VSS, Z );

  input  A ;
  input  B ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

assign `COMB_DELAY Z = A ~^ B;

endmodule   // dly_hdxn2xss2ur

module dly_hdoa21xss2ur ( A1, A2, B, VDD, VSS, Z );

  input  A1 ;
  input  A2 ;
  input  B ;
  input  VDD ;       //! TF="+TI" //! ET_UNCONNECTED="internal"
  input  VSS ;       //! TF="-TI" //! ET_UNCONNECTED="internal"
  output Z ;

assign `COMB_DELAY Z = (A1||A2)&&B;

endmodule   // dly_hdoa21xss2ur




