//                              -*- Mode: Verilog -*-

////////////////////////////////////////////////////////////////////////////
/*
 *
 *  Trade secret of ATI Technologies, Inc.
 *  Copyright 2005, ATI Technologies, Inc., (unpublished)
 *
 *  All rights reserved.  This notice is intended as a precaution against
 *  inadvertent publication and does not imply publication or any waiver
 *  of confidentiality.  The year included in the foregoing notice is the
 *  year of creation of the work.
 *
 */
////////////////////////////////////////////////////////////////////////////
//`include "dft_clk_cntl_features.vh"


module clone_SE_gc10 
(
input wire Func_Clk,
input wire ScanEn,
input wire SE_Sel,
input wire ScanEn_Override,
output wire ScanEn_Out

);

reg se_neg_ff;
wire ScanEn_Ored;

always @ (negedge Func_Clk)
 begin
  se_neg_ff <= ScanEn;
 end

wire SE_Out;
   ati_mux2 mux_se  (
   .i0(ScanEn),
   .i1(se_neg_ff),  // Bit 0 of gater table flops used for DC mode.      
   .s(SE_Sel),   
   .z(SE_Out));



// MCP leg-B
dfx_mrk_or_gc10 dfx_mrk_or_ScanEn (    .A(SE_Out), 
                          .B(ScanEn_Override),
                          .Y(ScanEn_Ored) );

ati_buffer1 mrk_SE (.A(ScanEn_Ored), .Y(ScanEn_Out) );


endmodule

