//                              -*- Mode: Verilog -*-

////////////////////////////////////////////////////////////////////////////
/*
 *
 *  Trade secret of ATI Technologies, Inc.
 *  Copyright 2005, ATI Technologies, Inc., (unpublished)
 *
 *  All rights reserved.  This notice is intended as a precaution against
 *  inadvertent publication and does not imply publication or any waiver
 *  of confidentiality.  The year included in the foregoing notice is the
 *  year of creation of the work.
 *
 */
////////////////////////////////////////////////////////////////////////////
//`include "dft_clk_cntl_features.vh"


module clone_dfx_cg_gc10 
  (
   input wire Func_Clk,
   output wire Func_Clk_Gated,
   input wire Dft_Clk_Gater_Aon,
   input wire Dft_Clk_Gater_En,
   input wire Func_Gater_En,
   input wire Tile_GaterEn,
   input wire Edt_Update
   
   );
  
  reg gater_en_ff;

   always @ (posedge Func_Clk)
    begin
	 gater_en_ff <= (Func_Gater_En & ~Dft_Clk_Gater_En) | Dft_Clk_Gater_Aon ;    
    end
   
   ati_clock_gate tile_root_DfxCLOCKGATER
     (.clk_out   (Func_Clk_Gated),
      .clk_src   (Func_Clk),
      .clk_en    (gater_en_ff & ~Edt_Update),   
      .TE        (Tile_GaterEn));
   
   ////////////////////////////////////////////////////////////////////////////
     
endmodule // clone_dfx_Cg


