// ==============================================================================================
// PLEASE DONOT CHANGES THIS FILE
// THIS FILE IS AUTO_GENERATED
// Source: import/address/src/rtl/gen_one/coordtobank.v
// ===============================================================================================
// Filename              : coordtobank.v
// Perforce changelist   : $Change$
//
// Copyright             : Trade secret of AMD, Inc.
//                         Copyright 2008, AMD, Inc., (unpublished)
//                         All rights reserved.  This notice is intended as a precaution against
//                         inadvertent publication and does not imply publication or any waiver
//                         of confidentiality.  The year included in the foregoing notice is the
//                         year of creation of the work.
//
// RTL author: kevin.gu
//
// Description:  calc bank number from x, y

module    coordtobank_gc(
                      //output
		      bank_number_0,    //bank number output
		      //input	      
                      pipe_config,      //10xx new added to in place of pipe num
	              bank_width,       //0:1tile, 1:2tiles, 2:4tiles, 3:8tiles
	              bank_height,      //0:1tile, 1:2tiles, 2:4tiles, 3:8tiles
	              sx,               //coordinate x, low 13-bit
	              sy,               //coordinate y, low 10-bit
	              bank_tiling	//number of banks, 0:2banks,1:4banks,2:8banks,3:16banks      
                     );

input    [4:0]     pipe_config;
input    [1:0]     bank_width;
input    [1:0]     bank_height;
input    [12:0]    sx;
input    [ 9:0]    sy;
input    [1:0]     bank_tiling;
output   [3:0]     bank_number_0;

/////10xx new logic to get pipes//////
   reg    [ 2 :0]   log2pipes;
   always@(*) begin
     case(pipe_config[4:0])
     5'b00000: log2pipes = 3'b001; //2 pipes
     5'b00100: log2pipes = 3'b010; //4 pipes
     5'b00101: log2pipes = 3'b010; //4 pipes
     5'b00110: log2pipes = 3'b010; //4 pipes
     5'b00111: log2pipes = 3'b010; //4 pipes
     5'b01000: log2pipes = 3'b011; //8 pipes
     5'b01001: log2pipes = 3'b011; //8 pipes
     5'b01010: log2pipes = 3'b011; //8 pipes
     5'b01011: log2pipes = 3'b011; //8 pipes
     5'b01100: log2pipes = 3'b011; //8 pipes
     5'b01101: log2pipes = 3'b011; //8 pipes
     5'b01110: log2pipes = 3'b011; //8 pipes
  	 5'b10010: log2pipes = 3'b100; //16 pipes
     //VCS coverage off
     default:  log2pipes = 3'b011; //default to be 8 pipes
     //VCS coverage on
     endcase
   end


reg   x3_bank_bit;
reg   x4_bank_bit;
reg   x5_bank_bit;
reg   x6_bank_bit;

reg   y3_bank_bit;
reg   y4_bank_bit;
reg   y5_bank_bit;
reg   y6_bank_bit;
wire  [2:0]   bank_width_plus_pipes;//0 -6
assign   bank_width_plus_pipes = bank_width + log2pipes[2:0];

always@(*)
begin
  case(bank_width_plus_pipes)
    3'b000: x3_bank_bit = sx[3];
    3'b001: x3_bank_bit = sx[4];
    3'b010: x3_bank_bit = sx[5];
    3'b011: x3_bank_bit = sx[6];
    3'b100: x3_bank_bit = sx[7];
    3'b101: x3_bank_bit = sx[8];
    3'b110: x3_bank_bit = sx[9];
    3'b111: x3_bank_bit = sx[10];
    default:x3_bank_bit = sx[3];
  endcase	
end	

always@(*)
begin
  case(bank_width_plus_pipes)
    3'b000: x4_bank_bit = sx[4];
    3'b001: x4_bank_bit = sx[5];
    3'b010: x4_bank_bit = sx[6];
    3'b011: x4_bank_bit = sx[7];
    3'b100: x4_bank_bit = sx[8];
    3'b101: x4_bank_bit = sx[9];
    3'b110: x4_bank_bit = sx[10];
    3'b111: x4_bank_bit = sx[11];
    default:x4_bank_bit = sx[4];
  endcase	
end	

always@(*)
begin
  case(bank_width_plus_pipes)
    3'b000: x5_bank_bit = sx[5];
    3'b001: x5_bank_bit = sx[6];
    3'b010: x5_bank_bit = sx[7];
    3'b011: x5_bank_bit = sx[8];
    3'b100: x5_bank_bit = sx[9];
    3'b101: x5_bank_bit = sx[10];
    3'b110: x5_bank_bit = sx[11];
    3'b111: x5_bank_bit = sx[12];
    default:x5_bank_bit = sx[5];
  endcase	
end

always@(*)
begin
  case(bank_width_plus_pipes)
    3'b000: x6_bank_bit = sx[6];
    3'b001: x6_bank_bit = sx[7];
    3'b010: x6_bank_bit = sx[8];
    3'b011: x6_bank_bit = sx[9];
    3'b100: x6_bank_bit = sx[10];
    3'b101: x6_bank_bit = sx[11];
    3'b110: x6_bank_bit = sx[12];
    3'b111: x6_bank_bit = sx[13];
    default:x6_bank_bit = sx[6];
  endcase	
end	

always@(*)
begin
  case(bank_height)
    2'b00://bank_height = 1
       y3_bank_bit = sy[3];
    2'b01://bank_height = 2
       y3_bank_bit = sy[4];
    2'b10://bank_height = 4
       y3_bank_bit = sy[5];
    2'b11://bank_height = 8
       y3_bank_bit = sy[6];
  endcase	
end	

always@(*)
begin
  case(bank_height)
    2'b00://bank_height = 1
       y4_bank_bit = sy[4];
    2'b01://bank_height = 2
       y4_bank_bit = sy[5];
    2'b10://bank_height = 4
       y4_bank_bit = sy[6];
    2'b11://bank_height = 8
       y4_bank_bit = sy[7];
  endcase	
end	

always@(*)
begin
  case(bank_height)
    2'b00://bank_height = 1
       y5_bank_bit = sy[5];
    2'b01://bank_height = 2
       y5_bank_bit = sy[6];
    2'b10://bank_height = 4
       y5_bank_bit = sy[7];
    2'b11://bank_height = 8
       y5_bank_bit = sy[8];
  endcase	
end	

always@(*)
begin
  case(bank_height)
    2'b00://bank_height = 1
       y6_bank_bit = sy[6];
    2'b01://bank_height = 2
       y6_bank_bit = sy[7];
    2'b10://bank_height = 4
       y6_bank_bit = sy[8];
    2'b11://bank_height = 8
       y6_bank_bit = sy[9];
  endcase	
end	

reg      [3:0]     bank_number_0_0;
always@(*)
begin
  case(bank_tiling)
    2'b00: //2 banks
          bank_number_0_0 = {3'b0, x3_bank_bit^y3_bank_bit};
    2'b01: //4 banks
          bank_number_0_0 = {2'b0, x4_bank_bit^y3_bank_bit, x3_bank_bit^y4_bank_bit};
    2'b10: //8 banks
          bank_number_0_0 = {1'b0, x5_bank_bit^y3_bank_bit, x4_bank_bit^y4_bank_bit^y5_bank_bit, x3_bank_bit^y5_bank_bit};
    2'b11: //16 banks
	  bank_number_0_0 = {x6_bank_bit^y3_bank_bit, x5_bank_bit^y4_bank_bit, x4_bank_bit^y5_bank_bit^y6_bank_bit, x3_bank_bit^y6_bank_bit};
    //default: bank_number_0 = 0;
  endcase		
end	

//10xx new added logic
wire [3:0] bank_number_0 = ((pipe_config == 5'b00111 || pipe_config == 5'b01110)&&(bank_width == 0))? {bank_number_0_0[3:1], bank_number_0_0[0]^sx[4]^sx[5]}: bank_number_0_0;

endmodule

