//                              -*- Mode: Verilog -*-
// (c) 2015, 2016 Advanced Micro Devices, Inc. All rights reserved.

////////////////////////////////////////////////////////////////////////////
//
// Filename    : dbg_bench_module.v.dpl
// Description : This module is temp, will get removed. It written to test the lib cells
//
// Search key
// <sync 24>
// <sync 32>
// <ssb_ 24>
// <ssb_ 32>
// <ssb_ 64>
// <asyn 12>
////////////////////////////////////////////////////////////////////////////
module dbg_bench_module (
   input ipclk                          ,
   input cold_resetb                    ,
   input TEST_CLK_EN                    ,
   input AEB_DBUS                       ,
   input [1:0] TARG_DBUS_daisychain_ctl ,
   input [2:0] dataClk
);


// <sync 24> Begin ---------------------------------------------------------------------------------------------
// <sync 24> End   ---------------------------------------------------------------------------------------------
// <sync 32> Begin ---------------------------------------------------------------------------------------------
  wire [35:0]  dbg_Mux0_SelLane_03 ;
  wire [31:0]  dbg_Mux0_Data_03    ;
  wire [35:0]  dbg_Mux0_SelLane_AF ;
  wire [31:0]  dbg_Mux0_Data_AF    ;
  wire [35:0]  dbg_Mux1_SelLane_03 ;
  wire [31:0]  dbg_Mux1_Data_03    ;
  wire [35:0]  dbg_Mux1_SelLane_AF ;
  wire [31:0]  dbg_Mux1_Data_AF    ;
  wire [35:0]  dbg_Mux2_SelLane_03 ;
  wire [31:0]  dbg_Mux2_Data_03    ;
  wire [35:0]  dbg_Mux2_SelLane_AF ;
  wire [31:0]  dbg_Mux2_Data_AF    ;
  wire [35:0]  dbg_Mux3_SelLane_03 ;
  wire [31:0]  dbg_Mux3_Data_03    ;
  wire [35:0]  dbg_Mux3_SelLane_AF ;
  wire [31:0]  dbg_Mux3_Data_AF    ;
  wire [35:0]  dbg_Mux4_SelLane_03 ;
  wire [31:0]  dbg_Mux4_Data_03    ;
  wire [35:0]  dbg_Mux4_SelLane_AF ;
  wire [31:0]  dbg_Mux4_Data_AF    ;
  wire [35:0]  dbg_Mux5_SelLane_03 ;
  wire [31:0]  dbg_Mux5_Data_03    ;
  wire [35:0]  dbg_Mux5_SelLane_AF ;
  wire [31:0]  dbg_Mux5_Data_AF    ;
  wire [31:0]  sync_32_daisychain_data;

  wire [7:0]            dbg_BlkId_03;
  wire                  dbg_active_03;
  wire                  dbg_rst_03;
  wire [1:0]            nxt_ctl_03;
  wire [31:0]  nxt_data_03;
  wire [7:0]            dbg_BlkId_AF;
  wire                  dbg_active_AF;
  wire                  dbg_rst_AF;
  wire [1:0]            nxt_ctl_AF;
  wire [31:0]  nxt_data_AF;

  // Instantiate all syn_dbg_client_mux


  dbg_client_sync_aon_steer #(.LANE_COUNT(4))
    I_dbg_client_sync_aon_steer_03 (
                                 .TARG_DBUS_daisychain_ctl(TARG_DBUS_daisychain_ctl[1:0]), // From dbgu
                                 .DBUS_TARG_daisychain_ctl(nxt_ctl_03[1:0]),
                                 .cold_resetb             (cold_resetb),

                                 .DbgBlkId                (8'h03),
                                 .TARG_DBUS_daisychain_data(sync_32_daisychain_data[31:0] ),
                                 .DBUS_TARG_daisychain_data(nxt_data_03[31:0]),
                                 .dbg_Mux0_SelLane              (dbg_Mux0_SelLane_03[35:0]), // output to   Mux
                                 .dbg_Mux0_Data                 (dbg_Mux0_Data_03   [31:0]), // input  from Mux
                                 .dbg_Mux1_SelLane              (dbg_Mux1_SelLane_03[35:0]), // output to   Mux
                                 .dbg_Mux1_Data                 (dbg_Mux1_Data_03   [31:0]), // input  from Mux
                                 .dbg_Mux2_SelLane              (dbg_Mux2_SelLane_03[35:0]), // output to   Mux
                                 .dbg_Mux2_Data                 (dbg_Mux2_Data_03   [31:0]), // input  from Mux
                                 .dbg_Mux3_SelLane              (dbg_Mux3_SelLane_03[35:0]), // output to   Mux
                                 .dbg_Mux3_Data                 (dbg_Mux3_Data_03   [31:0]), // input  from Mux
                                 .dbg_Mux4_SelLane              (dbg_Mux4_SelLane_03[35:0]), // output to   Mux
                                 .dbg_Mux4_Data                 (dbg_Mux4_Data_03   [31:0]), // input  from Mux
                                 .dbg_Mux5_SelLane              (dbg_Mux5_SelLane_03[35:0]), // output to   Mux
                                 .dbg_Mux5_Data                 (dbg_Mux5_Data_03   [31:0]), // input  from Mux

                                       /*AUTOINST*/
                                 // Outputs
                                 .dbg_active            (dbg_active_03),
                                 .dbg_rst               (dbg_rst_03),
                                 .dbg_BlkId             (dbg_BlkId_03[7:0]),
                                 // Inputs
                                 .ipclk                 (ipclk),
                                 .AEB_DBUS              (AEB_DBUS),
                                 .TEST_CLK_EN           (TEST_CLK_EN));

  dbg_client_sync_mux  #(.LANE_COUNT(4))
    I_dbg_client_sync_mux (
                           .dbg_Mux_SelLane     (dbg_Mux0_SelLane_03[35:0]),
                           .dbg_Mux_Data        (dbg_Mux0_Data_03   [31:0]),
                           .gclk                (gclk),
                           .idebug0   (32'h00030000),
                           .idebug1   (32'h00030001),
                           .idebug2   (32'h00030002),
                           .idebug3   (32'h00030003),
                           .idebug4   (32'h00030004),
                           .idebug5   (32'h00030005),
                           .idebug6   (32'h00030006),
                           .idebug7   (32'h00030007),
                           .idebug8   (32'h00030008),
                           .idebug9   (32'h00030009),
                           .idebug10   (32'h0003000a),
                           .idebug11   (32'h0003000b),
                           .idebug12   (32'h0003000c),
                           .idebug13   (32'h0003000d),
                           .idebug14   (32'h0003000e),
                           .idebug15   (32'h0003000f),
                           .idebug16   (32'h00030010),
                           .idebug17   (32'h00030011),
                           .idebug18   (32'h00030012),
                           .idebug19   (32'h00030013),
                           .idebug20   (32'h00030014),
                           .idebug21   (32'h00030015),
                           .idebug22   (32'h00030016),
                           .idebug23   (32'h00030017),
                           .idebug24   (32'h00030018),
                           .idebug25   (32'h00030019),
                           .idebug26   (32'h0003001a),
                           .idebug27   (32'h0003001b),
                           .idebug28   (32'h0003001c),
                           .idebug29   (32'h0003001d),
                           .idebug30   (32'h0003001e),
                           .idebug31   (32'h0003001f),
                           .idebug32   (32'h00030020),
                           .idebug33   (32'h00030021),
                           .idebug34   (32'h00030022),
                           .idebug35   (32'h00030023),
                           .idebug36   (32'h00030024),
                           .idebug37   (32'h00030025),
                           .idebug38   (32'h00030026),
                           .idebug39   (32'h00030027),
                           .idebug40   (32'h00030028),
                           .idebug41   (32'h00030029),
                           .idebug42   (32'h0003002a),
                           .idebug43   (32'h0003002b),
                           .idebug44   (32'h0003002c),
                           .idebug45   (32'h0003002d),
                           .idebug46   (32'h0003002e),
                           .idebug47   (32'h0003002f),
                           .idebug48   (32'h00030030),
                           .idebug49   (32'h00030031),
                           .idebug50   (32'h00030032),
                           .idebug51   (32'h00030033),
                           .idebug52   (32'h00030034),
                           .idebug53   (32'h00030035),
                           .idebug54   (32'h00030036),
                           .idebug55   (32'h00030037),
                           .idebug56   (32'h00030038),
                           .idebug57   (32'h00030039),
                           .idebug58   (32'h0003003a),
                           .idebug59   (32'h0003003b),
                           .idebug60   (32'h0003003c),
                           .idebug61   (32'h0003003d),
                           .idebug62   (32'h0003003e),
                                         /*AUTOINST*/
                           // Inputs
                           .ipclk               (ipclk),
                           .dbg_active          (dbg_active_03),
                           .dbg_BlkId           (dbg_BlkId_03[7:0]),
                           .dbg_rst             (dbg_rst_03),
                           .TEST_CLK_EN         (TEST_CLK_EN));
  dbg_client_sync_mux_byte #( .LANE_COUNT(4)
                            , .LANE_WIDTH(8)
                            )
    I_dbg_client_sync_mux_byte (
                                .dbg_Mux_SelLane(dbg_Mux1_SelLane_03[35:0]),
                                .dbg_Mux_Data   (dbg_Mux1_Data_03   [31:0]),
                                .idebug         (32'h00010000),
                                /*AUTOINST*/
                                // Inputs
                                .ipclk          (ipclk),
                                .dbg_active     (dbg_active_03),
                                .dbg_rst        (dbg_rst_03),
                                .TEST_CLK_EN    (TEST_CLK_EN));

  dbg_client_sync_aon_retimer #(.WIDTH(32))
    I_dbg_client_sync_aon_retimer (
                                   .TARG_DBUS_daisychain_ctl(nxt_ctl_03[1:0]), // toward dbgu
                                   .DBUS_TARG_daisychain_ctl(nxt_ctl_AF[1:0]),

                                   .TARG_DBUS_daisychain_data(nxt_data_03[31:0]),
                                   .DBUS_TARG_daisychain_data(nxt_data_AF[31:0]),
                                   /*AUTOINST*/
                                   // Inputs
                                   .ipclk               (ipclk),
                                   .TEST_CLK_EN         (TEST_CLK_EN));

  dbg_client_sync_aon_steer #(.LANE_COUNT(4))
    I_dbg_client_sync_aon_steer_AF (
                                 .TARG_DBUS_daisychain_ctl(nxt_ctl_AF[1:0]),
                                 .DBUS_TARG_daisychain_ctl(            ),
                                 .cold_resetb             (cold_resetb),

                                 .DbgBlkId                (8'hAF),
                                 .TARG_DBUS_daisychain_data(nxt_data_AF[31:0]),
                                 .DBUS_TARG_daisychain_data({ 32 {1'b0}}),
                                 .dbg_Mux0_SelLane              (dbg_Mux0_SelLane_AF[35:0]), // output to   Mux
                                 .dbg_Mux0_Data                 (dbg_Mux0_Data_AF   [31:0]), // input  from Mux
                                 .dbg_Mux1_SelLane              (dbg_Mux1_SelLane_AF[35:0]), // output to   Mux
                                 .dbg_Mux1_Data                 (dbg_Mux1_Data_AF   [31:0]), // input  from Mux
                                 .dbg_Mux2_SelLane              (dbg_Mux2_SelLane_AF[35:0]), // output to   Mux
                                 .dbg_Mux2_Data                 (dbg_Mux2_Data_AF   [31:0]), // input  from Mux
                                 .dbg_Mux3_SelLane              (dbg_Mux3_SelLane_AF[35:0]), // output to   Mux
                                 .dbg_Mux3_Data                 (dbg_Mux3_Data_AF   [31:0]), // input  from Mux
                                 .dbg_Mux4_SelLane              (dbg_Mux4_SelLane_AF[35:0]), // output to   Mux
                                 .dbg_Mux4_Data                 (dbg_Mux4_Data_AF   [31:0]), // input  from Mux
                                 .dbg_Mux5_SelLane              (dbg_Mux5_SelLane_AF[35:0]), // output to   Mux
                                 .dbg_Mux5_Data                 (dbg_Mux5_Data_AF   [31:0]), // input  from Mux

                                       /*AUTOINST*/
                                 // Outputs
                                 .dbg_active            (dbg_active_AF),
                                 .dbg_rst               (dbg_rst_AF),
                                 .dbg_BlkId             (dbg_BlkId_AF[7:0]),
                                 // Inputs
                                 .ipclk                 (ipclk),
                                 .AEB_DBUS              (AEB_DBUS),
                                 .TEST_CLK_EN           (TEST_CLK_EN));
  dbg_client_sync_mux  #(.LANE_COUNT(4))
    I_dbg_client_sync_mux_AF (
                           .dbg_Mux_SelLane     (dbg_Mux4_SelLane_AF[35:0]),
                           .dbg_Mux_Data        (dbg_Mux4_Data_AF   [31:0]),
                           .gclk                (gclk),
                           .idebug0   (32'h00af0000),
                           .idebug1   (32'h00af0001),
                           .idebug2   (32'h00af0002),
                           .idebug3   (32'h00af0003),
                           .idebug4   (32'h00af0004),
                           .idebug5   (32'h00af0005),
                           .idebug6   (32'h00af0006),
                           .idebug7   (32'h00af0007),
                           .idebug8   (32'h00af0008),
                           .idebug9   (32'h00af0009),
                           .idebug10   (32'h00af000a),
                           .idebug11   (32'h00af000b),
                           .idebug12   (32'h00af000c),
                           .idebug13   (32'h00af000d),
                           .idebug14   (32'h00af000e),
                           .idebug15   (32'h00af000f),
                           .idebug16   (32'h00af0010),
                           .idebug17   (32'h00af0011),
                           .idebug18   (32'h00af0012),
                           .idebug19   (32'h00af0013),
                           .idebug20   (32'h00af0014),
                           .idebug21   (32'h00af0015),
                           .idebug22   (32'h00af0016),
                           .idebug23   (32'h00af0017),
                           .idebug24   (32'h00af0018),
                           .idebug25   (32'h00af0019),
                           .idebug26   (32'h00af001a),
                           .idebug27   (32'h00af001b),
                           .idebug28   (32'h00af001c),
                           .idebug29   (32'h00af001d),
                           .idebug30   (32'h00af001e),
                           .idebug31   (32'h00af001f),
                           .idebug32   (32'h00af0020),
                           .idebug33   (32'h00af0021),
                           .idebug34   (32'h00af0022),
                           .idebug35   (32'h00af0023),
                           .idebug36   (32'h00af0024),
                           .idebug37   (32'h00af0025),
                           .idebug38   (32'h00af0026),
                           .idebug39   (32'h00af0027),
                           .idebug40   (32'h00af0028),
                           .idebug41   (32'h00af0029),
                           .idebug42   (32'h00af002a),
                           .idebug43   (32'h00af002b),
                           .idebug44   (32'h00af002c),
                           .idebug45   (32'h00af002d),
                           .idebug46   (32'h00af002e),
                           .idebug47   (32'h00af002f),
                           .idebug48   (32'h00af0030),
                           .idebug49   (32'h00af0031),
                           .idebug50   (32'h00af0032),
                           .idebug51   (32'h00af0033),
                           .idebug52   (32'h00af0034),
                           .idebug53   (32'h00af0035),
                           .idebug54   (32'h00af0036),
                           .idebug55   (32'h00af0037),
                           .idebug56   (32'h00af0038),
                           .idebug57   (32'h00af0039),
                           .idebug58   (32'h00af003a),
                           .idebug59   (32'h00af003b),
                           .idebug60   (32'h00af003c),
                           .idebug61   (32'h00af003d),
                           .idebug62   (32'h00af003e),
                                         /*AUTOINST*/
                           // Inputs
                           .ipclk               (ipclk),
                           .dbg_active          (dbg_active_AF),
                           .dbg_BlkId           (dbg_BlkId_AF[7:0]),
                           .dbg_rst             (dbg_rst_AF),
                           .TEST_CLK_EN         (TEST_CLK_EN));
// <sync 32> End   ---------------------------------------------------------------------------------------------
// <ssb_ 24> Begin ---------------------------------------------------------------------------------------------
  wire [26:0]  dbg_Mux0_SelLane_06 ;
  wire [23:0]  dbg_Mux0_Data_06    ;
  wire [2:0]  dbg_Mux0_Clk_06     ;
  wire [26:0]  dbg_Mux0_SelLane_AE ;
  wire [23:0]  dbg_Mux0_Data_AE    ;
  wire [2:0]  dbg_Mux0_Clk_AE     ;
  wire [26:0]  dbg_Mux1_SelLane_06 ;
  wire [23:0]  dbg_Mux1_Data_06    ;
  wire [2:0]  dbg_Mux1_Clk_06     ;
  wire [26:0]  dbg_Mux1_SelLane_AE ;
  wire [23:0]  dbg_Mux1_Data_AE    ;
  wire [2:0]  dbg_Mux1_Clk_AE     ;
  wire [26:0]  dbg_Mux2_SelLane_06 ;
  wire [23:0]  dbg_Mux2_Data_06    ;
  wire [2:0]  dbg_Mux2_Clk_06     ;
  wire [26:0]  dbg_Mux2_SelLane_AE ;
  wire [23:0]  dbg_Mux2_Data_AE    ;
  wire [2:0]  dbg_Mux2_Clk_AE     ;
  wire [26:0]  dbg_Mux3_SelLane_06 ;
  wire [23:0]  dbg_Mux3_Data_06    ;
  wire [2:0]  dbg_Mux3_Clk_06     ;
  wire [26:0]  dbg_Mux3_SelLane_AE ;
  wire [23:0]  dbg_Mux3_Data_AE    ;
  wire [2:0]  dbg_Mux3_Clk_AE     ;
  wire [26:0]  dbg_Mux4_SelLane_06 ;
  wire [23:0]  dbg_Mux4_Data_06    ;
  wire [2:0]  dbg_Mux4_Clk_06     ;
  wire [26:0]  dbg_Mux4_SelLane_AE ;
  wire [23:0]  dbg_Mux4_Data_AE    ;
  wire [2:0]  dbg_Mux4_Clk_AE     ;
  wire [26:0]  dbg_Mux5_SelLane_06 ;
  wire [23:0]  dbg_Mux5_Data_06    ;
  wire [2:0]  dbg_Mux5_Clk_06     ;
  wire [26:0]  dbg_Mux5_SelLane_AE ;
  wire [23:0]  dbg_Mux5_Data_AE    ;
  wire [2:0]  dbg_Mux5_Clk_AE     ;
  wire [26:0]  dbg_Mux3_SelLane_06n ;
  wire [23:0]  dbg_Mux3_Data_06n    ;
  wire [2:0]  dbg_Mux3_Clk_06n     ;
  wire [26:0]  dbg_Mux3_SelLane_06m ;
  wire [23:0]  dbg_Mux3_Data_06m    ;
  wire [2:0]  dbg_Mux3_Clk_06m     ;

  wire [23:0]  ssb__24_daisychain_data;
  wire [2:0]  ssb__24_daisychain_dclk;

  wire [7:0]               dbg_BlkId_06;
  wire                     ctlProg_ClkOn_06;
  wire [1:0]               nxt_ctl_06;
  wire                     nxt_clk_06;
  wire [23:0]     nxt_data_06;
  wire [2:0]     nxt_dclk_06;
  wire [7:0]               dbg_BlkId_AE;
  wire                     ctlProg_ClkOn_AE;
  wire [1:0]               nxt_ctl_AE;
  wire                     nxt_clk_AE;
  wire [23:0]     nxt_data_AE;
  wire [2:0]     nxt_dclk_AE;
   dbg_client_ssb__aon_steer #( .LANE_COUNT(3)
                              , .LANE_WIDTH(8)
                              )
     I_dbg_client_ssb__aon_steer_06 (
                                     .TARG_DBUS_daisychain_ctl (TARG_DBUS_daisychain_ctl[1:0]), // From dbgu
                                     .TARG_DBUS_daisychain_cclk(ipclk                        ),
                                     .TARG_DBUS_daisychain_data(ssb__24_daisychain_data[23:0] ),
                                     .TARG_DBUS_daisychain_dclk(ssb__24_daisychain_dclk[2:0] ),

                                     .DBUS_TARG_daisychain_ctl (nxt_ctl_06 [1:0]          ),
                                     .DBUS_TARG_daisychain_cclk(nxt_clk_06                ),
                                     .DBUS_TARG_daisychain_data(nxt_data_06[23:0]),
                                     .DBUS_TARG_daisychain_dclk(nxt_dclk_06[2:0]),

                                     .ctlProg_ClkOn            (ctlProg_ClkOn_     ),
                                     .dbg_Mux0_SelLane (dbg_Mux0_SelLane_06[26:0]), // output to   Mux
                                     .dbg_Mux0_Data    (dbg_Mux0_Data_06   [23:0]), // input  from Mux
                                     .dbg_Mux0_Clk     (dbg_Mux0_Clk_06    [2:0]), // input  from Mux
                                     .dbg_Mux1_SelLane (dbg_Mux1_SelLane_06[26:0]), // output to   Mux
                                     .dbg_Mux1_Data    (dbg_Mux1_Data_06   [23:0]), // input  from Mux
                                     .dbg_Mux1_Clk     (dbg_Mux1_Clk_06    [2:0]), // input  from Mux
                                     .dbg_Mux2_SelLane (dbg_Mux2_SelLane_06[26:0]), // output to   Mux
                                     .dbg_Mux2_Data    (dbg_Mux2_Data_06   [23:0]), // input  from Mux
                                     .dbg_Mux2_Clk     (dbg_Mux2_Clk_06    [2:0]), // input  from Mux
                                     .dbg_Mux3_SelLane (dbg_Mux3_SelLane_06[26:0]), // output to   Mux
                                     .dbg_Mux3_Data    (dbg_Mux3_Data_06   [23:0]), // input  from Mux
                                     .dbg_Mux3_Clk     (dbg_Mux3_Clk_06    [2:0]), // input  from Mux
                                     .dbg_Mux4_SelLane (dbg_Mux4_SelLane_06[26:0]), // output to   Mux
                                     .dbg_Mux4_Data    (dbg_Mux4_Data_06   [23:0]), // input  from Mux
                                     .dbg_Mux4_Clk     (dbg_Mux4_Clk_06    [2:0]), // input  from Mux
                                     .dbg_Mux5_SelLane (dbg_Mux5_SelLane_06[26:0]), // output to   Mux
                                     .dbg_Mux5_Data    (dbg_Mux5_Data_06   [23:0]), // input  from Mux
                                     .dbg_Mux5_Clk     (dbg_Mux5_Clk_06    [2:0]), // input  from Mux
                                     .DbgBlkId                 (8'h06            ),
                                     .AEB_DBUS                 (AEB_DBUS         ),
                                     .TEST_CLK_EN              (TEST_CLK_EN      ),
                                     .dbg_BlkId                (dbg_BlkId_06[7:0])
                                     );
   dbg_client_ssb__mux  #( .LANE_COUNT(3)
                         , .LANE_WIDTH(8)
                         )
     I_dbg_client_ssb__mux_06a (
                                .dbg_BlkId           (dbg_BlkId_06[7:0]                 ),
                                .dbg_Mux_SelLane     (dbg_Mux3_SelLane_06[26:0]),
                                .dbg_Mux_Data        (dbg_Mux3_Data_06   [23:0]),
                                .dbg_Mux_Clk         (dbg_Mux3_Clk_06    [2:0]),

                                .clk                 (dataClk[0]                         ),
                           .idebug0   (24'h040000),
                           .idebug1   (24'h040001),
                           .idebug2   (24'h040002),
                           .idebug3   (24'h040003),
                           .idebug4   (24'h040004),
                           .idebug5   (24'h040005),
                           .idebug6   (24'h040006),
                           .idebug7   (24'h040007),
                           .idebug8   (24'h040008),
                           .idebug9   (24'h040009),
                           .idebug10   (24'h04000a),
                           .idebug11   (24'h04000b),
                           .idebug12   (24'h04000c),
                           .idebug13   (24'h04000d),
                           .idebug14   (24'h04000e),
                           .idebug15   (24'h04000f),
                           .idebug16   (24'h040010),
                           .idebug17   (24'h040011),
                           .idebug18   (24'h040012),
                           .idebug19   (24'h040013),
                           .idebug20   (24'h040014),
                           .idebug21   (24'h040015),
                           .idebug22   (24'h040016),
                           .idebug23   (24'h040017),
                           .idebug24   (24'h040018),
                           .idebug25   (24'h040019),
                           .idebug26   (24'h04001a),
                           .idebug27   (24'h04001b),
                           .idebug28   (24'h04001c),
                           .idebug29   (24'h04001d),
                           .idebug30   (24'h04001e),
                           .idebug31   (24'h04001f),
                           .idebug32   (24'h000020),
                           .idebug33   (24'h000021),
                           .idebug34   (24'h000022),
                           .idebug35   (24'h000023),
                           .idebug36   (24'h000024),
                           .idebug37   (24'h000025),
                           .idebug38   (24'h000026),
                           .idebug39   (24'h000027),
                           .idebug40   (24'h000028),
                           .idebug41   (24'h000029),
                           .idebug42   (24'h00002a),
                           .idebug43   (24'h00002b),
                           .idebug44   (24'h00002c),
                           .idebug45   (24'h00002d),
                           .idebug46   (24'h00002e),
                           .idebug47   (24'h00002f),
                           .idebug48   (24'h000030),
                           .idebug49   (24'h000031),
                           .idebug50   (24'h000032),
                           .idebug51   (24'h000033),
                           .idebug52   (24'h000034),
                           .idebug53   (24'h000035),
                           .idebug54   (24'h000036),
                           .idebug55   (24'h000037),
                           .idebug56   (24'h000038),
                           .idebug57   (24'h000039),
                           .idebug58   (24'h00003a),
                           .idebug59   (24'h00003b),
                           .idebug60   (24'h00003c),
                           .idebug61   (24'h00003d),
                           .idebug62   (24'h00003e),
                                .TEST_CLK_EN         (TEST_CLK_EN                       ),
                                .ctlProg_ClkOn       (ctlProg_ClkOn_             )
                                );
   dbg_client_ssb__mux  #( .LANE_COUNT(3)
                         , .LANE_WIDTH(8)
                         )
     I_dbg_client_ssb__mux_06b (
                                .dbg_BlkId           (dbg_BlkId_06[7:0]                 ),
                                .dbg_Mux_SelLane     (dbg_Mux3_SelLane_06n[26:0]),
                                .dbg_Mux_Data        (dbg_Mux3_Data_06n   [23:0]),
                                .dbg_Mux_Clk         (dbg_Mux3_Clk_06n    [2:0]),

                                .clk                 (dataClk[1]                         ),
                           .idebug0   (24'h000000),
                           .idebug1   (24'h000001),
                           .idebug2   (24'h000002),
                           .idebug3   (24'h000003),
                           .idebug4   (24'h000004),
                           .idebug5   (24'h000005),
                           .idebug6   (24'h000006),
                           .idebug7   (24'h000007),
                           .idebug8   (24'h000008),
                           .idebug9   (24'h000009),
                           .idebug10   (24'h00000a),
                           .idebug11   (24'h00000b),
                           .idebug12   (24'h00000c),
                           .idebug13   (24'h00000d),
                           .idebug14   (24'h00000e),
                           .idebug15   (24'h00000f),
                           .idebug16   (24'h000010),
                           .idebug17   (24'h000011),
                           .idebug18   (24'h000012),
                           .idebug19   (24'h000013),
                           .idebug20   (24'h000014),
                           .idebug21   (24'h000015),
                           .idebug22   (24'h000016),
                           .idebug23   (24'h000017),
                           .idebug24   (24'h000018),
                           .idebug25   (24'h000019),
                           .idebug26   (24'h00001a),
                           .idebug27   (24'h00001b),
                           .idebug28   (24'h00001c),
                           .idebug29   (24'h00001d),
                           .idebug30   (24'h00001e),
                           .idebug31   (24'h00001f),
                           .idebug32   (24'h000020),
                           .idebug33   (24'h060021),
                           .idebug34   (24'h060022),
                           .idebug35   (24'h060023),
                           .idebug36   (24'h060024),
                           .idebug37   (24'h060025),
                           .idebug38   (24'h060026),
                           .idebug39   (24'h060027),
                           .idebug40   (24'h060028),
                           .idebug41   (24'h060029),
                           .idebug42   (24'h06002a),
                           .idebug43   (24'h06002b),
                           .idebug44   (24'h06002c),
                           .idebug45   (24'h06002d),
                           .idebug46   (24'h06002e),
                           .idebug47   (24'h06002f),
                           .idebug48   (24'h060030),
                           .idebug49   (24'h060031),
                           .idebug50   (24'h060032),
                           .idebug51   (24'h060033),
                           .idebug52   (24'h060034),
                           .idebug53   (24'h060035),
                           .idebug54   (24'h060036),
                           .idebug55   (24'h060037),
                           .idebug56   (24'h060038),
                           .idebug57   (24'h060039),
                           .idebug58   (24'h06003a),
                           .idebug59   (24'h06003b),
                           .idebug60   (24'h06003c),
                           .idebug61   (24'h06003d),
                           .idebug62   (24'h06003e),
                                .TEST_CLK_EN         (TEST_CLK_EN                       ),
                                .ctlProg_ClkOn       (ctlProg_ClkOn_             )
                                );
   dbg_client_ssb__mux_clk #( .LANE_COUNT(3)
                            , .LANE_WIDTH(8)
                            )
     I_dbg_client_ssb__mux_clk_06 (
                                   .dbg_Mux_SelLane     (dbg_Mux3_SelLane_06m[26:0]),
                                   .dbg_Mux_Data        (dbg_Mux3_Data_06m   [23:0]),
                                   .dbg_Mux_Clk         (dbg_Mux3_Clk_06m    [2:0]),

                                   .clk                 (dataClk[2]                        ),
                                   .TEST_CLK_EN         (TEST_CLK_EN                       ),
                                   .ctlProg_ClkOn       (ctlProg_ClkOn_             )
                                   );

   dbg_client_ssb__aon_steer #( .LANE_COUNT(3)
                              , .LANE_WIDTH(8)
                              )
     I_dbg_client_ssb__aon_steer_AE (
                                     .TARG_DBUS_daisychain_ctl (nxt_ctl_06 [1:0]          ), // From dbgu
                                     .TARG_DBUS_daisychain_cclk(nxt_clk_06                ),
                                     .TARG_DBUS_daisychain_data(nxt_data_06[23:0]),
                                     .TARG_DBUS_daisychain_dclk(nxt_dclk_06[2:0]),

                                     .DBUS_TARG_daisychain_ctl (nxt_ctl_AE [1:0]          ),
                                     .DBUS_TARG_daisychain_cclk(nxt_clk_AE                ),
                                     .DBUS_TARG_daisychain_data(nxt_data_AE[23:0]),
                                     .DBUS_TARG_daisychain_dclk(nxt_dclk_AE[2:0]),

                                     .ctlProg_ClkOn            (ctlProg_ClkOn_     ),
                                     .dbg_Mux0_SelLane (dbg_Mux0_SelLane_AE[26:0]), // output to   Mux
                                     .dbg_Mux0_Data    (dbg_Mux0_Data_AE   [23:0]), // input  from Mux
                                     .dbg_Mux0_Clk     (dbg_Mux0_Clk_AE    [2:0]), // input  from Mux
                                     .dbg_Mux1_SelLane (dbg_Mux1_SelLane_AE[26:0]), // output to   Mux
                                     .dbg_Mux1_Data    (dbg_Mux1_Data_AE   [23:0]), // input  from Mux
                                     .dbg_Mux1_Clk     (dbg_Mux1_Clk_AE    [2:0]), // input  from Mux
                                     .dbg_Mux2_SelLane (dbg_Mux2_SelLane_AE[26:0]), // output to   Mux
                                     .dbg_Mux2_Data    (dbg_Mux2_Data_AE   [23:0]), // input  from Mux
                                     .dbg_Mux2_Clk     (dbg_Mux2_Clk_AE    [2:0]), // input  from Mux
                                     .dbg_Mux3_SelLane (dbg_Mux3_SelLane_AE[26:0]), // output to   Mux
                                     .dbg_Mux3_Data    (dbg_Mux3_Data_AE   [23:0]), // input  from Mux
                                     .dbg_Mux3_Clk     (dbg_Mux3_Clk_AE    [2:0]), // input  from Mux
                                     .dbg_Mux4_SelLane (dbg_Mux4_SelLane_AE[26:0]), // output to   Mux
                                     .dbg_Mux4_Data    (dbg_Mux4_Data_AE   [23:0]), // input  from Mux
                                     .dbg_Mux4_Clk     (dbg_Mux4_Clk_AE    [2:0]), // input  from Mux
                                     .dbg_Mux5_SelLane (dbg_Mux5_SelLane_AE[26:0]), // output to   Mux
                                     .dbg_Mux5_Data    (dbg_Mux5_Data_AE   [23:0]), // input  from Mux
                                     .dbg_Mux5_Clk     (dbg_Mux5_Clk_AE    [2:0]), // input  from Mux
                                     .DbgBlkId                 (8'hAE            ),
                                     .AEB_DBUS                 (AEB_DBUS         ),
                                     .TEST_CLK_EN              (TEST_CLK_EN      ),
                                     .dbg_BlkId                (dbg_BlkId_AE[7:0])
                                     );
   dbg_client_ssb__mux  #( .LANE_COUNT(3)
                         , .LANE_WIDTH(8)
                         )
     I_dbg_client_ssb__mux_AE (
                                .dbg_BlkId           (dbg_BlkId_AE[7:0]                 ),
                                .dbg_Mux_SelLane     (dbg_Mux5_SelLane_AE[26:0]),
                                .dbg_Mux_Data        (dbg_Mux5_Data_AE   [23:0]),
                                .dbg_Mux_Clk         (dbg_Mux5_Clk_AE    [2:0]),

                                .clk                 (dataClk[0]                        ),
                           .idebug0   (24'hae0000),
                           .idebug1   (24'hae0001),
                           .idebug2   (24'hae0002),
                           .idebug3   (24'hae0003),
                           .idebug4   (24'hae0004),
                           .idebug5   (24'hae0005),
                           .idebug6   (24'hae0006),
                           .idebug7   (24'hae0007),
                           .idebug8   (24'hae0008),
                           .idebug9   (24'hae0009),
                           .idebug10   (24'hae000a),
                           .idebug11   (24'hae000b),
                           .idebug12   (24'hae000c),
                           .idebug13   (24'hae000d),
                           .idebug14   (24'hae000e),
                           .idebug15   (24'hae000f),
                           .idebug16   (24'hae0010),
                           .idebug17   (24'hae0011),
                           .idebug18   (24'hae0012),
                           .idebug19   (24'hae0013),
                           .idebug20   (24'hae0014),
                           .idebug21   (24'hae0015),
                           .idebug22   (24'hae0016),
                           .idebug23   (24'hae0017),
                           .idebug24   (24'hae0018),
                           .idebug25   (24'hae0019),
                           .idebug26   (24'hae001a),
                           .idebug27   (24'hae001b),
                           .idebug28   (24'hae001c),
                           .idebug29   (24'hae001d),
                           .idebug30   (24'hae001e),
                           .idebug31   (24'hae001f),
                           .idebug32   (24'hae0020),
                           .idebug33   (24'hae0021),
                           .idebug34   (24'hae0022),
                           .idebug35   (24'hae0023),
                           .idebug36   (24'hae0024),
                           .idebug37   (24'hae0025),
                           .idebug38   (24'hae0026),
                           .idebug39   (24'hae0027),
                           .idebug40   (24'hae0028),
                           .idebug41   (24'hae0029),
                           .idebug42   (24'hae002a),
                           .idebug43   (24'hae002b),
                           .idebug44   (24'hae002c),
                           .idebug45   (24'hae002d),
                           .idebug46   (24'hae002e),
                           .idebug47   (24'hae002f),
                           .idebug48   (24'hae0030),
                           .idebug49   (24'hae0031),
                           .idebug50   (24'hae0032),
                           .idebug51   (24'hae0033),
                           .idebug52   (24'hae0034),
                           .idebug53   (24'hae0035),
                           .idebug54   (24'hae0036),
                           .idebug55   (24'hae0037),
                           .idebug56   (24'hae0038),
                           .idebug57   (24'hae0039),
                           .idebug58   (24'hae003a),
                           .idebug59   (24'hae003b),
                           .idebug60   (24'hae003c),
                           .idebug61   (24'hae003d),
                           .idebug62   (24'hae003e),
                                .TEST_CLK_EN         (TEST_CLK_EN                       ),
                                .ctlProg_ClkOn       (ctlProg_ClkOn_             )
                                );
// <ssb_ 24> End   ---------------------------------------------------------------------------------------------
// <ssb_ 32> Begin ---------------------------------------------------------------------------------------------
  wire [35:0]  dbg_Mux0_SelLane_04 ;
  wire [31:0]  dbg_Mux0_Data_04    ;
  wire [3:0]  dbg_Mux0_Clk_04     ;
  wire [35:0]  dbg_Mux0_SelLane_AD ;
  wire [31:0]  dbg_Mux0_Data_AD    ;
  wire [3:0]  dbg_Mux0_Clk_AD     ;
  wire [35:0]  dbg_Mux1_SelLane_04 ;
  wire [31:0]  dbg_Mux1_Data_04    ;
  wire [3:0]  dbg_Mux1_Clk_04     ;
  wire [35:0]  dbg_Mux1_SelLane_AD ;
  wire [31:0]  dbg_Mux1_Data_AD    ;
  wire [3:0]  dbg_Mux1_Clk_AD     ;
  wire [35:0]  dbg_Mux2_SelLane_04 ;
  wire [31:0]  dbg_Mux2_Data_04    ;
  wire [3:0]  dbg_Mux2_Clk_04     ;
  wire [35:0]  dbg_Mux2_SelLane_AD ;
  wire [31:0]  dbg_Mux2_Data_AD    ;
  wire [3:0]  dbg_Mux2_Clk_AD     ;
  wire [35:0]  dbg_Mux3_SelLane_04 ;
  wire [31:0]  dbg_Mux3_Data_04    ;
  wire [3:0]  dbg_Mux3_Clk_04     ;
  wire [35:0]  dbg_Mux3_SelLane_AD ;
  wire [31:0]  dbg_Mux3_Data_AD    ;
  wire [3:0]  dbg_Mux3_Clk_AD     ;
  wire [35:0]  dbg_Mux4_SelLane_04 ;
  wire [31:0]  dbg_Mux4_Data_04    ;
  wire [3:0]  dbg_Mux4_Clk_04     ;
  wire [35:0]  dbg_Mux4_SelLane_AD ;
  wire [31:0]  dbg_Mux4_Data_AD    ;
  wire [3:0]  dbg_Mux4_Clk_AD     ;
  wire [35:0]  dbg_Mux5_SelLane_04 ;
  wire [31:0]  dbg_Mux5_Data_04    ;
  wire [3:0]  dbg_Mux5_Clk_04     ;
  wire [35:0]  dbg_Mux5_SelLane_AD ;
  wire [31:0]  dbg_Mux5_Data_AD    ;
  wire [3:0]  dbg_Mux5_Clk_AD     ;
  wire [35:0]  dbg_Mux3_SelLane_04n ;
  wire [31:0]  dbg_Mux3_Data_04n    ;
  wire [3:0]  dbg_Mux3_Clk_04n     ;
  wire [35:0]  dbg_Mux3_SelLane_04m ;
  wire [31:0]  dbg_Mux3_Data_04m    ;
  wire [3:0]  dbg_Mux3_Clk_04m     ;

  wire [31:0]  ssb__32_daisychain_data;
  wire [3:0]  ssb__32_daisychain_dclk;

  wire [7:0]               dbg_BlkId_04;
  wire                     ctlProg_ClkOn_04;
  wire [1:0]               nxt_ctl_04;
  wire                     nxt_clk_04;
  wire [31:0]     nxt_data_04;
  wire [3:0]     nxt_dclk_04;
  wire [7:0]               dbg_BlkId_AD;
  wire                     ctlProg_ClkOn_AD;
  wire [1:0]               nxt_ctl_AD;
  wire                     nxt_clk_AD;
  wire [31:0]     nxt_data_AD;
  wire [3:0]     nxt_dclk_AD;
   dbg_client_ssb__aon_steer #(.LANE_COUNT(4)
                              , .LANE_WIDTH(8)
                              )
     I_dbg_client_ssb__aon_steer_04 (
                                     .TARG_DBUS_daisychain_ctl (TARG_DBUS_daisychain_ctl[1:0]), // From dbgu
                                     .TARG_DBUS_daisychain_cclk(ipclk                        ),
                                     .TARG_DBUS_daisychain_data(ssb__32_daisychain_data[31:0] ),
                                     .TARG_DBUS_daisychain_dclk(ssb__32_daisychain_dclk[3:0] ),

                                     .DBUS_TARG_daisychain_ctl (nxt_ctl_04 [1:0]          ),
                                     .DBUS_TARG_daisychain_cclk(nxt_clk_04                ),
                                     .DBUS_TARG_daisychain_data(nxt_data_04[31:0]),
                                     .DBUS_TARG_daisychain_dclk(nxt_dclk_04[3:0]),

                                     .ctlProg_ClkOn            (ctlProg_ClkOn_     ),
                                     .dbg_Mux0_SelLane (dbg_Mux0_SelLane_04[35:0]), // output to   Mux
                                     .dbg_Mux0_Data    (dbg_Mux0_Data_04   [31:0]), // input  from Mux
                                     .dbg_Mux0_Clk     (dbg_Mux0_Clk_04    [3:0]), // input  from Mux
                                     .dbg_Mux1_SelLane (dbg_Mux1_SelLane_04[35:0]), // output to   Mux
                                     .dbg_Mux1_Data    (dbg_Mux1_Data_04   [31:0]), // input  from Mux
                                     .dbg_Mux1_Clk     (dbg_Mux1_Clk_04    [3:0]), // input  from Mux
                                     .dbg_Mux2_SelLane (dbg_Mux2_SelLane_04[35:0]), // output to   Mux
                                     .dbg_Mux2_Data    (dbg_Mux2_Data_04   [31:0]), // input  from Mux
                                     .dbg_Mux2_Clk     (dbg_Mux2_Clk_04    [3:0]), // input  from Mux
                                     .dbg_Mux3_SelLane (dbg_Mux3_SelLane_04[35:0]), // output to   Mux
                                     .dbg_Mux3_Data    (dbg_Mux3_Data_04   [31:0]), // input  from Mux
                                     .dbg_Mux3_Clk     (dbg_Mux3_Clk_04    [3:0]), // input  from Mux
                                     .dbg_Mux4_SelLane (dbg_Mux4_SelLane_04[35:0]), // output to   Mux
                                     .dbg_Mux4_Data    (dbg_Mux4_Data_04   [31:0]), // input  from Mux
                                     .dbg_Mux4_Clk     (dbg_Mux4_Clk_04    [3:0]), // input  from Mux
                                     .dbg_Mux5_SelLane (dbg_Mux5_SelLane_04[35:0]), // output to   Mux
                                     .dbg_Mux5_Data    (dbg_Mux5_Data_04   [31:0]), // input  from Mux
                                     .dbg_Mux5_Clk     (dbg_Mux5_Clk_04    [3:0]), // input  from Mux
                                     .DbgBlkId                 (8'h04            ),
                                     .AEB_DBUS                 (AEB_DBUS         ),
                                     .TEST_CLK_EN              (TEST_CLK_EN      ),
                                     .dbg_BlkId                (dbg_BlkId_04[7:0])
                                     );
   dbg_client_ssb__mux  #( .LANE_COUNT(4)
                         , .LANE_WIDTH(8)
                         )
     I_dbg_client_ssb__mux_04a (
                                .dbg_BlkId           (dbg_BlkId_04[7:0]                 ),
                                .dbg_Mux_SelLane     (dbg_Mux3_SelLane_04[35:0]),
                                .dbg_Mux_Data        (dbg_Mux3_Data_04   [31:0]),
                                .dbg_Mux_Clk         (dbg_Mux3_Clk_04    [3:0]),

                                .clk                 (dataClk[0]                         ),
                           .idebug0   (32'h00040000),
                           .idebug1   (32'h00040001),
                           .idebug2   (32'h00040002),
                           .idebug3   (32'h00040003),
                           .idebug4   (32'h00040004),
                           .idebug5   (32'h00040005),
                           .idebug6   (32'h00040006),
                           .idebug7   (32'h00040007),
                           .idebug8   (32'h00040008),
                           .idebug9   (32'h00040009),
                           .idebug10   (32'h0004000a),
                           .idebug11   (32'h0004000b),
                           .idebug12   (32'h0004000c),
                           .idebug13   (32'h0004000d),
                           .idebug14   (32'h0004000e),
                           .idebug15   (32'h0004000f),
                           .idebug16   (32'h00040010),
                           .idebug17   (32'h00040011),
                           .idebug18   (32'h00040012),
                           .idebug19   (32'h00040013),
                           .idebug20   (32'h00040014),
                           .idebug21   (32'h00040015),
                           .idebug22   (32'h00040016),
                           .idebug23   (32'h00040017),
                           .idebug24   (32'h00040018),
                           .idebug25   (32'h00040019),
                           .idebug26   (32'h0004001a),
                           .idebug27   (32'h0004001b),
                           .idebug28   (32'h0004001c),
                           .idebug29   (32'h0004001d),
                           .idebug30   (32'h0004001e),
                           .idebug31   (32'h0004001f),
                           .idebug32   (32'h00000020),
                           .idebug33   (32'h00000021),
                           .idebug34   (32'h00000022),
                           .idebug35   (32'h00000023),
                           .idebug36   (32'h00000024),
                           .idebug37   (32'h00000025),
                           .idebug38   (32'h00000026),
                           .idebug39   (32'h00000027),
                           .idebug40   (32'h00000028),
                           .idebug41   (32'h00000029),
                           .idebug42   (32'h0000002a),
                           .idebug43   (32'h0000002b),
                           .idebug44   (32'h0000002c),
                           .idebug45   (32'h0000002d),
                           .idebug46   (32'h0000002e),
                           .idebug47   (32'h0000002f),
                           .idebug48   (32'h00000030),
                           .idebug49   (32'h00000031),
                           .idebug50   (32'h00000032),
                           .idebug51   (32'h00000033),
                           .idebug52   (32'h00000034),
                           .idebug53   (32'h00000035),
                           .idebug54   (32'h00000036),
                           .idebug55   (32'h00000037),
                           .idebug56   (32'h00000038),
                           .idebug57   (32'h00000039),
                           .idebug58   (32'h0000003a),
                           .idebug59   (32'h0000003b),
                           .idebug60   (32'h0000003c),
                           .idebug61   (32'h0000003d),
                           .idebug62   (32'h0000003e),
                                .TEST_CLK_EN         (TEST_CLK_EN                       ),
                                .ctlProg_ClkOn       (ctlProg_ClkOn_             )
                                );
   dbg_client_ssb__mux  #( .LANE_COUNT(4)
                         , .LANE_WIDTH(8)
                         )
     I_dbg_client_ssb__mux_04b (
                                .dbg_BlkId           (dbg_BlkId_04[7:0]                 ),
                                .dbg_Mux_SelLane     (dbg_Mux3_SelLane_04n[35:0]),
                                .dbg_Mux_Data        (dbg_Mux3_Data_04n   [31:0]),
                                .dbg_Mux_Clk         (dbg_Mux3_Clk_04n    [3:0]),

                                .clk                 (dataClk[1]                         ),
                           .idebug0   (32'h00000000),
                           .idebug1   (32'h00000001),
                           .idebug2   (32'h00000002),
                           .idebug3   (32'h00000003),
                           .idebug4   (32'h00000004),
                           .idebug5   (32'h00000005),
                           .idebug6   (32'h00000006),
                           .idebug7   (32'h00000007),
                           .idebug8   (32'h00000008),
                           .idebug9   (32'h00000009),
                           .idebug10   (32'h0000000a),
                           .idebug11   (32'h0000000b),
                           .idebug12   (32'h0000000c),
                           .idebug13   (32'h0000000d),
                           .idebug14   (32'h0000000e),
                           .idebug15   (32'h0000000f),
                           .idebug16   (32'h00000010),
                           .idebug17   (32'h00000011),
                           .idebug18   (32'h00000012),
                           .idebug19   (32'h00000013),
                           .idebug20   (32'h00000014),
                           .idebug21   (32'h00000015),
                           .idebug22   (32'h00000016),
                           .idebug23   (32'h00000017),
                           .idebug24   (32'h00000018),
                           .idebug25   (32'h00000019),
                           .idebug26   (32'h0000001a),
                           .idebug27   (32'h0000001b),
                           .idebug28   (32'h0000001c),
                           .idebug29   (32'h0000001d),
                           .idebug30   (32'h0000001e),
                           .idebug31   (32'h0000001f),
                           .idebug32   (32'h00000020),
                           .idebug33   (32'h00040021),
                           .idebug34   (32'h00040022),
                           .idebug35   (32'h00040023),
                           .idebug36   (32'h00040024),
                           .idebug37   (32'h00040025),
                           .idebug38   (32'h00040026),
                           .idebug39   (32'h00040027),
                           .idebug40   (32'h00040028),
                           .idebug41   (32'h00040029),
                           .idebug42   (32'h0004002a),
                           .idebug43   (32'h0004002b),
                           .idebug44   (32'h0004002c),
                           .idebug45   (32'h0004002d),
                           .idebug46   (32'h0004002e),
                           .idebug47   (32'h0004002f),
                           .idebug48   (32'h00040030),
                           .idebug49   (32'h00040031),
                           .idebug50   (32'h00040032),
                           .idebug51   (32'h00040033),
                           .idebug52   (32'h00040034),
                           .idebug53   (32'h00040035),
                           .idebug54   (32'h00040036),
                           .idebug55   (32'h00040037),
                           .idebug56   (32'h00040038),
                           .idebug57   (32'h00040039),
                           .idebug58   (32'h0004003a),
                           .idebug59   (32'h0004003b),
                           .idebug60   (32'h0004003c),
                           .idebug61   (32'h0004003d),
                           .idebug62   (32'h0004003e),
                                .TEST_CLK_EN         (TEST_CLK_EN                       ),
                                .ctlProg_ClkOn       (ctlProg_ClkOn_             )
                                );
   dbg_client_ssb__mux_clk #( .LANE_COUNT(4)
                            , .LANE_WIDTH(8)
                            )
     I_dbg_client_ssb__mux_clk_04 (
                                   .dbg_Mux_SelLane     (dbg_Mux3_SelLane_04m[35:0]),
                                   .dbg_Mux_Data        (dbg_Mux3_Data_04m   [31:0]),
                                   .dbg_Mux_Clk         (dbg_Mux3_Clk_04m    [3:0]),

                                   .clk                 (dataClk[2]                        ),
                                   .TEST_CLK_EN         (TEST_CLK_EN                       ),
                                   .ctlProg_ClkOn       (ctlProg_ClkOn_             )
                                   );

   dbg_client_ssb__aon_steer #( .LANE_COUNT(4)
                              , .LANE_WIDTH(8)
                              )
     I_dbg_client_ssb__aon_steer_AD (
                                     .TARG_DBUS_daisychain_ctl (nxt_ctl_04 [1:0]          ), // From dbgu
                                     .TARG_DBUS_daisychain_cclk(nxt_clk_04                ),
                                     .TARG_DBUS_daisychain_data(nxt_data_04[31:0]),
                                     .TARG_DBUS_daisychain_dclk(nxt_dclk_04[3:0]),

                                     .DBUS_TARG_daisychain_ctl (nxt_ctl_AD [1:0]          ),
                                     .DBUS_TARG_daisychain_cclk(nxt_clk_AD                ),
                                     .DBUS_TARG_daisychain_data(nxt_data_AD[31:0]),
                                     .DBUS_TARG_daisychain_dclk(nxt_dclk_AD[3:0]),

                                     .ctlProg_ClkOn            (ctlProg_ClkOn_     ),
                                     .dbg_Mux0_SelLane (dbg_Mux0_SelLane_AD[35:0]), // output to   Mux
                                     .dbg_Mux0_Data    (dbg_Mux0_Data_AD   [31:0]), // input  from Mux
                                     .dbg_Mux0_Clk     (dbg_Mux0_Clk_AD    [3:0]), // input  from Mux
                                     .dbg_Mux1_SelLane (dbg_Mux1_SelLane_AD[35:0]), // output to   Mux
                                     .dbg_Mux1_Data    (dbg_Mux1_Data_AD   [31:0]), // input  from Mux
                                     .dbg_Mux1_Clk     (dbg_Mux1_Clk_AD    [3:0]), // input  from Mux
                                     .dbg_Mux2_SelLane (dbg_Mux2_SelLane_AD[35:0]), // output to   Mux
                                     .dbg_Mux2_Data    (dbg_Mux2_Data_AD   [31:0]), // input  from Mux
                                     .dbg_Mux2_Clk     (dbg_Mux2_Clk_AD    [3:0]), // input  from Mux
                                     .dbg_Mux3_SelLane (dbg_Mux3_SelLane_AD[35:0]), // output to   Mux
                                     .dbg_Mux3_Data    (dbg_Mux3_Data_AD   [31:0]), // input  from Mux
                                     .dbg_Mux3_Clk     (dbg_Mux3_Clk_AD    [3:0]), // input  from Mux
                                     .dbg_Mux4_SelLane (dbg_Mux4_SelLane_AD[35:0]), // output to   Mux
                                     .dbg_Mux4_Data    (dbg_Mux4_Data_AD   [31:0]), // input  from Mux
                                     .dbg_Mux4_Clk     (dbg_Mux4_Clk_AD    [3:0]), // input  from Mux
                                     .dbg_Mux5_SelLane (dbg_Mux5_SelLane_AD[35:0]), // output to   Mux
                                     .dbg_Mux5_Data    (dbg_Mux5_Data_AD   [31:0]), // input  from Mux
                                     .dbg_Mux5_Clk     (dbg_Mux5_Clk_AD    [3:0]), // input  from Mux
                                     .DbgBlkId                 (8'hAD            ),
                                     .AEB_DBUS                 (AEB_DBUS         ),
                                     .TEST_CLK_EN              (TEST_CLK_EN      ),
                                     .dbg_BlkId                (dbg_BlkId_AD[7:0])
                                     );
   dbg_client_ssb__mux  #( .LANE_COUNT(4)
                         , .LANE_WIDTH(8)
                         )
     I_dbg_client_ssb__mux_AD (
                                .dbg_BlkId           (dbg_BlkId_AD[7:0]                 ),
                                .dbg_Mux_SelLane     (dbg_Mux5_SelLane_AD[35:0]),
                                .dbg_Mux_Data        (dbg_Mux5_Data_AD   [31:0]),
                                .dbg_Mux_Clk         (dbg_Mux5_Clk_AD    [3:0]),

                                .clk                 (dataClk[0]                        ),
                           .idebug0   (32'h00ad0000),
                           .idebug1   (32'h00ad0001),
                           .idebug2   (32'h00ad0002),
                           .idebug3   (32'h00ad0003),
                           .idebug4   (32'h00ad0004),
                           .idebug5   (32'h00ad0005),
                           .idebug6   (32'h00ad0006),
                           .idebug7   (32'h00ad0007),
                           .idebug8   (32'h00ad0008),
                           .idebug9   (32'h00ad0009),
                           .idebug10   (32'h00ad000a),
                           .idebug11   (32'h00ad000b),
                           .idebug12   (32'h00ad000c),
                           .idebug13   (32'h00ad000d),
                           .idebug14   (32'h00ad000e),
                           .idebug15   (32'h00ad000f),
                           .idebug16   (32'h00ad0010),
                           .idebug17   (32'h00ad0011),
                           .idebug18   (32'h00ad0012),
                           .idebug19   (32'h00ad0013),
                           .idebug20   (32'h00ad0014),
                           .idebug21   (32'h00ad0015),
                           .idebug22   (32'h00ad0016),
                           .idebug23   (32'h00ad0017),
                           .idebug24   (32'h00ad0018),
                           .idebug25   (32'h00ad0019),
                           .idebug26   (32'h00ad001a),
                           .idebug27   (32'h00ad001b),
                           .idebug28   (32'h00ad001c),
                           .idebug29   (32'h00ad001d),
                           .idebug30   (32'h00ad001e),
                           .idebug31   (32'h00ad001f),
                           .idebug32   (32'h00ad0020),
                           .idebug33   (32'h00ad0021),
                           .idebug34   (32'h00ad0022),
                           .idebug35   (32'h00ad0023),
                           .idebug36   (32'h00ad0024),
                           .idebug37   (32'h00ad0025),
                           .idebug38   (32'h00ad0026),
                           .idebug39   (32'h00ad0027),
                           .idebug40   (32'h00ad0028),
                           .idebug41   (32'h00ad0029),
                           .idebug42   (32'h00ad002a),
                           .idebug43   (32'h00ad002b),
                           .idebug44   (32'h00ad002c),
                           .idebug45   (32'h00ad002d),
                           .idebug46   (32'h00ad002e),
                           .idebug47   (32'h00ad002f),
                           .idebug48   (32'h00ad0030),
                           .idebug49   (32'h00ad0031),
                           .idebug50   (32'h00ad0032),
                           .idebug51   (32'h00ad0033),
                           .idebug52   (32'h00ad0034),
                           .idebug53   (32'h00ad0035),
                           .idebug54   (32'h00ad0036),
                           .idebug55   (32'h00ad0037),
                           .idebug56   (32'h00ad0038),
                           .idebug57   (32'h00ad0039),
                           .idebug58   (32'h00ad003a),
                           .idebug59   (32'h00ad003b),
                           .idebug60   (32'h00ad003c),
                           .idebug61   (32'h00ad003d),
                           .idebug62   (32'h00ad003e),
                                .TEST_CLK_EN         (TEST_CLK_EN                       ),
                                .ctlProg_ClkOn       (ctlProg_ClkOn_             )
                                );
// <ssb_ 32> End   ---------------------------------------------------------------------------------------------
// <ssb_ 64> Begin ---------------------------------------------------------------------------------------------
  wire [35:0]  dbg_Mux0_SelLane_07 ;
  wire [63:0]  dbg_Mux0_Data_07    ;
  wire [3:0]  dbg_Mux0_Clk_07     ;
  wire [35:0]  dbg_Mux0_SelLane_AB ;
  wire [63:0]  dbg_Mux0_Data_AB    ;
  wire [3:0]  dbg_Mux0_Clk_AB     ;
  wire [35:0]  dbg_Mux1_SelLane_07 ;
  wire [63:0]  dbg_Mux1_Data_07    ;
  wire [3:0]  dbg_Mux1_Clk_07     ;
  wire [35:0]  dbg_Mux1_SelLane_AB ;
  wire [63:0]  dbg_Mux1_Data_AB    ;
  wire [3:0]  dbg_Mux1_Clk_AB     ;
  wire [35:0]  dbg_Mux2_SelLane_07 ;
  wire [63:0]  dbg_Mux2_Data_07    ;
  wire [3:0]  dbg_Mux2_Clk_07     ;
  wire [35:0]  dbg_Mux2_SelLane_AB ;
  wire [63:0]  dbg_Mux2_Data_AB    ;
  wire [3:0]  dbg_Mux2_Clk_AB     ;
  wire [35:0]  dbg_Mux3_SelLane_07 ;
  wire [63:0]  dbg_Mux3_Data_07    ;
  wire [3:0]  dbg_Mux3_Clk_07     ;
  wire [35:0]  dbg_Mux3_SelLane_AB ;
  wire [63:0]  dbg_Mux3_Data_AB    ;
  wire [3:0]  dbg_Mux3_Clk_AB     ;
  wire [35:0]  dbg_Mux4_SelLane_07 ;
  wire [63:0]  dbg_Mux4_Data_07    ;
  wire [3:0]  dbg_Mux4_Clk_07     ;
  wire [35:0]  dbg_Mux4_SelLane_AB ;
  wire [63:0]  dbg_Mux4_Data_AB    ;
  wire [3:0]  dbg_Mux4_Clk_AB     ;
  wire [35:0]  dbg_Mux5_SelLane_07 ;
  wire [63:0]  dbg_Mux5_Data_07    ;
  wire [3:0]  dbg_Mux5_Clk_07     ;
  wire [35:0]  dbg_Mux5_SelLane_AB ;
  wire [63:0]  dbg_Mux5_Data_AB    ;
  wire [3:0]  dbg_Mux5_Clk_AB     ;
  wire [35:0]  dbg_Mux3_SelLane_07n ;
  wire [63:0]  dbg_Mux3_Data_07n    ;
  wire [3:0]  dbg_Mux3_Clk_07n     ;
  wire [35:0]  dbg_Mux3_SelLane_07m ;
  wire [63:0]  dbg_Mux3_Data_07m    ;
  wire [3:0]  dbg_Mux3_Clk_07m     ;

  wire [63:0]  ssb__64_daisychain_data;
  wire [3:0]  ssb__64_daisychain_dclk;

  wire [7:0]               dbg_BlkId_07;
  wire                     ctlProg_ClkOn_07;
  wire [1:0]               nxt_ctl_07;
  wire                     nxt_clk_07;
  wire [63:0]     nxt_data_07;
  wire [3:0]     nxt_dclk_07;
  wire [7:0]               dbg_BlkId_AB;
  wire                     ctlProg_ClkOn_AB;
  wire [1:0]               nxt_ctl_AB;
  wire                     nxt_clk_AB;
  wire [63:0]     nxt_data_AB;
  wire [3:0]     nxt_dclk_AB;
   dbg_client_ssb__aon_steer #( .LANE_COUNT(4)
                              , .LANE_WIDTH(16)
                              )
     I_dbg_client_ssb__aon_steer_07 (
                                     .TARG_DBUS_daisychain_ctl (TARG_DBUS_daisychain_ctl[1:0]), // From dbgu
                                     .TARG_DBUS_daisychain_cclk(ipclk                        ),
                                     .TARG_DBUS_daisychain_data(ssb__64_daisychain_data[63:0] ),
                                     .TARG_DBUS_daisychain_dclk(ssb__64_daisychain_dclk[3:0] ),

                                     .DBUS_TARG_daisychain_ctl (nxt_ctl_07 [1:0]          ),
                                     .DBUS_TARG_daisychain_cclk(nxt_clk_07                ),
                                     .DBUS_TARG_daisychain_data(nxt_data_07[63:0]),
                                     .DBUS_TARG_daisychain_dclk(nxt_dclk_07[3:0]),

                                     .ctlProg_ClkOn            (ctlProg_ClkOn_     ),
                                     .dbg_Mux0_SelLane (dbg_Mux0_SelLane_07[35:0]), // output to   Mux
                                     .dbg_Mux0_Data    (dbg_Mux0_Data_07   [63:0]), // input  from Mux
                                     .dbg_Mux0_Clk     (dbg_Mux0_Clk_07    [3:0]), // input  from Mux
                                     .dbg_Mux1_SelLane (dbg_Mux1_SelLane_07[35:0]), // output to   Mux
                                     .dbg_Mux1_Data    (dbg_Mux1_Data_07   [63:0]), // input  from Mux
                                     .dbg_Mux1_Clk     (dbg_Mux1_Clk_07    [3:0]), // input  from Mux
                                     .dbg_Mux2_SelLane (dbg_Mux2_SelLane_07[35:0]), // output to   Mux
                                     .dbg_Mux2_Data    (dbg_Mux2_Data_07   [63:0]), // input  from Mux
                                     .dbg_Mux2_Clk     (dbg_Mux2_Clk_07    [3:0]), // input  from Mux
                                     .dbg_Mux3_SelLane (dbg_Mux3_SelLane_07[35:0]), // output to   Mux
                                     .dbg_Mux3_Data    (dbg_Mux3_Data_07   [63:0]), // input  from Mux
                                     .dbg_Mux3_Clk     (dbg_Mux3_Clk_07    [3:0]), // input  from Mux
                                     .dbg_Mux4_SelLane (dbg_Mux4_SelLane_07[35:0]), // output to   Mux
                                     .dbg_Mux4_Data    (dbg_Mux4_Data_07   [63:0]), // input  from Mux
                                     .dbg_Mux4_Clk     (dbg_Mux4_Clk_07    [3:0]), // input  from Mux
                                     .dbg_Mux5_SelLane (dbg_Mux5_SelLane_07[35:0]), // output to   Mux
                                     .dbg_Mux5_Data    (dbg_Mux5_Data_07   [63:0]), // input  from Mux
                                     .dbg_Mux5_Clk     (dbg_Mux5_Clk_07    [3:0]), // input  from Mux
                                     .DbgBlkId                 (8'h07            ),
                                     .AEB_DBUS                 (AEB_DBUS         ),
                                     .TEST_CLK_EN              (TEST_CLK_EN      ),
                                     .dbg_BlkId                (dbg_BlkId_07[7:0])
                                     );
   dbg_client_ssb__mux  #( .LANE_COUNT(4)
                         , .LANE_WIDTH(16)
                         )
     I_dbg_client_ssb__mux_07a (
                                .dbg_BlkId           (dbg_BlkId_07[7:0]                 ),
                                .dbg_Mux_SelLane     (dbg_Mux3_SelLane_07[35:0]),
                                .dbg_Mux_Data        (dbg_Mux3_Data_07   [63:0]),
                                .dbg_Mux_Clk         (dbg_Mux3_Clk_07    [3:0]),

                                .clk                 (dataClk[0]                         ),
                           .idebug0   (64'h00070000),
                           .idebug1   (64'h00070001),
                           .idebug2   (64'h00070002),
                           .idebug3   (64'h00070003),
                           .idebug4   (64'h00070004),
                           .idebug5   (64'h00070005),
                           .idebug6   (64'h00070006),
                           .idebug7   (64'h00070007),
                           .idebug8   (64'h00070008),
                           .idebug9   (64'h00070009),
                           .idebug10   (64'h0007000a),
                           .idebug11   (64'h0007000b),
                           .idebug12   (64'h0007000c),
                           .idebug13   (64'h0007000d),
                           .idebug14   (64'h0007000e),
                           .idebug15   (64'h0007000f),
                           .idebug16   (64'h00070010),
                           .idebug17   (64'h00070011),
                           .idebug18   (64'h00070012),
                           .idebug19   (64'h00070013),
                           .idebug20   (64'h00070014),
                           .idebug21   (64'h00070015),
                           .idebug22   (64'h00070016),
                           .idebug23   (64'h00070017),
                           .idebug24   (64'h00070018),
                           .idebug25   (64'h00070019),
                           .idebug26   (64'h0007001a),
                           .idebug27   (64'h0007001b),
                           .idebug28   (64'h0007001c),
                           .idebug29   (64'h0007001d),
                           .idebug30   (64'h0007001e),
                           .idebug31   (64'h0007001f),
                           .idebug32   (64'h00000020),
                           .idebug33   (64'h00000021),
                           .idebug34   (64'h00000022),
                           .idebug35   (64'h00000023),
                           .idebug36   (64'h00000024),
                           .idebug37   (64'h00000025),
                           .idebug38   (64'h00000026),
                           .idebug39   (64'h00000027),
                           .idebug40   (64'h00000028),
                           .idebug41   (64'h00000029),
                           .idebug42   (64'h0000002a),
                           .idebug43   (64'h0000002b),
                           .idebug44   (64'h0000002c),
                           .idebug45   (64'h0000002d),
                           .idebug46   (64'h0000002e),
                           .idebug47   (64'h0000002f),
                           .idebug48   (64'h00000030),
                           .idebug49   (64'h00000031),
                           .idebug50   (64'h00000032),
                           .idebug51   (64'h00000033),
                           .idebug52   (64'h00000034),
                           .idebug53   (64'h00000035),
                           .idebug54   (64'h00000036),
                           .idebug55   (64'h00000037),
                           .idebug56   (64'h00000038),
                           .idebug57   (64'h00000039),
                           .idebug58   (64'h0000003a),
                           .idebug59   (64'h0000003b),
                           .idebug60   (64'h0000003c),
                           .idebug61   (64'h0000003d),
                           .idebug62   (64'h0000003e),
                                .TEST_CLK_EN         (TEST_CLK_EN                       ),
                                .ctlProg_ClkOn       (ctlProg_ClkOn_             )
                                );
   dbg_client_ssb__mux  #( .LANE_COUNT(4)
                         , .LANE_WIDTH(16)
                         )
     I_dbg_client_ssb__mux_07b (
                                .dbg_BlkId           (dbg_BlkId_07[7:0]                 ),
                                .dbg_Mux_SelLane     (dbg_Mux3_SelLane_07n[35:0]),
                                .dbg_Mux_Data        (dbg_Mux3_Data_07n   [63:0]),
                                .dbg_Mux_Clk         (dbg_Mux3_Clk_07n    [3:0]),

                                .clk                 (dataClk[1]                         ),
                           .idebug0   (64'h00000000),
                           .idebug1   (64'h00000001),
                           .idebug2   (64'h00000002),
                           .idebug3   (64'h00000003),
                           .idebug4   (64'h00000004),
                           .idebug5   (64'h00000005),
                           .idebug6   (64'h00000006),
                           .idebug7   (64'h00000007),
                           .idebug8   (64'h00000008),
                           .idebug9   (64'h00000009),
                           .idebug10   (64'h0000000a),
                           .idebug11   (64'h0000000b),
                           .idebug12   (64'h0000000c),
                           .idebug13   (64'h0000000d),
                           .idebug14   (64'h0000000e),
                           .idebug15   (64'h0000000f),
                           .idebug16   (64'h00000010),
                           .idebug17   (64'h00000011),
                           .idebug18   (64'h00000012),
                           .idebug19   (64'h00000013),
                           .idebug20   (64'h00000014),
                           .idebug21   (64'h00000015),
                           .idebug22   (64'h00000016),
                           .idebug23   (64'h00000017),
                           .idebug24   (64'h00000018),
                           .idebug25   (64'h00000019),
                           .idebug26   (64'h0000001a),
                           .idebug27   (64'h0000001b),
                           .idebug28   (64'h0000001c),
                           .idebug29   (64'h0000001d),
                           .idebug30   (64'h0000001e),
                           .idebug31   (64'h0000001f),
                           .idebug32   (64'h00000020),
                           .idebug33   (64'h00040021),
                           .idebug34   (64'h00040022),
                           .idebug35   (64'h00040023),
                           .idebug36   (64'h00040024),
                           .idebug37   (64'h00040025),
                           .idebug38   (64'h00040026),
                           .idebug39   (64'h00040027),
                           .idebug40   (64'h00040028),
                           .idebug41   (64'h00040029),
                           .idebug42   (64'h0004002a),
                           .idebug43   (64'h0004002b),
                           .idebug44   (64'h0004002c),
                           .idebug45   (64'h0004002d),
                           .idebug46   (64'h0004002e),
                           .idebug47   (64'h0004002f),
                           .idebug48   (64'h00040030),
                           .idebug49   (64'h00040031),
                           .idebug50   (64'h00040032),
                           .idebug51   (64'h00040033),
                           .idebug52   (64'h00040034),
                           .idebug53   (64'h00040035),
                           .idebug54   (64'h00040036),
                           .idebug55   (64'h00040037),
                           .idebug56   (64'h00040038),
                           .idebug57   (64'h00040039),
                           .idebug58   (64'h0004003a),
                           .idebug59   (64'h0004003b),
                           .idebug60   (64'h0004003c),
                           .idebug61   (64'h0004003d),
                           .idebug62   (64'h0004003e),
                                .TEST_CLK_EN         (TEST_CLK_EN                       ),
                                .ctlProg_ClkOn       (ctlProg_ClkOn_             )
                                );
   dbg_client_ssb__mux_clk #(.LANE_COUNT(4)
                            , .LANE_WIDTH(16)
                            )
     I_dbg_client_ssb__mux_clk_07 (
                                   .dbg_Mux_SelLane     (dbg_Mux3_SelLane_07m[35:0]),
                                   .dbg_Mux_Data        (dbg_Mux3_Data_07m   [63:0]),
                                   .dbg_Mux_Clk         (dbg_Mux3_Clk_07m    [3:0]),

                                   .clk                 (dataClk[2]                        ),
                                   .TEST_CLK_EN         (TEST_CLK_EN                       ),
                                   .ctlProg_ClkOn       (ctlProg_ClkOn_             )
                                   );

   dbg_client_ssb__aon_steer #( .LANE_COUNT(4)
                              , .LANE_WIDTH(16)
                              )
     I_dbg_client_ssb__aon_steer_AB (
                                     .TARG_DBUS_daisychain_ctl (nxt_ctl_07 [1:0]          ), // From dbgu
                                     .TARG_DBUS_daisychain_cclk(nxt_clk_07                ),
                                     .TARG_DBUS_daisychain_data(nxt_data_07[63:0]),
                                     .TARG_DBUS_daisychain_dclk(nxt_dclk_07[3:0]),

                                     .DBUS_TARG_daisychain_ctl (nxt_ctl_AB [1:0]          ),
                                     .DBUS_TARG_daisychain_cclk(nxt_clk_AB                ),
                                     .DBUS_TARG_daisychain_data(nxt_data_AB[63:0]),
                                     .DBUS_TARG_daisychain_dclk(nxt_dclk_AB[3:0]),

                                     .ctlProg_ClkOn            (ctlProg_ClkOn_     ),
                                     .dbg_Mux0_SelLane (dbg_Mux0_SelLane_AB[35:0]), // output to   Mux
                                     .dbg_Mux0_Data    (dbg_Mux0_Data_AB   [63:0]), // input  from Mux
                                     .dbg_Mux0_Clk     (dbg_Mux0_Clk_AB    [3:0]), // input  from Mux
                                     .dbg_Mux1_SelLane (dbg_Mux1_SelLane_AB[35:0]), // output to   Mux
                                     .dbg_Mux1_Data    (dbg_Mux1_Data_AB   [63:0]), // input  from Mux
                                     .dbg_Mux1_Clk     (dbg_Mux1_Clk_AB    [3:0]), // input  from Mux
                                     .dbg_Mux2_SelLane (dbg_Mux2_SelLane_AB[35:0]), // output to   Mux
                                     .dbg_Mux2_Data    (dbg_Mux2_Data_AB   [63:0]), // input  from Mux
                                     .dbg_Mux2_Clk     (dbg_Mux2_Clk_AB    [3:0]), // input  from Mux
                                     .dbg_Mux3_SelLane (dbg_Mux3_SelLane_AB[35:0]), // output to   Mux
                                     .dbg_Mux3_Data    (dbg_Mux3_Data_AB   [63:0]), // input  from Mux
                                     .dbg_Mux3_Clk     (dbg_Mux3_Clk_AB    [3:0]), // input  from Mux
                                     .dbg_Mux4_SelLane (dbg_Mux4_SelLane_AB[35:0]), // output to   Mux
                                     .dbg_Mux4_Data    (dbg_Mux4_Data_AB   [63:0]), // input  from Mux
                                     .dbg_Mux4_Clk     (dbg_Mux4_Clk_AB    [3:0]), // input  from Mux
                                     .dbg_Mux5_SelLane (dbg_Mux5_SelLane_AB[35:0]), // output to   Mux
                                     .dbg_Mux5_Data    (dbg_Mux5_Data_AB   [63:0]), // input  from Mux
                                     .dbg_Mux5_Clk     (dbg_Mux5_Clk_AB    [3:0]), // input  from Mux
                                     .DbgBlkId                 (8'hAB            ),
                                     .AEB_DBUS                 (AEB_DBUS         ),
                                     .TEST_CLK_EN              (TEST_CLK_EN      ),
                                     .dbg_BlkId                (dbg_BlkId_AB[7:0])
                                     );
   dbg_client_ssb__mux  #( .LANE_COUNT(4)
                         , .LANE_WIDTH(16)
                         )
     I_dbg_client_ssb__mux_AB (
                                .dbg_BlkId           (dbg_BlkId_AB[7:0]                 ),
                                .dbg_Mux_SelLane     (dbg_Mux5_SelLane_AB[35:0]),
                                .dbg_Mux_Data        (dbg_Mux5_Data_AB   [63:0]),
                                .dbg_Mux_Clk         (dbg_Mux5_Clk_AB    [3:0]),

                                .clk                 (dataClk[0]                        ),
                           .idebug0   (64'h00ab0000),
                           .idebug1   (64'h00ab0001),
                           .idebug2   (64'h00ab0002),
                           .idebug3   (64'h00ab0003),
                           .idebug4   (64'h00ab0004),
                           .idebug5   (64'h00ab0005),
                           .idebug6   (64'h00ab0006),
                           .idebug7   (64'h00ab0007),
                           .idebug8   (64'h00ab0008),
                           .idebug9   (64'h00ab0009),
                           .idebug10   (64'h00ab000a),
                           .idebug11   (64'h00ab000b),
                           .idebug12   (64'h00ab000c),
                           .idebug13   (64'h00ab000d),
                           .idebug14   (64'h00ab000e),
                           .idebug15   (64'h00ab000f),
                           .idebug16   (64'h00ab0010),
                           .idebug17   (64'h00ab0011),
                           .idebug18   (64'h00ab0012),
                           .idebug19   (64'h00ab0013),
                           .idebug20   (64'h00ab0014),
                           .idebug21   (64'h00ab0015),
                           .idebug22   (64'h00ab0016),
                           .idebug23   (64'h00ab0017),
                           .idebug24   (64'h00ab0018),
                           .idebug25   (64'h00ab0019),
                           .idebug26   (64'h00ab001a),
                           .idebug27   (64'h00ab001b),
                           .idebug28   (64'h00ab001c),
                           .idebug29   (64'h00ab001d),
                           .idebug30   (64'h00ab001e),
                           .idebug31   (64'h00ab001f),
                           .idebug32   (64'h00ab0020),
                           .idebug33   (64'h00ab0021),
                           .idebug34   (64'h00ab0022),
                           .idebug35   (64'h00ab0023),
                           .idebug36   (64'h00ab0024),
                           .idebug37   (64'h00ab0025),
                           .idebug38   (64'h00ab0026),
                           .idebug39   (64'h00ab0027),
                           .idebug40   (64'h00ab0028),
                           .idebug41   (64'h00ab0029),
                           .idebug42   (64'h00ab002a),
                           .idebug43   (64'h00ab002b),
                           .idebug44   (64'h00ab002c),
                           .idebug45   (64'h00ab002d),
                           .idebug46   (64'h00ab002e),
                           .idebug47   (64'h00ab002f),
                           .idebug48   (64'h00ab0030),
                           .idebug49   (64'h00ab0031),
                           .idebug50   (64'h00ab0032),
                           .idebug51   (64'h00ab0033),
                           .idebug52   (64'h00ab0034),
                           .idebug53   (64'h00ab0035),
                           .idebug54   (64'h00ab0036),
                           .idebug55   (64'h00ab0037),
                           .idebug56   (64'h00ab0038),
                           .idebug57   (64'h00ab0039),
                           .idebug58   (64'h00ab003a),
                           .idebug59   (64'h00ab003b),
                           .idebug60   (64'h00ab003c),
                           .idebug61   (64'h00ab003d),
                           .idebug62   (64'h00ab003e),
                                .TEST_CLK_EN         (TEST_CLK_EN                       ),
                                .ctlProg_ClkOn       (ctlProg_ClkOn_             )
                                );
// <ssb_ 64> End   ---------------------------------------------------------------------------------------------
// <asyn 12> Begin ---------------------------------------------------------------------------------------------
/*
  wire [26:0]  dbg_Mux0_SelLane_05 ;
  wire [11:0]  dbg_Mux0_Data_05    ;
  wire [26:0]  dbg_Mux0_SelLane_AC ;
  wire [11:0]  dbg_Mux0_Data_AC    ;
  wire [26:0]  dbg_Mux1_SelLane_05 ;
  wire [11:0]  dbg_Mux1_Data_05    ;
  wire [26:0]  dbg_Mux1_SelLane_AC ;
  wire [11:0]  dbg_Mux1_Data_AC    ;
  wire [26:0]  dbg_Mux2_SelLane_05 ;
  wire [11:0]  dbg_Mux2_Data_05    ;
  wire [26:0]  dbg_Mux2_SelLane_AC ;
  wire [11:0]  dbg_Mux2_Data_AC    ;
  wire [26:0]  dbg_Mux3_SelLane_05 ;
  wire [11:0]  dbg_Mux3_Data_05    ;
  wire [26:0]  dbg_Mux3_SelLane_AC ;
  wire [11:0]  dbg_Mux3_Data_AC    ;
  wire [26:0]  dbg_Mux4_SelLane_05 ;
  wire [11:0]  dbg_Mux4_Data_05    ;
  wire [26:0]  dbg_Mux4_SelLane_AC ;
  wire [11:0]  dbg_Mux4_Data_AC    ;
  wire [26:0]  dbg_Mux5_SelLane_05 ;
  wire [11:0]  dbg_Mux5_Data_05    ;
  wire [26:0]  dbg_Mux5_SelLane_AC ;
  wire [11:0]  dbg_Mux5_Data_AC    ;
  wire [11:0]  async_12_daisychain_data;

  wire [7:0]            dbg_BlkId_05;
  wire                  dbg_active_05;
  wire                  dbg_rst_05;
  wire [1:0]            nxt_ctl_05;
  wire                  nxt_clk_05;
  wire [11:0]  nxt_data_05;
  wire [7:0]            dbg_BlkId_AC;
  wire                  dbg_active_AC;
  wire                  dbg_rst_AC;
  wire [1:0]            nxt_ctl_AC;
  wire                  nxt_clk_AC;
  wire [11:0]  nxt_data_AC;
   dbg_client_asyn_aon_steer #( .LANE_COUNT(3)
                              , .LANE_WIDTH(4)
                              )
     I_dbg_client_asyn_aon_steer_05 (
                                     .TARG_DBUS_daisychain_ctl (TARG_DBUS_daisychain_ctl[1:0]), // From dbgu
                                     .TARG_DBUS_daisychain_cclk(ipclk                        ),
                                     .TARG_DBUS_daisychain_data(async_12_daisychain_data[11:0] ),

                                     .DBUS_TARG_daisychain_ctl (nxt_ctl_05 [1:0]),
                                     .DBUS_TARG_daisychain_cclk(nxt_clk_05      ),
                                     .DBUS_TARG_daisychain_data(nxt_data_05[11:0]),
                                     .dbg_Mux0_SelLane (dbg_Mux0_SelLane_05[26:0]), // output to   Mux
                                     .dbg_Mux0_Data    (dbg_Mux0_Data_05   [11:0]), // input  from Mux
                                     .dbg_Mux1_SelLane (dbg_Mux1_SelLane_05[26:0]), // output to   Mux
                                     .dbg_Mux1_Data    (dbg_Mux1_Data_05   [11:0]), // input  from Mux
                                     .dbg_Mux2_SelLane (dbg_Mux2_SelLane_05[26:0]), // output to   Mux
                                     .dbg_Mux2_Data    (dbg_Mux2_Data_05   [11:0]), // input  from Mux
                                     .dbg_Mux3_SelLane (dbg_Mux3_SelLane_05[26:0]), // output to   Mux
                                     .dbg_Mux3_Data    (dbg_Mux3_Data_05   [11:0]), // input  from Mux
                                     .dbg_Mux4_SelLane (dbg_Mux4_SelLane_05[26:0]), // output to   Mux
                                     .dbg_Mux4_Data    (dbg_Mux4_Data_05   [11:0]), // input  from Mux
                                     .dbg_Mux5_SelLane (dbg_Mux5_SelLane_05[26:0]), // output to   Mux
                                     .dbg_Mux5_Data    (dbg_Mux5_Data_05   [11:0]), // input  from Mux

                                     .DbgBlkId                 (8'h05            ),
                                     .AEB_DBUS                 (AEB_DBUS         ),
                                     .TEST_CLK_EN              (TEST_CLK_EN      ),
                                     .dbg_BlkId                (dbg_BlkId_05[7:0])
                                     );
  dbg_client_asyn_mux #( .LANE_COUNT(3)
                       , .LANE_WIDTH(4)
                       )
    I_dbg_client_asyn_mux_05 (
                           .idebug0   (12'h000),
                           .idebug1   (12'h001),
                           .idebug2   (12'h002),
                           .idebug3   (12'h003),
                           .idebug4   (12'h004),
                           .idebug5   (12'h005),
                           .idebug6   (12'h006),
                           .idebug7   (12'h007),
                           .idebug8   (12'h008),
                           .idebug9   (12'h009),
                           .idebug10   (12'h00a),
                           .idebug11   (12'h00b),
                           .idebug12   (12'h00c),
                           .idebug13   (12'h00d),
                           .idebug14   (12'h00e),
                           .idebug15   (12'h00f),
                           .idebug16   (12'h010),
                           .idebug17   (12'h011),
                           .idebug18   (12'h012),
                           .idebug19   (12'h013),
                           .idebug20   (12'h014),
                           .idebug21   (12'h015),
                           .idebug22   (12'h016),
                           .idebug23   (12'h017),
                           .idebug24   (12'h018),
                           .idebug25   (12'h019),
                           .idebug26   (12'h01a),
                           .idebug27   (12'h01b),
                           .idebug28   (12'h01c),
                           .idebug29   (12'h01d),
                           .idebug30   (12'h01e),
                           .idebug31   (12'h01f),
                           .idebug32   (12'h020),
                           .idebug33   (12'h021),
                           .idebug34   (12'h022),
                           .idebug35   (12'h023),
                           .idebug36   (12'h024),
                           .idebug37   (12'h025),
                           .idebug38   (12'h026),
                           .idebug39   (12'h027),
                           .idebug40   (12'h028),
                           .idebug41   (12'h029),
                           .idebug42   (12'h02a),
                           .idebug43   (12'h02b),
                           .idebug44   (12'h02c),
                           .idebug45   (12'h02d),
                           .idebug46   (12'h02e),
                           .idebug47   (12'h02f),
                           .idebug48   (12'h030),
                           .idebug49   (12'h031),
                           .idebug50   (12'h032),
                           .idebug51   (12'h033),
                           .idebug52   (12'h034),
                           .idebug53   (12'h035),
                           .idebug54   (12'h036),
                           .idebug55   (12'h037),
                           .idebug56   (12'h038),
                           .idebug57   (12'h039),
                           .idebug58   (12'h03a),
                           .idebug59   (12'h03b),
                           .idebug60   (12'h03c),
                           .idebug61   (12'h03d),
                           .idebug62   (12'h03e),

                              .dbg_Mux_SelLane     (dbg_Mux2_SelLane_05[26:0]),
                              .dbg_Mux_Data        (dbg_Mux2_Data_05   [11:0]),
                              .dbg_BlkId           (dbg_BlkId_05[7:0]                 )

                              );
//------------------------------------------------------
   dbg_client_asyn_aon_steer #( .LANE_COUNT(3)
                              , .LANE_WIDTH(4)
                              )
     I_dbg_client_asyn_aon_steer_AC (
                                     .TARG_DBUS_daisychain_ctl (nxt_ctl_05 [1:0]          ), // From dbgu
                                     .TARG_DBUS_daisychain_cclk(nxt_clk_05                ),
                                     .TARG_DBUS_daisychain_data(nxt_data_05[11:0]),

                                     .DBUS_TARG_daisychain_ctl (nxt_ctl_AC [1:0]          ),
                                     .DBUS_TARG_daisychain_cclk(nxt_clk_AC                ),
                                     .DBUS_TARG_daisychain_data(nxt_data_AC[11:0]),
                                     .dbg_Mux0_SelLane (dbg_Mux0_SelLane_AC[26:0]), // output to   Mux
                                     .dbg_Mux0_Data    (dbg_Mux0_Data_AC   [11:0]), // input  from Mux
                                     .dbg_Mux1_SelLane (dbg_Mux1_SelLane_AC[26:0]), // output to   Mux
                                     .dbg_Mux1_Data    (dbg_Mux1_Data_AC   [11:0]), // input  from Mux
                                     .dbg_Mux2_SelLane (dbg_Mux2_SelLane_AC[26:0]), // output to   Mux
                                     .dbg_Mux2_Data    (dbg_Mux2_Data_AC   [11:0]), // input  from Mux
                                     .dbg_Mux3_SelLane (dbg_Mux3_SelLane_AC[26:0]), // output to   Mux
                                     .dbg_Mux3_Data    (dbg_Mux3_Data_AC   [11:0]), // input  from Mux
                                     .dbg_Mux4_SelLane (dbg_Mux4_SelLane_AC[26:0]), // output to   Mux
                                     .dbg_Mux4_Data    (dbg_Mux4_Data_AC   [11:0]), // input  from Mux
                                     .dbg_Mux5_SelLane (dbg_Mux5_SelLane_AC[26:0]), // output to   Mux
                                     .dbg_Mux5_Data    (dbg_Mux5_Data_AC   [11:0]), // input  from Mux

                                     .DbgBlkId                 (8'hAC            ),
                                     .AEB_DBUS                 (AEB_DBUS         ),
                                     .TEST_CLK_EN              (TEST_CLK_EN      ),
                                     .dbg_BlkId                (dbg_BlkId_AC[7:0])
                                     );

  dbg_client_asyn_mux #( .LANE_COUNT(3)
                       , .LANE_WIDTH(4)
                       )
    I_dbg_client_asyn_mux_AC (
                           .idebug0   (12'h000),
                           .idebug1   (12'h001),
                           .idebug2   (12'h002),
                           .idebug3   (12'h003),
                           .idebug4   (12'h004),
                           .idebug5   (12'h005),
                           .idebug6   (12'h006),
                           .idebug7   (12'h007),
                           .idebug8   (12'h008),
                           .idebug9   (12'h009),
                           .idebug10   (12'h00a),
                           .idebug11   (12'h00b),
                           .idebug12   (12'h00c),
                           .idebug13   (12'h00d),
                           .idebug14   (12'h00e),
                           .idebug15   (12'h00f),
                           .idebug16   (12'h010),
                           .idebug17   (12'h011),
                           .idebug18   (12'h012),
                           .idebug19   (12'h013),
                           .idebug20   (12'h014),
                           .idebug21   (12'h015),
                           .idebug22   (12'h016),
                           .idebug23   (12'h017),
                           .idebug24   (12'h018),
                           .idebug25   (12'h019),
                           .idebug26   (12'h01a),
                           .idebug27   (12'h01b),
                           .idebug28   (12'h01c),
                           .idebug29   (12'h01d),
                           .idebug30   (12'h01e),
                           .idebug31   (12'h01f),
                           .idebug32   (12'h020),
                           .idebug33   (12'h021),
                           .idebug34   (12'h022),
                           .idebug35   (12'h023),
                           .idebug36   (12'h024),
                           .idebug37   (12'h025),
                           .idebug38   (12'h026),
                           .idebug39   (12'h027),
                           .idebug40   (12'h028),
                           .idebug41   (12'h029),
                           .idebug42   (12'h02a),
                           .idebug43   (12'h02b),
                           .idebug44   (12'h02c),
                           .idebug45   (12'h02d),
                           .idebug46   (12'h02e),
                           .idebug47   (12'h02f),
                           .idebug48   (12'h030),
                           .idebug49   (12'h031),
                           .idebug50   (12'h032),
                           .idebug51   (12'h033),
                           .idebug52   (12'h034),
                           .idebug53   (12'h035),
                           .idebug54   (12'h036),
                           .idebug55   (12'h037),
                           .idebug56   (12'h038),
                           .idebug57   (12'h039),
                           .idebug58   (12'h03a),
                           .idebug59   (12'h03b),
                           .idebug60   (12'h03c),
                           .idebug61   (12'h03d),
                           .idebug62   (12'h03e),

                              .dbg_Mux_SelLane     (dbg_Mux2_SelLane_AC[26:0]),
                              .dbg_Mux_Data        (dbg_Mux2_Data_AC   [11:0]),
                              .dbg_BlkId           (dbg_BlkId_AC[7:0]                 )

                              );
*/
// <asyn 12> End   ---------------------------------------------------------------------------------------------

endmodule // dbg_bench_module
// =========================================================================================================
// setup for emacs
//Local Variables:
//verilog-library-directories:(".")
//verilog-library-flags:("")
//End:
// =========================================================================================================
