//                              -*- Mode: Verilog -*-
// (c) 2015, 2016 Advanced Micro Devices, Inc. All rights reserved.

////////////////////////////////////////////////////////////////////////////
//
// Filename    : dbg_client_ssb__clkmux.v
// Description : This is a copy of clkmux.v from (dfxlib 3):
// P4PORT=svvp4s02.amd.com:1677
// depotFile //sysip/dfx/dfxlib-3/3.0/main/src/rtl/misc/clkmux.v
//
// NOTE : This clock mux is NOT clitch free
//
////////////////////////////////////////////////////////////////////////////
// Hard code this to only support 8:1
////////////////////////////////////////////////////////////////////////////
module dbg_client_ssb__clkmux
#(parameter MUX_USED = 8'b11000000 )

( output       clk_o
, input [7:0]  clk_i
, input [2:0]  sel
);

  localparam  MUX_L1 = {|MUX_USED[7:6], |MUX_USED[5:4], |MUX_USED[3:2], |MUX_USED[1:0]} ;
  localparam  MUX_L2 = {|MUX_USED[7:4], |MUX_USED[3:0]} ;

  wire [3:0]  clk_mux_l0;
  wire [1:0]  clk_mux_l1;

  dbg_client_clkmux_2to1 #(.MUX_USED(MUX_USED[1:0])) I_mux_l0_0 (.clk_o(clk_mux_l0[0]), .clk_i(clk_i[1:0]     ), .sel(sel[0]));
  dbg_client_clkmux_2to1 #(.MUX_USED(MUX_USED[3:2])) I_mux_l0_1 (.clk_o(clk_mux_l0[1]), .clk_i(clk_i[3:2]     ), .sel(sel[0]));
  dbg_client_clkmux_2to1 #(.MUX_USED(MUX_USED[5:4])) I_mux_l0_2 (.clk_o(clk_mux_l0[2]), .clk_i(clk_i[5:4]     ), .sel(sel[0]));
  dbg_client_clkmux_2to1 #(.MUX_USED(MUX_USED[7:6])) I_mux_l0_3 (.clk_o(clk_mux_l0[3]), .clk_i(clk_i[7:6]     ), .sel(sel[0]));

  dbg_client_clkmux_2to1 #(.MUX_USED(MUX_L1[1:0]  )) I_mux_l1_0 (.clk_o(clk_mux_l1[0]), .clk_i(clk_mux_l0[1:0]), .sel(sel[1]));
  dbg_client_clkmux_2to1 #(.MUX_USED(MUX_L1[3:2]  )) I_mux_l1_1 (.clk_o(clk_mux_l1[1]), .clk_i(clk_mux_l0[3:2]), .sel(sel[1]));

  dbg_client_clkmux_2to1 #(.MUX_USED(MUX_L2[1:0]  )) I_mux_l2_0 (.clk_o(clk_o        ), .clk_i(clk_mux_l1[1:0]), .sel(sel[2]));

endmodule // dbg_client_ssb__clkmux
