//                              -*- Mode: Verilog -*-
// (c) 2015, 2016 Advanced Micro Devices, Inc. All rights reserved.

////////////////////////////////////////////////////////////////////////////
//
// Filename    : dbg_client_ssb__mux_flop.v
// Description : Flop stage to help timing for input to dbg_client_ssb__mux
//               User not required to used this module, but served as an example of usage
//
////////////////////////////////////////////////////////////////////////////
module dbg_client_ssb__mux_flop
#(parameter LANE_COUNT = 4
,           LANE_WIDTH = 8
)

( output [(LANE_COUNT*LANE_WIDTH-1):0] idebug        // Debug-bus data output to dbg_client_sync_mux
, input  [(LANE_COUNT*LANE_WIDTH-1):0] debugIn       // Debug-bus data inputs from functional logic
  
, input                                clk           // clock to drive dbg_client_ssb__clkmux instance
, input                                ctlProg_ClkOn // Async reset and clear data
);

  reg [(LANE_COUNT*LANE_WIDTH-1):0]       reg_debug;
  assign                                  idebug[(LANE_COUNT*LANE_WIDTH-1):0] = reg_debug[(LANE_COUNT*LANE_WIDTH-1):0];

  always @(posedge clk or negedge ctlProg_ClkOn)
    if (~ctlProg_ClkOn)
      reg_debug[(LANE_COUNT*LANE_WIDTH-1):0] <= {(LANE_COUNT*LANE_WIDTH-1) {1'b0}};
    else
      reg_debug[(LANE_COUNT*LANE_WIDTH-1):0] <= debugIn[(LANE_COUNT*LANE_WIDTH-1):0];

endmodule // dbg_client_sync_mux_flop
