//                              -*- Mode: Verilog -*-
// (c) 2015, 2016 Advanced Micro Devices, Inc. All rights reserved.

////////////////////////////////////////////////////////////////////////////
//
// Filename    : dbg_client_mux.v.dpl
// Description : Mux for synchronous debug bus client.
//
// NOTE : Multi-clock case should use Source-synchronous debug bus client
//
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
// Print out some input parameters to dperl --- begin
// MKEY          = 
// synchronicity = 
// DBG_WIDTH     = 
// DBG_IN_CNT    = 
// Print out some input parameters to dperl ----- end
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

module dbg_client_sync_mux (
ipclk           , // system clock

// ==========================================================================
// interface with _dbg_client_steer
// Begin --------------------------------------------------------------------
dbg_active      , // Clock gater control
dbg_BlkId       , // Debug bus ID used for debug the debug bus client (same as DbgBlkId)
dbg_Mux_SelLane , // LANE_COUNT * ([8] Lane Enable; [7:6] Byte Select; [5:0] Channel Select;)
dbg_Mux_Data    , // Debug-bus data outputs after muxing
// End ----------------------------------------------------------------------

// ==========================================================================
// Debug-bus data inputs from functional logic
// Begin --------------------------------------------------------------------
idebug62 ,
idebug61 ,
idebug60 ,
idebug59 ,
idebug58 ,
idebug57 ,
idebug56 ,
idebug55 ,
idebug54 ,
idebug53 ,
idebug52 ,
idebug51 ,
idebug50 ,
idebug49 ,
idebug48 ,
idebug47 ,
idebug46 ,
idebug45 ,
idebug44 ,
idebug43 ,
idebug42 ,
idebug41 ,
idebug40 ,
idebug39 ,
idebug38 ,
idebug37 ,
idebug36 ,
idebug35 ,
idebug34 ,
idebug33 ,
idebug32 ,
idebug31 ,
idebug30 ,
idebug29 ,
idebug28 ,
idebug27 ,
idebug26 ,
idebug25 ,
idebug24 ,
idebug23 ,
idebug22 ,
idebug21 ,
idebug20 ,
idebug19 ,
idebug18 ,
idebug17 ,
idebug16 ,
idebug15 ,
idebug14 ,
idebug13 ,
idebug12 ,
idebug11 ,
idebug10 ,
idebug9 ,
idebug8 ,
idebug7 ,
idebug6 ,
idebug5 ,
idebug4 ,
idebug3 ,
idebug2 ,
idebug1 ,
idebug0 ,
// End ----------------------------------------------------------------------

gclk          , // Gated clock for potential pipe stage
dbg_rst       , // Combined global reset with command decoded reset
TEST_CLK_EN     // Gater override for test mode

);
parameter        LANE_COUNT     = 4            ;
parameter        LANE_WIDTH     = 8            ;
parameter [0:0]  INCL_DBG_DBG   = 1'b1         ; // Include dbg_client_sync_debug
parameter [62:0] FLOPPED_INPUTS = {63 {1'b0}}  ; // flag to add flop before the mux

input                            ipclk           ; // system clock

// ==========================================================================
// interface with _dbg_client_steer
// Begin --------------------------------------------------------------------
input                                   dbg_active      ; // Clock gater control
input       [7:0]                       dbg_BlkId       ; // Debug bus ID used for debug the debug bus client (same as DbgBlkId)
input       [LANE_COUNT*9         -1:0] dbg_Mux_SelLane ; // LANE_COUNT * ([8] Lane Enable; [7:6] Byte Select; [5:0] Channel Select;)
output wire [LANE_COUNT*LANE_WIDTH-1:0] dbg_Mux_Data    ; // Debug-bus data outputs after muxing
// End ----------------------------------------------------------------------

// ==========================================================================
// Debug-bus data inputs from functional logic
// Begin --------------------------------------------------------------------
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug62 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug61 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug60 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug59 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug58 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug57 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug56 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug55 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug54 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug53 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug52 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug51 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug50 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug49 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug48 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug47 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug46 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug45 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug44 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug43 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug42 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug41 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug40 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug39 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug38 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug37 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug36 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug35 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug34 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug33 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug32 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug31 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug30 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug29 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug28 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug27 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug26 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug25 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug24 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug23 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug22 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug21 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug20 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug19 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug18 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug17 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug16 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug15 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug14 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug13 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug12 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug11 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug10 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug9 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug8 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug7 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug6 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug5 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug4 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug3 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug2 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug1 ;
input       [LANE_COUNT*LANE_WIDTH-1:0] idebug0 ;
// End ----------------------------------------------------------------------

output wire                      gclk          ; // Gated clock for potential pipe stage
input                            dbg_rst       ; // Combined global reset with command decoded reset
input                            TEST_CLK_EN   ; // Gater override for test mode

localparam BUS_WIDTH      = LANE_COUNT*LANE_WIDTH;

wire [BUS_WIDTH-1:0] dbg_L2DataMuxLane ;
reg  [BUS_WIDTH-1:0] reg_MuxData       ;

//--------------------------------------- Begin
// avoid 2d array duee  to leda complication
wire [BUS_WIDTH-1:0] bdebug63;
wire [BUS_WIDTH-1:0] bdebug62;
wire [BUS_WIDTH-1:0] bdebug61;
wire [BUS_WIDTH-1:0] bdebug60;
wire [BUS_WIDTH-1:0] bdebug59;
wire [BUS_WIDTH-1:0] bdebug58;
wire [BUS_WIDTH-1:0] bdebug57;
wire [BUS_WIDTH-1:0] bdebug56;
wire [BUS_WIDTH-1:0] bdebug55;
wire [BUS_WIDTH-1:0] bdebug54;
wire [BUS_WIDTH-1:0] bdebug53;
wire [BUS_WIDTH-1:0] bdebug52;
wire [BUS_WIDTH-1:0] bdebug51;
wire [BUS_WIDTH-1:0] bdebug50;
wire [BUS_WIDTH-1:0] bdebug49;
wire [BUS_WIDTH-1:0] bdebug48;
wire [BUS_WIDTH-1:0] bdebug47;
wire [BUS_WIDTH-1:0] bdebug46;
wire [BUS_WIDTH-1:0] bdebug45;
wire [BUS_WIDTH-1:0] bdebug44;
wire [BUS_WIDTH-1:0] bdebug43;
wire [BUS_WIDTH-1:0] bdebug42;
wire [BUS_WIDTH-1:0] bdebug41;
wire [BUS_WIDTH-1:0] bdebug40;
wire [BUS_WIDTH-1:0] bdebug39;
wire [BUS_WIDTH-1:0] bdebug38;
wire [BUS_WIDTH-1:0] bdebug37;
wire [BUS_WIDTH-1:0] bdebug36;
wire [BUS_WIDTH-1:0] bdebug35;
wire [BUS_WIDTH-1:0] bdebug34;
wire [BUS_WIDTH-1:0] bdebug33;
wire [BUS_WIDTH-1:0] bdebug32;
wire [BUS_WIDTH-1:0] bdebug31;
wire [BUS_WIDTH-1:0] bdebug30;
wire [BUS_WIDTH-1:0] bdebug29;
wire [BUS_WIDTH-1:0] bdebug28;
wire [BUS_WIDTH-1:0] bdebug27;
wire [BUS_WIDTH-1:0] bdebug26;
wire [BUS_WIDTH-1:0] bdebug25;
wire [BUS_WIDTH-1:0] bdebug24;
wire [BUS_WIDTH-1:0] bdebug23;
wire [BUS_WIDTH-1:0] bdebug22;
wire [BUS_WIDTH-1:0] bdebug21;
wire [BUS_WIDTH-1:0] bdebug20;
wire [BUS_WIDTH-1:0] bdebug19;
wire [BUS_WIDTH-1:0] bdebug18;
wire [BUS_WIDTH-1:0] bdebug17;
wire [BUS_WIDTH-1:0] bdebug16;
wire [BUS_WIDTH-1:0] bdebug15;
wire [BUS_WIDTH-1:0] bdebug14;
wire [BUS_WIDTH-1:0] bdebug13;
wire [BUS_WIDTH-1:0] bdebug12;
wire [BUS_WIDTH-1:0] bdebug11;
wire [BUS_WIDTH-1:0] bdebug10;
wire [BUS_WIDTH-1:0] bdebug9;
wire [BUS_WIDTH-1:0] bdebug8;
wire [BUS_WIDTH-1:0] bdebug7;
wire [BUS_WIDTH-1:0] bdebug6;
wire [BUS_WIDTH-1:0] bdebug5;
wire [BUS_WIDTH-1:0] bdebug4;
wire [BUS_WIDTH-1:0] bdebug3;
wire [BUS_WIDTH-1:0] bdebug2;
wire [BUS_WIDTH-1:0] bdebug1;
wire [BUS_WIDTH-1:0] bdebug0;
//----------------------------------------- End

//////////////////////////////////////////////////////////////////////////|
//                        Debug-Bus PipeLine                            //|
//////////////////////////////////////////////////////////////////////////|

// Clock gater (/import/rtllib/src/rtl/ati_clock_gate.v)
ati_clock_gate I_gclk (.clk_out(gclk), .clk_src(ipclk), .clk_en(dbg_active | dbg_rst), .TE(TEST_CLK_EN));

  assign dbg_Mux_Data[BUS_WIDTH-1:0] = reg_MuxData[BUS_WIDTH-1:0];

  always @(posedge gclk)
    if (dbg_rst)
      reg_MuxData[BUS_WIDTH-1:0] <= {BUS_WIDTH {1'b0}};
    else
      reg_MuxData[BUS_WIDTH-1:0] <= dbg_L2DataMuxLane[BUS_WIDTH-1 :0];

generate
//////////////////////////////////////////////////////////////////////////|
//                   <Debug-Bus Mux - all combo logic>                  //|
//////////////////////////////////////////////////////////////////////////|
// This module is in common with synchronous version                    //|
//////////////////////////////////////////////////////////////////////////|
   if (LANE_COUNT>3) begin : dbg_client_64to1_lane_mux_3
     dbg_client_64to1_lane_mux #(
                .LANE_COUNT(LANE_COUNT),
                .LANE_WIDTH(LANE_WIDTH),
                .LANE_INDEX(3))
             I_dbg_client_64to1_lane_mux_3
               (
                .dbg_Mux_SelLane(dbg_Mux_SelLane[35:27]),
                .idebug63(bdebug63[BUS_WIDTH-1:0]),
                .idebug62(bdebug62[BUS_WIDTH-1:0]),
                .idebug61(bdebug61[BUS_WIDTH-1:0]),
                .idebug60(bdebug60[BUS_WIDTH-1:0]),
                .idebug59(bdebug59[BUS_WIDTH-1:0]),
                .idebug58(bdebug58[BUS_WIDTH-1:0]),
                .idebug57(bdebug57[BUS_WIDTH-1:0]),
                .idebug56(bdebug56[BUS_WIDTH-1:0]),
                .idebug55(bdebug55[BUS_WIDTH-1:0]),
                .idebug54(bdebug54[BUS_WIDTH-1:0]),
                .idebug53(bdebug53[BUS_WIDTH-1:0]),
                .idebug52(bdebug52[BUS_WIDTH-1:0]),
                .idebug51(bdebug51[BUS_WIDTH-1:0]),
                .idebug50(bdebug50[BUS_WIDTH-1:0]),
                .idebug49(bdebug49[BUS_WIDTH-1:0]),
                .idebug48(bdebug48[BUS_WIDTH-1:0]),
                .idebug47(bdebug47[BUS_WIDTH-1:0]),
                .idebug46(bdebug46[BUS_WIDTH-1:0]),
                .idebug45(bdebug45[BUS_WIDTH-1:0]),
                .idebug44(bdebug44[BUS_WIDTH-1:0]),
                .idebug43(bdebug43[BUS_WIDTH-1:0]),
                .idebug42(bdebug42[BUS_WIDTH-1:0]),
                .idebug41(bdebug41[BUS_WIDTH-1:0]),
                .idebug40(bdebug40[BUS_WIDTH-1:0]),
                .idebug39(bdebug39[BUS_WIDTH-1:0]),
                .idebug38(bdebug38[BUS_WIDTH-1:0]),
                .idebug37(bdebug37[BUS_WIDTH-1:0]),
                .idebug36(bdebug36[BUS_WIDTH-1:0]),
                .idebug35(bdebug35[BUS_WIDTH-1:0]),
                .idebug34(bdebug34[BUS_WIDTH-1:0]),
                .idebug33(bdebug33[BUS_WIDTH-1:0]),
                .idebug32(bdebug32[BUS_WIDTH-1:0]),
                .idebug31(bdebug31[BUS_WIDTH-1:0]),
                .idebug30(bdebug30[BUS_WIDTH-1:0]),
                .idebug29(bdebug29[BUS_WIDTH-1:0]),
                .idebug28(bdebug28[BUS_WIDTH-1:0]),
                .idebug27(bdebug27[BUS_WIDTH-1:0]),
                .idebug26(bdebug26[BUS_WIDTH-1:0]),
                .idebug25(bdebug25[BUS_WIDTH-1:0]),
                .idebug24(bdebug24[BUS_WIDTH-1:0]),
                .idebug23(bdebug23[BUS_WIDTH-1:0]),
                .idebug22(bdebug22[BUS_WIDTH-1:0]),
                .idebug21(bdebug21[BUS_WIDTH-1:0]),
                .idebug20(bdebug20[BUS_WIDTH-1:0]),
                .idebug19(bdebug19[BUS_WIDTH-1:0]),
                .idebug18(bdebug18[BUS_WIDTH-1:0]),
                .idebug17(bdebug17[BUS_WIDTH-1:0]),
                .idebug16(bdebug16[BUS_WIDTH-1:0]),
                .idebug15(bdebug15[BUS_WIDTH-1:0]),
                .idebug14(bdebug14[BUS_WIDTH-1:0]),
                .idebug13(bdebug13[BUS_WIDTH-1:0]),
                .idebug12(bdebug12[BUS_WIDTH-1:0]),
                .idebug11(bdebug11[BUS_WIDTH-1:0]),
                .idebug10(bdebug10[BUS_WIDTH-1:0]),
                .idebug9(bdebug9[BUS_WIDTH-1:0]),
                .idebug8(bdebug8[BUS_WIDTH-1:0]),
                .idebug7(bdebug7[BUS_WIDTH-1:0]),
                .idebug6(bdebug6[BUS_WIDTH-1:0]),
                .idebug5(bdebug5[BUS_WIDTH-1:0]),
                .idebug4(bdebug4[BUS_WIDTH-1:0]),
                .idebug3(bdebug3[BUS_WIDTH-1:0]),
                .idebug2(bdebug2[BUS_WIDTH-1:0]),
                .idebug1(bdebug1[BUS_WIDTH-1:0]),
                .idebug0(bdebug0[BUS_WIDTH-1:0]),
                .dbg_L2DataMuxLane(dbg_L2DataMuxLane[((3+1)*LANE_WIDTH)-1:3*LANE_WIDTH])
               );
   end // if (LANE_COUNT>3)

   if (LANE_COUNT>2) begin : dbg_client_64to1_lane_mux_2
     dbg_client_64to1_lane_mux #(
                .LANE_COUNT(LANE_COUNT),
                .LANE_WIDTH(LANE_WIDTH),
                .LANE_INDEX(2))
             I_dbg_client_64to1_lane_mux_2
               (
                .dbg_Mux_SelLane(dbg_Mux_SelLane[26:18]),
                .idebug63(bdebug63[BUS_WIDTH-1:0]),
                .idebug62(bdebug62[BUS_WIDTH-1:0]),
                .idebug61(bdebug61[BUS_WIDTH-1:0]),
                .idebug60(bdebug60[BUS_WIDTH-1:0]),
                .idebug59(bdebug59[BUS_WIDTH-1:0]),
                .idebug58(bdebug58[BUS_WIDTH-1:0]),
                .idebug57(bdebug57[BUS_WIDTH-1:0]),
                .idebug56(bdebug56[BUS_WIDTH-1:0]),
                .idebug55(bdebug55[BUS_WIDTH-1:0]),
                .idebug54(bdebug54[BUS_WIDTH-1:0]),
                .idebug53(bdebug53[BUS_WIDTH-1:0]),
                .idebug52(bdebug52[BUS_WIDTH-1:0]),
                .idebug51(bdebug51[BUS_WIDTH-1:0]),
                .idebug50(bdebug50[BUS_WIDTH-1:0]),
                .idebug49(bdebug49[BUS_WIDTH-1:0]),
                .idebug48(bdebug48[BUS_WIDTH-1:0]),
                .idebug47(bdebug47[BUS_WIDTH-1:0]),
                .idebug46(bdebug46[BUS_WIDTH-1:0]),
                .idebug45(bdebug45[BUS_WIDTH-1:0]),
                .idebug44(bdebug44[BUS_WIDTH-1:0]),
                .idebug43(bdebug43[BUS_WIDTH-1:0]),
                .idebug42(bdebug42[BUS_WIDTH-1:0]),
                .idebug41(bdebug41[BUS_WIDTH-1:0]),
                .idebug40(bdebug40[BUS_WIDTH-1:0]),
                .idebug39(bdebug39[BUS_WIDTH-1:0]),
                .idebug38(bdebug38[BUS_WIDTH-1:0]),
                .idebug37(bdebug37[BUS_WIDTH-1:0]),
                .idebug36(bdebug36[BUS_WIDTH-1:0]),
                .idebug35(bdebug35[BUS_WIDTH-1:0]),
                .idebug34(bdebug34[BUS_WIDTH-1:0]),
                .idebug33(bdebug33[BUS_WIDTH-1:0]),
                .idebug32(bdebug32[BUS_WIDTH-1:0]),
                .idebug31(bdebug31[BUS_WIDTH-1:0]),
                .idebug30(bdebug30[BUS_WIDTH-1:0]),
                .idebug29(bdebug29[BUS_WIDTH-1:0]),
                .idebug28(bdebug28[BUS_WIDTH-1:0]),
                .idebug27(bdebug27[BUS_WIDTH-1:0]),
                .idebug26(bdebug26[BUS_WIDTH-1:0]),
                .idebug25(bdebug25[BUS_WIDTH-1:0]),
                .idebug24(bdebug24[BUS_WIDTH-1:0]),
                .idebug23(bdebug23[BUS_WIDTH-1:0]),
                .idebug22(bdebug22[BUS_WIDTH-1:0]),
                .idebug21(bdebug21[BUS_WIDTH-1:0]),
                .idebug20(bdebug20[BUS_WIDTH-1:0]),
                .idebug19(bdebug19[BUS_WIDTH-1:0]),
                .idebug18(bdebug18[BUS_WIDTH-1:0]),
                .idebug17(bdebug17[BUS_WIDTH-1:0]),
                .idebug16(bdebug16[BUS_WIDTH-1:0]),
                .idebug15(bdebug15[BUS_WIDTH-1:0]),
                .idebug14(bdebug14[BUS_WIDTH-1:0]),
                .idebug13(bdebug13[BUS_WIDTH-1:0]),
                .idebug12(bdebug12[BUS_WIDTH-1:0]),
                .idebug11(bdebug11[BUS_WIDTH-1:0]),
                .idebug10(bdebug10[BUS_WIDTH-1:0]),
                .idebug9(bdebug9[BUS_WIDTH-1:0]),
                .idebug8(bdebug8[BUS_WIDTH-1:0]),
                .idebug7(bdebug7[BUS_WIDTH-1:0]),
                .idebug6(bdebug6[BUS_WIDTH-1:0]),
                .idebug5(bdebug5[BUS_WIDTH-1:0]),
                .idebug4(bdebug4[BUS_WIDTH-1:0]),
                .idebug3(bdebug3[BUS_WIDTH-1:0]),
                .idebug2(bdebug2[BUS_WIDTH-1:0]),
                .idebug1(bdebug1[BUS_WIDTH-1:0]),
                .idebug0(bdebug0[BUS_WIDTH-1:0]),
                .dbg_L2DataMuxLane(dbg_L2DataMuxLane[((2+1)*LANE_WIDTH)-1:2*LANE_WIDTH])
               );
   end // if (LANE_COUNT>2)

   if (LANE_COUNT>1) begin : dbg_client_64to1_lane_mux_1
     dbg_client_64to1_lane_mux #(
                .LANE_COUNT(LANE_COUNT),
                .LANE_WIDTH(LANE_WIDTH),
                .LANE_INDEX(1))
             I_dbg_client_64to1_lane_mux_1
               (
                .dbg_Mux_SelLane(dbg_Mux_SelLane[17:9]),
                .idebug63(bdebug63[BUS_WIDTH-1:0]),
                .idebug62(bdebug62[BUS_WIDTH-1:0]),
                .idebug61(bdebug61[BUS_WIDTH-1:0]),
                .idebug60(bdebug60[BUS_WIDTH-1:0]),
                .idebug59(bdebug59[BUS_WIDTH-1:0]),
                .idebug58(bdebug58[BUS_WIDTH-1:0]),
                .idebug57(bdebug57[BUS_WIDTH-1:0]),
                .idebug56(bdebug56[BUS_WIDTH-1:0]),
                .idebug55(bdebug55[BUS_WIDTH-1:0]),
                .idebug54(bdebug54[BUS_WIDTH-1:0]),
                .idebug53(bdebug53[BUS_WIDTH-1:0]),
                .idebug52(bdebug52[BUS_WIDTH-1:0]),
                .idebug51(bdebug51[BUS_WIDTH-1:0]),
                .idebug50(bdebug50[BUS_WIDTH-1:0]),
                .idebug49(bdebug49[BUS_WIDTH-1:0]),
                .idebug48(bdebug48[BUS_WIDTH-1:0]),
                .idebug47(bdebug47[BUS_WIDTH-1:0]),
                .idebug46(bdebug46[BUS_WIDTH-1:0]),
                .idebug45(bdebug45[BUS_WIDTH-1:0]),
                .idebug44(bdebug44[BUS_WIDTH-1:0]),
                .idebug43(bdebug43[BUS_WIDTH-1:0]),
                .idebug42(bdebug42[BUS_WIDTH-1:0]),
                .idebug41(bdebug41[BUS_WIDTH-1:0]),
                .idebug40(bdebug40[BUS_WIDTH-1:0]),
                .idebug39(bdebug39[BUS_WIDTH-1:0]),
                .idebug38(bdebug38[BUS_WIDTH-1:0]),
                .idebug37(bdebug37[BUS_WIDTH-1:0]),
                .idebug36(bdebug36[BUS_WIDTH-1:0]),
                .idebug35(bdebug35[BUS_WIDTH-1:0]),
                .idebug34(bdebug34[BUS_WIDTH-1:0]),
                .idebug33(bdebug33[BUS_WIDTH-1:0]),
                .idebug32(bdebug32[BUS_WIDTH-1:0]),
                .idebug31(bdebug31[BUS_WIDTH-1:0]),
                .idebug30(bdebug30[BUS_WIDTH-1:0]),
                .idebug29(bdebug29[BUS_WIDTH-1:0]),
                .idebug28(bdebug28[BUS_WIDTH-1:0]),
                .idebug27(bdebug27[BUS_WIDTH-1:0]),
                .idebug26(bdebug26[BUS_WIDTH-1:0]),
                .idebug25(bdebug25[BUS_WIDTH-1:0]),
                .idebug24(bdebug24[BUS_WIDTH-1:0]),
                .idebug23(bdebug23[BUS_WIDTH-1:0]),
                .idebug22(bdebug22[BUS_WIDTH-1:0]),
                .idebug21(bdebug21[BUS_WIDTH-1:0]),
                .idebug20(bdebug20[BUS_WIDTH-1:0]),
                .idebug19(bdebug19[BUS_WIDTH-1:0]),
                .idebug18(bdebug18[BUS_WIDTH-1:0]),
                .idebug17(bdebug17[BUS_WIDTH-1:0]),
                .idebug16(bdebug16[BUS_WIDTH-1:0]),
                .idebug15(bdebug15[BUS_WIDTH-1:0]),
                .idebug14(bdebug14[BUS_WIDTH-1:0]),
                .idebug13(bdebug13[BUS_WIDTH-1:0]),
                .idebug12(bdebug12[BUS_WIDTH-1:0]),
                .idebug11(bdebug11[BUS_WIDTH-1:0]),
                .idebug10(bdebug10[BUS_WIDTH-1:0]),
                .idebug9(bdebug9[BUS_WIDTH-1:0]),
                .idebug8(bdebug8[BUS_WIDTH-1:0]),
                .idebug7(bdebug7[BUS_WIDTH-1:0]),
                .idebug6(bdebug6[BUS_WIDTH-1:0]),
                .idebug5(bdebug5[BUS_WIDTH-1:0]),
                .idebug4(bdebug4[BUS_WIDTH-1:0]),
                .idebug3(bdebug3[BUS_WIDTH-1:0]),
                .idebug2(bdebug2[BUS_WIDTH-1:0]),
                .idebug1(bdebug1[BUS_WIDTH-1:0]),
                .idebug0(bdebug0[BUS_WIDTH-1:0]),
                .dbg_L2DataMuxLane(dbg_L2DataMuxLane[((1+1)*LANE_WIDTH)-1:1*LANE_WIDTH])
               );
   end // if (LANE_COUNT>1)

   if (LANE_COUNT>0) begin : dbg_client_64to1_lane_mux_0
     dbg_client_64to1_lane_mux #(
                .LANE_COUNT(LANE_COUNT),
                .LANE_WIDTH(LANE_WIDTH),
                .LANE_INDEX(0))
             I_dbg_client_64to1_lane_mux_0
               (
                .dbg_Mux_SelLane(dbg_Mux_SelLane[8:0]),
                .idebug63(bdebug63[BUS_WIDTH-1:0]),
                .idebug62(bdebug62[BUS_WIDTH-1:0]),
                .idebug61(bdebug61[BUS_WIDTH-1:0]),
                .idebug60(bdebug60[BUS_WIDTH-1:0]),
                .idebug59(bdebug59[BUS_WIDTH-1:0]),
                .idebug58(bdebug58[BUS_WIDTH-1:0]),
                .idebug57(bdebug57[BUS_WIDTH-1:0]),
                .idebug56(bdebug56[BUS_WIDTH-1:0]),
                .idebug55(bdebug55[BUS_WIDTH-1:0]),
                .idebug54(bdebug54[BUS_WIDTH-1:0]),
                .idebug53(bdebug53[BUS_WIDTH-1:0]),
                .idebug52(bdebug52[BUS_WIDTH-1:0]),
                .idebug51(bdebug51[BUS_WIDTH-1:0]),
                .idebug50(bdebug50[BUS_WIDTH-1:0]),
                .idebug49(bdebug49[BUS_WIDTH-1:0]),
                .idebug48(bdebug48[BUS_WIDTH-1:0]),
                .idebug47(bdebug47[BUS_WIDTH-1:0]),
                .idebug46(bdebug46[BUS_WIDTH-1:0]),
                .idebug45(bdebug45[BUS_WIDTH-1:0]),
                .idebug44(bdebug44[BUS_WIDTH-1:0]),
                .idebug43(bdebug43[BUS_WIDTH-1:0]),
                .idebug42(bdebug42[BUS_WIDTH-1:0]),
                .idebug41(bdebug41[BUS_WIDTH-1:0]),
                .idebug40(bdebug40[BUS_WIDTH-1:0]),
                .idebug39(bdebug39[BUS_WIDTH-1:0]),
                .idebug38(bdebug38[BUS_WIDTH-1:0]),
                .idebug37(bdebug37[BUS_WIDTH-1:0]),
                .idebug36(bdebug36[BUS_WIDTH-1:0]),
                .idebug35(bdebug35[BUS_WIDTH-1:0]),
                .idebug34(bdebug34[BUS_WIDTH-1:0]),
                .idebug33(bdebug33[BUS_WIDTH-1:0]),
                .idebug32(bdebug32[BUS_WIDTH-1:0]),
                .idebug31(bdebug31[BUS_WIDTH-1:0]),
                .idebug30(bdebug30[BUS_WIDTH-1:0]),
                .idebug29(bdebug29[BUS_WIDTH-1:0]),
                .idebug28(bdebug28[BUS_WIDTH-1:0]),
                .idebug27(bdebug27[BUS_WIDTH-1:0]),
                .idebug26(bdebug26[BUS_WIDTH-1:0]),
                .idebug25(bdebug25[BUS_WIDTH-1:0]),
                .idebug24(bdebug24[BUS_WIDTH-1:0]),
                .idebug23(bdebug23[BUS_WIDTH-1:0]),
                .idebug22(bdebug22[BUS_WIDTH-1:0]),
                .idebug21(bdebug21[BUS_WIDTH-1:0]),
                .idebug20(bdebug20[BUS_WIDTH-1:0]),
                .idebug19(bdebug19[BUS_WIDTH-1:0]),
                .idebug18(bdebug18[BUS_WIDTH-1:0]),
                .idebug17(bdebug17[BUS_WIDTH-1:0]),
                .idebug16(bdebug16[BUS_WIDTH-1:0]),
                .idebug15(bdebug15[BUS_WIDTH-1:0]),
                .idebug14(bdebug14[BUS_WIDTH-1:0]),
                .idebug13(bdebug13[BUS_WIDTH-1:0]),
                .idebug12(bdebug12[BUS_WIDTH-1:0]),
                .idebug11(bdebug11[BUS_WIDTH-1:0]),
                .idebug10(bdebug10[BUS_WIDTH-1:0]),
                .idebug9(bdebug9[BUS_WIDTH-1:0]),
                .idebug8(bdebug8[BUS_WIDTH-1:0]),
                .idebug7(bdebug7[BUS_WIDTH-1:0]),
                .idebug6(bdebug6[BUS_WIDTH-1:0]),
                .idebug5(bdebug5[BUS_WIDTH-1:0]),
                .idebug4(bdebug4[BUS_WIDTH-1:0]),
                .idebug3(bdebug3[BUS_WIDTH-1:0]),
                .idebug2(bdebug2[BUS_WIDTH-1:0]),
                .idebug1(bdebug1[BUS_WIDTH-1:0]),
                .idebug0(bdebug0[BUS_WIDTH-1:0]),
                .dbg_L2DataMuxLane(dbg_L2DataMuxLane[((0+1)*LANE_WIDTH)-1:0*LANE_WIDTH])
               );
   end // if (LANE_COUNT>0)

endgenerate

//////////////////////////////////////////////////////////////////////////|
//                      Flop Mux Input                                  //|
//////////////////////////////////////////////////////////////////////////|

generate
   if (FLOPPED_INPUTS[62]) begin : flop_input62_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug62[BUS_WIDTH-1:0]),
                                   .debugIn(idebug62[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input62_tomux
      assign bdebug62[BUS_WIDTH-1:0] = idebug62[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[61]) begin : flop_input61_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug61[BUS_WIDTH-1:0]),
                                   .debugIn(idebug61[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input61_tomux
      assign bdebug61[BUS_WIDTH-1:0] = idebug61[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[60]) begin : flop_input60_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug60[BUS_WIDTH-1:0]),
                                   .debugIn(idebug60[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input60_tomux
      assign bdebug60[BUS_WIDTH-1:0] = idebug60[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[59]) begin : flop_input59_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug59[BUS_WIDTH-1:0]),
                                   .debugIn(idebug59[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input59_tomux
      assign bdebug59[BUS_WIDTH-1:0] = idebug59[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[58]) begin : flop_input58_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug58[BUS_WIDTH-1:0]),
                                   .debugIn(idebug58[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input58_tomux
      assign bdebug58[BUS_WIDTH-1:0] = idebug58[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[57]) begin : flop_input57_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug57[BUS_WIDTH-1:0]),
                                   .debugIn(idebug57[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input57_tomux
      assign bdebug57[BUS_WIDTH-1:0] = idebug57[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[56]) begin : flop_input56_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug56[BUS_WIDTH-1:0]),
                                   .debugIn(idebug56[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input56_tomux
      assign bdebug56[BUS_WIDTH-1:0] = idebug56[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[55]) begin : flop_input55_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug55[BUS_WIDTH-1:0]),
                                   .debugIn(idebug55[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input55_tomux
      assign bdebug55[BUS_WIDTH-1:0] = idebug55[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[54]) begin : flop_input54_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug54[BUS_WIDTH-1:0]),
                                   .debugIn(idebug54[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input54_tomux
      assign bdebug54[BUS_WIDTH-1:0] = idebug54[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[53]) begin : flop_input53_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug53[BUS_WIDTH-1:0]),
                                   .debugIn(idebug53[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input53_tomux
      assign bdebug53[BUS_WIDTH-1:0] = idebug53[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[52]) begin : flop_input52_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug52[BUS_WIDTH-1:0]),
                                   .debugIn(idebug52[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input52_tomux
      assign bdebug52[BUS_WIDTH-1:0] = idebug52[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[51]) begin : flop_input51_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug51[BUS_WIDTH-1:0]),
                                   .debugIn(idebug51[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input51_tomux
      assign bdebug51[BUS_WIDTH-1:0] = idebug51[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[50]) begin : flop_input50_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug50[BUS_WIDTH-1:0]),
                                   .debugIn(idebug50[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input50_tomux
      assign bdebug50[BUS_WIDTH-1:0] = idebug50[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[49]) begin : flop_input49_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug49[BUS_WIDTH-1:0]),
                                   .debugIn(idebug49[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input49_tomux
      assign bdebug49[BUS_WIDTH-1:0] = idebug49[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[48]) begin : flop_input48_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug48[BUS_WIDTH-1:0]),
                                   .debugIn(idebug48[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input48_tomux
      assign bdebug48[BUS_WIDTH-1:0] = idebug48[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[47]) begin : flop_input47_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug47[BUS_WIDTH-1:0]),
                                   .debugIn(idebug47[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input47_tomux
      assign bdebug47[BUS_WIDTH-1:0] = idebug47[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[46]) begin : flop_input46_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug46[BUS_WIDTH-1:0]),
                                   .debugIn(idebug46[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input46_tomux
      assign bdebug46[BUS_WIDTH-1:0] = idebug46[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[45]) begin : flop_input45_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug45[BUS_WIDTH-1:0]),
                                   .debugIn(idebug45[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input45_tomux
      assign bdebug45[BUS_WIDTH-1:0] = idebug45[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[44]) begin : flop_input44_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug44[BUS_WIDTH-1:0]),
                                   .debugIn(idebug44[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input44_tomux
      assign bdebug44[BUS_WIDTH-1:0] = idebug44[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[43]) begin : flop_input43_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug43[BUS_WIDTH-1:0]),
                                   .debugIn(idebug43[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input43_tomux
      assign bdebug43[BUS_WIDTH-1:0] = idebug43[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[42]) begin : flop_input42_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug42[BUS_WIDTH-1:0]),
                                   .debugIn(idebug42[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input42_tomux
      assign bdebug42[BUS_WIDTH-1:0] = idebug42[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[41]) begin : flop_input41_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug41[BUS_WIDTH-1:0]),
                                   .debugIn(idebug41[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input41_tomux
      assign bdebug41[BUS_WIDTH-1:0] = idebug41[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[40]) begin : flop_input40_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug40[BUS_WIDTH-1:0]),
                                   .debugIn(idebug40[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input40_tomux
      assign bdebug40[BUS_WIDTH-1:0] = idebug40[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[39]) begin : flop_input39_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug39[BUS_WIDTH-1:0]),
                                   .debugIn(idebug39[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input39_tomux
      assign bdebug39[BUS_WIDTH-1:0] = idebug39[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[38]) begin : flop_input38_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug38[BUS_WIDTH-1:0]),
                                   .debugIn(idebug38[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input38_tomux
      assign bdebug38[BUS_WIDTH-1:0] = idebug38[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[37]) begin : flop_input37_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug37[BUS_WIDTH-1:0]),
                                   .debugIn(idebug37[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input37_tomux
      assign bdebug37[BUS_WIDTH-1:0] = idebug37[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[36]) begin : flop_input36_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug36[BUS_WIDTH-1:0]),
                                   .debugIn(idebug36[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input36_tomux
      assign bdebug36[BUS_WIDTH-1:0] = idebug36[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[35]) begin : flop_input35_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug35[BUS_WIDTH-1:0]),
                                   .debugIn(idebug35[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input35_tomux
      assign bdebug35[BUS_WIDTH-1:0] = idebug35[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[34]) begin : flop_input34_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug34[BUS_WIDTH-1:0]),
                                   .debugIn(idebug34[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input34_tomux
      assign bdebug34[BUS_WIDTH-1:0] = idebug34[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[33]) begin : flop_input33_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug33[BUS_WIDTH-1:0]),
                                   .debugIn(idebug33[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input33_tomux
      assign bdebug33[BUS_WIDTH-1:0] = idebug33[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[32]) begin : flop_input32_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug32[BUS_WIDTH-1:0]),
                                   .debugIn(idebug32[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input32_tomux
      assign bdebug32[BUS_WIDTH-1:0] = idebug32[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[31]) begin : flop_input31_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug31[BUS_WIDTH-1:0]),
                                   .debugIn(idebug31[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input31_tomux
      assign bdebug31[BUS_WIDTH-1:0] = idebug31[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[30]) begin : flop_input30_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug30[BUS_WIDTH-1:0]),
                                   .debugIn(idebug30[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input30_tomux
      assign bdebug30[BUS_WIDTH-1:0] = idebug30[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[29]) begin : flop_input29_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug29[BUS_WIDTH-1:0]),
                                   .debugIn(idebug29[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input29_tomux
      assign bdebug29[BUS_WIDTH-1:0] = idebug29[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[28]) begin : flop_input28_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug28[BUS_WIDTH-1:0]),
                                   .debugIn(idebug28[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input28_tomux
      assign bdebug28[BUS_WIDTH-1:0] = idebug28[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[27]) begin : flop_input27_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug27[BUS_WIDTH-1:0]),
                                   .debugIn(idebug27[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input27_tomux
      assign bdebug27[BUS_WIDTH-1:0] = idebug27[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[26]) begin : flop_input26_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug26[BUS_WIDTH-1:0]),
                                   .debugIn(idebug26[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input26_tomux
      assign bdebug26[BUS_WIDTH-1:0] = idebug26[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[25]) begin : flop_input25_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug25[BUS_WIDTH-1:0]),
                                   .debugIn(idebug25[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input25_tomux
      assign bdebug25[BUS_WIDTH-1:0] = idebug25[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[24]) begin : flop_input24_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug24[BUS_WIDTH-1:0]),
                                   .debugIn(idebug24[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input24_tomux
      assign bdebug24[BUS_WIDTH-1:0] = idebug24[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[23]) begin : flop_input23_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug23[BUS_WIDTH-1:0]),
                                   .debugIn(idebug23[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input23_tomux
      assign bdebug23[BUS_WIDTH-1:0] = idebug23[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[22]) begin : flop_input22_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug22[BUS_WIDTH-1:0]),
                                   .debugIn(idebug22[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input22_tomux
      assign bdebug22[BUS_WIDTH-1:0] = idebug22[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[21]) begin : flop_input21_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug21[BUS_WIDTH-1:0]),
                                   .debugIn(idebug21[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input21_tomux
      assign bdebug21[BUS_WIDTH-1:0] = idebug21[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[20]) begin : flop_input20_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug20[BUS_WIDTH-1:0]),
                                   .debugIn(idebug20[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input20_tomux
      assign bdebug20[BUS_WIDTH-1:0] = idebug20[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[19]) begin : flop_input19_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug19[BUS_WIDTH-1:0]),
                                   .debugIn(idebug19[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input19_tomux
      assign bdebug19[BUS_WIDTH-1:0] = idebug19[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[18]) begin : flop_input18_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug18[BUS_WIDTH-1:0]),
                                   .debugIn(idebug18[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input18_tomux
      assign bdebug18[BUS_WIDTH-1:0] = idebug18[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[17]) begin : flop_input17_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug17[BUS_WIDTH-1:0]),
                                   .debugIn(idebug17[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input17_tomux
      assign bdebug17[BUS_WIDTH-1:0] = idebug17[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[16]) begin : flop_input16_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug16[BUS_WIDTH-1:0]),
                                   .debugIn(idebug16[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input16_tomux
      assign bdebug16[BUS_WIDTH-1:0] = idebug16[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[15]) begin : flop_input15_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug15[BUS_WIDTH-1:0]),
                                   .debugIn(idebug15[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input15_tomux
      assign bdebug15[BUS_WIDTH-1:0] = idebug15[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[14]) begin : flop_input14_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug14[BUS_WIDTH-1:0]),
                                   .debugIn(idebug14[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input14_tomux
      assign bdebug14[BUS_WIDTH-1:0] = idebug14[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[13]) begin : flop_input13_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug13[BUS_WIDTH-1:0]),
                                   .debugIn(idebug13[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input13_tomux
      assign bdebug13[BUS_WIDTH-1:0] = idebug13[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[12]) begin : flop_input12_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug12[BUS_WIDTH-1:0]),
                                   .debugIn(idebug12[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input12_tomux
      assign bdebug12[BUS_WIDTH-1:0] = idebug12[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[11]) begin : flop_input11_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug11[BUS_WIDTH-1:0]),
                                   .debugIn(idebug11[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input11_tomux
      assign bdebug11[BUS_WIDTH-1:0] = idebug11[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[10]) begin : flop_input10_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug10[BUS_WIDTH-1:0]),
                                   .debugIn(idebug10[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input10_tomux
      assign bdebug10[BUS_WIDTH-1:0] = idebug10[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[9]) begin : flop_input9_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug9[BUS_WIDTH-1:0]),
                                   .debugIn(idebug9[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input9_tomux
      assign bdebug9[BUS_WIDTH-1:0] = idebug9[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[8]) begin : flop_input8_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug8[BUS_WIDTH-1:0]),
                                   .debugIn(idebug8[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input8_tomux
      assign bdebug8[BUS_WIDTH-1:0] = idebug8[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[7]) begin : flop_input7_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug7[BUS_WIDTH-1:0]),
                                   .debugIn(idebug7[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input7_tomux
      assign bdebug7[BUS_WIDTH-1:0] = idebug7[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[6]) begin : flop_input6_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug6[BUS_WIDTH-1:0]),
                                   .debugIn(idebug6[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input6_tomux
      assign bdebug6[BUS_WIDTH-1:0] = idebug6[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[5]) begin : flop_input5_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug5[BUS_WIDTH-1:0]),
                                   .debugIn(idebug5[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input5_tomux
      assign bdebug5[BUS_WIDTH-1:0] = idebug5[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[4]) begin : flop_input4_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug4[BUS_WIDTH-1:0]),
                                   .debugIn(idebug4[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input4_tomux
      assign bdebug4[BUS_WIDTH-1:0] = idebug4[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[3]) begin : flop_input3_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug3[BUS_WIDTH-1:0]),
                                   .debugIn(idebug3[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input3_tomux
      assign bdebug3[BUS_WIDTH-1:0] = idebug3[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[2]) begin : flop_input2_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug2[BUS_WIDTH-1:0]),
                                   .debugIn(idebug2[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input2_tomux
      assign bdebug2[BUS_WIDTH-1:0] = idebug2[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[1]) begin : flop_input1_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug1[BUS_WIDTH-1:0]),
                                   .debugIn(idebug1[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input1_tomux
      assign bdebug1[BUS_WIDTH-1:0] = idebug1[BUS_WIDTH-1:0];
   end

   if (FLOPPED_INPUTS[0]) begin : flop_input0_tomux
     dbg_client_sync_mux_flop #(.LANE_COUNT(LANE_COUNT), .LANE_WIDTH(LANE_WIDTH))
       I_dbg_client_sync_mux_flop (
                                   .idebug (bdebug0[BUS_WIDTH-1:0]),
                                   .debugIn(idebug0[BUS_WIDTH-1:0]),
                                   .gclk   (gclk                            ),
                                   .dbg_rst(dbg_rst                         )
                                   );
   end else begin : unflop_input0_tomux
      assign bdebug0[BUS_WIDTH-1:0] = idebug0[BUS_WIDTH-1:0];
   end


endgenerate


//////////////////////////////////////////////////////////////////////////|
//                      Debug Debug bus                                 //|
//////////////////////////////////////////////////////////////////////////|
generate
  if (INCL_DBG_DBG) begin : have_sync_debug
    dbg_client_sync_debug #(.LANE_COUNT(LANE_COUNT))
      I_dbg_client_sync_debug (
                               .ipclk          (ipclk                              ),
                               .dbg_BlkId      (dbg_BlkId[7:0]                     ),
                               .dbg_active     (dbg_active                         ),
                               .dbg_Mux_SelLane(dbg_Mux_SelLane[(LANE_COUNT*9-1):0]),
                               .idebug         (bdebug63[BUS_WIDTH-1:0]       ),
                               .dbg_rst        (dbg_rst                            ),
                               .TEST_CLK_EN    (TEST_CLK_EN                        )
                               );
  end else begin : no_sync_debug
       assign bdebug63[BUS_WIDTH-1:0] = {BUS_WIDTH {1'b0}};
  end
endgenerate

endmodule // dbg_client_sync_mux
