




module dft_corner_common_mic_ip_gc_dfx0_gc_tatd_t_COMMON_common_gc10 #(parameter 
   CdcXRawDly = 5000,
   PatCntSize = 25,     // number of bits in FirstFailCnt  
   ComnOSize = 5,       // number of common scan out channels used for Intest
   TilesNum = 20,        // Number of replicant tiles. minimum is 4.
   TileNumCode = 5       // Number of bits in the binary number for TilesNum
   )(
   input                                              TAM_CLK,                  //  TAMCLK input connected to Shift Clock
   input              [ComnOSize-1:0]                 CommonScanOutChannel_gc_tatd_t00000,  // from all TilesNum replicant tiles
   output     reg     [ComnOSize-1:0]   SelTileScanOutChannel_gc_tatd_t00000,    // select all of the tile scan channel to output SRF
   input              [ComnOSize-1:0]                 CommonScanOutChannel_gc_tatd_t00010,  // from all TilesNum replicant tiles
   output     reg     [ComnOSize-1:0]   SelTileScanOutChannel_gc_tatd_t00010,    // select all of the tile scan channel to output SRF
   input              [ComnOSize-1:0]                 CommonScanOutChannel_gc_tatd_t00020,  // from all TilesNum replicant tiles
   output     reg     [ComnOSize-1:0]   SelTileScanOutChannel_gc_tatd_t00020,    // select all of the tile scan channel to output SRF
   input              [ComnOSize-1:0]                 CommonScanOutChannel_gc_tatd_t00100,  // from all TilesNum replicant tiles
   output     reg     [ComnOSize-1:0]   SelTileScanOutChannel_gc_tatd_t00100,    // select all of the tile scan channel to output SRF
   input              [ComnOSize-1:0]                 CommonScanOutChannel_gc_tatd_t00110,  // from all TilesNum replicant tiles
   output     reg     [ComnOSize-1:0]   SelTileScanOutChannel_gc_tatd_t00110,    // select all of the tile scan channel to output SRF
   input              [ComnOSize-1:0]                 CommonScanOutChannel_gc_tatd_t01000,  // from all TilesNum replicant tiles
   output     reg     [ComnOSize-1:0]   SelTileScanOutChannel_gc_tatd_t01000,    // select all of the tile scan channel to output SRF
   input              [ComnOSize-1:0]                 CommonScanOutChannel_gc_tatd_t01010,  // from all TilesNum replicant tiles
   output     reg     [ComnOSize-1:0]   SelTileScanOutChannel_gc_tatd_t01010,    // select all of the tile scan channel to output SRF
   input              [ComnOSize-1:0]                 CommonScanOutChannel_gc_tatd_t01020,  // from all TilesNum replicant tiles
   output     reg     [ComnOSize-1:0]   SelTileScanOutChannel_gc_tatd_t01020,    // select all of the tile scan channel to output SRF
   input              [ComnOSize-1:0]                 CommonScanOutChannel_gc_tatd_t01100,  // from all TilesNum replicant tiles
   output     reg     [ComnOSize-1:0]   SelTileScanOutChannel_gc_tatd_t01100,    // select all of the tile scan channel to output SRF
   input              [ComnOSize-1:0]                 CommonScanOutChannel_gc_tatd_t01110,  // from all TilesNum replicant tiles
   output     reg     [ComnOSize-1:0]   SelTileScanOutChannel_gc_tatd_t01110,    // select all of the tile scan channel to output SRF
   input              [ComnOSize-1:0]                 Mic_ExpectIn,             // from input SRF
   input              [ComnOSize-1:0]                 Mic_CareIn,               // from input SRF. 
                                                                                // We use care instead of mask because SRF drives
                                                                                // zeros on non-selected channels.
   input                                              Mic_Reset,                // from MicTamCntl_TDR, Resets Sticky bits
   input                                              OrStickyOtherFailIn,        // from snap-on other partial MICTAM for other harvestable
                                                                               // channel group if one exists; otherwise connect 1'b0.
   input      wire    [TileNumCode-1:0]               Mic_ObserveTileTDR,        // from MicTamCntl_TDR, Selects replicant to observe
   
   input                                              ScanEn, 
   output     wire                                    CntrEn_d1,                // to other partial MICTAM(s) for other harvestable
                                                                                // channel group or groups

   output     wire    [(TilesNum*ComnOSize)-1:0]      StickyCommonFail,         // to MicTamResult_TDR
   output     wire    [TilesNum-1:0]                  FirstCommonFailTile,      // to MicTamResult_TDR
   output     wire    [PatCntSize-1:0]                FirstFailCnt              // to MicTamResult_TDR
  );
   genvar i;
   wire               [(TilesNum*ComnOSize)-1:0]      CommonFail; 
   wire               [ComnOSize-1:0]                 Mic_ExpectInReg; 
   wire               [ComnOSize-1:0]                 Mic_CareInReg; 
   wire               [ComnOSize-1:0]                 ScanOutChannelReg_gc_tatd_t00000;
   wire               [ComnOSize-1:0]                 ScanOutChannelReg_gc_tatd_t00010;
   wire               [ComnOSize-1:0]                 ScanOutChannelReg_gc_tatd_t00020;
   wire               [ComnOSize-1:0]                 ScanOutChannelReg_gc_tatd_t00100;
   wire               [ComnOSize-1:0]                 ScanOutChannelReg_gc_tatd_t00110;
   wire               [ComnOSize-1:0]                 ScanOutChannelReg_gc_tatd_t01000;
   wire               [ComnOSize-1:0]                 ScanOutChannelReg_gc_tatd_t01010;
   wire               [ComnOSize-1:0]                 ScanOutChannelReg_gc_tatd_t01020;
   wire               [ComnOSize-1:0]                 ScanOutChannelReg_gc_tatd_t01100;
   wire               [ComnOSize-1:0]                 ScanOutChannelReg_gc_tatd_t01110;
   wire               [(TilesNum*ComnOSize)-1:0]      ScanOutChannelReg;
   wire               [TilesNum-1:0]                  TileCommonFail;             // 
   wire               [(TilesNum*ComnOSize)-1:0]      NxtStickyCommonFail;        // 
   wire               [PatCntSize-1:0]                NxtCnt;

  MIC_IP_FLOP_GATED_gc10 #(.size(ComnOSize)) I_SCANOUTCHANREG_gc_tatd_t00000 ( 
   .C(TAM_CLK),
   .D(CommonScanOutChannel_gc_tatd_t00000), 
   .R(1'b0),
   .G(1'b1),
   .Q(ScanOutChannelReg_gc_tatd_t00000)   //
   );

//

  MIC_IP_FLOP_GATED_gc10 #(.size(ComnOSize)) I_SCANOUTCHANREG_gc_tatd_t00010 ( 
   .C(TAM_CLK),
   .D(CommonScanOutChannel_gc_tatd_t00010), 
   .R(1'b0),
   .G(1'b1),
   .Q(ScanOutChannelReg_gc_tatd_t00010)   //
   );

//

  MIC_IP_FLOP_GATED_gc10 #(.size(ComnOSize)) I_SCANOUTCHANREG_gc_tatd_t00020 ( 
   .C(TAM_CLK),
   .D(CommonScanOutChannel_gc_tatd_t00020), 
   .R(1'b0),
   .G(1'b1),
   .Q(ScanOutChannelReg_gc_tatd_t00020)   //
   );

//

  MIC_IP_FLOP_GATED_gc10 #(.size(ComnOSize)) I_SCANOUTCHANREG_gc_tatd_t00100 ( 
   .C(TAM_CLK),
   .D(CommonScanOutChannel_gc_tatd_t00100), 
   .R(1'b0),
   .G(1'b1),
   .Q(ScanOutChannelReg_gc_tatd_t00100)   //
   );

//

  MIC_IP_FLOP_GATED_gc10 #(.size(ComnOSize)) I_SCANOUTCHANREG_gc_tatd_t00110 ( 
   .C(TAM_CLK),
   .D(CommonScanOutChannel_gc_tatd_t00110), 
   .R(1'b0),
   .G(1'b1),
   .Q(ScanOutChannelReg_gc_tatd_t00110)   //
   );

//

  MIC_IP_FLOP_GATED_gc10 #(.size(ComnOSize)) I_SCANOUTCHANREG_gc_tatd_t01000 ( 
   .C(TAM_CLK),
   .D(CommonScanOutChannel_gc_tatd_t01000), 
   .R(1'b0),
   .G(1'b1),
   .Q(ScanOutChannelReg_gc_tatd_t01000)   //
   );

//

  MIC_IP_FLOP_GATED_gc10 #(.size(ComnOSize)) I_SCANOUTCHANREG_gc_tatd_t01010 ( 
   .C(TAM_CLK),
   .D(CommonScanOutChannel_gc_tatd_t01010), 
   .R(1'b0),
   .G(1'b1),
   .Q(ScanOutChannelReg_gc_tatd_t01010)   //
   );

//

  MIC_IP_FLOP_GATED_gc10 #(.size(ComnOSize)) I_SCANOUTCHANREG_gc_tatd_t01020 ( 
   .C(TAM_CLK),
   .D(CommonScanOutChannel_gc_tatd_t01020), 
   .R(1'b0),
   .G(1'b1),
   .Q(ScanOutChannelReg_gc_tatd_t01020)   //
   );

//

  MIC_IP_FLOP_GATED_gc10 #(.size(ComnOSize)) I_SCANOUTCHANREG_gc_tatd_t01100 ( 
   .C(TAM_CLK),
   .D(CommonScanOutChannel_gc_tatd_t01100), 
   .R(1'b0),
   .G(1'b1),
   .Q(ScanOutChannelReg_gc_tatd_t01100)   //
   );

//

  MIC_IP_FLOP_GATED_gc10 #(.size(ComnOSize)) I_SCANOUTCHANREG_gc_tatd_t01110 ( 
   .C(TAM_CLK),
   .D(CommonScanOutChannel_gc_tatd_t01110), 
   .R(1'b0),
   .G(1'b1),
   .Q(ScanOutChannelReg_gc_tatd_t01110)   //
   );

//


assign ScanOutChannelReg = {ScanOutChannelReg_gc_tatd_t01110, ScanOutChannelReg_gc_tatd_t01100, ScanOutChannelReg_gc_tatd_t01020, ScanOutChannelReg_gc_tatd_t01010, ScanOutChannelReg_gc_tatd_t01000, ScanOutChannelReg_gc_tatd_t00110, ScanOutChannelReg_gc_tatd_t00100, ScanOutChannelReg_gc_tatd_t00020, ScanOutChannelReg_gc_tatd_t00010, ScanOutChannelReg_gc_tatd_t00000};


  MIC_IP_FLOP_GATED_gc10 #(.size(ComnOSize)) I_EXPECTINREG ( 
   .C(TAM_CLK),
   .D(Mic_ExpectIn),
   .R(1'b0),
   .G(1'b1),
   .Q(Mic_ExpectInReg)   //
   );
   
  MIC_IP_FLOP_GATED_gc10 #(.size(ComnOSize)) I_CAREINREG ( 
   .C(TAM_CLK),
   .D(Mic_CareIn),
   .R(1'b0),
   .G(1'b1),
   .Q(Mic_CareInReg)   //
   );

   
// Comparator part  
   generate 
     for(i=0; i<TilesNum; i=i+1) begin: ReplicantCompareCommon
     
        assign CommonFail[((i+1)*ComnOSize-1):i*ComnOSize] = (ScanOutChannelReg[((i+1)*ComnOSize)-1:i*ComnOSize] ^ Mic_ExpectInReg[ComnOSize-1:0]) &  
                                                              Mic_CareInReg[ComnOSize-1:0];
     

       assign TileCommonFail[i]                                     = |CommonFail[((i+1)*ComnOSize)-1:i*ComnOSize];
       assign NxtStickyCommonFail[((i+1)*ComnOSize)-1:i*ComnOSize]  =  CommonFail[((i+1)*ComnOSize)-1:i*ComnOSize] | 
                                                                       StickyCommonFail[((i+1)*ComnOSize)-1:i*ComnOSize];   
     end //ReplicantCompareCommon
   endgenerate
   
// Mux part
   assign SelTileScanOutChannel_gc_tatd_t00000 = ScanOutChannelReg_gc_tatd_t00000;
   assign SelTileScanOutChannel_gc_tatd_t00010 = ScanOutChannelReg_gc_tatd_t00010;
   assign SelTileScanOutChannel_gc_tatd_t00020 = ScanOutChannelReg_gc_tatd_t00020;
   assign SelTileScanOutChannel_gc_tatd_t00100 = ScanOutChannelReg_gc_tatd_t00100;
   assign SelTileScanOutChannel_gc_tatd_t00110 = ScanOutChannelReg_gc_tatd_t00110;
   assign SelTileScanOutChannel_gc_tatd_t01000 = ScanOutChannelReg_gc_tatd_t01000;
   assign SelTileScanOutChannel_gc_tatd_t01010 = ScanOutChannelReg_gc_tatd_t01010;
   assign SelTileScanOutChannel_gc_tatd_t01020 = ScanOutChannelReg_gc_tatd_t01020;
   assign SelTileScanOutChannel_gc_tatd_t01100 = ScanOutChannelReg_gc_tatd_t01100;
   assign SelTileScanOutChannel_gc_tatd_t01110 = ScanOutChannelReg_gc_tatd_t01110;

   wire CntrEn;
   assign CntrEn  = ~|{NxtStickyCommonFail,OrStickyOtherFailIn};
   assign NxtCnt = (FirstFailCnt == {PatCntSize{1'b1}}) ? FirstFailCnt : FirstFailCnt + 1; // increment unless saturated
   
      

  MIC_IP_FLOP_GATED_gc10 #(.size(TilesNum*ComnOSize)) I_STICKYCOMN ( 
   .C(TAM_CLK),
   .D(NxtStickyCommonFail),
   .R(Mic_Reset),
   .G(1'b1),
   .Q(StickyCommonFail)   // Output to MicTamResult_TDR // BOZO: TAM_CLK=>TCK CDC
   );
   

 MIC_IP_FLOP_GATED_gc10 #(.size(PatCntSize)) I_FIRSTFAILCNT ( 
   .C(TAM_CLK),
   .D(NxtCnt),
   .R(Mic_Reset),
   .G(CntrEn),        // don't increment count on failing cycle.
   .Q(FirstFailCnt)   // Output to MicTamResult_TDR // BOZO: TAM_CLK=>TCK CDC
   // FirstFailCnt will likely need a decoder ring to convert count to pattern number and cycle number.
   // Counts every TAM_CLK cycle 'til failure is recorded.
   );
   
  MIC_IP_FLOP_GATED_gc10 #(.size(1)) I_CNTREN_D1 ( 
   .C(TAM_CLK),
   .D(CntrEn),        
   .R(1'b0),
   .G(1'b1),
   .Q(CntrEn_d1)
   );
   
   MIC_IP_FLOP_GATED_gc10 #(.size(TilesNum)) I_FIRSTFAILTILE ( 
   .C(TAM_CLK),
   .D(TileCommonFail),
   .R(Mic_Reset),
   .G(CntrEn_d1),      // clocking enabled 'til and including failing cycle
   .Q(FirstCommonFailTile)   // Output to MicTamResult_TDR // BOZO: TAM_CLK=>TCK CDC
   );
      
endmodule

