module dft_scmmarker (    

                // Inputs
                //--------------
                input  iSI,
                input  iCLK,
                input  iRstb,
                input  iShiftEn,

                // Outputs
                // -------------
                output reg oSO

);

localparam SCMMARKER_WIDTH   = 8;
localparam SCMMARKER_RST_VAL = 8'h66;

// *** Wire and reg declaration *** //

reg [SCMMARKER_WIDTH-1:0] shift_register;

//////////////////////
//   Shift and reset logic   //|
///////////////////////////////|

always @(posedge iCLK or negedge iRstb) begin  if (~iRstb)
   shift_register[SCMMARKER_WIDTH-1:0] <= SCMMARKER_RST_VAL;  else if (iShiftEn)
   shift_register[SCMMARKER_WIDTH-1:0] <= (iSI << SCMMARKER_WIDTH - 1) | (shift_register >> 1); end

///////////////////////|
//   SO assignment   //|
///////////////////////|

//NEGLATCH so_latch (.D(shift_register[0]), .ENb(iCLK), .Q(oSO));

always @(negedge iCLK or negedge iRstb) begin
   if (~iRstb)
                   oSO  <= 1'b0;
                else if(iShiftEn)
                                oSO <= shift_register[0];
  
end

endmodule



