`include "rtllib_features.vh"
module dfx_async_rst_sync3 (
input  wire clk,
input  wire rstinB,
output wire rstoutB
);

//Active low Async reset with depth-3

/*
  parameter      size           =  1;
  parameter      depth          =  2;
  parameter      sourceFlop     =  0;
  parameter      asyncSet       =  0;
  parameter      asyncReset     =  0;
  parameter      asyncFlush     =  0;
  parameter      clockEnable    =  0;
  parameter      scan_muxD      =  0;
  parameter      scan_LSSD      =  0;
  parameter      MultiVolt      =  0;
  parameter      TransportDelay =  0;
  parameter      TransportCycle =  1;
  parameter      InputCheck     =  1;
  parameter      MetaWindowMode =  0;
*/

techind_sync_icd  
# (
   .size(1),
   .depth(3),
   .sourceFlop(0),
   .asyncSet(0),
   .asyncReset(1),
   .asyncFlush(0),
   .clockEnable(0),
   .scan_muxD(1),
   .scan_LSSD(0),
   .MultiVolt(0),
   .TransportDelay(0),  //10000ps (100Mhz)
   .TransportCycle(3),  //3 destination cycle
   .InputCheck(1),
   .MetaWindowMode(0)

) techind_sync_icd (
    .SB(1'b0),
    .RB(rstinB),
    .FLUSH(1'b0),

`ifdef ABV
    .InputChkDis(1'b1), // always disable, ok to miss pulses here,
`endif

    .CKsrc(1'b0),
    .CKdst(clk),
    .EN(1'b1),
    .Dsrc(1'b1),
    .Qsrc(),
    .Qdst(rstoutB),

    .SC1(1'b0),
    .SC2(1'b0),
    .SE(1'b0),
    .SI(1'b0),
    .SO()
);


endmodule // dfx_async_rst_sync3

