
//----------------------------------------------------------------------------
//
// Author :		 Nehal Patel, S1-330 (Sunnyvale - Yan Dong), 44290 

//
// Notes  :		 DO NOT HAND EDIT THIS FILE!!!!!!
//	   		 This file was automatically derived from /local_vol1_nobackup/user/nepatel/dfxip4_0_tree1/dftmisc/src/meta/tools/scripts/odt2tdr_rtl.pl
//----------------------------------------------------------------------------
	  


module dfx_counter_tdr 
# (
   parameter DFX_COUNTER_WIDTH = 1
     )
  (



//Broadcast to All TDRs
input Tdr_Tck,
input Tdr_Trstb,
input Tdr_Tdi,
input Tdr_Shift,
input Tdr_Capture,
input Tdr_Update



//TDR --> DFX_COUNTER
 ,output wire [1-1:0] count_done_mask
 ,output wire [DFX_COUNTER_WIDTH-1+1-1:0] counter_value
 ,input Tdr_dfx_counter_En
 ,output Tdr_dfx_counter_Tdo
); // End of Port Declaration

///// START TDR_INST - DFX_COUNTER /////

   localparam DFX_COUNTER__WIDTH = DFX_COUNTER_WIDTH-1+1+1;
   wire [DFX_COUNTER__WIDTH-1:0]	DFX_COUNTER;
   wire [DFX_COUNTER__WIDTH-1:0]	DFX_COUNTER__DEFAULT;  

	//DFX_COUNTER - 0:0

   localparam  DFX_COUNTER_COUNT_DONE_MASK__WIDTH  = 1;
   localparam [DFX_COUNTER_COUNT_DONE_MASK__WIDTH-1:0] DFX_COUNTER_COUNT_DONE_MASK__DEFAULT  = 'h0;
   

   localparam  DFX_COUNTER_COUNT_DONE_MASK__MSB  = 0;
   localparam  DFX_COUNTER_COUNT_DONE_MASK__LSB  = 0;
   

   assign DFX_COUNTER__DEFAULT
                 [DFX_COUNTER_COUNT_DONE_MASK__MSB : 
                  DFX_COUNTER_COUNT_DONE_MASK__LSB] =  
		  DFX_COUNTER_COUNT_DONE_MASK__DEFAULT;
   

  ati_buffer1 mrk_dfx_counter_count_done_mask[DFX_COUNTER_COUNT_DONE_MASK__WIDTH-1:0] 
  (
    .A(DFX_COUNTER
      [DFX_COUNTER_COUNT_DONE_MASK__MSB :
       DFX_COUNTER_COUNT_DONE_MASK__LSB
      ]),    
    .Y(count_done_mask[DFX_COUNTER_COUNT_DONE_MASK__WIDTH-1:0])
  );


	//DFX_COUNTER - DFX_COUNTER_WIDTH:1

   localparam  DFX_COUNTER_COUNTER_VALUE__WIDTH  = DFX_COUNTER_WIDTH-1+1;
   localparam [DFX_COUNTER_COUNTER_VALUE__WIDTH-1:0] DFX_COUNTER_COUNTER_VALUE__DEFAULT  = 'h0;
   

   localparam  DFX_COUNTER_COUNTER_VALUE__MSB  = DFX_COUNTER_WIDTH;
   localparam  DFX_COUNTER_COUNTER_VALUE__LSB  = 1;
   

   assign DFX_COUNTER__DEFAULT
                 [DFX_COUNTER_COUNTER_VALUE__MSB : 
                  DFX_COUNTER_COUNTER_VALUE__LSB] =  
		  DFX_COUNTER_COUNTER_VALUE__DEFAULT;
   

  ati_buffer1 mrk_dfx_counter_counter_value[DFX_COUNTER_COUNTER_VALUE__WIDTH-1:0] 
  (
    .A(DFX_COUNTER
      [DFX_COUNTER_COUNTER_VALUE__MSB :
       DFX_COUNTER_COUNTER_VALUE__LSB
      ]),    
    .Y(counter_value[DFX_COUNTER_COUNTER_VALUE__WIDTH-1:0])
  );





   test_reg_async_rst
     #(DFX_COUNTER__WIDTH)
   reg_DFX_COUNTER (
                           .clk(Tdr_Tck),
                           .rstb(Tdr_Trstb),
                           .en(Tdr_dfx_counter_En),
                           .shift(Tdr_Shift & Tdr_dfx_counter_En),
                           .capture(Tdr_Capture & Tdr_dfx_counter_En),
                           .update(Tdr_Update & Tdr_dfx_counter_En),
                           .d_rst(DFX_COUNTER__DEFAULT),
                           .q(DFX_COUNTER),
                           .d(DFX_COUNTER),
                           .si(Tdr_Tdi),
                           .so(Tdr_dfx_counter_Tdo),
                           .q_sr(),
                           .q_sr_posedge()
                           );









///// END TDR_INST - DFX_COUNTER /////
endmodule
