/////////////////////////////////////////////////////////////////////////////
// File Name: mrk_and
// Description: AND gate 
/////////////////////////////////////////////////////////////////////////////
`include "rtllib_features.vh"
  module dfx_mrk_and 
    (
     output wire    Y,
     input wire A,
     input wire B
     );
   
   /////////////////////////////////////////////////////////////////////////////
`ifdef RTLLIB__TECH__GF14LPE
      hdan2xss2ul d0nt_and2 
	(
	 .A(A),
         .B(B),
         .Z(Y)
         );
`else 
   // use a mrk_buffer so it's easy to make constraints
   // DECDFXIP40-518 -- replace with technology cells.
   wire    A_in, B_in;
   ati_buffer1 mrk_buf_in_A (.A(A), .Y(A_in) );
   ati_buffer1 mrk_buf_in_B (.A(B), .Y(B_in) );
   assign  Y = A_in & B_in;
   
`endif // !`ifdef RTLLIB__TECH__GF14LPE
  
   
endmodule
