`include "rtllib_features.vh"
module dfx_sync4_gc10 (
input  wire CK,
input  wire D,
output wire Q
);

//delay in ps
//Delay between src and dest flop
  parameter      TransportDelay =  0;

//propagation time from source to destination in term of destination cycle
  parameter      TransportCycle =  1;


//Active low Async reset with depth-4

/*
  parameter      size           =  1;
  parameter      depth          =  2;
  parameter      sourceFlop     =  0;
  parameter      asyncSet       =  0;
  parameter      asyncReset     =  0;
  parameter      asyncFlush     =  0;
  parameter      clockEnable    =  0;
  parameter      scan_muxD      =  0;
  parameter      scan_LSSD      =  0;
  parameter      MultiVolt      =  0;
  parameter      TransportDelay =  0;
  parameter      TransportCycle =  1;
  parameter      InputCheck     =  1;
  parameter      MetaWindowMode =  0;
*/

techind_sync_icd  
# (
   .size(1),
   .depth(4),
   .sourceFlop(0),
   .asyncSet(0),
   .asyncReset(0),
   .asyncFlush(0),
   .clockEnable(0),
   .scan_muxD(1),
   .scan_LSSD(0),
   .MultiVolt(0),
   .TransportDelay(TransportDelay),
   .TransportCycle(TransportCycle),
   .InputCheck(1),
   .MetaWindowMode(0)

) techind_sync_icd (
    .SB(1'b0),
    .RB(1'b0),
    .FLUSH(1'b0),

`ifdef ABV
    .InputChkDis(1'b1), // always disable, ok to miss pulses here,
`endif

    .CKsrc(1'b0),
    .CKdst(CK),
    .EN(1'b1),
    .Dsrc(D),
    .Qsrc(),
    .Qdst(Q),

    .SC1(1'b0),
    .SC2(1'b0),
    .SE(1'b0),
    .SI(1'b0),
    .SO()
);


endmodule // dfx_sync4

