`include "rtllib_features.vh"
// Wrapper to replace sync3_wrapper3_1b
//
module dfx_sync_1b_gc10 (
        SRC_CLK,
        DST_CLK,
        DBL_FLOP_EN,
        RST,
        D,
        Q,
        Q_SRC
);
  parameter      WIDTH          =  1;
  parameter      depth          =  3; // This should only be 3 or 4
  parameter      TransportDelay =  0;
  parameter      TransportCycle =  0; // cdcsync cell present 

input RST;
input SRC_CLK;
input DST_CLK;
input DBL_FLOP_EN;
input  [WIDTH-1:0] D;
output [WIDTH-1:0] Q;
output [WIDTH-1:0] Q_SRC; //output of flop on source clock domain, anded with mask for gray code checking
//wire EN_GRAYCHECK = 1'b1;

//Active low Async reset with depth-3

/*
  parameter      size           =  1;
  parameter      depth          =  2;
  parameter      sourceFlop     =  0;
  parameter      asyncSet       =  0;
  parameter      asyncReset     =  0;
  parameter      asyncFlush     =  1;
  parameter      clockEnable    =  0;
  parameter      scan_muxD      =  0;
  parameter      scan_LSSD      =  0;
  parameter      MultiVolt      =  0;
  parameter      TransportDelay =  0;
  parameter      TransportCycle =  1;
  parameter      InputCheck     =  1;
  parameter      MetaWindowMode =  0;
*/

    wire ZERO=1'b0;
    wire ONE=1'b1;

//! unused RST
//! unused DBL_FLOP_EN

techind_sync_icd
# (
   .size(WIDTH),
   .depth(depth),
   .sourceFlop(1),
   .asyncSet(0),
   .asyncReset(0),
   .asyncFlush(0),
   .clockEnable(0),
   .scan_muxD(1),
   .scan_LSSD(0),
   .MultiVolt(0),
   .TransportDelay(TransportDelay),
   .TransportCycle(TransportCycle),
   .InputCheck(1),
   .MetaWindowMode(0)

) techind_sync_icd (
    .SB(1'b0),
    .RB(1'b0),
    .FLUSH(1'b0),
    .CKsrc(SRC_CLK),
    .CKdst(DST_CLK),
    .EN(1'b1),
    .Dsrc(D),
    .Qsrc(Q_SRC),
    .Qdst(Q),
`ifdef ABV
`ifdef DFXSIP_EnableIPWC
        .InputChkDis(ZERO),
`else
        .InputChkDis(ONE),
`endif
`endif
    .SC1(1'b0),
    .SC2(1'b0),
    .SE(1'b0),
    .SI(1'b0),
    .SO()
);


endmodule // dfx_sync_1b
