`include "rtllib_features.vh"
// Wrapper to replace sync3_wrapper_flush
//
module dfx_sync_flush (
input  wire CK,
input  wire D,
input  wire FLSH,
output wire Q
);
  parameter      WIDTH          =  1;
  parameter      depth          =  3; // This should only be 3 or 4
  parameter      TransportDelay =  0;
  parameter      TransportCycle =  1;


//Active low Async reset with depth-3

/*
  parameter      size           =  1;
  parameter      depth          =  2;
  parameter      sourceFlop     =  0;
  parameter      asyncSet       =  0;
  parameter      asyncReset     =  0;
  parameter      asyncFlush     =  1;
  parameter      clockEnable    =  0;
  parameter      scan_muxD      =  0;
  parameter      scan_LSSD      =  0;
  parameter      MultiVolt      =  0;
  parameter      TransportDelay =  0;
  parameter      TransportCycle =  1;
  parameter      InputCheck     =  1;
  parameter      MetaWindowMode =  0;
*/

    wire ZERO=1'b0;
    wire ONE=1'b1;

techind_sync_icd  
# (
   .size(WIDTH),
   .depth(depth),
   .sourceFlop(0),
   .asyncSet(0),
   .asyncReset(0),
   .asyncFlush(1),
   .clockEnable(0),
   .scan_muxD(1),
   .scan_LSSD(0),
   .MultiVolt(0),
   .TransportDelay(TransportDelay),
   .TransportCycle(TransportCycle),
   .InputCheck(1),
   .MetaWindowMode(0)

) techind_sync_icd (
    .SB(1'b0),
    .RB(1'b0),
    .FLUSH(FLSH),
    .CKsrc(1'b0),
    .CKdst(CK),
    .EN(1'b1),
    .Dsrc(D),
    .Qsrc(),
    .Qdst(Q),
`ifdef ABV
`ifdef DFXSIP_EnableIPWC
        .InputChkDis(ZERO),
`else
        .InputChkDis(ONE),
`endif
`endif
    .SC1(1'b0),
    .SC2(1'b0),
    .SE(1'b0),
    .SI(1'b0),
    .SO()
);


endmodule // dfx_sync_flush

