// Filename              : sdma0.v
// Perforce changelist   : $Change$
//
// Copyright             : Trade secret of AMD, Inc.
//                         Copyright 2008, AMD, Inc., (unpublished)
//                         All rights reserved.  This notice is intended as a precaution against
//                         inadvertent publication and does not imply publication or any waiver
//                         of confidentiality.  The year included in the foregoing notice is the
//                         year of creation of the work.
//
// Name:                 : sdma0 top
//
// Description           : 

`include "global_features.vh"
`include "dma_common.vh"
`include "sdma_reg.v"
`timescale 1ns/10ps

module dma_ce_bc (
		/*AUTOARG*/
   // Outputs
   dma_ce_idle_stat, dma_ce_full_stat, broadcast, bc_mode, ce_drm_rts,
   ce_drm_data, ex_drm_header, rd_data_drm_rts, rd_data_drm1_rts,
   rd_data_drm_header, rd_data_drm_data, drm_rd_data_rtr, ce_drm1_rts,
   ce_drm1_data, ce_rd_vld, next_ce_rd_rts, ce_rd_addr, ce_rd_size, ce_rd_swap,
   ce_rd_mask, ce_rd_tag, ce_rd_stall, ce_rd_priv, ce_rd_vmid,
   ce_rd_urg, ce_rd_tci, ce_rd_vol, ce_rd_pol,
   SDMA_TAP_wrnfo_urg, SDMA_TAP_wrnfo_stall, dma_drm_req_stall,
   dma_drm1_req_stall, ce_drm_frozen, ce_drm1_frozen, drm_dbg_wptr,
   drm_dbg_rptr, drm_dbg_alloc_free, drm1_dbg_wptr, drm1_dbg_rptr,
   drm1_dbg_alloc_free, rd_data_dbg_alloc_free, mc_wr_wreq_rtr_next,
   ram_cmd_info_we, ram_cmd_info_waddr, ram_cmd_info_din, ram_cmd_info1_din,
   ram_cmd_info_re, ram_cmd_info_raddr, ram_cmd_info_dout,
   ram_data_lut_we, ram_data_lut_waddr, ram_data_lut_din,
   ram_data_lut_re, ram_data_lut_raddr, ram_data_lut_dout,
   ram_mbank_data_we, ram_mbank_data_waddr, ram_mbank_data_din,
   ram_mbank_data_re, ram_mbank_data_raddr, ram_mbank_data_dout,
   data_skid_dout, data_skid_re_nc, skid_empty,

`ifdef SDMA__UTC_L1__1
   ce_wr_data_rts, ce_rd_lut_info, ce_rd_stall_atc, wreq_mc_wr_atc_rts, wreq_mc_wr_atc_eoc,
   ce_mc_wr_addr_dout, ce_mc_wr_addr_din, ram_mc_wr_addr_waddr, ram_mc_wr_addr_raddr, ram_mc_wr_addr_we, ram_mc_wr_addr_re,
`endif
   wreq_mc_wr_rts, wreq_mc_wr_addr, wreq_mc_wr_aes, wreq_mc_wr_broadcast,	
   wreq_mc_wr_crc, wreq_mc_wr_mask, wreq_mc_wr_pol, wreq_mc_wr_priv, wreq_mc_wr_swap,	
   wreq_mc_wr_tci, wreq_mc_wr_vmid, wreq_mc_wr_vol, wreq_mc_wr_eoc, wreq_delta, wreq_dst2_info,		
   // Inputs
   clk, resetb, MEM_POWER_CTRL, oStMemLocal, oStMemAdrs, oStMemData,
   oStMemRts, DRM_DMA_cipher_valid, DRM_DMA_cipher_data,
   DRM1_DMA_cipher_valid, DRM1_DMA_cipher_data, mc_rd_ce_vld,
   mc_rd_ce_data, mc_rd_ce_tag, mc_rd_ce_tid, MC_DMA_rdret_tid_d1,
   mc_rd_ce_nack, next_mc_rd_rtr, MC_DMA_rdret_tag,
   MC_DMA_rdret_tag_d1, MC_DMA_rdret_vld_d1, MC_DMA_rdret_vld, MC_DMA_rdret_last, ex_mc_rreq_pending,
   mc_rdret_ecc, mc_rd_rtr, mc_dma_rtr_fnl, ex_vmid, ex_priv, use_ib,
   dma_ib_swap_enable, dma_rb_swap_enable, next_wr_credit,
   dma_drm_credit, drm_credit, next_drm_credit, drm1_credit,
   next_drm1_credit, session_sel, dma_channel_bits, dma_bank_bits,
   dma_channel_xor, dma_bank_xor, dma_gb_addr_conf_pipe_interleave_size, dma_gb_addr_conf_read_pipe_interleave_size,
   dfifo_watermark, lfifo_watermark, rd_burst, 
`ifdef SDMA__UTC_L1__1
   dma_utc_l1_enable, utcl1_wr_data_rtr, utcl1_wr_addr_rtr, l1_alloc_vld, l1_alloc_data,
`endif
   cmd_info1_full,
   dma_data_swap_enable, copy_ie_en, next_drm_ctx_restore_start,
   dma_drm_ivload0_rd, dma_freeze, dma_back_compat_enable
   );

   parameter	drm_on = 1;

   input 	  clk, resetb;
   input[`CHIP__MEM_POWER_CTRL-1:0] MEM_POWER_CTRL;

   input oStMemLocal;
   input [40-1:0] oStMemAdrs;
   input [32-1:0] oStMemData;
   input oStMemRts;

   output[9:0] dma_ce_idle_stat;
   output[4:0] dma_ce_full_stat;
   output bc_mode;
   output broadcast;

   output [`DMA_RD_INFO1_BUF_WIDTH-1:0] ram_cmd_info1_din;// From dma_ce_split of dma_ce_split.v
   output [`DMA_RD_INFO_BUF_WIDTH-1:0] ram_cmd_info_din;// From dma_ce_split of dma_ce_split.v
   input [`DMA_RD_INFO_BUF_WIDTH-1:0] ram_cmd_info_dout;// From dma_ce_memory of dma_ce_memory.v
   output [`DMA_RD_INFO_BUF_DEPTH-1:0] ram_cmd_info_raddr;// From dma_ce_out of dma_ce_out.v
   output			ram_cmd_info_re;	// From dma_ce_out of dma_ce_out.v
   output [`DMA_RD_INFO_BUF_DEPTH-1:0] ram_cmd_info_waddr;// From dma_ce_out of dma_ce_out.v
   output			ram_cmd_info_we;	// From dma_ce_split of dma_ce_split.v

   output			ram_data_lut_we;	// From dma_ce_rreq of dma_ce_rreq.v
   output [`DMA_DATA_LUT_DEPTH-1:0] ram_data_lut_waddr;// From dma_ce_rreq of dma_ce_rreq.v
   output [`DMA_DATA_LUT_WIDTH-1:0] ram_data_lut_din;// From dma_ce_rreq of dma_ce_rreq.v
   output			ram_data_lut_re;	// From dma_ce_in of dma_ce_in.v
   output [`DMA_DATA_LUT_DEPTH-1:0] ram_data_lut_raddr;// From dma_ce_in of dma_ce_in.v
   input[`DMA_DATA_LUT_WIDTH-1:0] ram_data_lut_dout;// From dma_ce_memory of dma_ce_memory.v

   output [`DMA_RD_DATA_DATA_SIZE-1:0]        ram_mbank_data_din;
   output [8*`DMA_RD_DATA_BUF_DEPTH-1:0]                             ram_mbank_data_waddr;
   output [7:0]                                 ram_mbank_data_we;

   input [`DMA_RD_DATA_DATA_SIZE-1:0]               ram_mbank_data_dout;
   output [8*`DMA_RD_DATA_BUF_DEPTH-1:0]                  ram_mbank_data_raddr;
   output [7:0]                 ram_mbank_data_re;

   output [`DMA_RD_DATA_DATA_SIZE-1:0] data_skid_dout;// From dma_ce_out of dma_ce_out.v
   input			data_skid_re_nc;		// From dma_ce_dst of dma_ce_dst.v
   output			skid_empty;		// From dma_ce_out of dma_ce_out.v

   // DRM cipher interface
   output 			    ce_drm_rts;
   output [`DMA_DRM_DATA_SIZE-1:0]  ce_drm_data;
   output 			    ex_drm_header;
   input 			    DRM_DMA_cipher_valid;
   input [`DMA_DRM_DATA_SIZE-1:0]   DRM_DMA_cipher_data;
   output                           rd_data_drm_rts;
   output                           rd_data_drm1_rts;
   output                           rd_data_drm_header;
   output [`DMA_DRM_DATA_SIZE-1:0]  rd_data_drm_data;
   output                           drm_rd_data_rtr;

   // DRM channel 1
   output 			    ce_drm1_rts;
   output [`DMA_DRM_DATA_SIZE-1:0]  ce_drm1_data;
   input 			    DRM1_DMA_cipher_valid;
   input [`DMA_DRM_DATA_SIZE-1:0]   DRM1_DMA_cipher_data;

   
   output ce_rd_vld;
   output next_ce_rd_rts;
   output [`DMA_MC_RDREQ_ADDR_SIZE-1:0]                        ce_rd_addr;
   output [1:0]           			       	       ce_rd_size;
   output [`DMA_MC_RDREQ_SWAP_SIZE-1:0]                        ce_rd_swap;
   output [`DMA_MC_RDREQ_MASK_SIZE-1:0]                        ce_rd_mask;
   output [`DMA_MC_RDREQ_TAG_SIZE-1:0]                         ce_rd_tag;
   output                                                      ce_rd_stall;
   output                                                      ce_rd_priv;
   output [`SDMA0_GFX_RB_CNTL_RB_VMID_SIZE-1:0]                ce_rd_vmid;
   output [`DMA_MC_RDNFO_URG_SIZE-1:0]                         ce_rd_urg;
   output                                                      ce_rd_tci;
   output                                                      ce_rd_vol;
   output                                                      ce_rd_pol;
   
                      // dma_mc_rd interface
    input                              mc_rd_ce_vld;
    input [`MC_DMA_RDRET_DATA_SIZE-1:0] mc_rd_ce_data;
    input [`MC_DMA_RDRET_TAG_SIZE-1:0]  mc_rd_ce_tag;
    input [`MC_DMA_RDRET_TID_SIZE-1:0]  mc_rd_ce_tid;
    input [`MC_DMA_RDRET_TID_SIZE-1:0]  MC_DMA_rdret_tid_d1;
    input [1:0]                         mc_rd_ce_nack;
    input                               next_mc_rd_rtr;
    input [`MC_DMA_RDRET_TAG_SIZE-1:0]  MC_DMA_rdret_tag;
    input [`MC_DMA_RDRET_TAG_SIZE-1:0]  MC_DMA_rdret_tag_d1;
    input                               MC_DMA_rdret_vld_d1;
    input                               MC_DMA_rdret_vld;
    input                               MC_DMA_rdret_last;
    input                               ex_mc_rreq_pending;
    input                               mc_rdret_ecc;
    input mc_rd_rtr;
   
`ifdef SDMA__UTC_L1__1
   input dma_utc_l1_enable;
   input utcl1_wr_data_rtr;
   input utcl1_wr_addr_rtr;

   input l1_alloc_vld;
   input [`DMA_MC_RDREQ_CE_ALLOC_WIDTH-1+14:0]	l1_alloc_data;
   output ce_rd_stall_atc;
`endif

`ifdef SDMA__UTC_L1__1
   output ce_wr_data_rts;
   output [`DMA_MC_RDREQ_CE_ALLOC_WIDTH -1:0] ce_rd_lut_info;

   // sdma memory interface
   input [`CMD_ADDR_SIZE-5-1:0] 			 ce_mc_wr_addr_dout;
   output [`CMD_ADDR_SIZE-5-1:0] 			 ce_mc_wr_addr_din;
   output [`DMA_MC_WR_ADDR_FIFO_DEPTH-1:0] 		 ram_mc_wr_addr_waddr, ram_mc_wr_addr_raddr;
   output 						 ram_mc_wr_addr_we, ram_mc_wr_addr_re;
`endif

`ifdef SDMA__UTC_L1__1
   output wreq_mc_wr_atc_rts ;
   output wreq_mc_wr_atc_eoc ;
`endif
   output  wreq_mc_wr_rts ;
   output [`CMD_ADDR_SIZE-5-1:0]  wreq_mc_wr_addr ;
   output [`CMD_ADDR_SIZE-5-1:0]  wreq_delta ;
   output  wreq_mc_wr_broadcast ;
   output [1:0]  wreq_mc_wr_swap ;
   output   wreq_mc_wr_aes ;
   output   wreq_mc_wr_crc ;
   output   wreq_mc_wr_priv ;
   output  [`SDMA0_GFX_RB_CNTL_RB_VMID_SIZE-1:0] wreq_mc_wr_vmid ;
   output [15:0]  wreq_mc_wr_mask ;
   output   wreq_mc_wr_tci ;
   output   wreq_mc_wr_vol ;
   output   wreq_mc_wr_pol ;
   output [5:0] wreq_dst2_info ;
   output   wreq_mc_wr_eoc ;

   // Port connectors for interface instance "SDMA_TAP_wrnfo" of type "CLI_TAP_wrnfo.transmit".
   output [3:0] 		    SDMA_TAP_wrnfo_urg;
   output [0:0] 		    SDMA_TAP_wrnfo_stall;
   output                           dma_drm_req_stall;
   output                           dma_drm1_req_stall;
   
   // Port connectors for interface instance "TAP_SDMA_wrret" of type "TAP_CLI_wrret.receive".
//   input [0:0] 			    TAP_SDMA_wrret_vld;
//   input [9:0] 			    TAP_SDMA_wrret_tag;
//   input [1:0] 			    TAP_SDMA_wrret_nack;
   
   input cmd_info1_full;

   input mc_dma_rtr_fnl;
   input [`SDMA0_GFX_RB_CNTL_RB_VMID_SIZE-1:0] ex_vmid;
   input ex_priv;
   input use_ib;
   input dma_ib_swap_enable;
   input dma_rb_swap_enable;
   input [`SDMA0_CNTL_MC_WRREQ_CREDIT_SIZE-1:0]         next_wr_credit;
   input [`SDMA0_CNTL_DRM_CREDIT_SIZE-1:0]          dma_drm_credit;
   input [`SDMA0_CNTL_DRM_CREDIT_SIZE-1:0]          drm_credit, next_drm_credit;
   input [`SDMA0_CNTL_DRM_CREDIT_SIZE-1:0]          drm1_credit, next_drm1_credit;
   input [`SDMA0_GFX_CONTEXT_CNTL_SESSION_SEL_SIZE-1:0]      session_sel;
   input [`SDMA0_HASH_CHANNEL_BITS_SIZE-1:0]            dma_channel_bits;
   input [`SDMA0_HASH_BANK_BITS_SIZE-1:0]                 dma_bank_bits;
   input [`SDMA0_HASH_CHANNEL_XOR_COUNT_SIZE-1:0]         dma_channel_xor;
   input [`SDMA0_HASH_BANK_XOR_COUNT_SIZE-1:0]            dma_bank_xor;
   input [`SDMA0_GB_ADDR_CONFIG_PIPE_INTERLEAVE_SIZE_SIZE-1:0]  dma_gb_addr_conf_pipe_interleave_size ;
   input [`SDMA0_GB_ADDR_CONFIG_READ_PIPE_INTERLEAVE_SIZE_SIZE-1:0]  dma_gb_addr_conf_read_pipe_interleave_size ;
   input [`SDMA0_CHICKEN_BITS_CE_DFIFO_WATERMARK_SIZE-1:0] 	dfifo_watermark;
   input [`SDMA0_CHICKEN_BITS_CE_LFIFO_WATERMARK_SIZE-1:0] 	lfifo_watermark;
   input [`SDMA0_RD_BURST_CNTL_RD_BURST_SIZE-1:0] rd_burst;
   input dma_data_swap_enable;
   input copy_ie_en;
   input next_drm_ctx_restore_start;
   input [31:0] dma_drm_ivload0_rd;

   input dma_freeze;
   output ce_drm_frozen;
   output ce_drm1_frozen;
   input dma_back_compat_enable;
   input mc_wr_wreq_rtr_next;

   // dma_dbg interface
   output [`DRM_DMA_MASK_FIFO_DEPTH:0]               drm_dbg_wptr;
   output [`DRM_DMA_MASK_FIFO_DEPTH:0]               drm_dbg_rptr;
   output [`DRM_DMA_MASK_FIFO_DEPTH:0]               drm_dbg_alloc_free;
   output [`DRM1_DMA_MASK_FIFO_DEPTH:0]              drm1_dbg_wptr;
   output [`DRM1_DMA_MASK_FIFO_DEPTH:0]              drm1_dbg_rptr;
   output [`DRM1_DMA_MASK_FIFO_DEPTH:0]              drm1_dbg_alloc_free;
   output [`DMA_RD_DATA_BUF_DEPTH:0]                 rd_data_dbg_alloc_free;

   /*AUTOWIRE*/
   // Beginning of automatic wires (for undeclared instantiated-module outputs)
   wire			aes;			// From dma_ce_split of dma_ce_split.v
   wire			aes_cbc;		// From dma_ce_split of dma_ce_split.v
   wire			afifo_full;		// From dma_ce_wr of dma_ce_wr.v
   wire [`DMA_MC_RDREQ_DWORD_SIZE-1:0] ce_rd_dw_size;// From dma_ce_rreq of dma_ce_rreq.v
   wire			ce_rd_t2l_last;		// From dma_ce_rreq of dma_ce_rreq.v
   wire			cmd_ie_enable;		// From dma_ce_cmd of dma_ce_cmd.v
   //wire			cmd_info1_full;		// From dma_ce_dst of dma_ce_dst.v
   wire			cmd_info_full;		// From dma_ce_out of dma_ce_out.v
   wire [`DMA_RD_DATA_BUF_DEPTH:0] data_rreq_alloc_free;// From dma_ce_in of dma_ce_in.v
   wire [`DMA_RD_DATA_BUF_DEPTH:0] data_rreq_alloc_used;// From dma_ce_in of dma_ce_in.v
   wire [`DMA_RD_DATA_BUF_DEPTH:0] data_rreq_alloc_wptr;// From dma_ce_in of dma_ce_in.v
   wire [3:0]                      data_rreq_alloc_wptr_inc;
   wire			dma_ce_drm1_idle;	// From dma_ce_drm1 of dma_ce_drm1.v
   wire			dma_ce_drm_idle;	// From dma_ce_drm of dma_ce_drm.v
   wire			dma_ce_dst_idle;	// From dma_ce_dst of dma_ce_dst.v
   wire			dma_ce_in_idle;		// From dma_ce_in of dma_ce_in.v
   wire			dma_ce_out_idle;	// From dma_ce_out of dma_ce_out.v
   wire			dma_ce_rreq_idle;	// From dma_ce_rreq of dma_ce_rreq.v
   wire			dma_ce_split_idle;	// From dma_ce_split of dma_ce_split.v
   wire			dma_ce_wr_idle;		// From dma_ce_wr of dma_ce_wr.v
   wire			dma_ce_wreq_idle;	// From dma_ce_wreq of dma_ce_wreq.v
   wire			dma_drm1_mask_full;	// From dma_ce_drm1 of dma_ce_drm1.v
   wire			dma_drm_mask_full;	// From dma_ce_drm of dma_ce_drm.v
   wire [`DRM_DMA_MASK_RANGE] drm1_drm_data;	// From dma_ce_drm1 of dma_ce_drm1.v
   wire			drm1_drm_rts;		// From dma_ce_drm1 of dma_ce_drm1.v
   wire [`DRM1_DMA_MASK_FIFO_DEPTH:0] drm1_ex_alloc_free;// From dma_ce_drm1 of dma_ce_drm1.v
   wire			drm1_ex_rtr;		// From dma_ce_drm1 of dma_ce_drm1.v
   wire			drm1_rd_data_rtr;	// From dma_ce_drm1 of dma_ce_drm1.v
   wire			drm_drm1_rtr;		// From dma_ce_drm of dma_ce_drm.v
   wire [`DRM_DMA_MASK_FIFO_DEPTH:0] drm_ex_alloc_free;// From dma_ce_drm of dma_ce_drm.v
   wire [`DRM_DMA_MASK_RANGE] drm_mc_wr_mask;	// From dma_ce_drm of dma_ce_drm.v
   wire			drm_mc_wr_rts;		// From dma_ce_drm of dma_ce_drm.v
   wire [`CMD_PARAM_RANGE] ex_param;		// From dma_ce_cmd of dma_ce_cmd.v
   wire			ex_start;		// From dma_ce_cmd of dma_ce_cmd.v
   wire [`DMA_RD_DATA_BUF_ENTRIES-1:0] fifo_entry_ecc;// From dma_ce_in of dma_ce_in.v
   wire [`DMA_RD_DATA_BUF_ENTRIES-1:0] fifo_entry_vld;// From dma_ce_in of dma_ce_in.v
   wire			mc_wr_drm_rtr;		// From dma_ce_wr of dma_ce_wr.v
   wire			mc_wr_rd_data_rtr;	// From dma_ce_wr of dma_ce_wr.v
   wire			mc_wr_wreq_rtr;		// From dma_ce_wr of dma_ce_wr.v
   //wire			mc_wr_wreq_rtr_next;	// From dma_ce_wr of dma_ce_wr.v
   wire [2:0]		next_quarter_entry;	// From dma_ce_in of dma_ce_in.v
   wire [6:0]		out_chunk_size;		// From dma_ce_out of dma_ce_out.v
   wire			out_ecc;		// From dma_ce_out of dma_ce_out.v
   wire [1:0]		out_granu;		// From dma_ce_out of dma_ce_out.v
   wire			out_ie;			// From dma_ce_out of dma_ce_out.v
   wire [`DRM_DMA_MASK_FIFO_WIDTH-1:0] ram_drm1_mask_din;// From dma_ce_drm1 of dma_ce_drm1.v
   wire [`DRM_DMA_MASK_FIFO_WIDTH-1:0] ram_drm1_mask_dout;// From dma_ce_memory of dma_ce_memory.v
   wire [`DRM1_SDMA_MASK_FIFO_DEPTH-1:0] ram_drm1_mask_raddr;// From dma_ce_drm1 of dma_ce_drm1.v
   wire			ram_drm1_mask_re;	// From dma_ce_drm1 of dma_ce_drm1.v
   wire [`DRM1_SDMA_MASK_FIFO_DEPTH-1:0] ram_drm1_mask_waddr;// From dma_ce_drm1 of dma_ce_drm1.v
   wire			ram_drm1_mask_we;	// From dma_ce_drm1 of dma_ce_drm1.v
   wire [`DRM_DMA_MASK_FIFO_WIDTH-1:0] ram_drm_mask_din;// From dma_ce_drm of dma_ce_drm.v
   wire [`DRM_DMA_MASK_FIFO_WIDTH-1:0] ram_drm_mask_dout;// From dma_ce_memory of dma_ce_memory.v
   wire [`DRM_SDMA_MASK_FIFO_DEPTH-1:0] ram_drm_mask_raddr;// From dma_ce_drm of dma_ce_drm.v
   wire			ram_drm_mask_re;	// From dma_ce_drm of dma_ce_drm.v
   wire [`DRM_SDMA_MASK_FIFO_DEPTH-1:0] ram_drm_mask_waddr;// From dma_ce_drm of dma_ce_drm.v
   wire			ram_drm_mask_we;	// From dma_ce_drm of dma_ce_drm.v
   //wire [`DMA_RD_DATA_DATA_SIZE-1:0] ram_mbank_data_din;// From dma_ce_in of dma_ce_in.v
   //wire [`DMA_RD_DATA_DATA_SIZE-1:0] ram_mbank_data_dout;// From dma_ce_memory of dma_ce_memory.v
   //wire [8*9-1:0]	ram_mbank_data_raddr;	// From dma_ce_out of dma_ce_out.v
   //wire [7:0]		ram_mbank_data_re;	// From dma_ce_out of dma_ce_out.v
   //wire [8*9-1:0]	ram_mbank_data_waddr;	// From dma_ce_in of dma_ce_in.v
   //wire [7:0]		ram_mbank_data_we;	// From dma_ce_in of dma_ce_in.v
   wire [8*32-1:0]	ram_mbank_data_wmask;	// From dma_ce_in of dma_ce_in.v
   wire [`DMA_MC_WR_ADDR_FIFO_WIDTH-1:0] ram_mc_wr_addr_din;// From dma_ce_wr of dma_ce_wr.v
   wire [`DMA_MC_WR_ADDR_FIFO_WIDTH-1:0] ram_mc_wr_addr_dout;// From dma_ce_memory of dma_ce_memory.v
   wire [`DMA_MC_WR_ADDR_FIFO_DEPTH-1:0] ram_mc_wr_addr_raddr;// From dma_ce_wr of dma_ce_wr.v
   wire			ram_mc_wr_addr_re;	// From dma_ce_wr of dma_ce_wr.v
   wire [`DMA_MC_WR_ADDR_FIFO_DEPTH-1:0] ram_mc_wr_addr_waddr;// From dma_ce_wr of dma_ce_wr.v
   wire			ram_mc_wr_addr_we;	// From dma_ce_wr of dma_ce_wr.v
   wire			ram_rd_data_rptr_inc;	// From dma_ce_out of dma_ce_out.v
   wire [3:0]		rd_data_drm_size;	// From dma_ce_dst of dma_ce_dst.v
   wire			rd_data_ex_crc;		// From dma_ce_dst of dma_ce_dst.v
   wire			rd_data_mc_wr_aes_cbc;	// From dma_ce_dst of dma_ce_dst.v
   wire [`DMA_EX_DATA_SIZE-1:0] rd_data_mc_wr_data;// From dma_ce_dst of dma_ce_dst.v
   wire			rd_data_mc_wr_ecc;	// From dma_ce_dst of dma_ce_dst.v
   wire			rd_data_mc_wr_l2t;	// From dma_ce_dst of dma_ce_dst.v
   wire [31:0]		rd_data_mc_wr_mask;	// From dma_ce_dst of dma_ce_dst.v
   wire			rd_data_mc_wr_rts;	// From dma_ce_dst of dma_ce_dst.v
   wire [2:0]		rd_data_mc_wr_void;	// From dma_ce_dst of dma_ce_dst.v
   wire			rreq_rtr;		// From dma_ce_rreq of dma_ce_rreq.v
   wire [`CMD_PARAM_RANGE] split_param;		// From dma_ce_split of dma_ce_split.v
   wire [`CMD_PARAM_RANGE] split_param_dst;	// From dma_ce_split of dma_ce_split.v
   wire			split_rts;		// From dma_ce_split of dma_ce_split.v
   wire			last_sub_cp;		// From dma_ce_split of dma_ce_split.v
   wire			split_start;		// From dma_ce_split of dma_ce_split.v
   wire [`CMD_COUNT_SIZE-1+1:0] ssize;		// From dma_ce_split of dma_ce_split.v
   wire			trns;			// From dma_ce_split of dma_ce_split.v
   wire [`CMD_ADDR_SIZE-5-1:0] wreq_delta;	// From dma_ce_wreq of dma_ce_wreq.v
   wire [5:0]		wreq_dst2_info;		// From dma_ce_wreq of dma_ce_wreq.v
   wire [`CMD_ADDR_SIZE-5-1:0] wreq_mc_wr_addr;	// From dma_ce_wreq of dma_ce_wreq.v
   wire			wreq_mc_wr_aes;		// From dma_ce_wreq of dma_ce_wreq.v
   wire			wreq_mc_wr_broadcast;	// From dma_ce_wreq of dma_ce_wreq.v
   wire			wreq_mc_wr_crc;		// From dma_ce_wreq of dma_ce_wreq.v
   wire [15:0]		wreq_mc_wr_mask;	// From dma_ce_wreq of dma_ce_wreq.v
   wire			wreq_mc_wr_pol;		// From dma_ce_wreq of dma_ce_wreq.v
   wire			wreq_mc_wr_priv;	// From dma_ce_wreq of dma_ce_wreq.v
   wire			wreq_mc_wr_rts;		// From dma_ce_wreq of dma_ce_wreq.v
   wire [1:0]		wreq_mc_wr_swap;	// From dma_ce_wreq of dma_ce_wreq.v
   wire			wreq_mc_wr_tci;		// From dma_ce_wreq of dma_ce_wreq.v
   wire [`SDMA0_GFX_RB_CNTL_RB_VMID_SIZE-1:0] wreq_mc_wr_vmid;// From dma_ce_wreq of dma_ce_wreq.v
   wire			wreq_mc_wr_vol;		// From dma_ce_wreq of dma_ce_wreq.v
   wire			wreq_rtr;		// From dma_ce_wreq of dma_ce_wreq.v
   // End of automatics
 
   assign dma_ce_idle_stat = {1'b1, 1'b1, 1'b1, 1'b1, dma_ce_in_idle, dma_ce_out_idle, dma_ce_rreq_idle,
		dma_ce_split_idle, 1'b1, dma_ce_wreq_idle};
   assign dma_ce_full_stat = {1'b0, cmd_info_full, 1'b0, 1'b0, 1'b0};


   dma_ce_cmd_bc dma_ce_cmd_bc (/*AUTOINST*/
			  // Outputs
			  .bc_mode		(bc_mode),
			  .broadcast		(broadcast),
			  .cmd_ie_enable	(cmd_ie_enable),
			  .ex_param		(ex_param[`CMD_PARAM_RANGE]),
			  .ex_start		(ex_start),
			  // Inputs
			  .clk			(clk),
			  .resetb		(resetb),
			  .oStMemLocal		(oStMemLocal),
			  .oStMemAdrs		(oStMemAdrs[40-1:0]),
			  .oStMemData		(oStMemData[32-1:0]),
			  .oStMemRts		(oStMemRts),
			  .ex_vmid		(ex_vmid[`SDMA0_GFX_RB_CNTL_RB_VMID_SIZE-1:0]),
			  .ex_priv		(ex_priv),
			  .use_ib		(use_ib),
			  .dma_ib_swap_enable	(dma_ib_swap_enable),
			  .dma_rb_swap_enable	(dma_rb_swap_enable),
			  .dma_data_swap_enable	(dma_data_swap_enable),
			  .next_drm_ctx_restore_start(next_drm_ctx_restore_start),
			  .dma_drm_ivload0_rd	(dma_drm_ivload0_rd[31:0]),
			  .session_sel		(session_sel[`SDMA0_GFX_CONTEXT_CNTL_SESSION_SEL_SIZE-1:0]),
			  .cmd_info_full	(cmd_info_full),
			  .cmd_info1_full	(cmd_info1_full),
			  .dma_back_compat_enable(dma_back_compat_enable),
			  .rreq_rtr		(rreq_rtr),
			  .wreq_rtr		(wreq_rtr));

   dma_ce_split_bc dma_ce_split_bc(
			     .copy_ie_en	(copy_ie_en & cmd_ie_enable),
				 /*AUTOINST*/
			     // Outputs
			     .split_start	(split_start),
			     .ram_cmd_info_we	(ram_cmd_info_we),
			     .ram_cmd_info_din	(ram_cmd_info_din[`DMA_RD_INFO_BUF_WIDTH-1:0]),
			     .ram_cmd_info1_din	(ram_cmd_info1_din[`DMA_RD_INFO1_BUF_WIDTH-1:0]),
			     .split_rts		(split_rts),
			     .last_sub_cp   (last_sub_cp),
			     .split_param	(split_param[`CMD_PARAM_RANGE]),
			     .split_param_dst	(split_param_dst[`CMD_PARAM_RANGE]),
			     .ssize		(ssize[`CMD_COUNT_SIZE-1+1:0]),
			     .aes		(aes),
			     .aes_cbc		(aes_cbc),
			     .trns		(trns),
			     .dma_ce_split_idle	(dma_ce_split_idle),
			     // Inputs
			     .clk		(clk),
			     .resetb		(resetb),
			     .ex_start		(ex_start && bc_mode),
			     .bc_mode		(bc_mode),
			     .ex_param		(ex_param[`CMD_PARAM_RANGE]),
			     .cmd_info_full	(cmd_info_full),
			     .cmd_info1_full	(cmd_info1_full),
			     .rreq_rtr		(rreq_rtr),
			     .wreq_rtr		(wreq_rtr));

   wire [3:0] dummy_bits;
   dma_ce_rreq_bc dma_ce_rreq_bc (
			    .ce_rd_addr		({dummy_bits, ce_rd_addr[`DMA_MC_RDREQ_ADDR_SIZE-1:0]}),
			/*AUTOINST*/
			    // Outputs
			    .ce_rd_size		(ce_rd_size[1:0]),
			    .ce_rd_dw_size	(ce_rd_dw_size[`DMA_MC_RDREQ_DWORD_SIZE-1:0]),
			    .next_ce_rd_rts	(next_ce_rd_rts),
			    .ce_rd_t2l_last	(ce_rd_t2l_last),
			    .rreq_rtr		(rreq_rtr),
			    .ce_rd_vld		(ce_rd_vld),
			    .ce_rd_swap		(ce_rd_swap[`DMA_MC_RDREQ_SWAP_SIZE-1:0]),
			    .ce_rd_mask		(ce_rd_mask[`DMA_MC_RDREQ_MASK_SIZE-1:0]),
			    .ce_rd_tag		(ce_rd_tag[`DMA_MC_RDREQ_TAG_SIZE-1:0]),
			    .ce_rd_stall	(ce_rd_stall),
			    .ce_rd_priv		(ce_rd_priv),
			    .ce_rd_vmid		(ce_rd_vmid[`SDMA0_GFX_RB_CNTL_RB_VMID_SIZE-1:0]),
			    .ce_rd_urg		(ce_rd_urg[`DMA_MC_RDNFO_URG_SIZE-1:0]),
			    .ce_rd_tci		(ce_rd_tci),
			    .ce_rd_vol		(ce_rd_vol),
			    .ce_rd_pol		(ce_rd_pol),
`ifdef SDMA__UTC_L1__1
			    .ce_rd_lut_info	(ce_rd_lut_info),
			    .ce_rd_stall_atc	(ce_rd_stall_atc),
`endif
			    .ram_data_lut_din	(ram_data_lut_din[`DMA_DATA_LUT_WIDTH-1:0]),
			    .ram_data_lut_waddr	(ram_data_lut_waddr[`DMA_DATA_LUT_DEPTH-1:0]),
			    .ram_data_lut_we	(ram_data_lut_we),
			    .rd_data_dbg_alloc_free(rd_data_dbg_alloc_free[`DMA_RD_DATA_BUF_DEPTH:0]),
			    .dma_ce_rreq_idle	(dma_ce_rreq_idle),
			    // Inputs
			    .clk		(clk),
			    .resetb		(resetb),
			    .bc_mode		(bc_mode),
			    .split_rts		(split_rts),
			    .split_param	(split_param[`CMD_PARAM_RANGE]),
			    .lfifo_watermark	(lfifo_watermark[`SDMA0_CHICKEN_BITS_CE_LFIFO_WATERMARK_SIZE-1:0]),
                	    .rd_burst        (rd_burst[`SDMA0_RD_BURST_CNTL_RD_BURST_SIZE-1:0]),
`ifdef SDMA__UTC_L1__1
			    .dma_utc_l1_enable	(dma_utc_l1_enable),
   			    .l1_alloc_vld	(l1_alloc_vld && bc_mode),
   			    .l1_alloc_data	(l1_alloc_data[`DMA_MC_RDREQ_CE_ALLOC_WIDTH -1:0]),	
`endif
			    .data_rreq_alloc_free(data_rreq_alloc_free[`DMA_RD_DATA_BUF_DEPTH:0]),
			    .data_rreq_alloc_used(data_rreq_alloc_used[`DMA_RD_DATA_BUF_DEPTH:0]),
			    .data_rreq_alloc_wptr(data_rreq_alloc_wptr[`DMA_RD_DATA_BUF_DEPTH:0]),
			    .data_rreq_alloc_wptr_inc(data_rreq_alloc_wptr_inc),
			    .MC_DMA_rdret_vld	(MC_DMA_rdret_vld && !ex_mc_rreq_pending),
			    .MC_DMA_rdret_tag	(MC_DMA_rdret_tag[`MC_DMA_RDRET_TAG_SIZE-1:0]),
			    .MC_DMA_rdret_last	(MC_DMA_rdret_last),
			    .next_quarter_entry	(next_quarter_entry[2:0]),
                .dma_addr_conf_pipe_interleave_size (dma_gb_addr_conf_read_pipe_interleave_size[`SDMA0_GB_ADDR_CONFIG_READ_PIPE_INTERLEAVE_SIZE_SIZE-1:0]),
			    .mc_rd_rtr		(mc_rd_rtr),
			    .next_mc_rd_rtr	(next_mc_rd_rtr),
			    .ram_rd_data_rptr_inc(ram_rd_data_rptr_inc),
			    .out_granu		(out_granu[1:0]),
			    .out_chunk_size	(out_chunk_size[6:0]),
			    .out_ie		(out_ie),
			    .dma_channel_bits	(dma_channel_bits[`SDMA0_HASH_CHANNEL_BITS_SIZE-1:0]),
			    .dma_bank_bits	(dma_bank_bits[`SDMA0_HASH_BANK_BITS_SIZE-1:0]),
			    .dma_channel_xor	(dma_channel_xor[`SDMA0_HASH_CHANNEL_XOR_COUNT_SIZE-1:0]),
			    .dma_bank_xor	(dma_bank_xor[`SDMA0_HASH_BANK_XOR_COUNT_SIZE-1:0]));

   dma_ce_wreq_bc dma_ce_wreq_bc (
			/*AUTOINST*/
			    // Outputs
`ifdef SDMA__UTC_L1__1
			    .wreq_mc_wr_atc_rts	(wreq_mc_wr_atc_rts),
			    .wreq_mc_wr_atc_eoc	(wreq_mc_wr_atc_eoc),
`endif
			    .wreq_rtr		(wreq_rtr),
			    .dma_ce_wreq_idle	(dma_ce_wreq_idle),
			    .wreq_mc_wr_rts	(wreq_mc_wr_rts),
			    .wreq_mc_wr_addr	(wreq_mc_wr_addr[`CMD_ADDR_SIZE-5-1:0]),
			    .wreq_delta		(wreq_delta[`CMD_ADDR_SIZE-5-1:0]),
			    .wreq_mc_wr_broadcast(wreq_mc_wr_broadcast),
			    .wreq_mc_wr_swap	(wreq_mc_wr_swap[1:0]),
			    .wreq_mc_wr_aes	(wreq_mc_wr_aes),
			    .wreq_mc_wr_crc	(wreq_mc_wr_crc),
			    .wreq_mc_wr_priv	(wreq_mc_wr_priv),
			    .wreq_mc_wr_vmid	(wreq_mc_wr_vmid[`SDMA0_GFX_RB_CNTL_RB_VMID_SIZE-1:0]),
			    .wreq_mc_wr_mask	(wreq_mc_wr_mask[15:0]),
			    .wreq_mc_wr_tci	(wreq_mc_wr_tci),
			    .wreq_mc_wr_vol	(wreq_mc_wr_vol),
			    .wreq_mc_wr_pol	(wreq_mc_wr_pol),
			    .wreq_dst2_info	(wreq_dst2_info[5:0]),
			    .wreq_mc_wr_eoc	(wreq_mc_wr_eoc),
			    // Inputs
			    .clk		(clk),
			    .resetb		(resetb),
			    .bc_mode		(bc_mode),
			    .split_rts		(split_rts),
			    .split_param_dst	(split_param_dst[`CMD_PARAM_RANGE]),
			    .last_sub_cp   (last_sub_cp),
			    .mc_wr_wreq_rtr_next(mc_wr_wreq_rtr_next),
`ifdef SDMA__UTC_L1__1
			    .dma_utc_l1_enable	(dma_utc_l1_enable),
			    .utcl1_wr_addr_rtr	(utcl1_wr_addr_rtr),
`endif
			    .dma_channel_bits	(dma_channel_bits[`SDMA0_HASH_CHANNEL_BITS_SIZE-1:0]),
			    .dma_bank_bits	(dma_bank_bits[`SDMA0_HASH_BANK_BITS_SIZE-1:0]),
			    .dma_channel_xor	(dma_channel_xor[`SDMA0_HASH_CHANNEL_XOR_COUNT_SIZE-1:0]),
			    .dma_bank_xor	(dma_bank_xor[`SDMA0_HASH_BANK_XOR_COUNT_SIZE-1:0]),
                .dma_addr_conf_pipe_interleave_size (dma_gb_addr_conf_pipe_interleave_size[`SDMA0_GB_ADDR_CONFIG_PIPE_INTERLEAVE_SIZE_SIZE-1:0]));

   dma_ce_in_bc dma_ce_in_bc (
				/*AUTOINST*/
			// Outputs
			.ram_data_lut_raddr(ram_data_lut_raddr[`DMA_DATA_LUT_DEPTH-1:0]),
			.ram_data_lut_re(ram_data_lut_re),
			.data_rreq_alloc_free(data_rreq_alloc_free[`DMA_RD_DATA_BUF_DEPTH:0]),
			.data_rreq_alloc_used(data_rreq_alloc_used[`DMA_RD_DATA_BUF_DEPTH:0]),
			.data_rreq_alloc_wptr(data_rreq_alloc_wptr[`DMA_RD_DATA_BUF_DEPTH:0]),
			.data_rreq_alloc_wptr_inc(data_rreq_alloc_wptr_inc),
			.next_quarter_entry(next_quarter_entry[2:0]),
			.dma_ce_in_idle	(dma_ce_in_idle),
			.fifo_entry_vld	(fifo_entry_vld[`DMA_RD_DATA_BUF_ENTRIES-1:0]),
			.fifo_entry_ecc	(fifo_entry_ecc[`DMA_RD_DATA_BUF_ENTRIES-1:0]),
			.ram_mbank_data_din(ram_mbank_data_din[`DMA_RD_DATA_DATA_SIZE-1:0]),
			.ram_mbank_data_waddr(ram_mbank_data_waddr[8*`DMA_RD_DATA_BUF_DEPTH-1:0]),
			.ram_mbank_data_wmask(),
			.ram_mbank_data_we(ram_mbank_data_we[7:0]),
			// Inputs
			.clk		(clk),
			.resetb		(resetb),
			.bc_mode	(bc_mode),
`ifdef SDMA__UTC_L1__1
			.dma_utc_l1_enable(dma_utc_l1_enable),
   			.l1_alloc_vld	(l1_alloc_vld && bc_mode),
   			.l1_alloc_data	(l1_alloc_data),	
`endif
			.dfifo_watermark (dfifo_watermark[`SDMA0_CHICKEN_BITS_CE_DFIFO_WATERMARK_SIZE-1:0]),
			.mc_rd_ce_vld	(mc_rd_ce_vld),
			.mc_rd_ce_data	(mc_rd_ce_data[`MC_DMA_RDRET_DATA_SIZE-1:0]),
			.mc_rd_ce_tag	(mc_rd_ce_tag[`MC_DMA_RDRET_TAG_SIZE-1:0]),
			.mc_rd_ce_tid	(mc_rd_ce_tid[`MC_DMA_RDRET_TID_SIZE-1:0]),
			.MC_DMA_rdret_tid_d1(MC_DMA_rdret_tid_d1[`MC_DMA_RDRET_TID_SIZE-1:0]),
			.mc_rd_ce_nack	(mc_rd_ce_nack[1:0]),
			.MC_DMA_rdret_tag(MC_DMA_rdret_tag[`MC_DMA_RDRET_TAG_SIZE-1:0]),
			.MC_DMA_rdret_tag_d1(MC_DMA_rdret_tag_d1[`MC_DMA_RDRET_TAG_SIZE-1:0]),
			.MC_DMA_rdret_vld_d1(MC_DMA_rdret_vld_d1),
			.MC_DMA_rdret_vld(MC_DMA_rdret_vld),
			.mc_rdret_ecc	(mc_rdret_ecc),
			.ram_data_lut_dout(ram_data_lut_dout[`DMA_DATA_LUT_WIDTH-1:0]),
			.ce_rd_vld	(ce_rd_vld),
			.ce_rd_tag	(ce_rd_tag[`DMA_MC_RDREQ_TAG_SIZE-1:0]),
			.ce_rd_size	(ce_rd_dw_size[`DMA_MC_RDREQ_DWORD_SIZE-1:0]),
			.ce_rd_t2l_last	(ce_rd_t2l_last),
			.ram_rd_data_rptr_inc(ram_rd_data_rptr_inc));

   dma_ce_out_bc dma_ce_out_bc (/*AUTOINST*/
			  // Outputs
			  .ram_rd_data_rptr_inc	(ram_rd_data_rptr_inc),
			  .out_granu		(out_granu[1:0]),
			  .out_chunk_size	(out_chunk_size[6:0]),
			  .out_ie		(out_ie),
			  .out_ecc		(out_ecc),
			  .ram_mbank_data_raddr	(ram_mbank_data_raddr[8*`DMA_RD_DATA_BUF_DEPTH-1:0]),
			  .ram_mbank_data_re	(ram_mbank_data_re[7:0]),
			  .ram_cmd_info_waddr	(ram_cmd_info_waddr[`DMA_RD_INFO_BUF_DEPTH-1:0]),
			  .ram_cmd_info_raddr	(ram_cmd_info_raddr[`DMA_RD_INFO_BUF_DEPTH-1:0]),
			  .ram_cmd_info_re	(ram_cmd_info_re),
			  .cmd_info_full	(cmd_info_full),
			  .dma_ce_out_idle	(dma_ce_out_idle),
			  .skid_empty		(skid_empty),
			  .data_skid_dout	(data_skid_dout[`DMA_RD_DATA_DATA_SIZE-1:0]),
			  // Inputs
			  .clk			(clk),
			  .resetb		(resetb),
			  .bc_mode		(bc_mode),
			  .fifo_entry_vld	(fifo_entry_vld[`DMA_RD_DATA_BUF_ENTRIES-1:0]),
			  .fifo_entry_ecc	(fifo_entry_ecc[`DMA_RD_DATA_BUF_ENTRIES-1:0]),
			  .ram_mbank_data_dout	(ram_mbank_data_dout[`DMA_RD_DATA_DATA_SIZE-1:0]),
			  .ram_cmd_info_dout	(ram_cmd_info_dout[`DMA_RD_INFO_BUF_WIDTH-1:0]),
			  .ram_cmd_info_we	(ram_cmd_info_we),
			  .data_skid_re		(bc_mode ? data_skid_re_nc : 1'b0));


endmodule // sdma

