//                              -*- Mode: Verilog -*-
// NOTE: need to open or re-open for the following to work right
// p4 edit   -t +k fuse_if.vh
// p4 reopen -t +k fuse_if.vh
//
// Perforce File         : : //sysip/dfx/dfx-4/4.1/branches/dfxip4_gfxip_gfx10/fuse_if/src/rtl/fuse_if.vh.dpl n// Perforce revision     : : #2 n// Perforce changelist   : : 2885168 n// Perforce date         : : 2017/06/27 n// Perforce Author       : : couyang n//
// Copyright             : Trade secret of ATI Technologies, Inc.
//                         Copyright 2001-2002, ATI Technologies, Inc., (unpublished)
//                         All rights reserved.  This notice is intended as a precaution against
//                         inadvertent publication and does not imply publication or any waiver
//                         of confidentiality.  The year included in the foregoing notice is the
//                         year of creation of the work.
//
// Description           : fuse_if header file
//
// =========================================================================================================
//===============================================================================
// Program state of Main state machine (fseCtl)
// Begin --------------------------------------------------------------------
`define       FSECTL_RST__LOW_GC10  5'b00000 // Reset SMSg and LARR
`define       FSECTL_RST__DLY_GC10  5'b00001 // Release Reset of  SMSg and LARR
`define       FSECTL_CONF_RDY_GC10  5'b00010 // Ready to receive Configuration fuse
`define       FSECTL_CONF_LD0_GC10  5'b00011 // Load Configuration fuse (assert busy)
`define       FSECTL_CONF_LD1_GC10  5'b00100 // Load Configuration fuse (Sample  data)

`define       FSECTL_BIHR_DL0_GC10  5'b11000 // Start SMSg Clock, Request fuse from RSMU
`define       FSECTL_BIHR_REQ_GC10  5'b11001 // Transmit BIHR Request to SMSg
`define       FSECTL_BIHR_F0W_GC10  5'b10000 // Wait for 1st Fuse request
`define       FSECTL_BIHR_RRQ_GC10  5'b11101 // request to RSMU to send Next 32 fuse bits
`define       FSECTL_BIHR_RWF_GC10  5'b11110 // Wait   for RSMU to send Next 32 fuse bits
`define       FSECTL_BIHR_F0T_GC10  5'b10001 // Transmit 1st Fuse to SMSg (bits  7: 0 )
`define       FSECTL_BIHR_F1W_GC10  5'b10010 // Wait for 2nd Fuse request
`define       FSECTL_BIHR_F1T_GC10  5'b10011 // Transmit 2nd Fuse to SMSg (bits 15: 8 )
`define       FSECTL_BIHR_F2W_GC10  5'b10100 // Wait for 3rd Fuse request
`define       FSECTL_BIHR_F2T_GC10  5'b10101 // Transmit 3rd Fuse to SMSg (bits 23:16 )
`define       FSECTL_BIHR_F3W_GC10  5'b10110 // Wait for 4th Fuse request
`define       FSECTL_BIHR_F3T_GC10  5'b10111 // Transmit 4th Fuse to SMSg (bits 31:24 )
`define       FSECTL_BIHR_DL1_GC10  5'b11010 // Delay SMSg Clock stop
`define       FSECTL_BIHRDONE_GC10  5'b11011 // BIHR Done

`define       FSECTL____PAUSE_GC10  5'b01111 // Reset counter

`define       FSECTL_BIST_DL0_GC10  5'b01000 // Start SMSg Clock
`define       FSECTL_BIST_REQ_GC10  5'b01001 // Transmit MBIST Request to SMSg and LARR
`define       FSECTL_BIST_ACK_GC10  5'b01010 // Wait for SMSg Ack
`define       FSECTL_BIST_RUN_GC10  5'b01011 // Wait for both SMSg done and LARR done
`define       FSECTL_BISTBURN_GC10  5'b01100 // Check if it's burn in mode
`define       FSECTL_BIST_DL1_GC10  5'b01101 // Delay SMSg Clock stop
`define       FSECTL_BISTDONE_GC10  5'b01110 // BIST for both SMSg and LARR are done

`define       FSECTL_____IDEL_GC10  5'b11111 // Idel or done state
// End ----------------------------------------------------------------------

//===============================================================================
// Program state of Main state machine (fseJtag)
// Begin --------------------------------------------------------------------
`define       FSEJTAG__IDEL_GC10    3'b000 // JTAG MBIST not triggered
`define       FSEJTAG_START_GC10    3'b100 // 
`define       FSEJTAG_RSTB0_GC10    3'b101 // Force resetb to Latch array & SMSg to   active state (1'b0)
`define       FSEJTAG_RSTB1_GC10    3'b110 // Force resetb to Latch array & SMSg to inactive state (1'b1)
`define       FSEJTAG_MBIST_GC10    3'b111 // Run MBIST; NOTE: Burn-in mode will infinite loop here
`define       FSEJTAG__DONE_GC10    3'b001 // JTAG MBIST is done;
// End ----------------------------------------------------------------------

//===============================================================================
// BIST Config Fuse Index
// This should match table 6 of the MAS: http://svdcp4web.amd.com:1677/sysip/dfx/dfx-4/4.0/main/fuse_if/src/meta/sigdata/MASTER/doc/fuse_if.pdf
// Begin --------------------------------------------------------------------
`define       FSECONF_UNUSED__RNG_GC10              31:13
`define       FSECONF_USED__RNG_GC10                 12:0
`define       FSECONF_CONFIG_15BIT__RNG_GC10           12
`define       FSECONF_DO_NOT_MBIST__RNG_GC10           11
`define       FSECONF_DO_NOT_BIHR__RNG_GC10            10
`define       FSECONF_SMSG_BIST_CLK_DIV__RNG_GC10     9:5
`define       FSECONF_SMSG_BIHR_CLK_DIV__RNG_GC10     4:0
// End ----------------------------------------------------------------------
