`include "grbm_defs.vh"
`include "gc_register_addr.v"

//;my  = 4 * 10 * 2;



module gc_didt_cntl
   #(parameter
      UNITS         = 9,
      DIDT_CNTL_NUM = 4)
(
 input                               Cpl_GFXCLK,
 input                               oCpl_GFXCLK,
 input                               combined_resetb,
 input                               hard_resetb,
 input                               cg_override,
 input                               TEST_CLK_EN,
 input                             	 dft_shift_clk,
 input                             	 Dft_Clk_Gater_En,
 input                             	 Dft_Clk_Gater_Aon,
 input   [2:0]                       RLC_DIDT_force_stall,
 input    		                     SMU_DIDT_force_stall,

 input	[2:0]						PSM_didt_throttle_level,

 input								 gc_se_stall,
 //output								 didt_enabled,

 input [6-1:0]    sa0_didt_SQ_credit_consumed,
  output [31:0]			sa0_didt_SQ_dbg_out_0,
  output [31:0]			sa0_didt_SQ_dbg_out_1,
  output [31:0]			sa0_didt_SQ_dbg_out_2,
  output [31:0]			sa0_didt_SQ_dbg_out_3,
 input [4-1:0]    sa0_didt_DB_credit_consumed,
  output [31:0]			sa0_didt_DB_dbg_out_0,
  output [31:0]			sa0_didt_DB_dbg_out_1,
  output [31:0]			sa0_didt_DB_dbg_out_2,
  output [31:0]			sa0_didt_DB_dbg_out_3,
 input [10-1:0]    sa0_didt_TD_credit_consumed,
  output [31:0]			sa0_didt_TD_dbg_out_0,
  output [31:0]			sa0_didt_TD_dbg_out_1,
  output [31:0]			sa0_didt_TD_dbg_out_2,
  output [31:0]			sa0_didt_TD_dbg_out_3,
 input [5-1:0]    sa0_didt_TCP_credit_consumed,
  output [31:0]			sa0_didt_TCP_dbg_out_0,
  output [31:0]			sa0_didt_TCP_dbg_out_1,
  output [31:0]			sa0_didt_TCP_dbg_out_2,
  output [31:0]			sa0_didt_TCP_dbg_out_3,
  output  [31:0] 		sa0_misc_dbg_out_0,
  output  [31:0] 		sa0_misc_dbg_out_1,
  output  [31:0] 		sa0_misc_dbg_out_2,
 input [6-1:0]    sa1_didt_SQ_credit_consumed,
  output [31:0]			sa1_didt_SQ_dbg_out_0,
  output [31:0]			sa1_didt_SQ_dbg_out_1,
  output [31:0]			sa1_didt_SQ_dbg_out_2,
  output [31:0]			sa1_didt_SQ_dbg_out_3,
 input [4-1:0]    sa1_didt_DB_credit_consumed,
  output [31:0]			sa1_didt_DB_dbg_out_0,
  output [31:0]			sa1_didt_DB_dbg_out_1,
  output [31:0]			sa1_didt_DB_dbg_out_2,
  output [31:0]			sa1_didt_DB_dbg_out_3,
 input [10-1:0]    sa1_didt_TD_credit_consumed,
  output [31:0]			sa1_didt_TD_dbg_out_0,
  output [31:0]			sa1_didt_TD_dbg_out_1,
  output [31:0]			sa1_didt_TD_dbg_out_2,
  output [31:0]			sa1_didt_TD_dbg_out_3,
 input [5-1:0]    sa1_didt_TCP_credit_consumed,
  output [31:0]			sa1_didt_TCP_dbg_out_0,
  output [31:0]			sa1_didt_TCP_dbg_out_1,
  output [31:0]			sa1_didt_TCP_dbg_out_2,
  output [31:0]			sa1_didt_TCP_dbg_out_3,
  output  [31:0] 		sa1_misc_dbg_out_0,
  output  [31:0] 		sa1_misc_dbg_out_1,
  output  [31:0] 		sa1_misc_dbg_out_2,


	output wire [10-1:0] sa0_didt_SQ_stall_out,


	output wire [4-1:0] sa0_didt_DB_stall_out,


	output wire [10-1:0] sa0_didt_TD_stall_out,


	output wire [10-1:0] sa0_didt_TCP_stall_out,


	output wire [10-1:0] sa1_didt_SQ_stall_out,


	output wire [4-1:0] sa1_didt_DB_stall_out,


	output wire [10-1:0] sa1_didt_TD_stall_out,


	output wire [10-1:0] sa1_didt_TCP_stall_out,


  output wire [3:0]					didt_SQ_power_level,
  input wire [2:0]					didt_SQ_stall_level,
  input wire [2:0]					didt_SQ_gc_edc_stall_level,

  output                        	didt_edc_SQ_enable,
  output wire [3:0]					didt_DB_power_level,
  input wire [2:0]					didt_DB_stall_level,
  input wire [2:0]					didt_DB_gc_edc_stall_level,

  output                        	didt_edc_DB_enable,
  output wire [3:0]					didt_TD_power_level,
  input wire [2:0]					didt_TD_stall_level,
  input wire [2:0]					didt_TD_gc_edc_stall_level,

  output                        	didt_edc_TD_enable,
  output wire [3:0]					didt_TCP_power_level,
  input wire [2:0]					didt_TCP_stall_level,
  input wire [2:0]					didt_TCP_gc_edc_stall_level,

  output                        	didt_edc_TCP_enable,

 output wire                              didt_read_valid,
 output wire [`TARG_GRBM_READ_DATA_RANGE] didt_read_data,

 input                               reg_clk,
 input                               reg_send,
 input                               reg_op,
 input [`GRBM_TARG_REG_ADDR_RANGE]   reg_addr,
 input [`GRBM_TARG_REG_WD_RANGE]     reg_wd,
 input [1:0]                         reg_se_index,
 input [1:0]                         reg_sh_index,
 input								 reg_instance_select,

 input [1:0]                         SE_STRAP_id
);


  reg [`GRBM_TARG_REG_SEND_RANGE]    reg_send_q;
  reg [`GRBM_TARG_REG_ADDR_RANGE]    reg_addr_q;
  reg [`GRBM_TARG_REG_WD_RANGE]      reg_wd_q;
  reg [`GRBM_TARG_REG_OP_RANGE]      reg_op_q;

  wire [`TARG_GRBM_READ_DATA_RANGE]  reg_rd_data;
  wire                               reg_rd_en;


  wire                               reg_instance_sel;
  wire                               didt_SQ_didt_ctrl_en;
  wire [1:0]                         didt_SQ_phase_offset;
  wire                               didt_SQ_didt_ctrl_rst;
  wire                               didt_SQ_didt_clk_en_override;
  wire [5:0]                         didt_SQ_didt_max_stalls_allowed_hi;
  wire [5:0]                         didt_SQ_didt_max_stalls_allowed_lo;
  wire [5:0]                         didt_SQ_stall_delay_hi;
  wire [5:0]                         didt_SQ_stall_delay_lo;

                                      // SA_DIDT_SQ_CTRL1
  wire [15:0]                        didt_SQ_min_power;
  wire [15:0]                        didt_SQ_max_power;
                             // SH_DIDT_SQ_CTRL2
  wire [13:0]                        didt_SQ_max_power_delta;
  wire [9:0]                         didt_SQ_short_term_interval_size;
  wire [3:0]                         didt_SQ_long_term_interval_ratio;

                                      // SA_DIDT_SQ_CTRL_OCP
  wire [15:0]                        didt_SQ_ocp_max_power;

                             // SH_DIDT_SQ_TUNING_CTRL
  wire [0:0]					     didt_SQ_didt_tuning_enable;
  wire [13:0]					     didt_SQ_max_power_delta_hi;
  wire [13:0]					     didt_SQ_max_power_delta_lo;
  wire [0:0]					     didt_SQ_didt_auto_mpd_enable;

  wire [3:0]                         didt_SQ_mpd_ratio_scale_level1;
  wire [3:0]                         didt_SQ_mpd_ratio_scale_level2;
  wire [3:0]                         didt_SQ_mpd_ratio_scale_level3;
  wire [3:0]                         didt_SQ_mpd_ratio_scale_level4;
  wire [3:0]                         didt_SQ_mpd_scale_level0;
  wire [3:0]                         didt_SQ_mpd_scale_level1;
  wire [3:0]                         didt_SQ_mpd_scale_level2;
  wire [3:0]                         didt_SQ_mpd_scale_level3;

                                      // DIDT_SQ_STALL_RELEASE_CNTL0
  wire [0:0]			     didt_SQ_didt_stall_release_cntl_en;
  wire [0:0]			     didt_SQ_didt_stall_cntl_sel;
  wire [10:0]			     didt_SQ_didt_release_delay_hi;
  wire [10:0]			     didt_SQ_didt_release_delay_lo;

                                      // DIDT_SQ_STALL_RELEASE_CNTL0
  wire [4:0]			     didt_SQ_didt_base_release_allowed_hi;
  wire [4:0]			     didt_SQ_didt_incr_release_allowed_hi;
  wire [4:0]		             didt_SQ_didt_base_release_allowed_lo;
  wire [4:0]			     didt_SQ_didt_incr_release_allowed_lo; 

  wire [1:0]                         didt_SQ_didt_stall_release_cntl_fsm_state;

                                      // SH_DIDT_SQ_WEIGHT0_3
  wire [7:0]                         didt_SQ_weight0;
  wire [7:0]                         didt_SQ_weight1;
  wire [7:0]                         didt_SQ_weight2;
  wire [7:0]                         didt_SQ_weight3;

                                      // SH_DIDT_SQ_WEIGHT4_7
  wire [7:0]                         didt_SQ_weight4;
  wire [7:0]                         didt_SQ_weight5;
  wire [7:0]                         didt_SQ_weight6;
  wire [7:0]                         didt_SQ_weight7;

                                      // SH_DIDT_SQ_WEIGHT8_11
  wire [7:0]                         didt_SQ_weight8;
  wire [7:0]                         didt_SQ_weight9;
  wire [7:0]                         didt_SQ_weight10;
  wire [7:0]                         didt_SQ_weight11;

  wire [15:0]                         		didt_SQ_hi_power_threshold;
  wire [4:0]					didt_SQ_didt_trigger_throttle_lowbit;
  wire [4:0]					didt_SQ_didt_power_level_lowbit;
  wire						didt_SQ_gc_didt_enable;
  wire						didt_SQ_gc_didt_clk_en_override;
  wire [1:0]					didt_SQ_throttle_policy;
  wire [7:0]					didt_SQ_didt_stall_pattern_bit_nums;
  wire [0:0]					didt_SQ_gc_didt_level_comb_en;
  wire [0:0]					didt_SQ_se_didt_level_comb_en;
  wire [0:0]					didt_SQ_qualify_stall_en;
  wire [1:0]					didt_SQ_didt_stall_sel;
  wire      					didt_SQ_didt_force_stall;
  wire      					didt_SQ_didt_stall_delay_en;

  wire [14:0]					didt_SQ_didt_stall_pattern1;
  wire [14:0]					didt_SQ_didt_stall_pattern2;
  wire [14:0]					didt_SQ_didt_stall_pattern3;
  wire [14:0]					didt_SQ_didt_stall_pattern4;
  wire [14:0]					didt_SQ_didt_stall_pattern5;
  wire [14:0]					didt_SQ_didt_stall_pattern6;
  wire [14:0]					didt_SQ_didt_stall_pattern7;

  wire						didt_SQ_didt_stall_event_enable;
  wire						didt_SQ_didt_stall_event_counter_clear;
  wire [31:0]					didt_SQ_didt_stall_event_counter;
  wire                                          didt_SQ_didt_rlc_force_stall_en;
  wire                                          didt_SQ_didt_rlc_stall_level_sel;
  wire								didt_SQ_didt_throttle_mode;
  wire				                didt_SQ_didt_fsm_state;
  wire[2:0]			                didt_SQ_didt_throttle_level;
  wire				                didt_SQ_didt_dbg_stall_out;

  wire				didt_SQ_edc_en;
  wire				didt_SQ_edc_sw_rst;
  wire				didt_SQ_edc_clk_en_override;
  wire				didt_SQ_edc_force_stall;
  wire[31:0]		        didt_SQ_edc_threshold;
  wire[4:0]			didt_SQ_edc_trigger_throttle_lowbit;
  wire[7:0]			didt_SQ_edc_stall_pattern_bit_nums;
  wire				didt_SQ_edc_allow_write_pwrdelta;
  wire				didt_SQ_edc_grbm_wr_pwrdelta_en;
  wire				didt_SQ_edc_grbm_clear_ov_counter;
  
	wire[6-1:0]		didt_SQ_edc_stall_delay_sig0;
	wire[6-1:0]		didt_SQ_edc_stall_delay_sig1;
	wire[6-1:0]		didt_SQ_edc_stall_delay_sig2;
	wire[6-1:0]		didt_SQ_edc_stall_delay_sig3;
	wire[6-1:0]		didt_SQ_edc_stall_delay_sig4;
	wire[6-1:0]		didt_SQ_edc_stall_delay_sig5;
	wire[6-1:0]		didt_SQ_edc_stall_delay_sig6;
	wire[6-1:0]		didt_SQ_edc_stall_delay_sig7;
	wire[6-1:0]		didt_SQ_edc_stall_delay_sig8;
	wire[6-1:0]		didt_SQ_edc_stall_delay_sig9;

  wire[31:0]		didt_SQ_edc_grbm_wr_pwrdelta_data;
  wire[15:0]		didt_SQ_edc_throttle_level_ov_counter;
  wire			didt_SQ_edc_rolling_power_delta_ov;
  wire			didt_SQ_edc_grbm_clear_rolling_power_delta_ov;
  wire[31:0]		didt_SQ_edc_rolling_power_delta;
  wire[14:0]		didt_SQ_edc_stall_pattern1;
  wire[14:0]		didt_SQ_edc_stall_pattern2;
  wire[14:0]		didt_SQ_edc_stall_pattern3;
  wire[14:0]		didt_SQ_edc_stall_pattern4;
  wire[14:0]		didt_SQ_edc_stall_pattern5;
  wire[14:0]		didt_SQ_edc_stall_pattern6;
  wire[14:0]		didt_SQ_edc_stall_pattern7;
  wire				didt_SQ_edc_fsm_state;
  wire[2:0]			didt_SQ_edc_throttle_level;
  wire				didt_SQ_edc_dbg_stall_out;

  wire				didt_SQ_gc_edc_en;
  wire[1:0]			didt_SQ_gc_edc_stall_policy;
  wire[0:0]			didt_SQ_gc_edc_level_comb_en;
  wire[0:0]			didt_SQ_se_edc_level_comb_en;
  wire[0:0]			didt_SQ_edc_level_mode_sel;
  wire[0:0]			didt_SQ_edc_level_comb_adapt_mode_en;
  wire				didt_SQ_gc_edc_stall_en;
  wire				didt_SQ_pcc_stall_en;
  wire				didt_SQ_pwrbrk_stall_en;
  wire[31:0]		didt_SQ_edc_pcc_perf_counter;
  wire				rd_didt_SQ_edc_pcc_perf_counter;
  wire 				didt_SQ_gc_edc_only_mode;
  wire[13:0]                    didt_SQ_edc_timer_period;

assign didt_edc_SQ_enable = didt_SQ_didt_ctrl_en || didt_SQ_edc_en;

  wire                               didt_DB_didt_ctrl_en;
  wire [1:0]                         didt_DB_phase_offset;
  wire                               didt_DB_didt_ctrl_rst;
  wire                               didt_DB_didt_clk_en_override;
  wire [5:0]                         didt_DB_didt_max_stalls_allowed_hi;
  wire [5:0]                         didt_DB_didt_max_stalls_allowed_lo;
  wire [5:0]                         didt_DB_stall_delay_hi;
  wire [5:0]                         didt_DB_stall_delay_lo;

                                      // SA_DIDT_DB_CTRL1
  wire [15:0]                        didt_DB_min_power;
  wire [15:0]                        didt_DB_max_power;
                             // SH_DIDT_DB_CTRL2
  wire [13:0]                        didt_DB_max_power_delta;
  wire [9:0]                         didt_DB_short_term_interval_size;
  wire [3:0]                         didt_DB_long_term_interval_ratio;

                                      // SA_DIDT_DB_CTRL_OCP
  wire [15:0]                        didt_DB_ocp_max_power;

                             // SH_DIDT_DB_TUNING_CTRL
  wire [0:0]					     didt_DB_didt_tuning_enable;
  wire [13:0]					     didt_DB_max_power_delta_hi;
  wire [13:0]					     didt_DB_max_power_delta_lo;
  wire [0:0]					     didt_DB_didt_auto_mpd_enable;

  wire [3:0]                         didt_DB_mpd_ratio_scale_level1;
  wire [3:0]                         didt_DB_mpd_ratio_scale_level2;
  wire [3:0]                         didt_DB_mpd_ratio_scale_level3;
  wire [3:0]                         didt_DB_mpd_ratio_scale_level4;
  wire [3:0]                         didt_DB_mpd_scale_level0;
  wire [3:0]                         didt_DB_mpd_scale_level1;
  wire [3:0]                         didt_DB_mpd_scale_level2;
  wire [3:0]                         didt_DB_mpd_scale_level3;

                                      // DIDT_DB_STALL_RELEASE_CNTL0
  wire [0:0]			     didt_DB_didt_stall_release_cntl_en;
  wire [0:0]			     didt_DB_didt_stall_cntl_sel;
  wire [10:0]			     didt_DB_didt_release_delay_hi;
  wire [10:0]			     didt_DB_didt_release_delay_lo;

                                      // DIDT_DB_STALL_RELEASE_CNTL0
  wire [4:0]			     didt_DB_didt_base_release_allowed_hi;
  wire [4:0]			     didt_DB_didt_incr_release_allowed_hi;
  wire [4:0]		             didt_DB_didt_base_release_allowed_lo;
  wire [4:0]			     didt_DB_didt_incr_release_allowed_lo; 

  wire [1:0]                         didt_DB_didt_stall_release_cntl_fsm_state;

                                      // SH_DIDT_DB_WEIGHT0_3
  wire [7:0]                         didt_DB_weight0;
  wire [7:0]                         didt_DB_weight1;
  wire [7:0]                         didt_DB_weight2;
  wire [7:0]                         didt_DB_weight3;

                                      // SH_DIDT_DB_WEIGHT4_7
  wire [7:0]                         didt_DB_weight4;
  wire [7:0]                         didt_DB_weight5;
  wire [7:0]                         didt_DB_weight6;
  wire [7:0]                         didt_DB_weight7;

                                      // SH_DIDT_DB_WEIGHT8_11
  wire [7:0]                         didt_DB_weight8;
  wire [7:0]                         didt_DB_weight9;
  wire [7:0]                         didt_DB_weight10;
  wire [7:0]                         didt_DB_weight11;

  wire [15:0]                         		didt_DB_hi_power_threshold;
  wire [4:0]					didt_DB_didt_trigger_throttle_lowbit;
  wire [4:0]					didt_DB_didt_power_level_lowbit;
  wire						didt_DB_gc_didt_enable;
  wire						didt_DB_gc_didt_clk_en_override;
  wire [1:0]					didt_DB_throttle_policy;
  wire [7:0]					didt_DB_didt_stall_pattern_bit_nums;
  wire [0:0]					didt_DB_gc_didt_level_comb_en;
  wire [0:0]					didt_DB_se_didt_level_comb_en;
  wire [0:0]					didt_DB_qualify_stall_en;
  wire [1:0]					didt_DB_didt_stall_sel;
  wire      					didt_DB_didt_force_stall;
  wire      					didt_DB_didt_stall_delay_en;

  wire [14:0]					didt_DB_didt_stall_pattern1;
  wire [14:0]					didt_DB_didt_stall_pattern2;
  wire [14:0]					didt_DB_didt_stall_pattern3;
  wire [14:0]					didt_DB_didt_stall_pattern4;
  wire [14:0]					didt_DB_didt_stall_pattern5;
  wire [14:0]					didt_DB_didt_stall_pattern6;
  wire [14:0]					didt_DB_didt_stall_pattern7;

  wire						didt_DB_didt_stall_event_enable;
  wire						didt_DB_didt_stall_event_counter_clear;
  wire [31:0]					didt_DB_didt_stall_event_counter;
  wire                                          didt_DB_didt_rlc_force_stall_en;
  wire                                          didt_DB_didt_rlc_stall_level_sel;
  wire								didt_DB_didt_throttle_mode;
  wire				                didt_DB_didt_fsm_state;
  wire[2:0]			                didt_DB_didt_throttle_level;
  wire				                didt_DB_didt_dbg_stall_out;

  wire				didt_DB_edc_en;
  wire				didt_DB_edc_sw_rst;
  wire				didt_DB_edc_clk_en_override;
  wire				didt_DB_edc_force_stall;
  wire[31:0]		        didt_DB_edc_threshold;
  wire[4:0]			didt_DB_edc_trigger_throttle_lowbit;
  wire[7:0]			didt_DB_edc_stall_pattern_bit_nums;
  wire				didt_DB_edc_allow_write_pwrdelta;
  wire				didt_DB_edc_grbm_wr_pwrdelta_en;
  wire				didt_DB_edc_grbm_clear_ov_counter;
  
	wire[5-1:0]		didt_DB_edc_stall_delay_sig0;
	wire[5-1:0]		didt_DB_edc_stall_delay_sig1;
	wire[5-1:0]		didt_DB_edc_stall_delay_sig2;
	wire[5-1:0]		didt_DB_edc_stall_delay_sig3;

  wire[31:0]		didt_DB_edc_grbm_wr_pwrdelta_data;
  wire[15:0]		didt_DB_edc_throttle_level_ov_counter;
  wire			didt_DB_edc_rolling_power_delta_ov;
  wire			didt_DB_edc_grbm_clear_rolling_power_delta_ov;
  wire[31:0]		didt_DB_edc_rolling_power_delta;
  wire[14:0]		didt_DB_edc_stall_pattern1;
  wire[14:0]		didt_DB_edc_stall_pattern2;
  wire[14:0]		didt_DB_edc_stall_pattern3;
  wire[14:0]		didt_DB_edc_stall_pattern4;
  wire[14:0]		didt_DB_edc_stall_pattern5;
  wire[14:0]		didt_DB_edc_stall_pattern6;
  wire[14:0]		didt_DB_edc_stall_pattern7;
  wire				didt_DB_edc_fsm_state;
  wire[2:0]			didt_DB_edc_throttle_level;
  wire				didt_DB_edc_dbg_stall_out;

  wire				didt_DB_gc_edc_en;
  wire[1:0]			didt_DB_gc_edc_stall_policy;
  wire[0:0]			didt_DB_gc_edc_level_comb_en;
  wire[0:0]			didt_DB_se_edc_level_comb_en;
  wire[0:0]			didt_DB_edc_level_mode_sel;
  wire[0:0]			didt_DB_edc_level_comb_adapt_mode_en;
  wire				didt_DB_gc_edc_stall_en;
  wire				didt_DB_pcc_stall_en;
  wire				didt_DB_pwrbrk_stall_en;
  wire[31:0]		didt_DB_edc_pcc_perf_counter;
  wire				rd_didt_DB_edc_pcc_perf_counter;
  wire 				didt_DB_gc_edc_only_mode;
  wire[13:0]                    didt_DB_edc_timer_period;

assign didt_edc_DB_enable = didt_DB_didt_ctrl_en || didt_DB_edc_en;

  wire                               didt_TD_didt_ctrl_en;
  wire [1:0]                         didt_TD_phase_offset;
  wire                               didt_TD_didt_ctrl_rst;
  wire                               didt_TD_didt_clk_en_override;
  wire [5:0]                         didt_TD_didt_max_stalls_allowed_hi;
  wire [5:0]                         didt_TD_didt_max_stalls_allowed_lo;
  wire [5:0]                         didt_TD_stall_delay_hi;
  wire [5:0]                         didt_TD_stall_delay_lo;

                                      // SA_DIDT_TD_CTRL1
  wire [15:0]                        didt_TD_min_power;
  wire [15:0]                        didt_TD_max_power;
                             // SH_DIDT_TD_CTRL2
  wire [13:0]                        didt_TD_max_power_delta;
  wire [9:0]                         didt_TD_short_term_interval_size;
  wire [3:0]                         didt_TD_long_term_interval_ratio;

                                      // SA_DIDT_TD_CTRL_OCP
  wire [15:0]                        didt_TD_ocp_max_power;

                             // SH_DIDT_TD_TUNING_CTRL
  wire [0:0]					     didt_TD_didt_tuning_enable;
  wire [13:0]					     didt_TD_max_power_delta_hi;
  wire [13:0]					     didt_TD_max_power_delta_lo;
  wire [0:0]					     didt_TD_didt_auto_mpd_enable;

  wire [3:0]                         didt_TD_mpd_ratio_scale_level1;
  wire [3:0]                         didt_TD_mpd_ratio_scale_level2;
  wire [3:0]                         didt_TD_mpd_ratio_scale_level3;
  wire [3:0]                         didt_TD_mpd_ratio_scale_level4;
  wire [3:0]                         didt_TD_mpd_scale_level0;
  wire [3:0]                         didt_TD_mpd_scale_level1;
  wire [3:0]                         didt_TD_mpd_scale_level2;
  wire [3:0]                         didt_TD_mpd_scale_level3;

                                      // DIDT_TD_STALL_RELEASE_CNTL0
  wire [0:0]			     didt_TD_didt_stall_release_cntl_en;
  wire [0:0]			     didt_TD_didt_stall_cntl_sel;
  wire [10:0]			     didt_TD_didt_release_delay_hi;
  wire [10:0]			     didt_TD_didt_release_delay_lo;

                                      // DIDT_TD_STALL_RELEASE_CNTL0
  wire [4:0]			     didt_TD_didt_base_release_allowed_hi;
  wire [4:0]			     didt_TD_didt_incr_release_allowed_hi;
  wire [4:0]		             didt_TD_didt_base_release_allowed_lo;
  wire [4:0]			     didt_TD_didt_incr_release_allowed_lo; 

  wire [1:0]                         didt_TD_didt_stall_release_cntl_fsm_state;

                                      // SH_DIDT_TD_WEIGHT0_3
  wire [7:0]                         didt_TD_weight0;
  wire [7:0]                         didt_TD_weight1;
  wire [7:0]                         didt_TD_weight2;
  wire [7:0]                         didt_TD_weight3;

                                      // SH_DIDT_TD_WEIGHT4_7
  wire [7:0]                         didt_TD_weight4;
  wire [7:0]                         didt_TD_weight5;
  wire [7:0]                         didt_TD_weight6;
  wire [7:0]                         didt_TD_weight7;

                                      // SH_DIDT_TD_WEIGHT8_11
  wire [7:0]                         didt_TD_weight8;
  wire [7:0]                         didt_TD_weight9;
  wire [7:0]                         didt_TD_weight10;
  wire [7:0]                         didt_TD_weight11;

  wire [15:0]                         		didt_TD_hi_power_threshold;
  wire [4:0]					didt_TD_didt_trigger_throttle_lowbit;
  wire [4:0]					didt_TD_didt_power_level_lowbit;
  wire						didt_TD_gc_didt_enable;
  wire						didt_TD_gc_didt_clk_en_override;
  wire [1:0]					didt_TD_throttle_policy;
  wire [7:0]					didt_TD_didt_stall_pattern_bit_nums;
  wire [0:0]					didt_TD_gc_didt_level_comb_en;
  wire [0:0]					didt_TD_se_didt_level_comb_en;
  wire [0:0]					didt_TD_qualify_stall_en;
  wire [1:0]					didt_TD_didt_stall_sel;
  wire      					didt_TD_didt_force_stall;
  wire      					didt_TD_didt_stall_delay_en;

  wire [14:0]					didt_TD_didt_stall_pattern1;
  wire [14:0]					didt_TD_didt_stall_pattern2;
  wire [14:0]					didt_TD_didt_stall_pattern3;
  wire [14:0]					didt_TD_didt_stall_pattern4;
  wire [14:0]					didt_TD_didt_stall_pattern5;
  wire [14:0]					didt_TD_didt_stall_pattern6;
  wire [14:0]					didt_TD_didt_stall_pattern7;

  wire						didt_TD_didt_stall_event_enable;
  wire						didt_TD_didt_stall_event_counter_clear;
  wire [31:0]					didt_TD_didt_stall_event_counter;
  wire                                          didt_TD_didt_rlc_force_stall_en;
  wire                                          didt_TD_didt_rlc_stall_level_sel;
  wire								didt_TD_didt_throttle_mode;
  wire				                didt_TD_didt_fsm_state;
  wire[2:0]			                didt_TD_didt_throttle_level;
  wire				                didt_TD_didt_dbg_stall_out;

  wire				didt_TD_edc_en;
  wire				didt_TD_edc_sw_rst;
  wire				didt_TD_edc_clk_en_override;
  wire				didt_TD_edc_force_stall;
  wire[31:0]		        didt_TD_edc_threshold;
  wire[4:0]			didt_TD_edc_trigger_throttle_lowbit;
  wire[7:0]			didt_TD_edc_stall_pattern_bit_nums;
  wire				didt_TD_edc_allow_write_pwrdelta;
  wire				didt_TD_edc_grbm_wr_pwrdelta_en;
  wire				didt_TD_edc_grbm_clear_ov_counter;
  
	wire[6-1:0]		didt_TD_edc_stall_delay_sig0;
	wire[6-1:0]		didt_TD_edc_stall_delay_sig1;
	wire[6-1:0]		didt_TD_edc_stall_delay_sig2;
	wire[6-1:0]		didt_TD_edc_stall_delay_sig3;
	wire[6-1:0]		didt_TD_edc_stall_delay_sig4;
	wire[6-1:0]		didt_TD_edc_stall_delay_sig5;
	wire[6-1:0]		didt_TD_edc_stall_delay_sig6;
	wire[6-1:0]		didt_TD_edc_stall_delay_sig7;
	wire[6-1:0]		didt_TD_edc_stall_delay_sig8;
	wire[6-1:0]		didt_TD_edc_stall_delay_sig9;

  wire[31:0]		didt_TD_edc_grbm_wr_pwrdelta_data;
  wire[15:0]		didt_TD_edc_throttle_level_ov_counter;
  wire			didt_TD_edc_rolling_power_delta_ov;
  wire			didt_TD_edc_grbm_clear_rolling_power_delta_ov;
  wire[31:0]		didt_TD_edc_rolling_power_delta;
  wire[14:0]		didt_TD_edc_stall_pattern1;
  wire[14:0]		didt_TD_edc_stall_pattern2;
  wire[14:0]		didt_TD_edc_stall_pattern3;
  wire[14:0]		didt_TD_edc_stall_pattern4;
  wire[14:0]		didt_TD_edc_stall_pattern5;
  wire[14:0]		didt_TD_edc_stall_pattern6;
  wire[14:0]		didt_TD_edc_stall_pattern7;
  wire				didt_TD_edc_fsm_state;
  wire[2:0]			didt_TD_edc_throttle_level;
  wire				didt_TD_edc_dbg_stall_out;

  wire				didt_TD_gc_edc_en;
  wire[1:0]			didt_TD_gc_edc_stall_policy;
  wire[0:0]			didt_TD_gc_edc_level_comb_en;
  wire[0:0]			didt_TD_se_edc_level_comb_en;
  wire[0:0]			didt_TD_edc_level_mode_sel;
  wire[0:0]			didt_TD_edc_level_comb_adapt_mode_en;
  wire				didt_TD_gc_edc_stall_en;
  wire				didt_TD_pcc_stall_en;
  wire				didt_TD_pwrbrk_stall_en;
  wire[31:0]		didt_TD_edc_pcc_perf_counter;
  wire				rd_didt_TD_edc_pcc_perf_counter;
  wire 				didt_TD_gc_edc_only_mode;
  wire[13:0]                    didt_TD_edc_timer_period;

assign didt_edc_TD_enable = didt_TD_didt_ctrl_en || didt_TD_edc_en;

  wire                               didt_TCP_didt_ctrl_en;
  wire [1:0]                         didt_TCP_phase_offset;
  wire                               didt_TCP_didt_ctrl_rst;
  wire                               didt_TCP_didt_clk_en_override;
  wire [5:0]                         didt_TCP_didt_max_stalls_allowed_hi;
  wire [5:0]                         didt_TCP_didt_max_stalls_allowed_lo;
  wire [5:0]                         didt_TCP_stall_delay_hi;
  wire [5:0]                         didt_TCP_stall_delay_lo;

                                      // SA_DIDT_TCP_CTRL1
  wire [15:0]                        didt_TCP_min_power;
  wire [15:0]                        didt_TCP_max_power;
                             // SH_DIDT_TCP_CTRL2
  wire [13:0]                        didt_TCP_max_power_delta;
  wire [9:0]                         didt_TCP_short_term_interval_size;
  wire [3:0]                         didt_TCP_long_term_interval_ratio;

                                      // SA_DIDT_TCP_CTRL_OCP
  wire [15:0]                        didt_TCP_ocp_max_power;

                             // SH_DIDT_TCP_TUNING_CTRL
  wire [0:0]					     didt_TCP_didt_tuning_enable;
  wire [13:0]					     didt_TCP_max_power_delta_hi;
  wire [13:0]					     didt_TCP_max_power_delta_lo;
  wire [0:0]					     didt_TCP_didt_auto_mpd_enable;

  wire [3:0]                         didt_TCP_mpd_ratio_scale_level1;
  wire [3:0]                         didt_TCP_mpd_ratio_scale_level2;
  wire [3:0]                         didt_TCP_mpd_ratio_scale_level3;
  wire [3:0]                         didt_TCP_mpd_ratio_scale_level4;
  wire [3:0]                         didt_TCP_mpd_scale_level0;
  wire [3:0]                         didt_TCP_mpd_scale_level1;
  wire [3:0]                         didt_TCP_mpd_scale_level2;
  wire [3:0]                         didt_TCP_mpd_scale_level3;

                                      // DIDT_TCP_STALL_RELEASE_CNTL0
  wire [0:0]			     didt_TCP_didt_stall_release_cntl_en;
  wire [0:0]			     didt_TCP_didt_stall_cntl_sel;
  wire [10:0]			     didt_TCP_didt_release_delay_hi;
  wire [10:0]			     didt_TCP_didt_release_delay_lo;

                                      // DIDT_TCP_STALL_RELEASE_CNTL0
  wire [4:0]			     didt_TCP_didt_base_release_allowed_hi;
  wire [4:0]			     didt_TCP_didt_incr_release_allowed_hi;
  wire [4:0]		             didt_TCP_didt_base_release_allowed_lo;
  wire [4:0]			     didt_TCP_didt_incr_release_allowed_lo; 

  wire [1:0]                         didt_TCP_didt_stall_release_cntl_fsm_state;

                                      // SH_DIDT_TCP_WEIGHT0_3
  wire [7:0]                         didt_TCP_weight0;
  wire [7:0]                         didt_TCP_weight1;
  wire [7:0]                         didt_TCP_weight2;
  wire [7:0]                         didt_TCP_weight3;

                                      // SH_DIDT_TCP_WEIGHT4_7
  wire [7:0]                         didt_TCP_weight4;
  wire [7:0]                         didt_TCP_weight5;
  wire [7:0]                         didt_TCP_weight6;
  wire [7:0]                         didt_TCP_weight7;

                                      // SH_DIDT_TCP_WEIGHT8_11
  wire [7:0]                         didt_TCP_weight8;
  wire [7:0]                         didt_TCP_weight9;
  wire [7:0]                         didt_TCP_weight10;
  wire [7:0]                         didt_TCP_weight11;

  wire [15:0]                         		didt_TCP_hi_power_threshold;
  wire [4:0]					didt_TCP_didt_trigger_throttle_lowbit;
  wire [4:0]					didt_TCP_didt_power_level_lowbit;
  wire						didt_TCP_gc_didt_enable;
  wire						didt_TCP_gc_didt_clk_en_override;
  wire [1:0]					didt_TCP_throttle_policy;
  wire [7:0]					didt_TCP_didt_stall_pattern_bit_nums;
  wire [0:0]					didt_TCP_gc_didt_level_comb_en;
  wire [0:0]					didt_TCP_se_didt_level_comb_en;
  wire [0:0]					didt_TCP_qualify_stall_en;
  wire [1:0]					didt_TCP_didt_stall_sel;
  wire      					didt_TCP_didt_force_stall;
  wire      					didt_TCP_didt_stall_delay_en;

  wire [14:0]					didt_TCP_didt_stall_pattern1;
  wire [14:0]					didt_TCP_didt_stall_pattern2;
  wire [14:0]					didt_TCP_didt_stall_pattern3;
  wire [14:0]					didt_TCP_didt_stall_pattern4;
  wire [14:0]					didt_TCP_didt_stall_pattern5;
  wire [14:0]					didt_TCP_didt_stall_pattern6;
  wire [14:0]					didt_TCP_didt_stall_pattern7;

  wire						didt_TCP_didt_stall_event_enable;
  wire						didt_TCP_didt_stall_event_counter_clear;
  wire [31:0]					didt_TCP_didt_stall_event_counter;
  wire                                          didt_TCP_didt_rlc_force_stall_en;
  wire                                          didt_TCP_didt_rlc_stall_level_sel;
  wire								didt_TCP_didt_throttle_mode;
  wire				                didt_TCP_didt_fsm_state;
  wire[2:0]			                didt_TCP_didt_throttle_level;
  wire				                didt_TCP_didt_dbg_stall_out;

  wire				didt_TCP_edc_en;
  wire				didt_TCP_edc_sw_rst;
  wire				didt_TCP_edc_clk_en_override;
  wire				didt_TCP_edc_force_stall;
  wire[31:0]		        didt_TCP_edc_threshold;
  wire[4:0]			didt_TCP_edc_trigger_throttle_lowbit;
  wire[7:0]			didt_TCP_edc_stall_pattern_bit_nums;
  wire				didt_TCP_edc_allow_write_pwrdelta;
  wire				didt_TCP_edc_grbm_wr_pwrdelta_en;
  wire				didt_TCP_edc_grbm_clear_ov_counter;
  
	wire[6-1:0]		didt_TCP_edc_stall_delay_sig0;
	wire[6-1:0]		didt_TCP_edc_stall_delay_sig1;
	wire[6-1:0]		didt_TCP_edc_stall_delay_sig2;
	wire[6-1:0]		didt_TCP_edc_stall_delay_sig3;
	wire[6-1:0]		didt_TCP_edc_stall_delay_sig4;
	wire[6-1:0]		didt_TCP_edc_stall_delay_sig5;
	wire[6-1:0]		didt_TCP_edc_stall_delay_sig6;
	wire[6-1:0]		didt_TCP_edc_stall_delay_sig7;
	wire[6-1:0]		didt_TCP_edc_stall_delay_sig8;
	wire[6-1:0]		didt_TCP_edc_stall_delay_sig9;

  wire[31:0]		didt_TCP_edc_grbm_wr_pwrdelta_data;
  wire[15:0]		didt_TCP_edc_throttle_level_ov_counter;
  wire			didt_TCP_edc_rolling_power_delta_ov;
  wire			didt_TCP_edc_grbm_clear_rolling_power_delta_ov;
  wire[31:0]		didt_TCP_edc_rolling_power_delta;
  wire[14:0]		didt_TCP_edc_stall_pattern1;
  wire[14:0]		didt_TCP_edc_stall_pattern2;
  wire[14:0]		didt_TCP_edc_stall_pattern3;
  wire[14:0]		didt_TCP_edc_stall_pattern4;
  wire[14:0]		didt_TCP_edc_stall_pattern5;
  wire[14:0]		didt_TCP_edc_stall_pattern6;
  wire[14:0]		didt_TCP_edc_stall_pattern7;
  wire				didt_TCP_edc_fsm_state;
  wire[2:0]			didt_TCP_edc_throttle_level;
  wire				didt_TCP_edc_dbg_stall_out;

  wire				didt_TCP_gc_edc_en;
  wire[1:0]			didt_TCP_gc_edc_stall_policy;
  wire[0:0]			didt_TCP_gc_edc_level_comb_en;
  wire[0:0]			didt_TCP_se_edc_level_comb_en;
  wire[0:0]			didt_TCP_edc_level_mode_sel;
  wire[0:0]			didt_TCP_edc_level_comb_adapt_mode_en;
  wire				didt_TCP_gc_edc_stall_en;
  wire				didt_TCP_pcc_stall_en;
  wire				didt_TCP_pwrbrk_stall_en;
  wire[31:0]		didt_TCP_edc_pcc_perf_counter;
  wire				rd_didt_TCP_edc_pcc_perf_counter;
  wire 				didt_TCP_gc_edc_only_mode;
  wire[13:0]                    didt_TCP_edc_timer_period;

assign didt_edc_TCP_enable = didt_TCP_didt_ctrl_en || didt_TCP_edc_en;




	 wire [10-1:0] didt_SQ_edc_stall;


	 wire [4-1:0] didt_DB_edc_stall;


	 wire [10-1:0] didt_TD_edc_stall;


	 wire [10-1:0] didt_TCP_edc_stall;

 wire                         didt_SQ_stall_ctrl_enable;
 wire[5:0]                    didt_SQ_stall_delay;
 wire                         didt_SQ_power_is_hi;
 wire[5:0]                    didt_SQ_max_stalls_allowed;
 wire                         didt_SQ_stall_auto_release_enable;
 wire [23:0]                  didt_SQ_stall_auto_release_time;

 wire[10:0]                    didt_SQ_didt_release_delay;
 wire[4:0]                     didt_SQ_didt_base_release_allowed;
 wire[4:0]                     didt_SQ_didt_incr_release_allowed;
 wire                         didt_DB_stall_ctrl_enable;
 wire[5:0]                    didt_DB_stall_delay;
 wire                         didt_DB_power_is_hi;
 wire[5:0]                    didt_DB_max_stalls_allowed;
 wire                         didt_DB_stall_auto_release_enable;
 wire [23:0]                  didt_DB_stall_auto_release_time;

 wire[10:0]                    didt_DB_didt_release_delay;
 wire[4:0]                     didt_DB_didt_base_release_allowed;
 wire[4:0]                     didt_DB_didt_incr_release_allowed;
 wire                         didt_TD_stall_ctrl_enable;
 wire[5:0]                    didt_TD_stall_delay;
 wire                         didt_TD_power_is_hi;
 wire[5:0]                    didt_TD_max_stalls_allowed;
 wire                         didt_TD_stall_auto_release_enable;
 wire [23:0]                  didt_TD_stall_auto_release_time;

 wire[10:0]                    didt_TD_didt_release_delay;
 wire[4:0]                     didt_TD_didt_base_release_allowed;
 wire[4:0]                     didt_TD_didt_incr_release_allowed;
 wire                         didt_TCP_stall_ctrl_enable;
 wire[5:0]                    didt_TCP_stall_delay;
 wire                         didt_TCP_power_is_hi;
 wire[5:0]                    didt_TCP_max_stalls_allowed;
 wire                         didt_TCP_stall_auto_release_enable;
 wire [23:0]                  didt_TCP_stall_auto_release_time;

 wire[10:0]                    didt_TCP_didt_release_delay;
 wire[4:0]                     didt_TCP_didt_base_release_allowed;
 wire[4:0]                     didt_TCP_didt_incr_release_allowed;

  wire reg_read_valid;
  wire [`TARG_GRBM_READ_DATA_RANGE]  reg_read_data;

assign reg_instance_sel = reg_send && ((reg_se_index == SE_STRAP_id) || (reg_instance_select && reg_op)) &&
       ( ({reg_addr, 2'b0} == `DIDT_IND_INDEX) || ({reg_addr, 2'b0} == `DIDT_IND_DATA) || ({reg_addr, 2'b0} == `DIDT_INDEX_AUTO_INCR_EN) );

always @(posedge reg_clk) begin
  if (~combined_resetb) begin
     reg_send_q   <= 1'b0;
     reg_addr_q   <= 16'h0;
     reg_wd_q     <= 32'h00000000;
     reg_op_q     <= 1'b0;
    end
  else begin
    reg_send_q   <=  reg_instance_sel;

     if (reg_instance_sel) begin
       reg_addr_q <= reg_addr;
       reg_wd_q   <= reg_wd;
       reg_op_q   <= reg_op;
     end
  end
end

// Combine read results from SH's.  Can only read from one at time.
assign reg_rd_en   = reg_read_valid;
assign reg_rd_data = reg_read_data;

//always @(posedge reg_clk) begin
//  if (~combined_resetb) begin
//   didt_read_valid <= 1'b0;
//   didt_read_data  <= `TARG_GRBM_READ_DATA_WIDTH'h0;
//  end
//  else begin
//   didt_read_valid <= reg_rd_en;
//   didt_read_data  <= reg_rd_data;
//  end
//end
assign didt_read_valid = reg_rd_en;
assign didt_read_data  = reg_rd_data;

//PCC logic
//FIXME anti-glitch here
wire[15:0] didt_SQ_max_power_pre;
assign didt_SQ_max_power_pre = SMU_DIDT_force_stall ? didt_SQ_ocp_max_power : didt_SQ_max_power;
wire[15:0] didt_DB_max_power_pre;
assign didt_DB_max_power_pre = SMU_DIDT_force_stall ? didt_DB_ocp_max_power : didt_DB_max_power;
wire[15:0] didt_TD_max_power_pre;
assign didt_TD_max_power_pre = SMU_DIDT_force_stall ? didt_TD_ocp_max_power : didt_TD_max_power;
wire[15:0] didt_TCP_max_power_pre;
assign didt_TCP_max_power_pre = SMU_DIDT_force_stall ? didt_TCP_ocp_max_power : didt_TCP_max_power;

gc_didt_regs didt_regs (
   .sclk				 	 (oCpl_GFXCLK),
   .resetb                   (hard_resetb),
   .reg_clk                  (reg_clk),
   .reg_send                 (reg_send_q),
   .reg_addr                 (reg_addr_q),
   .reg_op                   (reg_op_q),
   .reg_wd                   (reg_wd_q),

              // DIDT_SQ_CTRL1
   .didt_SQ_didt_ctrl_en             		(didt_SQ_didt_ctrl_en),
   .didt_SQ_phase_offset             		(didt_SQ_phase_offset),
   .didt_SQ_didt_ctrl_rst            		(didt_SQ_didt_ctrl_rst),
   .didt_SQ_didt_clk_en_override     		(didt_SQ_didt_clk_en_override),
   .didt_SQ_didt_max_stalls_allowed_hi     	(didt_SQ_didt_max_stalls_allowed_hi),
   .didt_SQ_didt_max_stalls_allowed_lo     	(didt_SQ_didt_max_stalls_allowed_lo),

   .didt_SQ_min_power                		(didt_SQ_min_power),
   .didt_SQ_max_power                		(didt_SQ_max_power),
			// DIDT_SQ_CTRL2
   .didt_SQ_max_power_delta          		(didt_SQ_max_power_delta),
   .didt_SQ_short_term_interval_size 		(didt_SQ_short_term_interval_size),
   .didt_SQ_long_term_interval_ratio 		(didt_SQ_long_term_interval_ratio),

			// DIDT_SQ_CTRL_OCP
   .didt_SQ_ocp_max_power	          		(didt_SQ_ocp_max_power),

			//DIDT_SQ_STALL_CTRL
   .didt_SQ_stall_ctrl_enable          		(didt_SQ_stall_ctrl_enable),
   .didt_SQ_stall_delay_hi          		(didt_SQ_stall_delay_hi),
   .didt_SQ_stall_delay_lo          		(didt_SQ_stall_delay_lo),
   .didt_SQ_hi_power_threshold          	(didt_SQ_hi_power_threshold),


   .didt_SQ_tuning_enable          			(didt_SQ_didt_tuning_enable),
   .didt_SQ_max_power_delta_hi          	(didt_SQ_max_power_delta_hi),
   .didt_SQ_max_power_delta_lo          	(didt_SQ_max_power_delta_lo),
   .didt_SQ_auto_mpd_enable          		(didt_SQ_didt_auto_mpd_enable),

   .didt_SQ_stall_auto_release_enable       (didt_SQ_stall_auto_release_enable),
   .didt_SQ_stall_auto_release_time         (didt_SQ_stall_auto_release_time),

   .didt_SQ_mpd_ratio_scale_level1   (didt_SQ_mpd_ratio_scale_level1),
   .didt_SQ_mpd_ratio_scale_level2   (didt_SQ_mpd_ratio_scale_level2),
   .didt_SQ_mpd_ratio_scale_level3   (didt_SQ_mpd_ratio_scale_level3),
   .didt_SQ_mpd_ratio_scale_level4   (didt_SQ_mpd_ratio_scale_level4),
   .didt_SQ_mpd_scale_level0         (didt_SQ_mpd_scale_level0),
   .didt_SQ_mpd_scale_level1         (didt_SQ_mpd_scale_level1),
   .didt_SQ_mpd_scale_level2         (didt_SQ_mpd_scale_level2),
   .didt_SQ_mpd_scale_level3         (didt_SQ_mpd_scale_level3),

   .didt_SQ_didt_stall_release_cntl_en    (didt_SQ_didt_stall_release_cntl_en),
   .didt_SQ_didt_stall_cntl_sel      (didt_SQ_didt_stall_cntl_sel),
   .didt_SQ_didt_release_delay_hi    (didt_SQ_didt_release_delay_hi),
   .didt_SQ_didt_release_delay_lo    (didt_SQ_didt_release_delay_lo),

   .didt_SQ_didt_base_release_allowed_hi  (didt_SQ_didt_base_release_allowed_hi),
   .didt_SQ_didt_incr_release_allowed_hi  (didt_SQ_didt_incr_release_allowed_hi),
   .didt_SQ_didt_base_release_allowed_lo  (didt_SQ_didt_base_release_allowed_lo),
   .didt_SQ_didt_incr_release_allowed_lo  (didt_SQ_didt_incr_release_allowed_lo),

   .didt_SQ_didt_stall_release_cntl_fsm_state  (didt_SQ_didt_stall_release_cntl_fsm_state),

   .didt_SQ_weight0                  		(didt_SQ_weight0),
   .didt_SQ_weight1                  		(didt_SQ_weight1),
   .didt_SQ_weight2                  		(didt_SQ_weight2),
   .didt_SQ_weight3                  		(didt_SQ_weight3),
   .didt_SQ_weight4                  		(didt_SQ_weight4),
   .didt_SQ_weight5                  		(didt_SQ_weight5),
   .didt_SQ_weight6                  		(didt_SQ_weight6),
   .didt_SQ_weight7                  		(didt_SQ_weight7),
   .didt_SQ_weight8                  		(didt_SQ_weight8),
   .didt_SQ_weight9                  		(didt_SQ_weight9),
   .didt_SQ_weight10                 		(didt_SQ_weight10),
   .didt_SQ_weight11                 		(didt_SQ_weight11),

   .didt_SQ_didt_trigger_throttle_lowbit	(didt_SQ_didt_trigger_throttle_lowbit),
   .didt_SQ_didt_power_level_lowbit			(didt_SQ_didt_power_level_lowbit),
   .didt_SQ_gc_didt_enable					(didt_SQ_gc_didt_enable),
   .didt_SQ_gc_didt_clk_en_override			(didt_SQ_gc_didt_clk_en_override),
   .didt_SQ_throttle_policy					(didt_SQ_throttle_policy),
   .didt_SQ_didt_stall_pattern_bit_nums		(didt_SQ_didt_stall_pattern_bit_nums),
   .didt_SQ_gc_didt_level_comb_en			(didt_SQ_gc_didt_level_comb_en),
   .didt_SQ_se_didt_level_comb_en			(didt_SQ_se_didt_level_comb_en),
   .didt_SQ_qualify_stall_en				(didt_SQ_qualify_stall_en),
   .didt_SQ_didt_stall_sel					(didt_SQ_didt_stall_sel),
   .didt_SQ_didt_force_stall				(didt_SQ_didt_force_stall),
   .didt_SQ_didt_stall_delay_en				(didt_SQ_didt_stall_delay_en),
   .didt_SQ_stall_pattern1					(didt_SQ_didt_stall_pattern1),
   .didt_SQ_stall_pattern2					(didt_SQ_didt_stall_pattern2),
   .didt_SQ_stall_pattern3					(didt_SQ_didt_stall_pattern3),
   .didt_SQ_stall_pattern4					(didt_SQ_didt_stall_pattern4),
   .didt_SQ_stall_pattern5					(didt_SQ_didt_stall_pattern5),
   .didt_SQ_stall_pattern6					(didt_SQ_didt_stall_pattern6),
   .didt_SQ_stall_pattern7					(didt_SQ_didt_stall_pattern7),

   .didt_SQ_stall_event_enable				(didt_SQ_didt_stall_event_enable),
   .didt_SQ_stall_event_counter				(didt_SQ_didt_stall_event_counter),
   .didt_SQ_stall_event_counter_clear		        (didt_SQ_didt_stall_event_counter_clear),
   .didt_SQ_didt_rlc_force_stall_en			        (didt_SQ_didt_rlc_force_stall_en),
   .didt_SQ_didt_rlc_stall_level_sel		        (didt_SQ_didt_rlc_stall_level_sel),
   .didt_SQ_didt_throttle_mode				(didt_SQ_didt_throttle_mode),

   .SQ_edc_en						(didt_SQ_edc_en),
   .SQ_edc_sw_rst						(didt_SQ_edc_sw_rst),
   .SQ_edc_clk_en_override					(didt_SQ_edc_clk_en_override),
   .SQ_edc_force_stall					(didt_SQ_edc_force_stall),
   .SQ_edc_threshold					(didt_SQ_edc_threshold),
   .SQ_edc_trigger_throttle_lowbit			(didt_SQ_edc_trigger_throttle_lowbit),
   .SQ_edc_stall_pattern_bit_nums			(didt_SQ_edc_stall_pattern_bit_nums),
   .SQ_edc_allow_write_pwrdelta				(didt_SQ_edc_allow_write_pwrdelta),
   .SQ_edc_grbm_wr_pwrdelta_en				(didt_SQ_edc_grbm_wr_pwrdelta_en),
   .SQ_edc_grbm_clear_overflow_counter		(didt_SQ_edc_grbm_clear_ov_counter),
   .SQ_edc_stall_delay_sig0	 			(didt_SQ_edc_stall_delay_sig0),
   .SQ_edc_stall_delay_sig1	 			(didt_SQ_edc_stall_delay_sig1),
   .SQ_edc_stall_delay_sig2	 			(didt_SQ_edc_stall_delay_sig2),
   .SQ_edc_stall_delay_sig3	 			(didt_SQ_edc_stall_delay_sig3),
   .SQ_edc_stall_delay_sig4	 			(didt_SQ_edc_stall_delay_sig4),
   .SQ_edc_stall_delay_sig5	 			(didt_SQ_edc_stall_delay_sig5),
   .SQ_edc_stall_delay_sig6	 			(didt_SQ_edc_stall_delay_sig6),
   .SQ_edc_stall_delay_sig7	 			(didt_SQ_edc_stall_delay_sig7),
   .SQ_edc_stall_delay_sig8	 			(didt_SQ_edc_stall_delay_sig8),
   .SQ_edc_stall_delay_sig9	 			(didt_SQ_edc_stall_delay_sig9),

   .SQ_edc_grbm_wr_pwrdelta_data				(didt_SQ_edc_grbm_wr_pwrdelta_data),
   .SQ_edc_stall_pattern1						(didt_SQ_edc_stall_pattern1),
   .SQ_edc_stall_pattern2						(didt_SQ_edc_stall_pattern2),
   .SQ_edc_stall_pattern3						(didt_SQ_edc_stall_pattern3),
   .SQ_edc_stall_pattern4						(didt_SQ_edc_stall_pattern4),
   .SQ_edc_stall_pattern5						(didt_SQ_edc_stall_pattern5),
   .SQ_edc_stall_pattern6						(didt_SQ_edc_stall_pattern6),
   .SQ_edc_stall_pattern7						(didt_SQ_edc_stall_pattern7),
   .SQ_edc_fsm_state							(didt_SQ_edc_fsm_state),
   .SQ_edc_throttle_level						(didt_SQ_edc_throttle_level),	
   .SQ_edc_rolling_power_delta_overflow			(didt_SQ_edc_rolling_power_delta_ov),	
   .SQ_edc_throttle_level_overflow_counter		(didt_SQ_edc_throttle_level_ov_counter),	
   .SQ_edc_rolling_power_delta					(didt_SQ_edc_rolling_power_delta),	
   .SQ_edc_grbm_clear_rolling_power_delta_ov	(didt_SQ_edc_grbm_clear_rolling_power_delta_ov),
   .SQ_gc_edc_en								(didt_SQ_gc_edc_en),
   .SQ_gc_edc_stall_policy						(didt_SQ_gc_edc_stall_policy),
   .SQ_gc_edc_level_comb_en						(didt_SQ_gc_edc_level_comb_en),
   .SQ_se_edc_level_comb_en						(didt_SQ_se_edc_level_comb_en),
   .SQ_edc_level_mode_sel			                        (didt_SQ_edc_level_mode_sel),
   .SQ_edc_level_comb_adapt_mode_en			                (didt_SQ_edc_level_comb_adapt_mode_en),
   .SQ_gc_edc_stall_en							(didt_SQ_gc_edc_stall_en),
   .SQ_pcc_stall_en								(didt_SQ_pcc_stall_en),
   .SQ_pwrbrk_stall_en							(didt_SQ_pwrbrk_stall_en),
   .SQ_edc_timer_period			                        (didt_SQ_edc_timer_period),

   .SQ_edc_pcc_perf_counter						(didt_SQ_edc_pcc_perf_counter),
   .rd_SQ_edc_pcc_perf_counter					(rd_didt_SQ_edc_pcc_perf_counter),
   .SQ_gc_edc_only_mode							(didt_SQ_gc_edc_only_mode),

              // DIDT_DB_CTRL1
   .didt_DB_didt_ctrl_en             		(didt_DB_didt_ctrl_en),
   .didt_DB_phase_offset             		(didt_DB_phase_offset),
   .didt_DB_didt_ctrl_rst            		(didt_DB_didt_ctrl_rst),
   .didt_DB_didt_clk_en_override     		(didt_DB_didt_clk_en_override),
   .didt_DB_didt_max_stalls_allowed_hi     	(didt_DB_didt_max_stalls_allowed_hi),
   .didt_DB_didt_max_stalls_allowed_lo     	(didt_DB_didt_max_stalls_allowed_lo),

   .didt_DB_min_power                		(didt_DB_min_power),
   .didt_DB_max_power                		(didt_DB_max_power),
			// DIDT_DB_CTRL2
   .didt_DB_max_power_delta          		(didt_DB_max_power_delta),
   .didt_DB_short_term_interval_size 		(didt_DB_short_term_interval_size),
   .didt_DB_long_term_interval_ratio 		(didt_DB_long_term_interval_ratio),

			// DIDT_DB_CTRL_OCP
   .didt_DB_ocp_max_power	          		(didt_DB_ocp_max_power),

			//DIDT_DB_STALL_CTRL
   .didt_DB_stall_ctrl_enable          		(didt_DB_stall_ctrl_enable),
   .didt_DB_stall_delay_hi          		(didt_DB_stall_delay_hi),
   .didt_DB_stall_delay_lo          		(didt_DB_stall_delay_lo),
   .didt_DB_hi_power_threshold          	(didt_DB_hi_power_threshold),


   .didt_DB_tuning_enable          			(didt_DB_didt_tuning_enable),
   .didt_DB_max_power_delta_hi          	(didt_DB_max_power_delta_hi),
   .didt_DB_max_power_delta_lo          	(didt_DB_max_power_delta_lo),
   .didt_DB_auto_mpd_enable          		(didt_DB_didt_auto_mpd_enable),

   .didt_DB_stall_auto_release_enable       (didt_DB_stall_auto_release_enable),
   .didt_DB_stall_auto_release_time         (didt_DB_stall_auto_release_time),

   .didt_DB_mpd_ratio_scale_level1   (didt_DB_mpd_ratio_scale_level1),
   .didt_DB_mpd_ratio_scale_level2   (didt_DB_mpd_ratio_scale_level2),
   .didt_DB_mpd_ratio_scale_level3   (didt_DB_mpd_ratio_scale_level3),
   .didt_DB_mpd_ratio_scale_level4   (didt_DB_mpd_ratio_scale_level4),
   .didt_DB_mpd_scale_level0         (didt_DB_mpd_scale_level0),
   .didt_DB_mpd_scale_level1         (didt_DB_mpd_scale_level1),
   .didt_DB_mpd_scale_level2         (didt_DB_mpd_scale_level2),
   .didt_DB_mpd_scale_level3         (didt_DB_mpd_scale_level3),

   .didt_DB_didt_stall_release_cntl_en    (didt_DB_didt_stall_release_cntl_en),
   .didt_DB_didt_stall_cntl_sel      (didt_DB_didt_stall_cntl_sel),
   .didt_DB_didt_release_delay_hi    (didt_DB_didt_release_delay_hi),
   .didt_DB_didt_release_delay_lo    (didt_DB_didt_release_delay_lo),

   .didt_DB_didt_base_release_allowed_hi  (didt_DB_didt_base_release_allowed_hi),
   .didt_DB_didt_incr_release_allowed_hi  (didt_DB_didt_incr_release_allowed_hi),
   .didt_DB_didt_base_release_allowed_lo  (didt_DB_didt_base_release_allowed_lo),
   .didt_DB_didt_incr_release_allowed_lo  (didt_DB_didt_incr_release_allowed_lo),

   .didt_DB_didt_stall_release_cntl_fsm_state  (didt_DB_didt_stall_release_cntl_fsm_state),

   .didt_DB_weight0                  		(didt_DB_weight0),
   .didt_DB_weight1                  		(didt_DB_weight1),
   .didt_DB_weight2                  		(didt_DB_weight2),
   .didt_DB_weight3                  		(didt_DB_weight3),
   .didt_DB_weight4                  		(didt_DB_weight4),
   .didt_DB_weight5                  		(didt_DB_weight5),
   .didt_DB_weight6                  		(didt_DB_weight6),
   .didt_DB_weight7                  		(didt_DB_weight7),
   .didt_DB_weight8                  		(didt_DB_weight8),
   .didt_DB_weight9                  		(didt_DB_weight9),
   .didt_DB_weight10                 		(didt_DB_weight10),
   .didt_DB_weight11                 		(didt_DB_weight11),

   .didt_DB_didt_trigger_throttle_lowbit	(didt_DB_didt_trigger_throttle_lowbit),
   .didt_DB_didt_power_level_lowbit			(didt_DB_didt_power_level_lowbit),
   .didt_DB_gc_didt_enable					(didt_DB_gc_didt_enable),
   .didt_DB_gc_didt_clk_en_override			(didt_DB_gc_didt_clk_en_override),
   .didt_DB_throttle_policy					(didt_DB_throttle_policy),
   .didt_DB_didt_stall_pattern_bit_nums		(didt_DB_didt_stall_pattern_bit_nums),
   .didt_DB_gc_didt_level_comb_en			(didt_DB_gc_didt_level_comb_en),
   .didt_DB_se_didt_level_comb_en			(didt_DB_se_didt_level_comb_en),
   .didt_DB_qualify_stall_en				(didt_DB_qualify_stall_en),
   .didt_DB_didt_stall_sel					(didt_DB_didt_stall_sel),
   .didt_DB_didt_force_stall				(didt_DB_didt_force_stall),
   .didt_DB_didt_stall_delay_en				(didt_DB_didt_stall_delay_en),
   .didt_DB_stall_pattern1					(didt_DB_didt_stall_pattern1),
   .didt_DB_stall_pattern2					(didt_DB_didt_stall_pattern2),
   .didt_DB_stall_pattern3					(didt_DB_didt_stall_pattern3),
   .didt_DB_stall_pattern4					(didt_DB_didt_stall_pattern4),
   .didt_DB_stall_pattern5					(didt_DB_didt_stall_pattern5),
   .didt_DB_stall_pattern6					(didt_DB_didt_stall_pattern6),
   .didt_DB_stall_pattern7					(didt_DB_didt_stall_pattern7),

   .didt_DB_stall_event_enable				(didt_DB_didt_stall_event_enable),
   .didt_DB_stall_event_counter				(didt_DB_didt_stall_event_counter),
   .didt_DB_stall_event_counter_clear		        (didt_DB_didt_stall_event_counter_clear),
   .didt_DB_didt_rlc_force_stall_en			        (didt_DB_didt_rlc_force_stall_en),
   .didt_DB_didt_rlc_stall_level_sel		        (didt_DB_didt_rlc_stall_level_sel),
   .didt_DB_didt_throttle_mode				(didt_DB_didt_throttle_mode),

   .DB_edc_en						(didt_DB_edc_en),
   .DB_edc_sw_rst						(didt_DB_edc_sw_rst),
   .DB_edc_clk_en_override					(didt_DB_edc_clk_en_override),
   .DB_edc_force_stall					(didt_DB_edc_force_stall),
   .DB_edc_threshold					(didt_DB_edc_threshold),
   .DB_edc_trigger_throttle_lowbit			(didt_DB_edc_trigger_throttle_lowbit),
   .DB_edc_stall_pattern_bit_nums			(didt_DB_edc_stall_pattern_bit_nums),
   .DB_edc_allow_write_pwrdelta				(didt_DB_edc_allow_write_pwrdelta),
   .DB_edc_grbm_wr_pwrdelta_en				(didt_DB_edc_grbm_wr_pwrdelta_en),
   .DB_edc_grbm_clear_overflow_counter		(didt_DB_edc_grbm_clear_ov_counter),
   .DB_edc_stall_delay_sig0	 			(didt_DB_edc_stall_delay_sig0),
   .DB_edc_stall_delay_sig1	 			(didt_DB_edc_stall_delay_sig1),
   .DB_edc_stall_delay_sig2	 			(didt_DB_edc_stall_delay_sig2),
   .DB_edc_stall_delay_sig3	 			(didt_DB_edc_stall_delay_sig3),

   .DB_edc_grbm_wr_pwrdelta_data				(didt_DB_edc_grbm_wr_pwrdelta_data),
   .DB_edc_stall_pattern1						(didt_DB_edc_stall_pattern1),
   .DB_edc_stall_pattern2						(didt_DB_edc_stall_pattern2),
   .DB_edc_stall_pattern3						(didt_DB_edc_stall_pattern3),
   .DB_edc_stall_pattern4						(didt_DB_edc_stall_pattern4),
   .DB_edc_stall_pattern5						(didt_DB_edc_stall_pattern5),
   .DB_edc_stall_pattern6						(didt_DB_edc_stall_pattern6),
   .DB_edc_stall_pattern7						(didt_DB_edc_stall_pattern7),
   .DB_edc_fsm_state							(didt_DB_edc_fsm_state),
   .DB_edc_throttle_level						(didt_DB_edc_throttle_level),	
   .DB_edc_rolling_power_delta_overflow			(didt_DB_edc_rolling_power_delta_ov),	
   .DB_edc_throttle_level_overflow_counter		(didt_DB_edc_throttle_level_ov_counter),	
   .DB_edc_rolling_power_delta					(didt_DB_edc_rolling_power_delta),	
   .DB_edc_grbm_clear_rolling_power_delta_ov	(didt_DB_edc_grbm_clear_rolling_power_delta_ov),
   .DB_gc_edc_en								(didt_DB_gc_edc_en),
   .DB_gc_edc_stall_policy						(didt_DB_gc_edc_stall_policy),
   .DB_gc_edc_level_comb_en						(didt_DB_gc_edc_level_comb_en),
   .DB_se_edc_level_comb_en						(didt_DB_se_edc_level_comb_en),
   .DB_edc_level_mode_sel			                        (didt_DB_edc_level_mode_sel),
   .DB_edc_level_comb_adapt_mode_en			                (didt_DB_edc_level_comb_adapt_mode_en),
   .DB_gc_edc_stall_en							(didt_DB_gc_edc_stall_en),
   .DB_pcc_stall_en								(didt_DB_pcc_stall_en),
   .DB_pwrbrk_stall_en							(didt_DB_pwrbrk_stall_en),
   .DB_edc_timer_period			                        (didt_DB_edc_timer_period),

   .DB_edc_pcc_perf_counter						(didt_DB_edc_pcc_perf_counter),
   .rd_DB_edc_pcc_perf_counter					(rd_didt_DB_edc_pcc_perf_counter),
   .DB_gc_edc_only_mode							(didt_DB_gc_edc_only_mode),

              // DIDT_TD_CTRL1
   .didt_TD_didt_ctrl_en             		(didt_TD_didt_ctrl_en),
   .didt_TD_phase_offset             		(didt_TD_phase_offset),
   .didt_TD_didt_ctrl_rst            		(didt_TD_didt_ctrl_rst),
   .didt_TD_didt_clk_en_override     		(didt_TD_didt_clk_en_override),
   .didt_TD_didt_max_stalls_allowed_hi     	(didt_TD_didt_max_stalls_allowed_hi),
   .didt_TD_didt_max_stalls_allowed_lo     	(didt_TD_didt_max_stalls_allowed_lo),

   .didt_TD_min_power                		(didt_TD_min_power),
   .didt_TD_max_power                		(didt_TD_max_power),
			// DIDT_TD_CTRL2
   .didt_TD_max_power_delta          		(didt_TD_max_power_delta),
   .didt_TD_short_term_interval_size 		(didt_TD_short_term_interval_size),
   .didt_TD_long_term_interval_ratio 		(didt_TD_long_term_interval_ratio),

			// DIDT_TD_CTRL_OCP
   .didt_TD_ocp_max_power	          		(didt_TD_ocp_max_power),

			//DIDT_TD_STALL_CTRL
   .didt_TD_stall_ctrl_enable          		(didt_TD_stall_ctrl_enable),
   .didt_TD_stall_delay_hi          		(didt_TD_stall_delay_hi),
   .didt_TD_stall_delay_lo          		(didt_TD_stall_delay_lo),
   .didt_TD_hi_power_threshold          	(didt_TD_hi_power_threshold),


   .didt_TD_tuning_enable          			(didt_TD_didt_tuning_enable),
   .didt_TD_max_power_delta_hi          	(didt_TD_max_power_delta_hi),
   .didt_TD_max_power_delta_lo          	(didt_TD_max_power_delta_lo),
   .didt_TD_auto_mpd_enable          		(didt_TD_didt_auto_mpd_enable),

   .didt_TD_stall_auto_release_enable       (didt_TD_stall_auto_release_enable),
   .didt_TD_stall_auto_release_time         (didt_TD_stall_auto_release_time),

   .didt_TD_mpd_ratio_scale_level1   (didt_TD_mpd_ratio_scale_level1),
   .didt_TD_mpd_ratio_scale_level2   (didt_TD_mpd_ratio_scale_level2),
   .didt_TD_mpd_ratio_scale_level3   (didt_TD_mpd_ratio_scale_level3),
   .didt_TD_mpd_ratio_scale_level4   (didt_TD_mpd_ratio_scale_level4),
   .didt_TD_mpd_scale_level0         (didt_TD_mpd_scale_level0),
   .didt_TD_mpd_scale_level1         (didt_TD_mpd_scale_level1),
   .didt_TD_mpd_scale_level2         (didt_TD_mpd_scale_level2),
   .didt_TD_mpd_scale_level3         (didt_TD_mpd_scale_level3),

   .didt_TD_didt_stall_release_cntl_en    (didt_TD_didt_stall_release_cntl_en),
   .didt_TD_didt_stall_cntl_sel      (didt_TD_didt_stall_cntl_sel),
   .didt_TD_didt_release_delay_hi    (didt_TD_didt_release_delay_hi),
   .didt_TD_didt_release_delay_lo    (didt_TD_didt_release_delay_lo),

   .didt_TD_didt_base_release_allowed_hi  (didt_TD_didt_base_release_allowed_hi),
   .didt_TD_didt_incr_release_allowed_hi  (didt_TD_didt_incr_release_allowed_hi),
   .didt_TD_didt_base_release_allowed_lo  (didt_TD_didt_base_release_allowed_lo),
   .didt_TD_didt_incr_release_allowed_lo  (didt_TD_didt_incr_release_allowed_lo),

   .didt_TD_didt_stall_release_cntl_fsm_state  (didt_TD_didt_stall_release_cntl_fsm_state),

   .didt_TD_weight0                  		(didt_TD_weight0),
   .didt_TD_weight1                  		(didt_TD_weight1),
   .didt_TD_weight2                  		(didt_TD_weight2),
   .didt_TD_weight3                  		(didt_TD_weight3),
   .didt_TD_weight4                  		(didt_TD_weight4),
   .didt_TD_weight5                  		(didt_TD_weight5),
   .didt_TD_weight6                  		(didt_TD_weight6),
   .didt_TD_weight7                  		(didt_TD_weight7),
   .didt_TD_weight8                  		(didt_TD_weight8),
   .didt_TD_weight9                  		(didt_TD_weight9),
   .didt_TD_weight10                 		(didt_TD_weight10),
   .didt_TD_weight11                 		(didt_TD_weight11),

   .didt_TD_didt_trigger_throttle_lowbit	(didt_TD_didt_trigger_throttle_lowbit),
   .didt_TD_didt_power_level_lowbit			(didt_TD_didt_power_level_lowbit),
   .didt_TD_gc_didt_enable					(didt_TD_gc_didt_enable),
   .didt_TD_gc_didt_clk_en_override			(didt_TD_gc_didt_clk_en_override),
   .didt_TD_throttle_policy					(didt_TD_throttle_policy),
   .didt_TD_didt_stall_pattern_bit_nums		(didt_TD_didt_stall_pattern_bit_nums),
   .didt_TD_gc_didt_level_comb_en			(didt_TD_gc_didt_level_comb_en),
   .didt_TD_se_didt_level_comb_en			(didt_TD_se_didt_level_comb_en),
   .didt_TD_qualify_stall_en				(didt_TD_qualify_stall_en),
   .didt_TD_didt_stall_sel					(didt_TD_didt_stall_sel),
   .didt_TD_didt_force_stall				(didt_TD_didt_force_stall),
   .didt_TD_didt_stall_delay_en				(didt_TD_didt_stall_delay_en),
   .didt_TD_stall_pattern1					(didt_TD_didt_stall_pattern1),
   .didt_TD_stall_pattern2					(didt_TD_didt_stall_pattern2),
   .didt_TD_stall_pattern3					(didt_TD_didt_stall_pattern3),
   .didt_TD_stall_pattern4					(didt_TD_didt_stall_pattern4),
   .didt_TD_stall_pattern5					(didt_TD_didt_stall_pattern5),
   .didt_TD_stall_pattern6					(didt_TD_didt_stall_pattern6),
   .didt_TD_stall_pattern7					(didt_TD_didt_stall_pattern7),

   .didt_TD_stall_event_enable				(didt_TD_didt_stall_event_enable),
   .didt_TD_stall_event_counter				(didt_TD_didt_stall_event_counter),
   .didt_TD_stall_event_counter_clear		        (didt_TD_didt_stall_event_counter_clear),
   .didt_TD_didt_rlc_force_stall_en			        (didt_TD_didt_rlc_force_stall_en),
   .didt_TD_didt_rlc_stall_level_sel		        (didt_TD_didt_rlc_stall_level_sel),
   .didt_TD_didt_throttle_mode				(didt_TD_didt_throttle_mode),

   .TD_edc_en						(didt_TD_edc_en),
   .TD_edc_sw_rst						(didt_TD_edc_sw_rst),
   .TD_edc_clk_en_override					(didt_TD_edc_clk_en_override),
   .TD_edc_force_stall					(didt_TD_edc_force_stall),
   .TD_edc_threshold					(didt_TD_edc_threshold),
   .TD_edc_trigger_throttle_lowbit			(didt_TD_edc_trigger_throttle_lowbit),
   .TD_edc_stall_pattern_bit_nums			(didt_TD_edc_stall_pattern_bit_nums),
   .TD_edc_allow_write_pwrdelta				(didt_TD_edc_allow_write_pwrdelta),
   .TD_edc_grbm_wr_pwrdelta_en				(didt_TD_edc_grbm_wr_pwrdelta_en),
   .TD_edc_grbm_clear_overflow_counter		(didt_TD_edc_grbm_clear_ov_counter),
   .TD_edc_stall_delay_sig0	 			(didt_TD_edc_stall_delay_sig0),
   .TD_edc_stall_delay_sig1	 			(didt_TD_edc_stall_delay_sig1),
   .TD_edc_stall_delay_sig2	 			(didt_TD_edc_stall_delay_sig2),
   .TD_edc_stall_delay_sig3	 			(didt_TD_edc_stall_delay_sig3),
   .TD_edc_stall_delay_sig4	 			(didt_TD_edc_stall_delay_sig4),
   .TD_edc_stall_delay_sig5	 			(didt_TD_edc_stall_delay_sig5),
   .TD_edc_stall_delay_sig6	 			(didt_TD_edc_stall_delay_sig6),
   .TD_edc_stall_delay_sig7	 			(didt_TD_edc_stall_delay_sig7),
   .TD_edc_stall_delay_sig8	 			(didt_TD_edc_stall_delay_sig8),
   .TD_edc_stall_delay_sig9	 			(didt_TD_edc_stall_delay_sig9),

   .TD_edc_grbm_wr_pwrdelta_data				(didt_TD_edc_grbm_wr_pwrdelta_data),
   .TD_edc_stall_pattern1						(didt_TD_edc_stall_pattern1),
   .TD_edc_stall_pattern2						(didt_TD_edc_stall_pattern2),
   .TD_edc_stall_pattern3						(didt_TD_edc_stall_pattern3),
   .TD_edc_stall_pattern4						(didt_TD_edc_stall_pattern4),
   .TD_edc_stall_pattern5						(didt_TD_edc_stall_pattern5),
   .TD_edc_stall_pattern6						(didt_TD_edc_stall_pattern6),
   .TD_edc_stall_pattern7						(didt_TD_edc_stall_pattern7),
   .TD_edc_fsm_state							(didt_TD_edc_fsm_state),
   .TD_edc_throttle_level						(didt_TD_edc_throttle_level),	
   .TD_edc_rolling_power_delta_overflow			(didt_TD_edc_rolling_power_delta_ov),	
   .TD_edc_throttle_level_overflow_counter		(didt_TD_edc_throttle_level_ov_counter),	
   .TD_edc_rolling_power_delta					(didt_TD_edc_rolling_power_delta),	
   .TD_edc_grbm_clear_rolling_power_delta_ov	(didt_TD_edc_grbm_clear_rolling_power_delta_ov),
   .TD_gc_edc_en								(didt_TD_gc_edc_en),
   .TD_gc_edc_stall_policy						(didt_TD_gc_edc_stall_policy),
   .TD_gc_edc_level_comb_en						(didt_TD_gc_edc_level_comb_en),
   .TD_se_edc_level_comb_en						(didt_TD_se_edc_level_comb_en),
   .TD_edc_level_mode_sel			                        (didt_TD_edc_level_mode_sel),
   .TD_edc_level_comb_adapt_mode_en			                (didt_TD_edc_level_comb_adapt_mode_en),
   .TD_gc_edc_stall_en							(didt_TD_gc_edc_stall_en),
   .TD_pcc_stall_en								(didt_TD_pcc_stall_en),
   .TD_pwrbrk_stall_en							(didt_TD_pwrbrk_stall_en),
   .TD_edc_timer_period			                        (didt_TD_edc_timer_period),

   .TD_edc_pcc_perf_counter						(didt_TD_edc_pcc_perf_counter),
   .rd_TD_edc_pcc_perf_counter					(rd_didt_TD_edc_pcc_perf_counter),
   .TD_gc_edc_only_mode							(didt_TD_gc_edc_only_mode),

              // DIDT_TCP_CTRL1
   .didt_TCP_didt_ctrl_en             		(didt_TCP_didt_ctrl_en),
   .didt_TCP_phase_offset             		(didt_TCP_phase_offset),
   .didt_TCP_didt_ctrl_rst            		(didt_TCP_didt_ctrl_rst),
   .didt_TCP_didt_clk_en_override     		(didt_TCP_didt_clk_en_override),
   .didt_TCP_didt_max_stalls_allowed_hi     	(didt_TCP_didt_max_stalls_allowed_hi),
   .didt_TCP_didt_max_stalls_allowed_lo     	(didt_TCP_didt_max_stalls_allowed_lo),

   .didt_TCP_min_power                		(didt_TCP_min_power),
   .didt_TCP_max_power                		(didt_TCP_max_power),
			// DIDT_TCP_CTRL2
   .didt_TCP_max_power_delta          		(didt_TCP_max_power_delta),
   .didt_TCP_short_term_interval_size 		(didt_TCP_short_term_interval_size),
   .didt_TCP_long_term_interval_ratio 		(didt_TCP_long_term_interval_ratio),

			// DIDT_TCP_CTRL_OCP
   .didt_TCP_ocp_max_power	          		(didt_TCP_ocp_max_power),

			//DIDT_TCP_STALL_CTRL
   .didt_TCP_stall_ctrl_enable          		(didt_TCP_stall_ctrl_enable),
   .didt_TCP_stall_delay_hi          		(didt_TCP_stall_delay_hi),
   .didt_TCP_stall_delay_lo          		(didt_TCP_stall_delay_lo),
   .didt_TCP_hi_power_threshold          	(didt_TCP_hi_power_threshold),


   .didt_TCP_tuning_enable          			(didt_TCP_didt_tuning_enable),
   .didt_TCP_max_power_delta_hi          	(didt_TCP_max_power_delta_hi),
   .didt_TCP_max_power_delta_lo          	(didt_TCP_max_power_delta_lo),
   .didt_TCP_auto_mpd_enable          		(didt_TCP_didt_auto_mpd_enable),

   .didt_TCP_stall_auto_release_enable       (didt_TCP_stall_auto_release_enable),
   .didt_TCP_stall_auto_release_time         (didt_TCP_stall_auto_release_time),

   .didt_TCP_mpd_ratio_scale_level1   (didt_TCP_mpd_ratio_scale_level1),
   .didt_TCP_mpd_ratio_scale_level2   (didt_TCP_mpd_ratio_scale_level2),
   .didt_TCP_mpd_ratio_scale_level3   (didt_TCP_mpd_ratio_scale_level3),
   .didt_TCP_mpd_ratio_scale_level4   (didt_TCP_mpd_ratio_scale_level4),
   .didt_TCP_mpd_scale_level0         (didt_TCP_mpd_scale_level0),
   .didt_TCP_mpd_scale_level1         (didt_TCP_mpd_scale_level1),
   .didt_TCP_mpd_scale_level2         (didt_TCP_mpd_scale_level2),
   .didt_TCP_mpd_scale_level3         (didt_TCP_mpd_scale_level3),

   .didt_TCP_didt_stall_release_cntl_en    (didt_TCP_didt_stall_release_cntl_en),
   .didt_TCP_didt_stall_cntl_sel      (didt_TCP_didt_stall_cntl_sel),
   .didt_TCP_didt_release_delay_hi    (didt_TCP_didt_release_delay_hi),
   .didt_TCP_didt_release_delay_lo    (didt_TCP_didt_release_delay_lo),

   .didt_TCP_didt_base_release_allowed_hi  (didt_TCP_didt_base_release_allowed_hi),
   .didt_TCP_didt_incr_release_allowed_hi  (didt_TCP_didt_incr_release_allowed_hi),
   .didt_TCP_didt_base_release_allowed_lo  (didt_TCP_didt_base_release_allowed_lo),
   .didt_TCP_didt_incr_release_allowed_lo  (didt_TCP_didt_incr_release_allowed_lo),

   .didt_TCP_didt_stall_release_cntl_fsm_state  (didt_TCP_didt_stall_release_cntl_fsm_state),

   .didt_TCP_weight0                  		(didt_TCP_weight0),
   .didt_TCP_weight1                  		(didt_TCP_weight1),
   .didt_TCP_weight2                  		(didt_TCP_weight2),
   .didt_TCP_weight3                  		(didt_TCP_weight3),
   .didt_TCP_weight4                  		(didt_TCP_weight4),
   .didt_TCP_weight5                  		(didt_TCP_weight5),
   .didt_TCP_weight6                  		(didt_TCP_weight6),
   .didt_TCP_weight7                  		(didt_TCP_weight7),
   .didt_TCP_weight8                  		(didt_TCP_weight8),
   .didt_TCP_weight9                  		(didt_TCP_weight9),
   .didt_TCP_weight10                 		(didt_TCP_weight10),
   .didt_TCP_weight11                 		(didt_TCP_weight11),

   .didt_TCP_didt_trigger_throttle_lowbit	(didt_TCP_didt_trigger_throttle_lowbit),
   .didt_TCP_didt_power_level_lowbit			(didt_TCP_didt_power_level_lowbit),
   .didt_TCP_gc_didt_enable					(didt_TCP_gc_didt_enable),
   .didt_TCP_gc_didt_clk_en_override			(didt_TCP_gc_didt_clk_en_override),
   .didt_TCP_throttle_policy					(didt_TCP_throttle_policy),
   .didt_TCP_didt_stall_pattern_bit_nums		(didt_TCP_didt_stall_pattern_bit_nums),
   .didt_TCP_gc_didt_level_comb_en			(didt_TCP_gc_didt_level_comb_en),
   .didt_TCP_se_didt_level_comb_en			(didt_TCP_se_didt_level_comb_en),
   .didt_TCP_qualify_stall_en				(didt_TCP_qualify_stall_en),
   .didt_TCP_didt_stall_sel					(didt_TCP_didt_stall_sel),
   .didt_TCP_didt_force_stall				(didt_TCP_didt_force_stall),
   .didt_TCP_didt_stall_delay_en				(didt_TCP_didt_stall_delay_en),
   .didt_TCP_stall_pattern1					(didt_TCP_didt_stall_pattern1),
   .didt_TCP_stall_pattern2					(didt_TCP_didt_stall_pattern2),
   .didt_TCP_stall_pattern3					(didt_TCP_didt_stall_pattern3),
   .didt_TCP_stall_pattern4					(didt_TCP_didt_stall_pattern4),
   .didt_TCP_stall_pattern5					(didt_TCP_didt_stall_pattern5),
   .didt_TCP_stall_pattern6					(didt_TCP_didt_stall_pattern6),
   .didt_TCP_stall_pattern7					(didt_TCP_didt_stall_pattern7),

   .didt_TCP_stall_event_enable				(didt_TCP_didt_stall_event_enable),
   .didt_TCP_stall_event_counter				(didt_TCP_didt_stall_event_counter),
   .didt_TCP_stall_event_counter_clear		        (didt_TCP_didt_stall_event_counter_clear),
   .didt_TCP_didt_rlc_force_stall_en			        (didt_TCP_didt_rlc_force_stall_en),
   .didt_TCP_didt_rlc_stall_level_sel		        (didt_TCP_didt_rlc_stall_level_sel),
   .didt_TCP_didt_throttle_mode				(didt_TCP_didt_throttle_mode),

   .TCP_edc_en						(didt_TCP_edc_en),
   .TCP_edc_sw_rst						(didt_TCP_edc_sw_rst),
   .TCP_edc_clk_en_override					(didt_TCP_edc_clk_en_override),
   .TCP_edc_force_stall					(didt_TCP_edc_force_stall),
   .TCP_edc_threshold					(didt_TCP_edc_threshold),
   .TCP_edc_trigger_throttle_lowbit			(didt_TCP_edc_trigger_throttle_lowbit),
   .TCP_edc_stall_pattern_bit_nums			(didt_TCP_edc_stall_pattern_bit_nums),
   .TCP_edc_allow_write_pwrdelta				(didt_TCP_edc_allow_write_pwrdelta),
   .TCP_edc_grbm_wr_pwrdelta_en				(didt_TCP_edc_grbm_wr_pwrdelta_en),
   .TCP_edc_grbm_clear_overflow_counter		(didt_TCP_edc_grbm_clear_ov_counter),
   .TCP_edc_stall_delay_sig0	 			(didt_TCP_edc_stall_delay_sig0),
   .TCP_edc_stall_delay_sig1	 			(didt_TCP_edc_stall_delay_sig1),
   .TCP_edc_stall_delay_sig2	 			(didt_TCP_edc_stall_delay_sig2),
   .TCP_edc_stall_delay_sig3	 			(didt_TCP_edc_stall_delay_sig3),
   .TCP_edc_stall_delay_sig4	 			(didt_TCP_edc_stall_delay_sig4),
   .TCP_edc_stall_delay_sig5	 			(didt_TCP_edc_stall_delay_sig5),
   .TCP_edc_stall_delay_sig6	 			(didt_TCP_edc_stall_delay_sig6),
   .TCP_edc_stall_delay_sig7	 			(didt_TCP_edc_stall_delay_sig7),
   .TCP_edc_stall_delay_sig8	 			(didt_TCP_edc_stall_delay_sig8),
   .TCP_edc_stall_delay_sig9	 			(didt_TCP_edc_stall_delay_sig9),

   .TCP_edc_grbm_wr_pwrdelta_data				(didt_TCP_edc_grbm_wr_pwrdelta_data),
   .TCP_edc_stall_pattern1						(didt_TCP_edc_stall_pattern1),
   .TCP_edc_stall_pattern2						(didt_TCP_edc_stall_pattern2),
   .TCP_edc_stall_pattern3						(didt_TCP_edc_stall_pattern3),
   .TCP_edc_stall_pattern4						(didt_TCP_edc_stall_pattern4),
   .TCP_edc_stall_pattern5						(didt_TCP_edc_stall_pattern5),
   .TCP_edc_stall_pattern6						(didt_TCP_edc_stall_pattern6),
   .TCP_edc_stall_pattern7						(didt_TCP_edc_stall_pattern7),
   .TCP_edc_fsm_state							(didt_TCP_edc_fsm_state),
   .TCP_edc_throttle_level						(didt_TCP_edc_throttle_level),	
   .TCP_edc_rolling_power_delta_overflow			(didt_TCP_edc_rolling_power_delta_ov),	
   .TCP_edc_throttle_level_overflow_counter		(didt_TCP_edc_throttle_level_ov_counter),	
   .TCP_edc_rolling_power_delta					(didt_TCP_edc_rolling_power_delta),	
   .TCP_edc_grbm_clear_rolling_power_delta_ov	(didt_TCP_edc_grbm_clear_rolling_power_delta_ov),
   .TCP_gc_edc_en								(didt_TCP_gc_edc_en),
   .TCP_gc_edc_stall_policy						(didt_TCP_gc_edc_stall_policy),
   .TCP_gc_edc_level_comb_en						(didt_TCP_gc_edc_level_comb_en),
   .TCP_se_edc_level_comb_en						(didt_TCP_se_edc_level_comb_en),
   .TCP_edc_level_mode_sel			                        (didt_TCP_edc_level_mode_sel),
   .TCP_edc_level_comb_adapt_mode_en			                (didt_TCP_edc_level_comb_adapt_mode_en),
   .TCP_gc_edc_stall_en							(didt_TCP_gc_edc_stall_en),
   .TCP_pcc_stall_en								(didt_TCP_pcc_stall_en),
   .TCP_pwrbrk_stall_en							(didt_TCP_pwrbrk_stall_en),
   .TCP_edc_timer_period			                        (didt_TCP_edc_timer_period),

   .TCP_edc_pcc_perf_counter						(didt_TCP_edc_pcc_perf_counter),
   .rd_TCP_edc_pcc_perf_counter					(rd_didt_TCP_edc_pcc_perf_counter),
   .TCP_gc_edc_only_mode							(didt_TCP_gc_edc_only_mode),

   .reg_read_valid                               (reg_read_valid),
   .reg_read_data                                (reg_read_data)
   );

reg[2:0] PSM_didt_throttle_level_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb)
		PSM_didt_throttle_level_q <= 'd0;
	else
		PSM_didt_throttle_level_q <= PSM_didt_throttle_level;
end


 wire [10-1:0] sa0_didt_SQ_stall;

 wire [10-1:0] sa0_didt_SQ_stall_release_cntl_stall_out; 
 assign sa0_didt_SQ_stall_out =  (didt_SQ_didt_stall_cntl_sel ? sa0_didt_SQ_stall_release_cntl_stall_out : sa0_didt_SQ_stall) | didt_SQ_edc_stall;  // this is the final stall output

 wire [15:0] sa0_didt_SQ_stall_out_clamped;
 wire [8:0]  sa0_didt_SQ_credit_consumed_clamped; 

   assign sa0_didt_SQ_stall_out_clamped = {{(16-10){1'b0}}, sa0_didt_SQ_stall_out};

   assign sa0_didt_SQ_credit_consumed_clamped = {{(9-6){1'b0}},sa0_didt_SQ_credit_consumed};

 wire [4-1:0] sa0_didt_DB_stall;

 wire [4-1:0] sa0_didt_DB_stall_release_cntl_stall_out; 
 assign sa0_didt_DB_stall_out =  (didt_DB_didt_stall_cntl_sel ? sa0_didt_DB_stall_release_cntl_stall_out : sa0_didt_DB_stall) | didt_DB_edc_stall;  // this is the final stall output

 wire [15:0] sa0_didt_DB_stall_out_clamped;
 wire [8:0]  sa0_didt_DB_credit_consumed_clamped; 

   assign sa0_didt_DB_stall_out_clamped = {{(16-4){1'b0}}, sa0_didt_DB_stall_out};

   assign sa0_didt_DB_credit_consumed_clamped = {{(9-4){1'b0}},sa0_didt_DB_credit_consumed};

 wire [10-1:0] sa0_didt_TD_stall;

 wire [10-1:0] sa0_didt_TD_stall_release_cntl_stall_out; 
 assign sa0_didt_TD_stall_out =  (didt_TD_didt_stall_cntl_sel ? sa0_didt_TD_stall_release_cntl_stall_out : sa0_didt_TD_stall) | didt_TD_edc_stall;  // this is the final stall output

 wire [15:0] sa0_didt_TD_stall_out_clamped;
 wire [8:0]  sa0_didt_TD_credit_consumed_clamped; 

   assign sa0_didt_TD_stall_out_clamped = {{(16-10){1'b0}}, sa0_didt_TD_stall_out};

   assign sa0_didt_TD_credit_consumed_clamped = sa0_didt_TD_credit_consumed[8:0];

 wire [10-1:0] sa0_didt_TCP_stall;

 wire [10-1:0] sa0_didt_TCP_stall_release_cntl_stall_out; 
 assign sa0_didt_TCP_stall_out =  (didt_TCP_didt_stall_cntl_sel ? sa0_didt_TCP_stall_release_cntl_stall_out : sa0_didt_TCP_stall) | didt_TCP_edc_stall;  // this is the final stall output

 wire [15:0] sa0_didt_TCP_stall_out_clamped;
 wire [8:0]  sa0_didt_TCP_credit_consumed_clamped; 

   assign sa0_didt_TCP_stall_out_clamped = {{(16-10){1'b0}}, sa0_didt_TCP_stall_out};

   assign sa0_didt_TCP_credit_consumed_clamped = {{(9-5){1'b0}},sa0_didt_TCP_credit_consumed};

 wire [10-1:0] sa1_didt_SQ_stall;

 wire [10-1:0] sa1_didt_SQ_stall_release_cntl_stall_out; 
 assign sa1_didt_SQ_stall_out =  (didt_SQ_didt_stall_cntl_sel ? sa1_didt_SQ_stall_release_cntl_stall_out : sa1_didt_SQ_stall) | didt_SQ_edc_stall;  // this is the final stall output

 wire [15:0] sa1_didt_SQ_stall_out_clamped;
 wire [8:0]  sa1_didt_SQ_credit_consumed_clamped; 

   assign sa1_didt_SQ_stall_out_clamped = {{(16-10){1'b0}}, sa1_didt_SQ_stall_out};

   assign sa1_didt_SQ_credit_consumed_clamped = {{(9-6){1'b0}},sa1_didt_SQ_credit_consumed};

 wire [4-1:0] sa1_didt_DB_stall;

 wire [4-1:0] sa1_didt_DB_stall_release_cntl_stall_out; 
 assign sa1_didt_DB_stall_out =  (didt_DB_didt_stall_cntl_sel ? sa1_didt_DB_stall_release_cntl_stall_out : sa1_didt_DB_stall) | didt_DB_edc_stall;  // this is the final stall output

 wire [15:0] sa1_didt_DB_stall_out_clamped;
 wire [8:0]  sa1_didt_DB_credit_consumed_clamped; 

   assign sa1_didt_DB_stall_out_clamped = {{(16-4){1'b0}}, sa1_didt_DB_stall_out};

   assign sa1_didt_DB_credit_consumed_clamped = {{(9-4){1'b0}},sa1_didt_DB_credit_consumed};

 wire [10-1:0] sa1_didt_TD_stall;

 wire [10-1:0] sa1_didt_TD_stall_release_cntl_stall_out; 
 assign sa1_didt_TD_stall_out =  (didt_TD_didt_stall_cntl_sel ? sa1_didt_TD_stall_release_cntl_stall_out : sa1_didt_TD_stall) | didt_TD_edc_stall;  // this is the final stall output

 wire [15:0] sa1_didt_TD_stall_out_clamped;
 wire [8:0]  sa1_didt_TD_credit_consumed_clamped; 

   assign sa1_didt_TD_stall_out_clamped = {{(16-10){1'b0}}, sa1_didt_TD_stall_out};

   assign sa1_didt_TD_credit_consumed_clamped = sa1_didt_TD_credit_consumed[8:0];

 wire [10-1:0] sa1_didt_TCP_stall;

 wire [10-1:0] sa1_didt_TCP_stall_release_cntl_stall_out; 
 assign sa1_didt_TCP_stall_out =  (didt_TCP_didt_stall_cntl_sel ? sa1_didt_TCP_stall_release_cntl_stall_out : sa1_didt_TCP_stall) | didt_TCP_edc_stall;  // this is the final stall output

 wire [15:0] sa1_didt_TCP_stall_out_clamped;
 wire [8:0]  sa1_didt_TCP_credit_consumed_clamped; 

   assign sa1_didt_TCP_stall_out_clamped = {{(16-10){1'b0}}, sa1_didt_TCP_stall_out};

   assign sa1_didt_TCP_credit_consumed_clamped = {{(9-5){1'b0}},sa1_didt_TCP_credit_consumed};


//output to debug bus
        assign sa0_didt_SQ_dbg_out_0 = {sa0_didt_SQ_stall_out_clamped, 1'b0, sa0_didt_SQ_credit_consumed_clamped, didt_SQ_gc_edc_stall_level, didt_SQ_stall_level};
 	assign sa0_didt_SQ_dbg_out_1 = {didt_SQ_edc_throttle_level_ov_counter[0], didt_SQ_edc_rolling_power_delta_ov, didt_SQ_edc_fsm_state, sa0_didt_SQ_stall_out_clamped[12:0], didt_SQ_edc_dbg_stall_out, sa0_didt_SQ_credit_consumed_clamped, didt_SQ_gc_edc_stall_level, didt_SQ_edc_throttle_level}; 
 	assign sa0_didt_SQ_dbg_out_2 = {didt_SQ_didt_fsm_state, sa0_didt_SQ_stall_out_clamped[14:0], didt_SQ_didt_dbg_stall_out, sa0_didt_SQ_credit_consumed_clamped, didt_SQ_stall_level, didt_SQ_didt_throttle_level};
        assign sa0_didt_SQ_dbg_out_3 = didt_SQ_edc_rolling_power_delta;
        assign sa0_didt_DB_dbg_out_0 = {sa0_didt_DB_stall_out_clamped, 1'b0, sa0_didt_DB_credit_consumed_clamped, didt_DB_gc_edc_stall_level, didt_DB_stall_level};
 	assign sa0_didt_DB_dbg_out_1 = {didt_DB_edc_throttle_level_ov_counter[0], didt_DB_edc_rolling_power_delta_ov, didt_DB_edc_fsm_state, sa0_didt_DB_stall_out_clamped[12:0], didt_DB_edc_dbg_stall_out, sa0_didt_DB_credit_consumed_clamped, didt_DB_gc_edc_stall_level, didt_DB_edc_throttle_level}; 
 	assign sa0_didt_DB_dbg_out_2 = {didt_DB_didt_fsm_state, sa0_didt_DB_stall_out_clamped[14:0], didt_DB_didt_dbg_stall_out, sa0_didt_DB_credit_consumed_clamped, didt_DB_stall_level, didt_DB_didt_throttle_level};
        assign sa0_didt_DB_dbg_out_3 = didt_DB_edc_rolling_power_delta;
        assign sa0_didt_TD_dbg_out_0 = {sa0_didt_TD_stall_out_clamped, 1'b0, sa0_didt_TD_credit_consumed_clamped, didt_TD_gc_edc_stall_level, didt_TD_stall_level};
 	assign sa0_didt_TD_dbg_out_1 = {didt_TD_edc_throttle_level_ov_counter[0], didt_TD_edc_rolling_power_delta_ov, didt_TD_edc_fsm_state, sa0_didt_TD_stall_out_clamped[12:0], didt_TD_edc_dbg_stall_out, sa0_didt_TD_credit_consumed_clamped, didt_TD_gc_edc_stall_level, didt_TD_edc_throttle_level}; 
 	assign sa0_didt_TD_dbg_out_2 = {didt_TD_didt_fsm_state, sa0_didt_TD_stall_out_clamped[14:0], didt_TD_didt_dbg_stall_out, sa0_didt_TD_credit_consumed_clamped, didt_TD_stall_level, didt_TD_didt_throttle_level};
        assign sa0_didt_TD_dbg_out_3 = didt_TD_edc_rolling_power_delta;
        assign sa0_didt_TCP_dbg_out_0 = {sa0_didt_TCP_stall_out_clamped, 1'b0, sa0_didt_TCP_credit_consumed_clamped, didt_TCP_gc_edc_stall_level, didt_TCP_stall_level};
 	assign sa0_didt_TCP_dbg_out_1 = {didt_TCP_edc_throttle_level_ov_counter[0], didt_TCP_edc_rolling_power_delta_ov, didt_TCP_edc_fsm_state, sa0_didt_TCP_stall_out_clamped[12:0], didt_TCP_edc_dbg_stall_out, sa0_didt_TCP_credit_consumed_clamped, didt_TCP_gc_edc_stall_level, didt_TCP_edc_throttle_level}; 
 	assign sa0_didt_TCP_dbg_out_2 = {didt_TCP_didt_fsm_state, sa0_didt_TCP_stall_out_clamped[14:0], didt_TCP_didt_dbg_stall_out, sa0_didt_TCP_credit_consumed_clamped, didt_TCP_stall_level, didt_TCP_didt_throttle_level};
        assign sa0_didt_TCP_dbg_out_3 = didt_TCP_edc_rolling_power_delta;


	assign sa0_misc_dbg_out_0 = {8'b0, didt_DB_edc_rolling_power_delta_ov, didt_DB_edc_throttle_level_ov_counter[0], didt_DB_edc_throttle_level, didt_DB_edc_fsm_state, didt_TD_edc_rolling_power_delta_ov, didt_TD_edc_throttle_level_ov_counter[0], didt_TD_edc_throttle_level, didt_TD_edc_fsm_state, didt_TCP_edc_rolling_power_delta_ov, didt_TCP_edc_throttle_level_ov_counter[0], didt_TCP_edc_throttle_level, didt_TCP_edc_fsm_state, didt_SQ_edc_rolling_power_delta_ov, didt_SQ_edc_throttle_level_ov_counter[0], didt_SQ_edc_throttle_level, didt_SQ_edc_fsm_state};
	assign sa0_misc_dbg_out_1 = {10'b0, didt_DB_didt_throttle_level, didt_DB_didt_fsm_state, 2'b0, didt_TD_didt_throttle_level, didt_TD_didt_fsm_state, 2'b0, didt_TCP_didt_throttle_level, didt_TCP_didt_fsm_state, 2'b0, didt_SQ_didt_throttle_level, didt_SQ_didt_fsm_state};        
	assign sa0_misc_dbg_out_2 = {24'b0, didt_DB_edc_dbg_stall_out, didt_DB_didt_dbg_stall_out, didt_TD_edc_dbg_stall_out, didt_TD_didt_dbg_stall_out, didt_TCP_edc_dbg_stall_out, didt_TCP_didt_dbg_stall_out, didt_SQ_edc_dbg_stall_out, didt_SQ_didt_dbg_stall_out};   
        assign sa1_didt_SQ_dbg_out_0 = {sa1_didt_SQ_stall_out_clamped, 1'b0, sa1_didt_SQ_credit_consumed_clamped, didt_SQ_gc_edc_stall_level, didt_SQ_stall_level};
 	assign sa1_didt_SQ_dbg_out_1 = {didt_SQ_edc_throttle_level_ov_counter[0], didt_SQ_edc_rolling_power_delta_ov, didt_SQ_edc_fsm_state, sa1_didt_SQ_stall_out_clamped[12:0], didt_SQ_edc_dbg_stall_out, sa1_didt_SQ_credit_consumed_clamped, didt_SQ_gc_edc_stall_level, didt_SQ_edc_throttle_level}; 
 	assign sa1_didt_SQ_dbg_out_2 = {didt_SQ_didt_fsm_state, sa1_didt_SQ_stall_out_clamped[14:0], didt_SQ_didt_dbg_stall_out, sa1_didt_SQ_credit_consumed_clamped, didt_SQ_stall_level, didt_SQ_didt_throttle_level};
        assign sa1_didt_SQ_dbg_out_3 = didt_SQ_edc_rolling_power_delta;
        assign sa1_didt_DB_dbg_out_0 = {sa1_didt_DB_stall_out_clamped, 1'b0, sa1_didt_DB_credit_consumed_clamped, didt_DB_gc_edc_stall_level, didt_DB_stall_level};
 	assign sa1_didt_DB_dbg_out_1 = {didt_DB_edc_throttle_level_ov_counter[0], didt_DB_edc_rolling_power_delta_ov, didt_DB_edc_fsm_state, sa1_didt_DB_stall_out_clamped[12:0], didt_DB_edc_dbg_stall_out, sa1_didt_DB_credit_consumed_clamped, didt_DB_gc_edc_stall_level, didt_DB_edc_throttle_level}; 
 	assign sa1_didt_DB_dbg_out_2 = {didt_DB_didt_fsm_state, sa1_didt_DB_stall_out_clamped[14:0], didt_DB_didt_dbg_stall_out, sa1_didt_DB_credit_consumed_clamped, didt_DB_stall_level, didt_DB_didt_throttle_level};
        assign sa1_didt_DB_dbg_out_3 = didt_DB_edc_rolling_power_delta;
        assign sa1_didt_TD_dbg_out_0 = {sa1_didt_TD_stall_out_clamped, 1'b0, sa1_didt_TD_credit_consumed_clamped, didt_TD_gc_edc_stall_level, didt_TD_stall_level};
 	assign sa1_didt_TD_dbg_out_1 = {didt_TD_edc_throttle_level_ov_counter[0], didt_TD_edc_rolling_power_delta_ov, didt_TD_edc_fsm_state, sa1_didt_TD_stall_out_clamped[12:0], didt_TD_edc_dbg_stall_out, sa1_didt_TD_credit_consumed_clamped, didt_TD_gc_edc_stall_level, didt_TD_edc_throttle_level}; 
 	assign sa1_didt_TD_dbg_out_2 = {didt_TD_didt_fsm_state, sa1_didt_TD_stall_out_clamped[14:0], didt_TD_didt_dbg_stall_out, sa1_didt_TD_credit_consumed_clamped, didt_TD_stall_level, didt_TD_didt_throttle_level};
        assign sa1_didt_TD_dbg_out_3 = didt_TD_edc_rolling_power_delta;
        assign sa1_didt_TCP_dbg_out_0 = {sa1_didt_TCP_stall_out_clamped, 1'b0, sa1_didt_TCP_credit_consumed_clamped, didt_TCP_gc_edc_stall_level, didt_TCP_stall_level};
 	assign sa1_didt_TCP_dbg_out_1 = {didt_TCP_edc_throttle_level_ov_counter[0], didt_TCP_edc_rolling_power_delta_ov, didt_TCP_edc_fsm_state, sa1_didt_TCP_stall_out_clamped[12:0], didt_TCP_edc_dbg_stall_out, sa1_didt_TCP_credit_consumed_clamped, didt_TCP_gc_edc_stall_level, didt_TCP_edc_throttle_level}; 
 	assign sa1_didt_TCP_dbg_out_2 = {didt_TCP_didt_fsm_state, sa1_didt_TCP_stall_out_clamped[14:0], didt_TCP_didt_dbg_stall_out, sa1_didt_TCP_credit_consumed_clamped, didt_TCP_stall_level, didt_TCP_didt_throttle_level};
        assign sa1_didt_TCP_dbg_out_3 = didt_TCP_edc_rolling_power_delta;


	assign sa1_misc_dbg_out_0 = {8'b0, didt_DB_edc_rolling_power_delta_ov, didt_DB_edc_throttle_level_ov_counter[0], didt_DB_edc_throttle_level, didt_DB_edc_fsm_state, didt_TD_edc_rolling_power_delta_ov, didt_TD_edc_throttle_level_ov_counter[0], didt_TD_edc_throttle_level, didt_TD_edc_fsm_state, didt_TCP_edc_rolling_power_delta_ov, didt_TCP_edc_throttle_level_ov_counter[0], didt_TCP_edc_throttle_level, didt_TCP_edc_fsm_state, didt_SQ_edc_rolling_power_delta_ov, didt_SQ_edc_throttle_level_ov_counter[0], didt_SQ_edc_throttle_level, didt_SQ_edc_fsm_state};
	assign sa1_misc_dbg_out_1 = {10'b0, didt_DB_didt_throttle_level, didt_DB_didt_fsm_state, 2'b0, didt_TD_didt_throttle_level, didt_TD_didt_fsm_state, 2'b0, didt_TCP_didt_throttle_level, didt_TCP_didt_fsm_state, 2'b0, didt_SQ_didt_throttle_level, didt_SQ_didt_fsm_state};        
	assign sa1_misc_dbg_out_2 = {24'b0, didt_DB_edc_dbg_stall_out, didt_DB_didt_dbg_stall_out, didt_TD_edc_dbg_stall_out, didt_TD_didt_dbg_stall_out, didt_TCP_edc_dbg_stall_out, didt_TCP_didt_dbg_stall_out, didt_SQ_edc_dbg_stall_out, didt_SQ_didt_dbg_stall_out};   



assign didt_SQ_stall_delay = ((didt_SQ_stall_ctrl_enable == 0) && (didt_SQ_didt_stall_release_cntl_en == 0)) ? 6'h0: didt_SQ_power_is_hi ? didt_SQ_stall_delay_hi : didt_SQ_stall_delay_lo;

//assign didt_SQ_max_stalls_allowed = ~didt_SQ_didt_tuning_enable ? didt_SQ_didt_max_stalls_allowed_hi : didt_SQ_power_is_hi ? didt_SQ_didt_max_stalls_allowed_hi : didt_SQ_didt_max_stalls_allowed_lo;
assign didt_SQ_max_stalls_allowed = (didt_SQ_didt_throttle_mode == 0)? (PSM_didt_throttle_level_q[1] ? didt_SQ_didt_max_stalls_allowed_hi : didt_SQ_didt_max_stalls_allowed_lo) : (~didt_SQ_didt_tuning_enable ? didt_SQ_didt_max_stalls_allowed_hi : didt_SQ_power_is_hi ? didt_SQ_didt_max_stalls_allowed_hi : didt_SQ_didt_max_stalls_allowed_lo);

wire [13:0] didt_SQ_max_power_delta_selected;
assign didt_SQ_max_power_delta_selected = ~didt_SQ_didt_tuning_enable ? didt_SQ_max_power_delta : didt_SQ_power_is_hi ? didt_SQ_max_power_delta_hi : didt_SQ_max_power_delta_lo;

wire [3:0]	didt_SQ_power_level_pre;
assign didt_SQ_power_level = didt_SQ_power_level_pre & {4{didt_SQ_gc_didt_enable}} & {4{didt_SQ_didt_ctrl_en}};

assign didt_SQ_didt_release_delay = ~didt_SQ_didt_stall_release_cntl_en ? 11'h0: didt_SQ_power_is_hi ? didt_SQ_didt_release_delay_hi : didt_SQ_didt_release_delay_lo;
assign didt_SQ_didt_base_release_allowed = ~didt_SQ_didt_stall_release_cntl_en ? 5'h0: didt_SQ_power_is_hi ? didt_SQ_didt_base_release_allowed_hi : didt_SQ_didt_base_release_allowed_lo;
assign didt_SQ_didt_incr_release_allowed = ~didt_SQ_didt_stall_release_cntl_en ? 5'h0: didt_SQ_power_is_hi ? didt_SQ_didt_incr_release_allowed_hi : didt_SQ_didt_incr_release_allowed_lo;

wire [6*2-1:0] didt_SQ_credit_consumed;
assign didt_SQ_credit_consumed = {
                                          sa1_didt_SQ_credit_consumed,
                                          sa0_didt_SQ_credit_consumed};
     gc_didt_edc_cntl_core #(
                .UNITS            (6),
                .NUM_SA           (2),
		.EDC_STALL_INST_NUMS	(2*5),
		.MAX_DELAY_NUMS			(40),
		.EDC_STALL_DELAY_SIZE	(6)
     ) SQ_didt_edc_cntl_core (
        .Cpl_GFXCLK						(Cpl_GFXCLK),
        .oCpl_GFXCLK						(oCpl_GFXCLK),
        .rst						(~combined_resetb),
   		.dft_shift_clk				(dft_shift_clk),
   		.Dft_Clk_Gater_En			(Dft_Clk_Gater_En),
   		.Dft_Clk_Gater_Aon			(Dft_Clk_Gater_Aon),			
        .credit_consumed          (didt_SQ_credit_consumed),
        .stall                    (didt_SQ_stall_pre),
		.power_is_hi			  (didt_SQ_power_is_hi),
		.hi_power_threshold		  (didt_SQ_hi_power_threshold),
		.auto_mpd_enable		  (didt_SQ_didt_auto_mpd_enable),
        .RLC_DIDT_force_stall     (RLC_DIDT_force_stall),
        .rlc_force_stall_en       (didt_SQ_didt_rlc_force_stall_en),
        .rlc_stall_level_sel      (didt_SQ_didt_rlc_stall_level_sel),
		.didt_throttle_mode	  		(didt_SQ_didt_throttle_mode),
		.PSM_didt_throttle_level	(PSM_didt_throttle_level_q),

        .didt_en                  (didt_SQ_didt_ctrl_en),
        .phase_offset             (didt_SQ_phase_offset),
        .didt_soft_rst            (didt_SQ_didt_ctrl_rst),
        .didt_clk_en_override     (didt_SQ_didt_clk_en_override),
        .min_power                (didt_SQ_min_power),
		.max_power                (didt_SQ_max_power_pre),
        .max_power_delta          (didt_SQ_max_power_delta_selected),
        .short_term_interval_size (didt_SQ_short_term_interval_size),
        .long_term_interval_ratio (didt_SQ_long_term_interval_ratio),

        .mpd_ratio_scale_level1   (didt_SQ_mpd_ratio_scale_level1),
        .mpd_ratio_scale_level2   (didt_SQ_mpd_ratio_scale_level2),
        .mpd_ratio_scale_level3   (didt_SQ_mpd_ratio_scale_level3),
        .mpd_ratio_scale_level4   (didt_SQ_mpd_ratio_scale_level4),
        .mpd_scale_level0         (didt_SQ_mpd_scale_level0),
        .mpd_scale_level1         (didt_SQ_mpd_scale_level1),
        .mpd_scale_level2         (didt_SQ_mpd_scale_level2),
        .mpd_scale_level3         (didt_SQ_mpd_scale_level3),

        .weight_0                 (didt_SQ_weight0),
        .weight_1                 (didt_SQ_weight1),
        .weight_2                 (didt_SQ_weight2),
        .weight_3                 (didt_SQ_weight3),
        .weight_4                 (didt_SQ_weight4),
        .weight_5                 (didt_SQ_weight5),
        .weight_6                 (didt_SQ_weight6),
        .weight_7                 (didt_SQ_weight7),
        .weight_8                 (didt_SQ_weight8),
        .weight_9                 (didt_SQ_weight9),
        .weight_10                (didt_SQ_weight10),
        .weight_11                (didt_SQ_weight11),

		//New DIDT
		.power_level			  (didt_SQ_power_level_pre),
		.stall_level			  (didt_SQ_stall_level),
		.didt_trigger_throttle_lowbit		(didt_SQ_didt_trigger_throttle_lowbit),
		.didt_power_level_lowbit			(didt_SQ_didt_power_level_lowbit),
		.throttle_policy					(didt_SQ_throttle_policy),
		.gc_didt_enable						(didt_SQ_gc_didt_enable),
		.gc_didt_clk_en_override			(didt_SQ_gc_didt_clk_en_override),
		.didt_stall_pattern_bit_nums		(didt_SQ_didt_stall_pattern_bit_nums),
		.gc_didt_level_comb_en				(didt_SQ_gc_didt_level_comb_en),
		.se_didt_level_comb_en				(didt_SQ_se_didt_level_comb_en),
		.didt_qualify_stall_en				(didt_SQ_qualify_stall_en),
		.didt_stall_sel						(didt_SQ_didt_stall_sel),
		.didt_force_stall					(didt_SQ_didt_force_stall),
		.didt_stall_delay_en				(didt_SQ_didt_stall_delay_en),
		.didt_stall_pattern1				(didt_SQ_didt_stall_pattern1),
		.didt_stall_pattern2				(didt_SQ_didt_stall_pattern2),
		.didt_stall_pattern3				(didt_SQ_didt_stall_pattern3),
		.didt_stall_pattern4				(didt_SQ_didt_stall_pattern4),
		.didt_stall_pattern5				(didt_SQ_didt_stall_pattern5),
		.didt_stall_pattern6				(didt_SQ_didt_stall_pattern6),
		.didt_stall_pattern7				(didt_SQ_didt_stall_pattern7),
		.didt_fsm_state					(didt_SQ_didt_fsm_state),
		.didt_throttle_level				(didt_SQ_didt_throttle_level),
		.didt_dbg_stall_out				(didt_SQ_didt_dbg_stall_out),

		.edc_en						(didt_SQ_edc_en),
		.edc_sw_rst					(didt_SQ_edc_sw_rst),
		.edc_clk_en_override				(didt_SQ_edc_clk_en_override),
		.edc_force_stall				(didt_SQ_edc_force_stall),
		.edc_threshold					(didt_SQ_edc_threshold),
		.edc_trigger_throttle_lowbit		        (didt_SQ_edc_trigger_throttle_lowbit),
		.edc_stall_pattern_bit_nums			(didt_SQ_edc_stall_pattern_bit_nums),
		.edc_allow_write_pwrdelta			(didt_SQ_edc_allow_write_pwrdelta),
		.edc_grbm_wr_pwrdelta_en			(didt_SQ_edc_grbm_wr_pwrdelta_en),
		.edc_grbm_clear_ov_counter			(didt_SQ_edc_grbm_clear_ov_counter),
		.edc_grbm_clear_rolling_power_delta_ov	        (didt_SQ_edc_grbm_clear_rolling_power_delta_ov),

		.gc_se_stall				(gc_se_stall),
		.gc_edc_en					(didt_SQ_gc_edc_en),
		.gc_edc_stall_policy				(didt_SQ_gc_edc_stall_policy),
		.gc_edc_level_comb_en				(didt_SQ_gc_edc_level_comb_en),
		.se_edc_level_comb_en				(didt_SQ_se_edc_level_comb_en),
		.edc_level_mode_sel  				(didt_SQ_edc_level_mode_sel),
		.edc_level_comb_adapt_mode_en    		(didt_SQ_edc_level_comb_adapt_mode_en),
		.gc_edc_stall_en					(didt_SQ_gc_edc_stall_en),
		.pcc_stall_en						(didt_SQ_pcc_stall_en),
		.pwrbrk_stall_en					(didt_SQ_pwrbrk_stall_en),
		.edc_timer_period           		        (didt_SQ_edc_timer_period),
		.gc_edc_stall_level				(didt_SQ_gc_edc_stall_level),

		.edc_pcc_perf_counter				(didt_SQ_edc_pcc_perf_counter),
		.rd_edc_pcc_perf_counter			(rd_didt_SQ_edc_pcc_perf_counter),
		.gc_edc_only_mode					(didt_SQ_gc_edc_only_mode),
		
		.stall_event_enable				(didt_SQ_didt_stall_event_enable),
		.stall_event_counter			(didt_SQ_didt_stall_event_counter),
		.stall_event_counter_clear		(didt_SQ_didt_stall_event_counter_clear),

		.edc_stall_delay 		({didt_SQ_edc_stall_delay_sig9,didt_SQ_edc_stall_delay_sig8,didt_SQ_edc_stall_delay_sig7,didt_SQ_edc_stall_delay_sig6,didt_SQ_edc_stall_delay_sig5,didt_SQ_edc_stall_delay_sig4,didt_SQ_edc_stall_delay_sig3,didt_SQ_edc_stall_delay_sig2,didt_SQ_edc_stall_delay_sig1,didt_SQ_edc_stall_delay_sig0}),


		.edc_grbm_wr_pwrdelta_data			(didt_SQ_edc_grbm_wr_pwrdelta_data),
		.edc_stall_pattern1					(didt_SQ_edc_stall_pattern1),
		.edc_stall_pattern2					(didt_SQ_edc_stall_pattern2),
		.edc_stall_pattern3					(didt_SQ_edc_stall_pattern3),
		.edc_stall_pattern4					(didt_SQ_edc_stall_pattern4),
		.edc_stall_pattern5					(didt_SQ_edc_stall_pattern5),
		.edc_stall_pattern6					(didt_SQ_edc_stall_pattern6),
		.edc_stall_pattern7					(didt_SQ_edc_stall_pattern7),
		.edc_fsm_state						(didt_SQ_edc_fsm_state),
		.edc_throttle_level					(didt_SQ_edc_throttle_level),
		.edc_stall							(didt_SQ_edc_stall),
		.edc_rolling_power_delta_ov			(didt_SQ_edc_rolling_power_delta_ov),
		.edc_throttle_level_ov_counter		(didt_SQ_edc_throttle_level_ov_counter),
		.edc_rolling_power_delta			(didt_SQ_edc_rolling_power_delta),
		.edc_dbg_stall_out					(didt_SQ_edc_dbg_stall_out),

        .TEST_CLK_EN(TEST_CLK_EN)
   );

assign didt_DB_stall_delay = ((didt_DB_stall_ctrl_enable == 0) && (didt_DB_didt_stall_release_cntl_en == 0)) ? 6'h0: didt_DB_power_is_hi ? didt_DB_stall_delay_hi : didt_DB_stall_delay_lo;

//assign didt_DB_max_stalls_allowed = ~didt_DB_didt_tuning_enable ? didt_DB_didt_max_stalls_allowed_hi : didt_DB_power_is_hi ? didt_DB_didt_max_stalls_allowed_hi : didt_DB_didt_max_stalls_allowed_lo;
assign didt_DB_max_stalls_allowed = (didt_DB_didt_throttle_mode == 0)? (PSM_didt_throttle_level_q[1] ? didt_SQ_didt_max_stalls_allowed_hi : didt_SQ_didt_max_stalls_allowed_lo) : (~didt_DB_didt_tuning_enable ? didt_DB_didt_max_stalls_allowed_hi : didt_DB_power_is_hi ? didt_DB_didt_max_stalls_allowed_hi : didt_DB_didt_max_stalls_allowed_lo);

wire [13:0] didt_DB_max_power_delta_selected;
assign didt_DB_max_power_delta_selected = ~didt_DB_didt_tuning_enable ? didt_DB_max_power_delta : didt_DB_power_is_hi ? didt_DB_max_power_delta_hi : didt_DB_max_power_delta_lo;

wire [3:0]	didt_DB_power_level_pre;
assign didt_DB_power_level = didt_DB_power_level_pre & {4{didt_DB_gc_didt_enable}} & {4{didt_DB_didt_ctrl_en}};

assign didt_DB_didt_release_delay = ~didt_DB_didt_stall_release_cntl_en ? 11'h0: didt_DB_power_is_hi ? didt_DB_didt_release_delay_hi : didt_DB_didt_release_delay_lo;
assign didt_DB_didt_base_release_allowed = ~didt_DB_didt_stall_release_cntl_en ? 5'h0: didt_DB_power_is_hi ? didt_DB_didt_base_release_allowed_hi : didt_DB_didt_base_release_allowed_lo;
assign didt_DB_didt_incr_release_allowed = ~didt_DB_didt_stall_release_cntl_en ? 5'h0: didt_DB_power_is_hi ? didt_DB_didt_incr_release_allowed_hi : didt_DB_didt_incr_release_allowed_lo;

wire [4*2-1:0] didt_DB_credit_consumed;
assign didt_DB_credit_consumed = {
                                          sa1_didt_DB_credit_consumed,
                                          sa0_didt_DB_credit_consumed};
     gc_didt_edc_cntl_core #(
                .UNITS            (4),
                .NUM_SA           (2),
		.EDC_STALL_INST_NUMS	(4),
		.MAX_DELAY_NUMS			(32),
		.EDC_STALL_DELAY_SIZE	(5)
     ) DB_didt_edc_cntl_core (
        .Cpl_GFXCLK						(Cpl_GFXCLK),
        .oCpl_GFXCLK						(oCpl_GFXCLK),
        .rst						(~combined_resetb),
   		.dft_shift_clk				(dft_shift_clk),
   		.Dft_Clk_Gater_En			(Dft_Clk_Gater_En),
   		.Dft_Clk_Gater_Aon			(Dft_Clk_Gater_Aon),			
        .credit_consumed          (didt_DB_credit_consumed),
        .stall                    (didt_DB_stall_pre),
		.power_is_hi			  (didt_DB_power_is_hi),
		.hi_power_threshold		  (didt_DB_hi_power_threshold),
		.auto_mpd_enable		  (didt_DB_didt_auto_mpd_enable),
        .RLC_DIDT_force_stall     (RLC_DIDT_force_stall),
        .rlc_force_stall_en       (didt_DB_didt_rlc_force_stall_en),
        .rlc_stall_level_sel      (didt_DB_didt_rlc_stall_level_sel),
		.didt_throttle_mode	  		(didt_DB_didt_throttle_mode),
		.PSM_didt_throttle_level	(PSM_didt_throttle_level_q),

        .didt_en                  (didt_DB_didt_ctrl_en),
        .phase_offset             (didt_DB_phase_offset),
        .didt_soft_rst            (didt_DB_didt_ctrl_rst),
        .didt_clk_en_override     (didt_DB_didt_clk_en_override),
        .min_power                (didt_DB_min_power),
		.max_power                (didt_DB_max_power_pre),
        .max_power_delta          (didt_DB_max_power_delta_selected),
        .short_term_interval_size (didt_DB_short_term_interval_size),
        .long_term_interval_ratio (didt_DB_long_term_interval_ratio),

        .mpd_ratio_scale_level1   (didt_DB_mpd_ratio_scale_level1),
        .mpd_ratio_scale_level2   (didt_DB_mpd_ratio_scale_level2),
        .mpd_ratio_scale_level3   (didt_DB_mpd_ratio_scale_level3),
        .mpd_ratio_scale_level4   (didt_DB_mpd_ratio_scale_level4),
        .mpd_scale_level0         (didt_DB_mpd_scale_level0),
        .mpd_scale_level1         (didt_DB_mpd_scale_level1),
        .mpd_scale_level2         (didt_DB_mpd_scale_level2),
        .mpd_scale_level3         (didt_DB_mpd_scale_level3),

        .weight_0                 (didt_DB_weight0),
        .weight_1                 (didt_DB_weight1),
        .weight_2                 (didt_DB_weight2),
        .weight_3                 (didt_DB_weight3),
        .weight_4                 (didt_DB_weight4),
        .weight_5                 (didt_DB_weight5),
        .weight_6                 (didt_DB_weight6),
        .weight_7                 (didt_DB_weight7),
        .weight_8                 (didt_DB_weight8),
        .weight_9                 (didt_DB_weight9),
        .weight_10                (didt_DB_weight10),
        .weight_11                (didt_DB_weight11),

		//New DIDT
		.power_level			  (didt_DB_power_level_pre),
		.stall_level			  (didt_DB_stall_level),
		.didt_trigger_throttle_lowbit		(didt_DB_didt_trigger_throttle_lowbit),
		.didt_power_level_lowbit			(didt_DB_didt_power_level_lowbit),
		.throttle_policy					(didt_DB_throttle_policy),
		.gc_didt_enable						(didt_DB_gc_didt_enable),
		.gc_didt_clk_en_override			(didt_DB_gc_didt_clk_en_override),
		.didt_stall_pattern_bit_nums		(didt_DB_didt_stall_pattern_bit_nums),
		.gc_didt_level_comb_en				(didt_DB_gc_didt_level_comb_en),
		.se_didt_level_comb_en				(didt_DB_se_didt_level_comb_en),
		.didt_qualify_stall_en				(didt_DB_qualify_stall_en),
		.didt_stall_sel						(didt_DB_didt_stall_sel),
		.didt_force_stall					(didt_DB_didt_force_stall),
		.didt_stall_delay_en				(didt_DB_didt_stall_delay_en),
		.didt_stall_pattern1				(didt_DB_didt_stall_pattern1),
		.didt_stall_pattern2				(didt_DB_didt_stall_pattern2),
		.didt_stall_pattern3				(didt_DB_didt_stall_pattern3),
		.didt_stall_pattern4				(didt_DB_didt_stall_pattern4),
		.didt_stall_pattern5				(didt_DB_didt_stall_pattern5),
		.didt_stall_pattern6				(didt_DB_didt_stall_pattern6),
		.didt_stall_pattern7				(didt_DB_didt_stall_pattern7),
		.didt_fsm_state					(didt_DB_didt_fsm_state),
		.didt_throttle_level				(didt_DB_didt_throttle_level),
		.didt_dbg_stall_out				(didt_DB_didt_dbg_stall_out),

		.edc_en						(didt_DB_edc_en),
		.edc_sw_rst					(didt_DB_edc_sw_rst),
		.edc_clk_en_override				(didt_DB_edc_clk_en_override),
		.edc_force_stall				(didt_DB_edc_force_stall),
		.edc_threshold					(didt_DB_edc_threshold),
		.edc_trigger_throttle_lowbit		        (didt_DB_edc_trigger_throttle_lowbit),
		.edc_stall_pattern_bit_nums			(didt_DB_edc_stall_pattern_bit_nums),
		.edc_allow_write_pwrdelta			(didt_DB_edc_allow_write_pwrdelta),
		.edc_grbm_wr_pwrdelta_en			(didt_DB_edc_grbm_wr_pwrdelta_en),
		.edc_grbm_clear_ov_counter			(didt_DB_edc_grbm_clear_ov_counter),
		.edc_grbm_clear_rolling_power_delta_ov	        (didt_DB_edc_grbm_clear_rolling_power_delta_ov),

		.gc_se_stall				(gc_se_stall),
		.gc_edc_en					(didt_DB_gc_edc_en),
		.gc_edc_stall_policy				(didt_DB_gc_edc_stall_policy),
		.gc_edc_level_comb_en				(didt_DB_gc_edc_level_comb_en),
		.se_edc_level_comb_en				(didt_DB_se_edc_level_comb_en),
		.edc_level_mode_sel  				(didt_DB_edc_level_mode_sel),
		.edc_level_comb_adapt_mode_en    		(didt_DB_edc_level_comb_adapt_mode_en),
		.gc_edc_stall_en					(didt_DB_gc_edc_stall_en),
		.pcc_stall_en						(didt_DB_pcc_stall_en),
		.pwrbrk_stall_en					(didt_DB_pwrbrk_stall_en),
		.edc_timer_period           		        (didt_DB_edc_timer_period),
		.gc_edc_stall_level				(didt_DB_gc_edc_stall_level),

		.edc_pcc_perf_counter				(didt_DB_edc_pcc_perf_counter),
		.rd_edc_pcc_perf_counter			(rd_didt_DB_edc_pcc_perf_counter),
		.gc_edc_only_mode					(didt_DB_gc_edc_only_mode),
		
		.stall_event_enable				(didt_DB_didt_stall_event_enable),
		.stall_event_counter			(didt_DB_didt_stall_event_counter),
		.stall_event_counter_clear		(didt_DB_didt_stall_event_counter_clear),

		.edc_stall_delay 		({didt_DB_edc_stall_delay_sig3,didt_DB_edc_stall_delay_sig2,didt_DB_edc_stall_delay_sig1,didt_DB_edc_stall_delay_sig0}),


		.edc_grbm_wr_pwrdelta_data			(didt_DB_edc_grbm_wr_pwrdelta_data),
		.edc_stall_pattern1					(didt_DB_edc_stall_pattern1),
		.edc_stall_pattern2					(didt_DB_edc_stall_pattern2),
		.edc_stall_pattern3					(didt_DB_edc_stall_pattern3),
		.edc_stall_pattern4					(didt_DB_edc_stall_pattern4),
		.edc_stall_pattern5					(didt_DB_edc_stall_pattern5),
		.edc_stall_pattern6					(didt_DB_edc_stall_pattern6),
		.edc_stall_pattern7					(didt_DB_edc_stall_pattern7),
		.edc_fsm_state						(didt_DB_edc_fsm_state),
		.edc_throttle_level					(didt_DB_edc_throttle_level),
		.edc_stall							(didt_DB_edc_stall),
		.edc_rolling_power_delta_ov			(didt_DB_edc_rolling_power_delta_ov),
		.edc_throttle_level_ov_counter		(didt_DB_edc_throttle_level_ov_counter),
		.edc_rolling_power_delta			(didt_DB_edc_rolling_power_delta),
		.edc_dbg_stall_out					(didt_DB_edc_dbg_stall_out),

        .TEST_CLK_EN(TEST_CLK_EN)
   );

assign didt_TD_stall_delay = ((didt_TD_stall_ctrl_enable == 0) && (didt_TD_didt_stall_release_cntl_en == 0)) ? 6'h0: didt_TD_power_is_hi ? didt_TD_stall_delay_hi : didt_TD_stall_delay_lo;

//assign didt_TD_max_stalls_allowed = ~didt_TD_didt_tuning_enable ? didt_TD_didt_max_stalls_allowed_hi : didt_TD_power_is_hi ? didt_TD_didt_max_stalls_allowed_hi : didt_TD_didt_max_stalls_allowed_lo;
assign didt_TD_max_stalls_allowed = (didt_TD_didt_throttle_mode == 0)? (PSM_didt_throttle_level_q[1] ? didt_SQ_didt_max_stalls_allowed_hi : didt_SQ_didt_max_stalls_allowed_lo) : (~didt_TD_didt_tuning_enable ? didt_TD_didt_max_stalls_allowed_hi : didt_TD_power_is_hi ? didt_TD_didt_max_stalls_allowed_hi : didt_TD_didt_max_stalls_allowed_lo);

wire [13:0] didt_TD_max_power_delta_selected;
assign didt_TD_max_power_delta_selected = ~didt_TD_didt_tuning_enable ? didt_TD_max_power_delta : didt_TD_power_is_hi ? didt_TD_max_power_delta_hi : didt_TD_max_power_delta_lo;

wire [3:0]	didt_TD_power_level_pre;
assign didt_TD_power_level = didt_TD_power_level_pre & {4{didt_TD_gc_didt_enable}} & {4{didt_TD_didt_ctrl_en}};

assign didt_TD_didt_release_delay = ~didt_TD_didt_stall_release_cntl_en ? 11'h0: didt_TD_power_is_hi ? didt_TD_didt_release_delay_hi : didt_TD_didt_release_delay_lo;
assign didt_TD_didt_base_release_allowed = ~didt_TD_didt_stall_release_cntl_en ? 5'h0: didt_TD_power_is_hi ? didt_TD_didt_base_release_allowed_hi : didt_TD_didt_base_release_allowed_lo;
assign didt_TD_didt_incr_release_allowed = ~didt_TD_didt_stall_release_cntl_en ? 5'h0: didt_TD_power_is_hi ? didt_TD_didt_incr_release_allowed_hi : didt_TD_didt_incr_release_allowed_lo;

wire [10*2-1:0] didt_TD_credit_consumed;
assign didt_TD_credit_consumed = {
                                          sa1_didt_TD_credit_consumed,
                                          sa0_didt_TD_credit_consumed};
     gc_didt_edc_cntl_core #(
                .UNITS            (10),
                .NUM_SA           (2),
		.EDC_STALL_INST_NUMS	(2*5),
		.MAX_DELAY_NUMS			(40),
		.EDC_STALL_DELAY_SIZE	(6)
     ) TD_didt_edc_cntl_core (
        .Cpl_GFXCLK						(Cpl_GFXCLK),
        .oCpl_GFXCLK						(oCpl_GFXCLK),
        .rst						(~combined_resetb),
   		.dft_shift_clk				(dft_shift_clk),
   		.Dft_Clk_Gater_En			(Dft_Clk_Gater_En),
   		.Dft_Clk_Gater_Aon			(Dft_Clk_Gater_Aon),			
        .credit_consumed          (didt_TD_credit_consumed),
        .stall                    (didt_TD_stall_pre),
		.power_is_hi			  (didt_TD_power_is_hi),
		.hi_power_threshold		  (didt_TD_hi_power_threshold),
		.auto_mpd_enable		  (didt_TD_didt_auto_mpd_enable),
        .RLC_DIDT_force_stall     (RLC_DIDT_force_stall),
        .rlc_force_stall_en       (didt_TD_didt_rlc_force_stall_en),
        .rlc_stall_level_sel      (didt_TD_didt_rlc_stall_level_sel),
		.didt_throttle_mode	  		(didt_TD_didt_throttle_mode),
		.PSM_didt_throttle_level	(PSM_didt_throttle_level_q),

        .didt_en                  (didt_TD_didt_ctrl_en),
        .phase_offset             (didt_TD_phase_offset),
        .didt_soft_rst            (didt_TD_didt_ctrl_rst),
        .didt_clk_en_override     (didt_TD_didt_clk_en_override),
        .min_power                (didt_TD_min_power),
		.max_power                (didt_TD_max_power_pre),
        .max_power_delta          (didt_TD_max_power_delta_selected),
        .short_term_interval_size (didt_TD_short_term_interval_size),
        .long_term_interval_ratio (didt_TD_long_term_interval_ratio),

        .mpd_ratio_scale_level1   (didt_TD_mpd_ratio_scale_level1),
        .mpd_ratio_scale_level2   (didt_TD_mpd_ratio_scale_level2),
        .mpd_ratio_scale_level3   (didt_TD_mpd_ratio_scale_level3),
        .mpd_ratio_scale_level4   (didt_TD_mpd_ratio_scale_level4),
        .mpd_scale_level0         (didt_TD_mpd_scale_level0),
        .mpd_scale_level1         (didt_TD_mpd_scale_level1),
        .mpd_scale_level2         (didt_TD_mpd_scale_level2),
        .mpd_scale_level3         (didt_TD_mpd_scale_level3),

        .weight_0                 (didt_TD_weight0),
        .weight_1                 (didt_TD_weight1),
        .weight_2                 (didt_TD_weight2),
        .weight_3                 (didt_TD_weight3),
        .weight_4                 (didt_TD_weight4),
        .weight_5                 (didt_TD_weight5),
        .weight_6                 (didt_TD_weight6),
        .weight_7                 (didt_TD_weight7),
        .weight_8                 (didt_TD_weight8),
        .weight_9                 (didt_TD_weight9),
        .weight_10                (didt_TD_weight10),
        .weight_11                (didt_TD_weight11),

		//New DIDT
		.power_level			  (didt_TD_power_level_pre),
		.stall_level			  (didt_TD_stall_level),
		.didt_trigger_throttle_lowbit		(didt_TD_didt_trigger_throttle_lowbit),
		.didt_power_level_lowbit			(didt_TD_didt_power_level_lowbit),
		.throttle_policy					(didt_TD_throttle_policy),
		.gc_didt_enable						(didt_TD_gc_didt_enable),
		.gc_didt_clk_en_override			(didt_TD_gc_didt_clk_en_override),
		.didt_stall_pattern_bit_nums		(didt_TD_didt_stall_pattern_bit_nums),
		.gc_didt_level_comb_en				(didt_TD_gc_didt_level_comb_en),
		.se_didt_level_comb_en				(didt_TD_se_didt_level_comb_en),
		.didt_qualify_stall_en				(didt_TD_qualify_stall_en),
		.didt_stall_sel						(didt_TD_didt_stall_sel),
		.didt_force_stall					(didt_TD_didt_force_stall),
		.didt_stall_delay_en				(didt_TD_didt_stall_delay_en),
		.didt_stall_pattern1				(didt_TD_didt_stall_pattern1),
		.didt_stall_pattern2				(didt_TD_didt_stall_pattern2),
		.didt_stall_pattern3				(didt_TD_didt_stall_pattern3),
		.didt_stall_pattern4				(didt_TD_didt_stall_pattern4),
		.didt_stall_pattern5				(didt_TD_didt_stall_pattern5),
		.didt_stall_pattern6				(didt_TD_didt_stall_pattern6),
		.didt_stall_pattern7				(didt_TD_didt_stall_pattern7),
		.didt_fsm_state					(didt_TD_didt_fsm_state),
		.didt_throttle_level				(didt_TD_didt_throttle_level),
		.didt_dbg_stall_out				(didt_TD_didt_dbg_stall_out),

		.edc_en						(didt_TD_edc_en),
		.edc_sw_rst					(didt_TD_edc_sw_rst),
		.edc_clk_en_override				(didt_TD_edc_clk_en_override),
		.edc_force_stall				(didt_TD_edc_force_stall),
		.edc_threshold					(didt_TD_edc_threshold),
		.edc_trigger_throttle_lowbit		        (didt_TD_edc_trigger_throttle_lowbit),
		.edc_stall_pattern_bit_nums			(didt_TD_edc_stall_pattern_bit_nums),
		.edc_allow_write_pwrdelta			(didt_TD_edc_allow_write_pwrdelta),
		.edc_grbm_wr_pwrdelta_en			(didt_TD_edc_grbm_wr_pwrdelta_en),
		.edc_grbm_clear_ov_counter			(didt_TD_edc_grbm_clear_ov_counter),
		.edc_grbm_clear_rolling_power_delta_ov	        (didt_TD_edc_grbm_clear_rolling_power_delta_ov),

		.gc_se_stall				(gc_se_stall),
		.gc_edc_en					(didt_TD_gc_edc_en),
		.gc_edc_stall_policy				(didt_TD_gc_edc_stall_policy),
		.gc_edc_level_comb_en				(didt_TD_gc_edc_level_comb_en),
		.se_edc_level_comb_en				(didt_TD_se_edc_level_comb_en),
		.edc_level_mode_sel  				(didt_TD_edc_level_mode_sel),
		.edc_level_comb_adapt_mode_en    		(didt_TD_edc_level_comb_adapt_mode_en),
		.gc_edc_stall_en					(didt_TD_gc_edc_stall_en),
		.pcc_stall_en						(didt_TD_pcc_stall_en),
		.pwrbrk_stall_en					(didt_TD_pwrbrk_stall_en),
		.edc_timer_period           		        (didt_TD_edc_timer_period),
		.gc_edc_stall_level				(didt_TD_gc_edc_stall_level),

		.edc_pcc_perf_counter				(didt_TD_edc_pcc_perf_counter),
		.rd_edc_pcc_perf_counter			(rd_didt_TD_edc_pcc_perf_counter),
		.gc_edc_only_mode					(didt_TD_gc_edc_only_mode),
		
		.stall_event_enable				(didt_TD_didt_stall_event_enable),
		.stall_event_counter			(didt_TD_didt_stall_event_counter),
		.stall_event_counter_clear		(didt_TD_didt_stall_event_counter_clear),

		.edc_stall_delay 		({didt_TD_edc_stall_delay_sig9,didt_TD_edc_stall_delay_sig8,didt_TD_edc_stall_delay_sig7,didt_TD_edc_stall_delay_sig6,didt_TD_edc_stall_delay_sig5,didt_TD_edc_stall_delay_sig4,didt_TD_edc_stall_delay_sig3,didt_TD_edc_stall_delay_sig2,didt_TD_edc_stall_delay_sig1,didt_TD_edc_stall_delay_sig0}),


		.edc_grbm_wr_pwrdelta_data			(didt_TD_edc_grbm_wr_pwrdelta_data),
		.edc_stall_pattern1					(didt_TD_edc_stall_pattern1),
		.edc_stall_pattern2					(didt_TD_edc_stall_pattern2),
		.edc_stall_pattern3					(didt_TD_edc_stall_pattern3),
		.edc_stall_pattern4					(didt_TD_edc_stall_pattern4),
		.edc_stall_pattern5					(didt_TD_edc_stall_pattern5),
		.edc_stall_pattern6					(didt_TD_edc_stall_pattern6),
		.edc_stall_pattern7					(didt_TD_edc_stall_pattern7),
		.edc_fsm_state						(didt_TD_edc_fsm_state),
		.edc_throttle_level					(didt_TD_edc_throttle_level),
		.edc_stall							(didt_TD_edc_stall),
		.edc_rolling_power_delta_ov			(didt_TD_edc_rolling_power_delta_ov),
		.edc_throttle_level_ov_counter		(didt_TD_edc_throttle_level_ov_counter),
		.edc_rolling_power_delta			(didt_TD_edc_rolling_power_delta),
		.edc_dbg_stall_out					(didt_TD_edc_dbg_stall_out),

        .TEST_CLK_EN(TEST_CLK_EN)
   );

assign didt_TCP_stall_delay = ((didt_TCP_stall_ctrl_enable == 0) && (didt_TCP_didt_stall_release_cntl_en == 0)) ? 6'h0: didt_TCP_power_is_hi ? didt_TCP_stall_delay_hi : didt_TCP_stall_delay_lo;

//assign didt_TCP_max_stalls_allowed = ~didt_TCP_didt_tuning_enable ? didt_TCP_didt_max_stalls_allowed_hi : didt_TCP_power_is_hi ? didt_TCP_didt_max_stalls_allowed_hi : didt_TCP_didt_max_stalls_allowed_lo;
assign didt_TCP_max_stalls_allowed = (didt_TCP_didt_throttle_mode == 0)? (PSM_didt_throttle_level_q[1] ? didt_SQ_didt_max_stalls_allowed_hi : didt_SQ_didt_max_stalls_allowed_lo) : (~didt_TCP_didt_tuning_enable ? didt_TCP_didt_max_stalls_allowed_hi : didt_TCP_power_is_hi ? didt_TCP_didt_max_stalls_allowed_hi : didt_TCP_didt_max_stalls_allowed_lo);

wire [13:0] didt_TCP_max_power_delta_selected;
assign didt_TCP_max_power_delta_selected = ~didt_TCP_didt_tuning_enable ? didt_TCP_max_power_delta : didt_TCP_power_is_hi ? didt_TCP_max_power_delta_hi : didt_TCP_max_power_delta_lo;

wire [3:0]	didt_TCP_power_level_pre;
assign didt_TCP_power_level = didt_TCP_power_level_pre & {4{didt_TCP_gc_didt_enable}} & {4{didt_TCP_didt_ctrl_en}};

assign didt_TCP_didt_release_delay = ~didt_TCP_didt_stall_release_cntl_en ? 11'h0: didt_TCP_power_is_hi ? didt_TCP_didt_release_delay_hi : didt_TCP_didt_release_delay_lo;
assign didt_TCP_didt_base_release_allowed = ~didt_TCP_didt_stall_release_cntl_en ? 5'h0: didt_TCP_power_is_hi ? didt_TCP_didt_base_release_allowed_hi : didt_TCP_didt_base_release_allowed_lo;
assign didt_TCP_didt_incr_release_allowed = ~didt_TCP_didt_stall_release_cntl_en ? 5'h0: didt_TCP_power_is_hi ? didt_TCP_didt_incr_release_allowed_hi : didt_TCP_didt_incr_release_allowed_lo;

wire [5*2-1:0] didt_TCP_credit_consumed;
assign didt_TCP_credit_consumed = {
                                          sa1_didt_TCP_credit_consumed,
                                          sa0_didt_TCP_credit_consumed};
     gc_didt_edc_cntl_core #(
                .UNITS            (5),
                .NUM_SA           (2),
		.EDC_STALL_INST_NUMS	(2*5),
		.MAX_DELAY_NUMS			(40),
		.EDC_STALL_DELAY_SIZE	(6)
     ) TCP_didt_edc_cntl_core (
        .Cpl_GFXCLK						(Cpl_GFXCLK),
        .oCpl_GFXCLK						(oCpl_GFXCLK),
        .rst						(~combined_resetb),
   		.dft_shift_clk				(dft_shift_clk),
   		.Dft_Clk_Gater_En			(Dft_Clk_Gater_En),
   		.Dft_Clk_Gater_Aon			(Dft_Clk_Gater_Aon),			
        .credit_consumed          (didt_TCP_credit_consumed),
        .stall                    (didt_TCP_stall_pre),
		.power_is_hi			  (didt_TCP_power_is_hi),
		.hi_power_threshold		  (didt_TCP_hi_power_threshold),
		.auto_mpd_enable		  (didt_TCP_didt_auto_mpd_enable),
        .RLC_DIDT_force_stall     (RLC_DIDT_force_stall),
        .rlc_force_stall_en       (didt_TCP_didt_rlc_force_stall_en),
        .rlc_stall_level_sel      (didt_TCP_didt_rlc_stall_level_sel),
		.didt_throttle_mode	  		(didt_TCP_didt_throttle_mode),
		.PSM_didt_throttle_level	(PSM_didt_throttle_level_q),

        .didt_en                  (didt_TCP_didt_ctrl_en),
        .phase_offset             (didt_TCP_phase_offset),
        .didt_soft_rst            (didt_TCP_didt_ctrl_rst),
        .didt_clk_en_override     (didt_TCP_didt_clk_en_override),
        .min_power                (didt_TCP_min_power),
		.max_power                (didt_TCP_max_power_pre),
        .max_power_delta          (didt_TCP_max_power_delta_selected),
        .short_term_interval_size (didt_TCP_short_term_interval_size),
        .long_term_interval_ratio (didt_TCP_long_term_interval_ratio),

        .mpd_ratio_scale_level1   (didt_TCP_mpd_ratio_scale_level1),
        .mpd_ratio_scale_level2   (didt_TCP_mpd_ratio_scale_level2),
        .mpd_ratio_scale_level3   (didt_TCP_mpd_ratio_scale_level3),
        .mpd_ratio_scale_level4   (didt_TCP_mpd_ratio_scale_level4),
        .mpd_scale_level0         (didt_TCP_mpd_scale_level0),
        .mpd_scale_level1         (didt_TCP_mpd_scale_level1),
        .mpd_scale_level2         (didt_TCP_mpd_scale_level2),
        .mpd_scale_level3         (didt_TCP_mpd_scale_level3),

        .weight_0                 (didt_TCP_weight0),
        .weight_1                 (didt_TCP_weight1),
        .weight_2                 (didt_TCP_weight2),
        .weight_3                 (didt_TCP_weight3),
        .weight_4                 (didt_TCP_weight4),
        .weight_5                 (didt_TCP_weight5),
        .weight_6                 (didt_TCP_weight6),
        .weight_7                 (didt_TCP_weight7),
        .weight_8                 (didt_TCP_weight8),
        .weight_9                 (didt_TCP_weight9),
        .weight_10                (didt_TCP_weight10),
        .weight_11                (didt_TCP_weight11),

		//New DIDT
		.power_level			  (didt_TCP_power_level_pre),
		.stall_level			  (didt_TCP_stall_level),
		.didt_trigger_throttle_lowbit		(didt_TCP_didt_trigger_throttle_lowbit),
		.didt_power_level_lowbit			(didt_TCP_didt_power_level_lowbit),
		.throttle_policy					(didt_TCP_throttle_policy),
		.gc_didt_enable						(didt_TCP_gc_didt_enable),
		.gc_didt_clk_en_override			(didt_TCP_gc_didt_clk_en_override),
		.didt_stall_pattern_bit_nums		(didt_TCP_didt_stall_pattern_bit_nums),
		.gc_didt_level_comb_en				(didt_TCP_gc_didt_level_comb_en),
		.se_didt_level_comb_en				(didt_TCP_se_didt_level_comb_en),
		.didt_qualify_stall_en				(didt_TCP_qualify_stall_en),
		.didt_stall_sel						(didt_TCP_didt_stall_sel),
		.didt_force_stall					(didt_TCP_didt_force_stall),
		.didt_stall_delay_en				(didt_TCP_didt_stall_delay_en),
		.didt_stall_pattern1				(didt_TCP_didt_stall_pattern1),
		.didt_stall_pattern2				(didt_TCP_didt_stall_pattern2),
		.didt_stall_pattern3				(didt_TCP_didt_stall_pattern3),
		.didt_stall_pattern4				(didt_TCP_didt_stall_pattern4),
		.didt_stall_pattern5				(didt_TCP_didt_stall_pattern5),
		.didt_stall_pattern6				(didt_TCP_didt_stall_pattern6),
		.didt_stall_pattern7				(didt_TCP_didt_stall_pattern7),
		.didt_fsm_state					(didt_TCP_didt_fsm_state),
		.didt_throttle_level				(didt_TCP_didt_throttle_level),
		.didt_dbg_stall_out				(didt_TCP_didt_dbg_stall_out),

		.edc_en						(didt_TCP_edc_en),
		.edc_sw_rst					(didt_TCP_edc_sw_rst),
		.edc_clk_en_override				(didt_TCP_edc_clk_en_override),
		.edc_force_stall				(didt_TCP_edc_force_stall),
		.edc_threshold					(didt_TCP_edc_threshold),
		.edc_trigger_throttle_lowbit		        (didt_TCP_edc_trigger_throttle_lowbit),
		.edc_stall_pattern_bit_nums			(didt_TCP_edc_stall_pattern_bit_nums),
		.edc_allow_write_pwrdelta			(didt_TCP_edc_allow_write_pwrdelta),
		.edc_grbm_wr_pwrdelta_en			(didt_TCP_edc_grbm_wr_pwrdelta_en),
		.edc_grbm_clear_ov_counter			(didt_TCP_edc_grbm_clear_ov_counter),
		.edc_grbm_clear_rolling_power_delta_ov	        (didt_TCP_edc_grbm_clear_rolling_power_delta_ov),

		.gc_se_stall				(gc_se_stall),
		.gc_edc_en					(didt_TCP_gc_edc_en),
		.gc_edc_stall_policy				(didt_TCP_gc_edc_stall_policy),
		.gc_edc_level_comb_en				(didt_TCP_gc_edc_level_comb_en),
		.se_edc_level_comb_en				(didt_TCP_se_edc_level_comb_en),
		.edc_level_mode_sel  				(didt_TCP_edc_level_mode_sel),
		.edc_level_comb_adapt_mode_en    		(didt_TCP_edc_level_comb_adapt_mode_en),
		.gc_edc_stall_en					(didt_TCP_gc_edc_stall_en),
		.pcc_stall_en						(didt_TCP_pcc_stall_en),
		.pwrbrk_stall_en					(didt_TCP_pwrbrk_stall_en),
		.edc_timer_period           		        (didt_TCP_edc_timer_period),
		.gc_edc_stall_level				(didt_TCP_gc_edc_stall_level),

		.edc_pcc_perf_counter				(didt_TCP_edc_pcc_perf_counter),
		.rd_edc_pcc_perf_counter			(rd_didt_TCP_edc_pcc_perf_counter),
		.gc_edc_only_mode					(didt_TCP_gc_edc_only_mode),
		
		.stall_event_enable				(didt_TCP_didt_stall_event_enable),
		.stall_event_counter			(didt_TCP_didt_stall_event_counter),
		.stall_event_counter_clear		(didt_TCP_didt_stall_event_counter_clear),

		.edc_stall_delay 		({didt_TCP_edc_stall_delay_sig9,didt_TCP_edc_stall_delay_sig8,didt_TCP_edc_stall_delay_sig7,didt_TCP_edc_stall_delay_sig6,didt_TCP_edc_stall_delay_sig5,didt_TCP_edc_stall_delay_sig4,didt_TCP_edc_stall_delay_sig3,didt_TCP_edc_stall_delay_sig2,didt_TCP_edc_stall_delay_sig1,didt_TCP_edc_stall_delay_sig0}),


		.edc_grbm_wr_pwrdelta_data			(didt_TCP_edc_grbm_wr_pwrdelta_data),
		.edc_stall_pattern1					(didt_TCP_edc_stall_pattern1),
		.edc_stall_pattern2					(didt_TCP_edc_stall_pattern2),
		.edc_stall_pattern3					(didt_TCP_edc_stall_pattern3),
		.edc_stall_pattern4					(didt_TCP_edc_stall_pattern4),
		.edc_stall_pattern5					(didt_TCP_edc_stall_pattern5),
		.edc_stall_pattern6					(didt_TCP_edc_stall_pattern6),
		.edc_stall_pattern7					(didt_TCP_edc_stall_pattern7),
		.edc_fsm_state						(didt_TCP_edc_fsm_state),
		.edc_throttle_level					(didt_TCP_edc_throttle_level),
		.edc_stall							(didt_TCP_edc_stall),
		.edc_rolling_power_delta_ov			(didt_TCP_edc_rolling_power_delta_ov),
		.edc_throttle_level_ov_counter		(didt_TCP_edc_throttle_level_ov_counter),
		.edc_rolling_power_delta			(didt_TCP_edc_rolling_power_delta),
		.edc_dbg_stall_out					(didt_TCP_edc_dbg_stall_out),

        .TEST_CLK_EN(TEST_CLK_EN)
   );

wire SQ_didt_stall_clk;
gfx_cgtt_local_dft u_didt_SQ_stall_cntl_clk_gater
(
 	.oclk			(SQ_didt_stall_clk),
	.Cpl_GFXCLK		(Cpl_GFXCLK),
	.core_busy		(didt_SQ_didt_ctrl_en || didt_SQ_didt_clk_en_override || ~combined_resetb || ~hard_resetb),
	.dft_clk_gate_ctrl	({Dft_Clk_Gater_En, Dft_Clk_Gater_Aon}),
	.dft_shift_clk		(dft_shift_clk)
);

wire SQ_didt_stall_release_cntl_clk;
gfx_cgtt_local_dft u_didt_SQ_stall_release_cntl_clk_gater
(
    .oclk       	 (SQ_didt_stall_release_cntl_clk),
    .Cpl_GFXCLK      (Cpl_GFXCLK),
    .core_busy         (didt_SQ_didt_stall_release_cntl_en || didt_SQ_didt_clk_en_override || ~combined_resetb || ~hard_resetb || didt_SQ_didt_ctrl_rst),
	.dft_clk_gate_ctrl	({Dft_Clk_Gater_En, Dft_Clk_Gater_Aon}),
	.dft_shift_clk		(dft_shift_clk)
);
wire DB_didt_stall_clk;
gfx_cgtt_local_dft u_didt_DB_stall_cntl_clk_gater
(
 	.oclk			(DB_didt_stall_clk),
	.Cpl_GFXCLK		(Cpl_GFXCLK),
	.core_busy		(didt_DB_didt_ctrl_en || didt_DB_didt_clk_en_override || ~combined_resetb || ~hard_resetb),
	.dft_clk_gate_ctrl	({Dft_Clk_Gater_En, Dft_Clk_Gater_Aon}),
	.dft_shift_clk		(dft_shift_clk)
);

wire DB_didt_stall_release_cntl_clk;
gfx_cgtt_local_dft u_didt_DB_stall_release_cntl_clk_gater
(
    .oclk       	 (DB_didt_stall_release_cntl_clk),
    .Cpl_GFXCLK      (Cpl_GFXCLK),
    .core_busy         (didt_DB_didt_stall_release_cntl_en || didt_DB_didt_clk_en_override || ~combined_resetb || ~hard_resetb || didt_DB_didt_ctrl_rst),
	.dft_clk_gate_ctrl	({Dft_Clk_Gater_En, Dft_Clk_Gater_Aon}),
	.dft_shift_clk		(dft_shift_clk)
);
wire TD_didt_stall_clk;
gfx_cgtt_local_dft u_didt_TD_stall_cntl_clk_gater
(
 	.oclk			(TD_didt_stall_clk),
	.Cpl_GFXCLK		(Cpl_GFXCLK),
	.core_busy		(didt_TD_didt_ctrl_en || didt_TD_didt_clk_en_override || ~combined_resetb || ~hard_resetb),
	.dft_clk_gate_ctrl	({Dft_Clk_Gater_En, Dft_Clk_Gater_Aon}),
	.dft_shift_clk		(dft_shift_clk)
);

wire TD_didt_stall_release_cntl_clk;
gfx_cgtt_local_dft u_didt_TD_stall_release_cntl_clk_gater
(
    .oclk       	 (TD_didt_stall_release_cntl_clk),
    .Cpl_GFXCLK      (Cpl_GFXCLK),
    .core_busy         (didt_TD_didt_stall_release_cntl_en || didt_TD_didt_clk_en_override || ~combined_resetb || ~hard_resetb || didt_TD_didt_ctrl_rst),
	.dft_clk_gate_ctrl	({Dft_Clk_Gater_En, Dft_Clk_Gater_Aon}),
	.dft_shift_clk		(dft_shift_clk)
);
wire TCP_didt_stall_clk;
gfx_cgtt_local_dft u_didt_TCP_stall_cntl_clk_gater
(
 	.oclk			(TCP_didt_stall_clk),
	.Cpl_GFXCLK		(Cpl_GFXCLK),
	.core_busy		(didt_TCP_didt_ctrl_en || didt_TCP_didt_clk_en_override || ~combined_resetb || ~hard_resetb),
	.dft_clk_gate_ctrl	({Dft_Clk_Gater_En, Dft_Clk_Gater_Aon}),
	.dft_shift_clk		(dft_shift_clk)
);

wire TCP_didt_stall_release_cntl_clk;
gfx_cgtt_local_dft u_didt_TCP_stall_release_cntl_clk_gater
(
    .oclk       	 (TCP_didt_stall_release_cntl_clk),
    .Cpl_GFXCLK      (Cpl_GFXCLK),
    .core_busy         (didt_TCP_didt_stall_release_cntl_en || didt_TCP_didt_clk_en_override || ~combined_resetb || ~hard_resetb || didt_TCP_didt_ctrl_rst),
	.dft_clk_gate_ctrl	({Dft_Clk_Gater_En, Dft_Clk_Gater_Aon}),
	.dft_shift_clk		(dft_shift_clk)
);


gc_didt_stall_cntl #(.NUM_INSTANCE(10)) sa0_SQ_didt_stall_cntl (
		.stall_delay					(didt_SQ_stall_delay),
		.stall_ctrl_enable				(didt_SQ_stall_ctrl_enable), 
		.max_stalls_allowed				(didt_SQ_max_stalls_allowed),
		.stall_auto_release_enable		(didt_SQ_stall_auto_release_enable),
		.stall_auto_release_time		(didt_SQ_stall_auto_release_time),

		.stall_in						(didt_SQ_stall_pre),
		.stall_out						(sa0_didt_SQ_stall),
		.TEST_CLK_EN 					(TEST_CLK_EN),
		.clk							(SQ_didt_stall_clk),
		.resetb							(combined_resetb)
);
gc_didt_stall_release_cntl #(.NUM_INSTANCE(10)) sa0_SQ_didt_stall_release_cntl (
        .didt_stall_release_cntl_en          (didt_SQ_didt_stall_release_cntl_en), 

        .didt_stall_delay               (didt_SQ_stall_delay),
        .didt_max_stalls_allowed        (didt_SQ_max_stalls_allowed),
        .didt_release_delay             (didt_SQ_didt_release_delay),
        .didt_base_release_allowed      (didt_SQ_didt_base_release_allowed),
        .didt_incr_release_allowed      (didt_SQ_didt_incr_release_allowed),
        .didt_stall_release_cntl_fsm_state   (didt_SQ_didt_stall_release_cntl_fsm_state),
        .stall_in                       (didt_SQ_stall_pre),
        .stall_out                      (sa0_didt_SQ_stall_release_cntl_stall_out),
        .TEST_CLK_EN                    (TEST_CLK_EN),
        .clk                            (SQ_didt_stall_release_cntl_clk),
        .resetb                         ((~combined_resetb) || didt_SQ_didt_ctrl_rst) //high active reset
);
gc_didt_stall_cntl #(.NUM_INSTANCE(10)) sa1_SQ_didt_stall_cntl (
		.stall_delay					(didt_SQ_stall_delay),
		.stall_ctrl_enable				(didt_SQ_stall_ctrl_enable), 
		.max_stalls_allowed				(didt_SQ_max_stalls_allowed),
		.stall_auto_release_enable		(didt_SQ_stall_auto_release_enable),
		.stall_auto_release_time		(didt_SQ_stall_auto_release_time),

		.stall_in						(didt_SQ_stall_pre),
		.stall_out						(sa1_didt_SQ_stall),
		.TEST_CLK_EN 					(TEST_CLK_EN),
		.clk							(SQ_didt_stall_clk),
		.resetb							(combined_resetb)
);
gc_didt_stall_release_cntl #(.NUM_INSTANCE(10)) sa1_SQ_didt_stall_release_cntl (
        .didt_stall_release_cntl_en          (didt_SQ_didt_stall_release_cntl_en), 

        .didt_stall_delay               (didt_SQ_stall_delay),
        .didt_max_stalls_allowed        (didt_SQ_max_stalls_allowed),
        .didt_release_delay             (didt_SQ_didt_release_delay),
        .didt_base_release_allowed      (didt_SQ_didt_base_release_allowed),
        .didt_incr_release_allowed      (didt_SQ_didt_incr_release_allowed),
        .didt_stall_release_cntl_fsm_state   (),
        .stall_in                       (didt_SQ_stall_pre),
        .stall_out                      (sa1_didt_SQ_stall_release_cntl_stall_out),
        .TEST_CLK_EN                    (TEST_CLK_EN),
        .clk                            (SQ_didt_stall_release_cntl_clk),
        .resetb                         ((~combined_resetb) || didt_SQ_didt_ctrl_rst) //high active reset
);

gc_didt_stall_cntl #(.NUM_INSTANCE(4)) sa0_DB_didt_stall_cntl (
		.stall_delay					(didt_DB_stall_delay),
		.stall_ctrl_enable				(didt_DB_stall_ctrl_enable), 
		.max_stalls_allowed				(didt_DB_max_stalls_allowed),
		.stall_auto_release_enable		(didt_DB_stall_auto_release_enable),
		.stall_auto_release_time		(didt_DB_stall_auto_release_time),

		.stall_in						(didt_DB_stall_pre),
		.stall_out						(sa0_didt_DB_stall),
		.TEST_CLK_EN 					(TEST_CLK_EN),
		.clk							(DB_didt_stall_clk),
		.resetb							(combined_resetb)
);
gc_didt_stall_release_cntl #(.NUM_INSTANCE(4)) sa0_DB_didt_stall_release_cntl (
        .didt_stall_release_cntl_en          (didt_DB_didt_stall_release_cntl_en), 

        .didt_stall_delay               (didt_DB_stall_delay),
        .didt_max_stalls_allowed        (didt_DB_max_stalls_allowed),
        .didt_release_delay             (didt_DB_didt_release_delay),
        .didt_base_release_allowed      (didt_DB_didt_base_release_allowed),
        .didt_incr_release_allowed      (didt_DB_didt_incr_release_allowed),
        .didt_stall_release_cntl_fsm_state   (didt_DB_didt_stall_release_cntl_fsm_state),
        .stall_in                       (didt_DB_stall_pre),
        .stall_out                      (sa0_didt_DB_stall_release_cntl_stall_out),
        .TEST_CLK_EN                    (TEST_CLK_EN),
        .clk                            (DB_didt_stall_release_cntl_clk),
        .resetb                         ((~combined_resetb) || didt_DB_didt_ctrl_rst) //high active reset
);
gc_didt_stall_cntl #(.NUM_INSTANCE(4)) sa1_DB_didt_stall_cntl (
		.stall_delay					(didt_DB_stall_delay),
		.stall_ctrl_enable				(didt_DB_stall_ctrl_enable), 
		.max_stalls_allowed				(didt_DB_max_stalls_allowed),
		.stall_auto_release_enable		(didt_DB_stall_auto_release_enable),
		.stall_auto_release_time		(didt_DB_stall_auto_release_time),

		.stall_in						(didt_DB_stall_pre),
		.stall_out						(sa1_didt_DB_stall),
		.TEST_CLK_EN 					(TEST_CLK_EN),
		.clk							(DB_didt_stall_clk),
		.resetb							(combined_resetb)
);
gc_didt_stall_release_cntl #(.NUM_INSTANCE(4)) sa1_DB_didt_stall_release_cntl (
        .didt_stall_release_cntl_en          (didt_DB_didt_stall_release_cntl_en), 

        .didt_stall_delay               (didt_DB_stall_delay),
        .didt_max_stalls_allowed        (didt_DB_max_stalls_allowed),
        .didt_release_delay             (didt_DB_didt_release_delay),
        .didt_base_release_allowed      (didt_DB_didt_base_release_allowed),
        .didt_incr_release_allowed      (didt_DB_didt_incr_release_allowed),
        .didt_stall_release_cntl_fsm_state   (),
        .stall_in                       (didt_DB_stall_pre),
        .stall_out                      (sa1_didt_DB_stall_release_cntl_stall_out),
        .TEST_CLK_EN                    (TEST_CLK_EN),
        .clk                            (DB_didt_stall_release_cntl_clk),
        .resetb                         ((~combined_resetb) || didt_DB_didt_ctrl_rst) //high active reset
);

gc_didt_stall_cntl #(.NUM_INSTANCE(10)) sa0_TD_didt_stall_cntl (
		.stall_delay					(didt_TD_stall_delay),
		.stall_ctrl_enable				(didt_TD_stall_ctrl_enable), 
		.max_stalls_allowed				(didt_TD_max_stalls_allowed),
		.stall_auto_release_enable		(didt_TD_stall_auto_release_enable),
		.stall_auto_release_time		(didt_TD_stall_auto_release_time),

		.stall_in						(didt_TD_stall_pre),
		.stall_out						(sa0_didt_TD_stall),
		.TEST_CLK_EN 					(TEST_CLK_EN),
		.clk							(TD_didt_stall_clk),
		.resetb							(combined_resetb)
);
gc_didt_stall_release_cntl #(.NUM_INSTANCE(10)) sa0_TD_didt_stall_release_cntl (
        .didt_stall_release_cntl_en          (didt_TD_didt_stall_release_cntl_en), 

        .didt_stall_delay               (didt_TD_stall_delay),
        .didt_max_stalls_allowed        (didt_TD_max_stalls_allowed),
        .didt_release_delay             (didt_TD_didt_release_delay),
        .didt_base_release_allowed      (didt_TD_didt_base_release_allowed),
        .didt_incr_release_allowed      (didt_TD_didt_incr_release_allowed),
        .didt_stall_release_cntl_fsm_state   (didt_TD_didt_stall_release_cntl_fsm_state),
        .stall_in                       (didt_TD_stall_pre),
        .stall_out                      (sa0_didt_TD_stall_release_cntl_stall_out),
        .TEST_CLK_EN                    (TEST_CLK_EN),
        .clk                            (TD_didt_stall_release_cntl_clk),
        .resetb                         ((~combined_resetb) || didt_TD_didt_ctrl_rst) //high active reset
);
gc_didt_stall_cntl #(.NUM_INSTANCE(10)) sa1_TD_didt_stall_cntl (
		.stall_delay					(didt_TD_stall_delay),
		.stall_ctrl_enable				(didt_TD_stall_ctrl_enable), 
		.max_stalls_allowed				(didt_TD_max_stalls_allowed),
		.stall_auto_release_enable		(didt_TD_stall_auto_release_enable),
		.stall_auto_release_time		(didt_TD_stall_auto_release_time),

		.stall_in						(didt_TD_stall_pre),
		.stall_out						(sa1_didt_TD_stall),
		.TEST_CLK_EN 					(TEST_CLK_EN),
		.clk							(TD_didt_stall_clk),
		.resetb							(combined_resetb)
);
gc_didt_stall_release_cntl #(.NUM_INSTANCE(10)) sa1_TD_didt_stall_release_cntl (
        .didt_stall_release_cntl_en          (didt_TD_didt_stall_release_cntl_en), 

        .didt_stall_delay               (didt_TD_stall_delay),
        .didt_max_stalls_allowed        (didt_TD_max_stalls_allowed),
        .didt_release_delay             (didt_TD_didt_release_delay),
        .didt_base_release_allowed      (didt_TD_didt_base_release_allowed),
        .didt_incr_release_allowed      (didt_TD_didt_incr_release_allowed),
        .didt_stall_release_cntl_fsm_state   (),
        .stall_in                       (didt_TD_stall_pre),
        .stall_out                      (sa1_didt_TD_stall_release_cntl_stall_out),
        .TEST_CLK_EN                    (TEST_CLK_EN),
        .clk                            (TD_didt_stall_release_cntl_clk),
        .resetb                         ((~combined_resetb) || didt_TD_didt_ctrl_rst) //high active reset
);

gc_didt_stall_cntl #(.NUM_INSTANCE(10)) sa0_TCP_didt_stall_cntl (
		.stall_delay					(didt_TCP_stall_delay),
		.stall_ctrl_enable				(didt_TCP_stall_ctrl_enable), 
		.max_stalls_allowed				(didt_TCP_max_stalls_allowed),
		.stall_auto_release_enable		(didt_TCP_stall_auto_release_enable),
		.stall_auto_release_time		(didt_TCP_stall_auto_release_time),

		.stall_in						(didt_TCP_stall_pre),
		.stall_out						(sa0_didt_TCP_stall),
		.TEST_CLK_EN 					(TEST_CLK_EN),
		.clk							(TCP_didt_stall_clk),
		.resetb							(combined_resetb)
);
gc_didt_stall_release_cntl #(.NUM_INSTANCE(10)) sa0_TCP_didt_stall_release_cntl (
        .didt_stall_release_cntl_en          (didt_TCP_didt_stall_release_cntl_en), 

        .didt_stall_delay               (didt_TCP_stall_delay),
        .didt_max_stalls_allowed        (didt_TCP_max_stalls_allowed),
        .didt_release_delay             (didt_TCP_didt_release_delay),
        .didt_base_release_allowed      (didt_TCP_didt_base_release_allowed),
        .didt_incr_release_allowed      (didt_TCP_didt_incr_release_allowed),
        .didt_stall_release_cntl_fsm_state   (didt_TCP_didt_stall_release_cntl_fsm_state),
        .stall_in                       (didt_TCP_stall_pre),
        .stall_out                      (sa0_didt_TCP_stall_release_cntl_stall_out),
        .TEST_CLK_EN                    (TEST_CLK_EN),
        .clk                            (TCP_didt_stall_release_cntl_clk),
        .resetb                         ((~combined_resetb) || didt_TCP_didt_ctrl_rst) //high active reset
);
gc_didt_stall_cntl #(.NUM_INSTANCE(10)) sa1_TCP_didt_stall_cntl (
		.stall_delay					(didt_TCP_stall_delay),
		.stall_ctrl_enable				(didt_TCP_stall_ctrl_enable), 
		.max_stalls_allowed				(didt_TCP_max_stalls_allowed),
		.stall_auto_release_enable		(didt_TCP_stall_auto_release_enable),
		.stall_auto_release_time		(didt_TCP_stall_auto_release_time),

		.stall_in						(didt_TCP_stall_pre),
		.stall_out						(sa1_didt_TCP_stall),
		.TEST_CLK_EN 					(TEST_CLK_EN),
		.clk							(TCP_didt_stall_clk),
		.resetb							(combined_resetb)
);
gc_didt_stall_release_cntl #(.NUM_INSTANCE(10)) sa1_TCP_didt_stall_release_cntl (
        .didt_stall_release_cntl_en          (didt_TCP_didt_stall_release_cntl_en), 

        .didt_stall_delay               (didt_TCP_stall_delay),
        .didt_max_stalls_allowed        (didt_TCP_max_stalls_allowed),
        .didt_release_delay             (didt_TCP_didt_release_delay),
        .didt_base_release_allowed      (didt_TCP_didt_base_release_allowed),
        .didt_incr_release_allowed      (didt_TCP_didt_incr_release_allowed),
        .didt_stall_release_cntl_fsm_state   (),
        .stall_in                       (didt_TCP_stall_pre),
        .stall_out                      (sa1_didt_TCP_stall_release_cntl_stall_out),
        .TEST_CLK_EN                    (TEST_CLK_EN),
        .clk                            (TCP_didt_stall_release_cntl_clk),
        .resetb                         ((~combined_resetb) || didt_TCP_didt_ctrl_rst) //high active reset
);


endmodule // gc_didt_cntl
