module gc_didt_stall_auto_release_cntl (
	//input
	stall_auto_release_enable,
	stall_auto_release_time,

	clk,
	resetb,

	//output
	stall_auto_release,
	stall_auto_release_raise

);

	parameter TIMER_WIDTH = 24;

	input wire stall_auto_release_enable;
	input wire[TIMER_WIDTH-1:0] stall_auto_release_time;
	
	input clk;
	input resetb;

	output wire stall_auto_release;
	output wire stall_auto_release_raise;
	

	wire stall_auto_release_enable_edge;
	reg  stall_auto_release_enable_d;

	always @(posedge clk) begin
		if(~resetb) begin
			stall_auto_release_enable_d <= 1'b0;
		end else begin
			stall_auto_release_enable_d <= stall_auto_release_enable;
		end
	end
	assign stall_auto_release_enable_edge = stall_auto_release_enable_d ^ stall_auto_release_enable;

	reg[TIMER_WIDTH:0] stall_auto_release_cntr;

	always @(posedge clk) begin
		if(~resetb ) begin
			stall_auto_release_cntr <= {(TIMER_WIDTH+1){1'b0}};
		end
		else if (stall_auto_release_enable_edge) begin
			stall_auto_release_cntr <= {(TIMER_WIDTH+1){1'b0}};
		end else
			if (stall_auto_release_enable && (stall_auto_release_cntr < (stall_auto_release_time + 1)) ) begin
				stall_auto_release_cntr <= stall_auto_release_cntr + 1'b1;
			end
	end

	assign stall_auto_release = ~stall_auto_release_enable ? 0 : (stall_auto_release_cntr >= stall_auto_release_time) ? 1 : 0;

	assign stall_auto_release_raise = ~stall_auto_release_enable ? 0 : (stall_auto_release_cntr == stall_auto_release_time) ? 1 : 0;

endmodule
