// ==============================================================================================
// PLEASE DONOT CHANGES THIS FILE
// THIS FILE IS AUTO_GENERATED
// Source: import/address/src/rtl/gen_one/generic_addr_calc2_tc.v
// ===============================================================================================
// Filename              : generic_10xx_addr_calc2_riro_tc.v
// Perforce changelist   : $Change$
//
// Copyright             : Trade secret of AMD, Inc.
//                         Copyright 2008, AMD, Inc., (unpublished)
//                         All rights reserved.  This notice is intended as a precaution against
//                         inadvertent publication and does not imply publication or any waiver
//                         of confidentiality.  The year included in the foregoing notice is the
//                         year of creation of the work.
//
// RTL author: kevin.gu
//
// Description: address calc module for tc for SI. projects
//

`include "global_features.vh"
`include "addrlib_defines_gc.vh"

module generic_addr_calc2_tc_gc( 
                                    //outputs
                                     address,
                                     busy, 
                                     //inputs
                                     x,                             //coordinate x
                                     y,                             //coordinate y
                                     z,                             //coordinate z
                                     s,                             //sample number
                                     baseAddr256B,                  //base addr 256B align
                                     log2_pixelsize,                //0: 8bpp, 1:16bpp, 2:32bpp, 3:64bpp, 4:128bpp
                                     log2_samples,                  //the number of samples
                                     pitch_tile_max,                //in tiles, pitch_element/8 -1
                                     slice_tile_max,                //in tiles, slice_tiles -1
                                     micro_tile_mode,               //new added in 10xx, change to 3-bits in 11xx
                                     array_mode,                    //as defines
                                     tile_split,                    //0: 64B split, 1: 128B split, 2: 256B ...
                                     bank_width,                    //0: 1tile, 1:2tiles, 2:4tiles, 3:8tiles
                                     bank_height,                   //0: 1tile, 1:2tiles, 2:4tiles, 3:8tiles
                                     macro_tile_aspect,             //0: 1tile, 1:2tiles, 2:4tiles, 3:8tiles
                                     num_banks,                     //0: 2banks,1:4banks, 2:8banks, 3:16banks
                                     pipe_interleave_size,          //0: 256B, 1:512B, 2:1024B, 3:2048B, 4:4096B
                                     pipe_config,                   //10xx new added
                                     hash_enable,                   //RFC: hash enable, 1 is enabled, 0 is disabled
                                     hash_channel_bits,             // number of channel bits in the address (1,2,4,8,16 channels)
                                     hash_bank_bits,                // number of banks bits in the address (1,2,4,8,16 banks)
                                     hash_channel_xor_count,        // number of XORs into channel bits
                                     hash_bank_xor_count,           // number of XORs into bank bits
                                     sclk,
                                     iRTS,
                                     oRTR,
                                     oRTS,
                                     iRTR,
                                     pass_thru_data_in,
                                     pass_thru_data_out,
                                     srst
                                    ,input_en
                                    ,output_en
                                     );

parameter RI = 1; 
parameter RO = 1; 
parameter PASSTHRU_WIDTH 		= 1;	// Bus Width of the pass through data
parameter COLLAPSABLE_PIPE_STAGE = 1;   // COLLAPSABLE/NONCOLLAPSABLE, 1/0

localparam CALC_STAGES = `BC_ADDR_CALC_TC; //number of "core" stages to calculate "outputs"
parameter PAD_STAGES = (`ADDR_CALC_STAGES - CALC_STAGES);


`ifdef GPU__GC__MEM_ADDR_BITS_ATC__48
localparam LPARAM_MEM_ADDR_WIDTH 	=  48,
           LPARAM_MEM_ADDR_BASE_WIDTH   =  48,
           LPARAM_MEM_ADDR_OFFSET_WIDTH	=  41;

`else
localparam LPARAM_MEM_ADDR_WIDTH 	=  40,
           LPARAM_MEM_ADDR_BASE_WIDTH   =  40,
           LPARAM_MEM_ADDR_OFFSET_WIDTH	=  40;

`endif

localparam LOG2_MAX_X = 16;
localparam LOG2_MAX_Y = 14;
localparam LOG2_MAX_Z = 13;
localparam PITCH_TILE_MAX_SIZE = 13;
localparam SLICE_TILE_MAX_SIZE = 24;

//inputs
input   [LOG2_MAX_X-1:0]                       x;                         
input   [LOG2_MAX_Y-1:0]                       y;                         
input   [LOG2_MAX_Z-1:0]                       z;                         
input   [ 2: 0]                                s;                         
input   [LPARAM_MEM_ADDR_BASE_WIDTH-8-1: 0]    baseAddr256B;              
input   [ 2: 0]                                log2_pixelsize;            
input   [ 1: 0]                                log2_samples;              
input   [PITCH_TILE_MAX_SIZE-1:0]              pitch_tile_max;            
input   [SLICE_TILE_MAX_SIZE-1:0]              slice_tile_max;            
input   [ 3: 0]                                array_mode;                
input   [ 2: 0]                                tile_split;                
input   [ 1: 0]                                bank_width;                
input   [ 1: 0]                                bank_height;               
input   [ 1: 0]                                macro_tile_aspect;         
input   [ 1: 0]                                num_banks;                 
input   [ 2: 0]                                pipe_interleave_size;      
input   [ 2: 0]                                micro_tile_mode;           // r11xx: changed to 3-bits
input   [ 4: 0]                                pipe_config;               
input                                          hash_enable;               

input   [2:0]                                  hash_channel_bits;         // number of channel bits in the address (1,2,4,8,16 channels)
input   [2:0]                                  hash_bank_bits;            // number of banks bits in the address (1,2,4,8,16 banks)
input   [2:0]                                  hash_channel_xor_count;    // number of XORs into channel bits
input   [2:0]                                  hash_bank_xor_count;       // number of XORs into bank bits

input                                          sclk;                      
input                                          srst;                      

input                                          iRTS;                      
output                                         oRTR;                      
input   [PASSTHRU_WIDTH-1:0]                   pass_thru_data_in;         //pass through data bus, pipelined PIPE_STAGES and enabled by (<pipe_stage_enable> & ~stall)

output                                         oRTS;                      
input                                          iRTR;                      
output  [PASSTHRU_WIDTH-1:0]                   pass_thru_data_out;        

output  [LPARAM_MEM_ADDR_WIDTH-1: 0]           address;                   
output                                          busy;
input                                          input_en;
output                                         output_en;

localparam TOTAL_PAD_STAGES = RO+PAD_STAGES;
localparam PIPE_STAGES = RI + CALC_STAGES + TOTAL_PAD_STAGES;
wire [PIPE_STAGES-1:0] en_stage;

addrlib_px_stage_gc #(.COLLAPSIBLE(COLLAPSABLE_PIPE_STAGE), .WIDTH(PASSTHRU_WIDTH), .DEPTH(PIPE_STAGES))
    px_stage(
			  // Outputs
			  .oRTR			(oRTR),
			  .oRTS			(oRTS),
			  .oDATA		(pass_thru_data_out[PASSTHRU_WIDTH-1:0]),
			  .pipe_stage_en (en_stage[PIPE_STAGES-1:0]),
			  .busy 		(busy),
			  // Inputs
			  .iCLK			(sclk),
			  .iRESET		(srst),
			  .iRTS			(iRTS),
			  .iDATA		(pass_thru_data_in[PASSTHRU_WIDTH-1:0]),
			  .iRTR			(iRTR)
              ,.i_en        (input_en)
              ,.o_en        (output_en)
        );

logic [LPARAM_MEM_ADDR_WIDTH-1: 0]            result, new_result;

logic    [LOG2_MAX_X-1:0]                     h0_x, x_in;
logic    [LOG2_MAX_Y-1:0]                     h0_y, y_in;
logic    [LOG2_MAX_Z-1:0]                     h0_z, z_in;
logic    [ 2: 0]                              h0_s, s_in;
logic    [LPARAM_MEM_ADDR_BASE_WIDTH-8-1: 0]  h0_baseAddr256B, baseAddr256B_in;
logic    [ 2: 0]                              h0_log2_pixelsize, log2_pixelsize_in;
logic    [ 1: 0]                              h0_log2_samples, log2_samples_in;
logic    [PITCH_TILE_MAX_SIZE-1:0]            h0_pitch_tile_max, pitch_tile_max_in;
logic    [SLICE_TILE_MAX_SIZE-1:0]            h0_slice_tile_max, slice_tile_max_in;
logic    [ 3: 0]                              h0_array_mode, array_mode_in;
logic    [ 2: 0]                              h0_tile_split, tile_split_in;
logic    [ 1: 0]                              h0_bank_width, bank_width_in;
logic    [ 1: 0]                              h0_bank_height, bank_height_in;
logic    [ 1: 0]                              h0_macro_tile_aspect, macro_tile_aspect_in;
logic    [ 1: 0]                              h0_num_banks, num_banks_in;
logic    [ 2: 0]                              h0_pipe_interleave_size, pipe_interleave_size_in;
logic    [ 2: 0]                              h0_micro_tile_mode, micro_tile_mode_in;
logic    [ 4: 0]                              h0_pipe_config, pipe_config_in;
logic                                         h0_hash_enable, hash_enable_in;
logic    [2:0]                                h0_hash_channel_bits, hash_channel_bits_in;
logic    [2:0]                                h0_hash_bank_bits, hash_bank_bits_in;
logic    [2:0]                                h0_hash_channel_xor_count, hash_channel_xor_count_in;
logic    [2:0]                                h0_hash_bank_xor_count, hash_bank_xor_count_in;

always @(posedge sclk)
  begin
     if(en_stage[0])
        begin
          h0_x <= x;
          h0_y <= y;
          h0_z <= z;
          h0_s <= s;
          h0_baseAddr256B <= baseAddr256B;
          h0_log2_pixelsize <= log2_pixelsize;
          h0_log2_samples <= log2_samples;
          h0_pitch_tile_max <= pitch_tile_max;
          h0_slice_tile_max <= slice_tile_max;
          h0_array_mode <= array_mode;
          h0_tile_split <= tile_split;
          h0_bank_width <= bank_width;
          h0_bank_height <= bank_height;
          h0_macro_tile_aspect <= macro_tile_aspect;
	      h0_num_banks <= num_banks;
          h0_pipe_interleave_size <= pipe_interleave_size;
          h0_micro_tile_mode <= micro_tile_mode;
          h0_pipe_config <= pipe_config;
          h0_hash_enable <= hash_enable;
          h0_hash_channel_bits          <= hash_channel_bits;
          h0_hash_bank_bits             <= hash_bank_bits;
          h0_hash_channel_xor_count     <= hash_channel_xor_count;
          h0_hash_bank_xor_count        <= hash_bank_xor_count;
        end
  end


assign x_in                      = (RI)? h0_x : x;                                              
assign y_in                      = (RI)? h0_y : y;                                              
assign z_in                      = (RI)? h0_z : z;                                              
assign s_in                      = (RI)? h0_s : s;                                              
assign baseAddr256B_in           = (RI)? h0_baseAddr256B : baseAddr256B;                        
assign log2_pixelsize_in         = (RI)? h0_log2_pixelsize : log2_pixelsize;                    
assign log2_samples_in           = (RI)? h0_log2_samples : log2_samples;                        
assign pitch_tile_max_in         = (RI)? h0_pitch_tile_max : pitch_tile_max;                    
assign slice_tile_max_in         = (RI)? h0_slice_tile_max : slice_tile_max;                    
assign array_mode_in             = (RI)? h0_array_mode : array_mode;                            
assign tile_split_in             = (RI)? h0_tile_split : tile_split;                            
assign bank_width_in             = (RI)? h0_bank_width : bank_width;                            
assign bank_height_in            = (RI)? h0_bank_height : bank_height;                          
assign macro_tile_aspect_in      = (RI)? h0_macro_tile_aspect : macro_tile_aspect;              
assign num_banks_in              = (RI)? h0_num_banks : num_banks;                              
assign pipe_interleave_size_in   = (RI)? h0_pipe_interleave_size : pipe_interleave_size;        
assign micro_tile_mode_in        = (RI)? h0_micro_tile_mode : micro_tile_mode;                  
assign pipe_config_in            = (RI)? h0_pipe_config : pipe_config;                          
assign hash_enable_in            = (RI)? h0_hash_enable : hash_enable;                          
assign hash_channel_bits_in      = (RI)? h0_hash_channel_bits          : hash_channel_bits;     
assign hash_bank_bits_in         = (RI)? h0_hash_bank_bits             : hash_bank_bits;        
assign hash_channel_xor_count_in = (RI)? h0_hash_channel_xor_count     : hash_channel_xor_count;
assign hash_bank_xor_count_in    = (RI)? h0_hash_bank_xor_count        : hash_bank_xor_count;   

function_generic_addr_calc_gc  #(LPARAM_MEM_ADDR_WIDTH, LPARAM_MEM_ADDR_BASE_WIDTH, LPARAM_MEM_ADDR_OFFSET_WIDTH, LOG2_MAX_X, LOG2_MAX_Y, LOG2_MAX_Z, PITCH_TILE_MAX_SIZE, SLICE_TILE_MAX_SIZE) u0_function_generic_addr_calc_tc(
                                     //outputs
                                     .address(result),
                                     //inputs
                                     .x(x_in),
                                     .y(y_in),
                                     .z(z_in),
                                     .s(s_in),
                                     .baseAddr256B(baseAddr256B_in),
                                     .log2_pixelsize(log2_pixelsize_in),
                                     .log2_samples(log2_samples_in),
                                     .pitch_tile_max(pitch_tile_max_in),
                                     .slice_tile_max(slice_tile_max_in),
                                     .micro_tile_mode(micro_tile_mode_in),
                                     .array_mode(array_mode_in),
                                     .tile_split(tile_split_in),
                                     .bank_width(bank_width_in),
                                     .bank_height(bank_height_in),
                                     .macro_tile_aspect(macro_tile_aspect_in),
                                     .bank_tiling(num_banks_in),
                                     .pipe_interleave_size(pipe_interleave_size_in),
                                     .pipe_config(pipe_config_in),
                                     .sclk(sclk),
                                     .h1_reg_en(en_stage[RI]),
                                     .h2_reg_en(en_stage[RI+1])
                                     );

//RFC: new added for tc only
//i did not add it to function core module as it affects tc only
//add two pipe stage
logic       h1_hash_enable;
logic       h2_hash_enable;
logic [2:0] h1_hash_channel_bits;
logic [2:0] h1_hash_bank_bits;
logic [2:0] h1_hash_channel_xor_count;
logic [2:0] h1_hash_bank_xor_count;

logic [2:0] h2_hash_channel_bits;
logic [2:0] h2_hash_bank_bits;
logic [2:0] h2_hash_channel_xor_count;
logic [2:0] h2_hash_bank_xor_count;

always @(posedge sclk) begin
  if(en_stage[RI]) begin
    h1_hash_enable                <= hash_enable_in;
    h1_hash_channel_bits          <= hash_channel_bits_in;
    h1_hash_bank_bits             <= hash_bank_bits_in;
    h1_hash_channel_xor_count     <= hash_channel_xor_count_in;
    h1_hash_bank_xor_count        <= hash_bank_xor_count_in;
  end
end

always @(posedge sclk) begin
  if(en_stage[RI+1]) begin
    h2_hash_enable <= h1_hash_enable;
    h2_hash_channel_bits          <= h1_hash_channel_bits;
    h2_hash_bank_bits             <= h1_hash_bank_bits;
    h2_hash_channel_xor_count     <= h1_hash_channel_xor_count;
    h2_hash_bank_xor_count        <= h1_hash_bank_xor_count;
  end
end

//"address" is passthrough if 'hash_enable' = 0
al_channel_bank_hash_gc #(.LPARAM_MEM_ADDR_WIDTH(LPARAM_MEM_ADDR_WIDTH)) channel_bank_hash(
				       // Outputs
				       .address_out	            (new_result[LPARAM_MEM_ADDR_WIDTH-1:0]),
				       // Inputs
				       .hash_enable	            (h2_hash_enable),
				       .hash_channel_bits       (h2_hash_channel_bits[2:0]),
				       .hash_bank_bits	        (h2_hash_bank_bits[2:0]),
				       .hash_channel_xor_count  (h2_hash_channel_xor_count[2:0]),
				       .hash_bank_xor_count     (h2_hash_bank_xor_count[2:0]),
				       .address_in	            (result[LPARAM_MEM_ADDR_WIDTH-1:0])
                       );

logic [LPARAM_MEM_ADDR_WIDTH-1: 0]  address_out_stages[TOTAL_PAD_STAGES:0];
int i;
always @(posedge sclk)
begin 
      for(i=0;i<TOTAL_PAD_STAGES;i=i+1) begin
        if(en_stage[RI+CALC_STAGES+i]) 
            if(i==0)    address_out_stages[i+1] <= new_result;
            else        address_out_stages[i+1] <= address_out_stages[i];
      end
end
localparam INSERT_PAD_STAGES = (TOTAL_PAD_STAGES > 'd0);

assign address = (INSERT_PAD_STAGES)? address_out_stages[TOTAL_PAD_STAGES] : new_result;

`include "generic_addr_calc2_riro_tc_fcov_gc.svh"

`ifdef ADDRESS__ADDRLIB_REPLAY_DEBUG__1
    addr_calc_replay_bc_gc #(  .HASH(1), //this is only for printing
                            .LPARAM_MEM_ADDR_BASE_WIDTH(LPARAM_MEM_ADDR_BASE_WIDTH), 
                            .LOG2_MAX_X(LOG2_MAX_X),.LOG2_MAX_Y(LOG2_MAX_Y), .LOG2_MAX_Z(LOG2_MAX_Z), 
                            .PITCH_TILE_MAX_SIZE(PITCH_TILE_MAX_SIZE), .SLICE_TILE_MAX_SIZE(SLICE_TILE_MAX_SIZE)
                          ) 
        replay (.*);
`endif

endmodule



