module gfx_cgts_local_cntl_cov
	(
	 // Inputs to cgts_local_cntl
     `ifdef GPU__GC__CGTS_BYPASS__1
     iCGTS_core_clk_en,iCGTS_vbus_clk_en,cgts_cntl_in,
     `endif
     simdbusy_soft_override, ls_soft_override, cg_soft_override, busy_override, ls_override, override, ls_override_in, override_in,  gated_iclk, iclk,resetb
	 );
//////////////////////////
`ifdef GPU__GC__CGTS_BYPASS__1
input iCGTS_core_clk_en;
input iCGTS_vbus_clk_en;
input [3:0] cgts_cntl_in;
`endif

input           simdbusy_soft_override;
input           ls_soft_override;
input           cg_soft_override;
input [1:0]     busy_override;
input           ls_override;
input			override;
input           ls_override_in;
input			override_in;
input           gated_iclk;
input           iclk;
input resetb;

//////////////////////////

//VCS coverage exclude_module
`ifdef VCS

 `ifdef GFX_CG_W2E
reg enable;
initial begin
  if($test$plusargs("cgt_assert_disable"))
    enable = 1'b0;
  else
    enable = 1'b1;
end

reg hier_enable;
string Hier;
initial begin
  hier_enable = 1'b1;

  $sformat(Hier, "%m");

  if($test$plusargs({Hier,"__cgt_assert_hier_disable"}))
  begin
    hier_enable = 1'b0;
    `MSGIO_DISPLAY("%m:cg cgts_local_cntl_cov assertion is waived via hierarchy");
  end
for(integer i=0;i<Hier.len();i++) 
  begin 
    if((Hier.substr(i,i+2)=="acv") || (Hier.substr(i,i+2)=="sqc"))      
	begin 
           hier_enable=1'b0; 
           `MSGIO_DISPLAY("%m: WARNING: cg acv cgts_local_cntl_cov assertion is waived via hierarchy");
           break; 
    end
  end

end

reg cgt_en_assert_enable;
initial begin
  if($test$plusargs("cgt_en_assert_disable"))
    cgt_en_assert_enable = 1'b0;
  else
    cgt_en_assert_enable = 1'b1;
end

reg CGTS_Coverage_enable;
initial begin
  if($test$plusargs("CGTS_Coverage_assert_enable"))
    CGTS_Coverage_enable = 1'b1;
  else
    CGTS_Coverage_enable = 1'b0;  
end

final if((busy_override != 2'b10) && CGTS_Coverage_enable && hier_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE CGTS Coverage: Busy Override never deactivated");

reg CGTS_OV_Coverage_enable0;
initial begin
  if($test$plusargs("CGTS_OV_Coverage_assert_enable0"))
    CGTS_OV_Coverage_enable0 = 1'b1;
  else
    CGTS_OV_Coverage_enable0 = 1'b0;  
end

final if( ((ls_override != 1'b0) || (override != 1'b0)) &&  CGTS_OV_Coverage_enable0 && hier_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE CGTS OV Coverage: Override and LS_Override not 0");

reg CGTS_OV_Coverage_enable1;
initial begin
  if($test$plusargs("CGTS_OV_Coverage_assert_enable1"))
    CGTS_OV_Coverage_enable1 = 1'b1;
  else
    CGTS_OV_Coverage_enable1 = 1'b0;  
end

final if( ((ls_override != 1'b1) || (override != 1'b1)) &&  CGTS_OV_Coverage_enable1 && hier_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE CGTS OV Coverage: Override and LS_Override not 1");

reg CGTS_SOFTOV_Coverage_enable;
initial begin
  if($test$plusargs("CGTS_SOFTOV_Coverage_assert_enable"))
    CGTS_SOFTOV_Coverage_enable = 1'b1;
  else
    CGTS_SOFTOV_Coverage_enable = 1'b0;  
end

final if( (cg_soft_override != 1'b1) &&  CGTS_SOFTOV_Coverage_enable && hier_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE CGTS SOFTOV Coverage: cg_soft_override not 1");

reg CGTS_LSSOFTOV_Coverage_enable;
initial begin
  if($test$plusargs("CGTS_LSSOFTOV_Coverage_assert_enable"))
    CGTS_LSSOFTOV_Coverage_enable = 1'b1;
  else
    CGTS_LSSOFTOV_Coverage_enable = 1'b0;  
end

final if( (ls_soft_override != 1'b1) &&  CGTS_LSSOFTOV_Coverage_enable && hier_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE CGTS LSSOFTOV Coverage: ls_soft_override not 1");

reg CGTS_SIMDOV_Coverage_enable;
initial begin
  if($test$plusargs("CGTS_SIMDOV_Coverage_assert_enable"))
    CGTS_SIMDOV_Coverage_enable = 1'b1;
  else
    CGTS_SIMDOV_Coverage_enable = 1'b0;  
end

final if( (simdbusy_soft_override != 1'b1) &&  CGTS_SIMDOV_Coverage_enable && hier_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE CGTS SIMDOV Coverage: simdbusy_soft_override not 1");


reg simdbusy_soft_override_disabled;
initial simdbusy_soft_override_disabled = 1'b0;
always @(posedge iclk) if(simdbusy_soft_override == 1'b0) simdbusy_soft_override_disabled <= 1'b1;
final if((simdbusy_soft_override_disabled == 1'b0) && enable && cgt_en_assert_enable && hier_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE Simdbusy_soft_override never deactivated");

reg ls_soft_override_disabled;
initial ls_soft_override_disabled = 1'b0;
always @(posedge iclk) if(ls_soft_override == 1'b0) ls_soft_override_disabled <= 1'b1;
final if((ls_soft_override_disabled == 1'b0) && enable && cgt_en_assert_enable && hier_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE Ls_soft_override never deactivated");

reg cg_soft_override_disabled;
initial cg_soft_override_disabled = 1'b0;
always @(posedge iclk) if(cg_soft_override == 1'b0) cg_soft_override_disabled <= 1'b1;
final if((cg_soft_override_disabled == 1'b0) && enable && cgt_en_assert_enable && hier_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE Cg_soft_override never deactivated");

reg busy0_override_disabled;
initial busy0_override_disabled = 1'b0;
always @(posedge iclk) if(busy_override[0] == 1'b0) busy0_override_disabled <= 1'b1;
final if((busy0_override_disabled == 1'b0) && enable && cgt_en_assert_enable && hier_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE Busy_override[0] never deactivated");

reg busy1_override_disabled;
initial busy1_override_disabled = 1'b0;
always @(posedge iclk) if(busy_override[1] == 1'b0) busy1_override_disabled <= 1'b1;
final if((busy1_override_disabled == 1'b0) && enable && cgt_en_assert_enable && hier_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE Busy_override[1] never deactivated");

`ifdef GPU__GC__CGTS_BYPASS__1
//add for CGTS bypass feature, bypass and chain mode cannot toggle at the same time
reg cgts_bypass_assert_enable;
initial begin
  if($test$plusargs("cgts_bypass_assert_enable"))
    cgts_bypass_assert_enable = 1'b1;
  else
    cgts_bypass_assert_enable = 1'b0;
end

reg cgts_chain_assert_enable;
initial begin
  if($test$plusargs("cgts_chain_assert_enable"))
    cgts_chain_assert_enable = 1'b1;
  else
    cgts_chain_assert_enable = 1'b0;
end

//wire cgts_bypass_clk_en = iCGTS_core_clk_en | iCGTS_vbus_clk_en; 
wire cgts_bypass_clk_en = iCGTS_core_clk_en; 
reg cgts_bypass_clk_en_1d =0;
reg cgts_bypass_clk_en_tgl =0;
reg [3:0] cgts_cntl_in_1d =0;
reg cgts_cntl_in_tgl = 0;

always @(posedge iclk) begin
   cgts_bypass_clk_en_1d <= cgts_bypass_clk_en;
   cgts_cntl_in_1d[3:0] <= cgts_cntl_in[3:0];
end

//for cgts_bypass test, skip the initial ucode program sm_ctrl_reg period
wire cgts_init_skip = (simdbusy_soft_override | ls_soft_override | cg_soft_override | busy_override | ls_override | override | ls_override_in | override_in); 
reg [31:0] cgts_init_skip_cnt = 0;
always @(posedge iclk) begin
if (~resetb) 
    cgts_init_skip_cnt <= 0;
else if ((~cgts_init_skip) & (cgts_init_skip_cnt < 1500))
        cgts_init_skip_cnt <= cgts_init_skip_cnt + 1; 
end
wire cgts_init_assert_enable_skip = (cgts_init_skip_cnt == 1500);

always @(posedge iclk) 
if (~resetb) begin
   cgts_bypass_clk_en_tgl <= 0;
   cgts_cntl_in_tgl <= 0;
end
else if(cgts_init_assert_enable_skip) begin
    cgts_bypass_clk_en_tgl <= (cgts_bypass_clk_en_tgl | (cgts_bypass_clk_en_1d != cgts_bypass_clk_en));
    cgts_cntl_in_tgl <= (cgts_cntl_in_tgl | (cgts_cntl_in_1d[3:0] != cgts_cntl_in[3:0]));
end

cgts_bypass_conflict_chk : assert property (@(negedge iclk) disable iff((~cgt_en_assert_enable) | (~hier_enable) | (~cgts_bypass_clk_en_tgl) | (~cgts_bypass_assert_enable)) ( cgts_bypass_clk_en |->  (cgts_cntl_in_1d[3:0] === cgts_cntl_in[3:0])));
final if(cgts_bypass_assert_enable & cgts_cntl_in_tgl & hier_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE CGTS bypass mode, but cgts_cntl_en toggled");
final if(cgts_bypass_assert_enable & (~cgts_bypass_clk_en_tgl) & hier_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE CGTS bypass mode, but cgts_bypass_clk_en never toggled");
final if(cgts_chain_assert_enable & cgts_bypass_clk_en_tgl & hier_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE CGTS chain mode, but cgts_bypass_clk_en toggled");
final if(cgts_chain_assert_enable & (~cgts_cntl_in_tgl) & hier_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE CGTS chain mode, but cgts_cntl_en never toggled");

`endif //`ifdef GPU__GC__CGTS_BYPASS__1

reg cgts_mgcg_assert_enable;
initial begin
  if($test$plusargs("cgts_mgcg_assert_enable"))
    cgts_mgcg_assert_enable = 1'b1;
  else
    cgts_mgcg_assert_enable = 1'b0;
end

reg[64]    iclk_count;
reg[64]    gated_iclk_count;

always @(posedge iclk)
begin
  if(~resetb) 
	iclk_count <= 0;
  else 
    iclk_count <= iclk_count + 1;
end

always @(posedge gated_iclk)
begin
  if(~resetb) 
    gated_iclk_count  <= 0;
  else 
	gated_iclk_count  <= gated_iclk_count + 1;
end
final if((gated_iclk_count >= iclk_count) && cgt_en_assert_enable && hier_enable && cgts_mgcg_assert_enable) `MSGIO_DISPLAY("%m ERROR: cgts mgcg never happened, gated_iclk_count less than iclk_count,");

//added for CGTS MGCG
wire ls_override_tgl;
wire override_tgl; 
assign ls_override_tgl = ls_override_in ^ ls_override;
assign override_tgl    = override_in ^ override;

cgts_mgcg_ov_tgl_chk : assert property (@(negedge iclk) disable iff((~cgt_en_assert_enable) | (~hier_enable) | (~cgts_mgcg_assert_enable)) ((ls_override_tgl | override_tgl) |-> ##[3:30] gated_iclk));
cgts_mgcg_cntl_in_chk : assert property (@(negedge iclk) disable iff((~cgt_en_assert_enable) | (~hier_enable) | (~cgts_mgcg_assert_enable)) ((cgts_cntl_in[3:0] != 4'd8) |-> ##2 gated_iclk));

`endif //`ifdef GFX_CG_W2E

`ifdef GFX_CG_SIGNALS_DUMP_EN
initial 
begin
	#1;
   `ifdef GC__SOC_ENV__1 
     `ifdef GC__FLAVOR__APU 
	$fmonitor(sys.cg_file_handle, "CG CGTS_RST:(%t) %m %b",$time,resetb);
      `else
	$fmonitor(tb.cg_file_handle, "CG CGTS_RST:(%t) %m %b",$time,resetb);
      `endif
    `else
	$fmonitor(tb.cg_file_handle, "CG CGTS_RST:(%t) %m %b",$time,resetb);
    `endif
end

`endif

`else // !`ifdef VCS

initial begin
  $display("%m at %0t: ld/src/misc/cgts_local_cntl_cov.sv: SVA not yet supported in NCSIM in wekiva scripts", $realtime);
end

`endif // VCS

endmodule // gfx_cgts_local_cntl_cov


