`timescale 1ps/1ps

`include "gc_features.vh"

module gfx_cgtt_local_dft(/*AUTOARG*/
   // Outputs
   oclk,
   // Inputs
   Cpl_GFXCLK, core_busy, dft_clk_gate_ctrl, dft_shift_clk
   );

//////////////////////////
//in/outs
//////////////////////////
 input        Cpl_GFXCLK;
 input        core_busy;
 input  [1:0] dft_clk_gate_ctrl;
 input        dft_shift_clk;

 output       oclk;

reg         n0scan_oCpl_GFXCLK_en;
reg	[1:0]		n0scan_dft_clk_gate_ctrl_d1;
always @(posedge Cpl_GFXCLK) begin
	n0scan_dft_clk_gate_ctrl_d1 <= dft_clk_gate_ctrl;
	n0scan_oCpl_GFXCLK_en <= (core_busy && ~n0scan_dft_clk_gate_ctrl_d1[1]) | n0scan_dft_clk_gate_ctrl_d1[0];
end

ati_clock_gate u_static_oclk(
    .clk_out (oclk),
    .clk_src (Cpl_GFXCLK),
    .clk_en  (n0scan_oCpl_GFXCLK_en),
    .TE      (dft_shift_clk)
   );

endmodule
