//graphics debug client ORing common module
//this module inputs two daisychain data, ORed together, and outputs one daisychain data.
//            inputs one daisychain ctrl, duplicated, and outputs two daisychain ctrl

module gfx_dbg_client_oring #(parameter WIDTH = 32) (

input                   Cpl_GFXCLK               , // system clock
input                   Dft_Clk_Gater_Aon,
input                   Dft_Clk_Gater_En,
input                   dft_shift_clk,
input                   TEST_CLK_EN              , // Gater override for test mode

input       [WIDTH-1:0] DBUS_TARG_daisychain0_data, // Daisy-chain input0
output wire     [1:0]       DBUS_TARG_daisychain0_ctl , // Daisy-chain program output0, reverse of data flow

input       [WIDTH-1:0] DBUS_TARG_daisychain1_data, // Daisy-chain input1
output reg     [1:0]       DBUS_TARG_daisychain1_ctl , // Daisy-chain program output1, reverse of data flow

output wire [WIDTH-1:0] TARG_DBUS_daisychain_data, // Daisy-chain output
input       [1:0]       TARG_DBUS_daisychain_ctl   // Daisy-chain program input,  reverse of data flow
);

 wire          Cpl_GFXCLK_int;


gfx_cgtt_local_dft dbg_client_oring_gfx_cgtt_local_dft (
   .oclk (Cpl_GFXCLK_int),
   .Cpl_GFXCLK (Cpl_GFXCLK),
   .core_busy(1'b1),
   .dft_clk_gate_ctrl({Dft_Clk_Gater_En,Dft_Clk_Gater_Aon}),
   .dft_shift_clk (dft_shift_clk)
    );

  reg  [WIDTH-1:0]      daisychain_data_d1;
  assign                TARG_DBUS_daisychain_data[WIDTH-1:0] = daisychain_data_d1[WIDTH-1:0];

  wire                  gclk;
  wire                  dbg_active;
  dbg_client_sync_aon_gclk I_dbg_active (
                                        .ipclk                    (Cpl_GFXCLK_int                   ),
                                        .dbg_active               (dbg_active                   ),
                                        .daisychain_ctl_d1        (DBUS_TARG_daisychain0_ctl[1:0]),
                                        .TARG_DBUS_daisychain_ctl (TARG_DBUS_daisychain_ctl[1:0])
                                        );

  gfx_cgtt_local_dft I_gclk (
    .oclk(gclk),
    .Cpl_GFXCLK(Cpl_GFXCLK),
    .core_busy(dbg_active),
    .dft_shift_clk(dft_shift_clk),
    .dft_clk_gate_ctrl({Dft_Clk_Gater_En,Dft_Clk_Gater_Aon})
  );

  always @(posedge gclk) daisychain_data_d1[WIDTH-1:0] <= DBUS_TARG_daisychain0_data[WIDTH-1:0] | DBUS_TARG_daisychain1_data[WIDTH-1:0];

  always @(posedge Cpl_GFXCLK_int) DBUS_TARG_daisychain1_ctl[1:0] <= TARG_DBUS_daisychain_ctl[1:0];

endmodule // gfx_dbg_client_oring
