//
//graphics debug client retimer common module
//that instances the dbg_client_sync_aon_retimer and the gfx_cgtt_local_dft
//

module gfx_dbg_client_retimer_wrapper (

input                   ipclk                    , // system clock
input                   Dft_Clk_Gater_Aon,
input                   Dft_Clk_Gater_En,
input                   dft_shift_clk,
input                   TEST_CLK_EN              , // Gater override for test mode

input       [(4*8-1) :0] DBUS_TARG_daisychain_data, // Daisy-chain input
output wire [1:0]       DBUS_TARG_daisychain_ctl , // Daisy-chain program output, reverse of data flow

output wire [(4*8-1) :0] TARG_DBUS_daisychain_data, // Daisy-chain output
input       [1:0]       TARG_DBUS_daisychain_ctl   // Daisy-chain program input,  reverse of data flow
);

 wire          Cpl_GFXCLK_int;


gfx_cgtt_local_dft dbg_client_retimer_wrapper_gfx_cgtt_local_dft (
   .oclk (Cpl_GFXCLK_int),
   .Cpl_GFXCLK (ipclk), 
   .core_busy(1'b1),
   .dft_clk_gate_ctrl ({Dft_Clk_Gater_En,Dft_Clk_Gater_Aon}), 
   .dft_shift_clk (dft_shift_clk)
    );

dbg_client_sync_aon_retimer u_dbg_client_sync_aon_retimer(
        .ipclk(Cpl_GFXCLK_int),               
        .TEST_CLK_EN(TEST_CLK_EN),          
        .DBUS_TARG_daisychain_data(DBUS_TARG_daisychain_data),
        .DBUS_TARG_daisychain_ctl(DBUS_TARG_daisychain_ctl), 
        .TARG_DBUS_daisychain_data(TARG_DBUS_daisychain_data),
        .TARG_DBUS_daisychain_ctl(TARG_DBUS_daisychain_ctl)
        );


endmodule // gfx_dbg_client_retimer_wrapper
