module gfx_pgfsm_assert 
       (
        input         iclk,
        input         reset,
        input         PGFSM_disable_strap,
        input         PGFSM_SD_next_daisy_status,
        input         PGFSM_tile_hard_resetb,
        input         PGFSM_tile_cold_resetb,
        input         PGFSM_tile_local_address,
        input         PGFSM_in_MEM_PD_power_ctrl,
        input         PGFSM_DFT_tdr_tdi,
        input         PGFSM_DFT_tdr_tresetb,
        input         PGFSM_DFT_tdr_shift,
        input         PGFSM_DFT_tdr_capture,
        input         PGFSM_DFT_tdr_update,
        input         TEST_CLK_EN,
        input         PGFSM_CGLS_override,
        input         PGFSM_SD_prev_daisy_status,
        input         PGFSM_PD_scan_iso_clampn,
        input         PGFSM_MEM_PD_power_ctrl,
        input         PGFSM_DFT_tdr_tdo,
        input         PGFSM_DFT_tdr_en,

        input         PGFSM_sel,
        input         PGFSM_new_cmd,
        input [31:0]  PGFSM_cmd,
        input         PGFSM_PD_resetb,
        input         PGFSM_PD_iso_clampn,
        input         PGFSM_PD_mother_sleep,
        input         PGFSM_PD_daughter_sleep,
        input         PGFSM_cmd_done
       );
`ifdef ABV // {
`include "gfx_pgfsm_assert_control.vh"
`include "gfx_pgfsm_defines.h"
`include "gc_features.vh"

// assert property for check input legality
// Unknown check
// AUTOCODE START
property unkn_p1;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_disable_strap);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_1: assert property(unkn_p1) else `AMD_ASSERT_ERROR("unknown_chk_1", $psprintf("%m fails! PGFSM_disable_strap is unknown"));
`else
unknown_chk_1: assert property(unkn_p1) else `AMD_ASSERT_WARNING("unknown_chk_1", $psprintf("%m fails! PGFSM_disable_strap is unknown"));
`endif
property unkn_p4;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_SD_next_daisy_status);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_4: assert property(unkn_p4) else `AMD_ASSERT_ERROR("unknown_chk_4", $psprintf("%m fails! PGFSM_SD_next_daisy_status is unknown"));
`else
unknown_chk_4: assert property(unkn_p4) else `AMD_ASSERT_WARNING("unknown_chk_4", $psprintf("%m fails! PGFSM_SD_next_daisy_status is unknown"));
`endif
property unkn_p5;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_tile_hard_resetb);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_5: assert property(unkn_p5) else `AMD_ASSERT_ERROR("unknown_chk_5", $psprintf("%m fails! PGFSM_tile_~reset is unknown"));
`else
unknown_chk_5: assert property(unkn_p5) else `AMD_ASSERT_WARNING("unknown_chk_5", $psprintf("%m fails! PGFSM_tile_~reset is unknown"));
`endif
property unkn_p6;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_tile_cold_resetb);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_6: assert property(unkn_p6) else `AMD_ASSERT_ERROR("unknown_chk_6", $psprintf("%m fails! PGFSM_tile_cold_resetb is unknown"));
`else
unknown_chk_6: assert property(unkn_p6) else `AMD_ASSERT_WARNING("unknown_chk_6", $psprintf("%m fails! PGFSM_tile_cold_resetb is unknown"));
`endif
property unkn_p7;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_tile_local_address);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_7: assert property(unkn_p7) else `AMD_ASSERT_ERROR("unknown_chk_7", $psprintf("%m fails! PGFSM_tile_local_address is unknown"));
`else
unknown_chk_7: assert property(unkn_p7) else `AMD_ASSERT_WARNING("unknown_chk_7", $psprintf("%m fails! PGFSM_tile_local_address is unknown"));
`endif
property unkn_p8;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_in_MEM_PD_power_ctrl);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_8: assert property(unkn_p8) else `AMD_ASSERT_ERROR("unknown_chk_8", $psprintf("%m fails! PGFSM_in_MEM_PD_power_ctrl is unknown"));
`else
unknown_chk_8: assert property(unkn_p8) else `AMD_ASSERT_WARNING("unknown_chk_8", $psprintf("%m fails! PGFSM_in_MEM_PD_power_ctrl is unknown"));
`endif
property unkn_p9;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_DFT_tdr_tdi);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_9: assert property(unkn_p9) else `AMD_ASSERT_ERROR("unknown_chk_9", $psprintf("%m fails! PGFSM_DFT_tdr_tdi is unknown"));
`else
unknown_chk_9: assert property(unkn_p9) else `AMD_ASSERT_WARNING("unknown_chk_9", $psprintf("%m fails! PGFSM_DFT_tdr_tdi is unknown"));
`endif
property unkn_p10;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_DFT_tdr_tresetb);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_10: assert property(unkn_p10) else `AMD_ASSERT_ERROR("unknown_chk_10", $psprintf("%m fails! PGFSM_DFT_tdr_tresetb is unknown"));
`else
unknown_chk_10: assert property(unkn_p10) else `AMD_ASSERT_WARNING("unknown_chk_10", $psprintf("%m fails! PGFSM_DFT_tdr_tresetb is unknown"));
`endif
property unkn_p11;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_DFT_tdr_shift);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_11: assert property(unkn_p11) else `AMD_ASSERT_ERROR("unknown_chk_11", $psprintf("%m fails! PGFSM_DFT_tdr_shift is unknown"));
`else
unknown_chk_11: assert property(unkn_p11) else `AMD_ASSERT_WARNING("unknown_chk_11", $psprintf("%m fails! PGFSM_DFT_tdr_shift is unknown"));
`endif
property unkn_p12;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_DFT_tdr_capture);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_12: assert property(unkn_p12) else `AMD_ASSERT_ERROR("unknown_chk_12", $psprintf("%m fails! PGFSM_DFT_tdr_capture is unknown"));
`else
unknown_chk_12: assert property(unkn_p12) else `AMD_ASSERT_WARNING("unknown_chk_12", $psprintf("%m fails! PGFSM_DFT_tdr_capture is unknown"));
`endif
property unkn_p13;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_DFT_tdr_update);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_13: assert property(unkn_p13) else `AMD_ASSERT_ERROR("unknown_chk_13", $psprintf("%m fails! PGFSM_DFT_tdr_update is unknown"));
`else
unknown_chk_13: assert property(unkn_p13) else `AMD_ASSERT_WARNING("unknown_chk_13", $psprintf("%m fails! PGFSM_DFT_tdr_update is unknown"));
`endif
property unkn_p14;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(TEST_CLK_EN);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_14: assert property(unkn_p14) else `AMD_ASSERT_ERROR("unknown_chk_14", $psprintf("%m fails! TEST_CLK_EN is unknown"));
`else
unknown_chk_14: assert property(unkn_p14) else `AMD_ASSERT_WARNING("unknown_chk_14", $psprintf("%m fails! TEST_CLK_EN is unknown"));
`endif
property unkn_p15;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_sel);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_15: assert property(unkn_p15) else `AMD_ASSERT_ERROR("unknown_chk_15", $psprintf("%m fails! PGFSM_sel is unknown"));
`else
unknown_chk_15: assert property(unkn_p15) else `AMD_ASSERT_WARNING("unknown_chk_15", $psprintf("%m fails! PGFSM_sel is unknown"));
`endif
property unkn_p16;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_CGLS_override);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_16: assert property(unkn_p16) else `AMD_ASSERT_ERROR("unknown_chk_16", $psprintf("%m fails! PGFSM_CGLS_override is unknown"));
`else
unknown_chk_16: assert property(unkn_p16) else `AMD_ASSERT_WARNING("unknown_chk_16", $psprintf("%m fails! PGFSM_CGLS_override is unknown"));
`endif
property unkn_p17;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_SD_prev_daisy_status);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_17: assert property(unkn_p17) else `AMD_ASSERT_ERROR("unknown_chk_17", $psprintf("%m fails! PGFSM_SD_prev_daisy_status is unknown"));
`else
unknown_chk_17: assert property(unkn_p17) else `AMD_ASSERT_WARNING("unknown_chk_17", $psprintf("%m fails! PGFSM_SD_prev_daisy_status is unknown"));
`endif
property unkn_p18;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_cmd_done);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_18: assert property(unkn_p18) else `AMD_ASSERT_ERROR("unknown_chk_18", $psprintf("%m fails! PGFSM_cmd_done is unknown"));
`else
unknown_chk_18: assert property(unkn_p18) else `AMD_ASSERT_WARNING("unknown_chk_18", $psprintf("%m fails! PGFSM_cmd_done is unknown"));
`endif
property unkn_p19;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_PD_mother_sleep);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_19: assert property(unkn_p19) else `AMD_ASSERT_ERROR("unknown_chk_19", $psprintf("%m fails! PGFSM_PD_mother_sleep is unknown"));
`else
unknown_chk_19: assert property(unkn_p19) else `AMD_ASSERT_WARNING("unknown_chk_19", $psprintf("%m fails! PGFSM_PD_mother_sleep is unknown"));
`endif
property unkn_p20;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_PD_daughter_sleep);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_20: assert property(unkn_p20) else `AMD_ASSERT_ERROR("unknown_chk_20", $psprintf("%m fails! PGFSM_PD_daughter_sleep is unknown"));
`else
unknown_chk_20: assert property(unkn_p20) else `AMD_ASSERT_WARNING("unknown_chk_20", $psprintf("%m fails! PGFSM_PD_daughter_sleep is unknown"));
`endif
property unkn_p21;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_PD_iso_clampn);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_21: assert property(unkn_p21) else `AMD_ASSERT_ERROR("unknown_chk_21", $psprintf("%m fails! PGFSM_PD_iso_clampn is unknown"));
`else
unknown_chk_21: assert property(unkn_p21) else `AMD_ASSERT_WARNING("unknown_chk_21", $psprintf("%m fails! PGFSM_PD_iso_clampn is unknown"));
`endif
property unkn_p22;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_PD_scan_iso_clampn);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_22: assert property(unkn_p22) else `AMD_ASSERT_ERROR("unknown_chk_22", $psprintf("%m fails! PGFSM_PD_scan_iso_clampn is unknown"));
`else
unknown_chk_22: assert property(unkn_p22) else `AMD_ASSERT_WARNING("unknown_chk_22", $psprintf("%m fails! PGFSM_PD_scan_iso_clampn is unknown"));
`endif
property unkn_p23;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_PD_resetb);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_23: assert property(unkn_p23) else `AMD_ASSERT_ERROR("unknown_chk_23", $psprintf("%m fails! PGFSM_PD_resetb is unknown"));
`else
unknown_chk_23: assert property(unkn_p23) else `AMD_ASSERT_WARNING("unknown_chk_23", $psprintf("%m fails! PGFSM_PD_resetb is unknown"));
`endif
property unkn_p24;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(PGFSM_MEM_PD_power_ctrl);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_24: assert property(unkn_p24) else `AMD_ASSERT_ERROR("unknown_chk_24", $psprintf("%m fails! PGFSM_MEM_PD_power_ctrl is unknown"));
`else
unknown_chk_24: assert property(unkn_p24) else `AMD_ASSERT_WARNING("unknown_chk_24", $psprintf("%m fails! PGFSM_MEM_PD_power_ctrl is unknown"));
`endif
property unkn_p25;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  (~reset & PGFSM_DFT_tdr_en) |-> not $isunknown(PGFSM_DFT_tdr_tdo);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_25: assert property(unkn_p25) else `AMD_ASSERT_ERROR("unknown_chk_25", $psprintf("%m fails! PGFSM_DFT_tdr_tdo is unknown"));
`else
unknown_chk_25: assert property(unkn_p25) else `AMD_ASSERT_WARNING("unknown_chk_25", $psprintf("%m fails! PGFSM_DFT_tdr_tdo is unknown"));
`endif
property unkn_p26;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  ~reset |-> not $isunknown(TEST_CLK_EN);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
unknown_chk_26: assert property(unkn_p26) else `AMD_ASSERT_ERROR("unknown_chk_26", $psprintf("%m fails! TEST_CLK_EN is unknown"));
`else
unknown_chk_26: assert property(unkn_p26) else `AMD_ASSERT_WARNING("unknown_chk_26", $psprintf("%m fails! TEST_CLK_EN is unknown"));
`endif

// AUTOCODE FINISH

// 1. When PGFSM is disabled, should not select pgfsm
property pi00;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  PGFSM_disable_strap |-> (~PGFSM_sel | PGFSM_cmd[12] | PGFSM_cmd[11]);
endproperty
`ifdef GFX_PGFSM__PGFSM_W2E__1
PGFSM_sel_chk: assert property(pi00) else `AMD_ASSERT_ERROR("PGFSM_sel_chk", $psprintf("%m fails! Should not select pgfsm when PGFSM is disabled"));
`else 
PGFSM_sel_chk: assert property(pi00) else `AMD_ASSERT_WARNING("PGFSM_sel_chk", $psprintf("%m fails! Should not select pgfsm when PGFSM is disabled"));
`endif

property pw00;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  PGFSM_disable_strap |-> ~(PGFSM_sel & PGFSM_cmd[12]);
endproperty
//PGFSM_dis_write: assert property(pw00) else $warning("%m fails! Should not write pgfsm when PGFSM is disabled");
always @(posedge iclk) begin
  if (PGFSM_disable_strap & (PGFSM_sel & PGFSM_cmd[12]))
    $display("Warning: should not send write command to PGFSM when PGFSM_disable_strap is asserted!");
end

// 2. Check the pgfsm command legality
property pi10;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  (~reset & PGFSM_new_cmd) |-> (not $isunknown(PGFSM_cmd));
endproperty
property pi11;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  PGFSM_new_cmd |-> ~(PGFSM_cmd[`GFX_PGFSM_CMD_PWRDN] & PGFSM_cmd[`GFX_PGFSM_CMD_PWRUP]);
endproperty
property pi12;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  PGFSM_new_cmd |-> ~(PGFSM_cmd[`GFX_PGFSM_CMD_WRITE] & PGFSM_cmd[`GFX_PGFSM_CMD_READ]);
endproperty
property pi13;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  PGFSM_new_cmd |-> ~(PGFSM_cmd[`GFX_PGFSM_CMD_BPM_ADDR]);
endproperty

`ifdef GFX_PGFSM__PGFSM_W2E__1
PGFSM_cmd_chk: assert property(pi10) else `AMD_ASSERT_ERROR("PGFSM_cmd_chk", $psprintf("%m fails! PGFSM_cmd should not be unknown"));
power_down_up_chk: assert property(pi11) else `AMD_ASSERT_ERROR("power_down_up_chk", $psprintf("%m fails! Cannot power up and power down at the same time!"));
read_write_chk: assert property(pi12) else `AMD_ASSERT_ERROR("read_write_chk", $psprintf("%m fails! Should not read and write at the same time!"));
bpm_addr_chk: assert property(pi13) else `AMD_ASSERT_ERROR("bpm_addr_chk", $psprintf("%m fails! BPM Addr bit should not be set!"));
`else
PGFSM_cmd_chk: assert property(pi10) else `AMD_ASSERT_WARNING("PGFSM_cmd_chk", $psprintf("%m fails! PGFSM_cmd should not be unknown"));
power_down_up_chk: assert property(pi11) else `AMD_ASSERT_WARNING("power_down_up_chk", $psprintf("%m fails! Cannot power up and power down at the same time!"));
read_write_chk: assert property(pi12) else `AMD_ASSERT_WARNING("read_write_chk", $psprintf("%m fails! Should not read and write at the same time!"));
bpm_addr_chk: assert property(pi13) else `AMD_ASSERT_WARNING("bpm_addr_chk", $psprintf("%m fails! BPM Addr bit should not be set!"));
`endif

// 3. Check for read write address legality
property p_rw0;
  @(posedge iclk)
  disable iff (~(`GFX_PGFSM_ABV_ALWAYS_EN))
  PGFSM_new_cmd & (PGFSM_cmd[`GFX_PGFSM_CMD_WRITE] | PGFSM_cmd[`GFX_PGFSM_CMD_READ]) |-> (~(&PGFSM_cmd[`GFX_PGFSM_CMD_REG_ADDR])); //F is illegal for PGFSM address space
endproperty

`ifdef GFX_PGFSM__PGFSM_W2E__1
PGFSM_rw_addr_chk: assert property(p_rw0) else `AMD_ASSERT_ERROR("PGFSM_rw_addr_chk", $psprintf("%m fails! PGFSM read/write register address is ileagal"));
`else
PGFSM_rw_addr_chk: assert property(p_rw0) else `AMD_ASSERT_WARNING("PGFSM_rw_addr_chk", $psprintf("%m fails! PGFSM read/write register address is ileagal"));
`endif

`endif // } ABV
endmodule

