`include "gfx_pgfsm_defines.h"

module pgfsm_cov
  (
    clk,
	PGFSM_tile_local_address,
	pgfsm_delay0_reg
   );
//////////////////////////
input			clk;
input    [7:0]  PGFSM_tile_local_address;
input    [23:0] pgfsm_delay0_reg;


//////////////////////////

// vrq translate_off
//VCS coverage exclude_module
`ifdef VCS

reg PGFSM_Coverage_enable;

initial begin
  if($test$plusargs("PGFSM_Coverage_assert_enable"))
    PGFSM_Coverage_enable = 1'b1;
  else
    PGFSM_Coverage_enable = 1'b0;
end





 `ifdef CG_W2E
final if((pgfsm_delay0_reg == `GFX_PGFSM_DELAY0_REG_RSTVAL)  && PGFSM_Coverage_enable) `MSGIO_DISPLAY("%m ERROR: CLKGATE PGFSM coverage test");
 `else
final if((pgfsm_delay0_reg == `GFX_PGFSM_DELAY0_REG_RSTVAL)  && PGFSM_Coverage_enable) `MSGIO_DISPLAY("%m WARNING: CLKGATE PGFSM coverage test");
 `endif


`ifdef GFX_CG_SIGNALS_DUMP_EN
initial 
begin
	#1;
	if(PGFSM_Coverage_enable) $fmonitor(tb.cg_file_handle, "CG PGFSM_COVERAGE:(%t) %m %d PGFSM_blk_addr:%d",$time,pgfsm_delay0_reg[`GFX_PGFSM_MEM_SD_DAUGHTER_DELAY_FLD],PGFSM_tile_local_address);
end
`endif



`else // !`ifdef VCS

/*
initial begin
  $display("%m at %0t: ld/src/misc/pgfsm_cov.sv: SVA not yet supported in NCSIM in wekiva scripts", $realtime);
end
*/

`endif // VCS

// vrq translate_on
endmodule // pgfsm_cov
