/////////////////////////////////////////////////////////////////////////
//
//                            Copyright 2001
//                            ATI Research, Inc.
//                            All Rights Reserved
//
//  Filename: gfx_rbbm_unit_regif.v
//
//  Filetype   : Verilog
//  Description: R400 Register Back Bone Manager (RBBM)
//               This subdesign block registers the input from client
//               before using it for anything in this design
//  Hierarchy:
//
//  Additional Files
//
/////////////////////////////////////////////////////////////////////////
//                        Modification History
//
//   Date       Author         Revision    Comments
//   -------    -----------    --------    -----------------------------
//   01-04-02    Tushar Shah       --      Initial Creation
//
/////////////////////////////////////////////////////////////////////////

module gfx_rbbm_unit_regif
(
  isclk,
  isignal_bus,
  osignal_bus
);

  //-------------------------
  // Parameters
  //-------------------------
  parameter   width = 512;

  //-------------------------
  // Input/Output
  //-------------------------
  input    isclk ;
  input    [width-1:0]   isignal_bus;
  output   [width-1:0]   osignal_bus;

  //-------------------------
  // Wires/Regs
  //-------------------------
  reg      [width-1:0]   qsignal_bus;

  //-------------------------
  // RTL:
  //-------------------------
  assign   osignal_bus = qsignal_bus;

  always @(posedge isclk) 
  begin
    qsignal_bus <= isignal_bus;
  end

endmodule
