`include "gc__rlc_reg.v"
`include "gc_register_addr_ext.v"
`include "gc_features.vh"
`include "gcutcl2_features.vh"

module gpu_iov_vf_id_reg 
  (
     //Outputs
     vf, vfid,
     //Inputs
     regbus_we, regbus_wd, regbus_a, sclk, reset
     );

input [19:2] regbus_a;
input [31:0] regbus_wd;
input        regbus_we;
input        sclk;
input        reset; // Active High

output       vf;
output [`GCUTCL2__VFID_WIDTH-1 : 0] vfid;


wire [19:0]  regbus_aa;

wire   gpu_iov_vfid_reg_we;

assign regbus_aa = {regbus_a , 2'b00};
assign gpu_iov_vfid_reg_we = regbus_we & (regbus_aa == `RLC_GPU_IOV_ACTIVE_FCN_ID_EXX);

reg vf;
reg [`GCUTCL2__VFID_WIDTH-1 : 0] vfid;

always @(posedge sclk)
begin
   if (reset)
   begin
      vf <= 1'b0;
      vfid <= {`GCUTCL2__VFID_WIDTH { 1'b0}};
   end
   else if (gpu_iov_vfid_reg_we)
     begin
        vf <= regbus_wd[31];
        vfid <= regbus_wd[`GCUTCL2__VFID_WIDTH-1:0]; 
     end
end


endmodule
