`include "gc_features.vh"
`include "gc__grbm_reg.v"
`include "grbm_defs.vh"

module grbmh (
              // inputs to grbm hub
              GRBM_GRBMH_reg_clken,
		      GRBM_GRBMH_reg_send,
		      GRBM_GRBMH_reg_addr,
		      GRBM_GRBMH_reg_wd,
		      GRBM_GRBMH_reg_op,
		      GRBM_GRBMH_reg_priv,
		      GRBM_GRBMH_reg_ssrcid,
		      GRBM_GRBMH_reg_vmid,
		      GRBM_GRBMH_reg_tmz,
              GRBM_GRBMH_reg_meid,
		      GRBM_GRBMH_reg_pipeid,
		      GRBM_GRBMH_reg_queueid,
		      GRBM_GRBMH_reg_index,

              // free back to GRBM
		      GRBM_GRBMH_reg_free0,
		      GRBM_GRBMH_reg_free1,
		      
              // outputs for use SPIM
              GRBMH_SPI_reg0_clken,
		      GRBMH_SPI_reg0_send,
		      GRBMH_SPI_reg0_addr,
		      GRBMH_SPI_reg0_wd,
		      GRBMH_SPI_reg0_op,
		      GRBMH_SPI_reg0_priv,
		      GRBMH_SPI_reg0_ssrcid,
		      GRBMH_SPI_reg0_vmid,
		      GRBMH_SPI_reg0_tmz,
              GRBMH_SPI_reg0_meid,
		      GRBMH_SPI_reg0_pipeid,
		      GRBMH_SPI_reg0_queueid,
		      GRBMH_SPI_reg0_index,

              // outputs for use SQG
              GRBMH_SPI_reg1_clken,
		      GRBMH_SPI_reg1_send,
		      GRBMH_SPI_reg1_addr,
		      GRBMH_SPI_reg1_wd,
		      GRBMH_SPI_reg1_op,
		      GRBMH_SPI_reg1_priv,
		      GRBMH_SPI_reg1_ssrcid,
		      GRBMH_SPI_reg1_vmid,
		      GRBMH_SPI_reg1_tmz,
              GRBMH_SPI_reg1_meid,
		      GRBMH_SPI_reg1_pipeid,
		      GRBMH_SPI_reg1_queueid,
		      GRBMH_SPI_reg1_index,

		      GRBMH_SPI_reg0_free,
		      GRBMH_SPI_reg1_free,

              // outputs for other targets
              GRBMH_TARG0_reg_clken,
              GRBMH_TARG0_reg_send,
              GRBMH_TARG0_reg_addr,
              GRBMH_TARG0_reg_wd,
              GRBMH_TARG0_reg_op,
              GRBMH_TARG0_reg_priv,
              GRBMH_TARG0_reg_vmid,
              GRBMH_TARG0_reg_tmz,
              GRBMH_TARG0_reg_meid,
              GRBMH_TARG0_reg_pipeid,
              GRBMH_TARG0_reg_index,

              GRBMH_TARG1_reg_clken,
              GRBMH_TARG1_reg_send,
              GRBMH_TARG1_reg_addr,
              GRBMH_TARG1_reg_wd,
              GRBMH_TARG1_reg_op,
              GRBMH_TARG1_reg_priv,
              GRBMH_TARG1_reg_vmid,
              GRBMH_TARG1_reg_tmz,
              GRBMH_TARG1_reg_meid,
              GRBMH_TARG1_reg_pipeid,
              GRBMH_TARG1_reg_index,

              GRBMH_TARG2_reg_clken,
              GRBMH_TARG2_reg_send,
              GRBMH_TARG2_reg_addr,
              GRBMH_TARG2_reg_wd,
              GRBMH_TARG2_reg_op,
              GRBMH_TARG2_reg_priv,
              GRBMH_TARG2_reg_vmid,
              GRBMH_TARG2_reg_tmz,
              GRBMH_TARG2_reg_meid,
              GRBMH_TARG2_reg_pipeid,
              GRBMH_TARG2_reg_index,

              GRBMH_TARG3_reg_clken,
              GRBMH_TARG3_reg_send,
              GRBMH_TARG3_reg_addr,
              GRBMH_TARG3_reg_wd,
              GRBMH_TARG3_reg_op,
              GRBMH_TARG3_reg_priv,
              GRBMH_TARG3_reg_vmid,
              GRBMH_TARG3_reg_tmz,
              GRBMH_TARG3_reg_meid,
              GRBMH_TARG3_reg_pipeid,
              GRBMH_TARG3_reg_index,

`ifdef   GC__NUM_SA_PER_SE__1_PRESENT
              GRBMH_TARG4_reg_clken,
              GRBMH_TARG4_reg_send,
              GRBMH_TARG4_reg_addr,
              GRBMH_TARG4_reg_wd,
              GRBMH_TARG4_reg_op,
              GRBMH_TARG4_reg_priv,
              GRBMH_TARG4_reg_vmid,
              GRBMH_TARG4_reg_tmz,
              GRBMH_TARG4_reg_meid,
              GRBMH_TARG4_reg_pipeid,
              GRBMH_TARG4_reg_index,

              GRBMH_TARG5_reg_clken,
              GRBMH_TARG5_reg_send,
              GRBMH_TARG5_reg_addr,
              GRBMH_TARG5_reg_wd,
              GRBMH_TARG5_reg_op,
              GRBMH_TARG5_reg_priv,
              GRBMH_TARG5_reg_vmid,
              GRBMH_TARG5_reg_tmz,
              GRBMH_TARG5_reg_meid,
              GRBMH_TARG5_reg_pipeid,
              GRBMH_TARG5_reg_index,

              GRBMH_TARG6_reg_clken,
              GRBMH_TARG6_reg_send,
              GRBMH_TARG6_reg_addr,
              GRBMH_TARG6_reg_wd,
              GRBMH_TARG6_reg_op,
              GRBMH_TARG6_reg_priv,
              GRBMH_TARG6_reg_vmid,
              GRBMH_TARG6_reg_tmz,
              GRBMH_TARG6_reg_meid,
              GRBMH_TARG6_reg_pipeid,
              GRBMH_TARG6_reg_index,

              GRBMH_TARG7_reg_clken,
              GRBMH_TARG7_reg_send,
              GRBMH_TARG7_reg_addr,
              GRBMH_TARG7_reg_wd,
              GRBMH_TARG7_reg_op,
              GRBMH_TARG7_reg_priv,
              GRBMH_TARG7_reg_vmid,
              GRBMH_TARG7_reg_tmz,
              GRBMH_TARG7_reg_meid,
              GRBMH_TARG7_reg_pipeid,
              GRBMH_TARG7_reg_index,
`endif

              TARG0_GRBMH_serread_data,
              TARG1_GRBMH_serread_data,
              TARG2_GRBMH_serread_data,
              TARG3_GRBMH_serread_data,
`ifdef   GC__NUM_SA_PER_SE__1_PRESENT
              TARG4_GRBMH_serread_data,
              TARG5_GRBMH_serread_data,
              TARG6_GRBMH_serread_data,
              TARG7_GRBMH_serread_data,
`endif
              RBR_GRBMH_serread_data,  // for rb redundancy in
              SPI_GRBMH_serread1_data,

              GRBMH_GRBM_serread_data,

              Cpl_GFXCLK,           // Permanent Clock

              Dft_Clk_Gater_En,
              Dft_Clk_Gater_Aon,
              dft_shift_clk
		      
		      );
   
//-------------------------------------------------------------    
// IO
//-------------------------------------------------------------

input                                   Cpl_GFXCLK;
input                                   Dft_Clk_Gater_Aon;
input                                   Dft_Clk_Gater_En;
input                                   dft_shift_clk;

input                                   GRBM_GRBMH_reg_clken;
input [`GRBM_GRBMH_REG_SEND_RANGE]      GRBM_GRBMH_reg_send;
input                                   GRBM_GRBMH_reg_op;
input                                   GRBM_GRBMH_reg_priv;
input [`GRBM_GRBMH_REG_SSRCID_RANGE]    GRBM_GRBMH_reg_ssrcid;
input [`GRBM_GRBMH_REG_VMID_RANGE]      GRBM_GRBMH_reg_vmid;
input                                   GRBM_GRBMH_reg_tmz;
input [`GRBM_GRBMH_REG_MEID_RANGE]      GRBM_GRBMH_reg_meid;
input [`GRBM_GRBMH_REG_PIPEID_RANGE]    GRBM_GRBMH_reg_pipeid;
input [`GRBM_GRBMH_REG_QUEUEID_RANGE]   GRBM_GRBMH_reg_queueid;
input [`GRBM_GRBMH_REG_INDEX_RANGE]     GRBM_GRBMH_reg_index;
input [`GRBM_GRBMH_REG_ADDR_RANGE]      GRBM_GRBMH_reg_addr;
input [`GRBM_GRBMH_REG_WD_RANGE]        GRBM_GRBMH_reg_wd;

output [`GRBM_GRBMH_REG_FREE0_RANGE]    GRBM_GRBMH_reg_free0;
output [`GRBM_GRBMH_REG_FREE1_RANGE]    GRBM_GRBMH_reg_free1;

output                                  GRBMH_SPI_reg0_clken;
output [`GRBM_TARGMCD_REG_SEND_RANGE]   GRBMH_SPI_reg0_send;
output                                  GRBMH_SPI_reg0_op;
output                                  GRBMH_SPI_reg0_priv;
output [`GRBM_TARGMCD_REG_SSRCID_RANGE] GRBMH_SPI_reg0_ssrcid;
output [`GRBM_TARGMCD_REG_VMID_RANGE]   GRBMH_SPI_reg0_vmid;
output                                  GRBMH_SPI_reg0_tmz;
output [`GRBM_TARGMCD_REG_MEID_RANGE]   GRBMH_SPI_reg0_meid;
output [`GRBM_TARGMCD_REG_PIPEID_RANGE] GRBMH_SPI_reg0_pipeid;
output [`GRBM_TARGMCD_REG_QUEUEID_RANGE]GRBMH_SPI_reg0_queueid;
output [`GRBM_TARGMCD_REG_INDEX_RANGE]  GRBMH_SPI_reg0_index;
output [`GRBM_TARGMCD_REG_ADDR_RANGE]   GRBMH_SPI_reg0_addr;
output [`GRBM_TARGMCD_REG_WD_RANGE]     GRBMH_SPI_reg0_wd;
input  [`GRBM_TARGMCD_REG_FREE_RANGE]   GRBMH_SPI_reg0_free;

output                                  GRBMH_SPI_reg1_clken;
output [`GRBM_TARGMCD_REG_SEND_RANGE]   GRBMH_SPI_reg1_send;
output                                  GRBMH_SPI_reg1_op;
output                                  GRBMH_SPI_reg1_priv;
output [`GRBM_TARGMCD_REG_SSRCID_RANGE] GRBMH_SPI_reg1_ssrcid;
output [`GRBM_TARGMCD_REG_VMID_RANGE]   GRBMH_SPI_reg1_vmid;
output                                  GRBMH_SPI_reg1_tmz;
output [`GRBM_TARGMCD_REG_MEID_RANGE]   GRBMH_SPI_reg1_meid;
output [`GRBM_TARGMCD_REG_PIPEID_RANGE] GRBMH_SPI_reg1_pipeid;
output [`GRBM_TARGMCD_REG_QUEUEID_RANGE]GRBMH_SPI_reg1_queueid;
output [`GRBM_TARGMCD_REG_INDEX_RANGE]  GRBMH_SPI_reg1_index;
output [`GRBM_TARGMCD_REG_ADDR_RANGE]   GRBMH_SPI_reg1_addr;
output [`GRBM_TARGMCD_REG_WD_RANGE]     GRBMH_SPI_reg1_wd;
input  [`GRBM_TARGMCD_REG_FREE_RANGE]   GRBMH_SPI_reg1_free;

output                                  GRBMH_TARG0_reg_clken;
output                                  GRBMH_TARG0_reg_send;
output                                  GRBMH_TARG0_reg_op;
output                                  GRBMH_TARG0_reg_priv;
output [`GRBM_TARGMCD_REG_VMID_RANGE]   GRBMH_TARG0_reg_vmid;
output                                  GRBMH_TARG0_reg_tmz;
output [`GRBM_TARGMCD_REG_MEID_RANGE]   GRBMH_TARG0_reg_meid;
output [`GRBM_TARGMCD_REG_PIPEID_RANGE] GRBMH_TARG0_reg_pipeid;
output [`GRBM_TARGMCD_REG_INDEX_RANGE]  GRBMH_TARG0_reg_index;
output [`GRBM_TARGMCD_REG_ADDR_RANGE]   GRBMH_TARG0_reg_addr;
output [`GRBM_TARGMCD_REG_WD_RANGE]     GRBMH_TARG0_reg_wd;

output                                  GRBMH_TARG1_reg_clken;
output                                  GRBMH_TARG1_reg_send;
output                                  GRBMH_TARG1_reg_op;
output                                  GRBMH_TARG1_reg_priv;
output [`GRBM_TARGMCD_REG_VMID_RANGE]   GRBMH_TARG1_reg_vmid;
output                                  GRBMH_TARG1_reg_tmz;
output [`GRBM_TARGMCD_REG_MEID_RANGE]   GRBMH_TARG1_reg_meid;
output [`GRBM_TARGMCD_REG_PIPEID_RANGE] GRBMH_TARG1_reg_pipeid;
output [`GRBM_TARGMCD_REG_INDEX_RANGE]  GRBMH_TARG1_reg_index;
output [`GRBM_TARGMCD_REG_ADDR_RANGE]   GRBMH_TARG1_reg_addr;
output [`GRBM_TARGMCD_REG_WD_RANGE]     GRBMH_TARG1_reg_wd;

output                                  GRBMH_TARG2_reg_clken;
output                                  GRBMH_TARG2_reg_send;
output                                  GRBMH_TARG2_reg_op;
output                                  GRBMH_TARG2_reg_priv;
output [`GRBM_TARGMCD_REG_VMID_RANGE]   GRBMH_TARG2_reg_vmid;
output                                  GRBMH_TARG2_reg_tmz;
output [`GRBM_TARGMCD_REG_MEID_RANGE]   GRBMH_TARG2_reg_meid;
output [`GRBM_TARGMCD_REG_PIPEID_RANGE] GRBMH_TARG2_reg_pipeid;
output [`GRBM_TARGMCD_REG_INDEX_RANGE]  GRBMH_TARG2_reg_index;
output [`GRBM_TARGMCD_REG_ADDR_RANGE]   GRBMH_TARG2_reg_addr;
output [`GRBM_TARGMCD_REG_WD_RANGE]     GRBMH_TARG2_reg_wd;

output                                  GRBMH_TARG3_reg_clken;
output                                  GRBMH_TARG3_reg_send;
output                                  GRBMH_TARG3_reg_op;
output                                  GRBMH_TARG3_reg_priv;
output [`GRBM_TARGMCD_REG_VMID_RANGE]   GRBMH_TARG3_reg_vmid;
output                                  GRBMH_TARG3_reg_tmz;
output [`GRBM_TARGMCD_REG_MEID_RANGE]   GRBMH_TARG3_reg_meid;
output [`GRBM_TARGMCD_REG_PIPEID_RANGE] GRBMH_TARG3_reg_pipeid;
output [`GRBM_TARGMCD_REG_INDEX_RANGE]  GRBMH_TARG3_reg_index;
output [`GRBM_TARGMCD_REG_ADDR_RANGE]   GRBMH_TARG3_reg_addr;
output [`GRBM_TARGMCD_REG_WD_RANGE]     GRBMH_TARG3_reg_wd;

`ifdef   GC__NUM_SA_PER_SE__1_PRESENT
output                                  GRBMH_TARG4_reg_clken;
output                                  GRBMH_TARG4_reg_send;
output                                  GRBMH_TARG4_reg_op;
output                                  GRBMH_TARG4_reg_priv;
output [`GRBM_TARGMCD_REG_VMID_RANGE]   GRBMH_TARG4_reg_vmid;
output                                  GRBMH_TARG4_reg_tmz;
output [`GRBM_TARGMCD_REG_MEID_RANGE]   GRBMH_TARG4_reg_meid;
output [`GRBM_TARGMCD_REG_PIPEID_RANGE] GRBMH_TARG4_reg_pipeid;
output [`GRBM_TARGMCD_REG_INDEX_RANGE]  GRBMH_TARG4_reg_index;
output [`GRBM_TARGMCD_REG_ADDR_RANGE]   GRBMH_TARG4_reg_addr;
output [`GRBM_TARGMCD_REG_WD_RANGE]     GRBMH_TARG4_reg_wd;

output                                  GRBMH_TARG5_reg_clken;
output                                  GRBMH_TARG5_reg_send;
output                                  GRBMH_TARG5_reg_op;
output                                  GRBMH_TARG5_reg_priv;
output [`GRBM_TARGMCD_REG_VMID_RANGE]   GRBMH_TARG5_reg_vmid;
output                                  GRBMH_TARG5_reg_tmz;
output [`GRBM_TARGMCD_REG_MEID_RANGE]   GRBMH_TARG5_reg_meid;
output [`GRBM_TARGMCD_REG_PIPEID_RANGE] GRBMH_TARG5_reg_pipeid;
output [`GRBM_TARGMCD_REG_INDEX_RANGE]  GRBMH_TARG5_reg_index;
output [`GRBM_TARGMCD_REG_ADDR_RANGE]   GRBMH_TARG5_reg_addr;
output [`GRBM_TARGMCD_REG_WD_RANGE]     GRBMH_TARG5_reg_wd;

output                                  GRBMH_TARG6_reg_clken;
output                                  GRBMH_TARG6_reg_send;
output                                  GRBMH_TARG6_reg_op;
output                                  GRBMH_TARG6_reg_priv;
output [`GRBM_TARGMCD_REG_VMID_RANGE]   GRBMH_TARG6_reg_vmid;
output                                  GRBMH_TARG6_reg_tmz;
output [`GRBM_TARGMCD_REG_MEID_RANGE]   GRBMH_TARG6_reg_meid;
output [`GRBM_TARGMCD_REG_PIPEID_RANGE] GRBMH_TARG6_reg_pipeid;
output [`GRBM_TARGMCD_REG_INDEX_RANGE]  GRBMH_TARG6_reg_index;
output [`GRBM_TARGMCD_REG_ADDR_RANGE]   GRBMH_TARG6_reg_addr;
output [`GRBM_TARGMCD_REG_WD_RANGE]     GRBMH_TARG6_reg_wd;

output                                  GRBMH_TARG7_reg_clken;
output                                  GRBMH_TARG7_reg_send;
output                                  GRBMH_TARG7_reg_op;
output                                  GRBMH_TARG7_reg_priv;
output [`GRBM_TARGMCD_REG_VMID_RANGE]   GRBMH_TARG7_reg_vmid;
output                                  GRBMH_TARG7_reg_tmz;
output [`GRBM_TARGMCD_REG_MEID_RANGE]   GRBMH_TARG7_reg_meid;
output [`GRBM_TARGMCD_REG_PIPEID_RANGE] GRBMH_TARG7_reg_pipeid;
output [`GRBM_TARGMCD_REG_INDEX_RANGE]  GRBMH_TARG7_reg_index;
output [`GRBM_TARGMCD_REG_ADDR_RANGE]   GRBMH_TARG7_reg_addr;
output [`GRBM_TARGMCD_REG_WD_RANGE]     GRBMH_TARG7_reg_wd;
`endif

input  [3:0]                            TARG0_GRBMH_serread_data;
input  [3:0]                            TARG1_GRBMH_serread_data;
input  [3:0]                            TARG2_GRBMH_serread_data;
input  [3:0]                            TARG3_GRBMH_serread_data;
`ifdef   GC__NUM_SA_PER_SE__1_PRESENT
input  [3:0]                            TARG4_GRBMH_serread_data;
input  [3:0]                            TARG5_GRBMH_serread_data;
input  [3:0]                            TARG6_GRBMH_serread_data;
input  [3:0]                            TARG7_GRBMH_serread_data;
`endif
input  [3:0]                            RBR_GRBMH_serread_data;
input  [3:0]                            SPI_GRBMH_serread1_data;

output [3:0]                            GRBMH_GRBM_serread_data;


wire                                    reg_clken;
wire   [`GRBM_GRBMH_REG_SEND_RANGE]     reg_send;
wire                                    reg_op;
wire                                    reg_priv;
wire   [`GRBM_GRBMH_REG_SSRCID_RANGE]   reg_ssrcid;
wire   [`GRBM_GRBMH_REG_VMID_RANGE]     reg_vmid;
wire                                    reg_tmz;
wire   [`GRBM_GRBMH_REG_MEID_RANGE]     reg_meid;
wire   [`GRBM_GRBMH_REG_PIPEID_RANGE]   reg_pipeid;
wire   [`GRBM_GRBMH_REG_QUEUEID_RANGE]  reg_queueid;
wire   [`GRBM_GRBMH_REG_INDEX_RANGE]    reg_index;
wire   [`GRBM_GRBMH_REG_ADDR_RANGE]     reg_addr;
wire   [`GRBM_GRBMH_REG_WD_RANGE]       reg_wd;

wire   [3:0]                            SERREAD_DATA_ORED;

wire                                    Cpl_GFXCLK_int;

//-------------------------------------------------------------    
// Code 
//-------------------------------------------------------------

gfx_cgtt_local_dft grbmh_gfx_cgtt_local_dft (
   .oclk (Cpl_GFXCLK_int),
   .Cpl_GFXCLK (Cpl_GFXCLK), 
   .core_busy(1'b1),
   .dft_clk_gate_ctrl ({Dft_Clk_Gater_En,Dft_Clk_Gater_Aon}), 
   .dft_shift_clk (dft_shift_clk)
    );

ati_dff_in
  #(1)
  uati_dff_in
    (.clk       (Cpl_GFXCLK_int),
     .d         (GRBM_GRBMH_reg_clken),
     .q         (reg_clken));

ati_dff_in
  #(`GRBM_GRBMH_REG_SEND_WIDTH)
  uati_dff_send_in
    (.clk     (Cpl_GFXCLK_int),
     .d       (GRBM_GRBMH_reg_send),
     .q       (reg_send));

ati_dff_en_in
  #(`GRBM_GRBMH_REG_INDEX_WIDTH +
    `GRBM_GRBMH_REG_QUEUEID_WIDTH +
    `GRBM_GRBMH_REG_PIPEID_WIDTH +
    `GRBM_GRBMH_REG_MEID_WIDTH +
    `GRBM_GRBMH_REG_VMID_WIDTH +
    `GRBM_GRBMH_REG_TMZ_WIDTH +
    `GRBM_GRBMH_REG_SSRCID_WIDTH +
    `GRBM_GRBMH_REG_PRIV_WIDTH +
    `GRBM_GRBMH_REG_OP_WIDTH +
    `GRBM_GRBMH_REG_ADDR_WIDTH +
    `GRBM_GRBMH_REG_WD_WIDTH
    )
  uati_dff_in_gated
    (.clk     (Cpl_GFXCLK_int),
    .en      (|GRBM_GRBMH_reg_send),
    .d       ({GRBM_GRBMH_reg_index,
               GRBM_GRBMH_reg_queueid,
               GRBM_GRBMH_reg_pipeid,
               GRBM_GRBMH_reg_meid,
               GRBM_GRBMH_reg_vmid,
               GRBM_GRBMH_reg_tmz,
               GRBM_GRBMH_reg_ssrcid,
               GRBM_GRBMH_reg_priv,
               GRBM_GRBMH_reg_op,
               GRBM_GRBMH_reg_addr,
               GRBM_GRBMH_reg_wd
               }),
     .q       ({reg_index,
                reg_queueid,
                reg_pipeid,
                reg_meid,
                reg_vmid,
                reg_tmz,
                reg_ssrcid,
                reg_priv,
                reg_op,
                reg_addr,
                reg_wd}));

ati_dff_out
  #(1)
  uati_dff_out_spi_reg0
    (.clk     (Cpl_GFXCLK_int),
     .d       (reg_clken),
     .q       (GRBMH_SPI_reg0_clken));

ati_dff_out
  #(`GRBM_TARGMCD_REG_SEND_WIDTH)
  uati_dff_send_out_spi_reg0
    (.clk     (Cpl_GFXCLK_int),
     .d       (reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .q       (GRBMH_SPI_reg0_send));

ati_dff_en_out
  #(`GRBM_TARGMCD_REG_INDEX_WIDTH +
    `GRBM_TARGMCD_REG_QUEUEID_WIDTH +
    `GRBM_TARGMCD_REG_PIPEID_WIDTH +
    `GRBM_TARGMCD_REG_MEID_WIDTH +
    `GRBM_TARGMCD_REG_VMID_WIDTH +
    `GRBM_TARGMCD_REG_TMZ_WIDTH +
    `GRBM_TARGMCD_REG_SSRCID_WIDTH +
    `GRBM_TARGMCD_REG_PRIV_WIDTH +
    `GRBM_TARGMCD_REG_OP_WIDTH +
    `GRBM_TARGMCD_REG_ADDR_WIDTH +
    `GRBM_TARGMCD_REG_WD_WIDTH
    )
  uati_dff_out_gated_spi_reg0
    (.clk     (Cpl_GFXCLK_int),
     .en      (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .d       ({reg_index,
                reg_queueid,
                reg_pipeid,
                reg_meid,
                reg_vmid,
                reg_tmz,
                reg_ssrcid,
                reg_priv,
                reg_op,
                reg_addr,
                reg_wd
                }),
     .q       ({GRBMH_SPI_reg0_index,
                GRBMH_SPI_reg0_queueid,
                GRBMH_SPI_reg0_pipeid,
                GRBMH_SPI_reg0_meid,
                GRBMH_SPI_reg0_vmid,
                GRBMH_SPI_reg0_tmz,
                GRBMH_SPI_reg0_ssrcid,
                GRBMH_SPI_reg0_priv,
                GRBMH_SPI_reg0_op,
                GRBMH_SPI_reg0_addr,
                GRBMH_SPI_reg0_wd}));

ati_dff_in
  #(`GRBM_TARGMCD_REG_FREE_WIDTH)
  uati_dff_in_spi_reg0_free
    (.clk     (Cpl_GFXCLK_int),
     .d       (GRBMH_SPI_reg0_free),
     .q       (GRBM_GRBMH_reg_free0));

ati_dff_out
  #(1)
  uati_dff_out_spi_reg1
    (.clk     (Cpl_GFXCLK_int),
     .d       (reg_clken),
     .q       (GRBMH_SPI_reg1_clken));

ati_dff_out
  #(`GRBM_TARGMCD_REG_SEND_WIDTH)
  uati_dff_send_out_spi_reg1
    (.clk     (Cpl_GFXCLK_int),
     .d       (reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .q       (GRBMH_SPI_reg1_send));

ati_dff_en_out
  #(`GRBM_TARGMCD_REG_INDEX_WIDTH +
    `GRBM_TARGMCD_REG_QUEUEID_WIDTH +
    `GRBM_TARGMCD_REG_PIPEID_WIDTH +
    `GRBM_TARGMCD_REG_MEID_WIDTH +
    `GRBM_TARGMCD_REG_VMID_WIDTH +
    `GRBM_TARGMCD_REG_TMZ_WIDTH +
    `GRBM_TARGMCD_REG_SSRCID_WIDTH +
    `GRBM_TARGMCD_REG_PRIV_WIDTH +
    `GRBM_TARGMCD_REG_OP_WIDTH +
    `GRBM_TARGMCD_REG_ADDR_WIDTH +
    `GRBM_TARGMCD_REG_WD_WIDTH
    )
  uati_dff_out_gated_spi_reg1
    (.clk     (Cpl_GFXCLK_int),
     .en      (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .d       ({reg_index,
                reg_queueid,
                reg_pipeid,
                reg_meid,
                reg_vmid,
                reg_tmz,
                reg_ssrcid,
                reg_priv,
                reg_op,
                reg_addr,
                reg_wd
                }),
     .q       ({GRBMH_SPI_reg1_index,
                GRBMH_SPI_reg1_queueid,
                GRBMH_SPI_reg1_pipeid,
                GRBMH_SPI_reg1_meid,
                GRBMH_SPI_reg1_vmid,
                GRBMH_SPI_reg1_tmz,
                GRBMH_SPI_reg1_ssrcid,
                GRBMH_SPI_reg1_priv,
                GRBMH_SPI_reg1_op,
                GRBMH_SPI_reg1_addr,
                GRBMH_SPI_reg1_wd}));

ati_dff_in
  #(`GRBM_TARGMCD_REG_FREE_WIDTH)
  uati_dff_in_spi_reg1_free
    (.clk     (Cpl_GFXCLK_int),
     .d       (GRBMH_SPI_reg1_free),
     .q       (GRBM_GRBMH_reg_free1));


ati_dff_out
  #(1)
  uati_dff_out_targ0
    (.clk     (Cpl_GFXCLK_int),
     .d       (reg_clken),
     .q       (GRBMH_TARG0_reg_clken));

ati_dff_out
  #(1)
  uati_dff_out_targ1
    (.clk     (Cpl_GFXCLK_int),
     .d       (reg_clken),
     .q       (GRBMH_TARG1_reg_clken));

ati_dff_out
  #(1)
  uati_dff_out_targ2
    (.clk     (Cpl_GFXCLK_int),
     .d       (reg_clken),
     .q       (GRBMH_TARG2_reg_clken));

ati_dff_out
  #(1)
  uati_dff_out_targ3
    (.clk     (Cpl_GFXCLK_int),
     .d       (reg_clken),
     .q       (GRBMH_TARG3_reg_clken));

`ifdef   GC__NUM_SA_PER_SE__1_PRESENT
ati_dff_out
  #(1)
  uati_dff_out_targ4
    (.clk     (Cpl_GFXCLK_int),
     .d       (reg_clken),
     .q       (GRBMH_TARG4_reg_clken));

ati_dff_out
  #(1)
  uati_dff_out_targ5
    (.clk     (Cpl_GFXCLK_int),
     .d       (reg_clken),
     .q       (GRBMH_TARG5_reg_clken));

ati_dff_out
  #(1)
  uati_dff_out_targ6
    (.clk     (Cpl_GFXCLK_int),
     .d       (reg_clken),
     .q       (GRBMH_TARG6_reg_clken));

ati_dff_out
  #(1)
  uati_dff_out_targ7
    (.clk     (Cpl_GFXCLK_int),
     .d       (reg_clken),
     .q       (GRBMH_TARG7_reg_clken));
`endif

ati_dff_out
  #(`GRBM_TARG_REG_SEND_WIDTH)
  uati_dff_send_out_targ0
    (.clk     (Cpl_GFXCLK_int),
     .d       (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .q       (GRBMH_TARG0_reg_send));

ati_dff_out
  #(`GRBM_TARG_REG_SEND_WIDTH)
  uati_dff_send_out_targ1
    (.clk     (Cpl_GFXCLK_int),
     .d       (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .q       (GRBMH_TARG1_reg_send));

ati_dff_out
  #(`GRBM_TARG_REG_SEND_WIDTH)
  uati_dff_send_out_targ2
    (.clk     (Cpl_GFXCLK_int),
     .d       (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .q       (GRBMH_TARG2_reg_send));

ati_dff_out
  #(`GRBM_TARG_REG_SEND_WIDTH)
  uati_dff_send_out_targ3
    (.clk     (Cpl_GFXCLK_int),
     .d       (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .q       (GRBMH_TARG3_reg_send));

`ifdef   GC__NUM_SA_PER_SE__1_PRESENT
ati_dff_out
  #(`GRBM_TARG_REG_SEND_WIDTH)
  uati_dff_send_out_targ4
    (.clk     (Cpl_GFXCLK_int),
     .d       (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .q       (GRBMH_TARG4_reg_send));

ati_dff_out
  #(`GRBM_TARG_REG_SEND_WIDTH)
  uati_dff_send_out_targ5
    (.clk     (Cpl_GFXCLK_int),
     .d       (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .q       (GRBMH_TARG5_reg_send));

ati_dff_out
  #(`GRBM_TARG_REG_SEND_WIDTH)
  uati_dff_send_out_targ6
    (.clk     (Cpl_GFXCLK_int),
     .d       (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .q       (GRBMH_TARG6_reg_send));

ati_dff_out
  #(`GRBM_TARG_REG_SEND_WIDTH)
  uati_dff_send_out_targ7
    (.clk     (Cpl_GFXCLK_int),
     .d       (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .q       (GRBMH_TARG7_reg_send));
`endif

ati_dff_en_out
  #(`GRBM_TARGMCD_REG_INDEX_WIDTH +
    `GRBM_TARGMCD_REG_PIPEID_WIDTH +
    `GRBM_TARGMCD_REG_MEID_WIDTH +
    `GRBM_TARGMCD_REG_VMID_WIDTH +
    `GRBM_TARGMCD_REG_TMZ_WIDTH +
    `GRBM_TARGMCD_REG_PRIV_WIDTH +
    `GRBM_TARGMCD_REG_OP_WIDTH +
    `GRBM_TARGMCD_REG_ADDR_WIDTH +
    `GRBM_TARGMCD_REG_WD_WIDTH
    )
  uati_dff_out_gated_targ0
    (.clk     (Cpl_GFXCLK_int),
     .en      (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .d       ({reg_index,
                reg_pipeid,
                reg_meid,
                reg_vmid,
                reg_tmz,
                reg_priv,
                reg_op,
                reg_addr,
                reg_wd
                }),
     .q       ({GRBMH_TARG0_reg_index,
                GRBMH_TARG0_reg_pipeid,
                GRBMH_TARG0_reg_meid,
                GRBMH_TARG0_reg_vmid,
                GRBMH_TARG0_reg_tmz,
                GRBMH_TARG0_reg_priv,
                GRBMH_TARG0_reg_op,
                GRBMH_TARG0_reg_addr,
                GRBMH_TARG0_reg_wd}));

ati_dff_en_out
  #(`GRBM_TARGMCD_REG_INDEX_WIDTH +
    `GRBM_TARGMCD_REG_PIPEID_WIDTH +
    `GRBM_TARGMCD_REG_MEID_WIDTH +
    `GRBM_TARGMCD_REG_VMID_WIDTH +
    `GRBM_TARGMCD_REG_TMZ_WIDTH +
    `GRBM_TARGMCD_REG_PRIV_WIDTH +
    `GRBM_TARGMCD_REG_OP_WIDTH +
    `GRBM_TARGMCD_REG_ADDR_WIDTH +
    `GRBM_TARGMCD_REG_WD_WIDTH
    )
  uati_dff_out_gated_targ1
    (.clk     (Cpl_GFXCLK_int),
     .en      (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .d       ({reg_index,
                reg_pipeid,
                reg_meid,
                reg_vmid,
                reg_tmz,
                reg_priv,
                reg_op,
                reg_addr,
                reg_wd
                }),
     .q       ({GRBMH_TARG1_reg_index,
                GRBMH_TARG1_reg_pipeid,
                GRBMH_TARG1_reg_meid,
                GRBMH_TARG1_reg_vmid,
                GRBMH_TARG1_reg_tmz,
                GRBMH_TARG1_reg_priv,
                GRBMH_TARG1_reg_op,
                GRBMH_TARG1_reg_addr,
                GRBMH_TARG1_reg_wd}));

ati_dff_en_out
  #(`GRBM_TARGMCD_REG_INDEX_WIDTH +
    `GRBM_TARGMCD_REG_PIPEID_WIDTH +
    `GRBM_TARGMCD_REG_MEID_WIDTH +
    `GRBM_TARGMCD_REG_VMID_WIDTH +
    `GRBM_TARGMCD_REG_TMZ_WIDTH +
    `GRBM_TARGMCD_REG_PRIV_WIDTH +
    `GRBM_TARGMCD_REG_OP_WIDTH +
    `GRBM_TARGMCD_REG_ADDR_WIDTH +
    `GRBM_TARGMCD_REG_WD_WIDTH
    )
  uati_dff_out_gated_targ2
    (.clk     (Cpl_GFXCLK_int),
     .en      (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .d       ({reg_index,
                reg_pipeid,
                reg_meid,
                reg_vmid,
                reg_tmz,
                reg_priv,
                reg_op,
                reg_addr,
                reg_wd
                }),
     .q       ({GRBMH_TARG2_reg_index,
                GRBMH_TARG2_reg_pipeid,
                GRBMH_TARG2_reg_meid,
                GRBMH_TARG2_reg_vmid,
                GRBMH_TARG2_reg_tmz,
                GRBMH_TARG2_reg_priv,
                GRBMH_TARG2_reg_op,
                GRBMH_TARG2_reg_addr,
                GRBMH_TARG2_reg_wd}));

ati_dff_en_out
  #(`GRBM_TARGMCD_REG_INDEX_WIDTH +
    `GRBM_TARGMCD_REG_PIPEID_WIDTH +
    `GRBM_TARGMCD_REG_MEID_WIDTH +
    `GRBM_TARGMCD_REG_VMID_WIDTH +
    `GRBM_TARGMCD_REG_TMZ_WIDTH +
    `GRBM_TARGMCD_REG_PRIV_WIDTH +
    `GRBM_TARGMCD_REG_OP_WIDTH +
    `GRBM_TARGMCD_REG_ADDR_WIDTH +
    `GRBM_TARGMCD_REG_WD_WIDTH
    )
  uati_dff_out_gated_targ3
    (.clk     (Cpl_GFXCLK_int),
     .en      (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .d       ({reg_index,
                reg_pipeid,
                reg_meid,
                reg_vmid,
                reg_tmz,
                reg_priv,
                reg_op,
                reg_addr,
                reg_wd
                }),
     .q       ({GRBMH_TARG3_reg_index,
                GRBMH_TARG3_reg_pipeid,
                GRBMH_TARG3_reg_meid,
                GRBMH_TARG3_reg_vmid,
                GRBMH_TARG3_reg_tmz,
                GRBMH_TARG3_reg_priv,
                GRBMH_TARG3_reg_op,
                GRBMH_TARG3_reg_addr,
                GRBMH_TARG3_reg_wd}));

`ifdef   GC__NUM_SA_PER_SE__1_PRESENT
ati_dff_en_out
  #(`GRBM_TARGMCD_REG_INDEX_WIDTH +
    `GRBM_TARGMCD_REG_PIPEID_WIDTH +
    `GRBM_TARGMCD_REG_MEID_WIDTH +
    `GRBM_TARGMCD_REG_VMID_WIDTH +
    `GRBM_TARGMCD_REG_TMZ_WIDTH +
    `GRBM_TARGMCD_REG_PRIV_WIDTH +
    `GRBM_TARGMCD_REG_OP_WIDTH +
    `GRBM_TARGMCD_REG_ADDR_WIDTH +
    `GRBM_TARGMCD_REG_WD_WIDTH
    )
  uati_dff_out_gated_targ4
    (.clk     (Cpl_GFXCLK_int),
     .en      (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .d       ({reg_index,
                reg_pipeid,
                reg_meid,
                reg_vmid,
                reg_tmz,
                reg_priv,
                reg_op,
                reg_addr,
                reg_wd
                }),
     .q       ({GRBMH_TARG4_reg_index,
                GRBMH_TARG4_reg_pipeid,
                GRBMH_TARG4_reg_meid,
                GRBMH_TARG4_reg_vmid,
                GRBMH_TARG4_reg_tmz,
                GRBMH_TARG4_reg_priv,
                GRBMH_TARG4_reg_op,
                GRBMH_TARG4_reg_addr,
                GRBMH_TARG4_reg_wd}));

ati_dff_en_out
  #(`GRBM_TARGMCD_REG_INDEX_WIDTH +
    `GRBM_TARGMCD_REG_PIPEID_WIDTH +
    `GRBM_TARGMCD_REG_MEID_WIDTH +
    `GRBM_TARGMCD_REG_VMID_WIDTH +
    `GRBM_TARGMCD_REG_TMZ_WIDTH +
    `GRBM_TARGMCD_REG_PRIV_WIDTH +
    `GRBM_TARGMCD_REG_OP_WIDTH +
    `GRBM_TARGMCD_REG_ADDR_WIDTH +
    `GRBM_TARGMCD_REG_WD_WIDTH
    )
  uati_dff_out_gated_targ5
    (.clk     (Cpl_GFXCLK_int),
     .en      (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .d       ({reg_index,
                reg_pipeid,
                reg_meid,
                reg_vmid,
                reg_tmz,
                reg_priv,
                reg_op,
                reg_addr,
                reg_wd
                }),
     .q       ({GRBMH_TARG5_reg_index,
                GRBMH_TARG5_reg_pipeid,
                GRBMH_TARG5_reg_meid,
                GRBMH_TARG5_reg_vmid,
                GRBMH_TARG5_reg_tmz,
                GRBMH_TARG5_reg_priv,
                GRBMH_TARG5_reg_op,
                GRBMH_TARG5_reg_addr,
                GRBMH_TARG5_reg_wd}));

ati_dff_en_out
  #(`GRBM_TARGMCD_REG_INDEX_WIDTH +
    `GRBM_TARGMCD_REG_PIPEID_WIDTH +
    `GRBM_TARGMCD_REG_MEID_WIDTH +
    `GRBM_TARGMCD_REG_VMID_WIDTH +
    `GRBM_TARGMCD_REG_TMZ_WIDTH +
    `GRBM_TARGMCD_REG_PRIV_WIDTH +
    `GRBM_TARGMCD_REG_OP_WIDTH +
    `GRBM_TARGMCD_REG_ADDR_WIDTH +
    `GRBM_TARGMCD_REG_WD_WIDTH
    )
  uati_dff_out_gated_targ6
    (.clk     (Cpl_GFXCLK_int),
     .en      (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .d       ({reg_index,
                reg_pipeid,
                reg_meid,
                reg_vmid,
                reg_tmz,
                reg_priv,
                reg_op,
                reg_addr,
                reg_wd
                }),
     .q       ({GRBMH_TARG6_reg_index,
                GRBMH_TARG6_reg_pipeid,
                GRBMH_TARG6_reg_meid,
                GRBMH_TARG6_reg_vmid,
                GRBMH_TARG6_reg_tmz,
                GRBMH_TARG6_reg_priv,
                GRBMH_TARG6_reg_op,
                GRBMH_TARG6_reg_addr,
                GRBMH_TARG6_reg_wd}));

ati_dff_en_out
  #(`GRBM_TARGMCD_REG_INDEX_WIDTH +
    `GRBM_TARGMCD_REG_PIPEID_WIDTH +
    `GRBM_TARGMCD_REG_MEID_WIDTH +
    `GRBM_TARGMCD_REG_VMID_WIDTH +
    `GRBM_TARGMCD_REG_TMZ_WIDTH +
    `GRBM_TARGMCD_REG_PRIV_WIDTH +
    `GRBM_TARGMCD_REG_OP_WIDTH +
    `GRBM_TARGMCD_REG_ADDR_WIDTH +
    `GRBM_TARGMCD_REG_WD_WIDTH
    )
  uati_dff_out_gated_targ7
    (.clk     (Cpl_GFXCLK_int),
     .en      (|reg_send[`GRBM_TARGMCD_REG_SEND_WIDTH-1:0]),
     .d       ({reg_index,
                reg_pipeid,
                reg_meid,
                reg_vmid,
                reg_tmz,
                reg_priv,
                reg_op,
                reg_addr,
                reg_wd
                }),
     .q       ({GRBMH_TARG7_reg_index,
                GRBMH_TARG7_reg_pipeid,
                GRBMH_TARG7_reg_meid,
                GRBMH_TARG7_reg_vmid,
                GRBMH_TARG7_reg_tmz,
                GRBMH_TARG7_reg_priv,
                GRBMH_TARG7_reg_op,
                GRBMH_TARG7_reg_addr,
                GRBMH_TARG7_reg_wd}));
`endif

assign  SERREAD_DATA_ORED = TARG0_GRBMH_serread_data |
                            TARG1_GRBMH_serread_data |
                            TARG2_GRBMH_serread_data |
                            TARG3_GRBMH_serread_data |
`ifdef   GC__NUM_SA_PER_SE__1_PRESENT
                            TARG4_GRBMH_serread_data |
                            TARG5_GRBMH_serread_data |
                            TARG6_GRBMH_serread_data |
                            TARG7_GRBMH_serread_data |
`endif
                            SPI_GRBMH_serread1_data |
                            RBR_GRBMH_serread_data ;

ati_dff_out
  #(4)
  uati_dff_serread_data
    (.clk     (Cpl_GFXCLK_int),
     .d       (SERREAD_DATA_ORED),
     .q       (GRBMH_GRBM_serread_data));

endmodule 
