`timescale 1ps / 1ps

`ifndef SNPS_SEQ_DELAY
`define SNPS_SEQ_DELAY 10
`endif
`ifndef SNPS_COMBO_DELAY
`define SNPS_COMBO_DELAY 0 
`endif
`ifndef SNPS_CKGT_DELAY
`define SNPS_CKGT_DELAY 0
`endif
`ifndef SNPS_CKGTLT_DELAY
`define SNPS_CKGTLT_DELAY 0
`endif
`ifndef SNPS_LAT_DELAY
`define SNPS_LAT_DELAY 10
`endif

`ifdef VIRL_functiononly
    `delay_mode_distributed
    `define _fv
    `define SNPS_MASK_X_OUT_LATCH
    `define SNPS_MASK_ERR_UDP
`else
    `delay_mode_path
`endif

`celldefine
module HDBULT11_MRKAN2_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
     and inst1   (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKAN2_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
     and inst1   (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKAN2_CK_4 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKAN2_CK_8 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKBUF_4 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKBUF_8 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKBUF_CK_4 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKBUF_CK_8 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKEO2_CKY2_1 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;


    xor inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKEO2_CKY4_4 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;


    xor inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKFDN_V2Y2_1 (Q, QN, CK, D);
   output Q, QN;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res__CK, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


   not inst2  (int_res__CK, delayed_CK);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst3  (xcr_0, int_res__CK, delayed_D);

  `endif
   snps_dff inst4  (int_res_iq, viol_0, int_res__CK, delayed_D, xcr_0);
   
`ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst5 (Q, int_res_iq);
    not #`SNPS_SEQ_DELAY  inst6 (QN, int_res_iq);
`else
    buf inst7  (Q, int_res_iq);
    not inst8  (QN, int_res_iq);
`endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

not inst9  (ENABLE_NOT_D, D);
buf inst10  (ENABLE_D, D);

specify
if (D==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
(negedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(negedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKFDN_V2Y2_4 (Q, QN, CK, D);
   output Q, QN;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res__CK, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


   not inst2  (int_res__CK, delayed_CK);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst3  (xcr_0, int_res__CK, delayed_D);

  `endif
   snps_dff inst4  (int_res_iq, viol_0, int_res__CK, delayed_D, xcr_0);
   
`ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst5 (Q, int_res_iq);
    not #`SNPS_SEQ_DELAY  inst6 (QN, int_res_iq);
`else
    buf inst7  (Q, int_res_iq);
    not inst8  (QN, int_res_iq);
`endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

not inst9  (ENABLE_NOT_D, D);
buf inst10  (ENABLE_D, D);

specify
if (D==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
(negedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(negedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKFDPQB_V2Y2_1 (QN, CK, D);
   output QN;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif
   snps_dff inst3  (int_res_iq, viol_0, delayed_CK, delayed_D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst4 (QN, int_res_iq);
   `else
        not inst5  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (D==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKFDP_V2Y2_1 (Q, QN, CK, D);
   output Q, QN;
   input CK, D;

   reg viol_0;
   wire delayed_D, delayed_CK;

   wire int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif

  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif
   snps_dff inst3  (int_res_iq, viol_0, delayed_CK, delayed_D, xcr_0);
  
`ifdef VIRL_functiononly
   buf #`SNPS_SEQ_DELAY  inst4 (Q, int_res_iq);
   not #`SNPS_SEQ_DELAY  inst5 (QN, int_res_iq);
`else
   buf inst6  (Q, int_res_iq);
   not inst7  (QN, int_res_iq);
`endif

`ifdef VIRL_functiononly

`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

not inst8  (ENABLE_NOT_D, D);
buf inst9  (ENABLE_D, D);

specify
(posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
`endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKFSDN_V2Y2_1 (Q, QN, CK, D, SI, SE);
   output Q, QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__CK, int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   not inst4  (int_res__CK, delayed_CK);
   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst6  (xcr_0, int_res__CK, int_res__D);

  `endif
   snps_dff inst7  (int_res_iq, viol_0, int_res__CK, int_res__D, xcr_0);
`ifdef VIRL_functiononly
   buf  #`SNPS_SEQ_DELAY  inst8 (Q, int_res_iq);
   not  #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
`else
   buf inst10  (Q, int_res_iq);
   not inst11  (QN, int_res_iq);
`endif
`ifdef VIRL_functiononly
`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst12  (_net_0, SE);
not inst13  (_net_1, D);
not inst14  (_net_2, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst16  (_net_3, SE);
not inst17  (_net_4, D);
and inst18  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst19  (_net_5, D);
not inst20  (_net_6, SI);
and inst21  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst22  (_net_7, D);
and inst23  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst24  (_net_8, SE);
not inst25  (_net_9, SI);
and inst26  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst27  (_net_10, SE);
and inst28  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst29  (_net_11, SI);
and inst30  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst31  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst32  (_net_12, SI);
not inst33  (_net_13, SE);
and inst34  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst35  (_net_14, SE);
and inst36  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst37  (_net_15, D);
and inst38  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst39  (_net_16, SI);
and inst40  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst41  (_net_17, D);
and inst42  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst43  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
(negedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
`endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKFSDN_V2Y2_4 (Q, QN, CK, D, SI, SE);
   output Q, QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__CK, int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   not inst4  (int_res__CK, delayed_CK);
   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst6  (xcr_0, int_res__CK, int_res__D);

  `endif
   snps_dff inst7  (int_res_iq, viol_0, int_res__CK, int_res__D, xcr_0);
`ifdef VIRL_functiononly
   buf  #`SNPS_SEQ_DELAY  inst8 (Q, int_res_iq);
   not  #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
`else
   buf inst10  (Q, int_res_iq);
   not inst11  (QN, int_res_iq);
`endif
`ifdef VIRL_functiononly
`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst12  (_net_0, SE);
not inst13  (_net_1, D);
not inst14  (_net_2, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst16  (_net_3, SE);
not inst17  (_net_4, D);
and inst18  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst19  (_net_5, D);
not inst20  (_net_6, SI);
and inst21  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst22  (_net_7, D);
and inst23  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst24  (_net_8, SE);
not inst25  (_net_9, SI);
and inst26  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst27  (_net_10, SE);
and inst28  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst29  (_net_11, SI);
and inst30  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst31  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst32  (_net_12, SI);
not inst33  (_net_13, SE);
and inst34  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst35  (_net_14, SE);
and inst36  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst37  (_net_15, D);
and inst38  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst39  (_net_16, SI);
and inst40  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst41  (_net_17, D);
and inst42  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst43  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
(negedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
`endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKFSDPQ_V2Y2_1 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKFSDPQ_V2Y2_4 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKFSDP_V2Y2_1 (Q, QN, CK, D, SI, SE);
   output Q, QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);
`ifdef VIRL_functiononly
   buf  #`SNPS_SEQ_DELAY  inst7 (Q, int_res_iq);
   not  #`SNPS_SEQ_DELAY  inst8 (QN, int_res_iq);
`else
   buf inst9  (Q, int_res_iq);
   not inst10  (QN, int_res_iq);
`endif
`ifdef VIRL_functiononly
`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst11  (_net_0, SE);
not inst12  (_net_1, D);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, D);
and inst17  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, D);
not inst19  (_net_6, SI);
and inst20  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst21  (_net_7, D);
and inst22  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst26  (_net_10, SE);
and inst27  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst28  (_net_11, SI);
and inst29  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst30  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst31  (ENABLE_NOT_SE, SE);
not inst32  (_net_12, D);
and inst33  (ENABLE_NOT_D_AND_SI, SI, _net_12);
not inst34  (_net_13, SI);
and inst35  (ENABLE_D_AND_NOT_SI, _net_13, D);
not inst36  (_net_14, D);
and inst37  (ENABLE_NOT_D_AND_SE, SE, _net_14);
and inst38  (ENABLE_D_AND_SE, SE, D);

specify
(posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE , posedge D &&& ENABLE_NOT_SE , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE , negedge D &&& ENABLE_NOT_SE , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
`endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKINV_4 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKINV_8 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKINV_CK_4 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKINV_CK_8 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKMUX2_CKY2_4 (Z, CLK1, CLK2, CLKSEL);
  input CLK1, CLK2, CLKSEL;
  output Z;
  wire Z_int;
  reg viol_0;


    snps_mux2 inst0  (Z_int, CLK2, CLK1, CLKSEL);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, Z_int);
  `else
    buf inst2  (Z, Z_int);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst3  (ENABLE_NOT_CLK2, CLK2);
not inst4  (ENABLE_NOT_CLK1, CLK1);

specify
if (CLK2==1'b0 && CLKSEL==1'b0) (CLK1 +=> Z)=(0, 0);
if (CLK2==1'b1 && CLKSEL==1'b0) (CLK1 +=> Z)=(0, 0);
if (CLK1==1'b0 && CLKSEL==1'b1) (CLK2 +=> Z)=(0, 0);
if (CLK1==1'b1 && CLKSEL==1'b1) (CLK2 +=> Z)=(0, 0);
if (CLK1==1'b1 && CLK2==1'b0) (CLKSEL -=> Z)=(0, 0);
if (CLK1==1'b0 && CLK2==1'b1) (CLKSEL +=> Z)=(0, 0);
$hold(negedge CLK1 &&& ENABLE_NOT_CLK2 , posedge CLKSEL &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$hold(negedge CLK1 &&& ENABLE_NOT_CLK2 , negedge CLKSEL &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$setup(posedge CLKSEL &&& ENABLE_NOT_CLK2 , posedge CLK1 &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$setup(negedge CLKSEL &&& ENABLE_NOT_CLK2 , posedge CLK1 &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$hold(negedge CLK2 &&& ENABLE_NOT_CLK1 , posedge CLKSEL &&& ENABLE_NOT_CLK1 , 0 , viol_0);
$hold(negedge CLK2 &&& ENABLE_NOT_CLK1 , negedge CLKSEL &&& ENABLE_NOT_CLK1 , 0 , viol_0);
$setup(posedge CLKSEL &&& ENABLE_NOT_CLK1 , posedge CLK2 &&& ENABLE_NOT_CLK1 , 0 , viol_0);
$setup(negedge CLKSEL &&& ENABLE_NOT_CLK1 , posedge CLK2 &&& ENABLE_NOT_CLK1 , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKMUX2_CK_1 (Z, CLK1, CLK2, CLKSEL);
  input CLK1, CLK2, CLKSEL;
  output Z;
  wire Z_int;
  reg viol_0;


    snps_mux2 inst0  (Z_int, CLK2, CLK1, CLKSEL);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, Z_int);
  `else
    buf inst2  (Z, Z_int);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst3  (ENABLE_NOT_CLK2, CLK2);
not inst4  (ENABLE_NOT_CLK1, CLK1);

specify
if (CLK2==1'b0 && CLKSEL==1'b0) (CLK1 +=> Z)=(0, 0);
if (CLK2==1'b1 && CLKSEL==1'b0) (CLK1 +=> Z)=(0, 0);
if (CLK1==1'b0 && CLKSEL==1'b1) (CLK2 +=> Z)=(0, 0);
if (CLK1==1'b1 && CLKSEL==1'b1) (CLK2 +=> Z)=(0, 0);
if (CLK1==1'b1 && CLK2==1'b0) (CLKSEL -=> Z)=(0, 0);
if (CLK1==1'b0 && CLK2==1'b1) (CLKSEL +=> Z)=(0, 0);
$hold(negedge CLK1 &&& ENABLE_NOT_CLK2 , posedge CLKSEL &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$hold(negedge CLK1 &&& ENABLE_NOT_CLK2 , negedge CLKSEL &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$setup(posedge CLKSEL &&& ENABLE_NOT_CLK2 , posedge CLK1 &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$setup(negedge CLKSEL &&& ENABLE_NOT_CLK2 , posedge CLK1 &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$hold(negedge CLK2 &&& ENABLE_NOT_CLK1 , posedge CLKSEL &&& ENABLE_NOT_CLK1 , 0 , viol_0);
$hold(negedge CLK2 &&& ENABLE_NOT_CLK1 , negedge CLKSEL &&& ENABLE_NOT_CLK1 , 0 , viol_0);
$setup(posedge CLKSEL &&& ENABLE_NOT_CLK1 , posedge CLK2 &&& ENABLE_NOT_CLK1 , 0 , viol_0);
$setup(negedge CLKSEL &&& ENABLE_NOT_CLK1 , posedge CLK2 &&& ENABLE_NOT_CLK1 , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKND2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKND2_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKND2_CK_4 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKND2_CK_8 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKNR2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

`celldefine
module HDBULT11_MRKNR2_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

