//======================================================================
//                       Zen RTL design file
//=======================================================================
//                  AMD PROPRIETARY AND CONFIDENTIAL
//           (c) Copyright 2012 Advanced Micro Devices, Inc.
//=======================================================================
// Module Description:
// Behavioral model for phi2 transparent latch.
//=======================================================================

`timescale 1ps/1ps

module integ_clk_gater_mapsmro
 #(parameter WIDTH=1             // default WIDTH of output
   ) 
  (
   output     [WIDTH-1:0] clkg,     // data out
   input                  clk,   // clock
   input      [WIDTH-1:0] d      // data in
   );

reg [WIDTH-1:0] lat2_q;

// Turn off the rule that checks for latches
// leda NTL_STR47 off
// leda W410 off
// leda XPROP_IF off
always @*
    if (~clk)
        lat2_q <= d;
// leda NTL_STR47 on
// leda W410 on
// leda XPROP_IF on

assign clkg = lat2_q & clk;

endmodule
