
module kc_rdtree_remainder_GV #(parameter SIZE = 1, WIDTH = 4, ND = 1)(
  input                      [SIZE-1:0] Data,                 // qualified data array, inverted
  output logic           [(SIZE % WIDTH > 0 ? SIZE/WIDTH+1 : SIZE/WIDTH)-1:0] RdData                // read data
);

// BOZO: gates should really be based off width, right now assuming nr is always size 2
//localparam WIDTH1
//localparam WIDTH2

generate
  if (SIZE == 1) begin
    HDBULT08_INV_2 I_GV_remainder0(.X(RdData[0]), .A(Data[0]));
  end
  else if (SIZE == 2) begin
    if (ND == 1) begin
      HDBULT08_ND2_2 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]));
    end
    else begin
      HDBULT08_NR2_2 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]));
    end
  end
  else if (SIZE == 3) begin
    if (ND == 1) begin
      HDBULT08_ND3_2 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]), .A3(Data[2]));
    end
    else begin
      if (WIDTH == 2) begin
        HDBULT08_NR2_2 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]));
        HDBULT08_INV_2 I_GV_remainder1(.X(RdData[1]), .A(Data[2]));
      end
      else begin
        HDBULT08_NR3_2 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]), .A3(Data[2]));
      end
    end
  end
  else if (SIZE == 4) begin
    if (ND == 1) begin
      HDBULT08_ND4_1 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]), .A3(Data[2]), .A4(Data[3]));
    end
    else begin
      if (WIDTH == 2) begin
        HDBULT08_NR2_2 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]));
        HDBULT08_NR2_2 I_GV_remainder1(.X(RdData[1]), .A1(Data[2]), .A2(Data[3]));
      end
      else begin
        HDBULT08_NR4_1 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]), .A3(Data[2]), .A4(Data[3]));      
      end
    end
  end
  else if (SIZE == 5) begin
    if (ND == 1) begin
      HDBULT08_ND3_2 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]), .A3(Data[2]));
      HDBULT08_ND2_2 I_GV_remainder1(.X(RdData[1]), .A1(Data[3]), .A2(Data[4]));      
    end
    else begin
      if (WIDTH == 2) begin
        HDBULT08_NR2_2 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]));
        HDBULT08_NR2_2 I_GV_remainder1(.X(RdData[1]), .A1(Data[2]), .A2(Data[3]));
        HDBULT08_INV_2 I_GV_remainder2(.X(RdData[2]), .A(Data[4]));
      end
      else begin
        HDBULT08_NR3_2 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]), .A3(Data[2]));
        HDBULT08_NR2_2 I_GV_remainder1(.X(RdData[1]), .A1(Data[3]), .A2(Data[4]));
      end         
    end
  end
  else if (SIZE == 6) begin
    if (ND == 1) begin
      HDBULT08_ND3_2 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]), .A3(Data[2]));
      HDBULT08_ND3_2 I_GV_remainder1(.X(RdData[1]), .A1(Data[3]), .A2(Data[4]), .A3(Data[5]));
    end
    else begin
      if (WIDTH == 2) begin
        HDBULT08_NR2_2 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]));
        HDBULT08_NR2_2 I_GV_remainder1(.X(RdData[1]), .A1(Data[2]), .A2(Data[3]));
        HDBULT08_NR2_2 I_GV_remainder2(.X(RdData[2]), .A1(Data[4]), .A2(Data[5]));
      end
      else begin
        HDBULT08_NR3_2 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]), .A3(Data[2]));
        HDBULT08_NR3_2 I_GV_remainder1(.X(RdData[1]), .A1(Data[3]), .A2(Data[4]), .A3(Data[5]));
      end
    end
  end
  else if (SIZE == 7) begin
    if (ND == 1) begin
      HDBULT08_ND4_1 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]), .A3(Data[2]), .A4(Data[3]));        
      HDBULT08_ND3_2 I_GV_remainder1(.X(RdData[1]), .A1(Data[4]), .A2(Data[5]), .A3(Data[6]));
    end
    else begin
      HDBULT08_NR4_1 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]), .A3(Data[2]), .A4(Data[3]));        
      HDBULT08_NR3_2 I_GV_remainder1(.X(RdData[1]), .A1(Data[4]), .A2(Data[5]), .A3(Data[6]));
    end
  end
  else if (SIZE == 8) begin
    if (ND == 1) begin
      HDBULT08_ND4_1 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]), .A3(Data[2]), .A4(Data[3]));        
      HDBULT08_ND4_1 I_GV_remainder1(.X(RdData[1]), .A1(Data[4]), .A2(Data[5]), .A3(Data[6]), .A4(Data[7]));
    end
    else begin
      HDBULT08_NR4_1 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]), .A3(Data[2]), .A4(Data[3]));        
      HDBULT08_NR4_1 I_GV_remainder1(.X(RdData[1]), .A1(Data[4]), .A2(Data[5]), .A3(Data[6]), .A4(Data[7]));
    end
  end
  else if (SIZE == 9) begin
    if (ND == 1) begin
      HDBULT08_ND3_2 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]), .A3(Data[2]));        
      HDBULT08_ND3_2 I_GV_remainder1(.X(RdData[1]), .A1(Data[3]), .A2(Data[4]), .A3(Data[5]));        
      HDBULT08_ND3_2 I_GV_remainder2(.X(RdData[2]), .A1(Data[6]), .A2(Data[7]), .A3(Data[8]));
    end
    else begin
      HDBULT08_NR3_2 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]), .A3(Data[2]));        
      HDBULT08_NR3_2 I_GV_remainder1(.X(RdData[1]), .A1(Data[3]), .A2(Data[4]), .A3(Data[5]));        
      HDBULT08_NR3_2 I_GV_remainder2(.X(RdData[2]), .A1(Data[6]), .A2(Data[7]), .A3(Data[8]));
    end
  end
  else if (SIZE == 10) begin
    if (ND == 1) begin
      HDBULT08_ND4_1 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]), .A3(Data[2]), .A4(Data[3]));        
      HDBULT08_ND3_2 I_GV_remainder1(.X(RdData[1]), .A1(Data[4]), .A2(Data[5]), .A3(Data[6]));        
      HDBULT08_ND3_2 I_GV_remainder2(.X(RdData[2]), .A1(Data[7]), .A2(Data[8]), .A3(Data[9]));
    end
    // there are no nr4
  end 
  else if (SIZE == 11) begin
    if (ND == 1) begin
      HDBULT08_ND4_1 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]), .A3(Data[2]), .A4(Data[3]));        
      HDBULT08_ND4_1 I_GV_remainder1(.X(RdData[1]), .A1(Data[4]), .A2(Data[5]), .A3(Data[6]), .A4(Data[7]));        
      HDBULT08_ND3_2 I_GV_remainder2(.X(RdData[2]), .A1(Data[8]), .A2(Data[9]), .A3(Data[10]));
    end
    // there are no nr4    
  end 
  else if (SIZE == 12) begin
    if (ND == 1) begin
      HDBULT08_ND4_1 I_GV_remainder0(.X(RdData[0]), .A1(Data[0]), .A2(Data[1]), .A3(Data[2]), .A4(Data[3]));        
      HDBULT08_ND4_1 I_GV_remainder1(.X(RdData[1]), .A1(Data[4]), .A2(Data[5]), .A3(Data[6]), .A4(Data[7]));
      HDBULT08_ND4_1 I_GV_remainder2(.X(RdData[2]), .A1(Data[8]), .A2(Data[9]), .A3(Data[10]), .A4(Data[11]));
    end
    // there are no nr4        
  end
endgenerate

endmodule


module kc_tree_level_GV #(parameter SIZE = 1, WIDTH = 4, ND = 1)(
  output logic         [(SIZE % WIDTH > 0 ? SIZE/WIDTH+1 : SIZE/WIDTH)-1:0] RdData,              // read data
  input                      [SIZE-1:0] Data                 // qualified data array, inverted
);
// BOZO: this doesn't utilize more than 2 remainder gates
localparam SMALL_TREE = SIZE <= WIDTH * 3;
localparam REMAINDER = SIZE % WIDTH;
localparam REMAINDER_BITS = SMALL_TREE ? SIZE : REMAINDER > 0 ? REMAINDER + WIDTH : 0;
localparam REMAINDER_GATES = REMAINDER > 0 ? REMAINDER_BITS / WIDTH + 1 : REMAINDER_BITS / WIDTH;

localparam GATES = REMAINDER > 0 ? SIZE / WIDTH + 1 : SIZE / WIDTH;
localparam NORMGATES = GATES - REMAINDER_GATES;

genvar gi;
generate
  for (gi=0; gi<NORMGATES; gi++) begin : glevel
    if (ND == 1) begin
      HDBULT08_ND4_1 I_GV(.X(RdData[gi]), .A1(Data[gi*4]), .A2(Data[gi*4+1]), .A3(Data[gi*4+2]), .A4(Data[gi*4+3]));
    end
    else begin
      HDBULT08_NR2_2 I_GV(.X(RdData[gi]), .A1(Data[gi*2]), .A2(Data[gi*2+1]));
    end
  end

  if (REMAINDER_GATES > 0) begin : glevel_remainder
    kc_rdtree_remainder_GV #(REMAINDER_BITS, WIDTH, ND) I_GV(.Data(Data[SIZE-1:SIZE-REMAINDER_BITS]),
                                                             .RdData(RdData[NORMGATES+:REMAINDER_GATES]));
  end
endgenerate

endmodule

// Expand for any number of levels
module kc_rdtree_GV #(parameter SIZE = 1, OR = 1)(
  input                      [SIZE-1:0] Data,                 // qualified data
  output logic                          RdData                  // read data
);

genvar gi;

// NOTE: can't use ceil in synthesizable code
localparam LEVEL0_GATES = SIZE % 4 > 0 ? SIZE / 4 + 1 : SIZE / 4;

// level1 is done with nr2
localparam LEVEL1_WIDTH = SIZE <= 12 ? 3 : 2;
localparam LEVEL1_GATES = LEVEL0_GATES % LEVEL1_WIDTH > 0 ? LEVEL0_GATES / LEVEL1_WIDTH + 1 : LEVEL0_GATES / LEVEL1_WIDTH;

// level2 is done with nd4
localparam LEVEL2_GATES = LEVEL1_GATES % 4 > 0 ? LEVEL1_GATES / 4 + 1 : LEVEL1_GATES / 4;

// level3 is done with nr4
localparam LEVEL3_GATES = LEVEL2_GATES % 4 > 0 ? LEVEL2_GATES / 4 + 1 : LEVEL2_GATES / 4;

logic [LEVEL0_GATES-1:0] level0;
logic [LEVEL1_GATES-1:0] level1;
logic [LEVEL2_GATES-1:0] level2;
logic [LEVEL3_GATES-1:0] level3;

kc_tree_level_GV #(SIZE)               I_level0(.RdData(level0[LEVEL0_GATES-1:0]),
                                                .Data(Data[SIZE-1:0]));

generate
  if (SIZE > 4 & SIZE <= 12) begin : smalltree
    // allow level1 to have >nr2 gates
    kc_tree_level_GV #(LEVEL0_GATES, LEVEL1_WIDTH, 0) I_level1(.RdData(level1[LEVEL1_GATES-1:0]), 
                                                               .Data(level0[LEVEL0_GATES-1:0]));
  end
  if (SIZE > 12) begin : bigtree
    kc_tree_level_GV #(LEVEL0_GATES, LEVEL1_WIDTH, 0) I_level1(.RdData(level1[LEVEL1_GATES-1:0]), 
                                                               .Data(level0[LEVEL0_GATES-1:0]));
    kc_tree_level_GV #(LEVEL1_GATES)       I_level2(.RdData(level2[LEVEL2_GATES-1:0]), 
                                                    .Data(level1[LEVEL1_GATES-1:0]));
  end
  if (SIZE > 32) begin : hugetree
    kc_tree_level_GV #(LEVEL2_GATES, 4, 0) I_level3(.RdData(level3[LEVEL3_GATES-1:0]), 
                                                    .Data(level2[LEVEL2_GATES-1:0]));
  end

  if (OR == 1) begin : ortree
    if (SIZE <= 4) begin : tinytree
      assign RdData = level0[0];
    end
    else if (SIZE <= 12) begin : smalltree
      assign RdData = ~level1[0];
    end
    else if (SIZE <= 32) begin : bigtree
      assign RdData = level2[0];
    end
    else begin : hugetree
      assign RdData = |(~level3[LEVEL3_GATES-1:0]);
    end
  end
  else begin : andtree
    if (SIZE <= 4) begin : tinytree
      assign RdData = ~level0[0];
    end
    else if (SIZE <= 12) begin : smalltree
      assign RdData = level1[0];
    end
    else if (SIZE <= 32) begin : bigtree
      assign RdData = ~level2[0];
    end
    else begin : hugetree
      assign RdData = &level3[LEVEL3_GATES-1:0];
    end
  end
endgenerate

endmodule

module kc_qual_GV #(parameter SIZE = 1, AOI = 0)(
   input [SIZE-1:0]        Data,
   input [SIZE-1:0]        Qual,
   output logic [SIZE-1:0] QualData_X
);

localparam NAND_GATES = AOI == 1 ? SIZE % 2 : SIZE;
localparam AOI_GATES = AOI == 1 ? SIZE / 2 : 0;
localparam NAND_START = AOI_GATES * 2;
localparam NAND_OUT_START = AOI_GATES;
localparam OUTPUT_SIZE = NAND_GATES + AOI_GATES;

genvar                    gi;

generate
   for (gi=0; gi<AOI_GATES; gi++) begin : aoi
      HDBULT08_AOI22_1 I_GV(.X(QualData_X[gi]), .A1(Qual[gi*2+1]), .A2(Data[gi*2+1]), .B1(Qual[gi*2]), .B2(Data[gi*2]));
   end

   for (gi=0; gi<NAND_GATES; gi++) begin : nd   
      HDBULT08_ND2_1 I_GV(.X(QualData_X[NAND_OUT_START+gi]), .A1(Qual[NAND_START+gi]), .A2(Data[NAND_START+gi]));
   end
endgenerate

endmodule

module kc_rdport_GV #(parameter SIZE = 1, PARTS = 1, AOI = 0)(
  input                      [SIZE-1:0] RdSel,                  // one-hot read pointer
  input                      [SIZE-1:0] Data,                   // data array
  output logic              [PARTS-1:0] RdData                  // read data
);

localparam PSIZE = SIZE / PARTS; // SIZE must be a multiple of part
localparam AOI_PSIZE = AOI == 1 ? PSIZE % 2 > 0 ? PSIZE / 2 + 1 : PSIZE / 2 : PSIZE;

logic          [SIZE-1:0] QualData;
genvar                    gi;

generate
   for (gi=0; gi<PARTS; gi++) begin : part
      kc_qual_GV #(PSIZE, AOI) I_QualData(.Data(Data[gi*PSIZE+:PSIZE]),
                                          .Qual(RdSel[gi*PSIZE+:PSIZE]),
                                          .QualData_X(QualData[gi*PSIZE+:PSIZE]));
      kc_rdtree_GV #(AOI_PSIZE) I_rdtree (.Data(QualData[gi*PSIZE+:AOI_PSIZE]),
                                          .RdData(RdData[gi]));
   end
endgenerate

endmodule




module kc_wrport_GV #(parameter SIZE = 1, PORTS = 1, LOOPBACK = 0)(
  output logic               [SIZE-1:0] NxtData,                // new array data
  input                      [SIZE-1:0] Data,                   // data array
  input           [PORTS-1:0][SIZE-1:0] WrEn,                   // write enable per port and entry
  input                      [SIZE-1:0] WrEnLb,                 // loopback write enable  
  input                     [PORTS-1:0] WrData                  // write data per port
);

localparam PORTS_LB = PORTS + LOOPBACK;
localparam NORM_GATES = PORTS_LB / 2;
localparam EXTRA = PORTS_LB % 2;
localparam QUAL_GATES = NORM_GATES + EXTRA;

localparam LEVEL1 = QUAL_GATES > 3 ? QUAL_GATES % 4 > 0 ? QUAL_GATES/4 + 1 : QUAL_GATES/4 : 1;

logic                 [PORTS_LB-1:0][SIZE-1:0] WrData_Lb;
logic                 [PORTS_LB-1:0][SIZE-1:0] WrEn_Lb;
logic                 [SIZE-1:0][PORTS_LB-1:0] WrData_LbT;
logic                 [SIZE-1:0][PORTS_LB-1:0] WrEn_LbT;
logic                 [SIZE-1:0][PORTS_LB-1:0] WrMux_out; // 2nd be QUAL_DATA, larger to support kc_qual_GV
logic                   [SIZE-1:0][LEVEL1-1:0] NxtData_out;

genvar                    gi;
genvar                    gj;

always_comb for(int i=0; i<PORTS; i++) begin
  WrData_Lb[i][SIZE-1:0] = {SIZE{WrData[i]}};
  WrEn_Lb[i][SIZE-1:0] = WrEn[i][SIZE-1:0];
end

kc_transpose2d #(PORTS_LB, SIZE) transpose_WrDataLB(.in(WrData_Lb[PORTS_LB-1:0]), .out(WrData_LbT[SIZE-1:0]));
kc_transpose2d #(PORTS_LB, SIZE) transpose_WrEnLB(.in(WrEn_Lb[PORTS_LB-1:0]), .out(WrEn_LbT[SIZE-1:0]));

generate
  if (PORTS_LB == 1) begin : SinglePort
    for (gj=0; gj<SIZE; gj++) begin : Entry
      assign NxtData_out[gj][0] = WrData_Lb[0][gj];
    end
  end
  else begin : MultiPort
    if (LOOPBACK == 1) begin : Loopback
      assign WrData_Lb[PORTS_LB-1][SIZE-1:0] = Data[SIZE-1:0];
      assign WrEn_Lb[PORTS_LB-1][SIZE-1:0] = WrEnLb[SIZE-1:0];
    end
    for (gi=0; gi<SIZE; gi++) begin : Entry
      kc_qual_GV #(PORTS_LB, 1) I_WrMux(.Data(WrData_LbT[gi]), 
                                        .Qual(WrEn_LbT[gi]),
                                        .QualData_X(WrMux_out[gi]));
      kc_tree_level_GV #(QUAL_GATES) WrMux_Final_I_GV(.RdData(NxtData_out[gi][LEVEL1-1:0]), 
                                                      .Data(WrMux_out[gi][QUAL_GATES-1:0]));
    end
  end
endgenerate

always_comb for (int i=0;i<SIZE;i++) NxtData[i] = |NxtData_out[i][LEVEL1-1:0];

endmodule



module kc_camport_GV #(parameter SIZE = 1, PARTS = 1, FULLCAM = 1)(
  input                     [PARTS-1:0] CamData,                // cam data
  input                      [SIZE-1:0] Data,                   // data array
  output logic               [SIZE-1:0] CamMatch                // cam match
);
localparam PSIZE = SIZE / PARTS; // SIZE must be a multiple of part
logic                        [SIZE-1:0] CamDataExt;

always_comb for (int i=0;i<SIZE;i++) CamDataExt[i] = CamData[i/PSIZE];

generate
  if (FULLCAM == 1) begin : fullcam
    HDBULT08_EO2_V2Y2_1 I_GV_CamXr[SIZE-1:0](.X(CamMatch[SIZE-1:0]), .A1(CamDataExt[SIZE-1:0]), .A2(Data[SIZE-1:0]));
  end
  else begin : partialcam
    HDBULT08_EN2_V2Y2_1 I_GV_CamXr[SIZE-1:0](.X(CamMatch[SIZE-1:0]), .A1(CamDataExt[SIZE-1:0]), .A2(Data[SIZE-1:0]));    
  end
endgenerate

endmodule



module kc_floparray_GV #(parameter WIDTH = 16, SIZE = 16, RDPORTS = 1, CAMPORTS = 1, WRPORTS = 1, LOOPBACK = 0, ZERODEFAULT = 0, RDPARTS = 1, CAMPARTS = 1, WRCHK = 1, QUAD = 0, READAOI = 1, FULLCAM = 0)(
  input                      [SIZE-1:0] RCLK_AR,                // fine gated write clock for each entry
  input                                 SSE,                    // scan shift enable
  input                   [WRPORTS-1:0] WrEn,                   // write enable per port, can be tied to 1 with accurate gating
  input         [WRPORTS-1:0][SIZE-1:0] WrSel,                  // one hot write select per port, can be tied to 1 with accurate gating
  input        [WRPORTS-1:0][WIDTH-1:0] WrData,                 // write data per port
  input          [CAMPORTS:1][SIZE-1:0] CamEn,                  // cam enable bit per entry, usually the valid bit
  input         [CAMPORTS:1][WIDTH-1:0] CamMask,                // cam mask bits, set to 1 for bits to ignore in cam
  input         [CAMPORTS:1][CAMPARTS-1:0][WIDTH-1:0] CamData,  // data to cam for (can also connect 1D or 2D vector here)
  input         [RDPORTS-1:0][SIZE-1:0] RdSel,                  // one hot read select per port

  output logic[RDPORTS-1:0][RDPARTS-1:0][WIDTH-1:0] RdData,     // data read from array (can also connect 1D or 2D vector here)
  output logic   [CAMPORTS:1][SIZE-1:0] CamMatch,               // cam data matched provided entry (per port)
  output logic    [SIZE-1:0][WIDTH-1:0] Data                    // reference to storage array (for debug or complicated cam functions)
);
logic                  [WIDTH-1:0][WRPORTS-1:0] WrDataT;
logic     [WIDTH-1:0][RDPORTS-1:0][RDPARTS-1:0] RdDataT;
logic     [WIDTH-1:0][CAMPORTS:1][CAMPARTS-1:0] CamDataT;
logic         [WIDTH-1:0][CAMPORTS:1][SIZE-1:0] CamMatchT;
logic         [SIZE-1:0][CAMPORTS:1][WIDTH-1:0] CamMatchTT;
logic                    [SIZE-1:0][CAMPORTS:1] CamEnT;
logic                    [SIZE-1:0][CAMPORTS:1] CamHitT;
logic                     [WIDTH-1:0][SIZE-1:0] DataT;
logic                     [WIDTH-1:0][SIZE-1:0] NxtData;
logic                   [WRPORTS-1:0][SIZE-1:0] FinalWrEn;
logic                   [SIZE-1:0][WRPORTS-1:0] FinalWrEnT;
logic                                [SIZE-1:0] LoopBackWrEn;

genvar gi;
generate
  for (gi=0; gi<WRPORTS; gi++) begin : WrPortLoop
    assign FinalWrEn[gi][SIZE-1:0] = {SIZE{WrEn[gi]}} & WrSel[gi][SIZE-1:0];
  end
endgenerate

kc_transpose2d #(WRPORTS, WIDTH) transpose_WrData(.in(WrData[WRPORTS-1:0]), .out(WrDataT[WIDTH-1:0]));

// Calculate loopback on a per entry basis
kc_transpose2d #(WRPORTS, SIZE) I_FinalWrEnT(.in(FinalWrEn[WRPORTS-1:0]), .out(FinalWrEnT[SIZE-1:0]));

always_comb for (int i=0; i<SIZE; i++) begin : WrEntryLoop
   LoopBackWrEn[i] = |LOOPBACK ? ~|FinalWrEnT[i][WRPORTS-1:0] : 1'b0;
end

// 3D array transpose
genvar camport;
generate
  for (camport=1; camport<=CAMPORTS; camport++) begin : camportloop0
    always_comb for (int i=0; i<WIDTH; i++) for (int j=0; j<CAMPARTS; j++) CamDataT[i][camport][j] = CamData[camport][j][i];
  end
endgenerate

localparam SINGLES = QUAD == 0 ? WIDTH : WIDTH%4;
localparam SINGLE_START = QUAD == 0 ? 0 : WIDTH-SINGLES;
localparam QUADS = QUAD == 0 ? 0 : WIDTH/4;
localparam QUAD_WIDTH = QUAD == 0 ? 0 : QUADS*4;

// the actual flop array
generate
  for (gi=0; gi<QUADS; gi++) begin : I_ArrayQ
    //quad_flop I_Data[SIZE-1:0](Data[SIZE-1:0][gi*4+:4], RCLK_AR[SIZE-1:0], NxtData[SIZE-1:0][gi*4+:4]);
    HDBULT08_FSDPQM4SS_V2Y8_1 I_Data[SIZE-1:0](.Q0(DataT[gi*4+0][SIZE-1:0]), .Q1(DataT[gi*4+1][SIZE-1:0]), .Q2(DataT[gi*4+2][SIZE-1:0]), .Q3(DataT[gi*4+3][SIZE-1:0]), .CK(RCLK_AR[SIZE-1:0]), .D0(NxtData[gi*4+0][SIZE-1:0]), .D1(NxtData[gi*4+1][SIZE-1:0]), .D2(NxtData[gi*4+2][SIZE-1:0]), .D3(NxtData[gi*4+3][SIZE-1:0]), .SI(1'b0), .SE(1'b0));
  end

  for (gi=0; gi<SINGLES; gi++) begin : I_ArrayS
     kc_dff I_Data[SIZE-1:0](.q(DataT[SINGLE_START+gi][SIZE-1:0]), 
                             .clk(RCLK_AR[SIZE-1:0]),
                             .d(NxtData[SINGLE_START+gi][SIZE-1:0]),
                             .SSE(SSE));
  end
endgenerate

// instantiate array of bit slices
kc_bitslice_GV #(SIZE, RDPORTS, CAMPORTS, WRPORTS, LOOPBACK, RDPARTS, CAMPARTS, 0, READAOI, FULLCAM) I_Array[WIDTH-1:0](
  .WrEn(FinalWrEn[WRPORTS-1:0]),
  .WrEnLb(LoopBackWrEn[SIZE-1:0]),
  .WrData(WrDataT[WIDTH-1:0]), 
  .CamData(CamDataT[WIDTH-1:0]),
  .RdSel(RdSel[RDPORTS-1:0]),
  .RdData(RdDataT[WIDTH-1:0]),
  .CamMatch(CamMatchT[WIDTH-1:0]),
  .NxtData(NxtData[WIDTH-1:0]),
  .Data(DataT[WIDTH-1:0])
);
kc_transpose2d #(WIDTH, SIZE) transpose_Data(.in(DataT[WIDTH-1:0]), .out(Data[SIZE-1:0]));

// 3D array transpose
always_comb 
  for (int i=0; i<WIDTH; i++) for (int j=0; j<RDPORTS; j++) for (int k=0; k<RDPARTS; k++)
    RdData[j][k][i] = RdDataT[i][j][k];

// 3D array transpose
generate
  for (camport=1; camport<=CAMPORTS; camport++) begin : camportloop
    always_comb for (int i=0; i<WIDTH; i++) for (int j=0; j<SIZE; j++) CamMatchTT[j][camport][i] = CamMatchT[i][camport][j];
  end
  if (CAMPORTS > 0) begin : camportif
    kc_transpose2d #(CAMPORTS, SIZE) transpose_CamEn(.in(CamEn[CAMPORTS:1]), .out(CamEnT[SIZE-1:0]));

    // cam match AND reduction tree
    kc_camtree_GV #(WIDTH, CAMPORTS, FULLCAM) cam_tree[SIZE-1:0](.CamMatch(CamMatchTT[SIZE-1:0]),
                                                                 .CamMask(CamMask[CAMPORTS:1]),
                                                                 .CamEn(CamEnT[SIZE-1:0]),
                                                                 .CamHit(CamHitT[SIZE-1:0]));

    kc_transpose2d #(SIZE, CAMPORTS) transpose_CamMatch(.in(CamHitT[SIZE-1:0]), .out(CamMatch[CAMPORTS:1]));
  end
endgenerate
  
endmodule


module kc_bitslice_GV #(parameter SIZE = 1, RDPORTS = 1, CAMPORTS = 1, WRPORTS = 1, LOOPBACK = 0, RDPARTS = 1, CAMPARTS = 1, MBIST = 0, READAOI = 0, FULLCAM = 1)(
  input         [WRPORTS-1:0][SIZE-1:0] WrEn,                   // this can be tied to 1 if the gater is accuarate
  input                      [SIZE-1:0] WrEnLb,                 // loopback write enable
  input                   [WRPORTS-1:0] WrData,                 // write data
  input      [CAMPORTS:1][CAMPARTS-1:0] CamData,                // cam data
  input         [RDPORTS-1:0][SIZE-1:0] RdSel,                  // one-hot read select
  input                                 LaunchModeEn,
  input                                 LaunchData,

  output logic[RDPORTS-1:0][RDPARTS-1:0] RdData,
  output logic   [CAMPORTS:1][SIZE-1:0] CamMatch,
  output logic               [SIZE-1:0] NxtData,

  input                      [SIZE-1:0] Data
);

localparam RDPARTSIZE  = SIZE / RDPARTS;  // SIZE must be a multiple of RDPARTS.
localparam SIZELM = SIZE+(MBIST*RDPARTS);

logic               [SIZELM-1:0] DataLM;
logic  [RDPORTS-1:0][SIZELM-1:0] RdSelLM;                  // one-hot read select

kc_wrport_GV #(SIZE, WRPORTS, LOOPBACK) wrport(.NxtData(NxtData[SIZE-1:0]),
                                               .Data(Data[SIZE-1:0]),
                                               .WrEn(WrEn[WRPORTS-1:0]),
                                               .WrEnLb(WrEnLb[SIZE-1:0]),
                                               .WrData(WrData[WRPORTS-1:0]));

genvar gi;
genvar gj;
genvar gk;
generate

  if (MBIST == 1) begin : mbist
    for (gi=0; gi<RDPARTS; gi++) begin : partloop
      for (gj=0; gj<RDPARTSIZE; gj++) begin : partsizeloop
        assign DataLM[gi*(RDPARTSIZE+1)+gj] = Data[gi*RDPARTSIZE+gj];
        
        for (gk=0; gk<RDPORTS; gk++) begin : rdportloop
          assign RdSelLM[gk][gi*(RDPARTSIZE+1)+gj] = RdSel[gk][gi*RDPARTSIZE+gj];
        end
      end

      assign DataLM[gi*(RDPARTSIZE+1)+RDPARTSIZE] = LaunchData;
      
      for (gk=0; gk<RDPORTS; gk++) begin : rdportloop
        assign RdSelLM[gk][gi*(RDPARTSIZE+1)+RDPARTSIZE] = LaunchModeEn;
      end
    end 
  end
  else begin : nombist
    assign DataLM[SIZE-1:0] = Data[SIZE-1:0];
    assign RdSelLM[RDPORTS-1:0] = RdSel[RDPORTS-1:0];
  end

  // instantiate the read port(s)
  if (RDPORTS > 0) begin : rdportval
    kc_rdport_GV #(SIZELM, RDPARTS, READAOI) rdport[RDPORTS-1:0](.RdSel(RdSelLM[RDPORTS-1:0]),
                                                                 .Data(DataLM[SIZELM-1:0]),
                                                                 .RdData(RdData[RDPORTS-1:0]));
  end

  // instantiate the cam port(s)
  if (CAMPORTS > 0) begin : camportval
    kc_camport_GV #(SIZE, CAMPARTS, FULLCAM) camport[CAMPORTS:1](.CamData(CamData[CAMPORTS:1]),
                                                                 .Data(Data[SIZE-1:0]),
                                                                 .CamMatch(CamMatch[CAMPORTS:1]));
  end
endgenerate

endmodule


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// mod:kc_camtree:generic array cam AND tree (used for structured placement)
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
module kc_camtree_GV #(parameter WIDTH = 1, CAMPORTS = 1, FULLCAM = 1)(
  input         [CAMPORTS:1][WIDTH-1:0] CamMatch,               // cam match per bit
  input         [CAMPORTS:1][WIDTH-1:0] CamMask,                // cam mask per bit, 1 forces hit
  input                    [CAMPORTS:1] CamEn,                  // cam enable per entry, 0 forces miss
  output logic             [CAMPORTS:1] CamHit                  // cam hit
);
genvar                                  gi;

logic [CAMPORTS:1][WIDTH-1:0] CamQual;


// BOZO: do we really want an aoi here if CamEn/CamMask are constant
//Design agreed to swap (CamMatch | CamMask) & (CamEn) for AOI
generate 
  for (gi=1; gi<=CAMPORTS; gi++) begin : camloop
    if (FULLCAM == 1) begin : fullcam
      HDBULT08_AOI21_2 I_GV_QualCam[WIDTH-1:0](.X(CamQual[gi]), .B({WIDTH{~CamEn[gi]}}), .A1(CamMatch[gi][WIDTH-1:0]), .A2(~CamMask[gi][WIDTH-1:0]));
      kc_rdtree_GV #(WIDTH, 0) I_rdtree(.Data(CamQual[gi][WIDTH-1:0]), 
                                        .RdData(CamHit[gi]));
    end
    else begin : partialcam
      assign CamHit[gi] = &((CamMatch[gi][WIDTH-1:0] | CamMask[gi][WIDTH-1:0]) & {WIDTH{CamEn[gi]}});
    end
  end
endgenerate

endmodule






//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// A-latch array
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

module kc_lat1array_GV #(parameter WIDTH = 16, SIZE = 16, RDPORTS = 1, CAMPORTS = 1, WRPORTS = 1, ZERODEFAULT = 0, RDPARTS = 1, CAMPARTS = 1, MBIST = 0, WRCHK = 1, WR_EN_LATCH = 1, WR_SEL_LATCH = 1, WR_DATA_LATCH = 1, RESET_VEC = {WIDTH{1'b0}}, QUAD = 0, READAOI = 1, FULLCAM = 0)(
  input                      [SIZE-1:0] RCLK_AR,                // fine gated write clock for each entry
  input                                 SSE,                    // scan shift enable
  input                                 SDI,
  input                                 LaunchModeEn,
  input                                 LatchArrayScanInit,
  input                   [WRPORTS-1:0] WrEn,                   // write enable per port, can be tied to 1 with accurate gating
  input         [WRPORTS-1:0][SIZE-1:0] WrSel,                  // one hot write select per port, can be tied to 1 with accurate gating. Already latched wrsel connects here if WRLATCHED==1
  input        [WRPORTS-1:0][WIDTH-1:0] WrData,                 // write data per port
  input                   [WRPORTS-1:0] RCLK_Write_BF,  
  input                   [WRPORTS-1:0] RCLK_WriteEn_BF,        // in multiple write port configurations (and MBIST=0), WriteEn needs to clock for an extra cycle to allow de-assertion (otherwise next write to different port will OR WrData from stale port and "different" port);  adding extra WriteEn_BF avoids clocking WrData during extra cycle, thereby reducing total power
  input          [CAMPORTS:1][SIZE-1:0] CamEn,                  // cam enable bit per entry, usually the valid bit
  input         [CAMPORTS:1][WIDTH-1:0] CamMask,                // cam mask bits, set to 1 for bits to ignore in cam
  input         [CAMPORTS:1][CAMPARTS-1:0][WIDTH-1:0] CamData,  // data to cam for (can also connect 1D or 2D vector here)
  input         [RDPORTS-1:0][SIZE-1:0] RdSel,                  // one hot read select per port
  input                   [WRPORTS-1:0] RCLK_Write_AR,          // only for scantest=1

  output logic[RDPORTS-1:0][RDPARTS-1:0][WIDTH-1:0] RdData,     // data read from array (can also connect 1D or 2D vector here)
  output logic   [CAMPORTS:1][SIZE-1:0] CamMatch,               // cam data matched provided entry (per port)
  output logic                          SDO,
  output logic    [SIZE-1:0][WIDTH-1:0] Data                    // reference to storage array (for debug or complicated cam functions)
);

logic                  [WRPORTS-1:0][WIDTH-1:0] WrData_B;
logic                  [WIDTH-1:0][WRPORTS-1:0] WrDataT_B;
logic                  [WIDTH-1:0][WRPORTS-1:0] WrDataT_sse;
logic     [WIDTH-1:0][RDPORTS-1:0][RDPARTS-1:0] RdDataT;
logic     [WIDTH-1:0][CAMPORTS:1][CAMPARTS-1:0] CamDataT;
logic         [WIDTH-1:0][CAMPORTS:1][SIZE-1:0] CamMatchT;
logic         [SIZE-1:0][CAMPORTS:1][WIDTH-1:0] CamMatchTT;
logic                    [SIZE-1:0][CAMPORTS:1] CamEnT;
logic                    [SIZE-1:0][CAMPORTS:1] CamHitT;
logic                     [WIDTH-1:0][SIZE-1:0] DataT;
logic                     [WIDTH-1:0][SIZE-1:0] NxtData;
logic                   [WRPORTS-1:0][SIZE-1:0] FinalWrEn;
logic                   [WRPORTS-1:0][SIZE-1:0] FinalWrEn_B;
logic                   [WRPORTS-1:0][SIZE-1:0] WrSel_B;
logic                             [WRPORTS-1:0] WrEn_B;

logic                  [WRPORTS-1:0][WIDTH-1:0] WrData_sse;
logic                             [WRPORTS-1:0] WrEn_sse;

logic                  [WRPORTS-1:0] sdi;
logic                  [WRPORTS-1:0][WIDTH-1:0] WrData_d1;
logic                  [WRPORTS-1:0][WIDTH-1:0] WrData_mux;

genvar gi;
genvar wrport;

// 3D array transpose
genvar camport;
generate
  for (camport=1; camport<=CAMPORTS; camport++) begin : camportloop0
    always_comb for (int i=0; i<WIDTH; i++) for (int j=0; j<CAMPARTS; j++) CamDataT[i][camport][j] = CamData[camport][j][i];
  end
endgenerate

// WrEn/WrSel 
generate
  if ((WRPORTS == 1)) begin : wrportval_single
    // in the single wrport case, wrdata is hooked up directly to all storage latches
    assign FinalWrEn_B[0] = {SIZE{1'b1}};
  end
  else begin : wrportval_multi
    // WrSel latches
    if ((WR_SEL_LATCH == 0)) begin : wrsel_no_latch
      assign WrSel_B[WRPORTS-1:0] = WrSel[WRPORTS-1:0];
    end
    else begin : wrsel_latch
      kc_wrlatches #(SIZE, WRPORTS, MBIST) sel_latches(.Wr_B(WrSel_B[WRPORTS-1:0]),
                                                       .Wr(WrSel[WRPORTS-1:0]),
                                                       .RCLK_En_BF(RCLK_WriteEn_BF[WRPORTS-1:0]),
                                                       .SSE(SSE));
    end

    // WrEn latches    
    if ((WR_EN_LATCH == 0)) begin : wren_no_latch
      assign WrEn_B[WRPORTS-1:0] = WrEn[WRPORTS-1:0];
    end
    else begin : wren_latch
      kc_wrlatches #(1, WRPORTS, MBIST) en_latches(.Wr_B(WrEn_B[WRPORTS-1:0]), 
                                                   .Wr(WrEn[WRPORTS-1:0]), 
                                                   .RCLK_En_BF(RCLK_WriteEn_BF[WRPORTS-1:0]), 
                                                   .SSE(SSE));
    end
    
    for (gi=0; gi<WRPORTS; gi++) begin : WrPortLoop
      assign FinalWrEn_B[gi][SIZE-1:0] = {SIZE{WrEn_B[gi]}} & WrSel_B[gi][SIZE-1:0];
    end
  end
endgenerate

// WrData, LatInit, Scan shiftreg
generate
  if (MBIST == 1) begin : mbist_enable
    for(wrport=0; wrport<WRPORTS; wrport++) begin: gen_shift_reg
      // BOZO: may want to shift down/up every other wrport
      if (wrport == 0) begin : wrport0
        assign sdi[wrport] = SDI;
      end
      else begin : wrportgt0
        assign sdi[wrport] = WrData_d1[wrport-1];
      end
      assign WrData_mux[wrport][WIDTH-1:0] = SSE ? {WrData_d1[wrport][WIDTH-2:0],sdi[wrport]} 
                                                   : WrData[wrport][WIDTH-1:0] ;
    end
    
    assign WrData_sse[WRPORTS-1:0] = WrData_mux[WRPORTS-1:0];
    assign SDO = WrData_d1[WRPORTS-1];

    kc_lat1 #(.WIDTH(WIDTH)) I_WrData_d1[WRPORTS-1:0](.q(WrData_d1[WRPORTS-1:0]), 
                                                      .clk(RCLK_Write_AR[WRPORTS-1:0]), 
                                                      .d(WrData_B[WRPORTS-1:0]));
  end
  else begin : mbist_disable
    kc_SSE_RESET_AND #(.WIDTH(WIDTH), .RESET_VEC(RESET_VEC)) I_WRDATA_SSE[WRPORTS-1:0](
        .OUT(WrData_sse[WRPORTS-1:0]), 
        .SSE({WIDTH{LatchArrayScanInit}}), 
        .DATA(WrData[WRPORTS-1:0])
    );
    assign SDO = 1'b0;
    assign WrData_d1[WRPORTS-1:0] = {WRPORTS*WIDTH{1'b0}};
  end  

  if (WR_DATA_LATCH == 1) begin : wrdata_latch
    kc_lat2 #(.WIDTH(WIDTH)) I_WrData_B[WRPORTS-1:0](.q(WrData_B[WRPORTS-1:0]), 
                                                     .clk(RCLK_Write_BF[WRPORTS-1:0]), 
                                                     .d(WrData_sse[WRPORTS-1:0]));
  end
  else begin : wrdata_no_latch
    assign WrData_B[WRPORTS-1:0] = WrData[WRPORTS-1:0];
  end
endgenerate


kc_transpose2d #(WRPORTS, WIDTH) transpose_WrData(.in(WrData_B[WRPORTS-1:0]), .out(WrDataT_B[WIDTH-1:0]));

localparam SINGLES = QUAD == 0 ? WIDTH : WIDTH%4;
localparam SINGLE_START = QUAD == 0 ? 0 : WIDTH-SINGLES;
localparam QUADS = QUAD == 0 ? 0 : WIDTH/4;
localparam QUAD_WIDTH = QUAD == 0 ? 0 : QUADS*4;

// the actual latch array
generate
  for (gi=0; gi<QUADS; gi++) begin : I_ArrayQ
    //quad_flop I_Data[SIZE-1:0](Data[SIZE-1:0][gi*4+:4], RCLK_AR[SIZE-1:0], NxtData[SIZE-1:0][gi*4+:4]);
    HDBULT08_LDPQM4_V2Y4_1 I_Data[SIZE-1:0](.Q0(DataT[gi*4+0][SIZE-1:0]), .Q1(DataT[gi*4+1][SIZE-1:0]), .Q2(DataT[gi*4+2][SIZE-1:0]), .Q3(DataT[gi*4+3][SIZE-1:0]), .G(RCLK_AR[SIZE-1:0]), .D0(NxtData[gi*4+0][SIZE-1:0]), .D1(NxtData[gi*4+1][SIZE-1:0]), .D2(NxtData[gi*4+2][SIZE-1:0]), .D3(NxtData[gi*4+3][SIZE-1:0]));
  end

  for (gi=0; gi<SINGLES; gi++) begin : I_ArrayS
     kc_lat1 I_Data[SIZE-1:0](.q(DataT[SINGLE_START+gi][SIZE-1:0]), 
                              .clk(RCLK_AR[SIZE-1:0]),
                              .d(NxtData[SINGLE_START+gi][SIZE-1:0]));
  end
endgenerate

// instantiate array of bit slices
kc_bitslice_GV #(SIZE, RDPORTS, CAMPORTS, WRPORTS, 0, RDPARTS, CAMPARTS, MBIST, READAOI, FULLCAM) I_Array[WIDTH-1:0](
  .WrEn(FinalWrEn_B[WRPORTS-1:0]),
  .WrEnLb({SIZE{1'b0}}),  
  .WrData(WrDataT_B[WIDTH-1:0]),
  .CamData(CamDataT[WIDTH-1:0]),
  .RdSel(RdSel[RDPORTS-1:0]),
  .RdData(RdDataT[WIDTH-1:0]),
  .LaunchData(WrData_d1[0][WIDTH-1:0]),
  .LaunchModeEn(LaunchModeEn),
  .CamMatch(CamMatchT[WIDTH-1:0]),
  .NxtData(NxtData[WIDTH-1:0]),
  .Data(DataT[WIDTH-1:0])
);
kc_transpose2d #(WIDTH, SIZE) transpose_Data(.in(DataT[WIDTH-1:0]), .out(Data[SIZE-1:0]));

// 3D array transpose
always_comb
  for (int i=0; i<WIDTH; i++) for (int j=0; j<RDPORTS; j++) for (int k=0; k<RDPARTS; k++)
    RdData[j][k][i] = RdDataT[i][j][k];

// 3D array transpose
generate
  for (camport=1; camport<=CAMPORTS; camport++) begin : camportloop
    always_comb for (int i=0; i<WIDTH; i++) for (int j=0; j<SIZE; j++) CamMatchTT[j][camport][i] = CamMatchT[i][camport][j];
  end
  if (CAMPORTS > 0) begin : camportif
    kc_transpose2d #(CAMPORTS, SIZE) transpose_CamEn(.in(CamEn[CAMPORTS:1]), .out(CamEnT[SIZE-1:0]));

    // cam match AND reduction tree
    kc_camtree_GV #(WIDTH, CAMPORTS, FULLCAM) cam_tree[SIZE-1:0](.CamMatch(CamMatchTT[SIZE-1:0]),
                                                                 .CamMask(CamMask[CAMPORTS:1]), 
                                                                 .CamEn(CamEnT[SIZE-1:0]),
                                                                 .CamHit(CamHitT[SIZE-1:0]));

    kc_transpose2d #(SIZE, CAMPORTS) transpose_CamMatch(.in(CamHitT[SIZE-1:0]), .out(CamMatch[CAMPORTS:1]));
  end
endgenerate

endmodule



module kc_floparray #(parameter 
  WIDTH = 16,      // Number of bits
  SIZE = 16,       // Number of entries (depth)
  RDPORTS = 1,     // Number of read ports
  CAMPORTS = 1,    // Number of cam ports
  WRPORTS = 1,     // Number of write ports
  ZERODEFAULT = 0, // Read default is 1'b0 for simulation
  LOOPBACK = 0,    // Use recirculation mux. Timing/power tradeoff. Strongly consider not using.
  RDPARTS = 1,     // Split bitslice read (OR) into RDPARTS parts. WIDTH must be evenly divisible by RDPARTS
  CAMPARTS = 1,    // Split entry AND into CAMPARTS parts. SIZE must be evenly divisible by CAMPARTS
  WRCHK = 1        // Enable assertions for write collisions
)(
  input                      [SIZE-1:0] RCLK_AR,                // fine gated write clock for each entry
  input                                 SSE,                    // scan shift enable
  input                   [WRPORTS-1:0] WrEn,                   // write enable per port, can be tied to 1 with accurate gating
  input         [WRPORTS-1:0][SIZE-1:0] WrSel,                  // one hot write select per port, can be tied to 1 with accurate gating
  input        [WRPORTS-1:0][WIDTH-1:0] WrData,                 // write data per port
  input          [CAMPORTS:1][SIZE-1:0] CamEn,                  // cam enable bit per entry, usually the valid bit
  input         [CAMPORTS:1][WIDTH-1:0] CamMask,                // cam mask bits, set to 1 for bits to ignore in cam
  input       [CAMPORTS:1][CAMPARTS-1:0][WIDTH-1:0] CamData,    // data to cam for (can also connect 1D or 2D vector here)
  input         [RDPORTS-1:0][SIZE-1:0] RdSel,                  // one hot read select per port

  output logic [RDPORTS-1:0][RDPARTS-1:0][WIDTH-1:0] RdData,    // data read from array (can also connect 1D or 2D vector here)
  output logic   [CAMPORTS:1][SIZE-1:0] CamMatch,               // cam data matched provided entry (per port)
  output logic    [SIZE-1:0][WIDTH-1:0] Data                    // reference to storage array (for debug or complicated cam functions)
);

// storage
reg [WIDTH-1:0] I_Array [SIZE-1:0];

// single read port
always_comb begin
  RdData[0][0][WIDTH-1:0] = {WIDTH{1'b0}};
  for (int i=0; i<SIZE; i++) if (RdSel[0][i]) RdData[0][0][WIDTH-1:0] |= I_Array[i][WIDTH-1:0];
end

// write port
genvar gi;
generate 
    for (gi = 0; gi < SIZE; gi++) begin 
        always @(posedge RCLK_AR[gi]) begin
            I_Array[gi] <= WrData[0][WIDTH-1:0];
        end
    end
endgenerate


endmodule


module kc_lat1array #(parameter 
  WIDTH = 16,         // Number of bits
  SIZE = 16,          // Number of entries (depth)
  RDPORTS = 1,
  CAMPORTS = 1,
  WRPORTS = 1,
  ZERODEFAULT = 0,    // Read default is 1'b0 for simulation
  RDPARTS = 1,        // Split bitslice read (OR) into RDPARTS parts. WIDTH must be evenly divisible by RDPARTS
  CAMPARTS = 1,       // Split entry AND into CAMPARTS parts. SIZE must be evenly divisible by CAMPARTS
  MBIST = 0,          // This array tested with MBIST (or ATPG)
  WRCHK = 1,          // Enable assertions for write collisions
  WR_EN_LATCH = 1,    // Enable the lat2 on WrEn input.  If not using this internal latch, probably need to AND with ~SSE manually.
  WR_SEL_LATCH = 1,   // Enable the lat2 on WrSel input. If not using this internal latch, probably need to AND with ~SSE manually.
  WR_DATA_LATCH = 1,  // Enable the lat2 on WrData input. If not using this internal latch, probably need to use LatchArrayScanInit manually for ATPG designs.
  RESET_VEC = {WIDTH{1'b0}} // Initialization vector for each entry. Currently can only set 1'b1 values for 1 wrport arrays
)(
  input                            [SIZE-1:0] RCLK_AR,             // fine gated write clock for each entry
  input                                       SSE,                 // scan shift enable
  input                                       SDI,                 // scan input to wrdata shift reg, used only if MBIST==1
  input                                       LaunchModeEn,        // enable for launch mode when MBIST==1
  input                                       LatchArrayScanInit,  // enable for scan initialization when MBIST==0.
  input                         [WRPORTS-1:0] WrEn,                // write enable per port, can be tied to 1 with accurate gating
  input               [WRPORTS-1:0][SIZE-1:0] WrSel,               // one hot write select per port, can be tied to 1 with accurate gating
  input              [WRPORTS-1:0][WIDTH-1:0] WrData,              // write data per port
  input                         [WRPORTS-1:0] RCLK_Write_BF,       // clock for WrData lat2
  input                         [WRPORTS-1:0] RCLK_WriteEn_BF,     // clock for WrEn/WrSel lat2
  input                [CAMPORTS:1][SIZE-1:0] CamEn,               // cam enable bit per entry, usually the valid bit
  input               [CAMPORTS:1][WIDTH-1:0] CamMask,             // cam mask bits, set to 1 for bits to ignore in cam
  input [CAMPORTS:1][CAMPARTS-1:0][WIDTH-1:0] CamData,             // data to cam for (can also connect 1D or 2D vector here)
  input               [RDPORTS-1:0][SIZE-1:0] RdSel,               // one hot read select per port
  input                         [WRPORTS-1:0] RCLK_Write_AR,       // clock for lat1 shift register, for MBIST==1 only

  output logic [RDPORTS-1:0][RDPARTS-1:0][WIDTH-1:0] RdData,    // data read from array (can also connect 1D or 2D vector here)
  output logic                [CAMPORTS:1][SIZE-1:0] CamMatch,  // cam data matched provided entry (per port)
  output logic                                       SDO,       // scan output from wrdata shift reg, meaningful only if MBIST==1
  output logic                 [SIZE-1:0][WIDTH-1:0] Data       // reference to storage array (for debug or complicated cam functions)
);

// storage
reg [WIDTH-1:0] I_Array [SIZE-1:0];

// single read port
always_comb begin
  RdData[0][0][WIDTH-1:0] = {WIDTH{1'b0}};
  for (int i=0; i<SIZE; i++) if (RdSel[0][i]) RdData[0][0][WIDTH-1:0] |= I_Array[i][WIDTH-1:0];
end

// write port
genvar gi;
generate 
    for (gi = 0; gi < SIZE; gi++) begin 
        always @(RCLK_AR[gi] or WrData) begin
            if (RCLK_AR[gi]) begin
                I_Array[gi] <= WrData[0][WIDTH-1:0];
            end
        end
    end
endgenerate

endmodule

module kc_hotmux #(parameter WIDTH = 1, NUMINPUTS = 1, ZERODEFAULT = 0)(
  output logic              [WIDTH-1:0] out,
  input                 [NUMINPUTS-1:0] sel,
  input      [NUMINPUTS-1:0][WIDTH-1:0] in
);
logic                       [WIDTH-1:0] outX;

always_comb begin
  outX[WIDTH-1:0] = {WIDTH{1'b0}};
  for (int i=0; i<NUMINPUTS; i++) if (sel[i]) outX[WIDTH-1:0] |= in[i][WIDTH-1:0];
end

generate
  if (ZERODEFAULT) begin : Out0IfNoSel
    assign out[WIDTH-1:0] = outX[WIDTH-1:0];
  end
  else begin : OutXIfNoSel
    assign out[WIDTH-1:0] = |sel[NUMINPUTS-1:0] ? outX[WIDTH-1:0] : {WIDTH{1'bx}};
  end
endgenerate  

endmodule



// transpose 2d packed array    
module kc_transpose2d #(parameter V = 1, W = 1) (
  input                  [V-1:0][W-1:0] in,
  output logic           [W-1:0][V-1:0] out
);
genvar gw;
genvar gv;
generate
  for (gw=0; gw<W; gw++) begin : outerloop
    for (gv=0; gv<V; gv++) begin : innerloop
      assign out[gw][gv] = in[gv][gw];
    end
  end
endgenerate
endmodule



module kc_wrlatches #(parameter SIZE = 1, WRPORTS = 1, MBIST = 0)(
  output logic  [WRPORTS-1:0][SIZE-1:0] Wr_B,                // latched write signal per port
  input         [WRPORTS-1:0][SIZE-1:0] Wr,                  // write signal per port
  input                   [WRPORTS-1:0] RCLK_En_BF,          // in multiple write port configurations...
  input                                 SSE
);

logic                   [WRPORTS-1:0][SIZE-1:0] Wr_sse;
logic                   [WRPORTS-1:0][SIZE-1:0] SSE_EXP;

genvar gi;
generate
  for (gi=0; gi<WRPORTS; gi++) begin : SSELoop
    assign SSE_EXP[gi][SIZE-1:0] = {SIZE{SSE}};
  end
endgenerate

    if ((MBIST == 1)) begin : mbist
      kc_lat2 #(.WIDTH(SIZE)) I_Wr_BLatch[WRPORTS-1:0](Wr_B[WRPORTS-1:0] , RCLK_En_BF[WRPORTS-1:0], Wr[WRPORTS-1:0]);
    end
    else begin : nombist
      kc_SSE_RESET_AND #(.WIDTH(SIZE)) I_WRSELECT_SSE[WRPORTS-1:0](.OUT(Wr_sse[WRPORTS-1:0]), .SSE(SSE_EXP[WRPORTS-1:0]), .DATA(Wr[WRPORTS-1:0]));
      kc_lat2 #(.WIDTH(SIZE)) I_WrSel_BLatch[WRPORTS-1:0](Wr_B[WRPORTS-1:0], RCLK_En_BF[WRPORTS-1:0], Wr_sse[WRPORTS-1:0]);
    end
endmodule



module kc_SSE_RESET_AND #(parameter WIDTH = 1, RESET_VEC = {{WIDTH}{1'b0}})(                // default WIDTH of output
  output                    [WIDTH-1:0] OUT,   
  input                     [WIDTH-1:0] SSE,
  input                     [WIDTH-1:0] DATA   
);

//assign OUT[WIDTH-1:0] = DATA[WIDTH-1:0] & ~SSE[WIDTH-1:0];

genvar i;
generate
  for (i=0; i<WIDTH; i++) begin : sseresetloop
    if (RESET_VEC[i] == 1'b0) begin : sseand
      assign OUT[i] = DATA[i] & ~SSE[i];
    end
    else begin : sseor
      assign OUT[i] = DATA[i] | SSE[i];
    end
  end
endgenerate 

endmodule



module kc_lat1
 #(parameter WIDTH=1             // default WIDTH of output
   ) 
  (
   output     [WIDTH-1:0] q,     // data out
   input                  clk,   // clock
   input      [WIDTH-1:0] d     // data in
   );

// A-phase latch
HDBULT08_LDPQ_V2Y2_1 lat1_q[WIDTH-1:0](.Q(q), .G(clk), .D(d));

endmodule



module kc_lat2
 #(parameter WIDTH=1             // default WIDTH of output
   ) 
  (
   output     [WIDTH-1:0] q,     // data out
   input                  clk,   // clock
   input      [WIDTH-1:0] d     // data in
   );

// B-phase latch
HDBULT08_LDNQ_V2Y2_1 lat2_q[WIDTH-1:0](.Q(q), .G(clk), .D(d)); 

endmodule



module kc_dff #(parameter WIDTH=1) (
   output [WIDTH-1:0]   q,     // data out
   input                clk,   // clock
   input  [WIDTH-1:0]   d,     // data in
   input                SSE    // this floats in gfx flow
);

reg  [WIDTH-1:0] dff_q;

always @(posedge clk) dff_q <= d;
assign q = dff_q;

endmodule

