
//----------------------------------------------------------------------------
//
// Author :		 Rita Patel, N1-501 (Sunnyvale - Yan Dong), 44288 

//
// Notes  :		 DO NOT HAND EDIT THIS FILE!!!!!!
//	   		 This file was automatically derived from /local_vol1_nobackup/user/ripatel/trees/dfxip4_1/dftmisc/src/meta/tools/scripts/odt2tdr_rtl.pl
//----------------------------------------------------------------------------
	  
//`include "larr_bist_features.vh"


module larr_setup_tdr_gc10 ( 


//Broadcast to All TDRs
input Tdr_Tck,
input Tdr_Trstb,
input Tdr_Tdi,
input Tdr_Shift,
input Tdr_Capture,
input Tdr_Update



//TDR --> LARR_SETUP
 ,output wire [32-1-0+1-1:0] fillcmp_cntr
 ,output wire [128+32-1-32+1-1:0] pattern
 ,output wire [1-1:0] smartmode_dis
 ,input Tdr_larr_setup_En
 ,output Tdr_larr_setup_Tdo
); // End of Port Declaration

///// START TDR_INST - LARR_SETUP /////

   localparam LARR_SETUP__WIDTH = 32-1-0+1+128+32-1-32+1+1+0;
   wire [LARR_SETUP__WIDTH-1:0]	LARR_SETUP;
   wire [LARR_SETUP__WIDTH-1:0]	LARR_SETUP__DEFAULT;  

	//LARR_SETUP - 32-1:0

   localparam  LARR_SETUP_FILLCMP_CNTR__WIDTH  = 32-1-0+1;
   localparam [LARR_SETUP_FILLCMP_CNTR__WIDTH-1:0] LARR_SETUP_FILLCMP_CNTR__DEFAULT  = 32'h800;
   

   localparam  LARR_SETUP_FILLCMP_CNTR__MSB  = 32-1;
   localparam  LARR_SETUP_FILLCMP_CNTR__LSB  = 0;
   

   assign LARR_SETUP__DEFAULT
                 [LARR_SETUP_FILLCMP_CNTR__MSB : 
                  LARR_SETUP_FILLCMP_CNTR__LSB] =  
		  LARR_SETUP_FILLCMP_CNTR__DEFAULT;
   

  ati_buffer1 mrk_larr_setup_fillcmp_cntr[LARR_SETUP_FILLCMP_CNTR__WIDTH-1:0] 
  (
    .A(LARR_SETUP
      [LARR_SETUP_FILLCMP_CNTR__MSB :
       LARR_SETUP_FILLCMP_CNTR__LSB
      ]),    
    .Y(fillcmp_cntr[LARR_SETUP_FILLCMP_CNTR__WIDTH-1:0])
  );


	//LARR_SETUP - 128+32-1:32

   localparam  LARR_SETUP_PATTERN__WIDTH  = 128+32-1-32+1;
   localparam [LARR_SETUP_PATTERN__WIDTH-1:0] LARR_SETUP_PATTERN__DEFAULT  = 128'haaaa_aaaa_aaaa_aaaa_aaaa_aaaa_aaaa_aaaa;
   

   localparam  LARR_SETUP_PATTERN__MSB  = 128+32-1;
   localparam  LARR_SETUP_PATTERN__LSB  = 32;
   

   assign LARR_SETUP__DEFAULT
                 [LARR_SETUP_PATTERN__MSB : 
                  LARR_SETUP_PATTERN__LSB] =  
		  LARR_SETUP_PATTERN__DEFAULT;
   

  ati_buffer1 mrk_larr_setup_pattern[LARR_SETUP_PATTERN__WIDTH-1:0] 
  (
    .A(LARR_SETUP
      [LARR_SETUP_PATTERN__MSB :
       LARR_SETUP_PATTERN__LSB
      ]),    
    .Y(pattern[LARR_SETUP_PATTERN__WIDTH-1:0])
  );


	//LARR_SETUP - 128+32:128+32

   localparam  LARR_SETUP_SMARTMODE_DIS__WIDTH  = 1;
   localparam [LARR_SETUP_SMARTMODE_DIS__WIDTH-1:0] LARR_SETUP_SMARTMODE_DIS__DEFAULT  = 1'h0;
   

   localparam  LARR_SETUP_SMARTMODE_DIS__MSB  = 128+32;
   localparam  LARR_SETUP_SMARTMODE_DIS__LSB  = 128+32;
   

   assign LARR_SETUP__DEFAULT
                 [LARR_SETUP_SMARTMODE_DIS__MSB : 
                  LARR_SETUP_SMARTMODE_DIS__LSB] =  
		  LARR_SETUP_SMARTMODE_DIS__DEFAULT;
   

  ati_buffer1 mrk_larr_setup_smartmode_dis[LARR_SETUP_SMARTMODE_DIS__WIDTH-1:0] 
  (
    .A(LARR_SETUP
      [LARR_SETUP_SMARTMODE_DIS__MSB :
       LARR_SETUP_SMARTMODE_DIS__LSB
      ]),    
    .Y(smartmode_dis[LARR_SETUP_SMARTMODE_DIS__WIDTH-1:0])
  );





   test_reg_async_rst_gc10
     #(LARR_SETUP__WIDTH)
   reg_LARR_SETUP (
                           .clk(Tdr_Tck),
                           .rstb(Tdr_Trstb),
                           .en(Tdr_larr_setup_En),
                           .shift(Tdr_Shift & Tdr_larr_setup_En),
                           .capture(Tdr_Capture & Tdr_larr_setup_En),
                           .update(Tdr_Update & Tdr_larr_setup_En),
                           .d_rst(LARR_SETUP__DEFAULT),
                           .q(LARR_SETUP),
                           .d(LARR_SETUP),
                           .si(Tdr_Tdi),
                           .so(Tdr_larr_setup_Tdo),
                           .q_sr(),
                           .q_sr_posedge()
                           );









///// END TDR_INST - LARR_SETUP /////
endmodule
