
//----------------------------------------------------------------------------
//
// Author :		 Nehal Patel, N1-504 (Sunnyvale - Yan Dong), 44290 

//
// Notes  :		 DO NOT HAND EDIT THIS FILE!!!!!!
//	   		 This file was automatically derived from /local_vol1_nobackup/user/nepatel/dfxip4_0/dftmisc/src/meta/tools/scripts/odt2tdr_rtl.pl
//----------------------------------------------------------------------------
	  


module latency_cnt_tdr_gc10 
# (
   parameter DFT_CLK_CNTL_LATENCY_CNT = 5
   )
( 


//Broadcast to All TDRs
input Tdr_Tck,
input Tdr_Trstb,
input Tdr_Tdi,
input Tdr_Shift,
input Tdr_Capture,
input Tdr_Update



//TDR --> LATENCY_CNT
 ,output wire [DFT_CLK_CNTL_LATENCY_CNT-1:0] latency_cnt
 ,input Tdr_latency_cnt_En
 ,output Tdr_latency_cnt_Tdo
); // End of Port Declaration

///// START TDR_INST - LATENCY_CNT /////

   localparam LATENCY_CNT__WIDTH = DFT_CLK_CNTL_LATENCY_CNT;
   wire [LATENCY_CNT__WIDTH-1:0]	LATENCY_CNT;
   wire [LATENCY_CNT__WIDTH-1:0]	LATENCY_CNT__DEFAULT;  

	//LATENCY_CNT - 9:0

   localparam  LATENCY_CNT_LATENCY_CNT__WIDTH  = DFT_CLK_CNTL_LATENCY_CNT;
   localparam [LATENCY_CNT_LATENCY_CNT__WIDTH-1:0] LATENCY_CNT_LATENCY_CNT__DEFAULT  = { (DFT_CLK_CNTL_LATENCY_CNT) {1'h0}};
   

   localparam  LATENCY_CNT_LATENCY_CNT__MSB  = DFT_CLK_CNTL_LATENCY_CNT-1;
   localparam  LATENCY_CNT_LATENCY_CNT__LSB  = 0;
   

   assign LATENCY_CNT__DEFAULT
                 [LATENCY_CNT_LATENCY_CNT__MSB : 
                  LATENCY_CNT_LATENCY_CNT__LSB] =  
		  LATENCY_CNT_LATENCY_CNT__DEFAULT;
   

  ati_buffer1 mrk_latency_cnt_latency_cnt[LATENCY_CNT_LATENCY_CNT__WIDTH-1:0] 
  (
    .A(LATENCY_CNT
      [LATENCY_CNT_LATENCY_CNT__MSB :
       LATENCY_CNT_LATENCY_CNT__LSB
      ]),    
    .Y(latency_cnt[LATENCY_CNT_LATENCY_CNT__WIDTH-1:0])
  );





   test_reg_async_rst_gc10
     #(LATENCY_CNT__WIDTH)
   reg_LATENCY_CNT (
                           .clk(Tdr_Tck),
                           .rstb(Tdr_Trstb),
                           .en(Tdr_latency_cnt_En),
                           .shift(Tdr_Shift & Tdr_latency_cnt_En),
                           .capture(Tdr_Capture & Tdr_latency_cnt_En),
                           .update(Tdr_Update & Tdr_latency_cnt_En),
                           .d_rst(LATENCY_CNT__DEFAULT),
                           .q(LATENCY_CNT),
                           .d(LATENCY_CNT),
                           .si(Tdr_Tdi),
                           .so(Tdr_latency_cnt_Tdo),
                           .q_sr(),
                           .q_sr_posedge()
                           );









///// END TDR_INST - LATENCY_CNT /////
endmodule
