//****************************************
// Warning! This file is machine generated
//****************************************


// leda E_001 off
// leda E_122 off
`timescale 1ps/1ps
module mapsmro_pg(
    // Voltage Supplies
    input VDD1,
    input VDD2,
    input VSS,
    // Input Clock
    input CLK1,
    // Input Signals
    input [1:0] div,
    input oscEn1,
    input oscEn2,
    input CLK2,
    //pwrOK signal added by Krishnan on July 30th 2015
    input pwrOK,
    // Output Signals
    output wire psmOscGater,
    output reg [31:0] psmOscLsb,
    output reg [7:0] psmOscMsb0,
    output reg [7:0] psmOscMsb1,
    // New output pins added to match PSM macro [PSMRNGPNA1] in matechcoe28u codeline 
    output reg invalid,
    //output reg overFlow
    //output reg overFlow
    output wire overFlow
);
    integer i;
    // leda off
    //-----------------------------------------------------------------------
    // This is a simplified PSM model for fast simulations
    //-----------------------------------------------------------------------
    reg [3:0] s;
    reg [2:0] z;
    reg divClk_d;
    reg en1;
    wire CLKG;
    wire [2:0] nxt;
    wire divClk;
    //Adding all these signals on June 29th 2016
    wire clk_CGRO;
    wire clk_CGPG;
    reg NOR2_OUT;
    reg NOR2_INV_OUT;
    wire [14:0] z_ded;
    wire [15:0] z_de;
    wire [15:0] zb_de;
    //reg    [7:0] nxt_cnt0_flops_1;
    //Can't be a reg object. Declaring it as a wire
    wire [7:0] nxt_cnt0_flops_1;
    //reg    [7:0] nxt_cnt1_flops_1;
    //Can't be a reg object. Declaring it as a wire
    wire [7:0] nxt_cnt1_flops_1;
    wire cnt0_is_zero;
    reg overFlow0_S_out;
    reg overFlow0_R_out;
    reg overFlow0_R_out_X;
    reg overFlow1_S_out;
    reg overFlow1_R_out;
    reg overFlow1_R_out_X;
    wire overFlow0_S_input;
    wire overFlow1_S_input;
    wire overFlow_sig;
    reg [14:0] UNUSED_3;
    reg [14:0] UNUSED_1;
    reg [7:0] z_cnt0_flops_1;
    reg z_cnt1_flops_1_0X;
    reg [7:1] z_cnt1_flops_1_pre;
    wire [7:0] z_cnt1_flops_1;
    reg [31:0] OscLSB_in;
    //output wire oscen1_LS;
    //oscen1_LS is an internal signal and hence wont be called 'output'
    wire oscen1_LS;
    // div s<3:0> 1-hot decoding
    // divider block modeled below
    always @* begin
        case(div[1:0])
            2'b00: begin
                s[3:0] = 4'b0001;
            end
            2'b01: begin
                s[3:0] = 4'b0010;
            end
            2'b10: begin
                s[3:0] = 4'b0100;
            end
            2'b11: begin
                s[3:0] = 4'b1000;
            end
            // VCS coverage off
            default: 
                //vrq begin
                begin
                    case(^div[1:0])
                        1'b0,
                        1'b1: 
                            //vrq end
                            begin
                                s[3:0] = 4'bxxxx;
                            end
                            
                            //vrq begin
                        default: begin
                            s[3:0] = 4'hx;
                        end
                    endcase
                end
                
                //vrq end
            // VCS coverage on
        endcase
        // case(div[1:0])
    end
    //// CLKDIV block ////
    //Adding all these latches/signals on June 29th 2016 (A to B)
    //A
    // oscEn latch:
    //lat2 I_EN1_LATCH (en1, CLK1, oscEn1 );
    // Pin mapping provided for lat2 on 15/10/2016
    // lat2 changed to mapsmro_lat2 on 22/02/2017
    mapsmro_lat2 I_EN1_LATCH (
        .q(en1),
        .clk(CLK1),
        .d(oscEn1)
    );
    // clock gater:
    //assign CLKG = en1 & CLK1;
    //No ICG cell used so far in the design (as on Sep 3rd 2016)
    //ICG cell added to the design (as on Sep 20th 2016)
    //integ_clk_gater_mapsmro ICG1 (CLKG, CLK1, oscEn1);
    //Pin mapping provided for ICG on 15/10/2016
    integ_clk_gater_mapsmro ICG1 (
        .clkg(CLKG),
        .clk(CLK1),
        .d(oscEn1)
    );
    //srdff_mapsmro #(.WIDTH(3)) zflop (z[2:0], CLKG, nxt[2:0], 1'b0, (~en1) );
    //Pin mapping provided for the zflop on 15/10/2016
    srdff_mapsmro #(.WIDTH(3)) zflop (
        .q(z[2:0]),
        .clk(CLKG),
        .d(nxt[2:0]),
        .set(1'b0),
        .rst(~en1)
    );
    //B 
    // Counter inside the clock divider 
    //3-bit counter Combitorial Logic
    assign   nxt[0]=~z[0];
    assign   nxt[1]=~(z[0]^z[1]);
    assign   nxt[2]=~z[0]&~z[1]^z[2];
    //Added by Krishnan: divClk is generated by CLKG now and not CLK1
    //assign divClk = (z[2]&s[3]) | (z[1]&s[2]) | (z[0]&s[1]) | (CLKG   & s[0]);
    assign   divClk=z[2]&s[3]|z[1]&s[2]|z[0]&s[1]|1'b1&s[0];
    //divclk_d is now generated by CLKG and not CLK1
    //srdff_mapsmro divclkflop (divClk_d, CLKG, divClk, 1'b0, (~en1) );
    //Pin mapping for divclkflop added on 15/10/2016
    srdff_mapsmro divclkflop (
        .q(divClk_d),
        .clk(CLKG),
        .d(divClk),
        .set(1'b0),
        .rst(~en1)
    );
    // Generating clk_cgRO
    //Second latch in the clkdiv block 
    //mapsmro_lat2 clk_CGRO_LATCH (cg1, CLKG, ((divClk & ~divClk_d) | s[0]));
    //assign clk_CGRO = cg1 & CLKG;
    // clk_CGRO is the output of clkdiv 
    //No ICG present in the design as on Sep 3rd 2016
    //ICG cell added to the design (as on Sep 20th 2016)
    //integ_clk_gater_mapsmro ICG2 (clk_CGRO, CLKG, ((divClk & ~divClk_d) | s[0]));
    //Pin mapping for ICG ICG2 provided on 15/10/2016
    integ_clk_gater_mapsmro ICG2 (
        .clkg(clk_CGRO),
        .clk(CLKG),
        .d(divClk&~divClk_d|s[0])
    );
    // BASED ON SCHEMATIC, THIS IS RELATIVE TO CLOCK 1
    assign   psmOscGater=divClk&~divClk_d|s[0];
    //// End of CLKDIV ////
    // Level shifter for clock at the psmosc hierarchy - Picking the standard cell Level shifter LSLLCKEQ0
    //LSLLCKEQ0 levelshift_clk ((clk_CGRO), pwrOK, VDD1, VDD2, VSS, c_LS);
    //CLK NON INV LS LSLLCKEQ0 in rtl_stdlib
    //Pin mapping for CLK LSLLCKEQ0 provided on 24/11/2016
    LSLLCKEQ0 levelshift_clk (
        .in_vpwr1(clk_CGRO),
        .vpwr1pwrok_vpwr2(pwrOK),
        .VPWR1(VDD1),
        .VPWR2(VDD2),
        .VSS(VSS),
        .out_vpwr2_l(c_LS)
    );
    // Level shifter for oscEn at the psmosc hierarchy - Picking the standard cell Level shifter LSLLCKEQ0
    //LSLLCKEQ0 levelshift_enable ((en1), pwrOK, VDD1, VDD2, VSS, oscen1_LS);
    //Pin mapping for CLK LSLLCKEQ0 provided on 24/11/2016
    LSLLCKEQ0 levelshift_enable (
        .in_vpwr1(en1),
        .vpwr1pwrok_vpwr2(pwrOK),
        .VPWR1(VDD1),
        .VPWR2(VDD2),
        .VSS(VSS),
        .out_vpwr2_l(oscen1_LS)
    );
    //Defined as CLK NON INV LS LSLLCKEQ0 in rtl_stdlib
    //Using the same LKLLCKEQ0 for oscEn1 signal because SCH/VERILOG has the same LS cell used for CLK LS which is non inverting with equal delays with Z=0 for pwrOK=0
    // Generating CLEAR
    // PSMCLEAR block of the sch modeled here
    //// PSMCLEAR BLOCK ////
    //srdff_mapsmro clearflop (Z0, clk_CGRO, en1, 1'b0, (~en1) );
    //mapsmro_lat2 clk_CLEAR_R_LATCH (r, clk_CGRO, Z0);
    //Pin mapping provided for the block 
    srdff_mapsmro clearflop (
        .q(Z0),
        .clk(clk_CGRO),
        .d(en1),
        .set(1'b0),
        .rst(~en1)
    );
    //Pin mapping provided for the block 
    mapsmro_lat2 clk_CLEAR_R_LATCH (
        .q(r),
        .clk(clk_CGRO),
        .d(Z0)
    );
    // this combo loop is set dominant, need to switch set and reset inputs
    //srlat_mapsmro clear_latch (r, (~en1), NOR2_INV_OUT);
    //Pin mapping provided for the block 
    srlat_mapsmro clear_latch (
        .s(r),
        .r(~en1),
        .q(NOR2_INV_OUT)
    );
    //srlat_mapsmro clear_latch ((~en1), r, NOR2_OUT);
    //assign NOR2_OUT = ~((~en1) | NOR2_INV_OUT);
    //assign NOR2_INV_OUT = ~(r | NOR2_OUT);
    //// End of PSMCLEAR ////
    //// DED BLOCK PRESENT INSIDE PULSEGEN ////
    //Adding the following nodes on June 29th 2016
    //Mapping DED nodes
    //Instance I4
    //srdff_mapsmro #(.WIDTH (15)) Ided4 (UNUSED_3[14:0], 1'b0, z_ded[14:0], 1'b0, (~en2) );
    //`define DED_ELEM_NAND1_DEL 30
    //30 for GF14 sims done with default netlist at ttlpp/1V/100c corner 
    //20 for N7 sims done with lumped netlist at tt/1V/100c corner
    //`define DED_ELEM_INV_DEL 12
    //12 for GF14 sims done with default netlist at ttlpp/1V/100c corner
    //7 for N7 sims done with lumped netlist at tt/1V/100c corner
    //srdff_mapsmro #(.WIDTH (15)) Ided4 (UNUSED_3[14:0], 1'b0, z_ded[14:0], 1'b0, (~oscen1_LS) );
    //Pin mapping provided for the block 
    srdff_mapsmro #(.WIDTH(15)) Ided4 (
        .q(UNUSED_3[14:0]),
        .clk(1'b0),
        .d(z_ded[14:0]),
        .set(1'b0),
        .rst(~oscen1_LS)
    );
    //assign z_ded[0] =  (~(~clk_CGPG & en2) );
    //assign z_ded[0] =  (~(~c_LS & oscen1_LS) );
    assign  #(20) z_ded[0]=~(~c_LS&oscen1_LS);
    assign  #(1*7) z_ded[1]=~z_ded[0];
    assign  #(2*7) z_ded[2]=z_ded[0];
    assign  #(3*7) z_ded[3]=~z_ded[0];
    assign  #(4*7) z_ded[4]=z_ded[0];
    assign  #(5*7) z_ded[5]=~z_ded[0];
    assign  #(6*7) z_ded[6]=z_ded[0];
    //assign z_ded[7] = ~(clk_CGPG & en2);
    assign  #(7*7+20) z_ded[7]=~(c_LS&oscen1_LS);
    assign  #(1*7) z_ded[8]=~z_ded[7];
    assign  #(2*7) z_ded[9]=z_ded[7];
    assign  #(3*7) z_ded[10]=~z_ded[7];
    assign  #(4*7) z_ded[11]=z_ded[7];
    assign  #(5*7) z_ded[12]=~z_ded[7];
    assign  #(6*7) z_ded[13]=z_ded[7];
    //assign z_ded[14] = en2;
    //assign #7 z_ded[14] = oscen1_LS;
    assign  #(7) z_ded[14]=~(z_ded[13]&z_ded[0]);
    //Instance I3
    //srdff_mapsmro #(.WIDTH (15)) Ided3 (UNUSED_1[14:0], 1'b0, z_ded[14:0], 1'b0, (~oscen1_LS) );
    //Pin mapping provided for the block 
    srdff_mapsmro #(.WIDTH(15)) Ided3 (
        .q(UNUSED_1[14:0]),
        .clk(1'b0),
        .d(z_ded[14:0]),
        .set(1'b0),
        .rst(~oscen1_LS)
    );
    //// End of DED BLOCK ////
    ////Mapping the last flop for 'invalid' output generation
    ////Invalid is inversion of zb, so its z output itself
    //srdff_mapsmro invalidflop (invalid, clk_CGRO, ~z_ded[14], 1'b0, ~NOR2_INV_OUT );
    //Pin mapping provided for the block 
    srdff_mapsmro invalidflop (
        .q(invalid),
        .clk(clk_CGRO),
        .d(~z_ded[14]),
        .set(1'b0),
        .rst(~NOR2_INV_OUT)
    );
    //////Modeling the RO chain and primary outputs (LSB*) present inside DE block
    ////Instance I1 - z
    always @* begin
        ////  integer i;
        //// Commenting out the two lines below as that causes a zero delay loop in verification.
        //// Expanding the FOR loop
        for(i = 0;i<32;i++) begin
            OscLSB_in[i] <= z_de[i/2];
        end
    end
    //// Generation of LSB outputs ////
    //srdff_mapsmro #(.WIDTH(32)) Ide1 (psmOscLsb[31:0], clk_CGRO, OscLSB_in[31:0], 1'b0, (~en1) );
    //Pin mapping provided for the block 
    srdff_mapsmro #(.WIDTH(32)) Ide1 (
        .q(psmOscLsb[31:0]),
        .clk(clk_CGRO),
        .d(OscLSB_in[31:0]),
        .set(1'b0),
        .rst(~en1)
    );
    //// Modeling the RO chain ////
    assign  #(1*7.5) z_de[0]=~(z_de[15]&z_ded[14]);
    //assign #(1 * 7.5) z_ded[1] =  ~z_ded[0];
    assign  #(1*7.5) zb_de[1]=~(z_de[0]|1'b0);
    assign  #(1*7.5) z_de[2]=~(zb_de[1]&1'b1);
    assign  #(1*7.5) zb_de[3]=~(z_de[2]|1'b0);
    assign  #(1*7.5) z_de[4]=~(zb_de[3]&1'b1);
    assign  #(1*7.5) zb_de[5]=~(z_de[4]|1'b0);
    assign  #(1*7.5) z_de[6]=~(zb_de[5]&1'b1);
    assign  #(1*7.5) zb_de[7]=~(z_de[6]|1'b0);
    assign  #(1*7.5) z_de[8]=~(zb_de[7]&z_ded[14]);
    assign  #(1*7.5) zb_de[9]=~(z_de[8]|1'b0);
    assign  #(1*7.5) z_de[10]=~(zb_de[9]&1'b1);
    assign  #(1*7.5) zb_de[11]=~(z_de[10]|1'b0);
    assign  #(1*7.5) z_de[12]=~(zb_de[11]&1'b1);
    assign  #(1*7.5) zb_de[13]=~(z_de[12]|1'b0);
    assign  #(1*7.5) z_de[14]=~(zb_de[13]&1'b1);
    assign  #(1*7.5) zb_de[15]=~(z_de[14]|1'b0);
    assign  #(1*7.5) zb_de[0]=~(zb_de[15]|~z_ded[14]);
    assign  #(1*7.5) z_de[1]=~(zb_de[0]&1'b1);
    assign  #(1*7.5) zb_de[2]=~(z_de[1]|1'b0);
    assign  #(1*7.5) z_de[3]=~(zb_de[2]&1'b1);
    assign  #(1*7.5) zb_de[4]=~(z_de[3]|1'b0);
    assign  #(1*7.5) z_de[5]=~(zb_de[4]&1'b1);
    assign  #(1*7.5) zb_de[6]=~(z_de[5]|1'b0);
    assign  #(1*7.5) z_de[7]=~(zb_de[6]&1'b1);
    assign  #(1*7.5) zb_de[8]=~(z_de[7]|~z_ded[14]);
    assign  #(1*7.5) z_de[9]=~(zb_de[8]&1'b1);
    assign  #(1*7.5) zb_de[10]=~(z_de[9]|1'b0);
    assign  #(1*7.5) z_de[11]=~(zb_de[10]&1'b1);
    assign  #(1*7.5) zb_de[12]=~(z_de[11]|1'b0);
    assign  #(1*7.5) z_de[13]=~(zb_de[12]&1'b1);
    assign  #(1*7.5) zb_de[14]=~(z_de[13]|1'b0);
    assign  #(1*7.5) z_de[15]=~(zb_de[14]&1'b1);
    //// End of DE block //// 
    //// COUNTER 0 (ICNT0) - FIRST COUNTER ////
    //Modeling the first set of flops (FLOPS_1)
    //srdff_mapsmro #(.WIDTH (8)) ICNT0_FLOPS_1 (z_cnt0_flops_1[7:0], (zb_de[15] & en2), nxt_cnt0_flops_1[7:0], 1'b0, ~en2);
    //srdff_mapsmro #(.WIDTH (8)) ICNT0_FLOPS_1 (z_cnt0_flops_1[7:0], (zb_de[15] & oscen1_LS), nxt_cnt0_flops_1[7:0], 1'b0, ~oscen1_LS);
    //Pin mapping provided for the block 
    srdff_mapsmro #(.WIDTH(8)) ICNT0_FLOPS_1 (
        .q(z_cnt0_flops_1[7:0]),
        .clk(zb_de[15]&oscen1_LS),
        .d(nxt_cnt0_flops_1[7:0]),
        .set(1'b0),
        .rst(~oscen1_LS)
    );
    assign   nxt_cnt0_flops_1[0]=~z_cnt0_flops_1[0];
    assign   nxt_cnt0_flops_1[1]=z_cnt0_flops_1[0]^z_cnt0_flops_1[1];
    assign   nxt_cnt0_flops_1[2]=z_cnt0_flops_1[2]^z_cnt0_flops_1[1]&z_cnt0_flops_1[0];
    assign   nxt_cnt0_flops_1[3]=z_cnt0_flops_1[3]^z_cnt0_flops_1[2]&z_cnt0_flops_1[1]&z_cnt0_flops_1[0];
    assign   nxt_cnt0_flops_1[4]=z_cnt0_flops_1[4]^z_cnt0_flops_1[3]&z_cnt0_flops_1[2]&z_cnt0_flops_1[1]&z_cnt0_flops_1[0];
    assign   nxt_cnt0_flops_1[5]=z_cnt0_flops_1[5]^z_cnt0_flops_1[4]&z_cnt0_flops_1[3]&z_cnt0_flops_1[2]&z_cnt0_flops_1[1]&z_cnt0_flops_1[0];
    assign   nxt_cnt0_flops_1[6]=z_cnt0_flops_1[6]^z_cnt0_flops_1[5]&z_cnt0_flops_1[4]&z_cnt0_flops_1[3]&z_cnt0_flops_1[2]&z_cnt0_flops_1[1]&z_cnt0_flops_1[0];
    assign   nxt_cnt0_flops_1[7]=z_cnt0_flops_1[7]^z_cnt0_flops_1[6]&z_cnt0_flops_1[5]&z_cnt0_flops_1[4]&z_cnt0_flops_1[3]&z_cnt0_flops_1[2]&z_cnt0_flops_1[1]&z_cnt0_flops_1[0];
    //Modeling the second set of flops (FLOPS_2)
    //Generates the primary MSB0* outputs
    //Pin mapping provided for the block 
    //srdff_mapsmro #(.WIDTH (8)) ICNT0_FLOPS_2 ( psmOscMsb0[7:0], clk_CGRO, z_cnt0_flops_1[7:0], 1'b0, ~NOR2_INV_OUT );
    srdff_mapsmro #(.WIDTH(8)) ICNT0_FLOPS_2 (
        .q(psmOscMsb0[7:0]),
        .clk(clk_CGRO),
        .d(z_cnt0_flops_1[7:0]),
        .set(1'b0),
        .rst(~NOR2_INV_OUT)
    );
    //Zero output of the first counter is used as reset for the 2nd counter
    assign   cnt0_is_zero=~(|z_cnt0_flops_1[7:0]);
    assign   overFlow0_S_input=&z_cnt0_flops_1[7:0];
    //srlat_mapsmro overFlow0 (overFlow0_S_input, ~z_ded[14], wire_overFlow0);
    //Pin mapping provided for the block 
    srlat_mapsmro overFlow0 (
        .s(overFlow0_S_input),
        .r(~z_ded[14]),
        .q(wire_overFlow0)
    );
    ////COUNTER 1 (ICNT1) -  SECOND COUNTER //// 
    //Modeling the first set of flops
    // The first set of flops in COUNTER1 is further split into a 'FIRST_FLOP' (0th instance) and 'FLOPS_1' (7:1 instances)
    // This is done because the 'FIRST_FLOP' called as psm28hp_saff_reset in the gate verilog has a slightly different circuit than the 7:1 instances
    //FIRST_FLOP( The SAFF RESET flop)
    //srdff_mapsmro ICNT1_FIRST_FLOP (z_cnt1_flops_1_0X, (z_de[15] & ~cnt0_is_zero), ~nxt_cnt1_flops_1[0], 1'b0, cnt0_is_zero);
    //Pin mapping provided for the block 
    srdff_mapsmro ICNT1_FIRST_FLOP (
        .q(z_cnt1_flops_1_0X),
        .clk(z_de[15]&~cnt0_is_zero),
        .d(~nxt_cnt1_flops_1[0]),
        .set(1'b0),
        .rst(cnt0_is_zero)
    );
    //REMAINING FLOPS (FLOPS_1)
    //srdff_mapsmro #(.WIDTH (7)) ICNT1_FLOPS_1 (z_cnt1_flops_1_pre[7:1], (z_de[15] & ~cnt0_is_zero), nxt_cnt1_flops_1[7:1], 1'b0, cnt0_is_zero);
    //Pin mapping provided for the block 
    srdff_mapsmro #(.WIDTH(7)) ICNT1_FLOPS_1 (
        .q(z_cnt1_flops_1_pre[7:1]),
        .clk(z_de[15]&~cnt0_is_zero),
        .d(nxt_cnt1_flops_1[7:1]),
        .set(1'b0),
        .rst(cnt0_is_zero)
    );
    assign   z_cnt1_flops_1[7:0]={z_cnt1_flops_1_pre[7:1],~z_cnt1_flops_1_0X};
    //always @* begin
    //  nxt_cnt1_flops_1[0] = ~z_cnt1_flops_1[0];
    //  for(integer j=1; j<8; j++) begin
    //    nxt_cnt1_flops_1[j] = z_cnt1_flops_1[j] ^ &(z_cnt1_flops_1[j-1:0]);
    //  end
    //end
    assign   nxt_cnt1_flops_1[0]=~z_cnt1_flops_1[0];
    assign   nxt_cnt1_flops_1[1]=z_cnt1_flops_1[0]^z_cnt1_flops_1[1];
    assign   nxt_cnt1_flops_1[2]=z_cnt1_flops_1[2]^z_cnt1_flops_1[1]&z_cnt1_flops_1[0];
    assign   nxt_cnt1_flops_1[3]=z_cnt1_flops_1[3]^z_cnt1_flops_1[2]&z_cnt1_flops_1[1]&z_cnt1_flops_1[0];
    assign   nxt_cnt1_flops_1[4]=z_cnt1_flops_1[4]^z_cnt1_flops_1[3]&z_cnt1_flops_1[2]&z_cnt1_flops_1[1]&z_cnt1_flops_1[0];
    assign   nxt_cnt1_flops_1[5]=z_cnt1_flops_1[5]^z_cnt1_flops_1[4]&z_cnt1_flops_1[3]&z_cnt1_flops_1[2]&z_cnt1_flops_1[1]&z_cnt1_flops_1[0];
    assign   nxt_cnt1_flops_1[6]=z_cnt1_flops_1[6]^z_cnt1_flops_1[5]&z_cnt1_flops_1[4]&z_cnt1_flops_1[3]&z_cnt1_flops_1[2]&z_cnt1_flops_1[1]&z_cnt1_flops_1[0];
    assign   nxt_cnt1_flops_1[7]=z_cnt1_flops_1[7]^z_cnt1_flops_1[6]&z_cnt1_flops_1[5]&z_cnt1_flops_1[4]&z_cnt1_flops_1[3]&z_cnt1_flops_1[2]&z_cnt1_flops_1[1]&z_cnt1_flops_1[0];
    assign   overFlow1_S_input=&z_cnt1_flops_1[7:0];
    //Modeling the second set of flops in COUNTER 1 (FLOPS_2)
    //Generates the primary MSB1* outputs
    //srdff_mapsmro #(.WIDTH (8)) ICNT1_FLOPS_2 ( psmOscMsb1[7:0], clk_CGRO, z_cnt1_flops_1[7:0], 1'b0, ~NOR2_INV_OUT );
    //Pin mapping provided for the block 
    srdff_mapsmro #(.WIDTH(8)) ICNT1_FLOPS_2 (
        .q(psmOscMsb1[7:0]),
        .clk(clk_CGRO),
        .d(z_cnt1_flops_1[7:0]),
        .set(1'b0),
        .rst(~NOR2_INV_OUT)
    );
    //srlat_mapsmro overFlow1 (overFlow1_S_input, cnt0_is_zero, wire_overFlow1);
    //Pin mapping provided for the block 
    srlat_mapsmro overFlow1 (
        .s(overFlow1_S_input),
        .r(cnt0_is_zero),
        .q(wire_overFlow1)
    );
    //// End of ICNT1 - SECOND COUNTER ////
    //// Modeling the primary output overFlow ////
    //assign overFlow = wire_overFlow0 | wire_overFlow1;
    assign   overFlow_sig=wire_overFlow0|wire_overFlow1;
    //lsclk_mapsmro levelshift_overFlow ((overFlow_sig), oscEn1, VDD2, VDD1, VSS, overFlow);
    //LSLLCKEQ0 levelshift_overFlow ((overFlow_sig), oscEn1, VDD2, VDD1, VSS, overFlow);
    //lsenosc_mapsmro levelshift_overFLow ((~overFlow_sig), oscEn1, VDD2, VDD1, VSS, overFlow);
    //Pin mapping provided for the LSLLCKEQ0 block 
    LSLLCKEQ0 levelshift_overFlow (
        .in_vpwr1(overFlow_sig),
        .vpwr1pwrok_vpwr2(oscEn1),
        .VPWR1(VDD2),
        .VPWR2(VDD1),
        .VSS(VSS),
        .out_vpwr2_l(overFlow)
    );
    //Commenting out the lines below on June 29th 2016 (A to B)
    //A
    //always @* begin
    //  overFlow = psmOscMsb0[7] & psmOscMsb1[7]; 
    //  //Added by Krishnan - en2 not generated now and hence invalid is ~en1
    //  invalid  = ~(en1);
    //end
    //
    ////CLKGATER clkGater2 ( .CG(clkout), .D(psmOscGater), .C(CLK) );
    //
    ////always @* begin
    ////  if (~en1) begin
    ////      psmOscMsb0[7:0] = 8'b0000_0000;
    ////      psmOscMsb1[7:0] = 8'b0000_0000;
    ////      psmOscLsb[31:0]  = 32'b0000_0000_0000_0000_0000_0000_0000_0000;
    ////  end
    ////  else begin
    ////    case (div[1:0])
    ////      2'b00: begin
    ////        psmOscMsb0[7:0] = 8'b0001_0000;
    ////        psmOscMsb1[7:0] = 8'b0001_0001;
    ////        psmOscLsb[31:0]  = 32'b0000_0000_0000_0000_0000_0000_0000_0011;
    ////      end
    ////      2'b01: begin
    ////        psmOscMsb0[7:0] = 8'b0010_0000;
    ////        psmOscMsb1[7:0] = 8'b0010_0001;
    ////        psmOscLsb[31:0]  = 32'b0000_0000_0000_0000_0000_0000_0000_1111;
    ////      end
    ////      2'b10: begin
    ////        psmOscMsb0[7:0] = 8'b0100_0000;
    ////        psmOscMsb1[7:0] = 8'b0100_0001;
    ////        psmOscLsb[31:0]  = 32'b0000_0000_0000_0000_0000_0000_1111_1111;
    ////      end
    ////      2'b11: begin
    ////        psmOscMsb0[7:0] = 8'b1000_0000;
    ////        psmOscMsb1[7:0] = 8'b1000_0001;
    ////        psmOscLsb[31:0]  = 32'b0000_0000_0000_0000_1111_1111_1111_1111;
    ////      end
    ////      // VCS coverage off
    ////      default: begin
    ////        psmOscMsb0[7:0] = 8'bxxxx_xxxx;
    ////        psmOscMsb1[7:0] = 8'bxxxx_xxxx;
    ////        psmOscLsb[31:0]  = 32'bxxxx_xxxx_xxxx_xxxx_xxxx_xxxx_xxxx_xxxx;
    ////      end
    ////      // VCS coverage on
    ////    endcase // case(div[1:0])
    ////  end // end of if statement
    ////end
    //
    ////always block taken from matechcoe28u as per macro owner's (Arun Iyer) feedback
    ////Added by Krishnan: oscEn2 not used any longer so the if statement will have oscEn1 only
    //always @* begin
    //  if (oscEn1) begin
    //    case (div[1:0])
    //      2'b00: begin
    //        psmOscMsb0[7:0] = 8'b0001_0000;
    //        psmOscMsb1[7:0] = 8'b0001_0001;
    //        psmOscLsb[31:0]  = 32'b0000_0000_0000_0000_0000_0000_0000_0011;
    //      end
    //      2'b01: begin
    //        psmOscMsb0[7:0] = 8'b0010_0000;
    //        psmOscMsb1[7:0] = 8'b0010_0001;
    //        psmOscLsb[31:0]  = 32'b0000_0000_0000_0000_0000_0000_0000_1111;
    //      end
    //      2'b10: begin
    //        psmOscMsb0[7:0] = 8'b0100_0000;
    //        psmOscMsb1[7:0] = 8'b0100_0001;
    //        psmOscLsb[31:0]  = 32'b0000_0000_0000_0000_0000_0000_1111_1111;
    //      end
    //      2'b11: begin
    //        psmOscMsb0[7:0] = 8'b1000_0000;
    //        psmOscMsb1[7:0] = 8'b1000_0001;
    //        psmOscLsb[31:0]  = 32'b0000_0000_0000_0000_1111_1111_1111_1111;
    //      end
    //      // VCS coverage off
    //      default: begin
    //        psmOscMsb0[7:0] = 8'bxxxx_xxxx;
    //        psmOscMsb1[7:0] = 8'bxxxx_xxxx;
    //        psmOscLsb[31:0]  = 32'bxxxx_xxxx_xxxx_xxxx_xxxx_xxxx_xxxx_xxxx;
    //      end
    //      // VCS coverage on
    //    endcase // case(div[1:0])
    //  end
    //  else begin
    //    psmOscMsb0[7:0] = 8'b0000_0000;
    //    psmOscMsb1[7:0] = 8'b0000_0000;
    //    psmOscLsb[31:0]  = 32'b0000_0000_0000_0000_0000_0000_0000_0000;
    //  end // end of else part (oscEn1 & oscEn2)
    //end // end of combitorial logic for MSB* & LSB* o/p
    //
    ////! unused VDD1
    ////! unused VDD2
    ////! unused VSS
    ////! unused divClk_d_2
    //B
    // leda on

endmodule
//
//// leda E_001 on
//// leda E_122 on


//****************************************
// Warning! This file is machine generated
//****************************************
