// mathermalro
// Thermal RO macro : Outputs ROC freq proportinal to temperature

`timescale 1ps/1ps

module mathermalro (
  input VDD,     
  input VSS,     
  input [6:0] en,
  output wire [6:0] out
);

  assign #750  out[0] = en[0] ? ~out[0] : en[0];   // osc count = "sample size" / 5  , assuming 300ps CCLK
  assign #900  out[1] = en[1] ? ~out[1] : en[1];   // osc count = "sample size" / 6  , assuming 300ps CCLK
  assign #1050 out[2] = en[2] ? ~out[2] : en[2];   // osc count = "sample size" / 7  , assuming 300ps CCLK
  assign #1200 out[3] = en[3] ? ~out[3] : en[3];   // osc count = "sample size" / 8  , assuming 300ps CCLK
  assign #1350 out[4] = en[4] ? ~out[4] : en[4];   // osc count = "sample size" / 9  , assuming 300ps CCLK
  assign #1500 out[5] = en[5] ? ~out[5] : en[5];   // osc count = "sample size" / 10 , assuming 300ps CCLK
  assign #300  out[6] = en[6] ? ~out[6] : en[6];   // osc count = "sample size" / 2  , assuming 300ps CCLK

//! unused VDD
//! unused VSS

endmodule

