
`timescale 1ps/1ps
module mbclkds_16to1_mux (
input       VDD,
input       VSS,
input [3:0] SEL,
input [15:0] IN,
output      OUT
);

reg pre_OUT;

always @(*) begin
    case (SEL[3:0])
        4'b0000 : pre_OUT = IN[0];
        4'b0001 : pre_OUT = IN[1];
        4'b0010 : pre_OUT = IN[2];
        4'b0011 : pre_OUT = IN[3];
        4'b0100 : pre_OUT = IN[4];
        4'b0101 : pre_OUT = IN[5];
        4'b0110 : pre_OUT = IN[6];
        4'b0111 : pre_OUT = IN[7];
        4'b1000 : pre_OUT = IN[8];
        4'b1001 : pre_OUT = IN[9];
        4'b1010 : pre_OUT = IN[10];
        4'b1011 : pre_OUT = IN[11];
        4'b1100 : pre_OUT = IN[12];
        4'b1101 : pre_OUT = IN[13];
        4'b1110 : pre_OUT = IN[14];
        4'b1111 : pre_OUT = IN[15];
        default : pre_OUT = 1'bx;
    endcase
end

assign OUT = pre_OUT;

endmodule
