`timescale 1ps/1ps
module mbclkds_charz_divider (
input       VDD,
input       VSS,
input [1:0] DIV_RATIO,
input       IN,
input       ASYNC_RESETB,
output      OUT
);

reg [1:0] count;

always @(posedge IN or negedge ASYNC_RESETB) begin
    if (~ASYNC_RESETB)
        count <= 2'b00;
    else
        count <= count + 1'b1;
end

wire div2_gated = (DIV_RATIO[1] & ~DIV_RATIO[0]) & count[0];
wire div4_gated = (DIV_RATIO[1] &  DIV_RATIO[0]) & count[1];

assign OUT = DIV_RATIO[1] ? DIV_RATIO[0] ? div4_gated : div2_gated : IN;


endmodule

