`timescale 1ps/1ps
module mbclkds_charz_observ (
input       VDD,
input       VSS,
input [3:0] CHARZ_SEL_A,
input [3:0] CHARZ_SEL_B,
input [1:0] CHARZ_DIV_A,
input [1:0] CHARZ_DIV_B,
input       ASYNC_RESETB,
input       IN_0,
input       IN_1,
input       IN_2,
input       IN_3,
input       IN_4,
input       IN_5,
input       IN_6,
input       IN_7,
input       IN_8,
input       IN_9,
input       IN_10,
input       IN_11,
input       IN_12,
input       IN_13,
input       IN_14,
input       IN_15,
output      charz_observ_a,
output      charz_observ_b
);

wire [15:0] IN_bus;

assign IN_bus = {
              IN_15,
              IN_14,
              IN_13,
              IN_12,
              IN_11,
              IN_10,
              IN_9,
              IN_8,
              IN_7,
              IN_6,
              IN_5,
              IN_4,
              IN_3,
              IN_2,
              IN_1,
              IN_0
              };



//=============================================
// Mux and divider for charz_observ_a
mbclkds_16to1_mux I_16to1_mux_a (
    .VDD        (VDD),
    .VSS        (VSS),
    .SEL        (CHARZ_SEL_A[3:0]),
    .IN         (IN_bus[15:0]),
    .OUT        (MUX_OUT_A)
    );

mbclkds_charz_divider I_charz_divider_a (
    .VDD                (VDD),
    .VSS                (VSS),
    .DIV_RATIO          (CHARZ_DIV_A[1:0]),
    .IN                 (MUX_OUT_A),
    .ASYNC_RESETB       (ASYNC_RESETB),
    .OUT                (charz_observ_a)
);

//=============================================
// Mux and divider for charz_observ_b
mbclkds_16to1_mux I_16to1_mux_b (
    .VDD        (VDD),
    .VSS        (VSS),
    .SEL        (CHARZ_SEL_B[3:0]),
    .IN         (IN_bus[15:0]),
    .OUT        (MUX_OUT_B)
    );

mbclkds_charz_divider I_charz_divider_b (
    .VDD                (VDD),
    .VSS                (VSS),
    .DIV_RATIO          (CHARZ_DIV_B[1:0]),
    .IN                 (MUX_OUT_B),
    .ASYNC_RESETB       (ASYNC_RESETB),
    .OUT                (charz_observ_b)
);

endmodule


