`timescale 1ps/1ps
module mbclkds_tiehi (
input VDD,
input VSS,
output Z
);

assign Z = VDD & ~VSS;

endmodule

`timescale 1ps/1ps

module mbstretch_LS_forRTL_only (
DIN_VDDIN, 
VDDINPWROK_VDDOUT, 
VDDIN, 
VDDOUT, 
VSS, 
DOUT_VDDOUT
);

parameter  size = 1;

input                  DIN_VDDIN;
input                  VDDINPWROK_VDDOUT;
input                  VDDIN;
input                  VDDOUT;
input                  VSS;
output wire            DOUT_VDDOUT;

wire DOUTN_VDDOUT;

LSILLEQ1_TSMC28HP #(.size(size)) I_LS (
                                  .in_vpwr1(DIN_VDDIN),
                                  .vpwr1pwrok_vpwr2 (VDDINPWROK_VDDOUT), 
                                  .VPWR1 (VDDIN),
                                  .VPWR2 (VDDOUT),
                                  .VSS1 (VSS),
                                  .VSS2 (VSS),
                                  .out_vpwr2_l(DOUTN_VDDOUT)
                                  );

assign DOUT_VDDOUT = ~DOUTN_VDDOUT;

endmodule

`timescale 1ps/1ps

module mbstretch_LSvdd2vddint_FastCell (
DIN_VDDIN, 
VDDINPWROK_VDDOUT, 
VDDIN, 
VDDOUT, 
VSS, 
DOUT_VDDOUT
);

input                  DIN_VDDIN;
input                  VDDINPWROK_VDDOUT;
input                  VDDIN;
input                  VDDOUT;
input                  VSS;
output wire            DOUT_VDDOUT;

mbstretch_LS_forRTL_only I_LS (
                                  .DIN_VDDIN(DIN_VDDIN),
                                  .VDDINPWROK_VDDOUT (VDDINPWROK_VDDOUT), 
                                  .VDDIN (VDDIN),
                                  .VDDOUT (VDDOUT),
                                  .VSS (VSS),
                                  .DOUT_VDDOUT (DOUT_VDDOUT)
                                  );

endmodule

`timescale 1ps/1ps

module mbstretch_LSvdd2vddint_cpu_FastCell (
DIN_VDDIN, 
VDDINPWROK_VDDOUT, 
VDDIN, 
VDDOUT, 
VSS, 
DOUT_VDDOUT
);

input                  DIN_VDDIN;
input                  VDDINPWROK_VDDOUT;
input                  VDDIN;
input                  VDDOUT;
input                  VSS;
output wire            DOUT_VDDOUT;

mbstretch_LS_forRTL_only I_LS (
                                  .DIN_VDDIN(DIN_VDDIN),
                                  .VDDINPWROK_VDDOUT (VDDINPWROK_VDDOUT), 
                                  .VDDIN (VDDIN),
                                  .VDDOUT (VDDOUT),
                                  .VSS (VSS),
                                  .DOUT_VDDOUT (DOUT_VDDOUT)
                                  );

endmodule

`timescale 1ps/1ps

module mbstretch_LSvdd2vddint_SlowCell (
DIN_VDDIN, 
VDDINPWROK_VDDOUT, 
VDDIN, 
VDDOUT, 
VSS, 
DOUT_VDDOUT
);

input                  DIN_VDDIN;
input                  VDDINPWROK_VDDOUT;
input                  VDDIN;
input                  VDDOUT;
input                  VSS;
output wire            DOUT_VDDOUT;


mbstretch_LS_forRTL_only I_LS (
                                  .DIN_VDDIN(DIN_VDDIN),
                                  .VDDINPWROK_VDDOUT (VDDINPWROK_VDDOUT), 
                                  .VDDIN (VDDIN),
                                  .VDDOUT (VDDOUT),
                                  .VSS (VSS),
                                  .DOUT_VDDOUT (DOUT_VDDOUT)
                                  );

endmodule

`timescale 1ps/1ps

module mbstretch_LSvdd2vddpll_SlowCell (
DIN_VDDIN, 
VDDINPWROK_VDDOUT, 
VDDIN, 
VDDOUT, 
VSS, 
DOUT_VDDOUT
);

input                  DIN_VDDIN;
input                  VDDINPWROK_VDDOUT;
input                  VDDIN;
input                  VDDOUT;
input                  VSS;
output wire            DOUT_VDDOUT;


mbstretch_LS_forRTL_only I_LS (
                                  .DIN_VDDIN(DIN_VDDIN),
                                  .VDDINPWROK_VDDOUT (VDDINPWROK_VDDOUT), 
                                  .VDDIN (VDDIN),
                                  .VDDOUT (VDDOUT),
                                  .VSS (VSS),
                                  .DOUT_VDDOUT (DOUT_VDDOUT)
                                  );

endmodule

`timescale 1ps/1ps

module mbstretch_LSvddint2vdd_FastCell (
DIN_VDDIN, 
VDDINPWROK_VDDOUT, 
VDDIN, 
VDDOUT, 
VSS, 
DOUT_VDDOUT
);

input                  DIN_VDDIN;
input                  VDDINPWROK_VDDOUT;
input                  VDDIN;
input                  VDDOUT;
input                  VSS;
output wire            DOUT_VDDOUT;


mbstretch_LS_forRTL_only I_LS (
                                  .DIN_VDDIN(DIN_VDDIN),
                                  .VDDINPWROK_VDDOUT (VDDINPWROK_VDDOUT), 
                                  .VDDIN (VDDIN),
                                  .VDDOUT (VDDOUT),
                                  .VSS (VSS),
                                  .DOUT_VDDOUT (DOUT_VDDOUT)
                                  );

endmodule

`timescale 1ps/1ps

module mbstretch_LSvddint2vdd_cpu_FastCell (
DIN_VDDIN, 
VDDINPWROK_VDDOUT, 
VDDIN, 
VDDOUT, 
VSS, 
DOUT_VDDOUT
);

input                  DIN_VDDIN;
input                  VDDINPWROK_VDDOUT;
input                  VDDIN;
input                  VDDOUT;
input                  VSS;
output wire            DOUT_VDDOUT;


mbstretch_LS_forRTL_only I_LS (
                                  .DIN_VDDIN(DIN_VDDIN),
                                  .VDDINPWROK_VDDOUT (VDDINPWROK_VDDOUT), 
                                  .VDDIN (VDDIN),
                                  .VDDOUT (VDDOUT),
                                  .VSS (VSS),
                                  .DOUT_VDDOUT (DOUT_VDDOUT)
                                  );

endmodule

`timescale 1ps/1ps

module mbstretch_LSvddint2vdd_SlowCell (
DIN_VDDIN, 
VDDINPWROK_VDDOUT, 
VDDIN, 
VDDOUT, 
VSS, 
DOUT_VDDOUT
);

input                  DIN_VDDIN;
input                  VDDINPWROK_VDDOUT;
input                  VDDIN;
input                  VDDOUT;
input                  VSS;
output wire            DOUT_VDDOUT;


mbstretch_LS_forRTL_only I_LS (
                                  .DIN_VDDIN(DIN_VDDIN),
                                  .VDDINPWROK_VDDOUT (VDDINPWROK_VDDOUT), 
                                  .VDDIN (VDDIN),
                                  .VDDOUT (VDDOUT),
                                  .VSS (VSS),
                                  .DOUT_VDDOUT (DOUT_VDDOUT)
                                  );

endmodule

`timescale 1ps/1ps

module mbstretch_LSvddpll2vdd_SlowCell (
DIN_VDDIN, 
VDDINPWROK_VDDOUT, 
VDDIN, 
VDDOUT, 
VSS, 
DOUT_VDDOUT
);

input                  DIN_VDDIN;
input                  VDDINPWROK_VDDOUT;
input                  VDDIN;
input                  VDDOUT;
input                  VSS;
output wire            DOUT_VDDOUT;

mbstretch_LS_forRTL_only I_LS (
                                  .DIN_VDDIN(DIN_VDDIN),
                                  .VDDINPWROK_VDDOUT (VDDINPWROK_VDDOUT), 
                                  .VDDIN (VDDIN),
                                  .VDDOUT (VDDOUT),
                                  .VSS (VSS),
                                  .DOUT_VDDOUT (DOUT_VDDOUT)
                                  );

endmodule

`timescale 1ps/1ps

module mbstretch_sniff_vdd_on_vddpll (
input                 VDDIN,
input                 VDDOUT,
input                 VSS,
output wire           VDDINOk
);


AMS_POWERSNIFFER I_sniff_vdd (
                                .VDDIN(VDDIN),
                                .VDDOUT(VDDOUT),
                                .VSS(VSS),
                                .VDDINOk(VDDINOk)
                             );

endmodule                             
`timescale 1ps/1ps

module mbstretch_sniff_vddint_on_vdd (
input                 VDDIN,
input                 VDDOUT,
input                 VSS,
output wire           VDDINOk
);


AMS_POWERSNIFFER I_sniff_vdd (
                                .VDDIN(VDDIN),
                                .VDDOUT(VDDOUT),
                                .VSS(VSS),
                                .VDDINOk(VDDINOk)
                             );

endmodule            

`timescale 1ps/1ps

module mbstretch_sniff_vddpll_on_vdd (
input                 VDDIN,
input                 VDDOUT,
input                 VSS,
output wire           VDDINOk
);


AMS_POWERSNIFFER I_sniff_vdd (
                                .VDDIN(VDDIN),
                                .VDDOUT(VDDOUT),
                                .VSS(VSS),
                                .VDDINOk(VDDINOk)
                             );

endmodule

`timescale 1ps/1ps

module mbstretch_ls_baco_and_VDDPLL (
input                 VDDPLL,
input                 VSS,
input                 IN_PWROK,
input                 IN_ISO_DISP,
output                OUT_PWROK_FOR_LS
                    );

wire pg_good = VDDPLL & ~VSS;

assign OUT_PWROK_FOR_LS = pg_good ? (IN_PWROK & IN_ISO_DISP) : 1'bx;

endmodule

`timescale 1ps/1ps

module mbstretch_ls_baco_and_VDD (
input                 VDD,
input                 VSS,
input                 IN_PWROK,
input                 IN_ISO_DISP,
output                OUT_PWROK_FOR_LS
                    );

wire pg_good = VDD & ~VSS;

assign OUT_PWROK_FOR_LS = pg_good ? (IN_PWROK & IN_ISO_DISP) : 1'bx;

endmodule
