`timescale 1ps/1ps

module mbdroop_cdc (

input           VDD, 
input           VSS,

input           dfs_clk,
input           ENABLE_DD,
input           STRETCH_ENABLE,
input           staticEnable,
input           masterReset,
input           FSM_OVERRIDE_EN,

output          cdc_ENABLE_DD,
output          cdc_STRETCH_ENABLE,
output          cdc_staticEnable,
output          cdc_masterReset,
output          cdc_FSM_OVERRIDE_EN
);


mbclkds_cdccell I_CDC_ENABLE_DD (
                    .VDD        (VDD),
                    .VSS        (VSS),
                    .CLK        (dfs_clk),
                    .DATAIN     (ENABLE_DD),
                    .DATAOUT    (cdc_ENABLE_DD)
                    );

mbclkds_cdccell I_CDC_STRETCH_ENABLE (
                    .VDD        (VDD),
                    .VSS        (VSS),
                    .CLK        (dfs_clk),
                    .DATAIN     (STRETCH_ENABLE),
                    .DATAOUT    (cdc_STRETCH_ENABLE)
                    );

mbclkds_cdccell I_CDC_staticEnable (
                    .VDD        (VDD),
                    .VSS        (VSS),
                    .CLK        (dfs_clk),
                    .DATAIN     (staticEnable),
                    .DATAOUT    (cdc_staticEnable)
                    );

mbclkds_cdccell I_CDC_masterReset (
                    .VDD        (VDD),
                    .VSS        (VSS),
                    .CLK        (dfs_clk),
                    .DATAIN     (masterReset),
                    .DATAOUT    (cdc_masterReset)
                    );

mbclkds_cdccell I_CDC_FSM_OVERRIDE_EN (
                    .VDD        (VDD),
                    .VSS        (VSS),
                    .CLK        (dfs_clk),
                    .DATAIN     (FSM_OVERRIDE_EN),
                    .DATAOUT    (cdc_FSM_OVERRIDE_EN)
                    );

endmodule                    
