`timescale 1ps/1ps

module mbdroop_sapr_top_cdc_container (

`ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
input dfs_clk_gated,
`endif
input        NO_EXTRA_COARSE_STEP,
input  [1:0] FREQ_MODE,
input  [2:0] STRETCH_THRESH,
input  [1:0] CONSERVATIVE_LOCK,
input  [2:0] LOW_BW_SKEW_EN ,
input  [6:0] LOW_BW_CONFIG_UP,
input  [6:0] LOW_BW_CONFIG ,
input  [3:0] FSM_WAIT_CYCLES,
input  [3:0] SAMPLE_SIZE ,
input  [1:0] PD_SYNC_SEL,
input  [4:0] UNSTRETCH_THRESH,
input  [3:0] DFSSTRETCH_AMOUNT,

output       NO_EXTRA_COARSE_STEP_buf,
output [1:0] FREQ_MODE_buf ,
output [2:0] STRETCH_THRESH_buf,
output [1:0] CONSERVATIVE_LOCK_buf,
output       LOW_BW_SKEW_EN_buf,
output [6:0] LOW_BW_CONFIG_UP_buf,
output [6:0] LOW_BW_CONFIG_buf ,
output [3:0] FSM_WAIT_CYCLES_buf ,
output [3:0] SAMPLE_SIZE_buf,
output [1:0] PD_SYNC_SEL_buf,
output [4:0] UNSTRETCH_THRESH_buf,
output [3:0] DFSSTRETCH_AMOUNT_buf

);

mbclkds_CDCBUF I_NO_EXTRA_COARSE_STEP (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(NO_EXTRA_COARSE_STEP), 
           .Z(NO_EXTRA_COARSE_STEP_buf) );
//---------------------------------------------------------
mbclkds_CDCBUF I_FREQ_MODE_1 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(FREQ_MODE[1]), 
           .Z(FREQ_MODE_buf[1]) );
mbclkds_CDCBUF I_FREQ_MODE_0 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(FREQ_MODE[0]), 
           .Z(FREQ_MODE_buf[0]) );
//--------------------------------------------------------
mbclkds_CDCBUF I_STRETCH_THRESH_2 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(STRETCH_THRESH[2]), 
           .Z(STRETCH_THRESH_buf[2]) );
mbclkds_CDCBUF I_STRETCH_THRESH_1 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(STRETCH_THRESH[1]), 
           .Z(STRETCH_THRESH_buf[1]) );
mbclkds_CDCBUF I_STRETCH_THRESH_0 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(STRETCH_THRESH[0]), 
           .Z(STRETCH_THRESH_buf[0]) );
//---------------------------------------------------------
mbclkds_CDCBUF I_CONSERVATIVE_LOCK_1 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(CONSERVATIVE_LOCK[1]), 
           .Z(CONSERVATIVE_LOCK_buf[1]) );
mbclkds_CDCBUF I_CONSERVATIVE_LOCK_0 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(CONSERVATIVE_LOCK[0]), 
           .Z(CONSERVATIVE_LOCK_buf[0]) );

//----------------------------------------------------------
mbclkds_CDCBUF I_LOW_BW_SKEW_EN (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(LOW_BW_SKEW_EN[0]), 
           .Z(LOW_BW_SKEW_EN_buf) );
//--------------------------------------------------------
mbclkds_CDCBUF I_LOW_BW_CONFIG_UP_6 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(LOW_BW_CONFIG_UP[6]), 
           .Z(LOW_BW_CONFIG_UP_buf[6]) );
mbclkds_CDCBUF I_LOW_BW_CONFIG_UP_5 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(LOW_BW_CONFIG_UP[5]), 
           .Z(LOW_BW_CONFIG_UP_buf[5]) );
mbclkds_CDCBUF I_LOW_BW_CONFIG_UP_4 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(LOW_BW_CONFIG_UP[4]), 
           .Z(LOW_BW_CONFIG_UP_buf[4]) );
mbclkds_CDCBUF I_LOW_BW_CONFIG_UP_3 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(LOW_BW_CONFIG_UP[3]), 
           .Z(LOW_BW_CONFIG_UP_buf[3]) );
mbclkds_CDCBUF I_LOW_BW_CONFIG_UP_2 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(LOW_BW_CONFIG_UP[2]), 
           .Z(LOW_BW_CONFIG_UP_buf[2]) );
mbclkds_CDCBUF I_LOW_BW_CONFIG_UP_1 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(LOW_BW_CONFIG_UP[1]), 
           .Z(LOW_BW_CONFIG_UP_buf[1]) );
mbclkds_CDCBUF I_LOW_BW_CONFIG_UP_0 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(LOW_BW_CONFIG_UP[0]), 
           .Z(LOW_BW_CONFIG_UP_buf[0]) );
//--------------------------------------------------------
mbclkds_CDCBUF I_LOW_BW_CONFIG_6 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(LOW_BW_CONFIG[6]), 
           .Z(LOW_BW_CONFIG_buf[6]) );
mbclkds_CDCBUF I_LOW_BW_CONFIG_5 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(LOW_BW_CONFIG[5]), 
           .Z(LOW_BW_CONFIG_buf[5]) );
mbclkds_CDCBUF I_LOW_BW_CONFIG_4 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(LOW_BW_CONFIG[4]), 
           .Z(LOW_BW_CONFIG_buf[4]) );
mbclkds_CDCBUF I_LOW_BW_CONFIG_3 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(LOW_BW_CONFIG[3]), 
           .Z(LOW_BW_CONFIG_buf[3]) );
mbclkds_CDCBUF I_LOW_BW_CONFIG_2 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(LOW_BW_CONFIG[2]), 
           .Z(LOW_BW_CONFIG_buf[2]) );
mbclkds_CDCBUF I_LOW_BW_CONFIG_1 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(LOW_BW_CONFIG[1]), 
           .Z(LOW_BW_CONFIG_buf[1]) );
mbclkds_CDCBUF I_LOW_BW_CONFIG_0 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(LOW_BW_CONFIG[0]), 
           .Z(LOW_BW_CONFIG_buf[0]) );
//--------------------------------------------------------
mbclkds_CDCBUF I_FSM_WAIT_CYCLES_3 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(FSM_WAIT_CYCLES[3]), 
           .Z(FSM_WAIT_CYCLES_buf[3]) );
mbclkds_CDCBUF I_FSM_WAIT_CYCLES_2 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(FSM_WAIT_CYCLES[2]), 
           .Z(FSM_WAIT_CYCLES_buf[2]) );
mbclkds_CDCBUF I_FSM_WAIT_CYCLES_1 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(FSM_WAIT_CYCLES[1]), 
           .Z(FSM_WAIT_CYCLES_buf[1]) );
mbclkds_CDCBUF I_FSM_WAIT_CYCLES_0 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(FSM_WAIT_CYCLES[0]), 
           .Z(FSM_WAIT_CYCLES_buf[0]) );
//---------------------------------------------------------
mbclkds_CDCBUF I_SAMPLE_SIZE_3 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(SAMPLE_SIZE[3]), 
           .Z(SAMPLE_SIZE_buf[3]) );
mbclkds_CDCBUF I_SAMPLE_SIZE_2 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(SAMPLE_SIZE[2]), 
           .Z(SAMPLE_SIZE_buf[2]) );
mbclkds_CDCBUF I_SAMPLE_SIZE_1 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(SAMPLE_SIZE[1]), 
           .Z(SAMPLE_SIZE_buf[1]) );
mbclkds_CDCBUF I_SAMPLE_SIZE_0 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(SAMPLE_SIZE[0]), 
           .Z(SAMPLE_SIZE_buf[0]) );
//---------------------------------------------------------
mbclkds_CDCBUF I_PD_SYNC_SEL_1 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(PD_SYNC_SEL[1]), 
           .Z(PD_SYNC_SEL_buf[1]) );
mbclkds_CDCBUF I_PD_SYNC_SEL_0 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(PD_SYNC_SEL[0]), 
           .Z(PD_SYNC_SEL_buf[0]) );
//--------------------------------------------------------
mbclkds_CDCBUF I_UNSTRETCH_THRESH_4 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(UNSTRETCH_THRESH[4]), 
           .Z(UNSTRETCH_THRESH_buf[4]) );
mbclkds_CDCBUF I_UNSTRETCH_THRESH_3 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(UNSTRETCH_THRESH[3]), 
           .Z(UNSTRETCH_THRESH_buf[3]) );
mbclkds_CDCBUF I_UNSTRETCH_THRESH_2 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(UNSTRETCH_THRESH[2]), 
           .Z(UNSTRETCH_THRESH_buf[2]) );
mbclkds_CDCBUF I_UNSTRETCH_THRESH_1 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(UNSTRETCH_THRESH[1]), 
           .Z(UNSTRETCH_THRESH_buf[1]) );
mbclkds_CDCBUF I_UNSTRETCH_THRESH_0 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(UNSTRETCH_THRESH[0]), 
           .Z(UNSTRETCH_THRESH_buf[0]) );
//---------------------------------------------------------
mbclkds_CDCBUF I_DFSSTRETCH_AMOUNT_3 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(DFSSTRETCH_AMOUNT[3]), 
           .Z(DFSSTRETCH_AMOUNT_buf[3]) );
mbclkds_CDCBUF I_DFSSTRETCH_AMOUNT_2 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(DFSSTRETCH_AMOUNT[2]), 
           .Z(DFSSTRETCH_AMOUNT_buf[2]) );
mbclkds_CDCBUF I_DFSSTRETCH_AMOUNT_1 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(DFSSTRETCH_AMOUNT[1]), 
           .Z(DFSSTRETCH_AMOUNT_buf[1]) );
mbclkds_CDCBUF I_DFSSTRETCH_AMOUNT_0 (
           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
           .DSTCLK(dfs_clk_gated),
           `endif
           .A(DFSSTRETCH_AMOUNT[0]), 
           .Z(DFSSTRETCH_AMOUNT_buf[0]) );



//mbclkds_CDCBUF I_RESERVE_6 (
//           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
//           .DSTCLK(dfs_clk_gated),
//           `endif
//           .A(RESERVE[6]), 
//           .Z(RESERVE_buf[6]) );
//
//mbclkds_CDCBUF I_RESERVE_5 (
//           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
//           .DSTCLK(dfs_clk_gated),
//           `endif
//           .A(RESERVE[5]), 
//           .Z(RESERVE_buf[5]) );
//
//mbclkds_CDCBUF I_RESERVE_4 (
//           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
//           .DSTCLK(dfs_clk_gated),
//           `endif
//           .A(RESERVE[4]), 
//           .Z(RESERVE_buf[4]) );
//
//mbclkds_CDCBUF I_RESERVE_3 (
//           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
//           .DSTCLK(dfs_clk_gated),
//           `endif
//           .A(RESERVE[3]), 
//           .Z(RESERVE_buf[3]) );
//
//mbclkds_CDCBUF I_RESERVE_2 (
//           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
//           .DSTCLK(dfs_clk_gated),
//           `endif
//           .A(RESERVE[2]), 
//           .Z(RESERVE_buf[2]) );
//
//mbclkds_CDCBUF I_RESERVE_1 (
//           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
//           .DSTCLK(dfs_clk_gated),
//           `endif
//           .A(RESERVE[1]), 
//           .Z(RESERVE_buf[1]) );
//
//mbclkds_CDCBUF I_RESERVE_0 (
//           `ifndef TECH__CDCBUF__DISABLE_BEHAVIORAL_VERILOG
//           .DSTCLK(dfs_clk_gated),
//           `endif
//           .A(RESERVE[0]), 
//           .Z(RESERVE_buf[0]) );
//



endmodule
