// Moving level shifter modules to a separate file
// mblvshtsmc28hp.v
// Ravi Rachala - 9/20/2011

`timescale 1ps/1ps
//! disable one_module_per_file 

module LSILLEQ0_TSMC28HP ( in_vpwr1, vpwr1pwrok_vpwr2, VPWR1, VPWR2, VSS1, VSS2, out_vpwr2_l);

parameter  size = 1;

input       [size-1:0] in_vpwr1;
input                  vpwr1pwrok_vpwr2;
input                  VPWR1;
input                  VPWR2;
input                  VSS1;
input                  VSS2;
output wire [size-1:0] out_vpwr2_l;

wire [size-1:0] tmp;
assign tmp[size-1:0] = ~in_vpwr1[size-1:0] ^~ {size{(VPWR1 & ~VSS1) | 1'bx}};
assign out_vpwr2_l[size-1:0] = (tmp[size-1:0] & {size{vpwr1pwrok_vpwr2}}) ^~ {size{(VPWR2 & ~VSS2) | 1'bx}};

endmodule

//===========================================================================
module LSILLNE0_TSMC28HP ( in_vpwr1, vpwr1pwrok_vpwr2, VPWR1, VPWR2, VSS1, VSS2, out_vpwr2_l);

parameter  size = 1;

input       [size-1:0] in_vpwr1;
input                  vpwr1pwrok_vpwr2;
input                  VPWR1;
input                  VPWR2;
input                  VSS1;
input                  VSS2;
output wire [size-1:0] out_vpwr2_l;

wire [size-1:0] tmp;
assign tmp[size-1:0] = ~in_vpwr1[size-1:0]  ^~ {size{(VPWR1 & ~VSS1) | 1'bx}};
assign out_vpwr2_l[size-1:0] = (tmp[size-1:0] & {size{vpwr1pwrok_vpwr2}}) ^~ {size{(VPWR2 & ~VSS2) | 1'bx}};

endmodule


module LSILLEQ1_TSMC28HP ( in_vpwr1, vpwr1pwrok_vpwr2, VPWR1, VPWR2, VSS1, VSS2, out_vpwr2_l);

parameter  size = 1;

input       [size-1:0] in_vpwr1;
input                  vpwr1pwrok_vpwr2;
input                  VPWR1;
input                  VPWR2;
input                  VSS1;
input                  VSS2;
output wire [size-1:0] out_vpwr2_l;

wire [size-1:0] tmp;
assign tmp[size-1:0] = ~in_vpwr1[size-1:0] ^~ {size{(VPWR1 & ~VSS1) | 1'bx}};
assign out_vpwr2_l[size-1:0] = (tmp[size-1:0] | {size{~vpwr1pwrok_vpwr2}}) ^~ {size{(VPWR2 & ~VSS2) | 1'bx}};
   
endmodule

//! enable one_module_per_file 

