//==================================================================================================
//
// mbdroopstretchfsm.v
// 
// Copyright (c) 2002 by Advanced Micro Devices, Inc.
//
// This file is protected by Federal Copyright Law, with all rights
// reserved. No part of this file may be reproduced, stored in a
// retrieval system, translated, transcribed, or transmitted, in any
// form, or by any means manual, electric, electronic, mechanical,
// electro-magnetic, chemical, optical, or otherwise, without prior
// explicit written permission from Advanced Micro Devices, Inc.
//
//==================================================================================================
//
// INTERESTED PARTIES
//
// Circuit              Ju Tung Ng 
// RTL                  Ricky Lau      
// Verification         Sean Sequeira 
//
//==================================================================================================
//
// Module Description
//
// Droop Detect and Stretcher CDC
//
//==================================================================================================

`timescale 1ps/1ps

module mbstretch_cdc (

input           VDD, 
input           VSS,

input           dfs_clk,
input           STRETCH_ENABLE,
input           masterReset,
input           LDO_COMP_HI,
input           LDO_COMP_LO,
input           LDO_EN,
input           FSM_OVERRIDE_EN,

output          cdc_STRETCH_ENABLE,
output          cdc_masterReset,
output          cdc_LDO_COMP_HI,
output          cdc_LDO_COMP_LO,
output          cdc_LDO_EN,
output          cdc_FSM_OVERRIDE_EN
);


mbclkds_cdccell I_CDC_STRETCH_ENABLE (
                    .VDD        (VDD),
                    .VSS        (VSS),
                    .CLK        (dfs_clk),
                    .DATAIN     (STRETCH_ENABLE),
                    .DATAOUT    (cdc_STRETCH_ENABLE)
                    );

mbclkds_cdccell I_CDC_masterReset (
                    .VDD        (VDD),
                    .VSS        (VSS),
                    .CLK        (dfs_clk),
                    .DATAIN     (masterReset),
                    .DATAOUT    (cdc_masterReset)
                    );

mbclkds_cdccell I_CDC_LDO_COMP_HI (
                    .VDD        (VDD),
                    .VSS        (VSS),
                    .CLK        (dfs_clk),
                    .DATAIN     (LDO_COMP_HI),
                    .DATAOUT    (cdc_LDO_COMP_HI)
                    );

mbclkds_cdccell I_CDC_LDO_COMP_LO (
                    .VDD        (VDD),
                    .VSS        (VSS),
                    .CLK        (dfs_clk),
                    .DATAIN     (LDO_COMP_LO),
                    .DATAOUT    (cdc_LDO_COMP_LO)
                    );

mbclkds_cdccell I_CDC_LDO_EN (
                    .VDD        (VDD),
                    .VSS        (VSS),
                    .CLK        (dfs_clk),
                    .DATAIN     (LDO_EN),
                    .DATAOUT    (cdc_LDO_EN)
                    );

mbclkds_cdccell I_CDC_FSM_OVERRIDE_EN (
                    .VDD        (VDD),
                    .VSS        (VSS),
                    .CLK        (dfs_clk),
                    .DATAIN     (FSM_OVERRIDE_EN),
                    .DATAOUT    (cdc_FSM_OVERRIDE_EN)
                    );

endmodule                    
