module mic_reset_tdr_gc10 ( 


//Broadcast to All TDRs
input Tdr_Tck,
input Tdr_Trstb,
input Tdr_Tdi,
input Tdr_Shift,
input Tdr_Capture,
input Tdr_Update



//TDR --> MIC_RESET
 ,output wire mic_rst
 ,input Tdr_mic_reset_En
 ,output Tdr_mic_reset_Tdo
); // End of Port Declaration

///// START TDR_INST - MIC_RESET /////

   localparam MIC_RESET__WIDTH = 1;
   wire [MIC_RESET__WIDTH-1:0]	MIC_RESET;
   wire [MIC_RESET__WIDTH-1:0]	MIC_RESET__DEFAULT;  

	//MIC_RESET - 0:0

   localparam  MIC_RESET_MIC_RESET__WIDTH  = 1;
   localparam [MIC_RESET_MIC_RESET__WIDTH-1:0] MIC_RESET_MIC_RESET__DEFAULT  = 1'h0;
   

   localparam  MIC_RESET_MIC_RESET__MSB  = 0;
   localparam  MIC_RESET_MIC_RESET__LSB  = 0;
   

   assign MIC_RESET__DEFAULT
                 [MIC_RESET_MIC_RESET__MSB : 
                  MIC_RESET_MIC_RESET__LSB] =  
		  MIC_RESET_MIC_RESET__DEFAULT;
   

  ati_buffer1 mrk_mic_reset[MIC_RESET_MIC_RESET__WIDTH-1:0] 
  (
    .A(MIC_RESET
      [MIC_RESET_MIC_RESET__MSB :
       MIC_RESET_MIC_RESET__LSB
      ]),    
    .Y(mic_rst)
  );





   test_reg_async_rst_gc10
     #(MIC_RESET__WIDTH)
   reg_MIC_RESET (
                           .clk(Tdr_Tck),
                           .rstb(Tdr_Trstb),
                           .en(Tdr_mic_reset_En),
                           .shift(Tdr_Shift & Tdr_mic_reset_En),
                           .capture(Tdr_Capture & Tdr_mic_reset_En),
                           .update(Tdr_Update & Tdr_mic_reset_En),
                           .d_rst(MIC_RESET__DEFAULT),
                           .q(MIC_RESET),
                           .d(MIC_RESET),
                           .si(Tdr_Tdi),
                           .so(Tdr_mic_reset_Tdo),
                           .q_sr(),
                           .q_sr_posedge()
                           );









///// END TDR_INST - MIC_RESET /////
endmodule

