//===========================================================================
//                  AMD PROPRIETARY AND CONFIDENTIAL
//           (c) 2015 Advanced Micro Devices, Inc.
//===========================================================================
// : 
// :
// : 
// : 
// : 
//=============================================================================
// Module Description:


`timescale 1ps/1ps







module mic_tam_gc_dfx1_gc_sp0_t_gc_sp0_0_t_gc10 #(
                parameter  TILE_INSTANCES    = 10, 
                parameter  NO_SCAN_CHANNELS  = 5
                ) (
  input                                      TAM_CLK,

  input        [NO_SCAN_CHANNELS-1 :0]       ScanOutChannel_gc_sp0_t00000,         // Tile Scan Channel : 
  output  wire [NO_SCAN_CHANNELS-1 :0]       SelTileScanOutChannel_gc_sp0_t00000,     // to output SRF
  input        [NO_SCAN_CHANNELS-1 :0]       ScanOutChannel_gc_sp0_t00010,         // Tile Scan Channel : 
  output  wire [NO_SCAN_CHANNELS-1 :0]       SelTileScanOutChannel_gc_sp0_t00010,     // to output SRF
  input        [NO_SCAN_CHANNELS-1 :0]       ScanOutChannel_gc_sp0_t00020,         // Tile Scan Channel : 
  output  wire [NO_SCAN_CHANNELS-1 :0]       SelTileScanOutChannel_gc_sp0_t00020,     // to output SRF
  input        [NO_SCAN_CHANNELS-1 :0]       ScanOutChannel_gc_sp0_t00100,         // Tile Scan Channel : 
  output  wire [NO_SCAN_CHANNELS-1 :0]       SelTileScanOutChannel_gc_sp0_t00100,     // to output SRF
  input        [NO_SCAN_CHANNELS-1 :0]       ScanOutChannel_gc_sp0_t00110,         // Tile Scan Channel : 
  output  wire [NO_SCAN_CHANNELS-1 :0]       SelTileScanOutChannel_gc_sp0_t00110,     // to output SRF
  input        [NO_SCAN_CHANNELS-1 :0]       ScanOutChannel_gc_sp0_t01000,         // Tile Scan Channel : 
  output  wire [NO_SCAN_CHANNELS-1 :0]       SelTileScanOutChannel_gc_sp0_t01000,     // to output SRF
  input        [NO_SCAN_CHANNELS-1 :0]       ScanOutChannel_gc_sp0_t01010,         // Tile Scan Channel : 
  output  wire [NO_SCAN_CHANNELS-1 :0]       SelTileScanOutChannel_gc_sp0_t01010,     // to output SRF
  input        [NO_SCAN_CHANNELS-1 :0]       ScanOutChannel_gc_sp0_t01020,         // Tile Scan Channel : 
  output  wire [NO_SCAN_CHANNELS-1 :0]       SelTileScanOutChannel_gc_sp0_t01020,     // to output SRF
  input        [NO_SCAN_CHANNELS-1 :0]       ScanOutChannel_gc_sp0_t01100,         // Tile Scan Channel : 
  output  wire [NO_SCAN_CHANNELS-1 :0]       SelTileScanOutChannel_gc_sp0_t01100,     // to output SRF
  input        [NO_SCAN_CHANNELS-1 :0]       ScanOutChannel_gc_sp0_t01110,         // Tile Scan Channel : 
  output  wire [NO_SCAN_CHANNELS-1 :0]       SelTileScanOutChannel_gc_sp0_t01110,     // to output SRF

  input        [NO_SCAN_CHANNELS-1 :0]       Mic_ExpectIn,              // from input SRF
  input        [NO_SCAN_CHANNELS-1 :0]       Mic_CareIn,                // from input SRF. 
                                                                        // We use care instead of mask because SRF drives
                                                                        // zeros on non-selected channels.

   // TDR Interface 
  input                                      Tdr_Tck,
  input                                      Tdr_Trstb,
  input                                      Tdr_Capture,
  input                                      Tdr_Shift,
  input                                      Tdr_Update,
   
  input                                      Tdr_mic_observe_Tdi,
  input                                      Tdr_mic_observe_En,        // MIC Control TDR Enable Signal
  output  wire                               Tdr_mic_observe_Tdo,
     
  input                                      Tdr_mic_fail_status_Tdi,
  input                                      Tdr_mic_fail_status_En,
  output  wire                               Tdr_mic_fail_status_Tdo,

  input                                      Tdr_mic_first_tile_fail_Tdi,
  input                                      Tdr_mic_first_tile_fail_En,
  output  wire                               Tdr_mic_first_tile_fail_Tdo,

  input                                      Tdr_mic_first_fail_cnt_Tdi,
  input                                      Tdr_mic_first_fail_cnt_En,
  output  wire                               Tdr_mic_first_fail_cnt_Tdo,

  input                                      Mic_Reset
  );



  localparam NO_HARV_DOMAINS = 1; 
  localparam PATCNT_SIZE = 32;
  localparam TILE_NUM_CODE = 4;

  //  TDR Interfacing   ////
  wire  [TILE_NUM_CODE-1:0]                         Mic_ObserveTileTDR;  // from MicTamCntl_TDR, Selects replicant to observe
  wire  [(TILE_INSTANCES*NO_SCAN_CHANNELS)-1:0]      StickyCompositeFail;       // single sticky per group per tile, to MicTamResult_TDR 
  wire                                              CntrEn_d1;
  wire  [PATCNT_SIZE-1:0]                           FirstFailCnt;              // to MicTamResult_TDR
  wire  [TILE_INSTANCES-1:0]                        FirstFailTile;             // First Fail Tile
  genvar                                            tile_num;
  wire [TILE_INSTANCES-1:0]                         FirstFailTile_common;



  ///////////////////////////////////////////////////////////////////////////////////
  //                       Instance : dft_corner_harvgrp_common        
 ///////////////////////////////////////////////////////////////////////////////////

  dft_corner_common_mic_ip_gc_dfx1_gc_sp0_t_gc_sp0_0_t_common_gc10 #(
    .ComnOSize(5), 
    .TilesNum(10), 
    .PatCntSize(32), 
    .TileNumCode(4)
    ) dft_corner_common_mic_ip_gc_dfx1_gc_sp0_t_gc_sp0_0_t (
    .TAM_CLK(TAM_CLK), 

    .CommonScanOutChannel_gc_sp0_t00000({{ScanOutChannel_gc_sp0_t00000[4]},{ScanOutChannel_gc_sp0_t00000[3]},{ScanOutChannel_gc_sp0_t00000[2]},{ScanOutChannel_gc_sp0_t00000[1]},{ScanOutChannel_gc_sp0_t00000[0]}}),          // from all TilesNum replicant tiles
    .CommonScanOutChannel_gc_sp0_t00010({{ScanOutChannel_gc_sp0_t00010[4]},{ScanOutChannel_gc_sp0_t00010[3]},{ScanOutChannel_gc_sp0_t00010[2]},{ScanOutChannel_gc_sp0_t00010[1]},{ScanOutChannel_gc_sp0_t00010[0]}}),          // from all TilesNum replicant tiles
    .CommonScanOutChannel_gc_sp0_t00020({{ScanOutChannel_gc_sp0_t00020[4]},{ScanOutChannel_gc_sp0_t00020[3]},{ScanOutChannel_gc_sp0_t00020[2]},{ScanOutChannel_gc_sp0_t00020[1]},{ScanOutChannel_gc_sp0_t00020[0]}}),          // from all TilesNum replicant tiles
    .CommonScanOutChannel_gc_sp0_t00100({{ScanOutChannel_gc_sp0_t00100[4]},{ScanOutChannel_gc_sp0_t00100[3]},{ScanOutChannel_gc_sp0_t00100[2]},{ScanOutChannel_gc_sp0_t00100[1]},{ScanOutChannel_gc_sp0_t00100[0]}}),          // from all TilesNum replicant tiles
    .CommonScanOutChannel_gc_sp0_t00110({{ScanOutChannel_gc_sp0_t00110[4]},{ScanOutChannel_gc_sp0_t00110[3]},{ScanOutChannel_gc_sp0_t00110[2]},{ScanOutChannel_gc_sp0_t00110[1]},{ScanOutChannel_gc_sp0_t00110[0]}}),          // from all TilesNum replicant tiles
    .CommonScanOutChannel_gc_sp0_t01000({{ScanOutChannel_gc_sp0_t01000[4]},{ScanOutChannel_gc_sp0_t01000[3]},{ScanOutChannel_gc_sp0_t01000[2]},{ScanOutChannel_gc_sp0_t01000[1]},{ScanOutChannel_gc_sp0_t01000[0]}}),          // from all TilesNum replicant tiles
    .CommonScanOutChannel_gc_sp0_t01010({{ScanOutChannel_gc_sp0_t01010[4]},{ScanOutChannel_gc_sp0_t01010[3]},{ScanOutChannel_gc_sp0_t01010[2]},{ScanOutChannel_gc_sp0_t01010[1]},{ScanOutChannel_gc_sp0_t01010[0]}}),          // from all TilesNum replicant tiles
    .CommonScanOutChannel_gc_sp0_t01020({{ScanOutChannel_gc_sp0_t01020[4]},{ScanOutChannel_gc_sp0_t01020[3]},{ScanOutChannel_gc_sp0_t01020[2]},{ScanOutChannel_gc_sp0_t01020[1]},{ScanOutChannel_gc_sp0_t01020[0]}}),          // from all TilesNum replicant tiles
    .CommonScanOutChannel_gc_sp0_t01100({{ScanOutChannel_gc_sp0_t01100[4]},{ScanOutChannel_gc_sp0_t01100[3]},{ScanOutChannel_gc_sp0_t01100[2]},{ScanOutChannel_gc_sp0_t01100[1]},{ScanOutChannel_gc_sp0_t01100[0]}}),          // from all TilesNum replicant tiles
    .CommonScanOutChannel_gc_sp0_t01110({{ScanOutChannel_gc_sp0_t01110[4]},{ScanOutChannel_gc_sp0_t01110[3]},{ScanOutChannel_gc_sp0_t01110[2]},{ScanOutChannel_gc_sp0_t01110[1]},{ScanOutChannel_gc_sp0_t01110[0]}}),          // from all TilesNum replicant tiles

    .Mic_ExpectIn({{Mic_ExpectIn[4]},{Mic_ExpectIn[3]},{Mic_ExpectIn[2]},{Mic_ExpectIn[1]},{Mic_ExpectIn[0]}}),    // from input SRF
    .Mic_CareIn({{Mic_CareIn[4]},{Mic_CareIn[3]},{Mic_CareIn[2]},{Mic_CareIn[1]},{Mic_CareIn[0]}}),    // from input SRF. 
    .SelTileScanOutChannel_gc_sp0_t00000({{SelTileScanOutChannel_gc_sp0_t00000[4]},{SelTileScanOutChannel_gc_sp0_t00000[3]},{SelTileScanOutChannel_gc_sp0_t00000[2]},{SelTileScanOutChannel_gc_sp0_t00000[1]},{SelTileScanOutChannel_gc_sp0_t00000[0]}}),   // to output SRF
    .SelTileScanOutChannel_gc_sp0_t00010({{SelTileScanOutChannel_gc_sp0_t00010[4]},{SelTileScanOutChannel_gc_sp0_t00010[3]},{SelTileScanOutChannel_gc_sp0_t00010[2]},{SelTileScanOutChannel_gc_sp0_t00010[1]},{SelTileScanOutChannel_gc_sp0_t00010[0]}}),   // to output SRF
    .SelTileScanOutChannel_gc_sp0_t00020({{SelTileScanOutChannel_gc_sp0_t00020[4]},{SelTileScanOutChannel_gc_sp0_t00020[3]},{SelTileScanOutChannel_gc_sp0_t00020[2]},{SelTileScanOutChannel_gc_sp0_t00020[1]},{SelTileScanOutChannel_gc_sp0_t00020[0]}}),   // to output SRF
    .SelTileScanOutChannel_gc_sp0_t00100({{SelTileScanOutChannel_gc_sp0_t00100[4]},{SelTileScanOutChannel_gc_sp0_t00100[3]},{SelTileScanOutChannel_gc_sp0_t00100[2]},{SelTileScanOutChannel_gc_sp0_t00100[1]},{SelTileScanOutChannel_gc_sp0_t00100[0]}}),   // to output SRF
    .SelTileScanOutChannel_gc_sp0_t00110({{SelTileScanOutChannel_gc_sp0_t00110[4]},{SelTileScanOutChannel_gc_sp0_t00110[3]},{SelTileScanOutChannel_gc_sp0_t00110[2]},{SelTileScanOutChannel_gc_sp0_t00110[1]},{SelTileScanOutChannel_gc_sp0_t00110[0]}}),   // to output SRF
    .SelTileScanOutChannel_gc_sp0_t01000({{SelTileScanOutChannel_gc_sp0_t01000[4]},{SelTileScanOutChannel_gc_sp0_t01000[3]},{SelTileScanOutChannel_gc_sp0_t01000[2]},{SelTileScanOutChannel_gc_sp0_t01000[1]},{SelTileScanOutChannel_gc_sp0_t01000[0]}}),   // to output SRF
    .SelTileScanOutChannel_gc_sp0_t01010({{SelTileScanOutChannel_gc_sp0_t01010[4]},{SelTileScanOutChannel_gc_sp0_t01010[3]},{SelTileScanOutChannel_gc_sp0_t01010[2]},{SelTileScanOutChannel_gc_sp0_t01010[1]},{SelTileScanOutChannel_gc_sp0_t01010[0]}}),   // to output SRF
    .SelTileScanOutChannel_gc_sp0_t01020({{SelTileScanOutChannel_gc_sp0_t01020[4]},{SelTileScanOutChannel_gc_sp0_t01020[3]},{SelTileScanOutChannel_gc_sp0_t01020[2]},{SelTileScanOutChannel_gc_sp0_t01020[1]},{SelTileScanOutChannel_gc_sp0_t01020[0]}}),   // to output SRF
    .SelTileScanOutChannel_gc_sp0_t01100({{SelTileScanOutChannel_gc_sp0_t01100[4]},{SelTileScanOutChannel_gc_sp0_t01100[3]},{SelTileScanOutChannel_gc_sp0_t01100[2]},{SelTileScanOutChannel_gc_sp0_t01100[1]},{SelTileScanOutChannel_gc_sp0_t01100[0]}}),   // to output SRF
    .SelTileScanOutChannel_gc_sp0_t01110({{SelTileScanOutChannel_gc_sp0_t01110[4]},{SelTileScanOutChannel_gc_sp0_t01110[3]},{SelTileScanOutChannel_gc_sp0_t01110[2]},{SelTileScanOutChannel_gc_sp0_t01110[1]},{SelTileScanOutChannel_gc_sp0_t01110[0]}}),   // to output SRF

    .CntrEn_d1(CntrEn_d1),    // to other partial MICTAM(s) for other harvestable
    .StickyCommonFail(
   		{{StickyCompositeFail[49]},{StickyCompositeFail[48]},{StickyCompositeFail[47]},{StickyCompositeFail[46]},{StickyCompositeFail[45]},
			 {StickyCompositeFail[44]},{StickyCompositeFail[43]},{StickyCompositeFail[42]},{StickyCompositeFail[41]},{StickyCompositeFail[40]},
			 {StickyCompositeFail[39]},{StickyCompositeFail[38]},{StickyCompositeFail[37]},{StickyCompositeFail[36]},{StickyCompositeFail[35]},
			 {StickyCompositeFail[34]},{StickyCompositeFail[33]},{StickyCompositeFail[32]},{StickyCompositeFail[31]},{StickyCompositeFail[30]},
			 {StickyCompositeFail[29]},{StickyCompositeFail[28]},{StickyCompositeFail[27]},{StickyCompositeFail[26]},{StickyCompositeFail[25]},
			 {StickyCompositeFail[24]},{StickyCompositeFail[23]},{StickyCompositeFail[22]},{StickyCompositeFail[21]},{StickyCompositeFail[20]},
			 {StickyCompositeFail[19]},{StickyCompositeFail[18]},{StickyCompositeFail[17]},{StickyCompositeFail[16]},{StickyCompositeFail[15]},
			 {StickyCompositeFail[14]},{StickyCompositeFail[13]},{StickyCompositeFail[12]},{StickyCompositeFail[11]},{StickyCompositeFail[10]},
			 {StickyCompositeFail[9]},{StickyCompositeFail[8]},{StickyCompositeFail[7]},{StickyCompositeFail[6]},{StickyCompositeFail[5]},
			 {StickyCompositeFail[4]},{StickyCompositeFail[3]},{StickyCompositeFail[2]},{StickyCompositeFail[1]},{StickyCompositeFail[0]}}
                    ),    // from all TilesNum replicant tiles
    .FirstCommonFailTile(FirstFailTile_common),   // to MicTamResult_TDR
    .FirstFailCnt(FirstFailCnt),    // to MicTamResult_TDR
    .Mic_Reset(Mic_Reset),    // from MicTamCntl_TDR, Resets Sticky bits
   .OrStickyOtherFailIn(1'b0),    // from snap-on other partial MICTAM for other harvestable
    .Mic_ObserveTileTDR(Mic_ObserveTileTDR)   // from MicTamCntl_TDR, Selects replicant to observe
   );

//
  generate
    for(tile_num = 0; tile_num < TILE_INSTANCES ; tile_num = tile_num+1) begin: FirstFailTileAccumulator
      
    assign FirstFailTile[tile_num] = FirstFailTile_common[tile_num];

    end // FirstFailTileAccumulator
  endgenerate

// TDR Module Instatiation //


mic_first_tile_fail_tdr_gc10  
    #(.MIC_FIRST_TILE_FAIL_WIDTH(10)) mic_first_tile_fail_tdr(
 .Tdr_Tck(Tdr_Tck),
 .Tdr_Trstb(Tdr_Trstb),
 .Tdr_Tdi(Tdr_mic_first_tile_fail_Tdi),
 .Tdr_Shift(Tdr_Shift),
 .Tdr_Capture(Tdr_Capture),
 .Tdr_Update(Tdr_Update),
 .Tdr_mic_first_tile_fail_En(Tdr_mic_first_tile_fail_En),
 .mic_first_tile_fail(FirstFailTile),
 .Tdr_mic_first_tile_fail_Tdo(Tdr_mic_first_tile_fail_Tdo)
                    
);

mic_first_fail_cnt_tdr_gc10  
    #(.MIC_FIRST_FAIL_CNT_WIDTH(32)) mic_first_fail_cnt_tdr(
 .Tdr_Tck(Tdr_Tck),
 .Tdr_Trstb(Tdr_Trstb),
 .Tdr_Tdi(Tdr_mic_first_fail_cnt_Tdi),
 .Tdr_Shift(Tdr_Shift),
 .Tdr_Capture(Tdr_Capture),
 .Tdr_Update(Tdr_Update),
 .Tdr_mic_first_fail_cnt_En(Tdr_mic_first_fail_cnt_En),
 .mic_first_fail_cnt(FirstFailCnt),
 .Tdr_mic_first_fail_cnt_Tdo(Tdr_mic_first_fail_cnt_Tdo)
                    
);


mic_observe_tdr_gc10 #(.MIC_OBSERVE_WIDTH(4)) mic_observe_tdr (
 .Tdr_Tck(Tdr_Tck),
 .Tdr_Trstb(Tdr_Trstb),
 .Tdr_Tdi(Tdr_mic_observe_Tdi),
 .Tdr_Shift(Tdr_Shift),
 .Tdr_Capture(Tdr_Capture),
 .Tdr_Update(Tdr_Update),
 .Tdr_mic_observe_En(Tdr_mic_observe_En),

 .encode_value(Mic_ObserveTileTDR),

 .Tdr_mic_observe_Tdo(Tdr_mic_observe_Tdo)
);


mic_fail_status_gc_dfx1_gc_sp0_t_gc_sp0_0_t_gc10 mic_fail_status_gc_dfx1_gc_sp0_t_gc_sp0_0_t (


 .Tdr_Tck(Tdr_Tck),
 .Tdr_Trstb(Tdr_Trstb),
 .Tdr_mic_fail_status_Tdi(Tdr_mic_fail_status_Tdi),
 .Tdr_Shift(Tdr_Shift),
 .Tdr_Capture(Tdr_Capture),
 .Tdr_Update(Tdr_Update),
 .Tdr_mic_fail_status_En(Tdr_mic_fail_status_En)

 ,.Scan_Channel_Out_Fail(StickyCompositeFail)
 ,.Tdr_mic_fail_status_Tdo(Tdr_mic_fail_status_Tdo)

);

endmodule

