// ==============================================================================================
// PLEASE DONOT CHANGES THIS FILE
// THIS FILE IS AUTO_GENERATED
// Source: import/address/src/rtl/gen_one/mipmap_calc_bc_retimed.sv
// ===============================================================================================
// Filename              : mipmap_calc.v
// Perforce changelist   : $Change$
//
// Copyright             : Trade secret of AMD, Inc.
//                         Copyright 2008, AMD, Inc., (unpublished)
//                         All rights reserved.  This notice is intended as a precaution against
//                         inadvertent publication and does not imply publication or any waiver
//                         of confidentiality.  The year included in the foregoing notice is the
//                         year of creation of the work.
//
// RTL author: kevin.gu
//
// Description: mipmap calculator for tc

`include  "gc__tc_reg.v"
//!!!!kgu: temp use IMG_DATA_FORMAT, remember to update if TC FORMAT is ready 
`include    "gc__gb_reg.v"  // r11xx

`include "gpu_features.vh"
`include "addrlib_defines_gc.vh"

module    mipmap_calc_bc_retimed_gc(
                     //output
                      new_arraymode_out,                    //mipmap array_mode
                      pitch_tile_max_out,                   //mipmap pitch-1 in units of 8 texels
                      slice_tile_max_out,                   //mipmap slice size w*h/64-1
                      levelAdr256B_out,                     //mipmap address(256B aligned)
                      log2_pixelsize_out,

                      //input
                      st_width,                             //width-1(0 to 48K-1)
                      st_height,                            //height-1(0 to 16K-1)
                      st_depth,                             //depth-1(0 to 8K-1)
                      st_baseaddress,                       //base map address(256B aligned)
                      texture_array,                        //0: single texture, 1: texture array
                      array_mode,                           //as defines above
                      pipe_interleave_size,                 //0: 256B, 1:512B, only pipe_interleave_size[0] used
                      num_banks,                            //0: 2banks,1:4banks, 2:8banks, 3:16banks
		              pipe_config,                          //10xx new added to inplace of numofpipes and pipe mapping
                      bank_width,                           //0: 1tile, 1: 2tiles, 2: 4tiles, 3: 8tiles
                      bank_height,                          //0: 1tile, 1: 2tiles, 2: 4tiles, 3: 8tiles
                      macro_tile_aspect,                    //0: 1tile, 1: 2tiles, 2: 4tiles, 3: 8tiles
		              level,                                //mipmap level(0 to 14)
		              data_format,                          //10xx added
		              pow2pad,                              //10xx added, true if map is padded to power of 2 dimensions, 
                                                            //else it is padded to tiling requirements, must be true if levels > 1
                      sclk,                                 //clock
                      srst,
                      
                      en_stage

                      
         	      );

`ifdef GPU__GC__MEM_ADDR_BITS_ATC__48
localparam LPARAM_MEM_ADDR_WIDTH 	=  48,
           LPARAM_MEM_ADDR_BASE_WIDTH   =  48,
           LPARAM_MEM_ADDR_OFFSET_WIDTH	=  41;

`else
localparam LPARAM_MEM_ADDR_WIDTH 	=  40,
           LPARAM_MEM_ADDR_BASE_WIDTH   =  40,
           LPARAM_MEM_ADDR_OFFSET_WIDTH	=  40;

`endif

// =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
localparam  RI = 0;                         //clients doesnot have access to this
localparam  RO = 0;                         //clients doesnot have access to this
localparam CALC_STAGES = `BC_MIPMAP_STAGES; //number of "core" stages to calculate "outputs"
localparam  PAD_STAGES = 1;                  // NBC mipmap is set to RI(1)+3 = 4 stages, to make minimal changes to the BC,                                             
// =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

localparam TOTAL_PAD_STAGES = RO+PAD_STAGES;
localparam PIPE_STAGES = RI + CALC_STAGES + TOTAL_PAD_STAGES;

input                                          sclk;                    
input                                          srst;                    

input [PIPE_STAGES-1:0]                        en_stage;


//surface descriptors
input     [13:0]       st_width;
input     [13:0]       st_height;
input     [12:0]       st_depth;
input     [LPARAM_MEM_ADDR_BASE_WIDTH-8-1:0]       st_baseaddress;
input     [ 0:0]       texture_array;

//tiling attributes
input     [ 3:0]       array_mode;
input     [ 2:0]       pipe_interleave_size;
input     [ 1:0]       num_banks;
input     [ 1:0]       bank_width;
input     [ 1:0]       bank_height;
input     [ 1:0]       macro_tile_aspect;
input     [ 4:0]       pipe_config;
input     [ 5:0]       data_format;
input     [ 0:0]       pow2pad;           

//mipmap level to compute address for
input     [ 3:0]       level;


//outputs
output    [ 3:0]       new_arraymode_out;
output    [12:0]       pitch_tile_max_out;
output    [23:0]       slice_tile_max_out;
output    [LPARAM_MEM_ADDR_BASE_WIDTH-8-1:0]       levelAdr256B_out;
output    [ 2:0]       log2_pixelsize_out;

//10xx new added: pipe config decode:
 reg    [ 2 :0]   log2pipes;
   always@(*) begin
     case(pipe_config[4:0])
     5'b00000: log2pipes = 3'b001; //2 pipes
     5'b00100: log2pipes = 3'b010; //4 pipes
     5'b00101: log2pipes = 3'b010; //4 pipes
     5'b00110: log2pipes = 3'b010; //4 pipes
     5'b00111: log2pipes = 3'b010; //4 pipes
     5'b01000: log2pipes = 3'b011; //8 pipes
     5'b01001: log2pipes = 3'b011; //8 pipes
     5'b01010: log2pipes = 3'b011; //8 pipes
     5'b01011: log2pipes = 3'b011; //8 pipes
     5'b01100: log2pipes = 3'b011; //8 pipes
     5'b01101: log2pipes = 3'b011; //8 pipes
     5'b01110: log2pipes = 3'b011; //8 pipes
	 5'b10010: log2pipes = 3'b100; //16 pipes
     //VCS coverage off
     default:  log2pipes = 3'b011; //default to be 8 pipes
     //VCS coverage on
     endcase
   end

//10xx new added: decode from data format
// decode texture format
//kgu: alias data format, may need update according to definition change
   wire  fmt_8                 = (data_format == `IMG_DATA_FORMAT_8);
   wire  fmt_16                = (data_format == `IMG_DATA_FORMAT_16);
   wire  fmt_8_8               = (data_format == `IMG_DATA_FORMAT_8_8);
   wire  fmt_32                = (data_format == `IMG_DATA_FORMAT_32);
   wire  fmt_16_16             = (data_format == `IMG_DATA_FORMAT_16_16);
   wire  fmt_10_11_11          = (data_format == `IMG_DATA_FORMAT_10_11_11);
   wire  fmt_11_11_10          = (data_format == `IMG_DATA_FORMAT_11_11_10);
   wire  fmt_10_10_10_2        = (data_format == `IMG_DATA_FORMAT_10_10_10_2);
   wire  fmt_2_10_10_10        = (data_format == `IMG_DATA_FORMAT_2_10_10_10);
   wire  fmt_8_8_8_8           = (data_format == `IMG_DATA_FORMAT_8_8_8_8);
   wire  fmt_32_32             = (data_format == `IMG_DATA_FORMAT_32_32);
   wire  fmt_16_16_16_16       = (data_format == `IMG_DATA_FORMAT_16_16_16_16);
   wire  fmt_32_32_32          = (data_format == `IMG_DATA_FORMAT_32_32_32);
   wire  fmt_32_32_32_32       = (data_format == `IMG_DATA_FORMAT_32_32_32_32);
   wire  fmt_5_6_5             = (data_format == `IMG_DATA_FORMAT_5_6_5);
   wire  fmt_1_5_5_5           = (data_format == `IMG_DATA_FORMAT_1_5_5_5);
   wire  fmt_5_5_5_1           = (data_format == `IMG_DATA_FORMAT_5_5_5_1);
   wire  fmt_4_4_4_4           = (data_format == `IMG_DATA_FORMAT_4_4_4_4);
   wire  fmt_8_24              = (data_format == `IMG_DATA_FORMAT_8_24);
   wire  fmt_24_8              = (data_format == `IMG_DATA_FORMAT_24_8);
   wire  fmt_x24_8_32          = (data_format == `IMG_DATA_FORMAT_X24_8_32);
   wire  fmt_gb_gr             = (data_format == `IMG_DATA_FORMAT_GB_GR);
   wire  fmt_bg_rg             = (data_format == `IMG_DATA_FORMAT_BG_RG);
   wire  fmt_5_9_9_9           = (data_format == `IMG_DATA_FORMAT_5_9_9_9);
   wire  fmt_bc1               = (data_format == `IMG_DATA_FORMAT_BC1);
   wire  fmt_bc2               = (data_format == `IMG_DATA_FORMAT_BC2);
   wire  fmt_bc3               = (data_format == `IMG_DATA_FORMAT_BC3);
   wire  fmt_bc4               = (data_format == `IMG_DATA_FORMAT_BC4);
   wire  fmt_bc5               = (data_format == `IMG_DATA_FORMAT_BC5);
   wire  fmt_bc6               = (data_format == `IMG_DATA_FORMAT_BC6);
   wire  fmt_bc7               = (data_format == `IMG_DATA_FORMAT_BC7);
   wire  fmt_4_4               = (data_format == `IMG_DATA_FORMAT_4_4);
   wire  fmt_6_5_5             = (data_format == `IMG_DATA_FORMAT_6_5_5);
   wire  fmt_1                 = (data_format == `IMG_DATA_FORMAT_1);
   wire  fmt_1_reversed        = (data_format == `IMG_DATA_FORMAT_1_REVERSED);
`ifdef REMOVED   
   wire  fmt_32_as_8           = (data_format == `IMG_DATA_FORMAT_32_AS_8);
   wire  fmt_32_as_8_8         = (data_format == `IMG_DATA_FORMAT_32_AS_8_8);
`else
   wire  fmt_32_as_8           = 0;
   wire  fmt_32_as_8_8         = 0;
`endif  
   wire  fmt_32_as_32_32_32_32 = (data_format == `IMG_DATA_FORMAT_32_AS_32_32_32_32);
   wire  fmt_fmask8_s2_f1      = (data_format == `IMG_DATA_FORMAT_FMASK8_S2_F1);
   wire  fmt_fmask8_s4_f1      = (data_format == `IMG_DATA_FORMAT_FMASK8_S4_F1);
   wire  fmt_fmask8_s8_f1      = (data_format == `IMG_DATA_FORMAT_FMASK8_S8_F1);
   wire  fmt_fmask8_s2_f2      = (data_format == `IMG_DATA_FORMAT_FMASK8_S2_F2);
   wire  fmt_fmask8_s4_f2      = (data_format == `IMG_DATA_FORMAT_FMASK8_S4_F2);
   wire  fmt_fmask8_s4_f4      = (data_format == `IMG_DATA_FORMAT_FMASK8_S4_F4);
   wire  fmt_fmask16_s16_f1    = (data_format == `IMG_DATA_FORMAT_FMASK16_S16_F1);
   wire  fmt_fmask16_s8_f2     = (data_format == `IMG_DATA_FORMAT_FMASK16_S8_F2);
   wire  fmt_fmask32_s16_f2    = (data_format == `IMG_DATA_FORMAT_FMASK32_S16_F2);
   wire  fmt_fmask32_s8_f4     = (data_format == `IMG_DATA_FORMAT_FMASK32_S8_F4);
   wire  fmt_fmask32_s8_f8     = (data_format == `IMG_DATA_FORMAT_FMASK32_S8_F8);
   wire  fmt_fmask64_s16_f4    = (data_format == `IMG_DATA_FORMAT_FMASK64_S16_F4);
   wire  fmt_fmask64_s16_f8    = (data_format == `IMG_DATA_FORMAT_FMASK64_S16_F8);

//group fmt according to pixelsize
   wire  fmt_log2_element_is_0 = fmt_8 | fmt_4_4 | fmt_1 | fmt_1_reversed | fmt_fmask8_s2_f1 | fmt_fmask8_s4_f1 | fmt_fmask8_s8_f1| fmt_fmask8_s2_f2 | fmt_fmask8_s4_f2 | fmt_fmask8_s4_f4;
   wire  fmt_log2_element_is_1 = fmt_16 | fmt_8_8 | fmt_5_6_5 | fmt_1_5_5_5 | fmt_5_5_5_1 | fmt_4_4_4_4 | fmt_gb_gr | fmt_bg_rg | fmt_6_5_5 | fmt_fmask16_s16_f1 | fmt_fmask16_s8_f2;
   wire  fmt_log2_element_is_2 = fmt_32 | fmt_16_16 | fmt_10_11_11 | fmt_11_11_10 | fmt_10_10_10_2 | fmt_2_10_10_10 | fmt_8_8_8_8 | fmt_32_32_32 |
                                 fmt_8_24 | fmt_24_8 | fmt_5_9_9_9 | fmt_32_as_8 | fmt_32_as_8_8 | fmt_32_as_32_32_32_32 | fmt_fmask32_s16_f2 |
                                 fmt_fmask32_s8_f4 | fmt_fmask32_s8_f8;
   wire  fmt_log2_element_is_3 = fmt_32_32 | fmt_16_16_16_16 | fmt_x24_8_32 | fmt_bc1 | fmt_bc4 | fmt_fmask64_s16_f4 |  fmt_fmask64_s16_f8;
   wire  fmt_log2_element_is_4 = fmt_32_32_32_32 | fmt_bc2 | fmt_bc3 | fmt_bc5 | fmt_bc6 | fmt_bc7;

//group fmt: width adjust
   wire  fmt_width_div_2       = fmt_32_as_8_8;
   wire  fmt_width_div_4       = fmt_bc1 | fmt_bc2 | fmt_bc3 | fmt_bc4 | fmt_bc5 | fmt_bc6 | fmt_bc7 | fmt_32_as_8; 
   wire  fmt_width_div_8       = fmt_1 | fmt_1_reversed;
   wire  fmt_width_mul_3       = fmt_32_32_32;
   wire  fmt_width_mul_4       = fmt_32_as_32_32_32_32;

//group fmt: height adjust
   wire  fmt_height_div_4      = fmt_bc1 | fmt_bc2 | fmt_bc3 | fmt_bc4 | fmt_bc5 | fmt_bc6 | fmt_bc7;

//get pixelsize
   wire  [2:0] log2_pixelsize = fmt_log2_element_is_0? 3'd0: 
                                fmt_log2_element_is_1? 3'd1:
                                fmt_log2_element_is_2? 3'd2:
                                fmt_log2_element_is_3? 3'd3:3'd4;   

//kgu: left bug history
/******************************* OLD CODE BELOW *******************************************
THIS CODE BREAKS FOR non power of 2 block-compressed (BC) textures
Problem: order of operations
Example: level 0 = 136 texels
         level 1 = 68 texels
         level 2 = 34 texels
Use level of detail (LOD) 2:

In 7xx (correct):
    1) compute base_width >> level ; ex: width = 34 (8.5 BC blocks)
    2) pad result to power of 2    ; ex: 34 padded to nearest power of 2 = 64
    3) convert to blocks/4         ; ex: 64/4 = 16 BC blocks = correct answer

In 8xx (wrong):
    1) convert to blocks/4         ; ex: 136/4 = 34 BC blocks
    1) compute blocks >> level     ; ex: width = 34 (8.5 BC blocks, truncated to 8)
    2) pad result to power of 2    ; ex: 8 padded to nearest power of 2 = 8 BC blocks = wrong answer

  wire [15:0]    base_width = texel_1b ?                   {5'b0, st_width[13:3]} : (
                              (texel_BC14|texel_BC23567) ? {4'b0, st_width[13:2]} : (
                              texel_32as8 ?                {4'b0, st_width[13:2]} : (
                              texel_32as16 ?               {3'b0, st_width[13:1]} : (
                              texel_96b ?                  (st_width + st_width_hi_cycle) : (
                                                           {2'b0, st_width[13:0]})))));

  wire [13:0]    base_height = (texel_BC14|texel_BC23567) ? st_height[13:2] : st_height;
****************************************************************************************/

//rename
   wire  [1:0]    bank_tiling = num_banks;
   wire  [0:0]    linear        = (array_mode == `ARRAY_LINEAR_ALIGNED) | (array_mode == `ARRAY_LINEAR_GENERAL);
   wire  [3:0]    st_arraymode2 = array_mode;//2B, 3B removed now in R8xx

  //*************depth conv*****************//
  //kgu: at level 0, no scale, for depth no packet, pow2 if needed 
   wire [12:0]    depth_base     =  get_pow2_or_not({3'b0, st_depth}, pow2pad);//level is 0
   wire [12:0]    depth_shifted  = get_level_shifted({3'b0,st_depth}, level);
   wire [12:0]    depth_pow2     = get_pow2_or_not(depth_shifted, (pow2pad | (level >0)));  
   wire [12:0]    depth_conv     = (texture_array == 1'd1) ? depth_base : depth_pow2;

   //thick -->thin
   wire [0:0]     thick  =   (st_arraymode2 == `ARRAY_1D_TILED_THICK) 
                           | (st_arraymode2 == `ARRAY_2D_TILED_THICK)
                           | (st_arraymode2 == `ARRAY_3D_TILED_THICK)
                           | (st_arraymode2 == `ARRAY_PRT_TILED_THICK)           // r11xx: PRT mode
                           | (st_arraymode2 == `ARRAY_PRT_2D_TILED_THICK)        // r11xx: PRT mode
                           | (st_arraymode2 == `ARRAY_PRT_3D_TILED_THICK);       // r11xx: PRT mode

   wire           xthick =   (st_arraymode2 == `ARRAY_2D_TILED_XTHICK) 
                           | (st_arraymode2 == `ARRAY_3D_TILED_XTHICK);


// r11xx: Change for CI/KV/TH,  for thick tiling should transition to 1D_Thick.
//        such that the micro-tiling is the same at all mip levels.
// 
// -	2D/3D_Thick    ->   1D_Thick
// -	2D/3D_XThick    ->  1D_Thick
// 
// Instead of 
// 
// -	2D/3D_Thick -> 2D/3D_Thin -> 1D_Thin
// 


        //kgu: incase there is 4,5,6 for depth conv, however it should not happen
   //wire [3:0]     st_arraymode3 = ((level != 4'd0) && (st_arraymode2 == `ARRAY_2D_TILED_XTHICK) && (depth_conv < 7))? `ARRAY_2D_TILED_THICK:   // r11xx
   //                               ((level != 4'd0) && (st_arraymode2 == `ARRAY_3D_TILED_XTHICK) && (depth_conv < 7))? `ARRAY_3D_TILED_THICK:   // r11xx
   //                                                                                                                    st_arraymode2;          // r11xx


// update for degration: for driver can't identify TC degration, so 2D/3DXthick -> 1DThick.
   wire [3:0] st_arraymode3 = st_arraymode2;


// r11xx end



   // decode array mode
   wire [0:0]     tiled_1d       =   (st_arraymode3 == `ARRAY_1D_TILED_THIN1)
                                   | (st_arraymode3 == `ARRAY_1D_TILED_THICK);

   wire [0:0]     tiled_2d_thick =   (st_arraymode3 == `ARRAY_2D_TILED_THICK)
                                   | (st_arraymode3 == `ARRAY_3D_TILED_THICK)
                                   | (st_arraymode3 == `ARRAY_PRT_TILED_THICK)       // r11xx
                                   | (st_arraymode3 == `ARRAY_PRT_2D_TILED_THICK)    // r11xx
                                   | (st_arraymode3 == `ARRAY_PRT_3D_TILED_THICK) ;  // r11xx

   wire [0:0]     tiled_2d_thin1 =   (st_arraymode3 == `ARRAY_2D_TILED_THIN1)
                                   | (st_arraymode3 == `ARRAY_3D_TILED_THIN1)
                                   | (st_arraymode3 == `ARRAY_PRT_TILED_THIN1)       // r11xx
                                   | (st_arraymode3 == `ARRAY_PRT_2D_TILED_THIN1)    // r11xx
                                   | (st_arraymode3 == `ARRAY_PRT_3D_TILED_THIN1) ;  // r11xx

   wire           tiled_2d_xthick=   (st_arraymode3 == `ARRAY_2D_TILED_XTHICK)
                                   | (st_arraymode3 == `ARRAY_3D_TILED_XTHICK);

   wire [0:0]     tiled_2d       = tiled_2d_thick | tiled_2d_thin1 | tiled_2d_xthick;

   wire [0:0]     tiled_thick    =   (st_arraymode3 == `ARRAY_1D_TILED_THICK) |  tiled_2d_thick;

   wire           tiled_xthick   = tiled_2d_xthick;
    
  //**********bank_height and macro_tile_aspect issue****//
   wire [2:0]     log2_group_size = pipe_interleave_size[0] + 2;
   wire [3:0]     log2_bank_height_align = log2_pixelsize + bank_width + bank_height;
   wire [3:0]     log2_aspect_align = log2pipes + bank_width + log2_pixelsize + macro_tile_aspect;

   wire [3:0]     log2_bank_height_align_xthick2thick = log2_pixelsize + bank_width + bank_height + 2;
   wire [3:0]     log2_aspect_align_xthick2thick = log2pipes + bank_width + log2_pixelsize + macro_tile_aspect + 2;

   wire           original_1d   = (st_arraymode2 == `ARRAY_1D_TILED_THIN1) | (st_arraymode2 == `ARRAY_1D_TILED_THICK);
   wire           original_2D_thick =   (st_arraymode2 == `ARRAY_2D_TILED_THICK)
                                      | (st_arraymode2 == `ARRAY_3D_TILED_THICK)
                                      | (st_arraymode2 == `ARRAY_PRT_TILED_THICK)      // r11xx
                                      | (st_arraymode2 == `ARRAY_PRT_2D_TILED_THICK)   // r11xx
                                      | (st_arraymode2 == `ARRAY_PRT_3D_TILED_THICK)   // r11xx
                                      |  xthick;


   wire           now_2D_thin       = tiled_2d_thin1;

   wire           original_xthick = xthick;//(st_arraymode2 == `ARRAY_2D_TILED_XTHICK) | (st_arraymode2 == `ARRAY_3D_TILED_XTHICK);
   wire           now_thick = tiled_2d_thick;//(st_arraymode3 == `ARRAY_2D_TILED_THICK) | (st_arraymode3 == `ARRAY_3D_TILED_THICK);

   wire           bump_bank_height_xthick2thick = (log2_group_size > log2_bank_height_align_xthick2thick) & (original_xthick & now_thick);
   wire           bump_aspect_xthick2thick = (log2_group_size > log2_aspect_align_xthick2thick) & (original_xthick & now_thick); 

   wire           bump_bank_height = ((log2_group_size > log2_bank_height_align) & (original_2D_thick & now_2D_thin)) | bump_bank_height_xthick2thick;
   wire           bump_aspect = ((log2_group_size > log2_aspect_align) & (original_2D_thick & now_2D_thin)) | bump_aspect_xthick2thick;

   //10xx:
   //1) >>level
   //2) packet
   //3) padding and pow2
   wire  [13:0]   mip_width_shifted = get_level_shifted(st_width, level);//scale
   wire  [14:0]   mip_width_shifted_p1 = mip_width_shifted + 1;
   wire  [15:0]   packed_width = fmt_width_div_8   ?      mip_width_shifted[13:3]:   //ceil(/8)-1
                                 fmt_width_div_4   ?      mip_width_shifted[13:2]:   //ceil(/4)-1
                                 fmt_width_div_2   ?      mip_width_shifted[13:1]:   //ceil(/2)-1
                                 fmt_width_mul_3   ?    ({mip_width_shifted_p1,1'b0} + mip_width_shifted): //*3 -1
                                 fmt_width_mul_4   ?     {mip_width_shifted,2'b11}: //*4-1
                                                          mip_width_shifted; //not changed
   wire  [15:0]   packed_width_pow2_or_not = get_pow2_or_not(packed_width, (pow2pad | (level >0))); 

   wire [15:0]    mip_width_conv = packed_width_pow2_or_not;

  //*************height conv*****************//
   wire [13:0]    mip_height_shifted = get_level_shifted(st_height, level);//scale

   wire [13:0]    packed_height = fmt_height_div_4  ?   mip_height_shifted[13:2]:   //ceil(/4)-1
                                                        mip_height_shifted; 
   wire [13:0]    packed_height_pow2_or_not = get_pow2_or_not(packed_height, (pow2pad | (level >0))); 
   wire [13:0]    mip_height_conv    = packed_height_pow2_or_not; 

  //**************determine padding requirements****************//
   // interpret GB register
   wire [9:0]     group_bytes = pipe_interleave_size[0] ? 10'd512 : 10'd256;//in-byte
   wire [2:0]     log2banks   = bank_tiling[1:0] + 1;

   // compute minimum multiple minus 1 for width
   wire [6:0]     group_bytes_linear = 64 >> log2_pixelsize;//restrict condition of linear mode
   wire [5:0]     min_width_linear   = ((group_bytes_linear > 10'd8) ? group_bytes_linear : 10'd8) - 1;//max(8,64/element_size)
   //kgu: 10xx restriction on 1d and linear changed
   //wire [6:0]     group_bytes_tiled_1d = ((tiled_xthick | tiled_thick) ? group_bytes[9:5] : group_bytes[9:3]) >> log2_pixelsize;//restrict condition of 1D tiling mode
   wire [7:0]     min_width_tiled_1d = 7;

    wire [ 3:0]    log2_macro_tile_width = bank_width + log2pipes[2:0] + macro_tile_aspect;//0+0+0...3+3+3
    wire [12:0]    min_width_tiled_2d_sel_op1 = (13'd8 << log2_macro_tile_width);
    wire [12:0]    min_width_tiled_2d_sel = min_width_tiled_2d_sel_op1;
    wire [12:0]    min_width_tiled_2d =  min_width_tiled_2d_sel - 1;

    // compute minimum multiple minus 1 for height
    wire [7:0]     min_height_linear   =  0;
    wire [7:0]     min_height_tiled_1d =  7;

    wire [ 2:0]    log2_macro_tile_height = bank_height + log2banks - macro_tile_aspect;//0...3+3+1-0
    wire [10:0]    min_height_tiled_2d = (11'd8 << log2_macro_tile_height) - 1;//(4+7)-bit
    wire [12:0]     min_width = linear   ? min_width_linear : (                                                 // linear
                               tiled_1d ? min_width_tiled_1d : (                                               // 1D tiled
                               ((level != 4'd0) & (bump_bank_height | bump_aspect | (mip_width_conv < min_width_tiled_2d) | (mip_height_conv < min_height_tiled_2d))) ? min_width_tiled_1d : min_width_tiled_2d)); // 2D tiled

   wire [10:0]     min_height = linear   ? min_height_linear : (                                               // linear
                                tiled_1d ? min_height_tiled_1d : (                                             // 1D tiled
                                ((level != 4'd0) & (bump_bank_height | bump_aspect | (mip_width_conv < min_width_tiled_2d) | (mip_height_conv < min_height_tiled_2d))) ? min_height_tiled_1d : min_height_tiled_2d)); // 2D tiled
   
   reg [3:0]      log2_min_height;
   always @ (*) begin
      casez (min_height)
	//VCS coverage off      
        11'b11111111111 : log2_min_height = 4'd11;
	//VCS coverage on
        11'b01111111111 : log2_min_height = 4'd10;
        11'b?0111111111 : log2_min_height = 4'd9;
        11'b??011111111 : log2_min_height = 4'd8;
        11'b???01111111 : log2_min_height = 4'd7;
        11'b????0111111 : log2_min_height = 4'd6;
        11'b?????011111 : log2_min_height = 4'd5;
        11'b??????01111 : log2_min_height = 4'd4;
        11'b???????0111 : log2_min_height = 4'd3;
	//VCS coverage off
        11'b????????011 : log2_min_height = 4'd2;
        11'b?????????01 : log2_min_height = 4'd1;
	//VCS coverage on
        11'b??????????0 : log2_min_height = 4'd0;
	//VCS coverage off
        default         : log2_min_height = 4'bx;
	//VCS coverage on
      endcase
   end

   //wire [15:0] mip_width_clamped_minus1 = (mip_width_conv > min_width)? mip_width_conv : min_width;
   //kgu: width need shift to get padded
    reg [3:0]      log2_min_width;
    always @ (*) begin
      casez (min_width)
	//VCS coverage off
        13'b1111111111111 : log2_min_width = 4'd13;
	//VCS coverage on
        13'b0111111111111 : log2_min_width = 4'd12;
        13'b?011111111111 : log2_min_width = 4'd11;
        13'b??01111111111 : log2_min_width = 4'd10;
        13'b???0111111111 : log2_min_width = 4'd9;
        13'b????011111111 : log2_min_width = 4'd8;
        13'b?????01111111 : log2_min_width = 4'd7;
        13'b??????0111111 : log2_min_width = 4'd6;
        13'b???????011111 : log2_min_width = 4'd5;
        13'b????????01111 : log2_min_width = 4'd4;
        13'b?????????0111 : log2_min_width = 4'd3;
	//VCS coverage off
        13'b??????????011 : log2_min_width = 4'd2;
        13'b???????????01 : log2_min_width = 4'd1;
        13'b????????????0 : log2_min_width = 4'd0;
	//VCS coverage on
        default           : log2_min_width = 4'bx;
      endcase
   end

   //width padding
   wire [16:0] mip_width_conv_shifted = (mip_width_conv >> log2_min_width) + 1;
   wire [16:0] mip_width_clamped = mip_width_conv_shifted << log2_min_width;
   //wire [15:0] mip_width_clamped_minus1 = mip_width_clamped - 1;


// r11xx: PRT

   //wire [3:0]  new_arraymode = ((level != 4'd0) & tiled_2d & (bump_bank_height | bump_aspect | (mip_width_conv < min_width_tiled_2d) | (mip_height_conv < min_height_tiled_2d))) ? ((tiled_2d_thick | tiled_2d_xthick) ? `ARRAY_1D_TILED_THICK : `ARRAY_1D_TILED_THIN1) : st_arraymode3;

   wire        array_prt_original =   (st_arraymode2 == `ARRAY_PRT_TILED_THIN1)
                                    | (st_arraymode2 == `ARRAY_PRT_2D_TILED_THIN1)
                                    | (st_arraymode2 == `ARRAY_PRT_TILED_THICK)
                                    | (st_arraymode2 == `ARRAY_PRT_2D_TILED_THICK)
                                    | (st_arraymode2 == `ARRAY_PRT_3D_TILED_THIN1)
                                    | (st_arraymode2 == `ARRAY_PRT_3D_TILED_THICK);


   wire        degrade_23d_to_1d = (level != 4'd0) & tiled_2d & (bump_bank_height | bump_aspect | (mip_width_conv < min_width_tiled_2d) | (mip_height_conv < min_height_tiled_2d));
   reg   [3:0] new_arraymode;

   always @ (*)
     begin
       if (degrade_23d_to_1d)
          if (tiled_2d_thick | tiled_2d_xthick)
                new_arraymode = `ARRAY_1D_TILED_THICK;
          else 
                new_arraymode = `ARRAY_1D_TILED_THIN1;
       else // if (!degrade_23d_1d)
          new_arraymode = st_arraymode3;

    end

// r11xx: end


   // height align
   wire [14:0] mip_height_conv_shifted = (mip_height_conv >> log2_min_height) + 1;
   wire [14:0] mip_height_clamped = mip_height_conv_shifted << log2_min_height;

   //kgu: for slice_align_logic
   /*****adjust pitch to meet slice align
   //algrithm
   It could be expressed as:    
        while( ((picth + (x++)*min_width)*height) mod (pipe_interleave_size) != 0 ) // increase x  until adjusted pitch mod pipe_interleave_size is 0
   Here is the RTL implementation:
   1) current_slice_size[8:0] = current_pitch[8:0]*height[8:0]
   2) get continuing ending zeros of current_slice_size[8:0], surppose to be slice_zero_num, 
      for example if currents_slice_size = 8b10101000, then slice_zero_num is 3
   3) get slice align size, surppose to be align_restric_size, in log2, max is 9
   4) if slice_zero_num > align_restric_size, meet slice align
   5) else, suppose delta_zero_num = align_restric_size - slice_zero_num
   6) surppose current_pitch's continuing ending zeros num is y, then pitch_odd = ((current_pitch -1)>>(y+delta_zero_num)) + 1
   7) adjusted new pitch = pitch_odd << (y+delta_zero_num)
   ******/

 
  //current align restriction in elements
   wire        new_thick_1d =   (new_arraymode == `ARRAY_1D_TILED_THICK);   

   wire  [3:0] align_linear_pipe_interleave = pipe_interleave_size[0] + 8 - log2_pixelsize;//in elements
   wire  [3:0] align_linear = (align_linear_pipe_interleave > 4'd6) ? align_linear_pipe_interleave : 4'd6;//max(64, pipe_interleave/element_bytes)    
   wire  [3:0] align_1D     = pipe_interleave_size[0] + 8 - log2_pixelsize - (new_thick_1d ? 2 : 0);
   wire  [3:0] align_restrict = linear ? align_linear : align_1D; 

   wire  [4:0]  num_zeros_of_mip_width_shifted = get_num_zeros_of_mip_width_shifted(mip_width_conv_shifted);

  //new min width
   reg [3:0]   align_restrict_p0;
   reg [3:0]      log2_min_width_p0;
   reg  [4:0]  num_zeros_of_mip_width_shifted_p0;
   reg [15:0]    mip_width_conv_p0;

   reg [13:0]    mip_height_conv_p0;
   reg [3:0]      log2_min_height_p0;
   reg [14:0] mip_height_clamped_p0;
   reg [16:0] mip_width_clamped_p0; 

  always@( posedge sclk) begin
      if(en_stage[0]) begin

      align_restrict_p0   <= align_restrict;
      log2_min_width_p0   <= log2_min_width;
      num_zeros_of_mip_width_shifted_p0<= num_zeros_of_mip_width_shifted;

      mip_width_conv_p0   <= mip_width_conv;

      mip_height_conv_p0 <= mip_height_conv;
      log2_min_height_p0 <= log2_min_height;
      mip_height_clamped_p0 <= mip_height_clamped;
      mip_width_clamped_p0  <= mip_width_clamped;
     end	      
  end

   //wire  [4:0]  num_zeros_of_mip_width_shifted = get_num_zeros_of_mip_width_shifted(mip_width_conv_shifted);
   wire  [8:0]  slice_align_pre_p0 =  mip_width_clamped_p0[8:0] * mip_height_clamped_p0[8:0];//trunc
 
   //count zeros from right to left till meet 1
   wire  [3:0]  num_end_zeros_p0 = get_num_end_zeros(slice_align_pre_p0);
 
  //we adjust width for slice align
  wire  [3:0]  log2_width_delta_p0 = (num_end_zeros_p0 > align_restrict_p0)? 4'b0 : align_restrict_p0 - num_end_zeros_p0;
 

   //width padding
   wire [15:0] mip_width_clamped_minus1 = mip_width_clamped_p0 - 1;

   //wire  [4:0]  num_zeros_of_mip_width_shifted = get_num_zeros_of_mip_width_shifted(mip_width_conv_shifted);

  wire  [4:0]  shifted_size_new = log2_min_width_p0 + log2_width_delta_p0 + num_zeros_of_mip_width_shifted_p0;
  wire  [16:0] mip_width_conv_shifted_new = (mip_width_conv_p0 >> shifted_size_new) + 1;
  wire  [16:0] mip_width_clamped_new = mip_width_conv_shifted_new << shifted_size_new;
  wire  [15:0] mip_width_clamped_minus1_new = mip_width_clamped_new - 1;


  
  wire linear_1d_new =  (new_arraymode == `ARRAY_LINEAR_ALIGNED) || (new_arraymode == `ARRAY_LINEAR_GENERAL ) ||
                        (new_arraymode == `ARRAY_1D_TILED_THIN1) || (new_arraymode == `ARRAY_1D_TILED_THICK);


  reg linear_1d_new_p0;
  always@( posedge sclk) begin
      if(en_stage[0]) begin
      linear_1d_new_p0   <= linear_1d_new;
     end	      
  end

  wire [12:0] pitch_tile_max = linear_1d_new_p0? mip_width_clamped_minus1_new[15:3] : mip_width_clamped_minus1[15:3];

  wire  [14:0]   height_clamped = mip_height_clamped_p0;


   //wire [13:0] width_mult  = (linear ? pitch_tile_max[12:3] : pitch_tile_max) + 1;
   wire [13:0] width_mult  = pitch_tile_max + 1;
   //wire [14:0] height_mult =  linear ? height_clamped : height_clamped[14:3];
   wire [14:0] height_mult = height_clamped;

/*   
   //divide it into small ones
   wire  [6:0]   width_mult_low   = width_mult[6:0];
   wire  [6:0]   width_mult_high  = width_mult[13:7];
   wire  [6:0]   height_mult_low  = height_mult[6:0];
   wire  [7:0]  height_mult_high = height_mult[14:7];

   reg  [6:0]   width_mult_low_p1;
   reg  [6:0]   width_mult_high_p1;
   reg  [6:0]   height_mult_low_p1;
   reg  [7:0]   height_mult_high_p1;

  always@( posedge sclk) begin
      if(stall_n) begin
      width_mult_low_p1   <= width_mult_low;
      width_mult_high_p1  <= width_mult_high;
      height_mult_low_p1  <= height_mult_low;
      height_mult_high_p1 <= height_mult_high;
     end	      
  end



   wire  [13:0]  mult_00_p1 = width_mult_low_p1 * height_mult_low_p1;
   wire  [13:0]  mult_10_p1 = width_mult_high_p1 * height_mult_low_p1;
   wire  [14:0]  mult_01_p1 = width_mult_low_p1 * height_mult_high_p1;
   wire  [14:0]  mult_11_p1 = width_mult_high_p1 * height_mult_high_p1;

   reg [13:0]  mult_00_p2;
   reg [13:0]  mult_10_p2;
   reg [14:0]  mult_01_p2;
   reg [14:0]  mult_11_p2;


  always@( posedge sclk) begin
      if(stall_n) begin
          mult_00_p2 <= mult_00_p1;
          mult_10_p2 <= mult_10_p1;
          mult_01_p2 <= mult_01_p1;
          mult_11_p2 <= mult_11_p1;
     end	      
  end

   wire [28:0]  slice_tile_max_temp = (mult_11_p2 << 14) + (mult_01_p2 << 7) + (mult_10_p2 << 7) + mult_00_p2 - 1;
*/
   wire [15+14-1:0] slice_tile_max_temp = (width_mult * height_mult)-1'b1;
   
   wire [23:0]  slice_tile_max_p0 = slice_tile_max_temp[26:3]; 

  reg [23:0] slice_tile_max_p1, slice_tile_max;
  always@( posedge sclk) begin
      if(en_stage[1]) begin
        slice_tile_max_p1   <= slice_tile_max_p0;
     end	      
  end

  always@( posedge sclk) begin
      if(en_stage[2]) begin
        slice_tile_max      <= slice_tile_max_p1;
     end	      
  end

   ////////////////////////////////////////////////////////////////
   // levelAddr256B
   //wire [4:0]  group_bytes_thick_1d = group_bytes[9:5] >> log2_pixelsize;
   wire [8:0]  min_width_thick_1d = 7;//((group_bytes_thick_1d > 5'd8) ? group_bytes_thick_1d : 5'd8) - 1;
   //wire [6:0]  group_bytes_thin_1d = group_bytes[9:3] >> log2_pixelsize;
   wire [8:0]  min_width_thin_1d  = 7;//((group_bytes_thin_1d > 7'd8) ? group_bytes_thin_1d : 7'd8) - 1;

      reg         texture_array_p0;
      reg [ 3:0]  array_mode_p0;
      reg [13:0]  st_width_p0;
      reg [13:0]  st_height_p0;
      reg [12:0]  st_depth_p0;
      reg [12:0]  depth_base_p0;
      reg [ 3:0]  level_p0;
      reg [ 2:0]  log2_pixelsize_p0;                // 0 to 4
      reg [ 5:0]  min_width_linear_p0;
      reg [ 8:0]  min_width_thick_1d_p0;
      reg [ 8:0]  min_width_thin_1d_p0;

      reg [12:0]  min_width_tiled_2d_p0;
      reg [10:0]  min_height_tiled_2d_p0;
      reg [ 2:0]  log2_group_size_p0;
      reg [ 3:0]  log2_bank_height_align_p0;
      reg [ 3:0]  log2_aspect_align_p0;

      reg [ 3:0]  log2_bank_height_align_xthick2thick_p0;
      reg [ 3:0]  log2_aspect_align_xthick2thick_p0;
      //kgu: update according to spec
      reg           pow2pad_p0;
      //group fmt: width adjust
      reg           fmt_width_div_2_p0 ;
      reg           fmt_width_div_4_p0 ;
      reg           fmt_width_div_8_p0 ;
      reg           fmt_width_mul_3_p0 ;
      reg           fmt_width_mul_4_p0 ;
      //group fmt: height adjust
      reg           fmt_height_div_4_p0 ;
      reg  [0:0]    pipe_interleave_size_p0 ;          

  always@( posedge sclk) begin
      if(en_stage[0]) begin
{texture_array_p0, 
array_mode_p0,
st_width_p0,
st_height_p0,
st_depth_p0,  
depth_base_p0, 
log2_pixelsize_p0, 
min_width_linear_p0, 
min_width_thick_1d_p0, 
min_width_thin_1d_p0, 
min_width_tiled_2d_p0, 
min_height_tiled_2d_p0, 
log2_group_size_p0, 
log2_bank_height_align_p0, 
log2_aspect_align_p0, 
log2_bank_height_align_xthick2thick_p0, 
log2_aspect_align_xthick2thick_p0, 
fmt_width_div_2_p0, 
fmt_width_div_4_p0, 
fmt_width_div_8_p0, 
fmt_width_mul_3_p0, 
fmt_width_mul_4_p0, 
fmt_height_div_4_p0, 
pipe_interleave_size_p0}

               <= 
{texture_array, 
array_mode, 
st_width, 
st_height, 
st_depth,  
depth_base, 
log2_pixelsize, 
min_width_linear, 
min_width_thick_1d, 
min_width_thin_1d, 
min_width_tiled_2d, 
min_height_tiled_2d, 
log2_group_size, 
log2_bank_height_align, 
log2_aspect_align, 
log2_bank_height_align_xthick2thick, 
log2_aspect_align_xthick2thick, 
fmt_width_div_2, 
fmt_width_div_4, 
fmt_width_div_8, 
fmt_width_mul_3, 
fmt_width_mul_4, 
fmt_height_div_4, 
pipe_interleave_size[0]};

     end	      
  end



   // r11xx: update for avoding the swizzle bit in baseaddr to take effect on 1D/Linear mode
   //  function [32:0] get_levelsize;   // r11xx: {mode_1d_or_linear, get_levelsize[31:0]}

   //note: i do not add level != 0 logic in this function as we call it only from 1 to 13, for remind in future projects 
   wire [33-1:0] size1_p0  =  get_levelsize(texture_array_p0, array_mode_p0, st_width_p0, st_height_p0, st_depth_p0,  depth_base_p0,  4'd1, log2_pixelsize_p0, min_width_linear_p0, min_width_thick_1d_p0, min_width_thin_1d_p0, min_width_tiled_2d_p0, min_height_tiled_2d_p0, log2_group_size_p0, log2_bank_height_align_p0, log2_aspect_align_p0, log2_bank_height_align_xthick2thick_p0, log2_aspect_align_xthick2thick_p0, 1'b1, fmt_width_div_2_p0, fmt_width_div_4_p0, fmt_width_div_8_p0, fmt_width_mul_3_p0, fmt_width_mul_4_p0, fmt_height_div_4_p0, pipe_interleave_size_p0);

   wire [33-1:0] size2_p0  =  get_levelsize(texture_array_p0, array_mode_p0, st_width_p0, st_height_p0, st_depth_p0,  depth_base_p0,  4'd2, log2_pixelsize_p0, min_width_linear_p0, min_width_thick_1d_p0, min_width_thin_1d_p0, min_width_tiled_2d_p0, min_height_tiled_2d_p0, log2_group_size_p0, log2_bank_height_align_p0, log2_aspect_align_p0, log2_bank_height_align_xthick2thick_p0, log2_aspect_align_xthick2thick_p0, 1'b1, fmt_width_div_2_p0, fmt_width_div_4_p0, fmt_width_div_8_p0, fmt_width_mul_3_p0, fmt_width_mul_4_p0, fmt_height_div_4_p0, pipe_interleave_size_p0);

   wire [33-1:0] size3_p0  =  get_levelsize(texture_array_p0, array_mode_p0, st_width_p0, st_height_p0, st_depth_p0,  depth_base_p0,  4'd3, log2_pixelsize_p0, min_width_linear_p0, min_width_thick_1d_p0, min_width_thin_1d_p0, min_width_tiled_2d_p0, min_height_tiled_2d_p0, log2_group_size_p0, log2_bank_height_align_p0, log2_aspect_align_p0, log2_bank_height_align_xthick2thick_p0, log2_aspect_align_xthick2thick_p0, 1'b1, fmt_width_div_2_p0, fmt_width_div_4_p0, fmt_width_div_8_p0, fmt_width_mul_3_p0, fmt_width_mul_4_p0, fmt_height_div_4_p0, pipe_interleave_size_p0);

   wire [33-1:0] size4_p0  =  get_levelsize(texture_array_p0, array_mode_p0, st_width_p0, st_height_p0, st_depth_p0,  depth_base_p0,  4'd4, log2_pixelsize_p0, min_width_linear_p0, min_width_thick_1d_p0, min_width_thin_1d_p0, min_width_tiled_2d_p0, min_height_tiled_2d_p0, log2_group_size_p0, log2_bank_height_align_p0, log2_aspect_align_p0, log2_bank_height_align_xthick2thick_p0, log2_aspect_align_xthick2thick_p0, 1'b1, fmt_width_div_2_p0, fmt_width_div_4_p0, fmt_width_div_8_p0, fmt_width_mul_3_p0, fmt_width_mul_4_p0, fmt_height_div_4_p0, pipe_interleave_size_p0);

   wire [33-1:0] size5_p0  =  get_levelsize(texture_array_p0, array_mode_p0, st_width_p0, st_height_p0, st_depth_p0,  depth_base_p0,  4'd5, log2_pixelsize_p0, min_width_linear_p0, min_width_thick_1d_p0, min_width_thin_1d_p0, min_width_tiled_2d_p0, min_height_tiled_2d_p0, log2_group_size_p0, log2_bank_height_align_p0, log2_aspect_align_p0, log2_bank_height_align_xthick2thick_p0, log2_aspect_align_xthick2thick_p0, 1'b1, fmt_width_div_2_p0, fmt_width_div_4_p0, fmt_width_div_8_p0, fmt_width_mul_3_p0, fmt_width_mul_4_p0, fmt_height_div_4_p0, pipe_interleave_size_p0);

   wire [33-1:0] size6_p0  =  get_levelsize(texture_array_p0, array_mode_p0, st_width_p0, st_height_p0, st_depth_p0,  depth_base_p0,  4'd6, log2_pixelsize_p0, min_width_linear_p0, min_width_thick_1d_p0, min_width_thin_1d_p0, min_width_tiled_2d_p0, min_height_tiled_2d_p0, log2_group_size_p0, log2_bank_height_align_p0, log2_aspect_align_p0, log2_bank_height_align_xthick2thick_p0, log2_aspect_align_xthick2thick_p0, 1'b1, fmt_width_div_2_p0, fmt_width_div_4_p0, fmt_width_div_8_p0, fmt_width_mul_3_p0, fmt_width_mul_4_p0, fmt_height_div_4_p0, pipe_interleave_size_p0);

   wire [33-1:0] size7_p0  =  get_levelsize(texture_array_p0, array_mode_p0, st_width_p0, st_height_p0, st_depth_p0,  depth_base_p0,  4'd7, log2_pixelsize_p0, min_width_linear_p0, min_width_thick_1d_p0, min_width_thin_1d_p0, min_width_tiled_2d_p0, min_height_tiled_2d_p0, log2_group_size_p0, log2_bank_height_align_p0, log2_aspect_align_p0, log2_bank_height_align_xthick2thick_p0, log2_aspect_align_xthick2thick_p0, 1'b1, fmt_width_div_2_p0, fmt_width_div_4_p0, fmt_width_div_8_p0, fmt_width_mul_3_p0, fmt_width_mul_4_p0, fmt_height_div_4_p0, pipe_interleave_size_p0);

   wire [33-1:0] size8_p0  =  get_levelsize(texture_array_p0, array_mode_p0, st_width_p0, st_height_p0, st_depth_p0,  depth_base_p0,  4'd8, log2_pixelsize_p0, min_width_linear_p0, min_width_thick_1d_p0, min_width_thin_1d_p0, min_width_tiled_2d_p0, min_height_tiled_2d_p0, log2_group_size_p0, log2_bank_height_align_p0, log2_aspect_align_p0, log2_bank_height_align_xthick2thick_p0, log2_aspect_align_xthick2thick_p0, 1'b1, fmt_width_div_2_p0, fmt_width_div_4_p0, fmt_width_div_8_p0, fmt_width_mul_3_p0, fmt_width_mul_4_p0, fmt_height_div_4_p0, pipe_interleave_size_p0);

   wire [33-1:0] size9_p0  =  get_levelsize(texture_array_p0, array_mode_p0, st_width_p0, st_height_p0, st_depth_p0,  depth_base_p0,  4'd9, log2_pixelsize_p0, min_width_linear_p0, min_width_thick_1d_p0, min_width_thin_1d_p0, min_width_tiled_2d_p0, min_height_tiled_2d_p0, log2_group_size_p0, log2_bank_height_align_p0, log2_aspect_align_p0, log2_bank_height_align_xthick2thick_p0, log2_aspect_align_xthick2thick_p0, 1'b1, fmt_width_div_2_p0, fmt_width_div_4_p0, fmt_width_div_8_p0, fmt_width_mul_3_p0, fmt_width_mul_4_p0, fmt_height_div_4_p0, pipe_interleave_size_p0);

   wire [33-1:0] size10_p0  =  get_levelsize(texture_array_p0, array_mode_p0, st_width_p0, st_height_p0, st_depth_p0,  depth_base_p0,  4'd10, log2_pixelsize_p0, min_width_linear_p0, min_width_thick_1d_p0, min_width_thin_1d_p0, min_width_tiled_2d_p0, min_height_tiled_2d_p0, log2_group_size_p0, log2_bank_height_align_p0, log2_aspect_align_p0, log2_bank_height_align_xthick2thick_p0, log2_aspect_align_xthick2thick_p0, 1'b1, fmt_width_div_2_p0, fmt_width_div_4_p0, fmt_width_div_8_p0, fmt_width_mul_3_p0, fmt_width_mul_4_p0, fmt_height_div_4_p0, pipe_interleave_size_p0);

   wire [33-1:0] size11_p0  =  get_levelsize(texture_array_p0, array_mode_p0, st_width_p0, st_height_p0, st_depth_p0,  depth_base_p0,  4'd11, log2_pixelsize_p0, min_width_linear_p0, min_width_thick_1d_p0, min_width_thin_1d_p0, min_width_tiled_2d_p0, min_height_tiled_2d_p0, log2_group_size_p0, log2_bank_height_align_p0, log2_aspect_align_p0, log2_bank_height_align_xthick2thick_p0, log2_aspect_align_xthick2thick_p0, 1'b1, fmt_width_div_2_p0, fmt_width_div_4_p0, fmt_width_div_8_p0, fmt_width_mul_3_p0, fmt_width_mul_4_p0, fmt_height_div_4_p0, pipe_interleave_size_p0);

   wire [33-1:0] size12_p0  =  get_levelsize(texture_array_p0, array_mode_p0, st_width_p0, st_height_p0, st_depth_p0,  depth_base_p0,  4'd12, log2_pixelsize_p0, min_width_linear_p0, min_width_thick_1d_p0, min_width_thin_1d_p0, min_width_tiled_2d_p0, min_height_tiled_2d_p0, log2_group_size_p0, log2_bank_height_align_p0, log2_aspect_align_p0, log2_bank_height_align_xthick2thick_p0, log2_aspect_align_xthick2thick_p0, 1'b1, fmt_width_div_2_p0, fmt_width_div_4_p0, fmt_width_div_8_p0, fmt_width_mul_3_p0, fmt_width_mul_4_p0, fmt_height_div_4_p0, pipe_interleave_size_p0);

   wire [33-1:0] size13_p0  =  get_levelsize(texture_array_p0, array_mode_p0, st_width_p0, st_height_p0, st_depth_p0,  depth_base_p0,  4'd13, log2_pixelsize_p0, min_width_linear_p0, min_width_thick_1d_p0, min_width_thin_1d_p0, min_width_tiled_2d_p0, min_height_tiled_2d_p0, log2_group_size_p0, log2_bank_height_align_p0, log2_aspect_align_p0, log2_bank_height_align_xthick2thick_p0, log2_aspect_align_xthick2thick_p0, 1'b1, fmt_width_div_2_p0, fmt_width_div_4_p0, fmt_width_div_8_p0, fmt_width_mul_3_p0, fmt_width_mul_4_p0, fmt_height_div_4_p0, pipe_interleave_size_p0);


 wire [13:0] level_mask = ~(14'h3_fff << level);
 wire [14:0] level_mask_1 = {level_mask[13:0], 1'b1};

/*************************************************************************
 wire [32-1:0] level_sum = (size1[31:0]  & {32{(level > 4'd1)}}) +
                           (size2[31:0]  & {32{(level > 4'd2)}}) +
                           (size3[31:0]  & {32{(level > 4'd3)}}) +
                           (size4[31:0]  & {32{(level > 4'd4)}}) +
                           (size5[31:0]  & {32{(level > 4'd5)}}) +
                           (size6[31:0]  & {32{(level > 4'd6)}}) +
                           (size7[31:0]  & {32{(level > 4'd7)}}) +
                           (size8[31:0]  & {32{(level > 4'd8)}}) +
                           (size9[31:0]  & {32{(level > 4'd9)}}) +
                           (size10[31:0] & {32{(level > 4'd10)}})+
                           (size11[31:0] & {32{(level > 4'd11)}})+
                           (size12[31:0] & {32{(level > 4'd12)}})+
                           (size13[31:0] & {32{(level > 4'd13)}});

 wire level_1d_or_linear = (size1[32]  & {1{(level > 4'd1)}}) ||
                           (size2[32]  & {1{(level > 4'd2)}}) ||
                           (size3[32]  & {1{(level > 4'd3)}}) ||
                           (size4[32]  & {1{(level > 4'd4)}}) ||
                           (size5[32]  & {1{(level > 4'd5)}}) ||
                           (size6[32]  & {1{(level > 4'd6)}}) ||
                           (size7[32]  & {1{(level > 4'd7)}}) ||
                           (size8[32]  & {1{(level > 4'd8)}}) ||
                           (size9[32]  & {1{(level > 4'd9)}}) ||
                           (size10[32] & {1{(level > 4'd10)}})||
                           (size11[32] & {1{(level > 4'd11)}})||
                           (size12[32] & {1{(level > 4'd12)}})||
                           (size13[32] & {1{(level > 4'd13)}});

**********************************************************************/
  reg [ 31: 0]    size1_p1;
  reg [ 31: 0]    size2_p1;
  reg [ 31: 0]    size3_p1;
  reg [ 31: 0]    size4_p1;
  reg [ 31: 0]    size5_p1;
  reg [ 31: 0]    size6_p1;
  reg [ 31: 0]    size7_p1;
  reg [ 31: 0]    size8_p1;
  reg [ 31: 0]    size9_p1;
  reg [ 31: 0]    size10_p1;
  reg [ 31: 0]    size11_p1;
  reg [ 31: 0]    size12_p1;
  reg [ 31: 0]    size13_p1;
  reg [ 13: 0]    level_mask_p0;
  reg [ 13: 0]    level_mask_p1;

  
  always@( posedge sclk) begin
  
      if(en_stage[0]) begin
          level_mask_p0 <= level_mask;
     end	      
  
  end

  always@( posedge sclk) begin
      if(en_stage[1]) begin
          size1_p1   <= size1_p0;
          size2_p1   <= size2_p0;
          size3_p1   <= size3_p0;
          size4_p1   <= size4_p0;
          size5_p1   <= size5_p0;
          size6_p1   <= size6_p0;
          size7_p1   <= size7_p0;
          size8_p1   <= size8_p0;
          size9_p1   <= size9_p0;
          size10_p1   <= size10_p0;
          size11_p1   <= size11_p0;
          size12_p1   <= size12_p0;
          size13_p1   <= size13_p0;
          level_mask_p1 <= level_mask_p0;
     end	      
  end


 wire [32-1:0] level_sum_p1 =(size1_p1[31:0]  & {32{level_mask_p1[1] }}) +
                             (size2_p1[31:0]  & {32{level_mask_p1[2] }}) +
                             (size3_p1[31:0]  & {32{level_mask_p1[3] }}) +
                             (size4_p1[31:0]  & {32{level_mask_p1[4] }}) +
                             (size5_p1[31:0]  & {32{level_mask_p1[5] }}) +
                             (size6_p1[31:0]  & {32{level_mask_p1[6] }}) +
                             (size7_p1[31:0]  & {32{level_mask_p1[7] }}) +
                             (size8_p1[31:0]  & {32{level_mask_p1[8] }}) +
                             (size9_p1[31:0]  & {32{level_mask_p1[9] }}) +
                             (size10_p1[31:0] & {32{level_mask_p1[10]}}) +
                             (size11_p1[31:0] & {32{level_mask_p1[11]}}) +
                             (size12_p1[31:0] & {32{level_mask_p1[12]}}) +
                             (size13_p1[31:0] & {32{level_mask_p1[13]}}) ;



 reg  [31:0] level_sum_p2;
  always@( posedge sclk) begin
      if(en_stage[2]) begin
          level_sum_p2 <= level_sum_p1;
     end	      
  end


 reg [14:0] level_mask_1_p0;
  always@( posedge sclk) begin
      if(en_stage[0]) begin
         level_mask_1_p0 <= level_mask_1;
     end	      
  end


wire level_1d_or_linear_p0=(size1_p0[32]  & level_mask_1_p0[1]) ||
                           (size2_p0[32]  & level_mask_1_p0[2]) ||
                           (size3_p0[32]  & level_mask_1_p0[3]) ||
                           (size4_p0[32]  & level_mask_1_p0[4]) ||
                           (size5_p0[32]  & level_mask_1_p0[5]) ||
                           (size6_p0[32]  & level_mask_1_p0[6]) ||
                           (size7_p0[32]  & level_mask_1_p0[7]) ||
                           (size8_p0[32]  & level_mask_1_p0[8]) ||
                           (size9_p0[32]  & level_mask_1_p0[9]) ||
                           (size10_p0[32] & level_mask_1_p0[10])||
                           (size11_p0[32] & level_mask_1_p0[11])||
                           (size12_p0[32] & level_mask_1_p0[12])||
                           (size13_p0[32] & level_mask_1_p0[13])||
                           linear_1d_new_p0;


   wire [33-1:0] size0_p0 =  get_levelsize(texture_array_p0, array_mode_p0, st_width_p0, st_height_p0, st_depth_p0,  depth_base_p0,  4'd0, log2_pixelsize_p0, min_width_linear_p0, min_width_thick_1d_p0, min_width_thin_1d_p0, min_width_tiled_2d_p0, min_height_tiled_2d_p0, log2_group_size_p0, log2_bank_height_align_p0, log2_aspect_align_p0, log2_bank_height_align_xthick2thick_p0, log2_aspect_align_xthick2thick_p0, 1'b1, fmt_width_div_2_p0, fmt_width_div_4_p0, fmt_width_div_8_p0, fmt_width_mul_3_p0, fmt_width_mul_4_p0, fmt_height_div_4_p0, pipe_interleave_size_p0);

   wire level0_1d_or_linear_p0 = size0_p0[32] & level_mask_1_p0[0];
   wire [31:0] level0_size_p0 = size0_p0[31:0] & {32{level_mask_p0[0]}};

   wire [3:0]    st_baseaddress_without_swizzle_mask_shift = log2pipes + log2banks + pipe_interleave_size[0];
   wire [LPARAM_MEM_ADDR_BASE_WIDTH-8-1:0]   st_baseaddress_without_swizzle_mask_a     = ({(LPARAM_MEM_ADDR_BASE_WIDTH-8){1'b1}} << st_baseaddress_without_swizzle_mask_shift);
   wire [LPARAM_MEM_ADDR_BASE_WIDTH-8-1:0]   st_baseaddress_without_swizzle_mask_b     = {{(LPARAM_MEM_ADDR_BASE_WIDTH-8-1){1'b0}}, pipe_interleave_size[0]};
   wire [LPARAM_MEM_ADDR_BASE_WIDTH-8-1:0]   st_baseaddress_without_swizzle_mask = st_baseaddress_without_swizzle_mask_a | st_baseaddress_without_swizzle_mask_b;
   wire [LPARAM_MEM_ADDR_BASE_WIDTH-8-1:0]   st_baseaddress_without_swizzle = st_baseaddress & st_baseaddress_without_swizzle_mask;
   wire [LPARAM_MEM_ADDR_BASE_WIDTH-8-1:0]   st_baseaddress_swizzle_bits    = st_baseaddress & ~st_baseaddress_without_swizzle_mask;

reg        level0_1d_or_linear_reg[2:0];
reg        level_1d_or_linear_reg[2:0];
reg        linear_reg[2:0];
reg        original_1d_reg[2:0];
reg [31:0] level0_size_reg[2:0];
reg [LPARAM_MEM_ADDR_BASE_WIDTH-8-1:0] st_baseaddress_reg[2:0];
reg [LPARAM_MEM_ADDR_BASE_WIDTH-8-1:0] st_baseaddress_without_swizzle_reg[2:0];
reg [LPARAM_MEM_ADDR_BASE_WIDTH-8-1:0] st_baseaddress_swizzle_bits_reg[2:0];
reg [ 3: 0]    new_arraymode_pipe[2:0]; 
reg [12: 0]   pitch_tile_max_pipe[2:0];
reg [LPARAM_MEM_ADDR_BASE_WIDTH-8-1:0]  levelAdr256B_pipe[2:0];
reg [ 2:0] log2_pixelsize_pipe[2:0];
reg  [LPARAM_MEM_ADDR_BASE_WIDTH-8-1:0] levelAdr256B;

  always@( posedge sclk) begin
      if(en_stage[0]) begin
	    linear_reg[0] <= linear;
	    original_1d_reg[0] <= original_1d;
	    st_baseaddress_reg[0] <= st_baseaddress;
	    st_baseaddress_without_swizzle_reg[0] <= st_baseaddress_without_swizzle;
	    st_baseaddress_swizzle_bits_reg[0] <= st_baseaddress_swizzle_bits;
	    new_arraymode_pipe[0] <= new_arraymode;
	    levelAdr256B_pipe[0] <= levelAdr256B;
	    log2_pixelsize_pipe[0] <= log2_pixelsize;
     end	
  end

  always@( posedge sclk) begin
      if(en_stage[1]) begin
        level0_1d_or_linear_reg[1] <= level0_1d_or_linear_p0; 	
        level_1d_or_linear_reg[1] <= level_1d_or_linear_p0; 	
        linear_reg[1] <= linear_reg[0]; 	
        original_1d_reg[1] <= original_1d_reg[0]; 	
        level0_size_reg[1] <= level0_size_p0; 	
        st_baseaddress_reg[1] <= st_baseaddress_reg[0]; 	
        st_baseaddress_without_swizzle_reg[1] <= st_baseaddress_without_swizzle_reg[0]; 	
        st_baseaddress_swizzle_bits_reg[1] <= st_baseaddress_swizzle_bits_reg[0]; 	
        new_arraymode_pipe[1] <= new_arraymode_pipe[0]; 	
        pitch_tile_max_pipe[1] <= pitch_tile_max; 	
        levelAdr256B_pipe[1] <= levelAdr256B_pipe[0]; 	
        log2_pixelsize_pipe[1] <= log2_pixelsize_pipe[0]; 	
     end	
  end

  always@( posedge sclk) begin
      if(en_stage[2]) begin
        level0_1d_or_linear_reg[2] <= level0_1d_or_linear_reg[1];
        level_1d_or_linear_reg[2] <= level_1d_or_linear_reg[1];
        linear_reg[2] <= linear_reg[1];
        original_1d_reg[2] <= original_1d_reg[1];
        level0_size_reg[2] <= level0_size_reg[1];
        st_baseaddress_reg[2] <= st_baseaddress_reg[1];
        st_baseaddress_without_swizzle_reg[2] <= st_baseaddress_without_swizzle_reg[1];
        st_baseaddress_swizzle_bits_reg[2] <= st_baseaddress_swizzle_bits_reg[1];
        new_arraymode_pipe[2] <= new_arraymode_pipe[1];
        pitch_tile_max_pipe[2] <= pitch_tile_max_pipe[1];
        levelAdr256B_pipe[2] <= levelAdr256B_pipe[1];
        log2_pixelsize_pipe[2] <= log2_pixelsize_pipe[1];
     end	
  end



   always @ (*)
     begin
          if (level0_1d_or_linear_reg[2] || level_1d_or_linear_reg[2]) 
              levelAdr256B = ((linear_reg[2] || original_1d_reg[2]) ? st_baseaddress_reg[2] : st_baseaddress_without_swizzle_reg[2]) + level0_size_reg[2] + level_sum_p2;
          else
              levelAdr256B = (st_baseaddress_without_swizzle_reg[2] + level0_size_reg[2] + level_sum_p2) | st_baseaddress_swizzle_bits_reg[2];
     end

// =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
  //output after CALC_STAGES  
wire  [ 3: 0]                             new_arraymode_calc = new_arraymode_pipe[2]; 
wire  [12: 0]                             pitch_tile_max_calc = pitch_tile_max_pipe[2];
wire  [23: 0]                             slice_tile_max_calc = slice_tile_max;
wire [LPARAM_MEM_ADDR_BASE_WIDTH-8-1:0]   levelAdr256B_calc = levelAdr256B; 
wire [ 2:0]                               log2_pixelsize_calc = log2_pixelsize_pipe[2];
// ------------------------------------------------------------------------------------
//output after PAD_STAGES  
logic  [ 3: 0]                             new_arraymode_stages[TOTAL_PAD_STAGES:0]; //to make code easier to write, [0] is not used. synthesis will optimize it anyways
logic  [12: 0]                             pitch_tile_max_stages[TOTAL_PAD_STAGES:0]; 
logic  [23: 0]                             slice_tile_max_stages[TOTAL_PAD_STAGES:0];
logic [LPARAM_MEM_ADDR_BASE_WIDTH-8-1:0]   levelAdr256B_stages[TOTAL_PAD_STAGES:0];
logic [ 2:0]                               log2_pixelsize_stages[TOTAL_PAD_STAGES:0];

int i;
always @(posedge sclk)
begin 
      for(i=0;i<TOTAL_PAD_STAGES;i=i+1) begin
        if(en_stage[RI+CALC_STAGES+i]) 
            if(i==0) begin 
               new_arraymode_stages[i+1]  <= new_arraymode_calc;
               pitch_tile_max_stages[i+1] <= pitch_tile_max_calc;
               slice_tile_max_stages[i+1] <= slice_tile_max_calc;
               levelAdr256B_stages[i+1]   <= levelAdr256B_calc;
               log2_pixelsize_stages[i+1] <= log2_pixelsize_calc;
            end
            else begin
               new_arraymode_stages[i+1]  <= new_arraymode_stages[i]; 
               pitch_tile_max_stages[i+1] <= pitch_tile_max_stages[i];
               slice_tile_max_stages[i+1] <= slice_tile_max_stages[i];
               levelAdr256B_stages[i+1]   <= levelAdr256B_stages[i];  
               log2_pixelsize_stages[i+1] <= log2_pixelsize_stages[i];                
            end
      end
end
localparam INSERT_PAD_STAGES = (TOTAL_PAD_STAGES > 'd0);
  
wire  [ 3: 0]                             new_arraymode_out  = (INSERT_PAD_STAGES)? new_arraymode_stages[TOTAL_PAD_STAGES]  : new_arraymode_calc;
wire  [12: 0]                             pitch_tile_max_out = (INSERT_PAD_STAGES)? pitch_tile_max_stages[TOTAL_PAD_STAGES] : pitch_tile_max_calc;
wire  [23: 0]                             slice_tile_max_out = (INSERT_PAD_STAGES)? slice_tile_max_stages[TOTAL_PAD_STAGES] : slice_tile_max_calc;
wire [LPARAM_MEM_ADDR_BASE_WIDTH-8-1:0]   levelAdr256B_out   = (INSERT_PAD_STAGES)? levelAdr256B_stages[TOTAL_PAD_STAGES]   : levelAdr256B_calc;
wire [ 2:0]                               log2_pixelsize_out = (INSERT_PAD_STAGES)? log2_pixelsize_stages[TOTAL_PAD_STAGES] : log2_pixelsize_calc;

// =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

   function [4:0] get_num_zeros_of_mip_width_shifted;
      input    [16:0]    mip_width_conv_shifted;
      reg      [4:0]     num_zeros_of_mip_width_shifted;
      begin
      casez (mip_width_conv_shifted)
	//VCS coverage off
      17'b00000000000000000: num_zeros_of_mip_width_shifted = 17;
      17'b10000000000000000: num_zeros_of_mip_width_shifted = 16;
      17'b?1000000000000000: num_zeros_of_mip_width_shifted = 15;
      17'b??100000000000000: num_zeros_of_mip_width_shifted = 14;
      17'b???10000000000000: num_zeros_of_mip_width_shifted = 13;
      17'b????1000000000000: num_zeros_of_mip_width_shifted = 12;
	//VCS coverage on
      17'b?????100000000000: num_zeros_of_mip_width_shifted = 11;
      17'b??????10000000000: num_zeros_of_mip_width_shifted = 10;
      17'b???????1000000000: num_zeros_of_mip_width_shifted =  9;
      17'b????????100000000: num_zeros_of_mip_width_shifted =  8;
      17'b?????????10000000: num_zeros_of_mip_width_shifted =  7;
      17'b??????????1000000: num_zeros_of_mip_width_shifted =  6;
      17'b???????????100000: num_zeros_of_mip_width_shifted =  5;
      17'b????????????10000: num_zeros_of_mip_width_shifted =  4;
      17'b?????????????1000: num_zeros_of_mip_width_shifted =  3;
      17'b??????????????100: num_zeros_of_mip_width_shifted =  2;
      17'b???????????????10: num_zeros_of_mip_width_shifted =  1;
      17'b????????????????1: num_zeros_of_mip_width_shifted =  0;
	//VCS coverage off
      default:               num_zeros_of_mip_width_shifted =  0;
	//VCS coverage on
      endcase
      get_num_zeros_of_mip_width_shifted = num_zeros_of_mip_width_shifted;
      end
   endfunction 

   function    [3:0]   get_num_end_zeros;
     input   [9:0]    slice_align_pre;
     reg     [3:0]    num_end_zeros;
     begin
     casez (slice_align_pre)
      9'b000000000: num_end_zeros = 9;
      9'b100000000: num_end_zeros = 8;
      9'b?10000000: num_end_zeros = 7;
      9'b??1000000: num_end_zeros = 6;
      9'b???100000: num_end_zeros = 5;
      9'b????10000: num_end_zeros = 4;
      9'b?????1000: num_end_zeros = 3;
	//VCS coverage off
      9'b??????100: num_end_zeros = 2;
      9'b???????10: num_end_zeros = 1;
      9'b????????1: num_end_zeros = 0;
	//VCS coverage on
      default:      num_end_zeros = 0;
     endcase
      get_num_end_zeros = num_end_zeros;
     end
   endfunction

//kgu: divided into small functions
   function [15:0]  get_level_shifted;
      input [15:0]  st_width;                 // width-1 in units of texels (0 to 24K-1)
      input [3:0]   level;                    // 0 to 13

      reg [16:0]    st_width_p1;
      reg [16:0]    a;
      reg [15:0]    a_m1;
      reg [15:0]    b;

      begin
         // for levels 1 and above use texture width instead of pitch
         // add 1 and right shift by level to compute true width of level
         st_width_p1 = st_width + 1'b1;
         a = st_width_p1 >> level;     // 1 to 24K
         a_m1 = a - 1;

         // subtract 1 from level width
         b = (a == 0) ? 0 : a_m1;         // 0 to 24K-1
         get_level_shifted = b;
      end
    endfunction

   function [15:0] get_pow2_or_not;
       input [15:0]  st_width_shifted;
       input         pow2pad;
       reg [15:0]    b;
       reg [15:0]    c;
       begin
       b = st_width_shifted;
        // round level width up to nearest power of 2. still in texels-1. (0 to 32K-1)
         c        = b[15] ? 16'b1111111111111111 : (
                    b[14] ? 16'b0111111111111111 : (
                    b[13] ? 16'b0011111111111111 : (
                    b[12] ? 16'b0001111111111111 : (
                    b[11] ? 16'b0000111111111111 : (
                    b[10] ? 16'b0000011111111111 : (
                    b[09] ? 16'b0000001111111111 : (
                    b[08] ? 16'b0000000111111111 : (
                    b[07] ? 16'b0000000011111111 : (
                    b[06] ? 16'b0000000001111111 : (
                    b[05] ? 16'b0000000000111111 : (
                    b[04] ? 16'b0000000000011111 : (
                    b[03] ? 16'b0000000000001111 : (
                    b[02] ? 16'b0000000000000111 : (
                    b[01] ? 16'b0000000000000011 : (
                    b[00] ? 16'b0000000000000001 : (
                            16'b0000000000000000))))))))))))))));
        get_pow2_or_not = pow2pad ? c : b;
      end
   endfunction

//iterator_begin

         // r11xx: update for avoding the swizzle bit in baseaddr to take effect on 1D/Linear mode
   function [32:0] get_levelsize;   // r11xx: {mode_1d_or_linear, get_levelsize[31:0]}
         // r11xx: end

      input         texture_array;
      input [ 3:0]  array_mode;
      input [13:0]  st_width;
      input [13:0]  st_height;
      input [12:0]  st_depth;
      input [12:0]  depth_base;
      input [ 3:0]  level;
      input [ 2:0]  log2bytes;                // 0 to 4
      input [ 8:0]  min_width_linear;
      input [ 8:0]  min_width_thick_1d;
      input [ 8:0]  min_width_thin_1d;

      input [12:0]  min_width_tiled_2d;
      input [10:0]  min_height_tiled_2d;
      input [ 3:0]  log2_group_size;
      input [ 3:0]  log2_bank_height_align;
      input [ 3:0]  log2_aspect_align;

      input [ 3:0]  log2_bank_height_align_xthick2thick;
      input [ 3:0]  log2_aspect_align_xthick2thick;
      //kgu: update according to spec
      input           pow2pad;
      //group fmt: width adjust
      input           fmt_width_div_2 ;
      input           fmt_width_div_4 ;
      input           fmt_width_div_8 ;
      input           fmt_width_mul_3 ;
      input           fmt_width_mul_4 ;
      //group fmt: height adjust
      input           fmt_height_div_4 ;
      input  [0:0]    pipe_interleave_size ;          
 
      reg [13:0]    width_shifted;
      reg [14:0]    width_shifted_p1;
      reg [13:0]    height_shifted;
      reg [12:0]    depth_shifted;
      reg [12:0]    depth_pow2;
      reg [12:0]    depth_base_pow2;
      reg [15:0]    packet_width;
      reg [13:0]    packet_height;     
      reg [15:0]    width_conv;
      reg [13:0]    height_conv;
      reg [12:0]    depth_conv;
      reg [13:0]    depth_conv_shifted;
      reg [15:0]    width_clamped;
      reg [13:0]    height_clamped;
      reg [13:0]    depth_clamped;
      reg [4:0]     width_clamped_ones;
      reg [3:0]     height_clamped_ones;
      reg [3:0]     depth_clamped_ones;
      reg [6:0]     log2size;
      reg [12:0]    min_width;
      reg [10:0]    min_height;
     
      reg [3:0]     thin_arraymode;
      reg           thick;
      reg [3:0]     st_arraymode3;
      reg           linear;
      reg           tiled_1d;
      reg           tiled_2d_thick;
      reg           tiled_2d_thin1;
      reg           tiled_2d;
      reg           tiled_thick;
      reg [8:0]     min_width_tiled_1d;
      reg [10:0]    min_height_tiled_2d;
      reg           original_2D_thick;
      reg           now_2D_thin;
      reg           bump_bank_height;
      reg           bump_aspect;
      reg           xthick;
      reg           tiled_2d_xthick;
      reg           tiled_xthick;
      reg [3:0]     st_arraymode3_t;
      reg           original_xthick;
      reg           now_thick;

      reg           bump_bank_height_xthick2thick;
      reg           bump_aspect_xthick2thick;

      reg [5:0]     slice_bytes;
      reg           meet_padding;
      reg [3:0]     slice_align_restric; 
      reg [5:0]     slice_bytes_aligned;
      reg [3:0]     new_arraymode;
      reg           mode_1d_linear;
      reg           mode_1d_thick;
      reg           mode_2d_thick;
      reg           mode_2d_xthick;
      reg [2:0]     min_depth;
      reg [3:0]     slice_align_linear_pipe_interleave;
      reg [3:0]     slice_align_linear_min;
      reg [3:0]     slice_align_linear;
      reg [3:0]     slice_align_1D;

      reg 	    array_prt_original;  // r11xx
      reg           mode_1d_or_linear;   // r11xx


        begin
          width_shifted  = get_level_shifted(st_width,  level);    
          height_shifted = get_level_shifted({2'b0,st_height}, level);
          depth_shifted  = get_level_shifted({3'b0,st_depth }, level);

          width_shifted_p1 = width_shifted + 1;

         //kgu: packet format:
                 packet_width = fmt_width_div_8   ?      width_shifted[13:3]:   //ceil(/8)-1
                                fmt_width_div_4   ?      width_shifted[13:2]:   //ceil(/4)-1
                                fmt_width_div_2   ?      width_shifted[13:1]:   //ceil(/2)-1
                                fmt_width_mul_3   ?    ({width_shifted_p1,1'b0} + width_shifted)://*3 -1
                                fmt_width_mul_4   ?     {width_shifted,2'b11}: //*4-1
                                                         width_shifted; //not changed
           
         width_conv = get_pow2_or_not(packet_width, pow2pad); 

         //kgu: packet format
         packet_height = fmt_height_div_4  ?   height_shifted[13:2]:   //ceil(/4)-1
                                               height_shifted;
         height_conv = get_pow2_or_not(packet_height, pow2pad);

         depth_pow2  = get_pow2_or_not(depth_shifted, pow2pad); 
         depth_base_pow2 = get_pow2_or_not(depth_base, pow2pad);//kgu: if mipmaps, pow2pad always be 1
        
         depth_conv = (texture_array == 1'b1) ? depth_base_pow2 : depth_pow2;

         thick =   (array_mode == `ARRAY_1D_TILED_THICK) 
                 | (array_mode == `ARRAY_2D_TILED_THICK)
                 | (array_mode == `ARRAY_3D_TILED_THICK)
                 | (array_mode == `ARRAY_PRT_TILED_THICK)           // r11xx: PRT mode
                 | (array_mode == `ARRAY_PRT_2D_TILED_THICK)        // r11xx: PRT mode
                 | (array_mode == `ARRAY_PRT_3D_TILED_THICK);       // r11xx: PRT mode

         xthick =   (array_mode == `ARRAY_2D_TILED_XTHICK) 
                  | (array_mode == `ARRAY_3D_TILED_XTHICK);


// r11xx: Change for CI/KV/TH,  for thick tiling should transition to 1D_Thick.
//        such that the micro-tiling is the same at all mip levels.
// 
// -	2D/3D_Thick    ->   1D_Thick
// -	2D/3D_XThick    ->  1D_Thick
// 
// Instead of 
// 
// -	2D/3D_Thick -> 2D/3D_Thin -> 1D_Thin
// 


        //kgu: incase there is 4,5,6 for depth conv, however it should not happen
        //st_arraymode3 = ((level != 4'd0) && (array_mode == `ARRAY_2D_TILED_XTHICK) && (depth_conv < 7))? `ARRAY_2D_TILED_THICK:    // r11xx
        //                ((level != 4'd0) && (array_mode == `ARRAY_3D_TILED_XTHICK) && (depth_conv < 7))? `ARRAY_3D_TILED_THICK:    // r11xx
        //                                                                                                  array_mode;              // r11xx

       // update for degration: for driver can't identify TC degration, so 2D/3DXthick -> 1DThick.
         st_arraymode3 = array_mode;

// r11xx end

         linear = (array_mode == `ARRAY_LINEAR_ALIGNED) | (array_mode == `ARRAY_LINEAR_GENERAL);

         tiled_1d       =   (st_arraymode3 == `ARRAY_1D_TILED_THIN1)
                          | (st_arraymode3 == `ARRAY_1D_TILED_THICK);

         tiled_2d_thick =            (st_arraymode3 == `ARRAY_2D_TILED_THICK)
                                   | (st_arraymode3 == `ARRAY_3D_TILED_THICK)
                                   | (st_arraymode3 == `ARRAY_PRT_TILED_THICK)       // r11xx
                                   | (st_arraymode3 == `ARRAY_PRT_2D_TILED_THICK)    // r11xx
                                   | (st_arraymode3 == `ARRAY_PRT_3D_TILED_THICK) ;  // r11xx

         tiled_2d_thin1 =            (st_arraymode3 == `ARRAY_2D_TILED_THIN1)
                                   | (st_arraymode3 == `ARRAY_3D_TILED_THIN1)
                                   | (st_arraymode3 == `ARRAY_PRT_TILED_THIN1)       // r11xx
                                   | (st_arraymode3 == `ARRAY_PRT_2D_TILED_THIN1)    // r11xx
                                   | (st_arraymode3 == `ARRAY_PRT_3D_TILED_THIN1) ;  // r11xx

         tiled_2d_xthick=            (st_arraymode3 == `ARRAY_2D_TILED_XTHICK)
                                   | (st_arraymode3 == `ARRAY_3D_TILED_XTHICK);

         tiled_2d       = tiled_2d_thick | tiled_2d_thin1 | tiled_2d_xthick;

         tiled_thick    =            (st_arraymode3 == `ARRAY_1D_TILED_THICK) |  tiled_2d_thick;

         tiled_xthick   = tiled_2d_xthick;

         min_width_tiled_1d =  (st_arraymode3 == `ARRAY_1D_TILED_THICK) ? min_width_thick_1d : min_width_thin_1d; // r11xx
         original_2D_thick =            (array_mode == `ARRAY_2D_TILED_THICK)
                                      | (array_mode == `ARRAY_3D_TILED_THICK)
                                      | (array_mode == `ARRAY_PRT_TILED_THICK)     // r11xx
                                      | (array_mode == `ARRAY_PRT_2D_TILED_THICK)  // r11xx
                                      | (array_mode == `ARRAY_PRT_3D_TILED_THICK)  // r11xx
                                      |  xthick;

	 now_2D_thin       = tiled_2d_thin1;

         original_xthick = xthick;
         now_thick = tiled_2d_thick;

         bump_bank_height_xthick2thick = (log2_group_size > log2_bank_height_align_xthick2thick) & (original_xthick&now_thick);
         bump_aspect_xthick2thick = (log2_group_size > log2_aspect_align_xthick2thick) & (original_xthick&now_thick);

         bump_bank_height = ((log2_group_size > log2_bank_height_align) & (original_2D_thick & now_2D_thin)) | bump_bank_height_xthick2thick;
         bump_aspect = ((log2_group_size > log2_aspect_align) & (original_2D_thick & now_2D_thin)) | bump_aspect_xthick2thick ;


         min_width = linear   ? min_width_linear : (                                                 // linear
                     tiled_1d ? min_width_tiled_1d : (                                               // 1D tiled
                     ((level != 4'd0) & (bump_bank_height | bump_aspect | (width_conv < min_width_tiled_2d) | (height_conv < min_height_tiled_2d))) ? ((tiled_2d_thick | tiled_2d_xthick)? min_width_thick_1d: min_width_thin_1d): min_width_tiled_2d)); // 2D tiled
         min_height = linear   ? 11'd0 : (                                               // linear
                      tiled_1d ? 11'd7 : (                                             // 1D tiled
                      ((level != 4'd0) & (bump_bank_height | bump_aspect | (width_conv < min_width_tiled_2d) | (height_conv < min_height_tiled_2d))) ? 11'd7 : min_height_tiled_2d));
         
         // clamp against min multiples
         //level>0, pow2 valid, alignment could be done by comparation
         width_clamped  = (width_conv > min_width) ? width_conv : min_width;
         height_clamped = (height_conv > min_height) ? height_conv : min_height;
         //depth_clamped  = depth_conv;
        
        //slice align

// r11xx: PRT

       array_prt_original =           (array_mode == `ARRAY_PRT_TILED_THIN1)
                                    | (array_mode == `ARRAY_PRT_2D_TILED_THIN1)
                                    | (array_mode == `ARRAY_PRT_TILED_THICK)
                                    | (array_mode == `ARRAY_PRT_2D_TILED_THICK)
                                    | (array_mode == `ARRAY_PRT_3D_TILED_THIN1)
                                    | (array_mode == `ARRAY_PRT_3D_TILED_THICK);



        new_arraymode = ((level != 4'd0) & tiled_2d & (bump_bank_height | bump_aspect | (width_conv < min_width_tiled_2d) | (height_conv < min_height_tiled_2d))) ? ((tiled_2d_thick | tiled_2d_xthick) ? (`ARRAY_1D_TILED_THICK) : (`ARRAY_1D_TILED_THIN1)) : st_arraymode3;


// r11xx: end



        mode_1d_linear = (new_arraymode == `ARRAY_LINEAR_ALIGNED) || (new_arraymode == `ARRAY_LINEAR_GENERAL ) ||
                         (new_arraymode == `ARRAY_1D_TILED_THIN1) || (new_arraymode == `ARRAY_1D_TILED_THICK);

        mode_1d_thick =  (new_arraymode == `ARRAY_1D_TILED_THICK);
        
        mode_2d_thick =   (new_arraymode == `ARRAY_2D_TILED_THICK) 
                        | (new_arraymode == `ARRAY_3D_TILED_THICK) 
                        | (new_arraymode == `ARRAY_PRT_TILED_THICK)      // r11xx
                        | (new_arraymode == `ARRAY_PRT_2D_TILED_THICK)   // r11xx
                        | (new_arraymode == `ARRAY_PRT_3D_TILED_THICK);  // r11xx

        mode_2d_xthick = (new_arraymode == `ARRAY_2D_TILED_XTHICK) | (new_arraymode == `ARRAY_3D_TILED_XTHICK); 


        min_depth = mode_2d_xthick ? 3'd7: (mode_1d_thick | mode_2d_thick)? 3'd3: 3'd0;
        depth_clamped  = (depth_conv > min_depth) ? depth_conv : min_depth;
 
         casez (width_clamped)
	   //VCS coverage off	 
           16'b1111111111111111 : width_clamped_ones = 5'd16;
           16'b0111111111111111 : width_clamped_ones = 5'd15;
	   //VCS coverage on
           16'b?011111111111111 : width_clamped_ones = 5'd14;
           16'b??01111111111111 : width_clamped_ones = 5'd13;
           16'b???0111111111111 : width_clamped_ones = 5'd12;
           16'b????011111111111 : width_clamped_ones = 5'd11;
           16'b?????01111111111 : width_clamped_ones = 5'd10;
           16'b??????0111111111 : width_clamped_ones = 5'd9;
           16'b???????011111111 : width_clamped_ones = 5'd8;
           16'b????????01111111 : width_clamped_ones = 5'd7;
           16'b?????????0111111 : width_clamped_ones = 5'd6;
           16'b??????????011111 : width_clamped_ones = 5'd5;
           16'b???????????01111 : width_clamped_ones = 5'd4;
           16'b????????????0111 : width_clamped_ones = 5'd3;
	   //VCS coverage off
           16'b?????????????011 : width_clamped_ones = 5'd2;
           16'b??????????????01 : width_clamped_ones = 5'd1;
           16'b???????????????0 : width_clamped_ones = 5'd0;
           default              : width_clamped_ones = 5'bx;
	   //VCS coverage on
         endcase // case(width_clamped)

         casez (height_clamped)
	   //VCS coverage off	 
           14'b11111111111111 : height_clamped_ones = 4'd14;
	   //VCS coverage on
           14'b01111111111111 : height_clamped_ones = 4'd13;
           14'b?0111111111111 : height_clamped_ones = 4'd12;
           14'b??011111111111 : height_clamped_ones = 4'd11;
           14'b???01111111111 : height_clamped_ones = 4'd10;
           14'b????0111111111 : height_clamped_ones = 4'd9;
           14'b?????011111111 : height_clamped_ones = 4'd8;
           14'b??????01111111 : height_clamped_ones = 4'd7;
           14'b???????0111111 : height_clamped_ones = 4'd6;
           14'b????????011111 : height_clamped_ones = 4'd5;
           14'b?????????01111 : height_clamped_ones = 4'd4;
           14'b??????????0111 : height_clamped_ones = 4'd3;
           14'b???????????011 : height_clamped_ones = 4'd2;
           14'b????????????01 : height_clamped_ones = 4'd1;
           14'b?????????????0 : height_clamped_ones = 4'd0;
	   //VCS coverage off
           default            : height_clamped_ones = 4'bx;
	   //VCS coverage on
         endcase // case(height_clamped)

         casez (depth_clamped)
           13'b1111111111111 : depth_clamped_ones = 4'd13;
           13'b0111111111111 : depth_clamped_ones = 4'd12;
           13'b?011111111111 : depth_clamped_ones = 4'd11;
           13'b??01111111111 : depth_clamped_ones = 4'd10;
           13'b???0111111111 : depth_clamped_ones = 4'd9;
           13'b????011111111 : depth_clamped_ones = 4'd8;
           13'b?????01111111 : depth_clamped_ones = 4'd7;
           13'b??????0111111 : depth_clamped_ones = 4'd6;
           13'b???????011111 : depth_clamped_ones = 4'd5;
           13'b????????01111 : depth_clamped_ones = 4'd4;
           13'b?????????0111 : depth_clamped_ones = 4'd3;
           13'b??????????011 : depth_clamped_ones = 4'd2;
           13'b???????????01 : depth_clamped_ones = 4'd1;
           13'b????????????0 : depth_clamped_ones = 4'd0;
	   //VCS coverage off
           default           : depth_clamped_ones = 4'bx;
	   //VCS coverage on
         endcase // case(width_clamped)

//kgu: add slice align logic:
         slice_bytes  = width_clamped_ones + height_clamped_ones + log2bytes;
         slice_align_linear_pipe_interleave = pipe_interleave_size[0] + 8;
         slice_align_linear_min = 4'd6 + log2bytes;
         slice_align_linear = (slice_align_linear_pipe_interleave > slice_align_linear_min) ? slice_align_linear_pipe_interleave : slice_align_linear_min;
         slice_align_1D = pipe_interleave_size[0] + 8 - (mode_1d_thick ? 2: 0);
         slice_align_restric = linear ? slice_align_linear : slice_align_1D;          

         meet_padding = (slice_bytes > slice_align_restric);
         
         slice_bytes_aligned = (!meet_padding && mode_1d_linear) ? slice_align_restric : slice_bytes;
        
         log2size = slice_bytes_aligned + depth_clamped_ones - 8;


         // r11xx: update for avoding the swizzle bit in baseaddr to take effect on 1D/Linear mode

         mode_1d_or_linear = mode_1d_linear || mode_1d_thick;
         // compute power of 2 level size in units of 256 bytes
         get_levelsize = {mode_1d_or_linear, 32'b1 << log2size};


         // r11xx: end


      end
   endfunction // get_levelsize
//iterator_end

`include "mipmap_calc_fcov_gc.svh"


endmodule


