// ==============================================================================================
// PLEASE DONOT CHANGES THIS FILE
// THIS FILE IS AUTO_GENERATED
// Source: import/address/src/rtl/gen_one/mipmap_calc.v
// ===============================================================================================
// Filename              : mipmap_calc.v
// Perforce changelist   : $Change$
//
// Copyright             : Trade secret of AMD, Inc.
//                         Copyright 2008, AMD, Inc., (unpublished)
//                         All rights reserved.  This notice is intended as a precaution against
//                         inadvertent publication and does not imply publication or any waiver
//                         of confidentiality.  The year included in the foregoing notice is the
//                         year of creation of the work.
//
// RTL author: kevin.gu
//
// Description: mipmap calculator for tc

`include  "gc__tc_reg.v"
//!!!!kgu: temp use IMG_DATA_FORMAT, remember to update if TC FORMAT is ready 
`include    "gc__gb_reg.v"  // r11xx

`include "gpu_features.vh"
`include "addrlib_defines_gc.vh"

module    mipmap_calc_gc(
                     //output
                      new_arraymode_out,                    //mipmap array_mode
                      pitch_tile_max_out,                   //mipmap pitch-1 in units of 8 texels
                      slice_tile_max_out,                   //mipmap slice size w*h/64-1
                      levelAdr256B_out,                     //mipmap address(256B aligned)
                      log2_pixelsize_out,

                      //input
                      st_width,                             //width-1(0 to 48K-1)
                      st_height,                            //height-1(0 to 16K-1)
                      st_depth,                             //depth-1(0 to 8K-1)
                      st_baseaddress,                       //base map address(256B aligned)
                      texture_array,                        //0: single texture, 1: texture array
                      array_mode,                           //as defines above
                      pipe_interleave_size,                 //0: 256B, 1:512B, only pipe_interleave_size[0] used
                      num_banks,                            //0: 2banks,1:4banks, 2:8banks, 3:16banks
		              pipe_config,                          //10xx new added to inplace of numofpipes and pipe mapping
                      bank_width,                           //0: 1tile, 1: 2tiles, 2: 4tiles, 3: 8tiles
                      bank_height,                          //0: 1tile, 1: 2tiles, 2: 4tiles, 3: 8tiles
                      macro_tile_aspect,                    //0: 1tile, 1: 2tiles, 2: 4tiles, 3: 8tiles
		              level,                                //mipmap level(0 to 14)
		              data_format,                          //10xx added
		              pow2pad,                              //10xx added, true if map is padded to power of 2 dimensions, 
                                                            //else it is padded to tiling requirements, must be true if levels > 1
                      sclk,                                 //clock
                      srst,

                      iRTS,
                      oRTR,
                      oRTS,
                      iRTR,
                      
                      pass_thru_data_in,
                      pass_thru_data_out,
                      
                     
                      input_en,
                      output_en,
                      busy,                   		                                   
                      
                      TEST_CLK_EN
         	      );

`ifdef GPU__GC__MEM_ADDR_BITS_ATC__48
localparam LPARAM_MEM_ADDR_WIDTH 	=  48,
           LPARAM_MEM_ADDR_BASE_WIDTH   =  48,
           LPARAM_MEM_ADDR_OFFSET_WIDTH	=  41;

`else
localparam LPARAM_MEM_ADDR_WIDTH 	=  40,
           LPARAM_MEM_ADDR_BASE_WIDTH   =  40,
           LPARAM_MEM_ADDR_OFFSET_WIDTH	=  40;

`endif

// =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
localparam  RI = 0;                         //clients doesnot have access to this
localparam  RO = 0;                         //clients doesnot have access to this
localparam CALC_STAGES = `BC_MIPMAP_STAGES; //number of "core" stages to calculate "outputs"
parameter  PASSTHRU_WIDTH 		= 1;	    // Bus Width of the pass through data
parameter  COLLAPSABLE_PIPE_STAGE = 0;      // COLLAPSABLE/NONCOLLAPSABLE, 1/0
parameter  PAD_STAGES = 1;                  // CLIENTS DONOT CHANGE THIS!!!!!!!! [TBD] make it a 'localparam'
                                            // NBC mipmap is set to RI(1)+3 = 4 stages, to make minimal changes to the BC,                                             
// =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

input                                          sclk;                    
input                                          srst;                    

input                                          iRTS;                    
output                                         oRTR;                    
input   [PASSTHRU_WIDTH-1:0]                   pass_thru_data_in;       //pass through data bus, pipelined PIPE_STAGES and enabled by (<pipe_stage_enable> & ~stall)

output                                         oRTS;                    
input                                          iRTR;                    
output  [PASSTHRU_WIDTH-1:0]                   pass_thru_data_out;      

    //outputs
input                                          input_en;
output                                         output_en;
output                                         busy;



input                                          TEST_CLK_EN;

localparam TOTAL_PAD_STAGES = RO+PAD_STAGES; //[TBD] bring the "TOTAL_PAD_STAGES" out of "retime" logic to flop the outputs.
localparam PIPE_STAGES = RI + CALC_STAGES + TOTAL_PAD_STAGES;

logic [PIPE_STAGES-1:0]             en_stage;

addrlib_px_stage_gc #(.COLLAPSIBLE(COLLAPSABLE_PIPE_STAGE), .WIDTH(PASSTHRU_WIDTH), .DEPTH(PIPE_STAGES))
    px_stage(
			  // Outputs
			  .oRTR			(oRTR),
			  .oRTS			(oRTS),
			  .oDATA		(pass_thru_data_out[PASSTHRU_WIDTH-1:0]),
			  .pipe_stage_en (en_stage[PIPE_STAGES-1:0]),
			  .busy 		(busy),
			  // Inputs
			  .iCLK			(sclk),
			  .iRESET		(srst),
			  .iRTS			(iRTS),
			  .iDATA		(pass_thru_data_in[PASSTHRU_WIDTH-1:0]),
			  .iRTR			(iRTR)
             ,.i_en         (input_en)
             ,.o_en         (output_en)
        );


//surface descriptors
input     [13:0]       st_width;
input     [13:0]       st_height;
input     [12:0]       st_depth;
input     [LPARAM_MEM_ADDR_BASE_WIDTH-8-1:0]       st_baseaddress;
input     [ 0:0]       texture_array;

//tiling attributes
input     [ 3:0]       array_mode;
input     [ 2:0]       pipe_interleave_size;
input     [ 1:0]       num_banks;
input     [ 1:0]       bank_width;
input     [ 1:0]       bank_height;
input     [ 1:0]       macro_tile_aspect;
input     [ 4:0]       pipe_config;
input     [ 5:0]       data_format;
input     [ 0:0]       pow2pad;           

//mipmap level to compute address for
input     [ 3:0]       level;


//outputs
output    [ 3:0]       new_arraymode_out;
output    [12:0]       pitch_tile_max_out;
output    [23:0]       slice_tile_max_out;
output    [LPARAM_MEM_ADDR_BASE_WIDTH-8-1:0]       levelAdr256B_out;
output    [ 2:0]       log2_pixelsize_out;

mipmap_calc_bc_retimed_gc mipmap_calc_bc_retimed(.*);

`ifdef ADDRESS__ADDRLIB_REPLAY_DEBUG__1
    mipmap_calc_replay_bc_gc replay(.*, .log2_pixelsize(mipmap_calc_bc_retimed.log2_pixelsize));
`endif

`ifdef ADDRESS__ADDRLIB_REPLAY_DEBUG__1
    mipmap_calc_replay_bc_gc replay(.*,
                                    .log2_pixelsize(mipmap_calc_bc_retimed.log2_pixelsize));
`endif

endmodule


