//                              -*- Mode: Verilog -*-

////////////////////////////////////////////////////////////////////////////
/*
 *
 * $Id: //sysip/dfx/dfx-4/4.1/branches/dfxip4_gfxip_gfx10/srf/src/rtl/prpg_128bit.v.dpl#2 $
 * $Revision: #2 $
 * $DateTime: 2017/06/27 21:37:00 $
 * $Author: couyang $
 *
 * Copyright (c) 2015 by Advanced Micro Devices, Inc.
 *
 * This file is protected by Federal Copyright Law, with all rights
 * reserved. No part of this file may be reproduced, stored in a
 * retrieval system, translated, transcribed, or transmitted, in any
 * form, or by any means manual, electric, electronic, mechanical,
 * electro-magnetic, chemical, optical, or otherwise, without prior
 * explicit written permission from Advanced Micro Devices, Inc.
 *
 */
////////////////////////////////////////////////////////////////////////////
//
// Description : 128bits PRPG
//
////////////////////////////////////////////////////////////////////////////

module prpg_128bit_gc10 (
        clock,
        reset,
        prpg_data);

// Clock port
input clock;            // PRPG clock

input reset;           //Initizlize PRPG in lbist mode 

output  [127:0]  prpg_data; //edt channel input to tile

reg [127:0] prpg_data;


//=================================================================================================
//
// PRPG for LBIST mode
//
//=================================================================================================

//PRPG function
always @(negedge reset or posedge clock)
   begin
       if (!reset) 
      	  begin
	     prpg_data[127:0] <= 128'hffffffffffffffffffffffffffffffff;	// initial seed value
	  end
       else
      	  begin
	     prpg_data[127:1] <= prpg_data[126:0];
	     prpg_data[0] <= prpg_data[127] ^ prpg_data[125] ^ prpg_data[100] ^ prpg_data[98];   //taps 127, 125, 100, 98
	  end
end

endmodule

