
//----------------------------------------------------------------------------
//
// Author :		 Nehal Patel, N1-504 (Sunnyvale - Yan Dong), 44290 

//
// Notes  :		 DO NOT HAND EDIT THIS FILE!!!!!!
//	   		 This file was automatically derived from /local_vol1_nobackup/user/nepatel/dfxip4_0/dftmisc/src/meta/tools/scripts/odt2tdr_rtl.pl
//----------------------------------------------------------------------------
	  


module pulse_cnt_tdr_gc10 
# (
   parameter DFT_CLK_CNTL_PULSE_CNT = 5
)

( 


//Broadcast to All TDRs
input Tdr_Tck,
input Tdr_Trstb,
input Tdr_Tdi,
input Tdr_Shift,
input Tdr_Capture,
input Tdr_Update



//TDR --> PULSE_CNT
 ,output wire [DFT_CLK_CNTL_PULSE_CNT-1:0] pulse_cnt
 ,input Tdr_pulse_cnt_En
 ,output Tdr_pulse_cnt_Tdo
); // End of Port Declaration

///// START TDR_INST - PULSE_CNT /////

   localparam PULSE_CNT__WIDTH = DFT_CLK_CNTL_PULSE_CNT;
   wire [PULSE_CNT__WIDTH-1:0]	PULSE_CNT;
   wire [PULSE_CNT__WIDTH-1:0]	PULSE_CNT__DEFAULT;  

	//PULSE_CNT - 4:0

   localparam  PULSE_CNT_PULSE_CNT__WIDTH  = DFT_CLK_CNTL_PULSE_CNT;
   localparam [PULSE_CNT_PULSE_CNT__WIDTH-1:0] PULSE_CNT_PULSE_CNT__DEFAULT  = {(DFT_CLK_CNTL_PULSE_CNT){1'h0}};
   

   localparam  PULSE_CNT_PULSE_CNT__MSB  = DFT_CLK_CNTL_PULSE_CNT-1;
   localparam  PULSE_CNT_PULSE_CNT__LSB  = 0;
   

   assign PULSE_CNT__DEFAULT
                 [PULSE_CNT_PULSE_CNT__MSB : 
                  PULSE_CNT_PULSE_CNT__LSB] =  
		  PULSE_CNT_PULSE_CNT__DEFAULT;
   

  ati_buffer1 mrk_pulse_cnt_pulse_cnt[PULSE_CNT_PULSE_CNT__WIDTH-1:0] 
  (
    .A(PULSE_CNT
      [PULSE_CNT_PULSE_CNT__MSB :
       PULSE_CNT_PULSE_CNT__LSB
      ]),    
    .Y(pulse_cnt[PULSE_CNT_PULSE_CNT__WIDTH-1:0])
  );





   test_reg_async_rst_gc10
     #(PULSE_CNT__WIDTH)
   reg_PULSE_CNT (
                           .clk(Tdr_Tck),
                           .rstb(Tdr_Trstb),
                           .en(Tdr_pulse_cnt_En),
                           .shift(Tdr_Shift & Tdr_pulse_cnt_En),
                           .capture(Tdr_Capture & Tdr_pulse_cnt_En),
                           .update(Tdr_Update & Tdr_pulse_cnt_En),
                           .d_rst(PULSE_CNT__DEFAULT),
                           .q(PULSE_CNT),
                           .d(PULSE_CNT),
                           .si(Tdr_Tdi),
                           .so(Tdr_pulse_cnt_Tdo),
                           .q_sr(),
                           .q_sr_posedge()
                           );









///// END TDR_INST - PULSE_CNT /////
endmodule
