
//================================================================================================================================
//
// Copyright (c) 2002 by Advanced Micro Devices, Inc.
//
// This file is protected by Federal Copyright Law, with all rights reserved. No part of this file may be reproduced, stored in a
// retrieval system, translated, transcribed, or transmitted, in any form, or by any means manual, electric, electronic,
// mechanical, electro-magnetic, chemical, optical, or otherwise, without prior explicit written permission from Advanced Micro
// Devices, Inc.
//
//================================================================================================================================

//================================================================================================================================
//
// <PERLOG>
//
//  This file was generated using perlog.
//
//  Run directory:
//    /proj/gfxip_gcregr_1/user/orlvalid/gfx10.1_navi10_rtl_freeze_atl/import/dfx/stac/src/rtl
//
//  Commandline:
//    /proj/verif_release_ro/perlog/40/perlog.pl -C /proj/gfxip_gcregr_1/user/orlvalid/gfx10.1_navi10_rtl_freeze_atl/out/linux_2.6.32_64.VCS/navi10/library/stac-gc3-dfxip4-gc10/pub/src/meta/tools/staccfg/default_dfx_stac.plcfg -C /proj/gfxip_gcregr_1/user/orlvalid/gfx10.1_navi10_rtl_freeze_atl/out/linux_2.6.32_64.VCS/navi10/common/pub/src/meta/tools/staccfg/rtl_dfx_stac_gc3.plcfg -D LIB_PRFX=DFXIP4_GC10
//
//  Config variables:
//    IP_NAME         : gc3
//    LIB_PRFX        : DFXIP4_GC10
//    AEB             : 1
//    NUM_1500        : 1
//    NUM_ALTTAP      : 2
//    NUM_SLAVETAP    : 0
//    NUM_STAC        : 0
//    PIPELINE        : 1
//    RESYNC_STAC     : ()
//    ROUTER          : 0
//    SINGLECHAIN     : 1
//    RESET_BC1500    : ()
//    NUM_TDR_RESETS  : 0
//    EARLY_1500      : (0)
//
//
//  Supported instruction opcodes:
//    8'h00   WBYPASS
//    8'h02   IDCODE
//    8'h03   BC1500
//    8'h04   BC1500_QRYUPD
//    8'h05   ALTTAPEN
//    8'h07   SYSSCANSHIFT
//    8'h09   SCANCONFIG
//    8'h0A   SELECTDIE
//    8'h0B   BROADCAST
//    8'h13   P1687A
//    8'h14   P1687A_QRYUPD
//    8'h20   SYSSCANSHIFT2
//    8'h21   SYSSCAN
//    8'h25   QRYUPD
//    8'h34   SMSG_CONTROL
//    8'h35   SMSG_STATUS
//    8'h36   JPC_WIR
//    8'h37   JPC_WDR
//    8'h38   SMS_WIR
//    8'h39   SMS_WDR
//    8'h3A   FUSE_IF_ATE_MODE
//    8'h3B   FUSE_IF_SETUP
//    8'h3C   FUSE_IF_STATUS
//    8'hFF   BYPASS
//
//================================================================================================================================

// leda B_1001 off
//~ format_rtl 1
//~ format_inst narrow

`timescale 1ps/1ps

module gc3_STAC_CORE (
  input        Mode1149,       // 1: follow 1149.1 protocol
                               // 0: follow 1500 protocol
  input        ModeSingleChain,
  input        SelectWSP,
  input        Tms,
  input        Wrst,
  input        SyncWrst,
  input        Wrck,
  input        Wsi,
  output  wire Wso,
  output  wire WsoEn,
  input        SecureMode,
  input        AEB,
  input        PipelineEn,
  output  wire       TapCapDR,                       // Raw TAP state
  output  wire       TapShfDR,                       // Raw TAP state
  output  wire       TapInCapDR,                     // Negedge TAP state
  output  wire       TapInShfDR,                     // Negedge TAP state
  output  wire       TapInUpdDR,                     // Raw TAP state
  output  wire       TapInUpdIR,                     // Raw TAP state
  output  wire       TapInTlr,                       // Negedge TAP state
  output  wire       TapInRti,                       // Negedge TAP state
  output  wire       TapInRtiNxt,                    // Raw TAP state
  output   reg       WdrCapture,
  output   reg       WdrShift,
  output   reg       WdrUpdate,
  output   reg       JTAGFF_WdrUpdate,
  output   reg [7:0] WirShiftReg,                    // Shift only WIR used to generate glitchless private BSR signals
  output   reg       WirUpdate,                      // Update WIR used to latch single bit, glitchless private BSR signals
  output   reg [7:0] WIR,
  output  wire       WdrWrck,
  output  wire       WdrWrst,
  output  wire       WdrWsi,
  input              MuxWso
);

//=============================================================================
// 1149.1 FSM
//=============================================================================

// All local shadow FSMs operate in lockstep with chip-level 1149.1 FSM
// even if the SelectWSP is not asserted.

  wire       CAPTURE_DR;
  wire       CAPTURE_IR;
  wire       SHIFT_DR;
  wire       SHIFT_IR;
  wire       JTAGFF_UPDATE_DR;
  wire       UPDATE_DR;
  wire       UPDATE_IR;
  wire       TEST_LOGIC_RESET;
  wire       RUN_TEST_IDLE;
  wire       RUN_TEST_IDLE_NXT;
  wire [7:0] RawWirShiftReg;
  wire [7:0] UnsecuredWirShiftReg;
  wire [7:0] RawWIR;
  wire [7:0] UnsecuredWIR;
  wire       JTAGFF_TapInUpdDR;
  wire       TapInCapIR;
  wire       TapInShfIR;
  wire       ZERO_BIT_SHIFT_IR;

gc3_TAPFSM TAPFSM (
  .TRST              ( Wrst              ),
  .TMS               ( Tms               ),
  .TCK               ( Wrck              ),
  .early_CAPTURE_DR  ( early_CAPTURE_DR  ),
  .early_SHIFT_DR    ( early_SHIFT_DR    ),
  .CAPTURE_DR        ( CAPTURE_DR        ),
  .CAPTURE_IR        ( CAPTURE_IR        ),
  .SHIFT_DR          ( SHIFT_DR          ),
  .SHIFT_IR          ( SHIFT_IR          ),
  .JTAGFF_UPDATE_DR  ( JTAGFF_UPDATE_DR  ),
  .UPDATE_DR         ( UPDATE_DR         ),
  .UPDATE_IR         ( UPDATE_IR         ),
  .TEST_LOGIC_RESET  ( TEST_LOGIC_RESET  ),
  .RUN_TEST_IDLE     ( RUN_TEST_IDLE     ),
  .RUN_TEST_IDLE_NXT ( RUN_TEST_IDLE_NXT ),
  .ZERO_BIT_SHIFT_IR ( ZERO_BIT_SHIFT_IR )
);

// UBTS 528914 fix: preload QRYUPD
assign UnsecuredWirShiftReg[7:0] = ZERO_BIT_SHIFT_IR ? 8'h25 : RawWirShiftReg[7:0];
assign UnsecuredWIR[7:0]  = RawWIR[7:0];
assign TapInTlr           = TEST_LOGIC_RESET;
assign TapInRti           = RUN_TEST_IDLE;
assign TapInRtiNxt        = RUN_TEST_IDLE_NXT;
assign TapInCapDR         = CAPTURE_DR;
assign TapInShfDR         = SHIFT_DR;
assign TapCapDR           = early_CAPTURE_DR;
assign TapShfDR           = early_SHIFT_DR;
assign TapInUpdDR         = UPDATE_DR;
assign JTAGFF_TapInUpdDR  = JTAGFF_UPDATE_DR;
assign TapInCapIR         = CAPTURE_IR;
assign TapInShfIR         = SHIFT_IR;
assign TapInUpdIR         = UPDATE_IR;

//=============================================================================
// SWB cell
//=============================================================================

// STAC in 1500+FSM mode - enable this bit and stitch it in.
// STAC in 1149.1 mode   - disable this bit and bypass it.
// Single chain mode     - disable this bit and bypass it.
// Both TLR (TapInTlr) and TRST will reset SIBs, SWIRs and any other network configuration bits.

  wire SwbWso;
  wire SelectWIR;
  reg  SwbCapture;
  reg  SwbShift;
  reg  SwbUpdate;

always @* begin
  SwbCapture = TapInCapDR & ~Mode1149;
  SwbShift   = TapInShfDR & ~Mode1149;
  SwbUpdate  = TapInUpdDR & ~Mode1149;
end

// SWB with additional bypass control for single chain

gc3_SWB I_SWB (
  .ZERO_BIT_SHIFT_IR ( ZERO_BIT_SHIFT_IR  ), // UBTS 528914
  .SYSSCANSHIFT_En   ( ModeSingleChain    ),
  .SwbEn             ( SelectWSP          ),
  .SwbCapture        ( SwbCapture         ),
  .SwbShift          ( SwbShift           ),
  .SwbUpdate         ( SwbUpdate          ),
  .TapInUpdIR        ( TapInUpdIR         ),
  .Trst              ( WdrWrst | TapInTlr ),
  .Tck               ( Wrck               ),
  .Tdi               ( Wsi                ),
  .Tdo               ( SwbWso             ),
  .SWB               ( SelectWIR          )     // Effective value of the SWB
);

//=============================================================================
// WIR
//=============================================================================

// STAC in 1500+FSM mode - control this WIR with the 'data' stack.
// STAC in 1149.1 mode   - control this WIR with the 'instruction' stack.

  wire WirWsi;
  wire WirWso;
  reg  WirCapture;
  reg  WirShift;

always @* begin
  if (Mode1149) begin
    WirCapture = TapInCapIR & SelectWSP;
    WirShift   = TapInShfIR & SelectWSP;
    WirUpdate  = TapInUpdIR & SelectWSP;
  end else begin
    WirCapture = TapInCapDR & SelectWSP & SelectWIR;
    WirShift   = TapInShfDR & SelectWSP & SelectWIR;
    WirUpdate  = ZERO_BIT_SHIFT_IR ? TapInUpdIR & SelectWSP : TapInUpdDR & SelectWSP & SelectWIR;
  end
end

DFXIP4_GC10_JTAGTDR_NO_UPD #(.LENGTH(8)) I_WirShift (
  .RSTVAL ( 8'hFF ),
  .CAP_D  ( {UnsecuredWIR[7:3], PipelineEn, UnsecuredWIR[1:0]} ),  // UBTS 484316
  .TDR_Q  ( RawWirShiftReg[7:0] ),
  .CAP    ( WirCapture          ),
  .SHF    ( WirShift            ),
  .TRST   ( SyncWrst | TapInTlr ),
  .TCK    ( Wrck                ),
  .TDI    ( WirWsi              ),
  .TDO    ( WirWso              ),
  .SEL    ( 1'b1                )
);

DFXIP4_GC10_JTAGTDR_UPD #(.LENGTH(8)) I_WIR (
  .RSTVAL ( 8'hFF ),
  .UPD_D  ( WirShiftReg[7:0]    ),
  .TDR_Q  ( RawWIR[7:0]         ),
  .UPD    ( WirUpdate           ),
  .TRST   ( SyncWrst | TapInTlr ),
  .TCK    ( Wrck                ),
  .SEL    ( 1'b1                )
);

//=============================================================================
// AEB override
//=============================================================================

// Intercept the WIR's SHIFT/UPDATE registers
// There's a set of instructions that are always accessible, regardless of the AEBs;
// this is defined by the PrintAebInstrCasez subroutine.
// For the instructions that are protected by the AEBs, if
//   AEB==1, we allow access to these instructions, else if
//   AEB==0, we default these instructions to BYPASS

  wire         AEB_GLOBAL;
DFXIP4_GC10_IP_SYNC I_SYNC_AEB (
  .SampleClk ( Wrck ),
  .DataIn    ( AEB
             ),
  .DataOut   ( AEB_GLOBAL )
);

always @* begin
  case(^{SecureMode, AEB_GLOBAL, UnsecuredWirShiftReg[7:0]})
    1'b0, 1'b1:
    begin
      casez({SecureMode, AEB_GLOBAL, UnsecuredWirShiftReg[7:0]})
        // Secure boot completed and access has been granted (secure and unlocked)
        {1'b1,1'b1,8'h??} : begin
                              // Determine what was actually granted based on the AEB
                              if (AEB_GLOBAL==1'b1 & ( 1'b0
                                              | UnsecuredWirShiftReg[7:0]==8'h00 // WBYPASS
                                              | UnsecuredWirShiftReg[7:0]==8'h02 // IDCODE
                                              | UnsecuredWirShiftReg[7:0]==8'h03 // BC1500
                                              | UnsecuredWirShiftReg[7:0]==8'h04 // BC1500_QRYUPD
                                              | UnsecuredWirShiftReg[7:0]==8'h05 // ALTTAPEN
                                              | UnsecuredWirShiftReg[7:0]==8'h07 // SYSSCANSHIFT
                                              | UnsecuredWirShiftReg[7:0]==8'h09 // SCANCONFIG
                                              | UnsecuredWirShiftReg[7:0]==8'h0A // SELECTDIE
                                              | UnsecuredWirShiftReg[7:0]==8'h0B // BROADCAST
                                              | UnsecuredWirShiftReg[7:0]==8'h13 // P1687A
                                              | UnsecuredWirShiftReg[7:0]==8'h14 // P1687A_QRYUPD
                                              | UnsecuredWirShiftReg[7:0]==8'h20 // SYSSCANSHIFT2
                                              | UnsecuredWirShiftReg[7:0]==8'h21 // SYSSCAN
                                              | UnsecuredWirShiftReg[7:0]==8'h25 // QRYUPD
                                              | UnsecuredWirShiftReg[7:0]==8'h34 // SMSG_CONTROL
                                              | UnsecuredWirShiftReg[7:0]==8'h35 // SMSG_STATUS
                                              | UnsecuredWirShiftReg[7:0]==8'h36 // JPC_WIR
                                              | UnsecuredWirShiftReg[7:0]==8'h37 // JPC_WDR
                                              | UnsecuredWirShiftReg[7:0]==8'h38 // SMS_WIR
                                              | UnsecuredWirShiftReg[7:0]==8'h39 // SMS_WDR
                                              | UnsecuredWirShiftReg[7:0]==8'h3A // FUSE_IF_ATE_MODE
                                              | UnsecuredWirShiftReg[7:0]==8'h3B // FUSE_IF_SETUP
                                              | UnsecuredWirShiftReg[7:0]==8'h3C // FUSE_IF_STATUS
                                              | UnsecuredWirShiftReg[7:0]==8'hFF // BYPASS
                                              )
                                 )
                                WirShiftReg[7:0] = UnsecuredWirShiftReg[7:0];
                              else
                                WirShiftReg[7:0] = 8'hFF;
                            end
        // Secure boot completed and with limited access (secure and locked)
        {1'b1,1'b0,8'h00} : WirShiftReg[7:0] = UnsecuredWirShiftReg[7:0];  // WBYPASS
        {1'b1,1'b0,8'h02} : WirShiftReg[7:0] = UnsecuredWirShiftReg[7:0];  // IDCODE
        {1'b1,1'b0,8'h03} : WirShiftReg[7:0] = UnsecuredWirShiftReg[7:0];  // BC1500
        {1'b1,1'b0,8'h04} : WirShiftReg[7:0] = UnsecuredWirShiftReg[7:0];  // BC1500_QRYUPD
        {1'b1,1'b0,8'h05} : WirShiftReg[7:0] = UnsecuredWirShiftReg[7:0];  // ALTTAPEN
        {1'b1,1'b0,8'h0A} : WirShiftReg[7:0] = UnsecuredWirShiftReg[7:0];  // SELECTDIE
        {1'b1,1'b0,8'h0B} : WirShiftReg[7:0] = UnsecuredWirShiftReg[7:0];  // BROADCAST
        {1'b1,1'b0,8'h13} : WirShiftReg[7:0] = UnsecuredWirShiftReg[7:0];  // P1687A
        {1'b1,1'b0,8'h14} : WirShiftReg[7:0] = UnsecuredWirShiftReg[7:0];  // P1687A_QRYUPD
        {1'b1,1'b0,8'h25} : WirShiftReg[7:0] = UnsecuredWirShiftReg[7:0];  // QRYUPD
        {1'b1,1'b0,8'h3A} : WirShiftReg[7:0] = UnsecuredWirShiftReg[7:0];  // FUSE_IF_ATE_MODE
        {1'b1,1'b0,8'hFF} : WirShiftReg[7:0] = UnsecuredWirShiftReg[7:0];  // BYPASS
        // Not in secure boot mode (unsecure)
        {1'b0,1'b?,8'h??} : WirShiftReg[7:0] = UnsecuredWirShiftReg[7:0];
        default : WirShiftReg[7:0] = 8'hFF;
      endcase
    end
    default     : WirShiftReg[7:0] = 8'bx;
  endcase
end
always @* begin
  case(^{SecureMode, AEB_GLOBAL, UnsecuredWIR[7:0]})
    1'b0, 1'b1:
    begin
      casez({SecureMode, AEB_GLOBAL, UnsecuredWIR[7:0]})
        // Secure boot completed and access has been granted (secure and unlocked)
        {1'b1,1'b1,8'h??} : begin
                              // Determine what was actually granted based on the AEB
                              if (AEB_GLOBAL==1'b1 & ( 1'b0
                                              | UnsecuredWIR[7:0]==8'h00 // WBYPASS
                                              | UnsecuredWIR[7:0]==8'h02 // IDCODE
                                              | UnsecuredWIR[7:0]==8'h03 // BC1500
                                              | UnsecuredWIR[7:0]==8'h04 // BC1500_QRYUPD
                                              | UnsecuredWIR[7:0]==8'h05 // ALTTAPEN
                                              | UnsecuredWIR[7:0]==8'h07 // SYSSCANSHIFT
                                              | UnsecuredWIR[7:0]==8'h09 // SCANCONFIG
                                              | UnsecuredWIR[7:0]==8'h0A // SELECTDIE
                                              | UnsecuredWIR[7:0]==8'h0B // BROADCAST
                                              | UnsecuredWIR[7:0]==8'h13 // P1687A
                                              | UnsecuredWIR[7:0]==8'h14 // P1687A_QRYUPD
                                              | UnsecuredWIR[7:0]==8'h20 // SYSSCANSHIFT2
                                              | UnsecuredWIR[7:0]==8'h21 // SYSSCAN
                                              | UnsecuredWIR[7:0]==8'h25 // QRYUPD
                                              | UnsecuredWIR[7:0]==8'h34 // SMSG_CONTROL
                                              | UnsecuredWIR[7:0]==8'h35 // SMSG_STATUS
                                              | UnsecuredWIR[7:0]==8'h36 // JPC_WIR
                                              | UnsecuredWIR[7:0]==8'h37 // JPC_WDR
                                              | UnsecuredWIR[7:0]==8'h38 // SMS_WIR
                                              | UnsecuredWIR[7:0]==8'h39 // SMS_WDR
                                              | UnsecuredWIR[7:0]==8'h3A // FUSE_IF_ATE_MODE
                                              | UnsecuredWIR[7:0]==8'h3B // FUSE_IF_SETUP
                                              | UnsecuredWIR[7:0]==8'h3C // FUSE_IF_STATUS
                                              | UnsecuredWIR[7:0]==8'hFF // BYPASS
                                              )
                                 )
                                WIR[7:0] = UnsecuredWIR[7:0];
                              else
                                WIR[7:0] = 8'hFF;
                            end
        // Secure boot completed and with limited access (secure and locked)
        {1'b1,1'b0,8'h00} : WIR[7:0] = UnsecuredWIR[7:0];  // WBYPASS
        {1'b1,1'b0,8'h02} : WIR[7:0] = UnsecuredWIR[7:0];  // IDCODE
        {1'b1,1'b0,8'h03} : WIR[7:0] = UnsecuredWIR[7:0];  // BC1500
        {1'b1,1'b0,8'h04} : WIR[7:0] = UnsecuredWIR[7:0];  // BC1500_QRYUPD
        {1'b1,1'b0,8'h05} : WIR[7:0] = UnsecuredWIR[7:0];  // ALTTAPEN
        {1'b1,1'b0,8'h0A} : WIR[7:0] = UnsecuredWIR[7:0];  // SELECTDIE
        {1'b1,1'b0,8'h0B} : WIR[7:0] = UnsecuredWIR[7:0];  // BROADCAST
        {1'b1,1'b0,8'h13} : WIR[7:0] = UnsecuredWIR[7:0];  // P1687A
        {1'b1,1'b0,8'h14} : WIR[7:0] = UnsecuredWIR[7:0];  // P1687A_QRYUPD
        {1'b1,1'b0,8'h25} : WIR[7:0] = UnsecuredWIR[7:0];  // QRYUPD
        {1'b1,1'b0,8'h3A} : WIR[7:0] = UnsecuredWIR[7:0];  // FUSE_IF_ATE_MODE
        {1'b1,1'b0,8'hFF} : WIR[7:0] = UnsecuredWIR[7:0];  // BYPASS
        // Not in secure boot mode (unsecure)
        {1'b0,1'b?,8'h??} : WIR[7:0] = UnsecuredWIR[7:0];
        default : WIR[7:0] = 8'hFF;
      endcase
    end
    default     : WIR[7:0] = 8'bx;
  endcase
end


//=============================================================================
// WDR
//=============================================================================

// STAC in 1500+FSM mode - factor in the SelectWIR.
// STAC in 1149.1 mode   - don't factor in the SelectWIR.

always @* begin
  if (Mode1149) begin
    WdrCapture        = TapInCapDR        & SelectWSP;
    WdrShift          = TapInShfDR        & SelectWSP;
    WdrUpdate         = TapInUpdDR        & SelectWSP;
    JTAGFF_WdrUpdate  = JTAGFF_TapInUpdDR & SelectWSP;
  end else begin
    WdrCapture        = TapInCapDR        & SelectWSP & ~SelectWIR;
    WdrShift          = TapInShfDR        & SelectWSP & ~SelectWIR;
    WdrUpdate         = TapInUpdDR        & SelectWSP & ~SelectWIR;
    JTAGFF_WdrUpdate  = JTAGFF_TapInUpdDR & SelectWSP & ~SelectWIR;
  end
end

// WDRs only get reset with WRSTN and not affected by TLR.
assign WdrWrst = SyncWrst;
assign WdrWrck = Wrck;

//=============================================================================
// WSI/WSO muxing
//=============================================================================

// STAC in 1500+FSM mode - include the SWB: Wsi -> SWB -> WIR/WDR -> Wso
// STAC in 1149.1 mode   - bypass the SWB:  Wsi -> WIR/WDR -> Wso
// Single chain mode     - bypass the SWB:  Wsi -> WIR/WDR -> Wso

assign WirWsi = Mode1149 ? Wsi : SwbWso;
assign WdrWsi = Mode1149 ? Wsi : SwbWso;

// STAC in 1500+FSM mode - select the WIR when the SelectWIR is set.
// STAC in 1149.1 mode   - select the WIR when we are shifting the WIR.
// Single chain mode     - do not select the WIR when we are shifting the single chain.

assign Wso   = ( (~Mode1149 & SelectWIR)
               | ( Mode1149 & WirShift ) )  ? WirWso
                                            : MuxWso;

// This is only when we're in 1149.1 mode.

assign WsoEn = Mode1149 & (TapInShfDR | TapInShfIR);

endmodule

// leda B_1001 on
