`include "grbm_defs.vh"
`include "gc__gc_cac_reg.v"
`include "gc_register_addr.v"

module se_cac_rbiu
(
 input                                 sclk,
 input                                 reg_sclk,
 input                                 combined_resetb,
 input                                 hard_resetb,

 input [1:0]                           SE_STRAP_id,

 input                                 GRBM_CAC_reg_clken,
 input                                 GRBM_CAC_reg_send,
 input                                 GRBM_CAC_reg_op,
 input                                 GRBM_CAC_reg_priv,
 input [`GRBM_TARG_REG_VMID_RANGE]     GRBM_CAC_reg_vmid,
 input                                 GRBM_CAC_reg_tmz,
 input [`GRBM_TARG_REG_MEID_RANGE]     GRBM_CAC_reg_meid,
 input [`GRBM_TARG_REG_PIPEID_RANGE]   GRBM_CAC_reg_pipeid,
 input [`GRBM_TARG_REG_INDEX_RANGE]    GRBM_CAC_reg_index,
 input [`GRBM_TARG_REG_ADDR_RANGE]     GRBM_CAC_reg_addr,
 input [`GRBM_TARG_REG_WD_RANGE]       GRBM_CAC_reg_wd,

 input                                 didt_read_valid,
 input [`TARG_GRBM_READ_DATA_RANGE]    didt_read_data,

 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TA_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TA_sig0_threshold,
 output wire [10-1:0]          SA0_TA_sig0_ovr_sel,
 output wire [10-1:0]          SA0_TA_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TA_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TA_sig0_threshold,
 output wire [10-1:0]          SA1_TA_sig0_ovr_sel,
 output wire [10-1:0]          SA1_TA_sig0_ovr_val,

 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig0_threshold,
 output wire [10-1:0]          SA0_TD_sig0_ovr_sel,
 output wire [10-1:0]          SA0_TD_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig0_threshold,
 output wire [10-1:0]          SA1_TD_sig0_ovr_sel,
 output wire [10-1:0]          SA1_TD_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig1_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig1_threshold,
 output wire [10-1:0]          SA0_TD_sig1_ovr_sel,
 output wire [10-1:0]          SA0_TD_sig1_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig1_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig1_threshold,
 output wire [10-1:0]          SA1_TD_sig1_ovr_sel,
 output wire [10-1:0]          SA1_TD_sig1_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig2_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig2_threshold,
 output wire [10-1:0]          SA0_TD_sig2_ovr_sel,
 output wire [10-1:0]          SA0_TD_sig2_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig2_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig2_threshold,
 output wire [10-1:0]          SA1_TD_sig2_ovr_sel,
 output wire [10-1:0]          SA1_TD_sig2_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig3_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig3_threshold,
 output wire [10-1:0]          SA0_TD_sig3_ovr_sel,
 output wire [10-1:0]          SA0_TD_sig3_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig3_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig3_threshold,
 output wire [10-1:0]          SA1_TD_sig3_ovr_sel,
 output wire [10-1:0]          SA1_TD_sig3_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig4_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig4_threshold,
 output wire [10-1:0]          SA0_TD_sig4_ovr_sel,
 output wire [10-1:0]          SA0_TD_sig4_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig4_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig4_threshold,
 output wire [10-1:0]          SA1_TD_sig4_ovr_sel,
 output wire [10-1:0]          SA1_TD_sig4_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig5_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig5_threshold,
 output wire [10-1:0]          SA0_TD_sig5_ovr_sel,
 output wire [10-1:0]          SA0_TD_sig5_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig5_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig5_threshold,
 output wire [10-1:0]          SA1_TD_sig5_ovr_sel,
 output wire [10-1:0]          SA1_TD_sig5_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig6_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig6_threshold,
 output wire [10-1:0]          SA0_TD_sig6_ovr_sel,
 output wire [10-1:0]          SA0_TD_sig6_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig6_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig6_threshold,
 output wire [10-1:0]          SA1_TD_sig6_ovr_sel,
 output wire [10-1:0]          SA1_TD_sig6_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig7_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig7_threshold,
 output wire [10-1:0]          SA0_TD_sig7_ovr_sel,
 output wire [10-1:0]          SA0_TD_sig7_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig7_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig7_threshold,
 output wire [10-1:0]          SA1_TD_sig7_ovr_sel,
 output wire [10-1:0]          SA1_TD_sig7_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig8_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig8_threshold,
 output wire [10-1:0]          SA0_TD_sig8_ovr_sel,
 output wire [10-1:0]          SA0_TD_sig8_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig8_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig8_threshold,
 output wire [10-1:0]          SA1_TD_sig8_ovr_sel,
 output wire [10-1:0]          SA1_TD_sig8_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig9_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig9_threshold,
 output wire [10-1:0]          SA0_TD_sig9_ovr_sel,
 output wire [10-1:0]          SA0_TD_sig9_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig9_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig9_threshold,
 output wire [10-1:0]          SA1_TD_sig9_ovr_sel,
 output wire [10-1:0]          SA1_TD_sig9_ovr_val,

 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TCP_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TCP_sig0_threshold,
 output wire [10-1:0]          SA0_TCP_sig0_ovr_sel,
 output wire [10-1:0]          SA0_TCP_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TCP_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TCP_sig0_threshold,
 output wire [10-1:0]          SA1_TCP_sig0_ovr_sel,
 output wire [10-1:0]          SA1_TCP_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TCP_sig1_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TCP_sig1_threshold,
 output wire [10-1:0]          SA0_TCP_sig1_ovr_sel,
 output wire [10-1:0]          SA0_TCP_sig1_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TCP_sig1_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TCP_sig1_threshold,
 output wire [10-1:0]          SA1_TCP_sig1_ovr_sel,
 output wire [10-1:0]          SA1_TCP_sig1_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TCP_sig2_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TCP_sig2_threshold,
 output wire [10-1:0]          SA0_TCP_sig2_ovr_sel,
 output wire [10-1:0]          SA0_TCP_sig2_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TCP_sig2_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TCP_sig2_threshold,
 output wire [10-1:0]          SA1_TCP_sig2_ovr_sel,
 output wire [10-1:0]          SA1_TCP_sig2_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TCP_sig3_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TCP_sig3_threshold,
 output wire [10-1:0]          SA0_TCP_sig3_ovr_sel,
 output wire [10-1:0]          SA0_TCP_sig3_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TCP_sig3_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TCP_sig3_threshold,
 output wire [10-1:0]          SA1_TCP_sig3_ovr_sel,
 output wire [10-1:0]          SA1_TCP_sig3_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TCP_sig4_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TCP_sig4_threshold,
 output wire [10-1:0]          SA0_TCP_sig4_ovr_sel,
 output wire [10-1:0]          SA0_TCP_sig4_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TCP_sig4_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TCP_sig4_threshold,
 output wire [10-1:0]          SA1_TCP_sig4_ovr_sel,
 output wire [10-1:0]          SA1_TCP_sig4_ovr_val,

 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SQ_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SQ_sig0_threshold,
 output wire [5-1:0]          SA0_SQ_sig0_ovr_sel,
 output wire [5-1:0]          SA0_SQ_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SQ_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SQ_sig0_threshold,
 output wire [5-1:0]          SA1_SQ_sig0_ovr_sel,
 output wire [5-1:0]          SA1_SQ_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SQ_sig1_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SQ_sig1_threshold,
 output wire [5-1:0]          SA0_SQ_sig1_ovr_sel,
 output wire [5-1:0]          SA0_SQ_sig1_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SQ_sig1_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SQ_sig1_threshold,
 output wire [5-1:0]          SA1_SQ_sig1_ovr_sel,
 output wire [5-1:0]          SA1_SQ_sig1_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SQ_sig2_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SQ_sig2_threshold,
 output wire [5-1:0]          SA0_SQ_sig2_ovr_sel,
 output wire [5-1:0]          SA0_SQ_sig2_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SQ_sig2_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SQ_sig2_threshold,
 output wire [5-1:0]          SA1_SQ_sig2_ovr_sel,
 output wire [5-1:0]          SA1_SQ_sig2_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SQ_sig3_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SQ_sig3_threshold,
 output wire [5-1:0]          SA0_SQ_sig3_ovr_sel,
 output wire [5-1:0]          SA0_SQ_sig3_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SQ_sig3_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SQ_sig3_threshold,
 output wire [5-1:0]          SA1_SQ_sig3_ovr_sel,
 output wire [5-1:0]          SA1_SQ_sig3_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SQ_sig4_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SQ_sig4_threshold,
 output wire [5-1:0]          SA0_SQ_sig4_ovr_sel,
 output wire [5-1:0]          SA0_SQ_sig4_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SQ_sig4_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SQ_sig4_threshold,
 output wire [5-1:0]          SA1_SQ_sig4_ovr_sel,
 output wire [5-1:0]          SA1_SQ_sig4_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SQ_sig5_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SQ_sig5_threshold,
 output wire [5-1:0]          SA0_SQ_sig5_ovr_sel,
 output wire [5-1:0]          SA0_SQ_sig5_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SQ_sig5_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SQ_sig5_threshold,
 output wire [5-1:0]          SA1_SQ_sig5_ovr_sel,
 output wire [5-1:0]          SA1_SQ_sig5_ovr_val,

 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_LDS_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_LDS_sig0_threshold,
 output wire [10-1:0]          SA0_LDS_sig0_ovr_sel,
 output wire [10-1:0]          SA0_LDS_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_LDS_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_LDS_sig0_threshold,
 output wire [10-1:0]          SA1_LDS_sig0_ovr_sel,
 output wire [10-1:0]          SA1_LDS_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_LDS_sig1_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_LDS_sig1_threshold,
 output wire [10-1:0]          SA0_LDS_sig1_ovr_sel,
 output wire [10-1:0]          SA0_LDS_sig1_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_LDS_sig1_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_LDS_sig1_threshold,
 output wire [10-1:0]          SA1_LDS_sig1_ovr_sel,
 output wire [10-1:0]          SA1_LDS_sig1_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_LDS_sig2_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_LDS_sig2_threshold,
 output wire [10-1:0]          SA0_LDS_sig2_ovr_sel,
 output wire [10-1:0]          SA0_LDS_sig2_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_LDS_sig2_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_LDS_sig2_threshold,
 output wire [10-1:0]          SA1_LDS_sig2_ovr_sel,
 output wire [10-1:0]          SA1_LDS_sig2_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_LDS_sig3_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_LDS_sig3_threshold,
 output wire [10-1:0]          SA0_LDS_sig3_ovr_sel,
 output wire [10-1:0]          SA0_LDS_sig3_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_LDS_sig3_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_LDS_sig3_threshold,
 output wire [10-1:0]          SA1_LDS_sig3_ovr_sel,
 output wire [10-1:0]          SA1_LDS_sig3_ovr_val,

 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_BCI_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_BCI_sig0_threshold,
 output wire [1-1:0]          SA0_BCI_sig0_ovr_sel,
 output wire [1-1:0]          SA0_BCI_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_BCI_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_BCI_sig0_threshold,
 output wire [1-1:0]          SA1_BCI_sig0_ovr_sel,
 output wire [1-1:0]          SA1_BCI_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_BCI_sig1_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_BCI_sig1_threshold,
 output wire [1-1:0]          SA0_BCI_sig1_ovr_sel,
 output wire [1-1:0]          SA0_BCI_sig1_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_BCI_sig1_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_BCI_sig1_threshold,
 output wire [1-1:0]          SA1_BCI_sig1_ovr_sel,
 output wire [1-1:0]          SA1_BCI_sig1_ovr_val,

 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_CB_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_CB_sig0_threshold,
 output wire [4-1:0]          SA0_CB_sig0_ovr_sel,
 output wire [4-1:0]          SA0_CB_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_CB_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_CB_sig0_threshold,
 output wire [4-1:0]          SA1_CB_sig0_ovr_sel,
 output wire [4-1:0]          SA1_CB_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_CB_sig1_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_CB_sig1_threshold,
 output wire [4-1:0]          SA0_CB_sig1_ovr_sel,
 output wire [4-1:0]          SA0_CB_sig1_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_CB_sig1_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_CB_sig1_threshold,
 output wire [4-1:0]          SA1_CB_sig1_ovr_sel,
 output wire [4-1:0]          SA1_CB_sig1_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_CB_sig2_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_CB_sig2_threshold,
 output wire [4-1:0]          SA0_CB_sig2_ovr_sel,
 output wire [4-1:0]          SA0_CB_sig2_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_CB_sig2_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_CB_sig2_threshold,
 output wire [4-1:0]          SA1_CB_sig2_ovr_sel,
 output wire [4-1:0]          SA1_CB_sig2_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_CB_sig3_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_CB_sig3_threshold,
 output wire [4-1:0]          SA0_CB_sig3_ovr_sel,
 output wire [4-1:0]          SA0_CB_sig3_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_CB_sig3_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_CB_sig3_threshold,
 output wire [4-1:0]          SA1_CB_sig3_ovr_sel,
 output wire [4-1:0]          SA1_CB_sig3_ovr_val,

 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_DB_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_DB_sig0_threshold,
 output wire [4-1:0]          SA0_DB_sig0_ovr_sel,
 output wire [4-1:0]          SA0_DB_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_DB_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_DB_sig0_threshold,
 output wire [4-1:0]          SA1_DB_sig0_ovr_sel,
 output wire [4-1:0]          SA1_DB_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_DB_sig1_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_DB_sig1_threshold,
 output wire [4-1:0]          SA0_DB_sig1_ovr_sel,
 output wire [4-1:0]          SA0_DB_sig1_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_DB_sig1_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_DB_sig1_threshold,
 output wire [4-1:0]          SA1_DB_sig1_ovr_sel,
 output wire [4-1:0]          SA1_DB_sig1_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_DB_sig2_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_DB_sig2_threshold,
 output wire [4-1:0]          SA0_DB_sig2_ovr_sel,
 output wire [4-1:0]          SA0_DB_sig2_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_DB_sig2_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_DB_sig2_threshold,
 output wire [4-1:0]          SA1_DB_sig2_ovr_sel,
 output wire [4-1:0]          SA1_DB_sig2_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_DB_sig3_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_DB_sig3_threshold,
 output wire [4-1:0]          SA0_DB_sig3_ovr_sel,
 output wire [4-1:0]          SA0_DB_sig3_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_DB_sig3_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_DB_sig3_threshold,
 output wire [4-1:0]          SA1_DB_sig3_ovr_sel,
 output wire [4-1:0]          SA1_DB_sig3_ovr_val,

 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_PA_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_PA_sig0_threshold,
 output wire [1-1:0]          SA0_PA_sig0_ovr_sel,
 output wire [1-1:0]          SA0_PA_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_PA_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_PA_sig0_threshold,
 output wire [1-1:0]          SA1_PA_sig0_ovr_sel,
 output wire [1-1:0]          SA1_PA_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_PA_sig1_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_PA_sig1_threshold,
 output wire [1-1:0]          SA0_PA_sig1_ovr_sel,
 output wire [1-1:0]          SA0_PA_sig1_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_PA_sig1_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_PA_sig1_threshold,
 output wire [1-1:0]          SA1_PA_sig1_ovr_sel,
 output wire [1-1:0]          SA1_PA_sig1_ovr_val,

 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_RMI_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_RMI_sig0_threshold,
 output wire [2-1:0]          SA0_RMI_sig0_ovr_sel,
 output wire [2-1:0]          SA0_RMI_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_RMI_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_RMI_sig0_threshold,
 output wire [2-1:0]          SA1_RMI_sig0_ovr_sel,
 output wire [2-1:0]          SA1_RMI_sig0_ovr_val,

 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SC_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SC_sig0_threshold,
 output wire [1-1:0]          SA0_SC_sig0_ovr_sel,
 output wire [1-1:0]          SA0_SC_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SC_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SC_sig0_threshold,
 output wire [1-1:0]          SA1_SC_sig0_ovr_sel,
 output wire [1-1:0]          SA1_SC_sig0_ovr_val,

 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SX_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SX_sig0_threshold,
 output wire [1-1:0]          SA0_SX_sig0_ovr_sel,
 output wire [1-1:0]          SA0_SX_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SX_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SX_sig0_threshold,
 output wire [1-1:0]          SA1_SX_sig0_ovr_sel,
 output wire [1-1:0]          SA1_SX_sig0_ovr_val,

 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SXRB_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SXRB_sig0_threshold,
 output wire [4-1:0]          SA0_SXRB_sig0_ovr_sel,
 output wire [4-1:0]          SA0_SXRB_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SXRB_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SXRB_sig0_threshold,
 output wire [4-1:0]          SA1_SXRB_sig0_ovr_sel,
 output wire [4-1:0]          SA1_SXRB_sig0_ovr_val,

 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_UTCL1_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_UTCL1_sig0_threshold,
 output wire [1-1:0]          SA0_UTCL1_sig0_ovr_sel,
 output wire [1-1:0]          SA0_UTCL1_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_UTCL1_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_UTCL1_sig0_threshold,
 output wire [1-1:0]          SA1_UTCL1_sig0_ovr_sel,
 output wire [1-1:0]          SA1_UTCL1_sig0_ovr_val,

 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_CU_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_CU_sig0_threshold,
 output wire [10-1:0]          SA0_CU_sig0_ovr_sel,
 output wire [10-1:0]          SA0_CU_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_CU_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_CU_sig0_threshold,
 output wire [10-1:0]          SA1_CU_sig0_ovr_sel,
 output wire [10-1:0]          SA1_CU_sig0_ovr_val,

 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SPI_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SPI_sig0_threshold,
 output wire [1-1:0]          SPI_sig0_ovr_sel,
 output wire [1-1:0]          SPI_sig0_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SPI_sig1_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SPI_sig1_threshold,
 output wire [1-1:0]          SPI_sig1_ovr_sel,
 output wire [1-1:0]          SPI_sig1_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SPI_sig2_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SPI_sig2_threshold,
 output wire [1-1:0]          SPI_sig2_ovr_sel,
 output wire [1-1:0]          SPI_sig2_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SPI_sig3_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SPI_sig3_threshold,
 output wire [1-1:0]          SPI_sig3_ovr_sel,
 output wire [1-1:0]          SPI_sig3_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SPI_sig4_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SPI_sig4_threshold,
 output wire [1-1:0]          SPI_sig4_ovr_sel,
 output wire [1-1:0]          SPI_sig4_ovr_val,
 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SPI_sig5_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SPI_sig5_threshold,
 output wire [1-1:0]          SPI_sig5_ovr_sel,
 output wire [1-1:0]          SPI_sig5_ovr_val,

 output wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              PC_sig0_force_disable,
 output wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  PC_sig0_threshold,
 output wire [1-1:0]          PC_sig0_ovr_sel,
 output wire [1-1:0]          PC_sig0_ovr_val,

 output wire                                reg_clken,
 output wire                                reg_send,
 output wire                                reg_op,
 output wire [`GRBM_TARG_REG_ADDR_RANGE]    reg_addr,
 output wire [`GRBM_TARG_REG_WD_RANGE]      reg_wd,
 output wire [1:0]                          reg_se_index,
 output wire [1:0]                          reg_sh_index,
 output wire								reg_instance_select,

 output wire								reg_busy,

 output wire [`SE_CAC_CGTT_CLK_CTRL_REG_SIZE-1:0]  cgtt_clk_ctrl,
 output wire [`GC_CAC_CTRL_2_SE_LCAC_ENABLE_SIZE-1:0]  se_lcac_enable,

 output                                CAC_TARG_reg_clken,
 output                                CAC_TARG_reg_send,
 output                                CAC_TARG_reg_op,
 output                                CAC_TARG_reg_priv,
 output[`GRBM_TARG_REG_VMID_RANGE]     CAC_TARG_reg_vmid,
 output                                CAC_TARG_reg_tmz,
 output[`GRBM_TARG_REG_MEID_RANGE]     CAC_TARG_reg_meid,
 output[`GRBM_TARG_REG_PIPEID_RANGE]   CAC_TARG_reg_pipeid,
 output[`GRBM_TARG_REG_INDEX_RANGE]    CAC_TARG_reg_index,
 output[`GRBM_TARG_REG_ADDR_RANGE]     CAC_TARG_reg_addr,
 output[`GRBM_TARG_REG_WD_RANGE]       CAC_TARG_reg_wd,

 input [`TARG_GRBM_SERREAD_DATA_RANGE] CAC_GRBM_serread_in_data,
 output[`TARG_GRBM_SERREAD_DATA_RANGE] CAC_GRBM_serread_data

);

  wire                                 cac_read_valid;
  wire [`TARG_GRBM_READ_DATA_RANGE]    cac_read_data;
  wire                                 read_valid;
  wire [`TARG_GRBM_READ_DATA_RANGE]    read_data;
  wire [`TARG_GRBM_SERREAD_DATA_RANGE] block_GRBM_serread_data;

assign read_valid = didt_read_valid | cac_read_valid;
assign read_data  = (didt_read_valid? didt_read_data : 0) | 
                    (cac_read_valid? cac_read_data : 0);

 wire                                reg_clken_q;
 wire                                reg_send_q;
 wire                                reg_op_q;
 wire [`GRBM_TARG_REG_ADDR_WIDTH-1:0]    reg_addr_q;
 wire [`GRBM_TARG_REG_WD_WIDTH-1:0]      reg_wd_q;

 reg                                reg_clken_q1;
 reg                                reg_send_q1;
 reg                                reg_op_q1;
 reg [`GRBM_TARG_REG_ADDR_WIDTH-1:0]    reg_addr_q1;
 reg [`GRBM_TARG_REG_WD_WIDTH-1:0]      reg_wd_q1;

 reg                                reg_clken_q2;
 reg                                reg_send_q2;
 reg                                reg_op_q2;
 reg [`GRBM_TARG_REG_ADDR_WIDTH-1:0]    reg_addr_q2;
 reg [`GRBM_TARG_REG_WD_WIDTH-1:0]      reg_wd_q2;

 wire [1:0]						reg_se_index_q;
 reg [1:0]						reg_se_index_q1;
 reg [1:0]						reg_se_index_q2;
 wire [1:0]						reg_sh_index_q;
 reg [1:0]						reg_sh_index_q1;
 reg [1:0]						reg_sh_index_q2;
 wire							reg_instance_select_q;
 reg							reg_instance_select_q1;
 reg							reg_instance_select_q2;

 always @(posedge sclk) begin
 	if(~hard_resetb) begin

		reg_clken_q1 <= 1'b0;
		reg_send_q1 <= 1'b0;
		reg_op_q1 <= 1'b0;
		reg_addr_q1 <= {`GRBM_TARG_REG_ADDR_WIDTH{1'b0}};
		//reg_wd_q1 <= {`GRBM_TARG_REG_WD_WIDTH{1'b0}};
		reg_se_index_q1 <= 'd0;
		reg_sh_index_q1 <= 'd0;
		reg_instance_select_q1 <= 'd0;

		reg_clken_q2 <= 1'b0;
		reg_send_q2 <= 1'b0;
		reg_op_q2 <= 1'b0;
		reg_addr_q2 <= {`GRBM_TARG_REG_ADDR_WIDTH{1'b0}};
		//reg_wd_q2 <= {`GRBM_TARG_REG_WD_WIDTH{1'b0}};
		reg_se_index_q2 <= 'd0;
		reg_sh_index_q2 <= 'd0;
		reg_instance_select_q2 <= 'd0;

	end
	else begin
		reg_clken_q1 <= reg_clken_q;
		reg_send_q1 <= reg_send_q;
		reg_op_q1 <= reg_op_q;
		reg_addr_q1 <= reg_addr_q;
		//reg_wd_q1 <= reg_wd_q;
		reg_se_index_q1 <= reg_se_index_q;
		reg_sh_index_q1 <= reg_sh_index_q;
		reg_instance_select_q1 <= reg_instance_select_q;

		reg_clken_q2 <= reg_clken_q1;
		reg_send_q2 <= reg_send_q1;
		reg_op_q2 <= reg_op_q1;
		reg_addr_q2 <= reg_addr_q1;
		//reg_wd_q2 <= reg_wd_q1;
		reg_se_index_q2 <= reg_se_index_q1;
		reg_sh_index_q2 <= reg_sh_index_q1;
		reg_instance_select_q2 <= reg_instance_select_q1;

		end
end

always @ (posedge sclk) begin
	if(~hard_resetb) begin
		reg_wd_q1 <= 'd0;
	end
	else if(reg_op_q) begin
		reg_wd_q1 <= reg_wd_q;
	end
end

always @ (posedge sclk) begin
	if(~hard_resetb) begin
		reg_wd_q2 <= 'd0;
	end
	else if(reg_op_q1) begin
		reg_wd_q2 <= reg_wd_q1;
	end
end


assign reg_clken = reg_clken_q2;
assign reg_addr  = reg_addr_q2;
assign reg_send  = reg_send_q2;
assign reg_op    = reg_op_q2;
assign reg_wd    = reg_wd_q2;
assign reg_se_index = reg_se_index_q2;
assign reg_sh_index = reg_sh_index_q2;
assign reg_instance_select = reg_instance_select_q2;

wire addr_valid;
wire addr_hit;
assign addr_hit = ((reg_send_q && (({reg_addr_q, 2'b0} >= `SE_CAC_IND_INDEX) && ({reg_addr_q,2'b0} <= `SE_CAC_IND_DATA)) || ({reg_addr_q, 2'b0} == `SE_CAC_CGTT_CLK_CTRL) || ({reg_addr_q, 2'b0} == `GC_CAC_CTRL_2))
				|| (reg_send_q && (({reg_addr_q, 2'b0} >= `DIDT_IND_INDEX) && ({reg_addr_q,2'b0} <= `DIDT_INDEX_AUTO_INCR_EN))))
				|| ((reg_send_q1 && (({reg_addr_q1, 2'b0} >= `SE_CAC_IND_INDEX) && ({reg_addr_q1,2'b0} <= `SE_CAC_IND_DATA)) || ({reg_addr_q1, 2'b0} == `SE_CAC_CGTT_CLK_CTRL) || ({reg_addr_q1, 2'b0} == `GC_CAC_CTRL_2)) 
				|| (reg_send_q1 && (({reg_addr_q1, 2'b0} >= `DIDT_IND_INDEX) && ({reg_addr_q1,2'b0} <= `DIDT_INDEX_AUTO_INCR_EN))))
				|| ((reg_send_q2 && (({reg_addr_q2, 2'b0} >= `SE_CAC_IND_INDEX) && ({reg_addr_q2,2'b0} <= `SE_CAC_IND_DATA)) || ({reg_addr_q2, 2'b0} == `SE_CAC_CGTT_CLK_CTRL) || ({reg_addr_q2, 2'b0} == `GC_CAC_CTRL_2)) 
				|| (reg_send_q2 && (({reg_addr_q2, 2'b0} >= `DIDT_IND_INDEX) && ({reg_addr_q2,2'b0} <= `DIDT_INDEX_AUTO_INCR_EN)))); 


assign addr_valid = (reg_send_q2 && (({reg_addr_q2, 2'b0} >= `SE_CAC_IND_INDEX) && ({reg_addr_q2,2'b0} <= `SE_CAC_IND_DATA)) || ({reg_addr_q2, 2'b0} == `SE_CAC_CGTT_CLK_CTRL) || ({reg_addr_q2, 2'b0} == `GC_CAC_CTRL_2)) 
					|| (reg_send_q2 && (({reg_addr_q2, 2'b0} >= `DIDT_IND_INDEX) && ({reg_addr_q2,2'b0} <= `DIDT_INDEX_AUTO_INCR_EN))); 

reg[2:0]  read_cntr;
always @(posedge sclk) begin
	if(~hard_resetb) begin
		read_cntr <= 3'b0;
	end else if( addr_valid && ~reg_op_q2 && reg_send_q2 && (SE_STRAP_id == reg_se_index_q2)) begin
		read_cntr <= read_cntr + 3'b001;
	end else if (cac_read_valid || didt_read_valid) begin
		read_cntr <= read_cntr - 3'b001;
	end
end

wire read_pending;
assign read_pending = (read_cntr == 3'b000) ? 0 : 1;

assign reg_busy = reg_clken && addr_hit || read_pending;
//assign reg_busy = 1'b1;

ati_grbm_se_intf udidt_ati_grbm_interface
(
 .sclk                                   (sclk),
 .sclk_reg                               (sclk),
 .srstb                                  (combined_resetb),
 .hard_srstb                             (hard_resetb),

 // inputs to didt
 .GRBM_block_reg_clken                   (GRBM_CAC_reg_clken),
 .GRBM_block_reg_send                    (GRBM_CAC_reg_send),
 .GRBM_block_reg_addr                    (GRBM_CAC_reg_addr),
 .GRBM_block_reg_wd                      (GRBM_CAC_reg_wd),
 .GRBM_block_reg_op                      (GRBM_CAC_reg_op),
 .GRBM_block_reg_priv                    (GRBM_CAC_reg_priv),
 .GRBM_block_reg_vmid                    (GRBM_CAC_reg_vmid),
 .GRBM_block_reg_tmz                     (GRBM_CAC_reg_tmz),
 .GRBM_block_reg_meid                    (GRBM_CAC_reg_meid),
 .GRBM_block_reg_pipeid                  (GRBM_CAC_reg_pipeid),
 .GRBM_block_reg_index                   (GRBM_CAC_reg_index),

 // outputs for use by didt
 .reg_clken                              (reg_clken_q),
 .reg_send                               (reg_send_q),
 .reg_addr                               (reg_addr_q),
 .reg_wd                                 (reg_wd_q),
 .reg_op                                 (reg_op_q),
 .reg_priv                               (),
 .reg_vmid                               (),
 .reg_tmz                                (),
 .reg_meid                               (),
 .reg_pipeid                             (),
 .reg_instance_select                    (reg_instance_select_q),
 .reg_se_index                           (reg_se_index_q),
 .reg_sa_index                           (reg_sh_index_q),
 .reg_instance_index                     (),

 // repeaters for use by other blocks
 .block_TARG_reg_clken                   (CAC_TARG_reg_clken),
 .block_TARG_reg_send                    (CAC_TARG_reg_send),
 .block_TARG_reg_addr                    (CAC_TARG_reg_addr),
 .block_TARG_reg_wd                      (CAC_TARG_reg_wd),
 .block_TARG_reg_op                      (CAC_TARG_reg_op),
 .block_TARG_reg_priv                    (CAC_TARG_reg_priv),
 .block_TARG_reg_vmid                    (CAC_TARG_reg_vmid),
 .block_TARG_reg_tmz                     (CAC_TARG_reg_tmz),
 .block_TARG_reg_meid                    (CAC_TARG_reg_meid),
 .block_TARG_reg_pipeid                  (CAC_TARG_reg_pipeid),
 .block_TARG_reg_index                   (CAC_TARG_reg_index),

 // read return signals
 .block_read_valid                       (read_valid),
 .block_read_data                        (read_data),

 // serialized input/output
 .block_GRBM_serread_in_data             (CAC_GRBM_serread_in_data),
 .block_GRBM_serread_data                (CAC_GRBM_serread_data),

 .sa_strap                               (2'h0),
 .se_strap                               (SE_STRAP_id),
 .instance_strap                         (7'h00)
);

assign reg_instance_sel = reg_send_q2 & ((SE_STRAP_id == reg_se_index_q2)  || (reg_instance_select_q2 && reg_op_q2));
//reg reg_instance_select_q1, reg_instance_select_q2;
//always @ (posedge sclk) begin
//	if(~hard_resetb) begin
//		reg_instance_select_q1 <= 'd0;
//		reg_instance_select_q2 <= 'd0;
//	end
//	else begin
//		reg_instance_select_q1 <= reg_instance_select;
//		reg_instance_select_q2 <= reg_instance_select_q1;
//	end
//end

se_cac_regs ucac_regs
(
   .resetb                               (hard_resetb),
   .reg_clk                              (reg_sclk),
   .reg_send                             (reg_instance_sel),
   .reg_op                               (reg_op_q2),
   .reg_addr                             (reg_addr_q2),
   .reg_wd                               (reg_wd_q2),
   .cgtt_clk_ctrl						 (cgtt_clk_ctrl),
   .se_lcac_enable                       (se_lcac_enable),
   .SA0_TA_sig0_force_disable                        (SA0_TA_sig0_force_disable),
   .SA0_TA_sig0_threshold                     (SA0_TA_sig0_threshold),
   .SA0_TA_sig0_ovr_sel                       (SA0_TA_sig0_ovr_sel),
   .SA0_TA_sig0_ovr_val                       (SA0_TA_sig0_ovr_val),
   .SA1_TA_sig0_force_disable                        (SA1_TA_sig0_force_disable),
   .SA1_TA_sig0_threshold                     (SA1_TA_sig0_threshold),
   .SA1_TA_sig0_ovr_sel                       (SA1_TA_sig0_ovr_sel),
   .SA1_TA_sig0_ovr_val                       (SA1_TA_sig0_ovr_val),
   .SA0_TD_sig0_force_disable                        (SA0_TD_sig0_force_disable),
   .SA0_TD_sig0_threshold                     (SA0_TD_sig0_threshold),
   .SA0_TD_sig0_ovr_sel                       (SA0_TD_sig0_ovr_sel),
   .SA0_TD_sig0_ovr_val                       (SA0_TD_sig0_ovr_val),
   .SA1_TD_sig0_force_disable                        (SA1_TD_sig0_force_disable),
   .SA1_TD_sig0_threshold                     (SA1_TD_sig0_threshold),
   .SA1_TD_sig0_ovr_sel                       (SA1_TD_sig0_ovr_sel),
   .SA1_TD_sig0_ovr_val                       (SA1_TD_sig0_ovr_val),
   .SA0_TD_sig1_force_disable                        (SA0_TD_sig1_force_disable),
   .SA0_TD_sig1_threshold                     (SA0_TD_sig1_threshold),
   .SA0_TD_sig1_ovr_sel                       (SA0_TD_sig1_ovr_sel),
   .SA0_TD_sig1_ovr_val                       (SA0_TD_sig1_ovr_val),
   .SA1_TD_sig1_force_disable                        (SA1_TD_sig1_force_disable),
   .SA1_TD_sig1_threshold                     (SA1_TD_sig1_threshold),
   .SA1_TD_sig1_ovr_sel                       (SA1_TD_sig1_ovr_sel),
   .SA1_TD_sig1_ovr_val                       (SA1_TD_sig1_ovr_val),
   .SA0_TD_sig2_force_disable                        (SA0_TD_sig2_force_disable),
   .SA0_TD_sig2_threshold                     (SA0_TD_sig2_threshold),
   .SA0_TD_sig2_ovr_sel                       (SA0_TD_sig2_ovr_sel),
   .SA0_TD_sig2_ovr_val                       (SA0_TD_sig2_ovr_val),
   .SA1_TD_sig2_force_disable                        (SA1_TD_sig2_force_disable),
   .SA1_TD_sig2_threshold                     (SA1_TD_sig2_threshold),
   .SA1_TD_sig2_ovr_sel                       (SA1_TD_sig2_ovr_sel),
   .SA1_TD_sig2_ovr_val                       (SA1_TD_sig2_ovr_val),
   .SA0_TD_sig3_force_disable                        (SA0_TD_sig3_force_disable),
   .SA0_TD_sig3_threshold                     (SA0_TD_sig3_threshold),
   .SA0_TD_sig3_ovr_sel                       (SA0_TD_sig3_ovr_sel),
   .SA0_TD_sig3_ovr_val                       (SA0_TD_sig3_ovr_val),
   .SA1_TD_sig3_force_disable                        (SA1_TD_sig3_force_disable),
   .SA1_TD_sig3_threshold                     (SA1_TD_sig3_threshold),
   .SA1_TD_sig3_ovr_sel                       (SA1_TD_sig3_ovr_sel),
   .SA1_TD_sig3_ovr_val                       (SA1_TD_sig3_ovr_val),
   .SA0_TD_sig4_force_disable                        (SA0_TD_sig4_force_disable),
   .SA0_TD_sig4_threshold                     (SA0_TD_sig4_threshold),
   .SA0_TD_sig4_ovr_sel                       (SA0_TD_sig4_ovr_sel),
   .SA0_TD_sig4_ovr_val                       (SA0_TD_sig4_ovr_val),
   .SA1_TD_sig4_force_disable                        (SA1_TD_sig4_force_disable),
   .SA1_TD_sig4_threshold                     (SA1_TD_sig4_threshold),
   .SA1_TD_sig4_ovr_sel                       (SA1_TD_sig4_ovr_sel),
   .SA1_TD_sig4_ovr_val                       (SA1_TD_sig4_ovr_val),
   .SA0_TD_sig5_force_disable                        (SA0_TD_sig5_force_disable),
   .SA0_TD_sig5_threshold                     (SA0_TD_sig5_threshold),
   .SA0_TD_sig5_ovr_sel                       (SA0_TD_sig5_ovr_sel),
   .SA0_TD_sig5_ovr_val                       (SA0_TD_sig5_ovr_val),
   .SA1_TD_sig5_force_disable                        (SA1_TD_sig5_force_disable),
   .SA1_TD_sig5_threshold                     (SA1_TD_sig5_threshold),
   .SA1_TD_sig5_ovr_sel                       (SA1_TD_sig5_ovr_sel),
   .SA1_TD_sig5_ovr_val                       (SA1_TD_sig5_ovr_val),
   .SA0_TD_sig6_force_disable                        (SA0_TD_sig6_force_disable),
   .SA0_TD_sig6_threshold                     (SA0_TD_sig6_threshold),
   .SA0_TD_sig6_ovr_sel                       (SA0_TD_sig6_ovr_sel),
   .SA0_TD_sig6_ovr_val                       (SA0_TD_sig6_ovr_val),
   .SA1_TD_sig6_force_disable                        (SA1_TD_sig6_force_disable),
   .SA1_TD_sig6_threshold                     (SA1_TD_sig6_threshold),
   .SA1_TD_sig6_ovr_sel                       (SA1_TD_sig6_ovr_sel),
   .SA1_TD_sig6_ovr_val                       (SA1_TD_sig6_ovr_val),
   .SA0_TD_sig7_force_disable                        (SA0_TD_sig7_force_disable),
   .SA0_TD_sig7_threshold                     (SA0_TD_sig7_threshold),
   .SA0_TD_sig7_ovr_sel                       (SA0_TD_sig7_ovr_sel),
   .SA0_TD_sig7_ovr_val                       (SA0_TD_sig7_ovr_val),
   .SA1_TD_sig7_force_disable                        (SA1_TD_sig7_force_disable),
   .SA1_TD_sig7_threshold                     (SA1_TD_sig7_threshold),
   .SA1_TD_sig7_ovr_sel                       (SA1_TD_sig7_ovr_sel),
   .SA1_TD_sig7_ovr_val                       (SA1_TD_sig7_ovr_val),
   .SA0_TD_sig8_force_disable                        (SA0_TD_sig8_force_disable),
   .SA0_TD_sig8_threshold                     (SA0_TD_sig8_threshold),
   .SA0_TD_sig8_ovr_sel                       (SA0_TD_sig8_ovr_sel),
   .SA0_TD_sig8_ovr_val                       (SA0_TD_sig8_ovr_val),
   .SA1_TD_sig8_force_disable                        (SA1_TD_sig8_force_disable),
   .SA1_TD_sig8_threshold                     (SA1_TD_sig8_threshold),
   .SA1_TD_sig8_ovr_sel                       (SA1_TD_sig8_ovr_sel),
   .SA1_TD_sig8_ovr_val                       (SA1_TD_sig8_ovr_val),
   .SA0_TD_sig9_force_disable                        (SA0_TD_sig9_force_disable),
   .SA0_TD_sig9_threshold                     (SA0_TD_sig9_threshold),
   .SA0_TD_sig9_ovr_sel                       (SA0_TD_sig9_ovr_sel),
   .SA0_TD_sig9_ovr_val                       (SA0_TD_sig9_ovr_val),
   .SA1_TD_sig9_force_disable                        (SA1_TD_sig9_force_disable),
   .SA1_TD_sig9_threshold                     (SA1_TD_sig9_threshold),
   .SA1_TD_sig9_ovr_sel                       (SA1_TD_sig9_ovr_sel),
   .SA1_TD_sig9_ovr_val                       (SA1_TD_sig9_ovr_val),
   .SA0_TCP_sig0_force_disable                        (SA0_TCP_sig0_force_disable),
   .SA0_TCP_sig0_threshold                     (SA0_TCP_sig0_threshold),
   .SA0_TCP_sig0_ovr_sel                       (SA0_TCP_sig0_ovr_sel),
   .SA0_TCP_sig0_ovr_val                       (SA0_TCP_sig0_ovr_val),
   .SA1_TCP_sig0_force_disable                        (SA1_TCP_sig0_force_disable),
   .SA1_TCP_sig0_threshold                     (SA1_TCP_sig0_threshold),
   .SA1_TCP_sig0_ovr_sel                       (SA1_TCP_sig0_ovr_sel),
   .SA1_TCP_sig0_ovr_val                       (SA1_TCP_sig0_ovr_val),
   .SA0_TCP_sig1_force_disable                        (SA0_TCP_sig1_force_disable),
   .SA0_TCP_sig1_threshold                     (SA0_TCP_sig1_threshold),
   .SA0_TCP_sig1_ovr_sel                       (SA0_TCP_sig1_ovr_sel),
   .SA0_TCP_sig1_ovr_val                       (SA0_TCP_sig1_ovr_val),
   .SA1_TCP_sig1_force_disable                        (SA1_TCP_sig1_force_disable),
   .SA1_TCP_sig1_threshold                     (SA1_TCP_sig1_threshold),
   .SA1_TCP_sig1_ovr_sel                       (SA1_TCP_sig1_ovr_sel),
   .SA1_TCP_sig1_ovr_val                       (SA1_TCP_sig1_ovr_val),
   .SA0_TCP_sig2_force_disable                        (SA0_TCP_sig2_force_disable),
   .SA0_TCP_sig2_threshold                     (SA0_TCP_sig2_threshold),
   .SA0_TCP_sig2_ovr_sel                       (SA0_TCP_sig2_ovr_sel),
   .SA0_TCP_sig2_ovr_val                       (SA0_TCP_sig2_ovr_val),
   .SA1_TCP_sig2_force_disable                        (SA1_TCP_sig2_force_disable),
   .SA1_TCP_sig2_threshold                     (SA1_TCP_sig2_threshold),
   .SA1_TCP_sig2_ovr_sel                       (SA1_TCP_sig2_ovr_sel),
   .SA1_TCP_sig2_ovr_val                       (SA1_TCP_sig2_ovr_val),
   .SA0_TCP_sig3_force_disable                        (SA0_TCP_sig3_force_disable),
   .SA0_TCP_sig3_threshold                     (SA0_TCP_sig3_threshold),
   .SA0_TCP_sig3_ovr_sel                       (SA0_TCP_sig3_ovr_sel),
   .SA0_TCP_sig3_ovr_val                       (SA0_TCP_sig3_ovr_val),
   .SA1_TCP_sig3_force_disable                        (SA1_TCP_sig3_force_disable),
   .SA1_TCP_sig3_threshold                     (SA1_TCP_sig3_threshold),
   .SA1_TCP_sig3_ovr_sel                       (SA1_TCP_sig3_ovr_sel),
   .SA1_TCP_sig3_ovr_val                       (SA1_TCP_sig3_ovr_val),
   .SA0_TCP_sig4_force_disable                        (SA0_TCP_sig4_force_disable),
   .SA0_TCP_sig4_threshold                     (SA0_TCP_sig4_threshold),
   .SA0_TCP_sig4_ovr_sel                       (SA0_TCP_sig4_ovr_sel),
   .SA0_TCP_sig4_ovr_val                       (SA0_TCP_sig4_ovr_val),
   .SA1_TCP_sig4_force_disable                        (SA1_TCP_sig4_force_disable),
   .SA1_TCP_sig4_threshold                     (SA1_TCP_sig4_threshold),
   .SA1_TCP_sig4_ovr_sel                       (SA1_TCP_sig4_ovr_sel),
   .SA1_TCP_sig4_ovr_val                       (SA1_TCP_sig4_ovr_val),
   .SA0_SQ_sig0_force_disable                        (SA0_SQ_sig0_force_disable),
   .SA0_SQ_sig0_threshold                     (SA0_SQ_sig0_threshold),
   .SA0_SQ_sig0_ovr_sel                       (SA0_SQ_sig0_ovr_sel),
   .SA0_SQ_sig0_ovr_val                       (SA0_SQ_sig0_ovr_val),
   .SA1_SQ_sig0_force_disable                        (SA1_SQ_sig0_force_disable),
   .SA1_SQ_sig0_threshold                     (SA1_SQ_sig0_threshold),
   .SA1_SQ_sig0_ovr_sel                       (SA1_SQ_sig0_ovr_sel),
   .SA1_SQ_sig0_ovr_val                       (SA1_SQ_sig0_ovr_val),
   .SA0_SQ_sig1_force_disable                        (SA0_SQ_sig1_force_disable),
   .SA0_SQ_sig1_threshold                     (SA0_SQ_sig1_threshold),
   .SA0_SQ_sig1_ovr_sel                       (SA0_SQ_sig1_ovr_sel),
   .SA0_SQ_sig1_ovr_val                       (SA0_SQ_sig1_ovr_val),
   .SA1_SQ_sig1_force_disable                        (SA1_SQ_sig1_force_disable),
   .SA1_SQ_sig1_threshold                     (SA1_SQ_sig1_threshold),
   .SA1_SQ_sig1_ovr_sel                       (SA1_SQ_sig1_ovr_sel),
   .SA1_SQ_sig1_ovr_val                       (SA1_SQ_sig1_ovr_val),
   .SA0_SQ_sig2_force_disable                        (SA0_SQ_sig2_force_disable),
   .SA0_SQ_sig2_threshold                     (SA0_SQ_sig2_threshold),
   .SA0_SQ_sig2_ovr_sel                       (SA0_SQ_sig2_ovr_sel),
   .SA0_SQ_sig2_ovr_val                       (SA0_SQ_sig2_ovr_val),
   .SA1_SQ_sig2_force_disable                        (SA1_SQ_sig2_force_disable),
   .SA1_SQ_sig2_threshold                     (SA1_SQ_sig2_threshold),
   .SA1_SQ_sig2_ovr_sel                       (SA1_SQ_sig2_ovr_sel),
   .SA1_SQ_sig2_ovr_val                       (SA1_SQ_sig2_ovr_val),
   .SA0_SQ_sig3_force_disable                        (SA0_SQ_sig3_force_disable),
   .SA0_SQ_sig3_threshold                     (SA0_SQ_sig3_threshold),
   .SA0_SQ_sig3_ovr_sel                       (SA0_SQ_sig3_ovr_sel),
   .SA0_SQ_sig3_ovr_val                       (SA0_SQ_sig3_ovr_val),
   .SA1_SQ_sig3_force_disable                        (SA1_SQ_sig3_force_disable),
   .SA1_SQ_sig3_threshold                     (SA1_SQ_sig3_threshold),
   .SA1_SQ_sig3_ovr_sel                       (SA1_SQ_sig3_ovr_sel),
   .SA1_SQ_sig3_ovr_val                       (SA1_SQ_sig3_ovr_val),
   .SA0_SQ_sig4_force_disable                        (SA0_SQ_sig4_force_disable),
   .SA0_SQ_sig4_threshold                     (SA0_SQ_sig4_threshold),
   .SA0_SQ_sig4_ovr_sel                       (SA0_SQ_sig4_ovr_sel),
   .SA0_SQ_sig4_ovr_val                       (SA0_SQ_sig4_ovr_val),
   .SA1_SQ_sig4_force_disable                        (SA1_SQ_sig4_force_disable),
   .SA1_SQ_sig4_threshold                     (SA1_SQ_sig4_threshold),
   .SA1_SQ_sig4_ovr_sel                       (SA1_SQ_sig4_ovr_sel),
   .SA1_SQ_sig4_ovr_val                       (SA1_SQ_sig4_ovr_val),
   .SA0_SQ_sig5_force_disable                        (SA0_SQ_sig5_force_disable),
   .SA0_SQ_sig5_threshold                     (SA0_SQ_sig5_threshold),
   .SA0_SQ_sig5_ovr_sel                       (SA0_SQ_sig5_ovr_sel),
   .SA0_SQ_sig5_ovr_val                       (SA0_SQ_sig5_ovr_val),
   .SA1_SQ_sig5_force_disable                        (SA1_SQ_sig5_force_disable),
   .SA1_SQ_sig5_threshold                     (SA1_SQ_sig5_threshold),
   .SA1_SQ_sig5_ovr_sel                       (SA1_SQ_sig5_ovr_sel),
   .SA1_SQ_sig5_ovr_val                       (SA1_SQ_sig5_ovr_val),
   .SA0_LDS_sig0_force_disable                        (SA0_LDS_sig0_force_disable),
   .SA0_LDS_sig0_threshold                     (SA0_LDS_sig0_threshold),
   .SA0_LDS_sig0_ovr_sel                       (SA0_LDS_sig0_ovr_sel),
   .SA0_LDS_sig0_ovr_val                       (SA0_LDS_sig0_ovr_val),
   .SA1_LDS_sig0_force_disable                        (SA1_LDS_sig0_force_disable),
   .SA1_LDS_sig0_threshold                     (SA1_LDS_sig0_threshold),
   .SA1_LDS_sig0_ovr_sel                       (SA1_LDS_sig0_ovr_sel),
   .SA1_LDS_sig0_ovr_val                       (SA1_LDS_sig0_ovr_val),
   .SA0_LDS_sig1_force_disable                        (SA0_LDS_sig1_force_disable),
   .SA0_LDS_sig1_threshold                     (SA0_LDS_sig1_threshold),
   .SA0_LDS_sig1_ovr_sel                       (SA0_LDS_sig1_ovr_sel),
   .SA0_LDS_sig1_ovr_val                       (SA0_LDS_sig1_ovr_val),
   .SA1_LDS_sig1_force_disable                        (SA1_LDS_sig1_force_disable),
   .SA1_LDS_sig1_threshold                     (SA1_LDS_sig1_threshold),
   .SA1_LDS_sig1_ovr_sel                       (SA1_LDS_sig1_ovr_sel),
   .SA1_LDS_sig1_ovr_val                       (SA1_LDS_sig1_ovr_val),
   .SA0_LDS_sig2_force_disable                        (SA0_LDS_sig2_force_disable),
   .SA0_LDS_sig2_threshold                     (SA0_LDS_sig2_threshold),
   .SA0_LDS_sig2_ovr_sel                       (SA0_LDS_sig2_ovr_sel),
   .SA0_LDS_sig2_ovr_val                       (SA0_LDS_sig2_ovr_val),
   .SA1_LDS_sig2_force_disable                        (SA1_LDS_sig2_force_disable),
   .SA1_LDS_sig2_threshold                     (SA1_LDS_sig2_threshold),
   .SA1_LDS_sig2_ovr_sel                       (SA1_LDS_sig2_ovr_sel),
   .SA1_LDS_sig2_ovr_val                       (SA1_LDS_sig2_ovr_val),
   .SA0_LDS_sig3_force_disable                        (SA0_LDS_sig3_force_disable),
   .SA0_LDS_sig3_threshold                     (SA0_LDS_sig3_threshold),
   .SA0_LDS_sig3_ovr_sel                       (SA0_LDS_sig3_ovr_sel),
   .SA0_LDS_sig3_ovr_val                       (SA0_LDS_sig3_ovr_val),
   .SA1_LDS_sig3_force_disable                        (SA1_LDS_sig3_force_disable),
   .SA1_LDS_sig3_threshold                     (SA1_LDS_sig3_threshold),
   .SA1_LDS_sig3_ovr_sel                       (SA1_LDS_sig3_ovr_sel),
   .SA1_LDS_sig3_ovr_val                       (SA1_LDS_sig3_ovr_val),
   .SA0_BCI_sig0_force_disable                        (SA0_BCI_sig0_force_disable),
   .SA0_BCI_sig0_threshold                     (SA0_BCI_sig0_threshold),
   .SA0_BCI_sig0_ovr_sel                       (SA0_BCI_sig0_ovr_sel),
   .SA0_BCI_sig0_ovr_val                       (SA0_BCI_sig0_ovr_val),
   .SA1_BCI_sig0_force_disable                        (SA1_BCI_sig0_force_disable),
   .SA1_BCI_sig0_threshold                     (SA1_BCI_sig0_threshold),
   .SA1_BCI_sig0_ovr_sel                       (SA1_BCI_sig0_ovr_sel),
   .SA1_BCI_sig0_ovr_val                       (SA1_BCI_sig0_ovr_val),
   .SA0_BCI_sig1_force_disable                        (SA0_BCI_sig1_force_disable),
   .SA0_BCI_sig1_threshold                     (SA0_BCI_sig1_threshold),
   .SA0_BCI_sig1_ovr_sel                       (SA0_BCI_sig1_ovr_sel),
   .SA0_BCI_sig1_ovr_val                       (SA0_BCI_sig1_ovr_val),
   .SA1_BCI_sig1_force_disable                        (SA1_BCI_sig1_force_disable),
   .SA1_BCI_sig1_threshold                     (SA1_BCI_sig1_threshold),
   .SA1_BCI_sig1_ovr_sel                       (SA1_BCI_sig1_ovr_sel),
   .SA1_BCI_sig1_ovr_val                       (SA1_BCI_sig1_ovr_val),
   .SA0_CB_sig0_force_disable                        (SA0_CB_sig0_force_disable),
   .SA0_CB_sig0_threshold                     (SA0_CB_sig0_threshold),
   .SA0_CB_sig0_ovr_sel                       (SA0_CB_sig0_ovr_sel),
   .SA0_CB_sig0_ovr_val                       (SA0_CB_sig0_ovr_val),
   .SA1_CB_sig0_force_disable                        (SA1_CB_sig0_force_disable),
   .SA1_CB_sig0_threshold                     (SA1_CB_sig0_threshold),
   .SA1_CB_sig0_ovr_sel                       (SA1_CB_sig0_ovr_sel),
   .SA1_CB_sig0_ovr_val                       (SA1_CB_sig0_ovr_val),
   .SA0_CB_sig1_force_disable                        (SA0_CB_sig1_force_disable),
   .SA0_CB_sig1_threshold                     (SA0_CB_sig1_threshold),
   .SA0_CB_sig1_ovr_sel                       (SA0_CB_sig1_ovr_sel),
   .SA0_CB_sig1_ovr_val                       (SA0_CB_sig1_ovr_val),
   .SA1_CB_sig1_force_disable                        (SA1_CB_sig1_force_disable),
   .SA1_CB_sig1_threshold                     (SA1_CB_sig1_threshold),
   .SA1_CB_sig1_ovr_sel                       (SA1_CB_sig1_ovr_sel),
   .SA1_CB_sig1_ovr_val                       (SA1_CB_sig1_ovr_val),
   .SA0_CB_sig2_force_disable                        (SA0_CB_sig2_force_disable),
   .SA0_CB_sig2_threshold                     (SA0_CB_sig2_threshold),
   .SA0_CB_sig2_ovr_sel                       (SA0_CB_sig2_ovr_sel),
   .SA0_CB_sig2_ovr_val                       (SA0_CB_sig2_ovr_val),
   .SA1_CB_sig2_force_disable                        (SA1_CB_sig2_force_disable),
   .SA1_CB_sig2_threshold                     (SA1_CB_sig2_threshold),
   .SA1_CB_sig2_ovr_sel                       (SA1_CB_sig2_ovr_sel),
   .SA1_CB_sig2_ovr_val                       (SA1_CB_sig2_ovr_val),
   .SA0_CB_sig3_force_disable                        (SA0_CB_sig3_force_disable),
   .SA0_CB_sig3_threshold                     (SA0_CB_sig3_threshold),
   .SA0_CB_sig3_ovr_sel                       (SA0_CB_sig3_ovr_sel),
   .SA0_CB_sig3_ovr_val                       (SA0_CB_sig3_ovr_val),
   .SA1_CB_sig3_force_disable                        (SA1_CB_sig3_force_disable),
   .SA1_CB_sig3_threshold                     (SA1_CB_sig3_threshold),
   .SA1_CB_sig3_ovr_sel                       (SA1_CB_sig3_ovr_sel),
   .SA1_CB_sig3_ovr_val                       (SA1_CB_sig3_ovr_val),
   .SA0_DB_sig0_force_disable                        (SA0_DB_sig0_force_disable),
   .SA0_DB_sig0_threshold                     (SA0_DB_sig0_threshold),
   .SA0_DB_sig0_ovr_sel                       (SA0_DB_sig0_ovr_sel),
   .SA0_DB_sig0_ovr_val                       (SA0_DB_sig0_ovr_val),
   .SA1_DB_sig0_force_disable                        (SA1_DB_sig0_force_disable),
   .SA1_DB_sig0_threshold                     (SA1_DB_sig0_threshold),
   .SA1_DB_sig0_ovr_sel                       (SA1_DB_sig0_ovr_sel),
   .SA1_DB_sig0_ovr_val                       (SA1_DB_sig0_ovr_val),
   .SA0_DB_sig1_force_disable                        (SA0_DB_sig1_force_disable),
   .SA0_DB_sig1_threshold                     (SA0_DB_sig1_threshold),
   .SA0_DB_sig1_ovr_sel                       (SA0_DB_sig1_ovr_sel),
   .SA0_DB_sig1_ovr_val                       (SA0_DB_sig1_ovr_val),
   .SA1_DB_sig1_force_disable                        (SA1_DB_sig1_force_disable),
   .SA1_DB_sig1_threshold                     (SA1_DB_sig1_threshold),
   .SA1_DB_sig1_ovr_sel                       (SA1_DB_sig1_ovr_sel),
   .SA1_DB_sig1_ovr_val                       (SA1_DB_sig1_ovr_val),
   .SA0_DB_sig2_force_disable                        (SA0_DB_sig2_force_disable),
   .SA0_DB_sig2_threshold                     (SA0_DB_sig2_threshold),
   .SA0_DB_sig2_ovr_sel                       (SA0_DB_sig2_ovr_sel),
   .SA0_DB_sig2_ovr_val                       (SA0_DB_sig2_ovr_val),
   .SA1_DB_sig2_force_disable                        (SA1_DB_sig2_force_disable),
   .SA1_DB_sig2_threshold                     (SA1_DB_sig2_threshold),
   .SA1_DB_sig2_ovr_sel                       (SA1_DB_sig2_ovr_sel),
   .SA1_DB_sig2_ovr_val                       (SA1_DB_sig2_ovr_val),
   .SA0_DB_sig3_force_disable                        (SA0_DB_sig3_force_disable),
   .SA0_DB_sig3_threshold                     (SA0_DB_sig3_threshold),
   .SA0_DB_sig3_ovr_sel                       (SA0_DB_sig3_ovr_sel),
   .SA0_DB_sig3_ovr_val                       (SA0_DB_sig3_ovr_val),
   .SA1_DB_sig3_force_disable                        (SA1_DB_sig3_force_disable),
   .SA1_DB_sig3_threshold                     (SA1_DB_sig3_threshold),
   .SA1_DB_sig3_ovr_sel                       (SA1_DB_sig3_ovr_sel),
   .SA1_DB_sig3_ovr_val                       (SA1_DB_sig3_ovr_val),
   .SA0_PA_sig0_force_disable                        (SA0_PA_sig0_force_disable),
   .SA0_PA_sig0_threshold                     (SA0_PA_sig0_threshold),
   .SA0_PA_sig0_ovr_sel                       (SA0_PA_sig0_ovr_sel),
   .SA0_PA_sig0_ovr_val                       (SA0_PA_sig0_ovr_val),
   .SA1_PA_sig0_force_disable                        (SA1_PA_sig0_force_disable),
   .SA1_PA_sig0_threshold                     (SA1_PA_sig0_threshold),
   .SA1_PA_sig0_ovr_sel                       (SA1_PA_sig0_ovr_sel),
   .SA1_PA_sig0_ovr_val                       (SA1_PA_sig0_ovr_val),
   .SA0_PA_sig1_force_disable                        (SA0_PA_sig1_force_disable),
   .SA0_PA_sig1_threshold                     (SA0_PA_sig1_threshold),
   .SA0_PA_sig1_ovr_sel                       (SA0_PA_sig1_ovr_sel),
   .SA0_PA_sig1_ovr_val                       (SA0_PA_sig1_ovr_val),
   .SA1_PA_sig1_force_disable                        (SA1_PA_sig1_force_disable),
   .SA1_PA_sig1_threshold                     (SA1_PA_sig1_threshold),
   .SA1_PA_sig1_ovr_sel                       (SA1_PA_sig1_ovr_sel),
   .SA1_PA_sig1_ovr_val                       (SA1_PA_sig1_ovr_val),
   .SA0_RMI_sig0_force_disable                        (SA0_RMI_sig0_force_disable),
   .SA0_RMI_sig0_threshold                     (SA0_RMI_sig0_threshold),
   .SA0_RMI_sig0_ovr_sel                       (SA0_RMI_sig0_ovr_sel),
   .SA0_RMI_sig0_ovr_val                       (SA0_RMI_sig0_ovr_val),
   .SA1_RMI_sig0_force_disable                        (SA1_RMI_sig0_force_disable),
   .SA1_RMI_sig0_threshold                     (SA1_RMI_sig0_threshold),
   .SA1_RMI_sig0_ovr_sel                       (SA1_RMI_sig0_ovr_sel),
   .SA1_RMI_sig0_ovr_val                       (SA1_RMI_sig0_ovr_val),
   .SA0_SC_sig0_force_disable                        (SA0_SC_sig0_force_disable),
   .SA0_SC_sig0_threshold                     (SA0_SC_sig0_threshold),
   .SA0_SC_sig0_ovr_sel                       (SA0_SC_sig0_ovr_sel),
   .SA0_SC_sig0_ovr_val                       (SA0_SC_sig0_ovr_val),
   .SA1_SC_sig0_force_disable                        (SA1_SC_sig0_force_disable),
   .SA1_SC_sig0_threshold                     (SA1_SC_sig0_threshold),
   .SA1_SC_sig0_ovr_sel                       (SA1_SC_sig0_ovr_sel),
   .SA1_SC_sig0_ovr_val                       (SA1_SC_sig0_ovr_val),
   .SA0_SX_sig0_force_disable                        (SA0_SX_sig0_force_disable),
   .SA0_SX_sig0_threshold                     (SA0_SX_sig0_threshold),
   .SA0_SX_sig0_ovr_sel                       (SA0_SX_sig0_ovr_sel),
   .SA0_SX_sig0_ovr_val                       (SA0_SX_sig0_ovr_val),
   .SA1_SX_sig0_force_disable                        (SA1_SX_sig0_force_disable),
   .SA1_SX_sig0_threshold                     (SA1_SX_sig0_threshold),
   .SA1_SX_sig0_ovr_sel                       (SA1_SX_sig0_ovr_sel),
   .SA1_SX_sig0_ovr_val                       (SA1_SX_sig0_ovr_val),
   .SA0_SXRB_sig0_force_disable                        (SA0_SXRB_sig0_force_disable),
   .SA0_SXRB_sig0_threshold                     (SA0_SXRB_sig0_threshold),
   .SA0_SXRB_sig0_ovr_sel                       (SA0_SXRB_sig0_ovr_sel),
   .SA0_SXRB_sig0_ovr_val                       (SA0_SXRB_sig0_ovr_val),
   .SA1_SXRB_sig0_force_disable                        (SA1_SXRB_sig0_force_disable),
   .SA1_SXRB_sig0_threshold                     (SA1_SXRB_sig0_threshold),
   .SA1_SXRB_sig0_ovr_sel                       (SA1_SXRB_sig0_ovr_sel),
   .SA1_SXRB_sig0_ovr_val                       (SA1_SXRB_sig0_ovr_val),
   .SA0_UTCL1_sig0_force_disable                        (SA0_UTCL1_sig0_force_disable),
   .SA0_UTCL1_sig0_threshold                     (SA0_UTCL1_sig0_threshold),
   .SA0_UTCL1_sig0_ovr_sel                       (SA0_UTCL1_sig0_ovr_sel),
   .SA0_UTCL1_sig0_ovr_val                       (SA0_UTCL1_sig0_ovr_val),
   .SA1_UTCL1_sig0_force_disable                        (SA1_UTCL1_sig0_force_disable),
   .SA1_UTCL1_sig0_threshold                     (SA1_UTCL1_sig0_threshold),
   .SA1_UTCL1_sig0_ovr_sel                       (SA1_UTCL1_sig0_ovr_sel),
   .SA1_UTCL1_sig0_ovr_val                       (SA1_UTCL1_sig0_ovr_val),
   .SA0_CU_sig0_force_disable                        (SA0_CU_sig0_force_disable),
   .SA0_CU_sig0_threshold                     (SA0_CU_sig0_threshold),
   .SA0_CU_sig0_ovr_sel                       (SA0_CU_sig0_ovr_sel),
   .SA0_CU_sig0_ovr_val                       (SA0_CU_sig0_ovr_val),
   .SA1_CU_sig0_force_disable                        (SA1_CU_sig0_force_disable),
   .SA1_CU_sig0_threshold                     (SA1_CU_sig0_threshold),
   .SA1_CU_sig0_ovr_sel                       (SA1_CU_sig0_ovr_sel),
   .SA1_CU_sig0_ovr_val                       (SA1_CU_sig0_ovr_val),
   .SPI_sig0_force_disable                        (SPI_sig0_force_disable),
   .SPI_sig0_threshold                     (SPI_sig0_threshold),
   .SPI_sig0_ovr_sel                       (SPI_sig0_ovr_sel),
   .SPI_sig0_ovr_val                       (SPI_sig0_ovr_val),
   .SPI_sig1_force_disable                        (SPI_sig1_force_disable),
   .SPI_sig1_threshold                     (SPI_sig1_threshold),
   .SPI_sig1_ovr_sel                       (SPI_sig1_ovr_sel),
   .SPI_sig1_ovr_val                       (SPI_sig1_ovr_val),
   .SPI_sig2_force_disable                        (SPI_sig2_force_disable),
   .SPI_sig2_threshold                     (SPI_sig2_threshold),
   .SPI_sig2_ovr_sel                       (SPI_sig2_ovr_sel),
   .SPI_sig2_ovr_val                       (SPI_sig2_ovr_val),
   .SPI_sig3_force_disable                        (SPI_sig3_force_disable),
   .SPI_sig3_threshold                     (SPI_sig3_threshold),
   .SPI_sig3_ovr_sel                       (SPI_sig3_ovr_sel),
   .SPI_sig3_ovr_val                       (SPI_sig3_ovr_val),
   .SPI_sig4_force_disable                        (SPI_sig4_force_disable),
   .SPI_sig4_threshold                     (SPI_sig4_threshold),
   .SPI_sig4_ovr_sel                       (SPI_sig4_ovr_sel),
   .SPI_sig4_ovr_val                       (SPI_sig4_ovr_val),
   .SPI_sig5_force_disable                        (SPI_sig5_force_disable),
   .SPI_sig5_threshold                     (SPI_sig5_threshold),
   .SPI_sig5_ovr_sel                       (SPI_sig5_ovr_sel),
   .SPI_sig5_ovr_val                       (SPI_sig5_ovr_val),
   .PC_sig0_force_disable                        (PC_sig0_force_disable),
   .PC_sig0_threshold                     (PC_sig0_threshold),
   .PC_sig0_ovr_sel                       (PC_sig0_ovr_sel),
   .PC_sig0_ovr_val                       (PC_sig0_ovr_val),
   .reg_read_valid                       (cac_read_valid),
   .reg_read_data                        (cac_read_data)

 );


endmodule // se_cac_rbiu
