/*---------------------------------------------------------------------*/
/*               Copyright(c) Synopsys, Inc.                           */
/*     All Rights reserved - Unpublished -rights reserved under        */
/*     the Copyright laws of the United States of America.             */
/*                                                                     */
/*  U.S. Patents: 7,093,156 B1 and 7,406,620 B2 (and more pending).    */
/*                                                                     */
/*  This file includes the Confidential information of Synopsys, Inc.. */
/*  The receiver of this Confidential Information shall not disclose   */
/*  it to any third party and shall protect its confidentiality by     */
/*  using the same degree of care, but not less then a reasonable      */
/*  degree of care, as the receiver uses to protect receiver's own     */
/*  Confidential Information.                                          */
/*  Licensee acknowledges and agrees that all output generated for     */
/*  Licensee by Synopsys, Inc. as described in the pertinent Program   */
/*  Schedule(s), or generated by Licensee through use of any Compiler  */
/*  licensed hereunder contains information that complies with the     */
/*  Virtual Component Identification Physical Tagging Standard (VCID)  */
/*  as maintained by the Virtual Socket Interface Alliance (VSIA).     */
/*  Such information may be expressed in GDSII Layer 63 or other such  */
/*  layer designated by the VSIA, hardware definition languages, or    */
/*  other formats.  Licensee is not authorized to alter or change any  */
/*  such information.                                                  */
/*---------------------------------------------------------------------*/
/*                                                                     */
/*  Built for linux64 and running on linux64.                          */
/*                                                                     */
/*  Software           : Rev: M-2017.03                                */
/*  Library Format     : Rev: 1.05.00                                  */
/*  Compiler Name      : vl00x000vpnnstsrv000sa31                      */
/*  Platform           : Linux2.6.32-573.el6.x86_64                    */
/*                     : #1 SMP Wed Jul 1 18:23:37 EDT 2015x86_64      */
/*  Date of Generation : Wed Oct 11 01:17:02 EDT 2017                  */
/*                                                                     */
/*---------------------------------------------------------------------*/

`resetall
// T I M E S C A L E
`ifndef SMS_NO_TIMESCALE
    `timescale 1ns/1ps
`endif

module smsg_gc13_rp_jpc   (
                            select_jpc_wir,
                            select_jpc_wdr,
                            tck,
                            tdi,
                            resetn,
                            select_sms_wir,
                            select_sms_wdr,
                            shift_dr,
                            capture_dr,
                            update_dr,
                            ser_data,
                            sms_wso,
                            sms_wsi,
                            sms_shiftwr,
                            sms_updatewr,
                            sms_capturewr,
                            tdi_sfp,
                            test_mode,
                            instr,
                            shiftdr,
                            updatedr,
                            capturedr,
                            updatewir_nr,
                            dreg_so_sfp,
                            sms_selectwir,
                            so_sfp,
                            selectwir_sfp,
                            capturewr_sfp,
                            shiftwr_sfp,
                            updatewr_sfp
                            );


input  select_jpc_wir;
input  select_jpc_wdr;
input  tck;
input  tdi;
input  resetn;
input  select_sms_wir;
input  select_sms_wdr;
input  shift_dr;
input  capture_dr;
input  update_dr;
output  ser_data;
input  sms_wso;
output  sms_wsi;
output  sms_shiftwr;
output  sms_updatewr;
output  sms_capturewr;
output  tdi_sfp;
output  test_mode;
output  [5:0] instr;
output  shiftdr;
output  updatedr;
output  capturedr;
output  updatewir_nr;
input  dreg_so_sfp;
output  sms_selectwir;
input  so_sfp;
input  selectwir_sfp;
input  capturewr_sfp;
input  shiftwr_sfp;
input  updatewr_sfp;



parameter SMS_SEL = 6'd33;
parameter STATUS_SEL = 6'd9;
parameter BIST_RUN = 6'd17;
parameter BISR_RUN = 6'd19;
parameter RBOX_RST = 6'd36;
parameter RBOX_SEL = 6'd37;
parameter RBOX_COMPARE = 6'd38;
parameter BR_SEL = 6'd42;
parameter FLOAD_RUN = 6'd48;
parameter BIHR_RUN = 6'd51;

// Converter section
wire sms_en;
reg sms_en_r;
wire sfp_on;
wire wsi_i;

// JPC section
////triggered signals
reg ser_data_r;
wire ser_data_nxt;
wire tdi_sfp;
/////triggered signals
reg select_jpc_wir_r;
reg select_jpc_wdr_r;

reg  [5:0] wir_nr;
wire [5:0] wir_nxt;
reg  [5:0] scanwir_r;
wire [5:0] scanwir_nxt;

reg  ins_bypass;
reg  bypass_r;
wire bypass_nxt;
wire capturedr_i;
wire shiftdr_i;
wire updatedr_i;
reg updatewir_nr;
wire updatewir_nxt;
wire wir_out;
wire jpc_sfp_so;
reg   sms_num_nr;
wire  sms_num_nxt;
reg   sms_num_scan_r;
wire  sms_num_scan_nxt;
wire ins_sel_sms;
assign wir_out = scanwir_r[5];
assign tdi_sfp = tdi;
assign test_mode = !ins_bypass;
assign instr = wir_nr;
assign updatewir_nxt = update_dr & select_jpc_wir_r;
assign capturedr = capturedr_i;
assign shiftdr = shiftdr_i;
assign updatedr = updatedr_i;
assign capturedr_i = capture_dr & select_jpc_wdr_r;
assign shiftdr_i = shift_dr & select_jpc_wdr_r;
assign updatedr_i = update_dr & select_jpc_wdr_r;
assign bypass_nxt = (ins_bypass & shiftdr_i) ? tdi : bypass_r;
assign scanwir_nxt = (select_jpc_wir_r & capture_dr) ? wir_nr :
                     (select_jpc_wir_r & shift_dr) ? { scanwir_r[4:0],tdi} : scanwir_r;
assign wir_nxt = (select_jpc_wir_r & update_dr) ? scanwir_r : wir_nr;

assign jpc_sfp_so = select_jpc_wir_r ? wir_out : ins_bypass ? bypass_r :
                    ins_sel_sms ? sms_num_scan_r :
                    dreg_so_sfp;

assign ins_sel_sms = (wir_nr == SMS_SEL);
assign sms_num_nxt = (ins_sel_sms & updatedr_i) ? sms_num_scan_r : sms_num_nr;
assign sms_num_scan_nxt = (ins_sel_sms & capturedr_i) ? sms_num_nr : (ins_sel_sms & shiftdr_i) ? tdi : sms_num_scan_r;



//Procedural assignments
always @(wir_nr)
  begin
    case (wir_nr)
      SMS_SEL,
      STATUS_SEL,
      BIST_RUN,
      BISR_RUN,
      RBOX_RST,
      RBOX_SEL,
      RBOX_COMPARE,
      BR_SEL,
      FLOAD_RUN,
      BIHR_RUN
        : ins_bypass = 1'b0;
      default    : ins_bypass = 1'b1;
    endcase
    
  end


always @(posedge tck or negedge resetn)
  if (!resetn)
    begin
      sms_num_scan_r          <=  {1{1'b0}};
      bypass_r                <=  1'b0;
      scanwir_r               <=  6'd0;
      select_jpc_wir_r        <=  1'b0;
      select_jpc_wdr_r        <=  1'b0;
    end
  else
    begin
      sms_num_scan_r          <=  sms_num_scan_nxt;
      bypass_r                <=  bypass_nxt;
      scanwir_r               <=  scanwir_nxt;
      select_jpc_wir_r        <=  select_jpc_wir;
      select_jpc_wdr_r        <=  select_jpc_wdr;
    end

//negedge synchronization
always @(negedge tck or negedge resetn)
  if (!resetn)
    begin
      sms_num_nr                <=  1'b1;
      wir_nr                    <=  6'd0;
      updatewir_nr              <=  1'b0;
    end
  else
    begin
      sms_num_nr                <=  sms_num_nxt;
      wir_nr                    <=  wir_nxt;
      updatewir_nr              <=  updatewir_nxt;
    end





// End of JPC section


//Start of converter section
assign sms_en = select_sms_wir | select_sms_wdr;
assign ser_data_nxt = ( shift_dr & (select_jpc_wir_r | select_jpc_wdr_r |
               select_sms_wir | select_sms_wdr) ) ? ((select_jpc_wir_r | select_jpc_wdr_r) ? jpc_sfp_so : sms_wso) : ser_data_r;

assign ser_data = ser_data_r;
assign  sfp_on = sms_num_nr;
assign  wsi_i = sfp_on ? so_sfp : tdi;
assign  sms_selectwir = sfp_on ? selectwir_sfp : select_sms_wir; // to sms


// posedge synchronization
always @(posedge tck or negedge resetn)
  if (!resetn)
    begin
      ser_data_r  <=  1'b0;
      sms_en_r    <=  1'b0;
    end
  else
    begin
      ser_data_r  <=  ser_data_nxt;
      sms_en_r    <=  sms_en;
    end


// IEEE1500 control signals to selected SMS
assign sms_wsi = wsi_i;
assign sms_capturewr = sfp_on ? capturewr_sfp : (sms_en & capture_dr);
assign sms_shiftwr   = sfp_on ? shiftwr_sfp : (sms_en & shift_dr);
assign sms_updatewr  = sfp_on ? updatewr_sfp : (sms_en_r & update_dr);

endmodule

