/*---------------------------------------------------------------------*/
/*               Copyright(c) Synopsys, Inc.                           */
/*     All Rights reserved - Unpublished -rights reserved under        */
/*     the Copyright laws of the United States of America.             */
/*                                                                     */
/*  U.S. Patents: 7,093,156 B1 and 7,406,620 B2 (and more pending).    */
/*                                                                     */
/*  This file includes the Confidential information of Synopsys, Inc.. */
/*  The receiver of this Confidential Information shall not disclose   */
/*  it to any third party and shall protect its confidentiality by     */
/*  using the same degree of care, but not less then a reasonable      */
/*  degree of care, as the receiver uses to protect receiver's own     */
/*  Confidential Information.                                          */
/*  Licensee acknowledges and agrees that all output generated for     */
/*  Licensee by Synopsys, Inc. as described in the pertinent Program   */
/*  Schedule(s), or generated by Licensee through use of any Compiler  */
/*  licensed hereunder contains information that complies with the     */
/*  Virtual Component Identification Physical Tagging Standard (VCID)  */
/*  as maintained by the Virtual Socket Interface Alliance (VSIA).     */
/*  Such information may be expressed in GDSII Layer 63 or other such  */
/*  layer designated by the VSIA, hardware definition languages, or    */
/*  other formats.  Licensee is not authorized to alter or change any  */
/*  such information.                                                  */
/*---------------------------------------------------------------------*/
/*                                                                     */
/*  Built for linux64 and running on linux64.                          */
/*                                                                     */
/*  Software           : Rev: M-2017.03                                */
/*  Library Format     : Rev: 1.05.00                                  */
/*  Compiler Name      : vl00x000vpnnstsrv000sa31                      */
/*  Platform           : Linux2.6.32-573.el6.x86_64                    */
/*                     : #1 SMP Wed Jul 1 18:23:37 EDT 2015x86_64      */
/*  Date of Generation : Fri Dec 01 14:01:01 EST 2017                  */
/*                                                                     */
/*---------------------------------------------------------------------*/
`resetall
// T I M E S C A L E ===============================================================================
`ifndef SMS_NO_TIMESCALE
    `timescale 1ns/1ps
`endif
module smsg_gc14_rp_mux (
//inputs
                            clk_sfbp,
                            rst_sfbp,
                            wrstn,
                            sfbp_wsi,
                            instr,
                            capturedr,
                            shiftdr,
                            updatedr,
                            update_puls,
                            sms_shift_en,
                            test_mode,
                            select_master,
                            data2sms,
                            shift_instr,
                            instr_ready,
                            update,
                            shift_data,
                            capture_data,
                            sms_fail,
                            dummy_shift2sms_chain,
                            test_contr_ready,
                            signature_in,
                            signature_en,
                            start_compress,
                            shift_rscr_id,
                            data_from_sms_p1500,
                            overflow,
                            data2sms_compr,
                            data2sms_sh_compr,
                            compare_err,
                            cycling,
                            data_sh_en_drv,
                            byte_in_ef,
                            addr_lsb,
                            smart,
                            fast_mode,
                            bist_run,
                            bisr_run,
                            bihr_run,
//outputs
                            ef_sign_read,
                            last_dummy_loop,
                            mux_data_msb_nxt,
                            smart_int,
                            fast_mode_int,
                            bist_run_int,
                            bisr_run_int,
                            bihr_run_int,
                            data_reg_out,
                            data2sms_p1500,
                            wir2sms_p1500,
                            capt2sms_p1500,
                            shift2sms_p1500,
                            update2sms_p1500,
                            output_data,
                            efuse_serial_data,
                            clean_status,
                            rscr_id_err,                            
                            sfbp_ready,
                            sfbp_fail
);

input clk_sfbp;
input rst_sfbp;
input wrstn;
input sfbp_wsi;
input [5:0]instr;
input capturedr;
input shiftdr;
input updatedr;
input update_puls;
input test_mode;
input [1:0]select_master;
input data2sms;
input shift_instr;
input instr_ready;
input update;
input shift_data;
input capture_data;
input sms_fail;
input dummy_shift2sms_chain;
input test_contr_ready;
input signature_in;
input signature_en;
input start_compress;
input shift_rscr_id;
input data_from_sms_p1500;
input overflow;
input data2sms_compr;
input data2sms_sh_compr;
input compare_err;
input cycling;
input data_sh_en_drv;
input [7:0] byte_in_ef;
input [2:0]addr_lsb;
input smart;
input fast_mode;
input bist_run;
input bisr_run;
input bihr_run;
input sms_shift_en;
input last_dummy_loop;
output ef_sign_read;
output  mux_data_msb_nxt;
output smart_int;
output fast_mode_int;
output bist_run_int;
output bisr_run_int;
output bihr_run_int;
output data_reg_out;
output data2sms_p1500;
output wir2sms_p1500;
output capt2sms_p1500;
output shift2sms_p1500;
output update2sms_p1500;
output output_data;
output efuse_serial_data;
output clean_status;
output rscr_id_err;
output sfbp_ready;
output sfbp_fail;

//Parameters
parameter STATUS_SEL    = 6'd9;
parameter BR_SEL        = 6'd42;
parameter RBOX_RST      = 6'd36;
parameter RBOX_SEL      = 6'd37;
parameter RBOX_COMPARE  = 6'd38;
parameter BIST_RUN      = 6'd17;
parameter BISR_RUN      = 6'd19;
parameter FLOAD_RUN     = 6'd48;
parameter BIHR_RUN      = 6'd51;

//Internal variables
reg [143:0]mux_data_r,mux_data_nxt;
reg output_data;
reg data_reg_out;
reg [5:0]status_r,status_nxt;
wire clean_status, clean_status_i;
reg exec_flag_r, exec_flag_nxt;
reg ready_del_r;
reg data2sms_p1500_nr,data2sms_p1500_nxt;
reg data_from_sms_nr,data_from_sms_r;
wire data_from_sms_neg_nxt;
reg start_compress_nr;
reg wir2sms_p1500_nr,wir2sms_p1500_nxt;
reg wir2sms_dis_r;
reg shift2sms_p1500_nr,shift2sms_p1500_nxt;
reg capture_data_nr,capture_data_nxt;
reg update2sms_p1500_r,update2sms_p1500_nxt;
reg sfp_fail;
reg [4:0]br_sh_r,br_sh_nxt;
reg [4:0]br_upd_nr,br_upd_nxt;
reg serin_data_ef;
reg [3:0]rscr_id_r;
wire [3:0]rscr_id_nxt;
wire ef_sign_read;
assign ef_sign_read          = ((instr == RBOX_RST) | bihr_run_int ) & !cycling & (select_master == 2'b01);
assign mux_data_msb_nxt      = mux_data_nxt[143];
// combinational loop breaking
assign data_from_sms_neg_nxt = shift2sms_p1500_nr ? data_from_sms_r : data_from_sms_nr; 
assign wir2sms_p1500         = wir2sms_p1500_nr;
assign shift2sms_p1500       = shift2sms_p1500_nr;
assign update2sms_p1500      = update2sms_p1500_r;
assign data2sms_p1500        = start_compress_nr ? data_from_sms_nr : data2sms_p1500_nr;
assign capt2sms_p1500        = capture_data_nr;
assign clean_status          = clean_status_i;
assign clean_status_i        = (instr != STATUS_SEL) & update_puls;
assign sfbp_ready            = test_contr_ready;
assign sfbp_fail             = sfp_fail;
assign smart_int          = test_mode ? br_upd_nr[4] : smart;
assign fast_mode_int          = test_mode ? br_upd_nr[3] : fast_mode;
assign bist_run_int          = test_mode ? br_upd_nr[2] : bist_run;
assign bisr_run_int          = test_mode ? br_upd_nr[1] : bisr_run;
assign bihr_run_int          = test_mode ? br_upd_nr[0] : bihr_run;
assign efuse_serial_data     = serin_data_ef;
assign rscr_id_err           = (rscr_id_r != 4'd5);
assign rscr_id_nxt           = update ? 4'd5 : 
                               (!start_compress_nr & sms_shift_en & data2sms_sh_compr | shift_rscr_id) ?
                               {rscr_id_r[2:0],data_from_sms_p1500} : rscr_id_r;

  

//p1500 output multiplexer
always @ (instr or mux_data_r or br_sh_r or status_r
          )
  begin
    case(instr)
      RBOX_SEL        : data_reg_out = mux_data_r[143];
      BR_SEL          : data_reg_out = br_sh_r[4];
      default         : data_reg_out = status_r[5];
    endcase
  end


//Data output control
always @ (mux_data_r)
  output_data = mux_data_r[143];

//Byte-to-bit multiplexer
always @ (addr_lsb or byte_in_ef)
  begin
    case(addr_lsb)
      3'd0    : serin_data_ef = byte_in_ef[0];
      3'd1    : serin_data_ef = byte_in_ef[1];
      3'd2    : serin_data_ef = byte_in_ef[2];
      3'd3    : serin_data_ef = byte_in_ef[3];
      3'd4    : serin_data_ef = byte_in_ef[4];
      3'd5    : serin_data_ef = byte_in_ef[5];
      3'd6    : serin_data_ef = byte_in_ef[6];
      default : serin_data_ef = byte_in_ef[7];
    endcase
  end

//Status register control
always @ (instr or capturedr or shiftdr or sfbp_wsi or status_r or update_puls or exec_flag_r or ready_del_r or clean_status_i
          or sfp_fail or mux_data_r or test_contr_ready 
          or overflow
          )
  begin
    case(instr)
      STATUS_SEL,
      RBOX_RST,
      RBOX_COMPARE,
      BIST_RUN,
      BISR_RUN,
      BIHR_RUN,
      FLOAD_RUN     : begin
                        exec_flag_nxt = clean_status_i ? 1'b0 : (ready_del_r & !test_contr_ready) ? 1'b1 : exec_flag_r;
                        if(capturedr)
                          status_nxt = {test_contr_ready,sfp_fail,mux_data_r[143],overflow,exec_flag_r,1'b0};
                        else if(shiftdr)
                          status_nxt = {status_r[4:0],sfbp_wsi};
                        else
                          status_nxt = status_r;
                      end                          
      default       : begin
                        exec_flag_nxt = update_puls ? 1'b0 : exec_flag_r;
                        status_nxt = status_r;
                      end
    endcase
  end

//Boundary register capture and shift
always @ (instr or capturedr or shiftdr or smart or fast_mode or bist_run or bisr_run or bihr_run or br_sh_r or sfbp_wsi)
  if(instr == BR_SEL)
    if(capturedr)
      br_sh_nxt = {smart,fast_mode,bist_run,bisr_run,bihr_run};
    else if(shiftdr)
      br_sh_nxt = {br_sh_r[3:0],sfbp_wsi};
    else
      br_sh_nxt = br_sh_r;
  else
    br_sh_nxt = br_sh_r;


//Boundary register update
always @ (instr or updatedr or br_upd_nr or br_sh_r)
  if((instr == BR_SEL) & updatedr)
    br_upd_nxt = br_sh_r;
  else
    br_upd_nxt = br_upd_nr;


//SFP fail pin control
always @ (instr or compare_err
          or overflow
          or sms_fail)
  begin
    case(instr)
      RBOX_COMPARE    : sfp_fail = compare_err;
      default         : sfp_fail = overflow | sms_fail;
    endcase
  end



//Data register control
always @ (select_master or mux_data_r or cycling or data_sh_en_drv or instr
          or signature_en or signature_in or shiftdr or sfbp_wsi
          or serin_data_ef
          or last_dummy_loop
          )
  begin
    if((instr == RBOX_SEL) & shiftdr)
      mux_data_nxt = {mux_data_r[142:0],sfbp_wsi};
    else if (last_dummy_loop)
      if(signature_en)
        mux_data_nxt = {mux_data_r[142:0],signature_in};
      else
        mux_data_nxt = mux_data_r;
    else
      case(select_master)
        2'b01           : if(cycling & data_sh_en_drv)
                            mux_data_nxt = {mux_data_r[142:0],mux_data_r[143]};
                          else if(!cycling & data_sh_en_drv)
                            mux_data_nxt = {mux_data_r[142:0],serin_data_ef};
                          else
                            mux_data_nxt = mux_data_r;
        2'b10           : if(signature_en)
                            mux_data_nxt = {mux_data_r[142:0],signature_in};
                          else
                            mux_data_nxt = mux_data_r;
        default         : mux_data_nxt = mux_data_r;
      endcase
  end

//SMS p1500 pins control
always @ (select_master or data2sms or shift_instr or update or wir2sms_p1500_nr or wir2sms_dis_r or instr_ready
          or data2sms_compr or data2sms_sh_compr or shift_data or capture_data or sms_shift_en
          or rscr_id_r or shift_rscr_id or dummy_shift2sms_chain)
  begin
    case(select_master)
      2'b00   : {data2sms_p1500_nxt,wir2sms_p1500_nxt,shift2sms_p1500_nxt,update2sms_p1500_nxt,capture_data_nxt} =
                {data2sms,(instr_ready | (wir2sms_p1500_nr & !wir2sms_dis_r)),(shift_instr | shift_data),update,capture_data};
      2'b10   : {data2sms_p1500_nxt,wir2sms_p1500_nxt,shift2sms_p1500_nxt,update2sms_p1500_nxt,capture_data_nxt} =
                {shift_rscr_id ? rscr_id_r[3] : data2sms_compr,1'b0,(sms_shift_en & data2sms_sh_compr | shift_rscr_id | dummy_shift2sms_chain),2'd0};
      default : {data2sms_p1500_nxt,wir2sms_p1500_nxt,shift2sms_p1500_nxt,update2sms_p1500_nxt,capture_data_nxt} = 5'd0;
    endcase
  end

//Non-blocking assignment
always @ (posedge clk_sfbp or negedge rst_sfbp)
  if(!rst_sfbp)
    begin
      mux_data_r             <=  144'd0;
      status_r               <=  6'd0;
    end
  else
    begin
      mux_data_r             <=  mux_data_nxt;
      status_r               <=  status_nxt;
    end

always @ (posedge clk_sfbp or negedge wrstn)
  if(!wrstn)
    begin
      data_from_sms_r        <=  1'b0;
      ready_del_r            <=  1'b0;
      exec_flag_r            <=  1'b0;
      update2sms_p1500_r     <=  1'b0;
      wir2sms_dis_r          <=  1'b0;
      br_sh_r                <=  5'd0;
      rscr_id_r              <=  4'd0;
    end
  else
    begin
      data_from_sms_r        <=  data_from_sms_p1500;
      ready_del_r            <=  test_contr_ready;
      exec_flag_r            <=  exec_flag_nxt;
      update2sms_p1500_r     <=  update2sms_p1500_nxt;
      wir2sms_dis_r          <=  update2sms_p1500_r;
      br_sh_r                <=  br_sh_nxt;
      rscr_id_r              <=  rscr_id_nxt;
    end

always @ (negedge clk_sfbp or negedge wrstn)
  if(!wrstn)
    begin
      start_compress_nr      <=  1'b0;
      data_from_sms_nr       <=  1'b0;
      data2sms_p1500_nr      <=  1'b0;
      wir2sms_p1500_nr       <=  1'b0;
      shift2sms_p1500_nr     <=  1'b0;
      br_upd_nr              <=  5'd0;
      capture_data_nr        <=  1'b0;
    end
  else
    begin
      start_compress_nr      <=  start_compress;
      data_from_sms_nr       <=  data_from_sms_neg_nxt;
      data2sms_p1500_nr      <=  data2sms_p1500_nxt;
      wir2sms_p1500_nr       <=  wir2sms_p1500_nxt;
      shift2sms_p1500_nr     <=  shift2sms_p1500_nxt;
      br_upd_nr              <=  br_upd_nxt;
      capture_data_nr        <=  capture_data_nxt;
    end

endmodule

