//                              -*- Mode: Verilog -*-

////////////////////////////////////////////////////////////////////////////
/*
 *
 *  Trade secret of ATI Technologies, Inc.
 *  Copyright 2005, ATI Technologies, Inc., (unpublished)
 *
 *  All rights reserved.  This notice is intended as a precaution against
 *  inadvertent publication and does not imply publication or any waiver
 *  of confidentiality.  The year included in the foregoing notice is the
 *  year of creation of the work.
 *
 */
////////////////////////////////////////////////////////////////////////////
//
// Filename    : smsg_gc16.v
// Description : SMSG
//
////////////////////////////////////////////////////////////////////////////

module smsg_gc16_gc10 (

input   Tdr_Tdi,  //Broadcast WSI
input	Tdr_Tck,
input	Tdr_Trstb,
input	Tdr_Shift,
input	Tdr_Capture,
input	Tdr_Update,

input   Tdr_smsg_control_En,
output  Tdr_smsg_control_Tdo,
input   Tdr_smsg_status_En,
output  Tdr_smsg_status_Tdo,
input   Tdr_jpc_wir_En,
output  Tdr_jpc_wir_Tdo,
input   Tdr_jpc_wdr_En,
output  Tdr_jpc_wdr_Tdo,
input   Tdr_sms_wir_En,
output  Tdr_sms_wir_Tdo,
input   Tdr_sms_wdr_En,
output  Tdr_sms_wdr_Tdo,

input   Async_Rstb_Scan_Override,
input   Async_Rstb_Scan_Override_Sel,
input   Scan_Mode,

//fuse interface
input   [7:0]  smsg_ef_byte,
input   smsg_ef_ready,
input   smsg_bihr,
input   smsg_bist,
input   smsg_bisr,
input   smsg_fclken,
input   smsg_sfp_request,
input   smsg_sfp_resetb,
output   [6:0]  smsg_ef_addr,
output   smsg_ef_req,
output  smsg_sfp_ready,
output  smsg_sfp_fail,

input   BC1500_Wrck,

//SMS processor ports
output  smsg_gc16_shiftwr_0,
output  smsg_gc16_wsi_0,
output  smsg_gc16_capturewr_0,
output  smsg_gc16_updatewr_0,
input   smsg_gc16_wso_0,
output  smsg_gc16_RSTb_0,
output  smsg_gc16_shiftwr_1,
output  smsg_gc16_wsi_1,
output  smsg_gc16_capturewr_1,
output  smsg_gc16_updatewr_1,
input   smsg_gc16_wso_1,
output  smsg_gc16_RSTb_1,
output  smsg_gc16_shiftwr_2,
output  smsg_gc16_wsi_2,
output  smsg_gc16_capturewr_2,
output  smsg_gc16_updatewr_2,
input   smsg_gc16_wso_2,
output  smsg_gc16_RSTb_2,

input [3-1:0] smsg_gc16_power_off,

output  smsg_gc16_ClkEn,
output  smsg_gc16_SAFE,
output  smsg_gc16_selectwir

);


wire    sfp_ready, sfp_fail;

wire [1-1:0] atemode;
wire [1-1:0] fastmode;
wire [1-1:0] smsclken_overrideen;
wire [1-1:0] smsclken_overrideval;
wire [1-1:0] rep_request_overrideen;
wire [1-1:0] rep_request_overrideval;
wire [1-1:0] safe_rr_overrideen;
wire [1-1:0] safe_rr_overrideval;
wire [1-1:0] sfp_dft_mode;
wire [1-1:0] sfp_ready_overrideen;
wire [1-1:0] sfp_ready_overrideval;
wire [1-1:0] sfp_rstb_overrideen;
wire [1-1:0] sfp_rstb_overrideval;
wire [1-1:0] smartbihr_overrideen;
wire [1-1:0] smartbihr_overrideval;
wire [1-1:0] smartbisr_overrideen;
wire [1-1:0] smartbisr_overrideval;
wire [1-1:0] smartbist_overrideen;
wire [1-1:0] smartbist_overrideval;
wire [1-1:0] sms_done_overrideen;
wire [1-1:0] sms_done_overrideval;
wire [1-1:0] sms_rstb_overrideen;
wire [1-1:0] sms_rstb_overrideval;

smsg_gc16_control_tdr_gc10 smsg_control_tdr (

 .Tdr_Tck               (Tdr_Tck),
 .Tdr_Trstb             (Tdr_Trstb),
 .Tdr_Tdi               (Tdr_Tdi),
 .Tdr_Shift             (Tdr_Shift),
 .Tdr_Capture           (Tdr_Capture),
 .Tdr_Update            (Tdr_Update)


//TDR --> SMSG_CONTROL
 ,.atemode               (atemode[1-1:0])
 ,.fastmode              (fastmode[1-1:0])
 ,.smsclken_overrideen           (smsclken_overrideen[1-1:0])
 ,.smsclken_overrideval          (smsclken_overrideval[1-1:0])
 ,.rep_request_overrideen                (rep_request_overrideen[1-1:0])
 ,.rep_request_overrideval               (rep_request_overrideval[1-1:0])
 ,.safe_rr_overrideen            (safe_rr_overrideen[1-1:0])
 ,.safe_rr_overrideval           (safe_rr_overrideval[1-1:0])
 ,.sfp_dft_mode          (sfp_dft_mode[1-1:0])
 ,.sfp_ready_overrideen          (sfp_ready_overrideen[1-1:0])
 ,.sfp_ready_overrideval                 (sfp_ready_overrideval[1-1:0])
 ,.sfp_rstb_overrideen           (sfp_rstb_overrideen[1-1:0])
 ,.sfp_rstb_overrideval          (sfp_rstb_overrideval[1-1:0])
 ,.smartbihr_overrideen          (smartbihr_overrideen[1-1:0])
 ,.smartbihr_overrideval                 (smartbihr_overrideval[1-1:0])
 ,.smartbisr_overrideen          (smartbisr_overrideen[1-1:0])
 ,.smartbisr_overrideval                 (smartbisr_overrideval[1-1:0])
 ,.smartbist_overrideen          (smartbist_overrideen[1-1:0])
 ,.smartbist_overrideval                 (smartbist_overrideval[1-1:0])
 ,.sms_done_overrideen           (sms_done_overrideen[1-1:0])
 ,.sms_done_overrideval          (sms_done_overrideval[1-1:0])
 ,.sms_rstb_overrideen           (sms_rstb_overrideen[1-1:0])
 ,.sms_rstb_overrideval          (sms_rstb_overrideval[1-1:0])
 ,.Tdr_smsg_control_En          (Tdr_smsg_control_En)
 ,.Tdr_smsg_control_Tdo         (Tdr_smsg_control_Tdo)
);

smsg_gc16_status_tdr_gc10 smsg_status_tdr (

 .Tdr_Tck               (Tdr_Tck) ,
 .Tdr_Trstb             (Tdr_Trstb),
 .Tdr_Tdi               (Tdr_Tdi),
 .Tdr_Shift             (Tdr_Shift),
 .Tdr_Capture           (Tdr_Capture),
 .Tdr_Update            (Tdr_Update)


//TDR --> SMSG_STATUS
 ,.sfp_fail             (sfp_fail)
 ,.sfp_ready            (sfp_ready)
 ,.Tdr_smsg_status_En           (Tdr_smsg_status_En)
 ,.Tdr_smsg_status_Tdo          (Tdr_smsg_status_Tdo)
);


reg     smarthr_pulse_sticky, smarthr_complete;
assign smsg_gc16_SAFE = safe_rr_overrideen ? safe_rr_overrideval : smarthr_complete;

assign smsg_gc16_ClkEn = smsclken_overrideen ? smsclken_overrideval : smsg_fclken;
//assign smsg_sfp_resetb_internal_pre = Async_Rstb_Scan_Override_Sel ?  Async_Rstb_Scan_Override : smsg_sfp_resetb;
ati_mux2 mux_smsg_async_rstb_scan (
    .i0(smsg_sfp_resetb),
    .i1(Async_Rstb_Scan_Override),
    .s(Async_Rstb_Scan_Override_Sel),
    .z(smsg_sfp_resetb_internal_pre)
);
assign rst_sfbp = sfp_rstb_overrideen ? sfp_rstb_overrideval : smsg_sfp_resetb_internal_pre;

assign smsg_sfp_resetb_internal = smsg_sfp_resetb_internal_pre;

wire [3-1:0] smsg_gc16_shiftwr;
wire [3-1:0] smsg_gc16_capturewr;
wire [3-1:0] smsg_gc16_updatewr;
wire [3-1:0] smsg_gc16_wsi;
wire [3-1:0] smsg_gc16_wso;


assign smsg_gc16_shiftwr_0 = smsg_gc16_shiftwr[0];
assign smsg_gc16_capturewr_0 = smsg_gc16_capturewr[0];
assign smsg_gc16_updatewr_0 = smsg_gc16_updatewr[0];
assign smsg_gc16_wsi_0 = smsg_gc16_wsi[0];
assign smsg_gc16_wso[0] = smsg_gc16_wso_0;
assign smsg_gc16_shiftwr_1 = smsg_gc16_shiftwr[1];
assign smsg_gc16_capturewr_1 = smsg_gc16_capturewr[1];
assign smsg_gc16_updatewr_1 = smsg_gc16_updatewr[1];
assign smsg_gc16_wsi_1 = smsg_gc16_wsi[1];
assign smsg_gc16_wso[1] = smsg_gc16_wso_1;
assign smsg_gc16_shiftwr_2 = smsg_gc16_shiftwr[2];
assign smsg_gc16_capturewr_2 = smsg_gc16_capturewr[2];
assign smsg_gc16_updatewr_2 = smsg_gc16_updatewr[2];
assign smsg_gc16_wsi_2 = smsg_gc16_wsi[2];
assign smsg_gc16_wso[2] = smsg_gc16_wso_2;
assign smsg_gc16_RSTb_0 = sms_rstb_overrideen ? sms_rstb_overrideval : (smsg_gc16_power_off[0] ? 1'b1 : smsg_sfp_resetb_internal);
assign smsg_gc16_RSTb_1 = sms_rstb_overrideen ? sms_rstb_overrideval : (smsg_gc16_power_off[1] ? 1'b1 : smsg_sfp_resetb_internal);
assign smsg_gc16_RSTb_2 = sms_rstb_overrideen ? sms_rstb_overrideval : (smsg_gc16_power_off[2] ? 1'b1 : smsg_sfp_resetb_internal);

wire  [5:0] instr;
wire  [3-1:0] pwdn;
wire  [3-1:0] pwdn_sfp;
wire fast_load;




smsg_gc16_jpc U_jpc     (
                .tck (BC1500_Wrck),
                .resetn (rst_sfbp),
                .rst_sfbp (rst_sfbp),
                .power_off (smsg_gc16_power_off),
                .tdi (Tdr_Tdi),
                .shift_dr (Tdr_Shift),
                .capture_dr (Tdr_Capture),
                .update_dr (Tdr_Update),
                .updatewir_nr (updatewir_nr),
              .select_jpc_wir (Tdr_jpc_wir_En),
              .select_jpc_wdr (Tdr_jpc_wdr_En),
              .select_sms_wir (Tdr_sms_wir_En),
              .select_sms_wdr (Tdr_sms_wdr_En),
                .ser_data (smsg_Tdo),
                .instr (instr),
                .tdi_sfp (tdi_sfp),
                .pwdn (pwdn),
                .smsg_so (smsg_so),
                .pwdn_sfp (pwdn_sfp),
                .fast_load (fast_load),
                .selectwir_sfp (selectwir_sfp),
                .capturewr_sfp (capturewr_sfp),
                .shiftwr_sfp (shiftwr_sfp),
                .updatewr_sfp (updatewr_sfp),
                .so_sfp (so_sfp),
                .dreg_so_sfp (dreg_so_sfp),
                .shiftdr (shiftdr),
                .capturedr (capturedr),
                .updatedr (updatedr),
                .test_mode (test_mode),
              .sms_wso (smsg_gc16_wso),
              .sms_wsi (smsg_gc16_wsi),
              .sms_shiftwr (smsg_gc16_shiftwr),
              .sms_updatewr (smsg_gc16_updatewr),
              .sms_capturewr (smsg_gc16_capturewr),
              .sms_selectwir (smsg_gc16_selectwir)
);

reg smsg_Tdo_nr;

always @(negedge BC1500_Wrck or negedge rst_sfbp)
    if (!rst_sfbp)
        begin
          smsg_Tdo_nr   <= 1'b0;
        end
    else
        begin
          smsg_Tdo_nr   <= smsg_Tdo;
        end

assign Tdr_jpc_wir_Tdo = smsg_Tdo_nr;
assign Tdr_jpc_wdr_Tdo = smsg_Tdo_nr;
assign Tdr_sms_wir_Tdo = smsg_Tdo_nr;
assign Tdr_sms_wdr_Tdo = smsg_Tdo_nr;


assign bist_run = smartbist_overrideen ? smartbist_overrideval : smsg_bist;
assign bisr_run = smartbisr_overrideen ? smartbisr_overrideval : smsg_bisr;
assign bihr_run = smartbihr_overrideen ? smartbihr_overrideval : smsg_bihr;
assign smart_mode_en = bihr_run || bisr_run || bist_run;
assign smart = rep_request_overrideen ? rep_request_overrideval : smsg_sfp_request;

reg smart_del1, smart_del2, smart_del3, smart_pulse;
// turn smsg_sfp-request into a pulse
always @(posedge BC1500_Wrck or negedge rst_sfbp)
    if (!rst_sfbp)
        begin
            smart_del1              <= 1'b0;
            smart_del2              <= 1'b0;
            smart_del3              <= 1'b0;
            smart_pulse             <= 1'b0;
        end
    else
        begin
            smart_del1              <= smart;
            smart_del2              <= smart_del1;
            smart_del3              <= smart_del2;
            smart_pulse             <= (smart && !smart_del3 && smart_mode_en);
        end

// after a hard repair has completed, we need to assert SAFE signal 
// SAFE signal also drives FISO which retains reconfig register contents during sleep states of memory
// During mission mode, ready asserting at the end of hard repair will cause smart to deassert
// In JTAG mode, if it desired for SAFE to be asserted, then TDR write will be needed to deassert smart,
// or alternatively TDR write to directly set SAFE
always @(posedge BC1500_Wrck or negedge rst_sfbp)
    if (!rst_sfbp)
        begin
            smarthr_pulse_sticky    <= 1'b0;
            smarthr_complete        <= 1'b0;
        end
    else
        begin
            smarthr_pulse_sticky    <= ((smart_pulse && bihr_run) || smarthr_pulse_sticky);
            smarthr_complete        <= (smarthr_pulse_sticky && !smart);
        end


assign smsg_sfp_ready = sfp_ready;
assign smsg_sfp_fail = sfp_fail;


 smsg_gc16_sfp   U_sfp     (
                .wrck (BC1500_Wrck)
                ,.wrstn (rst_sfbp)
                ,.wsi (tdi_sfp)
                ,.rst_sfbp (rst_sfbp)
                ,.shiftdr (shiftdr)
                ,.capturedr (capturedr)
                ,.updatedr (updatedr)
                ,.update_puls (updatewir_nr)
                ,.test_mode (test_mode)
                ,.pwdn (pwdn)
                ,.ring_bypass_unrep (pwdn_sfp)
                ,.fast_load (fast_load)
                ,.smart (smart_pulse)
                ,.bist_run (bist_run)
                ,.bisr_run (bisr_run)
                ,.bihr_run (bihr_run)
                ,.fast_mode (fastmode)
                ,.instr (instr)
                ,.sfp_ready (sfp_ready)
                ,.sfp_fail (sfp_fail)
                ,.data2sms_p1500 (so_sfp)
                ,.wir2sms_p1500 (selectwir_sfp)
                ,.capt2sms_p1500 (capturewr_sfp)
                ,.shift2sms_p1500 (shiftwr_sfp)
                ,.update2sms_p1500 (updatewr_sfp)
                ,.data_reg_out (dreg_so_sfp)
                ,.data_from_sms_p1500 (smsg_so)
                ,.ready_ef (smsg_ef_ready)
                ,.byte_in_ef (smsg_ef_byte)
                ,.addr (smsg_ef_addr)
                ,.req_ef (smsg_ef_req)

);


`ifdef ABV
 `include "smsg_assert_control.vh"

    //Verify: if safe_rr set then hard repair is not performed
    ovl_always #(
       .severity_level (`OVL_ERROR),
       .property_type (`OVL_ASSERT),
       .msg ("Error: hard repair should not assert if safe_rr is set"),
       .coverage_level (`OVL_COVER_DEFAULT),
       .clock_edge (`OVL_POSEDGE),
       .reset_polarity (`OVL_ACTIVE_LOW),
       .gating_type (`OVL_GATE_CLOCK) )  
    assert_safe_rr_no_hardrepair (
       .clock (BC1500_Wrck),
       .reset (rst_sfbp),
       .enable (`SMSG_ABV_PWROK_EN & 1'b0), 
       .test_expr (smsg_gc16_SAFE & ~bihr_run),
       .fire () );

`endif

endmodule
