/*---------------------------------------------------------------------*/
/*               Copyright(c) Synopsys, Inc.                           */
/*     All Rights reserved - Unpublished -rights reserved under        */
/*     the Copyright laws of the United States of America.             */
/*                                                                     */
/*  U.S. Patents: 7,093,156 B1 and 7,406,620 B2 (and more pending).    */
/*                                                                     */
/*  This file includes the Confidential information of Synopsys, Inc.. */
/*  The receiver of this Confidential Information shall not disclose   */
/*  it to any third party and shall protect its confidentiality by     */
/*  using the same degree of care, but not less then a reasonable      */
/*  degree of care, as the receiver uses to protect receiver's own     */
/*  Confidential Information.                                          */
/*  Licensee acknowledges and agrees that all output generated for     */
/*  Licensee by Synopsys, Inc. as described in the pertinent Program   */
/*  Schedule(s), or generated by Licensee through use of any Compiler  */
/*  licensed hereunder contains information that complies with the     */
/*  Virtual Component Identification Physical Tagging Standard (VCID)  */
/*  as maintained by the Virtual Socket Interface Alliance (VSIA).     */
/*  Such information may be expressed in GDSII Layer 63 or other such  */
/*  layer designated by the VSIA, hardware definition languages, or    */
/*  other formats.  Licensee is not authorized to alter or change any  */
/*  such information.                                                  */
/*---------------------------------------------------------------------*/
/*                                                                     */
/*  Built for linux64 and running on linux64.                          */
/*                                                                     */
/*  Software           : Rev: M-2017.03                                */
/*  Library Format     : Rev: 1.05.00                                  */
/*  Compiler Name      : vl00x000vpnnstsrv000sa31                      */
/*  Platform           : Linux2.6.32-573.el6.x86_64                    */
/*                     : #1 SMP Wed Jul 1 18:23:37 EDT 2015x86_64      */
/*  Date of Generation : Thu Jul 27 17:04:20 EDT 2017                  */
/*                                                                     */
/*---------------------------------------------------------------------*/
`resetall
// T I M E S C A L E ===============================================================================
`ifndef SMS_NO_TIMESCALE
    `timescale 1ns/1ps
`endif
module smsg_gc1_rp_controller  (
                                clk_sfbp,
                                rst_sfbp,                               
                                driver_on,
                                early_abort,
                                instr,
                                update_puls,
                                clean_status,
                                compr_expand_on,
                                smart_int,
                                fast_mode_int,
                                bist_run_int,
                                bisr_run_int,
                                bihr_run_int,
                                shiftdr,
                                rscr_id_err,
                                data_from_sms_p1500,
                                instr_ready,
                                sms_shift,
                                sms_early_shift,
                                pwdn,
                                power_off,
                                sms_wso_filtered,
                                sms_shift_en,
                                last_dummy_loop,
                                ring_bypass_unrep,
                                ld_sms_cntr,
                                decr_sms_cntr_ce,
                                curr_sms_bypass_ctrl,                                
                                sms_cntr,
                                decr_sms_cntr,
                                fast_load,
                                efread_flag,
  
                                select_master,
                                efcompare,
                                efread,
                                start_compress,
                                start_expand,
                                last_sms,
                                shift_rscr_id,
                                smart_flow,
                                sms_fail,
                                capture_data,
                                shift_data,
                                instr2net,
                                net_send,
                                update,
                                dummy_shift2sms_chain,
                                test_contr_ready
);

parameter BYPASS        = 6'd0;
parameter RBOX_RST      = 6'd36;
parameter RBOX_SEL      = 6'd37;
parameter RBOX_COMPARE  = 6'd38;
parameter RSCR_SEL      = 6'd24;
parameter FBIST_RUN     = 6'd16;
parameter BIST_RUN      = 6'd17;
parameter BIRA_RUN      = 6'd18;
parameter FBIRA_RUN     = 6'd26;
parameter BISR_RUN      = 6'd19;
parameter MRR2INBR      = 6'd20;
parameter BIHR_RUN      = 6'd51;
parameter FLOAD_RUN     = 6'd48;

//State machine states
parameter RESET         = 7'd0;
parameter SMART         = 7'd1;
parameter POSTBIHR      = 7'd2;
parameter BIHR          = 7'd3;
parameter POSTREAD      = 7'd4;
parameter BIHRON        = 7'd5;
parameter LOADRSCR      = 7'd6;
parameter SHIFTDATAEN   = 7'd7;
parameter SHIFTDATA     = 7'd8;
parameter POSTSHIFT     = 7'd9;
parameter SENDRSCR      = 7'd11;
parameter UPDATE1       = 7'd12;
parameter EXPAND        = 7'd13;
parameter EXPANDSTATE   = 7'd14;
parameter EXPANDPAUSE   = 7'd15;
parameter POSTEXPAND    = 7'd16;
parameter FUNCTIONAL    = 7'd17;
parameter BYPASSPAUSE   = 7'd18;
parameter BYPASSFLOW    = 7'd19;
parameter ALLBYPASS     = 7'd20;
parameter UPDATE2       = 7'd21;
parameter FLOAD         = 7'd22;
parameter RSCRPAUSE     = 7'd23;
parameter RSCRFLOW      = 7'd24;
parameter UPDATE3       = 7'd26;
parameter COMPRESS      = 7'd27;
parameter COMPRSTATE    = 7'd28;
parameter COMPRPAUSE    = 7'd29;
parameter POSTCOMPR     = 7'd30;
parameter READ          = 7'd31;
parameter READSTATE     = 7'd32;
parameter READPAUSE     = 7'd33;
parameter PROGRAMSTATE  = 7'd35;
parameter PROGRAMPAUSE  = 7'd36;
parameter LOADTIEOFFS   = 7'd37;
parameter READYCOUNTER  = 7'd38;
parameter SENDTIEOFF    = 7'd39;
parameter SENDBIST      = 7'd40;
parameter BYPASSTIEOFF  = 7'd42;
parameter POSTTIEOFF    = 7'd43;
parameter SHIFTSTRING   = 7'd44;
parameter UPDATE4       = 7'd45;
parameter COMPARE       = 7'd49;
parameter LOADSMSINFO   = 7'd65;
parameter ANALTIEOFF    = 7'd66;
parameter SHIFTBYPASS   = 7'd67;
parameter ANALSMSNUM    = 7'd68;
parameter NEXTSMS       = 7'd69;
parameter LSHIFTCOUNT   = 7'd70;
parameter SHFITSTATUS   = 7'd71;
parameter NEWCYCLE      = 7'd72;
parameter RSCRID_DUMMY  = 7'd81; 
parameter RSCRIDOUT     = 7'd76;
parameter RSCRID1       = 7'd77;
parameter RSCRID2       = 7'd78;
parameter RSCRID3       = 7'd79;
parameter RSCRID4       = 7'd80;

input clk_sfbp;
input rst_sfbp;
input driver_on;
input early_abort;
input [5:0]instr;
input update_puls;
input clean_status;
input compr_expand_on;
input smart_int;
input fast_mode_int;
input bist_run_int;
input bisr_run_int;
input bihr_run_int;
input shiftdr;
input rscr_id_err;
input data_from_sms_p1500;
input instr_ready;
input sms_shift;
input sms_early_shift;
input [1:0]pwdn;
input last_dummy_loop;
input  curr_sms_bypass_ctrl;
input [1:0] ring_bypass_unrep;
input ld_sms_cntr;
input decr_sms_cntr_ce;
input  decr_sms_cntr;
output fast_load;
output [4:0] sms_cntr;
output efread_flag;
output power_off;
output sms_wso_filtered;
output sms_shift_en;
output [1:0]select_master;
output efcompare;
output efread;
output start_compress;
output start_expand;
output shift_rscr_id;

output smart_flow;
output sms_fail;
output capture_data;
output shift_data;
output [5:0]instr2net;
output net_send;
output update;
output dummy_shift2sms_chain;
output test_contr_ready;
output  last_sms;

//Variables
reg [6:0]state_r,state_nxt;
reg  smart1_r,smart2_r;
reg [2:0]ready_counter_r,ready_counter_nxt;
reg sms_ready_r,sms_ready_nxt;
reg sms_fail_r, sms_fail_nxt;
reg smart_on_r,smart_on_nxt;
reg efread_r,efread_nxt;
reg efcompare_r,efcompare_nxt;
reg start_compress_r,start_compress_nxt;
reg start_expand_r,start_expand_nxt;
reg [1:0]select_master_r,select_master_nxt;
reg ready_r;
reg [5:0]instr_reg_r,instr_reg_nxt;
reg net_send_r,net_send_nxt;
reg update;
reg [4:0]sms_counter_r,sms_counter_nxt;
reg [29:0]tie_offs_r,tie_offs_nxt;
wire ready_nxt;
wire smart_pulse;

wire last_sms_i;
reg [1:0]pwdn_r,pwdn_nxt;
wire last_sms_in_ring_i;
wire sms_wso_filtered_i;
wire pwdn_shift_req;
wire power_off_i;
reg power_off_del_r;
reg first_bit_en_r;
wire first_bit_en_nxt;
reg wait4start_r;
wire wait4start_nxt;
reg [9:0] ch_size_counter_r;
wire [9:0] ch_size_counter_nxt;
wire [9:0] ch_size_mux_nxt;
wire load_ch_size;
wire ready_time_over;
wire bisr_exists;
wire first_seq;
wire bira_seq;
wire last_seq;
reg [2:0] seq_count_r;
wire [2:0] seq_count_nxt;
reg star_fail_r;
wire star_fail_nxt;

reg  efread_flag_r;
wire efread_flag_nxt;
wire curr_sms_bypass;
wire all_rings_bypass;
assign all_rings_bypass = ((&ring_bypass_unrep) == 1'b1);
wire [4:0] rbypass_next_sms;
reg [29:0] star_fail_vec_r;
wire [29:0] star_fail_vec_nxt;
wire wait_shift;
reg skip_fread_r;
wire skip_fread_nxt;
reg rscr_id_err_r;
wire rscr_id_err_nxt;
assign bisr_exists             = smart_on_r ? bisr_run_int : (instr == BISR_RUN);
assign first_seq               = (seq_count_r == 3'd1);
assign bira_seq                = (seq_count_r == 3'd3);
assign last_seq                = bisr_exists ? (seq_count_r == 3'd5) : first_seq;
assign sms_cntr                = sms_counter_r;
assign fast_load               = (state_r == POSTSHIFT) | (state_r == ALLBYPASS) | (state_r == RSCRFLOW) | shift_rscr_id | (state_r == POSTEXPAND) | (state_r == UPDATE1) | (state_r == UPDATE2) | (state_r == EXPANDPAUSE) | (state_r == EXPANDSTATE) | (state_r == EXPAND);
assign efread_flag             = efread_flag_r;

assign efread_flag_nxt         = ((state_r == READPAUSE) & (state_nxt != READPAUSE)) | ((state_r != FLOAD) & (state_r != READ) & !((instr == RBOX_SEL) & shiftdr) & efread_flag_r);
assign curr_sms_bypass         = curr_sms_bypass_ctrl & (instr != FLOAD_RUN);
assign rbypass_next_sms        =
                                 (sms_counter_r == 5'd5) ? 5'd0 :
                                 (sms_counter_r == 5'd29) ? 5'd5 :
                                  sms_counter_r;

assign seq_count_nxt           = (state_r == RESET) ? 3'd0 :
                                 (state_r == LOADTIEOFFS) ? (seq_count_r + 3'd1) : seq_count_r;

assign star_fail_vec_nxt       = (state_r == RESET) ? 30'd0 :
                                 (((state_r == SHIFTBYPASS) | (state_r == SENDTIEOFF) | 
                                 (state_r == ANALSMSNUM)) & (!first_seq)) ? {star_fail_vec_r[0], star_fail_vec_r[29:1]} :
                                 ((state_r == SHFITSTATUS) & ((ready_counter_r == 3'd4) | power_off_i) & first_seq) ? {(sms_fail_nxt), star_fail_vec_r[29:1]} :
                                 ((state_r == SHIFTBYPASS) & first_seq) ? {1'b0, star_fail_vec_r[29:1]} :
                                 star_fail_vec_r;
assign star_fail_nxt           = (!(smart_pulse | clean_status)) &
                                 ((((last_seq | bira_seq) & star_fail_vec_r[0] & sms_fail_r) |
                                 ((|star_fail_vec_r) & (!bisr_exists))) | star_fail_r);
assign dummy_shift2sms_chain   = (state_nxt == POSTCOMPR);
assign test_contr_ready        = ready_r;
assign efread                  = efread_r;
assign efcompare               = efcompare_r;
assign start_compress          = start_compress_r;
assign start_expand            = start_expand_r;
assign smart_flow              = smart_on_r;
assign select_master           = select_master_r;
assign skip_fread_nxt          = ((state_r == BIHRON) & (state_nxt != BIHRON) & smart_on_r) | 
                                 ((state_r != FLOAD) & (state_r != READ) & !((instr == RBOX_SEL) & shiftdr) & skip_fread_r);
assign rscr_id_err_nxt         = rscr_id_err & (state_r == POSTEXPAND) | !(smart_pulse | clean_status) & rscr_id_err_r;
assign shift_rscr_id           = (state_r == RSCRID1) | (state_r == RSCRID2) | (state_r == RSCRID3) | (state_r == RSCRID4);
assign last_sms                = last_sms_i;
assign last_sms_i              = (sms_counter_r == 5'd0);

assign wait_shift              = (state_r == EXPAND) | (state_r == COMPRESS);
assign wait4start_nxt          = (sms_early_shift | wait_shift) ? wait_shift : wait4start_r;
assign ch_size_counter_nxt     = (pwdn_shift_req | (state_r == EXPANDSTATE) | (state_r == COMPRSTATE)) ? ch_size_mux_nxt : sms_shift ? 
                                 (ch_size_counter_r - 10'd1) : ch_size_counter_r ;
assign ch_size_mux_nxt         = 
                                 (sms_counter_nxt == 5'd0) ? (curr_sms_bypass ? 10'd0 : 10'd410) :
                                 (sms_counter_nxt == 5'd1) ? (curr_sms_bypass ? 10'd0 : 10'd768) :
                                 (sms_counter_nxt == 5'd2) ? (curr_sms_bypass ? 10'd0 : 10'd768) :
                                 (sms_counter_nxt == 5'd3) ? (curr_sms_bypass ? 10'd0 : 10'd216) :
                                 (sms_counter_nxt == 5'd4) ? (curr_sms_bypass ? 10'd0 : 10'd216) :
                                 (sms_counter_nxt == 5'd5) ? (curr_sms_bypass ? 10'd0 : 10'd432) :
                                 (sms_counter_nxt == 5'd6) ? (curr_sms_bypass ? 10'd0 : 10'd490) :
                                 (sms_counter_nxt == 5'd7) ? (curr_sms_bypass ? 10'd0 : 10'd490) :
                                 (sms_counter_nxt == 5'd8) ? (curr_sms_bypass ? 10'd0 : 10'd64) :
                                 (sms_counter_nxt == 5'd9) ? (curr_sms_bypass ? 10'd0 : 10'd200) :
                                 (sms_counter_nxt == 5'd10) ? (curr_sms_bypass ? 10'd0 : 10'd256) :
                                 (sms_counter_nxt == 5'd11) ? (curr_sms_bypass ? 10'd0 : 10'd64) :
                                 (sms_counter_nxt == 5'd12) ? (curr_sms_bypass ? 10'd0 : 10'd64) :
                                 (sms_counter_nxt == 5'd13) ? (curr_sms_bypass ? 10'd0 : 10'd200) :
                                 (sms_counter_nxt == 5'd14) ? (curr_sms_bypass ? 10'd0 : 10'd256) :
                                 (sms_counter_nxt == 5'd15) ? (curr_sms_bypass ? 10'd0 : 10'd64) :
                                 (sms_counter_nxt == 5'd16) ? (curr_sms_bypass ? 10'd0 : 10'd64) :
                                 (sms_counter_nxt == 5'd17) ? (curr_sms_bypass ? 10'd0 : 10'd200) :
                                 (sms_counter_nxt == 5'd18) ? (curr_sms_bypass ? 10'd0 : 10'd256) :
                                 (sms_counter_nxt == 5'd19) ? (curr_sms_bypass ? 10'd0 : 10'd64) :
                                 (sms_counter_nxt == 5'd20) ? (curr_sms_bypass ? 10'd0 : 10'd64) :
                                 (sms_counter_nxt == 5'd21) ? (curr_sms_bypass ? 10'd0 : 10'd200) :
                                 (sms_counter_nxt == 5'd22) ? (curr_sms_bypass ? 10'd0 : 10'd64) :
                                 (sms_counter_nxt == 5'd23) ? (curr_sms_bypass ? 10'd0 : 10'd64) :
                                 (sms_counter_nxt == 5'd24) ? (curr_sms_bypass ? 10'd0 : 10'd200) :
                                 (sms_counter_nxt == 5'd25) ? (curr_sms_bypass ? 10'd0 : 10'd64) :
                                 (sms_counter_nxt == 5'd26) ? (curr_sms_bypass ? 10'd0 : 10'd64) :
                                 (sms_counter_nxt == 5'd27) ? (curr_sms_bypass ? 10'd0 : 10'd200) :
                                 (sms_counter_nxt == 5'd28) ? (curr_sms_bypass ? 10'd0 : 10'd64) :
                                 (curr_sms_bypass ?  10'd0 : 10'd510);
assign last_sms_in_ring_i      = (sms_counter_r == 5'd0) |
                                 (sms_counter_r == 5'd6);

assign power_off               = power_off_i;
                              
assign sms_wso_filtered        = sms_wso_filtered_i;
assign sms_wso_filtered_i      = data_from_sms_p1500 & !power_off_del_r;

assign power_off_i             = pwdn_r[1] & !last_dummy_loop;
assign first_bit_en_nxt        = load_ch_size | (!(sms_shift | (state_r == RSCRID4)) & first_bit_en_r);
assign sms_shift_en            = (first_bit_en_r & last_sms_in_ring_i) | !power_off_i;
assign pwdn_shift_req          = start_expand_r ? decr_sms_cntr_ce : sms_shift & (ch_size_counter_r == 0);
assign load_ch_size            = pwdn_shift_req | (sms_early_shift & wait4start_r);
assign smart_pulse             = (!smart1_r) & smart2_r;
assign instr2net               = instr_reg_r;
assign net_send                = net_send_r;
assign ready_time_over         = (ready_counter_r == 3'd0);
assign sms_fail                = ((state_r == RESET) ? star_fail_r : sms_fail_r) | rscr_id_err_r;
assign shift_data              = ((state_r == SHFITSTATUS) |
                                (state_r == SHIFTBYPASS)) & (last_sms_in_ring_i | !power_off_i);
assign capture_data            = (state_r == LOADSMSINFO);
assign ready_nxt               = (state_r == RESET) & !smart_pulse;

//Output p1500 interface Update pin control
always @ (state_r)
  begin
    case(state_r)
      UPDATE4,
      UPDATE1,
      UPDATE2,
      UPDATE3     : update = 1'b1;
      default     : update = 1'b0;
    endcase
  end

//SMS counter
always @ (state_r or sms_counter_r or pwdn or pwdn_r
          or pwdn_shift_req or last_sms_in_ring_i
          or decr_sms_cntr or smart_on_r or bist_run_int or bisr_run_int or ring_bypass_unrep or ld_sms_cntr or rbypass_next_sms
          )
  begin
    if (pwdn_shift_req | decr_sms_cntr | ld_sms_cntr)
       begin
         sms_counter_nxt = ld_sms_cntr ? rbypass_next_sms : (sms_counter_r - 5'd1);
         pwdn_nxt = (ld_sms_cntr | last_sms_in_ring_i) ? {pwdn_r[0], 1'b0} : pwdn_r;
       end
    else
      case(state_r)
        FUNCTIONAL  : begin
                       sms_counter_nxt = 5'd29;
                       pwdn_nxt = (!(smart_on_r & (bist_run_int | bisr_run_int))) ? (pwdn | ring_bypass_unrep) : pwdn;
                      end
        EXPAND,
        BIHRON,
        POSTEXPAND  : begin
                        sms_counter_nxt = 5'd29;
                        pwdn_nxt = pwdn | ring_bypass_unrep;
                      end                    
        POSTBIHR,
        UPDATE4,
        LOADSMSINFO,
        NEWCYCLE,
        RESET,
        COMPRESS    : begin
                        sms_counter_nxt = 5'd29;
                        pwdn_nxt = pwdn;
                      end
        SHIFTBYPASS,
        SHIFTSTRING,
        NEXTSMS,
        BYPASSPAUSE,
        RSCRPAUSE   : begin
                        sms_counter_nxt = (sms_counter_r - 5'd1);
                        pwdn_nxt = last_sms_in_ring_i ? {pwdn_r[0], 1'b0} : pwdn_r;
                      end
        default     : begin
                        sms_counter_nxt = sms_counter_r;
                        pwdn_nxt = pwdn_r;
                      end
      endcase
  end

//Delay/Shift counter control
always @ (state_r or ready_counter_r or power_off_i)
  case(state_r)
    LSHIFTCOUNT   : ready_counter_nxt = power_off_i ?  3'd0 : 3'd6;
    READYCOUNTER,
    SHFITSTATUS   : ready_counter_nxt = ready_counter_r - 3'd1;
    default       : ready_counter_nxt = 3'd6;
  endcase

//Tie-off control
always @ (state_r or tie_offs_r)
  begin
    case(state_r)
      RESET       : tie_offs_nxt = 30'd0;
      LOADSMSINFO,
      LOADTIEOFFS : tie_offs_nxt = 30'b111111111111111111111111111111;
      SHIFTBYPASS,
      NEXTSMS,
      SHIFTSTRING : tie_offs_nxt = {1'b0,tie_offs_r[29:1]};
      default     : tie_offs_nxt = tie_offs_r;
    endcase
  end

//Control of SMS status bits
always @ (state_r or sms_ready_r or sms_fail_r or ready_counter_r or sms_wso_filtered_i or power_off_i or clean_status )
  case(state_r)
    POSTBIHR,
    FLOAD         : begin
                      sms_ready_nxt = 1'b1;
                      sms_fail_nxt  = 1'b0;
                    end
    SHIFTBYPASS,
    ANALSMSNUM    : begin
                      sms_ready_nxt = sms_ready_r;
                      sms_fail_nxt  = 1'b0;
                    end
    LOADSMSINFO,
    LOADTIEOFFS   : begin
                      sms_ready_nxt = 1'b1;
                      sms_fail_nxt  = 1'b0;
                    end
    SHFITSTATUS   : begin
                      sms_ready_nxt = sms_ready_r & (power_off_i | ((ready_counter_r == 3'd5) ? sms_wso_filtered_i : 1'b1));
                      sms_fail_nxt  = (!power_off_i) & ((ready_counter_r == 3'd4) ? (sms_wso_filtered_i & sms_ready_r) : 1'b0);
                    end
    default       : begin
                      sms_ready_nxt = sms_ready_r;
                      sms_fail_nxt  = sms_fail_r & !clean_status;
                    end
  endcase


//net_send_engine control
always @ (state_r or instr_reg_r or seq_count_r or fast_mode_int  or last_sms_in_ring_i or power_off_i
          )
  case(state_r)
    RESET         : {instr_reg_nxt,net_send_nxt} = {BYPASS,1'b0};
    BYPASSFLOW    : {instr_reg_nxt,net_send_nxt} = {BYPASS,1'b1};
    FLOAD,
    SENDRSCR      : {instr_reg_nxt,net_send_nxt} = {RSCR_SEL,1'b1};
    SENDBIST      : begin
                      net_send_nxt = (last_sms_in_ring_i | !power_off_i);
                      case(seq_count_r)
                        3'd2  : instr_reg_nxt = MRR2INBR;
                        3'd3  : instr_reg_nxt = fast_mode_int ? FBIRA_RUN : BIRA_RUN;
                        3'd4  : instr_reg_nxt = BISR_RUN;
                      default : instr_reg_nxt = fast_mode_int ? FBIST_RUN : BIST_RUN;
                      endcase
                    end
    BYPASSTIEOFF  : {instr_reg_nxt,net_send_nxt} = {BYPASS,(last_sms_in_ring_i | !power_off_i)};
    default       : {instr_reg_nxt,net_send_nxt} = {instr_reg_r,1'b0};
  endcase

//SMART return point
always @ (state_r or smart_on_r)
  begin
    case(state_r)
      RESET       : smart_on_nxt = 1'b0;
      SMART       : smart_on_nxt = 1'b1;
      default     : smart_on_nxt = smart_on_r;
    endcase
  end

//E-fuse driver and compressor/decompressor controls
always @ (state_r)
  begin
    case(state_r)
      RESET       : {efread_nxt,start_compress_nxt,start_expand_nxt,efcompare_nxt} = 4'b0000;
      READ        : {efread_nxt,start_compress_nxt,start_expand_nxt,efcompare_nxt} = 4'b1000;
      COMPRPAUSE,
      COMPRSTATE,
      COMPRESS    : {efread_nxt,start_compress_nxt,start_expand_nxt,efcompare_nxt} = 4'b0100;
      EXPANDPAUSE,
      EXPANDSTATE,
      EXPAND      : {efread_nxt,start_compress_nxt,start_expand_nxt,efcompare_nxt} = 4'b0010;
      COMPARE     : {efread_nxt,start_compress_nxt,start_expand_nxt,efcompare_nxt} = 4'b0001;
      default     : {efread_nxt,start_compress_nxt,start_expand_nxt,efcompare_nxt} = 4'b0000;
    endcase
  end

//Multiplexer control
always @ (state_r or select_master_r)
  begin
    case(state_r)
      RESET,
      POSTBIHR,
      POSTREAD,
      POSTCOMPR,
      POSTEXPAND  : select_master_nxt = 2'b00;
      COMPARE,
      READ        : select_master_nxt = 2'b01;
      COMPRESS,
      RSCRID_DUMMY   : select_master_nxt = 2'b10;
      default     : select_master_nxt = select_master_r;
    endcase
  end


//State machine
always @ ( state_r or instr or smart_pulse or update_puls or compr_expand_on 
          or smart_on_r or instr_ready or sms_ready_r or ready_time_over or driver_on or last_seq
          or bist_run_int or bisr_run_int or bihr_run_int or star_fail_vec_r
          or skip_fread_r
          or last_sms_i or first_seq or tie_offs_r
          or early_abort
          or power_off_i
          or last_dummy_loop
          or all_rings_bypass or sms_shift
          )
  begin
    case(state_r)
      RESET       : if(smart_pulse)
                      state_nxt = SMART;
                    else if(update_puls)
                      begin
                        case(instr)
                          FLOAD_RUN     : state_nxt = FLOAD;
                          BIHR_RUN      : state_nxt = BIHR;
                          BISR_RUN,
                          BIST_RUN      : state_nxt = POSTBIHR;
                          RBOX_RST      : state_nxt = READ;
                          RBOX_COMPARE  : state_nxt = COMPARE;
                          default       : state_nxt = RESET;
                        endcase
                      end
                    else
                      state_nxt = RESET;
//SMART sub-program
      SMART       : if (bihr_run_int)
                      if(skip_fread_r)
                        state_nxt = POSTREAD;
                      else
                        state_nxt = READ;
                    else if(bist_run_int | bisr_run_int)
                        state_nxt = POSTBIHR;
                    else
                        state_nxt = RESET;
      POSTBIHR    : state_nxt = LOADTIEOFFS;
      LOADTIEOFFS : state_nxt = SENDTIEOFF;
      SENDTIEOFF  : if(tie_offs_r[0] & (star_fail_vec_r[0] | first_seq))
                      state_nxt = SENDBIST;
                    else
                      state_nxt = BYPASSTIEOFF;
      BYPASSTIEOFF: state_nxt = POSTTIEOFF;
      SENDBIST    : state_nxt = POSTTIEOFF;
      POSTTIEOFF  : if(instr_ready)
                      state_nxt = POSTTIEOFF;
                    else if(!last_sms_i)
                      state_nxt = SHIFTSTRING;
                    else
                      state_nxt = UPDATE4;
      SHIFTSTRING : state_nxt = SENDTIEOFF;
      UPDATE4     : state_nxt = READYCOUNTER;
      READYCOUNTER: if(!ready_time_over)
                      state_nxt = READYCOUNTER;
                    else
//Monitoring SMS readiness through p1500
                      state_nxt = LOADSMSINFO;
      LOADSMSINFO : state_nxt = ANALTIEOFF;
      ANALTIEOFF  : if(tie_offs_r[0] & (star_fail_vec_r[0] | first_seq))
                      if (power_off_i)
                         state_nxt = SHIFTBYPASS;   // to modify of SMS num 
                       else
                         state_nxt = LSHIFTCOUNT;
                    else 
                      state_nxt = SHIFTBYPASS;
      SHIFTBYPASS : if(!last_sms_i)
                      state_nxt = ANALTIEOFF;
                    else
                      state_nxt = NEWCYCLE;
      LSHIFTCOUNT : state_nxt = SHFITSTATUS;
      SHFITSTATUS : if(!ready_time_over)
                      state_nxt = SHFITSTATUS;
                    else
                      state_nxt = ANALSMSNUM;
      ANALSMSNUM  : if(!last_sms_i)
                      state_nxt = NEXTSMS;
                    else
                      state_nxt = NEWCYCLE;
      NEXTSMS     : state_nxt = ANALTIEOFF;
      NEWCYCLE    : if(sms_ready_r)
                      if(last_seq | (!star_fail_vec_r))
                        state_nxt = FUNCTIONAL;
                      else
                        state_nxt = LOADTIEOFFS;
                    else
                      state_nxt = LOADSMSINFO;
//BIHR sub-program
      BIHR        : state_nxt = POSTREAD;
      POSTREAD    : state_nxt = BIHRON;
      BIHRON      : if((!smart_on_r | !early_abort) & !all_rings_bypass)
                      state_nxt = LOADRSCR;
                    else if(smart_on_r & (bist_run_int | bisr_run_int))
                      state_nxt = POSTBIHR;
                    else
                      state_nxt = RESET;
//LOADRSCR sub-program
      LOADRSCR    : state_nxt = SHIFTDATAEN;
      SHIFTDATAEN : state_nxt = SHIFTDATA;
      SHIFTDATA   : state_nxt = SENDRSCR;
      SENDRSCR    : state_nxt = POSTSHIFT;
      POSTSHIFT   : if(instr_ready)
                      state_nxt = POSTSHIFT;
                    else
                      state_nxt = UPDATE1;
      UPDATE1     : state_nxt = RSCRID_DUMMY;
      RSCRID_DUMMY : state_nxt = RSCRIDOUT;
      RSCRIDOUT   : if(/*smart_on_r & */last_dummy_loop)
                      state_nxt = RSCRIDOUT;
                    else
                      state_nxt = RSCRID1;
      RSCRID1     : state_nxt = RSCRID2;
      RSCRID2     : state_nxt = RSCRID3;
      RSCRID3     : state_nxt = RSCRID4;
      RSCRID4     : state_nxt = EXPAND;
//EXPAND sub-program
      EXPAND      : state_nxt = EXPANDSTATE;
      EXPANDSTATE : state_nxt = EXPANDPAUSE;
      EXPANDPAUSE : if(sms_shift | compr_expand_on & !last_dummy_loop )
                      state_nxt = EXPANDPAUSE;
                    else
                      state_nxt = POSTEXPAND;
       POSTEXPAND  : if(smart_on_r & (bist_run_int | bisr_run_int))
                       state_nxt = POSTBIHR;
                     else
                       state_nxt = FUNCTIONAL;
//FUNCTIONAL sub-program, used for loading of instr to sel SMS ext. MPR as well
      FUNCTIONAL  : state_nxt = BYPASSFLOW;
      BYPASSPAUSE : state_nxt = BYPASSFLOW;
      BYPASSFLOW  : state_nxt = ALLBYPASS;
      ALLBYPASS   : if(instr_ready)
                      state_nxt = ALLBYPASS;
                    else if(!last_sms_i)
                      state_nxt = BYPASSPAUSE;
                    else
                      state_nxt = UPDATE2;
      UPDATE2     : state_nxt = RESET;
//FLOAD sub-program
      FLOAD       : state_nxt = RSCRFLOW;
      RSCRPAUSE   : state_nxt = FLOAD;
      RSCRFLOW    : if(instr_ready)
                      state_nxt = RSCRFLOW;
                    else if(!last_sms_i)
                      state_nxt = RSCRPAUSE;
                    else
                      state_nxt = UPDATE3;
      UPDATE3     : state_nxt = COMPRESS;
//COMPRESS sub-program
      COMPRESS    : state_nxt = COMPRSTATE;
      COMPRSTATE  : state_nxt = COMPRPAUSE;
      COMPRPAUSE  : if(compr_expand_on)
                      state_nxt = COMPRPAUSE;
                    else
                      state_nxt = POSTCOMPR;
      POSTCOMPR   : state_nxt = FUNCTIONAL;
//READ sub-program
      READ        : state_nxt = READSTATE;
      READSTATE   : state_nxt = READPAUSE;
      READPAUSE   : if(driver_on)
                      state_nxt = READPAUSE;
                    else if(smart_on_r)
                      state_nxt = POSTREAD;
                    else
                      state_nxt = RESET;
      PROGRAMSTATE: state_nxt = PROGRAMPAUSE;
      PROGRAMPAUSE: if(driver_on)
                      state_nxt = PROGRAMPAUSE;
                    else
                      state_nxt = RESET;
//COMPARE sub-program
      COMPARE     : state_nxt = PROGRAMSTATE;
      default     : state_nxt = RESET;
    endcase
  end


//Non-blocking assignment
always @ (posedge clk_sfbp or negedge rst_sfbp)
  if(!rst_sfbp)
    begin
      {state_r,smart1_r,smart2_r}             <=  {RESET,2'd0};
      ready_counter_r                         <=  3'd0;
      {sms_ready_r,sms_fail_r}                <=  2'd0;
      tie_offs_r                              <=  30'd0;
      smart_on_r                              <=  1'b0;
      {efread_r,efcompare_r}                  <=  2'd0;
      {start_compress_r,start_expand_r}       <=  2'd0;
      skip_fread_r                            <=  1'b0;
      select_master_r                         <=  2'd0;
      seq_count_r                             <=  3'd0;
      star_fail_r                             <=  1'b0;
      star_fail_vec_r                         <=  30'd0;
      sms_counter_r                           <=  5'd29;
      pwdn_r                                  <=  2'd0;
      power_off_del_r                         <=  1'b0;
      first_bit_en_r                          <=  1'b0;
      wait4start_r                            <=  1'b0;
      ch_size_counter_r                       <=  10'd0;
      {ready_r,net_send_r}                    <=  {1'b1,1'b0};
      instr_reg_r                             <=  6'd0;
      rscr_id_err_r                           <=  1'b0;
      efread_flag_r                           <=  1'b0;
    end
  else
    begin
      {state_r,smart1_r,smart2_r}             <=  {state_nxt,smart_int,smart1_r};
      ready_counter_r                         <=  ready_counter_nxt;
      {sms_ready_r,sms_fail_r}                <=  {sms_ready_nxt,sms_fail_nxt};
      tie_offs_r                              <=  tie_offs_nxt;
      smart_on_r                              <=  smart_on_nxt;
      {efread_r,efcompare_r}                  <=  {efread_nxt,efcompare_nxt};
      {start_compress_r,start_expand_r}       <=  {start_compress_nxt,start_expand_nxt};
      skip_fread_r                            <=  skip_fread_nxt;
      select_master_r                         <=  select_master_nxt;
      seq_count_r                             <=  seq_count_nxt;
      star_fail_r                             <=  star_fail_nxt;
      star_fail_vec_r                         <=  star_fail_vec_nxt;
      sms_counter_r                           <=  sms_counter_nxt;
      pwdn_r                                  <=  pwdn_nxt;
      power_off_del_r                         <=  power_off_i;
      first_bit_en_r                          <=  first_bit_en_nxt;
      wait4start_r                            <=  wait4start_nxt;
      ch_size_counter_r                       <=  ch_size_counter_nxt;
      {ready_r,net_send_r}                    <=  {ready_nxt,net_send_nxt};
      instr_reg_r                             <=  instr_reg_nxt;
      rscr_id_err_r                           <=  rscr_id_err_nxt;
      efread_flag_r                           <=  efread_flag_nxt;
    end

endmodule

