/*---------------------------------------------------------------------*/
/*               Copyright(c) Synopsys, Inc.                           */
/*     All Rights reserved - Unpublished -rights reserved under        */
/*     the Copyright laws of the United States of America.             */
/*                                                                     */
/*  U.S. Patents: 7,093,156 B1 and 7,406,620 B2 (and more pending).    */
/*                                                                     */
/*  This file includes the Confidential information of Synopsys, Inc.. */
/*  The receiver of this Confidential Information shall not disclose   */
/*  it to any third party and shall protect its confidentiality by     */
/*  using the same degree of care, but not less then a reasonable      */
/*  degree of care, as the receiver uses to protect receiver's own     */
/*  Confidential Information.                                          */
/*  Licensee acknowledges and agrees that all output generated for     */
/*  Licensee by Synopsys, Inc. as described in the pertinent Program   */
/*  Schedule(s), or generated by Licensee through use of any Compiler  */
/*  licensed hereunder contains information that complies with the     */
/*  Virtual Component Identification Physical Tagging Standard (VCID)  */
/*  as maintained by the Virtual Socket Interface Alliance (VSIA).     */
/*  Such information may be expressed in GDSII Layer 63 or other such  */
/*  layer designated by the VSIA, hardware definition languages, or    */
/*  other formats.  Licensee is not authorized to alter or change any  */
/*  such information.                                                  */
/*---------------------------------------------------------------------*/
/*                                                                     */
/*  Built for linux64 and running on linux64.                          */
/*                                                                     */
/*  Software           : Rev: M-2017.03                                */
/*  Library Format     : Rev: 1.05.00                                  */
/*  Compiler Name      : vl00x000vpnnstsrv000sa31                      */
/*  Platform           : Linux2.6.32-573.el6.x86_64                    */
/*                     : #1 SMP Wed Jul 1 18:23:37 EDT 2015x86_64      */
/*  Date of Generation : Tue Oct 10 23:43:01 EDT 2017                  */
/*                                                                     */
/*---------------------------------------------------------------------*/
`resetall
// T I M E S C A L E ===============================================================================
`ifndef SMS_NO_TIMESCALE
    `timescale 1ns/1ps
`endif

module smsg_gc6_rp_sfp (
//Inputs
                        wrck,
                        rst_sfbp,
                        wrstn,
                        wsi,
                        update_puls,
                        instr,
                        capturedr,
                        shiftdr,
                        updatedr,
                        test_mode,
                        smart,
                        fast_mode,
                        bist_run,
                        bisr_run,
                        bihr_run,
                        data_from_sms_p1500,
                        ready_ef,
                        byte_in_ef,

//Outputs
                        sfp_ready,
                        sfp_fail,
                        addr,
                        req_ef,
                        wir2sms_p1500,
                        data2sms_p1500,
                        capt2sms_p1500,
                        shift2sms_p1500,
                        update2sms_p1500,
                        data_reg_out
);
input wrck;
input rst_sfbp;
input wrstn;
input wsi;
input update_puls;
input [5:0] instr;
input capturedr;
input shiftdr;
input updatedr;
input test_mode;
input smart;
input fast_mode;
input bist_run;
input bisr_run;
input bihr_run;
input data_from_sms_p1500;
input ready_ef;
input [7:0] byte_in_ef;

output sfp_ready;
output sfp_fail;
output [6:0]addr;
output req_ef;
output wir2sms_p1500;
output data2sms_p1500;
output capt2sms_p1500;
output shift2sms_p1500;
output update2sms_p1500;
output data_reg_out;

//Wires
wire instr_ready;
wire shift_instr;
wire [5:0]instr2net;
wire net_send;
wire data2sms;
wire update;
wire [1:0]select_master;
wire smart_int;
wire fast_mode_int;
wire bist_run_int;
wire bisr_run_int;
wire bihr_run_int;
wire sms_fail;
wire capture_data;
wire shift_data;
wire last_sms;
wire driver_on;
wire dummy_shift2sms_chain;
wire early_abort;
wire efcompare;
wire efread;
wire smart_flow;
wire start_compress;
wire start_expand;
wire shift_rscr_id;
wire rscr_id_err;
wire test_contr_ready;
wire cycling;
wire data_sh_en_drv;
wire compare_err;
wire [9:0]addr_ef;
wire signature_in;
wire signature_en;
wire data2sms_sh_compr;
wire overflow;
wire data2sms_compr;
wire compr_expand_on;
wire clean_status;
wire signature_out;
wire dout_ef;
assign addr = addr_ef[9:3];
wire last_dummy_loop;
wire decr_sms_cntr;
wire fast_load;
wire ef_sign_read;
wire curr_sms_bypass_ctrl;
wire [3:0]sms_cntr;
wire efread_flag;
wire  mux_data_msb_nxt;

smsg_gc6_rp_controller U_smsg_gc6_rp_controller(
                        .clk_sfbp (wrck),
                        .rst_sfbp (rst_sfbp),
                        .compr_expand_on (compr_expand_on),
                        .rscr_id_err (rscr_id_err),
                        .driver_on (driver_on),
                        .early_abort (early_abort),
                        .instr (instr),
                        .update_puls (update_puls),
                        .clean_status (clean_status),
                        .last_dummy_loop(last_dummy_loop),
                        .sms_cntr (sms_cntr),
                        .fast_load (fast_load),
                        .decr_sms_cntr (decr_sms_cntr),
                        .efread_flag (efread_flag),
                        .smart_int (smart_int),
                        .fast_mode_int (fast_mode_int),
                        .bist_run_int (bist_run_int),
                        .bisr_run_int (bisr_run_int),
                        .bihr_run_int (bihr_run_int),
                        .shiftdr (shiftdr),
                        .data_from_sms_p1500 (data_from_sms_p1500),
                        .instr_ready (instr_ready),
                        .select_master (select_master),
                        .efcompare (efcompare),
                        .efread (efread),
                        .smart_flow (smart_flow),
                        .start_compress (start_compress),
                        .start_expand (start_expand),
                        .shift_rscr_id (shift_rscr_id),
                        .dummy_shift2sms_chain (dummy_shift2sms_chain),
                        .last_sms (last_sms),
                        .sms_fail (sms_fail),
                        .capture_data (capture_data),
                        .shift_data (shift_data),
                        .update (update),
                        .instr2net (instr2net),
                        .net_send (net_send),
                        .test_contr_ready (test_contr_ready)
);
                        
smsg_gc6_rp_efuse_drv U_smsg_gc6_rp_efuse_drv(
                        .clk_sfbp (wrck),
                        .rst_sfbp (rst_sfbp),
                        .efread (efread),
                        .efcompare (efcompare),
                        .ack_ef  (ready_ef),
                        .dout_ef (dout_ef),
                        .data_in (signature_out),
                        .smart_flow (smart_flow),
                        .driver_on (driver_on),
                        .cycling (cycling),
                        .data_shift_en (data_sh_en_drv),
                        .req_ef (req_ef),
                        .addr_ef (addr_ef),
                        .compare_err (compare_err),
                        .early_abort (early_abort)
);

smsg_gc6_rp_mux U_smsg_gc6_rp_mux(
                        .clk_sfbp (wrck),
                        .rst_sfbp (rst_sfbp),
                        .wrstn (wrstn),
                        .sfbp_wsi (wsi),
                        .instr (instr),
                        .capturedr (capturedr),
                        .shiftdr (shiftdr),
                        .updatedr (updatedr),
                        .update_puls (update_puls),
                        .test_mode (test_mode),
                        .select_master (select_master),
                        .data2sms (data2sms),                      
                        .shift_instr (shift_instr),
                        .instr_ready (instr_ready),
                        .shift_data (shift_data),
                        .capture_data (capture_data),
                        .sms_fail (sms_fail),                 
                        .update (update),
                        .test_contr_ready (test_contr_ready),
                        .signature_in (signature_in),
                        .signature_en (signature_en),
                        .start_compress (start_compress),
                        .shift_rscr_id (shift_rscr_id),
                        .data_from_sms_p1500 (data_from_sms_p1500),
                        .dummy_shift2sms_chain (dummy_shift2sms_chain),
                        .overflow (overflow),
                        .data2sms_compr (data2sms_compr),
                        .data2sms_sh_compr (data2sms_sh_compr),
                        .rscr_id_err (rscr_id_err),
                        .data_sh_en_drv (data_sh_en_drv),    
                        .cycling (cycling),
                        .compare_err (compare_err),
                        .byte_in_ef (byte_in_ef),
                        .addr_lsb (addr_ef[2:0]),
                        .smart (smart),
                        .fast_mode (fast_mode),
                        .bist_run (bist_run),
                        .bisr_run (bisr_run),
                        .bihr_run (bihr_run),
                        .data_reg_out (data_reg_out),
                        .wir2sms_p1500 (wir2sms_p1500),
                        .data2sms_p1500 (data2sms_p1500),
                        .capt2sms_p1500 (capt2sms_p1500),
                        .shift2sms_p1500 (shift2sms_p1500),
                        .update2sms_p1500 (update2sms_p1500),
                        .output_data (signature_out),
                        .efuse_serial_data (dout_ef),
                        .smart_int (smart_int),
                        .fast_mode_int (fast_mode_int),
                        .bist_run_int (bist_run_int),
                        .bisr_run_int (bisr_run_int),
                        .bihr_run_int (bihr_run_int),
                        .mux_data_msb_nxt (mux_data_msb_nxt),
                        .last_dummy_loop(last_dummy_loop),
                        .ef_sign_read (ef_sign_read),
                        .clean_status (clean_status),
                        .sfbp_fail (sfp_fail),
                        .sfbp_ready (sfp_ready)
);

smsg_gc6_rp_net_send_engine U_smsg_gc6_rp_net_send_engine(
                        .clk_sfbp (wrck),
                        .rst_sfbp (rst_sfbp),
                        .last_sms (last_sms),
                        .curr_sms_bypass_ctrl (curr_sms_bypass_ctrl),
                        .decr_sms_cntr (decr_sms_cntr),
                        .fast_load (fast_load),
                        .instr2net (instr2net),
                        .net_send (net_send),
                        .data2sms (data2sms),
                        .instr_ready (instr_ready),
                        .shift_instr (shift_instr)
);

smsg_gc6_rp_ce U_smsg_gc6_rp_ce (
                        .wrck (wrck),
                        .rst_sfbp (rst_sfbp),
                        .clean_status (clean_status),                        
                        .start_compress (start_compress),
                        .start_expand (start_expand),
                        .signature_out (signature_out),

                        .data_from_sms_p1500_n (data_from_sms_p1500),
                        .compr_expand_on (compr_expand_on),
                        .signature_in (signature_in),
                        .signature_en (signature_en),
                        .overflow (overflow),
                        .mux_data_msb_nxt (mux_data_msb_nxt),
                        .last_dummy_loop(last_dummy_loop),
                        .early_abort(early_abort),
                        .ef_sign_read (ef_sign_read),
                        .driver_on (driver_on), 
                        .data_sh_en_drv (data_sh_en_drv),
                        .dout_ef (dout_ef),
                        .curr_sms_bypass_ctrl (curr_sms_bypass_ctrl),
                        .sms_cntr (sms_cntr),
                        .efread_flag (efread_flag),
                        .data2sms_compr (data2sms_compr),
                        .data2sms_sh_compr (data2sms_sh_compr)
);

endmodule
