//                              -*- Mode: Verilog -*-

////////////////////////////////////////////////////////////////////////////
/*
 *
 *  Trade secret of ATI Technologies, Inc.
 *  Copyright 2005, ATI Technologies, Inc., (unpublished)
 *
 *  All rights reserved.  This notice is intended as a precaution against
 *  inadvertent publication and does not imply publication or any waiver
 *  of confidentiality.  The year included in the foregoing notice is the
 *  year of creation of the work.
 *
 */
////////////////////////////////////////////////////////////////////////////
//
// Filename    : spare_tdr.v
// Description : spare TDR bits
//
////////////////////////////////////////////////////////////////////////////

//`include "dftmisc_features.vh"

//;use comp_config;


module spare_tdr_gc10 ( 


//Broadcast to All TDRs
input Tdr_Tck,
input Tdr_Trstb,
input Tdr_Shift,
input Tdr_Capture,
input Tdr_Update



//TDR --> SPARE_TDR

 ,output wire spare_tdr_bit0
 ,output wire spare_tdr_bit1
 ,output wire spare_tdr_bit2
 ,output wire spare_tdr_bit3
 ,output wire spare_tdr_bit4
 ,output wire spare_tdr_bit5
 ,output wire spare_tdr_bit6
 ,output wire spare_tdr_bit7

 ,input Tdr_spare_tdr_Tdi
 ,input Tdr_spare_tdr_En
 ,output Tdr_spare_tdr_Tdo
); // End of Port Declaration



wire [8-1:0] spare_bits;
  assign spare_tdr_bit0 = spare_bits[0];
  assign spare_tdr_bit1 = spare_bits[1];
  assign spare_tdr_bit2 = spare_bits[2];
  assign spare_tdr_bit3 = spare_bits[3];
  assign spare_tdr_bit4 = spare_bits[4];
  assign spare_tdr_bit5 = spare_bits[5];
  assign spare_tdr_bit6 = spare_bits[6];
  assign spare_tdr_bit7 = spare_bits[7];



spare_tdr_bits_gc10 spare_tdr_bits ( 

 .Tdr_Tck               (Tdr_Tck) ,
 .Tdr_Trstb             (Tdr_Trstb),
 .Tdr_Tdi               (Tdr_spare_tdr_Tdi),
 .Tdr_Shift             (Tdr_Shift),
 .Tdr_Capture           (Tdr_Capture),
 .Tdr_Update            (Tdr_Update)


//TDR --> SPARE_TDR
 ,.spare_bits            (spare_bits[8-1:0])
 ,.Tdr_spare_tdr_En             (Tdr_spare_tdr_En)
 ,.Tdr_spare_tdr_Tdo            (Tdr_spare_tdr_Tdo)
); 


endmodule
