module sram_mem2p_fgcg_cov
(//input to sram_mem2p_fgcg
 input CLKA,
 input srst,
 input MEA,
 input MEB,
 input PIPEMEB,
 input RM_VALID,
 input CLKA_gated,
 input clk_en
);

//////////////////////////

//VCS coverage exclude_module
`ifdef VCS

`ifdef GFX_CG_W2E
reg enable;
initial begin
  if($test$plusargs("sram_fgcg_assert_enable"))
    enable = 1'b1;
  else
    enable = 1'b0;
end

reg hier_enable;
string Hier;
initial begin
  hier_enable = 1'b1;
  $sformat(Hier, "%m");
//`ifdef CG_WORKAROUND_CHECKER
//for(integer i=0;i<Hier.len();i++) 
//begin 
//    if((Hier.substr(i,i+2)==".cb") || (Hier.substr(i,i+2)==".db") || (Hier.substr(i,i+2)=="ge2") || (Hier.substr(i,i+2)=="rmi"))      
//	begin 
//           hier_enable=1'b0; 
//           `MSGIO_DISPLAY("%m: WARNING: sram_fgcg assertion is waived via hierarchy");
//           break; 
//    end
//end
//`endif
end


reg RM_VALID_activated;
initial RM_VALID_activated = 0;
always @(posedge CLKA) if(RM_VALID == 1'b1) RM_VALID_activated <= 1;
final if((RM_VALID_activated == 0) && enable && hier_enable) `MSGIO_DISPLAY("%m ERROR: RM_VALID never activated");

//override coverage check
reg RM_VALID_pos_activated;
reg RM_VALID_1d;
initial RM_VALID_pos_activated = 0;
initial RM_VALID_1d = 1;
always @(posedge CLKA) RM_VALID_1d <= RM_VALID;
always @(posedge CLKA) RM_VALID_pos_activated <= ((RM_VALID & (~RM_VALID_1d)) | RM_VALID_pos_activated);
final if((RM_VALID_pos_activated == 0) && enable && hier_enable) `MSGIO_DISPLAY("%m ERROR: RM_VALID never change from 0 to 1, override coverage check");

//override -> clock active
gated_clk_active :  assert property (@(negedge CLKA) disable iff((~enable)|| (~hier_enable)) (clk_en |=> (CLKA_gated)));
//bpm fgcg override -> clock active
//bpm fgcg override -> clock_en active
wire tb_bpm_fgcg_override;
assign tb_bpm_fgcg_override = tb.clock_gating_monitor.bpm_fgcg_override;
tb_gated_clk_active :     assert property (@(negedge CLKA) disable iff((~enable) || (~hier_enable)) ((tb_bpm_fgcg_override) |=> ##[0:50] (CLKA_gated))); 
tb_gated_clk_en_active :  assert property (@(negedge CLKA) disable iff((~enable) || (~hier_enable)) ((tb_bpm_fgcg_override) |-> ##[0:50] (clk_en))); 

tb_gated_clk_en_rose :  assert property (@(posedge CLKA) disable iff((~enable) || (~hier_enable)) (($rose(tb_bpm_fgcg_override)) |-> ##[0:50] ($rose(clk_en)))); 


`endif //!`ifdef GFX_CG_W2E

`else // !`ifdef VCS

initial begin
  $display("%m at %0t: src/rtl/shared/sram_fgcg_cov.sv: SVA not yet supported in NCSIM in wekiva scripts", $realtime);
end

`endif // VCS


endmodule
