//****************************************
// Warning! This file is machine generated
//****************************************


//======================================================================
//                       Zen RTL design file
//=======================================================================
//                  AMD PROPRIETARY AND CONFIDENTIAL
//           (c) Copyright 2012 Advanced Micro Devices, Inc.
//=======================================================================
// Module Description:
// Behavioral model for async set/reset rising edge non-scan D flip flop.
//=======================================================================
`timescale 1ps/1ps
module srdff_mapsmro #(
    parameter WIDTH = 1
)(
    // default WIDTH of output
    output [WIDTH-1:0] q,
    // data out
    input clk,
    // clock
    input [WIDTH-1:0] d,
    // data in
    input set,
    // async set
    input rst
    // async reset or clear
);
    reg [WIDTH-1:0] srdff_q;
    wire [WIDTH-1:0] intd;
    wire [WIDTH-1:0] lat2_q;
    // Turn off rule that caused this failure:
    // NTL_STR56: Do not use sequential registers with both asynchronous set and asynchronous reset
    // leda NTL_STR56 off
    // lat2 changed to mapsmro_lat2 on 22/02/2017
    mapsmro_lat2 #(.WIDTH(WIDTH)) I_lat2 (
        .q(lat2_q),
        .d(d),
        .clk(clk)
    );
    assign   intd=rst ? {WIDTH{1'b0}} : 
        ~rst ? clk ? lat2_q : 
        ~clk ? q : {1{1'bx}} : {1{1'bx}};
    // lat1 changed to mapsmro_lat1 on 22/02/2017
    mapsmro_lat1 #(.WIDTH(WIDTH)) I_lat1 (
        .q(srdff_q),
        .d(intd),
        .clk(clk|rst)
    );
    assign   q=srdff_q;
    // leda NTL_STR56 on

endmodule


//****************************************
// Warning! This file is machine generated
//****************************************
