module srf_reset_tdr_gc10 ( 


//Broadcast to All TDRs
input Tdr_Tck,
input Tdr_Trstb,
input Tdr_Tdi,
input Tdr_Shift,
input Tdr_Capture,
input Tdr_Update



//TDR --> SRF_RESET
 ,output wire srf_rst
 ,input Tdr_srf_reset_En
 ,output Tdr_srf_reset_Tdo
); // End of Port Declaration

///// START TDR_INST - SRF_RESET /////

   localparam SRF_RESET__WIDTH = 1;
   wire [SRF_RESET__WIDTH-1:0]	SRF_RESET;
   wire [SRF_RESET__WIDTH-1:0]	SRF_RESET__DEFAULT;  

	//SRF_RESET - 0:0

   localparam  SRF_RESET_SRF_RESET__WIDTH  = 1;
   localparam [SRF_RESET_SRF_RESET__WIDTH-1:0] SRF_RESET_SRF_RESET__DEFAULT  = 1'h0;
   

   localparam  SRF_RESET_SRF_RESET__MSB  = 0;
   localparam  SRF_RESET_SRF_RESET__LSB  = 0;
   

   assign SRF_RESET__DEFAULT
                 [SRF_RESET_SRF_RESET__MSB : 
                  SRF_RESET_SRF_RESET__LSB] =  
		  SRF_RESET_SRF_RESET__DEFAULT;
   

  ati_buffer1 mrk_srf_reset[SRF_RESET_SRF_RESET__WIDTH-1:0] 
  (
    .A(SRF_RESET
      [SRF_RESET_SRF_RESET__MSB :
       SRF_RESET_SRF_RESET__LSB
      ]),    
    .Y(srf_rst)
  );





   test_reg_async_rst_gc10
     #(SRF_RESET__WIDTH)
   reg_SRF_RESET (
                           .clk(Tdr_Tck),
                           .rstb(Tdr_Trstb),
                           .en(Tdr_srf_reset_En),
                           .shift(Tdr_Shift & Tdr_srf_reset_En),
                           .capture(Tdr_Capture & Tdr_srf_reset_En),
                           .update(Tdr_Update & Tdr_srf_reset_En),
                           .d_rst(SRF_RESET__DEFAULT),
                           .q(SRF_RESET),
                           .d(SRF_RESET),
                           .si(Tdr_Tdi),
                           .so(Tdr_srf_reset_Tdo),
                           .q_sr(),
                           .q_sr_posedge()
                           );









///// END TDR_INST - SRF_RESET /////
endmodule
