`timescale 1ns/100ps
module sync3_pulse (ICLK, IRESET, SYNC_IN, OCLK, DBL_FLOP_EN, LATENCY,
        `ifdef ABV   
        InputChkDis, 
        `endif  
SYNC_OUT);
input ICLK;
input IRESET;
input SYNC_IN;
`ifdef ABV
input InputChkDis ;
`endif
input OCLK;
input DBL_FLOP_EN;
input [1:0] LATENCY;
output SYNC_OUT;
wire    in_pulse;
wire    in_ff_in;
wire    sync_ff_out;
wire in_ff_out;
reg out_ff_out;
assign in_pulse = SYNC_IN ^ in_ff_out;
assign in_ff_in = in_pulse && !IRESET;
// sync3_wrapper2_1b sync3_wrapper2_1b (
//    .SRC_CLK      (ICLK),
//    .DST_CLK      (OCLK),
//    `ifdef ABV
//    .InputChkDis(InputChkDis),
//    `endif
//    .DBL_FLOP_EN  (DBL_FLOP_EN),
//    .D            (in_ff_in),
//    .Q            (sync_ff_out),
//    .Q_SRC        (in_ff_out)
// );
//sync_wrapper2_1b sync_wrapper2_1b (
//  .SRC_CLK      (ICLK),
//  .DST_CLK      (OCLK),
//  .DBL_FLOP_EN  (1'b1),
//  .D            (in_ff_in),
//  .Q            (sync_ff_out),
//  .Q_SRC        (in_ff_out)
//);
    
techind_sync_icd #(.depth           (3),
                   .sourceFlop      (1),
                   .TransportCycle  (0)
       )
u_techind_sync(
               .SB              (1'b1       ),
               .RB              (1'b1       ),
               .FLUSH           (1'b0       ),
               .CKsrc           (ICLK       ),
               .CKdst           (OCLK       ),
               .EN              (1'b1       ),
               .Dsrc            (in_ff_in   ),
               .Qsrc            (in_ff_out  ),
               .Qdst            (sync_ff_out),
               `ifdef ABV
               .InputChkDis     (InputChkDis),
               `endif
               .SC1             (1'b0       ),
               .SC2             (1'b0       ),
               .SE              (1'b0       ),
               .SI              (1'b0       ),
               .SO              ()
       ) ;

always @(posedge OCLK) out_ff_out <= sync_ff_out;
assign SYNC_OUT = sync_ff_out ^ out_ff_out;
endmodule
