//                              -*- Mode: Verilog -*-

////////////////////////////////////////////////////////////////////////////
/*
 *
 *  Trade secret of ATI Technologies, Inc.
 *  Copyright 2005, ATI Technologies, Inc., (unpublished)
 *
 *  All rights reserved.  This notice is intended as a precaution against
 *  inadvertent publication and does not imply publication or any waiver
 *  of confidentiality.  The year included in the foregoing notice is the
 *  year of creation of the work.
 *
 */
////////////////////////////////////////////////////////////////////////////
//
// Filename    : tdr_broadcast.v
// Description : TDR Broadcast
//
////////////////////////////////////////////////////////////////////////////

//`include "dftmisc_features.vh"

//;use comp_config;
//;use POSIX;


//;my 16 = 48;
//;my  = ceil ( log(16)/log(2) ) ;



module tdr_broadcast_16  (

input   Tdr_Broadcast_En,
input   Tdr_Tdi,  //Broadcast WSI

output wire Tdr_Tdi_0,
input  wire Tdr_Tdo_0,
output wire Tdr_Tdi_1,
input  wire Tdr_Tdo_1,
output wire Tdr_Tdi_2,
input  wire Tdr_Tdo_2,
output wire Tdr_Tdi_3,
input  wire Tdr_Tdo_3,
output wire Tdr_Tdi_4,
input  wire Tdr_Tdo_4,
output wire Tdr_Tdi_5,
input  wire Tdr_Tdo_5,
output wire Tdr_Tdi_6,
input  wire Tdr_Tdo_6,
output wire Tdr_Tdi_7,
input  wire Tdr_Tdo_7,
output wire Tdr_Tdi_8,
input  wire Tdr_Tdo_8,
output wire Tdr_Tdi_9,
input  wire Tdr_Tdo_9,
output wire Tdr_Tdi_10,
input  wire Tdr_Tdo_10,
output wire Tdr_Tdi_11,
input  wire Tdr_Tdo_11,
output wire Tdr_Tdi_12,
input  wire Tdr_Tdo_12,
output wire Tdr_Tdi_13,
input  wire Tdr_Tdo_13,
output wire Tdr_Tdi_14,
input  wire Tdr_Tdo_14,
output wire Tdr_Tdi_15,
input  wire Tdr_Tdo_15,

output  Tdr_Tdo  

);
parameter TOTAL_TDR_INST = 1;

//Create Bus
wire [15:0] tdi;
wire [15:0] tdo;

assign tdo[0] = Tdr_Tdo_0;
assign Tdr_Tdi_0 = tdi[0];
assign tdo[1] = Tdr_Tdo_1;
assign Tdr_Tdi_1 = tdi[1];
assign tdo[2] = Tdr_Tdo_2;
assign Tdr_Tdi_2 = tdi[2];
assign tdo[3] = Tdr_Tdo_3;
assign Tdr_Tdi_3 = tdi[3];
assign tdo[4] = Tdr_Tdo_4;
assign Tdr_Tdi_4 = tdi[4];
assign tdo[5] = Tdr_Tdo_5;
assign Tdr_Tdi_5 = tdi[5];
assign tdo[6] = Tdr_Tdo_6;
assign Tdr_Tdi_6 = tdi[6];
assign tdo[7] = Tdr_Tdo_7;
assign Tdr_Tdi_7 = tdi[7];
assign tdo[8] = Tdr_Tdo_8;
assign Tdr_Tdi_8 = tdi[8];
assign tdo[9] = Tdr_Tdo_9;
assign Tdr_Tdi_9 = tdi[9];
assign tdo[10] = Tdr_Tdo_10;
assign Tdr_Tdi_10 = tdi[10];
assign tdo[11] = Tdr_Tdo_11;
assign Tdr_Tdi_11 = tdi[11];
assign tdo[12] = Tdr_Tdo_12;
assign Tdr_Tdi_12 = tdi[12];
assign tdo[13] = Tdr_Tdo_13;
assign Tdr_Tdi_13 = tdi[13];
assign tdo[14] = Tdr_Tdo_14;
assign Tdr_Tdi_14 = tdi[14];
assign tdo[15] = Tdr_Tdo_15;
assign Tdr_Tdi_15 = tdi[15];


ati_buffer1 mrk_Tdi_0   (.A(Tdr_Tdi),  .Y(tdi[0]));  

generate 
genvar i;
 for (i=1; i< 16; i=i+1) begin  : mux_tditdo
  assign tdi[i] =  Tdr_Broadcast_En ? Tdr_Tdi : tdo[i-1];
 end
endgenerate

wire Tdr_Tdo_Last = tdo[TOTAL_TDR_INST-1];
ati_buffer1 mrk_Tdo   (.A(Tdr_Tdo_Last),  .Y(Tdr_Tdo));  

`ifdef ABV
generate
if(TOTAL_TDR_INST >= 16) begin
initial begin
 //$fatal("%m :: Illegal parameter passing. TOTAL_TDR_INST > 16 ");
 $display("ERROR:: Illegal parameter passing. TOTAL_TDR_INST > 16, %m");
end
end
endgenerate
`endif


endmodule
