//                              -*- Mode: Verilog -*-

////////////////////////////////////////////////////////////////////////////
/*
 *
 *  Trade secret of ATI Technologies, Inc.
 *  Copyright 2005, ATI Technologies, Inc., (unpublished)
 *
 *  All rights reserved.  This notice is intended as a precaution against
 *  inadvertent publication and does not imply publication or any waiver
 *  of confidentiality.  The year included in the foregoing notice is the
 *  year of creation of the work.
 *
 */
////////////////////////////////////////////////////////////////////////////
//
// Filename    : tdr_broadcast.v
// Description : TDR Broadcast
//
////////////////////////////////////////////////////////////////////////////

//`include "dftmisc_features.vh"

//;use comp_config;
//;use POSIX;


//;my 32 = 48;
//;my  = ceil ( log(32)/log(2) ) ;



module tdr_broadcast_32  (

input   Tdr_Broadcast_En,
input   Tdr_Tdi,  //Broadcast WSI

output wire Tdr_Tdi_0,
input  wire Tdr_Tdo_0,
output wire Tdr_Tdi_1,
input  wire Tdr_Tdo_1,
output wire Tdr_Tdi_2,
input  wire Tdr_Tdo_2,
output wire Tdr_Tdi_3,
input  wire Tdr_Tdo_3,
output wire Tdr_Tdi_4,
input  wire Tdr_Tdo_4,
output wire Tdr_Tdi_5,
input  wire Tdr_Tdo_5,
output wire Tdr_Tdi_6,
input  wire Tdr_Tdo_6,
output wire Tdr_Tdi_7,
input  wire Tdr_Tdo_7,
output wire Tdr_Tdi_8,
input  wire Tdr_Tdo_8,
output wire Tdr_Tdi_9,
input  wire Tdr_Tdo_9,
output wire Tdr_Tdi_10,
input  wire Tdr_Tdo_10,
output wire Tdr_Tdi_11,
input  wire Tdr_Tdo_11,
output wire Tdr_Tdi_12,
input  wire Tdr_Tdo_12,
output wire Tdr_Tdi_13,
input  wire Tdr_Tdo_13,
output wire Tdr_Tdi_14,
input  wire Tdr_Tdo_14,
output wire Tdr_Tdi_15,
input  wire Tdr_Tdo_15,
output wire Tdr_Tdi_16,
input  wire Tdr_Tdo_16,
output wire Tdr_Tdi_17,
input  wire Tdr_Tdo_17,
output wire Tdr_Tdi_18,
input  wire Tdr_Tdo_18,
output wire Tdr_Tdi_19,
input  wire Tdr_Tdo_19,
output wire Tdr_Tdi_20,
input  wire Tdr_Tdo_20,
output wire Tdr_Tdi_21,
input  wire Tdr_Tdo_21,
output wire Tdr_Tdi_22,
input  wire Tdr_Tdo_22,
output wire Tdr_Tdi_23,
input  wire Tdr_Tdo_23,
output wire Tdr_Tdi_24,
input  wire Tdr_Tdo_24,
output wire Tdr_Tdi_25,
input  wire Tdr_Tdo_25,
output wire Tdr_Tdi_26,
input  wire Tdr_Tdo_26,
output wire Tdr_Tdi_27,
input  wire Tdr_Tdo_27,
output wire Tdr_Tdi_28,
input  wire Tdr_Tdo_28,
output wire Tdr_Tdi_29,
input  wire Tdr_Tdo_29,
output wire Tdr_Tdi_30,
input  wire Tdr_Tdo_30,
output wire Tdr_Tdi_31,
input  wire Tdr_Tdo_31,

output  Tdr_Tdo  

);
parameter TOTAL_TDR_INST = 1;

//Create Bus
wire [31:0] tdi;
wire [31:0] tdo;

assign tdo[0] = Tdr_Tdo_0;
assign Tdr_Tdi_0 = tdi[0];
assign tdo[1] = Tdr_Tdo_1;
assign Tdr_Tdi_1 = tdi[1];
assign tdo[2] = Tdr_Tdo_2;
assign Tdr_Tdi_2 = tdi[2];
assign tdo[3] = Tdr_Tdo_3;
assign Tdr_Tdi_3 = tdi[3];
assign tdo[4] = Tdr_Tdo_4;
assign Tdr_Tdi_4 = tdi[4];
assign tdo[5] = Tdr_Tdo_5;
assign Tdr_Tdi_5 = tdi[5];
assign tdo[6] = Tdr_Tdo_6;
assign Tdr_Tdi_6 = tdi[6];
assign tdo[7] = Tdr_Tdo_7;
assign Tdr_Tdi_7 = tdi[7];
assign tdo[8] = Tdr_Tdo_8;
assign Tdr_Tdi_8 = tdi[8];
assign tdo[9] = Tdr_Tdo_9;
assign Tdr_Tdi_9 = tdi[9];
assign tdo[10] = Tdr_Tdo_10;
assign Tdr_Tdi_10 = tdi[10];
assign tdo[11] = Tdr_Tdo_11;
assign Tdr_Tdi_11 = tdi[11];
assign tdo[12] = Tdr_Tdo_12;
assign Tdr_Tdi_12 = tdi[12];
assign tdo[13] = Tdr_Tdo_13;
assign Tdr_Tdi_13 = tdi[13];
assign tdo[14] = Tdr_Tdo_14;
assign Tdr_Tdi_14 = tdi[14];
assign tdo[15] = Tdr_Tdo_15;
assign Tdr_Tdi_15 = tdi[15];
assign tdo[16] = Tdr_Tdo_16;
assign Tdr_Tdi_16 = tdi[16];
assign tdo[17] = Tdr_Tdo_17;
assign Tdr_Tdi_17 = tdi[17];
assign tdo[18] = Tdr_Tdo_18;
assign Tdr_Tdi_18 = tdi[18];
assign tdo[19] = Tdr_Tdo_19;
assign Tdr_Tdi_19 = tdi[19];
assign tdo[20] = Tdr_Tdo_20;
assign Tdr_Tdi_20 = tdi[20];
assign tdo[21] = Tdr_Tdo_21;
assign Tdr_Tdi_21 = tdi[21];
assign tdo[22] = Tdr_Tdo_22;
assign Tdr_Tdi_22 = tdi[22];
assign tdo[23] = Tdr_Tdo_23;
assign Tdr_Tdi_23 = tdi[23];
assign tdo[24] = Tdr_Tdo_24;
assign Tdr_Tdi_24 = tdi[24];
assign tdo[25] = Tdr_Tdo_25;
assign Tdr_Tdi_25 = tdi[25];
assign tdo[26] = Tdr_Tdo_26;
assign Tdr_Tdi_26 = tdi[26];
assign tdo[27] = Tdr_Tdo_27;
assign Tdr_Tdi_27 = tdi[27];
assign tdo[28] = Tdr_Tdo_28;
assign Tdr_Tdi_28 = tdi[28];
assign tdo[29] = Tdr_Tdo_29;
assign Tdr_Tdi_29 = tdi[29];
assign tdo[30] = Tdr_Tdo_30;
assign Tdr_Tdi_30 = tdi[30];
assign tdo[31] = Tdr_Tdo_31;
assign Tdr_Tdi_31 = tdi[31];


ati_buffer1 mrk_Tdi_0   (.A(Tdr_Tdi),  .Y(tdi[0]));  

generate 
genvar i;
 for (i=1; i< 32; i=i+1) begin  : mux_tditdo
  assign tdi[i] =  Tdr_Broadcast_En ? Tdr_Tdi : tdo[i-1];
 end
endgenerate

wire Tdr_Tdo_Last = tdo[TOTAL_TDR_INST-1];
ati_buffer1 mrk_Tdo   (.A(Tdr_Tdo_Last),  .Y(Tdr_Tdo));  

`ifdef ABV
generate
if(TOTAL_TDR_INST >= 32) begin
initial begin
 //$fatal("%m :: Illegal parameter passing. TOTAL_TDR_INST > 32 ");
 $display("ERROR:: Illegal parameter passing. TOTAL_TDR_INST > 32, %m");
end
end
endgenerate
`endif


endmodule
