//                              -*- Mode: Verilog -*-

////////////////////////////////////////////////////////////////////////////
/*
 *
 *  Trade secret of ATI Technologies, Inc.
 *  Copyright 2005, ATI Technologies, Inc., (unpublished)
 *
 *  All rights reserved.  This notice is intended as a precaution against
 *  inadvertent publication and does not imply publication or any waiver
 *  of confidentiality.  The year included in the foregoing notice is the
 *  year of creation of the work.
 *
 */
////////////////////////////////////////////////////////////////////////////
//
// Filename    : test_transistor.v
// Description : test_transistor TDR
//
////////////////////////////////////////////////////////////////////////////

module test_transistor 
(
//Broadcast to All TDRs
 input wire Tdr_Tck,
 input wire Tdr_Trstb,
 input wire Tdr_Shift,
 input wire Tdr_Capture,
 input wire Tdr_Update,
 
 //Tdr
 input wire Tdr_test_transistor_Tdi,
 input wire Tdr_test_transistor_En,
 output wire Tdr_test_transistor_Tdo,

 output wire[7:0] TESTTRAN_Sel

);


///////////////////////////////////////////////////////////////////
wire [8-1:0] testtran_sel;
test_transistor_tdr test_transistor_tdr ( 

 .Tdr_Tck               (Tdr_Tck) ,
 .Tdr_Trstb             (Tdr_Trstb),
 .Tdr_Tdi               (Tdr_test_transistor_Tdi),
 .Tdr_Shift             (Tdr_Shift),
 .Tdr_Capture           (Tdr_Capture),
 .Tdr_Update            (Tdr_Update)


//TDR --> TEST_TRANSISTOR
 ,.testtran_sel          (testtran_sel[8-1:0])
 ,.Tdr_test_transistor_En               (Tdr_test_transistor_En)
 ,.Tdr_test_transistor_Tdo              (Tdr_test_transistor_Tdo)
); 
///////////////////////////////////////////////////////////////////

assign TESTTRAN_Sel = testtran_sel;

endmodule
