//----------------------------------------------------------------------------
// Date		: $Date$
// Copyright	: 1997-2017 by Synopsys, Inc., All Rights Reserved.
// Revision	: $Revision$
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// Cell model definitions.
//----------------------------------------------------------------------------





`timescale 1ps / 1ps

`ifndef SNPS_SEQ_DELAY
`define SNPS_SEQ_DELAY 10
`endif
`ifndef SNPS_COMBO_DELAY
`define SNPS_COMBO_DELAY 0 
`endif
`ifndef SNPS_CKGT_DELAY
`define SNPS_CKGT_DELAY 0
`endif
`ifndef SNPS_CKGTLT_DELAY
`define SNPS_CKGTLT_DELAY 0
`endif
`ifndef SNPS_LAT_DELAY
`define SNPS_LAT_DELAY 10
`endif

`ifdef VIRL_functiononly
    `delay_mode_distributed
    `define _fv
    `define SNPS_MASK_X_OUT_LATCH
    `ifndef SNPS_STD_PRIMS
      `define SNPS_MASK_ERR_UDP
    `endif
`else
    `delay_mode_path
`endif
//%BEGIN HDPLVT08_CDCLVLDBUF_D_1

`celldefine
module HDPLVT08_CDCLVLDBUF_D_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY instt0  (X, A);    
   `else
       buf instt0   (X, A);         
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
(A +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDPLVT08_CDCLVLDBUF_D_1

//%BEGIN HDPLVT08_CDCLVLDINVE1_D_4

`celldefine
module HDPLVT08_CDCLVLDINVE1_D_4 (X, A, EN);
   output X;
   input A, EN;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY instt0  (X, A, EN);
   `else
      nand instt0   (X, A, EN);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (EN==1'b1) (A -=> X)=(0, 0);
if (A==1'b1) (EN -=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDPLVT08_CDCLVLDINVE1_D_4


