//----------------------------------------------------------------------------
// Date		: $Date$
// Copyright	: 1997-2017 by Synopsys, Inc., All Rights Reserved.
// Revision	: $Revision$
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// Cell model definitions.
//----------------------------------------------------------------------------





`timescale 1ps / 1ps

`ifndef SNPS_SEQ_DELAY
`define SNPS_SEQ_DELAY 10
`endif
`ifndef SNPS_COMBO_DELAY
`define SNPS_COMBO_DELAY 0 
`endif
`ifndef SNPS_CKGT_DELAY
`define SNPS_CKGT_DELAY 0
`endif
`ifndef SNPS_CKGTLT_DELAY
`define SNPS_CKGTLT_DELAY 0
`endif
`ifndef SNPS_LAT_DELAY
`define SNPS_LAT_DELAY 10
`endif

`ifdef VIRL_functiononly
    `delay_mode_distributed
    `define _fv
    `define SNPS_MASK_X_OUT_LATCH
    `ifndef SNPS_STD_PRIMS
      `define SNPS_MASK_ERR_UDP
    `endif
`else
    `delay_mode_path
`endif
//%BEGIN HDPLVT08_LVLDBUFE1_IV8Y2FS_4

`celldefine
module HDPLVT08_LVLDBUFE1_IV8Y2FS_4 (X, A, EN);
   output X;
   input A, EN;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0   (int_res_0, EN);

   `ifdef VIRL_functiononly
      or  #`SNPS_COMBO_DELAY instt0  (X, A, int_res_0);
   `else
      or instt0    (X, A, int_res_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (EN==1'b1) (A +=> X)=(0, 0);
if (A==1'b0) (EN -=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDPLVT08_LVLDBUFE1_IV8Y2FS_4

//%BEGIN HDPLVT08_LVLDBUFE1_IV8Y2SRCFS_4

`celldefine
module HDPLVT08_LVLDBUFE1_IV8Y2SRCFS_4 (X, A, EN);
   output X;
   input A, EN;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0   (int_res_0, EN);

   `ifdef VIRL_functiononly
      or  #`SNPS_COMBO_DELAY instt0  (X, A, int_res_0);
   `else
      or instt0    (X, A, int_res_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (EN==1'b1) (A +=> X)=(0, 0);
if (A==1'b0) (EN -=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDPLVT08_LVLDBUFE1_IV8Y2SRCFS_4

//%BEGIN HDPLVT08_LVLDBUFE1_IV8Y2SRC_4

`celldefine
module HDPLVT08_LVLDBUFE1_IV8Y2SRC_4 (X, A, EN);
   output X;
   input A, EN;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0   (int_res_0, EN);

   `ifdef VIRL_functiononly
      or  #`SNPS_COMBO_DELAY instt0  (X, A, int_res_0);
   `else
      or instt0    (X, A, int_res_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (EN==1'b1) (A +=> X)=(0, 0);
if (A==1'b0) (EN -=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDPLVT08_LVLDBUFE1_IV8Y2SRC_4

//%BEGIN HDPLVT08_LVLDBUFE1_IV8Y2_4

`celldefine
module HDPLVT08_LVLDBUFE1_IV8Y2_4 (X, A, EN);
   output X;
   input A, EN;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0   (int_res_0, EN);

   `ifdef VIRL_functiononly
      or  #`SNPS_COMBO_DELAY instt0  (X, A, int_res_0);
   `else
      or instt0    (X, A, int_res_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (EN==1'b1) (A +=> X)=(0, 0);
if (A==1'b0) (EN -=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDPLVT08_LVLDBUFE1_IV8Y2_4

//%BEGIN HDPLVT08_LVLDBUF_UY2_1

`celldefine
module HDPLVT08_LVLDBUF_UY2_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY instt0  (X, A);    
   `else
       buf instt0   (X, A);         
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
(A +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDPLVT08_LVLDBUF_UY2_1

