module vgpr_bank_swizzle (
   input swizzle_en,
   input wave64hi,
   input [1:0] wave_id_lsbs,
   input [1:0] bank_in,
   output logic [1:0] bank_out
);

   logic [1:0] swizzle_code;

   always_comb begin
       swizzle_code = 2'd0 - (wave_id_lsbs ^ wave64hi);
       bank_out = !(swizzle_en) ? bank_in : bank_in ^ swizzle_code;
   end

endmodule
