//                              -*- Mode: Verilog -*-

////////////////////////////////////////////////////////////////////////////
/*
 *
 *  Trade secret of ATI Technologies, Inc.
 *  Copyright 2005, ATI Technologies, Inc., (unpublished)
 *
 *  All rights reserved.  This notice is intended as a precaution against
 *  inadvertent publication and does not imply publication or any waiver
 *  of confidentiality.  The year included in the foregoing notice is the
 *  year of creation of the work.
 *
 */
////////////////////////////////////////////////////////////////////////////
//
// Filename    : bc1500.v
// Description : Broadcast 1500
//
////////////////////////////////////////////////////////////////////////////

//`include "bc1500_features.vh"

//;use comp_config;





module bc1500_gc10 
# (
parameter TOTAL_PGFSM = 2
)
(

//Broadcast
input                   BC1500_Wrck,
input                   BC1500_Wsi,
input                   BC1500_Sel_Wir,
input                   BC1500_Shift,
input                   BC1500_Capture,
input                   BC1500_Update,
input                   BC1500_Tlr,
input                   BC1500_Trstb,

//Daisy
input                   BC1500_Daisy_Wsi,
output                  BC1500_Daisy_Wso,

//TDR dec/so
output   reg BC1500_Inst_10_En,
input  wire BC1500_Inst_10_Tdo,
input  wire BC1500_Inst_10_Dec_En,
output   reg BC1500_Inst_11_En,
input  wire BC1500_Inst_11_Tdo,
input  wire BC1500_Inst_11_Dec_En,
output   reg BC1500_Inst_12_En,
input  wire BC1500_Inst_12_Tdo,
input  wire BC1500_Inst_12_Dec_En,
output   reg BC1500_Inst_13_En,
input  wire BC1500_Inst_13_Tdo,
input  wire BC1500_Inst_13_Dec_En,
output   reg BC1500_Inst_14_En,
input  wire BC1500_Inst_14_Tdo,
input  wire BC1500_Inst_14_Dec_En,
output   reg BC1500_Inst_15_En,
input  wire BC1500_Inst_15_Tdo,
input  wire BC1500_Inst_15_Dec_En,
output   reg BC1500_Inst_16_En,
input  wire BC1500_Inst_16_Tdo,
input  wire BC1500_Inst_16_Dec_En,
output   reg BC1500_Inst_17_En,
input  wire BC1500_Inst_17_Tdo,
input  wire BC1500_Inst_17_Dec_En,
output   reg BC1500_Inst_18_En,
input  wire BC1500_Inst_18_Tdo,
input  wire BC1500_Inst_18_Dec_En,
output   reg BC1500_Inst_19_En,
input  wire BC1500_Inst_19_Tdo,
input  wire BC1500_Inst_19_Dec_En,
output   reg BC1500_Inst_20_En,
input  wire BC1500_Inst_20_Tdo,
input  wire BC1500_Inst_20_Dec_En,
output   reg BC1500_Inst_21_En,
input  wire BC1500_Inst_21_Tdo,
input  wire BC1500_Inst_21_Dec_En,
output   reg BC1500_Inst_22_En,
input  wire BC1500_Inst_22_Tdo,
input  wire BC1500_Inst_22_Dec_En,
output   reg BC1500_Inst_23_En,
input  wire BC1500_Inst_23_Tdo,
input  wire BC1500_Inst_23_Dec_En,
output   reg BC1500_Inst_24_En,
input  wire BC1500_Inst_24_Tdo,
input  wire BC1500_Inst_24_Dec_En,
output   reg BC1500_Inst_25_En,
input  wire BC1500_Inst_25_Tdo,
input  wire BC1500_Inst_25_Dec_En,
output   reg BC1500_Inst_26_En,
input  wire BC1500_Inst_26_Tdo,
input  wire BC1500_Inst_26_Dec_En,
output   reg BC1500_Inst_27_En,
input  wire BC1500_Inst_27_Tdo,
input  wire BC1500_Inst_27_Dec_En,
output   reg BC1500_Inst_28_En,
input  wire BC1500_Inst_28_Tdo,
input  wire BC1500_Inst_28_Dec_En,
output   reg BC1500_Inst_29_En,
input  wire BC1500_Inst_29_Tdo,
input  wire BC1500_Inst_29_Dec_En,
output   reg BC1500_Inst_30_En,
input  wire BC1500_Inst_30_Tdo,
input  wire BC1500_Inst_30_Dec_En,
output   reg BC1500_Inst_31_En,
input  wire BC1500_Inst_31_Tdo,
input  wire BC1500_Inst_31_Dec_En,
output   reg BC1500_Inst_32_En,
input  wire BC1500_Inst_32_Tdo,
input  wire BC1500_Inst_32_Dec_En,
output   reg BC1500_Inst_33_En,
input  wire BC1500_Inst_33_Tdo,
input  wire BC1500_Inst_33_Dec_En,
output   reg BC1500_Inst_34_En,
input  wire BC1500_Inst_34_Tdo,
input  wire BC1500_Inst_34_Dec_En,
output   reg BC1500_Inst_35_En,
input  wire BC1500_Inst_35_Tdo,
input  wire BC1500_Inst_35_Dec_En,
output   reg BC1500_Inst_36_En,
input  wire BC1500_Inst_36_Tdo,
input  wire BC1500_Inst_36_Dec_En,
output   reg BC1500_Inst_37_En,
input  wire BC1500_Inst_37_Tdo,
input  wire BC1500_Inst_37_Dec_En,
output   reg BC1500_Inst_38_En,
input  wire BC1500_Inst_38_Tdo,
input  wire BC1500_Inst_38_Dec_En,
output   reg BC1500_Inst_39_En,
input  wire BC1500_Inst_39_Tdo,
input  wire BC1500_Inst_39_Dec_En,
output   reg BC1500_Inst_40_En,
input  wire BC1500_Inst_40_Tdo,
input  wire BC1500_Inst_40_Dec_En,
output   reg BC1500_Inst_41_En,
input  wire BC1500_Inst_41_Tdo,
input  wire BC1500_Inst_41_Dec_En,
output   reg BC1500_Inst_42_En,
input  wire BC1500_Inst_42_Tdo,
input  wire BC1500_Inst_42_Dec_En,
output   reg BC1500_Inst_43_En,
input  wire BC1500_Inst_43_Tdo,
input  wire BC1500_Inst_43_Dec_En,
output   reg BC1500_Inst_44_En,
input  wire BC1500_Inst_44_Tdo,
input  wire BC1500_Inst_44_Dec_En,
output   reg BC1500_Inst_45_En,
input  wire BC1500_Inst_45_Tdo,
input  wire BC1500_Inst_45_Dec_En,
output   reg BC1500_Inst_46_En,
input  wire BC1500_Inst_46_Tdo,
input  wire BC1500_Inst_46_Dec_En,
output   reg BC1500_Inst_47_En,
input  wire BC1500_Inst_47_Tdo,
input  wire BC1500_Inst_47_Dec_En,
output   reg BC1500_Inst_48_En,
input  wire BC1500_Inst_48_Tdo,
input  wire BC1500_Inst_48_Dec_En,
output   reg BC1500_Inst_49_En,
input  wire BC1500_Inst_49_Tdo,
input  wire BC1500_Inst_49_Dec_En,
output   reg BC1500_Inst_50_En,
input  wire BC1500_Inst_50_Tdo,
input  wire BC1500_Inst_50_Dec_En,
output   reg BC1500_Inst_51_En,
input  wire BC1500_Inst_51_Tdo,
input  wire BC1500_Inst_51_Dec_En,
output   reg BC1500_Inst_52_En,
input  wire BC1500_Inst_52_Tdo,
input  wire BC1500_Inst_52_Dec_En,
output   reg BC1500_Inst_53_En,
input  wire BC1500_Inst_53_Tdo,
input  wire BC1500_Inst_53_Dec_En,
output   reg BC1500_Inst_54_En,
input  wire BC1500_Inst_54_Tdo,
input  wire BC1500_Inst_54_Dec_En,
output   reg BC1500_Inst_55_En,
input  wire BC1500_Inst_55_Tdo,
input  wire BC1500_Inst_55_Dec_En,
output   reg BC1500_Inst_56_En,
input  wire BC1500_Inst_56_Tdo,
input  wire BC1500_Inst_56_Dec_En,
output   reg BC1500_Inst_57_En,
input  wire BC1500_Inst_57_Tdo,
input  wire BC1500_Inst_57_Dec_En,
output   reg BC1500_Inst_58_En,
input  wire BC1500_Inst_58_Tdo,
input  wire BC1500_Inst_58_Dec_En,
output   reg BC1500_Inst_59_En,
input  wire BC1500_Inst_59_Tdo,
input  wire BC1500_Inst_59_Dec_En,
output   reg BC1500_Inst_60_En,
input  wire BC1500_Inst_60_Tdo,
input  wire BC1500_Inst_60_Dec_En,
output   reg BC1500_Inst_61_En,
input  wire BC1500_Inst_61_Tdo,
input  wire BC1500_Inst_61_Dec_En,
output   reg BC1500_Inst_62_En,
input  wire BC1500_Inst_62_Tdo,
input  wire BC1500_Inst_62_Dec_En,
output   reg BC1500_Inst_63_En,
input  wire BC1500_Inst_63_Tdo,
input  wire BC1500_Inst_63_Dec_En,
output   reg BC1500_Inst_64_En,
input  wire BC1500_Inst_64_Tdo,
input  wire BC1500_Inst_64_Dec_En,
output   reg BC1500_Inst_65_En,
input  wire BC1500_Inst_65_Tdo,
input  wire BC1500_Inst_65_Dec_En,
output   reg BC1500_Inst_66_En,
input  wire BC1500_Inst_66_Tdo,
input  wire BC1500_Inst_66_Dec_En,
output   reg BC1500_Inst_67_En,
input  wire BC1500_Inst_67_Tdo,
input  wire BC1500_Inst_67_Dec_En,
output   reg BC1500_Inst_68_En,
input  wire BC1500_Inst_68_Tdo,
input  wire BC1500_Inst_68_Dec_En,
output   reg BC1500_Inst_69_En,
input  wire BC1500_Inst_69_Tdo,
input  wire BC1500_Inst_69_Dec_En,
output   reg BC1500_Inst_70_En,
input  wire BC1500_Inst_70_Tdo,
input  wire BC1500_Inst_70_Dec_En,
output   reg BC1500_Inst_71_En,
input  wire BC1500_Inst_71_Tdo,
input  wire BC1500_Inst_71_Dec_En,
output   reg BC1500_Inst_72_En,
input  wire BC1500_Inst_72_Tdo,
input  wire BC1500_Inst_72_Dec_En,
output   reg BC1500_Inst_73_En,
input  wire BC1500_Inst_73_Tdo,
input  wire BC1500_Inst_73_Dec_En,
output   reg BC1500_Inst_74_En,
input  wire BC1500_Inst_74_Tdo,
input  wire BC1500_Inst_74_Dec_En,
output   reg BC1500_Inst_75_En,
input  wire BC1500_Inst_75_Tdo,
input  wire BC1500_Inst_75_Dec_En,
output   reg BC1500_Inst_76_En,
input  wire BC1500_Inst_76_Tdo,
input  wire BC1500_Inst_76_Dec_En,
output   reg BC1500_Inst_77_En,
input  wire BC1500_Inst_77_Tdo,
input  wire BC1500_Inst_77_Dec_En,
output   reg BC1500_Inst_78_En,
input  wire BC1500_Inst_78_Tdo,
input  wire BC1500_Inst_78_Dec_En,
output   reg BC1500_Inst_79_En,
input  wire BC1500_Inst_79_Tdo,
input  wire BC1500_Inst_79_Dec_En,
output   reg BC1500_Inst_80_En,
input  wire BC1500_Inst_80_Tdo,
input  wire BC1500_Inst_80_Dec_En,
output   reg BC1500_Inst_81_En,
input  wire BC1500_Inst_81_Tdo,
input  wire BC1500_Inst_81_Dec_En,
output   reg BC1500_Inst_82_En,
input  wire BC1500_Inst_82_Tdo,
input  wire BC1500_Inst_82_Dec_En,
output   reg BC1500_Inst_83_En,
input  wire BC1500_Inst_83_Tdo,
input  wire BC1500_Inst_83_Dec_En,
output   reg BC1500_Inst_84_En,
input  wire BC1500_Inst_84_Tdo,
input  wire BC1500_Inst_84_Dec_En,
output   reg BC1500_Inst_85_En,
input  wire BC1500_Inst_85_Tdo,
input  wire BC1500_Inst_85_Dec_En,
output   reg BC1500_Inst_86_En,
input  wire BC1500_Inst_86_Tdo,
input  wire BC1500_Inst_86_Dec_En,
output   reg BC1500_Inst_87_En,
input  wire BC1500_Inst_87_Tdo,
input  wire BC1500_Inst_87_Dec_En,
output   reg BC1500_Inst_88_En,
input  wire BC1500_Inst_88_Tdo,
input  wire BC1500_Inst_88_Dec_En,
output   reg BC1500_Inst_89_En,
input  wire BC1500_Inst_89_Tdo,
input  wire BC1500_Inst_89_Dec_En,
output   reg BC1500_Inst_90_En,
input  wire BC1500_Inst_90_Tdo,
input  wire BC1500_Inst_90_Dec_En,
output   reg BC1500_Inst_91_En,
input  wire BC1500_Inst_91_Tdo,
input  wire BC1500_Inst_91_Dec_En,
output   reg BC1500_Inst_92_En,
input  wire BC1500_Inst_92_Tdo,
input  wire BC1500_Inst_92_Dec_En,
output   reg BC1500_Inst_93_En,
input  wire BC1500_Inst_93_Tdo,
input  wire BC1500_Inst_93_Dec_En,
output   reg BC1500_Inst_94_En,
input  wire BC1500_Inst_94_Tdo,
input  wire BC1500_Inst_94_Dec_En,
output   reg BC1500_Inst_95_En,
input  wire BC1500_Inst_95_Tdo,
input  wire BC1500_Inst_95_Dec_En,
output   reg BC1500_Inst_96_En,
input  wire BC1500_Inst_96_Tdo,
input  wire BC1500_Inst_96_Dec_En,
output   reg BC1500_Inst_97_En,
input  wire BC1500_Inst_97_Tdo,
input  wire BC1500_Inst_97_Dec_En,
output   reg BC1500_Inst_98_En,
input  wire BC1500_Inst_98_Tdo,
input  wire BC1500_Inst_98_Dec_En,
output   reg BC1500_Inst_99_En,
input  wire BC1500_Inst_99_Tdo,
input  wire BC1500_Inst_99_Dec_En,
output   reg BC1500_Inst_100_En,
input  wire BC1500_Inst_100_Tdo,
input  wire BC1500_Inst_100_Dec_En,
output   reg BC1500_Inst_101_En,
input  wire BC1500_Inst_101_Tdo,
input  wire BC1500_Inst_101_Dec_En,
output   reg BC1500_Inst_102_En,
input  wire BC1500_Inst_102_Tdo,
input  wire BC1500_Inst_102_Dec_En,
output   reg BC1500_Inst_103_En,
input  wire BC1500_Inst_103_Tdo,
input  wire BC1500_Inst_103_Dec_En,
output   reg BC1500_Inst_104_En,
input  wire BC1500_Inst_104_Tdo,
input  wire BC1500_Inst_104_Dec_En,
output   reg BC1500_Inst_105_En,
input  wire BC1500_Inst_105_Tdo,
input  wire BC1500_Inst_105_Dec_En,
output   reg BC1500_Inst_106_En,
input  wire BC1500_Inst_106_Tdo,
input  wire BC1500_Inst_106_Dec_En,
output   reg BC1500_Inst_107_En,
input  wire BC1500_Inst_107_Tdo,
input  wire BC1500_Inst_107_Dec_En,
output   reg BC1500_Inst_108_En,
input  wire BC1500_Inst_108_Tdo,
input  wire BC1500_Inst_108_Dec_En,
output   reg BC1500_Inst_109_En,
input  wire BC1500_Inst_109_Tdo,
input  wire BC1500_Inst_109_Dec_En,
output   reg BC1500_Inst_110_En,
input  wire BC1500_Inst_110_Tdo,
input  wire BC1500_Inst_110_Dec_En,
output   reg BC1500_Inst_111_En,
input  wire BC1500_Inst_111_Tdo,
input  wire BC1500_Inst_111_Dec_En,
output   reg BC1500_Inst_112_En,
input  wire BC1500_Inst_112_Tdo,
input  wire BC1500_Inst_112_Dec_En,
output   reg BC1500_Inst_113_En,
input  wire BC1500_Inst_113_Tdo,
input  wire BC1500_Inst_113_Dec_En,
output   reg BC1500_Inst_114_En,
input  wire BC1500_Inst_114_Tdo,
input  wire BC1500_Inst_114_Dec_En,
output   reg BC1500_Inst_115_En,
input  wire BC1500_Inst_115_Tdo,
input  wire BC1500_Inst_115_Dec_En,
output   reg BC1500_Inst_116_En,
input  wire BC1500_Inst_116_Tdo,
input  wire BC1500_Inst_116_Dec_En,
output   reg BC1500_Inst_117_En,
input  wire BC1500_Inst_117_Tdo,
input  wire BC1500_Inst_117_Dec_En,
output   reg BC1500_Inst_118_En,
input  wire BC1500_Inst_118_Tdo,
input  wire BC1500_Inst_118_Dec_En,
output   reg BC1500_Inst_119_En,
input  wire BC1500_Inst_119_Tdo,
input  wire BC1500_Inst_119_Dec_En,
output   reg BC1500_Inst_120_En,
input  wire BC1500_Inst_120_Tdo,
input  wire BC1500_Inst_120_Dec_En,
output   reg BC1500_Inst_121_En,
input  wire BC1500_Inst_121_Tdo,
input  wire BC1500_Inst_121_Dec_En,
output   reg BC1500_Inst_122_En,
input  wire BC1500_Inst_122_Tdo,
input  wire BC1500_Inst_122_Dec_En,
output   reg BC1500_Inst_123_En,
input  wire BC1500_Inst_123_Tdo,
input  wire BC1500_Inst_123_Dec_En,
output   reg BC1500_Inst_124_En,
input  wire BC1500_Inst_124_Tdo,
input  wire BC1500_Inst_124_Dec_En,
output   reg BC1500_Inst_125_En,
input  wire BC1500_Inst_125_Tdo,
input  wire BC1500_Inst_125_Dec_En,
output   reg BC1500_Inst_126_En,
input  wire BC1500_Inst_126_Tdo,
input  wire BC1500_Inst_126_Dec_En,
output   reg BC1500_Inst_127_En,
input  wire BC1500_Inst_127_Tdo,
input  wire BC1500_Inst_127_Dec_En,
output   reg BC1500_Inst_128_En,
input  wire BC1500_Inst_128_Tdo,
input  wire BC1500_Inst_128_Dec_En,
output   reg BC1500_Inst_129_En,
input  wire BC1500_Inst_129_Tdo,
input  wire BC1500_Inst_129_Dec_En,
output   reg BC1500_Inst_130_En,
input  wire BC1500_Inst_130_Tdo,
input  wire BC1500_Inst_130_Dec_En,
output   reg BC1500_Inst_131_En,
input  wire BC1500_Inst_131_Tdo,
input  wire BC1500_Inst_131_Dec_En,
output   reg BC1500_Inst_132_En,
input  wire BC1500_Inst_132_Tdo,
input  wire BC1500_Inst_132_Dec_En,
output   reg BC1500_Inst_133_En,
input  wire BC1500_Inst_133_Tdo,
input  wire BC1500_Inst_133_Dec_En,
output   reg BC1500_Inst_134_En,
input  wire BC1500_Inst_134_Tdo,
input  wire BC1500_Inst_134_Dec_En,
output   reg BC1500_Inst_135_En,
input  wire BC1500_Inst_135_Tdo,
input  wire BC1500_Inst_135_Dec_En,
output   reg BC1500_Inst_136_En,
input  wire BC1500_Inst_136_Tdo,
input  wire BC1500_Inst_136_Dec_En,
output   reg BC1500_Inst_137_En,
input  wire BC1500_Inst_137_Tdo,
input  wire BC1500_Inst_137_Dec_En,
output   reg BC1500_Inst_138_En,
input  wire BC1500_Inst_138_Tdo,
input  wire BC1500_Inst_138_Dec_En,
output   reg BC1500_Inst_139_En,
input  wire BC1500_Inst_139_Tdo,
input  wire BC1500_Inst_139_Dec_En,
output   reg BC1500_Inst_140_En,
input  wire BC1500_Inst_140_Tdo,
input  wire BC1500_Inst_140_Dec_En,
output   reg BC1500_Inst_141_En,
input  wire BC1500_Inst_141_Tdo,
input  wire BC1500_Inst_141_Dec_En,
output   reg BC1500_Inst_142_En,
input  wire BC1500_Inst_142_Tdo,
input  wire BC1500_Inst_142_Dec_En,
output   reg BC1500_Inst_143_En,
input  wire BC1500_Inst_143_Tdo,
input  wire BC1500_Inst_143_Dec_En,
output   reg BC1500_Inst_144_En,
input  wire BC1500_Inst_144_Tdo,
input  wire BC1500_Inst_144_Dec_En,
output   reg BC1500_Inst_145_En,
input  wire BC1500_Inst_145_Tdo,
input  wire BC1500_Inst_145_Dec_En,
output   reg BC1500_Inst_146_En,
input  wire BC1500_Inst_146_Tdo,
input  wire BC1500_Inst_146_Dec_En,
output   reg BC1500_Inst_147_En,
input  wire BC1500_Inst_147_Tdo,
input  wire BC1500_Inst_147_Dec_En,
output   reg BC1500_Inst_148_En,
input  wire BC1500_Inst_148_Tdo,
input  wire BC1500_Inst_148_Dec_En,
output   reg BC1500_Inst_149_En,
input  wire BC1500_Inst_149_Tdo,
input  wire BC1500_Inst_149_Dec_En,
output   reg BC1500_Inst_150_En,
input  wire BC1500_Inst_150_Tdo,
input  wire BC1500_Inst_150_Dec_En,
output   reg BC1500_Inst_151_En,
input  wire BC1500_Inst_151_Tdo,
input  wire BC1500_Inst_151_Dec_En,
output   reg BC1500_Inst_152_En,
input  wire BC1500_Inst_152_Tdo,
input  wire BC1500_Inst_152_Dec_En,
output   reg BC1500_Inst_153_En,
input  wire BC1500_Inst_153_Tdo,
input  wire BC1500_Inst_153_Dec_En,
output   reg BC1500_Inst_154_En,
input  wire BC1500_Inst_154_Tdo,
input  wire BC1500_Inst_154_Dec_En,
output   reg BC1500_Inst_155_En,
input  wire BC1500_Inst_155_Tdo,
input  wire BC1500_Inst_155_Dec_En,
output   reg BC1500_Inst_156_En,
input  wire BC1500_Inst_156_Tdo,
input  wire BC1500_Inst_156_Dec_En,
output   reg BC1500_Inst_157_En,
input  wire BC1500_Inst_157_Tdo,
input  wire BC1500_Inst_157_Dec_En,
output   reg BC1500_Inst_158_En,
input  wire BC1500_Inst_158_Tdo,
input  wire BC1500_Inst_158_Dec_En,
output   reg BC1500_Inst_159_En,
input  wire BC1500_Inst_159_Tdo,
input  wire BC1500_Inst_159_Dec_En,
output   reg BC1500_Inst_160_En,
input  wire BC1500_Inst_160_Tdo,
input  wire BC1500_Inst_160_Dec_En,
output   reg BC1500_Inst_161_En,
input  wire BC1500_Inst_161_Tdo,
input  wire BC1500_Inst_161_Dec_En,
output   reg BC1500_Inst_162_En,
input  wire BC1500_Inst_162_Tdo,
input  wire BC1500_Inst_162_Dec_En,
output   reg BC1500_Inst_163_En,
input  wire BC1500_Inst_163_Tdo,
input  wire BC1500_Inst_163_Dec_En,
output   reg BC1500_Inst_164_En,
input  wire BC1500_Inst_164_Tdo,
input  wire BC1500_Inst_164_Dec_En,
output   reg BC1500_Inst_165_En,
input  wire BC1500_Inst_165_Tdo,
input  wire BC1500_Inst_165_Dec_En,
output   reg BC1500_Inst_166_En,
input  wire BC1500_Inst_166_Tdo,
input  wire BC1500_Inst_166_Dec_En,
output   reg BC1500_Inst_167_En,
input  wire BC1500_Inst_167_Tdo,
input  wire BC1500_Inst_167_Dec_En,
output   reg BC1500_Inst_168_En,
input  wire BC1500_Inst_168_Tdo,
input  wire BC1500_Inst_168_Dec_En,
output   reg BC1500_Inst_169_En,
input  wire BC1500_Inst_169_Tdo,
input  wire BC1500_Inst_169_Dec_En,
output   reg BC1500_Inst_170_En,
input  wire BC1500_Inst_170_Tdo,
input  wire BC1500_Inst_170_Dec_En,
output   reg BC1500_Inst_171_En,
input  wire BC1500_Inst_171_Tdo,
input  wire BC1500_Inst_171_Dec_En,
output   reg BC1500_Inst_172_En,
input  wire BC1500_Inst_172_Tdo,
input  wire BC1500_Inst_172_Dec_En,
output   reg BC1500_Inst_173_En,
input  wire BC1500_Inst_173_Tdo,
input  wire BC1500_Inst_173_Dec_En,
output   reg BC1500_Inst_174_En,
input  wire BC1500_Inst_174_Tdo,
input  wire BC1500_Inst_174_Dec_En,
output   reg BC1500_Inst_175_En,
input  wire BC1500_Inst_175_Tdo,
input  wire BC1500_Inst_175_Dec_En,
output   reg BC1500_Inst_176_En,
input  wire BC1500_Inst_176_Tdo,
input  wire BC1500_Inst_176_Dec_En,
output   reg BC1500_Inst_177_En,
input  wire BC1500_Inst_177_Tdo,
input  wire BC1500_Inst_177_Dec_En,
output   reg BC1500_Inst_178_En,
input  wire BC1500_Inst_178_Tdo,
input  wire BC1500_Inst_178_Dec_En,
output   reg BC1500_Inst_179_En,
input  wire BC1500_Inst_179_Tdo,
input  wire BC1500_Inst_179_Dec_En,
output   reg BC1500_Inst_180_En,
input  wire BC1500_Inst_180_Tdo,
input  wire BC1500_Inst_180_Dec_En,
output   reg BC1500_Inst_181_En,
input  wire BC1500_Inst_181_Tdo,
input  wire BC1500_Inst_181_Dec_En,
output   reg BC1500_Inst_182_En,
input  wire BC1500_Inst_182_Tdo,
input  wire BC1500_Inst_182_Dec_En,
output   reg BC1500_Inst_183_En,
input  wire BC1500_Inst_183_Tdo,
input  wire BC1500_Inst_183_Dec_En,
output   reg BC1500_Inst_184_En,
input  wire BC1500_Inst_184_Tdo,
input  wire BC1500_Inst_184_Dec_En,
output   reg BC1500_Inst_185_En,
input  wire BC1500_Inst_185_Tdo,
input  wire BC1500_Inst_185_Dec_En,
output   reg BC1500_Inst_186_En,
input  wire BC1500_Inst_186_Tdo,
input  wire BC1500_Inst_186_Dec_En,
output   reg BC1500_Inst_187_En,
input  wire BC1500_Inst_187_Tdo,
input  wire BC1500_Inst_187_Dec_En,
output   reg BC1500_Inst_188_En,
input  wire BC1500_Inst_188_Tdo,
input  wire BC1500_Inst_188_Dec_En,
output   reg BC1500_Inst_189_En,
input  wire BC1500_Inst_189_Tdo,
input  wire BC1500_Inst_189_Dec_En,
output   reg BC1500_Inst_190_En,
input  wire BC1500_Inst_190_Tdo,
input  wire BC1500_Inst_190_Dec_En,
output   reg BC1500_Inst_191_En,
input  wire BC1500_Inst_191_Tdo,
input  wire BC1500_Inst_191_Dec_En,
output   reg BC1500_Inst_192_En,
input  wire BC1500_Inst_192_Tdo,
input  wire BC1500_Inst_192_Dec_En,
output   reg BC1500_Inst_193_En,
input  wire BC1500_Inst_193_Tdo,
input  wire BC1500_Inst_193_Dec_En,
output   reg BC1500_Inst_194_En,
input  wire BC1500_Inst_194_Tdo,
input  wire BC1500_Inst_194_Dec_En,
output   reg BC1500_Inst_195_En,
input  wire BC1500_Inst_195_Tdo,
input  wire BC1500_Inst_195_Dec_En,
output   reg BC1500_Inst_196_En,
input  wire BC1500_Inst_196_Tdo,
input  wire BC1500_Inst_196_Dec_En,
output   reg BC1500_Inst_197_En,
input  wire BC1500_Inst_197_Tdo,
input  wire BC1500_Inst_197_Dec_En,
output   reg BC1500_Inst_198_En,
input  wire BC1500_Inst_198_Tdo,
input  wire BC1500_Inst_198_Dec_En,
output   reg BC1500_Inst_199_En,
input  wire BC1500_Inst_199_Tdo,
input  wire BC1500_Inst_199_Dec_En,
output   reg BC1500_Inst_200_En,
input  wire BC1500_Inst_200_Tdo,
input  wire BC1500_Inst_200_Dec_En,
output   reg BC1500_Inst_201_En,
input  wire BC1500_Inst_201_Tdo,
input  wire BC1500_Inst_201_Dec_En,
output   reg BC1500_Inst_202_En,
input  wire BC1500_Inst_202_Tdo,
input  wire BC1500_Inst_202_Dec_En,
output   reg BC1500_Inst_203_En,
input  wire BC1500_Inst_203_Tdo,
input  wire BC1500_Inst_203_Dec_En,
output   reg BC1500_Inst_204_En,
input  wire BC1500_Inst_204_Tdo,
input  wire BC1500_Inst_204_Dec_En,
output   reg BC1500_Inst_205_En,
input  wire BC1500_Inst_205_Tdo,
input  wire BC1500_Inst_205_Dec_En,
output   reg BC1500_Inst_206_En,
input  wire BC1500_Inst_206_Tdo,
input  wire BC1500_Inst_206_Dec_En,
output   reg BC1500_Inst_207_En,
input  wire BC1500_Inst_207_Tdo,
input  wire BC1500_Inst_207_Dec_En,
output   reg BC1500_Inst_208_En,
input  wire BC1500_Inst_208_Tdo,
input  wire BC1500_Inst_208_Dec_En,
output   reg BC1500_Inst_209_En,
input  wire BC1500_Inst_209_Tdo,
input  wire BC1500_Inst_209_Dec_En,
output   reg BC1500_Inst_210_En,
input  wire BC1500_Inst_210_Tdo,
input  wire BC1500_Inst_210_Dec_En,
output   reg BC1500_Inst_211_En,
input  wire BC1500_Inst_211_Tdo,
input  wire BC1500_Inst_211_Dec_En,
output   reg BC1500_Inst_212_En,
input  wire BC1500_Inst_212_Tdo,
input  wire BC1500_Inst_212_Dec_En,
output   reg BC1500_Inst_213_En,
input  wire BC1500_Inst_213_Tdo,
input  wire BC1500_Inst_213_Dec_En,
output   reg BC1500_Inst_214_En,
input  wire BC1500_Inst_214_Tdo,
input  wire BC1500_Inst_214_Dec_En,
output   reg BC1500_Inst_215_En,
input  wire BC1500_Inst_215_Tdo,
input  wire BC1500_Inst_215_Dec_En,
output   reg BC1500_Inst_216_En,
input  wire BC1500_Inst_216_Tdo,
input  wire BC1500_Inst_216_Dec_En,
output   reg BC1500_Inst_217_En,
input  wire BC1500_Inst_217_Tdo,
input  wire BC1500_Inst_217_Dec_En,
output   reg BC1500_Inst_218_En,
input  wire BC1500_Inst_218_Tdo,
input  wire BC1500_Inst_218_Dec_En,
output   reg BC1500_Inst_219_En,
input  wire BC1500_Inst_219_Tdo,
input  wire BC1500_Inst_219_Dec_En,
output   reg BC1500_Inst_220_En,
input  wire BC1500_Inst_220_Tdo,
input  wire BC1500_Inst_220_Dec_En,
output   reg BC1500_Inst_221_En,
input  wire BC1500_Inst_221_Tdo,
input  wire BC1500_Inst_221_Dec_En,
output   reg BC1500_Inst_222_En,
input  wire BC1500_Inst_222_Tdo,
input  wire BC1500_Inst_222_Dec_En,
output   reg BC1500_Inst_223_En,
input  wire BC1500_Inst_223_Tdo,
input  wire BC1500_Inst_223_Dec_En,
output   reg BC1500_Inst_224_En,
input  wire BC1500_Inst_224_Tdo,
input  wire BC1500_Inst_224_Dec_En,
output   reg BC1500_Inst_225_En,
input  wire BC1500_Inst_225_Tdo,
input  wire BC1500_Inst_225_Dec_En,
output   reg BC1500_Inst_226_En,
input  wire BC1500_Inst_226_Tdo,
input  wire BC1500_Inst_226_Dec_En,
output   reg BC1500_Inst_227_En,
input  wire BC1500_Inst_227_Tdo,
input  wire BC1500_Inst_227_Dec_En,
output   reg BC1500_Inst_228_En,
input  wire BC1500_Inst_228_Tdo,
input  wire BC1500_Inst_228_Dec_En,
output   reg BC1500_Inst_229_En,
input  wire BC1500_Inst_229_Tdo,
input  wire BC1500_Inst_229_Dec_En,
output   reg BC1500_Inst_230_En,
input  wire BC1500_Inst_230_Tdo,
input  wire BC1500_Inst_230_Dec_En,
output   reg BC1500_Inst_231_En,
input  wire BC1500_Inst_231_Tdo,
input  wire BC1500_Inst_231_Dec_En,
output   reg BC1500_Inst_232_En,
input  wire BC1500_Inst_232_Tdo,
input  wire BC1500_Inst_232_Dec_En,
output   reg BC1500_Inst_233_En,
input  wire BC1500_Inst_233_Tdo,
input  wire BC1500_Inst_233_Dec_En,
output   reg BC1500_Inst_234_En,
input  wire BC1500_Inst_234_Tdo,
input  wire BC1500_Inst_234_Dec_En,
output   reg BC1500_Inst_235_En,
input  wire BC1500_Inst_235_Tdo,
input  wire BC1500_Inst_235_Dec_En,
output   reg BC1500_Inst_236_En,
input  wire BC1500_Inst_236_Tdo,
input  wire BC1500_Inst_236_Dec_En,
output   reg BC1500_Inst_237_En,
input  wire BC1500_Inst_237_Tdo,
input  wire BC1500_Inst_237_Dec_En,
output   reg BC1500_Inst_238_En,
input  wire BC1500_Inst_238_Tdo,
input  wire BC1500_Inst_238_Dec_En,
output   reg BC1500_Inst_239_En,
input  wire BC1500_Inst_239_Tdo,
input  wire BC1500_Inst_239_Dec_En,
output   reg BC1500_Inst_240_En,
input  wire BC1500_Inst_240_Tdo,
input  wire BC1500_Inst_240_Dec_En,
output   reg BC1500_Inst_241_En,
input  wire BC1500_Inst_241_Tdo,
input  wire BC1500_Inst_241_Dec_En,
output   reg BC1500_Inst_242_En,
input  wire BC1500_Inst_242_Tdo,
input  wire BC1500_Inst_242_Dec_En,
output   reg BC1500_Inst_243_En,
input  wire BC1500_Inst_243_Tdo,
input  wire BC1500_Inst_243_Dec_En,
output   reg BC1500_Inst_244_En,
input  wire BC1500_Inst_244_Tdo,
input  wire BC1500_Inst_244_Dec_En,
output   reg BC1500_Inst_245_En,
input  wire BC1500_Inst_245_Tdo,
input  wire BC1500_Inst_245_Dec_En,
output   reg BC1500_Inst_246_En,
input  wire BC1500_Inst_246_Tdo,
input  wire BC1500_Inst_246_Dec_En,
output   reg BC1500_Inst_247_En,
input  wire BC1500_Inst_247_Tdo,
input  wire BC1500_Inst_247_Dec_En,
output   reg BC1500_Inst_248_En,
input  wire BC1500_Inst_248_Tdo,
input  wire BC1500_Inst_248_Dec_En,
output   reg BC1500_Inst_249_En,
input  wire BC1500_Inst_249_Tdo,
input  wire BC1500_Inst_249_Dec_En,
output   reg BC1500_Inst_250_En,
input  wire BC1500_Inst_250_Tdo,
input  wire BC1500_Inst_250_Dec_En,
output   reg BC1500_Inst_251_En,
input  wire BC1500_Inst_251_Tdo,
input  wire BC1500_Inst_251_Dec_En,
output   reg BC1500_Inst_252_En,
input  wire BC1500_Inst_252_Tdo,
input  wire BC1500_Inst_252_Dec_En,
output   reg BC1500_Inst_253_En,
input  wire BC1500_Inst_253_Tdo,
input  wire BC1500_Inst_253_Dec_En,
output   reg BC1500_Inst_254_En,
input  wire BC1500_Inst_254_Tdo,
input  wire BC1500_Inst_254_Dec_En,
output   reg BC1500_Inst_255_En,
input  wire BC1500_Inst_255_Tdo,
input  wire BC1500_Inst_255_Dec_En,
output   reg BC1500_Inst_256_En,
input  wire BC1500_Inst_256_Tdo,
input  wire BC1500_Inst_256_Dec_En,
output   reg BC1500_Inst_257_En,
input  wire BC1500_Inst_257_Tdo,
input  wire BC1500_Inst_257_Dec_En,
output   reg BC1500_Inst_258_En,
input  wire BC1500_Inst_258_Tdo,
input  wire BC1500_Inst_258_Dec_En,
output   reg BC1500_Inst_259_En,
input  wire BC1500_Inst_259_Tdo,
input  wire BC1500_Inst_259_Dec_En,
output   reg BC1500_Inst_260_En,
input  wire BC1500_Inst_260_Tdo,
input  wire BC1500_Inst_260_Dec_En,
output   reg BC1500_Inst_261_En,
input  wire BC1500_Inst_261_Tdo,
input  wire BC1500_Inst_261_Dec_En,
output   reg BC1500_Inst_262_En,
input  wire BC1500_Inst_262_Tdo,
input  wire BC1500_Inst_262_Dec_En,
output   reg BC1500_Inst_263_En,
input  wire BC1500_Inst_263_Tdo,
input  wire BC1500_Inst_263_Dec_En,
output   reg BC1500_Inst_264_En,
input  wire BC1500_Inst_264_Tdo,
input  wire BC1500_Inst_264_Dec_En,
output   reg BC1500_Inst_265_En,
input  wire BC1500_Inst_265_Tdo,
input  wire BC1500_Inst_265_Dec_En,
output   reg BC1500_Inst_266_En,
input  wire BC1500_Inst_266_Tdo,
input  wire BC1500_Inst_266_Dec_En,
output   reg BC1500_Inst_267_En,
input  wire BC1500_Inst_267_Tdo,
input  wire BC1500_Inst_267_Dec_En,
output   reg BC1500_Inst_268_En,
input  wire BC1500_Inst_268_Tdo,
input  wire BC1500_Inst_268_Dec_En,
output   reg BC1500_Inst_269_En,
input  wire BC1500_Inst_269_Tdo,
input  wire BC1500_Inst_269_Dec_En,
output   reg BC1500_Inst_270_En,
input  wire BC1500_Inst_270_Tdo,
input  wire BC1500_Inst_270_Dec_En,
output   reg BC1500_Inst_271_En,
input  wire BC1500_Inst_271_Tdo,
input  wire BC1500_Inst_271_Dec_En,
output   reg BC1500_Inst_272_En,
input  wire BC1500_Inst_272_Tdo,
input  wire BC1500_Inst_272_Dec_En,
output   reg BC1500_Inst_273_En,
input  wire BC1500_Inst_273_Tdo,
input  wire BC1500_Inst_273_Dec_En,
output   reg BC1500_Inst_274_En,
input  wire BC1500_Inst_274_Tdo,
input  wire BC1500_Inst_274_Dec_En,
output   reg BC1500_Inst_275_En,
input  wire BC1500_Inst_275_Tdo,
input  wire BC1500_Inst_275_Dec_En,
output   reg BC1500_Inst_276_En,
input  wire BC1500_Inst_276_Tdo,
input  wire BC1500_Inst_276_Dec_En,
output   reg BC1500_Inst_277_En,
input  wire BC1500_Inst_277_Tdo,
input  wire BC1500_Inst_277_Dec_En,
output   reg BC1500_Inst_278_En,
input  wire BC1500_Inst_278_Tdo,
input  wire BC1500_Inst_278_Dec_En,
output   reg BC1500_Inst_279_En,
input  wire BC1500_Inst_279_Tdo,
input  wire BC1500_Inst_279_Dec_En,
output   reg BC1500_Inst_280_En,
input  wire BC1500_Inst_280_Tdo,
input  wire BC1500_Inst_280_Dec_En,
output   reg BC1500_Inst_281_En,
input  wire BC1500_Inst_281_Tdo,
input  wire BC1500_Inst_281_Dec_En,
output   reg BC1500_Inst_282_En,
input  wire BC1500_Inst_282_Tdo,
input  wire BC1500_Inst_282_Dec_En,
output   reg BC1500_Inst_283_En,
input  wire BC1500_Inst_283_Tdo,
input  wire BC1500_Inst_283_Dec_En,
output   reg BC1500_Inst_284_En,
input  wire BC1500_Inst_284_Tdo,
input  wire BC1500_Inst_284_Dec_En,
output   reg BC1500_Inst_285_En,
input  wire BC1500_Inst_285_Tdo,
input  wire BC1500_Inst_285_Dec_En,
output   reg BC1500_Inst_286_En,
input  wire BC1500_Inst_286_Tdo,
input  wire BC1500_Inst_286_Dec_En,
output   reg BC1500_Inst_287_En,
input  wire BC1500_Inst_287_Tdo,
input  wire BC1500_Inst_287_Dec_En,
output   reg BC1500_Inst_288_En,
input  wire BC1500_Inst_288_Tdo,
input  wire BC1500_Inst_288_Dec_En,
output   reg BC1500_Inst_289_En,
input  wire BC1500_Inst_289_Tdo,
input  wire BC1500_Inst_289_Dec_En,
output   reg BC1500_Inst_290_En,
input  wire BC1500_Inst_290_Tdo,
input  wire BC1500_Inst_290_Dec_En,
output   reg BC1500_Inst_291_En,
input  wire BC1500_Inst_291_Tdo,
input  wire BC1500_Inst_291_Dec_En,
output   reg BC1500_Inst_292_En,
input  wire BC1500_Inst_292_Tdo,
input  wire BC1500_Inst_292_Dec_En,
output   reg BC1500_Inst_293_En,
input  wire BC1500_Inst_293_Tdo,
input  wire BC1500_Inst_293_Dec_En,
output   reg BC1500_Inst_294_En,
input  wire BC1500_Inst_294_Tdo,
input  wire BC1500_Inst_294_Dec_En,
output   reg BC1500_Inst_295_En,
input  wire BC1500_Inst_295_Tdo,
input  wire BC1500_Inst_295_Dec_En,
output   reg BC1500_Inst_296_En,
input  wire BC1500_Inst_296_Tdo,
input  wire BC1500_Inst_296_Dec_En,
output   reg BC1500_Inst_297_En,
input  wire BC1500_Inst_297_Tdo,
input  wire BC1500_Inst_297_Dec_En,
output   reg BC1500_Inst_298_En,
input  wire BC1500_Inst_298_Tdo,
input  wire BC1500_Inst_298_Dec_En,
output   reg BC1500_Inst_299_En,
input  wire BC1500_Inst_299_Tdo,
input  wire BC1500_Inst_299_Dec_En,
output   reg BC1500_Inst_300_En,
input  wire BC1500_Inst_300_Tdo,
input  wire BC1500_Inst_300_Dec_En,
output   reg BC1500_Inst_301_En,
input  wire BC1500_Inst_301_Tdo,
input  wire BC1500_Inst_301_Dec_En,
output   reg BC1500_Inst_302_En,
input  wire BC1500_Inst_302_Tdo,
input  wire BC1500_Inst_302_Dec_En,
output   reg BC1500_Inst_303_En,
input  wire BC1500_Inst_303_Tdo,
input  wire BC1500_Inst_303_Dec_En,
output   reg BC1500_Inst_304_En,
input  wire BC1500_Inst_304_Tdo,
input  wire BC1500_Inst_304_Dec_En,
output   reg BC1500_Inst_305_En,
input  wire BC1500_Inst_305_Tdo,
input  wire BC1500_Inst_305_Dec_En,
output   reg BC1500_Inst_306_En,
input  wire BC1500_Inst_306_Tdo,
input  wire BC1500_Inst_306_Dec_En,
output   reg BC1500_Inst_307_En,
input  wire BC1500_Inst_307_Tdo,
input  wire BC1500_Inst_307_Dec_En,
output   reg BC1500_Inst_308_En,
input  wire BC1500_Inst_308_Tdo,
input  wire BC1500_Inst_308_Dec_En,
output   reg BC1500_Inst_309_En,
input  wire BC1500_Inst_309_Tdo,
input  wire BC1500_Inst_309_Dec_En,
output   reg BC1500_Inst_310_En,
input  wire BC1500_Inst_310_Tdo,
input  wire BC1500_Inst_310_Dec_En,
output   reg BC1500_Inst_311_En,
input  wire BC1500_Inst_311_Tdo,
input  wire BC1500_Inst_311_Dec_En,
output   reg BC1500_Inst_312_En,
input  wire BC1500_Inst_312_Tdo,
input  wire BC1500_Inst_312_Dec_En,
output   reg BC1500_Inst_313_En,
input  wire BC1500_Inst_313_Tdo,
input  wire BC1500_Inst_313_Dec_En,
output   reg BC1500_Inst_314_En,
input  wire BC1500_Inst_314_Tdo,
input  wire BC1500_Inst_314_Dec_En,
output   reg BC1500_Inst_315_En,
input  wire BC1500_Inst_315_Tdo,
input  wire BC1500_Inst_315_Dec_En,
output   reg BC1500_Inst_316_En,
input  wire BC1500_Inst_316_Tdo,
input  wire BC1500_Inst_316_Dec_En,
output   reg BC1500_Inst_317_En,
input  wire BC1500_Inst_317_Tdo,
input  wire BC1500_Inst_317_Dec_En,
output   reg BC1500_Inst_318_En,
input  wire BC1500_Inst_318_Tdo,
input  wire BC1500_Inst_318_Dec_En,
output   reg BC1500_Inst_319_En,
input  wire BC1500_Inst_319_Tdo,
input  wire BC1500_Inst_319_Dec_En,
output   reg BC1500_Inst_320_En,
input  wire BC1500_Inst_320_Tdo,
input  wire BC1500_Inst_320_Dec_En,
output   reg BC1500_Inst_321_En,
input  wire BC1500_Inst_321_Tdo,
input  wire BC1500_Inst_321_Dec_En,
output   reg BC1500_Inst_322_En,
input  wire BC1500_Inst_322_Tdo,
input  wire BC1500_Inst_322_Dec_En,
output   reg BC1500_Inst_323_En,
input  wire BC1500_Inst_323_Tdo,
input  wire BC1500_Inst_323_Dec_En,
output   reg BC1500_Inst_324_En,
input  wire BC1500_Inst_324_Tdo,
input  wire BC1500_Inst_324_Dec_En,
output   reg BC1500_Inst_325_En,
input  wire BC1500_Inst_325_Tdo,
input  wire BC1500_Inst_325_Dec_En,
output   reg BC1500_Inst_326_En,
input  wire BC1500_Inst_326_Tdo,
input  wire BC1500_Inst_326_Dec_En,
output   reg BC1500_Inst_327_En,
input  wire BC1500_Inst_327_Tdo,
input  wire BC1500_Inst_327_Dec_En,
output   reg BC1500_Inst_328_En,
input  wire BC1500_Inst_328_Tdo,
input  wire BC1500_Inst_328_Dec_En,
output   reg BC1500_Inst_329_En,
input  wire BC1500_Inst_329_Tdo,
input  wire BC1500_Inst_329_Dec_En,
output   reg BC1500_Inst_330_En,
input  wire BC1500_Inst_330_Tdo,
input  wire BC1500_Inst_330_Dec_En,
output   reg BC1500_Inst_331_En,
input  wire BC1500_Inst_331_Tdo,
input  wire BC1500_Inst_331_Dec_En,
output   reg BC1500_Inst_332_En,
input  wire BC1500_Inst_332_Tdo,
input  wire BC1500_Inst_332_Dec_En,
output   reg BC1500_Inst_333_En,
input  wire BC1500_Inst_333_Tdo,
input  wire BC1500_Inst_333_Dec_En,
output   reg BC1500_Inst_334_En,
input  wire BC1500_Inst_334_Tdo,
input  wire BC1500_Inst_334_Dec_En,
output   reg BC1500_Inst_335_En,
input  wire BC1500_Inst_335_Tdo,
input  wire BC1500_Inst_335_Dec_En,
output   reg BC1500_Inst_336_En,
input  wire BC1500_Inst_336_Tdo,
input  wire BC1500_Inst_336_Dec_En,
output   reg BC1500_Inst_337_En,
input  wire BC1500_Inst_337_Tdo,
input  wire BC1500_Inst_337_Dec_En,
output   reg BC1500_Inst_338_En,
input  wire BC1500_Inst_338_Tdo,
input  wire BC1500_Inst_338_Dec_En,
output   reg BC1500_Inst_339_En,
input  wire BC1500_Inst_339_Tdo,
input  wire BC1500_Inst_339_Dec_En,
output   reg BC1500_Inst_340_En,
input  wire BC1500_Inst_340_Tdo,
input  wire BC1500_Inst_340_Dec_En,
output   reg BC1500_Inst_341_En,
input  wire BC1500_Inst_341_Tdo,
input  wire BC1500_Inst_341_Dec_En,
output   reg BC1500_Inst_342_En,
input  wire BC1500_Inst_342_Tdo,
input  wire BC1500_Inst_342_Dec_En,
output   reg BC1500_Inst_343_En,
input  wire BC1500_Inst_343_Tdo,
input  wire BC1500_Inst_343_Dec_En,
output   reg BC1500_Inst_344_En,
input  wire BC1500_Inst_344_Tdo,
input  wire BC1500_Inst_344_Dec_En,
output   reg BC1500_Inst_345_En,
input  wire BC1500_Inst_345_Tdo,
input  wire BC1500_Inst_345_Dec_En,
output   reg BC1500_Inst_346_En,
input  wire BC1500_Inst_346_Tdo,
input  wire BC1500_Inst_346_Dec_En,
output   reg BC1500_Inst_347_En,
input  wire BC1500_Inst_347_Tdo,
input  wire BC1500_Inst_347_Dec_En,
output   reg BC1500_Inst_348_En,
input  wire BC1500_Inst_348_Tdo,
input  wire BC1500_Inst_348_Dec_En,
output   reg BC1500_Inst_349_En,
input  wire BC1500_Inst_349_Tdo,
input  wire BC1500_Inst_349_Dec_En,
output   reg BC1500_Inst_350_En,
input  wire BC1500_Inst_350_Tdo,
input  wire BC1500_Inst_350_Dec_En,
output   reg BC1500_Inst_351_En,
input  wire BC1500_Inst_351_Tdo,
input  wire BC1500_Inst_351_Dec_En,
output   reg BC1500_Inst_352_En,
input  wire BC1500_Inst_352_Tdo,
input  wire BC1500_Inst_352_Dec_En,
output   reg BC1500_Inst_353_En,
input  wire BC1500_Inst_353_Tdo,
input  wire BC1500_Inst_353_Dec_En,
output   reg BC1500_Inst_354_En,
input  wire BC1500_Inst_354_Tdo,
input  wire BC1500_Inst_354_Dec_En,
output   reg BC1500_Inst_355_En,
input  wire BC1500_Inst_355_Tdo,
input  wire BC1500_Inst_355_Dec_En,
output   reg BC1500_Inst_356_En,
input  wire BC1500_Inst_356_Tdo,
input  wire BC1500_Inst_356_Dec_En,
output   reg BC1500_Inst_357_En,
input  wire BC1500_Inst_357_Tdo,
input  wire BC1500_Inst_357_Dec_En,
output   reg BC1500_Inst_358_En,
input  wire BC1500_Inst_358_Tdo,
input  wire BC1500_Inst_358_Dec_En,
output   reg BC1500_Inst_359_En,
input  wire BC1500_Inst_359_Tdo,
input  wire BC1500_Inst_359_Dec_En,
output   reg BC1500_Inst_360_En,
input  wire BC1500_Inst_360_Tdo,
input  wire BC1500_Inst_360_Dec_En,
output   reg BC1500_Inst_361_En,
input  wire BC1500_Inst_361_Tdo,
input  wire BC1500_Inst_361_Dec_En,
output   reg BC1500_Inst_362_En,
input  wire BC1500_Inst_362_Tdo,
input  wire BC1500_Inst_362_Dec_En,
output   reg BC1500_Inst_363_En,
input  wire BC1500_Inst_363_Tdo,
input  wire BC1500_Inst_363_Dec_En,
output   reg BC1500_Inst_364_En,
input  wire BC1500_Inst_364_Tdo,
input  wire BC1500_Inst_364_Dec_En,
output   reg BC1500_Inst_365_En,
input  wire BC1500_Inst_365_Tdo,
input  wire BC1500_Inst_365_Dec_En,
output   reg BC1500_Inst_366_En,
input  wire BC1500_Inst_366_Tdo,
input  wire BC1500_Inst_366_Dec_En,
output   reg BC1500_Inst_367_En,
input  wire BC1500_Inst_367_Tdo,
input  wire BC1500_Inst_367_Dec_En,
output   reg BC1500_Inst_368_En,
input  wire BC1500_Inst_368_Tdo,
input  wire BC1500_Inst_368_Dec_En,
output   reg BC1500_Inst_369_En,
input  wire BC1500_Inst_369_Tdo,
input  wire BC1500_Inst_369_Dec_En,
output   reg BC1500_Inst_370_En,
input  wire BC1500_Inst_370_Tdo,
input  wire BC1500_Inst_370_Dec_En,
output   reg BC1500_Inst_371_En,
input  wire BC1500_Inst_371_Tdo,
input  wire BC1500_Inst_371_Dec_En,
output   reg BC1500_Inst_372_En,
input  wire BC1500_Inst_372_Tdo,
input  wire BC1500_Inst_372_Dec_En,
output   reg BC1500_Inst_373_En,
input  wire BC1500_Inst_373_Tdo,
input  wire BC1500_Inst_373_Dec_En,
output   reg BC1500_Inst_374_En,
input  wire BC1500_Inst_374_Tdo,
input  wire BC1500_Inst_374_Dec_En,
output   reg BC1500_Inst_375_En,
input  wire BC1500_Inst_375_Tdo,
input  wire BC1500_Inst_375_Dec_En,
output   reg BC1500_Inst_376_En,
input  wire BC1500_Inst_376_Tdo,
input  wire BC1500_Inst_376_Dec_En,
output   reg BC1500_Inst_377_En,
input  wire BC1500_Inst_377_Tdo,
input  wire BC1500_Inst_377_Dec_En,
output   reg BC1500_Inst_378_En,
input  wire BC1500_Inst_378_Tdo,
input  wire BC1500_Inst_378_Dec_En,
output   reg BC1500_Inst_379_En,
input  wire BC1500_Inst_379_Tdo,
input  wire BC1500_Inst_379_Dec_En,
output   reg BC1500_Inst_380_En,
input  wire BC1500_Inst_380_Tdo,
input  wire BC1500_Inst_380_Dec_En,
output   reg BC1500_Inst_381_En,
input  wire BC1500_Inst_381_Tdo,
input  wire BC1500_Inst_381_Dec_En,
output   reg BC1500_Inst_382_En,
input  wire BC1500_Inst_382_Tdo,
input  wire BC1500_Inst_382_Dec_En,
output   reg BC1500_Inst_383_En,
input  wire BC1500_Inst_383_Tdo,
input  wire BC1500_Inst_383_Dec_En,
output   reg BC1500_Inst_384_En,
input  wire BC1500_Inst_384_Tdo,
input  wire BC1500_Inst_384_Dec_En,
output   reg BC1500_Inst_385_En,
input  wire BC1500_Inst_385_Tdo,
input  wire BC1500_Inst_385_Dec_En,
output   reg BC1500_Inst_386_En,
input  wire BC1500_Inst_386_Tdo,
input  wire BC1500_Inst_386_Dec_En,
output   reg BC1500_Inst_387_En,
input  wire BC1500_Inst_387_Tdo,
input  wire BC1500_Inst_387_Dec_En,
output   reg BC1500_Inst_388_En,
input  wire BC1500_Inst_388_Tdo,
input  wire BC1500_Inst_388_Dec_En,
output   reg BC1500_Inst_389_En,
input  wire BC1500_Inst_389_Tdo,
input  wire BC1500_Inst_389_Dec_En,
output   reg BC1500_Inst_390_En,
input  wire BC1500_Inst_390_Tdo,
input  wire BC1500_Inst_390_Dec_En,
output   reg BC1500_Inst_391_En,
input  wire BC1500_Inst_391_Tdo,
input  wire BC1500_Inst_391_Dec_En,
output   reg BC1500_Inst_392_En,
input  wire BC1500_Inst_392_Tdo,
input  wire BC1500_Inst_392_Dec_En,
output   reg BC1500_Inst_393_En,
input  wire BC1500_Inst_393_Tdo,
input  wire BC1500_Inst_393_Dec_En,
output   reg BC1500_Inst_394_En,
input  wire BC1500_Inst_394_Tdo,
input  wire BC1500_Inst_394_Dec_En,
output   reg BC1500_Inst_395_En,
input  wire BC1500_Inst_395_Tdo,
input  wire BC1500_Inst_395_Dec_En,
output   reg BC1500_Inst_396_En,
input  wire BC1500_Inst_396_Tdo,
input  wire BC1500_Inst_396_Dec_En,
output   reg BC1500_Inst_397_En,
input  wire BC1500_Inst_397_Tdo,
input  wire BC1500_Inst_397_Dec_En,
output   reg BC1500_Inst_398_En,
input  wire BC1500_Inst_398_Tdo,
input  wire BC1500_Inst_398_Dec_En,
output   reg BC1500_Inst_399_En,
input  wire BC1500_Inst_399_Tdo,
input  wire BC1500_Inst_399_Dec_En,
output   reg BC1500_Inst_400_En,
input  wire BC1500_Inst_400_Tdo,
input  wire BC1500_Inst_400_Dec_En,
output   reg BC1500_Inst_401_En,
input  wire BC1500_Inst_401_Tdo,
input  wire BC1500_Inst_401_Dec_En,
output   reg BC1500_Inst_402_En,
input  wire BC1500_Inst_402_Tdo,
input  wire BC1500_Inst_402_Dec_En,
output   reg BC1500_Inst_403_En,
input  wire BC1500_Inst_403_Tdo,
input  wire BC1500_Inst_403_Dec_En,
output   reg BC1500_Inst_404_En,
input  wire BC1500_Inst_404_Tdo,
input  wire BC1500_Inst_404_Dec_En,
output   reg BC1500_Inst_405_En,
input  wire BC1500_Inst_405_Tdo,
input  wire BC1500_Inst_405_Dec_En,
output   reg BC1500_Inst_406_En,
input  wire BC1500_Inst_406_Tdo,
input  wire BC1500_Inst_406_Dec_En,
output   reg BC1500_Inst_407_En,
input  wire BC1500_Inst_407_Tdo,
input  wire BC1500_Inst_407_Dec_En,
output   reg BC1500_Inst_408_En,
input  wire BC1500_Inst_408_Tdo,
input  wire BC1500_Inst_408_Dec_En,
output   reg BC1500_Inst_409_En,
input  wire BC1500_Inst_409_Tdo,
input  wire BC1500_Inst_409_Dec_En,
output   reg BC1500_Inst_410_En,
input  wire BC1500_Inst_410_Tdo,
input  wire BC1500_Inst_410_Dec_En,
output   reg BC1500_Inst_411_En,
input  wire BC1500_Inst_411_Tdo,
input  wire BC1500_Inst_411_Dec_En,
output   reg BC1500_Inst_412_En,
input  wire BC1500_Inst_412_Tdo,
input  wire BC1500_Inst_412_Dec_En,
output   reg BC1500_Inst_413_En,
input  wire BC1500_Inst_413_Tdo,
input  wire BC1500_Inst_413_Dec_En,
output   reg BC1500_Inst_414_En,
input  wire BC1500_Inst_414_Tdo,
input  wire BC1500_Inst_414_Dec_En,
output   reg BC1500_Inst_415_En,
input  wire BC1500_Inst_415_Tdo,
input  wire BC1500_Inst_415_Dec_En,
output   reg BC1500_Inst_416_En,
input  wire BC1500_Inst_416_Tdo,
input  wire BC1500_Inst_416_Dec_En,
output   reg BC1500_Inst_417_En,
input  wire BC1500_Inst_417_Tdo,
input  wire BC1500_Inst_417_Dec_En,
output   reg BC1500_Inst_418_En,
input  wire BC1500_Inst_418_Tdo,
input  wire BC1500_Inst_418_Dec_En,
output   reg BC1500_Inst_419_En,
input  wire BC1500_Inst_419_Tdo,
input  wire BC1500_Inst_419_Dec_En,
output   reg BC1500_Inst_420_En,
input  wire BC1500_Inst_420_Tdo,
input  wire BC1500_Inst_420_Dec_En,
output   reg BC1500_Inst_421_En,
input  wire BC1500_Inst_421_Tdo,
input  wire BC1500_Inst_421_Dec_En,
output   reg BC1500_Inst_422_En,
input  wire BC1500_Inst_422_Tdo,
input  wire BC1500_Inst_422_Dec_En,
output   reg BC1500_Inst_423_En,
input  wire BC1500_Inst_423_Tdo,
input  wire BC1500_Inst_423_Dec_En,
output   reg BC1500_Inst_424_En,
input  wire BC1500_Inst_424_Tdo,
input  wire BC1500_Inst_424_Dec_En,
output   reg BC1500_Inst_425_En,
input  wire BC1500_Inst_425_Tdo,
input  wire BC1500_Inst_425_Dec_En,
output   reg BC1500_Inst_426_En,
input  wire BC1500_Inst_426_Tdo,
input  wire BC1500_Inst_426_Dec_En,
output   reg BC1500_Inst_427_En,
input  wire BC1500_Inst_427_Tdo,
input  wire BC1500_Inst_427_Dec_En,
output   reg BC1500_Inst_428_En,
input  wire BC1500_Inst_428_Tdo,
input  wire BC1500_Inst_428_Dec_En,
output   reg BC1500_Inst_429_En,
input  wire BC1500_Inst_429_Tdo,
input  wire BC1500_Inst_429_Dec_En,
output   reg BC1500_Inst_430_En,
input  wire BC1500_Inst_430_Tdo,
input  wire BC1500_Inst_430_Dec_En,
output   reg BC1500_Inst_431_En,
input  wire BC1500_Inst_431_Tdo,
input  wire BC1500_Inst_431_Dec_En,
output   reg BC1500_Inst_432_En,
input  wire BC1500_Inst_432_Tdo,
input  wire BC1500_Inst_432_Dec_En,
output   reg BC1500_Inst_433_En,
input  wire BC1500_Inst_433_Tdo,
input  wire BC1500_Inst_433_Dec_En,
output   reg BC1500_Inst_434_En,
input  wire BC1500_Inst_434_Tdo,
input  wire BC1500_Inst_434_Dec_En,
output   reg BC1500_Inst_435_En,
input  wire BC1500_Inst_435_Tdo,
input  wire BC1500_Inst_435_Dec_En,
output   reg BC1500_Inst_436_En,
input  wire BC1500_Inst_436_Tdo,
input  wire BC1500_Inst_436_Dec_En,
output   reg BC1500_Inst_437_En,
input  wire BC1500_Inst_437_Tdo,
input  wire BC1500_Inst_437_Dec_En,
output   reg BC1500_Inst_438_En,
input  wire BC1500_Inst_438_Tdo,
input  wire BC1500_Inst_438_Dec_En,
output   reg BC1500_Inst_439_En,
input  wire BC1500_Inst_439_Tdo,
input  wire BC1500_Inst_439_Dec_En,
output   reg BC1500_Inst_440_En,
input  wire BC1500_Inst_440_Tdo,
input  wire BC1500_Inst_440_Dec_En,
output   reg BC1500_Inst_441_En,
input  wire BC1500_Inst_441_Tdo,
input  wire BC1500_Inst_441_Dec_En,
output   reg BC1500_Inst_442_En,
input  wire BC1500_Inst_442_Tdo,
input  wire BC1500_Inst_442_Dec_En,
output   reg BC1500_Inst_443_En,
input  wire BC1500_Inst_443_Tdo,
input  wire BC1500_Inst_443_Dec_En,
output   reg BC1500_Inst_444_En,
input  wire BC1500_Inst_444_Tdo,
input  wire BC1500_Inst_444_Dec_En,
output   reg BC1500_Inst_445_En,
input  wire BC1500_Inst_445_Tdo,
input  wire BC1500_Inst_445_Dec_En,
output   reg BC1500_Inst_446_En,
input  wire BC1500_Inst_446_Tdo,
input  wire BC1500_Inst_446_Dec_En,
output   reg BC1500_Inst_447_En,
input  wire BC1500_Inst_447_Tdo,
input  wire BC1500_Inst_447_Dec_En,
output   reg BC1500_Inst_448_En,
input  wire BC1500_Inst_448_Tdo,
input  wire BC1500_Inst_448_Dec_En,
output   reg BC1500_Inst_449_En,
input  wire BC1500_Inst_449_Tdo,
input  wire BC1500_Inst_449_Dec_En,
output   reg BC1500_Inst_450_En,
input  wire BC1500_Inst_450_Tdo,
input  wire BC1500_Inst_450_Dec_En,
output   reg BC1500_Inst_451_En,
input  wire BC1500_Inst_451_Tdo,
input  wire BC1500_Inst_451_Dec_En,
output   reg BC1500_Inst_452_En,
input  wire BC1500_Inst_452_Tdo,
input  wire BC1500_Inst_452_Dec_En,
output   reg BC1500_Inst_453_En,
input  wire BC1500_Inst_453_Tdo,
input  wire BC1500_Inst_453_Dec_En,
output   reg BC1500_Inst_454_En,
input  wire BC1500_Inst_454_Tdo,
input  wire BC1500_Inst_454_Dec_En,
output   reg BC1500_Inst_455_En,
input  wire BC1500_Inst_455_Tdo,
input  wire BC1500_Inst_455_Dec_En,
output   reg BC1500_Inst_456_En,
input  wire BC1500_Inst_456_Tdo,
input  wire BC1500_Inst_456_Dec_En,
output   reg BC1500_Inst_457_En,
input  wire BC1500_Inst_457_Tdo,
input  wire BC1500_Inst_457_Dec_En,
output   reg BC1500_Inst_458_En,
input  wire BC1500_Inst_458_Tdo,
input  wire BC1500_Inst_458_Dec_En,
output   reg BC1500_Inst_459_En,
input  wire BC1500_Inst_459_Tdo,
input  wire BC1500_Inst_459_Dec_En,
output   reg BC1500_Inst_460_En,
input  wire BC1500_Inst_460_Tdo,
input  wire BC1500_Inst_460_Dec_En,
output   reg BC1500_Inst_461_En,
input  wire BC1500_Inst_461_Tdo,
input  wire BC1500_Inst_461_Dec_En,
output   reg BC1500_Inst_462_En,
input  wire BC1500_Inst_462_Tdo,
input  wire BC1500_Inst_462_Dec_En,
output   reg BC1500_Inst_463_En,
input  wire BC1500_Inst_463_Tdo,
input  wire BC1500_Inst_463_Dec_En,
output   reg BC1500_Inst_464_En,
input  wire BC1500_Inst_464_Tdo,
input  wire BC1500_Inst_464_Dec_En,
output   reg BC1500_Inst_465_En,
input  wire BC1500_Inst_465_Tdo,
input  wire BC1500_Inst_465_Dec_En,
output   reg BC1500_Inst_466_En,
input  wire BC1500_Inst_466_Tdo,
input  wire BC1500_Inst_466_Dec_En,
output   reg BC1500_Inst_467_En,
input  wire BC1500_Inst_467_Tdo,
input  wire BC1500_Inst_467_Dec_En,
output   reg BC1500_Inst_468_En,
input  wire BC1500_Inst_468_Tdo,
input  wire BC1500_Inst_468_Dec_En,
output   reg BC1500_Inst_469_En,
input  wire BC1500_Inst_469_Tdo,
input  wire BC1500_Inst_469_Dec_En,
output   reg BC1500_Inst_470_En,
input  wire BC1500_Inst_470_Tdo,
input  wire BC1500_Inst_470_Dec_En,
output   reg BC1500_Inst_471_En,
input  wire BC1500_Inst_471_Tdo,
input  wire BC1500_Inst_471_Dec_En,
output   reg BC1500_Inst_472_En,
input  wire BC1500_Inst_472_Tdo,
input  wire BC1500_Inst_472_Dec_En,
output   reg BC1500_Inst_473_En,
input  wire BC1500_Inst_473_Tdo,
input  wire BC1500_Inst_473_Dec_En,
output   reg BC1500_Inst_474_En,
input  wire BC1500_Inst_474_Tdo,
input  wire BC1500_Inst_474_Dec_En,
output   reg BC1500_Inst_475_En,
input  wire BC1500_Inst_475_Tdo,
input  wire BC1500_Inst_475_Dec_En,
output   reg BC1500_Inst_476_En,
input  wire BC1500_Inst_476_Tdo,
input  wire BC1500_Inst_476_Dec_En,
output   reg BC1500_Inst_477_En,
input  wire BC1500_Inst_477_Tdo,
input  wire BC1500_Inst_477_Dec_En,
output   reg BC1500_Inst_478_En,
input  wire BC1500_Inst_478_Tdo,
input  wire BC1500_Inst_478_Dec_En,
output   reg BC1500_Inst_479_En,
input  wire BC1500_Inst_479_Tdo,
input  wire BC1500_Inst_479_Dec_En,
output   reg BC1500_Inst_480_En,
input  wire BC1500_Inst_480_Tdo,
input  wire BC1500_Inst_480_Dec_En,
output   reg BC1500_Inst_481_En,
input  wire BC1500_Inst_481_Tdo,
input  wire BC1500_Inst_481_Dec_En,
output   reg BC1500_Inst_482_En,
input  wire BC1500_Inst_482_Tdo,
input  wire BC1500_Inst_482_Dec_En,
output   reg BC1500_Inst_483_En,
input  wire BC1500_Inst_483_Tdo,
input  wire BC1500_Inst_483_Dec_En,
output   reg BC1500_Inst_484_En,
input  wire BC1500_Inst_484_Tdo,
input  wire BC1500_Inst_484_Dec_En,
output   reg BC1500_Inst_485_En,
input  wire BC1500_Inst_485_Tdo,
input  wire BC1500_Inst_485_Dec_En,
output   reg BC1500_Inst_486_En,
input  wire BC1500_Inst_486_Tdo,
input  wire BC1500_Inst_486_Dec_En,
output   reg BC1500_Inst_487_En,
input  wire BC1500_Inst_487_Tdo,
input  wire BC1500_Inst_487_Dec_En,
output   reg BC1500_Inst_488_En,
input  wire BC1500_Inst_488_Tdo,
input  wire BC1500_Inst_488_Dec_En,
output   reg BC1500_Inst_489_En,
input  wire BC1500_Inst_489_Tdo,
input  wire BC1500_Inst_489_Dec_En,
output   reg BC1500_Inst_490_En,
input  wire BC1500_Inst_490_Tdo,
input  wire BC1500_Inst_490_Dec_En,
output   reg BC1500_Inst_491_En,
input  wire BC1500_Inst_491_Tdo,
input  wire BC1500_Inst_491_Dec_En,
output   reg BC1500_Inst_492_En,
input  wire BC1500_Inst_492_Tdo,
input  wire BC1500_Inst_492_Dec_En,
output   reg BC1500_Inst_493_En,
input  wire BC1500_Inst_493_Tdo,
input  wire BC1500_Inst_493_Dec_En,
output   reg BC1500_Inst_494_En,
input  wire BC1500_Inst_494_Tdo,
input  wire BC1500_Inst_494_Dec_En,
output   reg BC1500_Inst_495_En,
input  wire BC1500_Inst_495_Tdo,
input  wire BC1500_Inst_495_Dec_En,
output   reg BC1500_Inst_496_En,
input  wire BC1500_Inst_496_Tdo,
input  wire BC1500_Inst_496_Dec_En,
output   reg BC1500_Inst_497_En,
input  wire BC1500_Inst_497_Tdo,
input  wire BC1500_Inst_497_Dec_En,
output   reg BC1500_Inst_498_En,
input  wire BC1500_Inst_498_Tdo,
input  wire BC1500_Inst_498_Dec_En,
output   reg BC1500_Inst_499_En,
input  wire BC1500_Inst_499_Tdo,
input  wire BC1500_Inst_499_Dec_En,
output   reg BC1500_Inst_500_En,
input  wire BC1500_Inst_500_Tdo,
input  wire BC1500_Inst_500_Dec_En,
output   reg BC1500_Inst_501_En,
input  wire BC1500_Inst_501_Tdo,
input  wire BC1500_Inst_501_Dec_En,
output   reg BC1500_Inst_502_En,
input  wire BC1500_Inst_502_Tdo,
input  wire BC1500_Inst_502_Dec_En,
output   reg BC1500_Inst_503_En,
input  wire BC1500_Inst_503_Tdo,
input  wire BC1500_Inst_503_Dec_En,
output   reg BC1500_Inst_504_En,
input  wire BC1500_Inst_504_Tdo,
input  wire BC1500_Inst_504_Dec_En,
output   reg BC1500_Inst_505_En,
input  wire BC1500_Inst_505_Tdo,
input  wire BC1500_Inst_505_Dec_En,
output   reg BC1500_Inst_506_En,
input  wire BC1500_Inst_506_Tdo,
input  wire BC1500_Inst_506_Dec_En,
output   reg BC1500_Inst_507_En,
input  wire BC1500_Inst_507_Tdo,
input  wire BC1500_Inst_507_Dec_En,
output   reg BC1500_Inst_508_En,
input  wire BC1500_Inst_508_Tdo,
input  wire BC1500_Inst_508_Dec_En,
output   reg BC1500_Inst_509_En,
input  wire BC1500_Inst_509_Tdo,
input  wire BC1500_Inst_509_Dec_En,
output   reg BC1500_Inst_510_En,
input  wire BC1500_Inst_510_Tdo,
input  wire BC1500_Inst_510_Dec_En,

//PGFSM Reset
input                   PGFSM_P0_resetb,
input                   PGFSM_P1_resetb,
input                   PGFSM_P2_resetb,
input                   PGFSM_P3_resetb,
input                   PGFSM_P4_resetb,
input                   PGFSM_P5_resetb,
input                   PGFSM_P6_resetb,
input                   PGFSM_P7_resetb,

//TDR
output                   Tdr_Tck,
output                   Tdr_Trstb, //Aon Reset
output                   Tdr_Tdi,
output                   Tdr_Shift,
output                   Tdr_Capture,
output                   Tdr_Update,

output wire              Scanned_Tck,

output                   Tdr_P0_Trstb,  //P0 domain Tdr Reset
output                   Tdr_P1_Trstb,  //P1 domain Tdr Reset
output                   Tdr_P2_Trstb,  //P2 domain Tdr Reset
output                   Tdr_P3_Trstb,  //P3 domain Tdr Reset
output                   Tdr_P4_Trstb,  //P4 domain Tdr Reset
output                   Tdr_P5_Trstb,  //P5 domain Tdr Reset
output                   Tdr_P6_Trstb,  //P6 domain Tdr Reset
output                   Tdr_P7_Trstb,  //P7 domain Tdr Reset

output wire              Tdr_Bypass_Tdo,
output wire              Tdr_Broadcast_En

   );

localparam BC1500_IR_BROADCAST_DECODE = 9'h1;
localparam BC1500_IR_BYPASSEN_DECODE  = 9'h2;
localparam MAX_PGFSM  = 8;


wire BC1500_Inst_0_Tdo;
reg BC1500_Inst_0_En;
wire BC1500_Inst_1_Tdo;
reg BC1500_Inst_1_En;
wire BC1500_Inst_2_Tdo;
reg BC1500_Inst_2_En;
wire BC1500_Inst_3_Tdo;
reg BC1500_Inst_3_En;
wire BC1500_Inst_4_Tdo;
reg BC1500_Inst_4_En;
wire BC1500_Inst_5_Tdo;
reg BC1500_Inst_5_En;
wire BC1500_Inst_6_Tdo;
reg BC1500_Inst_6_En;
wire BC1500_Inst_7_Tdo;
reg BC1500_Inst_7_En;
wire BC1500_Inst_8_Tdo;
reg BC1500_Inst_8_En;
wire BC1500_Inst_9_Tdo;
reg BC1500_Inst_9_En;


// ;my  = 1 << 9;

wire [1-1:0] dis_sc, dis_sc_pre;
wire [1-1:0] dis_update, dis_update_pre;
//`ifdef TDR_PERSISTENCE_PRESENT__1
assign dis_sc     = dis_sc_pre;
assign dis_update = dis_update_pre;
//`else


  aticlk_buf mrk_tclk (
      .A(BC1500_Wrck),
      .Y(Wrck)
      );

  aticlk_buf mrk_scan_tclk (
      .A(BC1500_Wrck),
      .Y(Scanned_Tck)
      );

   ati_buffer1 mrk_wsi        (.A(BC1500_Wsi),      .Y(Wsi_Broadcast));
   ati_buffer1 mrk_wsi_daisy  (.A(BC1500_Daisy_Wsi), .Y(Wsi_Daisy));
   ati_buffer1 mrk_wso_daisy  (.A(BC1500_Tdo),        .Y(BC1500_Daisy_Wso));

   //Tlrb - reset for SIBS and nework control bits.
   //Tresetb - reset everything else, TDRs, etc..

   ati_buffer1 mrk_tlr      (.A(~BC1500_Tlr),     .Y(bc1500_tlrb));
   ati_buffer1 mrk_trstb    (.A(BC1500_Trstb),     .Y(bc1500_trstb));

   ati_buffer1 mrk_sel_wir  (.A(BC1500_Sel_Wir),  .Y(sel_wir_pre));

   ati_buffer1 mrk_update   (.A(BC1500_Update),   .Y(update));
   ati_buffer1 mrk_capture  (.A(BC1500_Capture),  .Y(capture_pre));
   ati_buffer1 mrk_shift    (.A(BC1500_Shift),    .Y(shift_pre));

   test_ff_neg_async_gc10 #(1) reg_sel_wir
        (
      .rstb               ( bc1500_tlrb ),  // SIB is network bit, hence reset using tlrb
      .d_rst              ( 1'b1  ),        //after reset IR
      .clk                ( Wrck ),
      .d                  ( sel_wir_pre ),
      .q                  ( sel_wir )
      );

   test_ff_neg_async_gc10 #(2) reg_shf_cap
        (
      .rstb               ( bc1500_tlrb ),  // SIB is network bit, hence reset using tlrb
      .d_rst              ( 2'b0  ),
      .clk                ( Wrck ),
      .d                  ( {shift_pre,capture_pre} ),
      .q                  ( {shift,capture} )
      );

   wire dr_update     = update  & !sel_wir;
   wire dr_capture    = capture & !sel_wir;
   wire dr_shift      = shift   & !sel_wir;

   wire ir_update     = update  & sel_wir;
   wire ir_capture    = capture & sel_wir;
   wire ir_shift      = shift   & sel_wir;

   wire broadcasten;
   wire bypassen;
   wire bypass;

   wire dr_si;
   ati_mux2  mux_Wsi ( 
        .i0 (Wsi_Daisy),
        .i1 (Wsi_Broadcast),
        .z (dr_si),
        .s (broadcasten)
   );



///////// Reset //////////////////////////////////////

wire [MAX_PGFSM-1:0] pgfsm_resetb;
wire [MAX_PGFSM-1:0] pgfsm_resetb_sync_anded;
assign pgfsm_resetb[0] = PGFSM_P0_resetb;
assign Tdr_P0_Trstb = pgfsm_resetb_sync_anded[0];
assign pgfsm_resetb[1] = PGFSM_P1_resetb;
assign Tdr_P1_Trstb = pgfsm_resetb_sync_anded[1];
assign pgfsm_resetb[2] = PGFSM_P2_resetb;
assign Tdr_P2_Trstb = pgfsm_resetb_sync_anded[2];
assign pgfsm_resetb[3] = PGFSM_P3_resetb;
assign Tdr_P3_Trstb = pgfsm_resetb_sync_anded[3];
assign pgfsm_resetb[4] = PGFSM_P4_resetb;
assign Tdr_P4_Trstb = pgfsm_resetb_sync_anded[4];
assign pgfsm_resetb[5] = PGFSM_P5_resetb;
assign Tdr_P5_Trstb = pgfsm_resetb_sync_anded[5];
assign pgfsm_resetb[6] = PGFSM_P6_resetb;
assign Tdr_P6_Trstb = pgfsm_resetb_sync_anded[6];
assign pgfsm_resetb[7] = PGFSM_P7_resetb;
assign Tdr_P7_Trstb = pgfsm_resetb_sync_anded[7];



generate
 genvar i;

if(TOTAL_PGFSM > 0) begin
wire [TOTAL_PGFSM-1:0] pgfsm_resetb_sync;

 for(i=0; i < TOTAL_PGFSM; i = i+1) begin : usync_pgfsm_resetb
   dfx_async_rst_sync3_gc10 rst_sync_PG_trstb (
                         .clk(Wrck),
                         .rstinB(pgfsm_resetb[i]),
                         .rstoutB(pgfsm_resetb_sync[i]));
 assign                   pgfsm_resetb_sync_anded[i]  = bc1500_trstb & pgfsm_resetb_sync[i];
 end
end

 for(i=TOTAL_PGFSM; i < MAX_PGFSM; i = i+1) begin : usync_pgfsm_resetb_tied
 assign                   pgfsm_resetb_sync_anded[i]  = 1'b0;
 end

endgenerate 

///////////////////////////////////////////////////////

assign                   Tdr_Tck    = Wrck;

assign                   Tdr_Trstb      = bc1500_trstb;

assign                   Tdr_Tdi      = dr_si;
assign                   Tdr_Shift    = dr_shift   & ~dis_sc;
assign                   Tdr_Capture  = dr_capture & ~dis_sc;
assign                   Tdr_Update   = dr_update  & ~dis_update;

   /************************ Instruction reg ***********************/

   wire [9-1:0]           IR;

   test_reg_async_rst_gc10 #(9) reg_IR
     (
      .clk(Wrck),
      .rstb(bc1500_tlrb),
      .en(sel_wir),
      .shift(ir_shift),
      .capture(ir_capture),
      .update(ir_update),
      .d_rst({(9){1'b1}}),
      .q(IR),
      .d({IR[9-1:2],2'b01}),
      .si(Wsi_Broadcast),     //Broadcast SI
      .so(Ir_Tdo),
      .q_sr(),
      .q_sr_posedge()
      );




///////////////////////////////////////////////////////////////////////

wire [9-1:0]           IR_to_decoder;

//when bypassen is set, only instruction decoded are BYPASSEN and BROADCAST.
//only way to clear decoding is to unload bypassen bit.

assign IR_to_decoder = (~bypassen) ? IR :
                       ( (IR==BC1500_IR_BYPASSEN_DECODE)||(IR==BC1500_IR_BROADCAST_DECODE) ) ? IR : 
                       { (9){1'b1} };




   /************************ BYPASS reg ***********************/

reg BC1500_Bypass_En;
wire Tdr_Bypass_En = BC1500_Bypass_En;

   test_reg_async_rst_gc10 #(1) reg_bypass
     (
      .q(),
      .q_sr(),
      .q_sr_posedge(),
      .d(1'b0),
      .en(Tdr_Bypass_En),
      .capture(dr_capture),
      .update(dr_update),
      .shift(dr_shift),
      .si(Wsi_Daisy),         //Daisy
      .so(Tdr_Bypass_Tdo),
      .clk(Wrck),
      .rstb(bc1500_trstb),
      .d_rst(1'b0)
      );



///////////////////////////////////////////////////////////////////////////////////


   /************************ BYPASSEN reg ***********************/
wire Tdr_Bypassen_En = BC1500_Inst_2_En;

   test_reg_async_rst_gc10 #(1) reg_bypassen
     (
      .q(bypassen),
      .q_sr(),
      .q_sr_posedge(),
      .d(bypassen),
      .en(Tdr_Bypassen_En),
      .capture(dr_capture),
      .update(dr_update),
      .shift(dr_shift),
      .si(Wsi_Daisy),         //Daisy
      .so(Tdr_Bypassen_Tdo),
      .clk(Wrck),
      .rstb(bc1500_tlrb),
      .d_rst(1'b0)
      );

  /************************ BROADCASTEN reg ***********************/
wire Tdr_Broadcasten_En = BC1500_Inst_1_En;
assign Tdr_Broadcast_En = broadcasten;

   test_reg_async_rst_gc10 #(1) reg_broadcasten
     (
      .q(broadcasten),
      .q_sr(),
      .q_sr_posedge(),
      .d(broadcasten),
      .en(Tdr_Broadcasten_En),
      .capture(dr_capture),
      .update(dr_update),
      .shift(dr_shift),
      .si(Wsi_Broadcast),         
      .so(Tdr_Broadcasten_Tdo),
      .clk(Wrck),
      .rstb(bc1500_tlrb),
      .d_rst(1'b0)
      );



///////////////////////////////////////////////////////////////////////////////////
wire Tdr_tdr_update_cntl_En = BC1500_Inst_4_En;

tdr_update_cntl_gc10 tdr_update_cntl ( 

 .Tdr_Tck               (Wrck) ,
 .Tdr_Trstb             (bc1500_tlrb),  //TBD??
 .Tdr_Tdi               (Tdr_Tdi),
 .Tdr_Shift             (dr_shift),
 .Tdr_Capture           (dr_capture),
 .Tdr_Update            (dr_update)


//TDR --> TDR_UPDATE_CNTL
 ,.all_update            (dis_sc_pre[1-1:0])
 ,.dis_update            (dis_update_pre[1-1:0])
 ,.Tdr_tdr_update_cntl_En               (Tdr_tdr_update_cntl_En)
 ,.Tdr_tdr_update_cntl_Tdo              (Tdr_tdr_update_cntl_Tdo)
); 

///////////////////////////////////////////////////////////////////////////////////

wire BC1500_Inst_0_Dec_En   =  1'b0; //dec-0 is bypass.
assign BC1500_Inst_0_Tdo = Tdr_Bypass_Tdo;  // all 0 decoded as bypass

wire BC1500_Inst_1_Dec_En   =  1'b1; //dec-1 is broadcasten.
assign BC1500_Inst_1_Tdo = Tdr_Broadcasten_Tdo;

wire BC1500_Inst_2_Dec_En   =  1'b1; //dec-2 is bypassen.
assign BC1500_Inst_2_Tdo = Tdr_Bypassen_Tdo;


wire BC1500_Inst_3_Dec_En   =  1'b1; //dec-3 is daisy chain.
ati_buffer1 DFT_DONT_TIME_delay_chain   (.A(Wsi_Daisy),  .Y(BC1500_Inst_3_Tdo));  // byapss path without flop

wire BC1500_Inst_4_Dec_En   =  1'b1; //dec-4 is tdr_update_cntl
assign BC1500_Inst_4_Tdo = Tdr_tdr_update_cntl_Tdo;

wire BC1500_Inst_5_Dec_En   =  1'b0; 
assign BC1500_Inst_5_Tdo = Tdr_Bypass_Tdo;
wire BC1500_Inst_6_Dec_En   =  1'b0; 
assign BC1500_Inst_6_Tdo = Tdr_Bypass_Tdo;
wire BC1500_Inst_7_Dec_En   =  1'b0; 
assign BC1500_Inst_7_Tdo = Tdr_Bypass_Tdo;
wire BC1500_Inst_8_Dec_En   =  1'b0; 
assign BC1500_Inst_8_Tdo = Tdr_Bypass_Tdo;
wire BC1500_Inst_9_Dec_En   =  1'b0; 
assign BC1500_Inst_9_Tdo = Tdr_Bypass_Tdo;


reg Tdr_Tdo;

  always @ (*)
   begin

BC1500_Inst_0_En = 1'b0;
BC1500_Inst_1_En = 1'b0;
BC1500_Inst_2_En = 1'b0;
BC1500_Inst_3_En = 1'b0;
BC1500_Inst_4_En = 1'b0;
BC1500_Inst_5_En = 1'b0;
BC1500_Inst_6_En = 1'b0;
BC1500_Inst_7_En = 1'b0;
BC1500_Inst_8_En = 1'b0;
BC1500_Inst_9_En = 1'b0;
BC1500_Inst_10_En = 1'b0;
BC1500_Inst_11_En = 1'b0;
BC1500_Inst_12_En = 1'b0;
BC1500_Inst_13_En = 1'b0;
BC1500_Inst_14_En = 1'b0;
BC1500_Inst_15_En = 1'b0;
BC1500_Inst_16_En = 1'b0;
BC1500_Inst_17_En = 1'b0;
BC1500_Inst_18_En = 1'b0;
BC1500_Inst_19_En = 1'b0;
BC1500_Inst_20_En = 1'b0;
BC1500_Inst_21_En = 1'b0;
BC1500_Inst_22_En = 1'b0;
BC1500_Inst_23_En = 1'b0;
BC1500_Inst_24_En = 1'b0;
BC1500_Inst_25_En = 1'b0;
BC1500_Inst_26_En = 1'b0;
BC1500_Inst_27_En = 1'b0;
BC1500_Inst_28_En = 1'b0;
BC1500_Inst_29_En = 1'b0;
BC1500_Inst_30_En = 1'b0;
BC1500_Inst_31_En = 1'b0;
BC1500_Inst_32_En = 1'b0;
BC1500_Inst_33_En = 1'b0;
BC1500_Inst_34_En = 1'b0;
BC1500_Inst_35_En = 1'b0;
BC1500_Inst_36_En = 1'b0;
BC1500_Inst_37_En = 1'b0;
BC1500_Inst_38_En = 1'b0;
BC1500_Inst_39_En = 1'b0;
BC1500_Inst_40_En = 1'b0;
BC1500_Inst_41_En = 1'b0;
BC1500_Inst_42_En = 1'b0;
BC1500_Inst_43_En = 1'b0;
BC1500_Inst_44_En = 1'b0;
BC1500_Inst_45_En = 1'b0;
BC1500_Inst_46_En = 1'b0;
BC1500_Inst_47_En = 1'b0;
BC1500_Inst_48_En = 1'b0;
BC1500_Inst_49_En = 1'b0;
BC1500_Inst_50_En = 1'b0;
BC1500_Inst_51_En = 1'b0;
BC1500_Inst_52_En = 1'b0;
BC1500_Inst_53_En = 1'b0;
BC1500_Inst_54_En = 1'b0;
BC1500_Inst_55_En = 1'b0;
BC1500_Inst_56_En = 1'b0;
BC1500_Inst_57_En = 1'b0;
BC1500_Inst_58_En = 1'b0;
BC1500_Inst_59_En = 1'b0;
BC1500_Inst_60_En = 1'b0;
BC1500_Inst_61_En = 1'b0;
BC1500_Inst_62_En = 1'b0;
BC1500_Inst_63_En = 1'b0;
BC1500_Inst_64_En = 1'b0;
BC1500_Inst_65_En = 1'b0;
BC1500_Inst_66_En = 1'b0;
BC1500_Inst_67_En = 1'b0;
BC1500_Inst_68_En = 1'b0;
BC1500_Inst_69_En = 1'b0;
BC1500_Inst_70_En = 1'b0;
BC1500_Inst_71_En = 1'b0;
BC1500_Inst_72_En = 1'b0;
BC1500_Inst_73_En = 1'b0;
BC1500_Inst_74_En = 1'b0;
BC1500_Inst_75_En = 1'b0;
BC1500_Inst_76_En = 1'b0;
BC1500_Inst_77_En = 1'b0;
BC1500_Inst_78_En = 1'b0;
BC1500_Inst_79_En = 1'b0;
BC1500_Inst_80_En = 1'b0;
BC1500_Inst_81_En = 1'b0;
BC1500_Inst_82_En = 1'b0;
BC1500_Inst_83_En = 1'b0;
BC1500_Inst_84_En = 1'b0;
BC1500_Inst_85_En = 1'b0;
BC1500_Inst_86_En = 1'b0;
BC1500_Inst_87_En = 1'b0;
BC1500_Inst_88_En = 1'b0;
BC1500_Inst_89_En = 1'b0;
BC1500_Inst_90_En = 1'b0;
BC1500_Inst_91_En = 1'b0;
BC1500_Inst_92_En = 1'b0;
BC1500_Inst_93_En = 1'b0;
BC1500_Inst_94_En = 1'b0;
BC1500_Inst_95_En = 1'b0;
BC1500_Inst_96_En = 1'b0;
BC1500_Inst_97_En = 1'b0;
BC1500_Inst_98_En = 1'b0;
BC1500_Inst_99_En = 1'b0;
BC1500_Inst_100_En = 1'b0;
BC1500_Inst_101_En = 1'b0;
BC1500_Inst_102_En = 1'b0;
BC1500_Inst_103_En = 1'b0;
BC1500_Inst_104_En = 1'b0;
BC1500_Inst_105_En = 1'b0;
BC1500_Inst_106_En = 1'b0;
BC1500_Inst_107_En = 1'b0;
BC1500_Inst_108_En = 1'b0;
BC1500_Inst_109_En = 1'b0;
BC1500_Inst_110_En = 1'b0;
BC1500_Inst_111_En = 1'b0;
BC1500_Inst_112_En = 1'b0;
BC1500_Inst_113_En = 1'b0;
BC1500_Inst_114_En = 1'b0;
BC1500_Inst_115_En = 1'b0;
BC1500_Inst_116_En = 1'b0;
BC1500_Inst_117_En = 1'b0;
BC1500_Inst_118_En = 1'b0;
BC1500_Inst_119_En = 1'b0;
BC1500_Inst_120_En = 1'b0;
BC1500_Inst_121_En = 1'b0;
BC1500_Inst_122_En = 1'b0;
BC1500_Inst_123_En = 1'b0;
BC1500_Inst_124_En = 1'b0;
BC1500_Inst_125_En = 1'b0;
BC1500_Inst_126_En = 1'b0;
BC1500_Inst_127_En = 1'b0;
BC1500_Inst_128_En = 1'b0;
BC1500_Inst_129_En = 1'b0;
BC1500_Inst_130_En = 1'b0;
BC1500_Inst_131_En = 1'b0;
BC1500_Inst_132_En = 1'b0;
BC1500_Inst_133_En = 1'b0;
BC1500_Inst_134_En = 1'b0;
BC1500_Inst_135_En = 1'b0;
BC1500_Inst_136_En = 1'b0;
BC1500_Inst_137_En = 1'b0;
BC1500_Inst_138_En = 1'b0;
BC1500_Inst_139_En = 1'b0;
BC1500_Inst_140_En = 1'b0;
BC1500_Inst_141_En = 1'b0;
BC1500_Inst_142_En = 1'b0;
BC1500_Inst_143_En = 1'b0;
BC1500_Inst_144_En = 1'b0;
BC1500_Inst_145_En = 1'b0;
BC1500_Inst_146_En = 1'b0;
BC1500_Inst_147_En = 1'b0;
BC1500_Inst_148_En = 1'b0;
BC1500_Inst_149_En = 1'b0;
BC1500_Inst_150_En = 1'b0;
BC1500_Inst_151_En = 1'b0;
BC1500_Inst_152_En = 1'b0;
BC1500_Inst_153_En = 1'b0;
BC1500_Inst_154_En = 1'b0;
BC1500_Inst_155_En = 1'b0;
BC1500_Inst_156_En = 1'b0;
BC1500_Inst_157_En = 1'b0;
BC1500_Inst_158_En = 1'b0;
BC1500_Inst_159_En = 1'b0;
BC1500_Inst_160_En = 1'b0;
BC1500_Inst_161_En = 1'b0;
BC1500_Inst_162_En = 1'b0;
BC1500_Inst_163_En = 1'b0;
BC1500_Inst_164_En = 1'b0;
BC1500_Inst_165_En = 1'b0;
BC1500_Inst_166_En = 1'b0;
BC1500_Inst_167_En = 1'b0;
BC1500_Inst_168_En = 1'b0;
BC1500_Inst_169_En = 1'b0;
BC1500_Inst_170_En = 1'b0;
BC1500_Inst_171_En = 1'b0;
BC1500_Inst_172_En = 1'b0;
BC1500_Inst_173_En = 1'b0;
BC1500_Inst_174_En = 1'b0;
BC1500_Inst_175_En = 1'b0;
BC1500_Inst_176_En = 1'b0;
BC1500_Inst_177_En = 1'b0;
BC1500_Inst_178_En = 1'b0;
BC1500_Inst_179_En = 1'b0;
BC1500_Inst_180_En = 1'b0;
BC1500_Inst_181_En = 1'b0;
BC1500_Inst_182_En = 1'b0;
BC1500_Inst_183_En = 1'b0;
BC1500_Inst_184_En = 1'b0;
BC1500_Inst_185_En = 1'b0;
BC1500_Inst_186_En = 1'b0;
BC1500_Inst_187_En = 1'b0;
BC1500_Inst_188_En = 1'b0;
BC1500_Inst_189_En = 1'b0;
BC1500_Inst_190_En = 1'b0;
BC1500_Inst_191_En = 1'b0;
BC1500_Inst_192_En = 1'b0;
BC1500_Inst_193_En = 1'b0;
BC1500_Inst_194_En = 1'b0;
BC1500_Inst_195_En = 1'b0;
BC1500_Inst_196_En = 1'b0;
BC1500_Inst_197_En = 1'b0;
BC1500_Inst_198_En = 1'b0;
BC1500_Inst_199_En = 1'b0;
BC1500_Inst_200_En = 1'b0;
BC1500_Inst_201_En = 1'b0;
BC1500_Inst_202_En = 1'b0;
BC1500_Inst_203_En = 1'b0;
BC1500_Inst_204_En = 1'b0;
BC1500_Inst_205_En = 1'b0;
BC1500_Inst_206_En = 1'b0;
BC1500_Inst_207_En = 1'b0;
BC1500_Inst_208_En = 1'b0;
BC1500_Inst_209_En = 1'b0;
BC1500_Inst_210_En = 1'b0;
BC1500_Inst_211_En = 1'b0;
BC1500_Inst_212_En = 1'b0;
BC1500_Inst_213_En = 1'b0;
BC1500_Inst_214_En = 1'b0;
BC1500_Inst_215_En = 1'b0;
BC1500_Inst_216_En = 1'b0;
BC1500_Inst_217_En = 1'b0;
BC1500_Inst_218_En = 1'b0;
BC1500_Inst_219_En = 1'b0;
BC1500_Inst_220_En = 1'b0;
BC1500_Inst_221_En = 1'b0;
BC1500_Inst_222_En = 1'b0;
BC1500_Inst_223_En = 1'b0;
BC1500_Inst_224_En = 1'b0;
BC1500_Inst_225_En = 1'b0;
BC1500_Inst_226_En = 1'b0;
BC1500_Inst_227_En = 1'b0;
BC1500_Inst_228_En = 1'b0;
BC1500_Inst_229_En = 1'b0;
BC1500_Inst_230_En = 1'b0;
BC1500_Inst_231_En = 1'b0;
BC1500_Inst_232_En = 1'b0;
BC1500_Inst_233_En = 1'b0;
BC1500_Inst_234_En = 1'b0;
BC1500_Inst_235_En = 1'b0;
BC1500_Inst_236_En = 1'b0;
BC1500_Inst_237_En = 1'b0;
BC1500_Inst_238_En = 1'b0;
BC1500_Inst_239_En = 1'b0;
BC1500_Inst_240_En = 1'b0;
BC1500_Inst_241_En = 1'b0;
BC1500_Inst_242_En = 1'b0;
BC1500_Inst_243_En = 1'b0;
BC1500_Inst_244_En = 1'b0;
BC1500_Inst_245_En = 1'b0;
BC1500_Inst_246_En = 1'b0;
BC1500_Inst_247_En = 1'b0;
BC1500_Inst_248_En = 1'b0;
BC1500_Inst_249_En = 1'b0;
BC1500_Inst_250_En = 1'b0;
BC1500_Inst_251_En = 1'b0;
BC1500_Inst_252_En = 1'b0;
BC1500_Inst_253_En = 1'b0;
BC1500_Inst_254_En = 1'b0;
BC1500_Inst_255_En = 1'b0;
BC1500_Inst_256_En = 1'b0;
BC1500_Inst_257_En = 1'b0;
BC1500_Inst_258_En = 1'b0;
BC1500_Inst_259_En = 1'b0;
BC1500_Inst_260_En = 1'b0;
BC1500_Inst_261_En = 1'b0;
BC1500_Inst_262_En = 1'b0;
BC1500_Inst_263_En = 1'b0;
BC1500_Inst_264_En = 1'b0;
BC1500_Inst_265_En = 1'b0;
BC1500_Inst_266_En = 1'b0;
BC1500_Inst_267_En = 1'b0;
BC1500_Inst_268_En = 1'b0;
BC1500_Inst_269_En = 1'b0;
BC1500_Inst_270_En = 1'b0;
BC1500_Inst_271_En = 1'b0;
BC1500_Inst_272_En = 1'b0;
BC1500_Inst_273_En = 1'b0;
BC1500_Inst_274_En = 1'b0;
BC1500_Inst_275_En = 1'b0;
BC1500_Inst_276_En = 1'b0;
BC1500_Inst_277_En = 1'b0;
BC1500_Inst_278_En = 1'b0;
BC1500_Inst_279_En = 1'b0;
BC1500_Inst_280_En = 1'b0;
BC1500_Inst_281_En = 1'b0;
BC1500_Inst_282_En = 1'b0;
BC1500_Inst_283_En = 1'b0;
BC1500_Inst_284_En = 1'b0;
BC1500_Inst_285_En = 1'b0;
BC1500_Inst_286_En = 1'b0;
BC1500_Inst_287_En = 1'b0;
BC1500_Inst_288_En = 1'b0;
BC1500_Inst_289_En = 1'b0;
BC1500_Inst_290_En = 1'b0;
BC1500_Inst_291_En = 1'b0;
BC1500_Inst_292_En = 1'b0;
BC1500_Inst_293_En = 1'b0;
BC1500_Inst_294_En = 1'b0;
BC1500_Inst_295_En = 1'b0;
BC1500_Inst_296_En = 1'b0;
BC1500_Inst_297_En = 1'b0;
BC1500_Inst_298_En = 1'b0;
BC1500_Inst_299_En = 1'b0;
BC1500_Inst_300_En = 1'b0;
BC1500_Inst_301_En = 1'b0;
BC1500_Inst_302_En = 1'b0;
BC1500_Inst_303_En = 1'b0;
BC1500_Inst_304_En = 1'b0;
BC1500_Inst_305_En = 1'b0;
BC1500_Inst_306_En = 1'b0;
BC1500_Inst_307_En = 1'b0;
BC1500_Inst_308_En = 1'b0;
BC1500_Inst_309_En = 1'b0;
BC1500_Inst_310_En = 1'b0;
BC1500_Inst_311_En = 1'b0;
BC1500_Inst_312_En = 1'b0;
BC1500_Inst_313_En = 1'b0;
BC1500_Inst_314_En = 1'b0;
BC1500_Inst_315_En = 1'b0;
BC1500_Inst_316_En = 1'b0;
BC1500_Inst_317_En = 1'b0;
BC1500_Inst_318_En = 1'b0;
BC1500_Inst_319_En = 1'b0;
BC1500_Inst_320_En = 1'b0;
BC1500_Inst_321_En = 1'b0;
BC1500_Inst_322_En = 1'b0;
BC1500_Inst_323_En = 1'b0;
BC1500_Inst_324_En = 1'b0;
BC1500_Inst_325_En = 1'b0;
BC1500_Inst_326_En = 1'b0;
BC1500_Inst_327_En = 1'b0;
BC1500_Inst_328_En = 1'b0;
BC1500_Inst_329_En = 1'b0;
BC1500_Inst_330_En = 1'b0;
BC1500_Inst_331_En = 1'b0;
BC1500_Inst_332_En = 1'b0;
BC1500_Inst_333_En = 1'b0;
BC1500_Inst_334_En = 1'b0;
BC1500_Inst_335_En = 1'b0;
BC1500_Inst_336_En = 1'b0;
BC1500_Inst_337_En = 1'b0;
BC1500_Inst_338_En = 1'b0;
BC1500_Inst_339_En = 1'b0;
BC1500_Inst_340_En = 1'b0;
BC1500_Inst_341_En = 1'b0;
BC1500_Inst_342_En = 1'b0;
BC1500_Inst_343_En = 1'b0;
BC1500_Inst_344_En = 1'b0;
BC1500_Inst_345_En = 1'b0;
BC1500_Inst_346_En = 1'b0;
BC1500_Inst_347_En = 1'b0;
BC1500_Inst_348_En = 1'b0;
BC1500_Inst_349_En = 1'b0;
BC1500_Inst_350_En = 1'b0;
BC1500_Inst_351_En = 1'b0;
BC1500_Inst_352_En = 1'b0;
BC1500_Inst_353_En = 1'b0;
BC1500_Inst_354_En = 1'b0;
BC1500_Inst_355_En = 1'b0;
BC1500_Inst_356_En = 1'b0;
BC1500_Inst_357_En = 1'b0;
BC1500_Inst_358_En = 1'b0;
BC1500_Inst_359_En = 1'b0;
BC1500_Inst_360_En = 1'b0;
BC1500_Inst_361_En = 1'b0;
BC1500_Inst_362_En = 1'b0;
BC1500_Inst_363_En = 1'b0;
BC1500_Inst_364_En = 1'b0;
BC1500_Inst_365_En = 1'b0;
BC1500_Inst_366_En = 1'b0;
BC1500_Inst_367_En = 1'b0;
BC1500_Inst_368_En = 1'b0;
BC1500_Inst_369_En = 1'b0;
BC1500_Inst_370_En = 1'b0;
BC1500_Inst_371_En = 1'b0;
BC1500_Inst_372_En = 1'b0;
BC1500_Inst_373_En = 1'b0;
BC1500_Inst_374_En = 1'b0;
BC1500_Inst_375_En = 1'b0;
BC1500_Inst_376_En = 1'b0;
BC1500_Inst_377_En = 1'b0;
BC1500_Inst_378_En = 1'b0;
BC1500_Inst_379_En = 1'b0;
BC1500_Inst_380_En = 1'b0;
BC1500_Inst_381_En = 1'b0;
BC1500_Inst_382_En = 1'b0;
BC1500_Inst_383_En = 1'b0;
BC1500_Inst_384_En = 1'b0;
BC1500_Inst_385_En = 1'b0;
BC1500_Inst_386_En = 1'b0;
BC1500_Inst_387_En = 1'b0;
BC1500_Inst_388_En = 1'b0;
BC1500_Inst_389_En = 1'b0;
BC1500_Inst_390_En = 1'b0;
BC1500_Inst_391_En = 1'b0;
BC1500_Inst_392_En = 1'b0;
BC1500_Inst_393_En = 1'b0;
BC1500_Inst_394_En = 1'b0;
BC1500_Inst_395_En = 1'b0;
BC1500_Inst_396_En = 1'b0;
BC1500_Inst_397_En = 1'b0;
BC1500_Inst_398_En = 1'b0;
BC1500_Inst_399_En = 1'b0;
BC1500_Inst_400_En = 1'b0;
BC1500_Inst_401_En = 1'b0;
BC1500_Inst_402_En = 1'b0;
BC1500_Inst_403_En = 1'b0;
BC1500_Inst_404_En = 1'b0;
BC1500_Inst_405_En = 1'b0;
BC1500_Inst_406_En = 1'b0;
BC1500_Inst_407_En = 1'b0;
BC1500_Inst_408_En = 1'b0;
BC1500_Inst_409_En = 1'b0;
BC1500_Inst_410_En = 1'b0;
BC1500_Inst_411_En = 1'b0;
BC1500_Inst_412_En = 1'b0;
BC1500_Inst_413_En = 1'b0;
BC1500_Inst_414_En = 1'b0;
BC1500_Inst_415_En = 1'b0;
BC1500_Inst_416_En = 1'b0;
BC1500_Inst_417_En = 1'b0;
BC1500_Inst_418_En = 1'b0;
BC1500_Inst_419_En = 1'b0;
BC1500_Inst_420_En = 1'b0;
BC1500_Inst_421_En = 1'b0;
BC1500_Inst_422_En = 1'b0;
BC1500_Inst_423_En = 1'b0;
BC1500_Inst_424_En = 1'b0;
BC1500_Inst_425_En = 1'b0;
BC1500_Inst_426_En = 1'b0;
BC1500_Inst_427_En = 1'b0;
BC1500_Inst_428_En = 1'b0;
BC1500_Inst_429_En = 1'b0;
BC1500_Inst_430_En = 1'b0;
BC1500_Inst_431_En = 1'b0;
BC1500_Inst_432_En = 1'b0;
BC1500_Inst_433_En = 1'b0;
BC1500_Inst_434_En = 1'b0;
BC1500_Inst_435_En = 1'b0;
BC1500_Inst_436_En = 1'b0;
BC1500_Inst_437_En = 1'b0;
BC1500_Inst_438_En = 1'b0;
BC1500_Inst_439_En = 1'b0;
BC1500_Inst_440_En = 1'b0;
BC1500_Inst_441_En = 1'b0;
BC1500_Inst_442_En = 1'b0;
BC1500_Inst_443_En = 1'b0;
BC1500_Inst_444_En = 1'b0;
BC1500_Inst_445_En = 1'b0;
BC1500_Inst_446_En = 1'b0;
BC1500_Inst_447_En = 1'b0;
BC1500_Inst_448_En = 1'b0;
BC1500_Inst_449_En = 1'b0;
BC1500_Inst_450_En = 1'b0;
BC1500_Inst_451_En = 1'b0;
BC1500_Inst_452_En = 1'b0;
BC1500_Inst_453_En = 1'b0;
BC1500_Inst_454_En = 1'b0;
BC1500_Inst_455_En = 1'b0;
BC1500_Inst_456_En = 1'b0;
BC1500_Inst_457_En = 1'b0;
BC1500_Inst_458_En = 1'b0;
BC1500_Inst_459_En = 1'b0;
BC1500_Inst_460_En = 1'b0;
BC1500_Inst_461_En = 1'b0;
BC1500_Inst_462_En = 1'b0;
BC1500_Inst_463_En = 1'b0;
BC1500_Inst_464_En = 1'b0;
BC1500_Inst_465_En = 1'b0;
BC1500_Inst_466_En = 1'b0;
BC1500_Inst_467_En = 1'b0;
BC1500_Inst_468_En = 1'b0;
BC1500_Inst_469_En = 1'b0;
BC1500_Inst_470_En = 1'b0;
BC1500_Inst_471_En = 1'b0;
BC1500_Inst_472_En = 1'b0;
BC1500_Inst_473_En = 1'b0;
BC1500_Inst_474_En = 1'b0;
BC1500_Inst_475_En = 1'b0;
BC1500_Inst_476_En = 1'b0;
BC1500_Inst_477_En = 1'b0;
BC1500_Inst_478_En = 1'b0;
BC1500_Inst_479_En = 1'b0;
BC1500_Inst_480_En = 1'b0;
BC1500_Inst_481_En = 1'b0;
BC1500_Inst_482_En = 1'b0;
BC1500_Inst_483_En = 1'b0;
BC1500_Inst_484_En = 1'b0;
BC1500_Inst_485_En = 1'b0;
BC1500_Inst_486_En = 1'b0;
BC1500_Inst_487_En = 1'b0;
BC1500_Inst_488_En = 1'b0;
BC1500_Inst_489_En = 1'b0;
BC1500_Inst_490_En = 1'b0;
BC1500_Inst_491_En = 1'b0;
BC1500_Inst_492_En = 1'b0;
BC1500_Inst_493_En = 1'b0;
BC1500_Inst_494_En = 1'b0;
BC1500_Inst_495_En = 1'b0;
BC1500_Inst_496_En = 1'b0;
BC1500_Inst_497_En = 1'b0;
BC1500_Inst_498_En = 1'b0;
BC1500_Inst_499_En = 1'b0;
BC1500_Inst_500_En = 1'b0;
BC1500_Inst_501_En = 1'b0;
BC1500_Inst_502_En = 1'b0;
BC1500_Inst_503_En = 1'b0;
BC1500_Inst_504_En = 1'b0;
BC1500_Inst_505_En = 1'b0;
BC1500_Inst_506_En = 1'b0;
BC1500_Inst_507_En = 1'b0;
BC1500_Inst_508_En = 1'b0;
BC1500_Inst_509_En = 1'b0;
BC1500_Inst_510_En = 1'b0;
BC1500_Bypass_En  = 1'b0; 

    case (IR_to_decoder [9-1:0])







    9'h0 : begin  //000000000 0     0

    BC1500_Inst_0_En   =  BC1500_Inst_0_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_0_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_0_Dec_En & ~dis_sc ? BC1500_Inst_0_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1 : begin  //000000001 1     1

    BC1500_Inst_1_En   =  BC1500_Inst_1_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_1_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_1_Dec_En & ~dis_sc ? BC1500_Inst_1_Tdo : Tdr_Bypass_Tdo;
    end




    9'h2 : begin  //000000010 2     2

    BC1500_Inst_2_En   =  BC1500_Inst_2_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_2_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_2_Dec_En & ~dis_sc ? BC1500_Inst_2_Tdo : Tdr_Bypass_Tdo;
    end




    9'h3 : begin  //000000011 3     3

    BC1500_Inst_3_En   =  BC1500_Inst_3_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_3_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_3_Dec_En & ~dis_sc ? BC1500_Inst_3_Tdo : Tdr_Bypass_Tdo;
    end




    9'h4 : begin  //000000100 4     4

    BC1500_Inst_4_En   =  BC1500_Inst_4_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_4_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_4_Dec_En & ~dis_sc ? BC1500_Inst_4_Tdo : Tdr_Bypass_Tdo;
    end




    9'h5 : begin  //000000101 5     5

    BC1500_Inst_5_En   =  BC1500_Inst_5_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_5_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_5_Dec_En & ~dis_sc ? BC1500_Inst_5_Tdo : Tdr_Bypass_Tdo;
    end




    9'h6 : begin  //000000110 6     6

    BC1500_Inst_6_En   =  BC1500_Inst_6_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_6_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_6_Dec_En & ~dis_sc ? BC1500_Inst_6_Tdo : Tdr_Bypass_Tdo;
    end




    9'h7 : begin  //000000111 7     7

    BC1500_Inst_7_En   =  BC1500_Inst_7_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_7_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_7_Dec_En & ~dis_sc ? BC1500_Inst_7_Tdo : Tdr_Bypass_Tdo;
    end




    9'h8 : begin  //000001000 8     8

    BC1500_Inst_8_En   =  BC1500_Inst_8_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_8_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_8_Dec_En & ~dis_sc ? BC1500_Inst_8_Tdo : Tdr_Bypass_Tdo;
    end




    9'h9 : begin  //000001001 9     9

    BC1500_Inst_9_En   =  BC1500_Inst_9_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_9_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_9_Dec_En & ~dis_sc ? BC1500_Inst_9_Tdo : Tdr_Bypass_Tdo;
    end




    9'ha : begin  //000001010 10     10

    BC1500_Inst_10_En   =  BC1500_Inst_10_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_10_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_10_Dec_En & ~dis_sc ? BC1500_Inst_10_Tdo : Tdr_Bypass_Tdo;
    end




    9'hb : begin  //000001011 11     11

    BC1500_Inst_11_En   =  BC1500_Inst_11_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_11_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_11_Dec_En & ~dis_sc ? BC1500_Inst_11_Tdo : Tdr_Bypass_Tdo;
    end




    9'hc : begin  //000001100 12     12

    BC1500_Inst_12_En   =  BC1500_Inst_12_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_12_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_12_Dec_En & ~dis_sc ? BC1500_Inst_12_Tdo : Tdr_Bypass_Tdo;
    end




    9'hd : begin  //000001101 13     13

    BC1500_Inst_13_En   =  BC1500_Inst_13_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_13_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_13_Dec_En & ~dis_sc ? BC1500_Inst_13_Tdo : Tdr_Bypass_Tdo;
    end




    9'he : begin  //000001110 14     14

    BC1500_Inst_14_En   =  BC1500_Inst_14_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_14_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_14_Dec_En & ~dis_sc ? BC1500_Inst_14_Tdo : Tdr_Bypass_Tdo;
    end




    9'hf : begin  //000001111 15     15

    BC1500_Inst_15_En   =  BC1500_Inst_15_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_15_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_15_Dec_En & ~dis_sc ? BC1500_Inst_15_Tdo : Tdr_Bypass_Tdo;
    end




    9'h10 : begin  //000010000 16     16

    BC1500_Inst_16_En   =  BC1500_Inst_16_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_16_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_16_Dec_En & ~dis_sc ? BC1500_Inst_16_Tdo : Tdr_Bypass_Tdo;
    end




    9'h11 : begin  //000010001 17     17

    BC1500_Inst_17_En   =  BC1500_Inst_17_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_17_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_17_Dec_En & ~dis_sc ? BC1500_Inst_17_Tdo : Tdr_Bypass_Tdo;
    end




    9'h12 : begin  //000010010 18     18

    BC1500_Inst_18_En   =  BC1500_Inst_18_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_18_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_18_Dec_En & ~dis_sc ? BC1500_Inst_18_Tdo : Tdr_Bypass_Tdo;
    end




    9'h13 : begin  //000010011 19     19

    BC1500_Inst_19_En   =  BC1500_Inst_19_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_19_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_19_Dec_En & ~dis_sc ? BC1500_Inst_19_Tdo : Tdr_Bypass_Tdo;
    end




    9'h14 : begin  //000010100 20     20

    BC1500_Inst_20_En   =  BC1500_Inst_20_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_20_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_20_Dec_En & ~dis_sc ? BC1500_Inst_20_Tdo : Tdr_Bypass_Tdo;
    end




    9'h15 : begin  //000010101 21     21

    BC1500_Inst_21_En   =  BC1500_Inst_21_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_21_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_21_Dec_En & ~dis_sc ? BC1500_Inst_21_Tdo : Tdr_Bypass_Tdo;
    end




    9'h16 : begin  //000010110 22     22

    BC1500_Inst_22_En   =  BC1500_Inst_22_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_22_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_22_Dec_En & ~dis_sc ? BC1500_Inst_22_Tdo : Tdr_Bypass_Tdo;
    end




    9'h17 : begin  //000010111 23     23

    BC1500_Inst_23_En   =  BC1500_Inst_23_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_23_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_23_Dec_En & ~dis_sc ? BC1500_Inst_23_Tdo : Tdr_Bypass_Tdo;
    end




    9'h18 : begin  //000011000 24     24

    BC1500_Inst_24_En   =  BC1500_Inst_24_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_24_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_24_Dec_En & ~dis_sc ? BC1500_Inst_24_Tdo : Tdr_Bypass_Tdo;
    end




    9'h19 : begin  //000011001 25     25

    BC1500_Inst_25_En   =  BC1500_Inst_25_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_25_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_25_Dec_En & ~dis_sc ? BC1500_Inst_25_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1a : begin  //000011010 26     26

    BC1500_Inst_26_En   =  BC1500_Inst_26_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_26_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_26_Dec_En & ~dis_sc ? BC1500_Inst_26_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1b : begin  //000011011 27     27

    BC1500_Inst_27_En   =  BC1500_Inst_27_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_27_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_27_Dec_En & ~dis_sc ? BC1500_Inst_27_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1c : begin  //000011100 28     28

    BC1500_Inst_28_En   =  BC1500_Inst_28_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_28_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_28_Dec_En & ~dis_sc ? BC1500_Inst_28_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1d : begin  //000011101 29     29

    BC1500_Inst_29_En   =  BC1500_Inst_29_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_29_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_29_Dec_En & ~dis_sc ? BC1500_Inst_29_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1e : begin  //000011110 30     30

    BC1500_Inst_30_En   =  BC1500_Inst_30_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_30_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_30_Dec_En & ~dis_sc ? BC1500_Inst_30_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1f : begin  //000011111 31     31

    BC1500_Inst_31_En   =  BC1500_Inst_31_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_31_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_31_Dec_En & ~dis_sc ? BC1500_Inst_31_Tdo : Tdr_Bypass_Tdo;
    end




    9'h20 : begin  //000100000 32     32

    BC1500_Inst_32_En   =  BC1500_Inst_32_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_32_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_32_Dec_En & ~dis_sc ? BC1500_Inst_32_Tdo : Tdr_Bypass_Tdo;
    end




    9'h21 : begin  //000100001 33     33

    BC1500_Inst_33_En   =  BC1500_Inst_33_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_33_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_33_Dec_En & ~dis_sc ? BC1500_Inst_33_Tdo : Tdr_Bypass_Tdo;
    end




    9'h22 : begin  //000100010 34     34

    BC1500_Inst_34_En   =  BC1500_Inst_34_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_34_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_34_Dec_En & ~dis_sc ? BC1500_Inst_34_Tdo : Tdr_Bypass_Tdo;
    end




    9'h23 : begin  //000100011 35     35

    BC1500_Inst_35_En   =  BC1500_Inst_35_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_35_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_35_Dec_En & ~dis_sc ? BC1500_Inst_35_Tdo : Tdr_Bypass_Tdo;
    end




    9'h24 : begin  //000100100 36     36

    BC1500_Inst_36_En   =  BC1500_Inst_36_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_36_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_36_Dec_En & ~dis_sc ? BC1500_Inst_36_Tdo : Tdr_Bypass_Tdo;
    end




    9'h25 : begin  //000100101 37     37

    BC1500_Inst_37_En   =  BC1500_Inst_37_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_37_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_37_Dec_En & ~dis_sc ? BC1500_Inst_37_Tdo : Tdr_Bypass_Tdo;
    end




    9'h26 : begin  //000100110 38     38

    BC1500_Inst_38_En   =  BC1500_Inst_38_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_38_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_38_Dec_En & ~dis_sc ? BC1500_Inst_38_Tdo : Tdr_Bypass_Tdo;
    end




    9'h27 : begin  //000100111 39     39

    BC1500_Inst_39_En   =  BC1500_Inst_39_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_39_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_39_Dec_En & ~dis_sc ? BC1500_Inst_39_Tdo : Tdr_Bypass_Tdo;
    end




    9'h28 : begin  //000101000 40     40

    BC1500_Inst_40_En   =  BC1500_Inst_40_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_40_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_40_Dec_En & ~dis_sc ? BC1500_Inst_40_Tdo : Tdr_Bypass_Tdo;
    end




    9'h29 : begin  //000101001 41     41

    BC1500_Inst_41_En   =  BC1500_Inst_41_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_41_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_41_Dec_En & ~dis_sc ? BC1500_Inst_41_Tdo : Tdr_Bypass_Tdo;
    end




    9'h2a : begin  //000101010 42     42

    BC1500_Inst_42_En   =  BC1500_Inst_42_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_42_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_42_Dec_En & ~dis_sc ? BC1500_Inst_42_Tdo : Tdr_Bypass_Tdo;
    end




    9'h2b : begin  //000101011 43     43

    BC1500_Inst_43_En   =  BC1500_Inst_43_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_43_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_43_Dec_En & ~dis_sc ? BC1500_Inst_43_Tdo : Tdr_Bypass_Tdo;
    end




    9'h2c : begin  //000101100 44     44

    BC1500_Inst_44_En   =  BC1500_Inst_44_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_44_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_44_Dec_En & ~dis_sc ? BC1500_Inst_44_Tdo : Tdr_Bypass_Tdo;
    end




    9'h2d : begin  //000101101 45     45

    BC1500_Inst_45_En   =  BC1500_Inst_45_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_45_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_45_Dec_En & ~dis_sc ? BC1500_Inst_45_Tdo : Tdr_Bypass_Tdo;
    end




    9'h2e : begin  //000101110 46     46

    BC1500_Inst_46_En   =  BC1500_Inst_46_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_46_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_46_Dec_En & ~dis_sc ? BC1500_Inst_46_Tdo : Tdr_Bypass_Tdo;
    end




    9'h2f : begin  //000101111 47     47

    BC1500_Inst_47_En   =  BC1500_Inst_47_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_47_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_47_Dec_En & ~dis_sc ? BC1500_Inst_47_Tdo : Tdr_Bypass_Tdo;
    end




    9'h30 : begin  //000110000 48     48

    BC1500_Inst_48_En   =  BC1500_Inst_48_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_48_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_48_Dec_En & ~dis_sc ? BC1500_Inst_48_Tdo : Tdr_Bypass_Tdo;
    end




    9'h31 : begin  //000110001 49     49

    BC1500_Inst_49_En   =  BC1500_Inst_49_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_49_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_49_Dec_En & ~dis_sc ? BC1500_Inst_49_Tdo : Tdr_Bypass_Tdo;
    end




    9'h32 : begin  //000110010 50     50

    BC1500_Inst_50_En   =  BC1500_Inst_50_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_50_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_50_Dec_En & ~dis_sc ? BC1500_Inst_50_Tdo : Tdr_Bypass_Tdo;
    end




    9'h33 : begin  //000110011 51     51

    BC1500_Inst_51_En   =  BC1500_Inst_51_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_51_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_51_Dec_En & ~dis_sc ? BC1500_Inst_51_Tdo : Tdr_Bypass_Tdo;
    end




    9'h34 : begin  //000110100 52     52

    BC1500_Inst_52_En   =  BC1500_Inst_52_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_52_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_52_Dec_En & ~dis_sc ? BC1500_Inst_52_Tdo : Tdr_Bypass_Tdo;
    end




    9'h35 : begin  //000110101 53     53

    BC1500_Inst_53_En   =  BC1500_Inst_53_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_53_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_53_Dec_En & ~dis_sc ? BC1500_Inst_53_Tdo : Tdr_Bypass_Tdo;
    end




    9'h36 : begin  //000110110 54     54

    BC1500_Inst_54_En   =  BC1500_Inst_54_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_54_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_54_Dec_En & ~dis_sc ? BC1500_Inst_54_Tdo : Tdr_Bypass_Tdo;
    end




    9'h37 : begin  //000110111 55     55

    BC1500_Inst_55_En   =  BC1500_Inst_55_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_55_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_55_Dec_En & ~dis_sc ? BC1500_Inst_55_Tdo : Tdr_Bypass_Tdo;
    end




    9'h38 : begin  //000111000 56     56

    BC1500_Inst_56_En   =  BC1500_Inst_56_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_56_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_56_Dec_En & ~dis_sc ? BC1500_Inst_56_Tdo : Tdr_Bypass_Tdo;
    end




    9'h39 : begin  //000111001 57     57

    BC1500_Inst_57_En   =  BC1500_Inst_57_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_57_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_57_Dec_En & ~dis_sc ? BC1500_Inst_57_Tdo : Tdr_Bypass_Tdo;
    end




    9'h3a : begin  //000111010 58     58

    BC1500_Inst_58_En   =  BC1500_Inst_58_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_58_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_58_Dec_En & ~dis_sc ? BC1500_Inst_58_Tdo : Tdr_Bypass_Tdo;
    end




    9'h3b : begin  //000111011 59     59

    BC1500_Inst_59_En   =  BC1500_Inst_59_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_59_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_59_Dec_En & ~dis_sc ? BC1500_Inst_59_Tdo : Tdr_Bypass_Tdo;
    end




    9'h3c : begin  //000111100 60     60

    BC1500_Inst_60_En   =  BC1500_Inst_60_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_60_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_60_Dec_En & ~dis_sc ? BC1500_Inst_60_Tdo : Tdr_Bypass_Tdo;
    end




    9'h3d : begin  //000111101 61     61

    BC1500_Inst_61_En   =  BC1500_Inst_61_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_61_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_61_Dec_En & ~dis_sc ? BC1500_Inst_61_Tdo : Tdr_Bypass_Tdo;
    end




    9'h3e : begin  //000111110 62     62

    BC1500_Inst_62_En   =  BC1500_Inst_62_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_62_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_62_Dec_En & ~dis_sc ? BC1500_Inst_62_Tdo : Tdr_Bypass_Tdo;
    end




    9'h3f : begin  //000111111 63     63

    BC1500_Inst_63_En   =  BC1500_Inst_63_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_63_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_63_Dec_En & ~dis_sc ? BC1500_Inst_63_Tdo : Tdr_Bypass_Tdo;
    end




    9'h40 : begin  //001000000 64     64

    BC1500_Inst_64_En   =  BC1500_Inst_64_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_64_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_64_Dec_En & ~dis_sc ? BC1500_Inst_64_Tdo : Tdr_Bypass_Tdo;
    end




    9'h41 : begin  //001000001 65     65

    BC1500_Inst_65_En   =  BC1500_Inst_65_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_65_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_65_Dec_En & ~dis_sc ? BC1500_Inst_65_Tdo : Tdr_Bypass_Tdo;
    end




    9'h42 : begin  //001000010 66     66

    BC1500_Inst_66_En   =  BC1500_Inst_66_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_66_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_66_Dec_En & ~dis_sc ? BC1500_Inst_66_Tdo : Tdr_Bypass_Tdo;
    end




    9'h43 : begin  //001000011 67     67

    BC1500_Inst_67_En   =  BC1500_Inst_67_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_67_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_67_Dec_En & ~dis_sc ? BC1500_Inst_67_Tdo : Tdr_Bypass_Tdo;
    end




    9'h44 : begin  //001000100 68     68

    BC1500_Inst_68_En   =  BC1500_Inst_68_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_68_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_68_Dec_En & ~dis_sc ? BC1500_Inst_68_Tdo : Tdr_Bypass_Tdo;
    end




    9'h45 : begin  //001000101 69     69

    BC1500_Inst_69_En   =  BC1500_Inst_69_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_69_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_69_Dec_En & ~dis_sc ? BC1500_Inst_69_Tdo : Tdr_Bypass_Tdo;
    end




    9'h46 : begin  //001000110 70     70

    BC1500_Inst_70_En   =  BC1500_Inst_70_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_70_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_70_Dec_En & ~dis_sc ? BC1500_Inst_70_Tdo : Tdr_Bypass_Tdo;
    end




    9'h47 : begin  //001000111 71     71

    BC1500_Inst_71_En   =  BC1500_Inst_71_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_71_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_71_Dec_En & ~dis_sc ? BC1500_Inst_71_Tdo : Tdr_Bypass_Tdo;
    end




    9'h48 : begin  //001001000 72     72

    BC1500_Inst_72_En   =  BC1500_Inst_72_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_72_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_72_Dec_En & ~dis_sc ? BC1500_Inst_72_Tdo : Tdr_Bypass_Tdo;
    end




    9'h49 : begin  //001001001 73     73

    BC1500_Inst_73_En   =  BC1500_Inst_73_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_73_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_73_Dec_En & ~dis_sc ? BC1500_Inst_73_Tdo : Tdr_Bypass_Tdo;
    end




    9'h4a : begin  //001001010 74     74

    BC1500_Inst_74_En   =  BC1500_Inst_74_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_74_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_74_Dec_En & ~dis_sc ? BC1500_Inst_74_Tdo : Tdr_Bypass_Tdo;
    end




    9'h4b : begin  //001001011 75     75

    BC1500_Inst_75_En   =  BC1500_Inst_75_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_75_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_75_Dec_En & ~dis_sc ? BC1500_Inst_75_Tdo : Tdr_Bypass_Tdo;
    end




    9'h4c : begin  //001001100 76     76

    BC1500_Inst_76_En   =  BC1500_Inst_76_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_76_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_76_Dec_En & ~dis_sc ? BC1500_Inst_76_Tdo : Tdr_Bypass_Tdo;
    end




    9'h4d : begin  //001001101 77     77

    BC1500_Inst_77_En   =  BC1500_Inst_77_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_77_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_77_Dec_En & ~dis_sc ? BC1500_Inst_77_Tdo : Tdr_Bypass_Tdo;
    end




    9'h4e : begin  //001001110 78     78

    BC1500_Inst_78_En   =  BC1500_Inst_78_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_78_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_78_Dec_En & ~dis_sc ? BC1500_Inst_78_Tdo : Tdr_Bypass_Tdo;
    end




    9'h4f : begin  //001001111 79     79

    BC1500_Inst_79_En   =  BC1500_Inst_79_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_79_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_79_Dec_En & ~dis_sc ? BC1500_Inst_79_Tdo : Tdr_Bypass_Tdo;
    end




    9'h50 : begin  //001010000 80     80

    BC1500_Inst_80_En   =  BC1500_Inst_80_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_80_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_80_Dec_En & ~dis_sc ? BC1500_Inst_80_Tdo : Tdr_Bypass_Tdo;
    end




    9'h51 : begin  //001010001 81     81

    BC1500_Inst_81_En   =  BC1500_Inst_81_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_81_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_81_Dec_En & ~dis_sc ? BC1500_Inst_81_Tdo : Tdr_Bypass_Tdo;
    end




    9'h52 : begin  //001010010 82     82

    BC1500_Inst_82_En   =  BC1500_Inst_82_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_82_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_82_Dec_En & ~dis_sc ? BC1500_Inst_82_Tdo : Tdr_Bypass_Tdo;
    end




    9'h53 : begin  //001010011 83     83

    BC1500_Inst_83_En   =  BC1500_Inst_83_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_83_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_83_Dec_En & ~dis_sc ? BC1500_Inst_83_Tdo : Tdr_Bypass_Tdo;
    end




    9'h54 : begin  //001010100 84     84

    BC1500_Inst_84_En   =  BC1500_Inst_84_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_84_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_84_Dec_En & ~dis_sc ? BC1500_Inst_84_Tdo : Tdr_Bypass_Tdo;
    end




    9'h55 : begin  //001010101 85     85

    BC1500_Inst_85_En   =  BC1500_Inst_85_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_85_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_85_Dec_En & ~dis_sc ? BC1500_Inst_85_Tdo : Tdr_Bypass_Tdo;
    end




    9'h56 : begin  //001010110 86     86

    BC1500_Inst_86_En   =  BC1500_Inst_86_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_86_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_86_Dec_En & ~dis_sc ? BC1500_Inst_86_Tdo : Tdr_Bypass_Tdo;
    end




    9'h57 : begin  //001010111 87     87

    BC1500_Inst_87_En   =  BC1500_Inst_87_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_87_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_87_Dec_En & ~dis_sc ? BC1500_Inst_87_Tdo : Tdr_Bypass_Tdo;
    end




    9'h58 : begin  //001011000 88     88

    BC1500_Inst_88_En   =  BC1500_Inst_88_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_88_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_88_Dec_En & ~dis_sc ? BC1500_Inst_88_Tdo : Tdr_Bypass_Tdo;
    end




    9'h59 : begin  //001011001 89     89

    BC1500_Inst_89_En   =  BC1500_Inst_89_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_89_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_89_Dec_En & ~dis_sc ? BC1500_Inst_89_Tdo : Tdr_Bypass_Tdo;
    end




    9'h5a : begin  //001011010 90     90

    BC1500_Inst_90_En   =  BC1500_Inst_90_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_90_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_90_Dec_En & ~dis_sc ? BC1500_Inst_90_Tdo : Tdr_Bypass_Tdo;
    end




    9'h5b : begin  //001011011 91     91

    BC1500_Inst_91_En   =  BC1500_Inst_91_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_91_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_91_Dec_En & ~dis_sc ? BC1500_Inst_91_Tdo : Tdr_Bypass_Tdo;
    end




    9'h5c : begin  //001011100 92     92

    BC1500_Inst_92_En   =  BC1500_Inst_92_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_92_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_92_Dec_En & ~dis_sc ? BC1500_Inst_92_Tdo : Tdr_Bypass_Tdo;
    end




    9'h5d : begin  //001011101 93     93

    BC1500_Inst_93_En   =  BC1500_Inst_93_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_93_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_93_Dec_En & ~dis_sc ? BC1500_Inst_93_Tdo : Tdr_Bypass_Tdo;
    end




    9'h5e : begin  //001011110 94     94

    BC1500_Inst_94_En   =  BC1500_Inst_94_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_94_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_94_Dec_En & ~dis_sc ? BC1500_Inst_94_Tdo : Tdr_Bypass_Tdo;
    end




    9'h5f : begin  //001011111 95     95

    BC1500_Inst_95_En   =  BC1500_Inst_95_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_95_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_95_Dec_En & ~dis_sc ? BC1500_Inst_95_Tdo : Tdr_Bypass_Tdo;
    end




    9'h60 : begin  //001100000 96     96

    BC1500_Inst_96_En   =  BC1500_Inst_96_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_96_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_96_Dec_En & ~dis_sc ? BC1500_Inst_96_Tdo : Tdr_Bypass_Tdo;
    end




    9'h61 : begin  //001100001 97     97

    BC1500_Inst_97_En   =  BC1500_Inst_97_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_97_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_97_Dec_En & ~dis_sc ? BC1500_Inst_97_Tdo : Tdr_Bypass_Tdo;
    end




    9'h62 : begin  //001100010 98     98

    BC1500_Inst_98_En   =  BC1500_Inst_98_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_98_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_98_Dec_En & ~dis_sc ? BC1500_Inst_98_Tdo : Tdr_Bypass_Tdo;
    end




    9'h63 : begin  //001100011 99     99

    BC1500_Inst_99_En   =  BC1500_Inst_99_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_99_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_99_Dec_En & ~dis_sc ? BC1500_Inst_99_Tdo : Tdr_Bypass_Tdo;
    end




    9'h64 : begin  //001100100 100     100

    BC1500_Inst_100_En   =  BC1500_Inst_100_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_100_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_100_Dec_En & ~dis_sc ? BC1500_Inst_100_Tdo : Tdr_Bypass_Tdo;
    end




    9'h65 : begin  //001100101 101     101

    BC1500_Inst_101_En   =  BC1500_Inst_101_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_101_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_101_Dec_En & ~dis_sc ? BC1500_Inst_101_Tdo : Tdr_Bypass_Tdo;
    end




    9'h66 : begin  //001100110 102     102

    BC1500_Inst_102_En   =  BC1500_Inst_102_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_102_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_102_Dec_En & ~dis_sc ? BC1500_Inst_102_Tdo : Tdr_Bypass_Tdo;
    end




    9'h67 : begin  //001100111 103     103

    BC1500_Inst_103_En   =  BC1500_Inst_103_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_103_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_103_Dec_En & ~dis_sc ? BC1500_Inst_103_Tdo : Tdr_Bypass_Tdo;
    end




    9'h68 : begin  //001101000 104     104

    BC1500_Inst_104_En   =  BC1500_Inst_104_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_104_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_104_Dec_En & ~dis_sc ? BC1500_Inst_104_Tdo : Tdr_Bypass_Tdo;
    end




    9'h69 : begin  //001101001 105     105

    BC1500_Inst_105_En   =  BC1500_Inst_105_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_105_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_105_Dec_En & ~dis_sc ? BC1500_Inst_105_Tdo : Tdr_Bypass_Tdo;
    end




    9'h6a : begin  //001101010 106     106

    BC1500_Inst_106_En   =  BC1500_Inst_106_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_106_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_106_Dec_En & ~dis_sc ? BC1500_Inst_106_Tdo : Tdr_Bypass_Tdo;
    end




    9'h6b : begin  //001101011 107     107

    BC1500_Inst_107_En   =  BC1500_Inst_107_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_107_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_107_Dec_En & ~dis_sc ? BC1500_Inst_107_Tdo : Tdr_Bypass_Tdo;
    end




    9'h6c : begin  //001101100 108     108

    BC1500_Inst_108_En   =  BC1500_Inst_108_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_108_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_108_Dec_En & ~dis_sc ? BC1500_Inst_108_Tdo : Tdr_Bypass_Tdo;
    end




    9'h6d : begin  //001101101 109     109

    BC1500_Inst_109_En   =  BC1500_Inst_109_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_109_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_109_Dec_En & ~dis_sc ? BC1500_Inst_109_Tdo : Tdr_Bypass_Tdo;
    end




    9'h6e : begin  //001101110 110     110

    BC1500_Inst_110_En   =  BC1500_Inst_110_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_110_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_110_Dec_En & ~dis_sc ? BC1500_Inst_110_Tdo : Tdr_Bypass_Tdo;
    end




    9'h6f : begin  //001101111 111     111

    BC1500_Inst_111_En   =  BC1500_Inst_111_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_111_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_111_Dec_En & ~dis_sc ? BC1500_Inst_111_Tdo : Tdr_Bypass_Tdo;
    end




    9'h70 : begin  //001110000 112     112

    BC1500_Inst_112_En   =  BC1500_Inst_112_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_112_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_112_Dec_En & ~dis_sc ? BC1500_Inst_112_Tdo : Tdr_Bypass_Tdo;
    end




    9'h71 : begin  //001110001 113     113

    BC1500_Inst_113_En   =  BC1500_Inst_113_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_113_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_113_Dec_En & ~dis_sc ? BC1500_Inst_113_Tdo : Tdr_Bypass_Tdo;
    end




    9'h72 : begin  //001110010 114     114

    BC1500_Inst_114_En   =  BC1500_Inst_114_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_114_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_114_Dec_En & ~dis_sc ? BC1500_Inst_114_Tdo : Tdr_Bypass_Tdo;
    end




    9'h73 : begin  //001110011 115     115

    BC1500_Inst_115_En   =  BC1500_Inst_115_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_115_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_115_Dec_En & ~dis_sc ? BC1500_Inst_115_Tdo : Tdr_Bypass_Tdo;
    end




    9'h74 : begin  //001110100 116     116

    BC1500_Inst_116_En   =  BC1500_Inst_116_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_116_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_116_Dec_En & ~dis_sc ? BC1500_Inst_116_Tdo : Tdr_Bypass_Tdo;
    end




    9'h75 : begin  //001110101 117     117

    BC1500_Inst_117_En   =  BC1500_Inst_117_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_117_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_117_Dec_En & ~dis_sc ? BC1500_Inst_117_Tdo : Tdr_Bypass_Tdo;
    end




    9'h76 : begin  //001110110 118     118

    BC1500_Inst_118_En   =  BC1500_Inst_118_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_118_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_118_Dec_En & ~dis_sc ? BC1500_Inst_118_Tdo : Tdr_Bypass_Tdo;
    end




    9'h77 : begin  //001110111 119     119

    BC1500_Inst_119_En   =  BC1500_Inst_119_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_119_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_119_Dec_En & ~dis_sc ? BC1500_Inst_119_Tdo : Tdr_Bypass_Tdo;
    end




    9'h78 : begin  //001111000 120     120

    BC1500_Inst_120_En   =  BC1500_Inst_120_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_120_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_120_Dec_En & ~dis_sc ? BC1500_Inst_120_Tdo : Tdr_Bypass_Tdo;
    end




    9'h79 : begin  //001111001 121     121

    BC1500_Inst_121_En   =  BC1500_Inst_121_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_121_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_121_Dec_En & ~dis_sc ? BC1500_Inst_121_Tdo : Tdr_Bypass_Tdo;
    end




    9'h7a : begin  //001111010 122     122

    BC1500_Inst_122_En   =  BC1500_Inst_122_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_122_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_122_Dec_En & ~dis_sc ? BC1500_Inst_122_Tdo : Tdr_Bypass_Tdo;
    end




    9'h7b : begin  //001111011 123     123

    BC1500_Inst_123_En   =  BC1500_Inst_123_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_123_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_123_Dec_En & ~dis_sc ? BC1500_Inst_123_Tdo : Tdr_Bypass_Tdo;
    end




    9'h7c : begin  //001111100 124     124

    BC1500_Inst_124_En   =  BC1500_Inst_124_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_124_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_124_Dec_En & ~dis_sc ? BC1500_Inst_124_Tdo : Tdr_Bypass_Tdo;
    end




    9'h7d : begin  //001111101 125     125

    BC1500_Inst_125_En   =  BC1500_Inst_125_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_125_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_125_Dec_En & ~dis_sc ? BC1500_Inst_125_Tdo : Tdr_Bypass_Tdo;
    end




    9'h7e : begin  //001111110 126     126

    BC1500_Inst_126_En   =  BC1500_Inst_126_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_126_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_126_Dec_En & ~dis_sc ? BC1500_Inst_126_Tdo : Tdr_Bypass_Tdo;
    end




    9'h7f : begin  //001111111 127     127

    BC1500_Inst_127_En   =  BC1500_Inst_127_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_127_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_127_Dec_En & ~dis_sc ? BC1500_Inst_127_Tdo : Tdr_Bypass_Tdo;
    end




    9'h80 : begin  //010000000 128     128

    BC1500_Inst_128_En   =  BC1500_Inst_128_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_128_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_128_Dec_En & ~dis_sc ? BC1500_Inst_128_Tdo : Tdr_Bypass_Tdo;
    end




    9'h81 : begin  //010000001 129     129

    BC1500_Inst_129_En   =  BC1500_Inst_129_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_129_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_129_Dec_En & ~dis_sc ? BC1500_Inst_129_Tdo : Tdr_Bypass_Tdo;
    end




    9'h82 : begin  //010000010 130     130

    BC1500_Inst_130_En   =  BC1500_Inst_130_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_130_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_130_Dec_En & ~dis_sc ? BC1500_Inst_130_Tdo : Tdr_Bypass_Tdo;
    end




    9'h83 : begin  //010000011 131     131

    BC1500_Inst_131_En   =  BC1500_Inst_131_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_131_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_131_Dec_En & ~dis_sc ? BC1500_Inst_131_Tdo : Tdr_Bypass_Tdo;
    end




    9'h84 : begin  //010000100 132     132

    BC1500_Inst_132_En   =  BC1500_Inst_132_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_132_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_132_Dec_En & ~dis_sc ? BC1500_Inst_132_Tdo : Tdr_Bypass_Tdo;
    end




    9'h85 : begin  //010000101 133     133

    BC1500_Inst_133_En   =  BC1500_Inst_133_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_133_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_133_Dec_En & ~dis_sc ? BC1500_Inst_133_Tdo : Tdr_Bypass_Tdo;
    end




    9'h86 : begin  //010000110 134     134

    BC1500_Inst_134_En   =  BC1500_Inst_134_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_134_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_134_Dec_En & ~dis_sc ? BC1500_Inst_134_Tdo : Tdr_Bypass_Tdo;
    end




    9'h87 : begin  //010000111 135     135

    BC1500_Inst_135_En   =  BC1500_Inst_135_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_135_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_135_Dec_En & ~dis_sc ? BC1500_Inst_135_Tdo : Tdr_Bypass_Tdo;
    end




    9'h88 : begin  //010001000 136     136

    BC1500_Inst_136_En   =  BC1500_Inst_136_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_136_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_136_Dec_En & ~dis_sc ? BC1500_Inst_136_Tdo : Tdr_Bypass_Tdo;
    end




    9'h89 : begin  //010001001 137     137

    BC1500_Inst_137_En   =  BC1500_Inst_137_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_137_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_137_Dec_En & ~dis_sc ? BC1500_Inst_137_Tdo : Tdr_Bypass_Tdo;
    end




    9'h8a : begin  //010001010 138     138

    BC1500_Inst_138_En   =  BC1500_Inst_138_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_138_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_138_Dec_En & ~dis_sc ? BC1500_Inst_138_Tdo : Tdr_Bypass_Tdo;
    end




    9'h8b : begin  //010001011 139     139

    BC1500_Inst_139_En   =  BC1500_Inst_139_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_139_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_139_Dec_En & ~dis_sc ? BC1500_Inst_139_Tdo : Tdr_Bypass_Tdo;
    end




    9'h8c : begin  //010001100 140     140

    BC1500_Inst_140_En   =  BC1500_Inst_140_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_140_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_140_Dec_En & ~dis_sc ? BC1500_Inst_140_Tdo : Tdr_Bypass_Tdo;
    end




    9'h8d : begin  //010001101 141     141

    BC1500_Inst_141_En   =  BC1500_Inst_141_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_141_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_141_Dec_En & ~dis_sc ? BC1500_Inst_141_Tdo : Tdr_Bypass_Tdo;
    end




    9'h8e : begin  //010001110 142     142

    BC1500_Inst_142_En   =  BC1500_Inst_142_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_142_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_142_Dec_En & ~dis_sc ? BC1500_Inst_142_Tdo : Tdr_Bypass_Tdo;
    end




    9'h8f : begin  //010001111 143     143

    BC1500_Inst_143_En   =  BC1500_Inst_143_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_143_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_143_Dec_En & ~dis_sc ? BC1500_Inst_143_Tdo : Tdr_Bypass_Tdo;
    end




    9'h90 : begin  //010010000 144     144

    BC1500_Inst_144_En   =  BC1500_Inst_144_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_144_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_144_Dec_En & ~dis_sc ? BC1500_Inst_144_Tdo : Tdr_Bypass_Tdo;
    end




    9'h91 : begin  //010010001 145     145

    BC1500_Inst_145_En   =  BC1500_Inst_145_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_145_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_145_Dec_En & ~dis_sc ? BC1500_Inst_145_Tdo : Tdr_Bypass_Tdo;
    end




    9'h92 : begin  //010010010 146     146

    BC1500_Inst_146_En   =  BC1500_Inst_146_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_146_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_146_Dec_En & ~dis_sc ? BC1500_Inst_146_Tdo : Tdr_Bypass_Tdo;
    end




    9'h93 : begin  //010010011 147     147

    BC1500_Inst_147_En   =  BC1500_Inst_147_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_147_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_147_Dec_En & ~dis_sc ? BC1500_Inst_147_Tdo : Tdr_Bypass_Tdo;
    end




    9'h94 : begin  //010010100 148     148

    BC1500_Inst_148_En   =  BC1500_Inst_148_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_148_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_148_Dec_En & ~dis_sc ? BC1500_Inst_148_Tdo : Tdr_Bypass_Tdo;
    end




    9'h95 : begin  //010010101 149     149

    BC1500_Inst_149_En   =  BC1500_Inst_149_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_149_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_149_Dec_En & ~dis_sc ? BC1500_Inst_149_Tdo : Tdr_Bypass_Tdo;
    end




    9'h96 : begin  //010010110 150     150

    BC1500_Inst_150_En   =  BC1500_Inst_150_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_150_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_150_Dec_En & ~dis_sc ? BC1500_Inst_150_Tdo : Tdr_Bypass_Tdo;
    end




    9'h97 : begin  //010010111 151     151

    BC1500_Inst_151_En   =  BC1500_Inst_151_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_151_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_151_Dec_En & ~dis_sc ? BC1500_Inst_151_Tdo : Tdr_Bypass_Tdo;
    end




    9'h98 : begin  //010011000 152     152

    BC1500_Inst_152_En   =  BC1500_Inst_152_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_152_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_152_Dec_En & ~dis_sc ? BC1500_Inst_152_Tdo : Tdr_Bypass_Tdo;
    end




    9'h99 : begin  //010011001 153     153

    BC1500_Inst_153_En   =  BC1500_Inst_153_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_153_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_153_Dec_En & ~dis_sc ? BC1500_Inst_153_Tdo : Tdr_Bypass_Tdo;
    end




    9'h9a : begin  //010011010 154     154

    BC1500_Inst_154_En   =  BC1500_Inst_154_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_154_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_154_Dec_En & ~dis_sc ? BC1500_Inst_154_Tdo : Tdr_Bypass_Tdo;
    end




    9'h9b : begin  //010011011 155     155

    BC1500_Inst_155_En   =  BC1500_Inst_155_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_155_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_155_Dec_En & ~dis_sc ? BC1500_Inst_155_Tdo : Tdr_Bypass_Tdo;
    end




    9'h9c : begin  //010011100 156     156

    BC1500_Inst_156_En   =  BC1500_Inst_156_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_156_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_156_Dec_En & ~dis_sc ? BC1500_Inst_156_Tdo : Tdr_Bypass_Tdo;
    end




    9'h9d : begin  //010011101 157     157

    BC1500_Inst_157_En   =  BC1500_Inst_157_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_157_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_157_Dec_En & ~dis_sc ? BC1500_Inst_157_Tdo : Tdr_Bypass_Tdo;
    end




    9'h9e : begin  //010011110 158     158

    BC1500_Inst_158_En   =  BC1500_Inst_158_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_158_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_158_Dec_En & ~dis_sc ? BC1500_Inst_158_Tdo : Tdr_Bypass_Tdo;
    end




    9'h9f : begin  //010011111 159     159

    BC1500_Inst_159_En   =  BC1500_Inst_159_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_159_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_159_Dec_En & ~dis_sc ? BC1500_Inst_159_Tdo : Tdr_Bypass_Tdo;
    end




    9'ha0 : begin  //010100000 160     160

    BC1500_Inst_160_En   =  BC1500_Inst_160_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_160_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_160_Dec_En & ~dis_sc ? BC1500_Inst_160_Tdo : Tdr_Bypass_Tdo;
    end




    9'ha1 : begin  //010100001 161     161

    BC1500_Inst_161_En   =  BC1500_Inst_161_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_161_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_161_Dec_En & ~dis_sc ? BC1500_Inst_161_Tdo : Tdr_Bypass_Tdo;
    end




    9'ha2 : begin  //010100010 162     162

    BC1500_Inst_162_En   =  BC1500_Inst_162_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_162_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_162_Dec_En & ~dis_sc ? BC1500_Inst_162_Tdo : Tdr_Bypass_Tdo;
    end




    9'ha3 : begin  //010100011 163     163

    BC1500_Inst_163_En   =  BC1500_Inst_163_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_163_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_163_Dec_En & ~dis_sc ? BC1500_Inst_163_Tdo : Tdr_Bypass_Tdo;
    end




    9'ha4 : begin  //010100100 164     164

    BC1500_Inst_164_En   =  BC1500_Inst_164_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_164_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_164_Dec_En & ~dis_sc ? BC1500_Inst_164_Tdo : Tdr_Bypass_Tdo;
    end




    9'ha5 : begin  //010100101 165     165

    BC1500_Inst_165_En   =  BC1500_Inst_165_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_165_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_165_Dec_En & ~dis_sc ? BC1500_Inst_165_Tdo : Tdr_Bypass_Tdo;
    end




    9'ha6 : begin  //010100110 166     166

    BC1500_Inst_166_En   =  BC1500_Inst_166_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_166_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_166_Dec_En & ~dis_sc ? BC1500_Inst_166_Tdo : Tdr_Bypass_Tdo;
    end




    9'ha7 : begin  //010100111 167     167

    BC1500_Inst_167_En   =  BC1500_Inst_167_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_167_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_167_Dec_En & ~dis_sc ? BC1500_Inst_167_Tdo : Tdr_Bypass_Tdo;
    end




    9'ha8 : begin  //010101000 168     168

    BC1500_Inst_168_En   =  BC1500_Inst_168_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_168_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_168_Dec_En & ~dis_sc ? BC1500_Inst_168_Tdo : Tdr_Bypass_Tdo;
    end




    9'ha9 : begin  //010101001 169     169

    BC1500_Inst_169_En   =  BC1500_Inst_169_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_169_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_169_Dec_En & ~dis_sc ? BC1500_Inst_169_Tdo : Tdr_Bypass_Tdo;
    end




    9'haa : begin  //010101010 170     170

    BC1500_Inst_170_En   =  BC1500_Inst_170_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_170_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_170_Dec_En & ~dis_sc ? BC1500_Inst_170_Tdo : Tdr_Bypass_Tdo;
    end




    9'hab : begin  //010101011 171     171

    BC1500_Inst_171_En   =  BC1500_Inst_171_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_171_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_171_Dec_En & ~dis_sc ? BC1500_Inst_171_Tdo : Tdr_Bypass_Tdo;
    end




    9'hac : begin  //010101100 172     172

    BC1500_Inst_172_En   =  BC1500_Inst_172_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_172_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_172_Dec_En & ~dis_sc ? BC1500_Inst_172_Tdo : Tdr_Bypass_Tdo;
    end




    9'had : begin  //010101101 173     173

    BC1500_Inst_173_En   =  BC1500_Inst_173_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_173_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_173_Dec_En & ~dis_sc ? BC1500_Inst_173_Tdo : Tdr_Bypass_Tdo;
    end




    9'hae : begin  //010101110 174     174

    BC1500_Inst_174_En   =  BC1500_Inst_174_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_174_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_174_Dec_En & ~dis_sc ? BC1500_Inst_174_Tdo : Tdr_Bypass_Tdo;
    end




    9'haf : begin  //010101111 175     175

    BC1500_Inst_175_En   =  BC1500_Inst_175_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_175_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_175_Dec_En & ~dis_sc ? BC1500_Inst_175_Tdo : Tdr_Bypass_Tdo;
    end




    9'hb0 : begin  //010110000 176     176

    BC1500_Inst_176_En   =  BC1500_Inst_176_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_176_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_176_Dec_En & ~dis_sc ? BC1500_Inst_176_Tdo : Tdr_Bypass_Tdo;
    end




    9'hb1 : begin  //010110001 177     177

    BC1500_Inst_177_En   =  BC1500_Inst_177_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_177_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_177_Dec_En & ~dis_sc ? BC1500_Inst_177_Tdo : Tdr_Bypass_Tdo;
    end




    9'hb2 : begin  //010110010 178     178

    BC1500_Inst_178_En   =  BC1500_Inst_178_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_178_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_178_Dec_En & ~dis_sc ? BC1500_Inst_178_Tdo : Tdr_Bypass_Tdo;
    end




    9'hb3 : begin  //010110011 179     179

    BC1500_Inst_179_En   =  BC1500_Inst_179_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_179_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_179_Dec_En & ~dis_sc ? BC1500_Inst_179_Tdo : Tdr_Bypass_Tdo;
    end




    9'hb4 : begin  //010110100 180     180

    BC1500_Inst_180_En   =  BC1500_Inst_180_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_180_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_180_Dec_En & ~dis_sc ? BC1500_Inst_180_Tdo : Tdr_Bypass_Tdo;
    end




    9'hb5 : begin  //010110101 181     181

    BC1500_Inst_181_En   =  BC1500_Inst_181_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_181_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_181_Dec_En & ~dis_sc ? BC1500_Inst_181_Tdo : Tdr_Bypass_Tdo;
    end




    9'hb6 : begin  //010110110 182     182

    BC1500_Inst_182_En   =  BC1500_Inst_182_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_182_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_182_Dec_En & ~dis_sc ? BC1500_Inst_182_Tdo : Tdr_Bypass_Tdo;
    end




    9'hb7 : begin  //010110111 183     183

    BC1500_Inst_183_En   =  BC1500_Inst_183_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_183_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_183_Dec_En & ~dis_sc ? BC1500_Inst_183_Tdo : Tdr_Bypass_Tdo;
    end




    9'hb8 : begin  //010111000 184     184

    BC1500_Inst_184_En   =  BC1500_Inst_184_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_184_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_184_Dec_En & ~dis_sc ? BC1500_Inst_184_Tdo : Tdr_Bypass_Tdo;
    end




    9'hb9 : begin  //010111001 185     185

    BC1500_Inst_185_En   =  BC1500_Inst_185_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_185_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_185_Dec_En & ~dis_sc ? BC1500_Inst_185_Tdo : Tdr_Bypass_Tdo;
    end




    9'hba : begin  //010111010 186     186

    BC1500_Inst_186_En   =  BC1500_Inst_186_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_186_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_186_Dec_En & ~dis_sc ? BC1500_Inst_186_Tdo : Tdr_Bypass_Tdo;
    end




    9'hbb : begin  //010111011 187     187

    BC1500_Inst_187_En   =  BC1500_Inst_187_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_187_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_187_Dec_En & ~dis_sc ? BC1500_Inst_187_Tdo : Tdr_Bypass_Tdo;
    end




    9'hbc : begin  //010111100 188     188

    BC1500_Inst_188_En   =  BC1500_Inst_188_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_188_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_188_Dec_En & ~dis_sc ? BC1500_Inst_188_Tdo : Tdr_Bypass_Tdo;
    end




    9'hbd : begin  //010111101 189     189

    BC1500_Inst_189_En   =  BC1500_Inst_189_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_189_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_189_Dec_En & ~dis_sc ? BC1500_Inst_189_Tdo : Tdr_Bypass_Tdo;
    end




    9'hbe : begin  //010111110 190     190

    BC1500_Inst_190_En   =  BC1500_Inst_190_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_190_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_190_Dec_En & ~dis_sc ? BC1500_Inst_190_Tdo : Tdr_Bypass_Tdo;
    end




    9'hbf : begin  //010111111 191     191

    BC1500_Inst_191_En   =  BC1500_Inst_191_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_191_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_191_Dec_En & ~dis_sc ? BC1500_Inst_191_Tdo : Tdr_Bypass_Tdo;
    end




    9'hc0 : begin  //011000000 192     192

    BC1500_Inst_192_En   =  BC1500_Inst_192_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_192_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_192_Dec_En & ~dis_sc ? BC1500_Inst_192_Tdo : Tdr_Bypass_Tdo;
    end




    9'hc1 : begin  //011000001 193     193

    BC1500_Inst_193_En   =  BC1500_Inst_193_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_193_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_193_Dec_En & ~dis_sc ? BC1500_Inst_193_Tdo : Tdr_Bypass_Tdo;
    end




    9'hc2 : begin  //011000010 194     194

    BC1500_Inst_194_En   =  BC1500_Inst_194_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_194_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_194_Dec_En & ~dis_sc ? BC1500_Inst_194_Tdo : Tdr_Bypass_Tdo;
    end




    9'hc3 : begin  //011000011 195     195

    BC1500_Inst_195_En   =  BC1500_Inst_195_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_195_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_195_Dec_En & ~dis_sc ? BC1500_Inst_195_Tdo : Tdr_Bypass_Tdo;
    end




    9'hc4 : begin  //011000100 196     196

    BC1500_Inst_196_En   =  BC1500_Inst_196_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_196_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_196_Dec_En & ~dis_sc ? BC1500_Inst_196_Tdo : Tdr_Bypass_Tdo;
    end




    9'hc5 : begin  //011000101 197     197

    BC1500_Inst_197_En   =  BC1500_Inst_197_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_197_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_197_Dec_En & ~dis_sc ? BC1500_Inst_197_Tdo : Tdr_Bypass_Tdo;
    end




    9'hc6 : begin  //011000110 198     198

    BC1500_Inst_198_En   =  BC1500_Inst_198_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_198_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_198_Dec_En & ~dis_sc ? BC1500_Inst_198_Tdo : Tdr_Bypass_Tdo;
    end




    9'hc7 : begin  //011000111 199     199

    BC1500_Inst_199_En   =  BC1500_Inst_199_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_199_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_199_Dec_En & ~dis_sc ? BC1500_Inst_199_Tdo : Tdr_Bypass_Tdo;
    end




    9'hc8 : begin  //011001000 200     200

    BC1500_Inst_200_En   =  BC1500_Inst_200_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_200_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_200_Dec_En & ~dis_sc ? BC1500_Inst_200_Tdo : Tdr_Bypass_Tdo;
    end




    9'hc9 : begin  //011001001 201     201

    BC1500_Inst_201_En   =  BC1500_Inst_201_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_201_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_201_Dec_En & ~dis_sc ? BC1500_Inst_201_Tdo : Tdr_Bypass_Tdo;
    end




    9'hca : begin  //011001010 202     202

    BC1500_Inst_202_En   =  BC1500_Inst_202_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_202_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_202_Dec_En & ~dis_sc ? BC1500_Inst_202_Tdo : Tdr_Bypass_Tdo;
    end




    9'hcb : begin  //011001011 203     203

    BC1500_Inst_203_En   =  BC1500_Inst_203_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_203_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_203_Dec_En & ~dis_sc ? BC1500_Inst_203_Tdo : Tdr_Bypass_Tdo;
    end




    9'hcc : begin  //011001100 204     204

    BC1500_Inst_204_En   =  BC1500_Inst_204_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_204_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_204_Dec_En & ~dis_sc ? BC1500_Inst_204_Tdo : Tdr_Bypass_Tdo;
    end




    9'hcd : begin  //011001101 205     205

    BC1500_Inst_205_En   =  BC1500_Inst_205_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_205_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_205_Dec_En & ~dis_sc ? BC1500_Inst_205_Tdo : Tdr_Bypass_Tdo;
    end




    9'hce : begin  //011001110 206     206

    BC1500_Inst_206_En   =  BC1500_Inst_206_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_206_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_206_Dec_En & ~dis_sc ? BC1500_Inst_206_Tdo : Tdr_Bypass_Tdo;
    end




    9'hcf : begin  //011001111 207     207

    BC1500_Inst_207_En   =  BC1500_Inst_207_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_207_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_207_Dec_En & ~dis_sc ? BC1500_Inst_207_Tdo : Tdr_Bypass_Tdo;
    end




    9'hd0 : begin  //011010000 208     208

    BC1500_Inst_208_En   =  BC1500_Inst_208_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_208_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_208_Dec_En & ~dis_sc ? BC1500_Inst_208_Tdo : Tdr_Bypass_Tdo;
    end




    9'hd1 : begin  //011010001 209     209

    BC1500_Inst_209_En   =  BC1500_Inst_209_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_209_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_209_Dec_En & ~dis_sc ? BC1500_Inst_209_Tdo : Tdr_Bypass_Tdo;
    end




    9'hd2 : begin  //011010010 210     210

    BC1500_Inst_210_En   =  BC1500_Inst_210_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_210_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_210_Dec_En & ~dis_sc ? BC1500_Inst_210_Tdo : Tdr_Bypass_Tdo;
    end




    9'hd3 : begin  //011010011 211     211

    BC1500_Inst_211_En   =  BC1500_Inst_211_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_211_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_211_Dec_En & ~dis_sc ? BC1500_Inst_211_Tdo : Tdr_Bypass_Tdo;
    end




    9'hd4 : begin  //011010100 212     212

    BC1500_Inst_212_En   =  BC1500_Inst_212_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_212_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_212_Dec_En & ~dis_sc ? BC1500_Inst_212_Tdo : Tdr_Bypass_Tdo;
    end




    9'hd5 : begin  //011010101 213     213

    BC1500_Inst_213_En   =  BC1500_Inst_213_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_213_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_213_Dec_En & ~dis_sc ? BC1500_Inst_213_Tdo : Tdr_Bypass_Tdo;
    end




    9'hd6 : begin  //011010110 214     214

    BC1500_Inst_214_En   =  BC1500_Inst_214_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_214_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_214_Dec_En & ~dis_sc ? BC1500_Inst_214_Tdo : Tdr_Bypass_Tdo;
    end




    9'hd7 : begin  //011010111 215     215

    BC1500_Inst_215_En   =  BC1500_Inst_215_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_215_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_215_Dec_En & ~dis_sc ? BC1500_Inst_215_Tdo : Tdr_Bypass_Tdo;
    end




    9'hd8 : begin  //011011000 216     216

    BC1500_Inst_216_En   =  BC1500_Inst_216_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_216_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_216_Dec_En & ~dis_sc ? BC1500_Inst_216_Tdo : Tdr_Bypass_Tdo;
    end




    9'hd9 : begin  //011011001 217     217

    BC1500_Inst_217_En   =  BC1500_Inst_217_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_217_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_217_Dec_En & ~dis_sc ? BC1500_Inst_217_Tdo : Tdr_Bypass_Tdo;
    end




    9'hda : begin  //011011010 218     218

    BC1500_Inst_218_En   =  BC1500_Inst_218_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_218_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_218_Dec_En & ~dis_sc ? BC1500_Inst_218_Tdo : Tdr_Bypass_Tdo;
    end




    9'hdb : begin  //011011011 219     219

    BC1500_Inst_219_En   =  BC1500_Inst_219_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_219_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_219_Dec_En & ~dis_sc ? BC1500_Inst_219_Tdo : Tdr_Bypass_Tdo;
    end




    9'hdc : begin  //011011100 220     220

    BC1500_Inst_220_En   =  BC1500_Inst_220_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_220_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_220_Dec_En & ~dis_sc ? BC1500_Inst_220_Tdo : Tdr_Bypass_Tdo;
    end




    9'hdd : begin  //011011101 221     221

    BC1500_Inst_221_En   =  BC1500_Inst_221_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_221_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_221_Dec_En & ~dis_sc ? BC1500_Inst_221_Tdo : Tdr_Bypass_Tdo;
    end




    9'hde : begin  //011011110 222     222

    BC1500_Inst_222_En   =  BC1500_Inst_222_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_222_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_222_Dec_En & ~dis_sc ? BC1500_Inst_222_Tdo : Tdr_Bypass_Tdo;
    end




    9'hdf : begin  //011011111 223     223

    BC1500_Inst_223_En   =  BC1500_Inst_223_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_223_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_223_Dec_En & ~dis_sc ? BC1500_Inst_223_Tdo : Tdr_Bypass_Tdo;
    end




    9'he0 : begin  //011100000 224     224

    BC1500_Inst_224_En   =  BC1500_Inst_224_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_224_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_224_Dec_En & ~dis_sc ? BC1500_Inst_224_Tdo : Tdr_Bypass_Tdo;
    end




    9'he1 : begin  //011100001 225     225

    BC1500_Inst_225_En   =  BC1500_Inst_225_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_225_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_225_Dec_En & ~dis_sc ? BC1500_Inst_225_Tdo : Tdr_Bypass_Tdo;
    end




    9'he2 : begin  //011100010 226     226

    BC1500_Inst_226_En   =  BC1500_Inst_226_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_226_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_226_Dec_En & ~dis_sc ? BC1500_Inst_226_Tdo : Tdr_Bypass_Tdo;
    end




    9'he3 : begin  //011100011 227     227

    BC1500_Inst_227_En   =  BC1500_Inst_227_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_227_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_227_Dec_En & ~dis_sc ? BC1500_Inst_227_Tdo : Tdr_Bypass_Tdo;
    end




    9'he4 : begin  //011100100 228     228

    BC1500_Inst_228_En   =  BC1500_Inst_228_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_228_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_228_Dec_En & ~dis_sc ? BC1500_Inst_228_Tdo : Tdr_Bypass_Tdo;
    end




    9'he5 : begin  //011100101 229     229

    BC1500_Inst_229_En   =  BC1500_Inst_229_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_229_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_229_Dec_En & ~dis_sc ? BC1500_Inst_229_Tdo : Tdr_Bypass_Tdo;
    end




    9'he6 : begin  //011100110 230     230

    BC1500_Inst_230_En   =  BC1500_Inst_230_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_230_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_230_Dec_En & ~dis_sc ? BC1500_Inst_230_Tdo : Tdr_Bypass_Tdo;
    end




    9'he7 : begin  //011100111 231     231

    BC1500_Inst_231_En   =  BC1500_Inst_231_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_231_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_231_Dec_En & ~dis_sc ? BC1500_Inst_231_Tdo : Tdr_Bypass_Tdo;
    end




    9'he8 : begin  //011101000 232     232

    BC1500_Inst_232_En   =  BC1500_Inst_232_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_232_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_232_Dec_En & ~dis_sc ? BC1500_Inst_232_Tdo : Tdr_Bypass_Tdo;
    end




    9'he9 : begin  //011101001 233     233

    BC1500_Inst_233_En   =  BC1500_Inst_233_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_233_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_233_Dec_En & ~dis_sc ? BC1500_Inst_233_Tdo : Tdr_Bypass_Tdo;
    end




    9'hea : begin  //011101010 234     234

    BC1500_Inst_234_En   =  BC1500_Inst_234_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_234_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_234_Dec_En & ~dis_sc ? BC1500_Inst_234_Tdo : Tdr_Bypass_Tdo;
    end




    9'heb : begin  //011101011 235     235

    BC1500_Inst_235_En   =  BC1500_Inst_235_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_235_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_235_Dec_En & ~dis_sc ? BC1500_Inst_235_Tdo : Tdr_Bypass_Tdo;
    end




    9'hec : begin  //011101100 236     236

    BC1500_Inst_236_En   =  BC1500_Inst_236_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_236_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_236_Dec_En & ~dis_sc ? BC1500_Inst_236_Tdo : Tdr_Bypass_Tdo;
    end




    9'hed : begin  //011101101 237     237

    BC1500_Inst_237_En   =  BC1500_Inst_237_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_237_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_237_Dec_En & ~dis_sc ? BC1500_Inst_237_Tdo : Tdr_Bypass_Tdo;
    end




    9'hee : begin  //011101110 238     238

    BC1500_Inst_238_En   =  BC1500_Inst_238_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_238_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_238_Dec_En & ~dis_sc ? BC1500_Inst_238_Tdo : Tdr_Bypass_Tdo;
    end




    9'hef : begin  //011101111 239     239

    BC1500_Inst_239_En   =  BC1500_Inst_239_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_239_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_239_Dec_En & ~dis_sc ? BC1500_Inst_239_Tdo : Tdr_Bypass_Tdo;
    end




    9'hf0 : begin  //011110000 240     240

    BC1500_Inst_240_En   =  BC1500_Inst_240_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_240_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_240_Dec_En & ~dis_sc ? BC1500_Inst_240_Tdo : Tdr_Bypass_Tdo;
    end




    9'hf1 : begin  //011110001 241     241

    BC1500_Inst_241_En   =  BC1500_Inst_241_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_241_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_241_Dec_En & ~dis_sc ? BC1500_Inst_241_Tdo : Tdr_Bypass_Tdo;
    end




    9'hf2 : begin  //011110010 242     242

    BC1500_Inst_242_En   =  BC1500_Inst_242_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_242_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_242_Dec_En & ~dis_sc ? BC1500_Inst_242_Tdo : Tdr_Bypass_Tdo;
    end




    9'hf3 : begin  //011110011 243     243

    BC1500_Inst_243_En   =  BC1500_Inst_243_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_243_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_243_Dec_En & ~dis_sc ? BC1500_Inst_243_Tdo : Tdr_Bypass_Tdo;
    end




    9'hf4 : begin  //011110100 244     244

    BC1500_Inst_244_En   =  BC1500_Inst_244_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_244_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_244_Dec_En & ~dis_sc ? BC1500_Inst_244_Tdo : Tdr_Bypass_Tdo;
    end




    9'hf5 : begin  //011110101 245     245

    BC1500_Inst_245_En   =  BC1500_Inst_245_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_245_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_245_Dec_En & ~dis_sc ? BC1500_Inst_245_Tdo : Tdr_Bypass_Tdo;
    end




    9'hf6 : begin  //011110110 246     246

    BC1500_Inst_246_En   =  BC1500_Inst_246_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_246_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_246_Dec_En & ~dis_sc ? BC1500_Inst_246_Tdo : Tdr_Bypass_Tdo;
    end




    9'hf7 : begin  //011110111 247     247

    BC1500_Inst_247_En   =  BC1500_Inst_247_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_247_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_247_Dec_En & ~dis_sc ? BC1500_Inst_247_Tdo : Tdr_Bypass_Tdo;
    end




    9'hf8 : begin  //011111000 248     248

    BC1500_Inst_248_En   =  BC1500_Inst_248_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_248_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_248_Dec_En & ~dis_sc ? BC1500_Inst_248_Tdo : Tdr_Bypass_Tdo;
    end




    9'hf9 : begin  //011111001 249     249

    BC1500_Inst_249_En   =  BC1500_Inst_249_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_249_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_249_Dec_En & ~dis_sc ? BC1500_Inst_249_Tdo : Tdr_Bypass_Tdo;
    end




    9'hfa : begin  //011111010 250     250

    BC1500_Inst_250_En   =  BC1500_Inst_250_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_250_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_250_Dec_En & ~dis_sc ? BC1500_Inst_250_Tdo : Tdr_Bypass_Tdo;
    end




    9'hfb : begin  //011111011 251     251

    BC1500_Inst_251_En   =  BC1500_Inst_251_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_251_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_251_Dec_En & ~dis_sc ? BC1500_Inst_251_Tdo : Tdr_Bypass_Tdo;
    end




    9'hfc : begin  //011111100 252     252

    BC1500_Inst_252_En   =  BC1500_Inst_252_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_252_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_252_Dec_En & ~dis_sc ? BC1500_Inst_252_Tdo : Tdr_Bypass_Tdo;
    end




    9'hfd : begin  //011111101 253     253

    BC1500_Inst_253_En   =  BC1500_Inst_253_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_253_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_253_Dec_En & ~dis_sc ? BC1500_Inst_253_Tdo : Tdr_Bypass_Tdo;
    end




    9'hfe : begin  //011111110 254     254

    BC1500_Inst_254_En   =  BC1500_Inst_254_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_254_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_254_Dec_En & ~dis_sc ? BC1500_Inst_254_Tdo : Tdr_Bypass_Tdo;
    end




    9'hff : begin  //011111111 255     255

    BC1500_Inst_255_En   =  BC1500_Inst_255_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_255_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_255_Dec_En & ~dis_sc ? BC1500_Inst_255_Tdo : Tdr_Bypass_Tdo;
    end




    9'h100 : begin  //100000000 256     256

    BC1500_Inst_256_En   =  BC1500_Inst_256_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_256_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_256_Dec_En & ~dis_sc ? BC1500_Inst_256_Tdo : Tdr_Bypass_Tdo;
    end




    9'h101 : begin  //100000001 257     257

    BC1500_Inst_257_En   =  BC1500_Inst_257_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_257_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_257_Dec_En & ~dis_sc ? BC1500_Inst_257_Tdo : Tdr_Bypass_Tdo;
    end




    9'h102 : begin  //100000010 258     258

    BC1500_Inst_258_En   =  BC1500_Inst_258_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_258_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_258_Dec_En & ~dis_sc ? BC1500_Inst_258_Tdo : Tdr_Bypass_Tdo;
    end




    9'h103 : begin  //100000011 259     259

    BC1500_Inst_259_En   =  BC1500_Inst_259_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_259_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_259_Dec_En & ~dis_sc ? BC1500_Inst_259_Tdo : Tdr_Bypass_Tdo;
    end




    9'h104 : begin  //100000100 260     260

    BC1500_Inst_260_En   =  BC1500_Inst_260_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_260_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_260_Dec_En & ~dis_sc ? BC1500_Inst_260_Tdo : Tdr_Bypass_Tdo;
    end




    9'h105 : begin  //100000101 261     261

    BC1500_Inst_261_En   =  BC1500_Inst_261_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_261_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_261_Dec_En & ~dis_sc ? BC1500_Inst_261_Tdo : Tdr_Bypass_Tdo;
    end




    9'h106 : begin  //100000110 262     262

    BC1500_Inst_262_En   =  BC1500_Inst_262_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_262_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_262_Dec_En & ~dis_sc ? BC1500_Inst_262_Tdo : Tdr_Bypass_Tdo;
    end




    9'h107 : begin  //100000111 263     263

    BC1500_Inst_263_En   =  BC1500_Inst_263_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_263_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_263_Dec_En & ~dis_sc ? BC1500_Inst_263_Tdo : Tdr_Bypass_Tdo;
    end




    9'h108 : begin  //100001000 264     264

    BC1500_Inst_264_En   =  BC1500_Inst_264_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_264_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_264_Dec_En & ~dis_sc ? BC1500_Inst_264_Tdo : Tdr_Bypass_Tdo;
    end




    9'h109 : begin  //100001001 265     265

    BC1500_Inst_265_En   =  BC1500_Inst_265_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_265_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_265_Dec_En & ~dis_sc ? BC1500_Inst_265_Tdo : Tdr_Bypass_Tdo;
    end




    9'h10a : begin  //100001010 266     266

    BC1500_Inst_266_En   =  BC1500_Inst_266_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_266_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_266_Dec_En & ~dis_sc ? BC1500_Inst_266_Tdo : Tdr_Bypass_Tdo;
    end




    9'h10b : begin  //100001011 267     267

    BC1500_Inst_267_En   =  BC1500_Inst_267_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_267_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_267_Dec_En & ~dis_sc ? BC1500_Inst_267_Tdo : Tdr_Bypass_Tdo;
    end




    9'h10c : begin  //100001100 268     268

    BC1500_Inst_268_En   =  BC1500_Inst_268_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_268_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_268_Dec_En & ~dis_sc ? BC1500_Inst_268_Tdo : Tdr_Bypass_Tdo;
    end




    9'h10d : begin  //100001101 269     269

    BC1500_Inst_269_En   =  BC1500_Inst_269_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_269_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_269_Dec_En & ~dis_sc ? BC1500_Inst_269_Tdo : Tdr_Bypass_Tdo;
    end




    9'h10e : begin  //100001110 270     270

    BC1500_Inst_270_En   =  BC1500_Inst_270_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_270_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_270_Dec_En & ~dis_sc ? BC1500_Inst_270_Tdo : Tdr_Bypass_Tdo;
    end




    9'h10f : begin  //100001111 271     271

    BC1500_Inst_271_En   =  BC1500_Inst_271_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_271_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_271_Dec_En & ~dis_sc ? BC1500_Inst_271_Tdo : Tdr_Bypass_Tdo;
    end




    9'h110 : begin  //100010000 272     272

    BC1500_Inst_272_En   =  BC1500_Inst_272_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_272_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_272_Dec_En & ~dis_sc ? BC1500_Inst_272_Tdo : Tdr_Bypass_Tdo;
    end




    9'h111 : begin  //100010001 273     273

    BC1500_Inst_273_En   =  BC1500_Inst_273_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_273_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_273_Dec_En & ~dis_sc ? BC1500_Inst_273_Tdo : Tdr_Bypass_Tdo;
    end




    9'h112 : begin  //100010010 274     274

    BC1500_Inst_274_En   =  BC1500_Inst_274_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_274_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_274_Dec_En & ~dis_sc ? BC1500_Inst_274_Tdo : Tdr_Bypass_Tdo;
    end




    9'h113 : begin  //100010011 275     275

    BC1500_Inst_275_En   =  BC1500_Inst_275_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_275_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_275_Dec_En & ~dis_sc ? BC1500_Inst_275_Tdo : Tdr_Bypass_Tdo;
    end




    9'h114 : begin  //100010100 276     276

    BC1500_Inst_276_En   =  BC1500_Inst_276_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_276_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_276_Dec_En & ~dis_sc ? BC1500_Inst_276_Tdo : Tdr_Bypass_Tdo;
    end




    9'h115 : begin  //100010101 277     277

    BC1500_Inst_277_En   =  BC1500_Inst_277_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_277_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_277_Dec_En & ~dis_sc ? BC1500_Inst_277_Tdo : Tdr_Bypass_Tdo;
    end




    9'h116 : begin  //100010110 278     278

    BC1500_Inst_278_En   =  BC1500_Inst_278_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_278_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_278_Dec_En & ~dis_sc ? BC1500_Inst_278_Tdo : Tdr_Bypass_Tdo;
    end




    9'h117 : begin  //100010111 279     279

    BC1500_Inst_279_En   =  BC1500_Inst_279_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_279_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_279_Dec_En & ~dis_sc ? BC1500_Inst_279_Tdo : Tdr_Bypass_Tdo;
    end




    9'h118 : begin  //100011000 280     280

    BC1500_Inst_280_En   =  BC1500_Inst_280_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_280_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_280_Dec_En & ~dis_sc ? BC1500_Inst_280_Tdo : Tdr_Bypass_Tdo;
    end




    9'h119 : begin  //100011001 281     281

    BC1500_Inst_281_En   =  BC1500_Inst_281_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_281_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_281_Dec_En & ~dis_sc ? BC1500_Inst_281_Tdo : Tdr_Bypass_Tdo;
    end




    9'h11a : begin  //100011010 282     282

    BC1500_Inst_282_En   =  BC1500_Inst_282_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_282_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_282_Dec_En & ~dis_sc ? BC1500_Inst_282_Tdo : Tdr_Bypass_Tdo;
    end




    9'h11b : begin  //100011011 283     283

    BC1500_Inst_283_En   =  BC1500_Inst_283_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_283_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_283_Dec_En & ~dis_sc ? BC1500_Inst_283_Tdo : Tdr_Bypass_Tdo;
    end




    9'h11c : begin  //100011100 284     284

    BC1500_Inst_284_En   =  BC1500_Inst_284_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_284_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_284_Dec_En & ~dis_sc ? BC1500_Inst_284_Tdo : Tdr_Bypass_Tdo;
    end




    9'h11d : begin  //100011101 285     285

    BC1500_Inst_285_En   =  BC1500_Inst_285_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_285_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_285_Dec_En & ~dis_sc ? BC1500_Inst_285_Tdo : Tdr_Bypass_Tdo;
    end




    9'h11e : begin  //100011110 286     286

    BC1500_Inst_286_En   =  BC1500_Inst_286_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_286_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_286_Dec_En & ~dis_sc ? BC1500_Inst_286_Tdo : Tdr_Bypass_Tdo;
    end




    9'h11f : begin  //100011111 287     287

    BC1500_Inst_287_En   =  BC1500_Inst_287_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_287_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_287_Dec_En & ~dis_sc ? BC1500_Inst_287_Tdo : Tdr_Bypass_Tdo;
    end




    9'h120 : begin  //100100000 288     288

    BC1500_Inst_288_En   =  BC1500_Inst_288_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_288_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_288_Dec_En & ~dis_sc ? BC1500_Inst_288_Tdo : Tdr_Bypass_Tdo;
    end




    9'h121 : begin  //100100001 289     289

    BC1500_Inst_289_En   =  BC1500_Inst_289_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_289_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_289_Dec_En & ~dis_sc ? BC1500_Inst_289_Tdo : Tdr_Bypass_Tdo;
    end




    9'h122 : begin  //100100010 290     290

    BC1500_Inst_290_En   =  BC1500_Inst_290_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_290_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_290_Dec_En & ~dis_sc ? BC1500_Inst_290_Tdo : Tdr_Bypass_Tdo;
    end




    9'h123 : begin  //100100011 291     291

    BC1500_Inst_291_En   =  BC1500_Inst_291_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_291_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_291_Dec_En & ~dis_sc ? BC1500_Inst_291_Tdo : Tdr_Bypass_Tdo;
    end




    9'h124 : begin  //100100100 292     292

    BC1500_Inst_292_En   =  BC1500_Inst_292_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_292_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_292_Dec_En & ~dis_sc ? BC1500_Inst_292_Tdo : Tdr_Bypass_Tdo;
    end




    9'h125 : begin  //100100101 293     293

    BC1500_Inst_293_En   =  BC1500_Inst_293_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_293_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_293_Dec_En & ~dis_sc ? BC1500_Inst_293_Tdo : Tdr_Bypass_Tdo;
    end




    9'h126 : begin  //100100110 294     294

    BC1500_Inst_294_En   =  BC1500_Inst_294_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_294_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_294_Dec_En & ~dis_sc ? BC1500_Inst_294_Tdo : Tdr_Bypass_Tdo;
    end




    9'h127 : begin  //100100111 295     295

    BC1500_Inst_295_En   =  BC1500_Inst_295_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_295_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_295_Dec_En & ~dis_sc ? BC1500_Inst_295_Tdo : Tdr_Bypass_Tdo;
    end




    9'h128 : begin  //100101000 296     296

    BC1500_Inst_296_En   =  BC1500_Inst_296_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_296_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_296_Dec_En & ~dis_sc ? BC1500_Inst_296_Tdo : Tdr_Bypass_Tdo;
    end




    9'h129 : begin  //100101001 297     297

    BC1500_Inst_297_En   =  BC1500_Inst_297_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_297_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_297_Dec_En & ~dis_sc ? BC1500_Inst_297_Tdo : Tdr_Bypass_Tdo;
    end




    9'h12a : begin  //100101010 298     298

    BC1500_Inst_298_En   =  BC1500_Inst_298_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_298_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_298_Dec_En & ~dis_sc ? BC1500_Inst_298_Tdo : Tdr_Bypass_Tdo;
    end




    9'h12b : begin  //100101011 299     299

    BC1500_Inst_299_En   =  BC1500_Inst_299_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_299_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_299_Dec_En & ~dis_sc ? BC1500_Inst_299_Tdo : Tdr_Bypass_Tdo;
    end




    9'h12c : begin  //100101100 300     300

    BC1500_Inst_300_En   =  BC1500_Inst_300_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_300_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_300_Dec_En & ~dis_sc ? BC1500_Inst_300_Tdo : Tdr_Bypass_Tdo;
    end




    9'h12d : begin  //100101101 301     301

    BC1500_Inst_301_En   =  BC1500_Inst_301_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_301_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_301_Dec_En & ~dis_sc ? BC1500_Inst_301_Tdo : Tdr_Bypass_Tdo;
    end




    9'h12e : begin  //100101110 302     302

    BC1500_Inst_302_En   =  BC1500_Inst_302_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_302_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_302_Dec_En & ~dis_sc ? BC1500_Inst_302_Tdo : Tdr_Bypass_Tdo;
    end




    9'h12f : begin  //100101111 303     303

    BC1500_Inst_303_En   =  BC1500_Inst_303_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_303_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_303_Dec_En & ~dis_sc ? BC1500_Inst_303_Tdo : Tdr_Bypass_Tdo;
    end




    9'h130 : begin  //100110000 304     304

    BC1500_Inst_304_En   =  BC1500_Inst_304_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_304_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_304_Dec_En & ~dis_sc ? BC1500_Inst_304_Tdo : Tdr_Bypass_Tdo;
    end




    9'h131 : begin  //100110001 305     305

    BC1500_Inst_305_En   =  BC1500_Inst_305_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_305_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_305_Dec_En & ~dis_sc ? BC1500_Inst_305_Tdo : Tdr_Bypass_Tdo;
    end




    9'h132 : begin  //100110010 306     306

    BC1500_Inst_306_En   =  BC1500_Inst_306_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_306_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_306_Dec_En & ~dis_sc ? BC1500_Inst_306_Tdo : Tdr_Bypass_Tdo;
    end




    9'h133 : begin  //100110011 307     307

    BC1500_Inst_307_En   =  BC1500_Inst_307_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_307_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_307_Dec_En & ~dis_sc ? BC1500_Inst_307_Tdo : Tdr_Bypass_Tdo;
    end




    9'h134 : begin  //100110100 308     308

    BC1500_Inst_308_En   =  BC1500_Inst_308_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_308_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_308_Dec_En & ~dis_sc ? BC1500_Inst_308_Tdo : Tdr_Bypass_Tdo;
    end




    9'h135 : begin  //100110101 309     309

    BC1500_Inst_309_En   =  BC1500_Inst_309_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_309_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_309_Dec_En & ~dis_sc ? BC1500_Inst_309_Tdo : Tdr_Bypass_Tdo;
    end




    9'h136 : begin  //100110110 310     310

    BC1500_Inst_310_En   =  BC1500_Inst_310_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_310_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_310_Dec_En & ~dis_sc ? BC1500_Inst_310_Tdo : Tdr_Bypass_Tdo;
    end




    9'h137 : begin  //100110111 311     311

    BC1500_Inst_311_En   =  BC1500_Inst_311_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_311_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_311_Dec_En & ~dis_sc ? BC1500_Inst_311_Tdo : Tdr_Bypass_Tdo;
    end




    9'h138 : begin  //100111000 312     312

    BC1500_Inst_312_En   =  BC1500_Inst_312_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_312_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_312_Dec_En & ~dis_sc ? BC1500_Inst_312_Tdo : Tdr_Bypass_Tdo;
    end




    9'h139 : begin  //100111001 313     313

    BC1500_Inst_313_En   =  BC1500_Inst_313_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_313_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_313_Dec_En & ~dis_sc ? BC1500_Inst_313_Tdo : Tdr_Bypass_Tdo;
    end




    9'h13a : begin  //100111010 314     314

    BC1500_Inst_314_En   =  BC1500_Inst_314_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_314_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_314_Dec_En & ~dis_sc ? BC1500_Inst_314_Tdo : Tdr_Bypass_Tdo;
    end




    9'h13b : begin  //100111011 315     315

    BC1500_Inst_315_En   =  BC1500_Inst_315_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_315_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_315_Dec_En & ~dis_sc ? BC1500_Inst_315_Tdo : Tdr_Bypass_Tdo;
    end




    9'h13c : begin  //100111100 316     316

    BC1500_Inst_316_En   =  BC1500_Inst_316_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_316_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_316_Dec_En & ~dis_sc ? BC1500_Inst_316_Tdo : Tdr_Bypass_Tdo;
    end




    9'h13d : begin  //100111101 317     317

    BC1500_Inst_317_En   =  BC1500_Inst_317_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_317_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_317_Dec_En & ~dis_sc ? BC1500_Inst_317_Tdo : Tdr_Bypass_Tdo;
    end




    9'h13e : begin  //100111110 318     318

    BC1500_Inst_318_En   =  BC1500_Inst_318_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_318_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_318_Dec_En & ~dis_sc ? BC1500_Inst_318_Tdo : Tdr_Bypass_Tdo;
    end




    9'h13f : begin  //100111111 319     319

    BC1500_Inst_319_En   =  BC1500_Inst_319_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_319_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_319_Dec_En & ~dis_sc ? BC1500_Inst_319_Tdo : Tdr_Bypass_Tdo;
    end




    9'h140 : begin  //101000000 320     320

    BC1500_Inst_320_En   =  BC1500_Inst_320_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_320_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_320_Dec_En & ~dis_sc ? BC1500_Inst_320_Tdo : Tdr_Bypass_Tdo;
    end




    9'h141 : begin  //101000001 321     321

    BC1500_Inst_321_En   =  BC1500_Inst_321_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_321_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_321_Dec_En & ~dis_sc ? BC1500_Inst_321_Tdo : Tdr_Bypass_Tdo;
    end




    9'h142 : begin  //101000010 322     322

    BC1500_Inst_322_En   =  BC1500_Inst_322_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_322_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_322_Dec_En & ~dis_sc ? BC1500_Inst_322_Tdo : Tdr_Bypass_Tdo;
    end




    9'h143 : begin  //101000011 323     323

    BC1500_Inst_323_En   =  BC1500_Inst_323_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_323_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_323_Dec_En & ~dis_sc ? BC1500_Inst_323_Tdo : Tdr_Bypass_Tdo;
    end




    9'h144 : begin  //101000100 324     324

    BC1500_Inst_324_En   =  BC1500_Inst_324_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_324_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_324_Dec_En & ~dis_sc ? BC1500_Inst_324_Tdo : Tdr_Bypass_Tdo;
    end




    9'h145 : begin  //101000101 325     325

    BC1500_Inst_325_En   =  BC1500_Inst_325_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_325_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_325_Dec_En & ~dis_sc ? BC1500_Inst_325_Tdo : Tdr_Bypass_Tdo;
    end




    9'h146 : begin  //101000110 326     326

    BC1500_Inst_326_En   =  BC1500_Inst_326_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_326_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_326_Dec_En & ~dis_sc ? BC1500_Inst_326_Tdo : Tdr_Bypass_Tdo;
    end




    9'h147 : begin  //101000111 327     327

    BC1500_Inst_327_En   =  BC1500_Inst_327_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_327_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_327_Dec_En & ~dis_sc ? BC1500_Inst_327_Tdo : Tdr_Bypass_Tdo;
    end




    9'h148 : begin  //101001000 328     328

    BC1500_Inst_328_En   =  BC1500_Inst_328_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_328_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_328_Dec_En & ~dis_sc ? BC1500_Inst_328_Tdo : Tdr_Bypass_Tdo;
    end




    9'h149 : begin  //101001001 329     329

    BC1500_Inst_329_En   =  BC1500_Inst_329_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_329_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_329_Dec_En & ~dis_sc ? BC1500_Inst_329_Tdo : Tdr_Bypass_Tdo;
    end




    9'h14a : begin  //101001010 330     330

    BC1500_Inst_330_En   =  BC1500_Inst_330_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_330_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_330_Dec_En & ~dis_sc ? BC1500_Inst_330_Tdo : Tdr_Bypass_Tdo;
    end




    9'h14b : begin  //101001011 331     331

    BC1500_Inst_331_En   =  BC1500_Inst_331_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_331_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_331_Dec_En & ~dis_sc ? BC1500_Inst_331_Tdo : Tdr_Bypass_Tdo;
    end




    9'h14c : begin  //101001100 332     332

    BC1500_Inst_332_En   =  BC1500_Inst_332_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_332_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_332_Dec_En & ~dis_sc ? BC1500_Inst_332_Tdo : Tdr_Bypass_Tdo;
    end




    9'h14d : begin  //101001101 333     333

    BC1500_Inst_333_En   =  BC1500_Inst_333_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_333_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_333_Dec_En & ~dis_sc ? BC1500_Inst_333_Tdo : Tdr_Bypass_Tdo;
    end




    9'h14e : begin  //101001110 334     334

    BC1500_Inst_334_En   =  BC1500_Inst_334_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_334_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_334_Dec_En & ~dis_sc ? BC1500_Inst_334_Tdo : Tdr_Bypass_Tdo;
    end




    9'h14f : begin  //101001111 335     335

    BC1500_Inst_335_En   =  BC1500_Inst_335_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_335_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_335_Dec_En & ~dis_sc ? BC1500_Inst_335_Tdo : Tdr_Bypass_Tdo;
    end




    9'h150 : begin  //101010000 336     336

    BC1500_Inst_336_En   =  BC1500_Inst_336_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_336_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_336_Dec_En & ~dis_sc ? BC1500_Inst_336_Tdo : Tdr_Bypass_Tdo;
    end




    9'h151 : begin  //101010001 337     337

    BC1500_Inst_337_En   =  BC1500_Inst_337_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_337_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_337_Dec_En & ~dis_sc ? BC1500_Inst_337_Tdo : Tdr_Bypass_Tdo;
    end




    9'h152 : begin  //101010010 338     338

    BC1500_Inst_338_En   =  BC1500_Inst_338_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_338_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_338_Dec_En & ~dis_sc ? BC1500_Inst_338_Tdo : Tdr_Bypass_Tdo;
    end




    9'h153 : begin  //101010011 339     339

    BC1500_Inst_339_En   =  BC1500_Inst_339_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_339_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_339_Dec_En & ~dis_sc ? BC1500_Inst_339_Tdo : Tdr_Bypass_Tdo;
    end




    9'h154 : begin  //101010100 340     340

    BC1500_Inst_340_En   =  BC1500_Inst_340_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_340_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_340_Dec_En & ~dis_sc ? BC1500_Inst_340_Tdo : Tdr_Bypass_Tdo;
    end




    9'h155 : begin  //101010101 341     341

    BC1500_Inst_341_En   =  BC1500_Inst_341_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_341_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_341_Dec_En & ~dis_sc ? BC1500_Inst_341_Tdo : Tdr_Bypass_Tdo;
    end




    9'h156 : begin  //101010110 342     342

    BC1500_Inst_342_En   =  BC1500_Inst_342_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_342_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_342_Dec_En & ~dis_sc ? BC1500_Inst_342_Tdo : Tdr_Bypass_Tdo;
    end




    9'h157 : begin  //101010111 343     343

    BC1500_Inst_343_En   =  BC1500_Inst_343_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_343_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_343_Dec_En & ~dis_sc ? BC1500_Inst_343_Tdo : Tdr_Bypass_Tdo;
    end




    9'h158 : begin  //101011000 344     344

    BC1500_Inst_344_En   =  BC1500_Inst_344_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_344_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_344_Dec_En & ~dis_sc ? BC1500_Inst_344_Tdo : Tdr_Bypass_Tdo;
    end




    9'h159 : begin  //101011001 345     345

    BC1500_Inst_345_En   =  BC1500_Inst_345_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_345_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_345_Dec_En & ~dis_sc ? BC1500_Inst_345_Tdo : Tdr_Bypass_Tdo;
    end




    9'h15a : begin  //101011010 346     346

    BC1500_Inst_346_En   =  BC1500_Inst_346_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_346_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_346_Dec_En & ~dis_sc ? BC1500_Inst_346_Tdo : Tdr_Bypass_Tdo;
    end




    9'h15b : begin  //101011011 347     347

    BC1500_Inst_347_En   =  BC1500_Inst_347_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_347_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_347_Dec_En & ~dis_sc ? BC1500_Inst_347_Tdo : Tdr_Bypass_Tdo;
    end




    9'h15c : begin  //101011100 348     348

    BC1500_Inst_348_En   =  BC1500_Inst_348_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_348_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_348_Dec_En & ~dis_sc ? BC1500_Inst_348_Tdo : Tdr_Bypass_Tdo;
    end




    9'h15d : begin  //101011101 349     349

    BC1500_Inst_349_En   =  BC1500_Inst_349_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_349_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_349_Dec_En & ~dis_sc ? BC1500_Inst_349_Tdo : Tdr_Bypass_Tdo;
    end




    9'h15e : begin  //101011110 350     350

    BC1500_Inst_350_En   =  BC1500_Inst_350_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_350_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_350_Dec_En & ~dis_sc ? BC1500_Inst_350_Tdo : Tdr_Bypass_Tdo;
    end




    9'h15f : begin  //101011111 351     351

    BC1500_Inst_351_En   =  BC1500_Inst_351_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_351_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_351_Dec_En & ~dis_sc ? BC1500_Inst_351_Tdo : Tdr_Bypass_Tdo;
    end




    9'h160 : begin  //101100000 352     352

    BC1500_Inst_352_En   =  BC1500_Inst_352_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_352_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_352_Dec_En & ~dis_sc ? BC1500_Inst_352_Tdo : Tdr_Bypass_Tdo;
    end




    9'h161 : begin  //101100001 353     353

    BC1500_Inst_353_En   =  BC1500_Inst_353_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_353_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_353_Dec_En & ~dis_sc ? BC1500_Inst_353_Tdo : Tdr_Bypass_Tdo;
    end




    9'h162 : begin  //101100010 354     354

    BC1500_Inst_354_En   =  BC1500_Inst_354_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_354_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_354_Dec_En & ~dis_sc ? BC1500_Inst_354_Tdo : Tdr_Bypass_Tdo;
    end




    9'h163 : begin  //101100011 355     355

    BC1500_Inst_355_En   =  BC1500_Inst_355_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_355_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_355_Dec_En & ~dis_sc ? BC1500_Inst_355_Tdo : Tdr_Bypass_Tdo;
    end




    9'h164 : begin  //101100100 356     356

    BC1500_Inst_356_En   =  BC1500_Inst_356_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_356_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_356_Dec_En & ~dis_sc ? BC1500_Inst_356_Tdo : Tdr_Bypass_Tdo;
    end




    9'h165 : begin  //101100101 357     357

    BC1500_Inst_357_En   =  BC1500_Inst_357_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_357_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_357_Dec_En & ~dis_sc ? BC1500_Inst_357_Tdo : Tdr_Bypass_Tdo;
    end




    9'h166 : begin  //101100110 358     358

    BC1500_Inst_358_En   =  BC1500_Inst_358_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_358_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_358_Dec_En & ~dis_sc ? BC1500_Inst_358_Tdo : Tdr_Bypass_Tdo;
    end




    9'h167 : begin  //101100111 359     359

    BC1500_Inst_359_En   =  BC1500_Inst_359_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_359_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_359_Dec_En & ~dis_sc ? BC1500_Inst_359_Tdo : Tdr_Bypass_Tdo;
    end




    9'h168 : begin  //101101000 360     360

    BC1500_Inst_360_En   =  BC1500_Inst_360_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_360_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_360_Dec_En & ~dis_sc ? BC1500_Inst_360_Tdo : Tdr_Bypass_Tdo;
    end




    9'h169 : begin  //101101001 361     361

    BC1500_Inst_361_En   =  BC1500_Inst_361_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_361_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_361_Dec_En & ~dis_sc ? BC1500_Inst_361_Tdo : Tdr_Bypass_Tdo;
    end




    9'h16a : begin  //101101010 362     362

    BC1500_Inst_362_En   =  BC1500_Inst_362_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_362_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_362_Dec_En & ~dis_sc ? BC1500_Inst_362_Tdo : Tdr_Bypass_Tdo;
    end




    9'h16b : begin  //101101011 363     363

    BC1500_Inst_363_En   =  BC1500_Inst_363_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_363_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_363_Dec_En & ~dis_sc ? BC1500_Inst_363_Tdo : Tdr_Bypass_Tdo;
    end




    9'h16c : begin  //101101100 364     364

    BC1500_Inst_364_En   =  BC1500_Inst_364_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_364_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_364_Dec_En & ~dis_sc ? BC1500_Inst_364_Tdo : Tdr_Bypass_Tdo;
    end




    9'h16d : begin  //101101101 365     365

    BC1500_Inst_365_En   =  BC1500_Inst_365_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_365_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_365_Dec_En & ~dis_sc ? BC1500_Inst_365_Tdo : Tdr_Bypass_Tdo;
    end




    9'h16e : begin  //101101110 366     366

    BC1500_Inst_366_En   =  BC1500_Inst_366_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_366_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_366_Dec_En & ~dis_sc ? BC1500_Inst_366_Tdo : Tdr_Bypass_Tdo;
    end




    9'h16f : begin  //101101111 367     367

    BC1500_Inst_367_En   =  BC1500_Inst_367_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_367_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_367_Dec_En & ~dis_sc ? BC1500_Inst_367_Tdo : Tdr_Bypass_Tdo;
    end




    9'h170 : begin  //101110000 368     368

    BC1500_Inst_368_En   =  BC1500_Inst_368_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_368_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_368_Dec_En & ~dis_sc ? BC1500_Inst_368_Tdo : Tdr_Bypass_Tdo;
    end




    9'h171 : begin  //101110001 369     369

    BC1500_Inst_369_En   =  BC1500_Inst_369_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_369_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_369_Dec_En & ~dis_sc ? BC1500_Inst_369_Tdo : Tdr_Bypass_Tdo;
    end




    9'h172 : begin  //101110010 370     370

    BC1500_Inst_370_En   =  BC1500_Inst_370_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_370_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_370_Dec_En & ~dis_sc ? BC1500_Inst_370_Tdo : Tdr_Bypass_Tdo;
    end




    9'h173 : begin  //101110011 371     371

    BC1500_Inst_371_En   =  BC1500_Inst_371_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_371_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_371_Dec_En & ~dis_sc ? BC1500_Inst_371_Tdo : Tdr_Bypass_Tdo;
    end




    9'h174 : begin  //101110100 372     372

    BC1500_Inst_372_En   =  BC1500_Inst_372_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_372_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_372_Dec_En & ~dis_sc ? BC1500_Inst_372_Tdo : Tdr_Bypass_Tdo;
    end




    9'h175 : begin  //101110101 373     373

    BC1500_Inst_373_En   =  BC1500_Inst_373_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_373_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_373_Dec_En & ~dis_sc ? BC1500_Inst_373_Tdo : Tdr_Bypass_Tdo;
    end




    9'h176 : begin  //101110110 374     374

    BC1500_Inst_374_En   =  BC1500_Inst_374_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_374_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_374_Dec_En & ~dis_sc ? BC1500_Inst_374_Tdo : Tdr_Bypass_Tdo;
    end




    9'h177 : begin  //101110111 375     375

    BC1500_Inst_375_En   =  BC1500_Inst_375_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_375_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_375_Dec_En & ~dis_sc ? BC1500_Inst_375_Tdo : Tdr_Bypass_Tdo;
    end




    9'h178 : begin  //101111000 376     376

    BC1500_Inst_376_En   =  BC1500_Inst_376_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_376_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_376_Dec_En & ~dis_sc ? BC1500_Inst_376_Tdo : Tdr_Bypass_Tdo;
    end




    9'h179 : begin  //101111001 377     377

    BC1500_Inst_377_En   =  BC1500_Inst_377_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_377_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_377_Dec_En & ~dis_sc ? BC1500_Inst_377_Tdo : Tdr_Bypass_Tdo;
    end




    9'h17a : begin  //101111010 378     378

    BC1500_Inst_378_En   =  BC1500_Inst_378_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_378_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_378_Dec_En & ~dis_sc ? BC1500_Inst_378_Tdo : Tdr_Bypass_Tdo;
    end




    9'h17b : begin  //101111011 379     379

    BC1500_Inst_379_En   =  BC1500_Inst_379_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_379_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_379_Dec_En & ~dis_sc ? BC1500_Inst_379_Tdo : Tdr_Bypass_Tdo;
    end




    9'h17c : begin  //101111100 380     380

    BC1500_Inst_380_En   =  BC1500_Inst_380_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_380_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_380_Dec_En & ~dis_sc ? BC1500_Inst_380_Tdo : Tdr_Bypass_Tdo;
    end




    9'h17d : begin  //101111101 381     381

    BC1500_Inst_381_En   =  BC1500_Inst_381_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_381_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_381_Dec_En & ~dis_sc ? BC1500_Inst_381_Tdo : Tdr_Bypass_Tdo;
    end




    9'h17e : begin  //101111110 382     382

    BC1500_Inst_382_En   =  BC1500_Inst_382_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_382_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_382_Dec_En & ~dis_sc ? BC1500_Inst_382_Tdo : Tdr_Bypass_Tdo;
    end




    9'h17f : begin  //101111111 383     383

    BC1500_Inst_383_En   =  BC1500_Inst_383_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_383_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_383_Dec_En & ~dis_sc ? BC1500_Inst_383_Tdo : Tdr_Bypass_Tdo;
    end




    9'h180 : begin  //110000000 384     384

    BC1500_Inst_384_En   =  BC1500_Inst_384_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_384_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_384_Dec_En & ~dis_sc ? BC1500_Inst_384_Tdo : Tdr_Bypass_Tdo;
    end




    9'h181 : begin  //110000001 385     385

    BC1500_Inst_385_En   =  BC1500_Inst_385_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_385_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_385_Dec_En & ~dis_sc ? BC1500_Inst_385_Tdo : Tdr_Bypass_Tdo;
    end




    9'h182 : begin  //110000010 386     386

    BC1500_Inst_386_En   =  BC1500_Inst_386_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_386_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_386_Dec_En & ~dis_sc ? BC1500_Inst_386_Tdo : Tdr_Bypass_Tdo;
    end




    9'h183 : begin  //110000011 387     387

    BC1500_Inst_387_En   =  BC1500_Inst_387_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_387_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_387_Dec_En & ~dis_sc ? BC1500_Inst_387_Tdo : Tdr_Bypass_Tdo;
    end




    9'h184 : begin  //110000100 388     388

    BC1500_Inst_388_En   =  BC1500_Inst_388_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_388_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_388_Dec_En & ~dis_sc ? BC1500_Inst_388_Tdo : Tdr_Bypass_Tdo;
    end




    9'h185 : begin  //110000101 389     389

    BC1500_Inst_389_En   =  BC1500_Inst_389_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_389_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_389_Dec_En & ~dis_sc ? BC1500_Inst_389_Tdo : Tdr_Bypass_Tdo;
    end




    9'h186 : begin  //110000110 390     390

    BC1500_Inst_390_En   =  BC1500_Inst_390_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_390_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_390_Dec_En & ~dis_sc ? BC1500_Inst_390_Tdo : Tdr_Bypass_Tdo;
    end




    9'h187 : begin  //110000111 391     391

    BC1500_Inst_391_En   =  BC1500_Inst_391_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_391_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_391_Dec_En & ~dis_sc ? BC1500_Inst_391_Tdo : Tdr_Bypass_Tdo;
    end




    9'h188 : begin  //110001000 392     392

    BC1500_Inst_392_En   =  BC1500_Inst_392_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_392_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_392_Dec_En & ~dis_sc ? BC1500_Inst_392_Tdo : Tdr_Bypass_Tdo;
    end




    9'h189 : begin  //110001001 393     393

    BC1500_Inst_393_En   =  BC1500_Inst_393_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_393_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_393_Dec_En & ~dis_sc ? BC1500_Inst_393_Tdo : Tdr_Bypass_Tdo;
    end




    9'h18a : begin  //110001010 394     394

    BC1500_Inst_394_En   =  BC1500_Inst_394_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_394_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_394_Dec_En & ~dis_sc ? BC1500_Inst_394_Tdo : Tdr_Bypass_Tdo;
    end




    9'h18b : begin  //110001011 395     395

    BC1500_Inst_395_En   =  BC1500_Inst_395_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_395_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_395_Dec_En & ~dis_sc ? BC1500_Inst_395_Tdo : Tdr_Bypass_Tdo;
    end




    9'h18c : begin  //110001100 396     396

    BC1500_Inst_396_En   =  BC1500_Inst_396_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_396_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_396_Dec_En & ~dis_sc ? BC1500_Inst_396_Tdo : Tdr_Bypass_Tdo;
    end




    9'h18d : begin  //110001101 397     397

    BC1500_Inst_397_En   =  BC1500_Inst_397_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_397_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_397_Dec_En & ~dis_sc ? BC1500_Inst_397_Tdo : Tdr_Bypass_Tdo;
    end




    9'h18e : begin  //110001110 398     398

    BC1500_Inst_398_En   =  BC1500_Inst_398_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_398_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_398_Dec_En & ~dis_sc ? BC1500_Inst_398_Tdo : Tdr_Bypass_Tdo;
    end




    9'h18f : begin  //110001111 399     399

    BC1500_Inst_399_En   =  BC1500_Inst_399_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_399_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_399_Dec_En & ~dis_sc ? BC1500_Inst_399_Tdo : Tdr_Bypass_Tdo;
    end




    9'h190 : begin  //110010000 400     400

    BC1500_Inst_400_En   =  BC1500_Inst_400_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_400_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_400_Dec_En & ~dis_sc ? BC1500_Inst_400_Tdo : Tdr_Bypass_Tdo;
    end




    9'h191 : begin  //110010001 401     401

    BC1500_Inst_401_En   =  BC1500_Inst_401_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_401_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_401_Dec_En & ~dis_sc ? BC1500_Inst_401_Tdo : Tdr_Bypass_Tdo;
    end




    9'h192 : begin  //110010010 402     402

    BC1500_Inst_402_En   =  BC1500_Inst_402_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_402_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_402_Dec_En & ~dis_sc ? BC1500_Inst_402_Tdo : Tdr_Bypass_Tdo;
    end




    9'h193 : begin  //110010011 403     403

    BC1500_Inst_403_En   =  BC1500_Inst_403_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_403_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_403_Dec_En & ~dis_sc ? BC1500_Inst_403_Tdo : Tdr_Bypass_Tdo;
    end




    9'h194 : begin  //110010100 404     404

    BC1500_Inst_404_En   =  BC1500_Inst_404_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_404_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_404_Dec_En & ~dis_sc ? BC1500_Inst_404_Tdo : Tdr_Bypass_Tdo;
    end




    9'h195 : begin  //110010101 405     405

    BC1500_Inst_405_En   =  BC1500_Inst_405_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_405_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_405_Dec_En & ~dis_sc ? BC1500_Inst_405_Tdo : Tdr_Bypass_Tdo;
    end




    9'h196 : begin  //110010110 406     406

    BC1500_Inst_406_En   =  BC1500_Inst_406_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_406_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_406_Dec_En & ~dis_sc ? BC1500_Inst_406_Tdo : Tdr_Bypass_Tdo;
    end




    9'h197 : begin  //110010111 407     407

    BC1500_Inst_407_En   =  BC1500_Inst_407_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_407_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_407_Dec_En & ~dis_sc ? BC1500_Inst_407_Tdo : Tdr_Bypass_Tdo;
    end




    9'h198 : begin  //110011000 408     408

    BC1500_Inst_408_En   =  BC1500_Inst_408_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_408_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_408_Dec_En & ~dis_sc ? BC1500_Inst_408_Tdo : Tdr_Bypass_Tdo;
    end




    9'h199 : begin  //110011001 409     409

    BC1500_Inst_409_En   =  BC1500_Inst_409_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_409_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_409_Dec_En & ~dis_sc ? BC1500_Inst_409_Tdo : Tdr_Bypass_Tdo;
    end




    9'h19a : begin  //110011010 410     410

    BC1500_Inst_410_En   =  BC1500_Inst_410_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_410_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_410_Dec_En & ~dis_sc ? BC1500_Inst_410_Tdo : Tdr_Bypass_Tdo;
    end




    9'h19b : begin  //110011011 411     411

    BC1500_Inst_411_En   =  BC1500_Inst_411_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_411_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_411_Dec_En & ~dis_sc ? BC1500_Inst_411_Tdo : Tdr_Bypass_Tdo;
    end




    9'h19c : begin  //110011100 412     412

    BC1500_Inst_412_En   =  BC1500_Inst_412_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_412_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_412_Dec_En & ~dis_sc ? BC1500_Inst_412_Tdo : Tdr_Bypass_Tdo;
    end




    9'h19d : begin  //110011101 413     413

    BC1500_Inst_413_En   =  BC1500_Inst_413_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_413_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_413_Dec_En & ~dis_sc ? BC1500_Inst_413_Tdo : Tdr_Bypass_Tdo;
    end




    9'h19e : begin  //110011110 414     414

    BC1500_Inst_414_En   =  BC1500_Inst_414_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_414_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_414_Dec_En & ~dis_sc ? BC1500_Inst_414_Tdo : Tdr_Bypass_Tdo;
    end




    9'h19f : begin  //110011111 415     415

    BC1500_Inst_415_En   =  BC1500_Inst_415_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_415_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_415_Dec_En & ~dis_sc ? BC1500_Inst_415_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1a0 : begin  //110100000 416     416

    BC1500_Inst_416_En   =  BC1500_Inst_416_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_416_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_416_Dec_En & ~dis_sc ? BC1500_Inst_416_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1a1 : begin  //110100001 417     417

    BC1500_Inst_417_En   =  BC1500_Inst_417_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_417_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_417_Dec_En & ~dis_sc ? BC1500_Inst_417_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1a2 : begin  //110100010 418     418

    BC1500_Inst_418_En   =  BC1500_Inst_418_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_418_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_418_Dec_En & ~dis_sc ? BC1500_Inst_418_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1a3 : begin  //110100011 419     419

    BC1500_Inst_419_En   =  BC1500_Inst_419_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_419_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_419_Dec_En & ~dis_sc ? BC1500_Inst_419_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1a4 : begin  //110100100 420     420

    BC1500_Inst_420_En   =  BC1500_Inst_420_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_420_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_420_Dec_En & ~dis_sc ? BC1500_Inst_420_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1a5 : begin  //110100101 421     421

    BC1500_Inst_421_En   =  BC1500_Inst_421_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_421_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_421_Dec_En & ~dis_sc ? BC1500_Inst_421_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1a6 : begin  //110100110 422     422

    BC1500_Inst_422_En   =  BC1500_Inst_422_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_422_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_422_Dec_En & ~dis_sc ? BC1500_Inst_422_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1a7 : begin  //110100111 423     423

    BC1500_Inst_423_En   =  BC1500_Inst_423_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_423_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_423_Dec_En & ~dis_sc ? BC1500_Inst_423_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1a8 : begin  //110101000 424     424

    BC1500_Inst_424_En   =  BC1500_Inst_424_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_424_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_424_Dec_En & ~dis_sc ? BC1500_Inst_424_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1a9 : begin  //110101001 425     425

    BC1500_Inst_425_En   =  BC1500_Inst_425_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_425_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_425_Dec_En & ~dis_sc ? BC1500_Inst_425_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1aa : begin  //110101010 426     426

    BC1500_Inst_426_En   =  BC1500_Inst_426_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_426_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_426_Dec_En & ~dis_sc ? BC1500_Inst_426_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1ab : begin  //110101011 427     427

    BC1500_Inst_427_En   =  BC1500_Inst_427_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_427_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_427_Dec_En & ~dis_sc ? BC1500_Inst_427_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1ac : begin  //110101100 428     428

    BC1500_Inst_428_En   =  BC1500_Inst_428_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_428_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_428_Dec_En & ~dis_sc ? BC1500_Inst_428_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1ad : begin  //110101101 429     429

    BC1500_Inst_429_En   =  BC1500_Inst_429_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_429_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_429_Dec_En & ~dis_sc ? BC1500_Inst_429_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1ae : begin  //110101110 430     430

    BC1500_Inst_430_En   =  BC1500_Inst_430_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_430_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_430_Dec_En & ~dis_sc ? BC1500_Inst_430_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1af : begin  //110101111 431     431

    BC1500_Inst_431_En   =  BC1500_Inst_431_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_431_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_431_Dec_En & ~dis_sc ? BC1500_Inst_431_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1b0 : begin  //110110000 432     432

    BC1500_Inst_432_En   =  BC1500_Inst_432_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_432_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_432_Dec_En & ~dis_sc ? BC1500_Inst_432_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1b1 : begin  //110110001 433     433

    BC1500_Inst_433_En   =  BC1500_Inst_433_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_433_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_433_Dec_En & ~dis_sc ? BC1500_Inst_433_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1b2 : begin  //110110010 434     434

    BC1500_Inst_434_En   =  BC1500_Inst_434_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_434_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_434_Dec_En & ~dis_sc ? BC1500_Inst_434_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1b3 : begin  //110110011 435     435

    BC1500_Inst_435_En   =  BC1500_Inst_435_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_435_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_435_Dec_En & ~dis_sc ? BC1500_Inst_435_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1b4 : begin  //110110100 436     436

    BC1500_Inst_436_En   =  BC1500_Inst_436_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_436_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_436_Dec_En & ~dis_sc ? BC1500_Inst_436_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1b5 : begin  //110110101 437     437

    BC1500_Inst_437_En   =  BC1500_Inst_437_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_437_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_437_Dec_En & ~dis_sc ? BC1500_Inst_437_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1b6 : begin  //110110110 438     438

    BC1500_Inst_438_En   =  BC1500_Inst_438_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_438_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_438_Dec_En & ~dis_sc ? BC1500_Inst_438_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1b7 : begin  //110110111 439     439

    BC1500_Inst_439_En   =  BC1500_Inst_439_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_439_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_439_Dec_En & ~dis_sc ? BC1500_Inst_439_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1b8 : begin  //110111000 440     440

    BC1500_Inst_440_En   =  BC1500_Inst_440_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_440_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_440_Dec_En & ~dis_sc ? BC1500_Inst_440_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1b9 : begin  //110111001 441     441

    BC1500_Inst_441_En   =  BC1500_Inst_441_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_441_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_441_Dec_En & ~dis_sc ? BC1500_Inst_441_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1ba : begin  //110111010 442     442

    BC1500_Inst_442_En   =  BC1500_Inst_442_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_442_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_442_Dec_En & ~dis_sc ? BC1500_Inst_442_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1bb : begin  //110111011 443     443

    BC1500_Inst_443_En   =  BC1500_Inst_443_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_443_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_443_Dec_En & ~dis_sc ? BC1500_Inst_443_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1bc : begin  //110111100 444     444

    BC1500_Inst_444_En   =  BC1500_Inst_444_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_444_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_444_Dec_En & ~dis_sc ? BC1500_Inst_444_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1bd : begin  //110111101 445     445

    BC1500_Inst_445_En   =  BC1500_Inst_445_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_445_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_445_Dec_En & ~dis_sc ? BC1500_Inst_445_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1be : begin  //110111110 446     446

    BC1500_Inst_446_En   =  BC1500_Inst_446_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_446_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_446_Dec_En & ~dis_sc ? BC1500_Inst_446_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1bf : begin  //110111111 447     447

    BC1500_Inst_447_En   =  BC1500_Inst_447_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_447_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_447_Dec_En & ~dis_sc ? BC1500_Inst_447_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1c0 : begin  //111000000 448     448

    BC1500_Inst_448_En   =  BC1500_Inst_448_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_448_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_448_Dec_En & ~dis_sc ? BC1500_Inst_448_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1c1 : begin  //111000001 449     449

    BC1500_Inst_449_En   =  BC1500_Inst_449_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_449_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_449_Dec_En & ~dis_sc ? BC1500_Inst_449_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1c2 : begin  //111000010 450     450

    BC1500_Inst_450_En   =  BC1500_Inst_450_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_450_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_450_Dec_En & ~dis_sc ? BC1500_Inst_450_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1c3 : begin  //111000011 451     451

    BC1500_Inst_451_En   =  BC1500_Inst_451_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_451_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_451_Dec_En & ~dis_sc ? BC1500_Inst_451_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1c4 : begin  //111000100 452     452

    BC1500_Inst_452_En   =  BC1500_Inst_452_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_452_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_452_Dec_En & ~dis_sc ? BC1500_Inst_452_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1c5 : begin  //111000101 453     453

    BC1500_Inst_453_En   =  BC1500_Inst_453_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_453_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_453_Dec_En & ~dis_sc ? BC1500_Inst_453_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1c6 : begin  //111000110 454     454

    BC1500_Inst_454_En   =  BC1500_Inst_454_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_454_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_454_Dec_En & ~dis_sc ? BC1500_Inst_454_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1c7 : begin  //111000111 455     455

    BC1500_Inst_455_En   =  BC1500_Inst_455_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_455_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_455_Dec_En & ~dis_sc ? BC1500_Inst_455_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1c8 : begin  //111001000 456     456

    BC1500_Inst_456_En   =  BC1500_Inst_456_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_456_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_456_Dec_En & ~dis_sc ? BC1500_Inst_456_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1c9 : begin  //111001001 457     457

    BC1500_Inst_457_En   =  BC1500_Inst_457_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_457_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_457_Dec_En & ~dis_sc ? BC1500_Inst_457_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1ca : begin  //111001010 458     458

    BC1500_Inst_458_En   =  BC1500_Inst_458_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_458_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_458_Dec_En & ~dis_sc ? BC1500_Inst_458_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1cb : begin  //111001011 459     459

    BC1500_Inst_459_En   =  BC1500_Inst_459_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_459_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_459_Dec_En & ~dis_sc ? BC1500_Inst_459_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1cc : begin  //111001100 460     460

    BC1500_Inst_460_En   =  BC1500_Inst_460_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_460_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_460_Dec_En & ~dis_sc ? BC1500_Inst_460_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1cd : begin  //111001101 461     461

    BC1500_Inst_461_En   =  BC1500_Inst_461_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_461_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_461_Dec_En & ~dis_sc ? BC1500_Inst_461_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1ce : begin  //111001110 462     462

    BC1500_Inst_462_En   =  BC1500_Inst_462_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_462_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_462_Dec_En & ~dis_sc ? BC1500_Inst_462_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1cf : begin  //111001111 463     463

    BC1500_Inst_463_En   =  BC1500_Inst_463_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_463_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_463_Dec_En & ~dis_sc ? BC1500_Inst_463_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1d0 : begin  //111010000 464     464

    BC1500_Inst_464_En   =  BC1500_Inst_464_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_464_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_464_Dec_En & ~dis_sc ? BC1500_Inst_464_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1d1 : begin  //111010001 465     465

    BC1500_Inst_465_En   =  BC1500_Inst_465_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_465_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_465_Dec_En & ~dis_sc ? BC1500_Inst_465_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1d2 : begin  //111010010 466     466

    BC1500_Inst_466_En   =  BC1500_Inst_466_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_466_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_466_Dec_En & ~dis_sc ? BC1500_Inst_466_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1d3 : begin  //111010011 467     467

    BC1500_Inst_467_En   =  BC1500_Inst_467_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_467_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_467_Dec_En & ~dis_sc ? BC1500_Inst_467_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1d4 : begin  //111010100 468     468

    BC1500_Inst_468_En   =  BC1500_Inst_468_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_468_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_468_Dec_En & ~dis_sc ? BC1500_Inst_468_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1d5 : begin  //111010101 469     469

    BC1500_Inst_469_En   =  BC1500_Inst_469_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_469_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_469_Dec_En & ~dis_sc ? BC1500_Inst_469_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1d6 : begin  //111010110 470     470

    BC1500_Inst_470_En   =  BC1500_Inst_470_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_470_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_470_Dec_En & ~dis_sc ? BC1500_Inst_470_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1d7 : begin  //111010111 471     471

    BC1500_Inst_471_En   =  BC1500_Inst_471_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_471_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_471_Dec_En & ~dis_sc ? BC1500_Inst_471_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1d8 : begin  //111011000 472     472

    BC1500_Inst_472_En   =  BC1500_Inst_472_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_472_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_472_Dec_En & ~dis_sc ? BC1500_Inst_472_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1d9 : begin  //111011001 473     473

    BC1500_Inst_473_En   =  BC1500_Inst_473_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_473_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_473_Dec_En & ~dis_sc ? BC1500_Inst_473_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1da : begin  //111011010 474     474

    BC1500_Inst_474_En   =  BC1500_Inst_474_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_474_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_474_Dec_En & ~dis_sc ? BC1500_Inst_474_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1db : begin  //111011011 475     475

    BC1500_Inst_475_En   =  BC1500_Inst_475_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_475_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_475_Dec_En & ~dis_sc ? BC1500_Inst_475_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1dc : begin  //111011100 476     476

    BC1500_Inst_476_En   =  BC1500_Inst_476_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_476_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_476_Dec_En & ~dis_sc ? BC1500_Inst_476_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1dd : begin  //111011101 477     477

    BC1500_Inst_477_En   =  BC1500_Inst_477_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_477_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_477_Dec_En & ~dis_sc ? BC1500_Inst_477_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1de : begin  //111011110 478     478

    BC1500_Inst_478_En   =  BC1500_Inst_478_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_478_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_478_Dec_En & ~dis_sc ? BC1500_Inst_478_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1df : begin  //111011111 479     479

    BC1500_Inst_479_En   =  BC1500_Inst_479_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_479_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_479_Dec_En & ~dis_sc ? BC1500_Inst_479_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1e0 : begin  //111100000 480     480

    BC1500_Inst_480_En   =  BC1500_Inst_480_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_480_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_480_Dec_En & ~dis_sc ? BC1500_Inst_480_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1e1 : begin  //111100001 481     481

    BC1500_Inst_481_En   =  BC1500_Inst_481_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_481_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_481_Dec_En & ~dis_sc ? BC1500_Inst_481_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1e2 : begin  //111100010 482     482

    BC1500_Inst_482_En   =  BC1500_Inst_482_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_482_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_482_Dec_En & ~dis_sc ? BC1500_Inst_482_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1e3 : begin  //111100011 483     483

    BC1500_Inst_483_En   =  BC1500_Inst_483_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_483_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_483_Dec_En & ~dis_sc ? BC1500_Inst_483_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1e4 : begin  //111100100 484     484

    BC1500_Inst_484_En   =  BC1500_Inst_484_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_484_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_484_Dec_En & ~dis_sc ? BC1500_Inst_484_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1e5 : begin  //111100101 485     485

    BC1500_Inst_485_En   =  BC1500_Inst_485_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_485_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_485_Dec_En & ~dis_sc ? BC1500_Inst_485_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1e6 : begin  //111100110 486     486

    BC1500_Inst_486_En   =  BC1500_Inst_486_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_486_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_486_Dec_En & ~dis_sc ? BC1500_Inst_486_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1e7 : begin  //111100111 487     487

    BC1500_Inst_487_En   =  BC1500_Inst_487_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_487_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_487_Dec_En & ~dis_sc ? BC1500_Inst_487_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1e8 : begin  //111101000 488     488

    BC1500_Inst_488_En   =  BC1500_Inst_488_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_488_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_488_Dec_En & ~dis_sc ? BC1500_Inst_488_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1e9 : begin  //111101001 489     489

    BC1500_Inst_489_En   =  BC1500_Inst_489_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_489_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_489_Dec_En & ~dis_sc ? BC1500_Inst_489_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1ea : begin  //111101010 490     490

    BC1500_Inst_490_En   =  BC1500_Inst_490_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_490_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_490_Dec_En & ~dis_sc ? BC1500_Inst_490_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1eb : begin  //111101011 491     491

    BC1500_Inst_491_En   =  BC1500_Inst_491_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_491_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_491_Dec_En & ~dis_sc ? BC1500_Inst_491_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1ec : begin  //111101100 492     492

    BC1500_Inst_492_En   =  BC1500_Inst_492_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_492_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_492_Dec_En & ~dis_sc ? BC1500_Inst_492_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1ed : begin  //111101101 493     493

    BC1500_Inst_493_En   =  BC1500_Inst_493_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_493_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_493_Dec_En & ~dis_sc ? BC1500_Inst_493_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1ee : begin  //111101110 494     494

    BC1500_Inst_494_En   =  BC1500_Inst_494_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_494_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_494_Dec_En & ~dis_sc ? BC1500_Inst_494_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1ef : begin  //111101111 495     495

    BC1500_Inst_495_En   =  BC1500_Inst_495_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_495_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_495_Dec_En & ~dis_sc ? BC1500_Inst_495_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1f0 : begin  //111110000 496     496

    BC1500_Inst_496_En   =  BC1500_Inst_496_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_496_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_496_Dec_En & ~dis_sc ? BC1500_Inst_496_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1f1 : begin  //111110001 497     497

    BC1500_Inst_497_En   =  BC1500_Inst_497_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_497_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_497_Dec_En & ~dis_sc ? BC1500_Inst_497_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1f2 : begin  //111110010 498     498

    BC1500_Inst_498_En   =  BC1500_Inst_498_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_498_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_498_Dec_En & ~dis_sc ? BC1500_Inst_498_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1f3 : begin  //111110011 499     499

    BC1500_Inst_499_En   =  BC1500_Inst_499_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_499_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_499_Dec_En & ~dis_sc ? BC1500_Inst_499_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1f4 : begin  //111110100 500     500

    BC1500_Inst_500_En   =  BC1500_Inst_500_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_500_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_500_Dec_En & ~dis_sc ? BC1500_Inst_500_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1f5 : begin  //111110101 501     501

    BC1500_Inst_501_En   =  BC1500_Inst_501_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_501_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_501_Dec_En & ~dis_sc ? BC1500_Inst_501_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1f6 : begin  //111110110 502     502

    BC1500_Inst_502_En   =  BC1500_Inst_502_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_502_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_502_Dec_En & ~dis_sc ? BC1500_Inst_502_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1f7 : begin  //111110111 503     503

    BC1500_Inst_503_En   =  BC1500_Inst_503_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_503_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_503_Dec_En & ~dis_sc ? BC1500_Inst_503_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1f8 : begin  //111111000 504     504

    BC1500_Inst_504_En   =  BC1500_Inst_504_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_504_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_504_Dec_En & ~dis_sc ? BC1500_Inst_504_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1f9 : begin  //111111001 505     505

    BC1500_Inst_505_En   =  BC1500_Inst_505_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_505_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_505_Dec_En & ~dis_sc ? BC1500_Inst_505_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1fa : begin  //111111010 506     506

    BC1500_Inst_506_En   =  BC1500_Inst_506_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_506_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_506_Dec_En & ~dis_sc ? BC1500_Inst_506_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1fb : begin  //111111011 507     507

    BC1500_Inst_507_En   =  BC1500_Inst_507_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_507_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_507_Dec_En & ~dis_sc ? BC1500_Inst_507_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1fc : begin  //111111100 508     508

    BC1500_Inst_508_En   =  BC1500_Inst_508_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_508_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_508_Dec_En & ~dis_sc ? BC1500_Inst_508_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1fd : begin  //111111101 509     509

    BC1500_Inst_509_En   =  BC1500_Inst_509_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_509_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_509_Dec_En & ~dis_sc ? BC1500_Inst_509_Tdo : Tdr_Bypass_Tdo;
    end




    9'h1fe : begin  //111111110 510     510

    BC1500_Inst_510_En   =  BC1500_Inst_510_Dec_En;
    BC1500_Bypass_En      = ~BC1500_Inst_510_Dec_En | dis_sc;
    Tdr_Tdo               =  BC1500_Inst_510_Dec_En & ~dis_sc ? BC1500_Inst_510_Tdo : Tdr_Bypass_Tdo;
    end


    {(9){1'b1}} : begin
    BC1500_Bypass_En      = 1'b1;
    Tdr_Tdo               =  Tdr_Bypass_Tdo;
    end



    default : begin // any unused instruction should be select bypass register.
    BC1500_Bypass_En      = 1'b1;
    Tdr_Tdo               =  Tdr_Bypass_Tdo;
    end

    endcase
  end

   ati_mux2  mux_Wso ( 
        .i0 (Tdr_Tdo),
        .i1 (Ir_Tdo),
        .z (BC1500_Tdo),
        .s (ir_shift)     //TBD??
   );





`ifdef ABV

// Ignore X, only check z
wire check_for_z = 
               ((BC1500_Inst_10_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_11_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_12_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_13_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_14_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_15_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_16_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_17_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_18_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_19_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_20_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_21_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_22_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_23_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_24_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_25_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_26_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_27_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_28_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_29_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_30_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_31_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_32_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_33_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_34_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_35_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_36_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_37_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_38_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_39_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_40_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_41_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_42_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_43_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_44_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_45_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_46_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_47_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_48_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_49_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_50_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_51_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_52_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_53_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_54_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_55_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_56_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_57_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_58_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_59_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_60_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_61_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_62_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_63_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_64_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_65_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_66_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_67_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_68_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_69_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_70_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_71_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_72_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_73_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_74_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_75_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_76_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_77_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_78_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_79_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_80_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_81_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_82_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_83_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_84_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_85_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_86_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_87_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_88_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_89_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_90_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_91_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_92_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_93_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_94_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_95_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_96_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_97_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_98_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_99_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_100_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_101_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_102_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_103_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_104_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_105_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_106_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_107_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_108_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_109_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_110_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_111_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_112_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_113_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_114_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_115_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_116_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_117_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_118_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_119_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_120_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_121_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_122_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_123_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_124_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_125_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_126_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_127_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_128_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_129_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_130_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_131_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_132_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_133_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_134_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_135_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_136_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_137_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_138_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_139_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_140_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_141_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_142_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_143_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_144_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_145_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_146_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_147_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_148_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_149_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_150_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_151_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_152_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_153_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_154_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_155_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_156_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_157_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_158_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_159_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_160_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_161_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_162_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_163_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_164_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_165_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_166_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_167_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_168_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_169_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_170_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_171_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_172_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_173_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_174_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_175_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_176_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_177_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_178_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_179_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_180_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_181_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_182_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_183_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_184_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_185_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_186_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_187_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_188_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_189_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_190_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_191_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_192_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_193_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_194_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_195_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_196_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_197_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_198_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_199_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_200_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_201_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_202_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_203_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_204_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_205_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_206_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_207_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_208_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_209_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_210_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_211_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_212_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_213_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_214_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_215_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_216_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_217_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_218_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_219_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_220_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_221_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_222_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_223_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_224_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_225_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_226_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_227_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_228_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_229_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_230_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_231_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_232_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_233_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_234_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_235_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_236_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_237_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_238_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_239_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_240_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_241_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_242_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_243_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_244_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_245_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_246_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_247_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_248_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_249_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_250_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_251_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_252_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_253_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_254_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_255_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_256_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_257_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_258_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_259_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_260_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_261_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_262_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_263_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_264_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_265_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_266_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_267_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_268_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_269_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_270_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_271_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_272_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_273_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_274_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_275_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_276_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_277_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_278_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_279_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_280_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_281_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_282_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_283_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_284_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_285_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_286_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_287_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_288_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_289_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_290_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_291_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_292_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_293_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_294_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_295_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_296_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_297_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_298_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_299_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_300_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_301_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_302_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_303_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_304_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_305_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_306_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_307_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_308_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_309_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_310_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_311_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_312_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_313_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_314_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_315_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_316_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_317_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_318_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_319_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_320_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_321_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_322_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_323_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_324_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_325_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_326_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_327_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_328_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_329_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_330_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_331_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_332_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_333_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_334_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_335_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_336_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_337_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_338_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_339_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_340_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_341_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_342_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_343_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_344_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_345_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_346_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_347_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_348_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_349_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_350_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_351_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_352_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_353_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_354_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_355_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_356_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_357_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_358_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_359_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_360_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_361_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_362_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_363_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_364_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_365_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_366_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_367_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_368_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_369_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_370_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_371_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_372_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_373_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_374_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_375_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_376_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_377_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_378_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_379_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_380_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_381_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_382_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_383_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_384_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_385_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_386_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_387_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_388_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_389_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_390_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_391_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_392_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_393_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_394_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_395_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_396_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_397_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_398_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_399_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_400_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_401_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_402_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_403_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_404_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_405_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_406_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_407_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_408_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_409_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_410_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_411_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_412_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_413_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_414_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_415_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_416_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_417_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_418_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_419_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_420_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_421_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_422_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_423_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_424_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_425_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_426_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_427_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_428_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_429_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_430_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_431_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_432_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_433_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_434_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_435_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_436_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_437_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_438_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_439_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_440_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_441_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_442_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_443_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_444_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_445_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_446_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_447_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_448_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_449_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_450_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_451_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_452_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_453_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_454_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_455_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_456_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_457_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_458_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_459_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_460_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_461_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_462_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_463_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_464_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_465_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_466_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_467_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_468_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_469_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_470_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_471_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_472_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_473_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_474_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_475_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_476_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_477_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_478_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_479_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_480_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_481_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_482_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_483_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_484_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_485_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_486_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_487_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_488_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_489_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_490_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_491_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_492_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_493_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_494_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_495_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_496_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_497_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_498_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_499_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_500_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_501_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_502_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_503_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_504_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_505_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_506_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_507_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_508_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_509_Dec_En  === 1'bz)? 1'bz :0)   |
               ((BC1500_Inst_510_Dec_En  === 1'bz)? 1'bz :0)   |
//`ifdef GPU__CHIP__TILES_PRESENT__1  // SOC only.
               ((BC1500_Inst_10_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_11_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_12_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_13_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_14_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_15_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_16_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_17_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_18_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_19_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_20_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_21_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_22_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_23_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_24_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_25_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_26_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_27_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_28_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_29_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_30_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_31_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_32_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_33_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_34_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_35_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_36_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_37_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_38_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_39_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_40_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_41_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_42_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_43_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_44_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_45_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_46_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_47_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_48_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_49_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_50_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_51_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_52_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_53_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_54_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_55_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_56_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_57_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_58_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_59_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_60_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_61_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_62_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_63_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_64_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_65_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_66_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_67_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_68_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_69_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_70_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_71_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_72_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_73_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_74_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_75_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_76_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_77_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_78_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_79_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_80_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_81_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_82_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_83_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_84_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_85_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_86_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_87_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_88_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_89_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_90_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_91_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_92_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_93_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_94_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_95_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_96_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_97_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_98_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_99_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_100_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_101_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_102_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_103_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_104_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_105_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_106_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_107_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_108_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_109_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_110_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_111_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_112_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_113_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_114_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_115_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_116_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_117_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_118_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_119_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_120_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_121_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_122_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_123_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_124_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_125_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_126_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_127_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_128_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_129_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_130_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_131_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_132_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_133_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_134_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_135_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_136_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_137_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_138_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_139_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_140_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_141_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_142_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_143_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_144_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_145_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_146_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_147_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_148_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_149_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_150_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_151_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_152_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_153_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_154_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_155_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_156_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_157_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_158_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_159_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_160_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_161_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_162_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_163_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_164_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_165_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_166_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_167_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_168_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_169_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_170_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_171_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_172_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_173_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_174_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_175_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_176_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_177_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_178_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_179_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_180_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_181_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_182_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_183_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_184_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_185_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_186_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_187_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_188_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_189_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_190_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_191_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_192_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_193_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_194_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_195_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_196_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_197_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_198_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_199_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_200_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_201_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_202_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_203_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_204_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_205_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_206_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_207_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_208_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_209_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_210_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_211_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_212_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_213_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_214_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_215_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_216_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_217_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_218_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_219_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_220_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_221_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_222_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_223_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_224_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_225_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_226_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_227_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_228_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_229_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_230_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_231_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_232_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_233_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_234_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_235_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_236_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_237_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_238_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_239_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_240_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_241_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_242_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_243_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_244_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_245_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_246_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_247_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_248_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_249_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_250_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_251_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_252_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_253_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_254_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_255_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_256_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_257_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_258_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_259_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_260_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_261_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_262_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_263_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_264_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_265_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_266_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_267_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_268_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_269_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_270_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_271_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_272_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_273_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_274_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_275_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_276_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_277_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_278_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_279_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_280_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_281_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_282_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_283_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_284_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_285_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_286_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_287_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_288_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_289_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_290_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_291_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_292_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_293_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_294_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_295_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_296_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_297_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_298_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_299_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_300_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_301_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_302_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_303_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_304_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_305_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_306_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_307_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_308_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_309_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_310_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_311_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_312_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_313_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_314_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_315_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_316_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_317_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_318_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_319_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_320_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_321_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_322_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_323_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_324_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_325_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_326_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_327_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_328_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_329_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_330_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_331_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_332_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_333_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_334_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_335_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_336_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_337_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_338_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_339_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_340_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_341_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_342_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_343_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_344_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_345_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_346_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_347_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_348_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_349_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_350_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_351_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_352_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_353_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_354_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_355_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_356_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_357_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_358_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_359_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_360_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_361_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_362_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_363_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_364_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_365_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_366_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_367_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_368_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_369_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_370_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_371_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_372_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_373_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_374_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_375_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_376_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_377_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_378_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_379_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_380_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_381_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_382_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_383_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_384_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_385_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_386_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_387_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_388_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_389_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_390_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_391_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_392_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_393_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_394_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_395_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_396_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_397_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_398_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_399_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_400_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_401_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_402_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_403_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_404_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_405_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_406_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_407_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_408_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_409_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_410_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_411_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_412_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_413_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_414_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_415_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_416_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_417_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_418_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_419_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_420_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_421_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_422_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_423_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_424_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_425_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_426_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_427_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_428_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_429_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_430_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_431_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_432_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_433_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_434_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_435_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_436_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_437_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_438_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_439_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_440_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_441_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_442_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_443_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_444_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_445_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_446_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_447_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_448_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_449_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_450_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_451_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_452_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_453_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_454_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_455_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_456_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_457_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_458_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_459_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_460_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_461_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_462_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_463_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_464_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_465_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_466_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_467_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_468_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_469_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_470_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_471_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_472_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_473_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_474_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_475_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_476_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_477_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_478_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_479_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_480_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_481_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_482_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_483_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_484_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_485_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_486_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_487_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_488_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_489_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_490_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_491_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_492_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_493_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_494_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_495_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_496_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_497_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_498_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_499_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_500_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_501_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_502_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_503_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_504_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_505_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_506_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_507_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_508_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_509_Tdo === 1'bz)? 1'bz :0)       | 
               ((BC1500_Inst_510_Tdo === 1'bz)? 1'bz :0)       | 
//`endif




               ((BC1500_Wrck === 1'bz)? 1'bz :0) |
               ((BC1500_Wsi === 1'bz)? 1'bz :0) |
               ((BC1500_Sel_Wir === 1'bz)? 1'bz :0) |
               ((BC1500_Shift === 1'bz)? 1'bz :0) |
               ((BC1500_Capture === 1'bz)? 1'bz :0) |
               ((BC1500_Update === 1'bz)? 1'bz :0) |
               ((BC1500_Trstb === 1'bz)? 1'bz :0) |
               ((BC1500_Tlr === 1'bz)? 1'bz :0) |
               ((BC1500_Daisy_Wsi === 1'bz)? 1'bz :0) ;


`include "bc1500_assert_control.vh"
ovl_never_unknown #(
   .msg("BC1500 input pins are X/Z"))
assert_bc1500_input_unknown(
   .clock     (BC1500_Wrck),
   .reset     (BC1500_Trstb),
   .enable    (`BC1500_ABV_ALWAYS_EN),
   .qualifier (BC1500_Trstb),
   .test_expr (check_for_z),
   .fire      ());

`endif //ABV



endmodule
