
`include "gc_features.vh"
`include "grbm_defs.vh"
`include "gc__gc_cac_reg.v"

module se_cac
(
   input [  1:0]                       SE_STRAP_id,
   input                               Cpl_GFXCLK,
   input                               dft_shift_clk,
   input                               Dft_Clk_Gater_Aon,
   input                               Dft_Clk_Gater_En,
   input                               RSMU_GFX_hard_resetb,
   input                               GRBM_CAC_soft_resetb,
`ifdef GC__DLDO_POWER_GATING__1
	input								bpm_bpm_resetb,
`endif
   input [2:0]                         didt_throttle_level,

   input                               SE_CAC_MGCG_clock_cntl,
   input                               TEST_CLK_EN,
   input [2:0]                         RLC_DIDT_force_stall, 
   input  		                       SMU_DIDT_force_stall, 

   input                               GRBM_SE_CAC_reg_clken,
   input                               GRBM_SE_CAC_reg_send,
   input                               GRBM_SE_CAC_reg_op,
   input                               GRBM_SE_CAC_reg_priv,
   input [`GRBM_TARG_REG_VMID_RANGE]   GRBM_SE_CAC_reg_vmid,
   input                               GRBM_SE_CAC_reg_tmz,
   input [`GRBM_TARG_REG_MEID_RANGE]   GRBM_SE_CAC_reg_meid,
   input [`GRBM_TARG_REG_PIPEID_RANGE] GRBM_SE_CAC_reg_pipeid,
   input [`GRBM_TARG_REG_INDEX_RANGE]  GRBM_SE_CAC_reg_index,
   input [`GRBM_TARG_REG_ADDR_RANGE]   GRBM_SE_CAC_reg_addr,
   input [`GRBM_TARG_REG_WD_RANGE]     GRBM_SE_CAC_reg_wd,


   input                               SA0WGP00_TA0_CAC_sig0_active,
   input                               SA0WGP00_TA1_CAC_sig0_active,
   input                               SA0WGP01_TA0_CAC_sig0_active,
   input                               SA0WGP01_TA1_CAC_sig0_active,
   input                               SA0WGP02_TA0_CAC_sig0_active,
   input                               SA0WGP02_TA1_CAC_sig0_active,
   input                               SA1WGP00_TA0_CAC_sig0_active,
   input                               SA1WGP00_TA1_CAC_sig0_active,
   input                               SA1WGP01_TA0_CAC_sig0_active,
   input                               SA1WGP01_TA1_CAC_sig0_active,
   input                               SA1WGP02_TA0_CAC_sig0_active,
   input                               SA1WGP02_TA1_CAC_sig0_active,
   input                               SA0WGP00_TD0_CAC_sig0_active,
   input                               SA0WGP00_TD1_CAC_sig0_active,
   input                               SA0WGP00_TD0_CAC_sig1_active,
   input                               SA0WGP00_TD1_CAC_sig1_active,
   input                               SA0WGP00_TD0_CAC_sig2_active,
   input                               SA0WGP00_TD1_CAC_sig2_active,
   input                               SA0WGP00_TD0_CAC_sig3_active,
   input                               SA0WGP00_TD1_CAC_sig3_active,
   input                               SA0WGP00_TD0_CAC_sig4_active,
   input                               SA0WGP00_TD1_CAC_sig4_active,
   input                               SA0WGP00_TD0_CAC_sig5_active,
   input                               SA0WGP00_TD1_CAC_sig5_active,
   input                               SA0WGP00_TD0_CAC_sig6_active,
   input                               SA0WGP00_TD1_CAC_sig6_active,
   input                               SA0WGP00_TD0_CAC_sig7_active,
   input                               SA0WGP00_TD1_CAC_sig7_active,
   input                               SA0WGP00_TD0_CAC_sig8_active,
   input                               SA0WGP00_TD1_CAC_sig8_active,
   input                               SA0WGP00_TD0_CAC_sig9_active,
   input                               SA0WGP00_TD1_CAC_sig9_active,
   input                               SA0WGP01_TD0_CAC_sig0_active,
   input                               SA0WGP01_TD1_CAC_sig0_active,
   input                               SA0WGP01_TD0_CAC_sig1_active,
   input                               SA0WGP01_TD1_CAC_sig1_active,
   input                               SA0WGP01_TD0_CAC_sig2_active,
   input                               SA0WGP01_TD1_CAC_sig2_active,
   input                               SA0WGP01_TD0_CAC_sig3_active,
   input                               SA0WGP01_TD1_CAC_sig3_active,
   input                               SA0WGP01_TD0_CAC_sig4_active,
   input                               SA0WGP01_TD1_CAC_sig4_active,
   input                               SA0WGP01_TD0_CAC_sig5_active,
   input                               SA0WGP01_TD1_CAC_sig5_active,
   input                               SA0WGP01_TD0_CAC_sig6_active,
   input                               SA0WGP01_TD1_CAC_sig6_active,
   input                               SA0WGP01_TD0_CAC_sig7_active,
   input                               SA0WGP01_TD1_CAC_sig7_active,
   input                               SA0WGP01_TD0_CAC_sig8_active,
   input                               SA0WGP01_TD1_CAC_sig8_active,
   input                               SA0WGP01_TD0_CAC_sig9_active,
   input                               SA0WGP01_TD1_CAC_sig9_active,
   input                               SA0WGP02_TD0_CAC_sig0_active,
   input                               SA0WGP02_TD1_CAC_sig0_active,
   input                               SA0WGP02_TD0_CAC_sig1_active,
   input                               SA0WGP02_TD1_CAC_sig1_active,
   input                               SA0WGP02_TD0_CAC_sig2_active,
   input                               SA0WGP02_TD1_CAC_sig2_active,
   input                               SA0WGP02_TD0_CAC_sig3_active,
   input                               SA0WGP02_TD1_CAC_sig3_active,
   input                               SA0WGP02_TD0_CAC_sig4_active,
   input                               SA0WGP02_TD1_CAC_sig4_active,
   input                               SA0WGP02_TD0_CAC_sig5_active,
   input                               SA0WGP02_TD1_CAC_sig5_active,
   input                               SA0WGP02_TD0_CAC_sig6_active,
   input                               SA0WGP02_TD1_CAC_sig6_active,
   input                               SA0WGP02_TD0_CAC_sig7_active,
   input                               SA0WGP02_TD1_CAC_sig7_active,
   input                               SA0WGP02_TD0_CAC_sig8_active,
   input                               SA0WGP02_TD1_CAC_sig8_active,
   input                               SA0WGP02_TD0_CAC_sig9_active,
   input                               SA0WGP02_TD1_CAC_sig9_active,
   input                               SA1WGP00_TD0_CAC_sig0_active,
   input                               SA1WGP00_TD1_CAC_sig0_active,
   input                               SA1WGP00_TD0_CAC_sig1_active,
   input                               SA1WGP00_TD1_CAC_sig1_active,
   input                               SA1WGP00_TD0_CAC_sig2_active,
   input                               SA1WGP00_TD1_CAC_sig2_active,
   input                               SA1WGP00_TD0_CAC_sig3_active,
   input                               SA1WGP00_TD1_CAC_sig3_active,
   input                               SA1WGP00_TD0_CAC_sig4_active,
   input                               SA1WGP00_TD1_CAC_sig4_active,
   input                               SA1WGP00_TD0_CAC_sig5_active,
   input                               SA1WGP00_TD1_CAC_sig5_active,
   input                               SA1WGP00_TD0_CAC_sig6_active,
   input                               SA1WGP00_TD1_CAC_sig6_active,
   input                               SA1WGP00_TD0_CAC_sig7_active,
   input                               SA1WGP00_TD1_CAC_sig7_active,
   input                               SA1WGP00_TD0_CAC_sig8_active,
   input                               SA1WGP00_TD1_CAC_sig8_active,
   input                               SA1WGP00_TD0_CAC_sig9_active,
   input                               SA1WGP00_TD1_CAC_sig9_active,
   input                               SA1WGP01_TD0_CAC_sig0_active,
   input                               SA1WGP01_TD1_CAC_sig0_active,
   input                               SA1WGP01_TD0_CAC_sig1_active,
   input                               SA1WGP01_TD1_CAC_sig1_active,
   input                               SA1WGP01_TD0_CAC_sig2_active,
   input                               SA1WGP01_TD1_CAC_sig2_active,
   input                               SA1WGP01_TD0_CAC_sig3_active,
   input                               SA1WGP01_TD1_CAC_sig3_active,
   input                               SA1WGP01_TD0_CAC_sig4_active,
   input                               SA1WGP01_TD1_CAC_sig4_active,
   input                               SA1WGP01_TD0_CAC_sig5_active,
   input                               SA1WGP01_TD1_CAC_sig5_active,
   input                               SA1WGP01_TD0_CAC_sig6_active,
   input                               SA1WGP01_TD1_CAC_sig6_active,
   input                               SA1WGP01_TD0_CAC_sig7_active,
   input                               SA1WGP01_TD1_CAC_sig7_active,
   input                               SA1WGP01_TD0_CAC_sig8_active,
   input                               SA1WGP01_TD1_CAC_sig8_active,
   input                               SA1WGP01_TD0_CAC_sig9_active,
   input                               SA1WGP01_TD1_CAC_sig9_active,
   input                               SA1WGP02_TD0_CAC_sig0_active,
   input                               SA1WGP02_TD1_CAC_sig0_active,
   input                               SA1WGP02_TD0_CAC_sig1_active,
   input                               SA1WGP02_TD1_CAC_sig1_active,
   input                               SA1WGP02_TD0_CAC_sig2_active,
   input                               SA1WGP02_TD1_CAC_sig2_active,
   input                               SA1WGP02_TD0_CAC_sig3_active,
   input                               SA1WGP02_TD1_CAC_sig3_active,
   input                               SA1WGP02_TD0_CAC_sig4_active,
   input                               SA1WGP02_TD1_CAC_sig4_active,
   input                               SA1WGP02_TD0_CAC_sig5_active,
   input                               SA1WGP02_TD1_CAC_sig5_active,
   input                               SA1WGP02_TD0_CAC_sig6_active,
   input                               SA1WGP02_TD1_CAC_sig6_active,
   input                               SA1WGP02_TD0_CAC_sig7_active,
   input                               SA1WGP02_TD1_CAC_sig7_active,
   input                               SA1WGP02_TD0_CAC_sig8_active,
   input                               SA1WGP02_TD1_CAC_sig8_active,
   input                               SA1WGP02_TD0_CAC_sig9_active,
   input                               SA1WGP02_TD1_CAC_sig9_active,
   input                               SA0WGP00_TCP0_CAC_sig0_active,
   input                               SA0WGP00_TCP1_CAC_sig0_active,
   input                               SA0WGP00_TCP0_CAC_sig1_active,
   input                               SA0WGP00_TCP1_CAC_sig1_active,
   input                               SA0WGP00_TCP0_CAC_sig2_active,
   input                               SA0WGP00_TCP1_CAC_sig2_active,
   input                               SA0WGP00_TCP0_CAC_sig3_active,
   input                               SA0WGP00_TCP1_CAC_sig3_active,
   input                               SA0WGP00_TCP0_CAC_sig4_active,
   input                               SA0WGP00_TCP1_CAC_sig4_active,
   input                               SA0WGP01_TCP0_CAC_sig0_active,
   input                               SA0WGP01_TCP1_CAC_sig0_active,
   input                               SA0WGP01_TCP0_CAC_sig1_active,
   input                               SA0WGP01_TCP1_CAC_sig1_active,
   input                               SA0WGP01_TCP0_CAC_sig2_active,
   input                               SA0WGP01_TCP1_CAC_sig2_active,
   input                               SA0WGP01_TCP0_CAC_sig3_active,
   input                               SA0WGP01_TCP1_CAC_sig3_active,
   input                               SA0WGP01_TCP0_CAC_sig4_active,
   input                               SA0WGP01_TCP1_CAC_sig4_active,
   input                               SA0WGP02_TCP0_CAC_sig0_active,
   input                               SA0WGP02_TCP1_CAC_sig0_active,
   input                               SA0WGP02_TCP0_CAC_sig1_active,
   input                               SA0WGP02_TCP1_CAC_sig1_active,
   input                               SA0WGP02_TCP0_CAC_sig2_active,
   input                               SA0WGP02_TCP1_CAC_sig2_active,
   input                               SA0WGP02_TCP0_CAC_sig3_active,
   input                               SA0WGP02_TCP1_CAC_sig3_active,
   input                               SA0WGP02_TCP0_CAC_sig4_active,
   input                               SA0WGP02_TCP1_CAC_sig4_active,
   input                               SA1WGP00_TCP0_CAC_sig0_active,
   input                               SA1WGP00_TCP1_CAC_sig0_active,
   input                               SA1WGP00_TCP0_CAC_sig1_active,
   input                               SA1WGP00_TCP1_CAC_sig1_active,
   input                               SA1WGP00_TCP0_CAC_sig2_active,
   input                               SA1WGP00_TCP1_CAC_sig2_active,
   input                               SA1WGP00_TCP0_CAC_sig3_active,
   input                               SA1WGP00_TCP1_CAC_sig3_active,
   input                               SA1WGP00_TCP0_CAC_sig4_active,
   input                               SA1WGP00_TCP1_CAC_sig4_active,
   input                               SA1WGP01_TCP0_CAC_sig0_active,
   input                               SA1WGP01_TCP1_CAC_sig0_active,
   input                               SA1WGP01_TCP0_CAC_sig1_active,
   input                               SA1WGP01_TCP1_CAC_sig1_active,
   input                               SA1WGP01_TCP0_CAC_sig2_active,
   input                               SA1WGP01_TCP1_CAC_sig2_active,
   input                               SA1WGP01_TCP0_CAC_sig3_active,
   input                               SA1WGP01_TCP1_CAC_sig3_active,
   input                               SA1WGP01_TCP0_CAC_sig4_active,
   input                               SA1WGP01_TCP1_CAC_sig4_active,
   input                               SA1WGP02_TCP0_CAC_sig0_active,
   input                               SA1WGP02_TCP1_CAC_sig0_active,
   input                               SA1WGP02_TCP0_CAC_sig1_active,
   input                               SA1WGP02_TCP1_CAC_sig1_active,
   input                               SA1WGP02_TCP0_CAC_sig2_active,
   input                               SA1WGP02_TCP1_CAC_sig2_active,
   input                               SA1WGP02_TCP0_CAC_sig3_active,
   input                               SA1WGP02_TCP1_CAC_sig3_active,
   input                               SA1WGP02_TCP0_CAC_sig4_active,
   input                               SA1WGP02_TCP1_CAC_sig4_active,
   input                               SA0WGP00_SQ_CAC_sig0_active,
   input                               SA0WGP00_SQ_CAC_sig1_active,
   input                               SA0WGP00_SQ_CAC_sig2_active,
   input                               SA0WGP00_SQ_CAC_sig3_active,
   input                               SA0WGP00_SQ_CAC_sig4_active,
   input                               SA0WGP00_SQ_CAC_sig5_active,
   input                               SA0WGP01_SQ_CAC_sig0_active,
   input                               SA0WGP01_SQ_CAC_sig1_active,
   input                               SA0WGP01_SQ_CAC_sig2_active,
   input                               SA0WGP01_SQ_CAC_sig3_active,
   input                               SA0WGP01_SQ_CAC_sig4_active,
   input                               SA0WGP01_SQ_CAC_sig5_active,
   input                               SA0WGP02_SQ_CAC_sig0_active,
   input                               SA0WGP02_SQ_CAC_sig1_active,
   input                               SA0WGP02_SQ_CAC_sig2_active,
   input                               SA0WGP02_SQ_CAC_sig3_active,
   input                               SA0WGP02_SQ_CAC_sig4_active,
   input                               SA0WGP02_SQ_CAC_sig5_active,
   input                               SA1WGP00_SQ_CAC_sig0_active,
   input                               SA1WGP00_SQ_CAC_sig1_active,
   input                               SA1WGP00_SQ_CAC_sig2_active,
   input                               SA1WGP00_SQ_CAC_sig3_active,
   input                               SA1WGP00_SQ_CAC_sig4_active,
   input                               SA1WGP00_SQ_CAC_sig5_active,
   input                               SA1WGP01_SQ_CAC_sig0_active,
   input                               SA1WGP01_SQ_CAC_sig1_active,
   input                               SA1WGP01_SQ_CAC_sig2_active,
   input                               SA1WGP01_SQ_CAC_sig3_active,
   input                               SA1WGP01_SQ_CAC_sig4_active,
   input                               SA1WGP01_SQ_CAC_sig5_active,
   input                               SA1WGP02_SQ_CAC_sig0_active,
   input                               SA1WGP02_SQ_CAC_sig1_active,
   input                               SA1WGP02_SQ_CAC_sig2_active,
   input                               SA1WGP02_SQ_CAC_sig3_active,
   input                               SA1WGP02_SQ_CAC_sig4_active,
   input                               SA1WGP02_SQ_CAC_sig5_active,
   input                               SA0WGP00_LDS0_CAC_sig0_active,
   input                               SA0WGP00_LDS1_CAC_sig0_active,
   input                               SA0WGP00_LDS0_CAC_sig1_active,
   input                               SA0WGP00_LDS1_CAC_sig1_active,
   input                               SA0WGP00_LDS0_CAC_sig2_active,
   input                               SA0WGP00_LDS1_CAC_sig2_active,
   input                               SA0WGP00_LDS0_CAC_sig3_active,
   input                               SA0WGP00_LDS1_CAC_sig3_active,
   input                               SA0WGP01_LDS0_CAC_sig0_active,
   input                               SA0WGP01_LDS1_CAC_sig0_active,
   input                               SA0WGP01_LDS0_CAC_sig1_active,
   input                               SA0WGP01_LDS1_CAC_sig1_active,
   input                               SA0WGP01_LDS0_CAC_sig2_active,
   input                               SA0WGP01_LDS1_CAC_sig2_active,
   input                               SA0WGP01_LDS0_CAC_sig3_active,
   input                               SA0WGP01_LDS1_CAC_sig3_active,
   input                               SA0WGP02_LDS0_CAC_sig0_active,
   input                               SA0WGP02_LDS1_CAC_sig0_active,
   input                               SA0WGP02_LDS0_CAC_sig1_active,
   input                               SA0WGP02_LDS1_CAC_sig1_active,
   input                               SA0WGP02_LDS0_CAC_sig2_active,
   input                               SA0WGP02_LDS1_CAC_sig2_active,
   input                               SA0WGP02_LDS0_CAC_sig3_active,
   input                               SA0WGP02_LDS1_CAC_sig3_active,
   input                               SA1WGP00_LDS0_CAC_sig0_active,
   input                               SA1WGP00_LDS1_CAC_sig0_active,
   input                               SA1WGP00_LDS0_CAC_sig1_active,
   input                               SA1WGP00_LDS1_CAC_sig1_active,
   input                               SA1WGP00_LDS0_CAC_sig2_active,
   input                               SA1WGP00_LDS1_CAC_sig2_active,
   input                               SA1WGP00_LDS0_CAC_sig3_active,
   input                               SA1WGP00_LDS1_CAC_sig3_active,
   input                               SA1WGP01_LDS0_CAC_sig0_active,
   input                               SA1WGP01_LDS1_CAC_sig0_active,
   input                               SA1WGP01_LDS0_CAC_sig1_active,
   input                               SA1WGP01_LDS1_CAC_sig1_active,
   input                               SA1WGP01_LDS0_CAC_sig2_active,
   input                               SA1WGP01_LDS1_CAC_sig2_active,
   input                               SA1WGP01_LDS0_CAC_sig3_active,
   input                               SA1WGP01_LDS1_CAC_sig3_active,
   input                               SA1WGP02_LDS0_CAC_sig0_active,
   input                               SA1WGP02_LDS1_CAC_sig0_active,
   input                               SA1WGP02_LDS0_CAC_sig1_active,
   input                               SA1WGP02_LDS1_CAC_sig1_active,
   input                               SA1WGP02_LDS0_CAC_sig2_active,
   input                               SA1WGP02_LDS1_CAC_sig2_active,
   input                               SA1WGP02_LDS0_CAC_sig3_active,
   input                               SA1WGP02_LDS1_CAC_sig3_active,

   input                               SA0WGP10_TA0_CAC_sig0_active,
   input                               SA0WGP10_TA1_CAC_sig0_active,
   input                               SA0WGP11_TA0_CAC_sig0_active,
   input                               SA0WGP11_TA1_CAC_sig0_active,
   input                               SA1WGP10_TA0_CAC_sig0_active,
   input                               SA1WGP10_TA1_CAC_sig0_active,
   input                               SA1WGP11_TA0_CAC_sig0_active,
   input                               SA1WGP11_TA1_CAC_sig0_active,
   input                               SA0WGP10_TD0_CAC_sig0_active,
   input                               SA0WGP10_TD1_CAC_sig0_active,
   input                               SA0WGP10_TD0_CAC_sig1_active,
   input                               SA0WGP10_TD1_CAC_sig1_active,
   input                               SA0WGP10_TD0_CAC_sig2_active,
   input                               SA0WGP10_TD1_CAC_sig2_active,
   input                               SA0WGP10_TD0_CAC_sig3_active,
   input                               SA0WGP10_TD1_CAC_sig3_active,
   input                               SA0WGP10_TD0_CAC_sig4_active,
   input                               SA0WGP10_TD1_CAC_sig4_active,
   input                               SA0WGP10_TD0_CAC_sig5_active,
   input                               SA0WGP10_TD1_CAC_sig5_active,
   input                               SA0WGP10_TD0_CAC_sig6_active,
   input                               SA0WGP10_TD1_CAC_sig6_active,
   input                               SA0WGP10_TD0_CAC_sig7_active,
   input                               SA0WGP10_TD1_CAC_sig7_active,
   input                               SA0WGP10_TD0_CAC_sig8_active,
   input                               SA0WGP10_TD1_CAC_sig8_active,
   input                               SA0WGP10_TD0_CAC_sig9_active,
   input                               SA0WGP10_TD1_CAC_sig9_active,
   input                               SA0WGP11_TD0_CAC_sig0_active,
   input                               SA0WGP11_TD1_CAC_sig0_active,
   input                               SA0WGP11_TD0_CAC_sig1_active,
   input                               SA0WGP11_TD1_CAC_sig1_active,
   input                               SA0WGP11_TD0_CAC_sig2_active,
   input                               SA0WGP11_TD1_CAC_sig2_active,
   input                               SA0WGP11_TD0_CAC_sig3_active,
   input                               SA0WGP11_TD1_CAC_sig3_active,
   input                               SA0WGP11_TD0_CAC_sig4_active,
   input                               SA0WGP11_TD1_CAC_sig4_active,
   input                               SA0WGP11_TD0_CAC_sig5_active,
   input                               SA0WGP11_TD1_CAC_sig5_active,
   input                               SA0WGP11_TD0_CAC_sig6_active,
   input                               SA0WGP11_TD1_CAC_sig6_active,
   input                               SA0WGP11_TD0_CAC_sig7_active,
   input                               SA0WGP11_TD1_CAC_sig7_active,
   input                               SA0WGP11_TD0_CAC_sig8_active,
   input                               SA0WGP11_TD1_CAC_sig8_active,
   input                               SA0WGP11_TD0_CAC_sig9_active,
   input                               SA0WGP11_TD1_CAC_sig9_active,
   input                               SA1WGP10_TD0_CAC_sig0_active,
   input                               SA1WGP10_TD1_CAC_sig0_active,
   input                               SA1WGP10_TD0_CAC_sig1_active,
   input                               SA1WGP10_TD1_CAC_sig1_active,
   input                               SA1WGP10_TD0_CAC_sig2_active,
   input                               SA1WGP10_TD1_CAC_sig2_active,
   input                               SA1WGP10_TD0_CAC_sig3_active,
   input                               SA1WGP10_TD1_CAC_sig3_active,
   input                               SA1WGP10_TD0_CAC_sig4_active,
   input                               SA1WGP10_TD1_CAC_sig4_active,
   input                               SA1WGP10_TD0_CAC_sig5_active,
   input                               SA1WGP10_TD1_CAC_sig5_active,
   input                               SA1WGP10_TD0_CAC_sig6_active,
   input                               SA1WGP10_TD1_CAC_sig6_active,
   input                               SA1WGP10_TD0_CAC_sig7_active,
   input                               SA1WGP10_TD1_CAC_sig7_active,
   input                               SA1WGP10_TD0_CAC_sig8_active,
   input                               SA1WGP10_TD1_CAC_sig8_active,
   input                               SA1WGP10_TD0_CAC_sig9_active,
   input                               SA1WGP10_TD1_CAC_sig9_active,
   input                               SA1WGP11_TD0_CAC_sig0_active,
   input                               SA1WGP11_TD1_CAC_sig0_active,
   input                               SA1WGP11_TD0_CAC_sig1_active,
   input                               SA1WGP11_TD1_CAC_sig1_active,
   input                               SA1WGP11_TD0_CAC_sig2_active,
   input                               SA1WGP11_TD1_CAC_sig2_active,
   input                               SA1WGP11_TD0_CAC_sig3_active,
   input                               SA1WGP11_TD1_CAC_sig3_active,
   input                               SA1WGP11_TD0_CAC_sig4_active,
   input                               SA1WGP11_TD1_CAC_sig4_active,
   input                               SA1WGP11_TD0_CAC_sig5_active,
   input                               SA1WGP11_TD1_CAC_sig5_active,
   input                               SA1WGP11_TD0_CAC_sig6_active,
   input                               SA1WGP11_TD1_CAC_sig6_active,
   input                               SA1WGP11_TD0_CAC_sig7_active,
   input                               SA1WGP11_TD1_CAC_sig7_active,
   input                               SA1WGP11_TD0_CAC_sig8_active,
   input                               SA1WGP11_TD1_CAC_sig8_active,
   input                               SA1WGP11_TD0_CAC_sig9_active,
   input                               SA1WGP11_TD1_CAC_sig9_active,
   input                               SA0WGP10_TCP0_CAC_sig0_active,
   input                               SA0WGP10_TCP1_CAC_sig0_active,
   input                               SA0WGP10_TCP0_CAC_sig1_active,
   input                               SA0WGP10_TCP1_CAC_sig1_active,
   input                               SA0WGP10_TCP0_CAC_sig2_active,
   input                               SA0WGP10_TCP1_CAC_sig2_active,
   input                               SA0WGP10_TCP0_CAC_sig3_active,
   input                               SA0WGP10_TCP1_CAC_sig3_active,
   input                               SA0WGP10_TCP0_CAC_sig4_active,
   input                               SA0WGP10_TCP1_CAC_sig4_active,
   input                               SA0WGP11_TCP0_CAC_sig0_active,
   input                               SA0WGP11_TCP1_CAC_sig0_active,
   input                               SA0WGP11_TCP0_CAC_sig1_active,
   input                               SA0WGP11_TCP1_CAC_sig1_active,
   input                               SA0WGP11_TCP0_CAC_sig2_active,
   input                               SA0WGP11_TCP1_CAC_sig2_active,
   input                               SA0WGP11_TCP0_CAC_sig3_active,
   input                               SA0WGP11_TCP1_CAC_sig3_active,
   input                               SA0WGP11_TCP0_CAC_sig4_active,
   input                               SA0WGP11_TCP1_CAC_sig4_active,
   input                               SA1WGP10_TCP0_CAC_sig0_active,
   input                               SA1WGP10_TCP1_CAC_sig0_active,
   input                               SA1WGP10_TCP0_CAC_sig1_active,
   input                               SA1WGP10_TCP1_CAC_sig1_active,
   input                               SA1WGP10_TCP0_CAC_sig2_active,
   input                               SA1WGP10_TCP1_CAC_sig2_active,
   input                               SA1WGP10_TCP0_CAC_sig3_active,
   input                               SA1WGP10_TCP1_CAC_sig3_active,
   input                               SA1WGP10_TCP0_CAC_sig4_active,
   input                               SA1WGP10_TCP1_CAC_sig4_active,
   input                               SA1WGP11_TCP0_CAC_sig0_active,
   input                               SA1WGP11_TCP1_CAC_sig0_active,
   input                               SA1WGP11_TCP0_CAC_sig1_active,
   input                               SA1WGP11_TCP1_CAC_sig1_active,
   input                               SA1WGP11_TCP0_CAC_sig2_active,
   input                               SA1WGP11_TCP1_CAC_sig2_active,
   input                               SA1WGP11_TCP0_CAC_sig3_active,
   input                               SA1WGP11_TCP1_CAC_sig3_active,
   input                               SA1WGP11_TCP0_CAC_sig4_active,
   input                               SA1WGP11_TCP1_CAC_sig4_active,
   input                               SA0WGP10_SQ_CAC_sig0_active,
   input                               SA0WGP10_SQ_CAC_sig1_active,
   input                               SA0WGP10_SQ_CAC_sig2_active,
   input                               SA0WGP10_SQ_CAC_sig3_active,
   input                               SA0WGP10_SQ_CAC_sig4_active,
   input                               SA0WGP10_SQ_CAC_sig5_active,
   input                               SA0WGP11_SQ_CAC_sig0_active,
   input                               SA0WGP11_SQ_CAC_sig1_active,
   input                               SA0WGP11_SQ_CAC_sig2_active,
   input                               SA0WGP11_SQ_CAC_sig3_active,
   input                               SA0WGP11_SQ_CAC_sig4_active,
   input                               SA0WGP11_SQ_CAC_sig5_active,
   input                               SA1WGP10_SQ_CAC_sig0_active,
   input                               SA1WGP10_SQ_CAC_sig1_active,
   input                               SA1WGP10_SQ_CAC_sig2_active,
   input                               SA1WGP10_SQ_CAC_sig3_active,
   input                               SA1WGP10_SQ_CAC_sig4_active,
   input                               SA1WGP10_SQ_CAC_sig5_active,
   input                               SA1WGP11_SQ_CAC_sig0_active,
   input                               SA1WGP11_SQ_CAC_sig1_active,
   input                               SA1WGP11_SQ_CAC_sig2_active,
   input                               SA1WGP11_SQ_CAC_sig3_active,
   input                               SA1WGP11_SQ_CAC_sig4_active,
   input                               SA1WGP11_SQ_CAC_sig5_active,
   input                               SA0WGP10_LDS0_CAC_sig0_active,
   input                               SA0WGP10_LDS1_CAC_sig0_active,
   input                               SA0WGP10_LDS0_CAC_sig1_active,
   input                               SA0WGP10_LDS1_CAC_sig1_active,
   input                               SA0WGP10_LDS0_CAC_sig2_active,
   input                               SA0WGP10_LDS1_CAC_sig2_active,
   input                               SA0WGP10_LDS0_CAC_sig3_active,
   input                               SA0WGP10_LDS1_CAC_sig3_active,
   input                               SA0WGP11_LDS0_CAC_sig0_active,
   input                               SA0WGP11_LDS1_CAC_sig0_active,
   input                               SA0WGP11_LDS0_CAC_sig1_active,
   input                               SA0WGP11_LDS1_CAC_sig1_active,
   input                               SA0WGP11_LDS0_CAC_sig2_active,
   input                               SA0WGP11_LDS1_CAC_sig2_active,
   input                               SA0WGP11_LDS0_CAC_sig3_active,
   input                               SA0WGP11_LDS1_CAC_sig3_active,
   input                               SA1WGP10_LDS0_CAC_sig0_active,
   input                               SA1WGP10_LDS1_CAC_sig0_active,
   input                               SA1WGP10_LDS0_CAC_sig1_active,
   input                               SA1WGP10_LDS1_CAC_sig1_active,
   input                               SA1WGP10_LDS0_CAC_sig2_active,
   input                               SA1WGP10_LDS1_CAC_sig2_active,
   input                               SA1WGP10_LDS0_CAC_sig3_active,
   input                               SA1WGP10_LDS1_CAC_sig3_active,
   input                               SA1WGP11_LDS0_CAC_sig0_active,
   input                               SA1WGP11_LDS1_CAC_sig0_active,
   input                               SA1WGP11_LDS0_CAC_sig1_active,
   input                               SA1WGP11_LDS1_CAC_sig1_active,
   input                               SA1WGP11_LDS0_CAC_sig2_active,
   input                               SA1WGP11_LDS1_CAC_sig2_active,
   input                               SA1WGP11_LDS0_CAC_sig3_active,
   input                               SA1WGP11_LDS1_CAC_sig3_active,


   input                        SA0BCI_CAC_sig0_active,
   input                        SA0BCI_CAC_sig1_active,
   input                        SA1BCI_CAC_sig0_active,
   input                        SA1BCI_CAC_sig1_active,
   input                        SA0CB0_CAC_sig0_active,
   input                        SA0CB0_CAC_sig1_active,
   input                        SA0CB0_CAC_sig2_active,
   input                        SA0CB0_CAC_sig3_active,
   input                        SA0CB1_CAC_sig0_active,
   input                        SA0CB1_CAC_sig1_active,
   input                        SA0CB1_CAC_sig2_active,
   input                        SA0CB1_CAC_sig3_active,
   input                        SA0CB2_CAC_sig0_active,
   input                        SA0CB2_CAC_sig1_active,
   input                        SA0CB2_CAC_sig2_active,
   input                        SA0CB2_CAC_sig3_active,
   input                        SA0CB3_CAC_sig0_active,
   input                        SA0CB3_CAC_sig1_active,
   input                        SA0CB3_CAC_sig2_active,
   input                        SA0CB3_CAC_sig3_active,
   input                        SA1CB0_CAC_sig0_active,
   input                        SA1CB0_CAC_sig1_active,
   input                        SA1CB0_CAC_sig2_active,
   input                        SA1CB0_CAC_sig3_active,
   input                        SA1CB1_CAC_sig0_active,
   input                        SA1CB1_CAC_sig1_active,
   input                        SA1CB1_CAC_sig2_active,
   input                        SA1CB1_CAC_sig3_active,
   input                        SA1CB2_CAC_sig0_active,
   input                        SA1CB2_CAC_sig1_active,
   input                        SA1CB2_CAC_sig2_active,
   input                        SA1CB2_CAC_sig3_active,
   input                        SA1CB3_CAC_sig0_active,
   input                        SA1CB3_CAC_sig1_active,
   input                        SA1CB3_CAC_sig2_active,
   input                        SA1CB3_CAC_sig3_active,
   input                        SA0DB0_CAC_sig0_active,
   input                        SA0DB0_CAC_sig1_active,
   input                        SA0DB0_CAC_sig2_active,
   input                        SA0DB0_CAC_sig3_active,
   input                        SA0DB1_CAC_sig0_active,
   input                        SA0DB1_CAC_sig1_active,
   input                        SA0DB1_CAC_sig2_active,
   input                        SA0DB1_CAC_sig3_active,
   input                        SA0DB2_CAC_sig0_active,
   input                        SA0DB2_CAC_sig1_active,
   input                        SA0DB2_CAC_sig2_active,
   input                        SA0DB2_CAC_sig3_active,
   input                        SA0DB3_CAC_sig0_active,
   input                        SA0DB3_CAC_sig1_active,
   input                        SA0DB3_CAC_sig2_active,
   input                        SA0DB3_CAC_sig3_active,
   input                        SA1DB0_CAC_sig0_active,
   input                        SA1DB0_CAC_sig1_active,
   input                        SA1DB0_CAC_sig2_active,
   input                        SA1DB0_CAC_sig3_active,
   input                        SA1DB1_CAC_sig0_active,
   input                        SA1DB1_CAC_sig1_active,
   input                        SA1DB1_CAC_sig2_active,
   input                        SA1DB1_CAC_sig3_active,
   input                        SA1DB2_CAC_sig0_active,
   input                        SA1DB2_CAC_sig1_active,
   input                        SA1DB2_CAC_sig2_active,
   input                        SA1DB2_CAC_sig3_active,
   input                        SA1DB3_CAC_sig0_active,
   input                        SA1DB3_CAC_sig1_active,
   input                        SA1DB3_CAC_sig2_active,
   input                        SA1DB3_CAC_sig3_active,
   input                        SA0PA_CAC_sig0_active,
   input                        SA0PA_CAC_sig1_active,
   input                        SA1PA_CAC_sig0_active,
   input                        SA1PA_CAC_sig1_active,
   input                        SA0RMI0_CAC_sig0_active,
   input                        SA0RMI1_CAC_sig0_active,
   input                        SA1RMI0_CAC_sig0_active,
   input                        SA1RMI1_CAC_sig0_active,
   input                        SA0SC_CAC_sig0_active,
   input                        SA1SC_CAC_sig0_active,
   input                        SA0SX_CAC_sig0_active,
   input                        SA1SX_CAC_sig0_active,
   input                        SA0SXRB0_CAC_sig0_active,
   input                        SA0SXRB1_CAC_sig0_active,
   input                        SA0SXRB2_CAC_sig0_active,
   input                        SA0SXRB3_CAC_sig0_active,
   input                        SA1SXRB0_CAC_sig0_active,
   input                        SA1SXRB1_CAC_sig0_active,
   input                        SA1SXRB2_CAC_sig0_active,
   input                        SA1SXRB3_CAC_sig0_active,
   input                        SA0UTCL1_CAC_sig0_active,
   input                        SA1UTCL1_CAC_sig0_active,
   input                               SA0WGP00_CU0_CAC_sig0_active,
   input                               SA0WGP01_CU0_CAC_sig0_active,
   input                               SA0WGP02_CU0_CAC_sig0_active,
   input                               SA0WGP10_CU0_CAC_sig0_active,
   input                               SA0WGP11_CU0_CAC_sig0_active,
   input                               SA1WGP00_CU0_CAC_sig0_active,
   input                               SA1WGP01_CU0_CAC_sig0_active,
   input                               SA1WGP02_CU0_CAC_sig0_active,
   input                               SA1WGP10_CU0_CAC_sig0_active,
   input                               SA1WGP11_CU0_CAC_sig0_active,
   input                               SA0WGP00_CU1_CAC_sig0_active,
   input                               SA0WGP01_CU1_CAC_sig0_active,
   input                               SA0WGP02_CU1_CAC_sig0_active,
   input                               SA0WGP10_CU1_CAC_sig0_active,
   input                               SA0WGP11_CU1_CAC_sig0_active,
   input                               SA1WGP00_CU1_CAC_sig0_active,
   input                               SA1WGP01_CU1_CAC_sig0_active,
   input                               SA1WGP02_CU1_CAC_sig0_active,
   input                               SA1WGP10_CU1_CAC_sig0_active,
   input                               SA1WGP11_CU1_CAC_sig0_active,
   input                               SPI_CAC_sig0_active,
   input                               SPI_CAC_sig1_active,
   input                               SPI_CAC_sig2_active,
   input                               SPI_CAC_sig3_active,
   input                               SPI_CAC_sig4_active,
   input                               SPI_CAC_sig5_active,
   input                               PC_CAC_sig0_active,

	input wire				SE_CAC_dyn_busy,


   output wire                         SA0_CAC_TA_sig0_active_comb,
   output wire                         SA1_CAC_TA_sig0_active_comb,
   output wire                         SA0_CAC_TD_sig0_active_comb,
   output wire                         SA1_CAC_TD_sig0_active_comb,
   output wire                         SA0_CAC_TD_sig1_active_comb,
   output wire                         SA1_CAC_TD_sig1_active_comb,
   output wire                         SA0_CAC_TD_sig2_active_comb,
   output wire                         SA1_CAC_TD_sig2_active_comb,
   output wire                         SA0_CAC_TD_sig3_active_comb,
   output wire                         SA1_CAC_TD_sig3_active_comb,
   output wire                         SA0_CAC_TD_sig4_active_comb,
   output wire                         SA1_CAC_TD_sig4_active_comb,
   output wire                         SA0_CAC_TD_sig5_active_comb,
   output wire                         SA1_CAC_TD_sig5_active_comb,
   output wire                         SA0_CAC_TD_sig6_active_comb,
   output wire                         SA1_CAC_TD_sig6_active_comb,
   output wire                         SA0_CAC_TD_sig7_active_comb,
   output wire                         SA1_CAC_TD_sig7_active_comb,
   output wire                         SA0_CAC_TD_sig8_active_comb,
   output wire                         SA1_CAC_TD_sig8_active_comb,
   output wire                         SA0_CAC_TD_sig9_active_comb,
   output wire                         SA1_CAC_TD_sig9_active_comb,
   output wire                         SA0_CAC_TCP_sig0_active_comb,
   output wire                         SA1_CAC_TCP_sig0_active_comb,
   output wire                         SA0_CAC_TCP_sig1_active_comb,
   output wire                         SA1_CAC_TCP_sig1_active_comb,
   output wire                         SA0_CAC_TCP_sig2_active_comb,
   output wire                         SA1_CAC_TCP_sig2_active_comb,
   output wire                         SA0_CAC_TCP_sig3_active_comb,
   output wire                         SA1_CAC_TCP_sig3_active_comb,
   output wire                         SA0_CAC_TCP_sig4_active_comb,
   output wire                         SA1_CAC_TCP_sig4_active_comb,
   output wire                         SA0_CAC_SQ_sig0_active_comb,
   output wire                         SA1_CAC_SQ_sig0_active_comb,
   output wire                         SA0_CAC_SQ_sig1_active_comb,
   output wire                         SA1_CAC_SQ_sig1_active_comb,
   output wire                         SA0_CAC_SQ_sig2_active_comb,
   output wire                         SA1_CAC_SQ_sig2_active_comb,
   output wire                         SA0_CAC_SQ_sig3_active_comb,
   output wire                         SA1_CAC_SQ_sig3_active_comb,
   output wire                         SA0_CAC_SQ_sig4_active_comb,
   output wire                         SA1_CAC_SQ_sig4_active_comb,
   output wire                         SA0_CAC_SQ_sig5_active_comb,
   output wire                         SA1_CAC_SQ_sig5_active_comb,
   output wire                         SA0_CAC_LDS_sig0_active_comb,
   output wire                         SA1_CAC_LDS_sig0_active_comb,
   output wire                         SA0_CAC_LDS_sig1_active_comb,
   output wire                         SA1_CAC_LDS_sig1_active_comb,
   output wire                         SA0_CAC_LDS_sig2_active_comb,
   output wire                         SA1_CAC_LDS_sig2_active_comb,
   output wire                         SA0_CAC_LDS_sig3_active_comb,
   output wire                         SA1_CAC_LDS_sig3_active_comb,

   output wire                         SA0_CAC_BCI_sig0_active_comb,
   output wire                         SA1_CAC_BCI_sig0_active_comb,
   output wire                         SA0_CAC_BCI_sig1_active_comb,
   output wire                         SA1_CAC_BCI_sig1_active_comb,
   output wire                         SA0_CAC_CB_sig0_active_comb,
   output wire                         SA1_CAC_CB_sig0_active_comb,
   output wire                         SA0_CAC_CB_sig1_active_comb,
   output wire                         SA1_CAC_CB_sig1_active_comb,
   output wire                         SA0_CAC_CB_sig2_active_comb,
   output wire                         SA1_CAC_CB_sig2_active_comb,
   output wire                         SA0_CAC_CB_sig3_active_comb,
   output wire                         SA1_CAC_CB_sig3_active_comb,
   output wire                         SA0_CAC_DB_sig0_active_comb,
   output wire                         SA1_CAC_DB_sig0_active_comb,
   output wire                         SA0_CAC_DB_sig1_active_comb,
   output wire                         SA1_CAC_DB_sig1_active_comb,
   output wire                         SA0_CAC_DB_sig2_active_comb,
   output wire                         SA1_CAC_DB_sig2_active_comb,
   output wire                         SA0_CAC_DB_sig3_active_comb,
   output wire                         SA1_CAC_DB_sig3_active_comb,
   output wire                         SA0_CAC_PA_sig0_active_comb,
   output wire                         SA1_CAC_PA_sig0_active_comb,
   output wire                         SA0_CAC_PA_sig1_active_comb,
   output wire                         SA1_CAC_PA_sig1_active_comb,
   output wire                         SA0_CAC_RMI_sig0_active_comb,
   output wire                         SA1_CAC_RMI_sig0_active_comb,
   output wire                         SA0_CAC_SC_sig0_active_comb,
   output wire                         SA1_CAC_SC_sig0_active_comb,
   output wire                         SA0_CAC_SX_sig0_active_comb,
   output wire                         SA1_CAC_SX_sig0_active_comb,
   output wire                         SA0_CAC_SXRB_sig0_active_comb,
   output wire                         SA1_CAC_SXRB_sig0_active_comb,
   output wire                         SA0_CAC_UTCL1_sig0_active_comb,
   output wire                         SA1_CAC_UTCL1_sig0_active_comb,

   output wire                         SA0_CAC_CU_sig0_active_comb,
   output wire                         SA1_CAC_CU_sig0_active_comb,
   output wire                         CAC_SPI_sig0_active_comb,
   output wire                         CAC_SPI_sig1_active_comb,
   output wire                         CAC_SPI_sig2_active_comb,
   output wire                         CAC_SPI_sig3_active_comb,
   output wire                         CAC_SPI_sig4_active_comb,
   output wire                         CAC_SPI_sig5_active_comb,
   output wire                         CAC_PC_sig0_active_comb,

   output wire                         DIDT_SA0_WGP00_SQ00_power_throttle_stall,
   output wire                         DIDT_SA0_WGP00_SQ01_power_throttle_stall,
   output wire                         DIDT_SA0_WGP00_SQ10_power_throttle_stall,
   output wire                         DIDT_SA0_WGP00_SQ11_power_throttle_stall,
   output wire                         DIDT_SA0_WGP01_SQ00_power_throttle_stall,
   output wire                         DIDT_SA0_WGP01_SQ01_power_throttle_stall,
   output wire                         DIDT_SA0_WGP01_SQ10_power_throttle_stall,
   output wire                         DIDT_SA0_WGP01_SQ11_power_throttle_stall,
   output wire                         DIDT_SA0_WGP02_SQ00_power_throttle_stall,
   output wire                         DIDT_SA0_WGP02_SQ01_power_throttle_stall,
   output wire                         DIDT_SA0_WGP02_SQ10_power_throttle_stall,
   output wire                         DIDT_SA0_WGP02_SQ11_power_throttle_stall,
   output wire                         DIDT_SA0_WGP10_SQ00_power_throttle_stall,
   output wire                         DIDT_SA0_WGP10_SQ01_power_throttle_stall,
   output wire                         DIDT_SA0_WGP10_SQ10_power_throttle_stall,
   output wire                         DIDT_SA0_WGP10_SQ11_power_throttle_stall,
   output wire                         DIDT_SA0_WGP11_SQ00_power_throttle_stall,
   output wire                         DIDT_SA0_WGP11_SQ01_power_throttle_stall,
   output wire                         DIDT_SA0_WGP11_SQ10_power_throttle_stall,
   output wire                         DIDT_SA0_WGP11_SQ11_power_throttle_stall,
   output wire                         DIDT_SA1_WGP00_SQ00_power_throttle_stall,
   output wire                         DIDT_SA1_WGP00_SQ01_power_throttle_stall,
   output wire                         DIDT_SA1_WGP00_SQ10_power_throttle_stall,
   output wire                         DIDT_SA1_WGP00_SQ11_power_throttle_stall,
   output wire                         DIDT_SA1_WGP01_SQ00_power_throttle_stall,
   output wire                         DIDT_SA1_WGP01_SQ01_power_throttle_stall,
   output wire                         DIDT_SA1_WGP01_SQ10_power_throttle_stall,
   output wire                         DIDT_SA1_WGP01_SQ11_power_throttle_stall,
   output wire                         DIDT_SA1_WGP02_SQ00_power_throttle_stall,
   output wire                         DIDT_SA1_WGP02_SQ01_power_throttle_stall,
   output wire                         DIDT_SA1_WGP02_SQ10_power_throttle_stall,
   output wire                         DIDT_SA1_WGP02_SQ11_power_throttle_stall,
   output wire                         DIDT_SA1_WGP10_SQ00_power_throttle_stall,
   output wire                         DIDT_SA1_WGP10_SQ01_power_throttle_stall,
   output wire                         DIDT_SA1_WGP10_SQ10_power_throttle_stall,
   output wire                         DIDT_SA1_WGP10_SQ11_power_throttle_stall,
   output wire                         DIDT_SA1_WGP11_SQ00_power_throttle_stall,
   output wire                         DIDT_SA1_WGP11_SQ01_power_throttle_stall,
   output wire                         DIDT_SA1_WGP11_SQ10_power_throttle_stall,
   output wire                         DIDT_SA1_WGP11_SQ11_power_throttle_stall,
   output wire                         DIDT_SA0_DB0_power_throttle_stall,
   output wire                         DIDT_SA1_DB0_power_throttle_stall,
   output wire                         DIDT_SA0_DB1_power_throttle_stall,
   output wire                         DIDT_SA1_DB1_power_throttle_stall,
   output wire                         DIDT_SA0_DB2_power_throttle_stall,
   output wire                         DIDT_SA1_DB2_power_throttle_stall,
   output wire                         DIDT_SA0_DB3_power_throttle_stall,
   output wire                         DIDT_SA1_DB3_power_throttle_stall,
   output wire                         DIDT_SA0_WGP00_TD0_power_throttle_stall,
   output wire                         DIDT_SA0_WGP00_TD1_power_throttle_stall,
   output wire                         DIDT_SA0_WGP01_TD0_power_throttle_stall,
   output wire                         DIDT_SA0_WGP01_TD1_power_throttle_stall,
   output wire                         DIDT_SA0_WGP02_TD0_power_throttle_stall,
   output wire                         DIDT_SA0_WGP02_TD1_power_throttle_stall,
   output wire                         DIDT_SA0_WGP10_TD0_power_throttle_stall,
   output wire                         DIDT_SA0_WGP10_TD1_power_throttle_stall,
   output wire                         DIDT_SA0_WGP11_TD0_power_throttle_stall,
   output wire                         DIDT_SA0_WGP11_TD1_power_throttle_stall,
   output wire                         DIDT_SA1_WGP00_TD0_power_throttle_stall,
   output wire                         DIDT_SA1_WGP00_TD1_power_throttle_stall,
   output wire                         DIDT_SA1_WGP01_TD0_power_throttle_stall,
   output wire                         DIDT_SA1_WGP01_TD1_power_throttle_stall,
   output wire                         DIDT_SA1_WGP02_TD0_power_throttle_stall,
   output wire                         DIDT_SA1_WGP02_TD1_power_throttle_stall,
   output wire                         DIDT_SA1_WGP10_TD0_power_throttle_stall,
   output wire                         DIDT_SA1_WGP10_TD1_power_throttle_stall,
   output wire                         DIDT_SA1_WGP11_TD0_power_throttle_stall,
   output wire                         DIDT_SA1_WGP11_TD1_power_throttle_stall,
   output wire                         DIDT_SA0_WGP00_TCP0_power_throttle_stall,
   output wire                         DIDT_SA0_WGP00_TCP1_power_throttle_stall,
   output wire                         DIDT_SA0_WGP01_TCP0_power_throttle_stall,
   output wire                         DIDT_SA0_WGP01_TCP1_power_throttle_stall,
   output wire                         DIDT_SA0_WGP02_TCP0_power_throttle_stall,
   output wire                         DIDT_SA0_WGP02_TCP1_power_throttle_stall,
   output wire                         DIDT_SA0_WGP10_TCP0_power_throttle_stall,
   output wire                         DIDT_SA0_WGP10_TCP1_power_throttle_stall,
   output wire                         DIDT_SA0_WGP11_TCP0_power_throttle_stall,
   output wire                         DIDT_SA0_WGP11_TCP1_power_throttle_stall,
   output wire                         DIDT_SA1_WGP00_TCP0_power_throttle_stall,
   output wire                         DIDT_SA1_WGP00_TCP1_power_throttle_stall,
   output wire                         DIDT_SA1_WGP01_TCP0_power_throttle_stall,
   output wire                         DIDT_SA1_WGP01_TCP1_power_throttle_stall,
   output wire                         DIDT_SA1_WGP02_TCP0_power_throttle_stall,
   output wire                         DIDT_SA1_WGP02_TCP1_power_throttle_stall,
   output wire                         DIDT_SA1_WGP10_TCP0_power_throttle_stall,
   output wire                         DIDT_SA1_WGP10_TCP1_power_throttle_stall,
   output wire                         DIDT_SA1_WGP11_TCP0_power_throttle_stall,
   output wire                         DIDT_SA1_WGP11_TCP1_power_throttle_stall,


   output wire[3:0]                     didt_SQ_power_level,
   input [2:0]                    	didt_SQ_stall_level,
   input [2:0]                    	edc_SQ_stall_level,
   output wire[3:0]                     didt_DB_power_level,
   input [2:0]                    	didt_DB_stall_level,
   input [2:0]                    	edc_DB_stall_level,
   output wire[3:0]                     didt_TD_power_level,
   input [2:0]                    	didt_TD_stall_level,
   input [2:0]                    	edc_TD_stall_level,
   output wire[3:0]                     didt_TCP_power_level,
   input [2:0]                    	didt_TCP_stall_level,
   input [2:0]                    	edc_TCP_stall_level,

	input							gc_se_stall,

	//debug bus IN/OUT
	output[31:0]							dbg_mux_Data,
	input									dbg_active,
	input [7:0]								dbg_blkid,
	input [35:0]							dbg_mux_SelLane,
	input									dbg_rst,

   output wire                              SE_CAC_TARG_reg_clken,
   output wire                              SE_CAC_TARG_reg_send,
   output wire                              SE_CAC_TARG_reg_op,
   output wire                              SE_CAC_TARG_reg_priv,
   output wire[`GRBM_TARG_REG_VMID_RANGE]   SE_CAC_TARG_reg_vmid,
   output wire                              SE_CAC_TARG_reg_tmz,
   output wire[`GRBM_TARG_REG_MEID_RANGE]   SE_CAC_TARG_reg_meid,
   output wire[`GRBM_TARG_REG_PIPEID_RANGE] SE_CAC_TARG_reg_pipeid,
   output wire[`GRBM_TARG_REG_INDEX_RANGE]  SE_CAC_TARG_reg_index,
   output wire[`GRBM_TARG_REG_ADDR_RANGE]   SE_CAC_TARG_reg_addr,
   output wire[`GRBM_TARG_REG_WD_RANGE]     SE_CAC_TARG_reg_wd,

   input  wire[`TARG_GRBM_SERREAD_DATA_RANGE] CAC_GRBM_serread_in_data,
   output wire[`TARG_GRBM_SERREAD_DATA_RANGE] CAC_GRBM_serread_data
  );

 wire                              reg_clk;
 wire                              reg_clk_vld;
 wire                              cac_sclk;

 wire                              reg_clken;
 wire                              reg_send;
 wire                              reg_op;
 wire                              reg_priv;
 wire [`GRBM_TARG_REG_ADDR_RANGE]  reg_addr;
 wire [`GRBM_TARG_REG_WD_RANGE]    reg_wd;
 wire [1:0]                        reg_se_index;
 wire [1:0]                        reg_sh_index;
 wire							   reg_instance_select;

 wire [`SE_CAC_CGTT_CLK_CTRL_REG_SIZE-1:0]  cgtt_clk_ctrl;
 wire [`GC_CAC_CTRL_2_SE_LCAC_ENABLE_SIZE-1:0]  se_lcac_enable;

 wire                              didt_read_valid;
 wire [`TARG_GRBM_READ_DATA_RANGE] didt_read_data;

 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_TA_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TA_sig0_threshold;
 wire [10-1:0]         SA0_TA_sig0_ovr_sel;
 wire [10-1:0]         SA0_TA_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_TA_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TA_sig0_threshold;
 wire [10-1:0]         SA1_TA_sig0_ovr_sel;
 wire [10-1:0]         SA1_TA_sig0_ovr_val;

 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_TD_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig0_threshold;
 wire [10-1:0]         SA0_TD_sig0_ovr_sel;
 wire [10-1:0]         SA0_TD_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_TD_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig0_threshold;
 wire [10-1:0]         SA1_TD_sig0_ovr_sel;
 wire [10-1:0]         SA1_TD_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_TD_sig1_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig1_threshold;
 wire [10-1:0]         SA0_TD_sig1_ovr_sel;
 wire [10-1:0]         SA0_TD_sig1_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_TD_sig1_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig1_threshold;
 wire [10-1:0]         SA1_TD_sig1_ovr_sel;
 wire [10-1:0]         SA1_TD_sig1_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_TD_sig2_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig2_threshold;
 wire [10-1:0]         SA0_TD_sig2_ovr_sel;
 wire [10-1:0]         SA0_TD_sig2_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_TD_sig2_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig2_threshold;
 wire [10-1:0]         SA1_TD_sig2_ovr_sel;
 wire [10-1:0]         SA1_TD_sig2_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_TD_sig3_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig3_threshold;
 wire [10-1:0]         SA0_TD_sig3_ovr_sel;
 wire [10-1:0]         SA0_TD_sig3_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_TD_sig3_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig3_threshold;
 wire [10-1:0]         SA1_TD_sig3_ovr_sel;
 wire [10-1:0]         SA1_TD_sig3_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_TD_sig4_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig4_threshold;
 wire [10-1:0]         SA0_TD_sig4_ovr_sel;
 wire [10-1:0]         SA0_TD_sig4_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_TD_sig4_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig4_threshold;
 wire [10-1:0]         SA1_TD_sig4_ovr_sel;
 wire [10-1:0]         SA1_TD_sig4_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_TD_sig5_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig5_threshold;
 wire [10-1:0]         SA0_TD_sig5_ovr_sel;
 wire [10-1:0]         SA0_TD_sig5_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_TD_sig5_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig5_threshold;
 wire [10-1:0]         SA1_TD_sig5_ovr_sel;
 wire [10-1:0]         SA1_TD_sig5_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_TD_sig6_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig6_threshold;
 wire [10-1:0]         SA0_TD_sig6_ovr_sel;
 wire [10-1:0]         SA0_TD_sig6_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_TD_sig6_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig6_threshold;
 wire [10-1:0]         SA1_TD_sig6_ovr_sel;
 wire [10-1:0]         SA1_TD_sig6_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_TD_sig7_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig7_threshold;
 wire [10-1:0]         SA0_TD_sig7_ovr_sel;
 wire [10-1:0]         SA0_TD_sig7_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_TD_sig7_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig7_threshold;
 wire [10-1:0]         SA1_TD_sig7_ovr_sel;
 wire [10-1:0]         SA1_TD_sig7_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_TD_sig8_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig8_threshold;
 wire [10-1:0]         SA0_TD_sig8_ovr_sel;
 wire [10-1:0]         SA0_TD_sig8_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_TD_sig8_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig8_threshold;
 wire [10-1:0]         SA1_TD_sig8_ovr_sel;
 wire [10-1:0]         SA1_TD_sig8_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_TD_sig9_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig9_threshold;
 wire [10-1:0]         SA0_TD_sig9_ovr_sel;
 wire [10-1:0]         SA0_TD_sig9_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_TD_sig9_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig9_threshold;
 wire [10-1:0]         SA1_TD_sig9_ovr_sel;
 wire [10-1:0]         SA1_TD_sig9_ovr_val;

 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_TCP_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TCP_sig0_threshold;
 wire [10-1:0]         SA0_TCP_sig0_ovr_sel;
 wire [10-1:0]         SA0_TCP_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_TCP_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TCP_sig0_threshold;
 wire [10-1:0]         SA1_TCP_sig0_ovr_sel;
 wire [10-1:0]         SA1_TCP_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_TCP_sig1_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TCP_sig1_threshold;
 wire [10-1:0]         SA0_TCP_sig1_ovr_sel;
 wire [10-1:0]         SA0_TCP_sig1_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_TCP_sig1_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TCP_sig1_threshold;
 wire [10-1:0]         SA1_TCP_sig1_ovr_sel;
 wire [10-1:0]         SA1_TCP_sig1_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_TCP_sig2_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TCP_sig2_threshold;
 wire [10-1:0]         SA0_TCP_sig2_ovr_sel;
 wire [10-1:0]         SA0_TCP_sig2_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_TCP_sig2_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TCP_sig2_threshold;
 wire [10-1:0]         SA1_TCP_sig2_ovr_sel;
 wire [10-1:0]         SA1_TCP_sig2_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_TCP_sig3_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TCP_sig3_threshold;
 wire [10-1:0]         SA0_TCP_sig3_ovr_sel;
 wire [10-1:0]         SA0_TCP_sig3_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_TCP_sig3_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TCP_sig3_threshold;
 wire [10-1:0]         SA1_TCP_sig3_ovr_sel;
 wire [10-1:0]         SA1_TCP_sig3_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_TCP_sig4_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TCP_sig4_threshold;
 wire [10-1:0]         SA0_TCP_sig4_ovr_sel;
 wire [10-1:0]         SA0_TCP_sig4_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_TCP_sig4_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TCP_sig4_threshold;
 wire [10-1:0]         SA1_TCP_sig4_ovr_sel;
 wire [10-1:0]         SA1_TCP_sig4_ovr_val;

 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_SQ_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SQ_sig0_threshold;
 wire [5-1:0]         SA0_SQ_sig0_ovr_sel;
 wire [5-1:0]         SA0_SQ_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_SQ_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SQ_sig0_threshold;
 wire [5-1:0]         SA1_SQ_sig0_ovr_sel;
 wire [5-1:0]         SA1_SQ_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_SQ_sig1_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SQ_sig1_threshold;
 wire [5-1:0]         SA0_SQ_sig1_ovr_sel;
 wire [5-1:0]         SA0_SQ_sig1_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_SQ_sig1_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SQ_sig1_threshold;
 wire [5-1:0]         SA1_SQ_sig1_ovr_sel;
 wire [5-1:0]         SA1_SQ_sig1_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_SQ_sig2_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SQ_sig2_threshold;
 wire [5-1:0]         SA0_SQ_sig2_ovr_sel;
 wire [5-1:0]         SA0_SQ_sig2_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_SQ_sig2_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SQ_sig2_threshold;
 wire [5-1:0]         SA1_SQ_sig2_ovr_sel;
 wire [5-1:0]         SA1_SQ_sig2_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_SQ_sig3_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SQ_sig3_threshold;
 wire [5-1:0]         SA0_SQ_sig3_ovr_sel;
 wire [5-1:0]         SA0_SQ_sig3_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_SQ_sig3_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SQ_sig3_threshold;
 wire [5-1:0]         SA1_SQ_sig3_ovr_sel;
 wire [5-1:0]         SA1_SQ_sig3_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_SQ_sig4_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SQ_sig4_threshold;
 wire [5-1:0]         SA0_SQ_sig4_ovr_sel;
 wire [5-1:0]         SA0_SQ_sig4_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_SQ_sig4_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SQ_sig4_threshold;
 wire [5-1:0]         SA1_SQ_sig4_ovr_sel;
 wire [5-1:0]         SA1_SQ_sig4_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_SQ_sig5_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SQ_sig5_threshold;
 wire [5-1:0]         SA0_SQ_sig5_ovr_sel;
 wire [5-1:0]         SA0_SQ_sig5_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_SQ_sig5_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SQ_sig5_threshold;
 wire [5-1:0]         SA1_SQ_sig5_ovr_sel;
 wire [5-1:0]         SA1_SQ_sig5_ovr_val;

 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_LDS_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_LDS_sig0_threshold;
 wire [10-1:0]         SA0_LDS_sig0_ovr_sel;
 wire [10-1:0]         SA0_LDS_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_LDS_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_LDS_sig0_threshold;
 wire [10-1:0]         SA1_LDS_sig0_ovr_sel;
 wire [10-1:0]         SA1_LDS_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_LDS_sig1_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_LDS_sig1_threshold;
 wire [10-1:0]         SA0_LDS_sig1_ovr_sel;
 wire [10-1:0]         SA0_LDS_sig1_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_LDS_sig1_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_LDS_sig1_threshold;
 wire [10-1:0]         SA1_LDS_sig1_ovr_sel;
 wire [10-1:0]         SA1_LDS_sig1_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_LDS_sig2_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_LDS_sig2_threshold;
 wire [10-1:0]         SA0_LDS_sig2_ovr_sel;
 wire [10-1:0]         SA0_LDS_sig2_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_LDS_sig2_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_LDS_sig2_threshold;
 wire [10-1:0]         SA1_LDS_sig2_ovr_sel;
 wire [10-1:0]         SA1_LDS_sig2_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_LDS_sig3_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_LDS_sig3_threshold;
 wire [10-1:0]         SA0_LDS_sig3_ovr_sel;
 wire [10-1:0]         SA0_LDS_sig3_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_LDS_sig3_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_LDS_sig3_threshold;
 wire [10-1:0]         SA1_LDS_sig3_ovr_sel;
 wire [10-1:0]         SA1_LDS_sig3_ovr_val;

 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_BCI_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_BCI_sig0_threshold;
 wire [1-1:0]         SA0_BCI_sig0_ovr_sel;
 wire [1-1:0]         SA0_BCI_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_BCI_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_BCI_sig0_threshold;
 wire [1-1:0]         SA1_BCI_sig0_ovr_sel;
 wire [1-1:0]         SA1_BCI_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_BCI_sig1_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_BCI_sig1_threshold;
 wire [1-1:0]         SA0_BCI_sig1_ovr_sel;
 wire [1-1:0]         SA0_BCI_sig1_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_BCI_sig1_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_BCI_sig1_threshold;
 wire [1-1:0]         SA1_BCI_sig1_ovr_sel;
 wire [1-1:0]         SA1_BCI_sig1_ovr_val;

 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_CB_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_CB_sig0_threshold;
 wire [4-1:0]         SA0_CB_sig0_ovr_sel;
 wire [4-1:0]         SA0_CB_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_CB_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_CB_sig0_threshold;
 wire [4-1:0]         SA1_CB_sig0_ovr_sel;
 wire [4-1:0]         SA1_CB_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_CB_sig1_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_CB_sig1_threshold;
 wire [4-1:0]         SA0_CB_sig1_ovr_sel;
 wire [4-1:0]         SA0_CB_sig1_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_CB_sig1_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_CB_sig1_threshold;
 wire [4-1:0]         SA1_CB_sig1_ovr_sel;
 wire [4-1:0]         SA1_CB_sig1_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_CB_sig2_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_CB_sig2_threshold;
 wire [4-1:0]         SA0_CB_sig2_ovr_sel;
 wire [4-1:0]         SA0_CB_sig2_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_CB_sig2_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_CB_sig2_threshold;
 wire [4-1:0]         SA1_CB_sig2_ovr_sel;
 wire [4-1:0]         SA1_CB_sig2_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_CB_sig3_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_CB_sig3_threshold;
 wire [4-1:0]         SA0_CB_sig3_ovr_sel;
 wire [4-1:0]         SA0_CB_sig3_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_CB_sig3_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_CB_sig3_threshold;
 wire [4-1:0]         SA1_CB_sig3_ovr_sel;
 wire [4-1:0]         SA1_CB_sig3_ovr_val;

 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_DB_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_DB_sig0_threshold;
 wire [4-1:0]         SA0_DB_sig0_ovr_sel;
 wire [4-1:0]         SA0_DB_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_DB_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_DB_sig0_threshold;
 wire [4-1:0]         SA1_DB_sig0_ovr_sel;
 wire [4-1:0]         SA1_DB_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_DB_sig1_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_DB_sig1_threshold;
 wire [4-1:0]         SA0_DB_sig1_ovr_sel;
 wire [4-1:0]         SA0_DB_sig1_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_DB_sig1_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_DB_sig1_threshold;
 wire [4-1:0]         SA1_DB_sig1_ovr_sel;
 wire [4-1:0]         SA1_DB_sig1_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_DB_sig2_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_DB_sig2_threshold;
 wire [4-1:0]         SA0_DB_sig2_ovr_sel;
 wire [4-1:0]         SA0_DB_sig2_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_DB_sig2_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_DB_sig2_threshold;
 wire [4-1:0]         SA1_DB_sig2_ovr_sel;
 wire [4-1:0]         SA1_DB_sig2_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_DB_sig3_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_DB_sig3_threshold;
 wire [4-1:0]         SA0_DB_sig3_ovr_sel;
 wire [4-1:0]         SA0_DB_sig3_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_DB_sig3_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_DB_sig3_threshold;
 wire [4-1:0]         SA1_DB_sig3_ovr_sel;
 wire [4-1:0]         SA1_DB_sig3_ovr_val;

 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_PA_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_PA_sig0_threshold;
 wire [1-1:0]         SA0_PA_sig0_ovr_sel;
 wire [1-1:0]         SA0_PA_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_PA_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_PA_sig0_threshold;
 wire [1-1:0]         SA1_PA_sig0_ovr_sel;
 wire [1-1:0]         SA1_PA_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_PA_sig1_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_PA_sig1_threshold;
 wire [1-1:0]         SA0_PA_sig1_ovr_sel;
 wire [1-1:0]         SA0_PA_sig1_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_PA_sig1_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_PA_sig1_threshold;
 wire [1-1:0]         SA1_PA_sig1_ovr_sel;
 wire [1-1:0]         SA1_PA_sig1_ovr_val;

 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_RMI_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_RMI_sig0_threshold;
 wire [2-1:0]         SA0_RMI_sig0_ovr_sel;
 wire [2-1:0]         SA0_RMI_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_RMI_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_RMI_sig0_threshold;
 wire [2-1:0]         SA1_RMI_sig0_ovr_sel;
 wire [2-1:0]         SA1_RMI_sig0_ovr_val;

 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_SC_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SC_sig0_threshold;
 wire [1-1:0]         SA0_SC_sig0_ovr_sel;
 wire [1-1:0]         SA0_SC_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_SC_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SC_sig0_threshold;
 wire [1-1:0]         SA1_SC_sig0_ovr_sel;
 wire [1-1:0]         SA1_SC_sig0_ovr_val;

 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_SX_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SX_sig0_threshold;
 wire [1-1:0]         SA0_SX_sig0_ovr_sel;
 wire [1-1:0]         SA0_SX_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_SX_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SX_sig0_threshold;
 wire [1-1:0]         SA1_SX_sig0_ovr_sel;
 wire [1-1:0]         SA1_SX_sig0_ovr_val;

 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_SXRB_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SXRB_sig0_threshold;
 wire [4-1:0]         SA0_SXRB_sig0_ovr_sel;
 wire [4-1:0]         SA0_SXRB_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_SXRB_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SXRB_sig0_threshold;
 wire [4-1:0]         SA1_SXRB_sig0_ovr_sel;
 wire [4-1:0]         SA1_SXRB_sig0_ovr_val;

 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_UTCL1_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_UTCL1_sig0_threshold;
 wire [1-1:0]         SA0_UTCL1_sig0_ovr_sel;
 wire [1-1:0]         SA0_UTCL1_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_UTCL1_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_UTCL1_sig0_threshold;
 wire [1-1:0]         SA1_UTCL1_sig0_ovr_sel;
 wire [1-1:0]         SA1_UTCL1_sig0_ovr_val;

 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA0_CU_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_CU_sig0_threshold;
 wire [10-1:0]         SA0_CU_sig0_ovr_sel;
 wire [10-1:0]         SA0_CU_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SA1_CU_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_CU_sig0_threshold;
 wire [10-1:0]         SA1_CU_sig0_ovr_sel;
 wire [10-1:0]         SA1_CU_sig0_ovr_val;

 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SPI_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SPI_sig0_threshold;
 wire [1-1:0]         SPI_sig0_ovr_sel;
 wire [1-1:0]         SPI_sig0_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SPI_sig1_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SPI_sig1_threshold;
 wire [1-1:0]         SPI_sig1_ovr_sel;
 wire [1-1:0]         SPI_sig1_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SPI_sig2_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SPI_sig2_threshold;
 wire [1-1:0]         SPI_sig2_ovr_sel;
 wire [1-1:0]         SPI_sig2_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SPI_sig3_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SPI_sig3_threshold;
 wire [1-1:0]         SPI_sig3_ovr_sel;
 wire [1-1:0]         SPI_sig3_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SPI_sig4_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SPI_sig4_threshold;
 wire [1-1:0]         SPI_sig4_ovr_sel;
 wire [1-1:0]         SPI_sig4_ovr_val;
 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             SPI_sig5_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SPI_sig5_threshold;
 wire [1-1:0]         SPI_sig5_ovr_sel;
 wire [1-1:0]         SPI_sig5_ovr_val;

 wire [`SE_CAC_CNTL_CAC_FORCE_DISABLE]             PC_sig0_force_disable;
 wire [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] PC_sig0_threshold;
 wire [1-1:0]         PC_sig0_ovr_sel;
 wire [1-1:0]         PC_sig0_ovr_val;


	wire[31:0]				   sa0_didt_SQ_dbg_out_0;
	wire[31:0]				   sa0_didt_SQ_dbg_out_1;
	wire[31:0]				   sa0_didt_SQ_dbg_out_2;
	wire[31:0]				   sa0_didt_SQ_dbg_out_3;
	wire[31:0]				   sa0_didt_DB_dbg_out_0;
	wire[31:0]				   sa0_didt_DB_dbg_out_1;
	wire[31:0]				   sa0_didt_DB_dbg_out_2;
	wire[31:0]				   sa0_didt_DB_dbg_out_3;
	wire[31:0]				   sa0_didt_TD_dbg_out_0;
	wire[31:0]				   sa0_didt_TD_dbg_out_1;
	wire[31:0]				   sa0_didt_TD_dbg_out_2;
	wire[31:0]				   sa0_didt_TD_dbg_out_3;
	wire[31:0]				   sa0_didt_TCP_dbg_out_0;
	wire[31:0]				   sa0_didt_TCP_dbg_out_1;
	wire[31:0]				   sa0_didt_TCP_dbg_out_2;
	wire[31:0]				   sa0_didt_TCP_dbg_out_3;
	wire[31:0]				   sa0_misc_dbg_out_0;
	wire[31:0]				   sa0_misc_dbg_out_1;
	wire[31:0]				   sa0_misc_dbg_out_2;

	wire[31:0]				   sa1_didt_SQ_dbg_out_0;
	wire[31:0]				   sa1_didt_SQ_dbg_out_1;
	wire[31:0]				   sa1_didt_SQ_dbg_out_2;
	wire[31:0]				   sa1_didt_SQ_dbg_out_3;
	wire[31:0]				   sa1_didt_DB_dbg_out_0;
	wire[31:0]				   sa1_didt_DB_dbg_out_1;
	wire[31:0]				   sa1_didt_DB_dbg_out_2;
	wire[31:0]				   sa1_didt_DB_dbg_out_3;
	wire[31:0]				   sa1_didt_TD_dbg_out_0;
	wire[31:0]				   sa1_didt_TD_dbg_out_1;
	wire[31:0]				   sa1_didt_TD_dbg_out_2;
	wire[31:0]				   sa1_didt_TD_dbg_out_3;
	wire[31:0]				   sa1_didt_TCP_dbg_out_0;
	wire[31:0]				   sa1_didt_TCP_dbg_out_1;
	wire[31:0]				   sa1_didt_TCP_dbg_out_2;
	wire[31:0]				   sa1_didt_TCP_dbg_out_3;
	wire[31:0]				   sa1_misc_dbg_out_0;
	wire[31:0]				   sa1_misc_dbg_out_1;
	wire[31:0]				   sa1_misc_dbg_out_2;


wire hard_resetb;
wire combined_resetb;
wire hard_resetb_pre;
wire combined_resetb_pre;
`ifdef GC__DLDO_POWER_GATING__1
wire bpm_bpm_resetb_q;
techind_sync_icd #(.depth (3)) bpm_reset_sync (.CKdst(oCpl_GFXCLK), .Dsrc(bpm_bpm_resetb), .Qdst(bpm_bpm_resetb_q),
                                 .SB(1'b1), .RB(1'b1), .FLUSH(1'b0), .CKsrc(1'b0), .EN(1'b1), .Qsrc(),
                                 .SC1(1'b0), .SC2(1'b0), .SE(1'b0), .SI(1'b0), .SO()
`ifdef ABV
                                 ,.InputChkDis(1'b0)
`endif
);

`endif

rst_combine_4 u_rst_combine ( 
 	// Outputs 
     .hard_resetb          	(hard_resetb_pre), 
     .combined_0_resetb     (combined_resetb_pre), 
     .combined_1_resetb     (), 
     .combined_2_resetb     (), 
     .combined_3_resetb     (), 
     // Inputs 
     .clk                  		(oCpl_GFXCLK), 
     .RCU_blk_hard_resetb  		(RSMU_GFX_hard_resetb), 
     .xRBM_blk_soft_0_resetb 	(GRBM_CAC_soft_resetb), 
     .xRBM_blk_soft_1_resetb 	(1'b1), 
     .xRBM_blk_soft_2_resetb 	(1'b1), 
     .xRBM_blk_soft_3_resetb 	(1'b1)
); 

`ifdef GC__DLDO_POWER_GATING__1
assign hard_resetb 		= hard_resetb_pre & bpm_bpm_resetb_q;
assign combined_resetb 	= combined_resetb_pre & bpm_bpm_resetb_q;
`else
assign hard_resetb 		= hard_resetb_pre;
assign combined_resetb 	= combined_resetb_pre;
`endif


wire SE_CAC_MGCG_clock_cntl_q;
techind_sync_icd #(.depth (3)) SE_CAC_MGCG_clock_cntl_sync (.CKdst(oCpl_GFXCLK), .Dsrc(SE_CAC_MGCG_clock_cntl), .Qdst(SE_CAC_MGCG_clock_cntl_q),
                                 .SB(1'b1), .RB(1'b1), .FLUSH(1'b0), .CKsrc(1'b0), .EN(1'b1), .Qsrc(),
                                 .SC1(1'b0), .SC2(1'b0), .SE(1'b0), .SI(1'b0), .SO()
`ifdef ABV
                                 ,.InputChkDis(1'b0)
`endif
);

wire SMU_DIDT_force_stall_q;
techind_sync_icd #(.depth (3)) SMU_DIDT_force_stall_sync (.CKdst(oCpl_GFXCLK), .Dsrc(SMU_DIDT_force_stall), .Qdst(SMU_DIDT_force_stall_q),
                                 .SB(1'b1), .RB(1'b1), .FLUSH(1'b0), .CKsrc(1'b0), .EN(1'b1), .Qsrc(),
                                 .SC1(1'b0), .SC2(1'b0), .SE(1'b0), .SI(1'b0), .SO()
`ifdef ABV
                                 ,.InputChkDis(1'b0)
`endif
);

//wire SE_CAC_dyn_busy_q;
//sync SE_CAC_dyn_busy_sync (
//	.CK		(oCpl_GFXCLK),
//	.D		(SE_CAC_dyn_busy),
//	.Q		(SE_CAC_dyn_busy_q)
//);

wire se_cac_sclk_en;
//assign se_cac_sclk_en = SE_CAC_dyn_busy_q || ~hard_resetb || ~combined_resetb;
assign se_cac_sclk_en = SE_CAC_dyn_busy || ~hard_resetb || ~combined_resetb;

gfx_cgtt_local_dft ucgtt_local_dft(
  .Cpl_GFXCLK(Cpl_GFXCLK),
  .core_busy(1'b1),
  .oclk(oCpl_GFXCLK),
  .dft_clk_gate_ctrl({Dft_Clk_Gater_En, Dft_Clk_Gater_Aon}),
  .dft_shift_clk(dft_shift_clk)
);

gfx_cgtt_local_dft u_se_cac_gfxclk_gater(
  .Cpl_GFXCLK(Cpl_GFXCLK),
  .core_busy(se_cac_sclk_en || cgtt_clk_ctrl[`SE_CAC_CGTT_CLK_CTRL_SOFT_OVERRIDE_DYN] || SE_CAC_MGCG_clock_cntl_q),
  .oclk(cac_sclk),
  .dft_clk_gate_ctrl({Dft_Clk_Gater_En, Dft_Clk_Gater_Aon}),
  .dft_shift_clk(dft_shift_clk)
);

wire reg_busy;
gfx_cgtt_local_dft u_se_cac_regclk_gater(
  .Cpl_GFXCLK(Cpl_GFXCLK),
  .core_busy(reg_busy || ~hard_resetb || ~combined_resetb || cgtt_clk_ctrl[`SE_CAC_CGTT_CLK_CTRL_SOFT_OVERRIDE_REG] || SE_CAC_MGCG_clock_cntl_q),
  .oclk(reg_clk),
  .dft_clk_gate_ctrl({Dft_Clk_Gater_En, Dft_Clk_Gater_Aon}),
  .dft_shift_clk(dft_shift_clk)
);


se_cac_rbiu cac_rbiu
(
   .sclk                 (oCpl_GFXCLK),
   .reg_sclk             (reg_clk),
   .combined_resetb      (combined_resetb),
   .hard_resetb          (hard_resetb),

   .SE_STRAP_id          (SE_STRAP_id),

   .GRBM_CAC_reg_clken   (GRBM_SE_CAC_reg_clken),
   .GRBM_CAC_reg_send    (GRBM_SE_CAC_reg_send),
   .GRBM_CAC_reg_op      (GRBM_SE_CAC_reg_op),
   .GRBM_CAC_reg_priv    (GRBM_SE_CAC_reg_priv),
   .GRBM_CAC_reg_vmid    (GRBM_SE_CAC_reg_vmid),
   .GRBM_CAC_reg_tmz     (GRBM_SE_CAC_reg_tmz),
   .GRBM_CAC_reg_meid    (GRBM_SE_CAC_reg_meid),
   .GRBM_CAC_reg_pipeid  (GRBM_SE_CAC_reg_pipeid),
   .GRBM_CAC_reg_index   (GRBM_SE_CAC_reg_index),
   .GRBM_CAC_reg_addr    (GRBM_SE_CAC_reg_addr),
   .GRBM_CAC_reg_wd      (GRBM_SE_CAC_reg_wd),

   .cgtt_clk_ctrl		 (cgtt_clk_ctrl),
   .se_lcac_enable       (se_lcac_enable),

   .didt_read_valid      (didt_read_valid),
   .didt_read_data       (didt_read_data),

   .SA0_TA_sig0_force_disable      (SA0_TA_sig0_force_disable),
   .SA0_TA_sig0_threshold   (SA0_TA_sig0_threshold),
   .SA0_TA_sig0_ovr_sel     (SA0_TA_sig0_ovr_sel),
   .SA0_TA_sig0_ovr_val     (SA0_TA_sig0_ovr_val),
   .SA1_TA_sig0_force_disable      (SA1_TA_sig0_force_disable),
   .SA1_TA_sig0_threshold   (SA1_TA_sig0_threshold),
   .SA1_TA_sig0_ovr_sel     (SA1_TA_sig0_ovr_sel),
   .SA1_TA_sig0_ovr_val     (SA1_TA_sig0_ovr_val),
   .SA0_TD_sig0_force_disable      (SA0_TD_sig0_force_disable),
   .SA0_TD_sig0_threshold   (SA0_TD_sig0_threshold),
   .SA0_TD_sig0_ovr_sel     (SA0_TD_sig0_ovr_sel),
   .SA0_TD_sig0_ovr_val     (SA0_TD_sig0_ovr_val),
   .SA1_TD_sig0_force_disable      (SA1_TD_sig0_force_disable),
   .SA1_TD_sig0_threshold   (SA1_TD_sig0_threshold),
   .SA1_TD_sig0_ovr_sel     (SA1_TD_sig0_ovr_sel),
   .SA1_TD_sig0_ovr_val     (SA1_TD_sig0_ovr_val),
   .SA0_TD_sig1_force_disable      (SA0_TD_sig1_force_disable),
   .SA0_TD_sig1_threshold   (SA0_TD_sig1_threshold),
   .SA0_TD_sig1_ovr_sel     (SA0_TD_sig1_ovr_sel),
   .SA0_TD_sig1_ovr_val     (SA0_TD_sig1_ovr_val),
   .SA1_TD_sig1_force_disable      (SA1_TD_sig1_force_disable),
   .SA1_TD_sig1_threshold   (SA1_TD_sig1_threshold),
   .SA1_TD_sig1_ovr_sel     (SA1_TD_sig1_ovr_sel),
   .SA1_TD_sig1_ovr_val     (SA1_TD_sig1_ovr_val),
   .SA0_TD_sig2_force_disable      (SA0_TD_sig2_force_disable),
   .SA0_TD_sig2_threshold   (SA0_TD_sig2_threshold),
   .SA0_TD_sig2_ovr_sel     (SA0_TD_sig2_ovr_sel),
   .SA0_TD_sig2_ovr_val     (SA0_TD_sig2_ovr_val),
   .SA1_TD_sig2_force_disable      (SA1_TD_sig2_force_disable),
   .SA1_TD_sig2_threshold   (SA1_TD_sig2_threshold),
   .SA1_TD_sig2_ovr_sel     (SA1_TD_sig2_ovr_sel),
   .SA1_TD_sig2_ovr_val     (SA1_TD_sig2_ovr_val),
   .SA0_TD_sig3_force_disable      (SA0_TD_sig3_force_disable),
   .SA0_TD_sig3_threshold   (SA0_TD_sig3_threshold),
   .SA0_TD_sig3_ovr_sel     (SA0_TD_sig3_ovr_sel),
   .SA0_TD_sig3_ovr_val     (SA0_TD_sig3_ovr_val),
   .SA1_TD_sig3_force_disable      (SA1_TD_sig3_force_disable),
   .SA1_TD_sig3_threshold   (SA1_TD_sig3_threshold),
   .SA1_TD_sig3_ovr_sel     (SA1_TD_sig3_ovr_sel),
   .SA1_TD_sig3_ovr_val     (SA1_TD_sig3_ovr_val),
   .SA0_TD_sig4_force_disable      (SA0_TD_sig4_force_disable),
   .SA0_TD_sig4_threshold   (SA0_TD_sig4_threshold),
   .SA0_TD_sig4_ovr_sel     (SA0_TD_sig4_ovr_sel),
   .SA0_TD_sig4_ovr_val     (SA0_TD_sig4_ovr_val),
   .SA1_TD_sig4_force_disable      (SA1_TD_sig4_force_disable),
   .SA1_TD_sig4_threshold   (SA1_TD_sig4_threshold),
   .SA1_TD_sig4_ovr_sel     (SA1_TD_sig4_ovr_sel),
   .SA1_TD_sig4_ovr_val     (SA1_TD_sig4_ovr_val),
   .SA0_TD_sig5_force_disable      (SA0_TD_sig5_force_disable),
   .SA0_TD_sig5_threshold   (SA0_TD_sig5_threshold),
   .SA0_TD_sig5_ovr_sel     (SA0_TD_sig5_ovr_sel),
   .SA0_TD_sig5_ovr_val     (SA0_TD_sig5_ovr_val),
   .SA1_TD_sig5_force_disable      (SA1_TD_sig5_force_disable),
   .SA1_TD_sig5_threshold   (SA1_TD_sig5_threshold),
   .SA1_TD_sig5_ovr_sel     (SA1_TD_sig5_ovr_sel),
   .SA1_TD_sig5_ovr_val     (SA1_TD_sig5_ovr_val),
   .SA0_TD_sig6_force_disable      (SA0_TD_sig6_force_disable),
   .SA0_TD_sig6_threshold   (SA0_TD_sig6_threshold),
   .SA0_TD_sig6_ovr_sel     (SA0_TD_sig6_ovr_sel),
   .SA0_TD_sig6_ovr_val     (SA0_TD_sig6_ovr_val),
   .SA1_TD_sig6_force_disable      (SA1_TD_sig6_force_disable),
   .SA1_TD_sig6_threshold   (SA1_TD_sig6_threshold),
   .SA1_TD_sig6_ovr_sel     (SA1_TD_sig6_ovr_sel),
   .SA1_TD_sig6_ovr_val     (SA1_TD_sig6_ovr_val),
   .SA0_TD_sig7_force_disable      (SA0_TD_sig7_force_disable),
   .SA0_TD_sig7_threshold   (SA0_TD_sig7_threshold),
   .SA0_TD_sig7_ovr_sel     (SA0_TD_sig7_ovr_sel),
   .SA0_TD_sig7_ovr_val     (SA0_TD_sig7_ovr_val),
   .SA1_TD_sig7_force_disable      (SA1_TD_sig7_force_disable),
   .SA1_TD_sig7_threshold   (SA1_TD_sig7_threshold),
   .SA1_TD_sig7_ovr_sel     (SA1_TD_sig7_ovr_sel),
   .SA1_TD_sig7_ovr_val     (SA1_TD_sig7_ovr_val),
   .SA0_TD_sig8_force_disable      (SA0_TD_sig8_force_disable),
   .SA0_TD_sig8_threshold   (SA0_TD_sig8_threshold),
   .SA0_TD_sig8_ovr_sel     (SA0_TD_sig8_ovr_sel),
   .SA0_TD_sig8_ovr_val     (SA0_TD_sig8_ovr_val),
   .SA1_TD_sig8_force_disable      (SA1_TD_sig8_force_disable),
   .SA1_TD_sig8_threshold   (SA1_TD_sig8_threshold),
   .SA1_TD_sig8_ovr_sel     (SA1_TD_sig8_ovr_sel),
   .SA1_TD_sig8_ovr_val     (SA1_TD_sig8_ovr_val),
   .SA0_TD_sig9_force_disable      (SA0_TD_sig9_force_disable),
   .SA0_TD_sig9_threshold   (SA0_TD_sig9_threshold),
   .SA0_TD_sig9_ovr_sel     (SA0_TD_sig9_ovr_sel),
   .SA0_TD_sig9_ovr_val     (SA0_TD_sig9_ovr_val),
   .SA1_TD_sig9_force_disable      (SA1_TD_sig9_force_disable),
   .SA1_TD_sig9_threshold   (SA1_TD_sig9_threshold),
   .SA1_TD_sig9_ovr_sel     (SA1_TD_sig9_ovr_sel),
   .SA1_TD_sig9_ovr_val     (SA1_TD_sig9_ovr_val),
   .SA0_TCP_sig0_force_disable      (SA0_TCP_sig0_force_disable),
   .SA0_TCP_sig0_threshold   (SA0_TCP_sig0_threshold),
   .SA0_TCP_sig0_ovr_sel     (SA0_TCP_sig0_ovr_sel),
   .SA0_TCP_sig0_ovr_val     (SA0_TCP_sig0_ovr_val),
   .SA1_TCP_sig0_force_disable      (SA1_TCP_sig0_force_disable),
   .SA1_TCP_sig0_threshold   (SA1_TCP_sig0_threshold),
   .SA1_TCP_sig0_ovr_sel     (SA1_TCP_sig0_ovr_sel),
   .SA1_TCP_sig0_ovr_val     (SA1_TCP_sig0_ovr_val),
   .SA0_TCP_sig1_force_disable      (SA0_TCP_sig1_force_disable),
   .SA0_TCP_sig1_threshold   (SA0_TCP_sig1_threshold),
   .SA0_TCP_sig1_ovr_sel     (SA0_TCP_sig1_ovr_sel),
   .SA0_TCP_sig1_ovr_val     (SA0_TCP_sig1_ovr_val),
   .SA1_TCP_sig1_force_disable      (SA1_TCP_sig1_force_disable),
   .SA1_TCP_sig1_threshold   (SA1_TCP_sig1_threshold),
   .SA1_TCP_sig1_ovr_sel     (SA1_TCP_sig1_ovr_sel),
   .SA1_TCP_sig1_ovr_val     (SA1_TCP_sig1_ovr_val),
   .SA0_TCP_sig2_force_disable      (SA0_TCP_sig2_force_disable),
   .SA0_TCP_sig2_threshold   (SA0_TCP_sig2_threshold),
   .SA0_TCP_sig2_ovr_sel     (SA0_TCP_sig2_ovr_sel),
   .SA0_TCP_sig2_ovr_val     (SA0_TCP_sig2_ovr_val),
   .SA1_TCP_sig2_force_disable      (SA1_TCP_sig2_force_disable),
   .SA1_TCP_sig2_threshold   (SA1_TCP_sig2_threshold),
   .SA1_TCP_sig2_ovr_sel     (SA1_TCP_sig2_ovr_sel),
   .SA1_TCP_sig2_ovr_val     (SA1_TCP_sig2_ovr_val),
   .SA0_TCP_sig3_force_disable      (SA0_TCP_sig3_force_disable),
   .SA0_TCP_sig3_threshold   (SA0_TCP_sig3_threshold),
   .SA0_TCP_sig3_ovr_sel     (SA0_TCP_sig3_ovr_sel),
   .SA0_TCP_sig3_ovr_val     (SA0_TCP_sig3_ovr_val),
   .SA1_TCP_sig3_force_disable      (SA1_TCP_sig3_force_disable),
   .SA1_TCP_sig3_threshold   (SA1_TCP_sig3_threshold),
   .SA1_TCP_sig3_ovr_sel     (SA1_TCP_sig3_ovr_sel),
   .SA1_TCP_sig3_ovr_val     (SA1_TCP_sig3_ovr_val),
   .SA0_TCP_sig4_force_disable      (SA0_TCP_sig4_force_disable),
   .SA0_TCP_sig4_threshold   (SA0_TCP_sig4_threshold),
   .SA0_TCP_sig4_ovr_sel     (SA0_TCP_sig4_ovr_sel),
   .SA0_TCP_sig4_ovr_val     (SA0_TCP_sig4_ovr_val),
   .SA1_TCP_sig4_force_disable      (SA1_TCP_sig4_force_disable),
   .SA1_TCP_sig4_threshold   (SA1_TCP_sig4_threshold),
   .SA1_TCP_sig4_ovr_sel     (SA1_TCP_sig4_ovr_sel),
   .SA1_TCP_sig4_ovr_val     (SA1_TCP_sig4_ovr_val),
   .SA0_SQ_sig0_force_disable      (SA0_SQ_sig0_force_disable),
   .SA0_SQ_sig0_threshold   (SA0_SQ_sig0_threshold),
   .SA0_SQ_sig0_ovr_sel     (SA0_SQ_sig0_ovr_sel),
   .SA0_SQ_sig0_ovr_val     (SA0_SQ_sig0_ovr_val),
   .SA1_SQ_sig0_force_disable      (SA1_SQ_sig0_force_disable),
   .SA1_SQ_sig0_threshold   (SA1_SQ_sig0_threshold),
   .SA1_SQ_sig0_ovr_sel     (SA1_SQ_sig0_ovr_sel),
   .SA1_SQ_sig0_ovr_val     (SA1_SQ_sig0_ovr_val),
   .SA0_SQ_sig1_force_disable      (SA0_SQ_sig1_force_disable),
   .SA0_SQ_sig1_threshold   (SA0_SQ_sig1_threshold),
   .SA0_SQ_sig1_ovr_sel     (SA0_SQ_sig1_ovr_sel),
   .SA0_SQ_sig1_ovr_val     (SA0_SQ_sig1_ovr_val),
   .SA1_SQ_sig1_force_disable      (SA1_SQ_sig1_force_disable),
   .SA1_SQ_sig1_threshold   (SA1_SQ_sig1_threshold),
   .SA1_SQ_sig1_ovr_sel     (SA1_SQ_sig1_ovr_sel),
   .SA1_SQ_sig1_ovr_val     (SA1_SQ_sig1_ovr_val),
   .SA0_SQ_sig2_force_disable      (SA0_SQ_sig2_force_disable),
   .SA0_SQ_sig2_threshold   (SA0_SQ_sig2_threshold),
   .SA0_SQ_sig2_ovr_sel     (SA0_SQ_sig2_ovr_sel),
   .SA0_SQ_sig2_ovr_val     (SA0_SQ_sig2_ovr_val),
   .SA1_SQ_sig2_force_disable      (SA1_SQ_sig2_force_disable),
   .SA1_SQ_sig2_threshold   (SA1_SQ_sig2_threshold),
   .SA1_SQ_sig2_ovr_sel     (SA1_SQ_sig2_ovr_sel),
   .SA1_SQ_sig2_ovr_val     (SA1_SQ_sig2_ovr_val),
   .SA0_SQ_sig3_force_disable      (SA0_SQ_sig3_force_disable),
   .SA0_SQ_sig3_threshold   (SA0_SQ_sig3_threshold),
   .SA0_SQ_sig3_ovr_sel     (SA0_SQ_sig3_ovr_sel),
   .SA0_SQ_sig3_ovr_val     (SA0_SQ_sig3_ovr_val),
   .SA1_SQ_sig3_force_disable      (SA1_SQ_sig3_force_disable),
   .SA1_SQ_sig3_threshold   (SA1_SQ_sig3_threshold),
   .SA1_SQ_sig3_ovr_sel     (SA1_SQ_sig3_ovr_sel),
   .SA1_SQ_sig3_ovr_val     (SA1_SQ_sig3_ovr_val),
   .SA0_SQ_sig4_force_disable      (SA0_SQ_sig4_force_disable),
   .SA0_SQ_sig4_threshold   (SA0_SQ_sig4_threshold),
   .SA0_SQ_sig4_ovr_sel     (SA0_SQ_sig4_ovr_sel),
   .SA0_SQ_sig4_ovr_val     (SA0_SQ_sig4_ovr_val),
   .SA1_SQ_sig4_force_disable      (SA1_SQ_sig4_force_disable),
   .SA1_SQ_sig4_threshold   (SA1_SQ_sig4_threshold),
   .SA1_SQ_sig4_ovr_sel     (SA1_SQ_sig4_ovr_sel),
   .SA1_SQ_sig4_ovr_val     (SA1_SQ_sig4_ovr_val),
   .SA0_SQ_sig5_force_disable      (SA0_SQ_sig5_force_disable),
   .SA0_SQ_sig5_threshold   (SA0_SQ_sig5_threshold),
   .SA0_SQ_sig5_ovr_sel     (SA0_SQ_sig5_ovr_sel),
   .SA0_SQ_sig5_ovr_val     (SA0_SQ_sig5_ovr_val),
   .SA1_SQ_sig5_force_disable      (SA1_SQ_sig5_force_disable),
   .SA1_SQ_sig5_threshold   (SA1_SQ_sig5_threshold),
   .SA1_SQ_sig5_ovr_sel     (SA1_SQ_sig5_ovr_sel),
   .SA1_SQ_sig5_ovr_val     (SA1_SQ_sig5_ovr_val),
   .SA0_LDS_sig0_force_disable      (SA0_LDS_sig0_force_disable),
   .SA0_LDS_sig0_threshold   (SA0_LDS_sig0_threshold),
   .SA0_LDS_sig0_ovr_sel     (SA0_LDS_sig0_ovr_sel),
   .SA0_LDS_sig0_ovr_val     (SA0_LDS_sig0_ovr_val),
   .SA1_LDS_sig0_force_disable      (SA1_LDS_sig0_force_disable),
   .SA1_LDS_sig0_threshold   (SA1_LDS_sig0_threshold),
   .SA1_LDS_sig0_ovr_sel     (SA1_LDS_sig0_ovr_sel),
   .SA1_LDS_sig0_ovr_val     (SA1_LDS_sig0_ovr_val),
   .SA0_LDS_sig1_force_disable      (SA0_LDS_sig1_force_disable),
   .SA0_LDS_sig1_threshold   (SA0_LDS_sig1_threshold),
   .SA0_LDS_sig1_ovr_sel     (SA0_LDS_sig1_ovr_sel),
   .SA0_LDS_sig1_ovr_val     (SA0_LDS_sig1_ovr_val),
   .SA1_LDS_sig1_force_disable      (SA1_LDS_sig1_force_disable),
   .SA1_LDS_sig1_threshold   (SA1_LDS_sig1_threshold),
   .SA1_LDS_sig1_ovr_sel     (SA1_LDS_sig1_ovr_sel),
   .SA1_LDS_sig1_ovr_val     (SA1_LDS_sig1_ovr_val),
   .SA0_LDS_sig2_force_disable      (SA0_LDS_sig2_force_disable),
   .SA0_LDS_sig2_threshold   (SA0_LDS_sig2_threshold),
   .SA0_LDS_sig2_ovr_sel     (SA0_LDS_sig2_ovr_sel),
   .SA0_LDS_sig2_ovr_val     (SA0_LDS_sig2_ovr_val),
   .SA1_LDS_sig2_force_disable      (SA1_LDS_sig2_force_disable),
   .SA1_LDS_sig2_threshold   (SA1_LDS_sig2_threshold),
   .SA1_LDS_sig2_ovr_sel     (SA1_LDS_sig2_ovr_sel),
   .SA1_LDS_sig2_ovr_val     (SA1_LDS_sig2_ovr_val),
   .SA0_LDS_sig3_force_disable      (SA0_LDS_sig3_force_disable),
   .SA0_LDS_sig3_threshold   (SA0_LDS_sig3_threshold),
   .SA0_LDS_sig3_ovr_sel     (SA0_LDS_sig3_ovr_sel),
   .SA0_LDS_sig3_ovr_val     (SA0_LDS_sig3_ovr_val),
   .SA1_LDS_sig3_force_disable      (SA1_LDS_sig3_force_disable),
   .SA1_LDS_sig3_threshold   (SA1_LDS_sig3_threshold),
   .SA1_LDS_sig3_ovr_sel     (SA1_LDS_sig3_ovr_sel),
   .SA1_LDS_sig3_ovr_val     (SA1_LDS_sig3_ovr_val),
   .SA0_BCI_sig0_force_disable      (SA0_BCI_sig0_force_disable),
   .SA0_BCI_sig0_threshold   (SA0_BCI_sig0_threshold),
   .SA0_BCI_sig0_ovr_sel     (SA0_BCI_sig0_ovr_sel),
   .SA0_BCI_sig0_ovr_val     (SA0_BCI_sig0_ovr_val),
   .SA1_BCI_sig0_force_disable      (SA1_BCI_sig0_force_disable),
   .SA1_BCI_sig0_threshold   (SA1_BCI_sig0_threshold),
   .SA1_BCI_sig0_ovr_sel     (SA1_BCI_sig0_ovr_sel),
   .SA1_BCI_sig0_ovr_val     (SA1_BCI_sig0_ovr_val),
   .SA0_BCI_sig1_force_disable      (SA0_BCI_sig1_force_disable),
   .SA0_BCI_sig1_threshold   (SA0_BCI_sig1_threshold),
   .SA0_BCI_sig1_ovr_sel     (SA0_BCI_sig1_ovr_sel),
   .SA0_BCI_sig1_ovr_val     (SA0_BCI_sig1_ovr_val),
   .SA1_BCI_sig1_force_disable      (SA1_BCI_sig1_force_disable),
   .SA1_BCI_sig1_threshold   (SA1_BCI_sig1_threshold),
   .SA1_BCI_sig1_ovr_sel     (SA1_BCI_sig1_ovr_sel),
   .SA1_BCI_sig1_ovr_val     (SA1_BCI_sig1_ovr_val),
   .SA0_CB_sig0_force_disable      (SA0_CB_sig0_force_disable),
   .SA0_CB_sig0_threshold   (SA0_CB_sig0_threshold),
   .SA0_CB_sig0_ovr_sel     (SA0_CB_sig0_ovr_sel),
   .SA0_CB_sig0_ovr_val     (SA0_CB_sig0_ovr_val),
   .SA1_CB_sig0_force_disable      (SA1_CB_sig0_force_disable),
   .SA1_CB_sig0_threshold   (SA1_CB_sig0_threshold),
   .SA1_CB_sig0_ovr_sel     (SA1_CB_sig0_ovr_sel),
   .SA1_CB_sig0_ovr_val     (SA1_CB_sig0_ovr_val),
   .SA0_CB_sig1_force_disable      (SA0_CB_sig1_force_disable),
   .SA0_CB_sig1_threshold   (SA0_CB_sig1_threshold),
   .SA0_CB_sig1_ovr_sel     (SA0_CB_sig1_ovr_sel),
   .SA0_CB_sig1_ovr_val     (SA0_CB_sig1_ovr_val),
   .SA1_CB_sig1_force_disable      (SA1_CB_sig1_force_disable),
   .SA1_CB_sig1_threshold   (SA1_CB_sig1_threshold),
   .SA1_CB_sig1_ovr_sel     (SA1_CB_sig1_ovr_sel),
   .SA1_CB_sig1_ovr_val     (SA1_CB_sig1_ovr_val),
   .SA0_CB_sig2_force_disable      (SA0_CB_sig2_force_disable),
   .SA0_CB_sig2_threshold   (SA0_CB_sig2_threshold),
   .SA0_CB_sig2_ovr_sel     (SA0_CB_sig2_ovr_sel),
   .SA0_CB_sig2_ovr_val     (SA0_CB_sig2_ovr_val),
   .SA1_CB_sig2_force_disable      (SA1_CB_sig2_force_disable),
   .SA1_CB_sig2_threshold   (SA1_CB_sig2_threshold),
   .SA1_CB_sig2_ovr_sel     (SA1_CB_sig2_ovr_sel),
   .SA1_CB_sig2_ovr_val     (SA1_CB_sig2_ovr_val),
   .SA0_CB_sig3_force_disable      (SA0_CB_sig3_force_disable),
   .SA0_CB_sig3_threshold   (SA0_CB_sig3_threshold),
   .SA0_CB_sig3_ovr_sel     (SA0_CB_sig3_ovr_sel),
   .SA0_CB_sig3_ovr_val     (SA0_CB_sig3_ovr_val),
   .SA1_CB_sig3_force_disable      (SA1_CB_sig3_force_disable),
   .SA1_CB_sig3_threshold   (SA1_CB_sig3_threshold),
   .SA1_CB_sig3_ovr_sel     (SA1_CB_sig3_ovr_sel),
   .SA1_CB_sig3_ovr_val     (SA1_CB_sig3_ovr_val),
   .SA0_DB_sig0_force_disable      (SA0_DB_sig0_force_disable),
   .SA0_DB_sig0_threshold   (SA0_DB_sig0_threshold),
   .SA0_DB_sig0_ovr_sel     (SA0_DB_sig0_ovr_sel),
   .SA0_DB_sig0_ovr_val     (SA0_DB_sig0_ovr_val),
   .SA1_DB_sig0_force_disable      (SA1_DB_sig0_force_disable),
   .SA1_DB_sig0_threshold   (SA1_DB_sig0_threshold),
   .SA1_DB_sig0_ovr_sel     (SA1_DB_sig0_ovr_sel),
   .SA1_DB_sig0_ovr_val     (SA1_DB_sig0_ovr_val),
   .SA0_DB_sig1_force_disable      (SA0_DB_sig1_force_disable),
   .SA0_DB_sig1_threshold   (SA0_DB_sig1_threshold),
   .SA0_DB_sig1_ovr_sel     (SA0_DB_sig1_ovr_sel),
   .SA0_DB_sig1_ovr_val     (SA0_DB_sig1_ovr_val),
   .SA1_DB_sig1_force_disable      (SA1_DB_sig1_force_disable),
   .SA1_DB_sig1_threshold   (SA1_DB_sig1_threshold),
   .SA1_DB_sig1_ovr_sel     (SA1_DB_sig1_ovr_sel),
   .SA1_DB_sig1_ovr_val     (SA1_DB_sig1_ovr_val),
   .SA0_DB_sig2_force_disable      (SA0_DB_sig2_force_disable),
   .SA0_DB_sig2_threshold   (SA0_DB_sig2_threshold),
   .SA0_DB_sig2_ovr_sel     (SA0_DB_sig2_ovr_sel),
   .SA0_DB_sig2_ovr_val     (SA0_DB_sig2_ovr_val),
   .SA1_DB_sig2_force_disable      (SA1_DB_sig2_force_disable),
   .SA1_DB_sig2_threshold   (SA1_DB_sig2_threshold),
   .SA1_DB_sig2_ovr_sel     (SA1_DB_sig2_ovr_sel),
   .SA1_DB_sig2_ovr_val     (SA1_DB_sig2_ovr_val),
   .SA0_DB_sig3_force_disable      (SA0_DB_sig3_force_disable),
   .SA0_DB_sig3_threshold   (SA0_DB_sig3_threshold),
   .SA0_DB_sig3_ovr_sel     (SA0_DB_sig3_ovr_sel),
   .SA0_DB_sig3_ovr_val     (SA0_DB_sig3_ovr_val),
   .SA1_DB_sig3_force_disable      (SA1_DB_sig3_force_disable),
   .SA1_DB_sig3_threshold   (SA1_DB_sig3_threshold),
   .SA1_DB_sig3_ovr_sel     (SA1_DB_sig3_ovr_sel),
   .SA1_DB_sig3_ovr_val     (SA1_DB_sig3_ovr_val),
   .SA0_PA_sig0_force_disable      (SA0_PA_sig0_force_disable),
   .SA0_PA_sig0_threshold   (SA0_PA_sig0_threshold),
   .SA0_PA_sig0_ovr_sel     (SA0_PA_sig0_ovr_sel),
   .SA0_PA_sig0_ovr_val     (SA0_PA_sig0_ovr_val),
   .SA1_PA_sig0_force_disable      (SA1_PA_sig0_force_disable),
   .SA1_PA_sig0_threshold   (SA1_PA_sig0_threshold),
   .SA1_PA_sig0_ovr_sel     (SA1_PA_sig0_ovr_sel),
   .SA1_PA_sig0_ovr_val     (SA1_PA_sig0_ovr_val),
   .SA0_PA_sig1_force_disable      (SA0_PA_sig1_force_disable),
   .SA0_PA_sig1_threshold   (SA0_PA_sig1_threshold),
   .SA0_PA_sig1_ovr_sel     (SA0_PA_sig1_ovr_sel),
   .SA0_PA_sig1_ovr_val     (SA0_PA_sig1_ovr_val),
   .SA1_PA_sig1_force_disable      (SA1_PA_sig1_force_disable),
   .SA1_PA_sig1_threshold   (SA1_PA_sig1_threshold),
   .SA1_PA_sig1_ovr_sel     (SA1_PA_sig1_ovr_sel),
   .SA1_PA_sig1_ovr_val     (SA1_PA_sig1_ovr_val),
   .SA0_RMI_sig0_force_disable      (SA0_RMI_sig0_force_disable),
   .SA0_RMI_sig0_threshold   (SA0_RMI_sig0_threshold),
   .SA0_RMI_sig0_ovr_sel     (SA0_RMI_sig0_ovr_sel),
   .SA0_RMI_sig0_ovr_val     (SA0_RMI_sig0_ovr_val),
   .SA1_RMI_sig0_force_disable      (SA1_RMI_sig0_force_disable),
   .SA1_RMI_sig0_threshold   (SA1_RMI_sig0_threshold),
   .SA1_RMI_sig0_ovr_sel     (SA1_RMI_sig0_ovr_sel),
   .SA1_RMI_sig0_ovr_val     (SA1_RMI_sig0_ovr_val),
   .SA0_SC_sig0_force_disable      (SA0_SC_sig0_force_disable),
   .SA0_SC_sig0_threshold   (SA0_SC_sig0_threshold),
   .SA0_SC_sig0_ovr_sel     (SA0_SC_sig0_ovr_sel),
   .SA0_SC_sig0_ovr_val     (SA0_SC_sig0_ovr_val),
   .SA1_SC_sig0_force_disable      (SA1_SC_sig0_force_disable),
   .SA1_SC_sig0_threshold   (SA1_SC_sig0_threshold),
   .SA1_SC_sig0_ovr_sel     (SA1_SC_sig0_ovr_sel),
   .SA1_SC_sig0_ovr_val     (SA1_SC_sig0_ovr_val),
   .SA0_SX_sig0_force_disable      (SA0_SX_sig0_force_disable),
   .SA0_SX_sig0_threshold   (SA0_SX_sig0_threshold),
   .SA0_SX_sig0_ovr_sel     (SA0_SX_sig0_ovr_sel),
   .SA0_SX_sig0_ovr_val     (SA0_SX_sig0_ovr_val),
   .SA1_SX_sig0_force_disable      (SA1_SX_sig0_force_disable),
   .SA1_SX_sig0_threshold   (SA1_SX_sig0_threshold),
   .SA1_SX_sig0_ovr_sel     (SA1_SX_sig0_ovr_sel),
   .SA1_SX_sig0_ovr_val     (SA1_SX_sig0_ovr_val),
   .SA0_SXRB_sig0_force_disable      (SA0_SXRB_sig0_force_disable),
   .SA0_SXRB_sig0_threshold   (SA0_SXRB_sig0_threshold),
   .SA0_SXRB_sig0_ovr_sel     (SA0_SXRB_sig0_ovr_sel),
   .SA0_SXRB_sig0_ovr_val     (SA0_SXRB_sig0_ovr_val),
   .SA1_SXRB_sig0_force_disable      (SA1_SXRB_sig0_force_disable),
   .SA1_SXRB_sig0_threshold   (SA1_SXRB_sig0_threshold),
   .SA1_SXRB_sig0_ovr_sel     (SA1_SXRB_sig0_ovr_sel),
   .SA1_SXRB_sig0_ovr_val     (SA1_SXRB_sig0_ovr_val),
   .SA0_UTCL1_sig0_force_disable      (SA0_UTCL1_sig0_force_disable),
   .SA0_UTCL1_sig0_threshold   (SA0_UTCL1_sig0_threshold),
   .SA0_UTCL1_sig0_ovr_sel     (SA0_UTCL1_sig0_ovr_sel),
   .SA0_UTCL1_sig0_ovr_val     (SA0_UTCL1_sig0_ovr_val),
   .SA1_UTCL1_sig0_force_disable      (SA1_UTCL1_sig0_force_disable),
   .SA1_UTCL1_sig0_threshold   (SA1_UTCL1_sig0_threshold),
   .SA1_UTCL1_sig0_ovr_sel     (SA1_UTCL1_sig0_ovr_sel),
   .SA1_UTCL1_sig0_ovr_val     (SA1_UTCL1_sig0_ovr_val),
   .SA0_CU_sig0_force_disable      (SA0_CU_sig0_force_disable),
   .SA0_CU_sig0_threshold   (SA0_CU_sig0_threshold),
   .SA0_CU_sig0_ovr_sel     (SA0_CU_sig0_ovr_sel),
   .SA0_CU_sig0_ovr_val     (SA0_CU_sig0_ovr_val),
   .SA1_CU_sig0_force_disable      (SA1_CU_sig0_force_disable),
   .SA1_CU_sig0_threshold   (SA1_CU_sig0_threshold),
   .SA1_CU_sig0_ovr_sel     (SA1_CU_sig0_ovr_sel),
   .SA1_CU_sig0_ovr_val     (SA1_CU_sig0_ovr_val),
   .SPI_sig0_force_disable      (SPI_sig0_force_disable),
   .SPI_sig0_threshold   (SPI_sig0_threshold),
   .SPI_sig0_ovr_sel     (SPI_sig0_ovr_sel),
   .SPI_sig0_ovr_val     (SPI_sig0_ovr_val),
   .SPI_sig1_force_disable      (SPI_sig1_force_disable),
   .SPI_sig1_threshold   (SPI_sig1_threshold),
   .SPI_sig1_ovr_sel     (SPI_sig1_ovr_sel),
   .SPI_sig1_ovr_val     (SPI_sig1_ovr_val),
   .SPI_sig2_force_disable      (SPI_sig2_force_disable),
   .SPI_sig2_threshold   (SPI_sig2_threshold),
   .SPI_sig2_ovr_sel     (SPI_sig2_ovr_sel),
   .SPI_sig2_ovr_val     (SPI_sig2_ovr_val),
   .SPI_sig3_force_disable      (SPI_sig3_force_disable),
   .SPI_sig3_threshold   (SPI_sig3_threshold),
   .SPI_sig3_ovr_sel     (SPI_sig3_ovr_sel),
   .SPI_sig3_ovr_val     (SPI_sig3_ovr_val),
   .SPI_sig4_force_disable      (SPI_sig4_force_disable),
   .SPI_sig4_threshold   (SPI_sig4_threshold),
   .SPI_sig4_ovr_sel     (SPI_sig4_ovr_sel),
   .SPI_sig4_ovr_val     (SPI_sig4_ovr_val),
   .SPI_sig5_force_disable      (SPI_sig5_force_disable),
   .SPI_sig5_threshold   (SPI_sig5_threshold),
   .SPI_sig5_ovr_sel     (SPI_sig5_ovr_sel),
   .SPI_sig5_ovr_val     (SPI_sig5_ovr_val),
   .PC_sig0_force_disable      (PC_sig0_force_disable),
   .PC_sig0_threshold   (PC_sig0_threshold),
   .PC_sig0_ovr_sel     (PC_sig0_ovr_sel),
   .PC_sig0_ovr_val     (PC_sig0_ovr_val),


   .reg_clken            (reg_clken),
   .reg_send             (reg_send),
   .reg_op               (reg_op),
   .reg_addr             (reg_addr),
   .reg_wd               (reg_wd),
   .reg_se_index         (reg_se_index),
   .reg_sh_index         (reg_sh_index),
   .reg_instance_select		(reg_instance_select),

   .reg_busy				(reg_busy),

   .CAC_TARG_reg_clken   (SE_CAC_TARG_reg_clken),
   .CAC_TARG_reg_send    (SE_CAC_TARG_reg_send),
   .CAC_TARG_reg_op      (SE_CAC_TARG_reg_op),
   .CAC_TARG_reg_priv    (SE_CAC_TARG_reg_priv),
   .CAC_TARG_reg_vmid    (SE_CAC_TARG_reg_vmid),
   .CAC_TARG_reg_tmz     (SE_CAC_TARG_reg_tmz),
   .CAC_TARG_reg_meid    (SE_CAC_TARG_reg_meid),
   .CAC_TARG_reg_pipeid  (SE_CAC_TARG_reg_pipeid),
   .CAC_TARG_reg_index   (SE_CAC_TARG_reg_index),
   .CAC_TARG_reg_addr    (SE_CAC_TARG_reg_addr),
   .CAC_TARG_reg_wd      (SE_CAC_TARG_reg_wd),

   .CAC_GRBM_serread_in_data	(CAC_GRBM_serread_in_data),
   .CAC_GRBM_serread_data		(CAC_GRBM_serread_data)

);

 wire     SQ_didt_edc_enable;
 wire     DB_didt_edc_enable;
 wire     TD_didt_edc_enable;
 wire     TCP_didt_edc_enable;


// ============================================================
// ================         Local WGP CACs        =================
// ============================================================

wire [31:0] SA0_TA_activity_sig0;
wire [31:0] SA1_TA_activity_sig0;
assign      SA0_TA_activity_sig0[0] = SA0WGP00_TA0_CAC_sig0_active;
assign      SA1_TA_activity_sig0[0] = SA1WGP00_TA0_CAC_sig0_active;
assign      SA0_TA_activity_sig0[1] = SA0WGP00_TA1_CAC_sig0_active;
assign      SA1_TA_activity_sig0[1] = SA1WGP00_TA1_CAC_sig0_active;
assign      SA0_TA_activity_sig0[2] = SA0WGP01_TA0_CAC_sig0_active;
assign      SA1_TA_activity_sig0[2] = SA1WGP01_TA0_CAC_sig0_active;
assign      SA0_TA_activity_sig0[3] = SA0WGP01_TA1_CAC_sig0_active;
assign      SA1_TA_activity_sig0[3] = SA1WGP01_TA1_CAC_sig0_active;
assign      SA0_TA_activity_sig0[4] = SA0WGP02_TA0_CAC_sig0_active;
assign      SA1_TA_activity_sig0[4] = SA1WGP02_TA0_CAC_sig0_active;
assign      SA0_TA_activity_sig0[5] = SA0WGP02_TA1_CAC_sig0_active;
assign      SA1_TA_activity_sig0[5] = SA1WGP02_TA1_CAC_sig0_active;

assign      SA0_TA_activity_sig0[6] = SA0WGP10_TA0_CAC_sig0_active;
assign      SA1_TA_activity_sig0[6] = SA1WGP10_TA0_CAC_sig0_active;
assign      SA0_TA_activity_sig0[7] = SA0WGP10_TA1_CAC_sig0_active;
assign      SA1_TA_activity_sig0[7] = SA1WGP10_TA1_CAC_sig0_active;
assign      SA0_TA_activity_sig0[8] = SA0WGP11_TA0_CAC_sig0_active;
assign      SA1_TA_activity_sig0[8] = SA1WGP11_TA0_CAC_sig0_active;
assign      SA0_TA_activity_sig0[9] = SA0WGP11_TA1_CAC_sig0_active;
assign      SA1_TA_activity_sig0[9] = SA1WGP11_TA1_CAC_sig0_active;
assign      SA0_TA_activity_sig0[31:10] = 22'd0;
assign      SA1_TA_activity_sig0[31:10] = 22'd0;
wire [31:0] SA0_TD_activity_sig0;
wire [31:0] SA1_TD_activity_sig0;
assign      SA0_TD_activity_sig0[0] = SA0WGP00_TD0_CAC_sig0_active;
assign      SA1_TD_activity_sig0[0] = SA1WGP00_TD0_CAC_sig0_active;
assign      SA0_TD_activity_sig0[1] = SA0WGP00_TD1_CAC_sig0_active;
assign      SA1_TD_activity_sig0[1] = SA1WGP00_TD1_CAC_sig0_active;
assign      SA0_TD_activity_sig0[2] = SA0WGP01_TD0_CAC_sig0_active;
assign      SA1_TD_activity_sig0[2] = SA1WGP01_TD0_CAC_sig0_active;
assign      SA0_TD_activity_sig0[3] = SA0WGP01_TD1_CAC_sig0_active;
assign      SA1_TD_activity_sig0[3] = SA1WGP01_TD1_CAC_sig0_active;
assign      SA0_TD_activity_sig0[4] = SA0WGP02_TD0_CAC_sig0_active;
assign      SA1_TD_activity_sig0[4] = SA1WGP02_TD0_CAC_sig0_active;
assign      SA0_TD_activity_sig0[5] = SA0WGP02_TD1_CAC_sig0_active;
assign      SA1_TD_activity_sig0[5] = SA1WGP02_TD1_CAC_sig0_active;

assign      SA0_TD_activity_sig0[6] = SA0WGP10_TD0_CAC_sig0_active;
assign      SA1_TD_activity_sig0[6] = SA1WGP10_TD0_CAC_sig0_active;
assign      SA0_TD_activity_sig0[7] = SA0WGP10_TD1_CAC_sig0_active;
assign      SA1_TD_activity_sig0[7] = SA1WGP10_TD1_CAC_sig0_active;
assign      SA0_TD_activity_sig0[8] = SA0WGP11_TD0_CAC_sig0_active;
assign      SA1_TD_activity_sig0[8] = SA1WGP11_TD0_CAC_sig0_active;
assign      SA0_TD_activity_sig0[9] = SA0WGP11_TD1_CAC_sig0_active;
assign      SA1_TD_activity_sig0[9] = SA1WGP11_TD1_CAC_sig0_active;
assign      SA0_TD_activity_sig0[31:10] = 22'd0;
assign      SA1_TD_activity_sig0[31:10] = 22'd0;
wire [31:0] SA0_TD_activity_sig1;
wire [31:0] SA1_TD_activity_sig1;
assign      SA0_TD_activity_sig1[0] = SA0WGP00_TD0_CAC_sig1_active;
assign      SA1_TD_activity_sig1[0] = SA1WGP00_TD0_CAC_sig1_active;
assign      SA0_TD_activity_sig1[1] = SA0WGP00_TD1_CAC_sig1_active;
assign      SA1_TD_activity_sig1[1] = SA1WGP00_TD1_CAC_sig1_active;
assign      SA0_TD_activity_sig1[2] = SA0WGP01_TD0_CAC_sig1_active;
assign      SA1_TD_activity_sig1[2] = SA1WGP01_TD0_CAC_sig1_active;
assign      SA0_TD_activity_sig1[3] = SA0WGP01_TD1_CAC_sig1_active;
assign      SA1_TD_activity_sig1[3] = SA1WGP01_TD1_CAC_sig1_active;
assign      SA0_TD_activity_sig1[4] = SA0WGP02_TD0_CAC_sig1_active;
assign      SA1_TD_activity_sig1[4] = SA1WGP02_TD0_CAC_sig1_active;
assign      SA0_TD_activity_sig1[5] = SA0WGP02_TD1_CAC_sig1_active;
assign      SA1_TD_activity_sig1[5] = SA1WGP02_TD1_CAC_sig1_active;

assign      SA0_TD_activity_sig1[6] = SA0WGP10_TD0_CAC_sig1_active;
assign      SA1_TD_activity_sig1[6] = SA1WGP10_TD0_CAC_sig1_active;
assign      SA0_TD_activity_sig1[7] = SA0WGP10_TD1_CAC_sig1_active;
assign      SA1_TD_activity_sig1[7] = SA1WGP10_TD1_CAC_sig1_active;
assign      SA0_TD_activity_sig1[8] = SA0WGP11_TD0_CAC_sig1_active;
assign      SA1_TD_activity_sig1[8] = SA1WGP11_TD0_CAC_sig1_active;
assign      SA0_TD_activity_sig1[9] = SA0WGP11_TD1_CAC_sig1_active;
assign      SA1_TD_activity_sig1[9] = SA1WGP11_TD1_CAC_sig1_active;
assign      SA0_TD_activity_sig1[31:10] = 22'd0;
assign      SA1_TD_activity_sig1[31:10] = 22'd0;
wire [31:0] SA0_TD_activity_sig2;
wire [31:0] SA1_TD_activity_sig2;
assign      SA0_TD_activity_sig2[0] = SA0WGP00_TD0_CAC_sig2_active;
assign      SA1_TD_activity_sig2[0] = SA1WGP00_TD0_CAC_sig2_active;
assign      SA0_TD_activity_sig2[1] = SA0WGP00_TD1_CAC_sig2_active;
assign      SA1_TD_activity_sig2[1] = SA1WGP00_TD1_CAC_sig2_active;
assign      SA0_TD_activity_sig2[2] = SA0WGP01_TD0_CAC_sig2_active;
assign      SA1_TD_activity_sig2[2] = SA1WGP01_TD0_CAC_sig2_active;
assign      SA0_TD_activity_sig2[3] = SA0WGP01_TD1_CAC_sig2_active;
assign      SA1_TD_activity_sig2[3] = SA1WGP01_TD1_CAC_sig2_active;
assign      SA0_TD_activity_sig2[4] = SA0WGP02_TD0_CAC_sig2_active;
assign      SA1_TD_activity_sig2[4] = SA1WGP02_TD0_CAC_sig2_active;
assign      SA0_TD_activity_sig2[5] = SA0WGP02_TD1_CAC_sig2_active;
assign      SA1_TD_activity_sig2[5] = SA1WGP02_TD1_CAC_sig2_active;

assign      SA0_TD_activity_sig2[6] = SA0WGP10_TD0_CAC_sig2_active;
assign      SA1_TD_activity_sig2[6] = SA1WGP10_TD0_CAC_sig2_active;
assign      SA0_TD_activity_sig2[7] = SA0WGP10_TD1_CAC_sig2_active;
assign      SA1_TD_activity_sig2[7] = SA1WGP10_TD1_CAC_sig2_active;
assign      SA0_TD_activity_sig2[8] = SA0WGP11_TD0_CAC_sig2_active;
assign      SA1_TD_activity_sig2[8] = SA1WGP11_TD0_CAC_sig2_active;
assign      SA0_TD_activity_sig2[9] = SA0WGP11_TD1_CAC_sig2_active;
assign      SA1_TD_activity_sig2[9] = SA1WGP11_TD1_CAC_sig2_active;
assign      SA0_TD_activity_sig2[31:10] = 22'd0;
assign      SA1_TD_activity_sig2[31:10] = 22'd0;
wire [31:0] SA0_TD_activity_sig3;
wire [31:0] SA1_TD_activity_sig3;
assign      SA0_TD_activity_sig3[0] = SA0WGP00_TD0_CAC_sig3_active;
assign      SA1_TD_activity_sig3[0] = SA1WGP00_TD0_CAC_sig3_active;
assign      SA0_TD_activity_sig3[1] = SA0WGP00_TD1_CAC_sig3_active;
assign      SA1_TD_activity_sig3[1] = SA1WGP00_TD1_CAC_sig3_active;
assign      SA0_TD_activity_sig3[2] = SA0WGP01_TD0_CAC_sig3_active;
assign      SA1_TD_activity_sig3[2] = SA1WGP01_TD0_CAC_sig3_active;
assign      SA0_TD_activity_sig3[3] = SA0WGP01_TD1_CAC_sig3_active;
assign      SA1_TD_activity_sig3[3] = SA1WGP01_TD1_CAC_sig3_active;
assign      SA0_TD_activity_sig3[4] = SA0WGP02_TD0_CAC_sig3_active;
assign      SA1_TD_activity_sig3[4] = SA1WGP02_TD0_CAC_sig3_active;
assign      SA0_TD_activity_sig3[5] = SA0WGP02_TD1_CAC_sig3_active;
assign      SA1_TD_activity_sig3[5] = SA1WGP02_TD1_CAC_sig3_active;

assign      SA0_TD_activity_sig3[6] = SA0WGP10_TD0_CAC_sig3_active;
assign      SA1_TD_activity_sig3[6] = SA1WGP10_TD0_CAC_sig3_active;
assign      SA0_TD_activity_sig3[7] = SA0WGP10_TD1_CAC_sig3_active;
assign      SA1_TD_activity_sig3[7] = SA1WGP10_TD1_CAC_sig3_active;
assign      SA0_TD_activity_sig3[8] = SA0WGP11_TD0_CAC_sig3_active;
assign      SA1_TD_activity_sig3[8] = SA1WGP11_TD0_CAC_sig3_active;
assign      SA0_TD_activity_sig3[9] = SA0WGP11_TD1_CAC_sig3_active;
assign      SA1_TD_activity_sig3[9] = SA1WGP11_TD1_CAC_sig3_active;
assign      SA0_TD_activity_sig3[31:10] = 22'd0;
assign      SA1_TD_activity_sig3[31:10] = 22'd0;
wire [31:0] SA0_TD_activity_sig4;
wire [31:0] SA1_TD_activity_sig4;
assign      SA0_TD_activity_sig4[0] = SA0WGP00_TD0_CAC_sig4_active;
assign      SA1_TD_activity_sig4[0] = SA1WGP00_TD0_CAC_sig4_active;
assign      SA0_TD_activity_sig4[1] = SA0WGP00_TD1_CAC_sig4_active;
assign      SA1_TD_activity_sig4[1] = SA1WGP00_TD1_CAC_sig4_active;
assign      SA0_TD_activity_sig4[2] = SA0WGP01_TD0_CAC_sig4_active;
assign      SA1_TD_activity_sig4[2] = SA1WGP01_TD0_CAC_sig4_active;
assign      SA0_TD_activity_sig4[3] = SA0WGP01_TD1_CAC_sig4_active;
assign      SA1_TD_activity_sig4[3] = SA1WGP01_TD1_CAC_sig4_active;
assign      SA0_TD_activity_sig4[4] = SA0WGP02_TD0_CAC_sig4_active;
assign      SA1_TD_activity_sig4[4] = SA1WGP02_TD0_CAC_sig4_active;
assign      SA0_TD_activity_sig4[5] = SA0WGP02_TD1_CAC_sig4_active;
assign      SA1_TD_activity_sig4[5] = SA1WGP02_TD1_CAC_sig4_active;

assign      SA0_TD_activity_sig4[6] = SA0WGP10_TD0_CAC_sig4_active;
assign      SA1_TD_activity_sig4[6] = SA1WGP10_TD0_CAC_sig4_active;
assign      SA0_TD_activity_sig4[7] = SA0WGP10_TD1_CAC_sig4_active;
assign      SA1_TD_activity_sig4[7] = SA1WGP10_TD1_CAC_sig4_active;
assign      SA0_TD_activity_sig4[8] = SA0WGP11_TD0_CAC_sig4_active;
assign      SA1_TD_activity_sig4[8] = SA1WGP11_TD0_CAC_sig4_active;
assign      SA0_TD_activity_sig4[9] = SA0WGP11_TD1_CAC_sig4_active;
assign      SA1_TD_activity_sig4[9] = SA1WGP11_TD1_CAC_sig4_active;
assign      SA0_TD_activity_sig4[31:10] = 22'd0;
assign      SA1_TD_activity_sig4[31:10] = 22'd0;
wire [31:0] SA0_TD_activity_sig5;
wire [31:0] SA1_TD_activity_sig5;
assign      SA0_TD_activity_sig5[0] = SA0WGP00_TD0_CAC_sig5_active;
assign      SA1_TD_activity_sig5[0] = SA1WGP00_TD0_CAC_sig5_active;
assign      SA0_TD_activity_sig5[1] = SA0WGP00_TD1_CAC_sig5_active;
assign      SA1_TD_activity_sig5[1] = SA1WGP00_TD1_CAC_sig5_active;
assign      SA0_TD_activity_sig5[2] = SA0WGP01_TD0_CAC_sig5_active;
assign      SA1_TD_activity_sig5[2] = SA1WGP01_TD0_CAC_sig5_active;
assign      SA0_TD_activity_sig5[3] = SA0WGP01_TD1_CAC_sig5_active;
assign      SA1_TD_activity_sig5[3] = SA1WGP01_TD1_CAC_sig5_active;
assign      SA0_TD_activity_sig5[4] = SA0WGP02_TD0_CAC_sig5_active;
assign      SA1_TD_activity_sig5[4] = SA1WGP02_TD0_CAC_sig5_active;
assign      SA0_TD_activity_sig5[5] = SA0WGP02_TD1_CAC_sig5_active;
assign      SA1_TD_activity_sig5[5] = SA1WGP02_TD1_CAC_sig5_active;

assign      SA0_TD_activity_sig5[6] = SA0WGP10_TD0_CAC_sig5_active;
assign      SA1_TD_activity_sig5[6] = SA1WGP10_TD0_CAC_sig5_active;
assign      SA0_TD_activity_sig5[7] = SA0WGP10_TD1_CAC_sig5_active;
assign      SA1_TD_activity_sig5[7] = SA1WGP10_TD1_CAC_sig5_active;
assign      SA0_TD_activity_sig5[8] = SA0WGP11_TD0_CAC_sig5_active;
assign      SA1_TD_activity_sig5[8] = SA1WGP11_TD0_CAC_sig5_active;
assign      SA0_TD_activity_sig5[9] = SA0WGP11_TD1_CAC_sig5_active;
assign      SA1_TD_activity_sig5[9] = SA1WGP11_TD1_CAC_sig5_active;
assign      SA0_TD_activity_sig5[31:10] = 22'd0;
assign      SA1_TD_activity_sig5[31:10] = 22'd0;
wire [31:0] SA0_TD_activity_sig6;
wire [31:0] SA1_TD_activity_sig6;
assign      SA0_TD_activity_sig6[0] = SA0WGP00_TD0_CAC_sig6_active;
assign      SA1_TD_activity_sig6[0] = SA1WGP00_TD0_CAC_sig6_active;
assign      SA0_TD_activity_sig6[1] = SA0WGP00_TD1_CAC_sig6_active;
assign      SA1_TD_activity_sig6[1] = SA1WGP00_TD1_CAC_sig6_active;
assign      SA0_TD_activity_sig6[2] = SA0WGP01_TD0_CAC_sig6_active;
assign      SA1_TD_activity_sig6[2] = SA1WGP01_TD0_CAC_sig6_active;
assign      SA0_TD_activity_sig6[3] = SA0WGP01_TD1_CAC_sig6_active;
assign      SA1_TD_activity_sig6[3] = SA1WGP01_TD1_CAC_sig6_active;
assign      SA0_TD_activity_sig6[4] = SA0WGP02_TD0_CAC_sig6_active;
assign      SA1_TD_activity_sig6[4] = SA1WGP02_TD0_CAC_sig6_active;
assign      SA0_TD_activity_sig6[5] = SA0WGP02_TD1_CAC_sig6_active;
assign      SA1_TD_activity_sig6[5] = SA1WGP02_TD1_CAC_sig6_active;

assign      SA0_TD_activity_sig6[6] = SA0WGP10_TD0_CAC_sig6_active;
assign      SA1_TD_activity_sig6[6] = SA1WGP10_TD0_CAC_sig6_active;
assign      SA0_TD_activity_sig6[7] = SA0WGP10_TD1_CAC_sig6_active;
assign      SA1_TD_activity_sig6[7] = SA1WGP10_TD1_CAC_sig6_active;
assign      SA0_TD_activity_sig6[8] = SA0WGP11_TD0_CAC_sig6_active;
assign      SA1_TD_activity_sig6[8] = SA1WGP11_TD0_CAC_sig6_active;
assign      SA0_TD_activity_sig6[9] = SA0WGP11_TD1_CAC_sig6_active;
assign      SA1_TD_activity_sig6[9] = SA1WGP11_TD1_CAC_sig6_active;
assign      SA0_TD_activity_sig6[31:10] = 22'd0;
assign      SA1_TD_activity_sig6[31:10] = 22'd0;
wire [31:0] SA0_TD_activity_sig7;
wire [31:0] SA1_TD_activity_sig7;
assign      SA0_TD_activity_sig7[0] = SA0WGP00_TD0_CAC_sig7_active;
assign      SA1_TD_activity_sig7[0] = SA1WGP00_TD0_CAC_sig7_active;
assign      SA0_TD_activity_sig7[1] = SA0WGP00_TD1_CAC_sig7_active;
assign      SA1_TD_activity_sig7[1] = SA1WGP00_TD1_CAC_sig7_active;
assign      SA0_TD_activity_sig7[2] = SA0WGP01_TD0_CAC_sig7_active;
assign      SA1_TD_activity_sig7[2] = SA1WGP01_TD0_CAC_sig7_active;
assign      SA0_TD_activity_sig7[3] = SA0WGP01_TD1_CAC_sig7_active;
assign      SA1_TD_activity_sig7[3] = SA1WGP01_TD1_CAC_sig7_active;
assign      SA0_TD_activity_sig7[4] = SA0WGP02_TD0_CAC_sig7_active;
assign      SA1_TD_activity_sig7[4] = SA1WGP02_TD0_CAC_sig7_active;
assign      SA0_TD_activity_sig7[5] = SA0WGP02_TD1_CAC_sig7_active;
assign      SA1_TD_activity_sig7[5] = SA1WGP02_TD1_CAC_sig7_active;

assign      SA0_TD_activity_sig7[6] = SA0WGP10_TD0_CAC_sig7_active;
assign      SA1_TD_activity_sig7[6] = SA1WGP10_TD0_CAC_sig7_active;
assign      SA0_TD_activity_sig7[7] = SA0WGP10_TD1_CAC_sig7_active;
assign      SA1_TD_activity_sig7[7] = SA1WGP10_TD1_CAC_sig7_active;
assign      SA0_TD_activity_sig7[8] = SA0WGP11_TD0_CAC_sig7_active;
assign      SA1_TD_activity_sig7[8] = SA1WGP11_TD0_CAC_sig7_active;
assign      SA0_TD_activity_sig7[9] = SA0WGP11_TD1_CAC_sig7_active;
assign      SA1_TD_activity_sig7[9] = SA1WGP11_TD1_CAC_sig7_active;
assign      SA0_TD_activity_sig7[31:10] = 22'd0;
assign      SA1_TD_activity_sig7[31:10] = 22'd0;
wire [31:0] SA0_TD_activity_sig8;
wire [31:0] SA1_TD_activity_sig8;
assign      SA0_TD_activity_sig8[0] = SA0WGP00_TD0_CAC_sig8_active;
assign      SA1_TD_activity_sig8[0] = SA1WGP00_TD0_CAC_sig8_active;
assign      SA0_TD_activity_sig8[1] = SA0WGP00_TD1_CAC_sig8_active;
assign      SA1_TD_activity_sig8[1] = SA1WGP00_TD1_CAC_sig8_active;
assign      SA0_TD_activity_sig8[2] = SA0WGP01_TD0_CAC_sig8_active;
assign      SA1_TD_activity_sig8[2] = SA1WGP01_TD0_CAC_sig8_active;
assign      SA0_TD_activity_sig8[3] = SA0WGP01_TD1_CAC_sig8_active;
assign      SA1_TD_activity_sig8[3] = SA1WGP01_TD1_CAC_sig8_active;
assign      SA0_TD_activity_sig8[4] = SA0WGP02_TD0_CAC_sig8_active;
assign      SA1_TD_activity_sig8[4] = SA1WGP02_TD0_CAC_sig8_active;
assign      SA0_TD_activity_sig8[5] = SA0WGP02_TD1_CAC_sig8_active;
assign      SA1_TD_activity_sig8[5] = SA1WGP02_TD1_CAC_sig8_active;

assign      SA0_TD_activity_sig8[6] = SA0WGP10_TD0_CAC_sig8_active;
assign      SA1_TD_activity_sig8[6] = SA1WGP10_TD0_CAC_sig8_active;
assign      SA0_TD_activity_sig8[7] = SA0WGP10_TD1_CAC_sig8_active;
assign      SA1_TD_activity_sig8[7] = SA1WGP10_TD1_CAC_sig8_active;
assign      SA0_TD_activity_sig8[8] = SA0WGP11_TD0_CAC_sig8_active;
assign      SA1_TD_activity_sig8[8] = SA1WGP11_TD0_CAC_sig8_active;
assign      SA0_TD_activity_sig8[9] = SA0WGP11_TD1_CAC_sig8_active;
assign      SA1_TD_activity_sig8[9] = SA1WGP11_TD1_CAC_sig8_active;
assign      SA0_TD_activity_sig8[31:10] = 22'd0;
assign      SA1_TD_activity_sig8[31:10] = 22'd0;
wire [31:0] SA0_TD_activity_sig9;
wire [31:0] SA1_TD_activity_sig9;
assign      SA0_TD_activity_sig9[0] = SA0WGP00_TD0_CAC_sig9_active;
assign      SA1_TD_activity_sig9[0] = SA1WGP00_TD0_CAC_sig9_active;
assign      SA0_TD_activity_sig9[1] = SA0WGP00_TD1_CAC_sig9_active;
assign      SA1_TD_activity_sig9[1] = SA1WGP00_TD1_CAC_sig9_active;
assign      SA0_TD_activity_sig9[2] = SA0WGP01_TD0_CAC_sig9_active;
assign      SA1_TD_activity_sig9[2] = SA1WGP01_TD0_CAC_sig9_active;
assign      SA0_TD_activity_sig9[3] = SA0WGP01_TD1_CAC_sig9_active;
assign      SA1_TD_activity_sig9[3] = SA1WGP01_TD1_CAC_sig9_active;
assign      SA0_TD_activity_sig9[4] = SA0WGP02_TD0_CAC_sig9_active;
assign      SA1_TD_activity_sig9[4] = SA1WGP02_TD0_CAC_sig9_active;
assign      SA0_TD_activity_sig9[5] = SA0WGP02_TD1_CAC_sig9_active;
assign      SA1_TD_activity_sig9[5] = SA1WGP02_TD1_CAC_sig9_active;

assign      SA0_TD_activity_sig9[6] = SA0WGP10_TD0_CAC_sig9_active;
assign      SA1_TD_activity_sig9[6] = SA1WGP10_TD0_CAC_sig9_active;
assign      SA0_TD_activity_sig9[7] = SA0WGP10_TD1_CAC_sig9_active;
assign      SA1_TD_activity_sig9[7] = SA1WGP10_TD1_CAC_sig9_active;
assign      SA0_TD_activity_sig9[8] = SA0WGP11_TD0_CAC_sig9_active;
assign      SA1_TD_activity_sig9[8] = SA1WGP11_TD0_CAC_sig9_active;
assign      SA0_TD_activity_sig9[9] = SA0WGP11_TD1_CAC_sig9_active;
assign      SA1_TD_activity_sig9[9] = SA1WGP11_TD1_CAC_sig9_active;
assign      SA0_TD_activity_sig9[31:10] = 22'd0;
assign      SA1_TD_activity_sig9[31:10] = 22'd0;
wire [31:0] SA0_TCP_activity_sig0;
wire [31:0] SA1_TCP_activity_sig0;
assign      SA0_TCP_activity_sig0[0] = SA0WGP00_TCP0_CAC_sig0_active;
assign      SA1_TCP_activity_sig0[0] = SA1WGP00_TCP0_CAC_sig0_active;
assign      SA0_TCP_activity_sig0[1] = SA0WGP00_TCP1_CAC_sig0_active;
assign      SA1_TCP_activity_sig0[1] = SA1WGP00_TCP1_CAC_sig0_active;
assign      SA0_TCP_activity_sig0[2] = SA0WGP01_TCP0_CAC_sig0_active;
assign      SA1_TCP_activity_sig0[2] = SA1WGP01_TCP0_CAC_sig0_active;
assign      SA0_TCP_activity_sig0[3] = SA0WGP01_TCP1_CAC_sig0_active;
assign      SA1_TCP_activity_sig0[3] = SA1WGP01_TCP1_CAC_sig0_active;
assign      SA0_TCP_activity_sig0[4] = SA0WGP02_TCP0_CAC_sig0_active;
assign      SA1_TCP_activity_sig0[4] = SA1WGP02_TCP0_CAC_sig0_active;
assign      SA0_TCP_activity_sig0[5] = SA0WGP02_TCP1_CAC_sig0_active;
assign      SA1_TCP_activity_sig0[5] = SA1WGP02_TCP1_CAC_sig0_active;

assign      SA0_TCP_activity_sig0[6] = SA0WGP10_TCP0_CAC_sig0_active;
assign      SA1_TCP_activity_sig0[6] = SA1WGP10_TCP0_CAC_sig0_active;
assign      SA0_TCP_activity_sig0[7] = SA0WGP10_TCP1_CAC_sig0_active;
assign      SA1_TCP_activity_sig0[7] = SA1WGP10_TCP1_CAC_sig0_active;
assign      SA0_TCP_activity_sig0[8] = SA0WGP11_TCP0_CAC_sig0_active;
assign      SA1_TCP_activity_sig0[8] = SA1WGP11_TCP0_CAC_sig0_active;
assign      SA0_TCP_activity_sig0[9] = SA0WGP11_TCP1_CAC_sig0_active;
assign      SA1_TCP_activity_sig0[9] = SA1WGP11_TCP1_CAC_sig0_active;
assign      SA0_TCP_activity_sig0[31:10] = 22'd0;
assign      SA1_TCP_activity_sig0[31:10] = 22'd0;
wire [31:0] SA0_TCP_activity_sig1;
wire [31:0] SA1_TCP_activity_sig1;
assign      SA0_TCP_activity_sig1[0] = SA0WGP00_TCP0_CAC_sig1_active;
assign      SA1_TCP_activity_sig1[0] = SA1WGP00_TCP0_CAC_sig1_active;
assign      SA0_TCP_activity_sig1[1] = SA0WGP00_TCP1_CAC_sig1_active;
assign      SA1_TCP_activity_sig1[1] = SA1WGP00_TCP1_CAC_sig1_active;
assign      SA0_TCP_activity_sig1[2] = SA0WGP01_TCP0_CAC_sig1_active;
assign      SA1_TCP_activity_sig1[2] = SA1WGP01_TCP0_CAC_sig1_active;
assign      SA0_TCP_activity_sig1[3] = SA0WGP01_TCP1_CAC_sig1_active;
assign      SA1_TCP_activity_sig1[3] = SA1WGP01_TCP1_CAC_sig1_active;
assign      SA0_TCP_activity_sig1[4] = SA0WGP02_TCP0_CAC_sig1_active;
assign      SA1_TCP_activity_sig1[4] = SA1WGP02_TCP0_CAC_sig1_active;
assign      SA0_TCP_activity_sig1[5] = SA0WGP02_TCP1_CAC_sig1_active;
assign      SA1_TCP_activity_sig1[5] = SA1WGP02_TCP1_CAC_sig1_active;

assign      SA0_TCP_activity_sig1[6] = SA0WGP10_TCP0_CAC_sig1_active;
assign      SA1_TCP_activity_sig1[6] = SA1WGP10_TCP0_CAC_sig1_active;
assign      SA0_TCP_activity_sig1[7] = SA0WGP10_TCP1_CAC_sig1_active;
assign      SA1_TCP_activity_sig1[7] = SA1WGP10_TCP1_CAC_sig1_active;
assign      SA0_TCP_activity_sig1[8] = SA0WGP11_TCP0_CAC_sig1_active;
assign      SA1_TCP_activity_sig1[8] = SA1WGP11_TCP0_CAC_sig1_active;
assign      SA0_TCP_activity_sig1[9] = SA0WGP11_TCP1_CAC_sig1_active;
assign      SA1_TCP_activity_sig1[9] = SA1WGP11_TCP1_CAC_sig1_active;
assign      SA0_TCP_activity_sig1[31:10] = 22'd0;
assign      SA1_TCP_activity_sig1[31:10] = 22'd0;
wire [31:0] SA0_TCP_activity_sig2;
wire [31:0] SA1_TCP_activity_sig2;
assign      SA0_TCP_activity_sig2[0] = SA0WGP00_TCP0_CAC_sig2_active;
assign      SA1_TCP_activity_sig2[0] = SA1WGP00_TCP0_CAC_sig2_active;
assign      SA0_TCP_activity_sig2[1] = SA0WGP00_TCP1_CAC_sig2_active;
assign      SA1_TCP_activity_sig2[1] = SA1WGP00_TCP1_CAC_sig2_active;
assign      SA0_TCP_activity_sig2[2] = SA0WGP01_TCP0_CAC_sig2_active;
assign      SA1_TCP_activity_sig2[2] = SA1WGP01_TCP0_CAC_sig2_active;
assign      SA0_TCP_activity_sig2[3] = SA0WGP01_TCP1_CAC_sig2_active;
assign      SA1_TCP_activity_sig2[3] = SA1WGP01_TCP1_CAC_sig2_active;
assign      SA0_TCP_activity_sig2[4] = SA0WGP02_TCP0_CAC_sig2_active;
assign      SA1_TCP_activity_sig2[4] = SA1WGP02_TCP0_CAC_sig2_active;
assign      SA0_TCP_activity_sig2[5] = SA0WGP02_TCP1_CAC_sig2_active;
assign      SA1_TCP_activity_sig2[5] = SA1WGP02_TCP1_CAC_sig2_active;

assign      SA0_TCP_activity_sig2[6] = SA0WGP10_TCP0_CAC_sig2_active;
assign      SA1_TCP_activity_sig2[6] = SA1WGP10_TCP0_CAC_sig2_active;
assign      SA0_TCP_activity_sig2[7] = SA0WGP10_TCP1_CAC_sig2_active;
assign      SA1_TCP_activity_sig2[7] = SA1WGP10_TCP1_CAC_sig2_active;
assign      SA0_TCP_activity_sig2[8] = SA0WGP11_TCP0_CAC_sig2_active;
assign      SA1_TCP_activity_sig2[8] = SA1WGP11_TCP0_CAC_sig2_active;
assign      SA0_TCP_activity_sig2[9] = SA0WGP11_TCP1_CAC_sig2_active;
assign      SA1_TCP_activity_sig2[9] = SA1WGP11_TCP1_CAC_sig2_active;
assign      SA0_TCP_activity_sig2[31:10] = 22'd0;
assign      SA1_TCP_activity_sig2[31:10] = 22'd0;
wire [31:0] SA0_TCP_activity_sig3;
wire [31:0] SA1_TCP_activity_sig3;
assign      SA0_TCP_activity_sig3[0] = SA0WGP00_TCP0_CAC_sig3_active;
assign      SA1_TCP_activity_sig3[0] = SA1WGP00_TCP0_CAC_sig3_active;
assign      SA0_TCP_activity_sig3[1] = SA0WGP00_TCP1_CAC_sig3_active;
assign      SA1_TCP_activity_sig3[1] = SA1WGP00_TCP1_CAC_sig3_active;
assign      SA0_TCP_activity_sig3[2] = SA0WGP01_TCP0_CAC_sig3_active;
assign      SA1_TCP_activity_sig3[2] = SA1WGP01_TCP0_CAC_sig3_active;
assign      SA0_TCP_activity_sig3[3] = SA0WGP01_TCP1_CAC_sig3_active;
assign      SA1_TCP_activity_sig3[3] = SA1WGP01_TCP1_CAC_sig3_active;
assign      SA0_TCP_activity_sig3[4] = SA0WGP02_TCP0_CAC_sig3_active;
assign      SA1_TCP_activity_sig3[4] = SA1WGP02_TCP0_CAC_sig3_active;
assign      SA0_TCP_activity_sig3[5] = SA0WGP02_TCP1_CAC_sig3_active;
assign      SA1_TCP_activity_sig3[5] = SA1WGP02_TCP1_CAC_sig3_active;

assign      SA0_TCP_activity_sig3[6] = SA0WGP10_TCP0_CAC_sig3_active;
assign      SA1_TCP_activity_sig3[6] = SA1WGP10_TCP0_CAC_sig3_active;
assign      SA0_TCP_activity_sig3[7] = SA0WGP10_TCP1_CAC_sig3_active;
assign      SA1_TCP_activity_sig3[7] = SA1WGP10_TCP1_CAC_sig3_active;
assign      SA0_TCP_activity_sig3[8] = SA0WGP11_TCP0_CAC_sig3_active;
assign      SA1_TCP_activity_sig3[8] = SA1WGP11_TCP0_CAC_sig3_active;
assign      SA0_TCP_activity_sig3[9] = SA0WGP11_TCP1_CAC_sig3_active;
assign      SA1_TCP_activity_sig3[9] = SA1WGP11_TCP1_CAC_sig3_active;
assign      SA0_TCP_activity_sig3[31:10] = 22'd0;
assign      SA1_TCP_activity_sig3[31:10] = 22'd0;
wire [31:0] SA0_TCP_activity_sig4;
wire [31:0] SA1_TCP_activity_sig4;
assign      SA0_TCP_activity_sig4[0] = SA0WGP00_TCP0_CAC_sig4_active;
assign      SA1_TCP_activity_sig4[0] = SA1WGP00_TCP0_CAC_sig4_active;
assign      SA0_TCP_activity_sig4[1] = SA0WGP00_TCP1_CAC_sig4_active;
assign      SA1_TCP_activity_sig4[1] = SA1WGP00_TCP1_CAC_sig4_active;
assign      SA0_TCP_activity_sig4[2] = SA0WGP01_TCP0_CAC_sig4_active;
assign      SA1_TCP_activity_sig4[2] = SA1WGP01_TCP0_CAC_sig4_active;
assign      SA0_TCP_activity_sig4[3] = SA0WGP01_TCP1_CAC_sig4_active;
assign      SA1_TCP_activity_sig4[3] = SA1WGP01_TCP1_CAC_sig4_active;
assign      SA0_TCP_activity_sig4[4] = SA0WGP02_TCP0_CAC_sig4_active;
assign      SA1_TCP_activity_sig4[4] = SA1WGP02_TCP0_CAC_sig4_active;
assign      SA0_TCP_activity_sig4[5] = SA0WGP02_TCP1_CAC_sig4_active;
assign      SA1_TCP_activity_sig4[5] = SA1WGP02_TCP1_CAC_sig4_active;

assign      SA0_TCP_activity_sig4[6] = SA0WGP10_TCP0_CAC_sig4_active;
assign      SA1_TCP_activity_sig4[6] = SA1WGP10_TCP0_CAC_sig4_active;
assign      SA0_TCP_activity_sig4[7] = SA0WGP10_TCP1_CAC_sig4_active;
assign      SA1_TCP_activity_sig4[7] = SA1WGP10_TCP1_CAC_sig4_active;
assign      SA0_TCP_activity_sig4[8] = SA0WGP11_TCP0_CAC_sig4_active;
assign      SA1_TCP_activity_sig4[8] = SA1WGP11_TCP0_CAC_sig4_active;
assign      SA0_TCP_activity_sig4[9] = SA0WGP11_TCP1_CAC_sig4_active;
assign      SA1_TCP_activity_sig4[9] = SA1WGP11_TCP1_CAC_sig4_active;
assign      SA0_TCP_activity_sig4[31:10] = 22'd0;
assign      SA1_TCP_activity_sig4[31:10] = 22'd0;
wire [31:0] SA0_SQ_activity_sig0;
wire [31:0] SA1_SQ_activity_sig0;
assign      SA0_SQ_activity_sig0[0] = SA0WGP00_SQ_CAC_sig0_active;
assign      SA1_SQ_activity_sig0[0] = SA1WGP00_SQ_CAC_sig0_active;
assign      SA0_SQ_activity_sig0[1] = SA0WGP01_SQ_CAC_sig0_active;
assign      SA1_SQ_activity_sig0[1] = SA1WGP01_SQ_CAC_sig0_active;
assign      SA0_SQ_activity_sig0[2] = SA0WGP02_SQ_CAC_sig0_active;
assign      SA1_SQ_activity_sig0[2] = SA1WGP02_SQ_CAC_sig0_active;

assign      SA0_SQ_activity_sig0[3] = SA0WGP10_SQ_CAC_sig0_active;
assign      SA1_SQ_activity_sig0[3] = SA1WGP10_SQ_CAC_sig0_active;
assign      SA0_SQ_activity_sig0[4] = SA0WGP11_SQ_CAC_sig0_active;
assign      SA1_SQ_activity_sig0[4] = SA1WGP11_SQ_CAC_sig0_active;
assign      SA0_SQ_activity_sig0[31:5] = 27'd0;
assign      SA1_SQ_activity_sig0[31:5] = 27'd0;
wire [31:0] SA0_SQ_activity_sig1;
wire [31:0] SA1_SQ_activity_sig1;
assign      SA0_SQ_activity_sig1[0] = SA0WGP00_SQ_CAC_sig1_active;
assign      SA1_SQ_activity_sig1[0] = SA1WGP00_SQ_CAC_sig1_active;
assign      SA0_SQ_activity_sig1[1] = SA0WGP01_SQ_CAC_sig1_active;
assign      SA1_SQ_activity_sig1[1] = SA1WGP01_SQ_CAC_sig1_active;
assign      SA0_SQ_activity_sig1[2] = SA0WGP02_SQ_CAC_sig1_active;
assign      SA1_SQ_activity_sig1[2] = SA1WGP02_SQ_CAC_sig1_active;

assign      SA0_SQ_activity_sig1[3] = SA0WGP10_SQ_CAC_sig1_active;
assign      SA1_SQ_activity_sig1[3] = SA1WGP10_SQ_CAC_sig1_active;
assign      SA0_SQ_activity_sig1[4] = SA0WGP11_SQ_CAC_sig1_active;
assign      SA1_SQ_activity_sig1[4] = SA1WGP11_SQ_CAC_sig1_active;
assign      SA0_SQ_activity_sig1[31:5] = 27'd0;
assign      SA1_SQ_activity_sig1[31:5] = 27'd0;
wire [31:0] SA0_SQ_activity_sig2;
wire [31:0] SA1_SQ_activity_sig2;
assign      SA0_SQ_activity_sig2[0] = SA0WGP00_SQ_CAC_sig2_active;
assign      SA1_SQ_activity_sig2[0] = SA1WGP00_SQ_CAC_sig2_active;
assign      SA0_SQ_activity_sig2[1] = SA0WGP01_SQ_CAC_sig2_active;
assign      SA1_SQ_activity_sig2[1] = SA1WGP01_SQ_CAC_sig2_active;
assign      SA0_SQ_activity_sig2[2] = SA0WGP02_SQ_CAC_sig2_active;
assign      SA1_SQ_activity_sig2[2] = SA1WGP02_SQ_CAC_sig2_active;

assign      SA0_SQ_activity_sig2[3] = SA0WGP10_SQ_CAC_sig2_active;
assign      SA1_SQ_activity_sig2[3] = SA1WGP10_SQ_CAC_sig2_active;
assign      SA0_SQ_activity_sig2[4] = SA0WGP11_SQ_CAC_sig2_active;
assign      SA1_SQ_activity_sig2[4] = SA1WGP11_SQ_CAC_sig2_active;
assign      SA0_SQ_activity_sig2[31:5] = 27'd0;
assign      SA1_SQ_activity_sig2[31:5] = 27'd0;
wire [31:0] SA0_SQ_activity_sig3;
wire [31:0] SA1_SQ_activity_sig3;
assign      SA0_SQ_activity_sig3[0] = SA0WGP00_SQ_CAC_sig3_active;
assign      SA1_SQ_activity_sig3[0] = SA1WGP00_SQ_CAC_sig3_active;
assign      SA0_SQ_activity_sig3[1] = SA0WGP01_SQ_CAC_sig3_active;
assign      SA1_SQ_activity_sig3[1] = SA1WGP01_SQ_CAC_sig3_active;
assign      SA0_SQ_activity_sig3[2] = SA0WGP02_SQ_CAC_sig3_active;
assign      SA1_SQ_activity_sig3[2] = SA1WGP02_SQ_CAC_sig3_active;

assign      SA0_SQ_activity_sig3[3] = SA0WGP10_SQ_CAC_sig3_active;
assign      SA1_SQ_activity_sig3[3] = SA1WGP10_SQ_CAC_sig3_active;
assign      SA0_SQ_activity_sig3[4] = SA0WGP11_SQ_CAC_sig3_active;
assign      SA1_SQ_activity_sig3[4] = SA1WGP11_SQ_CAC_sig3_active;
assign      SA0_SQ_activity_sig3[31:5] = 27'd0;
assign      SA1_SQ_activity_sig3[31:5] = 27'd0;
wire [31:0] SA0_SQ_activity_sig4;
wire [31:0] SA1_SQ_activity_sig4;
assign      SA0_SQ_activity_sig4[0] = SA0WGP00_SQ_CAC_sig4_active;
assign      SA1_SQ_activity_sig4[0] = SA1WGP00_SQ_CAC_sig4_active;
assign      SA0_SQ_activity_sig4[1] = SA0WGP01_SQ_CAC_sig4_active;
assign      SA1_SQ_activity_sig4[1] = SA1WGP01_SQ_CAC_sig4_active;
assign      SA0_SQ_activity_sig4[2] = SA0WGP02_SQ_CAC_sig4_active;
assign      SA1_SQ_activity_sig4[2] = SA1WGP02_SQ_CAC_sig4_active;

assign      SA0_SQ_activity_sig4[3] = SA0WGP10_SQ_CAC_sig4_active;
assign      SA1_SQ_activity_sig4[3] = SA1WGP10_SQ_CAC_sig4_active;
assign      SA0_SQ_activity_sig4[4] = SA0WGP11_SQ_CAC_sig4_active;
assign      SA1_SQ_activity_sig4[4] = SA1WGP11_SQ_CAC_sig4_active;
assign      SA0_SQ_activity_sig4[31:5] = 27'd0;
assign      SA1_SQ_activity_sig4[31:5] = 27'd0;
wire [31:0] SA0_SQ_activity_sig5;
wire [31:0] SA1_SQ_activity_sig5;
assign      SA0_SQ_activity_sig5[0] = SA0WGP00_SQ_CAC_sig5_active;
assign      SA1_SQ_activity_sig5[0] = SA1WGP00_SQ_CAC_sig5_active;
assign      SA0_SQ_activity_sig5[1] = SA0WGP01_SQ_CAC_sig5_active;
assign      SA1_SQ_activity_sig5[1] = SA1WGP01_SQ_CAC_sig5_active;
assign      SA0_SQ_activity_sig5[2] = SA0WGP02_SQ_CAC_sig5_active;
assign      SA1_SQ_activity_sig5[2] = SA1WGP02_SQ_CAC_sig5_active;

assign      SA0_SQ_activity_sig5[3] = SA0WGP10_SQ_CAC_sig5_active;
assign      SA1_SQ_activity_sig5[3] = SA1WGP10_SQ_CAC_sig5_active;
assign      SA0_SQ_activity_sig5[4] = SA0WGP11_SQ_CAC_sig5_active;
assign      SA1_SQ_activity_sig5[4] = SA1WGP11_SQ_CAC_sig5_active;
assign      SA0_SQ_activity_sig5[31:5] = 27'd0;
assign      SA1_SQ_activity_sig5[31:5] = 27'd0;
wire [31:0] SA0_LDS_activity_sig0;
wire [31:0] SA1_LDS_activity_sig0;
assign      SA0_LDS_activity_sig0[0] = SA0WGP00_LDS0_CAC_sig0_active;
assign      SA1_LDS_activity_sig0[0] = SA1WGP00_LDS0_CAC_sig0_active;
assign      SA0_LDS_activity_sig0[1] = SA0WGP00_LDS1_CAC_sig0_active;
assign      SA1_LDS_activity_sig0[1] = SA1WGP00_LDS1_CAC_sig0_active;
assign      SA0_LDS_activity_sig0[2] = SA0WGP01_LDS0_CAC_sig0_active;
assign      SA1_LDS_activity_sig0[2] = SA1WGP01_LDS0_CAC_sig0_active;
assign      SA0_LDS_activity_sig0[3] = SA0WGP01_LDS1_CAC_sig0_active;
assign      SA1_LDS_activity_sig0[3] = SA1WGP01_LDS1_CAC_sig0_active;
assign      SA0_LDS_activity_sig0[4] = SA0WGP02_LDS0_CAC_sig0_active;
assign      SA1_LDS_activity_sig0[4] = SA1WGP02_LDS0_CAC_sig0_active;
assign      SA0_LDS_activity_sig0[5] = SA0WGP02_LDS1_CAC_sig0_active;
assign      SA1_LDS_activity_sig0[5] = SA1WGP02_LDS1_CAC_sig0_active;

assign      SA0_LDS_activity_sig0[6] = SA0WGP10_LDS0_CAC_sig0_active;
assign      SA1_LDS_activity_sig0[6] = SA1WGP10_LDS0_CAC_sig0_active;
assign      SA0_LDS_activity_sig0[7] = SA0WGP10_LDS1_CAC_sig0_active;
assign      SA1_LDS_activity_sig0[7] = SA1WGP10_LDS1_CAC_sig0_active;
assign      SA0_LDS_activity_sig0[8] = SA0WGP11_LDS0_CAC_sig0_active;
assign      SA1_LDS_activity_sig0[8] = SA1WGP11_LDS0_CAC_sig0_active;
assign      SA0_LDS_activity_sig0[9] = SA0WGP11_LDS1_CAC_sig0_active;
assign      SA1_LDS_activity_sig0[9] = SA1WGP11_LDS1_CAC_sig0_active;
assign      SA0_LDS_activity_sig0[31:10] = 22'd0;
assign      SA1_LDS_activity_sig0[31:10] = 22'd0;
wire [31:0] SA0_LDS_activity_sig1;
wire [31:0] SA1_LDS_activity_sig1;
assign      SA0_LDS_activity_sig1[0] = SA0WGP00_LDS0_CAC_sig1_active;
assign      SA1_LDS_activity_sig1[0] = SA1WGP00_LDS0_CAC_sig1_active;
assign      SA0_LDS_activity_sig1[1] = SA0WGP00_LDS1_CAC_sig1_active;
assign      SA1_LDS_activity_sig1[1] = SA1WGP00_LDS1_CAC_sig1_active;
assign      SA0_LDS_activity_sig1[2] = SA0WGP01_LDS0_CAC_sig1_active;
assign      SA1_LDS_activity_sig1[2] = SA1WGP01_LDS0_CAC_sig1_active;
assign      SA0_LDS_activity_sig1[3] = SA0WGP01_LDS1_CAC_sig1_active;
assign      SA1_LDS_activity_sig1[3] = SA1WGP01_LDS1_CAC_sig1_active;
assign      SA0_LDS_activity_sig1[4] = SA0WGP02_LDS0_CAC_sig1_active;
assign      SA1_LDS_activity_sig1[4] = SA1WGP02_LDS0_CAC_sig1_active;
assign      SA0_LDS_activity_sig1[5] = SA0WGP02_LDS1_CAC_sig1_active;
assign      SA1_LDS_activity_sig1[5] = SA1WGP02_LDS1_CAC_sig1_active;

assign      SA0_LDS_activity_sig1[6] = SA0WGP10_LDS0_CAC_sig1_active;
assign      SA1_LDS_activity_sig1[6] = SA1WGP10_LDS0_CAC_sig1_active;
assign      SA0_LDS_activity_sig1[7] = SA0WGP10_LDS1_CAC_sig1_active;
assign      SA1_LDS_activity_sig1[7] = SA1WGP10_LDS1_CAC_sig1_active;
assign      SA0_LDS_activity_sig1[8] = SA0WGP11_LDS0_CAC_sig1_active;
assign      SA1_LDS_activity_sig1[8] = SA1WGP11_LDS0_CAC_sig1_active;
assign      SA0_LDS_activity_sig1[9] = SA0WGP11_LDS1_CAC_sig1_active;
assign      SA1_LDS_activity_sig1[9] = SA1WGP11_LDS1_CAC_sig1_active;
assign      SA0_LDS_activity_sig1[31:10] = 22'd0;
assign      SA1_LDS_activity_sig1[31:10] = 22'd0;
wire [31:0] SA0_LDS_activity_sig2;
wire [31:0] SA1_LDS_activity_sig2;
assign      SA0_LDS_activity_sig2[0] = SA0WGP00_LDS0_CAC_sig2_active;
assign      SA1_LDS_activity_sig2[0] = SA1WGP00_LDS0_CAC_sig2_active;
assign      SA0_LDS_activity_sig2[1] = SA0WGP00_LDS1_CAC_sig2_active;
assign      SA1_LDS_activity_sig2[1] = SA1WGP00_LDS1_CAC_sig2_active;
assign      SA0_LDS_activity_sig2[2] = SA0WGP01_LDS0_CAC_sig2_active;
assign      SA1_LDS_activity_sig2[2] = SA1WGP01_LDS0_CAC_sig2_active;
assign      SA0_LDS_activity_sig2[3] = SA0WGP01_LDS1_CAC_sig2_active;
assign      SA1_LDS_activity_sig2[3] = SA1WGP01_LDS1_CAC_sig2_active;
assign      SA0_LDS_activity_sig2[4] = SA0WGP02_LDS0_CAC_sig2_active;
assign      SA1_LDS_activity_sig2[4] = SA1WGP02_LDS0_CAC_sig2_active;
assign      SA0_LDS_activity_sig2[5] = SA0WGP02_LDS1_CAC_sig2_active;
assign      SA1_LDS_activity_sig2[5] = SA1WGP02_LDS1_CAC_sig2_active;

assign      SA0_LDS_activity_sig2[6] = SA0WGP10_LDS0_CAC_sig2_active;
assign      SA1_LDS_activity_sig2[6] = SA1WGP10_LDS0_CAC_sig2_active;
assign      SA0_LDS_activity_sig2[7] = SA0WGP10_LDS1_CAC_sig2_active;
assign      SA1_LDS_activity_sig2[7] = SA1WGP10_LDS1_CAC_sig2_active;
assign      SA0_LDS_activity_sig2[8] = SA0WGP11_LDS0_CAC_sig2_active;
assign      SA1_LDS_activity_sig2[8] = SA1WGP11_LDS0_CAC_sig2_active;
assign      SA0_LDS_activity_sig2[9] = SA0WGP11_LDS1_CAC_sig2_active;
assign      SA1_LDS_activity_sig2[9] = SA1WGP11_LDS1_CAC_sig2_active;
assign      SA0_LDS_activity_sig2[31:10] = 22'd0;
assign      SA1_LDS_activity_sig2[31:10] = 22'd0;
wire [31:0] SA0_LDS_activity_sig3;
wire [31:0] SA1_LDS_activity_sig3;
assign      SA0_LDS_activity_sig3[0] = SA0WGP00_LDS0_CAC_sig3_active;
assign      SA1_LDS_activity_sig3[0] = SA1WGP00_LDS0_CAC_sig3_active;
assign      SA0_LDS_activity_sig3[1] = SA0WGP00_LDS1_CAC_sig3_active;
assign      SA1_LDS_activity_sig3[1] = SA1WGP00_LDS1_CAC_sig3_active;
assign      SA0_LDS_activity_sig3[2] = SA0WGP01_LDS0_CAC_sig3_active;
assign      SA1_LDS_activity_sig3[2] = SA1WGP01_LDS0_CAC_sig3_active;
assign      SA0_LDS_activity_sig3[3] = SA0WGP01_LDS1_CAC_sig3_active;
assign      SA1_LDS_activity_sig3[3] = SA1WGP01_LDS1_CAC_sig3_active;
assign      SA0_LDS_activity_sig3[4] = SA0WGP02_LDS0_CAC_sig3_active;
assign      SA1_LDS_activity_sig3[4] = SA1WGP02_LDS0_CAC_sig3_active;
assign      SA0_LDS_activity_sig3[5] = SA0WGP02_LDS1_CAC_sig3_active;
assign      SA1_LDS_activity_sig3[5] = SA1WGP02_LDS1_CAC_sig3_active;

assign      SA0_LDS_activity_sig3[6] = SA0WGP10_LDS0_CAC_sig3_active;
assign      SA1_LDS_activity_sig3[6] = SA1WGP10_LDS0_CAC_sig3_active;
assign      SA0_LDS_activity_sig3[7] = SA0WGP10_LDS1_CAC_sig3_active;
assign      SA1_LDS_activity_sig3[7] = SA1WGP10_LDS1_CAC_sig3_active;
assign      SA0_LDS_activity_sig3[8] = SA0WGP11_LDS0_CAC_sig3_active;
assign      SA1_LDS_activity_sig3[8] = SA1WGP11_LDS0_CAC_sig3_active;
assign      SA0_LDS_activity_sig3[9] = SA0WGP11_LDS1_CAC_sig3_active;
assign      SA1_LDS_activity_sig3[9] = SA1WGP11_LDS1_CAC_sig3_active;
assign      SA0_LDS_activity_sig3[31:10] = 22'd0;
assign      SA1_LDS_activity_sig3[31:10] = 22'd0;

// =====================
//       SE CAC TA
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_TA_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_TA_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_TA_sig0_threshold),
     .ovr_sel                (SA0_TA_sig0_ovr_sel),
     .ovr_val                (SA0_TA_sig0_ovr_val),
     .activity_signals       (SA0_TA_activity_sig0),
     .activity_comb          (SA0_CAC_TA_sig0_active_comb)
);
// =====================
//       SE CAC TA
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_TA_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_TA_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_TA_sig0_threshold),
     .ovr_sel                (SA1_TA_sig0_ovr_sel),
     .ovr_val                (SA1_TA_sig0_ovr_val),
     .activity_signals       (SA1_TA_activity_sig0),
     .activity_comb          (SA1_CAC_TA_sig0_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_TD_sig0 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_TD_sig0_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA0_TD_sig0_threshold),
     .ovr_sel                (SA0_TD_sig0_ovr_sel),
     .ovr_val                (SA0_TD_sig0_ovr_val),
     .activity_signals       (SA0_TD_activity_sig0),
     .activity_comb          (SA0_CAC_TD_sig0_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_TD_sig0 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_TD_sig0_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA1_TD_sig0_threshold),
     .ovr_sel                (SA1_TD_sig0_ovr_sel),
     .ovr_val                (SA1_TD_sig0_ovr_val),
     .activity_signals       (SA1_TD_activity_sig0),
     .activity_comb          (SA1_CAC_TD_sig0_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_TD_sig1 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_TD_sig1_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA0_TD_sig1_threshold),
     .ovr_sel                (SA0_TD_sig1_ovr_sel),
     .ovr_val                (SA0_TD_sig1_ovr_val),
     .activity_signals       (SA0_TD_activity_sig1),
     .activity_comb          (SA0_CAC_TD_sig1_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_TD_sig1 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_TD_sig1_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA1_TD_sig1_threshold),
     .ovr_sel                (SA1_TD_sig1_ovr_sel),
     .ovr_val                (SA1_TD_sig1_ovr_val),
     .activity_signals       (SA1_TD_activity_sig1),
     .activity_comb          (SA1_CAC_TD_sig1_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_TD_sig2 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_TD_sig2_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA0_TD_sig2_threshold),
     .ovr_sel                (SA0_TD_sig2_ovr_sel),
     .ovr_val                (SA0_TD_sig2_ovr_val),
     .activity_signals       (SA0_TD_activity_sig2),
     .activity_comb          (SA0_CAC_TD_sig2_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_TD_sig2 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_TD_sig2_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA1_TD_sig2_threshold),
     .ovr_sel                (SA1_TD_sig2_ovr_sel),
     .ovr_val                (SA1_TD_sig2_ovr_val),
     .activity_signals       (SA1_TD_activity_sig2),
     .activity_comb          (SA1_CAC_TD_sig2_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_TD_sig3 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_TD_sig3_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA0_TD_sig3_threshold),
     .ovr_sel                (SA0_TD_sig3_ovr_sel),
     .ovr_val                (SA0_TD_sig3_ovr_val),
     .activity_signals       (SA0_TD_activity_sig3),
     .activity_comb          (SA0_CAC_TD_sig3_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_TD_sig3 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_TD_sig3_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA1_TD_sig3_threshold),
     .ovr_sel                (SA1_TD_sig3_ovr_sel),
     .ovr_val                (SA1_TD_sig3_ovr_val),
     .activity_signals       (SA1_TD_activity_sig3),
     .activity_comb          (SA1_CAC_TD_sig3_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_TD_sig4 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_TD_sig4_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA0_TD_sig4_threshold),
     .ovr_sel                (SA0_TD_sig4_ovr_sel),
     .ovr_val                (SA0_TD_sig4_ovr_val),
     .activity_signals       (SA0_TD_activity_sig4),
     .activity_comb          (SA0_CAC_TD_sig4_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_TD_sig4 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_TD_sig4_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA1_TD_sig4_threshold),
     .ovr_sel                (SA1_TD_sig4_ovr_sel),
     .ovr_val                (SA1_TD_sig4_ovr_val),
     .activity_signals       (SA1_TD_activity_sig4),
     .activity_comb          (SA1_CAC_TD_sig4_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_TD_sig5 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_TD_sig5_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA0_TD_sig5_threshold),
     .ovr_sel                (SA0_TD_sig5_ovr_sel),
     .ovr_val                (SA0_TD_sig5_ovr_val),
     .activity_signals       (SA0_TD_activity_sig5),
     .activity_comb          (SA0_CAC_TD_sig5_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_TD_sig5 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_TD_sig5_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA1_TD_sig5_threshold),
     .ovr_sel                (SA1_TD_sig5_ovr_sel),
     .ovr_val                (SA1_TD_sig5_ovr_val),
     .activity_signals       (SA1_TD_activity_sig5),
     .activity_comb          (SA1_CAC_TD_sig5_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_TD_sig6 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_TD_sig6_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA0_TD_sig6_threshold),
     .ovr_sel                (SA0_TD_sig6_ovr_sel),
     .ovr_val                (SA0_TD_sig6_ovr_val),
     .activity_signals       (SA0_TD_activity_sig6),
     .activity_comb          (SA0_CAC_TD_sig6_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_TD_sig6 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_TD_sig6_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA1_TD_sig6_threshold),
     .ovr_sel                (SA1_TD_sig6_ovr_sel),
     .ovr_val                (SA1_TD_sig6_ovr_val),
     .activity_signals       (SA1_TD_activity_sig6),
     .activity_comb          (SA1_CAC_TD_sig6_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_TD_sig7 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_TD_sig7_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA0_TD_sig7_threshold),
     .ovr_sel                (SA0_TD_sig7_ovr_sel),
     .ovr_val                (SA0_TD_sig7_ovr_val),
     .activity_signals       (SA0_TD_activity_sig7),
     .activity_comb          (SA0_CAC_TD_sig7_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_TD_sig7 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_TD_sig7_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA1_TD_sig7_threshold),
     .ovr_sel                (SA1_TD_sig7_ovr_sel),
     .ovr_val                (SA1_TD_sig7_ovr_val),
     .activity_signals       (SA1_TD_activity_sig7),
     .activity_comb          (SA1_CAC_TD_sig7_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_TD_sig8 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_TD_sig8_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA0_TD_sig8_threshold),
     .ovr_sel                (SA0_TD_sig8_ovr_sel),
     .ovr_val                (SA0_TD_sig8_ovr_val),
     .activity_signals       (SA0_TD_activity_sig8),
     .activity_comb          (SA0_CAC_TD_sig8_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_TD_sig8 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_TD_sig8_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA1_TD_sig8_threshold),
     .ovr_sel                (SA1_TD_sig8_ovr_sel),
     .ovr_val                (SA1_TD_sig8_ovr_val),
     .activity_signals       (SA1_TD_activity_sig8),
     .activity_comb          (SA1_CAC_TD_sig8_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_TD_sig9 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_TD_sig9_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA0_TD_sig9_threshold),
     .ovr_sel                (SA0_TD_sig9_ovr_sel),
     .ovr_val                (SA0_TD_sig9_ovr_val),
     .activity_signals       (SA0_TD_activity_sig9),
     .activity_comb          (SA0_CAC_TD_sig9_active_comb)
);
// =====================
//       SE CAC TD
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_TD_sig9 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_TD_sig9_force_disable ? 1'b0 : (se_lcac_enable || TD_didt_edc_enable)),
     .threshold              (SA1_TD_sig9_threshold),
     .ovr_sel                (SA1_TD_sig9_ovr_sel),
     .ovr_val                (SA1_TD_sig9_ovr_val),
     .activity_signals       (SA1_TD_activity_sig9),
     .activity_comb          (SA1_CAC_TD_sig9_active_comb)
);
// =====================
//       SE CAC TCP
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_TCP_sig0 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_TCP_sig0_force_disable ? 1'b0 : (se_lcac_enable || TCP_didt_edc_enable)),
     .threshold              (SA0_TCP_sig0_threshold),
     .ovr_sel                (SA0_TCP_sig0_ovr_sel),
     .ovr_val                (SA0_TCP_sig0_ovr_val),
     .activity_signals       (SA0_TCP_activity_sig0),
     .activity_comb          (SA0_CAC_TCP_sig0_active_comb)
);
// =====================
//       SE CAC TCP
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_TCP_sig0 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_TCP_sig0_force_disable ? 1'b0 : (se_lcac_enable || TCP_didt_edc_enable)),
     .threshold              (SA1_TCP_sig0_threshold),
     .ovr_sel                (SA1_TCP_sig0_ovr_sel),
     .ovr_val                (SA1_TCP_sig0_ovr_val),
     .activity_signals       (SA1_TCP_activity_sig0),
     .activity_comb          (SA1_CAC_TCP_sig0_active_comb)
);
// =====================
//       SE CAC TCP
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_TCP_sig1 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_TCP_sig1_force_disable ? 1'b0 : (se_lcac_enable || TCP_didt_edc_enable)),
     .threshold              (SA0_TCP_sig1_threshold),
     .ovr_sel                (SA0_TCP_sig1_ovr_sel),
     .ovr_val                (SA0_TCP_sig1_ovr_val),
     .activity_signals       (SA0_TCP_activity_sig1),
     .activity_comb          (SA0_CAC_TCP_sig1_active_comb)
);
// =====================
//       SE CAC TCP
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_TCP_sig1 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_TCP_sig1_force_disable ? 1'b0 : (se_lcac_enable || TCP_didt_edc_enable)),
     .threshold              (SA1_TCP_sig1_threshold),
     .ovr_sel                (SA1_TCP_sig1_ovr_sel),
     .ovr_val                (SA1_TCP_sig1_ovr_val),
     .activity_signals       (SA1_TCP_activity_sig1),
     .activity_comb          (SA1_CAC_TCP_sig1_active_comb)
);
// =====================
//       SE CAC TCP
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_TCP_sig2 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_TCP_sig2_force_disable ? 1'b0 : (se_lcac_enable || TCP_didt_edc_enable)),
     .threshold              (SA0_TCP_sig2_threshold),
     .ovr_sel                (SA0_TCP_sig2_ovr_sel),
     .ovr_val                (SA0_TCP_sig2_ovr_val),
     .activity_signals       (SA0_TCP_activity_sig2),
     .activity_comb          (SA0_CAC_TCP_sig2_active_comb)
);
// =====================
//       SE CAC TCP
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_TCP_sig2 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_TCP_sig2_force_disable ? 1'b0 : (se_lcac_enable || TCP_didt_edc_enable)),
     .threshold              (SA1_TCP_sig2_threshold),
     .ovr_sel                (SA1_TCP_sig2_ovr_sel),
     .ovr_val                (SA1_TCP_sig2_ovr_val),
     .activity_signals       (SA1_TCP_activity_sig2),
     .activity_comb          (SA1_CAC_TCP_sig2_active_comb)
);
// =====================
//       SE CAC TCP
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_TCP_sig3 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_TCP_sig3_force_disable ? 1'b0 : (se_lcac_enable || TCP_didt_edc_enable)),
     .threshold              (SA0_TCP_sig3_threshold),
     .ovr_sel                (SA0_TCP_sig3_ovr_sel),
     .ovr_val                (SA0_TCP_sig3_ovr_val),
     .activity_signals       (SA0_TCP_activity_sig3),
     .activity_comb          (SA0_CAC_TCP_sig3_active_comb)
);
// =====================
//       SE CAC TCP
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_TCP_sig3 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_TCP_sig3_force_disable ? 1'b0 : (se_lcac_enable || TCP_didt_edc_enable)),
     .threshold              (SA1_TCP_sig3_threshold),
     .ovr_sel                (SA1_TCP_sig3_ovr_sel),
     .ovr_val                (SA1_TCP_sig3_ovr_val),
     .activity_signals       (SA1_TCP_activity_sig3),
     .activity_comb          (SA1_CAC_TCP_sig3_active_comb)
);
// =====================
//       SE CAC TCP
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_TCP_sig4 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_TCP_sig4_force_disable ? 1'b0 : (se_lcac_enable || TCP_didt_edc_enable)),
     .threshold              (SA0_TCP_sig4_threshold),
     .ovr_sel                (SA0_TCP_sig4_ovr_sel),
     .ovr_val                (SA0_TCP_sig4_ovr_val),
     .activity_signals       (SA0_TCP_activity_sig4),
     .activity_comb          (SA0_CAC_TCP_sig4_active_comb)
);
// =====================
//       SE CAC TCP
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_TCP_sig4 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_TCP_sig4_force_disable ? 1'b0 : (se_lcac_enable || TCP_didt_edc_enable)),
     .threshold              (SA1_TCP_sig4_threshold),
     .ovr_sel                (SA1_TCP_sig4_ovr_sel),
     .ovr_val                (SA1_TCP_sig4_ovr_val),
     .activity_signals       (SA1_TCP_activity_sig4),
     .activity_comb          (SA1_CAC_TCP_sig4_active_comb)
);
// =====================
//       SE CAC SQ
// =====================
local_cac_gc #(.ACT_WIDTH(5), .OVR_WIDTH(5)) lcac_SA0_SQ_sig0 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_SQ_sig0_force_disable ? 1'b0 : (se_lcac_enable || SQ_didt_edc_enable)),
     .threshold              (SA0_SQ_sig0_threshold),
     .ovr_sel                (SA0_SQ_sig0_ovr_sel),
     .ovr_val                (SA0_SQ_sig0_ovr_val),
     .activity_signals       (SA0_SQ_activity_sig0),
     .activity_comb          (SA0_CAC_SQ_sig0_active_comb)
);
// =====================
//       SE CAC SQ
// =====================
local_cac_gc #(.ACT_WIDTH(5), .OVR_WIDTH(5)) lcac_SA1_SQ_sig0 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_SQ_sig0_force_disable ? 1'b0 : (se_lcac_enable || SQ_didt_edc_enable)),
     .threshold              (SA1_SQ_sig0_threshold),
     .ovr_sel                (SA1_SQ_sig0_ovr_sel),
     .ovr_val                (SA1_SQ_sig0_ovr_val),
     .activity_signals       (SA1_SQ_activity_sig0),
     .activity_comb          (SA1_CAC_SQ_sig0_active_comb)
);
// =====================
//       SE CAC SQ
// =====================
local_cac_gc #(.ACT_WIDTH(5), .OVR_WIDTH(5)) lcac_SA0_SQ_sig1 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_SQ_sig1_force_disable ? 1'b0 : (se_lcac_enable || SQ_didt_edc_enable)),
     .threshold              (SA0_SQ_sig1_threshold),
     .ovr_sel                (SA0_SQ_sig1_ovr_sel),
     .ovr_val                (SA0_SQ_sig1_ovr_val),
     .activity_signals       (SA0_SQ_activity_sig1),
     .activity_comb          (SA0_CAC_SQ_sig1_active_comb)
);
// =====================
//       SE CAC SQ
// =====================
local_cac_gc #(.ACT_WIDTH(5), .OVR_WIDTH(5)) lcac_SA1_SQ_sig1 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_SQ_sig1_force_disable ? 1'b0 : (se_lcac_enable || SQ_didt_edc_enable)),
     .threshold              (SA1_SQ_sig1_threshold),
     .ovr_sel                (SA1_SQ_sig1_ovr_sel),
     .ovr_val                (SA1_SQ_sig1_ovr_val),
     .activity_signals       (SA1_SQ_activity_sig1),
     .activity_comb          (SA1_CAC_SQ_sig1_active_comb)
);
// =====================
//       SE CAC SQ
// =====================
local_cac_gc #(.ACT_WIDTH(5), .OVR_WIDTH(5)) lcac_SA0_SQ_sig2 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_SQ_sig2_force_disable ? 1'b0 : (se_lcac_enable || SQ_didt_edc_enable)),
     .threshold              (SA0_SQ_sig2_threshold),
     .ovr_sel                (SA0_SQ_sig2_ovr_sel),
     .ovr_val                (SA0_SQ_sig2_ovr_val),
     .activity_signals       (SA0_SQ_activity_sig2),
     .activity_comb          (SA0_CAC_SQ_sig2_active_comb)
);
// =====================
//       SE CAC SQ
// =====================
local_cac_gc #(.ACT_WIDTH(5), .OVR_WIDTH(5)) lcac_SA1_SQ_sig2 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_SQ_sig2_force_disable ? 1'b0 : (se_lcac_enable || SQ_didt_edc_enable)),
     .threshold              (SA1_SQ_sig2_threshold),
     .ovr_sel                (SA1_SQ_sig2_ovr_sel),
     .ovr_val                (SA1_SQ_sig2_ovr_val),
     .activity_signals       (SA1_SQ_activity_sig2),
     .activity_comb          (SA1_CAC_SQ_sig2_active_comb)
);
// =====================
//       SE CAC SQ
// =====================
local_cac_gc #(.ACT_WIDTH(5), .OVR_WIDTH(5)) lcac_SA0_SQ_sig3 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_SQ_sig3_force_disable ? 1'b0 : (se_lcac_enable || SQ_didt_edc_enable)),
     .threshold              (SA0_SQ_sig3_threshold),
     .ovr_sel                (SA0_SQ_sig3_ovr_sel),
     .ovr_val                (SA0_SQ_sig3_ovr_val),
     .activity_signals       (SA0_SQ_activity_sig3),
     .activity_comb          (SA0_CAC_SQ_sig3_active_comb)
);
// =====================
//       SE CAC SQ
// =====================
local_cac_gc #(.ACT_WIDTH(5), .OVR_WIDTH(5)) lcac_SA1_SQ_sig3 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_SQ_sig3_force_disable ? 1'b0 : (se_lcac_enable || SQ_didt_edc_enable)),
     .threshold              (SA1_SQ_sig3_threshold),
     .ovr_sel                (SA1_SQ_sig3_ovr_sel),
     .ovr_val                (SA1_SQ_sig3_ovr_val),
     .activity_signals       (SA1_SQ_activity_sig3),
     .activity_comb          (SA1_CAC_SQ_sig3_active_comb)
);
// =====================
//       SE CAC SQ
// =====================
local_cac_gc #(.ACT_WIDTH(5), .OVR_WIDTH(5)) lcac_SA0_SQ_sig4 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_SQ_sig4_force_disable ? 1'b0 : (se_lcac_enable || SQ_didt_edc_enable)),
     .threshold              (SA0_SQ_sig4_threshold),
     .ovr_sel                (SA0_SQ_sig4_ovr_sel),
     .ovr_val                (SA0_SQ_sig4_ovr_val),
     .activity_signals       (SA0_SQ_activity_sig4),
     .activity_comb          (SA0_CAC_SQ_sig4_active_comb)
);
// =====================
//       SE CAC SQ
// =====================
local_cac_gc #(.ACT_WIDTH(5), .OVR_WIDTH(5)) lcac_SA1_SQ_sig4 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_SQ_sig4_force_disable ? 1'b0 : (se_lcac_enable || SQ_didt_edc_enable)),
     .threshold              (SA1_SQ_sig4_threshold),
     .ovr_sel                (SA1_SQ_sig4_ovr_sel),
     .ovr_val                (SA1_SQ_sig4_ovr_val),
     .activity_signals       (SA1_SQ_activity_sig4),
     .activity_comb          (SA1_CAC_SQ_sig4_active_comb)
);
// =====================
//       SE CAC SQ
// =====================
local_cac_gc #(.ACT_WIDTH(5), .OVR_WIDTH(5)) lcac_SA0_SQ_sig5 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_SQ_sig5_force_disable ? 1'b0 : (se_lcac_enable || SQ_didt_edc_enable)),
     .threshold              (SA0_SQ_sig5_threshold),
     .ovr_sel                (SA0_SQ_sig5_ovr_sel),
     .ovr_val                (SA0_SQ_sig5_ovr_val),
     .activity_signals       (SA0_SQ_activity_sig5),
     .activity_comb          (SA0_CAC_SQ_sig5_active_comb)
);
// =====================
//       SE CAC SQ
// =====================
local_cac_gc #(.ACT_WIDTH(5), .OVR_WIDTH(5)) lcac_SA1_SQ_sig5 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_SQ_sig5_force_disable ? 1'b0 : (se_lcac_enable || SQ_didt_edc_enable)),
     .threshold              (SA1_SQ_sig5_threshold),
     .ovr_sel                (SA1_SQ_sig5_ovr_sel),
     .ovr_val                (SA1_SQ_sig5_ovr_val),
     .activity_signals       (SA1_SQ_activity_sig5),
     .activity_comb          (SA1_CAC_SQ_sig5_active_comb)
);
// =====================
//       SE CAC LDS
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_LDS_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_LDS_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_LDS_sig0_threshold),
     .ovr_sel                (SA0_LDS_sig0_ovr_sel),
     .ovr_val                (SA0_LDS_sig0_ovr_val),
     .activity_signals       (SA0_LDS_activity_sig0),
     .activity_comb          (SA0_CAC_LDS_sig0_active_comb)
);
// =====================
//       SE CAC LDS
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_LDS_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_LDS_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_LDS_sig0_threshold),
     .ovr_sel                (SA1_LDS_sig0_ovr_sel),
     .ovr_val                (SA1_LDS_sig0_ovr_val),
     .activity_signals       (SA1_LDS_activity_sig0),
     .activity_comb          (SA1_CAC_LDS_sig0_active_comb)
);
// =====================
//       SE CAC LDS
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_LDS_sig1 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_LDS_sig1_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_LDS_sig1_threshold),
     .ovr_sel                (SA0_LDS_sig1_ovr_sel),
     .ovr_val                (SA0_LDS_sig1_ovr_val),
     .activity_signals       (SA0_LDS_activity_sig1),
     .activity_comb          (SA0_CAC_LDS_sig1_active_comb)
);
// =====================
//       SE CAC LDS
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_LDS_sig1 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_LDS_sig1_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_LDS_sig1_threshold),
     .ovr_sel                (SA1_LDS_sig1_ovr_sel),
     .ovr_val                (SA1_LDS_sig1_ovr_val),
     .activity_signals       (SA1_LDS_activity_sig1),
     .activity_comb          (SA1_CAC_LDS_sig1_active_comb)
);
// =====================
//       SE CAC LDS
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_LDS_sig2 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_LDS_sig2_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_LDS_sig2_threshold),
     .ovr_sel                (SA0_LDS_sig2_ovr_sel),
     .ovr_val                (SA0_LDS_sig2_ovr_val),
     .activity_signals       (SA0_LDS_activity_sig2),
     .activity_comb          (SA0_CAC_LDS_sig2_active_comb)
);
// =====================
//       SE CAC LDS
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_LDS_sig2 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_LDS_sig2_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_LDS_sig2_threshold),
     .ovr_sel                (SA1_LDS_sig2_ovr_sel),
     .ovr_val                (SA1_LDS_sig2_ovr_val),
     .activity_signals       (SA1_LDS_activity_sig2),
     .activity_comb          (SA1_CAC_LDS_sig2_active_comb)
);
// =====================
//       SE CAC LDS
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_LDS_sig3 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_LDS_sig3_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_LDS_sig3_threshold),
     .ovr_sel                (SA0_LDS_sig3_ovr_sel),
     .ovr_val                (SA0_LDS_sig3_ovr_val),
     .activity_signals       (SA0_LDS_activity_sig3),
     .activity_comb          (SA0_CAC_LDS_sig3_active_comb)
);
// =====================
//       SE CAC LDS
// =====================
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_LDS_sig3 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_LDS_sig3_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_LDS_sig3_threshold),
     .ovr_sel                (SA1_LDS_sig3_ovr_sel),
     .ovr_val                (SA1_LDS_sig3_ovr_val),
     .activity_signals       (SA1_LDS_activity_sig3),
     .activity_comb          (SA1_CAC_LDS_sig3_active_comb)
);
// ============================================================
// ================         Local SA CACs        =================
// ============================================================
wire [31:0] SA0_BCI_activity_sig0;
wire [31:0] SA1_BCI_activity_sig0;
assign      SA0_BCI_activity_sig0[0] = SA0BCI_CAC_sig0_active;
assign      SA1_BCI_activity_sig0[0] = SA1BCI_CAC_sig0_active;
assign      SA0_BCI_activity_sig0[31:1] = 31'd0;
assign      SA1_BCI_activity_sig0[31:1] = 31'd0;
wire [31:0] SA0_BCI_activity_sig1;
wire [31:0] SA1_BCI_activity_sig1;
assign      SA0_BCI_activity_sig1[0] = SA0BCI_CAC_sig1_active;
assign      SA1_BCI_activity_sig1[0] = SA1BCI_CAC_sig1_active;
assign      SA0_BCI_activity_sig1[31:1] = 31'd0;
assign      SA1_BCI_activity_sig1[31:1] = 31'd0;
wire [31:0] SA0_CB_activity_sig0;
wire [31:0] SA1_CB_activity_sig0;
assign      SA0_CB_activity_sig0[0] = SA0CB0_CAC_sig0_active;
assign      SA1_CB_activity_sig0[0] = SA1CB0_CAC_sig0_active;
assign      SA0_CB_activity_sig0[1] = SA0CB1_CAC_sig0_active;
assign      SA1_CB_activity_sig0[1] = SA1CB1_CAC_sig0_active;
assign      SA0_CB_activity_sig0[2] = SA0CB2_CAC_sig0_active;
assign      SA1_CB_activity_sig0[2] = SA1CB2_CAC_sig0_active;
assign      SA0_CB_activity_sig0[3] = SA0CB3_CAC_sig0_active;
assign      SA1_CB_activity_sig0[3] = SA1CB3_CAC_sig0_active;
assign      SA0_CB_activity_sig0[31:4] = 28'd0;
assign      SA1_CB_activity_sig0[31:4] = 28'd0;
wire [31:0] SA0_CB_activity_sig1;
wire [31:0] SA1_CB_activity_sig1;
assign      SA0_CB_activity_sig1[0] = SA0CB0_CAC_sig1_active;
assign      SA1_CB_activity_sig1[0] = SA1CB0_CAC_sig1_active;
assign      SA0_CB_activity_sig1[1] = SA0CB1_CAC_sig1_active;
assign      SA1_CB_activity_sig1[1] = SA1CB1_CAC_sig1_active;
assign      SA0_CB_activity_sig1[2] = SA0CB2_CAC_sig1_active;
assign      SA1_CB_activity_sig1[2] = SA1CB2_CAC_sig1_active;
assign      SA0_CB_activity_sig1[3] = SA0CB3_CAC_sig1_active;
assign      SA1_CB_activity_sig1[3] = SA1CB3_CAC_sig1_active;
assign      SA0_CB_activity_sig1[31:4] = 28'd0;
assign      SA1_CB_activity_sig1[31:4] = 28'd0;
wire [31:0] SA0_CB_activity_sig2;
wire [31:0] SA1_CB_activity_sig2;
assign      SA0_CB_activity_sig2[0] = SA0CB0_CAC_sig2_active;
assign      SA1_CB_activity_sig2[0] = SA1CB0_CAC_sig2_active;
assign      SA0_CB_activity_sig2[1] = SA0CB1_CAC_sig2_active;
assign      SA1_CB_activity_sig2[1] = SA1CB1_CAC_sig2_active;
assign      SA0_CB_activity_sig2[2] = SA0CB2_CAC_sig2_active;
assign      SA1_CB_activity_sig2[2] = SA1CB2_CAC_sig2_active;
assign      SA0_CB_activity_sig2[3] = SA0CB3_CAC_sig2_active;
assign      SA1_CB_activity_sig2[3] = SA1CB3_CAC_sig2_active;
assign      SA0_CB_activity_sig2[31:4] = 28'd0;
assign      SA1_CB_activity_sig2[31:4] = 28'd0;
wire [31:0] SA0_CB_activity_sig3;
wire [31:0] SA1_CB_activity_sig3;
assign      SA0_CB_activity_sig3[0] = SA0CB0_CAC_sig3_active;
assign      SA1_CB_activity_sig3[0] = SA1CB0_CAC_sig3_active;
assign      SA0_CB_activity_sig3[1] = SA0CB1_CAC_sig3_active;
assign      SA1_CB_activity_sig3[1] = SA1CB1_CAC_sig3_active;
assign      SA0_CB_activity_sig3[2] = SA0CB2_CAC_sig3_active;
assign      SA1_CB_activity_sig3[2] = SA1CB2_CAC_sig3_active;
assign      SA0_CB_activity_sig3[3] = SA0CB3_CAC_sig3_active;
assign      SA1_CB_activity_sig3[3] = SA1CB3_CAC_sig3_active;
assign      SA0_CB_activity_sig3[31:4] = 28'd0;
assign      SA1_CB_activity_sig3[31:4] = 28'd0;
wire [31:0] SA0_DB_activity_sig0;
wire [31:0] SA1_DB_activity_sig0;
assign      SA0_DB_activity_sig0[0] = SA0DB0_CAC_sig0_active;
assign      SA1_DB_activity_sig0[0] = SA1DB0_CAC_sig0_active;
assign      SA0_DB_activity_sig0[1] = SA0DB1_CAC_sig0_active;
assign      SA1_DB_activity_sig0[1] = SA1DB1_CAC_sig0_active;
assign      SA0_DB_activity_sig0[2] = SA0DB2_CAC_sig0_active;
assign      SA1_DB_activity_sig0[2] = SA1DB2_CAC_sig0_active;
assign      SA0_DB_activity_sig0[3] = SA0DB3_CAC_sig0_active;
assign      SA1_DB_activity_sig0[3] = SA1DB3_CAC_sig0_active;
assign      SA0_DB_activity_sig0[31:4] = 28'd0;
assign      SA1_DB_activity_sig0[31:4] = 28'd0;
wire [31:0] SA0_DB_activity_sig1;
wire [31:0] SA1_DB_activity_sig1;
assign      SA0_DB_activity_sig1[0] = SA0DB0_CAC_sig1_active;
assign      SA1_DB_activity_sig1[0] = SA1DB0_CAC_sig1_active;
assign      SA0_DB_activity_sig1[1] = SA0DB1_CAC_sig1_active;
assign      SA1_DB_activity_sig1[1] = SA1DB1_CAC_sig1_active;
assign      SA0_DB_activity_sig1[2] = SA0DB2_CAC_sig1_active;
assign      SA1_DB_activity_sig1[2] = SA1DB2_CAC_sig1_active;
assign      SA0_DB_activity_sig1[3] = SA0DB3_CAC_sig1_active;
assign      SA1_DB_activity_sig1[3] = SA1DB3_CAC_sig1_active;
assign      SA0_DB_activity_sig1[31:4] = 28'd0;
assign      SA1_DB_activity_sig1[31:4] = 28'd0;
wire [31:0] SA0_DB_activity_sig2;
wire [31:0] SA1_DB_activity_sig2;
assign      SA0_DB_activity_sig2[0] = SA0DB0_CAC_sig2_active;
assign      SA1_DB_activity_sig2[0] = SA1DB0_CAC_sig2_active;
assign      SA0_DB_activity_sig2[1] = SA0DB1_CAC_sig2_active;
assign      SA1_DB_activity_sig2[1] = SA1DB1_CAC_sig2_active;
assign      SA0_DB_activity_sig2[2] = SA0DB2_CAC_sig2_active;
assign      SA1_DB_activity_sig2[2] = SA1DB2_CAC_sig2_active;
assign      SA0_DB_activity_sig2[3] = SA0DB3_CAC_sig2_active;
assign      SA1_DB_activity_sig2[3] = SA1DB3_CAC_sig2_active;
assign      SA0_DB_activity_sig2[31:4] = 28'd0;
assign      SA1_DB_activity_sig2[31:4] = 28'd0;
wire [31:0] SA0_DB_activity_sig3;
wire [31:0] SA1_DB_activity_sig3;
assign      SA0_DB_activity_sig3[0] = SA0DB0_CAC_sig3_active;
assign      SA1_DB_activity_sig3[0] = SA1DB0_CAC_sig3_active;
assign      SA0_DB_activity_sig3[1] = SA0DB1_CAC_sig3_active;
assign      SA1_DB_activity_sig3[1] = SA1DB1_CAC_sig3_active;
assign      SA0_DB_activity_sig3[2] = SA0DB2_CAC_sig3_active;
assign      SA1_DB_activity_sig3[2] = SA1DB2_CAC_sig3_active;
assign      SA0_DB_activity_sig3[3] = SA0DB3_CAC_sig3_active;
assign      SA1_DB_activity_sig3[3] = SA1DB3_CAC_sig3_active;
assign      SA0_DB_activity_sig3[31:4] = 28'd0;
assign      SA1_DB_activity_sig3[31:4] = 28'd0;
wire [31:0] SA0_PA_activity_sig0;
wire [31:0] SA1_PA_activity_sig0;
assign      SA0_PA_activity_sig0[0] = SA0PA_CAC_sig0_active;
assign      SA1_PA_activity_sig0[0] = SA1PA_CAC_sig0_active;
assign      SA0_PA_activity_sig0[31:1] = 31'd0;
assign      SA1_PA_activity_sig0[31:1] = 31'd0;
wire [31:0] SA0_PA_activity_sig1;
wire [31:0] SA1_PA_activity_sig1;
assign      SA0_PA_activity_sig1[0] = SA0PA_CAC_sig1_active;
assign      SA1_PA_activity_sig1[0] = SA1PA_CAC_sig1_active;
assign      SA0_PA_activity_sig1[31:1] = 31'd0;
assign      SA1_PA_activity_sig1[31:1] = 31'd0;
wire [31:0] SA0_RMI_activity_sig0;
wire [31:0] SA1_RMI_activity_sig0;
assign      SA0_RMI_activity_sig0[0] = SA0RMI0_CAC_sig0_active;
assign      SA1_RMI_activity_sig0[0] = SA1RMI0_CAC_sig0_active;
assign      SA0_RMI_activity_sig0[1] = SA0RMI1_CAC_sig0_active;
assign      SA1_RMI_activity_sig0[1] = SA1RMI1_CAC_sig0_active;
assign      SA0_RMI_activity_sig0[31:2] = 30'd0;
assign      SA1_RMI_activity_sig0[31:2] = 30'd0;
wire [31:0] SA0_SC_activity_sig0;
wire [31:0] SA1_SC_activity_sig0;
assign      SA0_SC_activity_sig0[0] = SA0SC_CAC_sig0_active;
assign      SA1_SC_activity_sig0[0] = SA1SC_CAC_sig0_active;
assign      SA0_SC_activity_sig0[31:1] = 31'd0;
assign      SA1_SC_activity_sig0[31:1] = 31'd0;
wire [31:0] SA0_SX_activity_sig0;
wire [31:0] SA1_SX_activity_sig0;
assign      SA0_SX_activity_sig0[0] = SA0SX_CAC_sig0_active;
assign      SA1_SX_activity_sig0[0] = SA1SX_CAC_sig0_active;
assign      SA0_SX_activity_sig0[31:1] = 31'd0;
assign      SA1_SX_activity_sig0[31:1] = 31'd0;
wire [31:0] SA0_SXRB_activity_sig0;
wire [31:0] SA1_SXRB_activity_sig0;
assign      SA0_SXRB_activity_sig0[0] = SA0SXRB0_CAC_sig0_active;
assign      SA1_SXRB_activity_sig0[0] = SA1SXRB0_CAC_sig0_active;
assign      SA0_SXRB_activity_sig0[1] = SA0SXRB1_CAC_sig0_active;
assign      SA1_SXRB_activity_sig0[1] = SA1SXRB1_CAC_sig0_active;
assign      SA0_SXRB_activity_sig0[2] = SA0SXRB2_CAC_sig0_active;
assign      SA1_SXRB_activity_sig0[2] = SA1SXRB2_CAC_sig0_active;
assign      SA0_SXRB_activity_sig0[3] = SA0SXRB3_CAC_sig0_active;
assign      SA1_SXRB_activity_sig0[3] = SA1SXRB3_CAC_sig0_active;
assign      SA0_SXRB_activity_sig0[31:4] = 28'd0;
assign      SA1_SXRB_activity_sig0[31:4] = 28'd0;
wire [31:0] SA0_UTCL1_activity_sig0;
wire [31:0] SA1_UTCL1_activity_sig0;
assign      SA0_UTCL1_activity_sig0[0] = SA0UTCL1_CAC_sig0_active;
assign      SA1_UTCL1_activity_sig0[0] = SA1UTCL1_CAC_sig0_active;
assign      SA0_UTCL1_activity_sig0[31:1] = 31'd0;
assign      SA1_UTCL1_activity_sig0[31:1] = 31'd0;

// =====================
//       SE CAC BCI
// =====================
local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SA0_BCI_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_BCI_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_BCI_sig0_threshold),
     .ovr_sel                (SA0_BCI_sig0_ovr_sel),
     .ovr_val                (SA0_BCI_sig0_ovr_val),
     .activity_signals       (SA0_BCI_activity_sig0),
     .activity_comb          (SA0_CAC_BCI_sig0_active_comb)
);
// =====================
//       SE CAC BCI
// =====================
local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SA1_BCI_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_BCI_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_BCI_sig0_threshold),
     .ovr_sel                (SA1_BCI_sig0_ovr_sel),
     .ovr_val                (SA1_BCI_sig0_ovr_val),
     .activity_signals       (SA1_BCI_activity_sig0),
     .activity_comb          (SA1_CAC_BCI_sig0_active_comb)
);
// =====================
//       SE CAC BCI
// =====================
local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SA0_BCI_sig1 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_BCI_sig1_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_BCI_sig1_threshold),
     .ovr_sel                (SA0_BCI_sig1_ovr_sel),
     .ovr_val                (SA0_BCI_sig1_ovr_val),
     .activity_signals       (SA0_BCI_activity_sig1),
     .activity_comb          (SA0_CAC_BCI_sig1_active_comb)
);
// =====================
//       SE CAC BCI
// =====================
local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SA1_BCI_sig1 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_BCI_sig1_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_BCI_sig1_threshold),
     .ovr_sel                (SA1_BCI_sig1_ovr_sel),
     .ovr_val                (SA1_BCI_sig1_ovr_val),
     .activity_signals       (SA1_BCI_activity_sig1),
     .activity_comb          (SA1_CAC_BCI_sig1_active_comb)
);
// =====================
//       SE CAC CB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA0_CB_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_CB_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_CB_sig0_threshold),
     .ovr_sel                (SA0_CB_sig0_ovr_sel),
     .ovr_val                (SA0_CB_sig0_ovr_val),
     .activity_signals       (SA0_CB_activity_sig0),
     .activity_comb          (SA0_CAC_CB_sig0_active_comb)
);
// =====================
//       SE CAC CB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA1_CB_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_CB_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_CB_sig0_threshold),
     .ovr_sel                (SA1_CB_sig0_ovr_sel),
     .ovr_val                (SA1_CB_sig0_ovr_val),
     .activity_signals       (SA1_CB_activity_sig0),
     .activity_comb          (SA1_CAC_CB_sig0_active_comb)
);
// =====================
//       SE CAC CB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA0_CB_sig1 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_CB_sig1_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_CB_sig1_threshold),
     .ovr_sel                (SA0_CB_sig1_ovr_sel),
     .ovr_val                (SA0_CB_sig1_ovr_val),
     .activity_signals       (SA0_CB_activity_sig1),
     .activity_comb          (SA0_CAC_CB_sig1_active_comb)
);
// =====================
//       SE CAC CB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA1_CB_sig1 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_CB_sig1_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_CB_sig1_threshold),
     .ovr_sel                (SA1_CB_sig1_ovr_sel),
     .ovr_val                (SA1_CB_sig1_ovr_val),
     .activity_signals       (SA1_CB_activity_sig1),
     .activity_comb          (SA1_CAC_CB_sig1_active_comb)
);
// =====================
//       SE CAC CB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA0_CB_sig2 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_CB_sig2_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_CB_sig2_threshold),
     .ovr_sel                (SA0_CB_sig2_ovr_sel),
     .ovr_val                (SA0_CB_sig2_ovr_val),
     .activity_signals       (SA0_CB_activity_sig2),
     .activity_comb          (SA0_CAC_CB_sig2_active_comb)
);
// =====================
//       SE CAC CB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA1_CB_sig2 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_CB_sig2_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_CB_sig2_threshold),
     .ovr_sel                (SA1_CB_sig2_ovr_sel),
     .ovr_val                (SA1_CB_sig2_ovr_val),
     .activity_signals       (SA1_CB_activity_sig2),
     .activity_comb          (SA1_CAC_CB_sig2_active_comb)
);
// =====================
//       SE CAC CB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA0_CB_sig3 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_CB_sig3_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_CB_sig3_threshold),
     .ovr_sel                (SA0_CB_sig3_ovr_sel),
     .ovr_val                (SA0_CB_sig3_ovr_val),
     .activity_signals       (SA0_CB_activity_sig3),
     .activity_comb          (SA0_CAC_CB_sig3_active_comb)
);
// =====================
//       SE CAC CB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA1_CB_sig3 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_CB_sig3_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_CB_sig3_threshold),
     .ovr_sel                (SA1_CB_sig3_ovr_sel),
     .ovr_val                (SA1_CB_sig3_ovr_val),
     .activity_signals       (SA1_CB_activity_sig3),
     .activity_comb          (SA1_CAC_CB_sig3_active_comb)
);
// =====================
//       SE CAC DB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA0_DB_sig0 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_DB_sig0_force_disable ? 1'b0 : (se_lcac_enable || DB_didt_edc_enable)),
     .threshold              (SA0_DB_sig0_threshold),
     .ovr_sel                (SA0_DB_sig0_ovr_sel),
     .ovr_val                (SA0_DB_sig0_ovr_val),
     .activity_signals       (SA0_DB_activity_sig0),
     .activity_comb          (SA0_CAC_DB_sig0_active_comb)
);
// =====================
//       SE CAC DB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA1_DB_sig0 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_DB_sig0_force_disable ? 1'b0 : (se_lcac_enable || DB_didt_edc_enable)),
     .threshold              (SA1_DB_sig0_threshold),
     .ovr_sel                (SA1_DB_sig0_ovr_sel),
     .ovr_val                (SA1_DB_sig0_ovr_val),
     .activity_signals       (SA1_DB_activity_sig0),
     .activity_comb          (SA1_CAC_DB_sig0_active_comb)
);
// =====================
//       SE CAC DB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA0_DB_sig1 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_DB_sig1_force_disable ? 1'b0 : (se_lcac_enable || DB_didt_edc_enable)),
     .threshold              (SA0_DB_sig1_threshold),
     .ovr_sel                (SA0_DB_sig1_ovr_sel),
     .ovr_val                (SA0_DB_sig1_ovr_val),
     .activity_signals       (SA0_DB_activity_sig1),
     .activity_comb          (SA0_CAC_DB_sig1_active_comb)
);
// =====================
//       SE CAC DB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA1_DB_sig1 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_DB_sig1_force_disable ? 1'b0 : (se_lcac_enable || DB_didt_edc_enable)),
     .threshold              (SA1_DB_sig1_threshold),
     .ovr_sel                (SA1_DB_sig1_ovr_sel),
     .ovr_val                (SA1_DB_sig1_ovr_val),
     .activity_signals       (SA1_DB_activity_sig1),
     .activity_comb          (SA1_CAC_DB_sig1_active_comb)
);
// =====================
//       SE CAC DB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA0_DB_sig2 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_DB_sig2_force_disable ? 1'b0 : (se_lcac_enable || DB_didt_edc_enable)),
     .threshold              (SA0_DB_sig2_threshold),
     .ovr_sel                (SA0_DB_sig2_ovr_sel),
     .ovr_val                (SA0_DB_sig2_ovr_val),
     .activity_signals       (SA0_DB_activity_sig2),
     .activity_comb          (SA0_CAC_DB_sig2_active_comb)
);
// =====================
//       SE CAC DB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA1_DB_sig2 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_DB_sig2_force_disable ? 1'b0 : (se_lcac_enable || DB_didt_edc_enable)),
     .threshold              (SA1_DB_sig2_threshold),
     .ovr_sel                (SA1_DB_sig2_ovr_sel),
     .ovr_val                (SA1_DB_sig2_ovr_val),
     .activity_signals       (SA1_DB_activity_sig2),
     .activity_comb          (SA1_CAC_DB_sig2_active_comb)
);
// =====================
//       SE CAC DB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA0_DB_sig3 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA0_DB_sig3_force_disable ? 1'b0 : (se_lcac_enable || DB_didt_edc_enable)),
     .threshold              (SA0_DB_sig3_threshold),
     .ovr_sel                (SA0_DB_sig3_ovr_sel),
     .ovr_val                (SA0_DB_sig3_ovr_val),
     .activity_signals       (SA0_DB_activity_sig3),
     .activity_comb          (SA0_CAC_DB_sig3_active_comb)
);
// =====================
//       SE CAC DB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA1_DB_sig3 (
     .clk                    (oCpl_GFXCLK),
     .resetb                 (combined_resetb),
     .enable                 (SA1_DB_sig3_force_disable ? 1'b0 : (se_lcac_enable || DB_didt_edc_enable)),
     .threshold              (SA1_DB_sig3_threshold),
     .ovr_sel                (SA1_DB_sig3_ovr_sel),
     .ovr_val                (SA1_DB_sig3_ovr_val),
     .activity_signals       (SA1_DB_activity_sig3),
     .activity_comb          (SA1_CAC_DB_sig3_active_comb)
);
// =====================
//       SE CAC PA
// =====================
local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SA0_PA_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_PA_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_PA_sig0_threshold),
     .ovr_sel                (SA0_PA_sig0_ovr_sel),
     .ovr_val                (SA0_PA_sig0_ovr_val),
     .activity_signals       (SA0_PA_activity_sig0),
     .activity_comb          (SA0_CAC_PA_sig0_active_comb)
);
// =====================
//       SE CAC PA
// =====================
local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SA1_PA_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_PA_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_PA_sig0_threshold),
     .ovr_sel                (SA1_PA_sig0_ovr_sel),
     .ovr_val                (SA1_PA_sig0_ovr_val),
     .activity_signals       (SA1_PA_activity_sig0),
     .activity_comb          (SA1_CAC_PA_sig0_active_comb)
);
// =====================
//       SE CAC PA
// =====================
local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SA0_PA_sig1 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_PA_sig1_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_PA_sig1_threshold),
     .ovr_sel                (SA0_PA_sig1_ovr_sel),
     .ovr_val                (SA0_PA_sig1_ovr_val),
     .activity_signals       (SA0_PA_activity_sig1),
     .activity_comb          (SA0_CAC_PA_sig1_active_comb)
);
// =====================
//       SE CAC PA
// =====================
local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SA1_PA_sig1 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_PA_sig1_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_PA_sig1_threshold),
     .ovr_sel                (SA1_PA_sig1_ovr_sel),
     .ovr_val                (SA1_PA_sig1_ovr_val),
     .activity_signals       (SA1_PA_activity_sig1),
     .activity_comb          (SA1_CAC_PA_sig1_active_comb)
);
// =====================
//       SE CAC RMI
// =====================
local_cac_gc #(.ACT_WIDTH(2), .OVR_WIDTH(2)) lcac_SA0_RMI_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_RMI_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_RMI_sig0_threshold),
     .ovr_sel                (SA0_RMI_sig0_ovr_sel),
     .ovr_val                (SA0_RMI_sig0_ovr_val),
     .activity_signals       (SA0_RMI_activity_sig0),
     .activity_comb          (SA0_CAC_RMI_sig0_active_comb)
);
// =====================
//       SE CAC RMI
// =====================
local_cac_gc #(.ACT_WIDTH(2), .OVR_WIDTH(2)) lcac_SA1_RMI_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_RMI_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_RMI_sig0_threshold),
     .ovr_sel                (SA1_RMI_sig0_ovr_sel),
     .ovr_val                (SA1_RMI_sig0_ovr_val),
     .activity_signals       (SA1_RMI_activity_sig0),
     .activity_comb          (SA1_CAC_RMI_sig0_active_comb)
);
// =====================
//       SE CAC SC
// =====================
local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SA0_SC_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_SC_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_SC_sig0_threshold),
     .ovr_sel                (SA0_SC_sig0_ovr_sel),
     .ovr_val                (SA0_SC_sig0_ovr_val),
     .activity_signals       (SA0_SC_activity_sig0),
     .activity_comb          (SA0_CAC_SC_sig0_active_comb)
);
// =====================
//       SE CAC SC
// =====================
local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SA1_SC_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_SC_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_SC_sig0_threshold),
     .ovr_sel                (SA1_SC_sig0_ovr_sel),
     .ovr_val                (SA1_SC_sig0_ovr_val),
     .activity_signals       (SA1_SC_activity_sig0),
     .activity_comb          (SA1_CAC_SC_sig0_active_comb)
);
// =====================
//       SE CAC SX
// =====================
local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SA0_SX_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_SX_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_SX_sig0_threshold),
     .ovr_sel                (SA0_SX_sig0_ovr_sel),
     .ovr_val                (SA0_SX_sig0_ovr_val),
     .activity_signals       (SA0_SX_activity_sig0),
     .activity_comb          (SA0_CAC_SX_sig0_active_comb)
);
// =====================
//       SE CAC SX
// =====================
local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SA1_SX_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_SX_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_SX_sig0_threshold),
     .ovr_sel                (SA1_SX_sig0_ovr_sel),
     .ovr_val                (SA1_SX_sig0_ovr_val),
     .activity_signals       (SA1_SX_activity_sig0),
     .activity_comb          (SA1_CAC_SX_sig0_active_comb)
);
// =====================
//       SE CAC SXRB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA0_SXRB_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_SXRB_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_SXRB_sig0_threshold),
     .ovr_sel                (SA0_SXRB_sig0_ovr_sel),
     .ovr_val                (SA0_SXRB_sig0_ovr_val),
     .activity_signals       (SA0_SXRB_activity_sig0),
     .activity_comb          (SA0_CAC_SXRB_sig0_active_comb)
);
// =====================
//       SE CAC SXRB
// =====================
local_cac_gc #(.ACT_WIDTH(4), .OVR_WIDTH(4)) lcac_SA1_SXRB_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_SXRB_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_SXRB_sig0_threshold),
     .ovr_sel                (SA1_SXRB_sig0_ovr_sel),
     .ovr_val                (SA1_SXRB_sig0_ovr_val),
     .activity_signals       (SA1_SXRB_activity_sig0),
     .activity_comb          (SA1_CAC_SXRB_sig0_active_comb)
);
// =====================
//       SE CAC UTCL1
// =====================
local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SA0_UTCL1_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_UTCL1_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_UTCL1_sig0_threshold),
     .ovr_sel                (SA0_UTCL1_sig0_ovr_sel),
     .ovr_val                (SA0_UTCL1_sig0_ovr_val),
     .activity_signals       (SA0_UTCL1_activity_sig0),
     .activity_comb          (SA0_CAC_UTCL1_sig0_active_comb)
);
// =====================
//       SE CAC UTCL1
// =====================
local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SA1_UTCL1_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_UTCL1_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_UTCL1_sig0_threshold),
     .ovr_sel                (SA1_UTCL1_sig0_ovr_sel),
     .ovr_val                (SA1_UTCL1_sig0_ovr_val),
     .activity_signals       (SA1_UTCL1_activity_sig0),
     .activity_comb          (SA1_CAC_UTCL1_sig0_active_comb)
);

// ============================================================
// ================         Local SE CACs        =================
// ============================================================
// =====================
//       SE CAC CU
// =====================
wire [31:0] SA0_CU_activity_sig0;
wire [31:0] SA1_CU_activity_sig0;
assign      SA0_CU_activity_sig0[0] = SA0WGP00_CU0_CAC_sig0_active;
assign      SA1_CU_activity_sig0[0] = SA1WGP00_CU0_CAC_sig0_active;
assign      SA0_CU_activity_sig0[1] = SA0WGP01_CU0_CAC_sig0_active;
assign      SA1_CU_activity_sig0[1] = SA1WGP01_CU0_CAC_sig0_active;
assign      SA0_CU_activity_sig0[2] = SA0WGP02_CU0_CAC_sig0_active;
assign      SA1_CU_activity_sig0[2] = SA1WGP02_CU0_CAC_sig0_active;
assign      SA0_CU_activity_sig0[3] = SA0WGP10_CU0_CAC_sig0_active;
assign      SA1_CU_activity_sig0[3] = SA1WGP10_CU0_CAC_sig0_active;
assign      SA0_CU_activity_sig0[4] = SA0WGP11_CU0_CAC_sig0_active;
assign      SA1_CU_activity_sig0[4] = SA1WGP11_CU0_CAC_sig0_active;
assign      SA0_CU_activity_sig0[5] = SA0WGP00_CU1_CAC_sig0_active;
assign      SA1_CU_activity_sig0[5] = SA1WGP00_CU1_CAC_sig0_active;
assign      SA0_CU_activity_sig0[6] = SA0WGP01_CU1_CAC_sig0_active;
assign      SA1_CU_activity_sig0[6] = SA1WGP01_CU1_CAC_sig0_active;
assign      SA0_CU_activity_sig0[7] = SA0WGP02_CU1_CAC_sig0_active;
assign      SA1_CU_activity_sig0[7] = SA1WGP02_CU1_CAC_sig0_active;
assign      SA0_CU_activity_sig0[8] = SA0WGP10_CU1_CAC_sig0_active;
assign      SA1_CU_activity_sig0[8] = SA1WGP10_CU1_CAC_sig0_active;
assign      SA0_CU_activity_sig0[9] = SA0WGP11_CU1_CAC_sig0_active;
assign      SA1_CU_activity_sig0[9] = SA1WGP11_CU1_CAC_sig0_active;
assign      SA0_CU_activity_sig0[31:10] = 22'd0;
assign      SA1_CU_activity_sig0[31:10] = 22'd0;

local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA0_CU_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA0_CU_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA0_CU_sig0_threshold),
     .ovr_sel                (SA0_CU_sig0_ovr_sel),
     .ovr_val                (SA0_CU_sig0_ovr_val),
     .activity_signals       (SA0_CU_activity_sig0),
     .activity_comb          (SA0_CAC_CU_sig0_active_comb)
);
local_cac_gc #(.ACT_WIDTH(10), .OVR_WIDTH(10)) lcac_SA1_CU_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SA1_CU_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SA1_CU_sig0_threshold),
     .ovr_sel                (SA1_CU_sig0_ovr_sel),
     .ovr_val                (SA1_CU_sig0_ovr_val),
     .activity_signals       (SA1_CU_activity_sig0),
     .activity_comb          (SA1_CAC_CU_sig0_active_comb)
);

// =====================
//       SE CAC SPI
// =====================
wire [31:0] SPI_activity_sig0;
assign      SPI_activity_sig0[0] = SPI_CAC_sig0_active;
assign      SPI_activity_sig0[31:1] = 31'd0;
wire [31:0] SPI_activity_sig1;
assign      SPI_activity_sig1[0] = SPI_CAC_sig1_active;
assign      SPI_activity_sig1[31:1] = 31'd0;
wire [31:0] SPI_activity_sig2;
assign      SPI_activity_sig2[0] = SPI_CAC_sig2_active;
assign      SPI_activity_sig2[31:1] = 31'd0;
wire [31:0] SPI_activity_sig3;
assign      SPI_activity_sig3[0] = SPI_CAC_sig3_active;
assign      SPI_activity_sig3[31:1] = 31'd0;
wire [31:0] SPI_activity_sig4;
assign      SPI_activity_sig4[0] = SPI_CAC_sig4_active;
assign      SPI_activity_sig4[31:1] = 31'd0;
wire [31:0] SPI_activity_sig5;
assign      SPI_activity_sig5[0] = SPI_CAC_sig5_active;
assign      SPI_activity_sig5[31:1] = 31'd0;

local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SPI_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SPI_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SPI_sig0_threshold),
     .ovr_sel                (SPI_sig0_ovr_sel),
     .ovr_val                (SPI_sig0_ovr_val),
     .activity_signals       (SPI_activity_sig0),
     .activity_comb          (CAC_SPI_sig0_active_comb)
);

local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SPI_sig1 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SPI_sig1_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SPI_sig1_threshold),
     .ovr_sel                (SPI_sig1_ovr_sel),
     .ovr_val                (SPI_sig1_ovr_val),
     .activity_signals       (SPI_activity_sig1),
     .activity_comb          (CAC_SPI_sig1_active_comb)
);

local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SPI_sig2 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SPI_sig2_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SPI_sig2_threshold),
     .ovr_sel                (SPI_sig2_ovr_sel),
     .ovr_val                (SPI_sig2_ovr_val),
     .activity_signals       (SPI_activity_sig2),
     .activity_comb          (CAC_SPI_sig2_active_comb)
);

local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SPI_sig3 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SPI_sig3_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SPI_sig3_threshold),
     .ovr_sel                (SPI_sig3_ovr_sel),
     .ovr_val                (SPI_sig3_ovr_val),
     .activity_signals       (SPI_activity_sig3),
     .activity_comb          (CAC_SPI_sig3_active_comb)
);

local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SPI_sig4 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SPI_sig4_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SPI_sig4_threshold),
     .ovr_sel                (SPI_sig4_ovr_sel),
     .ovr_val                (SPI_sig4_ovr_val),
     .activity_signals       (SPI_activity_sig4),
     .activity_comb          (CAC_SPI_sig4_active_comb)
);

local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_SPI_sig5 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (SPI_sig5_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (SPI_sig5_threshold),
     .ovr_sel                (SPI_sig5_ovr_sel),
     .ovr_val                (SPI_sig5_ovr_val),
     .activity_signals       (SPI_activity_sig5),
     .activity_comb          (CAC_SPI_sig5_active_comb)
);

// =====================
//       SE CAC PC
// =====================
wire [31:0] PC_activity_sig0;
assign      PC_activity_sig0[0] = PC_CAC_sig0_active;
assign      PC_activity_sig0[31:1] = 31'd0;

local_cac_gc #(.ACT_WIDTH(1), .OVR_WIDTH(1)) lcac_PC_sig0 (
     .clk                    (cac_sclk),
     .resetb                 (combined_resetb),
     .enable                 (PC_sig0_force_disable ? 1'b0 : (se_lcac_enable)),
     .threshold              (PC_sig0_threshold),
     .ovr_sel                (PC_sig0_ovr_sel),
     .ovr_val                (PC_sig0_ovr_val),
     .activity_signals       (PC_activity_sig0),
     .activity_comb          (CAC_PC_sig0_active_comb)
);


// ============================================================
// ===================== DIDT Controller  =====================
// ============================================================
 wire [6-1:0]     sa0_didt_SQ_credit_consumed;
 wire [6-1:0]     sa1_didt_SQ_credit_consumed;
 wire [4-1:0]     sa0_didt_DB_credit_consumed;
 wire [4-1:0]     sa1_didt_DB_credit_consumed;
 wire [10-1:0]     sa0_didt_TD_credit_consumed;
 wire [10-1:0]     sa1_didt_TD_credit_consumed;
 wire [5-1:0]     sa0_didt_TCP_credit_consumed;
 wire [5-1:0]     sa1_didt_TCP_credit_consumed;

assign sa0_didt_SQ_credit_consumed = {
                                       SA0_CAC_SQ_sig5_active_comb,
                                       SA0_CAC_SQ_sig4_active_comb,
                                       SA0_CAC_SQ_sig3_active_comb,
                                       SA0_CAC_SQ_sig2_active_comb,
                                       SA0_CAC_SQ_sig1_active_comb,
                                       SA0_CAC_SQ_sig0_active_comb};
assign sa1_didt_SQ_credit_consumed = {
                                       SA1_CAC_SQ_sig5_active_comb,
                                       SA1_CAC_SQ_sig4_active_comb,
                                       SA1_CAC_SQ_sig3_active_comb,
                                       SA1_CAC_SQ_sig2_active_comb,
                                       SA1_CAC_SQ_sig1_active_comb,
                                       SA1_CAC_SQ_sig0_active_comb};
assign sa0_didt_DB_credit_consumed = {
                                       SA0_CAC_DB_sig3_active_comb,
                                       SA0_CAC_DB_sig2_active_comb,
                                       SA0_CAC_DB_sig1_active_comb,
                                       SA0_CAC_DB_sig0_active_comb};
assign sa1_didt_DB_credit_consumed = {
                                       SA1_CAC_DB_sig3_active_comb,
                                       SA1_CAC_DB_sig2_active_comb,
                                       SA1_CAC_DB_sig1_active_comb,
                                       SA1_CAC_DB_sig0_active_comb};
assign sa0_didt_TD_credit_consumed = {
                                       SA0_CAC_TD_sig9_active_comb,
                                       SA0_CAC_TD_sig8_active_comb,
                                       SA0_CAC_TD_sig7_active_comb,
                                       SA0_CAC_TD_sig6_active_comb,
                                       SA0_CAC_TD_sig5_active_comb,
                                       SA0_CAC_TD_sig4_active_comb,
                                       SA0_CAC_TD_sig3_active_comb,
                                       SA0_CAC_TD_sig2_active_comb,
                                       SA0_CAC_TD_sig1_active_comb,
                                       SA0_CAC_TD_sig0_active_comb};
assign sa1_didt_TD_credit_consumed = {
                                       SA1_CAC_TD_sig9_active_comb,
                                       SA1_CAC_TD_sig8_active_comb,
                                       SA1_CAC_TD_sig7_active_comb,
                                       SA1_CAC_TD_sig6_active_comb,
                                       SA1_CAC_TD_sig5_active_comb,
                                       SA1_CAC_TD_sig4_active_comb,
                                       SA1_CAC_TD_sig3_active_comb,
                                       SA1_CAC_TD_sig2_active_comb,
                                       SA1_CAC_TD_sig1_active_comb,
                                       SA1_CAC_TD_sig0_active_comb};
assign sa0_didt_TCP_credit_consumed = {
                                       SA0_CAC_TCP_sig4_active_comb,
                                       SA0_CAC_TCP_sig3_active_comb,
                                       SA0_CAC_TCP_sig2_active_comb,
                                       SA0_CAC_TCP_sig1_active_comb,
                                       SA0_CAC_TCP_sig0_active_comb};
assign sa1_didt_TCP_credit_consumed = {
                                       SA1_CAC_TCP_sig4_active_comb,
                                       SA1_CAC_TCP_sig3_active_comb,
                                       SA1_CAC_TCP_sig2_active_comb,
                                       SA1_CAC_TCP_sig1_active_comb,
                                       SA1_CAC_TCP_sig0_active_comb};

 wire [10-1:0] sa0_didt_SQ_stall;
 wire [10-1:0] sa1_didt_SQ_stall;
 wire [4-1:0] sa0_didt_DB_stall;
 wire [4-1:0] sa1_didt_DB_stall;
 wire [10-1:0] sa0_didt_TD_stall;
 wire [10-1:0] sa1_didt_TD_stall;
 wire [10-1:0] sa0_didt_TCP_stall;
 wire [10-1:0] sa1_didt_TCP_stall;

reg[2:0] didt_SQ_stall_level_q;
	always @(posedge oCpl_GFXCLK) begin
		if(~combined_resetb) begin
			didt_SQ_stall_level_q <= 'd0;
		end else begin
			didt_SQ_stall_level_q <= didt_SQ_stall_level;
		end
	end
reg[2:0] didt_DB_stall_level_q;
	always @(posedge oCpl_GFXCLK) begin
		if(~combined_resetb) begin
			didt_DB_stall_level_q <= 'd0;
		end else begin
			didt_DB_stall_level_q <= didt_DB_stall_level;
		end
	end
reg[2:0] didt_TD_stall_level_q;
	always @(posedge oCpl_GFXCLK) begin
		if(~combined_resetb) begin
			didt_TD_stall_level_q <= 'd0;
		end else begin
			didt_TD_stall_level_q <= didt_TD_stall_level;
		end
	end
reg[2:0] didt_TCP_stall_level_q;
	always @(posedge oCpl_GFXCLK) begin
		if(~combined_resetb) begin
			didt_TCP_stall_level_q <= 'd0;
		end else begin
			didt_TCP_stall_level_q <= didt_TCP_stall_level;
		end
	end

reg[2:0] edc_SQ_stall_level_q;
	always @(posedge oCpl_GFXCLK) begin
		if(~combined_resetb) begin
			edc_SQ_stall_level_q <= 'd0;
		end else begin
			edc_SQ_stall_level_q <= edc_SQ_stall_level;
		end
	end
reg[2:0] edc_DB_stall_level_q;
	always @(posedge oCpl_GFXCLK) begin
		if(~combined_resetb) begin
			edc_DB_stall_level_q <= 'd0;
		end else begin
			edc_DB_stall_level_q <= edc_DB_stall_level;
		end
	end
reg[2:0] edc_TD_stall_level_q;
	always @(posedge oCpl_GFXCLK) begin
		if(~combined_resetb) begin
			edc_TD_stall_level_q <= 'd0;
		end else begin
			edc_TD_stall_level_q <= edc_TD_stall_level;
		end
	end
reg[2:0] edc_TCP_stall_level_q;
	always @(posedge oCpl_GFXCLK) begin
		if(~combined_resetb) begin
			edc_TCP_stall_level_q <= 'd0;
		end else begin
			edc_TCP_stall_level_q <= edc_TCP_stall_level;
		end
	end

  gc_didt_cntl didt_cntl
  (
   .Cpl_GFXCLK                    (Cpl_GFXCLK),
   .oCpl_GFXCLK                   (oCpl_GFXCLK),
   .combined_resetb               (combined_resetb),
   .hard_resetb                   (hard_resetb),
   .cg_override                   (1'b0),
   .TEST_CLK_EN                   (TEST_CLK_EN),
   .dft_shift_clk					(dft_shift_clk),
   .Dft_Clk_Gater_En				(Dft_Clk_Gater_En),
   .Dft_Clk_Gater_Aon				(Dft_Clk_Gater_Aon),
   .RLC_DIDT_force_stall          (RLC_DIDT_force_stall),
   .SMU_DIDT_force_stall		  (SMU_DIDT_force_stall_q),
   .gc_se_stall					  (gc_se_stall),

   .PSM_didt_throttle_level			(didt_throttle_level),

   .sa0_didt_SQ_credit_consumed   	(sa0_didt_SQ_credit_consumed),
   .sa0_didt_SQ_stall_out         	(sa0_didt_SQ_stall),
   .sa0_didt_SQ_dbg_out_0			(sa0_didt_SQ_dbg_out_0),
   .sa0_didt_SQ_dbg_out_1			(sa0_didt_SQ_dbg_out_1),
   .sa0_didt_SQ_dbg_out_2			(sa0_didt_SQ_dbg_out_2),  
   .sa0_didt_SQ_dbg_out_3			(sa0_didt_SQ_dbg_out_3), 
   .sa0_didt_DB_credit_consumed   	(sa0_didt_DB_credit_consumed),
   .sa0_didt_DB_stall_out         	(sa0_didt_DB_stall),
   .sa0_didt_DB_dbg_out_0			(sa0_didt_DB_dbg_out_0),
   .sa0_didt_DB_dbg_out_1			(sa0_didt_DB_dbg_out_1),
   .sa0_didt_DB_dbg_out_2			(sa0_didt_DB_dbg_out_2),  
   .sa0_didt_DB_dbg_out_3			(sa0_didt_DB_dbg_out_3), 
   .sa0_didt_TD_credit_consumed   	(sa0_didt_TD_credit_consumed),
   .sa0_didt_TD_stall_out         	(sa0_didt_TD_stall),
   .sa0_didt_TD_dbg_out_0			(sa0_didt_TD_dbg_out_0),
   .sa0_didt_TD_dbg_out_1			(sa0_didt_TD_dbg_out_1),
   .sa0_didt_TD_dbg_out_2			(sa0_didt_TD_dbg_out_2),  
   .sa0_didt_TD_dbg_out_3			(sa0_didt_TD_dbg_out_3), 
   .sa0_didt_TCP_credit_consumed   	(sa0_didt_TCP_credit_consumed),
   .sa0_didt_TCP_stall_out         	(sa0_didt_TCP_stall),
   .sa0_didt_TCP_dbg_out_0			(sa0_didt_TCP_dbg_out_0),
   .sa0_didt_TCP_dbg_out_1			(sa0_didt_TCP_dbg_out_1),
   .sa0_didt_TCP_dbg_out_2			(sa0_didt_TCP_dbg_out_2),  
   .sa0_didt_TCP_dbg_out_3			(sa0_didt_TCP_dbg_out_3), 
   .sa0_misc_dbg_out_0					(sa0_misc_dbg_out_0),
   .sa0_misc_dbg_out_1					(sa0_misc_dbg_out_1),
   .sa0_misc_dbg_out_2					(sa0_misc_dbg_out_2),
   .sa1_didt_SQ_credit_consumed   	(sa1_didt_SQ_credit_consumed),
   .sa1_didt_SQ_stall_out         	(sa1_didt_SQ_stall),
   .sa1_didt_SQ_dbg_out_0			(sa1_didt_SQ_dbg_out_0),
   .sa1_didt_SQ_dbg_out_1			(sa1_didt_SQ_dbg_out_1),
   .sa1_didt_SQ_dbg_out_2			(sa1_didt_SQ_dbg_out_2),  
   .sa1_didt_SQ_dbg_out_3			(sa1_didt_SQ_dbg_out_3), 
   .sa1_didt_DB_credit_consumed   	(sa1_didt_DB_credit_consumed),
   .sa1_didt_DB_stall_out         	(sa1_didt_DB_stall),
   .sa1_didt_DB_dbg_out_0			(sa1_didt_DB_dbg_out_0),
   .sa1_didt_DB_dbg_out_1			(sa1_didt_DB_dbg_out_1),
   .sa1_didt_DB_dbg_out_2			(sa1_didt_DB_dbg_out_2),  
   .sa1_didt_DB_dbg_out_3			(sa1_didt_DB_dbg_out_3), 
   .sa1_didt_TD_credit_consumed   	(sa1_didt_TD_credit_consumed),
   .sa1_didt_TD_stall_out         	(sa1_didt_TD_stall),
   .sa1_didt_TD_dbg_out_0			(sa1_didt_TD_dbg_out_0),
   .sa1_didt_TD_dbg_out_1			(sa1_didt_TD_dbg_out_1),
   .sa1_didt_TD_dbg_out_2			(sa1_didt_TD_dbg_out_2),  
   .sa1_didt_TD_dbg_out_3			(sa1_didt_TD_dbg_out_3), 
   .sa1_didt_TCP_credit_consumed   	(sa1_didt_TCP_credit_consumed),
   .sa1_didt_TCP_stall_out         	(sa1_didt_TCP_stall),
   .sa1_didt_TCP_dbg_out_0			(sa1_didt_TCP_dbg_out_0),
   .sa1_didt_TCP_dbg_out_1			(sa1_didt_TCP_dbg_out_1),
   .sa1_didt_TCP_dbg_out_2			(sa1_didt_TCP_dbg_out_2),  
   .sa1_didt_TCP_dbg_out_3			(sa1_didt_TCP_dbg_out_3), 
   .sa1_misc_dbg_out_0					(sa1_misc_dbg_out_0),
   .sa1_misc_dbg_out_1					(sa1_misc_dbg_out_1),
   .sa1_misc_dbg_out_2					(sa1_misc_dbg_out_2),

   .didt_SQ_stall_level			(didt_SQ_stall_level_q),
   .didt_SQ_power_level			(didt_SQ_power_level),
   .didt_SQ_gc_edc_stall_level       	(edc_SQ_stall_level_q),

   .didt_edc_SQ_enable           (SQ_didt_edc_enable),

   .didt_DB_stall_level			(didt_DB_stall_level_q),
   .didt_DB_power_level			(didt_DB_power_level),
   .didt_DB_gc_edc_stall_level       	(edc_DB_stall_level_q),

   .didt_edc_DB_enable           (DB_didt_edc_enable),

   .didt_TD_stall_level			(didt_TD_stall_level_q),
   .didt_TD_power_level			(didt_TD_power_level),
   .didt_TD_gc_edc_stall_level       	(edc_TD_stall_level_q),

   .didt_edc_TD_enable           (TD_didt_edc_enable),

   .didt_TCP_stall_level			(didt_TCP_stall_level_q),
   .didt_TCP_power_level			(didt_TCP_power_level),
   .didt_TCP_gc_edc_stall_level       	(edc_TCP_stall_level_q),

   .didt_edc_TCP_enable           (TCP_didt_edc_enable),

   .reg_clk                       (reg_clk),
   .reg_send                      (reg_send),
   .reg_op                        (reg_op),
   .reg_addr                      (reg_addr),
   .reg_wd                        (reg_wd),
   .reg_se_index                  (reg_se_index),
   .reg_sh_index                  (reg_sh_index),
   .reg_instance_select			  (reg_instance_select),

   .didt_read_valid               (didt_read_valid),
   .didt_read_data                (didt_read_data),

   .SE_STRAP_id                   (SE_STRAP_id)

   );

   wire                         DIDT_SA0_WGP00_SQ00_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP00_SQ00_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP00_SQ01_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP00_SQ01_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP00_SQ10_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP00_SQ10_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP00_SQ11_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP00_SQ11_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP01_SQ00_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP01_SQ00_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP01_SQ01_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP01_SQ01_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP01_SQ10_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP01_SQ10_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP01_SQ11_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP01_SQ11_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP02_SQ00_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP02_SQ00_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP02_SQ01_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP02_SQ01_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP02_SQ10_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP02_SQ10_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP02_SQ11_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP02_SQ11_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP10_SQ00_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP10_SQ00_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP10_SQ01_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP10_SQ01_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP10_SQ10_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP10_SQ10_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP10_SQ11_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP10_SQ11_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP11_SQ00_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP11_SQ00_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP11_SQ01_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP11_SQ01_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP11_SQ10_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP11_SQ10_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP11_SQ11_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP11_SQ11_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP00_SQ00_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP00_SQ00_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP00_SQ01_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP00_SQ01_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP00_SQ10_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP00_SQ10_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP00_SQ11_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP00_SQ11_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP01_SQ00_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP01_SQ00_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP01_SQ01_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP01_SQ01_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP01_SQ10_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP01_SQ10_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP01_SQ11_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP01_SQ11_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP02_SQ00_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP02_SQ00_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP02_SQ01_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP02_SQ01_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP02_SQ10_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP02_SQ10_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP02_SQ11_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP02_SQ11_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP10_SQ00_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP10_SQ00_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP10_SQ01_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP10_SQ01_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP10_SQ10_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP10_SQ10_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP10_SQ11_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP10_SQ11_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP11_SQ00_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP11_SQ00_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP11_SQ01_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP11_SQ01_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP11_SQ10_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP11_SQ10_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP11_SQ11_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP11_SQ11_power_throttle_stall_q;
   wire                         DIDT_SA0_DB0_power_throttle_stall_pre;
   reg                         DIDT_SA0_DB0_power_throttle_stall_q;
   wire                         DIDT_SA1_DB0_power_throttle_stall_pre;
   reg                         DIDT_SA1_DB0_power_throttle_stall_q;
   wire                         DIDT_SA0_DB1_power_throttle_stall_pre;
   reg                         DIDT_SA0_DB1_power_throttle_stall_q;
   wire                         DIDT_SA1_DB1_power_throttle_stall_pre;
   reg                         DIDT_SA1_DB1_power_throttle_stall_q;
   wire                         DIDT_SA0_DB2_power_throttle_stall_pre;
   reg                         DIDT_SA0_DB2_power_throttle_stall_q;
   wire                         DIDT_SA1_DB2_power_throttle_stall_pre;
   reg                         DIDT_SA1_DB2_power_throttle_stall_q;
   wire                         DIDT_SA0_DB3_power_throttle_stall_pre;
   reg                         DIDT_SA0_DB3_power_throttle_stall_q;
   wire                         DIDT_SA1_DB3_power_throttle_stall_pre;
   reg                         DIDT_SA1_DB3_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP00_TD0_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP00_TD0_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP00_TD1_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP00_TD1_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP01_TD0_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP01_TD0_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP01_TD1_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP01_TD1_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP02_TD0_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP02_TD0_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP02_TD1_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP02_TD1_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP10_TD0_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP10_TD0_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP10_TD1_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP10_TD1_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP11_TD0_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP11_TD0_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP11_TD1_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP11_TD1_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP00_TD0_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP00_TD0_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP00_TD1_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP00_TD1_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP01_TD0_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP01_TD0_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP01_TD1_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP01_TD1_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP02_TD0_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP02_TD0_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP02_TD1_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP02_TD1_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP10_TD0_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP10_TD0_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP10_TD1_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP10_TD1_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP11_TD0_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP11_TD0_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP11_TD1_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP11_TD1_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP00_TCP0_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP00_TCP0_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP00_TCP1_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP00_TCP1_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP01_TCP0_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP01_TCP0_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP01_TCP1_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP01_TCP1_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP02_TCP0_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP02_TCP0_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP02_TCP1_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP02_TCP1_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP10_TCP0_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP10_TCP0_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP10_TCP1_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP10_TCP1_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP11_TCP0_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP11_TCP0_power_throttle_stall_q;
   wire                         DIDT_SA0_WGP11_TCP1_power_throttle_stall_pre;
   reg                          DIDT_SA0_WGP11_TCP1_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP00_TCP0_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP00_TCP0_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP00_TCP1_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP00_TCP1_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP01_TCP0_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP01_TCP0_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP01_TCP1_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP01_TCP1_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP02_TCP0_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP02_TCP0_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP02_TCP1_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP02_TCP1_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP10_TCP0_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP10_TCP0_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP10_TCP1_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP10_TCP1_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP11_TCP0_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP11_TCP0_power_throttle_stall_q;
   wire                         DIDT_SA1_WGP11_TCP1_power_throttle_stall_pre;
   reg                          DIDT_SA1_WGP11_TCP1_power_throttle_stall_q;


   assign DIDT_SA0_WGP00_SQ00_power_throttle_stall_pre = sa0_didt_SQ_stall[0];
   assign DIDT_SA0_WGP00_SQ01_power_throttle_stall_pre = sa0_didt_SQ_stall[0];
   assign DIDT_SA0_WGP00_SQ10_power_throttle_stall_pre = sa0_didt_SQ_stall[1];
   assign DIDT_SA0_WGP00_SQ11_power_throttle_stall_pre = sa0_didt_SQ_stall[1];
   assign DIDT_SA0_WGP01_SQ00_power_throttle_stall_pre = sa0_didt_SQ_stall[2];
   assign DIDT_SA0_WGP01_SQ01_power_throttle_stall_pre = sa0_didt_SQ_stall[2];
   assign DIDT_SA0_WGP01_SQ10_power_throttle_stall_pre = sa0_didt_SQ_stall[3];
   assign DIDT_SA0_WGP01_SQ11_power_throttle_stall_pre = sa0_didt_SQ_stall[3];
   assign DIDT_SA0_WGP02_SQ00_power_throttle_stall_pre = sa0_didt_SQ_stall[4];
   assign DIDT_SA0_WGP02_SQ01_power_throttle_stall_pre = sa0_didt_SQ_stall[4];
   assign DIDT_SA0_WGP02_SQ10_power_throttle_stall_pre = sa0_didt_SQ_stall[5];
   assign DIDT_SA0_WGP02_SQ11_power_throttle_stall_pre = sa0_didt_SQ_stall[5];
   assign DIDT_SA0_WGP10_SQ00_power_throttle_stall_pre = sa0_didt_SQ_stall[6];
   assign DIDT_SA0_WGP10_SQ01_power_throttle_stall_pre = sa0_didt_SQ_stall[6];
   assign DIDT_SA0_WGP10_SQ10_power_throttle_stall_pre = sa0_didt_SQ_stall[7];
   assign DIDT_SA0_WGP10_SQ11_power_throttle_stall_pre = sa0_didt_SQ_stall[7];
   assign DIDT_SA0_WGP11_SQ00_power_throttle_stall_pre = sa0_didt_SQ_stall[8];
   assign DIDT_SA0_WGP11_SQ01_power_throttle_stall_pre = sa0_didt_SQ_stall[8];
   assign DIDT_SA0_WGP11_SQ10_power_throttle_stall_pre = sa0_didt_SQ_stall[9];
   assign DIDT_SA0_WGP11_SQ11_power_throttle_stall_pre = sa0_didt_SQ_stall[9];
   assign DIDT_SA1_WGP00_SQ00_power_throttle_stall_pre = sa1_didt_SQ_stall[0];
   assign DIDT_SA1_WGP00_SQ01_power_throttle_stall_pre = sa1_didt_SQ_stall[0];
   assign DIDT_SA1_WGP00_SQ10_power_throttle_stall_pre = sa1_didt_SQ_stall[1];
   assign DIDT_SA1_WGP00_SQ11_power_throttle_stall_pre = sa1_didt_SQ_stall[1];
   assign DIDT_SA1_WGP01_SQ00_power_throttle_stall_pre = sa1_didt_SQ_stall[2];
   assign DIDT_SA1_WGP01_SQ01_power_throttle_stall_pre = sa1_didt_SQ_stall[2];
   assign DIDT_SA1_WGP01_SQ10_power_throttle_stall_pre = sa1_didt_SQ_stall[3];
   assign DIDT_SA1_WGP01_SQ11_power_throttle_stall_pre = sa1_didt_SQ_stall[3];
   assign DIDT_SA1_WGP02_SQ00_power_throttle_stall_pre = sa1_didt_SQ_stall[4];
   assign DIDT_SA1_WGP02_SQ01_power_throttle_stall_pre = sa1_didt_SQ_stall[4];
   assign DIDT_SA1_WGP02_SQ10_power_throttle_stall_pre = sa1_didt_SQ_stall[5];
   assign DIDT_SA1_WGP02_SQ11_power_throttle_stall_pre = sa1_didt_SQ_stall[5];
   assign DIDT_SA1_WGP10_SQ00_power_throttle_stall_pre = sa1_didt_SQ_stall[6];
   assign DIDT_SA1_WGP10_SQ01_power_throttle_stall_pre = sa1_didt_SQ_stall[6];
   assign DIDT_SA1_WGP10_SQ10_power_throttle_stall_pre = sa1_didt_SQ_stall[7];
   assign DIDT_SA1_WGP10_SQ11_power_throttle_stall_pre = sa1_didt_SQ_stall[7];
   assign DIDT_SA1_WGP11_SQ00_power_throttle_stall_pre = sa1_didt_SQ_stall[8];
   assign DIDT_SA1_WGP11_SQ01_power_throttle_stall_pre = sa1_didt_SQ_stall[8];
   assign DIDT_SA1_WGP11_SQ10_power_throttle_stall_pre = sa1_didt_SQ_stall[9];
   assign DIDT_SA1_WGP11_SQ11_power_throttle_stall_pre = sa1_didt_SQ_stall[9];
   assign DIDT_SA0_DB0_power_throttle_stall_pre = sa0_didt_DB_stall[0];
   assign DIDT_SA1_DB0_power_throttle_stall_pre = sa1_didt_DB_stall[0];
   assign DIDT_SA0_DB1_power_throttle_stall_pre = sa0_didt_DB_stall[1];
   assign DIDT_SA1_DB1_power_throttle_stall_pre = sa1_didt_DB_stall[1];
   assign DIDT_SA0_DB2_power_throttle_stall_pre = sa0_didt_DB_stall[2];
   assign DIDT_SA1_DB2_power_throttle_stall_pre = sa1_didt_DB_stall[2];
   assign DIDT_SA0_DB3_power_throttle_stall_pre = sa0_didt_DB_stall[3];
   assign DIDT_SA1_DB3_power_throttle_stall_pre = sa1_didt_DB_stall[3];
   assign DIDT_SA0_WGP00_TD0_power_throttle_stall_pre = sa0_didt_TD_stall[0];
   assign DIDT_SA0_WGP00_TD1_power_throttle_stall_pre = sa0_didt_TD_stall[1];
   assign DIDT_SA0_WGP01_TD0_power_throttle_stall_pre = sa0_didt_TD_stall[2];
   assign DIDT_SA0_WGP01_TD1_power_throttle_stall_pre = sa0_didt_TD_stall[3];
   assign DIDT_SA0_WGP02_TD0_power_throttle_stall_pre = sa0_didt_TD_stall[4];
   assign DIDT_SA0_WGP02_TD1_power_throttle_stall_pre = sa0_didt_TD_stall[5];
   assign DIDT_SA0_WGP10_TD0_power_throttle_stall_pre = sa0_didt_TD_stall[6];
   assign DIDT_SA0_WGP10_TD1_power_throttle_stall_pre = sa0_didt_TD_stall[7];
   assign DIDT_SA0_WGP11_TD0_power_throttle_stall_pre = sa0_didt_TD_stall[8];
   assign DIDT_SA0_WGP11_TD1_power_throttle_stall_pre = sa0_didt_TD_stall[9];
   assign DIDT_SA1_WGP00_TD0_power_throttle_stall_pre = sa1_didt_TD_stall[0];
   assign DIDT_SA1_WGP00_TD1_power_throttle_stall_pre = sa1_didt_TD_stall[1];
   assign DIDT_SA1_WGP01_TD0_power_throttle_stall_pre = sa1_didt_TD_stall[2];
   assign DIDT_SA1_WGP01_TD1_power_throttle_stall_pre = sa1_didt_TD_stall[3];
   assign DIDT_SA1_WGP02_TD0_power_throttle_stall_pre = sa1_didt_TD_stall[4];
   assign DIDT_SA1_WGP02_TD1_power_throttle_stall_pre = sa1_didt_TD_stall[5];
   assign DIDT_SA1_WGP10_TD0_power_throttle_stall_pre = sa1_didt_TD_stall[6];
   assign DIDT_SA1_WGP10_TD1_power_throttle_stall_pre = sa1_didt_TD_stall[7];
   assign DIDT_SA1_WGP11_TD0_power_throttle_stall_pre = sa1_didt_TD_stall[8];
   assign DIDT_SA1_WGP11_TD1_power_throttle_stall_pre = sa1_didt_TD_stall[9];
   assign DIDT_SA0_WGP00_TCP0_power_throttle_stall_pre = sa0_didt_TCP_stall[0];
   assign DIDT_SA0_WGP00_TCP1_power_throttle_stall_pre = sa0_didt_TCP_stall[1];
   assign DIDT_SA0_WGP01_TCP0_power_throttle_stall_pre = sa0_didt_TCP_stall[2];
   assign DIDT_SA0_WGP01_TCP1_power_throttle_stall_pre = sa0_didt_TCP_stall[3];
   assign DIDT_SA0_WGP02_TCP0_power_throttle_stall_pre = sa0_didt_TCP_stall[4];
   assign DIDT_SA0_WGP02_TCP1_power_throttle_stall_pre = sa0_didt_TCP_stall[5];
   assign DIDT_SA0_WGP10_TCP0_power_throttle_stall_pre = sa0_didt_TCP_stall[6];
   assign DIDT_SA0_WGP10_TCP1_power_throttle_stall_pre = sa0_didt_TCP_stall[7];
   assign DIDT_SA0_WGP11_TCP0_power_throttle_stall_pre = sa0_didt_TCP_stall[8];
   assign DIDT_SA0_WGP11_TCP1_power_throttle_stall_pre = sa0_didt_TCP_stall[9];
   assign DIDT_SA1_WGP00_TCP0_power_throttle_stall_pre = sa1_didt_TCP_stall[0];
   assign DIDT_SA1_WGP00_TCP1_power_throttle_stall_pre = sa1_didt_TCP_stall[1];
   assign DIDT_SA1_WGP01_TCP0_power_throttle_stall_pre = sa1_didt_TCP_stall[2];
   assign DIDT_SA1_WGP01_TCP1_power_throttle_stall_pre = sa1_didt_TCP_stall[3];
   assign DIDT_SA1_WGP02_TCP0_power_throttle_stall_pre = sa1_didt_TCP_stall[4];
   assign DIDT_SA1_WGP02_TCP1_power_throttle_stall_pre = sa1_didt_TCP_stall[5];
   assign DIDT_SA1_WGP10_TCP0_power_throttle_stall_pre = sa1_didt_TCP_stall[6];
   assign DIDT_SA1_WGP10_TCP1_power_throttle_stall_pre = sa1_didt_TCP_stall[7];
   assign DIDT_SA1_WGP11_TCP0_power_throttle_stall_pre = sa1_didt_TCP_stall[8];
   assign DIDT_SA1_WGP11_TCP1_power_throttle_stall_pre = sa1_didt_TCP_stall[9];

always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP00_SQ00_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP00_SQ00_power_throttle_stall_q <= DIDT_SA0_WGP00_SQ00_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP00_SQ00_power_throttle_stall = DIDT_SA0_WGP00_SQ00_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP00_SQ01_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP00_SQ01_power_throttle_stall_q <= DIDT_SA0_WGP00_SQ01_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP00_SQ01_power_throttle_stall = DIDT_SA0_WGP00_SQ01_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP00_SQ10_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP00_SQ10_power_throttle_stall_q <= DIDT_SA0_WGP00_SQ10_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP00_SQ10_power_throttle_stall = DIDT_SA0_WGP00_SQ10_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP00_SQ11_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP00_SQ11_power_throttle_stall_q <= DIDT_SA0_WGP00_SQ11_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP00_SQ11_power_throttle_stall = DIDT_SA0_WGP00_SQ11_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP01_SQ00_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP01_SQ00_power_throttle_stall_q <= DIDT_SA0_WGP01_SQ00_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP01_SQ00_power_throttle_stall = DIDT_SA0_WGP01_SQ00_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP01_SQ01_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP01_SQ01_power_throttle_stall_q <= DIDT_SA0_WGP01_SQ01_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP01_SQ01_power_throttle_stall = DIDT_SA0_WGP01_SQ01_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP01_SQ10_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP01_SQ10_power_throttle_stall_q <= DIDT_SA0_WGP01_SQ10_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP01_SQ10_power_throttle_stall = DIDT_SA0_WGP01_SQ10_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP01_SQ11_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP01_SQ11_power_throttle_stall_q <= DIDT_SA0_WGP01_SQ11_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP01_SQ11_power_throttle_stall = DIDT_SA0_WGP01_SQ11_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP02_SQ00_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP02_SQ00_power_throttle_stall_q <= DIDT_SA0_WGP02_SQ00_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP02_SQ00_power_throttle_stall = DIDT_SA0_WGP02_SQ00_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP02_SQ01_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP02_SQ01_power_throttle_stall_q <= DIDT_SA0_WGP02_SQ01_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP02_SQ01_power_throttle_stall = DIDT_SA0_WGP02_SQ01_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP02_SQ10_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP02_SQ10_power_throttle_stall_q <= DIDT_SA0_WGP02_SQ10_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP02_SQ10_power_throttle_stall = DIDT_SA0_WGP02_SQ10_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP02_SQ11_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP02_SQ11_power_throttle_stall_q <= DIDT_SA0_WGP02_SQ11_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP02_SQ11_power_throttle_stall = DIDT_SA0_WGP02_SQ11_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP10_SQ00_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP10_SQ00_power_throttle_stall_q <= DIDT_SA0_WGP10_SQ00_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP10_SQ00_power_throttle_stall = DIDT_SA0_WGP10_SQ00_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP10_SQ01_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP10_SQ01_power_throttle_stall_q <= DIDT_SA0_WGP10_SQ01_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP10_SQ01_power_throttle_stall = DIDT_SA0_WGP10_SQ01_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP10_SQ10_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP10_SQ10_power_throttle_stall_q <= DIDT_SA0_WGP10_SQ10_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP10_SQ10_power_throttle_stall = DIDT_SA0_WGP10_SQ10_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP10_SQ11_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP10_SQ11_power_throttle_stall_q <= DIDT_SA0_WGP10_SQ11_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP10_SQ11_power_throttle_stall = DIDT_SA0_WGP10_SQ11_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP11_SQ00_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP11_SQ00_power_throttle_stall_q <= DIDT_SA0_WGP11_SQ00_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP11_SQ00_power_throttle_stall = DIDT_SA0_WGP11_SQ00_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP11_SQ01_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP11_SQ01_power_throttle_stall_q <= DIDT_SA0_WGP11_SQ01_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP11_SQ01_power_throttle_stall = DIDT_SA0_WGP11_SQ01_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP11_SQ10_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP11_SQ10_power_throttle_stall_q <= DIDT_SA0_WGP11_SQ10_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP11_SQ10_power_throttle_stall = DIDT_SA0_WGP11_SQ10_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP11_SQ11_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP11_SQ11_power_throttle_stall_q <= DIDT_SA0_WGP11_SQ11_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP11_SQ11_power_throttle_stall = DIDT_SA0_WGP11_SQ11_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP00_SQ00_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP00_SQ00_power_throttle_stall_q <= DIDT_SA1_WGP00_SQ00_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP00_SQ00_power_throttle_stall = DIDT_SA1_WGP00_SQ00_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP00_SQ01_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP00_SQ01_power_throttle_stall_q <= DIDT_SA1_WGP00_SQ01_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP00_SQ01_power_throttle_stall = DIDT_SA1_WGP00_SQ01_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP00_SQ10_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP00_SQ10_power_throttle_stall_q <= DIDT_SA1_WGP00_SQ10_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP00_SQ10_power_throttle_stall = DIDT_SA1_WGP00_SQ10_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP00_SQ11_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP00_SQ11_power_throttle_stall_q <= DIDT_SA1_WGP00_SQ11_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP00_SQ11_power_throttle_stall = DIDT_SA1_WGP00_SQ11_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP01_SQ00_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP01_SQ00_power_throttle_stall_q <= DIDT_SA1_WGP01_SQ00_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP01_SQ00_power_throttle_stall = DIDT_SA1_WGP01_SQ00_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP01_SQ01_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP01_SQ01_power_throttle_stall_q <= DIDT_SA1_WGP01_SQ01_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP01_SQ01_power_throttle_stall = DIDT_SA1_WGP01_SQ01_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP01_SQ10_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP01_SQ10_power_throttle_stall_q <= DIDT_SA1_WGP01_SQ10_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP01_SQ10_power_throttle_stall = DIDT_SA1_WGP01_SQ10_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP01_SQ11_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP01_SQ11_power_throttle_stall_q <= DIDT_SA1_WGP01_SQ11_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP01_SQ11_power_throttle_stall = DIDT_SA1_WGP01_SQ11_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP02_SQ00_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP02_SQ00_power_throttle_stall_q <= DIDT_SA1_WGP02_SQ00_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP02_SQ00_power_throttle_stall = DIDT_SA1_WGP02_SQ00_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP02_SQ01_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP02_SQ01_power_throttle_stall_q <= DIDT_SA1_WGP02_SQ01_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP02_SQ01_power_throttle_stall = DIDT_SA1_WGP02_SQ01_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP02_SQ10_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP02_SQ10_power_throttle_stall_q <= DIDT_SA1_WGP02_SQ10_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP02_SQ10_power_throttle_stall = DIDT_SA1_WGP02_SQ10_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP02_SQ11_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP02_SQ11_power_throttle_stall_q <= DIDT_SA1_WGP02_SQ11_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP02_SQ11_power_throttle_stall = DIDT_SA1_WGP02_SQ11_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP10_SQ00_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP10_SQ00_power_throttle_stall_q <= DIDT_SA1_WGP10_SQ00_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP10_SQ00_power_throttle_stall = DIDT_SA1_WGP10_SQ00_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP10_SQ01_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP10_SQ01_power_throttle_stall_q <= DIDT_SA1_WGP10_SQ01_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP10_SQ01_power_throttle_stall = DIDT_SA1_WGP10_SQ01_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP10_SQ10_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP10_SQ10_power_throttle_stall_q <= DIDT_SA1_WGP10_SQ10_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP10_SQ10_power_throttle_stall = DIDT_SA1_WGP10_SQ10_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP10_SQ11_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP10_SQ11_power_throttle_stall_q <= DIDT_SA1_WGP10_SQ11_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP10_SQ11_power_throttle_stall = DIDT_SA1_WGP10_SQ11_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP11_SQ00_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP11_SQ00_power_throttle_stall_q <= DIDT_SA1_WGP11_SQ00_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP11_SQ00_power_throttle_stall = DIDT_SA1_WGP11_SQ00_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP11_SQ01_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP11_SQ01_power_throttle_stall_q <= DIDT_SA1_WGP11_SQ01_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP11_SQ01_power_throttle_stall = DIDT_SA1_WGP11_SQ01_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP11_SQ10_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP11_SQ10_power_throttle_stall_q <= DIDT_SA1_WGP11_SQ10_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP11_SQ10_power_throttle_stall = DIDT_SA1_WGP11_SQ10_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP11_SQ11_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP11_SQ11_power_throttle_stall_q <= DIDT_SA1_WGP11_SQ11_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP11_SQ11_power_throttle_stall = DIDT_SA1_WGP11_SQ11_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_DB0_power_throttle_stall_q <= 'd0;
	end else begin
		DIDT_SA0_DB0_power_throttle_stall_q <= DIDT_SA0_DB0_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_DB0_power_throttle_stall = DIDT_SA0_DB0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_DB0_power_throttle_stall_q <= 'd0;
	end else begin
		DIDT_SA1_DB0_power_throttle_stall_q <= DIDT_SA1_DB0_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_DB0_power_throttle_stall = DIDT_SA1_DB0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_DB1_power_throttle_stall_q <= 'd0;
	end else begin
		DIDT_SA0_DB1_power_throttle_stall_q <= DIDT_SA0_DB1_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_DB1_power_throttle_stall = DIDT_SA0_DB1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_DB1_power_throttle_stall_q <= 'd0;
	end else begin
		DIDT_SA1_DB1_power_throttle_stall_q <= DIDT_SA1_DB1_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_DB1_power_throttle_stall = DIDT_SA1_DB1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_DB2_power_throttle_stall_q <= 'd0;
	end else begin
		DIDT_SA0_DB2_power_throttle_stall_q <= DIDT_SA0_DB2_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_DB2_power_throttle_stall = DIDT_SA0_DB2_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_DB2_power_throttle_stall_q <= 'd0;
	end else begin
		DIDT_SA1_DB2_power_throttle_stall_q <= DIDT_SA1_DB2_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_DB2_power_throttle_stall = DIDT_SA1_DB2_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_DB3_power_throttle_stall_q <= 'd0;
	end else begin
		DIDT_SA0_DB3_power_throttle_stall_q <= DIDT_SA0_DB3_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_DB3_power_throttle_stall = DIDT_SA0_DB3_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_DB3_power_throttle_stall_q <= 'd0;
	end else begin
		DIDT_SA1_DB3_power_throttle_stall_q <= DIDT_SA1_DB3_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_DB3_power_throttle_stall = DIDT_SA1_DB3_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP00_TD0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP00_TD0_power_throttle_stall_q <= DIDT_SA0_WGP00_TD0_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP00_TD0_power_throttle_stall = DIDT_SA0_WGP00_TD0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP00_TD1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP00_TD1_power_throttle_stall_q <= DIDT_SA0_WGP00_TD1_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP00_TD1_power_throttle_stall = DIDT_SA0_WGP00_TD1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP01_TD0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP01_TD0_power_throttle_stall_q <= DIDT_SA0_WGP01_TD0_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP01_TD0_power_throttle_stall = DIDT_SA0_WGP01_TD0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP01_TD1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP01_TD1_power_throttle_stall_q <= DIDT_SA0_WGP01_TD1_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP01_TD1_power_throttle_stall = DIDT_SA0_WGP01_TD1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP02_TD0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP02_TD0_power_throttle_stall_q <= DIDT_SA0_WGP02_TD0_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP02_TD0_power_throttle_stall = DIDT_SA0_WGP02_TD0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP02_TD1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP02_TD1_power_throttle_stall_q <= DIDT_SA0_WGP02_TD1_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP02_TD1_power_throttle_stall = DIDT_SA0_WGP02_TD1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP10_TD0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP10_TD0_power_throttle_stall_q <= DIDT_SA0_WGP10_TD0_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP10_TD0_power_throttle_stall = DIDT_SA0_WGP10_TD0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP10_TD1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP10_TD1_power_throttle_stall_q <= DIDT_SA0_WGP10_TD1_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP10_TD1_power_throttle_stall = DIDT_SA0_WGP10_TD1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP11_TD0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP11_TD0_power_throttle_stall_q <= DIDT_SA0_WGP11_TD0_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP11_TD0_power_throttle_stall = DIDT_SA0_WGP11_TD0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP11_TD1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP11_TD1_power_throttle_stall_q <= DIDT_SA0_WGP11_TD1_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP11_TD1_power_throttle_stall = DIDT_SA0_WGP11_TD1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP00_TD0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP00_TD0_power_throttle_stall_q <= DIDT_SA1_WGP00_TD0_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP00_TD0_power_throttle_stall = DIDT_SA1_WGP00_TD0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP00_TD1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP00_TD1_power_throttle_stall_q <= DIDT_SA1_WGP00_TD1_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP00_TD1_power_throttle_stall = DIDT_SA1_WGP00_TD1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP01_TD0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP01_TD0_power_throttle_stall_q <= DIDT_SA1_WGP01_TD0_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP01_TD0_power_throttle_stall = DIDT_SA1_WGP01_TD0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP01_TD1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP01_TD1_power_throttle_stall_q <= DIDT_SA1_WGP01_TD1_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP01_TD1_power_throttle_stall = DIDT_SA1_WGP01_TD1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP02_TD0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP02_TD0_power_throttle_stall_q <= DIDT_SA1_WGP02_TD0_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP02_TD0_power_throttle_stall = DIDT_SA1_WGP02_TD0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP02_TD1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP02_TD1_power_throttle_stall_q <= DIDT_SA1_WGP02_TD1_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP02_TD1_power_throttle_stall = DIDT_SA1_WGP02_TD1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP10_TD0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP10_TD0_power_throttle_stall_q <= DIDT_SA1_WGP10_TD0_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP10_TD0_power_throttle_stall = DIDT_SA1_WGP10_TD0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP10_TD1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP10_TD1_power_throttle_stall_q <= DIDT_SA1_WGP10_TD1_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP10_TD1_power_throttle_stall = DIDT_SA1_WGP10_TD1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP11_TD0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP11_TD0_power_throttle_stall_q <= DIDT_SA1_WGP11_TD0_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP11_TD0_power_throttle_stall = DIDT_SA1_WGP11_TD0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP11_TD1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP11_TD1_power_throttle_stall_q <= DIDT_SA1_WGP11_TD1_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP11_TD1_power_throttle_stall = DIDT_SA1_WGP11_TD1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP00_TCP0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP00_TCP0_power_throttle_stall_q <= DIDT_SA0_WGP00_TCP0_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP00_TCP0_power_throttle_stall = DIDT_SA0_WGP00_TCP0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP00_TCP1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP00_TCP1_power_throttle_stall_q <= DIDT_SA0_WGP00_TCP1_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP00_TCP1_power_throttle_stall = DIDT_SA0_WGP00_TCP1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP01_TCP0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP01_TCP0_power_throttle_stall_q <= DIDT_SA0_WGP01_TCP0_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP01_TCP0_power_throttle_stall = DIDT_SA0_WGP01_TCP0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP01_TCP1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP01_TCP1_power_throttle_stall_q <= DIDT_SA0_WGP01_TCP1_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP01_TCP1_power_throttle_stall = DIDT_SA0_WGP01_TCP1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP02_TCP0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP02_TCP0_power_throttle_stall_q <= DIDT_SA0_WGP02_TCP0_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP02_TCP0_power_throttle_stall = DIDT_SA0_WGP02_TCP0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP02_TCP1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP02_TCP1_power_throttle_stall_q <= DIDT_SA0_WGP02_TCP1_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP02_TCP1_power_throttle_stall = DIDT_SA0_WGP02_TCP1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP10_TCP0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP10_TCP0_power_throttle_stall_q <= DIDT_SA0_WGP10_TCP0_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP10_TCP0_power_throttle_stall = DIDT_SA0_WGP10_TCP0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP10_TCP1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP10_TCP1_power_throttle_stall_q <= DIDT_SA0_WGP10_TCP1_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP10_TCP1_power_throttle_stall = DIDT_SA0_WGP10_TCP1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP11_TCP0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP11_TCP0_power_throttle_stall_q <= DIDT_SA0_WGP11_TCP0_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP11_TCP0_power_throttle_stall = DIDT_SA0_WGP11_TCP0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA0_WGP11_TCP1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA0_WGP11_TCP1_power_throttle_stall_q <= DIDT_SA0_WGP11_TCP1_power_throttle_stall_pre;
	end
end
assign DIDT_SA0_WGP11_TCP1_power_throttle_stall = DIDT_SA0_WGP11_TCP1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP00_TCP0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP00_TCP0_power_throttle_stall_q <= DIDT_SA1_WGP00_TCP0_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP00_TCP0_power_throttle_stall = DIDT_SA1_WGP00_TCP0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP00_TCP1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP00_TCP1_power_throttle_stall_q <= DIDT_SA1_WGP00_TCP1_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP00_TCP1_power_throttle_stall = DIDT_SA1_WGP00_TCP1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP01_TCP0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP01_TCP0_power_throttle_stall_q <= DIDT_SA1_WGP01_TCP0_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP01_TCP0_power_throttle_stall = DIDT_SA1_WGP01_TCP0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP01_TCP1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP01_TCP1_power_throttle_stall_q <= DIDT_SA1_WGP01_TCP1_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP01_TCP1_power_throttle_stall = DIDT_SA1_WGP01_TCP1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP02_TCP0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP02_TCP0_power_throttle_stall_q <= DIDT_SA1_WGP02_TCP0_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP02_TCP0_power_throttle_stall = DIDT_SA1_WGP02_TCP0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP02_TCP1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP02_TCP1_power_throttle_stall_q <= DIDT_SA1_WGP02_TCP1_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP02_TCP1_power_throttle_stall = DIDT_SA1_WGP02_TCP1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP10_TCP0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP10_TCP0_power_throttle_stall_q <= DIDT_SA1_WGP10_TCP0_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP10_TCP0_power_throttle_stall = DIDT_SA1_WGP10_TCP0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP10_TCP1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP10_TCP1_power_throttle_stall_q <= DIDT_SA1_WGP10_TCP1_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP10_TCP1_power_throttle_stall = DIDT_SA1_WGP10_TCP1_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP11_TCP0_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP11_TCP0_power_throttle_stall_q <= DIDT_SA1_WGP11_TCP0_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP11_TCP0_power_throttle_stall = DIDT_SA1_WGP11_TCP0_power_throttle_stall_q;
always @(posedge oCpl_GFXCLK) begin
	if(~combined_resetb) begin
    	DIDT_SA1_WGP11_TCP1_power_throttle_stall_q <= 'd0;
	end else begin
    	DIDT_SA1_WGP11_TCP1_power_throttle_stall_q <= DIDT_SA1_WGP11_TCP1_power_throttle_stall_pre;
	end
end
assign DIDT_SA1_WGP11_TCP1_power_throttle_stall = DIDT_SA1_WGP11_TCP1_power_throttle_stall_q;



// VCS coverage off
///////////////////////////////////////////////////////////////////////////////////////
// Instantiate Debug Common Mux
///////////////////////////////////////////////////////////////////////////////////////
gfx_dbg_mux u_se_cac_dbg_mux (    //instance name convention u_<block>_dbg_client_mux
    //output
    .gclk                   (),            //used by the block: Gated clock for potential debug bus pipe stage
    .dbg_mux_Data           (dbg_mux_Data), //to dbg steer

    //input
    .ipclk                  (oCpl_GFXCLK),  //connect to the local clock used by that block
    .dbg_active             (dbg_active),   //from dbg steer
    .dbg_mux_SelLane        (dbg_mux_SelLane),  //from dbg steer
    .dbg_rst                (dbg_rst),          //from dbg steer
    .dbg_blkid              (dbg_blkid),        //from dbg steer

    .TEST_CLK_EN            (1'b0),         // Hooked up by post-process

	.idebug0		(sa0_didt_SQ_dbg_out_0), 
	.idebug1		(sa0_didt_SQ_dbg_out_1), 
	.idebug2		(sa0_didt_SQ_dbg_out_2), 
	.idebug3		(sa0_didt_SQ_dbg_out_3), 
	.idebug4		(sa1_didt_SQ_dbg_out_0), 
	.idebug5		(sa1_didt_SQ_dbg_out_1), 
	.idebug6		(sa1_didt_SQ_dbg_out_2), 
	.idebug7		(sa1_didt_SQ_dbg_out_3), 

	.idebug8		(sa0_didt_DB_dbg_out_0), 
	.idebug9		(sa0_didt_DB_dbg_out_1), 
	.idebug10		(sa0_didt_DB_dbg_out_2), 
	.idebug11		(sa0_didt_DB_dbg_out_3), 
	.idebug12		(sa1_didt_DB_dbg_out_0), 
	.idebug13		(sa1_didt_DB_dbg_out_1), 
	.idebug14		(sa1_didt_DB_dbg_out_2), 
	.idebug15		(sa1_didt_DB_dbg_out_3), 

	.idebug16		(sa0_didt_TD_dbg_out_0), 
	.idebug17		(sa0_didt_TD_dbg_out_1), 
	.idebug18		(sa0_didt_TD_dbg_out_2), 
	.idebug19		(sa0_didt_TD_dbg_out_3), 
	.idebug20		(sa1_didt_TD_dbg_out_0), 
	.idebug21		(sa1_didt_TD_dbg_out_1), 
	.idebug22		(sa1_didt_TD_dbg_out_2), 
	.idebug23		(sa1_didt_TD_dbg_out_3), 

	.idebug24		(sa0_didt_TCP_dbg_out_0), 
	.idebug25		(sa0_didt_TCP_dbg_out_1), 
	.idebug26		(sa0_didt_TCP_dbg_out_2), 
	.idebug27		(sa0_didt_TCP_dbg_out_3), 
	.idebug28		(sa1_didt_TCP_dbg_out_0), 
	.idebug29		(sa1_didt_TCP_dbg_out_1), 
	.idebug30		(sa1_didt_TCP_dbg_out_2), 
	.idebug31		(sa1_didt_TCP_dbg_out_3), 

	.idebug32		(32'b0), 
	.idebug33		(32'b0), 
	.idebug34		(32'b0), 
	.idebug35		(32'b0), 
	.idebug36		(32'b0), 
	.idebug37		(32'b0), 
	.idebug38		(32'b0), 
	.idebug39		(32'b0), 

	.idebug40		(sa0_misc_dbg_out_0), 
	.idebug41		(sa0_misc_dbg_out_1), 
	.idebug42		(sa0_misc_dbg_out_2), 
	.idebug43		(sa1_misc_dbg_out_0), 
	.idebug44		(sa1_misc_dbg_out_1), 
	.idebug45		(sa1_misc_dbg_out_2), 

	.idebug46		(32'b0), 
	.idebug47		(32'b0), 
	.idebug48		(32'b0), 
	.idebug49		(32'b0), 
	.idebug50		(32'b0), 
	.idebug51		(32'b0), 
	.idebug52		(32'b0), 
	.idebug53		(32'b0), 
	.idebug54		(32'b0), 
	.idebug55		(32'b0), 
	.idebug56		(32'b0), 
	.idebug57		(32'b0), 
	.idebug58		(32'b0), 
	.idebug59		(32'b0), 
	.idebug60		(32'b0), 
	.idebug61		(32'b0), 
	.idebug62		(32'b0) 
);
// VCS coverage on

endmodule
