`include "grbm_defs.vh"
`include "gc__gc_cac_reg.v"
`include "gc_register_addr.v"

module se_cac_regs
(
   input                                   resetb,
   input                                   reg_clk,
   input                                   reg_send,
   input                                   reg_op,
   input [`GRBM_TARG_REG_ADDR_RANGE]       reg_addr,
   input [`GRBM_TARG_REG_WD_RANGE]         reg_wd,


   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TA_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TA_sig0_threshold,
   output reg [10-1:0]          SA0_TA_sig0_ovr_sel,
   output reg [10-1:0]          SA0_TA_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TA_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TA_sig0_threshold,
   output reg [10-1:0]          SA1_TA_sig0_ovr_sel,
   output reg [10-1:0]          SA1_TA_sig0_ovr_val,

   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig0_threshold,
   output reg [10-1:0]          SA0_TD_sig0_ovr_sel,
   output reg [10-1:0]          SA0_TD_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig0_threshold,
   output reg [10-1:0]          SA1_TD_sig0_ovr_sel,
   output reg [10-1:0]          SA1_TD_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig1_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig1_threshold,
   output reg [10-1:0]          SA0_TD_sig1_ovr_sel,
   output reg [10-1:0]          SA0_TD_sig1_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig1_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig1_threshold,
   output reg [10-1:0]          SA1_TD_sig1_ovr_sel,
   output reg [10-1:0]          SA1_TD_sig1_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig2_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig2_threshold,
   output reg [10-1:0]          SA0_TD_sig2_ovr_sel,
   output reg [10-1:0]          SA0_TD_sig2_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig2_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig2_threshold,
   output reg [10-1:0]          SA1_TD_sig2_ovr_sel,
   output reg [10-1:0]          SA1_TD_sig2_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig3_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig3_threshold,
   output reg [10-1:0]          SA0_TD_sig3_ovr_sel,
   output reg [10-1:0]          SA0_TD_sig3_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig3_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig3_threshold,
   output reg [10-1:0]          SA1_TD_sig3_ovr_sel,
   output reg [10-1:0]          SA1_TD_sig3_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig4_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig4_threshold,
   output reg [10-1:0]          SA0_TD_sig4_ovr_sel,
   output reg [10-1:0]          SA0_TD_sig4_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig4_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig4_threshold,
   output reg [10-1:0]          SA1_TD_sig4_ovr_sel,
   output reg [10-1:0]          SA1_TD_sig4_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig5_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig5_threshold,
   output reg [10-1:0]          SA0_TD_sig5_ovr_sel,
   output reg [10-1:0]          SA0_TD_sig5_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig5_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig5_threshold,
   output reg [10-1:0]          SA1_TD_sig5_ovr_sel,
   output reg [10-1:0]          SA1_TD_sig5_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig6_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig6_threshold,
   output reg [10-1:0]          SA0_TD_sig6_ovr_sel,
   output reg [10-1:0]          SA0_TD_sig6_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig6_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig6_threshold,
   output reg [10-1:0]          SA1_TD_sig6_ovr_sel,
   output reg [10-1:0]          SA1_TD_sig6_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig7_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig7_threshold,
   output reg [10-1:0]          SA0_TD_sig7_ovr_sel,
   output reg [10-1:0]          SA0_TD_sig7_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig7_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig7_threshold,
   output reg [10-1:0]          SA1_TD_sig7_ovr_sel,
   output reg [10-1:0]          SA1_TD_sig7_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig8_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig8_threshold,
   output reg [10-1:0]          SA0_TD_sig8_ovr_sel,
   output reg [10-1:0]          SA0_TD_sig8_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig8_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig8_threshold,
   output reg [10-1:0]          SA1_TD_sig8_ovr_sel,
   output reg [10-1:0]          SA1_TD_sig8_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TD_sig9_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TD_sig9_threshold,
   output reg [10-1:0]          SA0_TD_sig9_ovr_sel,
   output reg [10-1:0]          SA0_TD_sig9_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TD_sig9_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TD_sig9_threshold,
   output reg [10-1:0]          SA1_TD_sig9_ovr_sel,
   output reg [10-1:0]          SA1_TD_sig9_ovr_val,

   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TCP_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TCP_sig0_threshold,
   output reg [10-1:0]          SA0_TCP_sig0_ovr_sel,
   output reg [10-1:0]          SA0_TCP_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TCP_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TCP_sig0_threshold,
   output reg [10-1:0]          SA1_TCP_sig0_ovr_sel,
   output reg [10-1:0]          SA1_TCP_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TCP_sig1_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TCP_sig1_threshold,
   output reg [10-1:0]          SA0_TCP_sig1_ovr_sel,
   output reg [10-1:0]          SA0_TCP_sig1_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TCP_sig1_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TCP_sig1_threshold,
   output reg [10-1:0]          SA1_TCP_sig1_ovr_sel,
   output reg [10-1:0]          SA1_TCP_sig1_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TCP_sig2_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TCP_sig2_threshold,
   output reg [10-1:0]          SA0_TCP_sig2_ovr_sel,
   output reg [10-1:0]          SA0_TCP_sig2_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TCP_sig2_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TCP_sig2_threshold,
   output reg [10-1:0]          SA1_TCP_sig2_ovr_sel,
   output reg [10-1:0]          SA1_TCP_sig2_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TCP_sig3_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TCP_sig3_threshold,
   output reg [10-1:0]          SA0_TCP_sig3_ovr_sel,
   output reg [10-1:0]          SA0_TCP_sig3_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TCP_sig3_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TCP_sig3_threshold,
   output reg [10-1:0]          SA1_TCP_sig3_ovr_sel,
   output reg [10-1:0]          SA1_TCP_sig3_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_TCP_sig4_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_TCP_sig4_threshold,
   output reg [10-1:0]          SA0_TCP_sig4_ovr_sel,
   output reg [10-1:0]          SA0_TCP_sig4_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_TCP_sig4_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_TCP_sig4_threshold,
   output reg [10-1:0]          SA1_TCP_sig4_ovr_sel,
   output reg [10-1:0]          SA1_TCP_sig4_ovr_val,

   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SQ_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SQ_sig0_threshold,
   output reg [5-1:0]          SA0_SQ_sig0_ovr_sel,
   output reg [5-1:0]          SA0_SQ_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SQ_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SQ_sig0_threshold,
   output reg [5-1:0]          SA1_SQ_sig0_ovr_sel,
   output reg [5-1:0]          SA1_SQ_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SQ_sig1_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SQ_sig1_threshold,
   output reg [5-1:0]          SA0_SQ_sig1_ovr_sel,
   output reg [5-1:0]          SA0_SQ_sig1_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SQ_sig1_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SQ_sig1_threshold,
   output reg [5-1:0]          SA1_SQ_sig1_ovr_sel,
   output reg [5-1:0]          SA1_SQ_sig1_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SQ_sig2_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SQ_sig2_threshold,
   output reg [5-1:0]          SA0_SQ_sig2_ovr_sel,
   output reg [5-1:0]          SA0_SQ_sig2_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SQ_sig2_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SQ_sig2_threshold,
   output reg [5-1:0]          SA1_SQ_sig2_ovr_sel,
   output reg [5-1:0]          SA1_SQ_sig2_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SQ_sig3_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SQ_sig3_threshold,
   output reg [5-1:0]          SA0_SQ_sig3_ovr_sel,
   output reg [5-1:0]          SA0_SQ_sig3_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SQ_sig3_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SQ_sig3_threshold,
   output reg [5-1:0]          SA1_SQ_sig3_ovr_sel,
   output reg [5-1:0]          SA1_SQ_sig3_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SQ_sig4_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SQ_sig4_threshold,
   output reg [5-1:0]          SA0_SQ_sig4_ovr_sel,
   output reg [5-1:0]          SA0_SQ_sig4_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SQ_sig4_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SQ_sig4_threshold,
   output reg [5-1:0]          SA1_SQ_sig4_ovr_sel,
   output reg [5-1:0]          SA1_SQ_sig4_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SQ_sig5_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SQ_sig5_threshold,
   output reg [5-1:0]          SA0_SQ_sig5_ovr_sel,
   output reg [5-1:0]          SA0_SQ_sig5_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SQ_sig5_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SQ_sig5_threshold,
   output reg [5-1:0]          SA1_SQ_sig5_ovr_sel,
   output reg [5-1:0]          SA1_SQ_sig5_ovr_val,

   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_LDS_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_LDS_sig0_threshold,
   output reg [10-1:0]          SA0_LDS_sig0_ovr_sel,
   output reg [10-1:0]          SA0_LDS_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_LDS_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_LDS_sig0_threshold,
   output reg [10-1:0]          SA1_LDS_sig0_ovr_sel,
   output reg [10-1:0]          SA1_LDS_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_LDS_sig1_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_LDS_sig1_threshold,
   output reg [10-1:0]          SA0_LDS_sig1_ovr_sel,
   output reg [10-1:0]          SA0_LDS_sig1_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_LDS_sig1_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_LDS_sig1_threshold,
   output reg [10-1:0]          SA1_LDS_sig1_ovr_sel,
   output reg [10-1:0]          SA1_LDS_sig1_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_LDS_sig2_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_LDS_sig2_threshold,
   output reg [10-1:0]          SA0_LDS_sig2_ovr_sel,
   output reg [10-1:0]          SA0_LDS_sig2_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_LDS_sig2_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_LDS_sig2_threshold,
   output reg [10-1:0]          SA1_LDS_sig2_ovr_sel,
   output reg [10-1:0]          SA1_LDS_sig2_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_LDS_sig3_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_LDS_sig3_threshold,
   output reg [10-1:0]          SA0_LDS_sig3_ovr_sel,
   output reg [10-1:0]          SA0_LDS_sig3_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_LDS_sig3_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_LDS_sig3_threshold,
   output reg [10-1:0]          SA1_LDS_sig3_ovr_sel,
   output reg [10-1:0]          SA1_LDS_sig3_ovr_val,

   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_BCI_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_BCI_sig0_threshold,
   output reg [1-1:0]          SA0_BCI_sig0_ovr_sel,
   output reg [1-1:0]          SA0_BCI_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_BCI_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_BCI_sig0_threshold,
   output reg [1-1:0]          SA1_BCI_sig0_ovr_sel,
   output reg [1-1:0]          SA1_BCI_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_BCI_sig1_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_BCI_sig1_threshold,
   output reg [1-1:0]          SA0_BCI_sig1_ovr_sel,
   output reg [1-1:0]          SA0_BCI_sig1_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_BCI_sig1_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_BCI_sig1_threshold,
   output reg [1-1:0]          SA1_BCI_sig1_ovr_sel,
   output reg [1-1:0]          SA1_BCI_sig1_ovr_val,

   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_CB_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_CB_sig0_threshold,
   output reg [4-1:0]          SA0_CB_sig0_ovr_sel,
   output reg [4-1:0]          SA0_CB_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_CB_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_CB_sig0_threshold,
   output reg [4-1:0]          SA1_CB_sig0_ovr_sel,
   output reg [4-1:0]          SA1_CB_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_CB_sig1_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_CB_sig1_threshold,
   output reg [4-1:0]          SA0_CB_sig1_ovr_sel,
   output reg [4-1:0]          SA0_CB_sig1_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_CB_sig1_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_CB_sig1_threshold,
   output reg [4-1:0]          SA1_CB_sig1_ovr_sel,
   output reg [4-1:0]          SA1_CB_sig1_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_CB_sig2_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_CB_sig2_threshold,
   output reg [4-1:0]          SA0_CB_sig2_ovr_sel,
   output reg [4-1:0]          SA0_CB_sig2_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_CB_sig2_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_CB_sig2_threshold,
   output reg [4-1:0]          SA1_CB_sig2_ovr_sel,
   output reg [4-1:0]          SA1_CB_sig2_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_CB_sig3_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_CB_sig3_threshold,
   output reg [4-1:0]          SA0_CB_sig3_ovr_sel,
   output reg [4-1:0]          SA0_CB_sig3_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_CB_sig3_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_CB_sig3_threshold,
   output reg [4-1:0]          SA1_CB_sig3_ovr_sel,
   output reg [4-1:0]          SA1_CB_sig3_ovr_val,

   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_DB_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_DB_sig0_threshold,
   output reg [4-1:0]          SA0_DB_sig0_ovr_sel,
   output reg [4-1:0]          SA0_DB_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_DB_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_DB_sig0_threshold,
   output reg [4-1:0]          SA1_DB_sig0_ovr_sel,
   output reg [4-1:0]          SA1_DB_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_DB_sig1_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_DB_sig1_threshold,
   output reg [4-1:0]          SA0_DB_sig1_ovr_sel,
   output reg [4-1:0]          SA0_DB_sig1_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_DB_sig1_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_DB_sig1_threshold,
   output reg [4-1:0]          SA1_DB_sig1_ovr_sel,
   output reg [4-1:0]          SA1_DB_sig1_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_DB_sig2_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_DB_sig2_threshold,
   output reg [4-1:0]          SA0_DB_sig2_ovr_sel,
   output reg [4-1:0]          SA0_DB_sig2_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_DB_sig2_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_DB_sig2_threshold,
   output reg [4-1:0]          SA1_DB_sig2_ovr_sel,
   output reg [4-1:0]          SA1_DB_sig2_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_DB_sig3_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_DB_sig3_threshold,
   output reg [4-1:0]          SA0_DB_sig3_ovr_sel,
   output reg [4-1:0]          SA0_DB_sig3_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_DB_sig3_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_DB_sig3_threshold,
   output reg [4-1:0]          SA1_DB_sig3_ovr_sel,
   output reg [4-1:0]          SA1_DB_sig3_ovr_val,

   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_PA_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_PA_sig0_threshold,
   output reg [1-1:0]          SA0_PA_sig0_ovr_sel,
   output reg [1-1:0]          SA0_PA_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_PA_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_PA_sig0_threshold,
   output reg [1-1:0]          SA1_PA_sig0_ovr_sel,
   output reg [1-1:0]          SA1_PA_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_PA_sig1_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_PA_sig1_threshold,
   output reg [1-1:0]          SA0_PA_sig1_ovr_sel,
   output reg [1-1:0]          SA0_PA_sig1_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_PA_sig1_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_PA_sig1_threshold,
   output reg [1-1:0]          SA1_PA_sig1_ovr_sel,
   output reg [1-1:0]          SA1_PA_sig1_ovr_val,

   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_RMI_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_RMI_sig0_threshold,
   output reg [2-1:0]          SA0_RMI_sig0_ovr_sel,
   output reg [2-1:0]          SA0_RMI_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_RMI_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_RMI_sig0_threshold,
   output reg [2-1:0]          SA1_RMI_sig0_ovr_sel,
   output reg [2-1:0]          SA1_RMI_sig0_ovr_val,

   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SC_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SC_sig0_threshold,
   output reg [1-1:0]          SA0_SC_sig0_ovr_sel,
   output reg [1-1:0]          SA0_SC_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SC_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SC_sig0_threshold,
   output reg [1-1:0]          SA1_SC_sig0_ovr_sel,
   output reg [1-1:0]          SA1_SC_sig0_ovr_val,

   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SX_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SX_sig0_threshold,
   output reg [1-1:0]          SA0_SX_sig0_ovr_sel,
   output reg [1-1:0]          SA0_SX_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SX_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SX_sig0_threshold,
   output reg [1-1:0]          SA1_SX_sig0_ovr_sel,
   output reg [1-1:0]          SA1_SX_sig0_ovr_val,

   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_SXRB_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_SXRB_sig0_threshold,
   output reg [4-1:0]          SA0_SXRB_sig0_ovr_sel,
   output reg [4-1:0]          SA0_SXRB_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_SXRB_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_SXRB_sig0_threshold,
   output reg [4-1:0]          SA1_SXRB_sig0_ovr_sel,
   output reg [4-1:0]          SA1_SXRB_sig0_ovr_val,

   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_UTCL1_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_UTCL1_sig0_threshold,
   output reg [1-1:0]          SA0_UTCL1_sig0_ovr_sel,
   output reg [1-1:0]          SA0_UTCL1_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_UTCL1_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_UTCL1_sig0_threshold,
   output reg [1-1:0]          SA1_UTCL1_sig0_ovr_sel,
   output reg [1-1:0]          SA1_UTCL1_sig0_ovr_val,

   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA0_CU_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA0_CU_sig0_threshold,
   output reg [10-1:0]          SA0_CU_sig0_ovr_sel,
   output reg [10-1:0]          SA0_CU_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SA1_CU_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SA1_CU_sig0_threshold,
   output reg [10-1:0]          SA1_CU_sig0_ovr_sel,
   output reg [10-1:0]          SA1_CU_sig0_ovr_val,

   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SPI_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SPI_sig0_threshold,
   output reg [1-1:0]          SPI_sig0_ovr_sel,
   output reg [1-1:0]          SPI_sig0_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SPI_sig1_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SPI_sig1_threshold,
   output reg [1-1:0]          SPI_sig1_ovr_sel,
   output reg [1-1:0]          SPI_sig1_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SPI_sig2_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SPI_sig2_threshold,
   output reg [1-1:0]          SPI_sig2_ovr_sel,
   output reg [1-1:0]          SPI_sig2_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SPI_sig3_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SPI_sig3_threshold,
   output reg [1-1:0]          SPI_sig3_ovr_sel,
   output reg [1-1:0]          SPI_sig3_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SPI_sig4_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SPI_sig4_threshold,
   output reg [1-1:0]          SPI_sig4_ovr_sel,
   output reg [1-1:0]          SPI_sig4_ovr_val,
   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              SPI_sig5_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  SPI_sig5_threshold,
   output reg [1-1:0]          SPI_sig5_ovr_sel,
   output reg [1-1:0]          SPI_sig5_ovr_val,

   output reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE]              PC_sig0_force_disable,
   output reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0]  PC_sig0_threshold,
   output reg [1-1:0]          PC_sig0_ovr_sel,
   output reg [1-1:0]          PC_sig0_ovr_val,


   output reg [`SE_CAC_CGTT_CLK_CTRL_REG_SIZE-1:0]		cgtt_clk_ctrl, 
   output reg [`GC_CAC_CTRL_2_SE_LCAC_ENABLE_SIZE-1:0]  se_lcac_enable,

   output reg                                     reg_read_valid,
   output reg [`TARG_GRBM_READ_DATA_RANGE]        reg_read_data
);

   reg [10-1:0]          SA0_TA_sig0_ovr_sel_d;
   reg [10-1:0]          SA0_TA_sig0_ovr_val_d;
   reg [10-1:0]          SA1_TA_sig0_ovr_sel_d;
   reg [10-1:0]          SA1_TA_sig0_ovr_val_d;

   reg [10-1:0]          SA0_TD_sig0_ovr_sel_d;
   reg [10-1:0]          SA0_TD_sig0_ovr_val_d;
   reg [10-1:0]          SA1_TD_sig0_ovr_sel_d;
   reg [10-1:0]          SA1_TD_sig0_ovr_val_d;
   reg [10-1:0]          SA0_TD_sig1_ovr_sel_d;
   reg [10-1:0]          SA0_TD_sig1_ovr_val_d;
   reg [10-1:0]          SA1_TD_sig1_ovr_sel_d;
   reg [10-1:0]          SA1_TD_sig1_ovr_val_d;
   reg [10-1:0]          SA0_TD_sig2_ovr_sel_d;
   reg [10-1:0]          SA0_TD_sig2_ovr_val_d;
   reg [10-1:0]          SA1_TD_sig2_ovr_sel_d;
   reg [10-1:0]          SA1_TD_sig2_ovr_val_d;
   reg [10-1:0]          SA0_TD_sig3_ovr_sel_d;
   reg [10-1:0]          SA0_TD_sig3_ovr_val_d;
   reg [10-1:0]          SA1_TD_sig3_ovr_sel_d;
   reg [10-1:0]          SA1_TD_sig3_ovr_val_d;
   reg [10-1:0]          SA0_TD_sig4_ovr_sel_d;
   reg [10-1:0]          SA0_TD_sig4_ovr_val_d;
   reg [10-1:0]          SA1_TD_sig4_ovr_sel_d;
   reg [10-1:0]          SA1_TD_sig4_ovr_val_d;
   reg [10-1:0]          SA0_TD_sig5_ovr_sel_d;
   reg [10-1:0]          SA0_TD_sig5_ovr_val_d;
   reg [10-1:0]          SA1_TD_sig5_ovr_sel_d;
   reg [10-1:0]          SA1_TD_sig5_ovr_val_d;
   reg [10-1:0]          SA0_TD_sig6_ovr_sel_d;
   reg [10-1:0]          SA0_TD_sig6_ovr_val_d;
   reg [10-1:0]          SA1_TD_sig6_ovr_sel_d;
   reg [10-1:0]          SA1_TD_sig6_ovr_val_d;
   reg [10-1:0]          SA0_TD_sig7_ovr_sel_d;
   reg [10-1:0]          SA0_TD_sig7_ovr_val_d;
   reg [10-1:0]          SA1_TD_sig7_ovr_sel_d;
   reg [10-1:0]          SA1_TD_sig7_ovr_val_d;
   reg [10-1:0]          SA0_TD_sig8_ovr_sel_d;
   reg [10-1:0]          SA0_TD_sig8_ovr_val_d;
   reg [10-1:0]          SA1_TD_sig8_ovr_sel_d;
   reg [10-1:0]          SA1_TD_sig8_ovr_val_d;
   reg [10-1:0]          SA0_TD_sig9_ovr_sel_d;
   reg [10-1:0]          SA0_TD_sig9_ovr_val_d;
   reg [10-1:0]          SA1_TD_sig9_ovr_sel_d;
   reg [10-1:0]          SA1_TD_sig9_ovr_val_d;

   reg [10-1:0]          SA0_TCP_sig0_ovr_sel_d;
   reg [10-1:0]          SA0_TCP_sig0_ovr_val_d;
   reg [10-1:0]          SA1_TCP_sig0_ovr_sel_d;
   reg [10-1:0]          SA1_TCP_sig0_ovr_val_d;
   reg [10-1:0]          SA0_TCP_sig1_ovr_sel_d;
   reg [10-1:0]          SA0_TCP_sig1_ovr_val_d;
   reg [10-1:0]          SA1_TCP_sig1_ovr_sel_d;
   reg [10-1:0]          SA1_TCP_sig1_ovr_val_d;
   reg [10-1:0]          SA0_TCP_sig2_ovr_sel_d;
   reg [10-1:0]          SA0_TCP_sig2_ovr_val_d;
   reg [10-1:0]          SA1_TCP_sig2_ovr_sel_d;
   reg [10-1:0]          SA1_TCP_sig2_ovr_val_d;
   reg [10-1:0]          SA0_TCP_sig3_ovr_sel_d;
   reg [10-1:0]          SA0_TCP_sig3_ovr_val_d;
   reg [10-1:0]          SA1_TCP_sig3_ovr_sel_d;
   reg [10-1:0]          SA1_TCP_sig3_ovr_val_d;
   reg [10-1:0]          SA0_TCP_sig4_ovr_sel_d;
   reg [10-1:0]          SA0_TCP_sig4_ovr_val_d;
   reg [10-1:0]          SA1_TCP_sig4_ovr_sel_d;
   reg [10-1:0]          SA1_TCP_sig4_ovr_val_d;

   reg [5-1:0]          SA0_SQ_sig0_ovr_sel_d;
   reg [5-1:0]          SA0_SQ_sig0_ovr_val_d;
   reg [5-1:0]          SA1_SQ_sig0_ovr_sel_d;
   reg [5-1:0]          SA1_SQ_sig0_ovr_val_d;
   reg [5-1:0]          SA0_SQ_sig1_ovr_sel_d;
   reg [5-1:0]          SA0_SQ_sig1_ovr_val_d;
   reg [5-1:0]          SA1_SQ_sig1_ovr_sel_d;
   reg [5-1:0]          SA1_SQ_sig1_ovr_val_d;
   reg [5-1:0]          SA0_SQ_sig2_ovr_sel_d;
   reg [5-1:0]          SA0_SQ_sig2_ovr_val_d;
   reg [5-1:0]          SA1_SQ_sig2_ovr_sel_d;
   reg [5-1:0]          SA1_SQ_sig2_ovr_val_d;
   reg [5-1:0]          SA0_SQ_sig3_ovr_sel_d;
   reg [5-1:0]          SA0_SQ_sig3_ovr_val_d;
   reg [5-1:0]          SA1_SQ_sig3_ovr_sel_d;
   reg [5-1:0]          SA1_SQ_sig3_ovr_val_d;
   reg [5-1:0]          SA0_SQ_sig4_ovr_sel_d;
   reg [5-1:0]          SA0_SQ_sig4_ovr_val_d;
   reg [5-1:0]          SA1_SQ_sig4_ovr_sel_d;
   reg [5-1:0]          SA1_SQ_sig4_ovr_val_d;
   reg [5-1:0]          SA0_SQ_sig5_ovr_sel_d;
   reg [5-1:0]          SA0_SQ_sig5_ovr_val_d;
   reg [5-1:0]          SA1_SQ_sig5_ovr_sel_d;
   reg [5-1:0]          SA1_SQ_sig5_ovr_val_d;

   reg [10-1:0]          SA0_LDS_sig0_ovr_sel_d;
   reg [10-1:0]          SA0_LDS_sig0_ovr_val_d;
   reg [10-1:0]          SA1_LDS_sig0_ovr_sel_d;
   reg [10-1:0]          SA1_LDS_sig0_ovr_val_d;
   reg [10-1:0]          SA0_LDS_sig1_ovr_sel_d;
   reg [10-1:0]          SA0_LDS_sig1_ovr_val_d;
   reg [10-1:0]          SA1_LDS_sig1_ovr_sel_d;
   reg [10-1:0]          SA1_LDS_sig1_ovr_val_d;
   reg [10-1:0]          SA0_LDS_sig2_ovr_sel_d;
   reg [10-1:0]          SA0_LDS_sig2_ovr_val_d;
   reg [10-1:0]          SA1_LDS_sig2_ovr_sel_d;
   reg [10-1:0]          SA1_LDS_sig2_ovr_val_d;
   reg [10-1:0]          SA0_LDS_sig3_ovr_sel_d;
   reg [10-1:0]          SA0_LDS_sig3_ovr_val_d;
   reg [10-1:0]          SA1_LDS_sig3_ovr_sel_d;
   reg [10-1:0]          SA1_LDS_sig3_ovr_val_d;

   reg [1-1:0]          SA0_BCI_sig0_ovr_sel_d;
   reg [1-1:0]          SA0_BCI_sig0_ovr_val_d;
   reg [1-1:0]          SA1_BCI_sig0_ovr_sel_d;
   reg [1-1:0]          SA1_BCI_sig0_ovr_val_d;
   reg [1-1:0]          SA0_BCI_sig1_ovr_sel_d;
   reg [1-1:0]          SA0_BCI_sig1_ovr_val_d;
   reg [1-1:0]          SA1_BCI_sig1_ovr_sel_d;
   reg [1-1:0]          SA1_BCI_sig1_ovr_val_d;

   reg [4-1:0]          SA0_CB_sig0_ovr_sel_d;
   reg [4-1:0]          SA0_CB_sig0_ovr_val_d;
   reg [4-1:0]          SA1_CB_sig0_ovr_sel_d;
   reg [4-1:0]          SA1_CB_sig0_ovr_val_d;
   reg [4-1:0]          SA0_CB_sig1_ovr_sel_d;
   reg [4-1:0]          SA0_CB_sig1_ovr_val_d;
   reg [4-1:0]          SA1_CB_sig1_ovr_sel_d;
   reg [4-1:0]          SA1_CB_sig1_ovr_val_d;
   reg [4-1:0]          SA0_CB_sig2_ovr_sel_d;
   reg [4-1:0]          SA0_CB_sig2_ovr_val_d;
   reg [4-1:0]          SA1_CB_sig2_ovr_sel_d;
   reg [4-1:0]          SA1_CB_sig2_ovr_val_d;
   reg [4-1:0]          SA0_CB_sig3_ovr_sel_d;
   reg [4-1:0]          SA0_CB_sig3_ovr_val_d;
   reg [4-1:0]          SA1_CB_sig3_ovr_sel_d;
   reg [4-1:0]          SA1_CB_sig3_ovr_val_d;

   reg [4-1:0]          SA0_DB_sig0_ovr_sel_d;
   reg [4-1:0]          SA0_DB_sig0_ovr_val_d;
   reg [4-1:0]          SA1_DB_sig0_ovr_sel_d;
   reg [4-1:0]          SA1_DB_sig0_ovr_val_d;
   reg [4-1:0]          SA0_DB_sig1_ovr_sel_d;
   reg [4-1:0]          SA0_DB_sig1_ovr_val_d;
   reg [4-1:0]          SA1_DB_sig1_ovr_sel_d;
   reg [4-1:0]          SA1_DB_sig1_ovr_val_d;
   reg [4-1:0]          SA0_DB_sig2_ovr_sel_d;
   reg [4-1:0]          SA0_DB_sig2_ovr_val_d;
   reg [4-1:0]          SA1_DB_sig2_ovr_sel_d;
   reg [4-1:0]          SA1_DB_sig2_ovr_val_d;
   reg [4-1:0]          SA0_DB_sig3_ovr_sel_d;
   reg [4-1:0]          SA0_DB_sig3_ovr_val_d;
   reg [4-1:0]          SA1_DB_sig3_ovr_sel_d;
   reg [4-1:0]          SA1_DB_sig3_ovr_val_d;

   reg [1-1:0]          SA0_PA_sig0_ovr_sel_d;
   reg [1-1:0]          SA0_PA_sig0_ovr_val_d;
   reg [1-1:0]          SA1_PA_sig0_ovr_sel_d;
   reg [1-1:0]          SA1_PA_sig0_ovr_val_d;
   reg [1-1:0]          SA0_PA_sig1_ovr_sel_d;
   reg [1-1:0]          SA0_PA_sig1_ovr_val_d;
   reg [1-1:0]          SA1_PA_sig1_ovr_sel_d;
   reg [1-1:0]          SA1_PA_sig1_ovr_val_d;

   reg [2-1:0]          SA0_RMI_sig0_ovr_sel_d;
   reg [2-1:0]          SA0_RMI_sig0_ovr_val_d;
   reg [2-1:0]          SA1_RMI_sig0_ovr_sel_d;
   reg [2-1:0]          SA1_RMI_sig0_ovr_val_d;

   reg [1-1:0]          SA0_SC_sig0_ovr_sel_d;
   reg [1-1:0]          SA0_SC_sig0_ovr_val_d;
   reg [1-1:0]          SA1_SC_sig0_ovr_sel_d;
   reg [1-1:0]          SA1_SC_sig0_ovr_val_d;

   reg [1-1:0]          SA0_SX_sig0_ovr_sel_d;
   reg [1-1:0]          SA0_SX_sig0_ovr_val_d;
   reg [1-1:0]          SA1_SX_sig0_ovr_sel_d;
   reg [1-1:0]          SA1_SX_sig0_ovr_val_d;

   reg [4-1:0]          SA0_SXRB_sig0_ovr_sel_d;
   reg [4-1:0]          SA0_SXRB_sig0_ovr_val_d;
   reg [4-1:0]          SA1_SXRB_sig0_ovr_sel_d;
   reg [4-1:0]          SA1_SXRB_sig0_ovr_val_d;

   reg [1-1:0]          SA0_UTCL1_sig0_ovr_sel_d;
   reg [1-1:0]          SA0_UTCL1_sig0_ovr_val_d;
   reg [1-1:0]          SA1_UTCL1_sig0_ovr_sel_d;
   reg [1-1:0]          SA1_UTCL1_sig0_ovr_val_d;

   reg [10-1:0]          SA0_CU_sig0_ovr_sel_d;
   reg [10-1:0]          SA0_CU_sig0_ovr_val_d;
   reg [10-1:0]          SA1_CU_sig0_ovr_sel_d;
   reg [10-1:0]          SA1_CU_sig0_ovr_val_d;

   reg [1-1:0]          SPI_sig0_ovr_sel_d;
   reg [1-1:0]          SPI_sig0_ovr_val_d;
   reg [1-1:0]          SPI_sig1_ovr_sel_d;
   reg [1-1:0]          SPI_sig1_ovr_val_d;
   reg [1-1:0]          SPI_sig2_ovr_sel_d;
   reg [1-1:0]          SPI_sig2_ovr_val_d;
   reg [1-1:0]          SPI_sig3_ovr_sel_d;
   reg [1-1:0]          SPI_sig3_ovr_val_d;
   reg [1-1:0]          SPI_sig4_ovr_sel_d;
   reg [1-1:0]          SPI_sig4_ovr_val_d;
   reg [1-1:0]          SPI_sig5_ovr_sel_d;
   reg [1-1:0]          SPI_sig5_ovr_val_d;

   reg [1-1:0]          PC_sig0_ovr_sel_d;
   reg [1-1:0]          PC_sig0_ovr_val_d;


   reg [`SE_CAC_ID_CAC_BLOCK_ID_SIZE-1:0]   block_id;
   reg [`SE_CAC_ID_CAC_SIGNAL_ID_SIZE-1:0]  signal_id;

   reg [`SE_CAC_IND_INDEX_REG]                cac_ind_index;

   reg [`TARG_GRBM_READ_DATA_RANGE]        reg_read_data_d;

   reg [`SE_CAC_CGTT_CLK_CTRL_ON_DELAY_SIZE-1:0]			cgtt_clk_ctrl_on_delay;
   reg [`SE_CAC_CGTT_CLK_CTRL_OFF_HYSTERESIS_SIZE-1:0] 		cgtt_clk_ctrl_off_hysteresis;
   reg [`SE_CAC_CGTT_CLK_CTRL_SOFT_OVERRIDE_DYN_SIZE-1:0]	cgtt_clk_ctrl_soft_override_dyn;
   reg [`SE_CAC_CGTT_CLK_CTRL_SOFT_OVERRIDE_REG_SIZE-1:0]	cgtt_clk_ctrl_soft_override_reg;


   wire wr_ind_index = reg_send &  reg_op & ({reg_addr, 2'b0} == `SE_CAC_IND_INDEX);
   wire rd_ind_index = reg_send & ~reg_op & ({reg_addr, 2'b0} == `SE_CAC_IND_INDEX);
   wire wr_ind_data  = reg_send &  reg_op & ({reg_addr, 2'b0} == `SE_CAC_IND_DATA);
   wire rd_ind_data  = reg_send & ~reg_op & ({reg_addr, 2'b0} == `SE_CAC_IND_DATA);

   wire  wr_cac_id   = (wr_ind_data & (cac_ind_index == `SE_CAC_ID_DEC_ADDR));
   wire  wr_cac_cntl = (wr_ind_data & (cac_ind_index == `SE_CAC_CNTL_DEC_ADDR));
   wire  wr_ovr_sel  = (wr_ind_data & (cac_ind_index == `SE_CAC_OVR_SEL_DEC_ADDR));
   wire  wr_ovr_val  = (wr_ind_data & (cac_ind_index == `SE_CAC_OVR_VAL_DEC_ADDR));

   wire  rd_cac_id   = (rd_ind_data & (cac_ind_index == `SE_CAC_ID_DEC_ADDR));
   wire  rd_cac_cntl = (rd_ind_data & (cac_ind_index == `SE_CAC_CNTL_DEC_ADDR));
   wire  rd_ovr_sel  = (rd_ind_data & (cac_ind_index == `SE_CAC_OVR_SEL_DEC_ADDR));
   wire  rd_ovr_val  = (rd_ind_data & (cac_ind_index == `SE_CAC_OVR_VAL_DEC_ADDR));

   wire wr_se_cac_cgtt_clk_ctrl = reg_send &  reg_op & ({reg_addr, 2'b0} == `SE_CAC_CGTT_CLK_CTRL);
   wire rd_se_cac_cgtt_clk_ctrl = reg_send & ~reg_op & ({reg_addr, 2'b0} == `SE_CAC_CGTT_CLK_CTRL);

   wire wr_gc_cac_ctrl_2 = reg_send &  reg_op & ({reg_addr, 2'b0} == `GC_CAC_CTRL_2);

   wire [`SE_CAC_ID_CAC_BLOCK_ID_SIZE-1:0]  block_id_d  = wr_cac_id ? reg_wd[`SE_CAC_ID_CAC_BLOCK_ID]  : block_id;
   wire [`SE_CAC_ID_CAC_SIGNAL_ID_SIZE-1:0] signal_id_d = wr_cac_id ? reg_wd[`SE_CAC_ID_CAC_SIGNAL_ID] : signal_id;

   //wire [`SE_CAC_CGTT_CLK_CTRL_REG_SIZE-1:0]  cgtt_clk_ctrl_d = wr_se_cac_cgtt_clk_ctrl ? reg_wd[`SE_CAC_CGTT_CLK_CTRL_REG] : cgtt_clk_ctrl;
   wire [`SE_CAC_CGTT_CLK_CTRL_ON_DELAY_SIZE-1:0]    cgtt_clk_ctrl_on_delay_d = wr_se_cac_cgtt_clk_ctrl ? reg_wd[`SE_CAC_CGTT_CLK_CTRL_ON_DELAY] : cgtt_clk_ctrl_on_delay;
   wire [`SE_CAC_CGTT_CLK_CTRL_OFF_HYSTERESIS_SIZE-1:0]    cgtt_clk_ctrl_off_hysteresis_d = wr_se_cac_cgtt_clk_ctrl ? reg_wd[`SE_CAC_CGTT_CLK_CTRL_OFF_HYSTERESIS] : cgtt_clk_ctrl_off_hysteresis;
   wire [`SE_CAC_CGTT_CLK_CTRL_SOFT_OVERRIDE_DYN_SIZE-1:0]    cgtt_clk_ctrl_soft_override_dyn_d = wr_se_cac_cgtt_clk_ctrl ? reg_wd[`SE_CAC_CGTT_CLK_CTRL_SOFT_OVERRIDE_DYN] : cgtt_clk_ctrl_soft_override_dyn;
   wire [`SE_CAC_CGTT_CLK_CTRL_SOFT_OVERRIDE_REG_SIZE-1:0]    cgtt_clk_ctrl_soft_override_reg_d = wr_se_cac_cgtt_clk_ctrl ? reg_wd[`SE_CAC_CGTT_CLK_CTRL_SOFT_OVERRIDE_REG] : cgtt_clk_ctrl_soft_override_reg;
   wire [`GC_CAC_CTRL_2_SE_LCAC_ENABLE_SIZE-1:0]    se_lcac_enable_d = wr_gc_cac_ctrl_2 ? reg_wd[`GC_CAC_CTRL_2_SE_LCAC_ENABLE] : se_lcac_enable;

   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_TA_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TA_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_TA_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TA_sig0_threshold_d;

   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_TD_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_TD_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_TD_sig1_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig1_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_TD_sig1_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig1_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_TD_sig2_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig2_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_TD_sig2_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig2_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_TD_sig3_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig3_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_TD_sig3_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig3_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_TD_sig4_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig4_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_TD_sig4_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig4_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_TD_sig5_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig5_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_TD_sig5_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig5_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_TD_sig6_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig6_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_TD_sig6_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig6_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_TD_sig7_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig7_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_TD_sig7_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig7_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_TD_sig8_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig8_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_TD_sig8_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig8_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_TD_sig9_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TD_sig9_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_TD_sig9_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TD_sig9_threshold_d;

   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_TCP_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TCP_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_TCP_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TCP_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_TCP_sig1_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TCP_sig1_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_TCP_sig1_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TCP_sig1_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_TCP_sig2_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TCP_sig2_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_TCP_sig2_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TCP_sig2_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_TCP_sig3_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TCP_sig3_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_TCP_sig3_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TCP_sig3_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_TCP_sig4_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_TCP_sig4_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_TCP_sig4_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_TCP_sig4_threshold_d;

   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_SQ_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SQ_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_SQ_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SQ_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_SQ_sig1_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SQ_sig1_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_SQ_sig1_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SQ_sig1_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_SQ_sig2_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SQ_sig2_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_SQ_sig2_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SQ_sig2_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_SQ_sig3_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SQ_sig3_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_SQ_sig3_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SQ_sig3_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_SQ_sig4_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SQ_sig4_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_SQ_sig4_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SQ_sig4_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_SQ_sig5_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SQ_sig5_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_SQ_sig5_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SQ_sig5_threshold_d;

   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_LDS_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_LDS_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_LDS_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_LDS_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_LDS_sig1_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_LDS_sig1_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_LDS_sig1_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_LDS_sig1_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_LDS_sig2_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_LDS_sig2_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_LDS_sig2_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_LDS_sig2_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_LDS_sig3_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_LDS_sig3_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_LDS_sig3_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_LDS_sig3_threshold_d;

   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_BCI_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_BCI_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_BCI_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_BCI_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_BCI_sig1_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_BCI_sig1_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_BCI_sig1_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_BCI_sig1_threshold_d;

   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_CB_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_CB_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_CB_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_CB_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_CB_sig1_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_CB_sig1_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_CB_sig1_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_CB_sig1_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_CB_sig2_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_CB_sig2_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_CB_sig2_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_CB_sig2_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_CB_sig3_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_CB_sig3_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_CB_sig3_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_CB_sig3_threshold_d;

   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_DB_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_DB_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_DB_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_DB_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_DB_sig1_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_DB_sig1_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_DB_sig1_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_DB_sig1_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_DB_sig2_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_DB_sig2_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_DB_sig2_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_DB_sig2_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_DB_sig3_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_DB_sig3_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_DB_sig3_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_DB_sig3_threshold_d;

   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_PA_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_PA_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_PA_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_PA_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_PA_sig1_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_PA_sig1_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_PA_sig1_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_PA_sig1_threshold_d;

   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_RMI_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_RMI_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_RMI_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_RMI_sig0_threshold_d;

   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_SC_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SC_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_SC_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SC_sig0_threshold_d;

   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_SX_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SX_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_SX_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SX_sig0_threshold_d;

   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_SXRB_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_SXRB_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_SXRB_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_SXRB_sig0_threshold_d;

   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_UTCL1_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_UTCL1_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_UTCL1_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_UTCL1_sig0_threshold_d;

   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA0_CU_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA0_CU_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SA1_CU_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SA1_CU_sig0_threshold_d;

   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SPI_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SPI_sig0_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SPI_sig1_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SPI_sig1_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SPI_sig2_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SPI_sig2_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SPI_sig3_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SPI_sig3_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SPI_sig4_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SPI_sig4_threshold_d;
   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   SPI_sig5_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] SPI_sig5_threshold_d;

   reg [`SE_CAC_CNTL_CAC_FORCE_DISABLE_SIZE-1:0]   PC_sig0_force_disable_d;
   reg [`SE_CAC_CNTL_CAC_THRESHOLD_SIZE-1:0] PC_sig0_threshold_d;

always @(*)
begin
   SA0_TA_sig0_force_disable_d    = SA0_TA_sig0_force_disable;
   SA0_TA_sig0_threshold_d = SA0_TA_sig0_threshold;
   SA1_TA_sig0_force_disable_d    = SA1_TA_sig0_force_disable;
   SA1_TA_sig0_threshold_d = SA1_TA_sig0_threshold;
   SA0_TD_sig0_force_disable_d    = SA0_TD_sig0_force_disable;
   SA0_TD_sig0_threshold_d = SA0_TD_sig0_threshold;
   SA1_TD_sig0_force_disable_d    = SA1_TD_sig0_force_disable;
   SA1_TD_sig0_threshold_d = SA1_TD_sig0_threshold;
   SA0_TD_sig1_force_disable_d    = SA0_TD_sig1_force_disable;
   SA0_TD_sig1_threshold_d = SA0_TD_sig1_threshold;
   SA1_TD_sig1_force_disable_d    = SA1_TD_sig1_force_disable;
   SA1_TD_sig1_threshold_d = SA1_TD_sig1_threshold;
   SA0_TD_sig2_force_disable_d    = SA0_TD_sig2_force_disable;
   SA0_TD_sig2_threshold_d = SA0_TD_sig2_threshold;
   SA1_TD_sig2_force_disable_d    = SA1_TD_sig2_force_disable;
   SA1_TD_sig2_threshold_d = SA1_TD_sig2_threshold;
   SA0_TD_sig3_force_disable_d    = SA0_TD_sig3_force_disable;
   SA0_TD_sig3_threshold_d = SA0_TD_sig3_threshold;
   SA1_TD_sig3_force_disable_d    = SA1_TD_sig3_force_disable;
   SA1_TD_sig3_threshold_d = SA1_TD_sig3_threshold;
   SA0_TD_sig4_force_disable_d    = SA0_TD_sig4_force_disable;
   SA0_TD_sig4_threshold_d = SA0_TD_sig4_threshold;
   SA1_TD_sig4_force_disable_d    = SA1_TD_sig4_force_disable;
   SA1_TD_sig4_threshold_d = SA1_TD_sig4_threshold;
   SA0_TD_sig5_force_disable_d    = SA0_TD_sig5_force_disable;
   SA0_TD_sig5_threshold_d = SA0_TD_sig5_threshold;
   SA1_TD_sig5_force_disable_d    = SA1_TD_sig5_force_disable;
   SA1_TD_sig5_threshold_d = SA1_TD_sig5_threshold;
   SA0_TD_sig6_force_disable_d    = SA0_TD_sig6_force_disable;
   SA0_TD_sig6_threshold_d = SA0_TD_sig6_threshold;
   SA1_TD_sig6_force_disable_d    = SA1_TD_sig6_force_disable;
   SA1_TD_sig6_threshold_d = SA1_TD_sig6_threshold;
   SA0_TD_sig7_force_disable_d    = SA0_TD_sig7_force_disable;
   SA0_TD_sig7_threshold_d = SA0_TD_sig7_threshold;
   SA1_TD_sig7_force_disable_d    = SA1_TD_sig7_force_disable;
   SA1_TD_sig7_threshold_d = SA1_TD_sig7_threshold;
   SA0_TD_sig8_force_disable_d    = SA0_TD_sig8_force_disable;
   SA0_TD_sig8_threshold_d = SA0_TD_sig8_threshold;
   SA1_TD_sig8_force_disable_d    = SA1_TD_sig8_force_disable;
   SA1_TD_sig8_threshold_d = SA1_TD_sig8_threshold;
   SA0_TD_sig9_force_disable_d    = SA0_TD_sig9_force_disable;
   SA0_TD_sig9_threshold_d = SA0_TD_sig9_threshold;
   SA1_TD_sig9_force_disable_d    = SA1_TD_sig9_force_disable;
   SA1_TD_sig9_threshold_d = SA1_TD_sig9_threshold;
   SA0_TCP_sig0_force_disable_d    = SA0_TCP_sig0_force_disable;
   SA0_TCP_sig0_threshold_d = SA0_TCP_sig0_threshold;
   SA1_TCP_sig0_force_disable_d    = SA1_TCP_sig0_force_disable;
   SA1_TCP_sig0_threshold_d = SA1_TCP_sig0_threshold;
   SA0_TCP_sig1_force_disable_d    = SA0_TCP_sig1_force_disable;
   SA0_TCP_sig1_threshold_d = SA0_TCP_sig1_threshold;
   SA1_TCP_sig1_force_disable_d    = SA1_TCP_sig1_force_disable;
   SA1_TCP_sig1_threshold_d = SA1_TCP_sig1_threshold;
   SA0_TCP_sig2_force_disable_d    = SA0_TCP_sig2_force_disable;
   SA0_TCP_sig2_threshold_d = SA0_TCP_sig2_threshold;
   SA1_TCP_sig2_force_disable_d    = SA1_TCP_sig2_force_disable;
   SA1_TCP_sig2_threshold_d = SA1_TCP_sig2_threshold;
   SA0_TCP_sig3_force_disable_d    = SA0_TCP_sig3_force_disable;
   SA0_TCP_sig3_threshold_d = SA0_TCP_sig3_threshold;
   SA1_TCP_sig3_force_disable_d    = SA1_TCP_sig3_force_disable;
   SA1_TCP_sig3_threshold_d = SA1_TCP_sig3_threshold;
   SA0_TCP_sig4_force_disable_d    = SA0_TCP_sig4_force_disable;
   SA0_TCP_sig4_threshold_d = SA0_TCP_sig4_threshold;
   SA1_TCP_sig4_force_disable_d    = SA1_TCP_sig4_force_disable;
   SA1_TCP_sig4_threshold_d = SA1_TCP_sig4_threshold;
   SA0_SQ_sig0_force_disable_d    = SA0_SQ_sig0_force_disable;
   SA0_SQ_sig0_threshold_d = SA0_SQ_sig0_threshold;
   SA1_SQ_sig0_force_disable_d    = SA1_SQ_sig0_force_disable;
   SA1_SQ_sig0_threshold_d = SA1_SQ_sig0_threshold;
   SA0_SQ_sig1_force_disable_d    = SA0_SQ_sig1_force_disable;
   SA0_SQ_sig1_threshold_d = SA0_SQ_sig1_threshold;
   SA1_SQ_sig1_force_disable_d    = SA1_SQ_sig1_force_disable;
   SA1_SQ_sig1_threshold_d = SA1_SQ_sig1_threshold;
   SA0_SQ_sig2_force_disable_d    = SA0_SQ_sig2_force_disable;
   SA0_SQ_sig2_threshold_d = SA0_SQ_sig2_threshold;
   SA1_SQ_sig2_force_disable_d    = SA1_SQ_sig2_force_disable;
   SA1_SQ_sig2_threshold_d = SA1_SQ_sig2_threshold;
   SA0_SQ_sig3_force_disable_d    = SA0_SQ_sig3_force_disable;
   SA0_SQ_sig3_threshold_d = SA0_SQ_sig3_threshold;
   SA1_SQ_sig3_force_disable_d    = SA1_SQ_sig3_force_disable;
   SA1_SQ_sig3_threshold_d = SA1_SQ_sig3_threshold;
   SA0_SQ_sig4_force_disable_d    = SA0_SQ_sig4_force_disable;
   SA0_SQ_sig4_threshold_d = SA0_SQ_sig4_threshold;
   SA1_SQ_sig4_force_disable_d    = SA1_SQ_sig4_force_disable;
   SA1_SQ_sig4_threshold_d = SA1_SQ_sig4_threshold;
   SA0_SQ_sig5_force_disable_d    = SA0_SQ_sig5_force_disable;
   SA0_SQ_sig5_threshold_d = SA0_SQ_sig5_threshold;
   SA1_SQ_sig5_force_disable_d    = SA1_SQ_sig5_force_disable;
   SA1_SQ_sig5_threshold_d = SA1_SQ_sig5_threshold;
   SA0_LDS_sig0_force_disable_d    = SA0_LDS_sig0_force_disable;
   SA0_LDS_sig0_threshold_d = SA0_LDS_sig0_threshold;
   SA1_LDS_sig0_force_disable_d    = SA1_LDS_sig0_force_disable;
   SA1_LDS_sig0_threshold_d = SA1_LDS_sig0_threshold;
   SA0_LDS_sig1_force_disable_d    = SA0_LDS_sig1_force_disable;
   SA0_LDS_sig1_threshold_d = SA0_LDS_sig1_threshold;
   SA1_LDS_sig1_force_disable_d    = SA1_LDS_sig1_force_disable;
   SA1_LDS_sig1_threshold_d = SA1_LDS_sig1_threshold;
   SA0_LDS_sig2_force_disable_d    = SA0_LDS_sig2_force_disable;
   SA0_LDS_sig2_threshold_d = SA0_LDS_sig2_threshold;
   SA1_LDS_sig2_force_disable_d    = SA1_LDS_sig2_force_disable;
   SA1_LDS_sig2_threshold_d = SA1_LDS_sig2_threshold;
   SA0_LDS_sig3_force_disable_d    = SA0_LDS_sig3_force_disable;
   SA0_LDS_sig3_threshold_d = SA0_LDS_sig3_threshold;
   SA1_LDS_sig3_force_disable_d    = SA1_LDS_sig3_force_disable;
   SA1_LDS_sig3_threshold_d = SA1_LDS_sig3_threshold;
   SA0_BCI_sig0_force_disable_d    = SA0_BCI_sig0_force_disable;
   SA0_BCI_sig0_threshold_d = SA0_BCI_sig0_threshold;
   SA1_BCI_sig0_force_disable_d    = SA1_BCI_sig0_force_disable;
   SA1_BCI_sig0_threshold_d = SA1_BCI_sig0_threshold;
   SA0_BCI_sig1_force_disable_d    = SA0_BCI_sig1_force_disable;
   SA0_BCI_sig1_threshold_d = SA0_BCI_sig1_threshold;
   SA1_BCI_sig1_force_disable_d    = SA1_BCI_sig1_force_disable;
   SA1_BCI_sig1_threshold_d = SA1_BCI_sig1_threshold;
   SA0_CB_sig0_force_disable_d    = SA0_CB_sig0_force_disable;
   SA0_CB_sig0_threshold_d = SA0_CB_sig0_threshold;
   SA1_CB_sig0_force_disable_d    = SA1_CB_sig0_force_disable;
   SA1_CB_sig0_threshold_d = SA1_CB_sig0_threshold;
   SA0_CB_sig1_force_disable_d    = SA0_CB_sig1_force_disable;
   SA0_CB_sig1_threshold_d = SA0_CB_sig1_threshold;
   SA1_CB_sig1_force_disable_d    = SA1_CB_sig1_force_disable;
   SA1_CB_sig1_threshold_d = SA1_CB_sig1_threshold;
   SA0_CB_sig2_force_disable_d    = SA0_CB_sig2_force_disable;
   SA0_CB_sig2_threshold_d = SA0_CB_sig2_threshold;
   SA1_CB_sig2_force_disable_d    = SA1_CB_sig2_force_disable;
   SA1_CB_sig2_threshold_d = SA1_CB_sig2_threshold;
   SA0_CB_sig3_force_disable_d    = SA0_CB_sig3_force_disable;
   SA0_CB_sig3_threshold_d = SA0_CB_sig3_threshold;
   SA1_CB_sig3_force_disable_d    = SA1_CB_sig3_force_disable;
   SA1_CB_sig3_threshold_d = SA1_CB_sig3_threshold;
   SA0_DB_sig0_force_disable_d    = SA0_DB_sig0_force_disable;
   SA0_DB_sig0_threshold_d = SA0_DB_sig0_threshold;
   SA1_DB_sig0_force_disable_d    = SA1_DB_sig0_force_disable;
   SA1_DB_sig0_threshold_d = SA1_DB_sig0_threshold;
   SA0_DB_sig1_force_disable_d    = SA0_DB_sig1_force_disable;
   SA0_DB_sig1_threshold_d = SA0_DB_sig1_threshold;
   SA1_DB_sig1_force_disable_d    = SA1_DB_sig1_force_disable;
   SA1_DB_sig1_threshold_d = SA1_DB_sig1_threshold;
   SA0_DB_sig2_force_disable_d    = SA0_DB_sig2_force_disable;
   SA0_DB_sig2_threshold_d = SA0_DB_sig2_threshold;
   SA1_DB_sig2_force_disable_d    = SA1_DB_sig2_force_disable;
   SA1_DB_sig2_threshold_d = SA1_DB_sig2_threshold;
   SA0_DB_sig3_force_disable_d    = SA0_DB_sig3_force_disable;
   SA0_DB_sig3_threshold_d = SA0_DB_sig3_threshold;
   SA1_DB_sig3_force_disable_d    = SA1_DB_sig3_force_disable;
   SA1_DB_sig3_threshold_d = SA1_DB_sig3_threshold;
   SA0_PA_sig0_force_disable_d    = SA0_PA_sig0_force_disable;
   SA0_PA_sig0_threshold_d = SA0_PA_sig0_threshold;
   SA1_PA_sig0_force_disable_d    = SA1_PA_sig0_force_disable;
   SA1_PA_sig0_threshold_d = SA1_PA_sig0_threshold;
   SA0_PA_sig1_force_disable_d    = SA0_PA_sig1_force_disable;
   SA0_PA_sig1_threshold_d = SA0_PA_sig1_threshold;
   SA1_PA_sig1_force_disable_d    = SA1_PA_sig1_force_disable;
   SA1_PA_sig1_threshold_d = SA1_PA_sig1_threshold;
   SA0_RMI_sig0_force_disable_d    = SA0_RMI_sig0_force_disable;
   SA0_RMI_sig0_threshold_d = SA0_RMI_sig0_threshold;
   SA1_RMI_sig0_force_disable_d    = SA1_RMI_sig0_force_disable;
   SA1_RMI_sig0_threshold_d = SA1_RMI_sig0_threshold;
   SA0_SC_sig0_force_disable_d    = SA0_SC_sig0_force_disable;
   SA0_SC_sig0_threshold_d = SA0_SC_sig0_threshold;
   SA1_SC_sig0_force_disable_d    = SA1_SC_sig0_force_disable;
   SA1_SC_sig0_threshold_d = SA1_SC_sig0_threshold;
   SA0_SX_sig0_force_disable_d    = SA0_SX_sig0_force_disable;
   SA0_SX_sig0_threshold_d = SA0_SX_sig0_threshold;
   SA1_SX_sig0_force_disable_d    = SA1_SX_sig0_force_disable;
   SA1_SX_sig0_threshold_d = SA1_SX_sig0_threshold;
   SA0_SXRB_sig0_force_disable_d    = SA0_SXRB_sig0_force_disable;
   SA0_SXRB_sig0_threshold_d = SA0_SXRB_sig0_threshold;
   SA1_SXRB_sig0_force_disable_d    = SA1_SXRB_sig0_force_disable;
   SA1_SXRB_sig0_threshold_d = SA1_SXRB_sig0_threshold;
   SA0_UTCL1_sig0_force_disable_d    = SA0_UTCL1_sig0_force_disable;
   SA0_UTCL1_sig0_threshold_d = SA0_UTCL1_sig0_threshold;
   SA1_UTCL1_sig0_force_disable_d    = SA1_UTCL1_sig0_force_disable;
   SA1_UTCL1_sig0_threshold_d = SA1_UTCL1_sig0_threshold;
   SA0_CU_sig0_force_disable_d    = SA0_CU_sig0_force_disable;
   SA0_CU_sig0_threshold_d = SA0_CU_sig0_threshold;
   SA1_CU_sig0_force_disable_d    = SA1_CU_sig0_force_disable;
   SA1_CU_sig0_threshold_d = SA1_CU_sig0_threshold;
   SPI_sig0_force_disable_d    = SPI_sig0_force_disable;
   SPI_sig0_threshold_d = SPI_sig0_threshold;
   SPI_sig1_force_disable_d    = SPI_sig1_force_disable;
   SPI_sig1_threshold_d = SPI_sig1_threshold;
   SPI_sig2_force_disable_d    = SPI_sig2_force_disable;
   SPI_sig2_threshold_d = SPI_sig2_threshold;
   SPI_sig3_force_disable_d    = SPI_sig3_force_disable;
   SPI_sig3_threshold_d = SPI_sig3_threshold;
   SPI_sig4_force_disable_d    = SPI_sig4_force_disable;
   SPI_sig4_threshold_d = SPI_sig4_threshold;
   SPI_sig5_force_disable_d    = SPI_sig5_force_disable;
   SPI_sig5_threshold_d = SPI_sig5_threshold;
   PC_sig0_force_disable_d    = PC_sig0_force_disable;
   PC_sig0_threshold_d = PC_sig0_threshold;

  if (wr_cac_cntl) begin
case( {block_id_d, signal_id_d} )
        14'h0000 : begin
                   SA0_TA_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_TA_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0001 : begin
                   SA1_TA_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_TA_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0100 : begin
                   SA0_TD_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_TD_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0101 : begin
                   SA0_TD_sig1_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_TD_sig1_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0102 : begin
                   SA0_TD_sig2_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_TD_sig2_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0103 : begin
                   SA0_TD_sig3_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_TD_sig3_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0104 : begin
                   SA0_TD_sig4_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_TD_sig4_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0105 : begin
                   SA0_TD_sig5_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_TD_sig5_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0106 : begin
                   SA0_TD_sig6_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_TD_sig6_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0107 : begin
                   SA0_TD_sig7_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_TD_sig7_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0108 : begin
                   SA0_TD_sig8_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_TD_sig8_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0109 : begin
                   SA0_TD_sig9_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_TD_sig9_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h010A : begin
                   SA1_TD_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_TD_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h010B : begin
                   SA1_TD_sig1_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_TD_sig1_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h010C : begin
                   SA1_TD_sig2_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_TD_sig2_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h010D : begin
                   SA1_TD_sig3_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_TD_sig3_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h010E : begin
                   SA1_TD_sig4_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_TD_sig4_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h010F : begin
                   SA1_TD_sig5_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_TD_sig5_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0110 : begin
                   SA1_TD_sig6_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_TD_sig6_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0111 : begin
                   SA1_TD_sig7_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_TD_sig7_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0112 : begin
                   SA1_TD_sig8_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_TD_sig8_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0113 : begin
                   SA1_TD_sig9_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_TD_sig9_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0200 : begin
                   SA0_TCP_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_TCP_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0201 : begin
                   SA0_TCP_sig1_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_TCP_sig1_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0202 : begin
                   SA0_TCP_sig2_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_TCP_sig2_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0203 : begin
                   SA0_TCP_sig3_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_TCP_sig3_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0204 : begin
                   SA0_TCP_sig4_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_TCP_sig4_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0205 : begin
                   SA1_TCP_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_TCP_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0206 : begin
                   SA1_TCP_sig1_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_TCP_sig1_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0207 : begin
                   SA1_TCP_sig2_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_TCP_sig2_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0208 : begin
                   SA1_TCP_sig3_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_TCP_sig3_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0209 : begin
                   SA1_TCP_sig4_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_TCP_sig4_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0300 : begin
                   SA0_SQ_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_SQ_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0301 : begin
                   SA0_SQ_sig1_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_SQ_sig1_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0302 : begin
                   SA0_SQ_sig2_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_SQ_sig2_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0303 : begin
                   SA0_SQ_sig3_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_SQ_sig3_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0304 : begin
                   SA0_SQ_sig4_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_SQ_sig4_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0305 : begin
                   SA0_SQ_sig5_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_SQ_sig5_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0306 : begin
                   SA1_SQ_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_SQ_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0307 : begin
                   SA1_SQ_sig1_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_SQ_sig1_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0308 : begin
                   SA1_SQ_sig2_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_SQ_sig2_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0309 : begin
                   SA1_SQ_sig3_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_SQ_sig3_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h030A : begin
                   SA1_SQ_sig4_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_SQ_sig4_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h030B : begin
                   SA1_SQ_sig5_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_SQ_sig5_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0400 : begin
                   SA0_LDS_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_LDS_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0401 : begin
                   SA0_LDS_sig1_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_LDS_sig1_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0402 : begin
                   SA0_LDS_sig2_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_LDS_sig2_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0403 : begin
                   SA0_LDS_sig3_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_LDS_sig3_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0404 : begin
                   SA1_LDS_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_LDS_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0405 : begin
                   SA1_LDS_sig1_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_LDS_sig1_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0406 : begin
                   SA1_LDS_sig2_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_LDS_sig2_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0407 : begin
                   SA1_LDS_sig3_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_LDS_sig3_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0500 : begin
                   SA0_BCI_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_BCI_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0501 : begin
                   SA0_BCI_sig1_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_BCI_sig1_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0502 : begin
                   SA1_BCI_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_BCI_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0503 : begin
                   SA1_BCI_sig1_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_BCI_sig1_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0600 : begin
                   SA0_CB_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_CB_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0601 : begin
                   SA0_CB_sig1_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_CB_sig1_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0602 : begin
                   SA0_CB_sig2_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_CB_sig2_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0603 : begin
                   SA0_CB_sig3_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_CB_sig3_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0604 : begin
                   SA1_CB_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_CB_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0605 : begin
                   SA1_CB_sig1_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_CB_sig1_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0606 : begin
                   SA1_CB_sig2_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_CB_sig2_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0607 : begin
                   SA1_CB_sig3_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_CB_sig3_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0700 : begin
                   SA0_DB_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_DB_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0701 : begin
                   SA0_DB_sig1_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_DB_sig1_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0702 : begin
                   SA0_DB_sig2_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_DB_sig2_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0703 : begin
                   SA0_DB_sig3_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_DB_sig3_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0704 : begin
                   SA1_DB_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_DB_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0705 : begin
                   SA1_DB_sig1_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_DB_sig1_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0706 : begin
                   SA1_DB_sig2_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_DB_sig2_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0707 : begin
                   SA1_DB_sig3_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_DB_sig3_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0800 : begin
                   SA0_PA_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_PA_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0801 : begin
                   SA0_PA_sig1_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_PA_sig1_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0802 : begin
                   SA1_PA_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_PA_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0803 : begin
                   SA1_PA_sig1_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_PA_sig1_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0900 : begin
                   SA0_RMI_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_RMI_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0901 : begin
                   SA1_RMI_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_RMI_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0A00 : begin
                   SA0_SC_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_SC_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0A01 : begin
                   SA1_SC_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_SC_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0B00 : begin
                   SA0_SX_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_SX_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0B01 : begin
                   SA1_SX_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_SX_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0C00 : begin
                   SA0_SXRB_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_SXRB_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0C01 : begin
                   SA1_SXRB_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_SXRB_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0D00 : begin
                   SA0_UTCL1_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_UTCL1_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0D01 : begin
                   SA1_UTCL1_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_UTCL1_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0E00 : begin
                   SA0_CU_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA0_CU_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0E01 : begin
                   SA1_CU_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SA1_CU_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0F00 : begin
                   SPI_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SPI_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0F01 : begin
                   SPI_sig1_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SPI_sig1_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0F02 : begin
                   SPI_sig2_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SPI_sig2_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0F03 : begin
                   SPI_sig3_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SPI_sig3_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0F04 : begin
                   SPI_sig4_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SPI_sig4_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h0F05 : begin
                   SPI_sig5_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   SPI_sig5_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
        14'h1000 : begin
                   PC_sig0_force_disable_d = reg_wd[`SE_CAC_CNTL_CAC_FORCE_DISABLE];
                   PC_sig0_threshold_d = reg_wd[`SE_CAC_CNTL_CAC_THRESHOLD];
                   end
      endcase // case ( {block_id, signal_id} )
  end // if (wr_ovr_sel)
end // always @(*)


always @(*)
begin
   SA0_TA_sig0_ovr_sel_d = SA0_TA_sig0_ovr_sel;
   SA1_TA_sig0_ovr_sel_d = SA1_TA_sig0_ovr_sel;
   SA0_TD_sig0_ovr_sel_d = SA0_TD_sig0_ovr_sel;
   SA1_TD_sig0_ovr_sel_d = SA1_TD_sig0_ovr_sel;
   SA0_TD_sig1_ovr_sel_d = SA0_TD_sig1_ovr_sel;
   SA1_TD_sig1_ovr_sel_d = SA1_TD_sig1_ovr_sel;
   SA0_TD_sig2_ovr_sel_d = SA0_TD_sig2_ovr_sel;
   SA1_TD_sig2_ovr_sel_d = SA1_TD_sig2_ovr_sel;
   SA0_TD_sig3_ovr_sel_d = SA0_TD_sig3_ovr_sel;
   SA1_TD_sig3_ovr_sel_d = SA1_TD_sig3_ovr_sel;
   SA0_TD_sig4_ovr_sel_d = SA0_TD_sig4_ovr_sel;
   SA1_TD_sig4_ovr_sel_d = SA1_TD_sig4_ovr_sel;
   SA0_TD_sig5_ovr_sel_d = SA0_TD_sig5_ovr_sel;
   SA1_TD_sig5_ovr_sel_d = SA1_TD_sig5_ovr_sel;
   SA0_TD_sig6_ovr_sel_d = SA0_TD_sig6_ovr_sel;
   SA1_TD_sig6_ovr_sel_d = SA1_TD_sig6_ovr_sel;
   SA0_TD_sig7_ovr_sel_d = SA0_TD_sig7_ovr_sel;
   SA1_TD_sig7_ovr_sel_d = SA1_TD_sig7_ovr_sel;
   SA0_TD_sig8_ovr_sel_d = SA0_TD_sig8_ovr_sel;
   SA1_TD_sig8_ovr_sel_d = SA1_TD_sig8_ovr_sel;
   SA0_TD_sig9_ovr_sel_d = SA0_TD_sig9_ovr_sel;
   SA1_TD_sig9_ovr_sel_d = SA1_TD_sig9_ovr_sel;
   SA0_TCP_sig0_ovr_sel_d = SA0_TCP_sig0_ovr_sel;
   SA1_TCP_sig0_ovr_sel_d = SA1_TCP_sig0_ovr_sel;
   SA0_TCP_sig1_ovr_sel_d = SA0_TCP_sig1_ovr_sel;
   SA1_TCP_sig1_ovr_sel_d = SA1_TCP_sig1_ovr_sel;
   SA0_TCP_sig2_ovr_sel_d = SA0_TCP_sig2_ovr_sel;
   SA1_TCP_sig2_ovr_sel_d = SA1_TCP_sig2_ovr_sel;
   SA0_TCP_sig3_ovr_sel_d = SA0_TCP_sig3_ovr_sel;
   SA1_TCP_sig3_ovr_sel_d = SA1_TCP_sig3_ovr_sel;
   SA0_TCP_sig4_ovr_sel_d = SA0_TCP_sig4_ovr_sel;
   SA1_TCP_sig4_ovr_sel_d = SA1_TCP_sig4_ovr_sel;
   SA0_SQ_sig0_ovr_sel_d = SA0_SQ_sig0_ovr_sel;
   SA1_SQ_sig0_ovr_sel_d = SA1_SQ_sig0_ovr_sel;
   SA0_SQ_sig1_ovr_sel_d = SA0_SQ_sig1_ovr_sel;
   SA1_SQ_sig1_ovr_sel_d = SA1_SQ_sig1_ovr_sel;
   SA0_SQ_sig2_ovr_sel_d = SA0_SQ_sig2_ovr_sel;
   SA1_SQ_sig2_ovr_sel_d = SA1_SQ_sig2_ovr_sel;
   SA0_SQ_sig3_ovr_sel_d = SA0_SQ_sig3_ovr_sel;
   SA1_SQ_sig3_ovr_sel_d = SA1_SQ_sig3_ovr_sel;
   SA0_SQ_sig4_ovr_sel_d = SA0_SQ_sig4_ovr_sel;
   SA1_SQ_sig4_ovr_sel_d = SA1_SQ_sig4_ovr_sel;
   SA0_SQ_sig5_ovr_sel_d = SA0_SQ_sig5_ovr_sel;
   SA1_SQ_sig5_ovr_sel_d = SA1_SQ_sig5_ovr_sel;
   SA0_LDS_sig0_ovr_sel_d = SA0_LDS_sig0_ovr_sel;
   SA1_LDS_sig0_ovr_sel_d = SA1_LDS_sig0_ovr_sel;
   SA0_LDS_sig1_ovr_sel_d = SA0_LDS_sig1_ovr_sel;
   SA1_LDS_sig1_ovr_sel_d = SA1_LDS_sig1_ovr_sel;
   SA0_LDS_sig2_ovr_sel_d = SA0_LDS_sig2_ovr_sel;
   SA1_LDS_sig2_ovr_sel_d = SA1_LDS_sig2_ovr_sel;
   SA0_LDS_sig3_ovr_sel_d = SA0_LDS_sig3_ovr_sel;
   SA1_LDS_sig3_ovr_sel_d = SA1_LDS_sig3_ovr_sel;
   SA0_BCI_sig0_ovr_sel_d = SA0_BCI_sig0_ovr_sel;
   SA1_BCI_sig0_ovr_sel_d = SA1_BCI_sig0_ovr_sel;
   SA0_BCI_sig1_ovr_sel_d = SA0_BCI_sig1_ovr_sel;
   SA1_BCI_sig1_ovr_sel_d = SA1_BCI_sig1_ovr_sel;
   SA0_CB_sig0_ovr_sel_d = SA0_CB_sig0_ovr_sel;
   SA1_CB_sig0_ovr_sel_d = SA1_CB_sig0_ovr_sel;
   SA0_CB_sig1_ovr_sel_d = SA0_CB_sig1_ovr_sel;
   SA1_CB_sig1_ovr_sel_d = SA1_CB_sig1_ovr_sel;
   SA0_CB_sig2_ovr_sel_d = SA0_CB_sig2_ovr_sel;
   SA1_CB_sig2_ovr_sel_d = SA1_CB_sig2_ovr_sel;
   SA0_CB_sig3_ovr_sel_d = SA0_CB_sig3_ovr_sel;
   SA1_CB_sig3_ovr_sel_d = SA1_CB_sig3_ovr_sel;
   SA0_DB_sig0_ovr_sel_d = SA0_DB_sig0_ovr_sel;
   SA1_DB_sig0_ovr_sel_d = SA1_DB_sig0_ovr_sel;
   SA0_DB_sig1_ovr_sel_d = SA0_DB_sig1_ovr_sel;
   SA1_DB_sig1_ovr_sel_d = SA1_DB_sig1_ovr_sel;
   SA0_DB_sig2_ovr_sel_d = SA0_DB_sig2_ovr_sel;
   SA1_DB_sig2_ovr_sel_d = SA1_DB_sig2_ovr_sel;
   SA0_DB_sig3_ovr_sel_d = SA0_DB_sig3_ovr_sel;
   SA1_DB_sig3_ovr_sel_d = SA1_DB_sig3_ovr_sel;
   SA0_PA_sig0_ovr_sel_d = SA0_PA_sig0_ovr_sel;
   SA1_PA_sig0_ovr_sel_d = SA1_PA_sig0_ovr_sel;
   SA0_PA_sig1_ovr_sel_d = SA0_PA_sig1_ovr_sel;
   SA1_PA_sig1_ovr_sel_d = SA1_PA_sig1_ovr_sel;
   SA0_RMI_sig0_ovr_sel_d = SA0_RMI_sig0_ovr_sel;
   SA1_RMI_sig0_ovr_sel_d = SA1_RMI_sig0_ovr_sel;
   SA0_SC_sig0_ovr_sel_d = SA0_SC_sig0_ovr_sel;
   SA1_SC_sig0_ovr_sel_d = SA1_SC_sig0_ovr_sel;
   SA0_SX_sig0_ovr_sel_d = SA0_SX_sig0_ovr_sel;
   SA1_SX_sig0_ovr_sel_d = SA1_SX_sig0_ovr_sel;
   SA0_SXRB_sig0_ovr_sel_d = SA0_SXRB_sig0_ovr_sel;
   SA1_SXRB_sig0_ovr_sel_d = SA1_SXRB_sig0_ovr_sel;
   SA0_UTCL1_sig0_ovr_sel_d = SA0_UTCL1_sig0_ovr_sel;
   SA1_UTCL1_sig0_ovr_sel_d = SA1_UTCL1_sig0_ovr_sel;
   SA0_CU_sig0_ovr_sel_d = SA0_CU_sig0_ovr_sel;
   SA1_CU_sig0_ovr_sel_d = SA1_CU_sig0_ovr_sel;
   SPI_sig0_ovr_sel_d = SPI_sig0_ovr_sel;
   SPI_sig1_ovr_sel_d = SPI_sig1_ovr_sel;
   SPI_sig2_ovr_sel_d = SPI_sig2_ovr_sel;
   SPI_sig3_ovr_sel_d = SPI_sig3_ovr_sel;
   SPI_sig4_ovr_sel_d = SPI_sig4_ovr_sel;
   SPI_sig5_ovr_sel_d = SPI_sig5_ovr_sel;
   PC_sig0_ovr_sel_d = PC_sig0_ovr_sel;

  if (wr_ovr_sel) begin
case( {block_id_d, signal_id_d} )
        14'h0000 : SA0_TA_sig0_ovr_sel_d = reg_wd[10-1:0];
        14'h0001 : SA1_TA_sig0_ovr_sel_d = reg_wd[10-1:0];
        14'h0100 : SA0_TD_sig0_ovr_sel_d = reg_wd[10-1:0];
        14'h0101 : SA0_TD_sig1_ovr_sel_d = reg_wd[10-1:0];
        14'h0102 : SA0_TD_sig2_ovr_sel_d = reg_wd[10-1:0];
        14'h0103 : SA0_TD_sig3_ovr_sel_d = reg_wd[10-1:0];
        14'h0104 : SA0_TD_sig4_ovr_sel_d = reg_wd[10-1:0];
        14'h0105 : SA0_TD_sig5_ovr_sel_d = reg_wd[10-1:0];
        14'h0106 : SA0_TD_sig6_ovr_sel_d = reg_wd[10-1:0];
        14'h0107 : SA0_TD_sig7_ovr_sel_d = reg_wd[10-1:0];
        14'h0108 : SA0_TD_sig8_ovr_sel_d = reg_wd[10-1:0];
        14'h0109 : SA0_TD_sig9_ovr_sel_d = reg_wd[10-1:0];
        14'h010A : SA1_TD_sig0_ovr_sel_d = reg_wd[10-1:0];
        14'h010B : SA1_TD_sig1_ovr_sel_d = reg_wd[10-1:0];
        14'h010C : SA1_TD_sig2_ovr_sel_d = reg_wd[10-1:0];
        14'h010D : SA1_TD_sig3_ovr_sel_d = reg_wd[10-1:0];
        14'h010E : SA1_TD_sig4_ovr_sel_d = reg_wd[10-1:0];
        14'h010F : SA1_TD_sig5_ovr_sel_d = reg_wd[10-1:0];
        14'h0110 : SA1_TD_sig6_ovr_sel_d = reg_wd[10-1:0];
        14'h0111 : SA1_TD_sig7_ovr_sel_d = reg_wd[10-1:0];
        14'h0112 : SA1_TD_sig8_ovr_sel_d = reg_wd[10-1:0];
        14'h0113 : SA1_TD_sig9_ovr_sel_d = reg_wd[10-1:0];
        14'h0200 : SA0_TCP_sig0_ovr_sel_d = reg_wd[10-1:0];
        14'h0201 : SA0_TCP_sig1_ovr_sel_d = reg_wd[10-1:0];
        14'h0202 : SA0_TCP_sig2_ovr_sel_d = reg_wd[10-1:0];
        14'h0203 : SA0_TCP_sig3_ovr_sel_d = reg_wd[10-1:0];
        14'h0204 : SA0_TCP_sig4_ovr_sel_d = reg_wd[10-1:0];
        14'h0205 : SA1_TCP_sig0_ovr_sel_d = reg_wd[10-1:0];
        14'h0206 : SA1_TCP_sig1_ovr_sel_d = reg_wd[10-1:0];
        14'h0207 : SA1_TCP_sig2_ovr_sel_d = reg_wd[10-1:0];
        14'h0208 : SA1_TCP_sig3_ovr_sel_d = reg_wd[10-1:0];
        14'h0209 : SA1_TCP_sig4_ovr_sel_d = reg_wd[10-1:0];
        14'h0300 : SA0_SQ_sig0_ovr_sel_d = reg_wd[5-1:0];
        14'h0301 : SA0_SQ_sig1_ovr_sel_d = reg_wd[5-1:0];
        14'h0302 : SA0_SQ_sig2_ovr_sel_d = reg_wd[5-1:0];
        14'h0303 : SA0_SQ_sig3_ovr_sel_d = reg_wd[5-1:0];
        14'h0304 : SA0_SQ_sig4_ovr_sel_d = reg_wd[5-1:0];
        14'h0305 : SA0_SQ_sig5_ovr_sel_d = reg_wd[5-1:0];
        14'h0306 : SA1_SQ_sig0_ovr_sel_d = reg_wd[5-1:0];
        14'h0307 : SA1_SQ_sig1_ovr_sel_d = reg_wd[5-1:0];
        14'h0308 : SA1_SQ_sig2_ovr_sel_d = reg_wd[5-1:0];
        14'h0309 : SA1_SQ_sig3_ovr_sel_d = reg_wd[5-1:0];
        14'h030A : SA1_SQ_sig4_ovr_sel_d = reg_wd[5-1:0];
        14'h030B : SA1_SQ_sig5_ovr_sel_d = reg_wd[5-1:0];
        14'h0400 : SA0_LDS_sig0_ovr_sel_d = reg_wd[10-1:0];
        14'h0401 : SA0_LDS_sig1_ovr_sel_d = reg_wd[10-1:0];
        14'h0402 : SA0_LDS_sig2_ovr_sel_d = reg_wd[10-1:0];
        14'h0403 : SA0_LDS_sig3_ovr_sel_d = reg_wd[10-1:0];
        14'h0404 : SA1_LDS_sig0_ovr_sel_d = reg_wd[10-1:0];
        14'h0405 : SA1_LDS_sig1_ovr_sel_d = reg_wd[10-1:0];
        14'h0406 : SA1_LDS_sig2_ovr_sel_d = reg_wd[10-1:0];
        14'h0407 : SA1_LDS_sig3_ovr_sel_d = reg_wd[10-1:0];
        14'h0500 : SA0_BCI_sig0_ovr_sel_d = reg_wd[1-1:0];
        14'h0501 : SA0_BCI_sig1_ovr_sel_d = reg_wd[1-1:0];
        14'h0502 : SA1_BCI_sig0_ovr_sel_d = reg_wd[1-1:0];
        14'h0503 : SA1_BCI_sig1_ovr_sel_d = reg_wd[1-1:0];
        14'h0600 : SA0_CB_sig0_ovr_sel_d = reg_wd[4-1:0];
        14'h0601 : SA0_CB_sig1_ovr_sel_d = reg_wd[4-1:0];
        14'h0602 : SA0_CB_sig2_ovr_sel_d = reg_wd[4-1:0];
        14'h0603 : SA0_CB_sig3_ovr_sel_d = reg_wd[4-1:0];
        14'h0604 : SA1_CB_sig0_ovr_sel_d = reg_wd[4-1:0];
        14'h0605 : SA1_CB_sig1_ovr_sel_d = reg_wd[4-1:0];
        14'h0606 : SA1_CB_sig2_ovr_sel_d = reg_wd[4-1:0];
        14'h0607 : SA1_CB_sig3_ovr_sel_d = reg_wd[4-1:0];
        14'h0700 : SA0_DB_sig0_ovr_sel_d = reg_wd[4-1:0];
        14'h0701 : SA0_DB_sig1_ovr_sel_d = reg_wd[4-1:0];
        14'h0702 : SA0_DB_sig2_ovr_sel_d = reg_wd[4-1:0];
        14'h0703 : SA0_DB_sig3_ovr_sel_d = reg_wd[4-1:0];
        14'h0704 : SA1_DB_sig0_ovr_sel_d = reg_wd[4-1:0];
        14'h0705 : SA1_DB_sig1_ovr_sel_d = reg_wd[4-1:0];
        14'h0706 : SA1_DB_sig2_ovr_sel_d = reg_wd[4-1:0];
        14'h0707 : SA1_DB_sig3_ovr_sel_d = reg_wd[4-1:0];
        14'h0800 : SA0_PA_sig0_ovr_sel_d = reg_wd[1-1:0];
        14'h0801 : SA0_PA_sig1_ovr_sel_d = reg_wd[1-1:0];
        14'h0802 : SA1_PA_sig0_ovr_sel_d = reg_wd[1-1:0];
        14'h0803 : SA1_PA_sig1_ovr_sel_d = reg_wd[1-1:0];
        14'h0900 : SA0_RMI_sig0_ovr_sel_d = reg_wd[2-1:0];
        14'h0901 : SA1_RMI_sig0_ovr_sel_d = reg_wd[2-1:0];
        14'h0A00 : SA0_SC_sig0_ovr_sel_d = reg_wd[1-1:0];
        14'h0A01 : SA1_SC_sig0_ovr_sel_d = reg_wd[1-1:0];
        14'h0B00 : SA0_SX_sig0_ovr_sel_d = reg_wd[1-1:0];
        14'h0B01 : SA1_SX_sig0_ovr_sel_d = reg_wd[1-1:0];
        14'h0C00 : SA0_SXRB_sig0_ovr_sel_d = reg_wd[4-1:0];
        14'h0C01 : SA1_SXRB_sig0_ovr_sel_d = reg_wd[4-1:0];
        14'h0D00 : SA0_UTCL1_sig0_ovr_sel_d = reg_wd[1-1:0];
        14'h0D01 : SA1_UTCL1_sig0_ovr_sel_d = reg_wd[1-1:0];
        14'h0E00 : SA0_CU_sig0_ovr_sel_d = reg_wd[10-1:0];
        14'h0E01 : SA1_CU_sig0_ovr_sel_d = reg_wd[10-1:0];
        14'h0F00 : SPI_sig0_ovr_sel_d = reg_wd[1-1:0];
        14'h0F01 : SPI_sig1_ovr_sel_d = reg_wd[1-1:0];
        14'h0F02 : SPI_sig2_ovr_sel_d = reg_wd[1-1:0];
        14'h0F03 : SPI_sig3_ovr_sel_d = reg_wd[1-1:0];
        14'h0F04 : SPI_sig4_ovr_sel_d = reg_wd[1-1:0];
        14'h0F05 : SPI_sig5_ovr_sel_d = reg_wd[1-1:0];
        14'h1000 : PC_sig0_ovr_sel_d = reg_wd[1-1:0];
      endcase // case ( {block_id, signal_id} )
  end // if (wr_ovr_sel)
end // always @(*)


always @(*)
begin
   SA0_TA_sig0_ovr_val_d = SA0_TA_sig0_ovr_val;
   SA1_TA_sig0_ovr_val_d = SA1_TA_sig0_ovr_val;
   SA0_TD_sig0_ovr_val_d = SA0_TD_sig0_ovr_val;
   SA1_TD_sig0_ovr_val_d = SA1_TD_sig0_ovr_val;
   SA0_TD_sig1_ovr_val_d = SA0_TD_sig1_ovr_val;
   SA1_TD_sig1_ovr_val_d = SA1_TD_sig1_ovr_val;
   SA0_TD_sig2_ovr_val_d = SA0_TD_sig2_ovr_val;
   SA1_TD_sig2_ovr_val_d = SA1_TD_sig2_ovr_val;
   SA0_TD_sig3_ovr_val_d = SA0_TD_sig3_ovr_val;
   SA1_TD_sig3_ovr_val_d = SA1_TD_sig3_ovr_val;
   SA0_TD_sig4_ovr_val_d = SA0_TD_sig4_ovr_val;
   SA1_TD_sig4_ovr_val_d = SA1_TD_sig4_ovr_val;
   SA0_TD_sig5_ovr_val_d = SA0_TD_sig5_ovr_val;
   SA1_TD_sig5_ovr_val_d = SA1_TD_sig5_ovr_val;
   SA0_TD_sig6_ovr_val_d = SA0_TD_sig6_ovr_val;
   SA1_TD_sig6_ovr_val_d = SA1_TD_sig6_ovr_val;
   SA0_TD_sig7_ovr_val_d = SA0_TD_sig7_ovr_val;
   SA1_TD_sig7_ovr_val_d = SA1_TD_sig7_ovr_val;
   SA0_TD_sig8_ovr_val_d = SA0_TD_sig8_ovr_val;
   SA1_TD_sig8_ovr_val_d = SA1_TD_sig8_ovr_val;
   SA0_TD_sig9_ovr_val_d = SA0_TD_sig9_ovr_val;
   SA1_TD_sig9_ovr_val_d = SA1_TD_sig9_ovr_val;
   SA0_TCP_sig0_ovr_val_d = SA0_TCP_sig0_ovr_val;
   SA1_TCP_sig0_ovr_val_d = SA1_TCP_sig0_ovr_val;
   SA0_TCP_sig1_ovr_val_d = SA0_TCP_sig1_ovr_val;
   SA1_TCP_sig1_ovr_val_d = SA1_TCP_sig1_ovr_val;
   SA0_TCP_sig2_ovr_val_d = SA0_TCP_sig2_ovr_val;
   SA1_TCP_sig2_ovr_val_d = SA1_TCP_sig2_ovr_val;
   SA0_TCP_sig3_ovr_val_d = SA0_TCP_sig3_ovr_val;
   SA1_TCP_sig3_ovr_val_d = SA1_TCP_sig3_ovr_val;
   SA0_TCP_sig4_ovr_val_d = SA0_TCP_sig4_ovr_val;
   SA1_TCP_sig4_ovr_val_d = SA1_TCP_sig4_ovr_val;
   SA0_SQ_sig0_ovr_val_d = SA0_SQ_sig0_ovr_val;
   SA1_SQ_sig0_ovr_val_d = SA1_SQ_sig0_ovr_val;
   SA0_SQ_sig1_ovr_val_d = SA0_SQ_sig1_ovr_val;
   SA1_SQ_sig1_ovr_val_d = SA1_SQ_sig1_ovr_val;
   SA0_SQ_sig2_ovr_val_d = SA0_SQ_sig2_ovr_val;
   SA1_SQ_sig2_ovr_val_d = SA1_SQ_sig2_ovr_val;
   SA0_SQ_sig3_ovr_val_d = SA0_SQ_sig3_ovr_val;
   SA1_SQ_sig3_ovr_val_d = SA1_SQ_sig3_ovr_val;
   SA0_SQ_sig4_ovr_val_d = SA0_SQ_sig4_ovr_val;
   SA1_SQ_sig4_ovr_val_d = SA1_SQ_sig4_ovr_val;
   SA0_SQ_sig5_ovr_val_d = SA0_SQ_sig5_ovr_val;
   SA1_SQ_sig5_ovr_val_d = SA1_SQ_sig5_ovr_val;
   SA0_LDS_sig0_ovr_val_d = SA0_LDS_sig0_ovr_val;
   SA1_LDS_sig0_ovr_val_d = SA1_LDS_sig0_ovr_val;
   SA0_LDS_sig1_ovr_val_d = SA0_LDS_sig1_ovr_val;
   SA1_LDS_sig1_ovr_val_d = SA1_LDS_sig1_ovr_val;
   SA0_LDS_sig2_ovr_val_d = SA0_LDS_sig2_ovr_val;
   SA1_LDS_sig2_ovr_val_d = SA1_LDS_sig2_ovr_val;
   SA0_LDS_sig3_ovr_val_d = SA0_LDS_sig3_ovr_val;
   SA1_LDS_sig3_ovr_val_d = SA1_LDS_sig3_ovr_val;
   SA0_BCI_sig0_ovr_val_d = SA0_BCI_sig0_ovr_val;
   SA1_BCI_sig0_ovr_val_d = SA1_BCI_sig0_ovr_val;
   SA0_BCI_sig1_ovr_val_d = SA0_BCI_sig1_ovr_val;
   SA1_BCI_sig1_ovr_val_d = SA1_BCI_sig1_ovr_val;
   SA0_CB_sig0_ovr_val_d = SA0_CB_sig0_ovr_val;
   SA1_CB_sig0_ovr_val_d = SA1_CB_sig0_ovr_val;
   SA0_CB_sig1_ovr_val_d = SA0_CB_sig1_ovr_val;
   SA1_CB_sig1_ovr_val_d = SA1_CB_sig1_ovr_val;
   SA0_CB_sig2_ovr_val_d = SA0_CB_sig2_ovr_val;
   SA1_CB_sig2_ovr_val_d = SA1_CB_sig2_ovr_val;
   SA0_CB_sig3_ovr_val_d = SA0_CB_sig3_ovr_val;
   SA1_CB_sig3_ovr_val_d = SA1_CB_sig3_ovr_val;
   SA0_DB_sig0_ovr_val_d = SA0_DB_sig0_ovr_val;
   SA1_DB_sig0_ovr_val_d = SA1_DB_sig0_ovr_val;
   SA0_DB_sig1_ovr_val_d = SA0_DB_sig1_ovr_val;
   SA1_DB_sig1_ovr_val_d = SA1_DB_sig1_ovr_val;
   SA0_DB_sig2_ovr_val_d = SA0_DB_sig2_ovr_val;
   SA1_DB_sig2_ovr_val_d = SA1_DB_sig2_ovr_val;
   SA0_DB_sig3_ovr_val_d = SA0_DB_sig3_ovr_val;
   SA1_DB_sig3_ovr_val_d = SA1_DB_sig3_ovr_val;
   SA0_PA_sig0_ovr_val_d = SA0_PA_sig0_ovr_val;
   SA1_PA_sig0_ovr_val_d = SA1_PA_sig0_ovr_val;
   SA0_PA_sig1_ovr_val_d = SA0_PA_sig1_ovr_val;
   SA1_PA_sig1_ovr_val_d = SA1_PA_sig1_ovr_val;
   SA0_RMI_sig0_ovr_val_d = SA0_RMI_sig0_ovr_val;
   SA1_RMI_sig0_ovr_val_d = SA1_RMI_sig0_ovr_val;
   SA0_SC_sig0_ovr_val_d = SA0_SC_sig0_ovr_val;
   SA1_SC_sig0_ovr_val_d = SA1_SC_sig0_ovr_val;
   SA0_SX_sig0_ovr_val_d = SA0_SX_sig0_ovr_val;
   SA1_SX_sig0_ovr_val_d = SA1_SX_sig0_ovr_val;
   SA0_SXRB_sig0_ovr_val_d = SA0_SXRB_sig0_ovr_val;
   SA1_SXRB_sig0_ovr_val_d = SA1_SXRB_sig0_ovr_val;
   SA0_UTCL1_sig0_ovr_val_d = SA0_UTCL1_sig0_ovr_val;
   SA1_UTCL1_sig0_ovr_val_d = SA1_UTCL1_sig0_ovr_val;
   SA0_CU_sig0_ovr_val_d = SA0_CU_sig0_ovr_val;
   SA1_CU_sig0_ovr_val_d = SA1_CU_sig0_ovr_val;
   SPI_sig0_ovr_val_d = SPI_sig0_ovr_val;
   SPI_sig1_ovr_val_d = SPI_sig1_ovr_val;
   SPI_sig2_ovr_val_d = SPI_sig2_ovr_val;
   SPI_sig3_ovr_val_d = SPI_sig3_ovr_val;
   SPI_sig4_ovr_val_d = SPI_sig4_ovr_val;
   SPI_sig5_ovr_val_d = SPI_sig5_ovr_val;
   PC_sig0_ovr_val_d = PC_sig0_ovr_val;

  if (wr_ovr_val) begin
case( {block_id_d, signal_id_d} )
        14'h0000 : SA0_TA_sig0_ovr_val_d = reg_wd[10-1:0];
        14'h0001 : SA1_TA_sig0_ovr_val_d = reg_wd[10-1:0];
        14'h0100 : SA0_TD_sig0_ovr_val_d = reg_wd[10-1:0];
        14'h0101 : SA0_TD_sig1_ovr_val_d = reg_wd[10-1:0];
        14'h0102 : SA0_TD_sig2_ovr_val_d = reg_wd[10-1:0];
        14'h0103 : SA0_TD_sig3_ovr_val_d = reg_wd[10-1:0];
        14'h0104 : SA0_TD_sig4_ovr_val_d = reg_wd[10-1:0];
        14'h0105 : SA0_TD_sig5_ovr_val_d = reg_wd[10-1:0];
        14'h0106 : SA0_TD_sig6_ovr_val_d = reg_wd[10-1:0];
        14'h0107 : SA0_TD_sig7_ovr_val_d = reg_wd[10-1:0];
        14'h0108 : SA0_TD_sig8_ovr_val_d = reg_wd[10-1:0];
        14'h0109 : SA0_TD_sig9_ovr_val_d = reg_wd[10-1:0];
        14'h010A : SA1_TD_sig0_ovr_val_d = reg_wd[10-1:0];
        14'h010B : SA1_TD_sig1_ovr_val_d = reg_wd[10-1:0];
        14'h010C : SA1_TD_sig2_ovr_val_d = reg_wd[10-1:0];
        14'h010D : SA1_TD_sig3_ovr_val_d = reg_wd[10-1:0];
        14'h010E : SA1_TD_sig4_ovr_val_d = reg_wd[10-1:0];
        14'h010F : SA1_TD_sig5_ovr_val_d = reg_wd[10-1:0];
        14'h0110 : SA1_TD_sig6_ovr_val_d = reg_wd[10-1:0];
        14'h0111 : SA1_TD_sig7_ovr_val_d = reg_wd[10-1:0];
        14'h0112 : SA1_TD_sig8_ovr_val_d = reg_wd[10-1:0];
        14'h0113 : SA1_TD_sig9_ovr_val_d = reg_wd[10-1:0];
        14'h0200 : SA0_TCP_sig0_ovr_val_d = reg_wd[10-1:0];
        14'h0201 : SA0_TCP_sig1_ovr_val_d = reg_wd[10-1:0];
        14'h0202 : SA0_TCP_sig2_ovr_val_d = reg_wd[10-1:0];
        14'h0203 : SA0_TCP_sig3_ovr_val_d = reg_wd[10-1:0];
        14'h0204 : SA0_TCP_sig4_ovr_val_d = reg_wd[10-1:0];
        14'h0205 : SA1_TCP_sig0_ovr_val_d = reg_wd[10-1:0];
        14'h0206 : SA1_TCP_sig1_ovr_val_d = reg_wd[10-1:0];
        14'h0207 : SA1_TCP_sig2_ovr_val_d = reg_wd[10-1:0];
        14'h0208 : SA1_TCP_sig3_ovr_val_d = reg_wd[10-1:0];
        14'h0209 : SA1_TCP_sig4_ovr_val_d = reg_wd[10-1:0];
        14'h0300 : SA0_SQ_sig0_ovr_val_d = reg_wd[5-1:0];
        14'h0301 : SA0_SQ_sig1_ovr_val_d = reg_wd[5-1:0];
        14'h0302 : SA0_SQ_sig2_ovr_val_d = reg_wd[5-1:0];
        14'h0303 : SA0_SQ_sig3_ovr_val_d = reg_wd[5-1:0];
        14'h0304 : SA0_SQ_sig4_ovr_val_d = reg_wd[5-1:0];
        14'h0305 : SA0_SQ_sig5_ovr_val_d = reg_wd[5-1:0];
        14'h0306 : SA1_SQ_sig0_ovr_val_d = reg_wd[5-1:0];
        14'h0307 : SA1_SQ_sig1_ovr_val_d = reg_wd[5-1:0];
        14'h0308 : SA1_SQ_sig2_ovr_val_d = reg_wd[5-1:0];
        14'h0309 : SA1_SQ_sig3_ovr_val_d = reg_wd[5-1:0];
        14'h030A : SA1_SQ_sig4_ovr_val_d = reg_wd[5-1:0];
        14'h030B : SA1_SQ_sig5_ovr_val_d = reg_wd[5-1:0];
        14'h0400 : SA0_LDS_sig0_ovr_val_d = reg_wd[10-1:0];
        14'h0401 : SA0_LDS_sig1_ovr_val_d = reg_wd[10-1:0];
        14'h0402 : SA0_LDS_sig2_ovr_val_d = reg_wd[10-1:0];
        14'h0403 : SA0_LDS_sig3_ovr_val_d = reg_wd[10-1:0];
        14'h0404 : SA1_LDS_sig0_ovr_val_d = reg_wd[10-1:0];
        14'h0405 : SA1_LDS_sig1_ovr_val_d = reg_wd[10-1:0];
        14'h0406 : SA1_LDS_sig2_ovr_val_d = reg_wd[10-1:0];
        14'h0407 : SA1_LDS_sig3_ovr_val_d = reg_wd[10-1:0];
        14'h0500 : SA0_BCI_sig0_ovr_val_d = reg_wd[1-1:0];
        14'h0501 : SA0_BCI_sig1_ovr_val_d = reg_wd[1-1:0];
        14'h0502 : SA1_BCI_sig0_ovr_val_d = reg_wd[1-1:0];
        14'h0503 : SA1_BCI_sig1_ovr_val_d = reg_wd[1-1:0];
        14'h0600 : SA0_CB_sig0_ovr_val_d = reg_wd[4-1:0];
        14'h0601 : SA0_CB_sig1_ovr_val_d = reg_wd[4-1:0];
        14'h0602 : SA0_CB_sig2_ovr_val_d = reg_wd[4-1:0];
        14'h0603 : SA0_CB_sig3_ovr_val_d = reg_wd[4-1:0];
        14'h0604 : SA1_CB_sig0_ovr_val_d = reg_wd[4-1:0];
        14'h0605 : SA1_CB_sig1_ovr_val_d = reg_wd[4-1:0];
        14'h0606 : SA1_CB_sig2_ovr_val_d = reg_wd[4-1:0];
        14'h0607 : SA1_CB_sig3_ovr_val_d = reg_wd[4-1:0];
        14'h0700 : SA0_DB_sig0_ovr_val_d = reg_wd[4-1:0];
        14'h0701 : SA0_DB_sig1_ovr_val_d = reg_wd[4-1:0];
        14'h0702 : SA0_DB_sig2_ovr_val_d = reg_wd[4-1:0];
        14'h0703 : SA0_DB_sig3_ovr_val_d = reg_wd[4-1:0];
        14'h0704 : SA1_DB_sig0_ovr_val_d = reg_wd[4-1:0];
        14'h0705 : SA1_DB_sig1_ovr_val_d = reg_wd[4-1:0];
        14'h0706 : SA1_DB_sig2_ovr_val_d = reg_wd[4-1:0];
        14'h0707 : SA1_DB_sig3_ovr_val_d = reg_wd[4-1:0];
        14'h0800 : SA0_PA_sig0_ovr_val_d = reg_wd[1-1:0];
        14'h0801 : SA0_PA_sig1_ovr_val_d = reg_wd[1-1:0];
        14'h0802 : SA1_PA_sig0_ovr_val_d = reg_wd[1-1:0];
        14'h0803 : SA1_PA_sig1_ovr_val_d = reg_wd[1-1:0];
        14'h0900 : SA0_RMI_sig0_ovr_val_d = reg_wd[2-1:0];
        14'h0901 : SA1_RMI_sig0_ovr_val_d = reg_wd[2-1:0];
        14'h0A00 : SA0_SC_sig0_ovr_val_d = reg_wd[1-1:0];
        14'h0A01 : SA1_SC_sig0_ovr_val_d = reg_wd[1-1:0];
        14'h0B00 : SA0_SX_sig0_ovr_val_d = reg_wd[1-1:0];
        14'h0B01 : SA1_SX_sig0_ovr_val_d = reg_wd[1-1:0];
        14'h0C00 : SA0_SXRB_sig0_ovr_val_d = reg_wd[4-1:0];
        14'h0C01 : SA1_SXRB_sig0_ovr_val_d = reg_wd[4-1:0];
        14'h0D00 : SA0_UTCL1_sig0_ovr_val_d = reg_wd[1-1:0];
        14'h0D01 : SA1_UTCL1_sig0_ovr_val_d = reg_wd[1-1:0];
        14'h0E00 : SA0_CU_sig0_ovr_val_d = reg_wd[10-1:0];
        14'h0E01 : SA1_CU_sig0_ovr_val_d = reg_wd[10-1:0];
        14'h0F00 : SPI_sig0_ovr_val_d = reg_wd[1-1:0];
        14'h0F01 : SPI_sig1_ovr_val_d = reg_wd[1-1:0];
        14'h0F02 : SPI_sig2_ovr_val_d = reg_wd[1-1:0];
        14'h0F03 : SPI_sig3_ovr_val_d = reg_wd[1-1:0];
        14'h0F04 : SPI_sig4_ovr_val_d = reg_wd[1-1:0];
        14'h0F05 : SPI_sig5_ovr_val_d = reg_wd[1-1:0];
        14'h1000 : PC_sig0_ovr_val_d = reg_wd[1-1:0];
      endcase // case ( {block_id, signal_id} )
  end // if (wr_ovr_val)
end // always @(*)


always @(*)
begin
  reg_read_data_d = reg_read_data;
  
  if (rd_se_cac_cgtt_clk_ctrl)
	reg_read_data_d = cgtt_clk_ctrl;
  else if ( rd_ind_index )
    reg_read_data_d = cac_ind_index;
  else if (rd_cac_id || rd_cac_cntl || rd_ovr_sel || rd_ovr_val) begin
case( {block_id_d, signal_id_d} )
        14'h0000 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_TA_sig0_threshold, SA0_TA_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_TA_sig0_ovr_sel}} :  {{(32-10){1'b0}},{SA0_TA_sig0_ovr_val}};
        14'h0001 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_TA_sig0_threshold, SA1_TA_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_TA_sig0_ovr_sel}} :  {{(32-10){1'b0}},{SA1_TA_sig0_ovr_val}};
        14'h0100 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_TD_sig0_threshold, SA0_TD_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_TD_sig0_ovr_sel}} :  {{(32-10){1'b0}},{SA0_TD_sig0_ovr_val}};
        14'h0101 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_TD_sig1_threshold, SA0_TD_sig1_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_TD_sig1_ovr_sel}} :  {{(32-10){1'b0}},{SA0_TD_sig1_ovr_val}};
        14'h0102 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_TD_sig2_threshold, SA0_TD_sig2_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_TD_sig2_ovr_sel}} :  {{(32-10){1'b0}},{SA0_TD_sig2_ovr_val}};
        14'h0103 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_TD_sig3_threshold, SA0_TD_sig3_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_TD_sig3_ovr_sel}} :  {{(32-10){1'b0}},{SA0_TD_sig3_ovr_val}};
        14'h0104 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_TD_sig4_threshold, SA0_TD_sig4_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_TD_sig4_ovr_sel}} :  {{(32-10){1'b0}},{SA0_TD_sig4_ovr_val}};
        14'h0105 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_TD_sig5_threshold, SA0_TD_sig5_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_TD_sig5_ovr_sel}} :  {{(32-10){1'b0}},{SA0_TD_sig5_ovr_val}};
        14'h0106 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_TD_sig6_threshold, SA0_TD_sig6_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_TD_sig6_ovr_sel}} :  {{(32-10){1'b0}},{SA0_TD_sig6_ovr_val}};
        14'h0107 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_TD_sig7_threshold, SA0_TD_sig7_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_TD_sig7_ovr_sel}} :  {{(32-10){1'b0}},{SA0_TD_sig7_ovr_val}};
        14'h0108 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_TD_sig8_threshold, SA0_TD_sig8_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_TD_sig8_ovr_sel}} :  {{(32-10){1'b0}},{SA0_TD_sig8_ovr_val}};
        14'h0109 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_TD_sig9_threshold, SA0_TD_sig9_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_TD_sig9_ovr_sel}} :  {{(32-10){1'b0}},{SA0_TD_sig9_ovr_val}};
        14'h010A : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_TD_sig0_threshold, SA1_TD_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_TD_sig0_ovr_sel}} :  {{(32-10){1'b0}},{SA1_TD_sig0_ovr_val}};
        14'h010B : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_TD_sig1_threshold, SA1_TD_sig1_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_TD_sig1_ovr_sel}} :  {{(32-10){1'b0}},{SA1_TD_sig1_ovr_val}};
        14'h010C : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_TD_sig2_threshold, SA1_TD_sig2_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_TD_sig2_ovr_sel}} :  {{(32-10){1'b0}},{SA1_TD_sig2_ovr_val}};
        14'h010D : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_TD_sig3_threshold, SA1_TD_sig3_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_TD_sig3_ovr_sel}} :  {{(32-10){1'b0}},{SA1_TD_sig3_ovr_val}};
        14'h010E : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_TD_sig4_threshold, SA1_TD_sig4_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_TD_sig4_ovr_sel}} :  {{(32-10){1'b0}},{SA1_TD_sig4_ovr_val}};
        14'h010F : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_TD_sig5_threshold, SA1_TD_sig5_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_TD_sig5_ovr_sel}} :  {{(32-10){1'b0}},{SA1_TD_sig5_ovr_val}};
        14'h0110 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_TD_sig6_threshold, SA1_TD_sig6_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_TD_sig6_ovr_sel}} :  {{(32-10){1'b0}},{SA1_TD_sig6_ovr_val}};
        14'h0111 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_TD_sig7_threshold, SA1_TD_sig7_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_TD_sig7_ovr_sel}} :  {{(32-10){1'b0}},{SA1_TD_sig7_ovr_val}};
        14'h0112 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_TD_sig8_threshold, SA1_TD_sig8_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_TD_sig8_ovr_sel}} :  {{(32-10){1'b0}},{SA1_TD_sig8_ovr_val}};
        14'h0113 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_TD_sig9_threshold, SA1_TD_sig9_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_TD_sig9_ovr_sel}} :  {{(32-10){1'b0}},{SA1_TD_sig9_ovr_val}};
        14'h0200 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_TCP_sig0_threshold, SA0_TCP_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_TCP_sig0_ovr_sel}} :  {{(32-10){1'b0}},{SA0_TCP_sig0_ovr_val}};
        14'h0201 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_TCP_sig1_threshold, SA0_TCP_sig1_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_TCP_sig1_ovr_sel}} :  {{(32-10){1'b0}},{SA0_TCP_sig1_ovr_val}};
        14'h0202 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_TCP_sig2_threshold, SA0_TCP_sig2_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_TCP_sig2_ovr_sel}} :  {{(32-10){1'b0}},{SA0_TCP_sig2_ovr_val}};
        14'h0203 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_TCP_sig3_threshold, SA0_TCP_sig3_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_TCP_sig3_ovr_sel}} :  {{(32-10){1'b0}},{SA0_TCP_sig3_ovr_val}};
        14'h0204 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_TCP_sig4_threshold, SA0_TCP_sig4_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_TCP_sig4_ovr_sel}} :  {{(32-10){1'b0}},{SA0_TCP_sig4_ovr_val}};
        14'h0205 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_TCP_sig0_threshold, SA1_TCP_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_TCP_sig0_ovr_sel}} :  {{(32-10){1'b0}},{SA1_TCP_sig0_ovr_val}};
        14'h0206 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_TCP_sig1_threshold, SA1_TCP_sig1_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_TCP_sig1_ovr_sel}} :  {{(32-10){1'b0}},{SA1_TCP_sig1_ovr_val}};
        14'h0207 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_TCP_sig2_threshold, SA1_TCP_sig2_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_TCP_sig2_ovr_sel}} :  {{(32-10){1'b0}},{SA1_TCP_sig2_ovr_val}};
        14'h0208 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_TCP_sig3_threshold, SA1_TCP_sig3_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_TCP_sig3_ovr_sel}} :  {{(32-10){1'b0}},{SA1_TCP_sig3_ovr_val}};
        14'h0209 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_TCP_sig4_threshold, SA1_TCP_sig4_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_TCP_sig4_ovr_sel}} :  {{(32-10){1'b0}},{SA1_TCP_sig4_ovr_val}};
        14'h0300 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_SQ_sig0_threshold, SA0_SQ_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-5){1'b0}},{SA0_SQ_sig0_ovr_sel}} :  {{(32-5){1'b0}},{SA0_SQ_sig0_ovr_val}};
        14'h0301 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_SQ_sig1_threshold, SA0_SQ_sig1_force_disable} :
                                     rd_ovr_sel  ?{{(32-5){1'b0}},{SA0_SQ_sig1_ovr_sel}} :  {{(32-5){1'b0}},{SA0_SQ_sig1_ovr_val}};
        14'h0302 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_SQ_sig2_threshold, SA0_SQ_sig2_force_disable} :
                                     rd_ovr_sel  ?{{(32-5){1'b0}},{SA0_SQ_sig2_ovr_sel}} :  {{(32-5){1'b0}},{SA0_SQ_sig2_ovr_val}};
        14'h0303 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_SQ_sig3_threshold, SA0_SQ_sig3_force_disable} :
                                     rd_ovr_sel  ?{{(32-5){1'b0}},{SA0_SQ_sig3_ovr_sel}} :  {{(32-5){1'b0}},{SA0_SQ_sig3_ovr_val}};
        14'h0304 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_SQ_sig4_threshold, SA0_SQ_sig4_force_disable} :
                                     rd_ovr_sel  ?{{(32-5){1'b0}},{SA0_SQ_sig4_ovr_sel}} :  {{(32-5){1'b0}},{SA0_SQ_sig4_ovr_val}};
        14'h0305 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_SQ_sig5_threshold, SA0_SQ_sig5_force_disable} :
                                     rd_ovr_sel  ?{{(32-5){1'b0}},{SA0_SQ_sig5_ovr_sel}} :  {{(32-5){1'b0}},{SA0_SQ_sig5_ovr_val}};
        14'h0306 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_SQ_sig0_threshold, SA1_SQ_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-5){1'b0}},{SA1_SQ_sig0_ovr_sel}} :  {{(32-5){1'b0}},{SA1_SQ_sig0_ovr_val}};
        14'h0307 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_SQ_sig1_threshold, SA1_SQ_sig1_force_disable} :
                                     rd_ovr_sel  ?{{(32-5){1'b0}},{SA1_SQ_sig1_ovr_sel}} :  {{(32-5){1'b0}},{SA1_SQ_sig1_ovr_val}};
        14'h0308 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_SQ_sig2_threshold, SA1_SQ_sig2_force_disable} :
                                     rd_ovr_sel  ?{{(32-5){1'b0}},{SA1_SQ_sig2_ovr_sel}} :  {{(32-5){1'b0}},{SA1_SQ_sig2_ovr_val}};
        14'h0309 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_SQ_sig3_threshold, SA1_SQ_sig3_force_disable} :
                                     rd_ovr_sel  ?{{(32-5){1'b0}},{SA1_SQ_sig3_ovr_sel}} :  {{(32-5){1'b0}},{SA1_SQ_sig3_ovr_val}};
        14'h030A : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_SQ_sig4_threshold, SA1_SQ_sig4_force_disable} :
                                     rd_ovr_sel  ?{{(32-5){1'b0}},{SA1_SQ_sig4_ovr_sel}} :  {{(32-5){1'b0}},{SA1_SQ_sig4_ovr_val}};
        14'h030B : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_SQ_sig5_threshold, SA1_SQ_sig5_force_disable} :
                                     rd_ovr_sel  ?{{(32-5){1'b0}},{SA1_SQ_sig5_ovr_sel}} :  {{(32-5){1'b0}},{SA1_SQ_sig5_ovr_val}};
        14'h0400 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_LDS_sig0_threshold, SA0_LDS_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_LDS_sig0_ovr_sel}} :  {{(32-10){1'b0}},{SA0_LDS_sig0_ovr_val}};
        14'h0401 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_LDS_sig1_threshold, SA0_LDS_sig1_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_LDS_sig1_ovr_sel}} :  {{(32-10){1'b0}},{SA0_LDS_sig1_ovr_val}};
        14'h0402 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_LDS_sig2_threshold, SA0_LDS_sig2_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_LDS_sig2_ovr_sel}} :  {{(32-10){1'b0}},{SA0_LDS_sig2_ovr_val}};
        14'h0403 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_LDS_sig3_threshold, SA0_LDS_sig3_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_LDS_sig3_ovr_sel}} :  {{(32-10){1'b0}},{SA0_LDS_sig3_ovr_val}};
        14'h0404 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_LDS_sig0_threshold, SA1_LDS_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_LDS_sig0_ovr_sel}} :  {{(32-10){1'b0}},{SA1_LDS_sig0_ovr_val}};
        14'h0405 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_LDS_sig1_threshold, SA1_LDS_sig1_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_LDS_sig1_ovr_sel}} :  {{(32-10){1'b0}},{SA1_LDS_sig1_ovr_val}};
        14'h0406 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_LDS_sig2_threshold, SA1_LDS_sig2_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_LDS_sig2_ovr_sel}} :  {{(32-10){1'b0}},{SA1_LDS_sig2_ovr_val}};
        14'h0407 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_LDS_sig3_threshold, SA1_LDS_sig3_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_LDS_sig3_ovr_sel}} :  {{(32-10){1'b0}},{SA1_LDS_sig3_ovr_val}};
        14'h0500 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_BCI_sig0_threshold, SA0_BCI_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SA0_BCI_sig0_ovr_sel}} :  {{(32-1){1'b0}},{SA0_BCI_sig0_ovr_val}};
        14'h0501 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_BCI_sig1_threshold, SA0_BCI_sig1_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SA0_BCI_sig1_ovr_sel}} :  {{(32-1){1'b0}},{SA0_BCI_sig1_ovr_val}};
        14'h0502 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_BCI_sig0_threshold, SA1_BCI_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SA1_BCI_sig0_ovr_sel}} :  {{(32-1){1'b0}},{SA1_BCI_sig0_ovr_val}};
        14'h0503 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_BCI_sig1_threshold, SA1_BCI_sig1_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SA1_BCI_sig1_ovr_sel}} :  {{(32-1){1'b0}},{SA1_BCI_sig1_ovr_val}};
        14'h0600 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_CB_sig0_threshold, SA0_CB_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA0_CB_sig0_ovr_sel}} :  {{(32-4){1'b0}},{SA0_CB_sig0_ovr_val}};
        14'h0601 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_CB_sig1_threshold, SA0_CB_sig1_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA0_CB_sig1_ovr_sel}} :  {{(32-4){1'b0}},{SA0_CB_sig1_ovr_val}};
        14'h0602 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_CB_sig2_threshold, SA0_CB_sig2_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA0_CB_sig2_ovr_sel}} :  {{(32-4){1'b0}},{SA0_CB_sig2_ovr_val}};
        14'h0603 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_CB_sig3_threshold, SA0_CB_sig3_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA0_CB_sig3_ovr_sel}} :  {{(32-4){1'b0}},{SA0_CB_sig3_ovr_val}};
        14'h0604 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_CB_sig0_threshold, SA1_CB_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA1_CB_sig0_ovr_sel}} :  {{(32-4){1'b0}},{SA1_CB_sig0_ovr_val}};
        14'h0605 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_CB_sig1_threshold, SA1_CB_sig1_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA1_CB_sig1_ovr_sel}} :  {{(32-4){1'b0}},{SA1_CB_sig1_ovr_val}};
        14'h0606 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_CB_sig2_threshold, SA1_CB_sig2_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA1_CB_sig2_ovr_sel}} :  {{(32-4){1'b0}},{SA1_CB_sig2_ovr_val}};
        14'h0607 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_CB_sig3_threshold, SA1_CB_sig3_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA1_CB_sig3_ovr_sel}} :  {{(32-4){1'b0}},{SA1_CB_sig3_ovr_val}};
        14'h0700 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_DB_sig0_threshold, SA0_DB_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA0_DB_sig0_ovr_sel}} :  {{(32-4){1'b0}},{SA0_DB_sig0_ovr_val}};
        14'h0701 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_DB_sig1_threshold, SA0_DB_sig1_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA0_DB_sig1_ovr_sel}} :  {{(32-4){1'b0}},{SA0_DB_sig1_ovr_val}};
        14'h0702 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_DB_sig2_threshold, SA0_DB_sig2_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA0_DB_sig2_ovr_sel}} :  {{(32-4){1'b0}},{SA0_DB_sig2_ovr_val}};
        14'h0703 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_DB_sig3_threshold, SA0_DB_sig3_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA0_DB_sig3_ovr_sel}} :  {{(32-4){1'b0}},{SA0_DB_sig3_ovr_val}};
        14'h0704 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_DB_sig0_threshold, SA1_DB_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA1_DB_sig0_ovr_sel}} :  {{(32-4){1'b0}},{SA1_DB_sig0_ovr_val}};
        14'h0705 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_DB_sig1_threshold, SA1_DB_sig1_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA1_DB_sig1_ovr_sel}} :  {{(32-4){1'b0}},{SA1_DB_sig1_ovr_val}};
        14'h0706 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_DB_sig2_threshold, SA1_DB_sig2_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA1_DB_sig2_ovr_sel}} :  {{(32-4){1'b0}},{SA1_DB_sig2_ovr_val}};
        14'h0707 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_DB_sig3_threshold, SA1_DB_sig3_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA1_DB_sig3_ovr_sel}} :  {{(32-4){1'b0}},{SA1_DB_sig3_ovr_val}};
        14'h0800 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_PA_sig0_threshold, SA0_PA_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SA0_PA_sig0_ovr_sel}} :  {{(32-1){1'b0}},{SA0_PA_sig0_ovr_val}};
        14'h0801 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_PA_sig1_threshold, SA0_PA_sig1_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SA0_PA_sig1_ovr_sel}} :  {{(32-1){1'b0}},{SA0_PA_sig1_ovr_val}};
        14'h0802 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_PA_sig0_threshold, SA1_PA_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SA1_PA_sig0_ovr_sel}} :  {{(32-1){1'b0}},{SA1_PA_sig0_ovr_val}};
        14'h0803 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_PA_sig1_threshold, SA1_PA_sig1_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SA1_PA_sig1_ovr_sel}} :  {{(32-1){1'b0}},{SA1_PA_sig1_ovr_val}};
        14'h0900 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_RMI_sig0_threshold, SA0_RMI_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-2){1'b0}},{SA0_RMI_sig0_ovr_sel}} :  {{(32-2){1'b0}},{SA0_RMI_sig0_ovr_val}};
        14'h0901 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_RMI_sig0_threshold, SA1_RMI_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-2){1'b0}},{SA1_RMI_sig0_ovr_sel}} :  {{(32-2){1'b0}},{SA1_RMI_sig0_ovr_val}};
        14'h0A00 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_SC_sig0_threshold, SA0_SC_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SA0_SC_sig0_ovr_sel}} :  {{(32-1){1'b0}},{SA0_SC_sig0_ovr_val}};
        14'h0A01 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_SC_sig0_threshold, SA1_SC_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SA1_SC_sig0_ovr_sel}} :  {{(32-1){1'b0}},{SA1_SC_sig0_ovr_val}};
        14'h0B00 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_SX_sig0_threshold, SA0_SX_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SA0_SX_sig0_ovr_sel}} :  {{(32-1){1'b0}},{SA0_SX_sig0_ovr_val}};
        14'h0B01 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_SX_sig0_threshold, SA1_SX_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SA1_SX_sig0_ovr_sel}} :  {{(32-1){1'b0}},{SA1_SX_sig0_ovr_val}};
        14'h0C00 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_SXRB_sig0_threshold, SA0_SXRB_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA0_SXRB_sig0_ovr_sel}} :  {{(32-4){1'b0}},{SA0_SXRB_sig0_ovr_val}};
        14'h0C01 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_SXRB_sig0_threshold, SA1_SXRB_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-4){1'b0}},{SA1_SXRB_sig0_ovr_sel}} :  {{(32-4){1'b0}},{SA1_SXRB_sig0_ovr_val}};
        14'h0D00 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_UTCL1_sig0_threshold, SA0_UTCL1_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SA0_UTCL1_sig0_ovr_sel}} :  {{(32-1){1'b0}},{SA0_UTCL1_sig0_ovr_val}};
        14'h0D01 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_UTCL1_sig0_threshold, SA1_UTCL1_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SA1_UTCL1_sig0_ovr_sel}} :  {{(32-1){1'b0}},{SA1_UTCL1_sig0_ovr_val}};
        14'h0E00 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA0_CU_sig0_threshold, SA0_CU_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA0_CU_sig0_ovr_sel}} :  {{(32-10){1'b0}},{SA0_CU_sig0_ovr_val}};
        14'h0E01 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} : 
                                     rd_cac_cntl ? {15'b0, SA1_CU_sig0_threshold, SA1_CU_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-10){1'b0}},{SA1_CU_sig0_ovr_sel}} :  {{(32-10){1'b0}},{SA1_CU_sig0_ovr_val}};
        14'h0F00 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} :
                                     rd_cac_cntl ? {15'b0, SPI_sig0_threshold, SPI_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SPI_sig0_ovr_sel}} :  {{(32-1){1'b0}},{SPI_sig0_ovr_val}};
        14'h0F01 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} :
                                     rd_cac_cntl ? {15'b0, SPI_sig1_threshold, SPI_sig1_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SPI_sig1_ovr_sel}} :  {{(32-1){1'b0}},{SPI_sig1_ovr_val}};
        14'h0F02 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} :
                                     rd_cac_cntl ? {15'b0, SPI_sig2_threshold, SPI_sig2_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SPI_sig2_ovr_sel}} :  {{(32-1){1'b0}},{SPI_sig2_ovr_val}};
        14'h0F03 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} :
                                     rd_cac_cntl ? {15'b0, SPI_sig3_threshold, SPI_sig3_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SPI_sig3_ovr_sel}} :  {{(32-1){1'b0}},{SPI_sig3_ovr_val}};
        14'h0F04 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} :
                                     rd_cac_cntl ? {15'b0, SPI_sig4_threshold, SPI_sig4_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SPI_sig4_ovr_sel}} :  {{(32-1){1'b0}},{SPI_sig4_ovr_val}};
        14'h0F05 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} :
                                     rd_cac_cntl ? {15'b0, SPI_sig5_threshold, SPI_sig5_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{SPI_sig5_ovr_sel}} :  {{(32-1){1'b0}},{SPI_sig5_ovr_val}};
        14'h1000 : reg_read_data_d = rd_cac_id ? {18'b0, signal_id, block_id} :
                                     rd_cac_cntl ? {15'b0, PC_sig0_threshold, PC_sig0_force_disable} :
                                     rd_ovr_sel  ?{{(32-1){1'b0}},{PC_sig0_ovr_sel}} :  {{(32-1){1'b0}},{PC_sig0_ovr_val}};
                  default :  reg_read_data_d = 32'b0;
      endcase // case ( {block_id, signal_id} )
  end // if (rd_cac_id || rd_cac_cntl || rd_ovr_sel || rd_ovr_val)
  else if (rd_ind_data) begin
    reg_read_data_d = 32'b0;
  end // if (rd_ind_data)
end // always @(*)

// Index register updates
always @(posedge reg_clk)
begin
    if (~resetb)
      cac_ind_index <= 32'h0;
    else begin
      if (wr_ind_index)
        cac_ind_index <= reg_wd;
	end

end

always @(posedge reg_clk)
begin
    if (~resetb) begin
      block_id  <= `SE_CAC_ID_CAC_BLOCK_ID_DEFAULT;
      signal_id <= `SE_CAC_ID_CAC_SIGNAL_ID_DEFAULT;
    end
    else begin
      block_id  <= block_id_d;
      signal_id <= signal_id_d;
    end

end

always @(posedge reg_clk)
begin
    if (~resetb) begin
      reg_read_valid <= 1'b0;
      reg_read_data  <= 32'h0;
    end
    else begin
	  reg_read_valid <= rd_se_cac_cgtt_clk_ctrl | rd_cac_id | rd_cac_cntl | rd_ovr_sel | rd_ovr_val | rd_ind_index | rd_ind_data;
      reg_read_data  <= reg_read_data_d;
    end
end

always @(posedge reg_clk)
begin
    if (~resetb) begin
      SA0_TA_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_TA_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_TA_sig0_ovr_sel   <= 'd0;
      SA0_TA_sig0_ovr_val   <= 'd0;
      SA1_TA_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_TA_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_TA_sig0_ovr_sel   <= 'd0;
      SA1_TA_sig0_ovr_val   <= 'd0;

      SA0_TD_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_TD_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_TD_sig0_ovr_sel   <= 'd0;
      SA0_TD_sig0_ovr_val   <= 'd0;
      SA1_TD_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_TD_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_TD_sig0_ovr_sel   <= 'd0;
      SA1_TD_sig0_ovr_val   <= 'd0;
      SA0_TD_sig1_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_TD_sig1_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_TD_sig1_ovr_sel   <= 'd0;
      SA0_TD_sig1_ovr_val   <= 'd0;
      SA1_TD_sig1_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_TD_sig1_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_TD_sig1_ovr_sel   <= 'd0;
      SA1_TD_sig1_ovr_val   <= 'd0;
      SA0_TD_sig2_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_TD_sig2_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_TD_sig2_ovr_sel   <= 'd0;
      SA0_TD_sig2_ovr_val   <= 'd0;
      SA1_TD_sig2_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_TD_sig2_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_TD_sig2_ovr_sel   <= 'd0;
      SA1_TD_sig2_ovr_val   <= 'd0;
      SA0_TD_sig3_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_TD_sig3_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_TD_sig3_ovr_sel   <= 'd0;
      SA0_TD_sig3_ovr_val   <= 'd0;
      SA1_TD_sig3_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_TD_sig3_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_TD_sig3_ovr_sel   <= 'd0;
      SA1_TD_sig3_ovr_val   <= 'd0;
      SA0_TD_sig4_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_TD_sig4_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_TD_sig4_ovr_sel   <= 'd0;
      SA0_TD_sig4_ovr_val   <= 'd0;
      SA1_TD_sig4_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_TD_sig4_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_TD_sig4_ovr_sel   <= 'd0;
      SA1_TD_sig4_ovr_val   <= 'd0;
      SA0_TD_sig5_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_TD_sig5_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_TD_sig5_ovr_sel   <= 'd0;
      SA0_TD_sig5_ovr_val   <= 'd0;
      SA1_TD_sig5_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_TD_sig5_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_TD_sig5_ovr_sel   <= 'd0;
      SA1_TD_sig5_ovr_val   <= 'd0;
      SA0_TD_sig6_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_TD_sig6_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_TD_sig6_ovr_sel   <= 'd0;
      SA0_TD_sig6_ovr_val   <= 'd0;
      SA1_TD_sig6_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_TD_sig6_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_TD_sig6_ovr_sel   <= 'd0;
      SA1_TD_sig6_ovr_val   <= 'd0;
      SA0_TD_sig7_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_TD_sig7_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_TD_sig7_ovr_sel   <= 'd0;
      SA0_TD_sig7_ovr_val   <= 'd0;
      SA1_TD_sig7_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_TD_sig7_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_TD_sig7_ovr_sel   <= 'd0;
      SA1_TD_sig7_ovr_val   <= 'd0;
      SA0_TD_sig8_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_TD_sig8_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_TD_sig8_ovr_sel   <= 'd0;
      SA0_TD_sig8_ovr_val   <= 'd0;
      SA1_TD_sig8_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_TD_sig8_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_TD_sig8_ovr_sel   <= 'd0;
      SA1_TD_sig8_ovr_val   <= 'd0;
      SA0_TD_sig9_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_TD_sig9_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_TD_sig9_ovr_sel   <= 'd0;
      SA0_TD_sig9_ovr_val   <= 'd0;
      SA1_TD_sig9_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_TD_sig9_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_TD_sig9_ovr_sel   <= 'd0;
      SA1_TD_sig9_ovr_val   <= 'd0;

      SA0_TCP_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_TCP_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_TCP_sig0_ovr_sel   <= 'd0;
      SA0_TCP_sig0_ovr_val   <= 'd0;
      SA1_TCP_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_TCP_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_TCP_sig0_ovr_sel   <= 'd0;
      SA1_TCP_sig0_ovr_val   <= 'd0;
      SA0_TCP_sig1_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_TCP_sig1_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_TCP_sig1_ovr_sel   <= 'd0;
      SA0_TCP_sig1_ovr_val   <= 'd0;
      SA1_TCP_sig1_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_TCP_sig1_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_TCP_sig1_ovr_sel   <= 'd0;
      SA1_TCP_sig1_ovr_val   <= 'd0;
      SA0_TCP_sig2_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_TCP_sig2_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_TCP_sig2_ovr_sel   <= 'd0;
      SA0_TCP_sig2_ovr_val   <= 'd0;
      SA1_TCP_sig2_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_TCP_sig2_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_TCP_sig2_ovr_sel   <= 'd0;
      SA1_TCP_sig2_ovr_val   <= 'd0;
      SA0_TCP_sig3_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_TCP_sig3_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_TCP_sig3_ovr_sel   <= 'd0;
      SA0_TCP_sig3_ovr_val   <= 'd0;
      SA1_TCP_sig3_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_TCP_sig3_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_TCP_sig3_ovr_sel   <= 'd0;
      SA1_TCP_sig3_ovr_val   <= 'd0;
      SA0_TCP_sig4_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_TCP_sig4_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_TCP_sig4_ovr_sel   <= 'd0;
      SA0_TCP_sig4_ovr_val   <= 'd0;
      SA1_TCP_sig4_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_TCP_sig4_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_TCP_sig4_ovr_sel   <= 'd0;
      SA1_TCP_sig4_ovr_val   <= 'd0;

      SA0_SQ_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_SQ_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd5;
      SA0_SQ_sig0_ovr_sel   <= 'd0;
      SA0_SQ_sig0_ovr_val   <= 'd0;
      SA1_SQ_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_SQ_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd5;
      SA1_SQ_sig0_ovr_sel   <= 'd0;
      SA1_SQ_sig0_ovr_val   <= 'd0;
      SA0_SQ_sig1_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_SQ_sig1_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd5;
      SA0_SQ_sig1_ovr_sel   <= 'd0;
      SA0_SQ_sig1_ovr_val   <= 'd0;
      SA1_SQ_sig1_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_SQ_sig1_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd5;
      SA1_SQ_sig1_ovr_sel   <= 'd0;
      SA1_SQ_sig1_ovr_val   <= 'd0;
      SA0_SQ_sig2_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_SQ_sig2_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd5;
      SA0_SQ_sig2_ovr_sel   <= 'd0;
      SA0_SQ_sig2_ovr_val   <= 'd0;
      SA1_SQ_sig2_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_SQ_sig2_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd5;
      SA1_SQ_sig2_ovr_sel   <= 'd0;
      SA1_SQ_sig2_ovr_val   <= 'd0;
      SA0_SQ_sig3_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_SQ_sig3_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd5;
      SA0_SQ_sig3_ovr_sel   <= 'd0;
      SA0_SQ_sig3_ovr_val   <= 'd0;
      SA1_SQ_sig3_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_SQ_sig3_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd5;
      SA1_SQ_sig3_ovr_sel   <= 'd0;
      SA1_SQ_sig3_ovr_val   <= 'd0;
      SA0_SQ_sig4_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_SQ_sig4_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd5;
      SA0_SQ_sig4_ovr_sel   <= 'd0;
      SA0_SQ_sig4_ovr_val   <= 'd0;
      SA1_SQ_sig4_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_SQ_sig4_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd5;
      SA1_SQ_sig4_ovr_sel   <= 'd0;
      SA1_SQ_sig4_ovr_val   <= 'd0;
      SA0_SQ_sig5_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_SQ_sig5_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd5;
      SA0_SQ_sig5_ovr_sel   <= 'd0;
      SA0_SQ_sig5_ovr_val   <= 'd0;
      SA1_SQ_sig5_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_SQ_sig5_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd5;
      SA1_SQ_sig5_ovr_sel   <= 'd0;
      SA1_SQ_sig5_ovr_val   <= 'd0;

      SA0_LDS_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_LDS_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_LDS_sig0_ovr_sel   <= 'd0;
      SA0_LDS_sig0_ovr_val   <= 'd0;
      SA1_LDS_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_LDS_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_LDS_sig0_ovr_sel   <= 'd0;
      SA1_LDS_sig0_ovr_val   <= 'd0;
      SA0_LDS_sig1_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_LDS_sig1_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_LDS_sig1_ovr_sel   <= 'd0;
      SA0_LDS_sig1_ovr_val   <= 'd0;
      SA1_LDS_sig1_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_LDS_sig1_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_LDS_sig1_ovr_sel   <= 'd0;
      SA1_LDS_sig1_ovr_val   <= 'd0;
      SA0_LDS_sig2_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_LDS_sig2_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_LDS_sig2_ovr_sel   <= 'd0;
      SA0_LDS_sig2_ovr_val   <= 'd0;
      SA1_LDS_sig2_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_LDS_sig2_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_LDS_sig2_ovr_sel   <= 'd0;
      SA1_LDS_sig2_ovr_val   <= 'd0;
      SA0_LDS_sig3_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_LDS_sig3_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_LDS_sig3_ovr_sel   <= 'd0;
      SA0_LDS_sig3_ovr_val   <= 'd0;
      SA1_LDS_sig3_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_LDS_sig3_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_LDS_sig3_ovr_sel   <= 'd0;
      SA1_LDS_sig3_ovr_val   <= 'd0;

      SA0_BCI_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_BCI_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SA0_BCI_sig0_ovr_sel   <= 'd0;
      SA0_BCI_sig0_ovr_val   <= 'd0;
      SA1_BCI_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_BCI_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SA1_BCI_sig0_ovr_sel   <= 'd0;
      SA1_BCI_sig0_ovr_val   <= 'd0;
      SA0_BCI_sig1_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_BCI_sig1_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SA0_BCI_sig1_ovr_sel   <= 'd0;
      SA0_BCI_sig1_ovr_val   <= 'd0;
      SA1_BCI_sig1_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_BCI_sig1_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SA1_BCI_sig1_ovr_sel   <= 'd0;
      SA1_BCI_sig1_ovr_val   <= 'd0;

      SA0_CB_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_CB_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA0_CB_sig0_ovr_sel   <= 'd0;
      SA0_CB_sig0_ovr_val   <= 'd0;
      SA1_CB_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_CB_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA1_CB_sig0_ovr_sel   <= 'd0;
      SA1_CB_sig0_ovr_val   <= 'd0;
      SA0_CB_sig1_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_CB_sig1_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA0_CB_sig1_ovr_sel   <= 'd0;
      SA0_CB_sig1_ovr_val   <= 'd0;
      SA1_CB_sig1_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_CB_sig1_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA1_CB_sig1_ovr_sel   <= 'd0;
      SA1_CB_sig1_ovr_val   <= 'd0;
      SA0_CB_sig2_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_CB_sig2_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA0_CB_sig2_ovr_sel   <= 'd0;
      SA0_CB_sig2_ovr_val   <= 'd0;
      SA1_CB_sig2_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_CB_sig2_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA1_CB_sig2_ovr_sel   <= 'd0;
      SA1_CB_sig2_ovr_val   <= 'd0;
      SA0_CB_sig3_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_CB_sig3_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA0_CB_sig3_ovr_sel   <= 'd0;
      SA0_CB_sig3_ovr_val   <= 'd0;
      SA1_CB_sig3_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_CB_sig3_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA1_CB_sig3_ovr_sel   <= 'd0;
      SA1_CB_sig3_ovr_val   <= 'd0;

      SA0_DB_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_DB_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA0_DB_sig0_ovr_sel   <= 'd0;
      SA0_DB_sig0_ovr_val   <= 'd0;
      SA1_DB_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_DB_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA1_DB_sig0_ovr_sel   <= 'd0;
      SA1_DB_sig0_ovr_val   <= 'd0;
      SA0_DB_sig1_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_DB_sig1_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA0_DB_sig1_ovr_sel   <= 'd0;
      SA0_DB_sig1_ovr_val   <= 'd0;
      SA1_DB_sig1_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_DB_sig1_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA1_DB_sig1_ovr_sel   <= 'd0;
      SA1_DB_sig1_ovr_val   <= 'd0;
      SA0_DB_sig2_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_DB_sig2_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA0_DB_sig2_ovr_sel   <= 'd0;
      SA0_DB_sig2_ovr_val   <= 'd0;
      SA1_DB_sig2_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_DB_sig2_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA1_DB_sig2_ovr_sel   <= 'd0;
      SA1_DB_sig2_ovr_val   <= 'd0;
      SA0_DB_sig3_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_DB_sig3_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA0_DB_sig3_ovr_sel   <= 'd0;
      SA0_DB_sig3_ovr_val   <= 'd0;
      SA1_DB_sig3_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_DB_sig3_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA1_DB_sig3_ovr_sel   <= 'd0;
      SA1_DB_sig3_ovr_val   <= 'd0;

      SA0_PA_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_PA_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SA0_PA_sig0_ovr_sel   <= 'd0;
      SA0_PA_sig0_ovr_val   <= 'd0;
      SA1_PA_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_PA_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SA1_PA_sig0_ovr_sel   <= 'd0;
      SA1_PA_sig0_ovr_val   <= 'd0;
      SA0_PA_sig1_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_PA_sig1_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SA0_PA_sig1_ovr_sel   <= 'd0;
      SA0_PA_sig1_ovr_val   <= 'd0;
      SA1_PA_sig1_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_PA_sig1_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SA1_PA_sig1_ovr_sel   <= 'd0;
      SA1_PA_sig1_ovr_val   <= 'd0;

      SA0_RMI_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_RMI_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd2;
      SA0_RMI_sig0_ovr_sel   <= 'd0;
      SA0_RMI_sig0_ovr_val   <= 'd0;
      SA1_RMI_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_RMI_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd2;
      SA1_RMI_sig0_ovr_sel   <= 'd0;
      SA1_RMI_sig0_ovr_val   <= 'd0;

      SA0_SC_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_SC_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SA0_SC_sig0_ovr_sel   <= 'd0;
      SA0_SC_sig0_ovr_val   <= 'd0;
      SA1_SC_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_SC_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SA1_SC_sig0_ovr_sel   <= 'd0;
      SA1_SC_sig0_ovr_val   <= 'd0;

      SA0_SX_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_SX_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SA0_SX_sig0_ovr_sel   <= 'd0;
      SA0_SX_sig0_ovr_val   <= 'd0;
      SA1_SX_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_SX_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SA1_SX_sig0_ovr_sel   <= 'd0;
      SA1_SX_sig0_ovr_val   <= 'd0;

      SA0_SXRB_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_SXRB_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA0_SXRB_sig0_ovr_sel   <= 'd0;
      SA0_SXRB_sig0_ovr_val   <= 'd0;
      SA1_SXRB_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_SXRB_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd4;
      SA1_SXRB_sig0_ovr_sel   <= 'd0;
      SA1_SXRB_sig0_ovr_val   <= 'd0;

      SA0_UTCL1_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_UTCL1_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SA0_UTCL1_sig0_ovr_sel   <= 'd0;
      SA0_UTCL1_sig0_ovr_val   <= 'd0;
      SA1_UTCL1_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_UTCL1_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SA1_UTCL1_sig0_ovr_sel   <= 'd0;
      SA1_UTCL1_sig0_ovr_val   <= 'd0;

      SA0_CU_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA0_CU_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA0_CU_sig0_ovr_sel   <= 'd0;
      SA0_CU_sig0_ovr_val   <= 'd0;
      SA1_CU_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SA1_CU_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd10;
      SA1_CU_sig0_ovr_sel   <= 'd0;
      SA1_CU_sig0_ovr_val   <= 'd0;

      SPI_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SPI_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SPI_sig0_ovr_sel   <= 'd0;
      SPI_sig0_ovr_val   <= 'd0;
      SPI_sig1_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SPI_sig1_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SPI_sig1_ovr_sel   <= 'd0;
      SPI_sig1_ovr_val   <= 'd0;
      SPI_sig2_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SPI_sig2_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SPI_sig2_ovr_sel   <= 'd0;
      SPI_sig2_ovr_val   <= 'd0;
      SPI_sig3_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SPI_sig3_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SPI_sig3_ovr_sel   <= 'd0;
      SPI_sig3_ovr_val   <= 'd0;
      SPI_sig4_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SPI_sig4_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SPI_sig4_ovr_sel   <= 'd0;
      SPI_sig4_ovr_val   <= 'd0;
      SPI_sig5_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      SPI_sig5_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      SPI_sig5_ovr_sel   <= 'd0;
      SPI_sig5_ovr_val   <= 'd0;

      PC_sig0_force_disable    <= `SE_CAC_CNTL_CAC_FORCE_DISABLE_DEFAULT;
      PC_sig0_threshold <= `SE_CAC_CNTL_CAC_THRESHOLD_SIZE'd1;
      PC_sig0_ovr_sel   <= 'd0;
      PC_sig0_ovr_val   <= 'd0;

    end // if (~resetb)
    else begin
	if(wr_ind_data) begin
     SA0_TA_sig0_force_disable    <= SA0_TA_sig0_force_disable_d;
     SA0_TA_sig0_threshold <= SA0_TA_sig0_threshold_d;
     SA0_TA_sig0_ovr_sel   <= SA0_TA_sig0_ovr_sel_d;
     SA0_TA_sig0_ovr_val   <= SA0_TA_sig0_ovr_val_d;
     SA1_TA_sig0_force_disable    <= SA1_TA_sig0_force_disable_d;
     SA1_TA_sig0_threshold <= SA1_TA_sig0_threshold_d;
     SA1_TA_sig0_ovr_sel   <= SA1_TA_sig0_ovr_sel_d;
     SA1_TA_sig0_ovr_val   <= SA1_TA_sig0_ovr_val_d;

     SA0_TD_sig0_force_disable    <= SA0_TD_sig0_force_disable_d;
     SA0_TD_sig0_threshold <= SA0_TD_sig0_threshold_d;
     SA0_TD_sig0_ovr_sel   <= SA0_TD_sig0_ovr_sel_d;
     SA0_TD_sig0_ovr_val   <= SA0_TD_sig0_ovr_val_d;
     SA1_TD_sig0_force_disable    <= SA1_TD_sig0_force_disable_d;
     SA1_TD_sig0_threshold <= SA1_TD_sig0_threshold_d;
     SA1_TD_sig0_ovr_sel   <= SA1_TD_sig0_ovr_sel_d;
     SA1_TD_sig0_ovr_val   <= SA1_TD_sig0_ovr_val_d;
     SA0_TD_sig1_force_disable    <= SA0_TD_sig1_force_disable_d;
     SA0_TD_sig1_threshold <= SA0_TD_sig1_threshold_d;
     SA0_TD_sig1_ovr_sel   <= SA0_TD_sig1_ovr_sel_d;
     SA0_TD_sig1_ovr_val   <= SA0_TD_sig1_ovr_val_d;
     SA1_TD_sig1_force_disable    <= SA1_TD_sig1_force_disable_d;
     SA1_TD_sig1_threshold <= SA1_TD_sig1_threshold_d;
     SA1_TD_sig1_ovr_sel   <= SA1_TD_sig1_ovr_sel_d;
     SA1_TD_sig1_ovr_val   <= SA1_TD_sig1_ovr_val_d;
     SA0_TD_sig2_force_disable    <= SA0_TD_sig2_force_disable_d;
     SA0_TD_sig2_threshold <= SA0_TD_sig2_threshold_d;
     SA0_TD_sig2_ovr_sel   <= SA0_TD_sig2_ovr_sel_d;
     SA0_TD_sig2_ovr_val   <= SA0_TD_sig2_ovr_val_d;
     SA1_TD_sig2_force_disable    <= SA1_TD_sig2_force_disable_d;
     SA1_TD_sig2_threshold <= SA1_TD_sig2_threshold_d;
     SA1_TD_sig2_ovr_sel   <= SA1_TD_sig2_ovr_sel_d;
     SA1_TD_sig2_ovr_val   <= SA1_TD_sig2_ovr_val_d;
     SA0_TD_sig3_force_disable    <= SA0_TD_sig3_force_disable_d;
     SA0_TD_sig3_threshold <= SA0_TD_sig3_threshold_d;
     SA0_TD_sig3_ovr_sel   <= SA0_TD_sig3_ovr_sel_d;
     SA0_TD_sig3_ovr_val   <= SA0_TD_sig3_ovr_val_d;
     SA1_TD_sig3_force_disable    <= SA1_TD_sig3_force_disable_d;
     SA1_TD_sig3_threshold <= SA1_TD_sig3_threshold_d;
     SA1_TD_sig3_ovr_sel   <= SA1_TD_sig3_ovr_sel_d;
     SA1_TD_sig3_ovr_val   <= SA1_TD_sig3_ovr_val_d;
     SA0_TD_sig4_force_disable    <= SA0_TD_sig4_force_disable_d;
     SA0_TD_sig4_threshold <= SA0_TD_sig4_threshold_d;
     SA0_TD_sig4_ovr_sel   <= SA0_TD_sig4_ovr_sel_d;
     SA0_TD_sig4_ovr_val   <= SA0_TD_sig4_ovr_val_d;
     SA1_TD_sig4_force_disable    <= SA1_TD_sig4_force_disable_d;
     SA1_TD_sig4_threshold <= SA1_TD_sig4_threshold_d;
     SA1_TD_sig4_ovr_sel   <= SA1_TD_sig4_ovr_sel_d;
     SA1_TD_sig4_ovr_val   <= SA1_TD_sig4_ovr_val_d;
     SA0_TD_sig5_force_disable    <= SA0_TD_sig5_force_disable_d;
     SA0_TD_sig5_threshold <= SA0_TD_sig5_threshold_d;
     SA0_TD_sig5_ovr_sel   <= SA0_TD_sig5_ovr_sel_d;
     SA0_TD_sig5_ovr_val   <= SA0_TD_sig5_ovr_val_d;
     SA1_TD_sig5_force_disable    <= SA1_TD_sig5_force_disable_d;
     SA1_TD_sig5_threshold <= SA1_TD_sig5_threshold_d;
     SA1_TD_sig5_ovr_sel   <= SA1_TD_sig5_ovr_sel_d;
     SA1_TD_sig5_ovr_val   <= SA1_TD_sig5_ovr_val_d;
     SA0_TD_sig6_force_disable    <= SA0_TD_sig6_force_disable_d;
     SA0_TD_sig6_threshold <= SA0_TD_sig6_threshold_d;
     SA0_TD_sig6_ovr_sel   <= SA0_TD_sig6_ovr_sel_d;
     SA0_TD_sig6_ovr_val   <= SA0_TD_sig6_ovr_val_d;
     SA1_TD_sig6_force_disable    <= SA1_TD_sig6_force_disable_d;
     SA1_TD_sig6_threshold <= SA1_TD_sig6_threshold_d;
     SA1_TD_sig6_ovr_sel   <= SA1_TD_sig6_ovr_sel_d;
     SA1_TD_sig6_ovr_val   <= SA1_TD_sig6_ovr_val_d;
     SA0_TD_sig7_force_disable    <= SA0_TD_sig7_force_disable_d;
     SA0_TD_sig7_threshold <= SA0_TD_sig7_threshold_d;
     SA0_TD_sig7_ovr_sel   <= SA0_TD_sig7_ovr_sel_d;
     SA0_TD_sig7_ovr_val   <= SA0_TD_sig7_ovr_val_d;
     SA1_TD_sig7_force_disable    <= SA1_TD_sig7_force_disable_d;
     SA1_TD_sig7_threshold <= SA1_TD_sig7_threshold_d;
     SA1_TD_sig7_ovr_sel   <= SA1_TD_sig7_ovr_sel_d;
     SA1_TD_sig7_ovr_val   <= SA1_TD_sig7_ovr_val_d;
     SA0_TD_sig8_force_disable    <= SA0_TD_sig8_force_disable_d;
     SA0_TD_sig8_threshold <= SA0_TD_sig8_threshold_d;
     SA0_TD_sig8_ovr_sel   <= SA0_TD_sig8_ovr_sel_d;
     SA0_TD_sig8_ovr_val   <= SA0_TD_sig8_ovr_val_d;
     SA1_TD_sig8_force_disable    <= SA1_TD_sig8_force_disable_d;
     SA1_TD_sig8_threshold <= SA1_TD_sig8_threshold_d;
     SA1_TD_sig8_ovr_sel   <= SA1_TD_sig8_ovr_sel_d;
     SA1_TD_sig8_ovr_val   <= SA1_TD_sig8_ovr_val_d;
     SA0_TD_sig9_force_disable    <= SA0_TD_sig9_force_disable_d;
     SA0_TD_sig9_threshold <= SA0_TD_sig9_threshold_d;
     SA0_TD_sig9_ovr_sel   <= SA0_TD_sig9_ovr_sel_d;
     SA0_TD_sig9_ovr_val   <= SA0_TD_sig9_ovr_val_d;
     SA1_TD_sig9_force_disable    <= SA1_TD_sig9_force_disable_d;
     SA1_TD_sig9_threshold <= SA1_TD_sig9_threshold_d;
     SA1_TD_sig9_ovr_sel   <= SA1_TD_sig9_ovr_sel_d;
     SA1_TD_sig9_ovr_val   <= SA1_TD_sig9_ovr_val_d;

     SA0_TCP_sig0_force_disable    <= SA0_TCP_sig0_force_disable_d;
     SA0_TCP_sig0_threshold <= SA0_TCP_sig0_threshold_d;
     SA0_TCP_sig0_ovr_sel   <= SA0_TCP_sig0_ovr_sel_d;
     SA0_TCP_sig0_ovr_val   <= SA0_TCP_sig0_ovr_val_d;
     SA1_TCP_sig0_force_disable    <= SA1_TCP_sig0_force_disable_d;
     SA1_TCP_sig0_threshold <= SA1_TCP_sig0_threshold_d;
     SA1_TCP_sig0_ovr_sel   <= SA1_TCP_sig0_ovr_sel_d;
     SA1_TCP_sig0_ovr_val   <= SA1_TCP_sig0_ovr_val_d;
     SA0_TCP_sig1_force_disable    <= SA0_TCP_sig1_force_disable_d;
     SA0_TCP_sig1_threshold <= SA0_TCP_sig1_threshold_d;
     SA0_TCP_sig1_ovr_sel   <= SA0_TCP_sig1_ovr_sel_d;
     SA0_TCP_sig1_ovr_val   <= SA0_TCP_sig1_ovr_val_d;
     SA1_TCP_sig1_force_disable    <= SA1_TCP_sig1_force_disable_d;
     SA1_TCP_sig1_threshold <= SA1_TCP_sig1_threshold_d;
     SA1_TCP_sig1_ovr_sel   <= SA1_TCP_sig1_ovr_sel_d;
     SA1_TCP_sig1_ovr_val   <= SA1_TCP_sig1_ovr_val_d;
     SA0_TCP_sig2_force_disable    <= SA0_TCP_sig2_force_disable_d;
     SA0_TCP_sig2_threshold <= SA0_TCP_sig2_threshold_d;
     SA0_TCP_sig2_ovr_sel   <= SA0_TCP_sig2_ovr_sel_d;
     SA0_TCP_sig2_ovr_val   <= SA0_TCP_sig2_ovr_val_d;
     SA1_TCP_sig2_force_disable    <= SA1_TCP_sig2_force_disable_d;
     SA1_TCP_sig2_threshold <= SA1_TCP_sig2_threshold_d;
     SA1_TCP_sig2_ovr_sel   <= SA1_TCP_sig2_ovr_sel_d;
     SA1_TCP_sig2_ovr_val   <= SA1_TCP_sig2_ovr_val_d;
     SA0_TCP_sig3_force_disable    <= SA0_TCP_sig3_force_disable_d;
     SA0_TCP_sig3_threshold <= SA0_TCP_sig3_threshold_d;
     SA0_TCP_sig3_ovr_sel   <= SA0_TCP_sig3_ovr_sel_d;
     SA0_TCP_sig3_ovr_val   <= SA0_TCP_sig3_ovr_val_d;
     SA1_TCP_sig3_force_disable    <= SA1_TCP_sig3_force_disable_d;
     SA1_TCP_sig3_threshold <= SA1_TCP_sig3_threshold_d;
     SA1_TCP_sig3_ovr_sel   <= SA1_TCP_sig3_ovr_sel_d;
     SA1_TCP_sig3_ovr_val   <= SA1_TCP_sig3_ovr_val_d;
     SA0_TCP_sig4_force_disable    <= SA0_TCP_sig4_force_disable_d;
     SA0_TCP_sig4_threshold <= SA0_TCP_sig4_threshold_d;
     SA0_TCP_sig4_ovr_sel   <= SA0_TCP_sig4_ovr_sel_d;
     SA0_TCP_sig4_ovr_val   <= SA0_TCP_sig4_ovr_val_d;
     SA1_TCP_sig4_force_disable    <= SA1_TCP_sig4_force_disable_d;
     SA1_TCP_sig4_threshold <= SA1_TCP_sig4_threshold_d;
     SA1_TCP_sig4_ovr_sel   <= SA1_TCP_sig4_ovr_sel_d;
     SA1_TCP_sig4_ovr_val   <= SA1_TCP_sig4_ovr_val_d;

     SA0_SQ_sig0_force_disable    <= SA0_SQ_sig0_force_disable_d;
     SA0_SQ_sig0_threshold <= SA0_SQ_sig0_threshold_d;
     SA0_SQ_sig0_ovr_sel   <= SA0_SQ_sig0_ovr_sel_d;
     SA0_SQ_sig0_ovr_val   <= SA0_SQ_sig0_ovr_val_d;
     SA1_SQ_sig0_force_disable    <= SA1_SQ_sig0_force_disable_d;
     SA1_SQ_sig0_threshold <= SA1_SQ_sig0_threshold_d;
     SA1_SQ_sig0_ovr_sel   <= SA1_SQ_sig0_ovr_sel_d;
     SA1_SQ_sig0_ovr_val   <= SA1_SQ_sig0_ovr_val_d;
     SA0_SQ_sig1_force_disable    <= SA0_SQ_sig1_force_disable_d;
     SA0_SQ_sig1_threshold <= SA0_SQ_sig1_threshold_d;
     SA0_SQ_sig1_ovr_sel   <= SA0_SQ_sig1_ovr_sel_d;
     SA0_SQ_sig1_ovr_val   <= SA0_SQ_sig1_ovr_val_d;
     SA1_SQ_sig1_force_disable    <= SA1_SQ_sig1_force_disable_d;
     SA1_SQ_sig1_threshold <= SA1_SQ_sig1_threshold_d;
     SA1_SQ_sig1_ovr_sel   <= SA1_SQ_sig1_ovr_sel_d;
     SA1_SQ_sig1_ovr_val   <= SA1_SQ_sig1_ovr_val_d;
     SA0_SQ_sig2_force_disable    <= SA0_SQ_sig2_force_disable_d;
     SA0_SQ_sig2_threshold <= SA0_SQ_sig2_threshold_d;
     SA0_SQ_sig2_ovr_sel   <= SA0_SQ_sig2_ovr_sel_d;
     SA0_SQ_sig2_ovr_val   <= SA0_SQ_sig2_ovr_val_d;
     SA1_SQ_sig2_force_disable    <= SA1_SQ_sig2_force_disable_d;
     SA1_SQ_sig2_threshold <= SA1_SQ_sig2_threshold_d;
     SA1_SQ_sig2_ovr_sel   <= SA1_SQ_sig2_ovr_sel_d;
     SA1_SQ_sig2_ovr_val   <= SA1_SQ_sig2_ovr_val_d;
     SA0_SQ_sig3_force_disable    <= SA0_SQ_sig3_force_disable_d;
     SA0_SQ_sig3_threshold <= SA0_SQ_sig3_threshold_d;
     SA0_SQ_sig3_ovr_sel   <= SA0_SQ_sig3_ovr_sel_d;
     SA0_SQ_sig3_ovr_val   <= SA0_SQ_sig3_ovr_val_d;
     SA1_SQ_sig3_force_disable    <= SA1_SQ_sig3_force_disable_d;
     SA1_SQ_sig3_threshold <= SA1_SQ_sig3_threshold_d;
     SA1_SQ_sig3_ovr_sel   <= SA1_SQ_sig3_ovr_sel_d;
     SA1_SQ_sig3_ovr_val   <= SA1_SQ_sig3_ovr_val_d;
     SA0_SQ_sig4_force_disable    <= SA0_SQ_sig4_force_disable_d;
     SA0_SQ_sig4_threshold <= SA0_SQ_sig4_threshold_d;
     SA0_SQ_sig4_ovr_sel   <= SA0_SQ_sig4_ovr_sel_d;
     SA0_SQ_sig4_ovr_val   <= SA0_SQ_sig4_ovr_val_d;
     SA1_SQ_sig4_force_disable    <= SA1_SQ_sig4_force_disable_d;
     SA1_SQ_sig4_threshold <= SA1_SQ_sig4_threshold_d;
     SA1_SQ_sig4_ovr_sel   <= SA1_SQ_sig4_ovr_sel_d;
     SA1_SQ_sig4_ovr_val   <= SA1_SQ_sig4_ovr_val_d;
     SA0_SQ_sig5_force_disable    <= SA0_SQ_sig5_force_disable_d;
     SA0_SQ_sig5_threshold <= SA0_SQ_sig5_threshold_d;
     SA0_SQ_sig5_ovr_sel   <= SA0_SQ_sig5_ovr_sel_d;
     SA0_SQ_sig5_ovr_val   <= SA0_SQ_sig5_ovr_val_d;
     SA1_SQ_sig5_force_disable    <= SA1_SQ_sig5_force_disable_d;
     SA1_SQ_sig5_threshold <= SA1_SQ_sig5_threshold_d;
     SA1_SQ_sig5_ovr_sel   <= SA1_SQ_sig5_ovr_sel_d;
     SA1_SQ_sig5_ovr_val   <= SA1_SQ_sig5_ovr_val_d;

     SA0_LDS_sig0_force_disable    <= SA0_LDS_sig0_force_disable_d;
     SA0_LDS_sig0_threshold <= SA0_LDS_sig0_threshold_d;
     SA0_LDS_sig0_ovr_sel   <= SA0_LDS_sig0_ovr_sel_d;
     SA0_LDS_sig0_ovr_val   <= SA0_LDS_sig0_ovr_val_d;
     SA1_LDS_sig0_force_disable    <= SA1_LDS_sig0_force_disable_d;
     SA1_LDS_sig0_threshold <= SA1_LDS_sig0_threshold_d;
     SA1_LDS_sig0_ovr_sel   <= SA1_LDS_sig0_ovr_sel_d;
     SA1_LDS_sig0_ovr_val   <= SA1_LDS_sig0_ovr_val_d;
     SA0_LDS_sig1_force_disable    <= SA0_LDS_sig1_force_disable_d;
     SA0_LDS_sig1_threshold <= SA0_LDS_sig1_threshold_d;
     SA0_LDS_sig1_ovr_sel   <= SA0_LDS_sig1_ovr_sel_d;
     SA0_LDS_sig1_ovr_val   <= SA0_LDS_sig1_ovr_val_d;
     SA1_LDS_sig1_force_disable    <= SA1_LDS_sig1_force_disable_d;
     SA1_LDS_sig1_threshold <= SA1_LDS_sig1_threshold_d;
     SA1_LDS_sig1_ovr_sel   <= SA1_LDS_sig1_ovr_sel_d;
     SA1_LDS_sig1_ovr_val   <= SA1_LDS_sig1_ovr_val_d;
     SA0_LDS_sig2_force_disable    <= SA0_LDS_sig2_force_disable_d;
     SA0_LDS_sig2_threshold <= SA0_LDS_sig2_threshold_d;
     SA0_LDS_sig2_ovr_sel   <= SA0_LDS_sig2_ovr_sel_d;
     SA0_LDS_sig2_ovr_val   <= SA0_LDS_sig2_ovr_val_d;
     SA1_LDS_sig2_force_disable    <= SA1_LDS_sig2_force_disable_d;
     SA1_LDS_sig2_threshold <= SA1_LDS_sig2_threshold_d;
     SA1_LDS_sig2_ovr_sel   <= SA1_LDS_sig2_ovr_sel_d;
     SA1_LDS_sig2_ovr_val   <= SA1_LDS_sig2_ovr_val_d;
     SA0_LDS_sig3_force_disable    <= SA0_LDS_sig3_force_disable_d;
     SA0_LDS_sig3_threshold <= SA0_LDS_sig3_threshold_d;
     SA0_LDS_sig3_ovr_sel   <= SA0_LDS_sig3_ovr_sel_d;
     SA0_LDS_sig3_ovr_val   <= SA0_LDS_sig3_ovr_val_d;
     SA1_LDS_sig3_force_disable    <= SA1_LDS_sig3_force_disable_d;
     SA1_LDS_sig3_threshold <= SA1_LDS_sig3_threshold_d;
     SA1_LDS_sig3_ovr_sel   <= SA1_LDS_sig3_ovr_sel_d;
     SA1_LDS_sig3_ovr_val   <= SA1_LDS_sig3_ovr_val_d;

     SA0_BCI_sig0_force_disable    <= SA0_BCI_sig0_force_disable_d;
     SA0_BCI_sig0_threshold <= SA0_BCI_sig0_threshold_d;
     SA0_BCI_sig0_ovr_sel   <= SA0_BCI_sig0_ovr_sel_d;
     SA0_BCI_sig0_ovr_val   <= SA0_BCI_sig0_ovr_val_d;
     SA1_BCI_sig0_force_disable    <= SA1_BCI_sig0_force_disable_d;
     SA1_BCI_sig0_threshold <= SA1_BCI_sig0_threshold_d;
     SA1_BCI_sig0_ovr_sel   <= SA1_BCI_sig0_ovr_sel_d;
     SA1_BCI_sig0_ovr_val   <= SA1_BCI_sig0_ovr_val_d;
     SA0_BCI_sig1_force_disable    <= SA0_BCI_sig1_force_disable_d;
     SA0_BCI_sig1_threshold <= SA0_BCI_sig1_threshold_d;
     SA0_BCI_sig1_ovr_sel   <= SA0_BCI_sig1_ovr_sel_d;
     SA0_BCI_sig1_ovr_val   <= SA0_BCI_sig1_ovr_val_d;
     SA1_BCI_sig1_force_disable    <= SA1_BCI_sig1_force_disable_d;
     SA1_BCI_sig1_threshold <= SA1_BCI_sig1_threshold_d;
     SA1_BCI_sig1_ovr_sel   <= SA1_BCI_sig1_ovr_sel_d;
     SA1_BCI_sig1_ovr_val   <= SA1_BCI_sig1_ovr_val_d;

     SA0_CB_sig0_force_disable    <= SA0_CB_sig0_force_disable_d;
     SA0_CB_sig0_threshold <= SA0_CB_sig0_threshold_d;
     SA0_CB_sig0_ovr_sel   <= SA0_CB_sig0_ovr_sel_d;
     SA0_CB_sig0_ovr_val   <= SA0_CB_sig0_ovr_val_d;
     SA1_CB_sig0_force_disable    <= SA1_CB_sig0_force_disable_d;
     SA1_CB_sig0_threshold <= SA1_CB_sig0_threshold_d;
     SA1_CB_sig0_ovr_sel   <= SA1_CB_sig0_ovr_sel_d;
     SA1_CB_sig0_ovr_val   <= SA1_CB_sig0_ovr_val_d;
     SA0_CB_sig1_force_disable    <= SA0_CB_sig1_force_disable_d;
     SA0_CB_sig1_threshold <= SA0_CB_sig1_threshold_d;
     SA0_CB_sig1_ovr_sel   <= SA0_CB_sig1_ovr_sel_d;
     SA0_CB_sig1_ovr_val   <= SA0_CB_sig1_ovr_val_d;
     SA1_CB_sig1_force_disable    <= SA1_CB_sig1_force_disable_d;
     SA1_CB_sig1_threshold <= SA1_CB_sig1_threshold_d;
     SA1_CB_sig1_ovr_sel   <= SA1_CB_sig1_ovr_sel_d;
     SA1_CB_sig1_ovr_val   <= SA1_CB_sig1_ovr_val_d;
     SA0_CB_sig2_force_disable    <= SA0_CB_sig2_force_disable_d;
     SA0_CB_sig2_threshold <= SA0_CB_sig2_threshold_d;
     SA0_CB_sig2_ovr_sel   <= SA0_CB_sig2_ovr_sel_d;
     SA0_CB_sig2_ovr_val   <= SA0_CB_sig2_ovr_val_d;
     SA1_CB_sig2_force_disable    <= SA1_CB_sig2_force_disable_d;
     SA1_CB_sig2_threshold <= SA1_CB_sig2_threshold_d;
     SA1_CB_sig2_ovr_sel   <= SA1_CB_sig2_ovr_sel_d;
     SA1_CB_sig2_ovr_val   <= SA1_CB_sig2_ovr_val_d;
     SA0_CB_sig3_force_disable    <= SA0_CB_sig3_force_disable_d;
     SA0_CB_sig3_threshold <= SA0_CB_sig3_threshold_d;
     SA0_CB_sig3_ovr_sel   <= SA0_CB_sig3_ovr_sel_d;
     SA0_CB_sig3_ovr_val   <= SA0_CB_sig3_ovr_val_d;
     SA1_CB_sig3_force_disable    <= SA1_CB_sig3_force_disable_d;
     SA1_CB_sig3_threshold <= SA1_CB_sig3_threshold_d;
     SA1_CB_sig3_ovr_sel   <= SA1_CB_sig3_ovr_sel_d;
     SA1_CB_sig3_ovr_val   <= SA1_CB_sig3_ovr_val_d;

     SA0_DB_sig0_force_disable    <= SA0_DB_sig0_force_disable_d;
     SA0_DB_sig0_threshold <= SA0_DB_sig0_threshold_d;
     SA0_DB_sig0_ovr_sel   <= SA0_DB_sig0_ovr_sel_d;
     SA0_DB_sig0_ovr_val   <= SA0_DB_sig0_ovr_val_d;
     SA1_DB_sig0_force_disable    <= SA1_DB_sig0_force_disable_d;
     SA1_DB_sig0_threshold <= SA1_DB_sig0_threshold_d;
     SA1_DB_sig0_ovr_sel   <= SA1_DB_sig0_ovr_sel_d;
     SA1_DB_sig0_ovr_val   <= SA1_DB_sig0_ovr_val_d;
     SA0_DB_sig1_force_disable    <= SA0_DB_sig1_force_disable_d;
     SA0_DB_sig1_threshold <= SA0_DB_sig1_threshold_d;
     SA0_DB_sig1_ovr_sel   <= SA0_DB_sig1_ovr_sel_d;
     SA0_DB_sig1_ovr_val   <= SA0_DB_sig1_ovr_val_d;
     SA1_DB_sig1_force_disable    <= SA1_DB_sig1_force_disable_d;
     SA1_DB_sig1_threshold <= SA1_DB_sig1_threshold_d;
     SA1_DB_sig1_ovr_sel   <= SA1_DB_sig1_ovr_sel_d;
     SA1_DB_sig1_ovr_val   <= SA1_DB_sig1_ovr_val_d;
     SA0_DB_sig2_force_disable    <= SA0_DB_sig2_force_disable_d;
     SA0_DB_sig2_threshold <= SA0_DB_sig2_threshold_d;
     SA0_DB_sig2_ovr_sel   <= SA0_DB_sig2_ovr_sel_d;
     SA0_DB_sig2_ovr_val   <= SA0_DB_sig2_ovr_val_d;
     SA1_DB_sig2_force_disable    <= SA1_DB_sig2_force_disable_d;
     SA1_DB_sig2_threshold <= SA1_DB_sig2_threshold_d;
     SA1_DB_sig2_ovr_sel   <= SA1_DB_sig2_ovr_sel_d;
     SA1_DB_sig2_ovr_val   <= SA1_DB_sig2_ovr_val_d;
     SA0_DB_sig3_force_disable    <= SA0_DB_sig3_force_disable_d;
     SA0_DB_sig3_threshold <= SA0_DB_sig3_threshold_d;
     SA0_DB_sig3_ovr_sel   <= SA0_DB_sig3_ovr_sel_d;
     SA0_DB_sig3_ovr_val   <= SA0_DB_sig3_ovr_val_d;
     SA1_DB_sig3_force_disable    <= SA1_DB_sig3_force_disable_d;
     SA1_DB_sig3_threshold <= SA1_DB_sig3_threshold_d;
     SA1_DB_sig3_ovr_sel   <= SA1_DB_sig3_ovr_sel_d;
     SA1_DB_sig3_ovr_val   <= SA1_DB_sig3_ovr_val_d;

     SA0_PA_sig0_force_disable    <= SA0_PA_sig0_force_disable_d;
     SA0_PA_sig0_threshold <= SA0_PA_sig0_threshold_d;
     SA0_PA_sig0_ovr_sel   <= SA0_PA_sig0_ovr_sel_d;
     SA0_PA_sig0_ovr_val   <= SA0_PA_sig0_ovr_val_d;
     SA1_PA_sig0_force_disable    <= SA1_PA_sig0_force_disable_d;
     SA1_PA_sig0_threshold <= SA1_PA_sig0_threshold_d;
     SA1_PA_sig0_ovr_sel   <= SA1_PA_sig0_ovr_sel_d;
     SA1_PA_sig0_ovr_val   <= SA1_PA_sig0_ovr_val_d;
     SA0_PA_sig1_force_disable    <= SA0_PA_sig1_force_disable_d;
     SA0_PA_sig1_threshold <= SA0_PA_sig1_threshold_d;
     SA0_PA_sig1_ovr_sel   <= SA0_PA_sig1_ovr_sel_d;
     SA0_PA_sig1_ovr_val   <= SA0_PA_sig1_ovr_val_d;
     SA1_PA_sig1_force_disable    <= SA1_PA_sig1_force_disable_d;
     SA1_PA_sig1_threshold <= SA1_PA_sig1_threshold_d;
     SA1_PA_sig1_ovr_sel   <= SA1_PA_sig1_ovr_sel_d;
     SA1_PA_sig1_ovr_val   <= SA1_PA_sig1_ovr_val_d;

     SA0_RMI_sig0_force_disable    <= SA0_RMI_sig0_force_disable_d;
     SA0_RMI_sig0_threshold <= SA0_RMI_sig0_threshold_d;
     SA0_RMI_sig0_ovr_sel   <= SA0_RMI_sig0_ovr_sel_d;
     SA0_RMI_sig0_ovr_val   <= SA0_RMI_sig0_ovr_val_d;
     SA1_RMI_sig0_force_disable    <= SA1_RMI_sig0_force_disable_d;
     SA1_RMI_sig0_threshold <= SA1_RMI_sig0_threshold_d;
     SA1_RMI_sig0_ovr_sel   <= SA1_RMI_sig0_ovr_sel_d;
     SA1_RMI_sig0_ovr_val   <= SA1_RMI_sig0_ovr_val_d;

     SA0_SC_sig0_force_disable    <= SA0_SC_sig0_force_disable_d;
     SA0_SC_sig0_threshold <= SA0_SC_sig0_threshold_d;
     SA0_SC_sig0_ovr_sel   <= SA0_SC_sig0_ovr_sel_d;
     SA0_SC_sig0_ovr_val   <= SA0_SC_sig0_ovr_val_d;
     SA1_SC_sig0_force_disable    <= SA1_SC_sig0_force_disable_d;
     SA1_SC_sig0_threshold <= SA1_SC_sig0_threshold_d;
     SA1_SC_sig0_ovr_sel   <= SA1_SC_sig0_ovr_sel_d;
     SA1_SC_sig0_ovr_val   <= SA1_SC_sig0_ovr_val_d;

     SA0_SX_sig0_force_disable    <= SA0_SX_sig0_force_disable_d;
     SA0_SX_sig0_threshold <= SA0_SX_sig0_threshold_d;
     SA0_SX_sig0_ovr_sel   <= SA0_SX_sig0_ovr_sel_d;
     SA0_SX_sig0_ovr_val   <= SA0_SX_sig0_ovr_val_d;
     SA1_SX_sig0_force_disable    <= SA1_SX_sig0_force_disable_d;
     SA1_SX_sig0_threshold <= SA1_SX_sig0_threshold_d;
     SA1_SX_sig0_ovr_sel   <= SA1_SX_sig0_ovr_sel_d;
     SA1_SX_sig0_ovr_val   <= SA1_SX_sig0_ovr_val_d;

     SA0_SXRB_sig0_force_disable    <= SA0_SXRB_sig0_force_disable_d;
     SA0_SXRB_sig0_threshold <= SA0_SXRB_sig0_threshold_d;
     SA0_SXRB_sig0_ovr_sel   <= SA0_SXRB_sig0_ovr_sel_d;
     SA0_SXRB_sig0_ovr_val   <= SA0_SXRB_sig0_ovr_val_d;
     SA1_SXRB_sig0_force_disable    <= SA1_SXRB_sig0_force_disable_d;
     SA1_SXRB_sig0_threshold <= SA1_SXRB_sig0_threshold_d;
     SA1_SXRB_sig0_ovr_sel   <= SA1_SXRB_sig0_ovr_sel_d;
     SA1_SXRB_sig0_ovr_val   <= SA1_SXRB_sig0_ovr_val_d;

     SA0_UTCL1_sig0_force_disable    <= SA0_UTCL1_sig0_force_disable_d;
     SA0_UTCL1_sig0_threshold <= SA0_UTCL1_sig0_threshold_d;
     SA0_UTCL1_sig0_ovr_sel   <= SA0_UTCL1_sig0_ovr_sel_d;
     SA0_UTCL1_sig0_ovr_val   <= SA0_UTCL1_sig0_ovr_val_d;
     SA1_UTCL1_sig0_force_disable    <= SA1_UTCL1_sig0_force_disable_d;
     SA1_UTCL1_sig0_threshold <= SA1_UTCL1_sig0_threshold_d;
     SA1_UTCL1_sig0_ovr_sel   <= SA1_UTCL1_sig0_ovr_sel_d;
     SA1_UTCL1_sig0_ovr_val   <= SA1_UTCL1_sig0_ovr_val_d;

     SA0_CU_sig0_force_disable    <= SA0_CU_sig0_force_disable_d;
     SA0_CU_sig0_threshold <= SA0_CU_sig0_threshold_d;
     SA0_CU_sig0_ovr_sel   <= SA0_CU_sig0_ovr_sel_d;
     SA0_CU_sig0_ovr_val   <= SA0_CU_sig0_ovr_val_d;
     SA1_CU_sig0_force_disable    <= SA1_CU_sig0_force_disable_d;
     SA1_CU_sig0_threshold <= SA1_CU_sig0_threshold_d;
     SA1_CU_sig0_ovr_sel   <= SA1_CU_sig0_ovr_sel_d;
     SA1_CU_sig0_ovr_val   <= SA1_CU_sig0_ovr_val_d;

     SPI_sig0_force_disable    <= SPI_sig0_force_disable_d;
     SPI_sig0_threshold <= SPI_sig0_threshold_d;
     SPI_sig0_ovr_sel   <= SPI_sig0_ovr_sel_d;
     SPI_sig0_ovr_val   <= SPI_sig0_ovr_val_d;
     SPI_sig1_force_disable    <= SPI_sig1_force_disable_d;
     SPI_sig1_threshold <= SPI_sig1_threshold_d;
     SPI_sig1_ovr_sel   <= SPI_sig1_ovr_sel_d;
     SPI_sig1_ovr_val   <= SPI_sig1_ovr_val_d;
     SPI_sig2_force_disable    <= SPI_sig2_force_disable_d;
     SPI_sig2_threshold <= SPI_sig2_threshold_d;
     SPI_sig2_ovr_sel   <= SPI_sig2_ovr_sel_d;
     SPI_sig2_ovr_val   <= SPI_sig2_ovr_val_d;
     SPI_sig3_force_disable    <= SPI_sig3_force_disable_d;
     SPI_sig3_threshold <= SPI_sig3_threshold_d;
     SPI_sig3_ovr_sel   <= SPI_sig3_ovr_sel_d;
     SPI_sig3_ovr_val   <= SPI_sig3_ovr_val_d;
     SPI_sig4_force_disable    <= SPI_sig4_force_disable_d;
     SPI_sig4_threshold <= SPI_sig4_threshold_d;
     SPI_sig4_ovr_sel   <= SPI_sig4_ovr_sel_d;
     SPI_sig4_ovr_val   <= SPI_sig4_ovr_val_d;
     SPI_sig5_force_disable    <= SPI_sig5_force_disable_d;
     SPI_sig5_threshold <= SPI_sig5_threshold_d;
     SPI_sig5_ovr_sel   <= SPI_sig5_ovr_sel_d;
     SPI_sig5_ovr_val   <= SPI_sig5_ovr_val_d;

     PC_sig0_force_disable    <= PC_sig0_force_disable_d;
     PC_sig0_threshold <= PC_sig0_threshold_d;
     PC_sig0_ovr_sel   <= PC_sig0_ovr_sel_d;
     PC_sig0_ovr_val   <= PC_sig0_ovr_val_d;

		end //end of wr_ind_data
    end // else: !if(~resetb)
end // always @ (posedge reg_clk)

//cgtt_clk_ctrl
always @(posedge reg_clk)
begin
	if (~resetb) begin
		cgtt_clk_ctrl <= `SE_CAC_CGTT_CLK_CTRL_REG_DEFAULT;
		cgtt_clk_ctrl_on_delay <= `SE_CAC_CGTT_CLK_CTRL_ON_DELAY_DEFAULT;
	  	cgtt_clk_ctrl_off_hysteresis <= `SE_CAC_CGTT_CLK_CTRL_OFF_HYSTERESIS_DEFAULT;
	  	cgtt_clk_ctrl_soft_override_dyn <= `SE_CAC_CGTT_CLK_CTRL_SOFT_OVERRIDE_DYN_DEFAULT;
	  	cgtt_clk_ctrl_soft_override_reg <=  `SE_CAC_CGTT_CLK_CTRL_SOFT_OVERRIDE_REG_DEFAULT;

	end else begin
		cgtt_clk_ctrl <= {cgtt_clk_ctrl_soft_override_reg_d, cgtt_clk_ctrl_soft_override_dyn_d, 18'h0, cgtt_clk_ctrl_off_hysteresis_d, cgtt_clk_ctrl_on_delay_d};
		cgtt_clk_ctrl_on_delay <= cgtt_clk_ctrl_on_delay_d;
	  	cgtt_clk_ctrl_off_hysteresis <= cgtt_clk_ctrl_off_hysteresis_d;
	  	cgtt_clk_ctrl_soft_override_dyn <= cgtt_clk_ctrl_soft_override_dyn_d;
	  	cgtt_clk_ctrl_soft_override_reg <=  cgtt_clk_ctrl_soft_override_reg_d;
		end
end

//se_lcac_enable
always @(posedge reg_clk)
begin
    if(~resetb) begin
        se_lcac_enable <= `GC_CAC_CTRL_2_SE_LCAC_ENABLE_DEFAULT;
    end else begin
        se_lcac_enable <= se_lcac_enable_d;
    end
end


endmodule // cac_regs
