//----------------------------------------------------------------------------
// Date		: $Date$
// Copyright	: 1997-2017 by Synopsys, Inc., All Rights Reserved.
// Revision	: $Revision$
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// Cell model definitions.
//----------------------------------------------------------------------------


`timescale 1ps / 1ps

`ifndef SNPS_SEQ_DELAY
`define SNPS_SEQ_DELAY 10
`endif
`ifndef SNPS_COMBO_DELAY
`define SNPS_COMBO_DELAY 0 
`endif
`ifndef SNPS_CKGT_DELAY
`define SNPS_CKGT_DELAY 0
`endif
`ifndef SNPS_CKGTLT_DELAY
`define SNPS_CKGTLT_DELAY 0
`endif
`ifndef SNPS_LAT_DELAY
`define SNPS_LAT_DELAY 10
`endif

`ifdef VIRL_functiononly
    `delay_mode_distributed
    `define _fv
    `define SNPS_MASK_X_OUT_LATCH
    `define SNPS_MASK_ERR_UDP
`else
    `delay_mode_path
`endif

//%BEGIN HDBSVT08_TAPDSR

`celldefine
module HDBSVT08_TAPDSR ();
endmodule
`endcelldefine

//%END HDBSVT08_TAPDSR

//%BEGIN HDBSVT08_TAPDSB

`celldefine
module HDBSVT08_TAPDSB ();
endmodule
`endcelldefine

//%END HDBSVT08_TAPDSB

//%BEGIN HDBSVT08_TAPDSL

`celldefine
module HDBSVT08_TAPDSL ();
endmodule
`endcelldefine

//%END HDBSVT08_TAPDSL

//%BEGIN HDBSVT08_FSDPQB_PPV2Y2_1

`celldefine
module HDBSVT08_FSDPQB_PPV2Y2_1 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT08_FSDPQB_PPV2Y2_1

//%BEGIN HDBSVT08_FSDPQB_PPV2Y2_2

`celldefine
module HDBSVT08_FSDPQB_PPV2Y2_2 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT08_FSDPQB_PPV2Y2_2

//%BEGIN HDBSVT08_FSDPQB_PPV2Y2_4

`celldefine
module HDBSVT08_FSDPQB_PPV2Y2_4 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT08_FSDPQB_PPV2Y2_4

//%BEGIN HDBSVT08_FSDPQM4SS_PPLPV2Y8_1

`celldefine
module HDBSVT08_FSDPQM4SS_PPLPV2Y8_1 (Q0, Q1, Q2, Q3, CK, D0, D1, D2, D3, SI, SE);
   output Q0, Q1, Q2, Q3;
   input CK, D0, D1, D2, D3, SI, SE;

   reg viol_all, viol_0,  viol_1,  viol_2,  viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
`endif

   snps_mux2 inst7  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst9  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst10  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst11  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst12  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst13  (int_res__D2, int_res_iq1, delayed_D2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst14  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst15  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst16  (int_res__D3, int_res_iq2, delayed_D3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst17  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst18  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst19 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst20 (Q1, int_res_iq1);
        buf #`SNPS_SEQ_DELAY  inst21 (Q2, int_res_iq2);
        buf #`SNPS_SEQ_DELAY  inst22 (Q3, int_res_iq3);
   `else
        buf inst23  (Q0, int_res_iq0);
        buf inst24  (Q1, int_res_iq1);
        buf inst25  (Q2, int_res_iq2);
        buf inst26  (Q3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst27  (_net_0, D1);
not inst28  (_net_1, D0);
not inst29  (_net_2, D2);
not inst30  (_net_3, D3);
not inst31  (_net_4, SE);
not inst32  (_net_5, SI);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5);
not inst34  (_net_6, D1);
not inst35  (_net_7, D0);
not inst36  (_net_8, D2);
not inst37  (_net_9, D3);
not inst38  (_net_10, SE);
and inst39  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_6, _net_7, _net_8, _net_9, _net_10, SI);
not inst40  (_net_11, D1);
not inst41  (_net_12, D0);
not inst42  (_net_13, D2);
not inst43  (_net_14, D3);
not inst44  (_net_15, SI);
and inst45  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_11, _net_12, _net_13, _net_14, SE, _net_15);
not inst46  (_net_16, D1);
not inst47  (_net_17, D0);
not inst48  (_net_18, D2);
not inst49  (_net_19, D3);
and inst50  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_16, _net_17, _net_18, _net_19, SE, SI);
not inst51  (_net_20, D1);
not inst52  (_net_21, D0);
not inst53  (_net_22, D2);
not inst54  (_net_23, SE);
not inst55  (_net_24, SI);
and inst56  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22, D3, _net_23, _net_24);
not inst57  (_net_25, D1);
not inst58  (_net_26, D0);
not inst59  (_net_27, D2);
not inst60  (_net_28, SE);
and inst61  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_25, _net_26, _net_27, D3, _net_28, SI);
not inst62  (_net_29, D1);
not inst63  (_net_30, D0);
not inst64  (_net_31, D2);
not inst65  (_net_32, SI);
and inst66  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI, _net_29, _net_30, _net_31, D3, SE, _net_32);
not inst67  (_net_33, D1);
not inst68  (_net_34, D0);
not inst69  (_net_35, D2);
and inst70  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_33, _net_34, _net_35, D3, SE, SI);
not inst71  (_net_36, D1);
not inst72  (_net_37, D0);
not inst73  (_net_38, D3);
not inst74  (_net_39, SE);
not inst75  (_net_40, SI);
and inst76  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, D2, _net_38, _net_39, _net_40);
not inst77  (_net_41, D1);
not inst78  (_net_42, D0);
not inst79  (_net_43, D3);
not inst80  (_net_44, SE);
and inst81  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_41, _net_42, D2, _net_43, _net_44, SI);
not inst82  (_net_45, D1);
not inst83  (_net_46, D0);
not inst84  (_net_47, D3);
not inst85  (_net_48, SI);
and inst86  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_45, _net_46, D2, _net_47, SE, _net_48);
not inst87  (_net_49, D1);
not inst88  (_net_50, D0);
not inst89  (_net_51, D3);
and inst90  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_49, _net_50, D2, _net_51, SE, SI);
not inst91  (_net_52, D1);
not inst92  (_net_53, D0);
not inst93  (_net_54, SE);
not inst94  (_net_55, SI);
and inst95  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_52, _net_53, D2, D3, _net_54, _net_55);
not inst96  (_net_56, D1);
not inst97  (_net_57, D0);
not inst98  (_net_58, SE);
and inst99  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_56, _net_57, D2, D3, _net_58, SI);
not inst100  (_net_59, D1);
not inst101  (_net_60, D0);
not inst102  (_net_61, SI);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_59, _net_60, D2, D3, SE, _net_61);
not inst104  (_net_62, D1);
not inst105  (_net_63, D0);
and inst106  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_62, _net_63, D2, D3, SE, SI);
not inst107  (_net_64, D0);
not inst108  (_net_65, D2);
not inst109  (_net_66, D3);
not inst110  (_net_67, SE);
not inst111  (_net_68, SI);
and inst112  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_64, _net_65, _net_66, _net_67, _net_68);
not inst113  (_net_69, D0);
not inst114  (_net_70, D2);
not inst115  (_net_71, D3);
not inst116  (_net_72, SE);
and inst117  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_69, _net_70, _net_71, _net_72, SI);
not inst118  (_net_73, D0);
not inst119  (_net_74, D2);
not inst120  (_net_75, D3);
not inst121  (_net_76, SI);
and inst122  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D1, _net_73, _net_74, _net_75, SE, _net_76);
not inst123  (_net_77, D0);
not inst124  (_net_78, D2);
not inst125  (_net_79, D3);
and inst126  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D1, _net_77, _net_78, _net_79, SE, SI);
not inst127  (_net_80, D1);
not inst128  (_net_81, D2);
not inst129  (_net_82, D3);
not inst130  (_net_83, SE);
not inst131  (_net_84, SI);
and inst132  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_80, D0, _net_81, _net_82, _net_83, _net_84);
not inst133  (_net_85, D1);
not inst134  (_net_86, D2);
not inst135  (_net_87, D3);
not inst136  (_net_88, SE);
and inst137  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_85, D0, _net_86, _net_87, _net_88, SI);
not inst138  (_net_89, D1);
not inst139  (_net_90, D2);
not inst140  (_net_91, D3);
not inst141  (_net_92, SI);
and inst142  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_89, D0, _net_90, _net_91, SE, _net_92);
not inst143  (_net_93, D1);
not inst144  (_net_94, D2);
not inst145  (_net_95, D3);
and inst146  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_93, D0, _net_94, _net_95, SE, SI);
not inst147  (_net_96, D1);
not inst148  (_net_97, D3);
not inst149  (_net_98, SE);
not inst150  (_net_99, SI);
and inst151  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_96, D0, D2, _net_97, _net_98, _net_99);
not inst152  (_net_100, D1);
not inst153  (_net_101, D3);
not inst154  (_net_102, SE);
and inst155  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_100, D0, D2, _net_101, _net_102, SI);
not inst156  (_net_103, D1);
not inst157  (_net_104, D3);
not inst158  (_net_105, SI);
and inst159  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_103, D0, D2, _net_104, SE, _net_105);
not inst160  (_net_106, D1);
not inst161  (_net_107, D3);
and inst162  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_106, D0, D2, _net_107, SE, SI);
not inst163  (_net_108, D1);
not inst164  (_net_109, SE);
not inst165  (_net_110, SI);
and inst166  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_108, D0, D2, D3, _net_109, _net_110);
not inst167  (_net_111, D1);
not inst168  (_net_112, SE);
and inst169  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_111, D0, D2, D3, _net_112, SI);
not inst170  (_net_113, D1);
not inst171  (_net_114, SI);
and inst172  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_113, D0, D2, D3, SE, _net_114);
not inst173  (_net_115, D1);
and inst174  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_115, D0, D2, D3, SE, SI);
not inst175  (_net_116, SE);
not inst176  (_net_117, SI);
and inst177  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, _net_116, _net_117);
not inst178  (_net_118, SE);
and inst179  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D1, D0, D2, D3, _net_118, SI);
not inst180  (_net_119, SI);
and inst181  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D1, D0, D2, D3, SE, _net_119);
and inst182  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI, D1, D0, D2, D3, SE, SI);
not inst183  (_net_120, D1);
not inst184  (_net_121, D0);
not inst185  (_net_122, D2);
not inst186  (_net_123, D3);
and inst187  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI, _net_120, _net_121, _net_122, _net_123, SI);
not inst188  (_net_124, D1);
not inst189  (_net_125, D0);
not inst190  (_net_126, D2);
not inst191  (_net_127, SI);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI, _net_124, _net_125, _net_126, D3, _net_127);
not inst193  (_net_128, D1);
not inst194  (_net_129, D0);
not inst195  (_net_130, D3);
not inst196  (_net_131, SI);
and inst197  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI, _net_128, _net_129, D2, _net_130, _net_131);
not inst198  (_net_132, D0);
not inst199  (_net_133, D2);
not inst200  (_net_134, D3);
not inst201  (_net_135, SI);
and inst202  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, D1, _net_132, _net_133, _net_134, _net_135);
not inst203  (_net_136, D1);
not inst204  (_net_137, D2);
not inst205  (_net_138, D3);
not inst206  (_net_139, SI);
and inst207  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, _net_136, D0, _net_137, _net_138, _net_139);
not inst208  (_net_140, D0);
and inst209  (ENABLE_NOT_D0_AND_SE, SE, _net_140);
and inst210  (ENABLE_D0_AND_SE, SE, D0);
not inst211  (_net_141, SI);
not inst212  (_net_142, SE);
and inst213  (ENABLE_NOT_SE_AND_NOT_SI, _net_141, _net_142);
not inst214  (_net_143, SE);
and inst215  (ENABLE_NOT_SE_AND_SI, SI, _net_143);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
      viol_2 = (viol_2 !== viol_all) ? viol_all : ~viol_2;
      viol_3 = (viol_3 !== viol_all) ? viol_all : ~viol_3;
   end 
`endif 
specify
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT08_FSDPQM4SS_PPLPV2Y8_1

//%BEGIN HDBSVT08_FSDPQM4SS_PPLPV2Y8_2

`celldefine
module HDBSVT08_FSDPQM4SS_PPLPV2Y8_2 (Q0, Q1, Q2, Q3, CK, D0, D1, D2, D3, SI, SE);
   output Q0, Q1, Q2, Q3;
   input CK, D0, D1, D2, D3, SI, SE;

   reg viol_all, viol_0,  viol_1,  viol_2,  viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
`endif

   snps_mux2 inst7  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst9  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst10  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst11  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst12  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst13  (int_res__D2, int_res_iq1, delayed_D2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst14  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst15  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst16  (int_res__D3, int_res_iq2, delayed_D3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst17  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst18  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst19 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst20 (Q1, int_res_iq1);
        buf #`SNPS_SEQ_DELAY  inst21 (Q2, int_res_iq2);
        buf #`SNPS_SEQ_DELAY  inst22 (Q3, int_res_iq3);
   `else
        buf inst23  (Q0, int_res_iq0);
        buf inst24  (Q1, int_res_iq1);
        buf inst25  (Q2, int_res_iq2);
        buf inst26  (Q3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst27  (_net_0, D1);
not inst28  (_net_1, D0);
not inst29  (_net_2, D2);
not inst30  (_net_3, D3);
not inst31  (_net_4, SE);
not inst32  (_net_5, SI);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5);
not inst34  (_net_6, D1);
not inst35  (_net_7, D0);
not inst36  (_net_8, D2);
not inst37  (_net_9, D3);
not inst38  (_net_10, SE);
and inst39  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_6, _net_7, _net_8, _net_9, _net_10, SI);
not inst40  (_net_11, D1);
not inst41  (_net_12, D0);
not inst42  (_net_13, D2);
not inst43  (_net_14, D3);
not inst44  (_net_15, SI);
and inst45  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_11, _net_12, _net_13, _net_14, SE, _net_15);
not inst46  (_net_16, D1);
not inst47  (_net_17, D0);
not inst48  (_net_18, D2);
not inst49  (_net_19, D3);
and inst50  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_16, _net_17, _net_18, _net_19, SE, SI);
not inst51  (_net_20, D1);
not inst52  (_net_21, D0);
not inst53  (_net_22, D2);
not inst54  (_net_23, SE);
not inst55  (_net_24, SI);
and inst56  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22, D3, _net_23, _net_24);
not inst57  (_net_25, D1);
not inst58  (_net_26, D0);
not inst59  (_net_27, D2);
not inst60  (_net_28, SE);
and inst61  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_25, _net_26, _net_27, D3, _net_28, SI);
not inst62  (_net_29, D1);
not inst63  (_net_30, D0);
not inst64  (_net_31, D2);
not inst65  (_net_32, SI);
and inst66  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI, _net_29, _net_30, _net_31, D3, SE, _net_32);
not inst67  (_net_33, D1);
not inst68  (_net_34, D0);
not inst69  (_net_35, D2);
and inst70  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_33, _net_34, _net_35, D3, SE, SI);
not inst71  (_net_36, D1);
not inst72  (_net_37, D0);
not inst73  (_net_38, D3);
not inst74  (_net_39, SE);
not inst75  (_net_40, SI);
and inst76  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, D2, _net_38, _net_39, _net_40);
not inst77  (_net_41, D1);
not inst78  (_net_42, D0);
not inst79  (_net_43, D3);
not inst80  (_net_44, SE);
and inst81  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_41, _net_42, D2, _net_43, _net_44, SI);
not inst82  (_net_45, D1);
not inst83  (_net_46, D0);
not inst84  (_net_47, D3);
not inst85  (_net_48, SI);
and inst86  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_45, _net_46, D2, _net_47, SE, _net_48);
not inst87  (_net_49, D1);
not inst88  (_net_50, D0);
not inst89  (_net_51, D3);
and inst90  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_49, _net_50, D2, _net_51, SE, SI);
not inst91  (_net_52, D1);
not inst92  (_net_53, D0);
not inst93  (_net_54, SE);
not inst94  (_net_55, SI);
and inst95  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_52, _net_53, D2, D3, _net_54, _net_55);
not inst96  (_net_56, D1);
not inst97  (_net_57, D0);
not inst98  (_net_58, SE);
and inst99  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_56, _net_57, D2, D3, _net_58, SI);
not inst100  (_net_59, D1);
not inst101  (_net_60, D0);
not inst102  (_net_61, SI);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_59, _net_60, D2, D3, SE, _net_61);
not inst104  (_net_62, D1);
not inst105  (_net_63, D0);
and inst106  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_62, _net_63, D2, D3, SE, SI);
not inst107  (_net_64, D0);
not inst108  (_net_65, D2);
not inst109  (_net_66, D3);
not inst110  (_net_67, SE);
not inst111  (_net_68, SI);
and inst112  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_64, _net_65, _net_66, _net_67, _net_68);
not inst113  (_net_69, D0);
not inst114  (_net_70, D2);
not inst115  (_net_71, D3);
not inst116  (_net_72, SE);
and inst117  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_69, _net_70, _net_71, _net_72, SI);
not inst118  (_net_73, D0);
not inst119  (_net_74, D2);
not inst120  (_net_75, D3);
not inst121  (_net_76, SI);
and inst122  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D1, _net_73, _net_74, _net_75, SE, _net_76);
not inst123  (_net_77, D0);
not inst124  (_net_78, D2);
not inst125  (_net_79, D3);
and inst126  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D1, _net_77, _net_78, _net_79, SE, SI);
not inst127  (_net_80, D1);
not inst128  (_net_81, D2);
not inst129  (_net_82, D3);
not inst130  (_net_83, SE);
not inst131  (_net_84, SI);
and inst132  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_80, D0, _net_81, _net_82, _net_83, _net_84);
not inst133  (_net_85, D1);
not inst134  (_net_86, D2);
not inst135  (_net_87, D3);
not inst136  (_net_88, SE);
and inst137  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_85, D0, _net_86, _net_87, _net_88, SI);
not inst138  (_net_89, D1);
not inst139  (_net_90, D2);
not inst140  (_net_91, D3);
not inst141  (_net_92, SI);
and inst142  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_89, D0, _net_90, _net_91, SE, _net_92);
not inst143  (_net_93, D1);
not inst144  (_net_94, D2);
not inst145  (_net_95, D3);
and inst146  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_93, D0, _net_94, _net_95, SE, SI);
not inst147  (_net_96, D1);
not inst148  (_net_97, D3);
not inst149  (_net_98, SE);
not inst150  (_net_99, SI);
and inst151  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_96, D0, D2, _net_97, _net_98, _net_99);
not inst152  (_net_100, D1);
not inst153  (_net_101, D3);
not inst154  (_net_102, SE);
and inst155  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_100, D0, D2, _net_101, _net_102, SI);
not inst156  (_net_103, D1);
not inst157  (_net_104, D3);
not inst158  (_net_105, SI);
and inst159  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_103, D0, D2, _net_104, SE, _net_105);
not inst160  (_net_106, D1);
not inst161  (_net_107, D3);
and inst162  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_106, D0, D2, _net_107, SE, SI);
not inst163  (_net_108, D1);
not inst164  (_net_109, SE);
not inst165  (_net_110, SI);
and inst166  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_108, D0, D2, D3, _net_109, _net_110);
not inst167  (_net_111, D1);
not inst168  (_net_112, SE);
and inst169  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_111, D0, D2, D3, _net_112, SI);
not inst170  (_net_113, D1);
not inst171  (_net_114, SI);
and inst172  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_113, D0, D2, D3, SE, _net_114);
not inst173  (_net_115, D1);
and inst174  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_115, D0, D2, D3, SE, SI);
not inst175  (_net_116, SE);
not inst176  (_net_117, SI);
and inst177  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, _net_116, _net_117);
not inst178  (_net_118, SE);
and inst179  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D1, D0, D2, D3, _net_118, SI);
not inst180  (_net_119, SI);
and inst181  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D1, D0, D2, D3, SE, _net_119);
and inst182  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI, D1, D0, D2, D3, SE, SI);
not inst183  (_net_120, D1);
not inst184  (_net_121, D0);
not inst185  (_net_122, D2);
not inst186  (_net_123, D3);
and inst187  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI, _net_120, _net_121, _net_122, _net_123, SI);
not inst188  (_net_124, D1);
not inst189  (_net_125, D0);
not inst190  (_net_126, D2);
not inst191  (_net_127, SI);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI, _net_124, _net_125, _net_126, D3, _net_127);
not inst193  (_net_128, D1);
not inst194  (_net_129, D0);
not inst195  (_net_130, D3);
not inst196  (_net_131, SI);
and inst197  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI, _net_128, _net_129, D2, _net_130, _net_131);
not inst198  (_net_132, D0);
not inst199  (_net_133, D2);
not inst200  (_net_134, D3);
not inst201  (_net_135, SI);
and inst202  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, D1, _net_132, _net_133, _net_134, _net_135);
not inst203  (_net_136, D1);
not inst204  (_net_137, D2);
not inst205  (_net_138, D3);
not inst206  (_net_139, SI);
and inst207  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, _net_136, D0, _net_137, _net_138, _net_139);
not inst208  (_net_140, D0);
and inst209  (ENABLE_NOT_D0_AND_SE, SE, _net_140);
and inst210  (ENABLE_D0_AND_SE, SE, D0);
not inst211  (_net_141, SI);
not inst212  (_net_142, SE);
and inst213  (ENABLE_NOT_SE_AND_NOT_SI, _net_141, _net_142);
not inst214  (_net_143, SE);
and inst215  (ENABLE_NOT_SE_AND_SI, SI, _net_143);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
      viol_2 = (viol_2 !== viol_all) ? viol_all : ~viol_2;
      viol_3 = (viol_3 !== viol_all) ? viol_all : ~viol_3;
   end 
`endif 
specify
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT08_FSDPQM4SS_PPLPV2Y8_2

//%BEGIN HDBSVT08_FSDPQM4SS_PPV2P1Y8_2

`celldefine
module HDBSVT08_FSDPQM4SS_PPV2P1Y8_2 (Q0, Q1, Q2, Q3, CK, D0, D1, D2, D3, SI, SE);
   output Q0, Q1, Q2, Q3;
   input CK, D0, D1, D2, D3, SI, SE;

   reg viol_all, viol_0,  viol_1,  viol_2,  viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
`endif

   snps_mux2 inst7  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst9  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst10  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst11  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst12  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst13  (int_res__D2, int_res_iq1, delayed_D2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst14  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst15  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst16  (int_res__D3, int_res_iq2, delayed_D3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst17  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst18  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst19 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst20 (Q1, int_res_iq1);
        buf #`SNPS_SEQ_DELAY  inst21 (Q2, int_res_iq2);
        buf #`SNPS_SEQ_DELAY  inst22 (Q3, int_res_iq3);
   `else
        buf inst23  (Q0, int_res_iq0);
        buf inst24  (Q1, int_res_iq1);
        buf inst25  (Q2, int_res_iq2);
        buf inst26  (Q3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst27  (_net_0, D1);
not inst28  (_net_1, D0);
not inst29  (_net_2, D2);
not inst30  (_net_3, D3);
not inst31  (_net_4, SE);
not inst32  (_net_5, SI);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5);
not inst34  (_net_6, D1);
not inst35  (_net_7, D0);
not inst36  (_net_8, D2);
not inst37  (_net_9, D3);
not inst38  (_net_10, SE);
and inst39  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_6, _net_7, _net_8, _net_9, _net_10, SI);
not inst40  (_net_11, D1);
not inst41  (_net_12, D0);
not inst42  (_net_13, D2);
not inst43  (_net_14, D3);
not inst44  (_net_15, SI);
and inst45  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_11, _net_12, _net_13, _net_14, SE, _net_15);
not inst46  (_net_16, D1);
not inst47  (_net_17, D0);
not inst48  (_net_18, D2);
not inst49  (_net_19, D3);
and inst50  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_16, _net_17, _net_18, _net_19, SE, SI);
not inst51  (_net_20, D1);
not inst52  (_net_21, D0);
not inst53  (_net_22, D2);
not inst54  (_net_23, SE);
not inst55  (_net_24, SI);
and inst56  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22, D3, _net_23, _net_24);
not inst57  (_net_25, D1);
not inst58  (_net_26, D0);
not inst59  (_net_27, D2);
not inst60  (_net_28, SE);
and inst61  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_25, _net_26, _net_27, D3, _net_28, SI);
not inst62  (_net_29, D1);
not inst63  (_net_30, D0);
not inst64  (_net_31, D2);
not inst65  (_net_32, SI);
and inst66  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI, _net_29, _net_30, _net_31, D3, SE, _net_32);
not inst67  (_net_33, D1);
not inst68  (_net_34, D0);
not inst69  (_net_35, D2);
and inst70  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_33, _net_34, _net_35, D3, SE, SI);
not inst71  (_net_36, D1);
not inst72  (_net_37, D0);
not inst73  (_net_38, D3);
not inst74  (_net_39, SE);
not inst75  (_net_40, SI);
and inst76  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, D2, _net_38, _net_39, _net_40);
not inst77  (_net_41, D1);
not inst78  (_net_42, D0);
not inst79  (_net_43, D3);
not inst80  (_net_44, SE);
and inst81  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_41, _net_42, D2, _net_43, _net_44, SI);
not inst82  (_net_45, D1);
not inst83  (_net_46, D0);
not inst84  (_net_47, D3);
not inst85  (_net_48, SI);
and inst86  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_45, _net_46, D2, _net_47, SE, _net_48);
not inst87  (_net_49, D1);
not inst88  (_net_50, D0);
not inst89  (_net_51, D3);
and inst90  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_49, _net_50, D2, _net_51, SE, SI);
not inst91  (_net_52, D1);
not inst92  (_net_53, D0);
not inst93  (_net_54, SE);
not inst94  (_net_55, SI);
and inst95  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_52, _net_53, D2, D3, _net_54, _net_55);
not inst96  (_net_56, D1);
not inst97  (_net_57, D0);
not inst98  (_net_58, SE);
and inst99  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_56, _net_57, D2, D3, _net_58, SI);
not inst100  (_net_59, D1);
not inst101  (_net_60, D0);
not inst102  (_net_61, SI);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_59, _net_60, D2, D3, SE, _net_61);
not inst104  (_net_62, D1);
not inst105  (_net_63, D0);
and inst106  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_62, _net_63, D2, D3, SE, SI);
not inst107  (_net_64, D0);
not inst108  (_net_65, D2);
not inst109  (_net_66, D3);
not inst110  (_net_67, SE);
not inst111  (_net_68, SI);
and inst112  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_64, _net_65, _net_66, _net_67, _net_68);
not inst113  (_net_69, D0);
not inst114  (_net_70, D2);
not inst115  (_net_71, D3);
not inst116  (_net_72, SE);
and inst117  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_69, _net_70, _net_71, _net_72, SI);
not inst118  (_net_73, D0);
not inst119  (_net_74, D2);
not inst120  (_net_75, D3);
not inst121  (_net_76, SI);
and inst122  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D1, _net_73, _net_74, _net_75, SE, _net_76);
not inst123  (_net_77, D0);
not inst124  (_net_78, D2);
not inst125  (_net_79, D3);
and inst126  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D1, _net_77, _net_78, _net_79, SE, SI);
not inst127  (_net_80, D1);
not inst128  (_net_81, D2);
not inst129  (_net_82, D3);
not inst130  (_net_83, SE);
not inst131  (_net_84, SI);
and inst132  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_80, D0, _net_81, _net_82, _net_83, _net_84);
not inst133  (_net_85, D1);
not inst134  (_net_86, D2);
not inst135  (_net_87, D3);
not inst136  (_net_88, SE);
and inst137  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_85, D0, _net_86, _net_87, _net_88, SI);
not inst138  (_net_89, D1);
not inst139  (_net_90, D2);
not inst140  (_net_91, D3);
not inst141  (_net_92, SI);
and inst142  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_89, D0, _net_90, _net_91, SE, _net_92);
not inst143  (_net_93, D1);
not inst144  (_net_94, D2);
not inst145  (_net_95, D3);
and inst146  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_93, D0, _net_94, _net_95, SE, SI);
not inst147  (_net_96, D1);
not inst148  (_net_97, D3);
not inst149  (_net_98, SE);
not inst150  (_net_99, SI);
and inst151  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_96, D0, D2, _net_97, _net_98, _net_99);
not inst152  (_net_100, D1);
not inst153  (_net_101, D3);
not inst154  (_net_102, SE);
and inst155  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_100, D0, D2, _net_101, _net_102, SI);
not inst156  (_net_103, D1);
not inst157  (_net_104, D3);
not inst158  (_net_105, SI);
and inst159  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_103, D0, D2, _net_104, SE, _net_105);
not inst160  (_net_106, D1);
not inst161  (_net_107, D3);
and inst162  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_106, D0, D2, _net_107, SE, SI);
not inst163  (_net_108, D1);
not inst164  (_net_109, SE);
not inst165  (_net_110, SI);
and inst166  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_108, D0, D2, D3, _net_109, _net_110);
not inst167  (_net_111, D1);
not inst168  (_net_112, SE);
and inst169  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_111, D0, D2, D3, _net_112, SI);
not inst170  (_net_113, D1);
not inst171  (_net_114, SI);
and inst172  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_113, D0, D2, D3, SE, _net_114);
not inst173  (_net_115, D1);
and inst174  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_115, D0, D2, D3, SE, SI);
not inst175  (_net_116, SE);
not inst176  (_net_117, SI);
and inst177  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, _net_116, _net_117);
not inst178  (_net_118, SE);
and inst179  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D1, D0, D2, D3, _net_118, SI);
not inst180  (_net_119, SI);
and inst181  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D1, D0, D2, D3, SE, _net_119);
and inst182  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI, D1, D0, D2, D3, SE, SI);
not inst183  (_net_120, D1);
not inst184  (_net_121, D0);
not inst185  (_net_122, D2);
not inst186  (_net_123, D3);
and inst187  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI, _net_120, _net_121, _net_122, _net_123, SI);
not inst188  (_net_124, D1);
not inst189  (_net_125, D0);
not inst190  (_net_126, D2);
not inst191  (_net_127, SI);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI, _net_124, _net_125, _net_126, D3, _net_127);
not inst193  (_net_128, D1);
not inst194  (_net_129, D0);
not inst195  (_net_130, D3);
not inst196  (_net_131, SI);
and inst197  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI, _net_128, _net_129, D2, _net_130, _net_131);
not inst198  (_net_132, D0);
not inst199  (_net_133, D2);
not inst200  (_net_134, D3);
not inst201  (_net_135, SI);
and inst202  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, D1, _net_132, _net_133, _net_134, _net_135);
not inst203  (_net_136, D1);
not inst204  (_net_137, D2);
not inst205  (_net_138, D3);
not inst206  (_net_139, SI);
and inst207  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, _net_136, D0, _net_137, _net_138, _net_139);
not inst208  (_net_140, D0);
and inst209  (ENABLE_NOT_D0_AND_SE, SE, _net_140);
and inst210  (ENABLE_D0_AND_SE, SE, D0);
not inst211  (_net_141, SI);
not inst212  (_net_142, SE);
and inst213  (ENABLE_NOT_SE_AND_NOT_SI, _net_141, _net_142);
not inst214  (_net_143, SE);
and inst215  (ENABLE_NOT_SE_AND_SI, SI, _net_143);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
      viol_2 = (viol_2 !== viol_all) ? viol_all : ~viol_2;
      viol_3 = (viol_3 !== viol_all) ? viol_all : ~viol_3;
   end 
`endif 
specify
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT08_FSDPQM4SS_PPV2P1Y8_2

//%BEGIN HDBSVT08_FSDPQ_PPV2Y2_1

`celldefine
module HDBSVT08_FSDPQ_PPV2Y2_1 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT08_FSDPQ_PPV2Y2_1

//%BEGIN HDBSVT08_FSDPQ_PPV2Y2_2

`celldefine
module HDBSVT08_FSDPQ_PPV2Y2_2 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT08_FSDPQ_PPV2Y2_2

//%BEGIN HDBSVT08_FSDPQ_PPV2Y2_4

`celldefine
module HDBSVT08_FSDPQ_PPV2Y2_4 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT08_FSDPQ_PPV2Y2_4

//%BEGIN HDBSVT08_FSDPSYNRBQM4SS_PPV2Y8_1

`celldefine
module HDBSVT08_FSDPSYNRBQM4SS_PPV2Y8_1 (Q0, Q1, Q2, Q3, CK, D0, D1, D2, D3, SI, SE, RD);
   output Q0, Q1, Q2, Q3;
   input CK, D0, D1, D2, D3, SI, SE, RD;

   reg viol_0, viol_1, viol_2, viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE, delayed_RD;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res__RD0, int_res__RD1, int_res__RD2, int_res__RD3, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
   buf inst7  (delayed_RD, RD);
`endif
   not inst8  (int_res__RD, delayed_RD);

   and inst9  (int_res__RD0, delayed_D0, delayed_RD);
   and inst10  (int_res__RD1, delayed_D1, delayed_RD);
   and inst11  (int_res__RD2, delayed_D2, delayed_RD);
   and inst12  (int_res__RD3, delayed_D3, delayed_RD);
   

   snps_mux2 inst13  (int_res__D0, delayed_SI, int_res__RD0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst14  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst15  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst16  (int_res__D1, int_res_iq0, int_res__RD1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst17  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst18  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst19  (int_res__D2, int_res_iq1, int_res__RD2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst20  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst21  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst22  (int_res__D3, int_res_iq2, int_res__RD3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst23  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst24  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst25 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst26 (Q1, int_res_iq1);
        buf #`SNPS_SEQ_DELAY  inst27 (Q2, int_res_iq2);
        buf #`SNPS_SEQ_DELAY  inst28 (Q3, int_res_iq3);
   `else
        buf inst29  (Q0, int_res_iq0);
        buf inst30  (Q1, int_res_iq1);
        buf inst31  (Q2, int_res_iq2);
        buf inst32  (Q3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst33  (_net_0, D1);
not inst34  (_net_1, D0);
not inst35  (_net_2, D2);
not inst36  (_net_3, D3);
not inst37  (_net_4, RD);
not inst38  (_net_5, SE);
not inst39  (_net_6, SI);
and inst40  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5, _net_6);
not inst41  (_net_7, D1);
not inst42  (_net_8, D0);
not inst43  (_net_9, D2);
not inst44  (_net_10, D3);
not inst45  (_net_11, RD);
not inst46  (_net_12, SE);
and inst47  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_7, _net_8, _net_9, _net_10, _net_11, _net_12, SI);
not inst48  (_net_13, D1);
not inst49  (_net_14, D0);
not inst50  (_net_15, D2);
not inst51  (_net_16, D3);
not inst52  (_net_17, RD);
not inst53  (_net_18, SI);
and inst54  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_13, _net_14, _net_15, _net_16, _net_17, SE, _net_18);
not inst55  (_net_19, D1);
not inst56  (_net_20, D0);
not inst57  (_net_21, D2);
not inst58  (_net_22, D3);
not inst59  (_net_23, RD);
and inst60  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, _net_19, _net_20, _net_21, _net_22, _net_23, SE, SI);
not inst61  (_net_24, D1);
not inst62  (_net_25, D0);
not inst63  (_net_26, D2);
not inst64  (_net_27, D3);
not inst65  (_net_28, SE);
not inst66  (_net_29, SI);
and inst67  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_24, _net_25, _net_26, _net_27, RD, _net_28, _net_29);
not inst68  (_net_30, D1);
not inst69  (_net_31, D0);
not inst70  (_net_32, D2);
not inst71  (_net_33, D3);
not inst72  (_net_34, SE);
and inst73  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_30, _net_31, _net_32, _net_33, RD, _net_34, SI);
not inst74  (_net_35, D1);
not inst75  (_net_36, D0);
not inst76  (_net_37, D2);
not inst77  (_net_38, D3);
not inst78  (_net_39, SI);
and inst79  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_35, _net_36, _net_37, _net_38, RD, SE, _net_39);
not inst80  (_net_40, D1);
not inst81  (_net_41, D0);
not inst82  (_net_42, D2);
not inst83  (_net_43, D3);
and inst84  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_40, _net_41, _net_42, _net_43, RD, SE, SI);
not inst85  (_net_44, D1);
not inst86  (_net_45, D0);
not inst87  (_net_46, D2);
not inst88  (_net_47, RD);
not inst89  (_net_48, SE);
not inst90  (_net_49, SI);
and inst91  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_44, _net_45, _net_46, D3, _net_47, _net_48, _net_49);
not inst92  (_net_50, D1);
not inst93  (_net_51, D0);
not inst94  (_net_52, D2);
not inst95  (_net_53, RD);
not inst96  (_net_54, SE);
and inst97  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_50, _net_51, _net_52, D3, _net_53, _net_54, SI);
not inst98  (_net_55, D1);
not inst99  (_net_56, D0);
not inst100  (_net_57, D2);
not inst101  (_net_58, RD);
not inst102  (_net_59, SI);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_55, _net_56, _net_57, D3, _net_58, SE, _net_59);
not inst104  (_net_60, D1);
not inst105  (_net_61, D0);
not inst106  (_net_62, D2);
not inst107  (_net_63, RD);
and inst108  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI, _net_60, _net_61, _net_62, D3, _net_63, SE, SI);
not inst109  (_net_64, D1);
not inst110  (_net_65, D0);
not inst111  (_net_66, D2);
not inst112  (_net_67, SE);
not inst113  (_net_68, SI);
and inst114  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_64, _net_65, _net_66, D3, RD, _net_67, _net_68);
not inst115  (_net_69, D1);
not inst116  (_net_70, D0);
not inst117  (_net_71, D2);
not inst118  (_net_72, SE);
and inst119  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_69, _net_70, _net_71, D3, RD, _net_72, SI);
not inst120  (_net_73, D1);
not inst121  (_net_74, D0);
not inst122  (_net_75, D2);
not inst123  (_net_76, SI);
and inst124  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_73, _net_74, _net_75, D3, RD, SE, _net_76);
not inst125  (_net_77, D1);
not inst126  (_net_78, D0);
not inst127  (_net_79, D2);
and inst128  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_77, _net_78, _net_79, D3, RD, SE, SI);
not inst129  (_net_80, D1);
not inst130  (_net_81, D0);
not inst131  (_net_82, D3);
not inst132  (_net_83, RD);
not inst133  (_net_84, SE);
not inst134  (_net_85, SI);
and inst135  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_80, _net_81, D2, _net_82, _net_83, _net_84, _net_85);
not inst136  (_net_86, D1);
not inst137  (_net_87, D0);
not inst138  (_net_88, D3);
not inst139  (_net_89, RD);
not inst140  (_net_90, SE);
and inst141  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_86, _net_87, D2, _net_88, _net_89, _net_90, SI);
not inst142  (_net_91, D1);
not inst143  (_net_92, D0);
not inst144  (_net_93, D3);
not inst145  (_net_94, RD);
not inst146  (_net_95, SI);
and inst147  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_91, _net_92, D2, _net_93, _net_94, SE, _net_95);
not inst148  (_net_96, D1);
not inst149  (_net_97, D0);
not inst150  (_net_98, D3);
not inst151  (_net_99, RD);
and inst152  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, _net_96, _net_97, D2, _net_98, _net_99, SE, SI);
not inst153  (_net_100, D1);
not inst154  (_net_101, D0);
not inst155  (_net_102, D3);
not inst156  (_net_103, SE);
not inst157  (_net_104, SI);
and inst158  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_100, _net_101, D2, _net_102, RD, _net_103, _net_104);
not inst159  (_net_105, D1);
not inst160  (_net_106, D0);
not inst161  (_net_107, D3);
not inst162  (_net_108, SE);
and inst163  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_105, _net_106, D2, _net_107, RD, _net_108, SI);
not inst164  (_net_109, D1);
not inst165  (_net_110, D0);
not inst166  (_net_111, D3);
not inst167  (_net_112, SI);
and inst168  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_109, _net_110, D2, _net_111, RD, SE, _net_112);
not inst169  (_net_113, D1);
not inst170  (_net_114, D0);
not inst171  (_net_115, D3);
and inst172  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_113, _net_114, D2, _net_115, RD, SE, SI);
not inst173  (_net_116, D1);
not inst174  (_net_117, D0);
not inst175  (_net_118, RD);
not inst176  (_net_119, SE);
not inst177  (_net_120, SI);
and inst178  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_116, _net_117, D2, D3, _net_118, _net_119, _net_120);
not inst179  (_net_121, D1);
not inst180  (_net_122, D0);
not inst181  (_net_123, RD);
not inst182  (_net_124, SE);
and inst183  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_121, _net_122, D2, D3, _net_123, _net_124, SI);
not inst184  (_net_125, D1);
not inst185  (_net_126, D0);
not inst186  (_net_127, RD);
not inst187  (_net_128, SI);
and inst188  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_125, _net_126, D2, D3, _net_127, SE, _net_128);
not inst189  (_net_129, D1);
not inst190  (_net_130, D0);
not inst191  (_net_131, RD);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI, _net_129, _net_130, D2, D3, _net_131, SE, SI);
not inst193  (_net_132, D1);
not inst194  (_net_133, D0);
not inst195  (_net_134, SE);
not inst196  (_net_135, SI);
and inst197  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_132, _net_133, D2, D3, RD, _net_134, _net_135);
not inst198  (_net_136, D1);
not inst199  (_net_137, D0);
not inst200  (_net_138, SE);
and inst201  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_136, _net_137, D2, D3, RD, _net_138, SI);
not inst202  (_net_139, D1);
not inst203  (_net_140, D0);
not inst204  (_net_141, SI);
and inst205  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_139, _net_140, D2, D3, RD, SE, _net_141);
not inst206  (_net_142, D1);
not inst207  (_net_143, D0);
and inst208  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_142, _net_143, D2, D3, RD, SE, SI);
not inst209  (_net_144, D0);
not inst210  (_net_145, D2);
not inst211  (_net_146, D3);
not inst212  (_net_147, RD);
not inst213  (_net_148, SE);
not inst214  (_net_149, SI);
and inst215  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_144, _net_145, _net_146, _net_147, _net_148, _net_149);
not inst216  (_net_150, D0);
not inst217  (_net_151, D2);
not inst218  (_net_152, D3);
not inst219  (_net_153, RD);
not inst220  (_net_154, SE);
and inst221  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, D1, _net_150, _net_151, _net_152, _net_153, _net_154, SI);
not inst222  (_net_155, D0);
not inst223  (_net_156, D2);
not inst224  (_net_157, D3);
not inst225  (_net_158, RD);
not inst226  (_net_159, SI);
and inst227  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, D1, _net_155, _net_156, _net_157, _net_158, SE, _net_159);
not inst228  (_net_160, D0);
not inst229  (_net_161, D2);
not inst230  (_net_162, D3);
not inst231  (_net_163, RD);
and inst232  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, D1, _net_160, _net_161, _net_162, _net_163, SE, SI);
not inst233  (_net_164, D0);
not inst234  (_net_165, D2);
not inst235  (_net_166, D3);
not inst236  (_net_167, SE);
not inst237  (_net_168, SI);
and inst238  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_164, _net_165, _net_166, RD, _net_167, _net_168);
not inst239  (_net_169, D0);
not inst240  (_net_170, D2);
not inst241  (_net_171, D3);
not inst242  (_net_172, SE);
and inst243  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, D1, _net_169, _net_170, _net_171, RD, _net_172, SI);
not inst244  (_net_173, D0);
not inst245  (_net_174, D2);
not inst246  (_net_175, D3);
not inst247  (_net_176, SI);
and inst248  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, D1, _net_173, _net_174, _net_175, RD, SE, _net_176);
not inst249  (_net_177, D0);
not inst250  (_net_178, D2);
not inst251  (_net_179, D3);
and inst252  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, D1, _net_177, _net_178, _net_179, RD, SE, SI);
not inst253  (_net_180, D1);
not inst254  (_net_181, D2);
not inst255  (_net_182, D3);
not inst256  (_net_183, RD);
not inst257  (_net_184, SE);
not inst258  (_net_185, SI);
and inst259  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_180, D0, _net_181, _net_182, _net_183, _net_184, _net_185);
not inst260  (_net_186, D1);
not inst261  (_net_187, D2);
not inst262  (_net_188, D3);
not inst263  (_net_189, RD);
not inst264  (_net_190, SE);
and inst265  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_186, D0, _net_187, _net_188, _net_189, _net_190, SI);
not inst266  (_net_191, D1);
not inst267  (_net_192, D2);
not inst268  (_net_193, D3);
not inst269  (_net_194, RD);
not inst270  (_net_195, SI);
and inst271  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_191, D0, _net_192, _net_193, _net_194, SE, _net_195);
not inst272  (_net_196, D1);
not inst273  (_net_197, D2);
not inst274  (_net_198, D3);
not inst275  (_net_199, RD);
and inst276  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, _net_196, D0, _net_197, _net_198, _net_199, SE, SI);
not inst277  (_net_200, D1);
not inst278  (_net_201, D2);
not inst279  (_net_202, D3);
not inst280  (_net_203, SE);
not inst281  (_net_204, SI);
and inst282  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_200, D0, _net_201, _net_202, RD, _net_203, _net_204);
not inst283  (_net_205, D1);
not inst284  (_net_206, D2);
not inst285  (_net_207, D3);
not inst286  (_net_208, SE);
and inst287  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_205, D0, _net_206, _net_207, RD, _net_208, SI);
not inst288  (_net_209, D1);
not inst289  (_net_210, D2);
not inst290  (_net_211, D3);
not inst291  (_net_212, SI);
and inst292  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_209, D0, _net_210, _net_211, RD, SE, _net_212);
not inst293  (_net_213, D1);
not inst294  (_net_214, D2);
not inst295  (_net_215, D3);
and inst296  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_213, D0, _net_214, _net_215, RD, SE, SI);
not inst297  (_net_216, D1);
not inst298  (_net_217, D3);
not inst299  (_net_218, RD);
not inst300  (_net_219, SE);
not inst301  (_net_220, SI);
and inst302  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_216, D0, D2, _net_217, _net_218, _net_219, _net_220);
not inst303  (_net_221, D1);
not inst304  (_net_222, D3);
not inst305  (_net_223, RD);
not inst306  (_net_224, SE);
and inst307  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_221, D0, D2, _net_222, _net_223, _net_224, SI);
not inst308  (_net_225, D1);
not inst309  (_net_226, D3);
not inst310  (_net_227, RD);
not inst311  (_net_228, SI);
and inst312  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_225, D0, D2, _net_226, _net_227, SE, _net_228);
not inst313  (_net_229, D1);
not inst314  (_net_230, D3);
not inst315  (_net_231, RD);
and inst316  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, _net_229, D0, D2, _net_230, _net_231, SE, SI);
not inst317  (_net_232, D1);
not inst318  (_net_233, D3);
not inst319  (_net_234, SE);
not inst320  (_net_235, SI);
and inst321  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_232, D0, D2, _net_233, RD, _net_234, _net_235);
not inst322  (_net_236, D1);
not inst323  (_net_237, D3);
not inst324  (_net_238, SE);
and inst325  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_236, D0, D2, _net_237, RD, _net_238, SI);
not inst326  (_net_239, D1);
not inst327  (_net_240, D3);
not inst328  (_net_241, SI);
and inst329  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_239, D0, D2, _net_240, RD, SE, _net_241);
not inst330  (_net_242, D1);
not inst331  (_net_243, D3);
and inst332  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_242, D0, D2, _net_243, RD, SE, SI);
not inst333  (_net_244, D1);
not inst334  (_net_245, RD);
not inst335  (_net_246, SE);
not inst336  (_net_247, SI);
and inst337  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_244, D0, D2, D3, _net_245, _net_246, _net_247);
not inst338  (_net_248, D1);
not inst339  (_net_249, RD);
not inst340  (_net_250, SE);
and inst341  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_248, D0, D2, D3, _net_249, _net_250, SI);
not inst342  (_net_251, D1);
not inst343  (_net_252, RD);
not inst344  (_net_253, SI);
and inst345  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_251, D0, D2, D3, _net_252, SE, _net_253);
not inst346  (_net_254, D1);
not inst347  (_net_255, RD);
and inst348  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI, _net_254, D0, D2, D3, _net_255, SE, SI);
not inst349  (_net_256, D1);
not inst350  (_net_257, SE);
not inst351  (_net_258, SI);
and inst352  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_256, D0, D2, D3, RD, _net_257, _net_258);
not inst353  (_net_259, D1);
not inst354  (_net_260, SE);
and inst355  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_259, D0, D2, D3, RD, _net_260, SI);
not inst356  (_net_261, D1);
not inst357  (_net_262, SI);
and inst358  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_261, D0, D2, D3, RD, SE, _net_262);
not inst359  (_net_263, D1);
and inst360  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_263, D0, D2, D3, RD, SE, SI);
not inst361  (_net_264, RD);
not inst362  (_net_265, SE);
not inst363  (_net_266, SI);
and inst364  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, _net_264, _net_265, _net_266);
not inst365  (_net_267, RD);
not inst366  (_net_268, SE);
and inst367  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, D1, D0, D2, D3, _net_267, _net_268, SI);
not inst368  (_net_269, RD);
not inst369  (_net_270, SI);
and inst370  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, D1, D0, D2, D3, _net_269, SE, _net_270);
not inst371  (_net_271, RD);
and inst372  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI, D1, D0, D2, D3, _net_271, SE, SI);
not inst373  (_net_272, SE);
not inst374  (_net_273, SI);
and inst375  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, RD, _net_272, _net_273);
not inst376  (_net_274, SE);
and inst377  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, D1, D0, D2, D3, RD, _net_274, SI);
not inst378  (_net_275, SI);
and inst379  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, D1, D0, D2, D3, RD, SE, _net_275);
and inst380  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, D1, D0, D2, D3, RD, SE, SI);
not inst381  (_net_276, D1);
not inst382  (_net_277, D0);
not inst383  (_net_278, D2);
not inst384  (_net_279, SE);
not inst385  (_net_280, SI);
and inst386  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_276, _net_277, _net_278, D3, _net_279, _net_280);
not inst387  (_net_281, D1);
not inst388  (_net_282, D0);
not inst389  (_net_283, D2);
not inst390  (_net_284, SE);
and inst391  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_281, _net_282, _net_283, D3, _net_284, SI);
not inst392  (_net_285, D1);
not inst393  (_net_286, D0);
not inst394  (_net_287, D3);
not inst395  (_net_288, SE);
not inst396  (_net_289, SI);
and inst397  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_285, _net_286, D2, _net_287, _net_288, _net_289);
not inst398  (_net_290, D1);
not inst399  (_net_291, D0);
not inst400  (_net_292, D3);
not inst401  (_net_293, SE);
and inst402  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_290, _net_291, D2, _net_292, _net_293, SI);
not inst403  (_net_294, D0);
not inst404  (_net_295, D2);
not inst405  (_net_296, D3);
not inst406  (_net_297, SE);
not inst407  (_net_298, SI);
and inst408  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_294, _net_295, _net_296, _net_297, _net_298);
not inst409  (_net_299, D0);
not inst410  (_net_300, D2);
not inst411  (_net_301, D3);
not inst412  (_net_302, SE);
and inst413  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_299, _net_300, _net_301, _net_302, SI);
not inst414  (_net_303, D1);
not inst415  (_net_304, D2);
not inst416  (_net_305, D3);
not inst417  (_net_306, SE);
not inst418  (_net_307, SI);
and inst419  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_303, D0, _net_304, _net_305, _net_306, _net_307);
not inst420  (_net_308, D1);
not inst421  (_net_309, D2);
not inst422  (_net_310, D3);
not inst423  (_net_311, SE);
and inst424  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_308, D0, _net_309, _net_310, _net_311, SI);
not inst425  (_net_312, D1);
not inst426  (_net_313, D0);
not inst427  (_net_314, D2);
not inst428  (_net_315, D3);
not inst429  (_net_316, RD);
and inst430  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI, _net_312, _net_313, _net_314, _net_315, _net_316, SI);
not inst431  (_net_317, D1);
not inst432  (_net_318, D0);
not inst433  (_net_319, D2);
not inst434  (_net_320, D3);
and inst435  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI, _net_317, _net_318, _net_319, _net_320, RD, SI);
not inst436  (_net_321, D1);
not inst437  (_net_322, D0);
not inst438  (_net_323, D2);
not inst439  (_net_324, SI);
and inst440  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI, _net_321, _net_322, _net_323, D3, RD, _net_324);
not inst441  (_net_325, D1);
not inst442  (_net_326, D0);
not inst443  (_net_327, D3);
not inst444  (_net_328, SI);
and inst445  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, _net_325, _net_326, D2, _net_327, RD, _net_328);
not inst446  (_net_329, D0);
not inst447  (_net_330, D2);
not inst448  (_net_331, D3);
not inst449  (_net_332, SI);
and inst450  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, D1, _net_329, _net_330, _net_331, RD, _net_332);
not inst451  (_net_333, D1);
not inst452  (_net_334, D2);
not inst453  (_net_335, D3);
not inst454  (_net_336, SI);
and inst455  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, _net_333, D0, _net_334, _net_335, RD, _net_336);
not inst456  (_net_337, RD);
and inst457  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI, D1, D0, D2, D3, _net_337, SI);
not inst458  (_net_338, RD);
not inst459  (_net_339, D0);
and inst460  (ENABLE_NOT_D0_AND_NOT_RD_AND_SE, _net_338, _net_339, SE);
not inst461  (_net_340, D0);
and inst462  (ENABLE_NOT_D0_AND_RD_AND_SE, RD, _net_340, SE);
not inst463  (_net_341, RD);
and inst464  (ENABLE_D0_AND_NOT_RD_AND_SE, _net_341, D0, SE);
and inst465  (ENABLE_D0_AND_RD_AND_SE, RD, D0, SE);
not inst466  (_net_342, SE);
not inst467  (_net_343, SI);
and inst468  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_342, RD, _net_343);
not inst469  (_net_344, SE);
and inst470  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_344, RD, SI);

specify
if (D0==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK , 0 ,0, viol_0);
$width(negedge CK , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK , posedge RD , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK , negedge RD , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT08_FSDPSYNRBQM4SS_PPV2Y8_1

//%BEGIN HDBSVT08_FSDPSYNRBQM4SS_PPV2Y8_2

`celldefine
module HDBSVT08_FSDPSYNRBQM4SS_PPV2Y8_2 (Q0, Q1, Q2, Q3, CK, D0, D1, D2, D3, SI, SE, RD);
   output Q0, Q1, Q2, Q3;
   input CK, D0, D1, D2, D3, SI, SE, RD;

   reg viol_0, viol_1, viol_2, viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE, delayed_RD;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res__RD0, int_res__RD1, int_res__RD2, int_res__RD3, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
   buf inst7  (delayed_RD, RD);
`endif
   not inst8  (int_res__RD, delayed_RD);

   and inst9  (int_res__RD0, delayed_D0, delayed_RD);
   and inst10  (int_res__RD1, delayed_D1, delayed_RD);
   and inst11  (int_res__RD2, delayed_D2, delayed_RD);
   and inst12  (int_res__RD3, delayed_D3, delayed_RD);
   

   snps_mux2 inst13  (int_res__D0, delayed_SI, int_res__RD0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst14  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst15  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst16  (int_res__D1, int_res_iq0, int_res__RD1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst17  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst18  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst19  (int_res__D2, int_res_iq1, int_res__RD2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst20  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst21  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst22  (int_res__D3, int_res_iq2, int_res__RD3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst23  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst24  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst25 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst26 (Q1, int_res_iq1);
        buf #`SNPS_SEQ_DELAY  inst27 (Q2, int_res_iq2);
        buf #`SNPS_SEQ_DELAY  inst28 (Q3, int_res_iq3);
   `else
        buf inst29  (Q0, int_res_iq0);
        buf inst30  (Q1, int_res_iq1);
        buf inst31  (Q2, int_res_iq2);
        buf inst32  (Q3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst33  (_net_0, D1);
not inst34  (_net_1, D0);
not inst35  (_net_2, D2);
not inst36  (_net_3, D3);
not inst37  (_net_4, RD);
not inst38  (_net_5, SE);
not inst39  (_net_6, SI);
and inst40  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5, _net_6);
not inst41  (_net_7, D1);
not inst42  (_net_8, D0);
not inst43  (_net_9, D2);
not inst44  (_net_10, D3);
not inst45  (_net_11, RD);
not inst46  (_net_12, SE);
and inst47  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_7, _net_8, _net_9, _net_10, _net_11, _net_12, SI);
not inst48  (_net_13, D1);
not inst49  (_net_14, D0);
not inst50  (_net_15, D2);
not inst51  (_net_16, D3);
not inst52  (_net_17, RD);
not inst53  (_net_18, SI);
and inst54  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_13, _net_14, _net_15, _net_16, _net_17, SE, _net_18);
not inst55  (_net_19, D1);
not inst56  (_net_20, D0);
not inst57  (_net_21, D2);
not inst58  (_net_22, D3);
not inst59  (_net_23, RD);
and inst60  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, _net_19, _net_20, _net_21, _net_22, _net_23, SE, SI);
not inst61  (_net_24, D1);
not inst62  (_net_25, D0);
not inst63  (_net_26, D2);
not inst64  (_net_27, D3);
not inst65  (_net_28, SE);
not inst66  (_net_29, SI);
and inst67  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_24, _net_25, _net_26, _net_27, RD, _net_28, _net_29);
not inst68  (_net_30, D1);
not inst69  (_net_31, D0);
not inst70  (_net_32, D2);
not inst71  (_net_33, D3);
not inst72  (_net_34, SE);
and inst73  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_30, _net_31, _net_32, _net_33, RD, _net_34, SI);
not inst74  (_net_35, D1);
not inst75  (_net_36, D0);
not inst76  (_net_37, D2);
not inst77  (_net_38, D3);
not inst78  (_net_39, SI);
and inst79  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_35, _net_36, _net_37, _net_38, RD, SE, _net_39);
not inst80  (_net_40, D1);
not inst81  (_net_41, D0);
not inst82  (_net_42, D2);
not inst83  (_net_43, D3);
and inst84  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_40, _net_41, _net_42, _net_43, RD, SE, SI);
not inst85  (_net_44, D1);
not inst86  (_net_45, D0);
not inst87  (_net_46, D2);
not inst88  (_net_47, RD);
not inst89  (_net_48, SE);
not inst90  (_net_49, SI);
and inst91  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_44, _net_45, _net_46, D3, _net_47, _net_48, _net_49);
not inst92  (_net_50, D1);
not inst93  (_net_51, D0);
not inst94  (_net_52, D2);
not inst95  (_net_53, RD);
not inst96  (_net_54, SE);
and inst97  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_50, _net_51, _net_52, D3, _net_53, _net_54, SI);
not inst98  (_net_55, D1);
not inst99  (_net_56, D0);
not inst100  (_net_57, D2);
not inst101  (_net_58, RD);
not inst102  (_net_59, SI);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_55, _net_56, _net_57, D3, _net_58, SE, _net_59);
not inst104  (_net_60, D1);
not inst105  (_net_61, D0);
not inst106  (_net_62, D2);
not inst107  (_net_63, RD);
and inst108  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI, _net_60, _net_61, _net_62, D3, _net_63, SE, SI);
not inst109  (_net_64, D1);
not inst110  (_net_65, D0);
not inst111  (_net_66, D2);
not inst112  (_net_67, SE);
not inst113  (_net_68, SI);
and inst114  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_64, _net_65, _net_66, D3, RD, _net_67, _net_68);
not inst115  (_net_69, D1);
not inst116  (_net_70, D0);
not inst117  (_net_71, D2);
not inst118  (_net_72, SE);
and inst119  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_69, _net_70, _net_71, D3, RD, _net_72, SI);
not inst120  (_net_73, D1);
not inst121  (_net_74, D0);
not inst122  (_net_75, D2);
not inst123  (_net_76, SI);
and inst124  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_73, _net_74, _net_75, D3, RD, SE, _net_76);
not inst125  (_net_77, D1);
not inst126  (_net_78, D0);
not inst127  (_net_79, D2);
and inst128  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_77, _net_78, _net_79, D3, RD, SE, SI);
not inst129  (_net_80, D1);
not inst130  (_net_81, D0);
not inst131  (_net_82, D3);
not inst132  (_net_83, RD);
not inst133  (_net_84, SE);
not inst134  (_net_85, SI);
and inst135  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_80, _net_81, D2, _net_82, _net_83, _net_84, _net_85);
not inst136  (_net_86, D1);
not inst137  (_net_87, D0);
not inst138  (_net_88, D3);
not inst139  (_net_89, RD);
not inst140  (_net_90, SE);
and inst141  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_86, _net_87, D2, _net_88, _net_89, _net_90, SI);
not inst142  (_net_91, D1);
not inst143  (_net_92, D0);
not inst144  (_net_93, D3);
not inst145  (_net_94, RD);
not inst146  (_net_95, SI);
and inst147  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_91, _net_92, D2, _net_93, _net_94, SE, _net_95);
not inst148  (_net_96, D1);
not inst149  (_net_97, D0);
not inst150  (_net_98, D3);
not inst151  (_net_99, RD);
and inst152  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, _net_96, _net_97, D2, _net_98, _net_99, SE, SI);
not inst153  (_net_100, D1);
not inst154  (_net_101, D0);
not inst155  (_net_102, D3);
not inst156  (_net_103, SE);
not inst157  (_net_104, SI);
and inst158  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_100, _net_101, D2, _net_102, RD, _net_103, _net_104);
not inst159  (_net_105, D1);
not inst160  (_net_106, D0);
not inst161  (_net_107, D3);
not inst162  (_net_108, SE);
and inst163  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_105, _net_106, D2, _net_107, RD, _net_108, SI);
not inst164  (_net_109, D1);
not inst165  (_net_110, D0);
not inst166  (_net_111, D3);
not inst167  (_net_112, SI);
and inst168  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_109, _net_110, D2, _net_111, RD, SE, _net_112);
not inst169  (_net_113, D1);
not inst170  (_net_114, D0);
not inst171  (_net_115, D3);
and inst172  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_113, _net_114, D2, _net_115, RD, SE, SI);
not inst173  (_net_116, D1);
not inst174  (_net_117, D0);
not inst175  (_net_118, RD);
not inst176  (_net_119, SE);
not inst177  (_net_120, SI);
and inst178  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_116, _net_117, D2, D3, _net_118, _net_119, _net_120);
not inst179  (_net_121, D1);
not inst180  (_net_122, D0);
not inst181  (_net_123, RD);
not inst182  (_net_124, SE);
and inst183  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_121, _net_122, D2, D3, _net_123, _net_124, SI);
not inst184  (_net_125, D1);
not inst185  (_net_126, D0);
not inst186  (_net_127, RD);
not inst187  (_net_128, SI);
and inst188  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_125, _net_126, D2, D3, _net_127, SE, _net_128);
not inst189  (_net_129, D1);
not inst190  (_net_130, D0);
not inst191  (_net_131, RD);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI, _net_129, _net_130, D2, D3, _net_131, SE, SI);
not inst193  (_net_132, D1);
not inst194  (_net_133, D0);
not inst195  (_net_134, SE);
not inst196  (_net_135, SI);
and inst197  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_132, _net_133, D2, D3, RD, _net_134, _net_135);
not inst198  (_net_136, D1);
not inst199  (_net_137, D0);
not inst200  (_net_138, SE);
and inst201  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_136, _net_137, D2, D3, RD, _net_138, SI);
not inst202  (_net_139, D1);
not inst203  (_net_140, D0);
not inst204  (_net_141, SI);
and inst205  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_139, _net_140, D2, D3, RD, SE, _net_141);
not inst206  (_net_142, D1);
not inst207  (_net_143, D0);
and inst208  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_142, _net_143, D2, D3, RD, SE, SI);
not inst209  (_net_144, D0);
not inst210  (_net_145, D2);
not inst211  (_net_146, D3);
not inst212  (_net_147, RD);
not inst213  (_net_148, SE);
not inst214  (_net_149, SI);
and inst215  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_144, _net_145, _net_146, _net_147, _net_148, _net_149);
not inst216  (_net_150, D0);
not inst217  (_net_151, D2);
not inst218  (_net_152, D3);
not inst219  (_net_153, RD);
not inst220  (_net_154, SE);
and inst221  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, D1, _net_150, _net_151, _net_152, _net_153, _net_154, SI);
not inst222  (_net_155, D0);
not inst223  (_net_156, D2);
not inst224  (_net_157, D3);
not inst225  (_net_158, RD);
not inst226  (_net_159, SI);
and inst227  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, D1, _net_155, _net_156, _net_157, _net_158, SE, _net_159);
not inst228  (_net_160, D0);
not inst229  (_net_161, D2);
not inst230  (_net_162, D3);
not inst231  (_net_163, RD);
and inst232  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, D1, _net_160, _net_161, _net_162, _net_163, SE, SI);
not inst233  (_net_164, D0);
not inst234  (_net_165, D2);
not inst235  (_net_166, D3);
not inst236  (_net_167, SE);
not inst237  (_net_168, SI);
and inst238  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_164, _net_165, _net_166, RD, _net_167, _net_168);
not inst239  (_net_169, D0);
not inst240  (_net_170, D2);
not inst241  (_net_171, D3);
not inst242  (_net_172, SE);
and inst243  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, D1, _net_169, _net_170, _net_171, RD, _net_172, SI);
not inst244  (_net_173, D0);
not inst245  (_net_174, D2);
not inst246  (_net_175, D3);
not inst247  (_net_176, SI);
and inst248  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, D1, _net_173, _net_174, _net_175, RD, SE, _net_176);
not inst249  (_net_177, D0);
not inst250  (_net_178, D2);
not inst251  (_net_179, D3);
and inst252  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, D1, _net_177, _net_178, _net_179, RD, SE, SI);
not inst253  (_net_180, D1);
not inst254  (_net_181, D2);
not inst255  (_net_182, D3);
not inst256  (_net_183, RD);
not inst257  (_net_184, SE);
not inst258  (_net_185, SI);
and inst259  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_180, D0, _net_181, _net_182, _net_183, _net_184, _net_185);
not inst260  (_net_186, D1);
not inst261  (_net_187, D2);
not inst262  (_net_188, D3);
not inst263  (_net_189, RD);
not inst264  (_net_190, SE);
and inst265  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_186, D0, _net_187, _net_188, _net_189, _net_190, SI);
not inst266  (_net_191, D1);
not inst267  (_net_192, D2);
not inst268  (_net_193, D3);
not inst269  (_net_194, RD);
not inst270  (_net_195, SI);
and inst271  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_191, D0, _net_192, _net_193, _net_194, SE, _net_195);
not inst272  (_net_196, D1);
not inst273  (_net_197, D2);
not inst274  (_net_198, D3);
not inst275  (_net_199, RD);
and inst276  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, _net_196, D0, _net_197, _net_198, _net_199, SE, SI);
not inst277  (_net_200, D1);
not inst278  (_net_201, D2);
not inst279  (_net_202, D3);
not inst280  (_net_203, SE);
not inst281  (_net_204, SI);
and inst282  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_200, D0, _net_201, _net_202, RD, _net_203, _net_204);
not inst283  (_net_205, D1);
not inst284  (_net_206, D2);
not inst285  (_net_207, D3);
not inst286  (_net_208, SE);
and inst287  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_205, D0, _net_206, _net_207, RD, _net_208, SI);
not inst288  (_net_209, D1);
not inst289  (_net_210, D2);
not inst290  (_net_211, D3);
not inst291  (_net_212, SI);
and inst292  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_209, D0, _net_210, _net_211, RD, SE, _net_212);
not inst293  (_net_213, D1);
not inst294  (_net_214, D2);
not inst295  (_net_215, D3);
and inst296  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_213, D0, _net_214, _net_215, RD, SE, SI);
not inst297  (_net_216, D1);
not inst298  (_net_217, D3);
not inst299  (_net_218, RD);
not inst300  (_net_219, SE);
not inst301  (_net_220, SI);
and inst302  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_216, D0, D2, _net_217, _net_218, _net_219, _net_220);
not inst303  (_net_221, D1);
not inst304  (_net_222, D3);
not inst305  (_net_223, RD);
not inst306  (_net_224, SE);
and inst307  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_221, D0, D2, _net_222, _net_223, _net_224, SI);
not inst308  (_net_225, D1);
not inst309  (_net_226, D3);
not inst310  (_net_227, RD);
not inst311  (_net_228, SI);
and inst312  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_225, D0, D2, _net_226, _net_227, SE, _net_228);
not inst313  (_net_229, D1);
not inst314  (_net_230, D3);
not inst315  (_net_231, RD);
and inst316  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, _net_229, D0, D2, _net_230, _net_231, SE, SI);
not inst317  (_net_232, D1);
not inst318  (_net_233, D3);
not inst319  (_net_234, SE);
not inst320  (_net_235, SI);
and inst321  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_232, D0, D2, _net_233, RD, _net_234, _net_235);
not inst322  (_net_236, D1);
not inst323  (_net_237, D3);
not inst324  (_net_238, SE);
and inst325  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_236, D0, D2, _net_237, RD, _net_238, SI);
not inst326  (_net_239, D1);
not inst327  (_net_240, D3);
not inst328  (_net_241, SI);
and inst329  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_239, D0, D2, _net_240, RD, SE, _net_241);
not inst330  (_net_242, D1);
not inst331  (_net_243, D3);
and inst332  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_242, D0, D2, _net_243, RD, SE, SI);
not inst333  (_net_244, D1);
not inst334  (_net_245, RD);
not inst335  (_net_246, SE);
not inst336  (_net_247, SI);
and inst337  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_244, D0, D2, D3, _net_245, _net_246, _net_247);
not inst338  (_net_248, D1);
not inst339  (_net_249, RD);
not inst340  (_net_250, SE);
and inst341  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_248, D0, D2, D3, _net_249, _net_250, SI);
not inst342  (_net_251, D1);
not inst343  (_net_252, RD);
not inst344  (_net_253, SI);
and inst345  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_251, D0, D2, D3, _net_252, SE, _net_253);
not inst346  (_net_254, D1);
not inst347  (_net_255, RD);
and inst348  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI, _net_254, D0, D2, D3, _net_255, SE, SI);
not inst349  (_net_256, D1);
not inst350  (_net_257, SE);
not inst351  (_net_258, SI);
and inst352  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_256, D0, D2, D3, RD, _net_257, _net_258);
not inst353  (_net_259, D1);
not inst354  (_net_260, SE);
and inst355  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_259, D0, D2, D3, RD, _net_260, SI);
not inst356  (_net_261, D1);
not inst357  (_net_262, SI);
and inst358  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_261, D0, D2, D3, RD, SE, _net_262);
not inst359  (_net_263, D1);
and inst360  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_263, D0, D2, D3, RD, SE, SI);
not inst361  (_net_264, RD);
not inst362  (_net_265, SE);
not inst363  (_net_266, SI);
and inst364  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, _net_264, _net_265, _net_266);
not inst365  (_net_267, RD);
not inst366  (_net_268, SE);
and inst367  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, D1, D0, D2, D3, _net_267, _net_268, SI);
not inst368  (_net_269, RD);
not inst369  (_net_270, SI);
and inst370  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, D1, D0, D2, D3, _net_269, SE, _net_270);
not inst371  (_net_271, RD);
and inst372  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI, D1, D0, D2, D3, _net_271, SE, SI);
not inst373  (_net_272, SE);
not inst374  (_net_273, SI);
and inst375  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, RD, _net_272, _net_273);
not inst376  (_net_274, SE);
and inst377  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, D1, D0, D2, D3, RD, _net_274, SI);
not inst378  (_net_275, SI);
and inst379  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, D1, D0, D2, D3, RD, SE, _net_275);
and inst380  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, D1, D0, D2, D3, RD, SE, SI);
not inst381  (_net_276, D1);
not inst382  (_net_277, D0);
not inst383  (_net_278, D2);
not inst384  (_net_279, SE);
not inst385  (_net_280, SI);
and inst386  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_276, _net_277, _net_278, D3, _net_279, _net_280);
not inst387  (_net_281, D1);
not inst388  (_net_282, D0);
not inst389  (_net_283, D2);
not inst390  (_net_284, SE);
and inst391  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_281, _net_282, _net_283, D3, _net_284, SI);
not inst392  (_net_285, D1);
not inst393  (_net_286, D0);
not inst394  (_net_287, D3);
not inst395  (_net_288, SE);
not inst396  (_net_289, SI);
and inst397  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_285, _net_286, D2, _net_287, _net_288, _net_289);
not inst398  (_net_290, D1);
not inst399  (_net_291, D0);
not inst400  (_net_292, D3);
not inst401  (_net_293, SE);
and inst402  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_290, _net_291, D2, _net_292, _net_293, SI);
not inst403  (_net_294, D0);
not inst404  (_net_295, D2);
not inst405  (_net_296, D3);
not inst406  (_net_297, SE);
not inst407  (_net_298, SI);
and inst408  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_294, _net_295, _net_296, _net_297, _net_298);
not inst409  (_net_299, D0);
not inst410  (_net_300, D2);
not inst411  (_net_301, D3);
not inst412  (_net_302, SE);
and inst413  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_299, _net_300, _net_301, _net_302, SI);
not inst414  (_net_303, D1);
not inst415  (_net_304, D2);
not inst416  (_net_305, D3);
not inst417  (_net_306, SE);
not inst418  (_net_307, SI);
and inst419  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_303, D0, _net_304, _net_305, _net_306, _net_307);
not inst420  (_net_308, D1);
not inst421  (_net_309, D2);
not inst422  (_net_310, D3);
not inst423  (_net_311, SE);
and inst424  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_308, D0, _net_309, _net_310, _net_311, SI);
not inst425  (_net_312, D1);
not inst426  (_net_313, D0);
not inst427  (_net_314, D2);
not inst428  (_net_315, D3);
not inst429  (_net_316, RD);
and inst430  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI, _net_312, _net_313, _net_314, _net_315, _net_316, SI);
not inst431  (_net_317, D1);
not inst432  (_net_318, D0);
not inst433  (_net_319, D2);
not inst434  (_net_320, D3);
and inst435  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI, _net_317, _net_318, _net_319, _net_320, RD, SI);
not inst436  (_net_321, D1);
not inst437  (_net_322, D0);
not inst438  (_net_323, D2);
not inst439  (_net_324, SI);
and inst440  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI, _net_321, _net_322, _net_323, D3, RD, _net_324);
not inst441  (_net_325, D1);
not inst442  (_net_326, D0);
not inst443  (_net_327, D3);
not inst444  (_net_328, SI);
and inst445  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, _net_325, _net_326, D2, _net_327, RD, _net_328);
not inst446  (_net_329, D0);
not inst447  (_net_330, D2);
not inst448  (_net_331, D3);
not inst449  (_net_332, SI);
and inst450  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, D1, _net_329, _net_330, _net_331, RD, _net_332);
not inst451  (_net_333, D1);
not inst452  (_net_334, D2);
not inst453  (_net_335, D3);
not inst454  (_net_336, SI);
and inst455  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, _net_333, D0, _net_334, _net_335, RD, _net_336);
not inst456  (_net_337, RD);
and inst457  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI, D1, D0, D2, D3, _net_337, SI);
not inst458  (_net_338, RD);
not inst459  (_net_339, D0);
and inst460  (ENABLE_NOT_D0_AND_NOT_RD_AND_SE, _net_338, _net_339, SE);
not inst461  (_net_340, D0);
and inst462  (ENABLE_NOT_D0_AND_RD_AND_SE, RD, _net_340, SE);
not inst463  (_net_341, RD);
and inst464  (ENABLE_D0_AND_NOT_RD_AND_SE, _net_341, D0, SE);
and inst465  (ENABLE_D0_AND_RD_AND_SE, RD, D0, SE);
not inst466  (_net_342, SE);
not inst467  (_net_343, SI);
and inst468  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_342, RD, _net_343);
not inst469  (_net_344, SE);
and inst470  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_344, RD, SI);

specify
if (D0==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK , 0 ,0, viol_0);
$width(negedge CK , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK , posedge RD , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK , negedge RD , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT08_FSDPSYNRBQM4SS_PPV2Y8_2

//%BEGIN HDBSVT08_FSDPSYNRBQ_PPV2Y2_1

`celldefine
module HDBSVT08_FSDPSYNRBQ_PPV2Y2_1 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   and inst5  (int_res__D, delayed_D, delayed_RD);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   
   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `else
      snps_dff inst9  (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst10  (_net_0, RD);
not inst11  (_net_1, D);
not inst12  (_net_2, SE);
not inst13  (_net_3, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst15  (_net_4, RD);
not inst16  (_net_5, D);
not inst17  (_net_6, SE);
and inst18  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst19  (_net_7, RD);
not inst20  (_net_8, D);
not inst21  (_net_9, SI);
and inst22  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst23  (_net_10, RD);
not inst24  (_net_11, D);
and inst25  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst26  (_net_12, D);
not inst27  (_net_13, SE);
not inst28  (_net_14, SI);
and inst29  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_12, _net_13, _net_14);
not inst30  (_net_15, D);
not inst31  (_net_16, SE);
and inst32  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_15, _net_16, SI);
not inst33  (_net_17, D);
not inst34  (_net_18, SI);
and inst35  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_17, SE, _net_18);
not inst36  (_net_19, D);
and inst37  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_19, SE, SI);
not inst38  (_net_20, RD);
not inst39  (_net_21, SE);
not inst40  (_net_22, SI);
and inst41  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst42  (_net_23, RD);
not inst43  (_net_24, SE);
and inst44  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst45  (_net_25, RD);
not inst46  (_net_26, SI);
and inst47  (ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst48  (_net_27, RD);
and inst49  (ENABLE_D_AND_NOT_RD_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst50  (_net_28, SE);
not inst51  (_net_29, SI);
and inst52  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_28, _net_29);
not inst53  (_net_30, SE);
and inst54  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_30, SI);
not inst55  (_net_31, SI);
and inst56  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_31);
and inst57  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst58  (_net_32, SE);
not inst59  (_net_33, SI);
and inst60  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_32, RD, _net_33);
not inst61  (_net_34, SE);
and inst62  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_34, RD, SI);
not inst63  (_net_35, SE);
not inst64  (_net_36, SI);
and inst65  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_35, D, _net_36);
not inst66  (_net_37, SE);
and inst67  (ENABLE_D_AND_NOT_SE_AND_SI, _net_37, D, SI);
not inst68  (_net_38, RD);
not inst69  (_net_39, D);
and inst70  (ENABLE_NOT_D_AND_NOT_RD_AND_SI, _net_38, _net_39, SI);
not inst71  (_net_40, D);
and inst72  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_40, SI);
not inst73  (_net_41, RD);
and inst74  (ENABLE_D_AND_NOT_RD_AND_SI, _net_41, D, SI);
not inst75  (_net_42, SI);
and inst76  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_42);
not inst77  (_net_43, RD);
not inst78  (_net_44, D);
and inst79  (ENABLE_NOT_D_AND_NOT_RD_AND_SE, _net_43, _net_44, SE);
not inst80  (_net_45, D);
and inst81  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_45, SE);
not inst82  (_net_46, RD);
and inst83  (ENABLE_D_AND_NOT_RD_AND_SE, _net_46, D, SE);
and inst84  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif   
endmodule
`endcelldefine

//%END HDBSVT08_FSDPSYNRBQ_PPV2Y2_1

//%BEGIN HDBSVT08_FSDPSYNRBQ_PPV2Y2_2

`celldefine
module HDBSVT08_FSDPSYNRBQ_PPV2Y2_2 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   and inst5  (int_res__D, delayed_D, delayed_RD);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   
   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `else
      snps_dff inst9  (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst10  (_net_0, RD);
not inst11  (_net_1, D);
not inst12  (_net_2, SE);
not inst13  (_net_3, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst15  (_net_4, RD);
not inst16  (_net_5, D);
not inst17  (_net_6, SE);
and inst18  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst19  (_net_7, RD);
not inst20  (_net_8, D);
not inst21  (_net_9, SI);
and inst22  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst23  (_net_10, RD);
not inst24  (_net_11, D);
and inst25  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst26  (_net_12, D);
not inst27  (_net_13, SE);
not inst28  (_net_14, SI);
and inst29  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_12, _net_13, _net_14);
not inst30  (_net_15, D);
not inst31  (_net_16, SE);
and inst32  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_15, _net_16, SI);
not inst33  (_net_17, D);
not inst34  (_net_18, SI);
and inst35  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_17, SE, _net_18);
not inst36  (_net_19, D);
and inst37  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_19, SE, SI);
not inst38  (_net_20, RD);
not inst39  (_net_21, SE);
not inst40  (_net_22, SI);
and inst41  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst42  (_net_23, RD);
not inst43  (_net_24, SE);
and inst44  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst45  (_net_25, RD);
not inst46  (_net_26, SI);
and inst47  (ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst48  (_net_27, RD);
and inst49  (ENABLE_D_AND_NOT_RD_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst50  (_net_28, SE);
not inst51  (_net_29, SI);
and inst52  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_28, _net_29);
not inst53  (_net_30, SE);
and inst54  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_30, SI);
not inst55  (_net_31, SI);
and inst56  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_31);
and inst57  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst58  (_net_32, SE);
not inst59  (_net_33, SI);
and inst60  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_32, RD, _net_33);
not inst61  (_net_34, SE);
and inst62  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_34, RD, SI);
not inst63  (_net_35, SE);
not inst64  (_net_36, SI);
and inst65  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_35, D, _net_36);
not inst66  (_net_37, SE);
and inst67  (ENABLE_D_AND_NOT_SE_AND_SI, _net_37, D, SI);
not inst68  (_net_38, RD);
not inst69  (_net_39, D);
and inst70  (ENABLE_NOT_D_AND_NOT_RD_AND_SI, _net_38, _net_39, SI);
not inst71  (_net_40, D);
and inst72  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_40, SI);
not inst73  (_net_41, RD);
and inst74  (ENABLE_D_AND_NOT_RD_AND_SI, _net_41, D, SI);
not inst75  (_net_42, SI);
and inst76  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_42);
not inst77  (_net_43, RD);
not inst78  (_net_44, D);
and inst79  (ENABLE_NOT_D_AND_NOT_RD_AND_SE, _net_43, _net_44, SE);
not inst80  (_net_45, D);
and inst81  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_45, SE);
not inst82  (_net_46, RD);
and inst83  (ENABLE_D_AND_NOT_RD_AND_SE, _net_46, D, SE);
and inst84  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif   
endmodule
`endcelldefine

//%END HDBSVT08_FSDPSYNRBQ_PPV2Y2_2

//%BEGIN HDBSVT08_FSDPSYNRBQ_PPV2Y2_4

`celldefine
module HDBSVT08_FSDPSYNRBQ_PPV2Y2_4 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   and inst5  (int_res__D, delayed_D, delayed_RD);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   
   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `else
      snps_dff inst9  (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst10  (_net_0, RD);
not inst11  (_net_1, D);
not inst12  (_net_2, SE);
not inst13  (_net_3, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst15  (_net_4, RD);
not inst16  (_net_5, D);
not inst17  (_net_6, SE);
and inst18  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst19  (_net_7, RD);
not inst20  (_net_8, D);
not inst21  (_net_9, SI);
and inst22  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst23  (_net_10, RD);
not inst24  (_net_11, D);
and inst25  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst26  (_net_12, D);
not inst27  (_net_13, SE);
not inst28  (_net_14, SI);
and inst29  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_12, _net_13, _net_14);
not inst30  (_net_15, D);
not inst31  (_net_16, SE);
and inst32  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_15, _net_16, SI);
not inst33  (_net_17, D);
not inst34  (_net_18, SI);
and inst35  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_17, SE, _net_18);
not inst36  (_net_19, D);
and inst37  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_19, SE, SI);
not inst38  (_net_20, RD);
not inst39  (_net_21, SE);
not inst40  (_net_22, SI);
and inst41  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst42  (_net_23, RD);
not inst43  (_net_24, SE);
and inst44  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst45  (_net_25, RD);
not inst46  (_net_26, SI);
and inst47  (ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst48  (_net_27, RD);
and inst49  (ENABLE_D_AND_NOT_RD_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst50  (_net_28, SE);
not inst51  (_net_29, SI);
and inst52  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_28, _net_29);
not inst53  (_net_30, SE);
and inst54  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_30, SI);
not inst55  (_net_31, SI);
and inst56  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_31);
and inst57  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst58  (_net_32, SE);
not inst59  (_net_33, SI);
and inst60  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_32, RD, _net_33);
not inst61  (_net_34, SE);
and inst62  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_34, RD, SI);
not inst63  (_net_35, SE);
not inst64  (_net_36, SI);
and inst65  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_35, D, _net_36);
not inst66  (_net_37, SE);
and inst67  (ENABLE_D_AND_NOT_SE_AND_SI, _net_37, D, SI);
not inst68  (_net_38, RD);
not inst69  (_net_39, D);
and inst70  (ENABLE_NOT_D_AND_NOT_RD_AND_SI, _net_38, _net_39, SI);
not inst71  (_net_40, D);
and inst72  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_40, SI);
not inst73  (_net_41, RD);
and inst74  (ENABLE_D_AND_NOT_RD_AND_SI, _net_41, D, SI);
not inst75  (_net_42, SI);
and inst76  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_42);
not inst77  (_net_43, RD);
not inst78  (_net_44, D);
and inst79  (ENABLE_NOT_D_AND_NOT_RD_AND_SE, _net_43, _net_44, SE);
not inst80  (_net_45, D);
and inst81  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_45, SE);
not inst82  (_net_46, RD);
and inst83  (ENABLE_D_AND_NOT_RD_AND_SE, _net_46, D, SE);
and inst84  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif   
endmodule
`endcelldefine

//%END HDBSVT08_FSDPSYNRBQ_PPV2Y2_4

