//----------------------------------------------------------------------------
// Date		: $Date$
// Copyright	: 1997-2017 by Synopsys, Inc., All Rights Reserved.
// Revision	: $Revision$
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// Cell model definitions.
//----------------------------------------------------------------------------



`timescale 1ps / 1ps

`ifndef SNPS_SEQ_DELAY
`define SNPS_SEQ_DELAY 10
`endif
`ifndef SNPS_COMBO_DELAY
`define SNPS_COMBO_DELAY 0 
`endif
`ifndef SNPS_CKGT_DELAY
`define SNPS_CKGT_DELAY 0
`endif
`ifndef SNPS_CKGTLT_DELAY
`define SNPS_CKGTLT_DELAY 0
`endif
`ifndef SNPS_LAT_DELAY
`define SNPS_LAT_DELAY 10
`endif

`ifdef VIRL_functiononly
    `delay_mode_distributed
    `define _fv
    `define SNPS_MASK_X_OUT_LATCH
    `define SNPS_MASK_ERR_UDP
`else
    `delay_mode_path
`endif

//%BEGIN HDBSVT11_ADDF_CBV1Y2_1

`celldefine
module HDBSVT11_ADDF_CBV1Y2_1 (S, CO, A, B, CI);
   output S, CO;
   input A, B, CI;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A, B);
   and inst1  (int_res_1, A, CI);
   and inst2  (int_res_2, B, CI);
   `ifdef VIRL_functiononly
      xor #`SNPS_COMBO_DELAY  inst3 (S, A, B, CI);
      or #`SNPS_COMBO_DELAY  inst4 (CO, int_res_0, int_res_1, int_res_2);
   `else
      xor inst5  (S, A, B, CI);
      or inst6  (CO, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (B==1'b0 && CI==1'b1) (A +=> CO)=(0, 0);
if (B==1'b1 && CI==1'b0) (A +=> CO)=(0, 0);
if (A==1'b0 && CI==1'b1) (B +=> CO)=(0, 0);
if (A==1'b1 && CI==1'b0) (B +=> CO)=(0, 0);
if (A==1'b0 && B==1'b1) (CI +=> CO)=(0, 0);
if (A==1'b1 && B==1'b0) (CI +=> CO)=(0, 0);
if (B==1'b0 && CI==1'b1) (A -=> S)=(0, 0);
if (B==1'b1 && CI==1'b0) (A -=> S)=(0, 0);
if (B==1'b0 && CI==1'b0) (A +=> S)=(0, 0);
if (B==1'b1 && CI==1'b1) (A +=> S)=(0, 0);
if (A==1'b0 && CI==1'b1) (B -=> S)=(0, 0);
if (A==1'b1 && CI==1'b0) (B -=> S)=(0, 0);
if (A==1'b0 && CI==1'b0) (B +=> S)=(0, 0);
if (A==1'b1 && CI==1'b1) (B +=> S)=(0, 0);
if (A==1'b0 && B==1'b1) (CI -=> S)=(0, 0);
if (A==1'b1 && B==1'b0) (CI -=> S)=(0, 0);
if (A==1'b0 && B==1'b0) (CI +=> S)=(0, 0);
if (A==1'b1 && B==1'b1) (CI +=> S)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ADDF_CBV1Y2_1

//%BEGIN HDBSVT11_ADDF_V1Y2_1

`celldefine
module HDBSVT11_ADDF_V1Y2_1 (S, CO, A, B, CI);
   output S, CO;
   input A, B, CI;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A, B);
   and inst1  (int_res_1, A, CI);
   and inst2  (int_res_2, B, CI);
   `ifdef VIRL_functiononly
      xor #`SNPS_COMBO_DELAY  inst3 (S, A, B, CI);
      or #`SNPS_COMBO_DELAY  inst4 (CO, int_res_0, int_res_1, int_res_2);
   `else
      xor inst5  (S, A, B, CI);
      or inst6  (CO, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (B==1'b0 && CI==1'b1) (A +=> CO)=(0, 0);
if (B==1'b1 && CI==1'b0) (A +=> CO)=(0, 0);
if (A==1'b0 && CI==1'b1) (B +=> CO)=(0, 0);
if (A==1'b1 && CI==1'b0) (B +=> CO)=(0, 0);
if (A==1'b0 && B==1'b1) (CI +=> CO)=(0, 0);
if (A==1'b1 && B==1'b0) (CI +=> CO)=(0, 0);
if (B==1'b0 && CI==1'b1) (A -=> S)=(0, 0);
if (B==1'b1 && CI==1'b0) (A -=> S)=(0, 0);
if (B==1'b0 && CI==1'b0) (A +=> S)=(0, 0);
if (B==1'b1 && CI==1'b1) (A +=> S)=(0, 0);
if (A==1'b0 && CI==1'b1) (B -=> S)=(0, 0);
if (A==1'b1 && CI==1'b0) (B -=> S)=(0, 0);
if (A==1'b0 && CI==1'b0) (B +=> S)=(0, 0);
if (A==1'b1 && CI==1'b1) (B +=> S)=(0, 0);
if (A==1'b0 && B==1'b1) (CI -=> S)=(0, 0);
if (A==1'b1 && B==1'b0) (CI -=> S)=(0, 0);
if (A==1'b0 && B==1'b0) (CI +=> S)=(0, 0);
if (A==1'b1 && B==1'b1) (CI +=> S)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ADDF_V1Y2_1

//%BEGIN HDBSVT11_ADDF_V1Y2_2

`celldefine
module HDBSVT11_ADDF_V1Y2_2 (S, CO, A, B, CI);
   output S, CO;
   input A, B, CI;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A, B);
   and inst1  (int_res_1, A, CI);
   and inst2  (int_res_2, B, CI);
   `ifdef VIRL_functiononly
      xor #`SNPS_COMBO_DELAY  inst3 (S, A, B, CI);
      or #`SNPS_COMBO_DELAY  inst4 (CO, int_res_0, int_res_1, int_res_2);
   `else
      xor inst5  (S, A, B, CI);
      or inst6  (CO, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (B==1'b0 && CI==1'b1) (A +=> CO)=(0, 0);
if (B==1'b1 && CI==1'b0) (A +=> CO)=(0, 0);
if (A==1'b0 && CI==1'b1) (B +=> CO)=(0, 0);
if (A==1'b1 && CI==1'b0) (B +=> CO)=(0, 0);
if (A==1'b0 && B==1'b1) (CI +=> CO)=(0, 0);
if (A==1'b1 && B==1'b0) (CI +=> CO)=(0, 0);
if (B==1'b0 && CI==1'b1) (A -=> S)=(0, 0);
if (B==1'b1 && CI==1'b0) (A -=> S)=(0, 0);
if (B==1'b0 && CI==1'b0) (A +=> S)=(0, 0);
if (B==1'b1 && CI==1'b1) (A +=> S)=(0, 0);
if (A==1'b0 && CI==1'b1) (B -=> S)=(0, 0);
if (A==1'b1 && CI==1'b0) (B -=> S)=(0, 0);
if (A==1'b0 && CI==1'b0) (B +=> S)=(0, 0);
if (A==1'b1 && CI==1'b1) (B +=> S)=(0, 0);
if (A==1'b0 && B==1'b1) (CI -=> S)=(0, 0);
if (A==1'b1 && B==1'b0) (CI -=> S)=(0, 0);
if (A==1'b0 && B==1'b0) (CI +=> S)=(0, 0);
if (A==1'b1 && B==1'b1) (CI +=> S)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ADDF_V1Y2_2

//%BEGIN HDBSVT11_ADDF_V2Y2_1

`celldefine
module HDBSVT11_ADDF_V2Y2_1 (S, CO, A, B, CI);
   output S, CO;
   input A, B, CI;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A, B);
   and inst1  (int_res_1, A, CI);
   and inst2  (int_res_2, B, CI);
   `ifdef VIRL_functiononly
      xor #`SNPS_COMBO_DELAY  inst3 (S, A, B, CI);
      or #`SNPS_COMBO_DELAY  inst4 (CO, int_res_0, int_res_1, int_res_2);
   `else
      xor inst5  (S, A, B, CI);
      or inst6  (CO, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (B==1'b0 && CI==1'b1) (A +=> CO)=(0, 0);
if (B==1'b1 && CI==1'b0) (A +=> CO)=(0, 0);
if (A==1'b0 && CI==1'b1) (B +=> CO)=(0, 0);
if (A==1'b1 && CI==1'b0) (B +=> CO)=(0, 0);
if (A==1'b0 && B==1'b1) (CI +=> CO)=(0, 0);
if (A==1'b1 && B==1'b0) (CI +=> CO)=(0, 0);
if (B==1'b0 && CI==1'b1) (A -=> S)=(0, 0);
if (B==1'b1 && CI==1'b0) (A -=> S)=(0, 0);
if (B==1'b0 && CI==1'b0) (A +=> S)=(0, 0);
if (B==1'b1 && CI==1'b1) (A +=> S)=(0, 0);
if (A==1'b0 && CI==1'b1) (B -=> S)=(0, 0);
if (A==1'b1 && CI==1'b0) (B -=> S)=(0, 0);
if (A==1'b0 && CI==1'b0) (B +=> S)=(0, 0);
if (A==1'b1 && CI==1'b1) (B +=> S)=(0, 0);
if (A==1'b0 && B==1'b1) (CI -=> S)=(0, 0);
if (A==1'b1 && B==1'b0) (CI -=> S)=(0, 0);
if (A==1'b0 && B==1'b0) (CI +=> S)=(0, 0);
if (A==1'b1 && B==1'b1) (CI +=> S)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ADDF_V2Y2_1

//%BEGIN HDBSVT11_ADDF_V2Y2_2

`celldefine
module HDBSVT11_ADDF_V2Y2_2 (S, CO, A, B, CI);
   output S, CO;
   input A, B, CI;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A, B);
   and inst1  (int_res_1, A, CI);
   and inst2  (int_res_2, B, CI);
   `ifdef VIRL_functiononly
      xor #`SNPS_COMBO_DELAY  inst3 (S, A, B, CI);
      or #`SNPS_COMBO_DELAY  inst4 (CO, int_res_0, int_res_1, int_res_2);
   `else
      xor inst5  (S, A, B, CI);
      or inst6  (CO, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (B==1'b0 && CI==1'b1) (A +=> CO)=(0, 0);
if (B==1'b1 && CI==1'b0) (A +=> CO)=(0, 0);
if (A==1'b0 && CI==1'b1) (B +=> CO)=(0, 0);
if (A==1'b1 && CI==1'b0) (B +=> CO)=(0, 0);
if (A==1'b0 && B==1'b1) (CI +=> CO)=(0, 0);
if (A==1'b1 && B==1'b0) (CI +=> CO)=(0, 0);
if (B==1'b0 && CI==1'b1) (A -=> S)=(0, 0);
if (B==1'b1 && CI==1'b0) (A -=> S)=(0, 0);
if (B==1'b0 && CI==1'b0) (A +=> S)=(0, 0);
if (B==1'b1 && CI==1'b1) (A +=> S)=(0, 0);
if (A==1'b0 && CI==1'b1) (B -=> S)=(0, 0);
if (A==1'b1 && CI==1'b0) (B -=> S)=(0, 0);
if (A==1'b0 && CI==1'b0) (B +=> S)=(0, 0);
if (A==1'b1 && CI==1'b1) (B +=> S)=(0, 0);
if (A==1'b0 && B==1'b1) (CI -=> S)=(0, 0);
if (A==1'b1 && B==1'b0) (CI -=> S)=(0, 0);
if (A==1'b0 && B==1'b0) (CI +=> S)=(0, 0);
if (A==1'b1 && B==1'b1) (CI +=> S)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ADDF_V2Y2_2

//%BEGIN HDBSVT11_ADDF_V2Y4_4

`celldefine
module HDBSVT11_ADDF_V2Y4_4 (S, CO, A, B, CI);
   output S, CO;
   input A, B, CI;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A, B);
   and inst1  (int_res_1, A, CI);
   and inst2  (int_res_2, B, CI);
   `ifdef VIRL_functiononly
      xor #`SNPS_COMBO_DELAY  inst3 (S, A, B, CI);
      or #`SNPS_COMBO_DELAY  inst4 (CO, int_res_0, int_res_1, int_res_2);
   `else
      xor inst5  (S, A, B, CI);
      or inst6  (CO, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (B==1'b0 && CI==1'b1) (A +=> CO)=(0, 0);
if (B==1'b1 && CI==1'b0) (A +=> CO)=(0, 0);
if (A==1'b0 && CI==1'b1) (B +=> CO)=(0, 0);
if (A==1'b1 && CI==1'b0) (B +=> CO)=(0, 0);
if (A==1'b0 && B==1'b1) (CI +=> CO)=(0, 0);
if (A==1'b1 && B==1'b0) (CI +=> CO)=(0, 0);
if (B==1'b0 && CI==1'b1) (A -=> S)=(0, 0);
if (B==1'b1 && CI==1'b0) (A -=> S)=(0, 0);
if (B==1'b0 && CI==1'b0) (A +=> S)=(0, 0);
if (B==1'b1 && CI==1'b1) (A +=> S)=(0, 0);
if (A==1'b0 && CI==1'b1) (B -=> S)=(0, 0);
if (A==1'b1 && CI==1'b0) (B -=> S)=(0, 0);
if (A==1'b0 && CI==1'b0) (B +=> S)=(0, 0);
if (A==1'b1 && CI==1'b1) (B +=> S)=(0, 0);
if (A==1'b0 && B==1'b1) (CI -=> S)=(0, 0);
if (A==1'b1 && B==1'b0) (CI -=> S)=(0, 0);
if (A==1'b0 && B==1'b0) (CI +=> S)=(0, 0);
if (A==1'b1 && B==1'b1) (CI +=> S)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ADDF_V2Y4_4

//%BEGIN HDBSVT11_ADDH_CBY2_1

`celldefine
module HDBSVT11_ADDH_CBY2_1 (S, CO, A, B);
   output S, CO;
   input A, B;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     xor #`SNPS_COMBO_DELAY  inst0 (S, A, B);
     and #`SNPS_COMBO_DELAY  inst1 (CO, A, B);

   `else
     xor inst2  (S, A, B);
     and inst3  (CO, A, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (B==1'b1) (A +=> CO)=(0, 0);
if (A==1'b1) (B +=> CO)=(0, 0);
if (B==1'b1) (A -=> S)=(0, 0);
if (B==1'b0) (A +=> S)=(0, 0);
if (A==1'b1) (B -=> S)=(0, 0);
if (A==1'b0) (B +=> S)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_ADDH_CBY2_1

//%BEGIN HDBSVT11_ADDH_Y2_1

`celldefine
module HDBSVT11_ADDH_Y2_1 (S, CO, A, B);
   output S, CO;
   input A, B;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     xor #`SNPS_COMBO_DELAY  inst0 (S, A, B);
     and #`SNPS_COMBO_DELAY  inst1 (CO, A, B);

   `else
     xor inst2  (S, A, B);
     and inst3  (CO, A, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (B==1'b1) (A +=> CO)=(0, 0);
if (A==1'b1) (B +=> CO)=(0, 0);
if (B==1'b1) (A -=> S)=(0, 0);
if (B==1'b0) (A +=> S)=(0, 0);
if (A==1'b1) (B -=> S)=(0, 0);
if (A==1'b0) (B +=> S)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_ADDH_Y2_1

//%BEGIN HDBSVT11_ADDH_Y2_2

`celldefine
module HDBSVT11_ADDH_Y2_2 (S, CO, A, B);
   output S, CO;
   input A, B;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     xor #`SNPS_COMBO_DELAY  inst0 (S, A, B);
     and #`SNPS_COMBO_DELAY  inst1 (CO, A, B);

   `else
     xor inst2  (S, A, B);
     and inst3  (CO, A, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (B==1'b1) (A +=> CO)=(0, 0);
if (A==1'b1) (B +=> CO)=(0, 0);
if (B==1'b1) (A -=> S)=(0, 0);
if (B==1'b0) (A +=> S)=(0, 0);
if (A==1'b1) (B -=> S)=(0, 0);
if (A==1'b0) (B +=> S)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_ADDH_Y2_2

//%BEGIN HDBSVT11_ADDH_Y2_4

`celldefine
module HDBSVT11_ADDH_Y2_4 (S, CO, A, B);
   output S, CO;
   input A, B;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     xor #`SNPS_COMBO_DELAY  inst0 (S, A, B);
     and #`SNPS_COMBO_DELAY  inst1 (CO, A, B);

   `else
     xor inst2  (S, A, B);
     and inst3  (CO, A, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (B==1'b1) (A +=> CO)=(0, 0);
if (A==1'b1) (B +=> CO)=(0, 0);
if (B==1'b1) (A -=> S)=(0, 0);
if (B==1'b0) (A +=> S)=(0, 0);
if (A==1'b1) (B -=> S)=(0, 0);
if (A==1'b0) (B +=> S)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_ADDH_Y2_4

//%BEGIN HDBSVT11_AN2B_CKY2_12
`celldefine
module HDBSVT11_AN2B_CKY2_12 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    not inst0  (int_0, CLK);
    and inst1  (int_1, int_0, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2B_CKY2_12

//%BEGIN HDBSVT11_AN2B_CKY2_16
`celldefine
module HDBSVT11_AN2B_CKY2_16 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    not inst0  (int_0, CLK);
    and inst1  (int_1, int_0, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2B_CKY2_16

//%BEGIN HDBSVT11_AN2B_CKY2_20
`celldefine
module HDBSVT11_AN2B_CKY2_20 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    not inst0  (int_0, CLK);
    and inst1  (int_1, int_0, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2B_CKY2_20

//%BEGIN HDBSVT11_AN2B_CK_1
`celldefine
module HDBSVT11_AN2B_CK_1 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    not inst0  (int_0, CLK);
    and inst1  (int_1, int_0, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2B_CK_1

//%BEGIN HDBSVT11_AN2B_CK_2
`celldefine
module HDBSVT11_AN2B_CK_2 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    not inst0  (int_0, CLK);
    and inst1  (int_1, int_0, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2B_CK_2

//%BEGIN HDBSVT11_AN2B_CK_4
`celldefine
module HDBSVT11_AN2B_CK_4 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    not inst0  (int_0, CLK);
    and inst1  (int_1, int_0, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2B_CK_4

//%BEGIN HDBSVT11_AN2B_CK_6
`celldefine
module HDBSVT11_AN2B_CK_6 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    not inst0  (int_0, CLK);
    and inst1  (int_1, int_0, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2B_CK_6

//%BEGIN HDBSVT11_AN2B_CK_8
`celldefine
module HDBSVT11_AN2B_CK_8 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    not inst0  (int_0, CLK);
    and inst1  (int_1, int_0, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2B_CK_8

//%BEGIN HDBSVT11_AN2_1

`celldefine
module HDBSVT11_AN2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
     and inst1   (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN2_1

//%BEGIN HDBSVT11_AN2_12

`celldefine
module HDBSVT11_AN2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
     and inst1   (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN2_12

//%BEGIN HDBSVT11_AN2_2

`celldefine
module HDBSVT11_AN2_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
     and inst1   (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN2_2

//%BEGIN HDBSVT11_AN2_4

`celldefine
module HDBSVT11_AN2_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
     and inst1   (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN2_4

//%BEGIN HDBSVT11_AN2_8

`celldefine
module HDBSVT11_AN2_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
     and inst1   (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN2_8

//%BEGIN HDBSVT11_AN2_CBCK_1
`celldefine
module HDBSVT11_AN2_CBCK_1 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CBCK_1

//%BEGIN HDBSVT11_AN2_CBECOM2FS_2

`celldefine
module HDBSVT11_AN2_CBECOM2FS_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
     and inst1   (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN2_CBECOM2FS_2

//%BEGIN HDBSVT11_AN2_CBECOM2_2

`celldefine
module HDBSVT11_AN2_CBECOM2_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
     and inst1   (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN2_CBECOM2_2

//%BEGIN HDBSVT11_AN2_CBY2ECO_2

`celldefine
module HDBSVT11_AN2_CBY2ECO_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
     and inst1   (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN2_CBY2ECO_2

//%BEGIN HDBSVT11_AN2_CB_1

`celldefine
module HDBSVT11_AN2_CB_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
     and inst1   (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN2_CB_1

//%BEGIN HDBSVT11_AN2_CKST_0P5
`celldefine
module HDBSVT11_AN2_CKST_0P5 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CKST_0P5

//%BEGIN HDBSVT11_AN2_CKST_1P5
`celldefine
module HDBSVT11_AN2_CKST_1P5 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CKST_1P5

//%BEGIN HDBSVT11_AN2_CKST_2P5
`celldefine
module HDBSVT11_AN2_CKST_2P5 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CKST_2P5

//%BEGIN HDBSVT11_AN2_CKY2_10
`celldefine
module HDBSVT11_AN2_CKY2_10 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CKY2_10

//%BEGIN HDBSVT11_AN2_CKY2_12
`celldefine
module HDBSVT11_AN2_CKY2_12 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CKY2_12

//%BEGIN HDBSVT11_AN2_CKY2_16
`celldefine
module HDBSVT11_AN2_CKY2_16 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CKY2_16

//%BEGIN HDBSVT11_AN2_CKY2_20
`celldefine
module HDBSVT11_AN2_CKY2_20 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CKY2_20

//%BEGIN HDBSVT11_AN2_CKY2_24
`celldefine
module HDBSVT11_AN2_CKY2_24 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CKY2_24

//%BEGIN HDBSVT11_AN2_CK_1
`celldefine
module HDBSVT11_AN2_CK_1 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CK_1

//%BEGIN HDBSVT11_AN2_CK_10
`celldefine
module HDBSVT11_AN2_CK_10 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CK_10

//%BEGIN HDBSVT11_AN2_CK_2
`celldefine
module HDBSVT11_AN2_CK_2 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CK_2

//%BEGIN HDBSVT11_AN2_CK_3
`celldefine
module HDBSVT11_AN2_CK_3 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CK_3

//%BEGIN HDBSVT11_AN2_CK_4
`celldefine
module HDBSVT11_AN2_CK_4 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CK_4

//%BEGIN HDBSVT11_AN2_CK_5
`celldefine
module HDBSVT11_AN2_CK_5 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CK_5

//%BEGIN HDBSVT11_AN2_CK_6
`celldefine
module HDBSVT11_AN2_CK_6 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CK_6

//%BEGIN HDBSVT11_AN2_CK_7
`celldefine
module HDBSVT11_AN2_CK_7 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CK_7

//%BEGIN HDBSVT11_AN2_CK_8
`celldefine
module HDBSVT11_AN2_CK_8 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN +=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AN2_CK_8

//%BEGIN HDBSVT11_AN2_ECOM2FS_2

`celldefine
module HDBSVT11_AN2_ECOM2FS_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
     and inst1   (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN2_ECOM2FS_2

//%BEGIN HDBSVT11_AN2_ECOM2_2

`celldefine
module HDBSVT11_AN2_ECOM2_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
     and inst1   (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN2_ECOM2_2

//%BEGIN HDBSVT11_AN2_Y2ECO_2

`celldefine
module HDBSVT11_AN2_Y2ECO_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
     and inst1   (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN2_Y2ECO_2

//%BEGIN HDBSVT11_AN2_Y2_12

`celldefine
module HDBSVT11_AN2_Y2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
     and inst1   (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN2_Y2_12

//%BEGIN HDBSVT11_AN3_1

`celldefine
module HDBSVT11_AN3_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
      and inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN3_1

//%BEGIN HDBSVT11_AN3_2

`celldefine
module HDBSVT11_AN3_2 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
      and inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN3_2

//%BEGIN HDBSVT11_AN3_CBECOM2FS_1

`celldefine
module HDBSVT11_AN3_CBECOM2FS_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
      and inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN3_CBECOM2FS_1

//%BEGIN HDBSVT11_AN3_CBECOM2_1

`celldefine
module HDBSVT11_AN3_CBECOM2_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
      and inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN3_CBECOM2_1

//%BEGIN HDBSVT11_AN3_CBY2ECO_1

`celldefine
module HDBSVT11_AN3_CBY2ECO_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
      and inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN3_CBY2ECO_1

//%BEGIN HDBSVT11_AN3_ECOM2FS_1

`celldefine
module HDBSVT11_AN3_ECOM2FS_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
      and inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN3_ECOM2FS_1

//%BEGIN HDBSVT11_AN3_ECOM2_1

`celldefine
module HDBSVT11_AN3_ECOM2_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
      and inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN3_ECOM2_1

//%BEGIN HDBSVT11_AN3_Y2ECO_1

`celldefine
module HDBSVT11_AN3_Y2ECO_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
      and inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN3_Y2ECO_1

//%BEGIN HDBSVT11_AN3_Y2_12

`celldefine
module HDBSVT11_AN3_Y2_12 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
      and inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN3_Y2_12

//%BEGIN HDBSVT11_AN3_Y2_4

`celldefine
module HDBSVT11_AN3_Y2_4 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
      and inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN3_Y2_4

//%BEGIN HDBSVT11_AN3_Y2_8

`celldefine
module HDBSVT11_AN3_Y2_8 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
      and inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN3_Y2_8

//%BEGIN HDBSVT11_AN4_1

`celldefine
module HDBSVT11_AN4_1 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
      and inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN4_1

//%BEGIN HDBSVT11_AN4_2

`celldefine
module HDBSVT11_AN4_2 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
      and inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN4_2

//%BEGIN HDBSVT11_AN4_ECOM2FS_2

`celldefine
module HDBSVT11_AN4_ECOM2FS_2 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
      and inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN4_ECOM2FS_2

//%BEGIN HDBSVT11_AN4_ECOM2_2

`celldefine
module HDBSVT11_AN4_ECOM2_2 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
      and inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN4_ECOM2_2

//%BEGIN HDBSVT11_AN4_Y2ECO_2

`celldefine
module HDBSVT11_AN4_Y2ECO_2 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
      and inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN4_Y2ECO_2

//%BEGIN HDBSVT11_AN4_Y2_12

`celldefine
module HDBSVT11_AN4_Y2_12 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
      and inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN4_Y2_12

//%BEGIN HDBSVT11_AN4_Y2_4

`celldefine
module HDBSVT11_AN4_Y2_4 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
      and inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN4_Y2_4

//%BEGIN HDBSVT11_AN4_Y2_8

`celldefine
module HDBSVT11_AN4_Y2_8 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
      and inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AN4_Y2_8

//%BEGIN HDBSVT11_AO211_1

`celldefine
module HDBSVT11_AO211_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
      or inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO211_1

//%BEGIN HDBSVT11_AO211_2

`celldefine
module HDBSVT11_AO211_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
      or inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO211_2

//%BEGIN HDBSVT11_AO211_V1D1_1

`celldefine
module HDBSVT11_AO211_V1D1_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
      or inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO211_V1D1_1

//%BEGIN HDBSVT11_AO211_V1Y2_4

`celldefine
module HDBSVT11_AO211_V1Y2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
      or inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO211_V1Y2_4

//%BEGIN HDBSVT11_AO211_V1_1

`celldefine
module HDBSVT11_AO211_V1_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
      or inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO211_V1_1

//%BEGIN HDBSVT11_AO211_V1_2

`celldefine
module HDBSVT11_AO211_V1_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
      or inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO211_V1_2

//%BEGIN HDBSVT11_AO211_Y2_4

`celldefine
module HDBSVT11_AO211_Y2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
      or inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO211_Y2_4

//%BEGIN HDBSVT11_AO211_Y2_8

`celldefine
module HDBSVT11_AO211_Y2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
      or inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO211_Y2_8

//%BEGIN HDBSVT11_AO21B_1

`celldefine
module HDBSVT11_AO21B_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   not inst1  (int_res_1, B);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
     or inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21B_1

//%BEGIN HDBSVT11_AO21B_2

`celldefine
module HDBSVT11_AO21B_2 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   not inst1  (int_res_1, B);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
     or inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21B_2

//%BEGIN HDBSVT11_AO21B_4

`celldefine
module HDBSVT11_AO21B_4 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   not inst1  (int_res_1, B);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
     or inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21B_4

//%BEGIN HDBSVT11_AO21B_8

`celldefine
module HDBSVT11_AO21B_8 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   not inst1  (int_res_1, B);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
     or inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21B_8

//%BEGIN HDBSVT11_AO21B_CB_1

`celldefine
module HDBSVT11_AO21B_CB_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   not inst1  (int_res_1, B);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
     or inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21B_CB_1

//%BEGIN HDBSVT11_AO21B_CK_4
`celldefine
module HDBSVT11_AO21B_CK_4 (Z, E, CLK1, CLK2);
  input E, CLK1, CLK2;
  output Z;
  wire int_0, int_1, int_2;


    not inst0  (int_0, CLK2);
    and inst1  (int_1, E, CLK1);
    or inst2  (int_2, int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst3 (Z, int_2);
  `else
    buf inst4  (Z, int_2);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (CLK2==1'b1 && E==1'b1) (CLK1 +=> Z)=(0, 0);
if (CLK1==1'b0 && E==1'b0) (CLK2 -=> Z)=(0, 0);
if (CLK1==1'b0 && E==1'b1) (CLK2 -=> Z)=(0, 0);
if (CLK1==1'b1 && E==1'b0) (CLK2 -=> Z)=(0, 0);
if (CLK1==1'b1 && CLK2==1'b1) (E +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_AO21B_CK_4

//%BEGIN HDBSVT11_AO21B_Y2_12

`celldefine
module HDBSVT11_AO21B_Y2_12 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   not inst1  (int_res_1, B);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
     or inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21B_Y2_12

//%BEGIN HDBSVT11_AO21_1

`celldefine
module HDBSVT11_AO21_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21_1

//%BEGIN HDBSVT11_AO21_2

`celldefine
module HDBSVT11_AO21_2 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21_2

//%BEGIN HDBSVT11_AO21_4

`celldefine
module HDBSVT11_AO21_4 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21_4

//%BEGIN HDBSVT11_AO21_8

`celldefine
module HDBSVT11_AO21_8 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21_8

//%BEGIN HDBSVT11_AO21_CBECOM2FS_1

`celldefine
module HDBSVT11_AO21_CBECOM2FS_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21_CBECOM2FS_1

//%BEGIN HDBSVT11_AO21_CBECOM2_1

`celldefine
module HDBSVT11_AO21_CBECOM2_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21_CBECOM2_1

//%BEGIN HDBSVT11_AO21_CBY2ECO_1

`celldefine
module HDBSVT11_AO21_CBY2ECO_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21_CBY2ECO_1

//%BEGIN HDBSVT11_AO21_ECOM2FS_1

`celldefine
module HDBSVT11_AO21_ECOM2FS_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21_ECOM2FS_1

//%BEGIN HDBSVT11_AO21_ECOM2_1

`celldefine
module HDBSVT11_AO21_ECOM2_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21_ECOM2_1

//%BEGIN HDBSVT11_AO21_V1D1_1

`celldefine
module HDBSVT11_AO21_V1D1_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21_V1D1_1

//%BEGIN HDBSVT11_AO21_V1Y2_4

`celldefine
module HDBSVT11_AO21_V1Y2_4 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21_V1Y2_4

//%BEGIN HDBSVT11_AO21_V1_1

`celldefine
module HDBSVT11_AO21_V1_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21_V1_1

//%BEGIN HDBSVT11_AO21_V1_2

`celldefine
module HDBSVT11_AO21_V1_2 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21_V1_2

//%BEGIN HDBSVT11_AO21_Y2ECO_1

`celldefine
module HDBSVT11_AO21_Y2ECO_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO21_Y2ECO_1

//%BEGIN HDBSVT11_AO221_Y2_1

`celldefine
module HDBSVT11_AO221_Y2_1 (X, A1, A2, B1, B2, C);
   output X;
   input A1, A2, B1, B2, C;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1, C);
   `else
      or inst3  (X, int_res_0, int_res_1, C);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO221_Y2_1

//%BEGIN HDBSVT11_AO221_Y2_2

`celldefine
module HDBSVT11_AO221_Y2_2 (X, A1, A2, B1, B2, C);
   output X;
   input A1, A2, B1, B2, C;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1, C);
   `else
      or inst3  (X, int_res_0, int_res_1, C);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO221_Y2_2

//%BEGIN HDBSVT11_AO221_Y2_4

`celldefine
module HDBSVT11_AO221_Y2_4 (X, A1, A2, B1, B2, C);
   output X;
   input A1, A2, B1, B2, C;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1, C);
   `else
      or inst3  (X, int_res_0, int_res_1, C);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO221_Y2_4

//%BEGIN HDBSVT11_AO221_Y2_8

`celldefine
module HDBSVT11_AO221_Y2_8 (X, A1, A2, B1, B2, C);
   output X;
   input A1, A2, B1, B2, C;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1, C);
   `else
      or inst3  (X, int_res_0, int_res_1, C);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO221_Y2_8

//%BEGIN HDBSVT11_AO2222_Y2_1

`celldefine
module HDBSVT11_AO2222_Y2_1 (X, A1, A2, B1, B2, C1, C2, D1, D2);
   output X;
   input A1, A2, B1, B2, C1, C2, D1, D2;
   wire int_res_0, int_res_1, int_res_2, int_res_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);
   and inst2  (int_res_2, C1, C2);
   and inst3  (int_res_3, D1, D2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst4 (X, int_res_0, int_res_1, int_res_2, int_res_3);

   `else
      or inst5   (X, int_res_0, int_res_1, int_res_2, int_res_3);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO2222_Y2_1

//%BEGIN HDBSVT11_AO222_1

`celldefine
module HDBSVT11_AO222_1 (X, A1, A2, B1, B2, C1, C2);
   output X;
   input A1, A2, B1, B2, C1, C2;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);
   and inst2  (int_res_2, C1, C2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
      or inst4   (X, int_res_0, int_res_1, int_res_2);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO222_1

//%BEGIN HDBSVT11_AO222_2

`celldefine
module HDBSVT11_AO222_2 (X, A1, A2, B1, B2, C1, C2);
   output X;
   input A1, A2, B1, B2, C1, C2;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);
   and inst2  (int_res_2, C1, C2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
      or inst4   (X, int_res_0, int_res_1, int_res_2);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO222_2

//%BEGIN HDBSVT11_AO222_Y2_4

`celldefine
module HDBSVT11_AO222_Y2_4 (X, A1, A2, B1, B2, C1, C2);
   output X;
   input A1, A2, B1, B2, C1, C2;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);
   and inst2  (int_res_2, C1, C2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
      or inst4   (X, int_res_0, int_res_1, int_res_2);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO222_Y2_4

//%BEGIN HDBSVT11_AO222_Y2_8

`celldefine
module HDBSVT11_AO222_Y2_8 (X, A1, A2, B1, B2, C1, C2);
   output X;
   input A1, A2, B1, B2, C1, C2;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);
   and inst2  (int_res_2, C1, C2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
      or inst4   (X, int_res_0, int_res_1, int_res_2);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO222_Y2_8

//%BEGIN HDBSVT11_AO22_1

`celldefine
module HDBSVT11_AO22_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      or inst3   (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO22_1

//%BEGIN HDBSVT11_AO22_2

`celldefine
module HDBSVT11_AO22_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      or inst3   (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO22_2

//%BEGIN HDBSVT11_AO22_CB_1

`celldefine
module HDBSVT11_AO22_CB_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      or inst3   (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO22_CB_1

//%BEGIN HDBSVT11_AO22_CB_2

`celldefine
module HDBSVT11_AO22_CB_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      or inst3   (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO22_CB_2

//%BEGIN HDBSVT11_AO22_Y2_4

`celldefine
module HDBSVT11_AO22_Y2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      or inst3   (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO22_Y2_4

//%BEGIN HDBSVT11_AO22_Y2_8

`celldefine
module HDBSVT11_AO22_Y2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      or inst3   (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO22_Y2_8

//%BEGIN HDBSVT11_AO2BB2_1

`celldefine
module HDBSVT11_AO2BB2_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1, int_res_2, 
      int_res_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A1);
   not inst1  (int_res_1, A2);
   and inst2  (int_res_2, int_res_0, int_res_1);
   and inst3  (int_res_3, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst4 (X, int_res_2, int_res_3);
   `else
      or inst5  (X, int_res_2, int_res_3);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif
 
endmodule
`endcelldefine

//%END HDBSVT11_AO2BB2_1

//%BEGIN HDBSVT11_AO2BB2_2

`celldefine
module HDBSVT11_AO2BB2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1, int_res_2, 
      int_res_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A1);
   not inst1  (int_res_1, A2);
   and inst2  (int_res_2, int_res_0, int_res_1);
   and inst3  (int_res_3, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst4 (X, int_res_2, int_res_3);
   `else
      or inst5  (X, int_res_2, int_res_3);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif
 
endmodule
`endcelldefine

//%END HDBSVT11_AO2BB2_2

//%BEGIN HDBSVT11_AO2BB2_4

`celldefine
module HDBSVT11_AO2BB2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1, int_res_2, 
      int_res_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A1);
   not inst1  (int_res_1, A2);
   and inst2  (int_res_2, int_res_0, int_res_1);
   and inst3  (int_res_3, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst4 (X, int_res_2, int_res_3);
   `else
      or inst5  (X, int_res_2, int_res_3);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif
 
endmodule
`endcelldefine

//%END HDBSVT11_AO2BB2_4

//%BEGIN HDBSVT11_AO2BB2_CB_1

`celldefine
module HDBSVT11_AO2BB2_CB_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1, int_res_2, 
      int_res_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A1);
   not inst1  (int_res_1, A2);
   and inst2  (int_res_2, int_res_0, int_res_1);
   and inst3  (int_res_3, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst4 (X, int_res_2, int_res_3);
   `else
      or inst5  (X, int_res_2, int_res_3);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif
 
endmodule
`endcelldefine

//%END HDBSVT11_AO2BB2_CB_1

//%BEGIN HDBSVT11_AO2BB2_Y2_12

`celldefine
module HDBSVT11_AO2BB2_Y2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1, int_res_2, 
      int_res_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A1);
   not inst1  (int_res_1, A2);
   and inst2  (int_res_2, int_res_0, int_res_1);
   and inst3  (int_res_3, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst4 (X, int_res_2, int_res_3);
   `else
      or inst5  (X, int_res_2, int_res_3);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif
 
endmodule
`endcelldefine

//%END HDBSVT11_AO2BB2_Y2_12

//%BEGIN HDBSVT11_AO2BB2_Y2_8

`celldefine
module HDBSVT11_AO2BB2_Y2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1, int_res_2, 
      int_res_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A1);
   not inst1  (int_res_1, A2);
   and inst2  (int_res_2, int_res_0, int_res_1);
   and inst3  (int_res_3, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst4 (X, int_res_2, int_res_3);
   `else
      or inst5  (X, int_res_2, int_res_3);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif
 
endmodule
`endcelldefine

//%END HDBSVT11_AO2BB2_Y2_8

//%BEGIN HDBSVT11_AO31_1

`celldefine
module HDBSVT11_AO31_1 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif
 
endmodule
`endcelldefine

//%END HDBSVT11_AO31_1

//%BEGIN HDBSVT11_AO31_2

`celldefine
module HDBSVT11_AO31_2 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif
 
endmodule
`endcelldefine

//%END HDBSVT11_AO31_2

//%BEGIN HDBSVT11_AO31_D1_1

`celldefine
module HDBSVT11_AO31_D1_1 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif
 
endmodule
`endcelldefine

//%END HDBSVT11_AO31_D1_1

//%BEGIN HDBSVT11_AO31_Y2_4

`celldefine
module HDBSVT11_AO31_Y2_4 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif
 
endmodule
`endcelldefine

//%END HDBSVT11_AO31_Y2_4

//%BEGIN HDBSVT11_AO31_Y2_8

`celldefine
module HDBSVT11_AO31_Y2_8 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      or inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
endspecify
   `endif
 
endmodule
`endcelldefine

//%END HDBSVT11_AO31_Y2_8

//%BEGIN HDBSVT11_AO32_1

`celldefine
module HDBSVT11_AO32_1 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);
   and inst1  (int_res_1, B1, B2);
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);     
   `else
      or inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif 
endmodule
`endcelldefine

//%END HDBSVT11_AO32_1

//%BEGIN HDBSVT11_AO32_2

`celldefine
module HDBSVT11_AO32_2 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);
   and inst1  (int_res_1, B1, B2);
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);     
   `else
      or inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif 
endmodule
`endcelldefine

//%END HDBSVT11_AO32_2

//%BEGIN HDBSVT11_AO32_Y2_4

`celldefine
module HDBSVT11_AO32_Y2_4 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);
   and inst1  (int_res_1, B1, B2);
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);     
   `else
      or inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif 
endmodule
`endcelldefine

//%END HDBSVT11_AO32_Y2_4

//%BEGIN HDBSVT11_AO32_Y2_8

`celldefine
module HDBSVT11_AO32_Y2_8 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);
   and inst1  (int_res_1, B1, B2);
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);     
   `else
      or inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif 
endmodule
`endcelldefine

//%END HDBSVT11_AO32_Y2_8

//%BEGIN HDBSVT11_AO33_1

`celldefine
module HDBSVT11_AO33_1 (X, A1, A2, A3, B1, B2, B3);
   output X;
   input A1, A2, A3, B1, B2, B3;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);
   and inst1  (int_res_1, B1, B2, B3);



   `ifdef VIRL_functiononly
       or  #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
       or inst3   (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO33_1

//%BEGIN HDBSVT11_AO33_2

`celldefine
module HDBSVT11_AO33_2 (X, A1, A2, A3, B1, B2, B3);
   output X;
   input A1, A2, A3, B1, B2, B3;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);
   and inst1  (int_res_1, B1, B2, B3);



   `ifdef VIRL_functiononly
       or  #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
       or inst3   (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO33_2

//%BEGIN HDBSVT11_AO33_Y2_4

`celldefine
module HDBSVT11_AO33_Y2_4 (X, A1, A2, A3, B1, B2, B3);
   output X;
   input A1, A2, A3, B1, B2, B3;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);
   and inst1  (int_res_1, B1, B2, B3);



   `ifdef VIRL_functiononly
       or  #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
       or inst3   (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AO33_Y2_4

//%BEGIN HDBSVT11_AOAI211_1

`celldefine
module HDBSVT11_AOAI211_1 (X, A1, A2, B, C);
   output X;
   input A1, A2, B, C;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, int_res_0, B);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_1, C);
   `else
      nand inst3  (X, int_res_1, C);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0 && C==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0 && C==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && C==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && C==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && C==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B==1'b1) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b1) (C -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOAI211_1

//%BEGIN HDBSVT11_AOI211_1

`celldefine
module HDBSVT11_AOI211_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
  `else
     nor inst2  (X, int_res_0, B1, B2);
  `endif

  `ifdef VIRL_functiononly

  `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI211_1

//%BEGIN HDBSVT11_AOI211_2

`celldefine
module HDBSVT11_AOI211_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
  `else
     nor inst2  (X, int_res_0, B1, B2);
  `endif

  `ifdef VIRL_functiononly

  `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI211_2

//%BEGIN HDBSVT11_AOI211_CB_1

`celldefine
module HDBSVT11_AOI211_CB_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
  `else
     nor inst2  (X, int_res_0, B1, B2);
  `endif

  `ifdef VIRL_functiononly

  `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI211_CB_1

//%BEGIN HDBSVT11_AOI211_PC_2

`celldefine
module HDBSVT11_AOI211_PC_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
  `else
     nor inst2  (X, int_res_0, B1, B2);
  `endif

  `ifdef VIRL_functiononly

  `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI211_PC_2

//%BEGIN HDBSVT11_AOI211_Y2_4

`celldefine
module HDBSVT11_AOI211_Y2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
  `else
     nor inst2  (X, int_res_0, B1, B2);
  `endif

  `ifdef VIRL_functiononly

  `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI211_Y2_4

//%BEGIN HDBSVT11_AOI211_Y2_8

`celldefine
module HDBSVT11_AOI211_Y2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
  `else
     nor inst2  (X, int_res_0, B1, B2);
  `endif

  `ifdef VIRL_functiononly

  `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI211_Y2_8

//%BEGIN HDBSVT11_AOI21_1

`celldefine
module HDBSVT11_AOI21_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY   inst1 (X, int_res_0, B);
   `else
     nor inst2  (X, int_res_0, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI21_1

//%BEGIN HDBSVT11_AOI21_2

`celldefine
module HDBSVT11_AOI21_2 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY   inst1 (X, int_res_0, B);
   `else
     nor inst2  (X, int_res_0, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI21_2

//%BEGIN HDBSVT11_AOI21_3

`celldefine
module HDBSVT11_AOI21_3 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY   inst1 (X, int_res_0, B);
   `else
     nor inst2  (X, int_res_0, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI21_3

//%BEGIN HDBSVT11_AOI21_4

`celldefine
module HDBSVT11_AOI21_4 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY   inst1 (X, int_res_0, B);
   `else
     nor inst2  (X, int_res_0, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI21_4

//%BEGIN HDBSVT11_AOI21_CBECO_1

`celldefine
module HDBSVT11_AOI21_CBECO_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY   inst1 (X, int_res_0, B);
   `else
     nor inst2  (X, int_res_0, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI21_CBECO_1

//%BEGIN HDBSVT11_AOI21_CB_1

`celldefine
module HDBSVT11_AOI21_CB_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY   inst1 (X, int_res_0, B);
   `else
     nor inst2  (X, int_res_0, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI21_CB_1

//%BEGIN HDBSVT11_AOI21_CB_2

`celldefine
module HDBSVT11_AOI21_CB_2 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY   inst1 (X, int_res_0, B);
   `else
     nor inst2  (X, int_res_0, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI21_CB_2

//%BEGIN HDBSVT11_AOI21_ECO_1

`celldefine
module HDBSVT11_AOI21_ECO_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY   inst1 (X, int_res_0, B);
   `else
     nor inst2  (X, int_res_0, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI21_ECO_1

//%BEGIN HDBSVT11_AOI21_V1Y2_12

`celldefine
module HDBSVT11_AOI21_V1Y2_12 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY   inst1 (X, int_res_0, B);
   `else
     nor inst2  (X, int_res_0, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI21_V1Y2_12

//%BEGIN HDBSVT11_AOI21_V1Y2_2

`celldefine
module HDBSVT11_AOI21_V1Y2_2 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY   inst1 (X, int_res_0, B);
   `else
     nor inst2  (X, int_res_0, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI21_V1Y2_2

//%BEGIN HDBSVT11_AOI21_V1Y2_4

`celldefine
module HDBSVT11_AOI21_V1Y2_4 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY   inst1 (X, int_res_0, B);
   `else
     nor inst2  (X, int_res_0, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI21_V1Y2_4

//%BEGIN HDBSVT11_AOI21_V1Y2_6

`celldefine
module HDBSVT11_AOI21_V1Y2_6 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY   inst1 (X, int_res_0, B);
   `else
     nor inst2  (X, int_res_0, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI21_V1Y2_6

//%BEGIN HDBSVT11_AOI21_V1Y2_8

`celldefine
module HDBSVT11_AOI21_V1Y2_8 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY   inst1 (X, int_res_0, B);
   `else
     nor inst2  (X, int_res_0, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI21_V1Y2_8

//%BEGIN HDBSVT11_AOI21_V1_1

`celldefine
module HDBSVT11_AOI21_V1_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY   inst1 (X, int_res_0, B);
   `else
     nor inst2  (X, int_res_0, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI21_V1_1

//%BEGIN HDBSVT11_AOI21_Y2_12

`celldefine
module HDBSVT11_AOI21_Y2_12 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY   inst1 (X, int_res_0, B);
   `else
     nor inst2  (X, int_res_0, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI21_Y2_12

//%BEGIN HDBSVT11_AOI21_Y2_6

`celldefine
module HDBSVT11_AOI21_Y2_6 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY   inst1 (X, int_res_0, B);
   `else
     nor inst2  (X, int_res_0, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI21_Y2_6

//%BEGIN HDBSVT11_AOI21_Y2_8

`celldefine
module HDBSVT11_AOI21_Y2_8 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     nor #`SNPS_COMBO_DELAY   inst1 (X, int_res_0, B);
   `else
     nor inst2  (X, int_res_0, B);

   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI21_Y2_8

//%BEGIN HDBSVT11_AOI221_1

`celldefine
module HDBSVT11_AOI221_1 (X, A1, A2, B1, B2, C);
   output X;
   input A1, A2, B1, B2, C;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1, C);
  `else
      nor inst3  (X, int_res_0, int_res_1, C);
  `endif

  `ifdef VIRL_functiononly

  `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI221_1

//%BEGIN HDBSVT11_AOI221_Y2_2

`celldefine
module HDBSVT11_AOI221_Y2_2 (X, A1, A2, B1, B2, C);
   output X;
   input A1, A2, B1, B2, C;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1, C);
  `else
      nor inst3  (X, int_res_0, int_res_1, C);
  `endif

  `ifdef VIRL_functiononly

  `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI221_Y2_2

//%BEGIN HDBSVT11_AOI221_Y2_4

`celldefine
module HDBSVT11_AOI221_Y2_4 (X, A1, A2, B1, B2, C);
   output X;
   input A1, A2, B1, B2, C;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1, C);
  `else
      nor inst3  (X, int_res_0, int_res_1, C);
  `endif

  `ifdef VIRL_functiononly

  `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI221_Y2_4

//%BEGIN HDBSVT11_AOI2222_V2Y2_1

`celldefine
module HDBSVT11_AOI2222_V2Y2_1 (X, A1, A2, B1, B2, C1, C2, D1, D2);
   output X;
   input A1, A2, B1, B2, C1, C2, D1, D2;

   wire int_res_0, int_res_1, int_res_2, int_res_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);
   and inst2  (int_res_2, C1, C2);
   and inst3  (int_res_3, D1, D2);
   

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst4 (X, int_res_0, int_res_1, int_res_2, int_res_3);
   `else
      nor inst5  (X, int_res_0, int_res_1, int_res_2, int_res_3);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI2222_V2Y2_1

//%BEGIN HDBSVT11_AOI2222_V2Y2_2

`celldefine
module HDBSVT11_AOI2222_V2Y2_2 (X, A1, A2, B1, B2, C1, C2, D1, D2);
   output X;
   input A1, A2, B1, B2, C1, C2, D1, D2;

   wire int_res_0, int_res_1, int_res_2, int_res_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);
   and inst2  (int_res_2, C1, C2);
   and inst3  (int_res_3, D1, D2);
   

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst4 (X, int_res_0, int_res_1, int_res_2, int_res_3);
   `else
      nor inst5  (X, int_res_0, int_res_1, int_res_2, int_res_3);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI2222_V2Y2_2

//%BEGIN HDBSVT11_AOI2222_V2Y2_4

`celldefine
module HDBSVT11_AOI2222_V2Y2_4 (X, A1, A2, B1, B2, C1, C2, D1, D2);
   output X;
   input A1, A2, B1, B2, C1, C2, D1, D2;

   wire int_res_0, int_res_1, int_res_2, int_res_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);
   and inst2  (int_res_2, C1, C2);
   and inst3  (int_res_3, D1, D2);
   

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst4 (X, int_res_0, int_res_1, int_res_2, int_res_3);
   `else
      nor inst5  (X, int_res_0, int_res_1, int_res_2, int_res_3);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b0 && D2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1 && D2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b0 && D2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1 && D1==1'b1 && D2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b0 && D2==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && D1==1'b1 && D2==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D2==1'b1) (D1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1 && D1==1'b1) (D2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0 && D1==1'b1) (D2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI2222_V2Y2_4

//%BEGIN HDBSVT11_AOI222_1

`celldefine
module HDBSVT11_AOI222_1 (X, A1, A2, B1, B2, C1, C2);
   output X;
   input A1, A2, B1, B2, C1, C2;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);
   and inst2  (int_res_2, C1, C2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       nor #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
       nor inst4  (X, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI222_1

//%BEGIN HDBSVT11_AOI222_Y2_2

`celldefine
module HDBSVT11_AOI222_Y2_2 (X, A1, A2, B1, B2, C1, C2);
   output X;
   input A1, A2, B1, B2, C1, C2;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);
   and inst2  (int_res_2, C1, C2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       nor #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
       nor inst4  (X, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI222_Y2_2

//%BEGIN HDBSVT11_AOI222_Y2_4

`celldefine
module HDBSVT11_AOI222_Y2_4 (X, A1, A2, B1, B2, C1, C2);
   output X;
   input A1, A2, B1, B2, C1, C2;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);
   and inst2  (int_res_2, C1, C2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       nor #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
       nor inst4  (X, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI222_Y2_4

//%BEGIN HDBSVT11_AOI222_Y4_8

`celldefine
module HDBSVT11_AOI222_Y4_8 (X, A1, A2, B1, B2, C1, C2);
   output X;
   input A1, A2, B1, B2, C1, C2;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);
   and inst2  (int_res_2, C1, C2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       nor #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
       nor inst4  (X, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b1) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1) (C2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI222_Y4_8

//%BEGIN HDBSVT11_AOI22_1

`celldefine
module HDBSVT11_AOI22_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_1

//%BEGIN HDBSVT11_AOI22_CBECOM2FS_1

`celldefine
module HDBSVT11_AOI22_CBECOM2FS_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_CBECOM2FS_1

//%BEGIN HDBSVT11_AOI22_CBECOM2_1

`celldefine
module HDBSVT11_AOI22_CBECOM2_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_CBECOM2_1

//%BEGIN HDBSVT11_AOI22_CBY2ECO_1

`celldefine
module HDBSVT11_AOI22_CBY2ECO_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_CBY2ECO_1

//%BEGIN HDBSVT11_AOI22_CB_1

`celldefine
module HDBSVT11_AOI22_CB_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_CB_1

//%BEGIN HDBSVT11_AOI22_ECOM2FS_1

`celldefine
module HDBSVT11_AOI22_ECOM2FS_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_ECOM2FS_1

//%BEGIN HDBSVT11_AOI22_ECOM2_1

`celldefine
module HDBSVT11_AOI22_ECOM2_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_ECOM2_1

//%BEGIN HDBSVT11_AOI22_SKFY2_12

`celldefine
module HDBSVT11_AOI22_SKFY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_SKFY2_12

//%BEGIN HDBSVT11_AOI22_SKFY2_2

`celldefine
module HDBSVT11_AOI22_SKFY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_SKFY2_2

//%BEGIN HDBSVT11_AOI22_SKFY2_4

`celldefine
module HDBSVT11_AOI22_SKFY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_SKFY2_4

//%BEGIN HDBSVT11_AOI22_SKFY2_8

`celldefine
module HDBSVT11_AOI22_SKFY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_SKFY2_8

//%BEGIN HDBSVT11_AOI22_SKRY2_12

`celldefine
module HDBSVT11_AOI22_SKRY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_SKRY2_12

//%BEGIN HDBSVT11_AOI22_SKRY2_2

`celldefine
module HDBSVT11_AOI22_SKRY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_SKRY2_2

//%BEGIN HDBSVT11_AOI22_SKRY2_4

`celldefine
module HDBSVT11_AOI22_SKRY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_SKRY2_4

//%BEGIN HDBSVT11_AOI22_SKRY2_8

`celldefine
module HDBSVT11_AOI22_SKRY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_SKRY2_8

//%BEGIN HDBSVT11_AOI22_Y2ECO_1

`celldefine
module HDBSVT11_AOI22_Y2ECO_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_Y2ECO_1

//%BEGIN HDBSVT11_AOI22_Y2_12

`celldefine
module HDBSVT11_AOI22_Y2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_Y2_12

//%BEGIN HDBSVT11_AOI22_Y2_2

`celldefine
module HDBSVT11_AOI22_Y2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_Y2_2

//%BEGIN HDBSVT11_AOI22_Y2_3

`celldefine
module HDBSVT11_AOI22_Y2_3 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_Y2_3

//%BEGIN HDBSVT11_AOI22_Y2_4

`celldefine
module HDBSVT11_AOI22_Y2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_Y2_4

//%BEGIN HDBSVT11_AOI22_Y2_6

`celldefine
module HDBSVT11_AOI22_Y2_6 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_Y2_6

//%BEGIN HDBSVT11_AOI22_Y2_8

`celldefine
module HDBSVT11_AOI22_Y2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI22_Y2_8

//%BEGIN HDBSVT11_AOI311_1

`celldefine
module HDBSVT11_AOI311_1 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);


   `ifdef VIRL_functiononly
       nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);        
   `else
       nor inst2  (X, int_res_0, B1, B2);        
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
  

specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_AOI311_1

//%BEGIN HDBSVT11_AOI311_Y2_2

`celldefine
module HDBSVT11_AOI311_Y2_2 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);


   `ifdef VIRL_functiononly
       nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);        
   `else
       nor inst2  (X, int_res_0, B1, B2);        
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
  

specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_AOI311_Y2_2

//%BEGIN HDBSVT11_AOI311_Y2_4

`celldefine
module HDBSVT11_AOI311_Y2_4 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);


   `ifdef VIRL_functiononly
       nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);        
   `else
       nor inst2  (X, int_res_0, B1, B2);        
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
  

specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_AOI311_Y2_4

//%BEGIN HDBSVT11_AOI31_1

`celldefine
module HDBSVT11_AOI31_1 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nor inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI31_1

//%BEGIN HDBSVT11_AOI31_CBECOM2FS_1

`celldefine
module HDBSVT11_AOI31_CBECOM2FS_1 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nor inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI31_CBECOM2FS_1

//%BEGIN HDBSVT11_AOI31_CBECOM2_1

`celldefine
module HDBSVT11_AOI31_CBECOM2_1 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nor inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI31_CBECOM2_1

//%BEGIN HDBSVT11_AOI31_CBY2ECO_1

`celldefine
module HDBSVT11_AOI31_CBY2ECO_1 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nor inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI31_CBY2ECO_1

//%BEGIN HDBSVT11_AOI31_D1_1

`celldefine
module HDBSVT11_AOI31_D1_1 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nor inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI31_D1_1

//%BEGIN HDBSVT11_AOI31_ECOM2FS_1

`celldefine
module HDBSVT11_AOI31_ECOM2FS_1 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nor inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI31_ECOM2FS_1

//%BEGIN HDBSVT11_AOI31_ECOM2_1

`celldefine
module HDBSVT11_AOI31_ECOM2_1 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nor inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI31_ECOM2_1

//%BEGIN HDBSVT11_AOI31_Y2ECO_1

`celldefine
module HDBSVT11_AOI31_Y2ECO_1 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nor inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI31_Y2ECO_1

//%BEGIN HDBSVT11_AOI31_Y2_2

`celldefine
module HDBSVT11_AOI31_Y2_2 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nor inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI31_Y2_2

//%BEGIN HDBSVT11_AOI31_Y2_4

`celldefine
module HDBSVT11_AOI31_Y2_4 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nor inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI31_Y2_4

//%BEGIN HDBSVT11_AOI31_Y2_8

`celldefine
module HDBSVT11_AOI31_Y2_8 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nor inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI31_Y2_8

//%BEGIN HDBSVT11_AOI32_1

`celldefine
module HDBSVT11_AOI32_1 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);
   and inst1  (int_res_1, B1, B2);
   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);      
   `else
      nor inst3  (X, int_res_0, int_res_1);     
   `endif

   `ifdef VIRL_functiononly
   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_AOI32_1

//%BEGIN HDBSVT11_AOI32_Y2_2

`celldefine
module HDBSVT11_AOI32_Y2_2 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);
   and inst1  (int_res_1, B1, B2);
   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);      
   `else
      nor inst3  (X, int_res_0, int_res_1);     
   `endif

   `ifdef VIRL_functiononly
   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_AOI32_Y2_2

//%BEGIN HDBSVT11_AOI32_Y2_4

`celldefine
module HDBSVT11_AOI32_Y2_4 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);
   and inst1  (int_res_1, B1, B2);
   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);      
   `else
      nor inst3  (X, int_res_0, int_res_1);     
   `endif

   `ifdef VIRL_functiononly
   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_AOI32_Y2_4

//%BEGIN HDBSVT11_AOI32_Y2_8

`celldefine
module HDBSVT11_AOI32_Y2_8 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);
   and inst1  (int_res_1, B1, B2);
   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);      
   `else
      nor inst3  (X, int_res_0, int_res_1);     
   `endif

   `ifdef VIRL_functiononly
   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_AOI32_Y2_8

//%BEGIN HDBSVT11_AOI33_1

`celldefine
module HDBSVT11_AOI33_1 (X, A1, A2, A3, B1, B2, B3);
   output X;
   input A1, A2, A3, B1, B2, B3;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);
   and inst1  (int_res_1, B1, B2, B3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI33_1

//%BEGIN HDBSVT11_AOI33_D1_1

`celldefine
module HDBSVT11_AOI33_D1_1 (X, A1, A2, A3, B1, B2, B3);
   output X;
   input A1, A2, A3, B1, B2, B3;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);
   and inst1  (int_res_1, B1, B2, B3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI33_D1_1

//%BEGIN HDBSVT11_AOI33_Y2_2

`celldefine
module HDBSVT11_AOI33_Y2_2 (X, A1, A2, A3, B1, B2, B3);
   output X;
   input A1, A2, A3, B1, B2, B3;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);
   and inst1  (int_res_1, B1, B2, B3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI33_Y2_2

//%BEGIN HDBSVT11_AOI33_Y2_4

`celldefine
module HDBSVT11_AOI33_Y2_4 (X, A1, A2, A3, B1, B2, B3);
   output X;
   input A1, A2, A3, B1, B2, B3;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);
   and inst1  (int_res_1, B1, B2, B3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI33_Y2_4

//%BEGIN HDBSVT11_AOI33_Y4_8

`celldefine
module HDBSVT11_AOI33_Y4_8 (X, A1, A2, A3, B1, B2, B3);
   output X;
   input A1, A2, A3, B1, B2, B3;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2, A3);
   and inst1  (int_res_1, B1, B2, B3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1 && B3==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B3==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1 && B2==1'b1) (B3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_AOI33_Y4_8

//%BEGIN HDBSVT11_BUF_1

`celldefine
module HDBSVT11_BUF_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_1

//%BEGIN HDBSVT11_BUF_10

`celldefine
module HDBSVT11_BUF_10 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_10

//%BEGIN HDBSVT11_BUF_12

`celldefine
module HDBSVT11_BUF_12 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_12

//%BEGIN HDBSVT11_BUF_16

`celldefine
module HDBSVT11_BUF_16 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_16

//%BEGIN HDBSVT11_BUF_2

`celldefine
module HDBSVT11_BUF_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_2

//%BEGIN HDBSVT11_BUF_3

`celldefine
module HDBSVT11_BUF_3 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_3

//%BEGIN HDBSVT11_BUF_4

`celldefine
module HDBSVT11_BUF_4 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_4

//%BEGIN HDBSVT11_BUF_6

`celldefine
module HDBSVT11_BUF_6 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_6

//%BEGIN HDBSVT11_BUF_8

`celldefine
module HDBSVT11_BUF_8 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_8

//%BEGIN HDBSVT11_BUF_CBCK_4
`celldefine
module HDBSVT11_BUF_CBCK_4 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_BUF_CBCK_4

//%BEGIN HDBSVT11_BUF_CBCK_6
`celldefine
module HDBSVT11_BUF_CBCK_6 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_BUF_CBCK_6

//%BEGIN HDBSVT11_BUF_CBCK_8
`celldefine
module HDBSVT11_BUF_CBCK_8 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_BUF_CBCK_8

//%BEGIN HDBSVT11_BUF_CBECOM2FS_1

`celldefine
module HDBSVT11_BUF_CBECOM2FS_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CBECOM2FS_1

//%BEGIN HDBSVT11_BUF_CBECOM2FS_2

`celldefine
module HDBSVT11_BUF_CBECOM2FS_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CBECOM2FS_2

//%BEGIN HDBSVT11_BUF_CBECOM2_1

`celldefine
module HDBSVT11_BUF_CBECOM2_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CBECOM2_1

//%BEGIN HDBSVT11_BUF_CBECOM2_2

`celldefine
module HDBSVT11_BUF_CBECOM2_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CBECOM2_2

//%BEGIN HDBSVT11_BUF_CBECO_1

`celldefine
module HDBSVT11_BUF_CBECO_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CBECO_1

//%BEGIN HDBSVT11_BUF_CBY2ECO_2

`celldefine
module HDBSVT11_BUF_CBY2ECO_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CBY2ECO_2

//%BEGIN HDBSVT11_BUF_CBY2ECO_3

`celldefine
module HDBSVT11_BUF_CBY2ECO_3 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CBY2ECO_3

//%BEGIN HDBSVT11_BUF_CBY3ECO_4

`celldefine
module HDBSVT11_BUF_CBY3ECO_4 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CBY3ECO_4

//%BEGIN HDBSVT11_BUF_CBY4ECO_6

`celldefine
module HDBSVT11_BUF_CBY4ECO_6 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CBY4ECO_6

//%BEGIN HDBSVT11_BUF_CBY4ECO_7

`celldefine
module HDBSVT11_BUF_CBY4ECO_7 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CBY4ECO_7

//%BEGIN HDBSVT11_BUF_CBY4ECO_8

`celldefine
module HDBSVT11_BUF_CBY4ECO_8 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CBY4ECO_8

//%BEGIN HDBSVT11_BUF_CB_1

`celldefine
module HDBSVT11_BUF_CB_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CB_1

//%BEGIN HDBSVT11_BUF_CB_2

`celldefine
module HDBSVT11_BUF_CB_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CB_2

//%BEGIN HDBSVT11_BUF_CB_4

`celldefine
module HDBSVT11_BUF_CB_4 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CB_4

//%BEGIN HDBSVT11_BUF_CB_6

`celldefine
module HDBSVT11_BUF_CB_6 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CB_6

//%BEGIN HDBSVT11_BUF_CB_8

`celldefine
module HDBSVT11_BUF_CB_8 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CB_8

//%BEGIN HDBSVT11_BUF_CDC_1

`celldefine
module HDBSVT11_BUF_CDC_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CDC_1

//%BEGIN HDBSVT11_BUF_CDC_2

`celldefine
module HDBSVT11_BUF_CDC_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CDC_2

//%BEGIN HDBSVT11_BUF_CDC_4

`celldefine
module HDBSVT11_BUF_CDC_4 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_CDC_4

//%BEGIN HDBSVT11_BUF_CKY2_20
`celldefine
module HDBSVT11_BUF_CKY2_20 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_BUF_CKY2_20

//%BEGIN HDBSVT11_BUF_CKY4_16
`celldefine
module HDBSVT11_BUF_CKY4_16 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_BUF_CKY4_16

//%BEGIN HDBSVT11_BUF_CKY4_20
`celldefine
module HDBSVT11_BUF_CKY4_20 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_BUF_CKY4_20

//%BEGIN HDBSVT11_BUF_CK_1
`celldefine
module HDBSVT11_BUF_CK_1 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_BUF_CK_1

//%BEGIN HDBSVT11_BUF_CK_10
`celldefine
module HDBSVT11_BUF_CK_10 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_BUF_CK_10

//%BEGIN HDBSVT11_BUF_CK_12
`celldefine
module HDBSVT11_BUF_CK_12 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_BUF_CK_12

//%BEGIN HDBSVT11_BUF_CK_16
`celldefine
module HDBSVT11_BUF_CK_16 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_BUF_CK_16

//%BEGIN HDBSVT11_BUF_CK_2
`celldefine
module HDBSVT11_BUF_CK_2 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_BUF_CK_2

//%BEGIN HDBSVT11_BUF_CK_3
`celldefine
module HDBSVT11_BUF_CK_3 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_BUF_CK_3

//%BEGIN HDBSVT11_BUF_CK_4
`celldefine
module HDBSVT11_BUF_CK_4 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_BUF_CK_4

//%BEGIN HDBSVT11_BUF_CK_5
`celldefine
module HDBSVT11_BUF_CK_5 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_BUF_CK_5

//%BEGIN HDBSVT11_BUF_CK_6
`celldefine
module HDBSVT11_BUF_CK_6 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_BUF_CK_6

//%BEGIN HDBSVT11_BUF_CK_8
`celldefine
module HDBSVT11_BUF_CK_8 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_BUF_CK_8

//%BEGIN HDBSVT11_BUF_DY2_12

`celldefine
module HDBSVT11_BUF_DY2_12 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_DY2_12

//%BEGIN HDBSVT11_BUF_DY2_16

`celldefine
module HDBSVT11_BUF_DY2_16 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_DY2_16

//%BEGIN HDBSVT11_BUF_DY2_20

`celldefine
module HDBSVT11_BUF_DY2_20 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_DY2_20

//%BEGIN HDBSVT11_BUF_DY2_32

`celldefine
module HDBSVT11_BUF_DY2_32 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_DY2_32

//%BEGIN HDBSVT11_BUF_DY4_12

`celldefine
module HDBSVT11_BUF_DY4_12 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_DY4_12

//%BEGIN HDBSVT11_BUF_DY4_16

`celldefine
module HDBSVT11_BUF_DY4_16 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_DY4_16

//%BEGIN HDBSVT11_BUF_DY4_20

`celldefine
module HDBSVT11_BUF_DY4_20 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_DY4_20

//%BEGIN HDBSVT11_BUF_D_12

`celldefine
module HDBSVT11_BUF_D_12 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_D_12

//%BEGIN HDBSVT11_BUF_D_16

`celldefine
module HDBSVT11_BUF_D_16 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_D_16

//%BEGIN HDBSVT11_BUF_D_4

`celldefine
module HDBSVT11_BUF_D_4 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_D_4

//%BEGIN HDBSVT11_BUF_D_8

`celldefine
module HDBSVT11_BUF_D_8 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_D_8

//%BEGIN HDBSVT11_BUF_ECOM2FS_1

`celldefine
module HDBSVT11_BUF_ECOM2FS_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_ECOM2FS_1

//%BEGIN HDBSVT11_BUF_ECOM2FS_2

`celldefine
module HDBSVT11_BUF_ECOM2FS_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_ECOM2FS_2

//%BEGIN HDBSVT11_BUF_ECOM2_1

`celldefine
module HDBSVT11_BUF_ECOM2_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_ECOM2_1

//%BEGIN HDBSVT11_BUF_ECOM2_2

`celldefine
module HDBSVT11_BUF_ECOM2_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_ECOM2_2

//%BEGIN HDBSVT11_BUF_ECO_1

`celldefine
module HDBSVT11_BUF_ECO_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_ECO_1

//%BEGIN HDBSVT11_BUF_M12Y4_8
`celldefine
module HDBSVT11_BUF_M12Y4_8 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_COMBO_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_BUF_M12Y4_8

//%BEGIN HDBSVT11_BUF_MP_10

`celldefine
module HDBSVT11_BUF_MP_10 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_MP_10

//%BEGIN HDBSVT11_BUF_M_6

`celldefine
module HDBSVT11_BUF_M_6 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_M_6

//%BEGIN HDBSVT11_BUF_SY4FS_48

`celldefine
module HDBSVT11_BUF_SY4FS_48 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_SY4FS_48

//%BEGIN HDBSVT11_BUF_SY4FS_64

`celldefine
module HDBSVT11_BUF_SY4FS_64 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_SY4FS_64

//%BEGIN HDBSVT11_BUF_SY4_48

`celldefine
module HDBSVT11_BUF_SY4_48 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_SY4_48

//%BEGIN HDBSVT11_BUF_SY4_64

`celldefine
module HDBSVT11_BUF_SY4_64 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_SY4_64

//%BEGIN HDBSVT11_BUF_SY8FS_128

`celldefine
module HDBSVT11_BUF_SY8FS_128 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_SY8FS_128

//%BEGIN HDBSVT11_BUF_SY8FS_96

`celldefine
module HDBSVT11_BUF_SY8FS_96 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_SY8FS_96

//%BEGIN HDBSVT11_BUF_SY8_128

`celldefine
module HDBSVT11_BUF_SY8_128 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_SY8_128

//%BEGIN HDBSVT11_BUF_SY8_96

`celldefine
module HDBSVT11_BUF_SY8_96 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_SY8_96

//%BEGIN HDBSVT11_BUF_TIE0Y4FS_4

`celldefine
module HDBSVT11_BUF_TIE0Y4FS_4 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_TIE0Y4FS_4

//%BEGIN HDBSVT11_BUF_TIE0Y4_4

`celldefine
module HDBSVT11_BUF_TIE0Y4_4 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_TIE0Y4_4

//%BEGIN HDBSVT11_BUF_Y2ECO_2

`celldefine
module HDBSVT11_BUF_Y2ECO_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_Y2ECO_2

//%BEGIN HDBSVT11_BUF_Y2ECO_3

`celldefine
module HDBSVT11_BUF_Y2ECO_3 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_Y2ECO_3

//%BEGIN HDBSVT11_BUF_Y2_20

`celldefine
module HDBSVT11_BUF_Y2_20 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_Y2_20

//%BEGIN HDBSVT11_BUF_Y3ECO_4

`celldefine
module HDBSVT11_BUF_Y3ECO_4 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_Y3ECO_4

//%BEGIN HDBSVT11_BUF_Y4ECO_6

`celldefine
module HDBSVT11_BUF_Y4ECO_6 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_Y4ECO_6

//%BEGIN HDBSVT11_BUF_Y4ECO_7

`celldefine
module HDBSVT11_BUF_Y4ECO_7 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_Y4ECO_7

//%BEGIN HDBSVT11_BUF_Y4ECO_8

`celldefine
module HDBSVT11_BUF_Y4ECO_8 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_Y4ECO_8

//%BEGIN HDBSVT11_BUF_Y4_16

`celldefine
module HDBSVT11_BUF_Y4_16 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_Y4_16

//%BEGIN HDBSVT11_BUF_Y4_20

`celldefine
module HDBSVT11_BUF_Y4_20 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
       buf inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_BUF_Y4_20

//%BEGIN HDBSVT11_CAPB1

`celldefine
module HDBSVT11_CAPB1 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPB1

//%BEGIN HDBSVT11_CAPBLC5

`celldefine
module HDBSVT11_CAPBLC5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPBLC5

//%BEGIN HDBSVT11_CAPBLC_Y2_5

`celldefine
module HDBSVT11_CAPBLC_Y2_5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPBLC_Y2_5

//%BEGIN HDBSVT11_CAPBLINC5

`celldefine
module HDBSVT11_CAPBLINC5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPBLINC5

//%BEGIN HDBSVT11_CAPBLINC_Y2_5

`celldefine
module HDBSVT11_CAPBLINC_Y2_5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPBLINC_Y2_5

//%BEGIN HDBSVT11_CAPBRC5

`celldefine
module HDBSVT11_CAPBRC5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPBRC5

//%BEGIN HDBSVT11_CAPBRC_Y2_5

`celldefine
module HDBSVT11_CAPBRC_Y2_5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPBRC_Y2_5

//%BEGIN HDBSVT11_CAPBRINC5

`celldefine
module HDBSVT11_CAPBRINC5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPBRINC5

//%BEGIN HDBSVT11_CAPBRINC_Y2_5

`celldefine
module HDBSVT11_CAPBRINC_Y2_5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPBRINC_Y2_5

//%BEGIN HDBSVT11_CAPBTAP_Y2_9

`celldefine
module HDBSVT11_CAPBTAP_Y2_9 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPBTAP_Y2_9

//%BEGIN HDBSVT11_CAPB_Y2_1

`celldefine
module HDBSVT11_CAPB_Y2_1 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPB_Y2_1

//%BEGIN HDBSVT11_CAPL5

`celldefine
module HDBSVT11_CAPL5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPL5

//%BEGIN HDBSVT11_CAPLVDDCUT5

`celldefine
module HDBSVT11_CAPLVDDCUT5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPLVDDCUT5

//%BEGIN HDBSVT11_CAPR5

`celldefine
module HDBSVT11_CAPR5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPR5

//%BEGIN HDBSVT11_CAPRVDDCUT5

`celldefine
module HDBSVT11_CAPRVDDCUT5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPRVDDCUT5

//%BEGIN HDBSVT11_CAPT1

`celldefine
module HDBSVT11_CAPT1 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPT1

//%BEGIN HDBSVT11_CAPTLC5

`celldefine
module HDBSVT11_CAPTLC5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPTLC5

//%BEGIN HDBSVT11_CAPTLC_Y2_5

`celldefine
module HDBSVT11_CAPTLC_Y2_5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPTLC_Y2_5

//%BEGIN HDBSVT11_CAPTLINC5

`celldefine
module HDBSVT11_CAPTLINC5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPTLINC5

//%BEGIN HDBSVT11_CAPTLINC_Y2_5

`celldefine
module HDBSVT11_CAPTLINC_Y2_5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPTLINC_Y2_5

//%BEGIN HDBSVT11_CAPTRC5

`celldefine
module HDBSVT11_CAPTRC5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPTRC5

//%BEGIN HDBSVT11_CAPTRC_Y2_5

`celldefine
module HDBSVT11_CAPTRC_Y2_5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPTRC_Y2_5

//%BEGIN HDBSVT11_CAPTRINC5

`celldefine
module HDBSVT11_CAPTRINC5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPTRINC5

//%BEGIN HDBSVT11_CAPTRINC_Y2_5

`celldefine
module HDBSVT11_CAPTRINC_Y2_5 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPTRINC_Y2_5

//%BEGIN HDBSVT11_CAPTTAP_Y2_9

`celldefine
module HDBSVT11_CAPTTAP_Y2_9 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPTTAP_Y2_9

//%BEGIN HDBSVT11_CAPT_Y2_1

`celldefine
module HDBSVT11_CAPT_Y2_1 ();
endmodule
`endcelldefine

//%END HDBSVT11_CAPT_Y2_1

//%BEGIN HDBSVT11_CKBFMPCT_Y10_8
`celldefine
module HDBSVT11_CKBFMPCT_Y10_8 (Z, CLK);
  input CLK;
  output Z;


  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst0 (Z, CLK);
  `else
    buf inst1  (Z, CLK);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKBFMPCT_Y10_8

//%BEGIN HDBSVT11_CKGTNLT_V3Y2_1
`celldefine
module HDBSVT11_CKGTNLT_V3Y2_1 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_2, int_3, int_4, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, delayed_CLK, 1'b1, 1'b1);

  `endif
    or inst4  (int_2, delayed_E, delayed_TE);
    not inst5  (int_3, iq);
    or inst6  (int_4, delayed_CLK, int_3);
    snps_latch inst7  (iq, viol_x, delayed_CLK, int_2);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_4);
  `else
    buf inst9  (Z, int_4);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(negedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTNLT_V3Y2_1

//%BEGIN HDBSVT11_CKGTNLT_V3Y2_4
`celldefine
module HDBSVT11_CKGTNLT_V3Y2_4 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_2, int_3, int_4, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, delayed_CLK, 1'b1, 1'b1);

  `endif
    or inst4  (int_2, delayed_E, delayed_TE);
    not inst5  (int_3, iq);
    or inst6  (int_4, delayed_CLK, int_3);
    snps_latch inst7  (iq, viol_x, delayed_CLK, int_2);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_4);
  `else
    buf inst9  (Z, int_4);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(negedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTNLT_V3Y2_4

//%BEGIN HDBSVT11_CKGTNLT_V5Y2_1
`celldefine
module HDBSVT11_CKGTNLT_V5Y2_1 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_2, int_3, int_4, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, delayed_CLK, 1'b1, 1'b1);

  `endif
    or inst4  (int_2, delayed_E, delayed_TE);
    not inst5  (int_3, iq);
    or inst6  (int_4, delayed_CLK, int_3);
    snps_latch inst7  (iq, viol_x, delayed_CLK, int_2);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_4);
  `else
    buf inst9  (Z, int_4);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(negedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTNLT_V5Y2_1

//%BEGIN HDBSVT11_CKGTNLT_V5Y2_12
`celldefine
module HDBSVT11_CKGTNLT_V5Y2_12 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_2, int_3, int_4, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, delayed_CLK, 1'b1, 1'b1);

  `endif
    or inst4  (int_2, delayed_E, delayed_TE);
    not inst5  (int_3, iq);
    or inst6  (int_4, delayed_CLK, int_3);
    snps_latch inst7  (iq, viol_x, delayed_CLK, int_2);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_4);
  `else
    buf inst9  (Z, int_4);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(negedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTNLT_V5Y2_12

//%BEGIN HDBSVT11_CKGTNLT_V5Y2_2
`celldefine
module HDBSVT11_CKGTNLT_V5Y2_2 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_2, int_3, int_4, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, delayed_CLK, 1'b1, 1'b1);

  `endif
    or inst4  (int_2, delayed_E, delayed_TE);
    not inst5  (int_3, iq);
    or inst6  (int_4, delayed_CLK, int_3);
    snps_latch inst7  (iq, viol_x, delayed_CLK, int_2);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_4);
  `else
    buf inst9  (Z, int_4);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(negedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTNLT_V5Y2_2

//%BEGIN HDBSVT11_CKGTNLT_V5Y2_3
`celldefine
module HDBSVT11_CKGTNLT_V5Y2_3 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_2, int_3, int_4, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, delayed_CLK, 1'b1, 1'b1);

  `endif
    or inst4  (int_2, delayed_E, delayed_TE);
    not inst5  (int_3, iq);
    or inst6  (int_4, delayed_CLK, int_3);
    snps_latch inst7  (iq, viol_x, delayed_CLK, int_2);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_4);
  `else
    buf inst9  (Z, int_4);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(negedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTNLT_V5Y2_3

//%BEGIN HDBSVT11_CKGTNLT_V5Y2_4
`celldefine
module HDBSVT11_CKGTNLT_V5Y2_4 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_2, int_3, int_4, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, delayed_CLK, 1'b1, 1'b1);

  `endif
    or inst4  (int_2, delayed_E, delayed_TE);
    not inst5  (int_3, iq);
    or inst6  (int_4, delayed_CLK, int_3);
    snps_latch inst7  (iq, viol_x, delayed_CLK, int_2);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_4);
  `else
    buf inst9  (Z, int_4);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(negedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTNLT_V5Y2_4

//%BEGIN HDBSVT11_CKGTNLT_V5Y2_5
`celldefine
module HDBSVT11_CKGTNLT_V5Y2_5 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_2, int_3, int_4, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, delayed_CLK, 1'b1, 1'b1);

  `endif
    or inst4  (int_2, delayed_E, delayed_TE);
    not inst5  (int_3, iq);
    or inst6  (int_4, delayed_CLK, int_3);
    snps_latch inst7  (iq, viol_x, delayed_CLK, int_2);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_4);
  `else
    buf inst9  (Z, int_4);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(negedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTNLT_V5Y2_5

//%BEGIN HDBSVT11_CKGTNLT_V5Y2_6
`celldefine
module HDBSVT11_CKGTNLT_V5Y2_6 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_2, int_3, int_4, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, delayed_CLK, 1'b1, 1'b1);

  `endif
    or inst4  (int_2, delayed_E, delayed_TE);
    not inst5  (int_3, iq);
    or inst6  (int_4, delayed_CLK, int_3);
    snps_latch inst7  (iq, viol_x, delayed_CLK, int_2);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_4);
  `else
    buf inst9  (Z, int_4);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(negedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTNLT_V5Y2_6

//%BEGIN HDBSVT11_CKGTNLT_V5Y2_7
`celldefine
module HDBSVT11_CKGTNLT_V5Y2_7 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_2, int_3, int_4, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, delayed_CLK, 1'b1, 1'b1);

  `endif
    or inst4  (int_2, delayed_E, delayed_TE);
    not inst5  (int_3, iq);
    or inst6  (int_4, delayed_CLK, int_3);
    snps_latch inst7  (iq, viol_x, delayed_CLK, int_2);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_4);
  `else
    buf inst9  (Z, int_4);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(negedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTNLT_V5Y2_7

//%BEGIN HDBSVT11_CKGTNLT_V5Y2_8
`celldefine
module HDBSVT11_CKGTNLT_V5Y2_8 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_2, int_3, int_4, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, delayed_CLK, 1'b1, 1'b1);

  `endif
    or inst4  (int_2, delayed_E, delayed_TE);
    not inst5  (int_3, iq);
    or inst6  (int_4, delayed_CLK, int_3);
    snps_latch inst7  (iq, viol_x, delayed_CLK, int_2);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_4);
  `else
    buf inst9  (Z, int_4);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(negedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTNLT_V5Y2_8

//%BEGIN HDBSVT11_CKGTPLTN_V7Y2_1
`celldefine
module HDBSVT11_CKGTPLTN_V7Y2_1 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  reg viol_0;
  wire viol_x, int_2, int_3, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_EN, EN);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, int_2, 1'b1, 1'b1);

  `endif
    not inst3  (int_2, delayed_CLK);
    and inst4  (int_3, delayed_CLK, iq);
    snps_latch inst5  (iq, viol_x, int_2, delayed_EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst6 (Z, int_3);
  `else
    buf inst7  (Z, int_3);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst8  (ENABLE_NOT_EN, EN);
buf inst9  (ENABLE_EN, EN);

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (EN==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_EN , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_EN , 0 ,0, viol_0);
$setuphold(posedge CLK , posedge EN , 0 ,0, viol_0, , , delayed_CLK, delayed_EN);
$setuphold(posedge CLK , negedge EN , 0 ,0, viol_0, , , delayed_CLK, delayed_EN);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLTN_V7Y2_1

//%BEGIN HDBSVT11_CKGTPLTN_V7Y2_2
`celldefine
module HDBSVT11_CKGTPLTN_V7Y2_2 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  reg viol_0;
  wire viol_x, int_2, int_3, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_EN, EN);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, int_2, 1'b1, 1'b1);

  `endif
    not inst3  (int_2, delayed_CLK);
    and inst4  (int_3, delayed_CLK, iq);
    snps_latch inst5  (iq, viol_x, int_2, delayed_EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst6 (Z, int_3);
  `else
    buf inst7  (Z, int_3);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst8  (ENABLE_NOT_EN, EN);
buf inst9  (ENABLE_EN, EN);

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (EN==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_EN , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_EN , 0 ,0, viol_0);
$setuphold(posedge CLK , posedge EN , 0 ,0, viol_0, , , delayed_CLK, delayed_EN);
$setuphold(posedge CLK , negedge EN , 0 ,0, viol_0, , , delayed_CLK, delayed_EN);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLTN_V7Y2_2

//%BEGIN HDBSVT11_CKGTPLTN_V7Y2_4
`celldefine
module HDBSVT11_CKGTPLTN_V7Y2_4 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  reg viol_0;
  wire viol_x, int_2, int_3, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_EN, EN);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, int_2, 1'b1, 1'b1);

  `endif
    not inst3  (int_2, delayed_CLK);
    and inst4  (int_3, delayed_CLK, iq);
    snps_latch inst5  (iq, viol_x, int_2, delayed_EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst6 (Z, int_3);
  `else
    buf inst7  (Z, int_3);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst8  (ENABLE_NOT_EN, EN);
buf inst9  (ENABLE_EN, EN);

specify
if (EN==1'b1) (CLK +=> Z)=(0, 0);
if (EN==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_EN , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_EN , 0 ,0, viol_0);
$setuphold(posedge CLK , posedge EN , 0 ,0, viol_0, , , delayed_CLK, delayed_EN);
$setuphold(posedge CLK , negedge EN , 0 ,0, viol_0, , , delayed_CLK, delayed_EN);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLTN_V7Y2_4

//%BEGIN HDBSVT11_CKGTPLT_CBV7Y2_1
`celldefine
module HDBSVT11_CKGTPLT_CBV7Y2_1 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    snps_latch inst7  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_6);
  `else
    buf inst9  (Z, int_6);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLT_CBV7Y2_1

//%BEGIN HDBSVT11_CKGTPLT_CBV7Y2_4
`celldefine
module HDBSVT11_CKGTPLT_CBV7Y2_4 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    snps_latch inst7  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_6);
  `else
    buf inst9  (Z, int_6);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLT_CBV7Y2_4

//%BEGIN HDBSVT11_CKGTPLT_V7Y2_1
`celldefine
module HDBSVT11_CKGTPLT_V7Y2_1 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    snps_latch inst7  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_6);
  `else
    buf inst9  (Z, int_6);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLT_V7Y2_1

//%BEGIN HDBSVT11_CKGTPLT_V7Y2_10
`celldefine
module HDBSVT11_CKGTPLT_V7Y2_10 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    snps_latch inst7  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_6);
  `else
    buf inst9  (Z, int_6);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLT_V7Y2_10

//%BEGIN HDBSVT11_CKGTPLT_V7Y2_12
`celldefine
module HDBSVT11_CKGTPLT_V7Y2_12 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    snps_latch inst7  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_6);
  `else
    buf inst9  (Z, int_6);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLT_V7Y2_12

//%BEGIN HDBSVT11_CKGTPLT_V7Y2_16
`celldefine
module HDBSVT11_CKGTPLT_V7Y2_16 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    snps_latch inst7  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_6);
  `else
    buf inst9  (Z, int_6);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLT_V7Y2_16

//%BEGIN HDBSVT11_CKGTPLT_V7Y2_2
`celldefine
module HDBSVT11_CKGTPLT_V7Y2_2 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    snps_latch inst7  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_6);
  `else
    buf inst9  (Z, int_6);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLT_V7Y2_2

//%BEGIN HDBSVT11_CKGTPLT_V7Y2_20
`celldefine
module HDBSVT11_CKGTPLT_V7Y2_20 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    snps_latch inst7  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_6);
  `else
    buf inst9  (Z, int_6);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLT_V7Y2_20

//%BEGIN HDBSVT11_CKGTPLT_V7Y2_24
`celldefine
module HDBSVT11_CKGTPLT_V7Y2_24 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    snps_latch inst7  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_6);
  `else
    buf inst9  (Z, int_6);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLT_V7Y2_24

//%BEGIN HDBSVT11_CKGTPLT_V7Y2_3
`celldefine
module HDBSVT11_CKGTPLT_V7Y2_3 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    snps_latch inst7  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_6);
  `else
    buf inst9  (Z, int_6);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLT_V7Y2_3

//%BEGIN HDBSVT11_CKGTPLT_V7Y2_4
`celldefine
module HDBSVT11_CKGTPLT_V7Y2_4 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    snps_latch inst7  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_6);
  `else
    buf inst9  (Z, int_6);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLT_V7Y2_4

//%BEGIN HDBSVT11_CKGTPLT_V7Y2_5
`celldefine
module HDBSVT11_CKGTPLT_V7Y2_5 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    snps_latch inst7  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_6);
  `else
    buf inst9  (Z, int_6);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLT_V7Y2_5

//%BEGIN HDBSVT11_CKGTPLT_V7Y2_6
`celldefine
module HDBSVT11_CKGTPLT_V7Y2_6 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    snps_latch inst7  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_6);
  `else
    buf inst9  (Z, int_6);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLT_V7Y2_6

//%BEGIN HDBSVT11_CKGTPLT_V7Y2_7
`celldefine
module HDBSVT11_CKGTPLT_V7Y2_7 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    snps_latch inst7  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_6);
  `else
    buf inst9  (Z, int_6);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLT_V7Y2_7

//%BEGIN HDBSVT11_CKGTPLT_V7Y2_8
`celldefine
module HDBSVT11_CKGTPLT_V7Y2_8 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    snps_latch inst7  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst8 (Z, int_6);
  `else
    buf inst9  (Z, int_6);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst10  (_net_0, TE);
not inst11  (_net_1, E);
and inst12  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst13  (_net_2, E);
and inst14  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst15  (_net_3, TE);
and inst16  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst17  (ENABLE_E_AND_TE, TE, E);
not inst18  (ENABLE_NOT_TE, TE);
not inst19  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK +=> Z)=(0, 0);
ifnone (CLK +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKGTPLT_V7Y2_8

//%BEGIN HDBSVT11_CKINMPCT_Y10_8
`celldefine
module HDBSVT11_CKINMPCT_Y10_8 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKINMPCT_Y10_8

//%BEGIN HDBSVT11_CKINVGTPLT_V7Y2_1
`celldefine
module HDBSVT11_CKINVGTPLT_V7Y2_1 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, int_7, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    not inst7  (int_7, int_6);
    snps_latch inst8  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst9 (Z, int_7);
  `else
    buf inst10  (Z, int_7);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, TE);
not inst12  (_net_1, E);
and inst13  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst14  (_net_2, E);
and inst15  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst16  (_net_3, TE);
and inst17  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst18  (ENABLE_E_AND_TE, TE, E);
not inst19  (ENABLE_NOT_TE, TE);
not inst20  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK -=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK -=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK -=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK -=> Z)=(0, 0);
ifnone (CLK -=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKINVGTPLT_V7Y2_1

//%BEGIN HDBSVT11_CKINVGTPLT_V7Y2_2
`celldefine
module HDBSVT11_CKINVGTPLT_V7Y2_2 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, int_7, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    not inst7  (int_7, int_6);
    snps_latch inst8  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst9 (Z, int_7);
  `else
    buf inst10  (Z, int_7);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, TE);
not inst12  (_net_1, E);
and inst13  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst14  (_net_2, E);
and inst15  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst16  (_net_3, TE);
and inst17  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst18  (ENABLE_E_AND_TE, TE, E);
not inst19  (ENABLE_NOT_TE, TE);
not inst20  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK -=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK -=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK -=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK -=> Z)=(0, 0);
ifnone (CLK -=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKINVGTPLT_V7Y2_2

//%BEGIN HDBSVT11_CKINVGTPLT_V7Y2_3
`celldefine
module HDBSVT11_CKINVGTPLT_V7Y2_3 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, int_7, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    not inst7  (int_7, int_6);
    snps_latch inst8  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst9 (Z, int_7);
  `else
    buf inst10  (Z, int_7);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, TE);
not inst12  (_net_1, E);
and inst13  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst14  (_net_2, E);
and inst15  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst16  (_net_3, TE);
and inst17  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst18  (ENABLE_E_AND_TE, TE, E);
not inst19  (ENABLE_NOT_TE, TE);
not inst20  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK -=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK -=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK -=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK -=> Z)=(0, 0);
ifnone (CLK -=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKINVGTPLT_V7Y2_3

//%BEGIN HDBSVT11_CKINVGTPLT_V7Y2_4
`celldefine
module HDBSVT11_CKINVGTPLT_V7Y2_4 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, int_7, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    not inst7  (int_7, int_6);
    snps_latch inst8  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst9 (Z, int_7);
  `else
    buf inst10  (Z, int_7);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, TE);
not inst12  (_net_1, E);
and inst13  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst14  (_net_2, E);
and inst15  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst16  (_net_3, TE);
and inst17  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst18  (ENABLE_E_AND_TE, TE, E);
not inst19  (ENABLE_NOT_TE, TE);
not inst20  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK -=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK -=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK -=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK -=> Z)=(0, 0);
ifnone (CLK -=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKINVGTPLT_V7Y2_4

//%BEGIN HDBSVT11_CKINVGTPLT_V7Y2_5
`celldefine
module HDBSVT11_CKINVGTPLT_V7Y2_5 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, int_7, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    not inst7  (int_7, int_6);
    snps_latch inst8  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst9 (Z, int_7);
  `else
    buf inst10  (Z, int_7);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, TE);
not inst12  (_net_1, E);
and inst13  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst14  (_net_2, E);
and inst15  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst16  (_net_3, TE);
and inst17  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst18  (ENABLE_E_AND_TE, TE, E);
not inst19  (ENABLE_NOT_TE, TE);
not inst20  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK -=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK -=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK -=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK -=> Z)=(0, 0);
ifnone (CLK -=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKINVGTPLT_V7Y2_5

//%BEGIN HDBSVT11_CKINVGTPLT_V7Y2_6
`celldefine
module HDBSVT11_CKINVGTPLT_V7Y2_6 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, int_7, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    not inst7  (int_7, int_6);
    snps_latch inst8  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst9 (Z, int_7);
  `else
    buf inst10  (Z, int_7);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, TE);
not inst12  (_net_1, E);
and inst13  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst14  (_net_2, E);
and inst15  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst16  (_net_3, TE);
and inst17  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst18  (ENABLE_E_AND_TE, TE, E);
not inst19  (ENABLE_NOT_TE, TE);
not inst20  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK -=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK -=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK -=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK -=> Z)=(0, 0);
ifnone (CLK -=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKINVGTPLT_V7Y2_6

//%BEGIN HDBSVT11_CKINVGTPLT_V7Y2_8
`celldefine
module HDBSVT11_CKINVGTPLT_V7Y2_8 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, int_7, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_E, delayed_TE);
    not inst5  (int_5, delayed_CLK);
    and inst6  (int_6, delayed_CLK, iq);
    not inst7  (int_7, int_6);
    snps_latch inst8  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst9 (Z, int_7);
  `else
    buf inst10  (Z, int_7);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, TE);
not inst12  (_net_1, E);
and inst13  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst14  (_net_2, E);
and inst15  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst16  (_net_3, TE);
and inst17  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst18  (ENABLE_E_AND_TE, TE, E);
not inst19  (ENABLE_NOT_TE, TE);
not inst20  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (CLK -=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK -=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK -=> Z)=(0, 0);
if (E==1'b0 && TE==1'b0) (CLK -=> Z)=(0, 0);
ifnone (CLK -=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKINVGTPLT_V7Y2_8

//%BEGIN HDBSVT11_CKLDAO21NQ_CBV2Y2_1
`celldefine
module HDBSVT11_CKLDAO21NQ_CBV2Y2_1 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKLDAO21NQ_CBV2Y2_1

//%BEGIN HDBSVT11_CKLDAO21NQ_V2Y2_1
`celldefine
module HDBSVT11_CKLDAO21NQ_V2Y2_1 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKLDAO21NQ_V2Y2_1

//%BEGIN HDBSVT11_CKLDAO21NQ_V2Y2_2
`celldefine
module HDBSVT11_CKLDAO21NQ_V2Y2_2 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKLDAO21NQ_V2Y2_2

//%BEGIN HDBSVT11_CKLDAO21NQ_V2Y2_4
`celldefine
module HDBSVT11_CKLDAO21NQ_V2Y2_4 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKLDAO21NQ_V2Y2_4

//%BEGIN HDBSVT11_CKLDAO21NQ_V2Y2_8
`celldefine
module HDBSVT11_CKLDAO21NQ_V2Y2_8 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKLDAO21NQ_V2Y2_8

//%BEGIN HDBSVT11_CKLDCKNR2PQ_Y2_5

`celldefine
module HDBSVT11_CKLDCKNR2PQ_Y2_5 (Q, CLK1, CLK2, D);
   output Q;
   input CLK1, CLK2, D;

   reg viol_0;
     wire viol_x;
   wire delayed_CLK1, delayed_D, delayed_CLK2;

   wire int_res__G;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CLK1, CLK1);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_CLK2, CLK2);
`endif

   or inst3  (int_res__G, delayed_CLK1, delayed_CLK2);
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_res__G, 1'b1, 1'b1);

  `endif
`ifdef VIRL_functiononly
   snps_latch  #`SNPS_CKGT_DELAY  inst5 (Q, viol_x, int_res__G, delayed_D);
`else
   snps_latch inst6  (Q, viol_x, int_res__G, delayed_D);
`endif
`ifdef VIRL_functiononly
`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst7  (_net_0, D);
not inst8  (_net_1, CLK2);
and inst9  (ENABLE_NOT_CLK2_AND_NOT_D, _net_0, _net_1);
not inst10  (_net_2, CLK2);
and inst11  (ENABLE_NOT_CLK2_AND_D, D, _net_2);
not inst12  (_net_3, D);
not inst13  (_net_4, CLK1);
and inst14  (ENABLE_NOT_CLK1_AND_NOT_D, _net_3, _net_4);
not inst15  (_net_5, CLK1);
and inst16  (ENABLE_NOT_CLK1_AND_D, D, _net_5);
not inst17  (ENABLE_NOT_CLK2, CLK2);
not inst18  (ENABLE_NOT_CLK1, CLK1);

specify
if (CLK2==1'b0 && D==1'b0) (posedge CLK1 => (Q -: 1'b1))=(0, 0);
if (CLK2==1'b0 && D==1'b1) (posedge CLK1 => (Q +: 1'b1))=(0, 0);
(posedge CLK1 => (Q : 1'b1))=(0, 0);
if (CLK1==1'b0 && D==1'b0) (posedge CLK2 => (Q -: 1'b1))=(0, 0);
if (CLK1==1'b0 && D==1'b1) (posedge CLK2 => (Q +: 1'b1))=(0, 0);
(posedge CLK2 => (Q : 1'b1))=(0, 0);
if (CLK1==1'b0 && CLK2==1'b1) (D +=> Q)=(0, 0);
if (CLK1==1'b1 && CLK2==1'b0) (D +=> Q)=(0, 0);
if (CLK1==1'b1 && CLK2==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
$width(posedge CLK1 &&& ENABLE_NOT_CLK2_AND_NOT_D , 0 ,0, viol_0);
$width(posedge CLK1 &&& ENABLE_NOT_CLK2_AND_D , 0 ,0, viol_0);
$width(posedge CLK2 &&& ENABLE_NOT_CLK1_AND_NOT_D , 0 ,0, viol_0);
$width(posedge CLK2 &&& ENABLE_NOT_CLK1_AND_D , 0 ,0, viol_0);
$setuphold(negedge CLK1 &&& ENABLE_NOT_CLK2 , posedge D &&& ENABLE_NOT_CLK2 , 0 ,0, viol_0, , , delayed_CLK1, delayed_D);
$setuphold(negedge CLK1 &&& ENABLE_NOT_CLK2 , negedge D &&& ENABLE_NOT_CLK2 , 0 ,0, viol_0, , , delayed_CLK1, delayed_D);
$setuphold(negedge CLK2 &&& ENABLE_NOT_CLK1 , posedge D &&& ENABLE_NOT_CLK1 , 0 ,0, viol_0, , , delayed_CLK2, delayed_D);
$setuphold(negedge CLK2 &&& ENABLE_NOT_CLK1 , negedge D &&& ENABLE_NOT_CLK1 , 0 ,0, viol_0, , , delayed_CLK2, delayed_D);
endspecify
`endif
endmodule
`endcelldefine

//%END HDBSVT11_CKLDCKNR2PQ_Y2_5

//%BEGIN HDBSVT11_CKLDND2NQ_Y2_1

`celldefine
module HDBSVT11_CKLDND2NQ_Y2_1 (Z, CLK, E, TE);
   output Z;
   input CLK, TE, E;

   reg viol_0;
     wire viol_x;
   wire delayed_CLK, delayed_TE, delayed_E;

   wire int_res__q, int_res__g, int_res__d;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CLK, CLK);
   buf inst1  (delayed_TE, TE);
   buf inst2  (delayed_E, E);
`endif

   and inst3  (int_res__d, delayed_TE, delayed_E);
   not inst4  (int_res__g, delayed_CLK);
   snps_latch inst5  (int_res__q, viol_x, int_res__g, int_res__d);
   
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst6  (viol_x, viol_0, int_res__g, 1'b1, 1'b1);

  `endif
`ifdef VIRL_functiononly
   buf #`SNPS_CKGT_DELAY  inst7 (Z, int_res__q);
`else
   buf inst8  (Z, int_res__q);
`endif
`ifdef VIRL_functiononly
`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
buf inst17  (ENABLE_TE, TE);
buf inst18  (ENABLE_E, E);

specify
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b1) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b1) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_TE , posedge E &&& ENABLE_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_TE , negedge E &&& ENABLE_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_E , posedge TE &&& ENABLE_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_E , negedge TE &&& ENABLE_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
`endif
endmodule
`endcelldefine

//%END HDBSVT11_CKLDND2NQ_Y2_1

//%BEGIN HDBSVT11_CKLDND2NQ_Y2_2

`celldefine
module HDBSVT11_CKLDND2NQ_Y2_2 (Z, CLK, E, TE);
   output Z;
   input CLK, TE, E;

   reg viol_0;
     wire viol_x;
   wire delayed_CLK, delayed_TE, delayed_E;

   wire int_res__q, int_res__g, int_res__d;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CLK, CLK);
   buf inst1  (delayed_TE, TE);
   buf inst2  (delayed_E, E);
`endif

   and inst3  (int_res__d, delayed_TE, delayed_E);
   not inst4  (int_res__g, delayed_CLK);
   snps_latch inst5  (int_res__q, viol_x, int_res__g, int_res__d);
   
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst6  (viol_x, viol_0, int_res__g, 1'b1, 1'b1);

  `endif
`ifdef VIRL_functiononly
   buf #`SNPS_CKGT_DELAY  inst7 (Z, int_res__q);
`else
   buf inst8  (Z, int_res__q);
`endif
`ifdef VIRL_functiononly
`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
buf inst17  (ENABLE_TE, TE);
buf inst18  (ENABLE_E, E);

specify
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b1) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b1) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_TE , posedge E &&& ENABLE_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_TE , negedge E &&& ENABLE_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_E , posedge TE &&& ENABLE_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_E , negedge TE &&& ENABLE_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
`endif
endmodule
`endcelldefine

//%END HDBSVT11_CKLDND2NQ_Y2_2

//%BEGIN HDBSVT11_CKLDND2NQ_Y2_4

`celldefine
module HDBSVT11_CKLDND2NQ_Y2_4 (Z, CLK, E, TE);
   output Z;
   input CLK, TE, E;

   reg viol_0;
     wire viol_x;
   wire delayed_CLK, delayed_TE, delayed_E;

   wire int_res__q, int_res__g, int_res__d;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CLK, CLK);
   buf inst1  (delayed_TE, TE);
   buf inst2  (delayed_E, E);
`endif

   and inst3  (int_res__d, delayed_TE, delayed_E);
   not inst4  (int_res__g, delayed_CLK);
   snps_latch inst5  (int_res__q, viol_x, int_res__g, int_res__d);
   
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst6  (viol_x, viol_0, int_res__g, 1'b1, 1'b1);

  `endif
`ifdef VIRL_functiononly
   buf #`SNPS_CKGT_DELAY  inst7 (Z, int_res__q);
`else
   buf inst8  (Z, int_res__q);
`endif
`ifdef VIRL_functiononly
`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
buf inst17  (ENABLE_TE, TE);
buf inst18  (ENABLE_E, E);

specify
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b1) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b1) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_TE , posedge E &&& ENABLE_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_TE , negedge E &&& ENABLE_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_E , posedge TE &&& ENABLE_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_E , negedge TE &&& ENABLE_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
`endif
endmodule
`endcelldefine

//%END HDBSVT11_CKLDND2NQ_Y2_4

//%BEGIN HDBSVT11_CKLDND2PQ_Y2_1
`celldefine
module HDBSVT11_CKLDND2PQ_Y2_1 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_2, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, delayed_CLK, 1'b1, 1'b1);

  `endif
    and inst4  (int_2, delayed_E, delayed_TE);
    snps_latch inst5  (iq, viol_x, delayed_CLK, int_2);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst6 (Z, iq);
  `else
    buf inst7  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst8  (_net_0, TE);
not inst9  (_net_1, E);
and inst10  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst11  (_net_2, E);
and inst12  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst13  (_net_3, TE);
and inst14  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst15  (ENABLE_E_AND_TE, TE, E);
buf inst16  (ENABLE_TE, TE);
buf inst17  (ENABLE_E, E);

specify
if (E==1'b0 && TE==1'b0) (posedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b1) (posedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (posedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (posedge CLK => (Z +: 1'b1))=(0, 0);
(posedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b1 && TE==1'b1) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b1 && E==1'b1) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(negedge CLK &&& ENABLE_TE , posedge E &&& ENABLE_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_TE , negedge E &&& ENABLE_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_E , posedge TE &&& ENABLE_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(negedge CLK &&& ENABLE_E , negedge TE &&& ENABLE_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKLDND2PQ_Y2_1

//%BEGIN HDBSVT11_CKLDND2PQ_Y2_2
`celldefine
module HDBSVT11_CKLDND2PQ_Y2_2 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_2, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, delayed_CLK, 1'b1, 1'b1);

  `endif
    and inst4  (int_2, delayed_E, delayed_TE);
    snps_latch inst5  (iq, viol_x, delayed_CLK, int_2);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst6 (Z, iq);
  `else
    buf inst7  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst8  (_net_0, TE);
not inst9  (_net_1, E);
and inst10  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst11  (_net_2, E);
and inst12  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst13  (_net_3, TE);
and inst14  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst15  (ENABLE_E_AND_TE, TE, E);
buf inst16  (ENABLE_TE, TE);
buf inst17  (ENABLE_E, E);

specify
if (E==1'b0 && TE==1'b0) (posedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b1) (posedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (posedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (posedge CLK => (Z +: 1'b1))=(0, 0);
(posedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b1 && TE==1'b1) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b1 && E==1'b1) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(negedge CLK &&& ENABLE_TE , posedge E &&& ENABLE_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_TE , negedge E &&& ENABLE_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_E , posedge TE &&& ENABLE_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(negedge CLK &&& ENABLE_E , negedge TE &&& ENABLE_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKLDND2PQ_Y2_2

//%BEGIN HDBSVT11_CKLDNQOR2_CBY2_1
`celldefine
module HDBSVT11_CKLDNQOR2_CBY2_1 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKLDNQOR2_CBY2_1

//%BEGIN HDBSVT11_CKLDNQOR2_Y2_1
`celldefine
module HDBSVT11_CKLDNQOR2_Y2_1 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKLDNQOR2_Y2_1

//%BEGIN HDBSVT11_CKLDNQOR2_Y2_2
`celldefine
module HDBSVT11_CKLDNQOR2_Y2_2 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKLDNQOR2_Y2_2

//%BEGIN HDBSVT11_CKLDNQOR2_Y2_4
`celldefine
module HDBSVT11_CKLDNQOR2_Y2_4 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKLDNQOR2_Y2_4

//%BEGIN HDBSVT11_CKLDNQOR2_Y2_8
`celldefine
module HDBSVT11_CKLDNQOR2_Y2_8 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKLDNQOR2_Y2_8

//%BEGIN HDBSVT11_CKLDNQ_V2Y2_1
`celldefine
module HDBSVT11_CKLDNQ_V2Y2_1 (Q, CLK, D);
  input CLK, D;
  output Q;
  reg viol_0;
  wire viol_x, int_2, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_D, D);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, int_2, 1'b1, 1'b1);

  `endif
    not inst3  (int_2, delayed_CLK);
    snps_latch inst4  (iq, viol_x, int_2, delayed_D);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst5 (Q, iq);
  `else
    buf inst6  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst7  (ENABLE_NOT_D, D);
buf inst8  (ENABLE_D, D);

specify
if (D==1'b1) (negedge CLK => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge CLK => (Q +: 1'b1))=(0, 0);
(negedge CLK => (Q : 1'b1))=(0, 0);
if (CLK==1'b0) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CLK , posedge D , 0 ,0, viol_0, , , delayed_CLK, delayed_D);
$setuphold(posedge CLK , negedge D , 0 ,0, viol_0, , , delayed_CLK, delayed_D);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKLDNQ_V2Y2_1

//%BEGIN HDBSVT11_CKLDOR2PQ_Y2_1
`celldefine
module HDBSVT11_CKLDOR2PQ_Y2_1 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_2, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, delayed_CLK, 1'b1, 1'b1);

  `endif
    or inst4  (int_2, delayed_E, delayed_TE);
    snps_latch inst5  (iq, viol_x, delayed_CLK, int_2);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst6 (Z, iq);
  `else
    buf inst7  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst8  (_net_0, TE);
not inst9  (_net_1, E);
and inst10  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst11  (_net_2, E);
and inst12  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst13  (_net_3, TE);
and inst14  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst15  (ENABLE_E_AND_TE, TE, E);
not inst16  (ENABLE_NOT_TE, TE);
not inst17  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b0) (posedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b1) (posedge CLK => (Z +: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (posedge CLK => (Z +: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (posedge CLK => (Z +: 1'b1))=(0, 0);
(posedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b1 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b1 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(negedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKLDOR2PQ_Y2_1

//%BEGIN HDBSVT11_CKLDOR2PQ_Y2_2
`celldefine
module HDBSVT11_CKLDOR2PQ_Y2_2 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_2, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, delayed_CLK, 1'b1, 1'b1);

  `endif
    or inst4  (int_2, delayed_E, delayed_TE);
    snps_latch inst5  (iq, viol_x, delayed_CLK, int_2);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst6 (Z, iq);
  `else
    buf inst7  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst8  (_net_0, TE);
not inst9  (_net_1, E);
and inst10  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst11  (_net_2, E);
and inst12  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst13  (_net_3, TE);
and inst14  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst15  (ENABLE_E_AND_TE, TE, E);
not inst16  (ENABLE_NOT_TE, TE);
not inst17  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b0) (posedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b1) (posedge CLK => (Z +: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (posedge CLK => (Z +: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (posedge CLK => (Z +: 1'b1))=(0, 0);
(posedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b1 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b1 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(negedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKLDOR2PQ_Y2_2

//%BEGIN HDBSVT11_CKLDOR2PQ_Y2_4
`celldefine
module HDBSVT11_CKLDOR2PQ_Y2_4 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  reg viol_0;
  wire viol_x, int_2, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_E, E);
    buf inst2  (delayed_TE, TE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, delayed_CLK, 1'b1, 1'b1);

  `endif
    or inst4  (int_2, delayed_E, delayed_TE);
    snps_latch inst5  (iq, viol_x, delayed_CLK, int_2);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGTLT_DELAY  inst6 (Z, iq);
  `else
    buf inst7  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst8  (_net_0, TE);
not inst9  (_net_1, E);
and inst10  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst11  (_net_2, E);
and inst12  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst13  (_net_3, TE);
and inst14  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst15  (ENABLE_E_AND_TE, TE, E);
not inst16  (ENABLE_NOT_TE, TE);
not inst17  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b0) (posedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b1) (posedge CLK => (Z +: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (posedge CLK => (Z +: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (posedge CLK => (Z +: 1'b1))=(0, 0);
(posedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b1 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b1 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(negedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(negedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKLDOR2PQ_Y2_4

//%BEGIN HDBSVT11_CKLDPQ_V2Y2_1
`celldefine
module HDBSVT11_CKLDPQ_V2Y2_1 (Q, CLK, D);
  input CLK, D;
  output Q;
  reg viol_0;
  wire viol_x, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_D, D);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, delayed_CLK, 1'b1, 1'b1);

  `endif
    snps_latch inst3  (iq, viol_x, delayed_CLK, delayed_D);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst4 (Q, iq);
  `else
    buf inst5  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (D==1'b0) (posedge CLK => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge CLK => (Q +: 1'b1))=(0, 0);
(posedge CLK => (Q : 1'b1))=(0, 0);
if (CLK==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
$width(posedge CLK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CLK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(negedge CLK , posedge D , 0 ,0, viol_0, , , delayed_CLK, delayed_D);
$setuphold(negedge CLK , negedge D , 0 ,0, viol_0, , , delayed_CLK, delayed_D);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_CKLDPQ_V2Y2_1

//%BEGIN HDBSVT11_CLKSPLT_Y2_1

`celldefine
module HDBSVT11_CLKSPLT_Y2_1 (CKOUT, CKOUTB, CK);
   output CKOUT, CKOUTB;
   input CK;

   /////////////////////////////////////
   //          FUNCTICKOUTBALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (CKOUTB, CK);
	buf #`SNPS_COMBO_DELAY  inst1 (CKOUT, CK);
    `else
        not inst2  (CKOUTB, CK);
	buf inst3  (CKOUT, CK);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(CK +=> CKOUT)=(0, 0);
(CK -=> CKOUTB)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_CLKSPLT_Y2_1

//%BEGIN HDBSVT11_CLKSPLT_Y2_8

`celldefine
module HDBSVT11_CLKSPLT_Y2_8 (CKOUT, CKOUTB, CK);
   output CKOUT, CKOUTB;
   input CK;

   /////////////////////////////////////
   //          FUNCTICKOUTBALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (CKOUTB, CK);
	buf #`SNPS_COMBO_DELAY  inst1 (CKOUT, CK);
    `else
        not inst2  (CKOUTB, CK);
	buf inst3  (CKOUT, CK);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(CK +=> CKOUT)=(0, 0);
(CK -=> CKOUTB)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_CLKSPLT_Y2_8

//%BEGIN HDBSVT11_DCAP_CBECO_1

`celldefine
module HDBSVT11_DCAP_CBECO_1 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_CBECO_1

//%BEGIN HDBSVT11_DCAP_CBECO_2

`celldefine
module HDBSVT11_DCAP_CBECO_2 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_CBECO_2

//%BEGIN HDBSVT11_DCAP_CBY2ECO_1

`celldefine
module HDBSVT11_DCAP_CBY2ECO_1 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_CBY2ECO_1

//%BEGIN HDBSVT11_DCAP_CBY2ECO_2

`celldefine
module HDBSVT11_DCAP_CBY2ECO_2 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_CBY2ECO_2

//%BEGIN HDBSVT11_DCAP_CBY3ECO_1

`celldefine
module HDBSVT11_DCAP_CBY3ECO_1 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_CBY3ECO_1

//%BEGIN HDBSVT11_DCAP_CBY3ECO_2

`celldefine
module HDBSVT11_DCAP_CBY3ECO_2 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_CBY3ECO_2

//%BEGIN HDBSVT11_DCAP_CBY4ECO_1

`celldefine
module HDBSVT11_DCAP_CBY4ECO_1 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_CBY4ECO_1

//%BEGIN HDBSVT11_DCAP_CBY4ECO_2

`celldefine
module HDBSVT11_DCAP_CBY4ECO_2 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_CBY4ECO_2

//%BEGIN HDBSVT11_DCAP_CBY5ECO_1

`celldefine
module HDBSVT11_DCAP_CBY5ECO_1 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_CBY5ECO_1

//%BEGIN HDBSVT11_DCAP_CBY5ECO_2

`celldefine
module HDBSVT11_DCAP_CBY5ECO_2 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_CBY5ECO_2

//%BEGIN HDBSVT11_DCAP_CBY6ECO_1

`celldefine
module HDBSVT11_DCAP_CBY6ECO_1 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_CBY6ECO_1

//%BEGIN HDBSVT11_DCAP_CBY6ECO_2

`celldefine
module HDBSVT11_DCAP_CBY6ECO_2 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_CBY6ECO_2

//%BEGIN HDBSVT11_DCAP_ECO_1

`celldefine
module HDBSVT11_DCAP_ECO_1 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_ECO_1

//%BEGIN HDBSVT11_DCAP_ECO_2

`celldefine
module HDBSVT11_DCAP_ECO_2 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_ECO_2

//%BEGIN HDBSVT11_DCAP_ECO_3

`celldefine
module HDBSVT11_DCAP_ECO_3 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_ECO_3

//%BEGIN HDBSVT11_DCAP_V4_16

`celldefine
module HDBSVT11_DCAP_V4_16 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_V4_16

//%BEGIN HDBSVT11_DCAP_V4_32

`celldefine
module HDBSVT11_DCAP_V4_32 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_V4_32

//%BEGIN HDBSVT11_DCAP_V4_6

`celldefine
module HDBSVT11_DCAP_V4_6 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_V4_6

//%BEGIN HDBSVT11_DCAP_V4_64

`celldefine
module HDBSVT11_DCAP_V4_64 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_V4_64

//%BEGIN HDBSVT11_DCAP_V4_8

`celldefine
module HDBSVT11_DCAP_V4_8 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_V4_8

//%BEGIN HDBSVT11_DCAP_V7_16

`celldefine
module HDBSVT11_DCAP_V7_16 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_V7_16

//%BEGIN HDBSVT11_DCAP_V7_4

`celldefine
module HDBSVT11_DCAP_V7_4 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_V7_4

//%BEGIN HDBSVT11_DCAP_V7_6

`celldefine
module HDBSVT11_DCAP_V7_6 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_V7_6

//%BEGIN HDBSVT11_DCAP_V7_8

`celldefine
module HDBSVT11_DCAP_V7_8 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_V7_8

//%BEGIN HDBSVT11_DCAP_Y2ECO_1

`celldefine
module HDBSVT11_DCAP_Y2ECO_1 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_Y2ECO_1

//%BEGIN HDBSVT11_DCAP_Y2ECO_2

`celldefine
module HDBSVT11_DCAP_Y2ECO_2 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_Y2ECO_2

//%BEGIN HDBSVT11_DCAP_Y2ECO_3

`celldefine
module HDBSVT11_DCAP_Y2ECO_3 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_Y2ECO_3

//%BEGIN HDBSVT11_DCAP_Y3ECO_1

`celldefine
module HDBSVT11_DCAP_Y3ECO_1 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_Y3ECO_1

//%BEGIN HDBSVT11_DCAP_Y3ECO_2

`celldefine
module HDBSVT11_DCAP_Y3ECO_2 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_Y3ECO_2

//%BEGIN HDBSVT11_DCAP_Y3ECO_3

`celldefine
module HDBSVT11_DCAP_Y3ECO_3 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_Y3ECO_3

//%BEGIN HDBSVT11_DCAP_Y4ECO_1

`celldefine
module HDBSVT11_DCAP_Y4ECO_1 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_Y4ECO_1

//%BEGIN HDBSVT11_DCAP_Y4ECO_2

`celldefine
module HDBSVT11_DCAP_Y4ECO_2 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_Y4ECO_2

//%BEGIN HDBSVT11_DCAP_Y4ECO_3

`celldefine
module HDBSVT11_DCAP_Y4ECO_3 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_Y4ECO_3

//%BEGIN HDBSVT11_DCAP_Y5ECO_1

`celldefine
module HDBSVT11_DCAP_Y5ECO_1 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_Y5ECO_1

//%BEGIN HDBSVT11_DCAP_Y5ECO_2

`celldefine
module HDBSVT11_DCAP_Y5ECO_2 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_Y5ECO_2

//%BEGIN HDBSVT11_DCAP_Y5ECO_3

`celldefine
module HDBSVT11_DCAP_Y5ECO_3 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_Y5ECO_3

//%BEGIN HDBSVT11_DCAP_Y6ECO_1

`celldefine
module HDBSVT11_DCAP_Y6ECO_1 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_Y6ECO_1

//%BEGIN HDBSVT11_DCAP_Y6ECO_2

`celldefine
module HDBSVT11_DCAP_Y6ECO_2 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_Y6ECO_2

//%BEGIN HDBSVT11_DCAP_Y6ECO_3

`celldefine
module HDBSVT11_DCAP_Y6ECO_3 ();
endmodule
`endcelldefine

//%END HDBSVT11_DCAP_Y6ECO_3

//%BEGIN HDBSVT11_DELPROGS4_Y2_12

`celldefine
module HDBSVT11_DELPROGS4_Y2_12 (X, A, S0, S1, S2, S3);
   output X;
   input A, S0, S1, S2, S3;
   wire x_cond, x_cond_1, x_cond_2, x_cond_3, x_cond_4, s1_or_s2_or_s3, s2_or_s3, s0_or_s1_or_s2_or_s3;

   or inst0  (s2_or_s3, S2, S3);
   or inst1  (s1_or_s2_or_s3, S1, s2_or_s3);
   or inst2  (s0_or_s1_or_s2_or_s3, S0, s1_or_s2_or_s3);
   and inst3  (x_cond_1, S0, s1_or_s2_or_s3);
   and inst4  (x_cond_2, S1, s2_or_s3);
   and inst5  (x_cond_3, S2, S3);
   not inst6  (x_cond_4, s0_or_s1_or_s2_or_s3);
   or inst7   (x_cond, x_cond_1, x_cond_2, x_cond_3, x_cond_4);

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////
   
   `ifdef VIRL_functiononly
     snps_mux2 #`SNPS_COMBO_DELAY  inst8 (X, 1'bx, A, x_cond);
   `else
     snps_mux2 inst9  (X, 1'bx, A, x_cond);
   `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else


specify
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b1) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b1 && S3==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b1 && S2==1'b0 && S3==1'b0) (A +=> X)=(0, 0);
if (S0==1'b1 && S1==1'b0 && S2==1'b0 && S3==1'b0) (A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_DELPROGS4_Y2_12

//%BEGIN HDBSVT11_DELPROGS4_Y2_16

`celldefine
module HDBSVT11_DELPROGS4_Y2_16 (X, A, S0, S1, S2, S3);
   output X;
   input A, S0, S1, S2, S3;
   wire x_cond, x_cond_1, x_cond_2, x_cond_3, x_cond_4, s1_or_s2_or_s3, s2_or_s3, s0_or_s1_or_s2_or_s3;

   or inst0  (s2_or_s3, S2, S3);
   or inst1  (s1_or_s2_or_s3, S1, s2_or_s3);
   or inst2  (s0_or_s1_or_s2_or_s3, S0, s1_or_s2_or_s3);
   and inst3  (x_cond_1, S0, s1_or_s2_or_s3);
   and inst4  (x_cond_2, S1, s2_or_s3);
   and inst5  (x_cond_3, S2, S3);
   not inst6  (x_cond_4, s0_or_s1_or_s2_or_s3);
   or inst7   (x_cond, x_cond_1, x_cond_2, x_cond_3, x_cond_4);

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////
   
   `ifdef VIRL_functiononly
     snps_mux2 #`SNPS_COMBO_DELAY  inst8 (X, 1'bx, A, x_cond);
   `else
     snps_mux2 inst9  (X, 1'bx, A, x_cond);
   `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else


specify
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b1) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b1 && S3==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b1 && S2==1'b0 && S3==1'b0) (A +=> X)=(0, 0);
if (S0==1'b1 && S1==1'b0 && S2==1'b0 && S3==1'b0) (A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_DELPROGS4_Y2_16

//%BEGIN HDBSVT11_DELPROGS4_Y2_4

`celldefine
module HDBSVT11_DELPROGS4_Y2_4 (X, A, S0, S1, S2, S3);
   output X;
   input A, S0, S1, S2, S3;
   wire x_cond, x_cond_1, x_cond_2, x_cond_3, x_cond_4, s1_or_s2_or_s3, s2_or_s3, s0_or_s1_or_s2_or_s3;

   or inst0  (s2_or_s3, S2, S3);
   or inst1  (s1_or_s2_or_s3, S1, s2_or_s3);
   or inst2  (s0_or_s1_or_s2_or_s3, S0, s1_or_s2_or_s3);
   and inst3  (x_cond_1, S0, s1_or_s2_or_s3);
   and inst4  (x_cond_2, S1, s2_or_s3);
   and inst5  (x_cond_3, S2, S3);
   not inst6  (x_cond_4, s0_or_s1_or_s2_or_s3);
   or inst7   (x_cond, x_cond_1, x_cond_2, x_cond_3, x_cond_4);

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////
   
   `ifdef VIRL_functiononly
     snps_mux2 #`SNPS_COMBO_DELAY  inst8 (X, 1'bx, A, x_cond);
   `else
     snps_mux2 inst9  (X, 1'bx, A, x_cond);
   `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else


specify
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b1) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b1 && S3==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b1 && S2==1'b0 && S3==1'b0) (A +=> X)=(0, 0);
if (S0==1'b1 && S1==1'b0 && S2==1'b0 && S3==1'b0) (A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_DELPROGS4_Y2_4

//%BEGIN HDBSVT11_DELPROGS4_Y2_6

`celldefine
module HDBSVT11_DELPROGS4_Y2_6 (X, A, S0, S1, S2, S3);
   output X;
   input A, S0, S1, S2, S3;
   wire x_cond, x_cond_1, x_cond_2, x_cond_3, x_cond_4, s1_or_s2_or_s3, s2_or_s3, s0_or_s1_or_s2_or_s3;

   or inst0  (s2_or_s3, S2, S3);
   or inst1  (s1_or_s2_or_s3, S1, s2_or_s3);
   or inst2  (s0_or_s1_or_s2_or_s3, S0, s1_or_s2_or_s3);
   and inst3  (x_cond_1, S0, s1_or_s2_or_s3);
   and inst4  (x_cond_2, S1, s2_or_s3);
   and inst5  (x_cond_3, S2, S3);
   not inst6  (x_cond_4, s0_or_s1_or_s2_or_s3);
   or inst7   (x_cond, x_cond_1, x_cond_2, x_cond_3, x_cond_4);

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////
   
   `ifdef VIRL_functiononly
     snps_mux2 #`SNPS_COMBO_DELAY  inst8 (X, 1'bx, A, x_cond);
   `else
     snps_mux2 inst9  (X, 1'bx, A, x_cond);
   `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else


specify
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b1) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b1 && S3==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b1 && S2==1'b0 && S3==1'b0) (A +=> X)=(0, 0);
if (S0==1'b1 && S1==1'b0 && S2==1'b0 && S3==1'b0) (A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_DELPROGS4_Y2_6

//%BEGIN HDBSVT11_DELPROGS4_Y2_8

`celldefine
module HDBSVT11_DELPROGS4_Y2_8 (X, A, S0, S1, S2, S3);
   output X;
   input A, S0, S1, S2, S3;
   wire x_cond, x_cond_1, x_cond_2, x_cond_3, x_cond_4, s1_or_s2_or_s3, s2_or_s3, s0_or_s1_or_s2_or_s3;

   or inst0  (s2_or_s3, S2, S3);
   or inst1  (s1_or_s2_or_s3, S1, s2_or_s3);
   or inst2  (s0_or_s1_or_s2_or_s3, S0, s1_or_s2_or_s3);
   and inst3  (x_cond_1, S0, s1_or_s2_or_s3);
   and inst4  (x_cond_2, S1, s2_or_s3);
   and inst5  (x_cond_3, S2, S3);
   not inst6  (x_cond_4, s0_or_s1_or_s2_or_s3);
   or inst7   (x_cond, x_cond_1, x_cond_2, x_cond_3, x_cond_4);

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////
   
   `ifdef VIRL_functiononly
     snps_mux2 #`SNPS_COMBO_DELAY  inst8 (X, 1'bx, A, x_cond);
   `else
     snps_mux2 inst9  (X, 1'bx, A, x_cond);
   `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else


specify
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b1) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b1 && S3==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b1 && S2==1'b0 && S3==1'b0) (A +=> X)=(0, 0);
if (S0==1'b1 && S1==1'b0 && S2==1'b0 && S3==1'b0) (A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_DELPROGS4_Y2_8

//%BEGIN HDBSVT11_DELPROGS4_Y3_24

`celldefine
module HDBSVT11_DELPROGS4_Y3_24 (X, A, S0, S1, S2, S3);
   output X;
   input A, S0, S1, S2, S3;
   wire x_cond, x_cond_1, x_cond_2, x_cond_3, x_cond_4, s1_or_s2_or_s3, s2_or_s3, s0_or_s1_or_s2_or_s3;

   or inst0  (s2_or_s3, S2, S3);
   or inst1  (s1_or_s2_or_s3, S1, s2_or_s3);
   or inst2  (s0_or_s1_or_s2_or_s3, S0, s1_or_s2_or_s3);
   and inst3  (x_cond_1, S0, s1_or_s2_or_s3);
   and inst4  (x_cond_2, S1, s2_or_s3);
   and inst5  (x_cond_3, S2, S3);
   not inst6  (x_cond_4, s0_or_s1_or_s2_or_s3);
   or inst7   (x_cond, x_cond_1, x_cond_2, x_cond_3, x_cond_4);

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////
   
   `ifdef VIRL_functiononly
     snps_mux2 #`SNPS_COMBO_DELAY  inst8 (X, 1'bx, A, x_cond);
   `else
     snps_mux2 inst9  (X, 1'bx, A, x_cond);
   `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else


specify
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b1) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b1 && S3==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b1 && S2==1'b0 && S3==1'b0) (A +=> X)=(0, 0);
if (S0==1'b1 && S1==1'b0 && S2==1'b0 && S3==1'b0) (A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_DELPROGS4_Y3_24

//%BEGIN HDBSVT11_DELPROGS9_V1Y4_4

`celldefine
module HDBSVT11_DELPROGS9_V1Y4_4 (X, A, S0, S1, S2, S3, S4, S5, S6, S7, S8);
   output X;
   input A, S0, S1, S2, S3, S4, S5, S6, S7, S8;
   wire x_cond, x_cond_1, x_cond_2, x_cond_3, x_cond_4, x_cond_5, x_cond_6, x_cond_8, x_cond_9, s0_s8, s1_s8, s2_s8, s3_s8, s4_s8, s5_s8, s6_s8, s7_s8;
   
   or inst0  (s7_s8, S7, S8);
   or inst1  (s6_s8, S6, s7_s8);
   or inst2  (s5_s8, S5, s6_s8);
   or inst3  (s4_s8, S4, s5_s8);
   or inst4  (s3_s8, S3, s4_s8);
   or inst5  (s2_s8, S2, s3_s8);
   or inst6  (s1_s8, S1, s2_s8);
   or inst7  (s0_s8, S0, s1_s8);
   and inst8  (x_cond_1, S0, s1_s8);
   and inst9  (x_cond_2, S1, s2_s8);
   and inst10  (x_cond_3, S2, s3_s8);
   and inst11  (x_cond_4, S3, s4_s8);
   and inst12  (x_cond_5, S4, s5_s8);
   and inst13  (x_cond_6, S5, s6_s8);
   and inst14  (x_cond_7, S6, s7_s8);
   and inst15  (x_cond_8, S7, S8);
   not inst16  (x_cond_9, s0_s8);
   or inst17   (x_cond, x_cond_1, x_cond_2, x_cond_3, x_cond_4, x_cond_5, x_cond_6, x_cond_7, x_cond_8, x_cond_9);

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     snps_mux2 #`SNPS_COMBO_DELAY  inst18 (X, 1'bx, A, x_cond);
   `else
     snps_mux2 inst19  (X, 1'bx, A, x_cond);
   `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else


specify
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b0 && S4==1'b0 && S5==1'b0 && S6==1'b0 && S7==1'b0 && S8==1'b1) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b0 && S4==1'b0 && S5==1'b0 && S6==1'b0 && S7==1'b1 && S8==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b0 && S4==1'b0 && S5==1'b0 && S6==1'b1 && S7==1'b0 && S8==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b0 && S4==1'b0 && S5==1'b1 && S6==1'b0 && S7==1'b0 && S8==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b0 && S4==1'b1 && S5==1'b0 && S6==1'b0 && S7==1'b0 && S8==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b1 && S4==1'b0 && S5==1'b0 && S6==1'b0 && S7==1'b0 && S8==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b1 && S3==1'b0 && S4==1'b0 && S5==1'b0 && S6==1'b0 && S7==1'b0 && S8==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b1 && S2==1'b0 && S3==1'b0 && S4==1'b0 && S5==1'b0 && S6==1'b0 && S7==1'b0 && S8==1'b0) (A +=> X)=(0, 0);
if (S0==1'b1 && S1==1'b0 && S2==1'b0 && S3==1'b0 && S4==1'b0 && S5==1'b0 && S6==1'b0 && S7==1'b0 && S8==1'b0) (A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_DELPROGS9_V1Y4_4

//%BEGIN HDBSVT11_DELPROGS9_V2Y4_4

`celldefine
module HDBSVT11_DELPROGS9_V2Y4_4 (X, A, S0, S1, S2, S3, S4, S5, S6, S7, S8);
   output X;
   input A, S0, S1, S2, S3, S4, S5, S6, S7, S8;
   wire x_cond, x_cond_1, x_cond_2, x_cond_3, x_cond_4, x_cond_5, x_cond_6, x_cond_8, x_cond_9, s0_s8, s1_s8, s2_s8, s3_s8, s4_s8, s5_s8, s6_s8, s7_s8;
   
   or inst0  (s7_s8, S7, S8);
   or inst1  (s6_s8, S6, s7_s8);
   or inst2  (s5_s8, S5, s6_s8);
   or inst3  (s4_s8, S4, s5_s8);
   or inst4  (s3_s8, S3, s4_s8);
   or inst5  (s2_s8, S2, s3_s8);
   or inst6  (s1_s8, S1, s2_s8);
   or inst7  (s0_s8, S0, s1_s8);
   and inst8  (x_cond_1, S0, s1_s8);
   and inst9  (x_cond_2, S1, s2_s8);
   and inst10  (x_cond_3, S2, s3_s8);
   and inst11  (x_cond_4, S3, s4_s8);
   and inst12  (x_cond_5, S4, s5_s8);
   and inst13  (x_cond_6, S5, s6_s8);
   and inst14  (x_cond_7, S6, s7_s8);
   and inst15  (x_cond_8, S7, S8);
   not inst16  (x_cond_9, s0_s8);
   or inst17   (x_cond, x_cond_1, x_cond_2, x_cond_3, x_cond_4, x_cond_5, x_cond_6, x_cond_7, x_cond_8, x_cond_9);

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     snps_mux2 #`SNPS_COMBO_DELAY  inst18 (X, 1'bx, A, x_cond);
   `else
     snps_mux2 inst19  (X, 1'bx, A, x_cond);
   `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else


specify
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b0 && S4==1'b0 && S5==1'b0 && S6==1'b0 && S7==1'b0 && S8==1'b1) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b0 && S4==1'b0 && S5==1'b0 && S6==1'b0 && S7==1'b1 && S8==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b0 && S4==1'b0 && S5==1'b0 && S6==1'b1 && S7==1'b0 && S8==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b0 && S4==1'b0 && S5==1'b1 && S6==1'b0 && S7==1'b0 && S8==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b0 && S4==1'b1 && S5==1'b0 && S6==1'b0 && S7==1'b0 && S8==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b0 && S3==1'b1 && S4==1'b0 && S5==1'b0 && S6==1'b0 && S7==1'b0 && S8==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b0 && S2==1'b1 && S3==1'b0 && S4==1'b0 && S5==1'b0 && S6==1'b0 && S7==1'b0 && S8==1'b0) (A +=> X)=(0, 0);
if (S0==1'b0 && S1==1'b1 && S2==1'b0 && S3==1'b0 && S4==1'b0 && S5==1'b0 && S6==1'b0 && S7==1'b0 && S8==1'b0) (A +=> X)=(0, 0);
if (S0==1'b1 && S1==1'b0 && S2==1'b0 && S3==1'b0 && S4==1'b0 && S5==1'b0 && S6==1'b0 && S7==1'b0 && S8==1'b0) (A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_DELPROGS9_V2Y4_4

//%BEGIN HDBSVT11_DEL_L4D225_2

`celldefine
module HDBSVT11_DEL_L4D225_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
     buf inst1  (X, A);
   `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else


specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_DEL_L4D225_2

//%BEGIN HDBSVT11_DEL_R2V1_1

`celldefine
module HDBSVT11_DEL_R2V1_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
     buf inst1  (X, A);
   `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else


specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_DEL_R2V1_1

//%BEGIN HDBSVT11_DEL_R2V1_2

`celldefine
module HDBSVT11_DEL_R2V1_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
     buf inst1  (X, A);
   `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else


specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_DEL_R2V1_2

//%BEGIN HDBSVT11_DEL_R2V2_1

`celldefine
module HDBSVT11_DEL_R2V2_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
     buf inst1  (X, A);
   `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else


specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_DEL_R2V2_1

//%BEGIN HDBSVT11_DEL_R2V2_2

`celldefine
module HDBSVT11_DEL_R2V2_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
     buf inst1  (X, A);
   `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else


specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_DEL_R2V2_2

//%BEGIN HDBSVT11_DEL_R2V3_1

`celldefine
module HDBSVT11_DEL_R2V3_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
     buf inst1  (X, A);
   `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else


specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_DEL_R2V3_1

//%BEGIN HDBSVT11_DEL_R2V3_2

`celldefine
module HDBSVT11_DEL_R2V3_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
     buf inst1  (X, A);
   `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else


specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_DEL_R2V3_2

//%BEGIN HDBSVT11_DEL_R2V4_1

`celldefine
module HDBSVT11_DEL_R2V4_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
     buf inst1  (X, A);
   `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else


specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_DEL_R2V4_1

//%BEGIN HDBSVT11_DEL_R2V5_1

`celldefine
module HDBSVT11_DEL_R2V5_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, A);
   `else
     buf inst1  (X, A);
   `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else


specify
(A +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_DEL_R2V5_1

//%BEGIN HDBSVT11_DLYGATES_Y3_2
`celldefine
module HDBSVT11_DLYGATES_Y3_2 (Z, Z1, Z2, ZB, Z1B, Z2B, A, AB, S, SB);
  input A, AB, S, SB;
  output Z, Z1, Z2, ZB, Z1B, Z2B;
  wire int_0, int_3;


    and inst0  (int_0, AB, SB);
    or inst1  (int_3, A, S);
  `ifdef VIRL_functiononly
    buf #`SNPS_COMBO_DELAY  inst2 (Z2B, int_0);
    buf #`SNPS_COMBO_DELAY  inst3 (Z1B, int_0);
    buf #`SNPS_COMBO_DELAY  inst4 (ZB, int_0);
    buf #`SNPS_COMBO_DELAY  inst5 (Z2, int_3);
    buf #`SNPS_COMBO_DELAY  inst6 (Z1, int_3);
    buf #`SNPS_COMBO_DELAY  inst7 (Z, int_3);
  `else
    buf inst8  (Z2B, int_0);
    buf inst9  (Z1B, int_0);
    buf inst10  (ZB, int_0);
    buf inst11  (Z2, int_3);
    buf inst12  (Z1, int_3);
    buf inst13  (Z, int_3);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (S==1'b0 && SB==1'b1) (A +=> Z)=(0, 0);
if (A==1'b0 && AB==1'b1) (S +=> Z)=(0, 0);
if (S==1'b0 && SB==1'b1) (A +=> Z1)=(0, 0);
if (A==1'b0 && AB==1'b1) (S +=> Z1)=(0, 0);
if (S==1'b0 && SB==1'b1) (AB +=> Z1B)=(0, 0);
if (A==1'b0 && AB==1'b1) (SB +=> Z1B)=(0, 0);
if (S==1'b0 && SB==1'b1) (A +=> Z2)=(0, 0);
if (A==1'b0 && AB==1'b1) (S +=> Z2)=(0, 0);
if (S==1'b0 && SB==1'b1) (AB +=> Z2B)=(0, 0);
if (A==1'b0 && AB==1'b1) (SB +=> Z2B)=(0, 0);
if (S==1'b0 && SB==1'b1) (AB +=> ZB)=(0, 0);
if (A==1'b0 && AB==1'b1) (SB +=> ZB)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_DLYGATES_Y3_2

//%BEGIN HDBSVT11_EN2_CBV2Y2_1

`celldefine
module HDBSVT11_EN2_CBV2Y2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN2_CBV2Y2_1

//%BEGIN HDBSVT11_EN2_CBY3ECO_1

`celldefine
module HDBSVT11_EN2_CBY3ECO_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN2_CBY3ECO_1

//%BEGIN HDBSVT11_EN2_V2PCY2_1

`celldefine
module HDBSVT11_EN2_V2PCY2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN2_V2PCY2_1

//%BEGIN HDBSVT11_EN2_V2Y2_1

`celldefine
module HDBSVT11_EN2_V2Y2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN2_V2Y2_1

//%BEGIN HDBSVT11_EN2_V2Y2_2

`celldefine
module HDBSVT11_EN2_V2Y2_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN2_V2Y2_2

//%BEGIN HDBSVT11_EN2_V2Y2_8

`celldefine
module HDBSVT11_EN2_V2Y2_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN2_V2Y2_8

//%BEGIN HDBSVT11_EN2_Y2_1

`celldefine
module HDBSVT11_EN2_Y2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN2_Y2_1

//%BEGIN HDBSVT11_EN2_Y2_2

`celldefine
module HDBSVT11_EN2_Y2_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN2_Y2_2

//%BEGIN HDBSVT11_EN2_Y2_3

`celldefine
module HDBSVT11_EN2_Y2_3 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN2_Y2_3

//%BEGIN HDBSVT11_EN2_Y2_4

`celldefine
module HDBSVT11_EN2_Y2_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN2_Y2_4

//%BEGIN HDBSVT11_EN2_Y2_8

`celldefine
module HDBSVT11_EN2_Y2_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN2_Y2_8

//%BEGIN HDBSVT11_EN2_Y3ECO_1

`celldefine
module HDBSVT11_EN2_Y3ECO_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN2_Y3ECO_1

//%BEGIN HDBSVT11_EN3_Y2_1

`celldefine
module HDBSVT11_EN3_Y2_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
        xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        xnor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN3_Y2_1

//%BEGIN HDBSVT11_EN3_Y2_2

`celldefine
module HDBSVT11_EN3_Y2_2 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
        xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        xnor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN3_Y2_2

//%BEGIN HDBSVT11_EN3_Y2_4

`celldefine
module HDBSVT11_EN3_Y2_4 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
        xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        xnor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN3_Y2_4

//%BEGIN HDBSVT11_EN3_Y4_8

`celldefine
module HDBSVT11_EN3_Y4_8 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
        xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        xnor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN3_Y4_8

//%BEGIN HDBSVT11_EN4_V2Y2_1

`celldefine
module HDBSVT11_EN4_V2Y2_1 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);

   `else
         xnor inst1  (X, A1, A2, A3, A4);

   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (A4 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (A4 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (A4 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (A4 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (A4 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (A4 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN4_V2Y2_1

//%BEGIN HDBSVT11_EN4_V2Y2_2

`celldefine
module HDBSVT11_EN4_V2Y2_2 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);

   `else
         xnor inst1  (X, A1, A2, A3, A4);

   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (A4 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (A4 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (A4 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (A4 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (A4 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (A4 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN4_V2Y2_2

//%BEGIN HDBSVT11_EN4_V2Y2_3

`celldefine
module HDBSVT11_EN4_V2Y2_3 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);

   `else
         xnor inst1  (X, A1, A2, A3, A4);

   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (A4 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (A4 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (A4 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (A4 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (A4 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (A4 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN4_V2Y2_3

//%BEGIN HDBSVT11_EN4_V2Y2_4

`celldefine
module HDBSVT11_EN4_V2Y2_4 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);

   `else
         xnor inst1  (X, A1, A2, A3, A4);

   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (A4 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (A4 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (A4 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (A4 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (A4 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (A4 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN4_V2Y2_4

//%BEGIN HDBSVT11_EN4_V2Y4_8

`celldefine
module HDBSVT11_EN4_V2Y4_8 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);

   `else
         xnor inst1  (X, A1, A2, A3, A4);

   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (A4 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (A4 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (A4 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (A4 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (A4 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (A4 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EN4_V2Y4_8

//%BEGIN HDBSVT11_EO2_CBV2Y2_1

`celldefine
module HDBSVT11_EO2_CBV2Y2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO2_CBV2Y2_1

//%BEGIN HDBSVT11_EO2_CBY3ECO_1

`celldefine
module HDBSVT11_EO2_CBY3ECO_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO2_CBY3ECO_1

//%BEGIN HDBSVT11_EO2_CKY2_1
`celldefine
module HDBSVT11_EO2_CKY2_1 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;


    xor inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_EO2_CKY2_1

//%BEGIN HDBSVT11_EO2_CKY2_2
`celldefine
module HDBSVT11_EO2_CKY2_2 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;


    xor inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_EO2_CKY2_2

//%BEGIN HDBSVT11_EO2_CKY4_4
`celldefine
module HDBSVT11_EO2_CKY4_4 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;


    xor inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_EO2_CKY4_4

//%BEGIN HDBSVT11_EO2_FY4_8

`celldefine
module HDBSVT11_EO2_FY4_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO2_FY4_8

//%BEGIN HDBSVT11_EO2_V2PCY2_1

`celldefine
module HDBSVT11_EO2_V2PCY2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO2_V2PCY2_1

//%BEGIN HDBSVT11_EO2_V2Y2_1

`celldefine
module HDBSVT11_EO2_V2Y2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO2_V2Y2_1

//%BEGIN HDBSVT11_EO2_V2Y2_2

`celldefine
module HDBSVT11_EO2_V2Y2_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO2_V2Y2_2

//%BEGIN HDBSVT11_EO2_V2Y2_8

`celldefine
module HDBSVT11_EO2_V2Y2_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO2_V2Y2_8

//%BEGIN HDBSVT11_EO2_Y2_1

`celldefine
module HDBSVT11_EO2_Y2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO2_Y2_1

//%BEGIN HDBSVT11_EO2_Y2_2

`celldefine
module HDBSVT11_EO2_Y2_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO2_Y2_2

//%BEGIN HDBSVT11_EO2_Y2_3

`celldefine
module HDBSVT11_EO2_Y2_3 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO2_Y2_3

//%BEGIN HDBSVT11_EO2_Y2_4

`celldefine
module HDBSVT11_EO2_Y2_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO2_Y2_4

//%BEGIN HDBSVT11_EO2_Y2_8

`celldefine
module HDBSVT11_EO2_Y2_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO2_Y2_8

//%BEGIN HDBSVT11_EO2_Y3ECO_1

`celldefine
module HDBSVT11_EO2_Y3ECO_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO2_Y3ECO_1

//%BEGIN HDBSVT11_EO3_Y2_1

`celldefine
module HDBSVT11_EO3_Y2_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
         xor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO3_Y2_1

//%BEGIN HDBSVT11_EO3_Y2_2

`celldefine
module HDBSVT11_EO3_Y2_2 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
         xor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO3_Y2_2

//%BEGIN HDBSVT11_EO3_Y2_4

`celldefine
module HDBSVT11_EO3_Y2_4 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
         xor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO3_Y2_4

//%BEGIN HDBSVT11_EO3_Y4_8

`celldefine
module HDBSVT11_EO3_Y4_8 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
         xor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO3_Y4_8

//%BEGIN HDBSVT11_EO4_Y2_1

`celldefine
module HDBSVT11_EO4_Y2_1 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);

   `else
        xor inst1  (X, A1, A2, A3, A4);

   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (A4 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (A4 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (A4 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (A4 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (A4 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO4_Y2_1

//%BEGIN HDBSVT11_EO4_Y2_2

`celldefine
module HDBSVT11_EO4_Y2_2 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);

   `else
        xor inst1  (X, A1, A2, A3, A4);

   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (A4 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (A4 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (A4 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (A4 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (A4 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO4_Y2_2

//%BEGIN HDBSVT11_EO4_Y2_4

`celldefine
module HDBSVT11_EO4_Y2_4 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);

   `else
        xor inst1  (X, A1, A2, A3, A4);

   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b1 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0 && A4==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b1 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0 && A4==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A4==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (A4 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (A4 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (A4 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (A4 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (A4 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_EO4_Y2_4


//%BEGIN HDBSVT11_FD2PQB_MSY3_2

`celldefine
module HDBSVT11_FD2PQB_MSY3_2 (QB, CLK0, CLK1, D0, D1);
  output QB;
  input CLK0, CLK1, D0, D1;
  reg viol_0;
     wire viol_x;
  wire MN0__blknet15, MN0__blkCLK1B, MN0__blkCLK0B, MN0__blknet16, MN0__blknet17, l2q_set_0_0, l2q_set_1_0, l2q_set_0, l2q_C0_0, l2q_C1_0, l2q_reset_0_0, l2q_reset_1_0, l2q_reset_0, l2q_resetx_0, delayed_CLK0, delayed_CLK1, delayed_D0, delayed_D1;


`ifdef _fv
  buf inst0  (delayed_CLK0, CLK0);
  buf inst1  (delayed_CLK1, CLK1);
  buf inst2  (delayed_D0, D0);
  buf inst3  (delayed_D1, D1);
`endif

  not inst4   (MN0__blkCLK1B, delayed_CLK1);
  not inst5   (MN0__blkCLK0B, delayed_CLK0);
  snps_latch inst6   (MN0__blknet16, viol_x, MN0__blkCLK0B, delayed_D0);
  snps_latch inst7   (MN0__blknet17, viol_x, MN0__blkCLK1B, delayed_D1);
  and inst8   (l2q_set_0_0, delayed_CLK0, MN0__blknet16);
  and inst9   (l2q_set_1_0, delayed_CLK1, MN0__blknet17);
  or inst10    (l2q_set_0, l2q_set_0_0, l2q_set_1_0);
  not inst11   (l2q_C0_0, delayed_CLK0);
  not inst12   (l2q_C1_0, delayed_CLK1);
  or inst13    (l2q_reset_0_0, l2q_C0_0, MN0__blknet16);
  or inst14    (l2q_reset_1_0, l2q_C1_0, MN0__blknet17);
  and inst15   (l2q_reset_0, l2q_reset_0_0, l2q_reset_1_0);
  not inst16   (l2q_resetx_0, l2q_reset_0);
  and inst17   (x_sel, l2q_set_0, l2q_resetx_0); 
  snps_mux2 inst18  (reset, 1'bx, l2q_resetx_0, x_sel);
  snps_mux2 inst19  (set, 1'bx, l2q_set_0, x_sel);
  snps_sr_latch_x inst20   (MN0__blknet15, viol_x, set, reset);   


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst21  (viol_x, viol_0, MN0__blkCLK0B, 1'b1, 1'b1);

  `endif
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst22  (viol_x, viol_0, MN0__blkCLK1B, 1'b1, 1'b1);

  `endif
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst23  (viol_x, viol_0, set, reset, 1'b1);

  `endif
   `ifdef VIRL_functiononly
       not  #`SNPS_SEQ_DELAY  inst24 (QB, MN0__blknet15);
        
   `else
         not inst25    (QB, MN0__blknet15);

   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////



not inst26  (_net_0, D0);
not inst27  (_net_1, CLK1);
not inst28  (_net_2, D1);
and inst29  (ENABLE_NOT_CLK1_AND_NOT_D0_AND_NOT_D1, _net_0, _net_1, _net_2);
not inst30  (_net_3, D0);
not inst31  (_net_4, CLK1);
and inst32  (ENABLE_NOT_CLK1_AND_NOT_D0_AND_D1, _net_3, _net_4, D1);
not inst33  (_net_5, CLK1);
not inst34  (_net_6, D1);
and inst35  (ENABLE_NOT_CLK1_AND_D0_AND_NOT_D1, D0, _net_5, _net_6);
not inst36  (_net_7, CLK1);
and inst37  (ENABLE_NOT_CLK1_AND_D0_AND_D1, D0, _net_7, D1);
not inst38  (_net_8, D0);
not inst39  (_net_9, CLK0);
not inst40  (_net_10, D1);
and inst41  (ENABLE_NOT_CLK0_AND_NOT_D0_AND_NOT_D1, _net_8, _net_9, _net_10);
not inst42  (_net_11, D0);
not inst43  (_net_12, CLK0);
and inst44  (ENABLE_NOT_CLK0_AND_NOT_D0_AND_D1, _net_11, _net_12, D1);
not inst45  (_net_13, CLK0);
not inst46  (_net_14, D1);
and inst47  (ENABLE_NOT_CLK0_AND_D0_AND_NOT_D1, D0, _net_13, _net_14);
not inst48  (_net_15, CLK0);
and inst49  (ENABLE_NOT_CLK0_AND_D0_AND_D1, D0, _net_15, D1);
not inst50  (_net_16, D1);
not inst51  (_net_17, CLK1);
and inst52  (ENABLE_NOT_CLK1_AND_NOT_D1, _net_16, _net_17);
not inst53  (_net_18, D0);
not inst54  (_net_19, CLK0);
and inst55  (ENABLE_NOT_CLK0_AND_NOT_D0, _net_18, _net_19);

specify
if (CLK1==1'b0 && D0==1'b1 && D1==1'b0) (posedge CLK0 => (QB -: 1'b1))=(0, 0);
if (CLK1==1'b0 && D0==1'b0 && D1==1'b0) (posedge CLK0 => (QB +: 1'b1))=(0, 0);
(posedge CLK0 => (QB : 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1) (posedge CLK1 => (QB -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0) (posedge CLK1 => (QB +: 1'b1))=(0, 0);
(posedge CLK1 => (QB : 1'b1))=(0, 0);
$width(posedge CLK0 &&& ENABLE_NOT_CLK1_AND_NOT_D0_AND_NOT_D1 , 0 ,0, viol_0);
$width(negedge CLK0 &&& ENABLE_NOT_CLK1_AND_NOT_D0_AND_NOT_D1 , 0 ,0, viol_0);
$width(posedge CLK0 &&& ENABLE_NOT_CLK1_AND_NOT_D0_AND_D1 , 0 ,0, viol_0);
$width(negedge CLK0 &&& ENABLE_NOT_CLK1_AND_NOT_D0_AND_D1 , 0 ,0, viol_0);
$width(posedge CLK0 &&& ENABLE_NOT_CLK1_AND_D0_AND_NOT_D1 , 0 ,0, viol_0);
$width(negedge CLK0 &&& ENABLE_NOT_CLK1_AND_D0_AND_NOT_D1 , 0 ,0, viol_0);
$width(posedge CLK0 &&& ENABLE_NOT_CLK1_AND_D0_AND_D1 , 0 ,0, viol_0);
$width(negedge CLK0 &&& ENABLE_NOT_CLK1_AND_D0_AND_D1 , 0 ,0, viol_0);
$width(posedge CLK1 &&& ENABLE_NOT_CLK0_AND_NOT_D0_AND_NOT_D1 , 0 ,0, viol_0);
$width(negedge CLK1 &&& ENABLE_NOT_CLK0_AND_NOT_D0_AND_NOT_D1 , 0 ,0, viol_0);
$width(posedge CLK1 &&& ENABLE_NOT_CLK0_AND_NOT_D0_AND_D1 , 0 ,0, viol_0);
$width(negedge CLK1 &&& ENABLE_NOT_CLK0_AND_NOT_D0_AND_D1 , 0 ,0, viol_0);
$width(posedge CLK1 &&& ENABLE_NOT_CLK0_AND_D0_AND_NOT_D1 , 0 ,0, viol_0);
$width(negedge CLK1 &&& ENABLE_NOT_CLK0_AND_D0_AND_NOT_D1 , 0 ,0, viol_0);
$width(posedge CLK1 &&& ENABLE_NOT_CLK0_AND_D0_AND_D1 , 0 ,0, viol_0);
$width(negedge CLK1 &&& ENABLE_NOT_CLK0_AND_D0_AND_D1 , 0 ,0, viol_0);
$setuphold(posedge CLK0 &&& ENABLE_NOT_CLK1_AND_NOT_D1 , posedge D0 &&& ENABLE_NOT_CLK1_AND_NOT_D1 , 0 ,0, viol_0, , , delayed_CLK0, delayed_D0);
$setuphold(posedge CLK0 &&& ENABLE_NOT_CLK1_AND_NOT_D1 , negedge D0 &&& ENABLE_NOT_CLK1_AND_NOT_D1 , 0 ,0, viol_0, , , delayed_CLK0, delayed_D0);
$setuphold(posedge CLK1 &&& ENABLE_NOT_CLK0_AND_NOT_D0 , posedge D1 &&& ENABLE_NOT_CLK0_AND_NOT_D0 , 0 ,0, viol_0, , , delayed_CLK1, delayed_D1);
$setuphold(posedge CLK1 &&& ENABLE_NOT_CLK0_AND_NOT_D0 , negedge D1 &&& ENABLE_NOT_CLK0_AND_NOT_D0 , 0 ,0, viol_0, , , delayed_CLK1, delayed_D1);
endspecify
   `endif


endmodule

`endcelldefine

//%END HDBSVT11_FD2PQB_MSY3_2


//%BEGIN HDBSVT11_FDNQ_V3Y2_1

`celldefine
module HDBSVT11_FDNQ_V3Y2_1 (Q, CK, D);
   output Q;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res__CK, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif

   not inst2  (int_res__CK, delayed_CK);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst3  (xcr_0, int_res__CK, delayed_D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst4 (Q, viol_0, int_res__CK, delayed_D, xcr_0);
   `else
        snps_dff inst5  (Q, viol_0, int_res__CK, delayed_D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (D==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(negedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDNQ_V3Y2_1

//%BEGIN HDBSVT11_FDNQ_V3Y2_2

`celldefine
module HDBSVT11_FDNQ_V3Y2_2 (Q, CK, D);
   output Q;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res__CK, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif

   not inst2  (int_res__CK, delayed_CK);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst3  (xcr_0, int_res__CK, delayed_D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst4 (Q, viol_0, int_res__CK, delayed_D, xcr_0);
   `else
        snps_dff inst5  (Q, viol_0, int_res__CK, delayed_D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (D==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(negedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDNQ_V3Y2_2

//%BEGIN HDBSVT11_FDNQ_V3Y2_4

`celldefine
module HDBSVT11_FDNQ_V3Y2_4 (Q, CK, D);
   output Q;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res__CK, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif

   not inst2  (int_res__CK, delayed_CK);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst3  (xcr_0, int_res__CK, delayed_D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst4 (Q, viol_0, int_res__CK, delayed_D, xcr_0);
   `else
        snps_dff inst5  (Q, viol_0, int_res__CK, delayed_D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (D==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(negedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDNQ_V3Y2_4

//%BEGIN HDBSVT11_FDNQ_V4Y2_8

`celldefine
module HDBSVT11_FDNQ_V4Y2_8 (Q, CK, D);
   output Q;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res__CK, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif

   not inst2  (int_res__CK, delayed_CK);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst3  (xcr_0, int_res__CK, delayed_D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst4 (Q, viol_0, int_res__CK, delayed_D, xcr_0);
   `else
        snps_dff inst5  (Q, viol_0, int_res__CK, delayed_D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (D==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(negedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDNQ_V4Y2_8

//%BEGIN HDBSVT11_FDNRBQ_V2Y2_2

`celldefine
module HDBSVT11_FDNRBQ_V2Y2_2 (Q, CK, D, RD);
   output Q;
   input CK, D, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_RD;

   wire int_res__CK, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RD, RD);
`endif

   not inst3  (int_res__CK, delayed_CK);
   not inst4  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst5  (xcr_0, int_res__CK, delayed_D, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_r #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, int_res__CK, delayed_D, int_res__RD, xcr_0);
   `else
        snps_dff_r inst7  (Q, viol_0, int_res__CK, delayed_D, int_res__RD, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, D);
and inst9  (ENABLE_NOT_D_AND_RD, RD, _net_0);
and inst10  (ENABLE_D_AND_RD, RD, D);
buf inst11  (ENABLE_RD, RD);
buf inst12  (ENABLE_D, D);
not inst13  (_net_1, D);
not inst14  (_net_2, CK);
and inst15  (ENABLE_NOT_CK_AND_NOT_D, _net_1, _net_2);
not inst16  (_net_3, CK);
and inst17  (ENABLE_NOT_CK_AND_D, D, _net_3);
not inst18  (_net_4, D);
and inst19  (ENABLE_CK_AND_NOT_D, _net_4, CK);
and inst20  (ENABLE_CK_AND_D, D, CK);

specify
if (CK==1'b0 && D==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (D==1'b1 && RD==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$setuphold(negedge CK &&& ENABLE_RD , posedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_RD , negedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_D , negedge CK &&& ENABLE_D , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDNRBQ_V2Y2_2

//%BEGIN HDBSVT11_FDNRBSBQ_V2Y2_1

`celldefine
module HDBSVT11_FDNRBSBQ_V2Y2_1 (Q, CK, D, RD, SD);
   output Q;
   input CK, D, RD, SD;

   reg viol_0;
   wire delayed_D, delayed_CK,
	delayed_RD, delayed_SD;

   wire int_res__CK, int_res__RD, int_res__SD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RD, RD);
   buf inst3  (delayed_SD, SD);
`endif


   not inst4  (int_res__CK, delayed_CK);
   not inst5  (int_res__RD, delayed_RD);
   not inst6  (int_res__SD, delayed_SD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_sr_err inst7  (xcr_0, int_res__CK, delayed_D, int_res__SD, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
 
   `ifdef VIRL_functiononly
        snps_dff_sr_0 #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, int_res__CK, delayed_D, int_res__SD, int_res__RD, xcr_0);
    `else
        snps_dff_sr_0 inst9  (Q, viol_0, int_res__CK, delayed_D, int_res__SD, int_res__RD, xcr_0);
    `endif

    `ifdef VIRL_functiononly

    `else

not inst10  (_net_0, D);
and inst11  (ENABLE_NOT_D_AND_RD_AND_SD, RD, _net_0, SD);
and inst12  (ENABLE_D_AND_RD_AND_SD, RD, D, SD);
and inst13  (ENABLE_RD_AND_SD, SD, RD);
and inst14  (ENABLE_D_AND_SD, SD, D);
not inst15  (_net_1, D);
not inst16  (_net_2, CK);
and inst17  (ENABLE_NOT_CK_AND_NOT_D_AND_SD, _net_1, _net_2, SD);
not inst18  (_net_3, CK);
and inst19  (ENABLE_NOT_CK_AND_D_AND_SD, D, _net_3, SD);
not inst20  (_net_4, D);
and inst21  (ENABLE_CK_AND_NOT_D_AND_SD, _net_4, CK, SD);
and inst22  (ENABLE_CK_AND_D_AND_SD, D, CK, SD);
not inst23  (_net_5, D);
not inst24  (_net_6, CK);
and inst25  (ENABLE_NOT_CK_AND_NOT_D, _net_5, _net_6);
not inst26  (_net_7, CK);
and inst27  (ENABLE_NOT_CK_AND_D, D, _net_7);
not inst28  (_net_8, D);
and inst29  (ENABLE_CK_AND_NOT_D, _net_8, CK);
and inst30  (ENABLE_CK_AND_D, D, CK);
not inst31  (_net_9, D);
and inst32  (ENABLE_NOT_D_AND_RD, RD, _net_9);
not inst33  (_net_10, D);
not inst34  (_net_11, CK);
and inst35  (ENABLE_NOT_CK_AND_NOT_D_AND_RD, _net_10, _net_11, RD);
not inst36  (_net_12, CK);
and inst37  (ENABLE_NOT_CK_AND_D_AND_RD, D, _net_12, RD);
not inst38  (_net_13, D);
and inst39  (ENABLE_CK_AND_NOT_D_AND_RD, _net_13, CK, RD);
and inst40  (ENABLE_CK_AND_D_AND_RD, D, CK, RD);

specify
if (CK==1'b0 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$setuphold(negedge CK &&& ENABLE_RD_AND_SD , posedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_RD_AND_SD , negedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_D_AND_SD , negedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD , 0 ,0, viol_0);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D , posedge RD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D , posedge RD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D , posedge RD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD , negedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D , posedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D , posedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D , posedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD , 0 ,0, viol_0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDNRBSBQ_V2Y2_1

//%BEGIN HDBSVT11_FDNRBSBQ_V2Y2_2

`celldefine
module HDBSVT11_FDNRBSBQ_V2Y2_2 (Q, CK, D, RD, SD);
   output Q;
   input CK, D, RD, SD;

   reg viol_0;
   wire delayed_D, delayed_CK,
	delayed_RD, delayed_SD;

   wire int_res__CK, int_res__RD, int_res__SD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RD, RD);
   buf inst3  (delayed_SD, SD);
`endif


   not inst4  (int_res__CK, delayed_CK);
   not inst5  (int_res__RD, delayed_RD);
   not inst6  (int_res__SD, delayed_SD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_sr_err inst7  (xcr_0, int_res__CK, delayed_D, int_res__SD, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
 
   `ifdef VIRL_functiononly
        snps_dff_sr_0 #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, int_res__CK, delayed_D, int_res__SD, int_res__RD, xcr_0);
    `else
        snps_dff_sr_0 inst9  (Q, viol_0, int_res__CK, delayed_D, int_res__SD, int_res__RD, xcr_0);
    `endif

    `ifdef VIRL_functiononly

    `else

not inst10  (_net_0, D);
and inst11  (ENABLE_NOT_D_AND_RD_AND_SD, RD, _net_0, SD);
and inst12  (ENABLE_D_AND_RD_AND_SD, RD, D, SD);
and inst13  (ENABLE_RD_AND_SD, SD, RD);
and inst14  (ENABLE_D_AND_SD, SD, D);
not inst15  (_net_1, D);
not inst16  (_net_2, CK);
and inst17  (ENABLE_NOT_CK_AND_NOT_D_AND_SD, _net_1, _net_2, SD);
not inst18  (_net_3, CK);
and inst19  (ENABLE_NOT_CK_AND_D_AND_SD, D, _net_3, SD);
not inst20  (_net_4, D);
and inst21  (ENABLE_CK_AND_NOT_D_AND_SD, _net_4, CK, SD);
and inst22  (ENABLE_CK_AND_D_AND_SD, D, CK, SD);
not inst23  (_net_5, D);
not inst24  (_net_6, CK);
and inst25  (ENABLE_NOT_CK_AND_NOT_D, _net_5, _net_6);
not inst26  (_net_7, CK);
and inst27  (ENABLE_NOT_CK_AND_D, D, _net_7);
not inst28  (_net_8, D);
and inst29  (ENABLE_CK_AND_NOT_D, _net_8, CK);
and inst30  (ENABLE_CK_AND_D, D, CK);
not inst31  (_net_9, D);
and inst32  (ENABLE_NOT_D_AND_RD, RD, _net_9);
not inst33  (_net_10, D);
not inst34  (_net_11, CK);
and inst35  (ENABLE_NOT_CK_AND_NOT_D_AND_RD, _net_10, _net_11, RD);
not inst36  (_net_12, CK);
and inst37  (ENABLE_NOT_CK_AND_D_AND_RD, D, _net_12, RD);
not inst38  (_net_13, D);
and inst39  (ENABLE_CK_AND_NOT_D_AND_RD, _net_13, CK, RD);
and inst40  (ENABLE_CK_AND_D_AND_RD, D, CK, RD);

specify
if (CK==1'b0 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$setuphold(negedge CK &&& ENABLE_RD_AND_SD , posedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_RD_AND_SD , negedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_D_AND_SD , negedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD , 0 ,0, viol_0);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D , posedge RD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D , posedge RD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D , posedge RD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD , negedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D , posedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D , posedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D , posedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD , 0 ,0, viol_0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDNRBSBQ_V2Y2_2

//%BEGIN HDBSVT11_FDNRBSBQ_V2Y2_4

`celldefine
module HDBSVT11_FDNRBSBQ_V2Y2_4 (Q, CK, D, RD, SD);
   output Q;
   input CK, D, RD, SD;

   reg viol_0;
   wire delayed_D, delayed_CK,
	delayed_RD, delayed_SD;

   wire int_res__CK, int_res__RD, int_res__SD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RD, RD);
   buf inst3  (delayed_SD, SD);
`endif


   not inst4  (int_res__CK, delayed_CK);
   not inst5  (int_res__RD, delayed_RD);
   not inst6  (int_res__SD, delayed_SD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_sr_err inst7  (xcr_0, int_res__CK, delayed_D, int_res__SD, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
 
   `ifdef VIRL_functiononly
        snps_dff_sr_0 #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, int_res__CK, delayed_D, int_res__SD, int_res__RD, xcr_0);
    `else
        snps_dff_sr_0 inst9  (Q, viol_0, int_res__CK, delayed_D, int_res__SD, int_res__RD, xcr_0);
    `endif

    `ifdef VIRL_functiononly

    `else

not inst10  (_net_0, D);
and inst11  (ENABLE_NOT_D_AND_RD_AND_SD, RD, _net_0, SD);
and inst12  (ENABLE_D_AND_RD_AND_SD, RD, D, SD);
and inst13  (ENABLE_RD_AND_SD, SD, RD);
and inst14  (ENABLE_D_AND_SD, SD, D);
not inst15  (_net_1, D);
not inst16  (_net_2, CK);
and inst17  (ENABLE_NOT_CK_AND_NOT_D_AND_SD, _net_1, _net_2, SD);
not inst18  (_net_3, CK);
and inst19  (ENABLE_NOT_CK_AND_D_AND_SD, D, _net_3, SD);
not inst20  (_net_4, D);
and inst21  (ENABLE_CK_AND_NOT_D_AND_SD, _net_4, CK, SD);
and inst22  (ENABLE_CK_AND_D_AND_SD, D, CK, SD);
not inst23  (_net_5, D);
not inst24  (_net_6, CK);
and inst25  (ENABLE_NOT_CK_AND_NOT_D, _net_5, _net_6);
not inst26  (_net_7, CK);
and inst27  (ENABLE_NOT_CK_AND_D, D, _net_7);
not inst28  (_net_8, D);
and inst29  (ENABLE_CK_AND_NOT_D, _net_8, CK);
and inst30  (ENABLE_CK_AND_D, D, CK);
not inst31  (_net_9, D);
and inst32  (ENABLE_NOT_D_AND_RD, RD, _net_9);
not inst33  (_net_10, D);
not inst34  (_net_11, CK);
and inst35  (ENABLE_NOT_CK_AND_NOT_D_AND_RD, _net_10, _net_11, RD);
not inst36  (_net_12, CK);
and inst37  (ENABLE_NOT_CK_AND_D_AND_RD, D, _net_12, RD);
not inst38  (_net_13, D);
and inst39  (ENABLE_CK_AND_NOT_D_AND_RD, _net_13, CK, RD);
and inst40  (ENABLE_CK_AND_D_AND_RD, D, CK, RD);

specify
if (CK==1'b0 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$setuphold(negedge CK &&& ENABLE_RD_AND_SD , posedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_RD_AND_SD , negedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_D_AND_SD , negedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD , 0 ,0, viol_0);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D , posedge RD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D , posedge RD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D , posedge RD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD , negedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D , posedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D , posedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D , posedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD , 0 ,0, viol_0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDNRBSBQ_V2Y2_4

//%BEGIN HDBSVT11_FDN_V2Y2_1

`celldefine
module HDBSVT11_FDN_V2Y2_1 (Q, QN, CK, D);
   output Q, QN;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res__CK, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


   not inst2  (int_res__CK, delayed_CK);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst3  (xcr_0, int_res__CK, delayed_D);

  `endif
   snps_dff inst4  (int_res_iq, viol_0, int_res__CK, delayed_D, xcr_0);
   
`ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst5 (Q, int_res_iq);
    not #`SNPS_SEQ_DELAY  inst6 (QN, int_res_iq);
`else
    buf inst7  (Q, int_res_iq);
    not inst8  (QN, int_res_iq);
`endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

not inst9  (ENABLE_NOT_D, D);
buf inst10  (ENABLE_D, D);

specify
if (D==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
(negedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(negedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_FDN_V2Y2_1

  

//%BEGIN HDBSVT11_FDN_V2Y2_2

`celldefine
module HDBSVT11_FDN_V2Y2_2 (Q, QN, CK, D);
   output Q, QN;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res__CK, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


   not inst2  (int_res__CK, delayed_CK);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst3  (xcr_0, int_res__CK, delayed_D);

  `endif
   snps_dff inst4  (int_res_iq, viol_0, int_res__CK, delayed_D, xcr_0);
   
`ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst5 (Q, int_res_iq);
    not #`SNPS_SEQ_DELAY  inst6 (QN, int_res_iq);
`else
    buf inst7  (Q, int_res_iq);
    not inst8  (QN, int_res_iq);
`endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

not inst9  (ENABLE_NOT_D, D);
buf inst10  (ENABLE_D, D);

specify
if (D==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
(negedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(negedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_FDN_V2Y2_2

  

//%BEGIN HDBSVT11_FDN_V2Y2_4

`celldefine
module HDBSVT11_FDN_V2Y2_4 (Q, QN, CK, D);
   output Q, QN;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res__CK, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


   not inst2  (int_res__CK, delayed_CK);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst3  (xcr_0, int_res__CK, delayed_D);

  `endif
   snps_dff inst4  (int_res_iq, viol_0, int_res__CK, delayed_D, xcr_0);
   
`ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst5 (Q, int_res_iq);
    not #`SNPS_SEQ_DELAY  inst6 (QN, int_res_iq);
`else
    buf inst7  (Q, int_res_iq);
    not inst8  (QN, int_res_iq);
`endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

not inst9  (ENABLE_NOT_D, D);
buf inst10  (ENABLE_D, D);

specify
if (D==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
(negedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(negedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_FDN_V2Y2_4

  

//%BEGIN HDBSVT11_FDPCBQ_V2Y2_1

`celldefine
module HDBSVT11_FDPCBQ_V2Y2_1 (Q, CK, D, RS);
   output Q;
   input CK, D, RS;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_RS;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RS, RS);
`endif


   and inst3  (int_res__D, delayed_D, delayed_RS);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst4  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       snps_dff #`SNPS_SEQ_DELAY  inst5 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
       snps_dff inst6  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst7  (_net_0, RS);
not inst8  (_net_1, D);
and inst9  (ENABLE_NOT_D_AND_NOT_RS, _net_0, _net_1);
not inst10  (_net_2, D);
and inst11  (ENABLE_NOT_D_AND_RS, RS, _net_2);
not inst12  (_net_3, RS);
and inst13  (ENABLE_D_AND_NOT_RS, _net_3, D);
and inst14  (ENABLE_D_AND_RS, RS, D);
buf inst15  (ENABLE_RS, RS);
buf inst16  (ENABLE_D, D);

specify
if (D==1'b0 && RS==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RS==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RS==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RS==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RS , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RS , posedge D &&& ENABLE_RS , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RS , negedge D &&& ENABLE_RS , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D , posedge RS &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_RS);
$setuphold(posedge CK &&& ENABLE_D , negedge RS &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_RS);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPCBQ_V2Y2_1

//%BEGIN HDBSVT11_FDPCBQ_V2Y2_2

`celldefine
module HDBSVT11_FDPCBQ_V2Y2_2 (Q, CK, D, RS);
   output Q;
   input CK, D, RS;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_RS;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RS, RS);
`endif


   and inst3  (int_res__D, delayed_D, delayed_RS);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst4  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       snps_dff #`SNPS_SEQ_DELAY  inst5 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
       snps_dff inst6  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst7  (_net_0, RS);
not inst8  (_net_1, D);
and inst9  (ENABLE_NOT_D_AND_NOT_RS, _net_0, _net_1);
not inst10  (_net_2, D);
and inst11  (ENABLE_NOT_D_AND_RS, RS, _net_2);
not inst12  (_net_3, RS);
and inst13  (ENABLE_D_AND_NOT_RS, _net_3, D);
and inst14  (ENABLE_D_AND_RS, RS, D);
buf inst15  (ENABLE_RS, RS);
buf inst16  (ENABLE_D, D);

specify
if (D==1'b0 && RS==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RS==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RS==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RS==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RS , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RS , posedge D &&& ENABLE_RS , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RS , negedge D &&& ENABLE_RS , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D , posedge RS &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_RS);
$setuphold(posedge CK &&& ENABLE_D , negedge RS &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_RS);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPCBQ_V2Y2_2

//%BEGIN HDBSVT11_FDPCBQ_V2Y2_4

`celldefine
module HDBSVT11_FDPCBQ_V2Y2_4 (Q, CK, D, RS);
   output Q;
   input CK, D, RS;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_RS;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RS, RS);
`endif


   and inst3  (int_res__D, delayed_D, delayed_RS);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst4  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       snps_dff #`SNPS_SEQ_DELAY  inst5 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
       snps_dff inst6  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst7  (_net_0, RS);
not inst8  (_net_1, D);
and inst9  (ENABLE_NOT_D_AND_NOT_RS, _net_0, _net_1);
not inst10  (_net_2, D);
and inst11  (ENABLE_NOT_D_AND_RS, RS, _net_2);
not inst12  (_net_3, RS);
and inst13  (ENABLE_D_AND_NOT_RS, _net_3, D);
and inst14  (ENABLE_D_AND_RS, RS, D);
buf inst15  (ENABLE_RS, RS);
buf inst16  (ENABLE_D, D);

specify
if (D==1'b0 && RS==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RS==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RS==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RS==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RS , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RS , posedge D &&& ENABLE_RS , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RS , negedge D &&& ENABLE_RS , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D , posedge RS &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_RS);
$setuphold(posedge CK &&& ENABLE_D , negedge RS &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_RS);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPCBQ_V2Y2_4

//%BEGIN HDBSVT11_FDPCBQ_Y2_1

`celldefine
module HDBSVT11_FDPCBQ_Y2_1 (Q, CK, D, RS);
   output Q;
   input CK, D, RS;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_RS;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RS, RS);
`endif


   and inst3  (int_res__D, delayed_D, delayed_RS);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst4  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       snps_dff #`SNPS_SEQ_DELAY  inst5 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
       snps_dff inst6  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst7  (_net_0, RS);
not inst8  (_net_1, D);
and inst9  (ENABLE_NOT_D_AND_NOT_RS, _net_0, _net_1);
not inst10  (_net_2, D);
and inst11  (ENABLE_NOT_D_AND_RS, RS, _net_2);
not inst12  (_net_3, RS);
and inst13  (ENABLE_D_AND_NOT_RS, _net_3, D);
and inst14  (ENABLE_D_AND_RS, RS, D);
buf inst15  (ENABLE_RS, RS);
buf inst16  (ENABLE_D, D);

specify
if (D==1'b0 && RS==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RS==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RS==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RS==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RS , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RS , posedge D &&& ENABLE_RS , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RS , negedge D &&& ENABLE_RS , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D , posedge RS &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_RS);
$setuphold(posedge CK &&& ENABLE_D , negedge RS &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_RS);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPCBQ_Y2_1

//%BEGIN HDBSVT11_FDPCBQ_Y2_2

`celldefine
module HDBSVT11_FDPCBQ_Y2_2 (Q, CK, D, RS);
   output Q;
   input CK, D, RS;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_RS;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RS, RS);
`endif


   and inst3  (int_res__D, delayed_D, delayed_RS);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst4  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       snps_dff #`SNPS_SEQ_DELAY  inst5 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
       snps_dff inst6  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst7  (_net_0, RS);
not inst8  (_net_1, D);
and inst9  (ENABLE_NOT_D_AND_NOT_RS, _net_0, _net_1);
not inst10  (_net_2, D);
and inst11  (ENABLE_NOT_D_AND_RS, RS, _net_2);
not inst12  (_net_3, RS);
and inst13  (ENABLE_D_AND_NOT_RS, _net_3, D);
and inst14  (ENABLE_D_AND_RS, RS, D);
buf inst15  (ENABLE_RS, RS);
buf inst16  (ENABLE_D, D);

specify
if (D==1'b0 && RS==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RS==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RS==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RS==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RS , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RS , posedge D &&& ENABLE_RS , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RS , negedge D &&& ENABLE_RS , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D , posedge RS &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_RS);
$setuphold(posedge CK &&& ENABLE_D , negedge RS &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_RS);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPCBQ_Y2_2

//%BEGIN HDBSVT11_FDPCBQ_Y2_4

`celldefine
module HDBSVT11_FDPCBQ_Y2_4 (Q, CK, D, RS);
   output Q;
   input CK, D, RS;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_RS;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RS, RS);
`endif


   and inst3  (int_res__D, delayed_D, delayed_RS);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst4  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       snps_dff #`SNPS_SEQ_DELAY  inst5 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
       snps_dff inst6  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst7  (_net_0, RS);
not inst8  (_net_1, D);
and inst9  (ENABLE_NOT_D_AND_NOT_RS, _net_0, _net_1);
not inst10  (_net_2, D);
and inst11  (ENABLE_NOT_D_AND_RS, RS, _net_2);
not inst12  (_net_3, RS);
and inst13  (ENABLE_D_AND_NOT_RS, _net_3, D);
and inst14  (ENABLE_D_AND_RS, RS, D);
buf inst15  (ENABLE_RS, RS);
buf inst16  (ENABLE_D, D);

specify
if (D==1'b0 && RS==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RS==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RS==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RS==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RS , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RS , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RS , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RS , posedge D &&& ENABLE_RS , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RS , negedge D &&& ENABLE_RS , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D , posedge RS &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_RS);
$setuphold(posedge CK &&& ENABLE_D , negedge RS &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_RS);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPCBQ_Y2_4

//%BEGIN HDBSVT11_FDPHBQ_V2Y2_1
`celldefine
module HDBSVT11_FDPHBQ_V2Y2_1 (Q, CK, D, EN);
  input CK, D, EN;
  output Q;
  reg viol_0;
  wire iq, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_EN, EN);
  `endif


  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst3  (xcr_3, delayed_CK, d_int);

  `endif
    snps_dff inst4  (iq, viol_0, delayed_CK, d_int, xcr_3);
    snps_mux2 inst5  (d_int, delayed_D, iq, delayed_EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst6 (Q, iq);
  `else
    buf inst7  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst8  (_net_0, D);
and inst9  (ENABLE_NOT_D_AND_EN, EN, _net_0);
and inst10  (ENABLE_D_AND_EN, EN, D);
buf inst11  (ENABLE_EN, EN);
not inst12  (ENABLE_NOT_D, D);
buf inst13  (ENABLE_D, D);

specify
if (D==1'b0 && EN==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_EN , posedge D &&& ENABLE_EN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN , negedge D &&& ENABLE_EN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D , posedge EN &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D , negedge EN &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D , posedge EN &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D , negedge EN &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FDPHBQ_V2Y2_1

//%BEGIN HDBSVT11_FDPHBQ_V2Y2_2
`celldefine
module HDBSVT11_FDPHBQ_V2Y2_2 (Q, CK, D, EN);
  input CK, D, EN;
  output Q;
  reg viol_0;
  wire iq, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_EN, EN);
  `endif


  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst3  (xcr_3, delayed_CK, d_int);

  `endif
    snps_dff inst4  (iq, viol_0, delayed_CK, d_int, xcr_3);
    snps_mux2 inst5  (d_int, delayed_D, iq, delayed_EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst6 (Q, iq);
  `else
    buf inst7  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst8  (_net_0, D);
and inst9  (ENABLE_NOT_D_AND_EN, EN, _net_0);
and inst10  (ENABLE_D_AND_EN, EN, D);
buf inst11  (ENABLE_EN, EN);
not inst12  (ENABLE_NOT_D, D);
buf inst13  (ENABLE_D, D);

specify
if (D==1'b0 && EN==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_EN , posedge D &&& ENABLE_EN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN , negedge D &&& ENABLE_EN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D , posedge EN &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D , negedge EN &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D , posedge EN &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D , negedge EN &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FDPHBQ_V2Y2_2

//%BEGIN HDBSVT11_FDPHBQ_V2Y2_4
`celldefine
module HDBSVT11_FDPHBQ_V2Y2_4 (Q, CK, D, EN);
  input CK, D, EN;
  output Q;
  reg viol_0;
  wire iq, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_EN, EN);
  `endif


  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst3  (xcr_3, delayed_CK, d_int);

  `endif
    snps_dff inst4  (iq, viol_0, delayed_CK, d_int, xcr_3);
    snps_mux2 inst5  (d_int, delayed_D, iq, delayed_EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst6 (Q, iq);
  `else
    buf inst7  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst8  (_net_0, D);
and inst9  (ENABLE_NOT_D_AND_EN, EN, _net_0);
and inst10  (ENABLE_D_AND_EN, EN, D);
buf inst11  (ENABLE_EN, EN);
not inst12  (ENABLE_NOT_D, D);
buf inst13  (ENABLE_D, D);

specify
if (D==1'b0 && EN==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_EN , posedge D &&& ENABLE_EN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN , negedge D &&& ENABLE_EN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D , posedge EN &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D , negedge EN &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D , posedge EN &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D , negedge EN &&& ENABLE_D , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FDPHBQ_V2Y2_4

//%BEGIN HDBSVT11_FDPMQ_V2Y2_1

`celldefine
module HDBSVT11_FDPMQ_V2Y2_1 (Q, CK, D0, D1, S);
   output Q;
   input CK, D0, D1, S;

   reg viol_0;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_S;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_S, S);
`endif


   snps_mux2 inst4  (int_res__D, delayed_D1, delayed_D0, delayed_S);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
         snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, D1);
not inst9  (_net_1, D0);
not inst10  (_net_2, S);
and inst11  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S, _net_0, _net_1, _net_2);
not inst12  (_net_3, D1);
not inst13  (_net_4, D0);
and inst14  (ENABLE_NOT_D0_AND_NOT_D1_AND_S, _net_3, _net_4, S);
not inst15  (_net_5, D0);
not inst16  (_net_6, S);
and inst17  (ENABLE_NOT_D0_AND_D1_AND_NOT_S, D1, _net_5, _net_6);
not inst18  (_net_7, D0);
and inst19  (ENABLE_NOT_D0_AND_D1_AND_S, D1, _net_7, S);
not inst20  (_net_8, D1);
not inst21  (_net_9, S);
and inst22  (ENABLE_D0_AND_NOT_D1_AND_NOT_S, _net_8, D0, _net_9);
not inst23  (_net_10, D1);
and inst24  (ENABLE_D0_AND_NOT_D1_AND_S, _net_10, D0, S);
not inst25  (_net_11, S);
and inst26  (ENABLE_D0_AND_D1_AND_NOT_S, D1, D0, _net_11);
and inst27  (ENABLE_D0_AND_D1_AND_S, D1, D0, S);
not inst28  (_net_12, S);
not inst29  (_net_13, D1);
and inst30  (ENABLE_NOT_D1_AND_NOT_S, _net_12, _net_13);
not inst31  (_net_14, S);
and inst32  (ENABLE_D1_AND_NOT_S, _net_14, D1);
not inst33  (_net_15, D0);
and inst34  (ENABLE_NOT_D0_AND_S, S, _net_15);
and inst35  (ENABLE_D0_AND_S, S, D0);
not inst36  (_net_16, D0);
and inst37  (ENABLE_NOT_D0_AND_D1, D1, _net_16);
not inst38  (_net_17, D1);
and inst39  (ENABLE_D0_AND_NOT_D1, _net_17, D0);

specify
if (D0==1'b0 && D1==1'b0 && S==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_S , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S , posedge D0 &&& ENABLE_NOT_D1_AND_NOT_S , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S , negedge D0 &&& ENABLE_NOT_D1_AND_NOT_S , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S , posedge D0 &&& ENABLE_D1_AND_NOT_S , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S , negedge D0 &&& ENABLE_D1_AND_NOT_S , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S , posedge D1 &&& ENABLE_NOT_D0_AND_S , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S , negedge D1 &&& ENABLE_NOT_D0_AND_S , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S , posedge D1 &&& ENABLE_D0_AND_S , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S , negedge D1 &&& ENABLE_D0_AND_S , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1 , posedge S &&& ENABLE_NOT_D0_AND_D1 , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1 , negedge S &&& ENABLE_NOT_D0_AND_D1 , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1 , posedge S &&& ENABLE_D0_AND_NOT_D1 , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1 , negedge S &&& ENABLE_D0_AND_NOT_D1 , 0 ,0, viol_0, , , delayed_CK, delayed_S);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPMQ_V2Y2_1

//%BEGIN HDBSVT11_FDPMQ_V2Y2_2

`celldefine
module HDBSVT11_FDPMQ_V2Y2_2 (Q, CK, D0, D1, S);
   output Q;
   input CK, D0, D1, S;

   reg viol_0;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_S;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_S, S);
`endif


   snps_mux2 inst4  (int_res__D, delayed_D1, delayed_D0, delayed_S);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
         snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, D1);
not inst9  (_net_1, D0);
not inst10  (_net_2, S);
and inst11  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S, _net_0, _net_1, _net_2);
not inst12  (_net_3, D1);
not inst13  (_net_4, D0);
and inst14  (ENABLE_NOT_D0_AND_NOT_D1_AND_S, _net_3, _net_4, S);
not inst15  (_net_5, D0);
not inst16  (_net_6, S);
and inst17  (ENABLE_NOT_D0_AND_D1_AND_NOT_S, D1, _net_5, _net_6);
not inst18  (_net_7, D0);
and inst19  (ENABLE_NOT_D0_AND_D1_AND_S, D1, _net_7, S);
not inst20  (_net_8, D1);
not inst21  (_net_9, S);
and inst22  (ENABLE_D0_AND_NOT_D1_AND_NOT_S, _net_8, D0, _net_9);
not inst23  (_net_10, D1);
and inst24  (ENABLE_D0_AND_NOT_D1_AND_S, _net_10, D0, S);
not inst25  (_net_11, S);
and inst26  (ENABLE_D0_AND_D1_AND_NOT_S, D1, D0, _net_11);
and inst27  (ENABLE_D0_AND_D1_AND_S, D1, D0, S);
not inst28  (_net_12, S);
not inst29  (_net_13, D1);
and inst30  (ENABLE_NOT_D1_AND_NOT_S, _net_12, _net_13);
not inst31  (_net_14, S);
and inst32  (ENABLE_D1_AND_NOT_S, _net_14, D1);
not inst33  (_net_15, D0);
and inst34  (ENABLE_NOT_D0_AND_S, S, _net_15);
and inst35  (ENABLE_D0_AND_S, S, D0);
not inst36  (_net_16, D0);
and inst37  (ENABLE_NOT_D0_AND_D1, D1, _net_16);
not inst38  (_net_17, D1);
and inst39  (ENABLE_D0_AND_NOT_D1, _net_17, D0);

specify
if (D0==1'b0 && D1==1'b0 && S==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_S , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S , posedge D0 &&& ENABLE_NOT_D1_AND_NOT_S , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S , negedge D0 &&& ENABLE_NOT_D1_AND_NOT_S , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S , posedge D0 &&& ENABLE_D1_AND_NOT_S , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S , negedge D0 &&& ENABLE_D1_AND_NOT_S , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S , posedge D1 &&& ENABLE_NOT_D0_AND_S , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S , negedge D1 &&& ENABLE_NOT_D0_AND_S , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S , posedge D1 &&& ENABLE_D0_AND_S , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S , negedge D1 &&& ENABLE_D0_AND_S , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1 , posedge S &&& ENABLE_NOT_D0_AND_D1 , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1 , negedge S &&& ENABLE_NOT_D0_AND_D1 , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1 , posedge S &&& ENABLE_D0_AND_NOT_D1 , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1 , negedge S &&& ENABLE_D0_AND_NOT_D1 , 0 ,0, viol_0, , , delayed_CK, delayed_S);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPMQ_V2Y2_2

//%BEGIN HDBSVT11_FDPMQ_V2Y2_4

`celldefine
module HDBSVT11_FDPMQ_V2Y2_4 (Q, CK, D0, D1, S);
   output Q;
   input CK, D0, D1, S;

   reg viol_0;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_S;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_S, S);
`endif


   snps_mux2 inst4  (int_res__D, delayed_D1, delayed_D0, delayed_S);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
         snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, D1);
not inst9  (_net_1, D0);
not inst10  (_net_2, S);
and inst11  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S, _net_0, _net_1, _net_2);
not inst12  (_net_3, D1);
not inst13  (_net_4, D0);
and inst14  (ENABLE_NOT_D0_AND_NOT_D1_AND_S, _net_3, _net_4, S);
not inst15  (_net_5, D0);
not inst16  (_net_6, S);
and inst17  (ENABLE_NOT_D0_AND_D1_AND_NOT_S, D1, _net_5, _net_6);
not inst18  (_net_7, D0);
and inst19  (ENABLE_NOT_D0_AND_D1_AND_S, D1, _net_7, S);
not inst20  (_net_8, D1);
not inst21  (_net_9, S);
and inst22  (ENABLE_D0_AND_NOT_D1_AND_NOT_S, _net_8, D0, _net_9);
not inst23  (_net_10, D1);
and inst24  (ENABLE_D0_AND_NOT_D1_AND_S, _net_10, D0, S);
not inst25  (_net_11, S);
and inst26  (ENABLE_D0_AND_D1_AND_NOT_S, D1, D0, _net_11);
and inst27  (ENABLE_D0_AND_D1_AND_S, D1, D0, S);
not inst28  (_net_12, S);
not inst29  (_net_13, D1);
and inst30  (ENABLE_NOT_D1_AND_NOT_S, _net_12, _net_13);
not inst31  (_net_14, S);
and inst32  (ENABLE_D1_AND_NOT_S, _net_14, D1);
not inst33  (_net_15, D0);
and inst34  (ENABLE_NOT_D0_AND_S, S, _net_15);
and inst35  (ENABLE_D0_AND_S, S, D0);
not inst36  (_net_16, D0);
and inst37  (ENABLE_NOT_D0_AND_D1, D1, _net_16);
not inst38  (_net_17, D1);
and inst39  (ENABLE_D0_AND_NOT_D1, _net_17, D0);

specify
if (D0==1'b0 && D1==1'b0 && S==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_S , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S , posedge D0 &&& ENABLE_NOT_D1_AND_NOT_S , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S , negedge D0 &&& ENABLE_NOT_D1_AND_NOT_S , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S , posedge D0 &&& ENABLE_D1_AND_NOT_S , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S , negedge D0 &&& ENABLE_D1_AND_NOT_S , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S , posedge D1 &&& ENABLE_NOT_D0_AND_S , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S , negedge D1 &&& ENABLE_NOT_D0_AND_S , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S , posedge D1 &&& ENABLE_D0_AND_S , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S , negedge D1 &&& ENABLE_D0_AND_S , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1 , posedge S &&& ENABLE_NOT_D0_AND_D1 , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1 , negedge S &&& ENABLE_NOT_D0_AND_D1 , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1 , posedge S &&& ENABLE_D0_AND_NOT_D1 , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1 , negedge S &&& ENABLE_D0_AND_NOT_D1 , 0 ,0, viol_0, , , delayed_CK, delayed_S);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPMQ_V2Y2_4

//%BEGIN HDBSVT11_FDPQB_V2Y2_1

`celldefine
module HDBSVT11_FDPQB_V2Y2_1 (QN, CK, D);
   output QN;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif
   snps_dff inst3  (int_res_iq, viol_0, delayed_CK, delayed_D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst4 (QN, int_res_iq);
   `else
        not inst5  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (D==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQB_V2Y2_1

//%BEGIN HDBSVT11_FDPQB_V2Y2_2

`celldefine
module HDBSVT11_FDPQB_V2Y2_2 (QN, CK, D);
   output QN;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif
   snps_dff inst3  (int_res_iq, viol_0, delayed_CK, delayed_D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst4 (QN, int_res_iq);
   `else
        not inst5  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (D==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQB_V2Y2_2

//%BEGIN HDBSVT11_FDPQB_V2Y2_4

`celldefine
module HDBSVT11_FDPQB_V2Y2_4 (QN, CK, D);
   output QN;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif
   snps_dff inst3  (int_res_iq, viol_0, delayed_CK, delayed_D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst4 (QN, int_res_iq);
   `else
        not inst5  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (D==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQB_V2Y2_4

//%BEGIN HDBSVT11_FDPQB_V2Y2_8

`celldefine
module HDBSVT11_FDPQB_V2Y2_8 (QN, CK, D);
   output QN;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif
   snps_dff inst3  (int_res_iq, viol_0, delayed_CK, delayed_D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst4 (QN, int_res_iq);
   `else
        not inst5  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (D==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQB_V2Y2_8

//%BEGIN HDBSVT11_FDPQB_V3Y2_1

`celldefine
module HDBSVT11_FDPQB_V3Y2_1 (QN, CK, D);
   output QN;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif
   snps_dff inst3  (int_res_iq, viol_0, delayed_CK, delayed_D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst4 (QN, int_res_iq);
   `else
        not inst5  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (D==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQB_V3Y2_1

//%BEGIN HDBSVT11_FDPQB_V3Y2_2

`celldefine
module HDBSVT11_FDPQB_V3Y2_2 (QN, CK, D);
   output QN;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif
   snps_dff inst3  (int_res_iq, viol_0, delayed_CK, delayed_D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst4 (QN, int_res_iq);
   `else
        not inst5  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (D==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQB_V3Y2_2

//%BEGIN HDBSVT11_FDPQB_V3Y2_4

`celldefine
module HDBSVT11_FDPQB_V3Y2_4 (QN, CK, D);
   output QN;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif
   snps_dff inst3  (int_res_iq, viol_0, delayed_CK, delayed_D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst4 (QN, int_res_iq);
   `else
        not inst5  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (D==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQB_V3Y2_4

//%BEGIN HDBSVT11_FDPQB_V3Y2_8

`celldefine
module HDBSVT11_FDPQB_V3Y2_8 (QN, CK, D);
   output QN;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif
   snps_dff inst3  (int_res_iq, viol_0, delayed_CK, delayed_D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst4 (QN, int_res_iq);
   `else
        not inst5  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (D==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQB_V3Y2_8

//%BEGIN HDBSVT11_FDPQ_CBV2Y4ECOM2FS_1

`celldefine
module HDBSVT11_FDPQ_CBV2Y4ECOM2FS_1 (Q, CK, D);
   output Q;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst3 (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `else
        snps_dff inst4  (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////



not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (D==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQ_CBV2Y4ECOM2FS_1

//%BEGIN HDBSVT11_FDPQ_CBV2Y4ECOM2_1

`celldefine
module HDBSVT11_FDPQ_CBV2Y4ECOM2_1 (Q, CK, D);
   output Q;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst3 (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `else
        snps_dff inst4  (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////



not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (D==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQ_CBV2Y4ECOM2_1

//%BEGIN HDBSVT11_FDPQ_V2Y2_6

`celldefine
module HDBSVT11_FDPQ_V2Y2_6 (Q, CK, D);
   output Q;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst3 (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `else
        snps_dff inst4  (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////



not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (D==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQ_V2Y2_6

//%BEGIN HDBSVT11_FDPQ_V2Y4ECOM2FS_1

`celldefine
module HDBSVT11_FDPQ_V2Y4ECOM2FS_1 (Q, CK, D);
   output Q;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst3 (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `else
        snps_dff inst4  (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////



not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (D==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQ_V2Y4ECOM2FS_1

//%BEGIN HDBSVT11_FDPQ_V2Y4ECOM2_1

`celldefine
module HDBSVT11_FDPQ_V2Y4ECOM2_1 (Q, CK, D);
   output Q;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst3 (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `else
        snps_dff inst4  (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////



not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (D==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQ_V2Y4ECOM2_1

//%BEGIN HDBSVT11_FDPQ_V2Y4ECO_1

`celldefine
module HDBSVT11_FDPQ_V2Y4ECO_1 (Q, CK, D);
   output Q;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst3 (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `else
        snps_dff inst4  (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////



not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (D==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQ_V2Y4ECO_1

//%BEGIN HDBSVT11_FDPQ_V3Y2_1

`celldefine
module HDBSVT11_FDPQ_V3Y2_1 (Q, CK, D);
   output Q;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst3 (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `else
        snps_dff inst4  (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////



not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (D==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQ_V3Y2_1

//%BEGIN HDBSVT11_FDPQ_V3Y2_2

`celldefine
module HDBSVT11_FDPQ_V3Y2_2 (Q, CK, D);
   output Q;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst3 (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `else
        snps_dff inst4  (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////



not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (D==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQ_V3Y2_2

//%BEGIN HDBSVT11_FDPQ_V3Y2_4

`celldefine
module HDBSVT11_FDPQ_V3Y2_4 (Q, CK, D);
   output Q;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst3 (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `else
        snps_dff inst4  (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////



not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (D==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQ_V3Y2_4

//%BEGIN HDBSVT11_FDPQ_V4Y2_1

`celldefine
module HDBSVT11_FDPQ_V4Y2_1 (Q, CK, D);
   output Q;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst3 (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `else
        snps_dff inst4  (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////



not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (D==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQ_V4Y2_1

//%BEGIN HDBSVT11_FDPQ_V4Y2_8

`celldefine
module HDBSVT11_FDPQ_V4Y2_8 (Q, CK, D);
   output Q;
   input CK, D;

   reg viol_0;
   wire delayed_CK, delayed_D;

   wire xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst3 (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `else
        snps_dff inst4  (Q, viol_0, delayed_CK, delayed_D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////



not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (D==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPQ_V4Y2_8

//%BEGIN HDBSVT11_FDPRBQ_V2Y2_1

`celldefine
module HDBSVT11_FDPRBQ_V2Y2_1 (Q, CK, D, RD);
   output Q;
   input CK, D, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_RD;

   wire int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RD, RD);
`endif

  
   not inst3  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst4  (xcr_0, delayed_CK, delayed_D, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         snps_dff_r #`SNPS_SEQ_DELAY  inst5 (Q, viol_0, delayed_CK, delayed_D, int_res__RD, xcr_0);
   `else
         snps_dff_r inst6  (Q, viol_0, delayed_CK, delayed_D, int_res__RD, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst7  (_net_0, D);
and inst8  (ENABLE_NOT_D_AND_RD, RD, _net_0);
and inst9  (ENABLE_D_AND_RD, RD, D);
buf inst10  (ENABLE_RD, RD);
buf inst11  (ENABLE_D, D);
not inst12  (_net_1, D);
not inst13  (_net_2, CK);
and inst14  (ENABLE_NOT_CK_AND_NOT_D, _net_1, _net_2);
not inst15  (_net_3, CK);
and inst16  (ENABLE_NOT_CK_AND_D, D, _net_3);
not inst17  (_net_4, D);
and inst18  (ENABLE_CK_AND_NOT_D, _net_4, CK);
and inst19  (ENABLE_CK_AND_D, D, CK);

specify
if (CK==1'b0 && D==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (D==1'b0 && RD==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD , posedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD , negedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_D , posedge CK &&& ENABLE_D , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPRBQ_V2Y2_1

//%BEGIN HDBSVT11_FDPRBQ_V2Y2_2

`celldefine
module HDBSVT11_FDPRBQ_V2Y2_2 (Q, CK, D, RD);
   output Q;
   input CK, D, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_RD;

   wire int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RD, RD);
`endif

  
   not inst3  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst4  (xcr_0, delayed_CK, delayed_D, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         snps_dff_r #`SNPS_SEQ_DELAY  inst5 (Q, viol_0, delayed_CK, delayed_D, int_res__RD, xcr_0);
   `else
         snps_dff_r inst6  (Q, viol_0, delayed_CK, delayed_D, int_res__RD, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst7  (_net_0, D);
and inst8  (ENABLE_NOT_D_AND_RD, RD, _net_0);
and inst9  (ENABLE_D_AND_RD, RD, D);
buf inst10  (ENABLE_RD, RD);
buf inst11  (ENABLE_D, D);
not inst12  (_net_1, D);
not inst13  (_net_2, CK);
and inst14  (ENABLE_NOT_CK_AND_NOT_D, _net_1, _net_2);
not inst15  (_net_3, CK);
and inst16  (ENABLE_NOT_CK_AND_D, D, _net_3);
not inst17  (_net_4, D);
and inst18  (ENABLE_CK_AND_NOT_D, _net_4, CK);
and inst19  (ENABLE_CK_AND_D, D, CK);

specify
if (CK==1'b0 && D==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (D==1'b0 && RD==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD , posedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD , negedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_D , posedge CK &&& ENABLE_D , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPRBQ_V2Y2_2

//%BEGIN HDBSVT11_FDPRBQ_V2Y2_4

`celldefine
module HDBSVT11_FDPRBQ_V2Y2_4 (Q, CK, D, RD);
   output Q;
   input CK, D, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_RD;

   wire int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RD, RD);
`endif

  
   not inst3  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst4  (xcr_0, delayed_CK, delayed_D, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         snps_dff_r #`SNPS_SEQ_DELAY  inst5 (Q, viol_0, delayed_CK, delayed_D, int_res__RD, xcr_0);
   `else
         snps_dff_r inst6  (Q, viol_0, delayed_CK, delayed_D, int_res__RD, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst7  (_net_0, D);
and inst8  (ENABLE_NOT_D_AND_RD, RD, _net_0);
and inst9  (ENABLE_D_AND_RD, RD, D);
buf inst10  (ENABLE_RD, RD);
buf inst11  (ENABLE_D, D);
not inst12  (_net_1, D);
not inst13  (_net_2, CK);
and inst14  (ENABLE_NOT_CK_AND_NOT_D, _net_1, _net_2);
not inst15  (_net_3, CK);
and inst16  (ENABLE_NOT_CK_AND_D, D, _net_3);
not inst17  (_net_4, D);
and inst18  (ENABLE_CK_AND_NOT_D, _net_4, CK);
and inst19  (ENABLE_CK_AND_D, D, CK);

specify
if (CK==1'b0 && D==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (D==1'b0 && RD==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD , posedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD , negedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_D , posedge CK &&& ENABLE_D , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPRBQ_V2Y2_4

//%BEGIN HDBSVT11_FDPRBSBQ_CBY2_1

`celldefine
module HDBSVT11_FDPRBSBQ_CBY2_1 (Q, CK, D, RD, SD);
   output Q;
   input CK, D, RD, SD;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_RD, delayed_SD;

   wire int_res__SD, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_D, D);
   buf inst1  (delayed_CK, CK);
   buf inst2  (delayed_RD, RD);
   buf inst3  (delayed_SD, SD);
`endif


   not inst4  (int_res__SD, delayed_SD);
   not inst5  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_sr_err inst6  (xcr_0, delayed_CK, delayed_D, int_res__SD, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_sr_0 #`SNPS_SEQ_DELAY  inst7 (Q, viol_0, delayed_CK, delayed_D, int_res__SD, int_res__RD, xcr_0);
   `else
        snps_dff_sr_0 inst8  (Q, viol_0, delayed_CK, delayed_D, int_res__SD, int_res__RD, xcr_0); 

   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, D);
and inst10  (ENABLE_NOT_D_AND_RD_AND_SD, RD, _net_0, SD);
and inst11  (ENABLE_D_AND_RD_AND_SD, RD, D, SD);
and inst12  (ENABLE_RD_AND_SD, SD, RD);
and inst13  (ENABLE_D_AND_SD, SD, D);
not inst14  (_net_1, D);
not inst15  (_net_2, CK);
and inst16  (ENABLE_NOT_CK_AND_NOT_D_AND_SD, _net_1, _net_2, SD);
not inst17  (_net_3, CK);
and inst18  (ENABLE_NOT_CK_AND_D_AND_SD, D, _net_3, SD);
not inst19  (_net_4, D);
and inst20  (ENABLE_CK_AND_NOT_D_AND_SD, _net_4, CK, SD);
and inst21  (ENABLE_CK_AND_D_AND_SD, D, CK, SD);
not inst22  (_net_5, D);
not inst23  (_net_6, CK);
and inst24  (ENABLE_NOT_CK_AND_NOT_D, _net_5, _net_6);
not inst25  (_net_7, CK);
and inst26  (ENABLE_NOT_CK_AND_D, D, _net_7);
not inst27  (_net_8, D);
and inst28  (ENABLE_CK_AND_NOT_D, _net_8, CK);
and inst29  (ENABLE_CK_AND_D, D, CK);
not inst30  (_net_9, D);
and inst31  (ENABLE_NOT_D_AND_RD, RD, _net_9);
not inst32  (_net_10, D);
not inst33  (_net_11, CK);
and inst34  (ENABLE_NOT_CK_AND_NOT_D_AND_RD, _net_10, _net_11, RD);
not inst35  (_net_12, CK);
and inst36  (ENABLE_NOT_CK_AND_D_AND_RD, D, _net_12, RD);
not inst37  (_net_13, D);
and inst38  (ENABLE_CK_AND_NOT_D_AND_RD, _net_13, CK, RD);
and inst39  (ENABLE_CK_AND_D_AND_RD, D, CK, RD);

specify
if (CK==1'b0 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD , posedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD , negedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_D_AND_SD , posedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD , 0 ,0, viol_0);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D , posedge RD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D , posedge RD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D , posedge RD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD , posedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D , posedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D , posedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D , posedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPRBSBQ_CBY2_1

//%BEGIN HDBSVT11_FDPRBSBQ_P1Y2_1

`celldefine
module HDBSVT11_FDPRBSBQ_P1Y2_1 (Q, CK, D, RD, SD);
   output Q;
   input CK, D, RD, SD;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_RD, delayed_SD;

   wire int_res__SD, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_D, D);
   buf inst1  (delayed_CK, CK);
   buf inst2  (delayed_RD, RD);
   buf inst3  (delayed_SD, SD);
`endif


   not inst4  (int_res__SD, delayed_SD);
   not inst5  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_sr_err inst6  (xcr_0, delayed_CK, delayed_D, int_res__SD, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_sr_0 #`SNPS_SEQ_DELAY  inst7 (Q, viol_0, delayed_CK, delayed_D, int_res__SD, int_res__RD, xcr_0);
   `else
        snps_dff_sr_0 inst8  (Q, viol_0, delayed_CK, delayed_D, int_res__SD, int_res__RD, xcr_0); 

   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, D);
and inst10  (ENABLE_NOT_D_AND_RD_AND_SD, RD, _net_0, SD);
and inst11  (ENABLE_D_AND_RD_AND_SD, RD, D, SD);
and inst12  (ENABLE_RD_AND_SD, SD, RD);
and inst13  (ENABLE_D_AND_SD, SD, D);
not inst14  (_net_1, D);
not inst15  (_net_2, CK);
and inst16  (ENABLE_NOT_CK_AND_NOT_D_AND_SD, _net_1, _net_2, SD);
not inst17  (_net_3, CK);
and inst18  (ENABLE_NOT_CK_AND_D_AND_SD, D, _net_3, SD);
not inst19  (_net_4, D);
and inst20  (ENABLE_CK_AND_NOT_D_AND_SD, _net_4, CK, SD);
and inst21  (ENABLE_CK_AND_D_AND_SD, D, CK, SD);
not inst22  (_net_5, D);
not inst23  (_net_6, CK);
and inst24  (ENABLE_NOT_CK_AND_NOT_D, _net_5, _net_6);
not inst25  (_net_7, CK);
and inst26  (ENABLE_NOT_CK_AND_D, D, _net_7);
not inst27  (_net_8, D);
and inst28  (ENABLE_CK_AND_NOT_D, _net_8, CK);
and inst29  (ENABLE_CK_AND_D, D, CK);
not inst30  (_net_9, D);
and inst31  (ENABLE_NOT_D_AND_RD, RD, _net_9);
not inst32  (_net_10, D);
not inst33  (_net_11, CK);
and inst34  (ENABLE_NOT_CK_AND_NOT_D_AND_RD, _net_10, _net_11, RD);
not inst35  (_net_12, CK);
and inst36  (ENABLE_NOT_CK_AND_D_AND_RD, D, _net_12, RD);
not inst37  (_net_13, D);
and inst38  (ENABLE_CK_AND_NOT_D_AND_RD, _net_13, CK, RD);
and inst39  (ENABLE_CK_AND_D_AND_RD, D, CK, RD);

specify
if (CK==1'b0 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD , posedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD , negedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_D_AND_SD , posedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD , 0 ,0, viol_0);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D , posedge RD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D , posedge RD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D , posedge RD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD , posedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D , posedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D , posedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D , posedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPRBSBQ_P1Y2_1

//%BEGIN HDBSVT11_FDPRBSBQ_Y2FS_1

`celldefine
module HDBSVT11_FDPRBSBQ_Y2FS_1 (Q, CK, D, RD, SD);
   output Q;
   input CK, D, RD, SD;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_RD, delayed_SD;

   wire int_res__SD, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_D, D);
   buf inst1  (delayed_CK, CK);
   buf inst2  (delayed_RD, RD);
   buf inst3  (delayed_SD, SD);
`endif


   not inst4  (int_res__SD, delayed_SD);
   not inst5  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_sr_err inst6  (xcr_0, delayed_CK, delayed_D, int_res__SD, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_sr_0 #`SNPS_SEQ_DELAY  inst7 (Q, viol_0, delayed_CK, delayed_D, int_res__SD, int_res__RD, xcr_0);
   `else
        snps_dff_sr_0 inst8  (Q, viol_0, delayed_CK, delayed_D, int_res__SD, int_res__RD, xcr_0); 

   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, D);
and inst10  (ENABLE_NOT_D_AND_RD_AND_SD, RD, _net_0, SD);
and inst11  (ENABLE_D_AND_RD_AND_SD, RD, D, SD);
and inst12  (ENABLE_RD_AND_SD, SD, RD);
and inst13  (ENABLE_D_AND_SD, SD, D);
not inst14  (_net_1, D);
not inst15  (_net_2, CK);
and inst16  (ENABLE_NOT_CK_AND_NOT_D_AND_SD, _net_1, _net_2, SD);
not inst17  (_net_3, CK);
and inst18  (ENABLE_NOT_CK_AND_D_AND_SD, D, _net_3, SD);
not inst19  (_net_4, D);
and inst20  (ENABLE_CK_AND_NOT_D_AND_SD, _net_4, CK, SD);
and inst21  (ENABLE_CK_AND_D_AND_SD, D, CK, SD);
not inst22  (_net_5, D);
not inst23  (_net_6, CK);
and inst24  (ENABLE_NOT_CK_AND_NOT_D, _net_5, _net_6);
not inst25  (_net_7, CK);
and inst26  (ENABLE_NOT_CK_AND_D, D, _net_7);
not inst27  (_net_8, D);
and inst28  (ENABLE_CK_AND_NOT_D, _net_8, CK);
and inst29  (ENABLE_CK_AND_D, D, CK);
not inst30  (_net_9, D);
and inst31  (ENABLE_NOT_D_AND_RD, RD, _net_9);
not inst32  (_net_10, D);
not inst33  (_net_11, CK);
and inst34  (ENABLE_NOT_CK_AND_NOT_D_AND_RD, _net_10, _net_11, RD);
not inst35  (_net_12, CK);
and inst36  (ENABLE_NOT_CK_AND_D_AND_RD, D, _net_12, RD);
not inst37  (_net_13, D);
and inst38  (ENABLE_CK_AND_NOT_D_AND_RD, _net_13, CK, RD);
and inst39  (ENABLE_CK_AND_D_AND_RD, D, CK, RD);

specify
if (CK==1'b0 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD , posedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD , negedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_D_AND_SD , posedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD , 0 ,0, viol_0);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D , posedge RD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D , posedge RD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D , posedge RD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD , posedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D , posedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D , posedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D , posedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPRBSBQ_Y2FS_1

//%BEGIN HDBSVT11_FDPRBSBQ_Y2_1

`celldefine
module HDBSVT11_FDPRBSBQ_Y2_1 (Q, CK, D, RD, SD);
   output Q;
   input CK, D, RD, SD;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_RD, delayed_SD;

   wire int_res__SD, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_D, D);
   buf inst1  (delayed_CK, CK);
   buf inst2  (delayed_RD, RD);
   buf inst3  (delayed_SD, SD);
`endif


   not inst4  (int_res__SD, delayed_SD);
   not inst5  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_sr_err inst6  (xcr_0, delayed_CK, delayed_D, int_res__SD, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_sr_0 #`SNPS_SEQ_DELAY  inst7 (Q, viol_0, delayed_CK, delayed_D, int_res__SD, int_res__RD, xcr_0);
   `else
        snps_dff_sr_0 inst8  (Q, viol_0, delayed_CK, delayed_D, int_res__SD, int_res__RD, xcr_0); 

   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, D);
and inst10  (ENABLE_NOT_D_AND_RD_AND_SD, RD, _net_0, SD);
and inst11  (ENABLE_D_AND_RD_AND_SD, RD, D, SD);
and inst12  (ENABLE_RD_AND_SD, SD, RD);
and inst13  (ENABLE_D_AND_SD, SD, D);
not inst14  (_net_1, D);
not inst15  (_net_2, CK);
and inst16  (ENABLE_NOT_CK_AND_NOT_D_AND_SD, _net_1, _net_2, SD);
not inst17  (_net_3, CK);
and inst18  (ENABLE_NOT_CK_AND_D_AND_SD, D, _net_3, SD);
not inst19  (_net_4, D);
and inst20  (ENABLE_CK_AND_NOT_D_AND_SD, _net_4, CK, SD);
and inst21  (ENABLE_CK_AND_D_AND_SD, D, CK, SD);
not inst22  (_net_5, D);
not inst23  (_net_6, CK);
and inst24  (ENABLE_NOT_CK_AND_NOT_D, _net_5, _net_6);
not inst25  (_net_7, CK);
and inst26  (ENABLE_NOT_CK_AND_D, D, _net_7);
not inst27  (_net_8, D);
and inst28  (ENABLE_CK_AND_NOT_D, _net_8, CK);
and inst29  (ENABLE_CK_AND_D, D, CK);
not inst30  (_net_9, D);
and inst31  (ENABLE_NOT_D_AND_RD, RD, _net_9);
not inst32  (_net_10, D);
not inst33  (_net_11, CK);
and inst34  (ENABLE_NOT_CK_AND_NOT_D_AND_RD, _net_10, _net_11, RD);
not inst35  (_net_12, CK);
and inst36  (ENABLE_NOT_CK_AND_D_AND_RD, D, _net_12, RD);
not inst37  (_net_13, D);
and inst38  (ENABLE_CK_AND_NOT_D_AND_RD, _net_13, CK, RD);
and inst39  (ENABLE_CK_AND_D_AND_RD, D, CK, RD);

specify
if (CK==1'b0 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD , posedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD , negedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_D_AND_SD , posedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD , 0 ,0, viol_0);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D , posedge RD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D , posedge RD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D , posedge RD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD , posedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D , posedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D , posedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D , posedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPRBSBQ_Y2_1

//%BEGIN HDBSVT11_FDPRBSBQ_Y2_2

`celldefine
module HDBSVT11_FDPRBSBQ_Y2_2 (Q, CK, D, RD, SD);
   output Q;
   input CK, D, RD, SD;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_RD, delayed_SD;

   wire int_res__SD, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_D, D);
   buf inst1  (delayed_CK, CK);
   buf inst2  (delayed_RD, RD);
   buf inst3  (delayed_SD, SD);
`endif


   not inst4  (int_res__SD, delayed_SD);
   not inst5  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_sr_err inst6  (xcr_0, delayed_CK, delayed_D, int_res__SD, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_sr_0 #`SNPS_SEQ_DELAY  inst7 (Q, viol_0, delayed_CK, delayed_D, int_res__SD, int_res__RD, xcr_0);
   `else
        snps_dff_sr_0 inst8  (Q, viol_0, delayed_CK, delayed_D, int_res__SD, int_res__RD, xcr_0); 

   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, D);
and inst10  (ENABLE_NOT_D_AND_RD_AND_SD, RD, _net_0, SD);
and inst11  (ENABLE_D_AND_RD_AND_SD, RD, D, SD);
and inst12  (ENABLE_RD_AND_SD, SD, RD);
and inst13  (ENABLE_D_AND_SD, SD, D);
not inst14  (_net_1, D);
not inst15  (_net_2, CK);
and inst16  (ENABLE_NOT_CK_AND_NOT_D_AND_SD, _net_1, _net_2, SD);
not inst17  (_net_3, CK);
and inst18  (ENABLE_NOT_CK_AND_D_AND_SD, D, _net_3, SD);
not inst19  (_net_4, D);
and inst20  (ENABLE_CK_AND_NOT_D_AND_SD, _net_4, CK, SD);
and inst21  (ENABLE_CK_AND_D_AND_SD, D, CK, SD);
not inst22  (_net_5, D);
not inst23  (_net_6, CK);
and inst24  (ENABLE_NOT_CK_AND_NOT_D, _net_5, _net_6);
not inst25  (_net_7, CK);
and inst26  (ENABLE_NOT_CK_AND_D, D, _net_7);
not inst27  (_net_8, D);
and inst28  (ENABLE_CK_AND_NOT_D, _net_8, CK);
and inst29  (ENABLE_CK_AND_D, D, CK);
not inst30  (_net_9, D);
and inst31  (ENABLE_NOT_D_AND_RD, RD, _net_9);
not inst32  (_net_10, D);
not inst33  (_net_11, CK);
and inst34  (ENABLE_NOT_CK_AND_NOT_D_AND_RD, _net_10, _net_11, RD);
not inst35  (_net_12, CK);
and inst36  (ENABLE_NOT_CK_AND_D_AND_RD, D, _net_12, RD);
not inst37  (_net_13, D);
and inst38  (ENABLE_CK_AND_NOT_D_AND_RD, _net_13, CK, RD);
and inst39  (ENABLE_CK_AND_D_AND_RD, D, CK, RD);

specify
if (CK==1'b0 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD , posedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD , negedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_D_AND_SD , posedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD , 0 ,0, viol_0);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D , posedge RD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D , posedge RD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D , posedge RD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD , posedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D , posedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D , posedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D , posedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPRBSBQ_Y2_2

//%BEGIN HDBSVT11_FDPRBSBQ_Y2_4

`celldefine
module HDBSVT11_FDPRBSBQ_Y2_4 (Q, CK, D, RD, SD);
   output Q;
   input CK, D, RD, SD;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_RD, delayed_SD;

   wire int_res__SD, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_D, D);
   buf inst1  (delayed_CK, CK);
   buf inst2  (delayed_RD, RD);
   buf inst3  (delayed_SD, SD);
`endif


   not inst4  (int_res__SD, delayed_SD);
   not inst5  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_sr_err inst6  (xcr_0, delayed_CK, delayed_D, int_res__SD, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_sr_0 #`SNPS_SEQ_DELAY  inst7 (Q, viol_0, delayed_CK, delayed_D, int_res__SD, int_res__RD, xcr_0);
   `else
        snps_dff_sr_0 inst8  (Q, viol_0, delayed_CK, delayed_D, int_res__SD, int_res__RD, xcr_0); 

   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, D);
and inst10  (ENABLE_NOT_D_AND_RD_AND_SD, RD, _net_0, SD);
and inst11  (ENABLE_D_AND_RD_AND_SD, RD, D, SD);
and inst12  (ENABLE_RD_AND_SD, SD, RD);
and inst13  (ENABLE_D_AND_SD, SD, D);
not inst14  (_net_1, D);
not inst15  (_net_2, CK);
and inst16  (ENABLE_NOT_CK_AND_NOT_D_AND_SD, _net_1, _net_2, SD);
not inst17  (_net_3, CK);
and inst18  (ENABLE_NOT_CK_AND_D_AND_SD, D, _net_3, SD);
not inst19  (_net_4, D);
and inst20  (ENABLE_CK_AND_NOT_D_AND_SD, _net_4, CK, SD);
and inst21  (ENABLE_CK_AND_D_AND_SD, D, CK, SD);
not inst22  (_net_5, D);
not inst23  (_net_6, CK);
and inst24  (ENABLE_NOT_CK_AND_NOT_D, _net_5, _net_6);
not inst25  (_net_7, CK);
and inst26  (ENABLE_NOT_CK_AND_D, D, _net_7);
not inst27  (_net_8, D);
and inst28  (ENABLE_CK_AND_NOT_D, _net_8, CK);
and inst29  (ENABLE_CK_AND_D, D, CK);
not inst30  (_net_9, D);
and inst31  (ENABLE_NOT_D_AND_RD, RD, _net_9);
not inst32  (_net_10, D);
not inst33  (_net_11, CK);
and inst34  (ENABLE_NOT_CK_AND_NOT_D_AND_RD, _net_10, _net_11, RD);
not inst35  (_net_12, CK);
and inst36  (ENABLE_NOT_CK_AND_D_AND_RD, D, _net_12, RD);
not inst37  (_net_13, D);
and inst38  (ENABLE_CK_AND_NOT_D_AND_RD, _net_13, CK, RD);
and inst39  (ENABLE_CK_AND_D_AND_RD, D, CK, RD);

specify
if (CK==1'b0 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD , posedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD , negedge D &&& ENABLE_RD_AND_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_D_AND_SD , posedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD , 0 ,0, viol_0);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D , posedge RD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D , posedge RD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D , posedge RD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD , posedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D , posedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D , posedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D , posedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPRBSBQ_Y2_4

//%BEGIN HDBSVT11_FDPRB_V3Y2_2

`celldefine
module HDBSVT11_FDPRB_V3Y2_2 (Q, QN, CK, D, RD);
   output Q, QN;
   input CK, D, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_RD;

   wire int_res__RD, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RD, RD);
`endif


   not inst3  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst4  (xcr_0, delayed_CK, delayed_D, int_res__RD);

  `endif
   snps_dff_r inst5  (int_res_iq, viol_0, delayed_CK, delayed_D, int_res__RD, xcr_0);
   
   `ifdef VIRL_functiononly
      buf #`SNPS_SEQ_DELAY  inst6 (Q, int_res_iq);
      not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
      buf inst8  (Q, int_res_iq);
      not inst9  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

not inst10  (_net_0, D);
and inst11  (ENABLE_NOT_D_AND_RD, RD, _net_0);
and inst12  (ENABLE_D_AND_RD, RD, D);
buf inst13  (ENABLE_RD, RD);
buf inst14  (ENABLE_D, D);
not inst15  (_net_1, D);
not inst16  (_net_2, CK);
and inst17  (ENABLE_NOT_CK_AND_NOT_D, _net_1, _net_2);
not inst18  (_net_3, CK);
and inst19  (ENABLE_NOT_CK_AND_D, D, _net_3);
not inst20  (_net_4, D);
and inst21  (ENABLE_CK_AND_NOT_D, _net_4, CK);
and inst22  (ENABLE_CK_AND_D, D, CK);

specify
if (CK==1'b0 && D==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0) (negedge RD => (QN -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1) (negedge RD => (QN -: 1'b1))=(0, 0);
if (CK==1'b1) (negedge RD => (QN -: 1'b1))=(0, 0);
(negedge RD => (QN : 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD , posedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD , negedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_D , posedge CK &&& ENABLE_D , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_FDPRB_V3Y2_2

  

//%BEGIN HDBSVT11_FDPRSQB_Y2_1
`celldefine
module HDBSVT11_FDPRSQB_Y2_1 (QN, CK, D, RD, SD);
  input CK, D, RD, SD;
  output QN;
  reg viol_0;
  wire int_0, iq;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_RD, RD);
    buf inst3  (delayed_SD, SD);
  `endif


    not inst4  (int_0, iq);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_sr_err inst5  (xcr_4, delayed_CK, delayed_D, delayed_SD, delayed_RD);

  `endif
    snps_dff_sr_0 inst6  (iq, viol_0, delayed_CK, delayed_D, delayed_SD, delayed_RD, xcr_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst7 (QN, int_0);
  `else
    buf inst8  (QN, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, RD);
not inst10  (_net_1, D);
not inst11  (_net_2, SD);
and inst12  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SD, _net_0, _net_1, _net_2);
not inst13  (_net_3, RD);
not inst14  (_net_4, SD);
and inst15  (ENABLE_D_AND_NOT_RD_AND_NOT_SD, _net_3, D, _net_4);
not inst16  (_net_5, SD);
not inst17  (_net_6, RD);
and inst18  (ENABLE_NOT_RD_AND_NOT_SD, _net_5, _net_6);
not inst19  (_net_7, SD);
and inst20  (ENABLE_D_AND_NOT_SD, _net_7, D);
not inst21  (_net_8, D);
not inst22  (_net_9, CK);
not inst23  (_net_10, SD);
and inst24  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SD, _net_8, _net_9, _net_10);
not inst25  (_net_11, CK);
not inst26  (_net_12, SD);
and inst27  (ENABLE_NOT_CK_AND_D_AND_NOT_SD, D, _net_11, _net_12);
not inst28  (_net_13, D);
not inst29  (_net_14, SD);
and inst30  (ENABLE_CK_AND_NOT_D_AND_NOT_SD, _net_13, CK, _net_14);
not inst31  (_net_15, SD);
and inst32  (ENABLE_CK_AND_D_AND_NOT_SD, D, CK, _net_15);
not inst33  (ENABLE_NOT_D, D);
buf inst34  (ENABLE_D, D);
not inst35  (_net_16, RD);
not inst36  (_net_17, D);
and inst37  (ENABLE_NOT_D_AND_NOT_RD, _net_16, _net_17);
not inst38  (_net_18, D);
not inst39  (_net_19, CK);
not inst40  (_net_20, RD);
and inst41  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_RD, _net_18, _net_19, _net_20);
not inst42  (_net_21, CK);
not inst43  (_net_22, RD);
and inst44  (ENABLE_NOT_CK_AND_D_AND_NOT_RD, D, _net_21, _net_22);
not inst45  (_net_23, D);
not inst46  (_net_24, RD);
and inst47  (ENABLE_CK_AND_NOT_D_AND_NOT_RD, _net_23, CK, _net_24);
not inst48  (_net_25, RD);
and inst49  (ENABLE_CK_AND_D_AND_NOT_RD, D, CK, _net_25);

specify
if (CK==1'b0 && D==1'b0 && SD==1'b0) (posedge RD => (QN +: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1) (posedge RD => (QN +: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0) (posedge RD => (QN +: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1) (posedge RD => (QN +: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0) (posedge RD => (QN +: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1) (posedge RD => (QN +: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0) (posedge RD => (QN +: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1) (posedge RD => (QN +: 1'b1))=(0, 0);
(posedge RD => (QN : 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b0) (posedge SD => (QN -: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b0) (posedge SD => (QN -: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b0) (posedge SD => (QN -: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b0) (posedge SD => (QN -: 1'b0))=(0, 0);
(posedge SD => (QN : 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SD==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SD==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_RD_AND_NOT_SD , posedge D &&& ENABLE_NOT_RD_AND_NOT_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_RD_AND_NOT_SD , negedge D &&& ENABLE_NOT_RD_AND_NOT_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(negedge RD &&& ENABLE_D_AND_NOT_SD , posedge CK &&& ENABLE_D_AND_NOT_SD , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SD , 0 ,0, viol_0);
$width(posedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SD , 0 ,0, viol_0);
$width(posedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SD , 0 ,0, viol_0);
$width(posedge RD &&& ENABLE_CK_AND_D_AND_NOT_SD , 0 ,0, viol_0);
$setuphold(negedge SD &&& ENABLE_NOT_D , negedge RD &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(negedge SD &&& ENABLE_D , negedge RD &&& ENABLE_D , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$recrem(negedge SD &&& ENABLE_NOT_D_AND_NOT_RD , posedge CK &&& ENABLE_NOT_D_AND_NOT_RD , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$setuphold(negedge RD &&& ENABLE_NOT_D , negedge SD &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(negedge RD &&& ENABLE_D , negedge SD &&& ENABLE_D , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$width(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_RD , 0 ,0, viol_0);
$width(posedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_RD , 0 ,0, viol_0);
$width(posedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_RD , 0 ,0, viol_0);
$width(posedge SD &&& ENABLE_CK_AND_D_AND_NOT_RD , 0 ,0, viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FDPRSQB_Y2_1



//%BEGIN HDBSVT11_FDPSBQJT_Y4_1

`celldefine
module HDBSVT11_FDPSBQJT_Y4_1 (Q,CK,D,SD);
  output Q;
  input CK, D, SD;

  reg viol_0;
     wire viol_x;
  wire N0__blkclkbb, N0__blkclkb, N0__blknet_019, N0__blknet_015, N0__blknet_017, N0__blknet040, N0__blknet039, N0__blkxq0, N0__blkxq1, delayed_CK, delayed_D, delayed_SD;


`ifdef _fv
  buf inst0  (delayed_CK, CK);
  buf inst1  (delayed_D, D);
  buf inst2  (delayed_SD, SD);
`endif

  not inst3   (N0__blkclkbb, N0__blkclkb);
  not inst4   (N0__blknet_019, delayed_SD);
  not inst5   (N0__blknet_015, delayed_SD);
  not inst6   (N0__blknet_017, delayed_SD);
  not inst7   (N0__blknet040, N0__blknet039);
  not inst8   (N0__blknet039, delayed_D);
  not inst9   (N0__blkclkb, delayed_CK);
  snps_latch_s inst10   (N0__blkxq0, viol_x, N0__blkclkb, N0__blknet040, N0__blknet_019);
  snps_latch_s inst11   (N0__blkxq1, viol_x, N0__blkclkbb, N0__blkxq0, N0__blknet_017);

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst12  (viol_x, viol_0, N0__blkclkb, N0__blknet_019, 1'b1);

  `endif
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst13  (viol_x, viol_0, N0__blkclkbb, N0__blknet_017, 1'b1);

  `endif
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst14  (viol_x, viol_0, N0__blkclkb, N0__blknet_015, 1'b1);

  `endif
   `ifdef VIRL_functiononly
       snps_latch_s  #`SNPS_SEQ_DELAY  inst15 (Q, viol_x, N0__blkclkb, N0__blkxq1, N0__blknet_015);
        
   `else
         snps_latch_s inst16    (Q, viol_x, N0__blkclkb, N0__blkxq1, N0__blknet_015);

   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////



not inst17  (_net_0, D);
and inst18  (ENABLE_NOT_D_AND_SD, SD, _net_0);
and inst19  (ENABLE_D_AND_SD, SD, D);
buf inst20  (ENABLE_SD, SD);
not inst21  (ENABLE_NOT_D, D);
not inst22  (_net_1, D);
not inst23  (_net_2, CK);
and inst24  (ENABLE_NOT_CK_AND_NOT_D, _net_1, _net_2);
not inst25  (_net_3, CK);
and inst26  (ENABLE_NOT_CK_AND_D, D, _net_3);
not inst27  (_net_4, D);
and inst28  (ENABLE_CK_AND_NOT_D, _net_4, CK);
and inst29  (ENABLE_CK_AND_D, D, CK);

specify
if (SD==1'b1) (negedge CK => (Q : 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_SD , posedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD , negedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge SD &&& ENABLE_NOT_D , posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
   `endif


endmodule

`endcelldefine

//%END HDBSVT11_FDPSBQJT_Y4_1



//%BEGIN HDBSVT11_FDPSBQJT_Y4_2

`celldefine
module HDBSVT11_FDPSBQJT_Y4_2 (Q,CK,D,SD);
  output Q;
  input CK, D, SD;

  reg viol_0;
     wire viol_x;
  wire N0__blkclkbb, N0__blkclkb, N0__blknet_019, N0__blknet_015, N0__blknet_017, N0__blknet040, N0__blknet039, N0__blkxq0, N0__blkxq1, delayed_CK, delayed_D, delayed_SD;


`ifdef _fv
  buf inst0  (delayed_CK, CK);
  buf inst1  (delayed_D, D);
  buf inst2  (delayed_SD, SD);
`endif

  not inst3   (N0__blkclkbb, N0__blkclkb);
  not inst4   (N0__blknet_019, delayed_SD);
  not inst5   (N0__blknet_015, delayed_SD);
  not inst6   (N0__blknet_017, delayed_SD);
  not inst7   (N0__blknet040, N0__blknet039);
  not inst8   (N0__blknet039, delayed_D);
  not inst9   (N0__blkclkb, delayed_CK);
  snps_latch_s inst10   (N0__blkxq0, viol_x, N0__blkclkb, N0__blknet040, N0__blknet_019);
  snps_latch_s inst11   (N0__blkxq1, viol_x, N0__blkclkbb, N0__blkxq0, N0__blknet_017);

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst12  (viol_x, viol_0, N0__blkclkb, N0__blknet_019, 1'b1);

  `endif
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst13  (viol_x, viol_0, N0__blkclkbb, N0__blknet_017, 1'b1);

  `endif
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst14  (viol_x, viol_0, N0__blkclkb, N0__blknet_015, 1'b1);

  `endif
   `ifdef VIRL_functiononly
       snps_latch_s  #`SNPS_SEQ_DELAY  inst15 (Q, viol_x, N0__blkclkb, N0__blkxq1, N0__blknet_015);
        
   `else
         snps_latch_s inst16    (Q, viol_x, N0__blkclkb, N0__blkxq1, N0__blknet_015);

   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////



not inst17  (_net_0, D);
and inst18  (ENABLE_NOT_D_AND_SD, SD, _net_0);
and inst19  (ENABLE_D_AND_SD, SD, D);
buf inst20  (ENABLE_SD, SD);
not inst21  (ENABLE_NOT_D, D);
not inst22  (_net_1, D);
not inst23  (_net_2, CK);
and inst24  (ENABLE_NOT_CK_AND_NOT_D, _net_1, _net_2);
not inst25  (_net_3, CK);
and inst26  (ENABLE_NOT_CK_AND_D, D, _net_3);
not inst27  (_net_4, D);
and inst28  (ENABLE_CK_AND_NOT_D, _net_4, CK);
and inst29  (ENABLE_CK_AND_D, D, CK);

specify
if (SD==1'b1) (negedge CK => (Q : 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_SD , posedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD , negedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge SD &&& ENABLE_NOT_D , posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
   `endif


endmodule

`endcelldefine

//%END HDBSVT11_FDPSBQJT_Y4_2


//%BEGIN HDBSVT11_FDPSBQ_Y2_1

`celldefine
module HDBSVT11_FDPSBQ_Y2_1 (Q, CK, D, SD);
   output Q;
   input CK, D, SD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SD;

   wire int_res__SD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SD, SD);
`endif


   not inst3  (int_res__SD, delayed_SD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_s_err inst4  (xcr_0, delayed_CK, delayed_D, int_res__SD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifdef VIRL_functiononly
      snps_dff_s #`SNPS_SEQ_DELAY  inst5 (Q, viol_0, delayed_CK, delayed_D, int_res__SD, xcr_0);

  `else
      snps_dff_s inst6  (Q, viol_0, delayed_CK, delayed_D, int_res__SD, xcr_0);

  `endif

  `ifdef VIRL_functiononly

  `else

not inst7  (_net_0, D);
and inst8  (ENABLE_NOT_D_AND_SD, SD, _net_0);
and inst9  (ENABLE_D_AND_SD, SD, D);
buf inst10  (ENABLE_SD, SD);
not inst11  (ENABLE_NOT_D, D);
not inst12  (_net_1, D);
not inst13  (_net_2, CK);
and inst14  (ENABLE_NOT_CK_AND_NOT_D, _net_1, _net_2);
not inst15  (_net_3, CK);
and inst16  (ENABLE_NOT_CK_AND_D, D, _net_3);
not inst17  (_net_4, D);
and inst18  (ENABLE_CK_AND_NOT_D, _net_4, CK);
and inst19  (ENABLE_CK_AND_D, D, CK);

specify
if (CK==1'b0 && D==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_SD , posedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD , negedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge SD &&& ENABLE_NOT_D , posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPSBQ_Y2_1

//%BEGIN HDBSVT11_FDPSBQ_Y2_2

`celldefine
module HDBSVT11_FDPSBQ_Y2_2 (Q, CK, D, SD);
   output Q;
   input CK, D, SD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SD;

   wire int_res__SD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SD, SD);
`endif


   not inst3  (int_res__SD, delayed_SD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_s_err inst4  (xcr_0, delayed_CK, delayed_D, int_res__SD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifdef VIRL_functiononly
      snps_dff_s #`SNPS_SEQ_DELAY  inst5 (Q, viol_0, delayed_CK, delayed_D, int_res__SD, xcr_0);

  `else
      snps_dff_s inst6  (Q, viol_0, delayed_CK, delayed_D, int_res__SD, xcr_0);

  `endif

  `ifdef VIRL_functiononly

  `else

not inst7  (_net_0, D);
and inst8  (ENABLE_NOT_D_AND_SD, SD, _net_0);
and inst9  (ENABLE_D_AND_SD, SD, D);
buf inst10  (ENABLE_SD, SD);
not inst11  (ENABLE_NOT_D, D);
not inst12  (_net_1, D);
not inst13  (_net_2, CK);
and inst14  (ENABLE_NOT_CK_AND_NOT_D, _net_1, _net_2);
not inst15  (_net_3, CK);
and inst16  (ENABLE_NOT_CK_AND_D, D, _net_3);
not inst17  (_net_4, D);
and inst18  (ENABLE_CK_AND_NOT_D, _net_4, CK);
and inst19  (ENABLE_CK_AND_D, D, CK);

specify
if (CK==1'b0 && D==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_SD , posedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD , negedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge SD &&& ENABLE_NOT_D , posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPSBQ_Y2_2

//%BEGIN HDBSVT11_FDPSBQ_Y2_4

`celldefine
module HDBSVT11_FDPSBQ_Y2_4 (Q, CK, D, SD);
   output Q;
   input CK, D, SD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SD;

   wire int_res__SD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SD, SD);
`endif


   not inst3  (int_res__SD, delayed_SD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_s_err inst4  (xcr_0, delayed_CK, delayed_D, int_res__SD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifdef VIRL_functiononly
      snps_dff_s #`SNPS_SEQ_DELAY  inst5 (Q, viol_0, delayed_CK, delayed_D, int_res__SD, xcr_0);

  `else
      snps_dff_s inst6  (Q, viol_0, delayed_CK, delayed_D, int_res__SD, xcr_0);

  `endif

  `ifdef VIRL_functiononly

  `else

not inst7  (_net_0, D);
and inst8  (ENABLE_NOT_D_AND_SD, SD, _net_0);
and inst9  (ENABLE_D_AND_SD, SD, D);
buf inst10  (ENABLE_SD, SD);
not inst11  (ENABLE_NOT_D, D);
not inst12  (_net_1, D);
not inst13  (_net_2, CK);
and inst14  (ENABLE_NOT_CK_AND_NOT_D, _net_1, _net_2);
not inst15  (_net_3, CK);
and inst16  (ENABLE_NOT_CK_AND_D, D, _net_3);
not inst17  (_net_4, D);
and inst18  (ENABLE_CK_AND_NOT_D, _net_4, CK);
and inst19  (ENABLE_CK_AND_D, D, CK);

specify
if (CK==1'b0 && D==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_SD , posedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD , negedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge SD &&& ENABLE_NOT_D , posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPSBQ_Y2_4

//%BEGIN HDBSVT11_FDPSQB_V2Y2_2

`celldefine
module HDBSVT11_FDPSQB_V2Y2_2 (QN, CK, D, SD);
   output QN;
   input CK, D, SD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SD;
   wire int_res__q, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SD, SD);
`endif


  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_s_err inst3  (xcr_0, delayed_CK, delayed_D, delayed_SD);

  `endif
   snps_dff_s inst4  (int_res__q, viol_0, delayed_CK, delayed_D, delayed_SD, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifdef VIRL_functiononly
      not #`SNPS_SEQ_DELAY  inst5 (QN, int_res__q);
  `else
      not inst6  (QN, int_res__q);
  `endif

  `ifdef VIRL_functiononly

  `else

not inst7  (_net_0, SD);
not inst8  (_net_1, D);
and inst9  (ENABLE_NOT_D_AND_NOT_SD, _net_0, _net_1);
not inst10  (_net_2, SD);
and inst11  (ENABLE_D_AND_NOT_SD, _net_2, D);
not inst12  (ENABLE_NOT_SD, SD);
not inst13  (ENABLE_NOT_D, D);
not inst14  (_net_3, D);
not inst15  (_net_4, CK);
and inst16  (ENABLE_NOT_CK_AND_NOT_D, _net_3, _net_4);
not inst17  (_net_5, CK);
and inst18  (ENABLE_NOT_CK_AND_D, D, _net_5);
not inst19  (_net_6, D);
and inst20  (ENABLE_CK_AND_NOT_D, _net_6, CK);
and inst21  (ENABLE_CK_AND_D, D, CK);

specify
if (CK==1'b0 && D==1'b0) (posedge SD => (QN -: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1) (posedge SD => (QN -: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0) (posedge SD => (QN -: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1) (posedge SD => (QN -: 1'b0))=(0, 0);
(posedge SD => (QN : 1'b1))=(0, 0);
if (D==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SD , posedge D &&& ENABLE_NOT_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SD , negedge D &&& ENABLE_NOT_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(negedge SD &&& ENABLE_NOT_D , posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$width(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(posedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(posedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(posedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FDPSQB_V2Y2_2

//%BEGIN HDBSVT11_FDPSYNSBQ_V2Y2_1
`celldefine
module HDBSVT11_FDPSYNSBQ_V2Y2_1 (Q, CK, D, SD);
  input CK, D, SD;
  output Q;
  reg viol_0;
  wire int_2, int_3, iq;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SD, SD);
  `endif


    not inst3  (int_2, delayed_SD);
    or inst4  (int_3, delayed_D, int_2);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst5  (xcr_6, delayed_CK, int_3);

  `endif
    snps_dff inst6  (iq, viol_0, delayed_CK, int_3, xcr_6);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst7 (Q, iq);
  `else
    buf inst8  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, SD);
not inst10  (_net_1, D);
and inst11  (ENABLE_NOT_D_AND_NOT_SD, _net_0, _net_1);
not inst12  (_net_2, D);
and inst13  (ENABLE_NOT_D_AND_SD, SD, _net_2);
not inst14  (_net_3, SD);
and inst15  (ENABLE_D_AND_NOT_SD, _net_3, D);
and inst16  (ENABLE_D_AND_SD, SD, D);
buf inst17  (ENABLE_SD, SD);
not inst18  (ENABLE_NOT_D, D);

specify
if (D==1'b0 && SD==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_SD , posedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD , negedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D , posedge SD &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
$setuphold(posedge CK &&& ENABLE_NOT_D , negedge SD &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FDPSYNSBQ_V2Y2_1

//%BEGIN HDBSVT11_FDPSYNSBQ_V2Y2_2
`celldefine
module HDBSVT11_FDPSYNSBQ_V2Y2_2 (Q, CK, D, SD);
  input CK, D, SD;
  output Q;
  reg viol_0;
  wire int_2, int_3, iq;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SD, SD);
  `endif


    not inst3  (int_2, delayed_SD);
    or inst4  (int_3, delayed_D, int_2);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst5  (xcr_6, delayed_CK, int_3);

  `endif
    snps_dff inst6  (iq, viol_0, delayed_CK, int_3, xcr_6);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst7 (Q, iq);
  `else
    buf inst8  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, SD);
not inst10  (_net_1, D);
and inst11  (ENABLE_NOT_D_AND_NOT_SD, _net_0, _net_1);
not inst12  (_net_2, D);
and inst13  (ENABLE_NOT_D_AND_SD, SD, _net_2);
not inst14  (_net_3, SD);
and inst15  (ENABLE_D_AND_NOT_SD, _net_3, D);
and inst16  (ENABLE_D_AND_SD, SD, D);
buf inst17  (ENABLE_SD, SD);
not inst18  (ENABLE_NOT_D, D);

specify
if (D==1'b0 && SD==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_SD , posedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD , negedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D , posedge SD &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
$setuphold(posedge CK &&& ENABLE_NOT_D , negedge SD &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FDPSYNSBQ_V2Y2_2

//%BEGIN HDBSVT11_FDPSYNSBQ_V2Y2_4
`celldefine
module HDBSVT11_FDPSYNSBQ_V2Y2_4 (Q, CK, D, SD);
  input CK, D, SD;
  output Q;
  reg viol_0;
  wire int_2, int_3, iq;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SD, SD);
  `endif


    not inst3  (int_2, delayed_SD);
    or inst4  (int_3, delayed_D, int_2);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst5  (xcr_6, delayed_CK, int_3);

  `endif
    snps_dff inst6  (iq, viol_0, delayed_CK, int_3, xcr_6);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst7 (Q, iq);
  `else
    buf inst8  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, SD);
not inst10  (_net_1, D);
and inst11  (ENABLE_NOT_D_AND_NOT_SD, _net_0, _net_1);
not inst12  (_net_2, D);
and inst13  (ENABLE_NOT_D_AND_SD, SD, _net_2);
not inst14  (_net_3, SD);
and inst15  (ENABLE_D_AND_NOT_SD, _net_3, D);
and inst16  (ENABLE_D_AND_SD, SD, D);
buf inst17  (ENABLE_SD, SD);
not inst18  (ENABLE_NOT_D, D);

specify
if (D==1'b0 && SD==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_SD , posedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD , negedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D , posedge SD &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
$setuphold(posedge CK &&& ENABLE_NOT_D , negedge SD &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FDPSYNSBQ_V2Y2_4

//%BEGIN HDBSVT11_FDPS_V2Y2_2

`celldefine
module HDBSVT11_FDPS_V2Y2_2 (Q, QN, CK, D, S);
   output Q, QN;
   input CK, D, S;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_S;

   wire xcr_0, int_res_iq;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_S, S);
`endif



  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_s_err inst3  (xcr_0, delayed_CK, delayed_D, delayed_S);

  `endif
   snps_dff_s inst4  (int_res_iq, viol_0, delayed_CK, delayed_D, delayed_S, xcr_0);
   
  `ifdef VIRL_functiononly
     buf #`SNPS_SEQ_DELAY  inst5 (Q, int_res_iq);
     not #`SNPS_SEQ_DELAY  inst6 (QN, int_res_iq);
  `else
     buf inst7  (Q, int_res_iq);
     not inst8  (QN, int_res_iq);
  `endif

  `ifdef VIRL_functiononly

  `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

not inst9  (_net_0, S);
not inst10  (_net_1, D);
and inst11  (ENABLE_NOT_D_AND_NOT_S, _net_0, _net_1);
not inst12  (_net_2, S);
and inst13  (ENABLE_D_AND_NOT_S, _net_2, D);
not inst14  (ENABLE_NOT_S, S);
not inst15  (ENABLE_NOT_D, D);
not inst16  (_net_3, D);
not inst17  (_net_4, CK);
and inst18  (ENABLE_NOT_CK_AND_NOT_D, _net_3, _net_4);
not inst19  (_net_5, CK);
and inst20  (ENABLE_NOT_CK_AND_D, D, _net_5);
not inst21  (_net_6, D);
and inst22  (ENABLE_CK_AND_NOT_D, _net_6, CK);
and inst23  (ENABLE_CK_AND_D, D, CK);

specify
if (CK==1'b0 && D==1'b0) (posedge S => (Q +: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1) (posedge S => (Q +: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0) (posedge S => (Q +: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1) (posedge S => (Q +: 1'b1))=(0, 0);
(posedge S => (Q : 1'b0))=(0, 0);
if (D==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0) (posedge S => (QN -: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1) (posedge S => (QN -: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0) (posedge S => (QN -: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1) (posedge S => (QN -: 1'b0))=(0, 0);
(posedge S => (QN : 1'b1))=(0, 0);
if (D==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_S , posedge D &&& ENABLE_NOT_S , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S , negedge D &&& ENABLE_NOT_S , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(negedge S &&& ENABLE_NOT_D , posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_S, delayed_CK);
$width(posedge S &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(posedge S &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(posedge S &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(posedge S &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_FDPS_V2Y2_2

 

//%BEGIN HDBSVT11_FDP_V2Y2_1

`celldefine
module HDBSVT11_FDP_V2Y2_1 (Q, QN, CK, D);
   output Q, QN;
   input CK, D;

   reg viol_0;
   wire delayed_D, delayed_CK;

   wire int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif

  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif
   snps_dff inst3  (int_res_iq, viol_0, delayed_CK, delayed_D, xcr_0);
  
`ifdef VIRL_functiononly
   buf #`SNPS_SEQ_DELAY  inst4 (Q, int_res_iq);
   not #`SNPS_SEQ_DELAY  inst5 (QN, int_res_iq);
`else
   buf inst6  (Q, int_res_iq);
   not inst7  (QN, int_res_iq);
`endif

`ifdef VIRL_functiononly

`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

not inst8  (ENABLE_NOT_D, D);
buf inst9  (ENABLE_D, D);

specify
(posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
`endif
endmodule
`endcelldefine

//%END HDBSVT11_FDP_V2Y2_1



//%BEGIN HDBSVT11_FDP_V2Y2_2

`celldefine
module HDBSVT11_FDP_V2Y2_2 (Q, QN, CK, D);
   output Q, QN;
   input CK, D;

   reg viol_0;
   wire delayed_D, delayed_CK;

   wire int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif

  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif
   snps_dff inst3  (int_res_iq, viol_0, delayed_CK, delayed_D, xcr_0);
  
`ifdef VIRL_functiononly
   buf #`SNPS_SEQ_DELAY  inst4 (Q, int_res_iq);
   not #`SNPS_SEQ_DELAY  inst5 (QN, int_res_iq);
`else
   buf inst6  (Q, int_res_iq);
   not inst7  (QN, int_res_iq);
`endif

`ifdef VIRL_functiononly

`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

not inst8  (ENABLE_NOT_D, D);
buf inst9  (ENABLE_D, D);

specify
(posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
`endif
endmodule
`endcelldefine

//%END HDBSVT11_FDP_V2Y2_2



//%BEGIN HDBSVT11_FDP_V2Y2_4

`celldefine
module HDBSVT11_FDP_V2Y2_4 (Q, QN, CK, D);
   output Q, QN;
   input CK, D;

   reg viol_0;
   wire delayed_D, delayed_CK;

   wire int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
`endif

  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst2  (xcr_0, delayed_CK, delayed_D);

  `endif
   snps_dff inst3  (int_res_iq, viol_0, delayed_CK, delayed_D, xcr_0);
  
`ifdef VIRL_functiononly
   buf #`SNPS_SEQ_DELAY  inst4 (Q, int_res_iq);
   not #`SNPS_SEQ_DELAY  inst5 (QN, int_res_iq);
`else
   buf inst6  (Q, int_res_iq);
   not inst7  (QN, int_res_iq);
`endif

`ifdef VIRL_functiononly

`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

not inst8  (ENABLE_NOT_D, D);
buf inst9  (ENABLE_D, D);

specify
(posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D , 0 ,0, viol_0);
$setuphold(posedge CK , posedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK , negedge D , 0 ,0, viol_0, , , delayed_CK, delayed_D);
endspecify
`endif
endmodule
`endcelldefine

//%END HDBSVT11_FDP_V2Y2_4



//%BEGIN HDBSVT11_FILL1

`celldefine
module HDBSVT11_FILL1 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL1

//%BEGIN HDBSVT11_FILL16

`celldefine
module HDBSVT11_FILL16 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL16

//%BEGIN HDBSVT11_FILL2

`celldefine
module HDBSVT11_FILL2 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL2

//%BEGIN HDBSVT11_FILL3

`celldefine
module HDBSVT11_FILL3 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL3

//%BEGIN HDBSVT11_FILL32

`celldefine
module HDBSVT11_FILL32 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL32

//%BEGIN HDBSVT11_FILL4

`celldefine
module HDBSVT11_FILL4 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL4

//%BEGIN HDBSVT11_FILL5

`celldefine
module HDBSVT11_FILL5 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL5

//%BEGIN HDBSVT11_FILL64

`celldefine
module HDBSVT11_FILL64 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL64

//%BEGIN HDBSVT11_FILL8

`celldefine
module HDBSVT11_FILL8 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL8

//%BEGIN HDBSVT11_FILL_BSPACERY2_5

`celldefine
module HDBSVT11_FILL_BSPACERY2_5 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_BSPACERY2_5

//%BEGIN HDBSVT11_FILL_BSPACER_5

`celldefine
module HDBSVT11_FILL_BSPACER_5 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_BSPACER_5

//%BEGIN HDBSVT11_FILL_E1_1

`celldefine
module HDBSVT11_FILL_E1_1 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_E1_1

//%BEGIN HDBSVT11_FILL_ECO1

`celldefine
module HDBSVT11_FILL_ECO1 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_ECO1

//%BEGIN HDBSVT11_FILL_ECO2

`celldefine
module HDBSVT11_FILL_ECO2 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_ECO2

//%BEGIN HDBSVT11_FILL_ECO3

`celldefine
module HDBSVT11_FILL_ECO3 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_ECO3

//%BEGIN HDBSVT11_FILL_LRSPACER_5

`celldefine
module HDBSVT11_FILL_LRSPACER_5 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_LRSPACER_5

//%BEGIN HDBSVT11_FILL_MVT_1

`celldefine
module HDBSVT11_FILL_MVT_1 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_MVT_1

//%BEGIN HDBSVT11_FILL_TSPACERY2_5

`celldefine
module HDBSVT11_FILL_TSPACERY2_5 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_TSPACERY2_5

//%BEGIN HDBSVT11_FILL_TSPACER_5

`celldefine
module HDBSVT11_FILL_TSPACER_5 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_TSPACER_5

//%BEGIN HDBSVT11_FILL_Y2ECO1

`celldefine
module HDBSVT11_FILL_Y2ECO1 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_Y2ECO1

//%BEGIN HDBSVT11_FILL_Y2ECO2

`celldefine
module HDBSVT11_FILL_Y2ECO2 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_Y2ECO2

//%BEGIN HDBSVT11_FILL_Y2ECO3

`celldefine
module HDBSVT11_FILL_Y2ECO3 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_Y2ECO3

//%BEGIN HDBSVT11_FILL_Y3ECO1

`celldefine
module HDBSVT11_FILL_Y3ECO1 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_Y3ECO1

//%BEGIN HDBSVT11_FILL_Y3ECO2

`celldefine
module HDBSVT11_FILL_Y3ECO2 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_Y3ECO2

//%BEGIN HDBSVT11_FILL_Y3ECO3

`celldefine
module HDBSVT11_FILL_Y3ECO3 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_Y3ECO3

//%BEGIN HDBSVT11_FILL_Y4ECO1

`celldefine
module HDBSVT11_FILL_Y4ECO1 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_Y4ECO1

//%BEGIN HDBSVT11_FILL_Y4ECO2

`celldefine
module HDBSVT11_FILL_Y4ECO2 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_Y4ECO2

//%BEGIN HDBSVT11_FILL_Y4ECO3

`celldefine
module HDBSVT11_FILL_Y4ECO3 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_Y4ECO3

//%BEGIN HDBSVT11_FILL_Y5ECO1

`celldefine
module HDBSVT11_FILL_Y5ECO1 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_Y5ECO1

//%BEGIN HDBSVT11_FILL_Y5ECO2

`celldefine
module HDBSVT11_FILL_Y5ECO2 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_Y5ECO2

//%BEGIN HDBSVT11_FILL_Y5ECO3

`celldefine
module HDBSVT11_FILL_Y5ECO3 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_Y5ECO3

//%BEGIN HDBSVT11_FILL_Y6ECO1

`celldefine
module HDBSVT11_FILL_Y6ECO1 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_Y6ECO1

//%BEGIN HDBSVT11_FILL_Y6ECO2

`celldefine
module HDBSVT11_FILL_Y6ECO2 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_Y6ECO2

//%BEGIN HDBSVT11_FILL_Y6ECO3

`celldefine
module HDBSVT11_FILL_Y6ECO3 ();
endmodule
`endcelldefine

//%END HDBSVT11_FILL_Y6ECO3

//%BEGIN HDBSVT11_FSDND2PQB_CBV2Y2_1

`celldefine
module HDBSVT11_FSDND2PQB_CBV2Y2_1 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_CBV2Y2_1

//%BEGIN HDBSVT11_FSDND2PQB_CBV2Y2_2

`celldefine
module HDBSVT11_FSDND2PQB_CBV2Y2_2 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_CBV2Y2_2

//%BEGIN HDBSVT11_FSDND2PQB_V1Y2_1

`celldefine
module HDBSVT11_FSDND2PQB_V1Y2_1 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_V1Y2_1

//%BEGIN HDBSVT11_FSDND2PQB_V1Y2_12

`celldefine
module HDBSVT11_FSDND2PQB_V1Y2_12 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_V1Y2_12

//%BEGIN HDBSVT11_FSDND2PQB_V1Y2_2

`celldefine
module HDBSVT11_FSDND2PQB_V1Y2_2 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_V1Y2_2

//%BEGIN HDBSVT11_FSDND2PQB_V1Y2_4

`celldefine
module HDBSVT11_FSDND2PQB_V1Y2_4 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_V1Y2_4

//%BEGIN HDBSVT11_FSDND2PQB_V1Y2_8

`celldefine
module HDBSVT11_FSDND2PQB_V1Y2_8 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_V1Y2_8

//%BEGIN HDBSVT11_FSDND2PQB_V2Y2_1

`celldefine
module HDBSVT11_FSDND2PQB_V2Y2_1 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_V2Y2_1

//%BEGIN HDBSVT11_FSDND2PQB_V2Y2_2

`celldefine
module HDBSVT11_FSDND2PQB_V2Y2_2 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_V2Y2_2

//%BEGIN HDBSVT11_FSDND2PQB_V2Y2_4

`celldefine
module HDBSVT11_FSDND2PQB_V2Y2_4 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_V2Y2_4

//%BEGIN HDBSVT11_FSDND2PQB_V2Y2_8

`celldefine
module HDBSVT11_FSDND2PQB_V2Y2_8 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_V2Y2_8

//%BEGIN HDBSVT11_FSDND2PQB_V3Y2_1

`celldefine
module HDBSVT11_FSDND2PQB_V3Y2_1 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_V3Y2_1

//%BEGIN HDBSVT11_FSDND2PQB_V3Y2_2

`celldefine
module HDBSVT11_FSDND2PQB_V3Y2_2 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_V3Y2_2

//%BEGIN HDBSVT11_FSDND2PQB_V3Y2_4

`celldefine
module HDBSVT11_FSDND2PQB_V3Y2_4 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_V3Y2_4

//%BEGIN HDBSVT11_FSDND2PQB_V3Y2_8

`celldefine
module HDBSVT11_FSDND2PQB_V3Y2_8 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_V3Y2_8

//%BEGIN HDBSVT11_FSDND2PQB_V4Y2_1

`celldefine
module HDBSVT11_FSDND2PQB_V4Y2_1 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_V4Y2_1

//%BEGIN HDBSVT11_FSDND2PQB_V4Y2_2

`celldefine
module HDBSVT11_FSDND2PQB_V4Y2_2 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_V4Y2_2

//%BEGIN HDBSVT11_FSDND2PQB_V4Y2_4

`celldefine
module HDBSVT11_FSDND2PQB_V4Y2_4 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_V4Y2_4

//%BEGIN HDBSVT11_FSDND2PQB_V4Y2_8

`celldefine
module HDBSVT11_FSDND2PQB_V4Y2_8 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_V4Y2_8

//%BEGIN HDBSVT11_FSDND2PQB_Y2_1

`celldefine
module HDBSVT11_FSDND2PQB_Y2_1 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_Y2_1

//%BEGIN HDBSVT11_FSDND2PQB_Y2_2

`celldefine
module HDBSVT11_FSDND2PQB_Y2_2 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_Y2_2

//%BEGIN HDBSVT11_FSDND2PQB_Y2_4

`celldefine
module HDBSVT11_FSDND2PQB_Y2_4 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_Y2_4

//%BEGIN HDBSVT11_FSDND2PQB_Y2_8

`celldefine
module HDBSVT11_FSDND2PQB_Y2_8 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDND2PQB_Y2_8

//%BEGIN HDBSVT11_FSDNQ_Y2_1

`celldefine
module HDBSVT11_FSDNQ_Y2_1 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__CK, int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   not inst4  (int_res__CK, delayed_CK);
   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst6  (xcr_0, int_res__CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       snps_dff #`SNPS_SEQ_DELAY  inst7 (Q, viol_0, int_res__CK, int_res__D, xcr_0);
   `else
       snps_dff inst8  (Q, viol_0, int_res__CK, int_res__D, xcr_0);
    `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNQ_Y2_1

//%BEGIN HDBSVT11_FSDNQ_Y2_2

`celldefine
module HDBSVT11_FSDNQ_Y2_2 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__CK, int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   not inst4  (int_res__CK, delayed_CK);
   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst6  (xcr_0, int_res__CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       snps_dff #`SNPS_SEQ_DELAY  inst7 (Q, viol_0, int_res__CK, int_res__D, xcr_0);
   `else
       snps_dff inst8  (Q, viol_0, int_res__CK, int_res__D, xcr_0);
    `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNQ_Y2_2

//%BEGIN HDBSVT11_FSDNQ_Y2_4

`celldefine
module HDBSVT11_FSDNQ_Y2_4 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__CK, int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   not inst4  (int_res__CK, delayed_CK);
   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst6  (xcr_0, int_res__CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       snps_dff #`SNPS_SEQ_DELAY  inst7 (Q, viol_0, int_res__CK, int_res__D, xcr_0);
   `else
       snps_dff inst8  (Q, viol_0, int_res__CK, int_res__D, xcr_0);
    `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNQ_Y2_4

//%BEGIN HDBSVT11_FSDNR2PQB_V1Y2_1

`celldefine
module HDBSVT11_FSDNR2PQB_V1Y2_1 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNR2PQB_V1Y2_1

//%BEGIN HDBSVT11_FSDNR2PQB_V1Y2_2

`celldefine
module HDBSVT11_FSDNR2PQB_V1Y2_2 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNR2PQB_V1Y2_2

//%BEGIN HDBSVT11_FSDNR2PQB_V1Y2_4

`celldefine
module HDBSVT11_FSDNR2PQB_V1Y2_4 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNR2PQB_V1Y2_4

//%BEGIN HDBSVT11_FSDNR2PQB_V1Y2_8

`celldefine
module HDBSVT11_FSDNR2PQB_V1Y2_8 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNR2PQB_V1Y2_8

//%BEGIN HDBSVT11_FSDNR2PQB_V2Y2_1

`celldefine
module HDBSVT11_FSDNR2PQB_V2Y2_1 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNR2PQB_V2Y2_1

//%BEGIN HDBSVT11_FSDNR2PQB_V2Y2_2

`celldefine
module HDBSVT11_FSDNR2PQB_V2Y2_2 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNR2PQB_V2Y2_2

//%BEGIN HDBSVT11_FSDNR2PQB_V2Y2_4

`celldefine
module HDBSVT11_FSDNR2PQB_V2Y2_4 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNR2PQB_V2Y2_4

//%BEGIN HDBSVT11_FSDNR2PQB_V2Y2_8

`celldefine
module HDBSVT11_FSDNR2PQB_V2Y2_8 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNR2PQB_V2Y2_8

//%BEGIN HDBSVT11_FSDNR2PQB_V3Y2_1

`celldefine
module HDBSVT11_FSDNR2PQB_V3Y2_1 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNR2PQB_V3Y2_1

//%BEGIN HDBSVT11_FSDNR2PQB_V3Y2_2

`celldefine
module HDBSVT11_FSDNR2PQB_V3Y2_2 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNR2PQB_V3Y2_2

//%BEGIN HDBSVT11_FSDNR2PQB_V3Y2_4

`celldefine
module HDBSVT11_FSDNR2PQB_V3Y2_4 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNR2PQB_V3Y2_4

//%BEGIN HDBSVT11_FSDNR2PQB_V3Y2_8

`celldefine
module HDBSVT11_FSDNR2PQB_V3Y2_8 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNR2PQB_V3Y2_8

//%BEGIN HDBSVT11_FSDNR2PQB_Y2_1

`celldefine
module HDBSVT11_FSDNR2PQB_Y2_1 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNR2PQB_Y2_1

//%BEGIN HDBSVT11_FSDNR2PQB_Y2_2

`celldefine
module HDBSVT11_FSDNR2PQB_Y2_2 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNR2PQB_Y2_2

//%BEGIN HDBSVT11_FSDNR2PQB_Y2_4

`celldefine
module HDBSVT11_FSDNR2PQB_Y2_4 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNR2PQB_Y2_4

//%BEGIN HDBSVT11_FSDNR2PQB_Y2_8

`celldefine
module HDBSVT11_FSDNR2PQB_Y2_8 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNR2PQB_Y2_8

//%BEGIN HDBSVT11_FSDNRBQ_V2Y2_2

`celldefine
module HDBSVT11_FSDNRBQ_V2Y2_2 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__CK, int_res__RD, int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   not inst5  (int_res__CK, delayed_CK);
   not inst6  (int_res__RD, delayed_RD);
   snps_mux2 inst7  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst8  (xcr_0, int_res__CK, int_res__D, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       snps_dff_r #`SNPS_SEQ_DELAY  inst9 (Q, viol_0, int_res__CK, int_res__D, int_res__RD, xcr_0);
   `else
       snps_dff_r inst10  (Q, viol_0, int_res__CK, int_res__D, int_res__RD, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, D);
not inst12  (_net_1, SE);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_0, _net_1, _net_2);
not inst15  (_net_3, D);
not inst16  (_net_4, SE);
and inst17  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_3, _net_4, SI);
not inst18  (_net_5, D);
not inst19  (_net_6, SI);
and inst20  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_5, SE, _net_6);
not inst21  (_net_7, D);
and inst22  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_7, SE, SI);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_8, _net_9);
not inst26  (_net_10, SE);
and inst27  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_10, SI);
not inst28  (_net_11, SI);
and inst29  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_11);
and inst30  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst31  (_net_12, SE);
not inst32  (_net_13, SI);
and inst33  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_12, RD, _net_13);
not inst34  (_net_14, SE);
and inst35  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_14, RD, SI);
not inst36  (_net_15, D);
and inst37  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_15, SI);
not inst38  (_net_16, SE);
not inst39  (_net_17, SI);
and inst40  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_16, D, _net_17);
not inst41  (_net_18, SE);
and inst42  (ENABLE_D_AND_NOT_SE_AND_SI, _net_18, D, SI);
and inst43  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst44  (_net_19, D);
not inst45  (_net_20, CK);
not inst46  (_net_21, SE);
not inst47  (_net_22, SI);
and inst48  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_19, _net_20, _net_21, _net_22);
not inst49  (_net_23, D);
not inst50  (_net_24, CK);
not inst51  (_net_25, SE);
and inst52  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_23, _net_24, _net_25, SI);
not inst53  (_net_26, D);
not inst54  (_net_27, CK);
not inst55  (_net_28, SI);
and inst56  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_26, _net_27, SE, _net_28);
not inst57  (_net_29, D);
not inst58  (_net_30, CK);
and inst59  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_29, _net_30, SE, SI);
not inst60  (_net_31, CK);
not inst61  (_net_32, SE);
not inst62  (_net_33, SI);
and inst63  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_31, _net_32, _net_33);
not inst64  (_net_34, CK);
not inst65  (_net_35, SE);
and inst66  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_34, _net_35, SI);
not inst67  (_net_36, CK);
not inst68  (_net_37, SI);
and inst69  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_36, SE, _net_37);
not inst70  (_net_38, CK);
and inst71  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_38, SE, SI);
not inst72  (_net_39, D);
not inst73  (_net_40, SE);
not inst74  (_net_41, SI);
and inst75  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_39, CK, _net_40, _net_41);
not inst76  (_net_42, D);
not inst77  (_net_43, SE);
and inst78  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_42, CK, _net_43, SI);
not inst79  (_net_44, D);
not inst80  (_net_45, SI);
and inst81  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_44, CK, SE, _net_45);
not inst82  (_net_46, D);
and inst83  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_46, CK, SE, SI);
not inst84  (_net_47, SE);
not inst85  (_net_48, SI);
and inst86  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_47, _net_48);
not inst87  (_net_49, SE);
and inst88  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_49, SI);
not inst89  (_net_50, SI);
and inst90  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_50);
and inst91  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst92  (_net_51, D);
and inst93  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_51, SI);
not inst94  (_net_52, SI);
and inst95  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_52);
not inst96  (_net_53, D);
and inst97  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_53, SE);
and inst98  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(negedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_NOT_D_AND_SE_AND_SI , negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SE_AND_SI , negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDNRBQ_V2Y2_2

//%BEGIN HDBSVT11_FSDN_V2Y2_1

`celldefine
module HDBSVT11_FSDN_V2Y2_1 (Q, QN, CK, D, SI, SE);
   output Q, QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__CK, int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   not inst4  (int_res__CK, delayed_CK);
   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst6  (xcr_0, int_res__CK, int_res__D);

  `endif
   snps_dff inst7  (int_res_iq, viol_0, int_res__CK, int_res__D, xcr_0);
`ifdef VIRL_functiononly
   buf  #`SNPS_SEQ_DELAY  inst8 (Q, int_res_iq);
   not  #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
`else
   buf inst10  (Q, int_res_iq);
   not inst11  (QN, int_res_iq);
`endif
`ifdef VIRL_functiononly
`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst12  (_net_0, SE);
not inst13  (_net_1, D);
not inst14  (_net_2, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst16  (_net_3, SE);
not inst17  (_net_4, D);
and inst18  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst19  (_net_5, D);
not inst20  (_net_6, SI);
and inst21  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst22  (_net_7, D);
and inst23  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst24  (_net_8, SE);
not inst25  (_net_9, SI);
and inst26  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst27  (_net_10, SE);
and inst28  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst29  (_net_11, SI);
and inst30  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst31  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst32  (_net_12, SI);
not inst33  (_net_13, SE);
and inst34  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst35  (_net_14, SE);
and inst36  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst37  (_net_15, D);
and inst38  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst39  (_net_16, SI);
and inst40  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst41  (_net_17, D);
and inst42  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst43  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
(negedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
`endif
endmodule
`endcelldefine

//%END HDBSVT11_FSDN_V2Y2_1

//%BEGIN HDBSVT11_FSDN_V2Y2_2

`celldefine
module HDBSVT11_FSDN_V2Y2_2 (Q, QN, CK, D, SI, SE);
   output Q, QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__CK, int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   not inst4  (int_res__CK, delayed_CK);
   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst6  (xcr_0, int_res__CK, int_res__D);

  `endif
   snps_dff inst7  (int_res_iq, viol_0, int_res__CK, int_res__D, xcr_0);
`ifdef VIRL_functiononly
   buf  #`SNPS_SEQ_DELAY  inst8 (Q, int_res_iq);
   not  #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
`else
   buf inst10  (Q, int_res_iq);
   not inst11  (QN, int_res_iq);
`endif
`ifdef VIRL_functiononly
`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst12  (_net_0, SE);
not inst13  (_net_1, D);
not inst14  (_net_2, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst16  (_net_3, SE);
not inst17  (_net_4, D);
and inst18  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst19  (_net_5, D);
not inst20  (_net_6, SI);
and inst21  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst22  (_net_7, D);
and inst23  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst24  (_net_8, SE);
not inst25  (_net_9, SI);
and inst26  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst27  (_net_10, SE);
and inst28  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst29  (_net_11, SI);
and inst30  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst31  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst32  (_net_12, SI);
not inst33  (_net_13, SE);
and inst34  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst35  (_net_14, SE);
and inst36  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst37  (_net_15, D);
and inst38  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst39  (_net_16, SI);
and inst40  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst41  (_net_17, D);
and inst42  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst43  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
(negedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
`endif
endmodule
`endcelldefine

//%END HDBSVT11_FSDN_V2Y2_2

//%BEGIN HDBSVT11_FSDN_V2Y2_4

`celldefine
module HDBSVT11_FSDN_V2Y2_4 (Q, QN, CK, D, SI, SE);
   output Q, QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__CK, int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   not inst4  (int_res__CK, delayed_CK);
   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst6  (xcr_0, int_res__CK, int_res__D);

  `endif
   snps_dff inst7  (int_res_iq, viol_0, int_res__CK, int_res__D, xcr_0);
`ifdef VIRL_functiononly
   buf  #`SNPS_SEQ_DELAY  inst8 (Q, int_res_iq);
   not  #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
`else
   buf inst10  (Q, int_res_iq);
   not inst11  (QN, int_res_iq);
`endif
`ifdef VIRL_functiononly
`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst12  (_net_0, SE);
not inst13  (_net_1, D);
not inst14  (_net_2, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst16  (_net_3, SE);
not inst17  (_net_4, D);
and inst18  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst19  (_net_5, D);
not inst20  (_net_6, SI);
and inst21  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst22  (_net_7, D);
and inst23  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst24  (_net_8, SE);
not inst25  (_net_9, SI);
and inst26  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst27  (_net_10, SE);
and inst28  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst29  (_net_11, SI);
and inst30  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst31  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst32  (_net_12, SI);
not inst33  (_net_13, SE);
and inst34  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst35  (_net_14, SE);
and inst36  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst37  (_net_15, D);
and inst38  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst39  (_net_16, SI);
and inst40  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst41  (_net_17, D);
and inst42  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst43  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (Q +: 1'b1))=(0, 0);
(negedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (QN +: 1'b1))=(0, 0);
(negedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(negedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
`endif
endmodule
`endcelldefine

//%END HDBSVT11_FSDN_V2Y2_4

//%BEGIN HDBSVT11_FSDPHBQB_V1Y2_2
`celldefine
module HDBSVT11_FSDPHBQB_V1Y2_2 (QN, CK, D, SI, SE, EN);
  input CK, D, SI, SE, EN;
  output QN;
  reg viol_0;
  wire int_0, iq, d_int, d_1;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
    buf inst4  (delayed_EN, EN);
  `endif


    not inst5  (int_0, iq);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_4, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq, viol_0, delayed_CK, d_int, xcr_4);
    snps_mux2 inst8  (d_int, delayed_SI, d_1, delayed_SE);
    snps_mux2 inst9  (d_1, delayed_D, iq, delayed_EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (QN, int_0);
  `else
    buf inst11  (QN, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst12  (_net_0, EN);
not inst13  (_net_1, D);
not inst14  (_net_2, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_0, _net_1, SE, _net_2);
not inst16  (_net_3, EN);
not inst17  (_net_4, D);
and inst18  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI, _net_3, _net_4, SE, SI);
not inst19  (_net_5, D);
not inst20  (_net_6, SE);
not inst21  (_net_7, SI);
and inst22  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, _net_5, _net_6, _net_7);
not inst23  (_net_8, D);
not inst24  (_net_9, SE);
and inst25  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI, EN, _net_8, _net_9, SI);
not inst26  (_net_10, D);
not inst27  (_net_11, SI);
and inst28  (ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI, EN, _net_10, SE, _net_11);
not inst29  (_net_12, D);
and inst30  (ENABLE_NOT_D_AND_EN_AND_SE_AND_SI, EN, _net_12, SE, SI);
not inst31  (_net_13, EN);
not inst32  (_net_14, SI);
and inst33  (ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_13, D, SE, _net_14);
not inst34  (_net_15, EN);
and inst35  (ENABLE_D_AND_NOT_EN_AND_SE_AND_SI, _net_15, D, SE, SI);
not inst36  (_net_16, SE);
not inst37  (_net_17, SI);
and inst38  (ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, D, _net_16, _net_17);
not inst39  (_net_18, SE);
and inst40  (ENABLE_D_AND_EN_AND_NOT_SE_AND_SI, EN, D, _net_18, SI);
not inst41  (_net_19, SI);
and inst42  (ENABLE_D_AND_EN_AND_SE_AND_NOT_SI, EN, D, SE, _net_19);
and inst43  (ENABLE_D_AND_EN_AND_SE_AND_SI, EN, D, SE, SI);
not inst44  (_net_20, SE);
not inst45  (_net_21, SI);
and inst46  (ENABLE_EN_AND_NOT_SE_AND_NOT_SI, _net_20, EN, _net_21);
not inst47  (_net_22, SE);
and inst48  (ENABLE_EN_AND_NOT_SE_AND_SI, _net_22, EN, SI);
not inst49  (_net_23, SE);
not inst50  (_net_24, D);
not inst51  (_net_25, SI);
and inst52  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25);
not inst53  (_net_26, SE);
not inst54  (_net_27, D);
and inst55  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_26, _net_27, SI);
not inst56  (_net_28, SE);
not inst57  (_net_29, SI);
and inst58  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_28, D, _net_29);
not inst59  (_net_30, SE);
and inst60  (ENABLE_D_AND_NOT_SE_AND_SI, _net_30, D, SI);
not inst61  (_net_31, D);
and inst62  (ENABLE_NOT_D_AND_EN_AND_SI, EN, _net_31, SI);
not inst63  (_net_32, SI);
and inst64  (ENABLE_D_AND_EN_AND_NOT_SI, EN, D, _net_32);
not inst65  (_net_33, EN);
not inst66  (_net_34, D);
and inst67  (ENABLE_NOT_D_AND_NOT_EN_AND_SE, _net_33, _net_34, SE);
not inst68  (_net_35, D);
and inst69  (ENABLE_NOT_D_AND_EN_AND_SE, EN, _net_35, SE);
not inst70  (_net_36, EN);
and inst71  (ENABLE_D_AND_NOT_EN_AND_SE, _net_36, D, SE);
and inst72  (ENABLE_D_AND_EN_AND_SE, EN, D, SE);

specify
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , posedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , negedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPHBQB_V1Y2_2

//%BEGIN HDBSVT11_FSDPHBQB_V1Y2_4
`celldefine
module HDBSVT11_FSDPHBQB_V1Y2_4 (QN, CK, D, SI, SE, EN);
  input CK, D, SI, SE, EN;
  output QN;
  reg viol_0;
  wire int_0, iq, d_int, d_1;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
    buf inst4  (delayed_EN, EN);
  `endif


    not inst5  (int_0, iq);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_4, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq, viol_0, delayed_CK, d_int, xcr_4);
    snps_mux2 inst8  (d_int, delayed_SI, d_1, delayed_SE);
    snps_mux2 inst9  (d_1, delayed_D, iq, delayed_EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (QN, int_0);
  `else
    buf inst11  (QN, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst12  (_net_0, EN);
not inst13  (_net_1, D);
not inst14  (_net_2, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_0, _net_1, SE, _net_2);
not inst16  (_net_3, EN);
not inst17  (_net_4, D);
and inst18  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI, _net_3, _net_4, SE, SI);
not inst19  (_net_5, D);
not inst20  (_net_6, SE);
not inst21  (_net_7, SI);
and inst22  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, _net_5, _net_6, _net_7);
not inst23  (_net_8, D);
not inst24  (_net_9, SE);
and inst25  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI, EN, _net_8, _net_9, SI);
not inst26  (_net_10, D);
not inst27  (_net_11, SI);
and inst28  (ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI, EN, _net_10, SE, _net_11);
not inst29  (_net_12, D);
and inst30  (ENABLE_NOT_D_AND_EN_AND_SE_AND_SI, EN, _net_12, SE, SI);
not inst31  (_net_13, EN);
not inst32  (_net_14, SI);
and inst33  (ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_13, D, SE, _net_14);
not inst34  (_net_15, EN);
and inst35  (ENABLE_D_AND_NOT_EN_AND_SE_AND_SI, _net_15, D, SE, SI);
not inst36  (_net_16, SE);
not inst37  (_net_17, SI);
and inst38  (ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, D, _net_16, _net_17);
not inst39  (_net_18, SE);
and inst40  (ENABLE_D_AND_EN_AND_NOT_SE_AND_SI, EN, D, _net_18, SI);
not inst41  (_net_19, SI);
and inst42  (ENABLE_D_AND_EN_AND_SE_AND_NOT_SI, EN, D, SE, _net_19);
and inst43  (ENABLE_D_AND_EN_AND_SE_AND_SI, EN, D, SE, SI);
not inst44  (_net_20, SE);
not inst45  (_net_21, SI);
and inst46  (ENABLE_EN_AND_NOT_SE_AND_NOT_SI, _net_20, EN, _net_21);
not inst47  (_net_22, SE);
and inst48  (ENABLE_EN_AND_NOT_SE_AND_SI, _net_22, EN, SI);
not inst49  (_net_23, SE);
not inst50  (_net_24, D);
not inst51  (_net_25, SI);
and inst52  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25);
not inst53  (_net_26, SE);
not inst54  (_net_27, D);
and inst55  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_26, _net_27, SI);
not inst56  (_net_28, SE);
not inst57  (_net_29, SI);
and inst58  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_28, D, _net_29);
not inst59  (_net_30, SE);
and inst60  (ENABLE_D_AND_NOT_SE_AND_SI, _net_30, D, SI);
not inst61  (_net_31, D);
and inst62  (ENABLE_NOT_D_AND_EN_AND_SI, EN, _net_31, SI);
not inst63  (_net_32, SI);
and inst64  (ENABLE_D_AND_EN_AND_NOT_SI, EN, D, _net_32);
not inst65  (_net_33, EN);
not inst66  (_net_34, D);
and inst67  (ENABLE_NOT_D_AND_NOT_EN_AND_SE, _net_33, _net_34, SE);
not inst68  (_net_35, D);
and inst69  (ENABLE_NOT_D_AND_EN_AND_SE, EN, _net_35, SE);
not inst70  (_net_36, EN);
and inst71  (ENABLE_D_AND_NOT_EN_AND_SE, _net_36, D, SE);
and inst72  (ENABLE_D_AND_EN_AND_SE, EN, D, SE);

specify
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , posedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , negedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPHBQB_V1Y2_4

//%BEGIN HDBSVT11_FSDPHBQB_V1Y2_8
`celldefine
module HDBSVT11_FSDPHBQB_V1Y2_8 (QN, CK, D, SI, SE, EN);
  input CK, D, SI, SE, EN;
  output QN;
  reg viol_0;
  wire int_0, iq, d_int, d_1;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
    buf inst4  (delayed_EN, EN);
  `endif


    not inst5  (int_0, iq);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_4, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq, viol_0, delayed_CK, d_int, xcr_4);
    snps_mux2 inst8  (d_int, delayed_SI, d_1, delayed_SE);
    snps_mux2 inst9  (d_1, delayed_D, iq, delayed_EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (QN, int_0);
  `else
    buf inst11  (QN, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst12  (_net_0, EN);
not inst13  (_net_1, D);
not inst14  (_net_2, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_0, _net_1, SE, _net_2);
not inst16  (_net_3, EN);
not inst17  (_net_4, D);
and inst18  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI, _net_3, _net_4, SE, SI);
not inst19  (_net_5, D);
not inst20  (_net_6, SE);
not inst21  (_net_7, SI);
and inst22  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, _net_5, _net_6, _net_7);
not inst23  (_net_8, D);
not inst24  (_net_9, SE);
and inst25  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI, EN, _net_8, _net_9, SI);
not inst26  (_net_10, D);
not inst27  (_net_11, SI);
and inst28  (ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI, EN, _net_10, SE, _net_11);
not inst29  (_net_12, D);
and inst30  (ENABLE_NOT_D_AND_EN_AND_SE_AND_SI, EN, _net_12, SE, SI);
not inst31  (_net_13, EN);
not inst32  (_net_14, SI);
and inst33  (ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_13, D, SE, _net_14);
not inst34  (_net_15, EN);
and inst35  (ENABLE_D_AND_NOT_EN_AND_SE_AND_SI, _net_15, D, SE, SI);
not inst36  (_net_16, SE);
not inst37  (_net_17, SI);
and inst38  (ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, D, _net_16, _net_17);
not inst39  (_net_18, SE);
and inst40  (ENABLE_D_AND_EN_AND_NOT_SE_AND_SI, EN, D, _net_18, SI);
not inst41  (_net_19, SI);
and inst42  (ENABLE_D_AND_EN_AND_SE_AND_NOT_SI, EN, D, SE, _net_19);
and inst43  (ENABLE_D_AND_EN_AND_SE_AND_SI, EN, D, SE, SI);
not inst44  (_net_20, SE);
not inst45  (_net_21, SI);
and inst46  (ENABLE_EN_AND_NOT_SE_AND_NOT_SI, _net_20, EN, _net_21);
not inst47  (_net_22, SE);
and inst48  (ENABLE_EN_AND_NOT_SE_AND_SI, _net_22, EN, SI);
not inst49  (_net_23, SE);
not inst50  (_net_24, D);
not inst51  (_net_25, SI);
and inst52  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25);
not inst53  (_net_26, SE);
not inst54  (_net_27, D);
and inst55  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_26, _net_27, SI);
not inst56  (_net_28, SE);
not inst57  (_net_29, SI);
and inst58  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_28, D, _net_29);
not inst59  (_net_30, SE);
and inst60  (ENABLE_D_AND_NOT_SE_AND_SI, _net_30, D, SI);
not inst61  (_net_31, D);
and inst62  (ENABLE_NOT_D_AND_EN_AND_SI, EN, _net_31, SI);
not inst63  (_net_32, SI);
and inst64  (ENABLE_D_AND_EN_AND_NOT_SI, EN, D, _net_32);
not inst65  (_net_33, EN);
not inst66  (_net_34, D);
and inst67  (ENABLE_NOT_D_AND_NOT_EN_AND_SE, _net_33, _net_34, SE);
not inst68  (_net_35, D);
and inst69  (ENABLE_NOT_D_AND_EN_AND_SE, EN, _net_35, SE);
not inst70  (_net_36, EN);
and inst71  (ENABLE_D_AND_NOT_EN_AND_SE, _net_36, D, SE);
and inst72  (ENABLE_D_AND_EN_AND_SE, EN, D, SE);

specify
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , posedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , negedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPHBQB_V1Y2_8

//%BEGIN HDBSVT11_FSDPHBQB_V2Y2_2
`celldefine
module HDBSVT11_FSDPHBQB_V2Y2_2 (QN, CK, D, SI, SE, EN);
  input CK, D, SI, SE, EN;
  output QN;
  reg viol_0;
  wire int_0, iq, d_int, d_1;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
    buf inst4  (delayed_EN, EN);
  `endif


    not inst5  (int_0, iq);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_4, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq, viol_0, delayed_CK, d_int, xcr_4);
    snps_mux2 inst8  (d_int, delayed_SI, d_1, delayed_SE);
    snps_mux2 inst9  (d_1, delayed_D, iq, delayed_EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (QN, int_0);
  `else
    buf inst11  (QN, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst12  (_net_0, EN);
not inst13  (_net_1, D);
not inst14  (_net_2, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_0, _net_1, SE, _net_2);
not inst16  (_net_3, EN);
not inst17  (_net_4, D);
and inst18  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI, _net_3, _net_4, SE, SI);
not inst19  (_net_5, D);
not inst20  (_net_6, SE);
not inst21  (_net_7, SI);
and inst22  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, _net_5, _net_6, _net_7);
not inst23  (_net_8, D);
not inst24  (_net_9, SE);
and inst25  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI, EN, _net_8, _net_9, SI);
not inst26  (_net_10, D);
not inst27  (_net_11, SI);
and inst28  (ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI, EN, _net_10, SE, _net_11);
not inst29  (_net_12, D);
and inst30  (ENABLE_NOT_D_AND_EN_AND_SE_AND_SI, EN, _net_12, SE, SI);
not inst31  (_net_13, EN);
not inst32  (_net_14, SI);
and inst33  (ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_13, D, SE, _net_14);
not inst34  (_net_15, EN);
and inst35  (ENABLE_D_AND_NOT_EN_AND_SE_AND_SI, _net_15, D, SE, SI);
not inst36  (_net_16, SE);
not inst37  (_net_17, SI);
and inst38  (ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, D, _net_16, _net_17);
not inst39  (_net_18, SE);
and inst40  (ENABLE_D_AND_EN_AND_NOT_SE_AND_SI, EN, D, _net_18, SI);
not inst41  (_net_19, SI);
and inst42  (ENABLE_D_AND_EN_AND_SE_AND_NOT_SI, EN, D, SE, _net_19);
and inst43  (ENABLE_D_AND_EN_AND_SE_AND_SI, EN, D, SE, SI);
not inst44  (_net_20, SE);
not inst45  (_net_21, SI);
and inst46  (ENABLE_EN_AND_NOT_SE_AND_NOT_SI, _net_20, EN, _net_21);
not inst47  (_net_22, SE);
and inst48  (ENABLE_EN_AND_NOT_SE_AND_SI, _net_22, EN, SI);
not inst49  (_net_23, SE);
not inst50  (_net_24, D);
not inst51  (_net_25, SI);
and inst52  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25);
not inst53  (_net_26, SE);
not inst54  (_net_27, D);
and inst55  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_26, _net_27, SI);
not inst56  (_net_28, SE);
not inst57  (_net_29, SI);
and inst58  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_28, D, _net_29);
not inst59  (_net_30, SE);
and inst60  (ENABLE_D_AND_NOT_SE_AND_SI, _net_30, D, SI);
not inst61  (_net_31, D);
and inst62  (ENABLE_NOT_D_AND_EN_AND_SI, EN, _net_31, SI);
not inst63  (_net_32, SI);
and inst64  (ENABLE_D_AND_EN_AND_NOT_SI, EN, D, _net_32);
not inst65  (_net_33, EN);
not inst66  (_net_34, D);
and inst67  (ENABLE_NOT_D_AND_NOT_EN_AND_SE, _net_33, _net_34, SE);
not inst68  (_net_35, D);
and inst69  (ENABLE_NOT_D_AND_EN_AND_SE, EN, _net_35, SE);
not inst70  (_net_36, EN);
and inst71  (ENABLE_D_AND_NOT_EN_AND_SE, _net_36, D, SE);
and inst72  (ENABLE_D_AND_EN_AND_SE, EN, D, SE);

specify
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , posedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , negedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPHBQB_V2Y2_2

//%BEGIN HDBSVT11_FSDPHBQB_V2Y2_4
`celldefine
module HDBSVT11_FSDPHBQB_V2Y2_4 (QN, CK, D, SI, SE, EN);
  input CK, D, SI, SE, EN;
  output QN;
  reg viol_0;
  wire int_0, iq, d_int, d_1;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
    buf inst4  (delayed_EN, EN);
  `endif


    not inst5  (int_0, iq);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_4, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq, viol_0, delayed_CK, d_int, xcr_4);
    snps_mux2 inst8  (d_int, delayed_SI, d_1, delayed_SE);
    snps_mux2 inst9  (d_1, delayed_D, iq, delayed_EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (QN, int_0);
  `else
    buf inst11  (QN, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst12  (_net_0, EN);
not inst13  (_net_1, D);
not inst14  (_net_2, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_0, _net_1, SE, _net_2);
not inst16  (_net_3, EN);
not inst17  (_net_4, D);
and inst18  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI, _net_3, _net_4, SE, SI);
not inst19  (_net_5, D);
not inst20  (_net_6, SE);
not inst21  (_net_7, SI);
and inst22  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, _net_5, _net_6, _net_7);
not inst23  (_net_8, D);
not inst24  (_net_9, SE);
and inst25  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI, EN, _net_8, _net_9, SI);
not inst26  (_net_10, D);
not inst27  (_net_11, SI);
and inst28  (ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI, EN, _net_10, SE, _net_11);
not inst29  (_net_12, D);
and inst30  (ENABLE_NOT_D_AND_EN_AND_SE_AND_SI, EN, _net_12, SE, SI);
not inst31  (_net_13, EN);
not inst32  (_net_14, SI);
and inst33  (ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_13, D, SE, _net_14);
not inst34  (_net_15, EN);
and inst35  (ENABLE_D_AND_NOT_EN_AND_SE_AND_SI, _net_15, D, SE, SI);
not inst36  (_net_16, SE);
not inst37  (_net_17, SI);
and inst38  (ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, D, _net_16, _net_17);
not inst39  (_net_18, SE);
and inst40  (ENABLE_D_AND_EN_AND_NOT_SE_AND_SI, EN, D, _net_18, SI);
not inst41  (_net_19, SI);
and inst42  (ENABLE_D_AND_EN_AND_SE_AND_NOT_SI, EN, D, SE, _net_19);
and inst43  (ENABLE_D_AND_EN_AND_SE_AND_SI, EN, D, SE, SI);
not inst44  (_net_20, SE);
not inst45  (_net_21, SI);
and inst46  (ENABLE_EN_AND_NOT_SE_AND_NOT_SI, _net_20, EN, _net_21);
not inst47  (_net_22, SE);
and inst48  (ENABLE_EN_AND_NOT_SE_AND_SI, _net_22, EN, SI);
not inst49  (_net_23, SE);
not inst50  (_net_24, D);
not inst51  (_net_25, SI);
and inst52  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25);
not inst53  (_net_26, SE);
not inst54  (_net_27, D);
and inst55  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_26, _net_27, SI);
not inst56  (_net_28, SE);
not inst57  (_net_29, SI);
and inst58  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_28, D, _net_29);
not inst59  (_net_30, SE);
and inst60  (ENABLE_D_AND_NOT_SE_AND_SI, _net_30, D, SI);
not inst61  (_net_31, D);
and inst62  (ENABLE_NOT_D_AND_EN_AND_SI, EN, _net_31, SI);
not inst63  (_net_32, SI);
and inst64  (ENABLE_D_AND_EN_AND_NOT_SI, EN, D, _net_32);
not inst65  (_net_33, EN);
not inst66  (_net_34, D);
and inst67  (ENABLE_NOT_D_AND_NOT_EN_AND_SE, _net_33, _net_34, SE);
not inst68  (_net_35, D);
and inst69  (ENABLE_NOT_D_AND_EN_AND_SE, EN, _net_35, SE);
not inst70  (_net_36, EN);
and inst71  (ENABLE_D_AND_NOT_EN_AND_SE, _net_36, D, SE);
and inst72  (ENABLE_D_AND_EN_AND_SE, EN, D, SE);

specify
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , posedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , negedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPHBQB_V2Y2_4

//%BEGIN HDBSVT11_FSDPHBQB_V2Y2_8
`celldefine
module HDBSVT11_FSDPHBQB_V2Y2_8 (QN, CK, D, SI, SE, EN);
  input CK, D, SI, SE, EN;
  output QN;
  reg viol_0;
  wire int_0, iq, d_int, d_1;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
    buf inst4  (delayed_EN, EN);
  `endif


    not inst5  (int_0, iq);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_4, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq, viol_0, delayed_CK, d_int, xcr_4);
    snps_mux2 inst8  (d_int, delayed_SI, d_1, delayed_SE);
    snps_mux2 inst9  (d_1, delayed_D, iq, delayed_EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (QN, int_0);
  `else
    buf inst11  (QN, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst12  (_net_0, EN);
not inst13  (_net_1, D);
not inst14  (_net_2, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_0, _net_1, SE, _net_2);
not inst16  (_net_3, EN);
not inst17  (_net_4, D);
and inst18  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI, _net_3, _net_4, SE, SI);
not inst19  (_net_5, D);
not inst20  (_net_6, SE);
not inst21  (_net_7, SI);
and inst22  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, _net_5, _net_6, _net_7);
not inst23  (_net_8, D);
not inst24  (_net_9, SE);
and inst25  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI, EN, _net_8, _net_9, SI);
not inst26  (_net_10, D);
not inst27  (_net_11, SI);
and inst28  (ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI, EN, _net_10, SE, _net_11);
not inst29  (_net_12, D);
and inst30  (ENABLE_NOT_D_AND_EN_AND_SE_AND_SI, EN, _net_12, SE, SI);
not inst31  (_net_13, EN);
not inst32  (_net_14, SI);
and inst33  (ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_13, D, SE, _net_14);
not inst34  (_net_15, EN);
and inst35  (ENABLE_D_AND_NOT_EN_AND_SE_AND_SI, _net_15, D, SE, SI);
not inst36  (_net_16, SE);
not inst37  (_net_17, SI);
and inst38  (ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, D, _net_16, _net_17);
not inst39  (_net_18, SE);
and inst40  (ENABLE_D_AND_EN_AND_NOT_SE_AND_SI, EN, D, _net_18, SI);
not inst41  (_net_19, SI);
and inst42  (ENABLE_D_AND_EN_AND_SE_AND_NOT_SI, EN, D, SE, _net_19);
and inst43  (ENABLE_D_AND_EN_AND_SE_AND_SI, EN, D, SE, SI);
not inst44  (_net_20, SE);
not inst45  (_net_21, SI);
and inst46  (ENABLE_EN_AND_NOT_SE_AND_NOT_SI, _net_20, EN, _net_21);
not inst47  (_net_22, SE);
and inst48  (ENABLE_EN_AND_NOT_SE_AND_SI, _net_22, EN, SI);
not inst49  (_net_23, SE);
not inst50  (_net_24, D);
not inst51  (_net_25, SI);
and inst52  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25);
not inst53  (_net_26, SE);
not inst54  (_net_27, D);
and inst55  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_26, _net_27, SI);
not inst56  (_net_28, SE);
not inst57  (_net_29, SI);
and inst58  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_28, D, _net_29);
not inst59  (_net_30, SE);
and inst60  (ENABLE_D_AND_NOT_SE_AND_SI, _net_30, D, SI);
not inst61  (_net_31, D);
and inst62  (ENABLE_NOT_D_AND_EN_AND_SI, EN, _net_31, SI);
not inst63  (_net_32, SI);
and inst64  (ENABLE_D_AND_EN_AND_NOT_SI, EN, D, _net_32);
not inst65  (_net_33, EN);
not inst66  (_net_34, D);
and inst67  (ENABLE_NOT_D_AND_NOT_EN_AND_SE, _net_33, _net_34, SE);
not inst68  (_net_35, D);
and inst69  (ENABLE_NOT_D_AND_EN_AND_SE, EN, _net_35, SE);
not inst70  (_net_36, EN);
and inst71  (ENABLE_D_AND_NOT_EN_AND_SE, _net_36, D, SE);
and inst72  (ENABLE_D_AND_EN_AND_SE, EN, D, SE);

specify
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , posedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , negedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPHBQB_V2Y2_8

//%BEGIN HDBSVT11_FSDPHBQB_V3Y2_2
`celldefine
module HDBSVT11_FSDPHBQB_V3Y2_2 (QN, CK, D, SI, SE, EN);
  input CK, D, SI, SE, EN;
  output QN;
  reg viol_0;
  wire int_0, iq, d_int, d_1;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
    buf inst4  (delayed_EN, EN);
  `endif


    not inst5  (int_0, iq);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_4, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq, viol_0, delayed_CK, d_int, xcr_4);
    snps_mux2 inst8  (d_int, delayed_SI, d_1, delayed_SE);
    snps_mux2 inst9  (d_1, delayed_D, iq, delayed_EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (QN, int_0);
  `else
    buf inst11  (QN, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst12  (_net_0, EN);
not inst13  (_net_1, D);
not inst14  (_net_2, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_0, _net_1, SE, _net_2);
not inst16  (_net_3, EN);
not inst17  (_net_4, D);
and inst18  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI, _net_3, _net_4, SE, SI);
not inst19  (_net_5, D);
not inst20  (_net_6, SE);
not inst21  (_net_7, SI);
and inst22  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, _net_5, _net_6, _net_7);
not inst23  (_net_8, D);
not inst24  (_net_9, SE);
and inst25  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI, EN, _net_8, _net_9, SI);
not inst26  (_net_10, D);
not inst27  (_net_11, SI);
and inst28  (ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI, EN, _net_10, SE, _net_11);
not inst29  (_net_12, D);
and inst30  (ENABLE_NOT_D_AND_EN_AND_SE_AND_SI, EN, _net_12, SE, SI);
not inst31  (_net_13, EN);
not inst32  (_net_14, SI);
and inst33  (ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_13, D, SE, _net_14);
not inst34  (_net_15, EN);
and inst35  (ENABLE_D_AND_NOT_EN_AND_SE_AND_SI, _net_15, D, SE, SI);
not inst36  (_net_16, SE);
not inst37  (_net_17, SI);
and inst38  (ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, D, _net_16, _net_17);
not inst39  (_net_18, SE);
and inst40  (ENABLE_D_AND_EN_AND_NOT_SE_AND_SI, EN, D, _net_18, SI);
not inst41  (_net_19, SI);
and inst42  (ENABLE_D_AND_EN_AND_SE_AND_NOT_SI, EN, D, SE, _net_19);
and inst43  (ENABLE_D_AND_EN_AND_SE_AND_SI, EN, D, SE, SI);
not inst44  (_net_20, SE);
not inst45  (_net_21, SI);
and inst46  (ENABLE_EN_AND_NOT_SE_AND_NOT_SI, _net_20, EN, _net_21);
not inst47  (_net_22, SE);
and inst48  (ENABLE_EN_AND_NOT_SE_AND_SI, _net_22, EN, SI);
not inst49  (_net_23, SE);
not inst50  (_net_24, D);
not inst51  (_net_25, SI);
and inst52  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25);
not inst53  (_net_26, SE);
not inst54  (_net_27, D);
and inst55  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_26, _net_27, SI);
not inst56  (_net_28, SE);
not inst57  (_net_29, SI);
and inst58  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_28, D, _net_29);
not inst59  (_net_30, SE);
and inst60  (ENABLE_D_AND_NOT_SE_AND_SI, _net_30, D, SI);
not inst61  (_net_31, D);
and inst62  (ENABLE_NOT_D_AND_EN_AND_SI, EN, _net_31, SI);
not inst63  (_net_32, SI);
and inst64  (ENABLE_D_AND_EN_AND_NOT_SI, EN, D, _net_32);
not inst65  (_net_33, EN);
not inst66  (_net_34, D);
and inst67  (ENABLE_NOT_D_AND_NOT_EN_AND_SE, _net_33, _net_34, SE);
not inst68  (_net_35, D);
and inst69  (ENABLE_NOT_D_AND_EN_AND_SE, EN, _net_35, SE);
not inst70  (_net_36, EN);
and inst71  (ENABLE_D_AND_NOT_EN_AND_SE, _net_36, D, SE);
and inst72  (ENABLE_D_AND_EN_AND_SE, EN, D, SE);

specify
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , posedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , negedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPHBQB_V3Y2_2

//%BEGIN HDBSVT11_FSDPHBQB_V3Y2_4
`celldefine
module HDBSVT11_FSDPHBQB_V3Y2_4 (QN, CK, D, SI, SE, EN);
  input CK, D, SI, SE, EN;
  output QN;
  reg viol_0;
  wire int_0, iq, d_int, d_1;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
    buf inst4  (delayed_EN, EN);
  `endif


    not inst5  (int_0, iq);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_4, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq, viol_0, delayed_CK, d_int, xcr_4);
    snps_mux2 inst8  (d_int, delayed_SI, d_1, delayed_SE);
    snps_mux2 inst9  (d_1, delayed_D, iq, delayed_EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (QN, int_0);
  `else
    buf inst11  (QN, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst12  (_net_0, EN);
not inst13  (_net_1, D);
not inst14  (_net_2, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_0, _net_1, SE, _net_2);
not inst16  (_net_3, EN);
not inst17  (_net_4, D);
and inst18  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI, _net_3, _net_4, SE, SI);
not inst19  (_net_5, D);
not inst20  (_net_6, SE);
not inst21  (_net_7, SI);
and inst22  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, _net_5, _net_6, _net_7);
not inst23  (_net_8, D);
not inst24  (_net_9, SE);
and inst25  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI, EN, _net_8, _net_9, SI);
not inst26  (_net_10, D);
not inst27  (_net_11, SI);
and inst28  (ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI, EN, _net_10, SE, _net_11);
not inst29  (_net_12, D);
and inst30  (ENABLE_NOT_D_AND_EN_AND_SE_AND_SI, EN, _net_12, SE, SI);
not inst31  (_net_13, EN);
not inst32  (_net_14, SI);
and inst33  (ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_13, D, SE, _net_14);
not inst34  (_net_15, EN);
and inst35  (ENABLE_D_AND_NOT_EN_AND_SE_AND_SI, _net_15, D, SE, SI);
not inst36  (_net_16, SE);
not inst37  (_net_17, SI);
and inst38  (ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, D, _net_16, _net_17);
not inst39  (_net_18, SE);
and inst40  (ENABLE_D_AND_EN_AND_NOT_SE_AND_SI, EN, D, _net_18, SI);
not inst41  (_net_19, SI);
and inst42  (ENABLE_D_AND_EN_AND_SE_AND_NOT_SI, EN, D, SE, _net_19);
and inst43  (ENABLE_D_AND_EN_AND_SE_AND_SI, EN, D, SE, SI);
not inst44  (_net_20, SE);
not inst45  (_net_21, SI);
and inst46  (ENABLE_EN_AND_NOT_SE_AND_NOT_SI, _net_20, EN, _net_21);
not inst47  (_net_22, SE);
and inst48  (ENABLE_EN_AND_NOT_SE_AND_SI, _net_22, EN, SI);
not inst49  (_net_23, SE);
not inst50  (_net_24, D);
not inst51  (_net_25, SI);
and inst52  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25);
not inst53  (_net_26, SE);
not inst54  (_net_27, D);
and inst55  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_26, _net_27, SI);
not inst56  (_net_28, SE);
not inst57  (_net_29, SI);
and inst58  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_28, D, _net_29);
not inst59  (_net_30, SE);
and inst60  (ENABLE_D_AND_NOT_SE_AND_SI, _net_30, D, SI);
not inst61  (_net_31, D);
and inst62  (ENABLE_NOT_D_AND_EN_AND_SI, EN, _net_31, SI);
not inst63  (_net_32, SI);
and inst64  (ENABLE_D_AND_EN_AND_NOT_SI, EN, D, _net_32);
not inst65  (_net_33, EN);
not inst66  (_net_34, D);
and inst67  (ENABLE_NOT_D_AND_NOT_EN_AND_SE, _net_33, _net_34, SE);
not inst68  (_net_35, D);
and inst69  (ENABLE_NOT_D_AND_EN_AND_SE, EN, _net_35, SE);
not inst70  (_net_36, EN);
and inst71  (ENABLE_D_AND_NOT_EN_AND_SE, _net_36, D, SE);
and inst72  (ENABLE_D_AND_EN_AND_SE, EN, D, SE);

specify
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , posedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , negedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPHBQB_V3Y2_4

//%BEGIN HDBSVT11_FSDPHBQB_V3Y2_8
`celldefine
module HDBSVT11_FSDPHBQB_V3Y2_8 (QN, CK, D, SI, SE, EN);
  input CK, D, SI, SE, EN;
  output QN;
  reg viol_0;
  wire int_0, iq, d_int, d_1;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
    buf inst4  (delayed_EN, EN);
  `endif


    not inst5  (int_0, iq);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_4, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq, viol_0, delayed_CK, d_int, xcr_4);
    snps_mux2 inst8  (d_int, delayed_SI, d_1, delayed_SE);
    snps_mux2 inst9  (d_1, delayed_D, iq, delayed_EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (QN, int_0);
  `else
    buf inst11  (QN, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst12  (_net_0, EN);
not inst13  (_net_1, D);
not inst14  (_net_2, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_0, _net_1, SE, _net_2);
not inst16  (_net_3, EN);
not inst17  (_net_4, D);
and inst18  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI, _net_3, _net_4, SE, SI);
not inst19  (_net_5, D);
not inst20  (_net_6, SE);
not inst21  (_net_7, SI);
and inst22  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, _net_5, _net_6, _net_7);
not inst23  (_net_8, D);
not inst24  (_net_9, SE);
and inst25  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI, EN, _net_8, _net_9, SI);
not inst26  (_net_10, D);
not inst27  (_net_11, SI);
and inst28  (ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI, EN, _net_10, SE, _net_11);
not inst29  (_net_12, D);
and inst30  (ENABLE_NOT_D_AND_EN_AND_SE_AND_SI, EN, _net_12, SE, SI);
not inst31  (_net_13, EN);
not inst32  (_net_14, SI);
and inst33  (ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_13, D, SE, _net_14);
not inst34  (_net_15, EN);
and inst35  (ENABLE_D_AND_NOT_EN_AND_SE_AND_SI, _net_15, D, SE, SI);
not inst36  (_net_16, SE);
not inst37  (_net_17, SI);
and inst38  (ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, D, _net_16, _net_17);
not inst39  (_net_18, SE);
and inst40  (ENABLE_D_AND_EN_AND_NOT_SE_AND_SI, EN, D, _net_18, SI);
not inst41  (_net_19, SI);
and inst42  (ENABLE_D_AND_EN_AND_SE_AND_NOT_SI, EN, D, SE, _net_19);
and inst43  (ENABLE_D_AND_EN_AND_SE_AND_SI, EN, D, SE, SI);
not inst44  (_net_20, SE);
not inst45  (_net_21, SI);
and inst46  (ENABLE_EN_AND_NOT_SE_AND_NOT_SI, _net_20, EN, _net_21);
not inst47  (_net_22, SE);
and inst48  (ENABLE_EN_AND_NOT_SE_AND_SI, _net_22, EN, SI);
not inst49  (_net_23, SE);
not inst50  (_net_24, D);
not inst51  (_net_25, SI);
and inst52  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25);
not inst53  (_net_26, SE);
not inst54  (_net_27, D);
and inst55  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_26, _net_27, SI);
not inst56  (_net_28, SE);
not inst57  (_net_29, SI);
and inst58  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_28, D, _net_29);
not inst59  (_net_30, SE);
and inst60  (ENABLE_D_AND_NOT_SE_AND_SI, _net_30, D, SI);
not inst61  (_net_31, D);
and inst62  (ENABLE_NOT_D_AND_EN_AND_SI, EN, _net_31, SI);
not inst63  (_net_32, SI);
and inst64  (ENABLE_D_AND_EN_AND_NOT_SI, EN, D, _net_32);
not inst65  (_net_33, EN);
not inst66  (_net_34, D);
and inst67  (ENABLE_NOT_D_AND_NOT_EN_AND_SE, _net_33, _net_34, SE);
not inst68  (_net_35, D);
and inst69  (ENABLE_NOT_D_AND_EN_AND_SE, EN, _net_35, SE);
not inst70  (_net_36, EN);
and inst71  (ENABLE_D_AND_NOT_EN_AND_SE, _net_36, D, SE);
and inst72  (ENABLE_D_AND_EN_AND_SE, EN, D, SE);

specify
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , posedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , negedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPHBQB_V3Y2_8

//%BEGIN HDBSVT11_FSDPHBQ_V2Y2_1

`celldefine
module HDBSVT11_FSDPHBQ_V2Y2_1 (Q, CK, D, SI, SE, EN);
   output Q;
   input CK, D, SI, SE, EN;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_EN;

   wire int_res__D, int_res__S, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_EN, EN);
`endif

   snps_mux2 inst5  (int_res__D, delayed_D, int_res_iq, delayed_EN);
   snps_mux2 inst6  (int_res__S, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res__S);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res__S, xcr_0);
   
   `ifdef VIRL_functiononly
      buf #`SNPS_SEQ_DELAY inst9 (Q, int_res_iq);
   `else
      buf inst10  (Q, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

not inst11  (_net_0, EN);
not inst12  (_net_1, D);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_0, _net_1, SE, _net_2);
not inst15  (_net_3, EN);
not inst16  (_net_4, D);
and inst17  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI, _net_3, _net_4, SE, SI);
not inst18  (_net_5, D);
not inst19  (_net_6, SE);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, _net_5, _net_6, _net_7);
not inst22  (_net_8, D);
not inst23  (_net_9, SE);
and inst24  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI, EN, _net_8, _net_9, SI);
not inst25  (_net_10, D);
not inst26  (_net_11, SI);
and inst27  (ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI, EN, _net_10, SE, _net_11);
not inst28  (_net_12, D);
and inst29  (ENABLE_NOT_D_AND_EN_AND_SE_AND_SI, EN, _net_12, SE, SI);
not inst30  (_net_13, EN);
not inst31  (_net_14, SI);
and inst32  (ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_13, D, SE, _net_14);
not inst33  (_net_15, EN);
and inst34  (ENABLE_D_AND_NOT_EN_AND_SE_AND_SI, _net_15, D, SE, SI);
not inst35  (_net_16, SE);
not inst36  (_net_17, SI);
and inst37  (ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, D, _net_16, _net_17);
not inst38  (_net_18, SE);
and inst39  (ENABLE_D_AND_EN_AND_NOT_SE_AND_SI, EN, D, _net_18, SI);
not inst40  (_net_19, SI);
and inst41  (ENABLE_D_AND_EN_AND_SE_AND_NOT_SI, EN, D, SE, _net_19);
and inst42  (ENABLE_D_AND_EN_AND_SE_AND_SI, EN, D, SE, SI);
not inst43  (_net_20, SE);
not inst44  (_net_21, SI);
and inst45  (ENABLE_EN_AND_NOT_SE_AND_NOT_SI, _net_20, EN, _net_21);
not inst46  (_net_22, SE);
and inst47  (ENABLE_EN_AND_NOT_SE_AND_SI, _net_22, EN, SI);
not inst48  (_net_23, SE);
not inst49  (_net_24, D);
not inst50  (_net_25, SI);
and inst51  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25);
not inst52  (_net_26, SE);
not inst53  (_net_27, D);
and inst54  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_26, _net_27, SI);
not inst55  (_net_28, SE);
not inst56  (_net_29, SI);
and inst57  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_28, D, _net_29);
not inst58  (_net_30, SE);
and inst59  (ENABLE_D_AND_NOT_SE_AND_SI, _net_30, D, SI);
not inst60  (_net_31, D);
and inst61  (ENABLE_NOT_D_AND_EN_AND_SI, EN, _net_31, SI);
not inst62  (_net_32, SI);
and inst63  (ENABLE_D_AND_EN_AND_NOT_SI, EN, D, _net_32);
not inst64  (_net_33, EN);
not inst65  (_net_34, D);
and inst66  (ENABLE_NOT_D_AND_NOT_EN_AND_SE, _net_33, _net_34, SE);
not inst67  (_net_35, D);
and inst68  (ENABLE_NOT_D_AND_EN_AND_SE, EN, _net_35, SE);
not inst69  (_net_36, EN);
and inst70  (ENABLE_D_AND_NOT_EN_AND_SE, _net_36, D, SE);
and inst71  (ENABLE_D_AND_EN_AND_SE, EN, D, SE);

specify
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , posedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , negedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_FSDPHBQ_V2Y2_1   

  

//%BEGIN HDBSVT11_FSDPHBQ_V2Y2_2

`celldefine
module HDBSVT11_FSDPHBQ_V2Y2_2 (Q, CK, D, SI, SE, EN);
   output Q;
   input CK, D, SI, SE, EN;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_EN;

   wire int_res__D, int_res__S, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_EN, EN);
`endif

   snps_mux2 inst5  (int_res__D, delayed_D, int_res_iq, delayed_EN);
   snps_mux2 inst6  (int_res__S, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res__S);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res__S, xcr_0);
   
   `ifdef VIRL_functiononly
      buf #`SNPS_SEQ_DELAY inst9 (Q, int_res_iq);
   `else
      buf inst10  (Q, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

not inst11  (_net_0, EN);
not inst12  (_net_1, D);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_0, _net_1, SE, _net_2);
not inst15  (_net_3, EN);
not inst16  (_net_4, D);
and inst17  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI, _net_3, _net_4, SE, SI);
not inst18  (_net_5, D);
not inst19  (_net_6, SE);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, _net_5, _net_6, _net_7);
not inst22  (_net_8, D);
not inst23  (_net_9, SE);
and inst24  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI, EN, _net_8, _net_9, SI);
not inst25  (_net_10, D);
not inst26  (_net_11, SI);
and inst27  (ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI, EN, _net_10, SE, _net_11);
not inst28  (_net_12, D);
and inst29  (ENABLE_NOT_D_AND_EN_AND_SE_AND_SI, EN, _net_12, SE, SI);
not inst30  (_net_13, EN);
not inst31  (_net_14, SI);
and inst32  (ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_13, D, SE, _net_14);
not inst33  (_net_15, EN);
and inst34  (ENABLE_D_AND_NOT_EN_AND_SE_AND_SI, _net_15, D, SE, SI);
not inst35  (_net_16, SE);
not inst36  (_net_17, SI);
and inst37  (ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, D, _net_16, _net_17);
not inst38  (_net_18, SE);
and inst39  (ENABLE_D_AND_EN_AND_NOT_SE_AND_SI, EN, D, _net_18, SI);
not inst40  (_net_19, SI);
and inst41  (ENABLE_D_AND_EN_AND_SE_AND_NOT_SI, EN, D, SE, _net_19);
and inst42  (ENABLE_D_AND_EN_AND_SE_AND_SI, EN, D, SE, SI);
not inst43  (_net_20, SE);
not inst44  (_net_21, SI);
and inst45  (ENABLE_EN_AND_NOT_SE_AND_NOT_SI, _net_20, EN, _net_21);
not inst46  (_net_22, SE);
and inst47  (ENABLE_EN_AND_NOT_SE_AND_SI, _net_22, EN, SI);
not inst48  (_net_23, SE);
not inst49  (_net_24, D);
not inst50  (_net_25, SI);
and inst51  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25);
not inst52  (_net_26, SE);
not inst53  (_net_27, D);
and inst54  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_26, _net_27, SI);
not inst55  (_net_28, SE);
not inst56  (_net_29, SI);
and inst57  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_28, D, _net_29);
not inst58  (_net_30, SE);
and inst59  (ENABLE_D_AND_NOT_SE_AND_SI, _net_30, D, SI);
not inst60  (_net_31, D);
and inst61  (ENABLE_NOT_D_AND_EN_AND_SI, EN, _net_31, SI);
not inst62  (_net_32, SI);
and inst63  (ENABLE_D_AND_EN_AND_NOT_SI, EN, D, _net_32);
not inst64  (_net_33, EN);
not inst65  (_net_34, D);
and inst66  (ENABLE_NOT_D_AND_NOT_EN_AND_SE, _net_33, _net_34, SE);
not inst67  (_net_35, D);
and inst68  (ENABLE_NOT_D_AND_EN_AND_SE, EN, _net_35, SE);
not inst69  (_net_36, EN);
and inst70  (ENABLE_D_AND_NOT_EN_AND_SE, _net_36, D, SE);
and inst71  (ENABLE_D_AND_EN_AND_SE, EN, D, SE);

specify
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , posedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , negedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_FSDPHBQ_V2Y2_2   

  

//%BEGIN HDBSVT11_FSDPHBQ_V2Y2_4

`celldefine
module HDBSVT11_FSDPHBQ_V2Y2_4 (Q, CK, D, SI, SE, EN);
   output Q;
   input CK, D, SI, SE, EN;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_EN;

   wire int_res__D, int_res__S, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_EN, EN);
`endif

   snps_mux2 inst5  (int_res__D, delayed_D, int_res_iq, delayed_EN);
   snps_mux2 inst6  (int_res__S, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res__S);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res__S, xcr_0);
   
   `ifdef VIRL_functiononly
      buf #`SNPS_SEQ_DELAY inst9 (Q, int_res_iq);
   `else
      buf inst10  (Q, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

not inst11  (_net_0, EN);
not inst12  (_net_1, D);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_0, _net_1, SE, _net_2);
not inst15  (_net_3, EN);
not inst16  (_net_4, D);
and inst17  (ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI, _net_3, _net_4, SE, SI);
not inst18  (_net_5, D);
not inst19  (_net_6, SE);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, _net_5, _net_6, _net_7);
not inst22  (_net_8, D);
not inst23  (_net_9, SE);
and inst24  (ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI, EN, _net_8, _net_9, SI);
not inst25  (_net_10, D);
not inst26  (_net_11, SI);
and inst27  (ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI, EN, _net_10, SE, _net_11);
not inst28  (_net_12, D);
and inst29  (ENABLE_NOT_D_AND_EN_AND_SE_AND_SI, EN, _net_12, SE, SI);
not inst30  (_net_13, EN);
not inst31  (_net_14, SI);
and inst32  (ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI, _net_13, D, SE, _net_14);
not inst33  (_net_15, EN);
and inst34  (ENABLE_D_AND_NOT_EN_AND_SE_AND_SI, _net_15, D, SE, SI);
not inst35  (_net_16, SE);
not inst36  (_net_17, SI);
and inst37  (ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI, EN, D, _net_16, _net_17);
not inst38  (_net_18, SE);
and inst39  (ENABLE_D_AND_EN_AND_NOT_SE_AND_SI, EN, D, _net_18, SI);
not inst40  (_net_19, SI);
and inst41  (ENABLE_D_AND_EN_AND_SE_AND_NOT_SI, EN, D, SE, _net_19);
and inst42  (ENABLE_D_AND_EN_AND_SE_AND_SI, EN, D, SE, SI);
not inst43  (_net_20, SE);
not inst44  (_net_21, SI);
and inst45  (ENABLE_EN_AND_NOT_SE_AND_NOT_SI, _net_20, EN, _net_21);
not inst46  (_net_22, SE);
and inst47  (ENABLE_EN_AND_NOT_SE_AND_SI, _net_22, EN, SI);
not inst48  (_net_23, SE);
not inst49  (_net_24, D);
not inst50  (_net_25, SI);
and inst51  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25);
not inst52  (_net_26, SE);
not inst53  (_net_27, D);
and inst54  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_26, _net_27, SI);
not inst55  (_net_28, SE);
not inst56  (_net_29, SI);
and inst57  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_28, D, _net_29);
not inst58  (_net_30, SE);
and inst59  (ENABLE_D_AND_NOT_SE_AND_SI, _net_30, D, SI);
not inst60  (_net_31, D);
and inst61  (ENABLE_NOT_D_AND_EN_AND_SI, EN, _net_31, SI);
not inst62  (_net_32, SI);
and inst63  (ENABLE_D_AND_EN_AND_NOT_SI, EN, D, _net_32);
not inst64  (_net_33, EN);
not inst65  (_net_34, D);
and inst66  (ENABLE_NOT_D_AND_NOT_EN_AND_SE, _net_33, _net_34, SE);
not inst67  (_net_35, D);
and inst68  (ENABLE_NOT_D_AND_EN_AND_SE, EN, _net_35, SE);
not inst69  (_net_36, EN);
and inst70  (ENABLE_D_AND_NOT_EN_AND_SE, _net_36, D, SE);
and inst71  (ENABLE_D_AND_EN_AND_SE, EN, D, SE);

specify
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && EN==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_EN_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_EN_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_EN_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge EN &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_EN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_EN_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_EN_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_EN_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_EN_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , posedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_EN_AND_SE , negedge SI &&& ENABLE_D_AND_EN_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_FSDPHBQ_V2Y2_4   

  

//%BEGIN HDBSVT11_FSDPHQBOP_V2Y2_1
`celldefine
module HDBSVT11_FSDPHQBOP_V2Y2_1 (QB, SDO, CK, D, SDI, BYPASSN, SEN);
  input CK, D, SDI, BYPASSN, SEN;
  output QB, SDO;
  reg viol_0;
  wire int_0, sdo_out, iq, int_res_d, bypass_out;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SDI, SDI);
    buf inst3  (delayed_BYPASSN, BYPASSN);
    buf inst4  (delayed_SEN, SEN);
  `endif


    not inst5  (int_0, iq);
    snps_mux2 inst6  (sdo_out, iq, delayed_SDI, delayed_BYPASSN);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst7  (xcr_6, delayed_CK, int_res_d);

  `endif
    snps_dff inst8  (iq, viol_0, delayed_CK, int_res_d, xcr_6);
    snps_mux2 inst9  (int_res_d, bypass_out, delayed_D, delayed_SEN);
    snps_mux2 inst10  (bypass_out, delayed_SDI, iq, BYPASSN);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst11 (SDO, sdo_out);
    buf #`SNPS_SEQ_DELAY  inst12 (QB, int_0);
  `else
    buf inst13  (SDO, sdo_out);
    buf inst14  (QB, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst15  (_net_0, SDI);
not inst16  (_net_1, D);
and inst17  (ENABLE_NOT_D_AND_NOT_SDI_AND_SEN, _net_0, _net_1, SEN);
not inst18  (_net_2, D);
and inst19  (ENABLE_NOT_D_AND_SDI_AND_SEN, SDI, _net_2, SEN);
not inst20  (_net_3, SDI);
and inst21  (ENABLE_D_AND_NOT_SDI_AND_SEN, _net_3, D, SEN);
and inst22  (ENABLE_D_AND_SDI_AND_SEN, SDI, D, SEN);
not inst23  (_net_4, D);
not inst24  (_net_5, BYPASSN);
not inst25  (_net_6, SDI);
not inst26  (_net_7, SEN);
and inst27  (ENABLE_NOT_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_NOT_SEN, _net_4, _net_5, _net_6, _net_7);
not inst28  (_net_8, D);
not inst29  (_net_9, BYPASSN);
not inst30  (_net_10, SEN);
and inst31  (ENABLE_NOT_BYPASSN_AND_NOT_D_AND_SDI_AND_NOT_SEN, _net_8, _net_9, SDI, _net_10);
not inst32  (_net_11, BYPASSN);
not inst33  (_net_12, SDI);
not inst34  (_net_13, SEN);
and inst35  (ENABLE_NOT_BYPASSN_AND_D_AND_NOT_SDI_AND_NOT_SEN, D, _net_11, _net_12, _net_13);
not inst36  (_net_14, BYPASSN);
not inst37  (_net_15, SEN);
and inst38  (ENABLE_NOT_BYPASSN_AND_D_AND_SDI_AND_NOT_SEN, D, _net_14, SDI, _net_15);
not inst39  (_net_16, D);
not inst40  (_net_17, SDI);
not inst41  (_net_18, SEN);
and inst42  (ENABLE_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_NOT_SEN, _net_16, BYPASSN, _net_17, _net_18);
not inst43  (_net_19, D);
not inst44  (_net_20, SDI);
and inst45  (ENABLE_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_SEN, _net_19, BYPASSN, _net_20, SEN);
not inst46  (_net_21, D);
not inst47  (_net_22, SEN);
and inst48  (ENABLE_BYPASSN_AND_NOT_D_AND_SDI_AND_NOT_SEN, _net_21, BYPASSN, SDI, _net_22);
not inst49  (_net_23, D);
and inst50  (ENABLE_BYPASSN_AND_NOT_D_AND_SDI_AND_SEN, _net_23, BYPASSN, SDI, SEN);
not inst51  (_net_24, SDI);
not inst52  (_net_25, SEN);
and inst53  (ENABLE_BYPASSN_AND_D_AND_NOT_SDI_AND_NOT_SEN, D, BYPASSN, _net_24, _net_25);
not inst54  (_net_26, SDI);
and inst55  (ENABLE_BYPASSN_AND_D_AND_NOT_SDI_AND_SEN, D, BYPASSN, _net_26, SEN);
not inst56  (_net_27, SEN);
and inst57  (ENABLE_BYPASSN_AND_D_AND_SDI_AND_NOT_SEN, D, BYPASSN, SDI, _net_27);
and inst58  (ENABLE_BYPASSN_AND_D_AND_SDI_AND_SEN, D, BYPASSN, SDI, SEN);
not inst59  (_net_28, SDI);
not inst60  (_net_29, BYPASSN);
not inst61  (_net_30, SEN);
and inst62  (ENABLE_NOT_BYPASSN_AND_NOT_SDI_AND_NOT_SEN, _net_28, _net_29, _net_30);
not inst63  (_net_31, BYPASSN);
not inst64  (_net_32, SEN);
and inst65  (ENABLE_NOT_BYPASSN_AND_SDI_AND_NOT_SEN, SDI, _net_31, _net_32);
not inst66  (_net_33, SDI);
not inst67  (_net_34, SEN);
and inst68  (ENABLE_BYPASSN_AND_NOT_SDI_AND_NOT_SEN, _net_33, BYPASSN, _net_34);
not inst69  (_net_35, SEN);
and inst70  (ENABLE_BYPASSN_AND_SDI_AND_NOT_SEN, SDI, BYPASSN, _net_35);
not inst71  (_net_36, D);
and inst72  (ENABLE_BYPASSN_AND_NOT_D_AND_SEN, _net_36, BYPASSN, SEN);
and inst73  (ENABLE_BYPASSN_AND_D_AND_SEN, D, BYPASSN, SEN);
not inst74  (_net_37, D);
and inst75  (ENABLE_BYPASSN_AND_NOT_D_AND_SDI, _net_37, BYPASSN, SDI);
not inst76  (_net_38, SDI);
and inst77  (ENABLE_BYPASSN_AND_D_AND_NOT_SDI, D, BYPASSN, _net_38);

specify
if (BYPASSN==1'b0 && D==1'b1 && SDI==1'b0 && SEN==1'b0) (posedge CK => (QB -: 1'b1))=(0, 0);
if (BYPASSN==1'b0 && D==1'b1 && SDI==1'b1 && SEN==1'b0) (posedge CK => (QB -: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b0 && SDI==1'b1 && SEN==1'b1) (posedge CK => (QB -: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b1 && SDI==1'b0 && SEN==1'b0) (posedge CK => (QB -: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b1 && SDI==1'b1 && SEN==1'b0) (posedge CK => (QB -: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b1 && SDI==1'b1 && SEN==1'b1) (posedge CK => (QB -: 1'b1))=(0, 0);
if (BYPASSN==1'b0 && D==1'b0 && SDI==1'b0 && SEN==1'b0) (posedge CK => (QB +: 1'b1))=(0, 0);
if (BYPASSN==1'b0 && D==1'b0 && SDI==1'b1 && SEN==1'b0) (posedge CK => (QB +: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b0 && SDI==1'b0 && SEN==1'b0) (posedge CK => (QB +: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b0 && SDI==1'b0 && SEN==1'b1) (posedge CK => (QB +: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b0 && SDI==1'b1 && SEN==1'b0) (posedge CK => (QB +: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b1 && SDI==1'b0 && SEN==1'b1) (posedge CK => (QB +: 1'b1))=(0, 0);
(posedge CK => (QB : 1'b1))=(0, 0);
if (SDI==1'b1) (BYPASSN -=> SDO)=(0, 0);
if (SDI==1'b0) (BYPASSN +=> SDO)=(0, 0);
ifnone (BYPASSN -=> SDO)=(0, 0);
if (BYPASSN==1'b1 && D==1'b0 && SDI==1'b0 && SEN==1'b0) (posedge CK => (SDO -: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b0 && SDI==1'b0 && SEN==1'b1) (posedge CK => (SDO -: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b0 && SDI==1'b1 && SEN==1'b0) (posedge CK => (SDO -: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b1 && SDI==1'b0 && SEN==1'b1) (posedge CK => (SDO -: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b0 && SDI==1'b1 && SEN==1'b1) (posedge CK => (SDO +: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b1 && SDI==1'b0 && SEN==1'b0) (posedge CK => (SDO +: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b1 && SDI==1'b1 && SEN==1'b0) (posedge CK => (SDO +: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b1 && SDI==1'b1 && SEN==1'b1) (posedge CK => (SDO +: 1'b1))=(0, 0);
(posedge CK => (SDO : 1'b1))=(0, 0);
if (BYPASSN==1'b0) (SDI +=> SDO)=(0, 0);
ifnone (SDI +=> SDO)=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SDI_AND_SEN , posedge BYPASSN &&& ENABLE_NOT_D_AND_NOT_SDI_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_BYPASSN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SDI_AND_SEN , negedge BYPASSN &&& ENABLE_NOT_D_AND_NOT_SDI_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_BYPASSN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SDI_AND_SEN , posedge BYPASSN &&& ENABLE_NOT_D_AND_SDI_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_BYPASSN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SDI_AND_SEN , negedge BYPASSN &&& ENABLE_NOT_D_AND_SDI_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_BYPASSN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SDI_AND_SEN , posedge BYPASSN &&& ENABLE_D_AND_NOT_SDI_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_BYPASSN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SDI_AND_SEN , negedge BYPASSN &&& ENABLE_D_AND_NOT_SDI_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_BYPASSN);
$setuphold(posedge CK &&& ENABLE_D_AND_SDI_AND_SEN , posedge BYPASSN &&& ENABLE_D_AND_SDI_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_BYPASSN);
$setuphold(posedge CK &&& ENABLE_D_AND_SDI_AND_SEN , negedge BYPASSN &&& ENABLE_D_AND_SDI_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_BYPASSN);
$width(posedge CK &&& ENABLE_NOT_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_BYPASSN_AND_NOT_D_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_BYPASSN_AND_NOT_D_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_BYPASSN_AND_D_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_BYPASSN_AND_D_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_BYPASSN_AND_D_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_BYPASSN_AND_D_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_SDI_AND_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_SDI_AND_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_BYPASSN_AND_D_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_BYPASSN_AND_D_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_BYPASSN_AND_D_AND_NOT_SDI_AND_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_BYPASSN_AND_D_AND_NOT_SDI_AND_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_BYPASSN_AND_D_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_BYPASSN_AND_D_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_BYPASSN_AND_D_AND_SDI_AND_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_BYPASSN_AND_D_AND_SDI_AND_SEN , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_BYPASSN_AND_NOT_SDI_AND_NOT_SEN , posedge D &&& ENABLE_NOT_BYPASSN_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_BYPASSN_AND_NOT_SDI_AND_NOT_SEN , negedge D &&& ENABLE_NOT_BYPASSN_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_BYPASSN_AND_SDI_AND_NOT_SEN , posedge D &&& ENABLE_NOT_BYPASSN_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_BYPASSN_AND_SDI_AND_NOT_SEN , negedge D &&& ENABLE_NOT_BYPASSN_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_NOT_SDI_AND_NOT_SEN , posedge D &&& ENABLE_BYPASSN_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_NOT_SDI_AND_NOT_SEN , negedge D &&& ENABLE_BYPASSN_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_SDI_AND_NOT_SEN , posedge D &&& ENABLE_BYPASSN_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_SDI_AND_NOT_SEN , negedge D &&& ENABLE_BYPASSN_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_SEN , posedge SDI &&& ENABLE_BYPASSN_AND_NOT_D_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_SDI);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_SEN , negedge SDI &&& ENABLE_BYPASSN_AND_NOT_D_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_SDI);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_D_AND_SEN , posedge SDI &&& ENABLE_BYPASSN_AND_D_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_SDI);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_D_AND_SEN , negedge SDI &&& ENABLE_BYPASSN_AND_D_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_SDI);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_SDI , posedge SEN &&& ENABLE_BYPASSN_AND_NOT_D_AND_SDI , 0 ,0, viol_0, , , delayed_CK, delayed_SEN);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_SDI , negedge SEN &&& ENABLE_BYPASSN_AND_NOT_D_AND_SDI , 0 ,0, viol_0, , , delayed_CK, delayed_SEN);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_D_AND_NOT_SDI , posedge SEN &&& ENABLE_BYPASSN_AND_D_AND_NOT_SDI , 0 ,0, viol_0, , , delayed_CK, delayed_SEN);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_D_AND_NOT_SDI , negedge SEN &&& ENABLE_BYPASSN_AND_D_AND_NOT_SDI , 0 ,0, viol_0, , , delayed_CK, delayed_SEN);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPHQBOP_V2Y2_1


//%BEGIN HDBSVT11_FSDPHQBOP_V2Y2_2
`celldefine
module HDBSVT11_FSDPHQBOP_V2Y2_2 (QB, SDO, CK, D, SDI, BYPASSN, SEN);
  input CK, D, SDI, BYPASSN, SEN;
  output QB, SDO;
  reg viol_0;
  wire int_0, sdo_out, iq, int_res_d, bypass_out;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SDI, SDI);
    buf inst3  (delayed_BYPASSN, BYPASSN);
    buf inst4  (delayed_SEN, SEN);
  `endif


    not inst5  (int_0, iq);
    snps_mux2 inst6  (sdo_out, iq, delayed_SDI, delayed_BYPASSN);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst7  (xcr_6, delayed_CK, int_res_d);

  `endif
    snps_dff inst8  (iq, viol_0, delayed_CK, int_res_d, xcr_6);
    snps_mux2 inst9  (int_res_d, bypass_out, delayed_D, delayed_SEN);
    snps_mux2 inst10  (bypass_out, delayed_SDI, iq, BYPASSN);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst11 (SDO, sdo_out);
    buf #`SNPS_SEQ_DELAY  inst12 (QB, int_0);
  `else
    buf inst13  (SDO, sdo_out);
    buf inst14  (QB, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst15  (_net_0, SDI);
not inst16  (_net_1, D);
and inst17  (ENABLE_NOT_D_AND_NOT_SDI_AND_SEN, _net_0, _net_1, SEN);
not inst18  (_net_2, D);
and inst19  (ENABLE_NOT_D_AND_SDI_AND_SEN, SDI, _net_2, SEN);
not inst20  (_net_3, SDI);
and inst21  (ENABLE_D_AND_NOT_SDI_AND_SEN, _net_3, D, SEN);
and inst22  (ENABLE_D_AND_SDI_AND_SEN, SDI, D, SEN);
not inst23  (_net_4, D);
not inst24  (_net_5, BYPASSN);
not inst25  (_net_6, SDI);
not inst26  (_net_7, SEN);
and inst27  (ENABLE_NOT_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_NOT_SEN, _net_4, _net_5, _net_6, _net_7);
not inst28  (_net_8, D);
not inst29  (_net_9, BYPASSN);
not inst30  (_net_10, SEN);
and inst31  (ENABLE_NOT_BYPASSN_AND_NOT_D_AND_SDI_AND_NOT_SEN, _net_8, _net_9, SDI, _net_10);
not inst32  (_net_11, BYPASSN);
not inst33  (_net_12, SDI);
not inst34  (_net_13, SEN);
and inst35  (ENABLE_NOT_BYPASSN_AND_D_AND_NOT_SDI_AND_NOT_SEN, D, _net_11, _net_12, _net_13);
not inst36  (_net_14, BYPASSN);
not inst37  (_net_15, SEN);
and inst38  (ENABLE_NOT_BYPASSN_AND_D_AND_SDI_AND_NOT_SEN, D, _net_14, SDI, _net_15);
not inst39  (_net_16, D);
not inst40  (_net_17, SDI);
not inst41  (_net_18, SEN);
and inst42  (ENABLE_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_NOT_SEN, _net_16, BYPASSN, _net_17, _net_18);
not inst43  (_net_19, D);
not inst44  (_net_20, SDI);
and inst45  (ENABLE_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_SEN, _net_19, BYPASSN, _net_20, SEN);
not inst46  (_net_21, D);
not inst47  (_net_22, SEN);
and inst48  (ENABLE_BYPASSN_AND_NOT_D_AND_SDI_AND_NOT_SEN, _net_21, BYPASSN, SDI, _net_22);
not inst49  (_net_23, D);
and inst50  (ENABLE_BYPASSN_AND_NOT_D_AND_SDI_AND_SEN, _net_23, BYPASSN, SDI, SEN);
not inst51  (_net_24, SDI);
not inst52  (_net_25, SEN);
and inst53  (ENABLE_BYPASSN_AND_D_AND_NOT_SDI_AND_NOT_SEN, D, BYPASSN, _net_24, _net_25);
not inst54  (_net_26, SDI);
and inst55  (ENABLE_BYPASSN_AND_D_AND_NOT_SDI_AND_SEN, D, BYPASSN, _net_26, SEN);
not inst56  (_net_27, SEN);
and inst57  (ENABLE_BYPASSN_AND_D_AND_SDI_AND_NOT_SEN, D, BYPASSN, SDI, _net_27);
and inst58  (ENABLE_BYPASSN_AND_D_AND_SDI_AND_SEN, D, BYPASSN, SDI, SEN);
not inst59  (_net_28, SDI);
not inst60  (_net_29, BYPASSN);
not inst61  (_net_30, SEN);
and inst62  (ENABLE_NOT_BYPASSN_AND_NOT_SDI_AND_NOT_SEN, _net_28, _net_29, _net_30);
not inst63  (_net_31, BYPASSN);
not inst64  (_net_32, SEN);
and inst65  (ENABLE_NOT_BYPASSN_AND_SDI_AND_NOT_SEN, SDI, _net_31, _net_32);
not inst66  (_net_33, SDI);
not inst67  (_net_34, SEN);
and inst68  (ENABLE_BYPASSN_AND_NOT_SDI_AND_NOT_SEN, _net_33, BYPASSN, _net_34);
not inst69  (_net_35, SEN);
and inst70  (ENABLE_BYPASSN_AND_SDI_AND_NOT_SEN, SDI, BYPASSN, _net_35);
not inst71  (_net_36, D);
and inst72  (ENABLE_BYPASSN_AND_NOT_D_AND_SEN, _net_36, BYPASSN, SEN);
and inst73  (ENABLE_BYPASSN_AND_D_AND_SEN, D, BYPASSN, SEN);
not inst74  (_net_37, D);
and inst75  (ENABLE_BYPASSN_AND_NOT_D_AND_SDI, _net_37, BYPASSN, SDI);
not inst76  (_net_38, SDI);
and inst77  (ENABLE_BYPASSN_AND_D_AND_NOT_SDI, D, BYPASSN, _net_38);

specify
if (BYPASSN==1'b0 && D==1'b1 && SDI==1'b0 && SEN==1'b0) (posedge CK => (QB -: 1'b1))=(0, 0);
if (BYPASSN==1'b0 && D==1'b1 && SDI==1'b1 && SEN==1'b0) (posedge CK => (QB -: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b0 && SDI==1'b1 && SEN==1'b1) (posedge CK => (QB -: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b1 && SDI==1'b0 && SEN==1'b0) (posedge CK => (QB -: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b1 && SDI==1'b1 && SEN==1'b0) (posedge CK => (QB -: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b1 && SDI==1'b1 && SEN==1'b1) (posedge CK => (QB -: 1'b1))=(0, 0);
if (BYPASSN==1'b0 && D==1'b0 && SDI==1'b0 && SEN==1'b0) (posedge CK => (QB +: 1'b1))=(0, 0);
if (BYPASSN==1'b0 && D==1'b0 && SDI==1'b1 && SEN==1'b0) (posedge CK => (QB +: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b0 && SDI==1'b0 && SEN==1'b0) (posedge CK => (QB +: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b0 && SDI==1'b0 && SEN==1'b1) (posedge CK => (QB +: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b0 && SDI==1'b1 && SEN==1'b0) (posedge CK => (QB +: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b1 && SDI==1'b0 && SEN==1'b1) (posedge CK => (QB +: 1'b1))=(0, 0);
(posedge CK => (QB : 1'b1))=(0, 0);
if (SDI==1'b1) (BYPASSN -=> SDO)=(0, 0);
if (SDI==1'b0) (BYPASSN +=> SDO)=(0, 0);
ifnone (BYPASSN -=> SDO)=(0, 0);
if (BYPASSN==1'b1 && D==1'b0 && SDI==1'b0 && SEN==1'b0) (posedge CK => (SDO -: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b0 && SDI==1'b0 && SEN==1'b1) (posedge CK => (SDO -: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b0 && SDI==1'b1 && SEN==1'b0) (posedge CK => (SDO -: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b1 && SDI==1'b0 && SEN==1'b1) (posedge CK => (SDO -: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b0 && SDI==1'b1 && SEN==1'b1) (posedge CK => (SDO +: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b1 && SDI==1'b0 && SEN==1'b0) (posedge CK => (SDO +: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b1 && SDI==1'b1 && SEN==1'b0) (posedge CK => (SDO +: 1'b1))=(0, 0);
if (BYPASSN==1'b1 && D==1'b1 && SDI==1'b1 && SEN==1'b1) (posedge CK => (SDO +: 1'b1))=(0, 0);
(posedge CK => (SDO : 1'b1))=(0, 0);
if (BYPASSN==1'b0) (SDI +=> SDO)=(0, 0);
ifnone (SDI +=> SDO)=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SDI_AND_SEN , posedge BYPASSN &&& ENABLE_NOT_D_AND_NOT_SDI_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_BYPASSN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SDI_AND_SEN , negedge BYPASSN &&& ENABLE_NOT_D_AND_NOT_SDI_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_BYPASSN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SDI_AND_SEN , posedge BYPASSN &&& ENABLE_NOT_D_AND_SDI_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_BYPASSN);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SDI_AND_SEN , negedge BYPASSN &&& ENABLE_NOT_D_AND_SDI_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_BYPASSN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SDI_AND_SEN , posedge BYPASSN &&& ENABLE_D_AND_NOT_SDI_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_BYPASSN);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SDI_AND_SEN , negedge BYPASSN &&& ENABLE_D_AND_NOT_SDI_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_BYPASSN);
$setuphold(posedge CK &&& ENABLE_D_AND_SDI_AND_SEN , posedge BYPASSN &&& ENABLE_D_AND_SDI_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_BYPASSN);
$setuphold(posedge CK &&& ENABLE_D_AND_SDI_AND_SEN , negedge BYPASSN &&& ENABLE_D_AND_SDI_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_BYPASSN);
$width(posedge CK &&& ENABLE_NOT_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_BYPASSN_AND_NOT_D_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_BYPASSN_AND_NOT_D_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_BYPASSN_AND_D_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_BYPASSN_AND_D_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_BYPASSN_AND_D_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_BYPASSN_AND_D_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_NOT_SDI_AND_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_SDI_AND_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_SDI_AND_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_BYPASSN_AND_D_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_BYPASSN_AND_D_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_BYPASSN_AND_D_AND_NOT_SDI_AND_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_BYPASSN_AND_D_AND_NOT_SDI_AND_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_BYPASSN_AND_D_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_BYPASSN_AND_D_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_BYPASSN_AND_D_AND_SDI_AND_SEN , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_BYPASSN_AND_D_AND_SDI_AND_SEN , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_BYPASSN_AND_NOT_SDI_AND_NOT_SEN , posedge D &&& ENABLE_NOT_BYPASSN_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_BYPASSN_AND_NOT_SDI_AND_NOT_SEN , negedge D &&& ENABLE_NOT_BYPASSN_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_BYPASSN_AND_SDI_AND_NOT_SEN , posedge D &&& ENABLE_NOT_BYPASSN_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_BYPASSN_AND_SDI_AND_NOT_SEN , negedge D &&& ENABLE_NOT_BYPASSN_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_NOT_SDI_AND_NOT_SEN , posedge D &&& ENABLE_BYPASSN_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_NOT_SDI_AND_NOT_SEN , negedge D &&& ENABLE_BYPASSN_AND_NOT_SDI_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_SDI_AND_NOT_SEN , posedge D &&& ENABLE_BYPASSN_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_SDI_AND_NOT_SEN , negedge D &&& ENABLE_BYPASSN_AND_SDI_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_SEN , posedge SDI &&& ENABLE_BYPASSN_AND_NOT_D_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_SDI);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_SEN , negedge SDI &&& ENABLE_BYPASSN_AND_NOT_D_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_SDI);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_D_AND_SEN , posedge SDI &&& ENABLE_BYPASSN_AND_D_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_SDI);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_D_AND_SEN , negedge SDI &&& ENABLE_BYPASSN_AND_D_AND_SEN , 0 ,0, viol_0, , , delayed_CK, delayed_SDI);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_SDI , posedge SEN &&& ENABLE_BYPASSN_AND_NOT_D_AND_SDI , 0 ,0, viol_0, , , delayed_CK, delayed_SEN);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_NOT_D_AND_SDI , negedge SEN &&& ENABLE_BYPASSN_AND_NOT_D_AND_SDI , 0 ,0, viol_0, , , delayed_CK, delayed_SEN);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_D_AND_NOT_SDI , posedge SEN &&& ENABLE_BYPASSN_AND_D_AND_NOT_SDI , 0 ,0, viol_0, , , delayed_CK, delayed_SEN);
$setuphold(posedge CK &&& ENABLE_BYPASSN_AND_D_AND_NOT_SDI , negedge SEN &&& ENABLE_BYPASSN_AND_D_AND_NOT_SDI , 0 ,0, viol_0, , , delayed_CK, delayed_SEN);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPHQBOP_V2Y2_2


//%BEGIN HDBSVT11_FSDPMQ_V2Y2_1

`celldefine
module HDBSVT11_FSDPMQ_V2Y2_1 (Q, CK, D0, D1, S, SI, SE);
   output Q;
   input CK, D0, D1, S, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D0, delayed_D1,
	delayed_S, delayed_SI, delayed_SE;

   wire int_res__D, int_res__S, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_S, S);
   buf inst4  (delayed_SI, SI);
   buf inst5  (delayed_SE, SE);
`endif

   snps_mux2 inst6  (int_res__D, delayed_D1, delayed_D0, delayed_S);
   snps_mux2 inst7  (int_res__S, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__S);

  `endif

   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst9 (Q, viol_0, delayed_CK, int_res__S, xcr_0);
   `else
      snps_dff inst10  (Q, viol_0, delayed_CK, int_res__S, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst11  (_net_0, D1);
not inst12  (_net_1, D0);
not inst13  (_net_2, S);
not inst14  (_net_3, SE);
not inst15  (_net_4, SI);
and inst16  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4);
not inst17  (_net_5, D1);
not inst18  (_net_6, D0);
not inst19  (_net_7, S);
not inst20  (_net_8, SE);
and inst21  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI, _net_5, _net_6, _net_7, _net_8, SI);
not inst22  (_net_9, D1);
not inst23  (_net_10, D0);
not inst24  (_net_11, S);
not inst25  (_net_12, SI);
and inst26  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI, _net_9, _net_10, _net_11, SE, _net_12);
not inst27  (_net_13, D1);
not inst28  (_net_14, D0);
not inst29  (_net_15, S);
and inst30  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI, _net_13, _net_14, _net_15, SE, SI);
not inst31  (_net_16, D1);
not inst32  (_net_17, D0);
not inst33  (_net_18, SE);
not inst34  (_net_19, SI);
and inst35  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI, _net_16, _net_17, S, _net_18, _net_19);
not inst36  (_net_20, D1);
not inst37  (_net_21, D0);
not inst38  (_net_22, SE);
and inst39  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI, _net_20, _net_21, S, _net_22, SI);
not inst40  (_net_23, D1);
not inst41  (_net_24, D0);
not inst42  (_net_25, SI);
and inst43  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI, _net_23, _net_24, S, SE, _net_25);
not inst44  (_net_26, D1);
not inst45  (_net_27, D0);
and inst46  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI, _net_26, _net_27, S, SE, SI);
not inst47  (_net_28, D0);
not inst48  (_net_29, S);
not inst49  (_net_30, SE);
not inst50  (_net_31, SI);
and inst51  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, D1, _net_28, _net_29, _net_30, _net_31);
not inst52  (_net_32, D0);
not inst53  (_net_33, S);
not inst54  (_net_34, SE);
and inst55  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI, D1, _net_32, _net_33, _net_34, SI);
not inst56  (_net_35, D0);
not inst57  (_net_36, S);
not inst58  (_net_37, SI);
and inst59  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI, D1, _net_35, _net_36, SE, _net_37);
not inst60  (_net_38, D0);
not inst61  (_net_39, S);
and inst62  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI, D1, _net_38, _net_39, SE, SI);
not inst63  (_net_40, D0);
not inst64  (_net_41, SE);
not inst65  (_net_42, SI);
and inst66  (ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI, D1, _net_40, S, _net_41, _net_42);
not inst67  (_net_43, D0);
not inst68  (_net_44, SE);
and inst69  (ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI, D1, _net_43, S, _net_44, SI);
not inst70  (_net_45, D0);
not inst71  (_net_46, SI);
and inst72  (ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI, D1, _net_45, S, SE, _net_46);
not inst73  (_net_47, D0);
and inst74  (ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_SI, D1, _net_47, S, SE, SI);
not inst75  (_net_48, D1);
not inst76  (_net_49, S);
not inst77  (_net_50, SE);
not inst78  (_net_51, SI);
and inst79  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_48, D0, _net_49, _net_50, _net_51);
not inst80  (_net_52, D1);
not inst81  (_net_53, S);
not inst82  (_net_54, SE);
and inst83  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI, _net_52, D0, _net_53, _net_54, SI);
not inst84  (_net_55, D1);
not inst85  (_net_56, S);
not inst86  (_net_57, SI);
and inst87  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI, _net_55, D0, _net_56, SE, _net_57);
not inst88  (_net_58, D1);
not inst89  (_net_59, S);
and inst90  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI, _net_58, D0, _net_59, SE, SI);
not inst91  (_net_60, D1);
not inst92  (_net_61, SE);
not inst93  (_net_62, SI);
and inst94  (ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI, _net_60, D0, S, _net_61, _net_62);
not inst95  (_net_63, D1);
not inst96  (_net_64, SE);
and inst97  (ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI, _net_63, D0, S, _net_64, SI);
not inst98  (_net_65, D1);
not inst99  (_net_66, SI);
and inst100  (ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI, _net_65, D0, S, SE, _net_66);
not inst101  (_net_67, D1);
and inst102  (ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI, _net_67, D0, S, SE, SI);
not inst103  (_net_68, S);
not inst104  (_net_69, SE);
not inst105  (_net_70, SI);
and inst106  (ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, D1, D0, _net_68, _net_69, _net_70);
not inst107  (_net_71, S);
not inst108  (_net_72, SE);
and inst109  (ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI, D1, D0, _net_71, _net_72, SI);
not inst110  (_net_73, S);
not inst111  (_net_74, SI);
and inst112  (ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI, D1, D0, _net_73, SE, _net_74);
not inst113  (_net_75, S);
and inst114  (ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI, D1, D0, _net_75, SE, SI);
not inst115  (_net_76, SE);
not inst116  (_net_77, SI);
and inst117  (ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI, D1, D0, S, _net_76, _net_77);
not inst118  (_net_78, SE);
and inst119  (ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI, D1, D0, S, _net_78, SI);
not inst120  (_net_79, SI);
and inst121  (ENABLE_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI, D1, D0, S, SE, _net_79);
and inst122  (ENABLE_D0_AND_D1_AND_S_AND_SE_AND_SI, D1, D0, S, SE, SI);
not inst123  (_net_80, S);
not inst124  (_net_81, D1);
not inst125  (_net_82, SE);
not inst126  (_net_83, SI);
and inst127  (ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_80, _net_81, _net_82, _net_83);
not inst128  (_net_84, S);
not inst129  (_net_85, D1);
not inst130  (_net_86, SE);
and inst131  (ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI, _net_84, _net_85, _net_86, SI);
not inst132  (_net_87, S);
not inst133  (_net_88, SE);
not inst134  (_net_89, SI);
and inst135  (ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_87, D1, _net_88, _net_89);
not inst136  (_net_90, S);
not inst137  (_net_91, SE);
and inst138  (ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_SI, _net_90, D1, _net_91, SI);
not inst139  (_net_92, D0);
not inst140  (_net_93, SE);
not inst141  (_net_94, SI);
and inst142  (ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_NOT_SI, S, _net_92, _net_93, _net_94);
not inst143  (_net_95, D0);
not inst144  (_net_96, SE);
and inst145  (ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_SI, S, _net_95, _net_96, SI);
not inst146  (_net_97, SE);
not inst147  (_net_98, SI);
and inst148  (ENABLE_D0_AND_S_AND_NOT_SE_AND_NOT_SI, S, D0, _net_97, _net_98);
not inst149  (_net_99, SE);
and inst150  (ENABLE_D0_AND_S_AND_NOT_SE_AND_SI, S, D0, _net_99, SI);
not inst151  (_net_100, D0);
not inst152  (_net_101, SE);
not inst153  (_net_102, SI);
and inst154  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D1, _net_100, _net_101, _net_102);
not inst155  (_net_103, D0);
not inst156  (_net_104, SE);
and inst157  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI, D1, _net_103, _net_104, SI);
not inst158  (_net_105, D1);
not inst159  (_net_106, SE);
not inst160  (_net_107, SI);
and inst161  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_105, D0, _net_106, _net_107);
not inst162  (_net_108, D1);
not inst163  (_net_109, SE);
and inst164  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_108, D0, _net_109, SI);
not inst165  (_net_110, D1);
not inst166  (_net_111, D0);
not inst167  (_net_112, S);
and inst168  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SI, _net_110, _net_111, _net_112, SI);
not inst169  (_net_113, D1);
not inst170  (_net_114, D0);
and inst171  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SI, _net_113, _net_114, S, SI);
not inst172  (_net_115, D0);
not inst173  (_net_116, S);
and inst174  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SI, D1, _net_115, _net_116, SI);
not inst175  (_net_117, D0);
not inst176  (_net_118, SI);
and inst177  (ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SI, D1, _net_117, S, _net_118);
not inst178  (_net_119, D1);
not inst179  (_net_120, S);
not inst180  (_net_121, SI);
and inst181  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SI, _net_119, D0, _net_120, _net_121);
not inst182  (_net_122, D1);
and inst183  (ENABLE_D0_AND_NOT_D1_AND_S_AND_SI, _net_122, D0, S, SI);
not inst184  (_net_123, S);
not inst185  (_net_124, SI);
and inst186  (ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SI, D1, D0, _net_123, _net_124);
not inst187  (_net_125, SI);
and inst188  (ENABLE_D0_AND_D1_AND_S_AND_NOT_SI, D1, D0, S, _net_125);
not inst189  (_net_126, D1);
not inst190  (_net_127, D0);
not inst191  (_net_128, S);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE, _net_126, _net_127, _net_128, SE);
not inst193  (_net_129, D1);
not inst194  (_net_130, D0);
and inst195  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE, _net_129, _net_130, S, SE);
not inst196  (_net_131, D0);
not inst197  (_net_132, S);
and inst198  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE, D1, _net_131, _net_132, SE);
not inst199  (_net_133, D0);
and inst200  (ENABLE_NOT_D0_AND_D1_AND_S_AND_SE, D1, _net_133, S, SE);
not inst201  (_net_134, D1);
not inst202  (_net_135, S);
and inst203  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE, _net_134, D0, _net_135, SE);
not inst204  (_net_136, D1);
and inst205  (ENABLE_D0_AND_NOT_D1_AND_S_AND_SE, _net_136, D0, S, SE);
not inst206  (_net_137, S);
and inst207  (ENABLE_D0_AND_D1_AND_NOT_S_AND_SE, D1, D0, _net_137, SE);
and inst208  (ENABLE_D0_AND_D1_AND_S_AND_SE, D1, D0, S, SE);

specify
if (D0==1'b0 && D1==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , posedge S &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , negedge S &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , posedge S &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , negedge S &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , posedge S &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , negedge S &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , posedge S &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , negedge S &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE , posedge SI &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE , negedge SI &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE , posedge SI &&& ENABLE_D0_AND_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE , negedge SI &&& ENABLE_D0_AND_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_FSDPMQ_V2Y2_1

//%BEGIN HDBSVT11_FSDPMQ_V2Y2_2

`celldefine
module HDBSVT11_FSDPMQ_V2Y2_2 (Q, CK, D0, D1, S, SI, SE);
   output Q;
   input CK, D0, D1, S, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D0, delayed_D1,
	delayed_S, delayed_SI, delayed_SE;

   wire int_res__D, int_res__S, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_S, S);
   buf inst4  (delayed_SI, SI);
   buf inst5  (delayed_SE, SE);
`endif

   snps_mux2 inst6  (int_res__D, delayed_D1, delayed_D0, delayed_S);
   snps_mux2 inst7  (int_res__S, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__S);

  `endif

   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst9 (Q, viol_0, delayed_CK, int_res__S, xcr_0);
   `else
      snps_dff inst10  (Q, viol_0, delayed_CK, int_res__S, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst11  (_net_0, D1);
not inst12  (_net_1, D0);
not inst13  (_net_2, S);
not inst14  (_net_3, SE);
not inst15  (_net_4, SI);
and inst16  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4);
not inst17  (_net_5, D1);
not inst18  (_net_6, D0);
not inst19  (_net_7, S);
not inst20  (_net_8, SE);
and inst21  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI, _net_5, _net_6, _net_7, _net_8, SI);
not inst22  (_net_9, D1);
not inst23  (_net_10, D0);
not inst24  (_net_11, S);
not inst25  (_net_12, SI);
and inst26  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI, _net_9, _net_10, _net_11, SE, _net_12);
not inst27  (_net_13, D1);
not inst28  (_net_14, D0);
not inst29  (_net_15, S);
and inst30  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI, _net_13, _net_14, _net_15, SE, SI);
not inst31  (_net_16, D1);
not inst32  (_net_17, D0);
not inst33  (_net_18, SE);
not inst34  (_net_19, SI);
and inst35  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI, _net_16, _net_17, S, _net_18, _net_19);
not inst36  (_net_20, D1);
not inst37  (_net_21, D0);
not inst38  (_net_22, SE);
and inst39  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI, _net_20, _net_21, S, _net_22, SI);
not inst40  (_net_23, D1);
not inst41  (_net_24, D0);
not inst42  (_net_25, SI);
and inst43  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI, _net_23, _net_24, S, SE, _net_25);
not inst44  (_net_26, D1);
not inst45  (_net_27, D0);
and inst46  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI, _net_26, _net_27, S, SE, SI);
not inst47  (_net_28, D0);
not inst48  (_net_29, S);
not inst49  (_net_30, SE);
not inst50  (_net_31, SI);
and inst51  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, D1, _net_28, _net_29, _net_30, _net_31);
not inst52  (_net_32, D0);
not inst53  (_net_33, S);
not inst54  (_net_34, SE);
and inst55  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI, D1, _net_32, _net_33, _net_34, SI);
not inst56  (_net_35, D0);
not inst57  (_net_36, S);
not inst58  (_net_37, SI);
and inst59  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI, D1, _net_35, _net_36, SE, _net_37);
not inst60  (_net_38, D0);
not inst61  (_net_39, S);
and inst62  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI, D1, _net_38, _net_39, SE, SI);
not inst63  (_net_40, D0);
not inst64  (_net_41, SE);
not inst65  (_net_42, SI);
and inst66  (ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI, D1, _net_40, S, _net_41, _net_42);
not inst67  (_net_43, D0);
not inst68  (_net_44, SE);
and inst69  (ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI, D1, _net_43, S, _net_44, SI);
not inst70  (_net_45, D0);
not inst71  (_net_46, SI);
and inst72  (ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI, D1, _net_45, S, SE, _net_46);
not inst73  (_net_47, D0);
and inst74  (ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_SI, D1, _net_47, S, SE, SI);
not inst75  (_net_48, D1);
not inst76  (_net_49, S);
not inst77  (_net_50, SE);
not inst78  (_net_51, SI);
and inst79  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_48, D0, _net_49, _net_50, _net_51);
not inst80  (_net_52, D1);
not inst81  (_net_53, S);
not inst82  (_net_54, SE);
and inst83  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI, _net_52, D0, _net_53, _net_54, SI);
not inst84  (_net_55, D1);
not inst85  (_net_56, S);
not inst86  (_net_57, SI);
and inst87  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI, _net_55, D0, _net_56, SE, _net_57);
not inst88  (_net_58, D1);
not inst89  (_net_59, S);
and inst90  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI, _net_58, D0, _net_59, SE, SI);
not inst91  (_net_60, D1);
not inst92  (_net_61, SE);
not inst93  (_net_62, SI);
and inst94  (ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI, _net_60, D0, S, _net_61, _net_62);
not inst95  (_net_63, D1);
not inst96  (_net_64, SE);
and inst97  (ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI, _net_63, D0, S, _net_64, SI);
not inst98  (_net_65, D1);
not inst99  (_net_66, SI);
and inst100  (ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI, _net_65, D0, S, SE, _net_66);
not inst101  (_net_67, D1);
and inst102  (ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI, _net_67, D0, S, SE, SI);
not inst103  (_net_68, S);
not inst104  (_net_69, SE);
not inst105  (_net_70, SI);
and inst106  (ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, D1, D0, _net_68, _net_69, _net_70);
not inst107  (_net_71, S);
not inst108  (_net_72, SE);
and inst109  (ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI, D1, D0, _net_71, _net_72, SI);
not inst110  (_net_73, S);
not inst111  (_net_74, SI);
and inst112  (ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI, D1, D0, _net_73, SE, _net_74);
not inst113  (_net_75, S);
and inst114  (ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI, D1, D0, _net_75, SE, SI);
not inst115  (_net_76, SE);
not inst116  (_net_77, SI);
and inst117  (ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI, D1, D0, S, _net_76, _net_77);
not inst118  (_net_78, SE);
and inst119  (ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI, D1, D0, S, _net_78, SI);
not inst120  (_net_79, SI);
and inst121  (ENABLE_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI, D1, D0, S, SE, _net_79);
and inst122  (ENABLE_D0_AND_D1_AND_S_AND_SE_AND_SI, D1, D0, S, SE, SI);
not inst123  (_net_80, S);
not inst124  (_net_81, D1);
not inst125  (_net_82, SE);
not inst126  (_net_83, SI);
and inst127  (ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_80, _net_81, _net_82, _net_83);
not inst128  (_net_84, S);
not inst129  (_net_85, D1);
not inst130  (_net_86, SE);
and inst131  (ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI, _net_84, _net_85, _net_86, SI);
not inst132  (_net_87, S);
not inst133  (_net_88, SE);
not inst134  (_net_89, SI);
and inst135  (ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_87, D1, _net_88, _net_89);
not inst136  (_net_90, S);
not inst137  (_net_91, SE);
and inst138  (ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_SI, _net_90, D1, _net_91, SI);
not inst139  (_net_92, D0);
not inst140  (_net_93, SE);
not inst141  (_net_94, SI);
and inst142  (ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_NOT_SI, S, _net_92, _net_93, _net_94);
not inst143  (_net_95, D0);
not inst144  (_net_96, SE);
and inst145  (ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_SI, S, _net_95, _net_96, SI);
not inst146  (_net_97, SE);
not inst147  (_net_98, SI);
and inst148  (ENABLE_D0_AND_S_AND_NOT_SE_AND_NOT_SI, S, D0, _net_97, _net_98);
not inst149  (_net_99, SE);
and inst150  (ENABLE_D0_AND_S_AND_NOT_SE_AND_SI, S, D0, _net_99, SI);
not inst151  (_net_100, D0);
not inst152  (_net_101, SE);
not inst153  (_net_102, SI);
and inst154  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D1, _net_100, _net_101, _net_102);
not inst155  (_net_103, D0);
not inst156  (_net_104, SE);
and inst157  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI, D1, _net_103, _net_104, SI);
not inst158  (_net_105, D1);
not inst159  (_net_106, SE);
not inst160  (_net_107, SI);
and inst161  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_105, D0, _net_106, _net_107);
not inst162  (_net_108, D1);
not inst163  (_net_109, SE);
and inst164  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_108, D0, _net_109, SI);
not inst165  (_net_110, D1);
not inst166  (_net_111, D0);
not inst167  (_net_112, S);
and inst168  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SI, _net_110, _net_111, _net_112, SI);
not inst169  (_net_113, D1);
not inst170  (_net_114, D0);
and inst171  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SI, _net_113, _net_114, S, SI);
not inst172  (_net_115, D0);
not inst173  (_net_116, S);
and inst174  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SI, D1, _net_115, _net_116, SI);
not inst175  (_net_117, D0);
not inst176  (_net_118, SI);
and inst177  (ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SI, D1, _net_117, S, _net_118);
not inst178  (_net_119, D1);
not inst179  (_net_120, S);
not inst180  (_net_121, SI);
and inst181  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SI, _net_119, D0, _net_120, _net_121);
not inst182  (_net_122, D1);
and inst183  (ENABLE_D0_AND_NOT_D1_AND_S_AND_SI, _net_122, D0, S, SI);
not inst184  (_net_123, S);
not inst185  (_net_124, SI);
and inst186  (ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SI, D1, D0, _net_123, _net_124);
not inst187  (_net_125, SI);
and inst188  (ENABLE_D0_AND_D1_AND_S_AND_NOT_SI, D1, D0, S, _net_125);
not inst189  (_net_126, D1);
not inst190  (_net_127, D0);
not inst191  (_net_128, S);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE, _net_126, _net_127, _net_128, SE);
not inst193  (_net_129, D1);
not inst194  (_net_130, D0);
and inst195  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE, _net_129, _net_130, S, SE);
not inst196  (_net_131, D0);
not inst197  (_net_132, S);
and inst198  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE, D1, _net_131, _net_132, SE);
not inst199  (_net_133, D0);
and inst200  (ENABLE_NOT_D0_AND_D1_AND_S_AND_SE, D1, _net_133, S, SE);
not inst201  (_net_134, D1);
not inst202  (_net_135, S);
and inst203  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE, _net_134, D0, _net_135, SE);
not inst204  (_net_136, D1);
and inst205  (ENABLE_D0_AND_NOT_D1_AND_S_AND_SE, _net_136, D0, S, SE);
not inst206  (_net_137, S);
and inst207  (ENABLE_D0_AND_D1_AND_NOT_S_AND_SE, D1, D0, _net_137, SE);
and inst208  (ENABLE_D0_AND_D1_AND_S_AND_SE, D1, D0, S, SE);

specify
if (D0==1'b0 && D1==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , posedge S &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , negedge S &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , posedge S &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , negedge S &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , posedge S &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , negedge S &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , posedge S &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , negedge S &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE , posedge SI &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE , negedge SI &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE , posedge SI &&& ENABLE_D0_AND_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE , negedge SI &&& ENABLE_D0_AND_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_FSDPMQ_V2Y2_2

//%BEGIN HDBSVT11_FSDPMQ_V2Y2_4

`celldefine
module HDBSVT11_FSDPMQ_V2Y2_4 (Q, CK, D0, D1, S, SI, SE);
   output Q;
   input CK, D0, D1, S, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D0, delayed_D1,
	delayed_S, delayed_SI, delayed_SE;

   wire int_res__D, int_res__S, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_S, S);
   buf inst4  (delayed_SI, SI);
   buf inst5  (delayed_SE, SE);
`endif

   snps_mux2 inst6  (int_res__D, delayed_D1, delayed_D0, delayed_S);
   snps_mux2 inst7  (int_res__S, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__S);

  `endif

   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst9 (Q, viol_0, delayed_CK, int_res__S, xcr_0);
   `else
      snps_dff inst10  (Q, viol_0, delayed_CK, int_res__S, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst11  (_net_0, D1);
not inst12  (_net_1, D0);
not inst13  (_net_2, S);
not inst14  (_net_3, SE);
not inst15  (_net_4, SI);
and inst16  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4);
not inst17  (_net_5, D1);
not inst18  (_net_6, D0);
not inst19  (_net_7, S);
not inst20  (_net_8, SE);
and inst21  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI, _net_5, _net_6, _net_7, _net_8, SI);
not inst22  (_net_9, D1);
not inst23  (_net_10, D0);
not inst24  (_net_11, S);
not inst25  (_net_12, SI);
and inst26  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI, _net_9, _net_10, _net_11, SE, _net_12);
not inst27  (_net_13, D1);
not inst28  (_net_14, D0);
not inst29  (_net_15, S);
and inst30  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI, _net_13, _net_14, _net_15, SE, SI);
not inst31  (_net_16, D1);
not inst32  (_net_17, D0);
not inst33  (_net_18, SE);
not inst34  (_net_19, SI);
and inst35  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI, _net_16, _net_17, S, _net_18, _net_19);
not inst36  (_net_20, D1);
not inst37  (_net_21, D0);
not inst38  (_net_22, SE);
and inst39  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI, _net_20, _net_21, S, _net_22, SI);
not inst40  (_net_23, D1);
not inst41  (_net_24, D0);
not inst42  (_net_25, SI);
and inst43  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI, _net_23, _net_24, S, SE, _net_25);
not inst44  (_net_26, D1);
not inst45  (_net_27, D0);
and inst46  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI, _net_26, _net_27, S, SE, SI);
not inst47  (_net_28, D0);
not inst48  (_net_29, S);
not inst49  (_net_30, SE);
not inst50  (_net_31, SI);
and inst51  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, D1, _net_28, _net_29, _net_30, _net_31);
not inst52  (_net_32, D0);
not inst53  (_net_33, S);
not inst54  (_net_34, SE);
and inst55  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI, D1, _net_32, _net_33, _net_34, SI);
not inst56  (_net_35, D0);
not inst57  (_net_36, S);
not inst58  (_net_37, SI);
and inst59  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI, D1, _net_35, _net_36, SE, _net_37);
not inst60  (_net_38, D0);
not inst61  (_net_39, S);
and inst62  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI, D1, _net_38, _net_39, SE, SI);
not inst63  (_net_40, D0);
not inst64  (_net_41, SE);
not inst65  (_net_42, SI);
and inst66  (ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI, D1, _net_40, S, _net_41, _net_42);
not inst67  (_net_43, D0);
not inst68  (_net_44, SE);
and inst69  (ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI, D1, _net_43, S, _net_44, SI);
not inst70  (_net_45, D0);
not inst71  (_net_46, SI);
and inst72  (ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI, D1, _net_45, S, SE, _net_46);
not inst73  (_net_47, D0);
and inst74  (ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_SI, D1, _net_47, S, SE, SI);
not inst75  (_net_48, D1);
not inst76  (_net_49, S);
not inst77  (_net_50, SE);
not inst78  (_net_51, SI);
and inst79  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_48, D0, _net_49, _net_50, _net_51);
not inst80  (_net_52, D1);
not inst81  (_net_53, S);
not inst82  (_net_54, SE);
and inst83  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI, _net_52, D0, _net_53, _net_54, SI);
not inst84  (_net_55, D1);
not inst85  (_net_56, S);
not inst86  (_net_57, SI);
and inst87  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI, _net_55, D0, _net_56, SE, _net_57);
not inst88  (_net_58, D1);
not inst89  (_net_59, S);
and inst90  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI, _net_58, D0, _net_59, SE, SI);
not inst91  (_net_60, D1);
not inst92  (_net_61, SE);
not inst93  (_net_62, SI);
and inst94  (ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI, _net_60, D0, S, _net_61, _net_62);
not inst95  (_net_63, D1);
not inst96  (_net_64, SE);
and inst97  (ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI, _net_63, D0, S, _net_64, SI);
not inst98  (_net_65, D1);
not inst99  (_net_66, SI);
and inst100  (ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI, _net_65, D0, S, SE, _net_66);
not inst101  (_net_67, D1);
and inst102  (ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI, _net_67, D0, S, SE, SI);
not inst103  (_net_68, S);
not inst104  (_net_69, SE);
not inst105  (_net_70, SI);
and inst106  (ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, D1, D0, _net_68, _net_69, _net_70);
not inst107  (_net_71, S);
not inst108  (_net_72, SE);
and inst109  (ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI, D1, D0, _net_71, _net_72, SI);
not inst110  (_net_73, S);
not inst111  (_net_74, SI);
and inst112  (ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI, D1, D0, _net_73, SE, _net_74);
not inst113  (_net_75, S);
and inst114  (ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI, D1, D0, _net_75, SE, SI);
not inst115  (_net_76, SE);
not inst116  (_net_77, SI);
and inst117  (ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI, D1, D0, S, _net_76, _net_77);
not inst118  (_net_78, SE);
and inst119  (ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI, D1, D0, S, _net_78, SI);
not inst120  (_net_79, SI);
and inst121  (ENABLE_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI, D1, D0, S, SE, _net_79);
and inst122  (ENABLE_D0_AND_D1_AND_S_AND_SE_AND_SI, D1, D0, S, SE, SI);
not inst123  (_net_80, S);
not inst124  (_net_81, D1);
not inst125  (_net_82, SE);
not inst126  (_net_83, SI);
and inst127  (ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_80, _net_81, _net_82, _net_83);
not inst128  (_net_84, S);
not inst129  (_net_85, D1);
not inst130  (_net_86, SE);
and inst131  (ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI, _net_84, _net_85, _net_86, SI);
not inst132  (_net_87, S);
not inst133  (_net_88, SE);
not inst134  (_net_89, SI);
and inst135  (ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_87, D1, _net_88, _net_89);
not inst136  (_net_90, S);
not inst137  (_net_91, SE);
and inst138  (ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_SI, _net_90, D1, _net_91, SI);
not inst139  (_net_92, D0);
not inst140  (_net_93, SE);
not inst141  (_net_94, SI);
and inst142  (ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_NOT_SI, S, _net_92, _net_93, _net_94);
not inst143  (_net_95, D0);
not inst144  (_net_96, SE);
and inst145  (ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_SI, S, _net_95, _net_96, SI);
not inst146  (_net_97, SE);
not inst147  (_net_98, SI);
and inst148  (ENABLE_D0_AND_S_AND_NOT_SE_AND_NOT_SI, S, D0, _net_97, _net_98);
not inst149  (_net_99, SE);
and inst150  (ENABLE_D0_AND_S_AND_NOT_SE_AND_SI, S, D0, _net_99, SI);
not inst151  (_net_100, D0);
not inst152  (_net_101, SE);
not inst153  (_net_102, SI);
and inst154  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D1, _net_100, _net_101, _net_102);
not inst155  (_net_103, D0);
not inst156  (_net_104, SE);
and inst157  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI, D1, _net_103, _net_104, SI);
not inst158  (_net_105, D1);
not inst159  (_net_106, SE);
not inst160  (_net_107, SI);
and inst161  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_105, D0, _net_106, _net_107);
not inst162  (_net_108, D1);
not inst163  (_net_109, SE);
and inst164  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_108, D0, _net_109, SI);
not inst165  (_net_110, D1);
not inst166  (_net_111, D0);
not inst167  (_net_112, S);
and inst168  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SI, _net_110, _net_111, _net_112, SI);
not inst169  (_net_113, D1);
not inst170  (_net_114, D0);
and inst171  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SI, _net_113, _net_114, S, SI);
not inst172  (_net_115, D0);
not inst173  (_net_116, S);
and inst174  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SI, D1, _net_115, _net_116, SI);
not inst175  (_net_117, D0);
not inst176  (_net_118, SI);
and inst177  (ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SI, D1, _net_117, S, _net_118);
not inst178  (_net_119, D1);
not inst179  (_net_120, S);
not inst180  (_net_121, SI);
and inst181  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SI, _net_119, D0, _net_120, _net_121);
not inst182  (_net_122, D1);
and inst183  (ENABLE_D0_AND_NOT_D1_AND_S_AND_SI, _net_122, D0, S, SI);
not inst184  (_net_123, S);
not inst185  (_net_124, SI);
and inst186  (ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SI, D1, D0, _net_123, _net_124);
not inst187  (_net_125, SI);
and inst188  (ENABLE_D0_AND_D1_AND_S_AND_NOT_SI, D1, D0, S, _net_125);
not inst189  (_net_126, D1);
not inst190  (_net_127, D0);
not inst191  (_net_128, S);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE, _net_126, _net_127, _net_128, SE);
not inst193  (_net_129, D1);
not inst194  (_net_130, D0);
and inst195  (ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE, _net_129, _net_130, S, SE);
not inst196  (_net_131, D0);
not inst197  (_net_132, S);
and inst198  (ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE, D1, _net_131, _net_132, SE);
not inst199  (_net_133, D0);
and inst200  (ENABLE_NOT_D0_AND_D1_AND_S_AND_SE, D1, _net_133, S, SE);
not inst201  (_net_134, D1);
not inst202  (_net_135, S);
and inst203  (ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE, _net_134, D0, _net_135, SE);
not inst204  (_net_136, D1);
and inst205  (ENABLE_D0_AND_NOT_D1_AND_S_AND_SE, _net_136, D0, S, SE);
not inst206  (_net_137, S);
and inst207  (ENABLE_D0_AND_D1_AND_NOT_S_AND_SE, D1, D0, _net_137, SE);
and inst208  (ENABLE_D0_AND_D1_AND_S_AND_SE, D1, D0, S, SE);

specify
if (D0==1'b0 && D1==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D0==1'b1 && D1==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_D1_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_D0_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_D0_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , posedge S &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , negedge S &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , posedge S &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , negedge S &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , posedge S &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , negedge S &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , posedge S &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , negedge S &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_S);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_D1_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_NOT_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_D0_AND_NOT_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE , posedge SI &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE , negedge SI &&& ENABLE_D0_AND_NOT_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_D0_AND_D1_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE , posedge SI &&& ENABLE_D0_AND_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_S_AND_SE , negedge SI &&& ENABLE_D0_AND_D1_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_FSDPMQ_V2Y2_4

//%BEGIN HDBSVT11_FSDPQBM2SS_V2Y4_1
`celldefine
module HDBSVT11_FSDPQBM2SS_V2Y4_1 (QN0, QN1, CK, D0, D1, SI, SE);
  input CK, D0, D1, SI, SE;
  output QN0, QN1;
  reg viol_0;
  wire int_0, int_1, iq1, iq0, d1_int, d0_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D0, D0);
    buf inst2  (delayed_D1, D1);
    buf inst3  (delayed_SI, SI);
    buf inst4  (delayed_SE, SE);
  `endif


    not inst5  (int_0, iq1);
    not inst6  (int_1, iq0);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst7  (xcr_6, delayed_CK, d1_int);

  `endif
    snps_dff inst8  (iq1, viol_0, delayed_CK, d1_int, xcr_6);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst9  (xcr_8, delayed_CK, d0_int);

  `endif
    snps_dff inst10  (iq0, viol_0, delayed_CK, d0_int, xcr_8);
    snps_mux2 inst11  (d1_int, iq0, delayed_D1, delayed_SE);
    snps_mux2 inst12  (d0_int, delayed_SI, delayed_D0, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst13 (QN1, int_0);
    buf #`SNPS_SEQ_DELAY  inst14 (QN0, int_1);
  `else
    buf inst15  (QN1, int_0);
    buf inst16  (QN0, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst17  (_net_0, D1);
not inst18  (_net_1, D0);
not inst19  (_net_2, SE);
not inst20  (_net_3, SI);
and inst21  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst22  (_net_4, D1);
not inst23  (_net_5, D0);
not inst24  (_net_6, SE);
and inst25  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst26  (_net_7, D1);
not inst27  (_net_8, D0);
not inst28  (_net_9, SI);
and inst29  (ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst30  (_net_10, D1);
not inst31  (_net_11, D0);
and inst32  (ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst33  (_net_12, D0);
not inst34  (_net_13, SE);
not inst35  (_net_14, SI);
and inst36  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D1, _net_12, _net_13, _net_14);
not inst37  (_net_15, D0);
not inst38  (_net_16, SE);
and inst39  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI, D1, _net_15, _net_16, SI);
not inst40  (_net_17, D0);
not inst41  (_net_18, SI);
and inst42  (ENABLE_NOT_D0_AND_D1_AND_SE_AND_NOT_SI, D1, _net_17, SE, _net_18);
not inst43  (_net_19, D0);
and inst44  (ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI, D1, _net_19, SE, SI);
not inst45  (_net_20, D1);
not inst46  (_net_21, SE);
not inst47  (_net_22, SI);
and inst48  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_20, D0, _net_21, _net_22);
not inst49  (_net_23, D1);
not inst50  (_net_24, SE);
and inst51  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_23, D0, _net_24, SI);
not inst52  (_net_25, D1);
not inst53  (_net_26, SI);
and inst54  (ENABLE_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, _net_25, D0, SE, _net_26);
not inst55  (_net_27, D1);
and inst56  (ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI, _net_27, D0, SE, SI);
not inst57  (_net_28, SE);
not inst58  (_net_29, SI);
and inst59  (ENABLE_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D1, D0, _net_28, _net_29);
not inst60  (_net_30, SE);
and inst61  (ENABLE_D0_AND_D1_AND_NOT_SE_AND_SI, D1, D0, _net_30, SI);
not inst62  (_net_31, SI);
and inst63  (ENABLE_D0_AND_D1_AND_SE_AND_NOT_SI, D1, D0, SE, _net_31);
and inst64  (ENABLE_D0_AND_D1_AND_SE_AND_SI, D1, D0, SE, SI);
not inst65  (_net_32, D1);
not inst66  (_net_33, D0);
and inst67  (ENABLE_NOT_D0_AND_NOT_D1_AND_SI, _net_32, _net_33, SI);
not inst68  (_net_34, D0);
not inst69  (_net_35, SI);
and inst70  (ENABLE_NOT_D0_AND_D1_AND_NOT_SI, D1, _net_34, _net_35);
not inst71  (_net_36, D1);
not inst72  (_net_37, SI);
and inst73  (ENABLE_D0_AND_NOT_D1_AND_NOT_SI, _net_36, D0, _net_37);
not inst74  (_net_38, D0);
and inst75  (ENABLE_NOT_D0_AND_SE, SE, _net_38);
and inst76  (ENABLE_D0_AND_SE, SE, D0);
not inst77  (_net_39, SI);
not inst78  (_net_40, SE);
and inst79  (ENABLE_NOT_SE_AND_NOT_SI, _net_39, _net_40);
not inst80  (_net_41, SE);
and inst81  (ENABLE_NOT_SE_AND_SI, SI, _net_41);

specify
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
(posedge CK => (QN0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
(posedge CK => (QN1 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK , 0 ,0, viol_0);
$width(negedge CK , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPQBM2SS_V2Y4_1

//%BEGIN HDBSVT11_FSDPQBM2SS_V2Y4_2
`celldefine
module HDBSVT11_FSDPQBM2SS_V2Y4_2 (QN0, QN1, CK, D0, D1, SI, SE);
  input CK, D0, D1, SI, SE;
  output QN0, QN1;
  reg viol_0;
  wire int_0, int_1, iq1, iq0, d1_int, d0_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D0, D0);
    buf inst2  (delayed_D1, D1);
    buf inst3  (delayed_SI, SI);
    buf inst4  (delayed_SE, SE);
  `endif


    not inst5  (int_0, iq1);
    not inst6  (int_1, iq0);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst7  (xcr_6, delayed_CK, d1_int);

  `endif
    snps_dff inst8  (iq1, viol_0, delayed_CK, d1_int, xcr_6);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst9  (xcr_8, delayed_CK, d0_int);

  `endif
    snps_dff inst10  (iq0, viol_0, delayed_CK, d0_int, xcr_8);
    snps_mux2 inst11  (d1_int, iq0, delayed_D1, delayed_SE);
    snps_mux2 inst12  (d0_int, delayed_SI, delayed_D0, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst13 (QN1, int_0);
    buf #`SNPS_SEQ_DELAY  inst14 (QN0, int_1);
  `else
    buf inst15  (QN1, int_0);
    buf inst16  (QN0, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst17  (_net_0, D1);
not inst18  (_net_1, D0);
not inst19  (_net_2, SE);
not inst20  (_net_3, SI);
and inst21  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst22  (_net_4, D1);
not inst23  (_net_5, D0);
not inst24  (_net_6, SE);
and inst25  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst26  (_net_7, D1);
not inst27  (_net_8, D0);
not inst28  (_net_9, SI);
and inst29  (ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst30  (_net_10, D1);
not inst31  (_net_11, D0);
and inst32  (ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst33  (_net_12, D0);
not inst34  (_net_13, SE);
not inst35  (_net_14, SI);
and inst36  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D1, _net_12, _net_13, _net_14);
not inst37  (_net_15, D0);
not inst38  (_net_16, SE);
and inst39  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI, D1, _net_15, _net_16, SI);
not inst40  (_net_17, D0);
not inst41  (_net_18, SI);
and inst42  (ENABLE_NOT_D0_AND_D1_AND_SE_AND_NOT_SI, D1, _net_17, SE, _net_18);
not inst43  (_net_19, D0);
and inst44  (ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI, D1, _net_19, SE, SI);
not inst45  (_net_20, D1);
not inst46  (_net_21, SE);
not inst47  (_net_22, SI);
and inst48  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_20, D0, _net_21, _net_22);
not inst49  (_net_23, D1);
not inst50  (_net_24, SE);
and inst51  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_23, D0, _net_24, SI);
not inst52  (_net_25, D1);
not inst53  (_net_26, SI);
and inst54  (ENABLE_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, _net_25, D0, SE, _net_26);
not inst55  (_net_27, D1);
and inst56  (ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI, _net_27, D0, SE, SI);
not inst57  (_net_28, SE);
not inst58  (_net_29, SI);
and inst59  (ENABLE_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D1, D0, _net_28, _net_29);
not inst60  (_net_30, SE);
and inst61  (ENABLE_D0_AND_D1_AND_NOT_SE_AND_SI, D1, D0, _net_30, SI);
not inst62  (_net_31, SI);
and inst63  (ENABLE_D0_AND_D1_AND_SE_AND_NOT_SI, D1, D0, SE, _net_31);
and inst64  (ENABLE_D0_AND_D1_AND_SE_AND_SI, D1, D0, SE, SI);
not inst65  (_net_32, D1);
not inst66  (_net_33, D0);
and inst67  (ENABLE_NOT_D0_AND_NOT_D1_AND_SI, _net_32, _net_33, SI);
not inst68  (_net_34, D0);
not inst69  (_net_35, SI);
and inst70  (ENABLE_NOT_D0_AND_D1_AND_NOT_SI, D1, _net_34, _net_35);
not inst71  (_net_36, D1);
not inst72  (_net_37, SI);
and inst73  (ENABLE_D0_AND_NOT_D1_AND_NOT_SI, _net_36, D0, _net_37);
not inst74  (_net_38, D0);
and inst75  (ENABLE_NOT_D0_AND_SE, SE, _net_38);
and inst76  (ENABLE_D0_AND_SE, SE, D0);
not inst77  (_net_39, SI);
not inst78  (_net_40, SE);
and inst79  (ENABLE_NOT_SE_AND_NOT_SI, _net_39, _net_40);
not inst80  (_net_41, SE);
and inst81  (ENABLE_NOT_SE_AND_SI, SI, _net_41);

specify
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
(posedge CK => (QN0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
(posedge CK => (QN1 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK , 0 ,0, viol_0);
$width(negedge CK , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPQBM2SS_V2Y4_2

//%BEGIN HDBSVT11_FSDPQBM4SS_LPV2Y8_1

`celldefine
module HDBSVT11_FSDPQBM4SS_LPV2Y8_1 (QN0, QN1, QN2, QN3, CK, D0, D1, D2, D3, SI, SE);
   output QN0, QN1, QN2, QN3;
   input CK, D0, D1, D2, D3, SI, SE;

   reg viol_0, viol_1, viol_2, viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
`endif

   snps_mux2 inst7  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst9  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst10  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst11  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst12  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst13  (int_res__D2, int_res_iq1, delayed_D2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst14  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst15  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst16  (int_res__D3, int_res_iq2, delayed_D3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst17  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst18  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst19 (QN0, int_res_iq0);
        not #`SNPS_SEQ_DELAY  inst20 (QN1, int_res_iq1);
        not #`SNPS_SEQ_DELAY  inst21 (QN2, int_res_iq2);
        not #`SNPS_SEQ_DELAY  inst22 (QN3, int_res_iq3);
   `else
        not inst23  (QN0, int_res_iq0);
        not inst24  (QN1, int_res_iq1);
        not inst25  (QN2, int_res_iq2);
        not inst26  (QN3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst27  (_net_0, D1);
not inst28  (_net_1, D0);
not inst29  (_net_2, D2);
not inst30  (_net_3, D3);
not inst31  (_net_4, SE);
not inst32  (_net_5, SI);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5);
not inst34  (_net_6, D1);
not inst35  (_net_7, D0);
not inst36  (_net_8, D2);
not inst37  (_net_9, D3);
not inst38  (_net_10, SE);
and inst39  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_6, _net_7, _net_8, _net_9, _net_10, SI);
not inst40  (_net_11, D1);
not inst41  (_net_12, D0);
not inst42  (_net_13, D2);
not inst43  (_net_14, D3);
not inst44  (_net_15, SI);
and inst45  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_11, _net_12, _net_13, _net_14, SE, _net_15);
not inst46  (_net_16, D1);
not inst47  (_net_17, D0);
not inst48  (_net_18, D2);
not inst49  (_net_19, D3);
and inst50  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_16, _net_17, _net_18, _net_19, SE, SI);
not inst51  (_net_20, D1);
not inst52  (_net_21, D0);
not inst53  (_net_22, D2);
not inst54  (_net_23, SE);
not inst55  (_net_24, SI);
and inst56  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22, D3, _net_23, _net_24);
not inst57  (_net_25, D1);
not inst58  (_net_26, D0);
not inst59  (_net_27, D2);
not inst60  (_net_28, SE);
and inst61  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_25, _net_26, _net_27, D3, _net_28, SI);
not inst62  (_net_29, D1);
not inst63  (_net_30, D0);
not inst64  (_net_31, D2);
not inst65  (_net_32, SI);
and inst66  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI, _net_29, _net_30, _net_31, D3, SE, _net_32);
not inst67  (_net_33, D1);
not inst68  (_net_34, D0);
not inst69  (_net_35, D2);
and inst70  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_33, _net_34, _net_35, D3, SE, SI);
not inst71  (_net_36, D1);
not inst72  (_net_37, D0);
not inst73  (_net_38, D3);
not inst74  (_net_39, SE);
not inst75  (_net_40, SI);
and inst76  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, D2, _net_38, _net_39, _net_40);
not inst77  (_net_41, D1);
not inst78  (_net_42, D0);
not inst79  (_net_43, D3);
not inst80  (_net_44, SE);
and inst81  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_41, _net_42, D2, _net_43, _net_44, SI);
not inst82  (_net_45, D1);
not inst83  (_net_46, D0);
not inst84  (_net_47, D3);
not inst85  (_net_48, SI);
and inst86  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_45, _net_46, D2, _net_47, SE, _net_48);
not inst87  (_net_49, D1);
not inst88  (_net_50, D0);
not inst89  (_net_51, D3);
and inst90  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_49, _net_50, D2, _net_51, SE, SI);
not inst91  (_net_52, D1);
not inst92  (_net_53, D0);
not inst93  (_net_54, SE);
not inst94  (_net_55, SI);
and inst95  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_52, _net_53, D2, D3, _net_54, _net_55);
not inst96  (_net_56, D1);
not inst97  (_net_57, D0);
not inst98  (_net_58, SE);
and inst99  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_56, _net_57, D2, D3, _net_58, SI);
not inst100  (_net_59, D1);
not inst101  (_net_60, D0);
not inst102  (_net_61, SI);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_59, _net_60, D2, D3, SE, _net_61);
not inst104  (_net_62, D1);
not inst105  (_net_63, D0);
and inst106  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_62, _net_63, D2, D3, SE, SI);
not inst107  (_net_64, D0);
not inst108  (_net_65, D2);
not inst109  (_net_66, D3);
not inst110  (_net_67, SE);
not inst111  (_net_68, SI);
and inst112  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_64, _net_65, _net_66, _net_67, _net_68);
not inst113  (_net_69, D0);
not inst114  (_net_70, D2);
not inst115  (_net_71, D3);
not inst116  (_net_72, SE);
and inst117  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_69, _net_70, _net_71, _net_72, SI);
not inst118  (_net_73, D0);
not inst119  (_net_74, D2);
not inst120  (_net_75, D3);
not inst121  (_net_76, SI);
and inst122  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D1, _net_73, _net_74, _net_75, SE, _net_76);
not inst123  (_net_77, D0);
not inst124  (_net_78, D2);
not inst125  (_net_79, D3);
and inst126  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D1, _net_77, _net_78, _net_79, SE, SI);
not inst127  (_net_80, D1);
not inst128  (_net_81, D2);
not inst129  (_net_82, D3);
not inst130  (_net_83, SE);
not inst131  (_net_84, SI);
and inst132  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_80, D0, _net_81, _net_82, _net_83, _net_84);
not inst133  (_net_85, D1);
not inst134  (_net_86, D2);
not inst135  (_net_87, D3);
not inst136  (_net_88, SE);
and inst137  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_85, D0, _net_86, _net_87, _net_88, SI);
not inst138  (_net_89, D1);
not inst139  (_net_90, D2);
not inst140  (_net_91, D3);
not inst141  (_net_92, SI);
and inst142  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_89, D0, _net_90, _net_91, SE, _net_92);
not inst143  (_net_93, D1);
not inst144  (_net_94, D2);
not inst145  (_net_95, D3);
and inst146  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_93, D0, _net_94, _net_95, SE, SI);
not inst147  (_net_96, D1);
not inst148  (_net_97, D3);
not inst149  (_net_98, SE);
not inst150  (_net_99, SI);
and inst151  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_96, D0, D2, _net_97, _net_98, _net_99);
not inst152  (_net_100, D1);
not inst153  (_net_101, D3);
not inst154  (_net_102, SE);
and inst155  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_100, D0, D2, _net_101, _net_102, SI);
not inst156  (_net_103, D1);
not inst157  (_net_104, D3);
not inst158  (_net_105, SI);
and inst159  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_103, D0, D2, _net_104, SE, _net_105);
not inst160  (_net_106, D1);
not inst161  (_net_107, D3);
and inst162  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_106, D0, D2, _net_107, SE, SI);
not inst163  (_net_108, D1);
not inst164  (_net_109, SE);
not inst165  (_net_110, SI);
and inst166  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_108, D0, D2, D3, _net_109, _net_110);
not inst167  (_net_111, D1);
not inst168  (_net_112, SE);
and inst169  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_111, D0, D2, D3, _net_112, SI);
not inst170  (_net_113, D1);
not inst171  (_net_114, SI);
and inst172  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_113, D0, D2, D3, SE, _net_114);
not inst173  (_net_115, D1);
and inst174  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_115, D0, D2, D3, SE, SI);
not inst175  (_net_116, SE);
not inst176  (_net_117, SI);
and inst177  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, _net_116, _net_117);
not inst178  (_net_118, SE);
and inst179  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D1, D0, D2, D3, _net_118, SI);
not inst180  (_net_119, SI);
and inst181  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D1, D0, D2, D3, SE, _net_119);
and inst182  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI, D1, D0, D2, D3, SE, SI);
not inst183  (_net_120, D1);
not inst184  (_net_121, D0);
not inst185  (_net_122, D2);
not inst186  (_net_123, D3);
and inst187  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI, _net_120, _net_121, _net_122, _net_123, SI);
not inst188  (_net_124, D1);
not inst189  (_net_125, D0);
not inst190  (_net_126, D2);
not inst191  (_net_127, SI);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI, _net_124, _net_125, _net_126, D3, _net_127);
not inst193  (_net_128, D1);
not inst194  (_net_129, D0);
not inst195  (_net_130, D3);
not inst196  (_net_131, SI);
and inst197  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI, _net_128, _net_129, D2, _net_130, _net_131);
not inst198  (_net_132, D0);
not inst199  (_net_133, D2);
not inst200  (_net_134, D3);
not inst201  (_net_135, SI);
and inst202  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, D1, _net_132, _net_133, _net_134, _net_135);
not inst203  (_net_136, D1);
not inst204  (_net_137, D2);
not inst205  (_net_138, D3);
not inst206  (_net_139, SI);
and inst207  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, _net_136, D0, _net_137, _net_138, _net_139);
not inst208  (_net_140, D0);
and inst209  (ENABLE_NOT_D0_AND_SE, SE, _net_140);
and inst210  (ENABLE_D0_AND_SE, SE, D0);
not inst211  (_net_141, SI);
not inst212  (_net_142, SE);
and inst213  (ENABLE_NOT_SE_AND_NOT_SI, _net_141, _net_142);
not inst214  (_net_143, SE);
and inst215  (ENABLE_NOT_SE_AND_SI, SI, _net_143);

specify
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
(posedge CK => (QN0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
(posedge CK => (QN1 : 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN2 +: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN2 +: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN2 +: 1'b1))=(0, 0);
(posedge CK => (QN2 : 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN3 +: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN3 +: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN3 +: 1'b1))=(0, 0);
(posedge CK => (QN3 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK , 0 ,0, viol_0);
$width(negedge CK , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQBM4SS_LPV2Y8_1

//%BEGIN HDBSVT11_FSDPQBM4SS_LPV2Y8_2

`celldefine
module HDBSVT11_FSDPQBM4SS_LPV2Y8_2 (QN0, QN1, QN2, QN3, CK, D0, D1, D2, D3, SI, SE);
   output QN0, QN1, QN2, QN3;
   input CK, D0, D1, D2, D3, SI, SE;

   reg viol_0, viol_1, viol_2, viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
`endif

   snps_mux2 inst7  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst9  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst10  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst11  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst12  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst13  (int_res__D2, int_res_iq1, delayed_D2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst14  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst15  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst16  (int_res__D3, int_res_iq2, delayed_D3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst17  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst18  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst19 (QN0, int_res_iq0);
        not #`SNPS_SEQ_DELAY  inst20 (QN1, int_res_iq1);
        not #`SNPS_SEQ_DELAY  inst21 (QN2, int_res_iq2);
        not #`SNPS_SEQ_DELAY  inst22 (QN3, int_res_iq3);
   `else
        not inst23  (QN0, int_res_iq0);
        not inst24  (QN1, int_res_iq1);
        not inst25  (QN2, int_res_iq2);
        not inst26  (QN3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst27  (_net_0, D1);
not inst28  (_net_1, D0);
not inst29  (_net_2, D2);
not inst30  (_net_3, D3);
not inst31  (_net_4, SE);
not inst32  (_net_5, SI);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5);
not inst34  (_net_6, D1);
not inst35  (_net_7, D0);
not inst36  (_net_8, D2);
not inst37  (_net_9, D3);
not inst38  (_net_10, SE);
and inst39  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_6, _net_7, _net_8, _net_9, _net_10, SI);
not inst40  (_net_11, D1);
not inst41  (_net_12, D0);
not inst42  (_net_13, D2);
not inst43  (_net_14, D3);
not inst44  (_net_15, SI);
and inst45  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_11, _net_12, _net_13, _net_14, SE, _net_15);
not inst46  (_net_16, D1);
not inst47  (_net_17, D0);
not inst48  (_net_18, D2);
not inst49  (_net_19, D3);
and inst50  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_16, _net_17, _net_18, _net_19, SE, SI);
not inst51  (_net_20, D1);
not inst52  (_net_21, D0);
not inst53  (_net_22, D2);
not inst54  (_net_23, SE);
not inst55  (_net_24, SI);
and inst56  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22, D3, _net_23, _net_24);
not inst57  (_net_25, D1);
not inst58  (_net_26, D0);
not inst59  (_net_27, D2);
not inst60  (_net_28, SE);
and inst61  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_25, _net_26, _net_27, D3, _net_28, SI);
not inst62  (_net_29, D1);
not inst63  (_net_30, D0);
not inst64  (_net_31, D2);
not inst65  (_net_32, SI);
and inst66  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI, _net_29, _net_30, _net_31, D3, SE, _net_32);
not inst67  (_net_33, D1);
not inst68  (_net_34, D0);
not inst69  (_net_35, D2);
and inst70  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_33, _net_34, _net_35, D3, SE, SI);
not inst71  (_net_36, D1);
not inst72  (_net_37, D0);
not inst73  (_net_38, D3);
not inst74  (_net_39, SE);
not inst75  (_net_40, SI);
and inst76  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, D2, _net_38, _net_39, _net_40);
not inst77  (_net_41, D1);
not inst78  (_net_42, D0);
not inst79  (_net_43, D3);
not inst80  (_net_44, SE);
and inst81  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_41, _net_42, D2, _net_43, _net_44, SI);
not inst82  (_net_45, D1);
not inst83  (_net_46, D0);
not inst84  (_net_47, D3);
not inst85  (_net_48, SI);
and inst86  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_45, _net_46, D2, _net_47, SE, _net_48);
not inst87  (_net_49, D1);
not inst88  (_net_50, D0);
not inst89  (_net_51, D3);
and inst90  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_49, _net_50, D2, _net_51, SE, SI);
not inst91  (_net_52, D1);
not inst92  (_net_53, D0);
not inst93  (_net_54, SE);
not inst94  (_net_55, SI);
and inst95  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_52, _net_53, D2, D3, _net_54, _net_55);
not inst96  (_net_56, D1);
not inst97  (_net_57, D0);
not inst98  (_net_58, SE);
and inst99  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_56, _net_57, D2, D3, _net_58, SI);
not inst100  (_net_59, D1);
not inst101  (_net_60, D0);
not inst102  (_net_61, SI);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_59, _net_60, D2, D3, SE, _net_61);
not inst104  (_net_62, D1);
not inst105  (_net_63, D0);
and inst106  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_62, _net_63, D2, D3, SE, SI);
not inst107  (_net_64, D0);
not inst108  (_net_65, D2);
not inst109  (_net_66, D3);
not inst110  (_net_67, SE);
not inst111  (_net_68, SI);
and inst112  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_64, _net_65, _net_66, _net_67, _net_68);
not inst113  (_net_69, D0);
not inst114  (_net_70, D2);
not inst115  (_net_71, D3);
not inst116  (_net_72, SE);
and inst117  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_69, _net_70, _net_71, _net_72, SI);
not inst118  (_net_73, D0);
not inst119  (_net_74, D2);
not inst120  (_net_75, D3);
not inst121  (_net_76, SI);
and inst122  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D1, _net_73, _net_74, _net_75, SE, _net_76);
not inst123  (_net_77, D0);
not inst124  (_net_78, D2);
not inst125  (_net_79, D3);
and inst126  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D1, _net_77, _net_78, _net_79, SE, SI);
not inst127  (_net_80, D1);
not inst128  (_net_81, D2);
not inst129  (_net_82, D3);
not inst130  (_net_83, SE);
not inst131  (_net_84, SI);
and inst132  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_80, D0, _net_81, _net_82, _net_83, _net_84);
not inst133  (_net_85, D1);
not inst134  (_net_86, D2);
not inst135  (_net_87, D3);
not inst136  (_net_88, SE);
and inst137  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_85, D0, _net_86, _net_87, _net_88, SI);
not inst138  (_net_89, D1);
not inst139  (_net_90, D2);
not inst140  (_net_91, D3);
not inst141  (_net_92, SI);
and inst142  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_89, D0, _net_90, _net_91, SE, _net_92);
not inst143  (_net_93, D1);
not inst144  (_net_94, D2);
not inst145  (_net_95, D3);
and inst146  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_93, D0, _net_94, _net_95, SE, SI);
not inst147  (_net_96, D1);
not inst148  (_net_97, D3);
not inst149  (_net_98, SE);
not inst150  (_net_99, SI);
and inst151  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_96, D0, D2, _net_97, _net_98, _net_99);
not inst152  (_net_100, D1);
not inst153  (_net_101, D3);
not inst154  (_net_102, SE);
and inst155  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_100, D0, D2, _net_101, _net_102, SI);
not inst156  (_net_103, D1);
not inst157  (_net_104, D3);
not inst158  (_net_105, SI);
and inst159  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_103, D0, D2, _net_104, SE, _net_105);
not inst160  (_net_106, D1);
not inst161  (_net_107, D3);
and inst162  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_106, D0, D2, _net_107, SE, SI);
not inst163  (_net_108, D1);
not inst164  (_net_109, SE);
not inst165  (_net_110, SI);
and inst166  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_108, D0, D2, D3, _net_109, _net_110);
not inst167  (_net_111, D1);
not inst168  (_net_112, SE);
and inst169  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_111, D0, D2, D3, _net_112, SI);
not inst170  (_net_113, D1);
not inst171  (_net_114, SI);
and inst172  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_113, D0, D2, D3, SE, _net_114);
not inst173  (_net_115, D1);
and inst174  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_115, D0, D2, D3, SE, SI);
not inst175  (_net_116, SE);
not inst176  (_net_117, SI);
and inst177  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, _net_116, _net_117);
not inst178  (_net_118, SE);
and inst179  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D1, D0, D2, D3, _net_118, SI);
not inst180  (_net_119, SI);
and inst181  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D1, D0, D2, D3, SE, _net_119);
and inst182  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI, D1, D0, D2, D3, SE, SI);
not inst183  (_net_120, D1);
not inst184  (_net_121, D0);
not inst185  (_net_122, D2);
not inst186  (_net_123, D3);
and inst187  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI, _net_120, _net_121, _net_122, _net_123, SI);
not inst188  (_net_124, D1);
not inst189  (_net_125, D0);
not inst190  (_net_126, D2);
not inst191  (_net_127, SI);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI, _net_124, _net_125, _net_126, D3, _net_127);
not inst193  (_net_128, D1);
not inst194  (_net_129, D0);
not inst195  (_net_130, D3);
not inst196  (_net_131, SI);
and inst197  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI, _net_128, _net_129, D2, _net_130, _net_131);
not inst198  (_net_132, D0);
not inst199  (_net_133, D2);
not inst200  (_net_134, D3);
not inst201  (_net_135, SI);
and inst202  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, D1, _net_132, _net_133, _net_134, _net_135);
not inst203  (_net_136, D1);
not inst204  (_net_137, D2);
not inst205  (_net_138, D3);
not inst206  (_net_139, SI);
and inst207  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, _net_136, D0, _net_137, _net_138, _net_139);
not inst208  (_net_140, D0);
and inst209  (ENABLE_NOT_D0_AND_SE, SE, _net_140);
and inst210  (ENABLE_D0_AND_SE, SE, D0);
not inst211  (_net_141, SI);
not inst212  (_net_142, SE);
and inst213  (ENABLE_NOT_SE_AND_NOT_SI, _net_141, _net_142);
not inst214  (_net_143, SE);
and inst215  (ENABLE_NOT_SE_AND_SI, SI, _net_143);

specify
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
(posedge CK => (QN0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
(posedge CK => (QN1 : 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN2 +: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN2 +: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN2 +: 1'b1))=(0, 0);
(posedge CK => (QN2 : 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN3 +: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN3 +: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN3 +: 1'b1))=(0, 0);
(posedge CK => (QN3 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK , 0 ,0, viol_0);
$width(negedge CK , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQBM4SS_LPV2Y8_2

//%BEGIN HDBSVT11_FSDPQBM4SS_V2Y8_1

`celldefine
module HDBSVT11_FSDPQBM4SS_V2Y8_1 (QN0, QN1, QN2, QN3, CK, D0, D1, D2, D3, SI, SE);
   output QN0, QN1, QN2, QN3;
   input CK, D0, D1, D2, D3, SI, SE;

   reg viol_0, viol_1, viol_2, viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
`endif

   snps_mux2 inst7  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst9  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst10  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst11  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst12  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst13  (int_res__D2, int_res_iq1, delayed_D2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst14  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst15  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst16  (int_res__D3, int_res_iq2, delayed_D3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst17  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst18  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst19 (QN0, int_res_iq0);
        not #`SNPS_SEQ_DELAY  inst20 (QN1, int_res_iq1);
        not #`SNPS_SEQ_DELAY  inst21 (QN2, int_res_iq2);
        not #`SNPS_SEQ_DELAY  inst22 (QN3, int_res_iq3);
   `else
        not inst23  (QN0, int_res_iq0);
        not inst24  (QN1, int_res_iq1);
        not inst25  (QN2, int_res_iq2);
        not inst26  (QN3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst27  (_net_0, D1);
not inst28  (_net_1, D0);
not inst29  (_net_2, D2);
not inst30  (_net_3, D3);
not inst31  (_net_4, SE);
not inst32  (_net_5, SI);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5);
not inst34  (_net_6, D1);
not inst35  (_net_7, D0);
not inst36  (_net_8, D2);
not inst37  (_net_9, D3);
not inst38  (_net_10, SE);
and inst39  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_6, _net_7, _net_8, _net_9, _net_10, SI);
not inst40  (_net_11, D1);
not inst41  (_net_12, D0);
not inst42  (_net_13, D2);
not inst43  (_net_14, D3);
not inst44  (_net_15, SI);
and inst45  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_11, _net_12, _net_13, _net_14, SE, _net_15);
not inst46  (_net_16, D1);
not inst47  (_net_17, D0);
not inst48  (_net_18, D2);
not inst49  (_net_19, D3);
and inst50  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_16, _net_17, _net_18, _net_19, SE, SI);
not inst51  (_net_20, D1);
not inst52  (_net_21, D0);
not inst53  (_net_22, D2);
not inst54  (_net_23, SE);
not inst55  (_net_24, SI);
and inst56  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22, D3, _net_23, _net_24);
not inst57  (_net_25, D1);
not inst58  (_net_26, D0);
not inst59  (_net_27, D2);
not inst60  (_net_28, SE);
and inst61  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_25, _net_26, _net_27, D3, _net_28, SI);
not inst62  (_net_29, D1);
not inst63  (_net_30, D0);
not inst64  (_net_31, D2);
not inst65  (_net_32, SI);
and inst66  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI, _net_29, _net_30, _net_31, D3, SE, _net_32);
not inst67  (_net_33, D1);
not inst68  (_net_34, D0);
not inst69  (_net_35, D2);
and inst70  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_33, _net_34, _net_35, D3, SE, SI);
not inst71  (_net_36, D1);
not inst72  (_net_37, D0);
not inst73  (_net_38, D3);
not inst74  (_net_39, SE);
not inst75  (_net_40, SI);
and inst76  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, D2, _net_38, _net_39, _net_40);
not inst77  (_net_41, D1);
not inst78  (_net_42, D0);
not inst79  (_net_43, D3);
not inst80  (_net_44, SE);
and inst81  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_41, _net_42, D2, _net_43, _net_44, SI);
not inst82  (_net_45, D1);
not inst83  (_net_46, D0);
not inst84  (_net_47, D3);
not inst85  (_net_48, SI);
and inst86  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_45, _net_46, D2, _net_47, SE, _net_48);
not inst87  (_net_49, D1);
not inst88  (_net_50, D0);
not inst89  (_net_51, D3);
and inst90  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_49, _net_50, D2, _net_51, SE, SI);
not inst91  (_net_52, D1);
not inst92  (_net_53, D0);
not inst93  (_net_54, SE);
not inst94  (_net_55, SI);
and inst95  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_52, _net_53, D2, D3, _net_54, _net_55);
not inst96  (_net_56, D1);
not inst97  (_net_57, D0);
not inst98  (_net_58, SE);
and inst99  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_56, _net_57, D2, D3, _net_58, SI);
not inst100  (_net_59, D1);
not inst101  (_net_60, D0);
not inst102  (_net_61, SI);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_59, _net_60, D2, D3, SE, _net_61);
not inst104  (_net_62, D1);
not inst105  (_net_63, D0);
and inst106  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_62, _net_63, D2, D3, SE, SI);
not inst107  (_net_64, D0);
not inst108  (_net_65, D2);
not inst109  (_net_66, D3);
not inst110  (_net_67, SE);
not inst111  (_net_68, SI);
and inst112  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_64, _net_65, _net_66, _net_67, _net_68);
not inst113  (_net_69, D0);
not inst114  (_net_70, D2);
not inst115  (_net_71, D3);
not inst116  (_net_72, SE);
and inst117  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_69, _net_70, _net_71, _net_72, SI);
not inst118  (_net_73, D0);
not inst119  (_net_74, D2);
not inst120  (_net_75, D3);
not inst121  (_net_76, SI);
and inst122  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D1, _net_73, _net_74, _net_75, SE, _net_76);
not inst123  (_net_77, D0);
not inst124  (_net_78, D2);
not inst125  (_net_79, D3);
and inst126  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D1, _net_77, _net_78, _net_79, SE, SI);
not inst127  (_net_80, D1);
not inst128  (_net_81, D2);
not inst129  (_net_82, D3);
not inst130  (_net_83, SE);
not inst131  (_net_84, SI);
and inst132  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_80, D0, _net_81, _net_82, _net_83, _net_84);
not inst133  (_net_85, D1);
not inst134  (_net_86, D2);
not inst135  (_net_87, D3);
not inst136  (_net_88, SE);
and inst137  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_85, D0, _net_86, _net_87, _net_88, SI);
not inst138  (_net_89, D1);
not inst139  (_net_90, D2);
not inst140  (_net_91, D3);
not inst141  (_net_92, SI);
and inst142  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_89, D0, _net_90, _net_91, SE, _net_92);
not inst143  (_net_93, D1);
not inst144  (_net_94, D2);
not inst145  (_net_95, D3);
and inst146  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_93, D0, _net_94, _net_95, SE, SI);
not inst147  (_net_96, D1);
not inst148  (_net_97, D3);
not inst149  (_net_98, SE);
not inst150  (_net_99, SI);
and inst151  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_96, D0, D2, _net_97, _net_98, _net_99);
not inst152  (_net_100, D1);
not inst153  (_net_101, D3);
not inst154  (_net_102, SE);
and inst155  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_100, D0, D2, _net_101, _net_102, SI);
not inst156  (_net_103, D1);
not inst157  (_net_104, D3);
not inst158  (_net_105, SI);
and inst159  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_103, D0, D2, _net_104, SE, _net_105);
not inst160  (_net_106, D1);
not inst161  (_net_107, D3);
and inst162  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_106, D0, D2, _net_107, SE, SI);
not inst163  (_net_108, D1);
not inst164  (_net_109, SE);
not inst165  (_net_110, SI);
and inst166  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_108, D0, D2, D3, _net_109, _net_110);
not inst167  (_net_111, D1);
not inst168  (_net_112, SE);
and inst169  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_111, D0, D2, D3, _net_112, SI);
not inst170  (_net_113, D1);
not inst171  (_net_114, SI);
and inst172  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_113, D0, D2, D3, SE, _net_114);
not inst173  (_net_115, D1);
and inst174  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_115, D0, D2, D3, SE, SI);
not inst175  (_net_116, SE);
not inst176  (_net_117, SI);
and inst177  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, _net_116, _net_117);
not inst178  (_net_118, SE);
and inst179  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D1, D0, D2, D3, _net_118, SI);
not inst180  (_net_119, SI);
and inst181  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D1, D0, D2, D3, SE, _net_119);
and inst182  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI, D1, D0, D2, D3, SE, SI);
not inst183  (_net_120, D1);
not inst184  (_net_121, D0);
not inst185  (_net_122, D2);
not inst186  (_net_123, D3);
and inst187  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI, _net_120, _net_121, _net_122, _net_123, SI);
not inst188  (_net_124, D1);
not inst189  (_net_125, D0);
not inst190  (_net_126, D2);
not inst191  (_net_127, SI);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI, _net_124, _net_125, _net_126, D3, _net_127);
not inst193  (_net_128, D1);
not inst194  (_net_129, D0);
not inst195  (_net_130, D3);
not inst196  (_net_131, SI);
and inst197  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI, _net_128, _net_129, D2, _net_130, _net_131);
not inst198  (_net_132, D0);
not inst199  (_net_133, D2);
not inst200  (_net_134, D3);
not inst201  (_net_135, SI);
and inst202  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, D1, _net_132, _net_133, _net_134, _net_135);
not inst203  (_net_136, D1);
not inst204  (_net_137, D2);
not inst205  (_net_138, D3);
not inst206  (_net_139, SI);
and inst207  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, _net_136, D0, _net_137, _net_138, _net_139);
not inst208  (_net_140, D0);
and inst209  (ENABLE_NOT_D0_AND_SE, SE, _net_140);
and inst210  (ENABLE_D0_AND_SE, SE, D0);
not inst211  (_net_141, SI);
not inst212  (_net_142, SE);
and inst213  (ENABLE_NOT_SE_AND_NOT_SI, _net_141, _net_142);
not inst214  (_net_143, SE);
and inst215  (ENABLE_NOT_SE_AND_SI, SI, _net_143);

specify
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
(posedge CK => (QN0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
(posedge CK => (QN1 : 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN2 +: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN2 +: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN2 +: 1'b1))=(0, 0);
(posedge CK => (QN2 : 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN3 +: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN3 +: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN3 +: 1'b1))=(0, 0);
(posedge CK => (QN3 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK , 0 ,0, viol_0);
$width(negedge CK , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQBM4SS_V2Y8_1

//%BEGIN HDBSVT11_FSDPQBM4SS_V2Y8_2

`celldefine
module HDBSVT11_FSDPQBM4SS_V2Y8_2 (QN0, QN1, QN2, QN3, CK, D0, D1, D2, D3, SI, SE);
   output QN0, QN1, QN2, QN3;
   input CK, D0, D1, D2, D3, SI, SE;

   reg viol_0, viol_1, viol_2, viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
`endif

   snps_mux2 inst7  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst9  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst10  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst11  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst12  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst13  (int_res__D2, int_res_iq1, delayed_D2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst14  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst15  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst16  (int_res__D3, int_res_iq2, delayed_D3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst17  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst18  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst19 (QN0, int_res_iq0);
        not #`SNPS_SEQ_DELAY  inst20 (QN1, int_res_iq1);
        not #`SNPS_SEQ_DELAY  inst21 (QN2, int_res_iq2);
        not #`SNPS_SEQ_DELAY  inst22 (QN3, int_res_iq3);
   `else
        not inst23  (QN0, int_res_iq0);
        not inst24  (QN1, int_res_iq1);
        not inst25  (QN2, int_res_iq2);
        not inst26  (QN3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst27  (_net_0, D1);
not inst28  (_net_1, D0);
not inst29  (_net_2, D2);
not inst30  (_net_3, D3);
not inst31  (_net_4, SE);
not inst32  (_net_5, SI);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5);
not inst34  (_net_6, D1);
not inst35  (_net_7, D0);
not inst36  (_net_8, D2);
not inst37  (_net_9, D3);
not inst38  (_net_10, SE);
and inst39  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_6, _net_7, _net_8, _net_9, _net_10, SI);
not inst40  (_net_11, D1);
not inst41  (_net_12, D0);
not inst42  (_net_13, D2);
not inst43  (_net_14, D3);
not inst44  (_net_15, SI);
and inst45  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_11, _net_12, _net_13, _net_14, SE, _net_15);
not inst46  (_net_16, D1);
not inst47  (_net_17, D0);
not inst48  (_net_18, D2);
not inst49  (_net_19, D3);
and inst50  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_16, _net_17, _net_18, _net_19, SE, SI);
not inst51  (_net_20, D1);
not inst52  (_net_21, D0);
not inst53  (_net_22, D2);
not inst54  (_net_23, SE);
not inst55  (_net_24, SI);
and inst56  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22, D3, _net_23, _net_24);
not inst57  (_net_25, D1);
not inst58  (_net_26, D0);
not inst59  (_net_27, D2);
not inst60  (_net_28, SE);
and inst61  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_25, _net_26, _net_27, D3, _net_28, SI);
not inst62  (_net_29, D1);
not inst63  (_net_30, D0);
not inst64  (_net_31, D2);
not inst65  (_net_32, SI);
and inst66  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI, _net_29, _net_30, _net_31, D3, SE, _net_32);
not inst67  (_net_33, D1);
not inst68  (_net_34, D0);
not inst69  (_net_35, D2);
and inst70  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_33, _net_34, _net_35, D3, SE, SI);
not inst71  (_net_36, D1);
not inst72  (_net_37, D0);
not inst73  (_net_38, D3);
not inst74  (_net_39, SE);
not inst75  (_net_40, SI);
and inst76  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, D2, _net_38, _net_39, _net_40);
not inst77  (_net_41, D1);
not inst78  (_net_42, D0);
not inst79  (_net_43, D3);
not inst80  (_net_44, SE);
and inst81  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_41, _net_42, D2, _net_43, _net_44, SI);
not inst82  (_net_45, D1);
not inst83  (_net_46, D0);
not inst84  (_net_47, D3);
not inst85  (_net_48, SI);
and inst86  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_45, _net_46, D2, _net_47, SE, _net_48);
not inst87  (_net_49, D1);
not inst88  (_net_50, D0);
not inst89  (_net_51, D3);
and inst90  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_49, _net_50, D2, _net_51, SE, SI);
not inst91  (_net_52, D1);
not inst92  (_net_53, D0);
not inst93  (_net_54, SE);
not inst94  (_net_55, SI);
and inst95  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_52, _net_53, D2, D3, _net_54, _net_55);
not inst96  (_net_56, D1);
not inst97  (_net_57, D0);
not inst98  (_net_58, SE);
and inst99  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_56, _net_57, D2, D3, _net_58, SI);
not inst100  (_net_59, D1);
not inst101  (_net_60, D0);
not inst102  (_net_61, SI);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_59, _net_60, D2, D3, SE, _net_61);
not inst104  (_net_62, D1);
not inst105  (_net_63, D0);
and inst106  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_62, _net_63, D2, D3, SE, SI);
not inst107  (_net_64, D0);
not inst108  (_net_65, D2);
not inst109  (_net_66, D3);
not inst110  (_net_67, SE);
not inst111  (_net_68, SI);
and inst112  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_64, _net_65, _net_66, _net_67, _net_68);
not inst113  (_net_69, D0);
not inst114  (_net_70, D2);
not inst115  (_net_71, D3);
not inst116  (_net_72, SE);
and inst117  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_69, _net_70, _net_71, _net_72, SI);
not inst118  (_net_73, D0);
not inst119  (_net_74, D2);
not inst120  (_net_75, D3);
not inst121  (_net_76, SI);
and inst122  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D1, _net_73, _net_74, _net_75, SE, _net_76);
not inst123  (_net_77, D0);
not inst124  (_net_78, D2);
not inst125  (_net_79, D3);
and inst126  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D1, _net_77, _net_78, _net_79, SE, SI);
not inst127  (_net_80, D1);
not inst128  (_net_81, D2);
not inst129  (_net_82, D3);
not inst130  (_net_83, SE);
not inst131  (_net_84, SI);
and inst132  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_80, D0, _net_81, _net_82, _net_83, _net_84);
not inst133  (_net_85, D1);
not inst134  (_net_86, D2);
not inst135  (_net_87, D3);
not inst136  (_net_88, SE);
and inst137  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_85, D0, _net_86, _net_87, _net_88, SI);
not inst138  (_net_89, D1);
not inst139  (_net_90, D2);
not inst140  (_net_91, D3);
not inst141  (_net_92, SI);
and inst142  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_89, D0, _net_90, _net_91, SE, _net_92);
not inst143  (_net_93, D1);
not inst144  (_net_94, D2);
not inst145  (_net_95, D3);
and inst146  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_93, D0, _net_94, _net_95, SE, SI);
not inst147  (_net_96, D1);
not inst148  (_net_97, D3);
not inst149  (_net_98, SE);
not inst150  (_net_99, SI);
and inst151  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_96, D0, D2, _net_97, _net_98, _net_99);
not inst152  (_net_100, D1);
not inst153  (_net_101, D3);
not inst154  (_net_102, SE);
and inst155  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_100, D0, D2, _net_101, _net_102, SI);
not inst156  (_net_103, D1);
not inst157  (_net_104, D3);
not inst158  (_net_105, SI);
and inst159  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_103, D0, D2, _net_104, SE, _net_105);
not inst160  (_net_106, D1);
not inst161  (_net_107, D3);
and inst162  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_106, D0, D2, _net_107, SE, SI);
not inst163  (_net_108, D1);
not inst164  (_net_109, SE);
not inst165  (_net_110, SI);
and inst166  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_108, D0, D2, D3, _net_109, _net_110);
not inst167  (_net_111, D1);
not inst168  (_net_112, SE);
and inst169  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_111, D0, D2, D3, _net_112, SI);
not inst170  (_net_113, D1);
not inst171  (_net_114, SI);
and inst172  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_113, D0, D2, D3, SE, _net_114);
not inst173  (_net_115, D1);
and inst174  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_115, D0, D2, D3, SE, SI);
not inst175  (_net_116, SE);
not inst176  (_net_117, SI);
and inst177  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, _net_116, _net_117);
not inst178  (_net_118, SE);
and inst179  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D1, D0, D2, D3, _net_118, SI);
not inst180  (_net_119, SI);
and inst181  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D1, D0, D2, D3, SE, _net_119);
and inst182  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI, D1, D0, D2, D3, SE, SI);
not inst183  (_net_120, D1);
not inst184  (_net_121, D0);
not inst185  (_net_122, D2);
not inst186  (_net_123, D3);
and inst187  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI, _net_120, _net_121, _net_122, _net_123, SI);
not inst188  (_net_124, D1);
not inst189  (_net_125, D0);
not inst190  (_net_126, D2);
not inst191  (_net_127, SI);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI, _net_124, _net_125, _net_126, D3, _net_127);
not inst193  (_net_128, D1);
not inst194  (_net_129, D0);
not inst195  (_net_130, D3);
not inst196  (_net_131, SI);
and inst197  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI, _net_128, _net_129, D2, _net_130, _net_131);
not inst198  (_net_132, D0);
not inst199  (_net_133, D2);
not inst200  (_net_134, D3);
not inst201  (_net_135, SI);
and inst202  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, D1, _net_132, _net_133, _net_134, _net_135);
not inst203  (_net_136, D1);
not inst204  (_net_137, D2);
not inst205  (_net_138, D3);
not inst206  (_net_139, SI);
and inst207  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, _net_136, D0, _net_137, _net_138, _net_139);
not inst208  (_net_140, D0);
and inst209  (ENABLE_NOT_D0_AND_SE, SE, _net_140);
and inst210  (ENABLE_D0_AND_SE, SE, D0);
not inst211  (_net_141, SI);
not inst212  (_net_142, SE);
and inst213  (ENABLE_NOT_SE_AND_NOT_SI, _net_141, _net_142);
not inst214  (_net_143, SE);
and inst215  (ENABLE_NOT_SE_AND_SI, SI, _net_143);

specify
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN0 +: 1'b1))=(0, 0);
(posedge CK => (QN0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN1 +: 1'b1))=(0, 0);
(posedge CK => (QN1 : 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN2 +: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN2 +: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN2 +: 1'b1))=(0, 0);
(posedge CK => (QN2 : 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (QN3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (QN3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (QN3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (QN3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (QN3 +: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (QN3 +: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (QN3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (QN3 +: 1'b1))=(0, 0);
(posedge CK => (QN3 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK , 0 ,0, viol_0);
$width(negedge CK , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQBM4SS_V2Y8_2

//%BEGIN HDBSVT11_FSDPQB_V1Y2_1

`celldefine
module HDBSVT11_FSDPQB_V1Y2_1 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V1Y2_1

//%BEGIN HDBSVT11_FSDPQB_V1Y2_12

`celldefine
module HDBSVT11_FSDPQB_V1Y2_12 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V1Y2_12

//%BEGIN HDBSVT11_FSDPQB_V1Y2_2

`celldefine
module HDBSVT11_FSDPQB_V1Y2_2 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V1Y2_2

//%BEGIN HDBSVT11_FSDPQB_V1Y2_4

`celldefine
module HDBSVT11_FSDPQB_V1Y2_4 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V1Y2_4

//%BEGIN HDBSVT11_FSDPQB_V1Y2_8

`celldefine
module HDBSVT11_FSDPQB_V1Y2_8 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V1Y2_8

//%BEGIN HDBSVT11_FSDPQB_V2Y2_1

`celldefine
module HDBSVT11_FSDPQB_V2Y2_1 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V2Y2_1

//%BEGIN HDBSVT11_FSDPQB_V2Y2_2

`celldefine
module HDBSVT11_FSDPQB_V2Y2_2 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V2Y2_2

//%BEGIN HDBSVT11_FSDPQB_V2Y2_4

`celldefine
module HDBSVT11_FSDPQB_V2Y2_4 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V2Y2_4

//%BEGIN HDBSVT11_FSDPQB_V2Y2_8

`celldefine
module HDBSVT11_FSDPQB_V2Y2_8 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V2Y2_8

//%BEGIN HDBSVT11_FSDPQB_V3Y2_1

`celldefine
module HDBSVT11_FSDPQB_V3Y2_1 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V3Y2_1

//%BEGIN HDBSVT11_FSDPQB_V3Y2_12

`celldefine
module HDBSVT11_FSDPQB_V3Y2_12 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V3Y2_12

//%BEGIN HDBSVT11_FSDPQB_V3Y2_2

`celldefine
module HDBSVT11_FSDPQB_V3Y2_2 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V3Y2_2

//%BEGIN HDBSVT11_FSDPQB_V3Y2_4

`celldefine
module HDBSVT11_FSDPQB_V3Y2_4 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V3Y2_4

//%BEGIN HDBSVT11_FSDPQB_V3Y2_8

`celldefine
module HDBSVT11_FSDPQB_V3Y2_8 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V3Y2_8

//%BEGIN HDBSVT11_FSDPQB_V4Y4_1

`celldefine
module HDBSVT11_FSDPQB_V4Y4_1 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V4Y4_1

//%BEGIN HDBSVT11_FSDPQB_V4Y4_2

`celldefine
module HDBSVT11_FSDPQB_V4Y4_2 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V4Y4_2

//%BEGIN HDBSVT11_FSDPQB_V4Y4_4

`celldefine
module HDBSVT11_FSDPQB_V4Y4_4 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V4Y4_4

//%BEGIN HDBSVT11_FSDPQB_V4Y4_8

`celldefine
module HDBSVT11_FSDPQB_V4Y4_8 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_V4Y4_8

//%BEGIN HDBSVT11_FSDPQB_Y2_1

`celldefine
module HDBSVT11_FSDPQB_Y2_1 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_Y2_1

//%BEGIN HDBSVT11_FSDPQB_Y2_2

`celldefine
module HDBSVT11_FSDPQB_Y2_2 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_Y2_2

//%BEGIN HDBSVT11_FSDPQB_Y2_4

`celldefine
module HDBSVT11_FSDPQB_Y2_4 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_Y2_4

//%BEGIN HDBSVT11_FSDPQB_Y2_8

`celldefine
module HDBSVT11_FSDPQB_Y2_8 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQB_Y2_8

//%BEGIN HDBSVT11_FSDPQM2SS_CBV2Y4_1

`celldefine
module HDBSVT11_FSDPQM2SS_CBV2Y4_1 (Q0, Q1, CK, D0, D1, SI, SE);
   output Q0, Q1;
   input CK, D0, D1, SI, SE;

   reg viol_all, viol_0,  viol_1;
   wire delayed_CK, delayed_D0, delayed_D1, 
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res_iq0, int_res_iq1, xcr_0, xcr_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif

   snps_mux2 inst5  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst6  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst7  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);
   snps_mux2 inst8  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst9  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst10  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst11 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst12 (Q1, int_res_iq1);
   `else
        buf inst13  (Q0, int_res_iq0);
        buf inst14  (Q1, int_res_iq1);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst15  (_net_0, D1);
not inst16  (_net_1, D0);
not inst17  (_net_2, SE);
not inst18  (_net_3, SI);
and inst19  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst20  (_net_4, D1);
not inst21  (_net_5, D0);
not inst22  (_net_6, SE);
and inst23  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst24  (_net_7, D1);
not inst25  (_net_8, D0);
not inst26  (_net_9, SI);
and inst27  (ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst28  (_net_10, D1);
not inst29  (_net_11, D0);
and inst30  (ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst31  (_net_12, D0);
not inst32  (_net_13, SE);
not inst33  (_net_14, SI);
and inst34  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D1, _net_12, _net_13, _net_14);
not inst35  (_net_15, D0);
not inst36  (_net_16, SE);
and inst37  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI, D1, _net_15, _net_16, SI);
not inst38  (_net_17, D0);
not inst39  (_net_18, SI);
and inst40  (ENABLE_NOT_D0_AND_D1_AND_SE_AND_NOT_SI, D1, _net_17, SE, _net_18);
not inst41  (_net_19, D0);
and inst42  (ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI, D1, _net_19, SE, SI);
not inst43  (_net_20, D1);
not inst44  (_net_21, SE);
not inst45  (_net_22, SI);
and inst46  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_20, D0, _net_21, _net_22);
not inst47  (_net_23, D1);
not inst48  (_net_24, SE);
and inst49  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_23, D0, _net_24, SI);
not inst50  (_net_25, D1);
not inst51  (_net_26, SI);
and inst52  (ENABLE_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, _net_25, D0, SE, _net_26);
not inst53  (_net_27, D1);
and inst54  (ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI, _net_27, D0, SE, SI);
not inst55  (_net_28, SE);
not inst56  (_net_29, SI);
and inst57  (ENABLE_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D1, D0, _net_28, _net_29);
not inst58  (_net_30, SE);
and inst59  (ENABLE_D0_AND_D1_AND_NOT_SE_AND_SI, D1, D0, _net_30, SI);
not inst60  (_net_31, SI);
and inst61  (ENABLE_D0_AND_D1_AND_SE_AND_NOT_SI, D1, D0, SE, _net_31);
and inst62  (ENABLE_D0_AND_D1_AND_SE_AND_SI, D1, D0, SE, SI);
not inst63  (_net_32, D1);
not inst64  (_net_33, D0);
not inst65  (_net_34, SI);
and inst66  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SI, _net_32, _net_33, _net_34);
not inst67  (_net_35, D1);
not inst68  (_net_36, D0);
and inst69  (ENABLE_NOT_D0_AND_NOT_D1_AND_SI, _net_35, _net_36, SI);
not inst70  (_net_37, D0);
not inst71  (_net_38, SI);
and inst72  (ENABLE_NOT_D0_AND_D1_AND_NOT_SI, D1, _net_37, _net_38);
not inst73  (_net_39, D1);
not inst74  (_net_40, SI);
and inst75  (ENABLE_D0_AND_NOT_D1_AND_NOT_SI, _net_39, D0, _net_40);
not inst76  (_net_41, D0);
and inst77  (ENABLE_NOT_D0_AND_SE, SE, _net_41);
and inst78  (ENABLE_D0_AND_SE, SE, D0);
not inst79  (_net_42, SI);
not inst80  (_net_43, SE);
and inst81  (ENABLE_NOT_SE_AND_NOT_SI, _net_42, _net_43);
not inst82  (_net_44, SE);
and inst83  (ENABLE_NOT_SE_AND_SI, SI, _net_44);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
   end 
`endif 
specify
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQM2SS_CBV2Y4_1

//%BEGIN HDBSVT11_FSDPQM2SS_V2Y4_1

`celldefine
module HDBSVT11_FSDPQM2SS_V2Y4_1 (Q0, Q1, CK, D0, D1, SI, SE);
   output Q0, Q1;
   input CK, D0, D1, SI, SE;

   reg viol_all, viol_0,  viol_1;
   wire delayed_CK, delayed_D0, delayed_D1, 
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res_iq0, int_res_iq1, xcr_0, xcr_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif

   snps_mux2 inst5  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst6  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst7  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);
   snps_mux2 inst8  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst9  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst10  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst11 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst12 (Q1, int_res_iq1);
   `else
        buf inst13  (Q0, int_res_iq0);
        buf inst14  (Q1, int_res_iq1);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst15  (_net_0, D1);
not inst16  (_net_1, D0);
not inst17  (_net_2, SE);
not inst18  (_net_3, SI);
and inst19  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst20  (_net_4, D1);
not inst21  (_net_5, D0);
not inst22  (_net_6, SE);
and inst23  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst24  (_net_7, D1);
not inst25  (_net_8, D0);
not inst26  (_net_9, SI);
and inst27  (ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst28  (_net_10, D1);
not inst29  (_net_11, D0);
and inst30  (ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst31  (_net_12, D0);
not inst32  (_net_13, SE);
not inst33  (_net_14, SI);
and inst34  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D1, _net_12, _net_13, _net_14);
not inst35  (_net_15, D0);
not inst36  (_net_16, SE);
and inst37  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI, D1, _net_15, _net_16, SI);
not inst38  (_net_17, D0);
not inst39  (_net_18, SI);
and inst40  (ENABLE_NOT_D0_AND_D1_AND_SE_AND_NOT_SI, D1, _net_17, SE, _net_18);
not inst41  (_net_19, D0);
and inst42  (ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI, D1, _net_19, SE, SI);
not inst43  (_net_20, D1);
not inst44  (_net_21, SE);
not inst45  (_net_22, SI);
and inst46  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_20, D0, _net_21, _net_22);
not inst47  (_net_23, D1);
not inst48  (_net_24, SE);
and inst49  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_23, D0, _net_24, SI);
not inst50  (_net_25, D1);
not inst51  (_net_26, SI);
and inst52  (ENABLE_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, _net_25, D0, SE, _net_26);
not inst53  (_net_27, D1);
and inst54  (ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI, _net_27, D0, SE, SI);
not inst55  (_net_28, SE);
not inst56  (_net_29, SI);
and inst57  (ENABLE_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D1, D0, _net_28, _net_29);
not inst58  (_net_30, SE);
and inst59  (ENABLE_D0_AND_D1_AND_NOT_SE_AND_SI, D1, D0, _net_30, SI);
not inst60  (_net_31, SI);
and inst61  (ENABLE_D0_AND_D1_AND_SE_AND_NOT_SI, D1, D0, SE, _net_31);
and inst62  (ENABLE_D0_AND_D1_AND_SE_AND_SI, D1, D0, SE, SI);
not inst63  (_net_32, D1);
not inst64  (_net_33, D0);
not inst65  (_net_34, SI);
and inst66  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SI, _net_32, _net_33, _net_34);
not inst67  (_net_35, D1);
not inst68  (_net_36, D0);
and inst69  (ENABLE_NOT_D0_AND_NOT_D1_AND_SI, _net_35, _net_36, SI);
not inst70  (_net_37, D0);
not inst71  (_net_38, SI);
and inst72  (ENABLE_NOT_D0_AND_D1_AND_NOT_SI, D1, _net_37, _net_38);
not inst73  (_net_39, D1);
not inst74  (_net_40, SI);
and inst75  (ENABLE_D0_AND_NOT_D1_AND_NOT_SI, _net_39, D0, _net_40);
not inst76  (_net_41, D0);
and inst77  (ENABLE_NOT_D0_AND_SE, SE, _net_41);
and inst78  (ENABLE_D0_AND_SE, SE, D0);
not inst79  (_net_42, SI);
not inst80  (_net_43, SE);
and inst81  (ENABLE_NOT_SE_AND_NOT_SI, _net_42, _net_43);
not inst82  (_net_44, SE);
and inst83  (ENABLE_NOT_SE_AND_SI, SI, _net_44);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
   end 
`endif 
specify
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQM2SS_V2Y4_1

//%BEGIN HDBSVT11_FSDPQM2SS_V2Y4_2

`celldefine
module HDBSVT11_FSDPQM2SS_V2Y4_2 (Q0, Q1, CK, D0, D1, SI, SE);
   output Q0, Q1;
   input CK, D0, D1, SI, SE;

   reg viol_all, viol_0,  viol_1;
   wire delayed_CK, delayed_D0, delayed_D1, 
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res_iq0, int_res_iq1, xcr_0, xcr_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif

   snps_mux2 inst5  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst6  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst7  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);
   snps_mux2 inst8  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst9  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst10  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst11 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst12 (Q1, int_res_iq1);
   `else
        buf inst13  (Q0, int_res_iq0);
        buf inst14  (Q1, int_res_iq1);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst15  (_net_0, D1);
not inst16  (_net_1, D0);
not inst17  (_net_2, SE);
not inst18  (_net_3, SI);
and inst19  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst20  (_net_4, D1);
not inst21  (_net_5, D0);
not inst22  (_net_6, SE);
and inst23  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst24  (_net_7, D1);
not inst25  (_net_8, D0);
not inst26  (_net_9, SI);
and inst27  (ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst28  (_net_10, D1);
not inst29  (_net_11, D0);
and inst30  (ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst31  (_net_12, D0);
not inst32  (_net_13, SE);
not inst33  (_net_14, SI);
and inst34  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D1, _net_12, _net_13, _net_14);
not inst35  (_net_15, D0);
not inst36  (_net_16, SE);
and inst37  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI, D1, _net_15, _net_16, SI);
not inst38  (_net_17, D0);
not inst39  (_net_18, SI);
and inst40  (ENABLE_NOT_D0_AND_D1_AND_SE_AND_NOT_SI, D1, _net_17, SE, _net_18);
not inst41  (_net_19, D0);
and inst42  (ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI, D1, _net_19, SE, SI);
not inst43  (_net_20, D1);
not inst44  (_net_21, SE);
not inst45  (_net_22, SI);
and inst46  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_20, D0, _net_21, _net_22);
not inst47  (_net_23, D1);
not inst48  (_net_24, SE);
and inst49  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_23, D0, _net_24, SI);
not inst50  (_net_25, D1);
not inst51  (_net_26, SI);
and inst52  (ENABLE_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, _net_25, D0, SE, _net_26);
not inst53  (_net_27, D1);
and inst54  (ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI, _net_27, D0, SE, SI);
not inst55  (_net_28, SE);
not inst56  (_net_29, SI);
and inst57  (ENABLE_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D1, D0, _net_28, _net_29);
not inst58  (_net_30, SE);
and inst59  (ENABLE_D0_AND_D1_AND_NOT_SE_AND_SI, D1, D0, _net_30, SI);
not inst60  (_net_31, SI);
and inst61  (ENABLE_D0_AND_D1_AND_SE_AND_NOT_SI, D1, D0, SE, _net_31);
and inst62  (ENABLE_D0_AND_D1_AND_SE_AND_SI, D1, D0, SE, SI);
not inst63  (_net_32, D1);
not inst64  (_net_33, D0);
not inst65  (_net_34, SI);
and inst66  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SI, _net_32, _net_33, _net_34);
not inst67  (_net_35, D1);
not inst68  (_net_36, D0);
and inst69  (ENABLE_NOT_D0_AND_NOT_D1_AND_SI, _net_35, _net_36, SI);
not inst70  (_net_37, D0);
not inst71  (_net_38, SI);
and inst72  (ENABLE_NOT_D0_AND_D1_AND_NOT_SI, D1, _net_37, _net_38);
not inst73  (_net_39, D1);
not inst74  (_net_40, SI);
and inst75  (ENABLE_D0_AND_NOT_D1_AND_NOT_SI, _net_39, D0, _net_40);
not inst76  (_net_41, D0);
and inst77  (ENABLE_NOT_D0_AND_SE, SE, _net_41);
and inst78  (ENABLE_D0_AND_SE, SE, D0);
not inst79  (_net_42, SI);
not inst80  (_net_43, SE);
and inst81  (ENABLE_NOT_SE_AND_NOT_SI, _net_42, _net_43);
not inst82  (_net_44, SE);
and inst83  (ENABLE_NOT_SE_AND_SI, SI, _net_44);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
   end 
`endif 
specify
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQM2SS_V2Y4_2

//%BEGIN HDBSVT11_FSDPQM4SS_CBV2Y8_1

`celldefine
module HDBSVT11_FSDPQM4SS_CBV2Y8_1 (Q0, Q1, Q2, Q3, CK, D0, D1, D2, D3, SI, SE);
   output Q0, Q1, Q2, Q3;
   input CK, D0, D1, D2, D3, SI, SE;

   reg viol_all, viol_0,  viol_1,  viol_2,  viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
`endif

   snps_mux2 inst7  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst9  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst10  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst11  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst12  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst13  (int_res__D2, int_res_iq1, delayed_D2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst14  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst15  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst16  (int_res__D3, int_res_iq2, delayed_D3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst17  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst18  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst19 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst20 (Q1, int_res_iq1);
        buf #`SNPS_SEQ_DELAY  inst21 (Q2, int_res_iq2);
        buf #`SNPS_SEQ_DELAY  inst22 (Q3, int_res_iq3);
   `else
        buf inst23  (Q0, int_res_iq0);
        buf inst24  (Q1, int_res_iq1);
        buf inst25  (Q2, int_res_iq2);
        buf inst26  (Q3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst27  (_net_0, D1);
not inst28  (_net_1, D0);
not inst29  (_net_2, D2);
not inst30  (_net_3, D3);
not inst31  (_net_4, SE);
not inst32  (_net_5, SI);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5);
not inst34  (_net_6, D1);
not inst35  (_net_7, D0);
not inst36  (_net_8, D2);
not inst37  (_net_9, D3);
not inst38  (_net_10, SE);
and inst39  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_6, _net_7, _net_8, _net_9, _net_10, SI);
not inst40  (_net_11, D1);
not inst41  (_net_12, D0);
not inst42  (_net_13, D2);
not inst43  (_net_14, D3);
not inst44  (_net_15, SI);
and inst45  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_11, _net_12, _net_13, _net_14, SE, _net_15);
not inst46  (_net_16, D1);
not inst47  (_net_17, D0);
not inst48  (_net_18, D2);
not inst49  (_net_19, D3);
and inst50  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_16, _net_17, _net_18, _net_19, SE, SI);
not inst51  (_net_20, D1);
not inst52  (_net_21, D0);
not inst53  (_net_22, D2);
not inst54  (_net_23, SE);
not inst55  (_net_24, SI);
and inst56  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22, D3, _net_23, _net_24);
not inst57  (_net_25, D1);
not inst58  (_net_26, D0);
not inst59  (_net_27, D2);
not inst60  (_net_28, SE);
and inst61  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_25, _net_26, _net_27, D3, _net_28, SI);
not inst62  (_net_29, D1);
not inst63  (_net_30, D0);
not inst64  (_net_31, D2);
not inst65  (_net_32, SI);
and inst66  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI, _net_29, _net_30, _net_31, D3, SE, _net_32);
not inst67  (_net_33, D1);
not inst68  (_net_34, D0);
not inst69  (_net_35, D2);
and inst70  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_33, _net_34, _net_35, D3, SE, SI);
not inst71  (_net_36, D1);
not inst72  (_net_37, D0);
not inst73  (_net_38, D3);
not inst74  (_net_39, SE);
not inst75  (_net_40, SI);
and inst76  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, D2, _net_38, _net_39, _net_40);
not inst77  (_net_41, D1);
not inst78  (_net_42, D0);
not inst79  (_net_43, D3);
not inst80  (_net_44, SE);
and inst81  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_41, _net_42, D2, _net_43, _net_44, SI);
not inst82  (_net_45, D1);
not inst83  (_net_46, D0);
not inst84  (_net_47, D3);
not inst85  (_net_48, SI);
and inst86  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_45, _net_46, D2, _net_47, SE, _net_48);
not inst87  (_net_49, D1);
not inst88  (_net_50, D0);
not inst89  (_net_51, D3);
and inst90  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_49, _net_50, D2, _net_51, SE, SI);
not inst91  (_net_52, D1);
not inst92  (_net_53, D0);
not inst93  (_net_54, SE);
not inst94  (_net_55, SI);
and inst95  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_52, _net_53, D2, D3, _net_54, _net_55);
not inst96  (_net_56, D1);
not inst97  (_net_57, D0);
not inst98  (_net_58, SE);
and inst99  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_56, _net_57, D2, D3, _net_58, SI);
not inst100  (_net_59, D1);
not inst101  (_net_60, D0);
not inst102  (_net_61, SI);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_59, _net_60, D2, D3, SE, _net_61);
not inst104  (_net_62, D1);
not inst105  (_net_63, D0);
and inst106  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_62, _net_63, D2, D3, SE, SI);
not inst107  (_net_64, D0);
not inst108  (_net_65, D2);
not inst109  (_net_66, D3);
not inst110  (_net_67, SE);
not inst111  (_net_68, SI);
and inst112  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_64, _net_65, _net_66, _net_67, _net_68);
not inst113  (_net_69, D0);
not inst114  (_net_70, D2);
not inst115  (_net_71, D3);
not inst116  (_net_72, SE);
and inst117  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_69, _net_70, _net_71, _net_72, SI);
not inst118  (_net_73, D0);
not inst119  (_net_74, D2);
not inst120  (_net_75, D3);
not inst121  (_net_76, SI);
and inst122  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D1, _net_73, _net_74, _net_75, SE, _net_76);
not inst123  (_net_77, D0);
not inst124  (_net_78, D2);
not inst125  (_net_79, D3);
and inst126  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D1, _net_77, _net_78, _net_79, SE, SI);
not inst127  (_net_80, D1);
not inst128  (_net_81, D2);
not inst129  (_net_82, D3);
not inst130  (_net_83, SE);
not inst131  (_net_84, SI);
and inst132  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_80, D0, _net_81, _net_82, _net_83, _net_84);
not inst133  (_net_85, D1);
not inst134  (_net_86, D2);
not inst135  (_net_87, D3);
not inst136  (_net_88, SE);
and inst137  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_85, D0, _net_86, _net_87, _net_88, SI);
not inst138  (_net_89, D1);
not inst139  (_net_90, D2);
not inst140  (_net_91, D3);
not inst141  (_net_92, SI);
and inst142  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_89, D0, _net_90, _net_91, SE, _net_92);
not inst143  (_net_93, D1);
not inst144  (_net_94, D2);
not inst145  (_net_95, D3);
and inst146  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_93, D0, _net_94, _net_95, SE, SI);
not inst147  (_net_96, D1);
not inst148  (_net_97, D3);
not inst149  (_net_98, SE);
not inst150  (_net_99, SI);
and inst151  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_96, D0, D2, _net_97, _net_98, _net_99);
not inst152  (_net_100, D1);
not inst153  (_net_101, D3);
not inst154  (_net_102, SE);
and inst155  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_100, D0, D2, _net_101, _net_102, SI);
not inst156  (_net_103, D1);
not inst157  (_net_104, D3);
not inst158  (_net_105, SI);
and inst159  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_103, D0, D2, _net_104, SE, _net_105);
not inst160  (_net_106, D1);
not inst161  (_net_107, D3);
and inst162  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_106, D0, D2, _net_107, SE, SI);
not inst163  (_net_108, D1);
not inst164  (_net_109, SE);
not inst165  (_net_110, SI);
and inst166  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_108, D0, D2, D3, _net_109, _net_110);
not inst167  (_net_111, D1);
not inst168  (_net_112, SE);
and inst169  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_111, D0, D2, D3, _net_112, SI);
not inst170  (_net_113, D1);
not inst171  (_net_114, SI);
and inst172  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_113, D0, D2, D3, SE, _net_114);
not inst173  (_net_115, D1);
and inst174  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_115, D0, D2, D3, SE, SI);
not inst175  (_net_116, SE);
not inst176  (_net_117, SI);
and inst177  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, _net_116, _net_117);
not inst178  (_net_118, SE);
and inst179  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D1, D0, D2, D3, _net_118, SI);
not inst180  (_net_119, SI);
and inst181  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D1, D0, D2, D3, SE, _net_119);
and inst182  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI, D1, D0, D2, D3, SE, SI);
not inst183  (_net_120, D1);
not inst184  (_net_121, D0);
not inst185  (_net_122, D2);
not inst186  (_net_123, D3);
and inst187  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI, _net_120, _net_121, _net_122, _net_123, SI);
not inst188  (_net_124, D1);
not inst189  (_net_125, D0);
not inst190  (_net_126, D2);
not inst191  (_net_127, SI);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI, _net_124, _net_125, _net_126, D3, _net_127);
not inst193  (_net_128, D1);
not inst194  (_net_129, D0);
not inst195  (_net_130, D3);
not inst196  (_net_131, SI);
and inst197  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI, _net_128, _net_129, D2, _net_130, _net_131);
not inst198  (_net_132, D0);
not inst199  (_net_133, D2);
not inst200  (_net_134, D3);
not inst201  (_net_135, SI);
and inst202  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, D1, _net_132, _net_133, _net_134, _net_135);
not inst203  (_net_136, D1);
not inst204  (_net_137, D2);
not inst205  (_net_138, D3);
not inst206  (_net_139, SI);
and inst207  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, _net_136, D0, _net_137, _net_138, _net_139);
not inst208  (_net_140, D0);
and inst209  (ENABLE_NOT_D0_AND_SE, SE, _net_140);
and inst210  (ENABLE_D0_AND_SE, SE, D0);
not inst211  (_net_141, SI);
not inst212  (_net_142, SE);
and inst213  (ENABLE_NOT_SE_AND_NOT_SI, _net_141, _net_142);
not inst214  (_net_143, SE);
and inst215  (ENABLE_NOT_SE_AND_SI, SI, _net_143);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
      viol_2 = (viol_2 !== viol_all) ? viol_all : ~viol_2;
      viol_3 = (viol_3 !== viol_all) ? viol_all : ~viol_3;
   end 
`endif 
specify
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQM4SS_CBV2Y8_1

//%BEGIN HDBSVT11_FSDPQM4SS_LPV2Y8_1

`celldefine
module HDBSVT11_FSDPQM4SS_LPV2Y8_1 (Q0, Q1, Q2, Q3, CK, D0, D1, D2, D3, SI, SE);
   output Q0, Q1, Q2, Q3;
   input CK, D0, D1, D2, D3, SI, SE;

   reg viol_all, viol_0,  viol_1,  viol_2,  viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
`endif

   snps_mux2 inst7  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst9  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst10  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst11  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst12  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst13  (int_res__D2, int_res_iq1, delayed_D2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst14  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst15  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst16  (int_res__D3, int_res_iq2, delayed_D3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst17  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst18  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst19 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst20 (Q1, int_res_iq1);
        buf #`SNPS_SEQ_DELAY  inst21 (Q2, int_res_iq2);
        buf #`SNPS_SEQ_DELAY  inst22 (Q3, int_res_iq3);
   `else
        buf inst23  (Q0, int_res_iq0);
        buf inst24  (Q1, int_res_iq1);
        buf inst25  (Q2, int_res_iq2);
        buf inst26  (Q3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst27  (_net_0, D1);
not inst28  (_net_1, D0);
not inst29  (_net_2, D2);
not inst30  (_net_3, D3);
not inst31  (_net_4, SE);
not inst32  (_net_5, SI);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5);
not inst34  (_net_6, D1);
not inst35  (_net_7, D0);
not inst36  (_net_8, D2);
not inst37  (_net_9, D3);
not inst38  (_net_10, SE);
and inst39  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_6, _net_7, _net_8, _net_9, _net_10, SI);
not inst40  (_net_11, D1);
not inst41  (_net_12, D0);
not inst42  (_net_13, D2);
not inst43  (_net_14, D3);
not inst44  (_net_15, SI);
and inst45  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_11, _net_12, _net_13, _net_14, SE, _net_15);
not inst46  (_net_16, D1);
not inst47  (_net_17, D0);
not inst48  (_net_18, D2);
not inst49  (_net_19, D3);
and inst50  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_16, _net_17, _net_18, _net_19, SE, SI);
not inst51  (_net_20, D1);
not inst52  (_net_21, D0);
not inst53  (_net_22, D2);
not inst54  (_net_23, SE);
not inst55  (_net_24, SI);
and inst56  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22, D3, _net_23, _net_24);
not inst57  (_net_25, D1);
not inst58  (_net_26, D0);
not inst59  (_net_27, D2);
not inst60  (_net_28, SE);
and inst61  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_25, _net_26, _net_27, D3, _net_28, SI);
not inst62  (_net_29, D1);
not inst63  (_net_30, D0);
not inst64  (_net_31, D2);
not inst65  (_net_32, SI);
and inst66  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI, _net_29, _net_30, _net_31, D3, SE, _net_32);
not inst67  (_net_33, D1);
not inst68  (_net_34, D0);
not inst69  (_net_35, D2);
and inst70  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_33, _net_34, _net_35, D3, SE, SI);
not inst71  (_net_36, D1);
not inst72  (_net_37, D0);
not inst73  (_net_38, D3);
not inst74  (_net_39, SE);
not inst75  (_net_40, SI);
and inst76  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, D2, _net_38, _net_39, _net_40);
not inst77  (_net_41, D1);
not inst78  (_net_42, D0);
not inst79  (_net_43, D3);
not inst80  (_net_44, SE);
and inst81  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_41, _net_42, D2, _net_43, _net_44, SI);
not inst82  (_net_45, D1);
not inst83  (_net_46, D0);
not inst84  (_net_47, D3);
not inst85  (_net_48, SI);
and inst86  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_45, _net_46, D2, _net_47, SE, _net_48);
not inst87  (_net_49, D1);
not inst88  (_net_50, D0);
not inst89  (_net_51, D3);
and inst90  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_49, _net_50, D2, _net_51, SE, SI);
not inst91  (_net_52, D1);
not inst92  (_net_53, D0);
not inst93  (_net_54, SE);
not inst94  (_net_55, SI);
and inst95  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_52, _net_53, D2, D3, _net_54, _net_55);
not inst96  (_net_56, D1);
not inst97  (_net_57, D0);
not inst98  (_net_58, SE);
and inst99  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_56, _net_57, D2, D3, _net_58, SI);
not inst100  (_net_59, D1);
not inst101  (_net_60, D0);
not inst102  (_net_61, SI);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_59, _net_60, D2, D3, SE, _net_61);
not inst104  (_net_62, D1);
not inst105  (_net_63, D0);
and inst106  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_62, _net_63, D2, D3, SE, SI);
not inst107  (_net_64, D0);
not inst108  (_net_65, D2);
not inst109  (_net_66, D3);
not inst110  (_net_67, SE);
not inst111  (_net_68, SI);
and inst112  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_64, _net_65, _net_66, _net_67, _net_68);
not inst113  (_net_69, D0);
not inst114  (_net_70, D2);
not inst115  (_net_71, D3);
not inst116  (_net_72, SE);
and inst117  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_69, _net_70, _net_71, _net_72, SI);
not inst118  (_net_73, D0);
not inst119  (_net_74, D2);
not inst120  (_net_75, D3);
not inst121  (_net_76, SI);
and inst122  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D1, _net_73, _net_74, _net_75, SE, _net_76);
not inst123  (_net_77, D0);
not inst124  (_net_78, D2);
not inst125  (_net_79, D3);
and inst126  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D1, _net_77, _net_78, _net_79, SE, SI);
not inst127  (_net_80, D1);
not inst128  (_net_81, D2);
not inst129  (_net_82, D3);
not inst130  (_net_83, SE);
not inst131  (_net_84, SI);
and inst132  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_80, D0, _net_81, _net_82, _net_83, _net_84);
not inst133  (_net_85, D1);
not inst134  (_net_86, D2);
not inst135  (_net_87, D3);
not inst136  (_net_88, SE);
and inst137  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_85, D0, _net_86, _net_87, _net_88, SI);
not inst138  (_net_89, D1);
not inst139  (_net_90, D2);
not inst140  (_net_91, D3);
not inst141  (_net_92, SI);
and inst142  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_89, D0, _net_90, _net_91, SE, _net_92);
not inst143  (_net_93, D1);
not inst144  (_net_94, D2);
not inst145  (_net_95, D3);
and inst146  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_93, D0, _net_94, _net_95, SE, SI);
not inst147  (_net_96, D1);
not inst148  (_net_97, D3);
not inst149  (_net_98, SE);
not inst150  (_net_99, SI);
and inst151  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_96, D0, D2, _net_97, _net_98, _net_99);
not inst152  (_net_100, D1);
not inst153  (_net_101, D3);
not inst154  (_net_102, SE);
and inst155  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_100, D0, D2, _net_101, _net_102, SI);
not inst156  (_net_103, D1);
not inst157  (_net_104, D3);
not inst158  (_net_105, SI);
and inst159  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_103, D0, D2, _net_104, SE, _net_105);
not inst160  (_net_106, D1);
not inst161  (_net_107, D3);
and inst162  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_106, D0, D2, _net_107, SE, SI);
not inst163  (_net_108, D1);
not inst164  (_net_109, SE);
not inst165  (_net_110, SI);
and inst166  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_108, D0, D2, D3, _net_109, _net_110);
not inst167  (_net_111, D1);
not inst168  (_net_112, SE);
and inst169  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_111, D0, D2, D3, _net_112, SI);
not inst170  (_net_113, D1);
not inst171  (_net_114, SI);
and inst172  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_113, D0, D2, D3, SE, _net_114);
not inst173  (_net_115, D1);
and inst174  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_115, D0, D2, D3, SE, SI);
not inst175  (_net_116, SE);
not inst176  (_net_117, SI);
and inst177  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, _net_116, _net_117);
not inst178  (_net_118, SE);
and inst179  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D1, D0, D2, D3, _net_118, SI);
not inst180  (_net_119, SI);
and inst181  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D1, D0, D2, D3, SE, _net_119);
and inst182  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI, D1, D0, D2, D3, SE, SI);
not inst183  (_net_120, D1);
not inst184  (_net_121, D0);
not inst185  (_net_122, D2);
not inst186  (_net_123, D3);
and inst187  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI, _net_120, _net_121, _net_122, _net_123, SI);
not inst188  (_net_124, D1);
not inst189  (_net_125, D0);
not inst190  (_net_126, D2);
not inst191  (_net_127, SI);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI, _net_124, _net_125, _net_126, D3, _net_127);
not inst193  (_net_128, D1);
not inst194  (_net_129, D0);
not inst195  (_net_130, D3);
not inst196  (_net_131, SI);
and inst197  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI, _net_128, _net_129, D2, _net_130, _net_131);
not inst198  (_net_132, D0);
not inst199  (_net_133, D2);
not inst200  (_net_134, D3);
not inst201  (_net_135, SI);
and inst202  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, D1, _net_132, _net_133, _net_134, _net_135);
not inst203  (_net_136, D1);
not inst204  (_net_137, D2);
not inst205  (_net_138, D3);
not inst206  (_net_139, SI);
and inst207  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, _net_136, D0, _net_137, _net_138, _net_139);
not inst208  (_net_140, D0);
and inst209  (ENABLE_NOT_D0_AND_SE, SE, _net_140);
and inst210  (ENABLE_D0_AND_SE, SE, D0);
not inst211  (_net_141, SI);
not inst212  (_net_142, SE);
and inst213  (ENABLE_NOT_SE_AND_NOT_SI, _net_141, _net_142);
not inst214  (_net_143, SE);
and inst215  (ENABLE_NOT_SE_AND_SI, SI, _net_143);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
      viol_2 = (viol_2 !== viol_all) ? viol_all : ~viol_2;
      viol_3 = (viol_3 !== viol_all) ? viol_all : ~viol_3;
   end 
`endif 
specify
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQM4SS_LPV2Y8_1

//%BEGIN HDBSVT11_FSDPQM4SS_LPV2Y8_2

`celldefine
module HDBSVT11_FSDPQM4SS_LPV2Y8_2 (Q0, Q1, Q2, Q3, CK, D0, D1, D2, D3, SI, SE);
   output Q0, Q1, Q2, Q3;
   input CK, D0, D1, D2, D3, SI, SE;

   reg viol_all, viol_0,  viol_1,  viol_2,  viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
`endif

   snps_mux2 inst7  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst9  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst10  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst11  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst12  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst13  (int_res__D2, int_res_iq1, delayed_D2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst14  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst15  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst16  (int_res__D3, int_res_iq2, delayed_D3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst17  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst18  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst19 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst20 (Q1, int_res_iq1);
        buf #`SNPS_SEQ_DELAY  inst21 (Q2, int_res_iq2);
        buf #`SNPS_SEQ_DELAY  inst22 (Q3, int_res_iq3);
   `else
        buf inst23  (Q0, int_res_iq0);
        buf inst24  (Q1, int_res_iq1);
        buf inst25  (Q2, int_res_iq2);
        buf inst26  (Q3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst27  (_net_0, D1);
not inst28  (_net_1, D0);
not inst29  (_net_2, D2);
not inst30  (_net_3, D3);
not inst31  (_net_4, SE);
not inst32  (_net_5, SI);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5);
not inst34  (_net_6, D1);
not inst35  (_net_7, D0);
not inst36  (_net_8, D2);
not inst37  (_net_9, D3);
not inst38  (_net_10, SE);
and inst39  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_6, _net_7, _net_8, _net_9, _net_10, SI);
not inst40  (_net_11, D1);
not inst41  (_net_12, D0);
not inst42  (_net_13, D2);
not inst43  (_net_14, D3);
not inst44  (_net_15, SI);
and inst45  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_11, _net_12, _net_13, _net_14, SE, _net_15);
not inst46  (_net_16, D1);
not inst47  (_net_17, D0);
not inst48  (_net_18, D2);
not inst49  (_net_19, D3);
and inst50  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_16, _net_17, _net_18, _net_19, SE, SI);
not inst51  (_net_20, D1);
not inst52  (_net_21, D0);
not inst53  (_net_22, D2);
not inst54  (_net_23, SE);
not inst55  (_net_24, SI);
and inst56  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22, D3, _net_23, _net_24);
not inst57  (_net_25, D1);
not inst58  (_net_26, D0);
not inst59  (_net_27, D2);
not inst60  (_net_28, SE);
and inst61  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_25, _net_26, _net_27, D3, _net_28, SI);
not inst62  (_net_29, D1);
not inst63  (_net_30, D0);
not inst64  (_net_31, D2);
not inst65  (_net_32, SI);
and inst66  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI, _net_29, _net_30, _net_31, D3, SE, _net_32);
not inst67  (_net_33, D1);
not inst68  (_net_34, D0);
not inst69  (_net_35, D2);
and inst70  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_33, _net_34, _net_35, D3, SE, SI);
not inst71  (_net_36, D1);
not inst72  (_net_37, D0);
not inst73  (_net_38, D3);
not inst74  (_net_39, SE);
not inst75  (_net_40, SI);
and inst76  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, D2, _net_38, _net_39, _net_40);
not inst77  (_net_41, D1);
not inst78  (_net_42, D0);
not inst79  (_net_43, D3);
not inst80  (_net_44, SE);
and inst81  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_41, _net_42, D2, _net_43, _net_44, SI);
not inst82  (_net_45, D1);
not inst83  (_net_46, D0);
not inst84  (_net_47, D3);
not inst85  (_net_48, SI);
and inst86  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_45, _net_46, D2, _net_47, SE, _net_48);
not inst87  (_net_49, D1);
not inst88  (_net_50, D0);
not inst89  (_net_51, D3);
and inst90  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_49, _net_50, D2, _net_51, SE, SI);
not inst91  (_net_52, D1);
not inst92  (_net_53, D0);
not inst93  (_net_54, SE);
not inst94  (_net_55, SI);
and inst95  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_52, _net_53, D2, D3, _net_54, _net_55);
not inst96  (_net_56, D1);
not inst97  (_net_57, D0);
not inst98  (_net_58, SE);
and inst99  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_56, _net_57, D2, D3, _net_58, SI);
not inst100  (_net_59, D1);
not inst101  (_net_60, D0);
not inst102  (_net_61, SI);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_59, _net_60, D2, D3, SE, _net_61);
not inst104  (_net_62, D1);
not inst105  (_net_63, D0);
and inst106  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_62, _net_63, D2, D3, SE, SI);
not inst107  (_net_64, D0);
not inst108  (_net_65, D2);
not inst109  (_net_66, D3);
not inst110  (_net_67, SE);
not inst111  (_net_68, SI);
and inst112  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_64, _net_65, _net_66, _net_67, _net_68);
not inst113  (_net_69, D0);
not inst114  (_net_70, D2);
not inst115  (_net_71, D3);
not inst116  (_net_72, SE);
and inst117  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_69, _net_70, _net_71, _net_72, SI);
not inst118  (_net_73, D0);
not inst119  (_net_74, D2);
not inst120  (_net_75, D3);
not inst121  (_net_76, SI);
and inst122  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D1, _net_73, _net_74, _net_75, SE, _net_76);
not inst123  (_net_77, D0);
not inst124  (_net_78, D2);
not inst125  (_net_79, D3);
and inst126  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D1, _net_77, _net_78, _net_79, SE, SI);
not inst127  (_net_80, D1);
not inst128  (_net_81, D2);
not inst129  (_net_82, D3);
not inst130  (_net_83, SE);
not inst131  (_net_84, SI);
and inst132  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_80, D0, _net_81, _net_82, _net_83, _net_84);
not inst133  (_net_85, D1);
not inst134  (_net_86, D2);
not inst135  (_net_87, D3);
not inst136  (_net_88, SE);
and inst137  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_85, D0, _net_86, _net_87, _net_88, SI);
not inst138  (_net_89, D1);
not inst139  (_net_90, D2);
not inst140  (_net_91, D3);
not inst141  (_net_92, SI);
and inst142  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_89, D0, _net_90, _net_91, SE, _net_92);
not inst143  (_net_93, D1);
not inst144  (_net_94, D2);
not inst145  (_net_95, D3);
and inst146  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_93, D0, _net_94, _net_95, SE, SI);
not inst147  (_net_96, D1);
not inst148  (_net_97, D3);
not inst149  (_net_98, SE);
not inst150  (_net_99, SI);
and inst151  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_96, D0, D2, _net_97, _net_98, _net_99);
not inst152  (_net_100, D1);
not inst153  (_net_101, D3);
not inst154  (_net_102, SE);
and inst155  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_100, D0, D2, _net_101, _net_102, SI);
not inst156  (_net_103, D1);
not inst157  (_net_104, D3);
not inst158  (_net_105, SI);
and inst159  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_103, D0, D2, _net_104, SE, _net_105);
not inst160  (_net_106, D1);
not inst161  (_net_107, D3);
and inst162  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_106, D0, D2, _net_107, SE, SI);
not inst163  (_net_108, D1);
not inst164  (_net_109, SE);
not inst165  (_net_110, SI);
and inst166  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_108, D0, D2, D3, _net_109, _net_110);
not inst167  (_net_111, D1);
not inst168  (_net_112, SE);
and inst169  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_111, D0, D2, D3, _net_112, SI);
not inst170  (_net_113, D1);
not inst171  (_net_114, SI);
and inst172  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_113, D0, D2, D3, SE, _net_114);
not inst173  (_net_115, D1);
and inst174  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_115, D0, D2, D3, SE, SI);
not inst175  (_net_116, SE);
not inst176  (_net_117, SI);
and inst177  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, _net_116, _net_117);
not inst178  (_net_118, SE);
and inst179  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D1, D0, D2, D3, _net_118, SI);
not inst180  (_net_119, SI);
and inst181  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D1, D0, D2, D3, SE, _net_119);
and inst182  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI, D1, D0, D2, D3, SE, SI);
not inst183  (_net_120, D1);
not inst184  (_net_121, D0);
not inst185  (_net_122, D2);
not inst186  (_net_123, D3);
and inst187  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI, _net_120, _net_121, _net_122, _net_123, SI);
not inst188  (_net_124, D1);
not inst189  (_net_125, D0);
not inst190  (_net_126, D2);
not inst191  (_net_127, SI);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI, _net_124, _net_125, _net_126, D3, _net_127);
not inst193  (_net_128, D1);
not inst194  (_net_129, D0);
not inst195  (_net_130, D3);
not inst196  (_net_131, SI);
and inst197  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI, _net_128, _net_129, D2, _net_130, _net_131);
not inst198  (_net_132, D0);
not inst199  (_net_133, D2);
not inst200  (_net_134, D3);
not inst201  (_net_135, SI);
and inst202  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, D1, _net_132, _net_133, _net_134, _net_135);
not inst203  (_net_136, D1);
not inst204  (_net_137, D2);
not inst205  (_net_138, D3);
not inst206  (_net_139, SI);
and inst207  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, _net_136, D0, _net_137, _net_138, _net_139);
not inst208  (_net_140, D0);
and inst209  (ENABLE_NOT_D0_AND_SE, SE, _net_140);
and inst210  (ENABLE_D0_AND_SE, SE, D0);
not inst211  (_net_141, SI);
not inst212  (_net_142, SE);
and inst213  (ENABLE_NOT_SE_AND_NOT_SI, _net_141, _net_142);
not inst214  (_net_143, SE);
and inst215  (ENABLE_NOT_SE_AND_SI, SI, _net_143);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
      viol_2 = (viol_2 !== viol_all) ? viol_all : ~viol_2;
      viol_3 = (viol_3 !== viol_all) ? viol_all : ~viol_3;
   end 
`endif 
specify
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQM4SS_LPV2Y8_2

//%BEGIN HDBSVT11_FSDPQM4SS_V2P1Y8_2

`celldefine
module HDBSVT11_FSDPQM4SS_V2P1Y8_2 (Q0, Q1, Q2, Q3, CK, D0, D1, D2, D3, SI, SE);
   output Q0, Q1, Q2, Q3;
   input CK, D0, D1, D2, D3, SI, SE;

   reg viol_all, viol_0,  viol_1,  viol_2,  viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
`endif

   snps_mux2 inst7  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst9  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst10  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst11  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst12  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst13  (int_res__D2, int_res_iq1, delayed_D2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst14  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst15  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst16  (int_res__D3, int_res_iq2, delayed_D3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst17  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst18  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst19 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst20 (Q1, int_res_iq1);
        buf #`SNPS_SEQ_DELAY  inst21 (Q2, int_res_iq2);
        buf #`SNPS_SEQ_DELAY  inst22 (Q3, int_res_iq3);
   `else
        buf inst23  (Q0, int_res_iq0);
        buf inst24  (Q1, int_res_iq1);
        buf inst25  (Q2, int_res_iq2);
        buf inst26  (Q3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst27  (_net_0, D1);
not inst28  (_net_1, D0);
not inst29  (_net_2, D2);
not inst30  (_net_3, D3);
not inst31  (_net_4, SE);
not inst32  (_net_5, SI);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5);
not inst34  (_net_6, D1);
not inst35  (_net_7, D0);
not inst36  (_net_8, D2);
not inst37  (_net_9, D3);
not inst38  (_net_10, SE);
and inst39  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_6, _net_7, _net_8, _net_9, _net_10, SI);
not inst40  (_net_11, D1);
not inst41  (_net_12, D0);
not inst42  (_net_13, D2);
not inst43  (_net_14, D3);
not inst44  (_net_15, SI);
and inst45  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_11, _net_12, _net_13, _net_14, SE, _net_15);
not inst46  (_net_16, D1);
not inst47  (_net_17, D0);
not inst48  (_net_18, D2);
not inst49  (_net_19, D3);
and inst50  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_16, _net_17, _net_18, _net_19, SE, SI);
not inst51  (_net_20, D1);
not inst52  (_net_21, D0);
not inst53  (_net_22, D2);
not inst54  (_net_23, SE);
not inst55  (_net_24, SI);
and inst56  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22, D3, _net_23, _net_24);
not inst57  (_net_25, D1);
not inst58  (_net_26, D0);
not inst59  (_net_27, D2);
not inst60  (_net_28, SE);
and inst61  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_25, _net_26, _net_27, D3, _net_28, SI);
not inst62  (_net_29, D1);
not inst63  (_net_30, D0);
not inst64  (_net_31, D2);
not inst65  (_net_32, SI);
and inst66  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI, _net_29, _net_30, _net_31, D3, SE, _net_32);
not inst67  (_net_33, D1);
not inst68  (_net_34, D0);
not inst69  (_net_35, D2);
and inst70  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_33, _net_34, _net_35, D3, SE, SI);
not inst71  (_net_36, D1);
not inst72  (_net_37, D0);
not inst73  (_net_38, D3);
not inst74  (_net_39, SE);
not inst75  (_net_40, SI);
and inst76  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, D2, _net_38, _net_39, _net_40);
not inst77  (_net_41, D1);
not inst78  (_net_42, D0);
not inst79  (_net_43, D3);
not inst80  (_net_44, SE);
and inst81  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_41, _net_42, D2, _net_43, _net_44, SI);
not inst82  (_net_45, D1);
not inst83  (_net_46, D0);
not inst84  (_net_47, D3);
not inst85  (_net_48, SI);
and inst86  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_45, _net_46, D2, _net_47, SE, _net_48);
not inst87  (_net_49, D1);
not inst88  (_net_50, D0);
not inst89  (_net_51, D3);
and inst90  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_49, _net_50, D2, _net_51, SE, SI);
not inst91  (_net_52, D1);
not inst92  (_net_53, D0);
not inst93  (_net_54, SE);
not inst94  (_net_55, SI);
and inst95  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_52, _net_53, D2, D3, _net_54, _net_55);
not inst96  (_net_56, D1);
not inst97  (_net_57, D0);
not inst98  (_net_58, SE);
and inst99  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_56, _net_57, D2, D3, _net_58, SI);
not inst100  (_net_59, D1);
not inst101  (_net_60, D0);
not inst102  (_net_61, SI);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_59, _net_60, D2, D3, SE, _net_61);
not inst104  (_net_62, D1);
not inst105  (_net_63, D0);
and inst106  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_62, _net_63, D2, D3, SE, SI);
not inst107  (_net_64, D0);
not inst108  (_net_65, D2);
not inst109  (_net_66, D3);
not inst110  (_net_67, SE);
not inst111  (_net_68, SI);
and inst112  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_64, _net_65, _net_66, _net_67, _net_68);
not inst113  (_net_69, D0);
not inst114  (_net_70, D2);
not inst115  (_net_71, D3);
not inst116  (_net_72, SE);
and inst117  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_69, _net_70, _net_71, _net_72, SI);
not inst118  (_net_73, D0);
not inst119  (_net_74, D2);
not inst120  (_net_75, D3);
not inst121  (_net_76, SI);
and inst122  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D1, _net_73, _net_74, _net_75, SE, _net_76);
not inst123  (_net_77, D0);
not inst124  (_net_78, D2);
not inst125  (_net_79, D3);
and inst126  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D1, _net_77, _net_78, _net_79, SE, SI);
not inst127  (_net_80, D1);
not inst128  (_net_81, D2);
not inst129  (_net_82, D3);
not inst130  (_net_83, SE);
not inst131  (_net_84, SI);
and inst132  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_80, D0, _net_81, _net_82, _net_83, _net_84);
not inst133  (_net_85, D1);
not inst134  (_net_86, D2);
not inst135  (_net_87, D3);
not inst136  (_net_88, SE);
and inst137  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_85, D0, _net_86, _net_87, _net_88, SI);
not inst138  (_net_89, D1);
not inst139  (_net_90, D2);
not inst140  (_net_91, D3);
not inst141  (_net_92, SI);
and inst142  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_89, D0, _net_90, _net_91, SE, _net_92);
not inst143  (_net_93, D1);
not inst144  (_net_94, D2);
not inst145  (_net_95, D3);
and inst146  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_93, D0, _net_94, _net_95, SE, SI);
not inst147  (_net_96, D1);
not inst148  (_net_97, D3);
not inst149  (_net_98, SE);
not inst150  (_net_99, SI);
and inst151  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_96, D0, D2, _net_97, _net_98, _net_99);
not inst152  (_net_100, D1);
not inst153  (_net_101, D3);
not inst154  (_net_102, SE);
and inst155  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_100, D0, D2, _net_101, _net_102, SI);
not inst156  (_net_103, D1);
not inst157  (_net_104, D3);
not inst158  (_net_105, SI);
and inst159  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_103, D0, D2, _net_104, SE, _net_105);
not inst160  (_net_106, D1);
not inst161  (_net_107, D3);
and inst162  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_106, D0, D2, _net_107, SE, SI);
not inst163  (_net_108, D1);
not inst164  (_net_109, SE);
not inst165  (_net_110, SI);
and inst166  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_108, D0, D2, D3, _net_109, _net_110);
not inst167  (_net_111, D1);
not inst168  (_net_112, SE);
and inst169  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_111, D0, D2, D3, _net_112, SI);
not inst170  (_net_113, D1);
not inst171  (_net_114, SI);
and inst172  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_113, D0, D2, D3, SE, _net_114);
not inst173  (_net_115, D1);
and inst174  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_115, D0, D2, D3, SE, SI);
not inst175  (_net_116, SE);
not inst176  (_net_117, SI);
and inst177  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, _net_116, _net_117);
not inst178  (_net_118, SE);
and inst179  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D1, D0, D2, D3, _net_118, SI);
not inst180  (_net_119, SI);
and inst181  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D1, D0, D2, D3, SE, _net_119);
and inst182  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI, D1, D0, D2, D3, SE, SI);
not inst183  (_net_120, D1);
not inst184  (_net_121, D0);
not inst185  (_net_122, D2);
not inst186  (_net_123, D3);
and inst187  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI, _net_120, _net_121, _net_122, _net_123, SI);
not inst188  (_net_124, D1);
not inst189  (_net_125, D0);
not inst190  (_net_126, D2);
not inst191  (_net_127, SI);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI, _net_124, _net_125, _net_126, D3, _net_127);
not inst193  (_net_128, D1);
not inst194  (_net_129, D0);
not inst195  (_net_130, D3);
not inst196  (_net_131, SI);
and inst197  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI, _net_128, _net_129, D2, _net_130, _net_131);
not inst198  (_net_132, D0);
not inst199  (_net_133, D2);
not inst200  (_net_134, D3);
not inst201  (_net_135, SI);
and inst202  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, D1, _net_132, _net_133, _net_134, _net_135);
not inst203  (_net_136, D1);
not inst204  (_net_137, D2);
not inst205  (_net_138, D3);
not inst206  (_net_139, SI);
and inst207  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, _net_136, D0, _net_137, _net_138, _net_139);
not inst208  (_net_140, D0);
and inst209  (ENABLE_NOT_D0_AND_SE, SE, _net_140);
and inst210  (ENABLE_D0_AND_SE, SE, D0);
not inst211  (_net_141, SI);
not inst212  (_net_142, SE);
and inst213  (ENABLE_NOT_SE_AND_NOT_SI, _net_141, _net_142);
not inst214  (_net_143, SE);
and inst215  (ENABLE_NOT_SE_AND_SI, SI, _net_143);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
      viol_2 = (viol_2 !== viol_all) ? viol_all : ~viol_2;
      viol_3 = (viol_3 !== viol_all) ? viol_all : ~viol_3;
   end 
`endif 
specify
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQM4SS_V2P1Y8_2

//%BEGIN HDBSVT11_FSDPQM4SS_V2Y8_1

`celldefine
module HDBSVT11_FSDPQM4SS_V2Y8_1 (Q0, Q1, Q2, Q3, CK, D0, D1, D2, D3, SI, SE);
   output Q0, Q1, Q2, Q3;
   input CK, D0, D1, D2, D3, SI, SE;

   reg viol_all, viol_0,  viol_1,  viol_2,  viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
`endif

   snps_mux2 inst7  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst9  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst10  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst11  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst12  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst13  (int_res__D2, int_res_iq1, delayed_D2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst14  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst15  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst16  (int_res__D3, int_res_iq2, delayed_D3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst17  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst18  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst19 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst20 (Q1, int_res_iq1);
        buf #`SNPS_SEQ_DELAY  inst21 (Q2, int_res_iq2);
        buf #`SNPS_SEQ_DELAY  inst22 (Q3, int_res_iq3);
   `else
        buf inst23  (Q0, int_res_iq0);
        buf inst24  (Q1, int_res_iq1);
        buf inst25  (Q2, int_res_iq2);
        buf inst26  (Q3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst27  (_net_0, D1);
not inst28  (_net_1, D0);
not inst29  (_net_2, D2);
not inst30  (_net_3, D3);
not inst31  (_net_4, SE);
not inst32  (_net_5, SI);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5);
not inst34  (_net_6, D1);
not inst35  (_net_7, D0);
not inst36  (_net_8, D2);
not inst37  (_net_9, D3);
not inst38  (_net_10, SE);
and inst39  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_6, _net_7, _net_8, _net_9, _net_10, SI);
not inst40  (_net_11, D1);
not inst41  (_net_12, D0);
not inst42  (_net_13, D2);
not inst43  (_net_14, D3);
not inst44  (_net_15, SI);
and inst45  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_11, _net_12, _net_13, _net_14, SE, _net_15);
not inst46  (_net_16, D1);
not inst47  (_net_17, D0);
not inst48  (_net_18, D2);
not inst49  (_net_19, D3);
and inst50  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_16, _net_17, _net_18, _net_19, SE, SI);
not inst51  (_net_20, D1);
not inst52  (_net_21, D0);
not inst53  (_net_22, D2);
not inst54  (_net_23, SE);
not inst55  (_net_24, SI);
and inst56  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22, D3, _net_23, _net_24);
not inst57  (_net_25, D1);
not inst58  (_net_26, D0);
not inst59  (_net_27, D2);
not inst60  (_net_28, SE);
and inst61  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_25, _net_26, _net_27, D3, _net_28, SI);
not inst62  (_net_29, D1);
not inst63  (_net_30, D0);
not inst64  (_net_31, D2);
not inst65  (_net_32, SI);
and inst66  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI, _net_29, _net_30, _net_31, D3, SE, _net_32);
not inst67  (_net_33, D1);
not inst68  (_net_34, D0);
not inst69  (_net_35, D2);
and inst70  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_33, _net_34, _net_35, D3, SE, SI);
not inst71  (_net_36, D1);
not inst72  (_net_37, D0);
not inst73  (_net_38, D3);
not inst74  (_net_39, SE);
not inst75  (_net_40, SI);
and inst76  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, D2, _net_38, _net_39, _net_40);
not inst77  (_net_41, D1);
not inst78  (_net_42, D0);
not inst79  (_net_43, D3);
not inst80  (_net_44, SE);
and inst81  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_41, _net_42, D2, _net_43, _net_44, SI);
not inst82  (_net_45, D1);
not inst83  (_net_46, D0);
not inst84  (_net_47, D3);
not inst85  (_net_48, SI);
and inst86  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_45, _net_46, D2, _net_47, SE, _net_48);
not inst87  (_net_49, D1);
not inst88  (_net_50, D0);
not inst89  (_net_51, D3);
and inst90  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_49, _net_50, D2, _net_51, SE, SI);
not inst91  (_net_52, D1);
not inst92  (_net_53, D0);
not inst93  (_net_54, SE);
not inst94  (_net_55, SI);
and inst95  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_52, _net_53, D2, D3, _net_54, _net_55);
not inst96  (_net_56, D1);
not inst97  (_net_57, D0);
not inst98  (_net_58, SE);
and inst99  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_56, _net_57, D2, D3, _net_58, SI);
not inst100  (_net_59, D1);
not inst101  (_net_60, D0);
not inst102  (_net_61, SI);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_59, _net_60, D2, D3, SE, _net_61);
not inst104  (_net_62, D1);
not inst105  (_net_63, D0);
and inst106  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_62, _net_63, D2, D3, SE, SI);
not inst107  (_net_64, D0);
not inst108  (_net_65, D2);
not inst109  (_net_66, D3);
not inst110  (_net_67, SE);
not inst111  (_net_68, SI);
and inst112  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_64, _net_65, _net_66, _net_67, _net_68);
not inst113  (_net_69, D0);
not inst114  (_net_70, D2);
not inst115  (_net_71, D3);
not inst116  (_net_72, SE);
and inst117  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_69, _net_70, _net_71, _net_72, SI);
not inst118  (_net_73, D0);
not inst119  (_net_74, D2);
not inst120  (_net_75, D3);
not inst121  (_net_76, SI);
and inst122  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D1, _net_73, _net_74, _net_75, SE, _net_76);
not inst123  (_net_77, D0);
not inst124  (_net_78, D2);
not inst125  (_net_79, D3);
and inst126  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D1, _net_77, _net_78, _net_79, SE, SI);
not inst127  (_net_80, D1);
not inst128  (_net_81, D2);
not inst129  (_net_82, D3);
not inst130  (_net_83, SE);
not inst131  (_net_84, SI);
and inst132  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_80, D0, _net_81, _net_82, _net_83, _net_84);
not inst133  (_net_85, D1);
not inst134  (_net_86, D2);
not inst135  (_net_87, D3);
not inst136  (_net_88, SE);
and inst137  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_85, D0, _net_86, _net_87, _net_88, SI);
not inst138  (_net_89, D1);
not inst139  (_net_90, D2);
not inst140  (_net_91, D3);
not inst141  (_net_92, SI);
and inst142  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_89, D0, _net_90, _net_91, SE, _net_92);
not inst143  (_net_93, D1);
not inst144  (_net_94, D2);
not inst145  (_net_95, D3);
and inst146  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_93, D0, _net_94, _net_95, SE, SI);
not inst147  (_net_96, D1);
not inst148  (_net_97, D3);
not inst149  (_net_98, SE);
not inst150  (_net_99, SI);
and inst151  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_96, D0, D2, _net_97, _net_98, _net_99);
not inst152  (_net_100, D1);
not inst153  (_net_101, D3);
not inst154  (_net_102, SE);
and inst155  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_100, D0, D2, _net_101, _net_102, SI);
not inst156  (_net_103, D1);
not inst157  (_net_104, D3);
not inst158  (_net_105, SI);
and inst159  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_103, D0, D2, _net_104, SE, _net_105);
not inst160  (_net_106, D1);
not inst161  (_net_107, D3);
and inst162  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_106, D0, D2, _net_107, SE, SI);
not inst163  (_net_108, D1);
not inst164  (_net_109, SE);
not inst165  (_net_110, SI);
and inst166  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_108, D0, D2, D3, _net_109, _net_110);
not inst167  (_net_111, D1);
not inst168  (_net_112, SE);
and inst169  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_111, D0, D2, D3, _net_112, SI);
not inst170  (_net_113, D1);
not inst171  (_net_114, SI);
and inst172  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_113, D0, D2, D3, SE, _net_114);
not inst173  (_net_115, D1);
and inst174  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_115, D0, D2, D3, SE, SI);
not inst175  (_net_116, SE);
not inst176  (_net_117, SI);
and inst177  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, _net_116, _net_117);
not inst178  (_net_118, SE);
and inst179  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D1, D0, D2, D3, _net_118, SI);
not inst180  (_net_119, SI);
and inst181  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D1, D0, D2, D3, SE, _net_119);
and inst182  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI, D1, D0, D2, D3, SE, SI);
not inst183  (_net_120, D1);
not inst184  (_net_121, D0);
not inst185  (_net_122, D2);
not inst186  (_net_123, D3);
and inst187  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI, _net_120, _net_121, _net_122, _net_123, SI);
not inst188  (_net_124, D1);
not inst189  (_net_125, D0);
not inst190  (_net_126, D2);
not inst191  (_net_127, SI);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI, _net_124, _net_125, _net_126, D3, _net_127);
not inst193  (_net_128, D1);
not inst194  (_net_129, D0);
not inst195  (_net_130, D3);
not inst196  (_net_131, SI);
and inst197  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI, _net_128, _net_129, D2, _net_130, _net_131);
not inst198  (_net_132, D0);
not inst199  (_net_133, D2);
not inst200  (_net_134, D3);
not inst201  (_net_135, SI);
and inst202  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, D1, _net_132, _net_133, _net_134, _net_135);
not inst203  (_net_136, D1);
not inst204  (_net_137, D2);
not inst205  (_net_138, D3);
not inst206  (_net_139, SI);
and inst207  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, _net_136, D0, _net_137, _net_138, _net_139);
not inst208  (_net_140, D0);
and inst209  (ENABLE_NOT_D0_AND_SE, SE, _net_140);
and inst210  (ENABLE_D0_AND_SE, SE, D0);
not inst211  (_net_141, SI);
not inst212  (_net_142, SE);
and inst213  (ENABLE_NOT_SE_AND_NOT_SI, _net_141, _net_142);
not inst214  (_net_143, SE);
and inst215  (ENABLE_NOT_SE_AND_SI, SI, _net_143);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
      viol_2 = (viol_2 !== viol_all) ? viol_all : ~viol_2;
      viol_3 = (viol_3 !== viol_all) ? viol_all : ~viol_3;
   end 
`endif 
specify
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQM4SS_V2Y8_1

//%BEGIN HDBSVT11_FSDPQM4SS_V2Y8_2

`celldefine
module HDBSVT11_FSDPQM4SS_V2Y8_2 (Q0, Q1, Q2, Q3, CK, D0, D1, D2, D3, SI, SE);
   output Q0, Q1, Q2, Q3;
   input CK, D0, D1, D2, D3, SI, SE;

   reg viol_all, viol_0,  viol_1,  viol_2,  viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
`endif

   snps_mux2 inst7  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst9  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst10  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst11  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst12  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst13  (int_res__D2, int_res_iq1, delayed_D2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst14  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst15  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst16  (int_res__D3, int_res_iq2, delayed_D3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst17  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst18  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst19 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst20 (Q1, int_res_iq1);
        buf #`SNPS_SEQ_DELAY  inst21 (Q2, int_res_iq2);
        buf #`SNPS_SEQ_DELAY  inst22 (Q3, int_res_iq3);
   `else
        buf inst23  (Q0, int_res_iq0);
        buf inst24  (Q1, int_res_iq1);
        buf inst25  (Q2, int_res_iq2);
        buf inst26  (Q3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst27  (_net_0, D1);
not inst28  (_net_1, D0);
not inst29  (_net_2, D2);
not inst30  (_net_3, D3);
not inst31  (_net_4, SE);
not inst32  (_net_5, SI);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5);
not inst34  (_net_6, D1);
not inst35  (_net_7, D0);
not inst36  (_net_8, D2);
not inst37  (_net_9, D3);
not inst38  (_net_10, SE);
and inst39  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_6, _net_7, _net_8, _net_9, _net_10, SI);
not inst40  (_net_11, D1);
not inst41  (_net_12, D0);
not inst42  (_net_13, D2);
not inst43  (_net_14, D3);
not inst44  (_net_15, SI);
and inst45  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_11, _net_12, _net_13, _net_14, SE, _net_15);
not inst46  (_net_16, D1);
not inst47  (_net_17, D0);
not inst48  (_net_18, D2);
not inst49  (_net_19, D3);
and inst50  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_16, _net_17, _net_18, _net_19, SE, SI);
not inst51  (_net_20, D1);
not inst52  (_net_21, D0);
not inst53  (_net_22, D2);
not inst54  (_net_23, SE);
not inst55  (_net_24, SI);
and inst56  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22, D3, _net_23, _net_24);
not inst57  (_net_25, D1);
not inst58  (_net_26, D0);
not inst59  (_net_27, D2);
not inst60  (_net_28, SE);
and inst61  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_25, _net_26, _net_27, D3, _net_28, SI);
not inst62  (_net_29, D1);
not inst63  (_net_30, D0);
not inst64  (_net_31, D2);
not inst65  (_net_32, SI);
and inst66  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI, _net_29, _net_30, _net_31, D3, SE, _net_32);
not inst67  (_net_33, D1);
not inst68  (_net_34, D0);
not inst69  (_net_35, D2);
and inst70  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_33, _net_34, _net_35, D3, SE, SI);
not inst71  (_net_36, D1);
not inst72  (_net_37, D0);
not inst73  (_net_38, D3);
not inst74  (_net_39, SE);
not inst75  (_net_40, SI);
and inst76  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, D2, _net_38, _net_39, _net_40);
not inst77  (_net_41, D1);
not inst78  (_net_42, D0);
not inst79  (_net_43, D3);
not inst80  (_net_44, SE);
and inst81  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_41, _net_42, D2, _net_43, _net_44, SI);
not inst82  (_net_45, D1);
not inst83  (_net_46, D0);
not inst84  (_net_47, D3);
not inst85  (_net_48, SI);
and inst86  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_45, _net_46, D2, _net_47, SE, _net_48);
not inst87  (_net_49, D1);
not inst88  (_net_50, D0);
not inst89  (_net_51, D3);
and inst90  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_49, _net_50, D2, _net_51, SE, SI);
not inst91  (_net_52, D1);
not inst92  (_net_53, D0);
not inst93  (_net_54, SE);
not inst94  (_net_55, SI);
and inst95  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_52, _net_53, D2, D3, _net_54, _net_55);
not inst96  (_net_56, D1);
not inst97  (_net_57, D0);
not inst98  (_net_58, SE);
and inst99  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_56, _net_57, D2, D3, _net_58, SI);
not inst100  (_net_59, D1);
not inst101  (_net_60, D0);
not inst102  (_net_61, SI);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_59, _net_60, D2, D3, SE, _net_61);
not inst104  (_net_62, D1);
not inst105  (_net_63, D0);
and inst106  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_62, _net_63, D2, D3, SE, SI);
not inst107  (_net_64, D0);
not inst108  (_net_65, D2);
not inst109  (_net_66, D3);
not inst110  (_net_67, SE);
not inst111  (_net_68, SI);
and inst112  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_64, _net_65, _net_66, _net_67, _net_68);
not inst113  (_net_69, D0);
not inst114  (_net_70, D2);
not inst115  (_net_71, D3);
not inst116  (_net_72, SE);
and inst117  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_69, _net_70, _net_71, _net_72, SI);
not inst118  (_net_73, D0);
not inst119  (_net_74, D2);
not inst120  (_net_75, D3);
not inst121  (_net_76, SI);
and inst122  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D1, _net_73, _net_74, _net_75, SE, _net_76);
not inst123  (_net_77, D0);
not inst124  (_net_78, D2);
not inst125  (_net_79, D3);
and inst126  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D1, _net_77, _net_78, _net_79, SE, SI);
not inst127  (_net_80, D1);
not inst128  (_net_81, D2);
not inst129  (_net_82, D3);
not inst130  (_net_83, SE);
not inst131  (_net_84, SI);
and inst132  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_80, D0, _net_81, _net_82, _net_83, _net_84);
not inst133  (_net_85, D1);
not inst134  (_net_86, D2);
not inst135  (_net_87, D3);
not inst136  (_net_88, SE);
and inst137  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_85, D0, _net_86, _net_87, _net_88, SI);
not inst138  (_net_89, D1);
not inst139  (_net_90, D2);
not inst140  (_net_91, D3);
not inst141  (_net_92, SI);
and inst142  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_89, D0, _net_90, _net_91, SE, _net_92);
not inst143  (_net_93, D1);
not inst144  (_net_94, D2);
not inst145  (_net_95, D3);
and inst146  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_93, D0, _net_94, _net_95, SE, SI);
not inst147  (_net_96, D1);
not inst148  (_net_97, D3);
not inst149  (_net_98, SE);
not inst150  (_net_99, SI);
and inst151  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_96, D0, D2, _net_97, _net_98, _net_99);
not inst152  (_net_100, D1);
not inst153  (_net_101, D3);
not inst154  (_net_102, SE);
and inst155  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_100, D0, D2, _net_101, _net_102, SI);
not inst156  (_net_103, D1);
not inst157  (_net_104, D3);
not inst158  (_net_105, SI);
and inst159  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_103, D0, D2, _net_104, SE, _net_105);
not inst160  (_net_106, D1);
not inst161  (_net_107, D3);
and inst162  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_106, D0, D2, _net_107, SE, SI);
not inst163  (_net_108, D1);
not inst164  (_net_109, SE);
not inst165  (_net_110, SI);
and inst166  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_108, D0, D2, D3, _net_109, _net_110);
not inst167  (_net_111, D1);
not inst168  (_net_112, SE);
and inst169  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_111, D0, D2, D3, _net_112, SI);
not inst170  (_net_113, D1);
not inst171  (_net_114, SI);
and inst172  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_113, D0, D2, D3, SE, _net_114);
not inst173  (_net_115, D1);
and inst174  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_115, D0, D2, D3, SE, SI);
not inst175  (_net_116, SE);
not inst176  (_net_117, SI);
and inst177  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, _net_116, _net_117);
not inst178  (_net_118, SE);
and inst179  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D1, D0, D2, D3, _net_118, SI);
not inst180  (_net_119, SI);
and inst181  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D1, D0, D2, D3, SE, _net_119);
and inst182  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI, D1, D0, D2, D3, SE, SI);
not inst183  (_net_120, D1);
not inst184  (_net_121, D0);
not inst185  (_net_122, D2);
not inst186  (_net_123, D3);
and inst187  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI, _net_120, _net_121, _net_122, _net_123, SI);
not inst188  (_net_124, D1);
not inst189  (_net_125, D0);
not inst190  (_net_126, D2);
not inst191  (_net_127, SI);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI, _net_124, _net_125, _net_126, D3, _net_127);
not inst193  (_net_128, D1);
not inst194  (_net_129, D0);
not inst195  (_net_130, D3);
not inst196  (_net_131, SI);
and inst197  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI, _net_128, _net_129, D2, _net_130, _net_131);
not inst198  (_net_132, D0);
not inst199  (_net_133, D2);
not inst200  (_net_134, D3);
not inst201  (_net_135, SI);
and inst202  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, D1, _net_132, _net_133, _net_134, _net_135);
not inst203  (_net_136, D1);
not inst204  (_net_137, D2);
not inst205  (_net_138, D3);
not inst206  (_net_139, SI);
and inst207  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI, _net_136, D0, _net_137, _net_138, _net_139);
not inst208  (_net_140, D0);
and inst209  (ENABLE_NOT_D0_AND_SE, SE, _net_140);
and inst210  (ENABLE_D0_AND_SE, SE, D0);
not inst211  (_net_141, SI);
not inst212  (_net_142, SE);
and inst213  (ENABLE_NOT_SE_AND_NOT_SI, _net_141, _net_142);
not inst214  (_net_143, SE);
and inst215  (ENABLE_NOT_SE_AND_SI, SI, _net_143);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
      viol_2 = (viol_2 !== viol_all) ? viol_all : ~viol_2;
      viol_3 = (viol_3 !== viol_all) ? viol_all : ~viol_3;
   end 
`endif 
specify
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQM4SS_V2Y8_2

//%BEGIN HDBSVT11_FSDPQM8SS_V2Y16_1

`celldefine
module HDBSVT11_FSDPQM8SS_V2Y16_1 (Q0, Q1, Q2, Q3, Q4, Q5, Q6, Q7, CK, D0, D1, D2, D3, D4, D5, D6, D7, SI, SE);
   output Q0, Q1, Q2, Q3, Q4, Q5, Q6, Q7;
   input CK, D0, D1, D2, D3, D4, D5, D6, D7, SI, SE;

   reg viol_all, viol_0,  viol_1,  viol_2,  viol_3,  viol_4,  viol_5,  viol_6,  viol_7;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3, delayed_D4, delayed_D5, delayed_D6, delayed_D7, 
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res__D4, int_res__D5, int_res__D6, int_res__D7, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, int_res_iq4, int_res_iq5, int_res_iq6, int_res_iq7, 
        xcr_0, xcr_1, xcr_2, xcr_3, xcr_4, xcr_5, xcr_6, xcr_7;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_D4, D4);
   buf inst6  (delayed_D5, D5);
   buf inst7  (delayed_D6, D6);
   buf inst8  (delayed_D7, D7);
   buf inst9  (delayed_SI, SI);
   buf inst10  (delayed_SE, SE);
`endif

   snps_mux2 inst11  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst12  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst13  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst14  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst15  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst16  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst17  (int_res__D2, int_res_iq1, delayed_D2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst18  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst19  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst20  (int_res__D3, int_res_iq2, delayed_D3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst21  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst22  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   snps_mux2 inst23  (int_res__D4, int_res_iq3, delayed_D4, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst24  (xcr_4, delayed_CK, int_res__D4);

  `endif
   snps_dff inst25  (int_res_iq4, viol_4, delayed_CK, int_res__D4, xcr_4);

   snps_mux2 inst26  (int_res__D5, int_res_iq4, delayed_D5, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst27  (xcr_5, delayed_CK, int_res__D5);

  `endif
   snps_dff inst28  (int_res_iq5, viol_5, delayed_CK, int_res__D5, xcr_5);

   snps_mux2 inst29  (int_res__D6, int_res_iq5, delayed_D6, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst30  (xcr_6, delayed_CK, int_res__D6);

  `endif
   snps_dff inst31  (int_res_iq6, viol_6, delayed_CK, int_res__D6, xcr_6);

   snps_mux2 inst32  (int_res__D7, int_res_iq6, delayed_D7, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst33  (xcr_7, delayed_CK, int_res__D7);

  `endif
   snps_dff inst34  (int_res_iq7, viol_7, delayed_CK, int_res__D7, xcr_7);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst35 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst36 (Q1, int_res_iq1);
        buf #`SNPS_SEQ_DELAY  inst37 (Q2, int_res_iq2);
        buf #`SNPS_SEQ_DELAY  inst38 (Q3, int_res_iq3);
        buf #`SNPS_SEQ_DELAY  inst39 (Q4, int_res_iq4);
        buf #`SNPS_SEQ_DELAY  inst40 (Q5, int_res_iq5);
        buf #`SNPS_SEQ_DELAY  inst41 (Q6, int_res_iq6);
        buf #`SNPS_SEQ_DELAY  inst42 (Q7, int_res_iq7);
   `else
        buf inst43  (Q0, int_res_iq0);
        buf inst44  (Q1, int_res_iq1);
        buf inst45  (Q2, int_res_iq2);
        buf inst46  (Q3, int_res_iq3);
        buf inst47  (Q4, int_res_iq4);
        buf inst48  (Q5, int_res_iq5);
        buf inst49  (Q6, int_res_iq6);
        buf inst50  (Q7, int_res_iq7);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst51  (_net_0, D1);
not inst52  (_net_1, D0);
not inst53  (_net_2, D2);
not inst54  (_net_3, D3);
not inst55  (_net_4, D4);
not inst56  (_net_5, D5);
not inst57  (_net_6, D6);
not inst58  (_net_7, D7);
not inst59  (_net_8, SE);
not inst60  (_net_9, SI);
and inst61  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5, _net_6, _net_7, _net_8, _net_9);
not inst62  (_net_10, D1);
not inst63  (_net_11, D0);
not inst64  (_net_12, D2);
not inst65  (_net_13, D3);
not inst66  (_net_14, D4);
not inst67  (_net_15, D5);
not inst68  (_net_16, D6);
not inst69  (_net_17, D7);
not inst70  (_net_18, SE);
and inst71  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, _net_13, _net_14, _net_15, _net_16, _net_17, _net_18, SI);
not inst72  (_net_19, D1);
not inst73  (_net_20, D0);
not inst74  (_net_21, D2);
not inst75  (_net_22, D3);
not inst76  (_net_23, D4);
not inst77  (_net_24, D5);
not inst78  (_net_25, D6);
not inst79  (_net_26, D7);
not inst80  (_net_27, SI);
and inst81  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_19, _net_20, _net_21, _net_22, _net_23, _net_24, _net_25, _net_26, SE, _net_27);
not inst82  (_net_28, D1);
not inst83  (_net_29, D0);
not inst84  (_net_30, D2);
not inst85  (_net_31, D3);
not inst86  (_net_32, D4);
not inst87  (_net_33, D5);
not inst88  (_net_34, D6);
not inst89  (_net_35, D7);
and inst90  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_28, _net_29, _net_30, _net_31, _net_32, _net_33, _net_34, _net_35, SE, SI);
not inst91  (_net_36, D1);
not inst92  (_net_37, D0);
not inst93  (_net_38, D2);
not inst94  (_net_39, D3);
not inst95  (_net_40, D4);
not inst96  (_net_41, D5);
not inst97  (_net_42, D6);
not inst98  (_net_43, SE);
not inst99  (_net_44, SI);
and inst100  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, _net_38, _net_39, _net_40, _net_41, _net_42, D7, _net_43, _net_44);
not inst101  (_net_45, D1);
not inst102  (_net_46, D0);
not inst103  (_net_47, D2);
not inst104  (_net_48, D3);
not inst105  (_net_49, D4);
not inst106  (_net_50, D5);
not inst107  (_net_51, D6);
not inst108  (_net_52, SE);
and inst109  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI, _net_45, _net_46, _net_47, _net_48, _net_49, _net_50, _net_51, D7, _net_52, SI);
not inst110  (_net_53, D1);
not inst111  (_net_54, D0);
not inst112  (_net_55, D2);
not inst113  (_net_56, D3);
not inst114  (_net_57, D4);
not inst115  (_net_58, D5);
not inst116  (_net_59, D6);
not inst117  (_net_60, SI);
and inst118  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_NOT_SI, _net_53, _net_54, _net_55, _net_56, _net_57, _net_58, _net_59, D7, SE, _net_60);
not inst119  (_net_61, D1);
not inst120  (_net_62, D0);
not inst121  (_net_63, D2);
not inst122  (_net_64, D3);
not inst123  (_net_65, D4);
not inst124  (_net_66, D5);
not inst125  (_net_67, D6);
and inst126  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI, _net_61, _net_62, _net_63, _net_64, _net_65, _net_66, _net_67, D7, SE, SI);
not inst127  (_net_68, D1);
not inst128  (_net_69, D0);
not inst129  (_net_70, D2);
not inst130  (_net_71, D3);
not inst131  (_net_72, D4);
not inst132  (_net_73, D5);
not inst133  (_net_74, D7);
not inst134  (_net_75, SE);
not inst135  (_net_76, SI);
and inst136  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_68, _net_69, _net_70, _net_71, _net_72, _net_73, D6, _net_74, _net_75, _net_76);
not inst137  (_net_77, D1);
not inst138  (_net_78, D0);
not inst139  (_net_79, D2);
not inst140  (_net_80, D3);
not inst141  (_net_81, D4);
not inst142  (_net_82, D5);
not inst143  (_net_83, D7);
not inst144  (_net_84, SE);
and inst145  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_77, _net_78, _net_79, _net_80, _net_81, _net_82, D6, _net_83, _net_84, SI);
not inst146  (_net_85, D1);
not inst147  (_net_86, D0);
not inst148  (_net_87, D2);
not inst149  (_net_88, D3);
not inst150  (_net_89, D4);
not inst151  (_net_90, D5);
not inst152  (_net_91, D7);
not inst153  (_net_92, SI);
and inst154  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_85, _net_86, _net_87, _net_88, _net_89, _net_90, D6, _net_91, SE, _net_92);
not inst155  (_net_93, D1);
not inst156  (_net_94, D0);
not inst157  (_net_95, D2);
not inst158  (_net_96, D3);
not inst159  (_net_97, D4);
not inst160  (_net_98, D5);
not inst161  (_net_99, D7);
and inst162  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI, _net_93, _net_94, _net_95, _net_96, _net_97, _net_98, D6, _net_99, SE, SI);
not inst163  (_net_100, D1);
not inst164  (_net_101, D0);
not inst165  (_net_102, D2);
not inst166  (_net_103, D3);
not inst167  (_net_104, D4);
not inst168  (_net_105, D6);
not inst169  (_net_106, D7);
not inst170  (_net_107, SE);
not inst171  (_net_108, SI);
and inst172  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_100, _net_101, _net_102, _net_103, _net_104, D5, _net_105, _net_106, _net_107, _net_108);
not inst173  (_net_109, D1);
not inst174  (_net_110, D0);
not inst175  (_net_111, D2);
not inst176  (_net_112, D3);
not inst177  (_net_113, D4);
not inst178  (_net_114, D6);
not inst179  (_net_115, D7);
not inst180  (_net_116, SE);
and inst181  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_109, _net_110, _net_111, _net_112, _net_113, D5, _net_114, _net_115, _net_116, SI);
not inst182  (_net_117, D1);
not inst183  (_net_118, D0);
not inst184  (_net_119, D2);
not inst185  (_net_120, D3);
not inst186  (_net_121, D4);
not inst187  (_net_122, D6);
not inst188  (_net_123, D7);
not inst189  (_net_124, SI);
and inst190  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_117, _net_118, _net_119, _net_120, _net_121, D5, _net_122, _net_123, SE, _net_124);
not inst191  (_net_125, D1);
not inst192  (_net_126, D0);
not inst193  (_net_127, D2);
not inst194  (_net_128, D3);
not inst195  (_net_129, D4);
not inst196  (_net_130, D6);
not inst197  (_net_131, D7);
and inst198  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_125, _net_126, _net_127, _net_128, _net_129, D5, _net_130, _net_131, SE, SI);
not inst199  (_net_132, D1);
not inst200  (_net_133, D0);
not inst201  (_net_134, D2);
not inst202  (_net_135, D3);
not inst203  (_net_136, D5);
not inst204  (_net_137, D6);
not inst205  (_net_138, D7);
not inst206  (_net_139, SE);
not inst207  (_net_140, SI);
and inst208  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_132, _net_133, _net_134, _net_135, D4, _net_136, _net_137, _net_138, _net_139, _net_140);
not inst209  (_net_141, D1);
not inst210  (_net_142, D0);
not inst211  (_net_143, D2);
not inst212  (_net_144, D3);
not inst213  (_net_145, D5);
not inst214  (_net_146, D6);
not inst215  (_net_147, D7);
not inst216  (_net_148, SE);
and inst217  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_141, _net_142, _net_143, _net_144, D4, _net_145, _net_146, _net_147, _net_148, SI);
not inst218  (_net_149, D1);
not inst219  (_net_150, D0);
not inst220  (_net_151, D2);
not inst221  (_net_152, D3);
not inst222  (_net_153, D5);
not inst223  (_net_154, D6);
not inst224  (_net_155, D7);
not inst225  (_net_156, SI);
and inst226  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_149, _net_150, _net_151, _net_152, D4, _net_153, _net_154, _net_155, SE, _net_156);
not inst227  (_net_157, D1);
not inst228  (_net_158, D0);
not inst229  (_net_159, D2);
not inst230  (_net_160, D3);
not inst231  (_net_161, D5);
not inst232  (_net_162, D6);
not inst233  (_net_163, D7);
and inst234  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_157, _net_158, _net_159, _net_160, D4, _net_161, _net_162, _net_163, SE, SI);
not inst235  (_net_164, D1);
not inst236  (_net_165, D0);
not inst237  (_net_166, D2);
not inst238  (_net_167, D3);
not inst239  (_net_168, SE);
not inst240  (_net_169, SI);
and inst241  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_164, _net_165, _net_166, _net_167, D4, D5, D6, D7, _net_168, _net_169);
not inst242  (_net_170, D1);
not inst243  (_net_171, D0);
not inst244  (_net_172, D2);
not inst245  (_net_173, D3);
not inst246  (_net_174, SE);
and inst247  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, _net_170, _net_171, _net_172, _net_173, D4, D5, D6, D7, _net_174, SI);
not inst248  (_net_175, D1);
not inst249  (_net_176, D0);
not inst250  (_net_177, D2);
not inst251  (_net_178, D3);
not inst252  (_net_179, SI);
and inst253  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, _net_175, _net_176, _net_177, _net_178, D4, D5, D6, D7, SE, _net_179);
not inst254  (_net_180, D1);
not inst255  (_net_181, D0);
not inst256  (_net_182, D2);
not inst257  (_net_183, D3);
and inst258  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, _net_180, _net_181, _net_182, _net_183, D4, D5, D6, D7, SE, SI);
not inst259  (_net_184, D1);
not inst260  (_net_185, D0);
not inst261  (_net_186, D2);
not inst262  (_net_187, D4);
not inst263  (_net_188, D5);
not inst264  (_net_189, D6);
not inst265  (_net_190, D7);
not inst266  (_net_191, SE);
not inst267  (_net_192, SI);
and inst268  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_184, _net_185, _net_186, D3, _net_187, _net_188, _net_189, _net_190, _net_191, _net_192);
not inst269  (_net_193, D1);
not inst270  (_net_194, D0);
not inst271  (_net_195, D2);
not inst272  (_net_196, D4);
not inst273  (_net_197, D5);
not inst274  (_net_198, D6);
not inst275  (_net_199, D7);
not inst276  (_net_200, SE);
and inst277  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_193, _net_194, _net_195, D3, _net_196, _net_197, _net_198, _net_199, _net_200, SI);
not inst278  (_net_201, D1);
not inst279  (_net_202, D0);
not inst280  (_net_203, D2);
not inst281  (_net_204, D4);
not inst282  (_net_205, D5);
not inst283  (_net_206, D6);
not inst284  (_net_207, D7);
not inst285  (_net_208, SI);
and inst286  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_201, _net_202, _net_203, D3, _net_204, _net_205, _net_206, _net_207, SE, _net_208);
not inst287  (_net_209, D1);
not inst288  (_net_210, D0);
not inst289  (_net_211, D2);
not inst290  (_net_212, D4);
not inst291  (_net_213, D5);
not inst292  (_net_214, D6);
not inst293  (_net_215, D7);
and inst294  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_209, _net_210, _net_211, D3, _net_212, _net_213, _net_214, _net_215, SE, SI);
not inst295  (_net_216, D1);
not inst296  (_net_217, D0);
not inst297  (_net_218, D3);
not inst298  (_net_219, D4);
not inst299  (_net_220, D5);
not inst300  (_net_221, D6);
not inst301  (_net_222, D7);
not inst302  (_net_223, SE);
not inst303  (_net_224, SI);
and inst304  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_216, _net_217, D2, _net_218, _net_219, _net_220, _net_221, _net_222, _net_223, _net_224);
not inst305  (_net_225, D1);
not inst306  (_net_226, D0);
not inst307  (_net_227, D3);
not inst308  (_net_228, D4);
not inst309  (_net_229, D5);
not inst310  (_net_230, D6);
not inst311  (_net_231, D7);
not inst312  (_net_232, SE);
and inst313  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_225, _net_226, D2, _net_227, _net_228, _net_229, _net_230, _net_231, _net_232, SI);
not inst314  (_net_233, D1);
not inst315  (_net_234, D0);
not inst316  (_net_235, D3);
not inst317  (_net_236, D4);
not inst318  (_net_237, D5);
not inst319  (_net_238, D6);
not inst320  (_net_239, D7);
not inst321  (_net_240, SI);
and inst322  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_233, _net_234, D2, _net_235, _net_236, _net_237, _net_238, _net_239, SE, _net_240);
not inst323  (_net_241, D1);
not inst324  (_net_242, D0);
not inst325  (_net_243, D3);
not inst326  (_net_244, D4);
not inst327  (_net_245, D5);
not inst328  (_net_246, D6);
not inst329  (_net_247, D7);
and inst330  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_241, _net_242, D2, _net_243, _net_244, _net_245, _net_246, _net_247, SE, SI);
not inst331  (_net_248, D0);
not inst332  (_net_249, D2);
not inst333  (_net_250, D3);
not inst334  (_net_251, D4);
not inst335  (_net_252, D5);
not inst336  (_net_253, D6);
not inst337  (_net_254, D7);
not inst338  (_net_255, SE);
not inst339  (_net_256, SI);
and inst340  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, D1, _net_248, _net_249, _net_250, _net_251, _net_252, _net_253, _net_254, _net_255, _net_256);
not inst341  (_net_257, D0);
not inst342  (_net_258, D2);
not inst343  (_net_259, D3);
not inst344  (_net_260, D4);
not inst345  (_net_261, D5);
not inst346  (_net_262, D6);
not inst347  (_net_263, D7);
not inst348  (_net_264, SE);
and inst349  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, D1, _net_257, _net_258, _net_259, _net_260, _net_261, _net_262, _net_263, _net_264, SI);
not inst350  (_net_265, D0);
not inst351  (_net_266, D2);
not inst352  (_net_267, D3);
not inst353  (_net_268, D4);
not inst354  (_net_269, D5);
not inst355  (_net_270, D6);
not inst356  (_net_271, D7);
not inst357  (_net_272, SI);
and inst358  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, D1, _net_265, _net_266, _net_267, _net_268, _net_269, _net_270, _net_271, SE, _net_272);
not inst359  (_net_273, D0);
not inst360  (_net_274, D2);
not inst361  (_net_275, D3);
not inst362  (_net_276, D4);
not inst363  (_net_277, D5);
not inst364  (_net_278, D6);
not inst365  (_net_279, D7);
and inst366  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, D1, _net_273, _net_274, _net_275, _net_276, _net_277, _net_278, _net_279, SE, SI);
not inst367  (_net_280, D1);
not inst368  (_net_281, D2);
not inst369  (_net_282, D3);
not inst370  (_net_283, D4);
not inst371  (_net_284, D5);
not inst372  (_net_285, D6);
not inst373  (_net_286, D7);
not inst374  (_net_287, SE);
not inst375  (_net_288, SI);
and inst376  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_280, D0, _net_281, _net_282, _net_283, _net_284, _net_285, _net_286, _net_287, _net_288);
not inst377  (_net_289, D1);
not inst378  (_net_290, D2);
not inst379  (_net_291, D3);
not inst380  (_net_292, D4);
not inst381  (_net_293, D5);
not inst382  (_net_294, D6);
not inst383  (_net_295, D7);
not inst384  (_net_296, SE);
and inst385  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_289, D0, _net_290, _net_291, _net_292, _net_293, _net_294, _net_295, _net_296, SI);
not inst386  (_net_297, D1);
not inst387  (_net_298, D2);
not inst388  (_net_299, D3);
not inst389  (_net_300, D4);
not inst390  (_net_301, D5);
not inst391  (_net_302, D6);
not inst392  (_net_303, D7);
not inst393  (_net_304, SI);
and inst394  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_297, D0, _net_298, _net_299, _net_300, _net_301, _net_302, _net_303, SE, _net_304);
not inst395  (_net_305, D1);
not inst396  (_net_306, D2);
not inst397  (_net_307, D3);
not inst398  (_net_308, D4);
not inst399  (_net_309, D5);
not inst400  (_net_310, D6);
not inst401  (_net_311, D7);
and inst402  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_305, D0, _net_306, _net_307, _net_308, _net_309, _net_310, _net_311, SE, SI);
not inst403  (_net_312, D1);
not inst404  (_net_313, D2);
not inst405  (_net_314, D3);
not inst406  (_net_315, SE);
not inst407  (_net_316, SI);
and inst408  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_312, D0, _net_313, _net_314, D4, D5, D6, D7, _net_315, _net_316);
not inst409  (_net_317, D1);
not inst410  (_net_318, D2);
not inst411  (_net_319, D3);
not inst412  (_net_320, SE);
and inst413  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, _net_317, D0, _net_318, _net_319, D4, D5, D6, D7, _net_320, SI);
not inst414  (_net_321, D1);
not inst415  (_net_322, D2);
not inst416  (_net_323, D3);
not inst417  (_net_324, SI);
and inst418  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, _net_321, D0, _net_322, _net_323, D4, D5, D6, D7, SE, _net_324);
not inst419  (_net_325, D1);
not inst420  (_net_326, D2);
not inst421  (_net_327, D3);
and inst422  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, _net_325, D0, _net_326, _net_327, D4, D5, D6, D7, SE, SI);
not inst423  (_net_328, D1);
not inst424  (_net_329, D3);
not inst425  (_net_330, D5);
not inst426  (_net_331, D7);
not inst427  (_net_332, SE);
not inst428  (_net_333, SI);
and inst429  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_328, D0, D2, _net_329, D4, _net_330, D6, _net_331, _net_332, _net_333);
not inst430  (_net_334, D1);
not inst431  (_net_335, D3);
not inst432  (_net_336, D5);
not inst433  (_net_337, D7);
not inst434  (_net_338, SE);
and inst435  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_334, D0, D2, _net_335, D4, _net_336, D6, _net_337, _net_338, SI);
not inst436  (_net_339, D1);
not inst437  (_net_340, D3);
not inst438  (_net_341, D5);
not inst439  (_net_342, D7);
not inst440  (_net_343, SI);
and inst441  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_339, D0, D2, _net_340, D4, _net_341, D6, _net_342, SE, _net_343);
not inst442  (_net_344, D1);
not inst443  (_net_345, D3);
not inst444  (_net_346, D5);
not inst445  (_net_347, D7);
and inst446  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI, _net_344, D0, D2, _net_345, D4, _net_346, D6, _net_347, SE, SI);
not inst447  (_net_348, D1);
not inst448  (_net_349, D3);
not inst449  (_net_350, D5);
not inst450  (_net_351, SE);
not inst451  (_net_352, SI);
and inst452  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_348, D0, D2, _net_349, D4, _net_350, D6, D7, _net_351, _net_352);
not inst453  (_net_353, D1);
not inst454  (_net_354, D3);
not inst455  (_net_355, D5);
not inst456  (_net_356, SE);
and inst457  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, _net_353, D0, D2, _net_354, D4, _net_355, D6, D7, _net_356, SI);
not inst458  (_net_357, D1);
not inst459  (_net_358, D3);
not inst460  (_net_359, D5);
not inst461  (_net_360, SI);
and inst462  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, _net_357, D0, D2, _net_358, D4, _net_359, D6, D7, SE, _net_360);
not inst463  (_net_361, D1);
not inst464  (_net_362, D3);
not inst465  (_net_363, D5);
and inst466  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_SI, _net_361, D0, D2, _net_362, D4, _net_363, D6, D7, SE, SI);
not inst467  (_net_364, D1);
not inst468  (_net_365, D3);
not inst469  (_net_366, SE);
not inst470  (_net_367, SI);
and inst471  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_364, D0, D2, _net_365, D4, D5, D6, D7, _net_366, _net_367);
not inst472  (_net_368, D1);
not inst473  (_net_369, D3);
not inst474  (_net_370, SE);
and inst475  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, _net_368, D0, D2, _net_369, D4, D5, D6, D7, _net_370, SI);
not inst476  (_net_371, D1);
not inst477  (_net_372, D3);
not inst478  (_net_373, SI);
and inst479  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, _net_371, D0, D2, _net_372, D4, D5, D6, D7, SE, _net_373);
not inst480  (_net_374, D1);
not inst481  (_net_375, D3);
and inst482  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, _net_374, D0, D2, _net_375, D4, D5, D6, D7, SE, SI);
not inst483  (_net_376, SE);
not inst484  (_net_377, SI);
and inst485  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, D4, D5, D6, D7, _net_376, _net_377);
not inst486  (_net_378, SE);
and inst487  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, _net_378, SI);
not inst488  (_net_379, SI);
and inst489  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D1, D0, D2, D3, D4, D5, D6, D7, SE, _net_379);
and inst490  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, SE, SI);
not inst491  (_net_380, D1);
not inst492  (_net_381, D0);
not inst493  (_net_382, D2);
not inst494  (_net_383, D3);
not inst495  (_net_384, D4);
not inst496  (_net_385, D5);
not inst497  (_net_386, D6);
not inst498  (_net_387, D7);
and inst499  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SI, _net_380, _net_381, _net_382, _net_383, _net_384, _net_385, _net_386, _net_387, SI);
not inst500  (_net_388, D1);
not inst501  (_net_389, D0);
not inst502  (_net_390, D2);
not inst503  (_net_391, D3);
not inst504  (_net_392, D4);
not inst505  (_net_393, D5);
not inst506  (_net_394, D6);
not inst507  (_net_395, SI);
and inst508  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SI, _net_388, _net_389, _net_390, _net_391, _net_392, _net_393, _net_394, D7, _net_395);
not inst509  (_net_396, D1);
not inst510  (_net_397, D0);
not inst511  (_net_398, D2);
not inst512  (_net_399, D3);
not inst513  (_net_400, D4);
not inst514  (_net_401, D5);
not inst515  (_net_402, D7);
not inst516  (_net_403, SI);
and inst517  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SI, _net_396, _net_397, _net_398, _net_399, _net_400, _net_401, D6, _net_402, _net_403);
not inst518  (_net_404, D1);
not inst519  (_net_405, D0);
not inst520  (_net_406, D2);
not inst521  (_net_407, D3);
not inst522  (_net_408, D4);
not inst523  (_net_409, D6);
not inst524  (_net_410, D7);
not inst525  (_net_411, SI);
and inst526  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI, _net_404, _net_405, _net_406, _net_407, _net_408, D5, _net_409, _net_410, _net_411);
not inst527  (_net_412, D1);
not inst528  (_net_413, D0);
not inst529  (_net_414, D2);
not inst530  (_net_415, D3);
not inst531  (_net_416, D5);
not inst532  (_net_417, D6);
not inst533  (_net_418, D7);
not inst534  (_net_419, SI);
and inst535  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI, _net_412, _net_413, _net_414, _net_415, D4, _net_416, _net_417, _net_418, _net_419);
not inst536  (_net_420, D1);
not inst537  (_net_421, D0);
not inst538  (_net_422, D2);
not inst539  (_net_423, D4);
not inst540  (_net_424, D5);
not inst541  (_net_425, D6);
not inst542  (_net_426, D7);
not inst543  (_net_427, SI);
and inst544  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI, _net_420, _net_421, _net_422, D3, _net_423, _net_424, _net_425, _net_426, _net_427);
not inst545  (_net_428, D1);
not inst546  (_net_429, D0);
not inst547  (_net_430, D3);
not inst548  (_net_431, D4);
not inst549  (_net_432, D5);
not inst550  (_net_433, D6);
not inst551  (_net_434, D7);
not inst552  (_net_435, SI);
and inst553  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI, _net_428, _net_429, D2, _net_430, _net_431, _net_432, _net_433, _net_434, _net_435);
not inst554  (_net_436, D0);
not inst555  (_net_437, D2);
not inst556  (_net_438, D3);
not inst557  (_net_439, D4);
not inst558  (_net_440, D5);
not inst559  (_net_441, D6);
not inst560  (_net_442, D7);
not inst561  (_net_443, SI);
and inst562  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI, D1, _net_436, _net_437, _net_438, _net_439, _net_440, _net_441, _net_442, _net_443);
not inst563  (_net_444, D1);
not inst564  (_net_445, D2);
not inst565  (_net_446, D3);
not inst566  (_net_447, D4);
not inst567  (_net_448, D5);
not inst568  (_net_449, D6);
not inst569  (_net_450, D7);
not inst570  (_net_451, SI);
and inst571  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI, _net_444, D0, _net_445, _net_446, _net_447, _net_448, _net_449, _net_450, _net_451);
not inst572  (_net_452, D0);
and inst573  (ENABLE_NOT_D0_AND_SE, SE, _net_452);
and inst574  (ENABLE_D0_AND_SE, SE, D0);
not inst575  (_net_453, SI);
not inst576  (_net_454, SE);
and inst577  (ENABLE_NOT_SE_AND_NOT_SI, _net_453, _net_454);
not inst578  (_net_455, SE);
and inst579  (ENABLE_NOT_SE_AND_SI, SI, _net_455);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
      viol_2 = (viol_2 !== viol_all) ? viol_all : ~viol_2;
      viol_3 = (viol_3 !== viol_all) ? viol_all : ~viol_3;
      viol_4 = (viol_4 !== viol_all) ? viol_all : ~viol_4;
      viol_5 = (viol_5 !== viol_all) ? viol_all : ~viol_5;
      viol_6 = (viol_6 !== viol_all) ? viol_all : ~viol_6;
      viol_7 = (viol_7 !== viol_all) ? viol_all : ~viol_7;
   end 
`endif 
specify
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
if (D4==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
(posedge CK => (Q4 : 1'b1))=(0, 0);
if (D5==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
(posedge CK => (Q5 : 1'b1))=(0, 0);
if (D6==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
(posedge CK => (Q6 : 1'b1))=(0, 0);
if (D7==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
(posedge CK => (Q7 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D4 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_4, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D4 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_4, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D4 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_4, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D4 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_4, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D5 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_5, , , delayed_CK, delayed_D5);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D5 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_5, , , delayed_CK, delayed_D5);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D5 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_5, , , delayed_CK, delayed_D5);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D5 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_5, , , delayed_CK, delayed_D5);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D6 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_6, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D6 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_6, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D6 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_6, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D6 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_6, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D7 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_7, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D7 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_7, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D7 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_7, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D7 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_7, , , delayed_CK, delayed_D7);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQM8SS_V2Y16_1

//%BEGIN HDBSVT11_FSDPQM8SS_V2Y16_2

`celldefine
module HDBSVT11_FSDPQM8SS_V2Y16_2 (Q0, Q1, Q2, Q3, Q4, Q5, Q6, Q7, CK, D0, D1, D2, D3, D4, D5, D6, D7, SI, SE);
   output Q0, Q1, Q2, Q3, Q4, Q5, Q6, Q7;
   input CK, D0, D1, D2, D3, D4, D5, D6, D7, SI, SE;

   reg viol_all, viol_0,  viol_1,  viol_2,  viol_3,  viol_4,  viol_5,  viol_6,  viol_7;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3, delayed_D4, delayed_D5, delayed_D6, delayed_D7, 
	delayed_SI, delayed_SE;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res__D4, int_res__D5, int_res__D6, int_res__D7, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, int_res_iq4, int_res_iq5, int_res_iq6, int_res_iq7, 
        xcr_0, xcr_1, xcr_2, xcr_3, xcr_4, xcr_5, xcr_6, xcr_7;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_D4, D4);
   buf inst6  (delayed_D5, D5);
   buf inst7  (delayed_D6, D6);
   buf inst8  (delayed_D7, D7);
   buf inst9  (delayed_SI, SI);
   buf inst10  (delayed_SE, SE);
`endif

   snps_mux2 inst11  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst12  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst13  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst14  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst15  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst16  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst17  (int_res__D2, int_res_iq1, delayed_D2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst18  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst19  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst20  (int_res__D3, int_res_iq2, delayed_D3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst21  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst22  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   snps_mux2 inst23  (int_res__D4, int_res_iq3, delayed_D4, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst24  (xcr_4, delayed_CK, int_res__D4);

  `endif
   snps_dff inst25  (int_res_iq4, viol_4, delayed_CK, int_res__D4, xcr_4);

   snps_mux2 inst26  (int_res__D5, int_res_iq4, delayed_D5, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst27  (xcr_5, delayed_CK, int_res__D5);

  `endif
   snps_dff inst28  (int_res_iq5, viol_5, delayed_CK, int_res__D5, xcr_5);

   snps_mux2 inst29  (int_res__D6, int_res_iq5, delayed_D6, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst30  (xcr_6, delayed_CK, int_res__D6);

  `endif
   snps_dff inst31  (int_res_iq6, viol_6, delayed_CK, int_res__D6, xcr_6);

   snps_mux2 inst32  (int_res__D7, int_res_iq6, delayed_D7, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst33  (xcr_7, delayed_CK, int_res__D7);

  `endif
   snps_dff inst34  (int_res_iq7, viol_7, delayed_CK, int_res__D7, xcr_7);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst35 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst36 (Q1, int_res_iq1);
        buf #`SNPS_SEQ_DELAY  inst37 (Q2, int_res_iq2);
        buf #`SNPS_SEQ_DELAY  inst38 (Q3, int_res_iq3);
        buf #`SNPS_SEQ_DELAY  inst39 (Q4, int_res_iq4);
        buf #`SNPS_SEQ_DELAY  inst40 (Q5, int_res_iq5);
        buf #`SNPS_SEQ_DELAY  inst41 (Q6, int_res_iq6);
        buf #`SNPS_SEQ_DELAY  inst42 (Q7, int_res_iq7);
   `else
        buf inst43  (Q0, int_res_iq0);
        buf inst44  (Q1, int_res_iq1);
        buf inst45  (Q2, int_res_iq2);
        buf inst46  (Q3, int_res_iq3);
        buf inst47  (Q4, int_res_iq4);
        buf inst48  (Q5, int_res_iq5);
        buf inst49  (Q6, int_res_iq6);
        buf inst50  (Q7, int_res_iq7);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst51  (_net_0, D1);
not inst52  (_net_1, D0);
not inst53  (_net_2, D2);
not inst54  (_net_3, D3);
not inst55  (_net_4, D4);
not inst56  (_net_5, D5);
not inst57  (_net_6, D6);
not inst58  (_net_7, D7);
not inst59  (_net_8, SE);
not inst60  (_net_9, SI);
and inst61  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5, _net_6, _net_7, _net_8, _net_9);
not inst62  (_net_10, D1);
not inst63  (_net_11, D0);
not inst64  (_net_12, D2);
not inst65  (_net_13, D3);
not inst66  (_net_14, D4);
not inst67  (_net_15, D5);
not inst68  (_net_16, D6);
not inst69  (_net_17, D7);
not inst70  (_net_18, SE);
and inst71  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, _net_13, _net_14, _net_15, _net_16, _net_17, _net_18, SI);
not inst72  (_net_19, D1);
not inst73  (_net_20, D0);
not inst74  (_net_21, D2);
not inst75  (_net_22, D3);
not inst76  (_net_23, D4);
not inst77  (_net_24, D5);
not inst78  (_net_25, D6);
not inst79  (_net_26, D7);
not inst80  (_net_27, SI);
and inst81  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_19, _net_20, _net_21, _net_22, _net_23, _net_24, _net_25, _net_26, SE, _net_27);
not inst82  (_net_28, D1);
not inst83  (_net_29, D0);
not inst84  (_net_30, D2);
not inst85  (_net_31, D3);
not inst86  (_net_32, D4);
not inst87  (_net_33, D5);
not inst88  (_net_34, D6);
not inst89  (_net_35, D7);
and inst90  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_28, _net_29, _net_30, _net_31, _net_32, _net_33, _net_34, _net_35, SE, SI);
not inst91  (_net_36, D1);
not inst92  (_net_37, D0);
not inst93  (_net_38, D2);
not inst94  (_net_39, D3);
not inst95  (_net_40, D4);
not inst96  (_net_41, D5);
not inst97  (_net_42, D6);
not inst98  (_net_43, SE);
not inst99  (_net_44, SI);
and inst100  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, _net_38, _net_39, _net_40, _net_41, _net_42, D7, _net_43, _net_44);
not inst101  (_net_45, D1);
not inst102  (_net_46, D0);
not inst103  (_net_47, D2);
not inst104  (_net_48, D3);
not inst105  (_net_49, D4);
not inst106  (_net_50, D5);
not inst107  (_net_51, D6);
not inst108  (_net_52, SE);
and inst109  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI, _net_45, _net_46, _net_47, _net_48, _net_49, _net_50, _net_51, D7, _net_52, SI);
not inst110  (_net_53, D1);
not inst111  (_net_54, D0);
not inst112  (_net_55, D2);
not inst113  (_net_56, D3);
not inst114  (_net_57, D4);
not inst115  (_net_58, D5);
not inst116  (_net_59, D6);
not inst117  (_net_60, SI);
and inst118  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_NOT_SI, _net_53, _net_54, _net_55, _net_56, _net_57, _net_58, _net_59, D7, SE, _net_60);
not inst119  (_net_61, D1);
not inst120  (_net_62, D0);
not inst121  (_net_63, D2);
not inst122  (_net_64, D3);
not inst123  (_net_65, D4);
not inst124  (_net_66, D5);
not inst125  (_net_67, D6);
and inst126  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI, _net_61, _net_62, _net_63, _net_64, _net_65, _net_66, _net_67, D7, SE, SI);
not inst127  (_net_68, D1);
not inst128  (_net_69, D0);
not inst129  (_net_70, D2);
not inst130  (_net_71, D3);
not inst131  (_net_72, D4);
not inst132  (_net_73, D5);
not inst133  (_net_74, D7);
not inst134  (_net_75, SE);
not inst135  (_net_76, SI);
and inst136  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_68, _net_69, _net_70, _net_71, _net_72, _net_73, D6, _net_74, _net_75, _net_76);
not inst137  (_net_77, D1);
not inst138  (_net_78, D0);
not inst139  (_net_79, D2);
not inst140  (_net_80, D3);
not inst141  (_net_81, D4);
not inst142  (_net_82, D5);
not inst143  (_net_83, D7);
not inst144  (_net_84, SE);
and inst145  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_77, _net_78, _net_79, _net_80, _net_81, _net_82, D6, _net_83, _net_84, SI);
not inst146  (_net_85, D1);
not inst147  (_net_86, D0);
not inst148  (_net_87, D2);
not inst149  (_net_88, D3);
not inst150  (_net_89, D4);
not inst151  (_net_90, D5);
not inst152  (_net_91, D7);
not inst153  (_net_92, SI);
and inst154  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_85, _net_86, _net_87, _net_88, _net_89, _net_90, D6, _net_91, SE, _net_92);
not inst155  (_net_93, D1);
not inst156  (_net_94, D0);
not inst157  (_net_95, D2);
not inst158  (_net_96, D3);
not inst159  (_net_97, D4);
not inst160  (_net_98, D5);
not inst161  (_net_99, D7);
and inst162  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI, _net_93, _net_94, _net_95, _net_96, _net_97, _net_98, D6, _net_99, SE, SI);
not inst163  (_net_100, D1);
not inst164  (_net_101, D0);
not inst165  (_net_102, D2);
not inst166  (_net_103, D3);
not inst167  (_net_104, D4);
not inst168  (_net_105, D6);
not inst169  (_net_106, D7);
not inst170  (_net_107, SE);
not inst171  (_net_108, SI);
and inst172  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_100, _net_101, _net_102, _net_103, _net_104, D5, _net_105, _net_106, _net_107, _net_108);
not inst173  (_net_109, D1);
not inst174  (_net_110, D0);
not inst175  (_net_111, D2);
not inst176  (_net_112, D3);
not inst177  (_net_113, D4);
not inst178  (_net_114, D6);
not inst179  (_net_115, D7);
not inst180  (_net_116, SE);
and inst181  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_109, _net_110, _net_111, _net_112, _net_113, D5, _net_114, _net_115, _net_116, SI);
not inst182  (_net_117, D1);
not inst183  (_net_118, D0);
not inst184  (_net_119, D2);
not inst185  (_net_120, D3);
not inst186  (_net_121, D4);
not inst187  (_net_122, D6);
not inst188  (_net_123, D7);
not inst189  (_net_124, SI);
and inst190  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_117, _net_118, _net_119, _net_120, _net_121, D5, _net_122, _net_123, SE, _net_124);
not inst191  (_net_125, D1);
not inst192  (_net_126, D0);
not inst193  (_net_127, D2);
not inst194  (_net_128, D3);
not inst195  (_net_129, D4);
not inst196  (_net_130, D6);
not inst197  (_net_131, D7);
and inst198  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_125, _net_126, _net_127, _net_128, _net_129, D5, _net_130, _net_131, SE, SI);
not inst199  (_net_132, D1);
not inst200  (_net_133, D0);
not inst201  (_net_134, D2);
not inst202  (_net_135, D3);
not inst203  (_net_136, D5);
not inst204  (_net_137, D6);
not inst205  (_net_138, D7);
not inst206  (_net_139, SE);
not inst207  (_net_140, SI);
and inst208  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_132, _net_133, _net_134, _net_135, D4, _net_136, _net_137, _net_138, _net_139, _net_140);
not inst209  (_net_141, D1);
not inst210  (_net_142, D0);
not inst211  (_net_143, D2);
not inst212  (_net_144, D3);
not inst213  (_net_145, D5);
not inst214  (_net_146, D6);
not inst215  (_net_147, D7);
not inst216  (_net_148, SE);
and inst217  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_141, _net_142, _net_143, _net_144, D4, _net_145, _net_146, _net_147, _net_148, SI);
not inst218  (_net_149, D1);
not inst219  (_net_150, D0);
not inst220  (_net_151, D2);
not inst221  (_net_152, D3);
not inst222  (_net_153, D5);
not inst223  (_net_154, D6);
not inst224  (_net_155, D7);
not inst225  (_net_156, SI);
and inst226  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_149, _net_150, _net_151, _net_152, D4, _net_153, _net_154, _net_155, SE, _net_156);
not inst227  (_net_157, D1);
not inst228  (_net_158, D0);
not inst229  (_net_159, D2);
not inst230  (_net_160, D3);
not inst231  (_net_161, D5);
not inst232  (_net_162, D6);
not inst233  (_net_163, D7);
and inst234  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_157, _net_158, _net_159, _net_160, D4, _net_161, _net_162, _net_163, SE, SI);
not inst235  (_net_164, D1);
not inst236  (_net_165, D0);
not inst237  (_net_166, D2);
not inst238  (_net_167, D3);
not inst239  (_net_168, SE);
not inst240  (_net_169, SI);
and inst241  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_164, _net_165, _net_166, _net_167, D4, D5, D6, D7, _net_168, _net_169);
not inst242  (_net_170, D1);
not inst243  (_net_171, D0);
not inst244  (_net_172, D2);
not inst245  (_net_173, D3);
not inst246  (_net_174, SE);
and inst247  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, _net_170, _net_171, _net_172, _net_173, D4, D5, D6, D7, _net_174, SI);
not inst248  (_net_175, D1);
not inst249  (_net_176, D0);
not inst250  (_net_177, D2);
not inst251  (_net_178, D3);
not inst252  (_net_179, SI);
and inst253  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, _net_175, _net_176, _net_177, _net_178, D4, D5, D6, D7, SE, _net_179);
not inst254  (_net_180, D1);
not inst255  (_net_181, D0);
not inst256  (_net_182, D2);
not inst257  (_net_183, D3);
and inst258  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, _net_180, _net_181, _net_182, _net_183, D4, D5, D6, D7, SE, SI);
not inst259  (_net_184, D1);
not inst260  (_net_185, D0);
not inst261  (_net_186, D2);
not inst262  (_net_187, D4);
not inst263  (_net_188, D5);
not inst264  (_net_189, D6);
not inst265  (_net_190, D7);
not inst266  (_net_191, SE);
not inst267  (_net_192, SI);
and inst268  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_184, _net_185, _net_186, D3, _net_187, _net_188, _net_189, _net_190, _net_191, _net_192);
not inst269  (_net_193, D1);
not inst270  (_net_194, D0);
not inst271  (_net_195, D2);
not inst272  (_net_196, D4);
not inst273  (_net_197, D5);
not inst274  (_net_198, D6);
not inst275  (_net_199, D7);
not inst276  (_net_200, SE);
and inst277  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_193, _net_194, _net_195, D3, _net_196, _net_197, _net_198, _net_199, _net_200, SI);
not inst278  (_net_201, D1);
not inst279  (_net_202, D0);
not inst280  (_net_203, D2);
not inst281  (_net_204, D4);
not inst282  (_net_205, D5);
not inst283  (_net_206, D6);
not inst284  (_net_207, D7);
not inst285  (_net_208, SI);
and inst286  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_201, _net_202, _net_203, D3, _net_204, _net_205, _net_206, _net_207, SE, _net_208);
not inst287  (_net_209, D1);
not inst288  (_net_210, D0);
not inst289  (_net_211, D2);
not inst290  (_net_212, D4);
not inst291  (_net_213, D5);
not inst292  (_net_214, D6);
not inst293  (_net_215, D7);
and inst294  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_209, _net_210, _net_211, D3, _net_212, _net_213, _net_214, _net_215, SE, SI);
not inst295  (_net_216, D1);
not inst296  (_net_217, D0);
not inst297  (_net_218, D3);
not inst298  (_net_219, D4);
not inst299  (_net_220, D5);
not inst300  (_net_221, D6);
not inst301  (_net_222, D7);
not inst302  (_net_223, SE);
not inst303  (_net_224, SI);
and inst304  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_216, _net_217, D2, _net_218, _net_219, _net_220, _net_221, _net_222, _net_223, _net_224);
not inst305  (_net_225, D1);
not inst306  (_net_226, D0);
not inst307  (_net_227, D3);
not inst308  (_net_228, D4);
not inst309  (_net_229, D5);
not inst310  (_net_230, D6);
not inst311  (_net_231, D7);
not inst312  (_net_232, SE);
and inst313  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_225, _net_226, D2, _net_227, _net_228, _net_229, _net_230, _net_231, _net_232, SI);
not inst314  (_net_233, D1);
not inst315  (_net_234, D0);
not inst316  (_net_235, D3);
not inst317  (_net_236, D4);
not inst318  (_net_237, D5);
not inst319  (_net_238, D6);
not inst320  (_net_239, D7);
not inst321  (_net_240, SI);
and inst322  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_233, _net_234, D2, _net_235, _net_236, _net_237, _net_238, _net_239, SE, _net_240);
not inst323  (_net_241, D1);
not inst324  (_net_242, D0);
not inst325  (_net_243, D3);
not inst326  (_net_244, D4);
not inst327  (_net_245, D5);
not inst328  (_net_246, D6);
not inst329  (_net_247, D7);
and inst330  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_241, _net_242, D2, _net_243, _net_244, _net_245, _net_246, _net_247, SE, SI);
not inst331  (_net_248, D0);
not inst332  (_net_249, D2);
not inst333  (_net_250, D3);
not inst334  (_net_251, D4);
not inst335  (_net_252, D5);
not inst336  (_net_253, D6);
not inst337  (_net_254, D7);
not inst338  (_net_255, SE);
not inst339  (_net_256, SI);
and inst340  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, D1, _net_248, _net_249, _net_250, _net_251, _net_252, _net_253, _net_254, _net_255, _net_256);
not inst341  (_net_257, D0);
not inst342  (_net_258, D2);
not inst343  (_net_259, D3);
not inst344  (_net_260, D4);
not inst345  (_net_261, D5);
not inst346  (_net_262, D6);
not inst347  (_net_263, D7);
not inst348  (_net_264, SE);
and inst349  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, D1, _net_257, _net_258, _net_259, _net_260, _net_261, _net_262, _net_263, _net_264, SI);
not inst350  (_net_265, D0);
not inst351  (_net_266, D2);
not inst352  (_net_267, D3);
not inst353  (_net_268, D4);
not inst354  (_net_269, D5);
not inst355  (_net_270, D6);
not inst356  (_net_271, D7);
not inst357  (_net_272, SI);
and inst358  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, D1, _net_265, _net_266, _net_267, _net_268, _net_269, _net_270, _net_271, SE, _net_272);
not inst359  (_net_273, D0);
not inst360  (_net_274, D2);
not inst361  (_net_275, D3);
not inst362  (_net_276, D4);
not inst363  (_net_277, D5);
not inst364  (_net_278, D6);
not inst365  (_net_279, D7);
and inst366  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, D1, _net_273, _net_274, _net_275, _net_276, _net_277, _net_278, _net_279, SE, SI);
not inst367  (_net_280, D1);
not inst368  (_net_281, D2);
not inst369  (_net_282, D3);
not inst370  (_net_283, D4);
not inst371  (_net_284, D5);
not inst372  (_net_285, D6);
not inst373  (_net_286, D7);
not inst374  (_net_287, SE);
not inst375  (_net_288, SI);
and inst376  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_280, D0, _net_281, _net_282, _net_283, _net_284, _net_285, _net_286, _net_287, _net_288);
not inst377  (_net_289, D1);
not inst378  (_net_290, D2);
not inst379  (_net_291, D3);
not inst380  (_net_292, D4);
not inst381  (_net_293, D5);
not inst382  (_net_294, D6);
not inst383  (_net_295, D7);
not inst384  (_net_296, SE);
and inst385  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_289, D0, _net_290, _net_291, _net_292, _net_293, _net_294, _net_295, _net_296, SI);
not inst386  (_net_297, D1);
not inst387  (_net_298, D2);
not inst388  (_net_299, D3);
not inst389  (_net_300, D4);
not inst390  (_net_301, D5);
not inst391  (_net_302, D6);
not inst392  (_net_303, D7);
not inst393  (_net_304, SI);
and inst394  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_297, D0, _net_298, _net_299, _net_300, _net_301, _net_302, _net_303, SE, _net_304);
not inst395  (_net_305, D1);
not inst396  (_net_306, D2);
not inst397  (_net_307, D3);
not inst398  (_net_308, D4);
not inst399  (_net_309, D5);
not inst400  (_net_310, D6);
not inst401  (_net_311, D7);
and inst402  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_305, D0, _net_306, _net_307, _net_308, _net_309, _net_310, _net_311, SE, SI);
not inst403  (_net_312, D1);
not inst404  (_net_313, D2);
not inst405  (_net_314, D3);
not inst406  (_net_315, SE);
not inst407  (_net_316, SI);
and inst408  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_312, D0, _net_313, _net_314, D4, D5, D6, D7, _net_315, _net_316);
not inst409  (_net_317, D1);
not inst410  (_net_318, D2);
not inst411  (_net_319, D3);
not inst412  (_net_320, SE);
and inst413  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, _net_317, D0, _net_318, _net_319, D4, D5, D6, D7, _net_320, SI);
not inst414  (_net_321, D1);
not inst415  (_net_322, D2);
not inst416  (_net_323, D3);
not inst417  (_net_324, SI);
and inst418  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, _net_321, D0, _net_322, _net_323, D4, D5, D6, D7, SE, _net_324);
not inst419  (_net_325, D1);
not inst420  (_net_326, D2);
not inst421  (_net_327, D3);
and inst422  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, _net_325, D0, _net_326, _net_327, D4, D5, D6, D7, SE, SI);
not inst423  (_net_328, D1);
not inst424  (_net_329, D3);
not inst425  (_net_330, D5);
not inst426  (_net_331, D7);
not inst427  (_net_332, SE);
not inst428  (_net_333, SI);
and inst429  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_328, D0, D2, _net_329, D4, _net_330, D6, _net_331, _net_332, _net_333);
not inst430  (_net_334, D1);
not inst431  (_net_335, D3);
not inst432  (_net_336, D5);
not inst433  (_net_337, D7);
not inst434  (_net_338, SE);
and inst435  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_334, D0, D2, _net_335, D4, _net_336, D6, _net_337, _net_338, SI);
not inst436  (_net_339, D1);
not inst437  (_net_340, D3);
not inst438  (_net_341, D5);
not inst439  (_net_342, D7);
not inst440  (_net_343, SI);
and inst441  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_339, D0, D2, _net_340, D4, _net_341, D6, _net_342, SE, _net_343);
not inst442  (_net_344, D1);
not inst443  (_net_345, D3);
not inst444  (_net_346, D5);
not inst445  (_net_347, D7);
and inst446  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI, _net_344, D0, D2, _net_345, D4, _net_346, D6, _net_347, SE, SI);
not inst447  (_net_348, D1);
not inst448  (_net_349, D3);
not inst449  (_net_350, D5);
not inst450  (_net_351, SE);
not inst451  (_net_352, SI);
and inst452  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_348, D0, D2, _net_349, D4, _net_350, D6, D7, _net_351, _net_352);
not inst453  (_net_353, D1);
not inst454  (_net_354, D3);
not inst455  (_net_355, D5);
not inst456  (_net_356, SE);
and inst457  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, _net_353, D0, D2, _net_354, D4, _net_355, D6, D7, _net_356, SI);
not inst458  (_net_357, D1);
not inst459  (_net_358, D3);
not inst460  (_net_359, D5);
not inst461  (_net_360, SI);
and inst462  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, _net_357, D0, D2, _net_358, D4, _net_359, D6, D7, SE, _net_360);
not inst463  (_net_361, D1);
not inst464  (_net_362, D3);
not inst465  (_net_363, D5);
and inst466  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_SI, _net_361, D0, D2, _net_362, D4, _net_363, D6, D7, SE, SI);
not inst467  (_net_364, D1);
not inst468  (_net_365, D3);
not inst469  (_net_366, SE);
not inst470  (_net_367, SI);
and inst471  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_364, D0, D2, _net_365, D4, D5, D6, D7, _net_366, _net_367);
not inst472  (_net_368, D1);
not inst473  (_net_369, D3);
not inst474  (_net_370, SE);
and inst475  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, _net_368, D0, D2, _net_369, D4, D5, D6, D7, _net_370, SI);
not inst476  (_net_371, D1);
not inst477  (_net_372, D3);
not inst478  (_net_373, SI);
and inst479  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, _net_371, D0, D2, _net_372, D4, D5, D6, D7, SE, _net_373);
not inst480  (_net_374, D1);
not inst481  (_net_375, D3);
and inst482  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, _net_374, D0, D2, _net_375, D4, D5, D6, D7, SE, SI);
not inst483  (_net_376, SE);
not inst484  (_net_377, SI);
and inst485  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, D4, D5, D6, D7, _net_376, _net_377);
not inst486  (_net_378, SE);
and inst487  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, _net_378, SI);
not inst488  (_net_379, SI);
and inst489  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D1, D0, D2, D3, D4, D5, D6, D7, SE, _net_379);
and inst490  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, SE, SI);
not inst491  (_net_380, D1);
not inst492  (_net_381, D0);
not inst493  (_net_382, D2);
not inst494  (_net_383, D3);
not inst495  (_net_384, D4);
not inst496  (_net_385, D5);
not inst497  (_net_386, D6);
not inst498  (_net_387, D7);
and inst499  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SI, _net_380, _net_381, _net_382, _net_383, _net_384, _net_385, _net_386, _net_387, SI);
not inst500  (_net_388, D1);
not inst501  (_net_389, D0);
not inst502  (_net_390, D2);
not inst503  (_net_391, D3);
not inst504  (_net_392, D4);
not inst505  (_net_393, D5);
not inst506  (_net_394, D6);
not inst507  (_net_395, SI);
and inst508  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SI, _net_388, _net_389, _net_390, _net_391, _net_392, _net_393, _net_394, D7, _net_395);
not inst509  (_net_396, D1);
not inst510  (_net_397, D0);
not inst511  (_net_398, D2);
not inst512  (_net_399, D3);
not inst513  (_net_400, D4);
not inst514  (_net_401, D5);
not inst515  (_net_402, D7);
not inst516  (_net_403, SI);
and inst517  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SI, _net_396, _net_397, _net_398, _net_399, _net_400, _net_401, D6, _net_402, _net_403);
not inst518  (_net_404, D1);
not inst519  (_net_405, D0);
not inst520  (_net_406, D2);
not inst521  (_net_407, D3);
not inst522  (_net_408, D4);
not inst523  (_net_409, D6);
not inst524  (_net_410, D7);
not inst525  (_net_411, SI);
and inst526  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI, _net_404, _net_405, _net_406, _net_407, _net_408, D5, _net_409, _net_410, _net_411);
not inst527  (_net_412, D1);
not inst528  (_net_413, D0);
not inst529  (_net_414, D2);
not inst530  (_net_415, D3);
not inst531  (_net_416, D5);
not inst532  (_net_417, D6);
not inst533  (_net_418, D7);
not inst534  (_net_419, SI);
and inst535  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI, _net_412, _net_413, _net_414, _net_415, D4, _net_416, _net_417, _net_418, _net_419);
not inst536  (_net_420, D1);
not inst537  (_net_421, D0);
not inst538  (_net_422, D2);
not inst539  (_net_423, D4);
not inst540  (_net_424, D5);
not inst541  (_net_425, D6);
not inst542  (_net_426, D7);
not inst543  (_net_427, SI);
and inst544  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI, _net_420, _net_421, _net_422, D3, _net_423, _net_424, _net_425, _net_426, _net_427);
not inst545  (_net_428, D1);
not inst546  (_net_429, D0);
not inst547  (_net_430, D3);
not inst548  (_net_431, D4);
not inst549  (_net_432, D5);
not inst550  (_net_433, D6);
not inst551  (_net_434, D7);
not inst552  (_net_435, SI);
and inst553  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI, _net_428, _net_429, D2, _net_430, _net_431, _net_432, _net_433, _net_434, _net_435);
not inst554  (_net_436, D0);
not inst555  (_net_437, D2);
not inst556  (_net_438, D3);
not inst557  (_net_439, D4);
not inst558  (_net_440, D5);
not inst559  (_net_441, D6);
not inst560  (_net_442, D7);
not inst561  (_net_443, SI);
and inst562  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI, D1, _net_436, _net_437, _net_438, _net_439, _net_440, _net_441, _net_442, _net_443);
not inst563  (_net_444, D1);
not inst564  (_net_445, D2);
not inst565  (_net_446, D3);
not inst566  (_net_447, D4);
not inst567  (_net_448, D5);
not inst568  (_net_449, D6);
not inst569  (_net_450, D7);
not inst570  (_net_451, SI);
and inst571  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI, _net_444, D0, _net_445, _net_446, _net_447, _net_448, _net_449, _net_450, _net_451);
not inst572  (_net_452, D0);
and inst573  (ENABLE_NOT_D0_AND_SE, SE, _net_452);
and inst574  (ENABLE_D0_AND_SE, SE, D0);
not inst575  (_net_453, SI);
not inst576  (_net_454, SE);
and inst577  (ENABLE_NOT_SE_AND_NOT_SI, _net_453, _net_454);
not inst578  (_net_455, SE);
and inst579  (ENABLE_NOT_SE_AND_SI, SI, _net_455);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
      viol_2 = (viol_2 !== viol_all) ? viol_all : ~viol_2;
      viol_3 = (viol_3 !== viol_all) ? viol_all : ~viol_3;
      viol_4 = (viol_4 !== viol_all) ? viol_all : ~viol_4;
      viol_5 = (viol_5 !== viol_all) ? viol_all : ~viol_5;
      viol_6 = (viol_6 !== viol_all) ? viol_all : ~viol_6;
      viol_7 = (viol_7 !== viol_all) ? viol_all : ~viol_7;
   end 
`endif 
specify
if (D0==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
if (D4==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
(posedge CK => (Q4 : 1'b1))=(0, 0);
if (D5==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
(posedge CK => (Q5 : 1'b1))=(0, 0);
if (D6==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
(posedge CK => (Q6 : 1'b1))=(0, 0);
if (D7==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
(posedge CK => (Q7 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , posedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_SE , negedge SI &&& ENABLE_D0_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D0 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D1 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D2 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D3 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D4 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_4, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D4 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_4, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D4 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_4, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D4 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_4, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D5 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_5, , , delayed_CK, delayed_D5);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D5 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_5, , , delayed_CK, delayed_D5);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D5 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_5, , , delayed_CK, delayed_D5);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D5 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_5, , , delayed_CK, delayed_D5);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D6 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_6, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D6 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_6, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D6 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_6, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D6 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_6, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D7 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_7, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D7 &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_7, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D7 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_7, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D7 &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_7, , , delayed_CK, delayed_D7);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQM8SS_V2Y16_2

//%BEGIN HDBSVT11_FSDPQMO_V2Y2_1
`celldefine
module HDBSVT11_FSDPQMO_V2Y2_1 (QM, SO, CK, D, SI, SE);
  input CK, D, SI, SE;
  output QM, SO;
  reg viol_0;
  wire viol_x, int_2, iq1, iq, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_2, 1'b1, 1'b1);

  `endif
    not inst5  (int_2, delayed_CK);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_6, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq1, viol_0, delayed_CK, d_int, xcr_6);
    snps_latch inst8  (iq, viol_x, int_2, d_int);
    snps_mux2 inst9  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (SO, iq1);
    buf #`SNPS_SEQ_DELAY  inst11 (QM, iq);
  `else
    buf inst12  (SO, iq1);
    buf inst13  (QM, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst14  (_net_0, SE);
not inst15  (_net_1, D);
not inst16  (_net_2, SI);
and inst17  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst18  (_net_3, SE);
not inst19  (_net_4, D);
and inst20  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst21  (_net_5, D);
not inst22  (_net_6, SI);
and inst23  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst24  (_net_7, D);
and inst25  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst26  (_net_8, SE);
not inst27  (_net_9, SI);
and inst28  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst29  (_net_10, SE);
and inst30  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst31  (_net_11, SI);
and inst32  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst33  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst34  (_net_12, SI);
not inst35  (_net_13, SE);
and inst36  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst37  (_net_14, SE);
and inst38  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst39  (_net_15, D);
and inst40  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst41  (_net_16, SI);
and inst42  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst43  (_net_17, D);
and inst44  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst45  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (negedge CK => (QM -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (QM -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (QM -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (QM -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (negedge CK => (QM +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (negedge CK => (QM +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (negedge CK => (QM +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (QM +: 1'b1))=(0, 0);
(negedge CK => (QM : 1'b1))=(0, 0);
if (CK==1'b0 && SE==1'b0 && SI==1'b0) (D +=> QM)=(0, 0);
if (CK==1'b0 && SE==1'b0 && SI==1'b1) (D +=> QM)=(0, 0);
if (CK==1'b0 && D==1'b1 && SI==1'b0) (SE -=> QM)=(0, 0);
if (CK==1'b0 && D==1'b0 && SI==1'b1) (SE +=> QM)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1) (SI +=> QM)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1) (SI +=> QM)=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
(posedge CK => (SO : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPQMO_V2Y2_1

//%BEGIN HDBSVT11_FSDPQMO_V2Y2_2
`celldefine
module HDBSVT11_FSDPQMO_V2Y2_2 (QM, SO, CK, D, SI, SE);
  input CK, D, SI, SE;
  output QM, SO;
  reg viol_0;
  wire viol_x, int_2, iq1, iq, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_2, 1'b1, 1'b1);

  `endif
    not inst5  (int_2, delayed_CK);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_6, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq1, viol_0, delayed_CK, d_int, xcr_6);
    snps_latch inst8  (iq, viol_x, int_2, d_int);
    snps_mux2 inst9  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (SO, iq1);
    buf #`SNPS_SEQ_DELAY  inst11 (QM, iq);
  `else
    buf inst12  (SO, iq1);
    buf inst13  (QM, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst14  (_net_0, SE);
not inst15  (_net_1, D);
not inst16  (_net_2, SI);
and inst17  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst18  (_net_3, SE);
not inst19  (_net_4, D);
and inst20  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst21  (_net_5, D);
not inst22  (_net_6, SI);
and inst23  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst24  (_net_7, D);
and inst25  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst26  (_net_8, SE);
not inst27  (_net_9, SI);
and inst28  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst29  (_net_10, SE);
and inst30  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst31  (_net_11, SI);
and inst32  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst33  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst34  (_net_12, SI);
not inst35  (_net_13, SE);
and inst36  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst37  (_net_14, SE);
and inst38  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst39  (_net_15, D);
and inst40  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst41  (_net_16, SI);
and inst42  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst43  (_net_17, D);
and inst44  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst45  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (negedge CK => (QM -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (QM -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (QM -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (QM -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (negedge CK => (QM +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (negedge CK => (QM +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (negedge CK => (QM +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (QM +: 1'b1))=(0, 0);
(negedge CK => (QM : 1'b1))=(0, 0);
if (CK==1'b0 && SE==1'b0 && SI==1'b0) (D +=> QM)=(0, 0);
if (CK==1'b0 && SE==1'b0 && SI==1'b1) (D +=> QM)=(0, 0);
if (CK==1'b0 && D==1'b1 && SI==1'b0) (SE -=> QM)=(0, 0);
if (CK==1'b0 && D==1'b0 && SI==1'b1) (SE +=> QM)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1) (SI +=> QM)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1) (SI +=> QM)=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
(posedge CK => (SO : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPQMO_V2Y2_2

//%BEGIN HDBSVT11_FSDPQMO_V2Y2_4
`celldefine
module HDBSVT11_FSDPQMO_V2Y2_4 (QM, SO, CK, D, SI, SE);
  input CK, D, SI, SE;
  output QM, SO;
  reg viol_0;
  wire viol_x, int_2, iq1, iq, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_2, 1'b1, 1'b1);

  `endif
    not inst5  (int_2, delayed_CK);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_6, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq1, viol_0, delayed_CK, d_int, xcr_6);
    snps_latch inst8  (iq, viol_x, int_2, d_int);
    snps_mux2 inst9  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (SO, iq1);
    buf #`SNPS_SEQ_DELAY  inst11 (QM, iq);
  `else
    buf inst12  (SO, iq1);
    buf inst13  (QM, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst14  (_net_0, SE);
not inst15  (_net_1, D);
not inst16  (_net_2, SI);
and inst17  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst18  (_net_3, SE);
not inst19  (_net_4, D);
and inst20  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst21  (_net_5, D);
not inst22  (_net_6, SI);
and inst23  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst24  (_net_7, D);
and inst25  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst26  (_net_8, SE);
not inst27  (_net_9, SI);
and inst28  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst29  (_net_10, SE);
and inst30  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst31  (_net_11, SI);
and inst32  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst33  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst34  (_net_12, SI);
not inst35  (_net_13, SE);
and inst36  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst37  (_net_14, SE);
and inst38  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst39  (_net_15, D);
and inst40  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst41  (_net_16, SI);
and inst42  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst43  (_net_17, D);
and inst44  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst45  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (negedge CK => (QM -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (negedge CK => (QM -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (negedge CK => (QM -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (negedge CK => (QM -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (negedge CK => (QM +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (negedge CK => (QM +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (negedge CK => (QM +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (negedge CK => (QM +: 1'b1))=(0, 0);
(negedge CK => (QM : 1'b1))=(0, 0);
if (CK==1'b0 && SE==1'b0 && SI==1'b0) (D +=> QM)=(0, 0);
if (CK==1'b0 && SE==1'b0 && SI==1'b1) (D +=> QM)=(0, 0);
if (CK==1'b0 && D==1'b1 && SI==1'b0) (SE -=> QM)=(0, 0);
if (CK==1'b0 && D==1'b0 && SI==1'b1) (SE +=> QM)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1) (SI +=> QM)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1) (SI +=> QM)=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
(posedge CK => (SO : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPQMO_V2Y2_4

//%BEGIN HDBSVT11_FSDPQ_CBV1Y2_1

`celldefine
module HDBSVT11_FSDPQ_CBV1Y2_1 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_CBV1Y2_1

//%BEGIN HDBSVT11_FSDPQ_CBV2Y2_1

`celldefine
module HDBSVT11_FSDPQ_CBV2Y2_1 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_CBV2Y2_1

//%BEGIN HDBSVT11_FSDPQ_CBV2Y2_2

`celldefine
module HDBSVT11_FSDPQ_CBV2Y2_2 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_CBV2Y2_2

//%BEGIN HDBSVT11_FSDPQ_CBV2Y2_4

`celldefine
module HDBSVT11_FSDPQ_CBV2Y2_4 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_CBV2Y2_4

//%BEGIN HDBSVT11_FSDPQ_DY2_1

`celldefine
module HDBSVT11_FSDPQ_DY2_1 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_DY2_1

//%BEGIN HDBSVT11_FSDPQ_DY2_4

`celldefine
module HDBSVT11_FSDPQ_DY2_4 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_DY2_4

//%BEGIN HDBSVT11_FSDPQ_V1Y2_1

`celldefine
module HDBSVT11_FSDPQ_V1Y2_1 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_V1Y2_1

//%BEGIN HDBSVT11_FSDPQ_V1Y2_2

`celldefine
module HDBSVT11_FSDPQ_V1Y2_2 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_V1Y2_2

//%BEGIN HDBSVT11_FSDPQ_V1Y2_4

`celldefine
module HDBSVT11_FSDPQ_V1Y2_4 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_V1Y2_4

//%BEGIN HDBSVT11_FSDPQ_V1Y2_8

`celldefine
module HDBSVT11_FSDPQ_V1Y2_8 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_V1Y2_8

//%BEGIN HDBSVT11_FSDPQ_V2Y2_1

`celldefine
module HDBSVT11_FSDPQ_V2Y2_1 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_V2Y2_1

//%BEGIN HDBSVT11_FSDPQ_V2Y2_2

`celldefine
module HDBSVT11_FSDPQ_V2Y2_2 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_V2Y2_2

//%BEGIN HDBSVT11_FSDPQ_V2Y2_4

`celldefine
module HDBSVT11_FSDPQ_V2Y2_4 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_V2Y2_4

//%BEGIN HDBSVT11_FSDPQ_V2Y2_8

`celldefine
module HDBSVT11_FSDPQ_V2Y2_8 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_V2Y2_8

//%BEGIN HDBSVT11_FSDPQ_V3Y2_1

`celldefine
module HDBSVT11_FSDPQ_V3Y2_1 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_V3Y2_1

//%BEGIN HDBSVT11_FSDPQ_V3Y2_2

`celldefine
module HDBSVT11_FSDPQ_V3Y2_2 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_V3Y2_2

//%BEGIN HDBSVT11_FSDPQ_V3Y2_4

`celldefine
module HDBSVT11_FSDPQ_V3Y2_4 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_V3Y2_4

//%BEGIN HDBSVT11_FSDPQ_V3Y2_8

`celldefine
module HDBSVT11_FSDPQ_V3Y2_8 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_V3Y2_8

//%BEGIN HDBSVT11_FSDPQ_V4Y2_1

`celldefine
module HDBSVT11_FSDPQ_V4Y2_1 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_V4Y2_1

//%BEGIN HDBSVT11_FSDPQ_V4Y2_2

`celldefine
module HDBSVT11_FSDPQ_V4Y2_2 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_V4Y2_2

//%BEGIN HDBSVT11_FSDPQ_V4Y2_4

`celldefine
module HDBSVT11_FSDPQ_V4Y2_4 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_V4Y2_4

//%BEGIN HDBSVT11_FSDPQ_Y2_1

`celldefine
module HDBSVT11_FSDPQ_Y2_1 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_Y2_1

//%BEGIN HDBSVT11_FSDPQ_Y2_2

`celldefine
module HDBSVT11_FSDPQ_Y2_2 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_Y2_2

//%BEGIN HDBSVT11_FSDPQ_Y2_4

`celldefine
module HDBSVT11_FSDPQ_Y2_4 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_Y2_4

//%BEGIN HDBSVT11_FSDPQ_Y2_8

`celldefine
module HDBSVT11_FSDPQ_Y2_8 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPQ_Y2_8

//%BEGIN HDBSVT11_FSDPRBQM2SS_V2Y4_1

`celldefine
module HDBSVT11_FSDPRBQM2SS_V2Y4_1 (Q0, Q1, CK, D0, D1, SI, SE, RD);
   output Q0, Q1;
   input CK, D0, D1, SI, SE, RD;

   reg viol_all, viol_0,  viol_1;
   wire delayed_CK, delayed_D0, delayed_D1,
	delayed_SI, delayed_SE, delayed_RD;

   wire int_res__D0, int_res__D1, int_res__RD, int_res_iq0, int_res_iq1,
        xcr_0, xcr_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
   buf inst5  (delayed_RD, RD);
`endif
   not inst6  (int_res__RD, delayed_RD);

   snps_mux2 inst7  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst8  (xcr_0, delayed_CK, int_res__D0, int_res__RD);

  `endif
   snps_dff_r inst9  (int_res_iq0, viol_0, delayed_CK, int_res__D0, int_res__RD, xcr_0);

   snps_mux2 inst10  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst11  (xcr_1, delayed_CK, int_res__D1, int_res__RD);

  `endif
   snps_dff_r inst12  (int_res_iq1, viol_1, delayed_CK, int_res__D1, int_res__RD, xcr_1);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst13 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst14 (Q1, int_res_iq1);
   `else
        buf inst15  (Q0, int_res_iq0);
        buf inst16  (Q1, int_res_iq1);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst17  (_net_0, D1);
not inst18  (_net_1, D0);
not inst19  (_net_2, SE);
not inst20  (_net_3, SI);
and inst21  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, RD, _net_2, _net_3);
not inst22  (_net_4, D1);
not inst23  (_net_5, D0);
not inst24  (_net_6, SE);
and inst25  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI, _net_4, _net_5, RD, _net_6, SI);
not inst26  (_net_7, D1);
not inst27  (_net_8, D0);
not inst28  (_net_9, SI);
and inst29  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI, _net_7, _net_8, RD, SE, _net_9);
not inst30  (_net_10, D1);
not inst31  (_net_11, D0);
and inst32  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI, _net_10, _net_11, RD, SE, SI);
not inst33  (_net_12, D0);
not inst34  (_net_13, SE);
not inst35  (_net_14, SI);
and inst36  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_12, RD, _net_13, _net_14);
not inst37  (_net_15, D0);
not inst38  (_net_16, SE);
and inst39  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI, D1, _net_15, RD, _net_16, SI);
not inst40  (_net_17, D0);
not inst41  (_net_18, SI);
and inst42  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI, D1, _net_17, RD, SE, _net_18);
not inst43  (_net_19, D0);
and inst44  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_SI, D1, _net_19, RD, SE, SI);
not inst45  (_net_20, D1);
not inst46  (_net_21, SE);
not inst47  (_net_22, SI);
and inst48  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_20, D0, RD, _net_21, _net_22);
not inst49  (_net_23, D1);
not inst50  (_net_24, SE);
and inst51  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI, _net_23, D0, RD, _net_24, SI);
not inst52  (_net_25, D1);
not inst53  (_net_26, SI);
and inst54  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI, _net_25, D0, RD, SE, _net_26);
not inst55  (_net_27, D1);
and inst56  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI, _net_27, D0, RD, SE, SI);
not inst57  (_net_28, SE);
not inst58  (_net_29, SI);
and inst59  (ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, RD, _net_28, _net_29);
not inst60  (_net_30, SE);
and inst61  (ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI, D1, D0, RD, _net_30, SI);
not inst62  (_net_31, SI);
and inst63  (ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI, D1, D0, RD, SE, _net_31);
and inst64  (ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_SI, D1, D0, RD, SE, SI);
not inst65  (_net_32, D1);
not inst66  (_net_33, D0);
and inst67  (ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI, _net_32, _net_33, SE, SI);
not inst68  (_net_34, D0);
not inst69  (_net_35, SE);
not inst70  (_net_36, SI);
and inst71  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D1, _net_34, _net_35, _net_36);
not inst72  (_net_37, D0);
not inst73  (_net_38, SE);
and inst74  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI, D1, _net_37, _net_38, SI);
not inst75  (_net_39, D0);
and inst76  (ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI, D1, _net_39, SE, SI);
not inst77  (_net_40, D1);
not inst78  (_net_41, SE);
not inst79  (_net_42, SI);
and inst80  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_40, D0, _net_41, _net_42);
not inst81  (_net_43, D1);
not inst82  (_net_44, SE);
and inst83  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_43, D0, _net_44, SI);
not inst84  (_net_45, D1);
and inst85  (ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI, _net_45, D0, SE, SI);
not inst86  (_net_46, D0);
not inst87  (_net_47, CK);
not inst88  (_net_48, D1);
not inst89  (_net_49, SE);
not inst90  (_net_50, SI);
and inst91  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_46, _net_47, _net_48, _net_49, _net_50);
not inst92  (_net_51, D0);
not inst93  (_net_52, CK);
not inst94  (_net_53, D1);
not inst95  (_net_54, SE);
and inst96  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_51, _net_52, _net_53, _net_54, SI);
not inst97  (_net_55, D0);
not inst98  (_net_56, CK);
not inst99  (_net_57, D1);
not inst100  (_net_58, SI);
and inst101  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, _net_55, _net_56, _net_57, SE, _net_58);
not inst102  (_net_59, D0);
not inst103  (_net_60, CK);
not inst104  (_net_61, D1);
and inst105  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_SE_AND_SI, _net_59, _net_60, _net_61, SE, SI);
not inst106  (_net_62, D0);
not inst107  (_net_63, CK);
not inst108  (_net_64, SE);
not inst109  (_net_65, SI);
and inst110  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, _net_62, _net_63, D1, _net_64, _net_65);
not inst111  (_net_66, D0);
not inst112  (_net_67, CK);
not inst113  (_net_68, SE);
and inst114  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_SE_AND_SI, _net_66, _net_67, D1, _net_68, SI);
not inst115  (_net_69, D0);
not inst116  (_net_70, CK);
not inst117  (_net_71, SI);
and inst118  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_SE_AND_NOT_SI, _net_69, _net_70, D1, SE, _net_71);
not inst119  (_net_72, D0);
not inst120  (_net_73, CK);
and inst121  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_SE_AND_SI, _net_72, _net_73, D1, SE, SI);
not inst122  (_net_74, CK);
not inst123  (_net_75, D1);
not inst124  (_net_76, SE);
not inst125  (_net_77, SI);
and inst126  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, D0, _net_74, _net_75, _net_76, _net_77);
not inst127  (_net_78, CK);
not inst128  (_net_79, D1);
not inst129  (_net_80, SE);
and inst130  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, D0, _net_78, _net_79, _net_80, SI);
not inst131  (_net_81, CK);
not inst132  (_net_82, D1);
not inst133  (_net_83, SI);
and inst134  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, D0, _net_81, _net_82, SE, _net_83);
not inst135  (_net_84, CK);
not inst136  (_net_85, D1);
and inst137  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_SE_AND_SI, D0, _net_84, _net_85, SE, SI);
not inst138  (_net_86, CK);
not inst139  (_net_87, SE);
not inst140  (_net_88, SI);
and inst141  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D0, _net_86, D1, _net_87, _net_88);
not inst142  (_net_89, CK);
not inst143  (_net_90, SE);
and inst144  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_NOT_SE_AND_SI, D0, _net_89, D1, _net_90, SI);
not inst145  (_net_91, CK);
not inst146  (_net_92, SI);
and inst147  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_SE_AND_NOT_SI, D0, _net_91, D1, SE, _net_92);
not inst148  (_net_93, CK);
and inst149  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_SE_AND_SI, D0, _net_93, D1, SE, SI);
not inst150  (_net_94, D0);
not inst151  (_net_95, D1);
not inst152  (_net_96, SE);
not inst153  (_net_97, SI);
and inst154  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_94, CK, _net_95, _net_96, _net_97);
not inst155  (_net_98, D0);
not inst156  (_net_99, D1);
not inst157  (_net_100, SE);
and inst158  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_98, CK, _net_99, _net_100, SI);
not inst159  (_net_101, D0);
not inst160  (_net_102, D1);
not inst161  (_net_103, SI);
and inst162  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, _net_101, CK, _net_102, SE, _net_103);
not inst163  (_net_104, D0);
not inst164  (_net_105, D1);
and inst165  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_SE_AND_SI, _net_104, CK, _net_105, SE, SI);
not inst166  (_net_106, D0);
not inst167  (_net_107, SE);
not inst168  (_net_108, SI);
and inst169  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, _net_106, CK, D1, _net_107, _net_108);
not inst170  (_net_109, D0);
not inst171  (_net_110, SE);
and inst172  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_SE_AND_SI, _net_109, CK, D1, _net_110, SI);
not inst173  (_net_111, D0);
not inst174  (_net_112, SI);
and inst175  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_SE_AND_NOT_SI, _net_111, CK, D1, SE, _net_112);
not inst176  (_net_113, D0);
and inst177  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_SE_AND_SI, _net_113, CK, D1, SE, SI);
not inst178  (_net_114, D1);
not inst179  (_net_115, SE);
not inst180  (_net_116, SI);
and inst181  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_114, _net_115, _net_116);
not inst182  (_net_117, D1);
not inst183  (_net_118, SE);
and inst184  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, D0, CK, _net_117, _net_118, SI);
not inst185  (_net_119, D1);
not inst186  (_net_120, SI);
and inst187  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, D0, CK, _net_119, SE, _net_120);
not inst188  (_net_121, D1);
and inst189  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_SE_AND_SI, D0, CK, _net_121, SE, SI);
not inst190  (_net_122, SE);
not inst191  (_net_123, SI);
and inst192  (ENABLE_CK_AND_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D0, CK, D1, _net_122, _net_123);
not inst193  (_net_124, SE);
and inst194  (ENABLE_CK_AND_D0_AND_D1_AND_NOT_SE_AND_SI, D0, CK, D1, _net_124, SI);
not inst195  (_net_125, SI);
and inst196  (ENABLE_CK_AND_D0_AND_D1_AND_SE_AND_NOT_SI, D0, CK, D1, SE, _net_125);
and inst197  (ENABLE_CK_AND_D0_AND_D1_AND_SE_AND_SI, D0, CK, D1, SE, SI);
not inst198  (_net_126, D1);
not inst199  (_net_127, D0);
not inst200  (_net_128, SI);
and inst201  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI, _net_126, _net_127, RD, _net_128);
not inst202  (_net_129, D1);
not inst203  (_net_130, D0);
and inst204  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI, _net_129, _net_130, RD, SI);
not inst205  (_net_131, D0);
not inst206  (_net_132, SI);
and inst207  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI, D1, _net_131, RD, _net_132);
not inst208  (_net_133, D1);
not inst209  (_net_134, SI);
and inst210  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI, _net_133, D0, RD, _net_134);
not inst211  (_net_135, D0);
and inst212  (ENABLE_NOT_D0_AND_RD_AND_SE, RD, _net_135, SE);
and inst213  (ENABLE_D0_AND_RD_AND_SE, RD, D0, SE);
not inst214  (_net_136, SE);
not inst215  (_net_137, SI);
and inst216  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_136, RD, _net_137);
not inst217  (_net_138, SE);
and inst218  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_138, RD, SI);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
   end 
`endif 
specify
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
(negedge RD => (Q0 : 1'b0))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
(negedge RD => (Q1 : 1'b0))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD , 0 ,0, viol_all);
$recrem(posedge RD , posedge CK , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPRBQM2SS_V2Y4_1

//%BEGIN HDBSVT11_FSDPRBQM2SS_V2Y4_2

`celldefine
module HDBSVT11_FSDPRBQM2SS_V2Y4_2 (Q0, Q1, CK, D0, D1, SI, SE, RD);
   output Q0, Q1;
   input CK, D0, D1, SI, SE, RD;

   reg viol_all, viol_0,  viol_1;
   wire delayed_CK, delayed_D0, delayed_D1,
	delayed_SI, delayed_SE, delayed_RD;

   wire int_res__D0, int_res__D1, int_res__RD, int_res_iq0, int_res_iq1,
        xcr_0, xcr_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
   buf inst5  (delayed_RD, RD);
`endif
   not inst6  (int_res__RD, delayed_RD);

   snps_mux2 inst7  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst8  (xcr_0, delayed_CK, int_res__D0, int_res__RD);

  `endif
   snps_dff_r inst9  (int_res_iq0, viol_0, delayed_CK, int_res__D0, int_res__RD, xcr_0);

   snps_mux2 inst10  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst11  (xcr_1, delayed_CK, int_res__D1, int_res__RD);

  `endif
   snps_dff_r inst12  (int_res_iq1, viol_1, delayed_CK, int_res__D1, int_res__RD, xcr_1);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst13 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst14 (Q1, int_res_iq1);
   `else
        buf inst15  (Q0, int_res_iq0);
        buf inst16  (Q1, int_res_iq1);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst17  (_net_0, D1);
not inst18  (_net_1, D0);
not inst19  (_net_2, SE);
not inst20  (_net_3, SI);
and inst21  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, RD, _net_2, _net_3);
not inst22  (_net_4, D1);
not inst23  (_net_5, D0);
not inst24  (_net_6, SE);
and inst25  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI, _net_4, _net_5, RD, _net_6, SI);
not inst26  (_net_7, D1);
not inst27  (_net_8, D0);
not inst28  (_net_9, SI);
and inst29  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI, _net_7, _net_8, RD, SE, _net_9);
not inst30  (_net_10, D1);
not inst31  (_net_11, D0);
and inst32  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI, _net_10, _net_11, RD, SE, SI);
not inst33  (_net_12, D0);
not inst34  (_net_13, SE);
not inst35  (_net_14, SI);
and inst36  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_12, RD, _net_13, _net_14);
not inst37  (_net_15, D0);
not inst38  (_net_16, SE);
and inst39  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI, D1, _net_15, RD, _net_16, SI);
not inst40  (_net_17, D0);
not inst41  (_net_18, SI);
and inst42  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI, D1, _net_17, RD, SE, _net_18);
not inst43  (_net_19, D0);
and inst44  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_SI, D1, _net_19, RD, SE, SI);
not inst45  (_net_20, D1);
not inst46  (_net_21, SE);
not inst47  (_net_22, SI);
and inst48  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_20, D0, RD, _net_21, _net_22);
not inst49  (_net_23, D1);
not inst50  (_net_24, SE);
and inst51  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI, _net_23, D0, RD, _net_24, SI);
not inst52  (_net_25, D1);
not inst53  (_net_26, SI);
and inst54  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI, _net_25, D0, RD, SE, _net_26);
not inst55  (_net_27, D1);
and inst56  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI, _net_27, D0, RD, SE, SI);
not inst57  (_net_28, SE);
not inst58  (_net_29, SI);
and inst59  (ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, RD, _net_28, _net_29);
not inst60  (_net_30, SE);
and inst61  (ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI, D1, D0, RD, _net_30, SI);
not inst62  (_net_31, SI);
and inst63  (ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI, D1, D0, RD, SE, _net_31);
and inst64  (ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_SI, D1, D0, RD, SE, SI);
not inst65  (_net_32, D1);
not inst66  (_net_33, D0);
and inst67  (ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI, _net_32, _net_33, SE, SI);
not inst68  (_net_34, D0);
not inst69  (_net_35, SE);
not inst70  (_net_36, SI);
and inst71  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D1, _net_34, _net_35, _net_36);
not inst72  (_net_37, D0);
not inst73  (_net_38, SE);
and inst74  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI, D1, _net_37, _net_38, SI);
not inst75  (_net_39, D0);
and inst76  (ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI, D1, _net_39, SE, SI);
not inst77  (_net_40, D1);
not inst78  (_net_41, SE);
not inst79  (_net_42, SI);
and inst80  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_40, D0, _net_41, _net_42);
not inst81  (_net_43, D1);
not inst82  (_net_44, SE);
and inst83  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_43, D0, _net_44, SI);
not inst84  (_net_45, D1);
and inst85  (ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI, _net_45, D0, SE, SI);
not inst86  (_net_46, D0);
not inst87  (_net_47, CK);
not inst88  (_net_48, D1);
not inst89  (_net_49, SE);
not inst90  (_net_50, SI);
and inst91  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_46, _net_47, _net_48, _net_49, _net_50);
not inst92  (_net_51, D0);
not inst93  (_net_52, CK);
not inst94  (_net_53, D1);
not inst95  (_net_54, SE);
and inst96  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_51, _net_52, _net_53, _net_54, SI);
not inst97  (_net_55, D0);
not inst98  (_net_56, CK);
not inst99  (_net_57, D1);
not inst100  (_net_58, SI);
and inst101  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, _net_55, _net_56, _net_57, SE, _net_58);
not inst102  (_net_59, D0);
not inst103  (_net_60, CK);
not inst104  (_net_61, D1);
and inst105  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_SE_AND_SI, _net_59, _net_60, _net_61, SE, SI);
not inst106  (_net_62, D0);
not inst107  (_net_63, CK);
not inst108  (_net_64, SE);
not inst109  (_net_65, SI);
and inst110  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, _net_62, _net_63, D1, _net_64, _net_65);
not inst111  (_net_66, D0);
not inst112  (_net_67, CK);
not inst113  (_net_68, SE);
and inst114  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_SE_AND_SI, _net_66, _net_67, D1, _net_68, SI);
not inst115  (_net_69, D0);
not inst116  (_net_70, CK);
not inst117  (_net_71, SI);
and inst118  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_SE_AND_NOT_SI, _net_69, _net_70, D1, SE, _net_71);
not inst119  (_net_72, D0);
not inst120  (_net_73, CK);
and inst121  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_SE_AND_SI, _net_72, _net_73, D1, SE, SI);
not inst122  (_net_74, CK);
not inst123  (_net_75, D1);
not inst124  (_net_76, SE);
not inst125  (_net_77, SI);
and inst126  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, D0, _net_74, _net_75, _net_76, _net_77);
not inst127  (_net_78, CK);
not inst128  (_net_79, D1);
not inst129  (_net_80, SE);
and inst130  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, D0, _net_78, _net_79, _net_80, SI);
not inst131  (_net_81, CK);
not inst132  (_net_82, D1);
not inst133  (_net_83, SI);
and inst134  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, D0, _net_81, _net_82, SE, _net_83);
not inst135  (_net_84, CK);
not inst136  (_net_85, D1);
and inst137  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_SE_AND_SI, D0, _net_84, _net_85, SE, SI);
not inst138  (_net_86, CK);
not inst139  (_net_87, SE);
not inst140  (_net_88, SI);
and inst141  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D0, _net_86, D1, _net_87, _net_88);
not inst142  (_net_89, CK);
not inst143  (_net_90, SE);
and inst144  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_NOT_SE_AND_SI, D0, _net_89, D1, _net_90, SI);
not inst145  (_net_91, CK);
not inst146  (_net_92, SI);
and inst147  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_SE_AND_NOT_SI, D0, _net_91, D1, SE, _net_92);
not inst148  (_net_93, CK);
and inst149  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_SE_AND_SI, D0, _net_93, D1, SE, SI);
not inst150  (_net_94, D0);
not inst151  (_net_95, D1);
not inst152  (_net_96, SE);
not inst153  (_net_97, SI);
and inst154  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_94, CK, _net_95, _net_96, _net_97);
not inst155  (_net_98, D0);
not inst156  (_net_99, D1);
not inst157  (_net_100, SE);
and inst158  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_98, CK, _net_99, _net_100, SI);
not inst159  (_net_101, D0);
not inst160  (_net_102, D1);
not inst161  (_net_103, SI);
and inst162  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, _net_101, CK, _net_102, SE, _net_103);
not inst163  (_net_104, D0);
not inst164  (_net_105, D1);
and inst165  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_SE_AND_SI, _net_104, CK, _net_105, SE, SI);
not inst166  (_net_106, D0);
not inst167  (_net_107, SE);
not inst168  (_net_108, SI);
and inst169  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, _net_106, CK, D1, _net_107, _net_108);
not inst170  (_net_109, D0);
not inst171  (_net_110, SE);
and inst172  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_SE_AND_SI, _net_109, CK, D1, _net_110, SI);
not inst173  (_net_111, D0);
not inst174  (_net_112, SI);
and inst175  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_SE_AND_NOT_SI, _net_111, CK, D1, SE, _net_112);
not inst176  (_net_113, D0);
and inst177  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_SE_AND_SI, _net_113, CK, D1, SE, SI);
not inst178  (_net_114, D1);
not inst179  (_net_115, SE);
not inst180  (_net_116, SI);
and inst181  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_114, _net_115, _net_116);
not inst182  (_net_117, D1);
not inst183  (_net_118, SE);
and inst184  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, D0, CK, _net_117, _net_118, SI);
not inst185  (_net_119, D1);
not inst186  (_net_120, SI);
and inst187  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_SE_AND_NOT_SI, D0, CK, _net_119, SE, _net_120);
not inst188  (_net_121, D1);
and inst189  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_SE_AND_SI, D0, CK, _net_121, SE, SI);
not inst190  (_net_122, SE);
not inst191  (_net_123, SI);
and inst192  (ENABLE_CK_AND_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D0, CK, D1, _net_122, _net_123);
not inst193  (_net_124, SE);
and inst194  (ENABLE_CK_AND_D0_AND_D1_AND_NOT_SE_AND_SI, D0, CK, D1, _net_124, SI);
not inst195  (_net_125, SI);
and inst196  (ENABLE_CK_AND_D0_AND_D1_AND_SE_AND_NOT_SI, D0, CK, D1, SE, _net_125);
and inst197  (ENABLE_CK_AND_D0_AND_D1_AND_SE_AND_SI, D0, CK, D1, SE, SI);
not inst198  (_net_126, D1);
not inst199  (_net_127, D0);
not inst200  (_net_128, SI);
and inst201  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI, _net_126, _net_127, RD, _net_128);
not inst202  (_net_129, D1);
not inst203  (_net_130, D0);
and inst204  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI, _net_129, _net_130, RD, SI);
not inst205  (_net_131, D0);
not inst206  (_net_132, SI);
and inst207  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI, D1, _net_131, RD, _net_132);
not inst208  (_net_133, D1);
not inst209  (_net_134, SI);
and inst210  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI, _net_133, D0, RD, _net_134);
not inst211  (_net_135, D0);
and inst212  (ENABLE_NOT_D0_AND_RD_AND_SE, RD, _net_135, SE);
and inst213  (ENABLE_D0_AND_RD_AND_SE, RD, D0, SE);
not inst214  (_net_136, SE);
not inst215  (_net_137, SI);
and inst216  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_136, RD, _net_137);
not inst217  (_net_138, SE);
and inst218  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_138, RD, SI);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
   end 
`endif 
specify
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
(negedge RD => (Q0 : 1'b0))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
(negedge RD => (Q1 : 1'b0))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD , 0 ,0, viol_all);
$recrem(posedge RD , posedge CK , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPRBQM2SS_V2Y4_2

//%BEGIN HDBSVT11_FSDPRBQM4SS_V2Y8_1

`celldefine
module HDBSVT11_FSDPRBQM4SS_V2Y8_1 (Q0, Q1, Q2, Q3, CK, D0, D1, D2, D3, SI, SE, RD);
   output Q0, Q1, Q2, Q3;
   input CK, D0, D1, D2, D3, SI, SE, RD;

   reg viol_all, viol_0,  viol_1,  viol_2,  viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE, delayed_RD;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res__RD, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
   buf inst7  (delayed_RD, RD);
`endif
   not inst8  (int_res__RD, delayed_RD);

   snps_mux2 inst9  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst10  (xcr_0, delayed_CK, int_res__D0, int_res__RD);

  `endif
   snps_dff_r inst11  (int_res_iq0, viol_0, delayed_CK, int_res__D0, int_res__RD, xcr_0);

   snps_mux2 inst12  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst13  (xcr_1, delayed_CK, int_res__D1, int_res__RD);

  `endif
   snps_dff_r inst14  (int_res_iq1, viol_1, delayed_CK, int_res__D1, int_res__RD, xcr_1);

   snps_mux2 inst15  (int_res__D2, int_res_iq1, delayed_D2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst16  (xcr_2, delayed_CK, int_res__D2, int_res__RD);

  `endif
   snps_dff_r inst17  (int_res_iq2, viol_2, delayed_CK, int_res__D2, int_res__RD, xcr_2);

   snps_mux2 inst18  (int_res__D3, int_res_iq2, delayed_D3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst19  (xcr_3, delayed_CK, int_res__D3, int_res__RD);

  `endif
   snps_dff_r inst20  (int_res_iq3, viol_3, delayed_CK, int_res__D3, int_res__RD, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst21 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst22 (Q1, int_res_iq1);
        buf #`SNPS_SEQ_DELAY  inst23 (Q2, int_res_iq2);
        buf #`SNPS_SEQ_DELAY  inst24 (Q3, int_res_iq3);
   `else
        buf inst25  (Q0, int_res_iq0);
        buf inst26  (Q1, int_res_iq1);
        buf inst27  (Q2, int_res_iq2);
        buf inst28  (Q3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst29  (_net_0, D1);
not inst30  (_net_1, D0);
not inst31  (_net_2, D2);
not inst32  (_net_3, D3);
not inst33  (_net_4, SE);
not inst34  (_net_5, SI);
and inst35  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, RD, _net_4, _net_5);
not inst36  (_net_6, D1);
not inst37  (_net_7, D0);
not inst38  (_net_8, D2);
not inst39  (_net_9, D3);
not inst40  (_net_10, SE);
and inst41  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_6, _net_7, _net_8, _net_9, RD, _net_10, SI);
not inst42  (_net_11, D1);
not inst43  (_net_12, D0);
not inst44  (_net_13, D2);
not inst45  (_net_14, D3);
not inst46  (_net_15, SI);
and inst47  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_11, _net_12, _net_13, _net_14, RD, SE, _net_15);
not inst48  (_net_16, D1);
not inst49  (_net_17, D0);
not inst50  (_net_18, D2);
not inst51  (_net_19, D3);
and inst52  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_16, _net_17, _net_18, _net_19, RD, SE, SI);
not inst53  (_net_20, D1);
not inst54  (_net_21, D0);
not inst55  (_net_22, D2);
not inst56  (_net_23, SE);
not inst57  (_net_24, SI);
and inst58  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22, D3, RD, _net_23, _net_24);
not inst59  (_net_25, D1);
not inst60  (_net_26, D0);
not inst61  (_net_27, D2);
not inst62  (_net_28, SE);
and inst63  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_25, _net_26, _net_27, D3, RD, _net_28, SI);
not inst64  (_net_29, D1);
not inst65  (_net_30, D0);
not inst66  (_net_31, D2);
not inst67  (_net_32, SI);
and inst68  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_29, _net_30, _net_31, D3, RD, SE, _net_32);
not inst69  (_net_33, D1);
not inst70  (_net_34, D0);
not inst71  (_net_35, D2);
and inst72  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_33, _net_34, _net_35, D3, RD, SE, SI);
not inst73  (_net_36, D1);
not inst74  (_net_37, D0);
not inst75  (_net_38, D3);
not inst76  (_net_39, SE);
not inst77  (_net_40, SI);
and inst78  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, D2, _net_38, RD, _net_39, _net_40);
not inst79  (_net_41, D1);
not inst80  (_net_42, D0);
not inst81  (_net_43, D3);
not inst82  (_net_44, SE);
and inst83  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_41, _net_42, D2, _net_43, RD, _net_44, SI);
not inst84  (_net_45, D1);
not inst85  (_net_46, D0);
not inst86  (_net_47, D3);
not inst87  (_net_48, SI);
and inst88  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_45, _net_46, D2, _net_47, RD, SE, _net_48);
not inst89  (_net_49, D1);
not inst90  (_net_50, D0);
not inst91  (_net_51, D3);
and inst92  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_49, _net_50, D2, _net_51, RD, SE, SI);
not inst93  (_net_52, D1);
not inst94  (_net_53, D0);
not inst95  (_net_54, SE);
not inst96  (_net_55, SI);
and inst97  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_52, _net_53, D2, D3, RD, _net_54, _net_55);
not inst98  (_net_56, D1);
not inst99  (_net_57, D0);
not inst100  (_net_58, SE);
and inst101  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_56, _net_57, D2, D3, RD, _net_58, SI);
not inst102  (_net_59, D1);
not inst103  (_net_60, D0);
not inst104  (_net_61, SI);
and inst105  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_59, _net_60, D2, D3, RD, SE, _net_61);
not inst106  (_net_62, D1);
not inst107  (_net_63, D0);
and inst108  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_62, _net_63, D2, D3, RD, SE, SI);
not inst109  (_net_64, D0);
not inst110  (_net_65, D2);
not inst111  (_net_66, D3);
not inst112  (_net_67, SE);
not inst113  (_net_68, SI);
and inst114  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_64, _net_65, _net_66, RD, _net_67, _net_68);
not inst115  (_net_69, D0);
not inst116  (_net_70, D2);
not inst117  (_net_71, D3);
not inst118  (_net_72, SE);
and inst119  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, D1, _net_69, _net_70, _net_71, RD, _net_72, SI);
not inst120  (_net_73, D0);
not inst121  (_net_74, D2);
not inst122  (_net_75, D3);
not inst123  (_net_76, SI);
and inst124  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, D1, _net_73, _net_74, _net_75, RD, SE, _net_76);
not inst125  (_net_77, D0);
not inst126  (_net_78, D2);
not inst127  (_net_79, D3);
and inst128  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, D1, _net_77, _net_78, _net_79, RD, SE, SI);
not inst129  (_net_80, D1);
not inst130  (_net_81, D2);
not inst131  (_net_82, D3);
not inst132  (_net_83, SE);
not inst133  (_net_84, SI);
and inst134  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_80, D0, _net_81, _net_82, RD, _net_83, _net_84);
not inst135  (_net_85, D1);
not inst136  (_net_86, D2);
not inst137  (_net_87, D3);
not inst138  (_net_88, SE);
and inst139  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_85, D0, _net_86, _net_87, RD, _net_88, SI);
not inst140  (_net_89, D1);
not inst141  (_net_90, D2);
not inst142  (_net_91, D3);
not inst143  (_net_92, SI);
and inst144  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_89, D0, _net_90, _net_91, RD, SE, _net_92);
not inst145  (_net_93, D1);
not inst146  (_net_94, D2);
not inst147  (_net_95, D3);
and inst148  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_93, D0, _net_94, _net_95, RD, SE, SI);
not inst149  (_net_96, D1);
not inst150  (_net_97, D3);
not inst151  (_net_98, SE);
not inst152  (_net_99, SI);
and inst153  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_96, D0, D2, _net_97, RD, _net_98, _net_99);
not inst154  (_net_100, D1);
not inst155  (_net_101, D3);
not inst156  (_net_102, SE);
and inst157  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_100, D0, D2, _net_101, RD, _net_102, SI);
not inst158  (_net_103, D1);
not inst159  (_net_104, D3);
not inst160  (_net_105, SI);
and inst161  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_103, D0, D2, _net_104, RD, SE, _net_105);
not inst162  (_net_106, D1);
not inst163  (_net_107, D3);
and inst164  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_106, D0, D2, _net_107, RD, SE, SI);
not inst165  (_net_108, D1);
not inst166  (_net_109, SE);
not inst167  (_net_110, SI);
and inst168  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_108, D0, D2, D3, RD, _net_109, _net_110);
not inst169  (_net_111, D1);
not inst170  (_net_112, SE);
and inst171  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_111, D0, D2, D3, RD, _net_112, SI);
not inst172  (_net_113, D1);
not inst173  (_net_114, SI);
and inst174  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_113, D0, D2, D3, RD, SE, _net_114);
not inst175  (_net_115, D1);
and inst176  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_115, D0, D2, D3, RD, SE, SI);
not inst177  (_net_116, SE);
not inst178  (_net_117, SI);
and inst179  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, RD, _net_116, _net_117);
not inst180  (_net_118, SE);
and inst181  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, D1, D0, D2, D3, RD, _net_118, SI);
not inst182  (_net_119, SI);
and inst183  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, D1, D0, D2, D3, RD, SE, _net_119);
and inst184  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, D1, D0, D2, D3, RD, SE, SI);
not inst185  (_net_120, D1);
not inst186  (_net_121, D0);
not inst187  (_net_122, D2);
not inst188  (_net_123, D3);
and inst189  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_120, _net_121, _net_122, _net_123, SE, SI);
not inst190  (_net_124, D1);
not inst191  (_net_125, D0);
not inst192  (_net_126, D2);
not inst193  (_net_127, SE);
not inst194  (_net_128, SI);
and inst195  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_124, _net_125, _net_126, D3, _net_127, _net_128);
not inst196  (_net_129, D1);
not inst197  (_net_130, D0);
not inst198  (_net_131, D2);
not inst199  (_net_132, SE);
and inst200  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_129, _net_130, _net_131, D3, _net_132, SI);
not inst201  (_net_133, D1);
not inst202  (_net_134, D0);
not inst203  (_net_135, D2);
and inst204  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_133, _net_134, _net_135, D3, SE, SI);
not inst205  (_net_136, D1);
not inst206  (_net_137, D0);
not inst207  (_net_138, D3);
not inst208  (_net_139, SE);
not inst209  (_net_140, SI);
and inst210  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_136, _net_137, D2, _net_138, _net_139, _net_140);
not inst211  (_net_141, D1);
not inst212  (_net_142, D0);
not inst213  (_net_143, D3);
not inst214  (_net_144, SE);
and inst215  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_141, _net_142, D2, _net_143, _net_144, SI);
not inst216  (_net_145, D1);
not inst217  (_net_146, D0);
not inst218  (_net_147, D3);
and inst219  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_145, _net_146, D2, _net_147, SE, SI);
not inst220  (_net_148, D0);
not inst221  (_net_149, D2);
not inst222  (_net_150, D3);
not inst223  (_net_151, SE);
not inst224  (_net_152, SI);
and inst225  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_148, _net_149, _net_150, _net_151, _net_152);
not inst226  (_net_153, D0);
not inst227  (_net_154, D2);
not inst228  (_net_155, D3);
not inst229  (_net_156, SE);
and inst230  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_153, _net_154, _net_155, _net_156, SI);
not inst231  (_net_157, D0);
not inst232  (_net_158, D2);
not inst233  (_net_159, D3);
and inst234  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D1, _net_157, _net_158, _net_159, SE, SI);
not inst235  (_net_160, D1);
not inst236  (_net_161, D2);
not inst237  (_net_162, D3);
not inst238  (_net_163, SE);
not inst239  (_net_164, SI);
and inst240  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_160, D0, _net_161, _net_162, _net_163, _net_164);
not inst241  (_net_165, D1);
not inst242  (_net_166, D2);
not inst243  (_net_167, D3);
not inst244  (_net_168, SE);
and inst245  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_165, D0, _net_166, _net_167, _net_168, SI);
not inst246  (_net_169, D1);
not inst247  (_net_170, D2);
not inst248  (_net_171, D3);
and inst249  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_169, D0, _net_170, _net_171, SE, SI);
not inst250  (_net_172, D0);
not inst251  (_net_173, CK);
not inst252  (_net_174, D1);
not inst253  (_net_175, D2);
not inst254  (_net_176, D3);
not inst255  (_net_177, SE);
not inst256  (_net_178, SI);
and inst257  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_172, _net_173, _net_174, _net_175, _net_176, _net_177, _net_178);
not inst258  (_net_179, D0);
not inst259  (_net_180, CK);
not inst260  (_net_181, D1);
not inst261  (_net_182, D2);
not inst262  (_net_183, D3);
not inst263  (_net_184, SE);
and inst264  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_179, _net_180, _net_181, _net_182, _net_183, _net_184, SI);
not inst265  (_net_185, D0);
not inst266  (_net_186, CK);
not inst267  (_net_187, D1);
not inst268  (_net_188, D2);
not inst269  (_net_189, D3);
not inst270  (_net_190, SI);
and inst271  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_185, _net_186, _net_187, _net_188, _net_189, SE, _net_190);
not inst272  (_net_191, D0);
not inst273  (_net_192, CK);
not inst274  (_net_193, D1);
not inst275  (_net_194, D2);
not inst276  (_net_195, D3);
and inst277  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_191, _net_192, _net_193, _net_194, _net_195, SE, SI);
not inst278  (_net_196, D0);
not inst279  (_net_197, CK);
not inst280  (_net_198, D1);
not inst281  (_net_199, D2);
not inst282  (_net_200, SE);
not inst283  (_net_201, SI);
and inst284  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_196, _net_197, _net_198, _net_199, D3, _net_200, _net_201);
not inst285  (_net_202, D0);
not inst286  (_net_203, CK);
not inst287  (_net_204, D1);
not inst288  (_net_205, D2);
not inst289  (_net_206, SE);
and inst290  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_202, _net_203, _net_204, _net_205, D3, _net_206, SI);
not inst291  (_net_207, D0);
not inst292  (_net_208, CK);
not inst293  (_net_209, D1);
not inst294  (_net_210, D2);
not inst295  (_net_211, SI);
and inst296  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI, _net_207, _net_208, _net_209, _net_210, D3, SE, _net_211);
not inst297  (_net_212, D0);
not inst298  (_net_213, CK);
not inst299  (_net_214, D1);
not inst300  (_net_215, D2);
and inst301  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_212, _net_213, _net_214, _net_215, D3, SE, SI);
not inst302  (_net_216, D0);
not inst303  (_net_217, CK);
not inst304  (_net_218, D1);
not inst305  (_net_219, D3);
not inst306  (_net_220, SE);
not inst307  (_net_221, SI);
and inst308  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_216, _net_217, _net_218, D2, _net_219, _net_220, _net_221);
not inst309  (_net_222, D0);
not inst310  (_net_223, CK);
not inst311  (_net_224, D1);
not inst312  (_net_225, D3);
not inst313  (_net_226, SE);
and inst314  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_222, _net_223, _net_224, D2, _net_225, _net_226, SI);
not inst315  (_net_227, D0);
not inst316  (_net_228, CK);
not inst317  (_net_229, D1);
not inst318  (_net_230, D3);
not inst319  (_net_231, SI);
and inst320  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_227, _net_228, _net_229, D2, _net_230, SE, _net_231);
not inst321  (_net_232, D0);
not inst322  (_net_233, CK);
not inst323  (_net_234, D1);
not inst324  (_net_235, D3);
and inst325  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_232, _net_233, _net_234, D2, _net_235, SE, SI);
not inst326  (_net_236, D0);
not inst327  (_net_237, CK);
not inst328  (_net_238, D1);
not inst329  (_net_239, SE);
not inst330  (_net_240, SI);
and inst331  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_236, _net_237, _net_238, D2, D3, _net_239, _net_240);
not inst332  (_net_241, D0);
not inst333  (_net_242, CK);
not inst334  (_net_243, D1);
not inst335  (_net_244, SE);
and inst336  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_241, _net_242, _net_243, D2, D3, _net_244, SI);
not inst337  (_net_245, D0);
not inst338  (_net_246, CK);
not inst339  (_net_247, D1);
not inst340  (_net_248, SI);
and inst341  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_245, _net_246, _net_247, D2, D3, SE, _net_248);
not inst342  (_net_249, D0);
not inst343  (_net_250, CK);
not inst344  (_net_251, D1);
and inst345  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_249, _net_250, _net_251, D2, D3, SE, SI);
not inst346  (_net_252, D0);
not inst347  (_net_253, CK);
not inst348  (_net_254, D2);
not inst349  (_net_255, D3);
not inst350  (_net_256, SE);
not inst351  (_net_257, SI);
and inst352  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_252, _net_253, D1, _net_254, _net_255, _net_256, _net_257);
not inst353  (_net_258, D0);
not inst354  (_net_259, CK);
not inst355  (_net_260, D2);
not inst356  (_net_261, D3);
not inst357  (_net_262, SE);
and inst358  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_258, _net_259, D1, _net_260, _net_261, _net_262, SI);
not inst359  (_net_263, D0);
not inst360  (_net_264, CK);
not inst361  (_net_265, D2);
not inst362  (_net_266, D3);
not inst363  (_net_267, SI);
and inst364  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_263, _net_264, D1, _net_265, _net_266, SE, _net_267);
not inst365  (_net_268, D0);
not inst366  (_net_269, CK);
not inst367  (_net_270, D2);
not inst368  (_net_271, D3);
and inst369  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_268, _net_269, D1, _net_270, _net_271, SE, SI);
not inst370  (_net_272, CK);
not inst371  (_net_273, D1);
not inst372  (_net_274, D2);
not inst373  (_net_275, D3);
not inst374  (_net_276, SE);
not inst375  (_net_277, SI);
and inst376  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D0, _net_272, _net_273, _net_274, _net_275, _net_276, _net_277);
not inst377  (_net_278, CK);
not inst378  (_net_279, D1);
not inst379  (_net_280, D2);
not inst380  (_net_281, D3);
not inst381  (_net_282, SE);
and inst382  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D0, _net_278, _net_279, _net_280, _net_281, _net_282, SI);
not inst383  (_net_283, CK);
not inst384  (_net_284, D1);
not inst385  (_net_285, D2);
not inst386  (_net_286, D3);
not inst387  (_net_287, SI);
and inst388  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D0, _net_283, _net_284, _net_285, _net_286, SE, _net_287);
not inst389  (_net_288, CK);
not inst390  (_net_289, D1);
not inst391  (_net_290, D2);
not inst392  (_net_291, D3);
and inst393  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D0, _net_288, _net_289, _net_290, _net_291, SE, SI);
not inst394  (_net_292, CK);
not inst395  (_net_293, D1);
not inst396  (_net_294, D3);
not inst397  (_net_295, SE);
not inst398  (_net_296, SI);
and inst399  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D0, _net_292, _net_293, D2, _net_294, _net_295, _net_296);
not inst400  (_net_297, CK);
not inst401  (_net_298, D1);
not inst402  (_net_299, D3);
not inst403  (_net_300, SE);
and inst404  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D0, _net_297, _net_298, D2, _net_299, _net_300, SI);
not inst405  (_net_301, CK);
not inst406  (_net_302, D1);
not inst407  (_net_303, D3);
not inst408  (_net_304, SI);
and inst409  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D0, _net_301, _net_302, D2, _net_303, SE, _net_304);
not inst410  (_net_305, CK);
not inst411  (_net_306, D1);
not inst412  (_net_307, D3);
and inst413  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, D0, _net_305, _net_306, D2, _net_307, SE, SI);
not inst414  (_net_308, CK);
not inst415  (_net_309, D1);
not inst416  (_net_310, SE);
not inst417  (_net_311, SI);
and inst418  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D0, _net_308, _net_309, D2, D3, _net_310, _net_311);
not inst419  (_net_312, CK);
not inst420  (_net_313, D1);
not inst421  (_net_314, SE);
and inst422  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D0, _net_312, _net_313, D2, D3, _net_314, SI);
not inst423  (_net_315, CK);
not inst424  (_net_316, D1);
not inst425  (_net_317, SI);
and inst426  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D0, _net_315, _net_316, D2, D3, SE, _net_317);
not inst427  (_net_318, CK);
not inst428  (_net_319, D1);
and inst429  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, D0, _net_318, _net_319, D2, D3, SE, SI);
not inst430  (_net_320, CK);
not inst431  (_net_321, SE);
not inst432  (_net_322, SI);
and inst433  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D0, _net_320, D1, D2, D3, _net_321, _net_322);
not inst434  (_net_323, CK);
not inst435  (_net_324, SE);
and inst436  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D0, _net_323, D1, D2, D3, _net_324, SI);
not inst437  (_net_325, CK);
not inst438  (_net_326, SI);
and inst439  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D0, _net_325, D1, D2, D3, SE, _net_326);
not inst440  (_net_327, CK);
and inst441  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI, D0, _net_327, D1, D2, D3, SE, SI);
not inst442  (_net_328, D0);
not inst443  (_net_329, D1);
not inst444  (_net_330, D2);
not inst445  (_net_331, D3);
not inst446  (_net_332, SE);
not inst447  (_net_333, SI);
and inst448  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_328, CK, _net_329, _net_330, _net_331, _net_332, _net_333);
not inst449  (_net_334, D0);
not inst450  (_net_335, D1);
not inst451  (_net_336, D2);
not inst452  (_net_337, D3);
not inst453  (_net_338, SE);
and inst454  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_334, CK, _net_335, _net_336, _net_337, _net_338, SI);
not inst455  (_net_339, D0);
not inst456  (_net_340, D1);
not inst457  (_net_341, D2);
not inst458  (_net_342, D3);
not inst459  (_net_343, SI);
and inst460  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_339, CK, _net_340, _net_341, _net_342, SE, _net_343);
not inst461  (_net_344, D0);
not inst462  (_net_345, D1);
not inst463  (_net_346, D2);
not inst464  (_net_347, D3);
and inst465  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_344, CK, _net_345, _net_346, _net_347, SE, SI);
not inst466  (_net_348, D0);
not inst467  (_net_349, D1);
not inst468  (_net_350, D2);
not inst469  (_net_351, SE);
not inst470  (_net_352, SI);
and inst471  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_348, CK, _net_349, _net_350, D3, _net_351, _net_352);
not inst472  (_net_353, D0);
not inst473  (_net_354, D1);
not inst474  (_net_355, D2);
not inst475  (_net_356, SE);
and inst476  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_353, CK, _net_354, _net_355, D3, _net_356, SI);
not inst477  (_net_357, D0);
not inst478  (_net_358, D1);
not inst479  (_net_359, D2);
not inst480  (_net_360, SI);
and inst481  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI, _net_357, CK, _net_358, _net_359, D3, SE, _net_360);
not inst482  (_net_361, D0);
not inst483  (_net_362, D1);
not inst484  (_net_363, D2);
and inst485  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_361, CK, _net_362, _net_363, D3, SE, SI);
not inst486  (_net_364, D0);
not inst487  (_net_365, D1);
not inst488  (_net_366, D3);
not inst489  (_net_367, SE);
not inst490  (_net_368, SI);
and inst491  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_364, CK, _net_365, D2, _net_366, _net_367, _net_368);
not inst492  (_net_369, D0);
not inst493  (_net_370, D1);
not inst494  (_net_371, D3);
not inst495  (_net_372, SE);
and inst496  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_369, CK, _net_370, D2, _net_371, _net_372, SI);
not inst497  (_net_373, D0);
not inst498  (_net_374, D1);
not inst499  (_net_375, D3);
not inst500  (_net_376, SI);
and inst501  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_373, CK, _net_374, D2, _net_375, SE, _net_376);
not inst502  (_net_377, D0);
not inst503  (_net_378, D1);
not inst504  (_net_379, D3);
and inst505  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_377, CK, _net_378, D2, _net_379, SE, SI);
not inst506  (_net_380, D0);
not inst507  (_net_381, D1);
not inst508  (_net_382, SE);
not inst509  (_net_383, SI);
and inst510  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_380, CK, _net_381, D2, D3, _net_382, _net_383);
not inst511  (_net_384, D0);
not inst512  (_net_385, D1);
not inst513  (_net_386, SE);
and inst514  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_384, CK, _net_385, D2, D3, _net_386, SI);
not inst515  (_net_387, D0);
not inst516  (_net_388, D1);
not inst517  (_net_389, SI);
and inst518  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_387, CK, _net_388, D2, D3, SE, _net_389);
not inst519  (_net_390, D0);
not inst520  (_net_391, D1);
and inst521  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_390, CK, _net_391, D2, D3, SE, SI);
not inst522  (_net_392, D0);
not inst523  (_net_393, D2);
not inst524  (_net_394, D3);
not inst525  (_net_395, SE);
not inst526  (_net_396, SI);
and inst527  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_392, CK, D1, _net_393, _net_394, _net_395, _net_396);
not inst528  (_net_397, D0);
not inst529  (_net_398, D2);
not inst530  (_net_399, D3);
not inst531  (_net_400, SE);
and inst532  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_397, CK, D1, _net_398, _net_399, _net_400, SI);
not inst533  (_net_401, D0);
not inst534  (_net_402, D2);
not inst535  (_net_403, D3);
not inst536  (_net_404, SI);
and inst537  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_401, CK, D1, _net_402, _net_403, SE, _net_404);
not inst538  (_net_405, D0);
not inst539  (_net_406, D2);
not inst540  (_net_407, D3);
and inst541  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_405, CK, D1, _net_406, _net_407, SE, SI);
not inst542  (_net_408, D1);
not inst543  (_net_409, D2);
not inst544  (_net_410, D3);
not inst545  (_net_411, SE);
not inst546  (_net_412, SI);
and inst547  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_408, _net_409, _net_410, _net_411, _net_412);
not inst548  (_net_413, D1);
not inst549  (_net_414, D2);
not inst550  (_net_415, D3);
not inst551  (_net_416, SE);
and inst552  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D0, CK, _net_413, _net_414, _net_415, _net_416, SI);
not inst553  (_net_417, D1);
not inst554  (_net_418, D2);
not inst555  (_net_419, D3);
not inst556  (_net_420, SI);
and inst557  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D0, CK, _net_417, _net_418, _net_419, SE, _net_420);
not inst558  (_net_421, D1);
not inst559  (_net_422, D2);
not inst560  (_net_423, D3);
and inst561  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D0, CK, _net_421, _net_422, _net_423, SE, SI);
not inst562  (_net_424, D1);
not inst563  (_net_425, D3);
not inst564  (_net_426, SE);
not inst565  (_net_427, SI);
and inst566  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_424, D2, _net_425, _net_426, _net_427);
not inst567  (_net_428, D1);
not inst568  (_net_429, D3);
not inst569  (_net_430, SE);
and inst570  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D0, CK, _net_428, D2, _net_429, _net_430, SI);
not inst571  (_net_431, D1);
not inst572  (_net_432, D3);
not inst573  (_net_433, SI);
and inst574  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D0, CK, _net_431, D2, _net_432, SE, _net_433);
not inst575  (_net_434, D1);
not inst576  (_net_435, D3);
and inst577  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, D0, CK, _net_434, D2, _net_435, SE, SI);
not inst578  (_net_436, D1);
not inst579  (_net_437, SE);
not inst580  (_net_438, SI);
and inst581  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_436, D2, D3, _net_437, _net_438);
not inst582  (_net_439, D1);
not inst583  (_net_440, SE);
and inst584  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D0, CK, _net_439, D2, D3, _net_440, SI);
not inst585  (_net_441, D1);
not inst586  (_net_442, SI);
and inst587  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D0, CK, _net_441, D2, D3, SE, _net_442);
not inst588  (_net_443, D1);
and inst589  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, D0, CK, _net_443, D2, D3, SE, SI);
not inst590  (_net_444, SE);
not inst591  (_net_445, SI);
and inst592  (ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D0, CK, D1, D2, D3, _net_444, _net_445);
not inst593  (_net_446, SE);
and inst594  (ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D0, CK, D1, D2, D3, _net_446, SI);
not inst595  (_net_447, SI);
and inst596  (ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D0, CK, D1, D2, D3, SE, _net_447);
and inst597  (ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI, D0, CK, D1, D2, D3, SE, SI);
not inst598  (_net_448, D1);
not inst599  (_net_449, D0);
not inst600  (_net_450, D2);
not inst601  (_net_451, D3);
not inst602  (_net_452, SI);
and inst603  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, _net_448, _net_449, _net_450, _net_451, RD, _net_452);
not inst604  (_net_453, D1);
not inst605  (_net_454, D0);
not inst606  (_net_455, D2);
not inst607  (_net_456, D3);
and inst608  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI, _net_453, _net_454, _net_455, _net_456, RD, SI);
not inst609  (_net_457, D1);
not inst610  (_net_458, D0);
not inst611  (_net_459, D2);
not inst612  (_net_460, SI);
and inst613  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI, _net_457, _net_458, _net_459, D3, RD, _net_460);
not inst614  (_net_461, D1);
not inst615  (_net_462, D0);
not inst616  (_net_463, D3);
not inst617  (_net_464, SI);
and inst618  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, _net_461, _net_462, D2, _net_463, RD, _net_464);
not inst619  (_net_465, D0);
not inst620  (_net_466, D2);
not inst621  (_net_467, D3);
not inst622  (_net_468, SI);
and inst623  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, D1, _net_465, _net_466, _net_467, RD, _net_468);
not inst624  (_net_469, D1);
not inst625  (_net_470, D2);
not inst626  (_net_471, D3);
not inst627  (_net_472, SI);
and inst628  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, _net_469, D0, _net_470, _net_471, RD, _net_472);
not inst629  (_net_473, D0);
and inst630  (ENABLE_NOT_D0_AND_RD_AND_SE, RD, _net_473, SE);
and inst631  (ENABLE_D0_AND_RD_AND_SE, RD, D0, SE);
not inst632  (_net_474, SE);
not inst633  (_net_475, SI);
and inst634  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_474, RD, _net_475);
not inst635  (_net_476, SE);
and inst636  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_476, RD, SI);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
      viol_2 = (viol_2 !== viol_all) ? viol_all : ~viol_2;
      viol_3 = (viol_3 !== viol_all) ? viol_all : ~viol_3;
   end 
`endif 
specify
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
(negedge RD => (Q0 : 1'b0))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
(negedge RD => (Q1 : 1'b0))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (CK==1'b0&&D2==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
(negedge RD => (Q2 : 1'b0))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
if (CK==1'b0&&D3==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
(negedge RD => (Q3 : 1'b0))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD , 0 ,0, viol_all);
$recrem(posedge RD , posedge CK , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPRBQM4SS_V2Y8_1

//%BEGIN HDBSVT11_FSDPRBQM4SS_V2Y8_2

`celldefine
module HDBSVT11_FSDPRBQM4SS_V2Y8_2 (Q0, Q1, Q2, Q3, CK, D0, D1, D2, D3, SI, SE, RD);
   output Q0, Q1, Q2, Q3;
   input CK, D0, D1, D2, D3, SI, SE, RD;

   reg viol_all, viol_0,  viol_1,  viol_2,  viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE, delayed_RD;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res__RD, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
   buf inst7  (delayed_RD, RD);
`endif
   not inst8  (int_res__RD, delayed_RD);

   snps_mux2 inst9  (int_res__D0, delayed_SI, delayed_D0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst10  (xcr_0, delayed_CK, int_res__D0, int_res__RD);

  `endif
   snps_dff_r inst11  (int_res_iq0, viol_0, delayed_CK, int_res__D0, int_res__RD, xcr_0);

   snps_mux2 inst12  (int_res__D1, int_res_iq0, delayed_D1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst13  (xcr_1, delayed_CK, int_res__D1, int_res__RD);

  `endif
   snps_dff_r inst14  (int_res_iq1, viol_1, delayed_CK, int_res__D1, int_res__RD, xcr_1);

   snps_mux2 inst15  (int_res__D2, int_res_iq1, delayed_D2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst16  (xcr_2, delayed_CK, int_res__D2, int_res__RD);

  `endif
   snps_dff_r inst17  (int_res_iq2, viol_2, delayed_CK, int_res__D2, int_res__RD, xcr_2);

   snps_mux2 inst18  (int_res__D3, int_res_iq2, delayed_D3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst19  (xcr_3, delayed_CK, int_res__D3, int_res__RD);

  `endif
   snps_dff_r inst20  (int_res_iq3, viol_3, delayed_CK, int_res__D3, int_res__RD, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst21 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst22 (Q1, int_res_iq1);
        buf #`SNPS_SEQ_DELAY  inst23 (Q2, int_res_iq2);
        buf #`SNPS_SEQ_DELAY  inst24 (Q3, int_res_iq3);
   `else
        buf inst25  (Q0, int_res_iq0);
        buf inst26  (Q1, int_res_iq1);
        buf inst27  (Q2, int_res_iq2);
        buf inst28  (Q3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst29  (_net_0, D1);
not inst30  (_net_1, D0);
not inst31  (_net_2, D2);
not inst32  (_net_3, D3);
not inst33  (_net_4, SE);
not inst34  (_net_5, SI);
and inst35  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, RD, _net_4, _net_5);
not inst36  (_net_6, D1);
not inst37  (_net_7, D0);
not inst38  (_net_8, D2);
not inst39  (_net_9, D3);
not inst40  (_net_10, SE);
and inst41  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_6, _net_7, _net_8, _net_9, RD, _net_10, SI);
not inst42  (_net_11, D1);
not inst43  (_net_12, D0);
not inst44  (_net_13, D2);
not inst45  (_net_14, D3);
not inst46  (_net_15, SI);
and inst47  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_11, _net_12, _net_13, _net_14, RD, SE, _net_15);
not inst48  (_net_16, D1);
not inst49  (_net_17, D0);
not inst50  (_net_18, D2);
not inst51  (_net_19, D3);
and inst52  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_16, _net_17, _net_18, _net_19, RD, SE, SI);
not inst53  (_net_20, D1);
not inst54  (_net_21, D0);
not inst55  (_net_22, D2);
not inst56  (_net_23, SE);
not inst57  (_net_24, SI);
and inst58  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22, D3, RD, _net_23, _net_24);
not inst59  (_net_25, D1);
not inst60  (_net_26, D0);
not inst61  (_net_27, D2);
not inst62  (_net_28, SE);
and inst63  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_25, _net_26, _net_27, D3, RD, _net_28, SI);
not inst64  (_net_29, D1);
not inst65  (_net_30, D0);
not inst66  (_net_31, D2);
not inst67  (_net_32, SI);
and inst68  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_29, _net_30, _net_31, D3, RD, SE, _net_32);
not inst69  (_net_33, D1);
not inst70  (_net_34, D0);
not inst71  (_net_35, D2);
and inst72  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_33, _net_34, _net_35, D3, RD, SE, SI);
not inst73  (_net_36, D1);
not inst74  (_net_37, D0);
not inst75  (_net_38, D3);
not inst76  (_net_39, SE);
not inst77  (_net_40, SI);
and inst78  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, D2, _net_38, RD, _net_39, _net_40);
not inst79  (_net_41, D1);
not inst80  (_net_42, D0);
not inst81  (_net_43, D3);
not inst82  (_net_44, SE);
and inst83  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_41, _net_42, D2, _net_43, RD, _net_44, SI);
not inst84  (_net_45, D1);
not inst85  (_net_46, D0);
not inst86  (_net_47, D3);
not inst87  (_net_48, SI);
and inst88  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_45, _net_46, D2, _net_47, RD, SE, _net_48);
not inst89  (_net_49, D1);
not inst90  (_net_50, D0);
not inst91  (_net_51, D3);
and inst92  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_49, _net_50, D2, _net_51, RD, SE, SI);
not inst93  (_net_52, D1);
not inst94  (_net_53, D0);
not inst95  (_net_54, SE);
not inst96  (_net_55, SI);
and inst97  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_52, _net_53, D2, D3, RD, _net_54, _net_55);
not inst98  (_net_56, D1);
not inst99  (_net_57, D0);
not inst100  (_net_58, SE);
and inst101  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_56, _net_57, D2, D3, RD, _net_58, SI);
not inst102  (_net_59, D1);
not inst103  (_net_60, D0);
not inst104  (_net_61, SI);
and inst105  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_59, _net_60, D2, D3, RD, SE, _net_61);
not inst106  (_net_62, D1);
not inst107  (_net_63, D0);
and inst108  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_62, _net_63, D2, D3, RD, SE, SI);
not inst109  (_net_64, D0);
not inst110  (_net_65, D2);
not inst111  (_net_66, D3);
not inst112  (_net_67, SE);
not inst113  (_net_68, SI);
and inst114  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_64, _net_65, _net_66, RD, _net_67, _net_68);
not inst115  (_net_69, D0);
not inst116  (_net_70, D2);
not inst117  (_net_71, D3);
not inst118  (_net_72, SE);
and inst119  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, D1, _net_69, _net_70, _net_71, RD, _net_72, SI);
not inst120  (_net_73, D0);
not inst121  (_net_74, D2);
not inst122  (_net_75, D3);
not inst123  (_net_76, SI);
and inst124  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, D1, _net_73, _net_74, _net_75, RD, SE, _net_76);
not inst125  (_net_77, D0);
not inst126  (_net_78, D2);
not inst127  (_net_79, D3);
and inst128  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, D1, _net_77, _net_78, _net_79, RD, SE, SI);
not inst129  (_net_80, D1);
not inst130  (_net_81, D2);
not inst131  (_net_82, D3);
not inst132  (_net_83, SE);
not inst133  (_net_84, SI);
and inst134  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_80, D0, _net_81, _net_82, RD, _net_83, _net_84);
not inst135  (_net_85, D1);
not inst136  (_net_86, D2);
not inst137  (_net_87, D3);
not inst138  (_net_88, SE);
and inst139  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_85, D0, _net_86, _net_87, RD, _net_88, SI);
not inst140  (_net_89, D1);
not inst141  (_net_90, D2);
not inst142  (_net_91, D3);
not inst143  (_net_92, SI);
and inst144  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_89, D0, _net_90, _net_91, RD, SE, _net_92);
not inst145  (_net_93, D1);
not inst146  (_net_94, D2);
not inst147  (_net_95, D3);
and inst148  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_93, D0, _net_94, _net_95, RD, SE, SI);
not inst149  (_net_96, D1);
not inst150  (_net_97, D3);
not inst151  (_net_98, SE);
not inst152  (_net_99, SI);
and inst153  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_96, D0, D2, _net_97, RD, _net_98, _net_99);
not inst154  (_net_100, D1);
not inst155  (_net_101, D3);
not inst156  (_net_102, SE);
and inst157  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_100, D0, D2, _net_101, RD, _net_102, SI);
not inst158  (_net_103, D1);
not inst159  (_net_104, D3);
not inst160  (_net_105, SI);
and inst161  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_103, D0, D2, _net_104, RD, SE, _net_105);
not inst162  (_net_106, D1);
not inst163  (_net_107, D3);
and inst164  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_106, D0, D2, _net_107, RD, SE, SI);
not inst165  (_net_108, D1);
not inst166  (_net_109, SE);
not inst167  (_net_110, SI);
and inst168  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_108, D0, D2, D3, RD, _net_109, _net_110);
not inst169  (_net_111, D1);
not inst170  (_net_112, SE);
and inst171  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_111, D0, D2, D3, RD, _net_112, SI);
not inst172  (_net_113, D1);
not inst173  (_net_114, SI);
and inst174  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_113, D0, D2, D3, RD, SE, _net_114);
not inst175  (_net_115, D1);
and inst176  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_115, D0, D2, D3, RD, SE, SI);
not inst177  (_net_116, SE);
not inst178  (_net_117, SI);
and inst179  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, RD, _net_116, _net_117);
not inst180  (_net_118, SE);
and inst181  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, D1, D0, D2, D3, RD, _net_118, SI);
not inst182  (_net_119, SI);
and inst183  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, D1, D0, D2, D3, RD, SE, _net_119);
and inst184  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, D1, D0, D2, D3, RD, SE, SI);
not inst185  (_net_120, D1);
not inst186  (_net_121, D0);
not inst187  (_net_122, D2);
not inst188  (_net_123, D3);
and inst189  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_120, _net_121, _net_122, _net_123, SE, SI);
not inst190  (_net_124, D1);
not inst191  (_net_125, D0);
not inst192  (_net_126, D2);
not inst193  (_net_127, SE);
not inst194  (_net_128, SI);
and inst195  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_124, _net_125, _net_126, D3, _net_127, _net_128);
not inst196  (_net_129, D1);
not inst197  (_net_130, D0);
not inst198  (_net_131, D2);
not inst199  (_net_132, SE);
and inst200  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_129, _net_130, _net_131, D3, _net_132, SI);
not inst201  (_net_133, D1);
not inst202  (_net_134, D0);
not inst203  (_net_135, D2);
and inst204  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_133, _net_134, _net_135, D3, SE, SI);
not inst205  (_net_136, D1);
not inst206  (_net_137, D0);
not inst207  (_net_138, D3);
not inst208  (_net_139, SE);
not inst209  (_net_140, SI);
and inst210  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_136, _net_137, D2, _net_138, _net_139, _net_140);
not inst211  (_net_141, D1);
not inst212  (_net_142, D0);
not inst213  (_net_143, D3);
not inst214  (_net_144, SE);
and inst215  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_141, _net_142, D2, _net_143, _net_144, SI);
not inst216  (_net_145, D1);
not inst217  (_net_146, D0);
not inst218  (_net_147, D3);
and inst219  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_145, _net_146, D2, _net_147, SE, SI);
not inst220  (_net_148, D0);
not inst221  (_net_149, D2);
not inst222  (_net_150, D3);
not inst223  (_net_151, SE);
not inst224  (_net_152, SI);
and inst225  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_148, _net_149, _net_150, _net_151, _net_152);
not inst226  (_net_153, D0);
not inst227  (_net_154, D2);
not inst228  (_net_155, D3);
not inst229  (_net_156, SE);
and inst230  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_153, _net_154, _net_155, _net_156, SI);
not inst231  (_net_157, D0);
not inst232  (_net_158, D2);
not inst233  (_net_159, D3);
and inst234  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D1, _net_157, _net_158, _net_159, SE, SI);
not inst235  (_net_160, D1);
not inst236  (_net_161, D2);
not inst237  (_net_162, D3);
not inst238  (_net_163, SE);
not inst239  (_net_164, SI);
and inst240  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_160, D0, _net_161, _net_162, _net_163, _net_164);
not inst241  (_net_165, D1);
not inst242  (_net_166, D2);
not inst243  (_net_167, D3);
not inst244  (_net_168, SE);
and inst245  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_165, D0, _net_166, _net_167, _net_168, SI);
not inst246  (_net_169, D1);
not inst247  (_net_170, D2);
not inst248  (_net_171, D3);
and inst249  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_169, D0, _net_170, _net_171, SE, SI);
not inst250  (_net_172, D0);
not inst251  (_net_173, CK);
not inst252  (_net_174, D1);
not inst253  (_net_175, D2);
not inst254  (_net_176, D3);
not inst255  (_net_177, SE);
not inst256  (_net_178, SI);
and inst257  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_172, _net_173, _net_174, _net_175, _net_176, _net_177, _net_178);
not inst258  (_net_179, D0);
not inst259  (_net_180, CK);
not inst260  (_net_181, D1);
not inst261  (_net_182, D2);
not inst262  (_net_183, D3);
not inst263  (_net_184, SE);
and inst264  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_179, _net_180, _net_181, _net_182, _net_183, _net_184, SI);
not inst265  (_net_185, D0);
not inst266  (_net_186, CK);
not inst267  (_net_187, D1);
not inst268  (_net_188, D2);
not inst269  (_net_189, D3);
not inst270  (_net_190, SI);
and inst271  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_185, _net_186, _net_187, _net_188, _net_189, SE, _net_190);
not inst272  (_net_191, D0);
not inst273  (_net_192, CK);
not inst274  (_net_193, D1);
not inst275  (_net_194, D2);
not inst276  (_net_195, D3);
and inst277  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_191, _net_192, _net_193, _net_194, _net_195, SE, SI);
not inst278  (_net_196, D0);
not inst279  (_net_197, CK);
not inst280  (_net_198, D1);
not inst281  (_net_199, D2);
not inst282  (_net_200, SE);
not inst283  (_net_201, SI);
and inst284  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_196, _net_197, _net_198, _net_199, D3, _net_200, _net_201);
not inst285  (_net_202, D0);
not inst286  (_net_203, CK);
not inst287  (_net_204, D1);
not inst288  (_net_205, D2);
not inst289  (_net_206, SE);
and inst290  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_202, _net_203, _net_204, _net_205, D3, _net_206, SI);
not inst291  (_net_207, D0);
not inst292  (_net_208, CK);
not inst293  (_net_209, D1);
not inst294  (_net_210, D2);
not inst295  (_net_211, SI);
and inst296  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI, _net_207, _net_208, _net_209, _net_210, D3, SE, _net_211);
not inst297  (_net_212, D0);
not inst298  (_net_213, CK);
not inst299  (_net_214, D1);
not inst300  (_net_215, D2);
and inst301  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_212, _net_213, _net_214, _net_215, D3, SE, SI);
not inst302  (_net_216, D0);
not inst303  (_net_217, CK);
not inst304  (_net_218, D1);
not inst305  (_net_219, D3);
not inst306  (_net_220, SE);
not inst307  (_net_221, SI);
and inst308  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_216, _net_217, _net_218, D2, _net_219, _net_220, _net_221);
not inst309  (_net_222, D0);
not inst310  (_net_223, CK);
not inst311  (_net_224, D1);
not inst312  (_net_225, D3);
not inst313  (_net_226, SE);
and inst314  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_222, _net_223, _net_224, D2, _net_225, _net_226, SI);
not inst315  (_net_227, D0);
not inst316  (_net_228, CK);
not inst317  (_net_229, D1);
not inst318  (_net_230, D3);
not inst319  (_net_231, SI);
and inst320  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_227, _net_228, _net_229, D2, _net_230, SE, _net_231);
not inst321  (_net_232, D0);
not inst322  (_net_233, CK);
not inst323  (_net_234, D1);
not inst324  (_net_235, D3);
and inst325  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_232, _net_233, _net_234, D2, _net_235, SE, SI);
not inst326  (_net_236, D0);
not inst327  (_net_237, CK);
not inst328  (_net_238, D1);
not inst329  (_net_239, SE);
not inst330  (_net_240, SI);
and inst331  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_236, _net_237, _net_238, D2, D3, _net_239, _net_240);
not inst332  (_net_241, D0);
not inst333  (_net_242, CK);
not inst334  (_net_243, D1);
not inst335  (_net_244, SE);
and inst336  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_241, _net_242, _net_243, D2, D3, _net_244, SI);
not inst337  (_net_245, D0);
not inst338  (_net_246, CK);
not inst339  (_net_247, D1);
not inst340  (_net_248, SI);
and inst341  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_245, _net_246, _net_247, D2, D3, SE, _net_248);
not inst342  (_net_249, D0);
not inst343  (_net_250, CK);
not inst344  (_net_251, D1);
and inst345  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_249, _net_250, _net_251, D2, D3, SE, SI);
not inst346  (_net_252, D0);
not inst347  (_net_253, CK);
not inst348  (_net_254, D2);
not inst349  (_net_255, D3);
not inst350  (_net_256, SE);
not inst351  (_net_257, SI);
and inst352  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_252, _net_253, D1, _net_254, _net_255, _net_256, _net_257);
not inst353  (_net_258, D0);
not inst354  (_net_259, CK);
not inst355  (_net_260, D2);
not inst356  (_net_261, D3);
not inst357  (_net_262, SE);
and inst358  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_258, _net_259, D1, _net_260, _net_261, _net_262, SI);
not inst359  (_net_263, D0);
not inst360  (_net_264, CK);
not inst361  (_net_265, D2);
not inst362  (_net_266, D3);
not inst363  (_net_267, SI);
and inst364  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_263, _net_264, D1, _net_265, _net_266, SE, _net_267);
not inst365  (_net_268, D0);
not inst366  (_net_269, CK);
not inst367  (_net_270, D2);
not inst368  (_net_271, D3);
and inst369  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_268, _net_269, D1, _net_270, _net_271, SE, SI);
not inst370  (_net_272, CK);
not inst371  (_net_273, D1);
not inst372  (_net_274, D2);
not inst373  (_net_275, D3);
not inst374  (_net_276, SE);
not inst375  (_net_277, SI);
and inst376  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D0, _net_272, _net_273, _net_274, _net_275, _net_276, _net_277);
not inst377  (_net_278, CK);
not inst378  (_net_279, D1);
not inst379  (_net_280, D2);
not inst380  (_net_281, D3);
not inst381  (_net_282, SE);
and inst382  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D0, _net_278, _net_279, _net_280, _net_281, _net_282, SI);
not inst383  (_net_283, CK);
not inst384  (_net_284, D1);
not inst385  (_net_285, D2);
not inst386  (_net_286, D3);
not inst387  (_net_287, SI);
and inst388  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D0, _net_283, _net_284, _net_285, _net_286, SE, _net_287);
not inst389  (_net_288, CK);
not inst390  (_net_289, D1);
not inst391  (_net_290, D2);
not inst392  (_net_291, D3);
and inst393  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D0, _net_288, _net_289, _net_290, _net_291, SE, SI);
not inst394  (_net_292, CK);
not inst395  (_net_293, D1);
not inst396  (_net_294, D3);
not inst397  (_net_295, SE);
not inst398  (_net_296, SI);
and inst399  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D0, _net_292, _net_293, D2, _net_294, _net_295, _net_296);
not inst400  (_net_297, CK);
not inst401  (_net_298, D1);
not inst402  (_net_299, D3);
not inst403  (_net_300, SE);
and inst404  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D0, _net_297, _net_298, D2, _net_299, _net_300, SI);
not inst405  (_net_301, CK);
not inst406  (_net_302, D1);
not inst407  (_net_303, D3);
not inst408  (_net_304, SI);
and inst409  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D0, _net_301, _net_302, D2, _net_303, SE, _net_304);
not inst410  (_net_305, CK);
not inst411  (_net_306, D1);
not inst412  (_net_307, D3);
and inst413  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, D0, _net_305, _net_306, D2, _net_307, SE, SI);
not inst414  (_net_308, CK);
not inst415  (_net_309, D1);
not inst416  (_net_310, SE);
not inst417  (_net_311, SI);
and inst418  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D0, _net_308, _net_309, D2, D3, _net_310, _net_311);
not inst419  (_net_312, CK);
not inst420  (_net_313, D1);
not inst421  (_net_314, SE);
and inst422  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D0, _net_312, _net_313, D2, D3, _net_314, SI);
not inst423  (_net_315, CK);
not inst424  (_net_316, D1);
not inst425  (_net_317, SI);
and inst426  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D0, _net_315, _net_316, D2, D3, SE, _net_317);
not inst427  (_net_318, CK);
not inst428  (_net_319, D1);
and inst429  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, D0, _net_318, _net_319, D2, D3, SE, SI);
not inst430  (_net_320, CK);
not inst431  (_net_321, SE);
not inst432  (_net_322, SI);
and inst433  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D0, _net_320, D1, D2, D3, _net_321, _net_322);
not inst434  (_net_323, CK);
not inst435  (_net_324, SE);
and inst436  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D0, _net_323, D1, D2, D3, _net_324, SI);
not inst437  (_net_325, CK);
not inst438  (_net_326, SI);
and inst439  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D0, _net_325, D1, D2, D3, SE, _net_326);
not inst440  (_net_327, CK);
and inst441  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI, D0, _net_327, D1, D2, D3, SE, SI);
not inst442  (_net_328, D0);
not inst443  (_net_329, D1);
not inst444  (_net_330, D2);
not inst445  (_net_331, D3);
not inst446  (_net_332, SE);
not inst447  (_net_333, SI);
and inst448  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_328, CK, _net_329, _net_330, _net_331, _net_332, _net_333);
not inst449  (_net_334, D0);
not inst450  (_net_335, D1);
not inst451  (_net_336, D2);
not inst452  (_net_337, D3);
not inst453  (_net_338, SE);
and inst454  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_334, CK, _net_335, _net_336, _net_337, _net_338, SI);
not inst455  (_net_339, D0);
not inst456  (_net_340, D1);
not inst457  (_net_341, D2);
not inst458  (_net_342, D3);
not inst459  (_net_343, SI);
and inst460  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_339, CK, _net_340, _net_341, _net_342, SE, _net_343);
not inst461  (_net_344, D0);
not inst462  (_net_345, D1);
not inst463  (_net_346, D2);
not inst464  (_net_347, D3);
and inst465  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_344, CK, _net_345, _net_346, _net_347, SE, SI);
not inst466  (_net_348, D0);
not inst467  (_net_349, D1);
not inst468  (_net_350, D2);
not inst469  (_net_351, SE);
not inst470  (_net_352, SI);
and inst471  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_348, CK, _net_349, _net_350, D3, _net_351, _net_352);
not inst472  (_net_353, D0);
not inst473  (_net_354, D1);
not inst474  (_net_355, D2);
not inst475  (_net_356, SE);
and inst476  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_353, CK, _net_354, _net_355, D3, _net_356, SI);
not inst477  (_net_357, D0);
not inst478  (_net_358, D1);
not inst479  (_net_359, D2);
not inst480  (_net_360, SI);
and inst481  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI, _net_357, CK, _net_358, _net_359, D3, SE, _net_360);
not inst482  (_net_361, D0);
not inst483  (_net_362, D1);
not inst484  (_net_363, D2);
and inst485  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI, _net_361, CK, _net_362, _net_363, D3, SE, SI);
not inst486  (_net_364, D0);
not inst487  (_net_365, D1);
not inst488  (_net_366, D3);
not inst489  (_net_367, SE);
not inst490  (_net_368, SI);
and inst491  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_364, CK, _net_365, D2, _net_366, _net_367, _net_368);
not inst492  (_net_369, D0);
not inst493  (_net_370, D1);
not inst494  (_net_371, D3);
not inst495  (_net_372, SE);
and inst496  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_369, CK, _net_370, D2, _net_371, _net_372, SI);
not inst497  (_net_373, D0);
not inst498  (_net_374, D1);
not inst499  (_net_375, D3);
not inst500  (_net_376, SI);
and inst501  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_373, CK, _net_374, D2, _net_375, SE, _net_376);
not inst502  (_net_377, D0);
not inst503  (_net_378, D1);
not inst504  (_net_379, D3);
and inst505  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, _net_377, CK, _net_378, D2, _net_379, SE, SI);
not inst506  (_net_380, D0);
not inst507  (_net_381, D1);
not inst508  (_net_382, SE);
not inst509  (_net_383, SI);
and inst510  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_380, CK, _net_381, D2, D3, _net_382, _net_383);
not inst511  (_net_384, D0);
not inst512  (_net_385, D1);
not inst513  (_net_386, SE);
and inst514  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, _net_384, CK, _net_385, D2, D3, _net_386, SI);
not inst515  (_net_387, D0);
not inst516  (_net_388, D1);
not inst517  (_net_389, SI);
and inst518  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, _net_387, CK, _net_388, D2, D3, SE, _net_389);
not inst519  (_net_390, D0);
not inst520  (_net_391, D1);
and inst521  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, _net_390, CK, _net_391, D2, D3, SE, SI);
not inst522  (_net_392, D0);
not inst523  (_net_393, D2);
not inst524  (_net_394, D3);
not inst525  (_net_395, SE);
not inst526  (_net_396, SI);
and inst527  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_392, CK, D1, _net_393, _net_394, _net_395, _net_396);
not inst528  (_net_397, D0);
not inst529  (_net_398, D2);
not inst530  (_net_399, D3);
not inst531  (_net_400, SE);
and inst532  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_397, CK, D1, _net_398, _net_399, _net_400, SI);
not inst533  (_net_401, D0);
not inst534  (_net_402, D2);
not inst535  (_net_403, D3);
not inst536  (_net_404, SI);
and inst537  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, _net_401, CK, D1, _net_402, _net_403, SE, _net_404);
not inst538  (_net_405, D0);
not inst539  (_net_406, D2);
not inst540  (_net_407, D3);
and inst541  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, _net_405, CK, D1, _net_406, _net_407, SE, SI);
not inst542  (_net_408, D1);
not inst543  (_net_409, D2);
not inst544  (_net_410, D3);
not inst545  (_net_411, SE);
not inst546  (_net_412, SI);
and inst547  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_408, _net_409, _net_410, _net_411, _net_412);
not inst548  (_net_413, D1);
not inst549  (_net_414, D2);
not inst550  (_net_415, D3);
not inst551  (_net_416, SE);
and inst552  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D0, CK, _net_413, _net_414, _net_415, _net_416, SI);
not inst553  (_net_417, D1);
not inst554  (_net_418, D2);
not inst555  (_net_419, D3);
not inst556  (_net_420, SI);
and inst557  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D0, CK, _net_417, _net_418, _net_419, SE, _net_420);
not inst558  (_net_421, D1);
not inst559  (_net_422, D2);
not inst560  (_net_423, D3);
and inst561  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI, D0, CK, _net_421, _net_422, _net_423, SE, SI);
not inst562  (_net_424, D1);
not inst563  (_net_425, D3);
not inst564  (_net_426, SE);
not inst565  (_net_427, SI);
and inst566  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_424, D2, _net_425, _net_426, _net_427);
not inst567  (_net_428, D1);
not inst568  (_net_429, D3);
not inst569  (_net_430, SE);
and inst570  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D0, CK, _net_428, D2, _net_429, _net_430, SI);
not inst571  (_net_431, D1);
not inst572  (_net_432, D3);
not inst573  (_net_433, SI);
and inst574  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI, D0, CK, _net_431, D2, _net_432, SE, _net_433);
not inst575  (_net_434, D1);
not inst576  (_net_435, D3);
and inst577  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI, D0, CK, _net_434, D2, _net_435, SE, SI);
not inst578  (_net_436, D1);
not inst579  (_net_437, SE);
not inst580  (_net_438, SI);
and inst581  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_436, D2, D3, _net_437, _net_438);
not inst582  (_net_439, D1);
not inst583  (_net_440, SE);
and inst584  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D0, CK, _net_439, D2, D3, _net_440, SI);
not inst585  (_net_441, D1);
not inst586  (_net_442, SI);
and inst587  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D0, CK, _net_441, D2, D3, SE, _net_442);
not inst588  (_net_443, D1);
and inst589  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI, D0, CK, _net_443, D2, D3, SE, SI);
not inst590  (_net_444, SE);
not inst591  (_net_445, SI);
and inst592  (ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, D0, CK, D1, D2, D3, _net_444, _net_445);
not inst593  (_net_446, SE);
and inst594  (ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI, D0, CK, D1, D2, D3, _net_446, SI);
not inst595  (_net_447, SI);
and inst596  (ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI, D0, CK, D1, D2, D3, SE, _net_447);
and inst597  (ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI, D0, CK, D1, D2, D3, SE, SI);
not inst598  (_net_448, D1);
not inst599  (_net_449, D0);
not inst600  (_net_450, D2);
not inst601  (_net_451, D3);
not inst602  (_net_452, SI);
and inst603  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, _net_448, _net_449, _net_450, _net_451, RD, _net_452);
not inst604  (_net_453, D1);
not inst605  (_net_454, D0);
not inst606  (_net_455, D2);
not inst607  (_net_456, D3);
and inst608  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI, _net_453, _net_454, _net_455, _net_456, RD, SI);
not inst609  (_net_457, D1);
not inst610  (_net_458, D0);
not inst611  (_net_459, D2);
not inst612  (_net_460, SI);
and inst613  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI, _net_457, _net_458, _net_459, D3, RD, _net_460);
not inst614  (_net_461, D1);
not inst615  (_net_462, D0);
not inst616  (_net_463, D3);
not inst617  (_net_464, SI);
and inst618  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, _net_461, _net_462, D2, _net_463, RD, _net_464);
not inst619  (_net_465, D0);
not inst620  (_net_466, D2);
not inst621  (_net_467, D3);
not inst622  (_net_468, SI);
and inst623  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, D1, _net_465, _net_466, _net_467, RD, _net_468);
not inst624  (_net_469, D1);
not inst625  (_net_470, D2);
not inst626  (_net_471, D3);
not inst627  (_net_472, SI);
and inst628  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, _net_469, D0, _net_470, _net_471, RD, _net_472);
not inst629  (_net_473, D0);
and inst630  (ENABLE_NOT_D0_AND_RD_AND_SE, RD, _net_473, SE);
and inst631  (ENABLE_D0_AND_RD_AND_SE, RD, D0, SE);
not inst632  (_net_474, SE);
not inst633  (_net_475, SI);
and inst634  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_474, RD, _net_475);
not inst635  (_net_476, SE);
and inst636  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_476, RD, SI);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
      viol_2 = (viol_2 !== viol_all) ? viol_all : ~viol_2;
      viol_3 = (viol_3 !== viol_all) ? viol_all : ~viol_3;
   end 
`endif 
specify
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
(negedge RD => (Q0 : 1'b0))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
(negedge RD => (Q1 : 1'b0))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (CK==1'b0&&D2==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
(negedge RD => (Q2 : 1'b0))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
if (CK==1'b0&&D3==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
(negedge RD => (Q3 : 1'b0))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD , 0 ,0, viol_all);
$recrem(posedge RD , posedge CK , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPRBQM4SS_V2Y8_2

//%BEGIN HDBSVT11_FSDPRBQM8SS_V2Y16_1
`celldefine
module HDBSVT11_FSDPRBQM8SS_V2Y16_1 (Q0, Q1, Q2, Q3, Q4, Q5, Q6, Q7, CK, D0, D1, D2, D3, D4, D5, D6, D7, SI, SE, RD);
  input CK, D0, D1, D2, D3, D4, D5, D6, D7, SI, SE, RD;
  output Q0, Q1, Q2, Q3, Q4, Q5, Q6, Q7;
   reg viol_all, viol_0,  viol_1,  viol_2,  viol_3,  viol_4,  viol_5,  viol_6,  viol_7;
  wire int_16, iq7, iq6, iq5, iq4, iq3, iq2, iq1, iq0, d_int7, d_int6, d_int5, d_int4, d_int3, d_int2, d_int1, d_int0;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D0, D0);
    buf inst2  (delayed_D1, D1);
    buf inst3  (delayed_D2, D2);
    buf inst4  (delayed_D3, D3);
    buf inst5  (delayed_D4, D4);
    buf inst6  (delayed_D5, D5);
    buf inst7  (delayed_D6, D6);
    buf inst8  (delayed_D7, D7);
    buf inst9  (delayed_SI, SI);
    buf inst10  (delayed_SE, SE);
    buf inst11  (delayed_RD, RD);
  `endif


    not inst12  (int_16, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst13  (xcr_26, delayed_CK, d_int7, int_16);

  `endif
    snps_dff_r inst14  (iq7, viol_7, delayed_CK, d_int7, int_16, xcr_26);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst15  (xcr_28, delayed_CK, d_int6, int_16);

  `endif
    snps_dff_r inst16  (iq6, viol_6, delayed_CK, d_int6, int_16, xcr_28);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst17  (xcr_30, delayed_CK, d_int5, int_16);

  `endif
    snps_dff_r inst18  (iq5, viol_5, delayed_CK, d_int5, int_16, xcr_30);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst19  (xcr_32, delayed_CK, d_int4, int_16);

  `endif
    snps_dff_r inst20  (iq4, viol_4, delayed_CK, d_int4, int_16, xcr_32);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst21  (xcr_34, delayed_CK, d_int3, int_16);

  `endif
    snps_dff_r inst22  (iq3, viol_3, delayed_CK, d_int3, int_16, xcr_34);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst23  (xcr_36, delayed_CK, d_int2, int_16);

  `endif
    snps_dff_r inst24  (iq2, viol_2, delayed_CK, d_int2, int_16, xcr_36);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst25  (xcr_38, delayed_CK, d_int1, int_16);

  `endif
    snps_dff_r inst26  (iq1, viol_1, delayed_CK, d_int1, int_16, xcr_38);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst27  (xcr_40, delayed_CK, d_int0, int_16);

  `endif
    snps_dff_r inst28  (iq0, viol_0, delayed_CK, d_int0, int_16, xcr_40);
    snps_mux2 inst29  (d_int7, iq6, delayed_D7, delayed_SE);
    snps_mux2 inst30  (d_int6, iq5, delayed_D6, delayed_SE);
    snps_mux2 inst31  (d_int5, iq4, delayed_D5, delayed_SE);
    snps_mux2 inst32  (d_int4, iq3, delayed_D4, delayed_SE);
    snps_mux2 inst33  (d_int3, iq2, delayed_D3, delayed_SE);
    snps_mux2 inst34  (d_int2, iq1, delayed_D2, delayed_SE);
    snps_mux2 inst35  (d_int1, iq0, delayed_D1, delayed_SE);
    snps_mux2 inst36  (d_int0, delayed_SI, delayed_D0, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst37 (Q7, iq7);
    buf #`SNPS_SEQ_DELAY  inst38 (Q6, iq6);
    buf #`SNPS_SEQ_DELAY  inst39 (Q5, iq5);
    buf #`SNPS_SEQ_DELAY  inst40 (Q4, iq4);
    buf #`SNPS_SEQ_DELAY  inst41 (Q3, iq3);
    buf #`SNPS_SEQ_DELAY  inst42 (Q2, iq2);
    buf #`SNPS_SEQ_DELAY  inst43 (Q1, iq1);
    buf #`SNPS_SEQ_DELAY  inst44 (Q0, iq0);
  `else
    buf inst45  (Q7, iq7);
    buf inst46  (Q6, iq6);
    buf inst47  (Q5, iq5);
    buf inst48  (Q4, iq4);
    buf inst49  (Q3, iq3);
    buf inst50  (Q2, iq2);
    buf inst51  (Q1, iq1);
    buf inst52  (Q0, iq0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst53  (_net_0, D1);
not inst54  (_net_1, D0);
not inst55  (_net_2, D2);
not inst56  (_net_3, D3);
not inst57  (_net_4, D4);
not inst58  (_net_5, D5);
not inst59  (_net_6, D6);
not inst60  (_net_7, D7);
not inst61  (_net_8, SE);
not inst62  (_net_9, SI);
and inst63  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5, _net_6, _net_7, RD, _net_8, _net_9);
not inst64  (_net_10, D1);
not inst65  (_net_11, D0);
not inst66  (_net_12, D2);
not inst67  (_net_13, D3);
not inst68  (_net_14, D4);
not inst69  (_net_15, D5);
not inst70  (_net_16, D6);
not inst71  (_net_17, D7);
not inst72  (_net_18, SE);
and inst73  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, _net_13, _net_14, _net_15, _net_16, _net_17, RD, _net_18, SI);
not inst74  (_net_19, D1);
not inst75  (_net_20, D0);
not inst76  (_net_21, D2);
not inst77  (_net_22, D3);
not inst78  (_net_23, D4);
not inst79  (_net_24, D5);
not inst80  (_net_25, D6);
not inst81  (_net_26, D7);
not inst82  (_net_27, SI);
and inst83  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_19, _net_20, _net_21, _net_22, _net_23, _net_24, _net_25, _net_26, RD, SE, _net_27);
not inst84  (_net_28, D1);
not inst85  (_net_29, D0);
not inst86  (_net_30, D2);
not inst87  (_net_31, D3);
not inst88  (_net_32, D4);
not inst89  (_net_33, D5);
not inst90  (_net_34, D6);
not inst91  (_net_35, D7);
and inst92  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_28, _net_29, _net_30, _net_31, _net_32, _net_33, _net_34, _net_35, RD, SE, SI);
not inst93  (_net_36, D1);
not inst94  (_net_37, D0);
not inst95  (_net_38, D2);
not inst96  (_net_39, D3);
not inst97  (_net_40, D4);
not inst98  (_net_41, D5);
not inst99  (_net_42, D6);
not inst100  (_net_43, SE);
not inst101  (_net_44, SI);
and inst102  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, _net_38, _net_39, _net_40, _net_41, _net_42, D7, RD, _net_43, _net_44);
not inst103  (_net_45, D1);
not inst104  (_net_46, D0);
not inst105  (_net_47, D2);
not inst106  (_net_48, D3);
not inst107  (_net_49, D4);
not inst108  (_net_50, D5);
not inst109  (_net_51, D6);
not inst110  (_net_52, SE);
and inst111  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_45, _net_46, _net_47, _net_48, _net_49, _net_50, _net_51, D7, RD, _net_52, SI);
not inst112  (_net_53, D1);
not inst113  (_net_54, D0);
not inst114  (_net_55, D2);
not inst115  (_net_56, D3);
not inst116  (_net_57, D4);
not inst117  (_net_58, D5);
not inst118  (_net_59, D6);
not inst119  (_net_60, SI);
and inst120  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_53, _net_54, _net_55, _net_56, _net_57, _net_58, _net_59, D7, RD, SE, _net_60);
not inst121  (_net_61, D1);
not inst122  (_net_62, D0);
not inst123  (_net_63, D2);
not inst124  (_net_64, D3);
not inst125  (_net_65, D4);
not inst126  (_net_66, D5);
not inst127  (_net_67, D6);
and inst128  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_61, _net_62, _net_63, _net_64, _net_65, _net_66, _net_67, D7, RD, SE, SI);
not inst129  (_net_68, D1);
not inst130  (_net_69, D0);
not inst131  (_net_70, D2);
not inst132  (_net_71, D3);
not inst133  (_net_72, D4);
not inst134  (_net_73, D5);
not inst135  (_net_74, D7);
not inst136  (_net_75, SE);
not inst137  (_net_76, SI);
and inst138  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_68, _net_69, _net_70, _net_71, _net_72, _net_73, D6, _net_74, RD, _net_75, _net_76);
not inst139  (_net_77, D1);
not inst140  (_net_78, D0);
not inst141  (_net_79, D2);
not inst142  (_net_80, D3);
not inst143  (_net_81, D4);
not inst144  (_net_82, D5);
not inst145  (_net_83, D7);
not inst146  (_net_84, SE);
and inst147  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_77, _net_78, _net_79, _net_80, _net_81, _net_82, D6, _net_83, RD, _net_84, SI);
not inst148  (_net_85, D1);
not inst149  (_net_86, D0);
not inst150  (_net_87, D2);
not inst151  (_net_88, D3);
not inst152  (_net_89, D4);
not inst153  (_net_90, D5);
not inst154  (_net_91, D7);
not inst155  (_net_92, SI);
and inst156  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_85, _net_86, _net_87, _net_88, _net_89, _net_90, D6, _net_91, RD, SE, _net_92);
not inst157  (_net_93, D1);
not inst158  (_net_94, D0);
not inst159  (_net_95, D2);
not inst160  (_net_96, D3);
not inst161  (_net_97, D4);
not inst162  (_net_98, D5);
not inst163  (_net_99, D7);
and inst164  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_93, _net_94, _net_95, _net_96, _net_97, _net_98, D6, _net_99, RD, SE, SI);
not inst165  (_net_100, D1);
not inst166  (_net_101, D0);
not inst167  (_net_102, D2);
not inst168  (_net_103, D3);
not inst169  (_net_104, D4);
not inst170  (_net_105, D6);
not inst171  (_net_106, D7);
not inst172  (_net_107, SE);
not inst173  (_net_108, SI);
and inst174  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_100, _net_101, _net_102, _net_103, _net_104, D5, _net_105, _net_106, RD, _net_107, _net_108);
not inst175  (_net_109, D1);
not inst176  (_net_110, D0);
not inst177  (_net_111, D2);
not inst178  (_net_112, D3);
not inst179  (_net_113, D4);
not inst180  (_net_114, D6);
not inst181  (_net_115, D7);
not inst182  (_net_116, SE);
and inst183  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_109, _net_110, _net_111, _net_112, _net_113, D5, _net_114, _net_115, RD, _net_116, SI);
not inst184  (_net_117, D1);
not inst185  (_net_118, D0);
not inst186  (_net_119, D2);
not inst187  (_net_120, D3);
not inst188  (_net_121, D4);
not inst189  (_net_122, D6);
not inst190  (_net_123, D7);
not inst191  (_net_124, SI);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_117, _net_118, _net_119, _net_120, _net_121, D5, _net_122, _net_123, RD, SE, _net_124);
not inst193  (_net_125, D1);
not inst194  (_net_126, D0);
not inst195  (_net_127, D2);
not inst196  (_net_128, D3);
not inst197  (_net_129, D4);
not inst198  (_net_130, D6);
not inst199  (_net_131, D7);
and inst200  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_125, _net_126, _net_127, _net_128, _net_129, D5, _net_130, _net_131, RD, SE, SI);
not inst201  (_net_132, D1);
not inst202  (_net_133, D0);
not inst203  (_net_134, D2);
not inst204  (_net_135, D3);
not inst205  (_net_136, D5);
not inst206  (_net_137, D6);
not inst207  (_net_138, D7);
not inst208  (_net_139, SE);
not inst209  (_net_140, SI);
and inst210  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_132, _net_133, _net_134, _net_135, D4, _net_136, _net_137, _net_138, RD, _net_139, _net_140);
not inst211  (_net_141, D1);
not inst212  (_net_142, D0);
not inst213  (_net_143, D2);
not inst214  (_net_144, D3);
not inst215  (_net_145, D5);
not inst216  (_net_146, D6);
not inst217  (_net_147, D7);
not inst218  (_net_148, SE);
and inst219  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_141, _net_142, _net_143, _net_144, D4, _net_145, _net_146, _net_147, RD, _net_148, SI);
not inst220  (_net_149, D1);
not inst221  (_net_150, D0);
not inst222  (_net_151, D2);
not inst223  (_net_152, D3);
not inst224  (_net_153, D5);
not inst225  (_net_154, D6);
not inst226  (_net_155, D7);
not inst227  (_net_156, SI);
and inst228  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_149, _net_150, _net_151, _net_152, D4, _net_153, _net_154, _net_155, RD, SE, _net_156);
not inst229  (_net_157, D1);
not inst230  (_net_158, D0);
not inst231  (_net_159, D2);
not inst232  (_net_160, D3);
not inst233  (_net_161, D5);
not inst234  (_net_162, D6);
not inst235  (_net_163, D7);
and inst236  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_157, _net_158, _net_159, _net_160, D4, _net_161, _net_162, _net_163, RD, SE, SI);
not inst237  (_net_164, D1);
not inst238  (_net_165, D0);
not inst239  (_net_166, D2);
not inst240  (_net_167, D3);
not inst241  (_net_168, SE);
not inst242  (_net_169, SI);
and inst243  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_164, _net_165, _net_166, _net_167, D4, D5, D6, D7, RD, _net_168, _net_169);
not inst244  (_net_170, D1);
not inst245  (_net_171, D0);
not inst246  (_net_172, D2);
not inst247  (_net_173, D3);
not inst248  (_net_174, SE);
and inst249  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_170, _net_171, _net_172, _net_173, D4, D5, D6, D7, RD, _net_174, SI);
not inst250  (_net_175, D1);
not inst251  (_net_176, D0);
not inst252  (_net_177, D2);
not inst253  (_net_178, D3);
not inst254  (_net_179, SI);
and inst255  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_175, _net_176, _net_177, _net_178, D4, D5, D6, D7, RD, SE, _net_179);
not inst256  (_net_180, D1);
not inst257  (_net_181, D0);
not inst258  (_net_182, D2);
not inst259  (_net_183, D3);
and inst260  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_180, _net_181, _net_182, _net_183, D4, D5, D6, D7, RD, SE, SI);
not inst261  (_net_184, D1);
not inst262  (_net_185, D0);
not inst263  (_net_186, D2);
not inst264  (_net_187, D4);
not inst265  (_net_188, D5);
not inst266  (_net_189, D6);
not inst267  (_net_190, D7);
not inst268  (_net_191, SE);
not inst269  (_net_192, SI);
and inst270  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_184, _net_185, _net_186, D3, _net_187, _net_188, _net_189, _net_190, RD, _net_191, _net_192);
not inst271  (_net_193, D1);
not inst272  (_net_194, D0);
not inst273  (_net_195, D2);
not inst274  (_net_196, D4);
not inst275  (_net_197, D5);
not inst276  (_net_198, D6);
not inst277  (_net_199, D7);
not inst278  (_net_200, SE);
and inst279  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_193, _net_194, _net_195, D3, _net_196, _net_197, _net_198, _net_199, RD, _net_200, SI);
not inst280  (_net_201, D1);
not inst281  (_net_202, D0);
not inst282  (_net_203, D2);
not inst283  (_net_204, D4);
not inst284  (_net_205, D5);
not inst285  (_net_206, D6);
not inst286  (_net_207, D7);
not inst287  (_net_208, SI);
and inst288  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_201, _net_202, _net_203, D3, _net_204, _net_205, _net_206, _net_207, RD, SE, _net_208);
not inst289  (_net_209, D1);
not inst290  (_net_210, D0);
not inst291  (_net_211, D2);
not inst292  (_net_212, D4);
not inst293  (_net_213, D5);
not inst294  (_net_214, D6);
not inst295  (_net_215, D7);
and inst296  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_209, _net_210, _net_211, D3, _net_212, _net_213, _net_214, _net_215, RD, SE, SI);
not inst297  (_net_216, D1);
not inst298  (_net_217, D0);
not inst299  (_net_218, D3);
not inst300  (_net_219, D4);
not inst301  (_net_220, D5);
not inst302  (_net_221, D6);
not inst303  (_net_222, D7);
not inst304  (_net_223, SE);
not inst305  (_net_224, SI);
and inst306  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_216, _net_217, D2, _net_218, _net_219, _net_220, _net_221, _net_222, RD, _net_223, _net_224);
not inst307  (_net_225, D1);
not inst308  (_net_226, D0);
not inst309  (_net_227, D3);
not inst310  (_net_228, D4);
not inst311  (_net_229, D5);
not inst312  (_net_230, D6);
not inst313  (_net_231, D7);
not inst314  (_net_232, SE);
and inst315  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_225, _net_226, D2, _net_227, _net_228, _net_229, _net_230, _net_231, RD, _net_232, SI);
not inst316  (_net_233, D1);
not inst317  (_net_234, D0);
not inst318  (_net_235, D3);
not inst319  (_net_236, D4);
not inst320  (_net_237, D5);
not inst321  (_net_238, D6);
not inst322  (_net_239, D7);
not inst323  (_net_240, SI);
and inst324  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_233, _net_234, D2, _net_235, _net_236, _net_237, _net_238, _net_239, RD, SE, _net_240);
not inst325  (_net_241, D1);
not inst326  (_net_242, D0);
not inst327  (_net_243, D3);
not inst328  (_net_244, D4);
not inst329  (_net_245, D5);
not inst330  (_net_246, D6);
not inst331  (_net_247, D7);
and inst332  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_241, _net_242, D2, _net_243, _net_244, _net_245, _net_246, _net_247, RD, SE, SI);
not inst333  (_net_248, D0);
not inst334  (_net_249, D2);
not inst335  (_net_250, D3);
not inst336  (_net_251, D4);
not inst337  (_net_252, D5);
not inst338  (_net_253, D6);
not inst339  (_net_254, D7);
not inst340  (_net_255, SE);
not inst341  (_net_256, SI);
and inst342  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_248, _net_249, _net_250, _net_251, _net_252, _net_253, _net_254, RD, _net_255, _net_256);
not inst343  (_net_257, D0);
not inst344  (_net_258, D2);
not inst345  (_net_259, D3);
not inst346  (_net_260, D4);
not inst347  (_net_261, D5);
not inst348  (_net_262, D6);
not inst349  (_net_263, D7);
not inst350  (_net_264, SE);
and inst351  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, D1, _net_257, _net_258, _net_259, _net_260, _net_261, _net_262, _net_263, RD, _net_264, SI);
not inst352  (_net_265, D0);
not inst353  (_net_266, D2);
not inst354  (_net_267, D3);
not inst355  (_net_268, D4);
not inst356  (_net_269, D5);
not inst357  (_net_270, D6);
not inst358  (_net_271, D7);
not inst359  (_net_272, SI);
and inst360  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, D1, _net_265, _net_266, _net_267, _net_268, _net_269, _net_270, _net_271, RD, SE, _net_272);
not inst361  (_net_273, D0);
not inst362  (_net_274, D2);
not inst363  (_net_275, D3);
not inst364  (_net_276, D4);
not inst365  (_net_277, D5);
not inst366  (_net_278, D6);
not inst367  (_net_279, D7);
and inst368  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, D1, _net_273, _net_274, _net_275, _net_276, _net_277, _net_278, _net_279, RD, SE, SI);
not inst369  (_net_280, D1);
not inst370  (_net_281, D2);
not inst371  (_net_282, D3);
not inst372  (_net_283, D4);
not inst373  (_net_284, D5);
not inst374  (_net_285, D6);
not inst375  (_net_286, D7);
not inst376  (_net_287, SE);
not inst377  (_net_288, SI);
and inst378  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_280, D0, _net_281, _net_282, _net_283, _net_284, _net_285, _net_286, RD, _net_287, _net_288);
not inst379  (_net_289, D1);
not inst380  (_net_290, D2);
not inst381  (_net_291, D3);
not inst382  (_net_292, D4);
not inst383  (_net_293, D5);
not inst384  (_net_294, D6);
not inst385  (_net_295, D7);
not inst386  (_net_296, SE);
and inst387  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_289, D0, _net_290, _net_291, _net_292, _net_293, _net_294, _net_295, RD, _net_296, SI);
not inst388  (_net_297, D1);
not inst389  (_net_298, D2);
not inst390  (_net_299, D3);
not inst391  (_net_300, D4);
not inst392  (_net_301, D5);
not inst393  (_net_302, D6);
not inst394  (_net_303, D7);
not inst395  (_net_304, SI);
and inst396  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_297, D0, _net_298, _net_299, _net_300, _net_301, _net_302, _net_303, RD, SE, _net_304);
not inst397  (_net_305, D1);
not inst398  (_net_306, D2);
not inst399  (_net_307, D3);
not inst400  (_net_308, D4);
not inst401  (_net_309, D5);
not inst402  (_net_310, D6);
not inst403  (_net_311, D7);
and inst404  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_305, D0, _net_306, _net_307, _net_308, _net_309, _net_310, _net_311, RD, SE, SI);
not inst405  (_net_312, D1);
not inst406  (_net_313, D2);
not inst407  (_net_314, D3);
not inst408  (_net_315, SE);
not inst409  (_net_316, SI);
and inst410  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_312, D0, _net_313, _net_314, D4, D5, D6, D7, RD, _net_315, _net_316);
not inst411  (_net_317, D1);
not inst412  (_net_318, D2);
not inst413  (_net_319, D3);
not inst414  (_net_320, SE);
and inst415  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_317, D0, _net_318, _net_319, D4, D5, D6, D7, RD, _net_320, SI);
not inst416  (_net_321, D1);
not inst417  (_net_322, D2);
not inst418  (_net_323, D3);
not inst419  (_net_324, SI);
and inst420  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_321, D0, _net_322, _net_323, D4, D5, D6, D7, RD, SE, _net_324);
not inst421  (_net_325, D1);
not inst422  (_net_326, D2);
not inst423  (_net_327, D3);
and inst424  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_325, D0, _net_326, _net_327, D4, D5, D6, D7, RD, SE, SI);
not inst425  (_net_328, D1);
not inst426  (_net_329, D3);
not inst427  (_net_330, D5);
not inst428  (_net_331, D7);
not inst429  (_net_332, SE);
not inst430  (_net_333, SI);
and inst431  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_328, D0, D2, _net_329, D4, _net_330, D6, _net_331, RD, _net_332, _net_333);
not inst432  (_net_334, D1);
not inst433  (_net_335, D3);
not inst434  (_net_336, D5);
not inst435  (_net_337, D7);
not inst436  (_net_338, SE);
and inst437  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_334, D0, D2, _net_335, D4, _net_336, D6, _net_337, RD, _net_338, SI);
not inst438  (_net_339, D1);
not inst439  (_net_340, D3);
not inst440  (_net_341, D5);
not inst441  (_net_342, D7);
not inst442  (_net_343, SI);
and inst443  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_339, D0, D2, _net_340, D4, _net_341, D6, _net_342, RD, SE, _net_343);
not inst444  (_net_344, D1);
not inst445  (_net_345, D3);
not inst446  (_net_346, D5);
not inst447  (_net_347, D7);
and inst448  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_344, D0, D2, _net_345, D4, _net_346, D6, _net_347, RD, SE, SI);
not inst449  (_net_348, D1);
not inst450  (_net_349, D3);
not inst451  (_net_350, D5);
not inst452  (_net_351, SE);
not inst453  (_net_352, SI);
and inst454  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_348, D0, D2, _net_349, D4, _net_350, D6, D7, RD, _net_351, _net_352);
not inst455  (_net_353, D1);
not inst456  (_net_354, D3);
not inst457  (_net_355, D5);
not inst458  (_net_356, SE);
and inst459  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_353, D0, D2, _net_354, D4, _net_355, D6, D7, RD, _net_356, SI);
not inst460  (_net_357, D1);
not inst461  (_net_358, D3);
not inst462  (_net_359, D5);
not inst463  (_net_360, SI);
and inst464  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_357, D0, D2, _net_358, D4, _net_359, D6, D7, RD, SE, _net_360);
not inst465  (_net_361, D1);
not inst466  (_net_362, D3);
not inst467  (_net_363, D5);
and inst468  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_361, D0, D2, _net_362, D4, _net_363, D6, D7, RD, SE, SI);
not inst469  (_net_364, D1);
not inst470  (_net_365, D3);
not inst471  (_net_366, SE);
not inst472  (_net_367, SI);
and inst473  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_364, D0, D2, _net_365, D4, D5, D6, D7, RD, _net_366, _net_367);
not inst474  (_net_368, D1);
not inst475  (_net_369, D3);
not inst476  (_net_370, SE);
and inst477  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_368, D0, D2, _net_369, D4, D5, D6, D7, RD, _net_370, SI);
not inst478  (_net_371, D1);
not inst479  (_net_372, D3);
not inst480  (_net_373, SI);
and inst481  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_371, D0, D2, _net_372, D4, D5, D6, D7, RD, SE, _net_373);
not inst482  (_net_374, D1);
not inst483  (_net_375, D3);
and inst484  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_374, D0, D2, _net_375, D4, D5, D6, D7, RD, SE, SI);
not inst485  (_net_376, SE);
not inst486  (_net_377, SI);
and inst487  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, D4, D5, D6, D7, RD, _net_376, _net_377);
not inst488  (_net_378, SE);
and inst489  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, RD, _net_378, SI);
not inst490  (_net_379, SI);
and inst491  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, D1, D0, D2, D3, D4, D5, D6, D7, RD, SE, _net_379);
and inst492  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, RD, SE, SI);
not inst493  (_net_380, D1);
not inst494  (_net_381, D0);
not inst495  (_net_382, D2);
not inst496  (_net_383, D3);
not inst497  (_net_384, D4);
not inst498  (_net_385, D5);
not inst499  (_net_386, D6);
not inst500  (_net_387, D7);
and inst501  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_380, _net_381, _net_382, _net_383, _net_384, _net_385, _net_386, _net_387, SE, SI);
not inst502  (_net_388, D1);
not inst503  (_net_389, D0);
not inst504  (_net_390, D2);
not inst505  (_net_391, D3);
not inst506  (_net_392, D4);
not inst507  (_net_393, D5);
not inst508  (_net_394, D6);
not inst509  (_net_395, SE);
not inst510  (_net_396, SI);
and inst511  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_388, _net_389, _net_390, _net_391, _net_392, _net_393, _net_394, D7, _net_395, _net_396);
not inst512  (_net_397, D1);
not inst513  (_net_398, D0);
not inst514  (_net_399, D2);
not inst515  (_net_400, D3);
not inst516  (_net_401, D4);
not inst517  (_net_402, D5);
not inst518  (_net_403, D6);
not inst519  (_net_404, SE);
and inst520  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI, _net_397, _net_398, _net_399, _net_400, _net_401, _net_402, _net_403, D7, _net_404, SI);
not inst521  (_net_405, D1);
not inst522  (_net_406, D0);
not inst523  (_net_407, D2);
not inst524  (_net_408, D3);
not inst525  (_net_409, D4);
not inst526  (_net_410, D5);
not inst527  (_net_411, D6);
and inst528  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI, _net_405, _net_406, _net_407, _net_408, _net_409, _net_410, _net_411, D7, SE, SI);
not inst529  (_net_412, D1);
not inst530  (_net_413, D0);
not inst531  (_net_414, D2);
not inst532  (_net_415, D3);
not inst533  (_net_416, D4);
not inst534  (_net_417, D5);
not inst535  (_net_418, D7);
not inst536  (_net_419, SE);
not inst537  (_net_420, SI);
and inst538  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_412, _net_413, _net_414, _net_415, _net_416, _net_417, D6, _net_418, _net_419, _net_420);
not inst539  (_net_421, D1);
not inst540  (_net_422, D0);
not inst541  (_net_423, D2);
not inst542  (_net_424, D3);
not inst543  (_net_425, D4);
not inst544  (_net_426, D5);
not inst545  (_net_427, D7);
not inst546  (_net_428, SE);
and inst547  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_421, _net_422, _net_423, _net_424, _net_425, _net_426, D6, _net_427, _net_428, SI);
not inst548  (_net_429, D1);
not inst549  (_net_430, D0);
not inst550  (_net_431, D2);
not inst551  (_net_432, D3);
not inst552  (_net_433, D4);
not inst553  (_net_434, D5);
not inst554  (_net_435, D7);
and inst555  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI, _net_429, _net_430, _net_431, _net_432, _net_433, _net_434, D6, _net_435, SE, SI);
not inst556  (_net_436, D1);
not inst557  (_net_437, D0);
not inst558  (_net_438, D2);
not inst559  (_net_439, D3);
not inst560  (_net_440, D4);
not inst561  (_net_441, D6);
not inst562  (_net_442, D7);
not inst563  (_net_443, SE);
not inst564  (_net_444, SI);
and inst565  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_436, _net_437, _net_438, _net_439, _net_440, D5, _net_441, _net_442, _net_443, _net_444);
not inst566  (_net_445, D1);
not inst567  (_net_446, D0);
not inst568  (_net_447, D2);
not inst569  (_net_448, D3);
not inst570  (_net_449, D4);
not inst571  (_net_450, D6);
not inst572  (_net_451, D7);
not inst573  (_net_452, SE);
and inst574  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_445, _net_446, _net_447, _net_448, _net_449, D5, _net_450, _net_451, _net_452, SI);
not inst575  (_net_453, D1);
not inst576  (_net_454, D0);
not inst577  (_net_455, D2);
not inst578  (_net_456, D3);
not inst579  (_net_457, D4);
not inst580  (_net_458, D6);
not inst581  (_net_459, D7);
and inst582  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_453, _net_454, _net_455, _net_456, _net_457, D5, _net_458, _net_459, SE, SI);
not inst583  (_net_460, D1);
not inst584  (_net_461, D0);
not inst585  (_net_462, D2);
not inst586  (_net_463, D3);
not inst587  (_net_464, D5);
not inst588  (_net_465, D6);
not inst589  (_net_466, D7);
not inst590  (_net_467, SE);
not inst591  (_net_468, SI);
and inst592  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_460, _net_461, _net_462, _net_463, D4, _net_464, _net_465, _net_466, _net_467, _net_468);
not inst593  (_net_469, D1);
not inst594  (_net_470, D0);
not inst595  (_net_471, D2);
not inst596  (_net_472, D3);
not inst597  (_net_473, D5);
not inst598  (_net_474, D6);
not inst599  (_net_475, D7);
not inst600  (_net_476, SE);
and inst601  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_469, _net_470, _net_471, _net_472, D4, _net_473, _net_474, _net_475, _net_476, SI);
not inst602  (_net_477, D1);
not inst603  (_net_478, D0);
not inst604  (_net_479, D2);
not inst605  (_net_480, D3);
not inst606  (_net_481, D5);
not inst607  (_net_482, D6);
not inst608  (_net_483, D7);
and inst609  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_477, _net_478, _net_479, _net_480, D4, _net_481, _net_482, _net_483, SE, SI);
not inst610  (_net_484, D1);
not inst611  (_net_485, D0);
not inst612  (_net_486, D2);
not inst613  (_net_487, D4);
not inst614  (_net_488, D5);
not inst615  (_net_489, D6);
not inst616  (_net_490, D7);
not inst617  (_net_491, SE);
not inst618  (_net_492, SI);
and inst619  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_484, _net_485, _net_486, D3, _net_487, _net_488, _net_489, _net_490, _net_491, _net_492);
not inst620  (_net_493, D1);
not inst621  (_net_494, D0);
not inst622  (_net_495, D2);
not inst623  (_net_496, D4);
not inst624  (_net_497, D5);
not inst625  (_net_498, D6);
not inst626  (_net_499, D7);
not inst627  (_net_500, SE);
and inst628  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_493, _net_494, _net_495, D3, _net_496, _net_497, _net_498, _net_499, _net_500, SI);
not inst629  (_net_501, D1);
not inst630  (_net_502, D0);
not inst631  (_net_503, D2);
not inst632  (_net_504, D4);
not inst633  (_net_505, D5);
not inst634  (_net_506, D6);
not inst635  (_net_507, D7);
and inst636  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_501, _net_502, _net_503, D3, _net_504, _net_505, _net_506, _net_507, SE, SI);
not inst637  (_net_508, D1);
not inst638  (_net_509, D0);
not inst639  (_net_510, D3);
not inst640  (_net_511, D4);
not inst641  (_net_512, D5);
not inst642  (_net_513, D6);
not inst643  (_net_514, D7);
not inst644  (_net_515, SE);
not inst645  (_net_516, SI);
and inst646  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_508, _net_509, D2, _net_510, _net_511, _net_512, _net_513, _net_514, _net_515, _net_516);
not inst647  (_net_517, D1);
not inst648  (_net_518, D0);
not inst649  (_net_519, D3);
not inst650  (_net_520, D4);
not inst651  (_net_521, D5);
not inst652  (_net_522, D6);
not inst653  (_net_523, D7);
not inst654  (_net_524, SE);
and inst655  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_517, _net_518, D2, _net_519, _net_520, _net_521, _net_522, _net_523, _net_524, SI);
not inst656  (_net_525, D1);
not inst657  (_net_526, D0);
not inst658  (_net_527, D3);
not inst659  (_net_528, D4);
not inst660  (_net_529, D5);
not inst661  (_net_530, D6);
not inst662  (_net_531, D7);
and inst663  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_525, _net_526, D2, _net_527, _net_528, _net_529, _net_530, _net_531, SE, SI);
not inst664  (_net_532, D0);
not inst665  (_net_533, D2);
not inst666  (_net_534, D3);
not inst667  (_net_535, D4);
not inst668  (_net_536, D5);
not inst669  (_net_537, D6);
not inst670  (_net_538, D7);
not inst671  (_net_539, SE);
not inst672  (_net_540, SI);
and inst673  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, D1, _net_532, _net_533, _net_534, _net_535, _net_536, _net_537, _net_538, _net_539, _net_540);
not inst674  (_net_541, D0);
not inst675  (_net_542, D2);
not inst676  (_net_543, D3);
not inst677  (_net_544, D4);
not inst678  (_net_545, D5);
not inst679  (_net_546, D6);
not inst680  (_net_547, D7);
not inst681  (_net_548, SE);
and inst682  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, D1, _net_541, _net_542, _net_543, _net_544, _net_545, _net_546, _net_547, _net_548, SI);
not inst683  (_net_549, D0);
not inst684  (_net_550, D2);
not inst685  (_net_551, D3);
not inst686  (_net_552, D4);
not inst687  (_net_553, D5);
not inst688  (_net_554, D6);
not inst689  (_net_555, D7);
and inst690  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, D1, _net_549, _net_550, _net_551, _net_552, _net_553, _net_554, _net_555, SE, SI);
not inst691  (_net_556, D1);
not inst692  (_net_557, D2);
not inst693  (_net_558, D3);
not inst694  (_net_559, D4);
not inst695  (_net_560, D5);
not inst696  (_net_561, D6);
not inst697  (_net_562, D7);
not inst698  (_net_563, SE);
not inst699  (_net_564, SI);
and inst700  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_556, D0, _net_557, _net_558, _net_559, _net_560, _net_561, _net_562, _net_563, _net_564);
not inst701  (_net_565, D1);
not inst702  (_net_566, D2);
not inst703  (_net_567, D3);
not inst704  (_net_568, D4);
not inst705  (_net_569, D5);
not inst706  (_net_570, D6);
not inst707  (_net_571, D7);
not inst708  (_net_572, SE);
and inst709  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_565, D0, _net_566, _net_567, _net_568, _net_569, _net_570, _net_571, _net_572, SI);
not inst710  (_net_573, D1);
not inst711  (_net_574, D2);
not inst712  (_net_575, D3);
not inst713  (_net_576, D4);
not inst714  (_net_577, D5);
not inst715  (_net_578, D6);
not inst716  (_net_579, D7);
and inst717  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_573, D0, _net_574, _net_575, _net_576, _net_577, _net_578, _net_579, SE, SI);
not inst718  (_net_580, D0);
not inst719  (_net_581, CK);
not inst720  (_net_582, D1);
not inst721  (_net_583, D2);
not inst722  (_net_584, D3);
not inst723  (_net_585, D4);
not inst724  (_net_586, D5);
not inst725  (_net_587, D6);
not inst726  (_net_588, D7);
not inst727  (_net_589, SE);
not inst728  (_net_590, SI);
and inst729  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_580, _net_581, _net_582, _net_583, _net_584, _net_585, _net_586, _net_587, _net_588, _net_589, _net_590);
not inst730  (_net_591, D0);
not inst731  (_net_592, CK);
not inst732  (_net_593, D1);
not inst733  (_net_594, D2);
not inst734  (_net_595, D3);
not inst735  (_net_596, D4);
not inst736  (_net_597, D5);
not inst737  (_net_598, D6);
not inst738  (_net_599, D7);
not inst739  (_net_600, SE);
and inst740  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_591, _net_592, _net_593, _net_594, _net_595, _net_596, _net_597, _net_598, _net_599, _net_600, SI);
not inst741  (_net_601, D0);
not inst742  (_net_602, CK);
not inst743  (_net_603, D1);
not inst744  (_net_604, D2);
not inst745  (_net_605, D3);
not inst746  (_net_606, D4);
not inst747  (_net_607, D5);
not inst748  (_net_608, D6);
not inst749  (_net_609, D7);
not inst750  (_net_610, SI);
and inst751  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_601, _net_602, _net_603, _net_604, _net_605, _net_606, _net_607, _net_608, _net_609, SE, _net_610);
not inst752  (_net_611, D0);
not inst753  (_net_612, CK);
not inst754  (_net_613, D1);
not inst755  (_net_614, D2);
not inst756  (_net_615, D3);
not inst757  (_net_616, D4);
not inst758  (_net_617, D5);
not inst759  (_net_618, D6);
not inst760  (_net_619, D7);
and inst761  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_611, _net_612, _net_613, _net_614, _net_615, _net_616, _net_617, _net_618, _net_619, SE, SI);
not inst762  (_net_620, D0);
not inst763  (_net_621, CK);
not inst764  (_net_622, D1);
not inst765  (_net_623, D2);
not inst766  (_net_624, D3);
not inst767  (_net_625, D4);
not inst768  (_net_626, D5);
not inst769  (_net_627, D6);
not inst770  (_net_628, SE);
not inst771  (_net_629, SI);
and inst772  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_620, _net_621, _net_622, _net_623, _net_624, _net_625, _net_626, _net_627, D7, _net_628, _net_629);
not inst773  (_net_630, D0);
not inst774  (_net_631, CK);
not inst775  (_net_632, D1);
not inst776  (_net_633, D2);
not inst777  (_net_634, D3);
not inst778  (_net_635, D4);
not inst779  (_net_636, D5);
not inst780  (_net_637, D6);
not inst781  (_net_638, SE);
and inst782  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI, _net_630, _net_631, _net_632, _net_633, _net_634, _net_635, _net_636, _net_637, D7, _net_638, SI);
not inst783  (_net_639, D0);
not inst784  (_net_640, CK);
not inst785  (_net_641, D1);
not inst786  (_net_642, D2);
not inst787  (_net_643, D3);
not inst788  (_net_644, D4);
not inst789  (_net_645, D5);
not inst790  (_net_646, D6);
not inst791  (_net_647, SI);
and inst792  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_NOT_SI, _net_639, _net_640, _net_641, _net_642, _net_643, _net_644, _net_645, _net_646, D7, SE, _net_647);
not inst793  (_net_648, D0);
not inst794  (_net_649, CK);
not inst795  (_net_650, D1);
not inst796  (_net_651, D2);
not inst797  (_net_652, D3);
not inst798  (_net_653, D4);
not inst799  (_net_654, D5);
not inst800  (_net_655, D6);
and inst801  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI, _net_648, _net_649, _net_650, _net_651, _net_652, _net_653, _net_654, _net_655, D7, SE, SI);
not inst802  (_net_656, D0);
not inst803  (_net_657, CK);
not inst804  (_net_658, D1);
not inst805  (_net_659, D2);
not inst806  (_net_660, D3);
not inst807  (_net_661, D4);
not inst808  (_net_662, D5);
not inst809  (_net_663, D7);
not inst810  (_net_664, SE);
not inst811  (_net_665, SI);
and inst812  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_656, _net_657, _net_658, _net_659, _net_660, _net_661, _net_662, D6, _net_663, _net_664, _net_665);
not inst813  (_net_666, D0);
not inst814  (_net_667, CK);
not inst815  (_net_668, D1);
not inst816  (_net_669, D2);
not inst817  (_net_670, D3);
not inst818  (_net_671, D4);
not inst819  (_net_672, D5);
not inst820  (_net_673, D7);
not inst821  (_net_674, SE);
and inst822  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_666, _net_667, _net_668, _net_669, _net_670, _net_671, _net_672, D6, _net_673, _net_674, SI);
not inst823  (_net_675, D0);
not inst824  (_net_676, CK);
not inst825  (_net_677, D1);
not inst826  (_net_678, D2);
not inst827  (_net_679, D3);
not inst828  (_net_680, D4);
not inst829  (_net_681, D5);
not inst830  (_net_682, D7);
not inst831  (_net_683, SI);
and inst832  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_675, _net_676, _net_677, _net_678, _net_679, _net_680, _net_681, D6, _net_682, SE, _net_683);
not inst833  (_net_684, D0);
not inst834  (_net_685, CK);
not inst835  (_net_686, D1);
not inst836  (_net_687, D2);
not inst837  (_net_688, D3);
not inst838  (_net_689, D4);
not inst839  (_net_690, D5);
not inst840  (_net_691, D7);
and inst841  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI, _net_684, _net_685, _net_686, _net_687, _net_688, _net_689, _net_690, D6, _net_691, SE, SI);
not inst842  (_net_692, D0);
not inst843  (_net_693, CK);
not inst844  (_net_694, D1);
not inst845  (_net_695, D2);
not inst846  (_net_696, D3);
not inst847  (_net_697, D4);
not inst848  (_net_698, D6);
not inst849  (_net_699, D7);
not inst850  (_net_700, SE);
not inst851  (_net_701, SI);
and inst852  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_692, _net_693, _net_694, _net_695, _net_696, _net_697, D5, _net_698, _net_699, _net_700, _net_701);
not inst853  (_net_702, D0);
not inst854  (_net_703, CK);
not inst855  (_net_704, D1);
not inst856  (_net_705, D2);
not inst857  (_net_706, D3);
not inst858  (_net_707, D4);
not inst859  (_net_708, D6);
not inst860  (_net_709, D7);
not inst861  (_net_710, SE);
and inst862  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_702, _net_703, _net_704, _net_705, _net_706, _net_707, D5, _net_708, _net_709, _net_710, SI);
not inst863  (_net_711, D0);
not inst864  (_net_712, CK);
not inst865  (_net_713, D1);
not inst866  (_net_714, D2);
not inst867  (_net_715, D3);
not inst868  (_net_716, D4);
not inst869  (_net_717, D6);
not inst870  (_net_718, D7);
not inst871  (_net_719, SI);
and inst872  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_711, _net_712, _net_713, _net_714, _net_715, _net_716, D5, _net_717, _net_718, SE, _net_719);
not inst873  (_net_720, D0);
not inst874  (_net_721, CK);
not inst875  (_net_722, D1);
not inst876  (_net_723, D2);
not inst877  (_net_724, D3);
not inst878  (_net_725, D4);
not inst879  (_net_726, D6);
not inst880  (_net_727, D7);
and inst881  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_720, _net_721, _net_722, _net_723, _net_724, _net_725, D5, _net_726, _net_727, SE, SI);
not inst882  (_net_728, D0);
not inst883  (_net_729, CK);
not inst884  (_net_730, D1);
not inst885  (_net_731, D2);
not inst886  (_net_732, D3);
not inst887  (_net_733, D5);
not inst888  (_net_734, D6);
not inst889  (_net_735, D7);
not inst890  (_net_736, SE);
not inst891  (_net_737, SI);
and inst892  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_728, _net_729, _net_730, _net_731, _net_732, D4, _net_733, _net_734, _net_735, _net_736, _net_737);
not inst893  (_net_738, D0);
not inst894  (_net_739, CK);
not inst895  (_net_740, D1);
not inst896  (_net_741, D2);
not inst897  (_net_742, D3);
not inst898  (_net_743, D5);
not inst899  (_net_744, D6);
not inst900  (_net_745, D7);
not inst901  (_net_746, SE);
and inst902  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_738, _net_739, _net_740, _net_741, _net_742, D4, _net_743, _net_744, _net_745, _net_746, SI);
not inst903  (_net_747, D0);
not inst904  (_net_748, CK);
not inst905  (_net_749, D1);
not inst906  (_net_750, D2);
not inst907  (_net_751, D3);
not inst908  (_net_752, D5);
not inst909  (_net_753, D6);
not inst910  (_net_754, D7);
not inst911  (_net_755, SI);
and inst912  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_747, _net_748, _net_749, _net_750, _net_751, D4, _net_752, _net_753, _net_754, SE, _net_755);
not inst913  (_net_756, D0);
not inst914  (_net_757, CK);
not inst915  (_net_758, D1);
not inst916  (_net_759, D2);
not inst917  (_net_760, D3);
not inst918  (_net_761, D5);
not inst919  (_net_762, D6);
not inst920  (_net_763, D7);
and inst921  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_756, _net_757, _net_758, _net_759, _net_760, D4, _net_761, _net_762, _net_763, SE, SI);
not inst922  (_net_764, D0);
not inst923  (_net_765, CK);
not inst924  (_net_766, D1);
not inst925  (_net_767, D2);
not inst926  (_net_768, D3);
not inst927  (_net_769, SE);
not inst928  (_net_770, SI);
and inst929  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_764, _net_765, _net_766, _net_767, _net_768, D4, D5, D6, D7, _net_769, _net_770);
not inst930  (_net_771, D0);
not inst931  (_net_772, CK);
not inst932  (_net_773, D1);
not inst933  (_net_774, D2);
not inst934  (_net_775, D3);
not inst935  (_net_776, SE);
and inst936  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, _net_771, _net_772, _net_773, _net_774, _net_775, D4, D5, D6, D7, _net_776, SI);
not inst937  (_net_777, D0);
not inst938  (_net_778, CK);
not inst939  (_net_779, D1);
not inst940  (_net_780, D2);
not inst941  (_net_781, D3);
not inst942  (_net_782, SI);
and inst943  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, _net_777, _net_778, _net_779, _net_780, _net_781, D4, D5, D6, D7, SE, _net_782);
not inst944  (_net_783, D0);
not inst945  (_net_784, CK);
not inst946  (_net_785, D1);
not inst947  (_net_786, D2);
not inst948  (_net_787, D3);
and inst949  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, _net_783, _net_784, _net_785, _net_786, _net_787, D4, D5, D6, D7, SE, SI);
not inst950  (_net_788, D0);
not inst951  (_net_789, CK);
not inst952  (_net_790, D1);
not inst953  (_net_791, D2);
not inst954  (_net_792, D4);
not inst955  (_net_793, D5);
not inst956  (_net_794, D6);
not inst957  (_net_795, D7);
not inst958  (_net_796, SE);
not inst959  (_net_797, SI);
and inst960  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_788, _net_789, _net_790, _net_791, D3, _net_792, _net_793, _net_794, _net_795, _net_796, _net_797);
not inst961  (_net_798, D0);
not inst962  (_net_799, CK);
not inst963  (_net_800, D1);
not inst964  (_net_801, D2);
not inst965  (_net_802, D4);
not inst966  (_net_803, D5);
not inst967  (_net_804, D6);
not inst968  (_net_805, D7);
not inst969  (_net_806, SE);
and inst970  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_798, _net_799, _net_800, _net_801, D3, _net_802, _net_803, _net_804, _net_805, _net_806, SI);
not inst971  (_net_807, D0);
not inst972  (_net_808, CK);
not inst973  (_net_809, D1);
not inst974  (_net_810, D2);
not inst975  (_net_811, D4);
not inst976  (_net_812, D5);
not inst977  (_net_813, D6);
not inst978  (_net_814, D7);
not inst979  (_net_815, SI);
and inst980  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_807, _net_808, _net_809, _net_810, D3, _net_811, _net_812, _net_813, _net_814, SE, _net_815);
not inst981  (_net_816, D0);
not inst982  (_net_817, CK);
not inst983  (_net_818, D1);
not inst984  (_net_819, D2);
not inst985  (_net_820, D4);
not inst986  (_net_821, D5);
not inst987  (_net_822, D6);
not inst988  (_net_823, D7);
and inst989  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_816, _net_817, _net_818, _net_819, D3, _net_820, _net_821, _net_822, _net_823, SE, SI);
not inst990  (_net_824, D0);
not inst991  (_net_825, CK);
not inst992  (_net_826, D1);
not inst993  (_net_827, D3);
not inst994  (_net_828, D4);
not inst995  (_net_829, D5);
not inst996  (_net_830, D6);
not inst997  (_net_831, D7);
not inst998  (_net_832, SE);
not inst999  (_net_833, SI);
and inst1000  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_824, _net_825, _net_826, D2, _net_827, _net_828, _net_829, _net_830, _net_831, _net_832, _net_833);
not inst1001  (_net_834, D0);
not inst1002  (_net_835, CK);
not inst1003  (_net_836, D1);
not inst1004  (_net_837, D3);
not inst1005  (_net_838, D4);
not inst1006  (_net_839, D5);
not inst1007  (_net_840, D6);
not inst1008  (_net_841, D7);
not inst1009  (_net_842, SE);
and inst1010  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_834, _net_835, _net_836, D2, _net_837, _net_838, _net_839, _net_840, _net_841, _net_842, SI);
not inst1011  (_net_843, D0);
not inst1012  (_net_844, CK);
not inst1013  (_net_845, D1);
not inst1014  (_net_846, D3);
not inst1015  (_net_847, D4);
not inst1016  (_net_848, D5);
not inst1017  (_net_849, D6);
not inst1018  (_net_850, D7);
not inst1019  (_net_851, SI);
and inst1020  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_843, _net_844, _net_845, D2, _net_846, _net_847, _net_848, _net_849, _net_850, SE, _net_851);
not inst1021  (_net_852, D0);
not inst1022  (_net_853, CK);
not inst1023  (_net_854, D1);
not inst1024  (_net_855, D3);
not inst1025  (_net_856, D4);
not inst1026  (_net_857, D5);
not inst1027  (_net_858, D6);
not inst1028  (_net_859, D7);
and inst1029  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_852, _net_853, _net_854, D2, _net_855, _net_856, _net_857, _net_858, _net_859, SE, SI);
not inst1030  (_net_860, D0);
not inst1031  (_net_861, CK);
not inst1032  (_net_862, D2);
not inst1033  (_net_863, D3);
not inst1034  (_net_864, D4);
not inst1035  (_net_865, D5);
not inst1036  (_net_866, D6);
not inst1037  (_net_867, D7);
not inst1038  (_net_868, SE);
not inst1039  (_net_869, SI);
and inst1040  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_860, _net_861, D1, _net_862, _net_863, _net_864, _net_865, _net_866, _net_867, _net_868, _net_869);
not inst1041  (_net_870, D0);
not inst1042  (_net_871, CK);
not inst1043  (_net_872, D2);
not inst1044  (_net_873, D3);
not inst1045  (_net_874, D4);
not inst1046  (_net_875, D5);
not inst1047  (_net_876, D6);
not inst1048  (_net_877, D7);
not inst1049  (_net_878, SE);
and inst1050  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_870, _net_871, D1, _net_872, _net_873, _net_874, _net_875, _net_876, _net_877, _net_878, SI);
not inst1051  (_net_879, D0);
not inst1052  (_net_880, CK);
not inst1053  (_net_881, D2);
not inst1054  (_net_882, D3);
not inst1055  (_net_883, D4);
not inst1056  (_net_884, D5);
not inst1057  (_net_885, D6);
not inst1058  (_net_886, D7);
not inst1059  (_net_887, SI);
and inst1060  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_879, _net_880, D1, _net_881, _net_882, _net_883, _net_884, _net_885, _net_886, SE, _net_887);
not inst1061  (_net_888, D0);
not inst1062  (_net_889, CK);
not inst1063  (_net_890, D2);
not inst1064  (_net_891, D3);
not inst1065  (_net_892, D4);
not inst1066  (_net_893, D5);
not inst1067  (_net_894, D6);
not inst1068  (_net_895, D7);
and inst1069  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_888, _net_889, D1, _net_890, _net_891, _net_892, _net_893, _net_894, _net_895, SE, SI);
not inst1070  (_net_896, CK);
not inst1071  (_net_897, D1);
not inst1072  (_net_898, D2);
not inst1073  (_net_899, D3);
not inst1074  (_net_900, D4);
not inst1075  (_net_901, D5);
not inst1076  (_net_902, D6);
not inst1077  (_net_903, D7);
not inst1078  (_net_904, SE);
not inst1079  (_net_905, SI);
and inst1080  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, D0, _net_896, _net_897, _net_898, _net_899, _net_900, _net_901, _net_902, _net_903, _net_904, _net_905);
not inst1081  (_net_906, CK);
not inst1082  (_net_907, D1);
not inst1083  (_net_908, D2);
not inst1084  (_net_909, D3);
not inst1085  (_net_910, D4);
not inst1086  (_net_911, D5);
not inst1087  (_net_912, D6);
not inst1088  (_net_913, D7);
not inst1089  (_net_914, SE);
and inst1090  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, D0, _net_906, _net_907, _net_908, _net_909, _net_910, _net_911, _net_912, _net_913, _net_914, SI);
not inst1091  (_net_915, CK);
not inst1092  (_net_916, D1);
not inst1093  (_net_917, D2);
not inst1094  (_net_918, D3);
not inst1095  (_net_919, D4);
not inst1096  (_net_920, D5);
not inst1097  (_net_921, D6);
not inst1098  (_net_922, D7);
not inst1099  (_net_923, SI);
and inst1100  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, D0, _net_915, _net_916, _net_917, _net_918, _net_919, _net_920, _net_921, _net_922, SE, _net_923);
not inst1101  (_net_924, CK);
not inst1102  (_net_925, D1);
not inst1103  (_net_926, D2);
not inst1104  (_net_927, D3);
not inst1105  (_net_928, D4);
not inst1106  (_net_929, D5);
not inst1107  (_net_930, D6);
not inst1108  (_net_931, D7);
and inst1109  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, D0, _net_924, _net_925, _net_926, _net_927, _net_928, _net_929, _net_930, _net_931, SE, SI);
not inst1110  (_net_932, CK);
not inst1111  (_net_933, D1);
not inst1112  (_net_934, D2);
not inst1113  (_net_935, D3);
not inst1114  (_net_936, SE);
not inst1115  (_net_937, SI);
and inst1116  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D0, _net_932, _net_933, _net_934, _net_935, D4, D5, D6, D7, _net_936, _net_937);
not inst1117  (_net_938, CK);
not inst1118  (_net_939, D1);
not inst1119  (_net_940, D2);
not inst1120  (_net_941, D3);
not inst1121  (_net_942, SE);
and inst1122  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D0, _net_938, _net_939, _net_940, _net_941, D4, D5, D6, D7, _net_942, SI);
not inst1123  (_net_943, CK);
not inst1124  (_net_944, D1);
not inst1125  (_net_945, D2);
not inst1126  (_net_946, D3);
not inst1127  (_net_947, SI);
and inst1128  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D0, _net_943, _net_944, _net_945, _net_946, D4, D5, D6, D7, SE, _net_947);
not inst1129  (_net_948, CK);
not inst1130  (_net_949, D1);
not inst1131  (_net_950, D2);
not inst1132  (_net_951, D3);
and inst1133  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, D0, _net_948, _net_949, _net_950, _net_951, D4, D5, D6, D7, SE, SI);
not inst1134  (_net_952, CK);
not inst1135  (_net_953, D1);
not inst1136  (_net_954, D3);
not inst1137  (_net_955, D5);
not inst1138  (_net_956, D7);
not inst1139  (_net_957, SE);
not inst1140  (_net_958, SI);
and inst1141  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, D0, _net_952, _net_953, D2, _net_954, D4, _net_955, D6, _net_956, _net_957, _net_958);
not inst1142  (_net_959, CK);
not inst1143  (_net_960, D1);
not inst1144  (_net_961, D3);
not inst1145  (_net_962, D5);
not inst1146  (_net_963, D7);
not inst1147  (_net_964, SE);
and inst1148  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, D0, _net_959, _net_960, D2, _net_961, D4, _net_962, D6, _net_963, _net_964, SI);
not inst1149  (_net_965, CK);
not inst1150  (_net_966, D1);
not inst1151  (_net_967, D3);
not inst1152  (_net_968, D5);
not inst1153  (_net_969, D7);
not inst1154  (_net_970, SI);
and inst1155  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, D0, _net_965, _net_966, D2, _net_967, D4, _net_968, D6, _net_969, SE, _net_970);
not inst1156  (_net_971, CK);
not inst1157  (_net_972, D1);
not inst1158  (_net_973, D3);
not inst1159  (_net_974, D5);
not inst1160  (_net_975, D7);
and inst1161  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI, D0, _net_971, _net_972, D2, _net_973, D4, _net_974, D6, _net_975, SE, SI);
not inst1162  (_net_976, CK);
not inst1163  (_net_977, D1);
not inst1164  (_net_978, D3);
not inst1165  (_net_979, D5);
not inst1166  (_net_980, SE);
not inst1167  (_net_981, SI);
and inst1168  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D0, _net_976, _net_977, D2, _net_978, D4, _net_979, D6, D7, _net_980, _net_981);
not inst1169  (_net_982, CK);
not inst1170  (_net_983, D1);
not inst1171  (_net_984, D3);
not inst1172  (_net_985, D5);
not inst1173  (_net_986, SE);
and inst1174  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D0, _net_982, _net_983, D2, _net_984, D4, _net_985, D6, D7, _net_986, SI);
not inst1175  (_net_987, CK);
not inst1176  (_net_988, D1);
not inst1177  (_net_989, D3);
not inst1178  (_net_990, D5);
not inst1179  (_net_991, SI);
and inst1180  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D0, _net_987, _net_988, D2, _net_989, D4, _net_990, D6, D7, SE, _net_991);
not inst1181  (_net_992, CK);
not inst1182  (_net_993, D1);
not inst1183  (_net_994, D3);
not inst1184  (_net_995, D5);
and inst1185  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_SI, D0, _net_992, _net_993, D2, _net_994, D4, _net_995, D6, D7, SE, SI);
not inst1186  (_net_996, CK);
not inst1187  (_net_997, D1);
not inst1188  (_net_998, D3);
not inst1189  (_net_999, SE);
not inst1190  (_net_1000, SI);
and inst1191  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D0, _net_996, _net_997, D2, _net_998, D4, D5, D6, D7, _net_999, _net_1000);
not inst1192  (_net_1001, CK);
not inst1193  (_net_1002, D1);
not inst1194  (_net_1003, D3);
not inst1195  (_net_1004, SE);
and inst1196  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D0, _net_1001, _net_1002, D2, _net_1003, D4, D5, D6, D7, _net_1004, SI);
not inst1197  (_net_1005, CK);
not inst1198  (_net_1006, D1);
not inst1199  (_net_1007, D3);
not inst1200  (_net_1008, SI);
and inst1201  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D0, _net_1005, _net_1006, D2, _net_1007, D4, D5, D6, D7, SE, _net_1008);
not inst1202  (_net_1009, CK);
not inst1203  (_net_1010, D1);
not inst1204  (_net_1011, D3);
and inst1205  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, D0, _net_1009, _net_1010, D2, _net_1011, D4, D5, D6, D7, SE, SI);
not inst1206  (_net_1012, CK);
not inst1207  (_net_1013, SE);
not inst1208  (_net_1014, SI);
and inst1209  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D0, _net_1012, D1, D2, D3, D4, D5, D6, D7, _net_1013, _net_1014);
not inst1210  (_net_1015, CK);
not inst1211  (_net_1016, SE);
and inst1212  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D0, _net_1015, D1, D2, D3, D4, D5, D6, D7, _net_1016, SI);
not inst1213  (_net_1017, CK);
not inst1214  (_net_1018, SI);
and inst1215  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D0, _net_1017, D1, D2, D3, D4, D5, D6, D7, SE, _net_1018);
not inst1216  (_net_1019, CK);
and inst1217  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, D0, _net_1019, D1, D2, D3, D4, D5, D6, D7, SE, SI);
not inst1218  (_net_1020, D0);
not inst1219  (_net_1021, D1);
not inst1220  (_net_1022, D2);
not inst1221  (_net_1023, D3);
not inst1222  (_net_1024, D4);
not inst1223  (_net_1025, D5);
not inst1224  (_net_1026, D6);
not inst1225  (_net_1027, D7);
not inst1226  (_net_1028, SE);
not inst1227  (_net_1029, SI);
and inst1228  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_1020, CK, _net_1021, _net_1022, _net_1023, _net_1024, _net_1025, _net_1026, _net_1027, _net_1028, _net_1029);
not inst1229  (_net_1030, D0);
not inst1230  (_net_1031, D1);
not inst1231  (_net_1032, D2);
not inst1232  (_net_1033, D3);
not inst1233  (_net_1034, D4);
not inst1234  (_net_1035, D5);
not inst1235  (_net_1036, D6);
not inst1236  (_net_1037, D7);
not inst1237  (_net_1038, SE);
and inst1238  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_1030, CK, _net_1031, _net_1032, _net_1033, _net_1034, _net_1035, _net_1036, _net_1037, _net_1038, SI);
not inst1239  (_net_1039, D0);
not inst1240  (_net_1040, D1);
not inst1241  (_net_1041, D2);
not inst1242  (_net_1042, D3);
not inst1243  (_net_1043, D4);
not inst1244  (_net_1044, D5);
not inst1245  (_net_1045, D6);
not inst1246  (_net_1046, D7);
not inst1247  (_net_1047, SI);
and inst1248  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_1039, CK, _net_1040, _net_1041, _net_1042, _net_1043, _net_1044, _net_1045, _net_1046, SE, _net_1047);
not inst1249  (_net_1048, D0);
not inst1250  (_net_1049, D1);
not inst1251  (_net_1050, D2);
not inst1252  (_net_1051, D3);
not inst1253  (_net_1052, D4);
not inst1254  (_net_1053, D5);
not inst1255  (_net_1054, D6);
not inst1256  (_net_1055, D7);
and inst1257  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_1048, CK, _net_1049, _net_1050, _net_1051, _net_1052, _net_1053, _net_1054, _net_1055, SE, SI);
not inst1258  (_net_1056, D0);
not inst1259  (_net_1057, D1);
not inst1260  (_net_1058, D2);
not inst1261  (_net_1059, D3);
not inst1262  (_net_1060, D4);
not inst1263  (_net_1061, D5);
not inst1264  (_net_1062, D6);
not inst1265  (_net_1063, SE);
not inst1266  (_net_1064, SI);
and inst1267  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_1056, CK, _net_1057, _net_1058, _net_1059, _net_1060, _net_1061, _net_1062, D7, _net_1063, _net_1064);
not inst1268  (_net_1065, D0);
not inst1269  (_net_1066, D1);
not inst1270  (_net_1067, D2);
not inst1271  (_net_1068, D3);
not inst1272  (_net_1069, D4);
not inst1273  (_net_1070, D5);
not inst1274  (_net_1071, D6);
not inst1275  (_net_1072, SE);
and inst1276  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI, _net_1065, CK, _net_1066, _net_1067, _net_1068, _net_1069, _net_1070, _net_1071, D7, _net_1072, SI);
not inst1277  (_net_1073, D0);
not inst1278  (_net_1074, D1);
not inst1279  (_net_1075, D2);
not inst1280  (_net_1076, D3);
not inst1281  (_net_1077, D4);
not inst1282  (_net_1078, D5);
not inst1283  (_net_1079, D6);
not inst1284  (_net_1080, SI);
and inst1285  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_NOT_SI, _net_1073, CK, _net_1074, _net_1075, _net_1076, _net_1077, _net_1078, _net_1079, D7, SE, _net_1080);
not inst1286  (_net_1081, D0);
not inst1287  (_net_1082, D1);
not inst1288  (_net_1083, D2);
not inst1289  (_net_1084, D3);
not inst1290  (_net_1085, D4);
not inst1291  (_net_1086, D5);
not inst1292  (_net_1087, D6);
and inst1293  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI, _net_1081, CK, _net_1082, _net_1083, _net_1084, _net_1085, _net_1086, _net_1087, D7, SE, SI);
not inst1294  (_net_1088, D0);
not inst1295  (_net_1089, D1);
not inst1296  (_net_1090, D2);
not inst1297  (_net_1091, D3);
not inst1298  (_net_1092, D4);
not inst1299  (_net_1093, D5);
not inst1300  (_net_1094, D7);
not inst1301  (_net_1095, SE);
not inst1302  (_net_1096, SI);
and inst1303  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_1088, CK, _net_1089, _net_1090, _net_1091, _net_1092, _net_1093, D6, _net_1094, _net_1095, _net_1096);
not inst1304  (_net_1097, D0);
not inst1305  (_net_1098, D1);
not inst1306  (_net_1099, D2);
not inst1307  (_net_1100, D3);
not inst1308  (_net_1101, D4);
not inst1309  (_net_1102, D5);
not inst1310  (_net_1103, D7);
not inst1311  (_net_1104, SE);
and inst1312  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_1097, CK, _net_1098, _net_1099, _net_1100, _net_1101, _net_1102, D6, _net_1103, _net_1104, SI);
not inst1313  (_net_1105, D0);
not inst1314  (_net_1106, D1);
not inst1315  (_net_1107, D2);
not inst1316  (_net_1108, D3);
not inst1317  (_net_1109, D4);
not inst1318  (_net_1110, D5);
not inst1319  (_net_1111, D7);
not inst1320  (_net_1112, SI);
and inst1321  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_1105, CK, _net_1106, _net_1107, _net_1108, _net_1109, _net_1110, D6, _net_1111, SE, _net_1112);
not inst1322  (_net_1113, D0);
not inst1323  (_net_1114, D1);
not inst1324  (_net_1115, D2);
not inst1325  (_net_1116, D3);
not inst1326  (_net_1117, D4);
not inst1327  (_net_1118, D5);
not inst1328  (_net_1119, D7);
and inst1329  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI, _net_1113, CK, _net_1114, _net_1115, _net_1116, _net_1117, _net_1118, D6, _net_1119, SE, SI);
not inst1330  (_net_1120, D0);
not inst1331  (_net_1121, D1);
not inst1332  (_net_1122, D2);
not inst1333  (_net_1123, D3);
not inst1334  (_net_1124, D4);
not inst1335  (_net_1125, D6);
not inst1336  (_net_1126, D7);
not inst1337  (_net_1127, SE);
not inst1338  (_net_1128, SI);
and inst1339  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_1120, CK, _net_1121, _net_1122, _net_1123, _net_1124, D5, _net_1125, _net_1126, _net_1127, _net_1128);
not inst1340  (_net_1129, D0);
not inst1341  (_net_1130, D1);
not inst1342  (_net_1131, D2);
not inst1343  (_net_1132, D3);
not inst1344  (_net_1133, D4);
not inst1345  (_net_1134, D6);
not inst1346  (_net_1135, D7);
not inst1347  (_net_1136, SE);
and inst1348  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_1129, CK, _net_1130, _net_1131, _net_1132, _net_1133, D5, _net_1134, _net_1135, _net_1136, SI);
not inst1349  (_net_1137, D0);
not inst1350  (_net_1138, D1);
not inst1351  (_net_1139, D2);
not inst1352  (_net_1140, D3);
not inst1353  (_net_1141, D4);
not inst1354  (_net_1142, D6);
not inst1355  (_net_1143, D7);
not inst1356  (_net_1144, SI);
and inst1357  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_1137, CK, _net_1138, _net_1139, _net_1140, _net_1141, D5, _net_1142, _net_1143, SE, _net_1144);
not inst1358  (_net_1145, D0);
not inst1359  (_net_1146, D1);
not inst1360  (_net_1147, D2);
not inst1361  (_net_1148, D3);
not inst1362  (_net_1149, D4);
not inst1363  (_net_1150, D6);
not inst1364  (_net_1151, D7);
and inst1365  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_1145, CK, _net_1146, _net_1147, _net_1148, _net_1149, D5, _net_1150, _net_1151, SE, SI);
not inst1366  (_net_1152, D0);
not inst1367  (_net_1153, D1);
not inst1368  (_net_1154, D2);
not inst1369  (_net_1155, D3);
not inst1370  (_net_1156, D5);
not inst1371  (_net_1157, D6);
not inst1372  (_net_1158, D7);
not inst1373  (_net_1159, SE);
not inst1374  (_net_1160, SI);
and inst1375  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_1152, CK, _net_1153, _net_1154, _net_1155, D4, _net_1156, _net_1157, _net_1158, _net_1159, _net_1160);
not inst1376  (_net_1161, D0);
not inst1377  (_net_1162, D1);
not inst1378  (_net_1163, D2);
not inst1379  (_net_1164, D3);
not inst1380  (_net_1165, D5);
not inst1381  (_net_1166, D6);
not inst1382  (_net_1167, D7);
not inst1383  (_net_1168, SE);
and inst1384  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_1161, CK, _net_1162, _net_1163, _net_1164, D4, _net_1165, _net_1166, _net_1167, _net_1168, SI);
not inst1385  (_net_1169, D0);
not inst1386  (_net_1170, D1);
not inst1387  (_net_1171, D2);
not inst1388  (_net_1172, D3);
not inst1389  (_net_1173, D5);
not inst1390  (_net_1174, D6);
not inst1391  (_net_1175, D7);
not inst1392  (_net_1176, SI);
and inst1393  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_1169, CK, _net_1170, _net_1171, _net_1172, D4, _net_1173, _net_1174, _net_1175, SE, _net_1176);
not inst1394  (_net_1177, D0);
not inst1395  (_net_1178, D1);
not inst1396  (_net_1179, D2);
not inst1397  (_net_1180, D3);
not inst1398  (_net_1181, D5);
not inst1399  (_net_1182, D6);
not inst1400  (_net_1183, D7);
and inst1401  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_1177, CK, _net_1178, _net_1179, _net_1180, D4, _net_1181, _net_1182, _net_1183, SE, SI);
not inst1402  (_net_1184, D0);
not inst1403  (_net_1185, D1);
not inst1404  (_net_1186, D2);
not inst1405  (_net_1187, D3);
not inst1406  (_net_1188, SE);
not inst1407  (_net_1189, SI);
and inst1408  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_1184, CK, _net_1185, _net_1186, _net_1187, D4, D5, D6, D7, _net_1188, _net_1189);
not inst1409  (_net_1190, D0);
not inst1410  (_net_1191, D1);
not inst1411  (_net_1192, D2);
not inst1412  (_net_1193, D3);
not inst1413  (_net_1194, SE);
and inst1414  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, _net_1190, CK, _net_1191, _net_1192, _net_1193, D4, D5, D6, D7, _net_1194, SI);
not inst1415  (_net_1195, D0);
not inst1416  (_net_1196, D1);
not inst1417  (_net_1197, D2);
not inst1418  (_net_1198, D3);
not inst1419  (_net_1199, SI);
and inst1420  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, _net_1195, CK, _net_1196, _net_1197, _net_1198, D4, D5, D6, D7, SE, _net_1199);
not inst1421  (_net_1200, D0);
not inst1422  (_net_1201, D1);
not inst1423  (_net_1202, D2);
not inst1424  (_net_1203, D3);
and inst1425  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, _net_1200, CK, _net_1201, _net_1202, _net_1203, D4, D5, D6, D7, SE, SI);
not inst1426  (_net_1204, D0);
not inst1427  (_net_1205, D1);
not inst1428  (_net_1206, D2);
not inst1429  (_net_1207, D4);
not inst1430  (_net_1208, D5);
not inst1431  (_net_1209, D6);
not inst1432  (_net_1210, D7);
not inst1433  (_net_1211, SE);
not inst1434  (_net_1212, SI);
and inst1435  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_1204, CK, _net_1205, _net_1206, D3, _net_1207, _net_1208, _net_1209, _net_1210, _net_1211, _net_1212);
not inst1436  (_net_1213, D0);
not inst1437  (_net_1214, D1);
not inst1438  (_net_1215, D2);
not inst1439  (_net_1216, D4);
not inst1440  (_net_1217, D5);
not inst1441  (_net_1218, D6);
not inst1442  (_net_1219, D7);
not inst1443  (_net_1220, SE);
and inst1444  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_1213, CK, _net_1214, _net_1215, D3, _net_1216, _net_1217, _net_1218, _net_1219, _net_1220, SI);
not inst1445  (_net_1221, D0);
not inst1446  (_net_1222, D1);
not inst1447  (_net_1223, D2);
not inst1448  (_net_1224, D4);
not inst1449  (_net_1225, D5);
not inst1450  (_net_1226, D6);
not inst1451  (_net_1227, D7);
not inst1452  (_net_1228, SI);
and inst1453  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_1221, CK, _net_1222, _net_1223, D3, _net_1224, _net_1225, _net_1226, _net_1227, SE, _net_1228);
not inst1454  (_net_1229, D0);
not inst1455  (_net_1230, D1);
not inst1456  (_net_1231, D2);
not inst1457  (_net_1232, D4);
not inst1458  (_net_1233, D5);
not inst1459  (_net_1234, D6);
not inst1460  (_net_1235, D7);
and inst1461  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_1229, CK, _net_1230, _net_1231, D3, _net_1232, _net_1233, _net_1234, _net_1235, SE, SI);
not inst1462  (_net_1236, D0);
not inst1463  (_net_1237, D1);
not inst1464  (_net_1238, D3);
not inst1465  (_net_1239, D4);
not inst1466  (_net_1240, D5);
not inst1467  (_net_1241, D6);
not inst1468  (_net_1242, D7);
not inst1469  (_net_1243, SE);
not inst1470  (_net_1244, SI);
and inst1471  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_1236, CK, _net_1237, D2, _net_1238, _net_1239, _net_1240, _net_1241, _net_1242, _net_1243, _net_1244);
not inst1472  (_net_1245, D0);
not inst1473  (_net_1246, D1);
not inst1474  (_net_1247, D3);
not inst1475  (_net_1248, D4);
not inst1476  (_net_1249, D5);
not inst1477  (_net_1250, D6);
not inst1478  (_net_1251, D7);
not inst1479  (_net_1252, SE);
and inst1480  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_1245, CK, _net_1246, D2, _net_1247, _net_1248, _net_1249, _net_1250, _net_1251, _net_1252, SI);
not inst1481  (_net_1253, D0);
not inst1482  (_net_1254, D1);
not inst1483  (_net_1255, D3);
not inst1484  (_net_1256, D4);
not inst1485  (_net_1257, D5);
not inst1486  (_net_1258, D6);
not inst1487  (_net_1259, D7);
not inst1488  (_net_1260, SI);
and inst1489  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_1253, CK, _net_1254, D2, _net_1255, _net_1256, _net_1257, _net_1258, _net_1259, SE, _net_1260);
not inst1490  (_net_1261, D0);
not inst1491  (_net_1262, D1);
not inst1492  (_net_1263, D3);
not inst1493  (_net_1264, D4);
not inst1494  (_net_1265, D5);
not inst1495  (_net_1266, D6);
not inst1496  (_net_1267, D7);
and inst1497  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_1261, CK, _net_1262, D2, _net_1263, _net_1264, _net_1265, _net_1266, _net_1267, SE, SI);
not inst1498  (_net_1268, D0);
not inst1499  (_net_1269, D2);
not inst1500  (_net_1270, D3);
not inst1501  (_net_1271, D4);
not inst1502  (_net_1272, D5);
not inst1503  (_net_1273, D6);
not inst1504  (_net_1274, D7);
not inst1505  (_net_1275, SE);
not inst1506  (_net_1276, SI);
and inst1507  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_1268, CK, D1, _net_1269, _net_1270, _net_1271, _net_1272, _net_1273, _net_1274, _net_1275, _net_1276);
not inst1508  (_net_1277, D0);
not inst1509  (_net_1278, D2);
not inst1510  (_net_1279, D3);
not inst1511  (_net_1280, D4);
not inst1512  (_net_1281, D5);
not inst1513  (_net_1282, D6);
not inst1514  (_net_1283, D7);
not inst1515  (_net_1284, SE);
and inst1516  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_1277, CK, D1, _net_1278, _net_1279, _net_1280, _net_1281, _net_1282, _net_1283, _net_1284, SI);
not inst1517  (_net_1285, D0);
not inst1518  (_net_1286, D2);
not inst1519  (_net_1287, D3);
not inst1520  (_net_1288, D4);
not inst1521  (_net_1289, D5);
not inst1522  (_net_1290, D6);
not inst1523  (_net_1291, D7);
not inst1524  (_net_1292, SI);
and inst1525  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_1285, CK, D1, _net_1286, _net_1287, _net_1288, _net_1289, _net_1290, _net_1291, SE, _net_1292);
not inst1526  (_net_1293, D0);
not inst1527  (_net_1294, D2);
not inst1528  (_net_1295, D3);
not inst1529  (_net_1296, D4);
not inst1530  (_net_1297, D5);
not inst1531  (_net_1298, D6);
not inst1532  (_net_1299, D7);
and inst1533  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_1293, CK, D1, _net_1294, _net_1295, _net_1296, _net_1297, _net_1298, _net_1299, SE, SI);
not inst1534  (_net_1300, D1);
not inst1535  (_net_1301, D2);
not inst1536  (_net_1302, D3);
not inst1537  (_net_1303, D4);
not inst1538  (_net_1304, D5);
not inst1539  (_net_1305, D6);
not inst1540  (_net_1306, D7);
not inst1541  (_net_1307, SE);
not inst1542  (_net_1308, SI);
and inst1543  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_1300, _net_1301, _net_1302, _net_1303, _net_1304, _net_1305, _net_1306, _net_1307, _net_1308);
not inst1544  (_net_1309, D1);
not inst1545  (_net_1310, D2);
not inst1546  (_net_1311, D3);
not inst1547  (_net_1312, D4);
not inst1548  (_net_1313, D5);
not inst1549  (_net_1314, D6);
not inst1550  (_net_1315, D7);
not inst1551  (_net_1316, SE);
and inst1552  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, D0, CK, _net_1309, _net_1310, _net_1311, _net_1312, _net_1313, _net_1314, _net_1315, _net_1316, SI);
not inst1553  (_net_1317, D1);
not inst1554  (_net_1318, D2);
not inst1555  (_net_1319, D3);
not inst1556  (_net_1320, D4);
not inst1557  (_net_1321, D5);
not inst1558  (_net_1322, D6);
not inst1559  (_net_1323, D7);
not inst1560  (_net_1324, SI);
and inst1561  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, D0, CK, _net_1317, _net_1318, _net_1319, _net_1320, _net_1321, _net_1322, _net_1323, SE, _net_1324);
not inst1562  (_net_1325, D1);
not inst1563  (_net_1326, D2);
not inst1564  (_net_1327, D3);
not inst1565  (_net_1328, D4);
not inst1566  (_net_1329, D5);
not inst1567  (_net_1330, D6);
not inst1568  (_net_1331, D7);
and inst1569  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, D0, CK, _net_1325, _net_1326, _net_1327, _net_1328, _net_1329, _net_1330, _net_1331, SE, SI);
not inst1570  (_net_1332, D1);
not inst1571  (_net_1333, D2);
not inst1572  (_net_1334, D3);
not inst1573  (_net_1335, SE);
not inst1574  (_net_1336, SI);
and inst1575  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_1332, _net_1333, _net_1334, D4, D5, D6, D7, _net_1335, _net_1336);
not inst1576  (_net_1337, D1);
not inst1577  (_net_1338, D2);
not inst1578  (_net_1339, D3);
not inst1579  (_net_1340, SE);
and inst1580  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D0, CK, _net_1337, _net_1338, _net_1339, D4, D5, D6, D7, _net_1340, SI);
not inst1581  (_net_1341, D1);
not inst1582  (_net_1342, D2);
not inst1583  (_net_1343, D3);
not inst1584  (_net_1344, SI);
and inst1585  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D0, CK, _net_1341, _net_1342, _net_1343, D4, D5, D6, D7, SE, _net_1344);
not inst1586  (_net_1345, D1);
not inst1587  (_net_1346, D2);
not inst1588  (_net_1347, D3);
and inst1589  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, D0, CK, _net_1345, _net_1346, _net_1347, D4, D5, D6, D7, SE, SI);
not inst1590  (_net_1348, D1);
not inst1591  (_net_1349, D3);
not inst1592  (_net_1350, D5);
not inst1593  (_net_1351, D7);
not inst1594  (_net_1352, SE);
not inst1595  (_net_1353, SI);
and inst1596  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_1348, D2, _net_1349, D4, _net_1350, D6, _net_1351, _net_1352, _net_1353);
not inst1597  (_net_1354, D1);
not inst1598  (_net_1355, D3);
not inst1599  (_net_1356, D5);
not inst1600  (_net_1357, D7);
not inst1601  (_net_1358, SE);
and inst1602  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, D0, CK, _net_1354, D2, _net_1355, D4, _net_1356, D6, _net_1357, _net_1358, SI);
not inst1603  (_net_1359, D1);
not inst1604  (_net_1360, D3);
not inst1605  (_net_1361, D5);
not inst1606  (_net_1362, D7);
not inst1607  (_net_1363, SI);
and inst1608  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, D0, CK, _net_1359, D2, _net_1360, D4, _net_1361, D6, _net_1362, SE, _net_1363);
not inst1609  (_net_1364, D1);
not inst1610  (_net_1365, D3);
not inst1611  (_net_1366, D5);
not inst1612  (_net_1367, D7);
and inst1613  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI, D0, CK, _net_1364, D2, _net_1365, D4, _net_1366, D6, _net_1367, SE, SI);
not inst1614  (_net_1368, D1);
not inst1615  (_net_1369, D3);
not inst1616  (_net_1370, D5);
not inst1617  (_net_1371, SE);
not inst1618  (_net_1372, SI);
and inst1619  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_1368, D2, _net_1369, D4, _net_1370, D6, D7, _net_1371, _net_1372);
not inst1620  (_net_1373, D1);
not inst1621  (_net_1374, D3);
not inst1622  (_net_1375, D5);
not inst1623  (_net_1376, SE);
and inst1624  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D0, CK, _net_1373, D2, _net_1374, D4, _net_1375, D6, D7, _net_1376, SI);
not inst1625  (_net_1377, D1);
not inst1626  (_net_1378, D3);
not inst1627  (_net_1379, D5);
not inst1628  (_net_1380, SI);
and inst1629  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D0, CK, _net_1377, D2, _net_1378, D4, _net_1379, D6, D7, SE, _net_1380);
not inst1630  (_net_1381, D1);
not inst1631  (_net_1382, D3);
not inst1632  (_net_1383, D5);
and inst1633  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_SI, D0, CK, _net_1381, D2, _net_1382, D4, _net_1383, D6, D7, SE, SI);
not inst1634  (_net_1384, D1);
not inst1635  (_net_1385, D3);
not inst1636  (_net_1386, SE);
not inst1637  (_net_1387, SI);
and inst1638  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_1384, D2, _net_1385, D4, D5, D6, D7, _net_1386, _net_1387);
not inst1639  (_net_1388, D1);
not inst1640  (_net_1389, D3);
not inst1641  (_net_1390, SE);
and inst1642  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D0, CK, _net_1388, D2, _net_1389, D4, D5, D6, D7, _net_1390, SI);
not inst1643  (_net_1391, D1);
not inst1644  (_net_1392, D3);
not inst1645  (_net_1393, SI);
and inst1646  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D0, CK, _net_1391, D2, _net_1392, D4, D5, D6, D7, SE, _net_1393);
not inst1647  (_net_1394, D1);
not inst1648  (_net_1395, D3);
and inst1649  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, D0, CK, _net_1394, D2, _net_1395, D4, D5, D6, D7, SE, SI);
not inst1650  (_net_1396, SE);
not inst1651  (_net_1397, SI);
and inst1652  (ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D0, CK, D1, D2, D3, D4, D5, D6, D7, _net_1396, _net_1397);
not inst1653  (_net_1398, SE);
and inst1654  (ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D0, CK, D1, D2, D3, D4, D5, D6, D7, _net_1398, SI);
not inst1655  (_net_1399, SI);
and inst1656  (ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D0, CK, D1, D2, D3, D4, D5, D6, D7, SE, _net_1399);
and inst1657  (ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, D0, CK, D1, D2, D3, D4, D5, D6, D7, SE, SI);
not inst1658  (_net_1400, D1);
not inst1659  (_net_1401, D0);
not inst1660  (_net_1402, D2);
not inst1661  (_net_1403, D3);
not inst1662  (_net_1404, D4);
not inst1663  (_net_1405, D5);
not inst1664  (_net_1406, D6);
not inst1665  (_net_1407, D7);
and inst1666  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI, _net_1400, _net_1401, _net_1402, _net_1403, _net_1404, _net_1405, _net_1406, _net_1407, RD, SI);
not inst1667  (_net_1408, D1);
not inst1668  (_net_1409, D0);
not inst1669  (_net_1410, D2);
not inst1670  (_net_1411, D3);
not inst1671  (_net_1412, D4);
not inst1672  (_net_1413, D5);
not inst1673  (_net_1414, D6);
not inst1674  (_net_1415, SI);
and inst1675  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI, _net_1408, _net_1409, _net_1410, _net_1411, _net_1412, _net_1413, _net_1414, D7, RD, _net_1415);
not inst1676  (_net_1416, D1);
not inst1677  (_net_1417, D0);
not inst1678  (_net_1418, D2);
not inst1679  (_net_1419, D3);
not inst1680  (_net_1420, D4);
not inst1681  (_net_1421, D5);
not inst1682  (_net_1422, D7);
not inst1683  (_net_1423, SI);
and inst1684  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_1416, _net_1417, _net_1418, _net_1419, _net_1420, _net_1421, D6, _net_1422, RD, _net_1423);
not inst1685  (_net_1424, D1);
not inst1686  (_net_1425, D0);
not inst1687  (_net_1426, D2);
not inst1688  (_net_1427, D3);
not inst1689  (_net_1428, D4);
not inst1690  (_net_1429, D6);
not inst1691  (_net_1430, D7);
not inst1692  (_net_1431, SI);
and inst1693  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_1424, _net_1425, _net_1426, _net_1427, _net_1428, D5, _net_1429, _net_1430, RD, _net_1431);
not inst1694  (_net_1432, D1);
not inst1695  (_net_1433, D0);
not inst1696  (_net_1434, D2);
not inst1697  (_net_1435, D3);
not inst1698  (_net_1436, D5);
not inst1699  (_net_1437, D6);
not inst1700  (_net_1438, D7);
not inst1701  (_net_1439, SI);
and inst1702  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_1432, _net_1433, _net_1434, _net_1435, D4, _net_1436, _net_1437, _net_1438, RD, _net_1439);
not inst1703  (_net_1440, D1);
not inst1704  (_net_1441, D0);
not inst1705  (_net_1442, D2);
not inst1706  (_net_1443, D4);
not inst1707  (_net_1444, D5);
not inst1708  (_net_1445, D6);
not inst1709  (_net_1446, D7);
not inst1710  (_net_1447, SI);
and inst1711  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_1440, _net_1441, _net_1442, D3, _net_1443, _net_1444, _net_1445, _net_1446, RD, _net_1447);
not inst1712  (_net_1448, D1);
not inst1713  (_net_1449, D0);
not inst1714  (_net_1450, D3);
not inst1715  (_net_1451, D4);
not inst1716  (_net_1452, D5);
not inst1717  (_net_1453, D6);
not inst1718  (_net_1454, D7);
not inst1719  (_net_1455, SI);
and inst1720  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_1448, _net_1449, D2, _net_1450, _net_1451, _net_1452, _net_1453, _net_1454, RD, _net_1455);
not inst1721  (_net_1456, D0);
not inst1722  (_net_1457, D2);
not inst1723  (_net_1458, D3);
not inst1724  (_net_1459, D4);
not inst1725  (_net_1460, D5);
not inst1726  (_net_1461, D6);
not inst1727  (_net_1462, D7);
not inst1728  (_net_1463, SI);
and inst1729  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, D1, _net_1456, _net_1457, _net_1458, _net_1459, _net_1460, _net_1461, _net_1462, RD, _net_1463);
not inst1730  (_net_1464, D1);
not inst1731  (_net_1465, D2);
not inst1732  (_net_1466, D3);
not inst1733  (_net_1467, D4);
not inst1734  (_net_1468, D5);
not inst1735  (_net_1469, D6);
not inst1736  (_net_1470, D7);
not inst1737  (_net_1471, SI);
and inst1738  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_1464, D0, _net_1465, _net_1466, _net_1467, _net_1468, _net_1469, _net_1470, RD, _net_1471);
not inst1739  (_net_1472, D0);
and inst1740  (ENABLE_NOT_D0_AND_RD_AND_SE, RD, _net_1472, SE);
and inst1741  (ENABLE_D0_AND_RD_AND_SE, RD, D0, SE);
not inst1742  (_net_1473, SE);
not inst1743  (_net_1474, SI);
and inst1744  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_1473, RD, _net_1474);
not inst1745  (_net_1475, SE);
and inst1746  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_1475, RD, SI);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
      viol_2 = (viol_2 !== viol_all) ? viol_all : ~viol_2;
      viol_3 = (viol_3 !== viol_all) ? viol_all : ~viol_3;
      viol_4 = (viol_4 !== viol_all) ? viol_all : ~viol_4;
      viol_5 = (viol_5 !== viol_all) ? viol_all : ~viol_5;
      viol_6 = (viol_6 !== viol_all) ? viol_all : ~viol_6;
      viol_7 = (viol_7 !== viol_all) ? viol_all : ~viol_7;
   end 
`endif 
specify
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
(negedge RD => (Q0 : 1'b0))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
(negedge RD => (Q1 : 1'b0))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (CK==1'b0&&D2==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
(negedge RD => (Q2 : 1'b0))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
if (CK==1'b0&&D3==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
(negedge RD => (Q3 : 1'b0))=(0, 0);
if (D4==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
(posedge CK => (Q4 : 1'b1))=(0, 0);
if (CK==1'b0&&D4==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b0&&D4==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b0&&D4==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b0&&D4==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b0&&D4==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b0&&D4==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b0&&D4==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b0&&D4==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b1&&D4==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b1&&D4==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b1&&D4==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b1&&D4==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b1&&D4==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b1&&D4==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b1&&D4==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b1&&D4==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q4 +: 1'b0))=(0, 0);
(negedge RD => (Q4 : 1'b0))=(0, 0);
if (D5==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
(posedge CK => (Q5 : 1'b1))=(0, 0);
if (CK==1'b0&&D5==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b0&&D5==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b0&&D5==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b0&&D5==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b0&&D5==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b0&&D5==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b0&&D5==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b0&&D5==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b1&&D5==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b1&&D5==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b1&&D5==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b1&&D5==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b1&&D5==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b1&&D5==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b1&&D5==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b1&&D5==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q5 +: 1'b0))=(0, 0);
(negedge RD => (Q5 : 1'b0))=(0, 0);
if (D6==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
(posedge CK => (Q6 : 1'b1))=(0, 0);
if (CK==1'b0&&D6==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b0&&D6==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b0&&D6==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b0&&D6==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b0&&D6==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b0&&D6==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b0&&D6==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b0&&D6==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b1&&D6==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b1&&D6==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b1&&D6==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b1&&D6==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b1&&D6==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b1&&D6==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b1&&D6==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b1&&D6==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q6 +: 1'b0))=(0, 0);
(negedge RD => (Q6 : 1'b0))=(0, 0);
if (D7==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
(posedge CK => (Q7 : 1'b1))=(0, 0);
if (CK==1'b0&&D7==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b0&&D7==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b0&&D7==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b0&&D7==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b0&&D7==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b0&&D7==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b0&&D7==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b0&&D7==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b1&&D7==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b1&&D7==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b1&&D7==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b1&&D7==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b1&&D7==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b1&&D7==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b1&&D7==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b1&&D7==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q7 +: 1'b0))=(0, 0);
(negedge RD => (Q7 : 1'b0))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$recrem(posedge RD , posedge CK , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$width(negedge RD , 0 ,0, viol_all);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D4 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_4, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D4 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_4, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D4 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_4, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D4 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_4, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D5 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_5, , , delayed_CK, delayed_D5);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D5 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_5, , , delayed_CK, delayed_D5);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D5 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_5, , , delayed_CK, delayed_D5);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D5 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_5, , , delayed_CK, delayed_D5);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D6 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_6, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D6 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_6, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D6 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_6, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D6 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_6, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D7 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_7, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D7 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_7, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D7 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_7, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D7 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_7, , , delayed_CK, delayed_D7);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPRBQM8SS_V2Y16_1

//%BEGIN HDBSVT11_FSDPRBQM8SS_V2Y16_2
`celldefine
module HDBSVT11_FSDPRBQM8SS_V2Y16_2 (Q0, Q1, Q2, Q3, Q4, Q5, Q6, Q7, CK, D0, D1, D2, D3, D4, D5, D6, D7, SI, SE, RD);
  input CK, D0, D1, D2, D3, D4, D5, D6, D7, SI, SE, RD;
  output Q0, Q1, Q2, Q3, Q4, Q5, Q6, Q7;
   reg viol_all, viol_0,  viol_1,  viol_2,  viol_3,  viol_4,  viol_5,  viol_6,  viol_7;
  wire int_16, iq7, iq6, iq5, iq4, iq3, iq2, iq1, iq0, d_int7, d_int6, d_int5, d_int4, d_int3, d_int2, d_int1, d_int0;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D0, D0);
    buf inst2  (delayed_D1, D1);
    buf inst3  (delayed_D2, D2);
    buf inst4  (delayed_D3, D3);
    buf inst5  (delayed_D4, D4);
    buf inst6  (delayed_D5, D5);
    buf inst7  (delayed_D6, D6);
    buf inst8  (delayed_D7, D7);
    buf inst9  (delayed_SI, SI);
    buf inst10  (delayed_SE, SE);
    buf inst11  (delayed_RD, RD);
  `endif


    not inst12  (int_16, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst13  (xcr_26, delayed_CK, d_int7, int_16);

  `endif
    snps_dff_r inst14  (iq7, viol_7, delayed_CK, d_int7, int_16, xcr_26);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst15  (xcr_28, delayed_CK, d_int6, int_16);

  `endif
    snps_dff_r inst16  (iq6, viol_6, delayed_CK, d_int6, int_16, xcr_28);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst17  (xcr_30, delayed_CK, d_int5, int_16);

  `endif
    snps_dff_r inst18  (iq5, viol_5, delayed_CK, d_int5, int_16, xcr_30);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst19  (xcr_32, delayed_CK, d_int4, int_16);

  `endif
    snps_dff_r inst20  (iq4, viol_4, delayed_CK, d_int4, int_16, xcr_32);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst21  (xcr_34, delayed_CK, d_int3, int_16);

  `endif
    snps_dff_r inst22  (iq3, viol_3, delayed_CK, d_int3, int_16, xcr_34);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst23  (xcr_36, delayed_CK, d_int2, int_16);

  `endif
    snps_dff_r inst24  (iq2, viol_2, delayed_CK, d_int2, int_16, xcr_36);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst25  (xcr_38, delayed_CK, d_int1, int_16);

  `endif
    snps_dff_r inst26  (iq1, viol_1, delayed_CK, d_int1, int_16, xcr_38);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst27  (xcr_40, delayed_CK, d_int0, int_16);

  `endif
    snps_dff_r inst28  (iq0, viol_0, delayed_CK, d_int0, int_16, xcr_40);
    snps_mux2 inst29  (d_int7, iq6, delayed_D7, delayed_SE);
    snps_mux2 inst30  (d_int6, iq5, delayed_D6, delayed_SE);
    snps_mux2 inst31  (d_int5, iq4, delayed_D5, delayed_SE);
    snps_mux2 inst32  (d_int4, iq3, delayed_D4, delayed_SE);
    snps_mux2 inst33  (d_int3, iq2, delayed_D3, delayed_SE);
    snps_mux2 inst34  (d_int2, iq1, delayed_D2, delayed_SE);
    snps_mux2 inst35  (d_int1, iq0, delayed_D1, delayed_SE);
    snps_mux2 inst36  (d_int0, delayed_SI, delayed_D0, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst37 (Q7, iq7);
    buf #`SNPS_SEQ_DELAY  inst38 (Q6, iq6);
    buf #`SNPS_SEQ_DELAY  inst39 (Q5, iq5);
    buf #`SNPS_SEQ_DELAY  inst40 (Q4, iq4);
    buf #`SNPS_SEQ_DELAY  inst41 (Q3, iq3);
    buf #`SNPS_SEQ_DELAY  inst42 (Q2, iq2);
    buf #`SNPS_SEQ_DELAY  inst43 (Q1, iq1);
    buf #`SNPS_SEQ_DELAY  inst44 (Q0, iq0);
  `else
    buf inst45  (Q7, iq7);
    buf inst46  (Q6, iq6);
    buf inst47  (Q5, iq5);
    buf inst48  (Q4, iq4);
    buf inst49  (Q3, iq3);
    buf inst50  (Q2, iq2);
    buf inst51  (Q1, iq1);
    buf inst52  (Q0, iq0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst53  (_net_0, D1);
not inst54  (_net_1, D0);
not inst55  (_net_2, D2);
not inst56  (_net_3, D3);
not inst57  (_net_4, D4);
not inst58  (_net_5, D5);
not inst59  (_net_6, D6);
not inst60  (_net_7, D7);
not inst61  (_net_8, SE);
not inst62  (_net_9, SI);
and inst63  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5, _net_6, _net_7, RD, _net_8, _net_9);
not inst64  (_net_10, D1);
not inst65  (_net_11, D0);
not inst66  (_net_12, D2);
not inst67  (_net_13, D3);
not inst68  (_net_14, D4);
not inst69  (_net_15, D5);
not inst70  (_net_16, D6);
not inst71  (_net_17, D7);
not inst72  (_net_18, SE);
and inst73  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, _net_13, _net_14, _net_15, _net_16, _net_17, RD, _net_18, SI);
not inst74  (_net_19, D1);
not inst75  (_net_20, D0);
not inst76  (_net_21, D2);
not inst77  (_net_22, D3);
not inst78  (_net_23, D4);
not inst79  (_net_24, D5);
not inst80  (_net_25, D6);
not inst81  (_net_26, D7);
not inst82  (_net_27, SI);
and inst83  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_19, _net_20, _net_21, _net_22, _net_23, _net_24, _net_25, _net_26, RD, SE, _net_27);
not inst84  (_net_28, D1);
not inst85  (_net_29, D0);
not inst86  (_net_30, D2);
not inst87  (_net_31, D3);
not inst88  (_net_32, D4);
not inst89  (_net_33, D5);
not inst90  (_net_34, D6);
not inst91  (_net_35, D7);
and inst92  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_28, _net_29, _net_30, _net_31, _net_32, _net_33, _net_34, _net_35, RD, SE, SI);
not inst93  (_net_36, D1);
not inst94  (_net_37, D0);
not inst95  (_net_38, D2);
not inst96  (_net_39, D3);
not inst97  (_net_40, D4);
not inst98  (_net_41, D5);
not inst99  (_net_42, D6);
not inst100  (_net_43, SE);
not inst101  (_net_44, SI);
and inst102  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_36, _net_37, _net_38, _net_39, _net_40, _net_41, _net_42, D7, RD, _net_43, _net_44);
not inst103  (_net_45, D1);
not inst104  (_net_46, D0);
not inst105  (_net_47, D2);
not inst106  (_net_48, D3);
not inst107  (_net_49, D4);
not inst108  (_net_50, D5);
not inst109  (_net_51, D6);
not inst110  (_net_52, SE);
and inst111  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_45, _net_46, _net_47, _net_48, _net_49, _net_50, _net_51, D7, RD, _net_52, SI);
not inst112  (_net_53, D1);
not inst113  (_net_54, D0);
not inst114  (_net_55, D2);
not inst115  (_net_56, D3);
not inst116  (_net_57, D4);
not inst117  (_net_58, D5);
not inst118  (_net_59, D6);
not inst119  (_net_60, SI);
and inst120  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_53, _net_54, _net_55, _net_56, _net_57, _net_58, _net_59, D7, RD, SE, _net_60);
not inst121  (_net_61, D1);
not inst122  (_net_62, D0);
not inst123  (_net_63, D2);
not inst124  (_net_64, D3);
not inst125  (_net_65, D4);
not inst126  (_net_66, D5);
not inst127  (_net_67, D6);
and inst128  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_61, _net_62, _net_63, _net_64, _net_65, _net_66, _net_67, D7, RD, SE, SI);
not inst129  (_net_68, D1);
not inst130  (_net_69, D0);
not inst131  (_net_70, D2);
not inst132  (_net_71, D3);
not inst133  (_net_72, D4);
not inst134  (_net_73, D5);
not inst135  (_net_74, D7);
not inst136  (_net_75, SE);
not inst137  (_net_76, SI);
and inst138  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_68, _net_69, _net_70, _net_71, _net_72, _net_73, D6, _net_74, RD, _net_75, _net_76);
not inst139  (_net_77, D1);
not inst140  (_net_78, D0);
not inst141  (_net_79, D2);
not inst142  (_net_80, D3);
not inst143  (_net_81, D4);
not inst144  (_net_82, D5);
not inst145  (_net_83, D7);
not inst146  (_net_84, SE);
and inst147  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_77, _net_78, _net_79, _net_80, _net_81, _net_82, D6, _net_83, RD, _net_84, SI);
not inst148  (_net_85, D1);
not inst149  (_net_86, D0);
not inst150  (_net_87, D2);
not inst151  (_net_88, D3);
not inst152  (_net_89, D4);
not inst153  (_net_90, D5);
not inst154  (_net_91, D7);
not inst155  (_net_92, SI);
and inst156  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_85, _net_86, _net_87, _net_88, _net_89, _net_90, D6, _net_91, RD, SE, _net_92);
not inst157  (_net_93, D1);
not inst158  (_net_94, D0);
not inst159  (_net_95, D2);
not inst160  (_net_96, D3);
not inst161  (_net_97, D4);
not inst162  (_net_98, D5);
not inst163  (_net_99, D7);
and inst164  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_93, _net_94, _net_95, _net_96, _net_97, _net_98, D6, _net_99, RD, SE, SI);
not inst165  (_net_100, D1);
not inst166  (_net_101, D0);
not inst167  (_net_102, D2);
not inst168  (_net_103, D3);
not inst169  (_net_104, D4);
not inst170  (_net_105, D6);
not inst171  (_net_106, D7);
not inst172  (_net_107, SE);
not inst173  (_net_108, SI);
and inst174  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_100, _net_101, _net_102, _net_103, _net_104, D5, _net_105, _net_106, RD, _net_107, _net_108);
not inst175  (_net_109, D1);
not inst176  (_net_110, D0);
not inst177  (_net_111, D2);
not inst178  (_net_112, D3);
not inst179  (_net_113, D4);
not inst180  (_net_114, D6);
not inst181  (_net_115, D7);
not inst182  (_net_116, SE);
and inst183  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_109, _net_110, _net_111, _net_112, _net_113, D5, _net_114, _net_115, RD, _net_116, SI);
not inst184  (_net_117, D1);
not inst185  (_net_118, D0);
not inst186  (_net_119, D2);
not inst187  (_net_120, D3);
not inst188  (_net_121, D4);
not inst189  (_net_122, D6);
not inst190  (_net_123, D7);
not inst191  (_net_124, SI);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_117, _net_118, _net_119, _net_120, _net_121, D5, _net_122, _net_123, RD, SE, _net_124);
not inst193  (_net_125, D1);
not inst194  (_net_126, D0);
not inst195  (_net_127, D2);
not inst196  (_net_128, D3);
not inst197  (_net_129, D4);
not inst198  (_net_130, D6);
not inst199  (_net_131, D7);
and inst200  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_125, _net_126, _net_127, _net_128, _net_129, D5, _net_130, _net_131, RD, SE, SI);
not inst201  (_net_132, D1);
not inst202  (_net_133, D0);
not inst203  (_net_134, D2);
not inst204  (_net_135, D3);
not inst205  (_net_136, D5);
not inst206  (_net_137, D6);
not inst207  (_net_138, D7);
not inst208  (_net_139, SE);
not inst209  (_net_140, SI);
and inst210  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_132, _net_133, _net_134, _net_135, D4, _net_136, _net_137, _net_138, RD, _net_139, _net_140);
not inst211  (_net_141, D1);
not inst212  (_net_142, D0);
not inst213  (_net_143, D2);
not inst214  (_net_144, D3);
not inst215  (_net_145, D5);
not inst216  (_net_146, D6);
not inst217  (_net_147, D7);
not inst218  (_net_148, SE);
and inst219  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_141, _net_142, _net_143, _net_144, D4, _net_145, _net_146, _net_147, RD, _net_148, SI);
not inst220  (_net_149, D1);
not inst221  (_net_150, D0);
not inst222  (_net_151, D2);
not inst223  (_net_152, D3);
not inst224  (_net_153, D5);
not inst225  (_net_154, D6);
not inst226  (_net_155, D7);
not inst227  (_net_156, SI);
and inst228  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_149, _net_150, _net_151, _net_152, D4, _net_153, _net_154, _net_155, RD, SE, _net_156);
not inst229  (_net_157, D1);
not inst230  (_net_158, D0);
not inst231  (_net_159, D2);
not inst232  (_net_160, D3);
not inst233  (_net_161, D5);
not inst234  (_net_162, D6);
not inst235  (_net_163, D7);
and inst236  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_157, _net_158, _net_159, _net_160, D4, _net_161, _net_162, _net_163, RD, SE, SI);
not inst237  (_net_164, D1);
not inst238  (_net_165, D0);
not inst239  (_net_166, D2);
not inst240  (_net_167, D3);
not inst241  (_net_168, SE);
not inst242  (_net_169, SI);
and inst243  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_164, _net_165, _net_166, _net_167, D4, D5, D6, D7, RD, _net_168, _net_169);
not inst244  (_net_170, D1);
not inst245  (_net_171, D0);
not inst246  (_net_172, D2);
not inst247  (_net_173, D3);
not inst248  (_net_174, SE);
and inst249  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_170, _net_171, _net_172, _net_173, D4, D5, D6, D7, RD, _net_174, SI);
not inst250  (_net_175, D1);
not inst251  (_net_176, D0);
not inst252  (_net_177, D2);
not inst253  (_net_178, D3);
not inst254  (_net_179, SI);
and inst255  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_175, _net_176, _net_177, _net_178, D4, D5, D6, D7, RD, SE, _net_179);
not inst256  (_net_180, D1);
not inst257  (_net_181, D0);
not inst258  (_net_182, D2);
not inst259  (_net_183, D3);
and inst260  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_180, _net_181, _net_182, _net_183, D4, D5, D6, D7, RD, SE, SI);
not inst261  (_net_184, D1);
not inst262  (_net_185, D0);
not inst263  (_net_186, D2);
not inst264  (_net_187, D4);
not inst265  (_net_188, D5);
not inst266  (_net_189, D6);
not inst267  (_net_190, D7);
not inst268  (_net_191, SE);
not inst269  (_net_192, SI);
and inst270  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_184, _net_185, _net_186, D3, _net_187, _net_188, _net_189, _net_190, RD, _net_191, _net_192);
not inst271  (_net_193, D1);
not inst272  (_net_194, D0);
not inst273  (_net_195, D2);
not inst274  (_net_196, D4);
not inst275  (_net_197, D5);
not inst276  (_net_198, D6);
not inst277  (_net_199, D7);
not inst278  (_net_200, SE);
and inst279  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_193, _net_194, _net_195, D3, _net_196, _net_197, _net_198, _net_199, RD, _net_200, SI);
not inst280  (_net_201, D1);
not inst281  (_net_202, D0);
not inst282  (_net_203, D2);
not inst283  (_net_204, D4);
not inst284  (_net_205, D5);
not inst285  (_net_206, D6);
not inst286  (_net_207, D7);
not inst287  (_net_208, SI);
and inst288  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_201, _net_202, _net_203, D3, _net_204, _net_205, _net_206, _net_207, RD, SE, _net_208);
not inst289  (_net_209, D1);
not inst290  (_net_210, D0);
not inst291  (_net_211, D2);
not inst292  (_net_212, D4);
not inst293  (_net_213, D5);
not inst294  (_net_214, D6);
not inst295  (_net_215, D7);
and inst296  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_209, _net_210, _net_211, D3, _net_212, _net_213, _net_214, _net_215, RD, SE, SI);
not inst297  (_net_216, D1);
not inst298  (_net_217, D0);
not inst299  (_net_218, D3);
not inst300  (_net_219, D4);
not inst301  (_net_220, D5);
not inst302  (_net_221, D6);
not inst303  (_net_222, D7);
not inst304  (_net_223, SE);
not inst305  (_net_224, SI);
and inst306  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_216, _net_217, D2, _net_218, _net_219, _net_220, _net_221, _net_222, RD, _net_223, _net_224);
not inst307  (_net_225, D1);
not inst308  (_net_226, D0);
not inst309  (_net_227, D3);
not inst310  (_net_228, D4);
not inst311  (_net_229, D5);
not inst312  (_net_230, D6);
not inst313  (_net_231, D7);
not inst314  (_net_232, SE);
and inst315  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_225, _net_226, D2, _net_227, _net_228, _net_229, _net_230, _net_231, RD, _net_232, SI);
not inst316  (_net_233, D1);
not inst317  (_net_234, D0);
not inst318  (_net_235, D3);
not inst319  (_net_236, D4);
not inst320  (_net_237, D5);
not inst321  (_net_238, D6);
not inst322  (_net_239, D7);
not inst323  (_net_240, SI);
and inst324  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_233, _net_234, D2, _net_235, _net_236, _net_237, _net_238, _net_239, RD, SE, _net_240);
not inst325  (_net_241, D1);
not inst326  (_net_242, D0);
not inst327  (_net_243, D3);
not inst328  (_net_244, D4);
not inst329  (_net_245, D5);
not inst330  (_net_246, D6);
not inst331  (_net_247, D7);
and inst332  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_241, _net_242, D2, _net_243, _net_244, _net_245, _net_246, _net_247, RD, SE, SI);
not inst333  (_net_248, D0);
not inst334  (_net_249, D2);
not inst335  (_net_250, D3);
not inst336  (_net_251, D4);
not inst337  (_net_252, D5);
not inst338  (_net_253, D6);
not inst339  (_net_254, D7);
not inst340  (_net_255, SE);
not inst341  (_net_256, SI);
and inst342  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_248, _net_249, _net_250, _net_251, _net_252, _net_253, _net_254, RD, _net_255, _net_256);
not inst343  (_net_257, D0);
not inst344  (_net_258, D2);
not inst345  (_net_259, D3);
not inst346  (_net_260, D4);
not inst347  (_net_261, D5);
not inst348  (_net_262, D6);
not inst349  (_net_263, D7);
not inst350  (_net_264, SE);
and inst351  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, D1, _net_257, _net_258, _net_259, _net_260, _net_261, _net_262, _net_263, RD, _net_264, SI);
not inst352  (_net_265, D0);
not inst353  (_net_266, D2);
not inst354  (_net_267, D3);
not inst355  (_net_268, D4);
not inst356  (_net_269, D5);
not inst357  (_net_270, D6);
not inst358  (_net_271, D7);
not inst359  (_net_272, SI);
and inst360  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, D1, _net_265, _net_266, _net_267, _net_268, _net_269, _net_270, _net_271, RD, SE, _net_272);
not inst361  (_net_273, D0);
not inst362  (_net_274, D2);
not inst363  (_net_275, D3);
not inst364  (_net_276, D4);
not inst365  (_net_277, D5);
not inst366  (_net_278, D6);
not inst367  (_net_279, D7);
and inst368  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, D1, _net_273, _net_274, _net_275, _net_276, _net_277, _net_278, _net_279, RD, SE, SI);
not inst369  (_net_280, D1);
not inst370  (_net_281, D2);
not inst371  (_net_282, D3);
not inst372  (_net_283, D4);
not inst373  (_net_284, D5);
not inst374  (_net_285, D6);
not inst375  (_net_286, D7);
not inst376  (_net_287, SE);
not inst377  (_net_288, SI);
and inst378  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_280, D0, _net_281, _net_282, _net_283, _net_284, _net_285, _net_286, RD, _net_287, _net_288);
not inst379  (_net_289, D1);
not inst380  (_net_290, D2);
not inst381  (_net_291, D3);
not inst382  (_net_292, D4);
not inst383  (_net_293, D5);
not inst384  (_net_294, D6);
not inst385  (_net_295, D7);
not inst386  (_net_296, SE);
and inst387  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_289, D0, _net_290, _net_291, _net_292, _net_293, _net_294, _net_295, RD, _net_296, SI);
not inst388  (_net_297, D1);
not inst389  (_net_298, D2);
not inst390  (_net_299, D3);
not inst391  (_net_300, D4);
not inst392  (_net_301, D5);
not inst393  (_net_302, D6);
not inst394  (_net_303, D7);
not inst395  (_net_304, SI);
and inst396  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_297, D0, _net_298, _net_299, _net_300, _net_301, _net_302, _net_303, RD, SE, _net_304);
not inst397  (_net_305, D1);
not inst398  (_net_306, D2);
not inst399  (_net_307, D3);
not inst400  (_net_308, D4);
not inst401  (_net_309, D5);
not inst402  (_net_310, D6);
not inst403  (_net_311, D7);
and inst404  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_305, D0, _net_306, _net_307, _net_308, _net_309, _net_310, _net_311, RD, SE, SI);
not inst405  (_net_312, D1);
not inst406  (_net_313, D2);
not inst407  (_net_314, D3);
not inst408  (_net_315, SE);
not inst409  (_net_316, SI);
and inst410  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_312, D0, _net_313, _net_314, D4, D5, D6, D7, RD, _net_315, _net_316);
not inst411  (_net_317, D1);
not inst412  (_net_318, D2);
not inst413  (_net_319, D3);
not inst414  (_net_320, SE);
and inst415  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_317, D0, _net_318, _net_319, D4, D5, D6, D7, RD, _net_320, SI);
not inst416  (_net_321, D1);
not inst417  (_net_322, D2);
not inst418  (_net_323, D3);
not inst419  (_net_324, SI);
and inst420  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_321, D0, _net_322, _net_323, D4, D5, D6, D7, RD, SE, _net_324);
not inst421  (_net_325, D1);
not inst422  (_net_326, D2);
not inst423  (_net_327, D3);
and inst424  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_325, D0, _net_326, _net_327, D4, D5, D6, D7, RD, SE, SI);
not inst425  (_net_328, D1);
not inst426  (_net_329, D3);
not inst427  (_net_330, D5);
not inst428  (_net_331, D7);
not inst429  (_net_332, SE);
not inst430  (_net_333, SI);
and inst431  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_328, D0, D2, _net_329, D4, _net_330, D6, _net_331, RD, _net_332, _net_333);
not inst432  (_net_334, D1);
not inst433  (_net_335, D3);
not inst434  (_net_336, D5);
not inst435  (_net_337, D7);
not inst436  (_net_338, SE);
and inst437  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_334, D0, D2, _net_335, D4, _net_336, D6, _net_337, RD, _net_338, SI);
not inst438  (_net_339, D1);
not inst439  (_net_340, D3);
not inst440  (_net_341, D5);
not inst441  (_net_342, D7);
not inst442  (_net_343, SI);
and inst443  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_339, D0, D2, _net_340, D4, _net_341, D6, _net_342, RD, SE, _net_343);
not inst444  (_net_344, D1);
not inst445  (_net_345, D3);
not inst446  (_net_346, D5);
not inst447  (_net_347, D7);
and inst448  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_344, D0, D2, _net_345, D4, _net_346, D6, _net_347, RD, SE, SI);
not inst449  (_net_348, D1);
not inst450  (_net_349, D3);
not inst451  (_net_350, D5);
not inst452  (_net_351, SE);
not inst453  (_net_352, SI);
and inst454  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_348, D0, D2, _net_349, D4, _net_350, D6, D7, RD, _net_351, _net_352);
not inst455  (_net_353, D1);
not inst456  (_net_354, D3);
not inst457  (_net_355, D5);
not inst458  (_net_356, SE);
and inst459  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_353, D0, D2, _net_354, D4, _net_355, D6, D7, RD, _net_356, SI);
not inst460  (_net_357, D1);
not inst461  (_net_358, D3);
not inst462  (_net_359, D5);
not inst463  (_net_360, SI);
and inst464  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_357, D0, D2, _net_358, D4, _net_359, D6, D7, RD, SE, _net_360);
not inst465  (_net_361, D1);
not inst466  (_net_362, D3);
not inst467  (_net_363, D5);
and inst468  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_361, D0, D2, _net_362, D4, _net_363, D6, D7, RD, SE, SI);
not inst469  (_net_364, D1);
not inst470  (_net_365, D3);
not inst471  (_net_366, SE);
not inst472  (_net_367, SI);
and inst473  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_364, D0, D2, _net_365, D4, D5, D6, D7, RD, _net_366, _net_367);
not inst474  (_net_368, D1);
not inst475  (_net_369, D3);
not inst476  (_net_370, SE);
and inst477  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_368, D0, D2, _net_369, D4, D5, D6, D7, RD, _net_370, SI);
not inst478  (_net_371, D1);
not inst479  (_net_372, D3);
not inst480  (_net_373, SI);
and inst481  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_371, D0, D2, _net_372, D4, D5, D6, D7, RD, SE, _net_373);
not inst482  (_net_374, D1);
not inst483  (_net_375, D3);
and inst484  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_374, D0, D2, _net_375, D4, D5, D6, D7, RD, SE, SI);
not inst485  (_net_376, SE);
not inst486  (_net_377, SI);
and inst487  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, D4, D5, D6, D7, RD, _net_376, _net_377);
not inst488  (_net_378, SE);
and inst489  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, RD, _net_378, SI);
not inst490  (_net_379, SI);
and inst491  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, D1, D0, D2, D3, D4, D5, D6, D7, RD, SE, _net_379);
and inst492  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, RD, SE, SI);
not inst493  (_net_380, D1);
not inst494  (_net_381, D0);
not inst495  (_net_382, D2);
not inst496  (_net_383, D3);
not inst497  (_net_384, D4);
not inst498  (_net_385, D5);
not inst499  (_net_386, D6);
not inst500  (_net_387, D7);
and inst501  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_380, _net_381, _net_382, _net_383, _net_384, _net_385, _net_386, _net_387, SE, SI);
not inst502  (_net_388, D1);
not inst503  (_net_389, D0);
not inst504  (_net_390, D2);
not inst505  (_net_391, D3);
not inst506  (_net_392, D4);
not inst507  (_net_393, D5);
not inst508  (_net_394, D6);
not inst509  (_net_395, SE);
not inst510  (_net_396, SI);
and inst511  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_388, _net_389, _net_390, _net_391, _net_392, _net_393, _net_394, D7, _net_395, _net_396);
not inst512  (_net_397, D1);
not inst513  (_net_398, D0);
not inst514  (_net_399, D2);
not inst515  (_net_400, D3);
not inst516  (_net_401, D4);
not inst517  (_net_402, D5);
not inst518  (_net_403, D6);
not inst519  (_net_404, SE);
and inst520  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI, _net_397, _net_398, _net_399, _net_400, _net_401, _net_402, _net_403, D7, _net_404, SI);
not inst521  (_net_405, D1);
not inst522  (_net_406, D0);
not inst523  (_net_407, D2);
not inst524  (_net_408, D3);
not inst525  (_net_409, D4);
not inst526  (_net_410, D5);
not inst527  (_net_411, D6);
and inst528  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI, _net_405, _net_406, _net_407, _net_408, _net_409, _net_410, _net_411, D7, SE, SI);
not inst529  (_net_412, D1);
not inst530  (_net_413, D0);
not inst531  (_net_414, D2);
not inst532  (_net_415, D3);
not inst533  (_net_416, D4);
not inst534  (_net_417, D5);
not inst535  (_net_418, D7);
not inst536  (_net_419, SE);
not inst537  (_net_420, SI);
and inst538  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_412, _net_413, _net_414, _net_415, _net_416, _net_417, D6, _net_418, _net_419, _net_420);
not inst539  (_net_421, D1);
not inst540  (_net_422, D0);
not inst541  (_net_423, D2);
not inst542  (_net_424, D3);
not inst543  (_net_425, D4);
not inst544  (_net_426, D5);
not inst545  (_net_427, D7);
not inst546  (_net_428, SE);
and inst547  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_421, _net_422, _net_423, _net_424, _net_425, _net_426, D6, _net_427, _net_428, SI);
not inst548  (_net_429, D1);
not inst549  (_net_430, D0);
not inst550  (_net_431, D2);
not inst551  (_net_432, D3);
not inst552  (_net_433, D4);
not inst553  (_net_434, D5);
not inst554  (_net_435, D7);
and inst555  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI, _net_429, _net_430, _net_431, _net_432, _net_433, _net_434, D6, _net_435, SE, SI);
not inst556  (_net_436, D1);
not inst557  (_net_437, D0);
not inst558  (_net_438, D2);
not inst559  (_net_439, D3);
not inst560  (_net_440, D4);
not inst561  (_net_441, D6);
not inst562  (_net_442, D7);
not inst563  (_net_443, SE);
not inst564  (_net_444, SI);
and inst565  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_436, _net_437, _net_438, _net_439, _net_440, D5, _net_441, _net_442, _net_443, _net_444);
not inst566  (_net_445, D1);
not inst567  (_net_446, D0);
not inst568  (_net_447, D2);
not inst569  (_net_448, D3);
not inst570  (_net_449, D4);
not inst571  (_net_450, D6);
not inst572  (_net_451, D7);
not inst573  (_net_452, SE);
and inst574  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_445, _net_446, _net_447, _net_448, _net_449, D5, _net_450, _net_451, _net_452, SI);
not inst575  (_net_453, D1);
not inst576  (_net_454, D0);
not inst577  (_net_455, D2);
not inst578  (_net_456, D3);
not inst579  (_net_457, D4);
not inst580  (_net_458, D6);
not inst581  (_net_459, D7);
and inst582  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_453, _net_454, _net_455, _net_456, _net_457, D5, _net_458, _net_459, SE, SI);
not inst583  (_net_460, D1);
not inst584  (_net_461, D0);
not inst585  (_net_462, D2);
not inst586  (_net_463, D3);
not inst587  (_net_464, D5);
not inst588  (_net_465, D6);
not inst589  (_net_466, D7);
not inst590  (_net_467, SE);
not inst591  (_net_468, SI);
and inst592  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_460, _net_461, _net_462, _net_463, D4, _net_464, _net_465, _net_466, _net_467, _net_468);
not inst593  (_net_469, D1);
not inst594  (_net_470, D0);
not inst595  (_net_471, D2);
not inst596  (_net_472, D3);
not inst597  (_net_473, D5);
not inst598  (_net_474, D6);
not inst599  (_net_475, D7);
not inst600  (_net_476, SE);
and inst601  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_469, _net_470, _net_471, _net_472, D4, _net_473, _net_474, _net_475, _net_476, SI);
not inst602  (_net_477, D1);
not inst603  (_net_478, D0);
not inst604  (_net_479, D2);
not inst605  (_net_480, D3);
not inst606  (_net_481, D5);
not inst607  (_net_482, D6);
not inst608  (_net_483, D7);
and inst609  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_477, _net_478, _net_479, _net_480, D4, _net_481, _net_482, _net_483, SE, SI);
not inst610  (_net_484, D1);
not inst611  (_net_485, D0);
not inst612  (_net_486, D2);
not inst613  (_net_487, D4);
not inst614  (_net_488, D5);
not inst615  (_net_489, D6);
not inst616  (_net_490, D7);
not inst617  (_net_491, SE);
not inst618  (_net_492, SI);
and inst619  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_484, _net_485, _net_486, D3, _net_487, _net_488, _net_489, _net_490, _net_491, _net_492);
not inst620  (_net_493, D1);
not inst621  (_net_494, D0);
not inst622  (_net_495, D2);
not inst623  (_net_496, D4);
not inst624  (_net_497, D5);
not inst625  (_net_498, D6);
not inst626  (_net_499, D7);
not inst627  (_net_500, SE);
and inst628  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_493, _net_494, _net_495, D3, _net_496, _net_497, _net_498, _net_499, _net_500, SI);
not inst629  (_net_501, D1);
not inst630  (_net_502, D0);
not inst631  (_net_503, D2);
not inst632  (_net_504, D4);
not inst633  (_net_505, D5);
not inst634  (_net_506, D6);
not inst635  (_net_507, D7);
and inst636  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_501, _net_502, _net_503, D3, _net_504, _net_505, _net_506, _net_507, SE, SI);
not inst637  (_net_508, D1);
not inst638  (_net_509, D0);
not inst639  (_net_510, D3);
not inst640  (_net_511, D4);
not inst641  (_net_512, D5);
not inst642  (_net_513, D6);
not inst643  (_net_514, D7);
not inst644  (_net_515, SE);
not inst645  (_net_516, SI);
and inst646  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_508, _net_509, D2, _net_510, _net_511, _net_512, _net_513, _net_514, _net_515, _net_516);
not inst647  (_net_517, D1);
not inst648  (_net_518, D0);
not inst649  (_net_519, D3);
not inst650  (_net_520, D4);
not inst651  (_net_521, D5);
not inst652  (_net_522, D6);
not inst653  (_net_523, D7);
not inst654  (_net_524, SE);
and inst655  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_517, _net_518, D2, _net_519, _net_520, _net_521, _net_522, _net_523, _net_524, SI);
not inst656  (_net_525, D1);
not inst657  (_net_526, D0);
not inst658  (_net_527, D3);
not inst659  (_net_528, D4);
not inst660  (_net_529, D5);
not inst661  (_net_530, D6);
not inst662  (_net_531, D7);
and inst663  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_525, _net_526, D2, _net_527, _net_528, _net_529, _net_530, _net_531, SE, SI);
not inst664  (_net_532, D0);
not inst665  (_net_533, D2);
not inst666  (_net_534, D3);
not inst667  (_net_535, D4);
not inst668  (_net_536, D5);
not inst669  (_net_537, D6);
not inst670  (_net_538, D7);
not inst671  (_net_539, SE);
not inst672  (_net_540, SI);
and inst673  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, D1, _net_532, _net_533, _net_534, _net_535, _net_536, _net_537, _net_538, _net_539, _net_540);
not inst674  (_net_541, D0);
not inst675  (_net_542, D2);
not inst676  (_net_543, D3);
not inst677  (_net_544, D4);
not inst678  (_net_545, D5);
not inst679  (_net_546, D6);
not inst680  (_net_547, D7);
not inst681  (_net_548, SE);
and inst682  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, D1, _net_541, _net_542, _net_543, _net_544, _net_545, _net_546, _net_547, _net_548, SI);
not inst683  (_net_549, D0);
not inst684  (_net_550, D2);
not inst685  (_net_551, D3);
not inst686  (_net_552, D4);
not inst687  (_net_553, D5);
not inst688  (_net_554, D6);
not inst689  (_net_555, D7);
and inst690  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, D1, _net_549, _net_550, _net_551, _net_552, _net_553, _net_554, _net_555, SE, SI);
not inst691  (_net_556, D1);
not inst692  (_net_557, D2);
not inst693  (_net_558, D3);
not inst694  (_net_559, D4);
not inst695  (_net_560, D5);
not inst696  (_net_561, D6);
not inst697  (_net_562, D7);
not inst698  (_net_563, SE);
not inst699  (_net_564, SI);
and inst700  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_556, D0, _net_557, _net_558, _net_559, _net_560, _net_561, _net_562, _net_563, _net_564);
not inst701  (_net_565, D1);
not inst702  (_net_566, D2);
not inst703  (_net_567, D3);
not inst704  (_net_568, D4);
not inst705  (_net_569, D5);
not inst706  (_net_570, D6);
not inst707  (_net_571, D7);
not inst708  (_net_572, SE);
and inst709  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_565, D0, _net_566, _net_567, _net_568, _net_569, _net_570, _net_571, _net_572, SI);
not inst710  (_net_573, D1);
not inst711  (_net_574, D2);
not inst712  (_net_575, D3);
not inst713  (_net_576, D4);
not inst714  (_net_577, D5);
not inst715  (_net_578, D6);
not inst716  (_net_579, D7);
and inst717  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_573, D0, _net_574, _net_575, _net_576, _net_577, _net_578, _net_579, SE, SI);
not inst718  (_net_580, D0);
not inst719  (_net_581, CK);
not inst720  (_net_582, D1);
not inst721  (_net_583, D2);
not inst722  (_net_584, D3);
not inst723  (_net_585, D4);
not inst724  (_net_586, D5);
not inst725  (_net_587, D6);
not inst726  (_net_588, D7);
not inst727  (_net_589, SE);
not inst728  (_net_590, SI);
and inst729  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_580, _net_581, _net_582, _net_583, _net_584, _net_585, _net_586, _net_587, _net_588, _net_589, _net_590);
not inst730  (_net_591, D0);
not inst731  (_net_592, CK);
not inst732  (_net_593, D1);
not inst733  (_net_594, D2);
not inst734  (_net_595, D3);
not inst735  (_net_596, D4);
not inst736  (_net_597, D5);
not inst737  (_net_598, D6);
not inst738  (_net_599, D7);
not inst739  (_net_600, SE);
and inst740  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_591, _net_592, _net_593, _net_594, _net_595, _net_596, _net_597, _net_598, _net_599, _net_600, SI);
not inst741  (_net_601, D0);
not inst742  (_net_602, CK);
not inst743  (_net_603, D1);
not inst744  (_net_604, D2);
not inst745  (_net_605, D3);
not inst746  (_net_606, D4);
not inst747  (_net_607, D5);
not inst748  (_net_608, D6);
not inst749  (_net_609, D7);
not inst750  (_net_610, SI);
and inst751  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_601, _net_602, _net_603, _net_604, _net_605, _net_606, _net_607, _net_608, _net_609, SE, _net_610);
not inst752  (_net_611, D0);
not inst753  (_net_612, CK);
not inst754  (_net_613, D1);
not inst755  (_net_614, D2);
not inst756  (_net_615, D3);
not inst757  (_net_616, D4);
not inst758  (_net_617, D5);
not inst759  (_net_618, D6);
not inst760  (_net_619, D7);
and inst761  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_611, _net_612, _net_613, _net_614, _net_615, _net_616, _net_617, _net_618, _net_619, SE, SI);
not inst762  (_net_620, D0);
not inst763  (_net_621, CK);
not inst764  (_net_622, D1);
not inst765  (_net_623, D2);
not inst766  (_net_624, D3);
not inst767  (_net_625, D4);
not inst768  (_net_626, D5);
not inst769  (_net_627, D6);
not inst770  (_net_628, SE);
not inst771  (_net_629, SI);
and inst772  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_620, _net_621, _net_622, _net_623, _net_624, _net_625, _net_626, _net_627, D7, _net_628, _net_629);
not inst773  (_net_630, D0);
not inst774  (_net_631, CK);
not inst775  (_net_632, D1);
not inst776  (_net_633, D2);
not inst777  (_net_634, D3);
not inst778  (_net_635, D4);
not inst779  (_net_636, D5);
not inst780  (_net_637, D6);
not inst781  (_net_638, SE);
and inst782  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI, _net_630, _net_631, _net_632, _net_633, _net_634, _net_635, _net_636, _net_637, D7, _net_638, SI);
not inst783  (_net_639, D0);
not inst784  (_net_640, CK);
not inst785  (_net_641, D1);
not inst786  (_net_642, D2);
not inst787  (_net_643, D3);
not inst788  (_net_644, D4);
not inst789  (_net_645, D5);
not inst790  (_net_646, D6);
not inst791  (_net_647, SI);
and inst792  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_NOT_SI, _net_639, _net_640, _net_641, _net_642, _net_643, _net_644, _net_645, _net_646, D7, SE, _net_647);
not inst793  (_net_648, D0);
not inst794  (_net_649, CK);
not inst795  (_net_650, D1);
not inst796  (_net_651, D2);
not inst797  (_net_652, D3);
not inst798  (_net_653, D4);
not inst799  (_net_654, D5);
not inst800  (_net_655, D6);
and inst801  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI, _net_648, _net_649, _net_650, _net_651, _net_652, _net_653, _net_654, _net_655, D7, SE, SI);
not inst802  (_net_656, D0);
not inst803  (_net_657, CK);
not inst804  (_net_658, D1);
not inst805  (_net_659, D2);
not inst806  (_net_660, D3);
not inst807  (_net_661, D4);
not inst808  (_net_662, D5);
not inst809  (_net_663, D7);
not inst810  (_net_664, SE);
not inst811  (_net_665, SI);
and inst812  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_656, _net_657, _net_658, _net_659, _net_660, _net_661, _net_662, D6, _net_663, _net_664, _net_665);
not inst813  (_net_666, D0);
not inst814  (_net_667, CK);
not inst815  (_net_668, D1);
not inst816  (_net_669, D2);
not inst817  (_net_670, D3);
not inst818  (_net_671, D4);
not inst819  (_net_672, D5);
not inst820  (_net_673, D7);
not inst821  (_net_674, SE);
and inst822  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_666, _net_667, _net_668, _net_669, _net_670, _net_671, _net_672, D6, _net_673, _net_674, SI);
not inst823  (_net_675, D0);
not inst824  (_net_676, CK);
not inst825  (_net_677, D1);
not inst826  (_net_678, D2);
not inst827  (_net_679, D3);
not inst828  (_net_680, D4);
not inst829  (_net_681, D5);
not inst830  (_net_682, D7);
not inst831  (_net_683, SI);
and inst832  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_675, _net_676, _net_677, _net_678, _net_679, _net_680, _net_681, D6, _net_682, SE, _net_683);
not inst833  (_net_684, D0);
not inst834  (_net_685, CK);
not inst835  (_net_686, D1);
not inst836  (_net_687, D2);
not inst837  (_net_688, D3);
not inst838  (_net_689, D4);
not inst839  (_net_690, D5);
not inst840  (_net_691, D7);
and inst841  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI, _net_684, _net_685, _net_686, _net_687, _net_688, _net_689, _net_690, D6, _net_691, SE, SI);
not inst842  (_net_692, D0);
not inst843  (_net_693, CK);
not inst844  (_net_694, D1);
not inst845  (_net_695, D2);
not inst846  (_net_696, D3);
not inst847  (_net_697, D4);
not inst848  (_net_698, D6);
not inst849  (_net_699, D7);
not inst850  (_net_700, SE);
not inst851  (_net_701, SI);
and inst852  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_692, _net_693, _net_694, _net_695, _net_696, _net_697, D5, _net_698, _net_699, _net_700, _net_701);
not inst853  (_net_702, D0);
not inst854  (_net_703, CK);
not inst855  (_net_704, D1);
not inst856  (_net_705, D2);
not inst857  (_net_706, D3);
not inst858  (_net_707, D4);
not inst859  (_net_708, D6);
not inst860  (_net_709, D7);
not inst861  (_net_710, SE);
and inst862  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_702, _net_703, _net_704, _net_705, _net_706, _net_707, D5, _net_708, _net_709, _net_710, SI);
not inst863  (_net_711, D0);
not inst864  (_net_712, CK);
not inst865  (_net_713, D1);
not inst866  (_net_714, D2);
not inst867  (_net_715, D3);
not inst868  (_net_716, D4);
not inst869  (_net_717, D6);
not inst870  (_net_718, D7);
not inst871  (_net_719, SI);
and inst872  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_711, _net_712, _net_713, _net_714, _net_715, _net_716, D5, _net_717, _net_718, SE, _net_719);
not inst873  (_net_720, D0);
not inst874  (_net_721, CK);
not inst875  (_net_722, D1);
not inst876  (_net_723, D2);
not inst877  (_net_724, D3);
not inst878  (_net_725, D4);
not inst879  (_net_726, D6);
not inst880  (_net_727, D7);
and inst881  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_720, _net_721, _net_722, _net_723, _net_724, _net_725, D5, _net_726, _net_727, SE, SI);
not inst882  (_net_728, D0);
not inst883  (_net_729, CK);
not inst884  (_net_730, D1);
not inst885  (_net_731, D2);
not inst886  (_net_732, D3);
not inst887  (_net_733, D5);
not inst888  (_net_734, D6);
not inst889  (_net_735, D7);
not inst890  (_net_736, SE);
not inst891  (_net_737, SI);
and inst892  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_728, _net_729, _net_730, _net_731, _net_732, D4, _net_733, _net_734, _net_735, _net_736, _net_737);
not inst893  (_net_738, D0);
not inst894  (_net_739, CK);
not inst895  (_net_740, D1);
not inst896  (_net_741, D2);
not inst897  (_net_742, D3);
not inst898  (_net_743, D5);
not inst899  (_net_744, D6);
not inst900  (_net_745, D7);
not inst901  (_net_746, SE);
and inst902  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_738, _net_739, _net_740, _net_741, _net_742, D4, _net_743, _net_744, _net_745, _net_746, SI);
not inst903  (_net_747, D0);
not inst904  (_net_748, CK);
not inst905  (_net_749, D1);
not inst906  (_net_750, D2);
not inst907  (_net_751, D3);
not inst908  (_net_752, D5);
not inst909  (_net_753, D6);
not inst910  (_net_754, D7);
not inst911  (_net_755, SI);
and inst912  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_747, _net_748, _net_749, _net_750, _net_751, D4, _net_752, _net_753, _net_754, SE, _net_755);
not inst913  (_net_756, D0);
not inst914  (_net_757, CK);
not inst915  (_net_758, D1);
not inst916  (_net_759, D2);
not inst917  (_net_760, D3);
not inst918  (_net_761, D5);
not inst919  (_net_762, D6);
not inst920  (_net_763, D7);
and inst921  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_756, _net_757, _net_758, _net_759, _net_760, D4, _net_761, _net_762, _net_763, SE, SI);
not inst922  (_net_764, D0);
not inst923  (_net_765, CK);
not inst924  (_net_766, D1);
not inst925  (_net_767, D2);
not inst926  (_net_768, D3);
not inst927  (_net_769, SE);
not inst928  (_net_770, SI);
and inst929  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_764, _net_765, _net_766, _net_767, _net_768, D4, D5, D6, D7, _net_769, _net_770);
not inst930  (_net_771, D0);
not inst931  (_net_772, CK);
not inst932  (_net_773, D1);
not inst933  (_net_774, D2);
not inst934  (_net_775, D3);
not inst935  (_net_776, SE);
and inst936  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, _net_771, _net_772, _net_773, _net_774, _net_775, D4, D5, D6, D7, _net_776, SI);
not inst937  (_net_777, D0);
not inst938  (_net_778, CK);
not inst939  (_net_779, D1);
not inst940  (_net_780, D2);
not inst941  (_net_781, D3);
not inst942  (_net_782, SI);
and inst943  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, _net_777, _net_778, _net_779, _net_780, _net_781, D4, D5, D6, D7, SE, _net_782);
not inst944  (_net_783, D0);
not inst945  (_net_784, CK);
not inst946  (_net_785, D1);
not inst947  (_net_786, D2);
not inst948  (_net_787, D3);
and inst949  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, _net_783, _net_784, _net_785, _net_786, _net_787, D4, D5, D6, D7, SE, SI);
not inst950  (_net_788, D0);
not inst951  (_net_789, CK);
not inst952  (_net_790, D1);
not inst953  (_net_791, D2);
not inst954  (_net_792, D4);
not inst955  (_net_793, D5);
not inst956  (_net_794, D6);
not inst957  (_net_795, D7);
not inst958  (_net_796, SE);
not inst959  (_net_797, SI);
and inst960  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_788, _net_789, _net_790, _net_791, D3, _net_792, _net_793, _net_794, _net_795, _net_796, _net_797);
not inst961  (_net_798, D0);
not inst962  (_net_799, CK);
not inst963  (_net_800, D1);
not inst964  (_net_801, D2);
not inst965  (_net_802, D4);
not inst966  (_net_803, D5);
not inst967  (_net_804, D6);
not inst968  (_net_805, D7);
not inst969  (_net_806, SE);
and inst970  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_798, _net_799, _net_800, _net_801, D3, _net_802, _net_803, _net_804, _net_805, _net_806, SI);
not inst971  (_net_807, D0);
not inst972  (_net_808, CK);
not inst973  (_net_809, D1);
not inst974  (_net_810, D2);
not inst975  (_net_811, D4);
not inst976  (_net_812, D5);
not inst977  (_net_813, D6);
not inst978  (_net_814, D7);
not inst979  (_net_815, SI);
and inst980  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_807, _net_808, _net_809, _net_810, D3, _net_811, _net_812, _net_813, _net_814, SE, _net_815);
not inst981  (_net_816, D0);
not inst982  (_net_817, CK);
not inst983  (_net_818, D1);
not inst984  (_net_819, D2);
not inst985  (_net_820, D4);
not inst986  (_net_821, D5);
not inst987  (_net_822, D6);
not inst988  (_net_823, D7);
and inst989  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_816, _net_817, _net_818, _net_819, D3, _net_820, _net_821, _net_822, _net_823, SE, SI);
not inst990  (_net_824, D0);
not inst991  (_net_825, CK);
not inst992  (_net_826, D1);
not inst993  (_net_827, D3);
not inst994  (_net_828, D4);
not inst995  (_net_829, D5);
not inst996  (_net_830, D6);
not inst997  (_net_831, D7);
not inst998  (_net_832, SE);
not inst999  (_net_833, SI);
and inst1000  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_824, _net_825, _net_826, D2, _net_827, _net_828, _net_829, _net_830, _net_831, _net_832, _net_833);
not inst1001  (_net_834, D0);
not inst1002  (_net_835, CK);
not inst1003  (_net_836, D1);
not inst1004  (_net_837, D3);
not inst1005  (_net_838, D4);
not inst1006  (_net_839, D5);
not inst1007  (_net_840, D6);
not inst1008  (_net_841, D7);
not inst1009  (_net_842, SE);
and inst1010  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_834, _net_835, _net_836, D2, _net_837, _net_838, _net_839, _net_840, _net_841, _net_842, SI);
not inst1011  (_net_843, D0);
not inst1012  (_net_844, CK);
not inst1013  (_net_845, D1);
not inst1014  (_net_846, D3);
not inst1015  (_net_847, D4);
not inst1016  (_net_848, D5);
not inst1017  (_net_849, D6);
not inst1018  (_net_850, D7);
not inst1019  (_net_851, SI);
and inst1020  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_843, _net_844, _net_845, D2, _net_846, _net_847, _net_848, _net_849, _net_850, SE, _net_851);
not inst1021  (_net_852, D0);
not inst1022  (_net_853, CK);
not inst1023  (_net_854, D1);
not inst1024  (_net_855, D3);
not inst1025  (_net_856, D4);
not inst1026  (_net_857, D5);
not inst1027  (_net_858, D6);
not inst1028  (_net_859, D7);
and inst1029  (ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_852, _net_853, _net_854, D2, _net_855, _net_856, _net_857, _net_858, _net_859, SE, SI);
not inst1030  (_net_860, D0);
not inst1031  (_net_861, CK);
not inst1032  (_net_862, D2);
not inst1033  (_net_863, D3);
not inst1034  (_net_864, D4);
not inst1035  (_net_865, D5);
not inst1036  (_net_866, D6);
not inst1037  (_net_867, D7);
not inst1038  (_net_868, SE);
not inst1039  (_net_869, SI);
and inst1040  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_860, _net_861, D1, _net_862, _net_863, _net_864, _net_865, _net_866, _net_867, _net_868, _net_869);
not inst1041  (_net_870, D0);
not inst1042  (_net_871, CK);
not inst1043  (_net_872, D2);
not inst1044  (_net_873, D3);
not inst1045  (_net_874, D4);
not inst1046  (_net_875, D5);
not inst1047  (_net_876, D6);
not inst1048  (_net_877, D7);
not inst1049  (_net_878, SE);
and inst1050  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_870, _net_871, D1, _net_872, _net_873, _net_874, _net_875, _net_876, _net_877, _net_878, SI);
not inst1051  (_net_879, D0);
not inst1052  (_net_880, CK);
not inst1053  (_net_881, D2);
not inst1054  (_net_882, D3);
not inst1055  (_net_883, D4);
not inst1056  (_net_884, D5);
not inst1057  (_net_885, D6);
not inst1058  (_net_886, D7);
not inst1059  (_net_887, SI);
and inst1060  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_879, _net_880, D1, _net_881, _net_882, _net_883, _net_884, _net_885, _net_886, SE, _net_887);
not inst1061  (_net_888, D0);
not inst1062  (_net_889, CK);
not inst1063  (_net_890, D2);
not inst1064  (_net_891, D3);
not inst1065  (_net_892, D4);
not inst1066  (_net_893, D5);
not inst1067  (_net_894, D6);
not inst1068  (_net_895, D7);
and inst1069  (ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_888, _net_889, D1, _net_890, _net_891, _net_892, _net_893, _net_894, _net_895, SE, SI);
not inst1070  (_net_896, CK);
not inst1071  (_net_897, D1);
not inst1072  (_net_898, D2);
not inst1073  (_net_899, D3);
not inst1074  (_net_900, D4);
not inst1075  (_net_901, D5);
not inst1076  (_net_902, D6);
not inst1077  (_net_903, D7);
not inst1078  (_net_904, SE);
not inst1079  (_net_905, SI);
and inst1080  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, D0, _net_896, _net_897, _net_898, _net_899, _net_900, _net_901, _net_902, _net_903, _net_904, _net_905);
not inst1081  (_net_906, CK);
not inst1082  (_net_907, D1);
not inst1083  (_net_908, D2);
not inst1084  (_net_909, D3);
not inst1085  (_net_910, D4);
not inst1086  (_net_911, D5);
not inst1087  (_net_912, D6);
not inst1088  (_net_913, D7);
not inst1089  (_net_914, SE);
and inst1090  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, D0, _net_906, _net_907, _net_908, _net_909, _net_910, _net_911, _net_912, _net_913, _net_914, SI);
not inst1091  (_net_915, CK);
not inst1092  (_net_916, D1);
not inst1093  (_net_917, D2);
not inst1094  (_net_918, D3);
not inst1095  (_net_919, D4);
not inst1096  (_net_920, D5);
not inst1097  (_net_921, D6);
not inst1098  (_net_922, D7);
not inst1099  (_net_923, SI);
and inst1100  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, D0, _net_915, _net_916, _net_917, _net_918, _net_919, _net_920, _net_921, _net_922, SE, _net_923);
not inst1101  (_net_924, CK);
not inst1102  (_net_925, D1);
not inst1103  (_net_926, D2);
not inst1104  (_net_927, D3);
not inst1105  (_net_928, D4);
not inst1106  (_net_929, D5);
not inst1107  (_net_930, D6);
not inst1108  (_net_931, D7);
and inst1109  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, D0, _net_924, _net_925, _net_926, _net_927, _net_928, _net_929, _net_930, _net_931, SE, SI);
not inst1110  (_net_932, CK);
not inst1111  (_net_933, D1);
not inst1112  (_net_934, D2);
not inst1113  (_net_935, D3);
not inst1114  (_net_936, SE);
not inst1115  (_net_937, SI);
and inst1116  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D0, _net_932, _net_933, _net_934, _net_935, D4, D5, D6, D7, _net_936, _net_937);
not inst1117  (_net_938, CK);
not inst1118  (_net_939, D1);
not inst1119  (_net_940, D2);
not inst1120  (_net_941, D3);
not inst1121  (_net_942, SE);
and inst1122  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D0, _net_938, _net_939, _net_940, _net_941, D4, D5, D6, D7, _net_942, SI);
not inst1123  (_net_943, CK);
not inst1124  (_net_944, D1);
not inst1125  (_net_945, D2);
not inst1126  (_net_946, D3);
not inst1127  (_net_947, SI);
and inst1128  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D0, _net_943, _net_944, _net_945, _net_946, D4, D5, D6, D7, SE, _net_947);
not inst1129  (_net_948, CK);
not inst1130  (_net_949, D1);
not inst1131  (_net_950, D2);
not inst1132  (_net_951, D3);
and inst1133  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, D0, _net_948, _net_949, _net_950, _net_951, D4, D5, D6, D7, SE, SI);
not inst1134  (_net_952, CK);
not inst1135  (_net_953, D1);
not inst1136  (_net_954, D3);
not inst1137  (_net_955, D5);
not inst1138  (_net_956, D7);
not inst1139  (_net_957, SE);
not inst1140  (_net_958, SI);
and inst1141  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, D0, _net_952, _net_953, D2, _net_954, D4, _net_955, D6, _net_956, _net_957, _net_958);
not inst1142  (_net_959, CK);
not inst1143  (_net_960, D1);
not inst1144  (_net_961, D3);
not inst1145  (_net_962, D5);
not inst1146  (_net_963, D7);
not inst1147  (_net_964, SE);
and inst1148  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, D0, _net_959, _net_960, D2, _net_961, D4, _net_962, D6, _net_963, _net_964, SI);
not inst1149  (_net_965, CK);
not inst1150  (_net_966, D1);
not inst1151  (_net_967, D3);
not inst1152  (_net_968, D5);
not inst1153  (_net_969, D7);
not inst1154  (_net_970, SI);
and inst1155  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, D0, _net_965, _net_966, D2, _net_967, D4, _net_968, D6, _net_969, SE, _net_970);
not inst1156  (_net_971, CK);
not inst1157  (_net_972, D1);
not inst1158  (_net_973, D3);
not inst1159  (_net_974, D5);
not inst1160  (_net_975, D7);
and inst1161  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI, D0, _net_971, _net_972, D2, _net_973, D4, _net_974, D6, _net_975, SE, SI);
not inst1162  (_net_976, CK);
not inst1163  (_net_977, D1);
not inst1164  (_net_978, D3);
not inst1165  (_net_979, D5);
not inst1166  (_net_980, SE);
not inst1167  (_net_981, SI);
and inst1168  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D0, _net_976, _net_977, D2, _net_978, D4, _net_979, D6, D7, _net_980, _net_981);
not inst1169  (_net_982, CK);
not inst1170  (_net_983, D1);
not inst1171  (_net_984, D3);
not inst1172  (_net_985, D5);
not inst1173  (_net_986, SE);
and inst1174  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D0, _net_982, _net_983, D2, _net_984, D4, _net_985, D6, D7, _net_986, SI);
not inst1175  (_net_987, CK);
not inst1176  (_net_988, D1);
not inst1177  (_net_989, D3);
not inst1178  (_net_990, D5);
not inst1179  (_net_991, SI);
and inst1180  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D0, _net_987, _net_988, D2, _net_989, D4, _net_990, D6, D7, SE, _net_991);
not inst1181  (_net_992, CK);
not inst1182  (_net_993, D1);
not inst1183  (_net_994, D3);
not inst1184  (_net_995, D5);
and inst1185  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_SI, D0, _net_992, _net_993, D2, _net_994, D4, _net_995, D6, D7, SE, SI);
not inst1186  (_net_996, CK);
not inst1187  (_net_997, D1);
not inst1188  (_net_998, D3);
not inst1189  (_net_999, SE);
not inst1190  (_net_1000, SI);
and inst1191  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D0, _net_996, _net_997, D2, _net_998, D4, D5, D6, D7, _net_999, _net_1000);
not inst1192  (_net_1001, CK);
not inst1193  (_net_1002, D1);
not inst1194  (_net_1003, D3);
not inst1195  (_net_1004, SE);
and inst1196  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D0, _net_1001, _net_1002, D2, _net_1003, D4, D5, D6, D7, _net_1004, SI);
not inst1197  (_net_1005, CK);
not inst1198  (_net_1006, D1);
not inst1199  (_net_1007, D3);
not inst1200  (_net_1008, SI);
and inst1201  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D0, _net_1005, _net_1006, D2, _net_1007, D4, D5, D6, D7, SE, _net_1008);
not inst1202  (_net_1009, CK);
not inst1203  (_net_1010, D1);
not inst1204  (_net_1011, D3);
and inst1205  (ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, D0, _net_1009, _net_1010, D2, _net_1011, D4, D5, D6, D7, SE, SI);
not inst1206  (_net_1012, CK);
not inst1207  (_net_1013, SE);
not inst1208  (_net_1014, SI);
and inst1209  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D0, _net_1012, D1, D2, D3, D4, D5, D6, D7, _net_1013, _net_1014);
not inst1210  (_net_1015, CK);
not inst1211  (_net_1016, SE);
and inst1212  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D0, _net_1015, D1, D2, D3, D4, D5, D6, D7, _net_1016, SI);
not inst1213  (_net_1017, CK);
not inst1214  (_net_1018, SI);
and inst1215  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D0, _net_1017, D1, D2, D3, D4, D5, D6, D7, SE, _net_1018);
not inst1216  (_net_1019, CK);
and inst1217  (ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, D0, _net_1019, D1, D2, D3, D4, D5, D6, D7, SE, SI);
not inst1218  (_net_1020, D0);
not inst1219  (_net_1021, D1);
not inst1220  (_net_1022, D2);
not inst1221  (_net_1023, D3);
not inst1222  (_net_1024, D4);
not inst1223  (_net_1025, D5);
not inst1224  (_net_1026, D6);
not inst1225  (_net_1027, D7);
not inst1226  (_net_1028, SE);
not inst1227  (_net_1029, SI);
and inst1228  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_1020, CK, _net_1021, _net_1022, _net_1023, _net_1024, _net_1025, _net_1026, _net_1027, _net_1028, _net_1029);
not inst1229  (_net_1030, D0);
not inst1230  (_net_1031, D1);
not inst1231  (_net_1032, D2);
not inst1232  (_net_1033, D3);
not inst1233  (_net_1034, D4);
not inst1234  (_net_1035, D5);
not inst1235  (_net_1036, D6);
not inst1236  (_net_1037, D7);
not inst1237  (_net_1038, SE);
and inst1238  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_1030, CK, _net_1031, _net_1032, _net_1033, _net_1034, _net_1035, _net_1036, _net_1037, _net_1038, SI);
not inst1239  (_net_1039, D0);
not inst1240  (_net_1040, D1);
not inst1241  (_net_1041, D2);
not inst1242  (_net_1042, D3);
not inst1243  (_net_1043, D4);
not inst1244  (_net_1044, D5);
not inst1245  (_net_1045, D6);
not inst1246  (_net_1046, D7);
not inst1247  (_net_1047, SI);
and inst1248  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_1039, CK, _net_1040, _net_1041, _net_1042, _net_1043, _net_1044, _net_1045, _net_1046, SE, _net_1047);
not inst1249  (_net_1048, D0);
not inst1250  (_net_1049, D1);
not inst1251  (_net_1050, D2);
not inst1252  (_net_1051, D3);
not inst1253  (_net_1052, D4);
not inst1254  (_net_1053, D5);
not inst1255  (_net_1054, D6);
not inst1256  (_net_1055, D7);
and inst1257  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_1048, CK, _net_1049, _net_1050, _net_1051, _net_1052, _net_1053, _net_1054, _net_1055, SE, SI);
not inst1258  (_net_1056, D0);
not inst1259  (_net_1057, D1);
not inst1260  (_net_1058, D2);
not inst1261  (_net_1059, D3);
not inst1262  (_net_1060, D4);
not inst1263  (_net_1061, D5);
not inst1264  (_net_1062, D6);
not inst1265  (_net_1063, SE);
not inst1266  (_net_1064, SI);
and inst1267  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_1056, CK, _net_1057, _net_1058, _net_1059, _net_1060, _net_1061, _net_1062, D7, _net_1063, _net_1064);
not inst1268  (_net_1065, D0);
not inst1269  (_net_1066, D1);
not inst1270  (_net_1067, D2);
not inst1271  (_net_1068, D3);
not inst1272  (_net_1069, D4);
not inst1273  (_net_1070, D5);
not inst1274  (_net_1071, D6);
not inst1275  (_net_1072, SE);
and inst1276  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI, _net_1065, CK, _net_1066, _net_1067, _net_1068, _net_1069, _net_1070, _net_1071, D7, _net_1072, SI);
not inst1277  (_net_1073, D0);
not inst1278  (_net_1074, D1);
not inst1279  (_net_1075, D2);
not inst1280  (_net_1076, D3);
not inst1281  (_net_1077, D4);
not inst1282  (_net_1078, D5);
not inst1283  (_net_1079, D6);
not inst1284  (_net_1080, SI);
and inst1285  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_NOT_SI, _net_1073, CK, _net_1074, _net_1075, _net_1076, _net_1077, _net_1078, _net_1079, D7, SE, _net_1080);
not inst1286  (_net_1081, D0);
not inst1287  (_net_1082, D1);
not inst1288  (_net_1083, D2);
not inst1289  (_net_1084, D3);
not inst1290  (_net_1085, D4);
not inst1291  (_net_1086, D5);
not inst1292  (_net_1087, D6);
and inst1293  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI, _net_1081, CK, _net_1082, _net_1083, _net_1084, _net_1085, _net_1086, _net_1087, D7, SE, SI);
not inst1294  (_net_1088, D0);
not inst1295  (_net_1089, D1);
not inst1296  (_net_1090, D2);
not inst1297  (_net_1091, D3);
not inst1298  (_net_1092, D4);
not inst1299  (_net_1093, D5);
not inst1300  (_net_1094, D7);
not inst1301  (_net_1095, SE);
not inst1302  (_net_1096, SI);
and inst1303  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_1088, CK, _net_1089, _net_1090, _net_1091, _net_1092, _net_1093, D6, _net_1094, _net_1095, _net_1096);
not inst1304  (_net_1097, D0);
not inst1305  (_net_1098, D1);
not inst1306  (_net_1099, D2);
not inst1307  (_net_1100, D3);
not inst1308  (_net_1101, D4);
not inst1309  (_net_1102, D5);
not inst1310  (_net_1103, D7);
not inst1311  (_net_1104, SE);
and inst1312  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_1097, CK, _net_1098, _net_1099, _net_1100, _net_1101, _net_1102, D6, _net_1103, _net_1104, SI);
not inst1313  (_net_1105, D0);
not inst1314  (_net_1106, D1);
not inst1315  (_net_1107, D2);
not inst1316  (_net_1108, D3);
not inst1317  (_net_1109, D4);
not inst1318  (_net_1110, D5);
not inst1319  (_net_1111, D7);
not inst1320  (_net_1112, SI);
and inst1321  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_1105, CK, _net_1106, _net_1107, _net_1108, _net_1109, _net_1110, D6, _net_1111, SE, _net_1112);
not inst1322  (_net_1113, D0);
not inst1323  (_net_1114, D1);
not inst1324  (_net_1115, D2);
not inst1325  (_net_1116, D3);
not inst1326  (_net_1117, D4);
not inst1327  (_net_1118, D5);
not inst1328  (_net_1119, D7);
and inst1329  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI, _net_1113, CK, _net_1114, _net_1115, _net_1116, _net_1117, _net_1118, D6, _net_1119, SE, SI);
not inst1330  (_net_1120, D0);
not inst1331  (_net_1121, D1);
not inst1332  (_net_1122, D2);
not inst1333  (_net_1123, D3);
not inst1334  (_net_1124, D4);
not inst1335  (_net_1125, D6);
not inst1336  (_net_1126, D7);
not inst1337  (_net_1127, SE);
not inst1338  (_net_1128, SI);
and inst1339  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_1120, CK, _net_1121, _net_1122, _net_1123, _net_1124, D5, _net_1125, _net_1126, _net_1127, _net_1128);
not inst1340  (_net_1129, D0);
not inst1341  (_net_1130, D1);
not inst1342  (_net_1131, D2);
not inst1343  (_net_1132, D3);
not inst1344  (_net_1133, D4);
not inst1345  (_net_1134, D6);
not inst1346  (_net_1135, D7);
not inst1347  (_net_1136, SE);
and inst1348  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_1129, CK, _net_1130, _net_1131, _net_1132, _net_1133, D5, _net_1134, _net_1135, _net_1136, SI);
not inst1349  (_net_1137, D0);
not inst1350  (_net_1138, D1);
not inst1351  (_net_1139, D2);
not inst1352  (_net_1140, D3);
not inst1353  (_net_1141, D4);
not inst1354  (_net_1142, D6);
not inst1355  (_net_1143, D7);
not inst1356  (_net_1144, SI);
and inst1357  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_1137, CK, _net_1138, _net_1139, _net_1140, _net_1141, D5, _net_1142, _net_1143, SE, _net_1144);
not inst1358  (_net_1145, D0);
not inst1359  (_net_1146, D1);
not inst1360  (_net_1147, D2);
not inst1361  (_net_1148, D3);
not inst1362  (_net_1149, D4);
not inst1363  (_net_1150, D6);
not inst1364  (_net_1151, D7);
and inst1365  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_1145, CK, _net_1146, _net_1147, _net_1148, _net_1149, D5, _net_1150, _net_1151, SE, SI);
not inst1366  (_net_1152, D0);
not inst1367  (_net_1153, D1);
not inst1368  (_net_1154, D2);
not inst1369  (_net_1155, D3);
not inst1370  (_net_1156, D5);
not inst1371  (_net_1157, D6);
not inst1372  (_net_1158, D7);
not inst1373  (_net_1159, SE);
not inst1374  (_net_1160, SI);
and inst1375  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_1152, CK, _net_1153, _net_1154, _net_1155, D4, _net_1156, _net_1157, _net_1158, _net_1159, _net_1160);
not inst1376  (_net_1161, D0);
not inst1377  (_net_1162, D1);
not inst1378  (_net_1163, D2);
not inst1379  (_net_1164, D3);
not inst1380  (_net_1165, D5);
not inst1381  (_net_1166, D6);
not inst1382  (_net_1167, D7);
not inst1383  (_net_1168, SE);
and inst1384  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_1161, CK, _net_1162, _net_1163, _net_1164, D4, _net_1165, _net_1166, _net_1167, _net_1168, SI);
not inst1385  (_net_1169, D0);
not inst1386  (_net_1170, D1);
not inst1387  (_net_1171, D2);
not inst1388  (_net_1172, D3);
not inst1389  (_net_1173, D5);
not inst1390  (_net_1174, D6);
not inst1391  (_net_1175, D7);
not inst1392  (_net_1176, SI);
and inst1393  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_1169, CK, _net_1170, _net_1171, _net_1172, D4, _net_1173, _net_1174, _net_1175, SE, _net_1176);
not inst1394  (_net_1177, D0);
not inst1395  (_net_1178, D1);
not inst1396  (_net_1179, D2);
not inst1397  (_net_1180, D3);
not inst1398  (_net_1181, D5);
not inst1399  (_net_1182, D6);
not inst1400  (_net_1183, D7);
and inst1401  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_1177, CK, _net_1178, _net_1179, _net_1180, D4, _net_1181, _net_1182, _net_1183, SE, SI);
not inst1402  (_net_1184, D0);
not inst1403  (_net_1185, D1);
not inst1404  (_net_1186, D2);
not inst1405  (_net_1187, D3);
not inst1406  (_net_1188, SE);
not inst1407  (_net_1189, SI);
and inst1408  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, _net_1184, CK, _net_1185, _net_1186, _net_1187, D4, D5, D6, D7, _net_1188, _net_1189);
not inst1409  (_net_1190, D0);
not inst1410  (_net_1191, D1);
not inst1411  (_net_1192, D2);
not inst1412  (_net_1193, D3);
not inst1413  (_net_1194, SE);
and inst1414  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, _net_1190, CK, _net_1191, _net_1192, _net_1193, D4, D5, D6, D7, _net_1194, SI);
not inst1415  (_net_1195, D0);
not inst1416  (_net_1196, D1);
not inst1417  (_net_1197, D2);
not inst1418  (_net_1198, D3);
not inst1419  (_net_1199, SI);
and inst1420  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, _net_1195, CK, _net_1196, _net_1197, _net_1198, D4, D5, D6, D7, SE, _net_1199);
not inst1421  (_net_1200, D0);
not inst1422  (_net_1201, D1);
not inst1423  (_net_1202, D2);
not inst1424  (_net_1203, D3);
and inst1425  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, _net_1200, CK, _net_1201, _net_1202, _net_1203, D4, D5, D6, D7, SE, SI);
not inst1426  (_net_1204, D0);
not inst1427  (_net_1205, D1);
not inst1428  (_net_1206, D2);
not inst1429  (_net_1207, D4);
not inst1430  (_net_1208, D5);
not inst1431  (_net_1209, D6);
not inst1432  (_net_1210, D7);
not inst1433  (_net_1211, SE);
not inst1434  (_net_1212, SI);
and inst1435  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_1204, CK, _net_1205, _net_1206, D3, _net_1207, _net_1208, _net_1209, _net_1210, _net_1211, _net_1212);
not inst1436  (_net_1213, D0);
not inst1437  (_net_1214, D1);
not inst1438  (_net_1215, D2);
not inst1439  (_net_1216, D4);
not inst1440  (_net_1217, D5);
not inst1441  (_net_1218, D6);
not inst1442  (_net_1219, D7);
not inst1443  (_net_1220, SE);
and inst1444  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_1213, CK, _net_1214, _net_1215, D3, _net_1216, _net_1217, _net_1218, _net_1219, _net_1220, SI);
not inst1445  (_net_1221, D0);
not inst1446  (_net_1222, D1);
not inst1447  (_net_1223, D2);
not inst1448  (_net_1224, D4);
not inst1449  (_net_1225, D5);
not inst1450  (_net_1226, D6);
not inst1451  (_net_1227, D7);
not inst1452  (_net_1228, SI);
and inst1453  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_1221, CK, _net_1222, _net_1223, D3, _net_1224, _net_1225, _net_1226, _net_1227, SE, _net_1228);
not inst1454  (_net_1229, D0);
not inst1455  (_net_1230, D1);
not inst1456  (_net_1231, D2);
not inst1457  (_net_1232, D4);
not inst1458  (_net_1233, D5);
not inst1459  (_net_1234, D6);
not inst1460  (_net_1235, D7);
and inst1461  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_1229, CK, _net_1230, _net_1231, D3, _net_1232, _net_1233, _net_1234, _net_1235, SE, SI);
not inst1462  (_net_1236, D0);
not inst1463  (_net_1237, D1);
not inst1464  (_net_1238, D3);
not inst1465  (_net_1239, D4);
not inst1466  (_net_1240, D5);
not inst1467  (_net_1241, D6);
not inst1468  (_net_1242, D7);
not inst1469  (_net_1243, SE);
not inst1470  (_net_1244, SI);
and inst1471  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_1236, CK, _net_1237, D2, _net_1238, _net_1239, _net_1240, _net_1241, _net_1242, _net_1243, _net_1244);
not inst1472  (_net_1245, D0);
not inst1473  (_net_1246, D1);
not inst1474  (_net_1247, D3);
not inst1475  (_net_1248, D4);
not inst1476  (_net_1249, D5);
not inst1477  (_net_1250, D6);
not inst1478  (_net_1251, D7);
not inst1479  (_net_1252, SE);
and inst1480  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_1245, CK, _net_1246, D2, _net_1247, _net_1248, _net_1249, _net_1250, _net_1251, _net_1252, SI);
not inst1481  (_net_1253, D0);
not inst1482  (_net_1254, D1);
not inst1483  (_net_1255, D3);
not inst1484  (_net_1256, D4);
not inst1485  (_net_1257, D5);
not inst1486  (_net_1258, D6);
not inst1487  (_net_1259, D7);
not inst1488  (_net_1260, SI);
and inst1489  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_1253, CK, _net_1254, D2, _net_1255, _net_1256, _net_1257, _net_1258, _net_1259, SE, _net_1260);
not inst1490  (_net_1261, D0);
not inst1491  (_net_1262, D1);
not inst1492  (_net_1263, D3);
not inst1493  (_net_1264, D4);
not inst1494  (_net_1265, D5);
not inst1495  (_net_1266, D6);
not inst1496  (_net_1267, D7);
and inst1497  (ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_1261, CK, _net_1262, D2, _net_1263, _net_1264, _net_1265, _net_1266, _net_1267, SE, SI);
not inst1498  (_net_1268, D0);
not inst1499  (_net_1269, D2);
not inst1500  (_net_1270, D3);
not inst1501  (_net_1271, D4);
not inst1502  (_net_1272, D5);
not inst1503  (_net_1273, D6);
not inst1504  (_net_1274, D7);
not inst1505  (_net_1275, SE);
not inst1506  (_net_1276, SI);
and inst1507  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_1268, CK, D1, _net_1269, _net_1270, _net_1271, _net_1272, _net_1273, _net_1274, _net_1275, _net_1276);
not inst1508  (_net_1277, D0);
not inst1509  (_net_1278, D2);
not inst1510  (_net_1279, D3);
not inst1511  (_net_1280, D4);
not inst1512  (_net_1281, D5);
not inst1513  (_net_1282, D6);
not inst1514  (_net_1283, D7);
not inst1515  (_net_1284, SE);
and inst1516  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_1277, CK, D1, _net_1278, _net_1279, _net_1280, _net_1281, _net_1282, _net_1283, _net_1284, SI);
not inst1517  (_net_1285, D0);
not inst1518  (_net_1286, D2);
not inst1519  (_net_1287, D3);
not inst1520  (_net_1288, D4);
not inst1521  (_net_1289, D5);
not inst1522  (_net_1290, D6);
not inst1523  (_net_1291, D7);
not inst1524  (_net_1292, SI);
and inst1525  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, _net_1285, CK, D1, _net_1286, _net_1287, _net_1288, _net_1289, _net_1290, _net_1291, SE, _net_1292);
not inst1526  (_net_1293, D0);
not inst1527  (_net_1294, D2);
not inst1528  (_net_1295, D3);
not inst1529  (_net_1296, D4);
not inst1530  (_net_1297, D5);
not inst1531  (_net_1298, D6);
not inst1532  (_net_1299, D7);
and inst1533  (ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, _net_1293, CK, D1, _net_1294, _net_1295, _net_1296, _net_1297, _net_1298, _net_1299, SE, SI);
not inst1534  (_net_1300, D1);
not inst1535  (_net_1301, D2);
not inst1536  (_net_1302, D3);
not inst1537  (_net_1303, D4);
not inst1538  (_net_1304, D5);
not inst1539  (_net_1305, D6);
not inst1540  (_net_1306, D7);
not inst1541  (_net_1307, SE);
not inst1542  (_net_1308, SI);
and inst1543  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_1300, _net_1301, _net_1302, _net_1303, _net_1304, _net_1305, _net_1306, _net_1307, _net_1308);
not inst1544  (_net_1309, D1);
not inst1545  (_net_1310, D2);
not inst1546  (_net_1311, D3);
not inst1547  (_net_1312, D4);
not inst1548  (_net_1313, D5);
not inst1549  (_net_1314, D6);
not inst1550  (_net_1315, D7);
not inst1551  (_net_1316, SE);
and inst1552  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, D0, CK, _net_1309, _net_1310, _net_1311, _net_1312, _net_1313, _net_1314, _net_1315, _net_1316, SI);
not inst1553  (_net_1317, D1);
not inst1554  (_net_1318, D2);
not inst1555  (_net_1319, D3);
not inst1556  (_net_1320, D4);
not inst1557  (_net_1321, D5);
not inst1558  (_net_1322, D6);
not inst1559  (_net_1323, D7);
not inst1560  (_net_1324, SI);
and inst1561  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, D0, CK, _net_1317, _net_1318, _net_1319, _net_1320, _net_1321, _net_1322, _net_1323, SE, _net_1324);
not inst1562  (_net_1325, D1);
not inst1563  (_net_1326, D2);
not inst1564  (_net_1327, D3);
not inst1565  (_net_1328, D4);
not inst1566  (_net_1329, D5);
not inst1567  (_net_1330, D6);
not inst1568  (_net_1331, D7);
and inst1569  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI, D0, CK, _net_1325, _net_1326, _net_1327, _net_1328, _net_1329, _net_1330, _net_1331, SE, SI);
not inst1570  (_net_1332, D1);
not inst1571  (_net_1333, D2);
not inst1572  (_net_1334, D3);
not inst1573  (_net_1335, SE);
not inst1574  (_net_1336, SI);
and inst1575  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_1332, _net_1333, _net_1334, D4, D5, D6, D7, _net_1335, _net_1336);
not inst1576  (_net_1337, D1);
not inst1577  (_net_1338, D2);
not inst1578  (_net_1339, D3);
not inst1579  (_net_1340, SE);
and inst1580  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D0, CK, _net_1337, _net_1338, _net_1339, D4, D5, D6, D7, _net_1340, SI);
not inst1581  (_net_1341, D1);
not inst1582  (_net_1342, D2);
not inst1583  (_net_1343, D3);
not inst1584  (_net_1344, SI);
and inst1585  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D0, CK, _net_1341, _net_1342, _net_1343, D4, D5, D6, D7, SE, _net_1344);
not inst1586  (_net_1345, D1);
not inst1587  (_net_1346, D2);
not inst1588  (_net_1347, D3);
and inst1589  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, D0, CK, _net_1345, _net_1346, _net_1347, D4, D5, D6, D7, SE, SI);
not inst1590  (_net_1348, D1);
not inst1591  (_net_1349, D3);
not inst1592  (_net_1350, D5);
not inst1593  (_net_1351, D7);
not inst1594  (_net_1352, SE);
not inst1595  (_net_1353, SI);
and inst1596  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_1348, D2, _net_1349, D4, _net_1350, D6, _net_1351, _net_1352, _net_1353);
not inst1597  (_net_1354, D1);
not inst1598  (_net_1355, D3);
not inst1599  (_net_1356, D5);
not inst1600  (_net_1357, D7);
not inst1601  (_net_1358, SE);
and inst1602  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, D0, CK, _net_1354, D2, _net_1355, D4, _net_1356, D6, _net_1357, _net_1358, SI);
not inst1603  (_net_1359, D1);
not inst1604  (_net_1360, D3);
not inst1605  (_net_1361, D5);
not inst1606  (_net_1362, D7);
not inst1607  (_net_1363, SI);
and inst1608  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI, D0, CK, _net_1359, D2, _net_1360, D4, _net_1361, D6, _net_1362, SE, _net_1363);
not inst1609  (_net_1364, D1);
not inst1610  (_net_1365, D3);
not inst1611  (_net_1366, D5);
not inst1612  (_net_1367, D7);
and inst1613  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI, D0, CK, _net_1364, D2, _net_1365, D4, _net_1366, D6, _net_1367, SE, SI);
not inst1614  (_net_1368, D1);
not inst1615  (_net_1369, D3);
not inst1616  (_net_1370, D5);
not inst1617  (_net_1371, SE);
not inst1618  (_net_1372, SI);
and inst1619  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_1368, D2, _net_1369, D4, _net_1370, D6, D7, _net_1371, _net_1372);
not inst1620  (_net_1373, D1);
not inst1621  (_net_1374, D3);
not inst1622  (_net_1375, D5);
not inst1623  (_net_1376, SE);
and inst1624  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D0, CK, _net_1373, D2, _net_1374, D4, _net_1375, D6, D7, _net_1376, SI);
not inst1625  (_net_1377, D1);
not inst1626  (_net_1378, D3);
not inst1627  (_net_1379, D5);
not inst1628  (_net_1380, SI);
and inst1629  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D0, CK, _net_1377, D2, _net_1378, D4, _net_1379, D6, D7, SE, _net_1380);
not inst1630  (_net_1381, D1);
not inst1631  (_net_1382, D3);
not inst1632  (_net_1383, D5);
and inst1633  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_SI, D0, CK, _net_1381, D2, _net_1382, D4, _net_1383, D6, D7, SE, SI);
not inst1634  (_net_1384, D1);
not inst1635  (_net_1385, D3);
not inst1636  (_net_1386, SE);
not inst1637  (_net_1387, SI);
and inst1638  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D0, CK, _net_1384, D2, _net_1385, D4, D5, D6, D7, _net_1386, _net_1387);
not inst1639  (_net_1388, D1);
not inst1640  (_net_1389, D3);
not inst1641  (_net_1390, SE);
and inst1642  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D0, CK, _net_1388, D2, _net_1389, D4, D5, D6, D7, _net_1390, SI);
not inst1643  (_net_1391, D1);
not inst1644  (_net_1392, D3);
not inst1645  (_net_1393, SI);
and inst1646  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D0, CK, _net_1391, D2, _net_1392, D4, D5, D6, D7, SE, _net_1393);
not inst1647  (_net_1394, D1);
not inst1648  (_net_1395, D3);
and inst1649  (ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, D0, CK, _net_1394, D2, _net_1395, D4, D5, D6, D7, SE, SI);
not inst1650  (_net_1396, SE);
not inst1651  (_net_1397, SI);
and inst1652  (ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI, D0, CK, D1, D2, D3, D4, D5, D6, D7, _net_1396, _net_1397);
not inst1653  (_net_1398, SE);
and inst1654  (ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI, D0, CK, D1, D2, D3, D4, D5, D6, D7, _net_1398, SI);
not inst1655  (_net_1399, SI);
and inst1656  (ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI, D0, CK, D1, D2, D3, D4, D5, D6, D7, SE, _net_1399);
and inst1657  (ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI, D0, CK, D1, D2, D3, D4, D5, D6, D7, SE, SI);
not inst1658  (_net_1400, D1);
not inst1659  (_net_1401, D0);
not inst1660  (_net_1402, D2);
not inst1661  (_net_1403, D3);
not inst1662  (_net_1404, D4);
not inst1663  (_net_1405, D5);
not inst1664  (_net_1406, D6);
not inst1665  (_net_1407, D7);
and inst1666  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI, _net_1400, _net_1401, _net_1402, _net_1403, _net_1404, _net_1405, _net_1406, _net_1407, RD, SI);
not inst1667  (_net_1408, D1);
not inst1668  (_net_1409, D0);
not inst1669  (_net_1410, D2);
not inst1670  (_net_1411, D3);
not inst1671  (_net_1412, D4);
not inst1672  (_net_1413, D5);
not inst1673  (_net_1414, D6);
not inst1674  (_net_1415, SI);
and inst1675  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI, _net_1408, _net_1409, _net_1410, _net_1411, _net_1412, _net_1413, _net_1414, D7, RD, _net_1415);
not inst1676  (_net_1416, D1);
not inst1677  (_net_1417, D0);
not inst1678  (_net_1418, D2);
not inst1679  (_net_1419, D3);
not inst1680  (_net_1420, D4);
not inst1681  (_net_1421, D5);
not inst1682  (_net_1422, D7);
not inst1683  (_net_1423, SI);
and inst1684  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_1416, _net_1417, _net_1418, _net_1419, _net_1420, _net_1421, D6, _net_1422, RD, _net_1423);
not inst1685  (_net_1424, D1);
not inst1686  (_net_1425, D0);
not inst1687  (_net_1426, D2);
not inst1688  (_net_1427, D3);
not inst1689  (_net_1428, D4);
not inst1690  (_net_1429, D6);
not inst1691  (_net_1430, D7);
not inst1692  (_net_1431, SI);
and inst1693  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_1424, _net_1425, _net_1426, _net_1427, _net_1428, D5, _net_1429, _net_1430, RD, _net_1431);
not inst1694  (_net_1432, D1);
not inst1695  (_net_1433, D0);
not inst1696  (_net_1434, D2);
not inst1697  (_net_1435, D3);
not inst1698  (_net_1436, D5);
not inst1699  (_net_1437, D6);
not inst1700  (_net_1438, D7);
not inst1701  (_net_1439, SI);
and inst1702  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_1432, _net_1433, _net_1434, _net_1435, D4, _net_1436, _net_1437, _net_1438, RD, _net_1439);
not inst1703  (_net_1440, D1);
not inst1704  (_net_1441, D0);
not inst1705  (_net_1442, D2);
not inst1706  (_net_1443, D4);
not inst1707  (_net_1444, D5);
not inst1708  (_net_1445, D6);
not inst1709  (_net_1446, D7);
not inst1710  (_net_1447, SI);
and inst1711  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_1440, _net_1441, _net_1442, D3, _net_1443, _net_1444, _net_1445, _net_1446, RD, _net_1447);
not inst1712  (_net_1448, D1);
not inst1713  (_net_1449, D0);
not inst1714  (_net_1450, D3);
not inst1715  (_net_1451, D4);
not inst1716  (_net_1452, D5);
not inst1717  (_net_1453, D6);
not inst1718  (_net_1454, D7);
not inst1719  (_net_1455, SI);
and inst1720  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_1448, _net_1449, D2, _net_1450, _net_1451, _net_1452, _net_1453, _net_1454, RD, _net_1455);
not inst1721  (_net_1456, D0);
not inst1722  (_net_1457, D2);
not inst1723  (_net_1458, D3);
not inst1724  (_net_1459, D4);
not inst1725  (_net_1460, D5);
not inst1726  (_net_1461, D6);
not inst1727  (_net_1462, D7);
not inst1728  (_net_1463, SI);
and inst1729  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, D1, _net_1456, _net_1457, _net_1458, _net_1459, _net_1460, _net_1461, _net_1462, RD, _net_1463);
not inst1730  (_net_1464, D1);
not inst1731  (_net_1465, D2);
not inst1732  (_net_1466, D3);
not inst1733  (_net_1467, D4);
not inst1734  (_net_1468, D5);
not inst1735  (_net_1469, D6);
not inst1736  (_net_1470, D7);
not inst1737  (_net_1471, SI);
and inst1738  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_1464, D0, _net_1465, _net_1466, _net_1467, _net_1468, _net_1469, _net_1470, RD, _net_1471);
not inst1739  (_net_1472, D0);
and inst1740  (ENABLE_NOT_D0_AND_RD_AND_SE, RD, _net_1472, SE);
and inst1741  (ENABLE_D0_AND_RD_AND_SE, RD, D0, SE);
not inst1742  (_net_1473, SE);
not inst1743  (_net_1474, SI);
and inst1744  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_1473, RD, _net_1474);
not inst1745  (_net_1475, SE);
and inst1746  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_1475, RD, SI);

`ifdef FORMALITY 
`else 
   always@(viol_all) begin
      viol_0 = (viol_0 !== viol_all) ? viol_all : ~viol_0;
      viol_1 = (viol_1 !== viol_all) ? viol_all : ~viol_1;
      viol_2 = (viol_2 !== viol_all) ? viol_all : ~viol_2;
      viol_3 = (viol_3 !== viol_all) ? viol_all : ~viol_3;
      viol_4 = (viol_4 !== viol_all) ? viol_all : ~viol_4;
      viol_5 = (viol_5 !== viol_all) ? viol_all : ~viol_5;
      viol_6 = (viol_6 !== viol_all) ? viol_all : ~viol_6;
      viol_7 = (viol_7 !== viol_all) ? viol_all : ~viol_7;
   end 
`endif 
specify
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b0&&D0==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q0 +: 1'b0))=(0, 0);
if (CK==1'b1&&D0==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q0 +: 1'b0))=(0, 0);
(negedge RD => (Q0 : 1'b0))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b0&&D1==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q1 +: 1'b0))=(0, 0);
if (CK==1'b1&&D1==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q1 +: 1'b0))=(0, 0);
(negedge RD => (Q1 : 1'b0))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (CK==1'b0&&D2==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b0&&D2==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q2 +: 1'b0))=(0, 0);
if (CK==1'b1&&D2==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q2 +: 1'b0))=(0, 0);
(negedge RD => (Q2 : 1'b0))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
if (CK==1'b0&&D3==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b0&&D3==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q3 +: 1'b0))=(0, 0);
if (CK==1'b1&&D3==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q3 +: 1'b0))=(0, 0);
(negedge RD => (Q3 : 1'b0))=(0, 0);
if (D4==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
(posedge CK => (Q4 : 1'b1))=(0, 0);
if (CK==1'b0&&D4==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b0&&D4==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b0&&D4==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b0&&D4==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b0&&D4==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b0&&D4==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b0&&D4==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b0&&D4==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b1&&D4==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b1&&D4==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b1&&D4==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b1&&D4==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b1&&D4==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b1&&D4==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b1&&D4==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q4 +: 1'b0))=(0, 0);
if (CK==1'b1&&D4==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q4 +: 1'b0))=(0, 0);
(negedge RD => (Q4 : 1'b0))=(0, 0);
if (D5==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
(posedge CK => (Q5 : 1'b1))=(0, 0);
if (CK==1'b0&&D5==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b0&&D5==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b0&&D5==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b0&&D5==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b0&&D5==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b0&&D5==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b0&&D5==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b0&&D5==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b1&&D5==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b1&&D5==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b1&&D5==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b1&&D5==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b1&&D5==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b1&&D5==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b1&&D5==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q5 +: 1'b0))=(0, 0);
if (CK==1'b1&&D5==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q5 +: 1'b0))=(0, 0);
(negedge RD => (Q5 : 1'b0))=(0, 0);
if (D6==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
(posedge CK => (Q6 : 1'b1))=(0, 0);
if (CK==1'b0&&D6==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b0&&D6==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b0&&D6==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b0&&D6==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b0&&D6==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b0&&D6==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b0&&D6==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b0&&D6==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b1&&D6==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b1&&D6==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b1&&D6==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b1&&D6==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b1&&D6==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b1&&D6==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b1&&D6==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q6 +: 1'b0))=(0, 0);
if (CK==1'b1&&D6==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q6 +: 1'b0))=(0, 0);
(negedge RD => (Q6 : 1'b0))=(0, 0);
if (D7==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
(posedge CK => (Q7 : 1'b1))=(0, 0);
if (CK==1'b0&&D7==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b0&&D7==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b0&&D7==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b0&&D7==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b0&&D7==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b0&&D7==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b0&&D7==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b0&&D7==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b1&&D7==1'b0&&SE==1'b0&&SI==1'b0) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b1&&D7==1'b0&&SE==1'b0&&SI==1'b1) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b1&&D7==1'b0&&SE==1'b1&&SI==1'b0) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b1&&D7==1'b0&&SE==1'b1&&SI==1'b1) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b1&&D7==1'b1&&SE==1'b0&&SI==1'b0) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b1&&D7==1'b1&&SE==1'b0&&SI==1'b1) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b1&&D7==1'b1&&SE==1'b1&&SI==1'b0) (negedge RD => (Q7 +: 1'b0))=(0, 0);
if (CK==1'b1&&D7==1'b1&&SE==1'b1&&SI==1'b1) (negedge RD => (Q7 +: 1'b0))=(0, 0);
(negedge RD => (Q7 : 1'b0))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_all);
$width(posedge CK , 0 ,0, viol_all);
$width(negedge CK , 0 ,0, viol_all);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_NOT_SI , 0 ,0, viol_all);
$width(negedge RD &&& ENABLE_CK_AND_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_SE_AND_SI , 0 ,0, viol_all);
$recrem(posedge RD , posedge CK , 0 ,0, viol_all, , , delayed_RD, delayed_CK);
$width(negedge RD , 0 ,0, viol_all);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_all, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_1, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_2, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_3, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D4 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_4, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D4 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_4, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D4 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_4, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D4 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_4, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D5 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_5, , , delayed_CK, delayed_D5);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D5 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_5, , , delayed_CK, delayed_D5);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D5 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_5, , , delayed_CK, delayed_D5);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D5 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_5, , , delayed_CK, delayed_D5);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D6 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_6, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D6 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_6, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D6 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_6, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D6 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_6, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D7 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_7, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D7 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_7, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D7 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_7, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D7 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_7, , , delayed_CK, delayed_D7);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPRBQM8SS_V2Y16_2

//%BEGIN HDBSVT11_FSDPRBQ_CBV2Y2_1

`celldefine
module HDBSVT11_FSDPRBQ_CBV2Y2_1 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst6  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst7  (xcr_0, delayed_CK, int_res__D, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_r #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `else
        snps_dff_r inst9  (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst10  (_net_0, D);
not inst11  (_net_1, SE);
not inst12  (_net_2, SI);
and inst13  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_0, _net_1, _net_2);
not inst14  (_net_3, D);
not inst15  (_net_4, SE);
and inst16  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_3, _net_4, SI);
not inst17  (_net_5, D);
not inst18  (_net_6, SI);
and inst19  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_5, SE, _net_6);
not inst20  (_net_7, D);
and inst21  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_7, SE, SI);
not inst22  (_net_8, SE);
not inst23  (_net_9, SI);
and inst24  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_8, _net_9);
not inst25  (_net_10, SE);
and inst26  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_10, SI);
not inst27  (_net_11, SI);
and inst28  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_11);
and inst29  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst30  (_net_12, SE);
not inst31  (_net_13, SI);
and inst32  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_12, RD, _net_13);
not inst33  (_net_14, SE);
and inst34  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_14, RD, SI);
not inst35  (_net_15, D);
and inst36  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_15, SI);
not inst37  (_net_16, SE);
not inst38  (_net_17, SI);
and inst39  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_16, D, _net_17);
not inst40  (_net_18, SE);
and inst41  (ENABLE_D_AND_NOT_SE_AND_SI, _net_18, D, SI);
and inst42  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst43  (_net_19, D);
not inst44  (_net_20, CK);
not inst45  (_net_21, SE);
not inst46  (_net_22, SI);
and inst47  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_19, _net_20, _net_21, _net_22);
not inst48  (_net_23, D);
not inst49  (_net_24, CK);
not inst50  (_net_25, SE);
and inst51  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_23, _net_24, _net_25, SI);
not inst52  (_net_26, D);
not inst53  (_net_27, CK);
not inst54  (_net_28, SI);
and inst55  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_26, _net_27, SE, _net_28);
not inst56  (_net_29, D);
not inst57  (_net_30, CK);
and inst58  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_29, _net_30, SE, SI);
not inst59  (_net_31, CK);
not inst60  (_net_32, SE);
not inst61  (_net_33, SI);
and inst62  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_31, _net_32, _net_33);
not inst63  (_net_34, CK);
not inst64  (_net_35, SE);
and inst65  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_34, _net_35, SI);
not inst66  (_net_36, CK);
not inst67  (_net_37, SI);
and inst68  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_36, SE, _net_37);
not inst69  (_net_38, CK);
and inst70  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_38, SE, SI);
not inst71  (_net_39, D);
not inst72  (_net_40, SE);
not inst73  (_net_41, SI);
and inst74  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_39, CK, _net_40, _net_41);
not inst75  (_net_42, D);
not inst76  (_net_43, SE);
and inst77  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_42, CK, _net_43, SI);
not inst78  (_net_44, D);
not inst79  (_net_45, SI);
and inst80  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_44, CK, SE, _net_45);
not inst81  (_net_46, D);
and inst82  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_46, CK, SE, SI);
not inst83  (_net_47, SE);
not inst84  (_net_48, SI);
and inst85  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_47, _net_48);
not inst86  (_net_49, SE);
and inst87  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_49, SI);
not inst88  (_net_50, SI);
and inst89  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_50);
and inst90  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst91  (_net_51, D);
and inst92  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_51, SI);
not inst93  (_net_52, SI);
and inst94  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_52);
not inst95  (_net_53, D);
and inst96  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_53, SE);
and inst97  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_NOT_D_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SE_AND_SI , posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPRBQ_CBV2Y2_1

//%BEGIN HDBSVT11_FSDPRBQ_V2Y2_1

`celldefine
module HDBSVT11_FSDPRBQ_V2Y2_1 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst6  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst7  (xcr_0, delayed_CK, int_res__D, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_r #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `else
        snps_dff_r inst9  (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst10  (_net_0, D);
not inst11  (_net_1, SE);
not inst12  (_net_2, SI);
and inst13  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_0, _net_1, _net_2);
not inst14  (_net_3, D);
not inst15  (_net_4, SE);
and inst16  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_3, _net_4, SI);
not inst17  (_net_5, D);
not inst18  (_net_6, SI);
and inst19  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_5, SE, _net_6);
not inst20  (_net_7, D);
and inst21  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_7, SE, SI);
not inst22  (_net_8, SE);
not inst23  (_net_9, SI);
and inst24  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_8, _net_9);
not inst25  (_net_10, SE);
and inst26  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_10, SI);
not inst27  (_net_11, SI);
and inst28  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_11);
and inst29  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst30  (_net_12, SE);
not inst31  (_net_13, SI);
and inst32  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_12, RD, _net_13);
not inst33  (_net_14, SE);
and inst34  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_14, RD, SI);
not inst35  (_net_15, D);
and inst36  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_15, SI);
not inst37  (_net_16, SE);
not inst38  (_net_17, SI);
and inst39  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_16, D, _net_17);
not inst40  (_net_18, SE);
and inst41  (ENABLE_D_AND_NOT_SE_AND_SI, _net_18, D, SI);
and inst42  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst43  (_net_19, D);
not inst44  (_net_20, CK);
not inst45  (_net_21, SE);
not inst46  (_net_22, SI);
and inst47  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_19, _net_20, _net_21, _net_22);
not inst48  (_net_23, D);
not inst49  (_net_24, CK);
not inst50  (_net_25, SE);
and inst51  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_23, _net_24, _net_25, SI);
not inst52  (_net_26, D);
not inst53  (_net_27, CK);
not inst54  (_net_28, SI);
and inst55  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_26, _net_27, SE, _net_28);
not inst56  (_net_29, D);
not inst57  (_net_30, CK);
and inst58  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_29, _net_30, SE, SI);
not inst59  (_net_31, CK);
not inst60  (_net_32, SE);
not inst61  (_net_33, SI);
and inst62  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_31, _net_32, _net_33);
not inst63  (_net_34, CK);
not inst64  (_net_35, SE);
and inst65  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_34, _net_35, SI);
not inst66  (_net_36, CK);
not inst67  (_net_37, SI);
and inst68  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_36, SE, _net_37);
not inst69  (_net_38, CK);
and inst70  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_38, SE, SI);
not inst71  (_net_39, D);
not inst72  (_net_40, SE);
not inst73  (_net_41, SI);
and inst74  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_39, CK, _net_40, _net_41);
not inst75  (_net_42, D);
not inst76  (_net_43, SE);
and inst77  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_42, CK, _net_43, SI);
not inst78  (_net_44, D);
not inst79  (_net_45, SI);
and inst80  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_44, CK, SE, _net_45);
not inst81  (_net_46, D);
and inst82  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_46, CK, SE, SI);
not inst83  (_net_47, SE);
not inst84  (_net_48, SI);
and inst85  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_47, _net_48);
not inst86  (_net_49, SE);
and inst87  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_49, SI);
not inst88  (_net_50, SI);
and inst89  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_50);
and inst90  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst91  (_net_51, D);
and inst92  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_51, SI);
not inst93  (_net_52, SI);
and inst94  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_52);
not inst95  (_net_53, D);
and inst96  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_53, SE);
and inst97  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_NOT_D_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SE_AND_SI , posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPRBQ_V2Y2_1

//%BEGIN HDBSVT11_FSDPRBQ_V2Y2_2

`celldefine
module HDBSVT11_FSDPRBQ_V2Y2_2 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst6  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst7  (xcr_0, delayed_CK, int_res__D, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_r #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `else
        snps_dff_r inst9  (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst10  (_net_0, D);
not inst11  (_net_1, SE);
not inst12  (_net_2, SI);
and inst13  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_0, _net_1, _net_2);
not inst14  (_net_3, D);
not inst15  (_net_4, SE);
and inst16  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_3, _net_4, SI);
not inst17  (_net_5, D);
not inst18  (_net_6, SI);
and inst19  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_5, SE, _net_6);
not inst20  (_net_7, D);
and inst21  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_7, SE, SI);
not inst22  (_net_8, SE);
not inst23  (_net_9, SI);
and inst24  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_8, _net_9);
not inst25  (_net_10, SE);
and inst26  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_10, SI);
not inst27  (_net_11, SI);
and inst28  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_11);
and inst29  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst30  (_net_12, SE);
not inst31  (_net_13, SI);
and inst32  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_12, RD, _net_13);
not inst33  (_net_14, SE);
and inst34  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_14, RD, SI);
not inst35  (_net_15, D);
and inst36  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_15, SI);
not inst37  (_net_16, SE);
not inst38  (_net_17, SI);
and inst39  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_16, D, _net_17);
not inst40  (_net_18, SE);
and inst41  (ENABLE_D_AND_NOT_SE_AND_SI, _net_18, D, SI);
and inst42  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst43  (_net_19, D);
not inst44  (_net_20, CK);
not inst45  (_net_21, SE);
not inst46  (_net_22, SI);
and inst47  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_19, _net_20, _net_21, _net_22);
not inst48  (_net_23, D);
not inst49  (_net_24, CK);
not inst50  (_net_25, SE);
and inst51  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_23, _net_24, _net_25, SI);
not inst52  (_net_26, D);
not inst53  (_net_27, CK);
not inst54  (_net_28, SI);
and inst55  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_26, _net_27, SE, _net_28);
not inst56  (_net_29, D);
not inst57  (_net_30, CK);
and inst58  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_29, _net_30, SE, SI);
not inst59  (_net_31, CK);
not inst60  (_net_32, SE);
not inst61  (_net_33, SI);
and inst62  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_31, _net_32, _net_33);
not inst63  (_net_34, CK);
not inst64  (_net_35, SE);
and inst65  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_34, _net_35, SI);
not inst66  (_net_36, CK);
not inst67  (_net_37, SI);
and inst68  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_36, SE, _net_37);
not inst69  (_net_38, CK);
and inst70  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_38, SE, SI);
not inst71  (_net_39, D);
not inst72  (_net_40, SE);
not inst73  (_net_41, SI);
and inst74  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_39, CK, _net_40, _net_41);
not inst75  (_net_42, D);
not inst76  (_net_43, SE);
and inst77  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_42, CK, _net_43, SI);
not inst78  (_net_44, D);
not inst79  (_net_45, SI);
and inst80  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_44, CK, SE, _net_45);
not inst81  (_net_46, D);
and inst82  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_46, CK, SE, SI);
not inst83  (_net_47, SE);
not inst84  (_net_48, SI);
and inst85  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_47, _net_48);
not inst86  (_net_49, SE);
and inst87  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_49, SI);
not inst88  (_net_50, SI);
and inst89  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_50);
and inst90  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst91  (_net_51, D);
and inst92  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_51, SI);
not inst93  (_net_52, SI);
and inst94  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_52);
not inst95  (_net_53, D);
and inst96  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_53, SE);
and inst97  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_NOT_D_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SE_AND_SI , posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPRBQ_V2Y2_2

//%BEGIN HDBSVT11_FSDPRBQ_V2Y2_4

`celldefine
module HDBSVT11_FSDPRBQ_V2Y2_4 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst6  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst7  (xcr_0, delayed_CK, int_res__D, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_r #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `else
        snps_dff_r inst9  (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst10  (_net_0, D);
not inst11  (_net_1, SE);
not inst12  (_net_2, SI);
and inst13  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_0, _net_1, _net_2);
not inst14  (_net_3, D);
not inst15  (_net_4, SE);
and inst16  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_3, _net_4, SI);
not inst17  (_net_5, D);
not inst18  (_net_6, SI);
and inst19  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_5, SE, _net_6);
not inst20  (_net_7, D);
and inst21  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_7, SE, SI);
not inst22  (_net_8, SE);
not inst23  (_net_9, SI);
and inst24  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_8, _net_9);
not inst25  (_net_10, SE);
and inst26  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_10, SI);
not inst27  (_net_11, SI);
and inst28  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_11);
and inst29  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst30  (_net_12, SE);
not inst31  (_net_13, SI);
and inst32  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_12, RD, _net_13);
not inst33  (_net_14, SE);
and inst34  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_14, RD, SI);
not inst35  (_net_15, D);
and inst36  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_15, SI);
not inst37  (_net_16, SE);
not inst38  (_net_17, SI);
and inst39  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_16, D, _net_17);
not inst40  (_net_18, SE);
and inst41  (ENABLE_D_AND_NOT_SE_AND_SI, _net_18, D, SI);
and inst42  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst43  (_net_19, D);
not inst44  (_net_20, CK);
not inst45  (_net_21, SE);
not inst46  (_net_22, SI);
and inst47  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_19, _net_20, _net_21, _net_22);
not inst48  (_net_23, D);
not inst49  (_net_24, CK);
not inst50  (_net_25, SE);
and inst51  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_23, _net_24, _net_25, SI);
not inst52  (_net_26, D);
not inst53  (_net_27, CK);
not inst54  (_net_28, SI);
and inst55  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_26, _net_27, SE, _net_28);
not inst56  (_net_29, D);
not inst57  (_net_30, CK);
and inst58  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_29, _net_30, SE, SI);
not inst59  (_net_31, CK);
not inst60  (_net_32, SE);
not inst61  (_net_33, SI);
and inst62  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_31, _net_32, _net_33);
not inst63  (_net_34, CK);
not inst64  (_net_35, SE);
and inst65  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_34, _net_35, SI);
not inst66  (_net_36, CK);
not inst67  (_net_37, SI);
and inst68  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_36, SE, _net_37);
not inst69  (_net_38, CK);
and inst70  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_38, SE, SI);
not inst71  (_net_39, D);
not inst72  (_net_40, SE);
not inst73  (_net_41, SI);
and inst74  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_39, CK, _net_40, _net_41);
not inst75  (_net_42, D);
not inst76  (_net_43, SE);
and inst77  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_42, CK, _net_43, SI);
not inst78  (_net_44, D);
not inst79  (_net_45, SI);
and inst80  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_44, CK, SE, _net_45);
not inst81  (_net_46, D);
and inst82  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_46, CK, SE, SI);
not inst83  (_net_47, SE);
not inst84  (_net_48, SI);
and inst85  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_47, _net_48);
not inst86  (_net_49, SE);
and inst87  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_49, SI);
not inst88  (_net_50, SI);
and inst89  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_50);
and inst90  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst91  (_net_51, D);
and inst92  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_51, SI);
not inst93  (_net_52, SI);
and inst94  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_52);
not inst95  (_net_53, D);
and inst96  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_53, SE);
and inst97  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_NOT_D_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SE_AND_SI , posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPRBQ_V2Y2_4

//%BEGIN HDBSVT11_FSDPRBQ_V3Y2_1

`celldefine
module HDBSVT11_FSDPRBQ_V3Y2_1 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst6  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst7  (xcr_0, delayed_CK, int_res__D, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_r #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `else
        snps_dff_r inst9  (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst10  (_net_0, D);
not inst11  (_net_1, SE);
not inst12  (_net_2, SI);
and inst13  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_0, _net_1, _net_2);
not inst14  (_net_3, D);
not inst15  (_net_4, SE);
and inst16  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_3, _net_4, SI);
not inst17  (_net_5, D);
not inst18  (_net_6, SI);
and inst19  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_5, SE, _net_6);
not inst20  (_net_7, D);
and inst21  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_7, SE, SI);
not inst22  (_net_8, SE);
not inst23  (_net_9, SI);
and inst24  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_8, _net_9);
not inst25  (_net_10, SE);
and inst26  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_10, SI);
not inst27  (_net_11, SI);
and inst28  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_11);
and inst29  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst30  (_net_12, SE);
not inst31  (_net_13, SI);
and inst32  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_12, RD, _net_13);
not inst33  (_net_14, SE);
and inst34  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_14, RD, SI);
not inst35  (_net_15, D);
and inst36  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_15, SI);
not inst37  (_net_16, SE);
not inst38  (_net_17, SI);
and inst39  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_16, D, _net_17);
not inst40  (_net_18, SE);
and inst41  (ENABLE_D_AND_NOT_SE_AND_SI, _net_18, D, SI);
and inst42  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst43  (_net_19, D);
not inst44  (_net_20, CK);
not inst45  (_net_21, SE);
not inst46  (_net_22, SI);
and inst47  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_19, _net_20, _net_21, _net_22);
not inst48  (_net_23, D);
not inst49  (_net_24, CK);
not inst50  (_net_25, SE);
and inst51  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_23, _net_24, _net_25, SI);
not inst52  (_net_26, D);
not inst53  (_net_27, CK);
not inst54  (_net_28, SI);
and inst55  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_26, _net_27, SE, _net_28);
not inst56  (_net_29, D);
not inst57  (_net_30, CK);
and inst58  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_29, _net_30, SE, SI);
not inst59  (_net_31, CK);
not inst60  (_net_32, SE);
not inst61  (_net_33, SI);
and inst62  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_31, _net_32, _net_33);
not inst63  (_net_34, CK);
not inst64  (_net_35, SE);
and inst65  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_34, _net_35, SI);
not inst66  (_net_36, CK);
not inst67  (_net_37, SI);
and inst68  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_36, SE, _net_37);
not inst69  (_net_38, CK);
and inst70  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_38, SE, SI);
not inst71  (_net_39, D);
not inst72  (_net_40, SE);
not inst73  (_net_41, SI);
and inst74  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_39, CK, _net_40, _net_41);
not inst75  (_net_42, D);
not inst76  (_net_43, SE);
and inst77  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_42, CK, _net_43, SI);
not inst78  (_net_44, D);
not inst79  (_net_45, SI);
and inst80  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_44, CK, SE, _net_45);
not inst81  (_net_46, D);
and inst82  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_46, CK, SE, SI);
not inst83  (_net_47, SE);
not inst84  (_net_48, SI);
and inst85  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_47, _net_48);
not inst86  (_net_49, SE);
and inst87  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_49, SI);
not inst88  (_net_50, SI);
and inst89  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_50);
and inst90  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst91  (_net_51, D);
and inst92  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_51, SI);
not inst93  (_net_52, SI);
and inst94  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_52);
not inst95  (_net_53, D);
and inst96  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_53, SE);
and inst97  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_NOT_D_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SE_AND_SI , posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPRBQ_V3Y2_1

//%BEGIN HDBSVT11_FSDPRBQ_V3Y2_2

`celldefine
module HDBSVT11_FSDPRBQ_V3Y2_2 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst6  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst7  (xcr_0, delayed_CK, int_res__D, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_r #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `else
        snps_dff_r inst9  (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst10  (_net_0, D);
not inst11  (_net_1, SE);
not inst12  (_net_2, SI);
and inst13  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_0, _net_1, _net_2);
not inst14  (_net_3, D);
not inst15  (_net_4, SE);
and inst16  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_3, _net_4, SI);
not inst17  (_net_5, D);
not inst18  (_net_6, SI);
and inst19  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_5, SE, _net_6);
not inst20  (_net_7, D);
and inst21  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_7, SE, SI);
not inst22  (_net_8, SE);
not inst23  (_net_9, SI);
and inst24  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_8, _net_9);
not inst25  (_net_10, SE);
and inst26  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_10, SI);
not inst27  (_net_11, SI);
and inst28  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_11);
and inst29  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst30  (_net_12, SE);
not inst31  (_net_13, SI);
and inst32  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_12, RD, _net_13);
not inst33  (_net_14, SE);
and inst34  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_14, RD, SI);
not inst35  (_net_15, D);
and inst36  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_15, SI);
not inst37  (_net_16, SE);
not inst38  (_net_17, SI);
and inst39  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_16, D, _net_17);
not inst40  (_net_18, SE);
and inst41  (ENABLE_D_AND_NOT_SE_AND_SI, _net_18, D, SI);
and inst42  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst43  (_net_19, D);
not inst44  (_net_20, CK);
not inst45  (_net_21, SE);
not inst46  (_net_22, SI);
and inst47  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_19, _net_20, _net_21, _net_22);
not inst48  (_net_23, D);
not inst49  (_net_24, CK);
not inst50  (_net_25, SE);
and inst51  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_23, _net_24, _net_25, SI);
not inst52  (_net_26, D);
not inst53  (_net_27, CK);
not inst54  (_net_28, SI);
and inst55  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_26, _net_27, SE, _net_28);
not inst56  (_net_29, D);
not inst57  (_net_30, CK);
and inst58  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_29, _net_30, SE, SI);
not inst59  (_net_31, CK);
not inst60  (_net_32, SE);
not inst61  (_net_33, SI);
and inst62  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_31, _net_32, _net_33);
not inst63  (_net_34, CK);
not inst64  (_net_35, SE);
and inst65  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_34, _net_35, SI);
not inst66  (_net_36, CK);
not inst67  (_net_37, SI);
and inst68  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_36, SE, _net_37);
not inst69  (_net_38, CK);
and inst70  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_38, SE, SI);
not inst71  (_net_39, D);
not inst72  (_net_40, SE);
not inst73  (_net_41, SI);
and inst74  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_39, CK, _net_40, _net_41);
not inst75  (_net_42, D);
not inst76  (_net_43, SE);
and inst77  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_42, CK, _net_43, SI);
not inst78  (_net_44, D);
not inst79  (_net_45, SI);
and inst80  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_44, CK, SE, _net_45);
not inst81  (_net_46, D);
and inst82  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_46, CK, SE, SI);
not inst83  (_net_47, SE);
not inst84  (_net_48, SI);
and inst85  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_47, _net_48);
not inst86  (_net_49, SE);
and inst87  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_49, SI);
not inst88  (_net_50, SI);
and inst89  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_50);
and inst90  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst91  (_net_51, D);
and inst92  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_51, SI);
not inst93  (_net_52, SI);
and inst94  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_52);
not inst95  (_net_53, D);
and inst96  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_53, SE);
and inst97  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_NOT_D_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SE_AND_SI , posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPRBQ_V3Y2_2

//%BEGIN HDBSVT11_FSDPRBQ_V3Y2_4

`celldefine
module HDBSVT11_FSDPRBQ_V3Y2_4 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst6  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst7  (xcr_0, delayed_CK, int_res__D, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_r #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `else
        snps_dff_r inst9  (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst10  (_net_0, D);
not inst11  (_net_1, SE);
not inst12  (_net_2, SI);
and inst13  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_0, _net_1, _net_2);
not inst14  (_net_3, D);
not inst15  (_net_4, SE);
and inst16  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_3, _net_4, SI);
not inst17  (_net_5, D);
not inst18  (_net_6, SI);
and inst19  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_5, SE, _net_6);
not inst20  (_net_7, D);
and inst21  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_7, SE, SI);
not inst22  (_net_8, SE);
not inst23  (_net_9, SI);
and inst24  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_8, _net_9);
not inst25  (_net_10, SE);
and inst26  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_10, SI);
not inst27  (_net_11, SI);
and inst28  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_11);
and inst29  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst30  (_net_12, SE);
not inst31  (_net_13, SI);
and inst32  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_12, RD, _net_13);
not inst33  (_net_14, SE);
and inst34  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_14, RD, SI);
not inst35  (_net_15, D);
and inst36  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_15, SI);
not inst37  (_net_16, SE);
not inst38  (_net_17, SI);
and inst39  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_16, D, _net_17);
not inst40  (_net_18, SE);
and inst41  (ENABLE_D_AND_NOT_SE_AND_SI, _net_18, D, SI);
and inst42  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst43  (_net_19, D);
not inst44  (_net_20, CK);
not inst45  (_net_21, SE);
not inst46  (_net_22, SI);
and inst47  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_19, _net_20, _net_21, _net_22);
not inst48  (_net_23, D);
not inst49  (_net_24, CK);
not inst50  (_net_25, SE);
and inst51  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_23, _net_24, _net_25, SI);
not inst52  (_net_26, D);
not inst53  (_net_27, CK);
not inst54  (_net_28, SI);
and inst55  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_26, _net_27, SE, _net_28);
not inst56  (_net_29, D);
not inst57  (_net_30, CK);
and inst58  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_29, _net_30, SE, SI);
not inst59  (_net_31, CK);
not inst60  (_net_32, SE);
not inst61  (_net_33, SI);
and inst62  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_31, _net_32, _net_33);
not inst63  (_net_34, CK);
not inst64  (_net_35, SE);
and inst65  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_34, _net_35, SI);
not inst66  (_net_36, CK);
not inst67  (_net_37, SI);
and inst68  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_36, SE, _net_37);
not inst69  (_net_38, CK);
and inst70  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_38, SE, SI);
not inst71  (_net_39, D);
not inst72  (_net_40, SE);
not inst73  (_net_41, SI);
and inst74  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_39, CK, _net_40, _net_41);
not inst75  (_net_42, D);
not inst76  (_net_43, SE);
and inst77  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_42, CK, _net_43, SI);
not inst78  (_net_44, D);
not inst79  (_net_45, SI);
and inst80  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_44, CK, SE, _net_45);
not inst81  (_net_46, D);
and inst82  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_46, CK, SE, SI);
not inst83  (_net_47, SE);
not inst84  (_net_48, SI);
and inst85  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_47, _net_48);
not inst86  (_net_49, SE);
and inst87  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_49, SI);
not inst88  (_net_50, SI);
and inst89  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_50);
and inst90  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst91  (_net_51, D);
and inst92  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_51, SI);
not inst93  (_net_52, SI);
and inst94  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_52);
not inst95  (_net_53, D);
and inst96  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_53, SE);
and inst97  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_NOT_D_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SE_AND_SI , posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPRBQ_V3Y2_4

//%BEGIN HDBSVT11_FSDPRBQ_Y2_1

`celldefine
module HDBSVT11_FSDPRBQ_Y2_1 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst6  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst7  (xcr_0, delayed_CK, int_res__D, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_r #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `else
        snps_dff_r inst9  (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst10  (_net_0, D);
not inst11  (_net_1, SE);
not inst12  (_net_2, SI);
and inst13  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_0, _net_1, _net_2);
not inst14  (_net_3, D);
not inst15  (_net_4, SE);
and inst16  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_3, _net_4, SI);
not inst17  (_net_5, D);
not inst18  (_net_6, SI);
and inst19  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_5, SE, _net_6);
not inst20  (_net_7, D);
and inst21  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_7, SE, SI);
not inst22  (_net_8, SE);
not inst23  (_net_9, SI);
and inst24  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_8, _net_9);
not inst25  (_net_10, SE);
and inst26  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_10, SI);
not inst27  (_net_11, SI);
and inst28  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_11);
and inst29  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst30  (_net_12, SE);
not inst31  (_net_13, SI);
and inst32  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_12, RD, _net_13);
not inst33  (_net_14, SE);
and inst34  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_14, RD, SI);
not inst35  (_net_15, D);
and inst36  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_15, SI);
not inst37  (_net_16, SE);
not inst38  (_net_17, SI);
and inst39  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_16, D, _net_17);
not inst40  (_net_18, SE);
and inst41  (ENABLE_D_AND_NOT_SE_AND_SI, _net_18, D, SI);
and inst42  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst43  (_net_19, D);
not inst44  (_net_20, CK);
not inst45  (_net_21, SE);
not inst46  (_net_22, SI);
and inst47  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_19, _net_20, _net_21, _net_22);
not inst48  (_net_23, D);
not inst49  (_net_24, CK);
not inst50  (_net_25, SE);
and inst51  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_23, _net_24, _net_25, SI);
not inst52  (_net_26, D);
not inst53  (_net_27, CK);
not inst54  (_net_28, SI);
and inst55  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_26, _net_27, SE, _net_28);
not inst56  (_net_29, D);
not inst57  (_net_30, CK);
and inst58  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_29, _net_30, SE, SI);
not inst59  (_net_31, CK);
not inst60  (_net_32, SE);
not inst61  (_net_33, SI);
and inst62  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_31, _net_32, _net_33);
not inst63  (_net_34, CK);
not inst64  (_net_35, SE);
and inst65  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_34, _net_35, SI);
not inst66  (_net_36, CK);
not inst67  (_net_37, SI);
and inst68  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_36, SE, _net_37);
not inst69  (_net_38, CK);
and inst70  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_38, SE, SI);
not inst71  (_net_39, D);
not inst72  (_net_40, SE);
not inst73  (_net_41, SI);
and inst74  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_39, CK, _net_40, _net_41);
not inst75  (_net_42, D);
not inst76  (_net_43, SE);
and inst77  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_42, CK, _net_43, SI);
not inst78  (_net_44, D);
not inst79  (_net_45, SI);
and inst80  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_44, CK, SE, _net_45);
not inst81  (_net_46, D);
and inst82  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_46, CK, SE, SI);
not inst83  (_net_47, SE);
not inst84  (_net_48, SI);
and inst85  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_47, _net_48);
not inst86  (_net_49, SE);
and inst87  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_49, SI);
not inst88  (_net_50, SI);
and inst89  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_50);
and inst90  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst91  (_net_51, D);
and inst92  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_51, SI);
not inst93  (_net_52, SI);
and inst94  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_52);
not inst95  (_net_53, D);
and inst96  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_53, SE);
and inst97  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_NOT_D_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SE_AND_SI , posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPRBQ_Y2_1

//%BEGIN HDBSVT11_FSDPRBQ_Y2_4

`celldefine
module HDBSVT11_FSDPRBQ_Y2_4 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst6  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_r_err inst7  (xcr_0, delayed_CK, int_res__D, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_r #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `else
        snps_dff_r inst9  (Q, viol_0, delayed_CK, int_res__D, int_res__RD, xcr_0);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst10  (_net_0, D);
not inst11  (_net_1, SE);
not inst12  (_net_2, SI);
and inst13  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_0, _net_1, _net_2);
not inst14  (_net_3, D);
not inst15  (_net_4, SE);
and inst16  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_3, _net_4, SI);
not inst17  (_net_5, D);
not inst18  (_net_6, SI);
and inst19  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_5, SE, _net_6);
not inst20  (_net_7, D);
and inst21  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_7, SE, SI);
not inst22  (_net_8, SE);
not inst23  (_net_9, SI);
and inst24  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_8, _net_9);
not inst25  (_net_10, SE);
and inst26  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_10, SI);
not inst27  (_net_11, SI);
and inst28  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_11);
and inst29  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst30  (_net_12, SE);
not inst31  (_net_13, SI);
and inst32  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_12, RD, _net_13);
not inst33  (_net_14, SE);
and inst34  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_14, RD, SI);
not inst35  (_net_15, D);
and inst36  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_15, SI);
not inst37  (_net_16, SE);
not inst38  (_net_17, SI);
and inst39  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_16, D, _net_17);
not inst40  (_net_18, SE);
and inst41  (ENABLE_D_AND_NOT_SE_AND_SI, _net_18, D, SI);
and inst42  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst43  (_net_19, D);
not inst44  (_net_20, CK);
not inst45  (_net_21, SE);
not inst46  (_net_22, SI);
and inst47  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_19, _net_20, _net_21, _net_22);
not inst48  (_net_23, D);
not inst49  (_net_24, CK);
not inst50  (_net_25, SE);
and inst51  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_23, _net_24, _net_25, SI);
not inst52  (_net_26, D);
not inst53  (_net_27, CK);
not inst54  (_net_28, SI);
and inst55  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_26, _net_27, SE, _net_28);
not inst56  (_net_29, D);
not inst57  (_net_30, CK);
and inst58  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_29, _net_30, SE, SI);
not inst59  (_net_31, CK);
not inst60  (_net_32, SE);
not inst61  (_net_33, SI);
and inst62  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_31, _net_32, _net_33);
not inst63  (_net_34, CK);
not inst64  (_net_35, SE);
and inst65  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_34, _net_35, SI);
not inst66  (_net_36, CK);
not inst67  (_net_37, SI);
and inst68  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_36, SE, _net_37);
not inst69  (_net_38, CK);
and inst70  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_38, SE, SI);
not inst71  (_net_39, D);
not inst72  (_net_40, SE);
not inst73  (_net_41, SI);
and inst74  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_39, CK, _net_40, _net_41);
not inst75  (_net_42, D);
not inst76  (_net_43, SE);
and inst77  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_42, CK, _net_43, SI);
not inst78  (_net_44, D);
not inst79  (_net_45, SI);
and inst80  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_44, CK, SE, _net_45);
not inst81  (_net_46, D);
and inst82  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_46, CK, SE, SI);
not inst83  (_net_47, SE);
not inst84  (_net_48, SI);
and inst85  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_47, _net_48);
not inst86  (_net_49, SE);
and inst87  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_49, SI);
not inst88  (_net_50, SI);
and inst89  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_50);
and inst90  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst91  (_net_51, D);
and inst92  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_51, SI);
not inst93  (_net_52, SI);
and inst94  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_52);
not inst95  (_net_53, D);
and inst96  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_53, SE);
and inst97  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_NOT_D_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SE_AND_SI , posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPRBQ_Y2_4

//%BEGIN HDBSVT11_FSDPRBSBQ_V2Y4_1

`celldefine
module HDBSVT11_FSDPRBSBQ_V2Y4_1 (Q, CK, D, SI, SE, RD, SD);
   output Q;
   input CK, D, SI, SE, RD, SD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD, delayed_SD;

   wire int_res__D, int_res__SD, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
   buf inst5  (delayed_SD, SD);
`endif

   snps_mux2 inst6  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst7  (int_res__SD, delayed_SD);
   not inst8  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_sr_err inst9  (xcr_0, delayed_CK, int_res__D, int_res__SD, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_sr_0 #`SNPS_SEQ_DELAY  inst10 (Q, viol_0, delayed_CK, int_res__D, int_res__SD, int_res__RD, xcr_0);
   `else
        snps_dff_sr_0 inst11  (Q, viol_0, delayed_CK, int_res__D, int_res__SD, int_res__RD, xcr_0);
    `endif

    `ifdef VIRL_functiononly

    `else

not inst12  (_net_0, D);
not inst13  (_net_1, SE);
not inst14  (_net_2, SI);
and inst15  (ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI, RD, _net_0, SD, _net_1, _net_2);
not inst16  (_net_3, D);
not inst17  (_net_4, SE);
and inst18  (ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI, RD, _net_3, SD, _net_4, SI);
not inst19  (_net_5, D);
not inst20  (_net_6, SI);
and inst21  (ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI, RD, _net_5, SD, SE, _net_6);
not inst22  (_net_7, D);
and inst23  (ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_SI, RD, _net_7, SD, SE, SI);
not inst24  (_net_8, SE);
not inst25  (_net_9, SI);
and inst26  (ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI, RD, D, SD, _net_8, _net_9);
not inst27  (_net_10, SE);
and inst28  (ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI, RD, D, SD, _net_10, SI);
not inst29  (_net_11, SI);
and inst30  (ENABLE_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI, RD, D, SD, SE, _net_11);
and inst31  (ENABLE_D_AND_RD_AND_SD_AND_SE_AND_SI, RD, D, SD, SE, SI);
not inst32  (_net_12, SE);
not inst33  (_net_13, SI);
and inst34  (ENABLE_RD_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, RD, _net_12, _net_13);
not inst35  (_net_14, SE);
and inst36  (ENABLE_RD_AND_SD_AND_NOT_SE_AND_SI, SD, RD, _net_14, SI);
not inst37  (_net_15, D);
and inst38  (ENABLE_NOT_D_AND_SD_AND_SE_AND_SI, SD, _net_15, SE, SI);
not inst39  (_net_16, SE);
not inst40  (_net_17, SI);
and inst41  (ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, D, _net_16, _net_17);
not inst42  (_net_18, SE);
and inst43  (ENABLE_D_AND_SD_AND_NOT_SE_AND_SI, SD, D, _net_18, SI);
and inst44  (ENABLE_D_AND_SD_AND_SE_AND_SI, SD, D, SE, SI);
not inst45  (_net_19, D);
not inst46  (_net_20, CK);
not inst47  (_net_21, SE);
not inst48  (_net_22, SI);
and inst49  (ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI, _net_19, _net_20, SD, _net_21, _net_22);
not inst50  (_net_23, D);
not inst51  (_net_24, CK);
not inst52  (_net_25, SE);
and inst53  (ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_SI, _net_23, _net_24, SD, _net_25, SI);
not inst54  (_net_26, D);
not inst55  (_net_27, CK);
not inst56  (_net_28, SI);
and inst57  (ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_SE_AND_NOT_SI, _net_26, _net_27, SD, SE, _net_28);
not inst58  (_net_29, D);
not inst59  (_net_30, CK);
and inst60  (ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_SE_AND_SI, _net_29, _net_30, SD, SE, SI);
not inst61  (_net_31, CK);
not inst62  (_net_32, SE);
not inst63  (_net_33, SI);
and inst64  (ENABLE_NOT_CK_AND_D_AND_SD_AND_NOT_SE_AND_NOT_SI, D, _net_31, SD, _net_32, _net_33);
not inst65  (_net_34, CK);
not inst66  (_net_35, SE);
and inst67  (ENABLE_NOT_CK_AND_D_AND_SD_AND_NOT_SE_AND_SI, D, _net_34, SD, _net_35, SI);
not inst68  (_net_36, CK);
not inst69  (_net_37, SI);
and inst70  (ENABLE_NOT_CK_AND_D_AND_SD_AND_SE_AND_NOT_SI, D, _net_36, SD, SE, _net_37);
not inst71  (_net_38, CK);
and inst72  (ENABLE_NOT_CK_AND_D_AND_SD_AND_SE_AND_SI, D, _net_38, SD, SE, SI);
not inst73  (_net_39, D);
not inst74  (_net_40, SE);
not inst75  (_net_41, SI);
and inst76  (ENABLE_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI, _net_39, CK, SD, _net_40, _net_41);
not inst77  (_net_42, D);
not inst78  (_net_43, SE);
and inst79  (ENABLE_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_SI, _net_42, CK, SD, _net_43, SI);
not inst80  (_net_44, D);
not inst81  (_net_45, SI);
and inst82  (ENABLE_CK_AND_NOT_D_AND_SD_AND_SE_AND_NOT_SI, _net_44, CK, SD, SE, _net_45);
not inst83  (_net_46, D);
and inst84  (ENABLE_CK_AND_NOT_D_AND_SD_AND_SE_AND_SI, _net_46, CK, SD, SE, SI);
not inst85  (_net_47, SE);
not inst86  (_net_48, SI);
and inst87  (ENABLE_CK_AND_D_AND_SD_AND_NOT_SE_AND_NOT_SI, D, CK, SD, _net_47, _net_48);
not inst88  (_net_49, SE);
and inst89  (ENABLE_CK_AND_D_AND_SD_AND_NOT_SE_AND_SI, D, CK, SD, _net_49, SI);
not inst90  (_net_50, SI);
and inst91  (ENABLE_CK_AND_D_AND_SD_AND_SE_AND_NOT_SI, D, CK, SD, SE, _net_50);
and inst92  (ENABLE_CK_AND_D_AND_SD_AND_SE_AND_SI, D, CK, SD, SE, SI);
not inst93  (_net_51, D);
not inst94  (_net_52, CK);
not inst95  (_net_53, SE);
not inst96  (_net_54, SI);
and inst97  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_51, _net_52, _net_53, _net_54);
not inst98  (_net_55, D);
not inst99  (_net_56, CK);
not inst100  (_net_57, SE);
and inst101  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_55, _net_56, _net_57, SI);
not inst102  (_net_58, D);
not inst103  (_net_59, CK);
not inst104  (_net_60, SI);
and inst105  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_58, _net_59, SE, _net_60);
not inst106  (_net_61, D);
not inst107  (_net_62, CK);
and inst108  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_61, _net_62, SE, SI);
not inst109  (_net_63, CK);
not inst110  (_net_64, SE);
not inst111  (_net_65, SI);
and inst112  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_63, _net_64, _net_65);
not inst113  (_net_66, CK);
not inst114  (_net_67, SE);
and inst115  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_66, _net_67, SI);
not inst116  (_net_68, CK);
not inst117  (_net_69, SI);
and inst118  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_68, SE, _net_69);
not inst119  (_net_70, CK);
and inst120  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_70, SE, SI);
not inst121  (_net_71, D);
not inst122  (_net_72, SE);
not inst123  (_net_73, SI);
and inst124  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_71, CK, _net_72, _net_73);
not inst125  (_net_74, D);
not inst126  (_net_75, SE);
and inst127  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_74, CK, _net_75, SI);
not inst128  (_net_76, D);
not inst129  (_net_77, SI);
and inst130  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_76, CK, SE, _net_77);
not inst131  (_net_78, D);
and inst132  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_78, CK, SE, SI);
not inst133  (_net_79, SE);
not inst134  (_net_80, SI);
and inst135  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_79, _net_80);
not inst136  (_net_81, SE);
and inst137  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_81, SI);
not inst138  (_net_82, SI);
and inst139  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_82);
and inst140  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst141  (_net_83, D);
not inst142  (_net_84, SE);
not inst143  (_net_85, SI);
and inst144  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_83, _net_84, _net_85);
not inst145  (_net_86, D);
not inst146  (_net_87, SE);
and inst147  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_86, _net_87, SI);
not inst148  (_net_88, D);
not inst149  (_net_89, SI);
and inst150  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_88, SE, _net_89);
not inst151  (_net_90, SI);
and inst152  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_90);
not inst153  (_net_91, D);
not inst154  (_net_92, CK);
not inst155  (_net_93, SE);
not inst156  (_net_94, SI);
and inst157  (ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_91, _net_92, RD, _net_93, _net_94);
not inst158  (_net_95, D);
not inst159  (_net_96, CK);
not inst160  (_net_97, SE);
and inst161  (ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_SI, _net_95, _net_96, RD, _net_97, SI);
not inst162  (_net_98, D);
not inst163  (_net_99, CK);
not inst164  (_net_100, SI);
and inst165  (ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_SE_AND_NOT_SI, _net_98, _net_99, RD, SE, _net_100);
not inst166  (_net_101, D);
not inst167  (_net_102, CK);
and inst168  (ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_SE_AND_SI, _net_101, _net_102, RD, SE, SI);
not inst169  (_net_103, CK);
not inst170  (_net_104, SE);
not inst171  (_net_105, SI);
and inst172  (ENABLE_NOT_CK_AND_D_AND_RD_AND_NOT_SE_AND_NOT_SI, D, _net_103, RD, _net_104, _net_105);
not inst173  (_net_106, CK);
not inst174  (_net_107, SE);
and inst175  (ENABLE_NOT_CK_AND_D_AND_RD_AND_NOT_SE_AND_SI, D, _net_106, RD, _net_107, SI);
not inst176  (_net_108, CK);
not inst177  (_net_109, SI);
and inst178  (ENABLE_NOT_CK_AND_D_AND_RD_AND_SE_AND_NOT_SI, D, _net_108, RD, SE, _net_109);
not inst179  (_net_110, CK);
and inst180  (ENABLE_NOT_CK_AND_D_AND_RD_AND_SE_AND_SI, D, _net_110, RD, SE, SI);
not inst181  (_net_111, D);
not inst182  (_net_112, SE);
not inst183  (_net_113, SI);
and inst184  (ENABLE_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_111, CK, RD, _net_112, _net_113);
not inst185  (_net_114, D);
not inst186  (_net_115, SE);
and inst187  (ENABLE_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_SI, _net_114, CK, RD, _net_115, SI);
not inst188  (_net_116, D);
not inst189  (_net_117, SI);
and inst190  (ENABLE_CK_AND_NOT_D_AND_RD_AND_SE_AND_NOT_SI, _net_116, CK, RD, SE, _net_117);
not inst191  (_net_118, D);
and inst192  (ENABLE_CK_AND_NOT_D_AND_RD_AND_SE_AND_SI, _net_118, CK, RD, SE, SI);
not inst193  (_net_119, SE);
not inst194  (_net_120, SI);
and inst195  (ENABLE_CK_AND_D_AND_RD_AND_NOT_SE_AND_NOT_SI, D, CK, RD, _net_119, _net_120);
not inst196  (_net_121, SE);
and inst197  (ENABLE_CK_AND_D_AND_RD_AND_NOT_SE_AND_SI, D, CK, RD, _net_121, SI);
not inst198  (_net_122, SI);
and inst199  (ENABLE_CK_AND_D_AND_RD_AND_SE_AND_NOT_SI, D, CK, RD, SE, _net_122);
and inst200  (ENABLE_CK_AND_D_AND_RD_AND_SE_AND_SI, D, CK, RD, SE, SI);
not inst201  (_net_123, D);
and inst202  (ENABLE_NOT_D_AND_RD_AND_SD_AND_SI, RD, _net_123, SD, SI);
not inst203  (_net_124, SI);
and inst204  (ENABLE_D_AND_RD_AND_SD_AND_NOT_SI, RD, D, SD, _net_124);
not inst205  (_net_125, D);
and inst206  (ENABLE_NOT_D_AND_RD_AND_SD_AND_SE, RD, _net_125, SD, SE);
and inst207  (ENABLE_D_AND_RD_AND_SD_AND_SE, RD, D, SD, SE);

specify
if (CK==1'b0 && D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SD_AND_SE_AND_SI , posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , posedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , posedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , posedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , posedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , posedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , posedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , posedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , posedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , posedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , posedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , posedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , posedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , posedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , posedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , posedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , posedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPRBSBQ_V2Y4_1

//%BEGIN HDBSVT11_FSDPRBSBQ_V2Y4_2

`celldefine
module HDBSVT11_FSDPRBSBQ_V2Y4_2 (Q, CK, D, SI, SE, RD, SD);
   output Q;
   input CK, D, SI, SE, RD, SD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD, delayed_SD;

   wire int_res__D, int_res__SD, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
   buf inst5  (delayed_SD, SD);
`endif

   snps_mux2 inst6  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst7  (int_res__SD, delayed_SD);
   not inst8  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_sr_err inst9  (xcr_0, delayed_CK, int_res__D, int_res__SD, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_sr_0 #`SNPS_SEQ_DELAY  inst10 (Q, viol_0, delayed_CK, int_res__D, int_res__SD, int_res__RD, xcr_0);
   `else
        snps_dff_sr_0 inst11  (Q, viol_0, delayed_CK, int_res__D, int_res__SD, int_res__RD, xcr_0);
    `endif

    `ifdef VIRL_functiononly

    `else

not inst12  (_net_0, D);
not inst13  (_net_1, SE);
not inst14  (_net_2, SI);
and inst15  (ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI, RD, _net_0, SD, _net_1, _net_2);
not inst16  (_net_3, D);
not inst17  (_net_4, SE);
and inst18  (ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI, RD, _net_3, SD, _net_4, SI);
not inst19  (_net_5, D);
not inst20  (_net_6, SI);
and inst21  (ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI, RD, _net_5, SD, SE, _net_6);
not inst22  (_net_7, D);
and inst23  (ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_SI, RD, _net_7, SD, SE, SI);
not inst24  (_net_8, SE);
not inst25  (_net_9, SI);
and inst26  (ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI, RD, D, SD, _net_8, _net_9);
not inst27  (_net_10, SE);
and inst28  (ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI, RD, D, SD, _net_10, SI);
not inst29  (_net_11, SI);
and inst30  (ENABLE_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI, RD, D, SD, SE, _net_11);
and inst31  (ENABLE_D_AND_RD_AND_SD_AND_SE_AND_SI, RD, D, SD, SE, SI);
not inst32  (_net_12, SE);
not inst33  (_net_13, SI);
and inst34  (ENABLE_RD_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, RD, _net_12, _net_13);
not inst35  (_net_14, SE);
and inst36  (ENABLE_RD_AND_SD_AND_NOT_SE_AND_SI, SD, RD, _net_14, SI);
not inst37  (_net_15, D);
and inst38  (ENABLE_NOT_D_AND_SD_AND_SE_AND_SI, SD, _net_15, SE, SI);
not inst39  (_net_16, SE);
not inst40  (_net_17, SI);
and inst41  (ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, D, _net_16, _net_17);
not inst42  (_net_18, SE);
and inst43  (ENABLE_D_AND_SD_AND_NOT_SE_AND_SI, SD, D, _net_18, SI);
and inst44  (ENABLE_D_AND_SD_AND_SE_AND_SI, SD, D, SE, SI);
not inst45  (_net_19, D);
not inst46  (_net_20, CK);
not inst47  (_net_21, SE);
not inst48  (_net_22, SI);
and inst49  (ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI, _net_19, _net_20, SD, _net_21, _net_22);
not inst50  (_net_23, D);
not inst51  (_net_24, CK);
not inst52  (_net_25, SE);
and inst53  (ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_SI, _net_23, _net_24, SD, _net_25, SI);
not inst54  (_net_26, D);
not inst55  (_net_27, CK);
not inst56  (_net_28, SI);
and inst57  (ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_SE_AND_NOT_SI, _net_26, _net_27, SD, SE, _net_28);
not inst58  (_net_29, D);
not inst59  (_net_30, CK);
and inst60  (ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_SE_AND_SI, _net_29, _net_30, SD, SE, SI);
not inst61  (_net_31, CK);
not inst62  (_net_32, SE);
not inst63  (_net_33, SI);
and inst64  (ENABLE_NOT_CK_AND_D_AND_SD_AND_NOT_SE_AND_NOT_SI, D, _net_31, SD, _net_32, _net_33);
not inst65  (_net_34, CK);
not inst66  (_net_35, SE);
and inst67  (ENABLE_NOT_CK_AND_D_AND_SD_AND_NOT_SE_AND_SI, D, _net_34, SD, _net_35, SI);
not inst68  (_net_36, CK);
not inst69  (_net_37, SI);
and inst70  (ENABLE_NOT_CK_AND_D_AND_SD_AND_SE_AND_NOT_SI, D, _net_36, SD, SE, _net_37);
not inst71  (_net_38, CK);
and inst72  (ENABLE_NOT_CK_AND_D_AND_SD_AND_SE_AND_SI, D, _net_38, SD, SE, SI);
not inst73  (_net_39, D);
not inst74  (_net_40, SE);
not inst75  (_net_41, SI);
and inst76  (ENABLE_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI, _net_39, CK, SD, _net_40, _net_41);
not inst77  (_net_42, D);
not inst78  (_net_43, SE);
and inst79  (ENABLE_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_SI, _net_42, CK, SD, _net_43, SI);
not inst80  (_net_44, D);
not inst81  (_net_45, SI);
and inst82  (ENABLE_CK_AND_NOT_D_AND_SD_AND_SE_AND_NOT_SI, _net_44, CK, SD, SE, _net_45);
not inst83  (_net_46, D);
and inst84  (ENABLE_CK_AND_NOT_D_AND_SD_AND_SE_AND_SI, _net_46, CK, SD, SE, SI);
not inst85  (_net_47, SE);
not inst86  (_net_48, SI);
and inst87  (ENABLE_CK_AND_D_AND_SD_AND_NOT_SE_AND_NOT_SI, D, CK, SD, _net_47, _net_48);
not inst88  (_net_49, SE);
and inst89  (ENABLE_CK_AND_D_AND_SD_AND_NOT_SE_AND_SI, D, CK, SD, _net_49, SI);
not inst90  (_net_50, SI);
and inst91  (ENABLE_CK_AND_D_AND_SD_AND_SE_AND_NOT_SI, D, CK, SD, SE, _net_50);
and inst92  (ENABLE_CK_AND_D_AND_SD_AND_SE_AND_SI, D, CK, SD, SE, SI);
not inst93  (_net_51, D);
not inst94  (_net_52, CK);
not inst95  (_net_53, SE);
not inst96  (_net_54, SI);
and inst97  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_51, _net_52, _net_53, _net_54);
not inst98  (_net_55, D);
not inst99  (_net_56, CK);
not inst100  (_net_57, SE);
and inst101  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_55, _net_56, _net_57, SI);
not inst102  (_net_58, D);
not inst103  (_net_59, CK);
not inst104  (_net_60, SI);
and inst105  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_58, _net_59, SE, _net_60);
not inst106  (_net_61, D);
not inst107  (_net_62, CK);
and inst108  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_61, _net_62, SE, SI);
not inst109  (_net_63, CK);
not inst110  (_net_64, SE);
not inst111  (_net_65, SI);
and inst112  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_63, _net_64, _net_65);
not inst113  (_net_66, CK);
not inst114  (_net_67, SE);
and inst115  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_66, _net_67, SI);
not inst116  (_net_68, CK);
not inst117  (_net_69, SI);
and inst118  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_68, SE, _net_69);
not inst119  (_net_70, CK);
and inst120  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_70, SE, SI);
not inst121  (_net_71, D);
not inst122  (_net_72, SE);
not inst123  (_net_73, SI);
and inst124  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_71, CK, _net_72, _net_73);
not inst125  (_net_74, D);
not inst126  (_net_75, SE);
and inst127  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_74, CK, _net_75, SI);
not inst128  (_net_76, D);
not inst129  (_net_77, SI);
and inst130  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_76, CK, SE, _net_77);
not inst131  (_net_78, D);
and inst132  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_78, CK, SE, SI);
not inst133  (_net_79, SE);
not inst134  (_net_80, SI);
and inst135  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_79, _net_80);
not inst136  (_net_81, SE);
and inst137  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_81, SI);
not inst138  (_net_82, SI);
and inst139  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_82);
and inst140  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst141  (_net_83, D);
not inst142  (_net_84, SE);
not inst143  (_net_85, SI);
and inst144  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_83, _net_84, _net_85);
not inst145  (_net_86, D);
not inst146  (_net_87, SE);
and inst147  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_86, _net_87, SI);
not inst148  (_net_88, D);
not inst149  (_net_89, SI);
and inst150  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_88, SE, _net_89);
not inst151  (_net_90, SI);
and inst152  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_90);
not inst153  (_net_91, D);
not inst154  (_net_92, CK);
not inst155  (_net_93, SE);
not inst156  (_net_94, SI);
and inst157  (ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_91, _net_92, RD, _net_93, _net_94);
not inst158  (_net_95, D);
not inst159  (_net_96, CK);
not inst160  (_net_97, SE);
and inst161  (ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_SI, _net_95, _net_96, RD, _net_97, SI);
not inst162  (_net_98, D);
not inst163  (_net_99, CK);
not inst164  (_net_100, SI);
and inst165  (ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_SE_AND_NOT_SI, _net_98, _net_99, RD, SE, _net_100);
not inst166  (_net_101, D);
not inst167  (_net_102, CK);
and inst168  (ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_SE_AND_SI, _net_101, _net_102, RD, SE, SI);
not inst169  (_net_103, CK);
not inst170  (_net_104, SE);
not inst171  (_net_105, SI);
and inst172  (ENABLE_NOT_CK_AND_D_AND_RD_AND_NOT_SE_AND_NOT_SI, D, _net_103, RD, _net_104, _net_105);
not inst173  (_net_106, CK);
not inst174  (_net_107, SE);
and inst175  (ENABLE_NOT_CK_AND_D_AND_RD_AND_NOT_SE_AND_SI, D, _net_106, RD, _net_107, SI);
not inst176  (_net_108, CK);
not inst177  (_net_109, SI);
and inst178  (ENABLE_NOT_CK_AND_D_AND_RD_AND_SE_AND_NOT_SI, D, _net_108, RD, SE, _net_109);
not inst179  (_net_110, CK);
and inst180  (ENABLE_NOT_CK_AND_D_AND_RD_AND_SE_AND_SI, D, _net_110, RD, SE, SI);
not inst181  (_net_111, D);
not inst182  (_net_112, SE);
not inst183  (_net_113, SI);
and inst184  (ENABLE_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_111, CK, RD, _net_112, _net_113);
not inst185  (_net_114, D);
not inst186  (_net_115, SE);
and inst187  (ENABLE_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_SI, _net_114, CK, RD, _net_115, SI);
not inst188  (_net_116, D);
not inst189  (_net_117, SI);
and inst190  (ENABLE_CK_AND_NOT_D_AND_RD_AND_SE_AND_NOT_SI, _net_116, CK, RD, SE, _net_117);
not inst191  (_net_118, D);
and inst192  (ENABLE_CK_AND_NOT_D_AND_RD_AND_SE_AND_SI, _net_118, CK, RD, SE, SI);
not inst193  (_net_119, SE);
not inst194  (_net_120, SI);
and inst195  (ENABLE_CK_AND_D_AND_RD_AND_NOT_SE_AND_NOT_SI, D, CK, RD, _net_119, _net_120);
not inst196  (_net_121, SE);
and inst197  (ENABLE_CK_AND_D_AND_RD_AND_NOT_SE_AND_SI, D, CK, RD, _net_121, SI);
not inst198  (_net_122, SI);
and inst199  (ENABLE_CK_AND_D_AND_RD_AND_SE_AND_NOT_SI, D, CK, RD, SE, _net_122);
and inst200  (ENABLE_CK_AND_D_AND_RD_AND_SE_AND_SI, D, CK, RD, SE, SI);
not inst201  (_net_123, D);
and inst202  (ENABLE_NOT_D_AND_RD_AND_SD_AND_SI, RD, _net_123, SD, SI);
not inst203  (_net_124, SI);
and inst204  (ENABLE_D_AND_RD_AND_SD_AND_NOT_SI, RD, D, SD, _net_124);
not inst205  (_net_125, D);
and inst206  (ENABLE_NOT_D_AND_RD_AND_SD_AND_SE, RD, _net_125, SD, SE);
and inst207  (ENABLE_D_AND_RD_AND_SD_AND_SE, RD, D, SD, SE);

specify
if (CK==1'b0 && D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SD_AND_SE_AND_SI , posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , posedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , posedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , posedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , posedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , posedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , posedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , posedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , posedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , posedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , posedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , posedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , posedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , posedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , posedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , posedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , posedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPRBSBQ_V2Y4_2

//%BEGIN HDBSVT11_FSDPRBSBQ_V2Y4_4

`celldefine
module HDBSVT11_FSDPRBSBQ_V2Y4_4 (Q, CK, D, SI, SE, RD, SD);
   output Q;
   input CK, D, SI, SE, RD, SD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD, delayed_SD;

   wire int_res__D, int_res__SD, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
   buf inst5  (delayed_SD, SD);
`endif

   snps_mux2 inst6  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst7  (int_res__SD, delayed_SD);
   not inst8  (int_res__RD, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_sr_err inst9  (xcr_0, delayed_CK, int_res__D, int_res__SD, int_res__RD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_sr_0 #`SNPS_SEQ_DELAY  inst10 (Q, viol_0, delayed_CK, int_res__D, int_res__SD, int_res__RD, xcr_0);
   `else
        snps_dff_sr_0 inst11  (Q, viol_0, delayed_CK, int_res__D, int_res__SD, int_res__RD, xcr_0);
    `endif

    `ifdef VIRL_functiononly

    `else

not inst12  (_net_0, D);
not inst13  (_net_1, SE);
not inst14  (_net_2, SI);
and inst15  (ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI, RD, _net_0, SD, _net_1, _net_2);
not inst16  (_net_3, D);
not inst17  (_net_4, SE);
and inst18  (ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI, RD, _net_3, SD, _net_4, SI);
not inst19  (_net_5, D);
not inst20  (_net_6, SI);
and inst21  (ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI, RD, _net_5, SD, SE, _net_6);
not inst22  (_net_7, D);
and inst23  (ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_SI, RD, _net_7, SD, SE, SI);
not inst24  (_net_8, SE);
not inst25  (_net_9, SI);
and inst26  (ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI, RD, D, SD, _net_8, _net_9);
not inst27  (_net_10, SE);
and inst28  (ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI, RD, D, SD, _net_10, SI);
not inst29  (_net_11, SI);
and inst30  (ENABLE_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI, RD, D, SD, SE, _net_11);
and inst31  (ENABLE_D_AND_RD_AND_SD_AND_SE_AND_SI, RD, D, SD, SE, SI);
not inst32  (_net_12, SE);
not inst33  (_net_13, SI);
and inst34  (ENABLE_RD_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, RD, _net_12, _net_13);
not inst35  (_net_14, SE);
and inst36  (ENABLE_RD_AND_SD_AND_NOT_SE_AND_SI, SD, RD, _net_14, SI);
not inst37  (_net_15, D);
and inst38  (ENABLE_NOT_D_AND_SD_AND_SE_AND_SI, SD, _net_15, SE, SI);
not inst39  (_net_16, SE);
not inst40  (_net_17, SI);
and inst41  (ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, D, _net_16, _net_17);
not inst42  (_net_18, SE);
and inst43  (ENABLE_D_AND_SD_AND_NOT_SE_AND_SI, SD, D, _net_18, SI);
and inst44  (ENABLE_D_AND_SD_AND_SE_AND_SI, SD, D, SE, SI);
not inst45  (_net_19, D);
not inst46  (_net_20, CK);
not inst47  (_net_21, SE);
not inst48  (_net_22, SI);
and inst49  (ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI, _net_19, _net_20, SD, _net_21, _net_22);
not inst50  (_net_23, D);
not inst51  (_net_24, CK);
not inst52  (_net_25, SE);
and inst53  (ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_SI, _net_23, _net_24, SD, _net_25, SI);
not inst54  (_net_26, D);
not inst55  (_net_27, CK);
not inst56  (_net_28, SI);
and inst57  (ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_SE_AND_NOT_SI, _net_26, _net_27, SD, SE, _net_28);
not inst58  (_net_29, D);
not inst59  (_net_30, CK);
and inst60  (ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_SE_AND_SI, _net_29, _net_30, SD, SE, SI);
not inst61  (_net_31, CK);
not inst62  (_net_32, SE);
not inst63  (_net_33, SI);
and inst64  (ENABLE_NOT_CK_AND_D_AND_SD_AND_NOT_SE_AND_NOT_SI, D, _net_31, SD, _net_32, _net_33);
not inst65  (_net_34, CK);
not inst66  (_net_35, SE);
and inst67  (ENABLE_NOT_CK_AND_D_AND_SD_AND_NOT_SE_AND_SI, D, _net_34, SD, _net_35, SI);
not inst68  (_net_36, CK);
not inst69  (_net_37, SI);
and inst70  (ENABLE_NOT_CK_AND_D_AND_SD_AND_SE_AND_NOT_SI, D, _net_36, SD, SE, _net_37);
not inst71  (_net_38, CK);
and inst72  (ENABLE_NOT_CK_AND_D_AND_SD_AND_SE_AND_SI, D, _net_38, SD, SE, SI);
not inst73  (_net_39, D);
not inst74  (_net_40, SE);
not inst75  (_net_41, SI);
and inst76  (ENABLE_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI, _net_39, CK, SD, _net_40, _net_41);
not inst77  (_net_42, D);
not inst78  (_net_43, SE);
and inst79  (ENABLE_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_SI, _net_42, CK, SD, _net_43, SI);
not inst80  (_net_44, D);
not inst81  (_net_45, SI);
and inst82  (ENABLE_CK_AND_NOT_D_AND_SD_AND_SE_AND_NOT_SI, _net_44, CK, SD, SE, _net_45);
not inst83  (_net_46, D);
and inst84  (ENABLE_CK_AND_NOT_D_AND_SD_AND_SE_AND_SI, _net_46, CK, SD, SE, SI);
not inst85  (_net_47, SE);
not inst86  (_net_48, SI);
and inst87  (ENABLE_CK_AND_D_AND_SD_AND_NOT_SE_AND_NOT_SI, D, CK, SD, _net_47, _net_48);
not inst88  (_net_49, SE);
and inst89  (ENABLE_CK_AND_D_AND_SD_AND_NOT_SE_AND_SI, D, CK, SD, _net_49, SI);
not inst90  (_net_50, SI);
and inst91  (ENABLE_CK_AND_D_AND_SD_AND_SE_AND_NOT_SI, D, CK, SD, SE, _net_50);
and inst92  (ENABLE_CK_AND_D_AND_SD_AND_SE_AND_SI, D, CK, SD, SE, SI);
not inst93  (_net_51, D);
not inst94  (_net_52, CK);
not inst95  (_net_53, SE);
not inst96  (_net_54, SI);
and inst97  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_51, _net_52, _net_53, _net_54);
not inst98  (_net_55, D);
not inst99  (_net_56, CK);
not inst100  (_net_57, SE);
and inst101  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_55, _net_56, _net_57, SI);
not inst102  (_net_58, D);
not inst103  (_net_59, CK);
not inst104  (_net_60, SI);
and inst105  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_58, _net_59, SE, _net_60);
not inst106  (_net_61, D);
not inst107  (_net_62, CK);
and inst108  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_61, _net_62, SE, SI);
not inst109  (_net_63, CK);
not inst110  (_net_64, SE);
not inst111  (_net_65, SI);
and inst112  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_63, _net_64, _net_65);
not inst113  (_net_66, CK);
not inst114  (_net_67, SE);
and inst115  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_66, _net_67, SI);
not inst116  (_net_68, CK);
not inst117  (_net_69, SI);
and inst118  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_68, SE, _net_69);
not inst119  (_net_70, CK);
and inst120  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_70, SE, SI);
not inst121  (_net_71, D);
not inst122  (_net_72, SE);
not inst123  (_net_73, SI);
and inst124  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_71, CK, _net_72, _net_73);
not inst125  (_net_74, D);
not inst126  (_net_75, SE);
and inst127  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_74, CK, _net_75, SI);
not inst128  (_net_76, D);
not inst129  (_net_77, SI);
and inst130  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_76, CK, SE, _net_77);
not inst131  (_net_78, D);
and inst132  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_78, CK, SE, SI);
not inst133  (_net_79, SE);
not inst134  (_net_80, SI);
and inst135  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_79, _net_80);
not inst136  (_net_81, SE);
and inst137  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_81, SI);
not inst138  (_net_82, SI);
and inst139  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_82);
and inst140  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst141  (_net_83, D);
not inst142  (_net_84, SE);
not inst143  (_net_85, SI);
and inst144  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_83, _net_84, _net_85);
not inst145  (_net_86, D);
not inst146  (_net_87, SE);
and inst147  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_86, _net_87, SI);
not inst148  (_net_88, D);
not inst149  (_net_89, SI);
and inst150  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_88, SE, _net_89);
not inst151  (_net_90, SI);
and inst152  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_90);
not inst153  (_net_91, D);
not inst154  (_net_92, CK);
not inst155  (_net_93, SE);
not inst156  (_net_94, SI);
and inst157  (ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_91, _net_92, RD, _net_93, _net_94);
not inst158  (_net_95, D);
not inst159  (_net_96, CK);
not inst160  (_net_97, SE);
and inst161  (ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_SI, _net_95, _net_96, RD, _net_97, SI);
not inst162  (_net_98, D);
not inst163  (_net_99, CK);
not inst164  (_net_100, SI);
and inst165  (ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_SE_AND_NOT_SI, _net_98, _net_99, RD, SE, _net_100);
not inst166  (_net_101, D);
not inst167  (_net_102, CK);
and inst168  (ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_SE_AND_SI, _net_101, _net_102, RD, SE, SI);
not inst169  (_net_103, CK);
not inst170  (_net_104, SE);
not inst171  (_net_105, SI);
and inst172  (ENABLE_NOT_CK_AND_D_AND_RD_AND_NOT_SE_AND_NOT_SI, D, _net_103, RD, _net_104, _net_105);
not inst173  (_net_106, CK);
not inst174  (_net_107, SE);
and inst175  (ENABLE_NOT_CK_AND_D_AND_RD_AND_NOT_SE_AND_SI, D, _net_106, RD, _net_107, SI);
not inst176  (_net_108, CK);
not inst177  (_net_109, SI);
and inst178  (ENABLE_NOT_CK_AND_D_AND_RD_AND_SE_AND_NOT_SI, D, _net_108, RD, SE, _net_109);
not inst179  (_net_110, CK);
and inst180  (ENABLE_NOT_CK_AND_D_AND_RD_AND_SE_AND_SI, D, _net_110, RD, SE, SI);
not inst181  (_net_111, D);
not inst182  (_net_112, SE);
not inst183  (_net_113, SI);
and inst184  (ENABLE_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_111, CK, RD, _net_112, _net_113);
not inst185  (_net_114, D);
not inst186  (_net_115, SE);
and inst187  (ENABLE_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_SI, _net_114, CK, RD, _net_115, SI);
not inst188  (_net_116, D);
not inst189  (_net_117, SI);
and inst190  (ENABLE_CK_AND_NOT_D_AND_RD_AND_SE_AND_NOT_SI, _net_116, CK, RD, SE, _net_117);
not inst191  (_net_118, D);
and inst192  (ENABLE_CK_AND_NOT_D_AND_RD_AND_SE_AND_SI, _net_118, CK, RD, SE, SI);
not inst193  (_net_119, SE);
not inst194  (_net_120, SI);
and inst195  (ENABLE_CK_AND_D_AND_RD_AND_NOT_SE_AND_NOT_SI, D, CK, RD, _net_119, _net_120);
not inst196  (_net_121, SE);
and inst197  (ENABLE_CK_AND_D_AND_RD_AND_NOT_SE_AND_SI, D, CK, RD, _net_121, SI);
not inst198  (_net_122, SI);
and inst199  (ENABLE_CK_AND_D_AND_RD_AND_SE_AND_NOT_SI, D, CK, RD, SE, _net_122);
and inst200  (ENABLE_CK_AND_D_AND_RD_AND_SE_AND_SI, D, CK, RD, SE, SI);
not inst201  (_net_123, D);
and inst202  (ENABLE_NOT_D_AND_RD_AND_SD_AND_SI, RD, _net_123, SD, SI);
not inst203  (_net_124, SI);
and inst204  (ENABLE_D_AND_RD_AND_SD_AND_NOT_SI, RD, D, SD, _net_124);
not inst205  (_net_125, D);
and inst206  (ENABLE_NOT_D_AND_RD_AND_SD_AND_SE, RD, _net_125, SD, SE);
and inst207  (ENABLE_D_AND_RD_AND_SD_AND_SE, RD, D, SD, SE);

specify
if (CK==1'b0 && D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (CK==1'b1 && D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$recrem(posedge RD &&& ENABLE_D_AND_SD_AND_SE_AND_SI , posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , posedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , posedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , posedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , posedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(posedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , posedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , posedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , posedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , posedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , posedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , posedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , posedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , posedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , posedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , posedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , posedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , posedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(posedge RD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , posedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPRBSBQ_V2Y4_4

//%BEGIN HDBSVT11_FSDPSBQ_DY2_4

`celldefine
module HDBSVT11_FSDPSBQ_DY2_4 (Q, CK, D, SI, SE, SD);
   output Q;
   input CK, D, SI, SE, SD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_SD;

   wire int_res__D, int_res__SD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_SD, SD);
`endif

   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst6  (int_res__SD, delayed_SD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_s_err inst7  (xcr_0, delayed_CK, int_res__D, int_res__SD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_s #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res__D, int_res__SD, xcr_0);

    `else
        snps_dff_s inst9  (Q, viol_0, delayed_CK, int_res__D, int_res__SD, xcr_0);

    `endif

    `ifdef VIRL_functiononly

    `else

not inst10  (_net_0, D);
not inst11  (_net_1, SE);
not inst12  (_net_2, SI);
and inst13  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, _net_0, _net_1, _net_2);
not inst14  (_net_3, D);
not inst15  (_net_4, SE);
and inst16  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI, SD, _net_3, _net_4, SI);
not inst17  (_net_5, D);
not inst18  (_net_6, SI);
and inst19  (ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI, SD, _net_5, SE, _net_6);
not inst20  (_net_7, D);
and inst21  (ENABLE_NOT_D_AND_SD_AND_SE_AND_SI, SD, _net_7, SE, SI);
not inst22  (_net_8, SE);
not inst23  (_net_9, SI);
and inst24  (ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, D, _net_8, _net_9);
not inst25  (_net_10, SE);
and inst26  (ENABLE_D_AND_SD_AND_NOT_SE_AND_SI, SD, D, _net_10, SI);
not inst27  (_net_11, SI);
and inst28  (ENABLE_D_AND_SD_AND_SE_AND_NOT_SI, SD, D, SE, _net_11);
and inst29  (ENABLE_D_AND_SD_AND_SE_AND_SI, SD, D, SE, SI);
not inst30  (_net_12, SE);
not inst31  (_net_13, SI);
and inst32  (ENABLE_SD_AND_NOT_SE_AND_NOT_SI, _net_12, SD, _net_13);
not inst33  (_net_14, SE);
and inst34  (ENABLE_SD_AND_NOT_SE_AND_SI, _net_14, SD, SI);
not inst35  (_net_15, SE);
not inst36  (_net_16, D);
not inst37  (_net_17, SI);
and inst38  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_15, _net_16, _net_17);
not inst39  (_net_18, SE);
not inst40  (_net_19, D);
and inst41  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_18, _net_19, SI);
not inst42  (_net_20, D);
not inst43  (_net_21, SI);
and inst44  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_20, _net_21);
not inst45  (_net_22, SI);
and inst46  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_22);
not inst47  (_net_23, D);
not inst48  (_net_24, CK);
not inst49  (_net_25, SE);
not inst50  (_net_26, SI);
and inst51  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25, _net_26);
not inst52  (_net_27, D);
not inst53  (_net_28, CK);
not inst54  (_net_29, SE);
and inst55  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_27, _net_28, _net_29, SI);
not inst56  (_net_30, D);
not inst57  (_net_31, CK);
not inst58  (_net_32, SI);
and inst59  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_30, _net_31, SE, _net_32);
not inst60  (_net_33, D);
not inst61  (_net_34, CK);
and inst62  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_33, _net_34, SE, SI);
not inst63  (_net_35, CK);
not inst64  (_net_36, SE);
not inst65  (_net_37, SI);
and inst66  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_35, _net_36, _net_37);
not inst67  (_net_38, CK);
not inst68  (_net_39, SE);
and inst69  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_38, _net_39, SI);
not inst70  (_net_40, CK);
not inst71  (_net_41, SI);
and inst72  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_40, SE, _net_41);
not inst73  (_net_42, CK);
and inst74  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_42, SE, SI);
not inst75  (_net_43, D);
not inst76  (_net_44, SE);
not inst77  (_net_45, SI);
and inst78  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_43, CK, _net_44, _net_45);
not inst79  (_net_46, D);
not inst80  (_net_47, SE);
and inst81  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_46, CK, _net_47, SI);
not inst82  (_net_48, D);
not inst83  (_net_49, SI);
and inst84  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_48, CK, SE, _net_49);
not inst85  (_net_50, D);
and inst86  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_50, CK, SE, SI);
not inst87  (_net_51, SE);
not inst88  (_net_52, SI);
and inst89  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_51, _net_52);
not inst90  (_net_53, SE);
and inst91  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_53, SI);
not inst92  (_net_54, SI);
and inst93  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_54);
and inst94  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst95  (_net_55, D);
and inst96  (ENABLE_NOT_D_AND_SD_AND_SI, SD, _net_55, SI);
not inst97  (_net_56, SI);
and inst98  (ENABLE_D_AND_SD_AND_NOT_SI, SD, D, _net_56);
not inst99  (_net_57, D);
and inst100  (ENABLE_NOT_D_AND_SD_AND_SE, SD, _net_57, SE);
and inst101  (ENABLE_D_AND_SD_AND_SE, SD, D, SE);

specify
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_D_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , posedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , negedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPSBQ_DY2_4

//%BEGIN HDBSVT11_FSDPSBQ_V2Y2_1

`celldefine
module HDBSVT11_FSDPSBQ_V2Y2_1 (Q, CK, D, SI, SE, SD);
   output Q;
   input CK, D, SI, SE, SD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_SD;

   wire int_res__D, int_res__SD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_SD, SD);
`endif

   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst6  (int_res__SD, delayed_SD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_s_err inst7  (xcr_0, delayed_CK, int_res__D, int_res__SD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_s #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res__D, int_res__SD, xcr_0);

    `else
        snps_dff_s inst9  (Q, viol_0, delayed_CK, int_res__D, int_res__SD, xcr_0);

    `endif

    `ifdef VIRL_functiononly

    `else

not inst10  (_net_0, D);
not inst11  (_net_1, SE);
not inst12  (_net_2, SI);
and inst13  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, _net_0, _net_1, _net_2);
not inst14  (_net_3, D);
not inst15  (_net_4, SE);
and inst16  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI, SD, _net_3, _net_4, SI);
not inst17  (_net_5, D);
not inst18  (_net_6, SI);
and inst19  (ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI, SD, _net_5, SE, _net_6);
not inst20  (_net_7, D);
and inst21  (ENABLE_NOT_D_AND_SD_AND_SE_AND_SI, SD, _net_7, SE, SI);
not inst22  (_net_8, SE);
not inst23  (_net_9, SI);
and inst24  (ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, D, _net_8, _net_9);
not inst25  (_net_10, SE);
and inst26  (ENABLE_D_AND_SD_AND_NOT_SE_AND_SI, SD, D, _net_10, SI);
not inst27  (_net_11, SI);
and inst28  (ENABLE_D_AND_SD_AND_SE_AND_NOT_SI, SD, D, SE, _net_11);
and inst29  (ENABLE_D_AND_SD_AND_SE_AND_SI, SD, D, SE, SI);
not inst30  (_net_12, SE);
not inst31  (_net_13, SI);
and inst32  (ENABLE_SD_AND_NOT_SE_AND_NOT_SI, _net_12, SD, _net_13);
not inst33  (_net_14, SE);
and inst34  (ENABLE_SD_AND_NOT_SE_AND_SI, _net_14, SD, SI);
not inst35  (_net_15, SE);
not inst36  (_net_16, D);
not inst37  (_net_17, SI);
and inst38  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_15, _net_16, _net_17);
not inst39  (_net_18, SE);
not inst40  (_net_19, D);
and inst41  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_18, _net_19, SI);
not inst42  (_net_20, D);
not inst43  (_net_21, SI);
and inst44  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_20, _net_21);
not inst45  (_net_22, SI);
and inst46  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_22);
not inst47  (_net_23, D);
not inst48  (_net_24, CK);
not inst49  (_net_25, SE);
not inst50  (_net_26, SI);
and inst51  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25, _net_26);
not inst52  (_net_27, D);
not inst53  (_net_28, CK);
not inst54  (_net_29, SE);
and inst55  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_27, _net_28, _net_29, SI);
not inst56  (_net_30, D);
not inst57  (_net_31, CK);
not inst58  (_net_32, SI);
and inst59  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_30, _net_31, SE, _net_32);
not inst60  (_net_33, D);
not inst61  (_net_34, CK);
and inst62  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_33, _net_34, SE, SI);
not inst63  (_net_35, CK);
not inst64  (_net_36, SE);
not inst65  (_net_37, SI);
and inst66  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_35, _net_36, _net_37);
not inst67  (_net_38, CK);
not inst68  (_net_39, SE);
and inst69  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_38, _net_39, SI);
not inst70  (_net_40, CK);
not inst71  (_net_41, SI);
and inst72  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_40, SE, _net_41);
not inst73  (_net_42, CK);
and inst74  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_42, SE, SI);
not inst75  (_net_43, D);
not inst76  (_net_44, SE);
not inst77  (_net_45, SI);
and inst78  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_43, CK, _net_44, _net_45);
not inst79  (_net_46, D);
not inst80  (_net_47, SE);
and inst81  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_46, CK, _net_47, SI);
not inst82  (_net_48, D);
not inst83  (_net_49, SI);
and inst84  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_48, CK, SE, _net_49);
not inst85  (_net_50, D);
and inst86  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_50, CK, SE, SI);
not inst87  (_net_51, SE);
not inst88  (_net_52, SI);
and inst89  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_51, _net_52);
not inst90  (_net_53, SE);
and inst91  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_53, SI);
not inst92  (_net_54, SI);
and inst93  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_54);
and inst94  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst95  (_net_55, D);
and inst96  (ENABLE_NOT_D_AND_SD_AND_SI, SD, _net_55, SI);
not inst97  (_net_56, SI);
and inst98  (ENABLE_D_AND_SD_AND_NOT_SI, SD, D, _net_56);
not inst99  (_net_57, D);
and inst100  (ENABLE_NOT_D_AND_SD_AND_SE, SD, _net_57, SE);
and inst101  (ENABLE_D_AND_SD_AND_SE, SD, D, SE);

specify
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_D_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , posedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , negedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPSBQ_V2Y2_1

//%BEGIN HDBSVT11_FSDPSBQ_V2Y2_2

`celldefine
module HDBSVT11_FSDPSBQ_V2Y2_2 (Q, CK, D, SI, SE, SD);
   output Q;
   input CK, D, SI, SE, SD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_SD;

   wire int_res__D, int_res__SD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_SD, SD);
`endif

   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst6  (int_res__SD, delayed_SD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_s_err inst7  (xcr_0, delayed_CK, int_res__D, int_res__SD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_s #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res__D, int_res__SD, xcr_0);

    `else
        snps_dff_s inst9  (Q, viol_0, delayed_CK, int_res__D, int_res__SD, xcr_0);

    `endif

    `ifdef VIRL_functiononly

    `else

not inst10  (_net_0, D);
not inst11  (_net_1, SE);
not inst12  (_net_2, SI);
and inst13  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, _net_0, _net_1, _net_2);
not inst14  (_net_3, D);
not inst15  (_net_4, SE);
and inst16  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI, SD, _net_3, _net_4, SI);
not inst17  (_net_5, D);
not inst18  (_net_6, SI);
and inst19  (ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI, SD, _net_5, SE, _net_6);
not inst20  (_net_7, D);
and inst21  (ENABLE_NOT_D_AND_SD_AND_SE_AND_SI, SD, _net_7, SE, SI);
not inst22  (_net_8, SE);
not inst23  (_net_9, SI);
and inst24  (ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, D, _net_8, _net_9);
not inst25  (_net_10, SE);
and inst26  (ENABLE_D_AND_SD_AND_NOT_SE_AND_SI, SD, D, _net_10, SI);
not inst27  (_net_11, SI);
and inst28  (ENABLE_D_AND_SD_AND_SE_AND_NOT_SI, SD, D, SE, _net_11);
and inst29  (ENABLE_D_AND_SD_AND_SE_AND_SI, SD, D, SE, SI);
not inst30  (_net_12, SE);
not inst31  (_net_13, SI);
and inst32  (ENABLE_SD_AND_NOT_SE_AND_NOT_SI, _net_12, SD, _net_13);
not inst33  (_net_14, SE);
and inst34  (ENABLE_SD_AND_NOT_SE_AND_SI, _net_14, SD, SI);
not inst35  (_net_15, SE);
not inst36  (_net_16, D);
not inst37  (_net_17, SI);
and inst38  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_15, _net_16, _net_17);
not inst39  (_net_18, SE);
not inst40  (_net_19, D);
and inst41  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_18, _net_19, SI);
not inst42  (_net_20, D);
not inst43  (_net_21, SI);
and inst44  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_20, _net_21);
not inst45  (_net_22, SI);
and inst46  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_22);
not inst47  (_net_23, D);
not inst48  (_net_24, CK);
not inst49  (_net_25, SE);
not inst50  (_net_26, SI);
and inst51  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25, _net_26);
not inst52  (_net_27, D);
not inst53  (_net_28, CK);
not inst54  (_net_29, SE);
and inst55  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_27, _net_28, _net_29, SI);
not inst56  (_net_30, D);
not inst57  (_net_31, CK);
not inst58  (_net_32, SI);
and inst59  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_30, _net_31, SE, _net_32);
not inst60  (_net_33, D);
not inst61  (_net_34, CK);
and inst62  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_33, _net_34, SE, SI);
not inst63  (_net_35, CK);
not inst64  (_net_36, SE);
not inst65  (_net_37, SI);
and inst66  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_35, _net_36, _net_37);
not inst67  (_net_38, CK);
not inst68  (_net_39, SE);
and inst69  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_38, _net_39, SI);
not inst70  (_net_40, CK);
not inst71  (_net_41, SI);
and inst72  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_40, SE, _net_41);
not inst73  (_net_42, CK);
and inst74  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_42, SE, SI);
not inst75  (_net_43, D);
not inst76  (_net_44, SE);
not inst77  (_net_45, SI);
and inst78  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_43, CK, _net_44, _net_45);
not inst79  (_net_46, D);
not inst80  (_net_47, SE);
and inst81  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_46, CK, _net_47, SI);
not inst82  (_net_48, D);
not inst83  (_net_49, SI);
and inst84  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_48, CK, SE, _net_49);
not inst85  (_net_50, D);
and inst86  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_50, CK, SE, SI);
not inst87  (_net_51, SE);
not inst88  (_net_52, SI);
and inst89  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_51, _net_52);
not inst90  (_net_53, SE);
and inst91  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_53, SI);
not inst92  (_net_54, SI);
and inst93  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_54);
and inst94  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst95  (_net_55, D);
and inst96  (ENABLE_NOT_D_AND_SD_AND_SI, SD, _net_55, SI);
not inst97  (_net_56, SI);
and inst98  (ENABLE_D_AND_SD_AND_NOT_SI, SD, D, _net_56);
not inst99  (_net_57, D);
and inst100  (ENABLE_NOT_D_AND_SD_AND_SE, SD, _net_57, SE);
and inst101  (ENABLE_D_AND_SD_AND_SE, SD, D, SE);

specify
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_D_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , posedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , negedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPSBQ_V2Y2_2

//%BEGIN HDBSVT11_FSDPSBQ_V2Y2_4

`celldefine
module HDBSVT11_FSDPSBQ_V2Y2_4 (Q, CK, D, SI, SE, SD);
   output Q;
   input CK, D, SI, SE, SD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_SD;

   wire int_res__D, int_res__SD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_SD, SD);
`endif

   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst6  (int_res__SD, delayed_SD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_s_err inst7  (xcr_0, delayed_CK, int_res__D, int_res__SD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_s #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res__D, int_res__SD, xcr_0);

    `else
        snps_dff_s inst9  (Q, viol_0, delayed_CK, int_res__D, int_res__SD, xcr_0);

    `endif

    `ifdef VIRL_functiononly

    `else

not inst10  (_net_0, D);
not inst11  (_net_1, SE);
not inst12  (_net_2, SI);
and inst13  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, _net_0, _net_1, _net_2);
not inst14  (_net_3, D);
not inst15  (_net_4, SE);
and inst16  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI, SD, _net_3, _net_4, SI);
not inst17  (_net_5, D);
not inst18  (_net_6, SI);
and inst19  (ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI, SD, _net_5, SE, _net_6);
not inst20  (_net_7, D);
and inst21  (ENABLE_NOT_D_AND_SD_AND_SE_AND_SI, SD, _net_7, SE, SI);
not inst22  (_net_8, SE);
not inst23  (_net_9, SI);
and inst24  (ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, D, _net_8, _net_9);
not inst25  (_net_10, SE);
and inst26  (ENABLE_D_AND_SD_AND_NOT_SE_AND_SI, SD, D, _net_10, SI);
not inst27  (_net_11, SI);
and inst28  (ENABLE_D_AND_SD_AND_SE_AND_NOT_SI, SD, D, SE, _net_11);
and inst29  (ENABLE_D_AND_SD_AND_SE_AND_SI, SD, D, SE, SI);
not inst30  (_net_12, SE);
not inst31  (_net_13, SI);
and inst32  (ENABLE_SD_AND_NOT_SE_AND_NOT_SI, _net_12, SD, _net_13);
not inst33  (_net_14, SE);
and inst34  (ENABLE_SD_AND_NOT_SE_AND_SI, _net_14, SD, SI);
not inst35  (_net_15, SE);
not inst36  (_net_16, D);
not inst37  (_net_17, SI);
and inst38  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_15, _net_16, _net_17);
not inst39  (_net_18, SE);
not inst40  (_net_19, D);
and inst41  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_18, _net_19, SI);
not inst42  (_net_20, D);
not inst43  (_net_21, SI);
and inst44  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_20, _net_21);
not inst45  (_net_22, SI);
and inst46  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_22);
not inst47  (_net_23, D);
not inst48  (_net_24, CK);
not inst49  (_net_25, SE);
not inst50  (_net_26, SI);
and inst51  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25, _net_26);
not inst52  (_net_27, D);
not inst53  (_net_28, CK);
not inst54  (_net_29, SE);
and inst55  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_27, _net_28, _net_29, SI);
not inst56  (_net_30, D);
not inst57  (_net_31, CK);
not inst58  (_net_32, SI);
and inst59  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_30, _net_31, SE, _net_32);
not inst60  (_net_33, D);
not inst61  (_net_34, CK);
and inst62  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_33, _net_34, SE, SI);
not inst63  (_net_35, CK);
not inst64  (_net_36, SE);
not inst65  (_net_37, SI);
and inst66  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_35, _net_36, _net_37);
not inst67  (_net_38, CK);
not inst68  (_net_39, SE);
and inst69  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_38, _net_39, SI);
not inst70  (_net_40, CK);
not inst71  (_net_41, SI);
and inst72  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_40, SE, _net_41);
not inst73  (_net_42, CK);
and inst74  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_42, SE, SI);
not inst75  (_net_43, D);
not inst76  (_net_44, SE);
not inst77  (_net_45, SI);
and inst78  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_43, CK, _net_44, _net_45);
not inst79  (_net_46, D);
not inst80  (_net_47, SE);
and inst81  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_46, CK, _net_47, SI);
not inst82  (_net_48, D);
not inst83  (_net_49, SI);
and inst84  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_48, CK, SE, _net_49);
not inst85  (_net_50, D);
and inst86  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_50, CK, SE, SI);
not inst87  (_net_51, SE);
not inst88  (_net_52, SI);
and inst89  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_51, _net_52);
not inst90  (_net_53, SE);
and inst91  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_53, SI);
not inst92  (_net_54, SI);
and inst93  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_54);
and inst94  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst95  (_net_55, D);
and inst96  (ENABLE_NOT_D_AND_SD_AND_SI, SD, _net_55, SI);
not inst97  (_net_56, SI);
and inst98  (ENABLE_D_AND_SD_AND_NOT_SI, SD, D, _net_56);
not inst99  (_net_57, D);
and inst100  (ENABLE_NOT_D_AND_SD_AND_SE, SD, _net_57, SE);
and inst101  (ENABLE_D_AND_SD_AND_SE, SD, D, SE);

specify
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_D_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , posedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , negedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPSBQ_V2Y2_4

//%BEGIN HDBSVT11_FSDPSBQ_Y2_1

`celldefine
module HDBSVT11_FSDPSBQ_Y2_1 (Q, CK, D, SI, SE, SD);
   output Q;
   input CK, D, SI, SE, SD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_SD;

   wire int_res__D, int_res__SD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_SD, SD);
`endif

   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst6  (int_res__SD, delayed_SD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_s_err inst7  (xcr_0, delayed_CK, int_res__D, int_res__SD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_s #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res__D, int_res__SD, xcr_0);

    `else
        snps_dff_s inst9  (Q, viol_0, delayed_CK, int_res__D, int_res__SD, xcr_0);

    `endif

    `ifdef VIRL_functiononly

    `else

not inst10  (_net_0, D);
not inst11  (_net_1, SE);
not inst12  (_net_2, SI);
and inst13  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, _net_0, _net_1, _net_2);
not inst14  (_net_3, D);
not inst15  (_net_4, SE);
and inst16  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI, SD, _net_3, _net_4, SI);
not inst17  (_net_5, D);
not inst18  (_net_6, SI);
and inst19  (ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI, SD, _net_5, SE, _net_6);
not inst20  (_net_7, D);
and inst21  (ENABLE_NOT_D_AND_SD_AND_SE_AND_SI, SD, _net_7, SE, SI);
not inst22  (_net_8, SE);
not inst23  (_net_9, SI);
and inst24  (ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, D, _net_8, _net_9);
not inst25  (_net_10, SE);
and inst26  (ENABLE_D_AND_SD_AND_NOT_SE_AND_SI, SD, D, _net_10, SI);
not inst27  (_net_11, SI);
and inst28  (ENABLE_D_AND_SD_AND_SE_AND_NOT_SI, SD, D, SE, _net_11);
and inst29  (ENABLE_D_AND_SD_AND_SE_AND_SI, SD, D, SE, SI);
not inst30  (_net_12, SE);
not inst31  (_net_13, SI);
and inst32  (ENABLE_SD_AND_NOT_SE_AND_NOT_SI, _net_12, SD, _net_13);
not inst33  (_net_14, SE);
and inst34  (ENABLE_SD_AND_NOT_SE_AND_SI, _net_14, SD, SI);
not inst35  (_net_15, SE);
not inst36  (_net_16, D);
not inst37  (_net_17, SI);
and inst38  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_15, _net_16, _net_17);
not inst39  (_net_18, SE);
not inst40  (_net_19, D);
and inst41  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_18, _net_19, SI);
not inst42  (_net_20, D);
not inst43  (_net_21, SI);
and inst44  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_20, _net_21);
not inst45  (_net_22, SI);
and inst46  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_22);
not inst47  (_net_23, D);
not inst48  (_net_24, CK);
not inst49  (_net_25, SE);
not inst50  (_net_26, SI);
and inst51  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25, _net_26);
not inst52  (_net_27, D);
not inst53  (_net_28, CK);
not inst54  (_net_29, SE);
and inst55  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_27, _net_28, _net_29, SI);
not inst56  (_net_30, D);
not inst57  (_net_31, CK);
not inst58  (_net_32, SI);
and inst59  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_30, _net_31, SE, _net_32);
not inst60  (_net_33, D);
not inst61  (_net_34, CK);
and inst62  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_33, _net_34, SE, SI);
not inst63  (_net_35, CK);
not inst64  (_net_36, SE);
not inst65  (_net_37, SI);
and inst66  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_35, _net_36, _net_37);
not inst67  (_net_38, CK);
not inst68  (_net_39, SE);
and inst69  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_38, _net_39, SI);
not inst70  (_net_40, CK);
not inst71  (_net_41, SI);
and inst72  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_40, SE, _net_41);
not inst73  (_net_42, CK);
and inst74  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_42, SE, SI);
not inst75  (_net_43, D);
not inst76  (_net_44, SE);
not inst77  (_net_45, SI);
and inst78  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_43, CK, _net_44, _net_45);
not inst79  (_net_46, D);
not inst80  (_net_47, SE);
and inst81  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_46, CK, _net_47, SI);
not inst82  (_net_48, D);
not inst83  (_net_49, SI);
and inst84  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_48, CK, SE, _net_49);
not inst85  (_net_50, D);
and inst86  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_50, CK, SE, SI);
not inst87  (_net_51, SE);
not inst88  (_net_52, SI);
and inst89  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_51, _net_52);
not inst90  (_net_53, SE);
and inst91  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_53, SI);
not inst92  (_net_54, SI);
and inst93  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_54);
and inst94  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst95  (_net_55, D);
and inst96  (ENABLE_NOT_D_AND_SD_AND_SI, SD, _net_55, SI);
not inst97  (_net_56, SI);
and inst98  (ENABLE_D_AND_SD_AND_NOT_SI, SD, D, _net_56);
not inst99  (_net_57, D);
and inst100  (ENABLE_NOT_D_AND_SD_AND_SE, SD, _net_57, SE);
and inst101  (ENABLE_D_AND_SD_AND_SE, SD, D, SE);

specify
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_D_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , posedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , negedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPSBQ_Y2_1

//%BEGIN HDBSVT11_FSDPSBQ_Y2_4

`celldefine
module HDBSVT11_FSDPSBQ_Y2_4 (Q, CK, D, SI, SE, SD);
   output Q;
   input CK, D, SI, SE, SD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_SD;

   wire int_res__D, int_res__SD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_SD, SD);
`endif

   snps_mux2 inst5  (int_res__D, delayed_SI, delayed_D, delayed_SE);
   not inst6  (int_res__SD, delayed_SD);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_s_err inst7  (xcr_0, delayed_CK, int_res__D, int_res__SD);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff_s #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res__D, int_res__SD, xcr_0);

    `else
        snps_dff_s inst9  (Q, viol_0, delayed_CK, int_res__D, int_res__SD, xcr_0);

    `endif

    `ifdef VIRL_functiononly

    `else

not inst10  (_net_0, D);
not inst11  (_net_1, SE);
not inst12  (_net_2, SI);
and inst13  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, _net_0, _net_1, _net_2);
not inst14  (_net_3, D);
not inst15  (_net_4, SE);
and inst16  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI, SD, _net_3, _net_4, SI);
not inst17  (_net_5, D);
not inst18  (_net_6, SI);
and inst19  (ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI, SD, _net_5, SE, _net_6);
not inst20  (_net_7, D);
and inst21  (ENABLE_NOT_D_AND_SD_AND_SE_AND_SI, SD, _net_7, SE, SI);
not inst22  (_net_8, SE);
not inst23  (_net_9, SI);
and inst24  (ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, D, _net_8, _net_9);
not inst25  (_net_10, SE);
and inst26  (ENABLE_D_AND_SD_AND_NOT_SE_AND_SI, SD, D, _net_10, SI);
not inst27  (_net_11, SI);
and inst28  (ENABLE_D_AND_SD_AND_SE_AND_NOT_SI, SD, D, SE, _net_11);
and inst29  (ENABLE_D_AND_SD_AND_SE_AND_SI, SD, D, SE, SI);
not inst30  (_net_12, SE);
not inst31  (_net_13, SI);
and inst32  (ENABLE_SD_AND_NOT_SE_AND_NOT_SI, _net_12, SD, _net_13);
not inst33  (_net_14, SE);
and inst34  (ENABLE_SD_AND_NOT_SE_AND_SI, _net_14, SD, SI);
not inst35  (_net_15, SE);
not inst36  (_net_16, D);
not inst37  (_net_17, SI);
and inst38  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_15, _net_16, _net_17);
not inst39  (_net_18, SE);
not inst40  (_net_19, D);
and inst41  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_18, _net_19, SI);
not inst42  (_net_20, D);
not inst43  (_net_21, SI);
and inst44  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_20, _net_21);
not inst45  (_net_22, SI);
and inst46  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_22);
not inst47  (_net_23, D);
not inst48  (_net_24, CK);
not inst49  (_net_25, SE);
not inst50  (_net_26, SI);
and inst51  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_23, _net_24, _net_25, _net_26);
not inst52  (_net_27, D);
not inst53  (_net_28, CK);
not inst54  (_net_29, SE);
and inst55  (ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_27, _net_28, _net_29, SI);
not inst56  (_net_30, D);
not inst57  (_net_31, CK);
not inst58  (_net_32, SI);
and inst59  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_30, _net_31, SE, _net_32);
not inst60  (_net_33, D);
not inst61  (_net_34, CK);
and inst62  (ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI, _net_33, _net_34, SE, SI);
not inst63  (_net_35, CK);
not inst64  (_net_36, SE);
not inst65  (_net_37, SI);
and inst66  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, _net_35, _net_36, _net_37);
not inst67  (_net_38, CK);
not inst68  (_net_39, SE);
and inst69  (ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI, D, _net_38, _net_39, SI);
not inst70  (_net_40, CK);
not inst71  (_net_41, SI);
and inst72  (ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI, D, _net_40, SE, _net_41);
not inst73  (_net_42, CK);
and inst74  (ENABLE_NOT_CK_AND_D_AND_SE_AND_SI, D, _net_42, SE, SI);
not inst75  (_net_43, D);
not inst76  (_net_44, SE);
not inst77  (_net_45, SI);
and inst78  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_43, CK, _net_44, _net_45);
not inst79  (_net_46, D);
not inst80  (_net_47, SE);
and inst81  (ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI, _net_46, CK, _net_47, SI);
not inst82  (_net_48, D);
not inst83  (_net_49, SI);
and inst84  (ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI, _net_48, CK, SE, _net_49);
not inst85  (_net_50, D);
and inst86  (ENABLE_CK_AND_NOT_D_AND_SE_AND_SI, _net_50, CK, SE, SI);
not inst87  (_net_51, SE);
not inst88  (_net_52, SI);
and inst89  (ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI, D, CK, _net_51, _net_52);
not inst90  (_net_53, SE);
and inst91  (ENABLE_CK_AND_D_AND_NOT_SE_AND_SI, D, CK, _net_53, SI);
not inst92  (_net_54, SI);
and inst93  (ENABLE_CK_AND_D_AND_SE_AND_NOT_SI, D, CK, SE, _net_54);
and inst94  (ENABLE_CK_AND_D_AND_SE_AND_SI, D, CK, SE, SI);
not inst95  (_net_55, D);
and inst96  (ENABLE_NOT_D_AND_SD_AND_SI, SD, _net_55, SI);
not inst97  (_net_56, SI);
and inst98  (ENABLE_D_AND_SD_AND_NOT_SI, SD, D, _net_56);
not inst99  (_net_57, D);
and inst100  (ENABLE_NOT_D_AND_SD_AND_SE, SD, _net_57, SE);
and inst101  (ENABLE_D_AND_SD_AND_SE, SD, D, SE);

specify
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$recrem(posedge SD &&& ENABLE_D_AND_SE_AND_NOT_SI , posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_NOT_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_CK_AND_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , posedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , negedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPSBQ_Y2_4

//%BEGIN HDBSVT11_FSDPSYNRBQM2SS_V2Y4_1

`celldefine
module HDBSVT11_FSDPSYNRBQM2SS_V2Y4_1 (Q0, Q1, CK, D0, D1, SI, SE, RD);
   output Q0, Q1;
   input CK, D0, D1, SI, SE, RD;

   reg viol_0, viol_1;
   wire delayed_CK, delayed_D0, delayed_D1,
	delayed_SI, delayed_SE, delayed_RD;

   wire int_res__D0, int_res__D1,  int_res_iq0, int_res_iq1, int_d0, int_d1, xcr_0, xcr_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
   buf inst5  (delayed_RD, RD);
`endif

   and inst6  (int_d0, delayed_D0, delayed_RD);
   snps_mux2 inst7  (int_res__D0, delayed_SI, int_d0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst9  (int_res_iq0, viol_0, delayed_CK, int_res__D0,  xcr_0);

   and inst10  (int_d1, delayed_D1, delayed_RD);
   snps_mux2 inst11  (int_res__D1, int_res_iq0, int_d1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst12  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst13  (int_res_iq1, viol_1, delayed_CK, int_res__D1,  xcr_1);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst14 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst15 (Q1, int_res_iq1);
   `else
        buf inst16  (Q0, int_res_iq0);
        buf inst17  (Q1, int_res_iq1);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst18  (_net_0, D1);
not inst19  (_net_1, D0);
not inst20  (_net_2, RD);
not inst21  (_net_3, SE);
not inst22  (_net_4, SI);
and inst23  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4);
not inst24  (_net_5, D1);
not inst25  (_net_6, D0);
not inst26  (_net_7, RD);
not inst27  (_net_8, SE);
and inst28  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_5, _net_6, _net_7, _net_8, SI);
not inst29  (_net_9, D1);
not inst30  (_net_10, D0);
not inst31  (_net_11, RD);
not inst32  (_net_12, SI);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_9, _net_10, _net_11, SE, _net_12);
not inst34  (_net_13, D1);
not inst35  (_net_14, D0);
not inst36  (_net_15, RD);
and inst37  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_SI, _net_13, _net_14, _net_15, SE, SI);
not inst38  (_net_16, D1);
not inst39  (_net_17, D0);
not inst40  (_net_18, SE);
not inst41  (_net_19, SI);
and inst42  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_16, _net_17, RD, _net_18, _net_19);
not inst43  (_net_20, D1);
not inst44  (_net_21, D0);
not inst45  (_net_22, SE);
and inst46  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI, _net_20, _net_21, RD, _net_22, SI);
not inst47  (_net_23, D1);
not inst48  (_net_24, D0);
not inst49  (_net_25, SI);
and inst50  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI, _net_23, _net_24, RD, SE, _net_25);
not inst51  (_net_26, D1);
not inst52  (_net_27, D0);
and inst53  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI, _net_26, _net_27, RD, SE, SI);
not inst54  (_net_28, D0);
not inst55  (_net_29, RD);
not inst56  (_net_30, SE);
not inst57  (_net_31, SI);
and inst58  (ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_28, _net_29, _net_30, _net_31);
not inst59  (_net_32, D0);
not inst60  (_net_33, RD);
not inst61  (_net_34, SE);
and inst62  (ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_SI, D1, _net_32, _net_33, _net_34, SI);
not inst63  (_net_35, D0);
not inst64  (_net_36, RD);
not inst65  (_net_37, SI);
and inst66  (ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_SE_AND_NOT_SI, D1, _net_35, _net_36, SE, _net_37);
not inst67  (_net_38, D0);
not inst68  (_net_39, RD);
and inst69  (ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_SE_AND_SI, D1, _net_38, _net_39, SE, SI);
not inst70  (_net_40, D0);
not inst71  (_net_41, SE);
not inst72  (_net_42, SI);
and inst73  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_40, RD, _net_41, _net_42);
not inst74  (_net_43, D0);
not inst75  (_net_44, SE);
and inst76  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI, D1, _net_43, RD, _net_44, SI);
not inst77  (_net_45, D0);
not inst78  (_net_46, SI);
and inst79  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI, D1, _net_45, RD, SE, _net_46);
not inst80  (_net_47, D0);
and inst81  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_SI, D1, _net_47, RD, SE, SI);
not inst82  (_net_48, D1);
not inst83  (_net_49, RD);
not inst84  (_net_50, SE);
not inst85  (_net_51, SI);
and inst86  (ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_48, D0, _net_49, _net_50, _net_51);
not inst87  (_net_52, D1);
not inst88  (_net_53, RD);
not inst89  (_net_54, SE);
and inst90  (ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_52, D0, _net_53, _net_54, SI);
not inst91  (_net_55, D1);
not inst92  (_net_56, RD);
not inst93  (_net_57, SI);
and inst94  (ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_55, D0, _net_56, SE, _net_57);
not inst95  (_net_58, D1);
not inst96  (_net_59, RD);
and inst97  (ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_SI, _net_58, D0, _net_59, SE, SI);
not inst98  (_net_60, D1);
not inst99  (_net_61, SE);
not inst100  (_net_62, SI);
and inst101  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_60, D0, RD, _net_61, _net_62);
not inst102  (_net_63, D1);
not inst103  (_net_64, SE);
and inst104  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI, _net_63, D0, RD, _net_64, SI);
not inst105  (_net_65, D1);
not inst106  (_net_66, SI);
and inst107  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI, _net_65, D0, RD, SE, _net_66);
not inst108  (_net_67, D1);
and inst109  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI, _net_67, D0, RD, SE, SI);
not inst110  (_net_68, RD);
not inst111  (_net_69, SE);
not inst112  (_net_70, SI);
and inst113  (ENABLE_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, _net_68, _net_69, _net_70);
not inst114  (_net_71, RD);
not inst115  (_net_72, SE);
and inst116  (ENABLE_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_SI, D1, D0, _net_71, _net_72, SI);
not inst117  (_net_73, RD);
not inst118  (_net_74, SI);
and inst119  (ENABLE_D0_AND_D1_AND_NOT_RD_AND_SE_AND_NOT_SI, D1, D0, _net_73, SE, _net_74);
not inst120  (_net_75, RD);
and inst121  (ENABLE_D0_AND_D1_AND_NOT_RD_AND_SE_AND_SI, D1, D0, _net_75, SE, SI);
not inst122  (_net_76, SE);
not inst123  (_net_77, SI);
and inst124  (ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, RD, _net_76, _net_77);
not inst125  (_net_78, SE);
and inst126  (ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI, D1, D0, RD, _net_78, SI);
not inst127  (_net_79, SI);
and inst128  (ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI, D1, D0, RD, SE, _net_79);
and inst129  (ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_SI, D1, D0, RD, SE, SI);
not inst130  (_net_80, D0);
not inst131  (_net_81, SE);
not inst132  (_net_82, SI);
and inst133  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D1, _net_80, _net_81, _net_82);
not inst134  (_net_83, D0);
not inst135  (_net_84, SE);
and inst136  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI, D1, _net_83, _net_84, SI);
not inst137  (_net_85, D1);
not inst138  (_net_86, SE);
not inst139  (_net_87, SI);
and inst140  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_85, D0, _net_86, _net_87);
not inst141  (_net_88, D1);
not inst142  (_net_89, SE);
and inst143  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_88, D0, _net_89, SI);
not inst144  (_net_90, D1);
not inst145  (_net_91, D0);
not inst146  (_net_92, RD);
and inst147  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SI, _net_90, _net_91, _net_92, SI);
not inst148  (_net_93, D1);
not inst149  (_net_94, D0);
not inst150  (_net_95, SI);
and inst151  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI, _net_93, _net_94, RD, _net_95);
not inst152  (_net_96, D1);
not inst153  (_net_97, D0);
and inst154  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI, _net_96, _net_97, RD, SI);
not inst155  (_net_98, D0);
not inst156  (_net_99, SI);
and inst157  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI, D1, _net_98, RD, _net_99);
not inst158  (_net_100, D1);
not inst159  (_net_101, SI);
and inst160  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI, _net_100, D0, RD, _net_101);
not inst161  (_net_102, RD);
and inst162  (ENABLE_D0_AND_D1_AND_NOT_RD_AND_SI, D1, D0, _net_102, SI);
not inst163  (_net_103, RD);
not inst164  (_net_104, D0);
and inst165  (ENABLE_NOT_D0_AND_NOT_RD_AND_SE, _net_103, _net_104, SE);
not inst166  (_net_105, D0);
and inst167  (ENABLE_NOT_D0_AND_RD_AND_SE, RD, _net_105, SE);
not inst168  (_net_106, RD);
and inst169  (ENABLE_D0_AND_NOT_RD_AND_SE, _net_106, D0, SE);
and inst170  (ENABLE_D0_AND_RD_AND_SE, RD, D0, SE);
not inst171  (_net_107, SE);
not inst172  (_net_108, SI);
and inst173  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_107, RD, _net_108);
not inst174  (_net_109, SE);
and inst175  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_109, RD, SI);

specify
if (D0==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK , 0 ,0, viol_0);
$width(negedge CK , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK , posedge RD , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK , negedge RD , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPSYNRBQM2SS_V2Y4_1

//%BEGIN HDBSVT11_FSDPSYNRBQM2SS_V2Y4_2

`celldefine
module HDBSVT11_FSDPSYNRBQM2SS_V2Y4_2 (Q0, Q1, CK, D0, D1, SI, SE, RD);
   output Q0, Q1;
   input CK, D0, D1, SI, SE, RD;

   reg viol_0, viol_1;
   wire delayed_CK, delayed_D0, delayed_D1,
	delayed_SI, delayed_SE, delayed_RD;

   wire int_res__D0, int_res__D1,  int_res_iq0, int_res_iq1, int_d0, int_d1, xcr_0, xcr_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
   buf inst5  (delayed_RD, RD);
`endif

   and inst6  (int_d0, delayed_D0, delayed_RD);
   snps_mux2 inst7  (int_res__D0, delayed_SI, int_d0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst9  (int_res_iq0, viol_0, delayed_CK, int_res__D0,  xcr_0);

   and inst10  (int_d1, delayed_D1, delayed_RD);
   snps_mux2 inst11  (int_res__D1, int_res_iq0, int_d1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst12  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst13  (int_res_iq1, viol_1, delayed_CK, int_res__D1,  xcr_1);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst14 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst15 (Q1, int_res_iq1);
   `else
        buf inst16  (Q0, int_res_iq0);
        buf inst17  (Q1, int_res_iq1);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst18  (_net_0, D1);
not inst19  (_net_1, D0);
not inst20  (_net_2, RD);
not inst21  (_net_3, SE);
not inst22  (_net_4, SI);
and inst23  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4);
not inst24  (_net_5, D1);
not inst25  (_net_6, D0);
not inst26  (_net_7, RD);
not inst27  (_net_8, SE);
and inst28  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_5, _net_6, _net_7, _net_8, SI);
not inst29  (_net_9, D1);
not inst30  (_net_10, D0);
not inst31  (_net_11, RD);
not inst32  (_net_12, SI);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_9, _net_10, _net_11, SE, _net_12);
not inst34  (_net_13, D1);
not inst35  (_net_14, D0);
not inst36  (_net_15, RD);
and inst37  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_SI, _net_13, _net_14, _net_15, SE, SI);
not inst38  (_net_16, D1);
not inst39  (_net_17, D0);
not inst40  (_net_18, SE);
not inst41  (_net_19, SI);
and inst42  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_16, _net_17, RD, _net_18, _net_19);
not inst43  (_net_20, D1);
not inst44  (_net_21, D0);
not inst45  (_net_22, SE);
and inst46  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI, _net_20, _net_21, RD, _net_22, SI);
not inst47  (_net_23, D1);
not inst48  (_net_24, D0);
not inst49  (_net_25, SI);
and inst50  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI, _net_23, _net_24, RD, SE, _net_25);
not inst51  (_net_26, D1);
not inst52  (_net_27, D0);
and inst53  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI, _net_26, _net_27, RD, SE, SI);
not inst54  (_net_28, D0);
not inst55  (_net_29, RD);
not inst56  (_net_30, SE);
not inst57  (_net_31, SI);
and inst58  (ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_28, _net_29, _net_30, _net_31);
not inst59  (_net_32, D0);
not inst60  (_net_33, RD);
not inst61  (_net_34, SE);
and inst62  (ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_SI, D1, _net_32, _net_33, _net_34, SI);
not inst63  (_net_35, D0);
not inst64  (_net_36, RD);
not inst65  (_net_37, SI);
and inst66  (ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_SE_AND_NOT_SI, D1, _net_35, _net_36, SE, _net_37);
not inst67  (_net_38, D0);
not inst68  (_net_39, RD);
and inst69  (ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_SE_AND_SI, D1, _net_38, _net_39, SE, SI);
not inst70  (_net_40, D0);
not inst71  (_net_41, SE);
not inst72  (_net_42, SI);
and inst73  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_40, RD, _net_41, _net_42);
not inst74  (_net_43, D0);
not inst75  (_net_44, SE);
and inst76  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI, D1, _net_43, RD, _net_44, SI);
not inst77  (_net_45, D0);
not inst78  (_net_46, SI);
and inst79  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI, D1, _net_45, RD, SE, _net_46);
not inst80  (_net_47, D0);
and inst81  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_SI, D1, _net_47, RD, SE, SI);
not inst82  (_net_48, D1);
not inst83  (_net_49, RD);
not inst84  (_net_50, SE);
not inst85  (_net_51, SI);
and inst86  (ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_48, D0, _net_49, _net_50, _net_51);
not inst87  (_net_52, D1);
not inst88  (_net_53, RD);
not inst89  (_net_54, SE);
and inst90  (ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_52, D0, _net_53, _net_54, SI);
not inst91  (_net_55, D1);
not inst92  (_net_56, RD);
not inst93  (_net_57, SI);
and inst94  (ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_55, D0, _net_56, SE, _net_57);
not inst95  (_net_58, D1);
not inst96  (_net_59, RD);
and inst97  (ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_SI, _net_58, D0, _net_59, SE, SI);
not inst98  (_net_60, D1);
not inst99  (_net_61, SE);
not inst100  (_net_62, SI);
and inst101  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_60, D0, RD, _net_61, _net_62);
not inst102  (_net_63, D1);
not inst103  (_net_64, SE);
and inst104  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI, _net_63, D0, RD, _net_64, SI);
not inst105  (_net_65, D1);
not inst106  (_net_66, SI);
and inst107  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI, _net_65, D0, RD, SE, _net_66);
not inst108  (_net_67, D1);
and inst109  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI, _net_67, D0, RD, SE, SI);
not inst110  (_net_68, RD);
not inst111  (_net_69, SE);
not inst112  (_net_70, SI);
and inst113  (ENABLE_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, _net_68, _net_69, _net_70);
not inst114  (_net_71, RD);
not inst115  (_net_72, SE);
and inst116  (ENABLE_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_SI, D1, D0, _net_71, _net_72, SI);
not inst117  (_net_73, RD);
not inst118  (_net_74, SI);
and inst119  (ENABLE_D0_AND_D1_AND_NOT_RD_AND_SE_AND_NOT_SI, D1, D0, _net_73, SE, _net_74);
not inst120  (_net_75, RD);
and inst121  (ENABLE_D0_AND_D1_AND_NOT_RD_AND_SE_AND_SI, D1, D0, _net_75, SE, SI);
not inst122  (_net_76, SE);
not inst123  (_net_77, SI);
and inst124  (ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, RD, _net_76, _net_77);
not inst125  (_net_78, SE);
and inst126  (ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI, D1, D0, RD, _net_78, SI);
not inst127  (_net_79, SI);
and inst128  (ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI, D1, D0, RD, SE, _net_79);
and inst129  (ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_SI, D1, D0, RD, SE, SI);
not inst130  (_net_80, D0);
not inst131  (_net_81, SE);
not inst132  (_net_82, SI);
and inst133  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI, D1, _net_80, _net_81, _net_82);
not inst134  (_net_83, D0);
not inst135  (_net_84, SE);
and inst136  (ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI, D1, _net_83, _net_84, SI);
not inst137  (_net_85, D1);
not inst138  (_net_86, SE);
not inst139  (_net_87, SI);
and inst140  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI, _net_85, D0, _net_86, _net_87);
not inst141  (_net_88, D1);
not inst142  (_net_89, SE);
and inst143  (ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI, _net_88, D0, _net_89, SI);
not inst144  (_net_90, D1);
not inst145  (_net_91, D0);
not inst146  (_net_92, RD);
and inst147  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SI, _net_90, _net_91, _net_92, SI);
not inst148  (_net_93, D1);
not inst149  (_net_94, D0);
not inst150  (_net_95, SI);
and inst151  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI, _net_93, _net_94, RD, _net_95);
not inst152  (_net_96, D1);
not inst153  (_net_97, D0);
and inst154  (ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI, _net_96, _net_97, RD, SI);
not inst155  (_net_98, D0);
not inst156  (_net_99, SI);
and inst157  (ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI, D1, _net_98, RD, _net_99);
not inst158  (_net_100, D1);
not inst159  (_net_101, SI);
and inst160  (ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI, _net_100, D0, RD, _net_101);
not inst161  (_net_102, RD);
and inst162  (ENABLE_D0_AND_D1_AND_NOT_RD_AND_SI, D1, D0, _net_102, SI);
not inst163  (_net_103, RD);
not inst164  (_net_104, D0);
and inst165  (ENABLE_NOT_D0_AND_NOT_RD_AND_SE, _net_103, _net_104, SE);
not inst166  (_net_105, D0);
and inst167  (ENABLE_NOT_D0_AND_RD_AND_SE, RD, _net_105, SE);
not inst168  (_net_106, RD);
and inst169  (ENABLE_D0_AND_NOT_RD_AND_SE, _net_106, D0, SE);
and inst170  (ENABLE_D0_AND_RD_AND_SE, RD, D0, SE);
not inst171  (_net_107, SE);
not inst172  (_net_108, SI);
and inst173  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_107, RD, _net_108);
not inst174  (_net_109, SE);
and inst175  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_109, RD, SI);

specify
if (D0==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK , 0 ,0, viol_0);
$width(negedge CK , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK , posedge RD , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK , negedge RD , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D0_AND_D1_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPSYNRBQM2SS_V2Y4_2

//%BEGIN HDBSVT11_FSDPSYNRBQM4SS_V2Y8_1

`celldefine
module HDBSVT11_FSDPSYNRBQM4SS_V2Y8_1 (Q0, Q1, Q2, Q3, CK, D0, D1, D2, D3, SI, SE, RD);
   output Q0, Q1, Q2, Q3;
   input CK, D0, D1, D2, D3, SI, SE, RD;

   reg viol_0, viol_1, viol_2, viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE, delayed_RD;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res__RD0, int_res__RD1, int_res__RD2, int_res__RD3, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
   buf inst7  (delayed_RD, RD);
`endif
   not inst8  (int_res__RD, delayed_RD);

   and inst9  (int_res__RD0, delayed_D0, delayed_RD);
   and inst10  (int_res__RD1, delayed_D1, delayed_RD);
   and inst11  (int_res__RD2, delayed_D2, delayed_RD);
   and inst12  (int_res__RD3, delayed_D3, delayed_RD);
   

   snps_mux2 inst13  (int_res__D0, delayed_SI, int_res__RD0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst14  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst15  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst16  (int_res__D1, int_res_iq0, int_res__RD1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst17  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst18  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst19  (int_res__D2, int_res_iq1, int_res__RD2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst20  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst21  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst22  (int_res__D3, int_res_iq2, int_res__RD3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst23  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst24  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst25 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst26 (Q1, int_res_iq1);
        buf #`SNPS_SEQ_DELAY  inst27 (Q2, int_res_iq2);
        buf #`SNPS_SEQ_DELAY  inst28 (Q3, int_res_iq3);
   `else
        buf inst29  (Q0, int_res_iq0);
        buf inst30  (Q1, int_res_iq1);
        buf inst31  (Q2, int_res_iq2);
        buf inst32  (Q3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst33  (_net_0, D1);
not inst34  (_net_1, D0);
not inst35  (_net_2, D2);
not inst36  (_net_3, D3);
not inst37  (_net_4, RD);
not inst38  (_net_5, SE);
not inst39  (_net_6, SI);
and inst40  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5, _net_6);
not inst41  (_net_7, D1);
not inst42  (_net_8, D0);
not inst43  (_net_9, D2);
not inst44  (_net_10, D3);
not inst45  (_net_11, RD);
not inst46  (_net_12, SE);
and inst47  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_7, _net_8, _net_9, _net_10, _net_11, _net_12, SI);
not inst48  (_net_13, D1);
not inst49  (_net_14, D0);
not inst50  (_net_15, D2);
not inst51  (_net_16, D3);
not inst52  (_net_17, RD);
not inst53  (_net_18, SI);
and inst54  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_13, _net_14, _net_15, _net_16, _net_17, SE, _net_18);
not inst55  (_net_19, D1);
not inst56  (_net_20, D0);
not inst57  (_net_21, D2);
not inst58  (_net_22, D3);
not inst59  (_net_23, RD);
and inst60  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, _net_19, _net_20, _net_21, _net_22, _net_23, SE, SI);
not inst61  (_net_24, D1);
not inst62  (_net_25, D0);
not inst63  (_net_26, D2);
not inst64  (_net_27, D3);
not inst65  (_net_28, SE);
not inst66  (_net_29, SI);
and inst67  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_24, _net_25, _net_26, _net_27, RD, _net_28, _net_29);
not inst68  (_net_30, D1);
not inst69  (_net_31, D0);
not inst70  (_net_32, D2);
not inst71  (_net_33, D3);
not inst72  (_net_34, SE);
and inst73  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_30, _net_31, _net_32, _net_33, RD, _net_34, SI);
not inst74  (_net_35, D1);
not inst75  (_net_36, D0);
not inst76  (_net_37, D2);
not inst77  (_net_38, D3);
not inst78  (_net_39, SI);
and inst79  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_35, _net_36, _net_37, _net_38, RD, SE, _net_39);
not inst80  (_net_40, D1);
not inst81  (_net_41, D0);
not inst82  (_net_42, D2);
not inst83  (_net_43, D3);
and inst84  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_40, _net_41, _net_42, _net_43, RD, SE, SI);
not inst85  (_net_44, D1);
not inst86  (_net_45, D0);
not inst87  (_net_46, D2);
not inst88  (_net_47, RD);
not inst89  (_net_48, SE);
not inst90  (_net_49, SI);
and inst91  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_44, _net_45, _net_46, D3, _net_47, _net_48, _net_49);
not inst92  (_net_50, D1);
not inst93  (_net_51, D0);
not inst94  (_net_52, D2);
not inst95  (_net_53, RD);
not inst96  (_net_54, SE);
and inst97  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_50, _net_51, _net_52, D3, _net_53, _net_54, SI);
not inst98  (_net_55, D1);
not inst99  (_net_56, D0);
not inst100  (_net_57, D2);
not inst101  (_net_58, RD);
not inst102  (_net_59, SI);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_55, _net_56, _net_57, D3, _net_58, SE, _net_59);
not inst104  (_net_60, D1);
not inst105  (_net_61, D0);
not inst106  (_net_62, D2);
not inst107  (_net_63, RD);
and inst108  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI, _net_60, _net_61, _net_62, D3, _net_63, SE, SI);
not inst109  (_net_64, D1);
not inst110  (_net_65, D0);
not inst111  (_net_66, D2);
not inst112  (_net_67, SE);
not inst113  (_net_68, SI);
and inst114  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_64, _net_65, _net_66, D3, RD, _net_67, _net_68);
not inst115  (_net_69, D1);
not inst116  (_net_70, D0);
not inst117  (_net_71, D2);
not inst118  (_net_72, SE);
and inst119  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_69, _net_70, _net_71, D3, RD, _net_72, SI);
not inst120  (_net_73, D1);
not inst121  (_net_74, D0);
not inst122  (_net_75, D2);
not inst123  (_net_76, SI);
and inst124  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_73, _net_74, _net_75, D3, RD, SE, _net_76);
not inst125  (_net_77, D1);
not inst126  (_net_78, D0);
not inst127  (_net_79, D2);
and inst128  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_77, _net_78, _net_79, D3, RD, SE, SI);
not inst129  (_net_80, D1);
not inst130  (_net_81, D0);
not inst131  (_net_82, D3);
not inst132  (_net_83, RD);
not inst133  (_net_84, SE);
not inst134  (_net_85, SI);
and inst135  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_80, _net_81, D2, _net_82, _net_83, _net_84, _net_85);
not inst136  (_net_86, D1);
not inst137  (_net_87, D0);
not inst138  (_net_88, D3);
not inst139  (_net_89, RD);
not inst140  (_net_90, SE);
and inst141  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_86, _net_87, D2, _net_88, _net_89, _net_90, SI);
not inst142  (_net_91, D1);
not inst143  (_net_92, D0);
not inst144  (_net_93, D3);
not inst145  (_net_94, RD);
not inst146  (_net_95, SI);
and inst147  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_91, _net_92, D2, _net_93, _net_94, SE, _net_95);
not inst148  (_net_96, D1);
not inst149  (_net_97, D0);
not inst150  (_net_98, D3);
not inst151  (_net_99, RD);
and inst152  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, _net_96, _net_97, D2, _net_98, _net_99, SE, SI);
not inst153  (_net_100, D1);
not inst154  (_net_101, D0);
not inst155  (_net_102, D3);
not inst156  (_net_103, SE);
not inst157  (_net_104, SI);
and inst158  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_100, _net_101, D2, _net_102, RD, _net_103, _net_104);
not inst159  (_net_105, D1);
not inst160  (_net_106, D0);
not inst161  (_net_107, D3);
not inst162  (_net_108, SE);
and inst163  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_105, _net_106, D2, _net_107, RD, _net_108, SI);
not inst164  (_net_109, D1);
not inst165  (_net_110, D0);
not inst166  (_net_111, D3);
not inst167  (_net_112, SI);
and inst168  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_109, _net_110, D2, _net_111, RD, SE, _net_112);
not inst169  (_net_113, D1);
not inst170  (_net_114, D0);
not inst171  (_net_115, D3);
and inst172  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_113, _net_114, D2, _net_115, RD, SE, SI);
not inst173  (_net_116, D1);
not inst174  (_net_117, D0);
not inst175  (_net_118, RD);
not inst176  (_net_119, SE);
not inst177  (_net_120, SI);
and inst178  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_116, _net_117, D2, D3, _net_118, _net_119, _net_120);
not inst179  (_net_121, D1);
not inst180  (_net_122, D0);
not inst181  (_net_123, RD);
not inst182  (_net_124, SE);
and inst183  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_121, _net_122, D2, D3, _net_123, _net_124, SI);
not inst184  (_net_125, D1);
not inst185  (_net_126, D0);
not inst186  (_net_127, RD);
not inst187  (_net_128, SI);
and inst188  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_125, _net_126, D2, D3, _net_127, SE, _net_128);
not inst189  (_net_129, D1);
not inst190  (_net_130, D0);
not inst191  (_net_131, RD);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI, _net_129, _net_130, D2, D3, _net_131, SE, SI);
not inst193  (_net_132, D1);
not inst194  (_net_133, D0);
not inst195  (_net_134, SE);
not inst196  (_net_135, SI);
and inst197  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_132, _net_133, D2, D3, RD, _net_134, _net_135);
not inst198  (_net_136, D1);
not inst199  (_net_137, D0);
not inst200  (_net_138, SE);
and inst201  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_136, _net_137, D2, D3, RD, _net_138, SI);
not inst202  (_net_139, D1);
not inst203  (_net_140, D0);
not inst204  (_net_141, SI);
and inst205  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_139, _net_140, D2, D3, RD, SE, _net_141);
not inst206  (_net_142, D1);
not inst207  (_net_143, D0);
and inst208  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_142, _net_143, D2, D3, RD, SE, SI);
not inst209  (_net_144, D0);
not inst210  (_net_145, D2);
not inst211  (_net_146, D3);
not inst212  (_net_147, RD);
not inst213  (_net_148, SE);
not inst214  (_net_149, SI);
and inst215  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_144, _net_145, _net_146, _net_147, _net_148, _net_149);
not inst216  (_net_150, D0);
not inst217  (_net_151, D2);
not inst218  (_net_152, D3);
not inst219  (_net_153, RD);
not inst220  (_net_154, SE);
and inst221  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, D1, _net_150, _net_151, _net_152, _net_153, _net_154, SI);
not inst222  (_net_155, D0);
not inst223  (_net_156, D2);
not inst224  (_net_157, D3);
not inst225  (_net_158, RD);
not inst226  (_net_159, SI);
and inst227  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, D1, _net_155, _net_156, _net_157, _net_158, SE, _net_159);
not inst228  (_net_160, D0);
not inst229  (_net_161, D2);
not inst230  (_net_162, D3);
not inst231  (_net_163, RD);
and inst232  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, D1, _net_160, _net_161, _net_162, _net_163, SE, SI);
not inst233  (_net_164, D0);
not inst234  (_net_165, D2);
not inst235  (_net_166, D3);
not inst236  (_net_167, SE);
not inst237  (_net_168, SI);
and inst238  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_164, _net_165, _net_166, RD, _net_167, _net_168);
not inst239  (_net_169, D0);
not inst240  (_net_170, D2);
not inst241  (_net_171, D3);
not inst242  (_net_172, SE);
and inst243  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, D1, _net_169, _net_170, _net_171, RD, _net_172, SI);
not inst244  (_net_173, D0);
not inst245  (_net_174, D2);
not inst246  (_net_175, D3);
not inst247  (_net_176, SI);
and inst248  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, D1, _net_173, _net_174, _net_175, RD, SE, _net_176);
not inst249  (_net_177, D0);
not inst250  (_net_178, D2);
not inst251  (_net_179, D3);
and inst252  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, D1, _net_177, _net_178, _net_179, RD, SE, SI);
not inst253  (_net_180, D1);
not inst254  (_net_181, D2);
not inst255  (_net_182, D3);
not inst256  (_net_183, RD);
not inst257  (_net_184, SE);
not inst258  (_net_185, SI);
and inst259  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_180, D0, _net_181, _net_182, _net_183, _net_184, _net_185);
not inst260  (_net_186, D1);
not inst261  (_net_187, D2);
not inst262  (_net_188, D3);
not inst263  (_net_189, RD);
not inst264  (_net_190, SE);
and inst265  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_186, D0, _net_187, _net_188, _net_189, _net_190, SI);
not inst266  (_net_191, D1);
not inst267  (_net_192, D2);
not inst268  (_net_193, D3);
not inst269  (_net_194, RD);
not inst270  (_net_195, SI);
and inst271  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_191, D0, _net_192, _net_193, _net_194, SE, _net_195);
not inst272  (_net_196, D1);
not inst273  (_net_197, D2);
not inst274  (_net_198, D3);
not inst275  (_net_199, RD);
and inst276  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, _net_196, D0, _net_197, _net_198, _net_199, SE, SI);
not inst277  (_net_200, D1);
not inst278  (_net_201, D2);
not inst279  (_net_202, D3);
not inst280  (_net_203, SE);
not inst281  (_net_204, SI);
and inst282  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_200, D0, _net_201, _net_202, RD, _net_203, _net_204);
not inst283  (_net_205, D1);
not inst284  (_net_206, D2);
not inst285  (_net_207, D3);
not inst286  (_net_208, SE);
and inst287  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_205, D0, _net_206, _net_207, RD, _net_208, SI);
not inst288  (_net_209, D1);
not inst289  (_net_210, D2);
not inst290  (_net_211, D3);
not inst291  (_net_212, SI);
and inst292  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_209, D0, _net_210, _net_211, RD, SE, _net_212);
not inst293  (_net_213, D1);
not inst294  (_net_214, D2);
not inst295  (_net_215, D3);
and inst296  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_213, D0, _net_214, _net_215, RD, SE, SI);
not inst297  (_net_216, D1);
not inst298  (_net_217, D3);
not inst299  (_net_218, RD);
not inst300  (_net_219, SE);
not inst301  (_net_220, SI);
and inst302  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_216, D0, D2, _net_217, _net_218, _net_219, _net_220);
not inst303  (_net_221, D1);
not inst304  (_net_222, D3);
not inst305  (_net_223, RD);
not inst306  (_net_224, SE);
and inst307  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_221, D0, D2, _net_222, _net_223, _net_224, SI);
not inst308  (_net_225, D1);
not inst309  (_net_226, D3);
not inst310  (_net_227, RD);
not inst311  (_net_228, SI);
and inst312  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_225, D0, D2, _net_226, _net_227, SE, _net_228);
not inst313  (_net_229, D1);
not inst314  (_net_230, D3);
not inst315  (_net_231, RD);
and inst316  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, _net_229, D0, D2, _net_230, _net_231, SE, SI);
not inst317  (_net_232, D1);
not inst318  (_net_233, D3);
not inst319  (_net_234, SE);
not inst320  (_net_235, SI);
and inst321  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_232, D0, D2, _net_233, RD, _net_234, _net_235);
not inst322  (_net_236, D1);
not inst323  (_net_237, D3);
not inst324  (_net_238, SE);
and inst325  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_236, D0, D2, _net_237, RD, _net_238, SI);
not inst326  (_net_239, D1);
not inst327  (_net_240, D3);
not inst328  (_net_241, SI);
and inst329  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_239, D0, D2, _net_240, RD, SE, _net_241);
not inst330  (_net_242, D1);
not inst331  (_net_243, D3);
and inst332  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_242, D0, D2, _net_243, RD, SE, SI);
not inst333  (_net_244, D1);
not inst334  (_net_245, RD);
not inst335  (_net_246, SE);
not inst336  (_net_247, SI);
and inst337  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_244, D0, D2, D3, _net_245, _net_246, _net_247);
not inst338  (_net_248, D1);
not inst339  (_net_249, RD);
not inst340  (_net_250, SE);
and inst341  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_248, D0, D2, D3, _net_249, _net_250, SI);
not inst342  (_net_251, D1);
not inst343  (_net_252, RD);
not inst344  (_net_253, SI);
and inst345  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_251, D0, D2, D3, _net_252, SE, _net_253);
not inst346  (_net_254, D1);
not inst347  (_net_255, RD);
and inst348  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI, _net_254, D0, D2, D3, _net_255, SE, SI);
not inst349  (_net_256, D1);
not inst350  (_net_257, SE);
not inst351  (_net_258, SI);
and inst352  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_256, D0, D2, D3, RD, _net_257, _net_258);
not inst353  (_net_259, D1);
not inst354  (_net_260, SE);
and inst355  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_259, D0, D2, D3, RD, _net_260, SI);
not inst356  (_net_261, D1);
not inst357  (_net_262, SI);
and inst358  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_261, D0, D2, D3, RD, SE, _net_262);
not inst359  (_net_263, D1);
and inst360  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_263, D0, D2, D3, RD, SE, SI);
not inst361  (_net_264, RD);
not inst362  (_net_265, SE);
not inst363  (_net_266, SI);
and inst364  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, _net_264, _net_265, _net_266);
not inst365  (_net_267, RD);
not inst366  (_net_268, SE);
and inst367  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, D1, D0, D2, D3, _net_267, _net_268, SI);
not inst368  (_net_269, RD);
not inst369  (_net_270, SI);
and inst370  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, D1, D0, D2, D3, _net_269, SE, _net_270);
not inst371  (_net_271, RD);
and inst372  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI, D1, D0, D2, D3, _net_271, SE, SI);
not inst373  (_net_272, SE);
not inst374  (_net_273, SI);
and inst375  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, RD, _net_272, _net_273);
not inst376  (_net_274, SE);
and inst377  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, D1, D0, D2, D3, RD, _net_274, SI);
not inst378  (_net_275, SI);
and inst379  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, D1, D0, D2, D3, RD, SE, _net_275);
and inst380  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, D1, D0, D2, D3, RD, SE, SI);
not inst381  (_net_276, D1);
not inst382  (_net_277, D0);
not inst383  (_net_278, D2);
not inst384  (_net_279, SE);
not inst385  (_net_280, SI);
and inst386  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_276, _net_277, _net_278, D3, _net_279, _net_280);
not inst387  (_net_281, D1);
not inst388  (_net_282, D0);
not inst389  (_net_283, D2);
not inst390  (_net_284, SE);
and inst391  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_281, _net_282, _net_283, D3, _net_284, SI);
not inst392  (_net_285, D1);
not inst393  (_net_286, D0);
not inst394  (_net_287, D3);
not inst395  (_net_288, SE);
not inst396  (_net_289, SI);
and inst397  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_285, _net_286, D2, _net_287, _net_288, _net_289);
not inst398  (_net_290, D1);
not inst399  (_net_291, D0);
not inst400  (_net_292, D3);
not inst401  (_net_293, SE);
and inst402  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_290, _net_291, D2, _net_292, _net_293, SI);
not inst403  (_net_294, D0);
not inst404  (_net_295, D2);
not inst405  (_net_296, D3);
not inst406  (_net_297, SE);
not inst407  (_net_298, SI);
and inst408  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_294, _net_295, _net_296, _net_297, _net_298);
not inst409  (_net_299, D0);
not inst410  (_net_300, D2);
not inst411  (_net_301, D3);
not inst412  (_net_302, SE);
and inst413  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_299, _net_300, _net_301, _net_302, SI);
not inst414  (_net_303, D1);
not inst415  (_net_304, D2);
not inst416  (_net_305, D3);
not inst417  (_net_306, SE);
not inst418  (_net_307, SI);
and inst419  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_303, D0, _net_304, _net_305, _net_306, _net_307);
not inst420  (_net_308, D1);
not inst421  (_net_309, D2);
not inst422  (_net_310, D3);
not inst423  (_net_311, SE);
and inst424  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_308, D0, _net_309, _net_310, _net_311, SI);
not inst425  (_net_312, D1);
not inst426  (_net_313, D0);
not inst427  (_net_314, D2);
not inst428  (_net_315, D3);
not inst429  (_net_316, RD);
and inst430  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI, _net_312, _net_313, _net_314, _net_315, _net_316, SI);
not inst431  (_net_317, D1);
not inst432  (_net_318, D0);
not inst433  (_net_319, D2);
not inst434  (_net_320, D3);
and inst435  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI, _net_317, _net_318, _net_319, _net_320, RD, SI);
not inst436  (_net_321, D1);
not inst437  (_net_322, D0);
not inst438  (_net_323, D2);
not inst439  (_net_324, SI);
and inst440  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI, _net_321, _net_322, _net_323, D3, RD, _net_324);
not inst441  (_net_325, D1);
not inst442  (_net_326, D0);
not inst443  (_net_327, D3);
not inst444  (_net_328, SI);
and inst445  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, _net_325, _net_326, D2, _net_327, RD, _net_328);
not inst446  (_net_329, D0);
not inst447  (_net_330, D2);
not inst448  (_net_331, D3);
not inst449  (_net_332, SI);
and inst450  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, D1, _net_329, _net_330, _net_331, RD, _net_332);
not inst451  (_net_333, D1);
not inst452  (_net_334, D2);
not inst453  (_net_335, D3);
not inst454  (_net_336, SI);
and inst455  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, _net_333, D0, _net_334, _net_335, RD, _net_336);
not inst456  (_net_337, RD);
and inst457  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI, D1, D0, D2, D3, _net_337, SI);
not inst458  (_net_338, RD);
not inst459  (_net_339, D0);
and inst460  (ENABLE_NOT_D0_AND_NOT_RD_AND_SE, _net_338, _net_339, SE);
not inst461  (_net_340, D0);
and inst462  (ENABLE_NOT_D0_AND_RD_AND_SE, RD, _net_340, SE);
not inst463  (_net_341, RD);
and inst464  (ENABLE_D0_AND_NOT_RD_AND_SE, _net_341, D0, SE);
and inst465  (ENABLE_D0_AND_RD_AND_SE, RD, D0, SE);
not inst466  (_net_342, SE);
not inst467  (_net_343, SI);
and inst468  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_342, RD, _net_343);
not inst469  (_net_344, SE);
and inst470  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_344, RD, SI);

specify
if (D0==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK , 0 ,0, viol_0);
$width(negedge CK , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK , posedge RD , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK , negedge RD , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPSYNRBQM4SS_V2Y8_1

//%BEGIN HDBSVT11_FSDPSYNRBQM4SS_V2Y8_2

`celldefine
module HDBSVT11_FSDPSYNRBQM4SS_V2Y8_2 (Q0, Q1, Q2, Q3, CK, D0, D1, D2, D3, SI, SE, RD);
   output Q0, Q1, Q2, Q3;
   input CK, D0, D1, D2, D3, SI, SE, RD;

   reg viol_0, viol_1, viol_2, viol_3;
   wire delayed_CK, delayed_D0, delayed_D1, delayed_D2, delayed_D3,  
	delayed_SI, delayed_SE, delayed_RD;

   wire int_res__D0, int_res__D1, int_res__D2, int_res__D3, int_res__RD0, int_res__RD1, int_res__RD2, int_res__RD3, int_res_iq0, int_res_iq1, int_res_iq2, int_res_iq3, 
        xcr_0, xcr_1, xcr_2, xcr_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D0, D0);
   buf inst2  (delayed_D1, D1);
   buf inst3  (delayed_D2, D2);
   buf inst4  (delayed_D3, D3);
   buf inst5  (delayed_SI, SI);
   buf inst6  (delayed_SE, SE);
   buf inst7  (delayed_RD, RD);
`endif
   not inst8  (int_res__RD, delayed_RD);

   and inst9  (int_res__RD0, delayed_D0, delayed_RD);
   and inst10  (int_res__RD1, delayed_D1, delayed_RD);
   and inst11  (int_res__RD2, delayed_D2, delayed_RD);
   and inst12  (int_res__RD3, delayed_D3, delayed_RD);
   

   snps_mux2 inst13  (int_res__D0, delayed_SI, int_res__RD0, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst14  (xcr_0, delayed_CK, int_res__D0);

  `endif
   snps_dff inst15  (int_res_iq0, viol_0, delayed_CK, int_res__D0, xcr_0);

   snps_mux2 inst16  (int_res__D1, int_res_iq0, int_res__RD1, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst17  (xcr_1, delayed_CK, int_res__D1);

  `endif
   snps_dff inst18  (int_res_iq1, viol_1, delayed_CK, int_res__D1, xcr_1);

   snps_mux2 inst19  (int_res__D2, int_res_iq1, int_res__RD2, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst20  (xcr_2, delayed_CK, int_res__D2);

  `endif
   snps_dff inst21  (int_res_iq2, viol_2, delayed_CK, int_res__D2, xcr_2);

   snps_mux2 inst22  (int_res__D3, int_res_iq2, int_res__RD3, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst23  (xcr_3, delayed_CK, int_res__D3);

  `endif
   snps_dff inst24  (int_res_iq3, viol_3, delayed_CK, int_res__D3, xcr_3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        buf #`SNPS_SEQ_DELAY  inst25 (Q0, int_res_iq0);
        buf #`SNPS_SEQ_DELAY  inst26 (Q1, int_res_iq1);
        buf #`SNPS_SEQ_DELAY  inst27 (Q2, int_res_iq2);
        buf #`SNPS_SEQ_DELAY  inst28 (Q3, int_res_iq3);
   `else
        buf inst29  (Q0, int_res_iq0);
        buf inst30  (Q1, int_res_iq1);
        buf inst31  (Q2, int_res_iq2);
        buf inst32  (Q3, int_res_iq3);

   `endif

   `ifdef VIRL_functiononly

   `else

not inst33  (_net_0, D1);
not inst34  (_net_1, D0);
not inst35  (_net_2, D2);
not inst36  (_net_3, D3);
not inst37  (_net_4, RD);
not inst38  (_net_5, SE);
not inst39  (_net_6, SI);
and inst40  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5, _net_6);
not inst41  (_net_7, D1);
not inst42  (_net_8, D0);
not inst43  (_net_9, D2);
not inst44  (_net_10, D3);
not inst45  (_net_11, RD);
not inst46  (_net_12, SE);
and inst47  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_7, _net_8, _net_9, _net_10, _net_11, _net_12, SI);
not inst48  (_net_13, D1);
not inst49  (_net_14, D0);
not inst50  (_net_15, D2);
not inst51  (_net_16, D3);
not inst52  (_net_17, RD);
not inst53  (_net_18, SI);
and inst54  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_13, _net_14, _net_15, _net_16, _net_17, SE, _net_18);
not inst55  (_net_19, D1);
not inst56  (_net_20, D0);
not inst57  (_net_21, D2);
not inst58  (_net_22, D3);
not inst59  (_net_23, RD);
and inst60  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, _net_19, _net_20, _net_21, _net_22, _net_23, SE, SI);
not inst61  (_net_24, D1);
not inst62  (_net_25, D0);
not inst63  (_net_26, D2);
not inst64  (_net_27, D3);
not inst65  (_net_28, SE);
not inst66  (_net_29, SI);
and inst67  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_24, _net_25, _net_26, _net_27, RD, _net_28, _net_29);
not inst68  (_net_30, D1);
not inst69  (_net_31, D0);
not inst70  (_net_32, D2);
not inst71  (_net_33, D3);
not inst72  (_net_34, SE);
and inst73  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_30, _net_31, _net_32, _net_33, RD, _net_34, SI);
not inst74  (_net_35, D1);
not inst75  (_net_36, D0);
not inst76  (_net_37, D2);
not inst77  (_net_38, D3);
not inst78  (_net_39, SI);
and inst79  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_35, _net_36, _net_37, _net_38, RD, SE, _net_39);
not inst80  (_net_40, D1);
not inst81  (_net_41, D0);
not inst82  (_net_42, D2);
not inst83  (_net_43, D3);
and inst84  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_40, _net_41, _net_42, _net_43, RD, SE, SI);
not inst85  (_net_44, D1);
not inst86  (_net_45, D0);
not inst87  (_net_46, D2);
not inst88  (_net_47, RD);
not inst89  (_net_48, SE);
not inst90  (_net_49, SI);
and inst91  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_44, _net_45, _net_46, D3, _net_47, _net_48, _net_49);
not inst92  (_net_50, D1);
not inst93  (_net_51, D0);
not inst94  (_net_52, D2);
not inst95  (_net_53, RD);
not inst96  (_net_54, SE);
and inst97  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_50, _net_51, _net_52, D3, _net_53, _net_54, SI);
not inst98  (_net_55, D1);
not inst99  (_net_56, D0);
not inst100  (_net_57, D2);
not inst101  (_net_58, RD);
not inst102  (_net_59, SI);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_55, _net_56, _net_57, D3, _net_58, SE, _net_59);
not inst104  (_net_60, D1);
not inst105  (_net_61, D0);
not inst106  (_net_62, D2);
not inst107  (_net_63, RD);
and inst108  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI, _net_60, _net_61, _net_62, D3, _net_63, SE, SI);
not inst109  (_net_64, D1);
not inst110  (_net_65, D0);
not inst111  (_net_66, D2);
not inst112  (_net_67, SE);
not inst113  (_net_68, SI);
and inst114  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_64, _net_65, _net_66, D3, RD, _net_67, _net_68);
not inst115  (_net_69, D1);
not inst116  (_net_70, D0);
not inst117  (_net_71, D2);
not inst118  (_net_72, SE);
and inst119  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_69, _net_70, _net_71, D3, RD, _net_72, SI);
not inst120  (_net_73, D1);
not inst121  (_net_74, D0);
not inst122  (_net_75, D2);
not inst123  (_net_76, SI);
and inst124  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_73, _net_74, _net_75, D3, RD, SE, _net_76);
not inst125  (_net_77, D1);
not inst126  (_net_78, D0);
not inst127  (_net_79, D2);
and inst128  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_77, _net_78, _net_79, D3, RD, SE, SI);
not inst129  (_net_80, D1);
not inst130  (_net_81, D0);
not inst131  (_net_82, D3);
not inst132  (_net_83, RD);
not inst133  (_net_84, SE);
not inst134  (_net_85, SI);
and inst135  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_80, _net_81, D2, _net_82, _net_83, _net_84, _net_85);
not inst136  (_net_86, D1);
not inst137  (_net_87, D0);
not inst138  (_net_88, D3);
not inst139  (_net_89, RD);
not inst140  (_net_90, SE);
and inst141  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_86, _net_87, D2, _net_88, _net_89, _net_90, SI);
not inst142  (_net_91, D1);
not inst143  (_net_92, D0);
not inst144  (_net_93, D3);
not inst145  (_net_94, RD);
not inst146  (_net_95, SI);
and inst147  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_91, _net_92, D2, _net_93, _net_94, SE, _net_95);
not inst148  (_net_96, D1);
not inst149  (_net_97, D0);
not inst150  (_net_98, D3);
not inst151  (_net_99, RD);
and inst152  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, _net_96, _net_97, D2, _net_98, _net_99, SE, SI);
not inst153  (_net_100, D1);
not inst154  (_net_101, D0);
not inst155  (_net_102, D3);
not inst156  (_net_103, SE);
not inst157  (_net_104, SI);
and inst158  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_100, _net_101, D2, _net_102, RD, _net_103, _net_104);
not inst159  (_net_105, D1);
not inst160  (_net_106, D0);
not inst161  (_net_107, D3);
not inst162  (_net_108, SE);
and inst163  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_105, _net_106, D2, _net_107, RD, _net_108, SI);
not inst164  (_net_109, D1);
not inst165  (_net_110, D0);
not inst166  (_net_111, D3);
not inst167  (_net_112, SI);
and inst168  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_109, _net_110, D2, _net_111, RD, SE, _net_112);
not inst169  (_net_113, D1);
not inst170  (_net_114, D0);
not inst171  (_net_115, D3);
and inst172  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_113, _net_114, D2, _net_115, RD, SE, SI);
not inst173  (_net_116, D1);
not inst174  (_net_117, D0);
not inst175  (_net_118, RD);
not inst176  (_net_119, SE);
not inst177  (_net_120, SI);
and inst178  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_116, _net_117, D2, D3, _net_118, _net_119, _net_120);
not inst179  (_net_121, D1);
not inst180  (_net_122, D0);
not inst181  (_net_123, RD);
not inst182  (_net_124, SE);
and inst183  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_121, _net_122, D2, D3, _net_123, _net_124, SI);
not inst184  (_net_125, D1);
not inst185  (_net_126, D0);
not inst186  (_net_127, RD);
not inst187  (_net_128, SI);
and inst188  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_125, _net_126, D2, D3, _net_127, SE, _net_128);
not inst189  (_net_129, D1);
not inst190  (_net_130, D0);
not inst191  (_net_131, RD);
and inst192  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI, _net_129, _net_130, D2, D3, _net_131, SE, SI);
not inst193  (_net_132, D1);
not inst194  (_net_133, D0);
not inst195  (_net_134, SE);
not inst196  (_net_135, SI);
and inst197  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_132, _net_133, D2, D3, RD, _net_134, _net_135);
not inst198  (_net_136, D1);
not inst199  (_net_137, D0);
not inst200  (_net_138, SE);
and inst201  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_136, _net_137, D2, D3, RD, _net_138, SI);
not inst202  (_net_139, D1);
not inst203  (_net_140, D0);
not inst204  (_net_141, SI);
and inst205  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_139, _net_140, D2, D3, RD, SE, _net_141);
not inst206  (_net_142, D1);
not inst207  (_net_143, D0);
and inst208  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_142, _net_143, D2, D3, RD, SE, SI);
not inst209  (_net_144, D0);
not inst210  (_net_145, D2);
not inst211  (_net_146, D3);
not inst212  (_net_147, RD);
not inst213  (_net_148, SE);
not inst214  (_net_149, SI);
and inst215  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_144, _net_145, _net_146, _net_147, _net_148, _net_149);
not inst216  (_net_150, D0);
not inst217  (_net_151, D2);
not inst218  (_net_152, D3);
not inst219  (_net_153, RD);
not inst220  (_net_154, SE);
and inst221  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, D1, _net_150, _net_151, _net_152, _net_153, _net_154, SI);
not inst222  (_net_155, D0);
not inst223  (_net_156, D2);
not inst224  (_net_157, D3);
not inst225  (_net_158, RD);
not inst226  (_net_159, SI);
and inst227  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, D1, _net_155, _net_156, _net_157, _net_158, SE, _net_159);
not inst228  (_net_160, D0);
not inst229  (_net_161, D2);
not inst230  (_net_162, D3);
not inst231  (_net_163, RD);
and inst232  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, D1, _net_160, _net_161, _net_162, _net_163, SE, SI);
not inst233  (_net_164, D0);
not inst234  (_net_165, D2);
not inst235  (_net_166, D3);
not inst236  (_net_167, SE);
not inst237  (_net_168, SI);
and inst238  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_164, _net_165, _net_166, RD, _net_167, _net_168);
not inst239  (_net_169, D0);
not inst240  (_net_170, D2);
not inst241  (_net_171, D3);
not inst242  (_net_172, SE);
and inst243  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, D1, _net_169, _net_170, _net_171, RD, _net_172, SI);
not inst244  (_net_173, D0);
not inst245  (_net_174, D2);
not inst246  (_net_175, D3);
not inst247  (_net_176, SI);
and inst248  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, D1, _net_173, _net_174, _net_175, RD, SE, _net_176);
not inst249  (_net_177, D0);
not inst250  (_net_178, D2);
not inst251  (_net_179, D3);
and inst252  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, D1, _net_177, _net_178, _net_179, RD, SE, SI);
not inst253  (_net_180, D1);
not inst254  (_net_181, D2);
not inst255  (_net_182, D3);
not inst256  (_net_183, RD);
not inst257  (_net_184, SE);
not inst258  (_net_185, SI);
and inst259  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_180, D0, _net_181, _net_182, _net_183, _net_184, _net_185);
not inst260  (_net_186, D1);
not inst261  (_net_187, D2);
not inst262  (_net_188, D3);
not inst263  (_net_189, RD);
not inst264  (_net_190, SE);
and inst265  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_186, D0, _net_187, _net_188, _net_189, _net_190, SI);
not inst266  (_net_191, D1);
not inst267  (_net_192, D2);
not inst268  (_net_193, D3);
not inst269  (_net_194, RD);
not inst270  (_net_195, SI);
and inst271  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_191, D0, _net_192, _net_193, _net_194, SE, _net_195);
not inst272  (_net_196, D1);
not inst273  (_net_197, D2);
not inst274  (_net_198, D3);
not inst275  (_net_199, RD);
and inst276  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, _net_196, D0, _net_197, _net_198, _net_199, SE, SI);
not inst277  (_net_200, D1);
not inst278  (_net_201, D2);
not inst279  (_net_202, D3);
not inst280  (_net_203, SE);
not inst281  (_net_204, SI);
and inst282  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_200, D0, _net_201, _net_202, RD, _net_203, _net_204);
not inst283  (_net_205, D1);
not inst284  (_net_206, D2);
not inst285  (_net_207, D3);
not inst286  (_net_208, SE);
and inst287  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_205, D0, _net_206, _net_207, RD, _net_208, SI);
not inst288  (_net_209, D1);
not inst289  (_net_210, D2);
not inst290  (_net_211, D3);
not inst291  (_net_212, SI);
and inst292  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_209, D0, _net_210, _net_211, RD, SE, _net_212);
not inst293  (_net_213, D1);
not inst294  (_net_214, D2);
not inst295  (_net_215, D3);
and inst296  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_213, D0, _net_214, _net_215, RD, SE, SI);
not inst297  (_net_216, D1);
not inst298  (_net_217, D3);
not inst299  (_net_218, RD);
not inst300  (_net_219, SE);
not inst301  (_net_220, SI);
and inst302  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_216, D0, D2, _net_217, _net_218, _net_219, _net_220);
not inst303  (_net_221, D1);
not inst304  (_net_222, D3);
not inst305  (_net_223, RD);
not inst306  (_net_224, SE);
and inst307  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_221, D0, D2, _net_222, _net_223, _net_224, SI);
not inst308  (_net_225, D1);
not inst309  (_net_226, D3);
not inst310  (_net_227, RD);
not inst311  (_net_228, SI);
and inst312  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_225, D0, D2, _net_226, _net_227, SE, _net_228);
not inst313  (_net_229, D1);
not inst314  (_net_230, D3);
not inst315  (_net_231, RD);
and inst316  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI, _net_229, D0, D2, _net_230, _net_231, SE, SI);
not inst317  (_net_232, D1);
not inst318  (_net_233, D3);
not inst319  (_net_234, SE);
not inst320  (_net_235, SI);
and inst321  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_232, D0, D2, _net_233, RD, _net_234, _net_235);
not inst322  (_net_236, D1);
not inst323  (_net_237, D3);
not inst324  (_net_238, SE);
and inst325  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI, _net_236, D0, D2, _net_237, RD, _net_238, SI);
not inst326  (_net_239, D1);
not inst327  (_net_240, D3);
not inst328  (_net_241, SI);
and inst329  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI, _net_239, D0, D2, _net_240, RD, SE, _net_241);
not inst330  (_net_242, D1);
not inst331  (_net_243, D3);
and inst332  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI, _net_242, D0, D2, _net_243, RD, SE, SI);
not inst333  (_net_244, D1);
not inst334  (_net_245, RD);
not inst335  (_net_246, SE);
not inst336  (_net_247, SI);
and inst337  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_244, D0, D2, D3, _net_245, _net_246, _net_247);
not inst338  (_net_248, D1);
not inst339  (_net_249, RD);
not inst340  (_net_250, SE);
and inst341  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_248, D0, D2, D3, _net_249, _net_250, SI);
not inst342  (_net_251, D1);
not inst343  (_net_252, RD);
not inst344  (_net_253, SI);
and inst345  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_251, D0, D2, D3, _net_252, SE, _net_253);
not inst346  (_net_254, D1);
not inst347  (_net_255, RD);
and inst348  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI, _net_254, D0, D2, D3, _net_255, SE, SI);
not inst349  (_net_256, D1);
not inst350  (_net_257, SE);
not inst351  (_net_258, SI);
and inst352  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_256, D0, D2, D3, RD, _net_257, _net_258);
not inst353  (_net_259, D1);
not inst354  (_net_260, SE);
and inst355  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, _net_259, D0, D2, D3, RD, _net_260, SI);
not inst356  (_net_261, D1);
not inst357  (_net_262, SI);
and inst358  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, _net_261, D0, D2, D3, RD, SE, _net_262);
not inst359  (_net_263, D1);
and inst360  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, _net_263, D0, D2, D3, RD, SE, SI);
not inst361  (_net_264, RD);
not inst362  (_net_265, SE);
not inst363  (_net_266, SI);
and inst364  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, _net_264, _net_265, _net_266);
not inst365  (_net_267, RD);
not inst366  (_net_268, SE);
and inst367  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI, D1, D0, D2, D3, _net_267, _net_268, SI);
not inst368  (_net_269, RD);
not inst369  (_net_270, SI);
and inst370  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI, D1, D0, D2, D3, _net_269, SE, _net_270);
not inst371  (_net_271, RD);
and inst372  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI, D1, D0, D2, D3, _net_271, SE, SI);
not inst373  (_net_272, SE);
not inst374  (_net_273, SI);
and inst375  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, RD, _net_272, _net_273);
not inst376  (_net_274, SE);
and inst377  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI, D1, D0, D2, D3, RD, _net_274, SI);
not inst378  (_net_275, SI);
and inst379  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI, D1, D0, D2, D3, RD, SE, _net_275);
and inst380  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI, D1, D0, D2, D3, RD, SE, SI);
not inst381  (_net_276, D1);
not inst382  (_net_277, D0);
not inst383  (_net_278, D2);
not inst384  (_net_279, SE);
not inst385  (_net_280, SI);
and inst386  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI, _net_276, _net_277, _net_278, D3, _net_279, _net_280);
not inst387  (_net_281, D1);
not inst388  (_net_282, D0);
not inst389  (_net_283, D2);
not inst390  (_net_284, SE);
and inst391  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI, _net_281, _net_282, _net_283, D3, _net_284, SI);
not inst392  (_net_285, D1);
not inst393  (_net_286, D0);
not inst394  (_net_287, D3);
not inst395  (_net_288, SE);
not inst396  (_net_289, SI);
and inst397  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_285, _net_286, D2, _net_287, _net_288, _net_289);
not inst398  (_net_290, D1);
not inst399  (_net_291, D0);
not inst400  (_net_292, D3);
not inst401  (_net_293, SE);
and inst402  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_290, _net_291, D2, _net_292, _net_293, SI);
not inst403  (_net_294, D0);
not inst404  (_net_295, D2);
not inst405  (_net_296, D3);
not inst406  (_net_297, SE);
not inst407  (_net_298, SI);
and inst408  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, D1, _net_294, _net_295, _net_296, _net_297, _net_298);
not inst409  (_net_299, D0);
not inst410  (_net_300, D2);
not inst411  (_net_301, D3);
not inst412  (_net_302, SE);
and inst413  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, D1, _net_299, _net_300, _net_301, _net_302, SI);
not inst414  (_net_303, D1);
not inst415  (_net_304, D2);
not inst416  (_net_305, D3);
not inst417  (_net_306, SE);
not inst418  (_net_307, SI);
and inst419  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI, _net_303, D0, _net_304, _net_305, _net_306, _net_307);
not inst420  (_net_308, D1);
not inst421  (_net_309, D2);
not inst422  (_net_310, D3);
not inst423  (_net_311, SE);
and inst424  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI, _net_308, D0, _net_309, _net_310, _net_311, SI);
not inst425  (_net_312, D1);
not inst426  (_net_313, D0);
not inst427  (_net_314, D2);
not inst428  (_net_315, D3);
not inst429  (_net_316, RD);
and inst430  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI, _net_312, _net_313, _net_314, _net_315, _net_316, SI);
not inst431  (_net_317, D1);
not inst432  (_net_318, D0);
not inst433  (_net_319, D2);
not inst434  (_net_320, D3);
and inst435  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI, _net_317, _net_318, _net_319, _net_320, RD, SI);
not inst436  (_net_321, D1);
not inst437  (_net_322, D0);
not inst438  (_net_323, D2);
not inst439  (_net_324, SI);
and inst440  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI, _net_321, _net_322, _net_323, D3, RD, _net_324);
not inst441  (_net_325, D1);
not inst442  (_net_326, D0);
not inst443  (_net_327, D3);
not inst444  (_net_328, SI);
and inst445  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, _net_325, _net_326, D2, _net_327, RD, _net_328);
not inst446  (_net_329, D0);
not inst447  (_net_330, D2);
not inst448  (_net_331, D3);
not inst449  (_net_332, SI);
and inst450  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, D1, _net_329, _net_330, _net_331, RD, _net_332);
not inst451  (_net_333, D1);
not inst452  (_net_334, D2);
not inst453  (_net_335, D3);
not inst454  (_net_336, SI);
and inst455  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI, _net_333, D0, _net_334, _net_335, RD, _net_336);
not inst456  (_net_337, RD);
and inst457  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI, D1, D0, D2, D3, _net_337, SI);
not inst458  (_net_338, RD);
not inst459  (_net_339, D0);
and inst460  (ENABLE_NOT_D0_AND_NOT_RD_AND_SE, _net_338, _net_339, SE);
not inst461  (_net_340, D0);
and inst462  (ENABLE_NOT_D0_AND_RD_AND_SE, RD, _net_340, SE);
not inst463  (_net_341, RD);
and inst464  (ENABLE_D0_AND_NOT_RD_AND_SE, _net_341, D0, SE);
and inst465  (ENABLE_D0_AND_RD_AND_SE, RD, D0, SE);
not inst466  (_net_342, SE);
not inst467  (_net_343, SI);
and inst468  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_342, RD, _net_343);
not inst469  (_net_344, SE);
and inst470  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_344, RD, SI);

specify
if (D0==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK , 0 ,0, viol_0);
$width(negedge CK , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK , posedge RD , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK , negedge RD , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_FSDPSYNRBQM4SS_V2Y8_2

//%BEGIN HDBSVT11_FSDPSYNRBQM8SS_V2Y8_1
`celldefine
module HDBSVT11_FSDPSYNRBQM8SS_V2Y8_1 (Q0, Q1, Q2, Q3, Q4, Q5, Q6, Q7, CK, D0, D1, D2, D3, D4, D5, D6, D7, SI, SE, RD);
  input CK, D0, D1, D2, D3, D4, D5, D6, D7, SI, SE, RD;
  output Q0, Q1, Q2, Q3, Q4, Q5, Q6, Q7;
  reg viol_0;
  wire int_16, int_17, int_18, int_19, int_20, int_21, int_22, int_23, iq7, iq6, iq5, iq4, iq3, iq2, iq1, iq0, d_int7, d_int6, d_int5, d_int4, d_int3, d_int2, d_int1, d_int0;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D0, D0);
    buf inst2  (delayed_D1, D1);
    buf inst3  (delayed_D2, D2);
    buf inst4  (delayed_D3, D3);
    buf inst5  (delayed_D4, D4);
    buf inst6  (delayed_D5, D5);
    buf inst7  (delayed_D6, D6);
    buf inst8  (delayed_D7, D7);
    buf inst9  (delayed_SI, SI);
    buf inst10  (delayed_SE, SE);
    buf inst11  (delayed_RD, RD);
  `endif


    and inst12  (int_16, delayed_RD, delayed_D0);
    and inst13  (int_17, delayed_RD, delayed_D1);
    and inst14  (int_18, delayed_RD, delayed_D2);
    and inst15  (int_19, delayed_RD, delayed_D3);
    and inst16  (int_20, delayed_RD, delayed_D4);
    and inst17  (int_21, delayed_RD, delayed_D5);
    and inst18  (int_22, delayed_RD, delayed_D6);
    and inst19  (int_23, delayed_RD, delayed_D7);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst20  (xcr_26, delayed_CK, d_int7);

  `endif
    snps_dff inst21  (iq7, viol_0, delayed_CK, d_int7, xcr_26);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst22  (xcr_28, delayed_CK, d_int6);

  `endif
    snps_dff inst23  (iq6, viol_0, delayed_CK, d_int6, xcr_28);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst24  (xcr_30, delayed_CK, d_int5);

  `endif
    snps_dff inst25  (iq5, viol_0, delayed_CK, d_int5, xcr_30);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst26  (xcr_32, delayed_CK, d_int4);

  `endif
    snps_dff inst27  (iq4, viol_0, delayed_CK, d_int4, xcr_32);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst28  (xcr_34, delayed_CK, d_int3);

  `endif
    snps_dff inst29  (iq3, viol_0, delayed_CK, d_int3, xcr_34);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst30  (xcr_36, delayed_CK, d_int2);

  `endif
    snps_dff inst31  (iq2, viol_0, delayed_CK, d_int2, xcr_36);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst32  (xcr_38, delayed_CK, d_int1);

  `endif
    snps_dff inst33  (iq1, viol_0, delayed_CK, d_int1, xcr_38);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst34  (xcr_40, delayed_CK, d_int0);

  `endif
    snps_dff inst35  (iq0, viol_0, delayed_CK, d_int0, xcr_40);
    snps_mux2 inst36  (d_int7, iq6, int_23, delayed_SE);
    snps_mux2 inst37  (d_int6, iq5, int_22, delayed_SE);
    snps_mux2 inst38  (d_int5, iq4, int_21, delayed_SE);
    snps_mux2 inst39  (d_int4, iq3, int_20, delayed_SE);
    snps_mux2 inst40  (d_int3, iq2, int_19, delayed_SE);
    snps_mux2 inst41  (d_int2, iq1, int_18, delayed_SE);
    snps_mux2 inst42  (d_int1, iq0, int_17, delayed_SE);
    snps_mux2 inst43  (d_int0, delayed_SI, int_16, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_COMBO_DELAY  inst44 (Q7, iq7);
    buf #`SNPS_COMBO_DELAY  inst45 (Q6, iq6);
    buf #`SNPS_COMBO_DELAY  inst46 (Q5, iq5);
    buf #`SNPS_COMBO_DELAY  inst47 (Q4, iq4);
    buf #`SNPS_COMBO_DELAY  inst48 (Q3, iq3);
    buf #`SNPS_COMBO_DELAY  inst49 (Q2, iq2);
    buf #`SNPS_COMBO_DELAY  inst50 (Q1, iq1);
    buf #`SNPS_COMBO_DELAY  inst51 (Q0, iq0);
  `else
    buf inst52  (Q7, iq7);
    buf inst53  (Q6, iq6);
    buf inst54  (Q5, iq5);
    buf inst55  (Q4, iq4);
    buf inst56  (Q3, iq3);
    buf inst57  (Q2, iq2);
    buf inst58  (Q1, iq1);
    buf inst59  (Q0, iq0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst60  (_net_0, D1);
not inst61  (_net_1, D0);
not inst62  (_net_2, D2);
not inst63  (_net_3, D3);
not inst64  (_net_4, D4);
not inst65  (_net_5, D5);
not inst66  (_net_6, D6);
not inst67  (_net_7, D7);
not inst68  (_net_8, RD);
not inst69  (_net_9, SE);
not inst70  (_net_10, SI);
and inst71  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5, _net_6, _net_7, _net_8, _net_9, _net_10);
not inst72  (_net_11, D1);
not inst73  (_net_12, D0);
not inst74  (_net_13, D2);
not inst75  (_net_14, D3);
not inst76  (_net_15, D4);
not inst77  (_net_16, D5);
not inst78  (_net_17, D6);
not inst79  (_net_18, D7);
not inst80  (_net_19, RD);
not inst81  (_net_20, SE);
and inst82  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_11, _net_12, _net_13, _net_14, _net_15, _net_16, _net_17, _net_18, _net_19, _net_20, SI);
not inst83  (_net_21, D1);
not inst84  (_net_22, D0);
not inst85  (_net_23, D2);
not inst86  (_net_24, D3);
not inst87  (_net_25, D4);
not inst88  (_net_26, D5);
not inst89  (_net_27, D6);
not inst90  (_net_28, D7);
not inst91  (_net_29, RD);
not inst92  (_net_30, SI);
and inst93  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_21, _net_22, _net_23, _net_24, _net_25, _net_26, _net_27, _net_28, _net_29, SE, _net_30);
not inst94  (_net_31, D1);
not inst95  (_net_32, D0);
not inst96  (_net_33, D2);
not inst97  (_net_34, D3);
not inst98  (_net_35, D4);
not inst99  (_net_36, D5);
not inst100  (_net_37, D6);
not inst101  (_net_38, D7);
not inst102  (_net_39, RD);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, _net_31, _net_32, _net_33, _net_34, _net_35, _net_36, _net_37, _net_38, _net_39, SE, SI);
not inst104  (_net_40, D1);
not inst105  (_net_41, D0);
not inst106  (_net_42, D2);
not inst107  (_net_43, D3);
not inst108  (_net_44, D4);
not inst109  (_net_45, D5);
not inst110  (_net_46, D6);
not inst111  (_net_47, D7);
not inst112  (_net_48, SE);
not inst113  (_net_49, SI);
and inst114  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_40, _net_41, _net_42, _net_43, _net_44, _net_45, _net_46, _net_47, RD, _net_48, _net_49);
not inst115  (_net_50, D1);
not inst116  (_net_51, D0);
not inst117  (_net_52, D2);
not inst118  (_net_53, D3);
not inst119  (_net_54, D4);
not inst120  (_net_55, D5);
not inst121  (_net_56, D6);
not inst122  (_net_57, D7);
not inst123  (_net_58, SE);
and inst124  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_50, _net_51, _net_52, _net_53, _net_54, _net_55, _net_56, _net_57, RD, _net_58, SI);
not inst125  (_net_59, D1);
not inst126  (_net_60, D0);
not inst127  (_net_61, D2);
not inst128  (_net_62, D3);
not inst129  (_net_63, D4);
not inst130  (_net_64, D5);
not inst131  (_net_65, D6);
not inst132  (_net_66, D7);
not inst133  (_net_67, SI);
and inst134  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_59, _net_60, _net_61, _net_62, _net_63, _net_64, _net_65, _net_66, RD, SE, _net_67);
not inst135  (_net_68, D1);
not inst136  (_net_69, D0);
not inst137  (_net_70, D2);
not inst138  (_net_71, D3);
not inst139  (_net_72, D4);
not inst140  (_net_73, D5);
not inst141  (_net_74, D6);
not inst142  (_net_75, D7);
and inst143  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_68, _net_69, _net_70, _net_71, _net_72, _net_73, _net_74, _net_75, RD, SE, SI);
not inst144  (_net_76, D1);
not inst145  (_net_77, D0);
not inst146  (_net_78, D2);
not inst147  (_net_79, D3);
not inst148  (_net_80, D4);
not inst149  (_net_81, D5);
not inst150  (_net_82, D6);
not inst151  (_net_83, RD);
not inst152  (_net_84, SE);
not inst153  (_net_85, SI);
and inst154  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_76, _net_77, _net_78, _net_79, _net_80, _net_81, _net_82, D7, _net_83, _net_84, _net_85);
not inst155  (_net_86, D1);
not inst156  (_net_87, D0);
not inst157  (_net_88, D2);
not inst158  (_net_89, D3);
not inst159  (_net_90, D4);
not inst160  (_net_91, D5);
not inst161  (_net_92, D6);
not inst162  (_net_93, RD);
not inst163  (_net_94, SE);
and inst164  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_86, _net_87, _net_88, _net_89, _net_90, _net_91, _net_92, D7, _net_93, _net_94, SI);
not inst165  (_net_95, D1);
not inst166  (_net_96, D0);
not inst167  (_net_97, D2);
not inst168  (_net_98, D3);
not inst169  (_net_99, D4);
not inst170  (_net_100, D5);
not inst171  (_net_101, D6);
not inst172  (_net_102, RD);
not inst173  (_net_103, SI);
and inst174  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_95, _net_96, _net_97, _net_98, _net_99, _net_100, _net_101, D7, _net_102, SE, _net_103);
not inst175  (_net_104, D1);
not inst176  (_net_105, D0);
not inst177  (_net_106, D2);
not inst178  (_net_107, D3);
not inst179  (_net_108, D4);
not inst180  (_net_109, D5);
not inst181  (_net_110, D6);
not inst182  (_net_111, RD);
and inst183  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI, _net_104, _net_105, _net_106, _net_107, _net_108, _net_109, _net_110, D7, _net_111, SE, SI);
not inst184  (_net_112, D1);
not inst185  (_net_113, D0);
not inst186  (_net_114, D2);
not inst187  (_net_115, D3);
not inst188  (_net_116, D4);
not inst189  (_net_117, D5);
not inst190  (_net_118, D6);
not inst191  (_net_119, SE);
not inst192  (_net_120, SI);
and inst193  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_112, _net_113, _net_114, _net_115, _net_116, _net_117, _net_118, D7, RD, _net_119, _net_120);
not inst194  (_net_121, D1);
not inst195  (_net_122, D0);
not inst196  (_net_123, D2);
not inst197  (_net_124, D3);
not inst198  (_net_125, D4);
not inst199  (_net_126, D5);
not inst200  (_net_127, D6);
not inst201  (_net_128, SE);
and inst202  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_121, _net_122, _net_123, _net_124, _net_125, _net_126, _net_127, D7, RD, _net_128, SI);
not inst203  (_net_129, D1);
not inst204  (_net_130, D0);
not inst205  (_net_131, D2);
not inst206  (_net_132, D3);
not inst207  (_net_133, D4);
not inst208  (_net_134, D5);
not inst209  (_net_135, D6);
not inst210  (_net_136, SI);
and inst211  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_129, _net_130, _net_131, _net_132, _net_133, _net_134, _net_135, D7, RD, SE, _net_136);
not inst212  (_net_137, D1);
not inst213  (_net_138, D0);
not inst214  (_net_139, D2);
not inst215  (_net_140, D3);
not inst216  (_net_141, D4);
not inst217  (_net_142, D5);
not inst218  (_net_143, D6);
and inst219  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_137, _net_138, _net_139, _net_140, _net_141, _net_142, _net_143, D7, RD, SE, SI);
not inst220  (_net_144, D1);
not inst221  (_net_145, D0);
not inst222  (_net_146, D2);
not inst223  (_net_147, D3);
not inst224  (_net_148, D4);
not inst225  (_net_149, D5);
not inst226  (_net_150, D7);
not inst227  (_net_151, RD);
not inst228  (_net_152, SE);
not inst229  (_net_153, SI);
and inst230  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_144, _net_145, _net_146, _net_147, _net_148, _net_149, D6, _net_150, _net_151, _net_152, _net_153);
not inst231  (_net_154, D1);
not inst232  (_net_155, D0);
not inst233  (_net_156, D2);
not inst234  (_net_157, D3);
not inst235  (_net_158, D4);
not inst236  (_net_159, D5);
not inst237  (_net_160, D7);
not inst238  (_net_161, RD);
not inst239  (_net_162, SE);
and inst240  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_154, _net_155, _net_156, _net_157, _net_158, _net_159, D6, _net_160, _net_161, _net_162, SI);
not inst241  (_net_163, D1);
not inst242  (_net_164, D0);
not inst243  (_net_165, D2);
not inst244  (_net_166, D3);
not inst245  (_net_167, D4);
not inst246  (_net_168, D5);
not inst247  (_net_169, D7);
not inst248  (_net_170, RD);
not inst249  (_net_171, SI);
and inst250  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_163, _net_164, _net_165, _net_166, _net_167, _net_168, D6, _net_169, _net_170, SE, _net_171);
not inst251  (_net_172, D1);
not inst252  (_net_173, D0);
not inst253  (_net_174, D2);
not inst254  (_net_175, D3);
not inst255  (_net_176, D4);
not inst256  (_net_177, D5);
not inst257  (_net_178, D7);
not inst258  (_net_179, RD);
and inst259  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, _net_172, _net_173, _net_174, _net_175, _net_176, _net_177, D6, _net_178, _net_179, SE, SI);
not inst260  (_net_180, D1);
not inst261  (_net_181, D0);
not inst262  (_net_182, D2);
not inst263  (_net_183, D3);
not inst264  (_net_184, D4);
not inst265  (_net_185, D5);
not inst266  (_net_186, D7);
not inst267  (_net_187, SE);
not inst268  (_net_188, SI);
and inst269  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_180, _net_181, _net_182, _net_183, _net_184, _net_185, D6, _net_186, RD, _net_187, _net_188);
not inst270  (_net_189, D1);
not inst271  (_net_190, D0);
not inst272  (_net_191, D2);
not inst273  (_net_192, D3);
not inst274  (_net_193, D4);
not inst275  (_net_194, D5);
not inst276  (_net_195, D7);
not inst277  (_net_196, SE);
and inst278  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_189, _net_190, _net_191, _net_192, _net_193, _net_194, D6, _net_195, RD, _net_196, SI);
not inst279  (_net_197, D1);
not inst280  (_net_198, D0);
not inst281  (_net_199, D2);
not inst282  (_net_200, D3);
not inst283  (_net_201, D4);
not inst284  (_net_202, D5);
not inst285  (_net_203, D7);
not inst286  (_net_204, SI);
and inst287  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_197, _net_198, _net_199, _net_200, _net_201, _net_202, D6, _net_203, RD, SE, _net_204);
not inst288  (_net_205, D1);
not inst289  (_net_206, D0);
not inst290  (_net_207, D2);
not inst291  (_net_208, D3);
not inst292  (_net_209, D4);
not inst293  (_net_210, D5);
not inst294  (_net_211, D7);
and inst295  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_205, _net_206, _net_207, _net_208, _net_209, _net_210, D6, _net_211, RD, SE, SI);
not inst296  (_net_212, D1);
not inst297  (_net_213, D0);
not inst298  (_net_214, D2);
not inst299  (_net_215, D3);
not inst300  (_net_216, D4);
not inst301  (_net_217, D6);
not inst302  (_net_218, D7);
not inst303  (_net_219, RD);
not inst304  (_net_220, SE);
not inst305  (_net_221, SI);
and inst306  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_212, _net_213, _net_214, _net_215, _net_216, D5, _net_217, _net_218, _net_219, _net_220, _net_221);
not inst307  (_net_222, D1);
not inst308  (_net_223, D0);
not inst309  (_net_224, D2);
not inst310  (_net_225, D3);
not inst311  (_net_226, D4);
not inst312  (_net_227, D6);
not inst313  (_net_228, D7);
not inst314  (_net_229, RD);
not inst315  (_net_230, SE);
and inst316  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_222, _net_223, _net_224, _net_225, _net_226, D5, _net_227, _net_228, _net_229, _net_230, SI);
not inst317  (_net_231, D1);
not inst318  (_net_232, D0);
not inst319  (_net_233, D2);
not inst320  (_net_234, D3);
not inst321  (_net_235, D4);
not inst322  (_net_236, D6);
not inst323  (_net_237, D7);
not inst324  (_net_238, RD);
not inst325  (_net_239, SI);
and inst326  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_231, _net_232, _net_233, _net_234, _net_235, D5, _net_236, _net_237, _net_238, SE, _net_239);
not inst327  (_net_240, D1);
not inst328  (_net_241, D0);
not inst329  (_net_242, D2);
not inst330  (_net_243, D3);
not inst331  (_net_244, D4);
not inst332  (_net_245, D6);
not inst333  (_net_246, D7);
not inst334  (_net_247, RD);
and inst335  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, _net_240, _net_241, _net_242, _net_243, _net_244, D5, _net_245, _net_246, _net_247, SE, SI);
not inst336  (_net_248, D1);
not inst337  (_net_249, D0);
not inst338  (_net_250, D2);
not inst339  (_net_251, D3);
not inst340  (_net_252, D4);
not inst341  (_net_253, D6);
not inst342  (_net_254, D7);
not inst343  (_net_255, SE);
not inst344  (_net_256, SI);
and inst345  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_248, _net_249, _net_250, _net_251, _net_252, D5, _net_253, _net_254, RD, _net_255, _net_256);
not inst346  (_net_257, D1);
not inst347  (_net_258, D0);
not inst348  (_net_259, D2);
not inst349  (_net_260, D3);
not inst350  (_net_261, D4);
not inst351  (_net_262, D6);
not inst352  (_net_263, D7);
not inst353  (_net_264, SE);
and inst354  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_257, _net_258, _net_259, _net_260, _net_261, D5, _net_262, _net_263, RD, _net_264, SI);
not inst355  (_net_265, D1);
not inst356  (_net_266, D0);
not inst357  (_net_267, D2);
not inst358  (_net_268, D3);
not inst359  (_net_269, D4);
not inst360  (_net_270, D6);
not inst361  (_net_271, D7);
not inst362  (_net_272, SI);
and inst363  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_265, _net_266, _net_267, _net_268, _net_269, D5, _net_270, _net_271, RD, SE, _net_272);
not inst364  (_net_273, D1);
not inst365  (_net_274, D0);
not inst366  (_net_275, D2);
not inst367  (_net_276, D3);
not inst368  (_net_277, D4);
not inst369  (_net_278, D6);
not inst370  (_net_279, D7);
and inst371  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_273, _net_274, _net_275, _net_276, _net_277, D5, _net_278, _net_279, RD, SE, SI);
not inst372  (_net_280, D1);
not inst373  (_net_281, D0);
not inst374  (_net_282, D2);
not inst375  (_net_283, D3);
not inst376  (_net_284, D5);
not inst377  (_net_285, D6);
not inst378  (_net_286, D7);
not inst379  (_net_287, RD);
not inst380  (_net_288, SE);
not inst381  (_net_289, SI);
and inst382  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_280, _net_281, _net_282, _net_283, D4, _net_284, _net_285, _net_286, _net_287, _net_288, _net_289);
not inst383  (_net_290, D1);
not inst384  (_net_291, D0);
not inst385  (_net_292, D2);
not inst386  (_net_293, D3);
not inst387  (_net_294, D5);
not inst388  (_net_295, D6);
not inst389  (_net_296, D7);
not inst390  (_net_297, RD);
not inst391  (_net_298, SE);
and inst392  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_290, _net_291, _net_292, _net_293, D4, _net_294, _net_295, _net_296, _net_297, _net_298, SI);
not inst393  (_net_299, D1);
not inst394  (_net_300, D0);
not inst395  (_net_301, D2);
not inst396  (_net_302, D3);
not inst397  (_net_303, D5);
not inst398  (_net_304, D6);
not inst399  (_net_305, D7);
not inst400  (_net_306, RD);
not inst401  (_net_307, SI);
and inst402  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_299, _net_300, _net_301, _net_302, D4, _net_303, _net_304, _net_305, _net_306, SE, _net_307);
not inst403  (_net_308, D1);
not inst404  (_net_309, D0);
not inst405  (_net_310, D2);
not inst406  (_net_311, D3);
not inst407  (_net_312, D5);
not inst408  (_net_313, D6);
not inst409  (_net_314, D7);
not inst410  (_net_315, RD);
and inst411  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, _net_308, _net_309, _net_310, _net_311, D4, _net_312, _net_313, _net_314, _net_315, SE, SI);
not inst412  (_net_316, D1);
not inst413  (_net_317, D0);
not inst414  (_net_318, D2);
not inst415  (_net_319, D3);
not inst416  (_net_320, D5);
not inst417  (_net_321, D6);
not inst418  (_net_322, D7);
not inst419  (_net_323, SE);
not inst420  (_net_324, SI);
and inst421  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_316, _net_317, _net_318, _net_319, D4, _net_320, _net_321, _net_322, RD, _net_323, _net_324);
not inst422  (_net_325, D1);
not inst423  (_net_326, D0);
not inst424  (_net_327, D2);
not inst425  (_net_328, D3);
not inst426  (_net_329, D5);
not inst427  (_net_330, D6);
not inst428  (_net_331, D7);
not inst429  (_net_332, SE);
and inst430  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_325, _net_326, _net_327, _net_328, D4, _net_329, _net_330, _net_331, RD, _net_332, SI);
not inst431  (_net_333, D1);
not inst432  (_net_334, D0);
not inst433  (_net_335, D2);
not inst434  (_net_336, D3);
not inst435  (_net_337, D5);
not inst436  (_net_338, D6);
not inst437  (_net_339, D7);
not inst438  (_net_340, SI);
and inst439  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_333, _net_334, _net_335, _net_336, D4, _net_337, _net_338, _net_339, RD, SE, _net_340);
not inst440  (_net_341, D1);
not inst441  (_net_342, D0);
not inst442  (_net_343, D2);
not inst443  (_net_344, D3);
not inst444  (_net_345, D5);
not inst445  (_net_346, D6);
not inst446  (_net_347, D7);
and inst447  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_341, _net_342, _net_343, _net_344, D4, _net_345, _net_346, _net_347, RD, SE, SI);
not inst448  (_net_348, D1);
not inst449  (_net_349, D0);
not inst450  (_net_350, D2);
not inst451  (_net_351, D3);
not inst452  (_net_352, RD);
not inst453  (_net_353, SE);
not inst454  (_net_354, SI);
and inst455  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_348, _net_349, _net_350, _net_351, D4, D5, D6, D7, _net_352, _net_353, _net_354);
not inst456  (_net_355, D1);
not inst457  (_net_356, D0);
not inst458  (_net_357, D2);
not inst459  (_net_358, D3);
not inst460  (_net_359, RD);
not inst461  (_net_360, SE);
and inst462  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_355, _net_356, _net_357, _net_358, D4, D5, D6, D7, _net_359, _net_360, SI);
not inst463  (_net_361, D1);
not inst464  (_net_362, D0);
not inst465  (_net_363, D2);
not inst466  (_net_364, D3);
not inst467  (_net_365, RD);
not inst468  (_net_366, SI);
and inst469  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_361, _net_362, _net_363, _net_364, D4, D5, D6, D7, _net_365, SE, _net_366);
not inst470  (_net_367, D1);
not inst471  (_net_368, D0);
not inst472  (_net_369, D2);
not inst473  (_net_370, D3);
not inst474  (_net_371, RD);
and inst475  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI, _net_367, _net_368, _net_369, _net_370, D4, D5, D6, D7, _net_371, SE, SI);
not inst476  (_net_372, D1);
not inst477  (_net_373, D0);
not inst478  (_net_374, D2);
not inst479  (_net_375, D3);
not inst480  (_net_376, SE);
not inst481  (_net_377, SI);
and inst482  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_372, _net_373, _net_374, _net_375, D4, D5, D6, D7, RD, _net_376, _net_377);
not inst483  (_net_378, D1);
not inst484  (_net_379, D0);
not inst485  (_net_380, D2);
not inst486  (_net_381, D3);
not inst487  (_net_382, SE);
and inst488  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_378, _net_379, _net_380, _net_381, D4, D5, D6, D7, RD, _net_382, SI);
not inst489  (_net_383, D1);
not inst490  (_net_384, D0);
not inst491  (_net_385, D2);
not inst492  (_net_386, D3);
not inst493  (_net_387, SI);
and inst494  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_383, _net_384, _net_385, _net_386, D4, D5, D6, D7, RD, SE, _net_387);
not inst495  (_net_388, D1);
not inst496  (_net_389, D0);
not inst497  (_net_390, D2);
not inst498  (_net_391, D3);
and inst499  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_388, _net_389, _net_390, _net_391, D4, D5, D6, D7, RD, SE, SI);
not inst500  (_net_392, D1);
not inst501  (_net_393, D0);
not inst502  (_net_394, D2);
not inst503  (_net_395, D4);
not inst504  (_net_396, D5);
not inst505  (_net_397, D6);
not inst506  (_net_398, D7);
not inst507  (_net_399, RD);
not inst508  (_net_400, SE);
not inst509  (_net_401, SI);
and inst510  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_392, _net_393, _net_394, D3, _net_395, _net_396, _net_397, _net_398, _net_399, _net_400, _net_401);
not inst511  (_net_402, D1);
not inst512  (_net_403, D0);
not inst513  (_net_404, D2);
not inst514  (_net_405, D4);
not inst515  (_net_406, D5);
not inst516  (_net_407, D6);
not inst517  (_net_408, D7);
not inst518  (_net_409, RD);
not inst519  (_net_410, SE);
and inst520  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_402, _net_403, _net_404, D3, _net_405, _net_406, _net_407, _net_408, _net_409, _net_410, SI);
not inst521  (_net_411, D1);
not inst522  (_net_412, D0);
not inst523  (_net_413, D2);
not inst524  (_net_414, D4);
not inst525  (_net_415, D5);
not inst526  (_net_416, D6);
not inst527  (_net_417, D7);
not inst528  (_net_418, RD);
not inst529  (_net_419, SI);
and inst530  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_411, _net_412, _net_413, D3, _net_414, _net_415, _net_416, _net_417, _net_418, SE, _net_419);
not inst531  (_net_420, D1);
not inst532  (_net_421, D0);
not inst533  (_net_422, D2);
not inst534  (_net_423, D4);
not inst535  (_net_424, D5);
not inst536  (_net_425, D6);
not inst537  (_net_426, D7);
not inst538  (_net_427, RD);
and inst539  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, _net_420, _net_421, _net_422, D3, _net_423, _net_424, _net_425, _net_426, _net_427, SE, SI);
not inst540  (_net_428, D1);
not inst541  (_net_429, D0);
not inst542  (_net_430, D2);
not inst543  (_net_431, D4);
not inst544  (_net_432, D5);
not inst545  (_net_433, D6);
not inst546  (_net_434, D7);
not inst547  (_net_435, SE);
not inst548  (_net_436, SI);
and inst549  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_428, _net_429, _net_430, D3, _net_431, _net_432, _net_433, _net_434, RD, _net_435, _net_436);
not inst550  (_net_437, D1);
not inst551  (_net_438, D0);
not inst552  (_net_439, D2);
not inst553  (_net_440, D4);
not inst554  (_net_441, D5);
not inst555  (_net_442, D6);
not inst556  (_net_443, D7);
not inst557  (_net_444, SE);
and inst558  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_437, _net_438, _net_439, D3, _net_440, _net_441, _net_442, _net_443, RD, _net_444, SI);
not inst559  (_net_445, D1);
not inst560  (_net_446, D0);
not inst561  (_net_447, D2);
not inst562  (_net_448, D4);
not inst563  (_net_449, D5);
not inst564  (_net_450, D6);
not inst565  (_net_451, D7);
not inst566  (_net_452, SI);
and inst567  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_445, _net_446, _net_447, D3, _net_448, _net_449, _net_450, _net_451, RD, SE, _net_452);
not inst568  (_net_453, D1);
not inst569  (_net_454, D0);
not inst570  (_net_455, D2);
not inst571  (_net_456, D4);
not inst572  (_net_457, D5);
not inst573  (_net_458, D6);
not inst574  (_net_459, D7);
and inst575  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_453, _net_454, _net_455, D3, _net_456, _net_457, _net_458, _net_459, RD, SE, SI);
not inst576  (_net_460, D1);
not inst577  (_net_461, D0);
not inst578  (_net_462, D3);
not inst579  (_net_463, D4);
not inst580  (_net_464, D5);
not inst581  (_net_465, D6);
not inst582  (_net_466, D7);
not inst583  (_net_467, RD);
not inst584  (_net_468, SE);
not inst585  (_net_469, SI);
and inst586  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_460, _net_461, D2, _net_462, _net_463, _net_464, _net_465, _net_466, _net_467, _net_468, _net_469);
not inst587  (_net_470, D1);
not inst588  (_net_471, D0);
not inst589  (_net_472, D3);
not inst590  (_net_473, D4);
not inst591  (_net_474, D5);
not inst592  (_net_475, D6);
not inst593  (_net_476, D7);
not inst594  (_net_477, RD);
not inst595  (_net_478, SE);
and inst596  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_470, _net_471, D2, _net_472, _net_473, _net_474, _net_475, _net_476, _net_477, _net_478, SI);
not inst597  (_net_479, D1);
not inst598  (_net_480, D0);
not inst599  (_net_481, D3);
not inst600  (_net_482, D4);
not inst601  (_net_483, D5);
not inst602  (_net_484, D6);
not inst603  (_net_485, D7);
not inst604  (_net_486, RD);
not inst605  (_net_487, SI);
and inst606  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_479, _net_480, D2, _net_481, _net_482, _net_483, _net_484, _net_485, _net_486, SE, _net_487);
not inst607  (_net_488, D1);
not inst608  (_net_489, D0);
not inst609  (_net_490, D3);
not inst610  (_net_491, D4);
not inst611  (_net_492, D5);
not inst612  (_net_493, D6);
not inst613  (_net_494, D7);
not inst614  (_net_495, RD);
and inst615  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, _net_488, _net_489, D2, _net_490, _net_491, _net_492, _net_493, _net_494, _net_495, SE, SI);
not inst616  (_net_496, D1);
not inst617  (_net_497, D0);
not inst618  (_net_498, D3);
not inst619  (_net_499, D4);
not inst620  (_net_500, D5);
not inst621  (_net_501, D6);
not inst622  (_net_502, D7);
not inst623  (_net_503, SE);
not inst624  (_net_504, SI);
and inst625  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_496, _net_497, D2, _net_498, _net_499, _net_500, _net_501, _net_502, RD, _net_503, _net_504);
not inst626  (_net_505, D1);
not inst627  (_net_506, D0);
not inst628  (_net_507, D3);
not inst629  (_net_508, D4);
not inst630  (_net_509, D5);
not inst631  (_net_510, D6);
not inst632  (_net_511, D7);
not inst633  (_net_512, SE);
and inst634  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_505, _net_506, D2, _net_507, _net_508, _net_509, _net_510, _net_511, RD, _net_512, SI);
not inst635  (_net_513, D1);
not inst636  (_net_514, D0);
not inst637  (_net_515, D3);
not inst638  (_net_516, D4);
not inst639  (_net_517, D5);
not inst640  (_net_518, D6);
not inst641  (_net_519, D7);
not inst642  (_net_520, SI);
and inst643  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_513, _net_514, D2, _net_515, _net_516, _net_517, _net_518, _net_519, RD, SE, _net_520);
not inst644  (_net_521, D1);
not inst645  (_net_522, D0);
not inst646  (_net_523, D3);
not inst647  (_net_524, D4);
not inst648  (_net_525, D5);
not inst649  (_net_526, D6);
not inst650  (_net_527, D7);
and inst651  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_521, _net_522, D2, _net_523, _net_524, _net_525, _net_526, _net_527, RD, SE, SI);
not inst652  (_net_528, D0);
not inst653  (_net_529, D2);
not inst654  (_net_530, D3);
not inst655  (_net_531, D4);
not inst656  (_net_532, D5);
not inst657  (_net_533, D6);
not inst658  (_net_534, D7);
not inst659  (_net_535, RD);
not inst660  (_net_536, SE);
not inst661  (_net_537, SI);
and inst662  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_528, _net_529, _net_530, _net_531, _net_532, _net_533, _net_534, _net_535, _net_536, _net_537);
not inst663  (_net_538, D0);
not inst664  (_net_539, D2);
not inst665  (_net_540, D3);
not inst666  (_net_541, D4);
not inst667  (_net_542, D5);
not inst668  (_net_543, D6);
not inst669  (_net_544, D7);
not inst670  (_net_545, RD);
not inst671  (_net_546, SE);
and inst672  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, D1, _net_538, _net_539, _net_540, _net_541, _net_542, _net_543, _net_544, _net_545, _net_546, SI);
not inst673  (_net_547, D0);
not inst674  (_net_548, D2);
not inst675  (_net_549, D3);
not inst676  (_net_550, D4);
not inst677  (_net_551, D5);
not inst678  (_net_552, D6);
not inst679  (_net_553, D7);
not inst680  (_net_554, RD);
not inst681  (_net_555, SI);
and inst682  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, D1, _net_547, _net_548, _net_549, _net_550, _net_551, _net_552, _net_553, _net_554, SE, _net_555);
not inst683  (_net_556, D0);
not inst684  (_net_557, D2);
not inst685  (_net_558, D3);
not inst686  (_net_559, D4);
not inst687  (_net_560, D5);
not inst688  (_net_561, D6);
not inst689  (_net_562, D7);
not inst690  (_net_563, RD);
and inst691  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, D1, _net_556, _net_557, _net_558, _net_559, _net_560, _net_561, _net_562, _net_563, SE, SI);
not inst692  (_net_564, D0);
not inst693  (_net_565, D2);
not inst694  (_net_566, D3);
not inst695  (_net_567, D4);
not inst696  (_net_568, D5);
not inst697  (_net_569, D6);
not inst698  (_net_570, D7);
not inst699  (_net_571, SE);
not inst700  (_net_572, SI);
and inst701  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_564, _net_565, _net_566, _net_567, _net_568, _net_569, _net_570, RD, _net_571, _net_572);
not inst702  (_net_573, D0);
not inst703  (_net_574, D2);
not inst704  (_net_575, D3);
not inst705  (_net_576, D4);
not inst706  (_net_577, D5);
not inst707  (_net_578, D6);
not inst708  (_net_579, D7);
not inst709  (_net_580, SE);
and inst710  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, D1, _net_573, _net_574, _net_575, _net_576, _net_577, _net_578, _net_579, RD, _net_580, SI);
not inst711  (_net_581, D0);
not inst712  (_net_582, D2);
not inst713  (_net_583, D3);
not inst714  (_net_584, D4);
not inst715  (_net_585, D5);
not inst716  (_net_586, D6);
not inst717  (_net_587, D7);
not inst718  (_net_588, SI);
and inst719  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, D1, _net_581, _net_582, _net_583, _net_584, _net_585, _net_586, _net_587, RD, SE, _net_588);
not inst720  (_net_589, D0);
not inst721  (_net_590, D2);
not inst722  (_net_591, D3);
not inst723  (_net_592, D4);
not inst724  (_net_593, D5);
not inst725  (_net_594, D6);
not inst726  (_net_595, D7);
and inst727  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, D1, _net_589, _net_590, _net_591, _net_592, _net_593, _net_594, _net_595, RD, SE, SI);
not inst728  (_net_596, D1);
not inst729  (_net_597, D2);
not inst730  (_net_598, D3);
not inst731  (_net_599, D4);
not inst732  (_net_600, D5);
not inst733  (_net_601, D6);
not inst734  (_net_602, D7);
not inst735  (_net_603, RD);
not inst736  (_net_604, SE);
not inst737  (_net_605, SI);
and inst738  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_596, D0, _net_597, _net_598, _net_599, _net_600, _net_601, _net_602, _net_603, _net_604, _net_605);
not inst739  (_net_606, D1);
not inst740  (_net_607, D2);
not inst741  (_net_608, D3);
not inst742  (_net_609, D4);
not inst743  (_net_610, D5);
not inst744  (_net_611, D6);
not inst745  (_net_612, D7);
not inst746  (_net_613, RD);
not inst747  (_net_614, SE);
and inst748  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_606, D0, _net_607, _net_608, _net_609, _net_610, _net_611, _net_612, _net_613, _net_614, SI);
not inst749  (_net_615, D1);
not inst750  (_net_616, D2);
not inst751  (_net_617, D3);
not inst752  (_net_618, D4);
not inst753  (_net_619, D5);
not inst754  (_net_620, D6);
not inst755  (_net_621, D7);
not inst756  (_net_622, RD);
not inst757  (_net_623, SI);
and inst758  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_615, D0, _net_616, _net_617, _net_618, _net_619, _net_620, _net_621, _net_622, SE, _net_623);
not inst759  (_net_624, D1);
not inst760  (_net_625, D2);
not inst761  (_net_626, D3);
not inst762  (_net_627, D4);
not inst763  (_net_628, D5);
not inst764  (_net_629, D6);
not inst765  (_net_630, D7);
not inst766  (_net_631, RD);
and inst767  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, _net_624, D0, _net_625, _net_626, _net_627, _net_628, _net_629, _net_630, _net_631, SE, SI);
not inst768  (_net_632, D1);
not inst769  (_net_633, D2);
not inst770  (_net_634, D3);
not inst771  (_net_635, D4);
not inst772  (_net_636, D5);
not inst773  (_net_637, D6);
not inst774  (_net_638, D7);
not inst775  (_net_639, SE);
not inst776  (_net_640, SI);
and inst777  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_632, D0, _net_633, _net_634, _net_635, _net_636, _net_637, _net_638, RD, _net_639, _net_640);
not inst778  (_net_641, D1);
not inst779  (_net_642, D2);
not inst780  (_net_643, D3);
not inst781  (_net_644, D4);
not inst782  (_net_645, D5);
not inst783  (_net_646, D6);
not inst784  (_net_647, D7);
not inst785  (_net_648, SE);
and inst786  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_641, D0, _net_642, _net_643, _net_644, _net_645, _net_646, _net_647, RD, _net_648, SI);
not inst787  (_net_649, D1);
not inst788  (_net_650, D2);
not inst789  (_net_651, D3);
not inst790  (_net_652, D4);
not inst791  (_net_653, D5);
not inst792  (_net_654, D6);
not inst793  (_net_655, D7);
not inst794  (_net_656, SI);
and inst795  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_649, D0, _net_650, _net_651, _net_652, _net_653, _net_654, _net_655, RD, SE, _net_656);
not inst796  (_net_657, D1);
not inst797  (_net_658, D2);
not inst798  (_net_659, D3);
not inst799  (_net_660, D4);
not inst800  (_net_661, D5);
not inst801  (_net_662, D6);
not inst802  (_net_663, D7);
and inst803  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_657, D0, _net_658, _net_659, _net_660, _net_661, _net_662, _net_663, RD, SE, SI);
not inst804  (_net_664, D1);
not inst805  (_net_665, D2);
not inst806  (_net_666, D3);
not inst807  (_net_667, RD);
not inst808  (_net_668, SE);
not inst809  (_net_669, SI);
and inst810  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_664, D0, _net_665, _net_666, D4, D5, D6, D7, _net_667, _net_668, _net_669);
not inst811  (_net_670, D1);
not inst812  (_net_671, D2);
not inst813  (_net_672, D3);
not inst814  (_net_673, RD);
not inst815  (_net_674, SE);
and inst816  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_670, D0, _net_671, _net_672, D4, D5, D6, D7, _net_673, _net_674, SI);
not inst817  (_net_675, D1);
not inst818  (_net_676, D2);
not inst819  (_net_677, D3);
not inst820  (_net_678, RD);
not inst821  (_net_679, SI);
and inst822  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_675, D0, _net_676, _net_677, D4, D5, D6, D7, _net_678, SE, _net_679);
not inst823  (_net_680, D1);
not inst824  (_net_681, D2);
not inst825  (_net_682, D3);
not inst826  (_net_683, RD);
and inst827  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI, _net_680, D0, _net_681, _net_682, D4, D5, D6, D7, _net_683, SE, SI);
not inst828  (_net_684, D1);
not inst829  (_net_685, D2);
not inst830  (_net_686, D3);
not inst831  (_net_687, SE);
not inst832  (_net_688, SI);
and inst833  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_684, D0, _net_685, _net_686, D4, D5, D6, D7, RD, _net_687, _net_688);
not inst834  (_net_689, D1);
not inst835  (_net_690, D2);
not inst836  (_net_691, D3);
not inst837  (_net_692, SE);
and inst838  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_689, D0, _net_690, _net_691, D4, D5, D6, D7, RD, _net_692, SI);
not inst839  (_net_693, D1);
not inst840  (_net_694, D2);
not inst841  (_net_695, D3);
not inst842  (_net_696, SI);
and inst843  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_693, D0, _net_694, _net_695, D4, D5, D6, D7, RD, SE, _net_696);
not inst844  (_net_697, D1);
not inst845  (_net_698, D2);
not inst846  (_net_699, D3);
and inst847  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_697, D0, _net_698, _net_699, D4, D5, D6, D7, RD, SE, SI);
not inst848  (_net_700, D1);
not inst849  (_net_701, D3);
not inst850  (_net_702, D5);
not inst851  (_net_703, D7);
not inst852  (_net_704, RD);
not inst853  (_net_705, SE);
not inst854  (_net_706, SI);
and inst855  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_700, D0, D2, _net_701, D4, _net_702, D6, _net_703, _net_704, _net_705, _net_706);
not inst856  (_net_707, D1);
not inst857  (_net_708, D3);
not inst858  (_net_709, D5);
not inst859  (_net_710, D7);
not inst860  (_net_711, RD);
not inst861  (_net_712, SE);
and inst862  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_707, D0, D2, _net_708, D4, _net_709, D6, _net_710, _net_711, _net_712, SI);
not inst863  (_net_713, D1);
not inst864  (_net_714, D3);
not inst865  (_net_715, D5);
not inst866  (_net_716, D7);
not inst867  (_net_717, RD);
not inst868  (_net_718, SI);
and inst869  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_713, D0, D2, _net_714, D4, _net_715, D6, _net_716, _net_717, SE, _net_718);
not inst870  (_net_719, D1);
not inst871  (_net_720, D3);
not inst872  (_net_721, D5);
not inst873  (_net_722, D7);
not inst874  (_net_723, RD);
and inst875  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, _net_719, D0, D2, _net_720, D4, _net_721, D6, _net_722, _net_723, SE, SI);
not inst876  (_net_724, D1);
not inst877  (_net_725, D3);
not inst878  (_net_726, D5);
not inst879  (_net_727, D7);
not inst880  (_net_728, SE);
not inst881  (_net_729, SI);
and inst882  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_724, D0, D2, _net_725, D4, _net_726, D6, _net_727, RD, _net_728, _net_729);
not inst883  (_net_730, D1);
not inst884  (_net_731, D3);
not inst885  (_net_732, D5);
not inst886  (_net_733, D7);
not inst887  (_net_734, SE);
and inst888  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_730, D0, D2, _net_731, D4, _net_732, D6, _net_733, RD, _net_734, SI);
not inst889  (_net_735, D1);
not inst890  (_net_736, D3);
not inst891  (_net_737, D5);
not inst892  (_net_738, D7);
not inst893  (_net_739, SI);
and inst894  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_735, D0, D2, _net_736, D4, _net_737, D6, _net_738, RD, SE, _net_739);
not inst895  (_net_740, D1);
not inst896  (_net_741, D3);
not inst897  (_net_742, D5);
not inst898  (_net_743, D7);
and inst899  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_740, D0, D2, _net_741, D4, _net_742, D6, _net_743, RD, SE, SI);
not inst900  (_net_744, D1);
not inst901  (_net_745, D3);
not inst902  (_net_746, D5);
not inst903  (_net_747, RD);
not inst904  (_net_748, SE);
not inst905  (_net_749, SI);
and inst906  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_744, D0, D2, _net_745, D4, _net_746, D6, D7, _net_747, _net_748, _net_749);
not inst907  (_net_750, D1);
not inst908  (_net_751, D3);
not inst909  (_net_752, D5);
not inst910  (_net_753, RD);
not inst911  (_net_754, SE);
and inst912  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_750, D0, D2, _net_751, D4, _net_752, D6, D7, _net_753, _net_754, SI);
not inst913  (_net_755, D1);
not inst914  (_net_756, D3);
not inst915  (_net_757, D5);
not inst916  (_net_758, RD);
not inst917  (_net_759, SI);
and inst918  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_755, D0, D2, _net_756, D4, _net_757, D6, D7, _net_758, SE, _net_759);
not inst919  (_net_760, D1);
not inst920  (_net_761, D3);
not inst921  (_net_762, D5);
not inst922  (_net_763, RD);
and inst923  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI, _net_760, D0, D2, _net_761, D4, _net_762, D6, D7, _net_763, SE, SI);
not inst924  (_net_764, D1);
not inst925  (_net_765, D3);
not inst926  (_net_766, D5);
not inst927  (_net_767, SE);
not inst928  (_net_768, SI);
and inst929  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_764, D0, D2, _net_765, D4, _net_766, D6, D7, RD, _net_767, _net_768);
not inst930  (_net_769, D1);
not inst931  (_net_770, D3);
not inst932  (_net_771, D5);
not inst933  (_net_772, SE);
and inst934  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_769, D0, D2, _net_770, D4, _net_771, D6, D7, RD, _net_772, SI);
not inst935  (_net_773, D1);
not inst936  (_net_774, D3);
not inst937  (_net_775, D5);
not inst938  (_net_776, SI);
and inst939  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_773, D0, D2, _net_774, D4, _net_775, D6, D7, RD, SE, _net_776);
not inst940  (_net_777, D1);
not inst941  (_net_778, D3);
not inst942  (_net_779, D5);
and inst943  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_777, D0, D2, _net_778, D4, _net_779, D6, D7, RD, SE, SI);
not inst944  (_net_780, D1);
not inst945  (_net_781, D3);
not inst946  (_net_782, RD);
not inst947  (_net_783, SE);
not inst948  (_net_784, SI);
and inst949  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_780, D0, D2, _net_781, D4, D5, D6, D7, _net_782, _net_783, _net_784);
not inst950  (_net_785, D1);
not inst951  (_net_786, D3);
not inst952  (_net_787, RD);
not inst953  (_net_788, SE);
and inst954  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_785, D0, D2, _net_786, D4, D5, D6, D7, _net_787, _net_788, SI);
not inst955  (_net_789, D1);
not inst956  (_net_790, D3);
not inst957  (_net_791, RD);
not inst958  (_net_792, SI);
and inst959  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_789, D0, D2, _net_790, D4, D5, D6, D7, _net_791, SE, _net_792);
not inst960  (_net_793, D1);
not inst961  (_net_794, D3);
not inst962  (_net_795, RD);
and inst963  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI, _net_793, D0, D2, _net_794, D4, D5, D6, D7, _net_795, SE, SI);
not inst964  (_net_796, D1);
not inst965  (_net_797, D3);
not inst966  (_net_798, SE);
not inst967  (_net_799, SI);
and inst968  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_796, D0, D2, _net_797, D4, D5, D6, D7, RD, _net_798, _net_799);
not inst969  (_net_800, D1);
not inst970  (_net_801, D3);
not inst971  (_net_802, SE);
and inst972  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_800, D0, D2, _net_801, D4, D5, D6, D7, RD, _net_802, SI);
not inst973  (_net_803, D1);
not inst974  (_net_804, D3);
not inst975  (_net_805, SI);
and inst976  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_803, D0, D2, _net_804, D4, D5, D6, D7, RD, SE, _net_805);
not inst977  (_net_806, D1);
not inst978  (_net_807, D3);
and inst979  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_806, D0, D2, _net_807, D4, D5, D6, D7, RD, SE, SI);
not inst980  (_net_808, RD);
not inst981  (_net_809, SE);
not inst982  (_net_810, SI);
and inst983  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, D4, D5, D6, D7, _net_808, _net_809, _net_810);
not inst984  (_net_811, RD);
not inst985  (_net_812, SE);
and inst986  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, _net_811, _net_812, SI);
not inst987  (_net_813, RD);
not inst988  (_net_814, SI);
and inst989  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, D1, D0, D2, D3, D4, D5, D6, D7, _net_813, SE, _net_814);
not inst990  (_net_815, RD);
and inst991  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, _net_815, SE, SI);
not inst992  (_net_816, SE);
not inst993  (_net_817, SI);
and inst994  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, D4, D5, D6, D7, RD, _net_816, _net_817);
not inst995  (_net_818, SE);
and inst996  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, RD, _net_818, SI);
not inst997  (_net_819, SI);
and inst998  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, D1, D0, D2, D3, D4, D5, D6, D7, RD, SE, _net_819);
and inst999  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, RD, SE, SI);
not inst1000  (_net_820, D1);
not inst1001  (_net_821, D0);
not inst1002  (_net_822, D2);
not inst1003  (_net_823, D3);
not inst1004  (_net_824, D4);
not inst1005  (_net_825, D5);
not inst1006  (_net_826, D7);
not inst1007  (_net_827, SE);
not inst1008  (_net_828, SI);
and inst1009  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_820, _net_821, _net_822, _net_823, _net_824, _net_825, D6, _net_826, _net_827, _net_828);
not inst1010  (_net_829, D1);
not inst1011  (_net_830, D0);
not inst1012  (_net_831, D2);
not inst1013  (_net_832, D3);
not inst1014  (_net_833, D4);
not inst1015  (_net_834, D5);
not inst1016  (_net_835, D7);
not inst1017  (_net_836, SE);
and inst1018  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_829, _net_830, _net_831, _net_832, _net_833, _net_834, D6, _net_835, _net_836, SI);
not inst1019  (_net_837, D1);
not inst1020  (_net_838, D0);
not inst1021  (_net_839, D2);
not inst1022  (_net_840, D3);
not inst1023  (_net_841, D4);
not inst1024  (_net_842, D6);
not inst1025  (_net_843, D7);
not inst1026  (_net_844, SE);
not inst1027  (_net_845, SI);
and inst1028  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_837, _net_838, _net_839, _net_840, _net_841, D5, _net_842, _net_843, _net_844, _net_845);
not inst1029  (_net_846, D1);
not inst1030  (_net_847, D0);
not inst1031  (_net_848, D2);
not inst1032  (_net_849, D3);
not inst1033  (_net_850, D4);
not inst1034  (_net_851, D6);
not inst1035  (_net_852, D7);
not inst1036  (_net_853, SE);
and inst1037  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_846, _net_847, _net_848, _net_849, _net_850, D5, _net_851, _net_852, _net_853, SI);
not inst1038  (_net_854, D1);
not inst1039  (_net_855, D0);
not inst1040  (_net_856, D2);
not inst1041  (_net_857, D3);
not inst1042  (_net_858, D5);
not inst1043  (_net_859, D6);
not inst1044  (_net_860, D7);
not inst1045  (_net_861, SE);
not inst1046  (_net_862, SI);
and inst1047  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_854, _net_855, _net_856, _net_857, D4, _net_858, _net_859, _net_860, _net_861, _net_862);
not inst1048  (_net_863, D1);
not inst1049  (_net_864, D0);
not inst1050  (_net_865, D2);
not inst1051  (_net_866, D3);
not inst1052  (_net_867, D5);
not inst1053  (_net_868, D6);
not inst1054  (_net_869, D7);
not inst1055  (_net_870, SE);
and inst1056  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_863, _net_864, _net_865, _net_866, D4, _net_867, _net_868, _net_869, _net_870, SI);
not inst1057  (_net_871, D1);
not inst1058  (_net_872, D0);
not inst1059  (_net_873, D2);
not inst1060  (_net_874, D4);
not inst1061  (_net_875, D5);
not inst1062  (_net_876, D6);
not inst1063  (_net_877, D7);
not inst1064  (_net_878, SE);
not inst1065  (_net_879, SI);
and inst1066  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_871, _net_872, _net_873, D3, _net_874, _net_875, _net_876, _net_877, _net_878, _net_879);
not inst1067  (_net_880, D1);
not inst1068  (_net_881, D0);
not inst1069  (_net_882, D2);
not inst1070  (_net_883, D4);
not inst1071  (_net_884, D5);
not inst1072  (_net_885, D6);
not inst1073  (_net_886, D7);
not inst1074  (_net_887, SE);
and inst1075  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_880, _net_881, _net_882, D3, _net_883, _net_884, _net_885, _net_886, _net_887, SI);
not inst1076  (_net_888, D1);
not inst1077  (_net_889, D0);
not inst1078  (_net_890, D3);
not inst1079  (_net_891, D4);
not inst1080  (_net_892, D5);
not inst1081  (_net_893, D6);
not inst1082  (_net_894, D7);
not inst1083  (_net_895, SE);
not inst1084  (_net_896, SI);
and inst1085  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_888, _net_889, D2, _net_890, _net_891, _net_892, _net_893, _net_894, _net_895, _net_896);
not inst1086  (_net_897, D1);
not inst1087  (_net_898, D0);
not inst1088  (_net_899, D3);
not inst1089  (_net_900, D4);
not inst1090  (_net_901, D5);
not inst1091  (_net_902, D6);
not inst1092  (_net_903, D7);
not inst1093  (_net_904, SE);
and inst1094  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_897, _net_898, D2, _net_899, _net_900, _net_901, _net_902, _net_903, _net_904, SI);
not inst1095  (_net_905, D0);
not inst1096  (_net_906, D2);
not inst1097  (_net_907, D3);
not inst1098  (_net_908, D4);
not inst1099  (_net_909, D5);
not inst1100  (_net_910, D6);
not inst1101  (_net_911, D7);
not inst1102  (_net_912, SE);
not inst1103  (_net_913, SI);
and inst1104  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, D1, _net_905, _net_906, _net_907, _net_908, _net_909, _net_910, _net_911, _net_912, _net_913);
not inst1105  (_net_914, D0);
not inst1106  (_net_915, D2);
not inst1107  (_net_916, D3);
not inst1108  (_net_917, D4);
not inst1109  (_net_918, D5);
not inst1110  (_net_919, D6);
not inst1111  (_net_920, D7);
not inst1112  (_net_921, SE);
and inst1113  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, D1, _net_914, _net_915, _net_916, _net_917, _net_918, _net_919, _net_920, _net_921, SI);
not inst1114  (_net_922, D1);
not inst1115  (_net_923, D2);
not inst1116  (_net_924, D3);
not inst1117  (_net_925, D4);
not inst1118  (_net_926, D5);
not inst1119  (_net_927, D6);
not inst1120  (_net_928, D7);
not inst1121  (_net_929, SE);
not inst1122  (_net_930, SI);
and inst1123  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_922, D0, _net_923, _net_924, _net_925, _net_926, _net_927, _net_928, _net_929, _net_930);
not inst1124  (_net_931, D1);
not inst1125  (_net_932, D2);
not inst1126  (_net_933, D3);
not inst1127  (_net_934, D4);
not inst1128  (_net_935, D5);
not inst1129  (_net_936, D6);
not inst1130  (_net_937, D7);
not inst1131  (_net_938, SE);
and inst1132  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_931, D0, _net_932, _net_933, _net_934, _net_935, _net_936, _net_937, _net_938, SI);
not inst1133  (_net_939, D1);
not inst1134  (_net_940, D0);
not inst1135  (_net_941, D2);
not inst1136  (_net_942, D3);
not inst1137  (_net_943, D4);
not inst1138  (_net_944, D5);
not inst1139  (_net_945, D6);
not inst1140  (_net_946, D7);
not inst1141  (_net_947, RD);
and inst1142  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SI, _net_939, _net_940, _net_941, _net_942, _net_943, _net_944, _net_945, _net_946, _net_947, SI);
not inst1143  (_net_948, D1);
not inst1144  (_net_949, D0);
not inst1145  (_net_950, D2);
not inst1146  (_net_951, D3);
not inst1147  (_net_952, D4);
not inst1148  (_net_953, D5);
not inst1149  (_net_954, D6);
not inst1150  (_net_955, D7);
and inst1151  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI, _net_948, _net_949, _net_950, _net_951, _net_952, _net_953, _net_954, _net_955, RD, SI);
not inst1152  (_net_956, D1);
not inst1153  (_net_957, D0);
not inst1154  (_net_958, D2);
not inst1155  (_net_959, D3);
not inst1156  (_net_960, D4);
not inst1157  (_net_961, D5);
not inst1158  (_net_962, D6);
not inst1159  (_net_963, SI);
and inst1160  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI, _net_956, _net_957, _net_958, _net_959, _net_960, _net_961, _net_962, D7, RD, _net_963);
not inst1161  (_net_964, D1);
not inst1162  (_net_965, D0);
not inst1163  (_net_966, D2);
not inst1164  (_net_967, D3);
not inst1165  (_net_968, D4);
not inst1166  (_net_969, D5);
not inst1167  (_net_970, D7);
not inst1168  (_net_971, SI);
and inst1169  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_964, _net_965, _net_966, _net_967, _net_968, _net_969, D6, _net_970, RD, _net_971);
not inst1170  (_net_972, D1);
not inst1171  (_net_973, D0);
not inst1172  (_net_974, D2);
not inst1173  (_net_975, D3);
not inst1174  (_net_976, D4);
not inst1175  (_net_977, D6);
not inst1176  (_net_978, D7);
not inst1177  (_net_979, SI);
and inst1178  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_972, _net_973, _net_974, _net_975, _net_976, D5, _net_977, _net_978, RD, _net_979);
not inst1179  (_net_980, D1);
not inst1180  (_net_981, D0);
not inst1181  (_net_982, D2);
not inst1182  (_net_983, D3);
not inst1183  (_net_984, D5);
not inst1184  (_net_985, D6);
not inst1185  (_net_986, D7);
not inst1186  (_net_987, SI);
and inst1187  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_980, _net_981, _net_982, _net_983, D4, _net_984, _net_985, _net_986, RD, _net_987);
not inst1188  (_net_988, D1);
not inst1189  (_net_989, D0);
not inst1190  (_net_990, D2);
not inst1191  (_net_991, D4);
not inst1192  (_net_992, D5);
not inst1193  (_net_993, D6);
not inst1194  (_net_994, D7);
not inst1195  (_net_995, SI);
and inst1196  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_988, _net_989, _net_990, D3, _net_991, _net_992, _net_993, _net_994, RD, _net_995);
not inst1197  (_net_996, D1);
not inst1198  (_net_997, D0);
not inst1199  (_net_998, D3);
not inst1200  (_net_999, D4);
not inst1201  (_net_1000, D5);
not inst1202  (_net_1001, D6);
not inst1203  (_net_1002, D7);
not inst1204  (_net_1003, SI);
and inst1205  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_996, _net_997, D2, _net_998, _net_999, _net_1000, _net_1001, _net_1002, RD, _net_1003);
not inst1206  (_net_1004, D0);
not inst1207  (_net_1005, D2);
not inst1208  (_net_1006, D3);
not inst1209  (_net_1007, D4);
not inst1210  (_net_1008, D5);
not inst1211  (_net_1009, D6);
not inst1212  (_net_1010, D7);
not inst1213  (_net_1011, SI);
and inst1214  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, D1, _net_1004, _net_1005, _net_1006, _net_1007, _net_1008, _net_1009, _net_1010, RD, _net_1011);
not inst1215  (_net_1012, D1);
not inst1216  (_net_1013, D2);
not inst1217  (_net_1014, D3);
not inst1218  (_net_1015, D4);
not inst1219  (_net_1016, D5);
not inst1220  (_net_1017, D6);
not inst1221  (_net_1018, D7);
not inst1222  (_net_1019, SI);
and inst1223  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_1012, D0, _net_1013, _net_1014, _net_1015, _net_1016, _net_1017, _net_1018, RD, _net_1019);
not inst1224  (_net_1020, RD);
and inst1225  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, _net_1020, SI);
not inst1226  (_net_1021, RD);
not inst1227  (_net_1022, D0);
and inst1228  (ENABLE_NOT_D0_AND_NOT_RD_AND_SE, _net_1021, _net_1022, SE);
not inst1229  (_net_1023, D0);
and inst1230  (ENABLE_NOT_D0_AND_RD_AND_SE, RD, _net_1023, SE);
not inst1231  (_net_1024, RD);
and inst1232  (ENABLE_D0_AND_NOT_RD_AND_SE, _net_1024, D0, SE);
and inst1233  (ENABLE_D0_AND_RD_AND_SE, RD, D0, SE);
not inst1234  (_net_1025, SE);
not inst1235  (_net_1026, SI);
and inst1236  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_1025, RD, _net_1026);
not inst1237  (_net_1027, SE);
and inst1238  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_1027, RD, SI);

specify
if (D0==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
(posedge CK => (Q4 : 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
(posedge CK => (Q5 : 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
(posedge CK => (Q6 : 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
(posedge CK => (Q7 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK , 0 ,0, viol_0);
$width(negedge CK , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK , posedge RD , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK , negedge RD , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D4 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D4 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D4 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D4 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D5 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D5);
$hold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D5 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 , viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D5 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D5);
$hold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D5 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 , viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D6 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D6 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D6 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D6 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D7 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D7 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D7 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D7 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D7);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPSYNRBQM8SS_V2Y8_1

//%BEGIN HDBSVT11_FSDPSYNRBQM8SS_V2Y8_2
`celldefine
module HDBSVT11_FSDPSYNRBQM8SS_V2Y8_2 (Q0, Q1, Q2, Q3, Q4, Q5, Q6, Q7, CK, D0, D1, D2, D3, D4, D5, D6, D7, SI, SE, RD);
  input CK, D0, D1, D2, D3, D4, D5, D6, D7, SI, SE, RD;
  output Q0, Q1, Q2, Q3, Q4, Q5, Q6, Q7;
  reg viol_0;
  wire int_16, int_17, int_18, int_19, int_20, int_21, int_22, int_23, iq7, iq6, iq5, iq4, iq3, iq2, iq1, iq0, d_int7, d_int6, d_int5, d_int4, d_int3, d_int2, d_int1, d_int0;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D0, D0);
    buf inst2  (delayed_D1, D1);
    buf inst3  (delayed_D2, D2);
    buf inst4  (delayed_D3, D3);
    buf inst5  (delayed_D4, D4);
    buf inst6  (delayed_D5, D5);
    buf inst7  (delayed_D6, D6);
    buf inst8  (delayed_D7, D7);
    buf inst9  (delayed_SI, SI);
    buf inst10  (delayed_SE, SE);
    buf inst11  (delayed_RD, RD);
  `endif


    and inst12  (int_16, delayed_RD, delayed_D0);
    and inst13  (int_17, delayed_RD, delayed_D1);
    and inst14  (int_18, delayed_RD, delayed_D2);
    and inst15  (int_19, delayed_RD, delayed_D3);
    and inst16  (int_20, delayed_RD, delayed_D4);
    and inst17  (int_21, delayed_RD, delayed_D5);
    and inst18  (int_22, delayed_RD, delayed_D6);
    and inst19  (int_23, delayed_RD, delayed_D7);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst20  (xcr_26, delayed_CK, d_int7);

  `endif
    snps_dff inst21  (iq7, viol_0, delayed_CK, d_int7, xcr_26);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst22  (xcr_28, delayed_CK, d_int6);

  `endif
    snps_dff inst23  (iq6, viol_0, delayed_CK, d_int6, xcr_28);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst24  (xcr_30, delayed_CK, d_int5);

  `endif
    snps_dff inst25  (iq5, viol_0, delayed_CK, d_int5, xcr_30);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst26  (xcr_32, delayed_CK, d_int4);

  `endif
    snps_dff inst27  (iq4, viol_0, delayed_CK, d_int4, xcr_32);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst28  (xcr_34, delayed_CK, d_int3);

  `endif
    snps_dff inst29  (iq3, viol_0, delayed_CK, d_int3, xcr_34);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst30  (xcr_36, delayed_CK, d_int2);

  `endif
    snps_dff inst31  (iq2, viol_0, delayed_CK, d_int2, xcr_36);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst32  (xcr_38, delayed_CK, d_int1);

  `endif
    snps_dff inst33  (iq1, viol_0, delayed_CK, d_int1, xcr_38);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst34  (xcr_40, delayed_CK, d_int0);

  `endif
    snps_dff inst35  (iq0, viol_0, delayed_CK, d_int0, xcr_40);
    snps_mux2 inst36  (d_int7, iq6, int_23, delayed_SE);
    snps_mux2 inst37  (d_int6, iq5, int_22, delayed_SE);
    snps_mux2 inst38  (d_int5, iq4, int_21, delayed_SE);
    snps_mux2 inst39  (d_int4, iq3, int_20, delayed_SE);
    snps_mux2 inst40  (d_int3, iq2, int_19, delayed_SE);
    snps_mux2 inst41  (d_int2, iq1, int_18, delayed_SE);
    snps_mux2 inst42  (d_int1, iq0, int_17, delayed_SE);
    snps_mux2 inst43  (d_int0, delayed_SI, int_16, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_COMBO_DELAY  inst44 (Q7, iq7);
    buf #`SNPS_COMBO_DELAY  inst45 (Q6, iq6);
    buf #`SNPS_COMBO_DELAY  inst46 (Q5, iq5);
    buf #`SNPS_COMBO_DELAY  inst47 (Q4, iq4);
    buf #`SNPS_COMBO_DELAY  inst48 (Q3, iq3);
    buf #`SNPS_COMBO_DELAY  inst49 (Q2, iq2);
    buf #`SNPS_COMBO_DELAY  inst50 (Q1, iq1);
    buf #`SNPS_COMBO_DELAY  inst51 (Q0, iq0);
  `else
    buf inst52  (Q7, iq7);
    buf inst53  (Q6, iq6);
    buf inst54  (Q5, iq5);
    buf inst55  (Q4, iq4);
    buf inst56  (Q3, iq3);
    buf inst57  (Q2, iq2);
    buf inst58  (Q1, iq1);
    buf inst59  (Q0, iq0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst60  (_net_0, D1);
not inst61  (_net_1, D0);
not inst62  (_net_2, D2);
not inst63  (_net_3, D3);
not inst64  (_net_4, D4);
not inst65  (_net_5, D5);
not inst66  (_net_6, D6);
not inst67  (_net_7, D7);
not inst68  (_net_8, RD);
not inst69  (_net_9, SE);
not inst70  (_net_10, SI);
and inst71  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3, _net_4, _net_5, _net_6, _net_7, _net_8, _net_9, _net_10);
not inst72  (_net_11, D1);
not inst73  (_net_12, D0);
not inst74  (_net_13, D2);
not inst75  (_net_14, D3);
not inst76  (_net_15, D4);
not inst77  (_net_16, D5);
not inst78  (_net_17, D6);
not inst79  (_net_18, D7);
not inst80  (_net_19, RD);
not inst81  (_net_20, SE);
and inst82  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_11, _net_12, _net_13, _net_14, _net_15, _net_16, _net_17, _net_18, _net_19, _net_20, SI);
not inst83  (_net_21, D1);
not inst84  (_net_22, D0);
not inst85  (_net_23, D2);
not inst86  (_net_24, D3);
not inst87  (_net_25, D4);
not inst88  (_net_26, D5);
not inst89  (_net_27, D6);
not inst90  (_net_28, D7);
not inst91  (_net_29, RD);
not inst92  (_net_30, SI);
and inst93  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_21, _net_22, _net_23, _net_24, _net_25, _net_26, _net_27, _net_28, _net_29, SE, _net_30);
not inst94  (_net_31, D1);
not inst95  (_net_32, D0);
not inst96  (_net_33, D2);
not inst97  (_net_34, D3);
not inst98  (_net_35, D4);
not inst99  (_net_36, D5);
not inst100  (_net_37, D6);
not inst101  (_net_38, D7);
not inst102  (_net_39, RD);
and inst103  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, _net_31, _net_32, _net_33, _net_34, _net_35, _net_36, _net_37, _net_38, _net_39, SE, SI);
not inst104  (_net_40, D1);
not inst105  (_net_41, D0);
not inst106  (_net_42, D2);
not inst107  (_net_43, D3);
not inst108  (_net_44, D4);
not inst109  (_net_45, D5);
not inst110  (_net_46, D6);
not inst111  (_net_47, D7);
not inst112  (_net_48, SE);
not inst113  (_net_49, SI);
and inst114  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_40, _net_41, _net_42, _net_43, _net_44, _net_45, _net_46, _net_47, RD, _net_48, _net_49);
not inst115  (_net_50, D1);
not inst116  (_net_51, D0);
not inst117  (_net_52, D2);
not inst118  (_net_53, D3);
not inst119  (_net_54, D4);
not inst120  (_net_55, D5);
not inst121  (_net_56, D6);
not inst122  (_net_57, D7);
not inst123  (_net_58, SE);
and inst124  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_50, _net_51, _net_52, _net_53, _net_54, _net_55, _net_56, _net_57, RD, _net_58, SI);
not inst125  (_net_59, D1);
not inst126  (_net_60, D0);
not inst127  (_net_61, D2);
not inst128  (_net_62, D3);
not inst129  (_net_63, D4);
not inst130  (_net_64, D5);
not inst131  (_net_65, D6);
not inst132  (_net_66, D7);
not inst133  (_net_67, SI);
and inst134  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_59, _net_60, _net_61, _net_62, _net_63, _net_64, _net_65, _net_66, RD, SE, _net_67);
not inst135  (_net_68, D1);
not inst136  (_net_69, D0);
not inst137  (_net_70, D2);
not inst138  (_net_71, D3);
not inst139  (_net_72, D4);
not inst140  (_net_73, D5);
not inst141  (_net_74, D6);
not inst142  (_net_75, D7);
and inst143  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_68, _net_69, _net_70, _net_71, _net_72, _net_73, _net_74, _net_75, RD, SE, SI);
not inst144  (_net_76, D1);
not inst145  (_net_77, D0);
not inst146  (_net_78, D2);
not inst147  (_net_79, D3);
not inst148  (_net_80, D4);
not inst149  (_net_81, D5);
not inst150  (_net_82, D6);
not inst151  (_net_83, RD);
not inst152  (_net_84, SE);
not inst153  (_net_85, SI);
and inst154  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_76, _net_77, _net_78, _net_79, _net_80, _net_81, _net_82, D7, _net_83, _net_84, _net_85);
not inst155  (_net_86, D1);
not inst156  (_net_87, D0);
not inst157  (_net_88, D2);
not inst158  (_net_89, D3);
not inst159  (_net_90, D4);
not inst160  (_net_91, D5);
not inst161  (_net_92, D6);
not inst162  (_net_93, RD);
not inst163  (_net_94, SE);
and inst164  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_86, _net_87, _net_88, _net_89, _net_90, _net_91, _net_92, D7, _net_93, _net_94, SI);
not inst165  (_net_95, D1);
not inst166  (_net_96, D0);
not inst167  (_net_97, D2);
not inst168  (_net_98, D3);
not inst169  (_net_99, D4);
not inst170  (_net_100, D5);
not inst171  (_net_101, D6);
not inst172  (_net_102, RD);
not inst173  (_net_103, SI);
and inst174  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_95, _net_96, _net_97, _net_98, _net_99, _net_100, _net_101, D7, _net_102, SE, _net_103);
not inst175  (_net_104, D1);
not inst176  (_net_105, D0);
not inst177  (_net_106, D2);
not inst178  (_net_107, D3);
not inst179  (_net_108, D4);
not inst180  (_net_109, D5);
not inst181  (_net_110, D6);
not inst182  (_net_111, RD);
and inst183  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI, _net_104, _net_105, _net_106, _net_107, _net_108, _net_109, _net_110, D7, _net_111, SE, SI);
not inst184  (_net_112, D1);
not inst185  (_net_113, D0);
not inst186  (_net_114, D2);
not inst187  (_net_115, D3);
not inst188  (_net_116, D4);
not inst189  (_net_117, D5);
not inst190  (_net_118, D6);
not inst191  (_net_119, SE);
not inst192  (_net_120, SI);
and inst193  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_112, _net_113, _net_114, _net_115, _net_116, _net_117, _net_118, D7, RD, _net_119, _net_120);
not inst194  (_net_121, D1);
not inst195  (_net_122, D0);
not inst196  (_net_123, D2);
not inst197  (_net_124, D3);
not inst198  (_net_125, D4);
not inst199  (_net_126, D5);
not inst200  (_net_127, D6);
not inst201  (_net_128, SE);
and inst202  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_121, _net_122, _net_123, _net_124, _net_125, _net_126, _net_127, D7, RD, _net_128, SI);
not inst203  (_net_129, D1);
not inst204  (_net_130, D0);
not inst205  (_net_131, D2);
not inst206  (_net_132, D3);
not inst207  (_net_133, D4);
not inst208  (_net_134, D5);
not inst209  (_net_135, D6);
not inst210  (_net_136, SI);
and inst211  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_129, _net_130, _net_131, _net_132, _net_133, _net_134, _net_135, D7, RD, SE, _net_136);
not inst212  (_net_137, D1);
not inst213  (_net_138, D0);
not inst214  (_net_139, D2);
not inst215  (_net_140, D3);
not inst216  (_net_141, D4);
not inst217  (_net_142, D5);
not inst218  (_net_143, D6);
and inst219  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_137, _net_138, _net_139, _net_140, _net_141, _net_142, _net_143, D7, RD, SE, SI);
not inst220  (_net_144, D1);
not inst221  (_net_145, D0);
not inst222  (_net_146, D2);
not inst223  (_net_147, D3);
not inst224  (_net_148, D4);
not inst225  (_net_149, D5);
not inst226  (_net_150, D7);
not inst227  (_net_151, RD);
not inst228  (_net_152, SE);
not inst229  (_net_153, SI);
and inst230  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_144, _net_145, _net_146, _net_147, _net_148, _net_149, D6, _net_150, _net_151, _net_152, _net_153);
not inst231  (_net_154, D1);
not inst232  (_net_155, D0);
not inst233  (_net_156, D2);
not inst234  (_net_157, D3);
not inst235  (_net_158, D4);
not inst236  (_net_159, D5);
not inst237  (_net_160, D7);
not inst238  (_net_161, RD);
not inst239  (_net_162, SE);
and inst240  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_154, _net_155, _net_156, _net_157, _net_158, _net_159, D6, _net_160, _net_161, _net_162, SI);
not inst241  (_net_163, D1);
not inst242  (_net_164, D0);
not inst243  (_net_165, D2);
not inst244  (_net_166, D3);
not inst245  (_net_167, D4);
not inst246  (_net_168, D5);
not inst247  (_net_169, D7);
not inst248  (_net_170, RD);
not inst249  (_net_171, SI);
and inst250  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_163, _net_164, _net_165, _net_166, _net_167, _net_168, D6, _net_169, _net_170, SE, _net_171);
not inst251  (_net_172, D1);
not inst252  (_net_173, D0);
not inst253  (_net_174, D2);
not inst254  (_net_175, D3);
not inst255  (_net_176, D4);
not inst256  (_net_177, D5);
not inst257  (_net_178, D7);
not inst258  (_net_179, RD);
and inst259  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, _net_172, _net_173, _net_174, _net_175, _net_176, _net_177, D6, _net_178, _net_179, SE, SI);
not inst260  (_net_180, D1);
not inst261  (_net_181, D0);
not inst262  (_net_182, D2);
not inst263  (_net_183, D3);
not inst264  (_net_184, D4);
not inst265  (_net_185, D5);
not inst266  (_net_186, D7);
not inst267  (_net_187, SE);
not inst268  (_net_188, SI);
and inst269  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_180, _net_181, _net_182, _net_183, _net_184, _net_185, D6, _net_186, RD, _net_187, _net_188);
not inst270  (_net_189, D1);
not inst271  (_net_190, D0);
not inst272  (_net_191, D2);
not inst273  (_net_192, D3);
not inst274  (_net_193, D4);
not inst275  (_net_194, D5);
not inst276  (_net_195, D7);
not inst277  (_net_196, SE);
and inst278  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_189, _net_190, _net_191, _net_192, _net_193, _net_194, D6, _net_195, RD, _net_196, SI);
not inst279  (_net_197, D1);
not inst280  (_net_198, D0);
not inst281  (_net_199, D2);
not inst282  (_net_200, D3);
not inst283  (_net_201, D4);
not inst284  (_net_202, D5);
not inst285  (_net_203, D7);
not inst286  (_net_204, SI);
and inst287  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_197, _net_198, _net_199, _net_200, _net_201, _net_202, D6, _net_203, RD, SE, _net_204);
not inst288  (_net_205, D1);
not inst289  (_net_206, D0);
not inst290  (_net_207, D2);
not inst291  (_net_208, D3);
not inst292  (_net_209, D4);
not inst293  (_net_210, D5);
not inst294  (_net_211, D7);
and inst295  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_205, _net_206, _net_207, _net_208, _net_209, _net_210, D6, _net_211, RD, SE, SI);
not inst296  (_net_212, D1);
not inst297  (_net_213, D0);
not inst298  (_net_214, D2);
not inst299  (_net_215, D3);
not inst300  (_net_216, D4);
not inst301  (_net_217, D6);
not inst302  (_net_218, D7);
not inst303  (_net_219, RD);
not inst304  (_net_220, SE);
not inst305  (_net_221, SI);
and inst306  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_212, _net_213, _net_214, _net_215, _net_216, D5, _net_217, _net_218, _net_219, _net_220, _net_221);
not inst307  (_net_222, D1);
not inst308  (_net_223, D0);
not inst309  (_net_224, D2);
not inst310  (_net_225, D3);
not inst311  (_net_226, D4);
not inst312  (_net_227, D6);
not inst313  (_net_228, D7);
not inst314  (_net_229, RD);
not inst315  (_net_230, SE);
and inst316  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_222, _net_223, _net_224, _net_225, _net_226, D5, _net_227, _net_228, _net_229, _net_230, SI);
not inst317  (_net_231, D1);
not inst318  (_net_232, D0);
not inst319  (_net_233, D2);
not inst320  (_net_234, D3);
not inst321  (_net_235, D4);
not inst322  (_net_236, D6);
not inst323  (_net_237, D7);
not inst324  (_net_238, RD);
not inst325  (_net_239, SI);
and inst326  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_231, _net_232, _net_233, _net_234, _net_235, D5, _net_236, _net_237, _net_238, SE, _net_239);
not inst327  (_net_240, D1);
not inst328  (_net_241, D0);
not inst329  (_net_242, D2);
not inst330  (_net_243, D3);
not inst331  (_net_244, D4);
not inst332  (_net_245, D6);
not inst333  (_net_246, D7);
not inst334  (_net_247, RD);
and inst335  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, _net_240, _net_241, _net_242, _net_243, _net_244, D5, _net_245, _net_246, _net_247, SE, SI);
not inst336  (_net_248, D1);
not inst337  (_net_249, D0);
not inst338  (_net_250, D2);
not inst339  (_net_251, D3);
not inst340  (_net_252, D4);
not inst341  (_net_253, D6);
not inst342  (_net_254, D7);
not inst343  (_net_255, SE);
not inst344  (_net_256, SI);
and inst345  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_248, _net_249, _net_250, _net_251, _net_252, D5, _net_253, _net_254, RD, _net_255, _net_256);
not inst346  (_net_257, D1);
not inst347  (_net_258, D0);
not inst348  (_net_259, D2);
not inst349  (_net_260, D3);
not inst350  (_net_261, D4);
not inst351  (_net_262, D6);
not inst352  (_net_263, D7);
not inst353  (_net_264, SE);
and inst354  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_257, _net_258, _net_259, _net_260, _net_261, D5, _net_262, _net_263, RD, _net_264, SI);
not inst355  (_net_265, D1);
not inst356  (_net_266, D0);
not inst357  (_net_267, D2);
not inst358  (_net_268, D3);
not inst359  (_net_269, D4);
not inst360  (_net_270, D6);
not inst361  (_net_271, D7);
not inst362  (_net_272, SI);
and inst363  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_265, _net_266, _net_267, _net_268, _net_269, D5, _net_270, _net_271, RD, SE, _net_272);
not inst364  (_net_273, D1);
not inst365  (_net_274, D0);
not inst366  (_net_275, D2);
not inst367  (_net_276, D3);
not inst368  (_net_277, D4);
not inst369  (_net_278, D6);
not inst370  (_net_279, D7);
and inst371  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_273, _net_274, _net_275, _net_276, _net_277, D5, _net_278, _net_279, RD, SE, SI);
not inst372  (_net_280, D1);
not inst373  (_net_281, D0);
not inst374  (_net_282, D2);
not inst375  (_net_283, D3);
not inst376  (_net_284, D5);
not inst377  (_net_285, D6);
not inst378  (_net_286, D7);
not inst379  (_net_287, RD);
not inst380  (_net_288, SE);
not inst381  (_net_289, SI);
and inst382  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_280, _net_281, _net_282, _net_283, D4, _net_284, _net_285, _net_286, _net_287, _net_288, _net_289);
not inst383  (_net_290, D1);
not inst384  (_net_291, D0);
not inst385  (_net_292, D2);
not inst386  (_net_293, D3);
not inst387  (_net_294, D5);
not inst388  (_net_295, D6);
not inst389  (_net_296, D7);
not inst390  (_net_297, RD);
not inst391  (_net_298, SE);
and inst392  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_290, _net_291, _net_292, _net_293, D4, _net_294, _net_295, _net_296, _net_297, _net_298, SI);
not inst393  (_net_299, D1);
not inst394  (_net_300, D0);
not inst395  (_net_301, D2);
not inst396  (_net_302, D3);
not inst397  (_net_303, D5);
not inst398  (_net_304, D6);
not inst399  (_net_305, D7);
not inst400  (_net_306, RD);
not inst401  (_net_307, SI);
and inst402  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_299, _net_300, _net_301, _net_302, D4, _net_303, _net_304, _net_305, _net_306, SE, _net_307);
not inst403  (_net_308, D1);
not inst404  (_net_309, D0);
not inst405  (_net_310, D2);
not inst406  (_net_311, D3);
not inst407  (_net_312, D5);
not inst408  (_net_313, D6);
not inst409  (_net_314, D7);
not inst410  (_net_315, RD);
and inst411  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, _net_308, _net_309, _net_310, _net_311, D4, _net_312, _net_313, _net_314, _net_315, SE, SI);
not inst412  (_net_316, D1);
not inst413  (_net_317, D0);
not inst414  (_net_318, D2);
not inst415  (_net_319, D3);
not inst416  (_net_320, D5);
not inst417  (_net_321, D6);
not inst418  (_net_322, D7);
not inst419  (_net_323, SE);
not inst420  (_net_324, SI);
and inst421  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_316, _net_317, _net_318, _net_319, D4, _net_320, _net_321, _net_322, RD, _net_323, _net_324);
not inst422  (_net_325, D1);
not inst423  (_net_326, D0);
not inst424  (_net_327, D2);
not inst425  (_net_328, D3);
not inst426  (_net_329, D5);
not inst427  (_net_330, D6);
not inst428  (_net_331, D7);
not inst429  (_net_332, SE);
and inst430  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_325, _net_326, _net_327, _net_328, D4, _net_329, _net_330, _net_331, RD, _net_332, SI);
not inst431  (_net_333, D1);
not inst432  (_net_334, D0);
not inst433  (_net_335, D2);
not inst434  (_net_336, D3);
not inst435  (_net_337, D5);
not inst436  (_net_338, D6);
not inst437  (_net_339, D7);
not inst438  (_net_340, SI);
and inst439  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_333, _net_334, _net_335, _net_336, D4, _net_337, _net_338, _net_339, RD, SE, _net_340);
not inst440  (_net_341, D1);
not inst441  (_net_342, D0);
not inst442  (_net_343, D2);
not inst443  (_net_344, D3);
not inst444  (_net_345, D5);
not inst445  (_net_346, D6);
not inst446  (_net_347, D7);
and inst447  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_341, _net_342, _net_343, _net_344, D4, _net_345, _net_346, _net_347, RD, SE, SI);
not inst448  (_net_348, D1);
not inst449  (_net_349, D0);
not inst450  (_net_350, D2);
not inst451  (_net_351, D3);
not inst452  (_net_352, RD);
not inst453  (_net_353, SE);
not inst454  (_net_354, SI);
and inst455  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_348, _net_349, _net_350, _net_351, D4, D5, D6, D7, _net_352, _net_353, _net_354);
not inst456  (_net_355, D1);
not inst457  (_net_356, D0);
not inst458  (_net_357, D2);
not inst459  (_net_358, D3);
not inst460  (_net_359, RD);
not inst461  (_net_360, SE);
and inst462  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_355, _net_356, _net_357, _net_358, D4, D5, D6, D7, _net_359, _net_360, SI);
not inst463  (_net_361, D1);
not inst464  (_net_362, D0);
not inst465  (_net_363, D2);
not inst466  (_net_364, D3);
not inst467  (_net_365, RD);
not inst468  (_net_366, SI);
and inst469  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_361, _net_362, _net_363, _net_364, D4, D5, D6, D7, _net_365, SE, _net_366);
not inst470  (_net_367, D1);
not inst471  (_net_368, D0);
not inst472  (_net_369, D2);
not inst473  (_net_370, D3);
not inst474  (_net_371, RD);
and inst475  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI, _net_367, _net_368, _net_369, _net_370, D4, D5, D6, D7, _net_371, SE, SI);
not inst476  (_net_372, D1);
not inst477  (_net_373, D0);
not inst478  (_net_374, D2);
not inst479  (_net_375, D3);
not inst480  (_net_376, SE);
not inst481  (_net_377, SI);
and inst482  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_372, _net_373, _net_374, _net_375, D4, D5, D6, D7, RD, _net_376, _net_377);
not inst483  (_net_378, D1);
not inst484  (_net_379, D0);
not inst485  (_net_380, D2);
not inst486  (_net_381, D3);
not inst487  (_net_382, SE);
and inst488  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_378, _net_379, _net_380, _net_381, D4, D5, D6, D7, RD, _net_382, SI);
not inst489  (_net_383, D1);
not inst490  (_net_384, D0);
not inst491  (_net_385, D2);
not inst492  (_net_386, D3);
not inst493  (_net_387, SI);
and inst494  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_383, _net_384, _net_385, _net_386, D4, D5, D6, D7, RD, SE, _net_387);
not inst495  (_net_388, D1);
not inst496  (_net_389, D0);
not inst497  (_net_390, D2);
not inst498  (_net_391, D3);
and inst499  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_388, _net_389, _net_390, _net_391, D4, D5, D6, D7, RD, SE, SI);
not inst500  (_net_392, D1);
not inst501  (_net_393, D0);
not inst502  (_net_394, D2);
not inst503  (_net_395, D4);
not inst504  (_net_396, D5);
not inst505  (_net_397, D6);
not inst506  (_net_398, D7);
not inst507  (_net_399, RD);
not inst508  (_net_400, SE);
not inst509  (_net_401, SI);
and inst510  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_392, _net_393, _net_394, D3, _net_395, _net_396, _net_397, _net_398, _net_399, _net_400, _net_401);
not inst511  (_net_402, D1);
not inst512  (_net_403, D0);
not inst513  (_net_404, D2);
not inst514  (_net_405, D4);
not inst515  (_net_406, D5);
not inst516  (_net_407, D6);
not inst517  (_net_408, D7);
not inst518  (_net_409, RD);
not inst519  (_net_410, SE);
and inst520  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_402, _net_403, _net_404, D3, _net_405, _net_406, _net_407, _net_408, _net_409, _net_410, SI);
not inst521  (_net_411, D1);
not inst522  (_net_412, D0);
not inst523  (_net_413, D2);
not inst524  (_net_414, D4);
not inst525  (_net_415, D5);
not inst526  (_net_416, D6);
not inst527  (_net_417, D7);
not inst528  (_net_418, RD);
not inst529  (_net_419, SI);
and inst530  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_411, _net_412, _net_413, D3, _net_414, _net_415, _net_416, _net_417, _net_418, SE, _net_419);
not inst531  (_net_420, D1);
not inst532  (_net_421, D0);
not inst533  (_net_422, D2);
not inst534  (_net_423, D4);
not inst535  (_net_424, D5);
not inst536  (_net_425, D6);
not inst537  (_net_426, D7);
not inst538  (_net_427, RD);
and inst539  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, _net_420, _net_421, _net_422, D3, _net_423, _net_424, _net_425, _net_426, _net_427, SE, SI);
not inst540  (_net_428, D1);
not inst541  (_net_429, D0);
not inst542  (_net_430, D2);
not inst543  (_net_431, D4);
not inst544  (_net_432, D5);
not inst545  (_net_433, D6);
not inst546  (_net_434, D7);
not inst547  (_net_435, SE);
not inst548  (_net_436, SI);
and inst549  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_428, _net_429, _net_430, D3, _net_431, _net_432, _net_433, _net_434, RD, _net_435, _net_436);
not inst550  (_net_437, D1);
not inst551  (_net_438, D0);
not inst552  (_net_439, D2);
not inst553  (_net_440, D4);
not inst554  (_net_441, D5);
not inst555  (_net_442, D6);
not inst556  (_net_443, D7);
not inst557  (_net_444, SE);
and inst558  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_437, _net_438, _net_439, D3, _net_440, _net_441, _net_442, _net_443, RD, _net_444, SI);
not inst559  (_net_445, D1);
not inst560  (_net_446, D0);
not inst561  (_net_447, D2);
not inst562  (_net_448, D4);
not inst563  (_net_449, D5);
not inst564  (_net_450, D6);
not inst565  (_net_451, D7);
not inst566  (_net_452, SI);
and inst567  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_445, _net_446, _net_447, D3, _net_448, _net_449, _net_450, _net_451, RD, SE, _net_452);
not inst568  (_net_453, D1);
not inst569  (_net_454, D0);
not inst570  (_net_455, D2);
not inst571  (_net_456, D4);
not inst572  (_net_457, D5);
not inst573  (_net_458, D6);
not inst574  (_net_459, D7);
and inst575  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_453, _net_454, _net_455, D3, _net_456, _net_457, _net_458, _net_459, RD, SE, SI);
not inst576  (_net_460, D1);
not inst577  (_net_461, D0);
not inst578  (_net_462, D3);
not inst579  (_net_463, D4);
not inst580  (_net_464, D5);
not inst581  (_net_465, D6);
not inst582  (_net_466, D7);
not inst583  (_net_467, RD);
not inst584  (_net_468, SE);
not inst585  (_net_469, SI);
and inst586  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_460, _net_461, D2, _net_462, _net_463, _net_464, _net_465, _net_466, _net_467, _net_468, _net_469);
not inst587  (_net_470, D1);
not inst588  (_net_471, D0);
not inst589  (_net_472, D3);
not inst590  (_net_473, D4);
not inst591  (_net_474, D5);
not inst592  (_net_475, D6);
not inst593  (_net_476, D7);
not inst594  (_net_477, RD);
not inst595  (_net_478, SE);
and inst596  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_470, _net_471, D2, _net_472, _net_473, _net_474, _net_475, _net_476, _net_477, _net_478, SI);
not inst597  (_net_479, D1);
not inst598  (_net_480, D0);
not inst599  (_net_481, D3);
not inst600  (_net_482, D4);
not inst601  (_net_483, D5);
not inst602  (_net_484, D6);
not inst603  (_net_485, D7);
not inst604  (_net_486, RD);
not inst605  (_net_487, SI);
and inst606  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_479, _net_480, D2, _net_481, _net_482, _net_483, _net_484, _net_485, _net_486, SE, _net_487);
not inst607  (_net_488, D1);
not inst608  (_net_489, D0);
not inst609  (_net_490, D3);
not inst610  (_net_491, D4);
not inst611  (_net_492, D5);
not inst612  (_net_493, D6);
not inst613  (_net_494, D7);
not inst614  (_net_495, RD);
and inst615  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, _net_488, _net_489, D2, _net_490, _net_491, _net_492, _net_493, _net_494, _net_495, SE, SI);
not inst616  (_net_496, D1);
not inst617  (_net_497, D0);
not inst618  (_net_498, D3);
not inst619  (_net_499, D4);
not inst620  (_net_500, D5);
not inst621  (_net_501, D6);
not inst622  (_net_502, D7);
not inst623  (_net_503, SE);
not inst624  (_net_504, SI);
and inst625  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_496, _net_497, D2, _net_498, _net_499, _net_500, _net_501, _net_502, RD, _net_503, _net_504);
not inst626  (_net_505, D1);
not inst627  (_net_506, D0);
not inst628  (_net_507, D3);
not inst629  (_net_508, D4);
not inst630  (_net_509, D5);
not inst631  (_net_510, D6);
not inst632  (_net_511, D7);
not inst633  (_net_512, SE);
and inst634  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_505, _net_506, D2, _net_507, _net_508, _net_509, _net_510, _net_511, RD, _net_512, SI);
not inst635  (_net_513, D1);
not inst636  (_net_514, D0);
not inst637  (_net_515, D3);
not inst638  (_net_516, D4);
not inst639  (_net_517, D5);
not inst640  (_net_518, D6);
not inst641  (_net_519, D7);
not inst642  (_net_520, SI);
and inst643  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_513, _net_514, D2, _net_515, _net_516, _net_517, _net_518, _net_519, RD, SE, _net_520);
not inst644  (_net_521, D1);
not inst645  (_net_522, D0);
not inst646  (_net_523, D3);
not inst647  (_net_524, D4);
not inst648  (_net_525, D5);
not inst649  (_net_526, D6);
not inst650  (_net_527, D7);
and inst651  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_521, _net_522, D2, _net_523, _net_524, _net_525, _net_526, _net_527, RD, SE, SI);
not inst652  (_net_528, D0);
not inst653  (_net_529, D2);
not inst654  (_net_530, D3);
not inst655  (_net_531, D4);
not inst656  (_net_532, D5);
not inst657  (_net_533, D6);
not inst658  (_net_534, D7);
not inst659  (_net_535, RD);
not inst660  (_net_536, SE);
not inst661  (_net_537, SI);
and inst662  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_528, _net_529, _net_530, _net_531, _net_532, _net_533, _net_534, _net_535, _net_536, _net_537);
not inst663  (_net_538, D0);
not inst664  (_net_539, D2);
not inst665  (_net_540, D3);
not inst666  (_net_541, D4);
not inst667  (_net_542, D5);
not inst668  (_net_543, D6);
not inst669  (_net_544, D7);
not inst670  (_net_545, RD);
not inst671  (_net_546, SE);
and inst672  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, D1, _net_538, _net_539, _net_540, _net_541, _net_542, _net_543, _net_544, _net_545, _net_546, SI);
not inst673  (_net_547, D0);
not inst674  (_net_548, D2);
not inst675  (_net_549, D3);
not inst676  (_net_550, D4);
not inst677  (_net_551, D5);
not inst678  (_net_552, D6);
not inst679  (_net_553, D7);
not inst680  (_net_554, RD);
not inst681  (_net_555, SI);
and inst682  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, D1, _net_547, _net_548, _net_549, _net_550, _net_551, _net_552, _net_553, _net_554, SE, _net_555);
not inst683  (_net_556, D0);
not inst684  (_net_557, D2);
not inst685  (_net_558, D3);
not inst686  (_net_559, D4);
not inst687  (_net_560, D5);
not inst688  (_net_561, D6);
not inst689  (_net_562, D7);
not inst690  (_net_563, RD);
and inst691  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, D1, _net_556, _net_557, _net_558, _net_559, _net_560, _net_561, _net_562, _net_563, SE, SI);
not inst692  (_net_564, D0);
not inst693  (_net_565, D2);
not inst694  (_net_566, D3);
not inst695  (_net_567, D4);
not inst696  (_net_568, D5);
not inst697  (_net_569, D6);
not inst698  (_net_570, D7);
not inst699  (_net_571, SE);
not inst700  (_net_572, SI);
and inst701  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, _net_564, _net_565, _net_566, _net_567, _net_568, _net_569, _net_570, RD, _net_571, _net_572);
not inst702  (_net_573, D0);
not inst703  (_net_574, D2);
not inst704  (_net_575, D3);
not inst705  (_net_576, D4);
not inst706  (_net_577, D5);
not inst707  (_net_578, D6);
not inst708  (_net_579, D7);
not inst709  (_net_580, SE);
and inst710  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, D1, _net_573, _net_574, _net_575, _net_576, _net_577, _net_578, _net_579, RD, _net_580, SI);
not inst711  (_net_581, D0);
not inst712  (_net_582, D2);
not inst713  (_net_583, D3);
not inst714  (_net_584, D4);
not inst715  (_net_585, D5);
not inst716  (_net_586, D6);
not inst717  (_net_587, D7);
not inst718  (_net_588, SI);
and inst719  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, D1, _net_581, _net_582, _net_583, _net_584, _net_585, _net_586, _net_587, RD, SE, _net_588);
not inst720  (_net_589, D0);
not inst721  (_net_590, D2);
not inst722  (_net_591, D3);
not inst723  (_net_592, D4);
not inst724  (_net_593, D5);
not inst725  (_net_594, D6);
not inst726  (_net_595, D7);
and inst727  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, D1, _net_589, _net_590, _net_591, _net_592, _net_593, _net_594, _net_595, RD, SE, SI);
not inst728  (_net_596, D1);
not inst729  (_net_597, D2);
not inst730  (_net_598, D3);
not inst731  (_net_599, D4);
not inst732  (_net_600, D5);
not inst733  (_net_601, D6);
not inst734  (_net_602, D7);
not inst735  (_net_603, RD);
not inst736  (_net_604, SE);
not inst737  (_net_605, SI);
and inst738  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_596, D0, _net_597, _net_598, _net_599, _net_600, _net_601, _net_602, _net_603, _net_604, _net_605);
not inst739  (_net_606, D1);
not inst740  (_net_607, D2);
not inst741  (_net_608, D3);
not inst742  (_net_609, D4);
not inst743  (_net_610, D5);
not inst744  (_net_611, D6);
not inst745  (_net_612, D7);
not inst746  (_net_613, RD);
not inst747  (_net_614, SE);
and inst748  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_606, D0, _net_607, _net_608, _net_609, _net_610, _net_611, _net_612, _net_613, _net_614, SI);
not inst749  (_net_615, D1);
not inst750  (_net_616, D2);
not inst751  (_net_617, D3);
not inst752  (_net_618, D4);
not inst753  (_net_619, D5);
not inst754  (_net_620, D6);
not inst755  (_net_621, D7);
not inst756  (_net_622, RD);
not inst757  (_net_623, SI);
and inst758  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_615, D0, _net_616, _net_617, _net_618, _net_619, _net_620, _net_621, _net_622, SE, _net_623);
not inst759  (_net_624, D1);
not inst760  (_net_625, D2);
not inst761  (_net_626, D3);
not inst762  (_net_627, D4);
not inst763  (_net_628, D5);
not inst764  (_net_629, D6);
not inst765  (_net_630, D7);
not inst766  (_net_631, RD);
and inst767  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, _net_624, D0, _net_625, _net_626, _net_627, _net_628, _net_629, _net_630, _net_631, SE, SI);
not inst768  (_net_632, D1);
not inst769  (_net_633, D2);
not inst770  (_net_634, D3);
not inst771  (_net_635, D4);
not inst772  (_net_636, D5);
not inst773  (_net_637, D6);
not inst774  (_net_638, D7);
not inst775  (_net_639, SE);
not inst776  (_net_640, SI);
and inst777  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_632, D0, _net_633, _net_634, _net_635, _net_636, _net_637, _net_638, RD, _net_639, _net_640);
not inst778  (_net_641, D1);
not inst779  (_net_642, D2);
not inst780  (_net_643, D3);
not inst781  (_net_644, D4);
not inst782  (_net_645, D5);
not inst783  (_net_646, D6);
not inst784  (_net_647, D7);
not inst785  (_net_648, SE);
and inst786  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_641, D0, _net_642, _net_643, _net_644, _net_645, _net_646, _net_647, RD, _net_648, SI);
not inst787  (_net_649, D1);
not inst788  (_net_650, D2);
not inst789  (_net_651, D3);
not inst790  (_net_652, D4);
not inst791  (_net_653, D5);
not inst792  (_net_654, D6);
not inst793  (_net_655, D7);
not inst794  (_net_656, SI);
and inst795  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_649, D0, _net_650, _net_651, _net_652, _net_653, _net_654, _net_655, RD, SE, _net_656);
not inst796  (_net_657, D1);
not inst797  (_net_658, D2);
not inst798  (_net_659, D3);
not inst799  (_net_660, D4);
not inst800  (_net_661, D5);
not inst801  (_net_662, D6);
not inst802  (_net_663, D7);
and inst803  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_657, D0, _net_658, _net_659, _net_660, _net_661, _net_662, _net_663, RD, SE, SI);
not inst804  (_net_664, D1);
not inst805  (_net_665, D2);
not inst806  (_net_666, D3);
not inst807  (_net_667, RD);
not inst808  (_net_668, SE);
not inst809  (_net_669, SI);
and inst810  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_664, D0, _net_665, _net_666, D4, D5, D6, D7, _net_667, _net_668, _net_669);
not inst811  (_net_670, D1);
not inst812  (_net_671, D2);
not inst813  (_net_672, D3);
not inst814  (_net_673, RD);
not inst815  (_net_674, SE);
and inst816  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_670, D0, _net_671, _net_672, D4, D5, D6, D7, _net_673, _net_674, SI);
not inst817  (_net_675, D1);
not inst818  (_net_676, D2);
not inst819  (_net_677, D3);
not inst820  (_net_678, RD);
not inst821  (_net_679, SI);
and inst822  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_675, D0, _net_676, _net_677, D4, D5, D6, D7, _net_678, SE, _net_679);
not inst823  (_net_680, D1);
not inst824  (_net_681, D2);
not inst825  (_net_682, D3);
not inst826  (_net_683, RD);
and inst827  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI, _net_680, D0, _net_681, _net_682, D4, D5, D6, D7, _net_683, SE, SI);
not inst828  (_net_684, D1);
not inst829  (_net_685, D2);
not inst830  (_net_686, D3);
not inst831  (_net_687, SE);
not inst832  (_net_688, SI);
and inst833  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_684, D0, _net_685, _net_686, D4, D5, D6, D7, RD, _net_687, _net_688);
not inst834  (_net_689, D1);
not inst835  (_net_690, D2);
not inst836  (_net_691, D3);
not inst837  (_net_692, SE);
and inst838  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_689, D0, _net_690, _net_691, D4, D5, D6, D7, RD, _net_692, SI);
not inst839  (_net_693, D1);
not inst840  (_net_694, D2);
not inst841  (_net_695, D3);
not inst842  (_net_696, SI);
and inst843  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_693, D0, _net_694, _net_695, D4, D5, D6, D7, RD, SE, _net_696);
not inst844  (_net_697, D1);
not inst845  (_net_698, D2);
not inst846  (_net_699, D3);
and inst847  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_697, D0, _net_698, _net_699, D4, D5, D6, D7, RD, SE, SI);
not inst848  (_net_700, D1);
not inst849  (_net_701, D3);
not inst850  (_net_702, D5);
not inst851  (_net_703, D7);
not inst852  (_net_704, RD);
not inst853  (_net_705, SE);
not inst854  (_net_706, SI);
and inst855  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_700, D0, D2, _net_701, D4, _net_702, D6, _net_703, _net_704, _net_705, _net_706);
not inst856  (_net_707, D1);
not inst857  (_net_708, D3);
not inst858  (_net_709, D5);
not inst859  (_net_710, D7);
not inst860  (_net_711, RD);
not inst861  (_net_712, SE);
and inst862  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_707, D0, D2, _net_708, D4, _net_709, D6, _net_710, _net_711, _net_712, SI);
not inst863  (_net_713, D1);
not inst864  (_net_714, D3);
not inst865  (_net_715, D5);
not inst866  (_net_716, D7);
not inst867  (_net_717, RD);
not inst868  (_net_718, SI);
and inst869  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_713, D0, D2, _net_714, D4, _net_715, D6, _net_716, _net_717, SE, _net_718);
not inst870  (_net_719, D1);
not inst871  (_net_720, D3);
not inst872  (_net_721, D5);
not inst873  (_net_722, D7);
not inst874  (_net_723, RD);
and inst875  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI, _net_719, D0, D2, _net_720, D4, _net_721, D6, _net_722, _net_723, SE, SI);
not inst876  (_net_724, D1);
not inst877  (_net_725, D3);
not inst878  (_net_726, D5);
not inst879  (_net_727, D7);
not inst880  (_net_728, SE);
not inst881  (_net_729, SI);
and inst882  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_724, D0, D2, _net_725, D4, _net_726, D6, _net_727, RD, _net_728, _net_729);
not inst883  (_net_730, D1);
not inst884  (_net_731, D3);
not inst885  (_net_732, D5);
not inst886  (_net_733, D7);
not inst887  (_net_734, SE);
and inst888  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI, _net_730, D0, D2, _net_731, D4, _net_732, D6, _net_733, RD, _net_734, SI);
not inst889  (_net_735, D1);
not inst890  (_net_736, D3);
not inst891  (_net_737, D5);
not inst892  (_net_738, D7);
not inst893  (_net_739, SI);
and inst894  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI, _net_735, D0, D2, _net_736, D4, _net_737, D6, _net_738, RD, SE, _net_739);
not inst895  (_net_740, D1);
not inst896  (_net_741, D3);
not inst897  (_net_742, D5);
not inst898  (_net_743, D7);
and inst899  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI, _net_740, D0, D2, _net_741, D4, _net_742, D6, _net_743, RD, SE, SI);
not inst900  (_net_744, D1);
not inst901  (_net_745, D3);
not inst902  (_net_746, D5);
not inst903  (_net_747, RD);
not inst904  (_net_748, SE);
not inst905  (_net_749, SI);
and inst906  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_744, D0, D2, _net_745, D4, _net_746, D6, D7, _net_747, _net_748, _net_749);
not inst907  (_net_750, D1);
not inst908  (_net_751, D3);
not inst909  (_net_752, D5);
not inst910  (_net_753, RD);
not inst911  (_net_754, SE);
and inst912  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_750, D0, D2, _net_751, D4, _net_752, D6, D7, _net_753, _net_754, SI);
not inst913  (_net_755, D1);
not inst914  (_net_756, D3);
not inst915  (_net_757, D5);
not inst916  (_net_758, RD);
not inst917  (_net_759, SI);
and inst918  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_755, D0, D2, _net_756, D4, _net_757, D6, D7, _net_758, SE, _net_759);
not inst919  (_net_760, D1);
not inst920  (_net_761, D3);
not inst921  (_net_762, D5);
not inst922  (_net_763, RD);
and inst923  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI, _net_760, D0, D2, _net_761, D4, _net_762, D6, D7, _net_763, SE, SI);
not inst924  (_net_764, D1);
not inst925  (_net_765, D3);
not inst926  (_net_766, D5);
not inst927  (_net_767, SE);
not inst928  (_net_768, SI);
and inst929  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_764, D0, D2, _net_765, D4, _net_766, D6, D7, RD, _net_767, _net_768);
not inst930  (_net_769, D1);
not inst931  (_net_770, D3);
not inst932  (_net_771, D5);
not inst933  (_net_772, SE);
and inst934  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_769, D0, D2, _net_770, D4, _net_771, D6, D7, RD, _net_772, SI);
not inst935  (_net_773, D1);
not inst936  (_net_774, D3);
not inst937  (_net_775, D5);
not inst938  (_net_776, SI);
and inst939  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_773, D0, D2, _net_774, D4, _net_775, D6, D7, RD, SE, _net_776);
not inst940  (_net_777, D1);
not inst941  (_net_778, D3);
not inst942  (_net_779, D5);
and inst943  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_777, D0, D2, _net_778, D4, _net_779, D6, D7, RD, SE, SI);
not inst944  (_net_780, D1);
not inst945  (_net_781, D3);
not inst946  (_net_782, RD);
not inst947  (_net_783, SE);
not inst948  (_net_784, SI);
and inst949  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_780, D0, D2, _net_781, D4, D5, D6, D7, _net_782, _net_783, _net_784);
not inst950  (_net_785, D1);
not inst951  (_net_786, D3);
not inst952  (_net_787, RD);
not inst953  (_net_788, SE);
and inst954  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_785, D0, D2, _net_786, D4, D5, D6, D7, _net_787, _net_788, SI);
not inst955  (_net_789, D1);
not inst956  (_net_790, D3);
not inst957  (_net_791, RD);
not inst958  (_net_792, SI);
and inst959  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_789, D0, D2, _net_790, D4, D5, D6, D7, _net_791, SE, _net_792);
not inst960  (_net_793, D1);
not inst961  (_net_794, D3);
not inst962  (_net_795, RD);
and inst963  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI, _net_793, D0, D2, _net_794, D4, D5, D6, D7, _net_795, SE, SI);
not inst964  (_net_796, D1);
not inst965  (_net_797, D3);
not inst966  (_net_798, SE);
not inst967  (_net_799, SI);
and inst968  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, _net_796, D0, D2, _net_797, D4, D5, D6, D7, RD, _net_798, _net_799);
not inst969  (_net_800, D1);
not inst970  (_net_801, D3);
not inst971  (_net_802, SE);
and inst972  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, _net_800, D0, D2, _net_801, D4, D5, D6, D7, RD, _net_802, SI);
not inst973  (_net_803, D1);
not inst974  (_net_804, D3);
not inst975  (_net_805, SI);
and inst976  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, _net_803, D0, D2, _net_804, D4, D5, D6, D7, RD, SE, _net_805);
not inst977  (_net_806, D1);
not inst978  (_net_807, D3);
and inst979  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, _net_806, D0, D2, _net_807, D4, D5, D6, D7, RD, SE, SI);
not inst980  (_net_808, RD);
not inst981  (_net_809, SE);
not inst982  (_net_810, SI);
and inst983  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, D4, D5, D6, D7, _net_808, _net_809, _net_810);
not inst984  (_net_811, RD);
not inst985  (_net_812, SE);
and inst986  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, _net_811, _net_812, SI);
not inst987  (_net_813, RD);
not inst988  (_net_814, SI);
and inst989  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI, D1, D0, D2, D3, D4, D5, D6, D7, _net_813, SE, _net_814);
not inst990  (_net_815, RD);
and inst991  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, _net_815, SE, SI);
not inst992  (_net_816, SE);
not inst993  (_net_817, SI);
and inst994  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI, D1, D0, D2, D3, D4, D5, D6, D7, RD, _net_816, _net_817);
not inst995  (_net_818, SE);
and inst996  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, RD, _net_818, SI);
not inst997  (_net_819, SI);
and inst998  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI, D1, D0, D2, D3, D4, D5, D6, D7, RD, SE, _net_819);
and inst999  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, RD, SE, SI);
not inst1000  (_net_820, D1);
not inst1001  (_net_821, D0);
not inst1002  (_net_822, D2);
not inst1003  (_net_823, D3);
not inst1004  (_net_824, D4);
not inst1005  (_net_825, D5);
not inst1006  (_net_826, D7);
not inst1007  (_net_827, SE);
not inst1008  (_net_828, SI);
and inst1009  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_820, _net_821, _net_822, _net_823, _net_824, _net_825, D6, _net_826, _net_827, _net_828);
not inst1010  (_net_829, D1);
not inst1011  (_net_830, D0);
not inst1012  (_net_831, D2);
not inst1013  (_net_832, D3);
not inst1014  (_net_833, D4);
not inst1015  (_net_834, D5);
not inst1016  (_net_835, D7);
not inst1017  (_net_836, SE);
and inst1018  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_829, _net_830, _net_831, _net_832, _net_833, _net_834, D6, _net_835, _net_836, SI);
not inst1019  (_net_837, D1);
not inst1020  (_net_838, D0);
not inst1021  (_net_839, D2);
not inst1022  (_net_840, D3);
not inst1023  (_net_841, D4);
not inst1024  (_net_842, D6);
not inst1025  (_net_843, D7);
not inst1026  (_net_844, SE);
not inst1027  (_net_845, SI);
and inst1028  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_837, _net_838, _net_839, _net_840, _net_841, D5, _net_842, _net_843, _net_844, _net_845);
not inst1029  (_net_846, D1);
not inst1030  (_net_847, D0);
not inst1031  (_net_848, D2);
not inst1032  (_net_849, D3);
not inst1033  (_net_850, D4);
not inst1034  (_net_851, D6);
not inst1035  (_net_852, D7);
not inst1036  (_net_853, SE);
and inst1037  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_846, _net_847, _net_848, _net_849, _net_850, D5, _net_851, _net_852, _net_853, SI);
not inst1038  (_net_854, D1);
not inst1039  (_net_855, D0);
not inst1040  (_net_856, D2);
not inst1041  (_net_857, D3);
not inst1042  (_net_858, D5);
not inst1043  (_net_859, D6);
not inst1044  (_net_860, D7);
not inst1045  (_net_861, SE);
not inst1046  (_net_862, SI);
and inst1047  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_854, _net_855, _net_856, _net_857, D4, _net_858, _net_859, _net_860, _net_861, _net_862);
not inst1048  (_net_863, D1);
not inst1049  (_net_864, D0);
not inst1050  (_net_865, D2);
not inst1051  (_net_866, D3);
not inst1052  (_net_867, D5);
not inst1053  (_net_868, D6);
not inst1054  (_net_869, D7);
not inst1055  (_net_870, SE);
and inst1056  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_863, _net_864, _net_865, _net_866, D4, _net_867, _net_868, _net_869, _net_870, SI);
not inst1057  (_net_871, D1);
not inst1058  (_net_872, D0);
not inst1059  (_net_873, D2);
not inst1060  (_net_874, D4);
not inst1061  (_net_875, D5);
not inst1062  (_net_876, D6);
not inst1063  (_net_877, D7);
not inst1064  (_net_878, SE);
not inst1065  (_net_879, SI);
and inst1066  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_871, _net_872, _net_873, D3, _net_874, _net_875, _net_876, _net_877, _net_878, _net_879);
not inst1067  (_net_880, D1);
not inst1068  (_net_881, D0);
not inst1069  (_net_882, D2);
not inst1070  (_net_883, D4);
not inst1071  (_net_884, D5);
not inst1072  (_net_885, D6);
not inst1073  (_net_886, D7);
not inst1074  (_net_887, SE);
and inst1075  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_880, _net_881, _net_882, D3, _net_883, _net_884, _net_885, _net_886, _net_887, SI);
not inst1076  (_net_888, D1);
not inst1077  (_net_889, D0);
not inst1078  (_net_890, D3);
not inst1079  (_net_891, D4);
not inst1080  (_net_892, D5);
not inst1081  (_net_893, D6);
not inst1082  (_net_894, D7);
not inst1083  (_net_895, SE);
not inst1084  (_net_896, SI);
and inst1085  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_888, _net_889, D2, _net_890, _net_891, _net_892, _net_893, _net_894, _net_895, _net_896);
not inst1086  (_net_897, D1);
not inst1087  (_net_898, D0);
not inst1088  (_net_899, D3);
not inst1089  (_net_900, D4);
not inst1090  (_net_901, D5);
not inst1091  (_net_902, D6);
not inst1092  (_net_903, D7);
not inst1093  (_net_904, SE);
and inst1094  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_897, _net_898, D2, _net_899, _net_900, _net_901, _net_902, _net_903, _net_904, SI);
not inst1095  (_net_905, D0);
not inst1096  (_net_906, D2);
not inst1097  (_net_907, D3);
not inst1098  (_net_908, D4);
not inst1099  (_net_909, D5);
not inst1100  (_net_910, D6);
not inst1101  (_net_911, D7);
not inst1102  (_net_912, SE);
not inst1103  (_net_913, SI);
and inst1104  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, D1, _net_905, _net_906, _net_907, _net_908, _net_909, _net_910, _net_911, _net_912, _net_913);
not inst1105  (_net_914, D0);
not inst1106  (_net_915, D2);
not inst1107  (_net_916, D3);
not inst1108  (_net_917, D4);
not inst1109  (_net_918, D5);
not inst1110  (_net_919, D6);
not inst1111  (_net_920, D7);
not inst1112  (_net_921, SE);
and inst1113  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, D1, _net_914, _net_915, _net_916, _net_917, _net_918, _net_919, _net_920, _net_921, SI);
not inst1114  (_net_922, D1);
not inst1115  (_net_923, D2);
not inst1116  (_net_924, D3);
not inst1117  (_net_925, D4);
not inst1118  (_net_926, D5);
not inst1119  (_net_927, D6);
not inst1120  (_net_928, D7);
not inst1121  (_net_929, SE);
not inst1122  (_net_930, SI);
and inst1123  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI, _net_922, D0, _net_923, _net_924, _net_925, _net_926, _net_927, _net_928, _net_929, _net_930);
not inst1124  (_net_931, D1);
not inst1125  (_net_932, D2);
not inst1126  (_net_933, D3);
not inst1127  (_net_934, D4);
not inst1128  (_net_935, D5);
not inst1129  (_net_936, D6);
not inst1130  (_net_937, D7);
not inst1131  (_net_938, SE);
and inst1132  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI, _net_931, D0, _net_932, _net_933, _net_934, _net_935, _net_936, _net_937, _net_938, SI);
not inst1133  (_net_939, D1);
not inst1134  (_net_940, D0);
not inst1135  (_net_941, D2);
not inst1136  (_net_942, D3);
not inst1137  (_net_943, D4);
not inst1138  (_net_944, D5);
not inst1139  (_net_945, D6);
not inst1140  (_net_946, D7);
not inst1141  (_net_947, RD);
and inst1142  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SI, _net_939, _net_940, _net_941, _net_942, _net_943, _net_944, _net_945, _net_946, _net_947, SI);
not inst1143  (_net_948, D1);
not inst1144  (_net_949, D0);
not inst1145  (_net_950, D2);
not inst1146  (_net_951, D3);
not inst1147  (_net_952, D4);
not inst1148  (_net_953, D5);
not inst1149  (_net_954, D6);
not inst1150  (_net_955, D7);
and inst1151  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI, _net_948, _net_949, _net_950, _net_951, _net_952, _net_953, _net_954, _net_955, RD, SI);
not inst1152  (_net_956, D1);
not inst1153  (_net_957, D0);
not inst1154  (_net_958, D2);
not inst1155  (_net_959, D3);
not inst1156  (_net_960, D4);
not inst1157  (_net_961, D5);
not inst1158  (_net_962, D6);
not inst1159  (_net_963, SI);
and inst1160  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI, _net_956, _net_957, _net_958, _net_959, _net_960, _net_961, _net_962, D7, RD, _net_963);
not inst1161  (_net_964, D1);
not inst1162  (_net_965, D0);
not inst1163  (_net_966, D2);
not inst1164  (_net_967, D3);
not inst1165  (_net_968, D4);
not inst1166  (_net_969, D5);
not inst1167  (_net_970, D7);
not inst1168  (_net_971, SI);
and inst1169  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_964, _net_965, _net_966, _net_967, _net_968, _net_969, D6, _net_970, RD, _net_971);
not inst1170  (_net_972, D1);
not inst1171  (_net_973, D0);
not inst1172  (_net_974, D2);
not inst1173  (_net_975, D3);
not inst1174  (_net_976, D4);
not inst1175  (_net_977, D6);
not inst1176  (_net_978, D7);
not inst1177  (_net_979, SI);
and inst1178  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_972, _net_973, _net_974, _net_975, _net_976, D5, _net_977, _net_978, RD, _net_979);
not inst1179  (_net_980, D1);
not inst1180  (_net_981, D0);
not inst1181  (_net_982, D2);
not inst1182  (_net_983, D3);
not inst1183  (_net_984, D5);
not inst1184  (_net_985, D6);
not inst1185  (_net_986, D7);
not inst1186  (_net_987, SI);
and inst1187  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_980, _net_981, _net_982, _net_983, D4, _net_984, _net_985, _net_986, RD, _net_987);
not inst1188  (_net_988, D1);
not inst1189  (_net_989, D0);
not inst1190  (_net_990, D2);
not inst1191  (_net_991, D4);
not inst1192  (_net_992, D5);
not inst1193  (_net_993, D6);
not inst1194  (_net_994, D7);
not inst1195  (_net_995, SI);
and inst1196  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_988, _net_989, _net_990, D3, _net_991, _net_992, _net_993, _net_994, RD, _net_995);
not inst1197  (_net_996, D1);
not inst1198  (_net_997, D0);
not inst1199  (_net_998, D3);
not inst1200  (_net_999, D4);
not inst1201  (_net_1000, D5);
not inst1202  (_net_1001, D6);
not inst1203  (_net_1002, D7);
not inst1204  (_net_1003, SI);
and inst1205  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_996, _net_997, D2, _net_998, _net_999, _net_1000, _net_1001, _net_1002, RD, _net_1003);
not inst1206  (_net_1004, D0);
not inst1207  (_net_1005, D2);
not inst1208  (_net_1006, D3);
not inst1209  (_net_1007, D4);
not inst1210  (_net_1008, D5);
not inst1211  (_net_1009, D6);
not inst1212  (_net_1010, D7);
not inst1213  (_net_1011, SI);
and inst1214  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, D1, _net_1004, _net_1005, _net_1006, _net_1007, _net_1008, _net_1009, _net_1010, RD, _net_1011);
not inst1215  (_net_1012, D1);
not inst1216  (_net_1013, D2);
not inst1217  (_net_1014, D3);
not inst1218  (_net_1015, D4);
not inst1219  (_net_1016, D5);
not inst1220  (_net_1017, D6);
not inst1221  (_net_1018, D7);
not inst1222  (_net_1019, SI);
and inst1223  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI, _net_1012, D0, _net_1013, _net_1014, _net_1015, _net_1016, _net_1017, _net_1018, RD, _net_1019);
not inst1224  (_net_1020, RD);
and inst1225  (ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SI, D1, D0, D2, D3, D4, D5, D6, D7, _net_1020, SI);
not inst1226  (_net_1021, RD);
not inst1227  (_net_1022, D0);
and inst1228  (ENABLE_NOT_D0_AND_NOT_RD_AND_SE, _net_1021, _net_1022, SE);
not inst1229  (_net_1023, D0);
and inst1230  (ENABLE_NOT_D0_AND_RD_AND_SE, RD, _net_1023, SE);
not inst1231  (_net_1024, RD);
and inst1232  (ENABLE_D0_AND_NOT_RD_AND_SE, _net_1024, D0, SE);
and inst1233  (ENABLE_D0_AND_RD_AND_SE, RD, D0, SE);
not inst1234  (_net_1025, SE);
not inst1235  (_net_1026, SI);
and inst1236  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_1025, RD, _net_1026);
not inst1237  (_net_1027, SE);
and inst1238  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_1027, RD, SI);

specify
if (D0==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
if (D0==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q0 +: 1'b1))=(0, 0);
(posedge CK => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
if (D1==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q1 +: 1'b1))=(0, 0);
(posedge CK => (Q1 : 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
if (D2==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q2 +: 1'b1))=(0, 0);
(posedge CK => (Q2 : 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
if (D3==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q3 +: 1'b1))=(0, 0);
(posedge CK => (Q3 : 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q4 -: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
if (D4==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q4 +: 1'b1))=(0, 0);
(posedge CK => (Q4 : 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q5 -: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
if (D5==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q5 +: 1'b1))=(0, 0);
(posedge CK => (Q5 : 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q6 -: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
if (D6==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q6 +: 1'b1))=(0, 0);
(posedge CK => (Q6 : 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b0&&SE==1'b0&&SI==1'b1) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b0) (posedge CK => (Q7 -: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b0&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b0&&SE==1'b1&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b0) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b1&&SE==1'b0&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
if (D7==1'b1&&RD==1'b1&&SE==1'b1&&SI==1'b1) (posedge CK => (Q7 +: 1'b1))=(0, 0);
(posedge CK => (Q7 : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK , 0 ,0, viol_0);
$width(negedge CK , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK , posedge RD , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK , negedge RD , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3_AND_NOT_D4_AND_NOT_D5_AND_NOT_D6_AND_NOT_D7_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D0_AND_D1_AND_D2_AND_D3_AND_D4_AND_D5_AND_D6_AND_D7_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , posedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK , negedge SE , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , posedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D0_AND_RD_AND_SE , negedge SI &&& ENABLE_D0_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D0 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D1 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D1);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D2 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D2);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D3 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D3);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D4 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D4 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D4 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D4 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D4);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D5 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D5);
$hold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D5 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 , viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D5 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D5);
$hold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D5 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 , viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D6 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D6 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D6 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D6 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D6);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D7 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D7 &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D7 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D7);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D7 &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D7);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_FSDPSYNRBQM8SS_V2Y8_2

//%BEGIN HDBSVT11_FSDPSYNRBQ_CBV2Y2_1

`celldefine
module HDBSVT11_FSDPSYNRBQ_CBV2Y2_1 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   and inst5  (int_res__D, delayed_D, delayed_RD);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   
   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `else
      snps_dff inst9  (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst10  (_net_0, RD);
not inst11  (_net_1, D);
not inst12  (_net_2, SE);
not inst13  (_net_3, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst15  (_net_4, RD);
not inst16  (_net_5, D);
not inst17  (_net_6, SE);
and inst18  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst19  (_net_7, RD);
not inst20  (_net_8, D);
not inst21  (_net_9, SI);
and inst22  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst23  (_net_10, RD);
not inst24  (_net_11, D);
and inst25  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst26  (_net_12, D);
not inst27  (_net_13, SE);
not inst28  (_net_14, SI);
and inst29  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_12, _net_13, _net_14);
not inst30  (_net_15, D);
not inst31  (_net_16, SE);
and inst32  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_15, _net_16, SI);
not inst33  (_net_17, D);
not inst34  (_net_18, SI);
and inst35  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_17, SE, _net_18);
not inst36  (_net_19, D);
and inst37  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_19, SE, SI);
not inst38  (_net_20, RD);
not inst39  (_net_21, SE);
not inst40  (_net_22, SI);
and inst41  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst42  (_net_23, RD);
not inst43  (_net_24, SE);
and inst44  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst45  (_net_25, RD);
not inst46  (_net_26, SI);
and inst47  (ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst48  (_net_27, RD);
and inst49  (ENABLE_D_AND_NOT_RD_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst50  (_net_28, SE);
not inst51  (_net_29, SI);
and inst52  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_28, _net_29);
not inst53  (_net_30, SE);
and inst54  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_30, SI);
not inst55  (_net_31, SI);
and inst56  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_31);
and inst57  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst58  (_net_32, SE);
not inst59  (_net_33, SI);
and inst60  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_32, RD, _net_33);
not inst61  (_net_34, SE);
and inst62  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_34, RD, SI);
not inst63  (_net_35, SE);
not inst64  (_net_36, SI);
and inst65  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_35, D, _net_36);
not inst66  (_net_37, SE);
and inst67  (ENABLE_D_AND_NOT_SE_AND_SI, _net_37, D, SI);
not inst68  (_net_38, RD);
not inst69  (_net_39, D);
and inst70  (ENABLE_NOT_D_AND_NOT_RD_AND_SI, _net_38, _net_39, SI);
not inst71  (_net_40, D);
and inst72  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_40, SI);
not inst73  (_net_41, RD);
and inst74  (ENABLE_D_AND_NOT_RD_AND_SI, _net_41, D, SI);
not inst75  (_net_42, SI);
and inst76  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_42);
not inst77  (_net_43, RD);
not inst78  (_net_44, D);
and inst79  (ENABLE_NOT_D_AND_NOT_RD_AND_SE, _net_43, _net_44, SE);
not inst80  (_net_45, D);
and inst81  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_45, SE);
not inst82  (_net_46, RD);
and inst83  (ENABLE_D_AND_NOT_RD_AND_SE, _net_46, D, SE);
and inst84  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif   
endmodule
`endcelldefine

//%END HDBSVT11_FSDPSYNRBQ_CBV2Y2_1

//%BEGIN HDBSVT11_FSDPSYNRBQ_V1Y2_1

`celldefine
module HDBSVT11_FSDPSYNRBQ_V1Y2_1 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   and inst5  (int_res__D, delayed_D, delayed_RD);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   
   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `else
      snps_dff inst9  (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst10  (_net_0, RD);
not inst11  (_net_1, D);
not inst12  (_net_2, SE);
not inst13  (_net_3, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst15  (_net_4, RD);
not inst16  (_net_5, D);
not inst17  (_net_6, SE);
and inst18  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst19  (_net_7, RD);
not inst20  (_net_8, D);
not inst21  (_net_9, SI);
and inst22  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst23  (_net_10, RD);
not inst24  (_net_11, D);
and inst25  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst26  (_net_12, D);
not inst27  (_net_13, SE);
not inst28  (_net_14, SI);
and inst29  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_12, _net_13, _net_14);
not inst30  (_net_15, D);
not inst31  (_net_16, SE);
and inst32  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_15, _net_16, SI);
not inst33  (_net_17, D);
not inst34  (_net_18, SI);
and inst35  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_17, SE, _net_18);
not inst36  (_net_19, D);
and inst37  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_19, SE, SI);
not inst38  (_net_20, RD);
not inst39  (_net_21, SE);
not inst40  (_net_22, SI);
and inst41  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst42  (_net_23, RD);
not inst43  (_net_24, SE);
and inst44  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst45  (_net_25, RD);
not inst46  (_net_26, SI);
and inst47  (ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst48  (_net_27, RD);
and inst49  (ENABLE_D_AND_NOT_RD_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst50  (_net_28, SE);
not inst51  (_net_29, SI);
and inst52  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_28, _net_29);
not inst53  (_net_30, SE);
and inst54  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_30, SI);
not inst55  (_net_31, SI);
and inst56  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_31);
and inst57  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst58  (_net_32, SE);
not inst59  (_net_33, SI);
and inst60  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_32, RD, _net_33);
not inst61  (_net_34, SE);
and inst62  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_34, RD, SI);
not inst63  (_net_35, SE);
not inst64  (_net_36, SI);
and inst65  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_35, D, _net_36);
not inst66  (_net_37, SE);
and inst67  (ENABLE_D_AND_NOT_SE_AND_SI, _net_37, D, SI);
not inst68  (_net_38, RD);
not inst69  (_net_39, D);
and inst70  (ENABLE_NOT_D_AND_NOT_RD_AND_SI, _net_38, _net_39, SI);
not inst71  (_net_40, D);
and inst72  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_40, SI);
not inst73  (_net_41, RD);
and inst74  (ENABLE_D_AND_NOT_RD_AND_SI, _net_41, D, SI);
not inst75  (_net_42, SI);
and inst76  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_42);
not inst77  (_net_43, RD);
not inst78  (_net_44, D);
and inst79  (ENABLE_NOT_D_AND_NOT_RD_AND_SE, _net_43, _net_44, SE);
not inst80  (_net_45, D);
and inst81  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_45, SE);
not inst82  (_net_46, RD);
and inst83  (ENABLE_D_AND_NOT_RD_AND_SE, _net_46, D, SE);
and inst84  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif   
endmodule
`endcelldefine

//%END HDBSVT11_FSDPSYNRBQ_V1Y2_1

//%BEGIN HDBSVT11_FSDPSYNRBQ_V1Y2_2

`celldefine
module HDBSVT11_FSDPSYNRBQ_V1Y2_2 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   and inst5  (int_res__D, delayed_D, delayed_RD);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   
   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `else
      snps_dff inst9  (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst10  (_net_0, RD);
not inst11  (_net_1, D);
not inst12  (_net_2, SE);
not inst13  (_net_3, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst15  (_net_4, RD);
not inst16  (_net_5, D);
not inst17  (_net_6, SE);
and inst18  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst19  (_net_7, RD);
not inst20  (_net_8, D);
not inst21  (_net_9, SI);
and inst22  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst23  (_net_10, RD);
not inst24  (_net_11, D);
and inst25  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst26  (_net_12, D);
not inst27  (_net_13, SE);
not inst28  (_net_14, SI);
and inst29  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_12, _net_13, _net_14);
not inst30  (_net_15, D);
not inst31  (_net_16, SE);
and inst32  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_15, _net_16, SI);
not inst33  (_net_17, D);
not inst34  (_net_18, SI);
and inst35  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_17, SE, _net_18);
not inst36  (_net_19, D);
and inst37  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_19, SE, SI);
not inst38  (_net_20, RD);
not inst39  (_net_21, SE);
not inst40  (_net_22, SI);
and inst41  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst42  (_net_23, RD);
not inst43  (_net_24, SE);
and inst44  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst45  (_net_25, RD);
not inst46  (_net_26, SI);
and inst47  (ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst48  (_net_27, RD);
and inst49  (ENABLE_D_AND_NOT_RD_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst50  (_net_28, SE);
not inst51  (_net_29, SI);
and inst52  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_28, _net_29);
not inst53  (_net_30, SE);
and inst54  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_30, SI);
not inst55  (_net_31, SI);
and inst56  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_31);
and inst57  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst58  (_net_32, SE);
not inst59  (_net_33, SI);
and inst60  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_32, RD, _net_33);
not inst61  (_net_34, SE);
and inst62  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_34, RD, SI);
not inst63  (_net_35, SE);
not inst64  (_net_36, SI);
and inst65  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_35, D, _net_36);
not inst66  (_net_37, SE);
and inst67  (ENABLE_D_AND_NOT_SE_AND_SI, _net_37, D, SI);
not inst68  (_net_38, RD);
not inst69  (_net_39, D);
and inst70  (ENABLE_NOT_D_AND_NOT_RD_AND_SI, _net_38, _net_39, SI);
not inst71  (_net_40, D);
and inst72  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_40, SI);
not inst73  (_net_41, RD);
and inst74  (ENABLE_D_AND_NOT_RD_AND_SI, _net_41, D, SI);
not inst75  (_net_42, SI);
and inst76  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_42);
not inst77  (_net_43, RD);
not inst78  (_net_44, D);
and inst79  (ENABLE_NOT_D_AND_NOT_RD_AND_SE, _net_43, _net_44, SE);
not inst80  (_net_45, D);
and inst81  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_45, SE);
not inst82  (_net_46, RD);
and inst83  (ENABLE_D_AND_NOT_RD_AND_SE, _net_46, D, SE);
and inst84  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif   
endmodule
`endcelldefine

//%END HDBSVT11_FSDPSYNRBQ_V1Y2_2

//%BEGIN HDBSVT11_FSDPSYNRBQ_V1Y2_4

`celldefine
module HDBSVT11_FSDPSYNRBQ_V1Y2_4 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   and inst5  (int_res__D, delayed_D, delayed_RD);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   
   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `else
      snps_dff inst9  (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst10  (_net_0, RD);
not inst11  (_net_1, D);
not inst12  (_net_2, SE);
not inst13  (_net_3, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst15  (_net_4, RD);
not inst16  (_net_5, D);
not inst17  (_net_6, SE);
and inst18  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst19  (_net_7, RD);
not inst20  (_net_8, D);
not inst21  (_net_9, SI);
and inst22  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst23  (_net_10, RD);
not inst24  (_net_11, D);
and inst25  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst26  (_net_12, D);
not inst27  (_net_13, SE);
not inst28  (_net_14, SI);
and inst29  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_12, _net_13, _net_14);
not inst30  (_net_15, D);
not inst31  (_net_16, SE);
and inst32  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_15, _net_16, SI);
not inst33  (_net_17, D);
not inst34  (_net_18, SI);
and inst35  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_17, SE, _net_18);
not inst36  (_net_19, D);
and inst37  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_19, SE, SI);
not inst38  (_net_20, RD);
not inst39  (_net_21, SE);
not inst40  (_net_22, SI);
and inst41  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst42  (_net_23, RD);
not inst43  (_net_24, SE);
and inst44  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst45  (_net_25, RD);
not inst46  (_net_26, SI);
and inst47  (ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst48  (_net_27, RD);
and inst49  (ENABLE_D_AND_NOT_RD_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst50  (_net_28, SE);
not inst51  (_net_29, SI);
and inst52  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_28, _net_29);
not inst53  (_net_30, SE);
and inst54  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_30, SI);
not inst55  (_net_31, SI);
and inst56  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_31);
and inst57  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst58  (_net_32, SE);
not inst59  (_net_33, SI);
and inst60  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_32, RD, _net_33);
not inst61  (_net_34, SE);
and inst62  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_34, RD, SI);
not inst63  (_net_35, SE);
not inst64  (_net_36, SI);
and inst65  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_35, D, _net_36);
not inst66  (_net_37, SE);
and inst67  (ENABLE_D_AND_NOT_SE_AND_SI, _net_37, D, SI);
not inst68  (_net_38, RD);
not inst69  (_net_39, D);
and inst70  (ENABLE_NOT_D_AND_NOT_RD_AND_SI, _net_38, _net_39, SI);
not inst71  (_net_40, D);
and inst72  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_40, SI);
not inst73  (_net_41, RD);
and inst74  (ENABLE_D_AND_NOT_RD_AND_SI, _net_41, D, SI);
not inst75  (_net_42, SI);
and inst76  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_42);
not inst77  (_net_43, RD);
not inst78  (_net_44, D);
and inst79  (ENABLE_NOT_D_AND_NOT_RD_AND_SE, _net_43, _net_44, SE);
not inst80  (_net_45, D);
and inst81  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_45, SE);
not inst82  (_net_46, RD);
and inst83  (ENABLE_D_AND_NOT_RD_AND_SE, _net_46, D, SE);
and inst84  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif   
endmodule
`endcelldefine

//%END HDBSVT11_FSDPSYNRBQ_V1Y2_4

//%BEGIN HDBSVT11_FSDPSYNRBQ_V2Y2_1

`celldefine
module HDBSVT11_FSDPSYNRBQ_V2Y2_1 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   and inst5  (int_res__D, delayed_D, delayed_RD);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   
   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `else
      snps_dff inst9  (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst10  (_net_0, RD);
not inst11  (_net_1, D);
not inst12  (_net_2, SE);
not inst13  (_net_3, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst15  (_net_4, RD);
not inst16  (_net_5, D);
not inst17  (_net_6, SE);
and inst18  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst19  (_net_7, RD);
not inst20  (_net_8, D);
not inst21  (_net_9, SI);
and inst22  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst23  (_net_10, RD);
not inst24  (_net_11, D);
and inst25  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst26  (_net_12, D);
not inst27  (_net_13, SE);
not inst28  (_net_14, SI);
and inst29  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_12, _net_13, _net_14);
not inst30  (_net_15, D);
not inst31  (_net_16, SE);
and inst32  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_15, _net_16, SI);
not inst33  (_net_17, D);
not inst34  (_net_18, SI);
and inst35  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_17, SE, _net_18);
not inst36  (_net_19, D);
and inst37  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_19, SE, SI);
not inst38  (_net_20, RD);
not inst39  (_net_21, SE);
not inst40  (_net_22, SI);
and inst41  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst42  (_net_23, RD);
not inst43  (_net_24, SE);
and inst44  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst45  (_net_25, RD);
not inst46  (_net_26, SI);
and inst47  (ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst48  (_net_27, RD);
and inst49  (ENABLE_D_AND_NOT_RD_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst50  (_net_28, SE);
not inst51  (_net_29, SI);
and inst52  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_28, _net_29);
not inst53  (_net_30, SE);
and inst54  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_30, SI);
not inst55  (_net_31, SI);
and inst56  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_31);
and inst57  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst58  (_net_32, SE);
not inst59  (_net_33, SI);
and inst60  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_32, RD, _net_33);
not inst61  (_net_34, SE);
and inst62  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_34, RD, SI);
not inst63  (_net_35, SE);
not inst64  (_net_36, SI);
and inst65  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_35, D, _net_36);
not inst66  (_net_37, SE);
and inst67  (ENABLE_D_AND_NOT_SE_AND_SI, _net_37, D, SI);
not inst68  (_net_38, RD);
not inst69  (_net_39, D);
and inst70  (ENABLE_NOT_D_AND_NOT_RD_AND_SI, _net_38, _net_39, SI);
not inst71  (_net_40, D);
and inst72  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_40, SI);
not inst73  (_net_41, RD);
and inst74  (ENABLE_D_AND_NOT_RD_AND_SI, _net_41, D, SI);
not inst75  (_net_42, SI);
and inst76  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_42);
not inst77  (_net_43, RD);
not inst78  (_net_44, D);
and inst79  (ENABLE_NOT_D_AND_NOT_RD_AND_SE, _net_43, _net_44, SE);
not inst80  (_net_45, D);
and inst81  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_45, SE);
not inst82  (_net_46, RD);
and inst83  (ENABLE_D_AND_NOT_RD_AND_SE, _net_46, D, SE);
and inst84  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif   
endmodule
`endcelldefine

//%END HDBSVT11_FSDPSYNRBQ_V2Y2_1

//%BEGIN HDBSVT11_FSDPSYNRBQ_V2Y2_2

`celldefine
module HDBSVT11_FSDPSYNRBQ_V2Y2_2 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   and inst5  (int_res__D, delayed_D, delayed_RD);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   
   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `else
      snps_dff inst9  (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst10  (_net_0, RD);
not inst11  (_net_1, D);
not inst12  (_net_2, SE);
not inst13  (_net_3, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst15  (_net_4, RD);
not inst16  (_net_5, D);
not inst17  (_net_6, SE);
and inst18  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst19  (_net_7, RD);
not inst20  (_net_8, D);
not inst21  (_net_9, SI);
and inst22  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst23  (_net_10, RD);
not inst24  (_net_11, D);
and inst25  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst26  (_net_12, D);
not inst27  (_net_13, SE);
not inst28  (_net_14, SI);
and inst29  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_12, _net_13, _net_14);
not inst30  (_net_15, D);
not inst31  (_net_16, SE);
and inst32  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_15, _net_16, SI);
not inst33  (_net_17, D);
not inst34  (_net_18, SI);
and inst35  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_17, SE, _net_18);
not inst36  (_net_19, D);
and inst37  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_19, SE, SI);
not inst38  (_net_20, RD);
not inst39  (_net_21, SE);
not inst40  (_net_22, SI);
and inst41  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst42  (_net_23, RD);
not inst43  (_net_24, SE);
and inst44  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst45  (_net_25, RD);
not inst46  (_net_26, SI);
and inst47  (ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst48  (_net_27, RD);
and inst49  (ENABLE_D_AND_NOT_RD_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst50  (_net_28, SE);
not inst51  (_net_29, SI);
and inst52  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_28, _net_29);
not inst53  (_net_30, SE);
and inst54  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_30, SI);
not inst55  (_net_31, SI);
and inst56  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_31);
and inst57  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst58  (_net_32, SE);
not inst59  (_net_33, SI);
and inst60  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_32, RD, _net_33);
not inst61  (_net_34, SE);
and inst62  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_34, RD, SI);
not inst63  (_net_35, SE);
not inst64  (_net_36, SI);
and inst65  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_35, D, _net_36);
not inst66  (_net_37, SE);
and inst67  (ENABLE_D_AND_NOT_SE_AND_SI, _net_37, D, SI);
not inst68  (_net_38, RD);
not inst69  (_net_39, D);
and inst70  (ENABLE_NOT_D_AND_NOT_RD_AND_SI, _net_38, _net_39, SI);
not inst71  (_net_40, D);
and inst72  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_40, SI);
not inst73  (_net_41, RD);
and inst74  (ENABLE_D_AND_NOT_RD_AND_SI, _net_41, D, SI);
not inst75  (_net_42, SI);
and inst76  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_42);
not inst77  (_net_43, RD);
not inst78  (_net_44, D);
and inst79  (ENABLE_NOT_D_AND_NOT_RD_AND_SE, _net_43, _net_44, SE);
not inst80  (_net_45, D);
and inst81  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_45, SE);
not inst82  (_net_46, RD);
and inst83  (ENABLE_D_AND_NOT_RD_AND_SE, _net_46, D, SE);
and inst84  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif   
endmodule
`endcelldefine

//%END HDBSVT11_FSDPSYNRBQ_V2Y2_2

//%BEGIN HDBSVT11_FSDPSYNRBQ_V2Y2_4

`celldefine
module HDBSVT11_FSDPSYNRBQ_V2Y2_4 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   and inst5  (int_res__D, delayed_D, delayed_RD);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   
   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `else
      snps_dff inst9  (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst10  (_net_0, RD);
not inst11  (_net_1, D);
not inst12  (_net_2, SE);
not inst13  (_net_3, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst15  (_net_4, RD);
not inst16  (_net_5, D);
not inst17  (_net_6, SE);
and inst18  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst19  (_net_7, RD);
not inst20  (_net_8, D);
not inst21  (_net_9, SI);
and inst22  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst23  (_net_10, RD);
not inst24  (_net_11, D);
and inst25  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst26  (_net_12, D);
not inst27  (_net_13, SE);
not inst28  (_net_14, SI);
and inst29  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_12, _net_13, _net_14);
not inst30  (_net_15, D);
not inst31  (_net_16, SE);
and inst32  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_15, _net_16, SI);
not inst33  (_net_17, D);
not inst34  (_net_18, SI);
and inst35  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_17, SE, _net_18);
not inst36  (_net_19, D);
and inst37  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_19, SE, SI);
not inst38  (_net_20, RD);
not inst39  (_net_21, SE);
not inst40  (_net_22, SI);
and inst41  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst42  (_net_23, RD);
not inst43  (_net_24, SE);
and inst44  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst45  (_net_25, RD);
not inst46  (_net_26, SI);
and inst47  (ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst48  (_net_27, RD);
and inst49  (ENABLE_D_AND_NOT_RD_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst50  (_net_28, SE);
not inst51  (_net_29, SI);
and inst52  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_28, _net_29);
not inst53  (_net_30, SE);
and inst54  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_30, SI);
not inst55  (_net_31, SI);
and inst56  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_31);
and inst57  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst58  (_net_32, SE);
not inst59  (_net_33, SI);
and inst60  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_32, RD, _net_33);
not inst61  (_net_34, SE);
and inst62  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_34, RD, SI);
not inst63  (_net_35, SE);
not inst64  (_net_36, SI);
and inst65  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_35, D, _net_36);
not inst66  (_net_37, SE);
and inst67  (ENABLE_D_AND_NOT_SE_AND_SI, _net_37, D, SI);
not inst68  (_net_38, RD);
not inst69  (_net_39, D);
and inst70  (ENABLE_NOT_D_AND_NOT_RD_AND_SI, _net_38, _net_39, SI);
not inst71  (_net_40, D);
and inst72  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_40, SI);
not inst73  (_net_41, RD);
and inst74  (ENABLE_D_AND_NOT_RD_AND_SI, _net_41, D, SI);
not inst75  (_net_42, SI);
and inst76  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_42);
not inst77  (_net_43, RD);
not inst78  (_net_44, D);
and inst79  (ENABLE_NOT_D_AND_NOT_RD_AND_SE, _net_43, _net_44, SE);
not inst80  (_net_45, D);
and inst81  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_45, SE);
not inst82  (_net_46, RD);
and inst83  (ENABLE_D_AND_NOT_RD_AND_SE, _net_46, D, SE);
and inst84  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif   
endmodule
`endcelldefine

//%END HDBSVT11_FSDPSYNRBQ_V2Y2_4

//%BEGIN HDBSVT11_FSDPSYNRBQ_V3Y2_1

`celldefine
module HDBSVT11_FSDPSYNRBQ_V3Y2_1 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   and inst5  (int_res__D, delayed_D, delayed_RD);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   
   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `else
      snps_dff inst9  (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst10  (_net_0, RD);
not inst11  (_net_1, D);
not inst12  (_net_2, SE);
not inst13  (_net_3, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst15  (_net_4, RD);
not inst16  (_net_5, D);
not inst17  (_net_6, SE);
and inst18  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst19  (_net_7, RD);
not inst20  (_net_8, D);
not inst21  (_net_9, SI);
and inst22  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst23  (_net_10, RD);
not inst24  (_net_11, D);
and inst25  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst26  (_net_12, D);
not inst27  (_net_13, SE);
not inst28  (_net_14, SI);
and inst29  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_12, _net_13, _net_14);
not inst30  (_net_15, D);
not inst31  (_net_16, SE);
and inst32  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_15, _net_16, SI);
not inst33  (_net_17, D);
not inst34  (_net_18, SI);
and inst35  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_17, SE, _net_18);
not inst36  (_net_19, D);
and inst37  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_19, SE, SI);
not inst38  (_net_20, RD);
not inst39  (_net_21, SE);
not inst40  (_net_22, SI);
and inst41  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst42  (_net_23, RD);
not inst43  (_net_24, SE);
and inst44  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst45  (_net_25, RD);
not inst46  (_net_26, SI);
and inst47  (ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst48  (_net_27, RD);
and inst49  (ENABLE_D_AND_NOT_RD_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst50  (_net_28, SE);
not inst51  (_net_29, SI);
and inst52  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_28, _net_29);
not inst53  (_net_30, SE);
and inst54  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_30, SI);
not inst55  (_net_31, SI);
and inst56  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_31);
and inst57  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst58  (_net_32, SE);
not inst59  (_net_33, SI);
and inst60  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_32, RD, _net_33);
not inst61  (_net_34, SE);
and inst62  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_34, RD, SI);
not inst63  (_net_35, SE);
not inst64  (_net_36, SI);
and inst65  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_35, D, _net_36);
not inst66  (_net_37, SE);
and inst67  (ENABLE_D_AND_NOT_SE_AND_SI, _net_37, D, SI);
not inst68  (_net_38, RD);
not inst69  (_net_39, D);
and inst70  (ENABLE_NOT_D_AND_NOT_RD_AND_SI, _net_38, _net_39, SI);
not inst71  (_net_40, D);
and inst72  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_40, SI);
not inst73  (_net_41, RD);
and inst74  (ENABLE_D_AND_NOT_RD_AND_SI, _net_41, D, SI);
not inst75  (_net_42, SI);
and inst76  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_42);
not inst77  (_net_43, RD);
not inst78  (_net_44, D);
and inst79  (ENABLE_NOT_D_AND_NOT_RD_AND_SE, _net_43, _net_44, SE);
not inst80  (_net_45, D);
and inst81  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_45, SE);
not inst82  (_net_46, RD);
and inst83  (ENABLE_D_AND_NOT_RD_AND_SE, _net_46, D, SE);
and inst84  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif   
endmodule
`endcelldefine

//%END HDBSVT11_FSDPSYNRBQ_V3Y2_1

//%BEGIN HDBSVT11_FSDPSYNRBQ_V3Y2_2

`celldefine
module HDBSVT11_FSDPSYNRBQ_V3Y2_2 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   and inst5  (int_res__D, delayed_D, delayed_RD);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   
   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `else
      snps_dff inst9  (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst10  (_net_0, RD);
not inst11  (_net_1, D);
not inst12  (_net_2, SE);
not inst13  (_net_3, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst15  (_net_4, RD);
not inst16  (_net_5, D);
not inst17  (_net_6, SE);
and inst18  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst19  (_net_7, RD);
not inst20  (_net_8, D);
not inst21  (_net_9, SI);
and inst22  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst23  (_net_10, RD);
not inst24  (_net_11, D);
and inst25  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst26  (_net_12, D);
not inst27  (_net_13, SE);
not inst28  (_net_14, SI);
and inst29  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_12, _net_13, _net_14);
not inst30  (_net_15, D);
not inst31  (_net_16, SE);
and inst32  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_15, _net_16, SI);
not inst33  (_net_17, D);
not inst34  (_net_18, SI);
and inst35  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_17, SE, _net_18);
not inst36  (_net_19, D);
and inst37  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_19, SE, SI);
not inst38  (_net_20, RD);
not inst39  (_net_21, SE);
not inst40  (_net_22, SI);
and inst41  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst42  (_net_23, RD);
not inst43  (_net_24, SE);
and inst44  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst45  (_net_25, RD);
not inst46  (_net_26, SI);
and inst47  (ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst48  (_net_27, RD);
and inst49  (ENABLE_D_AND_NOT_RD_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst50  (_net_28, SE);
not inst51  (_net_29, SI);
and inst52  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_28, _net_29);
not inst53  (_net_30, SE);
and inst54  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_30, SI);
not inst55  (_net_31, SI);
and inst56  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_31);
and inst57  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst58  (_net_32, SE);
not inst59  (_net_33, SI);
and inst60  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_32, RD, _net_33);
not inst61  (_net_34, SE);
and inst62  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_34, RD, SI);
not inst63  (_net_35, SE);
not inst64  (_net_36, SI);
and inst65  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_35, D, _net_36);
not inst66  (_net_37, SE);
and inst67  (ENABLE_D_AND_NOT_SE_AND_SI, _net_37, D, SI);
not inst68  (_net_38, RD);
not inst69  (_net_39, D);
and inst70  (ENABLE_NOT_D_AND_NOT_RD_AND_SI, _net_38, _net_39, SI);
not inst71  (_net_40, D);
and inst72  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_40, SI);
not inst73  (_net_41, RD);
and inst74  (ENABLE_D_AND_NOT_RD_AND_SI, _net_41, D, SI);
not inst75  (_net_42, SI);
and inst76  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_42);
not inst77  (_net_43, RD);
not inst78  (_net_44, D);
and inst79  (ENABLE_NOT_D_AND_NOT_RD_AND_SE, _net_43, _net_44, SE);
not inst80  (_net_45, D);
and inst81  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_45, SE);
not inst82  (_net_46, RD);
and inst83  (ENABLE_D_AND_NOT_RD_AND_SE, _net_46, D, SE);
and inst84  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif   
endmodule
`endcelldefine

//%END HDBSVT11_FSDPSYNRBQ_V3Y2_2

//%BEGIN HDBSVT11_FSDPSYNRBQ_V3Y2_4

`celldefine
module HDBSVT11_FSDPSYNRBQ_V3Y2_4 (Q, CK, D, SI, SE, RD);
   output Q;
   input CK, D, SI, SE, RD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_RD;

   wire int_res__D, int_res__RD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_RD, RD);
`endif

   and inst5  (int_res__D, delayed_D, delayed_RD);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   
   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst8 (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `else
      snps_dff inst9  (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst10  (_net_0, RD);
not inst11  (_net_1, D);
not inst12  (_net_2, SE);
not inst13  (_net_3, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst15  (_net_4, RD);
not inst16  (_net_5, D);
not inst17  (_net_6, SE);
and inst18  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst19  (_net_7, RD);
not inst20  (_net_8, D);
not inst21  (_net_9, SI);
and inst22  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst23  (_net_10, RD);
not inst24  (_net_11, D);
and inst25  (ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst26  (_net_12, D);
not inst27  (_net_13, SE);
not inst28  (_net_14, SI);
and inst29  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, _net_12, _net_13, _net_14);
not inst30  (_net_15, D);
not inst31  (_net_16, SE);
and inst32  (ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI, RD, _net_15, _net_16, SI);
not inst33  (_net_17, D);
not inst34  (_net_18, SI);
and inst35  (ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI, RD, _net_17, SE, _net_18);
not inst36  (_net_19, D);
and inst37  (ENABLE_NOT_D_AND_RD_AND_SE_AND_SI, RD, _net_19, SE, SI);
not inst38  (_net_20, RD);
not inst39  (_net_21, SE);
not inst40  (_net_22, SI);
and inst41  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst42  (_net_23, RD);
not inst43  (_net_24, SE);
and inst44  (ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst45  (_net_25, RD);
not inst46  (_net_26, SI);
and inst47  (ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst48  (_net_27, RD);
and inst49  (ENABLE_D_AND_NOT_RD_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst50  (_net_28, SE);
not inst51  (_net_29, SI);
and inst52  (ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI, RD, D, _net_28, _net_29);
not inst53  (_net_30, SE);
and inst54  (ENABLE_D_AND_RD_AND_NOT_SE_AND_SI, RD, D, _net_30, SI);
not inst55  (_net_31, SI);
and inst56  (ENABLE_D_AND_RD_AND_SE_AND_NOT_SI, RD, D, SE, _net_31);
and inst57  (ENABLE_D_AND_RD_AND_SE_AND_SI, RD, D, SE, SI);
not inst58  (_net_32, SE);
not inst59  (_net_33, SI);
and inst60  (ENABLE_RD_AND_NOT_SE_AND_NOT_SI, _net_32, RD, _net_33);
not inst61  (_net_34, SE);
and inst62  (ENABLE_RD_AND_NOT_SE_AND_SI, _net_34, RD, SI);
not inst63  (_net_35, SE);
not inst64  (_net_36, SI);
and inst65  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_35, D, _net_36);
not inst66  (_net_37, SE);
and inst67  (ENABLE_D_AND_NOT_SE_AND_SI, _net_37, D, SI);
not inst68  (_net_38, RD);
not inst69  (_net_39, D);
and inst70  (ENABLE_NOT_D_AND_NOT_RD_AND_SI, _net_38, _net_39, SI);
not inst71  (_net_40, D);
and inst72  (ENABLE_NOT_D_AND_RD_AND_SI, RD, _net_40, SI);
not inst73  (_net_41, RD);
and inst74  (ENABLE_D_AND_NOT_RD_AND_SI, _net_41, D, SI);
not inst75  (_net_42, SI);
and inst76  (ENABLE_D_AND_RD_AND_NOT_SI, RD, D, _net_42);
not inst77  (_net_43, RD);
not inst78  (_net_44, D);
and inst79  (ENABLE_NOT_D_AND_NOT_RD_AND_SE, _net_43, _net_44, SE);
not inst80  (_net_45, D);
and inst81  (ENABLE_NOT_D_AND_RD_AND_SE, RD, _net_45, SE);
not inst82  (_net_46, RD);
and inst83  (ENABLE_D_AND_NOT_RD_AND_SE, _net_46, D, SE);
and inst84  (ENABLE_D_AND_RD_AND_SE, RD, D, SE);

specify
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_RD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , posedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , negedge RD &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_RD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , posedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SI , negedge SE &&& ENABLE_D_AND_NOT_RD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_RD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_RD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_RD_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , posedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_RD_AND_SE , negedge SI &&& ENABLE_D_AND_RD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif   
endmodule
`endcelldefine

//%END HDBSVT11_FSDPSYNRBQ_V3Y2_4

//%BEGIN HDBSVT11_FSDPSYNSBQ_V2Y2_1

`celldefine
module HDBSVT11_FSDPSYNSBQ_V2Y2_1 (Q, CK, D, SI, SE, SD);
   output Q;
   input CK, D, SI, SE, SD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_SD;

   wire int_res__D, int_res__SD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_SD, SD);
`endif
   not inst5  (int_res__SD, delayed_SD);
   or inst6  (int_res__D, delayed_D, int_res__SD);
   snps_mux2 inst7  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res_mux);

  `endif
   
   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst9 (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `else
      snps_dff inst10  (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst11  (_net_0, SD);
not inst12  (_net_1, D);
not inst13  (_net_2, SE);
not inst14  (_net_3, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst16  (_net_4, SD);
not inst17  (_net_5, D);
not inst18  (_net_6, SE);
and inst19  (ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst20  (_net_7, SD);
not inst21  (_net_8, D);
not inst22  (_net_9, SI);
and inst23  (ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst24  (_net_10, SD);
not inst25  (_net_11, D);
and inst26  (ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst27  (_net_12, D);
not inst28  (_net_13, SE);
not inst29  (_net_14, SI);
and inst30  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, _net_12, _net_13, _net_14);
not inst31  (_net_15, D);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI, SD, _net_15, _net_16, SI);
not inst34  (_net_17, D);
not inst35  (_net_18, SI);
and inst36  (ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI, SD, _net_17, SE, _net_18);
not inst37  (_net_19, D);
and inst38  (ENABLE_NOT_D_AND_SD_AND_SE_AND_SI, SD, _net_19, SE, SI);
not inst39  (_net_20, SD);
not inst40  (_net_21, SE);
not inst41  (_net_22, SI);
and inst42  (ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst43  (_net_23, SD);
not inst44  (_net_24, SE);
and inst45  (ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst46  (_net_25, SD);
not inst47  (_net_26, SI);
and inst48  (ENABLE_D_AND_NOT_SD_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst49  (_net_27, SD);
and inst50  (ENABLE_D_AND_NOT_SD_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst51  (_net_28, SE);
not inst52  (_net_29, SI);
and inst53  (ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, D, _net_28, _net_29);
not inst54  (_net_30, SE);
and inst55  (ENABLE_D_AND_SD_AND_NOT_SE_AND_SI, SD, D, _net_30, SI);
not inst56  (_net_31, SI);
and inst57  (ENABLE_D_AND_SD_AND_SE_AND_NOT_SI, SD, D, SE, _net_31);
and inst58  (ENABLE_D_AND_SD_AND_SE_AND_SI, SD, D, SE, SI);
not inst59  (_net_32, SE);
not inst60  (_net_33, SI);
and inst61  (ENABLE_SD_AND_NOT_SE_AND_NOT_SI, _net_32, SD, _net_33);
not inst62  (_net_34, SE);
and inst63  (ENABLE_SD_AND_NOT_SE_AND_SI, _net_34, SD, SI);
not inst64  (_net_35, SE);
not inst65  (_net_36, D);
not inst66  (_net_37, SI);
and inst67  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_35, _net_36, _net_37);
not inst68  (_net_38, SE);
not inst69  (_net_39, D);
and inst70  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_38, _net_39, SI);
not inst71  (_net_40, SD);
not inst72  (_net_41, D);
not inst73  (_net_42, SI);
and inst74  (ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SI, _net_40, _net_41, _net_42);
not inst75  (_net_43, D);
and inst76  (ENABLE_NOT_D_AND_SD_AND_SI, SD, _net_43, SI);
not inst77  (_net_44, SD);
not inst78  (_net_45, SI);
and inst79  (ENABLE_D_AND_NOT_SD_AND_NOT_SI, _net_44, D, _net_45);
not inst80  (_net_46, SI);
and inst81  (ENABLE_D_AND_SD_AND_NOT_SI, SD, D, _net_46);
not inst82  (_net_47, SD);
not inst83  (_net_48, D);
and inst84  (ENABLE_NOT_D_AND_NOT_SD_AND_SE, _net_47, _net_48, SE);
not inst85  (_net_49, D);
and inst86  (ENABLE_NOT_D_AND_SD_AND_SE, SD, _net_49, SE);
not inst87  (_net_50, SD);
and inst88  (ENABLE_D_AND_NOT_SD_AND_SE, _net_50, D, SE);
and inst89  (ENABLE_D_AND_SD_AND_SE, SD, D, SE);

specify
if (D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , negedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , negedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , posedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , negedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif   
endmodule
`endcelldefine

//%END HDBSVT11_FSDPSYNSBQ_V2Y2_1

//%BEGIN HDBSVT11_FSDPSYNSBQ_V2Y2_2

`celldefine
module HDBSVT11_FSDPSYNSBQ_V2Y2_2 (Q, CK, D, SI, SE, SD);
   output Q;
   input CK, D, SI, SE, SD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_SD;

   wire int_res__D, int_res__SD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_SD, SD);
`endif
   not inst5  (int_res__SD, delayed_SD);
   or inst6  (int_res__D, delayed_D, int_res__SD);
   snps_mux2 inst7  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res_mux);

  `endif
   
   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst9 (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `else
      snps_dff inst10  (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst11  (_net_0, SD);
not inst12  (_net_1, D);
not inst13  (_net_2, SE);
not inst14  (_net_3, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst16  (_net_4, SD);
not inst17  (_net_5, D);
not inst18  (_net_6, SE);
and inst19  (ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst20  (_net_7, SD);
not inst21  (_net_8, D);
not inst22  (_net_9, SI);
and inst23  (ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst24  (_net_10, SD);
not inst25  (_net_11, D);
and inst26  (ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst27  (_net_12, D);
not inst28  (_net_13, SE);
not inst29  (_net_14, SI);
and inst30  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, _net_12, _net_13, _net_14);
not inst31  (_net_15, D);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI, SD, _net_15, _net_16, SI);
not inst34  (_net_17, D);
not inst35  (_net_18, SI);
and inst36  (ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI, SD, _net_17, SE, _net_18);
not inst37  (_net_19, D);
and inst38  (ENABLE_NOT_D_AND_SD_AND_SE_AND_SI, SD, _net_19, SE, SI);
not inst39  (_net_20, SD);
not inst40  (_net_21, SE);
not inst41  (_net_22, SI);
and inst42  (ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst43  (_net_23, SD);
not inst44  (_net_24, SE);
and inst45  (ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst46  (_net_25, SD);
not inst47  (_net_26, SI);
and inst48  (ENABLE_D_AND_NOT_SD_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst49  (_net_27, SD);
and inst50  (ENABLE_D_AND_NOT_SD_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst51  (_net_28, SE);
not inst52  (_net_29, SI);
and inst53  (ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, D, _net_28, _net_29);
not inst54  (_net_30, SE);
and inst55  (ENABLE_D_AND_SD_AND_NOT_SE_AND_SI, SD, D, _net_30, SI);
not inst56  (_net_31, SI);
and inst57  (ENABLE_D_AND_SD_AND_SE_AND_NOT_SI, SD, D, SE, _net_31);
and inst58  (ENABLE_D_AND_SD_AND_SE_AND_SI, SD, D, SE, SI);
not inst59  (_net_32, SE);
not inst60  (_net_33, SI);
and inst61  (ENABLE_SD_AND_NOT_SE_AND_NOT_SI, _net_32, SD, _net_33);
not inst62  (_net_34, SE);
and inst63  (ENABLE_SD_AND_NOT_SE_AND_SI, _net_34, SD, SI);
not inst64  (_net_35, SE);
not inst65  (_net_36, D);
not inst66  (_net_37, SI);
and inst67  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_35, _net_36, _net_37);
not inst68  (_net_38, SE);
not inst69  (_net_39, D);
and inst70  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_38, _net_39, SI);
not inst71  (_net_40, SD);
not inst72  (_net_41, D);
not inst73  (_net_42, SI);
and inst74  (ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SI, _net_40, _net_41, _net_42);
not inst75  (_net_43, D);
and inst76  (ENABLE_NOT_D_AND_SD_AND_SI, SD, _net_43, SI);
not inst77  (_net_44, SD);
not inst78  (_net_45, SI);
and inst79  (ENABLE_D_AND_NOT_SD_AND_NOT_SI, _net_44, D, _net_45);
not inst80  (_net_46, SI);
and inst81  (ENABLE_D_AND_SD_AND_NOT_SI, SD, D, _net_46);
not inst82  (_net_47, SD);
not inst83  (_net_48, D);
and inst84  (ENABLE_NOT_D_AND_NOT_SD_AND_SE, _net_47, _net_48, SE);
not inst85  (_net_49, D);
and inst86  (ENABLE_NOT_D_AND_SD_AND_SE, SD, _net_49, SE);
not inst87  (_net_50, SD);
and inst88  (ENABLE_D_AND_NOT_SD_AND_SE, _net_50, D, SE);
and inst89  (ENABLE_D_AND_SD_AND_SE, SD, D, SE);

specify
if (D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , negedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , negedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , posedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , negedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif   
endmodule
`endcelldefine

//%END HDBSVT11_FSDPSYNSBQ_V2Y2_2

//%BEGIN HDBSVT11_FSDPSYNSBQ_V2Y2_4

`celldefine
module HDBSVT11_FSDPSYNSBQ_V2Y2_4 (Q, CK, D, SI, SE, SD);
   output Q;
   input CK, D, SI, SE, SD;

   reg viol_0;
   wire delayed_CK, delayed_D, delayed_SI,
	delayed_SE, delayed_SD;

   wire int_res__D, int_res__SD, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
   buf inst4  (delayed_SD, SD);
`endif
   not inst5  (int_res__SD, delayed_SD);
   or inst6  (int_res__D, delayed_D, int_res__SD);
   snps_mux2 inst7  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst8  (xcr_0, delayed_CK, int_res_mux);

  `endif
   
   `ifdef VIRL_functiononly
      snps_dff #`SNPS_SEQ_DELAY  inst9 (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `else
      snps_dff inst10  (Q, viol_0, delayed_CK, int_res_mux, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst11  (_net_0, SD);
not inst12  (_net_1, D);
not inst13  (_net_2, SE);
not inst14  (_net_3, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst16  (_net_4, SD);
not inst17  (_net_5, D);
not inst18  (_net_6, SE);
and inst19  (ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst20  (_net_7, SD);
not inst21  (_net_8, D);
not inst22  (_net_9, SI);
and inst23  (ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst24  (_net_10, SD);
not inst25  (_net_11, D);
and inst26  (ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst27  (_net_12, D);
not inst28  (_net_13, SE);
not inst29  (_net_14, SI);
and inst30  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, _net_12, _net_13, _net_14);
not inst31  (_net_15, D);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI, SD, _net_15, _net_16, SI);
not inst34  (_net_17, D);
not inst35  (_net_18, SI);
and inst36  (ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI, SD, _net_17, SE, _net_18);
not inst37  (_net_19, D);
and inst38  (ENABLE_NOT_D_AND_SD_AND_SE_AND_SI, SD, _net_19, SE, SI);
not inst39  (_net_20, SD);
not inst40  (_net_21, SE);
not inst41  (_net_22, SI);
and inst42  (ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst43  (_net_23, SD);
not inst44  (_net_24, SE);
and inst45  (ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst46  (_net_25, SD);
not inst47  (_net_26, SI);
and inst48  (ENABLE_D_AND_NOT_SD_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst49  (_net_27, SD);
and inst50  (ENABLE_D_AND_NOT_SD_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst51  (_net_28, SE);
not inst52  (_net_29, SI);
and inst53  (ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI, SD, D, _net_28, _net_29);
not inst54  (_net_30, SE);
and inst55  (ENABLE_D_AND_SD_AND_NOT_SE_AND_SI, SD, D, _net_30, SI);
not inst56  (_net_31, SI);
and inst57  (ENABLE_D_AND_SD_AND_SE_AND_NOT_SI, SD, D, SE, _net_31);
and inst58  (ENABLE_D_AND_SD_AND_SE_AND_SI, SD, D, SE, SI);
not inst59  (_net_32, SE);
not inst60  (_net_33, SI);
and inst61  (ENABLE_SD_AND_NOT_SE_AND_NOT_SI, _net_32, SD, _net_33);
not inst62  (_net_34, SE);
and inst63  (ENABLE_SD_AND_NOT_SE_AND_SI, _net_34, SD, SI);
not inst64  (_net_35, SE);
not inst65  (_net_36, D);
not inst66  (_net_37, SI);
and inst67  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_35, _net_36, _net_37);
not inst68  (_net_38, SE);
not inst69  (_net_39, D);
and inst70  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_38, _net_39, SI);
not inst71  (_net_40, SD);
not inst72  (_net_41, D);
not inst73  (_net_42, SI);
and inst74  (ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SI, _net_40, _net_41, _net_42);
not inst75  (_net_43, D);
and inst76  (ENABLE_NOT_D_AND_SD_AND_SI, SD, _net_43, SI);
not inst77  (_net_44, SD);
not inst78  (_net_45, SI);
and inst79  (ENABLE_D_AND_NOT_SD_AND_NOT_SI, _net_44, D, _net_45);
not inst80  (_net_46, SI);
and inst81  (ENABLE_D_AND_SD_AND_NOT_SI, SD, D, _net_46);
not inst82  (_net_47, SD);
not inst83  (_net_48, D);
and inst84  (ENABLE_NOT_D_AND_NOT_SD_AND_SE, _net_47, _net_48, SE);
not inst85  (_net_49, D);
and inst86  (ENABLE_NOT_D_AND_SD_AND_SE, SD, _net_49, SE);
not inst87  (_net_50, SD);
and inst88  (ENABLE_D_AND_NOT_SD_AND_SE, _net_50, D, SE);
and inst89  (ENABLE_D_AND_SD_AND_SE, SD, D, SE);

specify
if (D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b0 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SD_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_SD_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_SD_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , negedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , posedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , negedge SD &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SD);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SD_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_SD_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SD_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SD_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , posedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SD_AND_SE , negedge SI &&& ENABLE_D_AND_SD_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif   
endmodule
`endcelldefine

//%END HDBSVT11_FSDPSYNSBQ_V2Y2_4

//%BEGIN HDBSVT11_FSDP_CBV2Y2_1

`celldefine
module HDBSVT11_FSDP_CBV2Y2_1 (Q, QN, CK, D, SI, SE);
   output Q, QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);
`ifdef VIRL_functiononly
   buf  #`SNPS_SEQ_DELAY  inst7 (Q, int_res_iq);
   not  #`SNPS_SEQ_DELAY  inst8 (QN, int_res_iq);
`else
   buf inst9  (Q, int_res_iq);
   not inst10  (QN, int_res_iq);
`endif
`ifdef VIRL_functiononly
`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst11  (_net_0, SE);
not inst12  (_net_1, D);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, D);
and inst17  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, D);
not inst19  (_net_6, SI);
and inst20  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst21  (_net_7, D);
and inst22  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst26  (_net_10, SE);
and inst27  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst28  (_net_11, SI);
and inst29  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst30  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst31  (ENABLE_NOT_SE, SE);
not inst32  (_net_12, D);
and inst33  (ENABLE_NOT_D_AND_SI, SI, _net_12);
not inst34  (_net_13, SI);
and inst35  (ENABLE_D_AND_NOT_SI, _net_13, D);
not inst36  (_net_14, D);
and inst37  (ENABLE_NOT_D_AND_SE, SE, _net_14);
and inst38  (ENABLE_D_AND_SE, SE, D);

specify
(posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE , posedge D &&& ENABLE_NOT_SE , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE , negedge D &&& ENABLE_NOT_SE , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
`endif
endmodule
`endcelldefine

//%END HDBSVT11_FSDP_CBV2Y2_1

//%BEGIN HDBSVT11_FSDP_V2Y2_1

`celldefine
module HDBSVT11_FSDP_V2Y2_1 (Q, QN, CK, D, SI, SE);
   output Q, QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);
`ifdef VIRL_functiononly
   buf  #`SNPS_SEQ_DELAY  inst7 (Q, int_res_iq);
   not  #`SNPS_SEQ_DELAY  inst8 (QN, int_res_iq);
`else
   buf inst9  (Q, int_res_iq);
   not inst10  (QN, int_res_iq);
`endif
`ifdef VIRL_functiononly
`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst11  (_net_0, SE);
not inst12  (_net_1, D);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, D);
and inst17  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, D);
not inst19  (_net_6, SI);
and inst20  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst21  (_net_7, D);
and inst22  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst26  (_net_10, SE);
and inst27  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst28  (_net_11, SI);
and inst29  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst30  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst31  (ENABLE_NOT_SE, SE);
not inst32  (_net_12, D);
and inst33  (ENABLE_NOT_D_AND_SI, SI, _net_12);
not inst34  (_net_13, SI);
and inst35  (ENABLE_D_AND_NOT_SI, _net_13, D);
not inst36  (_net_14, D);
and inst37  (ENABLE_NOT_D_AND_SE, SE, _net_14);
and inst38  (ENABLE_D_AND_SE, SE, D);

specify
(posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE , posedge D &&& ENABLE_NOT_SE , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE , negedge D &&& ENABLE_NOT_SE , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
`endif
endmodule
`endcelldefine

//%END HDBSVT11_FSDP_V2Y2_1

//%BEGIN HDBSVT11_FSDP_V2Y2_2

`celldefine
module HDBSVT11_FSDP_V2Y2_2 (Q, QN, CK, D, SI, SE);
   output Q, QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);
`ifdef VIRL_functiononly
   buf  #`SNPS_SEQ_DELAY  inst7 (Q, int_res_iq);
   not  #`SNPS_SEQ_DELAY  inst8 (QN, int_res_iq);
`else
   buf inst9  (Q, int_res_iq);
   not inst10  (QN, int_res_iq);
`endif
`ifdef VIRL_functiononly
`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst11  (_net_0, SE);
not inst12  (_net_1, D);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, D);
and inst17  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, D);
not inst19  (_net_6, SI);
and inst20  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst21  (_net_7, D);
and inst22  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst26  (_net_10, SE);
and inst27  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst28  (_net_11, SI);
and inst29  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst30  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst31  (ENABLE_NOT_SE, SE);
not inst32  (_net_12, D);
and inst33  (ENABLE_NOT_D_AND_SI, SI, _net_12);
not inst34  (_net_13, SI);
and inst35  (ENABLE_D_AND_NOT_SI, _net_13, D);
not inst36  (_net_14, D);
and inst37  (ENABLE_NOT_D_AND_SE, SE, _net_14);
and inst38  (ENABLE_D_AND_SE, SE, D);

specify
(posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE , posedge D &&& ENABLE_NOT_SE , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE , negedge D &&& ENABLE_NOT_SE , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
`endif
endmodule
`endcelldefine

//%END HDBSVT11_FSDP_V2Y2_2

//%BEGIN HDBSVT11_FSDP_V2Y2_4

`celldefine
module HDBSVT11_FSDP_V2Y2_4 (Q, QN, CK, D, SI, SE);
   output Q, QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);
`ifdef VIRL_functiononly
   buf  #`SNPS_SEQ_DELAY  inst7 (Q, int_res_iq);
   not  #`SNPS_SEQ_DELAY  inst8 (QN, int_res_iq);
`else
   buf inst9  (Q, int_res_iq);
   not inst10  (QN, int_res_iq);
`endif
`ifdef VIRL_functiononly
`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst11  (_net_0, SE);
not inst12  (_net_1, D);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, D);
and inst17  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, D);
not inst19  (_net_6, SI);
and inst20  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst21  (_net_7, D);
and inst22  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst26  (_net_10, SE);
and inst27  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst28  (_net_11, SI);
and inst29  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst30  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst31  (ENABLE_NOT_SE, SE);
not inst32  (_net_12, D);
and inst33  (ENABLE_NOT_D_AND_SI, SI, _net_12);
not inst34  (_net_13, SI);
and inst35  (ENABLE_D_AND_NOT_SI, _net_13, D);
not inst36  (_net_14, D);
and inst37  (ENABLE_NOT_D_AND_SE, SE, _net_14);
and inst38  (ENABLE_D_AND_SE, SE, D);

specify
(posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE , posedge D &&& ENABLE_NOT_SE , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE , negedge D &&& ENABLE_NOT_SE , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
`endif
endmodule
`endcelldefine

//%END HDBSVT11_FSDP_V2Y2_4

//%BEGIN HDBSVT11_INV_1

`celldefine
module HDBSVT11_INV_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_1

//%BEGIN HDBSVT11_INV_10

`celldefine
module HDBSVT11_INV_10 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_10

//%BEGIN HDBSVT11_INV_12

`celldefine
module HDBSVT11_INV_12 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_12

//%BEGIN HDBSVT11_INV_16

`celldefine
module HDBSVT11_INV_16 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_16

//%BEGIN HDBSVT11_INV_2

`celldefine
module HDBSVT11_INV_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_2

//%BEGIN HDBSVT11_INV_20

`celldefine
module HDBSVT11_INV_20 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_20

//%BEGIN HDBSVT11_INV_3

`celldefine
module HDBSVT11_INV_3 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_3

//%BEGIN HDBSVT11_INV_4

`celldefine
module HDBSVT11_INV_4 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_4

//%BEGIN HDBSVT11_INV_6

`celldefine
module HDBSVT11_INV_6 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_6

//%BEGIN HDBSVT11_INV_8

`celldefine
module HDBSVT11_INV_8 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_8

//%BEGIN HDBSVT11_INV_CBCK_1
`celldefine
module HDBSVT11_INV_CBCK_1 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CBCK_1

//%BEGIN HDBSVT11_INV_CBECOM2FS_3

`celldefine
module HDBSVT11_INV_CBECOM2FS_3 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_CBECOM2FS_3

//%BEGIN HDBSVT11_INV_CBECOM2_3

`celldefine
module HDBSVT11_INV_CBECOM2_3 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_CBECOM2_3

//%BEGIN HDBSVT11_INV_CBECO_1

`celldefine
module HDBSVT11_INV_CBECO_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_CBECO_1

//%BEGIN HDBSVT11_INV_CBECO_2

`celldefine
module HDBSVT11_INV_CBECO_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_CBECO_2

//%BEGIN HDBSVT11_INV_CBY2ECO_3

`celldefine
module HDBSVT11_INV_CBY2ECO_3 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_CBY2ECO_3

//%BEGIN HDBSVT11_INV_CBY2ECO_4

`celldefine
module HDBSVT11_INV_CBY2ECO_4 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_CBY2ECO_4

//%BEGIN HDBSVT11_INV_CBY2_8

`celldefine
module HDBSVT11_INV_CBY2_8 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_CBY2_8

//%BEGIN HDBSVT11_INV_CBY3ECO_6

`celldefine
module HDBSVT11_INV_CBY3ECO_6 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_CBY3ECO_6

//%BEGIN HDBSVT11_INV_CBY4ECO_8

`celldefine
module HDBSVT11_INV_CBY4ECO_8 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_CBY4ECO_8

//%BEGIN HDBSVT11_INV_CB_1

`celldefine
module HDBSVT11_INV_CB_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_CB_1

//%BEGIN HDBSVT11_INV_CB_2

`celldefine
module HDBSVT11_INV_CB_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_CB_2

//%BEGIN HDBSVT11_INV_CB_4

`celldefine
module HDBSVT11_INV_CB_4 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_CB_4

//%BEGIN HDBSVT11_INV_CB_6

`celldefine
module HDBSVT11_INV_CB_6 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_CB_6

//%BEGIN HDBSVT11_INV_CB_8

`celldefine
module HDBSVT11_INV_CB_8 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_CB_8

//%BEGIN HDBSVT11_INV_CKST_0P5
`celldefine
module HDBSVT11_INV_CKST_0P5 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CKST_0P5

//%BEGIN HDBSVT11_INV_CKST_1P5
`celldefine
module HDBSVT11_INV_CKST_1P5 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CKST_1P5

//%BEGIN HDBSVT11_INV_CKST_2P5
`celldefine
module HDBSVT11_INV_CKST_2P5 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CKST_2P5

//%BEGIN HDBSVT11_INV_CKY2_10
`celldefine
module HDBSVT11_INV_CKY2_10 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CKY2_10

//%BEGIN HDBSVT11_INV_CKY2_12
`celldefine
module HDBSVT11_INV_CKY2_12 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CKY2_12

//%BEGIN HDBSVT11_INV_CKY2_16
`celldefine
module HDBSVT11_INV_CKY2_16 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CKY2_16

//%BEGIN HDBSVT11_INV_CKY2_20
`celldefine
module HDBSVT11_INV_CKY2_20 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CKY2_20

//%BEGIN HDBSVT11_INV_CKY4_16
`celldefine
module HDBSVT11_INV_CKY4_16 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CKY4_16

//%BEGIN HDBSVT11_INV_CKY4_20
`celldefine
module HDBSVT11_INV_CKY4_20 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CKY4_20

//%BEGIN HDBSVT11_INV_CK_1
`celldefine
module HDBSVT11_INV_CK_1 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CK_1

//%BEGIN HDBSVT11_INV_CK_10
`celldefine
module HDBSVT11_INV_CK_10 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CK_10

//%BEGIN HDBSVT11_INV_CK_12
`celldefine
module HDBSVT11_INV_CK_12 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CK_12

//%BEGIN HDBSVT11_INV_CK_16
`celldefine
module HDBSVT11_INV_CK_16 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CK_16

//%BEGIN HDBSVT11_INV_CK_2
`celldefine
module HDBSVT11_INV_CK_2 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CK_2

//%BEGIN HDBSVT11_INV_CK_3
`celldefine
module HDBSVT11_INV_CK_3 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CK_3

//%BEGIN HDBSVT11_INV_CK_4
`celldefine
module HDBSVT11_INV_CK_4 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CK_4

//%BEGIN HDBSVT11_INV_CK_5
`celldefine
module HDBSVT11_INV_CK_5 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CK_5

//%BEGIN HDBSVT11_INV_CK_6
`celldefine
module HDBSVT11_INV_CK_6 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CK_6

//%BEGIN HDBSVT11_INV_CK_7
`celldefine
module HDBSVT11_INV_CK_7 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CK_7

//%BEGIN HDBSVT11_INV_CK_8
`celldefine
module HDBSVT11_INV_CK_8 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CK_8

//%BEGIN HDBSVT11_INV_CK_9
`celldefine
module HDBSVT11_INV_CK_9 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_CK_9

//%BEGIN HDBSVT11_INV_ECOM2FS_3

`celldefine
module HDBSVT11_INV_ECOM2FS_3 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_ECOM2FS_3

//%BEGIN HDBSVT11_INV_ECOM2FS_6

`celldefine
module HDBSVT11_INV_ECOM2FS_6 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_ECOM2FS_6

//%BEGIN HDBSVT11_INV_ECOM2_3

`celldefine
module HDBSVT11_INV_ECOM2_3 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_ECOM2_3

//%BEGIN HDBSVT11_INV_ECOM2_6

`celldefine
module HDBSVT11_INV_ECOM2_6 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_ECOM2_6

//%BEGIN HDBSVT11_INV_ECO_1

`celldefine
module HDBSVT11_INV_ECO_1 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_ECO_1

//%BEGIN HDBSVT11_INV_ECO_2

`celldefine
module HDBSVT11_INV_ECO_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_ECO_2

//%BEGIN HDBSVT11_INV_M12Y4_8
`celldefine
module HDBSVT11_INV_M12Y4_8 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_COMBO_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_M12Y4_8

//%BEGIN HDBSVT11_INV_MINN_2

`celldefine
module HDBSVT11_INV_MINN_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_MINN_2

//%BEGIN HDBSVT11_INV_MINP_2

`celldefine
module HDBSVT11_INV_MINP_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_MINP_2

//%BEGIN HDBSVT11_INV_RCK_2
`celldefine
module HDBSVT11_INV_RCK_2 (Z, CLK);
  input CLK;
  output Z;
  wire int_0;


    not inst0  (int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
(CLK -=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_INV_RCK_2

//%BEGIN HDBSVT11_INV_SKFY2_12

`celldefine
module HDBSVT11_INV_SKFY2_12 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_SKFY2_12

//%BEGIN HDBSVT11_INV_SKF_2

`celldefine
module HDBSVT11_INV_SKF_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_SKF_2

//%BEGIN HDBSVT11_INV_SKF_4

`celldefine
module HDBSVT11_INV_SKF_4 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_SKF_4

//%BEGIN HDBSVT11_INV_SKF_8

`celldefine
module HDBSVT11_INV_SKF_8 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_SKF_8

//%BEGIN HDBSVT11_INV_SKRY2_12

`celldefine
module HDBSVT11_INV_SKRY2_12 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_SKRY2_12

//%BEGIN HDBSVT11_INV_SKR_2

`celldefine
module HDBSVT11_INV_SKR_2 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_SKR_2

//%BEGIN HDBSVT11_INV_SKR_4

`celldefine
module HDBSVT11_INV_SKR_4 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_SKR_4

//%BEGIN HDBSVT11_INV_SKR_8

`celldefine
module HDBSVT11_INV_SKR_8 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_SKR_8

//%BEGIN HDBSVT11_INV_Y2ECO_3

`celldefine
module HDBSVT11_INV_Y2ECO_3 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y2ECO_3

//%BEGIN HDBSVT11_INV_Y2ECO_4

`celldefine
module HDBSVT11_INV_Y2ECO_4 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y2ECO_4

//%BEGIN HDBSVT11_INV_Y2_10

`celldefine
module HDBSVT11_INV_Y2_10 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y2_10

//%BEGIN HDBSVT11_INV_Y2_12

`celldefine
module HDBSVT11_INV_Y2_12 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y2_12

//%BEGIN HDBSVT11_INV_Y2_16

`celldefine
module HDBSVT11_INV_Y2_16 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y2_16

//%BEGIN HDBSVT11_INV_Y2_20

`celldefine
module HDBSVT11_INV_Y2_20 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y2_20

//%BEGIN HDBSVT11_INV_Y2_32

`celldefine
module HDBSVT11_INV_Y2_32 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y2_32

//%BEGIN HDBSVT11_INV_Y2_48

`celldefine
module HDBSVT11_INV_Y2_48 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y2_48

//%BEGIN HDBSVT11_INV_Y2_6

`celldefine
module HDBSVT11_INV_Y2_6 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y2_6

//%BEGIN HDBSVT11_INV_Y2_64

`celldefine
module HDBSVT11_INV_Y2_64 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y2_64

//%BEGIN HDBSVT11_INV_Y2_8

`celldefine
module HDBSVT11_INV_Y2_8 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y2_8

//%BEGIN HDBSVT11_INV_Y3ECO_6

`celldefine
module HDBSVT11_INV_Y3ECO_6 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y3ECO_6

//%BEGIN HDBSVT11_INV_Y4ECO_8

`celldefine
module HDBSVT11_INV_Y4ECO_8 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y4ECO_8

//%BEGIN HDBSVT11_INV_Y4_16

`celldefine
module HDBSVT11_INV_Y4_16 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y4_16

//%BEGIN HDBSVT11_INV_Y4_20

`celldefine
module HDBSVT11_INV_Y4_20 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y4_20

//%BEGIN HDBSVT11_INV_Y4_32

`celldefine
module HDBSVT11_INV_Y4_32 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y4_32

//%BEGIN HDBSVT11_INV_Y4_48

`celldefine
module HDBSVT11_INV_Y4_48 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y4_48

//%BEGIN HDBSVT11_INV_Y4_64

`celldefine
module HDBSVT11_INV_Y4_64 (X, A);
   output X;
   input A;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst0 (X, A);
    `else
        not inst1  (X, A);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
(A -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine
//
//%END HDBSVT11_INV_Y4_64

`celldefine
module HDBSVT11_LDAO21NQ_V2Y2_1 (Q, G, TEN, EN, SEN);
  input G, TEN, EN, SEN;
  output Q;
  reg viol_0;
     wire viol_x;
  wire int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_G, G);
    buf inst1  (delayed_TEN, TEN);
    buf inst2  (delayed_EN, EN);
    buf inst3  (delayed_SEN, SEN);
  `endif


    and inst4  (int_4, delayed_TEN, delayed_EN);
    or inst5  (int_5, int_4, delayed_SEN);
    not inst6  (int_6, delayed_G);
    snps_latch inst7  (iq, viol_x, int_6, int_5);
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst8  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst9 (Q, iq);
  `else
    buf inst10  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SEN);
and inst12  (ENABLE_NOT_SEN_AND_TEN, TEN, _net_0);
not inst13  (_net_1, SEN);
not inst14  (_net_2, EN);
not inst15  (_net_3, TEN);
and inst16  (ENABLE_NOT_EN_AND_NOT_SEN_AND_NOT_TEN, _net_1, _net_2, _net_3);
not inst17  (_net_4, SEN);
not inst18  (_net_5, EN);
and inst19  (ENABLE_NOT_EN_AND_NOT_SEN_AND_TEN, _net_4, _net_5, TEN);
not inst20  (_net_6, EN);
not inst21  (_net_7, TEN);
and inst22  (ENABLE_NOT_EN_AND_SEN_AND_NOT_TEN, SEN, _net_6, _net_7);
not inst23  (_net_8, EN);
and inst24  (ENABLE_NOT_EN_AND_SEN_AND_TEN, SEN, _net_8, TEN);
not inst25  (_net_9, SEN);
not inst26  (_net_10, TEN);
and inst27  (ENABLE_EN_AND_NOT_SEN_AND_NOT_TEN, _net_9, EN, _net_10);
not inst28  (_net_11, SEN);
and inst29  (ENABLE_EN_AND_NOT_SEN_AND_TEN, _net_11, EN, TEN);
not inst30  (_net_12, TEN);
and inst31  (ENABLE_EN_AND_SEN_AND_NOT_TEN, SEN, EN, _net_12);
and inst32  (ENABLE_EN_AND_SEN_AND_TEN, SEN, EN, TEN);
not inst33  (_net_13, TEN);
not inst34  (_net_14, EN);
and inst35  (ENABLE_NOT_EN_AND_NOT_TEN, _net_13, _net_14);
not inst36  (_net_15, EN);
and inst37  (ENABLE_NOT_EN_AND_TEN, TEN, _net_15);
not inst38  (_net_16, TEN);
and inst39  (ENABLE_EN_AND_NOT_TEN, _net_16, EN);
not inst40  (_net_17, SEN);
and inst41  (ENABLE_EN_AND_NOT_SEN, _net_17, EN);

specify
if (G==1'b0 && SEN==1'b0 && TEN==1'b1) (EN +=> Q)=(0, 0);
ifnone (EN +=> Q)=(0, 0);
if (EN==1'b0 && SEN==1'b1 && TEN==1'b0) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b0 && SEN==1'b1 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && SEN==1'b0 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && SEN==1'b1 && TEN==1'b0) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && SEN==1'b1 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b0 && SEN==1'b0 && TEN==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
if (EN==1'b0 && SEN==1'b0 && TEN==1'b1) (negedge G => (Q +: 1'b1))=(0, 0);
if (EN==1'b1 && SEN==1'b0 && TEN==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
if (EN==1'b0 && G==1'b0 && TEN==1'b0) (SEN +=> Q)=(0, 0);
if (EN==1'b0 && G==1'b0 && TEN==1'b1) (SEN +=> Q)=(0, 0);
if (EN==1'b1 && G==1'b0 && TEN==1'b0) (SEN +=> Q)=(0, 0);
ifnone (SEN +=> Q)=(0, 0);
if (EN==1'b1 && G==1'b0 && SEN==1'b0) (TEN +=> Q)=(0, 0);
ifnone (TEN +=> Q)=(0, 0);
$setuphold(posedge G &&& ENABLE_NOT_SEN_AND_TEN , posedge EN &&& ENABLE_NOT_SEN_AND_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$setuphold(posedge G &&& ENABLE_NOT_SEN_AND_TEN , negedge EN &&& ENABLE_NOT_SEN_AND_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$width(negedge G &&& ENABLE_NOT_EN_AND_NOT_SEN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_EN_AND_NOT_SEN_AND_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_EN_AND_SEN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_EN_AND_SEN_AND_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_NOT_SEN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_NOT_SEN_AND_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_SEN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_SEN_AND_TEN , 0 ,0, viol_0);
$setuphold(posedge G &&& ENABLE_NOT_EN_AND_NOT_TEN , posedge SEN &&& ENABLE_NOT_EN_AND_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_NOT_EN_AND_NOT_TEN , negedge SEN &&& ENABLE_NOT_EN_AND_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_NOT_EN_AND_TEN , posedge SEN &&& ENABLE_NOT_EN_AND_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_NOT_EN_AND_TEN , negedge SEN &&& ENABLE_NOT_EN_AND_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_EN_AND_NOT_TEN , posedge SEN &&& ENABLE_EN_AND_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_EN_AND_NOT_TEN , negedge SEN &&& ENABLE_EN_AND_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_EN_AND_NOT_SEN , posedge TEN &&& ENABLE_EN_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
$setuphold(posedge G &&& ENABLE_EN_AND_NOT_SEN , negedge TEN &&& ENABLE_EN_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
endspecify
  `endif
endmodule
`endcelldefine


`celldefine
module HDBSVT11_LDAO21NQ_V2Y2_2 (Q, G, TEN, EN, SEN);
  input G, TEN, EN, SEN;
  output Q;
  reg viol_0;
     wire viol_x;
  wire int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_G, G);
    buf inst1  (delayed_TEN, TEN);
    buf inst2  (delayed_EN, EN);
    buf inst3  (delayed_SEN, SEN);
  `endif


    and inst4  (int_4, delayed_TEN, delayed_EN);
    or inst5  (int_5, int_4, delayed_SEN);
    not inst6  (int_6, delayed_G);
    snps_latch inst7  (iq, viol_x, int_6, int_5);
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst8  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst9 (Q, iq);
  `else
    buf inst10  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SEN);
and inst12  (ENABLE_NOT_SEN_AND_TEN, TEN, _net_0);
not inst13  (_net_1, SEN);
not inst14  (_net_2, EN);
not inst15  (_net_3, TEN);
and inst16  (ENABLE_NOT_EN_AND_NOT_SEN_AND_NOT_TEN, _net_1, _net_2, _net_3);
not inst17  (_net_4, SEN);
not inst18  (_net_5, EN);
and inst19  (ENABLE_NOT_EN_AND_NOT_SEN_AND_TEN, _net_4, _net_5, TEN);
not inst20  (_net_6, EN);
not inst21  (_net_7, TEN);
and inst22  (ENABLE_NOT_EN_AND_SEN_AND_NOT_TEN, SEN, _net_6, _net_7);
not inst23  (_net_8, EN);
and inst24  (ENABLE_NOT_EN_AND_SEN_AND_TEN, SEN, _net_8, TEN);
not inst25  (_net_9, SEN);
not inst26  (_net_10, TEN);
and inst27  (ENABLE_EN_AND_NOT_SEN_AND_NOT_TEN, _net_9, EN, _net_10);
not inst28  (_net_11, SEN);
and inst29  (ENABLE_EN_AND_NOT_SEN_AND_TEN, _net_11, EN, TEN);
not inst30  (_net_12, TEN);
and inst31  (ENABLE_EN_AND_SEN_AND_NOT_TEN, SEN, EN, _net_12);
and inst32  (ENABLE_EN_AND_SEN_AND_TEN, SEN, EN, TEN);
not inst33  (_net_13, TEN);
not inst34  (_net_14, EN);
and inst35  (ENABLE_NOT_EN_AND_NOT_TEN, _net_13, _net_14);
not inst36  (_net_15, EN);
and inst37  (ENABLE_NOT_EN_AND_TEN, TEN, _net_15);
not inst38  (_net_16, TEN);
and inst39  (ENABLE_EN_AND_NOT_TEN, _net_16, EN);
not inst40  (_net_17, SEN);
and inst41  (ENABLE_EN_AND_NOT_SEN, _net_17, EN);

specify
if (G==1'b0 && SEN==1'b0 && TEN==1'b1) (EN +=> Q)=(0, 0);
ifnone (EN +=> Q)=(0, 0);
if (EN==1'b0 && SEN==1'b1 && TEN==1'b0) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b0 && SEN==1'b1 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && SEN==1'b0 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && SEN==1'b1 && TEN==1'b0) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && SEN==1'b1 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b0 && SEN==1'b0 && TEN==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
if (EN==1'b0 && SEN==1'b0 && TEN==1'b1) (negedge G => (Q +: 1'b1))=(0, 0);
if (EN==1'b1 && SEN==1'b0 && TEN==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
if (EN==1'b0 && G==1'b0 && TEN==1'b0) (SEN +=> Q)=(0, 0);
if (EN==1'b0 && G==1'b0 && TEN==1'b1) (SEN +=> Q)=(0, 0);
if (EN==1'b1 && G==1'b0 && TEN==1'b0) (SEN +=> Q)=(0, 0);
ifnone (SEN +=> Q)=(0, 0);
if (EN==1'b1 && G==1'b0 && SEN==1'b0) (TEN +=> Q)=(0, 0);
ifnone (TEN +=> Q)=(0, 0);
$setuphold(posedge G &&& ENABLE_NOT_SEN_AND_TEN , posedge EN &&& ENABLE_NOT_SEN_AND_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$setuphold(posedge G &&& ENABLE_NOT_SEN_AND_TEN , negedge EN &&& ENABLE_NOT_SEN_AND_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$width(negedge G &&& ENABLE_NOT_EN_AND_NOT_SEN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_EN_AND_NOT_SEN_AND_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_EN_AND_SEN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_EN_AND_SEN_AND_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_NOT_SEN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_NOT_SEN_AND_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_SEN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_SEN_AND_TEN , 0 ,0, viol_0);
$setuphold(posedge G &&& ENABLE_NOT_EN_AND_NOT_TEN , posedge SEN &&& ENABLE_NOT_EN_AND_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_NOT_EN_AND_NOT_TEN , negedge SEN &&& ENABLE_NOT_EN_AND_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_NOT_EN_AND_TEN , posedge SEN &&& ENABLE_NOT_EN_AND_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_NOT_EN_AND_TEN , negedge SEN &&& ENABLE_NOT_EN_AND_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_EN_AND_NOT_TEN , posedge SEN &&& ENABLE_EN_AND_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_EN_AND_NOT_TEN , negedge SEN &&& ENABLE_EN_AND_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_EN_AND_NOT_SEN , posedge TEN &&& ENABLE_EN_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
$setuphold(posedge G &&& ENABLE_EN_AND_NOT_SEN , negedge TEN &&& ENABLE_EN_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
endspecify
  `endif
endmodule
`endcelldefine


`celldefine
module HDBSVT11_LDAO21NQ_V2Y2_4 (Q, G, TEN, EN, SEN);
  input G, TEN, EN, SEN;
  output Q;
  reg viol_0;
     wire viol_x;
  wire int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_G, G);
    buf inst1  (delayed_TEN, TEN);
    buf inst2  (delayed_EN, EN);
    buf inst3  (delayed_SEN, SEN);
  `endif


    and inst4  (int_4, delayed_TEN, delayed_EN);
    or inst5  (int_5, int_4, delayed_SEN);
    not inst6  (int_6, delayed_G);
    snps_latch inst7  (iq, viol_x, int_6, int_5);
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst8  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst9 (Q, iq);
  `else
    buf inst10  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SEN);
and inst12  (ENABLE_NOT_SEN_AND_TEN, TEN, _net_0);
not inst13  (_net_1, SEN);
not inst14  (_net_2, EN);
not inst15  (_net_3, TEN);
and inst16  (ENABLE_NOT_EN_AND_NOT_SEN_AND_NOT_TEN, _net_1, _net_2, _net_3);
not inst17  (_net_4, SEN);
not inst18  (_net_5, EN);
and inst19  (ENABLE_NOT_EN_AND_NOT_SEN_AND_TEN, _net_4, _net_5, TEN);
not inst20  (_net_6, EN);
not inst21  (_net_7, TEN);
and inst22  (ENABLE_NOT_EN_AND_SEN_AND_NOT_TEN, SEN, _net_6, _net_7);
not inst23  (_net_8, EN);
and inst24  (ENABLE_NOT_EN_AND_SEN_AND_TEN, SEN, _net_8, TEN);
not inst25  (_net_9, SEN);
not inst26  (_net_10, TEN);
and inst27  (ENABLE_EN_AND_NOT_SEN_AND_NOT_TEN, _net_9, EN, _net_10);
not inst28  (_net_11, SEN);
and inst29  (ENABLE_EN_AND_NOT_SEN_AND_TEN, _net_11, EN, TEN);
not inst30  (_net_12, TEN);
and inst31  (ENABLE_EN_AND_SEN_AND_NOT_TEN, SEN, EN, _net_12);
and inst32  (ENABLE_EN_AND_SEN_AND_TEN, SEN, EN, TEN);
not inst33  (_net_13, TEN);
not inst34  (_net_14, EN);
and inst35  (ENABLE_NOT_EN_AND_NOT_TEN, _net_13, _net_14);
not inst36  (_net_15, EN);
and inst37  (ENABLE_NOT_EN_AND_TEN, TEN, _net_15);
not inst38  (_net_16, TEN);
and inst39  (ENABLE_EN_AND_NOT_TEN, _net_16, EN);
not inst40  (_net_17, SEN);
and inst41  (ENABLE_EN_AND_NOT_SEN, _net_17, EN);

specify
if (G==1'b0 && SEN==1'b0 && TEN==1'b1) (EN +=> Q)=(0, 0);
ifnone (EN +=> Q)=(0, 0);
if (EN==1'b0 && SEN==1'b1 && TEN==1'b0) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b0 && SEN==1'b1 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && SEN==1'b0 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && SEN==1'b1 && TEN==1'b0) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && SEN==1'b1 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b0 && SEN==1'b0 && TEN==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
if (EN==1'b0 && SEN==1'b0 && TEN==1'b1) (negedge G => (Q +: 1'b1))=(0, 0);
if (EN==1'b1 && SEN==1'b0 && TEN==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
if (EN==1'b0 && G==1'b0 && TEN==1'b0) (SEN +=> Q)=(0, 0);
if (EN==1'b0 && G==1'b0 && TEN==1'b1) (SEN +=> Q)=(0, 0);
if (EN==1'b1 && G==1'b0 && TEN==1'b0) (SEN +=> Q)=(0, 0);
ifnone (SEN +=> Q)=(0, 0);
if (EN==1'b1 && G==1'b0 && SEN==1'b0) (TEN +=> Q)=(0, 0);
ifnone (TEN +=> Q)=(0, 0);
$setuphold(posedge G &&& ENABLE_NOT_SEN_AND_TEN , posedge EN &&& ENABLE_NOT_SEN_AND_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$setuphold(posedge G &&& ENABLE_NOT_SEN_AND_TEN , negedge EN &&& ENABLE_NOT_SEN_AND_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$width(negedge G &&& ENABLE_NOT_EN_AND_NOT_SEN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_EN_AND_NOT_SEN_AND_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_EN_AND_SEN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_EN_AND_SEN_AND_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_NOT_SEN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_NOT_SEN_AND_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_SEN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_SEN_AND_TEN , 0 ,0, viol_0);
$setuphold(posedge G &&& ENABLE_NOT_EN_AND_NOT_TEN , posedge SEN &&& ENABLE_NOT_EN_AND_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_NOT_EN_AND_NOT_TEN , negedge SEN &&& ENABLE_NOT_EN_AND_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_NOT_EN_AND_TEN , posedge SEN &&& ENABLE_NOT_EN_AND_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_NOT_EN_AND_TEN , negedge SEN &&& ENABLE_NOT_EN_AND_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_EN_AND_NOT_TEN , posedge SEN &&& ENABLE_EN_AND_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_EN_AND_NOT_TEN , negedge SEN &&& ENABLE_EN_AND_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_SEN);
$setuphold(posedge G &&& ENABLE_EN_AND_NOT_SEN , posedge TEN &&& ENABLE_EN_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
$setuphold(posedge G &&& ENABLE_EN_AND_NOT_SEN , negedge TEN &&& ENABLE_EN_AND_NOT_SEN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
endspecify
  `endif
endmodule
`endcelldefine


//%BEGIN HDBSVT11_LDAO22NQ_V2Y2_4
`celldefine
module HDBSVT11_LDAO22NQ_V2Y2_4 (Q, G, A1, A2, B1, B2);
  input G, A1, A2, B1, B2;
  output Q;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, int_7, iq;
  `ifdef _fv
    buf inst0  (delayed_G, G);
    buf inst1  (delayed_A1, A1);
    buf inst2  (delayed_A2, A2);
    buf inst3  (delayed_B1, B1);
    buf inst4  (delayed_B2, B2);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst5  (viol_x, viol_0, int_7, 1'b1, 1'b1);

  `endif
    and inst6  (int_4, delayed_B1, delayed_B2);
    and inst7  (int_5, delayed_A1, delayed_A2);
    or inst8  (int_6, int_5, int_4);
    not inst9  (int_7, delayed_G);
    snps_latch inst10  (iq, viol_x, int_7, int_6);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst11 (Q, iq);
  `else
    buf inst12  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst13  (_net_0, B1);
not inst14  (_net_1, B2);
and inst15  (ENABLE_A2_AND_NOT_B1_AND_NOT_B2, _net_0, A2, _net_1);
not inst16  (_net_2, B1);
and inst17  (ENABLE_A2_AND_NOT_B1_AND_B2, _net_2, A2, B2);
not inst18  (_net_3, B2);
and inst19  (ENABLE_A2_AND_B1_AND_NOT_B2, B1, A2, _net_3);
not inst20  (_net_4, B1);
not inst21  (_net_5, B2);
and inst22  (ENABLE_A1_AND_NOT_B1_AND_NOT_B2, _net_4, A1, _net_5);
not inst23  (_net_6, B1);
and inst24  (ENABLE_A1_AND_NOT_B1_AND_B2, _net_6, A1, B2);
not inst25  (_net_7, B2);
and inst26  (ENABLE_A1_AND_B1_AND_NOT_B2, B1, A1, _net_7);
not inst27  (_net_8, A2);
not inst28  (_net_9, A1);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_B2, _net_8, _net_9, B2);
not inst30  (_net_10, A1);
and inst31  (ENABLE_NOT_A1_AND_A2_AND_B2, A2, _net_10, B2);
not inst32  (_net_11, A2);
and inst33  (ENABLE_A1_AND_NOT_A2_AND_B2, _net_11, A1, B2);
not inst34  (_net_12, A2);
not inst35  (_net_13, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_B1, _net_12, _net_13, B1);
not inst37  (_net_14, A1);
and inst38  (ENABLE_NOT_A1_AND_A2_AND_B1, A2, _net_14, B1);
not inst39  (_net_15, A2);
and inst40  (ENABLE_A1_AND_NOT_A2_AND_B1, _net_15, A1, B1);
not inst41  (_net_16, A2);
not inst42  (_net_17, A1);
not inst43  (_net_18, B1);
not inst44  (_net_19, B2);
and inst45  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_B1_AND_NOT_B2, _net_16, _net_17, _net_18, _net_19);
not inst46  (_net_20, A2);
not inst47  (_net_21, A1);
not inst48  (_net_22, B1);
and inst49  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_B1_AND_B2, _net_20, _net_21, _net_22, B2);
not inst50  (_net_23, A2);
not inst51  (_net_24, A1);
not inst52  (_net_25, B2);
and inst53  (ENABLE_NOT_A1_AND_NOT_A2_AND_B1_AND_NOT_B2, _net_23, _net_24, B1, _net_25);
not inst54  (_net_26, A2);
not inst55  (_net_27, A1);
and inst56  (ENABLE_NOT_A1_AND_NOT_A2_AND_B1_AND_B2, _net_26, _net_27, B1, B2);
not inst57  (_net_28, A1);
not inst58  (_net_29, B1);
not inst59  (_net_30, B2);
and inst60  (ENABLE_NOT_A1_AND_A2_AND_NOT_B1_AND_NOT_B2, A2, _net_28, _net_29, _net_30);
not inst61  (_net_31, A1);
not inst62  (_net_32, B1);
and inst63  (ENABLE_NOT_A1_AND_A2_AND_NOT_B1_AND_B2, A2, _net_31, _net_32, B2);
not inst64  (_net_33, A1);
not inst65  (_net_34, B2);
and inst66  (ENABLE_NOT_A1_AND_A2_AND_B1_AND_NOT_B2, A2, _net_33, B1, _net_34);
not inst67  (_net_35, A1);
and inst68  (ENABLE_NOT_A1_AND_A2_AND_B1_AND_B2, A2, _net_35, B1, B2);
not inst69  (_net_36, A2);
not inst70  (_net_37, B1);
not inst71  (_net_38, B2);
and inst72  (ENABLE_A1_AND_NOT_A2_AND_NOT_B1_AND_NOT_B2, _net_36, A1, _net_37, _net_38);
not inst73  (_net_39, A2);
not inst74  (_net_40, B1);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_NOT_B1_AND_B2, _net_39, A1, _net_40, B2);
not inst76  (_net_41, A2);
not inst77  (_net_42, B2);
and inst78  (ENABLE_A1_AND_NOT_A2_AND_B1_AND_NOT_B2, _net_41, A1, B1, _net_42);
not inst79  (_net_43, A2);
and inst80  (ENABLE_A1_AND_NOT_A2_AND_B1_AND_B2, _net_43, A1, B1, B2);
not inst81  (_net_44, B1);
not inst82  (_net_45, B2);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_B1_AND_NOT_B2, A2, A1, _net_44, _net_45);
not inst84  (_net_46, B1);
and inst85  (ENABLE_A1_AND_A2_AND_NOT_B1_AND_B2, A2, A1, _net_46, B2);
not inst86  (_net_47, B2);
and inst87  (ENABLE_A1_AND_A2_AND_B1_AND_NOT_B2, A2, A1, B1, _net_47);
and inst88  (ENABLE_A1_AND_A2_AND_B1_AND_B2, A2, A1, B1, B2);

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && G==1'b0) (A1 +=> Q)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && G==1'b0) (A1 +=> Q)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && G==1'b0) (A1 +=> Q)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && G==1'b0) (A2 +=> Q)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && G==1'b0) (A2 +=> Q)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && G==1'b0) (A2 +=> Q)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && G==1'b0) (B1 +=> Q)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && G==1'b0) (B1 +=> Q)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && G==1'b0) (B1 +=> Q)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && G==1'b0) (B2 +=> Q)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && G==1'b0) (B2 +=> Q)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && G==1'b0) (B2 +=> Q)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0) (negedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (negedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (negedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (negedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (negedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
$setuphold(posedge G &&& ENABLE_A2_AND_NOT_B1_AND_NOT_B2 , posedge A1 &&& ENABLE_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(posedge G &&& ENABLE_A2_AND_NOT_B1_AND_NOT_B2 , negedge A1 &&& ENABLE_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(posedge G &&& ENABLE_A2_AND_NOT_B1_AND_B2 , posedge A1 &&& ENABLE_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(posedge G &&& ENABLE_A2_AND_NOT_B1_AND_B2 , negedge A1 &&& ENABLE_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(posedge G &&& ENABLE_A2_AND_B1_AND_NOT_B2 , posedge A1 &&& ENABLE_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(posedge G &&& ENABLE_A2_AND_B1_AND_NOT_B2 , negedge A1 &&& ENABLE_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(posedge G &&& ENABLE_A1_AND_NOT_B1_AND_NOT_B2 , posedge A2 &&& ENABLE_A1_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(posedge G &&& ENABLE_A1_AND_NOT_B1_AND_NOT_B2 , negedge A2 &&& ENABLE_A1_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(posedge G &&& ENABLE_A1_AND_NOT_B1_AND_B2 , posedge A2 &&& ENABLE_A1_AND_NOT_B1_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(posedge G &&& ENABLE_A1_AND_NOT_B1_AND_B2 , negedge A2 &&& ENABLE_A1_AND_NOT_B1_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(posedge G &&& ENABLE_A1_AND_B1_AND_NOT_B2 , posedge A2 &&& ENABLE_A1_AND_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(posedge G &&& ENABLE_A1_AND_B1_AND_NOT_B2 , negedge A2 &&& ENABLE_A1_AND_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(posedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B2 , posedge B1 &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(posedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B2 , negedge B1 &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(posedge G &&& ENABLE_NOT_A1_AND_A2_AND_B2 , posedge B1 &&& ENABLE_NOT_A1_AND_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(posedge G &&& ENABLE_NOT_A1_AND_A2_AND_B2 , negedge B1 &&& ENABLE_NOT_A1_AND_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(posedge G &&& ENABLE_A1_AND_NOT_A2_AND_B2 , posedge B1 &&& ENABLE_A1_AND_NOT_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(posedge G &&& ENABLE_A1_AND_NOT_A2_AND_B2 , negedge B1 &&& ENABLE_A1_AND_NOT_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(posedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1 , posedge B2 &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$setuphold(posedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1 , negedge B2 &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$setuphold(posedge G &&& ENABLE_NOT_A1_AND_A2_AND_B1 , posedge B2 &&& ENABLE_NOT_A1_AND_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$setuphold(posedge G &&& ENABLE_NOT_A1_AND_A2_AND_B1 , negedge B2 &&& ENABLE_NOT_A1_AND_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$setuphold(posedge G &&& ENABLE_A1_AND_NOT_A2_AND_B1 , posedge B2 &&& ENABLE_A1_AND_NOT_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$setuphold(posedge G &&& ENABLE_A1_AND_NOT_A2_AND_B1 , negedge B2 &&& ENABLE_A1_AND_NOT_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$width(negedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1_AND_B2 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_A1_AND_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_A1_AND_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_A1_AND_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_A1_AND_A2_AND_B1_AND_B2 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_A1_AND_NOT_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_A1_AND_NOT_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_A1_AND_NOT_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_A1_AND_NOT_A2_AND_B1_AND_B2 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_A1_AND_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_A1_AND_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_A1_AND_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_A1_AND_A2_AND_B1_AND_B2 , 0 ,0, viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_LDAO22NQ_V2Y2_4

`celldefine
module HDBSVT11_LDAO22PQ_V2Y2_1 (Q, G, A1, A2, B1, B2);
  input G, A1, A2, B1, B2;
  output Q;
  reg viol_0;
     wire viol_x;
  wire int_2, int_3, int_4, iq;
  `ifdef _fv
    buf inst0  (delayed_G, G);
    buf inst1  (delayed_A1, A1);
    buf inst2  (delayed_A2, A2);
    buf inst3  (delayed_B1, B1);
    buf inst4  (delayed_B2, B2);
  `endif


    and inst5  (int_2, delayed_B1, delayed_B2);
    and inst6  (int_3, delayed_A1, delayed_A2);
    or inst7  (int_4, int_3, int_2);
    snps_latch inst8  (iq, viol_x, delayed_G, int_4);
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst9  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (Q, iq);
  `else
    buf inst11  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst12  (_net_0, B1);
not inst13  (_net_1, B2);
and inst14  (ENABLE_A2_AND_NOT_B1_AND_NOT_B2, _net_0, A2, _net_1);
not inst15  (_net_2, B1);
and inst16  (ENABLE_A2_AND_NOT_B1_AND_B2, _net_2, A2, B2);
not inst17  (_net_3, B2);
and inst18  (ENABLE_A2_AND_B1_AND_NOT_B2, B1, A2, _net_3);
not inst19  (_net_4, B1);
not inst20  (_net_5, B2);
and inst21  (ENABLE_A1_AND_NOT_B1_AND_NOT_B2, _net_4, A1, _net_5);
not inst22  (_net_6, B1);
and inst23  (ENABLE_A1_AND_NOT_B1_AND_B2, _net_6, A1, B2);
not inst24  (_net_7, B2);
and inst25  (ENABLE_A1_AND_B1_AND_NOT_B2, B1, A1, _net_7);
not inst26  (_net_8, A2);
not inst27  (_net_9, A1);
and inst28  (ENABLE_NOT_A1_AND_NOT_A2_AND_B2, _net_8, _net_9, B2);
not inst29  (_net_10, A1);
and inst30  (ENABLE_NOT_A1_AND_A2_AND_B2, A2, _net_10, B2);
not inst31  (_net_11, A2);
and inst32  (ENABLE_A1_AND_NOT_A2_AND_B2, _net_11, A1, B2);
not inst33  (_net_12, A2);
not inst34  (_net_13, A1);
and inst35  (ENABLE_NOT_A1_AND_NOT_A2_AND_B1, _net_12, _net_13, B1);
not inst36  (_net_14, A1);
and inst37  (ENABLE_NOT_A1_AND_A2_AND_B1, A2, _net_14, B1);
not inst38  (_net_15, A2);
and inst39  (ENABLE_A1_AND_NOT_A2_AND_B1, _net_15, A1, B1);
not inst40  (_net_16, A2);
not inst41  (_net_17, A1);
not inst42  (_net_18, B1);
not inst43  (_net_19, B2);
and inst44  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_B1_AND_NOT_B2, _net_16, _net_17, _net_18, _net_19);
not inst45  (_net_20, A2);
not inst46  (_net_21, A1);
not inst47  (_net_22, B1);
and inst48  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_B1_AND_B2, _net_20, _net_21, _net_22, B2);
not inst49  (_net_23, A2);
not inst50  (_net_24, A1);
not inst51  (_net_25, B2);
and inst52  (ENABLE_NOT_A1_AND_NOT_A2_AND_B1_AND_NOT_B2, _net_23, _net_24, B1, _net_25);
not inst53  (_net_26, A2);
not inst54  (_net_27, A1);
and inst55  (ENABLE_NOT_A1_AND_NOT_A2_AND_B1_AND_B2, _net_26, _net_27, B1, B2);
not inst56  (_net_28, A1);
not inst57  (_net_29, B1);
not inst58  (_net_30, B2);
and inst59  (ENABLE_NOT_A1_AND_A2_AND_NOT_B1_AND_NOT_B2, A2, _net_28, _net_29, _net_30);
not inst60  (_net_31, A1);
not inst61  (_net_32, B1);
and inst62  (ENABLE_NOT_A1_AND_A2_AND_NOT_B1_AND_B2, A2, _net_31, _net_32, B2);
not inst63  (_net_33, A1);
not inst64  (_net_34, B2);
and inst65  (ENABLE_NOT_A1_AND_A2_AND_B1_AND_NOT_B2, A2, _net_33, B1, _net_34);
not inst66  (_net_35, A1);
and inst67  (ENABLE_NOT_A1_AND_A2_AND_B1_AND_B2, A2, _net_35, B1, B2);
not inst68  (_net_36, A2);
not inst69  (_net_37, B1);
not inst70  (_net_38, B2);
and inst71  (ENABLE_A1_AND_NOT_A2_AND_NOT_B1_AND_NOT_B2, _net_36, A1, _net_37, _net_38);
not inst72  (_net_39, A2);
not inst73  (_net_40, B1);
and inst74  (ENABLE_A1_AND_NOT_A2_AND_NOT_B1_AND_B2, _net_39, A1, _net_40, B2);
not inst75  (_net_41, A2);
not inst76  (_net_42, B2);
and inst77  (ENABLE_A1_AND_NOT_A2_AND_B1_AND_NOT_B2, _net_41, A1, B1, _net_42);
not inst78  (_net_43, A2);
and inst79  (ENABLE_A1_AND_NOT_A2_AND_B1_AND_B2, _net_43, A1, B1, B2);
not inst80  (_net_44, B1);
not inst81  (_net_45, B2);
and inst82  (ENABLE_A1_AND_A2_AND_NOT_B1_AND_NOT_B2, A2, A1, _net_44, _net_45);
not inst83  (_net_46, B1);
and inst84  (ENABLE_A1_AND_A2_AND_NOT_B1_AND_B2, A2, A1, _net_46, B2);
not inst85  (_net_47, B2);
and inst86  (ENABLE_A1_AND_A2_AND_B1_AND_NOT_B2, A2, A1, B1, _net_47);
and inst87  (ENABLE_A1_AND_A2_AND_B1_AND_B2, A2, A1, B1, B2);

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && G==1'b1) (A1 +=> Q)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && G==1'b1) (A1 +=> Q)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && G==1'b1) (A1 +=> Q)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && G==1'b1) (A2 +=> Q)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && G==1'b1) (A2 +=> Q)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && G==1'b1) (A2 +=> Q)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && G==1'b1) (B1 +=> Q)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && G==1'b1) (B1 +=> Q)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && G==1'b1) (B1 +=> Q)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && G==1'b1) (B2 +=> Q)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && G==1'b1) (B2 +=> Q)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && G==1'b1) (B2 +=> Q)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0) (posedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (posedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
$setuphold(negedge G &&& ENABLE_A2_AND_NOT_B1_AND_NOT_B2 , posedge A1 &&& ENABLE_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(negedge G &&& ENABLE_A2_AND_NOT_B1_AND_NOT_B2 , negedge A1 &&& ENABLE_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(negedge G &&& ENABLE_A2_AND_NOT_B1_AND_B2 , posedge A1 &&& ENABLE_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(negedge G &&& ENABLE_A2_AND_NOT_B1_AND_B2 , negedge A1 &&& ENABLE_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(negedge G &&& ENABLE_A2_AND_B1_AND_NOT_B2 , posedge A1 &&& ENABLE_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(negedge G &&& ENABLE_A2_AND_B1_AND_NOT_B2 , negedge A1 &&& ENABLE_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(negedge G &&& ENABLE_A1_AND_NOT_B1_AND_NOT_B2 , posedge A2 &&& ENABLE_A1_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(negedge G &&& ENABLE_A1_AND_NOT_B1_AND_NOT_B2 , negedge A2 &&& ENABLE_A1_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(negedge G &&& ENABLE_A1_AND_NOT_B1_AND_B2 , posedge A2 &&& ENABLE_A1_AND_NOT_B1_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(negedge G &&& ENABLE_A1_AND_NOT_B1_AND_B2 , negedge A2 &&& ENABLE_A1_AND_NOT_B1_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(negedge G &&& ENABLE_A1_AND_B1_AND_NOT_B2 , posedge A2 &&& ENABLE_A1_AND_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(negedge G &&& ENABLE_A1_AND_B1_AND_NOT_B2 , negedge A2 &&& ENABLE_A1_AND_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(negedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B2 , posedge B1 &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(negedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B2 , negedge B1 &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(negedge G &&& ENABLE_NOT_A1_AND_A2_AND_B2 , posedge B1 &&& ENABLE_NOT_A1_AND_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(negedge G &&& ENABLE_NOT_A1_AND_A2_AND_B2 , negedge B1 &&& ENABLE_NOT_A1_AND_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(negedge G &&& ENABLE_A1_AND_NOT_A2_AND_B2 , posedge B1 &&& ENABLE_A1_AND_NOT_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(negedge G &&& ENABLE_A1_AND_NOT_A2_AND_B2 , negedge B1 &&& ENABLE_A1_AND_NOT_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(negedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1 , posedge B2 &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$setuphold(negedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1 , negedge B2 &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$setuphold(negedge G &&& ENABLE_NOT_A1_AND_A2_AND_B1 , posedge B2 &&& ENABLE_NOT_A1_AND_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$setuphold(negedge G &&& ENABLE_NOT_A1_AND_A2_AND_B1 , negedge B2 &&& ENABLE_NOT_A1_AND_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$setuphold(negedge G &&& ENABLE_A1_AND_NOT_A2_AND_B1 , posedge B2 &&& ENABLE_A1_AND_NOT_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$setuphold(negedge G &&& ENABLE_A1_AND_NOT_A2_AND_B1 , negedge B2 &&& ENABLE_A1_AND_NOT_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$width(posedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1_AND_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_A1_AND_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_A1_AND_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_A1_AND_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_A1_AND_A2_AND_B1_AND_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_A1_AND_NOT_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_A1_AND_NOT_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_A1_AND_NOT_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_A1_AND_NOT_A2_AND_B1_AND_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_A1_AND_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_A1_AND_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_A1_AND_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_A1_AND_A2_AND_B1_AND_B2 , 0 ,0, viol_0);
endspecify
  `endif
endmodule
`endcelldefine


`celldefine
module HDBSVT11_LDAO22PQ_V2Y2_4 (Q, G, A1, A2, B1, B2);
  input G, A1, A2, B1, B2;
  output Q;
  reg viol_0;
     wire viol_x;
  wire int_2, int_3, int_4, iq;
  `ifdef _fv
    buf inst0  (delayed_G, G);
    buf inst1  (delayed_A1, A1);
    buf inst2  (delayed_A2, A2);
    buf inst3  (delayed_B1, B1);
    buf inst4  (delayed_B2, B2);
  `endif


    and inst5  (int_2, delayed_B1, delayed_B2);
    and inst6  (int_3, delayed_A1, delayed_A2);
    or inst7  (int_4, int_3, int_2);
    snps_latch inst8  (iq, viol_x, delayed_G, int_4);
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst9  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (Q, iq);
  `else
    buf inst11  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst12  (_net_0, B1);
not inst13  (_net_1, B2);
and inst14  (ENABLE_A2_AND_NOT_B1_AND_NOT_B2, _net_0, A2, _net_1);
not inst15  (_net_2, B1);
and inst16  (ENABLE_A2_AND_NOT_B1_AND_B2, _net_2, A2, B2);
not inst17  (_net_3, B2);
and inst18  (ENABLE_A2_AND_B1_AND_NOT_B2, B1, A2, _net_3);
not inst19  (_net_4, B1);
not inst20  (_net_5, B2);
and inst21  (ENABLE_A1_AND_NOT_B1_AND_NOT_B2, _net_4, A1, _net_5);
not inst22  (_net_6, B1);
and inst23  (ENABLE_A1_AND_NOT_B1_AND_B2, _net_6, A1, B2);
not inst24  (_net_7, B2);
and inst25  (ENABLE_A1_AND_B1_AND_NOT_B2, B1, A1, _net_7);
not inst26  (_net_8, A2);
not inst27  (_net_9, A1);
and inst28  (ENABLE_NOT_A1_AND_NOT_A2_AND_B2, _net_8, _net_9, B2);
not inst29  (_net_10, A1);
and inst30  (ENABLE_NOT_A1_AND_A2_AND_B2, A2, _net_10, B2);
not inst31  (_net_11, A2);
and inst32  (ENABLE_A1_AND_NOT_A2_AND_B2, _net_11, A1, B2);
not inst33  (_net_12, A2);
not inst34  (_net_13, A1);
and inst35  (ENABLE_NOT_A1_AND_NOT_A2_AND_B1, _net_12, _net_13, B1);
not inst36  (_net_14, A1);
and inst37  (ENABLE_NOT_A1_AND_A2_AND_B1, A2, _net_14, B1);
not inst38  (_net_15, A2);
and inst39  (ENABLE_A1_AND_NOT_A2_AND_B1, _net_15, A1, B1);
not inst40  (_net_16, A2);
not inst41  (_net_17, A1);
not inst42  (_net_18, B1);
not inst43  (_net_19, B2);
and inst44  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_B1_AND_NOT_B2, _net_16, _net_17, _net_18, _net_19);
not inst45  (_net_20, A2);
not inst46  (_net_21, A1);
not inst47  (_net_22, B1);
and inst48  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_B1_AND_B2, _net_20, _net_21, _net_22, B2);
not inst49  (_net_23, A2);
not inst50  (_net_24, A1);
not inst51  (_net_25, B2);
and inst52  (ENABLE_NOT_A1_AND_NOT_A2_AND_B1_AND_NOT_B2, _net_23, _net_24, B1, _net_25);
not inst53  (_net_26, A2);
not inst54  (_net_27, A1);
and inst55  (ENABLE_NOT_A1_AND_NOT_A2_AND_B1_AND_B2, _net_26, _net_27, B1, B2);
not inst56  (_net_28, A1);
not inst57  (_net_29, B1);
not inst58  (_net_30, B2);
and inst59  (ENABLE_NOT_A1_AND_A2_AND_NOT_B1_AND_NOT_B2, A2, _net_28, _net_29, _net_30);
not inst60  (_net_31, A1);
not inst61  (_net_32, B1);
and inst62  (ENABLE_NOT_A1_AND_A2_AND_NOT_B1_AND_B2, A2, _net_31, _net_32, B2);
not inst63  (_net_33, A1);
not inst64  (_net_34, B2);
and inst65  (ENABLE_NOT_A1_AND_A2_AND_B1_AND_NOT_B2, A2, _net_33, B1, _net_34);
not inst66  (_net_35, A1);
and inst67  (ENABLE_NOT_A1_AND_A2_AND_B1_AND_B2, A2, _net_35, B1, B2);
not inst68  (_net_36, A2);
not inst69  (_net_37, B1);
not inst70  (_net_38, B2);
and inst71  (ENABLE_A1_AND_NOT_A2_AND_NOT_B1_AND_NOT_B2, _net_36, A1, _net_37, _net_38);
not inst72  (_net_39, A2);
not inst73  (_net_40, B1);
and inst74  (ENABLE_A1_AND_NOT_A2_AND_NOT_B1_AND_B2, _net_39, A1, _net_40, B2);
not inst75  (_net_41, A2);
not inst76  (_net_42, B2);
and inst77  (ENABLE_A1_AND_NOT_A2_AND_B1_AND_NOT_B2, _net_41, A1, B1, _net_42);
not inst78  (_net_43, A2);
and inst79  (ENABLE_A1_AND_NOT_A2_AND_B1_AND_B2, _net_43, A1, B1, B2);
not inst80  (_net_44, B1);
not inst81  (_net_45, B2);
and inst82  (ENABLE_A1_AND_A2_AND_NOT_B1_AND_NOT_B2, A2, A1, _net_44, _net_45);
not inst83  (_net_46, B1);
and inst84  (ENABLE_A1_AND_A2_AND_NOT_B1_AND_B2, A2, A1, _net_46, B2);
not inst85  (_net_47, B2);
and inst86  (ENABLE_A1_AND_A2_AND_B1_AND_NOT_B2, A2, A1, B1, _net_47);
and inst87  (ENABLE_A1_AND_A2_AND_B1_AND_B2, A2, A1, B1, B2);

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0 && G==1'b1) (A1 +=> Q)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1 && G==1'b1) (A1 +=> Q)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0 && G==1'b1) (A1 +=> Q)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0 && G==1'b1) (A2 +=> Q)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1 && G==1'b1) (A2 +=> Q)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0 && G==1'b1) (A2 +=> Q)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1 && G==1'b1) (B1 +=> Q)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1 && G==1'b1) (B1 +=> Q)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1 && G==1'b1) (B1 +=> Q)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && G==1'b1) (B2 +=> Q)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && G==1'b1) (B2 +=> Q)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && G==1'b1) (B2 +=> Q)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b0) (posedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (posedge G => (Q +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
$setuphold(negedge G &&& ENABLE_A2_AND_NOT_B1_AND_NOT_B2 , posedge A1 &&& ENABLE_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(negedge G &&& ENABLE_A2_AND_NOT_B1_AND_NOT_B2 , negedge A1 &&& ENABLE_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(negedge G &&& ENABLE_A2_AND_NOT_B1_AND_B2 , posedge A1 &&& ENABLE_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(negedge G &&& ENABLE_A2_AND_NOT_B1_AND_B2 , negedge A1 &&& ENABLE_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(negedge G &&& ENABLE_A2_AND_B1_AND_NOT_B2 , posedge A1 &&& ENABLE_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(negedge G &&& ENABLE_A2_AND_B1_AND_NOT_B2 , negedge A1 &&& ENABLE_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A1);
$setuphold(negedge G &&& ENABLE_A1_AND_NOT_B1_AND_NOT_B2 , posedge A2 &&& ENABLE_A1_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(negedge G &&& ENABLE_A1_AND_NOT_B1_AND_NOT_B2 , negedge A2 &&& ENABLE_A1_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(negedge G &&& ENABLE_A1_AND_NOT_B1_AND_B2 , posedge A2 &&& ENABLE_A1_AND_NOT_B1_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(negedge G &&& ENABLE_A1_AND_NOT_B1_AND_B2 , negedge A2 &&& ENABLE_A1_AND_NOT_B1_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(negedge G &&& ENABLE_A1_AND_B1_AND_NOT_B2 , posedge A2 &&& ENABLE_A1_AND_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(negedge G &&& ENABLE_A1_AND_B1_AND_NOT_B2 , negedge A2 &&& ENABLE_A1_AND_B1_AND_NOT_B2 , 0 ,0, viol_0, , , delayed_G, delayed_A2);
$setuphold(negedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B2 , posedge B1 &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(negedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B2 , negedge B1 &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(negedge G &&& ENABLE_NOT_A1_AND_A2_AND_B2 , posedge B1 &&& ENABLE_NOT_A1_AND_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(negedge G &&& ENABLE_NOT_A1_AND_A2_AND_B2 , negedge B1 &&& ENABLE_NOT_A1_AND_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(negedge G &&& ENABLE_A1_AND_NOT_A2_AND_B2 , posedge B1 &&& ENABLE_A1_AND_NOT_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(negedge G &&& ENABLE_A1_AND_NOT_A2_AND_B2 , negedge B1 &&& ENABLE_A1_AND_NOT_A2_AND_B2 , 0 ,0, viol_0, , , delayed_G, delayed_B1);
$setuphold(negedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1 , posedge B2 &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$setuphold(negedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1 , negedge B2 &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$setuphold(negedge G &&& ENABLE_NOT_A1_AND_A2_AND_B1 , posedge B2 &&& ENABLE_NOT_A1_AND_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$setuphold(negedge G &&& ENABLE_NOT_A1_AND_A2_AND_B1 , negedge B2 &&& ENABLE_NOT_A1_AND_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$setuphold(negedge G &&& ENABLE_A1_AND_NOT_A2_AND_B1 , posedge B2 &&& ENABLE_A1_AND_NOT_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$setuphold(negedge G &&& ENABLE_A1_AND_NOT_A2_AND_B1 , negedge B2 &&& ENABLE_A1_AND_NOT_A2_AND_B1 , 0 ,0, viol_0, , , delayed_G, delayed_B2);
$width(posedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_A1_AND_NOT_A2_AND_B1_AND_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_A1_AND_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_A1_AND_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_A1_AND_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_A1_AND_A2_AND_B1_AND_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_A1_AND_NOT_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_A1_AND_NOT_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_A1_AND_NOT_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_A1_AND_NOT_A2_AND_B1_AND_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_A1_AND_A2_AND_NOT_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_A1_AND_A2_AND_NOT_B1_AND_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_A1_AND_A2_AND_B1_AND_NOT_B2 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_A1_AND_A2_AND_B1_AND_B2 , 0 ,0, viol_0);
endspecify
  `endif
endmodule
`endcelldefine


//%BEGIN HDBSVT11_LDNQM4_V2Y4_1
`celldefine
module HDBSVT11_LDNQM4_V2Y4_1 (Q0, Q1, Q2, Q3, G, D0, D1, D2, D3);
  input G, D0, D1, D2, D3;
  output Q0, Q1, Q2, Q3;
  reg viol_0;
  wire viol_x, int_8, iq3, iq2, iq1, iq0;
  `ifdef _fv
    buf inst0  (delayed_G, G);
    buf inst1  (delayed_D0, D0);
    buf inst2  (delayed_D1, D1);
    buf inst3  (delayed_D2, D2);
    buf inst4  (delayed_D3, D3);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst5  (viol_x, viol_0, int_8, 1'b1, 1'b1);

  `endif
    not inst6  (int_8, delayed_G);
    snps_latch inst7  (iq3, viol_x, int_8, delayed_D3);
    snps_latch inst8  (iq2, viol_x, int_8, delayed_D2);
    snps_latch inst9  (iq1, viol_x, int_8, delayed_D1);
    snps_latch inst10  (iq0, viol_x, int_8, delayed_D0);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst11 (Q3, iq3);
    buf #`SNPS_SEQ_DELAY  inst12 (Q2, iq2);
    buf #`SNPS_SEQ_DELAY  inst13 (Q1, iq1);
    buf #`SNPS_SEQ_DELAY  inst14 (Q0, iq0);
  `else
    buf inst15  (Q3, iq3);
    buf inst16  (Q2, iq2);
    buf inst17  (Q1, iq1);
    buf inst18  (Q0, iq0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst19  (_net_0, D1);
not inst20  (_net_1, D0);
not inst21  (_net_2, D2);
not inst22  (_net_3, D3);
and inst23  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_0, _net_1, _net_2, _net_3);
not inst24  (_net_4, D1);
not inst25  (_net_5, D0);
not inst26  (_net_6, D2);
and inst27  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3, _net_4, _net_5, _net_6, D3);
not inst28  (_net_7, D1);
not inst29  (_net_8, D0);
not inst30  (_net_9, D3);
and inst31  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3, _net_7, _net_8, D2, _net_9);
not inst32  (_net_10, D1);
not inst33  (_net_11, D0);
and inst34  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3, _net_10, _net_11, D2, D3);
not inst35  (_net_12, D0);
not inst36  (_net_13, D2);
not inst37  (_net_14, D3);
and inst38  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3, D1, _net_12, _net_13, _net_14);
not inst39  (_net_15, D1);
not inst40  (_net_16, D2);
not inst41  (_net_17, D3);
and inst42  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_15, D0, _net_16, _net_17);
not inst43  (_net_18, D1);
not inst44  (_net_19, D3);
and inst45  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3, _net_18, D0, D2, _net_19);
not inst46  (_net_20, D1);
and inst47  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3, _net_20, D0, D2, D3);
and inst48  (ENABLE_D0_AND_D1_AND_D2_AND_D3, D1, D0, D2, D3);
not inst49  (_net_21, D2);
not inst50  (_net_22, D1);
not inst51  (_net_23, D3);
and inst52  (ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_21, _net_22, _net_23);
not inst53  (_net_24, D2);
not inst54  (_net_25, D0);
not inst55  (_net_26, D3);
and inst56  (ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3, _net_24, _net_25, _net_26);
not inst57  (_net_27, D1);
not inst58  (_net_28, D0);
not inst59  (_net_29, D3);
and inst60  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3, _net_27, _net_28, _net_29);
not inst61  (_net_30, D1);
not inst62  (_net_31, D0);
not inst63  (_net_32, D2);
and inst64  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2, _net_30, _net_31, _net_32);

specify
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q0 +: 1'b1))=(0, 0);
(negedge G => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0 && D2==1'b0 && D3==1'b0 && G==1'b0) (D0 +=> Q0)=(0, 0);
ifnone (D0 +=> Q0)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0) (negedge G => (Q1 -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q1 +: 1'b1))=(0, 0);
(negedge G => (Q1 : 1'b1))=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b0 && G==1'b0) (D1 +=> Q1)=(0, 0);
ifnone (D1 +=> Q1)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0) (negedge G => (Q2 -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q2 +: 1'b1))=(0, 0);
(negedge G => (Q2 : 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b0 && G==1'b0) (D2 +=> Q2)=(0, 0);
ifnone (D2 +=> Q2)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1) (negedge G => (Q3 -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q3 +: 1'b1))=(0, 0);
(negedge G => (Q3 : 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && G==1'b0) (D3 +=> Q3)=(0, 0);
ifnone (D3 +=> Q3)=(0, 0);
$width(negedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D0_AND_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$setuphold(posedge G &&& ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3 , posedge D0 &&& ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D0);
$setuphold(posedge G &&& ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3 , negedge D0 &&& ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D0);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3 , posedge D1 &&& ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D1);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3 , negedge D1 &&& ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D1);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3 , posedge D2 &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D2);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3 , negedge D2 &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D2);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2 , posedge D3 &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2 , 0 ,0, viol_0, , , delayed_G, delayed_D3);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2 , negedge D3 &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2 , 0 ,0, viol_0, , , delayed_G, delayed_D3);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_LDNQM4_V2Y4_1

//%BEGIN HDBSVT11_LDNQM4_V2Y4_2
`celldefine
module HDBSVT11_LDNQM4_V2Y4_2 (Q0, Q1, Q2, Q3, G, D0, D1, D2, D3);
  input G, D0, D1, D2, D3;
  output Q0, Q1, Q2, Q3;
  reg viol_0;
  wire viol_x, int_8, iq3, iq2, iq1, iq0;
  `ifdef _fv
    buf inst0  (delayed_G, G);
    buf inst1  (delayed_D0, D0);
    buf inst2  (delayed_D1, D1);
    buf inst3  (delayed_D2, D2);
    buf inst4  (delayed_D3, D3);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst5  (viol_x, viol_0, int_8, 1'b1, 1'b1);

  `endif
    not inst6  (int_8, delayed_G);
    snps_latch inst7  (iq3, viol_x, int_8, delayed_D3);
    snps_latch inst8  (iq2, viol_x, int_8, delayed_D2);
    snps_latch inst9  (iq1, viol_x, int_8, delayed_D1);
    snps_latch inst10  (iq0, viol_x, int_8, delayed_D0);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst11 (Q3, iq3);
    buf #`SNPS_SEQ_DELAY  inst12 (Q2, iq2);
    buf #`SNPS_SEQ_DELAY  inst13 (Q1, iq1);
    buf #`SNPS_SEQ_DELAY  inst14 (Q0, iq0);
  `else
    buf inst15  (Q3, iq3);
    buf inst16  (Q2, iq2);
    buf inst17  (Q1, iq1);
    buf inst18  (Q0, iq0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst19  (_net_0, D1);
not inst20  (_net_1, D0);
not inst21  (_net_2, D2);
not inst22  (_net_3, D3);
and inst23  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_0, _net_1, _net_2, _net_3);
not inst24  (_net_4, D1);
not inst25  (_net_5, D0);
not inst26  (_net_6, D2);
and inst27  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3, _net_4, _net_5, _net_6, D3);
not inst28  (_net_7, D1);
not inst29  (_net_8, D0);
not inst30  (_net_9, D3);
and inst31  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3, _net_7, _net_8, D2, _net_9);
not inst32  (_net_10, D1);
not inst33  (_net_11, D0);
and inst34  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3, _net_10, _net_11, D2, D3);
not inst35  (_net_12, D0);
not inst36  (_net_13, D2);
not inst37  (_net_14, D3);
and inst38  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3, D1, _net_12, _net_13, _net_14);
not inst39  (_net_15, D1);
not inst40  (_net_16, D2);
not inst41  (_net_17, D3);
and inst42  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_15, D0, _net_16, _net_17);
not inst43  (_net_18, D1);
not inst44  (_net_19, D3);
and inst45  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3, _net_18, D0, D2, _net_19);
not inst46  (_net_20, D1);
and inst47  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3, _net_20, D0, D2, D3);
and inst48  (ENABLE_D0_AND_D1_AND_D2_AND_D3, D1, D0, D2, D3);
not inst49  (_net_21, D2);
not inst50  (_net_22, D1);
not inst51  (_net_23, D3);
and inst52  (ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_21, _net_22, _net_23);
not inst53  (_net_24, D2);
not inst54  (_net_25, D0);
not inst55  (_net_26, D3);
and inst56  (ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3, _net_24, _net_25, _net_26);
not inst57  (_net_27, D1);
not inst58  (_net_28, D0);
not inst59  (_net_29, D3);
and inst60  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3, _net_27, _net_28, _net_29);
not inst61  (_net_30, D1);
not inst62  (_net_31, D0);
not inst63  (_net_32, D2);
and inst64  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2, _net_30, _net_31, _net_32);

specify
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q0 +: 1'b1))=(0, 0);
(negedge G => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0 && D2==1'b0 && D3==1'b0 && G==1'b0) (D0 +=> Q0)=(0, 0);
ifnone (D0 +=> Q0)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0) (negedge G => (Q1 -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q1 +: 1'b1))=(0, 0);
(negedge G => (Q1 : 1'b1))=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b0 && G==1'b0) (D1 +=> Q1)=(0, 0);
ifnone (D1 +=> Q1)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0) (negedge G => (Q2 -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q2 +: 1'b1))=(0, 0);
(negedge G => (Q2 : 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b0 && G==1'b0) (D2 +=> Q2)=(0, 0);
ifnone (D2 +=> Q2)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1) (negedge G => (Q3 -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q3 +: 1'b1))=(0, 0);
(negedge G => (Q3 : 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && G==1'b0) (D3 +=> Q3)=(0, 0);
ifnone (D3 +=> Q3)=(0, 0);
$width(negedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D0_AND_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$setuphold(posedge G &&& ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3 , posedge D0 &&& ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D0);
$setuphold(posedge G &&& ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3 , negedge D0 &&& ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D0);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3 , posedge D1 &&& ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D1);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3 , negedge D1 &&& ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D1);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3 , posedge D2 &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D2);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3 , negedge D2 &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D2);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2 , posedge D3 &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2 , 0 ,0, viol_0, , , delayed_G, delayed_D3);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2 , negedge D3 &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2 , 0 ,0, viol_0, , , delayed_G, delayed_D3);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_LDNQM4_V2Y4_2

//%BEGIN HDBSVT11_LDNQM4_V2Y8_1
`celldefine
module HDBSVT11_LDNQM4_V2Y8_1 (Q0, Q1, Q2, Q3, G, D0, D1, D2, D3);
  input G, D0, D1, D2, D3;
  output Q0, Q1, Q2, Q3;
  reg viol_0;
  wire viol_x, int_8, iq3, iq2, iq1, iq0;
  `ifdef _fv
    buf inst0  (delayed_G, G);
    buf inst1  (delayed_D0, D0);
    buf inst2  (delayed_D1, D1);
    buf inst3  (delayed_D2, D2);
    buf inst4  (delayed_D3, D3);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst5  (viol_x, viol_0, int_8, 1'b1, 1'b1);

  `endif
    not inst6  (int_8, delayed_G);
    snps_latch inst7  (iq3, viol_x, int_8, delayed_D3);
    snps_latch inst8  (iq2, viol_x, int_8, delayed_D2);
    snps_latch inst9  (iq1, viol_x, int_8, delayed_D1);
    snps_latch inst10  (iq0, viol_x, int_8, delayed_D0);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst11 (Q3, iq3);
    buf #`SNPS_SEQ_DELAY  inst12 (Q2, iq2);
    buf #`SNPS_SEQ_DELAY  inst13 (Q1, iq1);
    buf #`SNPS_SEQ_DELAY  inst14 (Q0, iq0);
  `else
    buf inst15  (Q3, iq3);
    buf inst16  (Q2, iq2);
    buf inst17  (Q1, iq1);
    buf inst18  (Q0, iq0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst19  (_net_0, D1);
not inst20  (_net_1, D0);
not inst21  (_net_2, D2);
not inst22  (_net_3, D3);
and inst23  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_0, _net_1, _net_2, _net_3);
not inst24  (_net_4, D1);
not inst25  (_net_5, D0);
not inst26  (_net_6, D2);
and inst27  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3, _net_4, _net_5, _net_6, D3);
not inst28  (_net_7, D1);
not inst29  (_net_8, D0);
not inst30  (_net_9, D3);
and inst31  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3, _net_7, _net_8, D2, _net_9);
not inst32  (_net_10, D1);
not inst33  (_net_11, D0);
and inst34  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3, _net_10, _net_11, D2, D3);
not inst35  (_net_12, D0);
not inst36  (_net_13, D2);
not inst37  (_net_14, D3);
and inst38  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3, D1, _net_12, _net_13, _net_14);
not inst39  (_net_15, D1);
not inst40  (_net_16, D2);
not inst41  (_net_17, D3);
and inst42  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_15, D0, _net_16, _net_17);
not inst43  (_net_18, D1);
not inst44  (_net_19, D3);
and inst45  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3, _net_18, D0, D2, _net_19);
not inst46  (_net_20, D1);
and inst47  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3, _net_20, D0, D2, D3);
and inst48  (ENABLE_D0_AND_D1_AND_D2_AND_D3, D1, D0, D2, D3);
not inst49  (_net_21, D2);
not inst50  (_net_22, D1);
not inst51  (_net_23, D3);
and inst52  (ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_21, _net_22, _net_23);
not inst53  (_net_24, D2);
not inst54  (_net_25, D0);
not inst55  (_net_26, D3);
and inst56  (ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3, _net_24, _net_25, _net_26);
not inst57  (_net_27, D1);
not inst58  (_net_28, D0);
not inst59  (_net_29, D3);
and inst60  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3, _net_27, _net_28, _net_29);
not inst61  (_net_30, D1);
not inst62  (_net_31, D0);
not inst63  (_net_32, D2);
and inst64  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2, _net_30, _net_31, _net_32);

specify
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q0 +: 1'b1))=(0, 0);
(negedge G => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0 && D2==1'b0 && D3==1'b0 && G==1'b0) (D0 +=> Q0)=(0, 0);
ifnone (D0 +=> Q0)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0) (negedge G => (Q1 -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q1 +: 1'b1))=(0, 0);
(negedge G => (Q1 : 1'b1))=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b0 && G==1'b0) (D1 +=> Q1)=(0, 0);
ifnone (D1 +=> Q1)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0) (negedge G => (Q2 -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q2 +: 1'b1))=(0, 0);
(negedge G => (Q2 : 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b0 && G==1'b0) (D2 +=> Q2)=(0, 0);
ifnone (D2 +=> Q2)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1) (negedge G => (Q3 -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q3 +: 1'b1))=(0, 0);
(negedge G => (Q3 : 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && G==1'b0) (D3 +=> Q3)=(0, 0);
ifnone (D3 +=> Q3)=(0, 0);
$width(negedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D0_AND_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$setuphold(posedge G &&& ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3 , posedge D0 &&& ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D0);
$setuphold(posedge G &&& ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3 , negedge D0 &&& ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D0);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3 , posedge D1 &&& ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D1);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3 , negedge D1 &&& ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D1);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3 , posedge D2 &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D2);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3 , negedge D2 &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D2);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2 , posedge D3 &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2 , 0 ,0, viol_0, , , delayed_G, delayed_D3);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2 , negedge D3 &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2 , 0 ,0, viol_0, , , delayed_G, delayed_D3);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_LDNQM4_V2Y8_1

//%BEGIN HDBSVT11_LDNQM4_V2Y8_2
`celldefine
module HDBSVT11_LDNQM4_V2Y8_2 (Q0, Q1, Q2, Q3, G, D0, D1, D2, D3);
  input G, D0, D1, D2, D3;
  output Q0, Q1, Q2, Q3;
  reg viol_0;
  wire viol_x, int_8, iq3, iq2, iq1, iq0;
  `ifdef _fv
    buf inst0  (delayed_G, G);
    buf inst1  (delayed_D0, D0);
    buf inst2  (delayed_D1, D1);
    buf inst3  (delayed_D2, D2);
    buf inst4  (delayed_D3, D3);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst5  (viol_x, viol_0, int_8, 1'b1, 1'b1);

  `endif
    not inst6  (int_8, delayed_G);
    snps_latch inst7  (iq3, viol_x, int_8, delayed_D3);
    snps_latch inst8  (iq2, viol_x, int_8, delayed_D2);
    snps_latch inst9  (iq1, viol_x, int_8, delayed_D1);
    snps_latch inst10  (iq0, viol_x, int_8, delayed_D0);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst11 (Q3, iq3);
    buf #`SNPS_SEQ_DELAY  inst12 (Q2, iq2);
    buf #`SNPS_SEQ_DELAY  inst13 (Q1, iq1);
    buf #`SNPS_SEQ_DELAY  inst14 (Q0, iq0);
  `else
    buf inst15  (Q3, iq3);
    buf inst16  (Q2, iq2);
    buf inst17  (Q1, iq1);
    buf inst18  (Q0, iq0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst19  (_net_0, D1);
not inst20  (_net_1, D0);
not inst21  (_net_2, D2);
not inst22  (_net_3, D3);
and inst23  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_0, _net_1, _net_2, _net_3);
not inst24  (_net_4, D1);
not inst25  (_net_5, D0);
not inst26  (_net_6, D2);
and inst27  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3, _net_4, _net_5, _net_6, D3);
not inst28  (_net_7, D1);
not inst29  (_net_8, D0);
not inst30  (_net_9, D3);
and inst31  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3, _net_7, _net_8, D2, _net_9);
not inst32  (_net_10, D1);
not inst33  (_net_11, D0);
and inst34  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3, _net_10, _net_11, D2, D3);
not inst35  (_net_12, D0);
not inst36  (_net_13, D2);
not inst37  (_net_14, D3);
and inst38  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3, D1, _net_12, _net_13, _net_14);
not inst39  (_net_15, D1);
not inst40  (_net_16, D2);
not inst41  (_net_17, D3);
and inst42  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_15, D0, _net_16, _net_17);
not inst43  (_net_18, D1);
not inst44  (_net_19, D3);
and inst45  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3, _net_18, D0, D2, _net_19);
not inst46  (_net_20, D1);
and inst47  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3, _net_20, D0, D2, D3);
and inst48  (ENABLE_D0_AND_D1_AND_D2_AND_D3, D1, D0, D2, D3);
not inst49  (_net_21, D2);
not inst50  (_net_22, D1);
not inst51  (_net_23, D3);
and inst52  (ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_21, _net_22, _net_23);
not inst53  (_net_24, D2);
not inst54  (_net_25, D0);
not inst55  (_net_26, D3);
and inst56  (ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3, _net_24, _net_25, _net_26);
not inst57  (_net_27, D1);
not inst58  (_net_28, D0);
not inst59  (_net_29, D3);
and inst60  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3, _net_27, _net_28, _net_29);
not inst61  (_net_30, D1);
not inst62  (_net_31, D0);
not inst63  (_net_32, D2);
and inst64  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2, _net_30, _net_31, _net_32);

specify
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q0 +: 1'b1))=(0, 0);
(negedge G => (Q0 : 1'b1))=(0, 0);
if (D1==1'b0 && D2==1'b0 && D3==1'b0 && G==1'b0) (D0 +=> Q0)=(0, 0);
ifnone (D0 +=> Q0)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0) (negedge G => (Q1 -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q1 +: 1'b1))=(0, 0);
(negedge G => (Q1 : 1'b1))=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b0 && G==1'b0) (D1 +=> Q1)=(0, 0);
ifnone (D1 +=> Q1)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0) (negedge G => (Q2 -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q2 +: 1'b1))=(0, 0);
(negedge G => (Q2 : 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b0 && G==1'b0) (D2 +=> Q2)=(0, 0);
ifnone (D2 +=> Q2)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1) (negedge G => (Q3 -: 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b0) (negedge G => (Q3 +: 1'b1))=(0, 0);
(negedge G => (Q3 : 1'b1))=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && G==1'b0) (D3 +=> Q3)=(0, 0);
ifnone (D3 +=> Q3)=(0, 0);
$width(negedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D0_AND_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$setuphold(posedge G &&& ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3 , posedge D0 &&& ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D0);
$setuphold(posedge G &&& ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3 , negedge D0 &&& ENABLE_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D0);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3 , posedge D1 &&& ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D1);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3 , negedge D1 &&& ENABLE_NOT_D0_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D1);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3 , posedge D2 &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D2);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3 , negedge D2 &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D3 , 0 ,0, viol_0, , , delayed_G, delayed_D2);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2 , posedge D3 &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2 , 0 ,0, viol_0, , , delayed_G, delayed_D3);
$setuphold(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2 , negedge D3 &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2 , 0 ,0, viol_0, , , delayed_G, delayed_D3);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_LDNQM4_V2Y8_2

//%BEGIN HDBSVT11_LDNQOR2_CKY2_1

`celldefine
module HDBSVT11_LDNQOR2_CKY2_1 (Q, G, TEN, EN);
   output Q;
   input G, TEN, EN;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_TEN, delayed_EN;

   wire int_res__G, int_res__d;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_TEN, TEN);
   buf inst2  (delayed_EN, EN);
`endif

   not inst3  (int_res__G, delayed_G);
   or inst4  (int_res__d, delayed_TEN, delayed_EN);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst5  (viol_x, viol_0, int_res__G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_CKGT_DELAY  inst6 (Q, viol_x, int_res__G, int_res__d);

   `else

        snps_latch inst7  (Q, viol_x, int_res__G, int_res__d);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (ENABLE_NOT_TEN, TEN);
not inst9  (_net_0, TEN);
not inst10  (_net_1, EN);
and inst11  (ENABLE_NOT_EN_AND_NOT_TEN, _net_0, _net_1);
not inst12  (_net_2, EN);
and inst13  (ENABLE_NOT_EN_AND_TEN, TEN, _net_2);
not inst14  (_net_3, TEN);
and inst15  (ENABLE_EN_AND_NOT_TEN, _net_3, EN);
and inst16  (ENABLE_EN_AND_TEN, TEN, EN);
not inst17  (ENABLE_NOT_EN, EN);

specify
if (G==1'b0 && TEN==1'b0) (EN +=> Q)=(0, 0);
ifnone (EN +=> Q)=(0, 0);
if (EN==1'b0 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && TEN==1'b0) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b0 && TEN==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
if (EN==1'b0 && G==1'b0) (TEN +=> Q)=(0, 0);
ifnone (TEN +=> Q)=(0, 0);
$setuphold(posedge G &&& ENABLE_NOT_TEN , posedge EN &&& ENABLE_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$setuphold(posedge G &&& ENABLE_NOT_TEN , negedge EN &&& ENABLE_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$width(negedge G &&& ENABLE_NOT_EN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_EN_AND_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_TEN , 0 ,0, viol_0);
$setuphold(posedge G &&& ENABLE_NOT_EN , posedge TEN &&& ENABLE_NOT_EN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
$setuphold(posedge G &&& ENABLE_NOT_EN , negedge TEN &&& ENABLE_NOT_EN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNQOR2_CKY2_1

//%BEGIN HDBSVT11_LDNQOR2_CKY2_2

`celldefine
module HDBSVT11_LDNQOR2_CKY2_2 (Q, G, TEN, EN);
   output Q;
   input G, TEN, EN;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_TEN, delayed_EN;

   wire int_res__G, int_res__d;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_TEN, TEN);
   buf inst2  (delayed_EN, EN);
`endif

   not inst3  (int_res__G, delayed_G);
   or inst4  (int_res__d, delayed_TEN, delayed_EN);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst5  (viol_x, viol_0, int_res__G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_CKGT_DELAY  inst6 (Q, viol_x, int_res__G, int_res__d);

   `else

        snps_latch inst7  (Q, viol_x, int_res__G, int_res__d);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (ENABLE_NOT_TEN, TEN);
not inst9  (_net_0, TEN);
not inst10  (_net_1, EN);
and inst11  (ENABLE_NOT_EN_AND_NOT_TEN, _net_0, _net_1);
not inst12  (_net_2, EN);
and inst13  (ENABLE_NOT_EN_AND_TEN, TEN, _net_2);
not inst14  (_net_3, TEN);
and inst15  (ENABLE_EN_AND_NOT_TEN, _net_3, EN);
and inst16  (ENABLE_EN_AND_TEN, TEN, EN);
not inst17  (ENABLE_NOT_EN, EN);

specify
if (G==1'b0 && TEN==1'b0) (EN +=> Q)=(0, 0);
ifnone (EN +=> Q)=(0, 0);
if (EN==1'b0 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && TEN==1'b0) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b0 && TEN==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
if (EN==1'b0 && G==1'b0) (TEN +=> Q)=(0, 0);
ifnone (TEN +=> Q)=(0, 0);
$setuphold(posedge G &&& ENABLE_NOT_TEN , posedge EN &&& ENABLE_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$setuphold(posedge G &&& ENABLE_NOT_TEN , negedge EN &&& ENABLE_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$width(negedge G &&& ENABLE_NOT_EN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_EN_AND_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_TEN , 0 ,0, viol_0);
$setuphold(posedge G &&& ENABLE_NOT_EN , posedge TEN &&& ENABLE_NOT_EN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
$setuphold(posedge G &&& ENABLE_NOT_EN , negedge TEN &&& ENABLE_NOT_EN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNQOR2_CKY2_2

//%BEGIN HDBSVT11_LDNQOR2_CKY2_4

`celldefine
module HDBSVT11_LDNQOR2_CKY2_4 (Q, G, TEN, EN);
   output Q;
   input G, TEN, EN;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_TEN, delayed_EN;

   wire int_res__G, int_res__d;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_TEN, TEN);
   buf inst2  (delayed_EN, EN);
`endif

   not inst3  (int_res__G, delayed_G);
   or inst4  (int_res__d, delayed_TEN, delayed_EN);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst5  (viol_x, viol_0, int_res__G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_CKGT_DELAY  inst6 (Q, viol_x, int_res__G, int_res__d);

   `else

        snps_latch inst7  (Q, viol_x, int_res__G, int_res__d);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (ENABLE_NOT_TEN, TEN);
not inst9  (_net_0, TEN);
not inst10  (_net_1, EN);
and inst11  (ENABLE_NOT_EN_AND_NOT_TEN, _net_0, _net_1);
not inst12  (_net_2, EN);
and inst13  (ENABLE_NOT_EN_AND_TEN, TEN, _net_2);
not inst14  (_net_3, TEN);
and inst15  (ENABLE_EN_AND_NOT_TEN, _net_3, EN);
and inst16  (ENABLE_EN_AND_TEN, TEN, EN);
not inst17  (ENABLE_NOT_EN, EN);

specify
if (G==1'b0 && TEN==1'b0) (EN +=> Q)=(0, 0);
ifnone (EN +=> Q)=(0, 0);
if (EN==1'b0 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && TEN==1'b0) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b0 && TEN==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
if (EN==1'b0 && G==1'b0) (TEN +=> Q)=(0, 0);
ifnone (TEN +=> Q)=(0, 0);
$setuphold(posedge G &&& ENABLE_NOT_TEN , posedge EN &&& ENABLE_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$setuphold(posedge G &&& ENABLE_NOT_TEN , negedge EN &&& ENABLE_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$width(negedge G &&& ENABLE_NOT_EN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_EN_AND_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_TEN , 0 ,0, viol_0);
$setuphold(posedge G &&& ENABLE_NOT_EN , posedge TEN &&& ENABLE_NOT_EN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
$setuphold(posedge G &&& ENABLE_NOT_EN , negedge TEN &&& ENABLE_NOT_EN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNQOR2_CKY2_4

//%BEGIN HDBSVT11_LDNQOR2_FY2_2

`celldefine
module HDBSVT11_LDNQOR2_FY2_2 (Q, G, TEN, EN);
   output Q;
   input G, TEN, EN;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_TEN, delayed_EN;

   wire int_res__G, int_res__d;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_TEN, TEN);
   buf inst2  (delayed_EN, EN);
`endif

   not inst3  (int_res__G, delayed_G);
   or inst4  (int_res__d, delayed_TEN, delayed_EN);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst5  (viol_x, viol_0, int_res__G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst6 (Q, viol_x, int_res__G, int_res__d);

   `else

        snps_latch inst7  (Q, viol_x, int_res__G, int_res__d);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (ENABLE_NOT_TEN, TEN);
not inst9  (_net_0, TEN);
not inst10  (_net_1, EN);
and inst11  (ENABLE_NOT_EN_AND_NOT_TEN, _net_0, _net_1);
not inst12  (_net_2, EN);
and inst13  (ENABLE_NOT_EN_AND_TEN, TEN, _net_2);
not inst14  (_net_3, TEN);
and inst15  (ENABLE_EN_AND_NOT_TEN, _net_3, EN);
and inst16  (ENABLE_EN_AND_TEN, TEN, EN);
not inst17  (ENABLE_NOT_EN, EN);

specify
if (G==1'b0 && TEN==1'b0) (EN +=> Q)=(0, 0);
ifnone (EN +=> Q)=(0, 0);
if (EN==1'b0 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && TEN==1'b0) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b0 && TEN==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
if (EN==1'b0 && G==1'b0) (TEN +=> Q)=(0, 0);
ifnone (TEN +=> Q)=(0, 0);
$setuphold(posedge G &&& ENABLE_NOT_TEN , posedge EN &&& ENABLE_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$setuphold(posedge G &&& ENABLE_NOT_TEN , negedge EN &&& ENABLE_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$width(negedge G &&& ENABLE_NOT_EN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_EN_AND_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_TEN , 0 ,0, viol_0);
$setuphold(posedge G &&& ENABLE_NOT_EN , posedge TEN &&& ENABLE_NOT_EN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
$setuphold(posedge G &&& ENABLE_NOT_EN , negedge TEN &&& ENABLE_NOT_EN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNQOR2_FY2_2

//%BEGIN HDBSVT11_LDNQOR2_FY2_4

`celldefine
module HDBSVT11_LDNQOR2_FY2_4 (Q, G, TEN, EN);
   output Q;
   input G, TEN, EN;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_TEN, delayed_EN;

   wire int_res__G, int_res__d;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_TEN, TEN);
   buf inst2  (delayed_EN, EN);
`endif

   not inst3  (int_res__G, delayed_G);
   or inst4  (int_res__d, delayed_TEN, delayed_EN);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst5  (viol_x, viol_0, int_res__G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst6 (Q, viol_x, int_res__G, int_res__d);

   `else

        snps_latch inst7  (Q, viol_x, int_res__G, int_res__d);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (ENABLE_NOT_TEN, TEN);
not inst9  (_net_0, TEN);
not inst10  (_net_1, EN);
and inst11  (ENABLE_NOT_EN_AND_NOT_TEN, _net_0, _net_1);
not inst12  (_net_2, EN);
and inst13  (ENABLE_NOT_EN_AND_TEN, TEN, _net_2);
not inst14  (_net_3, TEN);
and inst15  (ENABLE_EN_AND_NOT_TEN, _net_3, EN);
and inst16  (ENABLE_EN_AND_TEN, TEN, EN);
not inst17  (ENABLE_NOT_EN, EN);

specify
if (G==1'b0 && TEN==1'b0) (EN +=> Q)=(0, 0);
ifnone (EN +=> Q)=(0, 0);
if (EN==1'b0 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && TEN==1'b0) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b0 && TEN==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
if (EN==1'b0 && G==1'b0) (TEN +=> Q)=(0, 0);
ifnone (TEN +=> Q)=(0, 0);
$setuphold(posedge G &&& ENABLE_NOT_TEN , posedge EN &&& ENABLE_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$setuphold(posedge G &&& ENABLE_NOT_TEN , negedge EN &&& ENABLE_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$width(negedge G &&& ENABLE_NOT_EN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_EN_AND_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_TEN , 0 ,0, viol_0);
$setuphold(posedge G &&& ENABLE_NOT_EN , posedge TEN &&& ENABLE_NOT_EN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
$setuphold(posedge G &&& ENABLE_NOT_EN , negedge TEN &&& ENABLE_NOT_EN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNQOR2_FY2_4

//%BEGIN HDBSVT11_LDNQOR2_Y2_1

`celldefine
module HDBSVT11_LDNQOR2_Y2_1 (Q, G, TEN, EN);
   output Q;
   input G, TEN, EN;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_TEN, delayed_EN;

   wire int_res__G, int_res__d;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_TEN, TEN);
   buf inst2  (delayed_EN, EN);
`endif

   not inst3  (int_res__G, delayed_G);
   or inst4  (int_res__d, delayed_TEN, delayed_EN);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst5  (viol_x, viol_0, int_res__G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst6 (Q, viol_x, int_res__G, int_res__d);

   `else

        snps_latch inst7  (Q, viol_x, int_res__G, int_res__d);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (ENABLE_NOT_TEN, TEN);
not inst9  (_net_0, TEN);
not inst10  (_net_1, EN);
and inst11  (ENABLE_NOT_EN_AND_NOT_TEN, _net_0, _net_1);
not inst12  (_net_2, EN);
and inst13  (ENABLE_NOT_EN_AND_TEN, TEN, _net_2);
not inst14  (_net_3, TEN);
and inst15  (ENABLE_EN_AND_NOT_TEN, _net_3, EN);
and inst16  (ENABLE_EN_AND_TEN, TEN, EN);
not inst17  (ENABLE_NOT_EN, EN);

specify
if (G==1'b0 && TEN==1'b0) (EN +=> Q)=(0, 0);
ifnone (EN +=> Q)=(0, 0);
if (EN==1'b0 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && TEN==1'b0) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b0 && TEN==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
if (EN==1'b0 && G==1'b0) (TEN +=> Q)=(0, 0);
ifnone (TEN +=> Q)=(0, 0);
$setuphold(posedge G &&& ENABLE_NOT_TEN , posedge EN &&& ENABLE_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$setuphold(posedge G &&& ENABLE_NOT_TEN , negedge EN &&& ENABLE_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$width(negedge G &&& ENABLE_NOT_EN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_EN_AND_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_TEN , 0 ,0, viol_0);
$setuphold(posedge G &&& ENABLE_NOT_EN , posedge TEN &&& ENABLE_NOT_EN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
$setuphold(posedge G &&& ENABLE_NOT_EN , negedge TEN &&& ENABLE_NOT_EN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNQOR2_Y2_1

//%BEGIN HDBSVT11_LDNQOR2_Y2_2

`celldefine
module HDBSVT11_LDNQOR2_Y2_2 (Q, G, TEN, EN);
   output Q;
   input G, TEN, EN;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_TEN, delayed_EN;

   wire int_res__G, int_res__d;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_TEN, TEN);
   buf inst2  (delayed_EN, EN);
`endif

   not inst3  (int_res__G, delayed_G);
   or inst4  (int_res__d, delayed_TEN, delayed_EN);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst5  (viol_x, viol_0, int_res__G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst6 (Q, viol_x, int_res__G, int_res__d);

   `else

        snps_latch inst7  (Q, viol_x, int_res__G, int_res__d);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (ENABLE_NOT_TEN, TEN);
not inst9  (_net_0, TEN);
not inst10  (_net_1, EN);
and inst11  (ENABLE_NOT_EN_AND_NOT_TEN, _net_0, _net_1);
not inst12  (_net_2, EN);
and inst13  (ENABLE_NOT_EN_AND_TEN, TEN, _net_2);
not inst14  (_net_3, TEN);
and inst15  (ENABLE_EN_AND_NOT_TEN, _net_3, EN);
and inst16  (ENABLE_EN_AND_TEN, TEN, EN);
not inst17  (ENABLE_NOT_EN, EN);

specify
if (G==1'b0 && TEN==1'b0) (EN +=> Q)=(0, 0);
ifnone (EN +=> Q)=(0, 0);
if (EN==1'b0 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && TEN==1'b0) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b0 && TEN==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
if (EN==1'b0 && G==1'b0) (TEN +=> Q)=(0, 0);
ifnone (TEN +=> Q)=(0, 0);
$setuphold(posedge G &&& ENABLE_NOT_TEN , posedge EN &&& ENABLE_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$setuphold(posedge G &&& ENABLE_NOT_TEN , negedge EN &&& ENABLE_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$width(negedge G &&& ENABLE_NOT_EN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_EN_AND_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_TEN , 0 ,0, viol_0);
$setuphold(posedge G &&& ENABLE_NOT_EN , posedge TEN &&& ENABLE_NOT_EN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
$setuphold(posedge G &&& ENABLE_NOT_EN , negedge TEN &&& ENABLE_NOT_EN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNQOR2_Y2_2

//%BEGIN HDBSVT11_LDNQOR2_Y2_4

`celldefine
module HDBSVT11_LDNQOR2_Y2_4 (Q, G, TEN, EN);
   output Q;
   input G, TEN, EN;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_TEN, delayed_EN;

   wire int_res__G, int_res__d;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_TEN, TEN);
   buf inst2  (delayed_EN, EN);
`endif

   not inst3  (int_res__G, delayed_G);
   or inst4  (int_res__d, delayed_TEN, delayed_EN);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst5  (viol_x, viol_0, int_res__G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst6 (Q, viol_x, int_res__G, int_res__d);

   `else

        snps_latch inst7  (Q, viol_x, int_res__G, int_res__d);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (ENABLE_NOT_TEN, TEN);
not inst9  (_net_0, TEN);
not inst10  (_net_1, EN);
and inst11  (ENABLE_NOT_EN_AND_NOT_TEN, _net_0, _net_1);
not inst12  (_net_2, EN);
and inst13  (ENABLE_NOT_EN_AND_TEN, TEN, _net_2);
not inst14  (_net_3, TEN);
and inst15  (ENABLE_EN_AND_NOT_TEN, _net_3, EN);
and inst16  (ENABLE_EN_AND_TEN, TEN, EN);
not inst17  (ENABLE_NOT_EN, EN);

specify
if (G==1'b0 && TEN==1'b0) (EN +=> Q)=(0, 0);
ifnone (EN +=> Q)=(0, 0);
if (EN==1'b0 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && TEN==1'b0) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b1 && TEN==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (EN==1'b0 && TEN==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
if (EN==1'b0 && G==1'b0) (TEN +=> Q)=(0, 0);
ifnone (TEN +=> Q)=(0, 0);
$setuphold(posedge G &&& ENABLE_NOT_TEN , posedge EN &&& ENABLE_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$setuphold(posedge G &&& ENABLE_NOT_TEN , negedge EN &&& ENABLE_NOT_TEN , 0 ,0, viol_0, , , delayed_G, delayed_EN);
$width(negedge G &&& ENABLE_NOT_EN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_NOT_EN_AND_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_NOT_TEN , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_EN_AND_TEN , 0 ,0, viol_0);
$setuphold(posedge G &&& ENABLE_NOT_EN , posedge TEN &&& ENABLE_NOT_EN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
$setuphold(posedge G &&& ENABLE_NOT_EN , negedge TEN &&& ENABLE_NOT_EN , 0 ,0, viol_0, , , delayed_G, delayed_TEN);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNQOR2_Y2_4

//%BEGIN HDBSVT11_LDNQ_V2Y2_1

`celldefine
module HDBSVT11_LDNQ_V2Y2_1 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   wire int_res__G;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif

   not inst2  (int_res__G, delayed_G);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_res__G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst4 (Q, viol_x, int_res__G, delayed_D);

   `else

        snps_latch inst5  (Q, viol_x, int_res__G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (G==1'b0) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
$setuphold(posedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(posedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(negedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNQ_V2Y2_1

//%BEGIN HDBSVT11_LDNQ_V2Y2_2

`celldefine
module HDBSVT11_LDNQ_V2Y2_2 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   wire int_res__G;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif

   not inst2  (int_res__G, delayed_G);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_res__G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst4 (Q, viol_x, int_res__G, delayed_D);

   `else

        snps_latch inst5  (Q, viol_x, int_res__G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (G==1'b0) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
$setuphold(posedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(posedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(negedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNQ_V2Y2_2

//%BEGIN HDBSVT11_LDNQ_V2Y2_3

`celldefine
module HDBSVT11_LDNQ_V2Y2_3 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   wire int_res__G;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif

   not inst2  (int_res__G, delayed_G);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_res__G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst4 (Q, viol_x, int_res__G, delayed_D);

   `else

        snps_latch inst5  (Q, viol_x, int_res__G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (G==1'b0) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
$setuphold(posedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(posedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(negedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNQ_V2Y2_3

//%BEGIN HDBSVT11_LDNQ_V2Y2_4

`celldefine
module HDBSVT11_LDNQ_V2Y2_4 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   wire int_res__G;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif

   not inst2  (int_res__G, delayed_G);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_res__G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst4 (Q, viol_x, int_res__G, delayed_D);

   `else

        snps_latch inst5  (Q, viol_x, int_res__G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (G==1'b0) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
$setuphold(posedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(posedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(negedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNQ_V2Y2_4

//%BEGIN HDBSVT11_LDNQ_V2Y2_5

`celldefine
module HDBSVT11_LDNQ_V2Y2_5 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   wire int_res__G;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif

   not inst2  (int_res__G, delayed_G);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_res__G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst4 (Q, viol_x, int_res__G, delayed_D);

   `else

        snps_latch inst5  (Q, viol_x, int_res__G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (G==1'b0) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
$setuphold(posedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(posedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(negedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNQ_V2Y2_5

//%BEGIN HDBSVT11_LDNQ_V2Y2_6

`celldefine
module HDBSVT11_LDNQ_V2Y2_6 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   wire int_res__G;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif

   not inst2  (int_res__G, delayed_G);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_res__G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst4 (Q, viol_x, int_res__G, delayed_D);

   `else

        snps_latch inst5  (Q, viol_x, int_res__G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (G==1'b0) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
$setuphold(posedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(posedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(negedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNQ_V2Y2_6

//%BEGIN HDBSVT11_LDNQ_V2Y2_8

`celldefine
module HDBSVT11_LDNQ_V2Y2_8 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   wire int_res__G;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif

   not inst2  (int_res__G, delayed_G);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_res__G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst4 (Q, viol_x, int_res__G, delayed_D);

   `else

        snps_latch inst5  (Q, viol_x, int_res__G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (G==1'b0) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
$setuphold(posedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(posedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(negedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNQ_V2Y2_8

//%BEGIN HDBSVT11_LDNQ_V2_1

`celldefine
module HDBSVT11_LDNQ_V2_1 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   wire int_res__G;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif

   not inst2  (int_res__G, delayed_G);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_res__G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst4 (Q, viol_x, int_res__G, delayed_D);

   `else

        snps_latch inst5  (Q, viol_x, int_res__G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst6  (ENABLE_NOT_D, D);
buf inst7  (ENABLE_D, D);

specify
if (G==1'b0) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b0) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
$setuphold(posedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(posedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(negedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNQ_V2_1

//%BEGIN HDBSVT11_LDNRBQ_V2Y2_1

`celldefine
module HDBSVT11_LDNRBQ_V2Y2_1 (Q, G, D, RD);
   output Q;
   input G, D, RD;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D, delayed_RD;

   wire int_res__G, int_res__RD;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RD, RD);
`endif

   not inst3  (int_res__G, delayed_G);
   not inst4  (int_res__RD, delayed_RD);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst5  (viol_x, viol_0, int_res__G, int_res__RD, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch_r #`SNPS_LAT_DELAY  inst6 (Q, viol_x, int_res__G, delayed_D, int_res__RD);
    `else
        snps_latch_r inst7  (Q, viol_x, int_res__G, delayed_D, int_res__RD);
    `endif

    `ifdef VIRL_functiononly

    `else

buf inst8  (ENABLE_RD, RD);
not inst9  (_net_0, D);
and inst10  (ENABLE_NOT_D_AND_RD, RD, _net_0);
and inst11  (ENABLE_D_AND_RD, RD, D);
buf inst12  (ENABLE_D, D);
not inst13  (_net_1, D);
and inst14  (ENABLE_NOT_D_AND_G, G, _net_1);
and inst15  (ENABLE_D_AND_G, G, D);

specify
if (G==1'b0 && RD==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b1 && RD==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
if (D==1'b0 && G==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (D==1'b1 && G==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (D==1'b1 && G==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
$setuphold(posedge G &&& ENABLE_RD , posedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(posedge G &&& ENABLE_RD , negedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(negedge G &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$recrem(posedge RD &&& ENABLE_D , posedge G &&& ENABLE_D , 0 ,0, viol_0, , , delayed_RD, delayed_G);
$width(negedge RD &&& ENABLE_NOT_D_AND_G , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_D_AND_G , 0 ,0, viol_0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNRBQ_V2Y2_1

//%BEGIN HDBSVT11_LDNRBQ_V2Y2_2

`celldefine
module HDBSVT11_LDNRBQ_V2Y2_2 (Q, G, D, RD);
   output Q;
   input G, D, RD;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D, delayed_RD;

   wire int_res__G, int_res__RD;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RD, RD);
`endif

   not inst3  (int_res__G, delayed_G);
   not inst4  (int_res__RD, delayed_RD);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst5  (viol_x, viol_0, int_res__G, int_res__RD, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch_r #`SNPS_LAT_DELAY  inst6 (Q, viol_x, int_res__G, delayed_D, int_res__RD);
    `else
        snps_latch_r inst7  (Q, viol_x, int_res__G, delayed_D, int_res__RD);
    `endif

    `ifdef VIRL_functiononly

    `else

buf inst8  (ENABLE_RD, RD);
not inst9  (_net_0, D);
and inst10  (ENABLE_NOT_D_AND_RD, RD, _net_0);
and inst11  (ENABLE_D_AND_RD, RD, D);
buf inst12  (ENABLE_D, D);
not inst13  (_net_1, D);
and inst14  (ENABLE_NOT_D_AND_G, G, _net_1);
and inst15  (ENABLE_D_AND_G, G, D);

specify
if (G==1'b0 && RD==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b1 && RD==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
if (D==1'b0 && G==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (D==1'b1 && G==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (D==1'b1 && G==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
$setuphold(posedge G &&& ENABLE_RD , posedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(posedge G &&& ENABLE_RD , negedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(negedge G &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$recrem(posedge RD &&& ENABLE_D , posedge G &&& ENABLE_D , 0 ,0, viol_0, , , delayed_RD, delayed_G);
$width(negedge RD &&& ENABLE_NOT_D_AND_G , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_D_AND_G , 0 ,0, viol_0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNRBQ_V2Y2_2

//%BEGIN HDBSVT11_LDNRBQ_V2Y2_4

`celldefine
module HDBSVT11_LDNRBQ_V2Y2_4 (Q, G, D, RD);
   output Q;
   input G, D, RD;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D, delayed_RD;

   wire int_res__G, int_res__RD;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RD, RD);
`endif

   not inst3  (int_res__G, delayed_G);
   not inst4  (int_res__RD, delayed_RD);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst5  (viol_x, viol_0, int_res__G, int_res__RD, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch_r #`SNPS_LAT_DELAY  inst6 (Q, viol_x, int_res__G, delayed_D, int_res__RD);
    `else
        snps_latch_r inst7  (Q, viol_x, int_res__G, delayed_D, int_res__RD);
    `endif

    `ifdef VIRL_functiononly

    `else

buf inst8  (ENABLE_RD, RD);
not inst9  (_net_0, D);
and inst10  (ENABLE_NOT_D_AND_RD, RD, _net_0);
and inst11  (ENABLE_D_AND_RD, RD, D);
buf inst12  (ENABLE_D, D);
not inst13  (_net_1, D);
and inst14  (ENABLE_NOT_D_AND_G, G, _net_1);
and inst15  (ENABLE_D_AND_G, G, D);

specify
if (G==1'b0 && RD==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b1 && RD==1'b1) (negedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b1) (negedge G => (Q +: 1'b1))=(0, 0);
(negedge G => (Q : 1'b1))=(0, 0);
if (D==1'b0 && G==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
if (D==1'b1 && G==1'b0) (negedge RD => (Q +: 1'b0))=(0, 0);
if (D==1'b1 && G==1'b1) (negedge RD => (Q +: 1'b0))=(0, 0);
(negedge RD => (Q : 1'b0))=(0, 0);
$setuphold(posedge G &&& ENABLE_RD , posedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(posedge G &&& ENABLE_RD , negedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(negedge G &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge G &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$recrem(posedge RD &&& ENABLE_D , posedge G &&& ENABLE_D , 0 ,0, viol_0, , , delayed_RD, delayed_G);
$width(negedge RD &&& ENABLE_NOT_D_AND_G , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_D_AND_G , 0 ,0, viol_0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDNRBQ_V2Y2_4

`celldefine
module HDBSVT11_LDPQM4_V2Y4_1 (Q0, Q1, Q2, Q3, G, D0, D1, D2, D3);
  input G, D0, D1, D2, D3;
  output Q0, Q1, Q2, Q3;
  reg viol_0;
     wire viol_x;
  wire iq3, iq2, iq1, iq0;
  `ifdef _fv
    buf inst0  (delayed_G, G);
    buf inst1  (delayed_D0, D0);
    buf inst2  (delayed_D1, D1);
    buf inst3  (delayed_D2, D2);
    buf inst4  (delayed_D3, D3);
  `endif


    snps_latch inst5  (iq3, viol_x, delayed_G, delayed_D3);
    snps_latch inst6  (iq2, viol_x, delayed_G, delayed_D2);
    snps_latch inst7  (iq1, viol_x, delayed_G, delayed_D1);
    snps_latch inst8  (iq0, viol_x, delayed_G, delayed_D0);
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst9  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (Q3, iq3);
    buf #`SNPS_SEQ_DELAY  inst11 (Q2, iq2);
    buf #`SNPS_SEQ_DELAY  inst12 (Q1, iq1);
    buf #`SNPS_SEQ_DELAY  inst13 (Q0, iq0);
  `else
    buf inst14  (Q3, iq3);
    buf inst15  (Q2, iq2);
    buf inst16  (Q1, iq1);
    buf inst17  (Q0, iq0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst18  (_net_0, D1);
not inst19  (_net_1, D0);
not inst20  (_net_2, D2);
not inst21  (_net_3, D3);
and inst22  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_0, _net_1, _net_2, _net_3);
not inst23  (_net_4, D1);
not inst24  (_net_5, D0);
not inst25  (_net_6, D2);
and inst26  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3, _net_4, _net_5, _net_6, D3);
not inst27  (_net_7, D1);
not inst28  (_net_8, D0);
not inst29  (_net_9, D3);
and inst30  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3, _net_7, _net_8, D2, _net_9);
not inst31  (_net_10, D1);
not inst32  (_net_11, D0);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3, _net_10, _net_11, D2, D3);
not inst34  (_net_12, D0);
not inst35  (_net_13, D2);
not inst36  (_net_14, D3);
and inst37  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3, D1, _net_12, _net_13, _net_14);
not inst38  (_net_15, D1);
not inst39  (_net_16, D2);
not inst40  (_net_17, D3);
and inst41  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_15, D0, _net_16, _net_17);
not inst42  (_net_18, D1);
not inst43  (_net_19, D3);
and inst44  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3, _net_18, D0, D2, _net_19);
not inst45  (_net_20, D1);
and inst46  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3, _net_20, D0, D2, D3);
and inst47  (ENABLE_D0_AND_D1_AND_D2_AND_D3, D1, D0, D2, D3);

specify
if (D0==1'b0) (posedge G => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1) (posedge G => (Q0 +: 1'b1))=(0, 0);
(posedge G => (Q0 : 1'b1))=(0, 0);
if (G==1'b1) (D0 +=> Q0)=(0, 0);
ifnone (D0 +=> Q0)=(0, 0);
if (D1==1'b0) (posedge G => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1) (posedge G => (Q1 +: 1'b1))=(0, 0);
(posedge G => (Q1 : 1'b1))=(0, 0);
if (G==1'b1) (D1 +=> Q1)=(0, 0);
ifnone (D1 +=> Q1)=(0, 0);
if (D2==1'b0) (posedge G => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1) (posedge G => (Q2 +: 1'b1))=(0, 0);
(posedge G => (Q2 : 1'b1))=(0, 0);
if (G==1'b1) (D2 +=> Q2)=(0, 0);
ifnone (D2 +=> Q2)=(0, 0);
if (D3==1'b0) (posedge G => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1) (posedge G => (Q3 +: 1'b1))=(0, 0);
(posedge G => (Q3 : 1'b1))=(0, 0);
if (G==1'b1) (D3 +=> Q3)=(0, 0);
ifnone (D3 +=> Q3)=(0, 0);
$width(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D0_AND_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(posedge G , 0 ,0, viol_0);
$setuphold(negedge G , posedge D0 , 0 ,0, viol_0, , , delayed_G, delayed_D0);
$setuphold(negedge G , negedge D0 , 0 ,0, viol_0, , , delayed_G, delayed_D0);
$setuphold(negedge G , posedge D1 , 0 ,0, viol_0, , , delayed_G, delayed_D1);
$setuphold(negedge G , negedge D1 , 0 ,0, viol_0, , , delayed_G, delayed_D1);
$setuphold(negedge G , posedge D2 , 0 ,0, viol_0, , , delayed_G, delayed_D2);
$setuphold(negedge G , negedge D2 , 0 ,0, viol_0, , , delayed_G, delayed_D2);
$setuphold(negedge G , posedge D3 , 0 ,0, viol_0, , , delayed_G, delayed_D3);
$setuphold(negedge G , negedge D3 , 0 ,0, viol_0, , , delayed_G, delayed_D3);
endspecify
  `endif
endmodule
`endcelldefine


`celldefine
module HDBSVT11_LDPQM4_V2Y4_2 (Q0, Q1, Q2, Q3, G, D0, D1, D2, D3);
  input G, D0, D1, D2, D3;
  output Q0, Q1, Q2, Q3;
  reg viol_0;
     wire viol_x;
  wire iq3, iq2, iq1, iq0;
  `ifdef _fv
    buf inst0  (delayed_G, G);
    buf inst1  (delayed_D0, D0);
    buf inst2  (delayed_D1, D1);
    buf inst3  (delayed_D2, D2);
    buf inst4  (delayed_D3, D3);
  `endif


    snps_latch inst5  (iq3, viol_x, delayed_G, delayed_D3);
    snps_latch inst6  (iq2, viol_x, delayed_G, delayed_D2);
    snps_latch inst7  (iq1, viol_x, delayed_G, delayed_D1);
    snps_latch inst8  (iq0, viol_x, delayed_G, delayed_D0);
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst9  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (Q3, iq3);
    buf #`SNPS_SEQ_DELAY  inst11 (Q2, iq2);
    buf #`SNPS_SEQ_DELAY  inst12 (Q1, iq1);
    buf #`SNPS_SEQ_DELAY  inst13 (Q0, iq0);
  `else
    buf inst14  (Q3, iq3);
    buf inst15  (Q2, iq2);
    buf inst16  (Q1, iq1);
    buf inst17  (Q0, iq0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst18  (_net_0, D1);
not inst19  (_net_1, D0);
not inst20  (_net_2, D2);
not inst21  (_net_3, D3);
and inst22  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_0, _net_1, _net_2, _net_3);
not inst23  (_net_4, D1);
not inst24  (_net_5, D0);
not inst25  (_net_6, D2);
and inst26  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3, _net_4, _net_5, _net_6, D3);
not inst27  (_net_7, D1);
not inst28  (_net_8, D0);
not inst29  (_net_9, D3);
and inst30  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3, _net_7, _net_8, D2, _net_9);
not inst31  (_net_10, D1);
not inst32  (_net_11, D0);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3, _net_10, _net_11, D2, D3);
not inst34  (_net_12, D0);
not inst35  (_net_13, D2);
not inst36  (_net_14, D3);
and inst37  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3, D1, _net_12, _net_13, _net_14);
not inst38  (_net_15, D1);
not inst39  (_net_16, D2);
not inst40  (_net_17, D3);
and inst41  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_15, D0, _net_16, _net_17);
not inst42  (_net_18, D1);
not inst43  (_net_19, D3);
and inst44  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3, _net_18, D0, D2, _net_19);
not inst45  (_net_20, D1);
and inst46  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3, _net_20, D0, D2, D3);
and inst47  (ENABLE_D0_AND_D1_AND_D2_AND_D3, D1, D0, D2, D3);

specify
if (D0==1'b0) (posedge G => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1) (posedge G => (Q0 +: 1'b1))=(0, 0);
(posedge G => (Q0 : 1'b1))=(0, 0);
if (G==1'b1) (D0 +=> Q0)=(0, 0);
ifnone (D0 +=> Q0)=(0, 0);
if (D1==1'b0) (posedge G => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1) (posedge G => (Q1 +: 1'b1))=(0, 0);
(posedge G => (Q1 : 1'b1))=(0, 0);
if (G==1'b1) (D1 +=> Q1)=(0, 0);
ifnone (D1 +=> Q1)=(0, 0);
if (D2==1'b0) (posedge G => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1) (posedge G => (Q2 +: 1'b1))=(0, 0);
(posedge G => (Q2 : 1'b1))=(0, 0);
if (G==1'b1) (D2 +=> Q2)=(0, 0);
ifnone (D2 +=> Q2)=(0, 0);
if (D3==1'b0) (posedge G => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1) (posedge G => (Q3 +: 1'b1))=(0, 0);
(posedge G => (Q3 : 1'b1))=(0, 0);
if (G==1'b1) (D3 +=> Q3)=(0, 0);
ifnone (D3 +=> Q3)=(0, 0);
$width(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D0_AND_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(posedge G , 0 ,0, viol_0);
$setuphold(negedge G , posedge D0 , 0 ,0, viol_0, , , delayed_G, delayed_D0);
$setuphold(negedge G , negedge D0 , 0 ,0, viol_0, , , delayed_G, delayed_D0);
$setuphold(negedge G , posedge D1 , 0 ,0, viol_0, , , delayed_G, delayed_D1);
$setuphold(negedge G , negedge D1 , 0 ,0, viol_0, , , delayed_G, delayed_D1);
$setuphold(negedge G , posedge D2 , 0 ,0, viol_0, , , delayed_G, delayed_D2);
$setuphold(negedge G , negedge D2 , 0 ,0, viol_0, , , delayed_G, delayed_D2);
$setuphold(negedge G , posedge D3 , 0 ,0, viol_0, , , delayed_G, delayed_D3);
$setuphold(negedge G , negedge D3 , 0 ,0, viol_0, , , delayed_G, delayed_D3);
endspecify
  `endif
endmodule
`endcelldefine


`celldefine
module HDBSVT11_LDPQM4_V2Y8_1 (Q0, Q1, Q2, Q3, G, D0, D1, D2, D3);
  input G, D0, D1, D2, D3;
  output Q0, Q1, Q2, Q3;
  reg viol_0;
     wire viol_x;
  wire iq3, iq2, iq1, iq0;
  `ifdef _fv
    buf inst0  (delayed_G, G);
    buf inst1  (delayed_D0, D0);
    buf inst2  (delayed_D1, D1);
    buf inst3  (delayed_D2, D2);
    buf inst4  (delayed_D3, D3);
  `endif


    snps_latch inst5  (iq3, viol_x, delayed_G, delayed_D3);
    snps_latch inst6  (iq2, viol_x, delayed_G, delayed_D2);
    snps_latch inst7  (iq1, viol_x, delayed_G, delayed_D1);
    snps_latch inst8  (iq0, viol_x, delayed_G, delayed_D0);
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst9  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (Q3, iq3);
    buf #`SNPS_SEQ_DELAY  inst11 (Q2, iq2);
    buf #`SNPS_SEQ_DELAY  inst12 (Q1, iq1);
    buf #`SNPS_SEQ_DELAY  inst13 (Q0, iq0);
  `else
    buf inst14  (Q3, iq3);
    buf inst15  (Q2, iq2);
    buf inst16  (Q1, iq1);
    buf inst17  (Q0, iq0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst18  (_net_0, D1);
not inst19  (_net_1, D0);
not inst20  (_net_2, D2);
not inst21  (_net_3, D3);
and inst22  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_0, _net_1, _net_2, _net_3);
not inst23  (_net_4, D1);
not inst24  (_net_5, D0);
not inst25  (_net_6, D2);
and inst26  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3, _net_4, _net_5, _net_6, D3);
not inst27  (_net_7, D1);
not inst28  (_net_8, D0);
not inst29  (_net_9, D3);
and inst30  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3, _net_7, _net_8, D2, _net_9);
not inst31  (_net_10, D1);
not inst32  (_net_11, D0);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3, _net_10, _net_11, D2, D3);
not inst34  (_net_12, D0);
not inst35  (_net_13, D2);
not inst36  (_net_14, D3);
and inst37  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3, D1, _net_12, _net_13, _net_14);
not inst38  (_net_15, D1);
not inst39  (_net_16, D2);
not inst40  (_net_17, D3);
and inst41  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_15, D0, _net_16, _net_17);
not inst42  (_net_18, D1);
not inst43  (_net_19, D3);
and inst44  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3, _net_18, D0, D2, _net_19);
not inst45  (_net_20, D1);
and inst46  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3, _net_20, D0, D2, D3);
and inst47  (ENABLE_D0_AND_D1_AND_D2_AND_D3, D1, D0, D2, D3);

specify
if (D0==1'b0) (posedge G => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1) (posedge G => (Q0 +: 1'b1))=(0, 0);
(posedge G => (Q0 : 1'b1))=(0, 0);
if (G==1'b1) (D0 +=> Q0)=(0, 0);
ifnone (D0 +=> Q0)=(0, 0);
if (D1==1'b0) (posedge G => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1) (posedge G => (Q1 +: 1'b1))=(0, 0);
(posedge G => (Q1 : 1'b1))=(0, 0);
if (G==1'b1) (D1 +=> Q1)=(0, 0);
ifnone (D1 +=> Q1)=(0, 0);
if (D2==1'b0) (posedge G => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1) (posedge G => (Q2 +: 1'b1))=(0, 0);
(posedge G => (Q2 : 1'b1))=(0, 0);
if (G==1'b1) (D2 +=> Q2)=(0, 0);
ifnone (D2 +=> Q2)=(0, 0);
if (D3==1'b0) (posedge G => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1) (posedge G => (Q3 +: 1'b1))=(0, 0);
(posedge G => (Q3 : 1'b1))=(0, 0);
if (G==1'b1) (D3 +=> Q3)=(0, 0);
ifnone (D3 +=> Q3)=(0, 0);
$width(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D0_AND_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(posedge G , 0 ,0, viol_0);
$setuphold(negedge G , posedge D0 , 0 ,0, viol_0, , , delayed_G, delayed_D0);
$setuphold(negedge G , negedge D0 , 0 ,0, viol_0, , , delayed_G, delayed_D0);
$setuphold(negedge G , posedge D1 , 0 ,0, viol_0, , , delayed_G, delayed_D1);
$setuphold(negedge G , negedge D1 , 0 ,0, viol_0, , , delayed_G, delayed_D1);
$setuphold(negedge G , posedge D2 , 0 ,0, viol_0, , , delayed_G, delayed_D2);
$setuphold(negedge G , negedge D2 , 0 ,0, viol_0, , , delayed_G, delayed_D2);
$setuphold(negedge G , posedge D3 , 0 ,0, viol_0, , , delayed_G, delayed_D3);
$setuphold(negedge G , negedge D3 , 0 ,0, viol_0, , , delayed_G, delayed_D3);
endspecify
  `endif
endmodule
`endcelldefine


`celldefine
module HDBSVT11_LDPQM4_V2Y8_2 (Q0, Q1, Q2, Q3, G, D0, D1, D2, D3);
  input G, D0, D1, D2, D3;
  output Q0, Q1, Q2, Q3;
  reg viol_0;
     wire viol_x;
  wire iq3, iq2, iq1, iq0;
  `ifdef _fv
    buf inst0  (delayed_G, G);
    buf inst1  (delayed_D0, D0);
    buf inst2  (delayed_D1, D1);
    buf inst3  (delayed_D2, D2);
    buf inst4  (delayed_D3, D3);
  `endif


    snps_latch inst5  (iq3, viol_x, delayed_G, delayed_D3);
    snps_latch inst6  (iq2, viol_x, delayed_G, delayed_D2);
    snps_latch inst7  (iq1, viol_x, delayed_G, delayed_D1);
    snps_latch inst8  (iq0, viol_x, delayed_G, delayed_D0);
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst9  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (Q3, iq3);
    buf #`SNPS_SEQ_DELAY  inst11 (Q2, iq2);
    buf #`SNPS_SEQ_DELAY  inst12 (Q1, iq1);
    buf #`SNPS_SEQ_DELAY  inst13 (Q0, iq0);
  `else
    buf inst14  (Q3, iq3);
    buf inst15  (Q2, iq2);
    buf inst16  (Q1, iq1);
    buf inst17  (Q0, iq0);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst18  (_net_0, D1);
not inst19  (_net_1, D0);
not inst20  (_net_2, D2);
not inst21  (_net_3, D3);
and inst22  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_0, _net_1, _net_2, _net_3);
not inst23  (_net_4, D1);
not inst24  (_net_5, D0);
not inst25  (_net_6, D2);
and inst26  (ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3, _net_4, _net_5, _net_6, D3);
not inst27  (_net_7, D1);
not inst28  (_net_8, D0);
not inst29  (_net_9, D3);
and inst30  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3, _net_7, _net_8, D2, _net_9);
not inst31  (_net_10, D1);
not inst32  (_net_11, D0);
and inst33  (ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3, _net_10, _net_11, D2, D3);
not inst34  (_net_12, D0);
not inst35  (_net_13, D2);
not inst36  (_net_14, D3);
and inst37  (ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3, D1, _net_12, _net_13, _net_14);
not inst38  (_net_15, D1);
not inst39  (_net_16, D2);
not inst40  (_net_17, D3);
and inst41  (ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3, _net_15, D0, _net_16, _net_17);
not inst42  (_net_18, D1);
not inst43  (_net_19, D3);
and inst44  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3, _net_18, D0, D2, _net_19);
not inst45  (_net_20, D1);
and inst46  (ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3, _net_20, D0, D2, D3);
and inst47  (ENABLE_D0_AND_D1_AND_D2_AND_D3, D1, D0, D2, D3);

specify
if (D0==1'b0) (posedge G => (Q0 -: 1'b1))=(0, 0);
if (D0==1'b1) (posedge G => (Q0 +: 1'b1))=(0, 0);
(posedge G => (Q0 : 1'b1))=(0, 0);
if (G==1'b1) (D0 +=> Q0)=(0, 0);
ifnone (D0 +=> Q0)=(0, 0);
if (D1==1'b0) (posedge G => (Q1 -: 1'b1))=(0, 0);
if (D1==1'b1) (posedge G => (Q1 +: 1'b1))=(0, 0);
(posedge G => (Q1 : 1'b1))=(0, 0);
if (G==1'b1) (D1 +=> Q1)=(0, 0);
ifnone (D1 +=> Q1)=(0, 0);
if (D2==1'b0) (posedge G => (Q2 -: 1'b1))=(0, 0);
if (D2==1'b1) (posedge G => (Q2 +: 1'b1))=(0, 0);
(posedge G => (Q2 : 1'b1))=(0, 0);
if (G==1'b1) (D2 +=> Q2)=(0, 0);
ifnone (D2 +=> Q2)=(0, 0);
if (D3==1'b0) (posedge G => (Q3 -: 1'b1))=(0, 0);
if (D3==1'b1) (posedge G => (Q3 +: 1'b1))=(0, 0);
(posedge G => (Q3 : 1'b1))=(0, 0);
if (G==1'b1) (D3 +=> Q3)=(0, 0);
ifnone (D3 +=> Q3)=(0, 0);
$width(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_NOT_D2_AND_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_D0_AND_NOT_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_NOT_D0_AND_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D0_AND_NOT_D1_AND_NOT_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_NOT_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D0_AND_NOT_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D0_AND_D1_AND_D2_AND_D3 , 0 ,0, viol_0);
$width(posedge G , 0 ,0, viol_0);
$setuphold(negedge G , posedge D0 , 0 ,0, viol_0, , , delayed_G, delayed_D0);
$setuphold(negedge G , negedge D0 , 0 ,0, viol_0, , , delayed_G, delayed_D0);
$setuphold(negedge G , posedge D1 , 0 ,0, viol_0, , , delayed_G, delayed_D1);
$setuphold(negedge G , negedge D1 , 0 ,0, viol_0, , , delayed_G, delayed_D1);
$setuphold(negedge G , posedge D2 , 0 ,0, viol_0, , , delayed_G, delayed_D2);
$setuphold(negedge G , negedge D2 , 0 ,0, viol_0, , , delayed_G, delayed_D2);
$setuphold(negedge G , posedge D3 , 0 ,0, viol_0, , , delayed_G, delayed_D3);
$setuphold(negedge G , negedge D3 , 0 ,0, viol_0, , , delayed_G, delayed_D3);
endspecify
  `endif
endmodule
`endcelldefine


//%BEGIN HDBSVT11_LDPQ_CBV2Y2_1

`celldefine
module HDBSVT11_LDPQ_CBV2Y2_1 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst3 (Q, viol_x, delayed_G, delayed_D);

    `else

        snps_latch inst4  (Q, viol_x, delayed_G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (G==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
$setuphold(negedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDPQ_CBV2Y2_1

//%BEGIN HDBSVT11_LDPQ_CBV2Y2_2

`celldefine
module HDBSVT11_LDPQ_CBV2Y2_2 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst3 (Q, viol_x, delayed_G, delayed_D);

    `else

        snps_latch inst4  (Q, viol_x, delayed_G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (G==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
$setuphold(negedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDPQ_CBV2Y2_2

//%BEGIN HDBSVT11_LDPQ_CBY2ECOM2FS_1

`celldefine
module HDBSVT11_LDPQ_CBY2ECOM2FS_1 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst3 (Q, viol_x, delayed_G, delayed_D);

    `else

        snps_latch inst4  (Q, viol_x, delayed_G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (G==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
$setuphold(negedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDPQ_CBY2ECOM2FS_1

//%BEGIN HDBSVT11_LDPQ_CBY2ECOM2_1

`celldefine
module HDBSVT11_LDPQ_CBY2ECOM2_1 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst3 (Q, viol_x, delayed_G, delayed_D);

    `else

        snps_latch inst4  (Q, viol_x, delayed_G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (G==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
$setuphold(negedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDPQ_CBY2ECOM2_1

//%BEGIN HDBSVT11_LDPQ_CBY3ECO_1

`celldefine
module HDBSVT11_LDPQ_CBY3ECO_1 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst3 (Q, viol_x, delayed_G, delayed_D);

    `else

        snps_latch inst4  (Q, viol_x, delayed_G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (G==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
$setuphold(negedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDPQ_CBY3ECO_1

//%BEGIN HDBSVT11_LDPQ_V2Y2_1

`celldefine
module HDBSVT11_LDPQ_V2Y2_1 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst3 (Q, viol_x, delayed_G, delayed_D);

    `else

        snps_latch inst4  (Q, viol_x, delayed_G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (G==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
$setuphold(negedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDPQ_V2Y2_1

//%BEGIN HDBSVT11_LDPQ_V2Y2_2

`celldefine
module HDBSVT11_LDPQ_V2Y2_2 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst3 (Q, viol_x, delayed_G, delayed_D);

    `else

        snps_latch inst4  (Q, viol_x, delayed_G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (G==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
$setuphold(negedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDPQ_V2Y2_2

//%BEGIN HDBSVT11_LDPQ_V2Y2_3

`celldefine
module HDBSVT11_LDPQ_V2Y2_3 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst3 (Q, viol_x, delayed_G, delayed_D);

    `else

        snps_latch inst4  (Q, viol_x, delayed_G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (G==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
$setuphold(negedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDPQ_V2Y2_3

//%BEGIN HDBSVT11_LDPQ_V2Y2_4

`celldefine
module HDBSVT11_LDPQ_V2Y2_4 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst3 (Q, viol_x, delayed_G, delayed_D);

    `else

        snps_latch inst4  (Q, viol_x, delayed_G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (G==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
$setuphold(negedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDPQ_V2Y2_4

//%BEGIN HDBSVT11_LDPQ_V2Y2_5

`celldefine
module HDBSVT11_LDPQ_V2Y2_5 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst3 (Q, viol_x, delayed_G, delayed_D);

    `else

        snps_latch inst4  (Q, viol_x, delayed_G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (G==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
$setuphold(negedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDPQ_V2Y2_5

//%BEGIN HDBSVT11_LDPQ_V2Y2_6

`celldefine
module HDBSVT11_LDPQ_V2Y2_6 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst3 (Q, viol_x, delayed_G, delayed_D);

    `else

        snps_latch inst4  (Q, viol_x, delayed_G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (G==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
$setuphold(negedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDPQ_V2Y2_6

//%BEGIN HDBSVT11_LDPQ_V2Y2_8

`celldefine
module HDBSVT11_LDPQ_V2Y2_8 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst3 (Q, viol_x, delayed_G, delayed_D);

    `else

        snps_latch inst4  (Q, viol_x, delayed_G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (G==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
$setuphold(negedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDPQ_V2Y2_8

//%BEGIN HDBSVT11_LDPQ_V2_1

`celldefine
module HDBSVT11_LDPQ_V2_1 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst3 (Q, viol_x, delayed_G, delayed_D);

    `else

        snps_latch inst4  (Q, viol_x, delayed_G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (G==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
$setuphold(negedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDPQ_V2_1

//%BEGIN HDBSVT11_LDPQ_Y2ECOM2FS_1

`celldefine
module HDBSVT11_LDPQ_Y2ECOM2FS_1 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst3 (Q, viol_x, delayed_G, delayed_D);

    `else

        snps_latch inst4  (Q, viol_x, delayed_G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (G==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
$setuphold(negedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDPQ_Y2ECOM2FS_1

//%BEGIN HDBSVT11_LDPQ_Y2ECOM2_1

`celldefine
module HDBSVT11_LDPQ_Y2ECOM2_1 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst3 (Q, viol_x, delayed_G, delayed_D);

    `else

        snps_latch inst4  (Q, viol_x, delayed_G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (G==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
$setuphold(negedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDPQ_Y2ECOM2_1

//%BEGIN HDBSVT11_LDPQ_Y3ECO_1

`celldefine
module HDBSVT11_LDPQ_Y3ECO_1 (Q, G, D);
   output Q;
   input G, D;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
`endif


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst2  (viol_x, viol_0, delayed_G, 1'b1, 1'b1);

  `endif
   `ifdef VIRL_functiononly
        snps_latch #`SNPS_LAT_DELAY  inst3 (Q, viol_x, delayed_G, delayed_D);

    `else

        snps_latch inst4  (Q, viol_x, delayed_G, delayed_D);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst5  (ENABLE_NOT_D, D);
buf inst6  (ENABLE_D, D);

specify
if (G==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
$setuphold(negedge G , posedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G , negedge D , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D , 0 ,0, viol_0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_LDPQ_Y3ECO_1

//%BEGIN HDBSVT11_LDPRSQB_Y2_1

`celldefine
module HDBSVT11_LDPRSQB_Y2_1 (QN, G, D, RD, SD);
   output QN;
   input G, D, RD, SD;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D,
	delayed_RD, delayed_SD;

   wire int_res__SD, int_res__RD, int_res_iq;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_RD, RD);
   buf inst3  (delayed_SD, SD);
`endif

   buf inst4  (int_res__SD, delayed_SD);
   buf inst5  (int_res__RD, delayed_RD);

   snps_latch_sr_1 inst6  (int_res_iq, viol_x, delayed_G, delayed_D, int_res__SD, int_res__RD);
  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst7  (viol_x, viol_0, delayed_G, int_res__SD, int_res__RD);

  `endif
`ifdef VIRL_functiononly
   not  #`SNPS_LAT_DELAY  inst8 (QN, int_res_iq);
`else
   not inst9  (QN, int_res_iq);
`endif
`ifdef VIRL_functiononly
`else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
not inst10  (ENABLE_NOT_RD, RD);
not inst11  (_net_0, RD);
not inst12  (_net_1, D);
not inst13  (_net_2, SD);
and inst14  (ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SD, _net_0, _net_1, _net_2);
not inst15  (_net_3, RD);
not inst16  (_net_4, SD);
and inst17  (ENABLE_D_AND_NOT_RD_AND_NOT_SD, _net_3, D, _net_4);
not inst18  (_net_5, SD);
and inst19  (ENABLE_D_AND_NOT_SD, _net_5, D);
not inst20  (_net_6, G);
not inst21  (_net_7, D);
not inst22  (_net_8, SD);
and inst23  (ENABLE_NOT_D_AND_NOT_G_AND_NOT_SD, _net_6, _net_7, _net_8);
not inst24  (_net_9, G);
not inst25  (_net_10, SD);
and inst26  (ENABLE_D_AND_NOT_G_AND_NOT_SD, _net_9, D, _net_10);
not inst27  (_net_11, G);
not inst28  (_net_12, D);
and inst29  (ENABLE_NOT_D_AND_NOT_G, _net_11, _net_12);
not inst30  (_net_13, G);
and inst31  (ENABLE_D_AND_NOT_G, _net_13, D);
not inst32  (_net_14, RD);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_NOT_RD, _net_14, _net_15);
not inst35  (_net_16, G);
not inst36  (_net_17, D);
not inst37  (_net_18, RD);
and inst38  (ENABLE_NOT_D_AND_NOT_G_AND_NOT_RD, _net_16, _net_17, _net_18);
not inst39  (_net_19, G);
not inst40  (_net_20, RD);
and inst41  (ENABLE_D_AND_NOT_G_AND_NOT_RD, _net_19, D, _net_20);

specify
if (RD==1'b0) (D -=> QN)=(0, 0);
ifnone (D -=> QN)=(0, 0);
if (D==1'b1 && RD==1'b0) (posedge G => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && RD==1'b0) (posedge G => (QN +: 1'b1))=(0, 0);
(posedge G => (QN : 1'b1))=(0, 0);
if (D==1'b0 && G==1'b0 && SD==1'b0) (posedge RD => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && G==1'b0 && SD==1'b0) (posedge RD => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && G==1'b1 && SD==1'b0) (posedge RD => (QN +: 1'b1))=(0, 0);
(posedge RD => (QN : 1'b0))=(0, 0);
if (D==1'b0 && G==1'b0) (posedge SD => (QN -: 1'b0))=(0, 0);
if (D==1'b0 && G==1'b1) (posedge SD => (QN -: 1'b0))=(0, 0);
if (D==1'b1 && G==1'b0) (posedge SD => (QN -: 1'b0))=(0, 0);
(posedge SD => (QN : 1'b1))=(0, 0);
$setuphold(negedge G &&& ENABLE_NOT_RD , posedge D &&& ENABLE_NOT_RD , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G &&& ENABLE_NOT_RD , negedge D &&& ENABLE_NOT_RD , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D_AND_NOT_RD_AND_NOT_SD , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D_AND_NOT_RD_AND_NOT_SD , 0 ,0, viol_0);
$recrem(negedge RD &&& ENABLE_D_AND_NOT_SD , negedge G &&& ENABLE_D_AND_NOT_SD , 0 ,0, viol_0, , , delayed_RD, delayed_G);
$width(posedge RD &&& ENABLE_NOT_D_AND_NOT_G_AND_NOT_SD , 0 ,0, viol_0);
$width(posedge RD &&& ENABLE_D_AND_NOT_G_AND_NOT_SD , 0 ,0, viol_0);
$setuphold(negedge SD &&& ENABLE_NOT_D_AND_NOT_G , negedge RD &&& ENABLE_NOT_D_AND_NOT_G , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$setuphold(negedge SD &&& ENABLE_D_AND_NOT_G , negedge RD &&& ENABLE_D_AND_NOT_G , 0 ,0, viol_0, , , delayed_SD, delayed_RD);
$recrem(negedge SD &&& ENABLE_NOT_D_AND_NOT_RD , negedge G &&& ENABLE_NOT_D_AND_NOT_RD , 0 ,0, viol_0, , , delayed_SD, delayed_G);
$setuphold(negedge RD &&& ENABLE_NOT_D_AND_NOT_G , negedge SD &&& ENABLE_NOT_D_AND_NOT_G , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$setuphold(negedge RD &&& ENABLE_D_AND_NOT_G , negedge SD &&& ENABLE_D_AND_NOT_G , 0 ,0, viol_0, , , delayed_RD, delayed_SD);
$width(posedge SD &&& ENABLE_NOT_D_AND_NOT_G_AND_NOT_RD , 0 ,0, viol_0);
$width(posedge SD &&& ENABLE_D_AND_NOT_G_AND_NOT_RD , 0 ,0, viol_0);
endspecify
`endif
endmodule
`endcelldefine

//%END HDBSVT11_LDPRSQB_Y2_1

//%BEGIN HDBSVT11_LDPSBQ_V2Y2_1

`celldefine
module HDBSVT11_LDPSBQ_V2Y2_1 (Q, G, D, SD);
   output Q;
   input G, D, SD;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D, delayed_SD;

   wire int_res__SD;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SD, SD);
`endif

   not inst3  (int_res__SD, delayed_SD);

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, delayed_G, int_res__SD, 1'b1);

  `endif
   `ifdef VIRL_functiononly
      snps_latch_s #`SNPS_LAT_DELAY  inst5 (Q, viol_x, delayed_G, delayed_D, int_res__SD);
   `else
      snps_latch_s inst6  (Q, viol_x, delayed_G, delayed_D, int_res__SD);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

buf inst7  (ENABLE_SD, SD);
not inst8  (_net_0, D);
and inst9  (ENABLE_NOT_D_AND_SD, SD, _net_0);
and inst10  (ENABLE_D_AND_SD, SD, D);
not inst11  (ENABLE_NOT_D, D);
not inst12  (_net_1, G);
not inst13  (_net_2, D);
and inst14  (ENABLE_NOT_D_AND_NOT_G, _net_1, _net_2);
not inst15  (_net_3, G);
and inst16  (ENABLE_D_AND_NOT_G, _net_3, D);

specify
if (G==1'b1 && SD==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0 && SD==1'b1) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
if (D==1'b0 && G==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && G==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && G==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
$setuphold(negedge G &&& ENABLE_SD , posedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G &&& ENABLE_SD , negedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$recrem(posedge SD &&& ENABLE_NOT_D , negedge G &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_G);
$width(negedge SD &&& ENABLE_NOT_D_AND_NOT_G , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_D_AND_NOT_G , 0 ,0, viol_0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_LDPSBQ_V2Y2_1


//%BEGIN HDBSVT11_LDPSBQ_V2Y2_2

`celldefine
module HDBSVT11_LDPSBQ_V2Y2_2 (Q, G, D, SD);
   output Q;
   input G, D, SD;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D, delayed_SD;

   wire int_res__SD;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SD, SD);
`endif

   not inst3  (int_res__SD, delayed_SD);

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, delayed_G, int_res__SD, 1'b1);

  `endif
   `ifdef VIRL_functiononly
      snps_latch_s #`SNPS_LAT_DELAY  inst5 (Q, viol_x, delayed_G, delayed_D, int_res__SD);
   `else
      snps_latch_s inst6  (Q, viol_x, delayed_G, delayed_D, int_res__SD);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

buf inst7  (ENABLE_SD, SD);
not inst8  (_net_0, D);
and inst9  (ENABLE_NOT_D_AND_SD, SD, _net_0);
and inst10  (ENABLE_D_AND_SD, SD, D);
not inst11  (ENABLE_NOT_D, D);
not inst12  (_net_1, G);
not inst13  (_net_2, D);
and inst14  (ENABLE_NOT_D_AND_NOT_G, _net_1, _net_2);
not inst15  (_net_3, G);
and inst16  (ENABLE_D_AND_NOT_G, _net_3, D);

specify
if (G==1'b1 && SD==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0 && SD==1'b1) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
if (D==1'b0 && G==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && G==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && G==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
$setuphold(negedge G &&& ENABLE_SD , posedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G &&& ENABLE_SD , negedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$recrem(posedge SD &&& ENABLE_NOT_D , negedge G &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_G);
$width(negedge SD &&& ENABLE_NOT_D_AND_NOT_G , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_D_AND_NOT_G , 0 ,0, viol_0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_LDPSBQ_V2Y2_2


//%BEGIN HDBSVT11_LDPSBQ_V2Y2_4

`celldefine
module HDBSVT11_LDPSBQ_V2Y2_4 (Q, G, D, SD);
   output Q;
   input G, D, SD;

   reg viol_0;
     wire viol_x;
   wire delayed_G, delayed_D, delayed_SD;

   wire int_res__SD;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_G, G);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SD, SD);
`endif

   not inst3  (int_res__SD, delayed_SD);

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, delayed_G, int_res__SD, 1'b1);

  `endif
   `ifdef VIRL_functiononly
      snps_latch_s #`SNPS_LAT_DELAY  inst5 (Q, viol_x, delayed_G, delayed_D, int_res__SD);
   `else
      snps_latch_s inst6  (Q, viol_x, delayed_G, delayed_D, int_res__SD);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

buf inst7  (ENABLE_SD, SD);
not inst8  (_net_0, D);
and inst9  (ENABLE_NOT_D_AND_SD, SD, _net_0);
and inst10  (ENABLE_D_AND_SD, SD, D);
not inst11  (ENABLE_NOT_D, D);
not inst12  (_net_1, G);
not inst13  (_net_2, D);
and inst14  (ENABLE_NOT_D_AND_NOT_G, _net_1, _net_2);
not inst15  (_net_3, G);
and inst16  (ENABLE_D_AND_NOT_G, _net_3, D);

specify
if (G==1'b1 && SD==1'b1) (D +=> Q)=(0, 0);
ifnone (D +=> Q)=(0, 0);
if (D==1'b0 && SD==1'b1) (posedge G => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b1) (posedge G => (Q +: 1'b1))=(0, 0);
(posedge G => (Q : 1'b1))=(0, 0);
if (D==1'b0 && G==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && G==1'b1) (negedge SD => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && G==1'b0) (negedge SD => (Q -: 1'b1))=(0, 0);
(negedge SD => (Q : 1'b1))=(0, 0);
$setuphold(negedge G &&& ENABLE_SD , posedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_G, delayed_D);
$setuphold(negedge G &&& ENABLE_SD , negedge D &&& ENABLE_SD , 0 ,0, viol_0, , , delayed_G, delayed_D);
$width(posedge G &&& ENABLE_NOT_D_AND_SD , 0 ,0, viol_0);
$width(posedge G &&& ENABLE_D_AND_SD , 0 ,0, viol_0);
$recrem(posedge SD &&& ENABLE_NOT_D , negedge G &&& ENABLE_NOT_D , 0 ,0, viol_0, , , delayed_SD, delayed_G);
$width(negedge SD &&& ENABLE_NOT_D_AND_NOT_G , 0 ,0, viol_0);
$width(negedge SD &&& ENABLE_D_AND_NOT_G , 0 ,0, viol_0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_LDPSBQ_V2Y2_4


//%BEGIN HDBSVT11_MAJ3_Y2_1

`celldefine
module HDBSVT11_MAJ3_Y2_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, A1, A3);
   and inst2  (int_res_2, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        or #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
        or inst4  (X, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MAJ3_Y2_1

//%BEGIN HDBSVT11_MAJ3_Y2_2

`celldefine
module HDBSVT11_MAJ3_Y2_2 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, A1, A3);
   and inst2  (int_res_2, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        or #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
        or inst4  (X, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MAJ3_Y2_2

//%BEGIN HDBSVT11_MAJ3_Y2_4

`celldefine
module HDBSVT11_MAJ3_Y2_4 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, A1, A3);
   and inst2  (int_res_2, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        or #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
        or inst4  (X, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MAJ3_Y2_4

//%BEGIN HDBSVT11_MAJ3_Y2_8

`celldefine
module HDBSVT11_MAJ3_Y2_8 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, A1, A3);
   and inst2  (int_res_2, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        or #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
        or inst4  (X, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MAJ3_Y2_8

//%BEGIN HDBSVT11_MAJI3_Y2_1

`celldefine
module HDBSVT11_MAJI3_Y2_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, A1, A3);
   and inst2  (int_res_2, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
        nor inst4  (X, int_res_0, int_res_1, int_res_2);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MAJI3_Y2_1

//%BEGIN HDBSVT11_MAJI3_Y2_2

`celldefine
module HDBSVT11_MAJI3_Y2_2 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, A1, A3);
   and inst2  (int_res_2, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
        nor inst4  (X, int_res_0, int_res_1, int_res_2);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MAJI3_Y2_2

//%BEGIN HDBSVT11_MAJI3_Y2_4

`celldefine
module HDBSVT11_MAJI3_Y2_4 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, A1, A3);
   and inst2  (int_res_2, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
        nor inst4  (X, int_res_0, int_res_1, int_res_2);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MAJI3_Y2_4

//%BEGIN HDBSVT11_MAJI3_Y2_8

`celldefine
module HDBSVT11_MAJI3_Y2_8 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, A1, A3);
   and inst2  (int_res_2, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
        nor inst4  (X, int_res_0, int_res_1, int_res_2);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MAJI3_Y2_8

//%BEGIN HDBSVT11_MSFQBYPSOX_Y2_1
`celldefine
module HDBSVT11_MSFQBYPSOX_Y2_1 (Q, SO, CK, D, SI, SE, S);
  input CK, D, SI, SE, S;
  output Q, SO;
  reg viol_0;
  wire iqout, iq, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif
    buf inst4  (delayed_S, S);

    snps_mux2 inst5  (iqout, delayed_D, iq, delayed_S);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_5, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq, viol_0, delayed_CK, d_int, xcr_5);
    snps_mux2 inst8  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst9 (SO, iq);
    buf #`SNPS_SEQ_DELAY  inst10 (Q, iqout);
  `else
    buf inst11  (SO, iq);
    buf inst12  (Q, iqout);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst13  (_net_0, S);
not inst14  (_net_1, D);
not inst15  (_net_2, SE);
not inst16  (_net_3, SI);
and inst17  (ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst18  (_net_4, S);
not inst19  (_net_5, D);
not inst20  (_net_6, SE);
and inst21  (ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst22  (_net_7, S);
not inst23  (_net_8, D);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst26  (_net_10, S);
not inst27  (_net_11, D);
and inst28  (ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst29  (_net_12, D);
not inst30  (_net_13, SE);
not inst31  (_net_14, SI);
and inst32  (ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_NOT_SI, S, _net_12, _net_13, _net_14);
not inst33  (_net_15, D);
not inst34  (_net_16, SE);
and inst35  (ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_SI, S, _net_15, _net_16, SI);
not inst36  (_net_17, D);
not inst37  (_net_18, SI);
and inst38  (ENABLE_NOT_D_AND_S_AND_SE_AND_NOT_SI, S, _net_17, SE, _net_18);
not inst39  (_net_19, D);
and inst40  (ENABLE_NOT_D_AND_S_AND_SE_AND_SI, S, _net_19, SE, SI);
not inst41  (_net_20, S);
not inst42  (_net_21, SE);
not inst43  (_net_22, SI);
and inst44  (ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst45  (_net_23, S);
not inst46  (_net_24, SE);
and inst47  (ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst48  (_net_25, S);
not inst49  (_net_26, SI);
and inst50  (ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst51  (_net_27, S);
and inst52  (ENABLE_D_AND_NOT_S_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst53  (_net_28, SE);
not inst54  (_net_29, SI);
and inst55  (ENABLE_D_AND_S_AND_NOT_SE_AND_NOT_SI, S, D, _net_28, _net_29);
not inst56  (_net_30, SE);
and inst57  (ENABLE_D_AND_S_AND_NOT_SE_AND_SI, S, D, _net_30, SI);
not inst58  (_net_31, SI);
and inst59  (ENABLE_D_AND_S_AND_SE_AND_NOT_SI, S, D, SE, _net_31);
and inst60  (ENABLE_D_AND_S_AND_SE_AND_SI, S, D, SE, SI);
not inst61  (_net_32, SE);
not inst62  (_net_33, S);
not inst63  (_net_34, SI);
and inst64  (ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_32, _net_33, _net_34);
not inst65  (_net_35, SE);
not inst66  (_net_36, S);
and inst67  (ENABLE_NOT_S_AND_NOT_SE_AND_SI, _net_35, _net_36, SI);
not inst68  (_net_37, SE);
not inst69  (_net_38, SI);
and inst70  (ENABLE_S_AND_NOT_SE_AND_NOT_SI, _net_37, S, _net_38);
not inst71  (_net_39, SE);
and inst72  (ENABLE_S_AND_NOT_SE_AND_SI, _net_39, S, SI);
not inst73  (ENABLE_NOT_SE, SE);
not inst74  (_net_40, S);
not inst75  (_net_41, D);
and inst76  (ENABLE_NOT_D_AND_NOT_S_AND_SI, _net_40, _net_41, SI);
not inst77  (_net_42, D);
and inst78  (ENABLE_NOT_D_AND_S_AND_SI, S, _net_42, SI);
not inst79  (_net_43, S);
not inst80  (_net_44, SI);
and inst81  (ENABLE_D_AND_NOT_S_AND_NOT_SI, _net_43, D, _net_44);
not inst82  (_net_45, SI);
and inst83  (ENABLE_D_AND_S_AND_NOT_SI, S, D, _net_45);
not inst84  (_net_46, S);
not inst85  (_net_47, D);
and inst86  (ENABLE_NOT_D_AND_NOT_S_AND_SE, _net_46, _net_47, SE);
not inst87  (_net_48, D);
and inst88  (ENABLE_NOT_D_AND_S_AND_SE, S, _net_48, SE);
not inst89  (_net_49, S);
and inst90  (ENABLE_D_AND_NOT_S_AND_SE, _net_49, D, SE);
and inst91  (ENABLE_D_AND_S_AND_SE, S, D, SE);

specify
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (S +=> Q)=(0, 0);
ifnone (S -=> Q)=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
(posedge CK => (SO : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_S_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_S_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_S_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_S_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$hold(posedge CK &&& ENABLE_NOT_SE , negedge S &&& ENABLE_NOT_SE , 0 , viol_0);
$setup(negedge S &&& ENABLE_NOT_SE , negedge D &&& ENABLE_NOT_SE , 0 , viol_0);
$setup(negedge S &&& ENABLE_NOT_SE , posedge D &&& ENABLE_NOT_SE , 0 , viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_S_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_S_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_S_AND_SE , posedge SI &&& ENABLE_D_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_S_AND_SE , negedge SI &&& ENABLE_D_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_MSFQBYPSOX_Y2_1

//%BEGIN HDBSVT11_MSFQBYPSOX_Y2_2
`celldefine
module HDBSVT11_MSFQBYPSOX_Y2_2 (Q, SO, CK, D, SI, SE, S);
  input CK, D, SI, SE, S;
  output Q, SO;
  reg viol_0;
  wire iqout, iq, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif
    buf inst4  (delayed_S, S);

    snps_mux2 inst5  (iqout, delayed_D, iq, delayed_S);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_5, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq, viol_0, delayed_CK, d_int, xcr_5);
    snps_mux2 inst8  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst9 (SO, iq);
    buf #`SNPS_SEQ_DELAY  inst10 (Q, iqout);
  `else
    buf inst11  (SO, iq);
    buf inst12  (Q, iqout);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst13  (_net_0, S);
not inst14  (_net_1, D);
not inst15  (_net_2, SE);
not inst16  (_net_3, SI);
and inst17  (ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst18  (_net_4, S);
not inst19  (_net_5, D);
not inst20  (_net_6, SE);
and inst21  (ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst22  (_net_7, S);
not inst23  (_net_8, D);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst26  (_net_10, S);
not inst27  (_net_11, D);
and inst28  (ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst29  (_net_12, D);
not inst30  (_net_13, SE);
not inst31  (_net_14, SI);
and inst32  (ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_NOT_SI, S, _net_12, _net_13, _net_14);
not inst33  (_net_15, D);
not inst34  (_net_16, SE);
and inst35  (ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_SI, S, _net_15, _net_16, SI);
not inst36  (_net_17, D);
not inst37  (_net_18, SI);
and inst38  (ENABLE_NOT_D_AND_S_AND_SE_AND_NOT_SI, S, _net_17, SE, _net_18);
not inst39  (_net_19, D);
and inst40  (ENABLE_NOT_D_AND_S_AND_SE_AND_SI, S, _net_19, SE, SI);
not inst41  (_net_20, S);
not inst42  (_net_21, SE);
not inst43  (_net_22, SI);
and inst44  (ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst45  (_net_23, S);
not inst46  (_net_24, SE);
and inst47  (ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst48  (_net_25, S);
not inst49  (_net_26, SI);
and inst50  (ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst51  (_net_27, S);
and inst52  (ENABLE_D_AND_NOT_S_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst53  (_net_28, SE);
not inst54  (_net_29, SI);
and inst55  (ENABLE_D_AND_S_AND_NOT_SE_AND_NOT_SI, S, D, _net_28, _net_29);
not inst56  (_net_30, SE);
and inst57  (ENABLE_D_AND_S_AND_NOT_SE_AND_SI, S, D, _net_30, SI);
not inst58  (_net_31, SI);
and inst59  (ENABLE_D_AND_S_AND_SE_AND_NOT_SI, S, D, SE, _net_31);
and inst60  (ENABLE_D_AND_S_AND_SE_AND_SI, S, D, SE, SI);
not inst61  (_net_32, SE);
not inst62  (_net_33, S);
not inst63  (_net_34, SI);
and inst64  (ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_32, _net_33, _net_34);
not inst65  (_net_35, SE);
not inst66  (_net_36, S);
and inst67  (ENABLE_NOT_S_AND_NOT_SE_AND_SI, _net_35, _net_36, SI);
not inst68  (_net_37, SE);
not inst69  (_net_38, SI);
and inst70  (ENABLE_S_AND_NOT_SE_AND_NOT_SI, _net_37, S, _net_38);
not inst71  (_net_39, SE);
and inst72  (ENABLE_S_AND_NOT_SE_AND_SI, _net_39, S, SI);
not inst73  (ENABLE_NOT_SE, SE);
not inst74  (_net_40, S);
not inst75  (_net_41, D);
and inst76  (ENABLE_NOT_D_AND_NOT_S_AND_SI, _net_40, _net_41, SI);
not inst77  (_net_42, D);
and inst78  (ENABLE_NOT_D_AND_S_AND_SI, S, _net_42, SI);
not inst79  (_net_43, S);
not inst80  (_net_44, SI);
and inst81  (ENABLE_D_AND_NOT_S_AND_NOT_SI, _net_43, D, _net_44);
not inst82  (_net_45, SI);
and inst83  (ENABLE_D_AND_S_AND_NOT_SI, S, D, _net_45);
not inst84  (_net_46, S);
not inst85  (_net_47, D);
and inst86  (ENABLE_NOT_D_AND_NOT_S_AND_SE, _net_46, _net_47, SE);
not inst87  (_net_48, D);
and inst88  (ENABLE_NOT_D_AND_S_AND_SE, S, _net_48, SE);
not inst89  (_net_49, S);
and inst90  (ENABLE_D_AND_NOT_S_AND_SE, _net_49, D, SE);
and inst91  (ENABLE_D_AND_S_AND_SE, S, D, SE);

specify
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (S +=> Q)=(0, 0);
ifnone (S -=> Q)=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
(posedge CK => (SO : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_S_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_S_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_S_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_S_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$hold(posedge CK &&& ENABLE_NOT_SE , negedge S &&& ENABLE_NOT_SE , 0 , viol_0);
$setup(negedge S &&& ENABLE_NOT_SE , negedge D &&& ENABLE_NOT_SE , 0 , viol_0);
$setup(negedge S &&& ENABLE_NOT_SE , posedge D &&& ENABLE_NOT_SE , 0 , viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_S_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_S_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_S_AND_SE , posedge SI &&& ENABLE_D_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_S_AND_SE , negedge SI &&& ENABLE_D_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_MSFQBYPSOX_Y2_2

//%BEGIN HDBSVT11_MSFQBYPSOX_Y2_4
`celldefine
module HDBSVT11_MSFQBYPSOX_Y2_4 (Q, SO, CK, D, SI, SE, S);
  input CK, D, SI, SE, S;
  output Q, SO;
  reg viol_0;
  wire iqout, iq, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif
    buf inst4  (delayed_S, S);

    snps_mux2 inst5  (iqout, delayed_D, iq, delayed_S);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_5, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq, viol_0, delayed_CK, d_int, xcr_5);
    snps_mux2 inst8  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst9 (SO, iq);
    buf #`SNPS_SEQ_DELAY  inst10 (Q, iqout);
  `else
    buf inst11  (SO, iq);
    buf inst12  (Q, iqout);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst13  (_net_0, S);
not inst14  (_net_1, D);
not inst15  (_net_2, SE);
not inst16  (_net_3, SI);
and inst17  (ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst18  (_net_4, S);
not inst19  (_net_5, D);
not inst20  (_net_6, SE);
and inst21  (ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst22  (_net_7, S);
not inst23  (_net_8, D);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst26  (_net_10, S);
not inst27  (_net_11, D);
and inst28  (ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst29  (_net_12, D);
not inst30  (_net_13, SE);
not inst31  (_net_14, SI);
and inst32  (ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_NOT_SI, S, _net_12, _net_13, _net_14);
not inst33  (_net_15, D);
not inst34  (_net_16, SE);
and inst35  (ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_SI, S, _net_15, _net_16, SI);
not inst36  (_net_17, D);
not inst37  (_net_18, SI);
and inst38  (ENABLE_NOT_D_AND_S_AND_SE_AND_NOT_SI, S, _net_17, SE, _net_18);
not inst39  (_net_19, D);
and inst40  (ENABLE_NOT_D_AND_S_AND_SE_AND_SI, S, _net_19, SE, SI);
not inst41  (_net_20, S);
not inst42  (_net_21, SE);
not inst43  (_net_22, SI);
and inst44  (ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_20, D, _net_21, _net_22);
not inst45  (_net_23, S);
not inst46  (_net_24, SE);
and inst47  (ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI, _net_23, D, _net_24, SI);
not inst48  (_net_25, S);
not inst49  (_net_26, SI);
and inst50  (ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI, _net_25, D, SE, _net_26);
not inst51  (_net_27, S);
and inst52  (ENABLE_D_AND_NOT_S_AND_SE_AND_SI, _net_27, D, SE, SI);
not inst53  (_net_28, SE);
not inst54  (_net_29, SI);
and inst55  (ENABLE_D_AND_S_AND_NOT_SE_AND_NOT_SI, S, D, _net_28, _net_29);
not inst56  (_net_30, SE);
and inst57  (ENABLE_D_AND_S_AND_NOT_SE_AND_SI, S, D, _net_30, SI);
not inst58  (_net_31, SI);
and inst59  (ENABLE_D_AND_S_AND_SE_AND_NOT_SI, S, D, SE, _net_31);
and inst60  (ENABLE_D_AND_S_AND_SE_AND_SI, S, D, SE, SI);
not inst61  (_net_32, SE);
not inst62  (_net_33, S);
not inst63  (_net_34, SI);
and inst64  (ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_32, _net_33, _net_34);
not inst65  (_net_35, SE);
not inst66  (_net_36, S);
and inst67  (ENABLE_NOT_S_AND_NOT_SE_AND_SI, _net_35, _net_36, SI);
not inst68  (_net_37, SE);
not inst69  (_net_38, SI);
and inst70  (ENABLE_S_AND_NOT_SE_AND_NOT_SI, _net_37, S, _net_38);
not inst71  (_net_39, SE);
and inst72  (ENABLE_S_AND_NOT_SE_AND_SI, _net_39, S, SI);
not inst73  (ENABLE_NOT_SE, SE);
not inst74  (_net_40, S);
not inst75  (_net_41, D);
and inst76  (ENABLE_NOT_D_AND_NOT_S_AND_SI, _net_40, _net_41, SI);
not inst77  (_net_42, D);
and inst78  (ENABLE_NOT_D_AND_S_AND_SI, S, _net_42, SI);
not inst79  (_net_43, S);
not inst80  (_net_44, SI);
and inst81  (ENABLE_D_AND_NOT_S_AND_NOT_SI, _net_43, D, _net_44);
not inst82  (_net_45, SI);
and inst83  (ENABLE_D_AND_S_AND_NOT_SI, S, D, _net_45);
not inst84  (_net_46, S);
not inst85  (_net_47, D);
and inst86  (ENABLE_NOT_D_AND_NOT_S_AND_SE, _net_46, _net_47, SE);
not inst87  (_net_48, D);
and inst88  (ENABLE_NOT_D_AND_S_AND_SE, S, _net_48, SE);
not inst89  (_net_49, S);
and inst90  (ENABLE_D_AND_NOT_S_AND_SE, _net_49, D, SE);
and inst91  (ENABLE_D_AND_S_AND_SE, S, D, SE);

specify
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (S +=> Q)=(0, 0);
ifnone (S -=> Q)=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (SO -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (SO +: 1'b1))=(0, 0);
(posedge CK => (SO : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_S_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_S_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_S_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_S_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_S_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$hold(posedge CK &&& ENABLE_NOT_SE , negedge S &&& ENABLE_NOT_SE , 0 , viol_0);
$setup(negedge S &&& ENABLE_NOT_SE , negedge D &&& ENABLE_NOT_SE , 0 , viol_0);
$setup(negedge S &&& ENABLE_NOT_SE , posedge D &&& ENABLE_NOT_SE , 0 , viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_S_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_S_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_S_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_S_AND_SE , posedge SI &&& ENABLE_D_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_S_AND_SE , negedge SI &&& ENABLE_D_AND_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_MSFQBYPSOX_Y2_4

//%BEGIN HDBSVT11_MSFQBYPX_Y2_1
`celldefine
module HDBSVT11_MSFQBYPX_Y2_1 (Q, CK, D, SI, SE, S);
  input CK, D, SI, SE, S;
  output Q;
  reg viol_0;
  wire q_out, iq, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif
    buf inst4  (delayed_S, S);


    snps_mux2 inst5  (q_out, delayed_D, iq, delayed_S);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_4, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq, viol_0, delayed_CK, d_int, xcr_4);
    snps_mux2 inst8  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst9 (Q, q_out);
  `else
    buf inst10  (Q, q_out);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, S);
not inst12  (_net_1, D);
not inst13  (_net_2, SE);
not inst14  (_net_3, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst16  (_net_4, S);
not inst17  (_net_5, D);
not inst18  (_net_6, SE);
and inst19  (ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst20  (_net_7, S);
not inst21  (_net_8, D);
not inst22  (_net_9, SI);
and inst23  (ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst24  (_net_10, S);
not inst25  (_net_11, D);
and inst26  (ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst27  (_net_12, S);
not inst28  (_net_13, SE);
not inst29  (_net_14, SI);
and inst30  (ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_12, D, _net_13, _net_14);
not inst31  (_net_15, S);
not inst32  (_net_16, SE);
and inst33  (ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI, _net_15, D, _net_16, SI);
not inst34  (_net_17, S);
not inst35  (_net_18, SI);
and inst36  (ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI, _net_17, D, SE, _net_18);
not inst37  (_net_19, S);
and inst38  (ENABLE_D_AND_NOT_S_AND_SE_AND_SI, _net_19, D, SE, SI);
not inst39  (_net_20, SE);
not inst40  (_net_21, S);
not inst41  (_net_22, SI);
and inst42  (ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22);
not inst43  (_net_23, SE);
not inst44  (_net_24, S);
and inst45  (ENABLE_NOT_S_AND_NOT_SE_AND_SI, _net_23, _net_24, SI);
not inst46  (ENABLE_NOT_SE, SE);
not inst47  (_net_25, S);
not inst48  (_net_26, D);
and inst49  (ENABLE_NOT_D_AND_NOT_S_AND_SI, _net_25, _net_26, SI);
not inst50  (_net_27, S);
not inst51  (_net_28, SI);
and inst52  (ENABLE_D_AND_NOT_S_AND_NOT_SI, _net_27, D, _net_28);
not inst53  (_net_29, S);
not inst54  (_net_30, D);
and inst55  (ENABLE_NOT_D_AND_NOT_S_AND_SE, _net_29, _net_30, SE);
not inst56  (_net_31, S);
and inst57  (ENABLE_D_AND_NOT_S_AND_SE, _net_31, D, SE);

specify
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (S +=> Q)=(0, 0);
ifnone (S -=> Q)=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$hold(posedge CK &&& ENABLE_NOT_SE , negedge S &&& ENABLE_NOT_SE , 0 , viol_0);
$setup(negedge S &&& ENABLE_NOT_SE , negedge D &&& ENABLE_NOT_SE , 0 , viol_0);
$setup(negedge S &&& ENABLE_NOT_SE , posedge D &&& ENABLE_NOT_SE , 0 , viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_MSFQBYPX_Y2_1

//%BEGIN HDBSVT11_MSFQBYPX_Y2_2
`celldefine
module HDBSVT11_MSFQBYPX_Y2_2 (Q, CK, D, SI, SE, S);
  input CK, D, SI, SE, S;
  output Q;
  reg viol_0;
  wire q_out, iq, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif
    buf inst4  (delayed_S, S);


    snps_mux2 inst5  (q_out, delayed_D, iq, delayed_S);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_4, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq, viol_0, delayed_CK, d_int, xcr_4);
    snps_mux2 inst8  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst9 (Q, q_out);
  `else
    buf inst10  (Q, q_out);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, S);
not inst12  (_net_1, D);
not inst13  (_net_2, SE);
not inst14  (_net_3, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst16  (_net_4, S);
not inst17  (_net_5, D);
not inst18  (_net_6, SE);
and inst19  (ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst20  (_net_7, S);
not inst21  (_net_8, D);
not inst22  (_net_9, SI);
and inst23  (ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst24  (_net_10, S);
not inst25  (_net_11, D);
and inst26  (ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst27  (_net_12, S);
not inst28  (_net_13, SE);
not inst29  (_net_14, SI);
and inst30  (ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_12, D, _net_13, _net_14);
not inst31  (_net_15, S);
not inst32  (_net_16, SE);
and inst33  (ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI, _net_15, D, _net_16, SI);
not inst34  (_net_17, S);
not inst35  (_net_18, SI);
and inst36  (ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI, _net_17, D, SE, _net_18);
not inst37  (_net_19, S);
and inst38  (ENABLE_D_AND_NOT_S_AND_SE_AND_SI, _net_19, D, SE, SI);
not inst39  (_net_20, SE);
not inst40  (_net_21, S);
not inst41  (_net_22, SI);
and inst42  (ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22);
not inst43  (_net_23, SE);
not inst44  (_net_24, S);
and inst45  (ENABLE_NOT_S_AND_NOT_SE_AND_SI, _net_23, _net_24, SI);
not inst46  (ENABLE_NOT_SE, SE);
not inst47  (_net_25, S);
not inst48  (_net_26, D);
and inst49  (ENABLE_NOT_D_AND_NOT_S_AND_SI, _net_25, _net_26, SI);
not inst50  (_net_27, S);
not inst51  (_net_28, SI);
and inst52  (ENABLE_D_AND_NOT_S_AND_NOT_SI, _net_27, D, _net_28);
not inst53  (_net_29, S);
not inst54  (_net_30, D);
and inst55  (ENABLE_NOT_D_AND_NOT_S_AND_SE, _net_29, _net_30, SE);
not inst56  (_net_31, S);
and inst57  (ENABLE_D_AND_NOT_S_AND_SE, _net_31, D, SE);

specify
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (S +=> Q)=(0, 0);
ifnone (S -=> Q)=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$hold(posedge CK &&& ENABLE_NOT_SE , negedge S &&& ENABLE_NOT_SE , 0 , viol_0);
$setup(negedge S &&& ENABLE_NOT_SE , negedge D &&& ENABLE_NOT_SE , 0 , viol_0);
$setup(negedge S &&& ENABLE_NOT_SE , posedge D &&& ENABLE_NOT_SE , 0 , viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_MSFQBYPX_Y2_2

//%BEGIN HDBSVT11_MSFQBYPX_Y2_4
`celldefine
module HDBSVT11_MSFQBYPX_Y2_4 (Q, CK, D, SI, SE, S);
  input CK, D, SI, SE, S;
  output Q;
  reg viol_0;
  wire q_out, iq, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif
    buf inst4  (delayed_S, S);


    snps_mux2 inst5  (q_out, delayed_D, iq, delayed_S);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_4, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq, viol_0, delayed_CK, d_int, xcr_4);
    snps_mux2 inst8  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst9 (Q, q_out);
  `else
    buf inst10  (Q, q_out);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, S);
not inst12  (_net_1, D);
not inst13  (_net_2, SE);
not inst14  (_net_3, SI);
and inst15  (ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2, _net_3);
not inst16  (_net_4, S);
not inst17  (_net_5, D);
not inst18  (_net_6, SE);
and inst19  (ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI, _net_4, _net_5, _net_6, SI);
not inst20  (_net_7, S);
not inst21  (_net_8, D);
not inst22  (_net_9, SI);
and inst23  (ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI, _net_7, _net_8, SE, _net_9);
not inst24  (_net_10, S);
not inst25  (_net_11, D);
and inst26  (ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI, _net_10, _net_11, SE, SI);
not inst27  (_net_12, S);
not inst28  (_net_13, SE);
not inst29  (_net_14, SI);
and inst30  (ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_12, D, _net_13, _net_14);
not inst31  (_net_15, S);
not inst32  (_net_16, SE);
and inst33  (ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI, _net_15, D, _net_16, SI);
not inst34  (_net_17, S);
not inst35  (_net_18, SI);
and inst36  (ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI, _net_17, D, SE, _net_18);
not inst37  (_net_19, S);
and inst38  (ENABLE_D_AND_NOT_S_AND_SE_AND_SI, _net_19, D, SE, SI);
not inst39  (_net_20, SE);
not inst40  (_net_21, S);
not inst41  (_net_22, SI);
and inst42  (ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI, _net_20, _net_21, _net_22);
not inst43  (_net_23, SE);
not inst44  (_net_24, S);
and inst45  (ENABLE_NOT_S_AND_NOT_SE_AND_SI, _net_23, _net_24, SI);
not inst46  (ENABLE_NOT_SE, SE);
not inst47  (_net_25, S);
not inst48  (_net_26, D);
and inst49  (ENABLE_NOT_D_AND_NOT_S_AND_SI, _net_25, _net_26, SI);
not inst50  (_net_27, S);
not inst51  (_net_28, SI);
and inst52  (ENABLE_D_AND_NOT_S_AND_NOT_SI, _net_27, D, _net_28);
not inst53  (_net_29, S);
not inst54  (_net_30, D);
and inst55  (ENABLE_NOT_D_AND_NOT_S_AND_SE, _net_29, _net_30, SE);
not inst56  (_net_31, S);
and inst57  (ENABLE_D_AND_NOT_S_AND_SE, _net_31, D, SE);

specify
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && S==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b0 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b0 && SE==1'b1 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b0 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b0) (S -=> Q)=(0, 0);
if (CK==1'b1 && D==1'b0 && SE==1'b1 && SI==1'b1) (S -=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b0 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b0 && D==1'b1 && SE==1'b1 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b0 && SI==1'b1) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b0) (S +=> Q)=(0, 0);
if (CK==1'b1 && D==1'b1 && SE==1'b1 && SI==1'b1) (S +=> Q)=(0, 0);
ifnone (S -=> Q)=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_S_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_S_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$hold(posedge CK &&& ENABLE_NOT_SE , negedge S &&& ENABLE_NOT_SE , 0 , viol_0);
$setup(negedge S &&& ENABLE_NOT_SE , negedge D &&& ENABLE_NOT_SE , 0 , viol_0);
$setup(negedge S &&& ENABLE_NOT_SE , posedge D &&& ENABLE_NOT_SE , 0 , viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_NOT_S_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_S_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE , posedge SI &&& ENABLE_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_S_AND_SE , negedge SI &&& ENABLE_D_AND_NOT_S_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_MSFQBYPX_Y2_4

//%BEGIN HDBSVT11_MUX2_1

`celldefine
module HDBSVT11_MUX2_1 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_mux2 #`SNPS_COMBO_DELAY  inst0 (X, D1, D0, S);
   `else
        snps_mux2 inst1  (X, D1, D0, S);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && S==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX2_1

//%BEGIN HDBSVT11_MUX2_CBY2ECOM2FS_1

`celldefine
module HDBSVT11_MUX2_CBY2ECOM2FS_1 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_mux2 #`SNPS_COMBO_DELAY  inst0 (X, D1, D0, S);
   `else
        snps_mux2 inst1  (X, D1, D0, S);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && S==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX2_CBY2ECOM2FS_1

//%BEGIN HDBSVT11_MUX2_CBY2ECOM2_1

`celldefine
module HDBSVT11_MUX2_CBY2ECOM2_1 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_mux2 #`SNPS_COMBO_DELAY  inst0 (X, D1, D0, S);
   `else
        snps_mux2 inst1  (X, D1, D0, S);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && S==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX2_CBY2ECOM2_1

//%BEGIN HDBSVT11_MUX2_CBY2_2

`celldefine
module HDBSVT11_MUX2_CBY2_2 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_mux2 #`SNPS_COMBO_DELAY  inst0 (X, D1, D0, S);
   `else
        snps_mux2 inst1  (X, D1, D0, S);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && S==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX2_CBY2_2

//%BEGIN HDBSVT11_MUX2_CKY2_4
`celldefine
module HDBSVT11_MUX2_CKY2_4 (Z, CLK1, CLK2, CLKSEL);
  input CLK1, CLK2, CLKSEL;
  output Z;
  wire Z_int;
  reg viol_0;


    snps_mux2 inst0  (Z_int, CLK2, CLK1, CLKSEL);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, Z_int);
  `else
    buf inst2  (Z, Z_int);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst3  (ENABLE_NOT_CLK2, CLK2);
not inst4  (ENABLE_NOT_CLK1, CLK1);

specify
if (CLK2==1'b0 && CLKSEL==1'b0) (CLK1 +=> Z)=(0, 0);
if (CLK2==1'b1 && CLKSEL==1'b0) (CLK1 +=> Z)=(0, 0);
if (CLK1==1'b0 && CLKSEL==1'b1) (CLK2 +=> Z)=(0, 0);
if (CLK1==1'b1 && CLKSEL==1'b1) (CLK2 +=> Z)=(0, 0);
if (CLK1==1'b1 && CLK2==1'b0) (CLKSEL -=> Z)=(0, 0);
if (CLK1==1'b0 && CLK2==1'b1) (CLKSEL +=> Z)=(0, 0);
$hold(negedge CLK1 &&& ENABLE_NOT_CLK2 , posedge CLKSEL &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$hold(negedge CLK1 &&& ENABLE_NOT_CLK2 , negedge CLKSEL &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$setup(posedge CLKSEL &&& ENABLE_NOT_CLK2 , posedge CLK1 &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$setup(negedge CLKSEL &&& ENABLE_NOT_CLK2 , posedge CLK1 &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$hold(negedge CLK2 &&& ENABLE_NOT_CLK1 , posedge CLKSEL &&& ENABLE_NOT_CLK1 , 0 , viol_0);
$hold(negedge CLK2 &&& ENABLE_NOT_CLK1 , negedge CLKSEL &&& ENABLE_NOT_CLK1 , 0 , viol_0);
$setup(posedge CLKSEL &&& ENABLE_NOT_CLK1 , posedge CLK2 &&& ENABLE_NOT_CLK1 , 0 , viol_0);
$setup(negedge CLKSEL &&& ENABLE_NOT_CLK1 , posedge CLK2 &&& ENABLE_NOT_CLK1 , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_MUX2_CKY2_4

//%BEGIN HDBSVT11_MUX2_CK_1
`celldefine
module HDBSVT11_MUX2_CK_1 (Z, CLK1, CLK2, CLKSEL);
  input CLK1, CLK2, CLKSEL;
  output Z;
  wire Z_int;
  reg viol_0;


    snps_mux2 inst0  (Z_int, CLK2, CLK1, CLKSEL);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, Z_int);
  `else
    buf inst2  (Z, Z_int);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst3  (ENABLE_NOT_CLK2, CLK2);
not inst4  (ENABLE_NOT_CLK1, CLK1);

specify
if (CLK2==1'b0 && CLKSEL==1'b0) (CLK1 +=> Z)=(0, 0);
if (CLK2==1'b1 && CLKSEL==1'b0) (CLK1 +=> Z)=(0, 0);
if (CLK1==1'b0 && CLKSEL==1'b1) (CLK2 +=> Z)=(0, 0);
if (CLK1==1'b1 && CLKSEL==1'b1) (CLK2 +=> Z)=(0, 0);
if (CLK1==1'b1 && CLK2==1'b0) (CLKSEL -=> Z)=(0, 0);
if (CLK1==1'b0 && CLK2==1'b1) (CLKSEL +=> Z)=(0, 0);
$hold(negedge CLK1 &&& ENABLE_NOT_CLK2 , posedge CLKSEL &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$hold(negedge CLK1 &&& ENABLE_NOT_CLK2 , negedge CLKSEL &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$setup(posedge CLKSEL &&& ENABLE_NOT_CLK2 , posedge CLK1 &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$setup(negedge CLKSEL &&& ENABLE_NOT_CLK2 , posedge CLK1 &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$hold(negedge CLK2 &&& ENABLE_NOT_CLK1 , posedge CLKSEL &&& ENABLE_NOT_CLK1 , 0 , viol_0);
$hold(negedge CLK2 &&& ENABLE_NOT_CLK1 , negedge CLKSEL &&& ENABLE_NOT_CLK1 , 0 , viol_0);
$setup(posedge CLKSEL &&& ENABLE_NOT_CLK1 , posedge CLK2 &&& ENABLE_NOT_CLK1 , 0 , viol_0);
$setup(negedge CLKSEL &&& ENABLE_NOT_CLK1 , posedge CLK2 &&& ENABLE_NOT_CLK1 , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_MUX2_CK_1

//%BEGIN HDBSVT11_MUX2_CK_2
`celldefine
module HDBSVT11_MUX2_CK_2 (Z, CLK1, CLK2, CLKSEL);
  input CLK1, CLK2, CLKSEL;
  output Z;
  wire Z_int;
  reg viol_0;


    snps_mux2 inst0  (Z_int, CLK2, CLK1, CLKSEL);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, Z_int);
  `else
    buf inst2  (Z, Z_int);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst3  (ENABLE_NOT_CLK2, CLK2);
not inst4  (ENABLE_NOT_CLK1, CLK1);

specify
if (CLK2==1'b0 && CLKSEL==1'b0) (CLK1 +=> Z)=(0, 0);
if (CLK2==1'b1 && CLKSEL==1'b0) (CLK1 +=> Z)=(0, 0);
if (CLK1==1'b0 && CLKSEL==1'b1) (CLK2 +=> Z)=(0, 0);
if (CLK1==1'b1 && CLKSEL==1'b1) (CLK2 +=> Z)=(0, 0);
if (CLK1==1'b1 && CLK2==1'b0) (CLKSEL -=> Z)=(0, 0);
if (CLK1==1'b0 && CLK2==1'b1) (CLKSEL +=> Z)=(0, 0);
$hold(negedge CLK1 &&& ENABLE_NOT_CLK2 , posedge CLKSEL &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$hold(negedge CLK1 &&& ENABLE_NOT_CLK2 , negedge CLKSEL &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$setup(posedge CLKSEL &&& ENABLE_NOT_CLK2 , posedge CLK1 &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$setup(negedge CLKSEL &&& ENABLE_NOT_CLK2 , posedge CLK1 &&& ENABLE_NOT_CLK2 , 0 , viol_0);
$hold(negedge CLK2 &&& ENABLE_NOT_CLK1 , posedge CLKSEL &&& ENABLE_NOT_CLK1 , 0 , viol_0);
$hold(negedge CLK2 &&& ENABLE_NOT_CLK1 , negedge CLKSEL &&& ENABLE_NOT_CLK1 , 0 , viol_0);
$setup(posedge CLKSEL &&& ENABLE_NOT_CLK1 , posedge CLK2 &&& ENABLE_NOT_CLK1 , 0 , viol_0);
$setup(negedge CLKSEL &&& ENABLE_NOT_CLK1 , posedge CLK2 &&& ENABLE_NOT_CLK1 , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_MUX2_CK_2

//%BEGIN HDBSVT11_MUX2_Y2ECOM2FS_1

`celldefine
module HDBSVT11_MUX2_Y2ECOM2FS_1 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_mux2 #`SNPS_COMBO_DELAY  inst0 (X, D1, D0, S);
   `else
        snps_mux2 inst1  (X, D1, D0, S);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && S==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX2_Y2ECOM2FS_1

//%BEGIN HDBSVT11_MUX2_Y2ECOM2_1

`celldefine
module HDBSVT11_MUX2_Y2ECOM2_1 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_mux2 #`SNPS_COMBO_DELAY  inst0 (X, D1, D0, S);
   `else
        snps_mux2 inst1  (X, D1, D0, S);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && S==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX2_Y2ECOM2_1

//%BEGIN HDBSVT11_MUX2_Y2ECO_1

`celldefine
module HDBSVT11_MUX2_Y2ECO_1 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_mux2 #`SNPS_COMBO_DELAY  inst0 (X, D1, D0, S);
   `else
        snps_mux2 inst1  (X, D1, D0, S);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && S==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX2_Y2ECO_1

//%BEGIN HDBSVT11_MUX2_Y2ECO_2

`celldefine
module HDBSVT11_MUX2_Y2ECO_2 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_mux2 #`SNPS_COMBO_DELAY  inst0 (X, D1, D0, S);
   `else
        snps_mux2 inst1  (X, D1, D0, S);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && S==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX2_Y2ECO_2

//%BEGIN HDBSVT11_MUX2_Y2_1

`celldefine
module HDBSVT11_MUX2_Y2_1 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_mux2 #`SNPS_COMBO_DELAY  inst0 (X, D1, D0, S);
   `else
        snps_mux2 inst1  (X, D1, D0, S);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && S==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX2_Y2_1

//%BEGIN HDBSVT11_MUX2_Y2_12

`celldefine
module HDBSVT11_MUX2_Y2_12 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_mux2 #`SNPS_COMBO_DELAY  inst0 (X, D1, D0, S);
   `else
        snps_mux2 inst1  (X, D1, D0, S);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && S==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX2_Y2_12

//%BEGIN HDBSVT11_MUX2_Y2_2

`celldefine
module HDBSVT11_MUX2_Y2_2 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_mux2 #`SNPS_COMBO_DELAY  inst0 (X, D1, D0, S);
   `else
        snps_mux2 inst1  (X, D1, D0, S);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && S==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX2_Y2_2

//%BEGIN HDBSVT11_MUX2_Y2_4

`celldefine
module HDBSVT11_MUX2_Y2_4 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_mux2 #`SNPS_COMBO_DELAY  inst0 (X, D1, D0, S);
   `else
        snps_mux2 inst1  (X, D1, D0, S);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && S==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX2_Y2_4

//%BEGIN HDBSVT11_MUX2_Y2_8

`celldefine
module HDBSVT11_MUX2_Y2_8 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_mux2 #`SNPS_COMBO_DELAY  inst0 (X, D1, D0, S);
   `else
        snps_mux2 inst1  (X, D1, D0, S);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && S==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX2_Y2_8

//%BEGIN HDBSVT11_MUX3_Y2_1

`celldefine
module HDBSVT11_MUX3_Y2_1 (X, D0, D1, D2, S0, S1);
   output X;
   input D0, D1, D2, S0, S1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_mux4 #`SNPS_COMBO_DELAY  inst0 (X, D2, D2, D1, D0, S1, S0);
   `else
        snps_mux4 inst1  (X, D2, D2, D1, D0, S1, S0);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && D2==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && S0==1'b1 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && S0==1'b1 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && S0==1'b1 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && S0==1'b1 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif 

endmodule
`endcelldefine

//%END HDBSVT11_MUX3_Y2_1

//%BEGIN HDBSVT11_MUX3_Y2_2

`celldefine
module HDBSVT11_MUX3_Y2_2 (X, D0, D1, D2, S0, S1);
   output X;
   input D0, D1, D2, S0, S1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_mux4 #`SNPS_COMBO_DELAY  inst0 (X, D2, D2, D1, D0, S1, S0);
   `else
        snps_mux4 inst1  (X, D2, D2, D1, D0, S1, S0);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && D2==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && S0==1'b1 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && S0==1'b1 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && S0==1'b1 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && S0==1'b1 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif 

endmodule
`endcelldefine

//%END HDBSVT11_MUX3_Y2_2

//%BEGIN HDBSVT11_MUX3_Y2_4

`celldefine
module HDBSVT11_MUX3_Y2_4 (X, D0, D1, D2, S0, S1);
   output X;
   input D0, D1, D2, S0, S1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_mux4 #`SNPS_COMBO_DELAY  inst0 (X, D2, D2, D1, D0, S1, S0);
   `else
        snps_mux4 inst1  (X, D2, D2, D1, D0, S1, S0);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && D2==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && S0==1'b1 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && S0==1'b1 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && S0==1'b1 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && S0==1'b1 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif 

endmodule
`endcelldefine

//%END HDBSVT11_MUX3_Y2_4

//%BEGIN HDBSVT11_MUX4_CBY2_1

`celldefine
module HDBSVT11_MUX4_CBY2_1 (X, D0, D1, D2, D3, S0, S1);
   output X;
   input D0, D1, D2, D3, S0, S1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         snps_mux4 #`SNPS_COMBO_DELAY  inst0 (X, D3, D2, D1, D0, S1, S0);
   `else
         snps_mux4 inst1  (X, D3, D2, D1, D0, S1, S0);
   `endif

   `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX4_CBY2_1

//%BEGIN HDBSVT11_MUX4_V3Y2_1

`celldefine
module HDBSVT11_MUX4_V3Y2_1 (X, D0, D1, D2, D3, S0, S1);
   output X;
   input D0, D1, D2, D3, S0, S1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         snps_mux4 #`SNPS_COMBO_DELAY  inst0 (X, D3, D2, D1, D0, S1, S0);
   `else
         snps_mux4 inst1  (X, D3, D2, D1, D0, S1, S0);
   `endif

   `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX4_V3Y2_1

//%BEGIN HDBSVT11_MUX4_V3Y2_2

`celldefine
module HDBSVT11_MUX4_V3Y2_2 (X, D0, D1, D2, D3, S0, S1);
   output X;
   input D0, D1, D2, D3, S0, S1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         snps_mux4 #`SNPS_COMBO_DELAY  inst0 (X, D3, D2, D1, D0, S1, S0);
   `else
         snps_mux4 inst1  (X, D3, D2, D1, D0, S1, S0);
   `endif

   `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX4_V3Y2_2

//%BEGIN HDBSVT11_MUX4_V3Y2_4

`celldefine
module HDBSVT11_MUX4_V3Y2_4 (X, D0, D1, D2, D3, S0, S1);
   output X;
   input D0, D1, D2, D3, S0, S1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         snps_mux4 #`SNPS_COMBO_DELAY  inst0 (X, D3, D2, D1, D0, S1, S0);
   `else
         snps_mux4 inst1  (X, D3, D2, D1, D0, S1, S0);
   `endif

   `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX4_V3Y2_4

//%BEGIN HDBSVT11_MUX4_Y2_1

`celldefine
module HDBSVT11_MUX4_Y2_1 (X, D0, D1, D2, D3, S0, S1);
   output X;
   input D0, D1, D2, D3, S0, S1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         snps_mux4 #`SNPS_COMBO_DELAY  inst0 (X, D3, D2, D1, D0, S1, S0);
   `else
         snps_mux4 inst1  (X, D3, D2, D1, D0, S1, S0);
   `endif

   `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX4_Y2_1

//%BEGIN HDBSVT11_MUX4_Y2_2

`celldefine
module HDBSVT11_MUX4_Y2_2 (X, D0, D1, D2, D3, S0, S1);
   output X;
   input D0, D1, D2, D3, S0, S1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         snps_mux4 #`SNPS_COMBO_DELAY  inst0 (X, D3, D2, D1, D0, S1, S0);
   `else
         snps_mux4 inst1  (X, D3, D2, D1, D0, S1, S0);
   `endif

   `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX4_Y2_2

//%BEGIN HDBSVT11_MUX4_Y2_4

`celldefine
module HDBSVT11_MUX4_Y2_4 (X, D0, D1, D2, D3, S0, S1);
   output X;
   input D0, D1, D2, D3, S0, S1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         snps_mux4 #`SNPS_COMBO_DELAY  inst0 (X, D3, D2, D1, D0, S1, S0);
   `else
         snps_mux4 inst1  (X, D3, D2, D1, D0, S1, S0);
   `endif

   `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUX4_Y2_4

//%BEGIN HDBSVT11_MUXI2_1

`celldefine
module HDBSVT11_MUXI2_1 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux2 inst0  (int_res_mux1, D1, D0, S);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

    `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
    `else
        not inst2  (X, int_res_mux1);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && S==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUXI2_1

//%BEGIN HDBSVT11_MUXI2_BY2_2

`celldefine
module HDBSVT11_MUXI2_BY2_2 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux2 inst0  (int_res_mux1, D1, D0, S);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

    `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
    `else
        not inst2  (X, int_res_mux1);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && S==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUXI2_BY2_2

//%BEGIN HDBSVT11_MUXI2_BY2_4

`celldefine
module HDBSVT11_MUXI2_BY2_4 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux2 inst0  (int_res_mux1, D1, D0, S);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

    `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
    `else
        not inst2  (X, int_res_mux1);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && S==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUXI2_BY2_4

//%BEGIN HDBSVT11_MUXI2_BY2_8

`celldefine
module HDBSVT11_MUXI2_BY2_8 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux2 inst0  (int_res_mux1, D1, D0, S);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

    `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
    `else
        not inst2  (X, int_res_mux1);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && S==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUXI2_BY2_8

//%BEGIN HDBSVT11_MUXI2_CBY2_1

`celldefine
module HDBSVT11_MUXI2_CBY2_1 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux2 inst0  (int_res_mux1, D1, D0, S);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

    `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
    `else
        not inst2  (X, int_res_mux1);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && S==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUXI2_CBY2_1

//%BEGIN HDBSVT11_MUXI2_CBY4ECO_1

`celldefine
module HDBSVT11_MUXI2_CBY4ECO_1 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux2 inst0  (int_res_mux1, D1, D0, S);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

    `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
    `else
        not inst2  (X, int_res_mux1);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && S==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUXI2_CBY4ECO_1

//%BEGIN HDBSVT11_MUXI2_CBY4ECO_2

`celldefine
module HDBSVT11_MUXI2_CBY4ECO_2 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux2 inst0  (int_res_mux1, D1, D0, S);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

    `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
    `else
        not inst2  (X, int_res_mux1);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && S==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUXI2_CBY4ECO_2

//%BEGIN HDBSVT11_MUXI2_Y2_1

`celldefine
module HDBSVT11_MUXI2_Y2_1 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux2 inst0  (int_res_mux1, D1, D0, S);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

    `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
    `else
        not inst2  (X, int_res_mux1);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && S==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUXI2_Y2_1

//%BEGIN HDBSVT11_MUXI2_Y2_2

`celldefine
module HDBSVT11_MUXI2_Y2_2 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux2 inst0  (int_res_mux1, D1, D0, S);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

    `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
    `else
        not inst2  (X, int_res_mux1);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && S==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUXI2_Y2_2

//%BEGIN HDBSVT11_MUXI2_Y2_4

`celldefine
module HDBSVT11_MUXI2_Y2_4 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux2 inst0  (int_res_mux1, D1, D0, S);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

    `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
    `else
        not inst2  (X, int_res_mux1);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && S==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUXI2_Y2_4

//%BEGIN HDBSVT11_MUXI2_Y4ECO_1

`celldefine
module HDBSVT11_MUXI2_Y4ECO_1 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux2 inst0  (int_res_mux1, D1, D0, S);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

    `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
    `else
        not inst2  (X, int_res_mux1);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && S==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUXI2_Y4ECO_1

//%BEGIN HDBSVT11_MUXI2_Y4ECO_2

`celldefine
module HDBSVT11_MUXI2_Y4ECO_2 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux2 inst0  (int_res_mux1, D1, D0, S);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

    `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
    `else
        not inst2  (X, int_res_mux1);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && S==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUXI2_Y4ECO_2

//%BEGIN HDBSVT11_MUXI2_Y4_8

`celldefine
module HDBSVT11_MUXI2_Y4_8 (X, D0, D1, S);
   output X;
   input D0, D1, S;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux2 inst0  (int_res_mux1, D1, D0, S);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

    `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
    `else
        not inst2  (X, int_res_mux1);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (D1==1'b0 && S==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && S==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b1 && S==1'b1) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1) (S -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0) (S +=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_MUXI2_Y4_8

//%BEGIN HDBSVT11_MUXI3_Y2_1

`celldefine
module HDBSVT11_MUXI3_Y2_1 (X, D0, D1, D2, S0, S1);
   output X;
   input D0, D1, D2, S0, S1;
   wire int_res__x;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux4 inst0  (int_res__x, D2, D2, D1, D0, S1, S0);
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst1 (X, int_res__x);
   `else
        not inst2  (X, int_res__x);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && D2==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && S0==1'b1 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && S0==1'b1 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && S0==1'b1 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && S0==1'b1 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif 

endmodule
`endcelldefine

//%END HDBSVT11_MUXI3_Y2_1

//%BEGIN HDBSVT11_MUXI3_Y2_2

`celldefine
module HDBSVT11_MUXI3_Y2_2 (X, D0, D1, D2, S0, S1);
   output X;
   input D0, D1, D2, S0, S1;
   wire int_res__x;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux4 inst0  (int_res__x, D2, D2, D1, D0, S1, S0);
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst1 (X, int_res__x);
   `else
        not inst2  (X, int_res__x);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && D2==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && S0==1'b1 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && S0==1'b1 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && S0==1'b1 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && S0==1'b1 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif 

endmodule
`endcelldefine

//%END HDBSVT11_MUXI3_Y2_2

//%BEGIN HDBSVT11_MUXI3_Y2_4

`celldefine
module HDBSVT11_MUXI3_Y2_4 (X, D0, D1, D2, S0, S1);
   output X;
   input D0, D1, D2, S0, S1;
   wire int_res__x;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux4 inst0  (int_res__x, D2, D2, D1, D0, S1, S0);
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_COMBO_DELAY  inst1 (X, int_res__x);
   `else
        not inst2  (X, int_res__x);
    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (D1==1'b0 && D2==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && S0==1'b1 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && S0==1'b1 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && S0==1'b1 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && S0==1'b1 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif 

endmodule
`endcelldefine

//%END HDBSVT11_MUXI3_Y2_4

//%BEGIN HDBSVT11_MUXI4_V3Y2_1

`celldefine
module HDBSVT11_MUXI4_V3Y2_1 (X, D0, D1, D2, D3, S0, S1);
   output X;
   input D0, D1, D2, D3, S0, S1;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux4 inst0  (int_res_mux1, D3, D2, D1, D0, S1, S0);

   `ifdef VIRL_functiononly
      not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
   `else
      not inst2  (X, int_res_mux1);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_MUXI4_V3Y2_1


//%BEGIN HDBSVT11_MUXI4_V3Y2_2

`celldefine
module HDBSVT11_MUXI4_V3Y2_2 (X, D0, D1, D2, D3, S0, S1);
   output X;
   input D0, D1, D2, D3, S0, S1;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux4 inst0  (int_res_mux1, D3, D2, D1, D0, S1, S0);

   `ifdef VIRL_functiononly
      not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
   `else
      not inst2  (X, int_res_mux1);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_MUXI4_V3Y2_2


//%BEGIN HDBSVT11_MUXI4_V3Y2_4

`celldefine
module HDBSVT11_MUXI4_V3Y2_4 (X, D0, D1, D2, D3, S0, S1);
   output X;
   input D0, D1, D2, D3, S0, S1;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux4 inst0  (int_res_mux1, D3, D2, D1, D0, S1, S0);

   `ifdef VIRL_functiononly
      not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
   `else
      not inst2  (X, int_res_mux1);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_MUXI4_V3Y2_4


//%BEGIN HDBSVT11_MUXI4_Y2_1

`celldefine
module HDBSVT11_MUXI4_Y2_1 (X, D0, D1, D2, D3, S0, S1);
   output X;
   input D0, D1, D2, D3, S0, S1;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux4 inst0  (int_res_mux1, D3, D2, D1, D0, S1, S0);

   `ifdef VIRL_functiononly
      not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
   `else
      not inst2  (X, int_res_mux1);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_MUXI4_Y2_1


//%BEGIN HDBSVT11_MUXI4_Y2_2

`celldefine
module HDBSVT11_MUXI4_Y2_2 (X, D0, D1, D2, D3, S0, S1);
   output X;
   input D0, D1, D2, D3, S0, S1;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux4 inst0  (int_res_mux1, D3, D2, D1, D0, S1, S0);

   `ifdef VIRL_functiononly
      not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
   `else
      not inst2  (X, int_res_mux1);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_MUXI4_Y2_2


//%BEGIN HDBSVT11_MUXI4_Y2_4

`celldefine
module HDBSVT11_MUXI4_Y2_4 (X, D0, D1, D2, D3, S0, S1);
   output X;
   input D0, D1, D2, D3, S0, S1;

   wire int_res_mux1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_mux4 inst0  (int_res_mux1, D3, D2, D1, D0, S1, S0);

   `ifdef VIRL_functiononly
      not #`SNPS_COMBO_DELAY  inst1 (X, int_res_mux1);
   `else
      not inst2  (X, int_res_mux1);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b0) (D0 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b1 && S1==1'b0) (D1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b0 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D3==1'b1 && S0==1'b0 && S1==1'b1) (D2 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && S0==1'b1 && S1==1'b1) (D3 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S1==1'b1) (S0 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S1==1'b0) (S0 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S1==1'b1) (S0 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b1 && S0==1'b0) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b1 && D3==1'b1 && S0==1'b1) (S1 -=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b0 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b0 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b0 && D3==1'b1 && S0==1'b0) (S1 +=> X)=(0, 0);
if (D0==1'b1 && D1==1'b1 && D2==1'b1 && D3==1'b0 && S0==1'b1) (S1 +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_MUXI4_Y2_4


//%BEGIN HDBSVT11_ND2B_1

`celldefine
module HDBSVT11_ND2B_1 (X, A, B);
   output X;
   input A, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (B==1'b1) (A +=> X)=(0, 0);
if (A==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2B_1

//%BEGIN HDBSVT11_ND2B_2

`celldefine
module HDBSVT11_ND2B_2 (X, A, B);
   output X;
   input A, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (B==1'b1) (A +=> X)=(0, 0);
if (A==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2B_2

//%BEGIN HDBSVT11_ND2B_4

`celldefine
module HDBSVT11_ND2B_4 (X, A, B);
   output X;
   input A, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (B==1'b1) (A +=> X)=(0, 0);
if (A==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2B_4

//%BEGIN HDBSVT11_ND2B_8

`celldefine
module HDBSVT11_ND2B_8 (X, A, B);
   output X;
   input A, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (B==1'b1) (A +=> X)=(0, 0);
if (A==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2B_8

//%BEGIN HDBSVT11_ND2B_CB_1

`celldefine
module HDBSVT11_ND2B_CB_1 (X, A, B);
   output X;
   input A, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (B==1'b1) (A +=> X)=(0, 0);
if (A==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2B_CB_1

//%BEGIN HDBSVT11_ND2B_Y2_12

`celldefine
module HDBSVT11_ND2B_Y2_12 (X, A, B);
   output X;
   input A, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (B==1'b1) (A +=> X)=(0, 0);
if (A==1'b0) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2B_Y2_12

//%BEGIN HDBSVT11_ND2_1

`celldefine
module HDBSVT11_ND2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_1

//%BEGIN HDBSVT11_ND2_2

`celldefine
module HDBSVT11_ND2_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_2

//%BEGIN HDBSVT11_ND2_3

`celldefine
module HDBSVT11_ND2_3 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_3

//%BEGIN HDBSVT11_ND2_4

`celldefine
module HDBSVT11_ND2_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_4

//%BEGIN HDBSVT11_ND2_5

`celldefine
module HDBSVT11_ND2_5 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_5

//%BEGIN HDBSVT11_ND2_6

`celldefine
module HDBSVT11_ND2_6 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_6

//%BEGIN HDBSVT11_ND2_8

`celldefine
module HDBSVT11_ND2_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_8

//%BEGIN HDBSVT11_ND2_CBCDC_2
`celldefine
module HDBSVT11_ND2_CBCDC_2 (X, EN, A);
  input EN, A;
  output X;
  wire int_0, int_1;


    and inst0  (int_0, EN, A);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_COMBO_DELAY  inst2 (X, int_1);
  `else
    buf inst3  (X, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (A -=> X)=(0, 0);
if (A==1'b1) (EN -=> X)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CBCDC_2

//%BEGIN HDBSVT11_ND2_CBCK_1
`celldefine
module HDBSVT11_ND2_CBCK_1 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CBCK_1

//%BEGIN HDBSVT11_ND2_CBECOM2FS_1

`celldefine
module HDBSVT11_ND2_CBECOM2FS_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_CBECOM2FS_1

//%BEGIN HDBSVT11_ND2_CBECOM2_1

`celldefine
module HDBSVT11_ND2_CBECOM2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_CBECOM2_1

//%BEGIN HDBSVT11_ND2_CBECO_1

`celldefine
module HDBSVT11_ND2_CBECO_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_CBECO_1

//%BEGIN HDBSVT11_ND2_CBY2ECOM2FS_2

`celldefine
module HDBSVT11_ND2_CBY2ECOM2FS_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_CBY2ECOM2FS_2

//%BEGIN HDBSVT11_ND2_CBY2ECOM2_2

`celldefine
module HDBSVT11_ND2_CBY2ECOM2_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_CBY2ECOM2_2

//%BEGIN HDBSVT11_ND2_CBY2ECO_2

`celldefine
module HDBSVT11_ND2_CBY2ECO_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_CBY2ECO_2

//%BEGIN HDBSVT11_ND2_CB_1

`celldefine
module HDBSVT11_ND2_CB_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_CB_1

//%BEGIN HDBSVT11_ND2_CB_2

`celldefine
module HDBSVT11_ND2_CB_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_CB_2

//%BEGIN HDBSVT11_ND2_CDC_1
`celldefine
module HDBSVT11_ND2_CDC_1 (X, EN, A);
  input EN, A;
  output X;
  wire int_0, int_1;


    and inst0  (int_0, EN, A);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_COMBO_DELAY  inst2 (X, int_1);
  `else
    buf inst3  (X, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (A -=> X)=(0, 0);
if (A==1'b1) (EN -=> X)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CDC_1

//%BEGIN HDBSVT11_ND2_CDC_2
`celldefine
module HDBSVT11_ND2_CDC_2 (X, EN, A);
  input EN, A;
  output X;
  wire int_0, int_1;


    and inst0  (int_0, EN, A);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_COMBO_DELAY  inst2 (X, int_1);
  `else
    buf inst3  (X, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (A -=> X)=(0, 0);
if (A==1'b1) (EN -=> X)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CDC_2

//%BEGIN HDBSVT11_ND2_CDC_4
`celldefine
module HDBSVT11_ND2_CDC_4 (X, EN, A);
  input EN, A;
  output X;
  wire int_0, int_1;


    and inst0  (int_0, EN, A);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_COMBO_DELAY  inst2 (X, int_1);
  `else
    buf inst3  (X, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (A -=> X)=(0, 0);
if (A==1'b1) (EN -=> X)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CDC_4

//%BEGIN HDBSVT11_ND2_CKY2_10
`celldefine
module HDBSVT11_ND2_CKY2_10 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CKY2_10

//%BEGIN HDBSVT11_ND2_CKY2_11
`celldefine
module HDBSVT11_ND2_CKY2_11 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CKY2_11

//%BEGIN HDBSVT11_ND2_CKY2_12
`celldefine
module HDBSVT11_ND2_CKY2_12 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CKY2_12

//%BEGIN HDBSVT11_ND2_CKY2_16
`celldefine
module HDBSVT11_ND2_CKY2_16 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CKY2_16

//%BEGIN HDBSVT11_ND2_CK_1
`celldefine
module HDBSVT11_ND2_CK_1 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CK_1

//%BEGIN HDBSVT11_ND2_CK_2
`celldefine
module HDBSVT11_ND2_CK_2 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CK_2

//%BEGIN HDBSVT11_ND2_CK_3
`celldefine
module HDBSVT11_ND2_CK_3 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CK_3

//%BEGIN HDBSVT11_ND2_CK_4
`celldefine
module HDBSVT11_ND2_CK_4 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CK_4

//%BEGIN HDBSVT11_ND2_CK_5
`celldefine
module HDBSVT11_ND2_CK_5 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CK_5

//%BEGIN HDBSVT11_ND2_CK_6
`celldefine
module HDBSVT11_ND2_CK_6 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CK_6

//%BEGIN HDBSVT11_ND2_CK_7
`celldefine
module HDBSVT11_ND2_CK_7 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CK_7

//%BEGIN HDBSVT11_ND2_CK_8
`celldefine
module HDBSVT11_ND2_CK_8 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CK_8

//%BEGIN HDBSVT11_ND2_CK_9
`celldefine
module HDBSVT11_ND2_CK_9 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    and inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b1) (CLK -=> Z)=(0, 0);
if (CLK==1'b1) (EN -=> Z)=(0, 0);
$hold(negedge CLK , posedge EN , 0 , viol_0);
$hold(negedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , posedge CLK , 0 , viol_0);
$setup(negedge EN , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_ND2_CK_9

//%BEGIN HDBSVT11_ND2_ECOM2FS_1

`celldefine
module HDBSVT11_ND2_ECOM2FS_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_ECOM2FS_1

//%BEGIN HDBSVT11_ND2_ECOM2_1

`celldefine
module HDBSVT11_ND2_ECOM2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_ECOM2_1

//%BEGIN HDBSVT11_ND2_ECO_1

`celldefine
module HDBSVT11_ND2_ECO_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_ECO_1

//%BEGIN HDBSVT11_ND2_SKFY2_12

`celldefine
module HDBSVT11_ND2_SKFY2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_SKFY2_12

//%BEGIN HDBSVT11_ND2_SKF_2

`celldefine
module HDBSVT11_ND2_SKF_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_SKF_2

//%BEGIN HDBSVT11_ND2_SKF_4

`celldefine
module HDBSVT11_ND2_SKF_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_SKF_4

//%BEGIN HDBSVT11_ND2_SKF_8

`celldefine
module HDBSVT11_ND2_SKF_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_SKF_8

//%BEGIN HDBSVT11_ND2_SKRY2_12

`celldefine
module HDBSVT11_ND2_SKRY2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_SKRY2_12

//%BEGIN HDBSVT11_ND2_SKR_2

`celldefine
module HDBSVT11_ND2_SKR_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_SKR_2

//%BEGIN HDBSVT11_ND2_SKR_4

`celldefine
module HDBSVT11_ND2_SKR_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_SKR_4

//%BEGIN HDBSVT11_ND2_SKR_8

`celldefine
module HDBSVT11_ND2_SKR_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_SKR_8

//%BEGIN HDBSVT11_ND2_Y2ECOM2FS_2

`celldefine
module HDBSVT11_ND2_Y2ECOM2FS_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_Y2ECOM2FS_2

//%BEGIN HDBSVT11_ND2_Y2ECOM2_2

`celldefine
module HDBSVT11_ND2_Y2ECOM2_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_Y2ECOM2_2

//%BEGIN HDBSVT11_ND2_Y2ECO_2

`celldefine
module HDBSVT11_ND2_Y2ECO_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_Y2ECO_2

//%BEGIN HDBSVT11_ND2_Y2_16

`celldefine
module HDBSVT11_ND2_Y2_16 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_Y2_16

//%BEGIN HDBSVT11_ND2_Y2_32

`celldefine
module HDBSVT11_ND2_Y2_32 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_Y2_32

//%BEGIN HDBSVT11_ND2_Y4ECO_4

`celldefine
module HDBSVT11_ND2_Y4ECO_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_Y4ECO_4

//%BEGIN HDBSVT11_ND2_Y4_32

`celldefine
module HDBSVT11_ND2_Y4_32 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND2_Y4_32

//%BEGIN HDBSVT11_ND3B_1

`celldefine
module HDBSVT11_ND3B_1 (X, A, B1, B2);
   output X;
   input A, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

    `ifdef VIRL_functiononly
          nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);

    `else
          nand inst2  (X, int_res_0, B1, B2);

    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (B1==1'b1 && B2==1'b1) (A +=> X)=(0, 0);
if (A==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3B_1

//%BEGIN HDBSVT11_ND3B_Y2_2

`celldefine
module HDBSVT11_ND3B_Y2_2 (X, A, B1, B2);
   output X;
   input A, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

    `ifdef VIRL_functiononly
          nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);

    `else
          nand inst2  (X, int_res_0, B1, B2);

    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (B1==1'b1 && B2==1'b1) (A +=> X)=(0, 0);
if (A==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3B_Y2_2

//%BEGIN HDBSVT11_ND3B_Y2_4

`celldefine
module HDBSVT11_ND3B_Y2_4 (X, A, B1, B2);
   output X;
   input A, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

    `ifdef VIRL_functiononly
          nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);

    `else
          nand inst2  (X, int_res_0, B1, B2);

    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (B1==1'b1 && B2==1'b1) (A +=> X)=(0, 0);
if (A==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3B_Y2_4

//%BEGIN HDBSVT11_ND3B_Y2_8

`celldefine
module HDBSVT11_ND3B_Y2_8 (X, A, B1, B2);
   output X;
   input A, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

    `ifdef VIRL_functiononly
          nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);

    `else
          nand inst2  (X, int_res_0, B1, B2);

    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (B1==1'b1 && B2==1'b1) (A +=> X)=(0, 0);
if (A==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3B_Y2_8

//%BEGIN HDBSVT11_ND3_1

`celldefine
module HDBSVT11_ND3_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nand inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3_1

//%BEGIN HDBSVT11_ND3_2

`celldefine
module HDBSVT11_ND3_2 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nand inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3_2

//%BEGIN HDBSVT11_ND3_CBD1_1

`celldefine
module HDBSVT11_ND3_CBD1_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nand inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3_CBD1_1

//%BEGIN HDBSVT11_ND3_CBECOM2FS_1

`celldefine
module HDBSVT11_ND3_CBECOM2FS_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nand inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3_CBECOM2FS_1

//%BEGIN HDBSVT11_ND3_CBECOM2_1

`celldefine
module HDBSVT11_ND3_CBECOM2_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nand inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3_CBECOM2_1

//%BEGIN HDBSVT11_ND3_CBY2ECO_1

`celldefine
module HDBSVT11_ND3_CBY2ECO_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nand inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3_CBY2ECO_1

//%BEGIN HDBSVT11_ND3_CB_2

`celldefine
module HDBSVT11_ND3_CB_2 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nand inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3_CB_2

//%BEGIN HDBSVT11_ND3_D1_1

`celldefine
module HDBSVT11_ND3_D1_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nand inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3_D1_1

//%BEGIN HDBSVT11_ND3_ECOM2FS_1

`celldefine
module HDBSVT11_ND3_ECOM2FS_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nand inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3_ECOM2FS_1

//%BEGIN HDBSVT11_ND3_ECOM2_1

`celldefine
module HDBSVT11_ND3_ECOM2_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nand inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3_ECOM2_1

//%BEGIN HDBSVT11_ND3_Y2ECO_1

`celldefine
module HDBSVT11_ND3_Y2ECO_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nand inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3_Y2ECO_1

//%BEGIN HDBSVT11_ND3_Y2_16

`celldefine
module HDBSVT11_ND3_Y2_16 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nand inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3_Y2_16

//%BEGIN HDBSVT11_ND3_Y2_3

`celldefine
module HDBSVT11_ND3_Y2_3 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nand inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3_Y2_3

//%BEGIN HDBSVT11_ND3_Y2_4

`celldefine
module HDBSVT11_ND3_Y2_4 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nand inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3_Y2_4

//%BEGIN HDBSVT11_ND3_Y2_8

`celldefine
module HDBSVT11_ND3_Y2_8 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nand inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND3_Y2_8

//%BEGIN HDBSVT11_ND4_1

`celldefine
module HDBSVT11_ND4_1 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
       nand inst1  (X, A1, A2, A3, A4);

    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND4_1

//%BEGIN HDBSVT11_ND4_CBY2_2

`celldefine
module HDBSVT11_ND4_CBY2_2 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
       nand inst1  (X, A1, A2, A3, A4);

    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND4_CBY2_2

//%BEGIN HDBSVT11_ND4_CB_1

`celldefine
module HDBSVT11_ND4_CB_1 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
       nand inst1  (X, A1, A2, A3, A4);

    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND4_CB_1

//%BEGIN HDBSVT11_ND4_D1_1

`celldefine
module HDBSVT11_ND4_D1_1 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
       nand inst1  (X, A1, A2, A3, A4);

    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND4_D1_1

//%BEGIN HDBSVT11_ND4_Y2_12

`celldefine
module HDBSVT11_ND4_Y2_12 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
       nand inst1  (X, A1, A2, A3, A4);

    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND4_Y2_12

//%BEGIN HDBSVT11_ND4_Y2_2

`celldefine
module HDBSVT11_ND4_Y2_2 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
       nand inst1  (X, A1, A2, A3, A4);

    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND4_Y2_2

//%BEGIN HDBSVT11_ND4_Y2_3

`celldefine
module HDBSVT11_ND4_Y2_3 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
       nand inst1  (X, A1, A2, A3, A4);

    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND4_Y2_3

//%BEGIN HDBSVT11_ND4_Y2_4

`celldefine
module HDBSVT11_ND4_Y2_4 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
       nand inst1  (X, A1, A2, A3, A4);

    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND4_Y2_4

//%BEGIN HDBSVT11_ND4_Y2_8

`celldefine
module HDBSVT11_ND4_Y2_8 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
       nand inst1  (X, A1, A2, A3, A4);

    `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && A3==1'b1 && A4==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && A3==1'b1 && A4==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A4==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (A4 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_ND4_Y2_8

//%BEGIN HDBSVT11_NR2B_1

`celldefine
module HDBSVT11_NR2B_1 (X, A, B);
   output X;
   input A, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);

   `else
        nor inst2  (X, int_res_0, B);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (B==1'b0) (A +=> X)=(0, 0);
if (A==1'b1) (B -=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2B_1

//%BEGIN HDBSVT11_NR2B_2

`celldefine
module HDBSVT11_NR2B_2 (X, A, B);
   output X;
   input A, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);

   `else
        nor inst2  (X, int_res_0, B);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (B==1'b0) (A +=> X)=(0, 0);
if (A==1'b1) (B -=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2B_2

//%BEGIN HDBSVT11_NR2B_4

`celldefine
module HDBSVT11_NR2B_4 (X, A, B);
   output X;
   input A, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);

   `else
        nor inst2  (X, int_res_0, B);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (B==1'b0) (A +=> X)=(0, 0);
if (A==1'b1) (B -=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2B_4

//%BEGIN HDBSVT11_NR2B_8

`celldefine
module HDBSVT11_NR2B_8 (X, A, B);
   output X;
   input A, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);

   `else
        nor inst2  (X, int_res_0, B);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (B==1'b0) (A +=> X)=(0, 0);
if (A==1'b1) (B -=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2B_8

//%BEGIN HDBSVT11_NR2B_CB_1

`celldefine
module HDBSVT11_NR2B_CB_1 (X, A, B);
   output X;
   input A, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);

   `else
        nor inst2  (X, int_res_0, B);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (B==1'b0) (A +=> X)=(0, 0);
if (A==1'b1) (B -=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2B_CB_1

//%BEGIN HDBSVT11_NR2B_CB_4

`celldefine
module HDBSVT11_NR2B_CB_4 (X, A, B);
   output X;
   input A, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);

   `else
        nor inst2  (X, int_res_0, B);
    `endif

    `ifdef VIRL_functiononly

    `else


specify
if (B==1'b0) (A +=> X)=(0, 0);
if (A==1'b1) (B -=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2B_CB_4

//%BEGIN HDBSVT11_NR2_1

`celldefine
module HDBSVT11_NR2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_1

//%BEGIN HDBSVT11_NR2_2

`celldefine
module HDBSVT11_NR2_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_2

//%BEGIN HDBSVT11_NR2_3

`celldefine
module HDBSVT11_NR2_3 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_3

//%BEGIN HDBSVT11_NR2_4

`celldefine
module HDBSVT11_NR2_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_4

//%BEGIN HDBSVT11_NR2_5

`celldefine
module HDBSVT11_NR2_5 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_5

//%BEGIN HDBSVT11_NR2_6

`celldefine
module HDBSVT11_NR2_6 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_6

//%BEGIN HDBSVT11_NR2_8

`celldefine
module HDBSVT11_NR2_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_8

//%BEGIN HDBSVT11_NR2_CBECOM2FS_1

`celldefine
module HDBSVT11_NR2_CBECOM2FS_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_CBECOM2FS_1

//%BEGIN HDBSVT11_NR2_CBECOM2_1

`celldefine
module HDBSVT11_NR2_CBECOM2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_CBECOM2_1

//%BEGIN HDBSVT11_NR2_CBECO_1

`celldefine
module HDBSVT11_NR2_CBECO_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_CBECO_1

//%BEGIN HDBSVT11_NR2_CBY2ECOM2FS_2

`celldefine
module HDBSVT11_NR2_CBY2ECOM2FS_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_CBY2ECOM2FS_2

//%BEGIN HDBSVT11_NR2_CBY2ECOM2_2

`celldefine
module HDBSVT11_NR2_CBY2ECOM2_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_CBY2ECOM2_2

//%BEGIN HDBSVT11_NR2_CBY2ECO_2

`celldefine
module HDBSVT11_NR2_CBY2ECO_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_CBY2ECO_2

//%BEGIN HDBSVT11_NR2_CB_1

`celldefine
module HDBSVT11_NR2_CB_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_CB_1

//%BEGIN HDBSVT11_NR2_CB_2

`celldefine
module HDBSVT11_NR2_CB_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_CB_2

//%BEGIN HDBSVT11_NR2_CKY2_10
`celldefine
module HDBSVT11_NR2_CKY2_10 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN -=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_NR2_CKY2_10

//%BEGIN HDBSVT11_NR2_CKY2_11
`celldefine
module HDBSVT11_NR2_CKY2_11 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN -=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_NR2_CKY2_11

//%BEGIN HDBSVT11_NR2_CKY2_12
`celldefine
module HDBSVT11_NR2_CKY2_12 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN -=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_NR2_CKY2_12

//%BEGIN HDBSVT11_NR2_CKY2_16
`celldefine
module HDBSVT11_NR2_CKY2_16 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN -=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_NR2_CKY2_16

//%BEGIN HDBSVT11_NR2_CK_1
`celldefine
module HDBSVT11_NR2_CK_1 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN -=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_NR2_CK_1

//%BEGIN HDBSVT11_NR2_CK_2
`celldefine
module HDBSVT11_NR2_CK_2 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN -=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_NR2_CK_2

//%BEGIN HDBSVT11_NR2_CK_3
`celldefine
module HDBSVT11_NR2_CK_3 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN -=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_NR2_CK_3

//%BEGIN HDBSVT11_NR2_CK_4
`celldefine
module HDBSVT11_NR2_CK_4 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN -=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_NR2_CK_4

//%BEGIN HDBSVT11_NR2_CK_5
`celldefine
module HDBSVT11_NR2_CK_5 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN -=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_NR2_CK_5

//%BEGIN HDBSVT11_NR2_CK_6
`celldefine
module HDBSVT11_NR2_CK_6 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN -=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_NR2_CK_6

//%BEGIN HDBSVT11_NR2_CK_7
`celldefine
module HDBSVT11_NR2_CK_7 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN -=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_NR2_CK_7

//%BEGIN HDBSVT11_NR2_CK_8
`celldefine
module HDBSVT11_NR2_CK_8 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN -=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_NR2_CK_8

//%BEGIN HDBSVT11_NR2_CK_9
`celldefine
module HDBSVT11_NR2_CK_9 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, CLK, EN);
    not inst1  (int_1, int_0);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK -=> Z)=(0, 0);
if (CLK==1'b0) (EN -=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_NR2_CK_9

//%BEGIN HDBSVT11_NR2_ECOM2FS_1

`celldefine
module HDBSVT11_NR2_ECOM2FS_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_ECOM2FS_1

//%BEGIN HDBSVT11_NR2_ECOM2_1

`celldefine
module HDBSVT11_NR2_ECOM2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_ECOM2_1

//%BEGIN HDBSVT11_NR2_ECO_1

`celldefine
module HDBSVT11_NR2_ECO_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_ECO_1

//%BEGIN HDBSVT11_NR2_SKFY2_12

`celldefine
module HDBSVT11_NR2_SKFY2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_SKFY2_12

//%BEGIN HDBSVT11_NR2_SKF_2

`celldefine
module HDBSVT11_NR2_SKF_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_SKF_2

//%BEGIN HDBSVT11_NR2_SKF_4

`celldefine
module HDBSVT11_NR2_SKF_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_SKF_4

//%BEGIN HDBSVT11_NR2_SKF_8

`celldefine
module HDBSVT11_NR2_SKF_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_SKF_8

//%BEGIN HDBSVT11_NR2_SKRY2_12

`celldefine
module HDBSVT11_NR2_SKRY2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_SKRY2_12

//%BEGIN HDBSVT11_NR2_SKR_2

`celldefine
module HDBSVT11_NR2_SKR_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_SKR_2

//%BEGIN HDBSVT11_NR2_SKR_4

`celldefine
module HDBSVT11_NR2_SKR_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_SKR_4

//%BEGIN HDBSVT11_NR2_SKR_8

`celldefine
module HDBSVT11_NR2_SKR_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_SKR_8

//%BEGIN HDBSVT11_NR2_Y2ECOM2FS_2

`celldefine
module HDBSVT11_NR2_Y2ECOM2FS_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_Y2ECOM2FS_2

//%BEGIN HDBSVT11_NR2_Y2ECOM2_2

`celldefine
module HDBSVT11_NR2_Y2ECOM2_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_Y2ECOM2_2

//%BEGIN HDBSVT11_NR2_Y2ECO_2

`celldefine
module HDBSVT11_NR2_Y2ECO_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_Y2ECO_2

//%BEGIN HDBSVT11_NR2_Y2_16

`celldefine
module HDBSVT11_NR2_Y2_16 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR2_Y2_16

//%BEGIN HDBSVT11_NR3B_1

`celldefine
module HDBSVT11_NR3B_1 (X, A, B1, B2);
   output X;
   input A, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
        nor inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

    `else


specify
if (B1==1'b0 && B2==1'b0) (A +=> X)=(0, 0);
if (A==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR3B_1

//%BEGIN HDBSVT11_NR3B_Y2_2

`celldefine
module HDBSVT11_NR3B_Y2_2 (X, A, B1, B2);
   output X;
   input A, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
        nor inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

    `else


specify
if (B1==1'b0 && B2==1'b0) (A +=> X)=(0, 0);
if (A==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR3B_Y2_2

//%BEGIN HDBSVT11_NR3B_Y2_4

`celldefine
module HDBSVT11_NR3B_Y2_4 (X, A, B1, B2);
   output X;
   input A, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
        nor inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

    `else


specify
if (B1==1'b0 && B2==1'b0) (A +=> X)=(0, 0);
if (A==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR3B_Y2_4

//%BEGIN HDBSVT11_NR3B_Y2_8

`celldefine
module HDBSVT11_NR3B_Y2_8 (X, A, B1, B2);
   output X;
   input A, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
        nor inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

    `else


specify
if (B1==1'b0 && B2==1'b0) (A +=> X)=(0, 0);
if (A==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
    `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR3B_Y2_8

//%BEGIN HDBSVT11_NR3_1

`celldefine
module HDBSVT11_NR3_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR3_1

//%BEGIN HDBSVT11_NR3_2

`celldefine
module HDBSVT11_NR3_2 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR3_2

//%BEGIN HDBSVT11_NR3_CBECOM2FS_1

`celldefine
module HDBSVT11_NR3_CBECOM2FS_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR3_CBECOM2FS_1

//%BEGIN HDBSVT11_NR3_CBECOM2_1

`celldefine
module HDBSVT11_NR3_CBECOM2_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR3_CBECOM2_1

//%BEGIN HDBSVT11_NR3_CBY2ECO_1

`celldefine
module HDBSVT11_NR3_CBY2ECO_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR3_CBY2ECO_1

//%BEGIN HDBSVT11_NR3_ECOM2FS_1

`celldefine
module HDBSVT11_NR3_ECOM2FS_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR3_ECOM2FS_1

//%BEGIN HDBSVT11_NR3_ECOM2_1

`celldefine
module HDBSVT11_NR3_ECOM2_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR3_ECOM2_1

//%BEGIN HDBSVT11_NR3_Y2ECO_1

`celldefine
module HDBSVT11_NR3_Y2ECO_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR3_Y2ECO_1

//%BEGIN HDBSVT11_NR3_Y2_12

`celldefine
module HDBSVT11_NR3_Y2_12 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR3_Y2_12

//%BEGIN HDBSVT11_NR3_Y2_3

`celldefine
module HDBSVT11_NR3_Y2_3 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR3_Y2_3

//%BEGIN HDBSVT11_NR3_Y2_4

`celldefine
module HDBSVT11_NR3_Y2_4 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR3_Y2_4

//%BEGIN HDBSVT11_NR3_Y2_8

`celldefine
module HDBSVT11_NR3_Y2_8 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR3_Y2_8

//%BEGIN HDBSVT11_NR4_1

`celldefine
module HDBSVT11_NR4_1 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
         nor inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR4_1

//%BEGIN HDBSVT11_NR4_CB_1

`celldefine
module HDBSVT11_NR4_CB_1 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
         nor inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR4_CB_1

//%BEGIN HDBSVT11_NR4_D1_1

`celldefine
module HDBSVT11_NR4_D1_1 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
         nor inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR4_D1_1

//%BEGIN HDBSVT11_NR4_Y2_2

`celldefine
module HDBSVT11_NR4_Y2_2 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
         nor inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR4_Y2_2

//%BEGIN HDBSVT11_NR4_Y2_8

`celldefine
module HDBSVT11_NR4_Y2_8 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
         nor inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR4_Y2_8

//%BEGIN HDBSVT11_NR4_Y4_16

`celldefine
module HDBSVT11_NR4_Y4_16 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
         nor inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_NR4_Y4_16

//%BEGIN HDBSVT11_OA211_1

`celldefine
module HDBSVT11_OA211_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   `ifdef VIRL_functiononly
   and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
   and inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_OA211_1


//%BEGIN HDBSVT11_OA211_2

`celldefine
module HDBSVT11_OA211_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   `ifdef VIRL_functiononly
   and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
   and inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_OA211_2


//%BEGIN HDBSVT11_OA211_V1D1_1

`celldefine
module HDBSVT11_OA211_V1D1_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   `ifdef VIRL_functiononly
   and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
   and inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_OA211_V1D1_1


//%BEGIN HDBSVT11_OA211_V1Y2_4

`celldefine
module HDBSVT11_OA211_V1Y2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   `ifdef VIRL_functiononly
   and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
   and inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_OA211_V1Y2_4


//%BEGIN HDBSVT11_OA211_V1_1

`celldefine
module HDBSVT11_OA211_V1_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   `ifdef VIRL_functiononly
   and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
   and inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_OA211_V1_1


//%BEGIN HDBSVT11_OA211_V1_2

`celldefine
module HDBSVT11_OA211_V1_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   `ifdef VIRL_functiononly
   and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
   and inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_OA211_V1_2


//%BEGIN HDBSVT11_OA211_Y2_4

`celldefine
module HDBSVT11_OA211_Y2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   `ifdef VIRL_functiononly
   and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
   and inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_OA211_Y2_4


//%BEGIN HDBSVT11_OA211_Y2_8

`celldefine
module HDBSVT11_OA211_Y2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   `ifdef VIRL_functiononly
   and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
   and inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_OA211_Y2_8


//%BEGIN HDBSVT11_OA21B_1

`celldefine
module HDBSVT11_OA21B_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   not inst1  (int_res_1, B);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
       and inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA21B_1

//%BEGIN HDBSVT11_OA21B_2

`celldefine
module HDBSVT11_OA21B_2 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   not inst1  (int_res_1, B);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
       and inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA21B_2

//%BEGIN HDBSVT11_OA21B_4

`celldefine
module HDBSVT11_OA21B_4 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   not inst1  (int_res_1, B);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
       and inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA21B_4

//%BEGIN HDBSVT11_OA21B_8

`celldefine
module HDBSVT11_OA21B_8 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   not inst1  (int_res_1, B);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
       and inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA21B_8

//%BEGIN HDBSVT11_OA21_1

`celldefine
module HDBSVT11_OA21_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        and inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA21_1

//%BEGIN HDBSVT11_OA21_2

`celldefine
module HDBSVT11_OA21_2 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        and inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA21_2

//%BEGIN HDBSVT11_OA21_4

`celldefine
module HDBSVT11_OA21_4 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        and inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA21_4

//%BEGIN HDBSVT11_OA21_8

`celldefine
module HDBSVT11_OA21_8 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        and inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA21_8

//%BEGIN HDBSVT11_OA21_CKV1Y2_4
`celldefine
module HDBSVT11_OA21_CKV1Y2_4 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, E, TE);
    and inst1  (int_1, int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1 && TE==1'b0) (E +=> Z)=(0, 0);
if (CLK==1'b1 && E==1'b0) (TE +=> Z)=(0, 0);
$hold(negedge CLK , posedge E , 0 , viol_0);
$hold(negedge CLK , negedge E , 0 , viol_0);
$setup(posedge E , posedge CLK , 0 , viol_0);
$setup(negedge E , posedge CLK , 0 , viol_0);
$hold(negedge CLK , posedge TE , 0 , viol_0);
$hold(negedge CLK , negedge TE , 0 , viol_0);
$setup(posedge TE , posedge CLK , 0 , viol_0);
$setup(negedge TE , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OA21_CKV1Y2_4

//%BEGIN HDBSVT11_OA21_CKV1Y2_6
`celldefine
module HDBSVT11_OA21_CKV1Y2_6 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, E, TE);
    and inst1  (int_1, int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1 && TE==1'b0) (E +=> Z)=(0, 0);
if (CLK==1'b1 && E==1'b0) (TE +=> Z)=(0, 0);
$hold(negedge CLK , posedge E , 0 , viol_0);
$hold(negedge CLK , negedge E , 0 , viol_0);
$setup(posedge E , posedge CLK , 0 , viol_0);
$setup(negedge E , posedge CLK , 0 , viol_0);
$hold(negedge CLK , posedge TE , 0 , viol_0);
$hold(negedge CLK , negedge TE , 0 , viol_0);
$setup(posedge TE , posedge CLK , 0 , viol_0);
$setup(negedge TE , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OA21_CKV1Y2_6

//%BEGIN HDBSVT11_OA21_CKV1_1
`celldefine
module HDBSVT11_OA21_CKV1_1 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, E, TE);
    and inst1  (int_1, int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1 && TE==1'b0) (E +=> Z)=(0, 0);
if (CLK==1'b1 && E==1'b0) (TE +=> Z)=(0, 0);
$hold(negedge CLK , posedge E , 0 , viol_0);
$hold(negedge CLK , negedge E , 0 , viol_0);
$setup(posedge E , posedge CLK , 0 , viol_0);
$setup(negedge E , posedge CLK , 0 , viol_0);
$hold(negedge CLK , posedge TE , 0 , viol_0);
$hold(negedge CLK , negedge TE , 0 , viol_0);
$setup(posedge TE , posedge CLK , 0 , viol_0);
$setup(negedge TE , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OA21_CKV1_1

//%BEGIN HDBSVT11_OA21_CKV1_2
`celldefine
module HDBSVT11_OA21_CKV1_2 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, E, TE);
    and inst1  (int_1, int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1 && TE==1'b0) (E +=> Z)=(0, 0);
if (CLK==1'b1 && E==1'b0) (TE +=> Z)=(0, 0);
$hold(negedge CLK , posedge E , 0 , viol_0);
$hold(negedge CLK , negedge E , 0 , viol_0);
$setup(posedge E , posedge CLK , 0 , viol_0);
$setup(negedge E , posedge CLK , 0 , viol_0);
$hold(negedge CLK , posedge TE , 0 , viol_0);
$hold(negedge CLK , negedge TE , 0 , viol_0);
$setup(posedge TE , posedge CLK , 0 , viol_0);
$setup(negedge TE , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OA21_CKV1_2

//%BEGIN HDBSVT11_OA21_CK_1
`celldefine
module HDBSVT11_OA21_CK_1 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, E, TE);
    and inst1  (int_1, int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1 && TE==1'b0) (E +=> Z)=(0, 0);
if (CLK==1'b1 && E==1'b0) (TE +=> Z)=(0, 0);
$hold(negedge CLK , posedge E , 0 , viol_0);
$hold(negedge CLK , negedge E , 0 , viol_0);
$setup(posedge E , posedge CLK , 0 , viol_0);
$setup(negedge E , posedge CLK , 0 , viol_0);
$hold(negedge CLK , posedge TE , 0 , viol_0);
$hold(negedge CLK , negedge TE , 0 , viol_0);
$setup(posedge TE , posedge CLK , 0 , viol_0);
$setup(negedge TE , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OA21_CK_1

//%BEGIN HDBSVT11_OA21_CK_2
`celldefine
module HDBSVT11_OA21_CK_2 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, E, TE);
    and inst1  (int_1, int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1 && TE==1'b0) (E +=> Z)=(0, 0);
if (CLK==1'b1 && E==1'b0) (TE +=> Z)=(0, 0);
$hold(negedge CLK , posedge E , 0 , viol_0);
$hold(negedge CLK , negedge E , 0 , viol_0);
$setup(posedge E , posedge CLK , 0 , viol_0);
$setup(negedge E , posedge CLK , 0 , viol_0);
$hold(negedge CLK , posedge TE , 0 , viol_0);
$hold(negedge CLK , negedge TE , 0 , viol_0);
$setup(posedge TE , posedge CLK , 0 , viol_0);
$setup(negedge TE , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OA21_CK_2

//%BEGIN HDBSVT11_OA21_CK_4
`celldefine
module HDBSVT11_OA21_CK_4 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, E, TE);
    and inst1  (int_1, int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1 && TE==1'b0) (E +=> Z)=(0, 0);
if (CLK==1'b1 && E==1'b0) (TE +=> Z)=(0, 0);
$hold(negedge CLK , posedge E , 0 , viol_0);
$hold(negedge CLK , negedge E , 0 , viol_0);
$setup(posedge E , posedge CLK , 0 , viol_0);
$setup(negedge E , posedge CLK , 0 , viol_0);
$hold(negedge CLK , posedge TE , 0 , viol_0);
$hold(negedge CLK , negedge TE , 0 , viol_0);
$setup(posedge TE , posedge CLK , 0 , viol_0);
$setup(negedge TE , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OA21_CK_4

//%BEGIN HDBSVT11_OA21_CK_6
`celldefine
module HDBSVT11_OA21_CK_6 (Z, CLK, E, TE);
  input CLK, E, TE;
  output Z;
  wire int_0, int_1;
  reg viol_0;


    or inst0  (int_0, E, TE);
    and inst1  (int_1, int_0, CLK);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst2 (Z, int_1);
  `else
    buf inst3  (Z, int_1);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (E==1'b0 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b0) (CLK +=> Z)=(0, 0);
if (E==1'b1 && TE==1'b1) (CLK +=> Z)=(0, 0);
if (CLK==1'b1 && TE==1'b0) (E +=> Z)=(0, 0);
if (CLK==1'b1 && E==1'b0) (TE +=> Z)=(0, 0);
$hold(negedge CLK , posedge E , 0 , viol_0);
$hold(negedge CLK , negedge E , 0 , viol_0);
$setup(posedge E , posedge CLK , 0 , viol_0);
$setup(negedge E , posedge CLK , 0 , viol_0);
$hold(negedge CLK , posedge TE , 0 , viol_0);
$hold(negedge CLK , negedge TE , 0 , viol_0);
$setup(posedge TE , posedge CLK , 0 , viol_0);
$setup(negedge TE , posedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OA21_CK_6

//%BEGIN HDBSVT11_OA21_V1D1_1

`celldefine
module HDBSVT11_OA21_V1D1_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        and inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA21_V1D1_1

//%BEGIN HDBSVT11_OA21_V1Y2_4

`celldefine
module HDBSVT11_OA21_V1Y2_4 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        and inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA21_V1Y2_4

//%BEGIN HDBSVT11_OA21_V1_1

`celldefine
module HDBSVT11_OA21_V1_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        and inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA21_V1_1

//%BEGIN HDBSVT11_OA21_V1_2

`celldefine
module HDBSVT11_OA21_V1_2 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        and inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA21_V1_2

//%BEGIN HDBSVT11_OA221_Y2_1

`celldefine
module HDBSVT11_OA221_Y2_1 (X, A1, A2, B1, B2, C);
   output X;
   input A1, A2, B1, B2, C;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1, C);
   `else
      and inst3  (X, int_res_0, int_res_1, C);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1) (C +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_OA221_Y2_1


//%BEGIN HDBSVT11_OA221_Y2_2

`celldefine
module HDBSVT11_OA221_Y2_2 (X, A1, A2, B1, B2, C);
   output X;
   input A1, A2, B1, B2, C;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1, C);
   `else
      and inst3  (X, int_res_0, int_res_1, C);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1) (C +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_OA221_Y2_2


//%BEGIN HDBSVT11_OA221_Y2_4

`celldefine
module HDBSVT11_OA221_Y2_4 (X, A1, A2, B1, B2, C);
   output X;
   input A1, A2, B1, B2, C;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   `ifdef VIRL_functiononly
      and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1, C);
   `else
      and inst3  (X, int_res_0, int_res_1, C);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1) (C +=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_OA221_Y2_4


//%BEGIN HDBSVT11_OA222_1

`celldefine
module HDBSVT11_OA222_1 (X, A1, A2, B1, B2, C1, C2);
   output X;
   input A1, A2, B1, B2, C1, C2;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0   (int_res_0, A1, A2);
   or inst1   (int_res_1, B1, B2);
   or inst2   (int_res_2, C1, C2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         and #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
         and inst4  (X, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA222_1

//%BEGIN HDBSVT11_OA222_2

`celldefine
module HDBSVT11_OA222_2 (X, A1, A2, B1, B2, C1, C2);
   output X;
   input A1, A2, B1, B2, C1, C2;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0   (int_res_0, A1, A2);
   or inst1   (int_res_1, B1, B2);
   or inst2   (int_res_2, C1, C2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         and #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
         and inst4  (X, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA222_2

//%BEGIN HDBSVT11_OA222_Y2_4

`celldefine
module HDBSVT11_OA222_Y2_4 (X, A1, A2, B1, B2, C1, C2);
   output X;
   input A1, A2, B1, B2, C1, C2;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0   (int_res_0, A1, A2);
   or inst1   (int_res_1, B1, B2);
   or inst2   (int_res_2, C1, C2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         and #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
         and inst4  (X, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA222_Y2_4

//%BEGIN HDBSVT11_OA222_Y2_8

`celldefine
module HDBSVT11_OA222_Y2_8 (X, A1, A2, B1, B2, C1, C2);
   output X;
   input A1, A2, B1, B2, C1, C2;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0   (int_res_0, A1, A2);
   or inst1   (int_res_1, B1, B2);
   or inst2   (int_res_2, C1, C2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         and #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
         and inst4  (X, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA222_Y2_8

//%BEGIN HDBSVT11_OA22_1

`celldefine
module HDBSVT11_OA22_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
        and inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA22_1

//%BEGIN HDBSVT11_OA22_2

`celldefine
module HDBSVT11_OA22_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
        and inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA22_2

//%BEGIN HDBSVT11_OA22_D1_1

`celldefine
module HDBSVT11_OA22_D1_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
        and inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA22_D1_1

//%BEGIN HDBSVT11_OA22_Y2_4

`celldefine
module HDBSVT11_OA22_Y2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
        and inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA22_Y2_4

//%BEGIN HDBSVT11_OA22_Y2_8

`celldefine
module HDBSVT11_OA22_Y2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
        and inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA22_Y2_8

//%BEGIN HDBSVT11_OA2BB2_1

`celldefine
module HDBSVT11_OA2BB2_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1, int_res_2, 
      int_res_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A1);
   not inst1  (int_res_1, A2);
   or inst2  (int_res_2, int_res_0, int_res_1);
   or inst3  (int_res_3, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst4 (X, int_res_2, int_res_3);
   `else
        and inst5  (X, int_res_2, int_res_3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA2BB2_1

//%BEGIN HDBSVT11_OA2BB2_2

`celldefine
module HDBSVT11_OA2BB2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1, int_res_2, 
      int_res_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A1);
   not inst1  (int_res_1, A2);
   or inst2  (int_res_2, int_res_0, int_res_1);
   or inst3  (int_res_3, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst4 (X, int_res_2, int_res_3);
   `else
        and inst5  (X, int_res_2, int_res_3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA2BB2_2

//%BEGIN HDBSVT11_OA2BB2_4

`celldefine
module HDBSVT11_OA2BB2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1, int_res_2, 
      int_res_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A1);
   not inst1  (int_res_1, A2);
   or inst2  (int_res_2, int_res_0, int_res_1);
   or inst3  (int_res_3, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst4 (X, int_res_2, int_res_3);
   `else
        and inst5  (X, int_res_2, int_res_3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA2BB2_4

//%BEGIN HDBSVT11_OA2BB2_CB_1

`celldefine
module HDBSVT11_OA2BB2_CB_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1, int_res_2, 
      int_res_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A1);
   not inst1  (int_res_1, A2);
   or inst2  (int_res_2, int_res_0, int_res_1);
   or inst3  (int_res_3, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst4 (X, int_res_2, int_res_3);
   `else
        and inst5  (X, int_res_2, int_res_3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA2BB2_CB_1

//%BEGIN HDBSVT11_OA2BB2_Y2_12

`celldefine
module HDBSVT11_OA2BB2_Y2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1, int_res_2, 
      int_res_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A1);
   not inst1  (int_res_1, A2);
   or inst2  (int_res_2, int_res_0, int_res_1);
   or inst3  (int_res_3, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst4 (X, int_res_2, int_res_3);
   `else
        and inst5  (X, int_res_2, int_res_3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA2BB2_Y2_12

//%BEGIN HDBSVT11_OA2BB2_Y2_8

`celldefine
module HDBSVT11_OA2BB2_Y2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1, int_res_2, 
      int_res_3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   not inst0  (int_res_0, A1);
   not inst1  (int_res_1, A2);
   or inst2  (int_res_2, int_res_0, int_res_1);
   or inst3  (int_res_3, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst4 (X, int_res_2, int_res_3);
   `else
        and inst5  (X, int_res_2, int_res_3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA2BB2_Y2_8

//%BEGIN HDBSVT11_OA31_1

`celldefine
module HDBSVT11_OA31_1 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        and inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA31_1

//%BEGIN HDBSVT11_OA31_2

`celldefine
module HDBSVT11_OA31_2 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        and inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA31_2

//%BEGIN HDBSVT11_OA31_D1_1

`celldefine
module HDBSVT11_OA31_D1_1 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        and inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA31_D1_1

//%BEGIN HDBSVT11_OA31_Y2_4

`celldefine
module HDBSVT11_OA31_Y2_4 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        and inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA31_Y2_4

//%BEGIN HDBSVT11_OA31_Y2_8

`celldefine
module HDBSVT11_OA31_Y2_8 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        and inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (B +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA31_Y2_8

//%BEGIN HDBSVT11_OA32_1

`celldefine
module HDBSVT11_OA32_1 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
       and inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA32_1

//%BEGIN HDBSVT11_OA32_2

`celldefine
module HDBSVT11_OA32_2 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
       and inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA32_2

//%BEGIN HDBSVT11_OA32_Y2_4

`celldefine
module HDBSVT11_OA32_Y2_4 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
       and inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA32_Y2_4

//%BEGIN HDBSVT11_OA33_1

`celldefine
module HDBSVT11_OA33_1 (X, A1, A2, A3, B1, B2, B3);
   output X;
   input A1, A2, A3, B1, B2, B3;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0   (int_res_0, A1, A2, A3);
   or inst1   (int_res_1, B1, B2, B3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
        and inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA33_1

//%BEGIN HDBSVT11_OA33_2

`celldefine
module HDBSVT11_OA33_2 (X, A1, A2, A3, B1, B2, B3);
   output X;
   input A1, A2, A3, B1, B2, B3;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0   (int_res_0, A1, A2, A3);
   or inst1   (int_res_1, B1, B2, B3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
        and inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA33_2

//%BEGIN HDBSVT11_OA33_Y2_4

`celldefine
module HDBSVT11_OA33_Y2_4 (X, A1, A2, A3, B1, B2, B3);
   output X;
   input A1, A2, A3, B1, B2, B3;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0   (int_res_0, A1, A2, A3);
   or inst1   (int_res_1, B1, B2, B3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        and #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
        and inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A1 +=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OA33_Y2_4

//%BEGIN HDBSVT11_OAI211_1

`celldefine
module HDBSVT11_OAI211_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
        nand inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI211_1

//%BEGIN HDBSVT11_OAI211_2

`celldefine
module HDBSVT11_OAI211_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
        nand inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI211_2

//%BEGIN HDBSVT11_OAI211_CB_1

`celldefine
module HDBSVT11_OAI211_CB_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
        nand inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI211_CB_1

//%BEGIN HDBSVT11_OAI211_PC_2

`celldefine
module HDBSVT11_OAI211_PC_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
        nand inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI211_PC_2

//%BEGIN HDBSVT11_OAI211_Y2_12

`celldefine
module HDBSVT11_OAI211_Y2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
        nand inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI211_Y2_12

//%BEGIN HDBSVT11_OAI211_Y2_4

`celldefine
module HDBSVT11_OAI211_Y2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
        nand inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI211_Y2_4

//%BEGIN HDBSVT11_OAI211_Y2_8

`celldefine
module HDBSVT11_OAI211_Y2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
        nand inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI211_Y2_8

//%BEGIN HDBSVT11_OAI21_1

`celldefine
module HDBSVT11_OAI21_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B); 
   `endif
 
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI21_1

//%BEGIN HDBSVT11_OAI21_2

`celldefine
module HDBSVT11_OAI21_2 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B); 
   `endif
 
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI21_2

//%BEGIN HDBSVT11_OAI21_3

`celldefine
module HDBSVT11_OAI21_3 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B); 
   `endif
 
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI21_3

//%BEGIN HDBSVT11_OAI21_4

`celldefine
module HDBSVT11_OAI21_4 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B); 
   `endif
 
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI21_4

//%BEGIN HDBSVT11_OAI21_CB_1

`celldefine
module HDBSVT11_OAI21_CB_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B); 
   `endif
 
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI21_CB_1

//%BEGIN HDBSVT11_OAI21_CB_2

`celldefine
module HDBSVT11_OAI21_CB_2 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B); 
   `endif
 
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI21_CB_2

//%BEGIN HDBSVT11_OAI21_V1Y2_12

`celldefine
module HDBSVT11_OAI21_V1Y2_12 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B); 
   `endif
 
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI21_V1Y2_12

//%BEGIN HDBSVT11_OAI21_V1Y2_2

`celldefine
module HDBSVT11_OAI21_V1Y2_2 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B); 
   `endif
 
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI21_V1Y2_2

//%BEGIN HDBSVT11_OAI21_V1Y2_4

`celldefine
module HDBSVT11_OAI21_V1Y2_4 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B); 
   `endif
 
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI21_V1Y2_4

//%BEGIN HDBSVT11_OAI21_V1Y2_6

`celldefine
module HDBSVT11_OAI21_V1Y2_6 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B); 
   `endif
 
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI21_V1Y2_6

//%BEGIN HDBSVT11_OAI21_V1Y2_8

`celldefine
module HDBSVT11_OAI21_V1Y2_8 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B); 
   `endif
 
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI21_V1Y2_8

//%BEGIN HDBSVT11_OAI21_V1_1

`celldefine
module HDBSVT11_OAI21_V1_1 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B); 
   `endif
 
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI21_V1_1

//%BEGIN HDBSVT11_OAI21_Y2_12

`celldefine
module HDBSVT11_OAI21_Y2_12 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B); 
   `endif
 
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI21_Y2_12

//%BEGIN HDBSVT11_OAI21_Y2_8

`celldefine
module HDBSVT11_OAI21_Y2_8 (X, A1, A2, B);
   output X;
   input A1, A2, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
        nand inst2  (X, int_res_0, B); 
   `endif
 
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI21_Y2_8

//%BEGIN HDBSVT11_OAI221_1

`celldefine
module HDBSVT11_OAI221_1 (X, A1, A2, B1, B2, C);
   output X;
   input A1, A2, B1, B2, C;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1, C);
   `else
      nand inst3  (X, int_res_0, int_res_1, C);
   `endif
   
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1) (C -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI221_1

//%BEGIN HDBSVT11_OAI221_CB_1

`celldefine
module HDBSVT11_OAI221_CB_1 (X, A1, A2, B1, B2, C);
   output X;
   input A1, A2, B1, B2, C;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1, C);
   `else
      nand inst3  (X, int_res_0, int_res_1, C);
   `endif
   
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1) (C -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI221_CB_1

//%BEGIN HDBSVT11_OAI221_Y2_2

`celldefine
module HDBSVT11_OAI221_Y2_2 (X, A1, A2, B1, B2, C);
   output X;
   input A1, A2, B1, B2, C;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1, C);
   `else
      nand inst3  (X, int_res_0, int_res_1, C);
   `endif
   
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1) (C -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI221_Y2_2

//%BEGIN HDBSVT11_OAI221_Y2_4

`celldefine
module HDBSVT11_OAI221_Y2_4 (X, A1, A2, B1, B2, C);
   output X;
   input A1, A2, B1, B2, C;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1, C);
   `else
      nand inst3  (X, int_res_0, int_res_1, C);
   `endif
   
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1) (C -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI221_Y2_4

//%BEGIN HDBSVT11_OAI221_Y2_8

`celldefine
module HDBSVT11_OAI221_Y2_8 (X, A1, A2, B1, B2, C);
   output X;
   input A1, A2, B1, B2, C;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1, C);
   `else
      nand inst3  (X, int_res_0, int_res_1, C);
   `endif
   
   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1) (C -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI221_Y2_8

//%BEGIN HDBSVT11_OAI222_1

`celldefine
module HDBSVT11_OAI222_1 (X, A1, A2, B1, B2, C1, C2);
   output X;
   input A1, A2, B1, B2, C1, C2;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);
   or inst2  (int_res_2, C1, C2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
      nand inst4  (X, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI222_1

//%BEGIN HDBSVT11_OAI222_Y2_2

`celldefine
module HDBSVT11_OAI222_Y2_2 (X, A1, A2, B1, B2, C1, C2);
   output X;
   input A1, A2, B1, B2, C1, C2;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);
   or inst2  (int_res_2, C1, C2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
      nand inst4  (X, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI222_Y2_2

//%BEGIN HDBSVT11_OAI222_Y2_4

`celldefine
module HDBSVT11_OAI222_Y2_4 (X, A1, A2, B1, B2, C1, C2);
   output X;
   input A1, A2, B1, B2, C1, C2;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);
   or inst2  (int_res_2, C1, C2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
      nand inst4  (X, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI222_Y2_4

//%BEGIN HDBSVT11_OAI222_Y4_8

`celldefine
module HDBSVT11_OAI222_Y4_8 (X, A1, A2, B1, B2, C1, C2);
   output X;
   input A1, A2, B1, B2, C1, C2;

   wire int_res_0, int_res_1, int_res_2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);
   or inst2  (int_res_2, C1, C2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst3 (X, int_res_0, int_res_1, int_res_2);
   `else
      nand inst4  (X, int_res_0, int_res_1, int_res_2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b1 && C2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b0 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0 && C1==1'b1 && C2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b0 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && C1==1'b1 && C2==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C2==1'b0) (C1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b0 && C1==1'b0) (C2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1 && B2==1'b1 && C1==1'b0) (C2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI222_Y4_8

//%BEGIN HDBSVT11_OAI22_1

`celldefine
module HDBSVT11_OAI22_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI22_1

//%BEGIN HDBSVT11_OAI22_CB_1

`celldefine
module HDBSVT11_OAI22_CB_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI22_CB_1

//%BEGIN HDBSVT11_OAI22_D1_1

`celldefine
module HDBSVT11_OAI22_D1_1 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI22_D1_1

//%BEGIN HDBSVT11_OAI22_SKFY2_12

`celldefine
module HDBSVT11_OAI22_SKFY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI22_SKFY2_12

//%BEGIN HDBSVT11_OAI22_SKFY2_2

`celldefine
module HDBSVT11_OAI22_SKFY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI22_SKFY2_2

//%BEGIN HDBSVT11_OAI22_SKFY2_4

`celldefine
module HDBSVT11_OAI22_SKFY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI22_SKFY2_4

//%BEGIN HDBSVT11_OAI22_SKFY2_8

`celldefine
module HDBSVT11_OAI22_SKFY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI22_SKFY2_8

//%BEGIN HDBSVT11_OAI22_SKRY2_12

`celldefine
module HDBSVT11_OAI22_SKRY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI22_SKRY2_12

//%BEGIN HDBSVT11_OAI22_SKRY2_2

`celldefine
module HDBSVT11_OAI22_SKRY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI22_SKRY2_2

//%BEGIN HDBSVT11_OAI22_SKRY2_4

`celldefine
module HDBSVT11_OAI22_SKRY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI22_SKRY2_4

//%BEGIN HDBSVT11_OAI22_SKRY2_8

`celldefine
module HDBSVT11_OAI22_SKRY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI22_SKRY2_8

//%BEGIN HDBSVT11_OAI22_Y2_12

`celldefine
module HDBSVT11_OAI22_Y2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI22_Y2_12

//%BEGIN HDBSVT11_OAI22_Y2_2

`celldefine
module HDBSVT11_OAI22_Y2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI22_Y2_2

//%BEGIN HDBSVT11_OAI22_Y2_3

`celldefine
module HDBSVT11_OAI22_Y2_3 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI22_Y2_3

//%BEGIN HDBSVT11_OAI22_Y2_4

`celldefine
module HDBSVT11_OAI22_Y2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI22_Y2_4

//%BEGIN HDBSVT11_OAI22_Y2_8

`celldefine
module HDBSVT11_OAI22_Y2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI22_Y2_8

//%BEGIN HDBSVT11_OAI311_1

`celldefine
module HDBSVT11_OAI311_1 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
       nand inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI311_1

//%BEGIN HDBSVT11_OAI311_Y2_2

`celldefine
module HDBSVT11_OAI311_Y2_2 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
       nand inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI311_Y2_2

//%BEGIN HDBSVT11_OAI311_Y2_4

`celldefine
module HDBSVT11_OAI311_Y2_4 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
       nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
       nand inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI311_Y2_4

//%BEGIN HDBSVT11_OAI31_1

`celldefine
module HDBSVT11_OAI31_1 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      nand inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI31_1

//%BEGIN HDBSVT11_OAI31_D1_1

`celldefine
module HDBSVT11_OAI31_D1_1 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      nand inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI31_D1_1

//%BEGIN HDBSVT11_OAI31_Y2_2

`celldefine
module HDBSVT11_OAI31_Y2_2 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      nand inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI31_Y2_2

//%BEGIN HDBSVT11_OAI31_Y2_4

`celldefine
module HDBSVT11_OAI31_Y2_4 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      nand inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI31_Y2_4

//%BEGIN HDBSVT11_OAI31_Y2_8

`celldefine
module HDBSVT11_OAI31_Y2_8 (X, A1, A2, A3, B);
   output X;
   input A1, A2, A3, B;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B);
   `else
      nand inst2  (X, int_res_0, B);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1) (B -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI31_Y2_8

//%BEGIN HDBSVT11_OAI32_1

`celldefine
module HDBSVT11_OAI32_1 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI32_1

//%BEGIN HDBSVT11_OAI32_D1_1

`celldefine
module HDBSVT11_OAI32_D1_1 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI32_D1_1

//%BEGIN HDBSVT11_OAI32_Y2_2

`celldefine
module HDBSVT11_OAI32_Y2_2 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI32_Y2_2

//%BEGIN HDBSVT11_OAI32_Y2_4

`celldefine
module HDBSVT11_OAI32_Y2_4 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI32_Y2_4

//%BEGIN HDBSVT11_OAI32_Y2_8

`celldefine
module HDBSVT11_OAI32_Y2_8 (X, A1, A2, A3, B1, B2);
   output X;
   input A1, A2, A3, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2, A3);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAI32_Y2_8

//%BEGIN HDBSVT11_OAI33_1

`celldefine
module HDBSVT11_OAI33_1 (X, A1, A2, A3, B1, B2, B3);
   output X;
   input A1, A2, A3, B1, B2, B3;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0   (int_res_0, A1, A2, A3);
   or inst1   (int_res_1, B1, B2, B3);

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_OAI33_1


//%BEGIN HDBSVT11_OAI33_Y2_2

`celldefine
module HDBSVT11_OAI33_Y2_2 (X, A1, A2, A3, B1, B2, B3);
   output X;
   input A1, A2, A3, B1, B2, B3;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0   (int_res_0, A1, A2, A3);
   or inst1   (int_res_1, B1, B2, B3);

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_OAI33_Y2_2


//%BEGIN HDBSVT11_OAI33_Y2_4

`celldefine
module HDBSVT11_OAI33_Y2_4 (X, A1, A2, A3, B1, B2, B3);
   output X;
   input A1, A2, A3, B1, B2, B3;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0   (int_res_0, A1, A2, A3);
   or inst1   (int_res_1, B1, B2, B3);

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_OAI33_Y2_4


//%BEGIN HDBSVT11_OAI33_Y4_8

`celldefine
module HDBSVT11_OAI33_Y4_8 (X, A1, A2, A3, B1, B2, B3);
   output X;
   input A1, A2, A3, B1, B2, B3;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0   (int_res_0, A1, A2, A3);
   or inst1   (int_res_1, B1, B2, B3);

   `ifdef VIRL_functiononly
      nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////


specify
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b0 && B2==1'b1 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b0 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b0) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1 && B2==1'b1 && B3==1'b1) (A3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B2==1'b0 && B3==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B3==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b0 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && A3==1'b1 && B1==1'b0 && B2==1'b0) (B3 -=> X)=(0, 0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_OAI33_Y4_8


//%BEGIN HDBSVT11_OAOI211_Y2_4

`celldefine
module HDBSVT11_OAOI211_Y2_4 (X, A1, A2, B, C);
   output X;
   input A1, A2, B, C;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, int_res_0, B);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_1, C);
   `else
      nor inst3  (X, int_res_1, C);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0 && B==1'b1 && C==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B==1'b1 && C==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && C==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && C==1'b0) (B -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && C==1'b0) (B -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B==1'b0) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B==1'b1) (C -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B==1'b0) (C -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B==1'b0) (C -=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OAOI211_Y2_4

//%BEGIN HDBSVT11_OR2_1

`celldefine
module HDBSVT11_OR2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       or inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR2_1

//%BEGIN HDBSVT11_OR2_12

`celldefine
module HDBSVT11_OR2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       or inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR2_12

//%BEGIN HDBSVT11_OR2_2

`celldefine
module HDBSVT11_OR2_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       or inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR2_2

//%BEGIN HDBSVT11_OR2_4

`celldefine
module HDBSVT11_OR2_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       or inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR2_4

//%BEGIN HDBSVT11_OR2_CBECOM2FS_2

`celldefine
module HDBSVT11_OR2_CBECOM2FS_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       or inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR2_CBECOM2FS_2

//%BEGIN HDBSVT11_OR2_CBECOM2_2

`celldefine
module HDBSVT11_OR2_CBECOM2_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       or inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR2_CBECOM2_2

//%BEGIN HDBSVT11_OR2_CBY2ECO_2

`celldefine
module HDBSVT11_OR2_CBY2ECO_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       or inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR2_CBY2ECO_2

//%BEGIN HDBSVT11_OR2_CB_1

`celldefine
module HDBSVT11_OR2_CB_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       or inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR2_CB_1

//%BEGIN HDBSVT11_OR2_CKST_0P5
`celldefine
module HDBSVT11_OR2_CKST_0P5 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;

    or inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OR2_CKST_0P5

//%BEGIN HDBSVT11_OR2_CKST_2
`celldefine
module HDBSVT11_OR2_CKST_2 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;

    or inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OR2_CKST_2

//%BEGIN HDBSVT11_OR2_CKST_2P5
`celldefine
module HDBSVT11_OR2_CKST_2P5 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;

    or inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OR2_CKST_2P5

//%BEGIN HDBSVT11_OR2_CKY2_12
`celldefine
module HDBSVT11_OR2_CKY2_12 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;

    or inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OR2_CKY2_12

//%BEGIN HDBSVT11_OR2_CKY2_16
`celldefine
module HDBSVT11_OR2_CKY2_16 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;

    or inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OR2_CKY2_16

//%BEGIN HDBSVT11_OR2_CKY2_20
`celldefine
module HDBSVT11_OR2_CKY2_20 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;

    or inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OR2_CKY2_20

//%BEGIN HDBSVT11_OR2_CK_1
`celldefine
module HDBSVT11_OR2_CK_1 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;

    or inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OR2_CK_1

//%BEGIN HDBSVT11_OR2_CK_10
`celldefine
module HDBSVT11_OR2_CK_10 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;

    or inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OR2_CK_10

//%BEGIN HDBSVT11_OR2_CK_2
`celldefine
module HDBSVT11_OR2_CK_2 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;

    or inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OR2_CK_2

//%BEGIN HDBSVT11_OR2_CK_3
`celldefine
module HDBSVT11_OR2_CK_3 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;

    or inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OR2_CK_3

//%BEGIN HDBSVT11_OR2_CK_4
`celldefine
module HDBSVT11_OR2_CK_4 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;

    or inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OR2_CK_4

//%BEGIN HDBSVT11_OR2_CK_5
`celldefine
module HDBSVT11_OR2_CK_5 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;

    or inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OR2_CK_5

//%BEGIN HDBSVT11_OR2_CK_6
`celldefine
module HDBSVT11_OR2_CK_6 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;

    or inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OR2_CK_6

//%BEGIN HDBSVT11_OR2_CK_7
`celldefine
module HDBSVT11_OR2_CK_7 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;

    or inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OR2_CK_7

//%BEGIN HDBSVT11_OR2_CK_8
`celldefine
module HDBSVT11_OR2_CK_8 (Z, CLK, EN);
  input CLK, EN;
  output Z;
  wire int_0;
  reg viol_0;

    or inst0  (int_0, CLK, EN);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (EN==1'b0) (CLK +=> Z)=(0, 0);
if (CLK==1'b0) (EN +=> Z)=(0, 0);
$hold(posedge CLK , posedge EN , 0 , viol_0);
$hold(posedge CLK , negedge EN , 0 , viol_0);
$setup(posedge EN , negedge CLK , 0 , viol_0);
$setup(negedge EN , negedge CLK , 0 , viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_OR2_CK_8

//%BEGIN HDBSVT11_OR2_D_8

`celldefine
module HDBSVT11_OR2_D_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       or inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR2_D_8

//%BEGIN HDBSVT11_OR2_ECOM2FS_2

`celldefine
module HDBSVT11_OR2_ECOM2FS_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       or inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR2_ECOM2FS_2

//%BEGIN HDBSVT11_OR2_ECOM2_2

`celldefine
module HDBSVT11_OR2_ECOM2_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       or inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR2_ECOM2_2

//%BEGIN HDBSVT11_OR2_Y2ECO_2

`celldefine
module HDBSVT11_OR2_Y2ECO_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       or inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR2_Y2ECO_2

//%BEGIN HDBSVT11_OR2_Y2_12

`celldefine
module HDBSVT11_OR2_Y2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       or inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR2_Y2_12

//%BEGIN HDBSVT11_OR3_1

`celldefine
module HDBSVT11_OR3_1 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
      or inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0 && A3==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR3_1

//%BEGIN HDBSVT11_OR3_2

`celldefine
module HDBSVT11_OR3_2 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
      or inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0 && A3==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR3_2

//%BEGIN HDBSVT11_OR3_CB_2

`celldefine
module HDBSVT11_OR3_CB_2 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
      or inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0 && A3==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR3_CB_2

//%BEGIN HDBSVT11_OR3_Y2_4

`celldefine
module HDBSVT11_OR3_Y2_4 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
      or inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0 && A3==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR3_Y2_4

//%BEGIN HDBSVT11_OR3_Y2_8

`celldefine
module HDBSVT11_OR3_Y2_8 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
      or inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b0 && A3==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR3_Y2_8

//%BEGIN HDBSVT11_OR4_1

`celldefine
module HDBSVT11_OR4_1 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
      or inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR4_1

//%BEGIN HDBSVT11_OR4_2

`celldefine
module HDBSVT11_OR4_2 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
      or inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR4_2

//%BEGIN HDBSVT11_OR4_4

`celldefine
module HDBSVT11_OR4_4 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
      or inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR4_4

//%BEGIN HDBSVT11_OR4_CB_2

`celldefine
module HDBSVT11_OR4_CB_2 (X, A1, A2, A3, A4);
   output X;
   input A1, A2, A3, A4;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
      or #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3, A4);
   `else
      or inst1  (X, A1, A2, A3, A4);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0 && A4==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0 && A4==1'b0) (A2 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A4==1'b0) (A3 +=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && A3==1'b0) (A4 +=> X)=(0, 0);
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_OR4_CB_2

//%BEGIN HDBSVT11_PDLYCH3C0B2GX_Y4_2
`celldefine
module HDBSVT11_PDLYCH3C0B2GX_Y4_2 (Z, AVFSTESTDATA, A, CSEL2, CSEL1, CSEL0, CBYPASS, MUXSE);
  input AVFSTESTDATA, A, CSEL2, CSEL1, CSEL0, CBYPASS, MUXSE;
  output Z;
  wire int_0;


    or inst0  (int_0, A, AVFSTESTDATA);
  `ifdef VIRL_functiononly
    buf #`SNPS_COMBO_DELAY  inst1 (Z, int_0);
  `else
    buf inst2  (Z, int_0);
  `endif
  `ifdef VIRL_functiononly
  `else

specify
if (AVFSTESTDATA==1'b0 && CBYPASS==1'b0 && CSEL0==1'b0 && CSEL1==1'b0 && CSEL2==1'b1 && MUXSE==1'b0) (A +=> Z)=(0, 0);
if (AVFSTESTDATA==1'b0 && CBYPASS==1'b0 && CSEL0==1'b0 && CSEL1==1'b0 && CSEL2==1'b1 && MUXSE==1'b1) (A +=> Z)=(0, 0);
if (AVFSTESTDATA==1'b0 && CBYPASS==1'b0 && CSEL0==1'b0 && CSEL1==1'b1 && CSEL2==1'b0 && MUXSE==1'b0) (A +=> Z)=(0, 0);
if (AVFSTESTDATA==1'b0 && CBYPASS==1'b0 && CSEL0==1'b0 && CSEL1==1'b1 && CSEL2==1'b0 && MUXSE==1'b1) (A +=> Z)=(0, 0);
if (AVFSTESTDATA==1'b0 && CBYPASS==1'b0 && CSEL0==1'b1 && CSEL1==1'b0 && CSEL2==1'b0 && MUXSE==1'b0) (A +=> Z)=(0, 0);
if (AVFSTESTDATA==1'b0 && CBYPASS==1'b0 && CSEL0==1'b1 && CSEL1==1'b0 && CSEL2==1'b0 && MUXSE==1'b1) (A +=> Z)=(0, 0);
if (AVFSTESTDATA==1'b0 && CBYPASS==1'b1 && CSEL0==1'b0 && CSEL1==1'b0 && CSEL2==1'b0 && MUXSE==1'b0) (A +=> Z)=(0, 0);
if (AVFSTESTDATA==1'b0 && CBYPASS==1'b1 && CSEL0==1'b0 && CSEL1==1'b0 && CSEL2==1'b0 && MUXSE==1'b1) (A +=> Z)=(0, 0);
if (A==1'b0 && CBYPASS==1'b0 && CSEL0==1'b0 && CSEL1==1'b0 && CSEL2==1'b0 && MUXSE==1'b0) (AVFSTESTDATA +=> Z)=(0, 0);
if (A==1'b0 && CBYPASS==1'b0 && CSEL0==1'b0 && CSEL1==1'b0 && CSEL2==1'b0 && MUXSE==1'b1) (AVFSTESTDATA +=> Z)=(0, 0);
if (A==1'b1 && CBYPASS==1'b0 && CSEL0==1'b0 && CSEL1==1'b0 && CSEL2==1'b0 && MUXSE==1'b0) (AVFSTESTDATA +=> Z)=(0, 0);
if (A==1'b1 && CBYPASS==1'b0 && CSEL0==1'b0 && CSEL1==1'b0 && CSEL2==1'b0 && MUXSE==1'b1) (AVFSTESTDATA +=> Z)=(0, 0);
if (A==1'b1 && AVFSTESTDATA==1'b0 && CSEL0==1'b0 && CSEL1==1'b0 && CSEL2==1'b0 && MUXSE==1'b0) (CBYPASS +=> Z)=(0, 0);
if (A==1'b1 && AVFSTESTDATA==1'b0 && CSEL0==1'b0 && CSEL1==1'b0 && CSEL2==1'b0 && MUXSE==1'b1) (CBYPASS +=> Z)=(0, 0);
if (A==1'b1 && AVFSTESTDATA==1'b0 && CBYPASS==1'b0 && CSEL1==1'b0 && CSEL2==1'b0 && MUXSE==1'b0) (CSEL0 +=> Z)=(0, 0);
if (A==1'b1 && AVFSTESTDATA==1'b0 && CBYPASS==1'b0 && CSEL1==1'b0 && CSEL2==1'b0 && MUXSE==1'b1) (CSEL0 +=> Z)=(0, 0);
if (A==1'b1 && AVFSTESTDATA==1'b0 && CBYPASS==1'b0 && CSEL0==1'b0 && CSEL2==1'b0 && MUXSE==1'b0) (CSEL1 +=> Z)=(0, 0);
if (A==1'b1 && AVFSTESTDATA==1'b0 && CBYPASS==1'b0 && CSEL0==1'b0 && CSEL2==1'b0 && MUXSE==1'b1) (CSEL1 +=> Z)=(0, 0);
if (A==1'b1 && AVFSTESTDATA==1'b0 && CBYPASS==1'b0 && CSEL0==1'b0 && CSEL1==1'b0 && MUXSE==1'b0) (CSEL2 +=> Z)=(0, 0);
if (A==1'b1 && AVFSTESTDATA==1'b0 && CBYPASS==1'b0 && CSEL0==1'b0 && CSEL1==1'b0 && MUXSE==1'b1) (CSEL2 +=> Z)=(0, 0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PDLYCH3C0B2GX_Y4_2

//%BEGIN HDBSVT11_PINVN_1
`celldefine
module HDBSVT11_PINVN_1 (X, A, RD, LD);
  input A, RD, LD;
  output X;
  wire int_4, int_5, int_6, int_7, int_8, x_int;


    or inst0  (int_4, A, RD);
    not inst1  (int_5, int_4);
    and inst2  (int_6, int_5, LD);
    or inst3  (int_7, LD, RD);
    or inst4  (int_8, int_7, A);
  `ifdef VIRL_functiononly
      bufif1 #`SNPS_COMBO_DELAY  inst5 (X, int_6, int_8);	
  `else
      bufif1 inst6  (X, int_6, int_8);	  
  `endif    

  `ifdef VIRL_functiononly
  `else

specify
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PINVN_1

//%BEGIN HDBSVT11_PINVP_1
`celldefine
module HDBSVT11_PINVP_1 (X, A, RD, LD);
  input A, RD, LD;
  output X;
  wire int_4, int_5, int_6, int_7, int_8, int_9, x_int;


    and inst0  (int_4, A, RD);
    not inst1  (int_5, int_4);
    and inst2  (int_6, int_5, LD);
    and inst3  (int_7, LD, RD);
    and inst4  (int_8, int_7, A);
    not inst5  (int_9, int_8);

  `ifdef VIRL_functiononly
      bufif1 #`SNPS_COMBO_DELAY  inst6 (X, int_6, int_9);	
  `else
      bufif1 inst7  (X, int_6, int_9);	  
  `endif
  `ifdef VIRL_functiononly
  `else

specify
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PINVP_1

//%BEGIN HDBSVT11_PIPE2MSFQX_Y2_1
`celldefine
module HDBSVT11_PIPE2MSFQX_Y2_1 (Q, CK, D, SI, SE);
  input CK, D, SI, SE;
  output Q;
  reg viol_0;
  wire iq, iq0, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif


  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst4  (xcr_3, delayed_CK, iq0);

  `endif
    snps_dff inst5  (iq, viol_0, delayed_CK, iq0, xcr_3);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_5, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq0, viol_0, delayed_CK, d_int, xcr_5);
    snps_mux2 inst8  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst9 (Q, iq);
  `else
    buf inst10  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SE);
not inst12  (_net_1, D);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, D);
and inst17  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, D);
not inst19  (_net_6, SI);
and inst20  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst21  (_net_7, D);
and inst22  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst26  (_net_10, SE);
and inst27  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst28  (_net_11, SI);
and inst29  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst30  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst31  (_net_12, SI);
not inst32  (_net_13, SE);
and inst33  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst34  (_net_14, SE);
and inst35  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst36  (_net_15, D);
and inst37  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst38  (_net_16, SI);
and inst39  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst40  (_net_17, D);
and inst41  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst42  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PIPE2MSFQX_Y2_1

//%BEGIN HDBSVT11_PIPE2MSFQX_Y2_2
`celldefine
module HDBSVT11_PIPE2MSFQX_Y2_2 (Q, CK, D, SI, SE);
  input CK, D, SI, SE;
  output Q;
  reg viol_0;
  wire iq, iq0, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif


  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst4  (xcr_3, delayed_CK, iq0);

  `endif
    snps_dff inst5  (iq, viol_0, delayed_CK, iq0, xcr_3);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_5, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq0, viol_0, delayed_CK, d_int, xcr_5);
    snps_mux2 inst8  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst9 (Q, iq);
  `else
    buf inst10  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SE);
not inst12  (_net_1, D);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, D);
and inst17  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, D);
not inst19  (_net_6, SI);
and inst20  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst21  (_net_7, D);
and inst22  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst26  (_net_10, SE);
and inst27  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst28  (_net_11, SI);
and inst29  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst30  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst31  (_net_12, SI);
not inst32  (_net_13, SE);
and inst33  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst34  (_net_14, SE);
and inst35  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst36  (_net_15, D);
and inst37  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst38  (_net_16, SI);
and inst39  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst40  (_net_17, D);
and inst41  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst42  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PIPE2MSFQX_Y2_2

//%BEGIN HDBSVT11_PIPE2MSFQX_Y2_4
`celldefine
module HDBSVT11_PIPE2MSFQX_Y2_4 (Q, CK, D, SI, SE);
  input CK, D, SI, SE;
  output Q;
  reg viol_0;
  wire iq, iq0, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif


  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst4  (xcr_3, delayed_CK, iq0);

  `endif
    snps_dff inst5  (iq, viol_0, delayed_CK, iq0, xcr_3);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_5, delayed_CK, d_int);

  `endif
    snps_dff inst7  (iq0, viol_0, delayed_CK, d_int, xcr_5);
    snps_mux2 inst8  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst9 (Q, iq);
  `else
    buf inst10  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SE);
not inst12  (_net_1, D);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, D);
and inst17  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, D);
not inst19  (_net_6, SI);
and inst20  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst21  (_net_7, D);
and inst22  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst26  (_net_10, SE);
and inst27  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst28  (_net_11, SI);
and inst29  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst30  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst31  (_net_12, SI);
not inst32  (_net_13, SE);
and inst33  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst34  (_net_14, SE);
and inst35  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst36  (_net_15, D);
and inst37  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst38  (_net_16, SI);
and inst39  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst40  (_net_17, D);
and inst41  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst42  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PIPE2MSFQX_Y2_4

//%BEGIN HDBSVT11_PIPE3MSFQX_Y4_1
`celldefine
module HDBSVT11_PIPE3MSFQX_Y4_1 (Q, CK, D, SI, SE);
  input CK, D, SI, SE;
  output Q;
  reg viol_0;
  wire iq, iq1, iq0, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif


  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst4  (xcr_3, delayed_CK, iq1);

  `endif
    snps_dff inst5  (iq, viol_0, delayed_CK, iq1, xcr_3);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_5, delayed_CK, iq0);

  `endif
    snps_dff inst7  (iq1, viol_0, delayed_CK, iq0, xcr_5);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst8  (xcr_7, delayed_CK, d_int);

  `endif
    snps_dff inst9  (iq0, viol_0, delayed_CK, d_int, xcr_7);
    snps_mux2 inst10  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst11 (Q, iq);
  `else
    buf inst12  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst13  (_net_0, SE);
not inst14  (_net_1, D);
not inst15  (_net_2, SI);
and inst16  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst17  (_net_3, SE);
not inst18  (_net_4, D);
and inst19  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst20  (_net_5, D);
not inst21  (_net_6, SI);
and inst22  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst23  (_net_7, D);
and inst24  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst25  (_net_8, SE);
not inst26  (_net_9, SI);
and inst27  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst28  (_net_10, SE);
and inst29  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst30  (_net_11, SI);
and inst31  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst32  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst33  (_net_12, SI);
not inst34  (_net_13, SE);
and inst35  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst36  (_net_14, SE);
and inst37  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst38  (_net_15, D);
and inst39  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst40  (_net_16, SI);
and inst41  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst42  (_net_17, D);
and inst43  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst44  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PIPE3MSFQX_Y4_1

//%BEGIN HDBSVT11_PIPE3MSFQX_Y4_2
`celldefine
module HDBSVT11_PIPE3MSFQX_Y4_2 (Q, CK, D, SI, SE);
  input CK, D, SI, SE;
  output Q;
  reg viol_0;
  wire iq, iq1, iq0, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif


  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst4  (xcr_3, delayed_CK, iq1);

  `endif
    snps_dff inst5  (iq, viol_0, delayed_CK, iq1, xcr_3);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_5, delayed_CK, iq0);

  `endif
    snps_dff inst7  (iq1, viol_0, delayed_CK, iq0, xcr_5);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst8  (xcr_7, delayed_CK, d_int);

  `endif
    snps_dff inst9  (iq0, viol_0, delayed_CK, d_int, xcr_7);
    snps_mux2 inst10  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst11 (Q, iq);
  `else
    buf inst12  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst13  (_net_0, SE);
not inst14  (_net_1, D);
not inst15  (_net_2, SI);
and inst16  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst17  (_net_3, SE);
not inst18  (_net_4, D);
and inst19  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst20  (_net_5, D);
not inst21  (_net_6, SI);
and inst22  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst23  (_net_7, D);
and inst24  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst25  (_net_8, SE);
not inst26  (_net_9, SI);
and inst27  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst28  (_net_10, SE);
and inst29  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst30  (_net_11, SI);
and inst31  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst32  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst33  (_net_12, SI);
not inst34  (_net_13, SE);
and inst35  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst36  (_net_14, SE);
and inst37  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst38  (_net_15, D);
and inst39  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst40  (_net_16, SI);
and inst41  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst42  (_net_17, D);
and inst43  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst44  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PIPE3MSFQX_Y4_2

//%BEGIN HDBSVT11_PIPE3MSFQX_Y4_4
`celldefine
module HDBSVT11_PIPE3MSFQX_Y4_4 (Q, CK, D, SI, SE);
  input CK, D, SI, SE;
  output Q;
  reg viol_0;
  wire iq, iq1, iq0, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif


  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst4  (xcr_3, delayed_CK, iq1);

  `endif
    snps_dff inst5  (iq, viol_0, delayed_CK, iq1, xcr_3);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_5, delayed_CK, iq0);

  `endif
    snps_dff inst7  (iq1, viol_0, delayed_CK, iq0, xcr_5);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst8  (xcr_7, delayed_CK, d_int);

  `endif
    snps_dff inst9  (iq0, viol_0, delayed_CK, d_int, xcr_7);
    snps_mux2 inst10  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst11 (Q, iq);
  `else
    buf inst12  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst13  (_net_0, SE);
not inst14  (_net_1, D);
not inst15  (_net_2, SI);
and inst16  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst17  (_net_3, SE);
not inst18  (_net_4, D);
and inst19  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst20  (_net_5, D);
not inst21  (_net_6, SI);
and inst22  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst23  (_net_7, D);
and inst24  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst25  (_net_8, SE);
not inst26  (_net_9, SI);
and inst27  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst28  (_net_10, SE);
and inst29  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst30  (_net_11, SI);
and inst31  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst32  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst33  (_net_12, SI);
not inst34  (_net_13, SE);
and inst35  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst36  (_net_14, SE);
and inst37  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst38  (_net_15, D);
and inst39  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst40  (_net_16, SI);
and inst41  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst42  (_net_17, D);
and inst43  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst44  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PIPE3MSFQX_Y4_4

//%BEGIN HDBSVT11_PIPE3RMSFQNSX_Y4_1
`celldefine
module HDBSVT11_PIPE3RMSFQNSX_Y4_1 (Q, CK, D, RD);
  input CK, D, RD;
  output Q;
  reg viol_0;
  wire int_6, iq, iq1, iq0;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_RD, RD);
  `endif


    not inst3  (int_6, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst4  (xcr_9, delayed_CK, iq1, int_6);

  `endif
    snps_dff_r inst5  (iq, viol_0, delayed_CK, iq1, int_6, xcr_9);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst6  (xcr_11, delayed_CK, iq0, int_6);

  `endif
    snps_dff_r inst7  (iq1, viol_0, delayed_CK, iq0, int_6, xcr_11);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst8  (xcr_13, delayed_CK, delayed_D, int_6);

  `endif
    snps_dff_r inst9  (iq0, viol_0, delayed_CK, delayed_D, int_6, xcr_13);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (Q, iq);
  `else
    buf inst11  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst12  (_net_0, D);
and inst13  (ENABLE_NOT_D_AND_RD, RD, _net_0);
and inst14  (ENABLE_D_AND_RD, RD, D);
buf inst15  (ENABLE_RD, RD);
not inst16  (_net_1, D);
not inst17  (_net_2, CK);
and inst18  (ENABLE_NOT_CK_AND_NOT_D, _net_1, _net_2);
not inst19  (_net_3, CK);
and inst20  (ENABLE_NOT_CK_AND_D, D, _net_3);
not inst21  (_net_4, D);
and inst22  (ENABLE_CK_AND_NOT_D, _net_4, CK);
and inst23  (ENABLE_CK_AND_D, D, CK);

specify
if (D==1'b0 && RD==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
(negedge RD => (Q +: 1'b0))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD , posedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD , negedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD , posedge CK , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PIPE3RMSFQNSX_Y4_1

//%BEGIN HDBSVT11_PIPE3RMSFQNSX_Y4_2
`celldefine
module HDBSVT11_PIPE3RMSFQNSX_Y4_2 (Q, CK, D, RD);
  input CK, D, RD;
  output Q;
  reg viol_0;
  wire int_6, iq, iq1, iq0;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_RD, RD);
  `endif


    not inst3  (int_6, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst4  (xcr_9, delayed_CK, iq1, int_6);

  `endif
    snps_dff_r inst5  (iq, viol_0, delayed_CK, iq1, int_6, xcr_9);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst6  (xcr_11, delayed_CK, iq0, int_6);

  `endif
    snps_dff_r inst7  (iq1, viol_0, delayed_CK, iq0, int_6, xcr_11);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst8  (xcr_13, delayed_CK, delayed_D, int_6);

  `endif
    snps_dff_r inst9  (iq0, viol_0, delayed_CK, delayed_D, int_6, xcr_13);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (Q, iq);
  `else
    buf inst11  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst12  (_net_0, D);
and inst13  (ENABLE_NOT_D_AND_RD, RD, _net_0);
and inst14  (ENABLE_D_AND_RD, RD, D);
buf inst15  (ENABLE_RD, RD);
not inst16  (_net_1, D);
not inst17  (_net_2, CK);
and inst18  (ENABLE_NOT_CK_AND_NOT_D, _net_1, _net_2);
not inst19  (_net_3, CK);
and inst20  (ENABLE_NOT_CK_AND_D, D, _net_3);
not inst21  (_net_4, D);
and inst22  (ENABLE_CK_AND_NOT_D, _net_4, CK);
and inst23  (ENABLE_CK_AND_D, D, CK);

specify
if (D==1'b0 && RD==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
(negedge RD => (Q +: 1'b0))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD , posedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD , negedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD , posedge CK , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PIPE3RMSFQNSX_Y4_2

//%BEGIN HDBSVT11_PIPE3RMSFQNSX_Y4_4
`celldefine
module HDBSVT11_PIPE3RMSFQNSX_Y4_4 (Q, CK, D, RD);
  input CK, D, RD;
  output Q;
  reg viol_0;
  wire int_6, iq, iq1, iq0;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_RD, RD);
  `endif


    not inst3  (int_6, delayed_RD);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst4  (xcr_9, delayed_CK, iq1, int_6);

  `endif
    snps_dff_r inst5  (iq, viol_0, delayed_CK, iq1, int_6, xcr_9);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst6  (xcr_11, delayed_CK, iq0, int_6);

  `endif
    snps_dff_r inst7  (iq1, viol_0, delayed_CK, iq0, int_6, xcr_11);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst8  (xcr_13, delayed_CK, delayed_D, int_6);

  `endif
    snps_dff_r inst9  (iq0, viol_0, delayed_CK, delayed_D, int_6, xcr_13);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (Q, iq);
  `else
    buf inst11  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst12  (_net_0, D);
and inst13  (ENABLE_NOT_D_AND_RD, RD, _net_0);
and inst14  (ENABLE_D_AND_RD, RD, D);
buf inst15  (ENABLE_RD, RD);
not inst16  (_net_1, D);
not inst17  (_net_2, CK);
and inst18  (ENABLE_NOT_CK_AND_NOT_D, _net_1, _net_2);
not inst19  (_net_3, CK);
and inst20  (ENABLE_NOT_CK_AND_D, D, _net_3);
not inst21  (_net_4, D);
and inst22  (ENABLE_CK_AND_NOT_D, _net_4, CK);
and inst23  (ENABLE_CK_AND_D, D, CK);

specify
if (D==1'b0 && RD==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && RD==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
(negedge RD => (Q +: 1'b0))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_RD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_RD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_RD , posedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_RD , negedge D &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(posedge RD , posedge CK , 0 ,0, viol_0, , , delayed_RD, delayed_CK);
$width(negedge RD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PIPE3RMSFQNSX_Y4_4

//%BEGIN HDBSVT11_PIPE3SMSFQNSX_Y4_1
`celldefine
module HDBSVT11_PIPE3SMSFQNSX_Y4_1 (Q, CK, D, SD);
  input CK, D, SD;
  output Q;
  reg viol_0;
  wire iq, iq1, iq0;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SD, SD);
  `endif


  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_s_err inst3  (xcr_3, delayed_CK, iq1, delayed_SD);

  `endif
    snps_dff_s inst4  (iq, viol_0, delayed_CK, iq1, delayed_SD, xcr_3);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_s_err inst5  (xcr_5, delayed_CK, iq0, delayed_SD);

  `endif
    snps_dff_s inst6  (iq1, viol_0, delayed_CK, iq0, delayed_SD, xcr_5);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_s_err inst7  (xcr_7, delayed_CK, delayed_D, delayed_SD);

  `endif
    snps_dff_s inst8  (iq0, viol_0, delayed_CK, delayed_D, delayed_SD, xcr_7);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst9 (Q, iq);
  `else
    buf inst10  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SD);
not inst12  (_net_1, D);
and inst13  (ENABLE_NOT_D_AND_NOT_SD, _net_0, _net_1);
not inst14  (_net_2, SD);
and inst15  (ENABLE_D_AND_NOT_SD, _net_2, D);
not inst16  (ENABLE_NOT_SD, SD);
not inst17  (_net_3, D);
not inst18  (_net_4, CK);
and inst19  (ENABLE_NOT_CK_AND_NOT_D, _net_3, _net_4);
not inst20  (_net_5, CK);
and inst21  (ENABLE_NOT_CK_AND_D, D, _net_5);
not inst22  (_net_6, D);
and inst23  (ENABLE_CK_AND_NOT_D, _net_6, CK);
and inst24  (ENABLE_CK_AND_D, D, CK);

specify
if (D==1'b0 && SD==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
(posedge SD => (Q +: 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SD , posedge D &&& ENABLE_NOT_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SD , negedge D &&& ENABLE_NOT_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(negedge SD , posedge CK , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$width(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(posedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(posedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(posedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PIPE3SMSFQNSX_Y4_1

//%BEGIN HDBSVT11_PIPE3SMSFQNSX_Y4_2
`celldefine
module HDBSVT11_PIPE3SMSFQNSX_Y4_2 (Q, CK, D, SD);
  input CK, D, SD;
  output Q;
  reg viol_0;
  wire iq, iq1, iq0;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SD, SD);
  `endif


  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_s_err inst3  (xcr_3, delayed_CK, iq1, delayed_SD);

  `endif
    snps_dff_s inst4  (iq, viol_0, delayed_CK, iq1, delayed_SD, xcr_3);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_s_err inst5  (xcr_5, delayed_CK, iq0, delayed_SD);

  `endif
    snps_dff_s inst6  (iq1, viol_0, delayed_CK, iq0, delayed_SD, xcr_5);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_s_err inst7  (xcr_7, delayed_CK, delayed_D, delayed_SD);

  `endif
    snps_dff_s inst8  (iq0, viol_0, delayed_CK, delayed_D, delayed_SD, xcr_7);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst9 (Q, iq);
  `else
    buf inst10  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SD);
not inst12  (_net_1, D);
and inst13  (ENABLE_NOT_D_AND_NOT_SD, _net_0, _net_1);
not inst14  (_net_2, SD);
and inst15  (ENABLE_D_AND_NOT_SD, _net_2, D);
not inst16  (ENABLE_NOT_SD, SD);
not inst17  (_net_3, D);
not inst18  (_net_4, CK);
and inst19  (ENABLE_NOT_CK_AND_NOT_D, _net_3, _net_4);
not inst20  (_net_5, CK);
and inst21  (ENABLE_NOT_CK_AND_D, D, _net_5);
not inst22  (_net_6, D);
and inst23  (ENABLE_CK_AND_NOT_D, _net_6, CK);
and inst24  (ENABLE_CK_AND_D, D, CK);

specify
if (D==1'b0 && SD==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
(posedge SD => (Q +: 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SD , posedge D &&& ENABLE_NOT_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SD , negedge D &&& ENABLE_NOT_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(negedge SD , posedge CK , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$width(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(posedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(posedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(posedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PIPE3SMSFQNSX_Y4_2

//%BEGIN HDBSVT11_PIPE3SMSFQNSX_Y4_4
`celldefine
module HDBSVT11_PIPE3SMSFQNSX_Y4_4 (Q, CK, D, SD);
  input CK, D, SD;
  output Q;
  reg viol_0;
  wire iq, iq1, iq0;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SD, SD);
  `endif


  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_s_err inst3  (xcr_3, delayed_CK, iq1, delayed_SD);

  `endif
    snps_dff_s inst4  (iq, viol_0, delayed_CK, iq1, delayed_SD, xcr_3);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_s_err inst5  (xcr_5, delayed_CK, iq0, delayed_SD);

  `endif
    snps_dff_s inst6  (iq1, viol_0, delayed_CK, iq0, delayed_SD, xcr_5);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_s_err inst7  (xcr_7, delayed_CK, delayed_D, delayed_SD);

  `endif
    snps_dff_s inst8  (iq0, viol_0, delayed_CK, delayed_D, delayed_SD, xcr_7);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst9 (Q, iq);
  `else
    buf inst10  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SD);
not inst12  (_net_1, D);
and inst13  (ENABLE_NOT_D_AND_NOT_SD, _net_0, _net_1);
not inst14  (_net_2, SD);
and inst15  (ENABLE_D_AND_NOT_SD, _net_2, D);
not inst16  (ENABLE_NOT_SD, SD);
not inst17  (_net_3, D);
not inst18  (_net_4, CK);
and inst19  (ENABLE_NOT_CK_AND_NOT_D, _net_3, _net_4);
not inst20  (_net_5, CK);
and inst21  (ENABLE_NOT_CK_AND_D, D, _net_5);
not inst22  (_net_6, D);
and inst23  (ENABLE_CK_AND_NOT_D, _net_6, CK);
and inst24  (ENABLE_CK_AND_D, D, CK);

specify
if (D==1'b0 && SD==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SD==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
(posedge SD => (Q +: 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SD , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SD , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SD , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SD , posedge D &&& ENABLE_NOT_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SD , negedge D &&& ENABLE_NOT_SD , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$recrem(negedge SD , posedge CK , 0 ,0, viol_0, , , delayed_SD, delayed_CK);
$width(posedge SD &&& ENABLE_NOT_CK_AND_NOT_D , 0 ,0, viol_0);
$width(posedge SD &&& ENABLE_NOT_CK_AND_D , 0 ,0, viol_0);
$width(posedge SD &&& ENABLE_CK_AND_NOT_D , 0 ,0, viol_0);
$width(posedge SD &&& ENABLE_CK_AND_D , 0 ,0, viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PIPE3SMSFQNSX_Y4_4

//%BEGIN HDBSVT11_PIPE4MSFQX_Y4_1
`celldefine
module HDBSVT11_PIPE4MSFQX_Y4_1 (Q, CK, D, SI, SE);
  input CK, D, SI, SE;
  output Q;
  reg viol_0;
  wire iq, iq2, iq1, iq0, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif


  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst4  (xcr_3, delayed_CK, iq2);

  `endif
    snps_dff inst5  (iq, viol_0, delayed_CK, iq2, xcr_3);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_5, delayed_CK, iq1);

  `endif
    snps_dff inst7  (iq2, viol_0, delayed_CK, iq1, xcr_5);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst8  (xcr_7, delayed_CK, iq0);

  `endif
    snps_dff inst9  (iq1, viol_0, delayed_CK, iq0, xcr_7);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst10  (xcr_9, delayed_CK, d_int);

  `endif
    snps_dff inst11  (iq0, viol_0, delayed_CK, d_int, xcr_9);
    snps_mux2 inst12  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst13 (Q, iq);
  `else
    buf inst14  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst15  (_net_0, SE);
not inst16  (_net_1, D);
not inst17  (_net_2, SI);
and inst18  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst19  (_net_3, SE);
not inst20  (_net_4, D);
and inst21  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst22  (_net_5, D);
not inst23  (_net_6, SI);
and inst24  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst25  (_net_7, D);
and inst26  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst27  (_net_8, SE);
not inst28  (_net_9, SI);
and inst29  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst30  (_net_10, SE);
and inst31  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst32  (_net_11, SI);
and inst33  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst34  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst35  (_net_12, SI);
not inst36  (_net_13, SE);
and inst37  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst38  (_net_14, SE);
and inst39  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst40  (_net_15, D);
and inst41  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst42  (_net_16, SI);
and inst43  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst44  (_net_17, D);
and inst45  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst46  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PIPE4MSFQX_Y4_1

//%BEGIN HDBSVT11_PIPE4MSFQX_Y4_2
`celldefine
module HDBSVT11_PIPE4MSFQX_Y4_2 (Q, CK, D, SI, SE);
  input CK, D, SI, SE;
  output Q;
  reg viol_0;
  wire iq, iq2, iq1, iq0, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif


  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst4  (xcr_3, delayed_CK, iq2);

  `endif
    snps_dff inst5  (iq, viol_0, delayed_CK, iq2, xcr_3);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_5, delayed_CK, iq1);

  `endif
    snps_dff inst7  (iq2, viol_0, delayed_CK, iq1, xcr_5);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst8  (xcr_7, delayed_CK, iq0);

  `endif
    snps_dff inst9  (iq1, viol_0, delayed_CK, iq0, xcr_7);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst10  (xcr_9, delayed_CK, d_int);

  `endif
    snps_dff inst11  (iq0, viol_0, delayed_CK, d_int, xcr_9);
    snps_mux2 inst12  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst13 (Q, iq);
  `else
    buf inst14  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst15  (_net_0, SE);
not inst16  (_net_1, D);
not inst17  (_net_2, SI);
and inst18  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst19  (_net_3, SE);
not inst20  (_net_4, D);
and inst21  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst22  (_net_5, D);
not inst23  (_net_6, SI);
and inst24  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst25  (_net_7, D);
and inst26  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst27  (_net_8, SE);
not inst28  (_net_9, SI);
and inst29  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst30  (_net_10, SE);
and inst31  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst32  (_net_11, SI);
and inst33  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst34  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst35  (_net_12, SI);
not inst36  (_net_13, SE);
and inst37  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst38  (_net_14, SE);
and inst39  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst40  (_net_15, D);
and inst41  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst42  (_net_16, SI);
and inst43  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst44  (_net_17, D);
and inst45  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst46  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PIPE4MSFQX_Y4_2

//%BEGIN HDBSVT11_PIPE4MSFQX_Y4_4
`celldefine
module HDBSVT11_PIPE4MSFQX_Y4_4 (Q, CK, D, SI, SE);
  input CK, D, SI, SE;
  output Q;
  reg viol_0;
  wire iq, iq2, iq1, iq0, d_int;
  `ifdef _fv
    buf inst0  (delayed_CK, CK);
    buf inst1  (delayed_D, D);
    buf inst2  (delayed_SI, SI);
    buf inst3  (delayed_SE, SE);
  `endif


  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst4  (xcr_3, delayed_CK, iq2);

  `endif
    snps_dff inst5  (iq, viol_0, delayed_CK, iq2, xcr_3);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst6  (xcr_5, delayed_CK, iq1);

  `endif
    snps_dff inst7  (iq2, viol_0, delayed_CK, iq1, xcr_5);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst8  (xcr_7, delayed_CK, iq0);

  `endif
    snps_dff inst9  (iq1, viol_0, delayed_CK, iq0, xcr_7);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_err inst10  (xcr_9, delayed_CK, d_int);

  `endif
    snps_dff inst11  (iq0, viol_0, delayed_CK, d_int, xcr_9);
    snps_mux2 inst12  (d_int, delayed_SI, delayed_D, delayed_SE);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst13 (Q, iq);
  `else
    buf inst14  (Q, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst15  (_net_0, SE);
not inst16  (_net_1, D);
not inst17  (_net_2, SI);
and inst18  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst19  (_net_3, SE);
not inst20  (_net_4, D);
and inst21  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst22  (_net_5, D);
not inst23  (_net_6, SI);
and inst24  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst25  (_net_7, D);
and inst26  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst27  (_net_8, SE);
not inst28  (_net_9, SI);
and inst29  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst30  (_net_10, SE);
and inst31  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst32  (_net_11, SI);
and inst33  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst34  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst35  (_net_12, SI);
not inst36  (_net_13, SE);
and inst37  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst38  (_net_14, SE);
and inst39  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst40  (_net_15, D);
and inst41  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst42  (_net_16, SI);
and inst43  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst44  (_net_17, D);
and inst45  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst46  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q : 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q : 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PIPE4MSFQX_Y4_4

//%BEGIN HDBSVT11_PRDSAFNSX_Y2_2
`celldefine
module HDBSVT11_PRDSAFNSX_Y2_2 (RD, ZB, Z, A, C, AB);
  input RD, A, C, AB;
  output ZB, Z;
  reg viol_0;
  wire int_4, int_5, int_6, int_7, iq;
  `ifdef _fv
    buf inst0  (delayed_A, A);
    buf inst1  (delayed_C, C);
    buf inst2  (delayed_AB, AB);
  `endif
    buf inst3  (delayed_RD, RD);


    not inst4  (int_4, delayed_RD);
    not inst5  (int_5, delayed_AB);
    or inst6  (int_6, delayed_A, int_5);
    not inst7  (int_7, iq);
  `ifndef SNPS_MASK_ERR_UDP
    snps_dff_r_err inst8  (xcr_10, delayed_C, int_6, int_4);

  `endif
    snps_dff_r inst9  (iq, viol_0, delayed_C, int_6, int_4, xcr_10);
  `ifdef VIRL_functiononly
    buf #`SNPS_SEQ_DELAY  inst10 (ZB, int_7);
    buf #`SNPS_SEQ_DELAY  inst11 (Z, iq);
  `else
    buf inst12  (ZB, int_7);
    buf inst13  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
buf inst14  (ENABLE_RD, RD);
not inst15  (_net_0, A);
and inst16  (ENABLE_NOT_A_AND_AB_AND_RD, AB, _net_0, RD);
not inst17  (_net_1, AB);
and inst18  (ENABLE_A_AND_NOT_AB_AND_RD, _net_1, A, RD);
not inst19  (_net_2, AB);
and inst20  (ENABLE_A_AND_NOT_AB, _net_2, A);
not inst21  (_net_3, A);
not inst22  (_net_4, C);
and inst23  (ENABLE_NOT_A_AND_AB_AND_NOT_C, AB, _net_3, _net_4);
not inst24  (_net_5, AB);
not inst25  (_net_6, C);
and inst26  (ENABLE_A_AND_NOT_AB_AND_NOT_C, _net_5, A, _net_6);

specify
if (A==1'b0 && AB==1'b1 && C==1'b1) (RD +=> Z)=(0, 0);
if (A==1'b0 && AB==1'b1 && C==1'b0) (RD +=> Z)=(0, 0);
if (A==1'b1 && AB==1'b0 && C==1'b0) (RD +=> Z)=(0, 0);
if (A==1'b1 && AB==1'b0 && C==1'b1) (RD +=> Z)=(0, 0);
if (A==1'b0 && AB==1'b1 && RD==1'b1) (posedge C => (Z -: 1'b1))=(0, 0);
if (A==1'b1 && AB==1'b0 && RD==1'b1) (posedge C => (Z +: 1'b1))=(0, 0);
if (A==1'b0 && AB==1'b1 && C==1'b1) (RD -=> ZB)=(0, 0);
if (A==1'b0 && AB==1'b1 && C==1'b0) (RD -=> ZB)=(0, 0);
if (A==1'b1 && AB==1'b0 && C==1'b0) (RD -=> ZB)=(0, 0);
if (A==1'b1 && AB==1'b0 && C==1'b1) (RD -=> ZB)=(0, 0);
if (A==1'b1 && AB==1'b0 && RD==1'b1) (posedge C => (ZB -: 1'b1))=(0, 0);
if (A==1'b0 && AB==1'b1 && RD==1'b1) (posedge C => (ZB +: 1'b1))=(0, 0);
$setuphold(posedge C &&& ENABLE_RD , posedge A &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_C, delayed_A);
$setuphold(posedge C &&& ENABLE_RD , negedge A &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_C, delayed_A);
$setuphold(posedge C &&& ENABLE_RD , posedge AB &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_C, delayed_AB);
$setuphold(posedge C &&& ENABLE_RD , negedge AB &&& ENABLE_RD , 0 ,0, viol_0, , , delayed_C, delayed_AB);
$width(posedge C &&& ENABLE_NOT_A_AND_AB_AND_RD , 0 ,0, viol_0);
$width(negedge C &&& ENABLE_NOT_A_AND_AB_AND_RD , 0 ,0, viol_0);
$width(posedge C &&& ENABLE_A_AND_NOT_AB_AND_RD , 0 ,0, viol_0);
$width(negedge C &&& ENABLE_A_AND_NOT_AB_AND_RD , 0 ,0, viol_0);
$recovery(posedge RD &&& ENABLE_A_AND_NOT_AB , posedge C &&& ENABLE_A_AND_NOT_AB , 0 , viol_0);
$width(negedge RD &&& ENABLE_NOT_A_AND_AB_AND_NOT_C , 0 ,0, viol_0);
$width(negedge RD &&& ENABLE_A_AND_NOT_AB_AND_NOT_C , 0 ,0, viol_0);
endspecify
  `endif
endmodule
`endcelldefine
//%END HDBSVT11_PRDSAFNSX_Y2_2

//%BEGIN HDBSVT11_SRLD_Y2_3

`celldefine
module HDBSVT11_SRLD_Y2_3 (Q, QN, S, R);
   output Q, QN;
   input S, R;

   reg viol_0;
     wire viol_x;

   wire int_res__G, int_res_iq;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   snps_sr_latch inst0  (int_res_iq, viol_x, S, R);

  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst1  (viol_x, viol_0, S, R, 1'b1);

  `endif
   `ifdef VIRL_functiononly
      buf #`SNPS_LAT_DELAY  inst2 (Q, int_res_iq);
      not #`SNPS_LAT_DELAY  inst3 (QN, int_res_iq);
   `else
      buf inst4  (Q, int_res_iq);
      not inst5  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

not inst6  (ENABLE_NOT_S, S);
not inst7  (ENABLE_NOT_R, R);

specify
if (S==1'b0) (posedge R => (Q -: 1'b0))=(0, 0);
(posedge R => (Q : 1'b1))=(0, 0);
if (R==1'b0) (posedge S => (Q +: 1'b1))=(0, 0);
if (R==1'b1) (posedge S => (Q +: 1'b1))=(0, 0);
(posedge S => (Q : 1'b0))=(0, 0);
if (S==1'b0) (posedge R => (QN +: 1'b1))=(0, 0);
(posedge R => (QN : 1'b0))=(0, 0);
if (R==1'b0) (posedge S => (QN -: 1'b0))=(0, 0);
if (R==1'b1) (posedge S => (QN -: 1'b0))=(0, 0);
(posedge S => (QN : 1'b1))=(0, 0);
$width(posedge R &&& ENABLE_NOT_S , 0 ,0, viol_0);
$hold(negedge S , negedge R , 0 , viol_0);
$hold(negedge R , negedge S , 0 , viol_0);
$width(posedge S &&& ENABLE_NOT_R , 0 ,0, viol_0);
endspecify
   `endif
endmodule
`endcelldefine

//%END HDBSVT11_SRLD_Y2_3


//%BEGIN HDBSVT11_TAPDS

`celldefine
module HDBSVT11_TAPDS ();
endmodule
`endcelldefine

//%END HDBSVT11_TAPDS

//%BEGIN HDBSVT11_TAPDS_V1

`celldefine
module HDBSVT11_TAPDS_V1 ();
endmodule
`endcelldefine

//%END HDBSVT11_TAPDS_V1

//%BEGIN HDBSVT11_TAPFIN8

`celldefine
module HDBSVT11_TAPFIN8 ();
endmodule
`endcelldefine

//%END HDBSVT11_TAPFIN8

//%BEGIN HDBSVT11_TAPPN

`celldefine
module HDBSVT11_TAPPN ();
endmodule
`endcelldefine

//%END HDBSVT11_TAPPN

//%BEGIN HDBSVT11_TAPWALL

`celldefine
module HDBSVT11_TAPWALL ();
endmodule
`endcelldefine

//%END HDBSVT11_TAPWALL

//%BEGIN HDBSVT11_TIE0_1

`celldefine
module HDBSVT11_TIE0_1 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b0);
   `else
      buf inst1  (X, 1'b0);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE0_1

//%BEGIN HDBSVT11_TIE0_B_4

`celldefine
module HDBSVT11_TIE0_B_4 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b0);
   `else
      buf inst1  (X, 1'b0);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE0_B_4

//%BEGIN HDBSVT11_TIE0_CBECO_1

`celldefine
module HDBSVT11_TIE0_CBECO_1 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b0);
   `else
      buf inst1  (X, 1'b0);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE0_CBECO_1

//%BEGIN HDBSVT11_TIE0_CBV1_2

`celldefine
module HDBSVT11_TIE0_CBV1_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b0);
   `else
      buf inst1  (X, 1'b0);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE0_CBV1_2

//%BEGIN HDBSVT11_TIE0_CB_1

`celldefine
module HDBSVT11_TIE0_CB_1 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b0);
   `else
      buf inst1  (X, 1'b0);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE0_CB_1

//%BEGIN HDBSVT11_TIE0_ECO_1

`celldefine
module HDBSVT11_TIE0_ECO_1 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b0);
   `else
      buf inst1  (X, 1'b0);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE0_ECO_1

//%BEGIN HDBSVT11_TIE0_MV1Y8FS_2

`celldefine
module HDBSVT11_TIE0_MV1Y8FS_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b0);
   `else
      buf inst1  (X, 1'b0);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE0_MV1Y8FS_2

//%BEGIN HDBSVT11_TIE0_MV1Y8_2

`celldefine
module HDBSVT11_TIE0_MV1Y8_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b0);
   `else
      buf inst1  (X, 1'b0);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE0_MV1Y8_2

//%BEGIN HDBSVT11_TIE0_V1BY4FS_4

`celldefine
module HDBSVT11_TIE0_V1BY4FS_4 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b0);
   `else
      buf inst1  (X, 1'b0);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE0_V1BY4FS_4

//%BEGIN HDBSVT11_TIE0_V1BY4_4

`celldefine
module HDBSVT11_TIE0_V1BY4_4 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b0);
   `else
      buf inst1  (X, 1'b0);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE0_V1BY4_4

//%BEGIN HDBSVT11_TIE0_V1_2

`celldefine
module HDBSVT11_TIE0_V1_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b0);
   `else
      buf inst1  (X, 1'b0);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE0_V1_2

//%BEGIN HDBSVT11_TIE1_1

`celldefine
module HDBSVT11_TIE1_1 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_1

//%BEGIN HDBSVT11_TIE1_B_4

`celldefine
module HDBSVT11_TIE1_B_4 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_B_4

//%BEGIN HDBSVT11_TIE1_CBECO_1

`celldefine
module HDBSVT11_TIE1_CBECO_1 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_CBECO_1

//%BEGIN HDBSVT11_TIE1_CB_1

`celldefine
module HDBSVT11_TIE1_CB_1 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_CB_1

//%BEGIN HDBSVT11_TIE1_ECO_1

`celldefine
module HDBSVT11_TIE1_ECO_1 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_ECO_1

//%BEGIN HDBSVT11_TIE1_M1V1Y8FS_2

`celldefine
module HDBSVT11_TIE1_M1V1Y8FS_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_M1V1Y8FS_2

//%BEGIN HDBSVT11_TIE1_M1V1Y8_2

`celldefine
module HDBSVT11_TIE1_M1V1Y8_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_M1V1Y8_2

//%BEGIN HDBSVT11_TIE1_M2V1Y8FS_2

`celldefine
module HDBSVT11_TIE1_M2V1Y8FS_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_M2V1Y8FS_2

//%BEGIN HDBSVT11_TIE1_M2V1Y8_2

`celldefine
module HDBSVT11_TIE1_M2V1Y8_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_M2V1Y8_2

//%BEGIN HDBSVT11_TIE1_M3V1Y8FS_2

`celldefine
module HDBSVT11_TIE1_M3V1Y8FS_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_M3V1Y8FS_2

//%BEGIN HDBSVT11_TIE1_M3V1Y8_2

`celldefine
module HDBSVT11_TIE1_M3V1Y8_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_M3V1Y8_2

//%BEGIN HDBSVT11_TIE1_M4V1Y8FS_2

`celldefine
module HDBSVT11_TIE1_M4V1Y8FS_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_M4V1Y8FS_2

//%BEGIN HDBSVT11_TIE1_M4V1Y8_2

`celldefine
module HDBSVT11_TIE1_M4V1Y8_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_M4V1Y8_2

//%BEGIN HDBSVT11_TIE1_M5V1Y8FS_2

`celldefine
module HDBSVT11_TIE1_M5V1Y8FS_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_M5V1Y8FS_2

//%BEGIN HDBSVT11_TIE1_M5V1Y8_2

`celldefine
module HDBSVT11_TIE1_M5V1Y8_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_M5V1Y8_2

//%BEGIN HDBSVT11_TIE1_M6V1Y8FS_2

`celldefine
module HDBSVT11_TIE1_M6V1Y8FS_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_M6V1Y8FS_2

//%BEGIN HDBSVT11_TIE1_M6V1Y8_2

`celldefine
module HDBSVT11_TIE1_M6V1Y8_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_M6V1Y8_2

//%BEGIN HDBSVT11_TIE1_M7V1Y8FS_2

`celldefine
module HDBSVT11_TIE1_M7V1Y8FS_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_M7V1Y8FS_2

//%BEGIN HDBSVT11_TIE1_M7V1Y8_2

`celldefine
module HDBSVT11_TIE1_M7V1Y8_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_M7V1Y8_2

//%BEGIN HDBSVT11_TIE1_M8V1Y8FS_2

`celldefine
module HDBSVT11_TIE1_M8V1Y8FS_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_M8V1Y8FS_2

//%BEGIN HDBSVT11_TIE1_M8V1Y8_2

`celldefine
module HDBSVT11_TIE1_M8V1Y8_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_M8V1Y8_2

//%BEGIN HDBSVT11_TIE1_V1BY4FS_4

`celldefine
module HDBSVT11_TIE1_V1BY4FS_4 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_V1BY4FS_4

//%BEGIN HDBSVT11_TIE1_V1BY4_4

`celldefine
module HDBSVT11_TIE1_V1BY4_4 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_V1BY4_4

//%BEGIN HDBSVT11_TIE1_V1_2

`celldefine
module HDBSVT11_TIE1_V1_2 (X);
   output X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   `ifdef VIRL_functiononly
     buf #`SNPS_COMBO_DELAY  inst0 (X, 1'b1);
   `else
     buf inst1  (X, 1'b1);
   `endif
   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly

   `else
specify
endspecify
   `endif

endmodule
`endcelldefine

//%END HDBSVT11_TIE1_V1_2

//%BEGIN HDBSVT11_TIEDIN_4

`celldefine
module HDBSVT11_TIEDIN_4 (X);
   input X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


endmodule
`endcelldefine

//%END HDBSVT11_TIEDIN_4

//%BEGIN HDBSVT11_TIEDIN_CBY3ECOM2FS_6

`celldefine
module HDBSVT11_TIEDIN_CBY3ECOM2FS_6 (X);
   input X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


endmodule
`endcelldefine

//%END HDBSVT11_TIEDIN_CBY3ECOM2FS_6

//%BEGIN HDBSVT11_TIEDIN_CBY3ECOM2_6

`celldefine
module HDBSVT11_TIEDIN_CBY3ECOM2_6 (X);
   input X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


endmodule
`endcelldefine

//%END HDBSVT11_TIEDIN_CBY3ECOM2_6

//%BEGIN HDBSVT11_TIEDIN_CBY4ECO_6

`celldefine
module HDBSVT11_TIEDIN_CBY4ECO_6 (X);
   input X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


endmodule
`endcelldefine

//%END HDBSVT11_TIEDIN_CBY4ECO_6

//%BEGIN HDBSVT11_TIEDIN_M12Y10_1

`celldefine
module HDBSVT11_TIEDIN_M12Y10_1 (X);
   input X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


endmodule
`endcelldefine

//%END HDBSVT11_TIEDIN_M12Y10_1

//%BEGIN HDBSVT11_TIEDIN_Y10_1

`celldefine
module HDBSVT11_TIEDIN_Y10_1 (X);
   input X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


endmodule
`endcelldefine

//%END HDBSVT11_TIEDIN_Y10_1

//%BEGIN HDBSVT11_TIEDIN_Y3ECOM2FS_6

`celldefine
module HDBSVT11_TIEDIN_Y3ECOM2FS_6 (X);
   input X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


endmodule
`endcelldefine

//%END HDBSVT11_TIEDIN_Y3ECOM2FS_6

//%BEGIN HDBSVT11_TIEDIN_Y3ECOM2_6

`celldefine
module HDBSVT11_TIEDIN_Y3ECOM2_6 (X);
   input X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


endmodule
`endcelldefine

//%END HDBSVT11_TIEDIN_Y3ECOM2_6

//%BEGIN HDBSVT11_TIEDIN_Y4ECO_6

`celldefine
module HDBSVT11_TIEDIN_Y4ECO_6 (X);
   input X;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


endmodule
`endcelldefine

//%END HDBSVT11_TIEDIN_Y4ECO_6

//%BEGIN HDBSVT11_TIESUB

`celldefine
module HDBSVT11_TIESUB ();
endmodule
`endcelldefine

//%END HDBSVT11_TIESUB

