//----------------------------------------------------------------------------
// Cell model definitions.
//----------------------------------------------------------------------------


`timescale 1ps / 1ps

`ifndef SNPS_SEQ_DELAY
`define SNPS_SEQ_DELAY 10
`endif
`ifndef SNPS_COMBO_DELAY
`define SNPS_COMBO_DELAY 0 
`endif
`ifndef SNPS_CKGT_DELAY
`define SNPS_CKGT_DELAY 0
`endif
`ifndef SNPS_CKGTLT_DELAY
`define SNPS_CKGTLT_DELAY 0
`endif
`ifndef SNPS_LAT_DELAY
`define SNPS_LAT_DELAY 10
`endif

`ifdef VIRL_functiononly
    `delay_mode_distributed
    `define _fv
    `define SNPS_MASK_X_OUT_LATCH
    `define SNPS_MASK_ERR_UDP
`else
    `delay_mode_path
`endif

//%BEGIN HDBLVT08_AOI22_LSKFY2_12

module HDBLVT08_AOI22_LSKFY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_AOI22_LSKFY2_12

//%BEGIN HDBLVT08_AOI22_LSKFY2_2

module HDBLVT08_AOI22_LSKFY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_AOI22_LSKFY2_2

//%BEGIN HDBLVT08_AOI22_LSKFY2_4

module HDBLVT08_AOI22_LSKFY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_AOI22_LSKFY2_4

//%BEGIN HDBLVT08_AOI22_LSKFY2_8

module HDBLVT08_AOI22_LSKFY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_AOI22_LSKFY2_8

//%BEGIN HDBLVT08_AOI22_LSKRY2_12

module HDBLVT08_AOI22_LSKRY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_AOI22_LSKRY2_12

//%BEGIN HDBLVT08_AOI22_LSKRY2_2

module HDBLVT08_AOI22_LSKRY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_AOI22_LSKRY2_2

//%BEGIN HDBLVT08_AOI22_LSKRY2_4

module HDBLVT08_AOI22_LSKRY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_AOI22_LSKRY2_4

//%BEGIN HDBLVT08_AOI22_LSKRY2_8

module HDBLVT08_AOI22_LSKRY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_AOI22_LSKRY2_8

//%BEGIN HDBLVT08_AOI22_LY2_12

module HDBLVT08_AOI22_LY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_AOI22_LY2_12

//%BEGIN HDBLVT08_AOI22_LY2_2

module HDBLVT08_AOI22_LY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_AOI22_LY2_2

//%BEGIN HDBLVT08_AOI22_LY2_4

module HDBLVT08_AOI22_LY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_AOI22_LY2_4

//%BEGIN HDBLVT08_AOI22_LY2_6

module HDBLVT08_AOI22_LY2_6 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_AOI22_LY2_6

//%BEGIN HDBLVT08_AOI22_LY2_8

module HDBLVT08_AOI22_LY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_AOI22_LY2_8

//%BEGIN HDBLVT08_CKLDAO21NQ_LPV1Y2_1
module HDBLVT08_CKLDAO21NQ_LPV1Y2_1 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBLVT08_CKLDAO21NQ_LPV1Y2_1

//%BEGIN HDBLVT08_CKLDAO21NQ_LPV1Y2_2
module HDBLVT08_CKLDAO21NQ_LPV1Y2_2 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBLVT08_CKLDAO21NQ_LPV1Y2_2

//%BEGIN HDBLVT08_CKLDAO21NQ_LPV1Y2_4
module HDBLVT08_CKLDAO21NQ_LPV1Y2_4 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBLVT08_CKLDAO21NQ_LPV1Y2_4

//%BEGIN HDBLVT08_CKLDNQOR2_LPV1Y2_1
module HDBLVT08_CKLDNQOR2_LPV1Y2_1 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBLVT08_CKLDNQOR2_LPV1Y2_1

//%BEGIN HDBLVT08_CKLDNQOR2_LPV1Y2_2
module HDBLVT08_CKLDNQOR2_LPV1Y2_2 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBLVT08_CKLDNQOR2_LPV1Y2_2

//%BEGIN HDBLVT08_CKLDNQOR2_LPV1Y2_4
module HDBLVT08_CKLDNQOR2_LPV1Y2_4 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBLVT08_CKLDNQOR2_LPV1Y2_4

//%BEGIN HDBLVT08_EN2_LCBV2_1

module HDBLVT08_EN2_LCBV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule

//%END HDBLVT08_EN2_LCBV2_1

//%BEGIN HDBLVT08_EN2_LV2_1

module HDBLVT08_EN2_LV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule

//%END HDBLVT08_EN2_LV2_1

//%BEGIN HDBLVT08_EO2_LCBV2_1

module HDBLVT08_EO2_LCBV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_EO2_LCBV2_1

//%BEGIN HDBLVT08_EO2_LV2_1

module HDBLVT08_EO2_LV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_EO2_LV2_1

//%BEGIN HDBLVT08_ND2_LSKF_2

module HDBLVT08_ND2_LSKF_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_ND2_LSKF_2

//%BEGIN HDBLVT08_ND2_LSKRY2_12

module HDBLVT08_ND2_LSKRY2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_ND2_LSKRY2_12

//%BEGIN HDBLVT08_NR2_LSKFY2_12

module HDBLVT08_NR2_LSKFY2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_NR2_LSKFY2_12

//%BEGIN HDBLVT08_NR2_LSKF_4

module HDBLVT08_NR2_LSKF_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_NR2_LSKF_4

//%BEGIN HDBLVT08_NR2_LSKF_8

module HDBLVT08_NR2_LSKF_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_NR2_LSKF_8

//%BEGIN HDBLVT08_NR2_LSKRY2_12

module HDBLVT08_NR2_LSKRY2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_NR2_LSKRY2_12

//%BEGIN HDBLVT08_NR2_LSKR_2

module HDBLVT08_NR2_LSKR_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_NR2_LSKR_2

//%BEGIN HDBLVT08_NR3_LY2_12

module HDBLVT08_NR3_LY2_12 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_NR3_LY2_12

//%BEGIN HDBLVT08_OAI211_LY2_12

module HDBLVT08_OAI211_LY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
        nand inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT08_OAI211_LY2_12

//%BEGIN HDBLVT08_OAI22_LSKFY2_12

module HDBLVT08_OAI22_LSKFY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT08_OAI22_LSKFY2_12

//%BEGIN HDBLVT08_OAI22_LSKFY2_2

module HDBLVT08_OAI22_LSKFY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT08_OAI22_LSKFY2_2

//%BEGIN HDBLVT08_OAI22_LSKFY2_4

module HDBLVT08_OAI22_LSKFY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT08_OAI22_LSKFY2_4

//%BEGIN HDBLVT08_OAI22_LSKFY2_8

module HDBLVT08_OAI22_LSKFY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT08_OAI22_LSKFY2_8

//%BEGIN HDBLVT08_OAI22_LSKRY2_12

module HDBLVT08_OAI22_LSKRY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT08_OAI22_LSKRY2_12

//%BEGIN HDBLVT08_OAI22_LSKRY2_2

module HDBLVT08_OAI22_LSKRY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT08_OAI22_LSKRY2_2

//%BEGIN HDBLVT08_OAI22_LSKRY2_4

module HDBLVT08_OAI22_LSKRY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT08_OAI22_LSKRY2_4

//%BEGIN HDBLVT08_OAI22_LSKRY2_8

module HDBLVT08_OAI22_LSKRY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT08_OAI22_LSKRY2_8

//%BEGIN HDBLVT08_OAI22_LY2_2

module HDBLVT08_OAI22_LY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT08_OAI22_LY2_2

//%BEGIN HDBLVT08_OAI22_LY2_4

module HDBLVT08_OAI22_LY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT08_OAI22_LY2_4

//%BEGIN HDBLVT11_AOI22_LSKFY2_12

module HDBLVT11_AOI22_LSKFY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_AOI22_LSKFY2_12

//%BEGIN HDBLVT11_AOI22_LSKFY2_2

module HDBLVT11_AOI22_LSKFY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_AOI22_LSKFY2_2

//%BEGIN HDBLVT11_AOI22_LSKFY2_4

module HDBLVT11_AOI22_LSKFY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_AOI22_LSKFY2_4

//%BEGIN HDBLVT11_AOI22_LSKFY2_8

module HDBLVT11_AOI22_LSKFY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_AOI22_LSKFY2_8

//%BEGIN HDBLVT11_AOI22_LSKRY2_12

module HDBLVT11_AOI22_LSKRY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_AOI22_LSKRY2_12

//%BEGIN HDBLVT11_AOI22_LSKRY2_2

module HDBLVT11_AOI22_LSKRY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_AOI22_LSKRY2_2

//%BEGIN HDBLVT11_AOI22_LSKRY2_4

module HDBLVT11_AOI22_LSKRY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_AOI22_LSKRY2_4

//%BEGIN HDBLVT11_AOI22_LSKRY2_8

module HDBLVT11_AOI22_LSKRY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_AOI22_LSKRY2_8

//%BEGIN HDBLVT11_AOI22_LY2_12

module HDBLVT11_AOI22_LY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_AOI22_LY2_12

//%BEGIN HDBLVT11_AOI22_LY2_2

module HDBLVT11_AOI22_LY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_AOI22_LY2_2

//%BEGIN HDBLVT11_AOI22_LY2_4

module HDBLVT11_AOI22_LY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_AOI22_LY2_4

//%BEGIN HDBLVT11_AOI22_LY2_6

module HDBLVT11_AOI22_LY2_6 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_AOI22_LY2_6

//%BEGIN HDBLVT11_AOI22_LY2_8

module HDBLVT11_AOI22_LY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_AOI22_LY2_8

//%BEGIN HDBLVT11_EN2_LCBV2_1

module HDBLVT11_EN2_LCBV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule

//%END HDBLVT11_EN2_LCBV2_1

//%BEGIN HDBLVT11_EN2_LV2_1

module HDBLVT11_EN2_LV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule

//%END HDBLVT11_EN2_LV2_1

//%BEGIN HDBLVT11_EO2_LCBV2_1

module HDBLVT11_EO2_LCBV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_EO2_LCBV2_1

//%BEGIN HDBLVT11_EO2_LV2_1

module HDBLVT11_EO2_LV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_EO2_LV2_1

//%BEGIN HDBLVT11_ND2_LSKF_2

module HDBLVT11_ND2_LSKF_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_ND2_LSKF_2

//%BEGIN HDBLVT11_ND2_LSKRY2_12

module HDBLVT11_ND2_LSKRY2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_ND2_LSKRY2_12

//%BEGIN HDBLVT11_NR2_LSKFY2_12

module HDBLVT11_NR2_LSKFY2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_NR2_LSKFY2_12

//%BEGIN HDBLVT11_NR2_LSKF_4

module HDBLVT11_NR2_LSKF_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_NR2_LSKF_4

//%BEGIN HDBLVT11_NR2_LSKF_8

module HDBLVT11_NR2_LSKF_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_NR2_LSKF_8

//%BEGIN HDBLVT11_NR2_LSKRY2_12

module HDBLVT11_NR2_LSKRY2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_NR2_LSKRY2_12

//%BEGIN HDBLVT11_NR2_LSKR_2

module HDBLVT11_NR2_LSKR_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_NR2_LSKR_2

//%BEGIN HDBLVT11_NR3_LY2_12

module HDBLVT11_NR3_LY2_12 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_NR3_LY2_12

//%BEGIN HDBLVT11_OAI211_LY2_12

module HDBLVT11_OAI211_LY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
        nand inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBLVT11_OAI211_LY2_12

//%BEGIN HDBLVT11_OAI22_LSKFY2_12

module HDBLVT11_OAI22_LSKFY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT11_OAI22_LSKFY2_12

//%BEGIN HDBLVT11_OAI22_LSKFY2_2

module HDBLVT11_OAI22_LSKFY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT11_OAI22_LSKFY2_2

//%BEGIN HDBLVT11_OAI22_LSKFY2_4

module HDBLVT11_OAI22_LSKFY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT11_OAI22_LSKFY2_4

//%BEGIN HDBLVT11_OAI22_LSKFY2_8

module HDBLVT11_OAI22_LSKFY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT11_OAI22_LSKFY2_8

//%BEGIN HDBLVT11_OAI22_LSKRY2_12

module HDBLVT11_OAI22_LSKRY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT11_OAI22_LSKRY2_12

//%BEGIN HDBLVT11_OAI22_LSKRY2_2

module HDBLVT11_OAI22_LSKRY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT11_OAI22_LSKRY2_2

//%BEGIN HDBLVT11_OAI22_LSKRY2_4

module HDBLVT11_OAI22_LSKRY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT11_OAI22_LSKRY2_4

//%BEGIN HDBLVT11_OAI22_LSKRY2_8

module HDBLVT11_OAI22_LSKRY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT11_OAI22_LSKRY2_8

//%BEGIN HDBLVT11_OAI22_LY2_2

module HDBLVT11_OAI22_LY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT11_OAI22_LY2_2

//%BEGIN HDBLVT11_OAI22_LY2_4

module HDBLVT11_OAI22_LY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBLVT11_OAI22_LY2_4

//%BEGIN HDBSVT08_AOI22_LY2_12

module HDBSVT08_AOI22_LY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBSVT08_AOI22_LY2_12

//%BEGIN HDBSVT08_AOI22_LY2_2

module HDBSVT08_AOI22_LY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBSVT08_AOI22_LY2_2

//%BEGIN HDBSVT08_AOI22_LY2_4

module HDBSVT08_AOI22_LY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBSVT08_AOI22_LY2_4

//%BEGIN HDBSVT08_AOI22_LY2_6

module HDBSVT08_AOI22_LY2_6 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBSVT08_AOI22_LY2_6

//%BEGIN HDBSVT08_AOI22_LY2_8

module HDBSVT08_AOI22_LY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBSVT08_AOI22_LY2_8

//%BEGIN HDBSVT08_CKLDAO21NQ_LPV1Y2_1
module HDBSVT08_CKLDAO21NQ_LPV1Y2_1 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBSVT08_CKLDAO21NQ_LPV1Y2_1

//%BEGIN HDBSVT08_CKLDAO21NQ_LPV1Y2_2
module HDBSVT08_CKLDAO21NQ_LPV1Y2_2 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBSVT08_CKLDAO21NQ_LPV1Y2_2

//%BEGIN HDBSVT08_CKLDAO21NQ_LPV1Y2_4
module HDBSVT08_CKLDAO21NQ_LPV1Y2_4 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBSVT08_CKLDAO21NQ_LPV1Y2_4

//%BEGIN HDBSVT08_CKLDNQOR2_LPV1Y2_1
module HDBSVT08_CKLDNQOR2_LPV1Y2_1 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBSVT08_CKLDNQOR2_LPV1Y2_1

//%BEGIN HDBSVT08_CKLDNQOR2_LPV1Y2_2
module HDBSVT08_CKLDNQOR2_LPV1Y2_2 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBSVT08_CKLDNQOR2_LPV1Y2_2

//%BEGIN HDBSVT08_CKLDNQOR2_LPV1Y2_4
module HDBSVT08_CKLDNQOR2_LPV1Y2_4 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBSVT08_CKLDNQOR2_LPV1Y2_4

//%BEGIN HDBSVT08_EN2_LCBV2_1

module HDBSVT08_EN2_LCBV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule

//%END HDBSVT08_EN2_LCBV2_1

//%BEGIN HDBSVT08_EN2_LV2_1

module HDBSVT08_EN2_LV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule

//%END HDBSVT08_EN2_LV2_1

//%BEGIN HDBSVT08_EO2_LCBV2_1

module HDBSVT08_EO2_LCBV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBSVT08_EO2_LCBV2_1

//%BEGIN HDBSVT08_EO2_LV2_1

module HDBSVT08_EO2_LV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBSVT08_EO2_LV2_1

//%BEGIN HDBSVT08_NR3_LY2_12

module HDBSVT08_NR3_LY2_12 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBSVT08_NR3_LY2_12

//%BEGIN HDBSVT08_OAI211_LY2_12

module HDBSVT08_OAI211_LY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
        nand inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBSVT08_OAI211_LY2_12

//%BEGIN HDBSVT08_OAI22_LY2_2

module HDBSVT08_OAI22_LY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBSVT08_OAI22_LY2_2

//%BEGIN HDBSVT08_OAI22_LY2_4

module HDBSVT08_OAI22_LY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBSVT08_OAI22_LY2_4

//%BEGIN HDBSVT11_EN2_LCBV2_1

module HDBSVT11_EN2_LCBV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule

//%END HDBSVT11_EN2_LCBV2_1

//%BEGIN HDBSVT11_EN2_LV2_1

module HDBSVT11_EN2_LV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule

//%END HDBSVT11_EN2_LV2_1

//%BEGIN HDBSVT11_EO2_LCBV2_1

module HDBSVT11_EO2_LCBV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBSVT11_EO2_LCBV2_1

//%BEGIN HDBSVT11_EO2_LV2_1

module HDBSVT11_EO2_LV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBSVT11_EO2_LV2_1

//%BEGIN HDBULT08_AOI22_LSKFY2_12

module HDBULT08_AOI22_LSKFY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_AOI22_LSKFY2_12

//%BEGIN HDBULT08_AOI22_LSKFY2_2

module HDBULT08_AOI22_LSKFY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_AOI22_LSKFY2_2

//%BEGIN HDBULT08_AOI22_LSKFY2_4

module HDBULT08_AOI22_LSKFY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_AOI22_LSKFY2_4

//%BEGIN HDBULT08_AOI22_LSKFY2_8

module HDBULT08_AOI22_LSKFY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_AOI22_LSKFY2_8

//%BEGIN HDBULT08_AOI22_LSKRY2_12

module HDBULT08_AOI22_LSKRY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_AOI22_LSKRY2_12

//%BEGIN HDBULT08_AOI22_LSKRY2_2

module HDBULT08_AOI22_LSKRY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_AOI22_LSKRY2_2

//%BEGIN HDBULT08_AOI22_LSKRY2_4

module HDBULT08_AOI22_LSKRY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_AOI22_LSKRY2_4

//%BEGIN HDBULT08_AOI22_LSKRY2_8

module HDBULT08_AOI22_LSKRY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_AOI22_LSKRY2_8

//%BEGIN HDBULT08_AOI22_LY2_12

module HDBULT08_AOI22_LY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_AOI22_LY2_12

//%BEGIN HDBULT08_AOI22_LY2_2

module HDBULT08_AOI22_LY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_AOI22_LY2_2

//%BEGIN HDBULT08_AOI22_LY2_4

module HDBULT08_AOI22_LY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_AOI22_LY2_4

//%BEGIN HDBULT08_AOI22_LY2_6

module HDBULT08_AOI22_LY2_6 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_AOI22_LY2_6

//%BEGIN HDBULT08_AOI22_LY2_8

module HDBULT08_AOI22_LY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_AOI22_LY2_8

//%BEGIN HDBULT08_CKLDAO21NQ_LLPV1Y2_1
module HDBULT08_CKLDAO21NQ_LLPV1Y2_1 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDAO21NQ_LLPV1Y2_1

//%BEGIN HDBULT08_CKLDAO21NQ_LLPV1Y2_2
module HDBULT08_CKLDAO21NQ_LLPV1Y2_2 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDAO21NQ_LLPV1Y2_2

//%BEGIN HDBULT08_CKLDAO21NQ_LLPV1Y2_4
module HDBULT08_CKLDAO21NQ_LLPV1Y2_4 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDAO21NQ_LLPV1Y2_4

//%BEGIN HDBULT08_CKLDAO21NQ_LLV2Y2_1
module HDBULT08_CKLDAO21NQ_LLV2Y2_1 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDAO21NQ_LLV2Y2_1

//%BEGIN HDBULT08_CKLDAO21NQ_LLV2Y2_2
module HDBULT08_CKLDAO21NQ_LLV2Y2_2 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDAO21NQ_LLV2Y2_2

//%BEGIN HDBULT08_CKLDAO21NQ_LLV2Y2_4
module HDBULT08_CKLDAO21NQ_LLV2Y2_4 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDAO21NQ_LLV2Y2_4

//%BEGIN HDBULT08_CKLDAO21NQ_LLV2Y2_8
module HDBULT08_CKLDAO21NQ_LLV2Y2_8 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDAO21NQ_LLV2Y2_8

//%BEGIN HDBULT08_CKLDAO21NQ_LPV1Y2_1
module HDBULT08_CKLDAO21NQ_LPV1Y2_1 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDAO21NQ_LPV1Y2_1

//%BEGIN HDBULT08_CKLDAO21NQ_LPV1Y2_2
module HDBULT08_CKLDAO21NQ_LPV1Y2_2 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDAO21NQ_LPV1Y2_2

//%BEGIN HDBULT08_CKLDAO21NQ_LPV1Y2_4
module HDBULT08_CKLDAO21NQ_LPV1Y2_4 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDAO21NQ_LPV1Y2_4

//%BEGIN HDBULT08_CKLDAO21NQ_LSV2Y2_1
module HDBULT08_CKLDAO21NQ_LSV2Y2_1 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDAO21NQ_LSV2Y2_1

//%BEGIN HDBULT08_CKLDAO21NQ_LSV2Y2_2
module HDBULT08_CKLDAO21NQ_LSV2Y2_2 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDAO21NQ_LSV2Y2_2

//%BEGIN HDBULT08_CKLDAO21NQ_LSV2Y2_4
module HDBULT08_CKLDAO21NQ_LSV2Y2_4 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDAO21NQ_LSV2Y2_4

//%BEGIN HDBULT08_CKLDAO21NQ_LSV2Y2_8
module HDBULT08_CKLDAO21NQ_LSV2Y2_8 (Z, CLK, TE, CE, SSE);
  input CLK, TE, CE, SSE;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, int_6, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_CE, CE);
    buf inst3  (delayed_SSE, SSE);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst4  (viol_x, viol_0, int_6, 1'b1, 1'b1);

  `endif
    and inst5  (int_4, delayed_TE, delayed_CE);
    or inst6  (int_5, int_4, delayed_SSE);
    not inst7  (int_6, delayed_CLK);
    snps_latch inst8  (iq, viol_x, int_6, int_5);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst9 (Z, iq);
  `else
    buf inst10  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst11  (_net_0, SSE);
and inst12  (ENABLE_NOT_SSE_AND_TE, TE, _net_0);
not inst13  (_net_1, SSE);
not inst14  (_net_2, CE);
not inst15  (_net_3, TE);
and inst16  (ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE, _net_1, _net_2, _net_3);
not inst17  (_net_4, SSE);
not inst18  (_net_5, CE);
and inst19  (ENABLE_NOT_CE_AND_NOT_SSE_AND_TE, _net_4, _net_5, TE);
not inst20  (_net_6, CE);
not inst21  (_net_7, TE);
and inst22  (ENABLE_NOT_CE_AND_SSE_AND_NOT_TE, SSE, _net_6, _net_7);
not inst23  (_net_8, CE);
and inst24  (ENABLE_NOT_CE_AND_SSE_AND_TE, SSE, _net_8, TE);
not inst25  (_net_9, SSE);
not inst26  (_net_10, TE);
and inst27  (ENABLE_CE_AND_NOT_SSE_AND_NOT_TE, _net_9, CE, _net_10);
not inst28  (_net_11, SSE);
and inst29  (ENABLE_CE_AND_NOT_SSE_AND_TE, _net_11, CE, TE);
not inst30  (_net_12, TE);
and inst31  (ENABLE_CE_AND_SSE_AND_NOT_TE, SSE, CE, _net_12);
and inst32  (ENABLE_CE_AND_SSE_AND_TE, SSE, CE, TE);
not inst33  (_net_13, TE);
not inst34  (_net_14, CE);
and inst35  (ENABLE_NOT_CE_AND_NOT_TE, _net_13, _net_14);
not inst36  (_net_15, CE);
and inst37  (ENABLE_NOT_CE_AND_TE, TE, _net_15);
not inst38  (_net_16, TE);
and inst39  (ENABLE_CE_AND_NOT_TE, _net_16, CE);
not inst40  (_net_17, SSE);
and inst41  (ENABLE_CE_AND_NOT_SSE, _net_17, CE);

specify
if (CLK==1'b0 && SSE==1'b0 && TE==1'b1) (CE +=> Z)=(0, 0);
ifnone (CE +=> Z)=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b0 && SSE==1'b0 && TE==1'b1) (negedge CLK => (Z +: 1'b1))=(0, 0);
if (CE==1'b1 && SSE==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
if (CE==1'b0 && CLK==1'b0 && TE==1'b1) (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && TE==1'b0) (SSE +=> Z)=(0, 0);
ifnone (SSE +=> Z)=(0, 0);
if (CE==1'b1 && CLK==1'b0 && SSE==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , posedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$setuphold(posedge CLK &&& ENABLE_NOT_SSE_AND_TE , negedge CE &&& ENABLE_NOT_SSE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_CE);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_NOT_SSE_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_CE_AND_SSE_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , posedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_NOT_TE , negedge SSE &&& ENABLE_NOT_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , posedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_NOT_CE_AND_TE , negedge SSE &&& ENABLE_NOT_CE_AND_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , posedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_TE , negedge SSE &&& ENABLE_CE_AND_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_SSE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , posedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_CE_AND_NOT_SSE , negedge TE &&& ENABLE_CE_AND_NOT_SSE , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDAO21NQ_LSV2Y2_8

//%BEGIN HDBULT08_CKLDNQOR2_LLPV1Y2_1
module HDBULT08_CKLDNQOR2_LLPV1Y2_1 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDNQOR2_LLPV1Y2_1

//%BEGIN HDBULT08_CKLDNQOR2_LLPV1Y2_2
module HDBULT08_CKLDNQOR2_LLPV1Y2_2 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDNQOR2_LLPV1Y2_2

//%BEGIN HDBULT08_CKLDNQOR2_LLPV1Y2_4
module HDBULT08_CKLDNQOR2_LLPV1Y2_4 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDNQOR2_LLPV1Y2_4

//%BEGIN HDBULT08_CKLDNQOR2_LLY2_1
module HDBULT08_CKLDNQOR2_LLY2_1 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDNQOR2_LLY2_1

//%BEGIN HDBULT08_CKLDNQOR2_LLY2_2
module HDBULT08_CKLDNQOR2_LLY2_2 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDNQOR2_LLY2_2

//%BEGIN HDBULT08_CKLDNQOR2_LLY2_4
module HDBULT08_CKLDNQOR2_LLY2_4 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDNQOR2_LLY2_4

//%BEGIN HDBULT08_CKLDNQOR2_LLY2_8
module HDBULT08_CKLDNQOR2_LLY2_8 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDNQOR2_LLY2_8

//%BEGIN HDBULT08_CKLDNQOR2_LPV1Y2_1
module HDBULT08_CKLDNQOR2_LPV1Y2_1 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDNQOR2_LPV1Y2_1

//%BEGIN HDBULT08_CKLDNQOR2_LPV1Y2_2
module HDBULT08_CKLDNQOR2_LPV1Y2_2 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDNQOR2_LPV1Y2_2

//%BEGIN HDBULT08_CKLDNQOR2_LPV1Y2_4
module HDBULT08_CKLDNQOR2_LPV1Y2_4 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDNQOR2_LPV1Y2_4

//%BEGIN HDBULT08_CKLDNQOR2_LSY2_1
module HDBULT08_CKLDNQOR2_LSY2_1 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDNQOR2_LSY2_1

//%BEGIN HDBULT08_CKLDNQOR2_LSY2_2
module HDBULT08_CKLDNQOR2_LSY2_2 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDNQOR2_LSY2_2

//%BEGIN HDBULT08_CKLDNQOR2_LSY2_4
module HDBULT08_CKLDNQOR2_LSY2_4 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDNQOR2_LSY2_4

//%BEGIN HDBULT08_CKLDNQOR2_LSY2_8
module HDBULT08_CKLDNQOR2_LSY2_8 (Z, CLK, TE, E);
  input CLK, TE, E;
  output Z;
  reg viol_0;
  wire viol_x, int_4, int_5, iq;
  `ifdef _fv
    buf inst0  (delayed_CLK, CLK);
    buf inst1  (delayed_TE, TE);
    buf inst2  (delayed_E, E);
  `endif


  `ifndef SNPS_MASK_X_OUT_LATCH
    snps_x_out_latch inst3  (viol_x, viol_0, int_5, 1'b1, 1'b1);

  `endif
    or inst4  (int_4, delayed_TE, delayed_E);
    not inst5  (int_5, delayed_CLK);
    snps_latch inst6  (iq, viol_x, int_5, int_4);
  `ifdef VIRL_functiononly
    buf #`SNPS_CKGT_DELAY  inst7 (Z, iq);
  `else
    buf inst8  (Z, iq);
  `endif
  `ifdef VIRL_functiononly
  `else
not inst9  (_net_0, TE);
not inst10  (_net_1, E);
and inst11  (ENABLE_NOT_E_AND_NOT_TE, _net_0, _net_1);
not inst12  (_net_2, E);
and inst13  (ENABLE_NOT_E_AND_TE, TE, _net_2);
not inst14  (_net_3, TE);
and inst15  (ENABLE_E_AND_NOT_TE, _net_3, E);
and inst16  (ENABLE_E_AND_TE, TE, E);
not inst17  (ENABLE_NOT_TE, TE);
not inst18  (ENABLE_NOT_E, E);

specify
if (E==1'b0 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b0) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b1 && TE==1'b1) (negedge CLK => (Z -: 1'b1))=(0, 0);
if (E==1'b0 && TE==1'b0) (negedge CLK => (Z +: 1'b1))=(0, 0);
(negedge CLK => (Z : 1'b1))=(0, 0);
if (CLK==1'b0 && TE==1'b0) (E +=> Z)=(0, 0);
ifnone (E +=> Z)=(0, 0);
if (CLK==1'b0 && E==1'b0) (TE +=> Z)=(0, 0);
ifnone (TE +=> Z)=(0, 0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_NOT_E_AND_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_NOT_TE , 0 ,0, viol_0);
$width(negedge CLK &&& ENABLE_E_AND_TE , 0 ,0, viol_0);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , posedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_TE , negedge E &&& ENABLE_NOT_TE , 0 ,0, viol_0, , , delayed_CLK, delayed_E);
$setuphold(posedge CLK &&& ENABLE_NOT_E , posedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
$setuphold(posedge CLK &&& ENABLE_NOT_E , negedge TE &&& ENABLE_NOT_E , 0 ,0, viol_0, , , delayed_CLK, delayed_TE);
endspecify
  `endif
endmodule
//%END HDBULT08_CKLDNQOR2_LSY2_8

//%BEGIN HDBULT08_EN2_LCBV2_1

module HDBULT08_EN2_LCBV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule

//%END HDBULT08_EN2_LCBV2_1

//%BEGIN HDBULT08_EN2_LV2_1

module HDBULT08_EN2_LV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule

//%END HDBULT08_EN2_LV2_1

//%BEGIN HDBULT08_EO2_LCBV2_1

module HDBULT08_EO2_LCBV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_EO2_LCBV2_1

//%BEGIN HDBULT08_EO2_LV2_1

module HDBULT08_EO2_LV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_EO2_LV2_1

//%BEGIN HDBULT08_FSDND2PQB_LBSKY2_1

module HDBULT08_FSDND2PQB_LBSKY2_1 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDND2PQB_LBSKY2_1
//%END HDBULT08_FSDND2PQB_LBSKY2_1

//%BEGIN HDBULT08_FSDND2PQB_LBSKY2_10

module HDBULT08_FSDND2PQB_LBSKY2_10 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDND2PQB_LBSKY2_10
//%END HDBULT08_FSDND2PQB_LBSKY2_10

//%BEGIN HDBULT08_FSDND2PQB_LBSKY2_12

module HDBULT08_FSDND2PQB_LBSKY2_12 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDND2PQB_LBSKY2_12
//%END HDBULT08_FSDND2PQB_LBSKY2_12

//%BEGIN HDBULT08_FSDND2PQB_LBSKY2_2

module HDBULT08_FSDND2PQB_LBSKY2_2 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDND2PQB_LBSKY2_2
//%END HDBULT08_FSDND2PQB_LBSKY2_2

//%BEGIN HDBULT08_FSDND2PQB_LBSKY2_4

module HDBULT08_FSDND2PQB_LBSKY2_4 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDND2PQB_LBSKY2_4
//%END HDBULT08_FSDND2PQB_LBSKY2_4

//%BEGIN HDBULT08_FSDND2PQB_LSKY2_1

module HDBULT08_FSDND2PQB_LSKY2_1 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDND2PQB_LSKY2_1
//%END HDBULT08_FSDND2PQB_LSKY2_1

//%BEGIN HDBULT08_FSDND2PQB_LSKY2_10

module HDBULT08_FSDND2PQB_LSKY2_10 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDND2PQB_LSKY2_10
//%END HDBULT08_FSDND2PQB_LSKY2_10

//%BEGIN HDBULT08_FSDND2PQB_LSKY2_12

module HDBULT08_FSDND2PQB_LSKY2_12 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDND2PQB_LSKY2_12
//%END HDBULT08_FSDND2PQB_LSKY2_12

//%BEGIN HDBULT08_FSDND2PQB_LSKY2_2

module HDBULT08_FSDND2PQB_LSKY2_2 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDND2PQB_LSKY2_2
//%END HDBULT08_FSDND2PQB_LSKY2_2

//%BEGIN HDBULT08_FSDND2PQB_LSKY2_4

module HDBULT08_FSDND2PQB_LSKY2_4 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   and inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, SI);
and inst13  (ENABLE_A2_AND_NOT_SE_AND_NOT_SI, _net_0, A2, _net_1);
not inst14  (_net_2, SE);
and inst15  (ENABLE_A2_AND_NOT_SE_AND_SI, _net_2, A2, SI);
not inst16  (_net_3, SE);
not inst17  (_net_4, SI);
and inst18  (ENABLE_A1_AND_NOT_SE_AND_NOT_SI, _net_3, A1, _net_4);
not inst19  (_net_5, SE);
and inst20  (ENABLE_A1_AND_NOT_SE_AND_SI, _net_5, A1, SI);
not inst21  (_net_6, A2);
not inst22  (_net_7, A1);
not inst23  (_net_8, SE);
not inst24  (_net_9, SI);
and inst25  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_6, _net_7, _net_8, _net_9);
not inst26  (_net_10, A2);
not inst27  (_net_11, A1);
not inst28  (_net_12, SE);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_10, _net_11, _net_12, SI);
not inst30  (_net_13, A2);
not inst31  (_net_14, A1);
not inst32  (_net_15, SI);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_13, _net_14, SE, _net_15);
not inst34  (_net_16, A2);
not inst35  (_net_17, A1);
and inst36  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_16, _net_17, SE, SI);
not inst37  (_net_18, A1);
not inst38  (_net_19, SE);
not inst39  (_net_20, SI);
and inst40  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_18, _net_19, _net_20);
not inst41  (_net_21, A1);
not inst42  (_net_22, SE);
and inst43  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_21, _net_22, SI);
not inst44  (_net_23, A1);
not inst45  (_net_24, SI);
and inst46  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_23, SE, _net_24);
not inst47  (_net_25, A1);
and inst48  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_25, SE, SI);
not inst49  (_net_26, A2);
not inst50  (_net_27, SE);
not inst51  (_net_28, SI);
and inst52  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_26, A1, _net_27, _net_28);
not inst53  (_net_29, A2);
not inst54  (_net_30, SE);
and inst55  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_29, A1, _net_30, SI);
not inst56  (_net_31, A2);
not inst57  (_net_32, SI);
and inst58  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_31, A1, SE, _net_32);
not inst59  (_net_33, A2);
and inst60  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_33, A1, SE, SI);
not inst61  (_net_34, SE);
not inst62  (_net_35, SI);
and inst63  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_34, _net_35);
not inst64  (_net_36, SE);
and inst65  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_36, SI);
not inst66  (_net_37, SI);
and inst67  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_37);
and inst68  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst69  (_net_38, A2);
not inst70  (_net_39, A1);
and inst71  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_38, _net_39, SI);
not inst72  (_net_40, A1);
and inst73  (ENABLE_NOT_A1_AND_A2_AND_SI, A2, _net_40, SI);
not inst74  (_net_41, A2);
and inst75  (ENABLE_A1_AND_NOT_A2_AND_SI, _net_41, A1, SI);
not inst76  (_net_42, SI);
and inst77  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_42);
not inst78  (_net_43, A2);
not inst79  (_net_44, A1);
and inst80  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_43, _net_44, SE);
not inst81  (_net_45, A1);
and inst82  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_45, SE);
not inst83  (_net_46, A2);
and inst84  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_46, A1, SE);
and inst85  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDND2PQB_LSKY2_4
//%END HDBULT08_FSDND2PQB_LSKY2_4

//%BEGIN HDBULT08_FSDNR2PQB_LBSKY2_1

module HDBULT08_FSDNR2PQB_LBSKY2_1 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDNR2PQB_LBSKY2_1

//%BEGIN HDBULT08_FSDNR2PQB_LBSKY2_10

module HDBULT08_FSDNR2PQB_LBSKY2_10 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDNR2PQB_LBSKY2_10

//%BEGIN HDBULT08_FSDNR2PQB_LBSKY2_12

module HDBULT08_FSDNR2PQB_LBSKY2_12 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDNR2PQB_LBSKY2_12

//%BEGIN HDBULT08_FSDNR2PQB_LBSKY2_2

module HDBULT08_FSDNR2PQB_LBSKY2_2 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDNR2PQB_LBSKY2_2

//%BEGIN HDBULT08_FSDNR2PQB_LBSKY2_4

module HDBULT08_FSDNR2PQB_LBSKY2_4 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDNR2PQB_LBSKY2_4

//%BEGIN HDBULT08_FSDNR2PQB_LSKY2_1

module HDBULT08_FSDNR2PQB_LSKY2_1 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDNR2PQB_LSKY2_1

//%BEGIN HDBULT08_FSDNR2PQB_LSKY2_10

module HDBULT08_FSDNR2PQB_LSKY2_10 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDNR2PQB_LSKY2_10

//%BEGIN HDBULT08_FSDNR2PQB_LSKY2_12

module HDBULT08_FSDNR2PQB_LSKY2_12 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDNR2PQB_LSKY2_12

//%BEGIN HDBULT08_FSDNR2PQB_LSKY2_2

module HDBULT08_FSDNR2PQB_LSKY2_2 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDNR2PQB_LSKY2_2

//%BEGIN HDBULT08_FSDNR2PQB_LSKY2_4

module HDBULT08_FSDNR2PQB_LSKY2_4 (QN, CK, A1, A2, SI, SE);
   output QN;
   input CK, A1, A2, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_A1, delayed_A2,
        delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_A1, A1);
   buf inst2  (delayed_A2, A2);
   buf inst3  (delayed_SI, SI);
   buf inst4  (delayed_SE, SE);
`endif


   or inst5  (int_res__D, delayed_A1, delayed_A2);
   snps_mux2 inst6  (int_res_mux, delayed_SI, int_res__D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst7  (xcr_0, delayed_CK, int_res_mux);

  `endif
   snps_dff inst8  (int_res_iq, viol_0, delayed_CK, int_res_mux, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst9 (QN, int_res_iq);
   `else
        not inst10  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst11  (_net_0, SE);
not inst12  (_net_1, A2);
not inst13  (_net_2, SI);
and inst14  (ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst15  (_net_3, SE);
not inst16  (_net_4, A2);
and inst17  (ENABLE_NOT_A2_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst18  (_net_5, SE);
not inst19  (_net_6, A1);
not inst20  (_net_7, SI);
and inst21  (ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI, _net_5, _net_6, _net_7);
not inst22  (_net_8, SE);
not inst23  (_net_9, A1);
and inst24  (ENABLE_NOT_A1_AND_NOT_SE_AND_SI, _net_8, _net_9, SI);
not inst25  (_net_10, A2);
not inst26  (_net_11, A1);
not inst27  (_net_12, SE);
not inst28  (_net_13, SI);
and inst29  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_10, _net_11, _net_12, _net_13);
not inst30  (_net_14, A2);
not inst31  (_net_15, A1);
not inst32  (_net_16, SE);
and inst33  (ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_14, _net_15, _net_16, SI);
not inst34  (_net_17, A2);
not inst35  (_net_18, A1);
not inst36  (_net_19, SI);
and inst37  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_17, _net_18, SE, _net_19);
not inst38  (_net_20, A2);
not inst39  (_net_21, A1);
and inst40  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI, _net_20, _net_21, SE, SI);
not inst41  (_net_22, A1);
not inst42  (_net_23, SE);
not inst43  (_net_24, SI);
and inst44  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, _net_22, _net_23, _net_24);
not inst45  (_net_25, A1);
not inst46  (_net_26, SE);
and inst47  (ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI, A2, _net_25, _net_26, SI);
not inst48  (_net_27, A1);
not inst49  (_net_28, SI);
and inst50  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI, A2, _net_27, SE, _net_28);
not inst51  (_net_29, A1);
and inst52  (ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI, A2, _net_29, SE, SI);
not inst53  (_net_30, A2);
not inst54  (_net_31, SE);
not inst55  (_net_32, SI);
and inst56  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI, _net_30, A1, _net_31, _net_32);
not inst57  (_net_33, A2);
not inst58  (_net_34, SE);
and inst59  (ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI, _net_33, A1, _net_34, SI);
not inst60  (_net_35, A2);
not inst61  (_net_36, SI);
and inst62  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI, _net_35, A1, SE, _net_36);
not inst63  (_net_37, A2);
and inst64  (ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI, _net_37, A1, SE, SI);
not inst65  (_net_38, SE);
not inst66  (_net_39, SI);
and inst67  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI, A2, A1, _net_38, _net_39);
not inst68  (_net_40, SE);
and inst69  (ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI, A2, A1, _net_40, SI);
not inst70  (_net_41, SI);
and inst71  (ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI, A2, A1, SE, _net_41);
and inst72  (ENABLE_A1_AND_A2_AND_SE_AND_SI, A2, A1, SE, SI);
not inst73  (_net_42, A2);
not inst74  (_net_43, A1);
and inst75  (ENABLE_NOT_A1_AND_NOT_A2_AND_SI, _net_42, _net_43, SI);
not inst76  (_net_44, A1);
not inst77  (_net_45, SI);
and inst78  (ENABLE_NOT_A1_AND_A2_AND_NOT_SI, A2, _net_44, _net_45);
not inst79  (_net_46, A2);
not inst80  (_net_47, SI);
and inst81  (ENABLE_A1_AND_NOT_A2_AND_NOT_SI, _net_46, A1, _net_47);
not inst82  (_net_48, SI);
and inst83  (ENABLE_A1_AND_A2_AND_NOT_SI, A2, A1, _net_48);
not inst84  (_net_49, A2);
not inst85  (_net_50, A1);
and inst86  (ENABLE_NOT_A1_AND_NOT_A2_AND_SE, _net_49, _net_50, SE);
not inst87  (_net_51, A1);
and inst88  (ENABLE_NOT_A1_AND_A2_AND_SE, A2, _net_51, SE);
not inst89  (_net_52, A2);
and inst90  (ENABLE_A1_AND_NOT_A2_AND_SE, _net_52, A1, SE);
and inst91  (ENABLE_A1_AND_A2_AND_SE, A2, A1, SE);

specify
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b0 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (A1==1'b1 && A2==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , posedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , negedge A1 &&& ENABLE_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A1);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , posedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , negedge A2 &&& ENABLE_NOT_A1_AND_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_A2);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_A1_AND_A2_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , posedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , negedge SE &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_NOT_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_NOT_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , posedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_NOT_SI , negedge SE &&& ENABLE_A1_AND_A2_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_NOT_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_NOT_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_NOT_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , posedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_A1_AND_A2_AND_SE , negedge SI &&& ENABLE_A1_AND_A2_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDNR2PQB_LSKY2_4

//%BEGIN HDBULT08_FSDPQB_LBSKY2_1

module HDBULT08_FSDPQB_LBSKY2_1 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDPQB_LBSKY2_1
//%END HDBULT08_FSDPQB_LBSKY2_1

//%BEGIN HDBULT08_FSDPQB_LBSKY2_10

module HDBULT08_FSDPQB_LBSKY2_10 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDPQB_LBSKY2_10
//%END HDBULT08_FSDPQB_LBSKY2_10

//%BEGIN HDBULT08_FSDPQB_LBSKY2_12

module HDBULT08_FSDPQB_LBSKY2_12 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDPQB_LBSKY2_12
//%END HDBULT08_FSDPQB_LBSKY2_12

//%BEGIN HDBULT08_FSDPQB_LBSKY2_2

module HDBULT08_FSDPQB_LBSKY2_2 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDPQB_LBSKY2_2
//%END HDBULT08_FSDPQB_LBSKY2_2

//%BEGIN HDBULT08_FSDPQB_LBSKY2_4

module HDBULT08_FSDPQB_LBSKY2_4 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDPQB_LBSKY2_4
//%END HDBULT08_FSDPQB_LBSKY2_4

//%BEGIN HDBULT08_FSDPQB_LSKY2_1

module HDBULT08_FSDPQB_LSKY2_1 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDPQB_LSKY2_1
//%END HDBULT08_FSDPQB_LSKY2_1

//%BEGIN HDBULT08_FSDPQB_LSKY2_10

module HDBULT08_FSDPQB_LSKY2_10 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDPQB_LSKY2_10
//%END HDBULT08_FSDPQB_LSKY2_10

//%BEGIN HDBULT08_FSDPQB_LSKY2_12

module HDBULT08_FSDPQB_LSKY2_12 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDPQB_LSKY2_12
//%END HDBULT08_FSDPQB_LSKY2_12

//%BEGIN HDBULT08_FSDPQB_LSKY2_2

module HDBULT08_FSDPQB_LSKY2_2 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDPQB_LSKY2_2
//%END HDBULT08_FSDPQB_LSKY2_2

//%BEGIN HDBULT08_FSDPQB_LSKY2_4

module HDBULT08_FSDPQB_LSKY2_4 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDPQB_LSKY2_4
//%END HDBULT08_FSDPQB_LSKY2_4

//%BEGIN HDBULT08_FSDPQB_LV1Y2_1

module HDBULT08_FSDPQB_LV1Y2_1 (QN, CK, D, SI, SE);
   output QN;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D, 
	delayed_SI, delayed_SE;

   wire int_res__D, int_res_iq, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif
   snps_dff inst6  (int_res_iq, viol_0, delayed_CK, int_res__D, xcr_0);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        not #`SNPS_SEQ_DELAY  inst7 (QN, int_res_iq);
   `else
        not inst8  (QN, int_res_iq);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst9  (_net_0, SE);
not inst10  (_net_1, D);
not inst11  (_net_2, SI);
and inst12  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst13  (_net_3, SE);
not inst14  (_net_4, D);
and inst15  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst16  (_net_5, D);
not inst17  (_net_6, SI);
and inst18  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst19  (_net_7, D);
and inst20  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst21  (_net_8, SE);
not inst22  (_net_9, SI);
and inst23  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst24  (_net_10, SE);
and inst25  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst26  (_net_11, SI);
and inst27  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst28  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst29  (_net_12, SI);
not inst30  (_net_13, SE);
and inst31  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst32  (_net_14, SE);
and inst33  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst34  (_net_15, D);
and inst35  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst36  (_net_16, SI);
and inst37  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst38  (_net_17, D);
and inst39  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst40  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (QN -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (QN +: 1'b1))=(0, 0);
(posedge CK => (QN : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDPQB_LV1Y2_1
//%END HDBULT08_FSDPQB_LV1Y2_1

//%BEGIN HDBULT08_FSDPQ_LCBV1Y2_1

module HDBULT08_FSDPQ_LCBV1Y2_1 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDPQ_LCBV1Y2_1

//%BEGIN HDBULT08_FSDPQ_LV1Y2_1

module HDBULT08_FSDPQ_LV1Y2_1 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDPQ_LV1Y2_1

//%BEGIN HDBULT08_FSDPQ_LV1Y2_8

module HDBULT08_FSDPQ_LV1Y2_8 (Q, CK, D, SI, SE);
   output Q;
   input CK, D, SI, SE;

   reg viol_0;
   wire delayed_CK, delayed_D,
	delayed_SI, delayed_SE;

   wire int_res__D, xcr_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

`ifdef _fv
   buf inst0  (delayed_CK, CK);
   buf inst1  (delayed_D, D);
   buf inst2  (delayed_SI, SI);
   buf inst3  (delayed_SE, SE);
`endif

   snps_mux2 inst4  (int_res__D, delayed_SI, delayed_D, delayed_SE);
  `ifndef SNPS_MASK_ERR_UDP
   snps_dff_err inst5  (xcr_0, delayed_CK, int_res__D);

  `endif

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        snps_dff #`SNPS_SEQ_DELAY  inst6 (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `else
        snps_dff inst7  (Q, viol_0, delayed_CK, int_res__D, xcr_0);
   `endif

   `ifdef VIRL_functiononly

   `else

not inst8  (_net_0, SE);
not inst9  (_net_1, D);
not inst10  (_net_2, SI);
and inst11  (ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI, _net_0, _net_1, _net_2);
not inst12  (_net_3, SE);
not inst13  (_net_4, D);
and inst14  (ENABLE_NOT_D_AND_NOT_SE_AND_SI, _net_3, _net_4, SI);
not inst15  (_net_5, D);
not inst16  (_net_6, SI);
and inst17  (ENABLE_NOT_D_AND_SE_AND_NOT_SI, SE, _net_5, _net_6);
not inst18  (_net_7, D);
and inst19  (ENABLE_NOT_D_AND_SE_AND_SI, SE, _net_7, SI);
not inst20  (_net_8, SE);
not inst21  (_net_9, SI);
and inst22  (ENABLE_D_AND_NOT_SE_AND_NOT_SI, _net_8, D, _net_9);
not inst23  (_net_10, SE);
and inst24  (ENABLE_D_AND_NOT_SE_AND_SI, _net_10, D, SI);
not inst25  (_net_11, SI);
and inst26  (ENABLE_D_AND_SE_AND_NOT_SI, SE, D, _net_11);
and inst27  (ENABLE_D_AND_SE_AND_SI, SE, D, SI);
not inst28  (_net_12, SI);
not inst29  (_net_13, SE);
and inst30  (ENABLE_NOT_SE_AND_NOT_SI, _net_12, _net_13);
not inst31  (_net_14, SE);
and inst32  (ENABLE_NOT_SE_AND_SI, SI, _net_14);
not inst33  (_net_15, D);
and inst34  (ENABLE_NOT_D_AND_SI, SI, _net_15);
not inst35  (_net_16, SI);
and inst36  (ENABLE_D_AND_NOT_SI, _net_16, D);
not inst37  (_net_17, D);
and inst38  (ENABLE_NOT_D_AND_SE, SE, _net_17);
and inst39  (ENABLE_D_AND_SE, SE, D);

specify
if (D==1'b0 && SE==1'b0 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b0 && SI==1'b1) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b0) (posedge CK => (Q -: 1'b1))=(0, 0);
if (D==1'b0 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b0) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b0 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
if (D==1'b1 && SE==1'b1 && SI==1'b1) (posedge CK => (Q +: 1'b1))=(0, 0);
(posedge CK => (Q : 1'b1))=(0, 0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_NOT_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_NOT_SE_AND_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_NOT_SI , 0 ,0, viol_0);
$width(posedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$width(negedge CK &&& ENABLE_D_AND_SE_AND_SI , 0 ,0, viol_0);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , posedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_NOT_SI , negedge D &&& ENABLE_NOT_SE_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , posedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_SE_AND_SI , negedge D &&& ENABLE_NOT_SE_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_D);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , posedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SI , negedge SE &&& ENABLE_NOT_D_AND_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , posedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_D_AND_NOT_SI , negedge SE &&& ENABLE_D_AND_NOT_SI , 0 ,0, viol_0, , , delayed_CK, delayed_SE);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , posedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_NOT_D_AND_SE , negedge SI &&& ENABLE_NOT_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , posedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
$setuphold(posedge CK &&& ENABLE_D_AND_SE , negedge SI &&& ENABLE_D_AND_SE , 0 ,0, viol_0, , , delayed_CK, delayed_SI);
endspecify
   `endif

endmodule

//%END HDBULT08_FSDPQ_LV1Y2_8

//%BEGIN HDBULT08_ND2_LSKF_2

module HDBULT08_ND2_LSKF_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_ND2_LSKF_2

//%BEGIN HDBULT08_ND2_LSKRY2_12

module HDBULT08_ND2_LSKRY2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_ND2_LSKRY2_12

//%BEGIN HDBULT08_NR2_LSKFY2_12

module HDBULT08_NR2_LSKFY2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_NR2_LSKFY2_12

//%BEGIN HDBULT08_NR2_LSKF_4

module HDBULT08_NR2_LSKF_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_NR2_LSKF_4

//%BEGIN HDBULT08_NR2_LSKF_8

module HDBULT08_NR2_LSKF_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_NR2_LSKF_8

//%BEGIN HDBULT08_NR2_LSKRY2_12

module HDBULT08_NR2_LSKRY2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_NR2_LSKRY2_12

//%BEGIN HDBULT08_NR2_LSKR_2

module HDBULT08_NR2_LSKR_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_NR2_LSKR_2

//%BEGIN HDBULT08_NR3_LY2_12

module HDBULT08_NR3_LY2_12 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_NR3_LY2_12

//%BEGIN HDBULT08_OAI211_LY2_12

module HDBULT08_OAI211_LY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
        nand inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT08_OAI211_LY2_12

//%BEGIN HDBULT08_OAI22_LSKFY2_12

module HDBULT08_OAI22_LSKFY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT08_OAI22_LSKFY2_12

//%BEGIN HDBULT08_OAI22_LSKFY2_2

module HDBULT08_OAI22_LSKFY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT08_OAI22_LSKFY2_2

//%BEGIN HDBULT08_OAI22_LSKFY2_4

module HDBULT08_OAI22_LSKFY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT08_OAI22_LSKFY2_4

//%BEGIN HDBULT08_OAI22_LSKFY2_8

module HDBULT08_OAI22_LSKFY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT08_OAI22_LSKFY2_8

//%BEGIN HDBULT08_OAI22_LSKRY2_12

module HDBULT08_OAI22_LSKRY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT08_OAI22_LSKRY2_12

//%BEGIN HDBULT08_OAI22_LSKRY2_2

module HDBULT08_OAI22_LSKRY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT08_OAI22_LSKRY2_2

//%BEGIN HDBULT08_OAI22_LSKRY2_4

module HDBULT08_OAI22_LSKRY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT08_OAI22_LSKRY2_4

//%BEGIN HDBULT08_OAI22_LSKRY2_8

module HDBULT08_OAI22_LSKRY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT08_OAI22_LSKRY2_8

//%BEGIN HDBULT08_OAI22_LY2_2

module HDBULT08_OAI22_LY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT08_OAI22_LY2_2

//%BEGIN HDBULT08_OAI22_LY2_4

module HDBULT08_OAI22_LY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT08_OAI22_LY2_4

//%BEGIN HDBULT11_AOI22_LSKFY2_12

module HDBULT11_AOI22_LSKFY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_AOI22_LSKFY2_12

//%BEGIN HDBULT11_AOI22_LSKFY2_2

module HDBULT11_AOI22_LSKFY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_AOI22_LSKFY2_2

//%BEGIN HDBULT11_AOI22_LSKFY2_4

module HDBULT11_AOI22_LSKFY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_AOI22_LSKFY2_4

//%BEGIN HDBULT11_AOI22_LSKFY2_8

module HDBULT11_AOI22_LSKFY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_AOI22_LSKFY2_8

//%BEGIN HDBULT11_AOI22_LSKRY2_12

module HDBULT11_AOI22_LSKRY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_AOI22_LSKRY2_12

//%BEGIN HDBULT11_AOI22_LSKRY2_2

module HDBULT11_AOI22_LSKRY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_AOI22_LSKRY2_2

//%BEGIN HDBULT11_AOI22_LSKRY2_4

module HDBULT11_AOI22_LSKRY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_AOI22_LSKRY2_4

//%BEGIN HDBULT11_AOI22_LSKRY2_8

module HDBULT11_AOI22_LSKRY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_AOI22_LSKRY2_8

//%BEGIN HDBULT11_AOI22_LY2_12

module HDBULT11_AOI22_LY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_AOI22_LY2_12

//%BEGIN HDBULT11_AOI22_LY2_2

module HDBULT11_AOI22_LY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_AOI22_LY2_2

//%BEGIN HDBULT11_AOI22_LY2_4

module HDBULT11_AOI22_LY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_AOI22_LY2_4

//%BEGIN HDBULT11_AOI22_LY2_6

module HDBULT11_AOI22_LY2_6 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_AOI22_LY2_6

//%BEGIN HDBULT11_AOI22_LY2_8

module HDBULT11_AOI22_LY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   and inst0  (int_res_0, A1, A2);
   and inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
      nor #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
      nor inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else

specify
if (A2==1'b1 && B1==1'b0 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b1 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b1 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_AOI22_LY2_8

//%BEGIN HDBULT11_EN2_LCBV2_1

module HDBULT11_EN2_LCBV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule

//%END HDBULT11_EN2_LCBV2_1

//%BEGIN HDBULT11_EN2_LV2_1

module HDBULT11_EN2_LV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////
   `ifdef VIRL_functiononly
       xnor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
       xnor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b1) (A1 +=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b1) (A2 +=> X)=(0, 0);
endspecify
    `endif

endmodule

//%END HDBULT11_EN2_LV2_1

//%BEGIN HDBULT11_EO2_LCBV2_1

module HDBULT11_EO2_LCBV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_EO2_LCBV2_1

//%BEGIN HDBULT11_EO2_LV2_1

module HDBULT11_EO2_LV2_1 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         xor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
         xor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0) (A1 +=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0) (A2 +=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_EO2_LV2_1

//%BEGIN HDBULT11_ND2_LSKF_2

module HDBULT11_ND2_LSKF_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_ND2_LSKF_2

//%BEGIN HDBULT11_ND2_LSKRY2_12

module HDBULT11_ND2_LSKRY2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nand inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b1) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_ND2_LSKRY2_12

//%BEGIN HDBULT11_NR2_LSKFY2_12

module HDBULT11_NR2_LSKFY2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_NR2_LSKFY2_12

//%BEGIN HDBULT11_NR2_LSKF_4

module HDBULT11_NR2_LSKF_4 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_NR2_LSKF_4

//%BEGIN HDBULT11_NR2_LSKF_8

module HDBULT11_NR2_LSKF_8 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_NR2_LSKF_8

//%BEGIN HDBULT11_NR2_LSKRY2_12

module HDBULT11_NR2_LSKRY2_12 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_NR2_LSKRY2_12

//%BEGIN HDBULT11_NR2_LSKR_2

module HDBULT11_NR2_LSKR_2 (X, A1, A2);
   output X;
   input A1, A2;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2);
   `else
        nor inst1  (X, A1, A2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0) (A2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_NR2_LSKR_2

//%BEGIN HDBULT11_NR3_LY2_12

module HDBULT11_NR3_LY2_12 (X, A1, A2, A3);
   output X;
   input A1, A2, A3;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////


   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nor #`SNPS_COMBO_DELAY  inst0 (X, A1, A2, A3);
   `else
        nor inst1  (X, A1, A2, A3);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && A3==1'b0) (A1 -=> X)=(0, 0);
if (A1==1'b0 && A3==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b0) (A3 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_NR3_LY2_12

//%BEGIN HDBULT11_OAI211_LY2_12

module HDBULT11_OAI211_LY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
        nand #`SNPS_COMBO_DELAY  inst1 (X, int_res_0, B1, B2);
   `else
        nand inst2  (X, int_res_0, B1, B2);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b1) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b1) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b1) (B2 -=> X)=(0, 0);
endspecify
   `endif

endmodule

//%END HDBULT11_OAI211_LY2_12

//%BEGIN HDBULT11_OAI22_LSKFY2_12

module HDBULT11_OAI22_LSKFY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT11_OAI22_LSKFY2_12

//%BEGIN HDBULT11_OAI22_LSKFY2_2

module HDBULT11_OAI22_LSKFY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT11_OAI22_LSKFY2_2

//%BEGIN HDBULT11_OAI22_LSKFY2_4

module HDBULT11_OAI22_LSKFY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT11_OAI22_LSKFY2_4

//%BEGIN HDBULT11_OAI22_LSKFY2_8

module HDBULT11_OAI22_LSKFY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT11_OAI22_LSKFY2_8

//%BEGIN HDBULT11_OAI22_LSKRY2_12

module HDBULT11_OAI22_LSKRY2_12 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT11_OAI22_LSKRY2_12

//%BEGIN HDBULT11_OAI22_LSKRY2_2

module HDBULT11_OAI22_LSKRY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT11_OAI22_LSKRY2_2

//%BEGIN HDBULT11_OAI22_LSKRY2_4

module HDBULT11_OAI22_LSKRY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT11_OAI22_LSKRY2_4

//%BEGIN HDBULT11_OAI22_LSKRY2_8

module HDBULT11_OAI22_LSKRY2_8 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT11_OAI22_LSKRY2_8

//%BEGIN HDBULT11_OAI22_LY2_2

module HDBULT11_OAI22_LY2_2 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT11_OAI22_LY2_2

//%BEGIN HDBULT11_OAI22_LY2_4

module HDBULT11_OAI22_LY2_4 (X, A1, A2, B1, B2);
   output X;
   input A1, A2, B1, B2;

   wire int_res_0, int_res_1;

   /////////////////////////////////////
   //          FUNCTIONALITY          //
   /////////////////////////////////////

   or inst0  (int_res_0, A1, A2);
   or inst1  (int_res_1, B1, B2);

   /////////////////////////////////////
   //             TIMING              //
   /////////////////////////////////////

   `ifdef VIRL_functiononly
         nand #`SNPS_COMBO_DELAY  inst2 (X, int_res_0, int_res_1);
   `else
         nand inst3  (X, int_res_0, int_res_1);
   `endif

   `ifdef VIRL_functiononly

   `else


specify
if (A2==1'b0 && B1==1'b0 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b0) (A1 -=> X)=(0, 0);
if (A2==1'b0 && B1==1'b1 && B2==1'b1) (A1 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b0 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b0) (A2 -=> X)=(0, 0);
if (A1==1'b0 && B1==1'b1 && B2==1'b1) (A2 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B2==1'b0) (B1 -=> X)=(0, 0);
if (A1==1'b0 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b0 && B1==1'b0) (B2 -=> X)=(0, 0);
if (A1==1'b1 && A2==1'b1 && B1==1'b0) (B2 -=> X)=(0, 0);
endspecify
  `endif

endmodule

//%END HDBULT11_OAI22_LY2_4

